#include "rampabus.h"
#include "Com_UART.h"
#include "Herramienta.h"
#include "debug.h"

xSemaphoreHandle xSemaphoreUSART3;

uint8_t TX_Buf[buffersize];
uint8_t RX_Buf[buffersize];
uint8_t RX_B;
// revisar ..
uint16_t cont_char=0;
uint8_t id_cmd=0;
uint8_t in_cmd=0;

//data nueva....
Cap_Data cap_data;
uint8_t capa=0;
uint8_t inrx=0;

uint32_t BAUDIO;

void Config_USART3(uint32_t baudio){
	 GPIO_InitTypeDef GPIO_InitStructure;
   USART_InitTypeDef USART_InitStructure;

   //Enable GPIOC clock
  // RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);
   //Enable USART6 clock
   //RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);

   //Configure USART3_TX (PD8) and USART3_RX (PD9)
   GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9;
   GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
   GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
   GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
   GPIO_Init(GPIOD, &GPIO_InitStructure);

   //Remap USART3_TX and USART3_RX pins to PD8 and PD9
   GPIO_PinAFConfig(GPIOD, GPIO_PinSource8, GPIO_AF_USART3);
   GPIO_PinAFConfig(GPIOD, GPIO_PinSource9, GPIO_AF_USART3);

   //Configure USART3
   USART_InitStructure.USART_BaudRate = baudio;
   USART_InitStructure.USART_WordLength = USART_WordLength_8b;
   USART_InitStructure.USART_StopBits = USART_StopBits_1;
   USART_InitStructure.USART_Parity = USART_Parity_No;
   USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
   USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
   USART_Init(USART3, &USART_InitStructure);

   //Enable USART3
   USART_Cmd(USART3, ENABLE);
		
}

void Config_PinEnvio(void){
	 GPIO_InitTypeDef GPIO_InitStructure;
	
	 GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
   GPIO_InitStructure.GPIO_Speed = GPIO_Speed_25MHz;
   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
   GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
   GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
   GPIO_Init(GPIOD, &GPIO_InitStructure);
	
}

void Config_USART3_DMA_TX(void){
	DMA_InitTypeDef DMA_Struct;
	
	//RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1,ENABLE);
	
	DMA_DeInit(DMA1_Stream3);
	
	DMA_Struct.DMA_BufferSize=(uint16_t)sizeof(TX_Buf);
	DMA_Struct.DMA_Channel=DMA_Channel_4;
	DMA_Struct.DMA_DIR=DMA_DIR_MemoryToPeripheral;
	DMA_Struct.DMA_FIFOMode=DMA_FIFOMode_Disable;
	DMA_Struct.DMA_FIFOThreshold=DMA_FIFOThreshold_Full;
	DMA_Struct.DMA_Memory0BaseAddr=(uint32_t)TX_Buf;
	DMA_Struct.DMA_MemoryBurst=DMA_MemoryBurst_Single;
	DMA_Struct.DMA_MemoryDataSize=DMA_MemoryDataSize_Byte;
	DMA_Struct.DMA_MemoryInc=DMA_MemoryInc_Enable;
	DMA_Struct.DMA_Mode=DMA_Mode_Normal;
	DMA_Struct.DMA_PeripheralBaseAddr=(uint32_t)&USART3->DR;
	DMA_Struct.DMA_PeripheralBurst=DMA_PeripheralBurst_Single;
	DMA_Struct.DMA_PeripheralDataSize=DMA_PeripheralDataSize_Byte;
	DMA_Struct.DMA_PeripheralInc=DMA_PeripheralInc_Disable;
	DMA_Struct.DMA_Priority=DMA_Priority_Medium;
	
	DMA_Init(DMA1_Stream3,&DMA_Struct);
	
}
void Config_USART3_DMA_RX(uint16_t size){
	DMA_InitTypeDef DMA_Struct;
	DMA_Cmd(DMA1_Stream3,DISABLE);
	//RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1,ENABLE);
	/*
	if(xSemaphoreUSART3!=NULL){
		vSemaphoreDelete(xSemaphoreUSART3);
		xSemaphoreUSART3=NULL;
	}
	*/
	DMA_DeInit(DMA1_Stream1);
	
	DMA_Struct.DMA_BufferSize=size;
	DMA_Struct.DMA_Channel=DMA_Channel_4;
	DMA_Struct.DMA_DIR=DMA_DIR_PeripheralToMemory;
	DMA_Struct.DMA_FIFOMode=DMA_FIFOMode_Disable;
	DMA_Struct.DMA_FIFOThreshold=DMA_FIFOThreshold_Full;
	DMA_Struct.DMA_Memory0BaseAddr=(uint32_t)&RX_Buf;
	DMA_Struct.DMA_MemoryBurst=DMA_MemoryBurst_Single;
	DMA_Struct.DMA_MemoryDataSize=DMA_MemoryDataSize_Byte;
	DMA_Struct.DMA_MemoryInc=DMA_MemoryInc_Enable;
	DMA_Struct.DMA_Mode=DMA_Mode_Circular;
	DMA_Struct.DMA_PeripheralBaseAddr=(uint32_t)&USART3->DR;
	DMA_Struct.DMA_PeripheralBurst=DMA_PeripheralBurst_Single;
	DMA_Struct.DMA_PeripheralDataSize=DMA_PeripheralDataSize_Byte;
	DMA_Struct.DMA_PeripheralInc=DMA_PeripheralInc_Disable;
	DMA_Struct.DMA_Priority=DMA_Priority_High;
	
	//vSemaphoreCreateBinary( xSemaphoreUSART3 );
  
	
	USART_DMACmd(USART3,USART_DMAReq_Rx,ENABLE);
	
	DMA_Init(DMA1_Stream1,&DMA_Struct);
	
	DMA_ITConfig(DMA1_Stream1,DMA_IT_TC,ENABLE);
	DMA_Cmd(DMA1_Stream1,ENABLE);
}

void SendDmaTx(uint8_t *buffer,uint16_t size){
	DMA_InitTypeDef DMA_Struct;
	//RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA1,ENABLE);
	
	//DMA_ClearFlag(DMA1_Stream3,DMA_FLAG_TCIF3);
	
	
	DMA_DeInit(DMA1_Stream3);
	
	DMA_Struct.DMA_BufferSize=size;
	DMA_Struct.DMA_Channel=DMA_Channel_4;
	DMA_Struct.DMA_DIR=DMA_DIR_MemoryToPeripheral;
	DMA_Struct.DMA_FIFOMode=DMA_FIFOMode_Disable;
	DMA_Struct.DMA_FIFOThreshold=DMA_FIFOThreshold_Full;
	DMA_Struct.DMA_Memory0BaseAddr=(uint32_t)buffer;
	DMA_Struct.DMA_MemoryBurst=DMA_MemoryBurst_Single;
	DMA_Struct.DMA_MemoryDataSize=DMA_MemoryDataSize_Byte;
	DMA_Struct.DMA_MemoryInc=DMA_MemoryInc_Enable;
	DMA_Struct.DMA_Mode=DMA_Mode_Normal;
	DMA_Struct.DMA_PeripheralBaseAddr=(uint32_t)&USART3->DR;
	DMA_Struct.DMA_PeripheralBurst=DMA_PeripheralBurst_Single;
	DMA_Struct.DMA_PeripheralDataSize=DMA_PeripheralDataSize_Byte;
	DMA_Struct.DMA_PeripheralInc=DMA_PeripheralInc_Disable;
	DMA_Struct.DMA_Priority=DMA_Priority_Medium;
	
	DMA_Init(DMA1_Stream3,&DMA_Struct);
		
	USART_DMACmd(USART3,USART_DMAReq_Tx,ENABLE);
	
	DMA_Cmd(DMA1_Stream3,ENABLE);
	
	while(DMA_GetFlagStatus(DMA1_Stream3,DMA_FLAG_TCIF3 )==RESET);
	
	//DMA_ClearFlag(DMA1_Stream3,DMA_FLAG_TCIF3);
	//DMA_Cmd(DMA1_Stream3,DISABLE);
	
}
void Config_NVIC_DMA1_1(void){
	NVIC_InitTypeDef NVIC_Struct;
	
	NVIC_Struct.NVIC_IRQChannel=DMA1_Stream1_IRQn;
	NVIC_Struct.NVIC_IRQChannelCmd=ENABLE;
	NVIC_Struct.NVIC_IRQChannelPreemptionPriority=12;
	NVIC_Struct.NVIC_IRQChannelSubPriority=0;
	NVIC_Init(&NVIC_Struct);
	
	//NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);
	
}

void Proceder_USART3_DMA(void){
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD,ENABLE);
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3,ENABLE);
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA1,ENABLE);
	
	Config_USART3(BAUDIO);//38400
	Config_PinEnvio();
	Config_USART3_DMA_TX();
	Config_USART3_DMA_RX(5);
	Config_NVIC_DMA1_1();
	
	//GPIO_WriteBit(GPIOD,GPIO_Pin_10,Bit_RESET);
	DesactivarEnvio();
	vSemaphoreCreateBinary( xSemaphoreUSART3 );
}




void DMA1_Stream1_IRQHandler(void){
	//uint8_t tam_t;
	portBASE_TYPE xHigherPriorityTaskWoken;
	
	//uint32_t  tiempo=200000;
	
	if(DMA_GetITStatus(DMA1_Stream1,DMA_IT_TCIF1)){
		
		
		DMA_ClearITPendingBit(DMA1_Stream1,DMA_IT_TCIF1);
		
		if(capa==0){
			
		}
		if(capa==1){
			//Config_USART1_DMA_RX(cap_data.cap.Tamdatas);
			//memcpy((uint8_t*)
			
			INFUC=1;
			
			capa=0;
			
		}
		//inrx=1;
		/*
		DesModularMem(&cap2,RX_Buf,sizeof(cap2),0);
				DesModularMem(&t1,RX_Buf,2,5);
				DesModularMem(&h1,RX_Buf,2,7);
				DesModularMem(&t2,RX_Buf,2,9);
				
				TRACE_INFO("SE TRANSMITE QUEUE RAMPABUS dir=%d -- t1=%d -- h1=%d -- t2=%d\r\n",cap2.Direccion,t1,h1,Multiplo(11,5));
		*/
	}
	
	xHigherPriorityTaskWoken=pdFALSE;
	xSemaphoreGiveFromISR(xSemaphoreUSART3, &xHigherPriorityTaskWoken );
	if(xHigherPriorityTaskWoken!=pdFALSE){
		portEND_SWITCHING_ISR(xHigherPriorityTaskWoken);
	}
	
	
}

void ActivarEnvio(void){
	GPIO_WriteBit(GPIOD,GPIO_Pin_10,Bit_SET);
}
void DesactivarEnvio(void){
	GPIO_ResetBits(GPIOD,GPIO_Pin_10);
}
uint8_t Commando(uint8_t *txt){
	if(strcmp((char*)RX_Buf,"1#")==0){
		
		cont_char=0;
		return 1;
	}
	else if(strcmp((char*)RX_Buf,"2#")==0){
		
		cont_char=0;
		return 2;
	}
	else if(strcmp((char*)RX_Buf,"3#")==0){
		
		cont_char=0;
		return 3;
	}
	else if(strcmp((char*)RX_Buf,"4#")==0){
		
		cont_char=0;
		return 4;
	}
	else if(strcmp((char*)RX_Buf,"5#")==0){
		
		cont_char=0;
		return 5;
	}
	else if(strcmp((char*)RX_Buf,"7#")==0){
		
		cont_char=0;
		return 7;
	}
	
	else{
		
		cont_char=0;
		strcpy((char*)TX_Buf,"\rComando Incorrecto\n");
		SendDmaTx(TX_Buf,strlen((char*)TX_Buf));
		return 6;
	}
	
}
// recorte ojojojojojojojo
/*
if(strcmp((char*)RX_Buf,"1#")==0){
				
				cont=0;
				//bloque codigo
				
				return;
				
			}
			else if(strcmp((char*)RX_Buf,"2#")==0){
			
				cont=0;
				//bloque codigo
				
				
				return;
			}
			else if(strcmp((char*)RX_Buf,"3#")==0){
				
				cont=0;
				//bloque codigo
				
				
				return;
			}
			else if(strcmp((char*)RX_Buf,"4#")==0){
				
				cont=0;
				//bloque codigo
				
				
				return;
			}
			else if(strcmp((char*)RX_Buf,"5#")==0){
				
				cont=0;
				//bloque codigo
				
				
				return;
			}
			else{
				
				cont=0;
				
				strcpy((char*)TX_Buf,"\rComando Incorrecto\n");
				SendDmaTx(TX_Buf,strlen((char*)TX_Buf));
				return;
				
			}
			
*/
