/*******************************************************************************
* Copyright (C) 2014 Spansion LLC. All Rights Reserved. 
*
* This software is owned and published by: 
* Spansion LLC, 915 DeGuigne Dr. Sunnyvale, CA  94088-3453 ("Spansion").
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND 
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with Spansion 
* components. This software is licensed by Spansion to be adapted only 
* for use in systems utilizing Spansion components. Spansion shall not be 
* responsible for misuse or illegal use of this software for devices not 
* supported herein.  Spansion is providing this software "AS IS" and will 
* not be responsible for issues arising from incorrect user implementation 
* of the software.  
*
* SPANSION MAKES NO WARRANTY, EXPRESS OR IMPLIED, ARISING BY LAW OR OTHERWISE,
* REGARDING THE SOFTWARE (INCLUDING ANY ACOOMPANYING WRITTEN MATERIALS), 
* ITS PERFORMANCE OR SUITABILITY FOR YOUR INTENDED USE, INCLUDING, 
* WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY, THE IMPLIED 
* WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE OR USE, AND THE IMPLIED 
* WARRANTY OF NONINFRINGEMENT.  
* SPANSION SHALL HAVE NO LIABILITY (WHETHER IN CONTRACT, WARRANTY, TORT, 
* NEGLIGENCE OR OTHERWISE) FOR ANY DAMAGES WHATSOEVER (INCLUDING, WITHOUT 
* LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, 
* LOSS OF BUSINESS INFORMATION, OR OTHER PECUNIARY LOSS) ARISING FROM USE OR 
* INABILITY TO USE THE SOFTWARE, INCLUDING, WITHOUT LIMITATION, ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES OR LOSS OF DATA, 
* SAVINGS OR PROFITS, 
* EVEN IF SPANSION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 
* YOU ASSUME ALL RESPONSIBILITIES FOR SELECTION OF THE SOFTWARE TO ACHIEVE YOUR
* INTENDED RESULTS, AND FOR THE INSTALLATION OF, USE OF, AND RESULTS OBTAINED 
* FROM, THE SOFTWARE.  
*
* This software may be replicated in part or whole for the licensed use, 
* with the restriction that this Disclaimer and Copyright notice must be 
* included with each copy of this software, whether used in part or whole, 
* at all times.  
*/
/******************************************************************************/
/** \file s6e2cc.h
 **
 **
 ** History:
 **  - 2014-08-01  0.0.1  EH   Preliminary version
 **  - 2014-08-22  0.0.2  EH   Added CKRT bit of CNTREG register in I2S
 **                            Renamed RFTH bit of INTCNT register in I2S
 **                            Renamed HSSPI IRQ name
 **                            Renamed prefix of HSSPI definition
 **                            Renamed GPIO bit name
 **  - 2014-09-25  1.0.0  EH   Added FM4_DEVICE_TYPE definition
 **                            Added DMS bit of RXF1S register in CAN-FD
 **                            Revised DASZ bit of DFASZR register in Dual Flash
 **                            Revised DRWT bit of DFRWTR register in Dual Flash
 **                            Revised ICEN bit of ICCR register in I2S Clock Generation
 **                            Revised SCS70E & SCS60E bits of EPFR23 register in GPIO
 **                            Deleted TESTB bit of SWC_PSR register in Clock
 **  - 2014-10-22  1.1.0  EH   Added TCSD register in MFT
 **                            Added ACSC register in MFT
 **                            Modified OCSD register in MFT
 **                            Modified NZCL register in MFT
 **                            Modified ACSC register in MFT
 **                            Modified ESCR register in CSIO of MFS
 **                            Modified SCSCR register in CSIO of MFS
 **                            Modified SCSFR register in CSIO of MFS
 **  - 2014-10-23  1.2.0  EH   Added QPRCRR register in QPRC
 **  - 2015-02-10  1.3.0  MSc  Switched to new MCU template version
 **
 ******************************************************************************/

#ifndef _S6E2CC_H_
#define _S6E2CC_H_

#ifdef __cplusplus
extern "C" {
#endif

#define FM4_DEVICE_TYPE 3
#define FM_CORE_TYPE_FM4             1
#define FM_GENERAL_MCUHEADER_VERSION 0200

#define FM4_INT_TYPE_A    1    
#define FM4_WORKFLASH_IF_TYPE_A 1
#define FM4_FLASH_IF_TYPE_A 1
#define FM4_UNIQUE_ID_TYPE_A 1
#define FM4_ECC_CAPTURE_TYPE_A 1
#define FM4_CRG_TYPE_A 1
#define FM4_HWWDT_TYPE_A 1
#define FM4_SWWDT_TYPE_A 1
#define FM4_DTIM_TYPE_A 1
#define FM4_MFT_TYPE_A 1
#define FM4_BT_TYPE_A 1
#define FM4_SBSSR_TYPE_A 1
#define FM4_QPRC_TYPE_A 1
#define FM4_ADC_TYPE_A 1
#define FM4_DAC_TYPE_A 1
#define FM4_CRTRIM_TYPE_A 1
#define FM4_EXTI_TYPE_A 1
#define FM4_INTREQ_TYPE_A 1
#define FM4_GPIO_TYPE_A 1
#define FM4_LVD_TYPE_A 1
#define FM4_DS_TYPE_A 1
#define FM4_USBCLK_TYPE_A 1
#define FM4_CANPRES_TYPE_A 1
#define FM4_MFS_TYPE_A 1
#define FM4_CRC_TYPE_A 1
#define FM4_WC_TYPE_A 1
#define FM4_RTC_TYPE_A 1
#define FM4_LCR_TYPE_A 1
#define FM4_CLK_GATING_TYPE_A 1
#define FM4_PLL_CONTROL_TYPE_A 1
#define FM4_EXBUS_TYPE_A 1
#define FM4_USB_TYPE_A 1
#define FM4_DMAC_TYPE_A 1
#define FM4_DSTC_TYPE_A 1
#define FM4_CAN_TYPE_A 1
#define FM4_SDIF_TYPE_A 1  

#define IRQ_NMI_AVAILABLE          1
#define IRQ_HARDFAULT_AVAILABLE    1
#define IRQ_MEMMANAGE_AVAILABLE    1
#define IRQ_BUSFAULT_AVAILABLE     1
#define IRQ_USAGEFAULT_AVAILABLE   1
#define IRQ SVC_AVAILABLE          1
#define IRQ_DEBUGMONITOR_AVAILABLE 1
#define IRQ_PENDSV_AVAILABLE       1
#define IRQ_SYSTICK_AVAILABLE      1
#define IRQ_CSV_AVAILABLE          1
#define IRQ_SWDT_AVAILABLE         1
#define IRQ_LVD_AVAILABLE          1        
#define IRQ_IRQ003SEL_AVAILABLE          1       
#define IRQ_IRQ004SEL_AVAILABLE          1       
#define IRQ_IRQ005SEL_AVAILABLE          1       
#define IRQ_IRQ006SEL_AVAILABLE          1       
#define IRQ_IRQ007SEL_AVAILABLE          1       
#define IRQ_IRQ008SEL_AVAILABLE          1       
#define IRQ_IRQ009SEL_AVAILABLE          1       
#define IRQ_RQ010SEL_AVAILABLE          1       
#define IRQ_EXINT0_AVAILABLE          1          
#define IRQ_EXINT1_AVAILABLE          1          
#define IRQ_EXINT2_AVAILABLE          1          
#define IRQ_EXINT3_AVAILABLE          1          
#define IRQ_EXINT4_AVAILABLE          1          
#define IRQ_EXINT5_AVAILABLE          1          
#define IRQ_EXINT6_AVAILABLE          1          
#define IRQ_EXINT7_AVAILABLE          1          
#define IRQ_QPRC0_AVAILABLE          1           
#define IRQ_QPRC1_AVAILABLE          1           
#define IRQ_WFG0_DTIF0_AVAILABLE          1      
#define IRQ_WFG1_DTIF1_AVAILABLE          1      
#define IRQ_WFG2_DTIF2_AVAILABLE          1      
#define IRQ_FRT0_PEAK_AVAILABLE          1       
#define IRQ_FRT0_ZERO_AVAILABLE          1       
#define IRQ_ICU0_AVAILABLE          1            
#define IRQ_OCU0_AVAILABLE          1            
#define IRQ_FRT1_PEAK_AVAILABLE          1       
#define IRQ_FRT1_ZERO_AVAILABLE          1       
#define IRQ_ICU1_AVAILABLE          1            
#define IRQ_OCU1_AVAILABLE          1            
#define IRQ_FRT2_PEAK_AVAILABLE          1       
#define IRQ_FRT2_ZERO_AVAILABLE          1       
#define IRQ_ICU2_AVAILABLE          1            
#define IRQ_OCU2_AVAILABLE          1            
#define IRQ_PPG00_02_04_AVAILABLE          1     
#define IRQ_PPG08_10_12_AVAILABLE          1     
#define IRQ_PPG16_18_20_AVAILABLE          1     
#define IRQ_BT0_AVAILABLE          1             
#define IRQ_BT1_AVAILABLE          1             
#define IRQ_BT2_AVAILABLE          1             
#define IRQ_BT3_AVAILABLE          1             
#define IRQ_BT4_AVAILABLE          1             
#define IRQ_BT5_AVAILABLE          1             
#define IRQ_BT6_AVAILABLE          1             
#define IRQ_BT7_AVAILABLE          1             
#define IRQ_DT1_2_AVAILABLE          1           
#define IRQ_WC_AVAILABLE          1              
#define IRQ_EXTBUS_ERR_AVAILABLE          1      
#define IRQ_RTC_AVAILABLE          1             
#define IRQ_EXINT8_AVAILABLE          1          
#define IRQ_EXINT9_AVAILABLE          1          
#define IRQ_EXINT10_AVAILABLE          1         
#define IRQ_EXINT11_AVAILABLE          1         
#define IRQ_EXINT12_AVAILABLE          1         
#define IRQ_EXINT13_AVAILABLE          1         
#define IRQ_EXINT14_AVAILABLE          1         
#define IRQ_EXINT15_AVAILABLE          1         
#define IRQ_TIM_AVAILABLE          1             
#define IRQ_MFS0_RX_AVAILABLE          1         
#define IRQ_MFS0_TX_AVAILABLE          1         
#define IRQ_MFS1_RX_AVAILABLE          1         
#define IRQ_MFS1_TX_AVAILABLE          1         
#define IRQ_MFS2_RX_AVAILABLE          1         
#define IRQ_MFS2_TX_AVAILABLE          1         
#define IRQ_MFS3_RX_AVAILABLE          1         
#define IRQ_MFS3_TX_AVAILABLE          1         
#define IRQ_MFS4_RX_AVAILABLE          1         
#define IRQ_MFS4_TX_AVAILABLE          1         
#define IRQ_MFS5_RX_AVAILABLE          1         
#define IRQ_MFS5_TX_AVAILABLE          1         
#define IRQ_MFS6_RX_AVAILABLE          1         
#define IRQ_MFS6_TX_AVAILABLE          1         
#define IRQ_MFS7_RX_AVAILABLE          1         
#define IRQ_MFS7_TX_AVAILABLE          1         
#define IRQ_ADC0_AVAILABLE          1            
#define IRQ_ADC1_AVAILABLE          1            
#define IRQ_USB0_AVAILABLE          1            
#define IRQ_USB0_HOST_AVAILABLE          1       
#define IRQ_CAN0_AVAILABLE          1            
#define IRQ_CAN1_CANFD_AVAILABLE          1      
#define IRQ_ETHER0_AVAILABLE          1          
#define IRQ_DMAC0_AVAILABLE          1           
#define IRQ_DMAC1_AVAILABLE          1           
#define IRQ_DMAC2_AVAILABLE          1           
#define IRQ_DMAC3_AVAILABLE          1           
#define IRQ_DMAC4_AVAILABLE          1           
#define IRQ_DMAC5_AVAILABLE          1           
#define IRQ_DMAC6_AVAILABLE          1           
#define IRQ_DMAC7_AVAILABLE          1           
#define IRQ_DSTC_AVAILABLE          1            
#define IRQ_EXINT16_17_18_19_AVAILABLE          1
#define IRQ_EXINT20_21_22_23_AVAILABLE          1
#define IRQ_EXINT24_25_26_27_AVAILABLE          1
#define IRQ_EXINT28_29_30_31_AVAILABLE          1
#define IRQ_QPRC2_AVAILABLE          1           
#define IRQ_QPRC3_AVAILABLE          1           
#define IRQ_BT8_AVAILABLE          1             
#define IRQ_BT9_AVAILABLE          1             
#define IRQ_BT10_AVAILABLE          1            
#define IRQ_BT11_AVAILABLE          1            
#define IRQ_BT12_AVAILABLE          1            
#define IRQ_MFS8_RX_AVAILABLE          1         
#define IRQ_MFS8_TX_AVAILABLE          1         
#define IRQ_MFS9_RX_AVAILABLE          1         
#define IRQ_MFS9_TX_AVAILABLE          1         
#define IRQ_MFS10_RX_AVAILABLE          1        
#define IRQ_MFS10_TX_AVAILABLE          1        
#define IRQ_MFS11_RX_AVAILABLE          1        
#define IRQ_MFS11_TX_AVAILABLE          1        
#define IRQ_ADC2_AVAILABLE          1            
#define IRQ_USB1_HDMICEC0_AVAILABLE          1   
#define IRQ_USB1_HOST_HDMICEC1_IR
#define IRQ_HS_QSPI_AVAILABLE          1         
#define IRQ_PRGCRC_I2S_AVAILABLE          1      
#define IRQ_SD_AVAILABLE          1              
#define IRQ_FLASH_AVAILABLE          1           
#define IRQ_MFS12_RX_AVAILABLE          1        
#define IRQ_MFS12_TX_AVAILABLE          1        
#define IRQ_MFS13_RX_AVAILABLE          1        
#define IRQ_MFS13_TX_AVAILABLE          1        
#define IRQ_MFS14_RX_AVAILABLE          1        
#define IRQ_MFS14_TX_AVAILABLE          1        
#define IRQ_MFS15_RX_AVAILABLE          1        
#define IRQ_MFS15_TX_AVAILABLE          1   

/******************************************************************************
 * Configuration of the Cortex-M3 Processor and Core Peripherals
 ******************************************************************************/
#define __MPU_PRESENT           1 /* FM4 provide an MPU                           */
#define __NVIC_PRIO_BITS        4 /* FM4 uses 4 Bits for the Priority Levels      */
#define __Vendor_SysTickConfig  0 /* Set to 1 if different SysTick Config is used */
#define __FPU_PRESENT           1 /* FPU present                                  */

#include "mcu.h"

/**
 ******************************************************************************
 ** \brief Interrupt number definition for all type MCUs
 ******************************************************************************/
typedef enum IRQn
{
    NMI_IRQn          = -14, /*  2 Non Maskable      */
    HardFault_IRQn    = -13, /*  3 Hard Fault        */
    MemManage_IRQn    = -12, /*  4 Memory Management */
    BusFault_IRQn     = -11, /*  5 Bus Fault         */
    UsageFault_IRQn   = -10, /*  6 Usage Fault       */
    SVC_IRQn          = -5,  /* 11 SV Call           */
    DebugMonitor_IRQn = -4,  /* 12 Debug Monitor     */
    PendSV_IRQn       = -2,  /* 14 Pend SV           */
    SysTick_IRQn      = -1,  /* 15 System Tick       */

    CSV_IRQn              =   0,  /* Clock Supervisor                             */
    SWDT_IRQn             =   1,  /* Software Watchdog Timer                      */
    LVD_IRQn              =   2,  /* Low Voltage Detection                        */
    IRQ003SEL_IRQn        =   3,  /* Interrupt Selection IRQ003SEL                */
    IRQ004SEL_IRQn        =   4,  /* Interrupt Selection IRQ004SEL                */
    IRQ005SEL_IRQn        =   5,  /* Interrupt Selection IRQ005SEL                */
    IRQ006SEL_IRQn        =   6,  /* Interrupt Selection IRQ006SEL                */
    IRQ007SEL_IRQn        =   7,  /* Interrupt Selection IRQ007SEL                */
    IRQ008SEL_IRQn        =   8,  /* Interrupt Selection IRQ008SEL                */
    IRQ009SEL_IRQn        =   9,  /* Interrupt Selection IRQ009SEL                */
    IRQ010SEL_IRQn        =  10,  /* Interrupt Selection IRQ010SEL                */
    EXINT0_IRQn           =  11,  /* External Interrupt Ch. 0                     */
    EXINT1_IRQn           =  12,  /* External Interrupt Ch. 1                     */
    EXINT2_IRQn           =  13,  /* External Interrupt Ch. 2                     */
    EXINT3_IRQn           =  14,  /* External Interrupt Ch. 3                     */
    EXINT4_IRQn           =  15,  /* External Interrupt Ch. 4                     */
    EXINT5_IRQn           =  16,  /* External Interrupt Ch. 5                     */
    EXINT6_IRQn           =  17,  /* External Interrupt Ch. 6                     */
    EXINT7_IRQn           =  18,  /* External Interrupt Ch. 7                     */
    QPRC0_IRQn            =  19,  /* Quad Decoder and Revolution Counter Ch. 0    */
    QPRC1_IRQn            =  20,  /* Quad Decoder and Revolution Counter Ch. 1    */
    WFG0_DTIF0_IRQn       =  21,  /* MFT0 Wave Form Generator / DTIF              */
    WFG1_DTIF1_IRQn       =  22,  /* MFT1 Wave Form Generator / DTIF              */
    WFG2_DTIF2_IRQn       =  23,  /* MFT2 Wave Form Generator / DTIF              */
    FRT0_PEAK_IRQn        =  24,  /* MFT0 Free Running Timer Peak Detection       */
    FRT0_ZERO_IRQn        =  25,  /* MFT0 Free Running Timer Zero Detection       */
    ICU0_IRQn             =  26,  /* MFT0 Input Capture Unit                      */
    OCU0_IRQn             =  27,  /* MFT0 Output Compare Unit                     */
    FRT1_PEAK_IRQn        =  28,  /* MFT1 Free Running Timer Peak Detection       */
    FRT1_ZERO_IRQn        =  29,  /* MFT1 Free Running Timer Zero Detection       */
    ICU1_IRQn             =  30,  /* MFT1 Input Capture Unit                      */
    OCU1_IRQn             =  31,  /* MFT1 Output Compare Unit                     */
    FRT2_PEAK_IRQn        =  32,  /* MFT2 Free Running Timer Peak Detection       */
    FRT2_ZERO_IRQn        =  33,  /* MFT2 Free Running Timer Zero Detection       */
    ICU2_IRQn             =  34,  /* MFT2 Input Capture Unit                      */
    OCU2_IRQn             =  35,  /* MFT2 Output Compare Unit                     */
    PPG00_02_04_IRQn      =  36,  /* Programmable Pulse Generator Ch. 0, 2, 4     */
    PPG08_10_12_IRQn      =  37,  /* Programmable Pulse Generator Ch. 8, 10, 12   */
    PPG16_18_20_IRQn      =  38,  /* Programmable Pulse Generator Ch. 16, 18, 20  */
    BT0_IRQn              =  39,  /* Base Timer Ch. 0                             */
    BT1_IRQn              =  40,  /* Base Timer Ch. 1                             */
    BT2_IRQn              =  41,  /* Base Timer Ch. 2                             */
    BT3_IRQn              =  42,  /* Base Timer Ch. 3                             */
    BT4_IRQn              =  43,  /* Base Timer Ch. 4                             */
    BT5_IRQn              =  44,  /* Base Timer Ch. 5                             */
    BT6_IRQn              =  45,  /* Base Timer Ch. 6                             */
    BT7_IRQn              =  46,  /* Base Timer Ch. 7                             */
    DT1_2_IRQn            =  47,  /* Dual Timmer Ch. 1, 2                         */
    WC_IRQn               =  48,  /* Watch Counter                                */
    EXTBUS_ERR_IRQn       =  49,  /* External Bus Error                           */
    RTC_IRQn              =  50,  /* Realtime Clock                               */
    EXINT8_IRQn           =  51,  /* External Interrupt Ch. 8                     */
    EXINT9_IRQn           =  52,  /* External Interrupt Ch. 9                     */
    EXINT10_IRQn          =  53,  /* External Interrupt Ch. 10                    */
    EXINT11_IRQn          =  54,  /* External Interrupt Ch. 11                    */
    EXINT12_IRQn          =  55,  /* External Interrupt Ch. 12                    */
    EXINT13_IRQn          =  56,  /* External Interrupt Ch. 13                    */
    EXINT14_IRQn          =  57,  /* External Interrupt Ch. 14                    */
    EXINT15_IRQn          =  58,  /* External Interrupt Ch. 15                    */
    TIM_IRQn              =  59,  /* Clock/PLL/USB&Ethernet-PLL/I2S-PLL Timer     */
    MFS0_RX_IRQn          =  60,  /* Multifunction Serial I/F Reception Ch. 0     */
    MFS0_TX_IRQn          =  61,  /* Multifunction Serial I/F Transmission Ch. 0  */
    MFS1_RX_IRQn          =  62,  /* Multifunction Serial I/F Reception Ch. 1     */
    MFS1_TX_IRQn          =  63,  /* Multifunction Serial I/F Transmission Ch. 1  */
    MFS2_RX_IRQn          =  64,  /* Multifunction Serial I/F Reception Ch. 2     */
    MFS2_TX_IRQn          =  65,  /* Multifunction Serial I/F Transmission Ch. 2  */
    MFS3_RX_IRQn          =  66,  /* Multifunction Serial I/F Reception Ch. 3     */
    MFS3_TX_IRQn          =  67,  /* Multifunction Serial I/F Transmission Ch. 3  */
    MFS4_RX_IRQn          =  68,  /* Multifunction Serial I/F Reception Ch. 4     */
    MFS4_TX_IRQn          =  69,  /* Multifunction Serial I/F Transmission Ch. 4  */
    MFS5_RX_IRQn          =  70,  /* Multifunction Serial I/F Reception Ch. 5     */
    MFS5_TX_IRQn          =  71,  /* Multifunction Serial I/F Transmission Ch. 5  */
    MFS6_RX_IRQn          =  72,  /* Multifunction Serial I/F Reception Ch. 6     */
    MFS6_TX_IRQn          =  73,  /* Multifunction Serial I/F Transmission Ch. 6  */
    MFS7_RX_IRQn          =  74,  /* Multifunction Serial I/F Reception Ch. 7     */
    MFS7_TX_IRQn          =  75,  /* Multifunction Serial I/F Transmission Ch. 7  */
    ADC0_IRQn             =  76,  /* Analog Digital Converter Unit 0              */
    ADC1_IRQn             =  77,  /* Analog Digital Converter Unit 1              */
    USB0_IRQn             =  78,  /* USB0 Function                                */
    USB0_HOST_IRQn        =  79,  /* USB0 Function and Host                       */
    CAN0_IRQn             =  80,  /* CAN I/F Ch. 0                                */
    CAN1_CANFD_IRQn       =  81,  /* CAN I/F Ch. 1 & CAN-FD I/F                   */
    ETHER0_IRQn           =  82,  /* Ethernet                                     */
    DMAC0_IRQn            =  83,  /* Direct Memory Access Controller Ch. 0        */
    DMAC1_IRQn            =  84,  /* Direct Memory Access Controller Ch. 1        */
    DMAC2_IRQn            =  85,  /* Direct Memory Access Controller Ch. 2        */
    DMAC3_IRQn            =  86,  /* Direct Memory Access Controller Ch. 3        */
    DMAC4_IRQn            =  87,  /* Direct Memory Access Controller Ch. 4        */
    DMAC5_IRQn            =  88,  /* Direct Memory Access Controller Ch. 5        */
    DMAC6_IRQn            =  89,  /* Direct Memory Access Controller Ch. 6        */
    DMAC7_IRQn            =  90,  /* Direct Memory Access Controller Ch. 7        */
    DSTC_IRQn             =  91,  /* DSTC SW Transfer                             */
    EXINT16_17_18_19_IRQn =  92,  /* External Interrupt Ch. 16 - 19               */
    EXINT20_21_22_23_IRQn =  93,  /* External Interrupt Ch. 20 - 23               */
    EXINT24_25_26_27_IRQn =  94,  /* External Interrupt Ch. 24 - 27               */
    EXINT28_29_30_31_IRQn =  95,  /* External Interrupt Ch. 28 - 31               */
    QPRC2_IRQn            =  96,  /* Quad Decoder and Revolution Counter Ch. 2    */
    QPRC3_IRQn            =  97,  /* Quad Decoder and Revolution Counter Ch. 3    */
    BT8_IRQn              =  98,  /* Base Timer Ch. 8                             */
    BT9_IRQn              =  99,  /* Base Timer Ch. 9                             */
    BT10_IRQn             = 100,  /* Base Timer Ch. 10                            */
    BT11_IRQn             = 101,  /* Base Timer Ch. 11                            */
    BT12_IRQn             = 102,  /* Base Timer Ch. 12                            */
    MFS8_RX_IRQn          = 103,  /* Multifunction Serial I/F Reception Ch. 8     */
    MFS8_TX_IRQn          = 104,  /* Multifunction Serial I/F Transmission Ch. 8  */
    MFS9_RX_IRQn          = 105,  /* Multifunction Serial I/F Reception Ch. 9     */
    MFS9_TX_IRQn          = 106,  /* Multifunction Serial I/F Transmission Ch. 9  */
    MFS10_RX_IRQn         = 107,  /* Multifunction Serial I/F Reception Ch. 10    */
    MFS10_TX_IRQn         = 108,  /* Multifunction Serial I/F Transmission Ch. 10 */
    MFS11_RX_IRQn         = 109,  /* Multifunction Serial I/F Reception Ch. 11    */
    MFS11_TX_IRQn         = 110,  /* Multifunction Serial I/F Transmission Ch. 11 */
    ADC2_IRQn             = 111,  /* Analog Digital Converter Unit 2              */
    USB1_HDMICEC0_IRQn    = 113,  /* USB1 Function & HDMI-CEC ch.0                */
    USB1_HOST_HDMICEC1_IRQn = 114,  /* USB1 Function and Host & HDMI-CEC ch.1     */
    HSSPI_IRQn            = 115,  /* High-Speed Quad SPI                          */
    PRGCRC_I2S_IRQn       = 117,  /* Programmable CRC & I2S I/F                   */
    SD_IRQn               = 118,  /* SD Card I/F                                  */
    FLASH_IRQn            = 119,  /* Flash                                        */
    MFS12_RX_IRQn         = 120,  /* Multifunction Serial I/F Reception Ch. 12    */
    MFS12_TX_IRQn         = 121,  /* Multifunction Serial I/F Transmission Ch. 12 */
    MFS13_RX_IRQn         = 122,  /* Multifunction Serial I/F Reception Ch. 13    */
    MFS13_TX_IRQn         = 123,  /* Multifunction Serial I/F Transmission Ch. 13 */
    MFS14_RX_IRQn         = 124,  /* Multifunction Serial I/F Reception Ch. 14    */
    MFS14_TX_IRQn         = 125,  /* Multifunction Serial I/F Transmission Ch. 14 */
    MFS15_RX_IRQn         = 126,  /* Multifunction Serial I/F Reception Ch. 15    */
    MFS15_TX_IRQn         = 127   /* Multifunction Serial I/F Transmission Ch. 15 */
} IRQn_Type;


#include "core_cm4.h"
#include "system_s6e2cc.h"
#include <stdint.h>

#define SUCCESS  0
#define ERROR    -1

#ifndef NULL
#define NULL 0
#endif


/******************************************************************************/
/*                Device Specific Peripheral Registers structures             */
/******************************************************************************/

#if defined ( __CC_ARM   )
#pragma anon_unions
#endif

/******************************************************************************
 * Peripheral register bit fields
 ******************************************************************************/

/******************************************************************************
 * FLASH_IF_MODULE
 ******************************************************************************/
/* FLASH_IF_MODULE register bit fields */
typedef struct stc_flash_if_faszr_field
{
  __IO uint32_t ASZ        : 2;
} stc_flash_if_faszr_field_t;

typedef struct stc_flash_if_frwtr_field
{
  __IO uint32_t RWT        : 2;
} stc_flash_if_frwtr_field_t;

typedef struct stc_flash_if_fstr_field
{
  __IO uint32_t RDY        : 1;
  __IO uint32_t HNG        : 1;
  __IO uint32_t ERR        : 1;
} stc_flash_if_fstr_field_t;

typedef struct stc_flash_if_fsyndn_field
{
  __IO uint32_t SD         : 3;
} stc_flash_if_fsyndn_field_t;

typedef struct stc_flash_if_fbfcr_field
{
  __IO uint32_t BE         : 1;
  __IO uint32_t BS         : 1;
} stc_flash_if_fbfcr_field_t;

typedef struct stc_flash_if_ficr_field
{
  __IO uint32_t RDYIE      : 1;
  __IO uint32_t HANGIE     : 1;
  __IO uint32_t ERRIE      : 1;
} stc_flash_if_ficr_field_t;

typedef struct stc_flash_if_fisr_field
{
  __IO uint32_t RDYIF      : 1;
  __IO uint32_t HANGIF     : 1;
  __IO uint32_t ERRIF      : 1;
} stc_flash_if_fisr_field_t;

typedef struct stc_flash_if_ficlr_field
{
  __IO uint32_t RDYIC      : 1;
  __IO uint32_t HANGIC     : 1;
  __IO uint32_t ERRIC      : 1;
} stc_flash_if_ficlr_field_t;

typedef struct stc_flash_if_dfctrlr_field
{
  __IO uint32_t DFE        : 1;
  __IO uint32_t RME        : 1;
       uint32_t RESERVED1  : 14;
  __IO uint32_t WKEY       : 16;
} stc_flash_if_dfctrlr_field_t;

typedef struct stc_flash_if_crtrmm_field
{
  __IO uint32_t TRMM       : 10;
       uint32_t RESERVED1  : 6;
  __IO uint32_t TTRMM      : 5;
} stc_flash_if_crtrmm_field_t;

typedef struct stc_flash_if_fgpdm1_field
{
  __IO uint32_t GPD1       : 32;
} stc_flash_if_fgpdm1_field_t;

typedef struct stc_flash_if_fgpdm2_field
{
  __IO uint32_t GPD2       : 32;
} stc_flash_if_fgpdm2_field_t;

typedef struct stc_flash_if_fgpdm3_field
{
  __IO uint32_t GPD3       : 32;
} stc_flash_if_fgpdm3_field_t;

typedef struct stc_flash_if_fgpdm4_field
{
  __IO uint32_t GPD4       : 32;
} stc_flash_if_fgpdm4_field_t;

/******************************************************************************
 * DUALFLASH_IF_MODULE
 ******************************************************************************/
/* DUALFLASH_IF_MODULE register bit fields */
typedef struct stc_dualflash_if_dfaszr_field
{
  __IO uint32_t DASZ       : 2;
} stc_dualflash_if_dfaszr_field_t;

typedef struct stc_dualflash_if_dfrwtr_field
{
  __IO uint32_t DRWT       : 2;
} stc_dualflash_if_dfrwtr_field_t;

typedef struct stc_dualflash_if_dfstr_field
{
  __IO uint32_t DFRDY      : 1;
  __IO uint32_t DFHNG      : 1;
  __IO uint32_t DFERR      : 1;
} stc_dualflash_if_dfstr_field_t;

/******************************************************************************
 * UNIQUE_ID_MODULE
 ******************************************************************************/
/* UNIQUE_ID_MODULE register bit fields */
typedef struct stc_unique_id_uidr0_field
{
       uint32_t RESERVED0  : 4;
  __IO uint32_t UID        :28;
} stc_unique_id_uidr0_field_t;

typedef struct stc_unique_id_uidr1_field
{
  __IO uint32_t UID        :13;
} stc_unique_id_uidr1_field_t;

/******************************************************************************
 * ECC_CAPTURE_MODULE
 ******************************************************************************/
/* ECC_CAPTURE_MODULE register bit fields */
typedef struct stc_ecc_capture_ferrad_field
{
  __IO uint32_t ERRAD      :23;
} stc_ecc_capture_ferrad_field_t;

/******************************************************************************
 * Clock_Reset_MODULE
 ******************************************************************************/
/* Clock_Reset_MODULE register bit fields */
typedef struct stc_crg_scm_ctl_field
{
       uint32_t RESERVED1  : 1;
  __IO uint32_t MOSCE      : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t SOSCE      : 1;
  __IO uint32_t PLLE       : 1;
  __IO uint32_t RCS        : 3;
} stc_crg_scm_ctl_field_t;

typedef struct stc_crg_scm_str_field
{
       uint32_t RESERVED1  : 1;
  __IO uint32_t MORDY      : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t SORDY      : 1;
  __IO uint32_t PLRDY      : 1;
  __IO uint32_t RCM0       : 1;
  __IO uint32_t RCM1       : 1;
  __IO uint32_t RCM2       : 1;
} stc_crg_scm_str_field_t;

typedef struct stc_crg_rst_str_field
{
  __IO uint32_t PONR       : 1;
  __IO uint32_t INITX      : 1;
  __IO uint32_t LVDH       : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t SWDT       : 1;
  __IO uint32_t HWDT       : 1;
  __IO uint32_t CSVR       : 1;
  __IO uint32_t FCSR       : 1;
  __IO uint32_t SRST       : 1;
} stc_crg_rst_str_field_t;

typedef struct stc_crg_bsc_psr_field
{
  __IO uint32_t BSR0       : 1;
  __IO uint32_t BSR1       : 1;
  __IO uint32_t BSR2       : 1;
} stc_crg_bsc_psr_field_t;

typedef struct stc_crg_apbc0_psr_field
{
  __IO uint32_t APBC00     : 1;
  __IO uint32_t APBC01     : 1;
} stc_crg_apbc0_psr_field_t;

typedef struct stc_crg_apbc1_psr_field
{
  __IO uint32_t APBC10     : 1;
  __IO uint32_t APBC11     : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t APBC1RST   : 1;
       uint32_t RESERVED2  : 2;
  __IO uint32_t APBC1EN    : 1;
} stc_crg_apbc1_psr_field_t;

typedef struct stc_crg_apbc2_psr_field
{
  __IO uint32_t APBC20     : 1;
  __IO uint32_t APBC21     : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t APBC2RST   : 1;
       uint32_t RESERVED2  : 2;
  __IO uint32_t APBC2EN    : 1;
} stc_crg_apbc2_psr_field_t;

typedef struct stc_crg_swc_psr_field
{
  __IO uint32_t SWDS0      : 1;
  __IO uint32_t SWDS1      : 1;
} stc_crg_swc_psr_field_t;

typedef struct stc_crg_ttc_psr_field
{
  __IO uint32_t TTC        : 2;
} stc_crg_ttc_psr_field_t;

typedef struct stc_crg_csw_tmr_field
{
  __IO uint32_t MOWT0      : 1;
  __IO uint32_t MOWT1      : 1;
  __IO uint32_t MOWT2      : 1;
  __IO uint32_t MOWT3      : 1;
  __IO uint32_t SOWT0      : 1;
  __IO uint32_t SOWT1      : 1;
  __IO uint32_t SOWT2      : 1;
  __IO uint32_t SOWT3      : 1;
} stc_crg_csw_tmr_field_t;

typedef struct stc_crg_psw_tmr_field
{
  __IO uint32_t POWT0      : 1;
  __IO uint32_t POWT1      : 1;
  __IO uint32_t POWT2      : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t PINC       : 1;
} stc_crg_psw_tmr_field_t;

typedef struct stc_crg_pll_ctl1_field
{
  __IO uint32_t PLLM0      : 1;
  __IO uint32_t PLLM1      : 1;
  __IO uint32_t PLLM2      : 1;
  __IO uint32_t PLLM3      : 1;
  __IO uint32_t PLLK0      : 1;
  __IO uint32_t PLLK1      : 1;
  __IO uint32_t PLLK2      : 1;
  __IO uint32_t PLLK3      : 1;
} stc_crg_pll_ctl1_field_t;

typedef struct stc_crg_pll_ctl2_field
{
  __IO uint32_t PLLN0      : 1;
  __IO uint32_t PLLN1      : 1;
  __IO uint32_t PLLN2      : 1;
  __IO uint32_t PLLN3      : 1;
  __IO uint32_t PLLN4      : 1;
  __IO uint32_t PLLN5      : 1;
} stc_crg_pll_ctl2_field_t;

typedef struct stc_crg_csv_ctl_field
{
  __IO uint32_t MCSVE      : 1;
  __IO uint32_t SCSVE      : 1;
       uint32_t RESERVED1  : 6;
  __IO uint32_t FCSDE      : 1;
  __IO uint32_t FCSRE      : 1;
       uint32_t RESERVED2  : 2;
  __IO uint32_t FCD0       : 1;
  __IO uint32_t FCD1       : 1;
  __IO uint32_t FCD2       : 1;
} stc_crg_csv_ctl_field_t;

typedef struct stc_crg_csv_str_field
{
  __IO uint32_t MCMF       : 1;
  __IO uint32_t SCMF       : 1;
} stc_crg_csv_str_field_t;

typedef struct stc_crg_dbwdt_ctl_field
{
       uint32_t RESERVED1  : 5;
  __IO uint32_t DPSWBE     : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t DPHWBE     : 1;
} stc_crg_dbwdt_ctl_field_t;

typedef struct stc_crg_int_enr_field
{
  __IO uint32_t MCSE       : 1;
  __IO uint32_t SCSE       : 1;
  __IO uint32_t PCSE       : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t FCSE       : 1;
} stc_crg_int_enr_field_t;

typedef struct stc_crg_int_str_field
{
  __IO uint32_t MCSI       : 1;
  __IO uint32_t SCSI       : 1;
  __IO uint32_t PCSI       : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t FCSI       : 1;
} stc_crg_int_str_field_t;

typedef struct stc_crg_int_clr_field
{
  __IO uint32_t MCSC       : 1;
  __IO uint32_t SCSC       : 1;
  __IO uint32_t PCSC       : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t FCSC       : 1;
} stc_crg_int_clr_field_t;

/******************************************************************************
 * HWWDT_MODULE
 ******************************************************************************/
/* HWWDT_MODULE register bit fields */
typedef struct stc_hwwdt_wdg_ctl_field
{
  __IO uint32_t INTEN      : 1;
  __IO uint32_t RESEN      : 1;
} stc_hwwdt_wdg_ctl_field_t;

typedef struct stc_hwwdt_wdg_ris_field
{
  __IO uint32_t RIS        : 1;
} stc_hwwdt_wdg_ris_field_t;

/******************************************************************************
 * SWWDT_MODULE
 ******************************************************************************/
/* SWWDT_MODULE register bit fields */
typedef struct stc_swwdt_wdogcontrol_field
{
  union {
    struct {
      __IO uint32_t INTEN      : 1;
      __IO uint32_t RESEN      : 1;
      __IO uint32_t TWD        : 2;
      __IO uint32_t SPM        : 1;
           uint32_t RESERVED1  : 27;
    };
    struct {
           uint32_t RESERVED2  : 2;
      __IO uint32_t TWD0       : 1;
      __IO uint32_t TWD1       : 1;
           uint32_t RESERVED3  : 28;
    };
  };
} stc_swwdt_wdogcontrol_field_t;

typedef struct stc_swwdt_wdogris_field
{
  __IO uint32_t RIS        : 1;
       uint32_t RESERVED1  : 31;
} stc_swwdt_wdogris_field_t;

typedef struct stc_swwdt_wdogspmc_field
{
  __IO uint32_t TGR        : 1;
       uint32_t RESERVED1  : 31;
} stc_swwdt_wdogspmc_field_t;

/******************************************************************************
 * DTIM_MODULE
 ******************************************************************************/
/* DTIM_MODULE register bit fields */
typedef struct stc_dtim_timerXcontrol_field
{
  union {
    struct {
      __IO uint32_t ONESHOT    : 1;
      __IO uint32_t TIMERSIZE  : 1;
      __IO uint32_t TIMERPRE   : 2;
           uint32_t RESERVED1  : 1;
      __IO uint32_t INTENABLE  : 1;
      __IO uint32_t TIMERMODE  : 1;
      __IO uint32_t TIMEREN    : 1;
           uint32_t RESERVED2  : 24;
    };
    struct {
           uint32_t RESERVED3  : 2;
      __IO uint32_t TIMERPRE0  : 1;
      __IO uint32_t TIMERPRE1  : 1;
           uint32_t RESERVED4  : 28;
    };
  };
} stc_dtim_timerXcontrol_field_t;

typedef struct stc_dtim_timerXris_field
{
  __IO uint32_t TIMERXRIS  : 1;
       uint32_t RESERVED1  : 31;
} stc_dtim_timerXris_field_t;

typedef struct stc_dtim_timerXmis_field
{
  __IO uint32_t TIMERXMIS  : 1;
       uint32_t RESERVED1  : 31;
} stc_dtim_timerXmis_field_t;

/******************************************************************************
 * MFT_FRT_MODULE
 ******************************************************************************/
/* MFT_FRT_MODULE register bit fields */
typedef struct stc_mft_frt_tcsa0_field
{
  __IO uint16_t CLK0       : 1;
  __IO uint16_t CLK1       : 1;
  __IO uint16_t CLK2       : 1;
  __IO uint16_t CLK3       : 1;
  __IO uint16_t SCLR       : 1;
  __IO uint16_t MODE       : 1;
  __IO uint16_t STOP       : 1;
  __IO uint16_t BFE        : 1;
  __IO uint16_t ICRE       : 1;
  __IO uint16_t ICLR       : 1;
       uint16_t RESERVED1  : 3;
  __IO uint16_t IRQZE      : 1;
  __IO uint16_t IRQZF      : 1;
  __IO uint16_t ECKE       : 1;
} stc_mft_frt_tcsa0_field_t;

typedef struct stc_mft_frt_tcsc0_field
{
  __IO uint16_t MSZI       : 4;
  __IO uint16_t MSPI       : 4;
  __IO uint16_t MSZC       : 4;
  __IO uint16_t MSPC       : 4;
} stc_mft_frt_tcsc0_field_t;

typedef struct stc_mft_frt_tcsa1_field
{
  __IO uint16_t CLK0       : 1;
  __IO uint16_t CLK1       : 1;
  __IO uint16_t CLK2       : 1;
  __IO uint16_t CLK3       : 1;
  __IO uint16_t SCLR       : 1;
  __IO uint16_t MODE       : 1;
  __IO uint16_t STOP       : 1;
  __IO uint16_t BFE        : 1;
  __IO uint16_t ICRE       : 1;
  __IO uint16_t ICLR       : 1;
       uint16_t RESERVED1  : 3;
  __IO uint16_t IRQZE      : 1;
  __IO uint16_t IRQZF      : 1;
  __IO uint16_t ECKE       : 1;
} stc_mft_frt_tcsa1_field_t;

typedef struct stc_mft_frt_tcsc1_field
{
  __IO uint16_t MSZI       : 4;
  __IO uint16_t MSPI       : 4;
  __IO uint16_t MSZC       : 4;
  __IO uint16_t MSPC       : 4;
} stc_mft_frt_tcsc1_field_t;

typedef struct stc_mft_frt_tcsa2_field
{
  __IO uint16_t CLK0       : 1;
  __IO uint16_t CLK1       : 1;
  __IO uint16_t CLK2       : 1;
  __IO uint16_t CLK3       : 1;
  __IO uint16_t SCLR       : 1;
  __IO uint16_t MODE       : 1;
  __IO uint16_t STOP       : 1;
  __IO uint16_t BFE        : 1;
  __IO uint16_t ICRE       : 1;
  __IO uint16_t ICLR       : 1;
       uint16_t RESERVED1  : 3;
  __IO uint16_t IRQZE      : 1;
  __IO uint16_t IRQZF      : 1;
  __IO uint16_t ECKE       : 1;
} stc_mft_frt_tcsa2_field_t;

typedef struct stc_mft_frt_tcsc2_field
{
  __IO uint16_t MSZI       : 4;
  __IO uint16_t MSPI       : 4;
  __IO uint16_t MSZC       : 4;
  __IO uint16_t MSPC       : 4;
} stc_mft_frt_tcsc2_field_t;

typedef struct stc_mft_frt_tcal_field
{
  __IO uint32_t STOP00     : 1;
  __IO uint32_t STOP01     : 1;
  __IO uint32_t STOP02     : 1;
  __IO uint32_t STOP10     : 1;
  __IO uint32_t STOP11     : 1;
  __IO uint32_t STOP12     : 1;
  __IO uint32_t STOP20     : 1;
  __IO uint32_t STOP21     : 1;
  __IO uint32_t STOP22     : 1;
  __IO uint32_t RESERVED1  : 7;
  __IO uint32_t SCLR00     : 1;
  __IO uint32_t SCLR01     : 1;
  __IO uint32_t SCLR02     : 1;
  __IO uint32_t SCLR10     : 1;
  __IO uint32_t SCLR11     : 1;
  __IO uint32_t SCLR12     : 1;
  __IO uint32_t SCLR20     : 1;
  __IO uint32_t SCLR21     : 1;
  __IO uint32_t SCLR22     : 1;
  __IO uint32_t RESERVED2  : 7;
} stc_mft_frt_tcal_field_t;

typedef struct stc_mft_frt_tcsd_field
{
  __IO  uint8_t OFMD1      : 4;
  __IO  uint8_t OFMD2      : 4;
} stc_mft_frt_tcsd_field_t;

/******************************************************************************
 * MFT_OCU_MODULE
 ******************************************************************************/
/* MFT_OCU_MODULE register bit fields */
typedef struct stc_mft_ocu_ocsa10_field
{
  __IO  uint8_t CST0       : 1;
  __IO  uint8_t CST1       : 1;
  __IO  uint8_t RESERVED1  : 2;
  __IO  uint8_t IOE0       : 1;
  __IO  uint8_t IOE1       : 1;
  __IO  uint8_t IOP0       : 1;
  __IO  uint8_t IOP1       : 1;
} stc_mft_ocu_ocsa10_field_t;

typedef struct stc_mft_ocu_ocsb10_field
{
  __IO  uint8_t OTD0       : 1;
  __IO  uint8_t OTD1       : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t CMOD       : 1;
        uint8_t RESERVED2  : 2;
  __IO  uint8_t FM4        : 1;
} stc_mft_ocu_ocsb10_field_t;

typedef struct stc_mft_ocu_ocsa32_field
{
  __IO  uint8_t CST0       : 1;
  __IO  uint8_t CST1       : 1;
  __IO  uint8_t RESERVED1  : 2;
  __IO  uint8_t IOE0       : 1;
  __IO  uint8_t IOE1       : 1;
  __IO  uint8_t IOP0       : 1;
  __IO  uint8_t IOP1       : 1;
} stc_mft_ocu_ocsa32_field_t;

typedef struct stc_mft_ocu_ocsb32_field
{
  __IO  uint8_t OTD0       : 1;
  __IO  uint8_t OTD1       : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t CMOD       : 1;
        uint8_t RESERVED2  : 2;
  __IO  uint8_t FM4        : 1;
} stc_mft_ocu_ocsb32_field_t;

typedef struct stc_mft_ocu_ocsa54_field
{
  __IO  uint8_t CST0       : 1;
  __IO  uint8_t CST1       : 1;
  __IO  uint8_t RESERVED1  : 2;
  __IO  uint8_t IOE0       : 1;
  __IO  uint8_t IOE1       : 1;
  __IO  uint8_t IOP0       : 1;
  __IO  uint8_t IOP1       : 1;
} stc_mft_ocu_ocsa54_field_t;

typedef struct stc_mft_ocu_ocsb54_field
{
  __IO  uint8_t OTD0       : 1;
  __IO  uint8_t OTD1       : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t CMOD       : 1;
        uint8_t RESERVED2  : 2;
  __IO  uint8_t FM4        : 1;
} stc_mft_ocu_ocsb54_field_t;

typedef struct stc_mft_ocu_ocsc_field
{
  __IO  uint8_t MOD0       : 1;
  __IO  uint8_t MOD1       : 1;
  __IO  uint8_t MOD2       : 1;
  __IO  uint8_t MOD3       : 1;
  __IO  uint8_t MOD4       : 1;
  __IO  uint8_t MOD5       : 1;
} stc_mft_ocu_ocsc_field_t;

typedef struct stc_mft_ocu_ocfs10_field
{
  __IO  uint8_t FSO00      : 1;
  __IO  uint8_t FSO01      : 1;
  __IO  uint8_t FSO02      : 1;
  __IO  uint8_t FSO03      : 1;
  __IO  uint8_t FSO10      : 1;
  __IO  uint8_t FSO11      : 1;
  __IO  uint8_t FSO12      : 1;
  __IO  uint8_t FSO13      : 1;
} stc_mft_ocu_ocfs10_field_t;

typedef struct stc_mft_ocu_ocfs32_field
{
  __IO  uint8_t FSO00      : 1;
  __IO  uint8_t FSO01      : 1;
  __IO  uint8_t FSO02      : 1;
  __IO  uint8_t FSO03      : 1;
  __IO  uint8_t FSO10      : 1;
  __IO  uint8_t FSO11      : 1;
  __IO  uint8_t FSO12      : 1;
  __IO  uint8_t FSO13      : 1;
} stc_mft_ocu_ocfs32_field_t;

typedef struct stc_mft_ocu_ocfs54_field
{
  __IO  uint8_t FSO00      : 1;
  __IO  uint8_t FSO01      : 1;
  __IO  uint8_t FSO02      : 1;
  __IO  uint8_t FSO03      : 1;
  __IO  uint8_t FSO10      : 1;
  __IO  uint8_t FSO11      : 1;
  __IO  uint8_t FSO12      : 1;
  __IO  uint8_t FSO13      : 1;
} stc_mft_ocu_ocfs54_field_t;

typedef struct stc_mft_ocu_ocsd10_field
{
  __IO uint16_t OCCP0BUFE  : 2;
  __IO uint16_t OCCP1BUFE  : 2;
  __IO uint16_t OCSE0BUFE  : 2;
  __IO uint16_t OCSE1BUFE  : 2;
  __IO uint16_t OPBM0      : 1;
  __IO uint16_t OPBM1      : 1;
  __IO uint16_t OEBM0      : 1;
  __IO uint16_t OEBM1      : 1;
  __IO uint16_t OFEX0      : 1;
  __IO uint16_t OFEX1      : 1;
} stc_mft_ocu_ocsd10_field_t;

typedef struct stc_mft_ocu_ocsd32_field
{
  __IO uint16_t OCCP2BUFE  : 2;
  __IO uint16_t OCCP3BUFE  : 2;
  __IO uint16_t OCSE2BUFE  : 2;
  __IO uint16_t OCSE3BUFE  : 2;
  __IO uint16_t OPBM2      : 1;
  __IO uint16_t OPBM3      : 1;
  __IO uint16_t OEBM2      : 1;
  __IO uint16_t OEBM3      : 1;
  __IO uint16_t OFEX2      : 1;
  __IO uint16_t OFEX3      : 1;
} stc_mft_ocu_ocsd32_field_t;

typedef struct stc_mft_ocu_ocsd54_field
{
  __IO uint16_t OCCP4BUFE  : 2;
  __IO uint16_t OCCP5BUFE  : 2;
  __IO uint16_t OCSE4BUFE  : 2;
  __IO uint16_t OCSE5BUFE  : 2;
  __IO uint16_t OPBM4      : 1;
  __IO uint16_t OPBM5      : 1;
  __IO uint16_t OEBM4      : 1;
  __IO uint16_t OEBM5      : 1;
  __IO uint16_t OFEX4      : 1;
  __IO uint16_t OFEX5      : 1;
} stc_mft_ocu_ocsd54_field_t;

typedef struct stc_mft_ocu_ocse0_field
{
  __IO  uint16_t OCSE      : 16;
} stc_mft_ocu_ocse0_field_t;

typedef struct stc_mft_ocu_ocse1_field
{
  __IO  uint32_t OCSE      : 32;
} stc_mft_ocu_ocse1_field_t;

typedef struct stc_mft_ocu_ocse2_field
{
  __IO  uint16_t OCSE      : 16;
} stc_mft_ocu_ocse2_field_t;

typedef struct stc_mft_ocu_ocse3_field
{
  __IO  uint32_t OCSE      : 32;
} stc_mft_ocu_ocse3_field_t;

typedef struct stc_mft_ocu_ocse4_field
{
  __IO  uint16_t OCSE      : 16;
} stc_mft_ocu_ocse4_field_t;

typedef struct stc_mft_ocu_ocse5_field
{
  __IO  uint32_t OCSE      : 32;
} stc_mft_ocu_ocse5_field_t;

/******************************************************************************
 * MFT_WFG_MODULE
 ******************************************************************************/
/* MFT_WFG_MODULE register bit fields */
typedef struct stc_mft_wfg_wfsa10_field
{
  __IO uint16_t DCK0       : 1;
  __IO uint16_t DCK1       : 1;
  __IO uint16_t DCK2       : 1;
  __IO uint16_t TMD        : 3;
  __IO uint16_t GTEN0      : 1;
  __IO uint16_t GTEN1      : 1;
  __IO uint16_t PSEL0      : 1;
  __IO uint16_t PSEL1      : 1;
  __IO uint16_t PGEN0      : 1;
  __IO uint16_t PGEN1      : 1;
  __IO uint16_t DMOD       : 2;
} stc_mft_wfg_wfsa10_field_t;

typedef struct stc_mft_wfg_wfsa32_field
{
  __IO uint16_t DCK0       : 1;
  __IO uint16_t DCK1       : 1;
  __IO uint16_t DCK2       : 1;
  __IO uint16_t TMD        : 3;
  __IO uint16_t GTEN0      : 1;
  __IO uint16_t GTEN1      : 1;
  __IO uint16_t PSEL0      : 1;
  __IO uint16_t PSEL1      : 1;
  __IO uint16_t PGEN0      : 1;
  __IO uint16_t PGEN1      : 1;
  __IO uint16_t DMOD       : 2;
} stc_mft_wfg_wfsa32_field_t;

typedef struct stc_mft_wfg_wfsa54_field
{
  __IO uint16_t DCK0       : 1;
  __IO uint16_t DCK1       : 1;
  __IO uint16_t DCK2       : 1;
  __IO uint16_t TMD        : 3;
  __IO uint16_t GTEN0      : 1;
  __IO uint16_t GTEN1      : 1;
  __IO uint16_t PSEL0      : 1;
  __IO uint16_t PSEL1      : 1;
  __IO uint16_t PGEN0      : 1;
  __IO uint16_t PGEN1      : 1;
  __IO uint16_t DMOD       : 2;
} stc_mft_wfg_wfsa54_field_t;

typedef struct stc_mft_wfg_wfir_field
{
  __IO uint16_t DTIFA      : 1;
  __IO uint16_t DTICA      : 1;
  __IO uint16_t DTIFB      : 1;
  __IO uint16_t DTICB      : 1;
  __IO uint16_t TMIF10     : 1;
  __IO uint16_t TMIC10     : 1;
  __IO uint16_t TMIE10     : 1;
  __IO uint16_t TMIS10     : 1;
  __IO uint16_t TMIF32     : 1;
  __IO uint16_t TMIC32     : 1;
  __IO uint16_t TMIE32     : 1;
  __IO uint16_t TMIS32     : 1;
  __IO uint16_t TMIF54     : 1;
  __IO uint16_t TMIC54     : 1;
  __IO uint16_t TMIE54     : 1;
  __IO uint16_t TMIS54     : 1;
} stc_mft_wfg_wfir_field_t;

typedef struct stc_mft_wfg_nzcl_field
{
  __IO uint16_t DTIEA      : 1;
  __IO uint16_t NWS0       : 1;
  __IO uint16_t NWS1       : 1;
  __IO uint16_t NWS2       : 1;
  __IO uint16_t SDTI       : 1;
  __IO uint16_t DTIEB      : 1;
       uint16_t RESERVED1  : 1;
  __IO uint16_t DHOLD      : 1;
  __IO uint16_t DIMA       : 1;
  __IO uint16_t DIMB       : 1;
       uint16_t RESERVED2  : 2;
  __IO uint16_t WIM10      : 1;
  __IO uint16_t WIM32      : 1;
  __IO uint16_t WIM54      : 1;
       uint16_t RESERVED3  : 1;
} stc_mft_wfg_nzcl_field_t;

/******************************************************************************
 * MFT_ICU_MODULE
 ******************************************************************************/
/* MFT_ICU_MODULE register bit fields */
typedef struct stc_mft_icu_icfs10_field
{
  __IO  uint8_t FSI00      : 1;
  __IO  uint8_t FSI01      : 1;
  __IO  uint8_t FSI02      : 1;
  __IO  uint8_t FSI03      : 1;
  __IO  uint8_t FSI10      : 1;
  __IO  uint8_t FSI11      : 1;
  __IO  uint8_t FSI12      : 1;
  __IO  uint8_t FSI13      : 1;
} stc_mft_icu_icfs10_field_t;

typedef struct stc_mft_icu_icfs32_field
{
  __IO  uint8_t FSI00      : 1;
  __IO  uint8_t FSI01      : 1;
  __IO  uint8_t FSI02      : 1;
  __IO  uint8_t FSI03      : 1;
  __IO  uint8_t FSI10      : 1;
  __IO  uint8_t FSI11      : 1;
  __IO  uint8_t FSI12      : 1;
  __IO  uint8_t FSI13      : 1;
} stc_mft_icu_icfs32_field_t;

typedef struct stc_mft_icu_icsa10_field
{
  __IO  uint8_t EG00       : 1;
  __IO  uint8_t EG01       : 1;
  __IO  uint8_t EG10       : 1;
  __IO  uint8_t EG11       : 1;
  __IO  uint8_t ICE0       : 1;
  __IO  uint8_t ICE1       : 1;
  __IO  uint8_t ICP0       : 1;
  __IO  uint8_t ICP1       : 1;
} stc_mft_icu_icsa10_field_t;

typedef struct stc_mft_icu_icsb10_field
{
  __IO  uint8_t IEI0       : 1;
  __IO  uint8_t IEI1       : 1;
} stc_mft_icu_icsb10_field_t;

typedef struct stc_mft_icu_icsa32_field
{
  __IO  uint8_t EG00       : 1;
  __IO  uint8_t EG01       : 1;
  __IO  uint8_t EG10       : 1;
  __IO  uint8_t EG11       : 1;
  __IO  uint8_t ICE0       : 1;
  __IO  uint8_t ICE1       : 1;
  __IO  uint8_t ICP0       : 1;
  __IO  uint8_t ICP1       : 1;
} stc_mft_icu_icsa32_field_t;

typedef struct stc_mft_icu_icsb32_field
{
  __IO  uint8_t IEI0       : 1;
  __IO  uint8_t IEI1       : 1;
} stc_mft_icu_icsb32_field_t;

/******************************************************************************
 * MFT_ADCMP_MODULE
 ******************************************************************************/
/* MFT_ADCMP_MODULE register bit fields */
typedef struct stc_mft_adcmp_acfs10_field
{
  __IO  uint8_t FSA0       : 4;
  __IO  uint8_t FSA1       : 4;
} stc_mft_adcmp_acfs10_field_t;

typedef struct stc_mft_adcmp_acfs32_field
{
  __IO  uint8_t FSA2       : 4;
  __IO  uint8_t FSA3       : 4;
} stc_mft_adcmp_acfs32_field_t;

typedef struct stc_mft_adcmp_acfs54_field
{
  __IO  uint8_t FSA4       : 4;
  __IO  uint8_t FSA5       : 4;
} stc_mft_adcmp_acfs54_field_t;

typedef struct stc_mft_adcmp_acsa_field
{
  __IO uint16_t CE10       : 2;
  __IO uint16_t CE32       : 2;
  __IO uint16_t CE54       : 2;
       uint16_t RESERVED1  : 2;
  __IO uint16_t SEL10      : 2;
  __IO uint16_t SEL32      : 2;
  __IO uint16_t SEL54      : 2;
} stc_mft_adcmp_acsa_field_t;

typedef struct stc_mft_adcmp_acsc_field
{
  __IO uint8_t BUFE        : 2;
  __IO uint8_t ADSEL       : 3;
  __IO uint8_t APBM        : 1;
       uint8_t RESERVED1   : 2;
} stc_mft_adcmp_acsc_field_t;

typedef struct stc_mft_adcmp_acsd_field
{
  __IO uint8_t AMOD        : 1;
  __IO uint8_t OCUS        : 1;
       uint8_t RESERVED1   : 2;
  __IO uint8_t DE          : 1;
  __IO uint8_t PE          : 1;
  __IO uint8_t UE          : 1;
  __IO uint8_t ZE          : 1;
} stc_mft_adcmp_acsd_field_t;

typedef struct stc_mft_adcmp_acmc_field
{
  __IO uint8_t AMC         : 4;
       uint8_t RESERVED1   : 2;
  __IO uint8_t MZCE        : 1;
  __IO uint8_t MPCE        : 1;
} stc_mft_adcmp_acmc_field_t;

/******************************************************************************
 * DAC MODULE
 ******************************************************************************/
typedef struct stc_dacr_field
{
  __IO  uint8_t DAE        : 1;
  __IO  uint8_t DRDY       : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t DAC10      : 1;
  __IO  uint8_t DDAS       : 1;
  __IO  uint8_t RESERVED2  : 2;
} stc_dacr_field_t;

typedef struct stc_dadr_field
{
  __IO  uint16_t DA         : 12;
  __IO  uint16_t RESERVED   : 4;
} stc_dadr_field_t;

/******************************************************************************
 * MFT_PPG_MODULE
 ******************************************************************************/
/* MFT_PPG_MODULE register bit fields */
typedef struct stc_mft_ppg_ttcr0_field
{
  __IO  uint8_t STR0       : 1;
  __IO  uint8_t MONI0      : 1;
  __IO  uint8_t CS00       : 1;
  __IO  uint8_t CS01       : 1;
  __IO  uint8_t TRG0O      : 1;
  __IO  uint8_t TRG2O      : 1;
  __IO  uint8_t TRG4O      : 1;
  __IO  uint8_t TRG6O      : 1;
} stc_mft_ppg_ttcr0_field_t;

typedef struct stc_mft_ppg_ttcr1_field
{
  __IO  uint8_t STR1       : 1;
  __IO  uint8_t MONI1      : 1;
  __IO  uint8_t CS10       : 1;
  __IO  uint8_t CS11       : 1;
  __IO  uint8_t TRG1O      : 1;
  __IO  uint8_t TRG3O      : 1;
  __IO  uint8_t TRG5O      : 1;
  __IO  uint8_t TRG7O      : 1;
} stc_mft_ppg_ttcr1_field_t;

typedef struct stc_mft_ppg_ttcr2_field
{
  __IO  uint8_t STR2       : 1;
  __IO  uint8_t MONI2      : 1;
  __IO  uint8_t CS20       : 1;
  __IO  uint8_t CS21       : 1;
  __IO  uint8_t TRG16O     : 1;
  __IO  uint8_t TRG18O     : 1;
  __IO  uint8_t TRG20O     : 1;
  __IO  uint8_t TRG22O     : 1;
} stc_mft_ppg_ttcr2_field_t;

typedef struct stc_mft_ppg_trg_field
{
  __IO uint16_t PEN00      : 1;
  __IO uint16_t PEN01      : 1;
  __IO uint16_t PEN02      : 1;
  __IO uint16_t PEN03      : 1;
  __IO uint16_t PEN04      : 1;
  __IO uint16_t PEN05      : 1;
  __IO uint16_t PEN06      : 1;
  __IO uint16_t PEN07      : 1;
  __IO uint16_t PEN08      : 1;
  __IO uint16_t PEN09      : 1;
  __IO uint16_t PEN10      : 1;
  __IO uint16_t PEN11      : 1;
  __IO uint16_t PEN12      : 1;
  __IO uint16_t PEN13      : 1;
  __IO uint16_t PEN14      : 1;
  __IO uint16_t PEN15      : 1;
} stc_mft_ppg_trg0_field_t;

typedef struct stc_mft_ppg_trg1_field
{
  __IO uint16_t PEN16      : 1;
  __IO uint16_t PEN17      : 1;
  __IO uint16_t PEN18      : 1;
  __IO uint16_t PEN19      : 1;
  __IO uint16_t PEN20      : 1;
  __IO uint16_t PEN21      : 1;
  __IO uint16_t PEN22      : 1;
  __IO uint16_t PEN23      : 1;
} stc_mft_ppg_trg1_field_t;

typedef struct stc_mft_ppg_revc_field
{
  __IO uint16_t REV00      : 1;
  __IO uint16_t REV01      : 1;
  __IO uint16_t REV02      : 1;
  __IO uint16_t REV03      : 1;
  __IO uint16_t REV04      : 1;
  __IO uint16_t REV05      : 1;
  __IO uint16_t REV06      : 1;
  __IO uint16_t REV07      : 1;
  __IO uint16_t REV08      : 1;
  __IO uint16_t REV09      : 1;
  __IO uint16_t REV10      : 1;
  __IO uint16_t REV11      : 1;
  __IO uint16_t REV12      : 1;
  __IO uint16_t REV13      : 1;
  __IO uint16_t REV14      : 1;
  __IO uint16_t REV15      : 1;
} stc_mft_ppg_revc0_field_t;

typedef struct stc_mft_ppg_revc1_field
{
  __IO uint16_t REV16      : 1;
  __IO uint16_t REV17      : 1;
  __IO uint16_t REV18      : 1;
  __IO uint16_t REV19      : 1;
  __IO uint16_t REV20      : 1;
  __IO uint16_t REV21      : 1;
  __IO uint16_t REV22      : 1;
  __IO uint16_t REV23      : 1;
} stc_mft_ppg_revc1_field_t;

typedef struct stc_mft_ppg_ppgc1_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc1_field_t;

typedef struct stc_mft_ppg_ppgc0_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc0_field_t;

typedef struct stc_mft_ppg_ppgc3_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc3_field_t;

typedef struct stc_mft_ppg_ppgc2_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc2_field_t;

typedef struct stc_mft_ppg_gatec0_field
{
  __IO  uint8_t EDGE0      : 1;
  __IO  uint8_t STRG0      : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t EDGE2      : 1;
  __IO  uint8_t STRG2      : 1;
} stc_mft_ppg_gatec0_field_t;

typedef struct stc_mft_ppg_ppgc5_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc5_field_t;

typedef struct stc_mft_ppg_ppgc4_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc4_field_t;

typedef struct stc_mft_ppg_ppgc7_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc7_field_t;

typedef struct stc_mft_ppg_ppgc6_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc6_field_t;

typedef struct stc_mft_ppg_gatec4_field
{
  __IO  uint8_t EDGE4      : 1;
  __IO  uint8_t STRG4      : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t EDGE6      : 1;
  __IO  uint8_t STRG6      : 1;
} stc_mft_ppg_gatec4_field_t;

typedef struct stc_mft_ppg_ppgc9_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc9_field_t;

typedef struct stc_mft_ppg_ppgc8_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc8_field_t;

typedef struct stc_mft_ppg_ppgc11_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc11_field_t;

typedef struct stc_mft_ppg_ppgc10_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc10_field_t;

typedef struct stc_mft_ppg_gatec8_field
{
  __IO  uint8_t EDGE8      : 1;
  __IO  uint8_t STRG8      : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t EDGE10     : 1;
  __IO  uint8_t STRG10     : 1;
} stc_mft_ppg_gatec8_field_t;

typedef struct stc_mft_ppg_ppgc13_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc13_field_t;

typedef struct stc_mft_ppg_ppgc12_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc12_field_t;

typedef struct stc_mft_ppg_ppgc15_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc15_field_t;

typedef struct stc_mft_ppg_ppgc14_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc14_field_t;

typedef struct stc_mft_ppg_gatec12_field
{
  __IO  uint8_t EDGE12     : 1;
  __IO  uint8_t STRG12     : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t EDGE14     : 1;
  __IO  uint8_t STRG14     : 1;
} stc_mft_ppg_gatec12_field_t;

typedef struct stc_mft_ppg_ppgc17_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc17_field_t;

typedef struct stc_mft_ppg_ppgc16_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc16_field_t;

typedef struct stc_mft_ppg_ppgc19_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc19_field_t;

typedef struct stc_mft_ppg_ppgc18_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc18_field_t;

typedef struct stc_mft_ppg_gatec16_field
{
  __IO  uint8_t EDGE16     : 1;
  __IO  uint8_t STRG16     : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t EDGE18     : 1;
  __IO  uint8_t STRG18     : 1;
} stc_mft_ppg_gatec16_field_t;

typedef struct stc_mft_ppg_ppgc21_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc21_field_t;

typedef struct stc_mft_ppg_ppgc20_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc20_field_t;

typedef struct stc_mft_ppg_ppgc23_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc23_field_t;

typedef struct stc_mft_ppg_ppgc22_field
{
  __IO  uint8_t TTRG       : 1;
  __IO  uint8_t MD         : 2;
  __IO  uint8_t PCS0       : 1;
  __IO  uint8_t PCS1       : 1;
  __IO  uint8_t INTM       : 1;
  __IO  uint8_t PUF        : 1;
  __IO  uint8_t PIE        : 1;
} stc_mft_ppg_ppgc22_field_t;

typedef struct stc_mft_ppg_gatec20_field
{
  __IO  uint8_t EDGE20     : 1;
  __IO  uint8_t STRG20     : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t EDGE22     : 1;
  __IO  uint8_t STRG22     : 1;
} stc_mft_ppg_gatec20_field_t;

/******************************************************************************
 * BT_PPG_MODULE
 ******************************************************************************/
/* BT_PPG_MODULE register bit fields */
typedef struct stc_bt_ppg_tmcr_field
{
  __IO uint16_t STRG       : 1;
  __IO uint16_t CTEN       : 1;
  __IO uint16_t MDSE       : 1;
  __IO uint16_t OSEL       : 1;
  __IO uint16_t FMD0       : 1;
  __IO uint16_t FMD1       : 1;
  __IO uint16_t FMD2       : 1;
       uint16_t RESERVED1  : 1;
  __IO uint16_t EGS0       : 1;
  __IO uint16_t EGS1       : 1;
  __IO uint16_t PMSK       : 1;
  __IO uint16_t RTGEN      : 1;
  __IO uint16_t CKS0       : 1;
  __IO uint16_t CKS1       : 1;
  __IO uint16_t CKS2       : 1;
} stc_bt_ppg_tmcr_field_t;

typedef struct stc_bt_ppg_stc_field
{
  __IO  uint8_t UDIR       : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t TGIR       : 1;
        uint8_t RESERVED2  : 1;
  __IO  uint8_t UDIE       : 1;
        uint8_t RESERVED3  : 1;
  __IO  uint8_t TGIE       : 1;
} stc_bt_ppg_stc_field_t;

typedef struct stc_bt_ppg_tmcr2_field
{
  __IO  uint8_t CKS3       : 1;
} stc_bt_ppg_tmcr2_field_t;

/******************************************************************************
 * BT_PWM_MODULE
 ******************************************************************************/
/* BT_PWM_MODULE register bit fields */
typedef struct stc_bt_pwm_tmcr_field
{
  __IO uint16_t STRG       : 1;
  __IO uint16_t CTEN       : 1;
  __IO uint16_t MDSE       : 1;
  __IO uint16_t OSEL       : 1;
  __IO uint16_t FMD0       : 1;
  __IO uint16_t FMD1       : 1;
  __IO uint16_t FMD2       : 1;
       uint16_t RESERVED1  : 1;
  __IO uint16_t EGS0       : 1;
  __IO uint16_t EGS1       : 1;
  __IO uint16_t PMSK       : 1;
  __IO uint16_t RTGEN      : 1;
  __IO uint16_t CKS0       : 1;
  __IO uint16_t CKS1       : 1;
  __IO uint16_t CKS2       : 1;
} stc_bt_pwm_tmcr_field_t;

typedef struct stc_bt_pwm_stc_field
{
  __IO  uint8_t UDIR       : 1;
  __IO  uint8_t DTIR       : 1;
  __IO  uint8_t TGIR       : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t UDIE       : 1;
  __IO  uint8_t DTIE       : 1;
  __IO  uint8_t TGIE       : 1;
} stc_bt_pwm_stc_field_t;

typedef struct stc_bt_pwm_tmcr2_field
{
  __IO  uint8_t CKS3       : 1;
} stc_bt_pwm_tmcr2_field_t;

/******************************************************************************
 * BT_RT_MODULE
 ******************************************************************************/
/* BT_RT_MODULE register bit fields */
typedef struct stc_bt_rt_tmcr_field
{
  __IO uint16_t STRG       : 1;
  __IO uint16_t CTEN       : 1;
  __IO uint16_t MDSE       : 1;
  __IO uint16_t OSEL       : 1;
  __IO uint16_t FMD0       : 1;
  __IO uint16_t FMD1       : 1;
  __IO uint16_t FMD2       : 1;
  __IO uint16_t T32        : 1;
  __IO uint16_t EGS0       : 1;
  __IO uint16_t EGS1       : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t CKS0       : 1;
  __IO uint16_t CKS1       : 1;
  __IO uint16_t CKS2       : 1;
} stc_bt_rt_tmcr_field_t;

typedef struct stc_bt_rt_stc_field
{
  __IO  uint8_t UDIR       : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t TGIR       : 1;
        uint8_t RESERVED2  : 1;
  __IO  uint8_t UDIE       : 1;
        uint8_t RESERVED3  : 1;
  __IO  uint8_t TGIE       : 1;
} stc_bt_rt_stc_field_t;

typedef struct stc_bt_rt_tmcr2_field
{
  __IO  uint8_t CKS3       : 1;
  __IO  uint8_t RESERVED1  : 6;
  __IO  uint8_t GATE       : 1;
} stc_bt_rt_tmcr2_field_t;

/******************************************************************************
 * BT_PWC_MODULE
 ******************************************************************************/
/* BT_PWC_MODULE register bit fields */
typedef struct stc_bt_pwc_tmcr_field
{
       uint16_t RESERVED1  : 1;
  __IO uint16_t CTEN       : 1;
  __IO uint16_t MDSE       : 1;
       uint16_t RESERVED2  : 1;
  __IO uint16_t FMD0       : 1;
  __IO uint16_t FMD1       : 1;
  __IO uint16_t FMD2       : 1;
  __IO uint16_t T32        : 1;
  __IO uint16_t EGS0       : 1;
  __IO uint16_t EGS1       : 1;
  __IO uint16_t EGS2       : 1;
       uint16_t RESERVED3  : 1;
  __IO uint16_t CKS0       : 1;
  __IO uint16_t CKS1       : 1;
  __IO uint16_t CKS2       : 1;
} stc_bt_pwc_tmcr_field_t;

typedef struct stc_bt_pwc_stc_field
{
  __IO  uint8_t OVIR       : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t EDIR       : 1;
        uint8_t RESERVED2  : 1;
  __IO  uint8_t OVIE       : 1;
        uint8_t RESERVED3  : 1;
  __IO  uint8_t EDIE       : 1;
  __IO  uint8_t ERR        : 1;
} stc_bt_pwc_stc_field_t;

typedef struct stc_bt_pwc_tmcr2_field
{
  __IO  uint8_t CKS3       : 1;
} stc_bt_pwc_tmcr2_field_t;

/******************************************************************************
 * BTIOSEL03_MODULE
 ******************************************************************************/
/* BTIOSEL03_MODULE register bit fields */
typedef struct stc_btiosel03_btsel0123_field
{
  __IO  uint8_t SEL01_0    : 1;
  __IO  uint8_t SEL01_1    : 1;
  __IO  uint8_t SEL01_2    : 1;
  __IO  uint8_t SEL01_3    : 1;
  __IO  uint8_t SEL23_0    : 1;
  __IO  uint8_t SEL23_1    : 1;
  __IO  uint8_t SEL23_2    : 1;
  __IO  uint8_t SEL23_3    : 1;
} stc_btiosel03_btsel0123_field_t;

/******************************************************************************
 * BTIOSEL47_MODULE
 ******************************************************************************/
/* BTIOSEL47_MODULE register bit fields */
typedef struct stc_btiosel47_btsel4567_field
{
  __IO  uint8_t SEL45_0    : 1;
  __IO  uint8_t SEL45_1    : 1;
  __IO  uint8_t SEL45_2    : 1;
  __IO  uint8_t SEL45_3    : 1;
  __IO  uint8_t SEL67_0    : 1;
  __IO  uint8_t SEL67_1    : 1;
  __IO  uint8_t SEL67_2    : 1;
  __IO  uint8_t SEL67_3    : 1;
} stc_btiosel47_btsel4567_field_t;

/******************************************************************************
 * BTIOSEL811_MODULE
 ******************************************************************************/
/* BTIOSEL811_MODULE register bit fields */
typedef struct stc_btiosel8b_btsel89ab_field
{
  __IO  uint8_t SEL89_0    : 1;
  __IO  uint8_t SEL89_1    : 1;
  __IO  uint8_t SEL89_2    : 1;
  __IO  uint8_t SEL89_3    : 1;
  __IO  uint8_t SELAB_0    : 1;
  __IO  uint8_t SELAB_1    : 1;
  __IO  uint8_t SELAB_2    : 1;
  __IO  uint8_t SELAB_3    : 1;
} stc_btiosel8b_btsel89ab_field_t;

/******************************************************************************
 * BTIOSEL1215_MODULE
 ******************************************************************************/
/* BTIOSEL1215_MODULE register bit fields */
typedef struct stc_btioselcf_btselcdef_field
{
  __IO  uint8_t SELCD_0    : 1;
  __IO  uint8_t SELCD_1    : 1;
  __IO  uint8_t SELCD_2    : 1;
  __IO  uint8_t SELCD_3    : 1;
  __IO  uint8_t SELEF_0    : 1;
  __IO  uint8_t SELEF_1    : 1;
  __IO  uint8_t SELEF_2    : 1;
  __IO  uint8_t SELEF_3    : 1;
} stc_btioselcf_btselcdef_field_t;

/******************************************************************************
 * SBSSR_MODULE
 ******************************************************************************/
/* SBSSR_MODULE register bit fields */
typedef struct stc_sbssr_btsssr_field
{
  __IO uint16_t SSR0       : 1;
  __IO uint16_t SSR1       : 1;
  __IO uint16_t SSR2       : 1;
  __IO uint16_t SSR3       : 1;
  __IO uint16_t SSR4       : 1;
  __IO uint16_t SSR5       : 1;
  __IO uint16_t SSR6       : 1;
  __IO uint16_t SSR7       : 1;
  __IO uint16_t SSR8       : 1;
  __IO uint16_t SSR9       : 1;
  __IO uint16_t SSR10      : 1;
  __IO uint16_t SSR11      : 1;
  __IO uint16_t SSR12      : 1;
  __IO uint16_t SSR13      : 1;
  __IO uint16_t SSR14      : 1;
  __IO uint16_t SSR15      : 1;
} stc_sbssr_btsssr_field_t;

/******************************************************************************
 * QPRC_MODULE
 ******************************************************************************/
/* QPRC_MODULE register bit fields */
typedef struct stc_qprc_qicr_field
{
  __IO uint16_t QPCMIE     : 1;
  __IO uint16_t QPCMF      : 1;
  __IO uint16_t QPRCMIE    : 1;
  __IO uint16_t QPRCMF     : 1;
  __IO uint16_t OUZIE      : 1;
  __IO uint16_t UFDF       : 1;
  __IO uint16_t OFDF       : 1;
  __IO uint16_t ZIIF       : 1;
  __IO uint16_t CDCIE      : 1;
  __IO uint16_t CDCF       : 1;
  __IO uint16_t DIRPC      : 1;
  __IO uint16_t DIROU      : 1;
  __IO uint16_t QPCNRCMIE  : 1;
  __IO uint16_t QPCNRCMF   : 1;
} stc_qprc_qicr_field_t;

typedef struct stc_qprc_qicrl_field
{
  __IO  uint8_t QPCMIE     : 1;
  __IO  uint8_t QPCMF      : 1;
  __IO  uint8_t QPRCMIE    : 1;
  __IO  uint8_t QPRCMF     : 1;
  __IO  uint8_t OUZIE      : 1;
  __IO  uint8_t UFDF       : 1;
  __IO  uint8_t OFDF       : 1;
  __IO  uint8_t ZIIF       : 1;
} stc_qprc_qicrl_field_t;

typedef struct stc_qprc_qicrh_field
{
  __IO  uint8_t CDCIE      : 1;
  __IO  uint8_t CDCF       : 1;
  __IO  uint8_t DIRPC      : 1;
  __IO  uint8_t DIROU      : 1;
  __IO  uint8_t QPCNRCMIE  : 1;
  __IO  uint8_t QPCNRCMF   : 1;
} stc_qprc_qicrh_field_t;

typedef struct stc_qprc_qcr_field
{
  __IO uint16_t PCM0       : 1;
  __IO uint16_t PCM1       : 1;
  __IO uint16_t RCM0       : 1;
  __IO uint16_t RCM1       : 1;
  __IO uint16_t PSTP       : 1;
  __IO uint16_t CGSC       : 1;
  __IO uint16_t RSEL       : 1;
  __IO uint16_t SWAP       : 1;
  __IO uint16_t PCRM0      : 1;
  __IO uint16_t PCRM1      : 1;
  __IO uint16_t AES0       : 1;
  __IO uint16_t AES1       : 1;
  __IO uint16_t BES0       : 1;
  __IO uint16_t BES1       : 1;
  __IO uint16_t CGE0       : 1;
  __IO uint16_t CGE1       : 1;
} stc_qprc_qcr_field_t;

typedef struct stc_qprc_qcrl_field
{
  __IO  uint8_t PCM0       : 1;
  __IO  uint8_t PCM1       : 1;
  __IO  uint8_t RCM0       : 1;
  __IO  uint8_t RCM1       : 1;
  __IO  uint8_t PSTP       : 1;
  __IO  uint8_t CGSC       : 1;
  __IO  uint8_t RSEL       : 1;
  __IO  uint8_t SWAP       : 1;
} stc_qprc_qcrl_field_t;

typedef struct stc_qprc_qcrh_field
{
  __IO  uint8_t PCRM0      : 1;
  __IO  uint8_t PCRM1      : 1;
  __IO  uint8_t AES0       : 1;
  __IO  uint8_t AES1       : 1;
  __IO  uint8_t BES0       : 1;
  __IO  uint8_t BES1       : 1;
  __IO  uint8_t CGE0       : 1;
  __IO  uint8_t CGE1       : 1;
} stc_qprc_qcrh_field_t;

typedef struct stc_qprc_qecr_field
{
  __IO uint16_t ORNGMD     : 1;
  __IO uint16_t ORNGF      : 1;
  __IO uint16_t ORNGIE     : 1;
  __IO uint16_t PEC        : 1;
} stc_qprc_qecr_field_t;

/******************************************************************************
 * QPRC_NF_MODULE
 ******************************************************************************/
/* QPRC_NF_MODULE register bit fields */
typedef struct stc_qprc_nf_nfctla_field
{
  __IO uint8_t AINNWS     : 3;
       uint8_t RESERVED1  : 1;
  __IO uint8_t AINLV      : 1;
  __IO uint8_t AINMD      : 1;
} stc_qprc_nf_nfctla_field_t;

typedef struct stc_qprc_nf_nfctlb_field
{
  __IO uint8_t BINNWS     : 3;
       uint8_t RESERVED1  : 1;
  __IO uint8_t BINLV      : 1;
  __IO uint8_t BINMD      : 1;
} stc_qprc_nf_nfctlb_field_t;

typedef struct stc_qprc_nf_nfrctlz_field
{
  __IO uint8_t ZINNWS     : 3;
       uint8_t RESERVED1  : 1;
  __IO uint8_t ZINLV      : 1;
  __IO uint8_t ZINMD      : 1;
} stc_qprc_nf_nfrctlz_field_t;

/******************************************************************************
 * ADC12_MODULE
 ******************************************************************************/
/* ADC12_MODULE register bit fields */
typedef struct stc_adc_adsr_field
{
  __IO  uint8_t SCS        : 1;
  __IO  uint8_t PCS        : 1;
  __IO  uint8_t PCNS       : 1;
        uint8_t RESERVED1  : 3;
  __IO  uint8_t FDAS       : 1;
  __IO  uint8_t ADSTP      : 1;
} stc_adc_adsr_field_t;

typedef struct stc_adc_adcr_field
{
  __IO  uint8_t OVRIE      : 1;
  __IO  uint8_t CMPIE      : 1;
  __IO  uint8_t PCIE       : 1;
  __IO  uint8_t SCIE       : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t CMPIF      : 1;
  __IO  uint8_t PCIF       : 1;
  __IO  uint8_t SCIF       : 1;
} stc_adc_adcr_field_t;

typedef struct stc_adc_sfns_field
{
  __IO  uint8_t SFS0       : 1;
  __IO  uint8_t SFS1       : 1;
  __IO  uint8_t SFS2       : 1;
  __IO  uint8_t SFS3       : 1;
} stc_adc_sfns_field_t;

typedef struct stc_adc_sccr_field
{
  __IO  uint8_t SSTR       : 1;
  __IO  uint8_t SHEN       : 1;
  __IO  uint8_t RPT        : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t SFCLR      : 1;
  __IO  uint8_t SOVR       : 1;
  __IO  uint8_t SFUL       : 1;
  __IO  uint8_t SEMP       : 1;
} stc_adc_sccr_field_t;

typedef struct stc_adc_scfd_field
{
  __IO uint32_t SC0        : 1;
  __IO uint32_t SC1        : 1;
  __IO uint32_t SC2        : 1;
  __IO uint32_t SC3        : 1;
  __IO uint32_t SC4        : 1;
       uint32_t RESERVED1  : 3;
  __IO uint32_t RS0        : 1;
  __IO uint32_t RS1        : 1;
       uint32_t RESERVED2  : 2;
  __IO uint32_t INVL       : 1;
       uint32_t RESERVED3  : 7;
  __IO uint32_t SD0        : 1;
  __IO uint32_t SD1        : 1;
  __IO uint32_t SD2        : 1;
  __IO uint32_t SD3        : 1;
  __IO uint32_t SD4        : 1;
  __IO uint32_t SD5        : 1;
  __IO uint32_t SD6        : 1;
  __IO uint32_t SD7        : 1;
  __IO uint32_t SD8        : 1;
  __IO uint32_t SD9        : 1;
  __IO uint32_t SD10       : 1;
  __IO uint32_t SD11       : 1;
} stc_adc_scfd_field_t;

typedef struct stc_adc_scfdl_field
{
  __IO uint16_t SC0        : 1;
  __IO uint16_t SC1        : 1;
  __IO uint16_t SC2        : 1;
  __IO uint16_t SC3        : 1;
  __IO uint16_t SC4        : 1;
       uint16_t RESERVED1  : 3;
  __IO uint16_t RS0        : 1;
  __IO uint16_t RS1        : 1;
       uint16_t RESERVED2  : 2;
  __IO uint16_t INVL       : 1;
} stc_adc_scfdl_field_t;

typedef struct stc_adc_scfdh_field
{
       uint16_t RESERVED1  : 4;
  __IO uint16_t SD0        : 1;
  __IO uint16_t SD1        : 1;
  __IO uint16_t SD2        : 1;
  __IO uint16_t SD3        : 1;
  __IO uint16_t SD4        : 1;
  __IO uint16_t SD5        : 1;
  __IO uint16_t SD6        : 1;
  __IO uint16_t SD7        : 1;
  __IO uint16_t SD8        : 1;
  __IO uint16_t SD9        : 1;
  __IO uint16_t SD10       : 1;
  __IO uint16_t SD11       : 1;
} stc_adc_scfdh_field_t;

typedef struct stc_adc_scis23_field
{
  __IO uint16_t AN16       : 1;
  __IO uint16_t AN17       : 1;
  __IO uint16_t AN18       : 1;
  __IO uint16_t AN19       : 1;
  __IO uint16_t AN20       : 1;
  __IO uint16_t AN21       : 1;
  __IO uint16_t AN22       : 1;
  __IO uint16_t AN23       : 1;
  __IO uint16_t AN24       : 1;
  __IO uint16_t AN25       : 1;
  __IO uint16_t AN26       : 1;
  __IO uint16_t AN27       : 1;
  __IO uint16_t AN28       : 1;
  __IO uint16_t AN29       : 1;
  __IO uint16_t AN30       : 1;
  __IO uint16_t AN31       : 1;
} stc_adc_scis23_field_t;

typedef struct stc_adc_scis2_field
{
  __IO  uint8_t AN16       : 1;
  __IO  uint8_t AN17       : 1;
  __IO  uint8_t AN18       : 1;
  __IO  uint8_t AN19       : 1;
  __IO  uint8_t AN20       : 1;
  __IO  uint8_t AN21       : 1;
  __IO  uint8_t AN22       : 1;
  __IO  uint8_t AN23       : 1;
} stc_adc_scis2_field_t;

typedef struct stc_adc_scis3_field
{
  __IO  uint8_t AN24       : 1;
  __IO  uint8_t AN25       : 1;
  __IO  uint8_t AN26       : 1;
  __IO  uint8_t AN27       : 1;
  __IO  uint8_t AN28       : 1;
  __IO  uint8_t AN29       : 1;
  __IO  uint8_t AN30       : 1;
  __IO  uint8_t AN31       : 1;
} stc_adc_scis3_field_t;

typedef struct stc_adc_scis01_field
{
  __IO uint16_t AN0        : 1;
  __IO uint16_t AN1        : 1;
  __IO uint16_t AN2        : 1;
  __IO uint16_t AN3        : 1;
  __IO uint16_t AN4        : 1;
  __IO uint16_t AN5        : 1;
  __IO uint16_t AN6        : 1;
  __IO uint16_t AN7        : 1;
  __IO uint16_t AN8        : 1;
  __IO uint16_t AN9        : 1;
  __IO uint16_t AN10       : 1;
  __IO uint16_t AN11       : 1;
  __IO uint16_t AN12       : 1;
  __IO uint16_t AN13       : 1;
  __IO uint16_t AN14       : 1;
  __IO uint16_t AN15       : 1;
} stc_adc_scis01_field_t;

typedef struct stc_adc_scis0_field
{
  __IO  uint8_t AN0        : 1;
  __IO  uint8_t AN1        : 1;
  __IO  uint8_t AN2        : 1;
  __IO  uint8_t AN3        : 1;
  __IO  uint8_t AN4        : 1;
  __IO  uint8_t AN5        : 1;
  __IO  uint8_t AN6        : 1;
  __IO  uint8_t AN7        : 1;
} stc_adc_scis0_field_t;

typedef struct stc_adc_scis1_field
{
  __IO  uint8_t AN8        : 1;
  __IO  uint8_t AN9        : 1;
  __IO  uint8_t AN10       : 1;
  __IO  uint8_t AN11       : 1;
  __IO  uint8_t AN12       : 1;
  __IO  uint8_t AN13       : 1;
  __IO  uint8_t AN14       : 1;
  __IO  uint8_t AN15       : 1;
} stc_adc_scis1_field_t;

typedef struct stc_adc_pfns_field
{
  __IO  uint8_t PFS        : 2;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t TEST0      : 1;
  __IO  uint8_t TEST1      : 1;
} stc_adc_pfns_field_t;

typedef struct stc_adc_pccr_field
{
  __IO  uint8_t PSTR       : 1;
  __IO  uint8_t PHEN       : 1;
  __IO  uint8_t PEEN       : 1;
  __IO  uint8_t ESCE       : 1;
  __IO  uint8_t PFCLR      : 1;
  __IO  uint8_t POVR       : 1;
  __IO  uint8_t PFUL       : 1;
  __IO  uint8_t PEMP       : 1;
} stc_adc_pccr_field_t;

typedef struct stc_adc_pcfd_field
{
  __IO uint32_t PC0        : 1;
  __IO uint32_t PC1        : 1;
  __IO uint32_t PC2        : 1;
  __IO uint32_t PC3        : 1;
  __IO uint32_t PC4        : 1;
       uint32_t RESERVED1  : 3;
  __IO uint32_t RS0        : 1;
  __IO uint32_t RS1        : 1;
  __IO uint32_t RS2        : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t INVL       : 1;
       uint32_t RESERVED3  : 7;
  __IO uint32_t PD0        : 1;
  __IO uint32_t PD1        : 1;
  __IO uint32_t PD2        : 1;
  __IO uint32_t PD3        : 1;
  __IO uint32_t PD4        : 1;
  __IO uint32_t PD5        : 1;
  __IO uint32_t PD6        : 1;
  __IO uint32_t PD7        : 1;
  __IO uint32_t PD8        : 1;
  __IO uint32_t PD9        : 1;
  __IO uint32_t PD10       : 1;
  __IO uint32_t PD11       : 1;
} stc_adc_pcfd_field_t;

typedef struct stc_adc_pcfdl_field
{
  __IO uint16_t PC0        : 1;
  __IO uint16_t PC1        : 1;
  __IO uint16_t PC2        : 1;
  __IO uint16_t PC3        : 1;
  __IO uint16_t PC4        : 1;
       uint16_t RESERVED1  : 3;
  __IO uint16_t RS0        : 1;
  __IO uint16_t RS1        : 1;
  __IO uint16_t RS2        : 1;
       uint16_t RESERVED2  : 1;
  __IO uint16_t INVL       : 1;
} stc_adc_pcfdl_field_t;

typedef struct stc_adc_pcfdh_field
{
       uint16_t RESERVED1  : 4;
  __IO uint16_t PD0        : 1;
  __IO uint16_t PD1        : 1;
  __IO uint16_t PD2        : 1;
  __IO uint16_t PD3        : 1;
  __IO uint16_t PD4        : 1;
  __IO uint16_t PD5        : 1;
  __IO uint16_t PD6        : 1;
  __IO uint16_t PD7        : 1;
  __IO uint16_t PD8        : 1;
  __IO uint16_t PD9        : 1;
  __IO uint16_t PD10       : 1;
  __IO uint16_t PD11       : 1;
} stc_adc_pcfdh_field_t;

typedef struct stc_adc_pcis_field
{
  __IO  uint8_t P1A        : 3;
  __IO  uint8_t P2A        : 5;
} stc_adc_pcis_field_t;

typedef struct stc_adc_cmpcr_field
{
  __IO  uint8_t CCH        : 5;
  __IO  uint8_t CMD0       : 1;
  __IO  uint8_t CMD1       : 1;
  __IO  uint8_t CMPEN      : 1;
} stc_adc_cmpcr_field_t;

typedef struct stc_adc_cmpd_field
{
       uint16_t RESERVED1  : 6;
  __IO uint16_t CMAD2      : 1;
  __IO uint16_t CMAD3      : 1;
  __IO uint16_t CMAD4      : 1;
  __IO uint16_t CMAD5      : 1;
  __IO uint16_t CMAD6      : 1;
  __IO uint16_t CMAD7      : 1;
  __IO uint16_t CMAD8      : 1;
  __IO uint16_t CMAD9      : 1;
  __IO uint16_t CMAD10     : 1;
  __IO uint16_t CMAD11     : 1;
} stc_adc_cmpd_field_t;

typedef struct stc_adc_adss23_field
{
  __IO uint16_t TS16       : 1;
  __IO uint16_t TS17       : 1;
  __IO uint16_t TS18       : 1;
  __IO uint16_t TS19       : 1;
  __IO uint16_t TS20       : 1;
  __IO uint16_t TS21       : 1;
  __IO uint16_t TS22       : 1;
  __IO uint16_t TS23       : 1;
  __IO uint16_t TS24       : 1;
  __IO uint16_t TS25       : 1;
  __IO uint16_t TS26       : 1;
  __IO uint16_t TS27       : 1;
  __IO uint16_t TS28       : 1;
  __IO uint16_t TS29       : 1;
  __IO uint16_t TS30       : 1;
  __IO uint16_t TS31       : 1;
} stc_adc_adss23_field_t;

typedef struct stc_adc_adss2_field
{
  __IO  uint8_t TS16       : 1;
  __IO  uint8_t TS17       : 1;
  __IO  uint8_t TS18       : 1;
  __IO  uint8_t TS19       : 1;
  __IO  uint8_t TS20       : 1;
  __IO  uint8_t TS21       : 1;
  __IO  uint8_t TS22       : 1;
  __IO  uint8_t TS23       : 1;
} stc_adc_adss2_field_t;

typedef struct stc_adc_adss3_field
{
  __IO  uint8_t TS24       : 1;
  __IO  uint8_t TS25       : 1;
  __IO  uint8_t TS26       : 1;
  __IO  uint8_t TS27       : 1;
  __IO  uint8_t TS28       : 1;
  __IO  uint8_t TS29       : 1;
  __IO  uint8_t TS30       : 1;
  __IO  uint8_t TS31       : 1;
} stc_adc_adss3_field_t;

typedef struct stc_adc_adss01_field
{
  __IO uint16_t TS0        : 1;
  __IO uint16_t TS1        : 1;
  __IO uint16_t TS2        : 1;
  __IO uint16_t TS3        : 1;
  __IO uint16_t TS4        : 1;
  __IO uint16_t TS5        : 1;
  __IO uint16_t TS6        : 1;
  __IO uint16_t TS7        : 1;
  __IO uint16_t TS8        : 1;
  __IO uint16_t TS9        : 1;
  __IO uint16_t TS10       : 1;
  __IO uint16_t TS11       : 1;
  __IO uint16_t TS12       : 1;
  __IO uint16_t TS13       : 1;
  __IO uint16_t TS14       : 1;
  __IO uint16_t TS15       : 1;
} stc_adc_adss01_field_t;

typedef struct stc_adc_adss0_field
{
  __IO  uint8_t TS0        : 1;
  __IO  uint8_t TS1        : 1;
  __IO  uint8_t TS2        : 1;
  __IO  uint8_t TS3        : 1;
  __IO  uint8_t TS4        : 1;
  __IO  uint8_t TS5        : 1;
  __IO  uint8_t TS6        : 1;
  __IO  uint8_t TS7        : 1;
} stc_adc_adss0_field_t;

typedef struct stc_adc_adss1_field
{
  __IO  uint8_t TS8        : 1;
  __IO  uint8_t TS9        : 1;
  __IO  uint8_t TS10       : 1;
  __IO  uint8_t TS11       : 1;
  __IO  uint8_t TS12       : 1;
  __IO  uint8_t TS13       : 1;
  __IO  uint8_t TS14       : 1;
  __IO  uint8_t TS15       : 1;
} stc_adc_adss1_field_t;

typedef struct stc_adc_adst01_field
{
  __IO uint16_t ST10       : 1;
  __IO uint16_t ST11       : 1;
  __IO uint16_t ST12       : 1;
  __IO uint16_t ST13       : 1;
  __IO uint16_t ST14       : 1;
  __IO uint16_t STX10      : 1;
  __IO uint16_t STX11      : 1;
  __IO uint16_t STX12      : 1;
  __IO uint16_t ST00       : 1;
  __IO uint16_t ST01       : 1;
  __IO uint16_t ST02       : 1;
  __IO uint16_t ST03       : 1;
  __IO uint16_t ST04       : 1;
  __IO uint16_t STX00      : 1;
  __IO uint16_t STX01      : 1;
  __IO uint16_t STX02      : 1;
} stc_adc_adst01_field_t;

typedef struct stc_adc_adst1_field
{
  __IO  uint8_t ST1        : 5;
  __IO  uint8_t STX1       : 3;
} stc_adc_adst1_field_t;

typedef struct stc_adc_adst0_field
{
  __IO  uint8_t ST0        : 5;
  __IO  uint8_t STX0       : 3;
} stc_adc_adst0_field_t;

typedef struct stc_adc_adct_field
{
  __IO  uint8_t CT0        : 1;
  __IO  uint8_t CT1        : 1;
  __IO  uint8_t CT2        : 1;
} stc_adc_adct_field_t;

typedef struct stc_adc_prtsl_field
{
  __IO  uint8_t PRTSL0     : 1;
  __IO  uint8_t PRTSL1     : 1;
  __IO  uint8_t PRTSL2     : 1;
  __IO  uint8_t PRTSL3     : 1;
} stc_adc_prtsl_field_t;

typedef struct stc_adc_sctsl_field
{
  __IO  uint8_t SCTSL0     : 1;
  __IO  uint8_t SCTSL1     : 1;
  __IO  uint8_t SCTSL2     : 1;
  __IO  uint8_t SCTSL3     : 1;
} stc_adc_sctsl_field_t;

typedef struct stc_adc_adcen_field
{
  __IO  uint16_t ENBL       : 1;
  __IO  uint16_t READY      : 1;
  __IO  uint16_t RESERVED   : 6;
  __IO  uint16_t ENBLTIME   : 8;
} stc_adc_adcen_field_t;

typedef struct stc_adc_wcmpdh_field
{
        uint16_t RESERVED   : 6;
  __IO  uint16_t CMHD       : 10;
} stc_adc_wcmpdh_field_t;

typedef struct stc_adc_wcmpcr_field
{
        uint8_t  RESERVED   : 2;
  __IO  uint8_t  RCOE       : 1;
  __IO  uint8_t  RCOIE      : 1;
  __IO  uint8_t  RCOIRRS    : 1;
  __IO  uint8_t  RCOCD      : 3;
} stc_adc_wcmpcr_field_t;

typedef struct stc_adc_wcmpdl_field
{
        uint16_t RESERVED   : 6;
  __IO  uint16_t CMLD       : 10;
} stc_adc_wcmpdl_field_t;

typedef struct stc_adc_wcmpsr_field
{
  __IO  uint8_t  WCCH       : 5;
  __IO  uint8_t  WCMD       : 1;
  __IO  uint8_t  RESERVED   : 2;
} stc_adc_wcmpsr_field_t;

typedef struct stc_adc_wcmrcot_field
{
  __IO  uint32_t RCOOF      : 1;
        uint32_t RESERVED   : 31;
} stc_adc_wcmrcot_field_t;

typedef struct stc_adc_wcmrcif_field
{
  __IO  uint32_t RCINT      : 1;
        uint32_t RESERVED   : 31;
} stc_adc_wcmrcif_field_t;

/******************************************************************************
 * CRTRIM_MODULE
 ******************************************************************************/
/* CRTRIM_MODULE register bit fields */
typedef struct stc_crtrim_mcr_psr_field
{
  __IO  uint8_t CSR        : 3;
} stc_crtrim_mcr_psr_field_t;

typedef struct stc_crtrim_mcr_ftrm_field
{
  __IO uint16_t TRD        :10;
} stc_crtrim_mcr_ftrm_field_t;

typedef struct stc_crtrim_mcr_ttrm_field
{
  __IO  uint8_t TRT        : 5;
} stc_crtrim_mcr_ttrm_field_t;

typedef struct stc_crtrim_mcr_rlr_field
{
  __IO uint32_t TRMLCK     :32;
} stc_crtrim_mcr_rlr_field_t;

/******************************************************************************
 * EXTI_MODULE
 ******************************************************************************/
/* EXTI_MODULE register bit fields */
typedef struct stc_exti_enir_field
{
  __IO uint32_t EN0        : 1;
  __IO uint32_t EN1        : 1;
  __IO uint32_t EN2        : 1;
  __IO uint32_t EN3        : 1;
  __IO uint32_t EN4        : 1;
  __IO uint32_t EN5        : 1;
  __IO uint32_t EN6        : 1;
  __IO uint32_t EN7        : 1;
  __IO uint32_t EN8        : 1;
  __IO uint32_t EN9        : 1;
  __IO uint32_t EN10       : 1;
  __IO uint32_t EN11       : 1;
  __IO uint32_t EN12       : 1;
  __IO uint32_t EN13       : 1;
  __IO uint32_t EN14       : 1;
  __IO uint32_t EN15       : 1;
  __IO uint32_t EN16       : 1;
  __IO uint32_t EN17       : 1;
  __IO uint32_t EN18       : 1;
  __IO uint32_t EN19       : 1;
  __IO uint32_t EN20       : 1;
  __IO uint32_t EN21       : 1;
  __IO uint32_t EN22       : 1;
  __IO uint32_t EN23       : 1;
  __IO uint32_t EN24       : 1;
  __IO uint32_t EN25       : 1;
  __IO uint32_t EN26       : 1;
  __IO uint32_t EN27       : 1;
  __IO uint32_t EN28       : 1;
  __IO uint32_t EN29       : 1;
  __IO uint32_t EN30       : 1;
  __IO uint32_t EN31       : 1;
} stc_exti_enir_field_t;

typedef struct stc_exti_eirr_field
{
  __IO uint32_t ER0        : 1;
  __IO uint32_t ER1        : 1;
  __IO uint32_t ER2        : 1;
  __IO uint32_t ER3        : 1;
  __IO uint32_t ER4        : 1;
  __IO uint32_t ER5        : 1;
  __IO uint32_t ER6        : 1;
  __IO uint32_t ER7        : 1;
  __IO uint32_t ER8        : 1;
  __IO uint32_t ER9        : 1;
  __IO uint32_t ER10       : 1;
  __IO uint32_t ER11       : 1;
  __IO uint32_t ER12       : 1;
  __IO uint32_t ER13       : 1;
  __IO uint32_t ER14       : 1;
  __IO uint32_t ER15       : 1;
  __IO uint32_t ER16       : 1;
  __IO uint32_t ER17       : 1;
  __IO uint32_t ER18       : 1;
  __IO uint32_t ER19       : 1;
  __IO uint32_t ER20       : 1;
  __IO uint32_t ER21       : 1;
  __IO uint32_t ER22       : 1;
  __IO uint32_t ER23       : 1;
  __IO uint32_t ER24       : 1;
  __IO uint32_t ER25       : 1;
  __IO uint32_t ER26       : 1;
  __IO uint32_t ER27       : 1;
  __IO uint32_t ER28       : 1;
  __IO uint32_t ER29       : 1;
  __IO uint32_t ER30       : 1;
  __IO uint32_t ER31       : 1;
} stc_exti_eirr_field_t;

typedef struct stc_exti_eicl_field
{
  __IO uint32_t ECL0       : 1;
  __IO uint32_t ECL1       : 1;
  __IO uint32_t ECL2       : 1;
  __IO uint32_t ECL3       : 1;
  __IO uint32_t ECL4       : 1;
  __IO uint32_t ECL5       : 1;
  __IO uint32_t ECL6       : 1;
  __IO uint32_t ECL7       : 1;
  __IO uint32_t ECL8       : 1;
  __IO uint32_t ECL9       : 1;
  __IO uint32_t ECL10      : 1;
  __IO uint32_t ECL11      : 1;
  __IO uint32_t ECL12      : 1;
  __IO uint32_t ECL13      : 1;
  __IO uint32_t ECL14      : 1;
  __IO uint32_t ECL15      : 1;
  __IO uint32_t ECL16      : 1;
  __IO uint32_t ECL17      : 1;
  __IO uint32_t ECL18      : 1;
  __IO uint32_t ECL19      : 1;
  __IO uint32_t ECL20      : 1;
  __IO uint32_t ECL21      : 1;
  __IO uint32_t ECL22      : 1;
  __IO uint32_t ECL23      : 1;
  __IO uint32_t ECL24      : 1;
  __IO uint32_t ECL25      : 1;
  __IO uint32_t ECL26      : 1;
  __IO uint32_t ECL27      : 1;
  __IO uint32_t ECL28      : 1;
  __IO uint32_t ECL29      : 1;
  __IO uint32_t ECL30      : 1;
  __IO uint32_t ECL31      : 1;
} stc_exti_eicl_field_t;

typedef struct stc_exti_elvr_field
{
  __IO uint32_t LA0        : 1;
  __IO uint32_t LB0        : 1;
  __IO uint32_t LA1        : 1;
  __IO uint32_t LB1        : 1;
  __IO uint32_t LA2        : 1;
  __IO uint32_t LB2        : 1;
  __IO uint32_t LA3        : 1;
  __IO uint32_t LB3        : 1;
  __IO uint32_t LA4        : 1;
  __IO uint32_t LB4        : 1;
  __IO uint32_t LA5        : 1;
  __IO uint32_t LB5        : 1;
  __IO uint32_t LA6        : 1;
  __IO uint32_t LB6        : 1;
  __IO uint32_t LA7        : 1;
  __IO uint32_t LB7        : 1;
  __IO uint32_t LA8        : 1;
  __IO uint32_t LB8        : 1;
  __IO uint32_t LA9        : 1;
  __IO uint32_t LB9        : 1;
  __IO uint32_t LA10       : 1;
  __IO uint32_t LB10       : 1;
  __IO uint32_t LA11       : 1;
  __IO uint32_t LB11       : 1;
  __IO uint32_t LA12       : 1;
  __IO uint32_t LB12       : 1;
  __IO uint32_t LA13       : 1;
  __IO uint32_t LB13       : 1;
  __IO uint32_t LA14       : 1;
  __IO uint32_t LB14       : 1;
  __IO uint32_t LA15       : 1;
  __IO uint32_t LB15       : 1;
} stc_exti_elvr_field_t;

typedef struct stc_exti_elvr1_field
{
  __IO uint32_t LA16       : 1;
  __IO uint32_t LB16       : 1;
  __IO uint32_t LA17       : 1;
  __IO uint32_t LB17       : 1;
  __IO uint32_t LA18       : 1;
  __IO uint32_t LB18       : 1;
  __IO uint32_t LA19       : 1;
  __IO uint32_t LB19       : 1;
  __IO uint32_t LA20       : 1;
  __IO uint32_t LB20       : 1;
  __IO uint32_t LA21       : 1;
  __IO uint32_t LB21       : 1;
  __IO uint32_t LA22       : 1;
  __IO uint32_t LB22       : 1;
  __IO uint32_t LA23       : 1;
  __IO uint32_t LB23       : 1;
  __IO uint32_t LA24       : 1;
  __IO uint32_t LB24       : 1;
  __IO uint32_t LA25       : 1;
  __IO uint32_t LB25       : 1;
  __IO uint32_t LA26       : 1;
  __IO uint32_t LB26       : 1;
  __IO uint32_t LA27       : 1;
  __IO uint32_t LB27       : 1;
  __IO uint32_t LA28       : 1;
  __IO uint32_t LB28       : 1;
  __IO uint32_t LA29       : 1;
  __IO uint32_t LB29       : 1;
  __IO uint32_t LA30       : 1;
  __IO uint32_t LB30       : 1;
  __IO uint32_t LA31       : 1;
  __IO uint32_t LB31       : 1;
} stc_exti_elvr1_field_t;

typedef struct stc_exti_nmirr_field
{
  __IO  uint8_t NR         : 1;
} stc_exti_nmirr_field_t;

typedef struct stc_exti_nmicl_field
{
  __IO  uint8_t NCL        : 1;
} stc_exti_nmicl_field_t;

/******************************************************************************
 * INTREQ_MODULE
 ******************************************************************************/
/* INTREQ_MODULE register bit fields */
typedef struct stc_intreq_drqsel_field
{
  __IO uint32_t USBEP1     : 1;
  __IO uint32_t USBEP2     : 1;
  __IO uint32_t USBEP3     : 1;
  __IO uint32_t USBEP4     : 1;
  __IO uint32_t USBEP5     : 1;
  __IO uint32_t ADCSCAN0   : 1;
  __IO uint32_t ADCSCAN1   : 1;
  __IO uint32_t ADCSCAN2   : 1;
  __IO uint32_t IRQ0BT0    : 1;
  __IO uint32_t IRQ0BT2    : 1;
  __IO uint32_t IRQ0BT4    : 1;
  __IO uint32_t IRQ0BT6    : 1;
  __IO uint32_t MFS0RX     : 1;
  __IO uint32_t MFS0TX     : 1;
  __IO uint32_t MFS1RX     : 1;
  __IO uint32_t MFS1TX     : 1;
  __IO uint32_t MFS2RX     : 1;
  __IO uint32_t MFS2TX     : 1;
  __IO uint32_t MFS3RX     : 1;
  __IO uint32_t MFS3TX     : 1;
  __IO uint32_t MFS4RX     : 1;
  __IO uint32_t MFS4TX     : 1;
  __IO uint32_t MFS5RX     : 1;
  __IO uint32_t MFS5TX     : 1;
  __IO uint32_t MFS6RX     : 1;
  __IO uint32_t MFS6TX     : 1;
  __IO uint32_t MFS7RX     : 1;
  __IO uint32_t MFS7TX     : 1;
  __IO uint32_t EXINT0     : 1;
  __IO uint32_t EXINT1     : 1;
  __IO uint32_t EXINT2     : 1;
  __IO uint32_t EXINT3     : 1;
} stc_intreq_drqsel_field_t;

typedef struct stc_intreq_oddpks_field
{
  __IO  uint8_t ODDPKS0    : 1;
  __IO  uint8_t ODDPKS1    : 1;
  __IO  uint8_t ODDPKS2    : 1;
  __IO  uint8_t ODDPKS3    : 1;
  __IO  uint8_t ODDPKS4    : 1;
} stc_intreq_oddpks_field_t;

typedef struct stc_intreq_oddpks1_field
{
  __IO  uint8_t ODDPKS10   : 1;
  __IO  uint8_t ODDPKS11   : 1;
  __IO  uint8_t ODDPKS12   : 1;
  __IO  uint8_t ODDPKS13   : 1;
  __IO  uint8_t ODDPKS14   : 1;
} stc_intreq_oddpks1_field_t;

typedef struct stc_intreq_irq003sel_field
{
  __IO uint32_t SELIRQ     : 8;
       uint32_t RESERVED1  : 8;
  __IO uint32_t SELBIT     : 8;
} stc_intreq_irq003sel_field_t;

typedef struct stc_intreq_irq004sel_field
{
  __IO uint32_t SELIRQ     : 8;
       uint32_t RESERVED1  : 8;
  __IO uint32_t SELBIT     : 8;
} stc_intreq_irq004sel_field_t;

typedef struct stc_intreq_irq005sel_field
{
  __IO uint32_t SELIRQ     : 8;
       uint32_t RESERVED1  : 8;
  __IO uint32_t SELBIT     : 8;
} stc_intreq_irq005sel_field_t;

typedef struct stc_intreq_irq006sel_field
{
  __IO uint32_t SELIRQ     : 8;
       uint32_t RESERVED1  : 8;
  __IO uint32_t SELBIT     : 8;
} stc_intreq_irq006sel_field_t;

typedef struct stc_intreq_irq007sel_field
{
  __IO uint32_t SELIRQ     : 8;
       uint32_t RESERVED1  : 8;
  __IO uint32_t SELBIT     : 8;
} stc_intreq_irq007sel_field_t;

typedef struct stc_intreq_irq008sel_field
{
  __IO uint32_t SELIRQ     : 8;
       uint32_t RESERVED1  : 8;
  __IO uint32_t SELBIT     : 8;
} stc_intreq_irq008sel_field_t;

typedef struct stc_intreq_irq009sel_field
{
  __IO uint32_t SELIRQ     : 8;
       uint32_t RESERVED1  : 8;
  __IO uint32_t SELBIT     : 8;
} stc_intreq_irq009sel_field_t;

typedef struct stc_intreq_irq010sel_field
{
  __IO uint32_t SELIRQ     : 8;
       uint32_t RESERVED1  : 8;
  __IO uint32_t SELBIT     : 8;
} stc_intreq_irq010sel_field_t;

typedef struct stc_intreq_exc02mon_field
{
  __IO uint32_t NMI        : 1;
  __IO uint32_t HWINT      : 1;
} stc_intreq_exc02mon_field_t;

typedef struct stc_intreq_irq000mon_field
{
  __IO uint32_t FCSINT     : 1;
} stc_intreq_irq000mon_field_t;

typedef struct stc_intreq_irq001mon_field
{
  __IO uint32_t SWWDTINT   : 1;
} stc_intreq_irq001mon_field_t;

typedef struct stc_intreq_irq002mon_field
{
  __IO uint32_t LVDINT     : 1;
} stc_intreq_irq002mon_field_t;

typedef struct stc_intreq_irq003mon_field
{
  __IO uint32_t IRQBIT0    : 1;
  __IO uint32_t IRQBIT1    : 1;
  __IO uint32_t IRQBIT2    : 1;
  __IO uint32_t IRQBIT3    : 1;
  __IO uint32_t IRQBIT4    : 1;
  __IO uint32_t IRQBIT5    : 1;
  __IO uint32_t IRQBIT6    : 1;
  __IO uint32_t IRQBIT7    : 1;
} stc_intreq_irq003mon_field_t;

typedef struct stc_intreq_irq004mon_field
{
  __IO uint32_t IRQBIT0    : 1;
  __IO uint32_t IRQBIT1    : 1;
  __IO uint32_t IRQBIT2    : 1;
  __IO uint32_t IRQBIT3    : 1;
  __IO uint32_t IRQBIT4    : 1;
  __IO uint32_t IRQBIT5    : 1;
  __IO uint32_t IRQBIT6    : 1;
  __IO uint32_t IRQBIT7    : 1;
} stc_intreq_irq004mon_field_t;

typedef struct stc_intreq_irq005mon_field
{
  __IO uint32_t IRQBIT0    : 1;
  __IO uint32_t IRQBIT1    : 1;
  __IO uint32_t IRQBIT2    : 1;
  __IO uint32_t IRQBIT3    : 1;
  __IO uint32_t IRQBIT4    : 1;
  __IO uint32_t IRQBIT5    : 1;
  __IO uint32_t IRQBIT6    : 1;
  __IO uint32_t IRQBIT7    : 1;
} stc_intreq_irq005mon_field_t;

typedef struct stc_intreq_irq006mon_field
{
  __IO uint32_t IRQBIT0    : 1;
  __IO uint32_t IRQBIT1    : 1;
  __IO uint32_t IRQBIT2    : 1;
  __IO uint32_t IRQBIT3    : 1;
  __IO uint32_t IRQBIT4    : 1;
  __IO uint32_t IRQBIT5    : 1;
  __IO uint32_t IRQBIT6    : 1;
  __IO uint32_t IRQBIT7    : 1;
} stc_intreq_irq006mon_field_t;

typedef struct stc_intreq_irq007mon_field
{
  __IO uint32_t IRQBIT0    : 1;
  __IO uint32_t IRQBIT1    : 1;
  __IO uint32_t IRQBIT2    : 1;
  __IO uint32_t IRQBIT3    : 1;
  __IO uint32_t IRQBIT4    : 1;
  __IO uint32_t IRQBIT5    : 1;
  __IO uint32_t IRQBIT6    : 1;
  __IO uint32_t IRQBIT7    : 1;
} stc_intreq_irq007mon_field_t;

typedef struct stc_intreq_irq008mon_field
{
  __IO uint32_t IRQBIT0    : 1;
  __IO uint32_t IRQBIT1    : 1;
  __IO uint32_t IRQBIT2    : 1;
  __IO uint32_t IRQBIT3    : 1;
  __IO uint32_t IRQBIT4    : 1;
  __IO uint32_t IRQBIT5    : 1;
  __IO uint32_t IRQBIT6    : 1;
  __IO uint32_t IRQBIT7    : 1;
} stc_intreq_irq008mon_field_t;

typedef struct stc_intreq_irq009mon_field
{
  __IO uint32_t IRQBIT0    : 1;
  __IO uint32_t IRQBIT1    : 1;
  __IO uint32_t IRQBIT2    : 1;
  __IO uint32_t IRQBIT3    : 1;
  __IO uint32_t IRQBIT4    : 1;
  __IO uint32_t IRQBIT5    : 1;
  __IO uint32_t IRQBIT6    : 1;
  __IO uint32_t IRQBIT7    : 1;
} stc_intreq_irq009mon_field_t;

typedef struct stc_intreq_irq010mon_field
{
  __IO uint32_t IRQBIT0    : 1;
  __IO uint32_t IRQBIT1    : 1;
  __IO uint32_t IRQBIT2    : 1;
  __IO uint32_t IRQBIT3    : 1;
  __IO uint32_t IRQBIT4    : 1;
  __IO uint32_t IRQBIT5    : 1;
  __IO uint32_t IRQBIT6    : 1;
  __IO uint32_t IRQBIT7    : 1;
} stc_intreq_irq010mon_field_t;

typedef struct stc_intreq_irq011mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq011mon_field_t;

typedef struct stc_intreq_irq012mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq012mon_field_t;

typedef struct stc_intreq_irq013mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq013mon_field_t;

typedef struct stc_intreq_irq014mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq014mon_field_t;

typedef struct stc_intreq_irq015mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq015mon_field_t;

typedef struct stc_intreq_irq016mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq016mon_field_t;

typedef struct stc_intreq_irq017mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq017mon_field_t;

typedef struct stc_intreq_irq018mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq018mon_field_t;

typedef struct stc_intreq_irq019mon_field
{
  __IO uint32_t QUDINT0    : 1;
  __IO uint32_t QUDINT1    : 1;
  __IO uint32_t QUDINT2    : 1;
  __IO uint32_t QUDINT3    : 1;
  __IO uint32_t QUDINT4    : 1;
  __IO uint32_t QUDINT5    : 1;
} stc_intreq_irq019mon_field_t;

typedef struct stc_intreq_irq020mon_field
{
  __IO uint32_t QUDINT0    : 1;
  __IO uint32_t QUDINT1    : 1;
  __IO uint32_t QUDINT2    : 1;
  __IO uint32_t QUDINT3    : 1;
  __IO uint32_t QUDINT4    : 1;
  __IO uint32_t QUDINT5    : 1;
} stc_intreq_irq020mon_field_t;

typedef struct stc_intreq_irq021mon_field
{
  __IO uint32_t WAVEINT0   : 1;
  __IO uint32_t WAVEINT1   : 1;
  __IO uint32_t WAVEINT2   : 1;
  __IO uint32_t WAVEINT3   : 1;
} stc_intreq_irq021mon_field_t;

typedef struct stc_intreq_irq022mon_field
{
  __IO uint32_t WAVEINT0   : 1;
  __IO uint32_t WAVEINT1   : 1;
  __IO uint32_t WAVEINT2   : 1;
  __IO uint32_t WAVEINT3   : 1;
} stc_intreq_irq022mon_field_t;

typedef struct stc_intreq_irq023mon_field
{
  __IO uint32_t WAVEINT0   : 1;
  __IO uint32_t WAVEINT1   : 1;
  __IO uint32_t WAVEINT2   : 1;
  __IO uint32_t WAVEINT3   : 1;
} stc_intreq_irq023mon_field_t;

typedef struct stc_intreq_irq024mon_field
{
  __IO uint32_t FRT_PEAK_INT0: 1;
  __IO uint32_t FRT_PEAK_INT1: 1;
  __IO uint32_t FRT_PEAK_INT2: 1;
} stc_intreq_irq024mon_field_t;

typedef struct stc_intreq_irq025mon_field
{
  __IO uint32_t FRT_ZERO_INT0: 1;
  __IO uint32_t FRT_ZERO_INT1: 1;
  __IO uint32_t FRT_ZERO_INT2: 1;
} stc_intreq_irq025mon_field_t;

typedef struct stc_intreq_irq026mon_field
{
  __IO uint32_t ICUINT0    : 1;
  __IO uint32_t ICUINT1    : 1;
  __IO uint32_t ICUINT2    : 1;
  __IO uint32_t ICUINT3    : 1;
} stc_intreq_irq026mon_field_t;

typedef struct stc_intreq_irq027mon_field
{
  __IO uint32_t OCUINT0    : 1;
  __IO uint32_t OCUINT1    : 1;
  __IO uint32_t OCUINT2    : 1;
  __IO uint32_t OCUINT3    : 1;
  __IO uint32_t OCUINT4    : 1;
  __IO uint32_t OCUINT5    : 1;
} stc_intreq_irq027mon_field_t;

typedef struct stc_intreq_irq028mon_field
{
  __IO uint32_t FRT_PEAK_INT0: 1;
  __IO uint32_t FRT_PEAK_INT1: 1;
  __IO uint32_t FRT_PEAK_INT2: 1;
} stc_intreq_irq028mon_field_t;

typedef struct stc_intreq_irq029mon_field
{
  __IO uint32_t FRT_ZERO_INT0: 1;
  __IO uint32_t FRT_ZERO_INT1: 1;
  __IO uint32_t FRT_ZERO_INT2: 1;
} stc_intreq_irq029mon_field_t;

typedef struct stc_intreq_irq030mon_field
{
  __IO uint32_t ICUINT0    : 1;
  __IO uint32_t ICUINT1    : 1;
  __IO uint32_t ICUINT2    : 1;
  __IO uint32_t ICUINT3    : 1;
} stc_intreq_irq030mon_field_t;

typedef struct stc_intreq_irq031mon_field
{
  __IO uint32_t OCUINT0    : 1;
  __IO uint32_t OCUINT1    : 1;
  __IO uint32_t OCUINT2    : 1;
  __IO uint32_t OCUINT3    : 1;
  __IO uint32_t OCUINT4    : 1;
  __IO uint32_t OCUINT5    : 1;
} stc_intreq_irq031mon_field_t;

typedef struct stc_intreq_irq032mon_field
{
  __IO uint32_t FRT_PEAK_INT0: 1;
  __IO uint32_t FRT_PEAK_INT1: 1;
  __IO uint32_t FRT_PEAK_INT2: 1;
} stc_intreq_irq032mon_field_t;

typedef struct stc_intreq_irq033mon_field
{
  __IO uint32_t FRT_ZERO_INT0: 1;
  __IO uint32_t FRT_ZERO_INT1: 1;
  __IO uint32_t FRT_ZERO_INT2: 1;
} stc_intreq_irq033mon_field_t;

typedef struct stc_intreq_irq034mon_field
{
  __IO uint32_t ICUINT0    : 1;
  __IO uint32_t ICUINT1    : 1;
  __IO uint32_t ICUINT2    : 1;
  __IO uint32_t ICUINT3    : 1;
} stc_intreq_irq034mon_field_t;

typedef struct stc_intreq_irq035mon_field
{
  __IO uint32_t OCUINT0    : 1;
  __IO uint32_t OCUINT1    : 1;
  __IO uint32_t OCUINT2    : 1;
  __IO uint32_t OCUINT3    : 1;
  __IO uint32_t OCUINT4    : 1;
  __IO uint32_t OCUINT5    : 1;
} stc_intreq_irq035mon_field_t;

typedef struct stc_intreq_irq036mon_field
{
  __IO uint32_t PPGINT0    : 1;
  __IO uint32_t PPGINT1    : 1;
  __IO uint32_t PPGINT2    : 1;
} stc_intreq_irq036mon_field_t;

typedef struct stc_intreq_irq037mon_field
{
  __IO uint32_t PPGINT0    : 1;
  __IO uint32_t PPGINT1    : 1;
  __IO uint32_t PPGINT2    : 1;
} stc_intreq_irq037mon_field_t;

typedef struct stc_intreq_irq038mon_field
{
  __IO uint32_t PPGINT0    : 1;
  __IO uint32_t PPGINT1    : 1;
  __IO uint32_t PPGINT2    : 1;
} stc_intreq_irq038mon_field_t;

typedef struct stc_intreq_irq039mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq039mon_field_t;

typedef struct stc_intreq_irq040mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq040mon_field_t;

typedef struct stc_intreq_irq041mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq041mon_field_t;

typedef struct stc_intreq_irq042mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq042mon_field_t;

typedef struct stc_intreq_irq043mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq043mon_field_t;

typedef struct stc_intreq_irq044mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq044mon_field_t;

typedef struct stc_intreq_irq045mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq045mon_field_t;

typedef struct stc_intreq_irq046mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq046mon_field_t;

typedef struct stc_intreq_irq047mon_field
{
  __IO uint32_t TIMINT1    : 1;
  __IO uint32_t TIMINT2    : 1;
} stc_intreq_irq047mon_field_t;

typedef struct stc_intreq_irq048mon_field
{
  __IO uint32_t WCINT      : 1;
} stc_intreq_irq048mon_field_t;

typedef struct stc_intreq_irq049mon_field
{
  __IO uint32_t BMEMCS     : 1;
} stc_intreq_irq049mon_field_t;

typedef struct stc_intreq_irq050mon_field
{
  __IO uint32_t RTCINT     : 1;
} stc_intreq_irq050mon_field_t;

typedef struct stc_intreq_irq051mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq051mon_field_t;

typedef struct stc_intreq_irq052mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq052mon_field_t;

typedef struct stc_intreq_irq053mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq053mon_field_t;

typedef struct stc_intreq_irq054mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq054mon_field_t;

typedef struct stc_intreq_irq055mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq055mon_field_t;

typedef struct stc_intreq_irq056mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq056mon_field_t;

typedef struct stc_intreq_irq057mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq057mon_field_t;

typedef struct stc_intreq_irq058mon_field
{
  __IO uint32_t EXTINT     : 1;
} stc_intreq_irq058mon_field_t;

typedef struct stc_intreq_irq059mon_field
{
  __IO uint32_t MOSCINT    : 1;
  __IO uint32_t SOSCINT    : 1;
  __IO uint32_t MPLLINT    : 1;
  __IO uint32_t UPLLINT    : 1;
  __IO uint32_t IPLLINT    : 1;
} stc_intreq_irq059mon_field_t;

typedef struct stc_intreq_irq060mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq060mon_field_t;

typedef struct stc_intreq_irq061mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq061mon_field_t;

typedef struct stc_intreq_irq062mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq062mon_field_t;

typedef struct stc_intreq_irq063mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq063mon_field_t;

typedef struct stc_intreq_irq064mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq064mon_field_t;

typedef struct stc_intreq_irq065mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq065mon_field_t;

typedef struct stc_intreq_irq066mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq066mon_field_t;

typedef struct stc_intreq_irq067mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq067mon_field_t;

typedef struct stc_intreq_irq068mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq068mon_field_t;

typedef struct stc_intreq_irq069mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq069mon_field_t;

typedef struct stc_intreq_irq070mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq070mon_field_t;

typedef struct stc_intreq_irq071mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq071mon_field_t;

typedef struct stc_intreq_irq072mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq072mon_field_t;

typedef struct stc_intreq_irq073mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq073mon_field_t;

typedef struct stc_intreq_irq074mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq074mon_field_t;

typedef struct stc_intreq_irq075mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq075mon_field_t;

typedef struct stc_intreq_irq076mon_field
{
  __IO uint32_t ADCINT0    : 1;
  __IO uint32_t ADCINT1    : 1;
  __IO uint32_t ADCINT2    : 1;
  __IO uint32_t ADCINT3    : 1;
  __IO uint32_t ADCINT4    : 1;
} stc_intreq_irq076mon_field_t;

typedef struct stc_intreq_irq077mon_field
{
  __IO uint32_t ADCINT0    : 1;
  __IO uint32_t ADCINT1    : 1;
  __IO uint32_t ADCINT2    : 1;
  __IO uint32_t ADCINT3    : 1;
  __IO uint32_t ADCINT4    : 1;
} stc_intreq_irq077mon_field_t;

typedef struct stc_intreq_irq078mon_field
{
  __IO uint32_t USB_DRQ_INT0: 1;
  __IO uint32_t USB_DRQ_INT1: 1;
  __IO uint32_t USB_DRQ_INT2: 1;
  __IO uint32_t USB_DRQ_INT3: 1;
  __IO uint32_t USB_DRQ_INT4: 1;
} stc_intreq_irq078mon_field_t;

typedef struct stc_intreq_irq079mon_field
{
  __IO uint32_t USB_INT0   : 1;
  __IO uint32_t USB_INT1   : 1;
  __IO uint32_t USB_INT2   : 1;
  __IO uint32_t USB_INT3   : 1;
  __IO uint32_t USB_INT4   : 1;
  __IO uint32_t USB_INT5   : 1;
} stc_intreq_irq079mon_field_t;

typedef struct stc_intreq_irq080mon_field
{
  __IO uint32_t CANINT     : 1;
} stc_intreq_irq080mon_field_t;

typedef struct stc_intreq_irq081mon_field
{
  __IO uint32_t CANINT     : 1;
  __IO uint32_t CANDEINT   : 1;
  __IO uint32_t CANSEINT   : 1;
  __IO uint32_t CAN0INT    : 1;
  __IO uint32_t CAN1INT    : 1;
} stc_intreq_irq081mon_field_t;

typedef struct stc_intreq_irq082mon_field
{
  __IO uint32_t MACSBD     : 1;
  __IO uint32_t MACPMT     : 1;
  __IO uint32_t MACLPI     : 1;
} stc_intreq_irq082mon_field_t;

typedef struct stc_intreq_irq083mon_field
{
  __IO uint32_t DMACINT    : 1;
} stc_intreq_irq083mon_field_t;

typedef struct stc_intreq_irq084mon_field
{
  __IO uint32_t DMACINT    : 1;
} stc_intreq_irq084mon_field_t;

typedef struct stc_intreq_irq085mon_field
{
  __IO uint32_t DMACINT    : 1;
} stc_intreq_irq085mon_field_t;

typedef struct stc_intreq_irq086mon_field
{
  __IO uint32_t DMACINT    : 1;
} stc_intreq_irq086mon_field_t;

typedef struct stc_intreq_irq087mon_field
{
  __IO uint32_t DMACINT    : 1;
} stc_intreq_irq087mon_field_t;

typedef struct stc_intreq_irq088mon_field
{
  __IO uint32_t DMACINT    : 1;
} stc_intreq_irq088mon_field_t;

typedef struct stc_intreq_irq089mon_field
{
  __IO uint32_t DMACINT    : 1;
} stc_intreq_irq089mon_field_t;

typedef struct stc_intreq_irq090mon_field
{
  __IO uint32_t DMACINT    : 1;
} stc_intreq_irq090mon_field_t;

typedef struct stc_intreq_irq091mon_field
{
  __IO uint32_t DSTCINT0   : 1;
  __IO uint32_t DSTCINT1   : 1;
} stc_intreq_irq091mon_field_t;

typedef struct stc_intreq_irq092mon_field
{
  __IO uint32_t EXTINT0    : 1;
  __IO uint32_t EXTINT1    : 1;
  __IO uint32_t EXTINT2    : 1;
  __IO uint32_t EXTINT3    : 1;
} stc_intreq_irq092mon_field_t;

typedef struct stc_intreq_irq093mon_field
{
  __IO uint32_t EXTINT0    : 1;
  __IO uint32_t EXTINT1    : 1;
  __IO uint32_t EXTINT2    : 1;
  __IO uint32_t EXTINT3    : 1;
} stc_intreq_irq093mon_field_t;

typedef struct stc_intreq_irq094mon_field
{
  __IO uint32_t EXTINT0    : 1;
  __IO uint32_t EXTINT1    : 1;
  __IO uint32_t EXTINT2    : 1;
  __IO uint32_t EXTINT3    : 1;
} stc_intreq_irq094mon_field_t;

typedef struct stc_intreq_irq095mon_field
{
  __IO uint32_t EXTINT0    : 1;
  __IO uint32_t EXTINT1    : 1;
  __IO uint32_t EXTINT2    : 1;
  __IO uint32_t EXTINT3    : 1;
} stc_intreq_irq095mon_field_t;

typedef struct stc_intreq_irq096mon_field
{
  __IO uint32_t QUDINT0    : 1;
  __IO uint32_t QUDINT1    : 1;
  __IO uint32_t QUDINT2    : 1;
  __IO uint32_t QUDINT3    : 1;
  __IO uint32_t QUDINT4    : 1;
  __IO uint32_t QUDINT5    : 1;
} stc_intreq_irq096mon_field_t;

typedef struct stc_intreq_irq097mon_field
{
  __IO uint32_t QUDINT0    : 1;
  __IO uint32_t QUDINT1    : 1;
  __IO uint32_t QUDINT2    : 1;
  __IO uint32_t QUDINT3    : 1;
  __IO uint32_t QUDINT4    : 1;
  __IO uint32_t QUDINT5    : 1;
} stc_intreq_irq097mon_field_t;

typedef struct stc_intreq_irq098mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq098mon_field_t;

typedef struct stc_intreq_irq099mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq099mon_field_t;

typedef struct stc_intreq_irq100mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq100mon_field_t;

typedef struct stc_intreq_irq101mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
} stc_intreq_irq101mon_field_t;

typedef struct stc_intreq_irq102mon_field
{
  __IO uint32_t BTINT0     : 1;
  __IO uint32_t BTINT1     : 1;
  __IO uint32_t BTINT2     : 1;
  __IO uint32_t BTINT3     : 1;
  __IO uint32_t BTINT4     : 1;
  __IO uint32_t BTINT5     : 1;
  __IO uint32_t BTINT6     : 1;
  __IO uint32_t BTINT7     : 1;
} stc_intreq_irq102mon_field_t;

typedef struct stc_intreq_irq103mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq103mon_field_t;

typedef struct stc_intreq_irq104mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq104mon_field_t;

typedef struct stc_intreq_irq105mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq105mon_field_t;

typedef struct stc_intreq_irq106mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq106mon_field_t;

typedef struct stc_intreq_irq107mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq107mon_field_t;

typedef struct stc_intreq_irq108mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq108mon_field_t;

typedef struct stc_intreq_irq109mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq109mon_field_t;

typedef struct stc_intreq_irq110mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq110mon_field_t;

typedef struct stc_intreq_irq111mon_field
{
  __IO uint32_t ADCINT0    : 1;
  __IO uint32_t ADCINT1    : 1;
  __IO uint32_t ADCINT2    : 1;
  __IO uint32_t ADCINT3    : 1;
  __IO uint32_t ADCINT4    : 1;
} stc_intreq_irq111mon_field_t;

typedef struct stc_intreq_irq112mon_field
{
  __IO uint32_t I2SDINT0   : 1;
  __IO uint32_t I2SDINT1   : 1;
  __IO uint32_t QSPIDINT0  : 1;
  __IO uint32_t QSPIDINT1  : 1;
  __IO uint32_t PCRCDINT   : 1;
  __IO uint32_t CANDINT    : 1;
} stc_intreq_irq112mon_field_t;

typedef struct stc_intreq_irq113mon_field
{
  __IO uint32_t USB_DRQ_INT0: 1;
  __IO uint32_t USB_DRQ_INT1: 1;
  __IO uint32_t USB_DRQ_INT2: 1;
  __IO uint32_t USB_DRQ_INT3: 1;
  __IO uint32_t USB_DRQ_INT4: 1;
  __IO uint32_t RCEC0INT   : 1;
} stc_intreq_irq113mon_field_t;

typedef struct stc_intreq_irq114mon_field
{
  __IO uint32_t USB_INT0   : 1;
  __IO uint32_t USB_INT1   : 1;
  __IO uint32_t USB_INT2   : 1;
  __IO uint32_t USB_INT3   : 1;
  __IO uint32_t USB_INT4   : 1;
  __IO uint32_t USB_INT5   : 1;
  __IO uint32_t RCEC1INT   : 1;
} stc_intreq_irq114mon_field_t;

typedef struct stc_intreq_irq115mon_field
{
  __IO uint32_t QSPIINT0   : 1;
  __IO uint32_t QSPIINT1   : 1;
  __IO uint32_t QSPIINT2   : 1;
} stc_intreq_irq115mon_field_t;

typedef struct stc_intreq_irq117mon_field
{
  __IO uint32_t I2SINT     : 1;
  __IO uint32_t PRGCRC     : 1;
} stc_intreq_irq117mon_field_t;

typedef struct stc_intreq_irq118mon_field
{
  __IO uint32_t SDINT0     : 1;
  __IO uint32_t SDINT1     : 1;
} stc_intreq_irq118mon_field_t;

typedef struct stc_intreq_irq119mon_field
{
  __IO uint32_t FLINT      : 1;
} stc_intreq_irq119mon_field_t;

typedef struct stc_intreq_irq120mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq120mon_field_t;

typedef struct stc_intreq_irq121mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq121mon_field_t;

typedef struct stc_intreq_irq122mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq122mon_field_t;

typedef struct stc_intreq_irq123mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq123mon_field_t;

typedef struct stc_intreq_irq124mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq124mon_field_t;

typedef struct stc_intreq_irq125mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq125mon_field_t;

typedef struct stc_intreq_irq126mon_field
{
  __IO uint32_t MFSRINT    : 1;
} stc_intreq_irq126mon_field_t;

typedef struct stc_intreq_irq127mon_field
{
  __IO uint32_t MFSINT0    : 1;
  __IO uint32_t MFSINT1    : 1;
} stc_intreq_irq127mon_field_t;

/******************************************************************************
 * IRQSEL_MODULE
******************************************************************************/
typedef struct stc_irqsel_field
{
  __IO uint32_t SELIRQ    : 8;
       uint32_t RESERVED0 : 8;
  __IO uint32_t SELBIT    : 8;
       uint32_t RESERVED1 : 8;
} stc_irqsel_field_t;

/******************************************************************************
 * HDMI-CEC_MODULE
 ******************************************************************************/
/* HDMI-CEC MODULE registers bit fields */
typedef struct stc_hdmicec_txctrl_field
{
  __IO  uint8_t TXEN       : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t START      : 1;
  __IO  uint8_t EOM        : 1;
  __IO  uint8_t ITSTEN     : 1;
  __IO  uint8_t IBREN      : 1;
} stc_hdmicec_txctrl_field_t;

typedef struct stc_hdmicec_txdata_field
{
  union {
    struct {
      __IO  uint8_t TXDATA     : 8;
    };
    struct {
      __IO  uint8_t TXDATA0    : 1;
      __IO  uint8_t TXDATA1    : 1;
      __IO  uint8_t TXDATA2    : 1;
      __IO  uint8_t TXDATA3    : 1;
      __IO  uint8_t TXDATA4    : 1;
      __IO  uint8_t TXDATA5    : 1;
      __IO  uint8_t TXDATA6    : 1;
      __IO  uint8_t TXDATA7    : 1;
    };
  };
} stc_hdmicec_txdata_field_t;

typedef struct stc_hdmicec_txsts_field
{
  __IO  uint8_t ACKSV      : 1;
        uint8_t RESERVED1  : 3;
  __IO  uint8_t ITST       : 1;
  __IO  uint8_t IBR        : 1;
} stc_hdmicec_txsts_field_t;

typedef struct stc_hdmicec_sfree_field
{
  union {
    struct {
      __IO  uint8_t SFREE      : 4;
            uint8_t RESERVED1  : 4;
    };
    struct {
      __IO  uint8_t SFREE0     : 1;
      __IO  uint8_t SFREE1     : 1;
      __IO  uint8_t SFREE2     : 1;
      __IO  uint8_t SFREE3     : 1;
            uint8_t RESERVED2  : 4;
    };
  };
} stc_hdmicec_sfree_field_t;

typedef struct stc_hdmicec_rcst_field
{
  __IO  uint8_t OVF        : 1;
  __IO  uint8_t EOM        : 1;
  __IO  uint8_t ACK        : 1;
  __IO  uint8_t ST         : 1;
  __IO  uint8_t OVFSEL     : 1;
  __IO  uint8_t OVFIE      : 1;
  __IO  uint8_t ACKIE      : 1;
  __IO  uint8_t STIE       : 1;
} stc_hdmicec_rcst_field_t;

typedef struct stc_hdmicec_rccr_field
{
  __IO  uint8_t EN         : 1;
  __IO  uint8_t MOD        : 2;
  __IO  uint8_t ADRCE      : 1;
        uint8_t RESERVED2  : 3;
  __IO  uint8_t THSEL      : 1;
} stc_hdmicec_rccr_field_t;

typedef struct stc_hdmicec_rcckd_field
{
  union {
    struct {
      __IO uint16_t CKDIV      : 12;
      __IO uint16_t CKSEL      : 1;
           uint16_t RESERVED1  : 3;
    };
    struct {
      __IO uint16_t CKDIV0     : 1;
      __IO uint16_t CKDIV1     : 1;
      __IO uint16_t CKDIV2     : 1;
      __IO uint16_t CKDIV3     : 1;
      __IO uint16_t CKDIV4     : 1;
      __IO uint16_t CKDIV5     : 1;
      __IO uint16_t CKDIV6     : 1;
      __IO uint16_t CKDIV7     : 1;
      __IO uint16_t CKDIV8     : 1;
      __IO uint16_t CKDIV9     : 1;
      __IO uint16_t CKDIV10    : 1;
      __IO uint16_t CKDIV11    : 1;
           uint16_t RESERVED2  : 4;
    };
  };
} stc_hdmicec_rcckd_field_t;

typedef struct stc_hdmicec_rcrc_field
{
  __IO  uint8_t RC         : 1;
        uint8_t RESERVED1  : 3;
  __IO  uint8_t RCIE       : 1;
} stc_hdmicec_rcrc_field_t;

typedef struct stc_hdmicec_rcle_field
{
  __IO  uint8_t LES        : 1;
  __IO  uint8_t LEL        : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t EPE        : 1;
  __IO  uint8_t LESE       : 1;
  __IO  uint8_t LELE       : 1;
  __IO  uint8_t LESIE      : 1;
  __IO  uint8_t LELIE      : 1;
} stc_hdmicec_rcle_field_t;

/******************************************************************************
 * DSTC_MODULE
 ******************************************************************************/
/* DSTC_MODULE register bit fields */
typedef struct stc_dstc_hwdesp_field
{
  __IO uint32_t CHANNEL    : 8;
       uint32_t RESERVED1  : 8;
  __IO uint32_t HWDESP     : 14;
       uint32_t RESERVED2  : 2;
} stc_dstc_hwdesp_field_t;

typedef struct stc_dstc_cfg_field
{
  __IO uint8_t  SWINTE     : 1;
  __IO uint8_t  ERINTE     : 1;
  __IO uint8_t  RBDIS      : 1;
  __IO uint8_t  ESTE       : 1;
  __IO uint8_t  SWPR       : 3;
       uint8_t  RESERVED   : 1;
} stc_dstc_cfg_field_t;

typedef struct stc_dstc_swtr_field
{
  __IO uint16_t SWDESP     : 14;
  __IO uint16_t SWREQ      : 1;
  __IO uint16_t SWST       : 1;
} stc_dstc_swtr_field_t;

typedef struct stc_dstc_moners_field
{
  __IO uint32_t EST        : 3;
  __IO uint32_t DER        : 1;
  __IO uint32_t ESTOP      : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t EHS        : 1;
  __IO uint32_t RESERVED2  : 1;
  __IO uint32_t ECH        : 8;
  __IO uint32_t EDESP      : 14;
       uint32_t RESERVED3  : 2;
} stc_dstc_moners_field_t;

/******************************************************************************
 * GPIO_MODULE
 ******************************************************************************/
/* GPIO_MODULE register bit fields */
typedef struct stc_gpio_pfr0_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
       uint32_t RESERVED1  : 3;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
} stc_gpio_pfr0_field_t;

typedef struct stc_gpio_pfr1_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pfr1_field_t;

typedef struct stc_gpio_pfr2_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
} stc_gpio_pfr2_field_t;

typedef struct stc_gpio_pfr3_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pfr3_field_t;

typedef struct stc_gpio_pfr4_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pfr4_field_t;

typedef struct stc_gpio_pfr5_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pfr5_field_t;

typedef struct stc_gpio_pfr6_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pfr6_field_t;

typedef struct stc_gpio_pfr7_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pfr7_field_t;

typedef struct stc_gpio_pfr8_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pfr8_field_t;

typedef struct stc_gpio_pfr9_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
} stc_gpio_pfr9_field_t;

typedef struct stc_gpio_pfra_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pfra_field_t;

typedef struct stc_gpio_pfrb_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pfrb_field_t;

typedef struct stc_gpio_pfrc_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pfrc_field_t;

typedef struct stc_gpio_pfrd_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
} stc_gpio_pfrd_field_t;

typedef struct stc_gpio_pfre_field
{
  __IO uint32_t P0         : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pfre_field_t;

typedef struct stc_gpio_pfrf_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
} stc_gpio_pfrf_field_t;

typedef struct stc_gpio_pcr0_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
       uint32_t RESERVED1  : 3;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
} stc_gpio_pcr0_field_t;

typedef struct stc_gpio_pcr1_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pcr1_field_t;

typedef struct stc_gpio_pcr2_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
} stc_gpio_pcr2_field_t;

typedef struct stc_gpio_pcr3_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pcr3_field_t;

typedef struct stc_gpio_pcr4_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pcr4_field_t;

typedef struct stc_gpio_pcr5_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pcr5_field_t;

typedef struct stc_gpio_pcr6_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pcr6_field_t;

typedef struct stc_gpio_pcr7_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pcr7_field_t;

typedef struct stc_gpio_pcr8_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pcr8_field_t;

typedef struct stc_gpio_pcr9_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
} stc_gpio_pcr9_field_t;

typedef struct stc_gpio_pcra_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pcra_field_t;

typedef struct stc_gpio_pcrb_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pcrb_field_t;

typedef struct stc_gpio_pcrc_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pcrc_field_t;

typedef struct stc_gpio_pcrd_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
} stc_gpio_pcrd_field_t;

typedef struct stc_gpio_pcre_field
{
  __IO uint32_t P0         : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pcre_field_t;

typedef struct stc_gpio_pcrf_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
} stc_gpio_pcrf_field_t;

typedef struct stc_gpio_ddr0_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_ddr0_field_t;

typedef struct stc_gpio_ddr1_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_ddr1_field_t;

typedef struct stc_gpio_ddr2_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
} stc_gpio_ddr2_field_t;

typedef struct stc_gpio_ddr3_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_ddr3_field_t;

typedef struct stc_gpio_ddr4_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_ddr4_field_t;

typedef struct stc_gpio_ddr5_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_ddr5_field_t;

typedef struct stc_gpio_ddr6_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_ddr6_field_t;

typedef struct stc_gpio_ddr7_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_ddr7_field_t;

typedef struct stc_gpio_ddr8_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_ddr8_field_t;

typedef struct stc_gpio_ddr9_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
} stc_gpio_ddr9_field_t;

typedef struct stc_gpio_ddra_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_ddra_field_t;

typedef struct stc_gpio_ddrb_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_ddrb_field_t;

typedef struct stc_gpio_ddrc_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_ddrc_field_t;

typedef struct stc_gpio_ddrd_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
} stc_gpio_ddrd_field_t;

typedef struct stc_gpio_ddre_field
{
  __IO uint32_t P0         : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_ddre_field_t;

typedef struct stc_gpio_ddrf_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
} stc_gpio_ddrf_field_t;

typedef struct stc_gpio_pdir0_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdir0_field_t;

typedef struct stc_gpio_pdir1_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdir1_field_t;

typedef struct stc_gpio_pdir2_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
} stc_gpio_pdir2_field_t;

typedef struct stc_gpio_pdir3_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdir3_field_t;

typedef struct stc_gpio_pdir4_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdir4_field_t;

typedef struct stc_gpio_pdir5_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdir5_field_t;

typedef struct stc_gpio_pdir6_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdir6_field_t;

typedef struct stc_gpio_pdir7_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdir7_field_t;

typedef struct stc_gpio_pdir8_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pdir8_field_t;

typedef struct stc_gpio_pdir9_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
} stc_gpio_pdir9_field_t;

typedef struct stc_gpio_pdira_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdira_field_t;

typedef struct stc_gpio_pdirb_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdirb_field_t;

typedef struct stc_gpio_pdirc_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdirc_field_t;

typedef struct stc_gpio_pdird_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
} stc_gpio_pdird_field_t;

typedef struct stc_gpio_pdire_field
{
  __IO uint32_t P0         : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pdire_field_t;

typedef struct stc_gpio_pdirf_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
} stc_gpio_pdirf_field_t;

typedef struct stc_gpio_pdor0_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdor0_field_t;

typedef struct stc_gpio_pdor1_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdor1_field_t;

typedef struct stc_gpio_pdor2_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
} stc_gpio_pdor2_field_t;

typedef struct stc_gpio_pdor3_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdor3_field_t;

typedef struct stc_gpio_pdor4_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdor4_field_t;

typedef struct stc_gpio_pdor5_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdor5_field_t;

typedef struct stc_gpio_pdor6_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdor6_field_t;

typedef struct stc_gpio_pdor7_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdor7_field_t;

typedef struct stc_gpio_pdor8_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pdor8_field_t;

typedef struct stc_gpio_pdor9_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
} stc_gpio_pdor9_field_t;

typedef struct stc_gpio_pdora_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdora_field_t;

typedef struct stc_gpio_pdorb_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdorb_field_t;

typedef struct stc_gpio_pdorc_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdorc_field_t;

typedef struct stc_gpio_pdord_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
} stc_gpio_pdord_field_t;

typedef struct stc_gpio_pdore_field
{
  __IO uint32_t P0         : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pdore_field_t;

typedef struct stc_gpio_pdorf_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
} stc_gpio_pdorf_field_t;

typedef struct stc_gpio_ade_field
{
  __IO uint32_t AN00       : 1;
  __IO uint32_t AN01       : 1;
  __IO uint32_t AN02       : 1;
  __IO uint32_t AN03       : 1;
  __IO uint32_t AN04       : 1;
  __IO uint32_t AN05       : 1;
  __IO uint32_t AN06       : 1;
  __IO uint32_t AN07       : 1;
  __IO uint32_t AN08       : 1;
  __IO uint32_t AN09       : 1;
  __IO uint32_t AN10       : 1;
  __IO uint32_t AN11       : 1;
  __IO uint32_t AN12       : 1;
  __IO uint32_t AN13       : 1;
  __IO uint32_t AN14       : 1;
  __IO uint32_t AN15       : 1;
  __IO uint32_t AN16       : 1;
  __IO uint32_t AN17       : 1;
  __IO uint32_t AN18       : 1;
  __IO uint32_t AN19       : 1;
  __IO uint32_t AN20       : 1;
  __IO uint32_t AN21       : 1;
  __IO uint32_t AN22       : 1;
  __IO uint32_t AN23       : 1;
  __IO uint32_t AN24       : 1;
  __IO uint32_t AN25       : 1;
  __IO uint32_t AN26       : 1;
  __IO uint32_t AN27       : 1;
  __IO uint32_t AN28       : 1;
  __IO uint32_t AN29       : 1;
  __IO uint32_t AN30       : 1;
  __IO uint32_t AN31       : 1;
} stc_gpio_ade_field_t;

typedef struct stc_gpio_spsr_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t MAINXC     : 2;
  __IO uint32_t USB0C      : 1;
  __IO uint32_t USB1C      : 1;
} stc_gpio_spsr_field_t;

typedef struct stc_gpio_epfr00_field
{
  __IO uint32_t NMIS       : 1;
  __IO uint32_t CROUTE     : 2;
       uint32_t RESERVED1  : 1;
  __IO uint32_t RTCCOE     : 2;
  __IO uint32_t SUBOUTE    : 2;
       uint32_t RESERVED2  : 1;
  __IO uint32_t USBP0E     : 1;
       uint32_t RESERVED3  : 3;
  __IO uint32_t USBP1E     : 1;
       uint32_t RESERVED4  : 2;
  __IO uint32_t JTAGEN0B   : 1;
  __IO uint32_t JTAGEN1S   : 1;
       uint32_t RESERVED5  : 6;
  __IO uint32_t TRC0E      : 1;
  __IO uint32_t TRC1E      : 1;
  __IO uint32_t TRC2E      : 1;
  __IO uint32_t TRC3E      : 1;
} stc_gpio_epfr00_field_t;

typedef struct stc_gpio_epfr01_field
{
  __IO uint32_t RTO00E     : 2;
  __IO uint32_t RTO01E     : 2;
  __IO uint32_t RTO02E     : 2;
  __IO uint32_t RTO03E     : 2;
  __IO uint32_t RTO04E     : 2;
  __IO uint32_t RTO05E     : 2;
  __IO uint32_t DTTI0C     : 1;
       uint32_t RESERVED1  : 3;
  __IO uint32_t DTTI0S     : 2;
  __IO uint32_t FRCK0S     : 2;
  __IO uint32_t IC00S      : 3;
  __IO uint32_t IC01S      : 3;
  __IO uint32_t IC02S      : 3;
  __IO uint32_t IC03S      : 3;
} stc_gpio_epfr01_field_t;

typedef struct stc_gpio_epfr02_field
{
  __IO uint32_t RTO10E     : 2;
  __IO uint32_t RTO11E     : 2;
  __IO uint32_t RTO12E     : 2;
  __IO uint32_t RTO13E     : 2;
  __IO uint32_t RTO14E     : 2;
  __IO uint32_t RTO15E     : 2;
  __IO uint32_t DTTI1C     : 1;
       uint32_t RESERVED1  : 3;
  __IO uint32_t DTTI1S     : 2;
  __IO uint32_t FRCK1S     : 2;
  __IO uint32_t IC10S      : 3;
  __IO uint32_t IC11S      : 3;
  __IO uint32_t IC12S      : 3;
  __IO uint32_t IC13S      : 3;
} stc_gpio_epfr02_field_t;

typedef struct stc_gpio_epfr03_field
{
  __IO uint32_t RTO20E     : 2;
  __IO uint32_t RTO21E     : 2;
  __IO uint32_t RTO22E     : 2;
  __IO uint32_t RTO23E     : 2;
  __IO uint32_t RTO24E     : 2;
  __IO uint32_t RTO25E     : 2;
  __IO uint32_t DTTI2C     : 1;
       uint32_t RESERVED1  : 3;
  __IO uint32_t DTTI2S     : 2;
  __IO uint32_t FRCK2S     : 2;
  __IO uint32_t IC20S      : 3;
  __IO uint32_t IC21S      : 3;
  __IO uint32_t IC22S      : 3;
  __IO uint32_t IC23S      : 3;
} stc_gpio_epfr03_field_t;

typedef struct stc_gpio_epfr04_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t TIOA0E     : 2;
  __IO uint32_t TIOB0S     : 3;
       uint32_t RESERVED2  : 1;
  __IO uint32_t TIOA1S     : 2;
  __IO uint32_t TIOA1E     : 2;
  __IO uint32_t TIOB1S     : 2;
       uint32_t RESERVED3  : 4;
  __IO uint32_t TIOA2E     : 2;
  __IO uint32_t TIOB2S     : 2;
       uint32_t RESERVED4  : 2;
  __IO uint32_t TIOA3S     : 2;
  __IO uint32_t TIOA3E     : 2;
  __IO uint32_t TIOB3S     : 2;
} stc_gpio_epfr04_field_t;

typedef struct stc_gpio_epfr05_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t TIOA4E     : 2;
  __IO uint32_t TIOB4S     : 2;
       uint32_t RESERVED2  : 2;
  __IO uint32_t TIOA5S     : 2;
  __IO uint32_t TIOA5E     : 2;
  __IO uint32_t TIOB5S     : 2;
       uint32_t RESERVED3  : 4;
  __IO uint32_t TIOA6E     : 2;
  __IO uint32_t TIOB6S     : 2;
       uint32_t RESERVED4  : 2;
  __IO uint32_t TIOA7S     : 2;
  __IO uint32_t TIOA7E     : 2;
  __IO uint32_t TIOB7S     : 2;
} stc_gpio_epfr05_field_t;

typedef struct stc_gpio_epfr06_field
{
  __IO uint32_t EINT00S    : 2;
  __IO uint32_t EINT01S    : 2;
  __IO uint32_t EINT02S    : 2;
  __IO uint32_t EINT03S    : 2;
  __IO uint32_t EINT04S    : 2;
  __IO uint32_t EINT05S    : 2;
  __IO uint32_t EINT06S    : 2;
  __IO uint32_t EINT07S    : 2;
  __IO uint32_t EINT08S    : 2;
  __IO uint32_t EINT09S    : 2;
  __IO uint32_t EINT10S    : 2;
  __IO uint32_t EINT11S    : 2;
  __IO uint32_t EINT12S    : 2;
  __IO uint32_t EINT13S    : 2;
  __IO uint32_t EINT14S    : 2;
  __IO uint32_t EINT15S    : 2;
} stc_gpio_epfr06_field_t;

typedef struct stc_gpio_epfr07_field
{
       uint32_t RESERVED1  : 4;
  __IO uint32_t SIN0S      : 2;
  __IO uint32_t SOT0B      : 2;
  __IO uint32_t SCK0B      : 2;
  __IO uint32_t SIN1S      : 2;
  __IO uint32_t SOT1B      : 2;
  __IO uint32_t SCK1B      : 2;
  __IO uint32_t SIN2S      : 2;
  __IO uint32_t SOT2B      : 2;
  __IO uint32_t SCK2B      : 2;
  __IO uint32_t SIN3S      : 2;
  __IO uint32_t SOT3B      : 2;
  __IO uint32_t SCK3B      : 2;
} stc_gpio_epfr07_field_t;

typedef struct stc_gpio_epfr08_field
{
  __IO uint32_t RTS4E      : 2;
  __IO uint32_t CTS4S      : 2;
  __IO uint32_t SIN4S      : 2;
  __IO uint32_t SOT4B      : 2;
  __IO uint32_t SCK4B      : 2;
  __IO uint32_t SIN5S      : 2;
  __IO uint32_t SOT5B      : 2;
  __IO uint32_t SCK5B      : 2;
  __IO uint32_t SIN6S      : 2;
  __IO uint32_t SOT6B      : 2;
  __IO uint32_t SCK6B      : 2;
  __IO uint32_t SIN7S      : 2;
  __IO uint32_t SOT7B      : 2;
  __IO uint32_t SCK7B      : 2;
  __IO uint32_t RTS5E      : 2;
  __IO uint32_t CTS5S      : 2;
} stc_gpio_epfr08_field_t;

typedef struct stc_gpio_epfr09_field
{
  __IO uint32_t QAIN0S     : 2;
  __IO uint32_t QBIN0S     : 2;
  __IO uint32_t QZIN0S     : 2;
  __IO uint32_t QAIN1S     : 2;
  __IO uint32_t QBIN1S     : 2;
  __IO uint32_t QZIN1S     : 2;
  __IO uint32_t ADTRG0S    : 4;
  __IO uint32_t ADTRG1S    : 4;
  __IO uint32_t ADTRG2S    : 4;
  __IO uint32_t CRX0S      : 2;
  __IO uint32_t CTX0E      : 2;
  __IO uint32_t CRX1S      : 2;
  __IO uint32_t CTX1E      : 2;
} stc_gpio_epfr09_field_t;

typedef struct stc_gpio_epfr10_field
{
  __IO uint32_t UEDEFB     : 1;
  __IO uint32_t UEDTHB     : 1;
  __IO uint32_t UECLKE     : 1;
  __IO uint32_t UEWEXE     : 1;
  __IO uint32_t UEDQME     : 1;
  __IO uint32_t UEOEXE     : 1;
  __IO uint32_t UEFLSE     : 1;
  __IO uint32_t UECS1E     : 1;
  __IO uint32_t UECS2E     : 1;
  __IO uint32_t UECS3E     : 1;
  __IO uint32_t UECS4E     : 1;
  __IO uint32_t UECS5E     : 1;
  __IO uint32_t UECS6E     : 1;
  __IO uint32_t UECS7E     : 1;
  __IO uint32_t UEAOOE     : 1;
  __IO uint32_t UEA08E     : 1;
  __IO uint32_t UEA09E     : 1;
  __IO uint32_t UEA10E     : 1;
  __IO uint32_t UEA11E     : 1;
  __IO uint32_t UEA12E     : 1;
  __IO uint32_t UEA13E     : 1;
  __IO uint32_t UEA14E     : 1;
  __IO uint32_t UEA15E     : 1;
  __IO uint32_t UEA16E     : 1;
  __IO uint32_t UEA17E     : 1;
  __IO uint32_t UEA18E     : 1;
  __IO uint32_t UEA19E     : 1;
  __IO uint32_t UEA20E     : 1;
  __IO uint32_t UEA21E     : 1;
  __IO uint32_t UEA22E     : 1;
  __IO uint32_t UEA23E     : 1;
  __IO uint32_t UEA24E     : 1;
} stc_gpio_epfr10_field_t;

typedef struct stc_gpio_epfr11_field
{
  __IO uint32_t UEALEE     : 1;
  __IO uint32_t UECS0E     : 1;
  __IO uint32_t UEA01E     : 1;
  __IO uint32_t UEA02E     : 1;
  __IO uint32_t UEA03E     : 1;
  __IO uint32_t UEA04E     : 1;
  __IO uint32_t UEA05E     : 1;
  __IO uint32_t UEA06E     : 1;
  __IO uint32_t UEA07E     : 1;
  __IO uint32_t UED00B     : 1;
  __IO uint32_t UED01B     : 1;
  __IO uint32_t UED02B     : 1;
  __IO uint32_t UED03B     : 1;
  __IO uint32_t UED04B     : 1;
  __IO uint32_t UED05B     : 1;
  __IO uint32_t UED06B     : 1;
  __IO uint32_t UED07B     : 1;
  __IO uint32_t UED08B     : 1;
  __IO uint32_t UED09B     : 1;
  __IO uint32_t UED10B     : 1;
  __IO uint32_t UED11B     : 1;
  __IO uint32_t UED12B     : 1;
  __IO uint32_t UED13B     : 1;
  __IO uint32_t UED14B     : 1;
  __IO uint32_t UED15B     : 1;
  __IO uint32_t UERLC      : 1;
} stc_gpio_epfr11_field_t;

typedef struct stc_gpio_epfr12_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t TIOA8E     : 2;
  __IO uint32_t TIOB8S     : 2;
       uint32_t RESERVED2  : 2;
  __IO uint32_t TIOA9S     : 2;
  __IO uint32_t TIOA9E     : 2;
  __IO uint32_t TIOB9S     : 2;
       uint32_t RESERVED3  : 4;
  __IO uint32_t TIOA10E    : 2;
  __IO uint32_t TIOB10S    : 2;
       uint32_t RESERVED4  : 2;
  __IO uint32_t TIOA11S    : 2;
  __IO uint32_t TIOA11E    : 2;
  __IO uint32_t TIOB11S    : 2;
} stc_gpio_epfr12_field_t;

typedef struct stc_gpio_epfr13_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t TIOA12E    : 2;
  __IO uint32_t TIOB12S    : 2;
       uint32_t RESERVED2  : 2;
  __IO uint32_t TIOA13S    : 2;
  __IO uint32_t TIOA13E    : 2;
  __IO uint32_t TIOB13S    : 2;
       uint32_t RESERVED3  : 4;
  __IO uint32_t TIOA14E    : 2;
  __IO uint32_t TIOB14S    : 2;
       uint32_t RESERVED4  : 2;
  __IO uint32_t TIOA15S    : 2;
  __IO uint32_t TIOA15E    : 2;
  __IO uint32_t TIOB15S    : 2;
} stc_gpio_epfr13_field_t;

typedef struct stc_gpio_epfr14_field
{
  __IO uint32_t QAIN2S     : 2;
  __IO uint32_t QBIN2S     : 2;
  __IO uint32_t QZIN2S     : 2;
       uint32_t RESERVED1  : 12;
  __IO uint32_t E_TD0E     : 1;
  __IO uint32_t E_TD1E     : 1;
  __IO uint32_t E_TE0E     : 1;
  __IO uint32_t E_TE1E     : 1;
  __IO uint32_t E_MC0E     : 1;
  __IO uint32_t E_MC1B     : 1;
  __IO uint32_t E_MD0B     : 1;
  __IO uint32_t E_MD1B     : 1;
  __IO uint32_t E_CKE      : 1;
  __IO uint32_t E_PSE      : 1;
  __IO uint32_t E_SPLC     : 2;
} stc_gpio_epfr14_field_t;

typedef struct stc_gpio_epfr15_field
{
  __IO uint32_t EINT16S    : 2;
  __IO uint32_t EINT17S    : 2;
  __IO uint32_t EINT18S    : 2;
  __IO uint32_t EINT19S    : 2;
  __IO uint32_t EINT20S    : 2;
  __IO uint32_t EINT21S    : 2;
  __IO uint32_t EINT22S    : 2;
  __IO uint32_t EINT23S    : 2;
  __IO uint32_t EINT24S    : 2;
  __IO uint32_t EINT25S    : 2;
  __IO uint32_t EINT26S    : 2;
  __IO uint32_t EINT27S    : 2;
  __IO uint32_t EINT28S    : 2;
  __IO uint32_t EINT29S    : 2;
  __IO uint32_t EINT30S    : 2;
  __IO uint32_t EINT31S    : 2;
} stc_gpio_epfr15_field_t;

typedef struct stc_gpio_epfr16_field
{
  __IO uint32_t SCS6B      : 2;
  __IO uint32_t SCS7B      : 2;
  __IO uint32_t SIN8S      : 2;
  __IO uint32_t SOT8B      : 2;
  __IO uint32_t SCK8B      : 2;
  __IO uint32_t SIN9S      : 2;
  __IO uint32_t SOT9B      : 2;
  __IO uint32_t SCK9B      : 2;
  __IO uint32_t SIN10S     : 2;
  __IO uint32_t SOT10B     : 2;
  __IO uint32_t SCK10B     : 2;
  __IO uint32_t SIN11S     : 2;
  __IO uint32_t SOT11B     : 2;
  __IO uint32_t SCK11B     : 2;
  __IO uint32_t SFMPAC     : 1;
  __IO uint32_t SFMPBC     : 1;
} stc_gpio_epfr16_field_t;

typedef struct stc_gpio_epfr17_field
{
       uint32_t RESERVED1  : 4;
  __IO uint32_t SIN12S     : 2;
  __IO uint32_t SOT12B     : 2;
  __IO uint32_t SCK12B     : 2;
  __IO uint32_t SIN13S     : 2;
  __IO uint32_t SOT13B     : 2;
  __IO uint32_t SCK13B     : 2;
  __IO uint32_t SIN14S     : 2;
  __IO uint32_t SOT14B     : 2;
  __IO uint32_t SCK14B     : 2;
  __IO uint32_t SIN15S     : 2;
  __IO uint32_t SOT15B     : 2;
  __IO uint32_t SCK15B     : 2;
} stc_gpio_epfr17_field_t;

typedef struct stc_gpio_epfr18_field
{
  __IO uint32_t CECR0B     : 2;
  __IO uint32_t CECR1B     : 2;
  __IO uint32_t QAIN3S     : 2;
  __IO uint32_t QBIN3S     : 2;
  __IO uint32_t QZIN3S     : 2;
       uint32_t RESERVED1  : 4;
  __IO uint32_t SDCLKE     : 2;
  __IO uint32_t SDCMDB     : 2;
  __IO uint32_t SDDATA0B   : 2;
  __IO uint32_t SDDATA1B   : 2;
  __IO uint32_t SDDATA2B   : 2;
  __IO uint32_t SDDATA3B   : 2;
  __IO uint32_t SDCDS      : 2;
  __IO uint32_t SDWPS      : 2;
} stc_gpio_epfr18_field_t;

typedef struct stc_gpio_epfr20_field
{
  __IO uint32_t UESMCKE    : 1;
  __IO uint32_t UESMCEE    : 1;
  __IO uint32_t UERASE     : 1;
  __IO uint32_t UECASE     : 1;
  __IO uint32_t UEDWEXE    : 1;
  __IO uint32_t UECSXE     : 1;
  __IO uint32_t UEDQM2E    : 1;
  __IO uint32_t UEDQM3E    : 1;
  __IO uint32_t UEDTHHB    : 1;
  __IO uint32_t UED16B     : 1;
  __IO uint32_t UED17B     : 1;
  __IO uint32_t UED18B     : 1;
  __IO uint32_t UED19B     : 1;
  __IO uint32_t UED20B     : 1;
  __IO uint32_t UED21B     : 1;
  __IO uint32_t UED22B     : 1;
  __IO uint32_t UED23B     : 1;
  __IO uint32_t UED24B     : 1;
  __IO uint32_t UED25B     : 1;
  __IO uint32_t UED26B     : 1;
  __IO uint32_t UED27B     : 1;
  __IO uint32_t UED28B     : 1;
  __IO uint32_t UED29B     : 1;
  __IO uint32_t UED30B     : 1;
  __IO uint32_t UED31B     : 1;
} stc_gpio_epfr20_field_t;

typedef struct stc_gpio_epfr23_field
{
  __IO uint32_t SCS60E     : 2;
  __IO uint32_t SCS61E     : 2;
  __IO uint32_t SCS62E     : 2;
  __IO uint32_t SCS63E     : 2;
  __IO uint32_t SCS70E     : 2;
  __IO uint32_t SCS71E     : 2;
  __IO uint32_t SCS72E     : 2;
  __IO uint32_t SCS73E     : 2;
} stc_gpio_epfr23_field_t;

typedef struct stc_gpio_epfr24_field
{
  __IO uint32_t I2SM4_MCLK0S: 2;
  __IO uint32_t I2SM4_MCLK0E: 2;
  __IO uint32_t I2SM4_SCK0B: 2;
  __IO uint32_t I2SM4_WS0B : 2;
  __IO uint32_t I2SM4_SDI0S: 2;
  __IO uint32_t I2SM4_SDO0E: 2;
} stc_gpio_epfr24_field_t;

typedef struct stc_gpio_epfr25_field
{
  __IO uint32_t MCRX2S     : 2;
  __IO uint32_t MCTX2E     : 2;
} stc_gpio_epfr25_field_t;

typedef struct stc_gpio_epfr26_field
{
  __IO uint32_t Q_SCKE     : 2;
  __IO uint32_t Q_CS0E     : 2;
  __IO uint32_t Q_CS1E     : 2;
  __IO uint32_t Q_CS2E     : 2;
  __IO uint32_t Q_CS3E     : 2;
  __IO uint32_t Q_IO0B     : 2;
  __IO uint32_t Q_IO1B     : 2;
  __IO uint32_t Q_IO2B     : 2;
  __IO uint32_t Q_IO3B     : 2;
} stc_gpio_epfr26_field_t;

typedef struct stc_gpio_pzr0_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pzr0_field_t;

typedef struct stc_gpio_pzr1_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pzr1_field_t;

typedef struct stc_gpio_pzr2_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
} stc_gpio_pzr2_field_t;

typedef struct stc_gpio_pzr3_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pzr3_field_t;

typedef struct stc_gpio_pzr4_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pzr4_field_t;

typedef struct stc_gpio_pzr5_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pzr5_field_t;

typedef struct stc_gpio_pzr6_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pzr6_field_t;

typedef struct stc_gpio_pzr7_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pzr7_field_t;

typedef struct stc_gpio_pzr8_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pzr8_field_t;

typedef struct stc_gpio_pzr9_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
} stc_gpio_pzr9_field_t;

typedef struct stc_gpio_pzra_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pzra_field_t;

typedef struct stc_gpio_pzrb_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pzrb_field_t;

typedef struct stc_gpio_pzrc_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pzrc_field_t;

typedef struct stc_gpio_pzrd_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
} stc_gpio_pzrd_field_t;

typedef struct stc_gpio_pzre_field
{
  __IO uint32_t P0         : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pzre_field_t;

typedef struct stc_gpio_pzrf_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
} stc_gpio_pzrf_field_t;

typedef struct stc_gpio_pdsr0_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdsr0_field_t;

typedef struct stc_gpio_pdsr1_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdsr1_field_t;

typedef struct stc_gpio_pdsr2_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
} stc_gpio_pdsr2_field_t;

typedef struct stc_gpio_pdsr3_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdsr3_field_t;

typedef struct stc_gpio_pdsr4_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdsr4_field_t;

typedef struct stc_gpio_pdsr5_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdsr5_field_t;

typedef struct stc_gpio_pdsr6_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdsr6_field_t;

typedef struct stc_gpio_pdsr7_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
} stc_gpio_pdsr7_field_t;

typedef struct stc_gpio_pdsr8_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pdsr8_field_t;

typedef struct stc_gpio_pdsr9_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
} stc_gpio_pdsr9_field_t;

typedef struct stc_gpio_pdsra_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdsra_field_t;

typedef struct stc_gpio_pdsrb_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdsrb_field_t;

typedef struct stc_gpio_pdsrc_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
  __IO uint32_t PD         : 1;
  __IO uint32_t PE         : 1;
  __IO uint32_t PF         : 1;
} stc_gpio_pdsrc_field_t;

typedef struct stc_gpio_pdsrd_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
} stc_gpio_pdsrd_field_t;

typedef struct stc_gpio_pdsre_field
{
  __IO uint32_t P0         : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
} stc_gpio_pdsre_field_t;

typedef struct stc_gpio_pdsrf_field
{
  __IO uint32_t P0         : 1;
  __IO uint32_t P1         : 1;
  __IO uint32_t P2         : 1;
  __IO uint32_t P3         : 1;
  __IO uint32_t P4         : 1;
  __IO uint32_t P5         : 1;
  __IO uint32_t P6         : 1;
  __IO uint32_t P7         : 1;
  __IO uint32_t P8         : 1;
  __IO uint32_t P9         : 1;
  __IO uint32_t PA         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t PC         : 1;
} stc_gpio_pdsrf_field_t;

/******************************************************************************
 * LVD_MODULE
 ******************************************************************************/
/* LVD_MODULE register bit fields */
typedef struct stc_lvd_lvd_ctl_field
{
  union {
    struct {
            uint8_t RESERVED1  : 2;
      __IO  uint8_t SVHI       : 5;
      __IO  uint8_t LVDIE      : 1;
    };
    struct {
            uint8_t RESERVED3  : 2;
      __IO  uint8_t SVHI0      : 1;
      __IO  uint8_t SVHI1      : 1;
      __IO  uint8_t SVHI2      : 1;
      __IO  uint8_t SVHI3      : 1;
      __IO  uint8_t SVHI4      : 1;
            uint8_t RESERVED4  : 1;
    };
  };
} stc_lvd_lvd_ctl_field_t;

typedef struct stc_lvd_lvd_str_field
{
        uint8_t RESERVED1  : 7;
  __IO  uint8_t LVDIR      : 1;
} stc_lvd_lvd_str_field_t;

typedef struct stc_lvd_lvd_clr_field
{
        uint8_t RESERVED1  : 7;
  __IO  uint8_t LVDCL      : 1;
} stc_lvd_lvd_clr_field_t;

typedef struct stc_lvd_lvd_str2_field
{
        uint8_t RESERVED1  : 6;
  __IO  uint8_t LVDRRDY    : 1;
  __IO  uint8_t LVDIRDY    : 1;
} stc_lvd_lvd_str2_field_t;

/******************************************************************************
 * DS_MODULE
 ******************************************************************************/
/* DS_MODULE register bit fields */
typedef struct stc_ds_rck_ctl_field
{
        uint8_t RESERVED1  : 1;
  __IO  uint8_t CECCKE     : 1;
} stc_ds_rck_ctl_field_t;

typedef struct stc_ds_pmd_ctl_field
{
  __IO  uint8_t RTCE       : 1;
} stc_ds_pmd_ctl_field_t;

typedef struct stc_ds_wrfsr_field
{
  __IO  uint8_t WINITX     : 1;
  __IO  uint8_t WLVDH      : 1;
} stc_ds_wrfsr_field_t;

typedef struct stc_ds_wifsr_field
{
  __IO uint16_t WRTCI      : 1;
  __IO uint16_t WLVDI      : 1;
  __IO uint16_t WUI0       : 1;
  __IO uint16_t WUI1       : 1;
  __IO uint16_t WUI2       : 1;
  __IO uint16_t WUI3       : 1;
  __IO uint16_t WUI4       : 1;
  __IO uint16_t WUI5       : 1;
} stc_ds_wifsr_field_t;

typedef struct stc_ds_wier_field
{
  __IO uint16_t WRTCE      : 1;
  __IO uint16_t WLVDE      : 1;
       uint16_t RESERVED2  : 1;
  __IO uint16_t WUI1E      : 1;
  __IO uint16_t WUI2E      : 1;
  __IO uint16_t WUI3E      : 1;
  __IO uint16_t WUI4E      : 1;
  __IO uint16_t WUI5E      : 1;
} stc_ds_wier_field_t;

typedef struct stc_ds_wilvr_field
{
  __IO  uint8_t WUI1LV     : 1;
  __IO  uint8_t WUI2LV     : 1;
  __IO  uint8_t WUI3LV     : 1;
  __IO  uint8_t WUI4LV     : 1;
  __IO  uint8_t WUI5LV     : 1;
} stc_ds_wilvr_field_t;

typedef struct stc_ds_dsramr_field
{
  __IO  uint8_t SRAMR      : 2;
} stc_ds_dsramr_field_t;

/******************************************************************************
 * USB Ethernet CLK
 ******************************************************************************/
/* USB ETHERNET CLK register bit fields */
typedef struct stc_usbethernetclk_uccr_field
{
  __IO  uint8_t UCEN0      : 1;
  __IO  uint8_t UCSEL0     : 1;
  __IO  uint8_t UCSEL1     : 1;
  __IO  uint8_t UCEN1      : 1;
  __IO  uint8_t ECEN       : 1;
  __IO  uint8_t ECSEL0     : 1;
  __IO  uint8_t ECSEL1     : 1;
} stc_usbethernetclk_uccr_field_t;

typedef struct stc_usbethernetclk_upcr1_field
{
  __IO  uint8_t UPLLEN     : 1;
  __IO  uint8_t UPINC      : 1;
} stc_usbethernetclk_upcr1_field_t;

typedef struct stc_usbethernetclk_upcr2_field
{
  __IO  uint8_t UPOWT0     : 1;
  __IO  uint8_t UPOWT1     : 1;
  __IO  uint8_t UPOWT2     : 1;
} stc_usbethernetclk_upcr2_field_t;

typedef struct stc_usbethernetclk_upcr3_field
{
  __IO  uint8_t UPLLK0     : 1;
  __IO  uint8_t UPLLK1     : 1;
  __IO  uint8_t UPLLK2     : 1;
  __IO  uint8_t UPLLK3     : 1;
  __IO  uint8_t UPLLK4     : 1;
} stc_usbethernetclk_upcr3_field_t;

typedef struct stc_usbethernetclk_upcr4_field
{
  __IO  uint8_t UPLLN0     : 1;
  __IO  uint8_t UPLLN1     : 1;
  __IO  uint8_t UPLLN2     : 1;
  __IO  uint8_t UPLLN3     : 1;
  __IO  uint8_t UPLLN4     : 1;
  __IO  uint8_t UPLLN5     : 1;
  __IO  uint8_t UPLLN6     : 1;
} stc_usbethernetclk_upcr4_field_t;

typedef struct stc_usbethernetclk_up_str_field
{
  __IO  uint8_t UPRDY      : 1;
} stc_usbethernetclk_up_str_field_t;

typedef struct stc_usbethernetclk_upint_enr_field
{
  __IO  uint8_t UPCSE      : 1;
} stc_usbethernetclk_upint_enr_field_t;

typedef struct stc_usbethernetclk_upint_clr_field
{
  __IO  uint8_t UPCSC      : 1;
} stc_usbethernetclk_upint_clr_field_t;

typedef struct stc_usbethernetclk_upint_str_field
{
  __IO  uint8_t UPCSI      : 1;
} stc_usbethernetclk_upint_str_field_t;

typedef struct stc_usbethernetclk_upcr5_field
{
  __IO  uint8_t UPLLM0     : 1;
  __IO  uint8_t UPLLM1     : 1;
  __IO  uint8_t UPLLM2     : 1;
  __IO  uint8_t UPLLM3     : 1;
} stc_usbethernetclk_upcr5_field_t;

typedef struct stc_usbethernetclk_upcr6_field
{
  __IO  uint8_t UBSR0      : 1;
  __IO  uint8_t UBSR1      : 1;
  __IO  uint8_t UBSR2      : 1;
  __IO  uint8_t UBSR3      : 1;
} stc_usbethernetclk_upcr6_field_t;

typedef struct stc_usbethernetclk_upcr7_field
{
  __IO  uint8_t EPLLEN     : 1;
} stc_usbethernetclk_upcr7_field_t;

typedef struct stc_usbethernetclk_usben0_field
{
  __IO  uint8_t USBEN0     : 1;
} stc_usbethernetclk_usben0_field_t;

typedef struct stc_usbethernetclk_usben1_field
{
  __IO  uint8_t USBEN1     : 1;
} stc_usbethernetclk_usben1_field_t;


/******************************************************************************
 * USBCLK
 ******************************************************************************/
/* USBCLK register bit fields */
typedef struct stc_usbclk_uccr_field
{
  __IO  uint8_t UCEN       : 1;
  __IO  uint8_t UCSEL      : 1;
} stc_usbclk_uccr_field_t;

typedef struct stc_usbclk_upcr1_field
{
  __IO  uint8_t UPLLEN     : 1;
  __IO  uint8_t UPINC      : 1;
} stc_usbclk_upcr1_field_t;

typedef struct stc_usbclk_upcr2_field
{
  __IO  uint8_t UPOWT0     : 1;
  __IO  uint8_t UPOWT1     : 1;
  __IO  uint8_t UPOWT2     : 1;
} stc_usbclk_upcr2_field_t;

typedef struct stc_usbclk_upcr3_field
{
  __IO  uint8_t UPLLK0     : 1;
  __IO  uint8_t UPLLK1     : 1;
  __IO  uint8_t UPLLK2     : 1;
  __IO  uint8_t UPLLK3     : 1;
  __IO  uint8_t UPLLK4     : 1;
} stc_usbclk_upcr3_field_t;

typedef struct stc_usbclk_upcr4_field
{
  __IO  uint8_t UPLLN0     : 1;
  __IO  uint8_t UPLLN1     : 1;
  __IO  uint8_t UPLLN2     : 1;
  __IO  uint8_t UPLLN3     : 1;
  __IO  uint8_t UPLLN4     : 1;
} stc_usbclk_upcr4_field_t;

typedef struct stc_usbclk_up_str_field
{
  __IO  uint8_t UPRDY      : 1;
} stc_usbclk_up_str_field_t;

typedef struct stc_usbclk_upint_enr_field
{
  __IO  uint8_t UPCSE      : 1;
} stc_usbclk_upint_enr_field_t;

typedef struct stc_usbclk_upint_clr_field
{
  __IO  uint8_t UPCSC      : 1;
} stc_usbclk_upint_clr_field_t;

typedef struct stc_usbclk_upint_str_field
{
  __IO  uint8_t UPCSI      : 1;
} stc_usbclk_upint_str_field_t;

typedef struct stc_usbclk_usben_field
{
  __IO  uint8_t USBEN      : 1;
} stc_usbclk_usben_field_t;

/******************************************************************************
 * CANPRE_MODULE
 ******************************************************************************/
/* CANPRE_MODULE register bit fields */
typedef struct stc_canpre_canpre_field
{
  __IO  uint8_t CANPRE0    : 1;
  __IO  uint8_t CANPRE1    : 1;
  __IO  uint8_t CANPRE2    : 1;
  __IO  uint8_t CANPRE3    : 1;
} stc_canpre_canpre_field_t;

/******************************************************************************
 * MFS_MODULE(COMMON)
 ******************************************************************************/
/* MFS_MODULE(COMMON) register bit fields */
typedef struct stc_mfs_smr_field
{
  union {
    struct {
      __IO  uint8_t SOE        : 1; /* for UART/CSIO/LIN */
            uint8_t RESERVED1  : 1;
      __IO  uint8_t BDS        : 1; /* for UART/CSIO */
      __IO  uint8_t SBL        : 1; /* for UART/LIN */
      __IO  uint8_t WUCR       : 1; /* for UART/LIN */
      __IO  uint8_t MD         : 3; /* for UART/CSIO/LIN/I2C */
    };
    struct {
            uint8_t RESERVED2  : 1;
      __IO  uint8_t SCKE       : 1; /* for CSIO */
            uint8_t RESERVED3  : 1;
      __IO  uint8_t SCINV      : 1; /* for CSIO */
            uint8_t RESERVED4  : 4;
    };
    struct {
            uint8_t RESERVED5  : 2;
      __IO  uint8_t TIE        : 1; /* for I2C */
      __IO  uint8_t RIE        : 1; /* for I2C */
            uint8_t RESERVED6  : 4;
    };
  };
} stc_mfs_smr_field_t;

typedef struct stc_mfs_scr_field
{
  union {
    struct {
      __IO  uint8_t TXE        : 1; /* for UART/CSIO/LIN */
      __IO  uint8_t RXE        : 1; /* for UART/CSIO/LIN */
      __IO  uint8_t TBIE       : 1; /* for UART/CSIO/LIN */
      __IO  uint8_t TIE        : 1; /* for UART/CSIO/LIN */
      __IO  uint8_t RIE        : 1; /* for UART/CSIO/LIN */
            uint8_t RESERVED1  : 2;
      __IO  uint8_t UPCL       : 1; /* for UART/CSIO/LIN */
    };
    struct {
            uint8_t RESERVED2  : 5;
      __IO  uint8_t SPI        : 1; /* for CSIO */
      __IO  uint8_t MS         : 1; /* for CSIO/LIN */
            uint8_t RESERVED3  : 1;
    };
    struct {
            uint8_t RESERVED4  : 5;
      __IO  uint8_t LBR        : 1; /* for LIN */
            uint8_t RESERVED5  : 2;
    };
  };
} stc_mfs_scr_field_t;

typedef struct stc_mfs_escr_field
{
  union {
    struct {
      __IO  uint8_t L          : 3; /* for UART/CSIO */
      __IO  uint8_t P          : 1; /* for UART */
      __IO  uint8_t PEN        : 1; /* for UART */
      __IO  uint8_t INV        : 1; /* for UART */
      __IO  uint8_t ESBL       : 1; /* for UART/LIN */
      __IO  uint8_t FLWEN      : 1; /* for UART */
    };
    struct {
      __IO  uint8_t L0         : 1; /* for UART/CSIO */
      __IO  uint8_t L1         : 1; /* for UART/CSIO */
      __IO  uint8_t L2         : 1; /* for UART/CSIO */
      __IO  uint8_t WT         : 2; /* for CSIO */
      __IO  uint8_t CSFE       : 1; /* for CSIO */
      __IO  uint8_t L3         : 1; /* for CSIO */
      __IO  uint8_t SOP        : 1; /* for CSIO */
    };
    struct {
            uint8_t RESERVED3  : 3;
      __IO  uint8_t WT0        : 1; /* for CSIO */
      __IO  uint8_t WT1        : 1; /* for CSIO */
            uint8_t RESERVED4  : 3;
    };
    struct {
      __IO  uint8_t DEL        : 2; /* for LIN */
      __IO  uint8_t LBL        : 2; /* for LIN */
      __IO  uint8_t LBIE       : 1; /* for LIN */
            uint8_t RESERVED5  : 3;
    };
    struct {
      __IO  uint8_t DEL0       : 1; /* for LIN */
      __IO  uint8_t DEL1       : 1; /* for LIN */
      __IO  uint8_t LBL0       : 1; /* for LIN */
      __IO  uint8_t LBL1       : 1; /* for LIN */
            uint8_t RESERVED6  : 4;
    };
  };
} stc_mfs_escr_field_t;

typedef struct stc_mfs_ssr_field
{
  union {
    struct {
      __IO  uint8_t TBI        : 1; /* for UART/CSIO/LIN/I2C */
      __IO  uint8_t TDRE       : 1; /* for UART/CSIO/LIN/I2C */
      __IO  uint8_t RDRF       : 1; /* for UART/CSIO/LIN/I2C */
      __IO  uint8_t ORE        : 1; /* for UART/CSIO/LIN/I2C */
      __IO  uint8_t FRE        : 1; /* for UART/LIN */
      __IO  uint8_t PE         : 1; /* for UART */
            uint8_t RESERVED1  : 1;
      __IO  uint8_t REC        : 1; /* for UART/CSIO/LIN/I2C */
    };
    struct {
            uint8_t RESERVED2  : 4;
      __IO  uint8_t AWC        : 1; /* for CSIO */
            uint8_t RESERVED3  : 3;
    };
    struct {
            uint8_t RESERVED4  : 5;
      __IO  uint8_t LBD        : 1; /* for LIN */
            uint8_t RESERVED5  : 2;
    };
    struct {
            uint8_t RESERVED6  : 4;
      __IO  uint8_t TBIE       : 1; /* for I2C */
      __IO  uint8_t DMA        : 1; /* for I2C */
      __IO  uint8_t TSET       : 1; /* for I2C */
            uint8_t RESERVED7  : 1;
    };
  };
} stc_mfs_ssr_field_t;

typedef struct stc_mfs_bgr_field
{
       uint16_t RESERVED1  : 15;
  __IO uint16_t EXT        : 1;
} stc_mfs_bgr_field_t;

typedef struct stc_mfs_bgr1_field
{
        uint8_t RESERVED1  : 7;
  __IO  uint8_t EXT        : 1;
} stc_mfs_bgr1_field_t;

typedef struct stc_mfs_fcr_field
{
  __IO uint16_t FE1        : 1;
  __IO uint16_t FE2        : 1;
  __IO uint16_t FCL1       : 1;
  __IO uint16_t FCL2       : 1;
  __IO uint16_t FSET       : 1;
  __IO uint16_t FLD        : 1;
  __IO uint16_t FLST       : 1;
       uint16_t RESERVED1  : 1;
  __IO uint16_t FSEL       : 1;
  __IO uint16_t FTIE       : 1;
  __IO uint16_t FDRQ       : 1;
  __IO uint16_t FRIIE      : 1;
  __IO uint16_t FLSTE      : 1;
       uint16_t RESERVED2  : 1;
  __IO uint16_t FTST0      : 1;
  __IO uint16_t FTST1      : 1;
} stc_mfs_fcr_field_t;

typedef struct stc_mfs_fcr0_field
{
  __IO  uint8_t FE1        : 1;
  __IO  uint8_t FE2        : 1;
  __IO  uint8_t FCL1       : 1;
  __IO  uint8_t FCL2       : 1;
  __IO  uint8_t FSET       : 1;
  __IO  uint8_t FLD        : 1;
  __IO  uint8_t FLST       : 1;
        uint8_t RESERVED1  : 1;
} stc_mfs_fcr0_field_t;

typedef struct stc_mfs_fcr1_field
{
  __IO  uint8_t FSEL       : 1;
  __IO  uint8_t FTIE       : 1;
  __IO  uint8_t FDRQ       : 1;
  __IO  uint8_t FRIIE      : 1;
  __IO  uint8_t FLSTE      : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t FTST0      : 1;
  __IO  uint8_t FTST1      : 1;
} stc_mfs_fcr1_field_t;

typedef struct stc_mfs_fbyte_field
{
  __IO uint16_t FD0        : 1;
  __IO uint16_t FD1        : 1;
  __IO uint16_t FD2        : 1;
  __IO uint16_t FD3        : 1;
  __IO uint16_t FD4        : 1;
  __IO uint16_t FD5        : 1;
  __IO uint16_t FD6        : 1;
  __IO uint16_t FD7        : 1;
  __IO uint16_t FD8        : 1;
  __IO uint16_t FD9        : 1;
  __IO uint16_t FD10       : 1;
  __IO uint16_t FD11       : 1;
  __IO uint16_t FD12       : 1;
  __IO uint16_t FD13       : 1;
  __IO uint16_t FD14       : 1;
  __IO uint16_t FD15       : 1;
} stc_mfs_fbyte_field_t;

typedef struct stc_mfs_fbyte1_field
{
  __IO  uint8_t FD0        : 1;
  __IO  uint8_t FD1        : 1;
  __IO  uint8_t FD2        : 1;
  __IO  uint8_t FD3        : 1;
  __IO  uint8_t FD4        : 1;
  __IO  uint8_t FD5        : 1;
  __IO  uint8_t FD6        : 1;
  __IO  uint8_t FD7        : 1;
} stc_mfs_fbyte1_field_t;

typedef struct stc_mfs_fbyte2_field
{
  __IO  uint8_t FD8        : 1;
  __IO  uint8_t FD9        : 1;
  __IO  uint8_t FD10       : 1;
  __IO  uint8_t FD11       : 1;
  __IO  uint8_t FD12       : 1;
  __IO  uint8_t FD13       : 1;
  __IO  uint8_t FD14       : 1;
  __IO  uint8_t FD15       : 1;
} stc_mfs_fbyte2_field_t;

/******************************************************************************
 * MFS_MODULE(UART)
 ******************************************************************************/
/* MFS_MODULE(UART) register bit fields */
typedef struct stc_mfs_uart_rdr_field
{
       uint16_t RESERVED1  : 8;
  __IO uint16_t AD         : 1;
       uint16_t RESERVED2  : 7;
} stc_mfs_uart_rdr_field_t;

typedef struct stc_mfs_uart_tdr_field
{
       uint16_t RESERVED1  : 8;
  __IO uint16_t AD         : 1;
       uint16_t RESERVED2  : 7;
} stc_mfs_uart_tdr_field_t;

/******************************************************************************
 * MFS_MODULE(CSIO)
 ******************************************************************************/
/* MFS_MODULE(CSIO) register bit fields */
typedef struct stc_mfs_csio_scstr10_field
{
  __IO uint16_t CSHD0      : 1;
  __IO uint16_t CSHD1      : 1;
  __IO uint16_t CSHD2      : 1;
  __IO uint16_t CSHD3      : 1;
  __IO uint16_t CSHD4      : 1;
  __IO uint16_t CSHD5      : 1;
  __IO uint16_t CSHD6      : 1;
  __IO uint16_t CSHD7      : 1;
  __IO uint16_t CSSU0      : 1;
  __IO uint16_t CSSU1      : 1;
  __IO uint16_t CSSU2      : 1;
  __IO uint16_t CSSU3      : 1;
  __IO uint16_t CSSU4      : 1;
  __IO uint16_t CSSU5      : 1;
  __IO uint16_t CSSU6      : 1;
  __IO uint16_t CSSU7      : 1;
} stc_mfs_csio_scstr10_field_t;

typedef struct stc_mfs_csio_scstr0_field
{
  __IO  uint8_t CSHD0      : 1;
  __IO  uint8_t CSHD1      : 1;
  __IO  uint8_t CSHD2      : 1;
  __IO  uint8_t CSHD3      : 1;
  __IO  uint8_t CSHD4      : 1;
  __IO  uint8_t CSHD5      : 1;
  __IO  uint8_t CSHD6      : 1;
  __IO  uint8_t CSHD7      : 1;
} stc_mfs_csio_scstr0_field_t;

typedef struct stc_mfs_csio_scstr1_field
{
  __IO  uint8_t CSSU0      : 1;
  __IO  uint8_t CSSU1      : 1;
  __IO  uint8_t CSSU2      : 1;
  __IO  uint8_t CSSU3      : 1;
  __IO  uint8_t CSSU4      : 1;
  __IO  uint8_t CSSU5      : 1;
  __IO  uint8_t CSSU6      : 1;
  __IO  uint8_t CSSU7      : 1;
} stc_mfs_csio_scstr1_field_t;

typedef struct stc_mfs_csio_scstr32_field
{
  __IO uint16_t CSDS0      : 1;
  __IO uint16_t CSDS1      : 1;
  __IO uint16_t CSDS2      : 1;
  __IO uint16_t CSDS3      : 1;
  __IO uint16_t CSDS4      : 1;
  __IO uint16_t CSDS5      : 1;
  __IO uint16_t CSDS6      : 1;
  __IO uint16_t CSDS7      : 1;
  __IO uint16_t CSDS8      : 1;
  __IO uint16_t CSDS9      : 1;
  __IO uint16_t CSDS10     : 1;
  __IO uint16_t CSDS11     : 1;
  __IO uint16_t CSDS12     : 1;
  __IO uint16_t CSDS13     : 1;
  __IO uint16_t CSDS14     : 1;
  __IO uint16_t CSDS15     : 1;
} stc_mfs_csio_scstr32_field_t;

typedef struct stc_mfs_csio_scstr2_field
{
  __IO  uint8_t CSDS0      : 1;
  __IO  uint8_t CSDS1      : 1;
  __IO  uint8_t CSDS2      : 1;
  __IO  uint8_t CSDS3      : 1;
  __IO  uint8_t CSDS4      : 1;
  __IO  uint8_t CSDS5      : 1;
  __IO  uint8_t CSDS6      : 1;
  __IO  uint8_t CSDS7      : 1;
} stc_mfs_csio_scstr2_field_t;

typedef struct stc_mfs_csio_scstr3_field
{
  __IO  uint8_t CSDS8      : 1;
  __IO  uint8_t CSDS9      : 1;
  __IO  uint8_t CSDS10     : 1;
  __IO  uint8_t CSDS11     : 1;
  __IO  uint8_t CSDS12     : 1;
  __IO  uint8_t CSDS13     : 1;
  __IO  uint8_t CSDS14     : 1;
  __IO  uint8_t CSDS15     : 1;
} stc_mfs_csio_scstr3_field_t;

typedef struct stc_mfs_csio_sacsr_field
{
  __IO uint16_t TMRE       : 1;
  __IO uint16_t TDIV       : 4;
       uint16_t RESERVED1  : 1;
  __IO uint16_t TSYNE      : 1;
  __IO uint16_t TINTE      : 1;
  __IO uint16_t TINT       : 1;
       uint16_t RESERVED2  : 2;
  __IO uint16_t CSE        : 1;
  __IO uint16_t CSEIE      : 1;
  __IO uint16_t TBEEN      : 1;
       uint16_t RESERVED3  : 2;
} stc_mfs_csio_sacsr_field_t;

typedef struct stc_mfs_csio_sacsr0_field
{
  __IO  uint8_t TMRE       : 1;
  __IO  uint8_t TDIV       : 4;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t TSYNE      : 1;
  __IO  uint8_t TINTE      : 1;
} stc_mfs_csio_sacsr0_field_t;

typedef struct stc_mfs_csio_sacsr1_field
{
  __IO  uint8_t TINT       : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t CSE        : 1;
  __IO  uint8_t CSEIE      : 1;
  __IO  uint8_t TBEEN      : 1;
        uint8_t RESERVED2  : 2;
} stc_mfs_csio_sacsr1_field_t;

typedef struct stc_mfs_csio_stmr_field
{
  __IO uint16_t TM0        : 1;
  __IO uint16_t TM1        : 1;
  __IO uint16_t TM2        : 1;
  __IO uint16_t TM3        : 1;
  __IO uint16_t TM4        : 1;
  __IO uint16_t TM5        : 1;
  __IO uint16_t TM6        : 1;
  __IO uint16_t TM7        : 1;
  __IO uint16_t TM8        : 1;
  __IO uint16_t TM9        : 1;
  __IO uint16_t TM10       : 1;
  __IO uint16_t TM11       : 1;
  __IO uint16_t TM12       : 1;
  __IO uint16_t TM13       : 1;
  __IO uint16_t TM14       : 1;
  __IO uint16_t TM15       : 1;
} stc_mfs_csio_stmr_field_t;

typedef struct stc_mfs_csio_stmr0_field
{
  __IO  uint8_t TM0        : 1;
  __IO  uint8_t TM1        : 1;
  __IO  uint8_t TM2        : 1;
  __IO  uint8_t TM3        : 1;
  __IO  uint8_t TM4        : 1;
  __IO  uint8_t TM5        : 1;
  __IO  uint8_t TM6        : 1;
  __IO  uint8_t TM7        : 1;
} stc_mfs_csio_stmr0_field_t;

typedef struct stc_mfs_csio_stmr1_field
{
  __IO  uint8_t TM8        : 1;
  __IO  uint8_t TM9        : 1;
  __IO  uint8_t TM10       : 1;
  __IO  uint8_t TM11       : 1;
  __IO  uint8_t TM12       : 1;
  __IO  uint8_t TM13       : 1;
  __IO  uint8_t TM14       : 1;
  __IO  uint8_t TM15       : 1;
} stc_mfs_csio_stmr1_field_t;

typedef struct stc_mfs_csio_stmcr_field
{
  __IO uint16_t TC0        : 1;
  __IO uint16_t TC1        : 1;
  __IO uint16_t TC2        : 1;
  __IO uint16_t TC3        : 1;
  __IO uint16_t TC4        : 1;
  __IO uint16_t TC5        : 1;
  __IO uint16_t TC6        : 1;
  __IO uint16_t TC7        : 1;
  __IO uint16_t TC8        : 1;
  __IO uint16_t TC9        : 1;
  __IO uint16_t TC10       : 1;
  __IO uint16_t TC11       : 1;
  __IO uint16_t TC12       : 1;
  __IO uint16_t TC13       : 1;
  __IO uint16_t TC14       : 1;
  __IO uint16_t TC15       : 1;
} stc_mfs_csio_stmcr_field_t;

typedef struct stc_mfs_csio_stmcr0_field
{
  __IO  uint8_t TC0        : 1;
  __IO  uint8_t TC1        : 1;
  __IO  uint8_t TC2        : 1;
  __IO  uint8_t TC3        : 1;
  __IO  uint8_t TC4        : 1;
  __IO  uint8_t TC5        : 1;
  __IO  uint8_t TC6        : 1;
  __IO  uint8_t TC7        : 1;
} stc_mfs_csio_stmcr0_field_t;

typedef struct stc_mfs_csio_stmcr1_field
{
  __IO  uint8_t TC8        : 1;
  __IO  uint8_t TC9        : 1;
  __IO  uint8_t TC10       : 1;
  __IO  uint8_t TC11       : 1;
  __IO  uint8_t TC12       : 1;
  __IO  uint8_t TC13       : 1;
  __IO  uint8_t TC14       : 1;
  __IO  uint8_t TC15       : 1;
} stc_mfs_csio_stmcr1_field_t;

typedef struct stc_mfs_csio_scscr_field
{
  __IO uint16_t CSOE       : 1;
  __IO uint16_t CSEN0      : 1;
  __IO uint16_t CSEN1      : 1;
  __IO uint16_t CSEN2      : 1;
  __IO uint16_t CSEN3      : 1;
  __IO uint16_t CSLVL      : 1;
  __IO uint16_t CDIV       : 3;
  __IO uint16_t SCAM       : 1;
  __IO uint16_t SCD        : 2;
  __IO uint16_t SED        : 2;
  __IO uint16_t SST        : 2;
} stc_mfs_csio_scscr_field_t;

typedef struct stc_mfs_csio_scsfr0_field
{
  __IO  uint8_t CS1L       : 4;
  __IO  uint8_t CS1SPI     : 1;
  __IO  uint8_t CS1SCINV   : 1;
  __IO  uint8_t CS1CSLVL   : 1;
} stc_mfs_csio_scsfr0_field_t;

typedef struct stc_mfs_csio_scsfr1_field
{
  __IO  uint8_t CS2L       : 4;
  __IO  uint8_t CS2SPI     : 1;
  __IO  uint8_t CS2SCINV   : 1;
  __IO  uint8_t CS2CSLVL   : 1;
} stc_mfs_csio_scsfr1_field_t;

typedef struct stc_mfs_csio_scsfr2_field
{
  __IO  uint8_t CS3L       : 4;
  __IO  uint8_t CS3SPI     : 1;
  __IO  uint8_t CS3SCINV   : 1;
  __IO  uint8_t CS3CSLVL   : 1;
} stc_mfs_csio_scsfr2_field_t;

/******************************************************************************
 * MFS_MODULE(I2C)
 ******************************************************************************/
/* MFS_MODULE(I2C) register bit fields */
typedef struct stc_mfs_i2c_ibcr_field
{
  __IO  uint8_t INT        : 1;
  __IO  uint8_t BER        : 1;
  __IO  uint8_t INTE       : 1;
  __IO  uint8_t CNDE       : 1;
  __IO  uint8_t WSEL       : 1;
  __IO  uint8_t ACKE       : 1;
  __IO  uint8_t ACT_SCC    : 1;
  __IO  uint8_t MSS        : 1;
} stc_mfs_i2c_ibcr_field_t;

typedef struct stc_mfs_i2c_ibsr_field
{
  __IO  uint8_t BB         : 1;
  __IO  uint8_t SPC        : 1;
  __IO  uint8_t RSC        : 1;
  __IO  uint8_t AL         : 1;
  __IO  uint8_t TRX        : 1;
  __IO  uint8_t RSA        : 1;
  __IO  uint8_t RACK       : 1;
  __IO  uint8_t FBT        : 1;
} stc_mfs_i2c_ibsr_field_t;

typedef struct stc_mfs_i2c_isba_field
{
  union {
    struct {
      __IO  uint8_t SA         : 7;
      __IO  uint8_t SAEN       : 1;
    };
    struct {
      __IO  uint8_t SA0        : 1;
      __IO  uint8_t SA1        : 1;
      __IO  uint8_t SA2        : 1;
      __IO  uint8_t SA3        : 1;
      __IO  uint8_t SA4        : 1;
      __IO  uint8_t SA5        : 1;
      __IO  uint8_t SA6        : 1;
            uint8_t RESERVED1  : 1;
    };
  };
} stc_mfs_i2c_isba_field_t;

typedef struct stc_mfs_i2c_ismk_field
{
  union {
    struct {
      __IO  uint8_t SM         : 7;
      __IO  uint8_t EN         : 1;
    };
    struct {
      __IO  uint8_t SM0        : 1;
      __IO  uint8_t SM1        : 1;
      __IO  uint8_t SM2        : 1;
      __IO  uint8_t SM3        : 1;
      __IO  uint8_t SM4        : 1;
      __IO  uint8_t SM5        : 1;
      __IO  uint8_t SM6        : 1;
            uint8_t RESERVED1  : 1;
    };
  };
} stc_mfs_i2c_ismk_field_t;

typedef struct stc_mfs_i2c_nfcr_field
{
  __IO  uint8_t NFT        : 5;
        uint8_t RESERVED1  : 3;
} stc_mfs_i2c_nfcr_field_t;

typedef struct stc_mfs_i2c_eibcr_field
{
  __IO  uint8_t BEC        : 1;
  __IO  uint8_t SOCE       : 1;
  __IO  uint8_t SCLC       : 1;
  __IO  uint8_t SDAC       : 1;
  __IO  uint8_t SCLS       : 1;
  __IO  uint8_t SDAS       : 1;
        uint8_t RESERVED1  : 2;
} stc_mfs_i2c_eibcr_field_t;

/******************************************************************************
 * CRC_MODULE
 ******************************************************************************/
/* CRC_MODULE register bit fields */
typedef struct stc_crc_crccr_field
{
  __IO  uint8_t INIT       : 1;
  __IO  uint8_t CRC32      : 1;
  __IO  uint8_t LTLEND     : 1;
  __IO  uint8_t LSBFST     : 1;
  __IO  uint8_t CRCLTE     : 1;
  __IO  uint8_t CRCLSF     : 1;
  __IO  uint8_t FXOR       : 1;
} stc_crc_crccr_field_t;

/******************************************************************************
 * WC_MODULE
 ******************************************************************************/
/* WC_MODULE register bit fields */
typedef struct stc_wc_wcrd_field
{
  __IO  uint8_t CTR0       : 1;
  __IO  uint8_t CTR1       : 1;
  __IO  uint8_t CTR2       : 1;
  __IO  uint8_t CTR3       : 1;
  __IO  uint8_t CTR4       : 1;
  __IO  uint8_t CTR5       : 1;
} stc_wc_wcrd_field_t;

typedef struct stc_wc_wcrl_field
{
  __IO  uint8_t RLC0       : 1;
  __IO  uint8_t RLC1       : 1;
  __IO  uint8_t RLC2       : 1;
  __IO  uint8_t RLC3       : 1;
  __IO  uint8_t RLC4       : 1;
  __IO  uint8_t RLC5       : 1;
} stc_wc_wcrl_field_t;

typedef struct stc_wc_wccr_field
{
  __IO  uint8_t WCIF       : 1;
  __IO  uint8_t WCIE       : 1;
  __IO  uint8_t CS0        : 1;
  __IO  uint8_t CS1        : 1;
        uint8_t RESERVED1  : 2;
  __IO  uint8_t WCOP       : 1;
  __IO  uint8_t WCEN       : 1;
} stc_wc_wccr_field_t;

typedef struct stc_wc_clk_sel_field
{
  __IO uint16_t SEL_IN     : 2;
       uint16_t RESERVED1  : 6;
  __IO uint16_t SEL_OUT    : 3;
} stc_wc_clk_sel_field_t;

typedef struct stc_wc_clk_en_field
{
  __IO  uint8_t CLK_EN     : 1;
  __IO  uint8_t CLK_EN_R   : 1;
} stc_wc_clk_en_field_t;

/******************************************************************************
 * RTC_MODULE
 ******************************************************************************/
/* RTC_MODULE register bit fields */
/* RTC CNT */
typedef struct stc_rtc_wtcr10_field
{
  __IO  uint8_t ST         : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t RUN        : 1;
  __IO  uint8_t SRST       : 1;
  __IO  uint8_t SCST       : 1;
  __IO  uint8_t SCRST      : 1;
  __IO  uint8_t BUSY       : 1;
  __IO  uint8_t TRANS      : 1;
} stc_rtc_wtcr10_field_t;

typedef struct stc_rtc_wtcr11_field
{
  __IO  uint8_t MIEN       : 1;
  __IO  uint8_t HEN        : 1;
  __IO  uint8_t DEN        : 1;
  __IO  uint8_t MOEN       : 1;
  __IO  uint8_t YEN        : 1;
        uint8_t RESERVED1  : 3;
} stc_rtc_wtcr11_field_t;

typedef struct stc_rtc_wtcr12_field
{
  __IO  uint8_t INTSSI     : 1;
  __IO  uint8_t INTSI      : 1;
  __IO  uint8_t INTMI      : 1;
  __IO  uint8_t INTHI      : 1;
  __IO  uint8_t INTTMI     : 1;
  __IO  uint8_t INTALI     : 1;
  __IO  uint8_t INTERI     : 1;
  __IO  uint8_t INTCRI     : 1;
} stc_rtc_wtcr12_field_t;

typedef struct stc_rtc_wtcr13_field
{
  __IO  uint8_t INTSSIE    : 1;
  __IO  uint8_t INTSIE     : 1;
  __IO  uint8_t INTMIE     : 1;
  __IO  uint8_t INTHIE     : 1;
  __IO  uint8_t INTTMIE    : 1;
  __IO  uint8_t INTALIE    : 1;
  __IO  uint8_t INTERIE    : 1;
  __IO  uint8_t INTCRIE    : 1;
} stc_rtc_wtcr13_field_t;

typedef struct stc_rtc_wtcr20_field
{
  __IO  uint8_t CREAD      : 1;
  __IO  uint8_t CWRITE     : 1;
  __IO  uint8_t BREAD      : 1;
  __IO  uint8_t BWRITE     : 1;
  __IO  uint8_t PREAD      : 1;
  __IO  uint8_t PWRITE     : 1;
        uint8_t RESERVED1  : 2;
} stc_rtc_wtcr20_field_t;

typedef struct stc_rtc_wtcr21_field
{
  __IO  uint8_t TMST       : 1;
  __IO  uint8_t TMEN       : 1;
  __IO  uint8_t TMRUN      : 1;
        uint8_t RESERVED1  : 5;
} stc_rtc_wtcr21_field_t;

typedef struct stc_rtc_wtsr_field
{
  union {
    struct {
      __IO  uint8_t S          : 4;
      __IO  uint8_t TS         : 3;
            uint8_t RESERVED1  : 1;
    };
    struct {
      __IO  uint8_t S0         : 1;
      __IO  uint8_t S1         : 1;
      __IO  uint8_t S2         : 1;
      __IO  uint8_t S3         : 1;
      __IO  uint8_t TS0        : 1;
      __IO  uint8_t TS1        : 1;
      __IO  uint8_t TS2        : 1;
            uint8_t RESERVED2  : 1;
    };
  };
} stc_rtc_wtsr_field_t;

typedef struct stc_rtc_wtmir_field
{
  union {
    struct {
      __IO  uint8_t MI         : 4;
      __IO  uint8_t TMI        : 3;
            uint8_t RESERVED1  : 1;
    };
    struct {
      __IO  uint8_t MI0        : 1;
      __IO  uint8_t MI1        : 1;
      __IO  uint8_t MI2        : 1;
      __IO  uint8_t MI3        : 1;
      __IO  uint8_t TMI0       : 1;
      __IO  uint8_t TMI1       : 1;
      __IO  uint8_t TMI2       : 1;
            uint8_t RESERVED2  : 1;
    };
  };
} stc_rtc_wtmir_field_t;

typedef struct stc_rtc_wthr_field
{
  union {
    struct {
      __IO  uint8_t H          : 4;
      __IO  uint8_t TH         : 2;
            uint8_t RESERVED1  : 2;
    };
    struct {
      __IO  uint8_t H0         : 1;
      __IO  uint8_t H1         : 1;
      __IO  uint8_t H2         : 1;
      __IO  uint8_t H3         : 1;
      __IO  uint8_t TH0        : 1;
      __IO  uint8_t TH1        : 1;
            uint8_t RESERVED2  : 2;
    };
  };
} stc_rtc_wthr_field_t;

typedef struct stc_rtc_wtdr_field
{
  union {
    struct {
      __IO  uint8_t D          : 4;
      __IO  uint8_t TD         : 2;
            uint8_t RESERVED1  : 2;
    };
    struct {
      __IO  uint8_t D0         : 1;
      __IO  uint8_t D1         : 1;
      __IO  uint8_t D2         : 1;
      __IO  uint8_t D3         : 1;
      __IO  uint8_t TD0        : 1;
      __IO  uint8_t TD1        : 1;
            uint8_t RESERVED2  : 2;
    };
  };
} stc_rtc_wtdr_field_t;

typedef struct stc_rtc_wtdw_field
{
  union {
    struct {
      __IO  uint8_t DW         : 3;
            uint8_t RESERVED1  : 5;
    };
    struct {
      __IO  uint8_t DW0        : 1;
      __IO  uint8_t DW1        : 1;
      __IO  uint8_t DW2        : 1;
            uint8_t RESERVED2  : 5;
    };
  };
} stc_rtc_wtdw_field_t;

typedef struct stc_rtc_wtmor_field
{
  union {
    struct {
      __IO  uint8_t MO         : 4;
      __IO  uint8_t TMO        : 1;
            uint8_t RESERVED1  : 3;
    };
    struct {
      __IO  uint8_t MO0        : 1;
      __IO  uint8_t MO1        : 1;
      __IO  uint8_t MO2        : 1;
      __IO  uint8_t MO3        : 1;
            uint8_t RESERVED2  : 4;
    };
  };
} stc_rtc_wtmor_field_t;

typedef struct stc_rtc_wtyr_field
{
  union {
    struct {
      __IO  uint8_t Y          : 4;
      __IO  uint8_t TY         : 4;
    };
    struct {
      __IO  uint8_t Y0         : 1;
      __IO  uint8_t Y1         : 1;
      __IO  uint8_t Y2         : 1;
      __IO  uint8_t Y3         : 1;
      __IO  uint8_t TY0        : 1;
      __IO  uint8_t TY1        : 1;
      __IO  uint8_t TY2        : 1;
      __IO  uint8_t TY3        : 1;
    };
  };
} stc_rtc_wtyr_field_t;

typedef struct stc_rtc_almir_field
{
  union {
    struct {
      __IO  uint8_t AMI        : 4;
      __IO  uint8_t TAMI       : 3;
            uint8_t RESERVED1  : 1;
    };
    struct {
      __IO  uint8_t AMI0       : 1;
      __IO  uint8_t AMI1       : 1;
      __IO  uint8_t AMI2       : 1;
      __IO  uint8_t AMI3       : 1;
      __IO  uint8_t TAMI0      : 1;
      __IO  uint8_t TAMI1      : 1;
      __IO  uint8_t TAMI2      : 1;
            uint8_t RESERVED2  : 1;
    };
  };
} stc_rtc_almir_field_t;

typedef struct stc_rtc_alhr_field
{
  union {
    struct {
      __IO  uint8_t AH         : 4;
      __IO  uint8_t TAH        : 2;
            uint8_t RESERVED1  : 2;
    };
    struct {
      __IO  uint8_t AH0        : 1;
      __IO  uint8_t AH1        : 1;
      __IO  uint8_t AH2        : 1;
      __IO  uint8_t AH3        : 1;
      __IO  uint8_t TAH0       : 1;
      __IO  uint8_t TAH1       : 1;
            uint8_t RESERVED2  : 2;
    };
  };
} stc_rtc_alhr_field_t;

typedef struct stc_rtc_aldr_field
{
  union {
    struct {
      __IO  uint8_t AD         : 4;
      __IO  uint8_t TAD        : 2;
            uint8_t RESERVED1  : 2;
    };
    struct {
      __IO  uint8_t AD0        : 1;
      __IO  uint8_t AD1        : 1;
      __IO  uint8_t AD2        : 1;
      __IO  uint8_t AD3        : 1;
      __IO  uint8_t TAD0       : 1;
      __IO  uint8_t TAD1       : 1;
            uint8_t RESERVED2  : 2;
    };
  };
} stc_rtc_aldr_field_t;

typedef struct stc_rtc_almor_field
{
  union {
    struct {
      __IO  uint8_t AMO        : 4;
      __IO  uint8_t TAMO       : 1;
            uint8_t RESERVED1  : 3;
    };
    struct {
      __IO  uint8_t AMO0       : 1;
      __IO  uint8_t AMO1       : 1;
      __IO  uint8_t AMO2       : 1;
      __IO  uint8_t AMO3       : 1;
            uint8_t RESERVED2  : 4;
    };
  };
} stc_rtc_almor_field_t;

typedef struct stc_rtc_alyr_field
{
  union {
    struct {
      __IO  uint8_t AY         : 4;
      __IO  uint8_t TAY        : 4;
    };
    struct {
      __IO  uint8_t AY0        : 1;
      __IO  uint8_t AY1        : 1;
      __IO  uint8_t AY2        : 1;
      __IO  uint8_t AY3        : 1;
      __IO  uint8_t TAY0       : 1;
      __IO  uint8_t TAY1       : 1;
      __IO  uint8_t TAY2       : 1;
      __IO  uint8_t TAY3       : 1;
    };
  };
} stc_rtc_alyr_field_t;

typedef struct stc_rtc_wttr0_field
{
  __IO  uint8_t TM0        : 1;
  __IO  uint8_t TM1        : 1;
  __IO  uint8_t TM2        : 1;
  __IO  uint8_t TM3        : 1;
  __IO  uint8_t TM4        : 1;
  __IO  uint8_t TM5        : 1;
  __IO  uint8_t TM6        : 1;
  __IO  uint8_t TM7        : 1;
} stc_rtc_wttr0_field_t;

typedef struct stc_rtc_wttr1_field
{
  __IO  uint8_t TM8        : 1;
  __IO  uint8_t TM9        : 1;
  __IO  uint8_t TM10       : 1;
  __IO  uint8_t TM11       : 1;
  __IO  uint8_t TM12       : 1;
  __IO  uint8_t TM13       : 1;
  __IO  uint8_t TM14       : 1;
  __IO  uint8_t TM15       : 1;
} stc_rtc_wttr1_field_t;

typedef struct stc_rtc_wttr2_field
{
  __IO  uint8_t TM16       : 1;
  __IO  uint8_t TM17       : 1;
        uint8_t RESERVED1  : 6;
} stc_rtc_wttr2_field_t;

/* RTC CLK */
typedef struct stc_rtc_wtcal1_field
{
  union {
    struct {
      __IO  uint8_t WTCAL1     : 2;
            uint8_t RESERVED1  : 6;
    };
    struct {
      __IO  uint8_t WTCAL10    : 1;
      __IO  uint8_t WTCAL11    : 1;
            uint8_t RESERVED2  : 6;
    };
  };
} stc_rtc_wtcal1_field_t;

typedef struct stc_rtc_wtcalen_field
{
  __IO  uint8_t WTCALEN    : 1;
        uint8_t RESERVED1  : 7;
} stc_rtc_wtcalen_field_t;

typedef struct stc_rtc_wtdiv_field
{
  union {
    struct {
      __IO  uint8_t WTDIV      : 4;
            uint8_t RESERVED1  : 4;
    };
    struct {
      __IO  uint8_t WTDIV0     : 1;
      __IO  uint8_t WTDIV1     : 1;
      __IO  uint8_t WTDIV2     : 1;
      __IO  uint8_t WTDIV3     : 1;
            uint8_t RESERVED2  : 4;
    };
  };
} stc_rtc_wtdiv_field_t;

typedef struct stc_rtc_wtdiven_field
{
  __IO  uint8_t WTDIVEN    : 1;
  __IO  uint8_t WTDIVRDY   : 1;
        uint8_t RESERVED1  : 6;
} stc_rtc_wtdiven_field_t;

typedef struct stc_rtc_wtcalprd_field
{
  union {
    struct {
      __IO  uint8_t WTCALPRD   : 6;
            uint8_t RESERVED1  : 2;
    };
    struct {
      __IO  uint8_t WTCALPRD0  : 1;
      __IO  uint8_t WTCALPRD1  : 1;
      __IO  uint8_t WTCALPRD2  : 1;
      __IO  uint8_t WTCALPRD3  : 1;
      __IO  uint8_t WTCALPRD4  : 1;
      __IO  uint8_t WTCALPRD5  : 1;
            uint8_t RESERVED2  : 2;
    };
  };
} stc_rtc_wtcalprd_field_t;

typedef struct stc_rtc_wtcosel_field
{
  __IO  uint8_t WTCOSEL    : 1;
  __IO  uint8_t WTDIVRDY   : 7;
} stc_rtc_wtcosel_field_t;

/* VBVat Domain */
typedef struct stc_rtc_vb_clkdiv_field
{
  __IO  uint8_t DIV        : 8;
} stc_rtc_vb_clkdiv_field_t;

typedef struct stc_rtc_wtosccnt_field
{
  __IO  uint8_t SOSCEX     : 1;
  __IO  uint8_t SOSCNTL    : 1;
} stc_rtc_wtosccnt_field_t;

typedef struct stc_rtc_boost_field
{
  __IO  uint8_t BOOST      : 2;
} stc_rtc_boost_field_t;

typedef struct stc_rtc_ewkup_field
{
  __IO  uint8_t WUP0       : 1;
} stc_rtc_ewkup_field_t;

typedef struct stc_rtc_vdet_field
{
        uint8_t RESERVED0  : 7;
  __IO  uint8_t PON        : 1;
} stc_rtc_vdet_field_t;

typedef struct stc_rtc_hibrst_field
{
  __IO  uint8_t HIBRST     : 1;
} stc_rtc_hibrst_field_t;

typedef struct stc_rtc_vbpfr_field
{
  __IO  uint8_t VPFR0      : 1;
  __IO  uint8_t VPFR1      : 1;
  __IO  uint8_t VPFR2      : 1;
  __IO  uint8_t VPFR3      : 1;
  __IO  uint8_t SPSR0      : 1;
  __IO  uint8_t SPSR1      : 1;
} stc_rtc_vbpfr_field_t;

typedef struct stc_rtc_vbpcr_field
{
  __IO  uint8_t VPCR0      : 1;
  __IO  uint8_t VPCR1      : 1;
  __IO  uint8_t VPCR2      : 1;
  __IO  uint8_t VPCR3      : 1;
} stc_rtc_vbpcr_field_t;

typedef struct stc_rtc_vbddr_field
{
  __IO  uint8_t VDDR0      : 1;
  __IO  uint8_t VDDR1      : 1;
  __IO  uint8_t VDDR2      : 1;
  __IO  uint8_t VDDR3      : 1;
} stc_rtc_vbddr_field_t;

typedef struct stc_rtc_vbdir_field
{
  __IO  uint8_t VDIR0      : 1;
  __IO  uint8_t VDIR1      : 1;
  __IO  uint8_t VDIR2      : 1;
  __IO  uint8_t VDIR3      : 1;
} stc_rtc_vbdir_field_t;

typedef struct stc_rtc_vbdor_field
{
  __IO  uint8_t VDOR0      : 1;
  __IO  uint8_t VDOR1      : 1;
  __IO  uint8_t VDOR2      : 1;
  __IO  uint8_t VDOR3      : 1;
} stc_rtc_vbdor_field_t;

typedef struct stc_rtc_vbpzr_field
{
  __IO  uint8_t VPZR0      : 1;
  __IO  uint8_t VPZR1      : 1;
} stc_rtc_vbpzr_field_t;

/******************************************************************************
 * LCR_MODULE
 ******************************************************************************/
/* LCR_MODULE register bit fields */
typedef struct stc_lcr_lcr_prsld_field
{
  __IO  uint8_t LCR_PRSLD  : 6;
} stc_lcr_lcr_prsld_field_t;

/******************************************************************************
 * CLK_GATING_MODULE
 ******************************************************************************/
/* CLK_GATING_MODULE register bit fields */
typedef struct stc_clk_gating_cken0_field
{
  __IO uint32_t MFSCK0     : 1;
  __IO uint32_t MFSCK1     : 1;
  __IO uint32_t MFSCK2     : 1;
  __IO uint32_t MFSCK3     : 1;
  __IO uint32_t MFSCK4     : 1;
  __IO uint32_t MFSCK5     : 1;
  __IO uint32_t MFSCK6     : 1;
  __IO uint32_t MFSCK7     : 1;
  __IO uint32_t MFSCK8     : 1;
  __IO uint32_t MFSCK9     : 1;
  __IO uint32_t MFSCK10    : 1;
  __IO uint32_t MFSCK11    : 1;
  __IO uint32_t MFSCK12    : 1;
  __IO uint32_t MFSCK13    : 1;
  __IO uint32_t MFSCK14    : 1;
  __IO uint32_t MFSCK15    : 1;
  __IO uint32_t ADCCK0     : 1;
  __IO uint32_t ADCCK1     : 1;
  __IO uint32_t ADCCK2     : 1;
  __IO uint32_t ADCCK3     : 1;
       uint32_t RESERVED1  : 4;
  __IO uint32_t DMACK      : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t EXBCK      : 1;
       uint32_t RESERVED3  : 1;
  __IO uint32_t GIOCK      : 1;
} stc_clk_gating_cken0_field_t;

typedef struct stc_clk_gating_mrst0_field
{
  __IO uint32_t MFSRST0    : 1;
  __IO uint32_t MFSRST1    : 1;
  __IO uint32_t MFSRST2    : 1;
  __IO uint32_t MFSRST3    : 1;
  __IO uint32_t MFSRST4    : 1;
  __IO uint32_t MFSRST5    : 1;
  __IO uint32_t MFSRST6    : 1;
  __IO uint32_t MFSRST7    : 1;
  __IO uint32_t MFSRST8    : 1;
  __IO uint32_t MFSRST9    : 1;
  __IO uint32_t MFSRST10   : 1;
  __IO uint32_t MFSRST11   : 1;
  __IO uint32_t MFSRST12   : 1;
  __IO uint32_t MFSRST13   : 1;
  __IO uint32_t MFSRST14   : 1;
  __IO uint32_t MFSRST15   : 1;
  __IO uint32_t ADCRST0    : 1;
  __IO uint32_t ADCRST1    : 1;
  __IO uint32_t ADCRST2    : 1;
  __IO uint32_t ADCRST3    : 1;
       uint32_t RESERVED1  : 4;
  __IO uint32_t DMARST     : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t EXBRST     : 1;
} stc_clk_gating_mrst0_field_t;

typedef struct stc_clk_gating_cken1_field
{
  __IO uint32_t BTMCK0     : 1;
  __IO uint32_t BTMCK1     : 1;
  __IO uint32_t BTMCK2     : 1;
  __IO uint32_t BTMCK3     : 1;
       uint32_t RESERVED1  : 4;
  __IO uint32_t MFTCK0     : 1;
  __IO uint32_t MFTCK1     : 1;
  __IO uint32_t MFTCK2     : 1;
  __IO uint32_t MFTCK3     : 1;
       uint32_t RESERVED2  : 4;
  __IO uint32_t QDUCK0     : 1;
  __IO uint32_t QDUCK1     : 1;
  __IO uint32_t QDUCK2     : 1;
  __IO uint32_t QDUCK3     : 1;
} stc_clk_gating_cken1_field_t;

typedef struct stc_clk_gating_mrst1_field
{
  __IO uint32_t BTMRST0    : 1;
  __IO uint32_t BTMRST1    : 1;
  __IO uint32_t BTMRST2    : 1;
  __IO uint32_t BTMRST3    : 1;
       uint32_t RESERVED1  : 4;
  __IO uint32_t MFTRST0    : 1;
  __IO uint32_t MFTRST1    : 1;
  __IO uint32_t MFTRST2    : 1;
  __IO uint32_t MFTRST3    : 1;
       uint32_t RESERVED2  : 4;
  __IO uint32_t QDURST0    : 1;
  __IO uint32_t QDURST1    : 1;
  __IO uint32_t QDURST2    : 1;
  __IO uint32_t QDURST3    : 1;
} stc_clk_gating_mrst1_field_t;

typedef struct stc_clk_gating_cken2_field
{
  __IO uint32_t USBCK0     : 1;
  __IO uint32_t USBCK1     : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t CANCK0     : 1;
  __IO uint32_t CANCK1     : 1;
  __IO uint32_t CANCK2     : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t SDCCK      : 1;
       uint32_t RESERVED3  : 7;
  __IO uint32_t I2SCK0     : 1;
  __IO uint32_t I2SCK1     : 1;
       uint32_t RESERVED4  : 2;
  __IO uint32_t PCRCCK     : 1;
       uint32_t RESERVED5  : 3;
  __IO uint32_t CECCK0     : 1;
  __IO uint32_t CECCK1     : 1;
       uint32_t RESERVED6  : 2;
  __IO uint32_t QSPICK     : 1;
} stc_clk_gating_cken2_field_t;

typedef struct stc_clk_gating_mrst2_field
{
  __IO uint32_t USBRST0    : 1;
  __IO uint32_t USBRST1    : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t CANRST0    : 1;
  __IO uint32_t CANRST1    : 1;
  __IO uint32_t CANRST2    : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t SDCRST     : 1;
       uint32_t RESERVED3  : 7;
  __IO uint32_t I2SRST0    : 1;
  __IO uint32_t I2SRST1    : 1;
       uint32_t RESERVED4  : 2;
  __IO uint32_t PCRCRST    : 1;
       uint32_t RESERVED5  : 3;
  __IO uint32_t CECRST0    : 1;
  __IO uint32_t CECRST1    : 1;
       uint32_t RESERVED6  : 2;
  __IO uint32_t QSPIRST    : 1;
} stc_clk_gating_mrst2_field_t;

/******************************************************************************
 * I2SPRE_MODULE
 ******************************************************************************/
/* I2SPRE_MODULE register bit fields */
typedef struct stc_i2spre_iccr_field
{
  __IO uint32_t ICEN       : 1;
  __IO uint32_t ICSEL      : 1;
} stc_i2spre_iccr_field_t;

typedef struct stc_i2spre_ipcr1_field
{
  __IO uint32_t IPLLEN     : 1;
} stc_i2spre_ipcr1_field_t;

typedef struct stc_i2spre_ipcr2_field
{
  __IO uint32_t IPOWT      : 3;
} stc_i2spre_ipcr2_field_t;

typedef struct stc_i2spre_ipcr3_field
{
  __IO uint32_t IPLLK      : 5;
} stc_i2spre_ipcr3_field_t;

typedef struct stc_i2spre_ipcr4_field
{
  __IO uint32_t IPLLN      : 7;
} stc_i2spre_ipcr4_field_t;

typedef struct stc_i2spre_ip_str_field
{
  __IO uint32_t IPRDY      : 1;
} stc_i2spre_ip_str_field_t;

typedef struct stc_i2spre_ipint_enr_field
{
  __IO uint32_t IPCSE      : 1;
} stc_i2spre_ipint_enr_field_t;

typedef struct stc_i2spre_ipint_clr_field
{
  __IO uint32_t IPCSC      : 1;
} stc_i2spre_ipint_clr_field_t;

typedef struct stc_i2spre_ipint_str_field
{
  __IO uint32_t IPCSI      : 1;
} stc_i2spre_ipint_str_field_t;

typedef struct stc_i2spre_ipcr5_field
{
  __IO uint32_t IPLLM      : 7;
} stc_i2spre_ipcr5_field_t;

/******************************************************************************
 * EXBUS_MODULE
 ******************************************************************************/
/* EXBUS_MODULE register bit fields */
typedef struct stc_exbus_mode_field
{
  __IO uint32_t WDTH       : 2;
  __IO uint32_t RBMON      : 1;
  __IO uint32_t WEOFF      : 1;
  __IO uint32_t NAND       : 1;
  __IO uint32_t PAGE       : 1;
  __IO uint32_t RDY        : 1;
  __IO uint32_t SHRTDOUT   : 1;
  __IO uint32_t MPXMODE    : 1;
  __IO uint32_t ALEINV     : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t MPXDOFF    : 1;
  __IO uint32_t MPXCSOF    : 1;
  __IO uint32_t MOEXEUP    : 1;
       uint32_t RESERVED2  : 18;
} stc_exbus_mode_field_t;

typedef struct stc_exbus_tim_field
{
  __IO uint32_t RACC       : 4;
  __IO uint32_t RADC       : 4;
  __IO uint32_t FRADC      : 4;
  __IO uint32_t RIDLC      : 4;
  __IO uint32_t WACC       : 4;
  __IO uint32_t WADC       : 4;
  __IO uint32_t WWEC       : 4;
  __IO uint32_t WIDLC      : 4;
} stc_exbus_tim_field_t;

typedef struct stc_exbus_area_field
{
  __IO uint32_t ADDR       : 8;
       uint32_t RESERVED1  : 8;
  __IO uint32_t MASK       : 7;
       uint32_t RESERVED2  : 9;
} stc_exbus_area_field_t;

typedef struct stc_exbus_atim_field
{
  __IO uint32_t ALC        : 4;
  __IO uint32_t ALES       : 4;
  __IO uint32_t ALEW       : 4;
       uint32_t RESERVED0  : 20;
} stc_exbus_atim_field_t;

typedef struct stc_exbus_sdmode_field
{
  __IO uint32_t SDON       : 1;
  __IO uint32_t PDON       : 1;
  __IO uint32_t ROFF       : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t CASEL      : 2;
       uint32_t RESERVED2  : 2;
  __IO uint32_t RASEL      : 4;
  __IO uint32_t BASEL      : 4;
  __IO uint32_t MSDCLKOFF  : 1;
       uint32_t RESERVED3  : 15;
} stc_exbus_sdmode_field_t;

typedef struct stc_exbus_reftim_field
{
  __IO uint32_t REFC       : 16;
  __IO uint32_t NREF       : 8;
  __IO uint32_t PREF       : 1;
       uint32_t RESERVED0  : 7;
} stc_exbus_reftim_field_t;

typedef struct stc_exbus_pwrdwn_field
{
  __IO uint32_t PDC        : 16;
       uint32_t RESERVED0  : 16;
} stc_exbus_pwrdwn_field_t;

typedef struct stc_exbus_sdtim_field
{
  __IO uint32_t CL         : 2;
       uint32_t RESERVED1  : 2;
  __IO uint32_t TRC        : 4;
  __IO uint32_t TRP        : 4;
  __IO uint32_t TRCD       : 4;
  __IO uint32_t TRAS       : 4;
  __IO uint32_t TREFC      : 4;
  __IO uint32_t TDPL       : 2;
       uint32_t RESERVED2  : 5;
  __IO uint32_t BOFF       : 1;
} stc_exbus_sdtim_field_t;

typedef struct stc_exbus_sdcmd_field
{
  __IO uint32_t SDAD       : 16;
  __IO uint32_t SDWE       : 1;
  __IO uint32_t SDCAS      : 1;
  __IO uint32_t SDRAS      : 1;
  __IO uint32_t SDCS       : 1;
  __IO uint32_t SDCKE      : 1;
       uint32_t RESERVED1  : 10;
  __IO uint32_t PEND       : 1;
} stc_exbus_sdcmd_field_t;

typedef struct stc_exbus_memcerr_field
{
  __IO uint32_t SFER       : 1;
  __IO uint32_t SDER       : 1;
  __IO uint32_t SFION      : 1;
  __IO uint32_t SDION      : 1;
       uint32_t RESERVED0  : 28;
} stc_exbus_memcerr_field_t;

typedef struct stc_exbus_dclkr_field
{
  __IO uint32_t MDIV       : 4;
  __IO uint32_t MCLKON     : 1;
       uint32_t RESERVED0  : 27;
} stc_exbus_dclkr_field_t;

typedef struct stc_exbus_est_field
{
  __IO uint32_t WERR       : 1;
       uint32_t RESERVED0  : 31;
} stc_exbus_est_field_t;

typedef struct stc_exbus_wead_field
{
  __IO uint32_t ADDR       : 32;
} stc_exbus_wead_field_t;

typedef struct stc_exbus_esclr_field
{
  __IO uint32_t WERRCLR    : 1;
       uint32_t RESERVED0  : 31;
} stc_exbus_esclr_field_t;

typedef struct stc_exbus_amode_field
{
  __IO uint32_t WAEN       : 1;
       uint32_t RESERVED0  : 31;
} stc_exbus_amode_field_t;

/******************************************************************************
 * USB_MODULE
 ******************************************************************************/
/* USB_MODULE register bit fields */
typedef struct stc_usb_hcnt_field
{
  __IO uint16_t HOST       : 1;
  __IO uint16_t URST       : 1;
  __IO uint16_t SOFIRE     : 1;
  __IO uint16_t DIRE       : 1;
  __IO uint16_t CNNIRE     : 1;
  __IO uint16_t CMPIRE     : 1;
  __IO uint16_t URIRE      : 1;
  __IO uint16_t RWKIRE     : 1;
  __IO uint16_t RETRY      : 1;
  __IO uint16_t CANCEL     : 1;
  __IO uint16_t SOFSTEP    : 1;
} stc_usb_hcnt_field_t;

typedef struct stc_usb_hcnt0_field
{
  __IO  uint8_t HOST       : 1;
  __IO  uint8_t URST       : 1;
  __IO  uint8_t SOFIRE     : 1;
  __IO  uint8_t DIRE       : 1;
  __IO  uint8_t CNNIRE     : 1;
  __IO  uint8_t CMPIRE     : 1;
  __IO  uint8_t URIRE      : 1;
  __IO  uint8_t RWKIRE     : 1;
} stc_usb_hcnt0_field_t;

typedef struct stc_usb_hcnt1_field
{
  __IO  uint8_t RETRY      : 1;
  __IO  uint8_t CANCEL     : 1;
  __IO  uint8_t SOFSTEP    : 1;
} stc_usb_hcnt1_field_t;

typedef struct stc_usb_hirq_field
{
  __IO  uint8_t SOFIRQ     : 1;
  __IO  uint8_t DIRQ       : 1;
  __IO  uint8_t CNNIRQ     : 1;
  __IO  uint8_t CMPIRQ     : 1;
  __IO  uint8_t URIRQ      : 1;
  __IO  uint8_t RWKIRQ     : 1;
        uint8_t RESERVED1  : 1;
  __IO  uint8_t TCAN       : 1;
} stc_usb_hirq_field_t;

typedef struct stc_usb_herr_field
{
  __IO  uint8_t HS0        : 1;
  __IO  uint8_t HS1        : 1;
  __IO  uint8_t STUFF      : 1;
  __IO  uint8_t TGERR      : 1;
  __IO  uint8_t CRC        : 1;
  __IO  uint8_t TOUT       : 1;
  __IO  uint8_t RERR       : 1;
  __IO  uint8_t LSTOF      : 1;
} stc_usb_herr_field_t;

typedef struct stc_usb_hstate_field
{
  __IO  uint8_t CSTAT      : 1;
  __IO  uint8_t TMODE      : 1;
  __IO  uint8_t SUSP       : 1;
  __IO  uint8_t SOFBUSY    : 1;
  __IO  uint8_t CLKSEL     : 1;
  __IO  uint8_t ALIVE      : 1;
} stc_usb_hstate_field_t;

typedef struct stc_usb_hfcomp_field
{
  __IO  uint8_t FRAMECOMP0 : 1;
  __IO  uint8_t FRAMECOMP1 : 1;
  __IO  uint8_t FRAMECOMP2 : 1;
  __IO  uint8_t FRAMECOMP3 : 1;
  __IO  uint8_t FRAMECOMP4 : 1;
  __IO  uint8_t FRAMECOMP5 : 1;
  __IO  uint8_t FRAMECOMP6 : 1;
  __IO  uint8_t FRAMECOMP7 : 1;
} stc_usb_hfcomp_field_t;

typedef struct stc_usb_hrtimer_field
{
  __IO uint16_t RTIMER0    : 1;
  __IO uint16_t RTIMER1    : 1;
  __IO uint16_t RTIMER2    : 1;
  __IO uint16_t RTIMER3    : 1;
  __IO uint16_t RTIMER4    : 1;
  __IO uint16_t RTIMER5    : 1;
  __IO uint16_t RTIMER6    : 1;
  __IO uint16_t RTIMER7    : 1;
  __IO uint16_t RTIMER8    : 1;
  __IO uint16_t RTIMER9    : 1;
  __IO uint16_t RTIMER10   : 1;
  __IO uint16_t RTIMER11   : 1;
  __IO uint16_t RTIMER12   : 1;
  __IO uint16_t RTIMER13   : 1;
  __IO uint16_t RTIMER14   : 1;
  __IO uint16_t RTIMER15   : 1;
} stc_usb_hrtimer_field_t;

typedef struct stc_usb_hrtimer0_field
{
  __IO  uint8_t RTIMER00   : 1;
  __IO  uint8_t RTIMER01   : 1;
  __IO  uint8_t RTIMER02   : 1;
  __IO  uint8_t RTIMER03   : 1;
  __IO  uint8_t RTIMER04   : 1;
  __IO  uint8_t RTIMER05   : 1;
  __IO  uint8_t RTIMER06   : 1;
  __IO  uint8_t RTIMER07   : 1;
} stc_usb_hrtimer0_field_t;

typedef struct stc_usb_hrtimer1_field
{
  __IO  uint8_t RTIMER10   : 1;
  __IO  uint8_t RTIMER11   : 1;
  __IO  uint8_t RTIMER12   : 1;
  __IO  uint8_t RTIMER13   : 1;
  __IO  uint8_t RTIMER14   : 1;
  __IO  uint8_t RTIMER15   : 1;
  __IO  uint8_t RTIMER16   : 1;
  __IO  uint8_t RTIMER17   : 1;
} stc_usb_hrtimer1_field_t;

typedef struct stc_usb_hrtimer2_field
{
  __IO  uint8_t RTIMER20   : 1;
  __IO  uint8_t RTIMER21   : 1;
  __IO  uint8_t RTIMER22   : 1;
} stc_usb_hrtimer2_field_t;

typedef struct stc_usb_hadr_field
{
  __IO  uint8_t ADDRESS0   : 1;
  __IO  uint8_t ADDRESS1   : 1;
  __IO  uint8_t ADDRESS2   : 1;
  __IO  uint8_t ADDRESS3   : 1;
  __IO  uint8_t ADDRESS4   : 1;
  __IO  uint8_t ADDRESS5   : 1;
  __IO  uint8_t ADDRESS6   : 1;
} stc_usb_hadr_field_t;

typedef struct stc_usb_heof_field
{
  __IO uint16_t EOF0       : 1;
  __IO uint16_t EOF1       : 1;
  __IO uint16_t EOF2       : 1;
  __IO uint16_t EOF3       : 1;
  __IO uint16_t EOF4       : 1;
  __IO uint16_t EOF5       : 1;
  __IO uint16_t EOF6       : 1;
  __IO uint16_t EOF7       : 1;
  __IO uint16_t EOF8       : 1;
  __IO uint16_t EOF9       : 1;
  __IO uint16_t EOF10      : 1;
  __IO uint16_t EOF11      : 1;
  __IO uint16_t EOF12      : 1;
  __IO uint16_t EOF13      : 1;
  __IO uint16_t EOF14      : 1;
  __IO uint16_t EOF15      : 1;
} stc_usb_heof_field_t;

typedef struct stc_usb_heof0_field
{
  __IO  uint8_t EOF00      : 1;
  __IO  uint8_t EOF01      : 1;
  __IO  uint8_t EOF02      : 1;
  __IO  uint8_t EOF03      : 1;
  __IO  uint8_t EOF04      : 1;
  __IO  uint8_t EOF05      : 1;
  __IO  uint8_t EOF06      : 1;
  __IO  uint8_t EOF07      : 1;
} stc_usb_heof0_field_t;

typedef struct stc_usb_heof1_field
{
  __IO  uint8_t EOF10      : 1;
  __IO  uint8_t EOF11      : 1;
  __IO  uint8_t EOF12      : 1;
  __IO  uint8_t EOF13      : 1;
  __IO  uint8_t EOF14      : 1;
  __IO  uint8_t EOF15      : 1;
} stc_usb_heof1_field_t;

typedef struct stc_usb_hframe_field
{
  __IO uint16_t FRAME0     : 1;
  __IO uint16_t FRAME1     : 1;
  __IO uint16_t FRAME2     : 1;
  __IO uint16_t FRAME3     : 1;
  __IO uint16_t FRAME4     : 1;
  __IO uint16_t FRAME5     : 1;
  __IO uint16_t FRAME6     : 1;
  __IO uint16_t FRAME7     : 1;
  __IO uint16_t FRAME8     : 1;
  __IO uint16_t FRAME9     : 1;
  __IO uint16_t FRAME10    : 1;
} stc_usb_hframe_field_t;

typedef struct stc_usb_hframe0_field
{
  __IO  uint8_t FRAME00    : 1;
  __IO  uint8_t FRAME01    : 1;
  __IO  uint8_t FRAME02    : 1;
  __IO  uint8_t FRAME03    : 1;
  __IO  uint8_t FRAME04    : 1;
  __IO  uint8_t FRAME05    : 1;
  __IO  uint8_t FRAME06    : 1;
  __IO  uint8_t FRAME07    : 1;
} stc_usb_hframe0_field_t;

typedef struct stc_usb_hframe1_field
{
  __IO  uint8_t FRAME10    : 1;
  __IO  uint8_t FRAME11    : 1;
  __IO  uint8_t FRAME12    : 1;
  __IO  uint8_t FRAME13    : 1;
} stc_usb_hframe1_field_t;

typedef struct stc_usb_htoken_field
{
  __IO  uint8_t ENDPT0     : 1;
  __IO  uint8_t ENDPT1     : 1;
  __IO  uint8_t ENDPT2     : 1;
  __IO  uint8_t ENDPT3     : 1;
  __IO  uint8_t TKNEN0     : 1;
  __IO  uint8_t TKNEN1     : 1;
  __IO  uint8_t TKNEN2     : 1;
  __IO  uint8_t TGGL       : 1;
} stc_usb_htoken_field_t;

typedef struct stc_usb_udcc_field
{
  __IO uint16_t PWC        : 1;
  __IO uint16_t RFBK       : 1;
       uint16_t RESERVED1  : 1;
  __IO uint16_t STALCLREN  : 1;
  __IO uint16_t USTP       : 1;
  __IO uint16_t HCONX      : 1;
  __IO uint16_t RESUM      : 1;
  __IO uint16_t RST        : 1;
} stc_usb_udcc_field_t;

typedef struct stc_usb_ep0c_field
{
  __IO uint16_t PKS00      : 1;
  __IO uint16_t PKS01      : 1;
  __IO uint16_t PKS02      : 1;
  __IO uint16_t PKS03      : 1;
  __IO uint16_t PKS04      : 1;
  __IO uint16_t PKS05      : 1;
  __IO uint16_t PKS06      : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t STAL       : 1;
} stc_usb_ep0c_field_t;

typedef struct stc_usb_ep1c_field
{
  __IO uint16_t PKS10      : 1;
  __IO uint16_t PKS11      : 1;
  __IO uint16_t PKS12      : 1;
  __IO uint16_t PKS13      : 1;
  __IO uint16_t PKS14      : 1;
  __IO uint16_t PKS15      : 1;
  __IO uint16_t PKS16      : 1;
  __IO uint16_t PKS17      : 1;
  __IO uint16_t PKS18      : 1;
  __IO uint16_t STAL       : 1;
  __IO uint16_t NULE       : 1;
  __IO uint16_t DMAE       : 1;
  __IO uint16_t DIR        : 1;
  __IO uint16_t TYPE0      : 1;
  __IO uint16_t TYPE1      : 1;
  __IO uint16_t EPEN       : 1;
} stc_usb_ep1c_field_t;

typedef struct stc_usb_ep2c_field
{
  __IO uint16_t PKS20      : 1;
  __IO uint16_t PKS21      : 1;
  __IO uint16_t PKS22      : 1;
  __IO uint16_t PKS23      : 1;
  __IO uint16_t PKS24      : 1;
  __IO uint16_t PKS25      : 1;
  __IO uint16_t PKS26      : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t STAL       : 1;
  __IO uint16_t NULE       : 1;
  __IO uint16_t DMAE       : 1;
  __IO uint16_t DIR        : 1;
  __IO uint16_t TYPE0      : 1;
  __IO uint16_t TYPE1      : 1;
  __IO uint16_t EPEN       : 1;
} stc_usb_ep2c_field_t;

typedef struct stc_usb_ep3c_field
{
  __IO uint16_t PKS30      : 1;
  __IO uint16_t PKS31      : 1;
  __IO uint16_t PKS32      : 1;
  __IO uint16_t PKS33      : 1;
  __IO uint16_t PKS34      : 1;
  __IO uint16_t PKS35      : 1;
  __IO uint16_t PKS36      : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t STAL       : 1;
  __IO uint16_t NULE       : 1;
  __IO uint16_t DMAE       : 1;
  __IO uint16_t DIR        : 1;
  __IO uint16_t TYPE0      : 1;
  __IO uint16_t TYPE1      : 1;
  __IO uint16_t EPEN       : 1;
} stc_usb_ep3c_field_t;

typedef struct stc_usb_ep4c_field
{
  __IO uint16_t PKS40      : 1;
  __IO uint16_t PKS41      : 1;
  __IO uint16_t PKS42      : 1;
  __IO uint16_t PKS43      : 1;
  __IO uint16_t PKS44      : 1;
  __IO uint16_t PKS45      : 1;
  __IO uint16_t PKS46      : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t STAL       : 1;
  __IO uint16_t NULE       : 1;
  __IO uint16_t DMAE       : 1;
  __IO uint16_t DIR        : 1;
  __IO uint16_t TYPE0      : 1;
  __IO uint16_t TYPE1      : 1;
  __IO uint16_t EPEN       : 1;
} stc_usb_ep4c_field_t;

typedef struct stc_usb_ep5c_field
{
  __IO uint16_t PKS50      : 1;
  __IO uint16_t PKS51      : 1;
  __IO uint16_t PKS52      : 1;
  __IO uint16_t PKS53      : 1;
  __IO uint16_t PKS54      : 1;
  __IO uint16_t PKS55      : 1;
  __IO uint16_t PKS56      : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t STAL       : 1;
  __IO uint16_t NULE       : 1;
  __IO uint16_t DMAE       : 1;
  __IO uint16_t DIR        : 1;
  __IO uint16_t TYPE0      : 1;
  __IO uint16_t TYPE1      : 1;
  __IO uint16_t EPEN       : 1;
} stc_usb_ep5c_field_t;

typedef struct stc_usb_tmsp_field
{
  __IO uint16_t TMSP0      : 1;
  __IO uint16_t TMSP1      : 1;
  __IO uint16_t TMSP2      : 1;
  __IO uint16_t TMSP3      : 1;
  __IO uint16_t TMSP4      : 1;
  __IO uint16_t TMSP5      : 1;
  __IO uint16_t TMSP6      : 1;
  __IO uint16_t TMSP7      : 1;
  __IO uint16_t TMSP8      : 1;
  __IO uint16_t TMSP9      : 1;
  __IO uint16_t TMSP10     : 1;
} stc_usb_tmsp_field_t;

typedef struct stc_usb_udcs_field
{
  __IO  uint8_t CONF       : 1;
  __IO  uint8_t SETP       : 1;
  __IO  uint8_t WKUP       : 1;
  __IO  uint8_t BRST       : 1;
  __IO  uint8_t SOF        : 1;
  __IO  uint8_t SUSP       : 1;
} stc_usb_udcs_field_t;

typedef struct stc_usb_udcie_field
{
  __IO  uint8_t CONFIE     : 1;
  __IO  uint8_t CONFN      : 1;
  __IO  uint8_t WKUPIE     : 1;
  __IO  uint8_t BRSTIE     : 1;
  __IO  uint8_t SOFIE      : 1;
  __IO  uint8_t SUSPIE     : 1;
} stc_usb_udcie_field_t;

typedef struct stc_usb_ep0is_field
{
       uint16_t RESERVED1  : 10;
  __IO uint16_t DRQI       : 1;
       uint16_t RESERVED2  : 3;
  __IO uint16_t DRQIIE     : 1;
  __IO uint16_t BFINI      : 1;
} stc_usb_ep0is_field_t;

typedef struct stc_usb_ep0os_field
{
  __IO uint16_t SIZE0      : 1;
  __IO uint16_t SIZE1      : 1;
  __IO uint16_t SIZE2      : 1;
  __IO uint16_t SIZE3      : 1;
  __IO uint16_t SIZE4      : 1;
  __IO uint16_t SIZE5      : 1;
  __IO uint16_t SIZE6      : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t SPK        : 1;
  __IO uint16_t DRQO       : 1;
       uint16_t RESERVED2  : 2;
  __IO uint16_t SPKIE      : 1;
  __IO uint16_t DRQOIE     : 1;
  __IO uint16_t BFINI      : 1;
} stc_usb_ep0os_field_t;

typedef struct stc_usb_ep1s_field
{
  __IO uint16_t SIZE10     : 1;
  __IO uint16_t SIZE11     : 1;
  __IO uint16_t SIZE12     : 1;
  __IO uint16_t SIZE13     : 1;
  __IO uint16_t SIZE14     : 1;
  __IO uint16_t SIZE15     : 1;
  __IO uint16_t SIZE16     : 1;
  __IO uint16_t SIZE17     : 1;
  __IO uint16_t SIZE18     : 1;
  __IO uint16_t SPK        : 1;
  __IO uint16_t DRQ        : 1;
  __IO uint16_t BUSY       : 1;
       uint16_t RESERVED1  : 1;
  __IO uint16_t SPKIE      : 1;
  __IO uint16_t DRQIE      : 1;
  __IO uint16_t BFINI      : 1;
} stc_usb_ep1s_field_t;

typedef struct stc_usb_ep2s_field
{
  __IO uint16_t SIZE20     : 1;
  __IO uint16_t SIZE21     : 1;
  __IO uint16_t SIZE22     : 1;
  __IO uint16_t SIZE23     : 1;
  __IO uint16_t SIZE24     : 1;
  __IO uint16_t SIZE25     : 1;
  __IO uint16_t SIZE26     : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t SPK        : 1;
  __IO uint16_t DRQ        : 1;
  __IO uint16_t BUSY       : 1;
       uint16_t RESERVED2  : 1;
  __IO uint16_t SPKIE      : 1;
  __IO uint16_t DRQIE      : 1;
  __IO uint16_t BFINI      : 1;
} stc_usb_ep2s_field_t;

typedef struct stc_usb_ep4s_field
{
  __IO uint16_t SIZE40     : 1;
  __IO uint16_t SIZE41     : 1;
  __IO uint16_t SIZE42     : 1;
  __IO uint16_t SIZE43     : 1;
  __IO uint16_t SIZE44     : 1;
  __IO uint16_t SIZE45     : 1;
  __IO uint16_t SIZE46     : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t SPK        : 1;
  __IO uint16_t DRQ        : 1;
  __IO uint16_t BUSY       : 1;
       uint16_t RESERVED2  : 1;
  __IO uint16_t SPKIE      : 1;
  __IO uint16_t DRQIE      : 1;
  __IO uint16_t BFINI      : 1;
} stc_usb_ep4s_field_t;

typedef struct stc_usb_ep5s_field
{
  __IO uint16_t SIZE50     : 1;
  __IO uint16_t SIZE51     : 1;
  __IO uint16_t SIZE52     : 1;
  __IO uint16_t SIZE53     : 1;
  __IO uint16_t SIZE54     : 1;
  __IO uint16_t SIZE55     : 1;
  __IO uint16_t SIZE56     : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t SPK        : 1;
  __IO uint16_t DRQ        : 1;
  __IO uint16_t BUSY       : 1;
       uint16_t RESERVED2  : 1;
  __IO uint16_t SPKIE      : 1;
  __IO uint16_t DRQIE      : 1;
  __IO uint16_t BFINI      : 1;
} stc_usb_ep5s_field_t;

/******************************************************************************
 * DMAC_MODULE
 ******************************************************************************/
/* DMAC_MODULE register bit fields */
typedef struct stc_dmac_dmacr_field
{
       uint32_t RESERVED1  : 24;
  __IO uint32_t DH0        : 1;
  __IO uint32_t DH1        : 1;
  __IO uint32_t DH2        : 1;
  __IO uint32_t DH3        : 1;
  __IO uint32_t PR         : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t DS         : 1;
  __IO uint32_t DE         : 1;
} stc_dmac_dmacr_field_t;

typedef struct stc_dmac_dmaca0_field
{
  __IO uint32_t TC         : 16;
  __IO uint32_t BC         : 4;
       uint32_t RESERVED1  : 3;
  __IO uint32_t IS         : 6;
  __IO uint32_t ST         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t EB         : 1;
} stc_dmac_dmaca0_field_t;

typedef struct stc_dmac_dmacb0_field
{
  __IO uint32_t EM         : 1;
       uint32_t RESERVED1  : 15;
  __IO uint32_t SS         : 3;
  __IO uint32_t CI         : 1;
  __IO uint32_t EI         : 1;
  __IO uint32_t RD         : 1;
  __IO uint32_t RS         : 1;
  __IO uint32_t RC         : 1;
  __IO uint32_t FD         : 1;
  __IO uint32_t FS         : 1;
  __IO uint32_t TW         : 2;
  __IO uint32_t MS         : 2;
} stc_dmac_dmacb0_field_t;

typedef struct stc_dmac_dmaca1_field
{
  __IO uint32_t TC         : 16;
  __IO uint32_t BC         : 4;
       uint32_t RESERVED1  : 3;
  __IO uint32_t IS         : 6;
  __IO uint32_t ST         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t EB         : 1;
} stc_dmac_dmaca1_field_t;

typedef struct stc_dmac_dmacb1_field
{
  __IO uint32_t EM         : 1;
       uint32_t RESERVED1  : 15;
  __IO uint32_t SS         : 3;
  __IO uint32_t CI         : 1;
  __IO uint32_t EI         : 1;
  __IO uint32_t RD         : 1;
  __IO uint32_t RS         : 1;
  __IO uint32_t RC         : 1;
  __IO uint32_t FD         : 1;
  __IO uint32_t FS         : 1;
  __IO uint32_t TW         : 2;
  __IO uint32_t MS         : 2;
} stc_dmac_dmacb1_field_t;

typedef struct stc_dmac_dmaca2_field
{
  __IO uint32_t TC         : 16;
  __IO uint32_t BC         : 4;
       uint32_t RESERVED1  : 3;
  __IO uint32_t IS         : 6;
  __IO uint32_t ST         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t EB         : 1;
} stc_dmac_dmaca2_field_t;

typedef struct stc_dmac_dmacb2_field
{
  __IO uint32_t EM         : 1;
       uint32_t RESERVED1  : 15;
  __IO uint32_t SS         : 3;
  __IO uint32_t CI         : 1;
  __IO uint32_t EI         : 1;
  __IO uint32_t RD         : 1;
  __IO uint32_t RS         : 1;
  __IO uint32_t RC         : 1;
  __IO uint32_t FD         : 1;
  __IO uint32_t FS         : 1;
  __IO uint32_t TW         : 2;
  __IO uint32_t MS         : 2;
} stc_dmac_dmacb2_field_t;

typedef struct stc_dmac_dmaca3_field
{
  __IO uint32_t TC         : 16;
  __IO uint32_t BC         : 4;
       uint32_t RESERVED1  : 3;
  __IO uint32_t IS         : 6;
  __IO uint32_t ST         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t EB         : 1;
} stc_dmac_dmaca3_field_t;

typedef struct stc_dmac_dmacb3_field
{
  __IO uint32_t EM         : 1;
       uint32_t RESERVED1  : 15;
  __IO uint32_t SS         : 3;
  __IO uint32_t CI         : 1;
  __IO uint32_t EI         : 1;
  __IO uint32_t RD         : 1;
  __IO uint32_t RS         : 1;
  __IO uint32_t RC         : 1;
  __IO uint32_t FD         : 1;
  __IO uint32_t TW         : 2;
  __IO uint32_t MS         : 2;
} stc_dmac_dmacb3_field_t;

typedef struct stc_dmac_dmaca4_field
{
  __IO uint32_t TC         : 16;
  __IO uint32_t BC         : 4;
       uint32_t RESERVED1  : 3;
  __IO uint32_t IS         : 6;
  __IO uint32_t ST         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t EB         : 1;
} stc_dmac_dmaca4_field_t;

typedef struct stc_dmac_dmacb4_field
{
  __IO uint32_t EM         : 1;
       uint32_t RESERVED1  : 15;
  __IO uint32_t SS         : 3;
  __IO uint32_t CI         : 1;
  __IO uint32_t EI         : 1;
  __IO uint32_t RD         : 1;
  __IO uint32_t RS         : 1;
  __IO uint32_t RC         : 1;
  __IO uint32_t FD         : 1;
  __IO uint32_t FS         : 1;
  __IO uint32_t TW         : 2;
  __IO uint32_t MS         : 2;
} stc_dmac_dmacb4_field_t;

typedef struct stc_dmac_dmaca5_field
{
  __IO uint32_t TC         : 16;
  __IO uint32_t BC         : 4;
       uint32_t RESERVED1  : 3;
  __IO uint32_t IS         : 6;
  __IO uint32_t ST         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t EB         : 1;
} stc_dmac_dmaca5_field_t;

typedef struct stc_dmac_dmacb5_field
{
  __IO uint32_t EM         : 1;
       uint32_t RESERVED1  : 15;
  __IO uint32_t SS         : 3;
  __IO uint32_t CI         : 1;
  __IO uint32_t EI         : 1;
  __IO uint32_t RD         : 1;
  __IO uint32_t RS         : 1;
  __IO uint32_t RC         : 1;
  __IO uint32_t FD         : 1;
  __IO uint32_t FS         : 1;
  __IO uint32_t TW         : 2;
  __IO uint32_t MS         : 2;
} stc_dmac_dmacb5_field_t;

typedef struct stc_dmac_dmaca6_field
{
  __IO uint32_t TC         : 16;
  __IO uint32_t BC         : 4;
       uint32_t RESERVED1  : 3;
  __IO uint32_t IS         : 6;
  __IO uint32_t ST         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t EB         : 1;
} stc_dmac_dmaca6_field_t;

typedef struct stc_dmac_dmacb6_field
{
  __IO uint32_t EM         : 1;
       uint32_t RESERVED1  : 15;
  __IO uint32_t SS         : 3;
  __IO uint32_t CI         : 1;
  __IO uint32_t EI         : 1;
  __IO uint32_t RD         : 1;
  __IO uint32_t RS         : 1;
  __IO uint32_t RC         : 1;
  __IO uint32_t FD         : 1;
  __IO uint32_t FS         : 1;
  __IO uint32_t TW         : 2;
  __IO uint32_t MS         : 2;
} stc_dmac_dmacb6_field_t;

typedef struct stc_dmac_dmaca7_field
{
  __IO uint32_t TC         : 16;
  __IO uint32_t BC         : 4;
       uint32_t RESERVED1  : 3;
  __IO uint32_t IS         : 6;
  __IO uint32_t ST         : 1;
  __IO uint32_t PB         : 1;
  __IO uint32_t EB         : 1;
} stc_dmac_dmaca7_field_t;

typedef struct stc_dmac_dmacb7_field
{
  __IO uint32_t EM         : 1;
       uint32_t RESERVED1  : 15;
  __IO uint32_t SS         : 3;
  __IO uint32_t CI         : 1;
  __IO uint32_t EI         : 1;
  __IO uint32_t RD         : 1;
  __IO uint32_t RS         : 1;
  __IO uint32_t RC         : 1;
  __IO uint32_t FD         : 1;
  __IO uint32_t FS         : 1;
  __IO uint32_t TW         : 2;
  __IO uint32_t MS         : 2;
} stc_dmac_dmacb7_field_t;

/******************************************************************************
 * CAN_MODULE
 ******************************************************************************/
/* CAN_MODULE register bit fields */
typedef struct stc_can_ctrlr_field
{
  __IO uint16_t INIT       : 1;
  __IO uint16_t IE         : 1;
  __IO uint16_t SIE        : 1;
  __IO uint16_t EIE        : 1;
       uint16_t RESERVED1  : 1;
  __IO uint16_t DAR        : 1;
  __IO uint16_t CCE        : 1;
  __IO uint16_t TEST       : 1;
} stc_can_ctrlr_field_t;

typedef struct stc_can_statr_field
{
  __IO uint16_t LEC        : 3;
  __IO uint16_t TXOK       : 1;
  __IO uint16_t RXOK       : 1;
  __IO uint16_t EPASS      : 1;
  __IO uint16_t EWARN      : 1;
  __IO uint16_t BOFF       : 1;
} stc_can_statr_field_t;

typedef struct stc_can_errcnt_field
{
  __IO uint16_t TEC0       : 1;
  __IO uint16_t TEC1       : 1;
  __IO uint16_t TEC2       : 1;
  __IO uint16_t TEC3       : 1;
  __IO uint16_t TEC4       : 1;
  __IO uint16_t TEC5       : 1;
  __IO uint16_t TEC6       : 1;
  __IO uint16_t TEC7       : 1;
  __IO uint16_t REC0       : 1;
  __IO uint16_t REC1       : 1;
  __IO uint16_t REC2       : 1;
  __IO uint16_t REC3       : 1;
  __IO uint16_t REC4       : 1;
  __IO uint16_t REC5       : 1;
  __IO uint16_t REC6       : 1;
  __IO uint16_t RP         : 1;
} stc_can_errcnt_field_t;

typedef struct stc_can_btr_field
{
  __IO uint16_t BRP        : 6;
  __IO uint16_t SJW        : 2;
  __IO uint16_t TSEG1      : 4;
  __IO uint16_t TSEG2      : 3;
} stc_can_btr_field_t;

typedef struct stc_can_intr_field
{
  __IO uint16_t INTID0     : 1;
  __IO uint16_t INTID1     : 1;
  __IO uint16_t INTID2     : 1;
  __IO uint16_t INTID3     : 1;
  __IO uint16_t INTID4     : 1;
  __IO uint16_t INTID5     : 1;
  __IO uint16_t INTID6     : 1;
  __IO uint16_t INTID7     : 1;
  __IO uint16_t INTID8     : 1;
  __IO uint16_t INTID9     : 1;
  __IO uint16_t INTID10    : 1;
  __IO uint16_t INTID11    : 1;
  __IO uint16_t INTID12    : 1;
  __IO uint16_t INTID13    : 1;
  __IO uint16_t INTID14    : 1;
  __IO uint16_t INTID15    : 1;
} stc_can_intr_field_t;

typedef struct stc_can_testr_field
{
       uint16_t RESERVED1  : 2;
  __IO uint16_t BASIC      : 1;
  __IO uint16_t SILENT     : 1;
  __IO uint16_t LBACK      : 1;
  __IO uint16_t TX0        : 1;
  __IO uint16_t TX1        : 1;
  __IO uint16_t RX         : 1;
} stc_can_testr_field_t;

typedef struct stc_can_brper_field
{
  __IO uint16_t BRPE0      : 1;
  __IO uint16_t BRPE1      : 1;
  __IO uint16_t BRPE2      : 1;
  __IO uint16_t BRPE3      : 1;
} stc_can_brper_field_t;

typedef struct stc_can_if1creq_field
{
       uint16_t RESERVED1  : 15;
  __IO uint16_t BUSY       : 1;
} stc_can_if1creq_field_t;

typedef struct stc_can_if1cmsk_field
{
  __IO uint16_t DATAB      : 1;
  __IO uint16_t DATAA      : 1;
  __IO uint16_t NEWDAT     : 1;
  __IO uint16_t CIP        : 1;
  __IO uint16_t CONTROL    : 1;
  __IO uint16_t ARB        : 1;
  __IO uint16_t MASK       : 1;
  __IO uint16_t WRRD       : 1;
} stc_can_if1cmsk_field_t;

typedef struct stc_can_if1msk_field
{
  __IO uint32_t MSK        : 29;
       uint32_t RESERVED1  : 1;
  __IO uint32_t MDIR       : 1;
  __IO uint32_t MXTD       : 1;
} stc_can_if1msk_field_t;

typedef struct stc_can_if1msk2_field
{
       uint16_t RESERVED1  : 14;
  __IO uint16_t MDIR       : 1;
  __IO uint16_t MXTD       : 1;
} stc_can_if1msk2_field_t;

typedef struct stc_can_if1arb_field
{
  __IO uint32_t ID         : 29;
  __IO uint32_t DIR        : 1;
  __IO uint32_t XTD        : 1;
  __IO uint32_t MSGVAL     : 1;
} stc_can_if1arb_field_t;

typedef struct stc_can_if1arb2_field
{
       uint16_t RESERVED1  : 13;
  __IO uint16_t DIR        : 1;
  __IO uint16_t XTD        : 1;
  __IO uint16_t MSGVAL     : 1;
} stc_can_if1arb2_field_t;

typedef struct stc_can_if1mctr_field
{
  __IO uint16_t DLC        : 4;
       uint16_t RESERVED1  : 3;
  __IO uint16_t EOB        : 1;
  __IO uint16_t TXRQST     : 1;
  __IO uint16_t RMTEN      : 1;
  __IO uint16_t RXIE       : 1;
  __IO uint16_t TXIE       : 1;
  __IO uint16_t UMASK      : 1;
  __IO uint16_t INTPND     : 1;
  __IO uint16_t MSGLST     : 1;
  __IO uint16_t NEWDAT     : 1;
} stc_can_if1mctr_field_t;

typedef struct stc_can_if2creq_field
{
       uint16_t RESERVED1  : 15;
  __IO uint16_t BUSY       : 1;
} stc_can_if2creq_field_t;

typedef struct stc_can_if2cmsk_field
{
  __IO uint16_t DATAB      : 1;
  __IO uint16_t DATAA      : 1;
  __IO uint16_t NEWDAT     : 1;
  __IO uint16_t CIP        : 1;
  __IO uint16_t CONTROL    : 1;
  __IO uint16_t ARB        : 1;
  __IO uint16_t MASK       : 1;
  __IO uint16_t WRRD       : 1;
} stc_can_if2cmsk_field_t;

typedef struct stc_can_if2msk_field
{
       uint32_t RESERVED1  : 30;
  __IO uint32_t MDIR       : 1;
  __IO uint32_t MXTD       : 1;
} stc_can_if2msk_field_t;

typedef struct stc_can_if2msk2_field
{
       uint16_t RESERVED1  : 14;
  __IO uint16_t MDIR       : 1;
  __IO uint16_t MXTD       : 1;
} stc_can_if2msk2_field_t;

typedef struct stc_can_if2arb2_field
{
       uint16_t RESERVED1  : 13;
  __IO uint16_t DIR        : 1;
  __IO uint16_t XTD        : 1;
  __IO uint16_t MSGVAL     : 1;
} stc_can_if2arb2_field_t;

typedef struct stc_can_if2mctr_field
{
  __IO uint16_t DLC        : 4;
       uint16_t RESERVED1  : 3;
  __IO uint16_t EOB        : 1;
  __IO uint16_t TXRQST     : 1;
  __IO uint16_t RMTEN      : 1;
  __IO uint16_t RXIE       : 1;
  __IO uint16_t TXIE       : 1;
  __IO uint16_t UMASK      : 1;
  __IO uint16_t INTPND     : 1;
  __IO uint16_t MSGLST     : 1;
  __IO uint16_t NEWDAT     : 1;
} stc_can_if2mctr_field_t;

typedef struct stc_can_treqr_field
{
  __IO uint32_t TXRQST1    : 1;
  __IO uint32_t TXRQST2    : 1;
  __IO uint32_t TXRQST3    : 1;
  __IO uint32_t TXRQST4    : 1;
  __IO uint32_t TXRQST5    : 1;
  __IO uint32_t TXRQST6    : 1;
  __IO uint32_t TXRQST7    : 1;
  __IO uint32_t TXRQST8    : 1;
  __IO uint32_t TXRQST9    : 1;
  __IO uint32_t TXRQST10   : 1;
  __IO uint32_t TXRQST11   : 1;
  __IO uint32_t TXRQST12   : 1;
  __IO uint32_t TXRQST13   : 1;
  __IO uint32_t TXRQST14   : 1;
  __IO uint32_t TXRQST15   : 1;
  __IO uint32_t TXRQST16   : 1;
  __IO uint32_t TXRQST17   : 1;
  __IO uint32_t TXRQST18   : 1;
  __IO uint32_t TXRQST19   : 1;
  __IO uint32_t TXRQST20   : 1;
  __IO uint32_t TXRQST21   : 1;
  __IO uint32_t TXRQST22   : 1;
  __IO uint32_t TXRQST23   : 1;
  __IO uint32_t TXRQST24   : 1;
  __IO uint32_t TXRQST25   : 1;
  __IO uint32_t TXRQST26   : 1;
  __IO uint32_t TXRQST27   : 1;
  __IO uint32_t TXRQST28   : 1;
  __IO uint32_t TXRQST29   : 1;
  __IO uint32_t TXRQST30   : 1;
  __IO uint32_t TXRQST31   : 1;
  __IO uint32_t TXRQST32   : 1;
} stc_can_treqr_field_t;

typedef struct stc_can_treqr1_field
{
  __IO uint16_t TXRQST1    : 1;
  __IO uint16_t TXRQST2    : 1;
  __IO uint16_t TXRQST3    : 1;
  __IO uint16_t TXRQST4    : 1;
  __IO uint16_t TXRQST5    : 1;
  __IO uint16_t TXRQST6    : 1;
  __IO uint16_t TXRQST7    : 1;
  __IO uint16_t TXRQST8    : 1;
  __IO uint16_t TXRQST9    : 1;
  __IO uint16_t TXRQST10   : 1;
  __IO uint16_t TXRQST11   : 1;
  __IO uint16_t TXRQST12   : 1;
  __IO uint16_t TXRQST13   : 1;
  __IO uint16_t TXRQST14   : 1;
  __IO uint16_t TXRQST15   : 1;
  __IO uint16_t TXRQST16   : 1;
} stc_can_treqr1_field_t;

typedef struct stc_can_treqr2_field
{
  __IO uint16_t TXRQST17   : 1;
  __IO uint16_t TXRQST18   : 1;
  __IO uint16_t TXRQST19   : 1;
  __IO uint16_t TXRQST20   : 1;
  __IO uint16_t TXRQST21   : 1;
  __IO uint16_t TXRQST22   : 1;
  __IO uint16_t TXRQST23   : 1;
  __IO uint16_t TXRQST24   : 1;
  __IO uint16_t TXRQST25   : 1;
  __IO uint16_t TXRQST26   : 1;
  __IO uint16_t TXRQST27   : 1;
  __IO uint16_t TXRQST28   : 1;
  __IO uint16_t TXRQST29   : 1;
  __IO uint16_t TXRQST30   : 1;
  __IO uint16_t TXRQST31   : 1;
  __IO uint16_t TXRQST32   : 1;
} stc_can_treqr2_field_t;

typedef struct stc_can_newdt_field
{
  __IO uint32_t NEWDAT1    : 1;
  __IO uint32_t NEWDAT2    : 1;
  __IO uint32_t NEWDAT3    : 1;
  __IO uint32_t NEWDAT4    : 1;
  __IO uint32_t NEWDAT5    : 1;
  __IO uint32_t NEWDAT6    : 1;
  __IO uint32_t NEWDAT7    : 1;
  __IO uint32_t NEWDAT8    : 1;
  __IO uint32_t NEWDAT9    : 1;
  __IO uint32_t NEWDAT10   : 1;
  __IO uint32_t NEWDAT11   : 1;
  __IO uint32_t NEWDAT12   : 1;
  __IO uint32_t NEWDAT13   : 1;
  __IO uint32_t NEWDAT14   : 1;
  __IO uint32_t NEWDAT15   : 1;
  __IO uint32_t NEWDAT16   : 1;
  __IO uint32_t NEWDAT17   : 1;
  __IO uint32_t NEWDAT18   : 1;
  __IO uint32_t NEWDAT19   : 1;
  __IO uint32_t NEWDAT20   : 1;
  __IO uint32_t NEWDAT21   : 1;
  __IO uint32_t NEWDAT22   : 1;
  __IO uint32_t NEWDAT23   : 1;
  __IO uint32_t NEWDAT24   : 1;
  __IO uint32_t NEWDAT25   : 1;
  __IO uint32_t NEWDAT26   : 1;
  __IO uint32_t NEWDAT27   : 1;
  __IO uint32_t NEWDAT28   : 1;
  __IO uint32_t NEWDAT29   : 1;
  __IO uint32_t NEWDAT30   : 1;
  __IO uint32_t NEWDAT31   : 1;
  __IO uint32_t NEWDAT32   : 1;
} stc_can_newdt_field_t;

typedef struct stc_can_newdt1_field
{
  __IO uint16_t NEWDAT1    : 1;
  __IO uint16_t NEWDAT2    : 1;
  __IO uint16_t NEWDAT3    : 1;
  __IO uint16_t NEWDAT4    : 1;
  __IO uint16_t NEWDAT5    : 1;
  __IO uint16_t NEWDAT6    : 1;
  __IO uint16_t NEWDAT7    : 1;
  __IO uint16_t NEWDAT8    : 1;
  __IO uint16_t NEWDAT9    : 1;
  __IO uint16_t NEWDAT10   : 1;
  __IO uint16_t NEWDAT11   : 1;
  __IO uint16_t NEWDAT12   : 1;
  __IO uint16_t NEWDAT13   : 1;
  __IO uint16_t NEWDAT14   : 1;
  __IO uint16_t NEWDAT15   : 1;
  __IO uint16_t NEWDAT16   : 1;
} stc_can_newdt1_field_t;

typedef struct stc_can_intpnd_field
{
  __IO uint32_t INTPND1    : 1;
  __IO uint32_t INTPND2    : 1;
  __IO uint32_t INTPND3    : 1;
  __IO uint32_t INTPND4    : 1;
  __IO uint32_t INTPND5    : 1;
  __IO uint32_t INTPND6    : 1;
  __IO uint32_t INTPND7    : 1;
  __IO uint32_t INTPND8    : 1;
  __IO uint32_t INTPND9    : 1;
  __IO uint32_t INTPND10   : 1;
  __IO uint32_t INTPND11   : 1;
  __IO uint32_t INTPND12   : 1;
  __IO uint32_t INTPND13   : 1;
  __IO uint32_t INTPND14   : 1;
  __IO uint32_t INTPND15   : 1;
  __IO uint32_t INTPND16   : 1;
  __IO uint32_t INTPND17   : 1;
  __IO uint32_t INTPND18   : 1;
  __IO uint32_t INTPND19   : 1;
  __IO uint32_t INTPND20   : 1;
  __IO uint32_t INTPND21   : 1;
  __IO uint32_t INTPND22   : 1;
  __IO uint32_t INTPND23   : 1;
  __IO uint32_t INTPND24   : 1;
  __IO uint32_t INTPND25   : 1;
  __IO uint32_t INTPND26   : 1;
  __IO uint32_t INTPND27   : 1;
  __IO uint32_t INTPND28   : 1;
  __IO uint32_t INTPND29   : 1;
  __IO uint32_t INTPND30   : 1;
  __IO uint32_t INTPND31   : 1;
  __IO uint32_t INTPND32   : 1;
} stc_can_intpnd_field_t;

typedef struct stc_can_intpnd1_field
{
  __IO uint16_t INTPND1    : 1;
  __IO uint16_t INTPND2    : 1;
  __IO uint16_t INTPND3    : 1;
  __IO uint16_t INTPND4    : 1;
  __IO uint16_t INTPND5    : 1;
  __IO uint16_t INTPND6    : 1;
  __IO uint16_t INTPND7    : 1;
  __IO uint16_t INTPND8    : 1;
  __IO uint16_t INTPND9    : 1;
  __IO uint16_t INTPND10   : 1;
  __IO uint16_t INTPND11   : 1;
  __IO uint16_t INTPND12   : 1;
  __IO uint16_t INTPND13   : 1;
  __IO uint16_t INTPND14   : 1;
  __IO uint16_t INTPND15   : 1;
  __IO uint16_t INTPND16   : 1;
} stc_can_intpnd1_field_t;

typedef struct stc_can_intpnd2_field
{
  __IO uint16_t INTPND17   : 1;
  __IO uint16_t INTPND18   : 1;
  __IO uint16_t INTPND19   : 1;
  __IO uint16_t INTPND20   : 1;
  __IO uint16_t INTPND21   : 1;
  __IO uint16_t INTPND22   : 1;
  __IO uint16_t INTPND23   : 1;
  __IO uint16_t INTPND24   : 1;
  __IO uint16_t INTPND25   : 1;
  __IO uint16_t INTPND26   : 1;
  __IO uint16_t INTPND27   : 1;
  __IO uint16_t INTPND28   : 1;
  __IO uint16_t INTPND29   : 1;
  __IO uint16_t INTPND30   : 1;
  __IO uint16_t INTPND31   : 1;
  __IO uint16_t INTPND32   : 1;
} stc_can_intpnd2_field_t;

typedef struct stc_can_msgval_field
{
  __IO uint32_t MSGVAL1    : 1;
  __IO uint32_t MSGVAL2    : 1;
  __IO uint32_t MSGVAL3    : 1;
  __IO uint32_t MSGVAL4    : 1;
  __IO uint32_t MSGVAL5    : 1;
  __IO uint32_t MSGVAL6    : 1;
  __IO uint32_t MSGVAL7    : 1;
  __IO uint32_t MSGVAL8    : 1;
  __IO uint32_t MSGVAL9    : 1;
  __IO uint32_t MSGVAL10   : 1;
  __IO uint32_t MSGVAL11   : 1;
  __IO uint32_t MSGVAL12   : 1;
  __IO uint32_t MSGVAL13   : 1;
  __IO uint32_t MSGVAL14   : 1;
  __IO uint32_t MSGVAL15   : 1;
  __IO uint32_t MSGVAL16   : 1;
  __IO uint32_t MSGVAL17   : 1;
  __IO uint32_t MSGVAL18   : 1;
  __IO uint32_t MSGVAL19   : 1;
  __IO uint32_t MSGVAL20   : 1;
  __IO uint32_t MSGVAL21   : 1;
  __IO uint32_t MSGVAL22   : 1;
  __IO uint32_t MSGVAL23   : 1;
  __IO uint32_t MSGVAL24   : 1;
  __IO uint32_t MSGVAL25   : 1;
  __IO uint32_t MSGVAL26   : 1;
  __IO uint32_t MSGVAL27   : 1;
  __IO uint32_t MSGVAL28   : 1;
  __IO uint32_t MSGVAL29   : 1;
  __IO uint32_t MSGVAL30   : 1;
  __IO uint32_t MSGVAL31   : 1;
  __IO uint32_t MSGVAL32   : 1;
} stc_can_msgval_field_t;

typedef struct stc_can_msgval1_field
{
  __IO uint16_t MSGVAL1    : 1;
  __IO uint16_t MSGVAL2    : 1;
  __IO uint16_t MSGVAL3    : 1;
  __IO uint16_t MSGVAL4    : 1;
  __IO uint16_t MSGVAL5    : 1;
  __IO uint16_t MSGVAL6    : 1;
  __IO uint16_t MSGVAL7    : 1;
  __IO uint16_t MSGVAL8    : 1;
  __IO uint16_t MSGVAL9    : 1;
  __IO uint16_t MSGVAL10   : 1;
  __IO uint16_t MSGVAL11   : 1;
  __IO uint16_t MSGVAL12   : 1;
  __IO uint16_t MSGVAL13   : 1;
  __IO uint16_t MSGVAL14   : 1;
  __IO uint16_t MSGVAL15   : 1;
  __IO uint16_t MSGVAL16   : 1;
} stc_can_msgval1_field_t;

typedef struct stc_can_msgval2_field
{
  __IO uint16_t MSGVAL17   : 1;
  __IO uint16_t MSGVAL18   : 1;
  __IO uint16_t MSGVAL19   : 1;
  __IO uint16_t MSGVAL20   : 1;
  __IO uint16_t MSGVAL21   : 1;
  __IO uint16_t MSGVAL22   : 1;
  __IO uint16_t MSGVAL23   : 1;
  __IO uint16_t MSGVAL24   : 1;
  __IO uint16_t MSGVAL25   : 1;
  __IO uint16_t MSGVAL26   : 1;
  __IO uint16_t MSGVAL27   : 1;
  __IO uint16_t MSGVAL28   : 1;
  __IO uint16_t MSGVAL29   : 1;
  __IO uint16_t MSGVAL30   : 1;
  __IO uint16_t MSGVAL31   : 1;
  __IO uint16_t MSGVAL32   : 1;
} stc_can_msgval2_field_t;

/******************************************************************************
 * ETHERNET_MAC_MODULE
 ******************************************************************************/
/* ETHERNET_MAC_MODULE register bit fields */
typedef struct stc_ethernet_mac_mcr_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t RE         : 1;
  __IO uint32_t TE         : 1;
  __IO uint32_t DC         : 1;
  __IO uint32_t BL         : 2;
  __IO uint32_t ACS        : 1;
  __IO uint32_t LUD        : 1;
  __IO uint32_t DR         : 1;
  __IO uint32_t IPC        : 1;
  __IO uint32_t DM         : 1;
  __IO uint32_t LM         : 1;
  __IO uint32_t DO         : 1;
  __IO uint32_t FES        : 1;
  __IO uint32_t PS         : 1;
  __IO uint32_t DCRS       : 1;
  __IO uint32_t IFG        : 3;
  __IO uint32_t JE         : 1;
  __IO uint32_t BE         : 1;
  __IO uint32_t JD         : 1;
  __IO uint32_t WD         : 1;
  __IO uint32_t TC         : 1;
  __IO uint32_t CST        : 1;
} stc_ethernet_mac_mcr_field_t;

typedef struct stc_ethernet_mac_mffr_field
{
  __IO uint32_t PR         : 1;
  __IO uint32_t HUC        : 1;
  __IO uint32_t HMC        : 1;
  __IO uint32_t DAIF       : 1;
  __IO uint32_t PM         : 1;
  __IO uint32_t DB         : 1;
  __IO uint32_t PCF        : 2;
  __IO uint32_t SAIF       : 1;
  __IO uint32_t SAF        : 1;
  __IO uint32_t HPF        : 1;
       uint32_t RESERVED1  : 20;
  __IO uint32_t RA         : 1;
} stc_ethernet_mac_mffr_field_t;

typedef struct stc_ethernet_mac_mhtrh_field
{
  __IO uint32_t HTH        : 32;
} stc_ethernet_mac_mhtrh_field_t;

typedef struct stc_ethernet_mac_mhtrl_field
{
  __IO uint32_t HTL        : 32;
} stc_ethernet_mac_mhtrl_field_t;

typedef struct stc_ethernet_mac_gar_field
{
  __IO uint32_t GB         : 1;
  __IO uint32_t GW         : 1;
  __IO uint32_t CR         : 4;
  __IO uint32_t GR         : 5;
  __IO uint32_t PA         : 5;
} stc_ethernet_mac_gar_field_t;

typedef struct stc_ethernet_mac_gdr_field
{
  __IO uint32_t GD         : 16;
} stc_ethernet_mac_gdr_field_t;

typedef struct stc_ethernet_mac_fcr_field
{
  __IO uint32_t FCB_BPA    : 1;
  __IO uint32_t TFE        : 1;
  __IO uint32_t RFE        : 1;
  __IO uint32_t UP         : 1;
  __IO uint32_t PLT        : 2;
       uint32_t RESERVED1  : 1;
  __IO uint32_t DZPQ       : 1;
       uint32_t RESERVED2  : 8;
  __IO uint32_t PT         : 16;
} stc_ethernet_mac_fcr_field_t;

typedef struct stc_ethernet_mac_vtr_field
{
  __IO uint32_t VL         : 16;
  __IO uint32_t ETV        : 1;
} stc_ethernet_mac_vtr_field_t;

typedef struct stc_ethernet_mac_rwffr_field
{
  __IO uint32_t RWFFR      : 32;
} stc_ethernet_mac_rwffr_field_t;

typedef struct stc_ethernet_mac_pmtr_field
{
  __IO uint32_t PD         : 1;
  __IO uint32_t MPE        : 1;
  __IO uint32_t WFE        : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t MPR        : 1;
  __IO uint32_t WPR        : 1;
       uint32_t RESERVED2  : 2;
  __IO uint32_t GU         : 1;
       uint32_t RESERVED3  : 21;
  __IO uint32_t RWFFRPR    : 1;
} stc_ethernet_mac_pmtr_field_t;

typedef struct stc_ethernet_mac_lpicsr_field
{
  __IO uint32_t TLPIEN     : 1;
  __IO uint32_t TLPIEX     : 1;
  __IO uint32_t RLPIEN     : 1;
  __IO uint32_t RLPIEX     : 1;
       uint32_t RESERVED1  : 4;
  __IO uint32_t TLPIST     : 1;
  __IO uint32_t RLPIST     : 1;
       uint32_t RESERVED2  : 6;
  __IO uint32_t LPIEN      : 1;
  __IO uint32_t PLS        : 1;
  __IO uint32_t PLSEN      : 1;
  __IO uint32_t LPITXA     : 1;
} stc_ethernet_mac_lpicsr_field_t;

typedef struct stc_ethernet_mac_lpitcr_field
{
  __IO uint32_t TWT        : 16;
  __IO uint32_t LIT        : 10;
} stc_ethernet_mac_lpitcr_field_t;

typedef struct stc_ethernet_mac_isr_field
{
  __IO uint32_t RGIS       : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t PIS        : 1;
  __IO uint32_t MIS        : 1;
  __IO uint32_t RIS        : 1;
  __IO uint32_t TIS        : 1;
  __IO uint32_t COIS       : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t TSIS       : 1;
  __IO uint32_t LPIIS      : 1;
} stc_ethernet_mac_isr_field_t;

typedef struct stc_ethernet_mac_imr_field
{
  __IO uint32_t RGIM       : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t PIM        : 1;
       uint32_t RESERVED2  : 5;
  __IO uint32_t TSIM       : 1;
  __IO uint32_t LPIIM      : 1;
} stc_ethernet_mac_imr_field_t;

typedef struct stc_ethernet_mac_mar0h_field
{
  __IO uint32_t A0         : 16;
       uint32_t RESERVED1  : 15;
  __IO uint32_t MO         : 1;
} stc_ethernet_mac_mar0h_field_t;

typedef struct stc_ethernet_mac_mar0l_field
{
  __IO uint32_t A0         : 32;
} stc_ethernet_mac_mar0l_field_t;

typedef struct stc_ethernet_mac_marh_field
{
  __IO uint32_t A          : 16;
       uint32_t RESERVED1  : 8;
  __IO uint32_t MBC        : 6;
  __IO uint32_t SA         : 1;
  __IO uint32_t AE         : 1;
} stc_ethernet_mac_marh_field_t;

typedef struct stc_ethernet_mac_marl_field
{
  __IO uint32_t A          : 32;
} stc_ethernet_mac_marl_field_t;

typedef struct stc_ethernet_mac_rgsr_field
{
  __IO uint32_t LM         : 1;
  __IO uint32_t LSP        : 2;
  __IO uint32_t LS         : 1;
} stc_ethernet_mac_rgsr_field_t;

typedef struct stc_ethernet_mac_tscr_field
{
  __IO uint32_t TSE        : 1;
  __IO uint32_t TFCU       : 1;
  __IO uint32_t TSI        : 1;
  __IO uint32_t TSU        : 1;
  __IO uint32_t TITE       : 1;
  __IO uint32_t TARU       : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t TSEA       : 1;
  __IO uint32_t TSDB       : 1;
  __IO uint32_t TSV2E      : 1;
  __IO uint32_t TETSP      : 1;
  __IO uint32_t TSIP6E     : 1;
  __IO uint32_t TSIP4E     : 1;
  __IO uint32_t TETSEM     : 1;
  __IO uint32_t TSMRM      : 1;
  __IO uint32_t TSPS       : 2;
  __IO uint32_t TSENMF     : 1;
       uint32_t RESERVED2  : 5;
  __IO uint32_t ATSFC      : 1;
} stc_ethernet_mac_tscr_field_t;

typedef struct stc_ethernet_mac_ssir_field
{
  __IO uint32_t SSINC      : 8;
} stc_ethernet_mac_ssir_field_t;

typedef struct stc_ethernet_mac_stsr_field
{
  __IO uint32_t TSS        : 32;
} stc_ethernet_mac_stsr_field_t;

typedef struct stc_ethernet_mac_stnr_field
{
  __IO uint32_t TSSS       : 31;
} stc_ethernet_mac_stnr_field_t;

typedef struct stc_ethernet_mac_stsur_field
{
  __IO uint32_t TSS        : 32;
} stc_ethernet_mac_stsur_field_t;

typedef struct stc_ethernet_mac_stnur_field
{
  __IO uint32_t TSSS       : 31;
  __IO uint32_t ADDSUB     : 1;
} stc_ethernet_mac_stnur_field_t;

typedef struct stc_ethernet_mac_tsar_field
{
  __IO uint32_t TSAR       : 32;
} stc_ethernet_mac_tsar_field_t;

typedef struct stc_ethernet_mac_ttsr_field
{
  __IO uint32_t TSTR       : 32;
} stc_ethernet_mac_ttsr_field_t;

typedef struct stc_ethernet_mac_ttnr_field
{
  __IO uint32_t TSTR       : 31;
} stc_ethernet_mac_ttnr_field_t;

typedef struct stc_ethernet_mac_sthwsr_field
{
  __IO uint32_t TSHWR      : 16;
} stc_ethernet_mac_sthwsr_field_t;

typedef struct stc_ethernet_mac_tsr_field
{
  __IO uint32_t TSSOVF     : 1;
  __IO uint32_t TSTART     : 1;
  __IO uint32_t ATSTS      : 1;
  __IO uint32_t TRGTER     : 1;
       uint32_t RESERVED1  : 20;
  __IO uint32_t ATSSTM     : 1;
  __IO uint32_t ATSNS      : 3;
} stc_ethernet_mac_tsr_field_t;

typedef struct stc_ethernet_mac_ppscr_field
{
  __IO uint32_t PPSCTRL    : 4;
} stc_ethernet_mac_ppscr_field_t;

typedef struct stc_ethernet_mac_atnr_field
{
  __IO uint32_t ATN        : 31;
} stc_ethernet_mac_atnr_field_t;

typedef struct stc_ethernet_mac_atsr_field
{
  __IO uint32_t ATS        : 32;
} stc_ethernet_mac_atsr_field_t;

typedef struct stc_ethernet_mac_bmr_field
{
  __IO uint32_t SWR        : 1;
  __IO uint32_t DA         : 1;
  __IO uint32_t DSL        : 5;
  __IO uint32_t ATDS       : 1;
  __IO uint32_t PBL        : 6;
  __IO uint32_t PR         : 2;
  __IO uint32_t FB         : 1;
  __IO uint32_t RPBL       : 6;
  __IO uint32_t USP        : 1;
  __IO uint32_t _8XPBL     : 1;
  __IO uint32_t AAL        : 1;
  __IO uint32_t MB         : 1;
  __IO uint32_t TXPR       : 1;
} stc_ethernet_mac_bmr_field_t;

typedef struct stc_ethernet_mac_tpdr_field
{
  __IO uint32_t TPD        : 32;
} stc_ethernet_mac_tpdr_field_t;

typedef struct stc_ethernet_mac_rpdr_field
{
  __IO uint32_t RPD        : 32;
} stc_ethernet_mac_rpdr_field_t;

typedef struct stc_ethernet_mac_rdlar_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t SRL        : 30;
} stc_ethernet_mac_rdlar_field_t;

typedef struct stc_ethernet_mac_tdlar_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t STL        : 30;
} stc_ethernet_mac_tdlar_field_t;

typedef struct stc_ethernet_mac_sr_field
{
  __IO uint32_t TI         : 1;
  __IO uint32_t TPS        : 1;
  __IO uint32_t TU         : 1;
  __IO uint32_t TJT        : 1;
  __IO uint32_t OVF        : 1;
  __IO uint32_t UNF        : 1;
  __IO uint32_t RI         : 1;
  __IO uint32_t RU         : 1;
  __IO uint32_t RPS        : 1;
  __IO uint32_t RWT        : 1;
  __IO uint32_t ETI        : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t FBI        : 1;
  __IO uint32_t ERI        : 1;
  __IO uint32_t AIS        : 1;
  __IO uint32_t NIS        : 1;
  __IO uint32_t RS         : 3;
  __IO uint32_t TS         : 3;
  __IO uint32_t EB         : 3;
  __IO uint32_t GLI        : 1;
  __IO uint32_t GMI        : 1;
  __IO uint32_t GPI        : 1;
  __IO uint32_t TTI        : 1;
  __IO uint32_t GLPII      : 1;
} stc_ethernet_mac_sr_field_t;

typedef struct stc_ethernet_mac_omr_field
{
       uint32_t RESERVED1  : 1;
  __IO uint32_t SR         : 1;
  __IO uint32_t OSF        : 1;
  __IO uint32_t RTC        : 2;
       uint32_t RESERVED2  : 1;
  __IO uint32_t FUF        : 1;
  __IO uint32_t FEF        : 1;
       uint32_t RESERVED3  : 5;
  __IO uint32_t ST         : 1;
  __IO uint32_t TTC        : 3;
       uint32_t RESERVED4  : 3;
  __IO uint32_t FTF        : 1;
  __IO uint32_t TSF        : 1;
       uint32_t RESERVED5  : 2;
  __IO uint32_t DFF        : 1;
  __IO uint32_t RSF        : 1;
  __IO uint32_t DT         : 1;
} stc_ethernet_mac_omr_field_t;

typedef struct stc_ethernet_mac_ier_field
{
  __IO uint32_t TIE        : 1;
  __IO uint32_t TSE        : 1;
  __IO uint32_t TUE        : 1;
  __IO uint32_t TJE        : 1;
  __IO uint32_t OVE        : 1;
  __IO uint32_t UNE        : 1;
  __IO uint32_t RIE        : 1;
  __IO uint32_t RUE        : 1;
  __IO uint32_t RSE        : 1;
  __IO uint32_t RWE        : 1;
  __IO uint32_t ETE        : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t FBE        : 1;
  __IO uint32_t ERE        : 1;
  __IO uint32_t AIE        : 1;
  __IO uint32_t NIE        : 1;
} stc_ethernet_mac_ier_field_t;

typedef struct stc_ethernet_mac_mfbocr_field
{
  __IO uint32_t NMFH       : 16;
  __IO uint32_t ONMFH      : 1;
  __IO uint32_t NMFF       : 11;
  __IO uint32_t ONMFF      : 1;
} stc_ethernet_mac_mfbocr_field_t;

typedef struct stc_ethernet_mac_riwtr_field
{
  __IO uint32_t RIWT       : 8;
} stc_ethernet_mac_riwtr_field_t;

typedef struct stc_ethernet_mac_ahbsr_field
{
  __IO uint32_t AHBS       : 1;
} stc_ethernet_mac_ahbsr_field_t;

typedef struct stc_ethernet_mac_chtdr_field
{
  __IO uint32_t HTDAP      : 32;
} stc_ethernet_mac_chtdr_field_t;

typedef struct stc_ethernet_mac_chrdr_field
{
  __IO uint32_t HRDAP      : 32;
} stc_ethernet_mac_chrdr_field_t;

typedef struct stc_ethernet_mac_chtbar_field
{
  __IO uint32_t HTBAR      : 32;
} stc_ethernet_mac_chtbar_field_t;

typedef struct stc_ethernet_mac_chrbar_field
{
  __IO uint32_t HRBAR      : 32;
} stc_ethernet_mac_chrbar_field_t;

/******************************************************************************
 * ETHERNET_CONTROL_MODULE
 ******************************************************************************/
/* ETHERNET_CONTROL_MODULE register bit fields */
typedef struct stc_ethernet_control_eth_mode_field
{
  __IO uint32_t IFMODE     : 1;
       uint32_t RESERVED1  : 7;
  __IO uint32_t RST0       : 1;
  __IO uint32_t RST1       : 1;
       uint32_t RESERVED2  : 18;
  __IO uint32_t PPSSEL     : 1;
} stc_ethernet_control_eth_mode_field_t;

typedef struct stc_ethernet_control_eth_clkg_field
{
  __IO uint32_t MACEN      : 2;
} stc_ethernet_control_eth_clkg_field_t;

/******************************************************************************
 * I2S_MODULE
 ******************************************************************************/
/* I2S_MODULE register bit fields */
typedef struct stc_i2s_rxfdat_field
{
  __IO uint32_t RXDATA     : 32;
} stc_i2s_rxfdat_field_t;

typedef struct stc_i2s_txfdat_field
{
  __IO uint32_t TXDATA     : 32;
} stc_i2s_txfdat_field_t;

typedef struct stc_i2s_cntreg_field
{
  __IO uint32_t FSPL       : 1;
  __IO uint32_t FSLN       : 1;
  __IO uint32_t FSPH       : 1;
  __IO uint32_t CPOL       : 1;
  __IO uint32_t SMPL       : 1;
  __IO uint32_t RXDIS      : 1;
  __IO uint32_t TXDIS      : 1;
  __IO uint32_t MLSB       : 1;
  __IO uint32_t FRUN       : 1;
  __IO uint32_t BEXT       : 1;
  __IO uint32_t ECKM       : 1;
  __IO uint32_t RHLL       : 1;
  __IO uint32_t SBFN       : 1;
  __IO uint32_t MSMD       : 1;
  __IO uint32_t MSKB       : 1;
       uint32_t RESERVED1  : 1;
  __IO uint32_t OVHD       : 10;
  __IO uint32_t CKRT       : 6;
} stc_i2s_cntreg_field_t;

typedef struct stc_i2s_mcr0reg_field
{
  __IO uint32_t S0WDL      : 5;
  __IO uint32_t S0CHL      : 5;
  __IO uint32_t S0CHN      : 5;
       uint32_t RESERVED1  : 1;
  __IO uint32_t S1WDL      : 5;
  __IO uint32_t S1CHL      : 5;
  __IO uint32_t S1CHN      : 5;
} stc_i2s_mcr0reg_field_t;

typedef struct stc_i2s_mcr1reg_field
{
  __IO uint32_t S0CH00     : 1;
  __IO uint32_t S0CH01     : 1;
  __IO uint32_t S0CH02     : 1;
  __IO uint32_t S0CH03     : 1;
  __IO uint32_t S0CH04     : 1;
  __IO uint32_t S0CH05     : 1;
  __IO uint32_t S0CH06     : 1;
  __IO uint32_t S0CH07     : 1;
  __IO uint32_t S0CH08     : 1;
  __IO uint32_t S0CH09     : 1;
  __IO uint32_t S0CH10     : 1;
  __IO uint32_t S0CH11     : 1;
  __IO uint32_t S0CH12     : 1;
  __IO uint32_t S0CH13     : 1;
  __IO uint32_t S0CH14     : 1;
  __IO uint32_t S0CH15     : 1;
  __IO uint32_t S0CH16     : 1;
  __IO uint32_t S0CH17     : 1;
  __IO uint32_t S0CH18     : 1;
  __IO uint32_t S0CH19     : 1;
  __IO uint32_t S0CH20     : 1;
  __IO uint32_t S0CH21     : 1;
  __IO uint32_t S0CH22     : 1;
  __IO uint32_t S0CH23     : 1;
  __IO uint32_t S0CH24     : 1;
  __IO uint32_t S0CH25     : 1;
  __IO uint32_t S0CH26     : 1;
  __IO uint32_t S0CH27     : 1;
  __IO uint32_t S0CH28     : 1;
  __IO uint32_t S0CH29     : 1;
  __IO uint32_t S0CH30     : 1;
  __IO uint32_t S0CH31     : 1;
} stc_i2s_mcr1reg_field_t;

typedef struct stc_i2s_mcr2reg_field
{
  __IO uint32_t S1CH00     : 1;
  __IO uint32_t S1CH01     : 1;
  __IO uint32_t S1CH02     : 1;
  __IO uint32_t S1CH03     : 1;
  __IO uint32_t S1CH04     : 1;
  __IO uint32_t S1CH05     : 1;
  __IO uint32_t S1CH06     : 1;
  __IO uint32_t S1CH07     : 1;
  __IO uint32_t S1CH08     : 1;
  __IO uint32_t S1CH09     : 1;
  __IO uint32_t S1CH10     : 1;
  __IO uint32_t S1CH11     : 1;
  __IO uint32_t S1CH12     : 1;
  __IO uint32_t S1CH13     : 1;
  __IO uint32_t S1CH14     : 1;
  __IO uint32_t S1CH15     : 1;
  __IO uint32_t S1CH16     : 1;
  __IO uint32_t S1CH17     : 1;
  __IO uint32_t S1CH18     : 1;
  __IO uint32_t S1CH19     : 1;
  __IO uint32_t S1CH20     : 1;
  __IO uint32_t S1CH21     : 1;
  __IO uint32_t S1CH22     : 1;
  __IO uint32_t S1CH23     : 1;
  __IO uint32_t S1CH24     : 1;
  __IO uint32_t S1CH25     : 1;
  __IO uint32_t S1CH26     : 1;
  __IO uint32_t S1CH27     : 1;
  __IO uint32_t S1CH28     : 1;
  __IO uint32_t S1CH29     : 1;
  __IO uint32_t S1CH30     : 1;
  __IO uint32_t S1CH31     : 1;
} stc_i2s_mcr2reg_field_t;

typedef struct stc_i2s_oprreg_field
{
  __IO uint32_t START      : 1;
       uint32_t RESERVED1  : 15;
  __IO uint32_t TXENB      : 1;
       uint32_t RESERVED2  : 7;
  __IO uint32_t RXENB      : 1;
} stc_i2s_oprreg_field_t;

typedef struct stc_i2s_srst_field
{
  __IO uint32_t SRST       : 1;
} stc_i2s_srst_field_t;

typedef struct stc_i2s_intcnt_field
{
  __IO uint32_t RFTH       : 4;
  __IO uint32_t RPTMR      : 2;
       uint32_t RESERVED1  : 2;
  __IO uint32_t TFTH       : 4;
       uint32_t RESERVED2  : 4;
  __IO uint32_t RXFIM      : 1;
  __IO uint32_t RXFDM      : 1;
  __IO uint32_t EOPM       : 1;
  __IO uint32_t RXOVM      : 1;
  __IO uint32_t RXUDM      : 1;
  __IO uint32_t RBERM      : 1;
       uint32_t RESERVED3  : 2;
  __IO uint32_t TXFIM      : 1;
  __IO uint32_t TXFDM      : 1;
  __IO uint32_t TXOVM      : 1;
  __IO uint32_t TXUD0M     : 1;
  __IO uint32_t FERRM      : 1;
  __IO uint32_t TBERM      : 1;
  __IO uint32_t TXUD1M     : 1;
} stc_i2s_intcnt_field_t;

typedef struct stc_i2s_status_field
{
  __IO uint32_t RXNUM      : 8;
  __IO uint32_t TXNUM      : 8;
  __IO uint32_t RXFI       : 1;
  __IO uint32_t TXFI       : 1;
  __IO uint32_t BSY        : 1;
  __IO uint32_t EOPI       : 1;
       uint32_t RESERVED1  : 4;
  __IO uint32_t RXOVR      : 1;
  __IO uint32_t RXUDR      : 1;
  __IO uint32_t TXOVR      : 1;
  __IO uint32_t TXUDR0     : 1;
  __IO uint32_t TXUDR1     : 1;
  __IO uint32_t FERR       : 1;
  __IO uint32_t RBERR      : 1;
  __IO uint32_t TBERR      : 1;
} stc_i2s_status_field_t;

typedef struct stc_i2s_dmaact_field
{
  __IO uint32_t RDMACT     : 1;
       uint32_t RESERVED1  : 7;
  __IO uint32_t RL1E0      : 1;
       uint32_t RESERVED2  : 7;
  __IO uint32_t TDMACT     : 1;
       uint32_t RESERVED3  : 7;
  __IO uint32_t TL1E0      : 1;
} stc_i2s_dmaact_field_t;

typedef struct stc_i2s_tstreg_field
{
  __IO uint32_t LBMD       : 1;
} stc_i2s_tstreg_field_t;

/******************************************************************************
 * SDIF_MODULE
 ******************************************************************************/
/* SDIF_MODULE register bit fields */
typedef struct stc_sdif_sbsize_field
{
  __IO uint16_t TRSFBLCKSZ : 12;
  __IO uint16_t HSDMABUFBD : 3;
       uint16_t RESERVED1  : 1;
} stc_sdif_sbsize_field_t;

typedef struct stc_sdif_strsfmd_field
{
  __IO uint16_t DMAEN      : 1;
  __IO uint16_t BLCKCNTEN  : 1;
  __IO uint16_t AUTOCMDEN  : 2;
  __IO uint16_t DTTRSFDIR  : 1;
  __IO uint16_t BLCKCNTSEL : 1;
} stc_sdif_strsfmd_field_t;

typedef struct stc_sdif_scmmd_field
{
  __IO uint16_t RESPTYPE   : 2;
       uint16_t RESERVED1  : 1;
  __IO uint16_t CMDCRCCHKE : 1;
  __IO uint16_t CMDIDXCHKE : 1;
  __IO uint16_t DATPRESSEL : 1;
  __IO uint16_t CMDTYPE    : 2;
  __IO uint16_t CMDINDEX   : 6;
} stc_sdif_scmmd_field_t;

typedef struct stc_sdif_sprstat_field
{
  __IO uint32_t CMDINH     : 1;
  __IO uint32_t CMDDATINH : 1;
  __IO uint32_t DATLNACT   : 1;
  __IO uint32_t RETUNEREQ  : 1;
       uint32_t RESERVED1  : 4;
  __IO uint32_t WRTRSFACT  : 1;
  __IO uint32_t RDTRSFACT  : 1;
  __IO uint32_t BUFWREN    : 1;
  __IO uint32_t BUFRDEN    : 1;
       uint32_t RESERVED2  : 4;
  __IO uint32_t CARDINS    : 1;
  __IO uint32_t CARDSTB    : 1;
  __IO uint32_t CARDDET    : 1;
  __IO uint32_t WPPINLVL   : 1;
  __IO uint32_t LNSGNLVL   : 4;
  __IO uint32_t CMDLNSGN   : 1;
       uint32_t RESERVED3  : 7;
} stc_sdif_sprstat_field_t;

typedef struct stc_sdif_shctl1_field
{
  __IO uint8_t LEDCTRL     : 1;
  __IO uint8_t DATAWIDTH   : 1;
  __IO uint8_t HIGHSPDEN   : 1;
  __IO uint8_t DMASEL      : 2;
  __IO uint8_t EXTDTWIDTH  : 1;
  __IO uint8_t CDTSTLVL    : 1;
  __IO uint8_t CDSGNSEL    : 1;
} stc_sdif_shctl1_field_t;

typedef struct stc_sdif_spwrctl_field
{
  __IO uint8_t SDBUSPWR    : 1;
  __IO uint8_t SDBUSVLSEL  : 3;
       uint8_t RESERVED1   : 4;
} stc_sdif_spwrctl_field_t;

typedef struct stc_sdif_sblkgpctl_field
{
  __IO uint8_t BLCKGSTPREQ : 1;
  __IO uint8_t CONTREQ     : 1;
  __IO uint8_t RDWAITCTL   : 1;
  __IO uint8_t BLCKGAPINT  : 1;
       uint8_t RESERVED1   : 4;
} stc_sdif_sblkgpctl_field_t;

typedef struct stc_sdif_swkupctl_field
{
  __IO uint8_t WKUPEVNTEN0 : 1;
  __IO uint8_t WKUPEVNTEN1 : 1;
  __IO uint8_t WKUPEVNTEN2 : 1;
       uint8_t RESERVED1   : 5;
} stc_sdif_swkupctl_field_t;

typedef struct stc_sdif_sclkctl_field
{
  __IO uint16_t INTLCLCKEN : 1;
  __IO uint16_t INTLCLCKST : 1;
  __IO uint16_t SDCLCKEN   : 1;
       uint16_t RESERVED1  : 2;
  __IO uint16_t CLCKGENSEL : 1;
  __IO uint16_t UPSDCLKSEL : 2;
  __IO uint16_t SDCLKSEL   : 8;
} stc_sdif_sclkctl_field_t;

typedef struct stc_sdif_stoctl_field
{
  __IO uint8_t DTTMOUTVAL : 4;
       uint8_t RESERVED1  : 4;
} stc_sdif_stoctl_field_t;

typedef struct stc_sdif_ssrst_field
{
  __IO uint8_t SWRSTALL   : 1;
  __IO uint8_t SWRSTCMDLN : 1;
  __IO uint8_t SWRSTDATLN : 1;
       uint8_t RESERVED1  : 5;
} stc_sdif_ssrst_field_t;

typedef struct stc_sdif_snintst_field
{
  __IO uint16_t CMDCMPLT  : 1;
  __IO uint16_t TRSFCMPLT : 1;
  __IO uint16_t BLCKGEVNT : 1;
  __IO uint16_t DMAINT    : 1;
  __IO uint16_t BUFWRRDY  : 1;
  __IO uint16_t BUFRDRDY  : 1;
  __IO uint16_t CARDINS   : 1;
  __IO uint16_t CARDRMV   : 1;
  __IO uint16_t CARDINT   : 1;
  __IO uint16_t INT_A     : 1;
  __IO uint16_t INT_B     : 1;
  __IO uint16_t INT_C     : 1;
  __IO uint16_t RETUNEEVT : 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t ERRORINT  : 1;
} stc_sdif_snintst_field_t;

typedef struct stc_sdif_seintst_field
{
  __IO uint16_t CMDTOERR  : 1;
  __IO uint16_t CMDCRCERR : 1;
  __IO uint16_t CMDEBERR  : 1;
  __IO uint16_t CMDIDXERR : 1;
  __IO uint16_t DTTOERR   : 1;
  __IO uint16_t DTEBERR   : 1;
  __IO uint16_t DTCRCERR  : 1;
  __IO uint16_t CRTLMTERR : 1;
  __IO uint16_t ACMD12ERR : 1;
  __IO uint16_t ADMAERR   : 1;
  __IO uint16_t TUNINGERR : 1;
       uint16_t RESERVED1 : 1;
  __IO uint16_t BTACKERR  : 1;
  __IO uint16_t ACMD19ERR : 1;
  __IO uint16_t AHBMSTERR : 1;
       uint16_t RESERVED2 : 1;
} stc_sdif_seintst_field_t;

typedef struct stc_sdif_snintste_field
{
  __IO uint16_t CMDCMPLTS : 1;
  __IO uint16_t TRSFCMPLTS: 1;
  __IO uint16_t BLCKGEVNTS: 1;
  __IO uint16_t DMAINTS   : 1;
  __IO uint16_t BUFWRRDYS : 1;
  __IO uint16_t BUFRDRDYS : 1;
  __IO uint16_t CARDINSS  : 1;
  __IO uint16_t CARDRMVS  : 1;
  __IO uint16_t CARDINTS  : 1;
  __IO uint16_t INT_AS    : 1;
  __IO uint16_t INT_BS    : 1;
  __IO uint16_t INT_CS    : 1;
  __IO uint16_t RETUNEEVTS: 1;
       uint16_t RESERVED1 : 3;
} stc_sdif_snintste_field_t;

typedef struct stc_sdif_seintste_field
{
  __IO uint16_t CMDTOERRS : 1;
  __IO uint16_t CMDCRCERRS: 1;
  __IO uint16_t CMDEBERRS : 1;
  __IO uint16_t CMDIDXERRS: 1;
  __IO uint16_t DTTOERRS  : 1;
  __IO uint16_t DTEBERRS  : 1;
  __IO uint16_t DTCRCERRS : 1;
  __IO uint16_t CRTLMTERRS: 1;
  __IO uint16_t ACMD12ERRS: 1;
  __IO uint16_t ADMAERRS  : 1;
  __IO uint16_t TUNINGERRS: 1;
       uint16_t RESERVED1 : 1;
  __IO uint16_t BTACKERRS : 1;
  __IO uint16_t ACMD19ERRS: 1;
  __IO uint16_t AHBMSTERRS: 1;
       uint16_t RESERVED2 : 1;
} stc_sdif_seintste_field_t;

typedef struct stc_sdif_snintsge_field
{
  __IO uint16_t CMDCMPLTG : 1;
  __IO uint16_t TRSFCMPLTG: 1;
  __IO uint16_t BLCKGEVNTG: 1;
  __IO uint16_t DMAINTG   : 1;
  __IO uint16_t BUFWRRDYG : 1;
  __IO uint16_t BUFRDRDYG : 1;
  __IO uint16_t CARDINSG  : 1;
  __IO uint16_t CARDRMVG  : 1;
  __IO uint16_t CARDINTG  : 1;
  __IO uint16_t INT_AG    : 1;
  __IO uint16_t INT_BG    : 1;
  __IO uint16_t INT_CG    : 1;
  __IO uint16_t RETUNEEVTG: 1;
       uint16_t RESERVED1 : 3;
} stc_sdif_snintsge_field_t;

typedef struct stc_sdif_seintsge_field
{
  __IO uint16_t CMDTOERRG : 1;
  __IO uint16_t CMDCRCERRG: 1;
  __IO uint16_t CMDEBERRG : 1;
  __IO uint16_t CMDIDXERRG: 1;
  __IO uint16_t DTTOERRG  : 1;
  __IO uint16_t DTEBERRG  : 1;
  __IO uint16_t DTCRCERRG : 1;
  __IO uint16_t CRTLMTERRG: 1;
  __IO uint16_t ACMD12ERRG: 1;
  __IO uint16_t ADMAERRG  : 1;
  __IO uint16_t TUNINGERRG: 1;
       uint16_t RESERVED1 : 1;
  __IO uint16_t BTACKERRG : 1;
  __IO uint16_t ACMD19ERRG: 1;
  __IO uint16_t AHBMSTERRG: 1;
       uint16_t RESERVED2 : 1;
} stc_sdif_seintsge_field_t;

typedef struct stc_sdif_sacmdest_field
{
  __IO uint16_t ACMD12NOEX: 1;
  __IO uint16_t ACMDTOERR : 1;
  __IO uint16_t ACMDCRCERR: 1;
  __IO uint16_t ACMDEBERR : 1;
  __IO uint16_t ACMDIDXERR: 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t CMDND12ERR: 1;
       uint16_t RESERVED2 : 8;
} stc_sdif_sacmdest_field_t;

typedef struct stc_sdif_shctl2_field
{
  __IO uint16_t UHSMDSEL  : 3;
  __IO uint16_t V18SGNEN  : 1;
  __IO uint16_t DRVSEL    : 2;
  __IO uint16_t DOTUING   : 1;
  __IO uint16_t SMPCLKSEK : 1;
       uint16_t RESERVED1 : 6;
  __IO uint16_t ASYINTEN  : 1;
  __IO uint16_t PREVALEN  : 1;
} stc_sdif_shctl2_field_t;

typedef struct stc_sdif_capblty0_field
{
  __IO uint16_t TOCLKFREQ : 6;
       uint16_t RESERVED1 : 1;
  __IO uint16_t TOCLKUNIT : 1;
  __IO uint16_t SDBASECLK : 8;
} stc_sdif_capblty0_field_t;

typedef struct stc_sdif_capblty1_field
{
  __IO uint16_t MAXBLCKLEN: 2;
  __IO uint16_t EMBD8BIT  : 1;
  __IO uint16_t ADMA2SPT  : 1;
       uint16_t RESERVED1 : 1;
  __IO uint16_t HGHSPDSPT : 1;
  __IO uint16_t SDMASPT   : 1;
  __IO uint16_t LWPWRSPT  : 1;
  __IO uint16_t V33SPT    : 1;
  __IO uint16_t V30SPT    : 1;
  __IO uint16_t V18SPT    : 1;
       uint16_t RESERVED2 : 1;
  __IO uint16_t BUS64SPT  : 1;
  __IO uint16_t ASYINTSPT : 1;
  __IO uint16_t STOPTYPE  : 2;
} stc_sdif_capblty1_field_t;

typedef struct stc_sdif_capblty2_field
{
  __IO uint16_t SDR50SPT  : 1;
  __IO uint16_t SDR104SPT : 1;
  __IO uint16_t DDR50SPT  : 1;
       uint16_t RESERVED1 : 1;
  __IO uint16_t DRVTPASPT : 1;
  __IO uint16_t DRVTPBSPT : 1;
  __IO uint16_t DRVTPCSPT : 1;
       uint16_t RESERVED2 : 1;
  __IO uint16_t TMCNTRETN : 4;
       uint16_t RESERVED3 : 1;
  __IO uint16_t USETNSDR50: 1;
  __IO uint16_t RETNMODE  : 2;
} stc_sdif_capblty2_field_t;

typedef struct stc_sdif_capblty3_field
{
  __IO uint16_t CLKMULTPL : 8;
       uint16_t RESERVED1 : 8;
} stc_sdif_capblty3_field_t;

typedef struct stc_sdif_mxccapy0_field
{
  __IO uint16_t V33MAXCUR : 8;
  __IO uint16_t V30MAXCUR : 8;
} stc_sdif_mxccapy0_field_t;

typedef struct stc_sdif_mxccapy1_field
{
  __IO uint16_t V18MAXCUR : 8;
       uint16_t RESERVED1 : 8;
} stc_sdif_mxccapy1_field_t;

typedef struct stc_sdif_mxccapy2_field
{
       uint16_t RESERVED1 : 16;
} stc_sdif_mxccapy2_field_t;

typedef struct stc_sdif_mxccapy3_field
{
       uint16_t RESERVED1 : 16;
} stc_sdif_mxccapy3_field_t;

typedef struct stc_sdif_feacest_field
{
  __IO uint16_t FEVNT12ND : 1;
  __IO uint16_t FEVNTTO   : 1;
  __IO uint16_t FEVNTCRC  : 1;
  __IO uint16_t FEVNTEB   : 1;
  __IO uint16_t FEVNTIDX  : 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t FEVNTCMD12: 1;
       uint16_t RESERVED2 : 8;
} stc_sdif_feacest_field_t;

typedef struct stc_sdif_sfeeist_field
{
  __IO uint16_t FETOERR   : 1;
  __IO uint16_t FECRCERR  : 1;
  __IO uint16_t FEEBERR   : 1;
  __IO uint16_t FEIDXERR  : 1;
  __IO uint16_t FEDTOTERR : 1;
  __IO uint16_t FEDTCRCERR: 1;
  __IO uint16_t FEDTEBERR : 1;
  __IO uint16_t FECRLTERR : 1;
  __IO uint16_t FEA12ERR  : 1;
  __IO uint16_t FEADMAERR : 1;
  __IO uint16_t FETUNEERR : 1;
       uint16_t RESERVED1 : 1;
  __IO uint16_t FEACKERR  : 1;
  __IO uint16_t FEA19ERR  : 1;
  __IO uint16_t FEAHBMSERR: 1;
       uint16_t RESERVED2 : 1;
} stc_sdif_sfeeist_field_t;

typedef struct stc_sdif_admaest_field
{
  __IO uint8_t ADMAERRS  : 2;
  __IO uint8_t ADMALENME : 1;
       uint8_t RESERVED1 : 5;
} stc_sdif_admaest_field_t;

typedef struct stc_sdif_sadsa0_field
{
  __IO uint16_t ADR1500   : 16;
} stc_sdif_sadsa0_field_t;

typedef struct stc_sdif_sadsa1_field
{
  __IO uint16_t ADR3116   : 16;
} stc_sdif_sadsa1_field_t;

typedef struct stc_sdif_sadsa2_field
{
  __IO uint16_t ADR4732   : 16;
} stc_sdif_sadsa2_field_t;

typedef struct stc_sdif_sadsa3_field
{
  __IO uint16_t ADR6348   : 16;
} stc_sdif_sadsa3_field_t;

typedef struct stc_sdif_sprval0_field
{
  __IO uint16_t SCFSELVAL : 10;
  __IO uint16_t CGSELVAL  : 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t DSSELVAL  : 2;
} stc_sdif_sprval0_field_t;

typedef struct stc_sdif_sprval1_field
{
  __IO uint16_t SCFSELVAL : 10;
  __IO uint16_t CGSELVAL  : 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t DSSELVAL  : 2;
} stc_sdif_sprval1_field_t;

typedef struct stc_sdif_sprval2_field
{
  __IO uint16_t SCFSELVAL : 10;
  __IO uint16_t CGSELVAL  : 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t DSSELVAL  : 2;
} stc_sdif_sprval2_field_t;

typedef struct stc_sdif_sprval3_field
{
  __IO uint16_t SCFSELVAL : 10;
  __IO uint16_t CGSELVAL  : 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t DSSELVAL  : 2;
} stc_sdif_sprval3_field_t;

typedef struct stc_sdif_sprval4_field
{
  __IO uint16_t SCFSELVAL : 10;
  __IO uint16_t CGSELVAL  : 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t DSSELVAL  : 2;
} stc_sdif_sprval4_field_t;

typedef struct stc_sdif_sprval5_field
{
  __IO uint16_t SCFSELVAL : 10;
  __IO uint16_t CGSELVAL  : 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t DSSELVAL  : 2;
} stc_sdif_sprval5_field_t;

typedef struct stc_sdif_sprval6_field
{
  __IO uint16_t SCFSELVAL : 10;
  __IO uint16_t CGSELVAL  : 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t DSSELVAL  : 2;
} stc_sdif_sprval6_field_t;

typedef struct stc_sdif_sprval7_field
{
  __IO uint16_t SCFSELVAL : 10;
  __IO uint16_t CGSELVAL  : 1;
       uint16_t RESERVED1 : 2;
  __IO uint16_t DSSELVAL  : 2;
} stc_sdif_sprval7_field_t;

typedef struct stc_sdif_sshbctll_field
{
  __IO uint16_t CLCKPIN   : 3;
       uint16_t RESERVED1 : 1;
  __IO uint16_t INTINPIN  : 2;
       uint16_t RESERVED2 : 2;
  __IO uint16_t BUSWDPRST : 7;
       uint16_t RESERVED3 : 1;
} stc_sdif_sshbctll_field_t;

typedef struct stc_sdif_sshbctlh_field
{
  __IO uint16_t CLCKPINSEL: 3;
       uint16_t RESERVED1 : 1;
  __IO uint16_t INTPINSEL : 3;
       uint16_t RESERVED2 : 1;
  __IO uint16_t BEPWRCTL  : 7;
       uint16_t RESERVED3 : 1;
} stc_sdif_sshbctlh_field_t;


typedef struct stc_sdif_sslist_field
{
  __IO uint16_t SLOTINTSGN: 8;
       uint16_t RESERVED1 : 8;
} stc_sdif_sslist_field_t;

typedef struct stc_sdif_shctlv_field
{
  __IO uint16_t SPECVERNUM: 8;
  __IO uint16_t VNDVERNUM : 8;
} stc_sdif_shctlv_field_t;

typedef struct stc_sdif_ahbcfgl_field
{
  __IO uint16_t INCRSEL   : 3;
  __IO uint16_t SINEN     : 1;
  __IO uint16_t BSLOCK    : 1;
  __IO uint16_t BSLOCKSEL : 1;
  __IO uint16_t ENDIANSEL : 1;
       uint16_t RESERVED1 : 9;
} stc_sdif_ahbcfgl_field_t;

typedef struct stc_sdif_ahbcfgh_field
{
       uint16_t RESERVED1 : 16;
} stc_sdif_ahbcfgh_field_t;

typedef struct stc_sdif_spwswcl_field
{
  __IO uint16_t ATPWRSWEN : 1;
  __IO uint16_t IOREGSEL  : 1;
       uint16_t RESERVED1 : 14;
} stc_sdif_spwswcl_field_t;

typedef struct stc_sdif_spwswch_field
{
       uint16_t RESERVED1 : 16;
} stc_sdif_spwswch_field_t;

typedef struct stc_sdif_stunsetl_field
{
  __IO uint16_t TNPTSEL   : 8;
  __IO uint16_t TNPHSELEN : 1;
  __IO uint16_t TNERRBDSEL: 1;
  __IO uint16_t RETNTAPSEL: 1;
  __IO uint16_t RETNRNGSEL: 2;
       uint16_t RESERVED1 : 3;
} stc_sdif_stunsetl_field_t;

typedef struct stc_sdif_stunseth_field
{
  __IO uint16_t CMDCFCHKDS: 1;
       uint16_t RESERVED1 : 7;
  __IO uint16_t DTOTCNTVAL: 4;
       uint16_t RESERVED2 : 4;
} stc_sdif_stunseth_field_t;

typedef struct stc_sdif_stunstl_field
{
  __IO uint16_t REP8TNRSLT: 8;
  __IO uint16_t REP3TNRSLT: 3;
       uint16_t RESERVED1 : 5;
} stc_sdif_stunstl_field_t;

typedef struct stc_sdif_stunsth_field
{
  __IO uint16_t PRSTTNPNT : 8;
       uint16_t RESERVED1 : 8;
} stc_sdif_stunsth_field_t;

typedef struct stc_sdif_pswistl_field
{
  __IO uint16_t INT5MS    : 1;
  __IO uint16_t INT1MS    : 1;
       uint16_t RESERVED1 : 14;
} stc_sdif_pswistl_field_t;

typedef struct stc_sdif_pswisth_field
{
       uint16_t RESERVED1 : 16;
} stc_sdif_pswisth_field_t;


typedef struct stc_sdif_pswistel_field
{
  __IO uint16_t INT5MSSTS : 1;
  __IO uint16_t INT1MSSTS : 1;
       uint16_t RESERVED1 : 14;
} stc_sdif_pswistel_field_t;

typedef struct stc_sdif_pswisteh_field
{
       uint16_t RESERVED1 : 16;
} stc_sdif_pswisteh_field_t;

typedef struct stc_sdif_pswisgel_field
{
  __IO uint16_t INT5MSSGEN: 1;
  __IO uint16_t INT1MSSGEN: 1;
       uint16_t RESERVED1 : 14;
} stc_sdif_pswisgel_field_t;

typedef struct stc_sdif_pswisgeh_field
{
       uint16_t RESERVED1 : 16;
} stc_sdif_pswisgeh_field_t;

typedef struct stc_sdif_mmcsdcl_field
{
  __IO uint16_t LCKRSTESD : 1;
  __IO uint16_t RSTMMC    : 1;
  __IO uint16_t VCCCTLMMC : 1;
  __IO uint16_t VCCQCTLMMC: 1;
       uint16_t RESERVED1 : 4;
  __IO uint16_t MMCDDRSEL : 1;
  __IO uint16_t CMDDATDLY : 1;
       uint16_t RESERVED2 : 6;
} stc_sdif_mmcsdcl_field_t;

typedef struct stc_sdif_mmcsdch_field
{
  __IO uint16_t BTACKENMMC: 1;
  __IO uint16_t BTABTENMMC: 1;
  __IO uint16_t BTMDENMMC : 1;
       uint16_t RESERVED1 : 13;
} stc_sdif_mmcsdch_field_t;

typedef struct stc_sdif_mcwirqc0_field
{
  __IO uint16_t WTIRQEN   : 1;
  __IO uint16_t WTIRQST   : 1;
       uint16_t RESERVED1 : 14;
} stc_sdif_mcwirqc0_field_t;

typedef struct stc_sdif_mcwirqc1_field
{
  __IO uint16_t WTIRQCNCLR: 16;
} stc_sdif_mcwirqc1_field_t;

typedef struct stc_sdif_mcwirqc2_field
{
  __IO uint16_t WTIRQCNCLR: 16;
} stc_sdif_mcwirqc2_field_t;

typedef struct stc_sdif_mcwirqc3_field
{
  __IO uint16_t WTIRQCNCLR: 16;
} stc_sdif_mcwirqc3_field_t;

typedef struct stc_sdif_mcrpckbl_field
{
  __IO uint16_t CHECKBIT1 : 7;
  __IO uint16_t CHECKBIT2 : 6;
       uint16_t RESERVED1 : 3;
} stc_sdif_mcrpckbl_field_t;

typedef struct stc_sdif_mcrpckbh_field
{
       uint16_t RESERVED1 : 16;
} stc_sdif_mcrpckbh_field_t;

typedef struct stc_sdif_scdetecs_field
{
       uint16_t RESERVED1 : 8;
  __IO uint16_t CDDEBTCVAL: 4;
       uint16_t RESERVED2 : 4;
} stc_sdif_scdetecs_field_t;

/******************************************************************************
 * CANFD_MODULE
 ******************************************************************************/
/* CANFD_MODULE register bit fields */
typedef struct stc_canfd_crel_field
{
  __IO uint32_t DAY        : 8;
  __IO uint32_t MON        : 8;
  __IO uint32_t YEAR       : 4;
  __IO uint32_t SUBSTEP    : 4;
  __IO uint32_t STEP       : 4;
  __IO uint32_t REL        : 4;
} stc_canfd_crel_field_t;

typedef struct stc_canfd_endn_field
{
  __IO uint32_t ETV        : 32;
} stc_canfd_endn_field_t;

typedef struct stc_canfd_fbtp_field
{
  __IO uint32_t FSJW       : 2;
       uint32_t RESERVED1  : 2;
  __IO uint32_t FTSEG2     : 3;
       uint32_t RESERVED2  : 1;
  __IO uint32_t FTSEG1     : 4;
       uint32_t RESERVED3  : 4;
  __IO uint32_t FBRP       : 5;
       uint32_t RESERVED4  : 2;
  __IO uint32_t TDC        : 1;
  __IO uint32_t TDCO       : 5;
} stc_canfd_fbtp_field_t;

typedef struct stc_canfd_test_field
{
       uint32_t RESERVED1  : 4;
  __IO uint32_t LBCK       : 1;
  __IO uint32_t TX         : 2;
  __IO uint32_t RX         : 1;
  __IO uint32_t TDCV       : 6;
} stc_canfd_test_field_t;

typedef struct stc_canfd_rwd_field
{
  __IO uint32_t WDC        : 8;
  __IO uint32_t WDV        : 8;
} stc_canfd_rwd_field_t;

typedef struct stc_canfd_cccr_field
{
  __IO uint32_t INIT       : 1;
  __IO uint32_t CCE        : 1;
  __IO uint32_t ASM        : 1;
  __IO uint32_t CSA        : 1;
  __IO uint32_t CSR        : 1;
  __IO uint32_t MON        : 1;
  __IO uint32_t DAR        : 1;
  __IO uint32_t TEST       : 1;
  __IO uint32_t CME        : 2;
  __IO uint32_t CMR        : 2;
  __IO uint32_t FDO        : 1;
  __IO uint32_t FDBS       : 1;
  __IO uint32_t TXP        : 1;
} stc_canfd_cccr_field_t;

typedef struct stc_canfd_btp_field
{
  __IO uint32_t SJW        : 4;
  __IO uint32_t TSEG2      : 4;
  __IO uint32_t TSEG1      : 6;
       uint32_t RESERVED1  : 2;
  __IO uint32_t BRP        : 10;
} stc_canfd_btp_field_t;

typedef struct stc_canfd_tscc_field
{
  __IO uint32_t TSS        : 2;
       uint32_t RESERVED1  : 14;
  __IO uint32_t TCP        : 4;
} stc_canfd_tscc_field_t;

typedef struct stc_canfd_tscv_field
{
  __IO uint32_t TSC        : 16;
} stc_canfd_tscv_field_t;

typedef struct stc_canfd_tocc_field
{
  __IO uint32_t ETOC       : 1;
  __IO uint32_t TOS        : 2;
       uint32_t RESERVED1  : 13;
  __IO uint32_t TOP        : 16;
} stc_canfd_tocc_field_t;

typedef struct stc_canfd_tocv_field
{
  __IO uint32_t TOC        : 16;
} stc_canfd_tocv_field_t;

typedef struct stc_canfd_ecr_field
{
  __IO uint32_t TEC        : 8;
  __IO uint32_t REC        : 7;
  __IO uint32_t RP         : 1;
  __IO uint32_t CEL        : 8;
} stc_canfd_ecr_field_t;

typedef struct stc_canfd_psr_field
{
  __IO uint32_t LEC        : 3;
  __IO uint32_t ACT        : 2;
  __IO uint32_t EP         : 1;
  __IO uint32_t EW         : 1;
  __IO uint32_t BO         : 1;
  __IO uint32_t FLEC       : 3;
  __IO uint32_t RESI       : 1;
  __IO uint32_t RBRS       : 1;
  __IO uint32_t REDL       : 1;
} stc_canfd_psr_field_t;

typedef struct stc_canfd_ir_field
{
  __IO uint32_t RF0N       : 1;
  __IO uint32_t RF0W       : 1;
  __IO uint32_t RF0F       : 1;
  __IO uint32_t RF0L       : 1;
  __IO uint32_t RF1N       : 1;
  __IO uint32_t RF1W       : 1;
  __IO uint32_t RF1F       : 1;
  __IO uint32_t RF1L       : 1;
  __IO uint32_t HPM        : 1;
  __IO uint32_t TC         : 1;
  __IO uint32_t TCF        : 1;
  __IO uint32_t TFE        : 1;
  __IO uint32_t TEFN       : 1;
  __IO uint32_t TEFW       : 1;
  __IO uint32_t TEFF       : 1;
  __IO uint32_t TEFL       : 1;
  __IO uint32_t TSW        : 1;
  __IO uint32_t MRAF       : 1;
  __IO uint32_t TOO        : 1;
  __IO uint32_t DRX        : 1;
  __IO uint32_t BEC        : 1;
  __IO uint32_t BEU        : 1;
  __IO uint32_t ELO        : 1;
  __IO uint32_t EP         : 1;
  __IO uint32_t EW         : 1;
  __IO uint32_t BO         : 1;
  __IO uint32_t WDI        : 1;
  __IO uint32_t CRCE       : 1;
  __IO uint32_t BE         : 1;
  __IO uint32_t ACKE       : 1;
  __IO uint32_t FOE        : 1;
  __IO uint32_t STE        : 1;
} stc_canfd_ir_field_t;

typedef struct stc_canfd_ie_field
{
  __IO uint32_t RF0NE      : 1;
  __IO uint32_t RF0WE      : 1;
  __IO uint32_t RF0FE      : 1;
  __IO uint32_t RF0LE      : 1;
  __IO uint32_t RF1NE      : 1;
  __IO uint32_t RF1WE      : 1;
  __IO uint32_t RF1FE      : 1;
  __IO uint32_t RF1LE      : 1;
  __IO uint32_t HPME       : 1;
  __IO uint32_t TCE        : 1;
  __IO uint32_t TCFE       : 1;
  __IO uint32_t TFEE       : 1;
  __IO uint32_t TEFNE      : 1;
  __IO uint32_t TEFWE      : 1;
  __IO uint32_t TEFFE      : 1;
  __IO uint32_t TEFLE      : 1;
  __IO uint32_t TSWE       : 1;
  __IO uint32_t MRAFE      : 1;
  __IO uint32_t TOOE       : 1;
  __IO uint32_t DRXE       : 1;
  __IO uint32_t BECE       : 1;
  __IO uint32_t BEUE       : 1;
  __IO uint32_t ELOE       : 1;
  __IO uint32_t EPE        : 1;
  __IO uint32_t EWE        : 1;
  __IO uint32_t BOE        : 1;
  __IO uint32_t WDIE       : 1;
  __IO uint32_t CRCEE      : 1;
  __IO uint32_t BEE        : 1;
  __IO uint32_t ACKEE      : 1;
  __IO uint32_t FOEE       : 1;
  __IO uint32_t STEE       : 1;
} stc_canfd_ie_field_t;

typedef struct stc_canfd_ils_field
{
  __IO uint32_t RF0NL      : 1;
  __IO uint32_t RF0WL      : 1;
  __IO uint32_t RF0FL      : 1;
  __IO uint32_t RF0LL      : 1;
  __IO uint32_t RF1NL      : 1;
  __IO uint32_t RF1WL      : 1;
  __IO uint32_t RF1FL      : 1;
  __IO uint32_t RF1LL      : 1;
  __IO uint32_t HPML       : 1;
  __IO uint32_t TCL        : 1;
  __IO uint32_t TCFL       : 1;
  __IO uint32_t TFEL       : 1;
  __IO uint32_t TEFNL      : 1;
  __IO uint32_t TEFWL      : 1;
  __IO uint32_t TEFFL      : 1;
  __IO uint32_t TEFLL      : 1;
  __IO uint32_t TSWL       : 1;
  __IO uint32_t MRAFL      : 1;
  __IO uint32_t TOOL       : 1;
  __IO uint32_t DRXL       : 1;
  __IO uint32_t BECL       : 1;
  __IO uint32_t BEUL       : 1;
  __IO uint32_t ELOL       : 1;
  __IO uint32_t EPL        : 1;
  __IO uint32_t EWL        : 1;
  __IO uint32_t BOL        : 1;
  __IO uint32_t WDIL       : 1;
  __IO uint32_t CRCEL      : 1;
  __IO uint32_t BEL        : 1;
  __IO uint32_t ACKEL      : 1;
  __IO uint32_t FOEL       : 1;
  __IO uint32_t STEL       : 1;
} stc_canfd_ils_field_t;

typedef struct stc_canfd_ile_field
{
  __IO uint32_t EINT0      : 1;
  __IO uint32_t EINT1      : 1;
} stc_canfd_ile_field_t;

typedef struct stc_canfd_gfc_field
{
  __IO uint32_t RRFE       : 1;
  __IO uint32_t RRFS       : 1;
  __IO uint32_t ANFE       : 2;
  __IO uint32_t ANFS       : 2;
} stc_canfd_gfc_field_t;

typedef struct stc_canfd_sidfc_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t FLSSA      : 14;
  __IO uint32_t LSS        : 8;
} stc_canfd_sidfc_field_t;

typedef struct stc_canfd_xidfc_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t FLESA      : 14;
  __IO uint32_t LSE        : 7;
} stc_canfd_xidfc_field_t;

typedef struct stc_canfd_xidam_field
{
  __IO uint32_t EIDM       : 29;
} stc_canfd_xidam_field_t;

typedef struct stc_canfd_hpms_field
{
  __IO uint32_t BIDX       : 6;
  __IO uint32_t MSI        : 2;
  __IO uint32_t FIDX       : 7;
  __IO uint32_t FLST       : 1;
} stc_canfd_hpms_field_t;

typedef struct stc_canfd_ndat1_field
{
  __IO uint32_t ND0        : 1;
  __IO uint32_t ND1        : 1;
  __IO uint32_t ND2        : 1;
  __IO uint32_t ND3        : 1;
  __IO uint32_t ND4        : 1;
  __IO uint32_t ND5        : 1;
  __IO uint32_t ND6        : 1;
  __IO uint32_t ND7        : 1;
  __IO uint32_t ND8        : 1;
  __IO uint32_t ND9        : 1;
  __IO uint32_t ND10       : 1;
  __IO uint32_t ND11       : 1;
  __IO uint32_t ND12       : 1;
  __IO uint32_t ND13       : 1;
  __IO uint32_t ND14       : 1;
  __IO uint32_t ND15       : 1;
  __IO uint32_t ND16       : 1;
  __IO uint32_t ND17       : 1;
  __IO uint32_t ND18       : 1;
  __IO uint32_t ND19       : 1;
  __IO uint32_t ND20       : 1;
  __IO uint32_t ND21       : 1;
  __IO uint32_t ND22       : 1;
  __IO uint32_t ND23       : 1;
  __IO uint32_t ND24       : 1;
  __IO uint32_t ND25       : 1;
  __IO uint32_t ND26       : 1;
  __IO uint32_t ND27       : 1;
  __IO uint32_t ND28       : 1;
  __IO uint32_t ND29       : 1;
  __IO uint32_t ND30       : 1;
  __IO uint32_t ND31       : 1;
} stc_canfd_ndat1_field_t;

typedef struct stc_canfd_ndat2_field
{
  __IO uint32_t ND32       : 1;
  __IO uint32_t ND33       : 1;
  __IO uint32_t ND34       : 1;
  __IO uint32_t ND35       : 1;
  __IO uint32_t ND36       : 1;
  __IO uint32_t ND37       : 1;
  __IO uint32_t ND38       : 1;
  __IO uint32_t ND39       : 1;
  __IO uint32_t ND40       : 1;
  __IO uint32_t ND41       : 1;
  __IO uint32_t ND42       : 1;
  __IO uint32_t ND43       : 1;
  __IO uint32_t ND44       : 1;
  __IO uint32_t ND45       : 1;
  __IO uint32_t ND46       : 1;
  __IO uint32_t ND47       : 1;
  __IO uint32_t ND48       : 1;
  __IO uint32_t ND49       : 1;
  __IO uint32_t ND50       : 1;
  __IO uint32_t ND51       : 1;
  __IO uint32_t ND52       : 1;
  __IO uint32_t ND53       : 1;
  __IO uint32_t ND54       : 1;
  __IO uint32_t ND55       : 1;
  __IO uint32_t ND56       : 1;
  __IO uint32_t ND57       : 1;
  __IO uint32_t ND58       : 1;
  __IO uint32_t ND59       : 1;
  __IO uint32_t ND60       : 1;
  __IO uint32_t ND61       : 1;
  __IO uint32_t ND62       : 1;
  __IO uint32_t ND63       : 1;
} stc_canfd_ndat2_field_t;

typedef struct stc_canfd_rxf0c_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t F0SA       : 14;
  __IO uint32_t F0S        : 7;
       uint32_t RESERVED2  : 1;
  __IO uint32_t F0WM       : 7;
  __IO uint32_t F0OM       : 1;
} stc_canfd_rxf0c_field_t;

typedef struct stc_canfd_rxf0s_field
{
  __IO uint32_t F0FL       : 7;
       uint32_t RESERVED1  : 1;
  __IO uint32_t F0GI       : 6;
       uint32_t RESERVED2  : 2;
  __IO uint32_t F0PI       : 6;
       uint32_t RESERVED3  : 2;
  __IO uint32_t F0F        : 1;
  __IO uint32_t RF0L       : 1;
} stc_canfd_rxf0s_field_t;

typedef struct stc_canfd_rxf0a_field
{
  __IO uint32_t F0AI       : 6;
} stc_canfd_rxf0a_field_t;

typedef struct stc_canfd_rxbc_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t RBSA       : 14;
} stc_canfd_rxbc_field_t;

typedef struct stc_canfd_rxf1c_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t F1SA       : 14;
  __IO uint32_t F1S        : 7;
       uint32_t RESERVED2  : 1;
  __IO uint32_t F1WM       : 7;
  __IO uint32_t F1OM       : 1;
} stc_canfd_rxf1c_field_t;

typedef struct stc_canfd_rxf1s_field
{
  __IO uint32_t F1FL       : 7;
       uint32_t RESERVED1  : 1;
  __IO uint32_t F1GI       : 6;
       uint32_t RESERVED2  : 2;
  __IO uint32_t F1PI       : 6;
       uint32_t RESERVED3  : 2;
  __IO uint32_t F1F        : 1;
  __IO uint32_t RF1L       : 1;
       uint32_t RESERVED4  : 4;
  __IO uint32_t DMS        : 2;
} stc_canfd_rxf1s_field_t;

typedef struct stc_canfd_rxf1a_field
{
  __IO uint32_t F1AI       : 6;
} stc_canfd_rxf1a_field_t;

typedef struct stc_canfd_rxesc_field
{
  __IO uint32_t F0DS       : 3;
       uint32_t RESERVED1  : 1;
  __IO uint32_t F1DS       : 3;
       uint32_t RESERVED2  : 1;
  __IO uint32_t RBDS       : 3;
} stc_canfd_rxesc_field_t;

typedef struct stc_canfd_txbc_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t TBSA       : 14;
  __IO uint32_t NDTB       : 6;
       uint32_t RESERVED2  : 2;
  __IO uint32_t TFQS       : 6;
  __IO uint32_t TFQM       : 1;
} stc_canfd_txbc_field_t;

typedef struct stc_canfd_txfqs_field
{
  __IO uint32_t TFFL       : 6;
       uint32_t RESERVED1  : 2;
  __IO uint32_t TFGI       : 5;
       uint32_t RESERVED2  : 3;
  __IO uint32_t TFQPI      : 5;
  __IO uint32_t TFQF       : 1;
} stc_canfd_txfqs_field_t;

typedef struct stc_canfd_txesc_field
{
  __IO uint32_t TBDS       : 3;
} stc_canfd_txesc_field_t;

typedef struct stc_canfd_txbrp_field
{
  __IO uint32_t TRP0       : 1;
  __IO uint32_t TRP1       : 1;
  __IO uint32_t TRP2       : 1;
  __IO uint32_t TRP3       : 1;
  __IO uint32_t TRP4       : 1;
  __IO uint32_t TRP5       : 1;
  __IO uint32_t TRP6       : 1;
  __IO uint32_t TRP7       : 1;
  __IO uint32_t TRP8       : 1;
  __IO uint32_t TRP9       : 1;
  __IO uint32_t TRP10      : 1;
  __IO uint32_t TRP11      : 1;
  __IO uint32_t TRP12      : 1;
  __IO uint32_t TRP13      : 1;
  __IO uint32_t TRP14      : 1;
  __IO uint32_t TRP15      : 1;
  __IO uint32_t TRP16      : 1;
  __IO uint32_t TRP17      : 1;
  __IO uint32_t TRP18      : 1;
  __IO uint32_t TRP19      : 1;
  __IO uint32_t TRP20      : 1;
  __IO uint32_t TRP21      : 1;
  __IO uint32_t TRP22      : 1;
  __IO uint32_t TRP23      : 1;
  __IO uint32_t TRP24      : 1;
  __IO uint32_t TRP25      : 1;
  __IO uint32_t TRP26      : 1;
  __IO uint32_t TRP27      : 1;
  __IO uint32_t TRP28      : 1;
  __IO uint32_t TRP29      : 1;
  __IO uint32_t TRP30      : 1;
  __IO uint32_t TRP31      : 1;
} stc_canfd_txbrp_field_t;

typedef struct stc_canfd_txbar_field
{
  __IO uint32_t AR0        : 1;
  __IO uint32_t AR1        : 1;
  __IO uint32_t AR2        : 1;
  __IO uint32_t AR3        : 1;
  __IO uint32_t AR4        : 1;
  __IO uint32_t AR5        : 1;
  __IO uint32_t AR6        : 1;
  __IO uint32_t AR7        : 1;
  __IO uint32_t AR8        : 1;
  __IO uint32_t AR9        : 1;
  __IO uint32_t AR10       : 1;
  __IO uint32_t AR11       : 1;
  __IO uint32_t AR12       : 1;
  __IO uint32_t AR13       : 1;
  __IO uint32_t AR14       : 1;
  __IO uint32_t AR15       : 1;
  __IO uint32_t AR16       : 1;
  __IO uint32_t AR17       : 1;
  __IO uint32_t AR18       : 1;
  __IO uint32_t AR19       : 1;
  __IO uint32_t AR20       : 1;
  __IO uint32_t AR21       : 1;
  __IO uint32_t AR22       : 1;
  __IO uint32_t AR23       : 1;
  __IO uint32_t AR24       : 1;
  __IO uint32_t AR25       : 1;
  __IO uint32_t AR26       : 1;
  __IO uint32_t AR27       : 1;
  __IO uint32_t AR28       : 1;
  __IO uint32_t AR29       : 1;
  __IO uint32_t AR30       : 1;
  __IO uint32_t AR31       : 1;
} stc_canfd_txbar_field_t;

typedef struct stc_canfd_txbcr_field
{
  __IO uint32_t CR0        : 1;
  __IO uint32_t CR1        : 1;
  __IO uint32_t CR2        : 1;
  __IO uint32_t CR3        : 1;
  __IO uint32_t CR4        : 1;
  __IO uint32_t CR5        : 1;
  __IO uint32_t CR6        : 1;
  __IO uint32_t CR7        : 1;
  __IO uint32_t CR8        : 1;
  __IO uint32_t CR9        : 1;
  __IO uint32_t CR10       : 1;
  __IO uint32_t CR11       : 1;
  __IO uint32_t CR12       : 1;
  __IO uint32_t CR13       : 1;
  __IO uint32_t CR14       : 1;
  __IO uint32_t CR15       : 1;
  __IO uint32_t CR16       : 1;
  __IO uint32_t CR17       : 1;
  __IO uint32_t CR18       : 1;
  __IO uint32_t CR19       : 1;
  __IO uint32_t CR20       : 1;
  __IO uint32_t CR21       : 1;
  __IO uint32_t CR22       : 1;
  __IO uint32_t CR23       : 1;
  __IO uint32_t CR24       : 1;
  __IO uint32_t CR25       : 1;
  __IO uint32_t CR26       : 1;
  __IO uint32_t CR27       : 1;
  __IO uint32_t CR28       : 1;
  __IO uint32_t CR29       : 1;
  __IO uint32_t CR30       : 1;
  __IO uint32_t CR31       : 1;
} stc_canfd_txbcr_field_t;

typedef struct stc_canfd_txbto_field
{
  __IO uint32_t TO0        : 1;
  __IO uint32_t TO1        : 1;
  __IO uint32_t TO2        : 1;
  __IO uint32_t TO3        : 1;
  __IO uint32_t TO4        : 1;
  __IO uint32_t TO5        : 1;
  __IO uint32_t TO6        : 1;
  __IO uint32_t TO7        : 1;
  __IO uint32_t TO8        : 1;
  __IO uint32_t TO9        : 1;
  __IO uint32_t TO10       : 1;
  __IO uint32_t TO11       : 1;
  __IO uint32_t TO12       : 1;
  __IO uint32_t TO13       : 1;
  __IO uint32_t TO14       : 1;
  __IO uint32_t TO15       : 1;
  __IO uint32_t TO16       : 1;
  __IO uint32_t TO17       : 1;
  __IO uint32_t TO18       : 1;
  __IO uint32_t TO19       : 1;
  __IO uint32_t TO20       : 1;
  __IO uint32_t TO21       : 1;
  __IO uint32_t TO22       : 1;
  __IO uint32_t TO23       : 1;
  __IO uint32_t TO24       : 1;
  __IO uint32_t TO25       : 1;
  __IO uint32_t TO26       : 1;
  __IO uint32_t TO27       : 1;
  __IO uint32_t TO28       : 1;
  __IO uint32_t TO29       : 1;
  __IO uint32_t TO30       : 1;
  __IO uint32_t TO31       : 1;
} stc_canfd_txbto_field_t;

typedef struct stc_canfd_txbcf_field
{
  __IO uint32_t CF0        : 1;
  __IO uint32_t CF1        : 1;
  __IO uint32_t CF2        : 1;
  __IO uint32_t CF3        : 1;
  __IO uint32_t CF4        : 1;
  __IO uint32_t CF5        : 1;
  __IO uint32_t CF6        : 1;
  __IO uint32_t CF7        : 1;
  __IO uint32_t CF8        : 1;
  __IO uint32_t CF9        : 1;
  __IO uint32_t CF10       : 1;
  __IO uint32_t CF11       : 1;
  __IO uint32_t CF12       : 1;
  __IO uint32_t CF13       : 1;
  __IO uint32_t CF14       : 1;
  __IO uint32_t CF15       : 1;
  __IO uint32_t CF16       : 1;
  __IO uint32_t CF17       : 1;
  __IO uint32_t CF18       : 1;
  __IO uint32_t CF19       : 1;
  __IO uint32_t CF20       : 1;
  __IO uint32_t CF21       : 1;
  __IO uint32_t CF22       : 1;
  __IO uint32_t CF23       : 1;
  __IO uint32_t CF24       : 1;
  __IO uint32_t CF25       : 1;
  __IO uint32_t CF26       : 1;
  __IO uint32_t CF27       : 1;
  __IO uint32_t CF28       : 1;
  __IO uint32_t CF29       : 1;
  __IO uint32_t CF30       : 1;
  __IO uint32_t CF31       : 1;
} stc_canfd_txbcf_field_t;

typedef struct stc_canfd_txbtie_field
{
  __IO uint32_t TIE0       : 1;
  __IO uint32_t TIE1       : 1;
  __IO uint32_t TIE2       : 1;
  __IO uint32_t TIE3       : 1;
  __IO uint32_t TIE4       : 1;
  __IO uint32_t TIE5       : 1;
  __IO uint32_t TIE6       : 1;
  __IO uint32_t TIE7       : 1;
  __IO uint32_t TIE8       : 1;
  __IO uint32_t TIE9       : 1;
  __IO uint32_t TIE10      : 1;
  __IO uint32_t TIE11      : 1;
  __IO uint32_t TIE12      : 1;
  __IO uint32_t TIE13      : 1;
  __IO uint32_t TIE14      : 1;
  __IO uint32_t TIE15      : 1;
  __IO uint32_t TIE16      : 1;
  __IO uint32_t TIE17      : 1;
  __IO uint32_t TIE18      : 1;
  __IO uint32_t TIE19      : 1;
  __IO uint32_t TIE20      : 1;
  __IO uint32_t TIE21      : 1;
  __IO uint32_t TIE22      : 1;
  __IO uint32_t TIE23      : 1;
  __IO uint32_t TIE24      : 1;
  __IO uint32_t TIE25      : 1;
  __IO uint32_t TIE26      : 1;
  __IO uint32_t TIE27      : 1;
  __IO uint32_t TIE28      : 1;
  __IO uint32_t TIE29      : 1;
  __IO uint32_t TIE30      : 1;
  __IO uint32_t TIE31      : 1;
} stc_canfd_txbtie_field_t;

typedef struct stc_canfd_txbcie_field
{
  __IO uint32_t CFIE0      : 1;
  __IO uint32_t CFIE1      : 1;
  __IO uint32_t CFIE2      : 1;
  __IO uint32_t CFIE3      : 1;
  __IO uint32_t CFIE4      : 1;
  __IO uint32_t CFIE5      : 1;
  __IO uint32_t CFIE6      : 1;
  __IO uint32_t CFIE7      : 1;
  __IO uint32_t CFIE8      : 1;
  __IO uint32_t CFIE9      : 1;
  __IO uint32_t CFIE10     : 1;
  __IO uint32_t CFIE11     : 1;
  __IO uint32_t CFIE12     : 1;
  __IO uint32_t CFIE13     : 1;
  __IO uint32_t CFIE14     : 1;
  __IO uint32_t CFIE15     : 1;
  __IO uint32_t CFIE16     : 1;
  __IO uint32_t CFIE17     : 1;
  __IO uint32_t CFIE18     : 1;
  __IO uint32_t CFIE19     : 1;
  __IO uint32_t CFIE20     : 1;
  __IO uint32_t CFIE21     : 1;
  __IO uint32_t CFIE22     : 1;
  __IO uint32_t CFIE23     : 1;
  __IO uint32_t CFIE24     : 1;
  __IO uint32_t CFIE25     : 1;
  __IO uint32_t CFIE26     : 1;
  __IO uint32_t CFIE27     : 1;
  __IO uint32_t CFIE28     : 1;
  __IO uint32_t CFIE29     : 1;
  __IO uint32_t CFIE30     : 1;
  __IO uint32_t CFIE31     : 1;
} stc_canfd_txbcie_field_t;

typedef struct stc_canfd_txefc_field
{
       uint32_t RESERVED1  : 2;
  __IO uint32_t EFSA       : 14;
  __IO uint32_t EFS        : 6;
       uint32_t RESERVED2  : 2;
  __IO uint32_t EFWM       : 6;
} stc_canfd_txefc_field_t;

typedef struct stc_canfd_txfs_field
{
  __IO uint32_t EFFL       : 6;
       uint32_t RESERVED1  : 2;
  __IO uint32_t EFGI       : 5;
       uint32_t RESERVED2  : 3;
  __IO uint32_t EFPI       : 5;
       uint32_t RESERVED3  : 3;
  __IO uint32_t EFF        : 1;
  __IO uint32_t TEFL       : 1;
} stc_canfd_txfs_field_t;

typedef struct stc_canfd_txfa_field
{
  __IO uint32_t EFAI       : 5;
} stc_canfd_txfa_field_t;

typedef struct stc_canfd_fdecr_field
{
  __IO  uint8_t SEIE       : 1;
  __IO  uint8_t DEIE       : 1;
  __IO  uint8_t CEREN      : 1;
  __IO  uint8_t CEIV       : 1;
} stc_canfd_fdecr_field_t;

typedef struct stc_canfd_fdesr_field
{
  __IO  uint8_t SEI        : 1;
  __IO  uint8_t DEI        : 1;
} stc_canfd_fdesr_field_t;

typedef struct stc_canfd_fdsear_field
{
  __IO uint16_t SRA        : 16;
} stc_canfd_fdsear_field_t;

typedef struct stc_canfd_fdescr_field
{
  __IO  uint8_t SEIC       : 1;
  __IO  uint8_t DEIC       : 1;
} stc_canfd_fdescr_field_t;

typedef struct stc_canfd_fddear_field
{
  __IO uint16_t DRA        : 16;
} stc_canfd_fddear_field_t;

typedef struct stc_canfd_tscntr_field
{
  __IO uint16_t CCLR       : 1;
} stc_canfd_tscntr_field_t;

typedef struct stc_canfd_tsmdr_field
{
  __IO uint16_t CNTEN      : 1;
} stc_canfd_tsmdr_field_t;

typedef struct stc_canfd_tsdivr_field
{
  __IO uint32_t CDIV       : 16;
} stc_canfd_tsdivr_field_t;

typedef struct stc_canfd_tscdtr_field
{
  __IO uint16_t CNT        : 16;
} stc_canfd_tscdtr_field_t;

typedef struct stc_canfd_tscpclr_field
{
  __IO uint16_t CMP        : 16;
} stc_canfd_tscpclr_field_t;

/******************************************************************************
 * PCRC_MODULE
 ******************************************************************************/
/* PCRC_MODULE register bit fields */
typedef struct stc_pcrc_prgcrc_cfg_field
{
  __IO uint32_t CIRQCLR    : 1;
       uint32_t RESERVED0  : 7;
  __IO uint32_t FO         : 2;
  __IO uint32_t FI         : 2;
       uint32_t RESERVED1  : 4;
  __IO uint32_t TEST       : 6;
  __IO uint32_t SZ         : 2;
  __IO uint32_t CIRQ       : 1;
  __IO uint32_t CIEN       : 1;
  __IO uint32_t CDEN       : 1;
       uint32_t RESERVED2  : 1;
  __IO uint32_t LOCK       : 1;
} stc_pcrc_prgcrc_cfg_field_t;

/******************************************************************************
 * HSSPI_MODULE
 ******************************************************************************/
/* HSSPI_MODULE register bit fields */
typedef struct stc_hsspi_mctrl_field
{
  __IO uint32_t MEN        : 1;
  __IO uint32_t CSEN       : 1;
       uint32_t RESERVED1  : 2;
  __IO uint32_t MES        : 1;
  __IO uint32_t SYNCON     : 1;
} stc_hsspi_mctrl_field_t;

typedef struct stc_hsspi_pcc0_field
{
  __IO uint32_t CPHA       : 1;
  __IO uint32_t CPOL       : 1;
  __IO uint32_t ACES       : 1;
  __IO uint32_t RTM        : 1;
  __IO uint32_t SSPOL      : 1;
  __IO uint32_t SS2CD      : 2;
  __IO uint32_t SDIR       : 1;
  __IO uint32_t SENDIAN    : 1;
  __IO uint32_t CDRS       : 7;
  __IO uint32_t SAFESYNC   : 1;
  __IO uint32_t WRDSEL     : 4;
  __IO uint32_t RDDSEL     : 2;
} stc_hsspi_pcc0_field_t;

typedef struct stc_hsspi_pcc1_field
{
  __IO uint32_t CPHA       : 1;
  __IO uint32_t CPOL       : 1;
  __IO uint32_t ACES       : 1;
  __IO uint32_t RTM        : 1;
  __IO uint32_t SSPOL      : 1;
  __IO uint32_t SS2CD      : 2;
  __IO uint32_t SDIR       : 1;
  __IO uint32_t SENDIAN    : 1;
  __IO uint32_t CDRS       : 7;
  __IO uint32_t SAFESYNC   : 1;
  __IO uint32_t WRDSEL     : 4;
  __IO uint32_t RDDSEL     : 2;
} stc_hsspi_pcc1_field_t;

typedef struct stc_hsspi_pcc2_field
{
  __IO uint32_t CPHA       : 1;
  __IO uint32_t CPOL       : 1;
  __IO uint32_t ACES       : 1;
  __IO uint32_t RTM        : 1;
  __IO uint32_t SSPOL      : 1;
  __IO uint32_t SS2CD      : 2;
  __IO uint32_t SDIR       : 1;
  __IO uint32_t SENDIAN    : 1;
  __IO uint32_t CDRS       : 7;
  __IO uint32_t SAFESYNC   : 1;
  __IO uint32_t WRDSEL     : 4;
  __IO uint32_t RDDSEL     : 2;
} stc_hsspi_pcc2_field_t;

typedef struct stc_hsspi_pcc3_field
{
  __IO uint32_t CPHA       : 1;
  __IO uint32_t CPOL       : 1;
  __IO uint32_t ACES       : 1;
  __IO uint32_t RTM        : 1;
  __IO uint32_t SSPOL      : 1;
  __IO uint32_t SS2CD      : 2;
  __IO uint32_t SDIR       : 1;
  __IO uint32_t SENDIAN    : 1;
  __IO uint32_t CDRS       : 7;
  __IO uint32_t SAFESYNC   : 1;
  __IO uint32_t WRDSEL     : 4;
  __IO uint32_t RDDSEL     : 2;
} stc_hsspi_pcc3_field_t;

typedef struct stc_hsspi_txf_field
{
  __IO uint32_t TFFS       : 1;
  __IO uint32_t TFES       : 1;
  __IO uint32_t TFOS       : 1;
  __IO uint32_t TFUS       : 1;
  __IO uint32_t TFLETS     : 1;
  __IO uint32_t TFMTS      : 1;
  __IO uint32_t TSSRS      : 1;
} stc_hsspi_txf_field_t;

typedef struct stc_hsspi_txe_field
{
  __IO uint32_t TFFE       : 1;
  __IO uint32_t TFEE       : 1;
  __IO uint32_t TFOE       : 1;
  __IO uint32_t TFUE       : 1;
  __IO uint32_t TFLETE     : 1;
  __IO uint32_t TFMTE      : 1;
  __IO uint32_t TSSRE      : 1;
} stc_hsspi_txe_field_t;

typedef struct stc_hsspi_txc_field
{
  __IO uint32_t TFFC       : 1;
  __IO uint32_t TFEC       : 1;
  __IO uint32_t TFOC       : 1;
  __IO uint32_t TFUC       : 1;
  __IO uint32_t TFLETC     : 1;
  __IO uint32_t TFMTC      : 1;
  __IO uint32_t TSSRC      : 1;
} stc_hsspi_txc_field_t;

typedef struct stc_hsspi_rxf_field
{
  __IO uint32_t RFFS       : 1;
  __IO uint32_t RFES       : 1;
  __IO uint32_t RFOS       : 1;
  __IO uint32_t RFUS       : 1;
  __IO uint32_t RFLETS     : 1;
  __IO uint32_t RFMTS      : 1;
  __IO uint32_t RSSRS      : 1;
} stc_hsspi_rxf_field_t;

typedef struct stc_hsspi_rxe_field
{
  __IO uint32_t RFFE       : 1;
  __IO uint32_t RFEE       : 1;
  __IO uint32_t RFOE       : 1;
  __IO uint32_t RFUE       : 1;
  __IO uint32_t RFLETE     : 1;
  __IO uint32_t RFMTE      : 1;
  __IO uint32_t RSSRE      : 1;
} stc_hsspi_rxe_field_t;

typedef struct stc_hsspi_rxc_field
{
  __IO uint32_t RFFC       : 1;
  __IO uint32_t RFEC       : 1;
  __IO uint32_t RFOC       : 1;
  __IO uint32_t RFUC       : 1;
  __IO uint32_t RFLETC     : 1;
  __IO uint32_t RFMTC      : 1;
  __IO uint32_t RSSRC      : 1;
} stc_hsspi_rxc_field_t;

typedef struct stc_hsspi_faultf_field
{
  __IO uint32_t UMAFS      : 1;
  __IO uint32_t WAFS       : 1;
  __IO uint32_t PVFS       : 1;
  __IO uint32_t DWCBSFS    : 1;
  __IO uint32_t DRCBSFS    : 1;
} stc_hsspi_faultf_field_t;

typedef struct stc_hsspi_faultc_field
{
  __IO uint32_t UMAFC      : 1;
  __IO uint32_t WAFC       : 1;
  __IO uint32_t PVFC       : 1;
  __IO uint32_t DWCBSFC    : 1;
  __IO uint32_t DRCBSFC    : 1;
} stc_hsspi_faultc_field_t;

typedef struct stc_hsspi_dmcfg_field
{
        uint8_t RESERVED1  : 1;
  __IO  uint8_t SSDC       : 1;
} stc_hsspi_dmcfg_field_t;

typedef struct stc_hsspi_dmdmaen_field
{
  __IO  uint8_t RXDMAEN    : 1;
  __IO  uint8_t TXDMAEN    : 1;
} stc_hsspi_dmdmaen_field_t;

typedef struct stc_hsspi_dmstart_field
{
  __IO  uint8_t START      : 1;
} stc_hsspi_dmstart_field_t;

typedef struct stc_hsspi_dmstop_field
{
  __IO  uint8_t STOP       : 1;
} stc_hsspi_dmstop_field_t;

typedef struct stc_hsspi_dmpsel_field
{
  __IO  uint8_t PSEL       : 2;
} stc_hsspi_dmpsel_field_t;

typedef struct stc_hsspi_dmtrp_field
{
  __IO  uint8_t TRP        : 4;
} stc_hsspi_dmtrp_field_t;

typedef struct stc_hsspi_dmbcc_field
{
  __IO uint16_t BCC        : 16;
} stc_hsspi_dmbcc_field_t;

typedef struct stc_hsspi_dmbcs_field
{
  __IO uint16_t BCS        : 16;
} stc_hsspi_dmbcs_field_t;

typedef struct stc_hsspi_dmstatus_field
{
  __IO uint32_t RXACTIVE   : 1;
  __IO uint32_t TXACTIVE   : 1;
       uint32_t RESERVED1  : 6;
  __IO uint32_t RXFLEVEL   : 5;
       uint32_t RESERVED2  : 3;
  __IO uint32_t TXFLEVEL   : 5;
} stc_hsspi_dmstatus_field_t;

typedef struct stc_hsspi_fifocfg_field
{
  __IO uint32_t RXFTH      : 4;
  __IO uint32_t TXFTH      : 4;
  __IO uint32_t FWIDTH     : 2;
  __IO uint32_t TXCTRL     : 1;
  __IO uint32_t RXFLSH     : 1;
  __IO uint32_t TXFLSH     : 1;
} stc_hsspi_fifocfg_field_t;

typedef struct stc_hsspi_txfifo_field
{
  __IO uint32_t TXDATA     : 32;
} stc_hsspi_txfifo_field_t;

typedef struct stc_hsspi_rxfifo_field
{
  __IO uint32_t RXDATA     : 32;
} stc_hsspi_rxfifo_field_t;

typedef struct stc_hsspi_cscfg_field
{
  __IO uint32_t SRAM       : 1;
  __IO uint32_t MBM        : 2;
       uint32_t RESERVED1  : 5;
  __IO uint32_t SSEL0EN    : 1;
  __IO uint32_t SSEL1EN    : 1;
  __IO uint32_t SSEL2EN    : 1;
  __IO uint32_t SSEL3EN    : 1;
       uint32_t RESERVED2  : 4;
  __IO uint32_t MSEL       : 4;
} stc_hsspi_cscfg_field_t;

typedef struct stc_hsspi_csitime_field
{
  __IO uint32_t ITIME      : 16;
} stc_hsspi_csitime_field_t;

typedef struct stc_hsspi_csaext_field
{
       uint32_t RESERVED1  : 13;
  __IO uint32_t AEXT       : 19;
} stc_hsspi_csaext_field_t;

typedef struct stc_hsspi_rdcsdc_field
{
  __IO uint16_t DEC        : 1;
  __IO uint16_t TRP        : 2;
  __IO uint16_t CONT       : 1;
       uint16_t RESERVED1  : 4;
  __IO uint16_t RDCSDATA   : 8;
} stc_hsspi_rdcsdc_field_t;

typedef struct stc_hsspi_wrcsdc_field
{
  __IO uint16_t DEC        : 1;
  __IO uint16_t TRP        : 2;
  __IO uint16_t CONT       : 1;
       uint16_t RESERVED1  : 4;
  __IO uint16_t WRCSDATA   : 8;
} stc_hsspi_wrcsdc_field_t;

typedef struct stc_hsspi_mid_field
{
  __IO uint32_t MID        : 32;
} stc_hsspi_mid_field_t;

typedef struct stc_hsspi_qdclkr_field
{
  __IO  uint8_t QHDIV      : 4;
} stc_hsspi_qdclkr_field_t;

typedef struct stc_hsspi_dbcnt_field
{
  __IO  uint8_t RXDBEN     : 1;
  __IO  uint8_t TXDBEN     : 1;
} stc_hsspi_dbcnt_field_t;

/******************************************************************************
 * Peripheral register structures
 ******************************************************************************/

/******************************************************************************
 * FLASH_IF_MODULE
 ******************************************************************************/
/* FLASH_IF registers */
typedef struct
{
  union {
    __IO uint32_t FASZR;
    stc_flash_if_faszr_field_t FASZR_f;
  };
  union {
    __IO uint32_t FRWTR;
    stc_flash_if_frwtr_field_t FRWTR_f;
  };
  union {
    __IO uint32_t FSTR;
    stc_flash_if_fstr_field_t FSTR_f;
  };
        uint8_t RESERVED1[4];
  union {
    __IO uint32_t FSYNDN;
    stc_flash_if_fsyndn_field_t FSYNDN_f;
  };
  union {
    __IO uint32_t FBFCR;
    stc_flash_if_fbfcr_field_t FBFCR_f;
  };
        uint8_t RESERVED2[8];
  union {
    __IO uint32_t FICR;
    stc_flash_if_ficr_field_t FICR_f;
  };
  union {
    __IO uint32_t FISR;
    stc_flash_if_fisr_field_t FISR_f;
  };
  union {
    __IO uint32_t FICLR;
    stc_flash_if_ficlr_field_t FICLR_f;
  };
        uint8_t RESERVED3[4];
  union {
    __IO uint32_t DFCTRLR;
    stc_flash_if_dfctrlr_field_t DFCTRLR_f;
  };
        uint8_t RESERVED4[204];
  union {
    __IO uint32_t CRTRMM;
    stc_flash_if_crtrmm_field_t CRTRMM_f;
  };
        uint8_t RESERVED5[12];
  union {
    __IO uint32_t FGPDM1;
    stc_flash_if_fgpdm1_field_t FGPDM1_f;
  };
  union {
    __IO uint32_t FGPDM2;
    stc_flash_if_fgpdm2_field_t FGPDM2_f;
  };
  union {
    __IO uint32_t FGPDM3;
    stc_flash_if_fgpdm3_field_t FGPDM3_f;
  };
  union {
    __IO uint32_t FGPDM4;
    stc_flash_if_fgpdm4_field_t FGPDM4_f;
  };
}FM_FLASH_IF_TypeDef;

/******************************************************************************
 * DUALFLASH_IF_MODULE
 ******************************************************************************/
/* DUALFLASH_IF registers */
typedef struct
{
  union {
    __IO uint32_t DFASZR;
    stc_dualflash_if_dfaszr_field_t DFASZR_f;
  };
  union {
    __IO uint32_t DFRWTR;
    stc_dualflash_if_dfrwtr_field_t DFRWTR_f;
  };
  union {
    __IO uint32_t DFSTR;
    stc_dualflash_if_dfstr_field_t DFSTR_f;
  };
}FM_DUALFLASH_IF_TypeDef;

/******************************************************************************
 * UNIQUE_ID_MODULE
 ******************************************************************************/
/* Unique ID registers */
typedef struct
{
  union {
    __IO uint32_t UIDR0;
    stc_unique_id_uidr0_field_t UIDR0_f;
  };
  union {
    __IO uint32_t UIDR1;
    stc_unique_id_uidr1_field_t UIDR1_f;
  };
}FM_UNIQUE_ID_TypeDef;

/******************************************************************************
 * ECC_CAPTURE_MODULE
 ******************************************************************************/
/* ECC Capture address registers */
typedef struct
{
  union {
    __IO uint32_t FERRAD;
    stc_ecc_capture_ferrad_field_t FERRAD_f;
  };
}FM_ECC_CAPTURE_TypeDef;

/******************************************************************************
 * Clock_Reset_MODULE
 ******************************************************************************/
/* Clock and reset registers */
typedef struct
{
  union {
    __IO uint32_t SCM_CTL;
    stc_crg_scm_ctl_field_t SCM_CTL_f;
  };
  union {
    __IO uint32_t SCM_STR;
    stc_crg_scm_str_field_t SCM_STR_f;
  };
  __IO uint32_t STB_CTL;
  union {
    __IO uint32_t RST_STR;
    stc_crg_rst_str_field_t RST_STR_f;
  };
  union {
    __IO uint32_t BSC_PSR;
    stc_crg_bsc_psr_field_t BSC_PSR_f;
  };
  union {
    __IO uint32_t APBC0_PSR;
    stc_crg_apbc0_psr_field_t APBC0_PSR_f;
  };
  union {
    __IO uint32_t APBC1_PSR;
    stc_crg_apbc1_psr_field_t APBC1_PSR_f;
  };
  union {
    __IO uint32_t APBC2_PSR;
    stc_crg_apbc2_psr_field_t APBC2_PSR_f;
  };
  union {
    __IO uint32_t SWC_PSR;
    stc_crg_swc_psr_field_t SWC_PSR_f;
  };
        uint8_t RESERVED7[4];
  union {
    __IO uint32_t TTC_PSR;
    stc_crg_ttc_psr_field_t TTC_PSR_f;
  };
        uint8_t RESERVED8[4];
  union {
    __IO uint32_t CSW_TMR;
    stc_crg_csw_tmr_field_t CSW_TMR_f;
  };
  union {
    __IO uint32_t PSW_TMR;
    stc_crg_psw_tmr_field_t PSW_TMR_f;
  };
  union {
    __IO uint32_t PLL_CTL1;
    stc_crg_pll_ctl1_field_t PLL_CTL1_f;
  };
  union {
    __IO uint32_t PLL_CTL2;
    stc_crg_pll_ctl2_field_t PLL_CTL2_f;
  };
  union {
    __IO uint32_t CSV_CTL;
    stc_crg_csv_ctl_field_t CSV_CTL_f;
  };
  union {
    __IO uint32_t CSV_STR;
    stc_crg_csv_str_field_t CSV_STR_f;
  };
  __IO uint32_t FCSWH_CTL;
  __IO uint32_t FCSWL_CTL;
  __IO uint32_t FCSWD_CTL;
  union {
    __IO uint32_t DBWDT_CTL;
    stc_crg_dbwdt_ctl_field_t DBWDT_CTL_f;
  };
        uint8_t RESERVED18[8];
  union {
    __IO uint32_t INT_ENR;
    stc_crg_int_enr_field_t INT_ENR_f;
  };
  union {
    __IO uint32_t INT_STR;
    stc_crg_int_str_field_t INT_STR_f;
  };
  union {
    __IO  uint8_t INT_CLR;
    stc_crg_int_clr_field_t INT_CLR_f;
  };
}FM_CRG_TypeDef;

/******************************************************************************
 * HWWDT_MODULE
 ******************************************************************************/
/* Hardware watchdog registers */
typedef struct
{
  __IO uint32_t WDG_LDR;
  __IO uint32_t WDG_VLR;
  union {
    __IO uint32_t WDG_CTL;
    stc_hwwdt_wdg_ctl_field_t WDG_CTL_f;
  };
  __IO uint32_t WDG_ICL;
  union {
    __IO uint32_t WDG_RIS;
    stc_hwwdt_wdg_ris_field_t WDG_RIS_f;
  };
        uint8_t RESERVED2[3052];
  __IO uint32_t WDG_LCK;
}FM_HWWDT_TypeDef;

/******************************************************************************
 * SWWDT_MODULE
 ******************************************************************************/
/* Software watchdog registers */
typedef struct
{
  __IO uint32_t WDOGLOAD;
  __IO uint32_t WDOGVALUE;
  union {
    __IO uint32_t                 WDOGCONTROL;
    stc_swwdt_wdogcontrol_field_t WDOGCONTROL_f;
  };
  __IO uint32_t WDOGINTCLR;
  union {
    __IO uint32_t             WDOGRIS;
    stc_swwdt_wdogris_field_t WDOGRIS_f;
  };
        uint8_t RESERVED1[4];
  union {
    __IO uint32_t              WDOGSPMC;
    stc_swwdt_wdogspmc_field_t WDOGSPMC_f;
  };
        uint8_t RESERVED2[3044];
  __IO uint32_t WDOGLOCK;
}FM_SWWDT_TypeDef;

/******************************************************************************
 * DTIM_MODULE
 ******************************************************************************/
/* Dual timer 1/2 registers */
typedef struct
{
  __IO uint32_t TIMERXLOAD;
  __IO uint32_t TIMERXVALUE;
  union {
    __IO uint32_t                  TIMERXCONTROL;
    stc_dtim_timerXcontrol_field_t TIMERXCONTROL_f;
  };
  __IO uint32_t TIMERXINTCLR;
  union {
    __IO uint32_t              TIMERXRIS;
    stc_dtim_timerXris_field_t TIMERXRIS_f;
  };
  union {
    __IO uint32_t              TIMERXMIS;
    stc_dtim_timerXmis_field_t TIMERXMIS_f;
  };
  __IO uint32_t TIMERXBGLOAD;
        uint8_t RESERVED0[4];
}FM_DTIM_TypeDef;

/******************************************************************************
 * MFT_FRT_MODULE
 ******************************************************************************/
/* Multifunction Timer unit 0 Free Running Timer registers */
typedef struct
{
        uint8_t RESERVED0[66];
  __IO uint16_t TCCP0;
        uint8_t RESERVED1[2];
  __IO uint16_t TCDT0;
  union {
    __IO uint16_t TCSA0;
    stc_mft_frt_tcsa0_field_t TCSA0_f;
  };
  union {
    __IO uint16_t TCSC0;
    stc_mft_frt_tcsc0_field_t TCSC0_f;
  };
        uint8_t RESERVED2[2];
  __IO uint16_t TCCP1;
        uint8_t RESERVED3[2];
  __IO uint16_t TCDT1;
  union {
    __IO uint16_t TCSA1;
    stc_mft_frt_tcsa1_field_t TCSA1_f;
  };
  union {
    __IO uint16_t TCSC1;
    stc_mft_frt_tcsc1_field_t TCSC1_f;
  };
        uint8_t RESERVED4[2];
  __IO uint16_t TCCP2;
        uint8_t RESERVED5[2];
  __IO uint16_t TCDT2;
  union {
    __IO uint16_t TCSA2;
    stc_mft_frt_tcsa2_field_t TCSA2_f;
  };
  union {
    __IO uint16_t TCSC2;
    stc_mft_frt_tcsc2_field_t TCSC2_f;
  };
  union {
    __IO uint32_t TCAL;
    stc_mft_frt_tcal_field_t TCAL_f;
  };
        uint8_t RESERVED6[132];
  union {
    __IO uint32_t TCSD;
    stc_mft_frt_tcsd_field_t TCSD_f;
  };
}FM_MFT_FRT_TypeDef;

/******************************************************************************
 * MFT_OCU_MODULE
 ******************************************************************************/
/* Multifunction Timer unit 0 Output Compare Unit registers */
typedef struct
{
        uint8_t RESERVED0[2];
  __IO uint16_t OCCP0;
        uint8_t RESERVED1[2];
  __IO uint16_t OCCP1;
        uint8_t RESERVED2[2];
  __IO uint16_t OCCP2;
        uint8_t RESERVED3[2];
  __IO uint16_t OCCP3;
        uint8_t RESERVED4[2];
  __IO uint16_t OCCP4;
        uint8_t RESERVED5[2];
  __IO uint16_t OCCP5;
  union {
    __IO  uint8_t OCSA10;
    stc_mft_ocu_ocsa10_field_t OCSA10_f;
  };
  union {
    __IO  uint8_t OCSB10;
    stc_mft_ocu_ocsb10_field_t OCSB10_f;
  };
  union {
    __IO uint16_t OCSD10;
    stc_mft_ocu_ocsd10_field_t OCSD10_f;
  };
  union {
    __IO  uint8_t OCSA32;
    stc_mft_ocu_ocsa32_field_t OCSA32_f;
  };
  union {
    __IO  uint8_t OCSB32;
    stc_mft_ocu_ocsb32_field_t OCSB32_f;
  };
  union {
    __IO uint16_t OCSD32;
    stc_mft_ocu_ocsd32_field_t OCSD32_f;
  };
  union {
    __IO  uint8_t OCSA54;
    stc_mft_ocu_ocsa54_field_t OCSA54_f;
  };
  union {
    __IO  uint8_t OCSB54;
    stc_mft_ocu_ocsb54_field_t OCSB54_f;
  };
  union {
    __IO uint16_t OCSD54;
    stc_mft_ocu_ocsd54_field_t OCSD54_f;
  };
        uint8_t RESERVED8[1];
  union {
    __IO  uint8_t OCSC;
    stc_mft_ocu_ocsc_field_t OCSC_f;
  };
        uint8_t RESERVED9[2];
  union {
    __IO  uint16_t OCSE0;
    stc_mft_ocu_ocse0_field_t OCSE0_f;
  };
        uint8_t RESERVED10[2];
  union {
    __IO  uint32_t OCSE1;
    stc_mft_ocu_ocse1_field_t OCSE1_f;
  };
  union {
    __IO  uint16_t OCSE2;
    stc_mft_ocu_ocse2_field_t OCSE2_f;
  };
        uint8_t RESERVED11[2];
  union {
    __IO  uint32_t OCSE3;
    stc_mft_ocu_ocse3_field_t OCSE3_f;
  };
  union {
    __IO  uint16_t OCSE4;
    stc_mft_ocu_ocse4_field_t OCSE4_f;
  };
        uint8_t RESERVED12[2];
  union {
    __IO  uint32_t OCSE5;
    stc_mft_ocu_ocse5_field_t OCSE5_f;
  };
        uint8_t RESERVED13[40];
  union {
    __IO  uint8_t OCFS10;
    stc_mft_ocu_ocfs10_field_t OCFS10_f;
  };
  union {
    __IO  uint8_t OCFS32;
    stc_mft_ocu_ocfs32_field_t OCFS32_f;
  };
  union {
    __IO  uint8_t OCFS54;
    stc_mft_ocu_ocfs54_field_t OCFS54_f;
  };
}FM_MFT_OCU_TypeDef;

/******************************************************************************
 * MFT_WFG_MODULE
 ******************************************************************************/
/* Multifunction Timer unit 0 Waveform Generator and Noise Canceler registers */
typedef struct
{
        uint8_t RESERVED0[142];
  __IO uint16_t WFTF10;
  __IO uint16_t WFTA10;
  __IO uint16_t WFTB10;
        uint8_t RESERVED1[2];
  __IO uint16_t WFTF32;
  __IO uint16_t WFTA32;
  __IO uint16_t WFTB32;
        uint8_t RESERVED2[2];
  __IO uint16_t WFTF54;
  __IO uint16_t WFTA54;
  __IO uint16_t WFTB54;
  union {
    __IO uint16_t WFSA10;
    stc_mft_wfg_wfsa10_field_t WFSA10_f;
  };
        uint8_t RESERVED3[2];
  union {
    __IO uint16_t WFSA32;
    stc_mft_wfg_wfsa32_field_t WFSA32_f;
  };
        uint8_t RESERVED4[2];
  union {
    __IO uint16_t WFSA54;
    stc_mft_wfg_wfsa54_field_t WFSA54_f;
  };
        uint8_t RESERVED5[2];
  union {
    __IO uint16_t WFIR;
    stc_mft_wfg_wfir_field_t WFIR_f;
  };
        uint8_t RESERVED6[2];
  union {
    __IO uint16_t NZCL;
    stc_mft_wfg_nzcl_field_t NZCL_f;
  };
}FM_MFT_WFG_TypeDef;

/******************************************************************************
 * MFT_ICU_MODULE
 ******************************************************************************/
/* Multifunction Timer unit 0 Input Capture Unit registers */
typedef struct
{
        uint8_t RESERVED0[108];
  union {
    __IO  uint8_t ICFS10;
    stc_mft_icu_icfs10_field_t ICFS10_f;
  };
  union {
    __IO  uint8_t ICFS32;
    stc_mft_icu_icfs32_field_t ICFS32_f;
  };
        uint8_t RESERVED1[8];
  __IO uint16_t ICCP0;
        uint8_t RESERVED2[2];
  __IO uint16_t ICCP1;
        uint8_t RESERVED3[2];
  __IO uint16_t ICCP2;
        uint8_t RESERVED4[2];
  __IO uint16_t ICCP3;
  union {
    __IO  uint8_t ICSA10;
    stc_mft_icu_icsa10_field_t ICSA10_f;
  };
  union {
    __IO  uint8_t ICSB10;
    stc_mft_icu_icsb10_field_t ICSB10_f;
  };
        uint8_t RESERVED6[2];
  union {
    __IO  uint8_t ICSA32;
    stc_mft_icu_icsa32_field_t ICSA32_f;
  };
  union {
    __IO  uint8_t ICSB32;
    stc_mft_icu_icsb32_field_t ICSB32_f;
  };
}FM_MFT_ICU_TypeDef;

/******************************************************************************
 * MFT_ADCMP_MODULE
 ******************************************************************************/
/* Multifunction Timer unit 0 ADC Start Compare Unit registers */
typedef struct
{
        uint8_t RESERVED0[112];
  union {
    __IO  uint8_t ACFS10;
    stc_mft_adcmp_acfs10_field_t ACFS10_f;
  };
  union {
    __IO  uint8_t ACFS32;
    stc_mft_adcmp_acfs32_field_t ACFS32_f;
  };
  union {
    __IO  uint8_t ACFS54;
    stc_mft_adcmp_acfs54_field_t ACFS54_f;
  };
        uint8_t RESERVED1[71];
  __IO uint16_t ACMP0;
        uint8_t RESERVED2[2];
  __IO uint16_t ACMP1;
        uint8_t RESERVED3[2];
  __IO uint16_t ACMP2;
        uint8_t RESERVED4[2];
  __IO uint16_t ACMP3;
        uint8_t RESERVED5[2];
  __IO uint16_t ACMP4;
        uint8_t RESERVED6[2];
  __IO uint16_t ACMP5;
  union {
    __IO  uint16_t ACSA;
    stc_mft_adcmp_acsa_field_t ACSA_f;
  };
        uint8_t RESERVED7[2];
  union {
    __IO  uint8_t ACSC0;
    stc_mft_adcmp_acsc_field_t ACSC0_f;
  };
  union {
    __IO  uint8_t ACSD0;
    stc_mft_adcmp_acsd_field_t ACSD0_f;
  };
  union {
    __IO  uint8_t ACMC0;
    stc_mft_adcmp_acmc_field_t ACMC0_f;
  };
        uint8_t RESERVED8[1];
  union {
    __IO  uint8_t ACSC1;
    stc_mft_adcmp_acsc_field_t ACSC1_f;
  };
  union {
    __IO  uint8_t ACSD1;
    stc_mft_adcmp_acsd_field_t ACSD1_f;
  };
  union {
    __IO  uint8_t ACMC1;
    stc_mft_adcmp_acmc_field_t ACMC1_f;
  };
        uint8_t RESERVED9[1];
  union {
    __IO  uint8_t ACSC2;
    stc_mft_adcmp_acsc_field_t ACSC2_f;
  };
  union {
    __IO  uint8_t ACSD2;
    stc_mft_adcmp_acsd_field_t ACSD2_f;
  };
  union {
    __IO  uint8_t ACMC2;
    stc_mft_adcmp_acmc_field_t ACMC2_f;
  };
        uint8_t RESERVED10[1];
  union {
    __IO  uint8_t ACSC3;
    stc_mft_adcmp_acsc_field_t ACSC3_f;
  };
  union {
    __IO  uint8_t ACSD3;
    stc_mft_adcmp_acsd_field_t ACSD3_f;
  };
  union {
    __IO  uint8_t ACMC3;
    stc_mft_adcmp_acmc_field_t ACMC3_f;
  };
        uint8_t RESERVED11[1];
  union {
    __IO  uint8_t ACSC4;
    stc_mft_adcmp_acsc_field_t ACSC4_f;
  };
  union {
    __IO  uint8_t ACSD4;
    stc_mft_adcmp_acsd_field_t ACSD4_f;
  };
  union {
    __IO  uint8_t ACMC4;
    stc_mft_adcmp_acmc_field_t ACMC4_f;
  };
        uint8_t RESERVED12[1];
  union {
    __IO  uint8_t ACSC5;
    stc_mft_adcmp_acsc_field_t ACSC5_f;
  };
  union {
    __IO  uint8_t ACSD5;
    stc_mft_adcmp_acsd_field_t ACSD5_f;
  };
  union {
    __IO  uint8_t ACMC5;
    stc_mft_adcmp_acmc_field_t ACMC5_f;
  };
        uint8_t RESERVED13[1];
}FM_MFT_ADCMP_TypeDef;

/******************************************************************************
 * MFT_PPG_MODULE
 ******************************************************************************/
/* Multifunction Timer PPG registers */
typedef struct
{
        uint8_t RESERVED0;
  union {
    __IO  uint8_t TTCR0;
    stc_mft_ppg_ttcr0_field_t TTCR0_f;
  };
        uint8_t RESERVED1[2];
  __IO  uint8_t TSTPR0;
        uint8_t RESERVED3[4];
  __IO  uint8_t COMP0;
        uint8_t RESERVED4[2];
  __IO  uint8_t COMP2;
        uint8_t RESERVED5[4];
  __IO  uint8_t COMP4;
        uint8_t RESERVED6[2];
  __IO  uint8_t COMP6;
        uint8_t RESERVED7[12];
  union {
    __IO  uint8_t TTCR1;
    stc_mft_ppg_ttcr1_field_t TTCR1_f;
  };
        uint8_t RESERVED8[2];
  __IO  uint8_t TSTPR1;
        uint8_t RESERVED9[4];
  __IO  uint8_t COMP1;
        uint8_t RESERVED10[2];
  __IO  uint8_t COMP3;
        uint8_t RESERVED11[4];
  __IO  uint8_t COMP5;
        uint8_t RESERVED12[2];
  __IO  uint8_t COMP7;
        uint8_t RESERVED13[12];
  union {
    __IO  uint8_t TTCR2;
    stc_mft_ppg_ttcr2_field_t TTCR2_f;
  };
        uint8_t RESERVED14[2];
  __IO  uint8_t TSTPR2;
        uint8_t RESERVED15[4];
  __IO  uint8_t COMP8;
        uint8_t RESERVED16[2];
  __IO  uint8_t COMP10;
        uint8_t RESERVED17[4];
  __IO  uint8_t COMP12;
        uint8_t RESERVED18[2];
  __IO  uint8_t COMP14;
        uint8_t RESERVED19[171];
  union {
    __IO uint16_t TRG0;
    stc_mft_ppg_trg0_field_t TRG0_f;
  };
        uint8_t RESERVED20[2];
  union {
    __IO uint16_t REVC0;
    stc_mft_ppg_revc0_field_t REVC0_f;
  };
        uint8_t RESERVED21[58];
  union {
    __IO uint16_t TRG1;
    stc_mft_ppg_trg1_field_t TRG1_f;
  };
        uint8_t RESERVED22[2];
  union {
    __IO uint16_t REVC1;
    stc_mft_ppg_revc1_field_t REVC1_f;
  };
        uint8_t RESERVED23[186];
  union {
    __IO  uint8_t PPGC1;
    stc_mft_ppg_ppgc1_field_t PPGC1_f;
  };
  union {
    __IO  uint8_t PPGC0;
    stc_mft_ppg_ppgc0_field_t PPGC0_f;
  };
        uint8_t RESERVED24[2];
  union {
    __IO  uint8_t PPGC3;
    stc_mft_ppg_ppgc3_field_t PPGC3_f;
  };
  union {
    __IO  uint8_t PPGC2;
    stc_mft_ppg_ppgc2_field_t PPGC2_f;
  };
        uint8_t RESERVED25[2];
  union {
    __IO uint16_t PRL0;
    struct {
      __IO  uint8_t PRLL0;
      __IO  uint8_t PRLH0;
    };
  };
        uint8_t RESERVED26[2];
  union {
    __IO uint16_t PRL1;
    struct {
      __IO  uint8_t PRLL1;
      __IO  uint8_t PRLH1;
    };
  };
        uint8_t RESERVED27[2];
  union {
    __IO uint16_t PRL2;
    struct {
      __IO  uint8_t PRLL2;
      __IO  uint8_t PRLH2;
    };
  };
        uint8_t RESERVED28[2];
  union {
    __IO uint16_t PRL3;
    struct {
      __IO  uint8_t PRLL3;
      __IO  uint8_t PRLH3;
    };
  };
        uint8_t RESERVED29[2];
  union {
    __IO  uint8_t GATEC0;
    stc_mft_ppg_gatec0_field_t GATEC0_f;
  };
        uint8_t RESERVED30[39];
  union {
    __IO  uint8_t PPGC5;
    stc_mft_ppg_ppgc5_field_t PPGC5_f;
  };
  union {
    __IO  uint8_t PPGC4;
    stc_mft_ppg_ppgc4_field_t PPGC4_f;
  };
        uint8_t RESERVED31[2];
  union {
    __IO  uint8_t PPGC7;
    stc_mft_ppg_ppgc7_field_t PPGC7_f;
  };
  union {
    __IO  uint8_t PPGC6;
    stc_mft_ppg_ppgc6_field_t PPGC6_f;
  };
        uint8_t RESERVED32[2];
  union {
    __IO uint16_t PRL4;
    struct {
      __IO  uint8_t PRLL4;
      __IO  uint8_t PRLH4;
    };
  };
        uint8_t RESERVED33[2];
  union {
    __IO uint16_t PRL5;
    struct {
      __IO  uint8_t PRLL5;
      __IO  uint8_t PRLH5;
    };
  };
        uint8_t RESERVED34[2];
  union {
    __IO uint16_t PRL6;
    struct {
      __IO  uint8_t PRLL6;
      __IO  uint8_t PRLH6;
    };
  };
        uint8_t RESERVED35[2];
  union {
    __IO uint16_t PRL7;
    struct {
      __IO  uint8_t PRLL7;
      __IO  uint8_t PRLH7;
    };
  };
        uint8_t RESERVED36[2];
  union {
    __IO  uint8_t GATEC4;
    stc_mft_ppg_gatec4_field_t GATEC4_f;
  };
        uint8_t RESERVED37[39];
  union {
    __IO  uint8_t PPGC9;
    stc_mft_ppg_ppgc9_field_t PPGC9_f;
  };
  union {
    __IO  uint8_t PPGC8;
    stc_mft_ppg_ppgc8_field_t PPGC8_f;
  };
        uint8_t RESERVED38[2];
  union {
    __IO  uint8_t PPGC11;
    stc_mft_ppg_ppgc11_field_t PPGC11_f;
  };
  union {
    __IO  uint8_t PPGC10;
    stc_mft_ppg_ppgc10_field_t PPGC10_f;
  };
        uint8_t RESERVED39[2];
  union {
    __IO uint16_t PRL8;
    struct {
      __IO  uint8_t PRLL8;
      __IO  uint8_t PRLH8;
    };
  };
        uint8_t RESERVED40[2];
  union {
    __IO uint16_t PRL9;
    struct {
      __IO  uint8_t PRLL9;
      __IO  uint8_t PRLH9;
    };
  };
        uint8_t RESERVED41[2];
  union {
    __IO uint16_t PRL10;
    struct {
      __IO  uint8_t PRLL10;
      __IO  uint8_t PRLH10;
    };
  };
        uint8_t RESERVED42[2];
  union {
    __IO uint16_t PRL11;
    struct {
      __IO  uint8_t PRLL11;
      __IO  uint8_t PRLH11;
    };
  };
        uint8_t RESERVED43[2];
  union {
    __IO  uint8_t GATEC8;
    stc_mft_ppg_gatec8_field_t GATEC8_f;
  };
        uint8_t RESERVED44[39];
  union {
    __IO  uint8_t PPGC13;
    stc_mft_ppg_ppgc13_field_t PPGC13_f;
  };
  union {
    __IO  uint8_t PPGC12;
    stc_mft_ppg_ppgc12_field_t PPGC12_f;
  };
        uint8_t RESERVED45[2];
  union {
    __IO  uint8_t PPGC15;
    stc_mft_ppg_ppgc15_field_t PPGC15_f;
  };
  union {
    __IO  uint8_t PPGC14;
    stc_mft_ppg_ppgc14_field_t PPGC14_f;
  };
        uint8_t RESERVED46[2];
  union {
    __IO uint16_t PRL12;
    struct {
      __IO  uint8_t PRLL12;
      __IO  uint8_t PRLH12;
    };
  };
        uint8_t RESERVED47[2];
  union {
    __IO uint16_t PRL13;
    struct {
      __IO  uint8_t PRLL13;
      __IO  uint8_t PRLH13;
    };
  };
        uint8_t RESERVED48[2];
  union {
    __IO uint16_t PRL14;
    struct {
      __IO  uint8_t PRLL14;
      __IO  uint8_t PRLH14;
    };
  };
        uint8_t RESERVED49[2];
  union {
    __IO uint16_t PRL15;
    struct {
      __IO  uint8_t PRLL15;
      __IO  uint8_t PRLH15;
    };
  };
        uint8_t RESERVED50[2];
  union {
    __IO  uint8_t GATEC12;
    stc_mft_ppg_gatec12_field_t GATEC12_f;
  };
        uint8_t RESERVED51[39];
  union {
    __IO  uint8_t PPGC17;
    stc_mft_ppg_ppgc17_field_t PPGC17_f;
  };
  union {
    __IO  uint8_t PPGC16;
    stc_mft_ppg_ppgc16_field_t PPGC16_f;
  };
        uint8_t RESERVED52[2];
  union {
    __IO  uint8_t PPGC19;
    stc_mft_ppg_ppgc19_field_t PPGC19_f;
  };
  union {
    __IO  uint8_t PPGC18;
    stc_mft_ppg_ppgc18_field_t PPGC18_f;
  };
        uint8_t RESERVED53[2];
  union {
    __IO uint16_t PRL16;
    struct {
      __IO  uint8_t PRLL16;
      __IO  uint8_t PRLH16;
    };
  };
        uint8_t RESERVED54[2];
  union {
    __IO uint16_t PRL17;
    struct {
      __IO  uint8_t PRLL17;
      __IO  uint8_t PRLH17;
    };
  };
        uint8_t RESERVED55[2];
  union {
    __IO uint16_t PRL18;
    struct {
      __IO  uint8_t PRLL18;
      __IO  uint8_t PRLH18;
    };
  };
        uint8_t RESERVED56[2];
  union {
    __IO uint16_t PRL19;
    struct {
      __IO  uint8_t PRLL19;
      __IO  uint8_t PRLH19;
    };
  };
        uint8_t RESERVED57[2];
  union {
    __IO  uint8_t GATEC16;
    stc_mft_ppg_gatec16_field_t GATEC16_f;
  };
        uint8_t RESERVED58[39];
  union {
    __IO  uint8_t PPGC21;
    stc_mft_ppg_ppgc21_field_t PPGC21_f;
  };
  union {
    __IO  uint8_t PPGC20;
    stc_mft_ppg_ppgc20_field_t PPGC20_f;
  };
        uint8_t RESERVED59[2];
  union {
    __IO  uint8_t PPGC23;
    stc_mft_ppg_ppgc23_field_t PPGC23_f;
  };
  union {
    __IO  uint8_t PPGC22;
    stc_mft_ppg_ppgc22_field_t PPGC22_f;
  };
        uint8_t RESERVED60[2];
  union {
    __IO uint16_t PRL20;
    struct {
      __IO  uint8_t PRLL20;
      __IO  uint8_t PRLH20;
    };
  };
        uint8_t RESERVED61[2];
  union {
    __IO uint16_t PRL21;
    struct {
      __IO  uint8_t PRLL21;
      __IO  uint8_t PRLH21;
    };
  };
        uint8_t RESERVED62[2];
  union {
    __IO uint16_t PRL22;
    struct {
      __IO  uint8_t PRLL22;
      __IO  uint8_t PRLH22;
    };
  };
        uint8_t RESERVED63[2];
  union {
    __IO uint16_t PRL23;
    struct {
      __IO  uint8_t PRLL23;
      __IO  uint8_t PRLH23;
    };
  };
        uint8_t RESERVED64[2];
  union {
    __IO  uint8_t GATEC20;
    stc_mft_ppg_gatec20_field_t GATEC20_f;
  };
        uint8_t RESERVED65[39];
  __IO  uint8_t IGBTC;
        uint8_t RESERVED66[39];
}FM_MFT_PPG_TypeDef;

/******************************************************************************
 * BT_PPG_MODULE
 ******************************************************************************/
/* Base Timer 0 PPG registers */
typedef struct
{
  __IO uint16_t PRLL;
        uint8_t RESERVED0[2];
  __IO uint16_t PRLH;
        uint8_t RESERVED1[2];
  __IO uint16_t TMR;
        uint8_t RESERVED2[2];
  union {
    __IO uint16_t TMCR;
    stc_bt_ppg_tmcr_field_t TMCR_f;
  };
        uint8_t RESERVED3[2];
  union {
    __IO  uint8_t STC;
    stc_bt_ppg_stc_field_t STC_f;
  };
  union {
    __IO  uint8_t TMCR2;
    stc_bt_ppg_tmcr2_field_t TMCR2_f;
  };
}FM_BT_PPG_TypeDef;

/******************************************************************************
 * BT_PWM_MODULE
 ******************************************************************************/
/* Base Timer 0 PWM registers */
typedef struct
{
  __IO uint16_t PCSR;
        uint8_t RESERVED0[2];
  __IO uint16_t PDUT;
        uint8_t RESERVED1[2];
  __IO uint16_t TMR;
        uint8_t RESERVED2[2];
  union {
    __IO uint16_t TMCR;
    stc_bt_pwm_tmcr_field_t TMCR_f;
  };
        uint8_t RESERVED3[2];
  union {
    __IO  uint8_t STC;
    stc_bt_pwm_stc_field_t STC_f;
  };
  union {
    __IO  uint8_t TMCR2;
    stc_bt_pwm_tmcr2_field_t TMCR2_f;
  };
}FM_BT_PWM_TypeDef;

/******************************************************************************
 * BT_RT_MODULE
 ******************************************************************************/
/* Base Timer 0 RT registers */
typedef struct
{
  __IO uint16_t PCSR;
        uint8_t RESERVED0[6];
  __IO uint16_t TMR;
        uint8_t RESERVED1[2];
  union {
    __IO uint16_t TMCR;
    stc_bt_rt_tmcr_field_t TMCR_f;
  };
        uint8_t RESERVED2[2];
  union {
    __IO  uint8_t STC;
    stc_bt_rt_stc_field_t STC_f;
  };
  union {
    __IO  uint8_t TMCR2;
    stc_bt_rt_tmcr2_field_t TMCR2_f;
  };
}FM_BT_RT_TypeDef;

/******************************************************************************
 * BT_PWC_MODULE
 ******************************************************************************/
/* Base Timer 0 PWC registers */
typedef struct
{
        uint8_t RESERVED0[4];
  __IO uint16_t DTBF;
        uint8_t RESERVED1[6];
  union {
    __IO uint16_t TMCR;
    stc_bt_pwc_tmcr_field_t TMCR_f;
  };
        uint8_t RESERVED2[2];
  union {
    __IO  uint8_t STC;
    stc_bt_pwc_stc_field_t STC_f;
  };
  union {
    __IO  uint8_t TMCR2;
    stc_bt_pwc_tmcr2_field_t TMCR2_f;
  };
}FM_BT_PWC_TypeDef;

/******************************************************************************
 * BTIOSEL03_MODULE
 ******************************************************************************/
/* Base Timer I/O selector channel 0 - channel 3 registers */
typedef struct
{
        uint8_t RESERVED0;
  union {
    __IO  uint8_t BTSEL0123;
    stc_btiosel03_btsel0123_field_t BTSEL0123_f;
  };
}FM_BTIOSEL03_TypeDef;

/******************************************************************************
 * BTIOSEL47_MODULE
 ******************************************************************************/
/* Base Timer I/O selector channel 4 - channel 7 registers */
typedef struct
{
        uint8_t RESERVED0;
  union {
    __IO  uint8_t BTSEL4567;
    stc_btiosel47_btsel4567_field_t BTSEL4567_f;
  };
}FM_BTIOSEL47_TypeDef;

/******************************************************************************
 * BTIOSEL8B_MODULE
 ******************************************************************************/
/* Base Timer I/O selector channel 8 - channel 11 registers */
typedef struct
{
        uint8_t RESERVED0;
  union {
    __IO  uint8_t BTSEL89AB;
    stc_btiosel8b_btsel89ab_field_t BTSEL89AB_f;
  };
}FM_BTIOSEL8B_TypeDef;

/******************************************************************************
 * BTIOSELCF_MODULE
 ******************************************************************************/
/* Base Timer I/O selector channel 12 - channel 15 registers */
typedef struct
{
        uint8_t RESERVED0;
  union {
    __IO  uint8_t BTSELCDEF;
    stc_btioselcf_btselcdef_field_t BTSELCDEF_f;
  };
}FM_BTIOSELCF_TypeDef;

/******************************************************************************
 * SBSSR_MODULE
 ******************************************************************************/
/* Software based Simulation Startup (Base Timer) register */
typedef struct
{
  union {
    __IO uint16_t BTSSSR;
    stc_sbssr_btsssr_field_t BTSSSR_f;
  };
}FM_SBSSR_TypeDef;

/******************************************************************************
 * QPRC_MODULE
 ******************************************************************************/
/* Quad position and revolution counter channel 0 registers */
typedef struct
{
  __IO uint16_t QPCR;
        uint8_t RESERVED0[2];
  __IO uint16_t QRCR;
        uint8_t RESERVED1[2];
  __IO uint16_t QPCCR;
        uint8_t RESERVED2[2];
  __IO uint16_t QPRCR;
        uint8_t RESERVED3[2];
  __IO uint16_t QMPR;
        uint8_t RESERVED4[2];
  union {
    union {
      __IO uint16_t QICR;
      stc_qprc_qicr_field_t QICR_f;
    };
    struct {
      union {
        __IO  uint8_t QICRL;
        stc_qprc_qicrl_field_t QICRL_f;
      };
      union {
        __IO  uint8_t QICRH;
        stc_qprc_qicrh_field_t QICRH_f;
      };
    };
  };
        uint8_t RESERVED5[2];
  union {
    union {
      __IO uint16_t QCR;
      stc_qprc_qcr_field_t QCR_f;
    };
    struct {
      union {
        __IO  uint8_t QCRL;
        stc_qprc_qcrl_field_t QCRL_f;
      };
      union {
        __IO  uint8_t QCRH;
        stc_qprc_qcrh_field_t QCRH_f;
      };
    };
  };
        uint8_t RESERVED6[2];
  union {
    __IO uint16_t QECR;
    stc_qprc_qecr_field_t QECR_f;
  };
        uint8_t RESERVED7[30];
  union {
    __IO uint32_t QPRCRR;
    struct {
      __IO uint16_t QRCRR;
      __IO uint16_t QPCRR;
    };
  };
}FM_QPRC_TypeDef;

/******************************************************************************
 * QPRC_NF_MODULE
 ******************************************************************************/
/* Quad position and revolution counter noise filter registers */
typedef struct
{
  union {
    __IO  uint8_t NFCTLA;
    stc_qprc_nf_nfctla_field_t NFCTLA_f;
  };
        uint8_t RESERVED0[3];
  union {
    __IO  uint8_t NFCTLB;
    stc_qprc_nf_nfctlb_field_t NFCTLB_f;
  };
        uint8_t RESERVED1[3];
  union {
    __IO  uint8_t NFRCTLZ;
    stc_qprc_nf_nfrctlz_field_t NFRCTLZ_f;
  };
        uint8_t RESERVED2[7];
}FM_QPRC_NF_TypeDef;

/******************************************************************************
 * ADC12_MODULE
 ******************************************************************************/
/* 12-bit ADC unit 0 registers */
typedef struct
{
  union {
    __IO  uint8_t ADSR;
    stc_adc_adsr_field_t ADSR_f;
  };
  union {
    __IO  uint8_t ADCR;
    stc_adc_adcr_field_t ADCR_f;
  };
        uint8_t RESERVED0[6];
  union {
    __IO  uint8_t SFNS;
    stc_adc_sfns_field_t SFNS_f;
  };
  union {
    __IO  uint8_t SCCR;
    stc_adc_sccr_field_t SCCR_f;
  };
        uint8_t RESERVED1[2];
  union {
    union {
      __IO uint32_t SCFD;
      stc_adc_scfd_field_t SCFD_f;
    };
    struct {
      union {
        __IO uint16_t SCFDL;
        stc_adc_scfdl_field_t SCFDL_f;
      };
      union {
        __IO uint16_t SCFDH;
        stc_adc_scfdh_field_t SCFDH_f;
      };
    };
  };
  union {
    union {
      __IO uint16_t SCIS23;
      stc_adc_scis23_field_t SCIS23_f;
    };
    struct {
      union {
        __IO  uint8_t SCIS2;
        stc_adc_scis2_field_t SCIS2_f;
      };
      union {
        __IO  uint8_t SCIS3;
        stc_adc_scis3_field_t SCIS3_f;
      };
    };
  };
        uint8_t RESERVED2[2];
  union {
    union {
      __IO uint16_t SCIS01;
      stc_adc_scis01_field_t SCIS01_f;
    };
    struct {
      union {
        __IO  uint8_t SCIS0;
        stc_adc_scis0_field_t SCIS0_f;
      };
      union {
        __IO  uint8_t SCIS1;
        stc_adc_scis1_field_t SCIS1_f;
      };
    };
  };
        uint8_t RESERVED3[2];
  union {
    __IO  uint8_t PFNS;
    stc_adc_pfns_field_t PFNS_f;
  };
  union {
    __IO  uint8_t PCCR;
    stc_adc_pccr_field_t PCCR_f;
  };
        uint8_t RESERVED4[2];
  union {
    union {
      __IO uint32_t PCFD;
      stc_adc_pcfd_field_t PCFD_f;
    };
    struct {
      union {
        __IO uint16_t PCFDL;
        stc_adc_pcfdl_field_t PCFDL_f;
      };
      union {
        __IO uint16_t PCFDH;
        stc_adc_pcfdh_field_t PCFDH_f;
      };
    };
  };
  union {
    __IO  uint8_t PCIS;
    stc_adc_pcis_field_t PCIS_f;
  };
        uint8_t RESERVED5[3];
  union {
    __IO  uint8_t CMPCR;
    stc_adc_cmpcr_field_t CMPCR_f;
  };
        uint8_t RESERVED6;
  union {
    __IO uint16_t CMPD;
    stc_adc_cmpd_field_t CMPD_f;
  };
  union {
    union {
      __IO uint16_t ADSS23;
      stc_adc_adss23_field_t ADSS23_f;
    };
    struct {
      union {
        __IO  uint8_t ADSS2;
        stc_adc_adss2_field_t ADSS2_f;
      };
      union {
        __IO  uint8_t ADSS3;
        stc_adc_adss3_field_t ADSS3_f;
      };
    };
  };
        uint8_t RESERVED7[2];
  union {
    union {
      __IO uint16_t ADSS01;
      stc_adc_adss01_field_t ADSS01_f;
    };
    struct {
      union {
        __IO  uint8_t ADSS0;
        stc_adc_adss0_field_t ADSS0_f;
      };
      union {
        __IO  uint8_t ADSS1;
        stc_adc_adss1_field_t ADSS1_f;
      };
    };
  };
        uint8_t RESERVED8[2];
  union {
    union {
      __IO uint16_t ADST01;
      stc_adc_adst01_field_t ADST01_f;
    };
    struct {
      union {
        __IO  uint8_t ADST1;
        stc_adc_adst1_field_t ADST1_f;
      };
      union {
        __IO  uint8_t ADST0;
        stc_adc_adst0_field_t ADST0_f;
      };
    };
  };
        uint8_t RESERVED9[2];
  union {
    __IO  uint8_t ADCT;
    stc_adc_adct_field_t ADCT_f;
  };
        uint8_t RESERVED10[3];
  union {
    __IO  uint8_t PRTSL;
    stc_adc_prtsl_field_t PRTSL_f;
  };
  union {
    __IO  uint8_t SCTSL;
    stc_adc_sctsl_field_t SCTSL_f;
  };
        uint8_t RESERVED11[2];
  union {
    __IO  uint16_t ADCEN;
    stc_adc_adcen_field_t ADCEN_f;
  };
        uint8_t  RESERVED12[2];
        uint32_t OFFESET;
  union {
    __IO uint8_t WCMRCOT;
    stc_adc_wcmrcot_field_t WCMRCOT_f;
  };
        uint8_t  RESERVED13[3];
  union {
    __IO uint8_t WCMRCIF;
    stc_adc_wcmrcif_field_t WCMRCIF_f;
  };
        uint8_t  RESERVED14[3];
  union {
    __IO uint8_t WCMPCR;
    stc_adc_wcmpcr_field_t WCMPCR_f;
  };
  union {
    __IO uint8_t WCMPSR;
    stc_adc_wcmpsr_field_t WCMPSR_f;
  };
        uint8_t  RESERVED15[2];
  union {
    __IO uint16_t WCMPDL;
    stc_adc_wcmpdl_field_t WCMPDL_f;
  };
  union {
    __IO uint16_t WCMPDH;
    stc_adc_wcmpdh_field_t WCMPDH_f;
  };
}FM_ADC_TypeDef;

/******************************************************************************
 * DAC_MODULE
 ******************************************************************************/

typedef struct
{
  union {
    __IO uint8_t      DACR;
    stc_dacr_field_t  DACR_f;
  };
        uint8_t RESERVED0[3];
  union {
    __IO uint16_t     DADR;
    stc_dadr_field_t  DADR_f;
  };
}FM_DAC_TypeDef;

/******************************************************************************
 * CRTRIM_MODULE
 ******************************************************************************/
/* CR trimming registers */
typedef struct
{
  union {
    __IO  uint8_t MCR_PSR;
    stc_crtrim_mcr_psr_field_t MCR_PSR_f;
  };
        uint8_t RESERVED0[3];
  union {
    __IO uint16_t MCR_FTRM;
    stc_crtrim_mcr_ftrm_field_t MCR_FTRM_f;
  };
       uint8_t RESERVED1[2];
  union {
    __IO  uint8_t MCR_TTRM;
    stc_crtrim_mcr_ttrm_field_t MCR_TTRM_f;
  };
       uint8_t RESERVED2[3];
  union {
    __IO uint32_t MCR_RLR;
    stc_crtrim_mcr_rlr_field_t MCR_RLR_f;
  };
}FM_CRTRIM_TypeDef;

/******************************************************************************
 * EXTI_MODULE
 ******************************************************************************/
/* External interrupt registers */
typedef struct
{
  union {
    __IO uint32_t ENIR;
    stc_exti_enir_field_t ENIR_f;
  };
  union {
    __IO uint32_t EIRR;
    stc_exti_eirr_field_t EIRR_f;
  };
  union {
    __IO uint32_t EICL;
    stc_exti_eicl_field_t EICL_f;
  };
  union {
    __IO uint32_t ELVR;
    stc_exti_elvr_field_t ELVR_f;
  };
  union {
    __IO uint32_t ELVR1;
    stc_exti_elvr1_field_t ELVR1_f;
  };
  union {
    __IO  uint8_t NMIRR;
    stc_exti_nmirr_field_t NMIRR_f;
  };
       uint8_t RESERVED5[3];
  union {
    __IO  uint8_t NMICL;
    stc_exti_nmicl_field_t NMICL_f;
  };
}FM_EXTI_TypeDef;

/******************************************************************************
 * INTREQ_MODULE
 ******************************************************************************/
/* INTREQ registers */
typedef struct
{
  union {
    __IO uint32_t DRQSEL;
    stc_intreq_drqsel_field_t DRQSEL_f;
  };
        uint8_t RESERVED1[12];
  union {
    __IO  uint8_t ODDPKS;
    stc_intreq_oddpks_field_t ODDPKS_f;
  };
        uint8_t RESERVED2[3];
  union {
    __IO  uint8_t ODDPKS1;
    stc_intreq_oddpks1_field_t ODDPKS1_f;
  };
        uint8_t RESERVED3[251];
  union {
    __IO uint32_t IRQ003SEL;
    stc_intreq_irq003sel_field_t IRQ003SEL_f;
  };
  union {
    __IO uint32_t IRQ004SEL;
    stc_intreq_irq004sel_field_t IRQ004SEL_f;
  };
  union {
    __IO uint32_t IRQ005SEL;
    stc_intreq_irq005sel_field_t IRQ005SEL_f;
  };
  union {
    __IO uint32_t IRQ006SEL;
    stc_intreq_irq006sel_field_t IRQ006SEL_f;
  };
  union {
    __IO uint32_t IRQ007SEL;
    stc_intreq_irq007sel_field_t IRQ007SEL_f;
  };
  union {
    __IO uint32_t IRQ008SEL;
    stc_intreq_irq008sel_field_t IRQ008SEL_f;
  };
  union {
    __IO uint32_t IRQ009SEL;
    stc_intreq_irq009sel_field_t IRQ009SEL_f;
  };
  union {
    __IO uint32_t IRQ010SEL;
    stc_intreq_irq010sel_field_t IRQ010SEL_f;
  };
        uint8_t RESERVED4[208];
  union {
    __IO uint32_t EXC02MON;
    stc_intreq_exc02mon_field_t EXC02MON_f;
  };
  union {
    __IO uint32_t IRQ000MON;
    stc_intreq_irq000mon_field_t IRQ000MON_f;
  };
  union {
    __IO uint32_t IRQ001MON;
    stc_intreq_irq001mon_field_t IRQ001MON_f;
  };
  union {
    __IO uint32_t IRQ002MON;
    stc_intreq_irq002mon_field_t IRQ002MON_f;
  };
  union {
    __IO uint32_t IRQ003MON;
    stc_intreq_irq003mon_field_t IRQ003MON_f;
  };
  union {
    __IO uint32_t IRQ004MON;
    stc_intreq_irq004mon_field_t IRQ004MON_f;
  };
  union {
    __IO uint32_t IRQ005MON;
    stc_intreq_irq005mon_field_t IRQ005MON_f;
  };
  union {
    __IO uint32_t IRQ006MON;
    stc_intreq_irq006mon_field_t IRQ006MON_f;
  };
  union {
    __IO uint32_t IRQ007MON;
    stc_intreq_irq007mon_field_t IRQ007MON_f;
  };
  union {
    __IO uint32_t IRQ008MON;
    stc_intreq_irq008mon_field_t IRQ008MON_f;
  };
  union {
    __IO uint32_t IRQ009MON;
    stc_intreq_irq009mon_field_t IRQ009MON_f;
  };
  union {
    __IO uint32_t IRQ010MON;
    stc_intreq_irq010mon_field_t IRQ010MON_f;
  };
  union {
    __IO uint32_t IRQ011MON;
    stc_intreq_irq011mon_field_t IRQ011MON_f;
  };
  union {
    __IO uint32_t IRQ012MON;
    stc_intreq_irq012mon_field_t IRQ012MON_f;
  };
  union {
    __IO uint32_t IRQ013MON;
    stc_intreq_irq013mon_field_t IRQ013MON_f;
  };
  union {
    __IO uint32_t IRQ014MON;
    stc_intreq_irq014mon_field_t IRQ014MON_f;
  };
  union {
    __IO uint32_t IRQ015MON;
    stc_intreq_irq015mon_field_t IRQ015MON_f;
  };
  union {
    __IO uint32_t IRQ016MON;
    stc_intreq_irq016mon_field_t IRQ016MON_f;
  };
  union {
    __IO uint32_t IRQ017MON;
    stc_intreq_irq017mon_field_t IRQ017MON_f;
  };
  union {
    __IO uint32_t IRQ018MON;
    stc_intreq_irq018mon_field_t IRQ018MON_f;
  };
  union {
    __IO uint32_t IRQ019MON;
    stc_intreq_irq019mon_field_t IRQ019MON_f;
  };
  union {
    __IO uint32_t IRQ020MON;
    stc_intreq_irq020mon_field_t IRQ020MON_f;
  };
  union {
    __IO uint32_t IRQ021MON;
    stc_intreq_irq021mon_field_t IRQ021MON_f;
  };
  union {
    __IO uint32_t IRQ022MON;
    stc_intreq_irq022mon_field_t IRQ022MON_f;
  };
  union {
    __IO uint32_t IRQ023MON;
    stc_intreq_irq023mon_field_t IRQ023MON_f;
  };
  union {
    __IO uint32_t IRQ024MON;
    stc_intreq_irq024mon_field_t IRQ024MON_f;
  };
  union {
    __IO uint32_t IRQ025MON;
    stc_intreq_irq025mon_field_t IRQ025MON_f;
  };
  union {
    __IO uint32_t IRQ026MON;
    stc_intreq_irq026mon_field_t IRQ026MON_f;
  };
  union {
    __IO uint32_t IRQ027MON;
    stc_intreq_irq027mon_field_t IRQ027MON_f;
  };
  union {
    __IO uint32_t IRQ028MON;
    stc_intreq_irq028mon_field_t IRQ028MON_f;
  };
  union {
    __IO uint32_t IRQ029MON;
    stc_intreq_irq029mon_field_t IRQ029MON_f;
  };
  union {
    __IO uint32_t IRQ030MON;
    stc_intreq_irq030mon_field_t IRQ030MON_f;
  };
  union {
    __IO uint32_t IRQ031MON;
    stc_intreq_irq031mon_field_t IRQ031MON_f;
  };
  union {
    __IO uint32_t IRQ032MON;
    stc_intreq_irq032mon_field_t IRQ032MON_f;
  };
  union {
    __IO uint32_t IRQ033MON;
    stc_intreq_irq033mon_field_t IRQ033MON_f;
  };
  union {
    __IO uint32_t IRQ034MON;
    stc_intreq_irq034mon_field_t IRQ034MON_f;
  };
  union {
    __IO uint32_t IRQ035MON;
    stc_intreq_irq035mon_field_t IRQ035MON_f;
  };
  union {
    __IO uint32_t IRQ036MON;
    stc_intreq_irq036mon_field_t IRQ036MON_f;
  };
  union {
    __IO uint32_t IRQ037MON;
    stc_intreq_irq037mon_field_t IRQ037MON_f;
  };
  union {
    __IO uint32_t IRQ038MON;
    stc_intreq_irq038mon_field_t IRQ038MON_f;
  };
  union {
    __IO uint32_t IRQ039MON;
    stc_intreq_irq039mon_field_t IRQ039MON_f;
  };
  union {
    __IO uint32_t IRQ040MON;
    stc_intreq_irq040mon_field_t IRQ040MON_f;
  };
  union {
    __IO uint32_t IRQ041MON;
    stc_intreq_irq041mon_field_t IRQ041MON_f;
  };
  union {
    __IO uint32_t IRQ042MON;
    stc_intreq_irq042mon_field_t IRQ042MON_f;
  };
  union {
    __IO uint32_t IRQ043MON;
    stc_intreq_irq043mon_field_t IRQ043MON_f;
  };
  union {
    __IO uint32_t IRQ044MON;
    stc_intreq_irq044mon_field_t IRQ044MON_f;
  };
  union {
    __IO uint32_t IRQ045MON;
    stc_intreq_irq045mon_field_t IRQ045MON_f;
  };
  union {
    __IO uint32_t IRQ046MON;
    stc_intreq_irq046mon_field_t IRQ046MON_f;
  };
  union {
    __IO uint32_t IRQ047MON;
    stc_intreq_irq047mon_field_t IRQ047MON_f;
  };
  union {
    __IO uint32_t IRQ048MON;
    stc_intreq_irq048mon_field_t IRQ048MON_f;
  };
  union {
    __IO uint32_t IRQ049MON;
    stc_intreq_irq049mon_field_t IRQ049MON_f;
  };
  union {
    __IO uint32_t IRQ050MON;
    stc_intreq_irq050mon_field_t IRQ050MON_f;
  };
  union {
    __IO uint32_t IRQ051MON;
    stc_intreq_irq051mon_field_t IRQ051MON_f;
  };
  union {
    __IO uint32_t IRQ052MON;
    stc_intreq_irq052mon_field_t IRQ052MON_f;
  };
  union {
    __IO uint32_t IRQ053MON;
    stc_intreq_irq053mon_field_t IRQ053MON_f;
  };
  union {
    __IO uint32_t IRQ054MON;
    stc_intreq_irq054mon_field_t IRQ054MON_f;
  };
  union {
    __IO uint32_t IRQ055MON;
    stc_intreq_irq055mon_field_t IRQ055MON_f;
  };
  union {
    __IO uint32_t IRQ056MON;
    stc_intreq_irq056mon_field_t IRQ056MON_f;
  };
  union {
    __IO uint32_t IRQ057MON;
    stc_intreq_irq057mon_field_t IRQ057MON_f;
  };
  union {
    __IO uint32_t IRQ058MON;
    stc_intreq_irq058mon_field_t IRQ058MON_f;
  };
  union {
    __IO uint32_t IRQ059MON;
    stc_intreq_irq059mon_field_t IRQ059MON_f;
  };
  union {
    __IO uint32_t IRQ060MON;
    stc_intreq_irq060mon_field_t IRQ060MON_f;
  };
  union {
    __IO uint32_t IRQ061MON;
    stc_intreq_irq061mon_field_t IRQ061MON_f;
  };
  union {
    __IO uint32_t IRQ062MON;
    stc_intreq_irq062mon_field_t IRQ062MON_f;
  };
  union {
    __IO uint32_t IRQ063MON;
    stc_intreq_irq063mon_field_t IRQ063MON_f;
  };
  union {
    __IO uint32_t IRQ064MON;
    stc_intreq_irq064mon_field_t IRQ064MON_f;
  };
  union {
    __IO uint32_t IRQ065MON;
    stc_intreq_irq065mon_field_t IRQ065MON_f;
  };
  union {
    __IO uint32_t IRQ066MON;
    stc_intreq_irq066mon_field_t IRQ066MON_f;
  };
  union {
    __IO uint32_t IRQ067MON;
    stc_intreq_irq067mon_field_t IRQ067MON_f;
  };
  union {
    __IO uint32_t IRQ068MON;
    stc_intreq_irq068mon_field_t IRQ068MON_f;
  };
  union {
    __IO uint32_t IRQ069MON;
    stc_intreq_irq069mon_field_t IRQ069MON_f;
  };
  union {
    __IO uint32_t IRQ070MON;
    stc_intreq_irq070mon_field_t IRQ070MON_f;
  };
  union {
    __IO uint32_t IRQ071MON;
    stc_intreq_irq071mon_field_t IRQ071MON_f;
  };
  union {
    __IO uint32_t IRQ072MON;
    stc_intreq_irq072mon_field_t IRQ072MON_f;
  };
  union {
    __IO uint32_t IRQ073MON;
    stc_intreq_irq073mon_field_t IRQ073MON_f;
  };
  union {
    __IO uint32_t IRQ074MON;
    stc_intreq_irq074mon_field_t IRQ074MON_f;
  };
  union {
    __IO uint32_t IRQ075MON;
    stc_intreq_irq075mon_field_t IRQ075MON_f;
  };
  union {
    __IO uint32_t IRQ076MON;
    stc_intreq_irq076mon_field_t IRQ076MON_f;
  };
  union {
    __IO uint32_t IRQ077MON;
    stc_intreq_irq077mon_field_t IRQ077MON_f;
  };
  union {
    __IO uint32_t IRQ078MON;
    stc_intreq_irq078mon_field_t IRQ078MON_f;
  };
  union {
    __IO uint32_t IRQ079MON;
    stc_intreq_irq079mon_field_t IRQ079MON_f;
  };
  union {
    __IO uint32_t IRQ080MON;
    stc_intreq_irq080mon_field_t IRQ080MON_f;
  };
  union {
    __IO uint32_t IRQ081MON;
    stc_intreq_irq081mon_field_t IRQ081MON_f;
  };
  union {
    __IO uint32_t IRQ082MON;
    stc_intreq_irq082mon_field_t IRQ082MON_f;
  };
  union {
    __IO uint32_t IRQ083MON;
    stc_intreq_irq083mon_field_t IRQ083MON_f;
  };
  union {
    __IO uint32_t IRQ084MON;
    stc_intreq_irq084mon_field_t IRQ084MON_f;
  };
  union {
    __IO uint32_t IRQ085MON;
    stc_intreq_irq085mon_field_t IRQ085MON_f;
  };
  union {
    __IO uint32_t IRQ086MON;
    stc_intreq_irq086mon_field_t IRQ086MON_f;
  };
  union {
    __IO uint32_t IRQ087MON;
    stc_intreq_irq087mon_field_t IRQ087MON_f;
  };
  union {
    __IO uint32_t IRQ088MON;
    stc_intreq_irq088mon_field_t IRQ088MON_f;
  };
  union {
    __IO uint32_t IRQ089MON;
    stc_intreq_irq089mon_field_t IRQ089MON_f;
  };
  union {
    __IO uint32_t IRQ090MON;
    stc_intreq_irq090mon_field_t IRQ090MON_f;
  };
  union {
    __IO uint32_t IRQ091MON;
    stc_intreq_irq091mon_field_t IRQ091MON_f;
  };
  union {
    __IO uint32_t IRQ092MON;
    stc_intreq_irq092mon_field_t IRQ092MON_f;
  };
  union {
    __IO uint32_t IRQ093MON;
    stc_intreq_irq093mon_field_t IRQ093MON_f;
  };
  union {
    __IO uint32_t IRQ094MON;
    stc_intreq_irq094mon_field_t IRQ094MON_f;
  };
  union {
    __IO uint32_t IRQ095MON;
    stc_intreq_irq095mon_field_t IRQ095MON_f;
  };
  union {
    __IO uint32_t IRQ096MON;
    stc_intreq_irq096mon_field_t IRQ096MON_f;
  };
  union {
    __IO uint32_t IRQ097MON;
    stc_intreq_irq097mon_field_t IRQ097MON_f;
  };
  union {
    __IO uint32_t IRQ098MON;
    stc_intreq_irq098mon_field_t IRQ098MON_f;
  };
  union {
    __IO uint32_t IRQ099MON;
    stc_intreq_irq099mon_field_t IRQ099MON_f;
  };
  union {
    __IO uint32_t IRQ100MON;
    stc_intreq_irq100mon_field_t IRQ100MON_f;
  };
  union {
    __IO uint32_t IRQ101MON;
    stc_intreq_irq101mon_field_t IRQ101MON_f;
  };
  union {
    __IO uint32_t IRQ102MON;
    stc_intreq_irq102mon_field_t IRQ102MON_f;
  };
  union {
    __IO uint32_t IRQ103MON;
    stc_intreq_irq103mon_field_t IRQ103MON_f;
  };
  union {
    __IO uint32_t IRQ104MON;
    stc_intreq_irq104mon_field_t IRQ104MON_f;
  };
  union {
    __IO uint32_t IRQ105MON;
    stc_intreq_irq105mon_field_t IRQ105MON_f;
  };
  union {
    __IO uint32_t IRQ106MON;
    stc_intreq_irq106mon_field_t IRQ106MON_f;
  };
  union {
    __IO uint32_t IRQ107MON;
    stc_intreq_irq107mon_field_t IRQ107MON_f;
  };
  union {
    __IO uint32_t IRQ108MON;
    stc_intreq_irq108mon_field_t IRQ108MON_f;
  };
  union {
    __IO uint32_t IRQ109MON;
    stc_intreq_irq109mon_field_t IRQ109MON_f;
  };
  union {
    __IO uint32_t IRQ110MON;
    stc_intreq_irq110mon_field_t IRQ110MON_f;
  };
  union {
    __IO uint32_t IRQ111MON;
    stc_intreq_irq111mon_field_t IRQ111MON_f;
  };
  union {
    __IO uint32_t IRQ112MON;
    stc_intreq_irq112mon_field_t IRQ112MON_f;
  };
  union {
    __IO uint32_t IRQ113MON;
    stc_intreq_irq113mon_field_t IRQ113MON_f;
  };
  union {
    __IO uint32_t IRQ114MON;
    stc_intreq_irq114mon_field_t IRQ114MON_f;
  };
  union {
    __IO uint32_t IRQ115MON;
    stc_intreq_irq115mon_field_t IRQ115MON_f;
  };
  __IO uint32_t IRQ116MON;
  union {
    __IO uint32_t IRQ117MON;
    stc_intreq_irq117mon_field_t IRQ117MON_f;
  };
  union {
    __IO uint32_t IRQ118MON;
    stc_intreq_irq118mon_field_t IRQ118MON_f;
  };
  union {
    __IO uint32_t IRQ119MON;
    stc_intreq_irq119mon_field_t IRQ119MON_f;
  };
  union {
    __IO uint32_t IRQ120MON;
    stc_intreq_irq120mon_field_t IRQ120MON_f;
  };
  union {
    __IO uint32_t IRQ121MON;
    stc_intreq_irq121mon_field_t IRQ121MON_f;
  };
  union {
    __IO uint32_t IRQ122MON;
    stc_intreq_irq122mon_field_t IRQ122MON_f;
  };
  union {
    __IO uint32_t IRQ123MON;
    stc_intreq_irq123mon_field_t IRQ123MON_f;
  };
  union {
    __IO uint32_t IRQ124MON;
    stc_intreq_irq124mon_field_t IRQ124MON_f;
  };
  union {
    __IO uint32_t IRQ125MON;
    stc_intreq_irq125mon_field_t IRQ125MON_f;
  };
  union {
    __IO uint32_t IRQ126MON;
    stc_intreq_irq126mon_field_t IRQ126MON_f;
  };
  union {
    __IO uint32_t IRQ127MON;
    stc_intreq_irq127mon_field_t IRQ127MON_f;
  };
}FM_INTREQ_TypeDef;

/******************************************************************************
 * IRQSEL_MODULE
******************************************************************************/
typedef struct
{
  union {
    __IO uint32_t      IRQ03SEL;
    stc_irqsel_field_t IRQ03SEL_f;
  };
  union {
    __IO uint32_t      IRQ04SEL;
    stc_irqsel_field_t IRQ04SEL_f;
  };
  union {
    __IO uint32_t      IRQ05SEL;
    stc_irqsel_field_t IRQ05SEL_f;
  };
  union {
    __IO uint32_t      IRQ06SEL;
    stc_irqsel_field_t IRQ06SEL_f;
  };
  union {
    __IO uint32_t      IRQ07SEL;
    stc_irqsel_field_t IRQ07SEL_f;
  };
  union {
    __IO uint32_t      IRQ08SEL;
    stc_irqsel_field_t IRQ08SEL_f;
  };
  union {
    __IO uint32_t      IRQ09SEL;
    stc_irqsel_field_t IRQ09SEL_f;
  };
  union {
    __IO uint32_t      IRQ10SEL;
    stc_irqsel_field_t IRQ10SEL_f;
  };
} FM_IRQSEL_TypeDef;

/******************************************************************************
 * HDMI-CEC_MODULE
 ******************************************************************************/
/* HDMI-CEC MODULE registers */
typedef struct
{
  union {
    __IO  uint8_t TXCTRL;
    stc_hdmicec_txctrl_field_t TXCTRL_f;
  };
        uint8_t RESERVED1[3];
  union {
    __IO  uint8_t TXDATA;
    stc_hdmicec_txdata_field_t TXDATA_f;
  };
        uint8_t RESERVED2[3];
  union {
    __IO  uint8_t TXSTS;
    stc_hdmicec_txsts_field_t TXSTS_f;
  };
        uint8_t RESERVED3[3];
  union {
    __IO  uint8_t SFREE;
    stc_hdmicec_sfree_field_t SFREE_f;
  };
        uint8_t RESERVED4[51];
  union {
    __IO  uint8_t RCST;
    stc_hdmicec_rcst_field_t RCST_f;
  };
  union {
    __IO  uint8_t RCCR;
    stc_hdmicec_rccr_field_t RCCR_f;
  };
        uint8_t RESERVED5[2];
    __IO  uint8_t RCDAHW;
    __IO  uint8_t RCSHW;
        uint8_t RESERVED6[3];
    __IO  uint8_t RCDBHW;
        uint8_t RESERVED7[2];
    __IO  uint8_t RCADR2;
    __IO  uint8_t RCADR1;
        uint8_t RESERVED8[2];
    __IO  uint8_t RCDTHL;
    __IO  uint8_t RCDTHH;
        uint8_t RESERVED9[2];
    __IO  uint8_t RCDTLL;
    __IO  uint8_t RCDTLH;
        uint8_t RESERVED10[2];
  union {
    __IO uint16_t RCCKD;
    stc_hdmicec_rcckd_field_t RCCKD_f;
  };
        uint8_t RESERVED11[2];
    __IO  uint8_t RCRHW;
  union {
    __IO  uint8_t RCRC;
    stc_hdmicec_rcrc_field_t RCRC_f;
  };
        uint8_t RESERVED12[3];
  union {
    __IO  uint8_t RCLE;
    stc_hdmicec_rcle_field_t RCLE_f;
  };
        uint8_t RESERVED13[2];
    __IO  uint8_t RCLESW;
    __IO  uint8_t RCLELW;
}FM_HDMICEC_TypeDef;

/******************************************************************************
 * GPIO_MODULE
 ******************************************************************************/
/* GPIO registers */
typedef struct
{
  union {
    __IO uint32_t PFR0;
    stc_gpio_pfr0_field_t PFR0_f;
  };
  union {
    __IO uint32_t PFR1;
    stc_gpio_pfr1_field_t PFR1_f;
  };
  union {
    __IO uint32_t PFR2;
    stc_gpio_pfr2_field_t PFR2_f;
  };
  union {
    __IO uint32_t PFR3;
    stc_gpio_pfr3_field_t PFR3_f;
  };
  union {
    __IO uint32_t PFR4;
    stc_gpio_pfr4_field_t PFR4_f;
  };
  union {
    __IO uint32_t PFR5;
    stc_gpio_pfr5_field_t PFR5_f;
  };
  union {
    __IO uint32_t PFR6;
    stc_gpio_pfr6_field_t PFR6_f;
  };
  union {
    __IO uint32_t PFR7;
    stc_gpio_pfr7_field_t PFR7_f;
  };
  union {
    __IO uint32_t PFR8;
    stc_gpio_pfr8_field_t PFR8_f;
  };
  union {
    __IO uint32_t PFR9;
    stc_gpio_pfr9_field_t PFR9_f;
  };
  union {
    __IO uint32_t PFRA;
    stc_gpio_pfra_field_t PFRA_f;
  };
  union {
    __IO uint32_t PFRB;
    stc_gpio_pfrb_field_t PFRB_f;
  };
  union {
    __IO uint32_t PFRC;
    stc_gpio_pfrc_field_t PFRC_f;
  };
  union {
    __IO uint32_t PFRD;
    stc_gpio_pfrd_field_t PFRD_f;
  };
  union {
    __IO uint32_t PFRE;
    stc_gpio_pfre_field_t PFRE_f;
  };
  union {
    __IO uint32_t PFRF;
    stc_gpio_pfrf_field_t PFRF_f;
  };
        uint8_t RESERVED1[192];
  union {
    __IO uint32_t PCR0;
    stc_gpio_pcr0_field_t PCR0_f;
  };
  union {
    __IO uint32_t PCR1;
    stc_gpio_pcr1_field_t PCR1_f;
  };
  union {
    __IO uint32_t PCR2;
    stc_gpio_pcr2_field_t PCR2_f;
  };
  union {
    __IO uint32_t PCR3;
    stc_gpio_pcr3_field_t PCR3_f;
  };
  union {
    __IO uint32_t PCR4;
    stc_gpio_pcr4_field_t PCR4_f;
  };
  union {
    __IO uint32_t PCR5;
    stc_gpio_pcr5_field_t PCR5_f;
  };
  union {
    __IO uint32_t PCR6;
    stc_gpio_pcr6_field_t PCR6_f;
  };
  union {
    __IO uint32_t PCR7;
    stc_gpio_pcr7_field_t PCR7_f;
  };
  union {
    __IO uint32_t PCR8;
    stc_gpio_pcr8_field_t PCR8_f;
  };
  union {
    __IO uint32_t PCR9;
    stc_gpio_pcr9_field_t PCR9_f;
  };
  union {
    __IO uint32_t PCRA;
    stc_gpio_pcra_field_t PCRA_f;
  };
  union {
    __IO uint32_t PCRB;
    stc_gpio_pcrb_field_t PCRB_f;
  };
  union {
    __IO uint32_t PCRC;
    stc_gpio_pcrc_field_t PCRC_f;
  };
  union {
    __IO uint32_t PCRD;
    stc_gpio_pcrd_field_t PCRD_f;
  };
  union {
    __IO uint32_t PCRE;
    stc_gpio_pcre_field_t PCRE_f;
  };
  union {
    __IO uint32_t PCRF;
    stc_gpio_pcrf_field_t PCRF_f;
  };
        uint8_t RESERVED2[192];
  union {
    __IO uint32_t DDR0;
    stc_gpio_ddr0_field_t DDR0_f;
  };
  union {
    __IO uint32_t DDR1;
    stc_gpio_ddr1_field_t DDR1_f;
  };
  union {
    __IO uint32_t DDR2;
    stc_gpio_ddr2_field_t DDR2_f;
  };
  union {
    __IO uint32_t DDR3;
    stc_gpio_ddr3_field_t DDR3_f;
  };
  union {
    __IO uint32_t DDR4;
    stc_gpio_ddr4_field_t DDR4_f;
  };
  union {
    __IO uint32_t DDR5;
    stc_gpio_ddr5_field_t DDR5_f;
  };
  union {
    __IO uint32_t DDR6;
    stc_gpio_ddr6_field_t DDR6_f;
  };
  union {
    __IO uint32_t DDR7;
    stc_gpio_ddr7_field_t DDR7_f;
  };
  union {
    __IO uint32_t DDR8;
    stc_gpio_ddr8_field_t DDR8_f;
  };
  union {
    __IO uint32_t DDR9;
    stc_gpio_ddr9_field_t DDR9_f;
  };
  union {
    __IO uint32_t DDRA;
    stc_gpio_ddra_field_t DDRA_f;
  };
  union {
    __IO uint32_t DDRB;
    stc_gpio_ddrb_field_t DDRB_f;
  };
  union {
    __IO uint32_t DDRC;
    stc_gpio_ddrc_field_t DDRC_f;
  };
  union {
    __IO uint32_t DDRD;
    stc_gpio_ddrd_field_t DDRD_f;
  };
  union {
    __IO uint32_t DDRE;
    stc_gpio_ddre_field_t DDRE_f;
  };
  union {
    __IO uint32_t DDRF;
    stc_gpio_ddrf_field_t DDRF_f;
  };
        uint8_t RESERVED3[192];
  union {
    __IO uint32_t PDIR0;
    stc_gpio_pdir0_field_t PDIR0_f;
  };
  union {
    __IO uint32_t PDIR1;
    stc_gpio_pdir1_field_t PDIR1_f;
  };
  union {
    __IO uint32_t PDIR2;
    stc_gpio_pdir2_field_t PDIR2_f;
  };
  union {
    __IO uint32_t PDIR3;
    stc_gpio_pdir3_field_t PDIR3_f;
  };
  union {
    __IO uint32_t PDIR4;
    stc_gpio_pdir4_field_t PDIR4_f;
  };
  union {
    __IO uint32_t PDIR5;
    stc_gpio_pdir5_field_t PDIR5_f;
  };
  union {
    __IO uint32_t PDIR6;
    stc_gpio_pdir6_field_t PDIR6_f;
  };
  union {
    __IO uint32_t PDIR7;
    stc_gpio_pdir7_field_t PDIR7_f;
  };
  union {
    __IO uint32_t PDIR8;
    stc_gpio_pdir8_field_t PDIR8_f;
  };
  union {
    __IO uint32_t PDIR9;
    stc_gpio_pdir9_field_t PDIR9_f;
  };
  union {
    __IO uint32_t PDIRA;
    stc_gpio_pdira_field_t PDIRA_f;
  };
  union {
    __IO uint32_t PDIRB;
    stc_gpio_pdirb_field_t PDIRB_f;
  };
  union {
    __IO uint32_t PDIRC;
    stc_gpio_pdirc_field_t PDIRC_f;
  };
  union {
    __IO uint32_t PDIRD;
    stc_gpio_pdird_field_t PDIRD_f;
  };
  union {
    __IO uint32_t PDIRE;
    stc_gpio_pdire_field_t PDIRE_f;
  };
  union {
    __IO uint32_t PDIRF;
    stc_gpio_pdirf_field_t PDIRF_f;
  };
        uint8_t RESERVED4[192];
  union {
    __IO uint32_t PDOR0;
    stc_gpio_pdor0_field_t PDOR0_f;
  };
  union {
    __IO uint32_t PDOR1;
    stc_gpio_pdor1_field_t PDOR1_f;
  };
  union {
    __IO uint32_t PDOR2;
    stc_gpio_pdor2_field_t PDOR2_f;
  };
  union {
    __IO uint32_t PDOR3;
    stc_gpio_pdor3_field_t PDOR3_f;
  };
  union {
    __IO uint32_t PDOR4;
    stc_gpio_pdor4_field_t PDOR4_f;
  };
  union {
    __IO uint32_t PDOR5;
    stc_gpio_pdor5_field_t PDOR5_f;
  };
  union {
    __IO uint32_t PDOR6;
    stc_gpio_pdor6_field_t PDOR6_f;
  };
  union {
    __IO uint32_t PDOR7;
    stc_gpio_pdor7_field_t PDOR7_f;
  };
  union {
    __IO uint32_t PDOR8;
    stc_gpio_pdor8_field_t PDOR8_f;
  };
  union {
    __IO uint32_t PDOR9;
    stc_gpio_pdor9_field_t PDOR9_f;
  };
  union {
    __IO uint32_t PDORA;
    stc_gpio_pdora_field_t PDORA_f;
  };
  union {
    __IO uint32_t PDORB;
    stc_gpio_pdorb_field_t PDORB_f;
  };
  union {
    __IO uint32_t PDORC;
    stc_gpio_pdorc_field_t PDORC_f;
  };
  union {
    __IO uint32_t PDORD;
    stc_gpio_pdord_field_t PDORD_f;
  };
  union {
    __IO uint32_t PDORE;
    stc_gpio_pdore_field_t PDORE_f;
  };
  union {
    __IO uint32_t PDORF;
    stc_gpio_pdorf_field_t PDORF_f;
  };
        uint8_t RESERVED5[192];
  union {
    __IO uint32_t ADE;
    stc_gpio_ade_field_t ADE_f;
  };
        uint8_t RESERVED6[124];
  union {
    __IO uint32_t SPSR;
    stc_gpio_spsr_field_t SPSR_f;
  };
        uint8_t RESERVED7[124];
  union {
    __IO uint32_t EPFR00;
    stc_gpio_epfr00_field_t EPFR00_f;
  };
  union {
    __IO uint32_t EPFR01;
    stc_gpio_epfr01_field_t EPFR01_f;
  };
  union {
    __IO uint32_t EPFR02;
    stc_gpio_epfr02_field_t EPFR02_f;
  };
  union {
    __IO uint32_t EPFR03;
    stc_gpio_epfr03_field_t EPFR03_f;
  };
  union {
    __IO uint32_t EPFR04;
    stc_gpio_epfr04_field_t EPFR04_f;
  };
  union {
    __IO uint32_t EPFR05;
    stc_gpio_epfr05_field_t EPFR05_f;
  };
  union {
    __IO uint32_t EPFR06;
    stc_gpio_epfr06_field_t EPFR06_f;
  };
  union {
    __IO uint32_t EPFR07;
    stc_gpio_epfr07_field_t EPFR07_f;
  };
  union {
    __IO uint32_t EPFR08;
    stc_gpio_epfr08_field_t EPFR08_f;
  };
  union {
    __IO uint32_t EPFR09;
    stc_gpio_epfr09_field_t EPFR09_f;
  };
  union {
    __IO uint32_t EPFR10;
    stc_gpio_epfr10_field_t EPFR10_f;
  };
  union {
    __IO uint32_t EPFR11;
    stc_gpio_epfr11_field_t EPFR11_f;
  };
  union {
    __IO uint32_t EPFR12;
    stc_gpio_epfr12_field_t EPFR12_f;
  };
  union {
    __IO uint32_t EPFR13;
    stc_gpio_epfr13_field_t EPFR13_f;
  };
  union {
    __IO uint32_t EPFR14;
    stc_gpio_epfr14_field_t EPFR14_f;
  };
  union {
    __IO uint32_t EPFR15;
    stc_gpio_epfr15_field_t EPFR15_f;
  };
  union {
    __IO uint32_t EPFR16;
    stc_gpio_epfr16_field_t EPFR16_f;
  };
  union {
    __IO uint32_t EPFR17;
    stc_gpio_epfr17_field_t EPFR17_f;
  };
  union {
    __IO uint32_t EPFR18;
    stc_gpio_epfr18_field_t EPFR18_f;
  };
  __IO uint32_t EPFR19;
  union {
    __IO uint32_t EPFR20;
    stc_gpio_epfr20_field_t EPFR20_f;
  };
  __IO uint32_t EPFR21;
  __IO uint32_t EPFR22;
  union {
    __IO uint32_t EPFR23;
    stc_gpio_epfr23_field_t EPFR23_f;
  };
  union {
    __IO uint32_t EPFR24;
    stc_gpio_epfr24_field_t EPFR24_f;
  };
  union {
    __IO uint32_t EPFR25;
    stc_gpio_epfr25_field_t EPFR25_f;
  };
  union {
    __IO uint32_t EPFR26;
    stc_gpio_epfr26_field_t EPFR26_f;
  };
        uint8_t RESERVED8[148];
  union {
    __IO uint32_t PZR0;
    stc_gpio_pzr0_field_t PZR0_f;
  };
  union {
    __IO uint32_t PZR1;
    stc_gpio_pzr1_field_t PZR1_f;
  };
  union {
    __IO uint32_t PZR2;
    stc_gpio_pzr2_field_t PZR2_f;
  };
  union {
    __IO uint32_t PZR3;
    stc_gpio_pzr3_field_t PZR3_f;
  };
  union {
    __IO uint32_t PZR4;
    stc_gpio_pzr4_field_t PZR4_f;
  };
  union {
    __IO uint32_t PZR5;
    stc_gpio_pzr5_field_t PZR5_f;
  };
  union {
    __IO uint32_t PZR6;
    stc_gpio_pzr6_field_t PZR6_f;
  };
  union {
    __IO uint32_t PZR7;
    stc_gpio_pzr7_field_t PZR7_f;
  };
  union {
    __IO uint32_t PZR8;
    stc_gpio_pzr8_field_t PZR8_f;
  };
  union {
    __IO uint32_t PZR9;
    stc_gpio_pzr9_field_t PZR9_f;
  };
  union {
    __IO uint32_t PZRA;
    stc_gpio_pzra_field_t PZRA_f;
  };
  union {
    __IO uint32_t PZRB;
    stc_gpio_pzrb_field_t PZRB_f;
  };
  union {
    __IO uint32_t PZRC;
    stc_gpio_pzrc_field_t PZRC_f;
  };
  union {
    __IO uint32_t PZRD;
    stc_gpio_pzrd_field_t PZRD_f;
  };
  union {
    __IO uint32_t PZRE;
    stc_gpio_pzre_field_t PZRE_f;
  };
  union {
    __IO uint32_t PZRF;
    stc_gpio_pzrf_field_t PZRF_f;
  };
  union {
    __IO uint32_t PDSR0;
    stc_gpio_pdsr0_field_t PDSR0_f;
  };
  union {
    __IO uint32_t PDSR1;
    stc_gpio_pdsr1_field_t PDSR1_f;
  };
  union {
    __IO uint32_t PDSR2;
    stc_gpio_pdsr2_field_t PDSR2_f;
  };
  union {
    __IO uint32_t PDSR3;
    stc_gpio_pdsr3_field_t PDSR3_f;
  };
  union {
    __IO uint32_t PDSR4;
    stc_gpio_pdsr4_field_t PDSR4_f;
  };
  union {
    __IO uint32_t PDSR5;
    stc_gpio_pdsr5_field_t PDSR5_f;
  };
  union {
    __IO uint32_t PDSR6;
    stc_gpio_pdsr6_field_t PDSR6_f;
  };
  union {
    __IO uint32_t PDSR7;
    stc_gpio_pdsr7_field_t PDSR7_f;
  };
  union {
    __IO uint32_t PDSR8;
    stc_gpio_pdsr8_field_t PDSR8_f;
  };
  union {
    __IO uint32_t PDSR9;
    stc_gpio_pdsr9_field_t PDSR9_f;
  };
  union {
    __IO uint32_t PDSRA;
    stc_gpio_pdsra_field_t PDSRA_f;
  };
  union {
    __IO uint32_t PDSRB;
    stc_gpio_pdsrb_field_t PDSRB_f;
  };
  union {
    __IO uint32_t PDSRC;
    stc_gpio_pdsrc_field_t PDSRC_f;
  };
  union {
    __IO uint32_t PDSRD;
    stc_gpio_pdsrd_field_t PDSRD_f;
  };
  union {
    __IO uint32_t PDSRE;
    stc_gpio_pdsre_field_t PDSRE_f;
  };
  union {
    __IO uint32_t PDSRF;
    stc_gpio_pdsrf_field_t PDSRF_f;
  };
}FM_GPIO_TypeDef;

/******************************************************************************
 * LVD_MODULE
 ******************************************************************************/
/* Low voltage detection registers */
typedef struct
{
  union {
    __IO  uint8_t LVD_CTL;
    stc_lvd_lvd_ctl_field_t LVD_CTL_f;
  };
        uint8_t RESERVED0[3];
  union {
    __IO  uint8_t LVD_STR;
    stc_lvd_lvd_str_field_t LVD_STR_f;
  };
        uint8_t RESERVED1[3];
  union {
    __IO  uint8_t LVD_CLR;
    stc_lvd_lvd_clr_field_t LVD_CLR_f;
  };
        uint8_t RESERVED2[3];
  __IO uint32_t LVD_RLR;
  union {
    __IO  uint8_t LVD_STR2;
    stc_lvd_lvd_str2_field_t LVD_STR2_f;
  };
}FM_LVD_TypeDef;

/******************************************************************************
 * DS_MODULE
 ******************************************************************************/
/* Deep standby mode registers */
typedef struct
{
       uint8_t RESERVED10[4];
  union {
    __IO  uint8_t RCK_CTL;
    stc_ds_rck_ctl_field_t RCK_CTL_f;
  };
       uint8_t RESERVED0[1787];
  union {
    __IO  uint8_t PMD_CTL;
    stc_ds_pmd_ctl_field_t PMD_CTL_f;
  };
       uint8_t RESERVED1[3];
  union {
    __IO  uint8_t WRFSR;
    stc_ds_wrfsr_field_t WRFSR_f;
  };
       uint8_t RESERVED2[3];
  union {
    __IO uint16_t WIFSR;
    stc_ds_wifsr_field_t WIFSR_f;
  };
       uint8_t RESERVED3[2];
  union {
    __IO uint16_t WIER;
    stc_ds_wier_field_t WIER_f;
  };
       uint8_t RESERVED4[2];
  union {
    __IO  uint8_t WILVR;
    stc_ds_wilvr_field_t WILVR_f;
  };
       uint8_t RESERVED5[3];
  union {
    __IO  uint8_t DSRAMR;
    stc_ds_dsramr_field_t DSRAMR_f;
  };
       uint8_t RESERVED6[235];
  __IO  uint8_t BUR01;
  __IO  uint8_t BUR02;
  __IO  uint8_t BUR03;
  __IO  uint8_t BUR04;
  __IO  uint8_t BUR05;
  __IO  uint8_t BUR06;
  __IO  uint8_t BUR07;
  __IO  uint8_t BUR08;
  __IO  uint8_t BUR09;
  __IO  uint8_t BUR10;
  __IO  uint8_t BUR11;
  __IO  uint8_t BUR12;
  __IO  uint8_t BUR13;
  __IO  uint8_t BUR14;
  __IO  uint8_t BUR15;
  __IO  uint8_t BUR16;
}FM_DS_TypeDef;

/******************************************************************************
 * USBCLK
 ******************************************************************************/
/* USB clock registers */
/*
typedef struct
{
  union {
    __IO  uint8_t UCCR;
    stc_usbclk_uccr_field_t UCCR_f;
  };
        uint8_t RESERVED0[3];
  union {
    __IO  uint8_t UPCR1;
    stc_usbclk_upcr1_field_t UPCR1_f;
  };
        uint8_t RESERVED1[3];
  union {
    __IO  uint8_t UPCR2;
    stc_usbclk_upcr2_field_t UPCR2_f;
  };
        uint8_t RESERVED2[3];
  union {
    __IO  uint8_t UPCR3;
    stc_usbclk_upcr3_field_t UPCR3_f;
  };
        uint8_t RESERVED3[3];
  union {
    __IO  uint8_t UPCR4;
    stc_usbclk_upcr4_field_t UPCR4_f;
  };
        uint8_t RESERVED4[3];
  union {
    __IO  uint8_t UP_STR;
    stc_usbclk_up_str_field_t UP_STR_f;
  };
        uint8_t RESERVED5[3];
  union {
    __IO  uint8_t UPINT_ENR;
    stc_usbclk_upint_enr_field_t UPINT_ENR_f;
  };
        uint8_t RESERVED6[3];
  union {
    __IO  uint8_t UPINT_CLR;
    stc_usbclk_upint_clr_field_t UPINT_CLR_f;
  };
        uint8_t RESERVED7[3];
  union {
    __IO  uint8_t UPINT_STR;
    stc_usbclk_upint_str_field_t UPINT_STR_f;
  };
        uint8_t RESERVED8[15];
  union {
    __IO  uint8_t USBEN;
    stc_usbclk_usben_field_t USBEN_f;
  };
}FM_USBCLK_TypeDef;
*/

/******************************************************************************
 * CANPRE_MODULE
 ******************************************************************************/
/* CAN prescaler register */
typedef struct
{
  union {
    __IO  uint8_t CANPRE;
    stc_canpre_canpre_field_t CANPRE_f;
  };
}FM_CANPRE_TypeDef;

/******************************************************************************
 * USBETHERNETCLK
 ******************************************************************************/
/* USB Ethernet clock registers */
typedef struct
{
  union {
    __IO  uint8_t UCCR;
    stc_usbethernetclk_uccr_field_t UCCR_f;
  };
        uint8_t RESERVED0[3];
  union {
    __IO  uint8_t UPCR1;
    stc_usbethernetclk_upcr1_field_t UPCR1_f;
  };
        uint8_t RESERVED1[3];
  union {
    __IO  uint8_t UPCR2;
    stc_usbethernetclk_upcr2_field_t UPCR2_f;
  };
        uint8_t RESERVED2[3];
  union {
    __IO  uint8_t UPCR3;
    stc_usbethernetclk_upcr3_field_t UPCR3_f;
  };
        uint8_t RESERVED3[3];
  union {
    __IO  uint8_t UPCR4;
    stc_usbethernetclk_upcr4_field_t UPCR4_f;
  };
        uint8_t RESERVED4[3];
  union {
    __IO  uint8_t UP_STR;
    stc_usbethernetclk_up_str_field_t UP_STR_f;
  };
        uint8_t RESERVED5[3];
  union {
    __IO  uint8_t UPINT_ENR;
    stc_usbethernetclk_upint_enr_field_t UPINT_ENR_f;
  };
        uint8_t RESERVED6[3];
  union {
    __IO  uint8_t UPINT_CLR;
    stc_usbethernetclk_upint_clr_field_t UPINT_CLR_f;
  };
        uint8_t RESERVED7[3];
  union {
    __IO  uint8_t UPINT_STR;
    stc_usbethernetclk_upint_str_field_t UPINT_STR_f;
  };
        uint8_t RESERVED8[3];
  union {
    __IO  uint8_t UPCR5;
    stc_usbethernetclk_upcr5_field_t UPCR5_f;
  };
        uint8_t RESERVED9[3];
  union {
    __IO  uint8_t UPCR6;
    stc_usbethernetclk_upcr6_field_t UPCR6_f;
  };
        uint8_t RESERVED10[3];
  union {
    __IO  uint8_t UPCR7;
    stc_usbethernetclk_upcr7_field_t UPCR7_f;
  };
        uint8_t RESERVED11[3];
  union {
    __IO  uint8_t USBEN0;
    stc_usbethernetclk_usben0_field_t USBEN0_f;
  };
        uint8_t RESERVED12[3];
  union {
    __IO  uint8_t USBEN1;
    stc_usbethernetclk_usben1_field_t USBEN1_f;
  };
}FM_USBETHERNETCLK_TypeDef;

/******************************************************************************
 * MFS_MODULE
 ******************************************************************************/
typedef struct
{
  union {
    __IO  uint8_t       SMR;
    stc_mfs_smr_field_t SMR_f;
  };
  union {
    __IO  uint8_t            SCR;
    stc_mfs_scr_field_t      SCR_f;
    __IO  uint8_t            IBCR;
    stc_mfs_i2c_ibcr_field_t IBCR_f;
  };
        uint8_t RESERVED0[2];
  union {
    __IO  uint8_t            ESCR;
    stc_mfs_escr_field_t     ESCR_f;
    __IO  uint8_t            IBSR;
    stc_mfs_i2c_ibsr_field_t IBSR_f;
  };
  union {
    __IO  uint8_t       SSR;
    stc_mfs_ssr_field_t SSR_f;
  };
        uint8_t RESERVED1[2];
  union {
    __IO uint32_t RDR32;
    __IO uint32_t TDR32;
    struct {
      union {
        __IO uint16_t            RDR;
        stc_mfs_uart_rdr_field_t RDR_f;
      };
             uint8_t RESERVED2[2];
    };
    struct {
      union {
        __IO uint16_t            TDR;
        stc_mfs_uart_tdr_field_t TDR_f;
      };
             uint8_t RESERVED3[2];
    };
  };
  union {
    union {
      __IO uint16_t       BGR;
      stc_mfs_bgr_field_t BGR_f;
    };
    struct {
      __IO  uint8_t BGR0;
      union {
        __IO  uint8_t        BGR1;
        stc_mfs_bgr1_field_t BGR1_f;
      };
    };
  };
        uint8_t RESERVED4[2];
  union {
    __IO  uint8_t            ISBA;
    stc_mfs_i2c_isba_field_t ISBA_f;
  };
  union {
    __IO  uint8_t            ISMK;
    stc_mfs_i2c_ismk_field_t ISMK_f;
  };
        uint8_t RESERVED5[2];
  union {
    union {
      __IO uint16_t       FCR;
      stc_mfs_fcr_field_t FCR_f;
    };
    struct {
      union {
        __IO  uint8_t        FCR0;
        stc_mfs_fcr0_field_t FCR0_f;
      };
      union {
        __IO  uint8_t        FCR1;
        stc_mfs_fcr1_field_t FCR1_f;
      };
    };
  };
        uint8_t RESERVED6[2];
  union {
    union {
      __IO uint16_t         FBYTE;
      stc_mfs_fbyte_field_t FBYTE_f;
    };
    struct {
      union {
        __IO  uint8_t          FBYTE1;
        stc_mfs_fbyte1_field_t FBYTE1_f;
      };
      union {
        __IO  uint8_t          FBYTE2;
        stc_mfs_fbyte2_field_t FBYTE2_f;
      };
    };
  };
        uint8_t RESERVED7[2];
  union {
    __IO uint16_t                SCSTR10;
    stc_mfs_csio_scstr10_field_t SCSTR10_f;
    struct {
      union {
        __IO  uint8_t               SCSTR0;
        stc_mfs_csio_scstr0_field_t SCSTR0_f;
        __IO  uint8_t NFCR;
        stc_mfs_i2c_nfcr_field_t NFCR_f;
      };
      union {
        __IO  uint8_t               SCSTR1;
        stc_mfs_csio_scstr1_field_t SCSTR1_f;
        __IO  uint8_t               EIBCR;
        stc_mfs_i2c_eibcr_field_t   EIBCR_f;
      };
    };
  };
        uint8_t RESERVED8[2];
  union {
    __IO uint16_t                SCSTR32;
    stc_mfs_csio_scstr32_field_t SCSTR32_f;
    struct {
      union {
        __IO  uint8_t               SCSTR2;
        stc_mfs_csio_scstr2_field_t SCSTR2_f;
      };
      union {
        __IO  uint8_t               SCSTR3;
        stc_mfs_csio_scstr3_field_t SCSTR3_f;
      };
    };
  };
        uint8_t RESERVED9[2];
  union {
    __IO uint16_t              SACSR;
    stc_mfs_csio_sacsr_field_t SACSR_f;
    struct {
      union {
        __IO  uint8_t               SACSR0;
        stc_mfs_csio_sacsr0_field_t SACSR0_f;
      };
      union {
        __IO  uint8_t               SACSR1;
        stc_mfs_csio_sacsr1_field_t SACSR1_f;
      };
    };
  };
        uint8_t RESERVED10[2];
  union {
    __IO uint16_t             STMR;
    stc_mfs_csio_stmr_field_t STMR_f;
    struct {
      union {
        __IO  uint8_t              STMR0;
        stc_mfs_csio_stmr0_field_t STMR0_f;
      };
      union {
        __IO  uint8_t              STMR1;
        stc_mfs_csio_stmr1_field_t STMR1_f;
      };
    };
  };
        uint8_t RESERVED11[2];
  union {
    __IO uint16_t              STMCR;
    stc_mfs_csio_stmcr_field_t STMCR_f;
    struct {
      union {
        __IO  uint8_t               STMCR0;
        stc_mfs_csio_stmcr0_field_t STMCR0_f;
      };
      union {
        __IO  uint8_t               STMCR1;
        stc_mfs_csio_stmcr1_field_t STMCR1_f;
      };
    };
  };
        uint8_t RESERVED12[2];
  union {
    __IO uint16_t              SCSCR;
    stc_mfs_csio_scscr_field_t SCSCR_f;
  };
        uint8_t RESERVED13[2];
  union {
    __IO uint16_t SCSFR;
    struct {
      union {
        __IO  uint8_t               SCSFR0;
        stc_mfs_csio_scsfr0_field_t SCSFR0_f;
      };
      union {
        __IO  uint8_t               SCSFR1;
        stc_mfs_csio_scsfr1_field_t SCSFR1_f;
      };
    };
  };
        uint8_t RESERVED14[2];
  union {
    __IO  uint8_t               SCSFR2;
    stc_mfs_csio_scsfr2_field_t SCSFR2_f;
  };
        uint8_t RESERVED15[3];
  union {
    __IO uint16_t TBYTE10;
    struct {
      __IO  uint8_t TBYTE0;
      __IO  uint8_t TBYTE1;
    };
  };
        uint8_t RESERVED16[2];
  union {
    __IO uint16_t TBYTE32;
    struct {
      __IO  uint8_t TBYTE2;
      __IO  uint8_t TBYTE3;
    };
  };
}FM_MFS_TypeDef;

/******************************************************************************
 * CRC_MODULE
 ******************************************************************************/
/* CRC registers */
typedef struct
{
  union {
    __IO  uint8_t CRCCR;
    stc_crc_crccr_field_t CRCCR_f;
  };
        uint8_t RESERVED0[3];
  __IO uint32_t CRCINIT;
  union {
    __IO uint32_t CRCIN;
    struct {
      union {
        __IO uint16_t CRCINL;
        struct {
          __IO  uint8_t CRCINLL;
          __IO  uint8_t CRCINLH;
        };
      };
      union {
        __IO uint16_t CRCINH;
        struct {
          __IO  uint8_t CRCINHL;
          __IO  uint8_t CRCINHH;
        };
      };
    };
  };
  __IO uint32_t CRCR;
}FM_CRC_TypeDef;

/******************************************************************************
 * DSTC_MODULE
 ******************************************************************************/
/* DSTC registers */
typedef struct
{
  __IO uint32_t DESTP;
  union {
    __IO uint32_t HWDESP;
    stc_dstc_hwdesp_field_t HWDESP_f;
  };
  __IO uint8_t CMD;
  union {
    __IO uint8_t CFG;
    stc_dstc_cfg_field_t CFG_f;
  };
  union {
    __IO uint16_t SWTR;
    stc_dstc_swtr_field_t SWTR_f;
  };
  union {
    __IO uint32_t MONERS;
    stc_dstc_moners_field_t MONERS_f;
  };
  __IO uint32_t DREQENB0;
  __IO uint32_t DREQENB1;
  __IO uint32_t DREQENB2;
  __IO uint32_t DREQENB3;
  __IO uint32_t DREQENB4;
  __IO uint32_t DREQENB5;
  __IO uint32_t DREQENB6;
  __IO uint32_t DREQENB7;
  __IO uint32_t HWINT0;
  __IO uint32_t HWINT1;
  __IO uint32_t HWINT2;
  __IO uint32_t HWINT3;
  __IO uint32_t HWINT4;
  __IO uint32_t HWINT5;
  __IO uint32_t HWINT6;
  __IO uint32_t HWINT7;
  __IO uint32_t HWINTCLR0;
  __IO uint32_t HWINTCLR1;
  __IO uint32_t HWINTCLR2;
  __IO uint32_t HWINTCLR3;
  __IO uint32_t HWINTCLR4;
  __IO uint32_t HWINTCLR5;
  __IO uint32_t HWINTCLR6;
  __IO uint32_t HWINTCLR7;
  __IO uint32_t DQMSK0;
  __IO uint32_t DQMSK1;
  __IO uint32_t DQMSK2;
  __IO uint32_t DQMSK3;
  __IO uint32_t DQMSK4;
  __IO uint32_t DQMSK5;
  __IO uint32_t DQMSK6;
  __IO uint32_t DQMSK7;
  __IO uint32_t DQMSKCLR0;
  __IO uint32_t DQMSKCLR1;
  __IO uint32_t DQMSKCLR2;
  __IO uint32_t DQMSKCLR3;
  __IO uint32_t DQMSKCLR4;
  __IO uint32_t DQMSKCLR5;
  __IO uint32_t DQMSKCLR6;
  __IO uint32_t DQMSKCLR7;
}FM_DSTC_TypeDef;

/******************************************************************************
 * WC_MODULE
 ******************************************************************************/
/* Watch counter registers */
typedef struct
{
  union {
    __IO  uint8_t WCRD;
    stc_wc_wcrd_field_t WCRD_f;
  };
  union {
    __IO  uint8_t WCRL;
    stc_wc_wcrl_field_t WCRL_f;
  };
  union {
    __IO  uint8_t WCCR;
    stc_wc_wccr_field_t WCCR_f;
  };
        uint8_t RESERVED0[13];
  union {
    __IO uint16_t CLK_SEL;
    stc_wc_clk_sel_field_t CLK_SEL_f;
  };
        uint8_t RESERVED1[2];
  union {
    __IO  uint8_t CLK_EN;
    stc_wc_clk_en_field_t CLK_EN_f;
  };
}FM_WC_TypeDef;

/******************************************************************************
 * RTC_MODULE
 ******************************************************************************/
/* Real time clock registers */
typedef struct
{
  union {
    __IO  uint8_t WTCR10;
    stc_rtc_wtcr10_field_t WTCR10_f;
  };
        uint8_t RESERVED1[3];
  union {
    __IO  uint8_t WTCR11;
    stc_rtc_wtcr11_field_t WTCR11_f;
  };
        uint8_t RESERVED2[3];
  union {
    __IO  uint8_t WTCR12;
    stc_rtc_wtcr12_field_t WTCR12_f;
  };
        uint8_t RESERVED3[3];
  union {
    __IO  uint8_t WTCR13;
    stc_rtc_wtcr13_field_t WTCR13_f;
  };
        uint8_t RESERVED4[3];
  union {
    __IO  uint8_t WTCR20;
    stc_rtc_wtcr20_field_t WTCR20_f;
  };
        uint8_t RESERVED5[3];
  union {
    __IO  uint8_t WTCR21;
    stc_rtc_wtcr21_field_t WTCR21_f;
  };
        uint8_t RESERVED6[3];
  __IO  uint8_t WTCR22;
        uint8_t RESERVED7[3];
  union {
    __IO  uint8_t WTSR;
    stc_rtc_wtsr_field_t WTSR_f;
  };
        uint8_t RESERVED8[3];
  union {
    __IO  uint8_t WTMIR;
    stc_rtc_wtmir_field_t WTMIR_f;
  };
        uint8_t RESERVED9[3];
  union {
    __IO  uint8_t WTHR;
    stc_rtc_wthr_field_t WTHR_f;
  };
        uint8_t RESERVED10[3];
  union {
    __IO  uint8_t WTDR;
    stc_rtc_wtdr_field_t WTDR_f;
  };
        uint8_t RESERVED11[3];
  union {
    __IO  uint8_t WTDW;
    stc_rtc_wtdw_field_t WTDW_f;
  };
        uint8_t RESERVED12[3];
  union {
    __IO  uint8_t WTMOR;
    stc_rtc_wtmor_field_t WTMOR_f;
  };
        uint8_t RESERVED13[3];
  union {
    __IO  uint8_t WTYR;
    stc_rtc_wtyr_field_t WTYR_f;
  };
        uint8_t RESERVED14[3];
  union {
    __IO  uint8_t ALMIR;
    stc_rtc_almir_field_t ALMIR_f;
  };
        uint8_t RESERVED15[3];
  union {
    __IO  uint8_t ALHR;
    stc_rtc_alhr_field_t ALHR_f;
  };
        uint8_t RESERVED16[3];
  union {
    __IO  uint8_t ALDR;
    stc_rtc_aldr_field_t ALDR_f;
  };
        uint8_t RESERVED17[3];
  union {
    __IO  uint8_t ALMOR;
    stc_rtc_almor_field_t ALMOR_f;
  };
        uint8_t RESERVED18[3];
  union {
    __IO  uint8_t ALYR;
    stc_rtc_alyr_field_t ALYR_f;
  };
        uint8_t RESERVED19[3];
  union {
    __IO  uint8_t WTTR0;
    stc_rtc_wttr0_field_t WTTR0_f;
  };
        uint8_t RESERVED20[3];
  union {
    __IO  uint8_t WTTR1;
    stc_rtc_wttr1_field_t WTTR1_f;
  };
        uint8_t RESERVED21[3];
  union {
    __IO  uint8_t WTTR2;
    stc_rtc_wttr2_field_t WTTR2_f;
  };
        uint8_t RESERVED22[3];
  __IO  uint8_t WTCAL0;
        uint8_t RESERVED23[3];
  union {
    __IO  uint8_t WTCAL1;
    stc_rtc_wtcal1_field_t WTCAL1_f;
  };
        uint8_t RESERVED24[3];
  union {
    __IO  uint8_t WTCALEN;
    stc_rtc_wtcalen_field_t WTCALEN_f;
  };
        uint8_t RESERVED25[3];
  union {
    __IO  uint8_t WTDIV;
    stc_rtc_wtdiv_field_t WTDIV_f;
  };
        uint8_t RESERVED26[3];
  union {
    __IO  uint8_t WTDIVEN;
    stc_rtc_wtdiven_field_t WTDIVEN_f;
  };
        uint8_t RESERVED27[3];
  union {
    __IO  uint8_t WTCALPRD;
    stc_rtc_wtcalprd_field_t WTCALPRD_f;
  };
        uint8_t RESERVED28[3];
  union {
    __IO  uint8_t WTCOSEL;
    stc_rtc_wtcosel_field_t WTCOSEL_f;
  };
        uint8_t RESERVED29[3];
  union {
    __IO  uint8_t VB_CLKDIV;
    stc_rtc_vb_clkdiv_field_t VB_CLKDIV_f;
  };
        uint8_t RESERVED30[3];
  union {
    __IO  uint8_t WTOSCCNT;
    stc_rtc_wtosccnt_field_t WTOSCCNT_f;
  };
        uint8_t RESERVED31[3];
  __IO  uint8_t CCS;
        uint8_t RESERVED32[3];
  __IO  uint8_t CCB;
        uint8_t RESERVED33[3];
  /* Don't exist on peripheral manual */
  __IO  uint8_t TRIM;
        uint8_t RESERVED34[3];
  union {
    __IO  uint8_t BOOST;
    stc_rtc_boost_field_t BOOST_f;
  };
        uint8_t RESERVED35[3];
  union {
    __IO  uint8_t EWKUP;
    stc_rtc_ewkup_field_t EWKUP_f;
  };
        uint8_t RESERVED36[3];
  union {
    __IO  uint8_t VDET;
    stc_rtc_vdet_field_t VDET_f;
  };
        uint8_t RESERVED37[3];
  /* Don't exist on peripheral manual */
  __IO  uint8_t FDET;
        uint8_t RESERVED38[3];
  union {
    __IO  uint8_t HIBRST;
    stc_rtc_hibrst_field_t HIBRST_f;
  };
        uint8_t RESERVED39[3];
  union {
    __IO  uint8_t VBPFR;
    stc_rtc_vbpfr_field_t VBPFR_f;
  };
        uint8_t RESERVED40[3];
  union {
    __IO  uint8_t VBPCR;
    stc_rtc_vbpcr_field_t VBPCR_f;
  };
        uint8_t RESERVED41[3];
  union {
    __IO  uint8_t VBDDR;
    stc_rtc_vbddr_field_t VBDDR_f;
  };
        uint8_t RESERVED42[3];
  union {
    __IO  uint8_t VBDIR;
    stc_rtc_vbdir_field_t VBDIR_f;
  };
        uint8_t RESERVED43[3];
  union {
    __IO  uint8_t VBDOR;
    stc_rtc_vbdor_field_t VBDOR_f;
  };
        uint8_t RESERVED44[3];
  union {
    __IO  uint8_t VBPZR;
    stc_rtc_vbpzr_field_t VBPZR_f;
  };
        uint8_t RESERVED45[79];
  union {
    __IO uint32_t BREG00_03;
    struct {
      __IO uint16_t BREG00_01;
      __IO uint16_t BREG02_03;
    };
    struct {
      __IO  uint8_t BREG00;
      __IO  uint8_t BREG01;
      __IO  uint8_t BREG02;
      __IO  uint8_t BREG03;
    };
  };
  union {
    __IO uint32_t BREG04_07;
    struct {
      __IO uint16_t BREG04_05;
      __IO uint16_t BREG06_07;
    };
    struct {
      __IO  uint8_t BREG04;
      __IO  uint8_t BREG05;
      __IO  uint8_t BREG06;
      __IO  uint8_t BREG07;
    };
  };
  union {
    __IO uint32_t BREG08_0B;
    struct {
      __IO uint16_t BREG08_09;
      __IO uint16_t BREG0A_0B;
    };
    struct {
      __IO  uint8_t BREG08;
      __IO  uint8_t BREG09;
      __IO  uint8_t BREG0A;
      __IO  uint8_t BREG0B;
    };
  };
  union {
    __IO uint32_t BREG0C_0F;
    struct {
      __IO uint16_t BREG0C_0D;
      __IO uint16_t BREG0E_0F;
    };
    struct {
      __IO  uint8_t BREG0C;
      __IO  uint8_t BREG0D;
      __IO  uint8_t BREG0E;
      __IO  uint8_t BREG0F;
    };
  };
  union {
    __IO uint32_t BREG10_13;
    struct {
      __IO uint16_t BREG10_11;
      __IO uint16_t BREG12_13;
    };
    struct {
      __IO  uint8_t BREG10;
      __IO  uint8_t BREG11;
      __IO  uint8_t BREG12;
      __IO  uint8_t BREG13;
    };
  };
  union {
    __IO uint32_t BREG14_17;
    struct {
      __IO uint16_t BREG14_15;
      __IO uint16_t BREG16_17;
    };
    struct {
      __IO  uint8_t BREG14;
      __IO  uint8_t BREG15;
      __IO  uint8_t BREG16;
      __IO  uint8_t BREG17;
    };
  };
  union {
    __IO uint32_t BREG18_1B;
    struct {
      __IO uint16_t BREG18_19;
      __IO uint16_t BREG1A_1B;
    };
    struct {
      __IO  uint8_t BREG18;
      __IO  uint8_t BREG19;
      __IO  uint8_t BREG1A;
      __IO  uint8_t BREG1B;
    };
  };
  union {
    __IO uint32_t BREG1C_1F;
    struct {
      __IO uint16_t BREG1C_1D;
      __IO uint16_t BREG1E_1F;
    };
    struct {
      __IO  uint8_t BREG1C;
      __IO  uint8_t BREG1D;
      __IO  uint8_t BREG1E;
      __IO  uint8_t BREG1F;
    };
  };
  union {
    __IO uint32_t BREG20_23;
    struct {
      __IO uint16_t BREG20_21;
      __IO uint16_t BREG22_23;
    };
    struct {
      __IO  uint8_t BREG20;
      __IO  uint8_t BREG21;
      __IO  uint8_t BREG22;
      __IO  uint8_t BREG23;
    };
  };
  union {
    __IO uint32_t BREG24_27;
    struct {
      __IO uint16_t BREG24_25;
      __IO uint16_t BREG26_27;
    };
    struct {
      __IO  uint8_t BREG24;
      __IO  uint8_t BREG25;
      __IO  uint8_t BREG26;
      __IO  uint8_t BREG27;
    };
  };
  union {
    __IO uint32_t BREG28_2B;
    struct {
      __IO uint16_t BREG28_29;
      __IO uint16_t BREG2A_2B;
    };
    struct {
      __IO  uint8_t BREG28;
      __IO  uint8_t BREG29;
      __IO  uint8_t BREG2A;
      __IO  uint8_t BREG2B;
    };
  };
  union {
    __IO uint32_t BREG2C_2F;
    struct {
      __IO uint16_t BREG2C_2D;
      __IO uint16_t BREG2E_2F;
    };
    struct {
      __IO  uint8_t BREG2C;
      __IO  uint8_t BREG2D;
      __IO  uint8_t BREG2E;
      __IO  uint8_t BREG2F;
    };
  };
  union {
    __IO uint32_t BREG30_33;
    struct {
      __IO uint16_t BREG30_31;
      __IO uint16_t BREG32_33;
    };
    struct {
      __IO  uint8_t BREG30;
      __IO  uint8_t BREG31;
      __IO  uint8_t BREG32;
      __IO  uint8_t BREG33;
    };
  };
  union {
    __IO uint32_t BREG34_37;
    struct {
      __IO uint16_t BREG34_35;
      __IO uint16_t BREG36_37;
    };
    struct {
      __IO  uint8_t BREG34;
      __IO  uint8_t BREG35;
      __IO  uint8_t BREG36;
      __IO  uint8_t BREG37;
    };
  };
  union {
    __IO uint32_t BREG38_3B;
    struct {
      __IO uint16_t BREG38_39;
      __IO uint16_t BREG3A_3B;
    };
    struct {
      __IO  uint8_t BREG38;
      __IO  uint8_t BREG39;
      __IO  uint8_t BREG3A;
      __IO  uint8_t BREG3B;
    };
  };
  union {
    __IO uint32_t BREG3C_3F;
    struct {
      __IO uint16_t BREG3C_3D;
      __IO uint16_t BREG3E_3F;
    };
    struct {
      __IO  uint8_t BREG3C;
      __IO  uint8_t BREG3D;
      __IO  uint8_t BREG3E;
      __IO  uint8_t BREG3F;
    };
  };
  union {
    __IO uint32_t BREG40_43;
    struct {
      __IO uint16_t BREG40_41;
      __IO uint16_t BREG42_43;
    };
    struct {
      __IO  uint8_t BREG40;
      __IO  uint8_t BREG41;
      __IO  uint8_t BREG42;
      __IO  uint8_t BREG43;
    };
  };
  union {
    __IO uint32_t BREG44_47;
    struct {
      __IO uint16_t BREG44_45;
      __IO uint16_t BREG46_47;
    };
    struct {
      __IO  uint8_t BREG44;
      __IO  uint8_t BREG45;
      __IO  uint8_t BREG46;
      __IO  uint8_t BREG47;
    };
  };
  union {
    __IO uint32_t BREG48_4B;
    struct {
      __IO uint16_t BREG48_49;
      __IO uint16_t BREG4A_4B;
    };
    struct {
      __IO  uint8_t BREG48;
      __IO  uint8_t BREG49;
      __IO  uint8_t BREG4A;
      __IO  uint8_t BREG4B;
    };
  };
  union {
    __IO uint32_t BREG4C_4F;
    struct {
      __IO uint16_t BREG4C_4D;
      __IO uint16_t BREG4E_4F;
    };
    struct {
      __IO  uint8_t BREG4C;
      __IO  uint8_t BREG4D;
      __IO  uint8_t BREG4E;
      __IO  uint8_t BREG4F;
    };
  };
  union {
    __IO uint32_t BREG50_53;
    struct {
      __IO uint16_t BREG50_51;
      __IO uint16_t BREG52_53;
    };
    struct {
      __IO  uint8_t BREG50;
      __IO  uint8_t BREG51;
      __IO  uint8_t BREG52;
      __IO  uint8_t BREG53;
    };
  };
  union {
    __IO uint32_t BREG54_57;
    struct {
      __IO uint16_t BREG54_55;
      __IO uint16_t BREG56_57;
    };
    struct {
      __IO  uint8_t BREG54;
      __IO  uint8_t BREG55;
      __IO  uint8_t BREG56;
      __IO  uint8_t BREG57;
    };
  };
  union {
    __IO uint32_t BREG58_5B;
    struct {
      __IO uint16_t BREG58_59;
      __IO uint16_t BREG5A_5B;
    };
    struct {
      __IO  uint8_t BREG58;
      __IO  uint8_t BREG59;
      __IO  uint8_t BREG5A;
      __IO  uint8_t BREG5B;
    };
  };
  union {
    __IO uint32_t BREG5C_5F;
    struct {
      __IO uint16_t BREG5C_5D;
      __IO uint16_t BREG5E_5F;
    };
    struct {
      __IO  uint8_t BREG5C;
      __IO  uint8_t BREG5D;
      __IO  uint8_t BREG5E;
      __IO  uint8_t BREG5F;
    };
  };
  union {
    __IO uint32_t BREG60_63;
    struct {
      __IO uint16_t BREG60_61;
      __IO uint16_t BREG62_63;
    };
    struct {
      __IO  uint8_t BREG60;
      __IO  uint8_t BREG61;
      __IO  uint8_t BREG62;
      __IO  uint8_t BREG63;
    };
  };
  union {
    __IO uint32_t BREG64_67;
    struct {
      __IO uint16_t BREG64_65;
      __IO uint16_t BREG66_67;
    };
    struct {
      __IO  uint8_t BREG64;
      __IO  uint8_t BREG65;
      __IO  uint8_t BREG66;
      __IO  uint8_t BREG67;
    };
  };
  union {
    __IO uint32_t BREG68_6B;
    struct {
      __IO uint16_t BREG68_69;
      __IO uint16_t BREG6A_6B;
    };
    struct {
      __IO  uint8_t BREG68;
      __IO  uint8_t BREG69;
      __IO  uint8_t BREG6A;
      __IO  uint8_t BREG6B;
    };
  };
  union {
    __IO uint32_t BREG6C_6F;
    struct {
      __IO uint16_t BREG6C_6D;
      __IO uint16_t BREG6E_6F;
    };
    struct {
      __IO  uint8_t BREG6C;
      __IO  uint8_t BREG6D;
      __IO  uint8_t BREG6E;
      __IO  uint8_t BREG6F;
    };
  };
  union {
    __IO uint32_t BREG70_73;
    struct {
      __IO uint16_t BREG70_71;
      __IO uint16_t BREG72_73;
    };
    struct {
      __IO  uint8_t BREG70;
      __IO  uint8_t BREG71;
      __IO  uint8_t BREG72;
      __IO  uint8_t BREG73;
    };
  };
  union {
    __IO uint32_t BREG74_77;
    struct {
      __IO uint16_t BREG74_75;
      __IO uint16_t BREG76_77;
    };
    struct {
      __IO  uint8_t BREG74;
      __IO  uint8_t BREG75;
      __IO  uint8_t BREG76;
      __IO  uint8_t BREG77;
    };
  };
  union {
    __IO uint32_t BREG78_7B;
    struct {
      __IO uint16_t BREG78_79;
      __IO uint16_t BREG7A_7B;
    };
    struct {
      __IO  uint8_t BREG78;
      __IO  uint8_t BREG79;
      __IO  uint8_t BREG7A;
      __IO  uint8_t BREG7B;
    };
  };
  union {
    __IO uint32_t BREG7C_7F;
    struct {
      __IO uint16_t BREG7C_7D;
      __IO uint16_t BREG7E_7F;
    };
    struct {
      __IO  uint8_t BREG7C;
      __IO  uint8_t BREG7D;
      __IO  uint8_t BREG7E;
      __IO  uint8_t BREG7F;
    };
  };
}FM_RTC_TypeDef;

/******************************************************************************
 * LCR_MODULE
 ******************************************************************************/
/* Low-speed CR prescaler registers */
typedef struct
{
  union {
    __IO  uint8_t LCR_PRSLD;
    stc_lcr_lcr_prsld_field_t LCR_PRSLD_f;
  };
}FM_LCR_TypeDef;

/******************************************************************************
 * CLK_GATING_MODULE
 ******************************************************************************/
/* CLK_GATING registers */
typedef struct
{
  union {
    __IO uint32_t CKEN0;
    stc_clk_gating_cken0_field_t CKEN0_f;
  };
  union {
    __IO uint32_t MRST0;
    stc_clk_gating_mrst0_field_t MRST0_f;
  };
       uint8_t RESERVED1[8];
  union {
    __IO uint32_t CKEN1;
    stc_clk_gating_cken1_field_t CKEN1_f;
  };
  union {
    __IO uint32_t MRST1;
    stc_clk_gating_mrst1_field_t MRST1_f;
  };
       uint8_t RESERVED3[8];
  union {
    __IO uint32_t CKEN2;
    stc_clk_gating_cken2_field_t CKEN2_f;
  };
  union {
    __IO uint32_t MRST2;
    stc_clk_gating_mrst2_field_t MRST2_f;
  };
}FM_CLK_GATING_TypeDef;

/******************************************************************************
 * PLL_CONTROL_MODULE
 ******************************************************************************/
/* PLL_CONTROL registers */
typedef struct
{
  __IO uint32_t SSCTL1;
  __IO uint32_t SSCTL2;
}FM_PLL_CONTROL_TypeDef;

/******************************************************************************
 * I2SPRE_MODULE
 ******************************************************************************/
/* I2SPRE registers */
typedef struct
{
  union {
    __IO uint32_t ICCR;
    stc_i2spre_iccr_field_t ICCR_f;
  };
  union {
    __IO uint32_t IPCR1;
    stc_i2spre_ipcr1_field_t IPCR1_f;
  };
  union {
    __IO uint32_t IPCR2;
    stc_i2spre_ipcr2_field_t IPCR2_f;
  };
  union {
    __IO uint32_t IPCR3;
    stc_i2spre_ipcr3_field_t IPCR3_f;
  };
  union {
    __IO uint32_t IPCR4;
    stc_i2spre_ipcr4_field_t IPCR4_f;
  };
  union {
    __IO uint32_t IP_STR;
    stc_i2spre_ip_str_field_t IP_STR_f;
  };
  union {
    __IO uint32_t IPINT_ENR;
    stc_i2spre_ipint_enr_field_t IPINT_ENR_f;
  };
  union {
    __IO uint32_t IPINT_CLR;
    stc_i2spre_ipint_clr_field_t IPINT_CLR_f;
  };
  union {
    __IO uint32_t IPINT_STR;
    stc_i2spre_ipint_str_field_t IPINT_STR_f;
  };
  union {
    __IO uint32_t IPCR5;
    stc_i2spre_ipcr5_field_t IPCR5_f;
  };
}FM_I2SPRE_TypeDef;

/******************************************************************************
 * EXBUS_MODULE
 ******************************************************************************/
/* External bus interface registers */
typedef struct
{
  union {
    __IO uint32_t MODE0;
    stc_exbus_mode_field_t MODE0_f;
  };
  union {
    __IO uint32_t MODE1;
    stc_exbus_mode_field_t MODE1_f;
  };
  union {
    __IO uint32_t MODE2;
    stc_exbus_mode_field_t MODE2_f;
  };
  union {
    __IO uint32_t MODE3;
    stc_exbus_mode_field_t MODE3_f;
  };
  union {
    __IO uint32_t MODE4;
    stc_exbus_mode_field_t MODE4_f;
  };
  union {
    __IO uint32_t MODE5;
    stc_exbus_mode_field_t MODE5_f;
  };
  union {
    __IO uint32_t MODE6;
    stc_exbus_mode_field_t MODE6_f;
  };
  union {
    __IO uint32_t MODE7;
    stc_exbus_mode_field_t MODE7_f;
  };
  union {
    __IO uint32_t TIM0;
    stc_exbus_tim_field_t TIM0_f;
  };
  __IO uint32_t TIM1;
  union {
    __IO uint32_t TIM2;
    stc_exbus_tim_field_t TIM2_f;
  };
  union {
    __IO uint32_t TIM3;
    stc_exbus_tim_field_t TIM3_f;
  };
  union {
    __IO uint32_t TIM4;
    stc_exbus_tim_field_t TIM4_f;
  };
  union {
    __IO uint32_t TIM5;
    stc_exbus_tim_field_t TIM5_f;
  };
  union {
    __IO uint32_t TIM6;
    stc_exbus_tim_field_t TIM6_f;
  };
  union {
    __IO uint32_t TIM7;
    stc_exbus_tim_field_t TIM7_f;
  };
  union {
    __IO uint32_t AREA0;
    stc_exbus_area_field_t AREA0_f;
  };
  union {
    __IO uint32_t AREA1;
    stc_exbus_area_field_t AREA1_f;
  };
  union {
    __IO uint32_t AREA2;
    stc_exbus_area_field_t AREA2_f;
  };
  union {
    __IO uint32_t AREA3;
    stc_exbus_area_field_t AREA3_f;
  };
  union {
    __IO uint32_t AREA4;
    stc_exbus_area_field_t AREA4_f;
  };
  union {
    __IO uint32_t AREA5;
    stc_exbus_area_field_t AREA5_f;
  };
  union {
    __IO uint32_t AREA6;
    stc_exbus_area_field_t AREA6_f;
  };
  union {
    __IO uint32_t AREA7;
    stc_exbus_area_field_t AREA7_f;
  };
  union {
    __IO uint32_t ATIM0;
    stc_exbus_atim_field_t ATIM0_f;
  };
  union {
    __IO uint32_t ATIM1;
    stc_exbus_atim_field_t ATIM1_f;
  };
  union {
    __IO uint32_t ATIM2;
    stc_exbus_atim_field_t ATIM2_f;
  };
  union {
    __IO uint32_t ATIM3;
    stc_exbus_atim_field_t ATIM3_f;
  };
  union {
    __IO uint32_t ATIM4;
    stc_exbus_atim_field_t ATIM4_f;
  };
  union {
    __IO uint32_t ATIM5;
    stc_exbus_atim_field_t ATIM5_f;
  };
  union {
    __IO uint32_t ATIM6;
    stc_exbus_atim_field_t ATIM6_f;
  };
  union {
    __IO uint32_t ATIM7;
    stc_exbus_atim_field_t ATIM7_f;
  };
    uint8_t RESERVED1[128];
  union {
    __IO uint32_t SDMODE;
    stc_exbus_sdmode_field_t SDMODE_f;
  };
  union {
    __IO uint32_t REFTIM;
    stc_exbus_reftim_field_t REFTIM_f;
  };
  union {
    __IO uint32_t PWRDWN;
    stc_exbus_pwrdwn_field_t PWRDWN_f;
  };
  union {
    __IO uint32_t SDTIM;
    stc_exbus_sdtim_field_t SDTIM_f;
  };
  union {
    __IO uint32_t SDCMD;
    stc_exbus_sdcmd_field_t SDCMD_f;
  };
    uint8_t RESERVED2[236];
  union {
    __IO uint32_t MEMCERR;
    stc_exbus_memcerr_field_t MEMCERR_f;
  };
    uint8_t RESERVED3[252];
  union {
    __IO uint32_t DCLKR;
    stc_exbus_dclkr_field_t DCLKR_f;
  };
  union {
    __IO uint32_t EST;
    stc_exbus_est_field_t EST_f;
  };
  union {
    __IO uint32_t WEAD;
    stc_exbus_wead_field_t WEAD_f;
  };
  union {
    __IO uint32_t ESCLR;
    stc_exbus_esclr_field_t ESCLR_f;
  };
  union {
    __IO uint32_t AMODE;
    stc_exbus_amode_field_t AMODE_f;
  };
}FM_EXBUS_TypeDef;

/******************************************************************************
 * USB_MODULE
 ******************************************************************************/
/* USB channel 0 registers */
typedef struct
{
  union {
    union {
      __IO uint16_t HCNT;
      stc_usb_hcnt_field_t HCNT_f;
    };
    struct {
      union {
        __IO  uint8_t HCNT0;
        stc_usb_hcnt0_field_t HCNT0_f;
      };
      union {
        __IO  uint8_t HCNT1;
        stc_usb_hcnt1_field_t HCNT1_f;
      };
    };
  };
        uint8_t RESERVED0[2];
  union {
    __IO  uint8_t HIRQ;
    stc_usb_hirq_field_t HIRQ_f;
  };
  union {
    __IO  uint8_t HERR;
    stc_usb_herr_field_t HERR_f;
  };
        uint8_t RESERVED1[2];
  union {
    __IO  uint8_t HSTATE;
    stc_usb_hstate_field_t HSTATE_f;
  };
  union {
    __IO  uint8_t HFCOMP;
    stc_usb_hfcomp_field_t HFCOMP_f;
  };
        uint8_t RESERVED2[2];
  union {
    union {
      __IO uint16_t HRTIMER;
      stc_usb_hrtimer_field_t HRTIMER_f;
    };
    struct {
      union {
        __IO  uint8_t HRTIMER0;
        stc_usb_hrtimer0_field_t HRTIMER0_f;
      };
      union {
        __IO  uint8_t HRTIMER1;
        stc_usb_hrtimer1_field_t HRTIMER1_f;
      };
    };
  };
        uint8_t RESERVED3[2];
  union {
    __IO  uint8_t HRTIMER2;
    stc_usb_hrtimer2_field_t HRTIMER2_f;
  };
  union {
    __IO  uint8_t HADR;
    stc_usb_hadr_field_t HADR_f;
  };
        uint8_t RESERVED4[2];
  union {
    union {
      __IO uint16_t HEOF;
      stc_usb_heof_field_t HEOF_f;
    };
    struct {
      union {
        __IO  uint8_t HEOF0;
        stc_usb_heof0_field_t HEOF0_f;
      };
      union {
        __IO  uint8_t HEOF1;
        stc_usb_heof1_field_t HEOF1_f;
      };
    };
  };
        uint8_t RESERVED5[2];
  union {
    union {
      __IO uint16_t HFRAME;
      stc_usb_hframe_field_t HFRAME_f;
    };
    struct {
      union {
        __IO  uint8_t HFRAME0;
        stc_usb_hframe0_field_t HFRAME0_f;
      };
      union {
        __IO  uint8_t HFRAME1;
        stc_usb_hframe1_field_t HFRAME1_f;
      };
    };
  };
        uint8_t RESERVED6[2];
  union {
    __IO  uint8_t HTOKEN;
    stc_usb_htoken_field_t HTOKEN_f;
  };
        uint8_t RESERVED7[3];
  union {
    __IO uint16_t UDCC;
    stc_usb_udcc_field_t UDCC_f;
  };
        uint8_t RESERVED8[2];
  union {
    __IO uint16_t EP0C;
    stc_usb_ep0c_field_t EP0C_f;
  };
        uint8_t RESERVED9[2];
  union {
    __IO uint16_t EP1C;
    stc_usb_ep1c_field_t EP1C_f;
  };
        uint8_t RESERVED10[2];
  union {
    __IO uint16_t EP2C;
    stc_usb_ep2c_field_t EP2C_f;
  };
        uint8_t RESERVED11[2];
  union {
    __IO uint16_t EP3C;
    stc_usb_ep3c_field_t EP3C_f;
  };
        uint8_t RESERVED12[2];
  union {
    __IO uint16_t EP4C;
    stc_usb_ep4c_field_t EP4C_f;
  };
        uint8_t RESERVED13[2];
  union {
    __IO uint16_t EP5C;
    stc_usb_ep5c_field_t EP5C_f;
  };
        uint8_t RESERVED14[2];
  union {
    __IO uint16_t TMSP;
    stc_usb_tmsp_field_t TMSP_f;
  };
        uint8_t RESERVED15[2];
  union {
    __IO  uint8_t UDCS;
    stc_usb_udcs_field_t UDCS_f;
  };
  union {
    __IO  uint8_t UDCIE;
    stc_usb_udcie_field_t UDCIE_f;
  };
        uint8_t RESERVED16[2];
  union {
    __IO uint16_t EP0IS;
    stc_usb_ep0is_field_t EP0IS_f;
  };
        uint8_t RESERVED17[2];
  union {
    __IO uint16_t EP0OS;
    stc_usb_ep0os_field_t EP0OS_f;
  };
        uint8_t RESERVED18[2];
  union {
    __IO uint16_t EP1S;
    stc_usb_ep1s_field_t EP1S_f;
  };
        uint8_t RESERVED19[2];
  union {
    __IO uint16_t EP2S;
    stc_usb_ep2s_field_t EP2S_f;
  };
        uint8_t RESERVED20[2];
  __IO uint16_t EP3S;
        uint8_t RESERVED21[2];
  union {
    __IO uint16_t EP4S;
    stc_usb_ep4s_field_t EP4S_f;
  };
        uint8_t RESERVED22[2];
  union {
    __IO uint16_t EP5S;
    stc_usb_ep5s_field_t EP5S_f;
  };
        uint8_t RESERVED23[2];
  union {
    __IO uint16_t EP0DT;
    struct {
      __IO  uint8_t EP0DTL;
      __IO  uint8_t EP0DTH;
    };
  };
        uint8_t RESERVED24[2];
  union {
    __IO uint16_t EP1DT;
    struct {
      __IO  uint8_t EP1DTL;
      __IO  uint8_t EP1DTH;
    };
  };
        uint8_t RESERVED25[2];
  union {
    __IO uint16_t EP2DT;
    struct {
      __IO  uint8_t EP2DTL;
      __IO  uint8_t EP2DTH;
    };
  };
        uint8_t RESERVED26[2];
  union {
    __IO uint16_t EP3DT;
    struct {
      __IO  uint8_t EP3DTL;
      __IO  uint8_t EP3DTH;
    };
  };
        uint8_t RESERVED27[2];
  union {
    __IO uint16_t EP4DT;
    struct {
      __IO  uint8_t EP4DTL;
      __IO  uint8_t EP4DTH;
    };
  };
        uint8_t RESERVED28[2];
  union {
    __IO uint16_t EP5DT;
    struct {
      __IO  uint8_t EP5DTL;
      __IO  uint8_t EP5DTH;
    };
  };
}FM_USB_TypeDef;

/******************************************************************************
 * DMAC_MODULE
 ******************************************************************************/
/* DMA controller */
typedef struct
{
  union {
    __IO uint32_t DMACR;
    stc_dmac_dmacr_field_t DMACR_f;
  };
        uint8_t RESERVED0[12];
  union {
    __IO uint32_t DMACA0;
    stc_dmac_dmaca0_field_t DMACA0_f;
  };
  union {
    __IO uint32_t DMACB0;
    stc_dmac_dmacb0_field_t DMACB0_f;
  };
  __IO uint32_t DMACSA0;
  __IO uint32_t DMACDA0;
  union {
    __IO uint32_t DMACA1;
    stc_dmac_dmaca1_field_t DMACA1_f;
  };
  union {
    __IO uint32_t DMACB1;
    stc_dmac_dmacb1_field_t DMACB1_f;
  };
  __IO uint32_t DMACSA1;
  __IO uint32_t DMACDA1;
  union {
    __IO uint32_t DMACA2;
    stc_dmac_dmaca2_field_t DMACA2_f;
  };
  union {
    __IO uint32_t DMACB2;
    stc_dmac_dmacb2_field_t DMACB2_f;
  };
  __IO uint32_t DMACSA2;
  __IO uint32_t DMACDA2;
  union {
    __IO uint32_t DMACA3;
    stc_dmac_dmaca3_field_t DMACA3_f;
  };
  union {
    __IO uint32_t DMACB3;
    stc_dmac_dmacb3_field_t DMACB3_f;
  };
  __IO uint32_t DMACSA3;
  __IO uint32_t DMACDA3;
  union {
    __IO uint32_t DMACA4;
    stc_dmac_dmaca4_field_t DMACA4_f;
  };
  union {
    __IO uint32_t DMACB4;
    stc_dmac_dmacb4_field_t DMACB4_f;
  };
  __IO uint32_t DMACSA4;
  __IO uint32_t DMACDA4;
  union {
    __IO uint32_t DMACA5;
    stc_dmac_dmaca5_field_t DMACA5_f;
  };
  union {
    __IO uint32_t DMACB5;
    stc_dmac_dmacb5_field_t DMACB5_f;
  };
  __IO uint32_t DMACSA5;
  __IO uint32_t DMACDA5;
  union {
    __IO uint32_t DMACA6;
    stc_dmac_dmaca6_field_t DMACA6_f;
  };
  union {
    __IO uint32_t DMACB6;
    stc_dmac_dmacb6_field_t DMACB6_f;
  };
  __IO uint32_t DMACSA6;
  __IO uint32_t DMACDA6;
  union {
    __IO uint32_t DMACA7;
    stc_dmac_dmaca7_field_t DMACA7_f;
  };
  union {
    __IO uint32_t DMACB7;
    stc_dmac_dmacb7_field_t DMACB7_f;
  };
  __IO uint32_t DMACSA7;
  __IO uint32_t DMACDA7;
}FM_DMAC_TypeDef;

/******************************************************************************
 * CAN_MODULE
 ******************************************************************************/
/* CAN channel 0 registers */
typedef struct
{
  union {
    __IO uint16_t CTRLR;
    stc_can_ctrlr_field_t CTRLR_f;
  };
  union {
    __IO uint16_t STATR;
    stc_can_statr_field_t STATR_f;
  };
  union {
    __IO uint16_t ERRCNT;
    stc_can_errcnt_field_t ERRCNT_f;
  };
  union {
    __IO uint16_t BTR;
    stc_can_btr_field_t BTR_f;
  };
  union {
    __IO uint16_t INTR;
    stc_can_intr_field_t INTR_f;
  };
  union {
    __IO uint16_t TESTR;
    stc_can_testr_field_t TESTR_f;
  };
  union {
    __IO uint16_t BRPER;
    stc_can_brper_field_t BRPER_f;
  };
        uint8_t RESERVED0[2];
  union {
    __IO uint16_t IF1CREQ;
    stc_can_if1creq_field_t IF1CREQ_f;
  };
  union {
    __IO uint16_t IF1CMSK;
    stc_can_if1cmsk_field_t IF1CMSK_f;
  };
  union {
    union {
      __IO uint32_t IF1MSK;
      stc_can_if1msk_field_t IF1MSK_f;
    };
    struct {
      __IO uint16_t IF1MSK1;
      union {
        __IO uint16_t IF1MSK2;
        stc_can_if1msk2_field_t IF1MSK2_f;
      };
    };
  };
  union {
    union {
      __IO uint32_t IF1ARB;
      stc_can_if1arb_field_t IF1ARB_f;
    };
    struct {
      __IO uint16_t IF1ARB1;
      union {
        __IO uint16_t IF1ARB2;
        stc_can_if1arb2_field_t IF1ARB2_f;
      };
    };
  };
  union {
    __IO uint16_t IF1MCTR;
    stc_can_if1mctr_field_t IF1MCTR_f;
  };
        uint8_t RESERVED1[2];
  union {
    __IO uint32_t IF1DTA_L;
    struct {
      __IO uint16_t IF1DTA1_L;
      __IO uint16_t IF1DTA2_L;
    };
  };
  union {
    __IO uint32_t IF1DTB_L;
    struct {
      __IO uint16_t IF1DTB1_L;
      __IO uint16_t IF1DTB2_L;
    };
  };
        uint8_t RESERVED2[8];
  union {
    __IO uint32_t IF1DTA_B;
    struct {
      __IO uint16_t IF1DTA2_B;
      __IO uint16_t IF1DTA1_B;
    };
  };
  union {
    __IO uint32_t IF1DTB_B;
    struct {
      __IO uint16_t IF1DTB2_B;
      __IO uint16_t IF1DTB1_B;
    };
  };
        uint8_t RESERVED3[8];
  union {
    __IO uint16_t IF2CREQ;
    stc_can_if2creq_field_t IF2CREQ_f;
  };
  union {
    __IO uint16_t IF2CMSK;
    stc_can_if2cmsk_field_t IF2CMSK_f;
  };
  union {
    union {
      __IO uint32_t IF2MSK;
      stc_can_if2msk_field_t IF2MSK_f;
    };
    struct {
      __IO uint16_t IF2MSK1;
      union {
        __IO uint16_t IF2MSK2;
        stc_can_if2msk2_field_t IF2MSK2_f;
      };
    };
  };
  union {
    __IO uint32_t IF2ARB;
    struct {
      __IO uint16_t IF2ARB1;
      union {
        __IO uint16_t IF2ARB2;
        stc_can_if2arb2_field_t IF2ARB2_f;
      };
    };
  };
  union {
    __IO uint16_t IF2MCTR;
    stc_can_if2mctr_field_t IF2MCTR_f;
  };
        uint8_t RESERVED4[2];
  union {
    __IO uint32_t IF2DTA_L;
    struct {
      __IO uint16_t IF2DTA1_L;
      __IO uint16_t IF2DTA2_L;
    };
  };
  union {
    __IO uint32_t IF2DTB_L;
    struct {
      __IO uint16_t IF2DTB1_L;
      __IO uint16_t IF2DTB2_L;
    };
  };
        uint8_t RESERVED5[8];
  union {
    __IO uint32_t IF2DTA_B;
    struct {
      __IO uint16_t IF2DTA2_B;
      __IO uint16_t IF2DTA1_B;
    };
  };
  union {
    __IO uint32_t IF2DTB_B;
    struct {
      __IO uint16_t IF2DTB2_B;
      __IO uint16_t IF2DTB1_B;
    };
  };
        uint8_t RESERVED6[24];
  union {
    union {
      __IO uint32_t TREQR;
      stc_can_treqr_field_t TREQR_f;
    };
    struct {
      union {
        __IO uint16_t TREQR1;
        stc_can_treqr1_field_t TREQR1_f;
      };
      union {
        __IO uint16_t TREQR2;
        stc_can_treqr2_field_t TREQR2_f;
      };
    };
  };
        uint8_t RESERVED7[12];
  union {
    union {
      __IO uint32_t NEWDT;
      stc_can_newdt_field_t NEWDT_f;
    };
    struct {
      union {
        __IO uint16_t NEWDT1;
        stc_can_newdt1_field_t NEWDT1_f;
      };
      __IO uint16_t NEWDT2;
    };
  };
        uint8_t RESERVED8[12];
  union {
    union {
      __IO uint32_t INTPND;
      stc_can_intpnd_field_t INTPND_f;
    };
    struct {
      union {
        __IO uint16_t INTPND1;
        stc_can_intpnd1_field_t INTPND1_f;
      };
      union {
        __IO uint16_t INTPND2;
        stc_can_intpnd2_field_t INTPND2_f;
      };
    };
  };
        uint8_t RESERVED9[12];
  union {
    union {
      __IO uint32_t MSGVAL;
      stc_can_msgval_field_t MSGVAL_f;
    };
    struct {
      union {
        __IO uint16_t MSGVAL1;
        stc_can_msgval1_field_t MSGVAL1_f;
      };
      union {
        __IO uint16_t MSGVAL2;
        stc_can_msgval2_field_t MSGVAL2_f;
      };
    };
  };
}FM_CAN_TypeDef;

/******************************************************************************
 * ETHERNET_MAC_MODULE
 ******************************************************************************/
/* ETHERNET_MAC registers */
typedef struct
{
  union {
    __IO uint32_t MCR;
    stc_ethernet_mac_mcr_field_t MCR_f;
  };
  union {
    __IO uint32_t MFFR;
    stc_ethernet_mac_mffr_field_t MFFR_f;
  };
  union {
    __IO uint32_t MHTRH;
    stc_ethernet_mac_mhtrh_field_t MHTRH_f;
  };
  union {
    __IO uint32_t MHTRL;
    stc_ethernet_mac_mhtrl_field_t MHTRL_f;
  };
  union {
    __IO uint32_t GAR;
    stc_ethernet_mac_gar_field_t GAR_f;
  };
  union {
    __IO uint32_t GDR;
    stc_ethernet_mac_gdr_field_t GDR_f;
  };
  union {
    __IO uint32_t FCR;
    stc_ethernet_mac_fcr_field_t FCR_f;
  };
  union {
    __IO uint32_t VTR;
    stc_ethernet_mac_vtr_field_t VTR_f;
  };
        uint8_t RESERVED1[8];
  union {
    __IO uint32_t RWFFR;
    stc_ethernet_mac_rwffr_field_t RWFFR_f;
  };
  union {
    __IO uint32_t PMTR;
    stc_ethernet_mac_pmtr_field_t PMTR_f;
  };
  union {
    __IO uint32_t LPICSR;
    stc_ethernet_mac_lpicsr_field_t LPICSR_f;
  };
  union {
    __IO uint32_t LPITCR;
    stc_ethernet_mac_lpitcr_field_t LPITCR_f;
  };
  union {
    __IO uint32_t ISR;
    stc_ethernet_mac_isr_field_t ISR_f;
  };
  union {
    __IO uint32_t IMR;
    stc_ethernet_mac_imr_field_t IMR_f;
  };
  union {
    __IO uint32_t MAR0H;
    stc_ethernet_mac_mar0h_field_t MAR0H_f;
  };
  union {
    __IO uint32_t MAR0L;
    stc_ethernet_mac_mar0l_field_t MAR0L_f;
  };
  union {
    __IO uint32_t MAR1H;
    stc_ethernet_mac_marh_field_t MAR1H_f;
  };
  union {
    __IO uint32_t MAR1L;
    stc_ethernet_mac_marl_field_t MAR1L_f;
  };
  union {
    __IO uint32_t MAR2H;
    stc_ethernet_mac_marh_field_t MAR2H_f;
  };
  union {
    __IO uint32_t MAR2L;
    stc_ethernet_mac_marl_field_t MAR2L_f;
  };
  union {
    __IO uint32_t MAR3H;
    stc_ethernet_mac_marh_field_t MAR3H_f;
  };
  union {
    __IO uint32_t MAR3L;
    stc_ethernet_mac_marl_field_t MAR3L_f;
  };
  union {
    __IO uint32_t MAR4H;
    stc_ethernet_mac_marh_field_t MAR4H_f;
  };
  union {
    __IO uint32_t MAR4L;
    stc_ethernet_mac_marl_field_t MAR4L_f;
  };
  union {
    __IO uint32_t MAR5H;
    stc_ethernet_mac_marh_field_t MAR5H_f;
  };
  union {
    __IO uint32_t MAR5L;
    stc_ethernet_mac_marl_field_t MAR5L_f;
  };
  union {
    __IO uint32_t MAR6H;
    stc_ethernet_mac_marh_field_t MAR6H_f;
  };
  union {
    __IO uint32_t MAR6L;
    stc_ethernet_mac_marl_field_t MAR6L_f;
  };
  union {
    __IO uint32_t MAR7H;
    stc_ethernet_mac_marh_field_t MAR7H_f;
  };
  union {
    __IO uint32_t MAR7L;
    stc_ethernet_mac_marl_field_t MAR7L_f;
  };
  union {
    __IO uint32_t MAR8H;
    stc_ethernet_mac_marh_field_t MAR8H_f;
  };
  union {
    __IO uint32_t MAR8L;
    stc_ethernet_mac_marl_field_t MAR8L_f;
  };
  union {
    __IO uint32_t MAR9H;
    stc_ethernet_mac_marh_field_t MAR9H_f;
  };
  union {
    __IO uint32_t MAR9L;
    stc_ethernet_mac_marl_field_t MAR9L_f;
  };
  union {
    __IO uint32_t MAR10H;
    stc_ethernet_mac_marh_field_t MAR10H_f;
  };
  union {
    __IO uint32_t MAR10L;
    stc_ethernet_mac_marl_field_t MAR10L_f;
  };
  union {
    __IO uint32_t MAR11H;
    stc_ethernet_mac_marh_field_t MAR11H_f;
  };
  union {
    __IO uint32_t MAR11L;
    stc_ethernet_mac_marl_field_t MAR11L_f;
  };
  union {
    __IO uint32_t MAR12H;
    stc_ethernet_mac_marh_field_t MAR12H_f;
  };
  union {
    __IO uint32_t MAR12L;
    stc_ethernet_mac_marl_field_t MAR12L_f;
  };
  union {
    __IO uint32_t MAR13H;
    stc_ethernet_mac_marh_field_t MAR13H_f;
  };
  union {
    __IO uint32_t MAR13L;
    stc_ethernet_mac_marl_field_t MAR13L_f;
  };
  union {
    __IO uint32_t MAR14H;
    stc_ethernet_mac_marh_field_t MAR14H_f;
  };
  union {
    __IO uint32_t MAR14L;
    stc_ethernet_mac_marl_field_t MAR14L_f;
  };
  union {
    __IO uint32_t MAR15H;
    stc_ethernet_mac_marh_field_t MAR15H_f;
  };
  union {
    __IO uint32_t MAR15L;
    stc_ethernet_mac_marl_field_t MAR15L_f;
  };
        uint8_t RESERVED2[24];
  union {
    __IO uint32_t RGSR;
    stc_ethernet_mac_rgsr_field_t RGSR_f;
  };
        uint8_t RESERVED3[36];
  __IO uint32_t mmc_cntl;
  __IO uint32_t mmc_intr_rx;
  __IO uint32_t mmc_intr_tx;
  __IO uint32_t mmc_intr_mask_rx;
  __IO uint32_t mmc_intr_mask_tx;
  __IO uint32_t txoctetcount_gb;
  __IO uint32_t txframecount_gb;
  __IO uint32_t txbroadcastframes_g;
  __IO uint32_t txmulticastframes_g;
  __IO uint32_t tx64octets_gb;
  __IO uint32_t tx65to127octets_gb;
  __IO uint32_t tx128to255octets_gb;
  __IO uint32_t tx256to511octets_gb;
  __IO uint32_t tx512to1023octets_gb;
  __IO uint32_t tx1024tomaxoctets_gb;
  __IO uint32_t txunicastframes_gb;
  __IO uint32_t txmulticastframes_gb;
  __IO uint32_t txbroadcastframes_gb;
  __IO uint32_t txunderflowerror;
  __IO uint32_t txsinglecol_g;
  __IO uint32_t txmulticol_g;
  __IO uint32_t txdeferred;
  __IO uint32_t txlatecol;
  __IO uint32_t txexesscol;
  __IO uint32_t txcarriererror;
  __IO uint32_t txoctetcount_g;
  __IO uint32_t txframecount_g;
  __IO uint32_t txexecessdef_g;
  __IO uint32_t txpauseframes;
  __IO uint32_t txvlanframes_g;
        uint8_t RESERVED4[8];
  __IO uint32_t rxframecount_gb;
  __IO uint32_t rxoctetcount_gb;
  __IO uint32_t rxoctetcount_g;
  __IO uint32_t rxbroadcastframes_g;
  __IO uint32_t rxmulticastframes_g;
  __IO uint32_t rxcrcerror;
  __IO uint32_t rxallignmenterror;
  __IO uint32_t rxrunterror;
  __IO uint32_t rxjabbererror;
  __IO uint32_t rxundersize_g;
  __IO uint32_t rxoversize_g;
  __IO uint32_t rx64octets_gb;
  __IO uint32_t rx65to127octets_gb;
  __IO uint32_t rx128to255octets_gb;
  __IO uint32_t rx256to511octets_gb;
  __IO uint32_t rx512to1023octets_gb;
  __IO uint32_t rx1024tomaxoctets_gb;
  __IO uint32_t rxunicastframes_g;
  __IO uint32_t rxlengtherror;
  __IO uint32_t rxoutofrangetype;
  __IO uint32_t rxpauseframes;
  __IO uint32_t rxfifooverflow;
  __IO uint32_t rxvlanframes_gb;
  __IO uint32_t rxwatchdogerror;
        uint8_t RESERVED5[32];
  __IO uint32_t mmc_ipc_intr_mask_rx;
        uint8_t RESERVED6[4];
  __IO uint32_t mmc_ipc_intr_rx;
        uint8_t RESERVED7[4];
  __IO uint32_t rxipv4_gd_frms;
  __IO uint32_t rxipv4_hdrerr_frms;
  __IO uint32_t rxipv4_nopay_frms;
  __IO uint32_t rxipv4_frag_frms;
  __IO uint32_t rxipv4_udsbl_frms;
  __IO uint32_t rxipv6_gd_frms;
  __IO uint32_t rxipv6_hdrerr_frms;
  __IO uint32_t rxipv6_nopay_frms;
  __IO uint32_t rxudp_gd_frms;
  __IO uint32_t rxudp_err_frms;
  __IO uint32_t rxtcp_gd_frms;
  __IO uint32_t rxtcp_err_frms;
  __IO uint32_t rxicmp_gd_frms;
  __IO uint32_t rxicmp_err_frms;
        uint8_t RESERVED8[8];
  __IO uint32_t rxipv4_gd_octets;
  __IO uint32_t rxipv4_hdrerr_octets;
  __IO uint32_t rxipv4_nopay_octets;
  __IO uint32_t rxipv4_frag_octets;
  __IO uint32_t rxipv4_udsbl_octets;
  __IO uint32_t rxipv6_gd_octets;
  __IO uint32_t rxipv6_hdrerr_octets;
  __IO uint32_t rxipv6_nopay_octets;
  __IO uint32_t rxudp_gd_octets;
  __IO uint32_t rxudp_err_octets;
  __IO uint32_t rxtcp_gd_octets;
  __IO uint32_t rxtcp_err_octets;
  __IO uint32_t rxicmp_gd_octets;
  __IO uint32_t rxicmp_err_octets;
        uint8_t RESERVED9[1144];
  union {
    __IO uint32_t TSCR;
    stc_ethernet_mac_tscr_field_t TSCR_f;
  };
  union {
    __IO uint32_t SSIR;
    stc_ethernet_mac_ssir_field_t SSIR_f;
  };
  union {
    __IO uint32_t STSR;
    stc_ethernet_mac_stsr_field_t STSR_f;
  };
  union {
    __IO uint32_t STNR;
    stc_ethernet_mac_stnr_field_t STNR_f;
  };
  union {
    __IO uint32_t STSUR;
    stc_ethernet_mac_stsur_field_t STSUR_f;
  };
  union {
    __IO uint32_t STNUR;
    stc_ethernet_mac_stnur_field_t STNUR_f;
  };
  union {
    __IO uint32_t TSAR;
    stc_ethernet_mac_tsar_field_t TSAR_f;
  };
  union {
    __IO uint32_t TTSR;
    stc_ethernet_mac_ttsr_field_t TTSR_f;
  };
  union {
    __IO uint32_t TTNR;
    stc_ethernet_mac_ttnr_field_t TTNR_f;
  };
  union {
    __IO uint32_t STHWSR;
    stc_ethernet_mac_sthwsr_field_t STHWSR_f;
  };
  union {
    __IO uint32_t TSR;
    stc_ethernet_mac_tsr_field_t TSR_f;
  };
  union {
    __IO uint32_t PPSCR;
    stc_ethernet_mac_ppscr_field_t PPSCR_f;
  };
  union {
    __IO uint32_t ATNR;
    stc_ethernet_mac_atnr_field_t ATNR_f;
  };
  union {
    __IO uint32_t ATSR;
    stc_ethernet_mac_atsr_field_t ATSR_f;
  };
        uint8_t RESERVED10[200];
  union {
    __IO uint32_t MAR16H;
    stc_ethernet_mac_marh_field_t MAR16H_f;
  };
  union {
    __IO uint32_t MAR16L;
    stc_ethernet_mac_marl_field_t MAR16L_f;
  };
  union {
    __IO uint32_t MAR17H;
    stc_ethernet_mac_marh_field_t MAR17H_f;
  };
  union {
    __IO uint32_t MAR17L;
    stc_ethernet_mac_marl_field_t MAR17L_f;
  };
  union {
    __IO uint32_t MAR18H;
    stc_ethernet_mac_marh_field_t MAR18H_f;
  };
  union {
    __IO uint32_t MAR18L;
    stc_ethernet_mac_marl_field_t MAR18L_f;
  };
  union {
    __IO uint32_t MAR19H;
    stc_ethernet_mac_marh_field_t MAR19H_f;
  };
  union {
    __IO uint32_t MAR19L;
    stc_ethernet_mac_marl_field_t MAR19L_f;
  };
  union {
    __IO uint32_t MAR20H;
    stc_ethernet_mac_marh_field_t MAR20H_f;
  };
  union {
    __IO uint32_t MAR20L;
    stc_ethernet_mac_marl_field_t MAR20L_f;
  };
  union {
    __IO uint32_t MAR21H;
    stc_ethernet_mac_marh_field_t MAR21H_f;
  };
  union {
    __IO uint32_t MAR21L;
    stc_ethernet_mac_marl_field_t MAR21L_f;
  };
  union {
    __IO uint32_t MAR22H;
    stc_ethernet_mac_marh_field_t MAR22H_f;
  };
  union {
    __IO uint32_t MAR22L;
    stc_ethernet_mac_marl_field_t MAR22L_f;
  };
  union {
    __IO uint32_t MAR23H;
    stc_ethernet_mac_marh_field_t MAR23H_f;
  };
  union {
    __IO uint32_t MAR23L;
    stc_ethernet_mac_marl_field_t MAR23L_f;
  };
  union {
    __IO uint32_t MAR24H;
    stc_ethernet_mac_marh_field_t MAR24H_f;
  };
  union {
    __IO uint32_t MAR24L;
    stc_ethernet_mac_marl_field_t MAR24L_f;
  };
  union {
    __IO uint32_t MAR25H;
    stc_ethernet_mac_marh_field_t MAR25H_f;
  };
  union {
    __IO uint32_t MAR25L;
    stc_ethernet_mac_marl_field_t MAR25L_f;
  };
  union {
    __IO uint32_t MAR26H;
    stc_ethernet_mac_marh_field_t MAR26H_f;
  };
  union {
    __IO uint32_t MAR26L;
    stc_ethernet_mac_marl_field_t MAR26L_f;
  };
  union {
    __IO uint32_t MAR27H;
    stc_ethernet_mac_marh_field_t MAR27H_f;
  };
  union {
    __IO uint32_t MAR27L;
    stc_ethernet_mac_marl_field_t MAR27L_f;
  };
  union {
    __IO uint32_t MAR28H;
    stc_ethernet_mac_marh_field_t MAR28H_f;
  };
  union {
    __IO uint32_t MAR28L;
    stc_ethernet_mac_marl_field_t MAR28L_f;
  };
  union {
    __IO uint32_t MAR29H;
    stc_ethernet_mac_marh_field_t MAR29H_f;
  };
  union {
    __IO uint32_t MAR29L;
    stc_ethernet_mac_marl_field_t MAR29L_f;
  };
  union {
    __IO uint32_t MAR30H;
    stc_ethernet_mac_marh_field_t MAR30H_f;
  };
  union {
    __IO uint32_t MAR30L;
    stc_ethernet_mac_marl_field_t MAR30L_f;
  };
  union {
    __IO uint32_t MAR31H;
    stc_ethernet_mac_marh_field_t MAR31H_f;
  };
  union {
    __IO uint32_t MAR31L;
    stc_ethernet_mac_marl_field_t MAR31L_f;
  };
        uint8_t RESERVED11[1920];
  union {
    __IO uint32_t BMR;
    stc_ethernet_mac_bmr_field_t BMR_f;
  };
  union {
    __IO uint32_t TPDR;
    stc_ethernet_mac_tpdr_field_t TPDR_f;
  };
  union {
    __IO uint32_t RPDR;
    stc_ethernet_mac_rpdr_field_t RPDR_f;
  };
  union {
    __IO uint32_t RDLAR;
    stc_ethernet_mac_rdlar_field_t RDLAR_f;
  };
  union {
    __IO uint32_t TDLAR;
    stc_ethernet_mac_tdlar_field_t TDLAR_f;
  };
  union {
    __IO uint32_t SR;
    stc_ethernet_mac_sr_field_t SR_f;
  };
  union {
    __IO uint32_t OMR;
    stc_ethernet_mac_omr_field_t OMR_f;
  };
  union {
    __IO uint32_t IER;
    stc_ethernet_mac_ier_field_t IER_f;
  };
  union {
    __IO uint32_t MFBOCR;
    stc_ethernet_mac_mfbocr_field_t MFBOCR_f;
  };
  union {
    __IO uint32_t RIWTR;
    stc_ethernet_mac_riwtr_field_t RIWTR_f;
  };
        uint8_t RESERVED12[4];
  union {
    __IO uint32_t AHBSR;
    stc_ethernet_mac_ahbsr_field_t AHBSR_f;
  };
        uint8_t RESERVED13[24];
  union {
    __IO uint32_t CHTDR;
    stc_ethernet_mac_chtdr_field_t CHTDR_f;
  };
  union {
    __IO uint32_t CHRDR;
    stc_ethernet_mac_chrdr_field_t CHRDR_f;
  };
  union {
    __IO uint32_t CHTBAR;
    stc_ethernet_mac_chtbar_field_t CHTBAR_f;
  };
  union {
    __IO uint32_t CHRBAR;
    stc_ethernet_mac_chrbar_field_t CHRBAR_f;
  };
}FM_ETHERNET_MAC_TypeDef;

/******************************************************************************
 * ETHERNET_CONTROL_MODULE
 ******************************************************************************/
/* ETHERNET_CONTROL registers */
typedef struct
{
  union {
    __IO uint32_t ETH_MODE;
    stc_ethernet_control_eth_mode_field_t ETH_MODE_f;
  };
        uint8_t RESERVED1[4];
  union {
    __IO uint32_t ETH_CLKG;
    stc_ethernet_control_eth_clkg_field_t ETH_CLKG_f;
  };
}FM_ETHERNET_CONTROL_TypeDef;

/******************************************************************************
 * I2S_MODULE
 ******************************************************************************/
/* I2S registers */
typedef struct
{
  union {
    __IO uint32_t RXFDAT;
    stc_i2s_rxfdat_field_t RXFDAT_f;
  };
  union {
    __IO uint32_t TXFDAT;
    stc_i2s_txfdat_field_t TXFDAT_f;
  };
  union {
    __IO uint32_t CNTREG;
    stc_i2s_cntreg_field_t CNTREG_f;
  };
  union {
    __IO uint32_t MCR0REG;
    stc_i2s_mcr0reg_field_t MCR0REG_f;
  };
  union {
    __IO uint32_t MCR1REG;
    stc_i2s_mcr1reg_field_t MCR1REG_f;
  };
  union {
    __IO uint32_t MCR2REG;
    stc_i2s_mcr2reg_field_t MCR2REG_f;
  };
  union {
    __IO uint32_t OPRREG;
    stc_i2s_oprreg_field_t OPRREG_f;
  };
  union {
    __IO uint32_t SRST;
    stc_i2s_srst_field_t SRST_f;
  };
  union {
    __IO uint32_t INTCNT;
    stc_i2s_intcnt_field_t INTCNT_f;
  };
  union {
    __IO uint32_t STATUS;
    stc_i2s_status_field_t STATUS_f;
  };
  union {
    __IO uint32_t DMAACT;
    stc_i2s_dmaact_field_t DMAACT_f;
  };
  union {
    __IO uint32_t TSTREG;
    stc_i2s_tstreg_field_t TSTREG_f;
  };
}FM_I2S_TypeDef;

/******************************************************************************
 * SDIF_MODULE
 ******************************************************************************/
/* SD interface registers */
typedef struct
{
  union {
    __IO uint32_t SSA2;
    struct {
      __IO  uint16_t SSALA2;
      __IO  uint16_t SSAHA2;
    };
  };
  union {
    __IO  uint16_t SBSIZE;
    stc_sdif_sbsize_field_t SBSIZE_f;
  };
    __IO  uint16_t SBLCNT;
  union {
    __IO uint32_t SSA1;
    struct {
      __IO  uint16_t SSALA1;
      __IO  uint16_t SSAHA1;
    };
  };
  union {
    __IO  uint16_t STRSFMD;
    stc_sdif_strsfmd_field_t STRSFMD_f;
  };
  union {
    __IO  uint16_t SCMMD;
    stc_sdif_scmmd_field_t SCMMD_f;
  };
    __IO  uint16_t SRESP0;
    __IO  uint16_t SRESP1;
    __IO  uint16_t SRESP2;
    __IO  uint16_t SRESP3;
    __IO  uint16_t SRESP4;
    __IO  uint16_t SRESP5;
    __IO  uint16_t SRESP6;
    __IO  uint16_t SRESP7;
  union {
    __IO uint32_t SBUFDP;
    struct {
      __IO  uint16_t SBUFDP0;
      __IO  uint16_t SBUFDP1;
    };
  };
  union {
    __IO  uint32_t SPRSTAT;
    stc_sdif_sprstat_field_t SPRSTAT_f;
  };
  union {
    __IO  uint8_t SHCTL1;
    stc_sdif_shctl1_field_t SHCTL1_f;
  };
  union {
    __IO  uint8_t SPWRCTL;
    stc_sdif_spwrctl_field_t SPWRCTL_f;
  };
  union {
    __IO  uint8_t SBLKGPCTL;
    stc_sdif_sblkgpctl_field_t SBLKGPCTL_f;
  };
  union {
    __IO  uint8_t SWKUPCTL;
    stc_sdif_swkupctl_field_t SWKUPCTL_f;
  };
  union {
    __IO  uint16_t SCLKCTL;
    stc_sdif_sclkctl_field_t SCLKCTL_f;
  };
  union {
    __IO  uint8_t STOCTL;
    stc_sdif_stoctl_field_t STOCTL_f;
  };
  union {
    __IO  uint8_t SSRST;
    stc_sdif_ssrst_field_t SSRST_f;
  };
  union {
    __IO  uint16_t SNINTST;
    stc_sdif_snintst_field_t SNINTST_f;
  };
  union {
    __IO  uint16_t SEINTST;
    stc_sdif_seintst_field_t SEINTST_f;
  };
  union {
    __IO  uint16_t SNINTSTE;
    stc_sdif_snintste_field_t SNINTSTE_f;
  };
  union {
    __IO  uint16_t SEINTSTE;
    stc_sdif_seintste_field_t SEINTSTE_f;
  };
  union {
    __IO  uint16_t SNINTSGE;
    stc_sdif_snintsge_field_t SNINTSGE_f;
  };
  union {
    __IO  uint16_t SEINTSGE;
    stc_sdif_seintsge_field_t SEINTSGE_f;
  };
  union {
    __IO  uint16_t SACMDEST;
    stc_sdif_sacmdest_field_t SACMDEST_f;
  };
  union {
    __IO  uint16_t SHCTL2;
    stc_sdif_shctl2_field_t SHCTL2_f;
  };
  union {
    __IO  uint16_t CAPBLTY0;
    stc_sdif_capblty0_field_t CAPBLTY0_f;
  };
  union {
    __IO  uint16_t CAPBLTY1;
    stc_sdif_capblty1_field_t CAPBLTY1_f;
  };
  union {
    __IO  uint16_t CAPBLTY2;
    stc_sdif_capblty2_field_t CAPBLTY2_f;
  };
  union {
    __IO  uint16_t CAPBLTY3;
    stc_sdif_capblty3_field_t CAPBLTY3_f;
  };
  union {
    __IO  uint16_t MXCCAPY0;
    stc_sdif_mxccapy0_field_t MXCCAPY0_f;
  };
  union {
    __IO  uint16_t MXCCAPY1;
    stc_sdif_mxccapy1_field_t MXCCAPY1_f;
  };
  union {
    __IO  uint16_t MXCCAPY2;
    stc_sdif_mxccapy2_field_t MXCCAPY2_f;
  };
  union {
    __IO  uint16_t MXCCAPY3;
    stc_sdif_mxccapy3_field_t MXCCAPY3_f;
  };
  union {
    __IO  uint16_t FEACEST;
    stc_sdif_feacest_field_t FEACEST_f;
  };
  union {
    __IO  uint16_t SFEEIST;
    stc_sdif_sfeeist_field_t SFEEIST_f;
  };
  union {
    __IO  uint8_t ADMAEST;
    stc_sdif_admaest_field_t ADMAEST_f;
  };
        uint8_t RESERVED0[3];
  union {
    __IO  uint16_t SADSA0;
    stc_sdif_sadsa0_field_t SADSA0_f;
  };
  union {
    __IO  uint16_t SADSA1;
    stc_sdif_sadsa1_field_t SADSA1_f;
  };
  union {
    __IO  uint16_t SADSA2;
    stc_sdif_sadsa2_field_t SADSA2_f;
  };
  union {
    __IO  uint16_t SADSA3;
    stc_sdif_sadsa3_field_t SADSA3_f;
  };
  union {
    __IO  uint16_t SPRVAL0;
    stc_sdif_sprval0_field_t SPRVAL0_f;
  };
  union {
    __IO  uint16_t SPRVAL1;
    stc_sdif_sprval1_field_t SPRVAL1_f;
  };
  union {
    __IO  uint16_t SPRVAL2;
    stc_sdif_sprval2_field_t SPRVAL2_f;
  };
  union {
    __IO  uint16_t SPRVAL3;
    stc_sdif_sprval3_field_t SPRVAL3_f;
  };
  union {
    __IO  uint16_t SPRVAL4;
    stc_sdif_sprval4_field_t SPRVAL4_f;
  };
  union {
    __IO  uint16_t SPRVAL5;
    stc_sdif_sprval5_field_t SPRVAL5_f;
  };
  union {
    __IO  uint16_t SPRVAL6;
    stc_sdif_sprval6_field_t SPRVAL6_f;
  };
  union {
    __IO  uint16_t SPRVAL7;
    stc_sdif_sprval7_field_t SPRVAL7_f;
  };
        uint8_t RESERVED1[112];
  union {
    __IO  uint16_t SSHBCTLL;
    stc_sdif_sshbctll_field_t SSHBCTLL_f;
  };
  union {
    __IO  uint16_t SSHBCTLH;
    stc_sdif_sshbctlh_field_t SSHBCTLH_f;
  };
        uint8_t RESERVED2[24];
  union {
    __IO  uint16_t SSLIST;
    stc_sdif_sslist_field_t SSLIST_f;
  };
  union {
    __IO  uint16_t SHCTLV;
    stc_sdif_shctlv_field_t SHCTLV_f;
  };
  union {
    __IO  uint16_t AHBCFGL;
    stc_sdif_ahbcfgl_field_t AHBCFGL_f;
  };
  union {
    __IO  uint16_t AHBCFGH;
    stc_sdif_ahbcfgh_field_t AHBCFGH_f;
  };
  union {
    __IO  uint16_t SPWSWCL;
    stc_sdif_spwswcl_field_t SPWSWCL_f;
  };
  union {
    __IO  uint16_t SPWSWCH;
    stc_sdif_spwswch_field_t SPWSWCH_f;
  };
  union {
    __IO  uint16_t STUNSETL;
    stc_sdif_stunsetl_field_t STUNSETL_f;
  };
  union {
    __IO  uint16_t STUNSETH;
    stc_sdif_stunseth_field_t STUNSETH_f;
  };
  union {
    __IO  uint16_t STUNSTL;
    stc_sdif_stunstl_field_t STUNSTL_f;
  };
  union {
    __IO  uint16_t STUNSTH;
    stc_sdif_stunsth_field_t STUNSTH_f;
  };
        uint8_t RESERVED3[4];
  __IO  uint16_t SIOCTL2L;
  __IO  uint16_t SIOCTL2H;
  union {
    __IO  uint16_t PSWISTL;
    stc_sdif_pswistl_field_t PSWISTL_f;
  };
  union {
    __IO  uint16_t PSWISTH;
    stc_sdif_pswisth_field_t PSWISTH_f;
  };
  union {
    __IO  uint16_t PSWISTEL;
    stc_sdif_pswistel_field_t PSWISTEL_f;
  };
  union {
    __IO  uint16_t PSWISTEH;
    stc_sdif_pswisteh_field_t PSWISTEH_f;
  };
  union {
    __IO  uint16_t PSWISGEL;
    stc_sdif_pswisgel_field_t PSWISGEL_f;
  };
  union {
    __IO  uint16_t PSWISGEH;
    stc_sdif_pswisgeh_field_t PSWISGEH_f;
  };
  union {
    __IO  uint16_t MMCSDCL;
    stc_sdif_mmcsdcl_field_t MMCSDCL_f;
  };
  union {
    __IO  uint16_t MMCSDCH;
    stc_sdif_mmcsdch_field_t MMCSDCH_f;
  };
  union {
    __IO  uint16_t MCWIRQC0;
    stc_sdif_mcwirqc0_field_t MCWIRQC0_f;
  };
  union {
    __IO  uint16_t MCWIRQC1;
    stc_sdif_mcwirqc1_field_t MCWIRQC1_f;
  };
  union {
    __IO  uint16_t MCWIRQC2;
    stc_sdif_mcwirqc2_field_t MCWIRQC2_f;
  };
  union {
    __IO  uint16_t MCWIRQC3;
    stc_sdif_mcwirqc3_field_t MCWIRQC3_f;
  };
  union {
    __IO  uint16_t MCRPCKBL;
    stc_sdif_mcrpckbl_field_t MCRPCKBL_f;
  };
  union {
    __IO  uint16_t MCRPCKBH;
    stc_sdif_mcrpckbh_field_t MCRPCKBH_f;
  };
        uint8_t RESERVED4[32];
  union {
    __IO  uint16_t SCDETECS;
    stc_sdif_scdetecs_field_t SCDETECS_f;
  };
        uint8_t RESERVED5[2];
}FM_SDIF_TypeDef;

/******************************************************************************
 * CANFD_MODULE
 ******************************************************************************/
/* CANFD registers */
typedef struct
{
  union {
    __IO uint32_t CREL;
    stc_canfd_crel_field_t CREL_f;
  };
  union {
    __IO uint32_t ENDN;
    stc_canfd_endn_field_t ENDN_f;
  };
        uint8_t RESERVED1[4];
  union {
    __IO uint32_t FBTP;
    stc_canfd_fbtp_field_t FBTP_f;
  };
  union {
    __IO uint32_t TEST;
    stc_canfd_test_field_t TEST_f;
  };
  union {
    __IO uint32_t RWD;
    stc_canfd_rwd_field_t RWD_f;
  };
  union {
    __IO uint32_t CCCR;
    stc_canfd_cccr_field_t CCCR_f;
  };
  union {
    __IO uint32_t BTP;
    stc_canfd_btp_field_t BTP_f;
  };
  union {
    __IO uint32_t TSCC;
    stc_canfd_tscc_field_t TSCC_f;
  };
  union {
    __IO uint32_t TSCV;
    stc_canfd_tscv_field_t TSCV_f;
  };
  union {
    __IO uint32_t TOCC;
    stc_canfd_tocc_field_t TOCC_f;
  };
  union {
    __IO uint32_t TOCV;
    stc_canfd_tocv_field_t TOCV_f;
  };
        uint8_t RESERVED2[16];
  union {
    __IO uint32_t ECR;
    stc_canfd_ecr_field_t ECR_f;
  };
  union {
    __IO uint32_t PSR;
    stc_canfd_psr_field_t PSR_f;
  };
        uint8_t RESERVED3[8];
  union {
    __IO uint32_t IR;
    stc_canfd_ir_field_t IR_f;
  };
  union {
    __IO uint32_t IE;
    stc_canfd_ie_field_t IE_f;
  };
  union {
    __IO uint32_t ILS;
    stc_canfd_ils_field_t ILS_f;
  };
  union {
    __IO uint32_t ILE;
    stc_canfd_ile_field_t ILE_f;
  };
        uint8_t RESERVED4[32];
  union {
    __IO uint32_t GFC;
    stc_canfd_gfc_field_t GFC_f;
  };
  union {
    __IO uint32_t SIDFC;
    stc_canfd_sidfc_field_t SIDFC_f;
  };
  union {
    __IO uint32_t XIDFC;
    stc_canfd_xidfc_field_t XIDFC_f;
  };
        uint8_t RESERVED5[4];
  union {
    __IO uint32_t XIDAM;
    stc_canfd_xidam_field_t XIDAM_f;
  };
  union {
    __IO uint32_t HPMS;
    stc_canfd_hpms_field_t HPMS_f;
  };
  union {
    __IO uint32_t NDAT1;
    stc_canfd_ndat1_field_t NDAT1_f;
  };
  union {
    __IO uint32_t NDAT2;
    stc_canfd_ndat2_field_t NDAT2_f;
  };
  union {
    __IO uint32_t RXF0C;
    stc_canfd_rxf0c_field_t RXF0C_f;
  };
  union {
    __IO uint32_t RXF0S;
    stc_canfd_rxf0s_field_t RXF0S_f;
  };
  union {
    __IO uint32_t RXF0A;
    stc_canfd_rxf0a_field_t RXF0A_f;
  };
  union {
    __IO uint32_t RXBC;
    stc_canfd_rxbc_field_t RXBC_f;
  };
  union {
    __IO uint32_t RXF1C;
    stc_canfd_rxf1c_field_t RXF1C_f;
  };
  union {
    __IO uint32_t RXF1S;
    stc_canfd_rxf1s_field_t RXF1S_f;
  };
  union {
    __IO uint32_t RXF1A;
    stc_canfd_rxf1a_field_t RXF1A_f;
  };
  union {
    __IO uint32_t RXESC;
    stc_canfd_rxesc_field_t RXESC_f;
  };
  union {
    __IO uint32_t TXBC;
    stc_canfd_txbc_field_t TXBC_f;
  };
  union {
    __IO uint32_t TXFQS;
    stc_canfd_txfqs_field_t TXFQS_f;
  };
  union {
    __IO uint32_t TXESC;
    stc_canfd_txesc_field_t TXESC_f;
  };
  union {
    __IO uint32_t TXBRP;
    stc_canfd_txbrp_field_t TXBRP_f;
  };
  union {
    __IO uint32_t TXBAR;
    stc_canfd_txbar_field_t TXBAR_f;
  };
  union {
    __IO uint32_t TXBCR;
    stc_canfd_txbcr_field_t TXBCR_f;
  };
  union {
    __IO uint32_t TXBTO;
    stc_canfd_txbto_field_t TXBTO_f;
  };
  union {
    __IO uint32_t TXBCF;
    stc_canfd_txbcf_field_t TXBCF_f;
  };
  union {
    __IO uint32_t TXBTIE;
    stc_canfd_txbtie_field_t TXBTIE_f;
  };
  union {
    __IO uint32_t TXBCIE;
    stc_canfd_txbcie_field_t TXBCIE_f;
  };
        uint8_t RESERVED6[8];
  union {
    __IO uint32_t TXEFC;
    stc_canfd_txefc_field_t TXEFC_f;
  };
  union {
    __IO uint32_t TXFS;
    stc_canfd_txfs_field_t TXFS_f;
  };
  union {
    __IO uint32_t TXFA;
    stc_canfd_txfa_field_t TXFA_f;
  };
        uint8_t RESERVED7[260];
  union {
    __IO  uint8_t FDECR;
    stc_canfd_fdecr_field_t FDECR_f;
  };
  union {
    __IO  uint8_t FDESR;
    stc_canfd_fdesr_field_t FDESR_f;
  };
  union {
    __IO uint16_t FDSEAR;
    stc_canfd_fdsear_field_t FDSEAR_f;
  };
        uint8_t RESERVED8[1];
  union {
    __IO  uint8_t FDESCR;
    stc_canfd_fdescr_field_t FDESCR_f;
  };
  union {
    __IO uint16_t FDDEAR;
    stc_canfd_fddear_field_t FDDEAR_f;
  };
        uint8_t RESERVED9[8];
  union {
    __IO uint16_t TSCNTR;
    stc_canfd_tscntr_field_t TSCNTR_f;
  };
  union {
    __IO uint16_t TSMDR;
    stc_canfd_tsmdr_field_t TSMDR_f;
  };
  union {
    __IO uint32_t TSDIVR;
    stc_canfd_tsdivr_field_t TSDIVR_f;
  };
  union {
    __IO uint16_t TSCDTR;
    stc_canfd_tscdtr_field_t TSCDTR_f;
  };
  union {
    __IO uint16_t TSCPCLR;
    stc_canfd_tscpclr_field_t TSCPCLR_f;
  };
}FM_CANFD_TypeDef;

/******************************************************************************
 * PCRC_MODULE
 ******************************************************************************/
/* PCRC registers */
typedef struct
{
  __IO uint32_t PRGCRC_POLY;
  __IO uint32_t PRGCRC_SEED;
  __IO uint32_t PRGCRC_FXOR;
  union {
    __IO uint32_t PRGCRC_CFG;
    stc_pcrc_prgcrc_cfg_field_t PRGCRC_CFG_f;
  };
  __IO uint32_t PRGCRC_WR;
  __IO uint32_t PRGCRC_RD;
}FM_PCRC_TypeDef;

/******************************************************************************
 * HSSPI_MODULE
 ******************************************************************************/
/* HSSPI registers */
typedef struct
{
  union {
    __IO uint32_t MCTRL;
    stc_hsspi_mctrl_field_t MCTRL_f;
  };
  union {
    __IO uint32_t PCC0;
    stc_hsspi_pcc0_field_t PCC0_f;
  };
  union {
    __IO uint32_t PCC1;
    stc_hsspi_pcc1_field_t PCC1_f;
  };
  union {
    __IO uint32_t PCC2;
    stc_hsspi_pcc2_field_t PCC2_f;
  };
  union {
    __IO uint32_t PCC3;
    stc_hsspi_pcc3_field_t PCC3_f;
  };
  union {
    __IO uint32_t TXF;
    stc_hsspi_txf_field_t TXF_f;
  };
  union {
    __IO uint32_t TXE;
    stc_hsspi_txe_field_t TXE_f;
  };
  union {
    __IO uint32_t TXC;
    stc_hsspi_txc_field_t TXC_f;
  };
  union {
    __IO uint32_t RXF;
    stc_hsspi_rxf_field_t RXF_f;
  };
  union {
    __IO uint32_t RXE;
    stc_hsspi_rxe_field_t RXE_f;
  };
  union {
    __IO uint32_t RXC;
    stc_hsspi_rxc_field_t RXC_f;
  };
  union {
    __IO uint32_t FAULTF;
    stc_hsspi_faultf_field_t FAULTF_f;
  };
  union {
    __IO uint32_t FAULTC;
    stc_hsspi_faultc_field_t FAULTC_f;
  };
  union {
    __IO  uint8_t DMCFG;
    stc_hsspi_dmcfg_field_t DMCFG_f;
  };
  union {
    __IO  uint8_t DMDMAEN;
    stc_hsspi_dmdmaen_field_t DMDMAEN_f;
  };
        uint8_t RESERVED1[2];
  union {
    __IO  uint8_t DMSTART;
    stc_hsspi_dmstart_field_t DMSTART_f;
  };
  union {
    __IO  uint8_t DMSTOP;
    stc_hsspi_dmstop_field_t DMSTOP_f;
  };
  union {
    __IO  uint8_t DMPSEL;
    stc_hsspi_dmpsel_field_t DMPSEL_f;
  };
  union {
    __IO  uint8_t DMTRP;
    stc_hsspi_dmtrp_field_t DMTRP_f;
  };
  union {
    __IO uint16_t DMBCC;
    stc_hsspi_dmbcc_field_t DMBCC_f;
  };
  union {
    __IO uint16_t DMBCS;
    stc_hsspi_dmbcs_field_t DMBCS_f;
  };
  union {
    __IO uint32_t DMSTATUS;
    stc_hsspi_dmstatus_field_t DMSTATUS_f;
  };
        uint8_t RESERVED2[8];
  union {
    __IO uint32_t FIFOCFG;
    stc_hsspi_fifocfg_field_t FIFOCFG_f;
  };
  union {
    __IO uint32_t TXFIFO0;
    stc_hsspi_txfifo_field_t TXFIFO0_f;
  };
  union {
    __IO uint32_t TXFIFO1;
    stc_hsspi_txfifo_field_t TXFIFO1_f;
  };
  union {
    __IO uint32_t TXFIFO2;
    stc_hsspi_txfifo_field_t TXFIFO2_f;
  };
  union {
    __IO uint32_t TXFIFO3;
    stc_hsspi_txfifo_field_t TXFIFO3_f;
  };
  union {
    __IO uint32_t TXFIFO4;
    stc_hsspi_txfifo_field_t TXFIFO4_f;
  };
  union {
    __IO uint32_t TXFIFO5;
    stc_hsspi_txfifo_field_t TXFIFO5_f;
  };
  union {
    __IO uint32_t TXFIFO6;
    stc_hsspi_txfifo_field_t TXFIFO6_f;
  };
  union {
    __IO uint32_t TXFIFO7;
    stc_hsspi_txfifo_field_t TXFIFO7_f;
  };
  union {
    __IO uint32_t TXFIFO8;
    stc_hsspi_txfifo_field_t TXFIFO8_f;
  };
  union {
    __IO uint32_t TXFIFO9;
    stc_hsspi_txfifo_field_t TXFIFO9_f;
  };
  union {
    __IO uint32_t TXFIFO10;
    stc_hsspi_txfifo_field_t TXFIFO10_f;
  };
  union {
    __IO uint32_t TXFIFO11;
    stc_hsspi_txfifo_field_t TXFIFO11_f;
  };
  union {
    __IO uint32_t TXFIFO12;
    stc_hsspi_txfifo_field_t TXFIFO12_f;
  };
  union {
    __IO uint32_t TXFIFO13;
    stc_hsspi_txfifo_field_t TXFIFO13_f;
  };
  union {
    __IO uint32_t TXFIFO14;
    stc_hsspi_txfifo_field_t TXFIFO14_f;
  };
  union {
    __IO uint32_t TXFIFO15;
    stc_hsspi_txfifo_field_t TXFIFO15_f;
  };
  union {
    __IO uint32_t RXFIFO0;
    stc_hsspi_rxfifo_field_t RXFIFO0_f;
  };
  union {
    __IO uint32_t RXFIFO1;
    stc_hsspi_rxfifo_field_t RXFIFO1_f;
  };
  union {
    __IO uint32_t RXFIFO2;
    stc_hsspi_rxfifo_field_t RXFIFO2_f;
  };
  union {
    __IO uint32_t RXFIFO3;
    stc_hsspi_rxfifo_field_t RXFIFO3_f;
  };
  union {
    __IO uint32_t RXFIFO4;
    stc_hsspi_rxfifo_field_t RXFIFO4_f;
  };
  union {
    __IO uint32_t RXFIFO5;
    stc_hsspi_rxfifo_field_t RXFIFO5_f;
  };
  union {
    __IO uint32_t RXFIFO6;
    stc_hsspi_rxfifo_field_t RXFIFO6_f;
  };
  union {
    __IO uint32_t RXFIFO7;
    stc_hsspi_rxfifo_field_t RXFIFO7_f;
  };
  union {
    __IO uint32_t RXFIFO8;
    stc_hsspi_rxfifo_field_t RXFIFO8_f;
  };
  union {
    __IO uint32_t RXFIFO9;
    stc_hsspi_rxfifo_field_t RXFIFO9_f;
  };
  union {
    __IO uint32_t RXFIFO10;
    stc_hsspi_rxfifo_field_t RXFIFO10_f;
  };
  union {
    __IO uint32_t RXFIFO11;
    stc_hsspi_rxfifo_field_t RXFIFO11_f;
  };
  union {
    __IO uint32_t RXFIFO12;
    stc_hsspi_rxfifo_field_t RXFIFO12_f;
  };
  union {
    __IO uint32_t RXFIFO13;
    stc_hsspi_rxfifo_field_t RXFIFO13_f;
  };
  union {
    __IO uint32_t RXFIFO14;
    stc_hsspi_rxfifo_field_t RXFIFO14_f;
  };
  union {
    __IO uint32_t RXFIFO15;
    stc_hsspi_rxfifo_field_t RXFIFO15_f;
  };
  union {
    __IO uint32_t CSCFG;
    stc_hsspi_cscfg_field_t CSCFG_f;
  };
  union {
    __IO uint32_t CSITIME;
    stc_hsspi_csitime_field_t CSITIME_f;
  };
  union {
    __IO uint32_t CSAEXT;
    stc_hsspi_csaext_field_t CSAEXT_f;
  };
  union {
    __IO uint16_t RDCSDC0;
    stc_hsspi_rdcsdc_field_t RDCSDC0_f;
  };
  union {
    __IO uint16_t RDCSDC1;
    stc_hsspi_rdcsdc_field_t RDCSDC1_f;
  };
  union {
    __IO uint16_t RDCSDC2;
    stc_hsspi_rdcsdc_field_t RDCSDC2_f;
  };
  union {
    __IO uint16_t RDCSDC3;
    stc_hsspi_rdcsdc_field_t RDCSDC3_f;
  };
  union {
    __IO uint16_t RDCSDC4;
    stc_hsspi_rdcsdc_field_t RDCSDC4_f;
  };
  union {
    __IO uint16_t RDCSDC5;
    stc_hsspi_rdcsdc_field_t RDCSDC5_f;
  };
  union {
    __IO uint16_t RDCSDC6;
    stc_hsspi_rdcsdc_field_t RDCSDC6_f;
  };
  union {
    __IO uint16_t RDCSDC7;
    stc_hsspi_rdcsdc_field_t RDCSDC7_f;
  };
  union {
    __IO uint16_t WRCSDC0;
    stc_hsspi_wrcsdc_field_t WRCSDC0_f;
  };
  union {
    __IO uint16_t WRCSDC1;
    stc_hsspi_wrcsdc_field_t WRCSDC1_f;
  };
  union {
    __IO uint16_t WRCSDC2;
    stc_hsspi_wrcsdc_field_t WRCSDC2_f;
  };
  union {
    __IO uint16_t WRCSDC3;
    stc_hsspi_wrcsdc_field_t WRCSDC3_f;
  };
  union {
    __IO uint16_t WRCSDC4;
    stc_hsspi_wrcsdc_field_t WRCSDC4_f;
  };
  union {
    __IO uint16_t WRCSDC5;
    stc_hsspi_wrcsdc_field_t WRCSDC5_f;
  };
  union {
    __IO uint16_t WRCSDC6;
    stc_hsspi_wrcsdc_field_t WRCSDC6_f;
  };
  union {
    __IO uint16_t WRCSDC7;
    stc_hsspi_wrcsdc_field_t WRCSDC7_f;
  };
  union {
    __IO uint32_t MID;
    stc_hsspi_mid_field_t MID_f;
  };
        uint8_t RESERVED3[768];
  union {
    __IO  uint8_t QDCLKR;
    stc_hsspi_qdclkr_field_t QDCLKR_f;
  };
        uint8_t RESERVED4[3];
  union {
    __IO  uint8_t DBCNT;
    stc_hsspi_dbcnt_field_t DBCNT_f;
  };
}FM_HSSPI_TypeDef;

/******************************************************************************
 * Peripheral memory map
 ******************************************************************************/
#define FM4_FLASH_BASE        (0x00000000UL)                 /* Flash Base                             */
#define FM4_PERIPH_BASE       (0x40000000UL)                 /* Peripheral  Base                       */
#define FM4_HSQSPI_BASE       (0xD0000000UL)                 /* High-Speed Quad SPI Base               */
#define FM4_CM3_BASE          (0xE0100000UL)                 /* CM3 Private                            */

#define FM4_FLASH_IF_BASE     (FM4_PERIPH_BASE + 0x00000UL)  /* Flash interface registers              */
#define FM4_UNIQUE_ID_BASE    (FM4_PERIPH_BASE + 0x00200UL)  /* Unique ID registers                    */
#define FM4_ECC_CAPTURE_BASE  (FM4_PERIPH_BASE + 0x00300UL)  /* ECC Capture address registers          */
#define FM4_DUALFLASH_IF_BASE (FM4_PERIPH_BASE + 0x00400UL)  /* Dual Flash interface registers         */
#define FM4_CRG_BASE          (FM4_PERIPH_BASE + 0x10000UL)  /* Clock and reset registers              */
#define FM4_HWWDT_BASE        (FM4_PERIPH_BASE + 0x11000UL)  /* Hardware watchdog registers            */
#define FM4_SWWDT_BASE        (FM4_PERIPH_BASE + 0x12000UL)  /* Software watchdog registers            */
#define FM4_DTIM_BASE         (FM4_PERIPH_BASE + 0x15000UL)  /* Dual timer 1/2 registers               */
#define FM4_MFT0_FRT_BASE     (FM4_PERIPH_BASE + 0x20100UL)  /* Multifunction Timer unit 0 Free Running Timer registers */
#define FM4_MFT0_OCU_BASE     (FM4_PERIPH_BASE + 0x20100UL)  /* Multifunction Timer unit 0 Output Compare Unit registers */
#define FM4_MFT0_WFG_BASE     (FM4_PERIPH_BASE + 0x20100UL)  /* Multifunction Timer unit 0 Waveform Generator and Noise Canceler registers */
#define FM4_MFT0_ICU_BASE     (FM4_PERIPH_BASE + 0x20100UL)  /* Multifunction Timer unit 0 Input Capture Unit registers */
#define FM4_MFT0_ADCMP_BASE   (FM4_PERIPH_BASE + 0x20100UL)  /* Multifunction Timer unit 0 ADC Start Compare Unit registers */
#define FM4_MFT1_FRT_BASE     (FM4_PERIPH_BASE + 0x21100UL)  /* Multifunction Timer unit 1 Free Running Timer registers */
#define FM4_MFT1_OCU_BASE     (FM4_PERIPH_BASE + 0x21100UL)  /* Multifunction Timer unit 1 Output Compare Unit registers */
#define FM4_MFT1_WFG_BASE     (FM4_PERIPH_BASE + 0x21100UL)  /* Multifunction Timer unit 1 Waveform Generator and Noise Canceler registers */
#define FM4_MFT1_ICU_BASE     (FM4_PERIPH_BASE + 0x21100UL)  /* Multifunction Timer unit 1 Input Capture Unit registers */
#define FM4_MFT1_ADCMP_BASE   (FM4_PERIPH_BASE + 0x21100UL)  /* Multifunction Timer unit 1 ADC Start Compare Unit registers */
#define FM4_MFT2_FRT_BASE     (FM4_PERIPH_BASE + 0x22100UL)  /* Multifunction Timer unit 2 Free Running Timer registers */
#define FM4_MFT2_OCU_BASE     (FM4_PERIPH_BASE + 0x22100UL)  /* Multifunction Timer unit 2 Output Compare Unit registers */
#define FM4_MFT2_WFG_BASE     (FM4_PERIPH_BASE + 0x22100UL)  /* Multifunction Timer unit 2 Waveform Generator and Noise Canceler registers */
#define FM4_MFT2_ICU_BASE     (FM4_PERIPH_BASE + 0x22100UL)  /* Multifunction Timer unit 2 Input Capture Unit registers */
#define FM4_MFT2_ADCMP_BASE   (FM4_PERIPH_BASE + 0x22100UL)  /* Multifunction Timer unit 2 ADC Start Compare Unit registers */
#define FM4_MFT_PPG_BASE      (FM4_PERIPH_BASE + 0x24000UL)  /* Multifunction Timer PPG registers      */
#define FM4_BT0_PPG_BASE      (FM4_PERIPH_BASE + 0x25000UL)  /* Base Timer 0 PPG registers             */
#define FM4_BT0_PWM_BASE      (FM4_PERIPH_BASE + 0x25000UL)  /* Base Timer 0 PWM registers             */
#define FM4_BT0_RT_BASE       (FM4_PERIPH_BASE + 0x25000UL)  /* Base Timer 0 RT registers              */
#define FM4_BT0_PWC_BASE      (FM4_PERIPH_BASE + 0x25000UL)  /* Base Timer 0 PWC registers             */
#define FM4_BT1_PPG_BASE      (FM4_PERIPH_BASE + 0x25040UL)  /* Base Timer 1 PPG registers             */
#define FM4_BT1_PWM_BASE      (FM4_PERIPH_BASE + 0x25040UL)  /* Base Timer 1 PWM registers             */
#define FM4_BT1_RT_BASE       (FM4_PERIPH_BASE + 0x25040UL)  /* Base Timer 1 RT registers              */
#define FM4_BT1_PWC_BASE      (FM4_PERIPH_BASE + 0x25040UL)  /* Base Timer 1 PWC registers             */
#define FM4_BT2_PPG_BASE      (FM4_PERIPH_BASE + 0x25080UL)  /* Base Timer 2 PPG registers             */
#define FM4_BT2_PWM_BASE      (FM4_PERIPH_BASE + 0x25080UL)  /* Base Timer 2 PWM registers             */
#define FM4_BT2_RT_BASE       (FM4_PERIPH_BASE + 0x25080UL)  /* Base Timer 2 RT registers              */
#define FM4_BT2_PWC_BASE      (FM4_PERIPH_BASE + 0x25080UL)  /* Base Timer 2 PWC registers             */
#define FM4_BT3_PPG_BASE      (FM4_PERIPH_BASE + 0x250C0UL)  /* Base Timer 3 PPG registers             */
#define FM4_BT3_PWM_BASE      (FM4_PERIPH_BASE + 0x250C0UL)  /* Base Timer 3 PWM registers             */
#define FM4_BT3_RT_BASE       (FM4_PERIPH_BASE + 0x250C0UL)  /* Base Timer 3 RT registers              */
#define FM4_BT3_PWC_BASE      (FM4_PERIPH_BASE + 0x250C0UL)  /* Base Timer 3 PWC registers             */
#define FM4_BT4_PPG_BASE      (FM4_PERIPH_BASE + 0x25200UL)  /* Base Timer 4 PPG registers             */
#define FM4_BT4_PWM_BASE      (FM4_PERIPH_BASE + 0x25200UL)  /* Base Timer 4 PWM registers             */
#define FM4_BT4_RT_BASE       (FM4_PERIPH_BASE + 0x25200UL)  /* Base Timer 4 RT registers              */
#define FM4_BT4_PWC_BASE      (FM4_PERIPH_BASE + 0x25200UL)  /* Base Timer 4 PWC registers             */
#define FM4_BT5_PPG_BASE      (FM4_PERIPH_BASE + 0x25240UL)  /* Base Timer 5 PPG registers             */
#define FM4_BT5_PWM_BASE      (FM4_PERIPH_BASE + 0x25240UL)  /* Base Timer 5 PWM registers             */
#define FM4_BT5_RT_BASE       (FM4_PERIPH_BASE + 0x25240UL)  /* Base Timer 5 RT registers              */
#define FM4_BT5_PWC_BASE      (FM4_PERIPH_BASE + 0x25240UL)  /* Base Timer 5 PWC registers             */
#define FM4_BT6_PPG_BASE      (FM4_PERIPH_BASE + 0x25280UL)  /* Base Timer 6 PPG registers             */
#define FM4_BT6_PWM_BASE      (FM4_PERIPH_BASE + 0x25280UL)  /* Base Timer 6 PWM registers             */
#define FM4_BT6_RT_BASE       (FM4_PERIPH_BASE + 0x25280UL)  /* Base Timer 6 RT registers              */
#define FM4_BT6_PWC_BASE      (FM4_PERIPH_BASE + 0x25280UL)  /* Base Timer 6 PWC registers             */
#define FM4_BT7_PPG_BASE      (FM4_PERIPH_BASE + 0x252C0UL)  /* Base Timer 7 PPG registers             */
#define FM4_BT7_PWM_BASE      (FM4_PERIPH_BASE + 0x252C0UL)  /* Base Timer 7 PWM registers             */
#define FM4_BT7_RT_BASE       (FM4_PERIPH_BASE + 0x252C0UL)  /* Base Timer 7 RT registers              */
#define FM4_BT7_PWC_BASE      (FM4_PERIPH_BASE + 0x252C0UL)  /* Base Timer 7 PWC registers             */
#define FM4_BTIOSEL03_BASE    (FM4_PERIPH_BASE + 0x25100UL)  /* Base Timer I/O selector channel 0 - channel 3 registers */
#define FM4_BTIOSEL47_BASE    (FM4_PERIPH_BASE + 0x25300UL)  /* Base Timer I/O selector channel 4 - channel 7 registers */
#define FM4_BT8_PPG_BASE      (FM4_PERIPH_BASE + 0x25400UL)  /* Base Timer 8 PPG registers             */
#define FM4_BT8_PWM_BASE      (FM4_PERIPH_BASE + 0x25400UL)  /* Base Timer 8 PWM registers             */
#define FM4_BT8_RT_BASE       (FM4_PERIPH_BASE + 0x25400UL)  /* Base Timer 8 RT registers              */
#define FM4_BT8_PWC_BASE      (FM4_PERIPH_BASE + 0x25400UL)  /* Base Timer 8 PWC registers             */
#define FM4_BT9_PPG_BASE      (FM4_PERIPH_BASE + 0x25440UL)  /* Base Timer 9 PPG registers             */
#define FM4_BT9_PWM_BASE      (FM4_PERIPH_BASE + 0x25440UL)  /* Base Timer 9 PWM registers             */
#define FM4_BT9_RT_BASE       (FM4_PERIPH_BASE + 0x25440UL)  /* Base Timer 9 RT registers              */
#define FM4_BT9_PWC_BASE      (FM4_PERIPH_BASE + 0x25440UL)  /* Base Timer 9 PWC registers             */
#define FM4_BT10_PPG_BASE     (FM4_PERIPH_BASE + 0x25480UL)  /* Base Timer 10 PPG registers            */
#define FM4_BT10_PWM_BASE     (FM4_PERIPH_BASE + 0x25480UL)  /* Base Timer 10 PWM registers            */
#define FM4_BT10_RT_BASE      (FM4_PERIPH_BASE + 0x25480UL)  /* Base Timer 10 RT registers             */
#define FM4_BT10_PWC_BASE     (FM4_PERIPH_BASE + 0x25480UL)  /* Base Timer 10 PWC registers            */
#define FM4_BT11_PPG_BASE     (FM4_PERIPH_BASE + 0x254C0UL)  /* Base Timer 11 PPG registers            */
#define FM4_BT11_PWM_BASE     (FM4_PERIPH_BASE + 0x254C0UL)  /* Base Timer 11 PWM registers            */
#define FM4_BT11_RT_BASE      (FM4_PERIPH_BASE + 0x254C0UL)  /* Base Timer 11 RT registers             */
#define FM4_BT11_PWC_BASE     (FM4_PERIPH_BASE + 0x254C0UL)  /* Base Timer 11 PWC registers            */
#define FM4_BT12_PPG_BASE     (FM4_PERIPH_BASE + 0x25600UL)  /* Base Timer 8 PPG registers             */
#define FM4_BT12_PWM_BASE     (FM4_PERIPH_BASE + 0x25600UL)  /* Base Timer 8 PWM registers             */
#define FM4_BT12_RT_BASE      (FM4_PERIPH_BASE + 0x25600UL)  /* Base Timer 8 RT registers              */
#define FM4_BT12_PWC_BASE     (FM4_PERIPH_BASE + 0x25600UL)  /* Base Timer 8 PWC registers             */
#define FM4_BT13_PPG_BASE     (FM4_PERIPH_BASE + 0x25640UL)  /* Base Timer 9 PPG registers             */
#define FM4_BT13_PWM_BASE     (FM4_PERIPH_BASE + 0x25640UL)  /* Base Timer 9 PWM registers             */
#define FM4_BT13_RT_BASE      (FM4_PERIPH_BASE + 0x25640UL)  /* Base Timer 9 RT registers              */
#define FM4_BT13_PWC_BASE     (FM4_PERIPH_BASE + 0x25640UL)  /* Base Timer 9 PWC registers             */
#define FM4_BT14_PPG_BASE     (FM4_PERIPH_BASE + 0x25680UL)  /* Base Timer 10 PPG registers            */
#define FM4_BT14_PWM_BASE     (FM4_PERIPH_BASE + 0x25680UL)  /* Base Timer 10 PWM registers            */
#define FM4_BT14_RT_BASE      (FM4_PERIPH_BASE + 0x25680UL)  /* Base Timer 10 RT registers             */
#define FM4_BT14_PWC_BASE     (FM4_PERIPH_BASE + 0x25680UL)  /* Base Timer 10 PWC registers            */
#define FM4_BT15_PPG_BASE     (FM4_PERIPH_BASE + 0x256C0UL)  /* Base Timer 11 PPG registers            */
#define FM4_BT15_PWM_BASE     (FM4_PERIPH_BASE + 0x256C0UL)  /* Base Timer 11 PWM registers            */
#define FM4_BT15_RT_BASE      (FM4_PERIPH_BASE + 0x256C0UL)  /* Base Timer 11 RT registers             */
#define FM4_BT15_PWC_BASE     (FM4_PERIPH_BASE + 0x256C0UL)  /* Base Timer 11 PWC registers            */
#define FM4_BTIOSEL8B_BASE    (FM4_PERIPH_BASE + 0x25500UL)  /* Base Timer I/O selector channel 8 - channel 11 registers */
#define FM4_BTIOSELCF_BASE    (FM4_PERIPH_BASE + 0x25700UL)  /* Base Timer I/O selector channel 12 - channel 15 registers */
#define FM4_SBSSR_BASE        (FM4_PERIPH_BASE + 0x25FFCUL)  /* Software based Simulation Startup (Base Timer) register */
#define FM4_QPRC0_BASE        (FM4_PERIPH_BASE + 0x26000UL)  /* Quad position and revolution counter channel 0 registers */
#define FM4_QPRC1_BASE        (FM4_PERIPH_BASE + 0x26040UL)  /* Quad position and revolution counter channel 1 registers */
#define FM4_QPRC2_BASE        (FM4_PERIPH_BASE + 0x26080UL)  /* Quad position and revolution counter channel 2 registers */
#define FM4_QPRC3_BASE        (FM4_PERIPH_BASE + 0x260C0UL)  /* Quad position and revolution counter channel 3 registers */
#define FM4_QPRC0_NF_BASE     (FM4_PERIPH_BASE + 0x26100UL)  /* Quad position and revolution counter channel 0 noise filter registers */
#define FM4_QPRC1_NF_BASE     (FM4_PERIPH_BASE + 0x26110UL)  /* Quad position and revolution counter channel 0 noise filter registers */
#define FM4_QPRC2_NF_BASE     (FM4_PERIPH_BASE + 0x26120UL)  /* Quad position and revolution counter channel 0 noise filter registers */
#define FM4_QPRC3_NF_BASE     (FM4_PERIPH_BASE + 0x26130UL)  /* Quad position and revolution counter channel 0 noise filter registers */
#define FM4_ADC0_BASE         (FM4_PERIPH_BASE + 0x27000UL)  /* 12-bit ADC unit 0 registers            */
#define FM4_ADC1_BASE         (FM4_PERIPH_BASE + 0x27100UL)  /* 12-bit ADC unit 1 registers            */
#define FM4_ADC2_BASE         (FM4_PERIPH_BASE + 0x27200UL)  /* 12-bit ADC unit 2 registers            */
#define FM4_DAC0_BASE         (FM4_PERIPH_BASE + 0x33000UL)  /* 12-bit DAC uint 0 registers            */
#define FM4_DAC1_BASE         (FM4_PERIPH_BASE + 0x33008UL)  /* 12-bit DAC uint 1 registers            */
#define FM4_CRTRIM_BASE       (FM4_PERIPH_BASE + 0x2E000UL)  /* CR trimming registers                  */
#define FM4_EXTI_BASE         (FM4_PERIPH_BASE + 0x30000UL)  /* External interrupt registers           */
#define FM4_INTREQ_BASE       (FM4_PERIPH_BASE + 0x31000UL)  /* Interrupt request read registers       */
#define FM4_IRQSEL_BASE       (FM4_PERIPH_BASE + 0x31110UL)  /* Interrupt Selector                     */
#define FM4_HDMICEC0_BASE     (FM4_PERIPH_BASE + 0x34000UL)  /* HDMI-CEC ch.0 registers                */
#define FM4_HDMICEC1_BASE     (FM4_PERIPH_BASE + 0x34100UL)  /* HDMI-CEC ch.1 registers                */
#define FM4_GPIO_BASE         (FM4_PERIPH_BASE + 0x6F000UL)  /* General purpose I/O registers          */
#define FM4_LVD_BASE          (FM4_PERIPH_BASE + 0x35000UL)  /* Low voltage detection registers        */
#define FM4_DS_BASE           (FM4_PERIPH_BASE + 0x35100UL)  /* Deep standby mode registers            */
#define FM4_USBETHERNETCLK_BASE (FM4_PERIPH_BASE + 0x36000UL)  /* USB & Ethernet clock registers       */
#define FM4_CANPRES_BASE      (FM4_PERIPH_BASE + 0x37000UL)  /* CAN prescaler register                 */
#define FM4_MFS0_BASE         (FM4_PERIPH_BASE + 0x38000UL)  /* MFS channel 0 registers                */
#define FM4_MFS1_BASE         (FM4_PERIPH_BASE + 0x38100UL)  /* MFS channel 1 registers                */
#define FM4_MFS2_BASE         (FM4_PERIPH_BASE + 0x38200UL)  /* MFS channel 2 registers                */
#define FM4_MFS3_BASE         (FM4_PERIPH_BASE + 0x38300UL)  /* MFS channel 3 registers                */
#define FM4_MFS4_BASE         (FM4_PERIPH_BASE + 0x38400UL)  /* MFS channel 4 registers                */
#define FM4_MFS5_BASE         (FM4_PERIPH_BASE + 0x38500UL)  /* MFS channel 5 registers                */
#define FM4_MFS6_BASE         (FM4_PERIPH_BASE + 0x38600UL)  /* MFS channel 6 registers                */
#define FM4_MFS7_BASE         (FM4_PERIPH_BASE + 0x38700UL)  /* MFS channel 7 registers                */
#define FM4_MFS8_BASE         (FM4_PERIPH_BASE + 0x38800UL)  /* MFS channel 8 registers                */
#define FM4_MFS9_BASE         (FM4_PERIPH_BASE + 0x38900UL)  /* MFS channel 9 registers                */
#define FM4_MFS10_BASE        (FM4_PERIPH_BASE + 0x38A00UL)  /* MFS channel 10 registers               */
#define FM4_MFS11_BASE        (FM4_PERIPH_BASE + 0x38B00UL)  /* MFS channel 11 registers               */
#define FM4_MFS12_BASE        (FM4_PERIPH_BASE + 0x38C00UL)  /* MFS channel 12 registers               */
#define FM4_MFS13_BASE        (FM4_PERIPH_BASE + 0x38D00UL)  /* MFS channel 13 registers               */
#define FM4_MFS14_BASE        (FM4_PERIPH_BASE + 0x38E00UL)  /* MFS channel 14 registers               */
#define FM4_MFS15_BASE        (FM4_PERIPH_BASE + 0x38F00UL)  /* MFS channel 15 registers               */
#define FM4_MFS_NFC_BASE      (FM4_PERIPH_BASE + 0x38FFFF0)  /* JUST A RANDOM ADDRESS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
#define FM4_CRC_BASE          (FM4_PERIPH_BASE + 0x39000UL)  /* CRC registers                          */
#define FM4_WC_BASE           (FM4_PERIPH_BASE + 0x3A000UL)  /* Watch counter registers                */
#define FM4_RTC_BASE          (FM4_PERIPH_BASE + 0x3B100UL)  /* RTC registers                          */
#define FM4_LCR_BASE          (FM4_PERIPH_BASE + 0x3C000UL)  /* Low-speed CR prescaler registers       */
#define FM4_CLK_GATING_BASE   (FM4_PERIPH_BASE + 0x3C100UL)  /* Peripheral Clock Gating registers      */
#define FM4_PLL_CONTROL_BASE  (FM4_PERIPH_BASE + 0x3C800UL)  /* Main PLL Control registers             */
#define FM4_I2SPRE_BASE       (FM4_PERIPH_BASE + 0x3D000UL)  /* I2S Pre-scalor registers               */
#define FM4_EXBUS_BASE        (FM4_PERIPH_BASE + 0x3F000UL)  /* External bus interface registers       */
#define FM4_USB0_BASE         (FM4_PERIPH_BASE + 0x42100UL)  /* USB channel 0 registers                */
#define FM4_USB1_BASE         (FM4_PERIPH_BASE + 0x52100UL)  /* USB channel 0 registers                */
#define FM4_DMAC_BASE         (FM4_PERIPH_BASE + 0x60000UL)  /* DMA controller                         */
#define FM4_DSTC_BASE         (FM4_PERIPH_BASE + 0x61000UL)  /* DSTC controller                        */
#define FM4_CAN0_BASE         (FM4_PERIPH_BASE + 0x62000UL)  /* CAN channel 0 registers                */
#define FM4_CAN1_BASE         (FM4_PERIPH_BASE + 0x63000UL)  /* CAN channel 1 registers                */
#define FM4_ETHERNET_MAC0_BASE    (FM4_PERIPH_BASE + 0x64000UL) /* Ethernet MAC 0 registers            */
#define FM4_ETHERNET_CONTROL_BASE (FM4_PERIPH_BASE + 0x66000UL) /* Ethernet MAC control registers      */
#define FM4_I2S0_BASE         (FM4_PERIPH_BASE + 0x6C000UL)  /* I2S interface ch.0 registers           */
#define FM4_SDIF_BASE         (FM4_PERIPH_BASE + 0x6E000UL)  /* SDIF registers                         */
#define FM4_CANFD_BASE        (FM4_PERIPH_BASE + 0x70000UL)  /* CAN FD registers                       */
#define FM4_PCRC_BASE         (FM4_PERIPH_BASE + 0x80000UL)  /* Programable-CRC registers              */
#define FM4_HSSPI_BASE        (FM4_HSQSPI_BASE + 0x00000UL)  /* High-Speed Quad SPI registers          */

/******************************************************************************
 * Peripheral declaration
 ******************************************************************************/
#define FM4_FLASH_IF    ((FM_FLASH_IF_TypeDef *)FM4_FLASH_IF_BASE)
#define FM4_UNIQUE_ID   ((FM_UNIQUE_ID_TypeDef *)FM4_UNIQUE_ID_BASE)
#define FM4_ECC_CAPTURE ((FM_ECC_CAPTURE_TypeDef *)FM4_ECC_CAPTURE_BASE)
#define FM4_DUALFLASH_IF ((FM_DUALFLASH_IF_TypeDef *)FM4_DUALFLASH_IF_BASE)
#define FM4_CRG         ((FM_CRG_TypeDef *)FM4_CRG_BASE)
#define FM4_HWWDT       ((FM_HWWDT_TypeDef *)FM4_HWWDT_BASE)
#define FM4_SWWDT       ((FM_SWWDT_TypeDef *)FM4_SWWDT_BASE)
#define FM4_DTIM        ((FM_DTIM_TypeDef *)FM4_DTIM_BASE)
#define FM4_MFT0_FRT    ((FM_MFT_FRT_TypeDef *)FM4_MFT0_FRT_BASE)
#define FM4_MFT0_OCU    ((FM_MFT_OCU_TypeDef *)FM4_MFT0_OCU_BASE)
#define FM4_MFT0_WFG    ((FM_MFT_WFG_TypeDef *)FM4_MFT0_WFG_BASE)
#define FM4_MFT0_ICU    ((FM_MFT_ICU_TypeDef *)FM4_MFT0_ICU_BASE)
#define FM4_MFT0_ADCMP  ((FM_MFT_ADCMP_TypeDef *)FM4_MFT0_ADCMP_BASE)
#define FM4_MFT1_FRT    ((FM_MFT_FRT_TypeDef *)FM4_MFT1_FRT_BASE)
#define FM4_MFT1_OCU    ((FM_MFT_OCU_TypeDef *)FM4_MFT1_OCU_BASE)
#define FM4_MFT1_WFG    ((FM_MFT_WFG_TypeDef *)FM4_MFT1_WFG_BASE)
#define FM4_MFT1_ICU    ((FM_MFT_ICU_TypeDef *)FM4_MFT1_ICU_BASE)
#define FM4_MFT1_ADCMP  ((FM_MFT_ADCMP_TypeDef *)FM4_MFT1_ADCMP_BASE)
#define FM4_MFT2_FRT    ((FM_MFT_FRT_TypeDef *)FM4_MFT2_FRT_BASE)
#define FM4_MFT2_OCU    ((FM_MFT_OCU_TypeDef *)FM4_MFT2_OCU_BASE)
#define FM4_MFT2_WFG    ((FM_MFT_WFG_TypeDef *)FM4_MFT2_WFG_BASE)
#define FM4_MFT2_ICU    ((FM_MFT_ICU_TypeDef *)FM4_MFT2_ICU_BASE)
#define FM4_MFT2_ADCMP  ((FM_MFT_ADCMP_TypeDef *)FM4_MFT2_ADCMP_BASE)
#define FM4_MFT_PPG     ((FM_MFT_PPG_TypeDef *)FM4_MFT_PPG_BASE)
#define FM4_BT0_PPG     ((FM_BT_PPG_TypeDef *)FM4_BT0_PPG_BASE)
#define FM4_BT0_PWM     ((FM_BT_PWM_TypeDef *)FM4_BT0_PWM_BASE)
#define FM4_BT0_RT      ((FM_BT_RT_TypeDef *)FM4_BT0_RT_BASE)
#define FM4_BT0_PWC     ((FM_BT_PWC_TypeDef *)FM4_BT0_PWC_BASE)
#define FM4_BT1_PPG     ((FM_BT_PPG_TypeDef *)FM4_BT1_PPG_BASE)
#define FM4_BT1_PWM     ((FM_BT_PWM_TypeDef *)FM4_BT1_PWM_BASE)
#define FM4_BT1_RT      ((FM_BT_RT_TypeDef *)FM4_BT1_RT_BASE)
#define FM4_BT1_PWC     ((FM_BT_PWC_TypeDef *)FM4_BT1_PWC_BASE)
#define FM4_BT2_PPG     ((FM_BT_PPG_TypeDef *)FM4_BT2_PPG_BASE)
#define FM4_BT2_PWM     ((FM_BT_PWM_TypeDef *)FM4_BT2_PWM_BASE)
#define FM4_BT2_RT      ((FM_BT_RT_TypeDef *)FM4_BT2_RT_BASE)
#define FM4_BT2_PWC     ((FM_BT_PWC_TypeDef *)FM4_BT2_PWC_BASE)
#define FM4_BT3_PPG     ((FM_BT_PPG_TypeDef *)FM4_BT3_PPG_BASE)
#define FM4_BT3_PWM     ((FM_BT_PWM_TypeDef *)FM4_BT3_PWM_BASE)
#define FM4_BT3_RT      ((FM_BT_RT_TypeDef *)FM4_BT3_RT_BASE)
#define FM4_BT3_PWC     ((FM_BT_PWC_TypeDef *)FM4_BT3_PWC_BASE)
#define FM4_BT4_PPG     ((FM_BT_PPG_TypeDef *)FM4_BT4_PPG_BASE)
#define FM4_BT4_PWM     ((FM_BT_PWM_TypeDef *)FM4_BT4_PWM_BASE)
#define FM4_BT4_RT      ((FM_BT_RT_TypeDef *)FM4_BT4_RT_BASE)
#define FM4_BT4_PWC     ((FM_BT_PWC_TypeDef *)FM4_BT4_PWC_BASE)
#define FM4_BT5_PPG     ((FM_BT_PPG_TypeDef *)FM4_BT5_PPG_BASE)
#define FM4_BT5_PWM     ((FM_BT_PWM_TypeDef *)FM4_BT5_PWM_BASE)
#define FM4_BT5_RT      ((FM_BT_RT_TypeDef *)FM4_BT5_RT_BASE)
#define FM4_BT5_PWC     ((FM_BT_PWC_TypeDef *)FM4_BT5_PWC_BASE)
#define FM4_BT6_PPG     ((FM_BT_PPG_TypeDef *)FM4_BT6_PPG_BASE)
#define FM4_BT6_PWM     ((FM_BT_PWM_TypeDef *)FM4_BT6_PWM_BASE)
#define FM4_BT6_RT      ((FM_BT_RT_TypeDef *)FM4_BT6_RT_BASE)
#define FM4_BT6_PWC     ((FM_BT_PWC_TypeDef *)FM4_BT6_PWC_BASE)
#define FM4_BT7_PPG     ((FM_BT_PPG_TypeDef *)FM4_BT7_PPG_BASE)
#define FM4_BT7_PWM     ((FM_BT_PWM_TypeDef *)FM4_BT7_PWM_BASE)
#define FM4_BT7_RT      ((FM_BT_RT_TypeDef *)FM4_BT7_RT_BASE)
#define FM4_BT7_PWC     ((FM_BT_PWC_TypeDef *)FM4_BT7_PWC_BASE)
#define FM4_BTIOSEL03   ((FM_BTIOSEL03_TypeDef *)FM4_BTIOSEL03_BASE)
#define FM4_BTIOSEL47   ((FM_BTIOSEL47_TypeDef *)FM4_BTIOSEL47_BASE)
#define FM4_BT8_PPG     ((FM_BT_PPG_TypeDef *)FM4_BT8_PPG_BASE)
#define FM4_BT8_PWM     ((FM_BT_PWM_TypeDef *)FM4_BT8_PWM_BASE)
#define FM4_BT8_RT      ((FM_BT_RT_TypeDef *)FM4_BT8_RT_BASE)
#define FM4_BT8_PWC     ((FM_BT_PWC_TypeDef *)FM4_BT8_PWC_BASE)
#define FM4_BT9_PPG     ((FM_BT_PPG_TypeDef *)FM4_BT9_PPG_BASE)
#define FM4_BT9_PWM     ((FM_BT_PWM_TypeDef *)FM4_BT9_PWM_BASE)
#define FM4_BT9_RT      ((FM_BT_RT_TypeDef *)FM4_BT9_RT_BASE)
#define FM4_BT9_PWC     ((FM_BT_PWC_TypeDef *)FM4_BT9_PWC_BASE)
#define FM4_BT10_PPG    ((FM_BT_PPG_TypeDef *)FM4_BT10_PPG_BASE)
#define FM4_BT10_PWM    ((FM_BT_PWM_TypeDef *)FM4_BT10_PWM_BASE)
#define FM4_BT10_RT     ((FM_BT_RT_TypeDef *)FM4_BT10_RT_BASE)
#define FM4_BT10_PWC    ((FM_BT_PWC_TypeDef *)FM4_BT10_PWC_BASE)
#define FM4_BT11_PPG    ((FM_BT_PPG_TypeDef *)FM4_BT11_PPG_BASE)
#define FM4_BT11_PWM    ((FM_BT_PWM_TypeDef *)FM4_BT11_PWM_BASE)
#define FM4_BT11_RT     ((FM_BT_RT_TypeDef *)FM4_BT11_RT_BASE)
#define FM4_BT11_PWC    ((FM_BT_PWC_TypeDef *)FM4_BT11_PWC_BASE)
#define FM4_BT12_PPG    ((FM_BT_PPG_TypeDef *)FM4_BT12_PPG_BASE)
#define FM4_BT12_PWM    ((FM_BT_PWM_TypeDef *)FM4_BT12_PWM_BASE)
#define FM4_BT12_RT     ((FM_BT_RT_TypeDef *)FM4_BT12_RT_BASE)
#define FM4_BT12_PWC    ((FM_BT_PWC_TypeDef *)FM4_BT12_PWC_BASE)
#define FM4_BT13_PPG    ((FM_BT_PPG_TypeDef *)FM4_BT13_PPG_BASE)
#define FM4_BT13_PWM    ((FM_BT_PWM_TypeDef *)FM4_BT13_PWM_BASE)
#define FM4_BT13_RT     ((FM_BT_RT_TypeDef *)FM4_BT13_RT_BASE)
#define FM4_BT13_PWC    ((FM_BT_PWC_TypeDef *)FM4_BT13_PWC_BASE)
#define FM4_BT14_PPG    ((FM_BT_PPG_TypeDef *)FM4_BT14_PPG_BASE)
#define FM4_BT14_PWM    ((FM_BT_PWM_TypeDef *)FM4_BT14_PWM_BASE)
#define FM4_BT14_RT     ((FM_BT_RT_TypeDef *)FM4_BT14_RT_BASE)
#define FM4_BT14_PWC    ((FM_BT_PWC_TypeDef *)FM4_BT14_PWC_BASE)
#define FM4_BT15_PPG    ((FM_BT_PPG_TypeDef *)FM4_BT15_PPG_BASE)
#define FM4_BT15_PWM    ((FM_BT_PWM_TypeDef *)FM4_BT15_PWM_BASE)
#define FM4_BT15_RT     ((FM_BT_RT_TypeDef *)FM4_BT15_RT_BASE)
#define FM4_BT15_PWC    ((FM_BT_PWC_TypeDef *)FM4_BT15_PWC_BASE)
#define FM4_BTIOSEL8B   ((FM_BTIOSEL8B_TypeDef *)FM4_BTIOSEL8B_BASE)
#define FM4_BTIOSELCF   ((FM_BTIOSELCF_TypeDef *)FM4_BTIOSELCF_BASE)
#define FM4_SBSSR       ((FM_SBSSR_TypeDef *)FM4_SBSSR_BASE)
#define FM4_QPRC0       ((FM_QPRC_TypeDef *)FM4_QPRC0_BASE)
#define FM4_QPRC1       ((FM_QPRC_TypeDef *)FM4_QPRC1_BASE)
#define FM4_QPRC2       ((FM_QPRC_TypeDef *)FM4_QPRC2_BASE)
#define FM4_QPRC3       ((FM_QPRC_TypeDef *)FM4_QPRC3_BASE)
#define FM4_QPRC0_NF    ((FM_QPRC_NF_TypeDef *)FM4_QPRC0_NF_BASE)
#define FM4_QPRC1_NF    ((FM_QPRC_NF_TypeDef *)FM4_QPRC1_NF_BASE)
#define FM4_QPRC2_NF    ((FM_QPRC_NF_TypeDef *)FM4_QPRC2_NF_BASE)
#define FM4_QPRC3_NF    ((FM_QPRC_NF_TypeDef *)FM4_QPRC3_NF_BASE)
#define FM4_ADC0        ((FM_ADC_TypeDef *)FM4_ADC0_BASE)
#define FM4_ADC1        ((FM_ADC_TypeDef *)FM4_ADC1_BASE)
#define FM4_ADC2        ((FM_ADC_TypeDef *)FM4_ADC2_BASE)
#define FM4_DAC0        ((FM_DAC_TypeDef *)FM4_DAC0_BASE)
#define FM4_DAC1        ((FM_DAC_TypeDef *)FM4_DAC1_BASE)
#define FM4_CRTRIM      ((FM_CRTRIM_TypeDef *)FM4_CRTRIM_BASE)
#define FM4_EXTI        ((FM_EXTI_TypeDef *)FM4_EXTI_BASE)
#define FM4_INTREQ      ((FM_INTREQ_TypeDef *)FM4_INTREQ_BASE)
#define FM4_IRQSEL      ((FM_IRQSEL_TypeDef *)FM4_IRQSEL_BASE)
#define FM4_HDMICEC0    ((FM_HDMICEC_TypeDef *)FM4_HDMICEC0_BASE)
#define FM4_HDMICEC1    ((FM_HDMICEC_TypeDef *)FM4_HDMICEC1_BASE)
#define FM4_GPIO        ((FM_GPIO_TypeDef *)FM4_GPIO_BASE)
#define FM4_LVD         ((FM_LVD_TypeDef *)FM4_LVD_BASE)
#define FM4_DS          ((FM_DS_TypeDef *)FM4_DS_BASE)
#define FM4_USBETHERNETCLK ((FM_USBETHERNETCLK_TypeDef *)FM4_USBETHERNETCLK_BASE)
#define FM4_CANPRES     ((FM_CANPRE_TypeDef *)FM4_CANPRES_BASE)
#define FM4_MFS0        ((FM_MFS_TypeDef *)FM4_MFS0_BASE)
#define FM4_MFS1        ((FM_MFS_TypeDef *)FM4_MFS1_BASE)
#define FM4_MFS2        ((FM_MFS_TypeDef *)FM4_MFS2_BASE)
#define FM4_MFS3        ((FM_MFS_TypeDef *)FM4_MFS3_BASE)
#define FM4_MFS4        ((FM_MFS_TypeDef *)FM4_MFS4_BASE)
#define FM4_MFS5        ((FM_MFS_TypeDef *)FM4_MFS5_BASE)
#define FM4_MFS6        ((FM_MFS_TypeDef *)FM4_MFS6_BASE)
#define FM4_MFS7        ((FM_MFS_TypeDef *)FM4_MFS7_BASE)
#define FM4_MFS8        ((FM_MFS_TypeDef *)FM4_MFS8_BASE)
#define FM4_MFS9        ((FM_MFS_TypeDef *)FM4_MFS9_BASE)
#define FM4_MFS10       ((FM_MFS_TypeDef *)FM4_MFS10_BASE)
#define FM4_MFS11       ((FM_MFS_TypeDef *)FM4_MFS11_BASE)
#define FM4_MFS12       ((FM_MFS_TypeDef *)FM4_MFS12_BASE)
#define FM4_MFS13       ((FM_MFS_TypeDef *)FM4_MFS13_BASE)
#define FM4_MFS14       ((FM_MFS_TypeDef *)FM4_MFS14_BASE)
#define FM4_MFS15       ((FM_MFS_TypeDef *)FM4_MFS15_BASE)
#define FM4_CRC         ((FM_CRC_TypeDef *)FM4_CRC_BASE)
#define FM4_WC          ((FM_WC_TypeDef *)FM4_WC_BASE)
#define FM4_RTC         ((FM_RTC_TypeDef *)FM4_RTC_BASE)
#define FM4_LCR         ((FM_LCR_TypeDef *)FM4_LCR_BASE)
#define FM4_CLK_GATING  ((FM_CLK_GATING_TypeDef *)FM4_CLK_GATING_BASE)
#define FM4_PLL_CONTROL ((FM_PLL_CONTROL_TypeDef *)FM4_PLL_CONTROL_BASE)
#define FM4_I2SPRE      ((FM_I2SPRE_TypeDef *)FM4_I2SPRE_BASE)
#define FM4_EXBUS       ((FM_EXBUS_TypeDef *)FM4_EXBUS_BASE)
#define FM4_USB0        ((FM_USB_TypeDef *)FM4_USB0_BASE)
#define FM4_USB1        ((FM_USB_TypeDef *)FM4_USB1_BASE)
#define FM4_DMAC        ((FM_DMAC_TypeDef *)FM4_DMAC_BASE)
#define FM4_DSTC        ((FM_DSTC_TypeDef *)FM4_DSTC_BASE)
#define FM4_CAN0        ((FM_CAN_TypeDef *)FM4_CAN0_BASE)
#define FM4_CAN1        ((FM_CAN_TypeDef *)FM4_CAN1_BASE)
#define FM4_ETHERNET_MAC0 ((FM_ETHERNET_MAC_TypeDef *)FM4_ETHERNET_MAC0_BASE)
#define FM4_ETHERNET_CONTROL ((FM_ETHERNET_CONTROL_TypeDef *)FM4_ETHERNET_CONTROL_BASE)
#define FM4_I2S0        ((FM_I2S_TypeDef *)FM4_I2S0_BASE)
#define FM4_SDIF        ((FM_SDIF_TypeDef *)FM4_SDIF_BASE)
#define FM4_CANFD       ((FM_CANFD_TypeDef *)FM4_CANFD_BASE)
#define FM4_PCRC        ((FM_PCRC_TypeDef *)FM4_PCRC_BASE)
#define FM4_HSSPI       ((FM_HSSPI_TypeDef *)FM4_HSSPI_BASE)

/******************************************************************************
 * Peripheral Bit Band Alias declaration
 ******************************************************************************/

/* Flash interface registers */
#define bFM4_FLASH_IF_FASZR_ASZ0               *((volatile unsigned char*)(0x42000000UL))
#define bFM4_FLASH_IF_FASZR_ASZ1               *((volatile unsigned char*)(0x42000004UL))
#define bFM4_FLASH_IF_FRWTR_RWT0               *((volatile unsigned char*)(0x42000080UL))
#define bFM4_FLASH_IF_FRWTR_RWT1               *((volatile unsigned char*)(0x42000084UL))
#define bFM4_FLASH_IF_FSTR_RDY                 *((volatile unsigned char*)(0x42000100UL))
#define bFM4_FLASH_IF_FSTR_HNG                 *((volatile unsigned char*)(0x42000104UL))
#define bFM4_FLASH_IF_FSTR_ERR                 *((volatile unsigned char*)(0x42000108UL))
#define bFM4_FLASH_IF_FSYNDN_SD0               *((volatile unsigned char*)(0x42000200UL))
#define bFM4_FLASH_IF_FSYNDN_SD1               *((volatile unsigned char*)(0x42000204UL))
#define bFM4_FLASH_IF_FSYNDN_SD2               *((volatile unsigned char*)(0x42000208UL))
#define bFM4_FLASH_IF_FBFCR_BE                 *((volatile unsigned char*)(0x42000280UL))
#define bFM4_FLASH_IF_FBFCR_BS                 *((volatile unsigned char*)(0x42000284UL))
#define bFM4_FLASH_IF_FICR_RDYIE               *((volatile unsigned char*)(0x42000400UL))
#define bFM4_FLASH_IF_FICR_HANGIE              *((volatile unsigned char*)(0x42000404UL))
#define bFM4_FLASH_IF_FICR_ERRIE               *((volatile unsigned char*)(0x42000408UL))
#define bFM4_FLASH_IF_FISR_RDYIF               *((volatile unsigned char*)(0x42000480UL))
#define bFM4_FLASH_IF_FISR_HANGIF              *((volatile unsigned char*)(0x42000484UL))
#define bFM4_FLASH_IF_FISR_ERRIF               *((volatile unsigned char*)(0x42000488UL))
#define bFM4_FLASH_IF_FICLR_RDYIC              *((volatile unsigned char*)(0x42000500UL))
#define bFM4_FLASH_IF_FICLR_HANGIC             *((volatile unsigned char*)(0x42000504UL))
#define bFM4_FLASH_IF_FICLR_ERRIC              *((volatile unsigned char*)(0x42000508UL))
#define bFM4_FLASH_IF_DFCTRLR_DFE              *((volatile unsigned char*)(0x42000600UL))
#define bFM4_FLASH_IF_DFCTRLR_RME              *((volatile unsigned char*)(0x42000604UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY0            *((volatile unsigned char*)(0x42000640UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY1            *((volatile unsigned char*)(0x42000644UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY2            *((volatile unsigned char*)(0x42000648UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY3            *((volatile unsigned char*)(0x4200064CUL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY4            *((volatile unsigned char*)(0x42000650UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY5            *((volatile unsigned char*)(0x42000654UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY6            *((volatile unsigned char*)(0x42000658UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY7            *((volatile unsigned char*)(0x4200065CUL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY8            *((volatile unsigned char*)(0x42000660UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY9            *((volatile unsigned char*)(0x42000664UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY10           *((volatile unsigned char*)(0x42000668UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY11           *((volatile unsigned char*)(0x4200066CUL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY12           *((volatile unsigned char*)(0x42000670UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY13           *((volatile unsigned char*)(0x42000674UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY14           *((volatile unsigned char*)(0x42000678UL))
#define bFM4_FLASH_IF_DFCTRLR_WKEY15           *((volatile unsigned char*)(0x4200067CUL))
#define bFM4_FLASH_IF_CRTRMM_TRMM0             *((volatile unsigned char*)(0x42002000UL))
#define bFM4_FLASH_IF_CRTRMM_TRMM1             *((volatile unsigned char*)(0x42002004UL))
#define bFM4_FLASH_IF_CRTRMM_TRMM2             *((volatile unsigned char*)(0x42002008UL))
#define bFM4_FLASH_IF_CRTRMM_TRMM3             *((volatile unsigned char*)(0x4200200CUL))
#define bFM4_FLASH_IF_CRTRMM_TRMM4             *((volatile unsigned char*)(0x42002010UL))
#define bFM4_FLASH_IF_CRTRMM_TRMM5             *((volatile unsigned char*)(0x42002014UL))
#define bFM4_FLASH_IF_CRTRMM_TRMM6             *((volatile unsigned char*)(0x42002018UL))
#define bFM4_FLASH_IF_CRTRMM_TRMM7             *((volatile unsigned char*)(0x4200201CUL))
#define bFM4_FLASH_IF_CRTRMM_TRMM8             *((volatile unsigned char*)(0x42002020UL))
#define bFM4_FLASH_IF_CRTRMM_TRMM9             *((volatile unsigned char*)(0x42002024UL))
#define bFM4_FLASH_IF_CRTRMM_TTRMM0            *((volatile unsigned char*)(0x42002040UL))
#define bFM4_FLASH_IF_CRTRMM_TTRMM1            *((volatile unsigned char*)(0x42002044UL))
#define bFM4_FLASH_IF_CRTRMM_TTRMM2            *((volatile unsigned char*)(0x42002048UL))
#define bFM4_FLASH_IF_CRTRMM_TTRMM3            *((volatile unsigned char*)(0x4200204CUL))
#define bFM4_FLASH_IF_CRTRMM_TTRMM4            *((volatile unsigned char*)(0x42002050UL))
#define bFM4_FLASH_IF_FGPDM1_GPD10             *((volatile unsigned char*)(0x42002200UL))
#define bFM4_FLASH_IF_FGPDM1_GPD11             *((volatile unsigned char*)(0x42002204UL))
#define bFM4_FLASH_IF_FGPDM1_GPD12             *((volatile unsigned char*)(0x42002208UL))
#define bFM4_FLASH_IF_FGPDM1_GPD13             *((volatile unsigned char*)(0x4200220CUL))
#define bFM4_FLASH_IF_FGPDM1_GPD14             *((volatile unsigned char*)(0x42002210UL))
#define bFM4_FLASH_IF_FGPDM1_GPD15             *((volatile unsigned char*)(0x42002214UL))
#define bFM4_FLASH_IF_FGPDM1_GPD16             *((volatile unsigned char*)(0x42002218UL))
#define bFM4_FLASH_IF_FGPDM1_GPD17             *((volatile unsigned char*)(0x4200221CUL))
#define bFM4_FLASH_IF_FGPDM1_GPD18             *((volatile unsigned char*)(0x42002220UL))
#define bFM4_FLASH_IF_FGPDM1_GPD19             *((volatile unsigned char*)(0x42002224UL))
#define bFM4_FLASH_IF_FGPDM1_GPD110            *((volatile unsigned char*)(0x42002228UL))
#define bFM4_FLASH_IF_FGPDM1_GPD111            *((volatile unsigned char*)(0x4200222CUL))
#define bFM4_FLASH_IF_FGPDM1_GPD112            *((volatile unsigned char*)(0x42002230UL))
#define bFM4_FLASH_IF_FGPDM1_GPD113            *((volatile unsigned char*)(0x42002234UL))
#define bFM4_FLASH_IF_FGPDM1_GPD114            *((volatile unsigned char*)(0x42002238UL))
#define bFM4_FLASH_IF_FGPDM1_GPD115            *((volatile unsigned char*)(0x4200223CUL))
#define bFM4_FLASH_IF_FGPDM1_GPD116            *((volatile unsigned char*)(0x42002240UL))
#define bFM4_FLASH_IF_FGPDM1_GPD117            *((volatile unsigned char*)(0x42002244UL))
#define bFM4_FLASH_IF_FGPDM1_GPD118            *((volatile unsigned char*)(0x42002248UL))
#define bFM4_FLASH_IF_FGPDM1_GPD119            *((volatile unsigned char*)(0x4200224CUL))
#define bFM4_FLASH_IF_FGPDM1_GPD120            *((volatile unsigned char*)(0x42002250UL))
#define bFM4_FLASH_IF_FGPDM1_GPD121            *((volatile unsigned char*)(0x42002254UL))
#define bFM4_FLASH_IF_FGPDM1_GPD122            *((volatile unsigned char*)(0x42002258UL))
#define bFM4_FLASH_IF_FGPDM1_GPD123            *((volatile unsigned char*)(0x4200225CUL))
#define bFM4_FLASH_IF_FGPDM1_GPD124            *((volatile unsigned char*)(0x42002260UL))
#define bFM4_FLASH_IF_FGPDM1_GPD125            *((volatile unsigned char*)(0x42002264UL))
#define bFM4_FLASH_IF_FGPDM1_GPD126            *((volatile unsigned char*)(0x42002268UL))
#define bFM4_FLASH_IF_FGPDM1_GPD127            *((volatile unsigned char*)(0x4200226CUL))
#define bFM4_FLASH_IF_FGPDM1_GPD128            *((volatile unsigned char*)(0x42002270UL))
#define bFM4_FLASH_IF_FGPDM1_GPD129            *((volatile unsigned char*)(0x42002274UL))
#define bFM4_FLASH_IF_FGPDM1_GPD130            *((volatile unsigned char*)(0x42002278UL))
#define bFM4_FLASH_IF_FGPDM1_GPD131            *((volatile unsigned char*)(0x4200227CUL))
#define bFM4_FLASH_IF_FGPDM2_GPD20             *((volatile unsigned char*)(0x42002280UL))
#define bFM4_FLASH_IF_FGPDM2_GPD21             *((volatile unsigned char*)(0x42002284UL))
#define bFM4_FLASH_IF_FGPDM2_GPD22             *((volatile unsigned char*)(0x42002288UL))
#define bFM4_FLASH_IF_FGPDM2_GPD23             *((volatile unsigned char*)(0x4200228CUL))
#define bFM4_FLASH_IF_FGPDM2_GPD24             *((volatile unsigned char*)(0x42002290UL))
#define bFM4_FLASH_IF_FGPDM2_GPD25             *((volatile unsigned char*)(0x42002294UL))
#define bFM4_FLASH_IF_FGPDM2_GPD26             *((volatile unsigned char*)(0x42002298UL))
#define bFM4_FLASH_IF_FGPDM2_GPD27             *((volatile unsigned char*)(0x4200229CUL))
#define bFM4_FLASH_IF_FGPDM2_GPD28             *((volatile unsigned char*)(0x420022A0UL))
#define bFM4_FLASH_IF_FGPDM2_GPD29             *((volatile unsigned char*)(0x420022A4UL))
#define bFM4_FLASH_IF_FGPDM2_GPD210            *((volatile unsigned char*)(0x420022A8UL))
#define bFM4_FLASH_IF_FGPDM2_GPD211            *((volatile unsigned char*)(0x420022ACUL))
#define bFM4_FLASH_IF_FGPDM2_GPD212            *((volatile unsigned char*)(0x420022B0UL))
#define bFM4_FLASH_IF_FGPDM2_GPD213            *((volatile unsigned char*)(0x420022B4UL))
#define bFM4_FLASH_IF_FGPDM2_GPD214            *((volatile unsigned char*)(0x420022B8UL))
#define bFM4_FLASH_IF_FGPDM2_GPD215            *((volatile unsigned char*)(0x420022BCUL))
#define bFM4_FLASH_IF_FGPDM2_GPD216            *((volatile unsigned char*)(0x420022C0UL))
#define bFM4_FLASH_IF_FGPDM2_GPD217            *((volatile unsigned char*)(0x420022C4UL))
#define bFM4_FLASH_IF_FGPDM2_GPD218            *((volatile unsigned char*)(0x420022C8UL))
#define bFM4_FLASH_IF_FGPDM2_GPD219            *((volatile unsigned char*)(0x420022CCUL))
#define bFM4_FLASH_IF_FGPDM2_GPD220            *((volatile unsigned char*)(0x420022D0UL))
#define bFM4_FLASH_IF_FGPDM2_GPD221            *((volatile unsigned char*)(0x420022D4UL))
#define bFM4_FLASH_IF_FGPDM2_GPD222            *((volatile unsigned char*)(0x420022D8UL))
#define bFM4_FLASH_IF_FGPDM2_GPD223            *((volatile unsigned char*)(0x420022DCUL))
#define bFM4_FLASH_IF_FGPDM2_GPD224            *((volatile unsigned char*)(0x420022E0UL))
#define bFM4_FLASH_IF_FGPDM2_GPD225            *((volatile unsigned char*)(0x420022E4UL))
#define bFM4_FLASH_IF_FGPDM2_GPD226            *((volatile unsigned char*)(0x420022E8UL))
#define bFM4_FLASH_IF_FGPDM2_GPD227            *((volatile unsigned char*)(0x420022ECUL))
#define bFM4_FLASH_IF_FGPDM2_GPD228            *((volatile unsigned char*)(0x420022F0UL))
#define bFM4_FLASH_IF_FGPDM2_GPD229            *((volatile unsigned char*)(0x420022F4UL))
#define bFM4_FLASH_IF_FGPDM2_GPD230            *((volatile unsigned char*)(0x420022F8UL))
#define bFM4_FLASH_IF_FGPDM2_GPD231            *((volatile unsigned char*)(0x420022FCUL))
#define bFM4_FLASH_IF_FGPDM3_GPD30             *((volatile unsigned char*)(0x42002300UL))
#define bFM4_FLASH_IF_FGPDM3_GPD31             *((volatile unsigned char*)(0x42002304UL))
#define bFM4_FLASH_IF_FGPDM3_GPD32             *((volatile unsigned char*)(0x42002308UL))
#define bFM4_FLASH_IF_FGPDM3_GPD33             *((volatile unsigned char*)(0x4200230CUL))
#define bFM4_FLASH_IF_FGPDM3_GPD34             *((volatile unsigned char*)(0x42002310UL))
#define bFM4_FLASH_IF_FGPDM3_GPD35             *((volatile unsigned char*)(0x42002314UL))
#define bFM4_FLASH_IF_FGPDM3_GPD36             *((volatile unsigned char*)(0x42002318UL))
#define bFM4_FLASH_IF_FGPDM3_GPD37             *((volatile unsigned char*)(0x4200231CUL))
#define bFM4_FLASH_IF_FGPDM3_GPD38             *((volatile unsigned char*)(0x42002320UL))
#define bFM4_FLASH_IF_FGPDM3_GPD39             *((volatile unsigned char*)(0x42002324UL))
#define bFM4_FLASH_IF_FGPDM3_GPD310            *((volatile unsigned char*)(0x42002328UL))
#define bFM4_FLASH_IF_FGPDM3_GPD311            *((volatile unsigned char*)(0x4200232CUL))
#define bFM4_FLASH_IF_FGPDM3_GPD312            *((volatile unsigned char*)(0x42002330UL))
#define bFM4_FLASH_IF_FGPDM3_GPD313            *((volatile unsigned char*)(0x42002334UL))
#define bFM4_FLASH_IF_FGPDM3_GPD314            *((volatile unsigned char*)(0x42002338UL))
#define bFM4_FLASH_IF_FGPDM3_GPD315            *((volatile unsigned char*)(0x4200233CUL))
#define bFM4_FLASH_IF_FGPDM3_GPD316            *((volatile unsigned char*)(0x42002340UL))
#define bFM4_FLASH_IF_FGPDM3_GPD317            *((volatile unsigned char*)(0x42002344UL))
#define bFM4_FLASH_IF_FGPDM3_GPD318            *((volatile unsigned char*)(0x42002348UL))
#define bFM4_FLASH_IF_FGPDM3_GPD319            *((volatile unsigned char*)(0x4200234CUL))
#define bFM4_FLASH_IF_FGPDM3_GPD320            *((volatile unsigned char*)(0x42002350UL))
#define bFM4_FLASH_IF_FGPDM3_GPD321            *((volatile unsigned char*)(0x42002354UL))
#define bFM4_FLASH_IF_FGPDM3_GPD322            *((volatile unsigned char*)(0x42002358UL))
#define bFM4_FLASH_IF_FGPDM3_GPD323            *((volatile unsigned char*)(0x4200235CUL))
#define bFM4_FLASH_IF_FGPDM3_GPD324            *((volatile unsigned char*)(0x42002360UL))
#define bFM4_FLASH_IF_FGPDM3_GPD325            *((volatile unsigned char*)(0x42002364UL))
#define bFM4_FLASH_IF_FGPDM3_GPD326            *((volatile unsigned char*)(0x42002368UL))
#define bFM4_FLASH_IF_FGPDM3_GPD327            *((volatile unsigned char*)(0x4200236CUL))
#define bFM4_FLASH_IF_FGPDM3_GPD328            *((volatile unsigned char*)(0x42002370UL))
#define bFM4_FLASH_IF_FGPDM3_GPD329            *((volatile unsigned char*)(0x42002374UL))
#define bFM4_FLASH_IF_FGPDM3_GPD330            *((volatile unsigned char*)(0x42002378UL))
#define bFM4_FLASH_IF_FGPDM3_GPD331            *((volatile unsigned char*)(0x4200237CUL))
#define bFM4_FLASH_IF_FGPDM4_GPD40             *((volatile unsigned char*)(0x42002380UL))
#define bFM4_FLASH_IF_FGPDM4_GPD41             *((volatile unsigned char*)(0x42002384UL))
#define bFM4_FLASH_IF_FGPDM4_GPD42             *((volatile unsigned char*)(0x42002388UL))
#define bFM4_FLASH_IF_FGPDM4_GPD43             *((volatile unsigned char*)(0x4200238CUL))
#define bFM4_FLASH_IF_FGPDM4_GPD44             *((volatile unsigned char*)(0x42002390UL))
#define bFM4_FLASH_IF_FGPDM4_GPD45             *((volatile unsigned char*)(0x42002394UL))
#define bFM4_FLASH_IF_FGPDM4_GPD46             *((volatile unsigned char*)(0x42002398UL))
#define bFM4_FLASH_IF_FGPDM4_GPD47             *((volatile unsigned char*)(0x4200239CUL))
#define bFM4_FLASH_IF_FGPDM4_GPD48             *((volatile unsigned char*)(0x420023A0UL))
#define bFM4_FLASH_IF_FGPDM4_GPD49             *((volatile unsigned char*)(0x420023A4UL))
#define bFM4_FLASH_IF_FGPDM4_GPD410            *((volatile unsigned char*)(0x420023A8UL))
#define bFM4_FLASH_IF_FGPDM4_GPD411            *((volatile unsigned char*)(0x420023ACUL))
#define bFM4_FLASH_IF_FGPDM4_GPD412            *((volatile unsigned char*)(0x420023B0UL))
#define bFM4_FLASH_IF_FGPDM4_GPD413            *((volatile unsigned char*)(0x420023B4UL))
#define bFM4_FLASH_IF_FGPDM4_GPD414            *((volatile unsigned char*)(0x420023B8UL))
#define bFM4_FLASH_IF_FGPDM4_GPD415            *((volatile unsigned char*)(0x420023BCUL))
#define bFM4_FLASH_IF_FGPDM4_GPD416            *((volatile unsigned char*)(0x420023C0UL))
#define bFM4_FLASH_IF_FGPDM4_GPD417            *((volatile unsigned char*)(0x420023C4UL))
#define bFM4_FLASH_IF_FGPDM4_GPD418            *((volatile unsigned char*)(0x420023C8UL))
#define bFM4_FLASH_IF_FGPDM4_GPD419            *((volatile unsigned char*)(0x420023CCUL))
#define bFM4_FLASH_IF_FGPDM4_GPD420            *((volatile unsigned char*)(0x420023D0UL))
#define bFM4_FLASH_IF_FGPDM4_GPD421            *((volatile unsigned char*)(0x420023D4UL))
#define bFM4_FLASH_IF_FGPDM4_GPD422            *((volatile unsigned char*)(0x420023D8UL))
#define bFM4_FLASH_IF_FGPDM4_GPD423            *((volatile unsigned char*)(0x420023DCUL))
#define bFM4_FLASH_IF_FGPDM4_GPD424            *((volatile unsigned char*)(0x420023E0UL))
#define bFM4_FLASH_IF_FGPDM4_GPD425            *((volatile unsigned char*)(0x420023E4UL))
#define bFM4_FLASH_IF_FGPDM4_GPD426            *((volatile unsigned char*)(0x420023E8UL))
#define bFM4_FLASH_IF_FGPDM4_GPD427            *((volatile unsigned char*)(0x420023ECUL))
#define bFM4_FLASH_IF_FGPDM4_GPD428            *((volatile unsigned char*)(0x420023F0UL))
#define bFM4_FLASH_IF_FGPDM4_GPD429            *((volatile unsigned char*)(0x420023F4UL))
#define bFM4_FLASH_IF_FGPDM4_GPD430            *((volatile unsigned char*)(0x420023F8UL))
#define bFM4_FLASH_IF_FGPDM4_GPD431            *((volatile unsigned char*)(0x420023FCUL))

/* Dual Flash interface registers */
#define bFM4_DUALFLASH_IF_DFASZR_DASZ0         *((volatile unsigned char*)(0x42008000UL))
#define bFM4_DUALFLASH_IF_DFASZR_DASZ1         *((volatile unsigned char*)(0x42008004UL))
#define bFM4_DUALFLASH_IF_DFRWTR_DRWT0         *((volatile unsigned char*)(0x42008080UL))
#define bFM4_DUALFLASH_IF_DFRWTR_DRWT1         *((volatile unsigned char*)(0x42008084UL))
#define bFM4_DUALFLASH_IF_DFSTR_DFRDY          *((volatile unsigned char*)(0x42008100UL))
#define bFM4_DUALFLASH_IF_DFSTR_DFHNG          *((volatile unsigned char*)(0x42008104UL))
#define bFM4_DUALFLASH_IF_DFSTR_DFERR          *((volatile unsigned char*)(0x42008108UL))

/* Unique ID registers */
#define bFM4_UNIQUE_ID_UIDR0_UID0              *((volatile unsigned int*)(0x42004010UL))
#define bFM4_UNIQUE_ID_UIDR0_UID1              *((volatile unsigned int*)(0x42004014UL))
#define bFM4_UNIQUE_ID_UIDR0_UID2              *((volatile unsigned int*)(0x42004018UL))
#define bFM4_UNIQUE_ID_UIDR0_UID3              *((volatile unsigned int*)(0x4200401CUL))
#define bFM4_UNIQUE_ID_UIDR0_UID4              *((volatile unsigned int*)(0x42004020UL))
#define bFM4_UNIQUE_ID_UIDR0_UID5              *((volatile unsigned int*)(0x42004024UL))
#define bFM4_UNIQUE_ID_UIDR0_UID6              *((volatile unsigned int*)(0x42004028UL))
#define bFM4_UNIQUE_ID_UIDR0_UID7              *((volatile unsigned int*)(0x4200402CUL))
#define bFM4_UNIQUE_ID_UIDR0_UID8              *((volatile unsigned int*)(0x42004030UL))
#define bFM4_UNIQUE_ID_UIDR0_UID9              *((volatile unsigned int*)(0x42004034UL))
#define bFM4_UNIQUE_ID_UIDR0_UID10             *((volatile unsigned int*)(0x42004038UL))
#define bFM4_UNIQUE_ID_UIDR0_UID11             *((volatile unsigned int*)(0x4200403CUL))
#define bFM4_UNIQUE_ID_UIDR0_UID12             *((volatile unsigned int*)(0x42004040UL))
#define bFM4_UNIQUE_ID_UIDR0_UID13             *((volatile unsigned int*)(0x42004044UL))
#define bFM4_UNIQUE_ID_UIDR0_UID14             *((volatile unsigned int*)(0x42004048UL))
#define bFM4_UNIQUE_ID_UIDR0_UID15             *((volatile unsigned int*)(0x4200404CUL))
#define bFM4_UNIQUE_ID_UIDR0_UID16             *((volatile unsigned int*)(0x42004050UL))
#define bFM4_UNIQUE_ID_UIDR0_UID17             *((volatile unsigned int*)(0x42004054UL))
#define bFM4_UNIQUE_ID_UIDR0_UID18             *((volatile unsigned int*)(0x42004058UL))
#define bFM4_UNIQUE_ID_UIDR0_UID19             *((volatile unsigned int*)(0x4200405CUL))
#define bFM4_UNIQUE_ID_UIDR0_UID20             *((volatile unsigned int*)(0x42004060UL))
#define bFM4_UNIQUE_ID_UIDR0_UID21             *((volatile unsigned int*)(0x42004064UL))
#define bFM4_UNIQUE_ID_UIDR0_UID22             *((volatile unsigned int*)(0x42004068UL))
#define bFM4_UNIQUE_ID_UIDR0_UID23             *((volatile unsigned int*)(0x4200406CUL))
#define bFM4_UNIQUE_ID_UIDR0_UID24             *((volatile unsigned int*)(0x42004070UL))
#define bFM4_UNIQUE_ID_UIDR0_UID25             *((volatile unsigned int*)(0x42004074UL))
#define bFM4_UNIQUE_ID_UIDR0_UID26             *((volatile unsigned int*)(0x42004078UL))
#define bFM4_UNIQUE_ID_UIDR0_UID27             *((volatile unsigned int*)(0x4200407CUL))
#define bFM4_UNIQUE_ID_UIDR1_UID28             *((volatile unsigned int*)(0x42004080UL))
#define bFM4_UNIQUE_ID_UIDR1_UID29             *((volatile unsigned int*)(0x42004084UL))
#define bFM4_UNIQUE_ID_UIDR1_UID30             *((volatile unsigned int*)(0x42004088UL))
#define bFM4_UNIQUE_ID_UIDR1_UID31             *((volatile unsigned int*)(0x4200408CUL))
#define bFM4_UNIQUE_ID_UIDR1_UID32             *((volatile unsigned int*)(0x42004090UL))
#define bFM4_UNIQUE_ID_UIDR1_UID33             *((volatile unsigned int*)(0x42004094UL))
#define bFM4_UNIQUE_ID_UIDR1_UID34             *((volatile unsigned int*)(0x42004098UL))
#define bFM4_UNIQUE_ID_UIDR1_UID35             *((volatile unsigned int*)(0x4200409CUL))
#define bFM4_UNIQUE_ID_UIDR1_UID36             *((volatile unsigned int*)(0x420040A0UL))
#define bFM4_UNIQUE_ID_UIDR1_UID37             *((volatile unsigned int*)(0x420040A4UL))
#define bFM4_UNIQUE_ID_UIDR1_UID38             *((volatile unsigned int*)(0x420040A8UL))
#define bFM4_UNIQUE_ID_UIDR1_UID39             *((volatile unsigned int*)(0x420040ACUL))
#define bFM4_UNIQUE_ID_UIDR1_UID40             *((volatile unsigned int*)(0x420040B0UL))

/* ECC_CAPTURE registers */
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD0         *((volatile unsigned int*)(0x42006000UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD1         *((volatile unsigned int*)(0x42006004UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD2         *((volatile unsigned int*)(0x42006008UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD3         *((volatile unsigned int*)(0x4200600CUL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD4         *((volatile unsigned int*)(0x42006010UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD5         *((volatile unsigned int*)(0x42006014UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD6         *((volatile unsigned int*)(0x42006018UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD7         *((volatile unsigned int*)(0x4200601CUL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD8         *((volatile unsigned int*)(0x42006020UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD9         *((volatile unsigned int*)(0x42006024UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD10        *((volatile unsigned int*)(0x42006028UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD11        *((volatile unsigned int*)(0x4200602CUL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD12        *((volatile unsigned int*)(0x42006030UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD13        *((volatile unsigned int*)(0x42006034UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD14        *((volatile unsigned int*)(0x42006038UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD15        *((volatile unsigned int*)(0x4200603CUL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD16        *((volatile unsigned int*)(0x42006040UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD17        *((volatile unsigned int*)(0x42006044UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD18        *((volatile unsigned int*)(0x42006048UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD19        *((volatile unsigned int*)(0x4200604CUL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD20        *((volatile unsigned int*)(0x42006050UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD21        *((volatile unsigned int*)(0x42006054UL))
#define bFM4_ECC_CAPTURE_FERRAD_ERRAD22        *((volatile unsigned int*)(0x42006058UL))

/* Clock and reset registers */
#define bFM4_CRG_SCM_CTL_MOSCE                 *((volatile unsigned int*)(0x42200004UL))
#define bFM4_CRG_SCM_CTL_SOSCE                 *((volatile unsigned int*)(0x4220000CUL))
#define bFM4_CRG_SCM_CTL_PLLE                  *((volatile unsigned int*)(0x42200010UL))
#define bFM4_CRG_SCM_CTL_RCS0                  *((volatile unsigned int*)(0x42200014UL))
#define bFM4_CRG_SCM_CTL_RCS1                  *((volatile unsigned int*)(0x42200018UL))
#define bFM4_CRG_SCM_CTL_RCS2                  *((volatile unsigned int*)(0x4220001CUL))
#define bFM4_CRG_SCM_STR_MORDY                 *((volatile unsigned int*)(0x42200084UL))
#define bFM4_CRG_SCM_STR_SORDY                 *((volatile unsigned int*)(0x4220008CUL))
#define bFM4_CRG_SCM_STR_PLRDY                 *((volatile unsigned int*)(0x42200090UL))
#define bFM4_CRG_SCM_STR_RCM0                  *((volatile unsigned int*)(0x42200094UL))
#define bFM4_CRG_SCM_STR_RCM1                  *((volatile unsigned int*)(0x42200098UL))
#define bFM4_CRG_SCM_STR_RCM2                  *((volatile unsigned int*)(0x4220009CUL))
#define bFM4_CRG_RST_STR_PONR                  *((volatile unsigned int*)(0x42200180UL))
#define bFM4_CRG_RST_STR_INITX                 *((volatile unsigned int*)(0x42200184UL))
#define bFM4_CRG_RST_STR_SWDT                  *((volatile unsigned int*)(0x42200190UL))
#define bFM4_CRG_RST_STR_HWDT                  *((volatile unsigned int*)(0x42200194UL))
#define bFM4_CRG_RST_STR_CSVR                  *((volatile unsigned int*)(0x42200198UL))
#define bFM4_CRG_RST_STR_FCSR                  *((volatile unsigned int*)(0x4220019CUL))
#define bFM4_CRG_RST_STR_SRST                  *((volatile unsigned int*)(0x422001A0UL))
#define bFM4_CRG_BSC_PSR_BSR0                  *((volatile unsigned int*)(0x42200200UL))
#define bFM4_CRG_BSC_PSR_BSR1                  *((volatile unsigned int*)(0x42200204UL))
#define bFM4_CRG_BSC_PSR_BSR2                  *((volatile unsigned int*)(0x42200208UL))
#define bFM4_CRG_APBC0_PSR_APBC00              *((volatile unsigned int*)(0x42200280UL))
#define bFM4_CRG_APBC0_PSR_APBC01              *((volatile unsigned int*)(0x42200284UL))
#define bFM4_CRG_APBC1_PSR_APBC10              *((volatile unsigned int*)(0x42200300UL))
#define bFM4_CRG_APBC1_PSR_APBC11              *((volatile unsigned int*)(0x42200304UL))
#define bFM4_CRG_APBC1_PSR_APBC1RST            *((volatile unsigned int*)(0x42200310UL))
#define bFM4_CRG_APBC1_PSR_APBC1EN             *((volatile unsigned int*)(0x4220031CUL))
#define bFM4_CRG_APBC2_PSR_APBC20              *((volatile unsigned int*)(0x42200380UL))
#define bFM4_CRG_APBC2_PSR_APBC21              *((volatile unsigned int*)(0x42200384UL))
#define bFM4_CRG_APBC2_PSR_APBC2RST            *((volatile unsigned int*)(0x42200390UL))
#define bFM4_CRG_APBC2_PSR_APBC2EN             *((volatile unsigned int*)(0x4220039CUL))
#define bFM4_CRG_SWC_PSR_SWDS0                 *((volatile unsigned int*)(0x42200400UL))
#define bFM4_CRG_SWC_PSR_SWDS1                 *((volatile unsigned int*)(0x42200404UL))
#define bFM4_CRG_TTC_PSR_TTC0                  *((volatile unsigned int*)(0x42200500UL))
#define bFM4_CRG_TTC_PSR_TTC1                  *((volatile unsigned int*)(0x42200504UL))
#define bFM4_CRG_CSW_TMR_MOWT0                 *((volatile unsigned int*)(0x42200600UL))
#define bFM4_CRG_CSW_TMR_MOWT1                 *((volatile unsigned int*)(0x42200604UL))
#define bFM4_CRG_CSW_TMR_MOWT2                 *((volatile unsigned int*)(0x42200608UL))
#define bFM4_CRG_CSW_TMR_MOWT3                 *((volatile unsigned int*)(0x4220060CUL))
#define bFM4_CRG_CSW_TMR_SOWT0                 *((volatile unsigned int*)(0x42200610UL))
#define bFM4_CRG_CSW_TMR_SOWT1                 *((volatile unsigned int*)(0x42200614UL))
#define bFM4_CRG_CSW_TMR_SOWT2                 *((volatile unsigned int*)(0x42200618UL))
#define bFM4_CRG_CSW_TMR_SOWT3                 *((volatile unsigned int*)(0x4220061CUL))
#define bFM4_CRG_PSW_TMR_POWT0                 *((volatile unsigned int*)(0x42200680UL))
#define bFM4_CRG_PSW_TMR_POWT1                 *((volatile unsigned int*)(0x42200684UL))
#define bFM4_CRG_PSW_TMR_POWT2                 *((volatile unsigned int*)(0x42200688UL))
#define bFM4_CRG_PSW_TMR_PINC                  *((volatile unsigned int*)(0x42200690UL))
#define bFM4_CRG_PLL_CTL1_PLLM0                *((volatile unsigned int*)(0x42200700UL))
#define bFM4_CRG_PLL_CTL1_PLLM1                *((volatile unsigned int*)(0x42200704UL))
#define bFM4_CRG_PLL_CTL1_PLLM2                *((volatile unsigned int*)(0x42200708UL))
#define bFM4_CRG_PLL_CTL1_PLLM3                *((volatile unsigned int*)(0x4220070CUL))
#define bFM4_CRG_PLL_CTL1_PLLK0                *((volatile unsigned int*)(0x42200710UL))
#define bFM4_CRG_PLL_CTL1_PLLK1                *((volatile unsigned int*)(0x42200714UL))
#define bFM4_CRG_PLL_CTL1_PLLK2                *((volatile unsigned int*)(0x42200718UL))
#define bFM4_CRG_PLL_CTL1_PLLK3                *((volatile unsigned int*)(0x4220071CUL))
#define bFM4_CRG_PLL_CTL2_PLLN0                *((volatile unsigned int*)(0x42200780UL))
#define bFM4_CRG_PLL_CTL2_PLLN1                *((volatile unsigned int*)(0x42200784UL))
#define bFM4_CRG_PLL_CTL2_PLLN2                *((volatile unsigned int*)(0x42200788UL))
#define bFM4_CRG_PLL_CTL2_PLLN3                *((volatile unsigned int*)(0x4220078CUL))
#define bFM4_CRG_PLL_CTL2_PLLN4                *((volatile unsigned int*)(0x42200790UL))
#define bFM4_CRG_PLL_CTL2_PLLN5                *((volatile unsigned int*)(0x42200794UL))
#define bFM4_CRG_CSV_CTL_MCSVE                 *((volatile unsigned int*)(0x42200800UL))
#define bFM4_CRG_CSV_CTL_SCSVE                 *((volatile unsigned int*)(0x42200804UL))
#define bFM4_CRG_CSV_CTL_FCSDE                 *((volatile unsigned int*)(0x42200820UL))
#define bFM4_CRG_CSV_CTL_FCSRE                 *((volatile unsigned int*)(0x42200824UL))
#define bFM4_CRG_CSV_CTL_FCD0                  *((volatile unsigned int*)(0x42200830UL))
#define bFM4_CRG_CSV_CTL_FCD1                  *((volatile unsigned int*)(0x42200834UL))
#define bFM4_CRG_CSV_CTL_FCD2                  *((volatile unsigned int*)(0x42200838UL))
#define bFM4_CRG_CSV_STR_MCMF                  *((volatile unsigned int*)(0x42200880UL))
#define bFM4_CRG_CSV_STR_SCMF                  *((volatile unsigned int*)(0x42200884UL))
#define bFM4_CRG_DBWDT_CTL_DPSWBE              *((volatile unsigned int*)(0x42200A94UL))
#define bFM4_CRG_DBWDT_CTL_DPHWBE              *((volatile unsigned int*)(0x42200A9CUL))
#define bFM4_CRG_INT_ENR_MCSE                  *((volatile unsigned int*)(0x42200C00UL))
#define bFM4_CRG_INT_ENR_SCSE                  *((volatile unsigned int*)(0x42200C04UL))
#define bFM4_CRG_INT_ENR_PCSE                  *((volatile unsigned int*)(0x42200C08UL))
#define bFM4_CRG_INT_ENR_FCSE                  *((volatile unsigned int*)(0x42200C14UL))
#define bFM4_CRG_INT_STR_MCSI                  *((volatile unsigned int*)(0x42200C80UL))
#define bFM4_CRG_INT_STR_SCSI                  *((volatile unsigned int*)(0x42200C84UL))
#define bFM4_CRG_INT_STR_PCSI                  *((volatile unsigned int*)(0x42200C88UL))
#define bFM4_CRG_INT_STR_FCSI                  *((volatile unsigned int*)(0x42200C94UL))
#define bFM4_CRG_INT_CLR_MCSC                  *((volatile unsigned int*)(0x42200D00UL))
#define bFM4_CRG_INT_CLR_SCSC                  *((volatile unsigned int*)(0x42200D04UL))
#define bFM4_CRG_INT_CLR_PCSC                  *((volatile unsigned int*)(0x42200D08UL))
#define bFM4_CRG_INT_CLR_FCSC                  *((volatile unsigned int*)(0x42200D14UL))

/* Hardware watchdog registers */
#define bFM4_HWWDT_WDG_CTL_INTEN               *((volatile unsigned int*)(0x42220100UL))
#define bFM4_HWWDT_WDG_CTL_RESEN               *((volatile unsigned int*)(0x42220104UL))
#define bFM4_HWWDT_WDG_RIS_RIS                 *((volatile unsigned int*)(0x42220200UL))

/* Software watchdog registers */
#define bFM4_SWWDT_WDOGCONTROL_INTEN           *((volatile unsigned int*)(0x42240100UL))
#define bFM4_SWWDT_WDOGCONTROL_RESEN           *((volatile unsigned int*)(0x42240104UL))
#define bFM4_SWWDT_WDOGCONTROL_TWD0            *((volatile unsigned int*)(0x42240108UL))
#define bFM4_SWWDT_WDOGCONTROL_TWD1            *((volatile unsigned int*)(0x4224010CUL))
#define bFM4_SWWDT_WDOGCONTROL_SPM             *((volatile unsigned int*)(0x42240110UL))
#define bFM4_SWWDT_WDOGRIS_RIS                 *((volatile unsigned int*)(0x42240200UL))
#define bFM4_SWWDT_WDOGSPMC_TGR                *((volatile unsigned int*)(0x42240300UL))

/* Dual timer 1/2 registers */
#define bFM4_DTIM_TIMER1CONTROL_ONESHOT        *((volatile unsigned int*)(0x422A0100UL))
#define bFM4_DTIM_TIMER1CONTROL_TIMERSIZE      *((volatile unsigned int*)(0x422A0104UL))
#define bFM4_DTIM_TIMER1CONTROL_TIMERPRE0      *((volatile unsigned int*)(0x422A0108UL))
#define bFM4_DTIM_TIMER1CONTROL_TIMERPRE1      *((volatile unsigned int*)(0x422A010CUL))
#define bFM4_DTIM_TIMER1CONTROL_INTENABLE      *((volatile unsigned int*)(0x422A0114UL))
#define bFM4_DTIM_TIMER1CONTROL_TIMERMODE      *((volatile unsigned int*)(0x422A0118UL))
#define bFM4_DTIM_TIMER1CONTROL_TIMEREN        *((volatile unsigned int*)(0x422A011CUL))
#define bFM4_DTIM_TIMER1RIS_TIMERXRIS          *((volatile unsigned int*)(0x422A0200UL))
#define bFM4_DTIM_TIMER1MIS_TIMERXRIS          *((volatile unsigned int*)(0x422A0280UL))
#define bFM4_DTIM_TIMER2CONTROL_ONESHOT        *((volatile unsigned int*)(0x422A0500UL))
#define bFM4_DTIM_TIMER2CONTROL_TIMERSIZE      *((volatile unsigned int*)(0x422A0504UL))
#define bFM4_DTIM_TIMER2CONTROL_TIMERPRE0      *((volatile unsigned int*)(0x422A0508UL))
#define bFM4_DTIM_TIMER2CONTROL_TIMERPRE1      *((volatile unsigned int*)(0x422A050CUL))
#define bFM4_DTIM_TIMER2CONTROL_INTENABLE      *((volatile unsigned int*)(0x422A0514UL))
#define bFM4_DTIM_TIMER2CONTROL_TIMERMODE      *((volatile unsigned int*)(0x422A0518UL))
#define bFM4_DTIM_TIMER2CONTROL_TIMEREN        *((volatile unsigned int*)(0x422A051CUL))
#define bFM4_DTIM_TIMER2RIS_TIMERXRIS          *((volatile unsigned int*)(0x422A0600UL))
#define bFM4_DTIM_TIMER2MIS_TIMERXRIS          *((volatile unsigned int*)(0x422A0680UL))

/* Multifunction Timer unit 0 Free Running Timer registers */
#define bFM4_MFT0_FRT_TCSA0_CLK0               *((volatile unsigned char*)(0x42402900UL))
#define bFM4_MFT0_FRT_TCSA0_CLK1               *((volatile unsigned char*)(0x42402904UL))
#define bFM4_MFT0_FRT_TCSA0_CLK2               *((volatile unsigned char*)(0x42402908UL))
#define bFM4_MFT0_FRT_TCSA0_CLK3               *((volatile unsigned char*)(0x4240290CUL))
#define bFM4_MFT0_FRT_TCSA0_SCLR               *((volatile unsigned char*)(0x42402910UL))
#define bFM4_MFT0_FRT_TCSA0_MODE               *((volatile unsigned char*)(0x42402914UL))
#define bFM4_MFT0_FRT_TCSA0_STOP               *((volatile unsigned char*)(0x42402918UL))
#define bFM4_MFT0_FRT_TCSA0_BFE                *((volatile unsigned char*)(0x4240291CUL))
#define bFM4_MFT0_FRT_TCSA0_ICRE               *((volatile unsigned char*)(0x42402920UL))
#define bFM4_MFT0_FRT_TCSA0_ICLR               *((volatile unsigned char*)(0x42402924UL))
#define bFM4_MFT0_FRT_TCSA0_IRQZE              *((volatile unsigned char*)(0x42402934UL))
#define bFM4_MFT0_FRT_TCSA0_IRQZF              *((volatile unsigned char*)(0x42402938UL))
#define bFM4_MFT0_FRT_TCSA0_ECKE               *((volatile unsigned char*)(0x4240293CUL))
#define bFM4_MFT0_FRT_TCSC0_MSZI0              *((volatile unsigned char*)(0x42402940UL))
#define bFM4_MFT0_FRT_TCSC0_MSZI1              *((volatile unsigned char*)(0x42402944UL))
#define bFM4_MFT0_FRT_TCSC0_MSZI2              *((volatile unsigned char*)(0x42402948UL))
#define bFM4_MFT0_FRT_TCSC0_MSZI3              *((volatile unsigned char*)(0x4240294CUL))
#define bFM4_MFT0_FRT_TCSC0_MSPI0              *((volatile unsigned char*)(0x42402950UL))
#define bFM4_MFT0_FRT_TCSC0_MSPI1              *((volatile unsigned char*)(0x42402954UL))
#define bFM4_MFT0_FRT_TCSC0_MSPI2              *((volatile unsigned char*)(0x42402958UL))
#define bFM4_MFT0_FRT_TCSC0_MSPI3              *((volatile unsigned char*)(0x4240295CUL))
#define bFM4_MFT0_FRT_TCSC0_MSZC0              *((volatile unsigned char*)(0x42402960UL))
#define bFM4_MFT0_FRT_TCSC0_MSZC1              *((volatile unsigned char*)(0x42402964UL))
#define bFM4_MFT0_FRT_TCSC0_MSZC2              *((volatile unsigned char*)(0x42402968UL))
#define bFM4_MFT0_FRT_TCSC0_MSZC3              *((volatile unsigned char*)(0x4240296CUL))
#define bFM4_MFT0_FRT_TCSC0_MSPC0              *((volatile unsigned char*)(0x42402970UL))
#define bFM4_MFT0_FRT_TCSC0_MSPC1              *((volatile unsigned char*)(0x42402974UL))
#define bFM4_MFT0_FRT_TCSC0_MSPC2              *((volatile unsigned char*)(0x42402978UL))
#define bFM4_MFT0_FRT_TCSC0_MSPC3              *((volatile unsigned char*)(0x4240297CUL))
#define bFM4_MFT0_FRT_TCSA1_CLK0               *((volatile unsigned char*)(0x42402A80UL))
#define bFM4_MFT0_FRT_TCSA1_CLK1               *((volatile unsigned char*)(0x42402A84UL))
#define bFM4_MFT0_FRT_TCSA1_CLK2               *((volatile unsigned char*)(0x42402A88UL))
#define bFM4_MFT0_FRT_TCSA1_CLK3               *((volatile unsigned char*)(0x42402A8CUL))
#define bFM4_MFT0_FRT_TCSA1_SCLR               *((volatile unsigned char*)(0x42402A90UL))
#define bFM4_MFT0_FRT_TCSA1_MODE               *((volatile unsigned char*)(0x42402A94UL))
#define bFM4_MFT0_FRT_TCSA1_STOP               *((volatile unsigned char*)(0x42402A98UL))
#define bFM4_MFT0_FRT_TCSA1_BFE                *((volatile unsigned char*)(0x42402A9CUL))
#define bFM4_MFT0_FRT_TCSA1_ICRE               *((volatile unsigned char*)(0x42402AA0UL))
#define bFM4_MFT0_FRT_TCSA1_ICLR               *((volatile unsigned char*)(0x42402AA4UL))
#define bFM4_MFT0_FRT_TCSA1_IRQZE              *((volatile unsigned char*)(0x42402AB4UL))
#define bFM4_MFT0_FRT_TCSA1_IRQZF              *((volatile unsigned char*)(0x42402AB8UL))
#define bFM4_MFT0_FRT_TCSA1_ECKE               *((volatile unsigned char*)(0x42402ABCUL))
#define bFM4_MFT0_FRT_TCSC1_MSZI0              *((volatile unsigned char*)(0x42402AC0UL))
#define bFM4_MFT0_FRT_TCSC1_MSZI1              *((volatile unsigned char*)(0x42402AC4UL))
#define bFM4_MFT0_FRT_TCSC1_MSZI2              *((volatile unsigned char*)(0x42402AC8UL))
#define bFM4_MFT0_FRT_TCSC1_MSZI3              *((volatile unsigned char*)(0x42402ACCUL))
#define bFM4_MFT0_FRT_TCSC1_MSPI0              *((volatile unsigned char*)(0x42402AD0UL))
#define bFM4_MFT0_FRT_TCSC1_MSPI1              *((volatile unsigned char*)(0x42402AD4UL))
#define bFM4_MFT0_FRT_TCSC1_MSPI2              *((volatile unsigned char*)(0x42402AD8UL))
#define bFM4_MFT0_FRT_TCSC1_MSPI3              *((volatile unsigned char*)(0x42402ADCUL))
#define bFM4_MFT0_FRT_TCSC1_MSZC0              *((volatile unsigned char*)(0x42402AE0UL))
#define bFM4_MFT0_FRT_TCSC1_MSZC1              *((volatile unsigned char*)(0x42402AE4UL))
#define bFM4_MFT0_FRT_TCSC1_MSZC2              *((volatile unsigned char*)(0x42402AE8UL))
#define bFM4_MFT0_FRT_TCSC1_MSZC3              *((volatile unsigned char*)(0x42402AECUL))
#define bFM4_MFT0_FRT_TCSC1_MSPC0              *((volatile unsigned char*)(0x42402AF0UL))
#define bFM4_MFT0_FRT_TCSC1_MSPC1              *((volatile unsigned char*)(0x42402AF4UL))
#define bFM4_MFT0_FRT_TCSC1_MSPC2              *((volatile unsigned char*)(0x42402AF8UL))
#define bFM4_MFT0_FRT_TCSC1_MSPC3              *((volatile unsigned char*)(0x42402AFCUL))
#define bFM4_MFT0_FRT_TCSA2_CLK0               *((volatile unsigned char*)(0x42402C00UL))
#define bFM4_MFT0_FRT_TCSA2_CLK1               *((volatile unsigned char*)(0x42402C04UL))
#define bFM4_MFT0_FRT_TCSA2_CLK2               *((volatile unsigned char*)(0x42402C08UL))
#define bFM4_MFT0_FRT_TCSA2_CLK3               *((volatile unsigned char*)(0x42402C0CUL))
#define bFM4_MFT0_FRT_TCSA2_SCLR               *((volatile unsigned char*)(0x42402C10UL))
#define bFM4_MFT0_FRT_TCSA2_MODE               *((volatile unsigned char*)(0x42402C14UL))
#define bFM4_MFT0_FRT_TCSA2_STOP               *((volatile unsigned char*)(0x42402C18UL))
#define bFM4_MFT0_FRT_TCSA2_BFE                *((volatile unsigned char*)(0x42402C1CUL))
#define bFM4_MFT0_FRT_TCSA2_ICRE               *((volatile unsigned char*)(0x42402C20UL))
#define bFM4_MFT0_FRT_TCSA2_ICLR               *((volatile unsigned char*)(0x42402C24UL))
#define bFM4_MFT0_FRT_TCSA2_IRQZE              *((volatile unsigned char*)(0x42402C34UL))
#define bFM4_MFT0_FRT_TCSA2_IRQZF              *((volatile unsigned char*)(0x42402C38UL))
#define bFM4_MFT0_FRT_TCSA2_ECKE               *((volatile unsigned char*)(0x42402C3CUL))
#define bFM4_MFT0_FRT_TCSC2_MSZI0              *((volatile unsigned char*)(0x42402C40UL))
#define bFM4_MFT0_FRT_TCSC2_MSZI1              *((volatile unsigned char*)(0x42402C44UL))
#define bFM4_MFT0_FRT_TCSC2_MSZI2              *((volatile unsigned char*)(0x42402C48UL))
#define bFM4_MFT0_FRT_TCSC2_MSZI3              *((volatile unsigned char*)(0x42402C4CUL))
#define bFM4_MFT0_FRT_TCSC2_MSPI0              *((volatile unsigned char*)(0x42402C50UL))
#define bFM4_MFT0_FRT_TCSC2_MSPI1              *((volatile unsigned char*)(0x42402C54UL))
#define bFM4_MFT0_FRT_TCSC2_MSPI2              *((volatile unsigned char*)(0x42402C58UL))
#define bFM4_MFT0_FRT_TCSC2_MSPI3              *((volatile unsigned char*)(0x42402C5CUL))
#define bFM4_MFT0_FRT_TCSC2_MSZC0              *((volatile unsigned char*)(0x42402C60UL))
#define bFM4_MFT0_FRT_TCSC2_MSZC1              *((volatile unsigned char*)(0x42402C64UL))
#define bFM4_MFT0_FRT_TCSC2_MSZC2              *((volatile unsigned char*)(0x42402C68UL))
#define bFM4_MFT0_FRT_TCSC2_MSZC3              *((volatile unsigned char*)(0x42402C6CUL))
#define bFM4_MFT0_FRT_TCSC2_MSPC0              *((volatile unsigned char*)(0x42402C70UL))
#define bFM4_MFT0_FRT_TCSC2_MSPC1              *((volatile unsigned char*)(0x42402C74UL))
#define bFM4_MFT0_FRT_TCSC2_MSPC2              *((volatile unsigned char*)(0x42402C78UL))
#define bFM4_MFT0_FRT_TCSC2_MSPC3              *((volatile unsigned char*)(0x42402C7CUL))
#define bFM4_MFT0_FRT_TCAL_STOP00              *((volatile unsigned char*)(0x42402C80UL))
#define bFM4_MFT0_FRT_TCAL_STOP01              *((volatile unsigned char*)(0x42402C84UL))
#define bFM4_MFT0_FRT_TCAL_STOP02              *((volatile unsigned char*)(0x42402C88UL))
#define bFM4_MFT0_FRT_TCAL_STOP10              *((volatile unsigned char*)(0x42402C8CUL))
#define bFM4_MFT0_FRT_TCAL_STOP11              *((volatile unsigned char*)(0x42402C90UL))
#define bFM4_MFT0_FRT_TCAL_STOP12              *((volatile unsigned char*)(0x42402C94UL))
#define bFM4_MFT0_FRT_TCAL_STOP20              *((volatile unsigned char*)(0x42402C98UL))
#define bFM4_MFT0_FRT_TCAL_STOP21              *((volatile unsigned char*)(0x42402C9CUL))
#define bFM4_MFT0_FRT_TCAL_STOP22              *((volatile unsigned char*)(0x42402CA0UL))
#define bFM4_MFT0_FRT_TCAL_SCLR00              *((volatile unsigned char*)(0x42402CC0UL))
#define bFM4_MFT0_FRT_TCAL_SCLR01              *((volatile unsigned char*)(0x42402CC4UL))
#define bFM4_MFT0_FRT_TCAL_SCLR02              *((volatile unsigned char*)(0x42402CC8UL))
#define bFM4_MFT0_FRT_TCAL_SCLR10              *((volatile unsigned char*)(0x42402CCCUL))
#define bFM4_MFT0_FRT_TCAL_SCLR11              *((volatile unsigned char*)(0x42402CD0UL))
#define bFM4_MFT0_FRT_TCAL_SCLR12              *((volatile unsigned char*)(0x42402CD4UL))
#define bFM4_MFT0_FRT_TCAL_SCLR20              *((volatile unsigned char*)(0x42402CD8UL))
#define bFM4_MFT0_FRT_TCAL_SCLR21              *((volatile unsigned char*)(0x42402CDCUL))
#define bFM4_MFT0_FRT_TCAL_SCLR22              *((volatile unsigned char*)(0x42402CE0UL))
#define bFM4_MFT0_FRT_TCSD_OFMD1               *((volatile unsigned char*)(0x42403D80UL))
#define bFM4_MFT0_FRT_TCSD_OFMD2               *((volatile unsigned char*)(0x42403D84UL))

/* Multifunction Timer unit 0 Output Compare Unit registers */
#define bFM4_MFT0_OCU_OCSA10_CST0              *((volatile unsigned char*)(0x42402300UL))
#define bFM4_MFT0_OCU_OCSA10_CST1              *((volatile unsigned char*)(0x42402304UL))
#define bFM4_MFT0_OCU_OCSA10_IOE0              *((volatile unsigned char*)(0x42402310UL))
#define bFM4_MFT0_OCU_OCSA10_IOE1              *((volatile unsigned char*)(0x42402314UL))
#define bFM4_MFT0_OCU_OCSA10_IOP0              *((volatile unsigned char*)(0x42402318UL))
#define bFM4_MFT0_OCU_OCSA10_IOP1              *((volatile unsigned char*)(0x4240231CUL))
#define bFM4_MFT0_OCU_OCSB10_OTD0              *((volatile unsigned char*)(0x42402320UL))
#define bFM4_MFT0_OCU_OCSB10_OTD1              *((volatile unsigned char*)(0x42402324UL))
#define bFM4_MFT0_OCU_OCSB10_CMOD              *((volatile unsigned char*)(0x42402330UL))
#define bFM4_MFT0_OCU_OCSB10_FM4               *((volatile unsigned char*)(0x4240233CUL))
#define bFM4_MFT0_OCU_OCSD10_OCCP0BUFE0        *((volatile unsigned char*)(0x42402340UL))
#define bFM4_MFT0_OCU_OCSD10_OCCP0BUFE1        *((volatile unsigned char*)(0x42402344UL))
#define bFM4_MFT0_OCU_OCSD10_OCCP1BUFE0        *((volatile unsigned char*)(0x42402348UL))
#define bFM4_MFT0_OCU_OCSD10_OCCP1BUFE1        *((volatile unsigned char*)(0x4240234CUL))
#define bFM4_MFT0_OCU_OCSD10_OCSE0BUFE0        *((volatile unsigned char*)(0x42402350UL))
#define bFM4_MFT0_OCU_OCSD10_OCSE0BUFE1        *((volatile unsigned char*)(0x42402354UL))
#define bFM4_MFT0_OCU_OCSD10_OCSE1BUFE0        *((volatile unsigned char*)(0x42402358UL))
#define bFM4_MFT0_OCU_OCSD10_OCSE1BUFE1        *((volatile unsigned char*)(0x4240235CUL))
#define bFM4_MFT0_OCU_OCSD10_OPBM0             *((volatile unsigned char*)(0x42402360UL))
#define bFM4_MFT0_OCU_OCSD10_OPBM1             *((volatile unsigned char*)(0x42402364UL))
#define bFM4_MFT0_OCU_OCSD10_OEBM0             *((volatile unsigned char*)(0x42402368UL))
#define bFM4_MFT0_OCU_OCSD10_OEBM1             *((volatile unsigned char*)(0x4240236CUL))
#define bFM4_MFT0_OCU_OCSD10_OFEX0             *((volatile unsigned char*)(0x42402370UL))
#define bFM4_MFT0_OCU_OCSD10_OFEX1             *((volatile unsigned char*)(0x42402374UL))
#define bFM4_MFT0_OCU_OCSA32_CST0              *((volatile unsigned char*)(0x42402380UL))
#define bFM4_MFT0_OCU_OCSA32_CST1              *((volatile unsigned char*)(0x42402384UL))
#define bFM4_MFT0_OCU_OCSA32_IOE0              *((volatile unsigned char*)(0x42402390UL))
#define bFM4_MFT0_OCU_OCSA32_IOE1              *((volatile unsigned char*)(0x42402394UL))
#define bFM4_MFT0_OCU_OCSA32_IOP0              *((volatile unsigned char*)(0x42402398UL))
#define bFM4_MFT0_OCU_OCSA32_IOP1              *((volatile unsigned char*)(0x4240239CUL))
#define bFM4_MFT0_OCU_OCSB32_OTD0              *((volatile unsigned char*)(0x424023A0UL))
#define bFM4_MFT0_OCU_OCSB32_OTD1              *((volatile unsigned char*)(0x424023A4UL))
#define bFM4_MFT0_OCU_OCSB32_CMOD              *((volatile unsigned char*)(0x424023B0UL))
#define bFM4_MFT0_OCU_OCSB32_FM4               *((volatile unsigned char*)(0x424023BCUL))
#define bFM4_MFT0_OCU_OCSD32_OCCP2BUFE0        *((volatile unsigned char*)(0x424023C0UL))
#define bFM4_MFT0_OCU_OCSD32_OCCP2BUFE1        *((volatile unsigned char*)(0x424023C4UL))
#define bFM4_MFT0_OCU_OCSD32_OCCP3BUFE0        *((volatile unsigned char*)(0x424023C8UL))
#define bFM4_MFT0_OCU_OCSD32_OCCP3BUFE1        *((volatile unsigned char*)(0x424023CCUL))
#define bFM4_MFT0_OCU_OCSD32_OCSE2BUFE0        *((volatile unsigned char*)(0x424023D0UL))
#define bFM4_MFT0_OCU_OCSD32_OCSE2BUFE1        *((volatile unsigned char*)(0x424023D4UL))
#define bFM4_MFT0_OCU_OCSD32_OCSE3BUFE0        *((volatile unsigned char*)(0x424023D8UL))
#define bFM4_MFT0_OCU_OCSD32_OCSE3BUFE1        *((volatile unsigned char*)(0x424023DCUL))
#define bFM4_MFT0_OCU_OCSD32_OPBM2             *((volatile unsigned char*)(0x424023E0UL))
#define bFM4_MFT0_OCU_OCSD32_OPBM3             *((volatile unsigned char*)(0x424023E4UL))
#define bFM4_MFT0_OCU_OCSD32_OEBM2             *((volatile unsigned char*)(0x424023E8UL))
#define bFM4_MFT0_OCU_OCSD32_OEBM3             *((volatile unsigned char*)(0x424023ECUL))
#define bFM4_MFT0_OCU_OCSD32_OFEX2             *((volatile unsigned char*)(0x424023F0UL))
#define bFM4_MFT0_OCU_OCSD32_OFEX3             *((volatile unsigned char*)(0x424023F4UL))
#define bFM4_MFT0_OCU_OCSA54_CST0              *((volatile unsigned char*)(0x42402400UL))
#define bFM4_MFT0_OCU_OCSA54_CST1              *((volatile unsigned char*)(0x42402404UL))
#define bFM4_MFT0_OCU_OCSA54_IOE0              *((volatile unsigned char*)(0x42402410UL))
#define bFM4_MFT0_OCU_OCSA54_IOE1              *((volatile unsigned char*)(0x42402414UL))
#define bFM4_MFT0_OCU_OCSA54_IOP0              *((volatile unsigned char*)(0x42402418UL))
#define bFM4_MFT0_OCU_OCSA54_IOP1              *((volatile unsigned char*)(0x4240241CUL))
#define bFM4_MFT0_OCU_OCSB54_OTD0              *((volatile unsigned char*)(0x42402420UL))
#define bFM4_MFT0_OCU_OCSB54_OTD1              *((volatile unsigned char*)(0x42402424UL))
#define bFM4_MFT0_OCU_OCSB54_CMOD              *((volatile unsigned char*)(0x42402430UL))
#define bFM4_MFT0_OCU_OCSB54_FM4               *((volatile unsigned char*)(0x4240243CUL))
#define bFM4_MFT0_OCU_OCSD54_OCCP4BUFE0        *((volatile unsigned char*)(0x42402440UL))
#define bFM4_MFT0_OCU_OCSD54_OCCP4BUFE1        *((volatile unsigned char*)(0x42402444UL))
#define bFM4_MFT0_OCU_OCSD54_OCCP5BUFE0        *((volatile unsigned char*)(0x42402448UL))
#define bFM4_MFT0_OCU_OCSD54_OCCP5BUFE1        *((volatile unsigned char*)(0x4240244CUL))
#define bFM4_MFT0_OCU_OCSD54_OCSE4BUFE0        *((volatile unsigned char*)(0x42402450UL))
#define bFM4_MFT0_OCU_OCSD54_OCSE4BUFE1        *((volatile unsigned char*)(0x42402454UL))
#define bFM4_MFT0_OCU_OCSD54_OCSE5BUFE0        *((volatile unsigned char*)(0x42402458UL))
#define bFM4_MFT0_OCU_OCSD54_OCSE5BUFE1        *((volatile unsigned char*)(0x4240245CUL))
#define bFM4_MFT0_OCU_OCSD54_OPBM4             *((volatile unsigned char*)(0x42402460UL))
#define bFM4_MFT0_OCU_OCSD54_OPBM5             *((volatile unsigned char*)(0x42402464UL))
#define bFM4_MFT0_OCU_OCSD54_OEBM4             *((volatile unsigned char*)(0x42402468UL))
#define bFM4_MFT0_OCU_OCSD54_OEBM5             *((volatile unsigned char*)(0x4240246CUL))
#define bFM4_MFT0_OCU_OCSD54_OFEX4             *((volatile unsigned char*)(0x42402470UL))
#define bFM4_MFT0_OCU_OCSD54_OFEX5             *((volatile unsigned char*)(0x42402474UL))
#define bFM4_MFT0_OCU_OCSC_MOD0                *((volatile unsigned char*)(0x424024A0UL))
#define bFM4_MFT0_OCU_OCSC_MOD1                *((volatile unsigned char*)(0x424024A4UL))
#define bFM4_MFT0_OCU_OCSC_MOD2                *((volatile unsigned char*)(0x424024A8UL))
#define bFM4_MFT0_OCU_OCSC_MOD3                *((volatile unsigned char*)(0x424024ACUL))
#define bFM4_MFT0_OCU_OCSC_MOD4                *((volatile unsigned char*)(0x424024B0UL))
#define bFM4_MFT0_OCU_OCSC_MOD5                *((volatile unsigned char*)(0x424024B4UL))
#define bFM4_MFT0_OCU_OCFS10_FSO00             *((volatile unsigned char*)(0x42402D00UL))
#define bFM4_MFT0_OCU_OCFS10_FSO01             *((volatile unsigned char*)(0x42402D04UL))
#define bFM4_MFT0_OCU_OCFS10_FSO02             *((volatile unsigned char*)(0x42402D08UL))
#define bFM4_MFT0_OCU_OCFS10_FSO03             *((volatile unsigned char*)(0x42402D0CUL))
#define bFM4_MFT0_OCU_OCFS10_FSO10             *((volatile unsigned char*)(0x42402D10UL))
#define bFM4_MFT0_OCU_OCFS10_FSO11             *((volatile unsigned char*)(0x42402D14UL))
#define bFM4_MFT0_OCU_OCFS10_FSO12             *((volatile unsigned char*)(0x42402D18UL))
#define bFM4_MFT0_OCU_OCFS10_FSO13             *((volatile unsigned char*)(0x42402D1CUL))
#define bFM4_MFT0_OCU_OCFS32_FSO00             *((volatile unsigned char*)(0x42402D20UL))
#define bFM4_MFT0_OCU_OCFS32_FSO01             *((volatile unsigned char*)(0x42402D24UL))
#define bFM4_MFT0_OCU_OCFS32_FSO02             *((volatile unsigned char*)(0x42402D28UL))
#define bFM4_MFT0_OCU_OCFS32_FSO03             *((volatile unsigned char*)(0x42402D2CUL))
#define bFM4_MFT0_OCU_OCFS32_FSO10             *((volatile unsigned char*)(0x42402D30UL))
#define bFM4_MFT0_OCU_OCFS32_FSO11             *((volatile unsigned char*)(0x42402D34UL))
#define bFM4_MFT0_OCU_OCFS32_FSO12             *((volatile unsigned char*)(0x42402D38UL))
#define bFM4_MFT0_OCU_OCFS32_FSO13             *((volatile unsigned char*)(0x42402D3CUL))
#define bFM4_MFT0_OCU_OCFS54_FSO00             *((volatile unsigned char*)(0x42402D40UL))
#define bFM4_MFT0_OCU_OCFS54_FSO01             *((volatile unsigned char*)(0x42402D44UL))
#define bFM4_MFT0_OCU_OCFS54_FSO02             *((volatile unsigned char*)(0x42402D48UL))
#define bFM4_MFT0_OCU_OCFS54_FSO03             *((volatile unsigned char*)(0x42402D4CUL))
#define bFM4_MFT0_OCU_OCFS54_FSO10             *((volatile unsigned char*)(0x42402D50UL))
#define bFM4_MFT0_OCU_OCFS54_FSO11             *((volatile unsigned char*)(0x42402D54UL))
#define bFM4_MFT0_OCU_OCFS54_FSO12             *((volatile unsigned char*)(0x42402D58UL))
#define bFM4_MFT0_OCU_OCFS54_FSO13             *((volatile unsigned char*)(0x42402D5CUL))

/* Multifunction Timer unit 0 Waveform Generator and Noise Canceler registers */
#define bFM4_MFT0_WFG_WFSA10_DCK0              *((volatile unsigned char*)(0x42403480UL))
#define bFM4_MFT0_WFG_WFSA10_DCK1              *((volatile unsigned char*)(0x42403484UL))
#define bFM4_MFT0_WFG_WFSA10_DCK2              *((volatile unsigned char*)(0x42403488UL))
#define bFM4_MFT0_WFG_WFSA10_GTEN0             *((volatile unsigned char*)(0x42403498UL))
#define bFM4_MFT0_WFG_WFSA10_GTEN1             *((volatile unsigned char*)(0x4240349CUL))
#define bFM4_MFT0_WFG_WFSA10_PSEL0             *((volatile unsigned char*)(0x424034A0UL))
#define bFM4_MFT0_WFG_WFSA10_PSEL1             *((volatile unsigned char*)(0x424034A4UL))
#define bFM4_MFT0_WFG_WFSA10_PGEN0             *((volatile unsigned char*)(0x424034A8UL))
#define bFM4_MFT0_WFG_WFSA10_PGEN1             *((volatile unsigned char*)(0x424034ACUL))
#define bFM4_MFT0_WFG_WFSA32_DCK0              *((volatile unsigned char*)(0x42403500UL))
#define bFM4_MFT0_WFG_WFSA32_DCK1              *((volatile unsigned char*)(0x42403504UL))
#define bFM4_MFT0_WFG_WFSA32_DCK2              *((volatile unsigned char*)(0x42403508UL))
#define bFM4_MFT0_WFG_WFSA32_GTEN0             *((volatile unsigned char*)(0x42403518UL))
#define bFM4_MFT0_WFG_WFSA32_GTEN1             *((volatile unsigned char*)(0x4240351CUL))
#define bFM4_MFT0_WFG_WFSA32_PSEL0             *((volatile unsigned char*)(0x42403520UL))
#define bFM4_MFT0_WFG_WFSA32_PSEL1             *((volatile unsigned char*)(0x42403524UL))
#define bFM4_MFT0_WFG_WFSA32_PGEN0             *((volatile unsigned char*)(0x42403528UL))
#define bFM4_MFT0_WFG_WFSA32_PGEN1             *((volatile unsigned char*)(0x4240352CUL))
#define bFM4_MFT0_WFG_WFSA54_DCK0              *((volatile unsigned char*)(0x42403580UL))
#define bFM4_MFT0_WFG_WFSA54_DCK1              *((volatile unsigned char*)(0x42403584UL))
#define bFM4_MFT0_WFG_WFSA54_DCK2              *((volatile unsigned char*)(0x42403588UL))
#define bFM4_MFT0_WFG_WFSA54_GTEN0             *((volatile unsigned char*)(0x42403598UL))
#define bFM4_MFT0_WFG_WFSA54_GTEN1             *((volatile unsigned char*)(0x4240359CUL))
#define bFM4_MFT0_WFG_WFSA54_PSEL0             *((volatile unsigned char*)(0x424035A0UL))
#define bFM4_MFT0_WFG_WFSA54_PSEL1             *((volatile unsigned char*)(0x424035A4UL))
#define bFM4_MFT0_WFG_WFSA54_PGEN0             *((volatile unsigned char*)(0x424035A8UL))
#define bFM4_MFT0_WFG_WFSA54_PGEN1             *((volatile unsigned char*)(0x424035ACUL))
#define bFM4_MFT0_WFG_WFIR_DTIFA               *((volatile unsigned char*)(0x42403600UL))
#define bFM4_MFT0_WFG_WFIR_DTICA               *((volatile unsigned char*)(0x42403604UL))
#define bFM4_MFT0_WFG_WFIR_DTIFB               *((volatile unsigned char*)(0x42403608UL))
#define bFM4_MFT0_WFG_WFIR_DTICB               *((volatile unsigned char*)(0x4240360CUL))
#define bFM4_MFT0_WFG_WFIR_TMIF10              *((volatile unsigned char*)(0x42403610UL))
#define bFM4_MFT0_WFG_WFIR_TMIC10              *((volatile unsigned char*)(0x42403614UL))
#define bFM4_MFT0_WFG_WFIR_TMIE10              *((volatile unsigned char*)(0x42403618UL))
#define bFM4_MFT0_WFG_WFIR_TMIS10              *((volatile unsigned char*)(0x4240361CUL))
#define bFM4_MFT0_WFG_WFIR_TMIF32              *((volatile unsigned char*)(0x42403620UL))
#define bFM4_MFT0_WFG_WFIR_TMIC32              *((volatile unsigned char*)(0x42403624UL))
#define bFM4_MFT0_WFG_WFIR_TMIE32              *((volatile unsigned char*)(0x42403628UL))
#define bFM4_MFT0_WFG_WFIR_TMIS32              *((volatile unsigned char*)(0x4240362CUL))
#define bFM4_MFT0_WFG_WFIR_TMIF54              *((volatile unsigned char*)(0x42403630UL))
#define bFM4_MFT0_WFG_WFIR_TMIC54              *((volatile unsigned char*)(0x42403634UL))
#define bFM4_MFT0_WFG_WFIR_TMIE54              *((volatile unsigned char*)(0x42403638UL))
#define bFM4_MFT0_WFG_WFIR_TMIS54              *((volatile unsigned char*)(0x4240363CUL))
#define bFM4_MFT0_WFG_NZCL_DTIEA               *((volatile unsigned char*)(0x42403680UL))
#define bFM4_MFT0_WFG_NZCL_NWS0                *((volatile unsigned char*)(0x42403684UL))
#define bFM4_MFT0_WFG_NZCL_NWS1                *((volatile unsigned char*)(0x42403688UL))
#define bFM4_MFT0_WFG_NZCL_NWS2                *((volatile unsigned char*)(0x4240368CUL))
#define bFM4_MFT0_WFG_NZCL_SDTI                *((volatile unsigned char*)(0x42403690UL))
#define bFM4_MFT0_WFG_NZCL_DTIEB               *((volatile unsigned char*)(0x42403694UL))
#define bFM4_MFT0_WFG_NZCL_DHOLD               *((volatile unsigned char*)(0x4240369CUL))
#define bFM4_MFT0_WFG_NZCL_DIMA                *((volatile unsigned char*)(0x424036A0UL))
#define bFM4_MFT0_WFG_NZCL_DIMB                *((volatile unsigned char*)(0x424036A4UL))
#define bFM4_MFT0_WFG_NZCL_WIM10               *((volatile unsigned char*)(0x424036B0UL))
#define bFM4_MFT0_WFG_NZCL_WIM32               *((volatile unsigned char*)(0x424036B4UL))
#define bFM4_MFT0_WFG_NZCL_WIM54               *((volatile unsigned char*)(0x424036B8UL))

/* Multifunction Timer unit 0 Input Capture Unit registers */
#define bFM4_MFT0_ICU_ICFS10_FSI00             *((volatile unsigned char*)(0x42402D80UL))
#define bFM4_MFT0_ICU_ICFS10_FSI01             *((volatile unsigned char*)(0x42402D84UL))
#define bFM4_MFT0_ICU_ICFS10_FSI02             *((volatile unsigned char*)(0x42402D88UL))
#define bFM4_MFT0_ICU_ICFS10_FSI03             *((volatile unsigned char*)(0x42402D8CUL))
#define bFM4_MFT0_ICU_ICFS10_FSI10             *((volatile unsigned char*)(0x42402D90UL))
#define bFM4_MFT0_ICU_ICFS10_FSI11             *((volatile unsigned char*)(0x42402D94UL))
#define bFM4_MFT0_ICU_ICFS10_FSI12             *((volatile unsigned char*)(0x42402D98UL))
#define bFM4_MFT0_ICU_ICFS10_FSI13             *((volatile unsigned char*)(0x42402D9CUL))
#define bFM4_MFT0_ICU_ICFS32_FSI00             *((volatile unsigned char*)(0x42402DA0UL))
#define bFM4_MFT0_ICU_ICFS32_FSI01             *((volatile unsigned char*)(0x42402DA4UL))
#define bFM4_MFT0_ICU_ICFS32_FSI02             *((volatile unsigned char*)(0x42402DA8UL))
#define bFM4_MFT0_ICU_ICFS32_FSI03             *((volatile unsigned char*)(0x42402DACUL))
#define bFM4_MFT0_ICU_ICFS32_FSI10             *((volatile unsigned char*)(0x42402DB0UL))
#define bFM4_MFT0_ICU_ICFS32_FSI11             *((volatile unsigned char*)(0x42402DB4UL))
#define bFM4_MFT0_ICU_ICFS32_FSI12             *((volatile unsigned char*)(0x42402DB8UL))
#define bFM4_MFT0_ICU_ICFS32_FSI13             *((volatile unsigned char*)(0x42402DBCUL))
#define bFM4_MFT0_ICU_ICSA10_EG00              *((volatile unsigned char*)(0x42403080UL))
#define bFM4_MFT0_ICU_ICSA10_EG01              *((volatile unsigned char*)(0x42403084UL))
#define bFM4_MFT0_ICU_ICSA10_EG10              *((volatile unsigned char*)(0x42403088UL))
#define bFM4_MFT0_ICU_ICSA10_EG11              *((volatile unsigned char*)(0x4240308CUL))
#define bFM4_MFT0_ICU_ICSA10_ICE0              *((volatile unsigned char*)(0x42403090UL))
#define bFM4_MFT0_ICU_ICSA10_ICE1              *((volatile unsigned char*)(0x42403094UL))
#define bFM4_MFT0_ICU_ICSA10_ICP0              *((volatile unsigned char*)(0x42403098UL))
#define bFM4_MFT0_ICU_ICSA10_ICP1              *((volatile unsigned char*)(0x4240309CUL))
#define bFM4_MFT0_ICU_ICSB10_IEI0              *((volatile unsigned char*)(0x424030A0UL))
#define bFM4_MFT0_ICU_ICSB10_IEI1              *((volatile unsigned char*)(0x424030A4UL))
#define bFM4_MFT0_ICU_ICSA32_EG00              *((volatile unsigned char*)(0x42403100UL))
#define bFM4_MFT0_ICU_ICSA32_EG01              *((volatile unsigned char*)(0x42403104UL))
#define bFM4_MFT0_ICU_ICSA32_EG10              *((volatile unsigned char*)(0x42403108UL))
#define bFM4_MFT0_ICU_ICSA32_EG11              *((volatile unsigned char*)(0x4240310CUL))
#define bFM4_MFT0_ICU_ICSA32_ICE0              *((volatile unsigned char*)(0x42403110UL))
#define bFM4_MFT0_ICU_ICSA32_ICE1              *((volatile unsigned char*)(0x42403114UL))
#define bFM4_MFT0_ICU_ICSA32_ICP0              *((volatile unsigned char*)(0x42403118UL))
#define bFM4_MFT0_ICU_ICSA32_ICP1              *((volatile unsigned char*)(0x4240311CUL))
#define bFM4_MFT0_ICU_ICSB32_IEI0              *((volatile unsigned char*)(0x42403120UL))
#define bFM4_MFT0_ICU_ICSB32_IEI1              *((volatile unsigned char*)(0x42403124UL))

/* Multifunction Timer unit 0 ADC Start Compare Unit registers */
#define bFM4_MFT0_ADCMP_ACSC0_BUFE0            *((volatile unsigned char*)(0x42403A80UL))
#define bFM4_MFT0_ADCMP_ACSC0_BUFE1            *((volatile unsigned char*)(0x42403A84UL))
#define bFM4_MFT0_ADCMP_ACSC0_ADSEL0           *((volatile unsigned char*)(0x42403A88UL))
#define bFM4_MFT0_ADCMP_ACSC0_ADSEL1           *((volatile unsigned char*)(0x42403A8CUL))
#define bFM4_MFT0_ADCMP_ACSC0_ADSEL2           *((volatile unsigned char*)(0x42403A90UL))
#define bFM4_MFT0_ADCMP_ACSC0_APBM             *((volatile unsigned char*)(0x42403A94UL))
#define bFM4_MFT0_ADCMP_ACSD0_AMOD             *((volatile unsigned char*)(0x42403AA0UL))
#define bFM4_MFT0_ADCMP_ACSD0_OCUS             *((volatile unsigned char*)(0x42403AA4UL))
#define bFM4_MFT0_ADCMP_ACSD0_DE               *((volatile unsigned char*)(0x42403AB0UL))
#define bFM4_MFT0_ADCMP_ACSD0_PE               *((volatile unsigned char*)(0x42403AB4UL))
#define bFM4_MFT0_ADCMP_ACSD0_UE               *((volatile unsigned char*)(0x42403AB8UL))
#define bFM4_MFT0_ADCMP_ACSD0_ZE               *((volatile unsigned char*)(0x42403ABCUL))
#define bFM4_MFT0_ADCMP_ACMC0_AMC0             *((volatile unsigned char*)(0x42403AC0UL))
#define bFM4_MFT0_ADCMP_ACMC0_AMC1             *((volatile unsigned char*)(0x42403AC4UL))
#define bFM4_MFT0_ADCMP_ACMC0_AMC2             *((volatile unsigned char*)(0x42403AC8UL))
#define bFM4_MFT0_ADCMP_ACMC0_AMC3             *((volatile unsigned char*)(0x42403ACCUL))
#define bFM4_MFT0_ADCMP_ACMC0_MZCE             *((volatile unsigned char*)(0x42403AD8UL))
#define bFM4_MFT0_ADCMP_ACMC0_MPCE             *((volatile unsigned char*)(0x42403ADCUL))
#define bFM4_MFT0_ADCMP_ACSC1_BUFE0            *((volatile unsigned char*)(0x42403B00UL))
#define bFM4_MFT0_ADCMP_ACSC1_BUFE1            *((volatile unsigned char*)(0x42403B04UL))
#define bFM4_MFT0_ADCMP_ACSC1_ADSEL0           *((volatile unsigned char*)(0x42403B08UL))
#define bFM4_MFT0_ADCMP_ACSC1_ADSEL1           *((volatile unsigned char*)(0x42403B0CUL))
#define bFM4_MFT0_ADCMP_ACSC1_ADSEL2           *((volatile unsigned char*)(0x42403B10UL))
#define bFM4_MFT0_ADCMP_ACSC1_APBM             *((volatile unsigned char*)(0x42403B14UL))
#define bFM4_MFT0_ADCMP_ACSD1_AMOD             *((volatile unsigned char*)(0x42403B20UL))
#define bFM4_MFT0_ADCMP_ACSD1_OCUS             *((volatile unsigned char*)(0x42403B24UL))
#define bFM4_MFT0_ADCMP_ACSD1_DE               *((volatile unsigned char*)(0x42403B30UL))
#define bFM4_MFT0_ADCMP_ACSD1_PE               *((volatile unsigned char*)(0x42403B34UL))
#define bFM4_MFT0_ADCMP_ACSD1_UE               *((volatile unsigned char*)(0x42403B38UL))
#define bFM4_MFT0_ADCMP_ACSD1_ZE               *((volatile unsigned char*)(0x42403B3CUL))
#define bFM4_MFT0_ADCMP_ACMC1_AMC0             *((volatile unsigned char*)(0x42403B40UL))
#define bFM4_MFT0_ADCMP_ACMC1_AMC1             *((volatile unsigned char*)(0x42403B44UL))
#define bFM4_MFT0_ADCMP_ACMC1_AMC2             *((volatile unsigned char*)(0x42403B48UL))
#define bFM4_MFT0_ADCMP_ACMC1_AMC3             *((volatile unsigned char*)(0x42403B4CUL))
#define bFM4_MFT0_ADCMP_ACMC1_MZCE             *((volatile unsigned char*)(0x42403B58UL))
#define bFM4_MFT0_ADCMP_ACMC1_MPCE             *((volatile unsigned char*)(0x42403B5CUL))
#define bFM4_MFT0_ADCMP_ACSC2_BUFE0            *((volatile unsigned char*)(0x42403B80UL))
#define bFM4_MFT0_ADCMP_ACSC2_BUFE1            *((volatile unsigned char*)(0x42403B84UL))
#define bFM4_MFT0_ADCMP_ACSC2_ADSEL0           *((volatile unsigned char*)(0x42403B88UL))
#define bFM4_MFT0_ADCMP_ACSC2_ADSEL1           *((volatile unsigned char*)(0x42403B8CUL))
#define bFM4_MFT0_ADCMP_ACSC2_ADSEL2           *((volatile unsigned char*)(0x42403B90UL))
#define bFM4_MFT0_ADCMP_ACSC2_APBM             *((volatile unsigned char*)(0x42403B94UL))
#define bFM4_MFT0_ADCMP_ACSD2_AMOD             *((volatile unsigned char*)(0x42403BA0UL))
#define bFM4_MFT0_ADCMP_ACSD2_OCUS             *((volatile unsigned char*)(0x42403BA4UL))
#define bFM4_MFT0_ADCMP_ACSD2_DE               *((volatile unsigned char*)(0x42403BB0UL))
#define bFM4_MFT0_ADCMP_ACSD2_PE               *((volatile unsigned char*)(0x42403BB4UL))
#define bFM4_MFT0_ADCMP_ACSD2_UE               *((volatile unsigned char*)(0x42403BB8UL))
#define bFM4_MFT0_ADCMP_ACSD2_ZE               *((volatile unsigned char*)(0x42403BBCUL))
#define bFM4_MFT0_ADCMP_ACMC2_AMC0             *((volatile unsigned char*)(0x42403BC0UL))
#define bFM4_MFT0_ADCMP_ACMC2_AMC1             *((volatile unsigned char*)(0x42403BC4UL))
#define bFM4_MFT0_ADCMP_ACMC2_AMC2             *((volatile unsigned char*)(0x42403BC8UL))
#define bFM4_MFT0_ADCMP_ACMC2_AMC3             *((volatile unsigned char*)(0x42403BCCUL))
#define bFM4_MFT0_ADCMP_ACMC2_MZCE             *((volatile unsigned char*)(0x42403BD8UL))
#define bFM4_MFT0_ADCMP_ACMC2_MPCE             *((volatile unsigned char*)(0x42403BDCUL))
#define bFM4_MFT0_ADCMP_ACSC3_BUFE0            *((volatile unsigned char*)(0x42403C00UL))
#define bFM4_MFT0_ADCMP_ACSC3_BUFE1            *((volatile unsigned char*)(0x42403C04UL))
#define bFM4_MFT0_ADCMP_ACSC3_ADSEL0           *((volatile unsigned char*)(0x42403C08UL))
#define bFM4_MFT0_ADCMP_ACSC3_ADSEL1           *((volatile unsigned char*)(0x42403C0CUL))
#define bFM4_MFT0_ADCMP_ACSC3_ADSEL2           *((volatile unsigned char*)(0x42403C10UL))
#define bFM4_MFT0_ADCMP_ACSC3_APBM             *((volatile unsigned char*)(0x42403C14UL))
#define bFM4_MFT0_ADCMP_ACSD3_AMOD             *((volatile unsigned char*)(0x42403C20UL))
#define bFM4_MFT0_ADCMP_ACSD3_OCUS             *((volatile unsigned char*)(0x42403C24UL))
#define bFM4_MFT0_ADCMP_ACSD3_DE               *((volatile unsigned char*)(0x42403C30UL))
#define bFM4_MFT0_ADCMP_ACSD3_PE               *((volatile unsigned char*)(0x42403C34UL))
#define bFM4_MFT0_ADCMP_ACSD3_UE               *((volatile unsigned char*)(0x42403C38UL))
#define bFM4_MFT0_ADCMP_ACSD3_ZE               *((volatile unsigned char*)(0x42403C3CUL))
#define bFM4_MFT0_ADCMP_ACMC3_AMC0             *((volatile unsigned char*)(0x42403C40UL))
#define bFM4_MFT0_ADCMP_ACMC3_AMC1             *((volatile unsigned char*)(0x42403C44UL))
#define bFM4_MFT0_ADCMP_ACMC3_AMC2             *((volatile unsigned char*)(0x42403C48UL))
#define bFM4_MFT0_ADCMP_ACMC3_AMC3             *((volatile unsigned char*)(0x42403C4CUL))
#define bFM4_MFT0_ADCMP_ACMC3_MZCE             *((volatile unsigned char*)(0x42403C58UL))
#define bFM4_MFT0_ADCMP_ACMC3_MPCE             *((volatile unsigned char*)(0x42403C5CUL))
#define bFM4_MFT0_ADCMP_ACSC4_BUFE0            *((volatile unsigned char*)(0x42403C80UL))
#define bFM4_MFT0_ADCMP_ACSC4_BUFE1            *((volatile unsigned char*)(0x42403C84UL))
#define bFM4_MFT0_ADCMP_ACSC4_ADSEL0           *((volatile unsigned char*)(0x42403C88UL))
#define bFM4_MFT0_ADCMP_ACSC4_ADSEL1           *((volatile unsigned char*)(0x42403C8CUL))
#define bFM4_MFT0_ADCMP_ACSC4_ADSEL2           *((volatile unsigned char*)(0x42403C90UL))
#define bFM4_MFT0_ADCMP_ACSC4_APBM             *((volatile unsigned char*)(0x42403C94UL))
#define bFM4_MFT0_ADCMP_ACSD4_AMOD             *((volatile unsigned char*)(0x42403CA0UL))
#define bFM4_MFT0_ADCMP_ACSD4_OCUS             *((volatile unsigned char*)(0x42403CA4UL))
#define bFM4_MFT0_ADCMP_ACSD4_DE               *((volatile unsigned char*)(0x42403CB0UL))
#define bFM4_MFT0_ADCMP_ACSD4_PE               *((volatile unsigned char*)(0x42403CB4UL))
#define bFM4_MFT0_ADCMP_ACSD4_UE               *((volatile unsigned char*)(0x42403CB8UL))
#define bFM4_MFT0_ADCMP_ACSD4_ZE               *((volatile unsigned char*)(0x42403CBCUL))
#define bFM4_MFT0_ADCMP_ACMC4_AMC0             *((volatile unsigned char*)(0x42403CC0UL))
#define bFM4_MFT0_ADCMP_ACMC4_AMC1             *((volatile unsigned char*)(0x42403CC4UL))
#define bFM4_MFT0_ADCMP_ACMC4_AMC2             *((volatile unsigned char*)(0x42403CC8UL))
#define bFM4_MFT0_ADCMP_ACMC4_AMC3             *((volatile unsigned char*)(0x42403CCCUL))
#define bFM4_MFT0_ADCMP_ACMC4_MZCE             *((volatile unsigned char*)(0x42403CD8UL))
#define bFM4_MFT0_ADCMP_ACMC4_MPCE             *((volatile unsigned char*)(0x42403CDCUL))
#define bFM4_MFT0_ADCMP_ACSC5_BUFE0            *((volatile unsigned char*)(0x42403D00UL))
#define bFM4_MFT0_ADCMP_ACSC5_BUFE1            *((volatile unsigned char*)(0x42403D04UL))
#define bFM4_MFT0_ADCMP_ACSC5_ADSEL0           *((volatile unsigned char*)(0x42403D08UL))
#define bFM4_MFT0_ADCMP_ACSC5_ADSEL1           *((volatile unsigned char*)(0x42403D0CUL))
#define bFM4_MFT0_ADCMP_ACSC5_ADSEL2           *((volatile unsigned char*)(0x42403D10UL))
#define bFM4_MFT0_ADCMP_ACSC5_APBM             *((volatile unsigned char*)(0x42403D14UL))
#define bFM4_MFT0_ADCMP_ACSD5_AMOD             *((volatile unsigned char*)(0x42403D20UL))
#define bFM4_MFT0_ADCMP_ACSD5_OCUS             *((volatile unsigned char*)(0x42403D24UL))
#define bFM4_MFT0_ADCMP_ACSD5_DE               *((volatile unsigned char*)(0x42403D30UL))
#define bFM4_MFT0_ADCMP_ACSD5_PE               *((volatile unsigned char*)(0x42403D34UL))
#define bFM4_MFT0_ADCMP_ACSD5_UE               *((volatile unsigned char*)(0x42403D38UL))
#define bFM4_MFT0_ADCMP_ACSD5_ZE               *((volatile unsigned char*)(0x42403D3CUL))
#define bFM4_MFT0_ADCMP_ACMC5_AMC0             *((volatile unsigned char*)(0x42403D40UL))
#define bFM4_MFT0_ADCMP_ACMC5_AMC1             *((volatile unsigned char*)(0x42403D44UL))
#define bFM4_MFT0_ADCMP_ACMC5_AMC2             *((volatile unsigned char*)(0x42403D48UL))
#define bFM4_MFT0_ADCMP_ACMC5_AMC3             *((volatile unsigned char*)(0x42403D4CUL))
#define bFM4_MFT0_ADCMP_ACMC5_MZCE             *((volatile unsigned char*)(0x42403D58UL))
#define bFM4_MFT0_ADCMP_ACMC5_MPCE             *((volatile unsigned char*)(0x42403D5CUL))

/* Multifunction Timer unit 1 Free Running Timer registers */
#define bFM4_MFT1_FRT_TCSA0_CLK0               *((volatile unsigned char*)(0x42422900UL))
#define bFM4_MFT1_FRT_TCSA0_CLK1               *((volatile unsigned char*)(0x42422904UL))
#define bFM4_MFT1_FRT_TCSA0_CLK2               *((volatile unsigned char*)(0x42422908UL))
#define bFM4_MFT1_FRT_TCSA0_CLK3               *((volatile unsigned char*)(0x4242290CUL))
#define bFM4_MFT1_FRT_TCSA0_SCLR               *((volatile unsigned char*)(0x42422910UL))
#define bFM4_MFT1_FRT_TCSA0_MODE               *((volatile unsigned char*)(0x42422914UL))
#define bFM4_MFT1_FRT_TCSA0_STOP               *((volatile unsigned char*)(0x42422918UL))
#define bFM4_MFT1_FRT_TCSA0_BFE                *((volatile unsigned char*)(0x4242291CUL))
#define bFM4_MFT1_FRT_TCSA0_ICRE               *((volatile unsigned char*)(0x42422920UL))
#define bFM4_MFT1_FRT_TCSA0_ICLR               *((volatile unsigned char*)(0x42422924UL))
#define bFM4_MFT1_FRT_TCSA0_IRQZE              *((volatile unsigned char*)(0x42422934UL))
#define bFM4_MFT1_FRT_TCSA0_IRQZF              *((volatile unsigned char*)(0x42422938UL))
#define bFM4_MFT1_FRT_TCSA0_ECKE               *((volatile unsigned char*)(0x4242293CUL))
#define bFM4_MFT1_FRT_TCSC0_MSZI0              *((volatile unsigned char*)(0x42422940UL))
#define bFM4_MFT1_FRT_TCSC0_MSZI1              *((volatile unsigned char*)(0x42422944UL))
#define bFM4_MFT1_FRT_TCSC0_MSZI2              *((volatile unsigned char*)(0x42422948UL))
#define bFM4_MFT1_FRT_TCSC0_MSZI3              *((volatile unsigned char*)(0x4242294CUL))
#define bFM4_MFT1_FRT_TCSC0_MSPI0              *((volatile unsigned char*)(0x42422950UL))
#define bFM4_MFT1_FRT_TCSC0_MSPI1              *((volatile unsigned char*)(0x42422954UL))
#define bFM4_MFT1_FRT_TCSC0_MSPI2              *((volatile unsigned char*)(0x42422958UL))
#define bFM4_MFT1_FRT_TCSC0_MSPI3              *((volatile unsigned char*)(0x4242295CUL))
#define bFM4_MFT1_FRT_TCSC0_MSZC0              *((volatile unsigned char*)(0x42422960UL))
#define bFM4_MFT1_FRT_TCSC0_MSZC1              *((volatile unsigned char*)(0x42422964UL))
#define bFM4_MFT1_FRT_TCSC0_MSZC2              *((volatile unsigned char*)(0x42422968UL))
#define bFM4_MFT1_FRT_TCSC0_MSZC3              *((volatile unsigned char*)(0x4242296CUL))
#define bFM4_MFT1_FRT_TCSC0_MSPC0              *((volatile unsigned char*)(0x42422970UL))
#define bFM4_MFT1_FRT_TCSC0_MSPC1              *((volatile unsigned char*)(0x42422974UL))
#define bFM4_MFT1_FRT_TCSC0_MSPC2              *((volatile unsigned char*)(0x42422978UL))
#define bFM4_MFT1_FRT_TCSC0_MSPC3              *((volatile unsigned char*)(0x4242297CUL))
#define bFM4_MFT1_FRT_TCSA1_CLK0               *((volatile unsigned char*)(0x42422A80UL))
#define bFM4_MFT1_FRT_TCSA1_CLK1               *((volatile unsigned char*)(0x42422A84UL))
#define bFM4_MFT1_FRT_TCSA1_CLK2               *((volatile unsigned char*)(0x42422A88UL))
#define bFM4_MFT1_FRT_TCSA1_CLK3               *((volatile unsigned char*)(0x42422A8CUL))
#define bFM4_MFT1_FRT_TCSA1_SCLR               *((volatile unsigned char*)(0x42422A90UL))
#define bFM4_MFT1_FRT_TCSA1_MODE               *((volatile unsigned char*)(0x42422A94UL))
#define bFM4_MFT1_FRT_TCSA1_STOP               *((volatile unsigned char*)(0x42422A98UL))
#define bFM4_MFT1_FRT_TCSA1_BFE                *((volatile unsigned char*)(0x42422A9CUL))
#define bFM4_MFT1_FRT_TCSA1_ICRE               *((volatile unsigned char*)(0x42422AA0UL))
#define bFM4_MFT1_FRT_TCSA1_ICLR               *((volatile unsigned char*)(0x42422AA4UL))
#define bFM4_MFT1_FRT_TCSA1_IRQZE              *((volatile unsigned char*)(0x42422AB4UL))
#define bFM4_MFT1_FRT_TCSA1_IRQZF              *((volatile unsigned char*)(0x42422AB8UL))
#define bFM4_MFT1_FRT_TCSA1_ECKE               *((volatile unsigned char*)(0x42422ABCUL))
#define bFM4_MFT1_FRT_TCSC1_MSZI0              *((volatile unsigned char*)(0x42422AC0UL))
#define bFM4_MFT1_FRT_TCSC1_MSZI1              *((volatile unsigned char*)(0x42422AC4UL))
#define bFM4_MFT1_FRT_TCSC1_MSZI2              *((volatile unsigned char*)(0x42422AC8UL))
#define bFM4_MFT1_FRT_TCSC1_MSZI3              *((volatile unsigned char*)(0x42422ACCUL))
#define bFM4_MFT1_FRT_TCSC1_MSPI0              *((volatile unsigned char*)(0x42422AD0UL))
#define bFM4_MFT1_FRT_TCSC1_MSPI1              *((volatile unsigned char*)(0x42422AD4UL))
#define bFM4_MFT1_FRT_TCSC1_MSPI2              *((volatile unsigned char*)(0x42422AD8UL))
#define bFM4_MFT1_FRT_TCSC1_MSPI3              *((volatile unsigned char*)(0x42422ADCUL))
#define bFM4_MFT1_FRT_TCSC1_MSZC0              *((volatile unsigned char*)(0x42422AE0UL))
#define bFM4_MFT1_FRT_TCSC1_MSZC1              *((volatile unsigned char*)(0x42422AE4UL))
#define bFM4_MFT1_FRT_TCSC1_MSZC2              *((volatile unsigned char*)(0x42422AE8UL))
#define bFM4_MFT1_FRT_TCSC1_MSZC3              *((volatile unsigned char*)(0x42422AECUL))
#define bFM4_MFT1_FRT_TCSC1_MSPC0              *((volatile unsigned char*)(0x42422AF0UL))
#define bFM4_MFT1_FRT_TCSC1_MSPC1              *((volatile unsigned char*)(0x42422AF4UL))
#define bFM4_MFT1_FRT_TCSC1_MSPC2              *((volatile unsigned char*)(0x42422AF8UL))
#define bFM4_MFT1_FRT_TCSC1_MSPC3              *((volatile unsigned char*)(0x42422AFCUL))
#define bFM4_MFT1_FRT_TCSA2_CLK0               *((volatile unsigned char*)(0x42422C00UL))
#define bFM4_MFT1_FRT_TCSA2_CLK1               *((volatile unsigned char*)(0x42422C04UL))
#define bFM4_MFT1_FRT_TCSA2_CLK2               *((volatile unsigned char*)(0x42422C08UL))
#define bFM4_MFT1_FRT_TCSA2_CLK3               *((volatile unsigned char*)(0x42422C0CUL))
#define bFM4_MFT1_FRT_TCSA2_SCLR               *((volatile unsigned char*)(0x42422C10UL))
#define bFM4_MFT1_FRT_TCSA2_MODE               *((volatile unsigned char*)(0x42422C14UL))
#define bFM4_MFT1_FRT_TCSA2_STOP               *((volatile unsigned char*)(0x42422C18UL))
#define bFM4_MFT1_FRT_TCSA2_BFE                *((volatile unsigned char*)(0x42422C1CUL))
#define bFM4_MFT1_FRT_TCSA2_ICRE               *((volatile unsigned char*)(0x42422C20UL))
#define bFM4_MFT1_FRT_TCSA2_ICLR               *((volatile unsigned char*)(0x42422C24UL))
#define bFM4_MFT1_FRT_TCSA2_IRQZE              *((volatile unsigned char*)(0x42422C34UL))
#define bFM4_MFT1_FRT_TCSA2_IRQZF              *((volatile unsigned char*)(0x42422C38UL))
#define bFM4_MFT1_FRT_TCSA2_ECKE               *((volatile unsigned char*)(0x42422C3CUL))
#define bFM4_MFT1_FRT_TCSC2_MSZI0              *((volatile unsigned char*)(0x42422C40UL))
#define bFM4_MFT1_FRT_TCSC2_MSZI1              *((volatile unsigned char*)(0x42422C44UL))
#define bFM4_MFT1_FRT_TCSC2_MSZI2              *((volatile unsigned char*)(0x42422C48UL))
#define bFM4_MFT1_FRT_TCSC2_MSZI3              *((volatile unsigned char*)(0x42422C4CUL))
#define bFM4_MFT1_FRT_TCSC2_MSPI0              *((volatile unsigned char*)(0x42422C50UL))
#define bFM4_MFT1_FRT_TCSC2_MSPI1              *((volatile unsigned char*)(0x42422C54UL))
#define bFM4_MFT1_FRT_TCSC2_MSPI2              *((volatile unsigned char*)(0x42422C58UL))
#define bFM4_MFT1_FRT_TCSC2_MSPI3              *((volatile unsigned char*)(0x42422C5CUL))
#define bFM4_MFT1_FRT_TCSC2_MSZC0              *((volatile unsigned char*)(0x42422C60UL))
#define bFM4_MFT1_FRT_TCSC2_MSZC1              *((volatile unsigned char*)(0x42422C64UL))
#define bFM4_MFT1_FRT_TCSC2_MSZC2              *((volatile unsigned char*)(0x42422C68UL))
#define bFM4_MFT1_FRT_TCSC2_MSZC3              *((volatile unsigned char*)(0x42422C6CUL))
#define bFM4_MFT1_FRT_TCSC2_MSPC0              *((volatile unsigned char*)(0x42422C70UL))
#define bFM4_MFT1_FRT_TCSC2_MSPC1              *((volatile unsigned char*)(0x42422C74UL))
#define bFM4_MFT1_FRT_TCSC2_MSPC2              *((volatile unsigned char*)(0x42422C78UL))
#define bFM4_MFT1_FRT_TCSC2_MSPC3              *((volatile unsigned char*)(0x42422C7CUL))
#define bFM4_MFT1_FRT_TCAL_STOP00              *((volatile unsigned char*)(0x42422C80UL))
#define bFM4_MFT1_FRT_TCAL_STOP01              *((volatile unsigned char*)(0x42422C84UL))
#define bFM4_MFT1_FRT_TCAL_STOP02              *((volatile unsigned char*)(0x42422C88UL))
#define bFM4_MFT1_FRT_TCAL_STOP10              *((volatile unsigned char*)(0x42422C8CUL))
#define bFM4_MFT1_FRT_TCAL_STOP11              *((volatile unsigned char*)(0x42422C90UL))
#define bFM4_MFT1_FRT_TCAL_STOP12              *((volatile unsigned char*)(0x42422C94UL))
#define bFM4_MFT1_FRT_TCAL_STOP20              *((volatile unsigned char*)(0x42422C98UL))
#define bFM4_MFT1_FRT_TCAL_STOP21              *((volatile unsigned char*)(0x42422C9CUL))
#define bFM4_MFT1_FRT_TCAL_STOP22              *((volatile unsigned char*)(0x42422CA0UL))
#define bFM4_MFT1_FRT_TCAL_SCLR00              *((volatile unsigned char*)(0x42422CC0UL))
#define bFM4_MFT1_FRT_TCAL_SCLR01              *((volatile unsigned char*)(0x42422CC4UL))
#define bFM4_MFT1_FRT_TCAL_SCLR02              *((volatile unsigned char*)(0x42422CC8UL))
#define bFM4_MFT1_FRT_TCAL_SCLR10              *((volatile unsigned char*)(0x42422CCCUL))
#define bFM4_MFT1_FRT_TCAL_SCLR11              *((volatile unsigned char*)(0x42422CD0UL))
#define bFM4_MFT1_FRT_TCAL_SCLR12              *((volatile unsigned char*)(0x42422CD4UL))
#define bFM4_MFT1_FRT_TCAL_SCLR20              *((volatile unsigned char*)(0x42422CD8UL))
#define bFM4_MFT1_FRT_TCAL_SCLR21              *((volatile unsigned char*)(0x42422CDCUL))
#define bFM4_MFT1_FRT_TCAL_SCLR22              *((volatile unsigned char*)(0x42422CE0UL))
#define bFM4_MFT1_FRT_TCSD_OFMD1               *((volatile unsigned char*)(0x42423D80UL))
#define bFM4_MFT1_FRT_TCSD_OFMD2               *((volatile unsigned char*)(0x42423D84UL))

/* Multifunction Timer unit 1 Output Compare Unit registers */
#define bFM4_MFT1_OCU_OCSA10_CST0              *((volatile unsigned char*)(0x42422300UL))
#define bFM4_MFT1_OCU_OCSA10_CST1              *((volatile unsigned char*)(0x42422304UL))
#define bFM4_MFT1_OCU_OCSA10_IOE0              *((volatile unsigned char*)(0x42422310UL))
#define bFM4_MFT1_OCU_OCSA10_IOE1              *((volatile unsigned char*)(0x42422314UL))
#define bFM4_MFT1_OCU_OCSA10_IOP0              *((volatile unsigned char*)(0x42422318UL))
#define bFM4_MFT1_OCU_OCSA10_IOP1              *((volatile unsigned char*)(0x4242231CUL))
#define bFM4_MFT1_OCU_OCSB10_OTD0              *((volatile unsigned char*)(0x42422320UL))
#define bFM4_MFT1_OCU_OCSB10_OTD1              *((volatile unsigned char*)(0x42422324UL))
#define bFM4_MFT1_OCU_OCSB10_CMOD              *((volatile unsigned char*)(0x42422330UL))
#define bFM4_MFT1_OCU_OCSB10_FM4               *((volatile unsigned char*)(0x4242233CUL))
#define bFM4_MFT1_OCU_OCSD10_OCCP0BUFE0        *((volatile unsigned char*)(0x42422340UL))
#define bFM4_MFT1_OCU_OCSD10_OCCP0BUFE1        *((volatile unsigned char*)(0x42422344UL))
#define bFM4_MFT1_OCU_OCSD10_OCCP1BUFE0        *((volatile unsigned char*)(0x42422348UL))
#define bFM4_MFT1_OCU_OCSD10_OCCP1BUFE1        *((volatile unsigned char*)(0x4242234CUL))
#define bFM4_MFT1_OCU_OCSD10_OCSE0BUFE0        *((volatile unsigned char*)(0x42422350UL))
#define bFM4_MFT1_OCU_OCSD10_OCSE0BUFE1        *((volatile unsigned char*)(0x42422354UL))
#define bFM4_MFT1_OCU_OCSD10_OCSE1BUFE0        *((volatile unsigned char*)(0x42422358UL))
#define bFM4_MFT1_OCU_OCSD10_OCSE1BUFE1        *((volatile unsigned char*)(0x4242235CUL))
#define bFM4_MFT1_OCU_OCSD10_OPBM0             *((volatile unsigned char*)(0x42422360UL))
#define bFM4_MFT1_OCU_OCSD10_OPBM1             *((volatile unsigned char*)(0x42422364UL))
#define bFM4_MFT1_OCU_OCSD10_OEBM0             *((volatile unsigned char*)(0x42422368UL))
#define bFM4_MFT1_OCU_OCSD10_OEBM1             *((volatile unsigned char*)(0x4242236CUL))
#define bFM4_MFT1_OCU_OCSD10_OFEX0             *((volatile unsigned char*)(0x42422370UL))
#define bFM4_MFT1_OCU_OCSD10_OFEX1             *((volatile unsigned char*)(0x42422374UL))
#define bFM4_MFT1_OCU_OCSA32_CST0              *((volatile unsigned char*)(0x42422380UL))
#define bFM4_MFT1_OCU_OCSA32_CST1              *((volatile unsigned char*)(0x42422384UL))
#define bFM4_MFT1_OCU_OCSA32_IOE0              *((volatile unsigned char*)(0x42422390UL))
#define bFM4_MFT1_OCU_OCSA32_IOE1              *((volatile unsigned char*)(0x42422394UL))
#define bFM4_MFT1_OCU_OCSA32_IOP0              *((volatile unsigned char*)(0x42422398UL))
#define bFM4_MFT1_OCU_OCSA32_IOP1              *((volatile unsigned char*)(0x4242239CUL))
#define bFM4_MFT1_OCU_OCSB32_OTD0              *((volatile unsigned char*)(0x424223A0UL))
#define bFM4_MFT1_OCU_OCSB32_OTD1              *((volatile unsigned char*)(0x424223A4UL))
#define bFM4_MFT1_OCU_OCSB32_CMOD              *((volatile unsigned char*)(0x424223B0UL))
#define bFM4_MFT1_OCU_OCSB32_FM4               *((volatile unsigned char*)(0x424223BCUL))
#define bFM4_MFT1_OCU_OCSD32_OCCP2BUFE0        *((volatile unsigned char*)(0x424223C0UL))
#define bFM4_MFT1_OCU_OCSD32_OCCP2BUFE1        *((volatile unsigned char*)(0x424223C4UL))
#define bFM4_MFT1_OCU_OCSD32_OCCP3BUFE0        *((volatile unsigned char*)(0x424223C8UL))
#define bFM4_MFT1_OCU_OCSD32_OCCP3BUFE1        *((volatile unsigned char*)(0x424223CCUL))
#define bFM4_MFT1_OCU_OCSD32_OCSE2BUFE0        *((volatile unsigned char*)(0x424223D0UL))
#define bFM4_MFT1_OCU_OCSD32_OCSE2BUFE1        *((volatile unsigned char*)(0x424223D4UL))
#define bFM4_MFT1_OCU_OCSD32_OCSE3BUFE0        *((volatile unsigned char*)(0x424223D8UL))
#define bFM4_MFT1_OCU_OCSD32_OCSE3BUFE1        *((volatile unsigned char*)(0x424223DCUL))
#define bFM4_MFT1_OCU_OCSD32_OPBM2             *((volatile unsigned char*)(0x424223E0UL))
#define bFM4_MFT1_OCU_OCSD32_OPBM3             *((volatile unsigned char*)(0x424223E4UL))
#define bFM4_MFT1_OCU_OCSD32_OEBM2             *((volatile unsigned char*)(0x424223E8UL))
#define bFM4_MFT1_OCU_OCSD32_OEBM3             *((volatile unsigned char*)(0x424223ECUL))
#define bFM4_MFT1_OCU_OCSD32_OFEX2             *((volatile unsigned char*)(0x424223F0UL))
#define bFM4_MFT1_OCU_OCSD32_OFEX3             *((volatile unsigned char*)(0x424223F4UL))
#define bFM4_MFT1_OCU_OCSA54_CST0              *((volatile unsigned char*)(0x42422400UL))
#define bFM4_MFT1_OCU_OCSA54_CST1              *((volatile unsigned char*)(0x42422404UL))
#define bFM4_MFT1_OCU_OCSA54_IOE0              *((volatile unsigned char*)(0x42422410UL))
#define bFM4_MFT1_OCU_OCSA54_IOE1              *((volatile unsigned char*)(0x42422414UL))
#define bFM4_MFT1_OCU_OCSA54_IOP0              *((volatile unsigned char*)(0x42422418UL))
#define bFM4_MFT1_OCU_OCSA54_IOP1              *((volatile unsigned char*)(0x4242241CUL))
#define bFM4_MFT1_OCU_OCSB54_OTD0              *((volatile unsigned char*)(0x42422420UL))
#define bFM4_MFT1_OCU_OCSB54_OTD1              *((volatile unsigned char*)(0x42422424UL))
#define bFM4_MFT1_OCU_OCSB54_CMOD              *((volatile unsigned char*)(0x42422430UL))
#define bFM4_MFT1_OCU_OCSB54_FM4               *((volatile unsigned char*)(0x4242243CUL))
#define bFM4_MFT1_OCU_OCSD54_OCCP4BUFE0        *((volatile unsigned char*)(0x42422440UL))
#define bFM4_MFT1_OCU_OCSD54_OCCP4BUFE1        *((volatile unsigned char*)(0x42422444UL))
#define bFM4_MFT1_OCU_OCSD54_OCCP5BUFE0        *((volatile unsigned char*)(0x42422448UL))
#define bFM4_MFT1_OCU_OCSD54_OCCP5BUFE1        *((volatile unsigned char*)(0x4242244CUL))
#define bFM4_MFT1_OCU_OCSD54_OCSE4BUFE0        *((volatile unsigned char*)(0x42422450UL))
#define bFM4_MFT1_OCU_OCSD54_OCSE4BUFE1        *((volatile unsigned char*)(0x42422454UL))
#define bFM4_MFT1_OCU_OCSD54_OCSE5BUFE0        *((volatile unsigned char*)(0x42422458UL))
#define bFM4_MFT1_OCU_OCSD54_OCSE5BUFE1        *((volatile unsigned char*)(0x4242245CUL))
#define bFM4_MFT1_OCU_OCSD54_OPBM4             *((volatile unsigned char*)(0x42422460UL))
#define bFM4_MFT1_OCU_OCSD54_OPBM5             *((volatile unsigned char*)(0x42422464UL))
#define bFM4_MFT1_OCU_OCSD54_OEBM4             *((volatile unsigned char*)(0x42422468UL))
#define bFM4_MFT1_OCU_OCSD54_OEBM5             *((volatile unsigned char*)(0x4242246CUL))
#define bFM4_MFT1_OCU_OCSD54_OFEX4             *((volatile unsigned char*)(0x42422470UL))
#define bFM4_MFT1_OCU_OCSD54_OFEX5             *((volatile unsigned char*)(0x42422474UL))
#define bFM4_MFT1_OCU_OCSC_MOD0                *((volatile unsigned char*)(0x424224A0UL))
#define bFM4_MFT1_OCU_OCSC_MOD1                *((volatile unsigned char*)(0x424224A4UL))
#define bFM4_MFT1_OCU_OCSC_MOD2                *((volatile unsigned char*)(0x424224A8UL))
#define bFM4_MFT1_OCU_OCSC_MOD3                *((volatile unsigned char*)(0x424224ACUL))
#define bFM4_MFT1_OCU_OCSC_MOD4                *((volatile unsigned char*)(0x424224B0UL))
#define bFM4_MFT1_OCU_OCSC_MOD5                *((volatile unsigned char*)(0x424224B4UL))
#define bFM4_MFT1_OCU_OCFS10_FSO00             *((volatile unsigned char*)(0x42422D00UL))
#define bFM4_MFT1_OCU_OCFS10_FSO01             *((volatile unsigned char*)(0x42422D04UL))
#define bFM4_MFT1_OCU_OCFS10_FSO02             *((volatile unsigned char*)(0x42422D08UL))
#define bFM4_MFT1_OCU_OCFS10_FSO03             *((volatile unsigned char*)(0x42422D0CUL))
#define bFM4_MFT1_OCU_OCFS10_FSO10             *((volatile unsigned char*)(0x42422D10UL))
#define bFM4_MFT1_OCU_OCFS10_FSO11             *((volatile unsigned char*)(0x42422D14UL))
#define bFM4_MFT1_OCU_OCFS10_FSO12             *((volatile unsigned char*)(0x42422D18UL))
#define bFM4_MFT1_OCU_OCFS10_FSO13             *((volatile unsigned char*)(0x42422D1CUL))
#define bFM4_MFT1_OCU_OCFS32_FSO00             *((volatile unsigned char*)(0x42422D20UL))
#define bFM4_MFT1_OCU_OCFS32_FSO01             *((volatile unsigned char*)(0x42422D24UL))
#define bFM4_MFT1_OCU_OCFS32_FSO02             *((volatile unsigned char*)(0x42422D28UL))
#define bFM4_MFT1_OCU_OCFS32_FSO03             *((volatile unsigned char*)(0x42422D2CUL))
#define bFM4_MFT1_OCU_OCFS32_FSO10             *((volatile unsigned char*)(0x42422D30UL))
#define bFM4_MFT1_OCU_OCFS32_FSO11             *((volatile unsigned char*)(0x42422D34UL))
#define bFM4_MFT1_OCU_OCFS32_FSO12             *((volatile unsigned char*)(0x42422D38UL))
#define bFM4_MFT1_OCU_OCFS32_FSO13             *((volatile unsigned char*)(0x42422D3CUL))
#define bFM4_MFT1_OCU_OCFS54_FSO00             *((volatile unsigned char*)(0x42422D40UL))
#define bFM4_MFT1_OCU_OCFS54_FSO01             *((volatile unsigned char*)(0x42422D44UL))
#define bFM4_MFT1_OCU_OCFS54_FSO02             *((volatile unsigned char*)(0x42422D48UL))
#define bFM4_MFT1_OCU_OCFS54_FSO03             *((volatile unsigned char*)(0x42422D4CUL))
#define bFM4_MFT1_OCU_OCFS54_FSO10             *((volatile unsigned char*)(0x42422D50UL))
#define bFM4_MFT1_OCU_OCFS54_FSO11             *((volatile unsigned char*)(0x42422D54UL))
#define bFM4_MFT1_OCU_OCFS54_FSO12             *((volatile unsigned char*)(0x42422D58UL))
#define bFM4_MFT1_OCU_OCFS54_FSO13             *((volatile unsigned char*)(0x42422D5CUL))

/* Multifunction Timer unit 1 Waveform Generator and Noise Canceler registers */
#define bFM4_MFT1_WFG_WFSA10_DCK0              *((volatile unsigned char*)(0x42423480UL))
#define bFM4_MFT1_WFG_WFSA10_DCK1              *((volatile unsigned char*)(0x42423484UL))
#define bFM4_MFT1_WFG_WFSA10_DCK2              *((volatile unsigned char*)(0x42423488UL))
#define bFM4_MFT1_WFG_WFSA10_GTEN0             *((volatile unsigned char*)(0x42423498UL))
#define bFM4_MFT1_WFG_WFSA10_GTEN1             *((volatile unsigned char*)(0x4242349CUL))
#define bFM4_MFT1_WFG_WFSA10_PSEL0             *((volatile unsigned char*)(0x424234A0UL))
#define bFM4_MFT1_WFG_WFSA10_PSEL1             *((volatile unsigned char*)(0x424234A4UL))
#define bFM4_MFT1_WFG_WFSA10_PGEN0             *((volatile unsigned char*)(0x424234A8UL))
#define bFM4_MFT1_WFG_WFSA10_PGEN1             *((volatile unsigned char*)(0x424234ACUL))
#define bFM4_MFT1_WFG_WFSA32_DCK0              *((volatile unsigned char*)(0x42423500UL))
#define bFM4_MFT1_WFG_WFSA32_DCK1              *((volatile unsigned char*)(0x42423504UL))
#define bFM4_MFT1_WFG_WFSA32_DCK2              *((volatile unsigned char*)(0x42423508UL))
#define bFM4_MFT1_WFG_WFSA32_GTEN0             *((volatile unsigned char*)(0x42423518UL))
#define bFM4_MFT1_WFG_WFSA32_GTEN1             *((volatile unsigned char*)(0x4242351CUL))
#define bFM4_MFT1_WFG_WFSA32_PSEL0             *((volatile unsigned char*)(0x42423520UL))
#define bFM4_MFT1_WFG_WFSA32_PSEL1             *((volatile unsigned char*)(0x42423524UL))
#define bFM4_MFT1_WFG_WFSA32_PGEN0             *((volatile unsigned char*)(0x42423528UL))
#define bFM4_MFT1_WFG_WFSA32_PGEN1             *((volatile unsigned char*)(0x4242352CUL))
#define bFM4_MFT1_WFG_WFSA54_DCK0              *((volatile unsigned char*)(0x42423580UL))
#define bFM4_MFT1_WFG_WFSA54_DCK1              *((volatile unsigned char*)(0x42423584UL))
#define bFM4_MFT1_WFG_WFSA54_DCK2              *((volatile unsigned char*)(0x42423588UL))
#define bFM4_MFT1_WFG_WFSA54_GTEN0             *((volatile unsigned char*)(0x42423598UL))
#define bFM4_MFT1_WFG_WFSA54_GTEN1             *((volatile unsigned char*)(0x4242359CUL))
#define bFM4_MFT1_WFG_WFSA54_PSEL0             *((volatile unsigned char*)(0x424235A0UL))
#define bFM4_MFT1_WFG_WFSA54_PSEL1             *((volatile unsigned char*)(0x424235A4UL))
#define bFM4_MFT1_WFG_WFSA54_PGEN0             *((volatile unsigned char*)(0x424235A8UL))
#define bFM4_MFT1_WFG_WFSA54_PGEN1             *((volatile unsigned char*)(0x424235ACUL))
#define bFM4_MFT1_WFG_WFIR_DTIFA               *((volatile unsigned char*)(0x42423600UL))
#define bFM4_MFT1_WFG_WFIR_DTICA               *((volatile unsigned char*)(0x42423604UL))
#define bFM4_MFT1_WFG_WFIR_DTIFB               *((volatile unsigned char*)(0x42423608UL))
#define bFM4_MFT1_WFG_WFIR_DTICB               *((volatile unsigned char*)(0x4242360CUL))
#define bFM4_MFT1_WFG_WFIR_TMIF10              *((volatile unsigned char*)(0x42423610UL))
#define bFM4_MFT1_WFG_WFIR_TMIC10              *((volatile unsigned char*)(0x42423614UL))
#define bFM4_MFT1_WFG_WFIR_TMIE10              *((volatile unsigned char*)(0x42423618UL))
#define bFM4_MFT1_WFG_WFIR_TMIS10              *((volatile unsigned char*)(0x4242361CUL))
#define bFM4_MFT1_WFG_WFIR_TMIF32              *((volatile unsigned char*)(0x42423620UL))
#define bFM4_MFT1_WFG_WFIR_TMIC32              *((volatile unsigned char*)(0x42423624UL))
#define bFM4_MFT1_WFG_WFIR_TMIE32              *((volatile unsigned char*)(0x42423628UL))
#define bFM4_MFT1_WFG_WFIR_TMIS32              *((volatile unsigned char*)(0x4242362CUL))
#define bFM4_MFT1_WFG_WFIR_TMIF54              *((volatile unsigned char*)(0x42423630UL))
#define bFM4_MFT1_WFG_WFIR_TMIC54              *((volatile unsigned char*)(0x42423634UL))
#define bFM4_MFT1_WFG_WFIR_TMIE54              *((volatile unsigned char*)(0x42423638UL))
#define bFM4_MFT1_WFG_WFIR_TMIS54              *((volatile unsigned char*)(0x4242363CUL))
#define bFM4_MFT1_WFG_NZCL_DTIEA               *((volatile unsigned char*)(0x42423680UL))
#define bFM4_MFT1_WFG_NZCL_NWS0                *((volatile unsigned char*)(0x42423684UL))
#define bFM4_MFT1_WFG_NZCL_NWS1                *((volatile unsigned char*)(0x42423688UL))
#define bFM4_MFT1_WFG_NZCL_NWS2                *((volatile unsigned char*)(0x4242368CUL))
#define bFM4_MFT1_WFG_NZCL_SDTI                *((volatile unsigned char*)(0x42423690UL))
#define bFM4_MFT1_WFG_NZCL_DTIEB               *((volatile unsigned char*)(0x42423694UL))
#define bFM4_MFT1_WFG_NZCL_DHOLD               *((volatile unsigned char*)(0x4242369CUL))
#define bFM4_MFT1_WFG_NZCL_DIMA                *((volatile unsigned char*)(0x424236A0UL))
#define bFM4_MFT1_WFG_NZCL_DIMB                *((volatile unsigned char*)(0x424236A4UL))
#define bFM4_MFT1_WFG_NZCL_WIM10               *((volatile unsigned char*)(0x424236B0UL))
#define bFM4_MFT1_WFG_NZCL_WIM32               *((volatile unsigned char*)(0x424236B4UL))
#define bFM4_MFT1_WFG_NZCL_WIM54               *((volatile unsigned char*)(0x424236B8UL))

/* Multifunction Timer unit 1 Input Capture Unit registers */
#define bFM4_MFT1_ICU_ICFS10_FSI00             *((volatile unsigned char*)(0x42422D80UL))
#define bFM4_MFT1_ICU_ICFS10_FSI01             *((volatile unsigned char*)(0x42422D84UL))
#define bFM4_MFT1_ICU_ICFS10_FSI02             *((volatile unsigned char*)(0x42422D88UL))
#define bFM4_MFT1_ICU_ICFS10_FSI03             *((volatile unsigned char*)(0x42422D8CUL))
#define bFM4_MFT1_ICU_ICFS10_FSI10             *((volatile unsigned char*)(0x42422D90UL))
#define bFM4_MFT1_ICU_ICFS10_FSI11             *((volatile unsigned char*)(0x42422D94UL))
#define bFM4_MFT1_ICU_ICFS10_FSI12             *((volatile unsigned char*)(0x42422D98UL))
#define bFM4_MFT1_ICU_ICFS10_FSI13             *((volatile unsigned char*)(0x42422D9CUL))
#define bFM4_MFT1_ICU_ICFS32_FSI00             *((volatile unsigned char*)(0x42422DA0UL))
#define bFM4_MFT1_ICU_ICFS32_FSI01             *((volatile unsigned char*)(0x42422DA4UL))
#define bFM4_MFT1_ICU_ICFS32_FSI02             *((volatile unsigned char*)(0x42422DA8UL))
#define bFM4_MFT1_ICU_ICFS32_FSI03             *((volatile unsigned char*)(0x42422DACUL))
#define bFM4_MFT1_ICU_ICFS32_FSI10             *((volatile unsigned char*)(0x42422DB0UL))
#define bFM4_MFT1_ICU_ICFS32_FSI11             *((volatile unsigned char*)(0x42422DB4UL))
#define bFM4_MFT1_ICU_ICFS32_FSI12             *((volatile unsigned char*)(0x42422DB8UL))
#define bFM4_MFT1_ICU_ICFS32_FSI13             *((volatile unsigned char*)(0x42422DBCUL))
#define bFM4_MFT1_ICU_ICSA10_EG00              *((volatile unsigned char*)(0x42423080UL))
#define bFM4_MFT1_ICU_ICSA10_EG01              *((volatile unsigned char*)(0x42423084UL))
#define bFM4_MFT1_ICU_ICSA10_EG10              *((volatile unsigned char*)(0x42423088UL))
#define bFM4_MFT1_ICU_ICSA10_EG11              *((volatile unsigned char*)(0x4242308CUL))
#define bFM4_MFT1_ICU_ICSA10_ICE0              *((volatile unsigned char*)(0x42423090UL))
#define bFM4_MFT1_ICU_ICSA10_ICE1              *((volatile unsigned char*)(0x42423094UL))
#define bFM4_MFT1_ICU_ICSA10_ICP0              *((volatile unsigned char*)(0x42423098UL))
#define bFM4_MFT1_ICU_ICSA10_ICP1              *((volatile unsigned char*)(0x4242309CUL))
#define bFM4_MFT1_ICU_ICSB10_IEI0              *((volatile unsigned char*)(0x424230A0UL))
#define bFM4_MFT1_ICU_ICSB10_IEI1              *((volatile unsigned char*)(0x424230A4UL))
#define bFM4_MFT1_ICU_ICSA32_EG00              *((volatile unsigned char*)(0x42423100UL))
#define bFM4_MFT1_ICU_ICSA32_EG01              *((volatile unsigned char*)(0x42423104UL))
#define bFM4_MFT1_ICU_ICSA32_EG10              *((volatile unsigned char*)(0x42423108UL))
#define bFM4_MFT1_ICU_ICSA32_EG11              *((volatile unsigned char*)(0x4242310CUL))
#define bFM4_MFT1_ICU_ICSA32_ICE0              *((volatile unsigned char*)(0x42423110UL))
#define bFM4_MFT1_ICU_ICSA32_ICE1              *((volatile unsigned char*)(0x42423114UL))
#define bFM4_MFT1_ICU_ICSA32_ICP0              *((volatile unsigned char*)(0x42423118UL))
#define bFM4_MFT1_ICU_ICSA32_ICP1              *((volatile unsigned char*)(0x4242311CUL))
#define bFM4_MFT1_ICU_ICSB32_IEI0              *((volatile unsigned char*)(0x42423120UL))
#define bFM4_MFT1_ICU_ICSB32_IEI1              *((volatile unsigned char*)(0x42423124UL))

/* Multifunction Timer unit 1 ADC Start Compare Unit registers */
#define bFM4_MFT1_ADCMP_ACSC0_BUFE0            *((volatile unsigned char*)(0x42423A80UL))
#define bFM4_MFT1_ADCMP_ACSC0_BUFE1            *((volatile unsigned char*)(0x42423A84UL))
#define bFM4_MFT1_ADCMP_ACSC0_ADSEL0           *((volatile unsigned char*)(0x42423A88UL))
#define bFM4_MFT1_ADCMP_ACSC0_ADSEL1           *((volatile unsigned char*)(0x42423A8CUL))
#define bFM4_MFT1_ADCMP_ACSC0_ADSEL2           *((volatile unsigned char*)(0x42423A90UL))
#define bFM4_MFT1_ADCMP_ACSC0_APBM             *((volatile unsigned char*)(0x42423A94UL))
#define bFM4_MFT1_ADCMP_ACSD0_AMOD             *((volatile unsigned char*)(0x42423AA0UL))
#define bFM4_MFT1_ADCMP_ACSD0_OCUS             *((volatile unsigned char*)(0x42423AA4UL))
#define bFM4_MFT1_ADCMP_ACSD0_DE               *((volatile unsigned char*)(0x42423AB0UL))
#define bFM4_MFT1_ADCMP_ACSD0_PE               *((volatile unsigned char*)(0x42423AB4UL))
#define bFM4_MFT1_ADCMP_ACSD0_UE               *((volatile unsigned char*)(0x42423AB8UL))
#define bFM4_MFT1_ADCMP_ACSD0_ZE               *((volatile unsigned char*)(0x42423ABCUL))
#define bFM4_MFT1_ADCMP_ACMC0_AMC0             *((volatile unsigned char*)(0x42423AC0UL))
#define bFM4_MFT1_ADCMP_ACMC0_AMC1             *((volatile unsigned char*)(0x42423AC4UL))
#define bFM4_MFT1_ADCMP_ACMC0_AMC2             *((volatile unsigned char*)(0x42423AC8UL))
#define bFM4_MFT1_ADCMP_ACMC0_AMC3             *((volatile unsigned char*)(0x42423ACCUL))
#define bFM4_MFT1_ADCMP_ACMC0_MZCE             *((volatile unsigned char*)(0x42423AD8UL))
#define bFM4_MFT1_ADCMP_ACMC0_MPCE             *((volatile unsigned char*)(0x42423ADCUL))
#define bFM4_MFT1_ADCMP_ACSC1_BUFE0            *((volatile unsigned char*)(0x42423B00UL))
#define bFM4_MFT1_ADCMP_ACSC1_BUFE1            *((volatile unsigned char*)(0x42423B04UL))
#define bFM4_MFT1_ADCMP_ACSC1_ADSEL0           *((volatile unsigned char*)(0x42423B08UL))
#define bFM4_MFT1_ADCMP_ACSC1_ADSEL1           *((volatile unsigned char*)(0x42423B0CUL))
#define bFM4_MFT1_ADCMP_ACSC1_ADSEL2           *((volatile unsigned char*)(0x42423B10UL))
#define bFM4_MFT1_ADCMP_ACSC1_APBM             *((volatile unsigned char*)(0x42423B14UL))
#define bFM4_MFT1_ADCMP_ACSD1_AMOD             *((volatile unsigned char*)(0x42423B20UL))
#define bFM4_MFT1_ADCMP_ACSD1_OCUS             *((volatile unsigned char*)(0x42423B24UL))
#define bFM4_MFT1_ADCMP_ACSD1_DE               *((volatile unsigned char*)(0x42423B30UL))
#define bFM4_MFT1_ADCMP_ACSD1_PE               *((volatile unsigned char*)(0x42423B34UL))
#define bFM4_MFT1_ADCMP_ACSD1_UE               *((volatile unsigned char*)(0x42423B38UL))
#define bFM4_MFT1_ADCMP_ACSD1_ZE               *((volatile unsigned char*)(0x42423B3CUL))
#define bFM4_MFT1_ADCMP_ACMC1_AMC0             *((volatile unsigned char*)(0x42423B40UL))
#define bFM4_MFT1_ADCMP_ACMC1_AMC1             *((volatile unsigned char*)(0x42423B44UL))
#define bFM4_MFT1_ADCMP_ACMC1_AMC2             *((volatile unsigned char*)(0x42423B48UL))
#define bFM4_MFT1_ADCMP_ACMC1_AMC3             *((volatile unsigned char*)(0x42423B4CUL))
#define bFM4_MFT1_ADCMP_ACMC1_MZCE             *((volatile unsigned char*)(0x42423B58UL))
#define bFM4_MFT1_ADCMP_ACMC1_MPCE             *((volatile unsigned char*)(0x42423B5CUL))
#define bFM4_MFT1_ADCMP_ACSC2_BUFE0            *((volatile unsigned char*)(0x42423B80UL))
#define bFM4_MFT1_ADCMP_ACSC2_BUFE1            *((volatile unsigned char*)(0x42423B84UL))
#define bFM4_MFT1_ADCMP_ACSC2_ADSEL0           *((volatile unsigned char*)(0x42423B88UL))
#define bFM4_MFT1_ADCMP_ACSC2_ADSEL1           *((volatile unsigned char*)(0x42423B8CUL))
#define bFM4_MFT1_ADCMP_ACSC2_ADSEL2           *((volatile unsigned char*)(0x42423B90UL))
#define bFM4_MFT1_ADCMP_ACSC2_APBM             *((volatile unsigned char*)(0x42423B94UL))
#define bFM4_MFT1_ADCMP_ACSD2_AMOD             *((volatile unsigned char*)(0x42423BA0UL))
#define bFM4_MFT1_ADCMP_ACSD2_OCUS             *((volatile unsigned char*)(0x42423BA4UL))
#define bFM4_MFT1_ADCMP_ACSD2_DE               *((volatile unsigned char*)(0x42423BB0UL))
#define bFM4_MFT1_ADCMP_ACSD2_PE               *((volatile unsigned char*)(0x42423BB4UL))
#define bFM4_MFT1_ADCMP_ACSD2_UE               *((volatile unsigned char*)(0x42423BB8UL))
#define bFM4_MFT1_ADCMP_ACSD2_ZE               *((volatile unsigned char*)(0x42423BBCUL))
#define bFM4_MFT1_ADCMP_ACMC2_AMC0             *((volatile unsigned char*)(0x42423BC0UL))
#define bFM4_MFT1_ADCMP_ACMC2_AMC1             *((volatile unsigned char*)(0x42423BC4UL))
#define bFM4_MFT1_ADCMP_ACMC2_AMC2             *((volatile unsigned char*)(0x42423BC8UL))
#define bFM4_MFT1_ADCMP_ACMC2_AMC3             *((volatile unsigned char*)(0x42423BCCUL))
#define bFM4_MFT1_ADCMP_ACMC2_MZCE             *((volatile unsigned char*)(0x42423BD8UL))
#define bFM4_MFT1_ADCMP_ACMC2_MPCE             *((volatile unsigned char*)(0x42423BDCUL))
#define bFM4_MFT1_ADCMP_ACSC3_BUFE0            *((volatile unsigned char*)(0x42423C00UL))
#define bFM4_MFT1_ADCMP_ACSC3_BUFE1            *((volatile unsigned char*)(0x42423C04UL))
#define bFM4_MFT1_ADCMP_ACSC3_ADSEL0           *((volatile unsigned char*)(0x42423C08UL))
#define bFM4_MFT1_ADCMP_ACSC3_ADSEL1           *((volatile unsigned char*)(0x42423C0CUL))
#define bFM4_MFT1_ADCMP_ACSC3_ADSEL2           *((volatile unsigned char*)(0x42423C10UL))
#define bFM4_MFT1_ADCMP_ACSC3_APBM             *((volatile unsigned char*)(0x42423C14UL))
#define bFM4_MFT1_ADCMP_ACSD3_AMOD             *((volatile unsigned char*)(0x42423C20UL))
#define bFM4_MFT1_ADCMP_ACSD3_OCUS             *((volatile unsigned char*)(0x42423C24UL))
#define bFM4_MFT1_ADCMP_ACSD3_DE               *((volatile unsigned char*)(0x42423C30UL))
#define bFM4_MFT1_ADCMP_ACSD3_PE               *((volatile unsigned char*)(0x42423C34UL))
#define bFM4_MFT1_ADCMP_ACSD3_UE               *((volatile unsigned char*)(0x42423C38UL))
#define bFM4_MFT1_ADCMP_ACSD3_ZE               *((volatile unsigned char*)(0x42423C3CUL))
#define bFM4_MFT1_ADCMP_ACMC3_AMC0             *((volatile unsigned char*)(0x42423C40UL))
#define bFM4_MFT1_ADCMP_ACMC3_AMC1             *((volatile unsigned char*)(0x42423C44UL))
#define bFM4_MFT1_ADCMP_ACMC3_AMC2             *((volatile unsigned char*)(0x42423C48UL))
#define bFM4_MFT1_ADCMP_ACMC3_AMC3             *((volatile unsigned char*)(0x42423C4CUL))
#define bFM4_MFT1_ADCMP_ACMC3_MZCE             *((volatile unsigned char*)(0x42423C58UL))
#define bFM4_MFT1_ADCMP_ACMC3_MPCE             *((volatile unsigned char*)(0x42423C5CUL))
#define bFM4_MFT1_ADCMP_ACSC4_BUFE0            *((volatile unsigned char*)(0x42423C80UL))
#define bFM4_MFT1_ADCMP_ACSC4_BUFE1            *((volatile unsigned char*)(0x42423C84UL))
#define bFM4_MFT1_ADCMP_ACSC4_ADSEL0           *((volatile unsigned char*)(0x42423C88UL))
#define bFM4_MFT1_ADCMP_ACSC4_ADSEL1           *((volatile unsigned char*)(0x42423C8CUL))
#define bFM4_MFT1_ADCMP_ACSC4_ADSEL2           *((volatile unsigned char*)(0x42423C90UL))
#define bFM4_MFT1_ADCMP_ACSC4_APBM             *((volatile unsigned char*)(0x42423C94UL))
#define bFM4_MFT1_ADCMP_ACSD4_AMOD             *((volatile unsigned char*)(0x42423CA0UL))
#define bFM4_MFT1_ADCMP_ACSD4_OCUS             *((volatile unsigned char*)(0x42423CA4UL))
#define bFM4_MFT1_ADCMP_ACSD4_DE               *((volatile unsigned char*)(0x42423CB0UL))
#define bFM4_MFT1_ADCMP_ACSD4_PE               *((volatile unsigned char*)(0x42423CB4UL))
#define bFM4_MFT1_ADCMP_ACSD4_UE               *((volatile unsigned char*)(0x42423CB8UL))
#define bFM4_MFT1_ADCMP_ACSD4_ZE               *((volatile unsigned char*)(0x42423CBCUL))
#define bFM4_MFT1_ADCMP_ACMC4_AMC0             *((volatile unsigned char*)(0x42423CC0UL))
#define bFM4_MFT1_ADCMP_ACMC4_AMC1             *((volatile unsigned char*)(0x42423CC4UL))
#define bFM4_MFT1_ADCMP_ACMC4_AMC2             *((volatile unsigned char*)(0x42423CC8UL))
#define bFM4_MFT1_ADCMP_ACMC4_AMC3             *((volatile unsigned char*)(0x42423CCCUL))
#define bFM4_MFT1_ADCMP_ACMC4_MZCE             *((volatile unsigned char*)(0x42423CD8UL))
#define bFM4_MFT1_ADCMP_ACMC4_MPCE             *((volatile unsigned char*)(0x42423CDCUL))
#define bFM4_MFT1_ADCMP_ACSC5_BUFE0            *((volatile unsigned char*)(0x42423D00UL))
#define bFM4_MFT1_ADCMP_ACSC5_BUFE1            *((volatile unsigned char*)(0x42423D04UL))
#define bFM4_MFT1_ADCMP_ACSC5_ADSEL0           *((volatile unsigned char*)(0x42423D08UL))
#define bFM4_MFT1_ADCMP_ACSC5_ADSEL1           *((volatile unsigned char*)(0x42423D0CUL))
#define bFM4_MFT1_ADCMP_ACSC5_ADSEL2           *((volatile unsigned char*)(0x42423D10UL))
#define bFM4_MFT1_ADCMP_ACSC5_APBM             *((volatile unsigned char*)(0x42423D14UL))
#define bFM4_MFT1_ADCMP_ACSD5_AMOD             *((volatile unsigned char*)(0x42423D20UL))
#define bFM4_MFT1_ADCMP_ACSD5_OCUS             *((volatile unsigned char*)(0x42423D24UL))
#define bFM4_MFT1_ADCMP_ACSD5_DE               *((volatile unsigned char*)(0x42423D30UL))
#define bFM4_MFT1_ADCMP_ACSD5_PE               *((volatile unsigned char*)(0x42423D34UL))
#define bFM4_MFT1_ADCMP_ACSD5_UE               *((volatile unsigned char*)(0x42423D38UL))
#define bFM4_MFT1_ADCMP_ACSD5_ZE               *((volatile unsigned char*)(0x42423D3CUL))
#define bFM4_MFT1_ADCMP_ACMC5_AMC0             *((volatile unsigned char*)(0x42423D40UL))
#define bFM4_MFT1_ADCMP_ACMC5_AMC1             *((volatile unsigned char*)(0x42423D44UL))
#define bFM4_MFT1_ADCMP_ACMC5_AMC2             *((volatile unsigned char*)(0x42423D48UL))
#define bFM4_MFT1_ADCMP_ACMC5_AMC3             *((volatile unsigned char*)(0x42423D4CUL))
#define bFM4_MFT1_ADCMP_ACMC5_MZCE             *((volatile unsigned char*)(0x42423D58UL))
#define bFM4_MFT1_ADCMP_ACMC5_MPCE             *((volatile unsigned char*)(0x42423D5CUL))

/* Multifunction Timer unit 2 Free Running Timer registers */
#define bFM4_MFT2_FRT_TCSA0_CLK0               *((volatile unsigned char*)(0x42442900UL))
#define bFM4_MFT2_FRT_TCSA0_CLK1               *((volatile unsigned char*)(0x42442904UL))
#define bFM4_MFT2_FRT_TCSA0_CLK2               *((volatile unsigned char*)(0x42442908UL))
#define bFM4_MFT2_FRT_TCSA0_CLK3               *((volatile unsigned char*)(0x4244290CUL))
#define bFM4_MFT2_FRT_TCSA0_SCLR               *((volatile unsigned char*)(0x42442910UL))
#define bFM4_MFT2_FRT_TCSA0_MODE               *((volatile unsigned char*)(0x42442914UL))
#define bFM4_MFT2_FRT_TCSA0_STOP               *((volatile unsigned char*)(0x42442918UL))
#define bFM4_MFT2_FRT_TCSA0_BFE                *((volatile unsigned char*)(0x4244291CUL))
#define bFM4_MFT2_FRT_TCSA0_ICRE               *((volatile unsigned char*)(0x42442920UL))
#define bFM4_MFT2_FRT_TCSA0_ICLR               *((volatile unsigned char*)(0x42442924UL))
#define bFM4_MFT2_FRT_TCSA0_IRQZE              *((volatile unsigned char*)(0x42442934UL))
#define bFM4_MFT2_FRT_TCSA0_IRQZF              *((volatile unsigned char*)(0x42442938UL))
#define bFM4_MFT2_FRT_TCSA0_ECKE               *((volatile unsigned char*)(0x4244293CUL))
#define bFM4_MFT2_FRT_TCSC0_MSZI0              *((volatile unsigned char*)(0x42442940UL))
#define bFM4_MFT2_FRT_TCSC0_MSZI1              *((volatile unsigned char*)(0x42442944UL))
#define bFM4_MFT2_FRT_TCSC0_MSZI2              *((volatile unsigned char*)(0x42442948UL))
#define bFM4_MFT2_FRT_TCSC0_MSZI3              *((volatile unsigned char*)(0x4244294CUL))
#define bFM4_MFT2_FRT_TCSC0_MSPI0              *((volatile unsigned char*)(0x42442950UL))
#define bFM4_MFT2_FRT_TCSC0_MSPI1              *((volatile unsigned char*)(0x42442954UL))
#define bFM4_MFT2_FRT_TCSC0_MSPI2              *((volatile unsigned char*)(0x42442958UL))
#define bFM4_MFT2_FRT_TCSC0_MSPI3              *((volatile unsigned char*)(0x4244295CUL))
#define bFM4_MFT2_FRT_TCSC0_MSZC0              *((volatile unsigned char*)(0x42442960UL))
#define bFM4_MFT2_FRT_TCSC0_MSZC1              *((volatile unsigned char*)(0x42442964UL))
#define bFM4_MFT2_FRT_TCSC0_MSZC2              *((volatile unsigned char*)(0x42442968UL))
#define bFM4_MFT2_FRT_TCSC0_MSZC3              *((volatile unsigned char*)(0x4244296CUL))
#define bFM4_MFT2_FRT_TCSC0_MSPC0              *((volatile unsigned char*)(0x42442970UL))
#define bFM4_MFT2_FRT_TCSC0_MSPC1              *((volatile unsigned char*)(0x42442974UL))
#define bFM4_MFT2_FRT_TCSC0_MSPC2              *((volatile unsigned char*)(0x42442978UL))
#define bFM4_MFT2_FRT_TCSC0_MSPC3              *((volatile unsigned char*)(0x4244297CUL))
#define bFM4_MFT2_FRT_TCSA1_CLK0               *((volatile unsigned char*)(0x42442A80UL))
#define bFM4_MFT2_FRT_TCSA1_CLK1               *((volatile unsigned char*)(0x42442A84UL))
#define bFM4_MFT2_FRT_TCSA1_CLK2               *((volatile unsigned char*)(0x42442A88UL))
#define bFM4_MFT2_FRT_TCSA1_CLK3               *((volatile unsigned char*)(0x42442A8CUL))
#define bFM4_MFT2_FRT_TCSA1_SCLR               *((volatile unsigned char*)(0x42442A90UL))
#define bFM4_MFT2_FRT_TCSA1_MODE               *((volatile unsigned char*)(0x42442A94UL))
#define bFM4_MFT2_FRT_TCSA1_STOP               *((volatile unsigned char*)(0x42442A98UL))
#define bFM4_MFT2_FRT_TCSA1_BFE                *((volatile unsigned char*)(0x42442A9CUL))
#define bFM4_MFT2_FRT_TCSA1_ICRE               *((volatile unsigned char*)(0x42442AA0UL))
#define bFM4_MFT2_FRT_TCSA1_ICLR               *((volatile unsigned char*)(0x42442AA4UL))
#define bFM4_MFT2_FRT_TCSA1_IRQZE              *((volatile unsigned char*)(0x42442AB4UL))
#define bFM4_MFT2_FRT_TCSA1_IRQZF              *((volatile unsigned char*)(0x42442AB8UL))
#define bFM4_MFT2_FRT_TCSA1_ECKE               *((volatile unsigned char*)(0x42442ABCUL))
#define bFM4_MFT2_FRT_TCSC1_MSZI0              *((volatile unsigned char*)(0x42442AC0UL))
#define bFM4_MFT2_FRT_TCSC1_MSZI1              *((volatile unsigned char*)(0x42442AC4UL))
#define bFM4_MFT2_FRT_TCSC1_MSZI2              *((volatile unsigned char*)(0x42442AC8UL))
#define bFM4_MFT2_FRT_TCSC1_MSZI3              *((volatile unsigned char*)(0x42442ACCUL))
#define bFM4_MFT2_FRT_TCSC1_MSPI0              *((volatile unsigned char*)(0x42442AD0UL))
#define bFM4_MFT2_FRT_TCSC1_MSPI1              *((volatile unsigned char*)(0x42442AD4UL))
#define bFM4_MFT2_FRT_TCSC1_MSPI2              *((volatile unsigned char*)(0x42442AD8UL))
#define bFM4_MFT2_FRT_TCSC1_MSPI3              *((volatile unsigned char*)(0x42442ADCUL))
#define bFM4_MFT2_FRT_TCSC1_MSZC0              *((volatile unsigned char*)(0x42442AE0UL))
#define bFM4_MFT2_FRT_TCSC1_MSZC1              *((volatile unsigned char*)(0x42442AE4UL))
#define bFM4_MFT2_FRT_TCSC1_MSZC2              *((volatile unsigned char*)(0x42442AE8UL))
#define bFM4_MFT2_FRT_TCSC1_MSZC3              *((volatile unsigned char*)(0x42442AECUL))
#define bFM4_MFT2_FRT_TCSC1_MSPC0              *((volatile unsigned char*)(0x42442AF0UL))
#define bFM4_MFT2_FRT_TCSC1_MSPC1              *((volatile unsigned char*)(0x42442AF4UL))
#define bFM4_MFT2_FRT_TCSC1_MSPC2              *((volatile unsigned char*)(0x42442AF8UL))
#define bFM4_MFT2_FRT_TCSC1_MSPC3              *((volatile unsigned char*)(0x42442AFCUL))
#define bFM4_MFT2_FRT_TCSA2_CLK0               *((volatile unsigned char*)(0x42442C00UL))
#define bFM4_MFT2_FRT_TCSA2_CLK1               *((volatile unsigned char*)(0x42442C04UL))
#define bFM4_MFT2_FRT_TCSA2_CLK2               *((volatile unsigned char*)(0x42442C08UL))
#define bFM4_MFT2_FRT_TCSA2_CLK3               *((volatile unsigned char*)(0x42442C0CUL))
#define bFM4_MFT2_FRT_TCSA2_SCLR               *((volatile unsigned char*)(0x42442C10UL))
#define bFM4_MFT2_FRT_TCSA2_MODE               *((volatile unsigned char*)(0x42442C14UL))
#define bFM4_MFT2_FRT_TCSA2_STOP               *((volatile unsigned char*)(0x42442C18UL))
#define bFM4_MFT2_FRT_TCSA2_BFE                *((volatile unsigned char*)(0x42442C1CUL))
#define bFM4_MFT2_FRT_TCSA2_ICRE               *((volatile unsigned char*)(0x42442C20UL))
#define bFM4_MFT2_FRT_TCSA2_ICLR               *((volatile unsigned char*)(0x42442C24UL))
#define bFM4_MFT2_FRT_TCSA2_IRQZE              *((volatile unsigned char*)(0x42442C34UL))
#define bFM4_MFT2_FRT_TCSA2_IRQZF              *((volatile unsigned char*)(0x42442C38UL))
#define bFM4_MFT2_FRT_TCSA2_ECKE               *((volatile unsigned char*)(0x42442C3CUL))
#define bFM4_MFT2_FRT_TCSC2_MSZI0              *((volatile unsigned char*)(0x42442C40UL))
#define bFM4_MFT2_FRT_TCSC2_MSZI1              *((volatile unsigned char*)(0x42442C44UL))
#define bFM4_MFT2_FRT_TCSC2_MSZI2              *((volatile unsigned char*)(0x42442C48UL))
#define bFM4_MFT2_FRT_TCSC2_MSZI3              *((volatile unsigned char*)(0x42442C4CUL))
#define bFM4_MFT2_FRT_TCSC2_MSPI0              *((volatile unsigned char*)(0x42442C50UL))
#define bFM4_MFT2_FRT_TCSC2_MSPI1              *((volatile unsigned char*)(0x42442C54UL))
#define bFM4_MFT2_FRT_TCSC2_MSPI2              *((volatile unsigned char*)(0x42442C58UL))
#define bFM4_MFT2_FRT_TCSC2_MSPI3              *((volatile unsigned char*)(0x42442C5CUL))
#define bFM4_MFT2_FRT_TCSC2_MSZC0              *((volatile unsigned char*)(0x42442C60UL))
#define bFM4_MFT2_FRT_TCSC2_MSZC1              *((volatile unsigned char*)(0x42442C64UL))
#define bFM4_MFT2_FRT_TCSC2_MSZC2              *((volatile unsigned char*)(0x42442C68UL))
#define bFM4_MFT2_FRT_TCSC2_MSZC3              *((volatile unsigned char*)(0x42442C6CUL))
#define bFM4_MFT2_FRT_TCSC2_MSPC0              *((volatile unsigned char*)(0x42442C70UL))
#define bFM4_MFT2_FRT_TCSC2_MSPC1              *((volatile unsigned char*)(0x42442C74UL))
#define bFM4_MFT2_FRT_TCSC2_MSPC2              *((volatile unsigned char*)(0x42442C78UL))
#define bFM4_MFT2_FRT_TCSC2_MSPC3              *((volatile unsigned char*)(0x42442C7CUL))
#define bFM4_MFT2_FRT_TCAL_STOP00              *((volatile unsigned char*)(0x42442C80UL))
#define bFM4_MFT2_FRT_TCAL_STOP01              *((volatile unsigned char*)(0x42442C84UL))
#define bFM4_MFT2_FRT_TCAL_STOP02              *((volatile unsigned char*)(0x42442C88UL))
#define bFM4_MFT2_FRT_TCAL_STOP10              *((volatile unsigned char*)(0x42442C8CUL))
#define bFM4_MFT2_FRT_TCAL_STOP11              *((volatile unsigned char*)(0x42442C90UL))
#define bFM4_MFT2_FRT_TCAL_STOP12              *((volatile unsigned char*)(0x42442C94UL))
#define bFM4_MFT2_FRT_TCAL_STOP20              *((volatile unsigned char*)(0x42442C98UL))
#define bFM4_MFT2_FRT_TCAL_STOP21              *((volatile unsigned char*)(0x42442C9CUL))
#define bFM4_MFT2_FRT_TCAL_STOP22              *((volatile unsigned char*)(0x42442CA0UL))
#define bFM4_MFT2_FRT_TCAL_SCLR00              *((volatile unsigned char*)(0x42442CC0UL))
#define bFM4_MFT2_FRT_TCAL_SCLR01              *((volatile unsigned char*)(0x42442CC4UL))
#define bFM4_MFT2_FRT_TCAL_SCLR02              *((volatile unsigned char*)(0x42442CC8UL))
#define bFM4_MFT2_FRT_TCAL_SCLR10              *((volatile unsigned char*)(0x42442CCCUL))
#define bFM4_MFT2_FRT_TCAL_SCLR11              *((volatile unsigned char*)(0x42442CD0UL))
#define bFM4_MFT2_FRT_TCAL_SCLR12              *((volatile unsigned char*)(0x42442CD4UL))
#define bFM4_MFT2_FRT_TCAL_SCLR20              *((volatile unsigned char*)(0x42442CD8UL))
#define bFM4_MFT2_FRT_TCAL_SCLR21              *((volatile unsigned char*)(0x42442CDCUL))
#define bFM4_MFT2_FRT_TCAL_SCLR22              *((volatile unsigned char*)(0x42442CE0UL))
#define bFM4_MFT2_FRT_TCSD_OFMD1               *((volatile unsigned char*)(0x42443D80UL))
#define bFM4_MFT2_FRT_TCSD_OFMD2               *((volatile unsigned char*)(0x42443D84UL))

/* Multifunction Timer unit 2 Output Compare Unit registers */
#define bFM4_MFT2_OCU_OCSA10_CST0              *((volatile unsigned char*)(0x42442300UL))
#define bFM4_MFT2_OCU_OCSA10_CST1              *((volatile unsigned char*)(0x42442304UL))
#define bFM4_MFT2_OCU_OCSA10_IOE0              *((volatile unsigned char*)(0x42442310UL))
#define bFM4_MFT2_OCU_OCSA10_IOE1              *((volatile unsigned char*)(0x42442314UL))
#define bFM4_MFT2_OCU_OCSA10_IOP0              *((volatile unsigned char*)(0x42442318UL))
#define bFM4_MFT2_OCU_OCSA10_IOP1              *((volatile unsigned char*)(0x4244231CUL))
#define bFM4_MFT2_OCU_OCSB10_OTD0              *((volatile unsigned char*)(0x42442320UL))
#define bFM4_MFT2_OCU_OCSB10_OTD1              *((volatile unsigned char*)(0x42442324UL))
#define bFM4_MFT2_OCU_OCSB10_CMOD              *((volatile unsigned char*)(0x42442330UL))
#define bFM4_MFT2_OCU_OCSB10_FM4               *((volatile unsigned char*)(0x4244233CUL))
#define bFM4_MFT2_OCU_OCSD10_OCCP0BUFE0        *((volatile unsigned char*)(0x42442340UL))
#define bFM4_MFT2_OCU_OCSD10_OCCP0BUFE1        *((volatile unsigned char*)(0x42442344UL))
#define bFM4_MFT2_OCU_OCSD10_OCCP1BUFE0        *((volatile unsigned char*)(0x42442348UL))
#define bFM4_MFT2_OCU_OCSD10_OCCP1BUFE1        *((volatile unsigned char*)(0x4244234CUL))
#define bFM4_MFT2_OCU_OCSD10_OCSE0BUFE0        *((volatile unsigned char*)(0x42442350UL))
#define bFM4_MFT2_OCU_OCSD10_OCSE0BUFE1        *((volatile unsigned char*)(0x42442354UL))
#define bFM4_MFT2_OCU_OCSD10_OCSE1BUFE0        *((volatile unsigned char*)(0x42442358UL))
#define bFM4_MFT2_OCU_OCSD10_OCSE1BUFE1        *((volatile unsigned char*)(0x4244235CUL))
#define bFM4_MFT2_OCU_OCSD10_OPBM0             *((volatile unsigned char*)(0x42442360UL))
#define bFM4_MFT2_OCU_OCSD10_OPBM1             *((volatile unsigned char*)(0x42442364UL))
#define bFM4_MFT2_OCU_OCSD10_OEBM0             *((volatile unsigned char*)(0x42442368UL))
#define bFM4_MFT2_OCU_OCSD10_OEBM1             *((volatile unsigned char*)(0x4244236CUL))
#define bFM4_MFT2_OCU_OCSD10_OFEX0             *((volatile unsigned char*)(0x42442370UL))
#define bFM4_MFT2_OCU_OCSD10_OFEX1             *((volatile unsigned char*)(0x42442374UL))
#define bFM4_MFT2_OCU_OCSA32_CST0              *((volatile unsigned char*)(0x42442380UL))
#define bFM4_MFT2_OCU_OCSA32_CST1              *((volatile unsigned char*)(0x42442384UL))
#define bFM4_MFT2_OCU_OCSA32_IOE0              *((volatile unsigned char*)(0x42442390UL))
#define bFM4_MFT2_OCU_OCSA32_IOE1              *((volatile unsigned char*)(0x42442394UL))
#define bFM4_MFT2_OCU_OCSA32_IOP0              *((volatile unsigned char*)(0x42442398UL))
#define bFM4_MFT2_OCU_OCSA32_IOP1              *((volatile unsigned char*)(0x4244239CUL))
#define bFM4_MFT2_OCU_OCSB32_OTD0              *((volatile unsigned char*)(0x424423A0UL))
#define bFM4_MFT2_OCU_OCSB32_OTD1              *((volatile unsigned char*)(0x424423A4UL))
#define bFM4_MFT2_OCU_OCSB32_CMOD              *((volatile unsigned char*)(0x424423B0UL))
#define bFM4_MFT2_OCU_OCSB32_FM4               *((volatile unsigned char*)(0x424423BCUL))
#define bFM4_MFT2_OCU_OCSD32_OCCP2BUFE0        *((volatile unsigned char*)(0x424423C0UL))
#define bFM4_MFT2_OCU_OCSD32_OCCP2BUFE1        *((volatile unsigned char*)(0x424423C4UL))
#define bFM4_MFT2_OCU_OCSD32_OCCP3BUFE0        *((volatile unsigned char*)(0x424423C8UL))
#define bFM4_MFT2_OCU_OCSD32_OCCP3BUFE1        *((volatile unsigned char*)(0x424423CCUL))
#define bFM4_MFT2_OCU_OCSD32_OCSE2BUFE0        *((volatile unsigned char*)(0x424423D0UL))
#define bFM4_MFT2_OCU_OCSD32_OCSE2BUFE1        *((volatile unsigned char*)(0x424423D4UL))
#define bFM4_MFT2_OCU_OCSD32_OCSE3BUFE0        *((volatile unsigned char*)(0x424423D8UL))
#define bFM4_MFT2_OCU_OCSD32_OCSE3BUFE1        *((volatile unsigned char*)(0x424423DCUL))
#define bFM4_MFT2_OCU_OCSD32_OPBM2             *((volatile unsigned char*)(0x424423E0UL))
#define bFM4_MFT2_OCU_OCSD32_OPBM3             *((volatile unsigned char*)(0x424423E4UL))
#define bFM4_MFT2_OCU_OCSD32_OEBM2             *((volatile unsigned char*)(0x424423E8UL))
#define bFM4_MFT2_OCU_OCSD32_OEBM3             *((volatile unsigned char*)(0x424423ECUL))
#define bFM4_MFT2_OCU_OCSD32_OFEX2             *((volatile unsigned char*)(0x424423F0UL))
#define bFM4_MFT2_OCU_OCSD32_OFEX3             *((volatile unsigned char*)(0x424423F4UL))
#define bFM4_MFT2_OCU_OCSA54_CST0              *((volatile unsigned char*)(0x42442400UL))
#define bFM4_MFT2_OCU_OCSA54_CST1              *((volatile unsigned char*)(0x42442404UL))
#define bFM4_MFT2_OCU_OCSA54_IOE0              *((volatile unsigned char*)(0x42442410UL))
#define bFM4_MFT2_OCU_OCSA54_IOE1              *((volatile unsigned char*)(0x42442414UL))
#define bFM4_MFT2_OCU_OCSA54_IOP0              *((volatile unsigned char*)(0x42442418UL))
#define bFM4_MFT2_OCU_OCSA54_IOP1              *((volatile unsigned char*)(0x4244241CUL))
#define bFM4_MFT2_OCU_OCSB54_OTD0              *((volatile unsigned char*)(0x42442420UL))
#define bFM4_MFT2_OCU_OCSB54_OTD1              *((volatile unsigned char*)(0x42442424UL))
#define bFM4_MFT2_OCU_OCSB54_CMOD              *((volatile unsigned char*)(0x42442430UL))
#define bFM4_MFT2_OCU_OCSB54_FM4               *((volatile unsigned char*)(0x4244243CUL))
#define bFM4_MFT2_OCU_OCSD54_OCCP4BUFE0        *((volatile unsigned char*)(0x42442440UL))
#define bFM4_MFT2_OCU_OCSD54_OCCP4BUFE1        *((volatile unsigned char*)(0x42442444UL))
#define bFM4_MFT2_OCU_OCSD54_OCCP5BUFE0        *((volatile unsigned char*)(0x42442448UL))
#define bFM4_MFT2_OCU_OCSD54_OCCP5BUFE1        *((volatile unsigned char*)(0x4244244CUL))
#define bFM4_MFT2_OCU_OCSD54_OCSE4BUFE0        *((volatile unsigned char*)(0x42442450UL))
#define bFM4_MFT2_OCU_OCSD54_OCSE4BUFE1        *((volatile unsigned char*)(0x42442454UL))
#define bFM4_MFT2_OCU_OCSD54_OCSE5BUFE0        *((volatile unsigned char*)(0x42442458UL))
#define bFM4_MFT2_OCU_OCSD54_OCSE5BUFE1        *((volatile unsigned char*)(0x4244245CUL))
#define bFM4_MFT2_OCU_OCSD54_OPBM4             *((volatile unsigned char*)(0x42442460UL))
#define bFM4_MFT2_OCU_OCSD54_OPBM5             *((volatile unsigned char*)(0x42442464UL))
#define bFM4_MFT2_OCU_OCSD54_OEBM4             *((volatile unsigned char*)(0x42442468UL))
#define bFM4_MFT2_OCU_OCSD54_OEBM5             *((volatile unsigned char*)(0x4244246CUL))
#define bFM4_MFT2_OCU_OCSD54_OFEX4             *((volatile unsigned char*)(0x42442470UL))
#define bFM4_MFT2_OCU_OCSD54_OFEX5             *((volatile unsigned char*)(0x42442474UL))
#define bFM4_MFT2_OCU_OCSC_MOD0                *((volatile unsigned char*)(0x424424A0UL))
#define bFM4_MFT2_OCU_OCSC_MOD1                *((volatile unsigned char*)(0x424424A4UL))
#define bFM4_MFT2_OCU_OCSC_MOD2                *((volatile unsigned char*)(0x424424A8UL))
#define bFM4_MFT2_OCU_OCSC_MOD3                *((volatile unsigned char*)(0x424424ACUL))
#define bFM4_MFT2_OCU_OCSC_MOD4                *((volatile unsigned char*)(0x424424B0UL))
#define bFM4_MFT2_OCU_OCSC_MOD5                *((volatile unsigned char*)(0x424424B4UL))
#define bFM4_MFT2_OCU_OCFS10_FSO00             *((volatile unsigned char*)(0x42442D00UL))
#define bFM4_MFT2_OCU_OCFS10_FSO01             *((volatile unsigned char*)(0x42442D04UL))
#define bFM4_MFT2_OCU_OCFS10_FSO02             *((volatile unsigned char*)(0x42442D08UL))
#define bFM4_MFT2_OCU_OCFS10_FSO03             *((volatile unsigned char*)(0x42442D0CUL))
#define bFM4_MFT2_OCU_OCFS10_FSO10             *((volatile unsigned char*)(0x42442D10UL))
#define bFM4_MFT2_OCU_OCFS10_FSO11             *((volatile unsigned char*)(0x42442D14UL))
#define bFM4_MFT2_OCU_OCFS10_FSO12             *((volatile unsigned char*)(0x42442D18UL))
#define bFM4_MFT2_OCU_OCFS10_FSO13             *((volatile unsigned char*)(0x42442D1CUL))
#define bFM4_MFT2_OCU_OCFS32_FSO00             *((volatile unsigned char*)(0x42442D20UL))
#define bFM4_MFT2_OCU_OCFS32_FSO01             *((volatile unsigned char*)(0x42442D24UL))
#define bFM4_MFT2_OCU_OCFS32_FSO02             *((volatile unsigned char*)(0x42442D28UL))
#define bFM4_MFT2_OCU_OCFS32_FSO03             *((volatile unsigned char*)(0x42442D2CUL))
#define bFM4_MFT2_OCU_OCFS32_FSO10             *((volatile unsigned char*)(0x42442D30UL))
#define bFM4_MFT2_OCU_OCFS32_FSO11             *((volatile unsigned char*)(0x42442D34UL))
#define bFM4_MFT2_OCU_OCFS32_FSO12             *((volatile unsigned char*)(0x42442D38UL))
#define bFM4_MFT2_OCU_OCFS32_FSO13             *((volatile unsigned char*)(0x42442D3CUL))
#define bFM4_MFT2_OCU_OCFS54_FSO00             *((volatile unsigned char*)(0x42442D40UL))
#define bFM4_MFT2_OCU_OCFS54_FSO01             *((volatile unsigned char*)(0x42442D44UL))
#define bFM4_MFT2_OCU_OCFS54_FSO02             *((volatile unsigned char*)(0x42442D48UL))
#define bFM4_MFT2_OCU_OCFS54_FSO03             *((volatile unsigned char*)(0x42442D4CUL))
#define bFM4_MFT2_OCU_OCFS54_FSO10             *((volatile unsigned char*)(0x42442D50UL))
#define bFM4_MFT2_OCU_OCFS54_FSO11             *((volatile unsigned char*)(0x42442D54UL))
#define bFM4_MFT2_OCU_OCFS54_FSO12             *((volatile unsigned char*)(0x42442D58UL))
#define bFM4_MFT2_OCU_OCFS54_FSO13             *((volatile unsigned char*)(0x42442D5CUL))

/* Multifunction Timer unit 2 Waveform Generator and Noise Canceler registers */
#define bFM4_MFT2_WFG_WFSA10_DCK0              *((volatile unsigned char*)(0x42443480UL))
#define bFM4_MFT2_WFG_WFSA10_DCK1              *((volatile unsigned char*)(0x42443484UL))
#define bFM4_MFT2_WFG_WFSA10_DCK2              *((volatile unsigned char*)(0x42443488UL))
#define bFM4_MFT2_WFG_WFSA10_GTEN0             *((volatile unsigned char*)(0x42443498UL))
#define bFM4_MFT2_WFG_WFSA10_GTEN1             *((volatile unsigned char*)(0x4244349CUL))
#define bFM4_MFT2_WFG_WFSA10_PSEL0             *((volatile unsigned char*)(0x424434A0UL))
#define bFM4_MFT2_WFG_WFSA10_PSEL1             *((volatile unsigned char*)(0x424434A4UL))
#define bFM4_MFT2_WFG_WFSA10_PGEN0             *((volatile unsigned char*)(0x424434A8UL))
#define bFM4_MFT2_WFG_WFSA10_PGEN1             *((volatile unsigned char*)(0x424434ACUL))
#define bFM4_MFT2_WFG_WFSA32_DCK0              *((volatile unsigned char*)(0x42443500UL))
#define bFM4_MFT2_WFG_WFSA32_DCK1              *((volatile unsigned char*)(0x42443504UL))
#define bFM4_MFT2_WFG_WFSA32_DCK2              *((volatile unsigned char*)(0x42443508UL))
#define bFM4_MFT2_WFG_WFSA32_GTEN0             *((volatile unsigned char*)(0x42443518UL))
#define bFM4_MFT2_WFG_WFSA32_GTEN1             *((volatile unsigned char*)(0x4244351CUL))
#define bFM4_MFT2_WFG_WFSA32_PSEL0             *((volatile unsigned char*)(0x42443520UL))
#define bFM4_MFT2_WFG_WFSA32_PSEL1             *((volatile unsigned char*)(0x42443524UL))
#define bFM4_MFT2_WFG_WFSA32_PGEN0             *((volatile unsigned char*)(0x42443528UL))
#define bFM4_MFT2_WFG_WFSA32_PGEN1             *((volatile unsigned char*)(0x4244352CUL))
#define bFM4_MFT2_WFG_WFSA54_DCK0              *((volatile unsigned char*)(0x42443580UL))
#define bFM4_MFT2_WFG_WFSA54_DCK1              *((volatile unsigned char*)(0x42443584UL))
#define bFM4_MFT2_WFG_WFSA54_DCK2              *((volatile unsigned char*)(0x42443588UL))
#define bFM4_MFT2_WFG_WFSA54_GTEN0             *((volatile unsigned char*)(0x42443598UL))
#define bFM4_MFT2_WFG_WFSA54_GTEN1             *((volatile unsigned char*)(0x4244359CUL))
#define bFM4_MFT2_WFG_WFSA54_PSEL0             *((volatile unsigned char*)(0x424435A0UL))
#define bFM4_MFT2_WFG_WFSA54_PSEL1             *((volatile unsigned char*)(0x424435A4UL))
#define bFM4_MFT2_WFG_WFSA54_PGEN0             *((volatile unsigned char*)(0x424435A8UL))
#define bFM4_MFT2_WFG_WFSA54_PGEN1             *((volatile unsigned char*)(0x424435ACUL))
#define bFM4_MFT2_WFG_WFIR_DTIFA               *((volatile unsigned char*)(0x42443600UL))
#define bFM4_MFT2_WFG_WFIR_DTICA               *((volatile unsigned char*)(0x42443604UL))
#define bFM4_MFT2_WFG_WFIR_DTIFB               *((volatile unsigned char*)(0x42443608UL))
#define bFM4_MFT2_WFG_WFIR_DTICB               *((volatile unsigned char*)(0x4244360CUL))
#define bFM4_MFT2_WFG_WFIR_TMIF10              *((volatile unsigned char*)(0x42443610UL))
#define bFM4_MFT2_WFG_WFIR_TMIC10              *((volatile unsigned char*)(0x42443614UL))
#define bFM4_MFT2_WFG_WFIR_TMIE10              *((volatile unsigned char*)(0x42443618UL))
#define bFM4_MFT2_WFG_WFIR_TMIS10              *((volatile unsigned char*)(0x4244361CUL))
#define bFM4_MFT2_WFG_WFIR_TMIF32              *((volatile unsigned char*)(0x42443620UL))
#define bFM4_MFT2_WFG_WFIR_TMIC32              *((volatile unsigned char*)(0x42443624UL))
#define bFM4_MFT2_WFG_WFIR_TMIE32              *((volatile unsigned char*)(0x42443628UL))
#define bFM4_MFT2_WFG_WFIR_TMIS32              *((volatile unsigned char*)(0x4244362CUL))
#define bFM4_MFT2_WFG_WFIR_TMIF54              *((volatile unsigned char*)(0x42443630UL))
#define bFM4_MFT2_WFG_WFIR_TMIC54              *((volatile unsigned char*)(0x42443634UL))
#define bFM4_MFT2_WFG_WFIR_TMIE54              *((volatile unsigned char*)(0x42443638UL))
#define bFM4_MFT2_WFG_WFIR_TMIS54              *((volatile unsigned char*)(0x4244363CUL))
#define bFM4_MFT2_WFG_NZCL_DTIEA               *((volatile unsigned char*)(0x42443680UL))
#define bFM4_MFT2_WFG_NZCL_NWS0                *((volatile unsigned char*)(0x42443684UL))
#define bFM4_MFT2_WFG_NZCL_NWS1                *((volatile unsigned char*)(0x42443688UL))
#define bFM4_MFT2_WFG_NZCL_NWS2                *((volatile unsigned char*)(0x4244368CUL))
#define bFM4_MFT2_WFG_NZCL_SDTI                *((volatile unsigned char*)(0x42443690UL))
#define bFM4_MFT2_WFG_NZCL_DTIEB               *((volatile unsigned char*)(0x42443694UL))
#define bFM4_MFT2_WFG_NZCL_DHOLD               *((volatile unsigned char*)(0x4244369CUL))
#define bFM4_MFT2_WFG_NZCL_DIMA                *((volatile unsigned char*)(0x424436A0UL))
#define bFM4_MFT2_WFG_NZCL_DIMB                *((volatile unsigned char*)(0x424436A4UL))
#define bFM4_MFT2_WFG_NZCL_WIM10               *((volatile unsigned char*)(0x424436B0UL))
#define bFM4_MFT2_WFG_NZCL_WIM32               *((volatile unsigned char*)(0x424436B4UL))
#define bFM4_MFT2_WFG_NZCL_WIM54               *((volatile unsigned char*)(0x424436B8UL))

/* Multifunction Timer unit 2 Input Capture Unit registers */
#define bFM4_MFT2_ICU_ICFS10_FSI00             *((volatile unsigned char*)(0x42442D80UL))
#define bFM4_MFT2_ICU_ICFS10_FSI01             *((volatile unsigned char*)(0x42442D84UL))
#define bFM4_MFT2_ICU_ICFS10_FSI02             *((volatile unsigned char*)(0x42442D88UL))
#define bFM4_MFT2_ICU_ICFS10_FSI03             *((volatile unsigned char*)(0x42442D8CUL))
#define bFM4_MFT2_ICU_ICFS10_FSI10             *((volatile unsigned char*)(0x42442D90UL))
#define bFM4_MFT2_ICU_ICFS10_FSI11             *((volatile unsigned char*)(0x42442D94UL))
#define bFM4_MFT2_ICU_ICFS10_FSI12             *((volatile unsigned char*)(0x42442D98UL))
#define bFM4_MFT2_ICU_ICFS10_FSI13             *((volatile unsigned char*)(0x42442D9CUL))
#define bFM4_MFT2_ICU_ICFS32_FSI00             *((volatile unsigned char*)(0x42442DA0UL))
#define bFM4_MFT2_ICU_ICFS32_FSI01             *((volatile unsigned char*)(0x42442DA4UL))
#define bFM4_MFT2_ICU_ICFS32_FSI02             *((volatile unsigned char*)(0x42442DA8UL))
#define bFM4_MFT2_ICU_ICFS32_FSI03             *((volatile unsigned char*)(0x42442DACUL))
#define bFM4_MFT2_ICU_ICFS32_FSI10             *((volatile unsigned char*)(0x42442DB0UL))
#define bFM4_MFT2_ICU_ICFS32_FSI11             *((volatile unsigned char*)(0x42442DB4UL))
#define bFM4_MFT2_ICU_ICFS32_FSI12             *((volatile unsigned char*)(0x42442DB8UL))
#define bFM4_MFT2_ICU_ICFS32_FSI13             *((volatile unsigned char*)(0x42442DBCUL))
#define bFM4_MFT2_ICU_ICSA10_EG00              *((volatile unsigned char*)(0x42443080UL))
#define bFM4_MFT2_ICU_ICSA10_EG01              *((volatile unsigned char*)(0x42443084UL))
#define bFM4_MFT2_ICU_ICSA10_EG10              *((volatile unsigned char*)(0x42443088UL))
#define bFM4_MFT2_ICU_ICSA10_EG11              *((volatile unsigned char*)(0x4244308CUL))
#define bFM4_MFT2_ICU_ICSA10_ICE0              *((volatile unsigned char*)(0x42443090UL))
#define bFM4_MFT2_ICU_ICSA10_ICE1              *((volatile unsigned char*)(0x42443094UL))
#define bFM4_MFT2_ICU_ICSA10_ICP0              *((volatile unsigned char*)(0x42443098UL))
#define bFM4_MFT2_ICU_ICSA10_ICP1              *((volatile unsigned char*)(0x4244309CUL))
#define bFM4_MFT2_ICU_ICSB10_IEI0              *((volatile unsigned char*)(0x424430A0UL))
#define bFM4_MFT2_ICU_ICSB10_IEI1              *((volatile unsigned char*)(0x424430A4UL))
#define bFM4_MFT2_ICU_ICSA32_EG00              *((volatile unsigned char*)(0x42443100UL))
#define bFM4_MFT2_ICU_ICSA32_EG01              *((volatile unsigned char*)(0x42443104UL))
#define bFM4_MFT2_ICU_ICSA32_EG10              *((volatile unsigned char*)(0x42443108UL))
#define bFM4_MFT2_ICU_ICSA32_EG11              *((volatile unsigned char*)(0x4244310CUL))
#define bFM4_MFT2_ICU_ICSA32_ICE0              *((volatile unsigned char*)(0x42443110UL))
#define bFM4_MFT2_ICU_ICSA32_ICE1              *((volatile unsigned char*)(0x42443114UL))
#define bFM4_MFT2_ICU_ICSA32_ICP0              *((volatile unsigned char*)(0x42443118UL))
#define bFM4_MFT2_ICU_ICSA32_ICP1              *((volatile unsigned char*)(0x4244311CUL))
#define bFM4_MFT2_ICU_ICSB32_IEI0              *((volatile unsigned char*)(0x42443120UL))
#define bFM4_MFT2_ICU_ICSB32_IEI1              *((volatile unsigned char*)(0x42443124UL))

/* Multifunction Timer unit 2 ADC Start Compare Unit registers */
#define bFM4_MFT2_ADCMP_ACSC0_BUFE0            *((volatile unsigned char*)(0x42443A80UL))
#define bFM4_MFT2_ADCMP_ACSC0_BUFE1            *((volatile unsigned char*)(0x42443A84UL))
#define bFM4_MFT2_ADCMP_ACSC0_ADSEL0           *((volatile unsigned char*)(0x42443A88UL))
#define bFM4_MFT2_ADCMP_ACSC0_ADSEL1           *((volatile unsigned char*)(0x42443A8CUL))
#define bFM4_MFT2_ADCMP_ACSC0_ADSEL2           *((volatile unsigned char*)(0x42443A90UL))
#define bFM4_MFT2_ADCMP_ACSC0_APBM             *((volatile unsigned char*)(0x42443A94UL))
#define bFM4_MFT2_ADCMP_ACSD0_AMOD             *((volatile unsigned char*)(0x42443AA0UL))
#define bFM4_MFT2_ADCMP_ACSD0_OCUS             *((volatile unsigned char*)(0x42443AA4UL))
#define bFM4_MFT2_ADCMP_ACSD0_DE               *((volatile unsigned char*)(0x42443AB0UL))
#define bFM4_MFT2_ADCMP_ACSD0_PE               *((volatile unsigned char*)(0x42443AB4UL))
#define bFM4_MFT2_ADCMP_ACSD0_UE               *((volatile unsigned char*)(0x42443AB8UL))
#define bFM4_MFT2_ADCMP_ACSD0_ZE               *((volatile unsigned char*)(0x42443ABCUL))
#define bFM4_MFT2_ADCMP_ACMC0_AMC0             *((volatile unsigned char*)(0x42443AC0UL))
#define bFM4_MFT2_ADCMP_ACMC0_AMC1             *((volatile unsigned char*)(0x42443AC4UL))
#define bFM4_MFT2_ADCMP_ACMC0_AMC2             *((volatile unsigned char*)(0x42443AC8UL))
#define bFM4_MFT2_ADCMP_ACMC0_AMC3             *((volatile unsigned char*)(0x42443ACCUL))
#define bFM4_MFT2_ADCMP_ACMC0_MZCE             *((volatile unsigned char*)(0x42443AD8UL))
#define bFM4_MFT2_ADCMP_ACMC0_MPCE             *((volatile unsigned char*)(0x42443ADCUL))
#define bFM4_MFT2_ADCMP_ACSC1_BUFE0            *((volatile unsigned char*)(0x42443B00UL))
#define bFM4_MFT2_ADCMP_ACSC1_BUFE1            *((volatile unsigned char*)(0x42443B04UL))
#define bFM4_MFT2_ADCMP_ACSC1_ADSEL0           *((volatile unsigned char*)(0x42443B08UL))
#define bFM4_MFT2_ADCMP_ACSC1_ADSEL1           *((volatile unsigned char*)(0x42443B0CUL))
#define bFM4_MFT2_ADCMP_ACSC1_ADSEL2           *((volatile unsigned char*)(0x42443B10UL))
#define bFM4_MFT2_ADCMP_ACSC1_APBM             *((volatile unsigned char*)(0x42443B14UL))
#define bFM4_MFT2_ADCMP_ACSD1_AMOD             *((volatile unsigned char*)(0x42443B20UL))
#define bFM4_MFT2_ADCMP_ACSD1_OCUS             *((volatile unsigned char*)(0x42443B24UL))
#define bFM4_MFT2_ADCMP_ACSD1_DE               *((volatile unsigned char*)(0x42443B30UL))
#define bFM4_MFT2_ADCMP_ACSD1_PE               *((volatile unsigned char*)(0x42443B34UL))
#define bFM4_MFT2_ADCMP_ACSD1_UE               *((volatile unsigned char*)(0x42443B38UL))
#define bFM4_MFT2_ADCMP_ACSD1_ZE               *((volatile unsigned char*)(0x42443B3CUL))
#define bFM4_MFT2_ADCMP_ACMC1_AMC0             *((volatile unsigned char*)(0x42443B40UL))
#define bFM4_MFT2_ADCMP_ACMC1_AMC1             *((volatile unsigned char*)(0x42443B44UL))
#define bFM4_MFT2_ADCMP_ACMC1_AMC2             *((volatile unsigned char*)(0x42443B48UL))
#define bFM4_MFT2_ADCMP_ACMC1_AMC3             *((volatile unsigned char*)(0x42443B4CUL))
#define bFM4_MFT2_ADCMP_ACMC1_MZCE             *((volatile unsigned char*)(0x42443B58UL))
#define bFM4_MFT2_ADCMP_ACMC1_MPCE             *((volatile unsigned char*)(0x42443B5CUL))
#define bFM4_MFT2_ADCMP_ACSC2_BUFE0            *((volatile unsigned char*)(0x42443B80UL))
#define bFM4_MFT2_ADCMP_ACSC2_BUFE1            *((volatile unsigned char*)(0x42443B84UL))
#define bFM4_MFT2_ADCMP_ACSC2_ADSEL0           *((volatile unsigned char*)(0x42443B88UL))
#define bFM4_MFT2_ADCMP_ACSC2_ADSEL1           *((volatile unsigned char*)(0x42443B8CUL))
#define bFM4_MFT2_ADCMP_ACSC2_ADSEL2           *((volatile unsigned char*)(0x42443B90UL))
#define bFM4_MFT2_ADCMP_ACSC2_APBM             *((volatile unsigned char*)(0x42443B94UL))
#define bFM4_MFT2_ADCMP_ACSD2_AMOD             *((volatile unsigned char*)(0x42443BA0UL))
#define bFM4_MFT2_ADCMP_ACSD2_OCUS             *((volatile unsigned char*)(0x42443BA4UL))
#define bFM4_MFT2_ADCMP_ACSD2_DE               *((volatile unsigned char*)(0x42443BB0UL))
#define bFM4_MFT2_ADCMP_ACSD2_PE               *((volatile unsigned char*)(0x42443BB4UL))
#define bFM4_MFT2_ADCMP_ACSD2_UE               *((volatile unsigned char*)(0x42443BB8UL))
#define bFM4_MFT2_ADCMP_ACSD2_ZE               *((volatile unsigned char*)(0x42443BBCUL))
#define bFM4_MFT2_ADCMP_ACMC2_AMC0             *((volatile unsigned char*)(0x42443BC0UL))
#define bFM4_MFT2_ADCMP_ACMC2_AMC1             *((volatile unsigned char*)(0x42443BC4UL))
#define bFM4_MFT2_ADCMP_ACMC2_AMC2             *((volatile unsigned char*)(0x42443BC8UL))
#define bFM4_MFT2_ADCMP_ACMC2_AMC3             *((volatile unsigned char*)(0x42443BCCUL))
#define bFM4_MFT2_ADCMP_ACMC2_MZCE             *((volatile unsigned char*)(0x42443BD8UL))
#define bFM4_MFT2_ADCMP_ACMC2_MPCE             *((volatile unsigned char*)(0x42443BDCUL))
#define bFM4_MFT2_ADCMP_ACSC3_BUFE0            *((volatile unsigned char*)(0x42443C00UL))
#define bFM4_MFT2_ADCMP_ACSC3_BUFE1            *((volatile unsigned char*)(0x42443C04UL))
#define bFM4_MFT2_ADCMP_ACSC3_ADSEL0           *((volatile unsigned char*)(0x42443C08UL))
#define bFM4_MFT2_ADCMP_ACSC3_ADSEL1           *((volatile unsigned char*)(0x42443C0CUL))
#define bFM4_MFT2_ADCMP_ACSC3_ADSEL2           *((volatile unsigned char*)(0x42443C10UL))
#define bFM4_MFT2_ADCMP_ACSC3_APBM             *((volatile unsigned char*)(0x42443C14UL))
#define bFM4_MFT2_ADCMP_ACSD3_AMOD             *((volatile unsigned char*)(0x42443C20UL))
#define bFM4_MFT2_ADCMP_ACSD3_OCUS             *((volatile unsigned char*)(0x42443C24UL))
#define bFM4_MFT2_ADCMP_ACSD3_DE               *((volatile unsigned char*)(0x42443C30UL))
#define bFM4_MFT2_ADCMP_ACSD3_PE               *((volatile unsigned char*)(0x42443C34UL))
#define bFM4_MFT2_ADCMP_ACSD3_UE               *((volatile unsigned char*)(0x42443C38UL))
#define bFM4_MFT2_ADCMP_ACSD3_ZE               *((volatile unsigned char*)(0x42443C3CUL))
#define bFM4_MFT2_ADCMP_ACMC3_AMC0             *((volatile unsigned char*)(0x42443C40UL))
#define bFM4_MFT2_ADCMP_ACMC3_AMC1             *((volatile unsigned char*)(0x42443C44UL))
#define bFM4_MFT2_ADCMP_ACMC3_AMC2             *((volatile unsigned char*)(0x42443C48UL))
#define bFM4_MFT2_ADCMP_ACMC3_AMC3             *((volatile unsigned char*)(0x42443C4CUL))
#define bFM4_MFT2_ADCMP_ACMC3_MZCE             *((volatile unsigned char*)(0x42443C58UL))
#define bFM4_MFT2_ADCMP_ACMC3_MPCE             *((volatile unsigned char*)(0x42443C5CUL))
#define bFM4_MFT2_ADCMP_ACSC4_BUFE0            *((volatile unsigned char*)(0x42443C80UL))
#define bFM4_MFT2_ADCMP_ACSC4_BUFE1            *((volatile unsigned char*)(0x42443C84UL))
#define bFM4_MFT2_ADCMP_ACSC4_ADSEL0           *((volatile unsigned char*)(0x42443C88UL))
#define bFM4_MFT2_ADCMP_ACSC4_ADSEL1           *((volatile unsigned char*)(0x42443C8CUL))
#define bFM4_MFT2_ADCMP_ACSC4_ADSEL2           *((volatile unsigned char*)(0x42443C90UL))
#define bFM4_MFT2_ADCMP_ACSC4_APBM             *((volatile unsigned char*)(0x42443C94UL))
#define bFM4_MFT2_ADCMP_ACSD4_AMOD             *((volatile unsigned char*)(0x42443CA0UL))
#define bFM4_MFT2_ADCMP_ACSD4_OCUS             *((volatile unsigned char*)(0x42443CA4UL))
#define bFM4_MFT2_ADCMP_ACSD4_DE               *((volatile unsigned char*)(0x42443CB0UL))
#define bFM4_MFT2_ADCMP_ACSD4_PE               *((volatile unsigned char*)(0x42443CB4UL))
#define bFM4_MFT2_ADCMP_ACSD4_UE               *((volatile unsigned char*)(0x42443CB8UL))
#define bFM4_MFT2_ADCMP_ACSD4_ZE               *((volatile unsigned char*)(0x42443CBCUL))
#define bFM4_MFT2_ADCMP_ACMC4_AMC0             *((volatile unsigned char*)(0x42443CC0UL))
#define bFM4_MFT2_ADCMP_ACMC4_AMC1             *((volatile unsigned char*)(0x42443CC4UL))
#define bFM4_MFT2_ADCMP_ACMC4_AMC2             *((volatile unsigned char*)(0x42443CC8UL))
#define bFM4_MFT2_ADCMP_ACMC4_AMC3             *((volatile unsigned char*)(0x42443CCCUL))
#define bFM4_MFT2_ADCMP_ACMC4_MZCE             *((volatile unsigned char*)(0x42443CD8UL))
#define bFM4_MFT2_ADCMP_ACMC4_MPCE             *((volatile unsigned char*)(0x42443CDCUL))
#define bFM4_MFT2_ADCMP_ACSC5_BUFE0            *((volatile unsigned char*)(0x42443D00UL))
#define bFM4_MFT2_ADCMP_ACSC5_BUFE1            *((volatile unsigned char*)(0x42443D04UL))
#define bFM4_MFT2_ADCMP_ACSC5_ADSEL0           *((volatile unsigned char*)(0x42443D08UL))
#define bFM4_MFT2_ADCMP_ACSC5_ADSEL1           *((volatile unsigned char*)(0x42443D0CUL))
#define bFM4_MFT2_ADCMP_ACSC5_ADSEL2           *((volatile unsigned char*)(0x42443D10UL))
#define bFM4_MFT2_ADCMP_ACSC5_APBM             *((volatile unsigned char*)(0x42443D14UL))
#define bFM4_MFT2_ADCMP_ACSD5_AMOD             *((volatile unsigned char*)(0x42443D20UL))
#define bFM4_MFT2_ADCMP_ACSD5_OCUS             *((volatile unsigned char*)(0x42443D24UL))
#define bFM4_MFT2_ADCMP_ACSD5_DE               *((volatile unsigned char*)(0x42443D30UL))
#define bFM4_MFT2_ADCMP_ACSD5_PE               *((volatile unsigned char*)(0x42443D34UL))
#define bFM4_MFT2_ADCMP_ACSD5_UE               *((volatile unsigned char*)(0x42443D38UL))
#define bFM4_MFT2_ADCMP_ACSD5_ZE               *((volatile unsigned char*)(0x42443D3CUL))
#define bFM4_MFT2_ADCMP_ACMC5_AMC0             *((volatile unsigned char*)(0x42443D40UL))
#define bFM4_MFT2_ADCMP_ACMC5_AMC1             *((volatile unsigned char*)(0x42443D44UL))
#define bFM4_MFT2_ADCMP_ACMC5_AMC2             *((volatile unsigned char*)(0x42443D48UL))
#define bFM4_MFT2_ADCMP_ACMC5_AMC3             *((volatile unsigned char*)(0x42443D4CUL))
#define bFM4_MFT2_ADCMP_ACMC5_MZCE             *((volatile unsigned char*)(0x42443D58UL))
#define bFM4_MFT2_ADCMP_ACMC5_MPCE             *((volatile unsigned char*)(0x42443D5CUL))

/* Multifunction Timer PPG registers */
#define bFM4_MFT_PPG_TTCR0_STR0                *((volatile unsigned char*)(0x42480020UL))
#define bFM4_MFT_PPG_TTCR0_MONI0               *((volatile unsigned char*)(0x42480024UL))
#define bFM4_MFT_PPG_TTCR0_CS00                *((volatile unsigned char*)(0x42480028UL))
#define bFM4_MFT_PPG_TTCR0_CS01                *((volatile unsigned char*)(0x4248002CUL))
#define bFM4_MFT_PPG_TTCR0_TRG0O               *((volatile unsigned char*)(0x42480030UL))
#define bFM4_MFT_PPG_TTCR0_TRG2O               *((volatile unsigned char*)(0x42480034UL))
#define bFM4_MFT_PPG_TTCR0_TRG4O               *((volatile unsigned char*)(0x42480038UL))
#define bFM4_MFT_PPG_TTCR0_TRG6O               *((volatile unsigned char*)(0x4248003CUL))
#define bFM4_MFT_PPG_TTCR1_STR1                *((volatile unsigned char*)(0x42480420UL))
#define bFM4_MFT_PPG_TTCR1_MONI1               *((volatile unsigned char*)(0x42480424UL))
#define bFM4_MFT_PPG_TTCR1_CS10                *((volatile unsigned char*)(0x42480428UL))
#define bFM4_MFT_PPG_TTCR1_CS11                *((volatile unsigned char*)(0x4248042CUL))
#define bFM4_MFT_PPG_TTCR1_TRG1O               *((volatile unsigned char*)(0x42480430UL))
#define bFM4_MFT_PPG_TTCR1_TRG3O               *((volatile unsigned char*)(0x42480434UL))
#define bFM4_MFT_PPG_TTCR1_TRG5O               *((volatile unsigned char*)(0x42480438UL))
#define bFM4_MFT_PPG_TTCR1_TRG7O               *((volatile unsigned char*)(0x4248043CUL))
#define bFM4_MFT_PPG_TTCR2_STR2                *((volatile unsigned char*)(0x42480820UL))
#define bFM4_MFT_PPG_TTCR2_MONI2               *((volatile unsigned char*)(0x42480824UL))
#define bFM4_MFT_PPG_TTCR2_CS20                *((volatile unsigned char*)(0x42480828UL))
#define bFM4_MFT_PPG_TTCR2_CS21                *((volatile unsigned char*)(0x4248082CUL))
#define bFM4_MFT_PPG_TTCR2_TRG16O              *((volatile unsigned char*)(0x42480830UL))
#define bFM4_MFT_PPG_TTCR2_TRG18O              *((volatile unsigned char*)(0x42480834UL))
#define bFM4_MFT_PPG_TTCR2_TRG20O              *((volatile unsigned char*)(0x42480838UL))
#define bFM4_MFT_PPG_TTCR2_TRG22O              *((volatile unsigned char*)(0x4248083CUL))
#define bFM4_MFT_PPG_TRG_PEN00                 *((volatile unsigned char*)(0x42482000UL))
#define bFM4_MFT_PPG_TRG_PEN01                 *((volatile unsigned char*)(0x42482004UL))
#define bFM4_MFT_PPG_TRG_PEN02                 *((volatile unsigned char*)(0x42482008UL))
#define bFM4_MFT_PPG_TRG_PEN03                 *((volatile unsigned char*)(0x4248200CUL))
#define bFM4_MFT_PPG_TRG_PEN04                 *((volatile unsigned char*)(0x42482010UL))
#define bFM4_MFT_PPG_TRG_PEN05                 *((volatile unsigned char*)(0x42482014UL))
#define bFM4_MFT_PPG_TRG_PEN06                 *((volatile unsigned char*)(0x42482018UL))
#define bFM4_MFT_PPG_TRG_PEN07                 *((volatile unsigned char*)(0x4248201CUL))
#define bFM4_MFT_PPG_TRG_PEN08                 *((volatile unsigned char*)(0x42482020UL))
#define bFM4_MFT_PPG_TRG_PEN09                 *((volatile unsigned char*)(0x42482024UL))
#define bFM4_MFT_PPG_TRG_PEN10                 *((volatile unsigned char*)(0x42482028UL))
#define bFM4_MFT_PPG_TRG_PEN11                 *((volatile unsigned char*)(0x4248202CUL))
#define bFM4_MFT_PPG_TRG_PEN12                 *((volatile unsigned char*)(0x42482030UL))
#define bFM4_MFT_PPG_TRG_PEN13                 *((volatile unsigned char*)(0x42482034UL))
#define bFM4_MFT_PPG_TRG_PEN14                 *((volatile unsigned char*)(0x42482038UL))
#define bFM4_MFT_PPG_TRG_PEN15                 *((volatile unsigned char*)(0x4248203CUL))
#define bFM4_MFT_PPG_REVC_REV00                *((volatile unsigned char*)(0x42482080UL))
#define bFM4_MFT_PPG_REVC_REV01                *((volatile unsigned char*)(0x42482084UL))
#define bFM4_MFT_PPG_REVC_REV02                *((volatile unsigned char*)(0x42482088UL))
#define bFM4_MFT_PPG_REVC_REV03                *((volatile unsigned char*)(0x4248208CUL))
#define bFM4_MFT_PPG_REVC_REV04                *((volatile unsigned char*)(0x42482090UL))
#define bFM4_MFT_PPG_REVC_REV05                *((volatile unsigned char*)(0x42482094UL))
#define bFM4_MFT_PPG_REVC_REV06                *((volatile unsigned char*)(0x42482098UL))
#define bFM4_MFT_PPG_REVC_REV07                *((volatile unsigned char*)(0x4248209CUL))
#define bFM4_MFT_PPG_REVC_REV08                *((volatile unsigned char*)(0x424820A0UL))
#define bFM4_MFT_PPG_REVC_REV09                *((volatile unsigned char*)(0x424820A4UL))
#define bFM4_MFT_PPG_REVC_REV10                *((volatile unsigned char*)(0x424820A8UL))
#define bFM4_MFT_PPG_REVC_REV11                *((volatile unsigned char*)(0x424820ACUL))
#define bFM4_MFT_PPG_REVC_REV12                *((volatile unsigned char*)(0x424820B0UL))
#define bFM4_MFT_PPG_REVC_REV13                *((volatile unsigned char*)(0x424820B4UL))
#define bFM4_MFT_PPG_REVC_REV14                *((volatile unsigned char*)(0x424820B8UL))
#define bFM4_MFT_PPG_REVC_REV15                *((volatile unsigned char*)(0x424820BCUL))
#define bFM4_MFT_PPG_TRG1_PEN16                *((volatile unsigned char*)(0x42482800UL))
#define bFM4_MFT_PPG_TRG1_PEN17                *((volatile unsigned char*)(0x42482804UL))
#define bFM4_MFT_PPG_TRG1_PEN18                *((volatile unsigned char*)(0x42482808UL))
#define bFM4_MFT_PPG_TRG1_PEN19                *((volatile unsigned char*)(0x4248280CUL))
#define bFM4_MFT_PPG_TRG1_PEN20                *((volatile unsigned char*)(0x42482810UL))
#define bFM4_MFT_PPG_TRG1_PEN21                *((volatile unsigned char*)(0x42482814UL))
#define bFM4_MFT_PPG_TRG1_PEN22                *((volatile unsigned char*)(0x42482818UL))
#define bFM4_MFT_PPG_TRG1_PEN23                *((volatile unsigned char*)(0x4248281CUL))
#define bFM4_MFT_PPG_REVC1_REV16               *((volatile unsigned char*)(0x42482880UL))
#define bFM4_MFT_PPG_REVC1_REV17               *((volatile unsigned char*)(0x42482884UL))
#define bFM4_MFT_PPG_REVC1_REV18               *((volatile unsigned char*)(0x42482888UL))
#define bFM4_MFT_PPG_REVC1_REV19               *((volatile unsigned char*)(0x4248288CUL))
#define bFM4_MFT_PPG_REVC1_REV20               *((volatile unsigned char*)(0x42482890UL))
#define bFM4_MFT_PPG_REVC1_REV21               *((volatile unsigned char*)(0x42482894UL))
#define bFM4_MFT_PPG_REVC1_REV22               *((volatile unsigned char*)(0x42482898UL))
#define bFM4_MFT_PPG_REVC1_REV23               *((volatile unsigned char*)(0x4248289CUL))
#define bFM4_MFT_PPG_PPGC1_TTRG                *((volatile unsigned char*)(0x42484000UL))
#define bFM4_MFT_PPG_PPGC1_PCS0                *((volatile unsigned char*)(0x4248400CUL))
#define bFM4_MFT_PPG_PPGC1_PCS1                *((volatile unsigned char*)(0x42484010UL))
#define bFM4_MFT_PPG_PPGC1_INTM                *((volatile unsigned char*)(0x42484014UL))
#define bFM4_MFT_PPG_PPGC1_PUF                 *((volatile unsigned char*)(0x42484018UL))
#define bFM4_MFT_PPG_PPGC1_PIE                 *((volatile unsigned char*)(0x4248401CUL))
#define bFM4_MFT_PPG_PPGC0_TTRG                *((volatile unsigned char*)(0x42484020UL))
#define bFM4_MFT_PPG_PPGC0_PCS0                *((volatile unsigned char*)(0x4248402CUL))
#define bFM4_MFT_PPG_PPGC0_PCS1                *((volatile unsigned char*)(0x42484030UL))
#define bFM4_MFT_PPG_PPGC0_INTM                *((volatile unsigned char*)(0x42484034UL))
#define bFM4_MFT_PPG_PPGC0_PUF                 *((volatile unsigned char*)(0x42484038UL))
#define bFM4_MFT_PPG_PPGC0_PIE                 *((volatile unsigned char*)(0x4248403CUL))
#define bFM4_MFT_PPG_PPGC3_TTRG                *((volatile unsigned char*)(0x42484080UL))
#define bFM4_MFT_PPG_PPGC3_PCS0                *((volatile unsigned char*)(0x4248408CUL))
#define bFM4_MFT_PPG_PPGC3_PCS1                *((volatile unsigned char*)(0x42484090UL))
#define bFM4_MFT_PPG_PPGC3_INTM                *((volatile unsigned char*)(0x42484094UL))
#define bFM4_MFT_PPG_PPGC3_PUF                 *((volatile unsigned char*)(0x42484098UL))
#define bFM4_MFT_PPG_PPGC3_PIE                 *((volatile unsigned char*)(0x4248409CUL))
#define bFM4_MFT_PPG_PPGC2_TTRG                *((volatile unsigned char*)(0x424840A0UL))
#define bFM4_MFT_PPG_PPGC2_PCS0                *((volatile unsigned char*)(0x424840ACUL))
#define bFM4_MFT_PPG_PPGC2_PCS1                *((volatile unsigned char*)(0x424840B0UL))
#define bFM4_MFT_PPG_PPGC2_INTM                *((volatile unsigned char*)(0x424840B4UL))
#define bFM4_MFT_PPG_PPGC2_PUF                 *((volatile unsigned char*)(0x424840B8UL))
#define bFM4_MFT_PPG_PPGC2_PIE                 *((volatile unsigned char*)(0x424840BCUL))
#define bFM4_MFT_PPG_GATEC0_EDGE0              *((volatile unsigned char*)(0x42484300UL))
#define bFM4_MFT_PPG_GATEC0_STRG0              *((volatile unsigned char*)(0x42484304UL))
#define bFM4_MFT_PPG_GATEC0_EDGE2              *((volatile unsigned char*)(0x42484310UL))
#define bFM4_MFT_PPG_GATEC0_STRG2              *((volatile unsigned char*)(0x42484314UL))
#define bFM4_MFT_PPG_PPGC5_TTRG                *((volatile unsigned char*)(0x42484800UL))
#define bFM4_MFT_PPG_PPGC5_PCS0                *((volatile unsigned char*)(0x4248480CUL))
#define bFM4_MFT_PPG_PPGC5_PCS1                *((volatile unsigned char*)(0x42484810UL))
#define bFM4_MFT_PPG_PPGC5_INTM                *((volatile unsigned char*)(0x42484814UL))
#define bFM4_MFT_PPG_PPGC5_PUF                 *((volatile unsigned char*)(0x42484818UL))
#define bFM4_MFT_PPG_PPGC5_PIE                 *((volatile unsigned char*)(0x4248481CUL))
#define bFM4_MFT_PPG_PPGC4_TTRG                *((volatile unsigned char*)(0x42484820UL))
#define bFM4_MFT_PPG_PPGC4_PCS0                *((volatile unsigned char*)(0x4248482CUL))
#define bFM4_MFT_PPG_PPGC4_PCS1                *((volatile unsigned char*)(0x42484830UL))
#define bFM4_MFT_PPG_PPGC4_INTM                *((volatile unsigned char*)(0x42484834UL))
#define bFM4_MFT_PPG_PPGC4_PUF                 *((volatile unsigned char*)(0x42484838UL))
#define bFM4_MFT_PPG_PPGC4_PIE                 *((volatile unsigned char*)(0x4248483CUL))
#define bFM4_MFT_PPG_PPGC7_TTRG                *((volatile unsigned char*)(0x42484880UL))
#define bFM4_MFT_PPG_PPGC7_PCS0                *((volatile unsigned char*)(0x4248488CUL))
#define bFM4_MFT_PPG_PPGC7_PCS1                *((volatile unsigned char*)(0x42484890UL))
#define bFM4_MFT_PPG_PPGC7_INTM                *((volatile unsigned char*)(0x42484894UL))
#define bFM4_MFT_PPG_PPGC7_PUF                 *((volatile unsigned char*)(0x42484898UL))
#define bFM4_MFT_PPG_PPGC7_PIE                 *((volatile unsigned char*)(0x4248489CUL))
#define bFM4_MFT_PPG_PPGC6_TTRG                *((volatile unsigned char*)(0x424848A0UL))
#define bFM4_MFT_PPG_PPGC6_PCS0                *((volatile unsigned char*)(0x424848ACUL))
#define bFM4_MFT_PPG_PPGC6_PCS1                *((volatile unsigned char*)(0x424848B0UL))
#define bFM4_MFT_PPG_PPGC6_INTM                *((volatile unsigned char*)(0x424848B4UL))
#define bFM4_MFT_PPG_PPGC6_PUF                 *((volatile unsigned char*)(0x424848B8UL))
#define bFM4_MFT_PPG_PPGC6_PIE                 *((volatile unsigned char*)(0x424848BCUL))
#define bFM4_MFT_PPG_GATEC4_EDGE4              *((volatile unsigned char*)(0x42484B00UL))
#define bFM4_MFT_PPG_GATEC4_STRG4              *((volatile unsigned char*)(0x42484B04UL))
#define bFM4_MFT_PPG_GATEC4_EDGE6              *((volatile unsigned char*)(0x42484B10UL))
#define bFM4_MFT_PPG_GATEC4_STRG6              *((volatile unsigned char*)(0x42484B14UL))
#define bFM4_MFT_PPG_PPGC9_TTRG                *((volatile unsigned char*)(0x42485000UL))
#define bFM4_MFT_PPG_PPGC9_PCS0                *((volatile unsigned char*)(0x4248500CUL))
#define bFM4_MFT_PPG_PPGC9_PCS1                *((volatile unsigned char*)(0x42485010UL))
#define bFM4_MFT_PPG_PPGC9_INTM                *((volatile unsigned char*)(0x42485014UL))
#define bFM4_MFT_PPG_PPGC9_PUF                 *((volatile unsigned char*)(0x42485018UL))
#define bFM4_MFT_PPG_PPGC9_PIE                 *((volatile unsigned char*)(0x4248501CUL))
#define bFM4_MFT_PPG_PPGC8_TTRG                *((volatile unsigned char*)(0x42485020UL))
#define bFM4_MFT_PPG_PPGC8_PCS0                *((volatile unsigned char*)(0x4248502CUL))
#define bFM4_MFT_PPG_PPGC8_PCS1                *((volatile unsigned char*)(0x42485030UL))
#define bFM4_MFT_PPG_PPGC8_INTM                *((volatile unsigned char*)(0x42485034UL))
#define bFM4_MFT_PPG_PPGC8_PUF                 *((volatile unsigned char*)(0x42485038UL))
#define bFM4_MFT_PPG_PPGC8_PIE                 *((volatile unsigned char*)(0x4248503CUL))
#define bFM4_MFT_PPG_PPGC11_TTRG               *((volatile unsigned char*)(0x42485080UL))
#define bFM4_MFT_PPG_PPGC11_PCS0               *((volatile unsigned char*)(0x4248508CUL))
#define bFM4_MFT_PPG_PPGC11_PCS1               *((volatile unsigned char*)(0x42485090UL))
#define bFM4_MFT_PPG_PPGC11_INTM               *((volatile unsigned char*)(0x42485094UL))
#define bFM4_MFT_PPG_PPGC11_PUF                *((volatile unsigned char*)(0x42485098UL))
#define bFM4_MFT_PPG_PPGC11_PIE                *((volatile unsigned char*)(0x4248509CUL))
#define bFM4_MFT_PPG_PPGC10_TTRG               *((volatile unsigned char*)(0x424850A0UL))
#define bFM4_MFT_PPG_PPGC10_PCS0               *((volatile unsigned char*)(0x424850ACUL))
#define bFM4_MFT_PPG_PPGC10_PCS1               *((volatile unsigned char*)(0x424850B0UL))
#define bFM4_MFT_PPG_PPGC10_INTM               *((volatile unsigned char*)(0x424850B4UL))
#define bFM4_MFT_PPG_PPGC10_PUF                *((volatile unsigned char*)(0x424850B8UL))
#define bFM4_MFT_PPG_PPGC10_PIE                *((volatile unsigned char*)(0x424850BCUL))
#define bFM4_MFT_PPG_GATEC8_EDGE8              *((volatile unsigned char*)(0x42485300UL))
#define bFM4_MFT_PPG_GATEC8_STRG8              *((volatile unsigned char*)(0x42485304UL))
#define bFM4_MFT_PPG_GATEC8_EDGE10             *((volatile unsigned char*)(0x42485310UL))
#define bFM4_MFT_PPG_GATEC8_STRG10             *((volatile unsigned char*)(0x42485314UL))
#define bFM4_MFT_PPG_PPGC13_TTRG               *((volatile unsigned char*)(0x42485800UL))
#define bFM4_MFT_PPG_PPGC13_PCS0               *((volatile unsigned char*)(0x4248580CUL))
#define bFM4_MFT_PPG_PPGC13_PCS1               *((volatile unsigned char*)(0x42485810UL))
#define bFM4_MFT_PPG_PPGC13_INTM               *((volatile unsigned char*)(0x42485814UL))
#define bFM4_MFT_PPG_PPGC13_PUF                *((volatile unsigned char*)(0x42485818UL))
#define bFM4_MFT_PPG_PPGC13_PIE                *((volatile unsigned char*)(0x4248581CUL))
#define bFM4_MFT_PPG_PPGC12_TTRG               *((volatile unsigned char*)(0x42485820UL))
#define bFM4_MFT_PPG_PPGC12_PCS0               *((volatile unsigned char*)(0x4248582CUL))
#define bFM4_MFT_PPG_PPGC12_PCS1               *((volatile unsigned char*)(0x42485830UL))
#define bFM4_MFT_PPG_PPGC12_INTM               *((volatile unsigned char*)(0x42485834UL))
#define bFM4_MFT_PPG_PPGC12_PUF                *((volatile unsigned char*)(0x42485838UL))
#define bFM4_MFT_PPG_PPGC12_PIE                *((volatile unsigned char*)(0x4248583CUL))
#define bFM4_MFT_PPG_PPGC15_TTRG               *((volatile unsigned char*)(0x42485880UL))
#define bFM4_MFT_PPG_PPGC15_PCS0               *((volatile unsigned char*)(0x4248588CUL))
#define bFM4_MFT_PPG_PPGC15_PCS1               *((volatile unsigned char*)(0x42485890UL))
#define bFM4_MFT_PPG_PPGC15_INTM               *((volatile unsigned char*)(0x42485894UL))
#define bFM4_MFT_PPG_PPGC15_PUF                *((volatile unsigned char*)(0x42485898UL))
#define bFM4_MFT_PPG_PPGC15_PIE                *((volatile unsigned char*)(0x4248589CUL))
#define bFM4_MFT_PPG_PPGC14_TTRG               *((volatile unsigned char*)(0x424858A0UL))
#define bFM4_MFT_PPG_PPGC14_PCS0               *((volatile unsigned char*)(0x424858ACUL))
#define bFM4_MFT_PPG_PPGC14_PCS1               *((volatile unsigned char*)(0x424858B0UL))
#define bFM4_MFT_PPG_PPGC14_INTM               *((volatile unsigned char*)(0x424858B4UL))
#define bFM4_MFT_PPG_PPGC14_PUF                *((volatile unsigned char*)(0x424858B8UL))
#define bFM4_MFT_PPG_PPGC14_PIE                *((volatile unsigned char*)(0x424858BCUL))
#define bFM4_MFT_PPG_GATEC12_EDGE12            *((volatile unsigned char*)(0x42485B00UL))
#define bFM4_MFT_PPG_GATEC12_STRG12            *((volatile unsigned char*)(0x42485B04UL))
#define bFM4_MFT_PPG_GATEC12_EDGE14            *((volatile unsigned char*)(0x42485B10UL))
#define bFM4_MFT_PPG_GATEC12_STRG14            *((volatile unsigned char*)(0x42485B14UL))
#define bFM4_MFT_PPG_PPGC17_TTRG               *((volatile unsigned char*)(0x42486000UL))
#define bFM4_MFT_PPG_PPGC17_PCS0               *((volatile unsigned char*)(0x4248600CUL))
#define bFM4_MFT_PPG_PPGC17_PCS1               *((volatile unsigned char*)(0x42486010UL))
#define bFM4_MFT_PPG_PPGC17_INTM               *((volatile unsigned char*)(0x42486014UL))
#define bFM4_MFT_PPG_PPGC17_PUF                *((volatile unsigned char*)(0x42486018UL))
#define bFM4_MFT_PPG_PPGC17_PIE                *((volatile unsigned char*)(0x4248601CUL))
#define bFM4_MFT_PPG_PPGC16_TTRG               *((volatile unsigned char*)(0x42486020UL))
#define bFM4_MFT_PPG_PPGC16_PCS0               *((volatile unsigned char*)(0x4248602CUL))
#define bFM4_MFT_PPG_PPGC16_PCS1               *((volatile unsigned char*)(0x42486030UL))
#define bFM4_MFT_PPG_PPGC16_INTM               *((volatile unsigned char*)(0x42486034UL))
#define bFM4_MFT_PPG_PPGC16_PUF                *((volatile unsigned char*)(0x42486038UL))
#define bFM4_MFT_PPG_PPGC16_PIE                *((volatile unsigned char*)(0x4248603CUL))
#define bFM4_MFT_PPG_PPGC19_TTRG               *((volatile unsigned char*)(0x42486080UL))
#define bFM4_MFT_PPG_PPGC19_PCS0               *((volatile unsigned char*)(0x4248608CUL))
#define bFM4_MFT_PPG_PPGC19_PCS1               *((volatile unsigned char*)(0x42486090UL))
#define bFM4_MFT_PPG_PPGC19_INTM               *((volatile unsigned char*)(0x42486094UL))
#define bFM4_MFT_PPG_PPGC19_PUF                *((volatile unsigned char*)(0x42486098UL))
#define bFM4_MFT_PPG_PPGC19_PIE                *((volatile unsigned char*)(0x4248609CUL))
#define bFM4_MFT_PPG_PPGC18_TTRG               *((volatile unsigned char*)(0x424860A0UL))
#define bFM4_MFT_PPG_PPGC18_PCS0               *((volatile unsigned char*)(0x424860ACUL))
#define bFM4_MFT_PPG_PPGC18_PCS1               *((volatile unsigned char*)(0x424860B0UL))
#define bFM4_MFT_PPG_PPGC18_INTM               *((volatile unsigned char*)(0x424860B4UL))
#define bFM4_MFT_PPG_PPGC18_PUF                *((volatile unsigned char*)(0x424860B8UL))
#define bFM4_MFT_PPG_PPGC18_PIE                *((volatile unsigned char*)(0x424860BCUL))
#define bFM4_MFT_PPG_GATEC16_EDGE16            *((volatile unsigned char*)(0x42486300UL))
#define bFM4_MFT_PPG_GATEC16_STRG16            *((volatile unsigned char*)(0x42486304UL))
#define bFM4_MFT_PPG_GATEC16_EDGE18            *((volatile unsigned char*)(0x42486310UL))
#define bFM4_MFT_PPG_GATEC16_STRG18            *((volatile unsigned char*)(0x42486314UL))
#define bFM4_MFT_PPG_PPGC21_TTRG               *((volatile unsigned char*)(0x42486800UL))
#define bFM4_MFT_PPG_PPGC21_PCS0               *((volatile unsigned char*)(0x4248680CUL))
#define bFM4_MFT_PPG_PPGC21_PCS1               *((volatile unsigned char*)(0x42486810UL))
#define bFM4_MFT_PPG_PPGC21_INTM               *((volatile unsigned char*)(0x42486814UL))
#define bFM4_MFT_PPG_PPGC21_PUF                *((volatile unsigned char*)(0x42486818UL))
#define bFM4_MFT_PPG_PPGC21_PIE                *((volatile unsigned char*)(0x4248681CUL))
#define bFM4_MFT_PPG_PPGC20_TTRG               *((volatile unsigned char*)(0x42486820UL))
#define bFM4_MFT_PPG_PPGC20_PCS0               *((volatile unsigned char*)(0x4248682CUL))
#define bFM4_MFT_PPG_PPGC20_PCS1               *((volatile unsigned char*)(0x42486830UL))
#define bFM4_MFT_PPG_PPGC20_INTM               *((volatile unsigned char*)(0x42486834UL))
#define bFM4_MFT_PPG_PPGC20_PUF                *((volatile unsigned char*)(0x42486838UL))
#define bFM4_MFT_PPG_PPGC20_PIE                *((volatile unsigned char*)(0x4248683CUL))
#define bFM4_MFT_PPG_PPGC23_TTRG               *((volatile unsigned char*)(0x42486880UL))
#define bFM4_MFT_PPG_PPGC23_PCS0               *((volatile unsigned char*)(0x4248688CUL))
#define bFM4_MFT_PPG_PPGC23_PCS1               *((volatile unsigned char*)(0x42486890UL))
#define bFM4_MFT_PPG_PPGC23_INTM               *((volatile unsigned char*)(0x42486894UL))
#define bFM4_MFT_PPG_PPGC23_PUF                *((volatile unsigned char*)(0x42486898UL))
#define bFM4_MFT_PPG_PPGC23_PIE                *((volatile unsigned char*)(0x4248689CUL))
#define bFM4_MFT_PPG_PPGC22_TTRG               *((volatile unsigned char*)(0x424868A0UL))
#define bFM4_MFT_PPG_PPGC22_PCS0               *((volatile unsigned char*)(0x424868ACUL))
#define bFM4_MFT_PPG_PPGC22_PCS1               *((volatile unsigned char*)(0x424868B0UL))
#define bFM4_MFT_PPG_PPGC22_INTM               *((volatile unsigned char*)(0x424868B4UL))
#define bFM4_MFT_PPG_PPGC22_PUF                *((volatile unsigned char*)(0x424868B8UL))
#define bFM4_MFT_PPG_PPGC22_PIE                *((volatile unsigned char*)(0x424868BCUL))
#define bFM4_MFT_PPG_GATEC20_EDGE20            *((volatile unsigned char*)(0x42486B00UL))
#define bFM4_MFT_PPG_GATEC20_STRG20            *((volatile unsigned char*)(0x42486B04UL))
#define bFM4_MFT_PPG_GATEC20_EDGE22            *((volatile unsigned char*)(0x42486B10UL))
#define bFM4_MFT_PPG_GATEC20_STRG22            *((volatile unsigned char*)(0x42486B14UL))

/* Base Timer 0 PPG registers */
#define bFM4_BT0_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A0180UL))
#define bFM4_BT0_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0184UL))
#define bFM4_BT0_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0188UL))
#define bFM4_BT0_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A018CUL))
#define bFM4_BT0_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0190UL))
#define bFM4_BT0_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0194UL))
#define bFM4_BT0_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0198UL))
#define bFM4_BT0_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A01A0UL))
#define bFM4_BT0_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A01A4UL))
#define bFM4_BT0_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A01A8UL))
#define bFM4_BT0_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A01ACUL))
#define bFM4_BT0_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A01B0UL))
#define bFM4_BT0_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A01B4UL))
#define bFM4_BT0_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A01B8UL))
#define bFM4_BT0_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A0200UL))
#define bFM4_BT0_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A0208UL))
#define bFM4_BT0_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A0210UL))
#define bFM4_BT0_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A0218UL))
#define bFM4_BT0_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0220UL))

/* Base Timer 0 PWM registers */
#define bFM4_BT0_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A0180UL))
#define bFM4_BT0_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0184UL))
#define bFM4_BT0_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0188UL))
#define bFM4_BT0_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A018CUL))
#define bFM4_BT0_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0190UL))
#define bFM4_BT0_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0194UL))
#define bFM4_BT0_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0198UL))
#define bFM4_BT0_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A01A0UL))
#define bFM4_BT0_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A01A4UL))
#define bFM4_BT0_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A01A8UL))
#define bFM4_BT0_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A01ACUL))
#define bFM4_BT0_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A01B0UL))
#define bFM4_BT0_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A01B4UL))
#define bFM4_BT0_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A01B8UL))
#define bFM4_BT0_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A0200UL))
#define bFM4_BT0_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A0204UL))
#define bFM4_BT0_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A0208UL))
#define bFM4_BT0_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A0210UL))
#define bFM4_BT0_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A0214UL))
#define bFM4_BT0_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A0218UL))
#define bFM4_BT0_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0220UL))

/* Base Timer 0 RT registers */
#define bFM4_BT0_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A0180UL))
#define bFM4_BT0_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A0184UL))
#define bFM4_BT0_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A0188UL))
#define bFM4_BT0_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A018CUL))
#define bFM4_BT0_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A0190UL))
#define bFM4_BT0_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A0194UL))
#define bFM4_BT0_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A0198UL))
#define bFM4_BT0_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A019CUL))
#define bFM4_BT0_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A01A0UL))
#define bFM4_BT0_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A01A4UL))
#define bFM4_BT0_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A01B0UL))
#define bFM4_BT0_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A01B4UL))
#define bFM4_BT0_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A01B8UL))
#define bFM4_BT0_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A0200UL))
#define bFM4_BT0_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A0208UL))
#define bFM4_BT0_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A0210UL))
#define bFM4_BT0_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A0218UL))
#define bFM4_BT0_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A0220UL))

/* Base Timer 0 PWC registers */
#define bFM4_BT0_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0184UL))
#define bFM4_BT0_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0188UL))
#define bFM4_BT0_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0190UL))
#define bFM4_BT0_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0194UL))
#define bFM4_BT0_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0198UL))
#define bFM4_BT0_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A019CUL))
#define bFM4_BT0_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A01A0UL))
#define bFM4_BT0_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A01A4UL))
#define bFM4_BT0_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A01A8UL))
#define bFM4_BT0_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A01B0UL))
#define bFM4_BT0_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A01B4UL))
#define bFM4_BT0_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A01B8UL))
#define bFM4_BT0_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A0200UL))
#define bFM4_BT0_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A0208UL))
#define bFM4_BT0_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A0210UL))
#define bFM4_BT0_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A0218UL))
#define bFM4_BT0_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A021CUL))
#define bFM4_BT0_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0220UL))

/* Base Timer 1 PPG registers */
#define bFM4_BT1_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A0980UL))
#define bFM4_BT1_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0984UL))
#define bFM4_BT1_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0988UL))
#define bFM4_BT1_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A098CUL))
#define bFM4_BT1_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0990UL))
#define bFM4_BT1_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0994UL))
#define bFM4_BT1_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0998UL))
#define bFM4_BT1_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A09A0UL))
#define bFM4_BT1_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A09A4UL))
#define bFM4_BT1_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A09A8UL))
#define bFM4_BT1_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A09ACUL))
#define bFM4_BT1_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A09B0UL))
#define bFM4_BT1_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A09B4UL))
#define bFM4_BT1_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A09B8UL))
#define bFM4_BT1_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A0A00UL))
#define bFM4_BT1_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A0A08UL))
#define bFM4_BT1_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A0A10UL))
#define bFM4_BT1_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A0A18UL))
#define bFM4_BT1_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0A20UL))

/* Base Timer 1 PWM registers */
#define bFM4_BT1_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A0980UL))
#define bFM4_BT1_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0984UL))
#define bFM4_BT1_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0988UL))
#define bFM4_BT1_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A098CUL))
#define bFM4_BT1_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0990UL))
#define bFM4_BT1_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0994UL))
#define bFM4_BT1_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0998UL))
#define bFM4_BT1_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A09A0UL))
#define bFM4_BT1_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A09A4UL))
#define bFM4_BT1_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A09A8UL))
#define bFM4_BT1_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A09ACUL))
#define bFM4_BT1_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A09B0UL))
#define bFM4_BT1_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A09B4UL))
#define bFM4_BT1_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A09B8UL))
#define bFM4_BT1_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A0A00UL))
#define bFM4_BT1_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A0A04UL))
#define bFM4_BT1_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A0A08UL))
#define bFM4_BT1_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A0A10UL))
#define bFM4_BT1_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A0A14UL))
#define bFM4_BT1_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A0A18UL))
#define bFM4_BT1_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0A20UL))

/* Base Timer 1 RT registers */
#define bFM4_BT1_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A0980UL))
#define bFM4_BT1_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A0984UL))
#define bFM4_BT1_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A0988UL))
#define bFM4_BT1_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A098CUL))
#define bFM4_BT1_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A0990UL))
#define bFM4_BT1_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A0994UL))
#define bFM4_BT1_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A0998UL))
#define bFM4_BT1_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A099CUL))
#define bFM4_BT1_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A09A0UL))
#define bFM4_BT1_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A09A4UL))
#define bFM4_BT1_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A09B0UL))
#define bFM4_BT1_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A09B4UL))
#define bFM4_BT1_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A09B8UL))
#define bFM4_BT1_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A0A00UL))
#define bFM4_BT1_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A0A08UL))
#define bFM4_BT1_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A0A10UL))
#define bFM4_BT1_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A0A18UL))
#define bFM4_BT1_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A0A20UL))

/* Base Timer 1 PWC registers */
#define bFM4_BT1_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0984UL))
#define bFM4_BT1_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0988UL))
#define bFM4_BT1_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0990UL))
#define bFM4_BT1_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0994UL))
#define bFM4_BT1_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0998UL))
#define bFM4_BT1_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A099CUL))
#define bFM4_BT1_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A09A0UL))
#define bFM4_BT1_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A09A4UL))
#define bFM4_BT1_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A09A8UL))
#define bFM4_BT1_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A09B0UL))
#define bFM4_BT1_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A09B4UL))
#define bFM4_BT1_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A09B8UL))
#define bFM4_BT1_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A0A00UL))
#define bFM4_BT1_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A0A08UL))
#define bFM4_BT1_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A0A10UL))
#define bFM4_BT1_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A0A18UL))
#define bFM4_BT1_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A0A1CUL))
#define bFM4_BT1_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0A20UL))

/* Base Timer 2 PPG registers */
#define bFM4_BT2_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A1180UL))
#define bFM4_BT2_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1184UL))
#define bFM4_BT2_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1188UL))
#define bFM4_BT2_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A118CUL))
#define bFM4_BT2_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1190UL))
#define bFM4_BT2_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1194UL))
#define bFM4_BT2_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1198UL))
#define bFM4_BT2_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A11A0UL))
#define bFM4_BT2_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A11A4UL))
#define bFM4_BT2_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A11A8UL))
#define bFM4_BT2_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A11ACUL))
#define bFM4_BT2_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A11B0UL))
#define bFM4_BT2_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A11B4UL))
#define bFM4_BT2_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A11B8UL))
#define bFM4_BT2_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A1200UL))
#define bFM4_BT2_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A1208UL))
#define bFM4_BT2_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A1210UL))
#define bFM4_BT2_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A1218UL))
#define bFM4_BT2_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1220UL))

/* Base Timer 2 PWM registers */
#define bFM4_BT2_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A1180UL))
#define bFM4_BT2_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1184UL))
#define bFM4_BT2_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1188UL))
#define bFM4_BT2_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A118CUL))
#define bFM4_BT2_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1190UL))
#define bFM4_BT2_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1194UL))
#define bFM4_BT2_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1198UL))
#define bFM4_BT2_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A11A0UL))
#define bFM4_BT2_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A11A4UL))
#define bFM4_BT2_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A11A8UL))
#define bFM4_BT2_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A11ACUL))
#define bFM4_BT2_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A11B0UL))
#define bFM4_BT2_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A11B4UL))
#define bFM4_BT2_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A11B8UL))
#define bFM4_BT2_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A1200UL))
#define bFM4_BT2_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A1204UL))
#define bFM4_BT2_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A1208UL))
#define bFM4_BT2_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A1210UL))
#define bFM4_BT2_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A1214UL))
#define bFM4_BT2_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A1218UL))
#define bFM4_BT2_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1220UL))

/* Base Timer 2 RT registers */
#define bFM4_BT2_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A1180UL))
#define bFM4_BT2_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A1184UL))
#define bFM4_BT2_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A1188UL))
#define bFM4_BT2_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A118CUL))
#define bFM4_BT2_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A1190UL))
#define bFM4_BT2_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A1194UL))
#define bFM4_BT2_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A1198UL))
#define bFM4_BT2_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A119CUL))
#define bFM4_BT2_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A11A0UL))
#define bFM4_BT2_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A11A4UL))
#define bFM4_BT2_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A11B0UL))
#define bFM4_BT2_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A11B4UL))
#define bFM4_BT2_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A11B8UL))
#define bFM4_BT2_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A1200UL))
#define bFM4_BT2_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A1208UL))
#define bFM4_BT2_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A1210UL))
#define bFM4_BT2_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A1218UL))
#define bFM4_BT2_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A1220UL))

/* Base Timer 2 PWC registers */
#define bFM4_BT2_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1184UL))
#define bFM4_BT2_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1188UL))
#define bFM4_BT2_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1190UL))
#define bFM4_BT2_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1194UL))
#define bFM4_BT2_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1198UL))
#define bFM4_BT2_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A119CUL))
#define bFM4_BT2_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A11A0UL))
#define bFM4_BT2_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A11A4UL))
#define bFM4_BT2_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A11A8UL))
#define bFM4_BT2_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A11B0UL))
#define bFM4_BT2_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A11B4UL))
#define bFM4_BT2_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A11B8UL))
#define bFM4_BT2_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A1200UL))
#define bFM4_BT2_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A1208UL))
#define bFM4_BT2_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A1210UL))
#define bFM4_BT2_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A1218UL))
#define bFM4_BT2_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A121CUL))
#define bFM4_BT2_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1220UL))

/* Base Timer 3 PPG registers */
#define bFM4_BT3_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A1980UL))
#define bFM4_BT3_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1984UL))
#define bFM4_BT3_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1988UL))
#define bFM4_BT3_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A198CUL))
#define bFM4_BT3_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1990UL))
#define bFM4_BT3_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1994UL))
#define bFM4_BT3_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1998UL))
#define bFM4_BT3_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A19A0UL))
#define bFM4_BT3_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A19A4UL))
#define bFM4_BT3_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A19A8UL))
#define bFM4_BT3_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A19ACUL))
#define bFM4_BT3_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A19B0UL))
#define bFM4_BT3_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A19B4UL))
#define bFM4_BT3_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A19B8UL))
#define bFM4_BT3_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A1A00UL))
#define bFM4_BT3_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A1A08UL))
#define bFM4_BT3_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A1A10UL))
#define bFM4_BT3_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A1A18UL))
#define bFM4_BT3_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1A20UL))

/* Base Timer 3 PWM registers */
#define bFM4_BT3_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A1980UL))
#define bFM4_BT3_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1984UL))
#define bFM4_BT3_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1988UL))
#define bFM4_BT3_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A198CUL))
#define bFM4_BT3_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1990UL))
#define bFM4_BT3_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1994UL))
#define bFM4_BT3_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1998UL))
#define bFM4_BT3_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A19A0UL))
#define bFM4_BT3_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A19A4UL))
#define bFM4_BT3_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A19A8UL))
#define bFM4_BT3_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A19ACUL))
#define bFM4_BT3_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A19B0UL))
#define bFM4_BT3_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A19B4UL))
#define bFM4_BT3_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A19B8UL))
#define bFM4_BT3_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A1A00UL))
#define bFM4_BT3_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A1A04UL))
#define bFM4_BT3_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A1A08UL))
#define bFM4_BT3_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A1A10UL))
#define bFM4_BT3_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A1A14UL))
#define bFM4_BT3_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A1A18UL))
#define bFM4_BT3_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1A20UL))

/* Base Timer 3 RT registers */
#define bFM4_BT3_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A1980UL))
#define bFM4_BT3_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A1984UL))
#define bFM4_BT3_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A1988UL))
#define bFM4_BT3_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A198CUL))
#define bFM4_BT3_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A1990UL))
#define bFM4_BT3_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A1994UL))
#define bFM4_BT3_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A1998UL))
#define bFM4_BT3_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A199CUL))
#define bFM4_BT3_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A19A0UL))
#define bFM4_BT3_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A19A4UL))
#define bFM4_BT3_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A19B0UL))
#define bFM4_BT3_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A19B4UL))
#define bFM4_BT3_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A19B8UL))
#define bFM4_BT3_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A1A00UL))
#define bFM4_BT3_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A1A08UL))
#define bFM4_BT3_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A1A10UL))
#define bFM4_BT3_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A1A18UL))
#define bFM4_BT3_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A1A20UL))

/* Base Timer 3 PWC registers */
#define bFM4_BT3_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1984UL))
#define bFM4_BT3_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1988UL))
#define bFM4_BT3_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1990UL))
#define bFM4_BT3_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1994UL))
#define bFM4_BT3_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1998UL))
#define bFM4_BT3_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A199CUL))
#define bFM4_BT3_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A19A0UL))
#define bFM4_BT3_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A19A4UL))
#define bFM4_BT3_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A19A8UL))
#define bFM4_BT3_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A19B0UL))
#define bFM4_BT3_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A19B4UL))
#define bFM4_BT3_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A19B8UL))
#define bFM4_BT3_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A1A00UL))
#define bFM4_BT3_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A1A08UL))
#define bFM4_BT3_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A1A10UL))
#define bFM4_BT3_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A1A18UL))
#define bFM4_BT3_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A1A1CUL))
#define bFM4_BT3_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1A20UL))

/* Base Timer 4 PPG registers */
#define bFM4_BT4_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A4180UL))
#define bFM4_BT4_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4184UL))
#define bFM4_BT4_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4188UL))
#define bFM4_BT4_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A418CUL))
#define bFM4_BT4_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4190UL))
#define bFM4_BT4_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4194UL))
#define bFM4_BT4_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4198UL))
#define bFM4_BT4_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A41A0UL))
#define bFM4_BT4_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A41A4UL))
#define bFM4_BT4_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A41A8UL))
#define bFM4_BT4_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A41ACUL))
#define bFM4_BT4_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A41B0UL))
#define bFM4_BT4_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A41B4UL))
#define bFM4_BT4_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A41B8UL))
#define bFM4_BT4_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A4200UL))
#define bFM4_BT4_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A4208UL))
#define bFM4_BT4_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A4210UL))
#define bFM4_BT4_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A4218UL))
#define bFM4_BT4_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4220UL))

/* Base Timer 4 PWM registers */
#define bFM4_BT4_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A4180UL))
#define bFM4_BT4_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4184UL))
#define bFM4_BT4_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4188UL))
#define bFM4_BT4_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A418CUL))
#define bFM4_BT4_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4190UL))
#define bFM4_BT4_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4194UL))
#define bFM4_BT4_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4198UL))
#define bFM4_BT4_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A41A0UL))
#define bFM4_BT4_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A41A4UL))
#define bFM4_BT4_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A41A8UL))
#define bFM4_BT4_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A41ACUL))
#define bFM4_BT4_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A41B0UL))
#define bFM4_BT4_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A41B4UL))
#define bFM4_BT4_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A41B8UL))
#define bFM4_BT4_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A4200UL))
#define bFM4_BT4_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A4204UL))
#define bFM4_BT4_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A4208UL))
#define bFM4_BT4_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A4210UL))
#define bFM4_BT4_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A4214UL))
#define bFM4_BT4_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A4218UL))
#define bFM4_BT4_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4220UL))

/* Base Timer 4 RT registers */
#define bFM4_BT4_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A4180UL))
#define bFM4_BT4_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A4184UL))
#define bFM4_BT4_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A4188UL))
#define bFM4_BT4_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A418CUL))
#define bFM4_BT4_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A4190UL))
#define bFM4_BT4_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A4194UL))
#define bFM4_BT4_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A4198UL))
#define bFM4_BT4_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A419CUL))
#define bFM4_BT4_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A41A0UL))
#define bFM4_BT4_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A41A4UL))
#define bFM4_BT4_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A41B0UL))
#define bFM4_BT4_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A41B4UL))
#define bFM4_BT4_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A41B8UL))
#define bFM4_BT4_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A4200UL))
#define bFM4_BT4_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A4208UL))
#define bFM4_BT4_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A4210UL))
#define bFM4_BT4_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A4218UL))
#define bFM4_BT4_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A4220UL))

/* Base Timer 4 PWC registers */
#define bFM4_BT4_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4184UL))
#define bFM4_BT4_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4188UL))
#define bFM4_BT4_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4190UL))
#define bFM4_BT4_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4194UL))
#define bFM4_BT4_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4198UL))
#define bFM4_BT4_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A419CUL))
#define bFM4_BT4_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A41A0UL))
#define bFM4_BT4_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A41A4UL))
#define bFM4_BT4_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A41A8UL))
#define bFM4_BT4_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A41B0UL))
#define bFM4_BT4_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A41B4UL))
#define bFM4_BT4_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A41B8UL))
#define bFM4_BT4_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A4200UL))
#define bFM4_BT4_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A4208UL))
#define bFM4_BT4_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A4210UL))
#define bFM4_BT4_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A4218UL))
#define bFM4_BT4_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A421CUL))
#define bFM4_BT4_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4220UL))

/* Base Timer 5 PPG registers */
#define bFM4_BT5_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A4980UL))
#define bFM4_BT5_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4984UL))
#define bFM4_BT5_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4988UL))
#define bFM4_BT5_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A498CUL))
#define bFM4_BT5_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4990UL))
#define bFM4_BT5_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4994UL))
#define bFM4_BT5_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4998UL))
#define bFM4_BT5_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A49A0UL))
#define bFM4_BT5_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A49A4UL))
#define bFM4_BT5_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A49A8UL))
#define bFM4_BT5_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A49ACUL))
#define bFM4_BT5_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A49B0UL))
#define bFM4_BT5_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A49B4UL))
#define bFM4_BT5_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A49B8UL))
#define bFM4_BT5_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A4A00UL))
#define bFM4_BT5_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A4A08UL))
#define bFM4_BT5_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A4A10UL))
#define bFM4_BT5_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A4A18UL))
#define bFM4_BT5_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4A20UL))

/* Base Timer 5 PWM registers */
#define bFM4_BT5_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A4980UL))
#define bFM4_BT5_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4984UL))
#define bFM4_BT5_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4988UL))
#define bFM4_BT5_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A498CUL))
#define bFM4_BT5_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4990UL))
#define bFM4_BT5_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4994UL))
#define bFM4_BT5_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4998UL))
#define bFM4_BT5_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A49A0UL))
#define bFM4_BT5_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A49A4UL))
#define bFM4_BT5_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A49A8UL))
#define bFM4_BT5_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A49ACUL))
#define bFM4_BT5_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A49B0UL))
#define bFM4_BT5_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A49B4UL))
#define bFM4_BT5_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A49B8UL))
#define bFM4_BT5_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A4A00UL))
#define bFM4_BT5_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A4A04UL))
#define bFM4_BT5_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A4A08UL))
#define bFM4_BT5_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A4A10UL))
#define bFM4_BT5_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A4A14UL))
#define bFM4_BT5_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A4A18UL))
#define bFM4_BT5_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4A20UL))

/* Base Timer 5 RT registers */
#define bFM4_BT5_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A4980UL))
#define bFM4_BT5_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A4984UL))
#define bFM4_BT5_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A4988UL))
#define bFM4_BT5_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A498CUL))
#define bFM4_BT5_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A4990UL))
#define bFM4_BT5_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A4994UL))
#define bFM4_BT5_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A4998UL))
#define bFM4_BT5_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A499CUL))
#define bFM4_BT5_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A49A0UL))
#define bFM4_BT5_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A49A4UL))
#define bFM4_BT5_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A49B0UL))
#define bFM4_BT5_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A49B4UL))
#define bFM4_BT5_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A49B8UL))
#define bFM4_BT5_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A4A00UL))
#define bFM4_BT5_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A4A08UL))
#define bFM4_BT5_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A4A10UL))
#define bFM4_BT5_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A4A18UL))
#define bFM4_BT5_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A4A20UL))

/* Base Timer 5 PWC registers */
#define bFM4_BT5_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4984UL))
#define bFM4_BT5_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4988UL))
#define bFM4_BT5_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4990UL))
#define bFM4_BT5_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4994UL))
#define bFM4_BT5_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4998UL))
#define bFM4_BT5_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A499CUL))
#define bFM4_BT5_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A49A0UL))
#define bFM4_BT5_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A49A4UL))
#define bFM4_BT5_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A49A8UL))
#define bFM4_BT5_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A49B0UL))
#define bFM4_BT5_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A49B4UL))
#define bFM4_BT5_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A49B8UL))
#define bFM4_BT5_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A4A00UL))
#define bFM4_BT5_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A4A08UL))
#define bFM4_BT5_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A4A10UL))
#define bFM4_BT5_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A4A18UL))
#define bFM4_BT5_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A4A1CUL))
#define bFM4_BT5_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4A20UL))

/* Base Timer 6 PPG registers */
#define bFM4_BT6_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A5180UL))
#define bFM4_BT6_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5184UL))
#define bFM4_BT6_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5188UL))
#define bFM4_BT6_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A518CUL))
#define bFM4_BT6_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5190UL))
#define bFM4_BT6_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5194UL))
#define bFM4_BT6_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5198UL))
#define bFM4_BT6_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A51A0UL))
#define bFM4_BT6_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A51A4UL))
#define bFM4_BT6_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A51A8UL))
#define bFM4_BT6_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A51ACUL))
#define bFM4_BT6_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A51B0UL))
#define bFM4_BT6_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A51B4UL))
#define bFM4_BT6_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A51B8UL))
#define bFM4_BT6_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A5200UL))
#define bFM4_BT6_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A5208UL))
#define bFM4_BT6_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A5210UL))
#define bFM4_BT6_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A5218UL))
#define bFM4_BT6_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5220UL))

/* Base Timer 6 PWM registers */
#define bFM4_BT6_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A5180UL))
#define bFM4_BT6_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5184UL))
#define bFM4_BT6_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5188UL))
#define bFM4_BT6_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A518CUL))
#define bFM4_BT6_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5190UL))
#define bFM4_BT6_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5194UL))
#define bFM4_BT6_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5198UL))
#define bFM4_BT6_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A51A0UL))
#define bFM4_BT6_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A51A4UL))
#define bFM4_BT6_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A51A8UL))
#define bFM4_BT6_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A51ACUL))
#define bFM4_BT6_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A51B0UL))
#define bFM4_BT6_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A51B4UL))
#define bFM4_BT6_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A51B8UL))
#define bFM4_BT6_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A5200UL))
#define bFM4_BT6_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A5204UL))
#define bFM4_BT6_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A5208UL))
#define bFM4_BT6_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A5210UL))
#define bFM4_BT6_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A5214UL))
#define bFM4_BT6_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A5218UL))
#define bFM4_BT6_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5220UL))

/* Base Timer 6 RT registers */
#define bFM4_BT6_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A5180UL))
#define bFM4_BT6_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A5184UL))
#define bFM4_BT6_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A5188UL))
#define bFM4_BT6_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A518CUL))
#define bFM4_BT6_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A5190UL))
#define bFM4_BT6_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A5194UL))
#define bFM4_BT6_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A5198UL))
#define bFM4_BT6_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A519CUL))
#define bFM4_BT6_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A51A0UL))
#define bFM4_BT6_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A51A4UL))
#define bFM4_BT6_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A51B0UL))
#define bFM4_BT6_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A51B4UL))
#define bFM4_BT6_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A51B8UL))
#define bFM4_BT6_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A5200UL))
#define bFM4_BT6_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A5208UL))
#define bFM4_BT6_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A5210UL))
#define bFM4_BT6_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A5218UL))
#define bFM4_BT6_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A5220UL))

/* Base Timer 6 PWC registers */
#define bFM4_BT6_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5184UL))
#define bFM4_BT6_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5188UL))
#define bFM4_BT6_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5190UL))
#define bFM4_BT6_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5194UL))
#define bFM4_BT6_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5198UL))
#define bFM4_BT6_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A519CUL))
#define bFM4_BT6_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A51A0UL))
#define bFM4_BT6_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A51A4UL))
#define bFM4_BT6_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A51A8UL))
#define bFM4_BT6_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A51B0UL))
#define bFM4_BT6_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A51B4UL))
#define bFM4_BT6_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A51B8UL))
#define bFM4_BT6_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A5200UL))
#define bFM4_BT6_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A5208UL))
#define bFM4_BT6_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A5210UL))
#define bFM4_BT6_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A5218UL))
#define bFM4_BT6_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A521CUL))
#define bFM4_BT6_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5220UL))

/* Base Timer 7 PPG registers */
#define bFM4_BT7_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A5980UL))
#define bFM4_BT7_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5984UL))
#define bFM4_BT7_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5988UL))
#define bFM4_BT7_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A598CUL))
#define bFM4_BT7_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5990UL))
#define bFM4_BT7_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5994UL))
#define bFM4_BT7_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5998UL))
#define bFM4_BT7_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A59A0UL))
#define bFM4_BT7_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A59A4UL))
#define bFM4_BT7_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A59A8UL))
#define bFM4_BT7_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A59ACUL))
#define bFM4_BT7_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A59B0UL))
#define bFM4_BT7_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A59B4UL))
#define bFM4_BT7_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A59B8UL))
#define bFM4_BT7_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A5A00UL))
#define bFM4_BT7_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A5A08UL))
#define bFM4_BT7_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A5A10UL))
#define bFM4_BT7_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A5A18UL))
#define bFM4_BT7_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5A20UL))

/* Base Timer 7 PWM registers */
#define bFM4_BT7_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A5980UL))
#define bFM4_BT7_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5984UL))
#define bFM4_BT7_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5988UL))
#define bFM4_BT7_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A598CUL))
#define bFM4_BT7_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5990UL))
#define bFM4_BT7_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5994UL))
#define bFM4_BT7_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5998UL))
#define bFM4_BT7_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A59A0UL))
#define bFM4_BT7_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A59A4UL))
#define bFM4_BT7_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A59A8UL))
#define bFM4_BT7_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A59ACUL))
#define bFM4_BT7_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A59B0UL))
#define bFM4_BT7_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A59B4UL))
#define bFM4_BT7_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A59B8UL))
#define bFM4_BT7_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A5A00UL))
#define bFM4_BT7_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A5A04UL))
#define bFM4_BT7_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A5A08UL))
#define bFM4_BT7_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A5A10UL))
#define bFM4_BT7_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A5A14UL))
#define bFM4_BT7_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A5A18UL))
#define bFM4_BT7_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5A20UL))

/* Base Timer 7 RT registers */
#define bFM4_BT7_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A5980UL))
#define bFM4_BT7_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A5984UL))
#define bFM4_BT7_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A5988UL))
#define bFM4_BT7_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A598CUL))
#define bFM4_BT7_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A5990UL))
#define bFM4_BT7_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A5994UL))
#define bFM4_BT7_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A5998UL))
#define bFM4_BT7_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A599CUL))
#define bFM4_BT7_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A59A0UL))
#define bFM4_BT7_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A59A4UL))
#define bFM4_BT7_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A59B0UL))
#define bFM4_BT7_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A59B4UL))
#define bFM4_BT7_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A59B8UL))
#define bFM4_BT7_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A5A00UL))
#define bFM4_BT7_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A5A08UL))
#define bFM4_BT7_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A5A10UL))
#define bFM4_BT7_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A5A18UL))
#define bFM4_BT7_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A5A20UL))

/* Base Timer 7 PWC registers */
#define bFM4_BT7_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5984UL))
#define bFM4_BT7_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5988UL))
#define bFM4_BT7_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5990UL))
#define bFM4_BT7_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5994UL))
#define bFM4_BT7_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5998UL))
#define bFM4_BT7_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A599CUL))
#define bFM4_BT7_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A59A0UL))
#define bFM4_BT7_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A59A4UL))
#define bFM4_BT7_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A59A8UL))
#define bFM4_BT7_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A59B0UL))
#define bFM4_BT7_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A59B4UL))
#define bFM4_BT7_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A59B8UL))
#define bFM4_BT7_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A5A00UL))
#define bFM4_BT7_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A5A08UL))
#define bFM4_BT7_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A5A10UL))
#define bFM4_BT7_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A5A18UL))
#define bFM4_BT7_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A5A1CUL))
#define bFM4_BT7_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5A20UL))

/* Base Timer I/O selector channel 0 - channel 3 registers */
#define bFM4_BTIOSEL03_BTSEL0123_SEL01_0       *((volatile unsigned char*)(0x424A2020UL))
#define bFM4_BTIOSEL03_BTSEL0123_SEL01_1       *((volatile unsigned char*)(0x424A2024UL))
#define bFM4_BTIOSEL03_BTSEL0123_SEL01_2       *((volatile unsigned char*)(0x424A2028UL))
#define bFM4_BTIOSEL03_BTSEL0123_SEL01_3       *((volatile unsigned char*)(0x424A202CUL))
#define bFM4_BTIOSEL03_BTSEL0123_SEL23_0       *((volatile unsigned char*)(0x424A2030UL))
#define bFM4_BTIOSEL03_BTSEL0123_SEL23_1       *((volatile unsigned char*)(0x424A2034UL))
#define bFM4_BTIOSEL03_BTSEL0123_SEL23_2       *((volatile unsigned char*)(0x424A2038UL))
#define bFM4_BTIOSEL03_BTSEL0123_SEL23_3       *((volatile unsigned char*)(0x424A203CUL))

/* Base Timer I/O selector channel 4 - channel 7 registers */
#define bFM4_BTIOSEL47_BTSEL4567_SEL45_0       *((volatile unsigned char*)(0x424A6020UL))
#define bFM4_BTIOSEL47_BTSEL4567_SEL45_1       *((volatile unsigned char*)(0x424A6024UL))
#define bFM4_BTIOSEL47_BTSEL4567_SEL45_2       *((volatile unsigned char*)(0x424A6028UL))
#define bFM4_BTIOSEL47_BTSEL4567_SEL45_3       *((volatile unsigned char*)(0x424A602CUL))
#define bFM4_BTIOSEL47_BTSEL4567_SEL67_0       *((volatile unsigned char*)(0x424A6030UL))
#define bFM4_BTIOSEL47_BTSEL4567_SEL67_1       *((volatile unsigned char*)(0x424A6034UL))
#define bFM4_BTIOSEL47_BTSEL4567_SEL67_2       *((volatile unsigned char*)(0x424A6038UL))
#define bFM4_BTIOSEL47_BTSEL4567_SEL67_3       *((volatile unsigned char*)(0x424A603CUL))

/* Base Timer 8 PPG registers */
#define bFM4_BT8_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A8180UL))
#define bFM4_BT8_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8184UL))
#define bFM4_BT8_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8188UL))
#define bFM4_BT8_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A818CUL))
#define bFM4_BT8_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A81A0UL))
#define bFM4_BT8_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A81A4UL))
#define bFM4_BT8_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A81A8UL))
#define bFM4_BT8_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A81ACUL))
#define bFM4_BT8_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A81B0UL))
#define bFM4_BT8_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A81B4UL))
#define bFM4_BT8_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A81B8UL))
#define bFM4_BT8_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A8200UL))
#define bFM4_BT8_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A8208UL))
#define bFM4_BT8_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A8210UL))
#define bFM4_BT8_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A8218UL))
#define bFM4_BT8_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8220UL))

/* Base Timer 8 PWM registers */
#define bFM4_BT8_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A8180UL))
#define bFM4_BT8_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8184UL))
#define bFM4_BT8_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8188UL))
#define bFM4_BT8_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A818CUL))
#define bFM4_BT8_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A81A0UL))
#define bFM4_BT8_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A81A4UL))
#define bFM4_BT8_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A81A8UL))
#define bFM4_BT8_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A81ACUL))
#define bFM4_BT8_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A81B0UL))
#define bFM4_BT8_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A81B4UL))
#define bFM4_BT8_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A81B8UL))
#define bFM4_BT8_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A8200UL))
#define bFM4_BT8_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A8204UL))
#define bFM4_BT8_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A8208UL))
#define bFM4_BT8_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A8210UL))
#define bFM4_BT8_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A8214UL))
#define bFM4_BT8_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A8218UL))
#define bFM4_BT8_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8220UL))

/* Base Timer 8 RT registers */
#define bFM4_BT8_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A8180UL))
#define bFM4_BT8_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A8184UL))
#define bFM4_BT8_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A8188UL))
#define bFM4_BT8_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A818CUL))
#define bFM4_BT8_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A819CUL))
#define bFM4_BT8_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A81A0UL))
#define bFM4_BT8_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A81A4UL))
#define bFM4_BT8_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A81B0UL))
#define bFM4_BT8_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A81B4UL))
#define bFM4_BT8_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A81B8UL))
#define bFM4_BT8_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A8200UL))
#define bFM4_BT8_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A8208UL))
#define bFM4_BT8_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A8210UL))
#define bFM4_BT8_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A8218UL))
#define bFM4_BT8_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A8220UL))

/* Base Timer 8 PWC registers */
#define bFM4_BT8_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8184UL))
#define bFM4_BT8_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8188UL))
#define bFM4_BT8_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A819CUL))
#define bFM4_BT8_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A81A0UL))
#define bFM4_BT8_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A81A4UL))
#define bFM4_BT8_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A81A8UL))
#define bFM4_BT8_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A81B0UL))
#define bFM4_BT8_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A81B4UL))
#define bFM4_BT8_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A81B8UL))
#define bFM4_BT8_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A8200UL))
#define bFM4_BT8_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A8208UL))
#define bFM4_BT8_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A8210UL))
#define bFM4_BT8_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A8218UL))
#define bFM4_BT8_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A821CUL))
#define bFM4_BT8_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8220UL))

/* Base Timer 9 PPG registers */
#define bFM4_BT9_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A8980UL))
#define bFM4_BT9_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8984UL))
#define bFM4_BT9_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8988UL))
#define bFM4_BT9_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A898CUL))
#define bFM4_BT9_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A89A0UL))
#define bFM4_BT9_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A89A4UL))
#define bFM4_BT9_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A89A8UL))
#define bFM4_BT9_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A89ACUL))
#define bFM4_BT9_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A89B0UL))
#define bFM4_BT9_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A89B4UL))
#define bFM4_BT9_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A89B8UL))
#define bFM4_BT9_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A8A00UL))
#define bFM4_BT9_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A8A08UL))
#define bFM4_BT9_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A8A10UL))
#define bFM4_BT9_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A8A18UL))
#define bFM4_BT9_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8A20UL))

/* Base Timer 9 PWM registers */
#define bFM4_BT9_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A8980UL))
#define bFM4_BT9_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8984UL))
#define bFM4_BT9_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8988UL))
#define bFM4_BT9_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A898CUL))
#define bFM4_BT9_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A89A0UL))
#define bFM4_BT9_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A89A4UL))
#define bFM4_BT9_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A89A8UL))
#define bFM4_BT9_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A89ACUL))
#define bFM4_BT9_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A89B0UL))
#define bFM4_BT9_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A89B4UL))
#define bFM4_BT9_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A89B8UL))
#define bFM4_BT9_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A8A00UL))
#define bFM4_BT9_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A8A04UL))
#define bFM4_BT9_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A8A08UL))
#define bFM4_BT9_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A8A10UL))
#define bFM4_BT9_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A8A14UL))
#define bFM4_BT9_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A8A18UL))
#define bFM4_BT9_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8A20UL))

/* Base Timer 9 RT registers */
#define bFM4_BT9_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A8980UL))
#define bFM4_BT9_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A8984UL))
#define bFM4_BT9_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A8988UL))
#define bFM4_BT9_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A898CUL))
#define bFM4_BT9_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A899CUL))
#define bFM4_BT9_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A89A0UL))
#define bFM4_BT9_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A89A4UL))
#define bFM4_BT9_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A89B0UL))
#define bFM4_BT9_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A89B4UL))
#define bFM4_BT9_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A89B8UL))
#define bFM4_BT9_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A8A00UL))
#define bFM4_BT9_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A8A08UL))
#define bFM4_BT9_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A8A10UL))
#define bFM4_BT9_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A8A18UL))
#define bFM4_BT9_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A8A20UL))

/* Base Timer 9 PWC registers */
#define bFM4_BT9_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8984UL))
#define bFM4_BT9_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8988UL))
#define bFM4_BT9_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A899CUL))
#define bFM4_BT9_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A89A0UL))
#define bFM4_BT9_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A89A4UL))
#define bFM4_BT9_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A89A8UL))
#define bFM4_BT9_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A89B0UL))
#define bFM4_BT9_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A89B4UL))
#define bFM4_BT9_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A89B8UL))
#define bFM4_BT9_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A8A00UL))
#define bFM4_BT9_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A8A08UL))
#define bFM4_BT9_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A8A10UL))
#define bFM4_BT9_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A8A18UL))
#define bFM4_BT9_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A8A1CUL))
#define bFM4_BT9_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8A20UL))

/* Base Timer 10 PPG registers */
#define bFM4_BT10_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424A9180UL))
#define bFM4_BT10_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424A9184UL))
#define bFM4_BT10_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424A9188UL))
#define bFM4_BT10_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424A918CUL))
#define bFM4_BT10_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424A91A0UL))
#define bFM4_BT10_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424A91A4UL))
#define bFM4_BT10_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424A91A8UL))
#define bFM4_BT10_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424A91ACUL))
#define bFM4_BT10_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424A91B0UL))
#define bFM4_BT10_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424A91B4UL))
#define bFM4_BT10_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424A91B8UL))
#define bFM4_BT10_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424A9200UL))
#define bFM4_BT10_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424A9208UL))
#define bFM4_BT10_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424A9210UL))
#define bFM4_BT10_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424A9218UL))
#define bFM4_BT10_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9220UL))

/* Base Timer 10 PWM registers */
#define bFM4_BT10_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424A9180UL))
#define bFM4_BT10_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424A9184UL))
#define bFM4_BT10_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424A9188UL))
#define bFM4_BT10_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424A918CUL))
#define bFM4_BT10_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424A91A0UL))
#define bFM4_BT10_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424A91A4UL))
#define bFM4_BT10_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424A91A8UL))
#define bFM4_BT10_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424A91ACUL))
#define bFM4_BT10_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424A91B0UL))
#define bFM4_BT10_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424A91B4UL))
#define bFM4_BT10_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424A91B8UL))
#define bFM4_BT10_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424A9200UL))
#define bFM4_BT10_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424A9204UL))
#define bFM4_BT10_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424A9208UL))
#define bFM4_BT10_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424A9210UL))
#define bFM4_BT10_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424A9214UL))
#define bFM4_BT10_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424A9218UL))
#define bFM4_BT10_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9220UL))

/* Base Timer 10 RT registers */
#define bFM4_BT10_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424A9180UL))
#define bFM4_BT10_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424A9184UL))
#define bFM4_BT10_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424A9188UL))
#define bFM4_BT10_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424A918CUL))
#define bFM4_BT10_RT_TMCR_T32                  *((volatile unsigned char*)(0x424A919CUL))
#define bFM4_BT10_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424A91A0UL))
#define bFM4_BT10_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424A91A4UL))
#define bFM4_BT10_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424A91B0UL))
#define bFM4_BT10_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424A91B4UL))
#define bFM4_BT10_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424A91B8UL))
#define bFM4_BT10_RT_STC_UDIR                  *((volatile unsigned char*)(0x424A9200UL))
#define bFM4_BT10_RT_STC_TGIR                  *((volatile unsigned char*)(0x424A9208UL))
#define bFM4_BT10_RT_STC_UDIE                  *((volatile unsigned char*)(0x424A9210UL))
#define bFM4_BT10_RT_STC_TGIE                  *((volatile unsigned char*)(0x424A9218UL))
#define bFM4_BT10_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424A9220UL))

/* Base Timer 10 PWC registers */
#define bFM4_BT10_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424A9184UL))
#define bFM4_BT10_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424A9188UL))
#define bFM4_BT10_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424A919CUL))
#define bFM4_BT10_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424A91A0UL))
#define bFM4_BT10_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424A91A4UL))
#define bFM4_BT10_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424A91A8UL))
#define bFM4_BT10_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424A91B0UL))
#define bFM4_BT10_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424A91B4UL))
#define bFM4_BT10_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424A91B8UL))
#define bFM4_BT10_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424A9200UL))
#define bFM4_BT10_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424A9208UL))
#define bFM4_BT10_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424A9210UL))
#define bFM4_BT10_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424A9218UL))
#define bFM4_BT10_PWC_STC_ERR                  *((volatile unsigned char*)(0x424A921CUL))
#define bFM4_BT10_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9220UL))

/* Base Timer 11 PPG registers */
#define bFM4_BT11_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424A9980UL))
#define bFM4_BT11_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424A9984UL))
#define bFM4_BT11_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424A9988UL))
#define bFM4_BT11_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424A998CUL))
#define bFM4_BT11_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424A99A0UL))
#define bFM4_BT11_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424A99A4UL))
#define bFM4_BT11_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424A99A8UL))
#define bFM4_BT11_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424A99ACUL))
#define bFM4_BT11_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424A99B0UL))
#define bFM4_BT11_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424A99B4UL))
#define bFM4_BT11_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424A99B8UL))
#define bFM4_BT11_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424A9A00UL))
#define bFM4_BT11_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424A9A08UL))
#define bFM4_BT11_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424A9A10UL))
#define bFM4_BT11_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424A9A18UL))
#define bFM4_BT11_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9A20UL))

/* Base Timer 11 PWM registers */
#define bFM4_BT11_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424A9980UL))
#define bFM4_BT11_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424A9984UL))
#define bFM4_BT11_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424A9988UL))
#define bFM4_BT11_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424A998CUL))
#define bFM4_BT11_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424A99A0UL))
#define bFM4_BT11_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424A99A4UL))
#define bFM4_BT11_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424A99A8UL))
#define bFM4_BT11_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424A99ACUL))
#define bFM4_BT11_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424A99B0UL))
#define bFM4_BT11_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424A99B4UL))
#define bFM4_BT11_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424A99B8UL))
#define bFM4_BT11_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424A9A00UL))
#define bFM4_BT11_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424A9A04UL))
#define bFM4_BT11_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424A9A08UL))
#define bFM4_BT11_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424A9A10UL))
#define bFM4_BT11_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424A9A14UL))
#define bFM4_BT11_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424A9A18UL))
#define bFM4_BT11_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9A20UL))

/* Base Timer 11 RT registers */
#define bFM4_BT11_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424A9980UL))
#define bFM4_BT11_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424A9984UL))
#define bFM4_BT11_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424A9988UL))
#define bFM4_BT11_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424A998CUL))
#define bFM4_BT11_RT_TMCR_T32                  *((volatile unsigned char*)(0x424A999CUL))
#define bFM4_BT11_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424A99A0UL))
#define bFM4_BT11_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424A99A4UL))
#define bFM4_BT11_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424A99B0UL))
#define bFM4_BT11_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424A99B4UL))
#define bFM4_BT11_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424A99B8UL))
#define bFM4_BT11_RT_STC_UDIR                  *((volatile unsigned char*)(0x424A9A00UL))
#define bFM4_BT11_RT_STC_TGIR                  *((volatile unsigned char*)(0x424A9A08UL))
#define bFM4_BT11_RT_STC_UDIE                  *((volatile unsigned char*)(0x424A9A10UL))
#define bFM4_BT11_RT_STC_TGIE                  *((volatile unsigned char*)(0x424A9A18UL))
#define bFM4_BT11_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424A9A20UL))

/* Base Timer 11 PWC registers */
#define bFM4_BT11_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424A9984UL))
#define bFM4_BT11_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424A9988UL))
#define bFM4_BT11_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424A999CUL))
#define bFM4_BT11_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424A99A0UL))
#define bFM4_BT11_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424A99A4UL))
#define bFM4_BT11_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424A99A8UL))
#define bFM4_BT11_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424A99B0UL))
#define bFM4_BT11_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424A99B4UL))
#define bFM4_BT11_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424A99B8UL))
#define bFM4_BT11_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424A9A00UL))
#define bFM4_BT11_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424A9A08UL))
#define bFM4_BT11_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424A9A10UL))
#define bFM4_BT11_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424A9A18UL))
#define bFM4_BT11_PWC_STC_ERR                  *((volatile unsigned char*)(0x424A9A1CUL))
#define bFM4_BT11_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9A20UL))

/* Base Timer 12 PPG registers */
#define bFM4_BT12_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424AC180UL))
#define bFM4_BT12_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424AC184UL))
#define bFM4_BT12_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424AC188UL))
#define bFM4_BT12_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424AC18CUL))
#define bFM4_BT12_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424AC1A0UL))
#define bFM4_BT12_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424AC1A4UL))
#define bFM4_BT12_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424AC1A8UL))
#define bFM4_BT12_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424AC1ACUL))
#define bFM4_BT12_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424AC1B0UL))
#define bFM4_BT12_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424AC1B4UL))
#define bFM4_BT12_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424AC1B8UL))
#define bFM4_BT12_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424AC200UL))
#define bFM4_BT12_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424AC208UL))
#define bFM4_BT12_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424AC210UL))
#define bFM4_BT12_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424AC218UL))
#define bFM4_BT12_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424AC220UL))

/* Base Timer 12 PWM registers */
#define bFM4_BT12_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424AC180UL))
#define bFM4_BT12_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424AC184UL))
#define bFM4_BT12_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424AC188UL))
#define bFM4_BT12_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424AC18CUL))
#define bFM4_BT12_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424AC1A0UL))
#define bFM4_BT12_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424AC1A4UL))
#define bFM4_BT12_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424AC1A8UL))
#define bFM4_BT12_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424AC1ACUL))
#define bFM4_BT12_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424AC1B0UL))
#define bFM4_BT12_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424AC1B4UL))
#define bFM4_BT12_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424AC1B8UL))
#define bFM4_BT12_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424AC200UL))
#define bFM4_BT12_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424AC204UL))
#define bFM4_BT12_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424AC208UL))
#define bFM4_BT12_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424AC210UL))
#define bFM4_BT12_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424AC214UL))
#define bFM4_BT12_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424AC218UL))
#define bFM4_BT12_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424AC220UL))

/* Base Timer 12 RT registers */
#define bFM4_BT12_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424AC180UL))
#define bFM4_BT12_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424AC184UL))
#define bFM4_BT12_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424AC188UL))
#define bFM4_BT12_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424AC18CUL))
#define bFM4_BT12_RT_TMCR_T32                  *((volatile unsigned char*)(0x424AC19CUL))
#define bFM4_BT12_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424AC1A0UL))
#define bFM4_BT12_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424AC1A4UL))
#define bFM4_BT12_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424AC1B0UL))
#define bFM4_BT12_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424AC1B4UL))
#define bFM4_BT12_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424AC1B8UL))
#define bFM4_BT12_RT_STC_UDIR                  *((volatile unsigned char*)(0x424AC200UL))
#define bFM4_BT12_RT_STC_TGIR                  *((volatile unsigned char*)(0x424AC208UL))
#define bFM4_BT12_RT_STC_UDIE                  *((volatile unsigned char*)(0x424AC210UL))
#define bFM4_BT12_RT_STC_TGIE                  *((volatile unsigned char*)(0x424AC218UL))
#define bFM4_BT12_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424AC220UL))

/* Base Timer 12 PWC registers */
#define bFM4_BT12_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424AC184UL))
#define bFM4_BT12_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424AC188UL))
#define bFM4_BT12_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424AC19CUL))
#define bFM4_BT12_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424AC1A0UL))
#define bFM4_BT12_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424AC1A4UL))
#define bFM4_BT12_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424AC1A8UL))
#define bFM4_BT12_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424AC1B0UL))
#define bFM4_BT12_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424AC1B4UL))
#define bFM4_BT12_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424AC1B8UL))
#define bFM4_BT12_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424AC200UL))
#define bFM4_BT12_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424AC208UL))
#define bFM4_BT12_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424AC210UL))
#define bFM4_BT12_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424AC218UL))
#define bFM4_BT12_PWC_STC_ERR                  *((volatile unsigned char*)(0x424AC21CUL))
#define bFM4_BT12_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424AC220UL))

/* Base Timer 13 PPG registers */
#define bFM4_BT13_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424AC980UL))
#define bFM4_BT13_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424AC984UL))
#define bFM4_BT13_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424AC988UL))
#define bFM4_BT13_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424AC98CUL))
#define bFM4_BT13_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424AC9A0UL))
#define bFM4_BT13_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424AC9A4UL))
#define bFM4_BT13_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424AC9A8UL))
#define bFM4_BT13_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424AC9ACUL))
#define bFM4_BT13_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424AC9B0UL))
#define bFM4_BT13_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424AC9B4UL))
#define bFM4_BT13_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424AC9B8UL))
#define bFM4_BT13_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424ACA00UL))
#define bFM4_BT13_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424ACA08UL))
#define bFM4_BT13_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424ACA10UL))
#define bFM4_BT13_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424ACA18UL))
#define bFM4_BT13_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424ACA20UL))

/* Base Timer 13 PWM registers */
#define bFM4_BT13_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424AC980UL))
#define bFM4_BT13_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424AC984UL))
#define bFM4_BT13_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424AC988UL))
#define bFM4_BT13_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424AC98CUL))
#define bFM4_BT13_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424AC9A0UL))
#define bFM4_BT13_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424AC9A4UL))
#define bFM4_BT13_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424AC9A8UL))
#define bFM4_BT13_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424AC9ACUL))
#define bFM4_BT13_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424AC9B0UL))
#define bFM4_BT13_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424AC9B4UL))
#define bFM4_BT13_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424AC9B8UL))
#define bFM4_BT13_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424ACA00UL))
#define bFM4_BT13_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424ACA04UL))
#define bFM4_BT13_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424ACA08UL))
#define bFM4_BT13_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424ACA10UL))
#define bFM4_BT13_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424ACA14UL))
#define bFM4_BT13_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424ACA18UL))
#define bFM4_BT13_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424ACA20UL))

/* Base Timer 13 RT registers */
#define bFM4_BT13_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424AC980UL))
#define bFM4_BT13_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424AC984UL))
#define bFM4_BT13_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424AC988UL))
#define bFM4_BT13_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424AC98CUL))
#define bFM4_BT13_RT_TMCR_T32                  *((volatile unsigned char*)(0x424AC99CUL))
#define bFM4_BT13_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424AC9A0UL))
#define bFM4_BT13_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424AC9A4UL))
#define bFM4_BT13_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424AC9B0UL))
#define bFM4_BT13_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424AC9B4UL))
#define bFM4_BT13_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424AC9B8UL))
#define bFM4_BT13_RT_STC_UDIR                  *((volatile unsigned char*)(0x424ACA00UL))
#define bFM4_BT13_RT_STC_TGIR                  *((volatile unsigned char*)(0x424ACA08UL))
#define bFM4_BT13_RT_STC_UDIE                  *((volatile unsigned char*)(0x424ACA10UL))
#define bFM4_BT13_RT_STC_TGIE                  *((volatile unsigned char*)(0x424ACA18UL))
#define bFM4_BT13_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424ACA20UL))

/* Base Timer 13 PWC registers */
#define bFM4_BT13_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424AC984UL))
#define bFM4_BT13_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424AC988UL))
#define bFM4_BT13_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424AC99CUL))
#define bFM4_BT13_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424AC9A0UL))
#define bFM4_BT13_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424AC9A4UL))
#define bFM4_BT13_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424AC9A8UL))
#define bFM4_BT13_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424AC9B0UL))
#define bFM4_BT13_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424AC9B4UL))
#define bFM4_BT13_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424AC9B8UL))
#define bFM4_BT13_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424ACA00UL))
#define bFM4_BT13_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424ACA08UL))
#define bFM4_BT13_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424ACA10UL))
#define bFM4_BT13_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424ACA18UL))
#define bFM4_BT13_PWC_STC_ERR                  *((volatile unsigned char*)(0x424ACA1CUL))
#define bFM4_BT13_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424ACA20UL))

/* Base Timer 14 PPG registers */
#define bFM4_BT14_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424AD180UL))
#define bFM4_BT14_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424AD184UL))
#define bFM4_BT14_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424AD188UL))
#define bFM4_BT14_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424AD18CUL))
#define bFM4_BT14_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424AD1A0UL))
#define bFM4_BT14_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424AD1A4UL))
#define bFM4_BT14_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424AD1A8UL))
#define bFM4_BT14_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424AD1ACUL))
#define bFM4_BT14_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424AD1B0UL))
#define bFM4_BT14_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424AD1B4UL))
#define bFM4_BT14_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424AD1B8UL))
#define bFM4_BT14_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424AD200UL))
#define bFM4_BT14_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424AD208UL))
#define bFM4_BT14_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424AD210UL))
#define bFM4_BT14_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424AD218UL))
#define bFM4_BT14_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424AD220UL))

/* Base Timer 14 PWM registers */
#define bFM4_BT14_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424AD180UL))
#define bFM4_BT14_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424AD184UL))
#define bFM4_BT14_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424AD188UL))
#define bFM4_BT14_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424AD18CUL))
#define bFM4_BT14_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424AD1A0UL))
#define bFM4_BT14_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424AD1A4UL))
#define bFM4_BT14_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424AD1A8UL))
#define bFM4_BT14_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424AD1ACUL))
#define bFM4_BT14_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424AD1B0UL))
#define bFM4_BT14_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424AD1B4UL))
#define bFM4_BT14_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424AD1B8UL))
#define bFM4_BT14_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424AD200UL))
#define bFM4_BT14_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424AD204UL))
#define bFM4_BT14_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424AD208UL))
#define bFM4_BT14_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424AD210UL))
#define bFM4_BT14_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424AD214UL))
#define bFM4_BT14_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424AD218UL))
#define bFM4_BT14_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424AD220UL))

/* Base Timer 14 RT registers */
#define bFM4_BT14_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424AD180UL))
#define bFM4_BT14_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424AD184UL))
#define bFM4_BT14_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424AD188UL))
#define bFM4_BT14_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424AD18CUL))
#define bFM4_BT14_RT_TMCR_T32                  *((volatile unsigned char*)(0x424AD19CUL))
#define bFM4_BT14_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424AD1A0UL))
#define bFM4_BT14_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424AD1A4UL))
#define bFM4_BT14_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424AD1B0UL))
#define bFM4_BT14_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424AD1B4UL))
#define bFM4_BT14_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424AD1B8UL))
#define bFM4_BT14_RT_STC_UDIR                  *((volatile unsigned char*)(0x424AD200UL))
#define bFM4_BT14_RT_STC_TGIR                  *((volatile unsigned char*)(0x424AD208UL))
#define bFM4_BT14_RT_STC_UDIE                  *((volatile unsigned char*)(0x424AD210UL))
#define bFM4_BT14_RT_STC_TGIE                  *((volatile unsigned char*)(0x424AD218UL))
#define bFM4_BT14_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424AD220UL))

/* Base Timer 14 PWC registers */
#define bFM4_BT14_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424AD184UL))
#define bFM4_BT14_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424AD188UL))
#define bFM4_BT14_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424AD19CUL))
#define bFM4_BT14_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424AD1A0UL))
#define bFM4_BT14_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424AD1A4UL))
#define bFM4_BT14_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424AD1A8UL))
#define bFM4_BT14_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424AD1B0UL))
#define bFM4_BT14_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424AD1B4UL))
#define bFM4_BT14_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424AD1B8UL))
#define bFM4_BT14_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424AD200UL))
#define bFM4_BT14_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424AD208UL))
#define bFM4_BT14_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424AD210UL))
#define bFM4_BT14_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424AD218UL))
#define bFM4_BT14_PWC_STC_ERR                  *((volatile unsigned char*)(0x424AD21CUL))
#define bFM4_BT14_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424AD220UL))

/* Base Timer 15 PPG registers */
#define bFM4_BT15_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424AD980UL))
#define bFM4_BT15_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424AD984UL))
#define bFM4_BT15_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424AD988UL))
#define bFM4_BT15_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424AD98CUL))
#define bFM4_BT15_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424AD9A0UL))
#define bFM4_BT15_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424AD9A4UL))
#define bFM4_BT15_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424AD9A8UL))
#define bFM4_BT15_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424AD9ACUL))
#define bFM4_BT15_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424AD9B0UL))
#define bFM4_BT15_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424AD9B4UL))
#define bFM4_BT15_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424AD9B8UL))
#define bFM4_BT15_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424ADA00UL))
#define bFM4_BT15_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424ADA08UL))
#define bFM4_BT15_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424ADA10UL))
#define bFM4_BT15_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424ADA18UL))
#define bFM4_BT15_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424ADA20UL))

/* Base Timer 15 PWM registers */
#define bFM4_BT15_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424AD980UL))
#define bFM4_BT15_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424AD984UL))
#define bFM4_BT15_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424AD988UL))
#define bFM4_BT15_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424AD98CUL))
#define bFM4_BT15_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424AD9A0UL))
#define bFM4_BT15_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424AD9A4UL))
#define bFM4_BT15_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424AD9A8UL))
#define bFM4_BT15_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424AD9ACUL))
#define bFM4_BT15_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424AD9B0UL))
#define bFM4_BT15_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424AD9B4UL))
#define bFM4_BT15_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424AD9B8UL))
#define bFM4_BT15_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424ADA00UL))
#define bFM4_BT15_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424ADA04UL))
#define bFM4_BT15_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424ADA08UL))
#define bFM4_BT15_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424ADA10UL))
#define bFM4_BT15_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424ADA14UL))
#define bFM4_BT15_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424ADA18UL))
#define bFM4_BT15_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424ADA20UL))

/* Base Timer 15 RT registers */
#define bFM4_BT15_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424AD980UL))
#define bFM4_BT15_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424AD984UL))
#define bFM4_BT15_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424AD988UL))
#define bFM4_BT15_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424AD98CUL))
#define bFM4_BT15_RT_TMCR_T32                  *((volatile unsigned char*)(0x424AD99CUL))
#define bFM4_BT15_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424AD9A0UL))
#define bFM4_BT15_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424AD9A4UL))
#define bFM4_BT15_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424AD9B0UL))
#define bFM4_BT15_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424AD9B4UL))
#define bFM4_BT15_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424AD9B8UL))
#define bFM4_BT15_RT_STC_UDIR                  *((volatile unsigned char*)(0x424ADA00UL))
#define bFM4_BT15_RT_STC_TGIR                  *((volatile unsigned char*)(0x424ADA08UL))
#define bFM4_BT15_RT_STC_UDIE                  *((volatile unsigned char*)(0x424ADA10UL))
#define bFM4_BT15_RT_STC_TGIE                  *((volatile unsigned char*)(0x424ADA18UL))
#define bFM4_BT15_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424ADA20UL))

/* Base Timer 15 PWC registers */
#define bFM4_BT15_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424AD984UL))
#define bFM4_BT15_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424AD988UL))
#define bFM4_BT15_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424AD99CUL))
#define bFM4_BT15_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424AD9A0UL))
#define bFM4_BT15_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424AD9A4UL))
#define bFM4_BT15_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424AD9A8UL))
#define bFM4_BT15_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424AD9B0UL))
#define bFM4_BT15_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424AD9B4UL))
#define bFM4_BT15_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424AD9B8UL))
#define bFM4_BT15_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424ADA00UL))
#define bFM4_BT15_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424ADA08UL))
#define bFM4_BT15_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424ADA10UL))
#define bFM4_BT15_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424ADA18UL))
#define bFM4_BT15_PWC_STC_ERR                  *((volatile unsigned char*)(0x424ADA1CUL))
#define bFM4_BT15_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424ADA20UL))

/* Base Timer I/O selector channel 8 - channel 11 registers */
#define bFM4_BTIOSEL8B_BTSEL89AB_SEL89_0       *((volatile unsigned char*)(0x424AA020UL))
#define bFM4_BTIOSEL8B_BTSEL89AB_SEL89_1       *((volatile unsigned char*)(0x424AA024UL))
#define bFM4_BTIOSEL8B_BTSEL89AB_SEL89_2       *((volatile unsigned char*)(0x424AA028UL))
#define bFM4_BTIOSEL8B_BTSEL89AB_SEL89_3       *((volatile unsigned char*)(0x424AA02CUL))
#define bFM4_BTIOSEL8B_BTSEL89AB_SELAB_0       *((volatile unsigned char*)(0x424AA030UL))
#define bFM4_BTIOSEL8B_BTSEL89AB_SELAB_1       *((volatile unsigned char*)(0x424AA034UL))
#define bFM4_BTIOSEL8B_BTSEL89AB_SELAB_2       *((volatile unsigned char*)(0x424AA038UL))
#define bFM4_BTIOSEL8B_BTSEL89AB_SELAB_3       *((volatile unsigned char*)(0x424AA03CUL))

/* Base Timer I/O selector channel 12 - channel 15 registers */
#define bFM4_BTIOSELCF_BTSELCDEF_SELCD_0       *((volatile unsigned char*)(0x424AE020UL))
#define bFM4_BTIOSELCF_BTSELCDEF_SELCD_1       *((volatile unsigned char*)(0x424AE024UL))
#define bFM4_BTIOSELCF_BTSELCDEF_SELCD_2       *((volatile unsigned char*)(0x424AE028UL))
#define bFM4_BTIOSELCF_BTSELCDEF_SELCD_3       *((volatile unsigned char*)(0x424AE02CUL))
#define bFM4_BTIOSELCF_BTSELCDEF_SELEF_0       *((volatile unsigned char*)(0x424AE030UL))
#define bFM4_BTIOSELCF_BTSELCDEF_SELEF_1       *((volatile unsigned char*)(0x424AE034UL))
#define bFM4_BTIOSELCF_BTSELCDEF_SELEF_2       *((volatile unsigned char*)(0x424AE038UL))
#define bFM4_BTIOSELCF_BTSELCDEF_SELEF_3       *((volatile unsigned char*)(0x424AE03CUL))

/* Software based Simulation Startup (Base Timer) register */

/* Quad position and revolution counter channel 0 registers */
#define bFM4_QPRC0_QICR_QPCMIE                 *((volatile unsigned char*)(0x424C0280UL))
#define bFM4_QPRC0_QICR_QPCMF                  *((volatile unsigned char*)(0x424C0284UL))
#define bFM4_QPRC0_QICR_QPRCMIE                *((volatile unsigned char*)(0x424C0288UL))
#define bFM4_QPRC0_QICR_QPRCMF                 *((volatile unsigned char*)(0x424C028CUL))
#define bFM4_QPRC0_QICR_OUZIE                  *((volatile unsigned char*)(0x424C0290UL))
#define bFM4_QPRC0_QICR_UFDF                   *((volatile unsigned char*)(0x424C0294UL))
#define bFM4_QPRC0_QICR_OFDF                   *((volatile unsigned char*)(0x424C0298UL))
#define bFM4_QPRC0_QICR_ZIIF                   *((volatile unsigned char*)(0x424C029CUL))
#define bFM4_QPRC0_QICR_CDCIE                  *((volatile unsigned char*)(0x424C02A0UL))
#define bFM4_QPRC0_QICR_CDCF                   *((volatile unsigned char*)(0x424C02A4UL))
#define bFM4_QPRC0_QICR_DIRPC                  *((volatile unsigned char*)(0x424C02A8UL))
#define bFM4_QPRC0_QICR_DIROU                  *((volatile unsigned char*)(0x424C02ACUL))
#define bFM4_QPRC0_QICR_QPCNRCMIE              *((volatile unsigned char*)(0x424C02B0UL))
#define bFM4_QPRC0_QICR_QPCNRCMF               *((volatile unsigned char*)(0x424C02B4UL))
#define bFM4_QPRC0_QICRL_QPCMIE                *((volatile unsigned char*)(0x424C0280UL))
#define bFM4_QPRC0_QICRL_QPCMF                 *((volatile unsigned char*)(0x424C0284UL))
#define bFM4_QPRC0_QICRL_QPRCMIE               *((volatile unsigned char*)(0x424C0288UL))
#define bFM4_QPRC0_QICRL_QPRCMF                *((volatile unsigned char*)(0x424C028CUL))
#define bFM4_QPRC0_QICRL_OUZIE                 *((volatile unsigned char*)(0x424C0290UL))
#define bFM4_QPRC0_QICRL_UFDF                  *((volatile unsigned char*)(0x424C0294UL))
#define bFM4_QPRC0_QICRL_OFDF                  *((volatile unsigned char*)(0x424C0298UL))
#define bFM4_QPRC0_QICRL_ZIIF                  *((volatile unsigned char*)(0x424C029CUL))
#define bFM4_QPRC0_QICRH_CDCIE                 *((volatile unsigned char*)(0x424C02A0UL))
#define bFM4_QPRC0_QICRH_CDCF                  *((volatile unsigned char*)(0x424C02A4UL))
#define bFM4_QPRC0_QICRH_DIRPC                 *((volatile unsigned char*)(0x424C02A8UL))
#define bFM4_QPRC0_QICRH_DIROU                 *((volatile unsigned char*)(0x424C02ACUL))
#define bFM4_QPRC0_QICRH_QPCNRCMIE             *((volatile unsigned char*)(0x424C02B0UL))
#define bFM4_QPRC0_QICRH_QPCNRCMF              *((volatile unsigned char*)(0x424C02B4UL))
#define bFM4_QPRC0_QCR_PCM0                    *((volatile unsigned char*)(0x424C0300UL))
#define bFM4_QPRC0_QCR_PCM1                    *((volatile unsigned char*)(0x424C0304UL))
#define bFM4_QPRC0_QCR_RCM0                    *((volatile unsigned char*)(0x424C0308UL))
#define bFM4_QPRC0_QCR_RCM1                    *((volatile unsigned char*)(0x424C030CUL))
#define bFM4_QPRC0_QCR_PSTP                    *((volatile unsigned char*)(0x424C0310UL))
#define bFM4_QPRC0_QCR_CGSC                    *((volatile unsigned char*)(0x424C0314UL))
#define bFM4_QPRC0_QCR_RSEL                    *((volatile unsigned char*)(0x424C0318UL))
#define bFM4_QPRC0_QCR_SWAP                    *((volatile unsigned char*)(0x424C031CUL))
#define bFM4_QPRC0_QCR_PCRM0                   *((volatile unsigned char*)(0x424C0320UL))
#define bFM4_QPRC0_QCR_PCRM1                   *((volatile unsigned char*)(0x424C0324UL))
#define bFM4_QPRC0_QCR_AES0                    *((volatile unsigned char*)(0x424C0328UL))
#define bFM4_QPRC0_QCR_AES1                    *((volatile unsigned char*)(0x424C032CUL))
#define bFM4_QPRC0_QCR_BES0                    *((volatile unsigned char*)(0x424C0330UL))
#define bFM4_QPRC0_QCR_BES1                    *((volatile unsigned char*)(0x424C0334UL))
#define bFM4_QPRC0_QCR_CGE0                    *((volatile unsigned char*)(0x424C0338UL))
#define bFM4_QPRC0_QCR_CGE1                    *((volatile unsigned char*)(0x424C033CUL))
#define bFM4_QPRC0_QCRL_PCM0                   *((volatile unsigned char*)(0x424C0300UL))
#define bFM4_QPRC0_QCRL_PCM1                   *((volatile unsigned char*)(0x424C0304UL))
#define bFM4_QPRC0_QCRL_RCM0                   *((volatile unsigned char*)(0x424C0308UL))
#define bFM4_QPRC0_QCRL_RCM1                   *((volatile unsigned char*)(0x424C030CUL))
#define bFM4_QPRC0_QCRL_PSTP                   *((volatile unsigned char*)(0x424C0310UL))
#define bFM4_QPRC0_QCRL_CGSC                   *((volatile unsigned char*)(0x424C0314UL))
#define bFM4_QPRC0_QCRL_RSEL                   *((volatile unsigned char*)(0x424C0318UL))
#define bFM4_QPRC0_QCRL_SWAP                   *((volatile unsigned char*)(0x424C031CUL))
#define bFM4_QPRC0_QCRH_PCRM0                  *((volatile unsigned char*)(0x424C0320UL))
#define bFM4_QPRC0_QCRH_PCRM1                  *((volatile unsigned char*)(0x424C0324UL))
#define bFM4_QPRC0_QCRH_AES0                   *((volatile unsigned char*)(0x424C0328UL))
#define bFM4_QPRC0_QCRH_AES1                   *((volatile unsigned char*)(0x424C032CUL))
#define bFM4_QPRC0_QCRH_BES0                   *((volatile unsigned char*)(0x424C0330UL))
#define bFM4_QPRC0_QCRH_BES1                   *((volatile unsigned char*)(0x424C0334UL))
#define bFM4_QPRC0_QCRH_CGE0                   *((volatile unsigned char*)(0x424C0338UL))
#define bFM4_QPRC0_QCRH_CGE1                   *((volatile unsigned char*)(0x424C033CUL))
#define bFM4_QPRC0_QECR_ORNGMD                 *((volatile unsigned char*)(0x424C0380UL))
#define bFM4_QPRC0_QECR_ORNGF                  *((volatile unsigned char*)(0x424C0384UL))
#define bFM4_QPRC0_QECR_ORNGIE                 *((volatile unsigned char*)(0x424C0388UL))
#define bFM4_QPRC0_QECR_PEC                    *((volatile unsigned char*)(0x424C038CUL))

/* Quad position and revolution counter channel 1 registers */
#define bFM4_QPRC1_QICR_QPCMIE                 *((volatile unsigned char*)(0x424C0A80UL))
#define bFM4_QPRC1_QICR_QPCMF                  *((volatile unsigned char*)(0x424C0A84UL))
#define bFM4_QPRC1_QICR_QPRCMIE                *((volatile unsigned char*)(0x424C0A88UL))
#define bFM4_QPRC1_QICR_QPRCMF                 *((volatile unsigned char*)(0x424C0A8CUL))
#define bFM4_QPRC1_QICR_OUZIE                  *((volatile unsigned char*)(0x424C0A90UL))
#define bFM4_QPRC1_QICR_UFDF                   *((volatile unsigned char*)(0x424C0A94UL))
#define bFM4_QPRC1_QICR_OFDF                   *((volatile unsigned char*)(0x424C0A98UL))
#define bFM4_QPRC1_QICR_ZIIF                   *((volatile unsigned char*)(0x424C0A9CUL))
#define bFM4_QPRC1_QICR_CDCIE                  *((volatile unsigned char*)(0x424C0AA0UL))
#define bFM4_QPRC1_QICR_CDCF                   *((volatile unsigned char*)(0x424C0AA4UL))
#define bFM4_QPRC1_QICR_DIRPC                  *((volatile unsigned char*)(0x424C0AA8UL))
#define bFM4_QPRC1_QICR_DIROU                  *((volatile unsigned char*)(0x424C0AACUL))
#define bFM4_QPRC1_QICR_QPCNRCMIE              *((volatile unsigned char*)(0x424C0AB0UL))
#define bFM4_QPRC1_QICR_QPCNRCMF               *((volatile unsigned char*)(0x424C0AB4UL))
#define bFM4_QPRC1_QICRL_QPCMIE                *((volatile unsigned char*)(0x424C0A80UL))
#define bFM4_QPRC1_QICRL_QPCMF                 *((volatile unsigned char*)(0x424C0A84UL))
#define bFM4_QPRC1_QICRL_QPRCMIE               *((volatile unsigned char*)(0x424C0A88UL))
#define bFM4_QPRC1_QICRL_QPRCMF                *((volatile unsigned char*)(0x424C0A8CUL))
#define bFM4_QPRC1_QICRL_OUZIE                 *((volatile unsigned char*)(0x424C0A90UL))
#define bFM4_QPRC1_QICRL_UFDF                  *((volatile unsigned char*)(0x424C0A94UL))
#define bFM4_QPRC1_QICRL_OFDF                  *((volatile unsigned char*)(0x424C0A98UL))
#define bFM4_QPRC1_QICRL_ZIIF                  *((volatile unsigned char*)(0x424C0A9CUL))
#define bFM4_QPRC1_QICRH_CDCIE                 *((volatile unsigned char*)(0x424C0AA0UL))
#define bFM4_QPRC1_QICRH_CDCF                  *((volatile unsigned char*)(0x424C0AA4UL))
#define bFM4_QPRC1_QICRH_DIRPC                 *((volatile unsigned char*)(0x424C0AA8UL))
#define bFM4_QPRC1_QICRH_DIROU                 *((volatile unsigned char*)(0x424C0AACUL))
#define bFM4_QPRC1_QICRH_QPCNRCMIE             *((volatile unsigned char*)(0x424C0AB0UL))
#define bFM4_QPRC1_QICRH_QPCNRCMF              *((volatile unsigned char*)(0x424C0AB4UL))
#define bFM4_QPRC1_QCR_PCM0                    *((volatile unsigned char*)(0x424C0B00UL))
#define bFM4_QPRC1_QCR_PCM1                    *((volatile unsigned char*)(0x424C0B04UL))
#define bFM4_QPRC1_QCR_RCM0                    *((volatile unsigned char*)(0x424C0B08UL))
#define bFM4_QPRC1_QCR_RCM1                    *((volatile unsigned char*)(0x424C0B0CUL))
#define bFM4_QPRC1_QCR_PSTP                    *((volatile unsigned char*)(0x424C0B10UL))
#define bFM4_QPRC1_QCR_CGSC                    *((volatile unsigned char*)(0x424C0B14UL))
#define bFM4_QPRC1_QCR_RSEL                    *((volatile unsigned char*)(0x424C0B18UL))
#define bFM4_QPRC1_QCR_SWAP                    *((volatile unsigned char*)(0x424C0B1CUL))
#define bFM4_QPRC1_QCR_PCRM0                   *((volatile unsigned char*)(0x424C0B20UL))
#define bFM4_QPRC1_QCR_PCRM1                   *((volatile unsigned char*)(0x424C0B24UL))
#define bFM4_QPRC1_QCR_AES0                    *((volatile unsigned char*)(0x424C0B28UL))
#define bFM4_QPRC1_QCR_AES1                    *((volatile unsigned char*)(0x424C0B2CUL))
#define bFM4_QPRC1_QCR_BES0                    *((volatile unsigned char*)(0x424C0B30UL))
#define bFM4_QPRC1_QCR_BES1                    *((volatile unsigned char*)(0x424C0B34UL))
#define bFM4_QPRC1_QCR_CGE0                    *((volatile unsigned char*)(0x424C0B38UL))
#define bFM4_QPRC1_QCR_CGE1                    *((volatile unsigned char*)(0x424C0B3CUL))
#define bFM4_QPRC1_QCRL_PCM0                   *((volatile unsigned char*)(0x424C0B00UL))
#define bFM4_QPRC1_QCRL_PCM1                   *((volatile unsigned char*)(0x424C0B04UL))
#define bFM4_QPRC1_QCRL_RCM0                   *((volatile unsigned char*)(0x424C0B08UL))
#define bFM4_QPRC1_QCRL_RCM1                   *((volatile unsigned char*)(0x424C0B0CUL))
#define bFM4_QPRC1_QCRL_PSTP                   *((volatile unsigned char*)(0x424C0B10UL))
#define bFM4_QPRC1_QCRL_CGSC                   *((volatile unsigned char*)(0x424C0B14UL))
#define bFM4_QPRC1_QCRL_RSEL                   *((volatile unsigned char*)(0x424C0B18UL))
#define bFM4_QPRC1_QCRL_SWAP                   *((volatile unsigned char*)(0x424C0B1CUL))
#define bFM4_QPRC1_QCRH_PCRM0                  *((volatile unsigned char*)(0x424C0B20UL))
#define bFM4_QPRC1_QCRH_PCRM1                  *((volatile unsigned char*)(0x424C0B24UL))
#define bFM4_QPRC1_QCRH_AES0                   *((volatile unsigned char*)(0x424C0B28UL))
#define bFM4_QPRC1_QCRH_AES1                   *((volatile unsigned char*)(0x424C0B2CUL))
#define bFM4_QPRC1_QCRH_BES0                   *((volatile unsigned char*)(0x424C0B30UL))
#define bFM4_QPRC1_QCRH_BES1                   *((volatile unsigned char*)(0x424C0B34UL))
#define bFM4_QPRC1_QCRH_CGE0                   *((volatile unsigned char*)(0x424C0B38UL))
#define bFM4_QPRC1_QCRH_CGE1                   *((volatile unsigned char*)(0x424C0B3CUL))
#define bFM4_QPRC1_QECR_ORNGMD                 *((volatile unsigned char*)(0x424C0B80UL))
#define bFM4_QPRC1_QECR_ORNGF                  *((volatile unsigned char*)(0x424C0B84UL))
#define bFM4_QPRC1_QECR_ORNGIE                 *((volatile unsigned char*)(0x424C0B88UL))

/* Quad position and revolution counter channel 2 registers */
#define bFM4_QPRC2_QICR_QPCMIE                 *((volatile unsigned char*)(0x424C1280UL))
#define bFM4_QPRC2_QICR_QPCMF                  *((volatile unsigned char*)(0x424C1284UL))
#define bFM4_QPRC2_QICR_QPRCMIE                *((volatile unsigned char*)(0x424C1288UL))
#define bFM4_QPRC2_QICR_QPRCMF                 *((volatile unsigned char*)(0x424C128CUL))
#define bFM4_QPRC2_QICR_OUZIE                  *((volatile unsigned char*)(0x424C1290UL))
#define bFM4_QPRC2_QICR_UFDF                   *((volatile unsigned char*)(0x424C1294UL))
#define bFM4_QPRC2_QICR_OFDF                   *((volatile unsigned char*)(0x424C1298UL))
#define bFM4_QPRC2_QICR_ZIIF                   *((volatile unsigned char*)(0x424C129CUL))
#define bFM4_QPRC2_QICR_CDCIE                  *((volatile unsigned char*)(0x424C12A0UL))
#define bFM4_QPRC2_QICR_CDCF                   *((volatile unsigned char*)(0x424C12A4UL))
#define bFM4_QPRC2_QICR_DIRPC                  *((volatile unsigned char*)(0x424C12A8UL))
#define bFM4_QPRC2_QICR_DIROU                  *((volatile unsigned char*)(0x424C12ACUL))
#define bFM4_QPRC2_QICR_QPCNRCMIE              *((volatile unsigned char*)(0x424C12B0UL))
#define bFM4_QPRC2_QICR_QPCNRCMF               *((volatile unsigned char*)(0x424C12B4UL))
#define bFM4_QPRC2_QICRL_QPCMIE                *((volatile unsigned char*)(0x424C1280UL))
#define bFM4_QPRC2_QICRL_QPCMF                 *((volatile unsigned char*)(0x424C1284UL))
#define bFM4_QPRC2_QICRL_QPRCMIE               *((volatile unsigned char*)(0x424C1288UL))
#define bFM4_QPRC2_QICRL_QPRCMF                *((volatile unsigned char*)(0x424C128CUL))
#define bFM4_QPRC2_QICRL_OUZIE                 *((volatile unsigned char*)(0x424C1290UL))
#define bFM4_QPRC2_QICRL_UFDF                  *((volatile unsigned char*)(0x424C1294UL))
#define bFM4_QPRC2_QICRL_OFDF                  *((volatile unsigned char*)(0x424C1298UL))
#define bFM4_QPRC2_QICRL_ZIIF                  *((volatile unsigned char*)(0x424C129CUL))
#define bFM4_QPRC2_QICRH_CDCIE                 *((volatile unsigned char*)(0x424C12A0UL))
#define bFM4_QPRC2_QICRH_CDCF                  *((volatile unsigned char*)(0x424C12A4UL))
#define bFM4_QPRC2_QICRH_DIRPC                 *((volatile unsigned char*)(0x424C12A8UL))
#define bFM4_QPRC2_QICRH_DIROU                 *((volatile unsigned char*)(0x424C12ACUL))
#define bFM4_QPRC2_QICRH_QPCNRCMIE             *((volatile unsigned char*)(0x424C12B0UL))
#define bFM4_QPRC2_QICRH_QPCNRCMF              *((volatile unsigned char*)(0x424C12B4UL))
#define bFM4_QPRC2_QCR_PCM0                    *((volatile unsigned char*)(0x424C1300UL))
#define bFM4_QPRC2_QCR_PCM1                    *((volatile unsigned char*)(0x424C1304UL))
#define bFM4_QPRC2_QCR_RCM0                    *((volatile unsigned char*)(0x424C1308UL))
#define bFM4_QPRC2_QCR_RCM1                    *((volatile unsigned char*)(0x424C130CUL))
#define bFM4_QPRC2_QCR_PSTP                    *((volatile unsigned char*)(0x424C1310UL))
#define bFM4_QPRC2_QCR_CGSC                    *((volatile unsigned char*)(0x424C1314UL))
#define bFM4_QPRC2_QCR_RSEL                    *((volatile unsigned char*)(0x424C1318UL))
#define bFM4_QPRC2_QCR_SWAP                    *((volatile unsigned char*)(0x424C131CUL))
#define bFM4_QPRC2_QCR_PCRM0                   *((volatile unsigned char*)(0x424C1320UL))
#define bFM4_QPRC2_QCR_PCRM1                   *((volatile unsigned char*)(0x424C1324UL))
#define bFM4_QPRC2_QCR_AES0                    *((volatile unsigned char*)(0x424C1328UL))
#define bFM4_QPRC2_QCR_AES1                    *((volatile unsigned char*)(0x424C132CUL))
#define bFM4_QPRC2_QCR_BES0                    *((volatile unsigned char*)(0x424C1330UL))
#define bFM4_QPRC2_QCR_BES1                    *((volatile unsigned char*)(0x424C1334UL))
#define bFM4_QPRC2_QCR_CGE0                    *((volatile unsigned char*)(0x424C1338UL))
#define bFM4_QPRC2_QCR_CGE1                    *((volatile unsigned char*)(0x424C133CUL))
#define bFM4_QPRC2_QCRL_PCM0                   *((volatile unsigned char*)(0x424C1300UL))
#define bFM4_QPRC2_QCRL_PCM1                   *((volatile unsigned char*)(0x424C1304UL))
#define bFM4_QPRC2_QCRL_RCM0                   *((volatile unsigned char*)(0x424C1308UL))
#define bFM4_QPRC2_QCRL_RCM1                   *((volatile unsigned char*)(0x424C130CUL))
#define bFM4_QPRC2_QCRL_PSTP                   *((volatile unsigned char*)(0x424C1310UL))
#define bFM4_QPRC2_QCRL_CGSC                   *((volatile unsigned char*)(0x424C1314UL))
#define bFM4_QPRC2_QCRL_RSEL                   *((volatile unsigned char*)(0x424C1318UL))
#define bFM4_QPRC2_QCRL_SWAP                   *((volatile unsigned char*)(0x424C131CUL))
#define bFM4_QPRC2_QCRH_PCRM0                  *((volatile unsigned char*)(0x424C1320UL))
#define bFM4_QPRC2_QCRH_PCRM1                  *((volatile unsigned char*)(0x424C1324UL))
#define bFM4_QPRC2_QCRH_AES0                   *((volatile unsigned char*)(0x424C1328UL))
#define bFM4_QPRC2_QCRH_AES1                   *((volatile unsigned char*)(0x424C132CUL))
#define bFM4_QPRC2_QCRH_BES0                   *((volatile unsigned char*)(0x424C1330UL))
#define bFM4_QPRC2_QCRH_BES1                   *((volatile unsigned char*)(0x424C1334UL))
#define bFM4_QPRC2_QCRH_CGE0                   *((volatile unsigned char*)(0x424C1338UL))
#define bFM4_QPRC2_QCRH_CGE1                   *((volatile unsigned char*)(0x424C133CUL))
#define bFM4_QPRC2_QECR_ORNGMD                 *((volatile unsigned char*)(0x424C1380UL))
#define bFM4_QPRC2_QECR_ORNGF                  *((volatile unsigned char*)(0x424C1384UL))
#define bFM4_QPRC2_QECR_ORNGIE                 *((volatile unsigned char*)(0x424C1388UL))

/* Quad position and revolution counter channel 3 registers */
#define bFM4_QPRC3_QICR_QPCMIE                 *((volatile unsigned char*)(0x424c1a80UL))
#define bFM4_QPRC3_QICR_QPCMF                  *((volatile unsigned char*)(0x424c1a84UL))
#define bFM4_QPRC3_QICR_QPRCMIE                *((volatile unsigned char*)(0x424c1a88UL))
#define bFM4_QPRC3_QICR_QPRCMF                 *((volatile unsigned char*)(0x424c1a8CUL))
#define bFM4_QPRC3_QICR_OUZIE                  *((volatile unsigned char*)(0x424c1a90UL))
#define bFM4_QPRC3_QICR_UFDF                   *((volatile unsigned char*)(0x424c1a94UL))
#define bFM4_QPRC3_QICR_OFDF                   *((volatile unsigned char*)(0x424c1a98UL))
#define bFM4_QPRC3_QICR_ZIIF                   *((volatile unsigned char*)(0x424c1a9CUL))
#define bFM4_QPRC3_QICR_CDCIE                  *((volatile unsigned char*)(0x424c1aa0UL))
#define bFM4_QPRC3_QICR_CDCF                   *((volatile unsigned char*)(0x424c1aa4UL))
#define bFM4_QPRC3_QICR_DIRPC                  *((volatile unsigned char*)(0x424c1aa8UL))
#define bFM4_QPRC3_QICR_DIROU                  *((volatile unsigned char*)(0x424c1aaCUL))
#define bFM4_QPRC3_QICR_QPCNRCMIE              *((volatile unsigned char*)(0x424c1ab0UL))
#define bFM4_QPRC3_QICR_QPCNRCMF               *((volatile unsigned char*)(0x424c1ab4UL))
#define bFM4_QPRC3_QCR_PCM0                    *((volatile unsigned char*)(0x424c1b00UL))
#define bFM4_QPRC3_QCR_PCM1                    *((volatile unsigned char*)(0x424c1b04UL))
#define bFM4_QPRC3_QCR_RCM0                    *((volatile unsigned char*)(0x424c1b08UL))
#define bFM4_QPRC3_QCR_RCM1                    *((volatile unsigned char*)(0x424c1b0CUL))
#define bFM4_QPRC3_QCR_PSTP                    *((volatile unsigned char*)(0x424c1b10UL))
#define bFM4_QPRC3_QCR_CGSC                    *((volatile unsigned char*)(0x424c1b14UL))
#define bFM4_QPRC3_QCR_RSEL                    *((volatile unsigned char*)(0x424c1b18UL))
#define bFM4_QPRC3_QCR_SWAP                    *((volatile unsigned char*)(0x424c1b1CUL))
#define bFM4_QPRC3_QCR_PCRM0                   *((volatile unsigned char*)(0x424c1b20UL))
#define bFM4_QPRC3_QCR_PCRM1                   *((volatile unsigned char*)(0x424c1b24UL))
#define bFM4_QPRC3_QCR_AES0                    *((volatile unsigned char*)(0x424c1b28UL))
#define bFM4_QPRC3_QCR_AES1                    *((volatile unsigned char*)(0x424c1b2CUL))
#define bFM4_QPRC3_QCR_BES0                    *((volatile unsigned char*)(0x424c1b30UL))
#define bFM4_QPRC3_QCR_BES1                    *((volatile unsigned char*)(0x424c1b34UL))
#define bFM4_QPRC3_QCR_CGE0                    *((volatile unsigned char*)(0x424c1b38UL))
#define bFM4_QPRC3_QCR_CGE1                    *((volatile unsigned char*)(0x424c1b3CUL))
#define bFM4_QPRC3_QECR_ORNGMD                 *((volatile unsigned char*)(0x424c1b80UL))
#define bFM4_QPRC3_QECR_ORNGF                  *((volatile unsigned char*)(0x424c1b84UL))
#define bFM4_QPRC3_QECR_ORNGIE                 *((volatile unsigned char*)(0x424c1b88UL))

/* QPRC NF channel 0 registers */
#define bFM4_QPRC0_NF_NFCTLA_AINLV             *((volatile unsigned char*)(0x424c2010UL))
#define bFM4_QPRC0_NF_NFCTLA_AINMD             *((volatile unsigned char*)(0x424c2014UL))
#define bFM4_QPRC0_NF_NFCTLB_BINLV             *((volatile unsigned char*)(0x424c2090UL))
#define bFM4_QPRC0_NF_NFCTLB_BINMD             *((volatile unsigned char*)(0x424c2094UL))
#define bFM4_QPRC0_NF_NFRCTLZ_ZINLV            *((volatile unsigned char*)(0x424c2110UL))
#define bFM4_QPRC0_NF_NFRCTLZ_ZINMD            *((volatile unsigned char*)(0x424c2114UL))

/* QPRC NF channel 1 registers */
#define bFM4_QPRC1_NF_NFCTLA_AINLV             *((volatile unsigned char*)(0x424c2210UL))
#define bFM4_QPRC1_NF_NFCTLA_AINMD             *((volatile unsigned char*)(0x424c2214UL))
#define bFM4_QPRC1_NF_NFCTLB_BINLV             *((volatile unsigned char*)(0x424c2290UL))
#define bFM4_QPRC1_NF_NFCTLB_BINMD             *((volatile unsigned char*)(0x424c2294UL))
#define bFM4_QPRC1_NF_NFRCTLZ_ZINLV            *((volatile unsigned char*)(0x424c2310UL))
#define bFM4_QPRC1_NF_NFRCTLZ_ZINMD            *((volatile unsigned char*)(0x424c2314UL))

/* QPRC NF channel 2 registers */
#define bFM4_QPRC2_NF_NFCTLA_AINLV             *((volatile unsigned char*)(0x424c2410UL))
#define bFM4_QPRC2_NF_NFCTLA_AINMD             *((volatile unsigned char*)(0x424c2414UL))
#define bFM4_QPRC2_NF_NFCTLB_BINLV             *((volatile unsigned char*)(0x424c2490UL))
#define bFM4_QPRC2_NF_NFCTLB_BINMD             *((volatile unsigned char*)(0x424c2494UL))
#define bFM4_QPRC2_NF_NFRCTLZ_ZINLV            *((volatile unsigned char*)(0x424c2510UL))
#define bFM4_QPRC2_NF_NFRCTLZ_ZINMD            *((volatile unsigned char*)(0x424c2514UL))

/* QPRC NF channel 3 registers */
#define bFM4_QPRC3_NF_NFCTLA_AINLV             *((volatile unsigned char*)(0x424c2610UL))
#define bFM4_QPRC3_NF_NFCTLA_AINMD             *((volatile unsigned char*)(0x424c2614UL))
#define bFM4_QPRC3_NF_NFCTLB_BINLV             *((volatile unsigned char*)(0x424c2690UL))
#define bFM4_QPRC3_NF_NFCTLB_BINMD             *((volatile unsigned char*)(0x424c2694UL))
#define bFM4_QPRC3_NF_NFRCTLZ_ZINLV            *((volatile unsigned char*)(0x424c2710UL))
#define bFM4_QPRC3_NF_NFRCTLZ_ZINMD            *((volatile unsigned char*)(0x424c2714UL))

/* 12-bit ADC unit 0 registers */
#define bFM4_ADC0_ADSR_SCS                     *((volatile unsigned char*)(0x424E0000UL))
#define bFM4_ADC0_ADSR_PCS                     *((volatile unsigned char*)(0x424E0004UL))
#define bFM4_ADC0_ADSR_PCNS                    *((volatile unsigned char*)(0x424E0008UL))
#define bFM4_ADC0_ADSR_FDAS                    *((volatile unsigned char*)(0x424E0018UL))
#define bFM4_ADC0_ADSR_ADSTP                   *((volatile unsigned char*)(0x424E001CUL))
#define bFM4_ADC0_ADCR_OVRIE                   *((volatile unsigned char*)(0x424E0020UL))
#define bFM4_ADC0_ADCR_CMPIE                   *((volatile unsigned char*)(0x424E0024UL))
#define bFM4_ADC0_ADCR_PCIE                    *((volatile unsigned char*)(0x424E0028UL))
#define bFM4_ADC0_ADCR_SCIE                    *((volatile unsigned char*)(0x424E002CUL))
#define bFM4_ADC0_ADCR_CMPIF                   *((volatile unsigned char*)(0x424E0034UL))
#define bFM4_ADC0_ADCR_PCIF                    *((volatile unsigned char*)(0x424E0038UL))
#define bFM4_ADC0_ADCR_SCIF                    *((volatile unsigned char*)(0x424E003CUL))
#define bFM4_ADC0_SFNS_SFS0                    *((volatile unsigned char*)(0x424E0100UL))
#define bFM4_ADC0_SFNS_SFS1                    *((volatile unsigned char*)(0x424E0104UL))
#define bFM4_ADC0_SFNS_SFS2                    *((volatile unsigned char*)(0x424E0108UL))
#define bFM4_ADC0_SFNS_SFS3                    *((volatile unsigned char*)(0x424E010CUL))
#define bFM4_ADC0_SCCR_SSTR                    *((volatile unsigned char*)(0x424E0120UL))
#define bFM4_ADC0_SCCR_SHEN                    *((volatile unsigned char*)(0x424E0124UL))
#define bFM4_ADC0_SCCR_RPT                     *((volatile unsigned char*)(0x424E0128UL))
#define bFM4_ADC0_SCCR_SFCLR                   *((volatile unsigned char*)(0x424E0130UL))
#define bFM4_ADC0_SCCR_SOVR                    *((volatile unsigned char*)(0x424E0134UL))
#define bFM4_ADC0_SCCR_SFUL                    *((volatile unsigned char*)(0x424E0138UL))
#define bFM4_ADC0_SCCR_SEMP                    *((volatile unsigned char*)(0x424E013CUL))
#define bFM4_ADC0_SCFD_SC0                     *((volatile unsigned char*)(0x424E0180UL))
#define bFM4_ADC0_SCFD_SC1                     *((volatile unsigned char*)(0x424E0184UL))
#define bFM4_ADC0_SCFD_SC2                     *((volatile unsigned char*)(0x424E0188UL))
#define bFM4_ADC0_SCFD_SC3                     *((volatile unsigned char*)(0x424E018CUL))
#define bFM4_ADC0_SCFD_SC4                     *((volatile unsigned char*)(0x424E0190UL))
#define bFM4_ADC0_SCFD_RS0                     *((volatile unsigned char*)(0x424E01A0UL))
#define bFM4_ADC0_SCFD_RS1                     *((volatile unsigned char*)(0x424E01A4UL))
#define bFM4_ADC0_SCFD_INVL                    *((volatile unsigned char*)(0x424E01B0UL))
#define bFM4_ADC0_SCFD_SD0                     *((volatile unsigned char*)(0x424E01D0UL))
#define bFM4_ADC0_SCFD_SD1                     *((volatile unsigned char*)(0x424E01D4UL))
#define bFM4_ADC0_SCFD_SD2                     *((volatile unsigned char*)(0x424E01D8UL))
#define bFM4_ADC0_SCFD_SD3                     *((volatile unsigned char*)(0x424E01DCUL))
#define bFM4_ADC0_SCFD_SD4                     *((volatile unsigned char*)(0x424E01E0UL))
#define bFM4_ADC0_SCFD_SD5                     *((volatile unsigned char*)(0x424E01E4UL))
#define bFM4_ADC0_SCFD_SD6                     *((volatile unsigned char*)(0x424E01E8UL))
#define bFM4_ADC0_SCFD_SD7                     *((volatile unsigned char*)(0x424E01ECUL))
#define bFM4_ADC0_SCFD_SD8                     *((volatile unsigned char*)(0x424E01F0UL))
#define bFM4_ADC0_SCFD_SD9                     *((volatile unsigned char*)(0x424E01F4UL))
#define bFM4_ADC0_SCFD_SD10                    *((volatile unsigned char*)(0x424E01F8UL))
#define bFM4_ADC0_SCFD_SD11                    *((volatile unsigned char*)(0x424E01FCUL))
#define bFM4_ADC0_SCFDL_SC0                    *((volatile unsigned char*)(0x424E0180UL))
#define bFM4_ADC0_SCFDL_SC1                    *((volatile unsigned char*)(0x424E0184UL))
#define bFM4_ADC0_SCFDL_SC2                    *((volatile unsigned char*)(0x424E0188UL))
#define bFM4_ADC0_SCFDL_SC3                    *((volatile unsigned char*)(0x424E018CUL))
#define bFM4_ADC0_SCFDL_SC4                    *((volatile unsigned char*)(0x424E0190UL))
#define bFM4_ADC0_SCFDL_RS0                    *((volatile unsigned char*)(0x424E01A0UL))
#define bFM4_ADC0_SCFDL_RS1                    *((volatile unsigned char*)(0x424E01A4UL))
#define bFM4_ADC0_SCFDL_INVL                   *((volatile unsigned char*)(0x424E01B0UL))
#define bFM4_ADC0_SCFDH_SD0                    *((volatile unsigned char*)(0x424E01D0UL))
#define bFM4_ADC0_SCFDH_SD1                    *((volatile unsigned char*)(0x424E01D4UL))
#define bFM4_ADC0_SCFDH_SD2                    *((volatile unsigned char*)(0x424E01D8UL))
#define bFM4_ADC0_SCFDH_SD3                    *((volatile unsigned char*)(0x424E01DCUL))
#define bFM4_ADC0_SCFDH_SD4                    *((volatile unsigned char*)(0x424E01E0UL))
#define bFM4_ADC0_SCFDH_SD5                    *((volatile unsigned char*)(0x424E01E4UL))
#define bFM4_ADC0_SCFDH_SD6                    *((volatile unsigned char*)(0x424E01E8UL))
#define bFM4_ADC0_SCFDH_SD7                    *((volatile unsigned char*)(0x424E01ECUL))
#define bFM4_ADC0_SCFDH_SD8                    *((volatile unsigned char*)(0x424E01F0UL))
#define bFM4_ADC0_SCFDH_SD9                    *((volatile unsigned char*)(0x424E01F4UL))
#define bFM4_ADC0_SCFDH_SD10                   *((volatile unsigned char*)(0x424E01F8UL))
#define bFM4_ADC0_SCFDH_SD11                   *((volatile unsigned char*)(0x424E01FCUL))
#define bFM4_ADC0_SCIS23_AN16                  *((volatile unsigned char*)(0x424E0200UL))
#define bFM4_ADC0_SCIS23_AN17                  *((volatile unsigned char*)(0x424E0204UL))
#define bFM4_ADC0_SCIS23_AN18                  *((volatile unsigned char*)(0x424E0208UL))
#define bFM4_ADC0_SCIS23_AN19                  *((volatile unsigned char*)(0x424E020CUL))
#define bFM4_ADC0_SCIS23_AN20                  *((volatile unsigned char*)(0x424E0210UL))
#define bFM4_ADC0_SCIS23_AN21                  *((volatile unsigned char*)(0x424E0214UL))
#define bFM4_ADC0_SCIS23_AN22                  *((volatile unsigned char*)(0x424E0218UL))
#define bFM4_ADC0_SCIS23_AN23                  *((volatile unsigned char*)(0x424E021CUL))
#define bFM4_ADC0_SCIS23_AN24                  *((volatile unsigned char*)(0x424E0220UL))
#define bFM4_ADC0_SCIS23_AN25                  *((volatile unsigned char*)(0x424E0224UL))
#define bFM4_ADC0_SCIS23_AN26                  *((volatile unsigned char*)(0x424E0228UL))
#define bFM4_ADC0_SCIS23_AN27                  *((volatile unsigned char*)(0x424E022CUL))
#define bFM4_ADC0_SCIS23_AN28                  *((volatile unsigned char*)(0x424E0230UL))
#define bFM4_ADC0_SCIS23_AN29                  *((volatile unsigned char*)(0x424E0234UL))
#define bFM4_ADC0_SCIS23_AN30                  *((volatile unsigned char*)(0x424E0238UL))
#define bFM4_ADC0_SCIS23_AN31                  *((volatile unsigned char*)(0x424E023CUL))
#define bFM4_ADC0_SCIS2_AN16                   *((volatile unsigned char*)(0x424E0200UL))
#define bFM4_ADC0_SCIS2_AN17                   *((volatile unsigned char*)(0x424E0204UL))
#define bFM4_ADC0_SCIS2_AN18                   *((volatile unsigned char*)(0x424E0208UL))
#define bFM4_ADC0_SCIS2_AN19                   *((volatile unsigned char*)(0x424E020CUL))
#define bFM4_ADC0_SCIS2_AN20                   *((volatile unsigned char*)(0x424E0210UL))
#define bFM4_ADC0_SCIS2_AN21                   *((volatile unsigned char*)(0x424E0214UL))
#define bFM4_ADC0_SCIS2_AN22                   *((volatile unsigned char*)(0x424E0218UL))
#define bFM4_ADC0_SCIS2_AN23                   *((volatile unsigned char*)(0x424E021CUL))
#define bFM4_ADC0_SCIS3_AN24                   *((volatile unsigned char*)(0x424E0220UL))
#define bFM4_ADC0_SCIS3_AN25                   *((volatile unsigned char*)(0x424E0224UL))
#define bFM4_ADC0_SCIS3_AN26                   *((volatile unsigned char*)(0x424E0228UL))
#define bFM4_ADC0_SCIS3_AN27                   *((volatile unsigned char*)(0x424E022CUL))
#define bFM4_ADC0_SCIS3_AN28                   *((volatile unsigned char*)(0x424E0230UL))
#define bFM4_ADC0_SCIS3_AN29                   *((volatile unsigned char*)(0x424E0234UL))
#define bFM4_ADC0_SCIS3_AN30                   *((volatile unsigned char*)(0x424E0238UL))
#define bFM4_ADC0_SCIS3_AN31                   *((volatile unsigned char*)(0x424E023CUL))
#define bFM4_ADC0_SCIS01_AN0                   *((volatile unsigned char*)(0x424E0280UL))
#define bFM4_ADC0_SCIS01_AN1                   *((volatile unsigned char*)(0x424E0284UL))
#define bFM4_ADC0_SCIS01_AN2                   *((volatile unsigned char*)(0x424E0288UL))
#define bFM4_ADC0_SCIS01_AN3                   *((volatile unsigned char*)(0x424E028CUL))
#define bFM4_ADC0_SCIS01_AN4                   *((volatile unsigned char*)(0x424E0290UL))
#define bFM4_ADC0_SCIS01_AN5                   *((volatile unsigned char*)(0x424E0294UL))
#define bFM4_ADC0_SCIS01_AN6                   *((volatile unsigned char*)(0x424E0298UL))
#define bFM4_ADC0_SCIS01_AN7                   *((volatile unsigned char*)(0x424E029CUL))
#define bFM4_ADC0_SCIS01_AN8                   *((volatile unsigned char*)(0x424E02A0UL))
#define bFM4_ADC0_SCIS01_AN9                   *((volatile unsigned char*)(0x424E02A4UL))
#define bFM4_ADC0_SCIS01_AN10                  *((volatile unsigned char*)(0x424E02A8UL))
#define bFM4_ADC0_SCIS01_AN11                  *((volatile unsigned char*)(0x424E02ACUL))
#define bFM4_ADC0_SCIS01_AN12                  *((volatile unsigned char*)(0x424E02B0UL))
#define bFM4_ADC0_SCIS01_AN13                  *((volatile unsigned char*)(0x424E02B4UL))
#define bFM4_ADC0_SCIS01_AN14                  *((volatile unsigned char*)(0x424E02B8UL))
#define bFM4_ADC0_SCIS01_AN15                  *((volatile unsigned char*)(0x424E02BCUL))
#define bFM4_ADC0_SCIS0_AN0                    *((volatile unsigned char*)(0x424E0280UL))
#define bFM4_ADC0_SCIS0_AN1                    *((volatile unsigned char*)(0x424E0284UL))
#define bFM4_ADC0_SCIS0_AN2                    *((volatile unsigned char*)(0x424E0288UL))
#define bFM4_ADC0_SCIS0_AN3                    *((volatile unsigned char*)(0x424E028CUL))
#define bFM4_ADC0_SCIS0_AN4                    *((volatile unsigned char*)(0x424E0290UL))
#define bFM4_ADC0_SCIS0_AN5                    *((volatile unsigned char*)(0x424E0294UL))
#define bFM4_ADC0_SCIS0_AN6                    *((volatile unsigned char*)(0x424E0298UL))
#define bFM4_ADC0_SCIS0_AN7                    *((volatile unsigned char*)(0x424E029CUL))
#define bFM4_ADC0_SCIS1_AN8                    *((volatile unsigned char*)(0x424E02A0UL))
#define bFM4_ADC0_SCIS1_AN9                    *((volatile unsigned char*)(0x424E02A4UL))
#define bFM4_ADC0_SCIS1_AN10                   *((volatile unsigned char*)(0x424E02A8UL))
#define bFM4_ADC0_SCIS1_AN11                   *((volatile unsigned char*)(0x424E02ACUL))
#define bFM4_ADC0_SCIS1_AN12                   *((volatile unsigned char*)(0x424E02B0UL))
#define bFM4_ADC0_SCIS1_AN13                   *((volatile unsigned char*)(0x424E02B4UL))
#define bFM4_ADC0_SCIS1_AN14                   *((volatile unsigned char*)(0x424E02B8UL))
#define bFM4_ADC0_SCIS1_AN15                   *((volatile unsigned char*)(0x424E02BCUL))
#define bFM4_ADC0_PFNS_PFS0                    *((volatile unsigned char*)(0x424E0300UL))
#define bFM4_ADC0_PFNS_PFS1                    *((volatile unsigned char*)(0x424E0304UL))
#define bFM4_ADC0_PFNS_TEST0                   *((volatile unsigned char*)(0x424E0310UL))
#define bFM4_ADC0_PFNS_TEST1                   *((volatile unsigned char*)(0x424E0314UL))
#define bFM4_ADC0_PCCR_PSTR                    *((volatile unsigned char*)(0x424E0320UL))
#define bFM4_ADC0_PCCR_PHEN                    *((volatile unsigned char*)(0x424E0324UL))
#define bFM4_ADC0_PCCR_PEEN                    *((volatile unsigned char*)(0x424E0328UL))
#define bFM4_ADC0_PCCR_ESCE                    *((volatile unsigned char*)(0x424E032CUL))
#define bFM4_ADC0_PCCR_PFCLR                   *((volatile unsigned char*)(0x424E0330UL))
#define bFM4_ADC0_PCCR_POVR                    *((volatile unsigned char*)(0x424E0334UL))
#define bFM4_ADC0_PCCR_PFUL                    *((volatile unsigned char*)(0x424E0338UL))
#define bFM4_ADC0_PCCR_PEMP                    *((volatile unsigned char*)(0x424E033CUL))
#define bFM4_ADC0_PCFD_PC0                     *((volatile unsigned char*)(0x424E0380UL))
#define bFM4_ADC0_PCFD_PC1                     *((volatile unsigned char*)(0x424E0384UL))
#define bFM4_ADC0_PCFD_PC2                     *((volatile unsigned char*)(0x424E0388UL))
#define bFM4_ADC0_PCFD_PC3                     *((volatile unsigned char*)(0x424E038CUL))
#define bFM4_ADC0_PCFD_PC4                     *((volatile unsigned char*)(0x424E0390UL))
#define bFM4_ADC0_PCFD_RS0                     *((volatile unsigned char*)(0x424E03A0UL))
#define bFM4_ADC0_PCFD_RS1                     *((volatile unsigned char*)(0x424E03A4UL))
#define bFM4_ADC0_PCFD_RS2                     *((volatile unsigned char*)(0x424E03A8UL))
#define bFM4_ADC0_PCFD_INVL                    *((volatile unsigned char*)(0x424E03B0UL))
#define bFM4_ADC0_PCFD_PD0                     *((volatile unsigned char*)(0x424E03D0UL))
#define bFM4_ADC0_PCFD_PD1                     *((volatile unsigned char*)(0x424E03D4UL))
#define bFM4_ADC0_PCFD_PD2                     *((volatile unsigned char*)(0x424E03D8UL))
#define bFM4_ADC0_PCFD_PD3                     *((volatile unsigned char*)(0x424E03DCUL))
#define bFM4_ADC0_PCFD_PD4                     *((volatile unsigned char*)(0x424E03E0UL))
#define bFM4_ADC0_PCFD_PD5                     *((volatile unsigned char*)(0x424E03E4UL))
#define bFM4_ADC0_PCFD_PD6                     *((volatile unsigned char*)(0x424E03E8UL))
#define bFM4_ADC0_PCFD_PD7                     *((volatile unsigned char*)(0x424E03ECUL))
#define bFM4_ADC0_PCFD_PD8                     *((volatile unsigned char*)(0x424E03F0UL))
#define bFM4_ADC0_PCFD_PD9                     *((volatile unsigned char*)(0x424E03F4UL))
#define bFM4_ADC0_PCFD_PD10                    *((volatile unsigned char*)(0x424E03F8UL))
#define bFM4_ADC0_PCFD_PD11                    *((volatile unsigned char*)(0x424E03FCUL))
#define bFM4_ADC0_PCFDL_PC0                    *((volatile unsigned char*)(0x424E0380UL))
#define bFM4_ADC0_PCFDL_PC1                    *((volatile unsigned char*)(0x424E0384UL))
#define bFM4_ADC0_PCFDL_PC2                    *((volatile unsigned char*)(0x424E0388UL))
#define bFM4_ADC0_PCFDL_PC3                    *((volatile unsigned char*)(0x424E038CUL))
#define bFM4_ADC0_PCFDL_PC4                    *((volatile unsigned char*)(0x424E0390UL))
#define bFM4_ADC0_PCFDL_RS0                    *((volatile unsigned char*)(0x424E03A0UL))
#define bFM4_ADC0_PCFDL_RS1                    *((volatile unsigned char*)(0x424E03A4UL))
#define bFM4_ADC0_PCFDL_RS2                    *((volatile unsigned char*)(0x424E03A8UL))
#define bFM4_ADC0_PCFDL_INVL                   *((volatile unsigned char*)(0x424E03B0UL))
#define bFM4_ADC0_PCFDH_PD0                    *((volatile unsigned char*)(0x424E03D0UL))
#define bFM4_ADC0_PCFDH_PD1                    *((volatile unsigned char*)(0x424E03D4UL))
#define bFM4_ADC0_PCFDH_PD2                    *((volatile unsigned char*)(0x424E03D8UL))
#define bFM4_ADC0_PCFDH_PD3                    *((volatile unsigned char*)(0x424E03DCUL))
#define bFM4_ADC0_PCFDH_PD4                    *((volatile unsigned char*)(0x424E03E0UL))
#define bFM4_ADC0_PCFDH_PD5                    *((volatile unsigned char*)(0x424E03E4UL))
#define bFM4_ADC0_PCFDH_PD6                    *((volatile unsigned char*)(0x424E03E8UL))
#define bFM4_ADC0_PCFDH_PD7                    *((volatile unsigned char*)(0x424E03ECUL))
#define bFM4_ADC0_PCFDH_PD8                    *((volatile unsigned char*)(0x424E03F0UL))
#define bFM4_ADC0_PCFDH_PD9                    *((volatile unsigned char*)(0x424E03F4UL))
#define bFM4_ADC0_PCFDH_PD10                   *((volatile unsigned char*)(0x424E03F8UL))
#define bFM4_ADC0_PCFDH_PD11                   *((volatile unsigned char*)(0x424E03FCUL))
#define bFM4_ADC0_PCIS_P1A0                    *((volatile unsigned char*)(0x424E0400UL))
#define bFM4_ADC0_PCIS_P1A1                    *((volatile unsigned char*)(0x424E0404UL))
#define bFM4_ADC0_PCIS_P1A2                    *((volatile unsigned char*)(0x424E0408UL))
#define bFM4_ADC0_PCIS_P2A0                    *((volatile unsigned char*)(0x424E040CUL))
#define bFM4_ADC0_PCIS_P2A1                    *((volatile unsigned char*)(0x424E0410UL))
#define bFM4_ADC0_PCIS_P2A2                    *((volatile unsigned char*)(0x424E0414UL))
#define bFM4_ADC0_PCIS_P2A3                    *((volatile unsigned char*)(0x424E0418UL))
#define bFM4_ADC0_PCIS_P2A4                    *((volatile unsigned char*)(0x424E041CUL))
#define bFM4_ADC0_CMPCR_CCH0                   *((volatile unsigned char*)(0x424E0480UL))
#define bFM4_ADC0_CMPCR_CCH1                   *((volatile unsigned char*)(0x424E0484UL))
#define bFM4_ADC0_CMPCR_CCH2                   *((volatile unsigned char*)(0x424E0488UL))
#define bFM4_ADC0_CMPCR_CCH3                   *((volatile unsigned char*)(0x424E048CUL))
#define bFM4_ADC0_CMPCR_CCH4                   *((volatile unsigned char*)(0x424E0490UL))
#define bFM4_ADC0_CMPCR_CMD0                   *((volatile unsigned char*)(0x424E0494UL))
#define bFM4_ADC0_CMPCR_CMD1                   *((volatile unsigned char*)(0x424E0498UL))
#define bFM4_ADC0_CMPCR_CMPEN                  *((volatile unsigned char*)(0x424E049CUL))
#define bFM4_ADC0_CMPD_CMAD2                   *((volatile unsigned char*)(0x424E04D8UL))
#define bFM4_ADC0_CMPD_CMAD3                   *((volatile unsigned char*)(0x424E04DCUL))
#define bFM4_ADC0_CMPD_CMAD4                   *((volatile unsigned char*)(0x424E04E0UL))
#define bFM4_ADC0_CMPD_CMAD5                   *((volatile unsigned char*)(0x424E04E4UL))
#define bFM4_ADC0_CMPD_CMAD6                   *((volatile unsigned char*)(0x424E04E8UL))
#define bFM4_ADC0_CMPD_CMAD7                   *((volatile unsigned char*)(0x424E04ECUL))
#define bFM4_ADC0_CMPD_CMAD8                   *((volatile unsigned char*)(0x424E04F0UL))
#define bFM4_ADC0_CMPD_CMAD9                   *((volatile unsigned char*)(0x424E04F4UL))
#define bFM4_ADC0_CMPD_CMAD10                  *((volatile unsigned char*)(0x424E04F8UL))
#define bFM4_ADC0_CMPD_CMAD11                  *((volatile unsigned char*)(0x424E04FCUL))
#define bFM4_ADC0_ADSS23_TS16                  *((volatile unsigned char*)(0x424E0500UL))
#define bFM4_ADC0_ADSS23_TS17                  *((volatile unsigned char*)(0x424E0504UL))
#define bFM4_ADC0_ADSS23_TS18                  *((volatile unsigned char*)(0x424E0508UL))
#define bFM4_ADC0_ADSS23_TS19                  *((volatile unsigned char*)(0x424E050CUL))
#define bFM4_ADC0_ADSS23_TS20                  *((volatile unsigned char*)(0x424E0510UL))
#define bFM4_ADC0_ADSS23_TS21                  *((volatile unsigned char*)(0x424E0514UL))
#define bFM4_ADC0_ADSS23_TS22                  *((volatile unsigned char*)(0x424E0518UL))
#define bFM4_ADC0_ADSS23_TS23                  *((volatile unsigned char*)(0x424E051CUL))
#define bFM4_ADC0_ADSS23_TS24                  *((volatile unsigned char*)(0x424E0520UL))
#define bFM4_ADC0_ADSS23_TS25                  *((volatile unsigned char*)(0x424E0524UL))
#define bFM4_ADC0_ADSS23_TS26                  *((volatile unsigned char*)(0x424E0528UL))
#define bFM4_ADC0_ADSS23_TS27                  *((volatile unsigned char*)(0x424E052CUL))
#define bFM4_ADC0_ADSS23_TS28                  *((volatile unsigned char*)(0x424E0530UL))
#define bFM4_ADC0_ADSS23_TS29                  *((volatile unsigned char*)(0x424E0534UL))
#define bFM4_ADC0_ADSS23_TS30                  *((volatile unsigned char*)(0x424E0538UL))
#define bFM4_ADC0_ADSS23_TS31                  *((volatile unsigned char*)(0x424E053CUL))
#define bFM4_ADC0_ADSS2_TS16                   *((volatile unsigned char*)(0x424E0500UL))
#define bFM4_ADC0_ADSS2_TS17                   *((volatile unsigned char*)(0x424E0504UL))
#define bFM4_ADC0_ADSS2_TS18                   *((volatile unsigned char*)(0x424E0508UL))
#define bFM4_ADC0_ADSS2_TS19                   *((volatile unsigned char*)(0x424E050CUL))
#define bFM4_ADC0_ADSS2_TS20                   *((volatile unsigned char*)(0x424E0510UL))
#define bFM4_ADC0_ADSS2_TS21                   *((volatile unsigned char*)(0x424E0514UL))
#define bFM4_ADC0_ADSS2_TS22                   *((volatile unsigned char*)(0x424E0518UL))
#define bFM4_ADC0_ADSS2_TS23                   *((volatile unsigned char*)(0x424E051CUL))
#define bFM4_ADC0_ADSS3_TS24                   *((volatile unsigned char*)(0x424E0520UL))
#define bFM4_ADC0_ADSS3_TS25                   *((volatile unsigned char*)(0x424E0524UL))
#define bFM4_ADC0_ADSS3_TS26                   *((volatile unsigned char*)(0x424E0528UL))
#define bFM4_ADC0_ADSS3_TS27                   *((volatile unsigned char*)(0x424E052CUL))
#define bFM4_ADC0_ADSS3_TS28                   *((volatile unsigned char*)(0x424E0530UL))
#define bFM4_ADC0_ADSS3_TS29                   *((volatile unsigned char*)(0x424E0534UL))
#define bFM4_ADC0_ADSS3_TS30                   *((volatile unsigned char*)(0x424E0538UL))
#define bFM4_ADC0_ADSS3_TS31                   *((volatile unsigned char*)(0x424E053CUL))
#define bFM4_ADC0_ADSS01_TS0                   *((volatile unsigned char*)(0x424E0580UL))
#define bFM4_ADC0_ADSS01_TS1                   *((volatile unsigned char*)(0x424E0584UL))
#define bFM4_ADC0_ADSS01_TS2                   *((volatile unsigned char*)(0x424E0588UL))
#define bFM4_ADC0_ADSS01_TS3                   *((volatile unsigned char*)(0x424E058CUL))
#define bFM4_ADC0_ADSS01_TS4                   *((volatile unsigned char*)(0x424E0590UL))
#define bFM4_ADC0_ADSS01_TS5                   *((volatile unsigned char*)(0x424E0594UL))
#define bFM4_ADC0_ADSS01_TS6                   *((volatile unsigned char*)(0x424E0598UL))
#define bFM4_ADC0_ADSS01_TS7                   *((volatile unsigned char*)(0x424E059CUL))
#define bFM4_ADC0_ADSS01_TS8                   *((volatile unsigned char*)(0x424E05A0UL))
#define bFM4_ADC0_ADSS01_TS9                   *((volatile unsigned char*)(0x424E05A4UL))
#define bFM4_ADC0_ADSS01_TS10                  *((volatile unsigned char*)(0x424E05A8UL))
#define bFM4_ADC0_ADSS01_TS11                  *((volatile unsigned char*)(0x424E05ACUL))
#define bFM4_ADC0_ADSS01_TS12                  *((volatile unsigned char*)(0x424E05B0UL))
#define bFM4_ADC0_ADSS01_TS13                  *((volatile unsigned char*)(0x424E05B4UL))
#define bFM4_ADC0_ADSS01_TS14                  *((volatile unsigned char*)(0x424E05B8UL))
#define bFM4_ADC0_ADSS01_TS15                  *((volatile unsigned char*)(0x424E05BCUL))
#define bFM4_ADC0_ADSS0_TS0                    *((volatile unsigned char*)(0x424E0580UL))
#define bFM4_ADC0_ADSS0_TS1                    *((volatile unsigned char*)(0x424E0584UL))
#define bFM4_ADC0_ADSS0_TS2                    *((volatile unsigned char*)(0x424E0588UL))
#define bFM4_ADC0_ADSS0_TS3                    *((volatile unsigned char*)(0x424E058CUL))
#define bFM4_ADC0_ADSS0_TS4                    *((volatile unsigned char*)(0x424E0590UL))
#define bFM4_ADC0_ADSS0_TS5                    *((volatile unsigned char*)(0x424E0594UL))
#define bFM4_ADC0_ADSS0_TS6                    *((volatile unsigned char*)(0x424E0598UL))
#define bFM4_ADC0_ADSS0_TS7                    *((volatile unsigned char*)(0x424E059CUL))
#define bFM4_ADC0_ADSS1_TS8                    *((volatile unsigned char*)(0x424E05A0UL))
#define bFM4_ADC0_ADSS1_TS9                    *((volatile unsigned char*)(0x424E05A4UL))
#define bFM4_ADC0_ADSS1_TS10                   *((volatile unsigned char*)(0x424E05A8UL))
#define bFM4_ADC0_ADSS1_TS11                   *((volatile unsigned char*)(0x424E05ACUL))
#define bFM4_ADC0_ADSS1_TS12                   *((volatile unsigned char*)(0x424E05B0UL))
#define bFM4_ADC0_ADSS1_TS13                   *((volatile unsigned char*)(0x424E05B4UL))
#define bFM4_ADC0_ADSS1_TS14                   *((volatile unsigned char*)(0x424E05B8UL))
#define bFM4_ADC0_ADSS1_TS15                   *((volatile unsigned char*)(0x424E05BCUL))
#define bFM4_ADC0_ADST01_ST10                  *((volatile unsigned char*)(0x424E0600UL))
#define bFM4_ADC0_ADST01_ST11                  *((volatile unsigned char*)(0x424E0604UL))
#define bFM4_ADC0_ADST01_ST12                  *((volatile unsigned char*)(0x424E0608UL))
#define bFM4_ADC0_ADST01_ST13                  *((volatile unsigned char*)(0x424E060CUL))
#define bFM4_ADC0_ADST01_ST14                  *((volatile unsigned char*)(0x424E0610UL))
#define bFM4_ADC0_ADST01_STX10                 *((volatile unsigned char*)(0x424E0614UL))
#define bFM4_ADC0_ADST01_STX11                 *((volatile unsigned char*)(0x424E0618UL))
#define bFM4_ADC0_ADST01_STX12                 *((volatile unsigned char*)(0x424E061CUL))
#define bFM4_ADC0_ADST01_ST00                  *((volatile unsigned char*)(0x424E0620UL))
#define bFM4_ADC0_ADST01_ST01                  *((volatile unsigned char*)(0x424E0624UL))
#define bFM4_ADC0_ADST01_ST02                  *((volatile unsigned char*)(0x424E0628UL))
#define bFM4_ADC0_ADST01_ST03                  *((volatile unsigned char*)(0x424E062CUL))
#define bFM4_ADC0_ADST01_ST04                  *((volatile unsigned char*)(0x424E0630UL))
#define bFM4_ADC0_ADST01_STX00                 *((volatile unsigned char*)(0x424E0634UL))
#define bFM4_ADC0_ADST01_STX01                 *((volatile unsigned char*)(0x424E0638UL))
#define bFM4_ADC0_ADST01_STX02                 *((volatile unsigned char*)(0x424E063CUL))
#define bFM4_ADC0_ADST1_ST10                   *((volatile unsigned char*)(0x424E0600UL))
#define bFM4_ADC0_ADST1_ST11                   *((volatile unsigned char*)(0x424E0604UL))
#define bFM4_ADC0_ADST1_ST12                   *((volatile unsigned char*)(0x424E0608UL))
#define bFM4_ADC0_ADST1_ST13                   *((volatile unsigned char*)(0x424E060CUL))
#define bFM4_ADC0_ADST1_ST14                   *((volatile unsigned char*)(0x424E0610UL))
#define bFM4_ADC0_ADST1_STX10                  *((volatile unsigned char*)(0x424E0614UL))
#define bFM4_ADC0_ADST1_STX11                  *((volatile unsigned char*)(0x424E0618UL))
#define bFM4_ADC0_ADST1_STX12                  *((volatile unsigned char*)(0x424E061CUL))
#define bFM4_ADC0_ADST0_ST00                   *((volatile unsigned char*)(0x424E0620UL))
#define bFM4_ADC0_ADST0_ST01                   *((volatile unsigned char*)(0x424E0624UL))
#define bFM4_ADC0_ADST0_ST02                   *((volatile unsigned char*)(0x424E0628UL))
#define bFM4_ADC0_ADST0_ST03                   *((volatile unsigned char*)(0x424E062CUL))
#define bFM4_ADC0_ADST0_ST04                   *((volatile unsigned char*)(0x424E0630UL))
#define bFM4_ADC0_ADST0_STX00                  *((volatile unsigned char*)(0x424E0634UL))
#define bFM4_ADC0_ADST0_STX01                  *((volatile unsigned char*)(0x424E0638UL))
#define bFM4_ADC0_ADST0_STX02                  *((volatile unsigned char*)(0x424E063CUL))
#define bFM4_ADC0_ADCT_CT0                     *((volatile unsigned char*)(0x424E0680UL))
#define bFM4_ADC0_ADCT_CT1                     *((volatile unsigned char*)(0x424E0684UL))
#define bFM4_ADC0_ADCT_CT2                     *((volatile unsigned char*)(0x424E0688UL))
#define bFM4_ADC0_PRTSL_PRTSL0                 *((volatile unsigned char*)(0x424E0700UL))
#define bFM4_ADC0_PRTSL_PRTSL1                 *((volatile unsigned char*)(0x424E0704UL))
#define bFM4_ADC0_PRTSL_PRTSL2                 *((volatile unsigned char*)(0x424E0708UL))
#define bFM4_ADC0_PRTSL_PRTSL3                 *((volatile unsigned char*)(0x424E070CUL))
#define bFM4_ADC0_SCTSL_SCTSL0                 *((volatile unsigned char*)(0x424E0720UL))
#define bFM4_ADC0_SCTSL_SCTSL1                 *((volatile unsigned char*)(0x424E0724UL))
#define bFM4_ADC0_SCTSL_SCTSL2                 *((volatile unsigned char*)(0x424E0728UL))
#define bFM4_ADC0_SCTSL_SCTSL3                 *((volatile unsigned char*)(0x424E072CUL))
#define bFM4_ADC0_ADCEN_ENBL                   *((volatile unsigned char*)(0x424E0780UL))
#define bFM4_ADC0_ADCEN_READY                  *((volatile unsigned char*)(0x424E0784UL))

/* 12-bit ADC unit 1 registers */
#define bFM4_ADC1_ADSR_SCS                     *((volatile unsigned char*)(0x424E2000UL))
#define bFM4_ADC1_ADSR_PCS                     *((volatile unsigned char*)(0x424E2004UL))
#define bFM4_ADC1_ADSR_PCNS                    *((volatile unsigned char*)(0x424E2008UL))
#define bFM4_ADC1_ADSR_FDAS                    *((volatile unsigned char*)(0x424E2018UL))
#define bFM4_ADC1_ADSR_ADSTP                   *((volatile unsigned char*)(0x424E201CUL))
#define bFM4_ADC1_ADCR_OVRIE                   *((volatile unsigned char*)(0x424E2020UL))
#define bFM4_ADC1_ADCR_CMPIE                   *((volatile unsigned char*)(0x424E2024UL))
#define bFM4_ADC1_ADCR_PCIE                    *((volatile unsigned char*)(0x424E2028UL))
#define bFM4_ADC1_ADCR_SCIE                    *((volatile unsigned char*)(0x424E202CUL))
#define bFM4_ADC1_ADCR_CMPIF                   *((volatile unsigned char*)(0x424E2034UL))
#define bFM4_ADC1_ADCR_PCIF                    *((volatile unsigned char*)(0x424E2038UL))
#define bFM4_ADC1_ADCR_SCIF                    *((volatile unsigned char*)(0x424E203CUL))
#define bFM4_ADC1_SFNS_SFS0                    *((volatile unsigned char*)(0x424E2100UL))
#define bFM4_ADC1_SFNS_SFS1                    *((volatile unsigned char*)(0x424E2104UL))
#define bFM4_ADC1_SFNS_SFS2                    *((volatile unsigned char*)(0x424E2108UL))
#define bFM4_ADC1_SFNS_SFS3                    *((volatile unsigned char*)(0x424E210CUL))
#define bFM4_ADC1_SCCR_SSTR                    *((volatile unsigned char*)(0x424E2120UL))
#define bFM4_ADC1_SCCR_SHEN                    *((volatile unsigned char*)(0x424E2124UL))
#define bFM4_ADC1_SCCR_RPT                     *((volatile unsigned char*)(0x424E2128UL))
#define bFM4_ADC1_SCCR_SFCLR                   *((volatile unsigned char*)(0x424E2130UL))
#define bFM4_ADC1_SCCR_SOVR                    *((volatile unsigned char*)(0x424E2134UL))
#define bFM4_ADC1_SCCR_SFUL                    *((volatile unsigned char*)(0x424E2138UL))
#define bFM4_ADC1_SCCR_SEMP                    *((volatile unsigned char*)(0x424E213CUL))
#define bFM4_ADC1_SCFD_SC0                     *((volatile unsigned char*)(0x424E2180UL))
#define bFM4_ADC1_SCFD_SC1                     *((volatile unsigned char*)(0x424E2184UL))
#define bFM4_ADC1_SCFD_SC2                     *((volatile unsigned char*)(0x424E2188UL))
#define bFM4_ADC1_SCFD_SC3                     *((volatile unsigned char*)(0x424E218CUL))
#define bFM4_ADC1_SCFD_SC4                     *((volatile unsigned char*)(0x424E2190UL))
#define bFM4_ADC1_SCFD_RS0                     *((volatile unsigned char*)(0x424E21A0UL))
#define bFM4_ADC1_SCFD_RS1                     *((volatile unsigned char*)(0x424E21A4UL))
#define bFM4_ADC1_SCFD_INVL                    *((volatile unsigned char*)(0x424E21B0UL))
#define bFM4_ADC1_SCFD_SD0                     *((volatile unsigned char*)(0x424E21D0UL))
#define bFM4_ADC1_SCFD_SD1                     *((volatile unsigned char*)(0x424E21D4UL))
#define bFM4_ADC1_SCFD_SD2                     *((volatile unsigned char*)(0x424E21D8UL))
#define bFM4_ADC1_SCFD_SD3                     *((volatile unsigned char*)(0x424E21DCUL))
#define bFM4_ADC1_SCFD_SD4                     *((volatile unsigned char*)(0x424E21E0UL))
#define bFM4_ADC1_SCFD_SD5                     *((volatile unsigned char*)(0x424E21E4UL))
#define bFM4_ADC1_SCFD_SD6                     *((volatile unsigned char*)(0x424E21E8UL))
#define bFM4_ADC1_SCFD_SD7                     *((volatile unsigned char*)(0x424E21ECUL))
#define bFM4_ADC1_SCFD_SD8                     *((volatile unsigned char*)(0x424E21F0UL))
#define bFM4_ADC1_SCFD_SD9                     *((volatile unsigned char*)(0x424E21F4UL))
#define bFM4_ADC1_SCFD_SD10                    *((volatile unsigned char*)(0x424E21F8UL))
#define bFM4_ADC1_SCFD_SD11                    *((volatile unsigned char*)(0x424E21FCUL))
#define bFM4_ADC1_SCFDL_SC0                    *((volatile unsigned char*)(0x424E2180UL))
#define bFM4_ADC1_SCFDL_SC1                    *((volatile unsigned char*)(0x424E2184UL))
#define bFM4_ADC1_SCFDL_SC2                    *((volatile unsigned char*)(0x424E2188UL))
#define bFM4_ADC1_SCFDL_SC3                    *((volatile unsigned char*)(0x424E218CUL))
#define bFM4_ADC1_SCFDL_SC4                    *((volatile unsigned char*)(0x424E2190UL))
#define bFM4_ADC1_SCFDL_RS0                    *((volatile unsigned char*)(0x424E21A0UL))
#define bFM4_ADC1_SCFDL_RS1                    *((volatile unsigned char*)(0x424E21A4UL))
#define bFM4_ADC1_SCFDL_INVL                   *((volatile unsigned char*)(0x424E21B0UL))
#define bFM4_ADC1_SCFDH_SD0                    *((volatile unsigned char*)(0x424E21D0UL))
#define bFM4_ADC1_SCFDH_SD1                    *((volatile unsigned char*)(0x424E21D4UL))
#define bFM4_ADC1_SCFDH_SD2                    *((volatile unsigned char*)(0x424E21D8UL))
#define bFM4_ADC1_SCFDH_SD3                    *((volatile unsigned char*)(0x424E21DCUL))
#define bFM4_ADC1_SCFDH_SD4                    *((volatile unsigned char*)(0x424E21E0UL))
#define bFM4_ADC1_SCFDH_SD5                    *((volatile unsigned char*)(0x424E21E4UL))
#define bFM4_ADC1_SCFDH_SD6                    *((volatile unsigned char*)(0x424E21E8UL))
#define bFM4_ADC1_SCFDH_SD7                    *((volatile unsigned char*)(0x424E21ECUL))
#define bFM4_ADC1_SCFDH_SD8                    *((volatile unsigned char*)(0x424E21F0UL))
#define bFM4_ADC1_SCFDH_SD9                    *((volatile unsigned char*)(0x424E21F4UL))
#define bFM4_ADC1_SCFDH_SD10                   *((volatile unsigned char*)(0x424E21F8UL))
#define bFM4_ADC1_SCFDH_SD11                   *((volatile unsigned char*)(0x424E21FCUL))
#define bFM4_ADC1_SCIS23_AN16                  *((volatile unsigned char*)(0x424E2200UL))
#define bFM4_ADC1_SCIS23_AN17                  *((volatile unsigned char*)(0x424E2204UL))
#define bFM4_ADC1_SCIS23_AN18                  *((volatile unsigned char*)(0x424E2208UL))
#define bFM4_ADC1_SCIS23_AN19                  *((volatile unsigned char*)(0x424E220CUL))
#define bFM4_ADC1_SCIS23_AN20                  *((volatile unsigned char*)(0x424E2210UL))
#define bFM4_ADC1_SCIS23_AN21                  *((volatile unsigned char*)(0x424E2214UL))
#define bFM4_ADC1_SCIS23_AN22                  *((volatile unsigned char*)(0x424E2218UL))
#define bFM4_ADC1_SCIS23_AN23                  *((volatile unsigned char*)(0x424E221CUL))
#define bFM4_ADC1_SCIS23_AN24                  *((volatile unsigned char*)(0x424E2220UL))
#define bFM4_ADC1_SCIS23_AN25                  *((volatile unsigned char*)(0x424E2224UL))
#define bFM4_ADC1_SCIS23_AN26                  *((volatile unsigned char*)(0x424E2228UL))
#define bFM4_ADC1_SCIS23_AN27                  *((volatile unsigned char*)(0x424E222CUL))
#define bFM4_ADC1_SCIS23_AN28                  *((volatile unsigned char*)(0x424E2230UL))
#define bFM4_ADC1_SCIS23_AN29                  *((volatile unsigned char*)(0x424E2234UL))
#define bFM4_ADC1_SCIS23_AN30                  *((volatile unsigned char*)(0x424E2238UL))
#define bFM4_ADC1_SCIS23_AN31                  *((volatile unsigned char*)(0x424E223CUL))
#define bFM4_ADC1_SCIS2_AN16                   *((volatile unsigned char*)(0x424E2200UL))
#define bFM4_ADC1_SCIS2_AN17                   *((volatile unsigned char*)(0x424E2204UL))
#define bFM4_ADC1_SCIS2_AN18                   *((volatile unsigned char*)(0x424E2208UL))
#define bFM4_ADC1_SCIS2_AN19                   *((volatile unsigned char*)(0x424E220CUL))
#define bFM4_ADC1_SCIS2_AN20                   *((volatile unsigned char*)(0x424E2210UL))
#define bFM4_ADC1_SCIS2_AN21                   *((volatile unsigned char*)(0x424E2214UL))
#define bFM4_ADC1_SCIS2_AN22                   *((volatile unsigned char*)(0x424E2218UL))
#define bFM4_ADC1_SCIS2_AN23                   *((volatile unsigned char*)(0x424E221CUL))
#define bFM4_ADC1_SCIS3_AN24                   *((volatile unsigned char*)(0x424E2220UL))
#define bFM4_ADC1_SCIS3_AN25                   *((volatile unsigned char*)(0x424E2224UL))
#define bFM4_ADC1_SCIS3_AN26                   *((volatile unsigned char*)(0x424E2228UL))
#define bFM4_ADC1_SCIS3_AN27                   *((volatile unsigned char*)(0x424E222CUL))
#define bFM4_ADC1_SCIS3_AN28                   *((volatile unsigned char*)(0x424E2230UL))
#define bFM4_ADC1_SCIS3_AN29                   *((volatile unsigned char*)(0x424E2234UL))
#define bFM4_ADC1_SCIS3_AN30                   *((volatile unsigned char*)(0x424E2238UL))
#define bFM4_ADC1_SCIS3_AN31                   *((volatile unsigned char*)(0x424E223CUL))
#define bFM4_ADC1_SCIS01_AN0                   *((volatile unsigned char*)(0x424E2280UL))
#define bFM4_ADC1_SCIS01_AN1                   *((volatile unsigned char*)(0x424E2284UL))
#define bFM4_ADC1_SCIS01_AN2                   *((volatile unsigned char*)(0x424E2288UL))
#define bFM4_ADC1_SCIS01_AN3                   *((volatile unsigned char*)(0x424E228CUL))
#define bFM4_ADC1_SCIS01_AN4                   *((volatile unsigned char*)(0x424E2290UL))
#define bFM4_ADC1_SCIS01_AN5                   *((volatile unsigned char*)(0x424E2294UL))
#define bFM4_ADC1_SCIS01_AN6                   *((volatile unsigned char*)(0x424E2298UL))
#define bFM4_ADC1_SCIS01_AN7                   *((volatile unsigned char*)(0x424E229CUL))
#define bFM4_ADC1_SCIS01_AN8                   *((volatile unsigned char*)(0x424E22A0UL))
#define bFM4_ADC1_SCIS01_AN9                   *((volatile unsigned char*)(0x424E22A4UL))
#define bFM4_ADC1_SCIS01_AN10                  *((volatile unsigned char*)(0x424E22A8UL))
#define bFM4_ADC1_SCIS01_AN11                  *((volatile unsigned char*)(0x424E22ACUL))
#define bFM4_ADC1_SCIS01_AN12                  *((volatile unsigned char*)(0x424E22B0UL))
#define bFM4_ADC1_SCIS01_AN13                  *((volatile unsigned char*)(0x424E22B4UL))
#define bFM4_ADC1_SCIS01_AN14                  *((volatile unsigned char*)(0x424E22B8UL))
#define bFM4_ADC1_SCIS01_AN15                  *((volatile unsigned char*)(0x424E22BCUL))
#define bFM4_ADC1_SCIS0_AN0                    *((volatile unsigned char*)(0x424E2280UL))
#define bFM4_ADC1_SCIS0_AN1                    *((volatile unsigned char*)(0x424E2284UL))
#define bFM4_ADC1_SCIS0_AN2                    *((volatile unsigned char*)(0x424E2288UL))
#define bFM4_ADC1_SCIS0_AN3                    *((volatile unsigned char*)(0x424E228CUL))
#define bFM4_ADC1_SCIS0_AN4                    *((volatile unsigned char*)(0x424E2290UL))
#define bFM4_ADC1_SCIS0_AN5                    *((volatile unsigned char*)(0x424E2294UL))
#define bFM4_ADC1_SCIS0_AN6                    *((volatile unsigned char*)(0x424E2298UL))
#define bFM4_ADC1_SCIS0_AN7                    *((volatile unsigned char*)(0x424E229CUL))
#define bFM4_ADC1_SCIS1_AN8                    *((volatile unsigned char*)(0x424E22A0UL))
#define bFM4_ADC1_SCIS1_AN9                    *((volatile unsigned char*)(0x424E22A4UL))
#define bFM4_ADC1_SCIS1_AN10                   *((volatile unsigned char*)(0x424E22A8UL))
#define bFM4_ADC1_SCIS1_AN11                   *((volatile unsigned char*)(0x424E22ACUL))
#define bFM4_ADC1_SCIS1_AN12                   *((volatile unsigned char*)(0x424E22B0UL))
#define bFM4_ADC1_SCIS1_AN13                   *((volatile unsigned char*)(0x424E22B4UL))
#define bFM4_ADC1_SCIS1_AN14                   *((volatile unsigned char*)(0x424E22B8UL))
#define bFM4_ADC1_SCIS1_AN15                   *((volatile unsigned char*)(0x424E22BCUL))
#define bFM4_ADC1_PFNS_PFS0                    *((volatile unsigned char*)(0x424E2300UL))
#define bFM4_ADC1_PFNS_PFS1                    *((volatile unsigned char*)(0x424E2304UL))
#define bFM4_ADC1_PFNS_TEST0                   *((volatile unsigned char*)(0x424E2310UL))
#define bFM4_ADC1_PFNS_TEST1                   *((volatile unsigned char*)(0x424E2314UL))
#define bFM4_ADC1_PCCR_PSTR                    *((volatile unsigned char*)(0x424E2320UL))
#define bFM4_ADC1_PCCR_PHEN                    *((volatile unsigned char*)(0x424E2324UL))
#define bFM4_ADC1_PCCR_PEEN                    *((volatile unsigned char*)(0x424E2328UL))
#define bFM4_ADC1_PCCR_ESCE                    *((volatile unsigned char*)(0x424E232CUL))
#define bFM4_ADC1_PCCR_PFCLR                   *((volatile unsigned char*)(0x424E2330UL))
#define bFM4_ADC1_PCCR_POVR                    *((volatile unsigned char*)(0x424E2334UL))
#define bFM4_ADC1_PCCR_PFUL                    *((volatile unsigned char*)(0x424E2338UL))
#define bFM4_ADC1_PCCR_PEMP                    *((volatile unsigned char*)(0x424E233CUL))
#define bFM4_ADC1_PCFD_PC0                     *((volatile unsigned char*)(0x424E2380UL))
#define bFM4_ADC1_PCFD_PC1                     *((volatile unsigned char*)(0x424E2384UL))
#define bFM4_ADC1_PCFD_PC2                     *((volatile unsigned char*)(0x424E2388UL))
#define bFM4_ADC1_PCFD_PC3                     *((volatile unsigned char*)(0x424E238CUL))
#define bFM4_ADC1_PCFD_PC4                     *((volatile unsigned char*)(0x424E2390UL))
#define bFM4_ADC1_PCFD_RS0                     *((volatile unsigned char*)(0x424E23A0UL))
#define bFM4_ADC1_PCFD_RS1                     *((volatile unsigned char*)(0x424E23A4UL))
#define bFM4_ADC1_PCFD_RS2                     *((volatile unsigned char*)(0x424E23A8UL))
#define bFM4_ADC1_PCFD_INVL                    *((volatile unsigned char*)(0x424E23B0UL))
#define bFM4_ADC1_PCFD_PD0                     *((volatile unsigned char*)(0x424E23D0UL))
#define bFM4_ADC1_PCFD_PD1                     *((volatile unsigned char*)(0x424E23D4UL))
#define bFM4_ADC1_PCFD_PD2                     *((volatile unsigned char*)(0x424E23D8UL))
#define bFM4_ADC1_PCFD_PD3                     *((volatile unsigned char*)(0x424E23DCUL))
#define bFM4_ADC1_PCFD_PD4                     *((volatile unsigned char*)(0x424E23E0UL))
#define bFM4_ADC1_PCFD_PD5                     *((volatile unsigned char*)(0x424E23E4UL))
#define bFM4_ADC1_PCFD_PD6                     *((volatile unsigned char*)(0x424E23E8UL))
#define bFM4_ADC1_PCFD_PD7                     *((volatile unsigned char*)(0x424E23ECUL))
#define bFM4_ADC1_PCFD_PD8                     *((volatile unsigned char*)(0x424E23F0UL))
#define bFM4_ADC1_PCFD_PD9                     *((volatile unsigned char*)(0x424E23F4UL))
#define bFM4_ADC1_PCFD_PD10                    *((volatile unsigned char*)(0x424E23F8UL))
#define bFM4_ADC1_PCFD_PD11                    *((volatile unsigned char*)(0x424E23FCUL))
#define bFM4_ADC1_PCFDL_PC0                    *((volatile unsigned char*)(0x424E2380UL))
#define bFM4_ADC1_PCFDL_PC1                    *((volatile unsigned char*)(0x424E2384UL))
#define bFM4_ADC1_PCFDL_PC2                    *((volatile unsigned char*)(0x424E2388UL))
#define bFM4_ADC1_PCFDL_PC3                    *((volatile unsigned char*)(0x424E238CUL))
#define bFM4_ADC1_PCFDL_PC4                    *((volatile unsigned char*)(0x424E2390UL))
#define bFM4_ADC1_PCFDL_RS0                    *((volatile unsigned char*)(0x424E23A0UL))
#define bFM4_ADC1_PCFDL_RS1                    *((volatile unsigned char*)(0x424E23A4UL))
#define bFM4_ADC1_PCFDL_RS2                    *((volatile unsigned char*)(0x424E23A8UL))
#define bFM4_ADC1_PCFDL_INVL                   *((volatile unsigned char*)(0x424E23B0UL))
#define bFM4_ADC1_PCFDH_PD0                    *((volatile unsigned char*)(0x424E23D0UL))
#define bFM4_ADC1_PCFDH_PD1                    *((volatile unsigned char*)(0x424E23D4UL))
#define bFM4_ADC1_PCFDH_PD2                    *((volatile unsigned char*)(0x424E23D8UL))
#define bFM4_ADC1_PCFDH_PD3                    *((volatile unsigned char*)(0x424E23DCUL))
#define bFM4_ADC1_PCFDH_PD4                    *((volatile unsigned char*)(0x424E23E0UL))
#define bFM4_ADC1_PCFDH_PD5                    *((volatile unsigned char*)(0x424E23E4UL))
#define bFM4_ADC1_PCFDH_PD6                    *((volatile unsigned char*)(0x424E23E8UL))
#define bFM4_ADC1_PCFDH_PD7                    *((volatile unsigned char*)(0x424E23ECUL))
#define bFM4_ADC1_PCFDH_PD8                    *((volatile unsigned char*)(0x424E23F0UL))
#define bFM4_ADC1_PCFDH_PD9                    *((volatile unsigned char*)(0x424E23F4UL))
#define bFM4_ADC1_PCFDH_PD10                   *((volatile unsigned char*)(0x424E23F8UL))
#define bFM4_ADC1_PCFDH_PD11                   *((volatile unsigned char*)(0x424E23FCUL))
#define bFM4_ADC1_PCIS_P1A0                    *((volatile unsigned char*)(0x424E2400UL))
#define bFM4_ADC1_PCIS_P1A1                    *((volatile unsigned char*)(0x424E2404UL))
#define bFM4_ADC1_PCIS_P1A2                    *((volatile unsigned char*)(0x424E2408UL))
#define bFM4_ADC1_PCIS_P2A0                    *((volatile unsigned char*)(0x424E240CUL))
#define bFM4_ADC1_PCIS_P2A1                    *((volatile unsigned char*)(0x424E2410UL))
#define bFM4_ADC1_PCIS_P2A2                    *((volatile unsigned char*)(0x424E2414UL))
#define bFM4_ADC1_PCIS_P2A3                    *((volatile unsigned char*)(0x424E2418UL))
#define bFM4_ADC1_PCIS_P2A4                    *((volatile unsigned char*)(0x424E241CUL))
#define bFM4_ADC1_CMPCR_CCH0                   *((volatile unsigned char*)(0x424E2480UL))
#define bFM4_ADC1_CMPCR_CCH1                   *((volatile unsigned char*)(0x424E2484UL))
#define bFM4_ADC1_CMPCR_CCH2                   *((volatile unsigned char*)(0x424E2488UL))
#define bFM4_ADC1_CMPCR_CCH3                   *((volatile unsigned char*)(0x424E248CUL))
#define bFM4_ADC1_CMPCR_CCH4                   *((volatile unsigned char*)(0x424E2490UL))
#define bFM4_ADC1_CMPCR_CMD0                   *((volatile unsigned char*)(0x424E2494UL))
#define bFM4_ADC1_CMPCR_CMD1                   *((volatile unsigned char*)(0x424E2498UL))
#define bFM4_ADC1_CMPCR_CMPEN                  *((volatile unsigned char*)(0x424E249CUL))
#define bFM4_ADC1_CMPD_CMAD2                   *((volatile unsigned char*)(0x424E24D8UL))
#define bFM4_ADC1_CMPD_CMAD3                   *((volatile unsigned char*)(0x424E24DCUL))
#define bFM4_ADC1_CMPD_CMAD4                   *((volatile unsigned char*)(0x424E24E0UL))
#define bFM4_ADC1_CMPD_CMAD5                   *((volatile unsigned char*)(0x424E24E4UL))
#define bFM4_ADC1_CMPD_CMAD6                   *((volatile unsigned char*)(0x424E24E8UL))
#define bFM4_ADC1_CMPD_CMAD7                   *((volatile unsigned char*)(0x424E24ECUL))
#define bFM4_ADC1_CMPD_CMAD8                   *((volatile unsigned char*)(0x424E24F0UL))
#define bFM4_ADC1_CMPD_CMAD9                   *((volatile unsigned char*)(0x424E24F4UL))
#define bFM4_ADC1_CMPD_CMAD10                  *((volatile unsigned char*)(0x424E24F8UL))
#define bFM4_ADC1_CMPD_CMAD11                  *((volatile unsigned char*)(0x424E24FCUL))
#define bFM4_ADC1_ADSS23_TS16                  *((volatile unsigned char*)(0x424E2500UL))
#define bFM4_ADC1_ADSS23_TS17                  *((volatile unsigned char*)(0x424E2504UL))
#define bFM4_ADC1_ADSS23_TS18                  *((volatile unsigned char*)(0x424E2508UL))
#define bFM4_ADC1_ADSS23_TS19                  *((volatile unsigned char*)(0x424E250CUL))
#define bFM4_ADC1_ADSS23_TS20                  *((volatile unsigned char*)(0x424E2510UL))
#define bFM4_ADC1_ADSS23_TS21                  *((volatile unsigned char*)(0x424E2514UL))
#define bFM4_ADC1_ADSS23_TS22                  *((volatile unsigned char*)(0x424E2518UL))
#define bFM4_ADC1_ADSS23_TS23                  *((volatile unsigned char*)(0x424E251CUL))
#define bFM4_ADC1_ADSS23_TS24                  *((volatile unsigned char*)(0x424E2520UL))
#define bFM4_ADC1_ADSS23_TS25                  *((volatile unsigned char*)(0x424E2524UL))
#define bFM4_ADC1_ADSS23_TS26                  *((volatile unsigned char*)(0x424E2528UL))
#define bFM4_ADC1_ADSS23_TS27                  *((volatile unsigned char*)(0x424E252CUL))
#define bFM4_ADC1_ADSS23_TS28                  *((volatile unsigned char*)(0x424E2530UL))
#define bFM4_ADC1_ADSS23_TS29                  *((volatile unsigned char*)(0x424E2534UL))
#define bFM4_ADC1_ADSS23_TS30                  *((volatile unsigned char*)(0x424E2538UL))
#define bFM4_ADC1_ADSS23_TS31                  *((volatile unsigned char*)(0x424E253CUL))
#define bFM4_ADC1_ADSS2_TS16                   *((volatile unsigned char*)(0x424E2500UL))
#define bFM4_ADC1_ADSS2_TS17                   *((volatile unsigned char*)(0x424E2504UL))
#define bFM4_ADC1_ADSS2_TS18                   *((volatile unsigned char*)(0x424E2508UL))
#define bFM4_ADC1_ADSS2_TS19                   *((volatile unsigned char*)(0x424E250CUL))
#define bFM4_ADC1_ADSS2_TS20                   *((volatile unsigned char*)(0x424E2510UL))
#define bFM4_ADC1_ADSS2_TS21                   *((volatile unsigned char*)(0x424E2514UL))
#define bFM4_ADC1_ADSS2_TS22                   *((volatile unsigned char*)(0x424E2518UL))
#define bFM4_ADC1_ADSS2_TS23                   *((volatile unsigned char*)(0x424E251CUL))
#define bFM4_ADC1_ADSS3_TS24                   *((volatile unsigned char*)(0x424E2520UL))
#define bFM4_ADC1_ADSS3_TS25                   *((volatile unsigned char*)(0x424E2524UL))
#define bFM4_ADC1_ADSS3_TS26                   *((volatile unsigned char*)(0x424E2528UL))
#define bFM4_ADC1_ADSS3_TS27                   *((volatile unsigned char*)(0x424E252CUL))
#define bFM4_ADC1_ADSS3_TS28                   *((volatile unsigned char*)(0x424E2530UL))
#define bFM4_ADC1_ADSS3_TS29                   *((volatile unsigned char*)(0x424E2534UL))
#define bFM4_ADC1_ADSS3_TS30                   *((volatile unsigned char*)(0x424E2538UL))
#define bFM4_ADC1_ADSS3_TS31                   *((volatile unsigned char*)(0x424E253CUL))
#define bFM4_ADC1_ADSS01_TS0                   *((volatile unsigned char*)(0x424E2580UL))
#define bFM4_ADC1_ADSS01_TS1                   *((volatile unsigned char*)(0x424E2584UL))
#define bFM4_ADC1_ADSS01_TS2                   *((volatile unsigned char*)(0x424E2588UL))
#define bFM4_ADC1_ADSS01_TS3                   *((volatile unsigned char*)(0x424E258CUL))
#define bFM4_ADC1_ADSS01_TS4                   *((volatile unsigned char*)(0x424E2590UL))
#define bFM4_ADC1_ADSS01_TS5                   *((volatile unsigned char*)(0x424E2594UL))
#define bFM4_ADC1_ADSS01_TS6                   *((volatile unsigned char*)(0x424E2598UL))
#define bFM4_ADC1_ADSS01_TS7                   *((volatile unsigned char*)(0x424E259CUL))
#define bFM4_ADC1_ADSS01_TS8                   *((volatile unsigned char*)(0x424E25A0UL))
#define bFM4_ADC1_ADSS01_TS9                   *((volatile unsigned char*)(0x424E25A4UL))
#define bFM4_ADC1_ADSS01_TS10                  *((volatile unsigned char*)(0x424E25A8UL))
#define bFM4_ADC1_ADSS01_TS11                  *((volatile unsigned char*)(0x424E25ACUL))
#define bFM4_ADC1_ADSS01_TS12                  *((volatile unsigned char*)(0x424E25B0UL))
#define bFM4_ADC1_ADSS01_TS13                  *((volatile unsigned char*)(0x424E25B4UL))
#define bFM4_ADC1_ADSS01_TS14                  *((volatile unsigned char*)(0x424E25B8UL))
#define bFM4_ADC1_ADSS01_TS15                  *((volatile unsigned char*)(0x424E25BCUL))
#define bFM4_ADC1_ADSS0_TS0                    *((volatile unsigned char*)(0x424E2580UL))
#define bFM4_ADC1_ADSS0_TS1                    *((volatile unsigned char*)(0x424E2584UL))
#define bFM4_ADC1_ADSS0_TS2                    *((volatile unsigned char*)(0x424E2588UL))
#define bFM4_ADC1_ADSS0_TS3                    *((volatile unsigned char*)(0x424E258CUL))
#define bFM4_ADC1_ADSS0_TS4                    *((volatile unsigned char*)(0x424E2590UL))
#define bFM4_ADC1_ADSS0_TS5                    *((volatile unsigned char*)(0x424E2594UL))
#define bFM4_ADC1_ADSS0_TS6                    *((volatile unsigned char*)(0x424E2598UL))
#define bFM4_ADC1_ADSS0_TS7                    *((volatile unsigned char*)(0x424E259CUL))
#define bFM4_ADC1_ADSS1_TS8                    *((volatile unsigned char*)(0x424E25A0UL))
#define bFM4_ADC1_ADSS1_TS9                    *((volatile unsigned char*)(0x424E25A4UL))
#define bFM4_ADC1_ADSS1_TS10                   *((volatile unsigned char*)(0x424E25A8UL))
#define bFM4_ADC1_ADSS1_TS11                   *((volatile unsigned char*)(0x424E25ACUL))
#define bFM4_ADC1_ADSS1_TS12                   *((volatile unsigned char*)(0x424E25B0UL))
#define bFM4_ADC1_ADSS1_TS13                   *((volatile unsigned char*)(0x424E25B4UL))
#define bFM4_ADC1_ADSS1_TS14                   *((volatile unsigned char*)(0x424E25B8UL))
#define bFM4_ADC1_ADSS1_TS15                   *((volatile unsigned char*)(0x424E25BCUL))
#define bFM4_ADC1_ADST01_ST10                  *((volatile unsigned char*)(0x424E2600UL))
#define bFM4_ADC1_ADST01_ST11                  *((volatile unsigned char*)(0x424E2604UL))
#define bFM4_ADC1_ADST01_ST12                  *((volatile unsigned char*)(0x424E2608UL))
#define bFM4_ADC1_ADST01_ST13                  *((volatile unsigned char*)(0x424E260CUL))
#define bFM4_ADC1_ADST01_ST14                  *((volatile unsigned char*)(0x424E2610UL))
#define bFM4_ADC1_ADST01_STX10                 *((volatile unsigned char*)(0x424E2614UL))
#define bFM4_ADC1_ADST01_STX11                 *((volatile unsigned char*)(0x424E2618UL))
#define bFM4_ADC1_ADST01_STX12                 *((volatile unsigned char*)(0x424E261CUL))
#define bFM4_ADC1_ADST01_ST00                  *((volatile unsigned char*)(0x424E2620UL))
#define bFM4_ADC1_ADST01_ST01                  *((volatile unsigned char*)(0x424E2624UL))
#define bFM4_ADC1_ADST01_ST02                  *((volatile unsigned char*)(0x424E2628UL))
#define bFM4_ADC1_ADST01_ST03                  *((volatile unsigned char*)(0x424E262CUL))
#define bFM4_ADC1_ADST01_ST04                  *((volatile unsigned char*)(0x424E2630UL))
#define bFM4_ADC1_ADST01_STX00                 *((volatile unsigned char*)(0x424E2634UL))
#define bFM4_ADC1_ADST01_STX01                 *((volatile unsigned char*)(0x424E2638UL))
#define bFM4_ADC1_ADST01_STX02                 *((volatile unsigned char*)(0x424E263CUL))
#define bFM4_ADC1_ADST1_ST10                   *((volatile unsigned char*)(0x424E2600UL))
#define bFM4_ADC1_ADST1_ST11                   *((volatile unsigned char*)(0x424E2604UL))
#define bFM4_ADC1_ADST1_ST12                   *((volatile unsigned char*)(0x424E2608UL))
#define bFM4_ADC1_ADST1_ST13                   *((volatile unsigned char*)(0x424E260CUL))
#define bFM4_ADC1_ADST1_ST14                   *((volatile unsigned char*)(0x424E2610UL))
#define bFM4_ADC1_ADST1_STX10                  *((volatile unsigned char*)(0x424E2614UL))
#define bFM4_ADC1_ADST1_STX11                  *((volatile unsigned char*)(0x424E2618UL))
#define bFM4_ADC1_ADST1_STX12                  *((volatile unsigned char*)(0x424E261CUL))
#define bFM4_ADC1_ADST0_ST00                   *((volatile unsigned char*)(0x424E2620UL))
#define bFM4_ADC1_ADST0_ST01                   *((volatile unsigned char*)(0x424E2624UL))
#define bFM4_ADC1_ADST0_ST02                   *((volatile unsigned char*)(0x424E2628UL))
#define bFM4_ADC1_ADST0_ST03                   *((volatile unsigned char*)(0x424E262CUL))
#define bFM4_ADC1_ADST0_ST04                   *((volatile unsigned char*)(0x424E2630UL))
#define bFM4_ADC1_ADST0_STX00                  *((volatile unsigned char*)(0x424E2634UL))
#define bFM4_ADC1_ADST0_STX01                  *((volatile unsigned char*)(0x424E2638UL))
#define bFM4_ADC1_ADST0_STX02                  *((volatile unsigned char*)(0x424E263CUL))
#define bFM4_ADC1_ADCT_CT0                     *((volatile unsigned char*)(0x424E2680UL))
#define bFM4_ADC1_ADCT_CT1                     *((volatile unsigned char*)(0x424E2684UL))
#define bFM4_ADC1_ADCT_CT2                     *((volatile unsigned char*)(0x424E2688UL))
#define bFM4_ADC1_PRTSL_PRTSL0                 *((volatile unsigned char*)(0x424E2700UL))
#define bFM4_ADC1_PRTSL_PRTSL1                 *((volatile unsigned char*)(0x424E2704UL))
#define bFM4_ADC1_PRTSL_PRTSL2                 *((volatile unsigned char*)(0x424E2708UL))
#define bFM4_ADC1_PRTSL_PRTSL3                 *((volatile unsigned char*)(0x424E270CUL))
#define bFM4_ADC1_SCTSL_SCTSL0                 *((volatile unsigned char*)(0x424E2720UL))
#define bFM4_ADC1_SCTSL_SCTSL1                 *((volatile unsigned char*)(0x424E2724UL))
#define bFM4_ADC1_SCTSL_SCTSL2                 *((volatile unsigned char*)(0x424E2728UL))
#define bFM4_ADC1_SCTSL_SCTSL3                 *((volatile unsigned char*)(0x424E272CUL))
#define bFM4_ADC1_ADCEN_ENBL                   *((volatile unsigned char*)(0x424E2780UL))
#define bFM4_ADC1_ADCEN_READY                  *((volatile unsigned char*)(0x424E2784UL))

/* 12-bit ADC unit 2 registers */
#define bFM4_ADC2_ADSR_SCS                     *((volatile unsigned char*)(0x424E4000UL))
#define bFM4_ADC2_ADSR_PCS                     *((volatile unsigned char*)(0x424E4004UL))
#define bFM4_ADC2_ADSR_PCNS                    *((volatile unsigned char*)(0x424E4008UL))
#define bFM4_ADC2_ADSR_FDAS                    *((volatile unsigned char*)(0x424E4018UL))
#define bFM4_ADC2_ADSR_ADSTP                   *((volatile unsigned char*)(0x424E401CUL))
#define bFM4_ADC2_ADCR_OVRIE                   *((volatile unsigned char*)(0x424E4020UL))
#define bFM4_ADC2_ADCR_CMPIE                   *((volatile unsigned char*)(0x424E4024UL))
#define bFM4_ADC2_ADCR_PCIE                    *((volatile unsigned char*)(0x424E4028UL))
#define bFM4_ADC2_ADCR_SCIE                    *((volatile unsigned char*)(0x424E402CUL))
#define bFM4_ADC2_ADCR_CMPIF                   *((volatile unsigned char*)(0x424E4034UL))
#define bFM4_ADC2_ADCR_PCIF                    *((volatile unsigned char*)(0x424E4038UL))
#define bFM4_ADC2_ADCR_SCIF                    *((volatile unsigned char*)(0x424E403CUL))
#define bFM4_ADC2_SFNS_SFS0                    *((volatile unsigned char*)(0x424E4100UL))
#define bFM4_ADC2_SFNS_SFS1                    *((volatile unsigned char*)(0x424E4104UL))
#define bFM4_ADC2_SFNS_SFS2                    *((volatile unsigned char*)(0x424E4108UL))
#define bFM4_ADC2_SFNS_SFS3                    *((volatile unsigned char*)(0x424E410CUL))
#define bFM4_ADC2_SCCR_SSTR                    *((volatile unsigned char*)(0x424E4120UL))
#define bFM4_ADC2_SCCR_SHEN                    *((volatile unsigned char*)(0x424E4124UL))
#define bFM4_ADC2_SCCR_RPT                     *((volatile unsigned char*)(0x424E4128UL))
#define bFM4_ADC2_SCCR_SFCLR                   *((volatile unsigned char*)(0x424E4130UL))
#define bFM4_ADC2_SCCR_SOVR                    *((volatile unsigned char*)(0x424E4134UL))
#define bFM4_ADC2_SCCR_SFUL                    *((volatile unsigned char*)(0x424E4138UL))
#define bFM4_ADC2_SCCR_SEMP                    *((volatile unsigned char*)(0x424E413CUL))
#define bFM4_ADC2_SCFD_SC0                     *((volatile unsigned char*)(0x424E4180UL))
#define bFM4_ADC2_SCFD_SC1                     *((volatile unsigned char*)(0x424E4184UL))
#define bFM4_ADC2_SCFD_SC2                     *((volatile unsigned char*)(0x424E4188UL))
#define bFM4_ADC2_SCFD_SC3                     *((volatile unsigned char*)(0x424E418CUL))
#define bFM4_ADC2_SCFD_SC4                     *((volatile unsigned char*)(0x424E4190UL))
#define bFM4_ADC2_SCFD_RS0                     *((volatile unsigned char*)(0x424E41A0UL))
#define bFM4_ADC2_SCFD_RS1                     *((volatile unsigned char*)(0x424E41A4UL))
#define bFM4_ADC2_SCFD_INVL                    *((volatile unsigned char*)(0x424E41B0UL))
#define bFM4_ADC2_SCFD_SD0                     *((volatile unsigned char*)(0x424E41D0UL))
#define bFM4_ADC2_SCFD_SD1                     *((volatile unsigned char*)(0x424E41D4UL))
#define bFM4_ADC2_SCFD_SD2                     *((volatile unsigned char*)(0x424E41D8UL))
#define bFM4_ADC2_SCFD_SD3                     *((volatile unsigned char*)(0x424E41DCUL))
#define bFM4_ADC2_SCFD_SD4                     *((volatile unsigned char*)(0x424E41E0UL))
#define bFM4_ADC2_SCFD_SD5                     *((volatile unsigned char*)(0x424E41E4UL))
#define bFM4_ADC2_SCFD_SD6                     *((volatile unsigned char*)(0x424E41E8UL))
#define bFM4_ADC2_SCFD_SD7                     *((volatile unsigned char*)(0x424E41ECUL))
#define bFM4_ADC2_SCFD_SD8                     *((volatile unsigned char*)(0x424E41F0UL))
#define bFM4_ADC2_SCFD_SD9                     *((volatile unsigned char*)(0x424E41F4UL))
#define bFM4_ADC2_SCFD_SD10                    *((volatile unsigned char*)(0x424E41F8UL))
#define bFM4_ADC2_SCFD_SD11                    *((volatile unsigned char*)(0x424E41FCUL))
#define bFM4_ADC2_SCFDL_SC0                    *((volatile unsigned char*)(0x424E4180UL))
#define bFM4_ADC2_SCFDL_SC1                    *((volatile unsigned char*)(0x424E4184UL))
#define bFM4_ADC2_SCFDL_SC2                    *((volatile unsigned char*)(0x424E4188UL))
#define bFM4_ADC2_SCFDL_SC3                    *((volatile unsigned char*)(0x424E418CUL))
#define bFM4_ADC2_SCFDL_SC4                    *((volatile unsigned char*)(0x424E4190UL))
#define bFM4_ADC2_SCFDL_RS0                    *((volatile unsigned char*)(0x424E41A0UL))
#define bFM4_ADC2_SCFDL_RS1                    *((volatile unsigned char*)(0x424E41A4UL))
#define bFM4_ADC2_SCFDL_INVL                   *((volatile unsigned char*)(0x424E41B0UL))
#define bFM4_ADC2_SCFDH_SD0                    *((volatile unsigned char*)(0x424E41D0UL))
#define bFM4_ADC2_SCFDH_SD1                    *((volatile unsigned char*)(0x424E41D4UL))
#define bFM4_ADC2_SCFDH_SD2                    *((volatile unsigned char*)(0x424E41D8UL))
#define bFM4_ADC2_SCFDH_SD3                    *((volatile unsigned char*)(0x424E41DCUL))
#define bFM4_ADC2_SCFDH_SD4                    *((volatile unsigned char*)(0x424E41E0UL))
#define bFM4_ADC2_SCFDH_SD5                    *((volatile unsigned char*)(0x424E41E4UL))
#define bFM4_ADC2_SCFDH_SD6                    *((volatile unsigned char*)(0x424E41E8UL))
#define bFM4_ADC2_SCFDH_SD7                    *((volatile unsigned char*)(0x424E41ECUL))
#define bFM4_ADC2_SCFDH_SD8                    *((volatile unsigned char*)(0x424E41F0UL))
#define bFM4_ADC2_SCFDH_SD9                    *((volatile unsigned char*)(0x424E41F4UL))
#define bFM4_ADC2_SCFDH_SD10                   *((volatile unsigned char*)(0x424E41F8UL))
#define bFM4_ADC2_SCFDH_SD11                   *((volatile unsigned char*)(0x424E41FCUL))
#define bFM4_ADC2_SCIS23_AN16                  *((volatile unsigned char*)(0x424E4200UL))
#define bFM4_ADC2_SCIS23_AN17                  *((volatile unsigned char*)(0x424E4204UL))
#define bFM4_ADC2_SCIS23_AN18                  *((volatile unsigned char*)(0x424E4208UL))
#define bFM4_ADC2_SCIS23_AN19                  *((volatile unsigned char*)(0x424E420CUL))
#define bFM4_ADC2_SCIS23_AN20                  *((volatile unsigned char*)(0x424E4210UL))
#define bFM4_ADC2_SCIS23_AN21                  *((volatile unsigned char*)(0x424E4214UL))
#define bFM4_ADC2_SCIS23_AN22                  *((volatile unsigned char*)(0x424E4218UL))
#define bFM4_ADC2_SCIS23_AN23                  *((volatile unsigned char*)(0x424E421CUL))
#define bFM4_ADC2_SCIS23_AN24                  *((volatile unsigned char*)(0x424E4220UL))
#define bFM4_ADC2_SCIS23_AN25                  *((volatile unsigned char*)(0x424E4224UL))
#define bFM4_ADC2_SCIS23_AN26                  *((volatile unsigned char*)(0x424E4228UL))
#define bFM4_ADC2_SCIS23_AN27                  *((volatile unsigned char*)(0x424E422CUL))
#define bFM4_ADC2_SCIS23_AN28                  *((volatile unsigned char*)(0x424E4230UL))
#define bFM4_ADC2_SCIS23_AN29                  *((volatile unsigned char*)(0x424E4234UL))
#define bFM4_ADC2_SCIS23_AN30                  *((volatile unsigned char*)(0x424E4238UL))
#define bFM4_ADC2_SCIS23_AN31                  *((volatile unsigned char*)(0x424E423CUL))
#define bFM4_ADC2_SCIS2_AN16                   *((volatile unsigned char*)(0x424E4200UL))
#define bFM4_ADC2_SCIS2_AN17                   *((volatile unsigned char*)(0x424E4204UL))
#define bFM4_ADC2_SCIS2_AN18                   *((volatile unsigned char*)(0x424E4208UL))
#define bFM4_ADC2_SCIS2_AN19                   *((volatile unsigned char*)(0x424E420CUL))
#define bFM4_ADC2_SCIS2_AN20                   *((volatile unsigned char*)(0x424E4210UL))
#define bFM4_ADC2_SCIS2_AN21                   *((volatile unsigned char*)(0x424E4214UL))
#define bFM4_ADC2_SCIS2_AN22                   *((volatile unsigned char*)(0x424E4218UL))
#define bFM4_ADC2_SCIS2_AN23                   *((volatile unsigned char*)(0x424E421CUL))
#define bFM4_ADC2_SCIS3_AN24                   *((volatile unsigned char*)(0x424E4220UL))
#define bFM4_ADC2_SCIS3_AN25                   *((volatile unsigned char*)(0x424E4224UL))
#define bFM4_ADC2_SCIS3_AN26                   *((volatile unsigned char*)(0x424E4228UL))
#define bFM4_ADC2_SCIS3_AN27                   *((volatile unsigned char*)(0x424E422CUL))
#define bFM4_ADC2_SCIS3_AN28                   *((volatile unsigned char*)(0x424E4230UL))
#define bFM4_ADC2_SCIS3_AN29                   *((volatile unsigned char*)(0x424E4234UL))
#define bFM4_ADC2_SCIS3_AN30                   *((volatile unsigned char*)(0x424E4238UL))
#define bFM4_ADC2_SCIS3_AN31                   *((volatile unsigned char*)(0x424E423CUL))
#define bFM4_ADC2_SCIS01_AN0                   *((volatile unsigned char*)(0x424E4280UL))
#define bFM4_ADC2_SCIS01_AN1                   *((volatile unsigned char*)(0x424E4284UL))
#define bFM4_ADC2_SCIS01_AN2                   *((volatile unsigned char*)(0x424E4288UL))
#define bFM4_ADC2_SCIS01_AN3                   *((volatile unsigned char*)(0x424E428CUL))
#define bFM4_ADC2_SCIS01_AN4                   *((volatile unsigned char*)(0x424E4290UL))
#define bFM4_ADC2_SCIS01_AN5                   *((volatile unsigned char*)(0x424E4294UL))
#define bFM4_ADC2_SCIS01_AN6                   *((volatile unsigned char*)(0x424E4298UL))
#define bFM4_ADC2_SCIS01_AN7                   *((volatile unsigned char*)(0x424E429CUL))
#define bFM4_ADC2_SCIS01_AN8                   *((volatile unsigned char*)(0x424E42A0UL))
#define bFM4_ADC2_SCIS01_AN9                   *((volatile unsigned char*)(0x424E42A4UL))
#define bFM4_ADC2_SCIS01_AN10                  *((volatile unsigned char*)(0x424E42A8UL))
#define bFM4_ADC2_SCIS01_AN11                  *((volatile unsigned char*)(0x424E42ACUL))
#define bFM4_ADC2_SCIS01_AN12                  *((volatile unsigned char*)(0x424E42B0UL))
#define bFM4_ADC2_SCIS01_AN13                  *((volatile unsigned char*)(0x424E42B4UL))
#define bFM4_ADC2_SCIS01_AN14                  *((volatile unsigned char*)(0x424E42B8UL))
#define bFM4_ADC2_SCIS01_AN15                  *((volatile unsigned char*)(0x424E42BCUL))
#define bFM4_ADC2_SCIS0_AN0                    *((volatile unsigned char*)(0x424E4280UL))
#define bFM4_ADC2_SCIS0_AN1                    *((volatile unsigned char*)(0x424E4284UL))
#define bFM4_ADC2_SCIS0_AN2                    *((volatile unsigned char*)(0x424E4288UL))
#define bFM4_ADC2_SCIS0_AN3                    *((volatile unsigned char*)(0x424E428CUL))
#define bFM4_ADC2_SCIS0_AN4                    *((volatile unsigned char*)(0x424E4290UL))
#define bFM4_ADC2_SCIS0_AN5                    *((volatile unsigned char*)(0x424E4294UL))
#define bFM4_ADC2_SCIS0_AN6                    *((volatile unsigned char*)(0x424E4298UL))
#define bFM4_ADC2_SCIS0_AN7                    *((volatile unsigned char*)(0x424E429CUL))
#define bFM4_ADC2_SCIS1_AN8                    *((volatile unsigned char*)(0x424E42A0UL))
#define bFM4_ADC2_SCIS1_AN9                    *((volatile unsigned char*)(0x424E42A4UL))
#define bFM4_ADC2_SCIS1_AN10                   *((volatile unsigned char*)(0x424E42A8UL))
#define bFM4_ADC2_SCIS1_AN11                   *((volatile unsigned char*)(0x424E42ACUL))
#define bFM4_ADC2_SCIS1_AN12                   *((volatile unsigned char*)(0x424E42B0UL))
#define bFM4_ADC2_SCIS1_AN13                   *((volatile unsigned char*)(0x424E42B4UL))
#define bFM4_ADC2_SCIS1_AN14                   *((volatile unsigned char*)(0x424E42B8UL))
#define bFM4_ADC2_SCIS1_AN15                   *((volatile unsigned char*)(0x424E42BCUL))
#define bFM4_ADC2_PFNS_PFS0                    *((volatile unsigned char*)(0x424E4300UL))
#define bFM4_ADC2_PFNS_PFS1                    *((volatile unsigned char*)(0x424E4304UL))
#define bFM4_ADC2_PFNS_TEST0                   *((volatile unsigned char*)(0x424E4310UL))
#define bFM4_ADC2_PFNS_TEST1                   *((volatile unsigned char*)(0x424E4314UL))
#define bFM4_ADC2_PCCR_PSTR                    *((volatile unsigned char*)(0x424E4320UL))
#define bFM4_ADC2_PCCR_PHEN                    *((volatile unsigned char*)(0x424E4324UL))
#define bFM4_ADC2_PCCR_PEEN                    *((volatile unsigned char*)(0x424E4328UL))
#define bFM4_ADC2_PCCR_ESCE                    *((volatile unsigned char*)(0x424E432CUL))
#define bFM4_ADC2_PCCR_PFCLR                   *((volatile unsigned char*)(0x424E4330UL))
#define bFM4_ADC2_PCCR_POVR                    *((volatile unsigned char*)(0x424E4334UL))
#define bFM4_ADC2_PCCR_PFUL                    *((volatile unsigned char*)(0x424E4338UL))
#define bFM4_ADC2_PCCR_PEMP                    *((volatile unsigned char*)(0x424E433CUL))
#define bFM4_ADC2_PCFD_PC0                     *((volatile unsigned char*)(0x424E4380UL))
#define bFM4_ADC2_PCFD_PC1                     *((volatile unsigned char*)(0x424E4384UL))
#define bFM4_ADC2_PCFD_PC2                     *((volatile unsigned char*)(0x424E4388UL))
#define bFM4_ADC2_PCFD_PC3                     *((volatile unsigned char*)(0x424E438CUL))
#define bFM4_ADC2_PCFD_PC4                     *((volatile unsigned char*)(0x424E4390UL))
#define bFM4_ADC2_PCFD_RS0                     *((volatile unsigned char*)(0x424E43A0UL))
#define bFM4_ADC2_PCFD_RS1                     *((volatile unsigned char*)(0x424E43A4UL))
#define bFM4_ADC2_PCFD_RS2                     *((volatile unsigned char*)(0x424E43A8UL))
#define bFM4_ADC2_PCFD_INVL                    *((volatile unsigned char*)(0x424E43B0UL))
#define bFM4_ADC2_PCFD_PD0                     *((volatile unsigned char*)(0x424E43D0UL))
#define bFM4_ADC2_PCFD_PD1                     *((volatile unsigned char*)(0x424E43D4UL))
#define bFM4_ADC2_PCFD_PD2                     *((volatile unsigned char*)(0x424E43D8UL))
#define bFM4_ADC2_PCFD_PD3                     *((volatile unsigned char*)(0x424E43DCUL))
#define bFM4_ADC2_PCFD_PD4                     *((volatile unsigned char*)(0x424E43E0UL))
#define bFM4_ADC2_PCFD_PD5                     *((volatile unsigned char*)(0x424E43E4UL))
#define bFM4_ADC2_PCFD_PD6                     *((volatile unsigned char*)(0x424E43E8UL))
#define bFM4_ADC2_PCFD_PD7                     *((volatile unsigned char*)(0x424E43ECUL))
#define bFM4_ADC2_PCFD_PD8                     *((volatile unsigned char*)(0x424E43F0UL))
#define bFM4_ADC2_PCFD_PD9                     *((volatile unsigned char*)(0x424E43F4UL))
#define bFM4_ADC2_PCFD_PD10                    *((volatile unsigned char*)(0x424E43F8UL))
#define bFM4_ADC2_PCFD_PD11                    *((volatile unsigned char*)(0x424E43FCUL))
#define bFM4_ADC2_PCFDL_PC0                    *((volatile unsigned char*)(0x424E4380UL))
#define bFM4_ADC2_PCFDL_PC1                    *((volatile unsigned char*)(0x424E4384UL))
#define bFM4_ADC2_PCFDL_PC2                    *((volatile unsigned char*)(0x424E4388UL))
#define bFM4_ADC2_PCFDL_PC3                    *((volatile unsigned char*)(0x424E438CUL))
#define bFM4_ADC2_PCFDL_PC4                    *((volatile unsigned char*)(0x424E4390UL))
#define bFM4_ADC2_PCFDL_RS0                    *((volatile unsigned char*)(0x424E43A0UL))
#define bFM4_ADC2_PCFDL_RS1                    *((volatile unsigned char*)(0x424E43A4UL))
#define bFM4_ADC2_PCFDL_RS2                    *((volatile unsigned char*)(0x424E43A8UL))
#define bFM4_ADC2_PCFDL_INVL                   *((volatile unsigned char*)(0x424E43B0UL))
#define bFM4_ADC2_PCFDH_PD0                    *((volatile unsigned char*)(0x424E43D0UL))
#define bFM4_ADC2_PCFDH_PD1                    *((volatile unsigned char*)(0x424E43D4UL))
#define bFM4_ADC2_PCFDH_PD2                    *((volatile unsigned char*)(0x424E43D8UL))
#define bFM4_ADC2_PCFDH_PD3                    *((volatile unsigned char*)(0x424E43DCUL))
#define bFM4_ADC2_PCFDH_PD4                    *((volatile unsigned char*)(0x424E43E0UL))
#define bFM4_ADC2_PCFDH_PD5                    *((volatile unsigned char*)(0x424E43E4UL))
#define bFM4_ADC2_PCFDH_PD6                    *((volatile unsigned char*)(0x424E43E8UL))
#define bFM4_ADC2_PCFDH_PD7                    *((volatile unsigned char*)(0x424E43ECUL))
#define bFM4_ADC2_PCFDH_PD8                    *((volatile unsigned char*)(0x424E43F0UL))
#define bFM4_ADC2_PCFDH_PD9                    *((volatile unsigned char*)(0x424E43F4UL))
#define bFM4_ADC2_PCFDH_PD10                   *((volatile unsigned char*)(0x424E43F8UL))
#define bFM4_ADC2_PCFDH_PD11                   *((volatile unsigned char*)(0x424E43FCUL))
#define bFM4_ADC2_PCIS_P1A0                    *((volatile unsigned char*)(0x424E4400UL))
#define bFM4_ADC2_PCIS_P1A1                    *((volatile unsigned char*)(0x424E4404UL))
#define bFM4_ADC2_PCIS_P1A2                    *((volatile unsigned char*)(0x424E4408UL))
#define bFM4_ADC2_PCIS_P2A0                    *((volatile unsigned char*)(0x424E440CUL))
#define bFM4_ADC2_PCIS_P2A1                    *((volatile unsigned char*)(0x424E4410UL))
#define bFM4_ADC2_PCIS_P2A2                    *((volatile unsigned char*)(0x424E4414UL))
#define bFM4_ADC2_PCIS_P2A3                    *((volatile unsigned char*)(0x424E4418UL))
#define bFM4_ADC2_PCIS_P2A4                    *((volatile unsigned char*)(0x424E441CUL))
#define bFM4_ADC2_CMPCR_CCH0                   *((volatile unsigned char*)(0x424E4480UL))
#define bFM4_ADC2_CMPCR_CCH1                   *((volatile unsigned char*)(0x424E4484UL))
#define bFM4_ADC2_CMPCR_CCH2                   *((volatile unsigned char*)(0x424E4488UL))
#define bFM4_ADC2_CMPCR_CCH3                   *((volatile unsigned char*)(0x424E448CUL))
#define bFM4_ADC2_CMPCR_CCH4                   *((volatile unsigned char*)(0x424E4490UL))
#define bFM4_ADC2_CMPCR_CMD0                   *((volatile unsigned char*)(0x424E4494UL))
#define bFM4_ADC2_CMPCR_CMD1                   *((volatile unsigned char*)(0x424E4498UL))
#define bFM4_ADC2_CMPCR_CMPEN                  *((volatile unsigned char*)(0x424E449CUL))
#define bFM4_ADC2_CMPD_CMAD2                   *((volatile unsigned char*)(0x424E44D8UL))
#define bFM4_ADC2_CMPD_CMAD3                   *((volatile unsigned char*)(0x424E44DCUL))
#define bFM4_ADC2_CMPD_CMAD4                   *((volatile unsigned char*)(0x424E44E0UL))
#define bFM4_ADC2_CMPD_CMAD5                   *((volatile unsigned char*)(0x424E44E4UL))
#define bFM4_ADC2_CMPD_CMAD6                   *((volatile unsigned char*)(0x424E44E8UL))
#define bFM4_ADC2_CMPD_CMAD7                   *((volatile unsigned char*)(0x424E44ECUL))
#define bFM4_ADC2_CMPD_CMAD8                   *((volatile unsigned char*)(0x424E44F0UL))
#define bFM4_ADC2_CMPD_CMAD9                   *((volatile unsigned char*)(0x424E44F4UL))
#define bFM4_ADC2_CMPD_CMAD10                  *((volatile unsigned char*)(0x424E44F8UL))
#define bFM4_ADC2_CMPD_CMAD11                  *((volatile unsigned char*)(0x424E44FCUL))
#define bFM4_ADC2_ADSS23_TS16                  *((volatile unsigned char*)(0x424E4500UL))
#define bFM4_ADC2_ADSS23_TS17                  *((volatile unsigned char*)(0x424E4504UL))
#define bFM4_ADC2_ADSS23_TS18                  *((volatile unsigned char*)(0x424E4508UL))
#define bFM4_ADC2_ADSS23_TS19                  *((volatile unsigned char*)(0x424E450CUL))
#define bFM4_ADC2_ADSS23_TS20                  *((volatile unsigned char*)(0x424E4510UL))
#define bFM4_ADC2_ADSS23_TS21                  *((volatile unsigned char*)(0x424E4514UL))
#define bFM4_ADC2_ADSS23_TS22                  *((volatile unsigned char*)(0x424E4518UL))
#define bFM4_ADC2_ADSS23_TS23                  *((volatile unsigned char*)(0x424E451CUL))
#define bFM4_ADC2_ADSS23_TS24                  *((volatile unsigned char*)(0x424E4520UL))
#define bFM4_ADC2_ADSS23_TS25                  *((volatile unsigned char*)(0x424E4524UL))
#define bFM4_ADC2_ADSS23_TS26                  *((volatile unsigned char*)(0x424E4528UL))
#define bFM4_ADC2_ADSS23_TS27                  *((volatile unsigned char*)(0x424E452CUL))
#define bFM4_ADC2_ADSS23_TS28                  *((volatile unsigned char*)(0x424E4530UL))
#define bFM4_ADC2_ADSS23_TS29                  *((volatile unsigned char*)(0x424E4534UL))
#define bFM4_ADC2_ADSS23_TS30                  *((volatile unsigned char*)(0x424E4538UL))
#define bFM4_ADC2_ADSS23_TS31                  *((volatile unsigned char*)(0x424E453CUL))
#define bFM4_ADC2_ADSS2_TS16                   *((volatile unsigned char*)(0x424E4500UL))
#define bFM4_ADC2_ADSS2_TS17                   *((volatile unsigned char*)(0x424E4504UL))
#define bFM4_ADC2_ADSS2_TS18                   *((volatile unsigned char*)(0x424E4508UL))
#define bFM4_ADC2_ADSS2_TS19                   *((volatile unsigned char*)(0x424E450CUL))
#define bFM4_ADC2_ADSS2_TS20                   *((volatile unsigned char*)(0x424E4510UL))
#define bFM4_ADC2_ADSS2_TS21                   *((volatile unsigned char*)(0x424E4514UL))
#define bFM4_ADC2_ADSS2_TS22                   *((volatile unsigned char*)(0x424E4518UL))
#define bFM4_ADC2_ADSS2_TS23                   *((volatile unsigned char*)(0x424E451CUL))
#define bFM4_ADC2_ADSS3_TS24                   *((volatile unsigned char*)(0x424E4520UL))
#define bFM4_ADC2_ADSS3_TS25                   *((volatile unsigned char*)(0x424E4524UL))
#define bFM4_ADC2_ADSS3_TS26                   *((volatile unsigned char*)(0x424E4528UL))
#define bFM4_ADC2_ADSS3_TS27                   *((volatile unsigned char*)(0x424E452CUL))
#define bFM4_ADC2_ADSS3_TS28                   *((volatile unsigned char*)(0x424E4530UL))
#define bFM4_ADC2_ADSS3_TS29                   *((volatile unsigned char*)(0x424E4534UL))
#define bFM4_ADC2_ADSS3_TS30                   *((volatile unsigned char*)(0x424E4538UL))
#define bFM4_ADC2_ADSS3_TS31                   *((volatile unsigned char*)(0x424E453CUL))
#define bFM4_ADC2_ADSS01_TS0                   *((volatile unsigned char*)(0x424E4580UL))
#define bFM4_ADC2_ADSS01_TS1                   *((volatile unsigned char*)(0x424E4584UL))
#define bFM4_ADC2_ADSS01_TS2                   *((volatile unsigned char*)(0x424E4588UL))
#define bFM4_ADC2_ADSS01_TS3                   *((volatile unsigned char*)(0x424E458CUL))
#define bFM4_ADC2_ADSS01_TS4                   *((volatile unsigned char*)(0x424E4590UL))
#define bFM4_ADC2_ADSS01_TS5                   *((volatile unsigned char*)(0x424E4594UL))
#define bFM4_ADC2_ADSS01_TS6                   *((volatile unsigned char*)(0x424E4598UL))
#define bFM4_ADC2_ADSS01_TS7                   *((volatile unsigned char*)(0x424E459CUL))
#define bFM4_ADC2_ADSS01_TS8                   *((volatile unsigned char*)(0x424E45A0UL))
#define bFM4_ADC2_ADSS01_TS9                   *((volatile unsigned char*)(0x424E45A4UL))
#define bFM4_ADC2_ADSS01_TS10                  *((volatile unsigned char*)(0x424E45A8UL))
#define bFM4_ADC2_ADSS01_TS11                  *((volatile unsigned char*)(0x424E45ACUL))
#define bFM4_ADC2_ADSS01_TS12                  *((volatile unsigned char*)(0x424E45B0UL))
#define bFM4_ADC2_ADSS01_TS13                  *((volatile unsigned char*)(0x424E45B4UL))
#define bFM4_ADC2_ADSS01_TS14                  *((volatile unsigned char*)(0x424E45B8UL))
#define bFM4_ADC2_ADSS01_TS15                  *((volatile unsigned char*)(0x424E45BCUL))
#define bFM4_ADC2_ADSS0_TS0                    *((volatile unsigned char*)(0x424E4580UL))
#define bFM4_ADC2_ADSS0_TS1                    *((volatile unsigned char*)(0x424E4584UL))
#define bFM4_ADC2_ADSS0_TS2                    *((volatile unsigned char*)(0x424E4588UL))
#define bFM4_ADC2_ADSS0_TS3                    *((volatile unsigned char*)(0x424E458CUL))
#define bFM4_ADC2_ADSS0_TS4                    *((volatile unsigned char*)(0x424E4590UL))
#define bFM4_ADC2_ADSS0_TS5                    *((volatile unsigned char*)(0x424E4594UL))
#define bFM4_ADC2_ADSS0_TS6                    *((volatile unsigned char*)(0x424E4598UL))
#define bFM4_ADC2_ADSS0_TS7                    *((volatile unsigned char*)(0x424E459CUL))
#define bFM4_ADC2_ADSS1_TS8                    *((volatile unsigned char*)(0x424E45A0UL))
#define bFM4_ADC2_ADSS1_TS9                    *((volatile unsigned char*)(0x424E45A4UL))
#define bFM4_ADC2_ADSS1_TS10                   *((volatile unsigned char*)(0x424E45A8UL))
#define bFM4_ADC2_ADSS1_TS11                   *((volatile unsigned char*)(0x424E45ACUL))
#define bFM4_ADC2_ADSS1_TS12                   *((volatile unsigned char*)(0x424E45B0UL))
#define bFM4_ADC2_ADSS1_TS13                   *((volatile unsigned char*)(0x424E45B4UL))
#define bFM4_ADC2_ADSS1_TS14                   *((volatile unsigned char*)(0x424E45B8UL))
#define bFM4_ADC2_ADSS1_TS15                   *((volatile unsigned char*)(0x424E45BCUL))
#define bFM4_ADC2_ADST01_ST10                  *((volatile unsigned char*)(0x424E4600UL))
#define bFM4_ADC2_ADST01_ST11                  *((volatile unsigned char*)(0x424E4604UL))
#define bFM4_ADC2_ADST01_ST12                  *((volatile unsigned char*)(0x424E4608UL))
#define bFM4_ADC2_ADST01_ST13                  *((volatile unsigned char*)(0x424E460CUL))
#define bFM4_ADC2_ADST01_ST14                  *((volatile unsigned char*)(0x424E4610UL))
#define bFM4_ADC2_ADST01_STX10                 *((volatile unsigned char*)(0x424E4614UL))
#define bFM4_ADC2_ADST01_STX11                 *((volatile unsigned char*)(0x424E4618UL))
#define bFM4_ADC2_ADST01_STX12                 *((volatile unsigned char*)(0x424E461CUL))
#define bFM4_ADC2_ADST01_ST00                  *((volatile unsigned char*)(0x424E4620UL))
#define bFM4_ADC2_ADST01_ST01                  *((volatile unsigned char*)(0x424E4624UL))
#define bFM4_ADC2_ADST01_ST02                  *((volatile unsigned char*)(0x424E4628UL))
#define bFM4_ADC2_ADST01_ST03                  *((volatile unsigned char*)(0x424E462CUL))
#define bFM4_ADC2_ADST01_ST04                  *((volatile unsigned char*)(0x424E4630UL))
#define bFM4_ADC2_ADST01_STX00                 *((volatile unsigned char*)(0x424E4634UL))
#define bFM4_ADC2_ADST01_STX01                 *((volatile unsigned char*)(0x424E4638UL))
#define bFM4_ADC2_ADST01_STX02                 *((volatile unsigned char*)(0x424E463CUL))
#define bFM4_ADC2_ADST1_ST10                   *((volatile unsigned char*)(0x424E4600UL))
#define bFM4_ADC2_ADST1_ST11                   *((volatile unsigned char*)(0x424E4604UL))
#define bFM4_ADC2_ADST1_ST12                   *((volatile unsigned char*)(0x424E4608UL))
#define bFM4_ADC2_ADST1_ST13                   *((volatile unsigned char*)(0x424E460CUL))
#define bFM4_ADC2_ADST1_ST14                   *((volatile unsigned char*)(0x424E4610UL))
#define bFM4_ADC2_ADST1_STX10                  *((volatile unsigned char*)(0x424E4614UL))
#define bFM4_ADC2_ADST1_STX11                  *((volatile unsigned char*)(0x424E4618UL))
#define bFM4_ADC2_ADST1_STX12                  *((volatile unsigned char*)(0x424E461CUL))
#define bFM4_ADC2_ADST0_ST00                   *((volatile unsigned char*)(0x424E4620UL))
#define bFM4_ADC2_ADST0_ST01                   *((volatile unsigned char*)(0x424E4624UL))
#define bFM4_ADC2_ADST0_ST02                   *((volatile unsigned char*)(0x424E4628UL))
#define bFM4_ADC2_ADST0_ST03                   *((volatile unsigned char*)(0x424E462CUL))
#define bFM4_ADC2_ADST0_ST04                   *((volatile unsigned char*)(0x424E4630UL))
#define bFM4_ADC2_ADST0_STX00                  *((volatile unsigned char*)(0x424E4634UL))
#define bFM4_ADC2_ADST0_STX01                  *((volatile unsigned char*)(0x424E4638UL))
#define bFM4_ADC2_ADST0_STX02                  *((volatile unsigned char*)(0x424E463CUL))
#define bFM4_ADC2_ADCT_CT0                     *((volatile unsigned char*)(0x424E4680UL))
#define bFM4_ADC2_ADCT_CT1                     *((volatile unsigned char*)(0x424E4684UL))
#define bFM4_ADC2_ADCT_CT2                     *((volatile unsigned char*)(0x424E4688UL))
#define bFM4_ADC2_PRTSL_PRTSL0                 *((volatile unsigned char*)(0x424E4700UL))
#define bFM4_ADC2_PRTSL_PRTSL1                 *((volatile unsigned char*)(0x424E4704UL))
#define bFM4_ADC2_PRTSL_PRTSL2                 *((volatile unsigned char*)(0x424E4708UL))
#define bFM4_ADC2_PRTSL_PRTSL3                 *((volatile unsigned char*)(0x424E470CUL))
#define bFM4_ADC2_SCTSL_SCTSL0                 *((volatile unsigned char*)(0x424E4720UL))
#define bFM4_ADC2_SCTSL_SCTSL1                 *((volatile unsigned char*)(0x424E4724UL))
#define bFM4_ADC2_SCTSL_SCTSL2                 *((volatile unsigned char*)(0x424E4728UL))
#define bFM4_ADC2_SCTSL_SCTSL3                 *((volatile unsigned char*)(0x424E472CUL))
#define bFM4_ADC2_ADCEN_ENBL                   *((volatile unsigned char*)(0x424E4780UL))
#define bFM4_ADC2_ADCEN_READY                  *((volatile unsigned char*)(0x424E4784UL))

/* CR trimming registers */
#define bFM4_CRTRIM_MCR_PSR_CSR0               *((volatile unsigned char*)(0x425C0000UL))
#define bFM4_CRTRIM_MCR_PSR_CSR1               *((volatile unsigned char*)(0x425C0004UL))
#define bFM4_CRTRIM_MCR_PSR_CSR2               *((volatile unsigned char*)(0x425C0008UL))
#define bFM4_CRTRIM_MCR_FTRM_TRD0              *((volatile unsigned char*)(0x425C0080UL))
#define bFM4_CRTRIM_MCR_FTRM_TRD1              *((volatile unsigned char*)(0x425C0084UL))
#define bFM4_CRTRIM_MCR_FTRM_TRD2              *((volatile unsigned char*)(0x425C0088UL))
#define bFM4_CRTRIM_MCR_FTRM_TRD3              *((volatile unsigned char*)(0x425C008CUL))
#define bFM4_CRTRIM_MCR_FTRM_TRD4              *((volatile unsigned char*)(0x425C0090UL))
#define bFM4_CRTRIM_MCR_FTRM_TRD5              *((volatile unsigned char*)(0x425C0094UL))
#define bFM4_CRTRIM_MCR_FTRM_TRD6              *((volatile unsigned char*)(0x425C0098UL))
#define bFM4_CRTRIM_MCR_FTRM_TRD7              *((volatile unsigned char*)(0x425C009CUL))
#define bFM4_CRTRIM_MCR_FTRM_TRD8              *((volatile unsigned char*)(0x425C00A0UL))
#define bFM4_CRTRIM_MCR_FTRM_TRD9              *((volatile unsigned char*)(0x425C00A4UL))
#define bFM4_CRTRIM_MCR_TTRM_TRT0              *((volatile unsigned char*)(0x425C0100UL))
#define bFM4_CRTRIM_MCR_TTRM_TRT1              *((volatile unsigned char*)(0x425C0104UL))
#define bFM4_CRTRIM_MCR_TTRM_TRT2              *((volatile unsigned char*)(0x425C0108UL))
#define bFM4_CRTRIM_MCR_TTRM_TRT3              *((volatile unsigned char*)(0x425C010CUL))
#define bFM4_CRTRIM_MCR_TTRM_TRT4              *((volatile unsigned char*)(0x425C0110UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK0            *((volatile unsigned int*)(0x425C0180UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK1            *((volatile unsigned int*)(0x425C0184UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK2            *((volatile unsigned int*)(0x425C0188UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK3            *((volatile unsigned int*)(0x425C018CUL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK4            *((volatile unsigned int*)(0x425C0190UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK5            *((volatile unsigned int*)(0x425C0194UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK6            *((volatile unsigned int*)(0x425C0198UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK7            *((volatile unsigned int*)(0x425C019CUL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK8            *((volatile unsigned int*)(0x425C01A0UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK9            *((volatile unsigned int*)(0x425C01A4UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK10           *((volatile unsigned int*)(0x425C01A8UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK11           *((volatile unsigned int*)(0x425C01ACUL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK12           *((volatile unsigned int*)(0x425C01B0UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK13           *((volatile unsigned int*)(0x425C01B4UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK14           *((volatile unsigned int*)(0x425C01B8UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK15           *((volatile unsigned int*)(0x425C01BCUL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK16           *((volatile unsigned int*)(0x425C01C0UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK17           *((volatile unsigned int*)(0x425C01C4UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK18           *((volatile unsigned int*)(0x425C01C8UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK19           *((volatile unsigned int*)(0x425C01CCUL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK20           *((volatile unsigned int*)(0x425C01D0UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK21           *((volatile unsigned int*)(0x425C01D4UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK22           *((volatile unsigned int*)(0x425C01D8UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK23           *((volatile unsigned int*)(0x425C01DCUL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK24           *((volatile unsigned int*)(0x425C01E0UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK25           *((volatile unsigned int*)(0x425C01E4UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK26           *((volatile unsigned int*)(0x425C01E8UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK27           *((volatile unsigned int*)(0x425C01ECUL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK28           *((volatile unsigned int*)(0x425C01F0UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK29           *((volatile unsigned int*)(0x425C01F4UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK30           *((volatile unsigned int*)(0x425C01F8UL))
#define bFM4_CRTRIM_MCR_RLR_TRMLCK31           *((volatile unsigned int*)(0x425C01FCUL))

/* External interrupt registers */
#define bFM4_EXTI_ENIR_EN0                     *((volatile unsigned char*)(0x42600000UL))
#define bFM4_EXTI_ENIR_EN1                     *((volatile unsigned char*)(0x42600004UL))
#define bFM4_EXTI_ENIR_EN2                     *((volatile unsigned char*)(0x42600008UL))
#define bFM4_EXTI_ENIR_EN3                     *((volatile unsigned char*)(0x4260000CUL))
#define bFM4_EXTI_ENIR_EN4                     *((volatile unsigned char*)(0x42600010UL))
#define bFM4_EXTI_ENIR_EN5                     *((volatile unsigned char*)(0x42600014UL))
#define bFM4_EXTI_ENIR_EN6                     *((volatile unsigned char*)(0x42600018UL))
#define bFM4_EXTI_ENIR_EN7                     *((volatile unsigned char*)(0x4260001CUL))
#define bFM4_EXTI_ENIR_EN8                     *((volatile unsigned char*)(0x42600020UL))
#define bFM4_EXTI_ENIR_EN9                     *((volatile unsigned char*)(0x42600024UL))
#define bFM4_EXTI_ENIR_EN10                    *((volatile unsigned char*)(0x42600028UL))
#define bFM4_EXTI_ENIR_EN11                    *((volatile unsigned char*)(0x4260002CUL))
#define bFM4_EXTI_ENIR_EN12                    *((volatile unsigned char*)(0x42600030UL))
#define bFM4_EXTI_ENIR_EN13                    *((volatile unsigned char*)(0x42600034UL))
#define bFM4_EXTI_ENIR_EN14                    *((volatile unsigned char*)(0x42600038UL))
#define bFM4_EXTI_ENIR_EN15                    *((volatile unsigned char*)(0x4260003CUL))
#define bFM4_EXTI_ENIR_EN16                    *((volatile unsigned char*)(0x42600040UL))
#define bFM4_EXTI_ENIR_EN17                    *((volatile unsigned char*)(0x42600044UL))
#define bFM4_EXTI_ENIR_EN18                    *((volatile unsigned char*)(0x42600048UL))
#define bFM4_EXTI_ENIR_EN19                    *((volatile unsigned char*)(0x4260004CUL))
#define bFM4_EXTI_ENIR_EN20                    *((volatile unsigned char*)(0x42600050UL))
#define bFM4_EXTI_ENIR_EN21                    *((volatile unsigned char*)(0x42600054UL))
#define bFM4_EXTI_ENIR_EN22                    *((volatile unsigned char*)(0x42600058UL))
#define bFM4_EXTI_ENIR_EN23                    *((volatile unsigned char*)(0x4260005CUL))
#define bFM4_EXTI_ENIR_EN24                    *((volatile unsigned char*)(0x42600060UL))
#define bFM4_EXTI_ENIR_EN25                    *((volatile unsigned char*)(0x42600064UL))
#define bFM4_EXTI_ENIR_EN26                    *((volatile unsigned char*)(0x42600068UL))
#define bFM4_EXTI_ENIR_EN27                    *((volatile unsigned char*)(0x4260006CUL))
#define bFM4_EXTI_ENIR_EN28                    *((volatile unsigned char*)(0x42600070UL))
#define bFM4_EXTI_ENIR_EN29                    *((volatile unsigned char*)(0x42600074UL))
#define bFM4_EXTI_ENIR_EN30                    *((volatile unsigned char*)(0x42600078UL))
#define bFM4_EXTI_ENIR_EN31                    *((volatile unsigned char*)(0x4260007CUL))
#define bFM4_EXTI_EIRR_ER0                     *((volatile unsigned char*)(0x42600080UL))
#define bFM4_EXTI_EIRR_ER1                     *((volatile unsigned char*)(0x42600084UL))
#define bFM4_EXTI_EIRR_ER2                     *((volatile unsigned char*)(0x42600088UL))
#define bFM4_EXTI_EIRR_ER3                     *((volatile unsigned char*)(0x4260008CUL))
#define bFM4_EXTI_EIRR_ER4                     *((volatile unsigned char*)(0x42600090UL))
#define bFM4_EXTI_EIRR_ER5                     *((volatile unsigned char*)(0x42600094UL))
#define bFM4_EXTI_EIRR_ER6                     *((volatile unsigned char*)(0x42600098UL))
#define bFM4_EXTI_EIRR_ER7                     *((volatile unsigned char*)(0x4260009CUL))
#define bFM4_EXTI_EIRR_ER8                     *((volatile unsigned char*)(0x426000A0UL))
#define bFM4_EXTI_EIRR_ER9                     *((volatile unsigned char*)(0x426000A4UL))
#define bFM4_EXTI_EIRR_ER10                    *((volatile unsigned char*)(0x426000A8UL))
#define bFM4_EXTI_EIRR_ER11                    *((volatile unsigned char*)(0x426000ACUL))
#define bFM4_EXTI_EIRR_ER12                    *((volatile unsigned char*)(0x426000B0UL))
#define bFM4_EXTI_EIRR_ER13                    *((volatile unsigned char*)(0x426000B4UL))
#define bFM4_EXTI_EIRR_ER14                    *((volatile unsigned char*)(0x426000B8UL))
#define bFM4_EXTI_EIRR_ER15                    *((volatile unsigned char*)(0x426000BCUL))
#define bFM4_EXTI_EIRR_ER16                    *((volatile unsigned char*)(0x426000C0UL))
#define bFM4_EXTI_EIRR_ER17                    *((volatile unsigned char*)(0x426000C4UL))
#define bFM4_EXTI_EIRR_ER18                    *((volatile unsigned char*)(0x426000C8UL))
#define bFM4_EXTI_EIRR_ER19                    *((volatile unsigned char*)(0x426000CCUL))
#define bFM4_EXTI_EIRR_ER20                    *((volatile unsigned char*)(0x426000D0UL))
#define bFM4_EXTI_EIRR_ER21                    *((volatile unsigned char*)(0x426000D4UL))
#define bFM4_EXTI_EIRR_ER22                    *((volatile unsigned char*)(0x426000D8UL))
#define bFM4_EXTI_EIRR_ER23                    *((volatile unsigned char*)(0x426000DCUL))
#define bFM4_EXTI_EIRR_ER24                    *((volatile unsigned char*)(0x426000E0UL))
#define bFM4_EXTI_EIRR_ER25                    *((volatile unsigned char*)(0x426000E4UL))
#define bFM4_EXTI_EIRR_ER26                    *((volatile unsigned char*)(0x426000E8UL))
#define bFM4_EXTI_EIRR_ER27                    *((volatile unsigned char*)(0x426000ECUL))
#define bFM4_EXTI_EIRR_ER28                    *((volatile unsigned char*)(0x426000F0UL))
#define bFM4_EXTI_EIRR_ER29                    *((volatile unsigned char*)(0x426000F4UL))
#define bFM4_EXTI_EIRR_ER30                    *((volatile unsigned char*)(0x426000F8UL))
#define bFM4_EXTI_EIRR_ER31                    *((volatile unsigned char*)(0x426000FCUL))
#define bFM4_EXTI_EICL_ECL0                    *((volatile unsigned char*)(0x42600100UL))
#define bFM4_EXTI_EICL_ECL1                    *((volatile unsigned char*)(0x42600104UL))
#define bFM4_EXTI_EICL_ECL2                    *((volatile unsigned char*)(0x42600108UL))
#define bFM4_EXTI_EICL_ECL3                    *((volatile unsigned char*)(0x4260010CUL))
#define bFM4_EXTI_EICL_ECL4                    *((volatile unsigned char*)(0x42600110UL))
#define bFM4_EXTI_EICL_ECL5                    *((volatile unsigned char*)(0x42600114UL))
#define bFM4_EXTI_EICL_ECL6                    *((volatile unsigned char*)(0x42600118UL))
#define bFM4_EXTI_EICL_ECL7                    *((volatile unsigned char*)(0x4260011CUL))
#define bFM4_EXTI_EICL_ECL8                    *((volatile unsigned char*)(0x42600120UL))
#define bFM4_EXTI_EICL_ECL9                    *((volatile unsigned char*)(0x42600124UL))
#define bFM4_EXTI_EICL_ECL10                   *((volatile unsigned char*)(0x42600128UL))
#define bFM4_EXTI_EICL_ECL11                   *((volatile unsigned char*)(0x4260012CUL))
#define bFM4_EXTI_EICL_ECL12                   *((volatile unsigned char*)(0x42600130UL))
#define bFM4_EXTI_EICL_ECL13                   *((volatile unsigned char*)(0x42600134UL))
#define bFM4_EXTI_EICL_ECL14                   *((volatile unsigned char*)(0x42600138UL))
#define bFM4_EXTI_EICL_ECL15                   *((volatile unsigned char*)(0x4260013CUL))
#define bFM4_EXTI_EICL_ECL16                   *((volatile unsigned char*)(0x42600140UL))
#define bFM4_EXTI_EICL_ECL17                   *((volatile unsigned char*)(0x42600144UL))
#define bFM4_EXTI_EICL_ECL18                   *((volatile unsigned char*)(0x42600148UL))
#define bFM4_EXTI_EICL_ECL19                   *((volatile unsigned char*)(0x4260014CUL))
#define bFM4_EXTI_EICL_ECL20                   *((volatile unsigned char*)(0x42600150UL))
#define bFM4_EXTI_EICL_ECL21                   *((volatile unsigned char*)(0x42600154UL))
#define bFM4_EXTI_EICL_ECL22                   *((volatile unsigned char*)(0x42600158UL))
#define bFM4_EXTI_EICL_ECL23                   *((volatile unsigned char*)(0x4260015CUL))
#define bFM4_EXTI_EICL_ECL24                   *((volatile unsigned char*)(0x42600160UL))
#define bFM4_EXTI_EICL_ECL25                   *((volatile unsigned char*)(0x42600164UL))
#define bFM4_EXTI_EICL_ECL26                   *((volatile unsigned char*)(0x42600168UL))
#define bFM4_EXTI_EICL_ECL27                   *((volatile unsigned char*)(0x4260016CUL))
#define bFM4_EXTI_EICL_ECL28                   *((volatile unsigned char*)(0x42600170UL))
#define bFM4_EXTI_EICL_ECL29                   *((volatile unsigned char*)(0x42600174UL))
#define bFM4_EXTI_EICL_ECL30                   *((volatile unsigned char*)(0x42600178UL))
#define bFM4_EXTI_EICL_ECL31                   *((volatile unsigned char*)(0x4260017CUL))
#define bFM4_EXTI_ELVR_LA0                     *((volatile unsigned char*)(0x42600180UL))
#define bFM4_EXTI_ELVR_LB0                     *((volatile unsigned char*)(0x42600184UL))
#define bFM4_EXTI_ELVR_LA1                     *((volatile unsigned char*)(0x42600188UL))
#define bFM4_EXTI_ELVR_LB1                     *((volatile unsigned char*)(0x4260018CUL))
#define bFM4_EXTI_ELVR_LA2                     *((volatile unsigned char*)(0x42600190UL))
#define bFM4_EXTI_ELVR_LB2                     *((volatile unsigned char*)(0x42600194UL))
#define bFM4_EXTI_ELVR_LA3                     *((volatile unsigned char*)(0x42600198UL))
#define bFM4_EXTI_ELVR_LB3                     *((volatile unsigned char*)(0x4260019CUL))
#define bFM4_EXTI_ELVR_LA4                     *((volatile unsigned char*)(0x426001A0UL))
#define bFM4_EXTI_ELVR_LB4                     *((volatile unsigned char*)(0x426001A4UL))
#define bFM4_EXTI_ELVR_LA5                     *((volatile unsigned char*)(0x426001A8UL))
#define bFM4_EXTI_ELVR_LB5                     *((volatile unsigned char*)(0x426001ACUL))
#define bFM4_EXTI_ELVR_LA6                     *((volatile unsigned char*)(0x426001B0UL))
#define bFM4_EXTI_ELVR_LB6                     *((volatile unsigned char*)(0x426001B4UL))
#define bFM4_EXTI_ELVR_LA7                     *((volatile unsigned char*)(0x426001B8UL))
#define bFM4_EXTI_ELVR_LB7                     *((volatile unsigned char*)(0x426001BCUL))
#define bFM4_EXTI_ELVR_LA8                     *((volatile unsigned char*)(0x426001C0UL))
#define bFM4_EXTI_ELVR_LB8                     *((volatile unsigned char*)(0x426001C4UL))
#define bFM4_EXTI_ELVR_LA9                     *((volatile unsigned char*)(0x426001C8UL))
#define bFM4_EXTI_ELVR_LB9                     *((volatile unsigned char*)(0x426001CCUL))
#define bFM4_EXTI_ELVR_LA10                    *((volatile unsigned char*)(0x426001D0UL))
#define bFM4_EXTI_ELVR_LB10                    *((volatile unsigned char*)(0x426001D4UL))
#define bFM4_EXTI_ELVR_LA11                    *((volatile unsigned char*)(0x426001D8UL))
#define bFM4_EXTI_ELVR_LB11                    *((volatile unsigned char*)(0x426001DCUL))
#define bFM4_EXTI_ELVR_LA12                    *((volatile unsigned char*)(0x426001E0UL))
#define bFM4_EXTI_ELVR_LB12                    *((volatile unsigned char*)(0x426001E4UL))
#define bFM4_EXTI_ELVR_LA13                    *((volatile unsigned char*)(0x426001E8UL))
#define bFM4_EXTI_ELVR_LB13                    *((volatile unsigned char*)(0x426001ECUL))
#define bFM4_EXTI_ELVR_LA14                    *((volatile unsigned char*)(0x426001F0UL))
#define bFM4_EXTI_ELVR_LB14                    *((volatile unsigned char*)(0x426001F4UL))
#define bFM4_EXTI_ELVR_LA15                    *((volatile unsigned char*)(0x426001F8UL))
#define bFM4_EXTI_ELVR_LB15                    *((volatile unsigned char*)(0x426001FCUL))
#define bFM4_EXTI_ELVR1_LA16                   *((volatile unsigned char*)(0x42600200UL))
#define bFM4_EXTI_ELVR1_LB16                   *((volatile unsigned char*)(0x42600204UL))
#define bFM4_EXTI_ELVR1_LA17                   *((volatile unsigned char*)(0x42600208UL))
#define bFM4_EXTI_ELVR1_LB17                   *((volatile unsigned char*)(0x4260020CUL))
#define bFM4_EXTI_ELVR1_LA18                   *((volatile unsigned char*)(0x42600210UL))
#define bFM4_EXTI_ELVR1_LB18                   *((volatile unsigned char*)(0x42600214UL))
#define bFM4_EXTI_ELVR1_LA19                   *((volatile unsigned char*)(0x42600218UL))
#define bFM4_EXTI_ELVR1_LB19                   *((volatile unsigned char*)(0x4260021CUL))
#define bFM4_EXTI_ELVR1_LA20                   *((volatile unsigned char*)(0x42600220UL))
#define bFM4_EXTI_ELVR1_LB20                   *((volatile unsigned char*)(0x42600224UL))
#define bFM4_EXTI_ELVR1_LA21                   *((volatile unsigned char*)(0x42600228UL))
#define bFM4_EXTI_ELVR1_LB21                   *((volatile unsigned char*)(0x4260022CUL))
#define bFM4_EXTI_ELVR1_LA22                   *((volatile unsigned char*)(0x42600230UL))
#define bFM4_EXTI_ELVR1_LB22                   *((volatile unsigned char*)(0x42600234UL))
#define bFM4_EXTI_ELVR1_LA23                   *((volatile unsigned char*)(0x42600238UL))
#define bFM4_EXTI_ELVR1_LB23                   *((volatile unsigned char*)(0x4260023CUL))
#define bFM4_EXTI_ELVR1_LA24                   *((volatile unsigned char*)(0x42600240UL))
#define bFM4_EXTI_ELVR1_LB24                   *((volatile unsigned char*)(0x42600244UL))
#define bFM4_EXTI_ELVR1_LA25                   *((volatile unsigned char*)(0x42600248UL))
#define bFM4_EXTI_ELVR1_LB25                   *((volatile unsigned char*)(0x4260024CUL))
#define bFM4_EXTI_ELVR1_LA26                   *((volatile unsigned char*)(0x42600250UL))
#define bFM4_EXTI_ELVR1_LB26                   *((volatile unsigned char*)(0x42600254UL))
#define bFM4_EXTI_ELVR1_LA27                   *((volatile unsigned char*)(0x42600258UL))
#define bFM4_EXTI_ELVR1_LB27                   *((volatile unsigned char*)(0x4260025CUL))
#define bFM4_EXTI_ELVR1_LA28                   *((volatile unsigned char*)(0x42600260UL))
#define bFM4_EXTI_ELVR1_LB28                   *((volatile unsigned char*)(0x42600264UL))
#define bFM4_EXTI_ELVR1_LA29                   *((volatile unsigned char*)(0x42600268UL))
#define bFM4_EXTI_ELVR1_LB29                   *((volatile unsigned char*)(0x4260026CUL))
#define bFM4_EXTI_ELVR1_LA30                   *((volatile unsigned char*)(0x42600270UL))
#define bFM4_EXTI_ELVR1_LB30                   *((volatile unsigned char*)(0x42600274UL))
#define bFM4_EXTI_ELVR1_LA31                   *((volatile unsigned char*)(0x42600278UL))
#define bFM4_EXTI_ELVR1_LB31                   *((volatile unsigned char*)(0x4260027CUL))
#define bFM4_EXTI_NMIRR_NR                     *((volatile unsigned char*)(0x42600280UL))
#define bFM4_EXTI_NMICL_NCL                    *((volatile unsigned char*)(0x42600300UL))

/* Interrupt request read registers */
#define bFM4_INTREQ_DRQSEL_USBEP1              *((volatile unsigned char*)(0x42620000UL))
#define bFM4_INTREQ_DRQSEL_USBEP2              *((volatile unsigned char*)(0x42620004UL))
#define bFM4_INTREQ_DRQSEL_USBEP3              *((volatile unsigned char*)(0x42620008UL))
#define bFM4_INTREQ_DRQSEL_USBEP4              *((volatile unsigned char*)(0x4262000CUL))
#define bFM4_INTREQ_DRQSEL_USBEP5              *((volatile unsigned char*)(0x42620010UL))
#define bFM4_INTREQ_DRQSEL_ADCSCAN0            *((volatile unsigned char*)(0x42620014UL))
#define bFM4_INTREQ_DRQSEL_ADCSCAN1            *((volatile unsigned char*)(0x42620018UL))
#define bFM4_INTREQ_DRQSEL_ADCSCAN2            *((volatile unsigned char*)(0x4262001CUL))
#define bFM4_INTREQ_DRQSEL_IRQ0BT0             *((volatile unsigned char*)(0x42620020UL))
#define bFM4_INTREQ_DRQSEL_IRQ0BT2             *((volatile unsigned char*)(0x42620024UL))
#define bFM4_INTREQ_DRQSEL_IRQ0BT4             *((volatile unsigned char*)(0x42620028UL))
#define bFM4_INTREQ_DRQSEL_IRQ0BT6             *((volatile unsigned char*)(0x4262002CUL))
#define bFM4_INTREQ_DRQSEL_MFS0RX              *((volatile unsigned char*)(0x42620030UL))
#define bFM4_INTREQ_DRQSEL_MFS0TX              *((volatile unsigned char*)(0x42620034UL))
#define bFM4_INTREQ_DRQSEL_MFS1RX              *((volatile unsigned char*)(0x42620038UL))
#define bFM4_INTREQ_DRQSEL_MFS1TX              *((volatile unsigned char*)(0x4262003CUL))
#define bFM4_INTREQ_DRQSEL_MFS2RX              *((volatile unsigned char*)(0x42620040UL))
#define bFM4_INTREQ_DRQSEL_MFS2TX              *((volatile unsigned char*)(0x42620044UL))
#define bFM4_INTREQ_DRQSEL_MFS3RX              *((volatile unsigned char*)(0x42620048UL))
#define bFM4_INTREQ_DRQSEL_MFS3TX              *((volatile unsigned char*)(0x4262004CUL))
#define bFM4_INTREQ_DRQSEL_MFS4RX              *((volatile unsigned char*)(0x42620050UL))
#define bFM4_INTREQ_DRQSEL_MFS4TX              *((volatile unsigned char*)(0x42620054UL))
#define bFM4_INTREQ_DRQSEL_MFS5RX              *((volatile unsigned char*)(0x42620058UL))
#define bFM4_INTREQ_DRQSEL_MFS5TX              *((volatile unsigned char*)(0x4262005CUL))
#define bFM4_INTREQ_DRQSEL_MFS6RX              *((volatile unsigned char*)(0x42620060UL))
#define bFM4_INTREQ_DRQSEL_MFS6TX              *((volatile unsigned char*)(0x42620064UL))
#define bFM4_INTREQ_DRQSEL_MFS7RX              *((volatile unsigned char*)(0x42620068UL))
#define bFM4_INTREQ_DRQSEL_MFS7TX              *((volatile unsigned char*)(0x4262006CUL))
#define bFM4_INTREQ_DRQSEL_EXINT0              *((volatile unsigned char*)(0x42620070UL))
#define bFM4_INTREQ_DRQSEL_EXINT1              *((volatile unsigned char*)(0x42620074UL))
#define bFM4_INTREQ_DRQSEL_EXINT2              *((volatile unsigned char*)(0x42620078UL))
#define bFM4_INTREQ_DRQSEL_EXINT3              *((volatile unsigned char*)(0x4262007CUL))
#define bFM4_INTREQ_ODDPKS_ODDPKS0             *((volatile unsigned char*)(0x42620200UL))
#define bFM4_INTREQ_ODDPKS_ODDPKS1             *((volatile unsigned char*)(0x42620204UL))
#define bFM4_INTREQ_ODDPKS_ODDPKS2             *((volatile unsigned char*)(0x42620208UL))
#define bFM4_INTREQ_ODDPKS_ODDPKS3             *((volatile unsigned char*)(0x4262020CUL))
#define bFM4_INTREQ_ODDPKS_ODDPKS4             *((volatile unsigned char*)(0x42620210UL))
#define bFM4_INTREQ_ODDPKS1_ODDPKS10           *((volatile unsigned char*)(0x42620280UL))
#define bFM4_INTREQ_ODDPKS1_ODDPKS11           *((volatile unsigned char*)(0x42620284UL))
#define bFM4_INTREQ_ODDPKS1_ODDPKS12           *((volatile unsigned char*)(0x42620288UL))
#define bFM4_INTREQ_ODDPKS1_ODDPKS13           *((volatile unsigned char*)(0x4262028CUL))
#define bFM4_INTREQ_ODDPKS1_ODDPKS14           *((volatile unsigned char*)(0x42620290UL))
#define bFM4_INTREQ_IRQ003SEL_SELIRQ0          *((volatile unsigned char*)(0x42622200UL))
#define bFM4_INTREQ_IRQ003SEL_SELIRQ1          *((volatile unsigned char*)(0x42622204UL))
#define bFM4_INTREQ_IRQ003SEL_SELIRQ2          *((volatile unsigned char*)(0x42622208UL))
#define bFM4_INTREQ_IRQ003SEL_SELIRQ3          *((volatile unsigned char*)(0x4262220CUL))
#define bFM4_INTREQ_IRQ003SEL_SELIRQ4          *((volatile unsigned char*)(0x42622210UL))
#define bFM4_INTREQ_IRQ003SEL_SELIRQ5          *((volatile unsigned char*)(0x42622214UL))
#define bFM4_INTREQ_IRQ003SEL_SELIRQ6          *((volatile unsigned char*)(0x42622218UL))
#define bFM4_INTREQ_IRQ003SEL_SELIRQ7          *((volatile unsigned char*)(0x4262221CUL))
#define bFM4_INTREQ_IRQ003SEL_SELBIT0          *((volatile unsigned char*)(0x42622240UL))
#define bFM4_INTREQ_IRQ003SEL_SELBIT1          *((volatile unsigned char*)(0x42622244UL))
#define bFM4_INTREQ_IRQ003SEL_SELBIT2          *((volatile unsigned char*)(0x42622248UL))
#define bFM4_INTREQ_IRQ003SEL_SELBIT3          *((volatile unsigned char*)(0x4262224CUL))
#define bFM4_INTREQ_IRQ003SEL_SELBIT4          *((volatile unsigned char*)(0x42622250UL))
#define bFM4_INTREQ_IRQ003SEL_SELBIT5          *((volatile unsigned char*)(0x42622254UL))
#define bFM4_INTREQ_IRQ003SEL_SELBIT6          *((volatile unsigned char*)(0x42622258UL))
#define bFM4_INTREQ_IRQ003SEL_SELBIT7          *((volatile unsigned char*)(0x4262225CUL))
#define bFM4_INTREQ_IRQ004SEL_SELIRQ0          *((volatile unsigned char*)(0x42622280UL))
#define bFM4_INTREQ_IRQ004SEL_SELIRQ1          *((volatile unsigned char*)(0x42622284UL))
#define bFM4_INTREQ_IRQ004SEL_SELIRQ2          *((volatile unsigned char*)(0x42622288UL))
#define bFM4_INTREQ_IRQ004SEL_SELIRQ3          *((volatile unsigned char*)(0x4262228CUL))
#define bFM4_INTREQ_IRQ004SEL_SELIRQ4          *((volatile unsigned char*)(0x42622290UL))
#define bFM4_INTREQ_IRQ004SEL_SELIRQ5          *((volatile unsigned char*)(0x42622294UL))
#define bFM4_INTREQ_IRQ004SEL_SELIRQ6          *((volatile unsigned char*)(0x42622298UL))
#define bFM4_INTREQ_IRQ004SEL_SELIRQ7          *((volatile unsigned char*)(0x4262229CUL))
#define bFM4_INTREQ_IRQ004SEL_SELBIT0          *((volatile unsigned char*)(0x426222C0UL))
#define bFM4_INTREQ_IRQ004SEL_SELBIT1          *((volatile unsigned char*)(0x426222C4UL))
#define bFM4_INTREQ_IRQ004SEL_SELBIT2          *((volatile unsigned char*)(0x426222C8UL))
#define bFM4_INTREQ_IRQ004SEL_SELBIT3          *((volatile unsigned char*)(0x426222CCUL))
#define bFM4_INTREQ_IRQ004SEL_SELBIT4          *((volatile unsigned char*)(0x426222D0UL))
#define bFM4_INTREQ_IRQ004SEL_SELBIT5          *((volatile unsigned char*)(0x426222D4UL))
#define bFM4_INTREQ_IRQ004SEL_SELBIT6          *((volatile unsigned char*)(0x426222D8UL))
#define bFM4_INTREQ_IRQ004SEL_SELBIT7          *((volatile unsigned char*)(0x426222DCUL))
#define bFM4_INTREQ_IRQ005SEL_SELIRQ0          *((volatile unsigned char*)(0x42622300UL))
#define bFM4_INTREQ_IRQ005SEL_SELIRQ1          *((volatile unsigned char*)(0x42622304UL))
#define bFM4_INTREQ_IRQ005SEL_SELIRQ2          *((volatile unsigned char*)(0x42622308UL))
#define bFM4_INTREQ_IRQ005SEL_SELIRQ3          *((volatile unsigned char*)(0x4262230CUL))
#define bFM4_INTREQ_IRQ005SEL_SELIRQ4          *((volatile unsigned char*)(0x42622310UL))
#define bFM4_INTREQ_IRQ005SEL_SELIRQ5          *((volatile unsigned char*)(0x42622314UL))
#define bFM4_INTREQ_IRQ005SEL_SELIRQ6          *((volatile unsigned char*)(0x42622318UL))
#define bFM4_INTREQ_IRQ005SEL_SELIRQ7          *((volatile unsigned char*)(0x4262231CUL))
#define bFM4_INTREQ_IRQ005SEL_SELBIT0          *((volatile unsigned char*)(0x42622340UL))
#define bFM4_INTREQ_IRQ005SEL_SELBIT1          *((volatile unsigned char*)(0x42622344UL))
#define bFM4_INTREQ_IRQ005SEL_SELBIT2          *((volatile unsigned char*)(0x42622348UL))
#define bFM4_INTREQ_IRQ005SEL_SELBIT3          *((volatile unsigned char*)(0x4262234CUL))
#define bFM4_INTREQ_IRQ005SEL_SELBIT4          *((volatile unsigned char*)(0x42622350UL))
#define bFM4_INTREQ_IRQ005SEL_SELBIT5          *((volatile unsigned char*)(0x42622354UL))
#define bFM4_INTREQ_IRQ005SEL_SELBIT6          *((volatile unsigned char*)(0x42622358UL))
#define bFM4_INTREQ_IRQ005SEL_SELBIT7          *((volatile unsigned char*)(0x4262235CUL))
#define bFM4_INTREQ_IRQ006SEL_SELIRQ0          *((volatile unsigned char*)(0x42622380UL))
#define bFM4_INTREQ_IRQ006SEL_SELIRQ1          *((volatile unsigned char*)(0x42622384UL))
#define bFM4_INTREQ_IRQ006SEL_SELIRQ2          *((volatile unsigned char*)(0x42622388UL))
#define bFM4_INTREQ_IRQ006SEL_SELIRQ3          *((volatile unsigned char*)(0x4262238CUL))
#define bFM4_INTREQ_IRQ006SEL_SELIRQ4          *((volatile unsigned char*)(0x42622390UL))
#define bFM4_INTREQ_IRQ006SEL_SELIRQ5          *((volatile unsigned char*)(0x42622394UL))
#define bFM4_INTREQ_IRQ006SEL_SELIRQ6          *((volatile unsigned char*)(0x42622398UL))
#define bFM4_INTREQ_IRQ006SEL_SELIRQ7          *((volatile unsigned char*)(0x4262239CUL))
#define bFM4_INTREQ_IRQ006SEL_SELBIT0          *((volatile unsigned char*)(0x426223C0UL))
#define bFM4_INTREQ_IRQ006SEL_SELBIT1          *((volatile unsigned char*)(0x426223C4UL))
#define bFM4_INTREQ_IRQ006SEL_SELBIT2          *((volatile unsigned char*)(0x426223C8UL))
#define bFM4_INTREQ_IRQ006SEL_SELBIT3          *((volatile unsigned char*)(0x426223CCUL))
#define bFM4_INTREQ_IRQ006SEL_SELBIT4          *((volatile unsigned char*)(0x426223D0UL))
#define bFM4_INTREQ_IRQ006SEL_SELBIT5          *((volatile unsigned char*)(0x426223D4UL))
#define bFM4_INTREQ_IRQ006SEL_SELBIT6          *((volatile unsigned char*)(0x426223D8UL))
#define bFM4_INTREQ_IRQ006SEL_SELBIT7          *((volatile unsigned char*)(0x426223DCUL))
#define bFM4_INTREQ_IRQ007SEL_SELIRQ0          *((volatile unsigned char*)(0x42622400UL))
#define bFM4_INTREQ_IRQ007SEL_SELIRQ1          *((volatile unsigned char*)(0x42622404UL))
#define bFM4_INTREQ_IRQ007SEL_SELIRQ2          *((volatile unsigned char*)(0x42622408UL))
#define bFM4_INTREQ_IRQ007SEL_SELIRQ3          *((volatile unsigned char*)(0x4262240CUL))
#define bFM4_INTREQ_IRQ007SEL_SELIRQ4          *((volatile unsigned char*)(0x42622410UL))
#define bFM4_INTREQ_IRQ007SEL_SELIRQ5          *((volatile unsigned char*)(0x42622414UL))
#define bFM4_INTREQ_IRQ007SEL_SELIRQ6          *((volatile unsigned char*)(0x42622418UL))
#define bFM4_INTREQ_IRQ007SEL_SELIRQ7          *((volatile unsigned char*)(0x4262241CUL))
#define bFM4_INTREQ_IRQ007SEL_SELBIT0          *((volatile unsigned char*)(0x42622440UL))
#define bFM4_INTREQ_IRQ007SEL_SELBIT1          *((volatile unsigned char*)(0x42622444UL))
#define bFM4_INTREQ_IRQ007SEL_SELBIT2          *((volatile unsigned char*)(0x42622448UL))
#define bFM4_INTREQ_IRQ007SEL_SELBIT3          *((volatile unsigned char*)(0x4262244CUL))
#define bFM4_INTREQ_IRQ007SEL_SELBIT4          *((volatile unsigned char*)(0x42622450UL))
#define bFM4_INTREQ_IRQ007SEL_SELBIT5          *((volatile unsigned char*)(0x42622454UL))
#define bFM4_INTREQ_IRQ007SEL_SELBIT6          *((volatile unsigned char*)(0x42622458UL))
#define bFM4_INTREQ_IRQ007SEL_SELBIT7          *((volatile unsigned char*)(0x4262245CUL))
#define bFM4_INTREQ_IRQ008SEL_SELIRQ0          *((volatile unsigned char*)(0x42622480UL))
#define bFM4_INTREQ_IRQ008SEL_SELIRQ1          *((volatile unsigned char*)(0x42622484UL))
#define bFM4_INTREQ_IRQ008SEL_SELIRQ2          *((volatile unsigned char*)(0x42622488UL))
#define bFM4_INTREQ_IRQ008SEL_SELIRQ3          *((volatile unsigned char*)(0x4262248CUL))
#define bFM4_INTREQ_IRQ008SEL_SELIRQ4          *((volatile unsigned char*)(0x42622490UL))
#define bFM4_INTREQ_IRQ008SEL_SELIRQ5          *((volatile unsigned char*)(0x42622494UL))
#define bFM4_INTREQ_IRQ008SEL_SELIRQ6          *((volatile unsigned char*)(0x42622498UL))
#define bFM4_INTREQ_IRQ008SEL_SELIRQ7          *((volatile unsigned char*)(0x4262249CUL))
#define bFM4_INTREQ_IRQ008SEL_SELBIT0          *((volatile unsigned char*)(0x426224C0UL))
#define bFM4_INTREQ_IRQ008SEL_SELBIT1          *((volatile unsigned char*)(0x426224C4UL))
#define bFM4_INTREQ_IRQ008SEL_SELBIT2          *((volatile unsigned char*)(0x426224C8UL))
#define bFM4_INTREQ_IRQ008SEL_SELBIT3          *((volatile unsigned char*)(0x426224CCUL))
#define bFM4_INTREQ_IRQ008SEL_SELBIT4          *((volatile unsigned char*)(0x426224D0UL))
#define bFM4_INTREQ_IRQ008SEL_SELBIT5          *((volatile unsigned char*)(0x426224D4UL))
#define bFM4_INTREQ_IRQ008SEL_SELBIT6          *((volatile unsigned char*)(0x426224D8UL))
#define bFM4_INTREQ_IRQ008SEL_SELBIT7          *((volatile unsigned char*)(0x426224DCUL))
#define bFM4_INTREQ_IRQ009SEL_SELIRQ0          *((volatile unsigned char*)(0x42622500UL))
#define bFM4_INTREQ_IRQ009SEL_SELIRQ1          *((volatile unsigned char*)(0x42622504UL))
#define bFM4_INTREQ_IRQ009SEL_SELIRQ2          *((volatile unsigned char*)(0x42622508UL))
#define bFM4_INTREQ_IRQ009SEL_SELIRQ3          *((volatile unsigned char*)(0x4262250CUL))
#define bFM4_INTREQ_IRQ009SEL_SELIRQ4          *((volatile unsigned char*)(0x42622510UL))
#define bFM4_INTREQ_IRQ009SEL_SELIRQ5          *((volatile unsigned char*)(0x42622514UL))
#define bFM4_INTREQ_IRQ009SEL_SELIRQ6          *((volatile unsigned char*)(0x42622518UL))
#define bFM4_INTREQ_IRQ009SEL_SELIRQ7          *((volatile unsigned char*)(0x4262251CUL))
#define bFM4_INTREQ_IRQ009SEL_SELBIT0          *((volatile unsigned char*)(0x42622540UL))
#define bFM4_INTREQ_IRQ009SEL_SELBIT1          *((volatile unsigned char*)(0x42622544UL))
#define bFM4_INTREQ_IRQ009SEL_SELBIT2          *((volatile unsigned char*)(0x42622548UL))
#define bFM4_INTREQ_IRQ009SEL_SELBIT3          *((volatile unsigned char*)(0x4262254CUL))
#define bFM4_INTREQ_IRQ009SEL_SELBIT4          *((volatile unsigned char*)(0x42622550UL))
#define bFM4_INTREQ_IRQ009SEL_SELBIT5          *((volatile unsigned char*)(0x42622554UL))
#define bFM4_INTREQ_IRQ009SEL_SELBIT6          *((volatile unsigned char*)(0x42622558UL))
#define bFM4_INTREQ_IRQ009SEL_SELBIT7          *((volatile unsigned char*)(0x4262255CUL))
#define bFM4_INTREQ_IRQ010SEL_SELIRQ0          *((volatile unsigned char*)(0x42622580UL))
#define bFM4_INTREQ_IRQ010SEL_SELIRQ1          *((volatile unsigned char*)(0x42622584UL))
#define bFM4_INTREQ_IRQ010SEL_SELIRQ2          *((volatile unsigned char*)(0x42622588UL))
#define bFM4_INTREQ_IRQ010SEL_SELIRQ3          *((volatile unsigned char*)(0x4262258CUL))
#define bFM4_INTREQ_IRQ010SEL_SELIRQ4          *((volatile unsigned char*)(0x42622590UL))
#define bFM4_INTREQ_IRQ010SEL_SELIRQ5          *((volatile unsigned char*)(0x42622594UL))
#define bFM4_INTREQ_IRQ010SEL_SELIRQ6          *((volatile unsigned char*)(0x42622598UL))
#define bFM4_INTREQ_IRQ010SEL_SELIRQ7          *((volatile unsigned char*)(0x4262259CUL))
#define bFM4_INTREQ_IRQ010SEL_SELBIT0          *((volatile unsigned char*)(0x426225C0UL))
#define bFM4_INTREQ_IRQ010SEL_SELBIT1          *((volatile unsigned char*)(0x426225C4UL))
#define bFM4_INTREQ_IRQ010SEL_SELBIT2          *((volatile unsigned char*)(0x426225C8UL))
#define bFM4_INTREQ_IRQ010SEL_SELBIT3          *((volatile unsigned char*)(0x426225CCUL))
#define bFM4_INTREQ_IRQ010SEL_SELBIT4          *((volatile unsigned char*)(0x426225D0UL))
#define bFM4_INTREQ_IRQ010SEL_SELBIT5          *((volatile unsigned char*)(0x426225D4UL))
#define bFM4_INTREQ_IRQ010SEL_SELBIT6          *((volatile unsigned char*)(0x426225D8UL))
#define bFM4_INTREQ_IRQ010SEL_SELBIT7          *((volatile unsigned char*)(0x426225DCUL))
#define bFM4_INTREQ_EXC02MON_NMI               *((volatile unsigned char*)(0x42624000UL))
#define bFM4_INTREQ_EXC02MON_HWINT             *((volatile unsigned char*)(0x42624004UL))
#define bFM4_INTREQ_IRQ000MON_FCSINT           *((volatile unsigned char*)(0x42624080UL))
#define bFM4_INTREQ_IRQ001MON_SWWDTINT         *((volatile unsigned char*)(0x42624100UL))
#define bFM4_INTREQ_IRQ002MON_LVDINT           *((volatile unsigned char*)(0x42624180UL))
#define bFM4_INTREQ_IRQ003MON_IRQBIT0          *((volatile unsigned char*)(0x42624200UL))
#define bFM4_INTREQ_IRQ003MON_IRQBIT1          *((volatile unsigned char*)(0x42624204UL))
#define bFM4_INTREQ_IRQ003MON_IRQBIT2          *((volatile unsigned char*)(0x42624208UL))
#define bFM4_INTREQ_IRQ003MON_IRQBIT3          *((volatile unsigned char*)(0x4262420CUL))
#define bFM4_INTREQ_IRQ003MON_IRQBIT4          *((volatile unsigned char*)(0x42624210UL))
#define bFM4_INTREQ_IRQ003MON_IRQBIT5          *((volatile unsigned char*)(0x42624214UL))
#define bFM4_INTREQ_IRQ003MON_IRQBIT6          *((volatile unsigned char*)(0x42624218UL))
#define bFM4_INTREQ_IRQ003MON_IRQBIT7          *((volatile unsigned char*)(0x4262421CUL))
#define bFM4_INTREQ_IRQ004MON_IRQBIT0          *((volatile unsigned char*)(0x42624280UL))
#define bFM4_INTREQ_IRQ004MON_IRQBIT1          *((volatile unsigned char*)(0x42624284UL))
#define bFM4_INTREQ_IRQ004MON_IRQBIT2          *((volatile unsigned char*)(0x42624288UL))
#define bFM4_INTREQ_IRQ004MON_IRQBIT3          *((volatile unsigned char*)(0x4262428CUL))
#define bFM4_INTREQ_IRQ004MON_IRQBIT4          *((volatile unsigned char*)(0x42624290UL))
#define bFM4_INTREQ_IRQ004MON_IRQBIT5          *((volatile unsigned char*)(0x42624294UL))
#define bFM4_INTREQ_IRQ004MON_IRQBIT6          *((volatile unsigned char*)(0x42624298UL))
#define bFM4_INTREQ_IRQ004MON_IRQBIT7          *((volatile unsigned char*)(0x4262429CUL))
#define bFM4_INTREQ_IRQ005MON_IRQBIT0          *((volatile unsigned char*)(0x42624300UL))
#define bFM4_INTREQ_IRQ005MON_IRQBIT1          *((volatile unsigned char*)(0x42624304UL))
#define bFM4_INTREQ_IRQ005MON_IRQBIT2          *((volatile unsigned char*)(0x42624308UL))
#define bFM4_INTREQ_IRQ005MON_IRQBIT3          *((volatile unsigned char*)(0x4262430CUL))
#define bFM4_INTREQ_IRQ005MON_IRQBIT4          *((volatile unsigned char*)(0x42624310UL))
#define bFM4_INTREQ_IRQ005MON_IRQBIT5          *((volatile unsigned char*)(0x42624314UL))
#define bFM4_INTREQ_IRQ005MON_IRQBIT6          *((volatile unsigned char*)(0x42624318UL))
#define bFM4_INTREQ_IRQ005MON_IRQBIT7          *((volatile unsigned char*)(0x4262431CUL))
#define bFM4_INTREQ_IRQ006MON_IRQBIT0          *((volatile unsigned char*)(0x42624380UL))
#define bFM4_INTREQ_IRQ006MON_IRQBIT1          *((volatile unsigned char*)(0x42624384UL))
#define bFM4_INTREQ_IRQ006MON_IRQBIT2          *((volatile unsigned char*)(0x42624388UL))
#define bFM4_INTREQ_IRQ006MON_IRQBIT3          *((volatile unsigned char*)(0x4262438CUL))
#define bFM4_INTREQ_IRQ006MON_IRQBIT4          *((volatile unsigned char*)(0x42624390UL))
#define bFM4_INTREQ_IRQ006MON_IRQBIT5          *((volatile unsigned char*)(0x42624394UL))
#define bFM4_INTREQ_IRQ006MON_IRQBIT6          *((volatile unsigned char*)(0x42624398UL))
#define bFM4_INTREQ_IRQ006MON_IRQBIT7          *((volatile unsigned char*)(0x4262439CUL))
#define bFM4_INTREQ_IRQ007MON_IRQBIT0          *((volatile unsigned char*)(0x42624400UL))
#define bFM4_INTREQ_IRQ007MON_IRQBIT1          *((volatile unsigned char*)(0x42624404UL))
#define bFM4_INTREQ_IRQ007MON_IRQBIT2          *((volatile unsigned char*)(0x42624408UL))
#define bFM4_INTREQ_IRQ007MON_IRQBIT3          *((volatile unsigned char*)(0x4262440CUL))
#define bFM4_INTREQ_IRQ007MON_IRQBIT4          *((volatile unsigned char*)(0x42624410UL))
#define bFM4_INTREQ_IRQ007MON_IRQBIT5          *((volatile unsigned char*)(0x42624414UL))
#define bFM4_INTREQ_IRQ007MON_IRQBIT6          *((volatile unsigned char*)(0x42624418UL))
#define bFM4_INTREQ_IRQ007MON_IRQBIT7          *((volatile unsigned char*)(0x4262441CUL))
#define bFM4_INTREQ_IRQ008MON_IRQBIT0          *((volatile unsigned char*)(0x42624480UL))
#define bFM4_INTREQ_IRQ008MON_IRQBIT1          *((volatile unsigned char*)(0x42624484UL))
#define bFM4_INTREQ_IRQ008MON_IRQBIT2          *((volatile unsigned char*)(0x42624488UL))
#define bFM4_INTREQ_IRQ008MON_IRQBIT3          *((volatile unsigned char*)(0x4262448CUL))
#define bFM4_INTREQ_IRQ008MON_IRQBIT4          *((volatile unsigned char*)(0x42624490UL))
#define bFM4_INTREQ_IRQ008MON_IRQBIT5          *((volatile unsigned char*)(0x42624494UL))
#define bFM4_INTREQ_IRQ008MON_IRQBIT6          *((volatile unsigned char*)(0x42624498UL))
#define bFM4_INTREQ_IRQ008MON_IRQBIT7          *((volatile unsigned char*)(0x4262449CUL))
#define bFM4_INTREQ_IRQ009MON_IRQBIT0          *((volatile unsigned char*)(0x42624500UL))
#define bFM4_INTREQ_IRQ009MON_IRQBIT1          *((volatile unsigned char*)(0x42624504UL))
#define bFM4_INTREQ_IRQ009MON_IRQBIT2          *((volatile unsigned char*)(0x42624508UL))
#define bFM4_INTREQ_IRQ009MON_IRQBIT3          *((volatile unsigned char*)(0x4262450CUL))
#define bFM4_INTREQ_IRQ009MON_IRQBIT4          *((volatile unsigned char*)(0x42624510UL))
#define bFM4_INTREQ_IRQ009MON_IRQBIT5          *((volatile unsigned char*)(0x42624514UL))
#define bFM4_INTREQ_IRQ009MON_IRQBIT6          *((volatile unsigned char*)(0x42624518UL))
#define bFM4_INTREQ_IRQ009MON_IRQBIT7          *((volatile unsigned char*)(0x4262451CUL))
#define bFM4_INTREQ_IRQ010MON_IRQBIT0          *((volatile unsigned char*)(0x42624580UL))
#define bFM4_INTREQ_IRQ010MON_IRQBIT1          *((volatile unsigned char*)(0x42624584UL))
#define bFM4_INTREQ_IRQ010MON_IRQBIT2          *((volatile unsigned char*)(0x42624588UL))
#define bFM4_INTREQ_IRQ010MON_IRQBIT3          *((volatile unsigned char*)(0x4262458CUL))
#define bFM4_INTREQ_IRQ010MON_IRQBIT4          *((volatile unsigned char*)(0x42624590UL))
#define bFM4_INTREQ_IRQ010MON_IRQBIT5          *((volatile unsigned char*)(0x42624594UL))
#define bFM4_INTREQ_IRQ010MON_IRQBIT6          *((volatile unsigned char*)(0x42624598UL))
#define bFM4_INTREQ_IRQ010MON_IRQBIT7          *((volatile unsigned char*)(0x4262459CUL))
#define bFM4_INTREQ_IRQ011MON_EXTINT           *((volatile unsigned char*)(0x42624600UL))
#define bFM4_INTREQ_IRQ012MON_EXTINT           *((volatile unsigned char*)(0x42624680UL))
#define bFM4_INTREQ_IRQ013MON_EXTINT           *((volatile unsigned char*)(0x42624700UL))
#define bFM4_INTREQ_IRQ014MON_EXTINT           *((volatile unsigned char*)(0x42624780UL))
#define bFM4_INTREQ_IRQ015MON_EXTINT           *((volatile unsigned char*)(0x42624800UL))
#define bFM4_INTREQ_IRQ016MON_EXTINT           *((volatile unsigned char*)(0x42624880UL))
#define bFM4_INTREQ_IRQ017MON_EXTINT           *((volatile unsigned char*)(0x42624900UL))
#define bFM4_INTREQ_IRQ018MON_EXTINT           *((volatile unsigned char*)(0x42624980UL))
#define bFM4_INTREQ_IRQ019MON_QUDINT0          *((volatile unsigned char*)(0x42624A00UL))
#define bFM4_INTREQ_IRQ019MON_QUDINT1          *((volatile unsigned char*)(0x42624A04UL))
#define bFM4_INTREQ_IRQ019MON_QUDINT2          *((volatile unsigned char*)(0x42624A08UL))
#define bFM4_INTREQ_IRQ019MON_QUDINT3          *((volatile unsigned char*)(0x42624A0CUL))
#define bFM4_INTREQ_IRQ019MON_QUDINT4          *((volatile unsigned char*)(0x42624A10UL))
#define bFM4_INTREQ_IRQ019MON_QUDINT5          *((volatile unsigned char*)(0x42624A14UL))
#define bFM4_INTREQ_IRQ020MON_QUDINT0          *((volatile unsigned char*)(0x42624A80UL))
#define bFM4_INTREQ_IRQ020MON_QUDINT1          *((volatile unsigned char*)(0x42624A84UL))
#define bFM4_INTREQ_IRQ020MON_QUDINT2          *((volatile unsigned char*)(0x42624A88UL))
#define bFM4_INTREQ_IRQ020MON_QUDINT3          *((volatile unsigned char*)(0x42624A8CUL))
#define bFM4_INTREQ_IRQ020MON_QUDINT4          *((volatile unsigned char*)(0x42624A90UL))
#define bFM4_INTREQ_IRQ020MON_QUDINT5          *((volatile unsigned char*)(0x42624A94UL))
#define bFM4_INTREQ_IRQ021MON_WAVEINT0         *((volatile unsigned char*)(0x42624B00UL))
#define bFM4_INTREQ_IRQ021MON_WAVEINT1         *((volatile unsigned char*)(0x42624B04UL))
#define bFM4_INTREQ_IRQ021MON_WAVEINT2         *((volatile unsigned char*)(0x42624B08UL))
#define bFM4_INTREQ_IRQ021MON_WAVEINT3         *((volatile unsigned char*)(0x42624B0CUL))
#define bFM4_INTREQ_IRQ022MON_WAVEINT0         *((volatile unsigned char*)(0x42624B80UL))
#define bFM4_INTREQ_IRQ022MON_WAVEINT1         *((volatile unsigned char*)(0x42624B84UL))
#define bFM4_INTREQ_IRQ022MON_WAVEINT2         *((volatile unsigned char*)(0x42624B88UL))
#define bFM4_INTREQ_IRQ022MON_WAVEINT3         *((volatile unsigned char*)(0x42624B8CUL))
#define bFM4_INTREQ_IRQ023MON_WAVEINT0         *((volatile unsigned char*)(0x42624C00UL))
#define bFM4_INTREQ_IRQ023MON_WAVEINT1         *((volatile unsigned char*)(0x42624C04UL))
#define bFM4_INTREQ_IRQ023MON_WAVEINT2         *((volatile unsigned char*)(0x42624C08UL))
#define bFM4_INTREQ_IRQ023MON_WAVEINT3         *((volatile unsigned char*)(0x42624C0CUL))
#define bFM4_INTREQ_IRQ024MON_FRT_PEAK_INT0    *((volatile unsigned char*)(0x42624C80UL))
#define bFM4_INTREQ_IRQ024MON_FRT_PEAK_INT1    *((volatile unsigned char*)(0x42624C84UL))
#define bFM4_INTREQ_IRQ024MON_FRT_PEAK_INT2    *((volatile unsigned char*)(0x42624C88UL))
#define bFM4_INTREQ_IRQ025MON_FRT_ZERO_INT0    *((volatile unsigned char*)(0x42624D00UL))
#define bFM4_INTREQ_IRQ025MON_FRT_ZERO_INT1    *((volatile unsigned char*)(0x42624D04UL))
#define bFM4_INTREQ_IRQ025MON_FRT_ZERO_INT2    *((volatile unsigned char*)(0x42624D08UL))
#define bFM4_INTREQ_IRQ026MON_ICUINT0          *((volatile unsigned char*)(0x42624D80UL))
#define bFM4_INTREQ_IRQ026MON_ICUINT1          *((volatile unsigned char*)(0x42624D84UL))
#define bFM4_INTREQ_IRQ026MON_ICUINT2          *((volatile unsigned char*)(0x42624D88UL))
#define bFM4_INTREQ_IRQ026MON_ICUINT3          *((volatile unsigned char*)(0x42624D8CUL))
#define bFM4_INTREQ_IRQ027MON_OCUINT0          *((volatile unsigned char*)(0x42624E00UL))
#define bFM4_INTREQ_IRQ027MON_OCUINT1          *((volatile unsigned char*)(0x42624E04UL))
#define bFM4_INTREQ_IRQ027MON_OCUINT2          *((volatile unsigned char*)(0x42624E08UL))
#define bFM4_INTREQ_IRQ027MON_OCUINT3          *((volatile unsigned char*)(0x42624E0CUL))
#define bFM4_INTREQ_IRQ027MON_OCUINT4          *((volatile unsigned char*)(0x42624E10UL))
#define bFM4_INTREQ_IRQ027MON_OCUINT5          *((volatile unsigned char*)(0x42624E14UL))
#define bFM4_INTREQ_IRQ028MON_FRT_PEAK_INT0    *((volatile unsigned char*)(0x42624E80UL))
#define bFM4_INTREQ_IRQ028MON_FRT_PEAK_INT1    *((volatile unsigned char*)(0x42624E84UL))
#define bFM4_INTREQ_IRQ028MON_FRT_PEAK_INT2    *((volatile unsigned char*)(0x42624E88UL))
#define bFM4_INTREQ_IRQ029MON_FRT_ZERO_INT0    *((volatile unsigned char*)(0x42624F00UL))
#define bFM4_INTREQ_IRQ029MON_FRT_ZERO_INT1    *((volatile unsigned char*)(0x42624F04UL))
#define bFM4_INTREQ_IRQ029MON_FRT_ZERO_INT2    *((volatile unsigned char*)(0x42624F08UL))
#define bFM4_INTREQ_IRQ030MON_ICUINT0          *((volatile unsigned char*)(0x42624F80UL))
#define bFM4_INTREQ_IRQ030MON_ICUINT1          *((volatile unsigned char*)(0x42624F84UL))
#define bFM4_INTREQ_IRQ030MON_ICUINT2          *((volatile unsigned char*)(0x42624F88UL))
#define bFM4_INTREQ_IRQ030MON_ICUINT3          *((volatile unsigned char*)(0x42624F8CUL))
#define bFM4_INTREQ_IRQ031MON_OCUINT0          *((volatile unsigned char*)(0x42625000UL))
#define bFM4_INTREQ_IRQ031MON_OCUINT1          *((volatile unsigned char*)(0x42625004UL))
#define bFM4_INTREQ_IRQ031MON_OCUINT2          *((volatile unsigned char*)(0x42625008UL))
#define bFM4_INTREQ_IRQ031MON_OCUINT3          *((volatile unsigned char*)(0x4262500CUL))
#define bFM4_INTREQ_IRQ031MON_OCUINT4          *((volatile unsigned char*)(0x42625010UL))
#define bFM4_INTREQ_IRQ031MON_OCUINT5          *((volatile unsigned char*)(0x42625014UL))
#define bFM4_INTREQ_IRQ032MON_FRT_PEAK_INT0    *((volatile unsigned char*)(0x42625080UL))
#define bFM4_INTREQ_IRQ032MON_FRT_PEAK_INT1    *((volatile unsigned char*)(0x42625084UL))
#define bFM4_INTREQ_IRQ032MON_FRT_PEAK_INT2    *((volatile unsigned char*)(0x42625088UL))
#define bFM4_INTREQ_IRQ033MON_FRT_ZERO_INT0    *((volatile unsigned char*)(0x42625100UL))
#define bFM4_INTREQ_IRQ033MON_FRT_ZERO_INT1    *((volatile unsigned char*)(0x42625104UL))
#define bFM4_INTREQ_IRQ033MON_FRT_ZERO_INT2    *((volatile unsigned char*)(0x42625108UL))
#define bFM4_INTREQ_IRQ034MON_ICUINT0          *((volatile unsigned char*)(0x42625180UL))
#define bFM4_INTREQ_IRQ034MON_ICUINT1          *((volatile unsigned char*)(0x42625184UL))
#define bFM4_INTREQ_IRQ034MON_ICUINT2          *((volatile unsigned char*)(0x42625188UL))
#define bFM4_INTREQ_IRQ034MON_ICUINT3          *((volatile unsigned char*)(0x4262518CUL))
#define bFM4_INTREQ_IRQ035MON_OCUINT0          *((volatile unsigned char*)(0x42625200UL))
#define bFM4_INTREQ_IRQ035MON_OCUINT1          *((volatile unsigned char*)(0x42625204UL))
#define bFM4_INTREQ_IRQ035MON_OCUINT2          *((volatile unsigned char*)(0x42625208UL))
#define bFM4_INTREQ_IRQ035MON_OCUINT3          *((volatile unsigned char*)(0x4262520CUL))
#define bFM4_INTREQ_IRQ035MON_OCUINT4          *((volatile unsigned char*)(0x42625210UL))
#define bFM4_INTREQ_IRQ035MON_OCUINT5          *((volatile unsigned char*)(0x42625214UL))
#define bFM4_INTREQ_IRQ036MON_PPGINT0          *((volatile unsigned char*)(0x42625280UL))
#define bFM4_INTREQ_IRQ036MON_PPGINT1          *((volatile unsigned char*)(0x42625284UL))
#define bFM4_INTREQ_IRQ036MON_PPGINT2          *((volatile unsigned char*)(0x42625288UL))
#define bFM4_INTREQ_IRQ037MON_PPGINT0          *((volatile unsigned char*)(0x42625300UL))
#define bFM4_INTREQ_IRQ037MON_PPGINT1          *((volatile unsigned char*)(0x42625304UL))
#define bFM4_INTREQ_IRQ037MON_PPGINT2          *((volatile unsigned char*)(0x42625308UL))
#define bFM4_INTREQ_IRQ038MON_PPGINT0          *((volatile unsigned char*)(0x42625380UL))
#define bFM4_INTREQ_IRQ038MON_PPGINT1          *((volatile unsigned char*)(0x42625384UL))
#define bFM4_INTREQ_IRQ038MON_PPGINT2          *((volatile unsigned char*)(0x42625388UL))
#define bFM4_INTREQ_IRQ039MON_BTINT0           *((volatile unsigned char*)(0x42625400UL))
#define bFM4_INTREQ_IRQ039MON_BTINT1           *((volatile unsigned char*)(0x42625404UL))
#define bFM4_INTREQ_IRQ040MON_BTINT0           *((volatile unsigned char*)(0x42625480UL))
#define bFM4_INTREQ_IRQ040MON_BTINT1           *((volatile unsigned char*)(0x42625484UL))
#define bFM4_INTREQ_IRQ041MON_BTINT0           *((volatile unsigned char*)(0x42625500UL))
#define bFM4_INTREQ_IRQ041MON_BTINT1           *((volatile unsigned char*)(0x42625504UL))
#define bFM4_INTREQ_IRQ042MON_BTINT0           *((volatile unsigned char*)(0x42625580UL))
#define bFM4_INTREQ_IRQ042MON_BTINT1           *((volatile unsigned char*)(0x42625584UL))
#define bFM4_INTREQ_IRQ043MON_BTINT0           *((volatile unsigned char*)(0x42625600UL))
#define bFM4_INTREQ_IRQ043MON_BTINT1           *((volatile unsigned char*)(0x42625604UL))
#define bFM4_INTREQ_IRQ044MON_BTINT0           *((volatile unsigned char*)(0x42625680UL))
#define bFM4_INTREQ_IRQ044MON_BTINT1           *((volatile unsigned char*)(0x42625684UL))
#define bFM4_INTREQ_IRQ045MON_BTINT0           *((volatile unsigned char*)(0x42625700UL))
#define bFM4_INTREQ_IRQ045MON_BTINT1           *((volatile unsigned char*)(0x42625704UL))
#define bFM4_INTREQ_IRQ046MON_BTINT0           *((volatile unsigned char*)(0x42625780UL))
#define bFM4_INTREQ_IRQ046MON_BTINT1           *((volatile unsigned char*)(0x42625784UL))
#define bFM4_INTREQ_IRQ047MON_TIMINT1          *((volatile unsigned char*)(0x42625800UL))
#define bFM4_INTREQ_IRQ047MON_TIMINT2          *((volatile unsigned char*)(0x42625804UL))
#define bFM4_INTREQ_IRQ048MON_WCINT            *((volatile unsigned char*)(0x42625880UL))
#define bFM4_INTREQ_IRQ049MON_BMEMCS           *((volatile unsigned char*)(0x42625900UL))
#define bFM4_INTREQ_IRQ050MON_RTCINT           *((volatile unsigned char*)(0x42625980UL))
#define bFM4_INTREQ_IRQ051MON_EXTINT           *((volatile unsigned char*)(0x42625A00UL))
#define bFM4_INTREQ_IRQ052MON_EXTINT           *((volatile unsigned char*)(0x42625A80UL))
#define bFM4_INTREQ_IRQ053MON_EXTINT           *((volatile unsigned char*)(0x42625B00UL))
#define bFM4_INTREQ_IRQ054MON_EXTINT           *((volatile unsigned char*)(0x42625B80UL))
#define bFM4_INTREQ_IRQ055MON_EXTINT           *((volatile unsigned char*)(0x42625C00UL))
#define bFM4_INTREQ_IRQ056MON_EXTINT           *((volatile unsigned char*)(0x42625C80UL))
#define bFM4_INTREQ_IRQ057MON_EXTINT           *((volatile unsigned char*)(0x42625D00UL))
#define bFM4_INTREQ_IRQ058MON_EXTINT           *((volatile unsigned char*)(0x42625D80UL))
#define bFM4_INTREQ_IRQ059MON_MOSCINT          *((volatile unsigned char*)(0x42625E00UL))
#define bFM4_INTREQ_IRQ059MON_SOSCINT          *((volatile unsigned char*)(0x42625E04UL))
#define bFM4_INTREQ_IRQ059MON_MPLLINT          *((volatile unsigned char*)(0x42625E08UL))
#define bFM4_INTREQ_IRQ059MON_UPLLINT          *((volatile unsigned char*)(0x42625E0CUL))
#define bFM4_INTREQ_IRQ059MON_IPLLINT          *((volatile unsigned char*)(0x42625E10UL))
#define bFM4_INTREQ_IRQ060MON_MFSRINT          *((volatile unsigned char*)(0x42625E80UL))
#define bFM4_INTREQ_IRQ061MON_MFSINT0          *((volatile unsigned char*)(0x42625F00UL))
#define bFM4_INTREQ_IRQ061MON_MFSINT1          *((volatile unsigned char*)(0x42625F04UL))
#define bFM4_INTREQ_IRQ062MON_MFSRINT          *((volatile unsigned char*)(0x42625F80UL))
#define bFM4_INTREQ_IRQ063MON_MFSINT0          *((volatile unsigned char*)(0x42626000UL))
#define bFM4_INTREQ_IRQ063MON_MFSINT1          *((volatile unsigned char*)(0x42626004UL))
#define bFM4_INTREQ_IRQ064MON_MFSRINT          *((volatile unsigned char*)(0x42626080UL))
#define bFM4_INTREQ_IRQ065MON_MFSINT0          *((volatile unsigned char*)(0x42626100UL))
#define bFM4_INTREQ_IRQ065MON_MFSINT1          *((volatile unsigned char*)(0x42626104UL))
#define bFM4_INTREQ_IRQ066MON_MFSRINT          *((volatile unsigned char*)(0x42626180UL))
#define bFM4_INTREQ_IRQ067MON_MFSINT0          *((volatile unsigned char*)(0x42626200UL))
#define bFM4_INTREQ_IRQ067MON_MFSINT1          *((volatile unsigned char*)(0x42626204UL))
#define bFM4_INTREQ_IRQ068MON_MFSRINT          *((volatile unsigned char*)(0x42626280UL))
#define bFM4_INTREQ_IRQ069MON_MFSINT0          *((volatile unsigned char*)(0x42626300UL))
#define bFM4_INTREQ_IRQ069MON_MFSINT1          *((volatile unsigned char*)(0x42626304UL))
#define bFM4_INTREQ_IRQ070MON_MFSRINT          *((volatile unsigned char*)(0x42626380UL))
#define bFM4_INTREQ_IRQ071MON_MFSINT0          *((volatile unsigned char*)(0x42626400UL))
#define bFM4_INTREQ_IRQ071MON_MFSINT1          *((volatile unsigned char*)(0x42626404UL))
#define bFM4_INTREQ_IRQ072MON_MFSRINT          *((volatile unsigned char*)(0x42626480UL))
#define bFM4_INTREQ_IRQ073MON_MFSINT0          *((volatile unsigned char*)(0x42626500UL))
#define bFM4_INTREQ_IRQ073MON_MFSINT1          *((volatile unsigned char*)(0x42626504UL))
#define bFM4_INTREQ_IRQ074MON_MFSRINT          *((volatile unsigned char*)(0x42626580UL))
#define bFM4_INTREQ_IRQ075MON_MFSINT0          *((volatile unsigned char*)(0x42626600UL))
#define bFM4_INTREQ_IRQ075MON_MFSINT1          *((volatile unsigned char*)(0x42626604UL))
#define bFM4_INTREQ_IRQ076MON_ADCINT0          *((volatile unsigned char*)(0x42626680UL))
#define bFM4_INTREQ_IRQ076MON_ADCINT1          *((volatile unsigned char*)(0x42626684UL))
#define bFM4_INTREQ_IRQ076MON_ADCINT2          *((volatile unsigned char*)(0x42626688UL))
#define bFM4_INTREQ_IRQ076MON_ADCINT3          *((volatile unsigned char*)(0x4262668CUL))
#define bFM4_INTREQ_IRQ076MON_ADCINT4          *((volatile unsigned char*)(0x42626690UL))
#define bFM4_INTREQ_IRQ077MON_ADCINT0          *((volatile unsigned char*)(0x42626700UL))
#define bFM4_INTREQ_IRQ077MON_ADCINT1          *((volatile unsigned char*)(0x42626704UL))
#define bFM4_INTREQ_IRQ077MON_ADCINT2          *((volatile unsigned char*)(0x42626708UL))
#define bFM4_INTREQ_IRQ077MON_ADCINT3          *((volatile unsigned char*)(0x4262670CUL))
#define bFM4_INTREQ_IRQ077MON_ADCINT4          *((volatile unsigned char*)(0x42626710UL))
#define bFM4_INTREQ_IRQ078MON_USB_DRQ_INT0     *((volatile unsigned char*)(0x42626780UL))
#define bFM4_INTREQ_IRQ078MON_USB_DRQ_INT1     *((volatile unsigned char*)(0x42626784UL))
#define bFM4_INTREQ_IRQ078MON_USB_DRQ_INT2     *((volatile unsigned char*)(0x42626788UL))
#define bFM4_INTREQ_IRQ078MON_USB_DRQ_INT3     *((volatile unsigned char*)(0x4262678CUL))
#define bFM4_INTREQ_IRQ078MON_USB_DRQ_INT4     *((volatile unsigned char*)(0x42626790UL))
#define bFM4_INTREQ_IRQ079MON_USB_INT0         *((volatile unsigned char*)(0x42626800UL))
#define bFM4_INTREQ_IRQ079MON_USB_INT1         *((volatile unsigned char*)(0x42626804UL))
#define bFM4_INTREQ_IRQ079MON_USB_INT2         *((volatile unsigned char*)(0x42626808UL))
#define bFM4_INTREQ_IRQ079MON_USB_INT3         *((volatile unsigned char*)(0x4262680CUL))
#define bFM4_INTREQ_IRQ079MON_USB_INT4         *((volatile unsigned char*)(0x42626810UL))
#define bFM4_INTREQ_IRQ079MON_USB_INT5         *((volatile unsigned char*)(0x42626814UL))
#define bFM4_INTREQ_IRQ080MON_CANINT           *((volatile unsigned char*)(0x42626880UL))
#define bFM4_INTREQ_IRQ081MON_CANINT           *((volatile unsigned char*)(0x42626900UL))
#define bFM4_INTREQ_IRQ081MON_CANDEINT         *((volatile unsigned char*)(0x42626904UL))
#define bFM4_INTREQ_IRQ081MON_CANSEINT         *((volatile unsigned char*)(0x42626908UL))
#define bFM4_INTREQ_IRQ081MON_CAN0INT          *((volatile unsigned char*)(0x4262690CUL))
#define bFM4_INTREQ_IRQ081MON_CAN1INT          *((volatile unsigned char*)(0x42626910UL))
#define bFM4_INTREQ_IRQ082MON_MACSBD           *((volatile unsigned char*)(0x42626980UL))
#define bFM4_INTREQ_IRQ082MON_MACPMT           *((volatile unsigned char*)(0x42626984UL))
#define bFM4_INTREQ_IRQ082MON_MACLPI           *((volatile unsigned char*)(0x42626988UL))
#define bFM4_INTREQ_IRQ083MON_DMACINT          *((volatile unsigned char*)(0x42626A00UL))
#define bFM4_INTREQ_IRQ084MON_DMACINT          *((volatile unsigned char*)(0x42626A80UL))
#define bFM4_INTREQ_IRQ085MON_DMACINT          *((volatile unsigned char*)(0x42626B00UL))
#define bFM4_INTREQ_IRQ086MON_DMACINT          *((volatile unsigned char*)(0x42626B80UL))
#define bFM4_INTREQ_IRQ087MON_DMACINT          *((volatile unsigned char*)(0x42626C00UL))
#define bFM4_INTREQ_IRQ088MON_DMACINT          *((volatile unsigned char*)(0x42626C80UL))
#define bFM4_INTREQ_IRQ089MON_DMACINT          *((volatile unsigned char*)(0x42626D00UL))
#define bFM4_INTREQ_IRQ090MON_DMACINT          *((volatile unsigned char*)(0x42626D80UL))
#define bFM4_INTREQ_IRQ091MON_DSTCINT0         *((volatile unsigned char*)(0x42626E00UL))
#define bFM4_INTREQ_IRQ091MON_DSTCINT1         *((volatile unsigned char*)(0x42626E04UL))
#define bFM4_INTREQ_IRQ092MON_EXTINT0          *((volatile unsigned char*)(0x42626E80UL))
#define bFM4_INTREQ_IRQ092MON_EXTINT1          *((volatile unsigned char*)(0x42626E84UL))
#define bFM4_INTREQ_IRQ092MON_EXTINT2          *((volatile unsigned char*)(0x42626E88UL))
#define bFM4_INTREQ_IRQ092MON_EXTINT3          *((volatile unsigned char*)(0x42626E8CUL))
#define bFM4_INTREQ_IRQ093MON_EXTINT0          *((volatile unsigned char*)(0x42626F00UL))
#define bFM4_INTREQ_IRQ093MON_EXTINT1          *((volatile unsigned char*)(0x42626F04UL))
#define bFM4_INTREQ_IRQ093MON_EXTINT2          *((volatile unsigned char*)(0x42626F08UL))
#define bFM4_INTREQ_IRQ093MON_EXTINT3          *((volatile unsigned char*)(0x42626F0CUL))
#define bFM4_INTREQ_IRQ094MON_EXTINT0          *((volatile unsigned char*)(0x42626F80UL))
#define bFM4_INTREQ_IRQ094MON_EXTINT1          *((volatile unsigned char*)(0x42626F84UL))
#define bFM4_INTREQ_IRQ094MON_EXTINT2          *((volatile unsigned char*)(0x42626F88UL))
#define bFM4_INTREQ_IRQ094MON_EXTINT3          *((volatile unsigned char*)(0x42626F8CUL))
#define bFM4_INTREQ_IRQ095MON_EXTINT0          *((volatile unsigned char*)(0x42627000UL))
#define bFM4_INTREQ_IRQ095MON_EXTINT1          *((volatile unsigned char*)(0x42627004UL))
#define bFM4_INTREQ_IRQ095MON_EXTINT2          *((volatile unsigned char*)(0x42627008UL))
#define bFM4_INTREQ_IRQ095MON_EXTINT3          *((volatile unsigned char*)(0x4262700CUL))
#define bFM4_INTREQ_IRQ096MON_QUDINT0          *((volatile unsigned char*)(0x42627080UL))
#define bFM4_INTREQ_IRQ096MON_QUDINT1          *((volatile unsigned char*)(0x42627084UL))
#define bFM4_INTREQ_IRQ096MON_QUDINT2          *((volatile unsigned char*)(0x42627088UL))
#define bFM4_INTREQ_IRQ096MON_QUDINT3          *((volatile unsigned char*)(0x4262708CUL))
#define bFM4_INTREQ_IRQ096MON_QUDINT4          *((volatile unsigned char*)(0x42627090UL))
#define bFM4_INTREQ_IRQ096MON_QUDINT5          *((volatile unsigned char*)(0x42627094UL))
#define bFM4_INTREQ_IRQ097MON_QUDINT0          *((volatile unsigned char*)(0x42627100UL))
#define bFM4_INTREQ_IRQ097MON_QUDINT1          *((volatile unsigned char*)(0x42627104UL))
#define bFM4_INTREQ_IRQ097MON_QUDINT2          *((volatile unsigned char*)(0x42627108UL))
#define bFM4_INTREQ_IRQ097MON_QUDINT3          *((volatile unsigned char*)(0x4262710CUL))
#define bFM4_INTREQ_IRQ097MON_QUDINT4          *((volatile unsigned char*)(0x42627110UL))
#define bFM4_INTREQ_IRQ097MON_QUDINT5          *((volatile unsigned char*)(0x42627114UL))
#define bFM4_INTREQ_IRQ098MON_BTINT0           *((volatile unsigned char*)(0x42627180UL))
#define bFM4_INTREQ_IRQ098MON_BTINT1           *((volatile unsigned char*)(0x42627184UL))
#define bFM4_INTREQ_IRQ099MON_BTINT0           *((volatile unsigned char*)(0x42627200UL))
#define bFM4_INTREQ_IRQ099MON_BTINT1           *((volatile unsigned char*)(0x42627204UL))
#define bFM4_INTREQ_IRQ100MON_BTINT0           *((volatile unsigned char*)(0x42627280UL))
#define bFM4_INTREQ_IRQ100MON_BTINT1           *((volatile unsigned char*)(0x42627284UL))
#define bFM4_INTREQ_IRQ101MON_BTINT0           *((volatile unsigned char*)(0x42627300UL))
#define bFM4_INTREQ_IRQ101MON_BTINT1           *((volatile unsigned char*)(0x42627304UL))
#define bFM4_INTREQ_IRQ102MON_BTINT0           *((volatile unsigned char*)(0x42627380UL))
#define bFM4_INTREQ_IRQ102MON_BTINT1           *((volatile unsigned char*)(0x42627384UL))
#define bFM4_INTREQ_IRQ102MON_BTINT2           *((volatile unsigned char*)(0x42627388UL))
#define bFM4_INTREQ_IRQ102MON_BTINT3           *((volatile unsigned char*)(0x4262738CUL))
#define bFM4_INTREQ_IRQ102MON_BTINT4           *((volatile unsigned char*)(0x42627390UL))
#define bFM4_INTREQ_IRQ102MON_BTINT5           *((volatile unsigned char*)(0x42627394UL))
#define bFM4_INTREQ_IRQ102MON_BTINT6           *((volatile unsigned char*)(0x42627398UL))
#define bFM4_INTREQ_IRQ102MON_BTINT7           *((volatile unsigned char*)(0x4262739CUL))
#define bFM4_INTREQ_IRQ103MON_MFSRINT          *((volatile unsigned char*)(0x42627400UL))
#define bFM4_INTREQ_IRQ104MON_MFSINT0          *((volatile unsigned char*)(0x42627480UL))
#define bFM4_INTREQ_IRQ104MON_MFSINT1          *((volatile unsigned char*)(0x42627484UL))
#define bFM4_INTREQ_IRQ105MON_MFSRINT          *((volatile unsigned char*)(0x42627500UL))
#define bFM4_INTREQ_IRQ106MON_MFSINT0          *((volatile unsigned char*)(0x42627580UL))
#define bFM4_INTREQ_IRQ106MON_MFSINT1          *((volatile unsigned char*)(0x42627584UL))
#define bFM4_INTREQ_IRQ107MON_MFSRINT          *((volatile unsigned char*)(0x42627600UL))
#define bFM4_INTREQ_IRQ108MON_MFSINT0          *((volatile unsigned char*)(0x42627680UL))
#define bFM4_INTREQ_IRQ108MON_MFSINT1          *((volatile unsigned char*)(0x42627684UL))
#define bFM4_INTREQ_IRQ109MON_MFSRINT          *((volatile unsigned char*)(0x42627700UL))
#define bFM4_INTREQ_IRQ110MON_MFSINT0          *((volatile unsigned char*)(0x42627780UL))
#define bFM4_INTREQ_IRQ110MON_MFSINT1          *((volatile unsigned char*)(0x42627784UL))
#define bFM4_INTREQ_IRQ111MON_ADCINT0          *((volatile unsigned char*)(0x42627800UL))
#define bFM4_INTREQ_IRQ111MON_ADCINT1          *((volatile unsigned char*)(0x42627804UL))
#define bFM4_INTREQ_IRQ111MON_ADCINT2          *((volatile unsigned char*)(0x42627808UL))
#define bFM4_INTREQ_IRQ111MON_ADCINT3          *((volatile unsigned char*)(0x4262780CUL))
#define bFM4_INTREQ_IRQ111MON_ADCINT4          *((volatile unsigned char*)(0x42627810UL))
#define bFM4_INTREQ_IRQ112MON_I2SDINT0         *((volatile unsigned char*)(0x42627880UL))
#define bFM4_INTREQ_IRQ112MON_I2SDINT1         *((volatile unsigned char*)(0x42627884UL))
#define bFM4_INTREQ_IRQ112MON_QSPIDINT0        *((volatile unsigned char*)(0x42627888UL))
#define bFM4_INTREQ_IRQ112MON_QSPIDINT1        *((volatile unsigned char*)(0x4262788CUL))
#define bFM4_INTREQ_IRQ112MON_PCRCDINT         *((volatile unsigned char*)(0x42627890UL))
#define bFM4_INTREQ_IRQ112MON_CANDINT          *((volatile unsigned char*)(0x42627894UL))
#define bFM4_INTREQ_IRQ113MON_USB_DRQ_INT0     *((volatile unsigned char*)(0x42627900UL))
#define bFM4_INTREQ_IRQ113MON_USB_DRQ_INT1     *((volatile unsigned char*)(0x42627904UL))
#define bFM4_INTREQ_IRQ113MON_USB_DRQ_INT2     *((volatile unsigned char*)(0x42627908UL))
#define bFM4_INTREQ_IRQ113MON_USB_DRQ_INT3     *((volatile unsigned char*)(0x4262790CUL))
#define bFM4_INTREQ_IRQ113MON_USB_DRQ_INT4     *((volatile unsigned char*)(0x42627910UL))
#define bFM4_INTREQ_IRQ113MON_RCEC0INT         *((volatile unsigned char*)(0x42627914UL))
#define bFM4_INTREQ_IRQ114MON_USB_INT0         *((volatile unsigned char*)(0x42627980UL))
#define bFM4_INTREQ_IRQ114MON_USB_INT1         *((volatile unsigned char*)(0x42627984UL))
#define bFM4_INTREQ_IRQ114MON_USB_INT2         *((volatile unsigned char*)(0x42627988UL))
#define bFM4_INTREQ_IRQ114MON_USB_INT3         *((volatile unsigned char*)(0x4262798CUL))
#define bFM4_INTREQ_IRQ114MON_USB_INT4         *((volatile unsigned char*)(0x42627990UL))
#define bFM4_INTREQ_IRQ114MON_USB_INT5         *((volatile unsigned char*)(0x42627994UL))
#define bFM4_INTREQ_IRQ114MON_RCEC1INT         *((volatile unsigned char*)(0x42627998UL))
#define bFM4_INTREQ_IRQ115MON_QSPIINT0         *((volatile unsigned char*)(0x42627A00UL))
#define bFM4_INTREQ_IRQ115MON_QSPIINT1         *((volatile unsigned char*)(0x42627A04UL))
#define bFM4_INTREQ_IRQ115MON_QSPIINT2         *((volatile unsigned char*)(0x42627A08UL))
#define bFM4_INTREQ_IRQ117MON_I2SINT           *((volatile unsigned char*)(0x42627B00UL))
#define bFM4_INTREQ_IRQ117MON_PRGCRC           *((volatile unsigned char*)(0x42627B04UL))
#define bFM4_INTREQ_IRQ118MON_SDINT0           *((volatile unsigned char*)(0x42627B80UL))
#define bFM4_INTREQ_IRQ118MON_SDINT1           *((volatile unsigned char*)(0x42627B84UL))
#define bFM4_INTREQ_IRQ119MON_FLINT            *((volatile unsigned char*)(0x42627C00UL))
#define bFM4_INTREQ_IRQ120MON_MFSRINT          *((volatile unsigned char*)(0x42627C80UL))
#define bFM4_INTREQ_IRQ121MON_MFSINT0          *((volatile unsigned char*)(0x42627D00UL))
#define bFM4_INTREQ_IRQ121MON_MFSINT1          *((volatile unsigned char*)(0x42627D04UL))
#define bFM4_INTREQ_IRQ122MON_MFSRINT          *((volatile unsigned char*)(0x42627D80UL))
#define bFM4_INTREQ_IRQ123MON_MFSINT0          *((volatile unsigned char*)(0x42627E00UL))
#define bFM4_INTREQ_IRQ123MON_MFSINT1          *((volatile unsigned char*)(0x42627E04UL))
#define bFM4_INTREQ_IRQ124MON_MFSRINT          *((volatile unsigned char*)(0x42627E80UL))
#define bFM4_INTREQ_IRQ125MON_MFSINT0          *((volatile unsigned char*)(0x42627F00UL))
#define bFM4_INTREQ_IRQ125MON_MFSINT1          *((volatile unsigned char*)(0x42627F04UL))
#define bFM4_INTREQ_IRQ126MON_MFSRINT          *((volatile unsigned char*)(0x42627F80UL))
#define bFM4_INTREQ_IRQ127MON_MFSINT0          *((volatile unsigned char*)(0x42628000UL))
#define bFM4_INTREQ_IRQ127MON_MFSINT1          *((volatile unsigned char*)(0x42628004UL))

/* 12-bit DAC unit 0 registers */
#define bFM4_DAC0_DACR_DAE                     *((volatile unsigned char*)(0x42660000UL))
#define bFM4_DAC0_DACR_DRDY                    *((volatile unsigned char*)(0x42660004UL))
#define bFM4_DAC0_DACR_DAC10                   *((volatile unsigned char*)(0x42660010UL))
#define bFM4_DAC0_DACR_DDAS                    *((volatile unsigned char*)(0x42660014UL))
#define bFM4_DAC0_DADR_DA0                     *((volatile unsigned short*)(0x42660080UL))
#define bFM4_DAC0_DADR_DA1                     *((volatile unsigned short*)(0x42660084UL))
#define bFM4_DAC0_DADR_DA2                     *((volatile unsigned short*)(0x42660088UL))
#define bFM4_DAC0_DADR_DA3                     *((volatile unsigned short*)(0x4266008CUL))
#define bFM4_DAC0_DADR_DA4                     *((volatile unsigned short*)(0x42660090UL))
#define bFM4_DAC0_DADR_DA5                     *((volatile unsigned short*)(0x42660094UL))
#define bFM4_DAC0_DADR_DA6                     *((volatile unsigned short*)(0x42660098UL))
#define bFM4_DAC0_DADR_DA7                     *((volatile unsigned short*)(0x4266009CUL))
#define bFM4_DAC0_DADR_DA8                     *((volatile unsigned short*)(0x426600A0UL))
#define bFM4_DAC0_DADR_DA9                     *((volatile unsigned short*)(0x426600A4UL))
#define bFM4_DAC0_DADR_DA10                    *((volatile unsigned short*)(0x426600A8UL))
#define bFM4_DAC0_DADR_DA11                    *((volatile unsigned short*)(0x426600ACUL))

/* 12-bit DAC unit 1 registers */
#define bFM4_DAC1_DACR_DAE                     *((volatile unsigned char*)(0x42660100UL))
#define bFM4_DAC1_DACR_DRDY                    *((volatile unsigned char*)(0x42660104UL))
#define bFM4_DAC1_DACR_DAC10                   *((volatile unsigned char*)(0x42660110UL))
#define bFM4_DAC1_DACR_DDAS                    *((volatile unsigned char*)(0x42660114UL))
#define bFM4_DAC1_DADR_DA0                     *((volatile unsigned short*)(0x42660180UL))
#define bFM4_DAC1_DADR_DA1                     *((volatile unsigned short*)(0x42660184UL))
#define bFM4_DAC1_DADR_DA2                     *((volatile unsigned short*)(0x42660188UL))
#define bFM4_DAC1_DADR_DA3                     *((volatile unsigned short*)(0x4266018CUL))
#define bFM4_DAC1_DADR_DA4                     *((volatile unsigned short*)(0x42660190UL))
#define bFM4_DAC1_DADR_DA5                     *((volatile unsigned short*)(0x42660194UL))
#define bFM4_DAC1_DADR_DA6                     *((volatile unsigned short*)(0x42660198UL))
#define bFM4_DAC1_DADR_DA7                     *((volatile unsigned short*)(0x4266019CUL))
#define bFM4_DAC1_DADR_DA8                     *((volatile unsigned short*)(0x426601A0UL))
#define bFM4_DAC1_DADR_DA9                     *((volatile unsigned short*)(0x426601A4UL))
#define bFM4_DAC1_DADR_DA10                    *((volatile unsigned short*)(0x426601A8UL))
#define bFM4_DAC1_DADR_DA11                    *((volatile unsigned short*)(0x426601ACUL))

/* HDMI-CEC ch.0 registers */
#define bFM4_HDMICEC0_TXCTRL_TXEN              *((volatile unsigned char*)(0x42680000UL))
#define bFM4_HDMICEC0_TXCTRL_START             *((volatile unsigned char*)(0x42680008UL))
#define bFM4_HDMICEC0_TXCTRL_EOM               *((volatile unsigned char*)(0x4268000CUL))
#define bFM4_HDMICEC0_TXCTRL_ITSTEN            *((volatile unsigned char*)(0x42680010UL))
#define bFM4_HDMICEC0_TXCTRL_IBREN             *((volatile unsigned char*)(0x42680014UL))
#define bFM4_HDMICEC0_TXDATA_TXDATA0           *((volatile unsigned char*)(0x42680080UL))
#define bFM4_HDMICEC0_TXDATA_TXDATA1           *((volatile unsigned char*)(0x42680084UL))
#define bFM4_HDMICEC0_TXDATA_TXDATA2           *((volatile unsigned char*)(0x42680088UL))
#define bFM4_HDMICEC0_TXDATA_TXDATA3           *((volatile unsigned char*)(0x4268008CUL))
#define bFM4_HDMICEC0_TXDATA_TXDATA4           *((volatile unsigned char*)(0x42680090UL))
#define bFM4_HDMICEC0_TXDATA_TXDATA5           *((volatile unsigned char*)(0x42680094UL))
#define bFM4_HDMICEC0_TXDATA_TXDATA6           *((volatile unsigned char*)(0x42680098UL))
#define bFM4_HDMICEC0_TXDATA_TXDATA7           *((volatile unsigned char*)(0x4268009CUL))
#define bFM4_HDMICEC0_TXSTS_ACKSV              *((volatile unsigned char*)(0x42680100UL))
#define bFM4_HDMICEC0_TXSTS_ITST               *((volatile unsigned char*)(0x42680110UL))
#define bFM4_HDMICEC0_TXSTS_IBR                *((volatile unsigned char*)(0x42680114UL))
#define bFM4_HDMICEC0_SFREE_SFREE0             *((volatile unsigned char*)(0x42680180UL))
#define bFM4_HDMICEC0_SFREE_SFREE1             *((volatile unsigned char*)(0x42680184UL))
#define bFM4_HDMICEC0_SFREE_SFREE2             *((volatile unsigned char*)(0x42680188UL))
#define bFM4_HDMICEC0_SFREE_SFREE3             *((volatile unsigned char*)(0x4268018CUL))
#define bFM4_HDMICEC0_RCST_OVF                 *((volatile unsigned char*)(0x42680800UL))
#define bFM4_HDMICEC0_RCST_EOM                 *((volatile unsigned char*)(0x42680804UL))
#define bFM4_HDMICEC0_RCST_ACK                 *((volatile unsigned char*)(0x42680808UL))
#define bFM4_HDMICEC0_RCST_ST                  *((volatile unsigned char*)(0x4268080CUL))
#define bFM4_HDMICEC0_RCST_OVFSEL              *((volatile unsigned char*)(0x42680810UL))
#define bFM4_HDMICEC0_RCST_OVFIE               *((volatile unsigned char*)(0x42680814UL))
#define bFM4_HDMICEC0_RCST_ACKIE               *((volatile unsigned char*)(0x42680818UL))
#define bFM4_HDMICEC0_RCST_STIE                *((volatile unsigned char*)(0x4268081CUL))
#define bFM4_HDMICEC0_RCCR_EN                  *((volatile unsigned char*)(0x42680820UL))
#define bFM4_HDMICEC0_RCCR_ADRCE               *((volatile unsigned char*)(0x4268082CUL))
#define bFM4_HDMICEC0_RCCR_THSEL               *((volatile unsigned char*)(0x4268083CUL))
#define bFM4_HDMICEC0_RCCKD_CKDIV0             *((volatile unsigned short*)(0x42680B00UL))
#define bFM4_HDMICEC0_RCCKD_CKDIV1             *((volatile unsigned short*)(0x42680B04UL))
#define bFM4_HDMICEC0_RCCKD_CKDIV2             *((volatile unsigned short*)(0x42680B08UL))
#define bFM4_HDMICEC0_RCCKD_CKDIV3             *((volatile unsigned short*)(0x42680B0CUL))
#define bFM4_HDMICEC0_RCCKD_CKDIV4             *((volatile unsigned short*)(0x42680B10UL))
#define bFM4_HDMICEC0_RCCKD_CKDIV5             *((volatile unsigned short*)(0x42680B14UL))
#define bFM4_HDMICEC0_RCCKD_CKDIV6             *((volatile unsigned short*)(0x42680B18UL))
#define bFM4_HDMICEC0_RCCKD_CKDIV7             *((volatile unsigned short*)(0x42680B1CUL))
#define bFM4_HDMICEC0_RCCKD_CKDIV8             *((volatile unsigned short*)(0x42680B20UL))
#define bFM4_HDMICEC0_RCCKD_CKDIV9             *((volatile unsigned short*)(0x42680B24UL))
#define bFM4_HDMICEC0_RCCKD_CKDIV10            *((volatile unsigned short*)(0x42680B28UL))
#define bFM4_HDMICEC0_RCCKD_CKDIV11            *((volatile unsigned short*)(0x42680B2CUL))
#define bFM4_HDMICEC0_RCCKD_CKSEL              *((volatile unsigned short*)(0x42680B30UL))
#define bFM4_HDMICEC0_RCRC_RC                  *((volatile unsigned char*)(0x42680BA0UL))
#define bFM4_HDMICEC0_RCRC_RCIE                *((volatile unsigned char*)(0x42680BB0UL))
#define bFM4_HDMICEC0_RCLE_LES                 *((volatile unsigned char*)(0x42680C20UL))
#define bFM4_HDMICEC0_RCLE_LEL                 *((volatile unsigned char*)(0x42680C24UL))
#define bFM4_HDMICEC0_RCLE_EPE                 *((volatile unsigned char*)(0x42680C2CUL))
#define bFM4_HDMICEC0_RCLE_LESE                *((volatile unsigned char*)(0x42680C30UL))
#define bFM4_HDMICEC0_RCLE_LELE                *((volatile unsigned char*)(0x42680C34UL))
#define bFM4_HDMICEC0_RCLE_LESIE               *((volatile unsigned char*)(0x42680C38UL))
#define bFM4_HDMICEC0_RCLE_LELIE               *((volatile unsigned char*)(0x42680C3CUL))

/* HDMI-CEC ch.1 registers */
#define bFM4_HDMICEC1_TXCTRL_TXEN              *((volatile unsigned char*)(0x42682000UL))
#define bFM4_HDMICEC1_TXCTRL_START             *((volatile unsigned char*)(0x42682008UL))
#define bFM4_HDMICEC1_TXCTRL_EOM               *((volatile unsigned char*)(0x4268200CUL))
#define bFM4_HDMICEC1_TXCTRL_ITSTEN            *((volatile unsigned char*)(0x42682010UL))
#define bFM4_HDMICEC1_TXCTRL_IBREN             *((volatile unsigned char*)(0x42682014UL))
#define bFM4_HDMICEC1_TXDATA_TXDATA0           *((volatile unsigned char*)(0x42682080UL))
#define bFM4_HDMICEC1_TXDATA_TXDATA1           *((volatile unsigned char*)(0x42682084UL))
#define bFM4_HDMICEC1_TXDATA_TXDATA2           *((volatile unsigned char*)(0x42682088UL))
#define bFM4_HDMICEC1_TXDATA_TXDATA3           *((volatile unsigned char*)(0x4268208CUL))
#define bFM4_HDMICEC1_TXDATA_TXDATA4           *((volatile unsigned char*)(0x42682090UL))
#define bFM4_HDMICEC1_TXDATA_TXDATA5           *((volatile unsigned char*)(0x42682094UL))
#define bFM4_HDMICEC1_TXDATA_TXDATA6           *((volatile unsigned char*)(0x42682098UL))
#define bFM4_HDMICEC1_TXDATA_TXDATA7           *((volatile unsigned char*)(0x4268209CUL))
#define bFM4_HDMICEC1_TXSTS_ACKSV              *((volatile unsigned char*)(0x42682100UL))
#define bFM4_HDMICEC1_TXSTS_ITST               *((volatile unsigned char*)(0x42682110UL))
#define bFM4_HDMICEC1_TXSTS_IBR                *((volatile unsigned char*)(0x42682114UL))
#define bFM4_HDMICEC1_SFREE_SFREE0             *((volatile unsigned char*)(0x42682180UL))
#define bFM4_HDMICEC1_SFREE_SFREE1             *((volatile unsigned char*)(0x42682184UL))
#define bFM4_HDMICEC1_SFREE_SFREE2             *((volatile unsigned char*)(0x42682188UL))
#define bFM4_HDMICEC1_SFREE_SFREE3             *((volatile unsigned char*)(0x4268218CUL))
#define bFM4_HDMICEC1_RCST_OVF                 *((volatile unsigned char*)(0x42682800UL))
#define bFM4_HDMICEC1_RCST_EOM                 *((volatile unsigned char*)(0x42682804UL))
#define bFM4_HDMICEC1_RCST_ACK                 *((volatile unsigned char*)(0x42682808UL))
#define bFM4_HDMICEC1_RCST_ST                  *((volatile unsigned char*)(0x4268280CUL))
#define bFM4_HDMICEC1_RCST_OVFSEL              *((volatile unsigned char*)(0x42682810UL))
#define bFM4_HDMICEC1_RCST_OVFIE               *((volatile unsigned char*)(0x42682814UL))
#define bFM4_HDMICEC1_RCST_ACKIE               *((volatile unsigned char*)(0x42682818UL))
#define bFM4_HDMICEC1_RCST_STIE                *((volatile unsigned char*)(0x4268281CUL))
#define bFM4_HDMICEC1_RCCR_EN                  *((volatile unsigned char*)(0x42682820UL))
#define bFM4_HDMICEC1_RCCR_ADRCE               *((volatile unsigned char*)(0x4268282CUL))
#define bFM4_HDMICEC1_RCCR_THSEL               *((volatile unsigned char*)(0x4268283CUL))
#define bFM4_HDMICEC1_RCCKD_CKDIV0             *((volatile unsigned short*)(0x42682B00UL))
#define bFM4_HDMICEC1_RCCKD_CKDIV1             *((volatile unsigned short*)(0x42682B04UL))
#define bFM4_HDMICEC1_RCCKD_CKDIV2             *((volatile unsigned short*)(0x42682B08UL))
#define bFM4_HDMICEC1_RCCKD_CKDIV3             *((volatile unsigned short*)(0x42682B0CUL))
#define bFM4_HDMICEC1_RCCKD_CKDIV4             *((volatile unsigned short*)(0x42682B10UL))
#define bFM4_HDMICEC1_RCCKD_CKDIV5             *((volatile unsigned short*)(0x42682B14UL))
#define bFM4_HDMICEC1_RCCKD_CKDIV6             *((volatile unsigned short*)(0x42682B18UL))
#define bFM4_HDMICEC1_RCCKD_CKDIV7             *((volatile unsigned short*)(0x42682B1CUL))
#define bFM4_HDMICEC1_RCCKD_CKDIV8             *((volatile unsigned short*)(0x42682B20UL))
#define bFM4_HDMICEC1_RCCKD_CKDIV9             *((volatile unsigned short*)(0x42682B24UL))
#define bFM4_HDMICEC1_RCCKD_CKDIV10            *((volatile unsigned short*)(0x42682B28UL))
#define bFM4_HDMICEC1_RCCKD_CKDIV11            *((volatile unsigned short*)(0x42682B2CUL))
#define bFM4_HDMICEC1_RCCKD_CKSEL              *((volatile unsigned short*)(0x42682B30UL))
#define bFM4_HDMICEC1_RCRC_RC                  *((volatile unsigned char*)(0x42682BA0UL))
#define bFM4_HDMICEC1_RCRC_RCIE                *((volatile unsigned char*)(0x42682BB0UL))
#define bFM4_HDMICEC1_RCLE_LES                 *((volatile unsigned char*)(0x42682C20UL))
#define bFM4_HDMICEC1_RCLE_LEL                 *((volatile unsigned char*)(0x42682C24UL))
#define bFM4_HDMICEC1_RCLE_EPE                 *((volatile unsigned char*)(0x42682C2CUL))
#define bFM4_HDMICEC1_RCLE_LESE                *((volatile unsigned char*)(0x42682C30UL))
#define bFM4_HDMICEC1_RCLE_LELE                *((volatile unsigned char*)(0x42682C34UL))
#define bFM4_HDMICEC1_RCLE_LESIE               *((volatile unsigned char*)(0x42682C38UL))
#define bFM4_HDMICEC1_RCLE_LELIE               *((volatile unsigned char*)(0x42682C3CUL))

/* General purpose I/O registers */
#define bFM4_GPIO_PFR0_P0                      *((volatile unsigned char*)(0x42DE0000UL))
#define bFM4_GPIO_PFR0_P1                      *((volatile unsigned char*)(0x42DE0004UL))
#define bFM4_GPIO_PFR0_P2                      *((volatile unsigned char*)(0x42DE0008UL))
#define bFM4_GPIO_PFR0_P3                      *((volatile unsigned char*)(0x42DE000CUL))
#define bFM4_GPIO_PFR0_P4                      *((volatile unsigned char*)(0x42DE0010UL))
#define bFM4_GPIO_PFR0_P8                      *((volatile unsigned char*)(0x42DE0020UL))
#define bFM4_GPIO_PFR0_P9                      *((volatile unsigned char*)(0x42DE0024UL))
#define bFM4_GPIO_PFR0_PA                      *((volatile unsigned char*)(0x42DE0028UL))
#define bFM4_GPIO_PFR1_P0                      *((volatile unsigned char*)(0x42DE0080UL))
#define bFM4_GPIO_PFR1_P1                      *((volatile unsigned char*)(0x42DE0084UL))
#define bFM4_GPIO_PFR1_P2                      *((volatile unsigned char*)(0x42DE0088UL))
#define bFM4_GPIO_PFR1_P3                      *((volatile unsigned char*)(0x42DE008CUL))
#define bFM4_GPIO_PFR1_P4                      *((volatile unsigned char*)(0x42DE0090UL))
#define bFM4_GPIO_PFR1_P5                      *((volatile unsigned char*)(0x42DE0094UL))
#define bFM4_GPIO_PFR1_P6                      *((volatile unsigned char*)(0x42DE0098UL))
#define bFM4_GPIO_PFR1_P7                      *((volatile unsigned char*)(0x42DE009CUL))
#define bFM4_GPIO_PFR1_P8                      *((volatile unsigned char*)(0x42DE00A0UL))
#define bFM4_GPIO_PFR1_P9                      *((volatile unsigned char*)(0x42DE00A4UL))
#define bFM4_GPIO_PFR1_PA                      *((volatile unsigned char*)(0x42DE00A8UL))
#define bFM4_GPIO_PFR1_PB                      *((volatile unsigned char*)(0x42DE00ACUL))
#define bFM4_GPIO_PFR1_PC                      *((volatile unsigned char*)(0x42DE00B0UL))
#define bFM4_GPIO_PFR1_PD                      *((volatile unsigned char*)(0x42DE00B4UL))
#define bFM4_GPIO_PFR1_PE                      *((volatile unsigned char*)(0x42DE00B8UL))
#define bFM4_GPIO_PFR1_PF                      *((volatile unsigned char*)(0x42DE00BCUL))
#define bFM4_GPIO_PFR2_P0                      *((volatile unsigned char*)(0x42DE0100UL))
#define bFM4_GPIO_PFR2_P1                      *((volatile unsigned char*)(0x42DE0104UL))
#define bFM4_GPIO_PFR2_P2                      *((volatile unsigned char*)(0x42DE0108UL))
#define bFM4_GPIO_PFR2_P3                      *((volatile unsigned char*)(0x42DE010CUL))
#define bFM4_GPIO_PFR2_P4                      *((volatile unsigned char*)(0x42DE0110UL))
#define bFM4_GPIO_PFR2_P5                      *((volatile unsigned char*)(0x42DE0114UL))
#define bFM4_GPIO_PFR2_P6                      *((volatile unsigned char*)(0x42DE0118UL))
#define bFM4_GPIO_PFR2_P7                      *((volatile unsigned char*)(0x42DE011CUL))
#define bFM4_GPIO_PFR2_P8                      *((volatile unsigned char*)(0x42DE0120UL))
#define bFM4_GPIO_PFR2_P9                      *((volatile unsigned char*)(0x42DE0124UL))
#define bFM4_GPIO_PFR2_PA                      *((volatile unsigned char*)(0x42DE0128UL))
#define bFM4_GPIO_PFR3_P0                      *((volatile unsigned char*)(0x42DE0180UL))
#define bFM4_GPIO_PFR3_P1                      *((volatile unsigned char*)(0x42DE0184UL))
#define bFM4_GPIO_PFR3_P2                      *((volatile unsigned char*)(0x42DE0188UL))
#define bFM4_GPIO_PFR3_P3                      *((volatile unsigned char*)(0x42DE018CUL))
#define bFM4_GPIO_PFR3_P4                      *((volatile unsigned char*)(0x42DE0190UL))
#define bFM4_GPIO_PFR3_P5                      *((volatile unsigned char*)(0x42DE0194UL))
#define bFM4_GPIO_PFR3_P6                      *((volatile unsigned char*)(0x42DE0198UL))
#define bFM4_GPIO_PFR3_P7                      *((volatile unsigned char*)(0x42DE019CUL))
#define bFM4_GPIO_PFR3_P8                      *((volatile unsigned char*)(0x42DE01A0UL))
#define bFM4_GPIO_PFR3_P9                      *((volatile unsigned char*)(0x42DE01A4UL))
#define bFM4_GPIO_PFR3_PA                      *((volatile unsigned char*)(0x42DE01A8UL))
#define bFM4_GPIO_PFR3_PB                      *((volatile unsigned char*)(0x42DE01ACUL))
#define bFM4_GPIO_PFR3_PC                      *((volatile unsigned char*)(0x42DE01B0UL))
#define bFM4_GPIO_PFR3_PD                      *((volatile unsigned char*)(0x42DE01B4UL))
#define bFM4_GPIO_PFR3_PE                      *((volatile unsigned char*)(0x42DE01B8UL))
#define bFM4_GPIO_PFR4_P0                      *((volatile unsigned char*)(0x42DE0200UL))
#define bFM4_GPIO_PFR4_P1                      *((volatile unsigned char*)(0x42DE0204UL))
#define bFM4_GPIO_PFR4_P2                      *((volatile unsigned char*)(0x42DE0208UL))
#define bFM4_GPIO_PFR4_P3                      *((volatile unsigned char*)(0x42DE020CUL))
#define bFM4_GPIO_PFR4_P4                      *((volatile unsigned char*)(0x42DE0210UL))
#define bFM4_GPIO_PFR4_P5                      *((volatile unsigned char*)(0x42DE0214UL))
#define bFM4_GPIO_PFR4_P6                      *((volatile unsigned char*)(0x42DE0218UL))
#define bFM4_GPIO_PFR4_P7                      *((volatile unsigned char*)(0x42DE021CUL))
#define bFM4_GPIO_PFR4_P8                      *((volatile unsigned char*)(0x42DE0220UL))
#define bFM4_GPIO_PFR4_P9                      *((volatile unsigned char*)(0x42DE0224UL))
#define bFM4_GPIO_PFR4_PA                      *((volatile unsigned char*)(0x42DE0228UL))
#define bFM4_GPIO_PFR4_PB                      *((volatile unsigned char*)(0x42DE022CUL))
#define bFM4_GPIO_PFR4_PC                      *((volatile unsigned char*)(0x42DE0230UL))
#define bFM4_GPIO_PFR4_PD                      *((volatile unsigned char*)(0x42DE0234UL))
#define bFM4_GPIO_PFR4_PE                      *((volatile unsigned char*)(0x42DE0238UL))
#define bFM4_GPIO_PFR5_P0                      *((volatile unsigned char*)(0x42DE0280UL))
#define bFM4_GPIO_PFR5_P1                      *((volatile unsigned char*)(0x42DE0284UL))
#define bFM4_GPIO_PFR5_P2                      *((volatile unsigned char*)(0x42DE0288UL))
#define bFM4_GPIO_PFR5_P3                      *((volatile unsigned char*)(0x42DE028CUL))
#define bFM4_GPIO_PFR5_P4                      *((volatile unsigned char*)(0x42DE0290UL))
#define bFM4_GPIO_PFR5_P5                      *((volatile unsigned char*)(0x42DE0294UL))
#define bFM4_GPIO_PFR5_P6                      *((volatile unsigned char*)(0x42DE0298UL))
#define bFM4_GPIO_PFR5_P7                      *((volatile unsigned char*)(0x42DE029CUL))
#define bFM4_GPIO_PFR5_P8                      *((volatile unsigned char*)(0x42DE02A0UL))
#define bFM4_GPIO_PFR5_P9                      *((volatile unsigned char*)(0x42DE02A4UL))
#define bFM4_GPIO_PFR5_PA                      *((volatile unsigned char*)(0x42DE02A8UL))
#define bFM4_GPIO_PFR5_PB                      *((volatile unsigned char*)(0x42DE02ACUL))
#define bFM4_GPIO_PFR5_PC                      *((volatile unsigned char*)(0x42DE02B0UL))
#define bFM4_GPIO_PFR5_PD                      *((volatile unsigned char*)(0x42DE02B4UL))
#define bFM4_GPIO_PFR5_PE                      *((volatile unsigned char*)(0x42DE02B8UL))
#define bFM4_GPIO_PFR5_PF                      *((volatile unsigned char*)(0x42DE02BCUL))
#define bFM4_GPIO_PFR6_P0                      *((volatile unsigned char*)(0x42DE0300UL))
#define bFM4_GPIO_PFR6_P1                      *((volatile unsigned char*)(0x42DE0304UL))
#define bFM4_GPIO_PFR6_P2                      *((volatile unsigned char*)(0x42DE0308UL))
#define bFM4_GPIO_PFR6_P3                      *((volatile unsigned char*)(0x42DE030CUL))
#define bFM4_GPIO_PFR6_P4                      *((volatile unsigned char*)(0x42DE0310UL))
#define bFM4_GPIO_PFR6_P5                      *((volatile unsigned char*)(0x42DE0314UL))
#define bFM4_GPIO_PFR6_P6                      *((volatile unsigned char*)(0x42DE0318UL))
#define bFM4_GPIO_PFR6_P7                      *((volatile unsigned char*)(0x42DE031CUL))
#define bFM4_GPIO_PFR6_P8                      *((volatile unsigned char*)(0x42DE0320UL))
#define bFM4_GPIO_PFR6_P9                      *((volatile unsigned char*)(0x42DE0324UL))
#define bFM4_GPIO_PFR6_PA                      *((volatile unsigned char*)(0x42DE0328UL))
#define bFM4_GPIO_PFR6_PB                      *((volatile unsigned char*)(0x42DE032CUL))
#define bFM4_GPIO_PFR6_PC                      *((volatile unsigned char*)(0x42DE0330UL))
#define bFM4_GPIO_PFR6_PD                      *((volatile unsigned char*)(0x42DE0334UL))
#define bFM4_GPIO_PFR6_PE                      *((volatile unsigned char*)(0x42DE0338UL))
#define bFM4_GPIO_PFR7_P0                      *((volatile unsigned char*)(0x42DE0380UL))
#define bFM4_GPIO_PFR7_P1                      *((volatile unsigned char*)(0x42DE0384UL))
#define bFM4_GPIO_PFR7_P2                      *((volatile unsigned char*)(0x42DE0388UL))
#define bFM4_GPIO_PFR7_P3                      *((volatile unsigned char*)(0x42DE038CUL))
#define bFM4_GPIO_PFR7_P4                      *((volatile unsigned char*)(0x42DE0390UL))
#define bFM4_GPIO_PFR7_P5                      *((volatile unsigned char*)(0x42DE0394UL))
#define bFM4_GPIO_PFR7_P6                      *((volatile unsigned char*)(0x42DE0398UL))
#define bFM4_GPIO_PFR7_P7                      *((volatile unsigned char*)(0x42DE039CUL))
#define bFM4_GPIO_PFR7_P8                      *((volatile unsigned char*)(0x42DE03A0UL))
#define bFM4_GPIO_PFR7_P9                      *((volatile unsigned char*)(0x42DE03A4UL))
#define bFM4_GPIO_PFR7_PA                      *((volatile unsigned char*)(0x42DE03A8UL))
#define bFM4_GPIO_PFR7_PB                      *((volatile unsigned char*)(0x42DE03ACUL))
#define bFM4_GPIO_PFR7_PC                      *((volatile unsigned char*)(0x42DE03B0UL))
#define bFM4_GPIO_PFR7_PD                      *((volatile unsigned char*)(0x42DE03B4UL))
#define bFM4_GPIO_PFR7_PE                      *((volatile unsigned char*)(0x42DE03B8UL))
#define bFM4_GPIO_PFR8_P0                      *((volatile unsigned char*)(0x42DE0400UL))
#define bFM4_GPIO_PFR8_P1                      *((volatile unsigned char*)(0x42DE0404UL))
#define bFM4_GPIO_PFR8_P2                      *((volatile unsigned char*)(0x42DE0408UL))
#define bFM4_GPIO_PFR8_P3                      *((volatile unsigned char*)(0x42DE040CUL))
#define bFM4_GPIO_PFR9_P0                      *((volatile unsigned char*)(0x42DE0480UL))
#define bFM4_GPIO_PFR9_P1                      *((volatile unsigned char*)(0x42DE0484UL))
#define bFM4_GPIO_PFR9_P2                      *((volatile unsigned char*)(0x42DE0488UL))
#define bFM4_GPIO_PFR9_P3                      *((volatile unsigned char*)(0x42DE048CUL))
#define bFM4_GPIO_PFR9_P4                      *((volatile unsigned char*)(0x42DE0490UL))
#define bFM4_GPIO_PFR9_P5                      *((volatile unsigned char*)(0x42DE0494UL))
#define bFM4_GPIO_PFR9_P6                      *((volatile unsigned char*)(0x42DE0498UL))
#define bFM4_GPIO_PFR9_P7                      *((volatile unsigned char*)(0x42DE049CUL))
#define bFM4_GPIO_PFRA_P0                      *((volatile unsigned char*)(0x42DE0500UL))
#define bFM4_GPIO_PFRA_P1                      *((volatile unsigned char*)(0x42DE0504UL))
#define bFM4_GPIO_PFRA_P2                      *((volatile unsigned char*)(0x42DE0508UL))
#define bFM4_GPIO_PFRA_P3                      *((volatile unsigned char*)(0x42DE050CUL))
#define bFM4_GPIO_PFRA_P4                      *((volatile unsigned char*)(0x42DE0510UL))
#define bFM4_GPIO_PFRA_P5                      *((volatile unsigned char*)(0x42DE0514UL))
#define bFM4_GPIO_PFRA_P6                      *((volatile unsigned char*)(0x42DE0518UL))
#define bFM4_GPIO_PFRA_P7                      *((volatile unsigned char*)(0x42DE051CUL))
#define bFM4_GPIO_PFRA_P8                      *((volatile unsigned char*)(0x42DE0520UL))
#define bFM4_GPIO_PFRA_P9                      *((volatile unsigned char*)(0x42DE0524UL))
#define bFM4_GPIO_PFRA_PA                      *((volatile unsigned char*)(0x42DE0528UL))
#define bFM4_GPIO_PFRA_PB                      *((volatile unsigned char*)(0x42DE052CUL))
#define bFM4_GPIO_PFRA_PC                      *((volatile unsigned char*)(0x42DE0530UL))
#define bFM4_GPIO_PFRA_PD                      *((volatile unsigned char*)(0x42DE0534UL))
#define bFM4_GPIO_PFRA_PE                      *((volatile unsigned char*)(0x42DE0538UL))
#define bFM4_GPIO_PFRA_PF                      *((volatile unsigned char*)(0x42DE053CUL))
#define bFM4_GPIO_PFRB_P0                      *((volatile unsigned char*)(0x42DE0580UL))
#define bFM4_GPIO_PFRB_P1                      *((volatile unsigned char*)(0x42DE0584UL))
#define bFM4_GPIO_PFRB_P2                      *((volatile unsigned char*)(0x42DE0588UL))
#define bFM4_GPIO_PFRB_P3                      *((volatile unsigned char*)(0x42DE058CUL))
#define bFM4_GPIO_PFRB_P4                      *((volatile unsigned char*)(0x42DE0590UL))
#define bFM4_GPIO_PFRB_P5                      *((volatile unsigned char*)(0x42DE0594UL))
#define bFM4_GPIO_PFRB_P6                      *((volatile unsigned char*)(0x42DE0598UL))
#define bFM4_GPIO_PFRB_P7                      *((volatile unsigned char*)(0x42DE059CUL))
#define bFM4_GPIO_PFRB_P8                      *((volatile unsigned char*)(0x42DE05A0UL))
#define bFM4_GPIO_PFRB_P9                      *((volatile unsigned char*)(0x42DE05A4UL))
#define bFM4_GPIO_PFRB_PA                      *((volatile unsigned char*)(0x42DE05A8UL))
#define bFM4_GPIO_PFRB_PB                      *((volatile unsigned char*)(0x42DE05ACUL))
#define bFM4_GPIO_PFRB_PC                      *((volatile unsigned char*)(0x42DE05B0UL))
#define bFM4_GPIO_PFRB_PD                      *((volatile unsigned char*)(0x42DE05B4UL))
#define bFM4_GPIO_PFRB_PE                      *((volatile unsigned char*)(0x42DE05B8UL))
#define bFM4_GPIO_PFRB_PF                      *((volatile unsigned char*)(0x42DE05BCUL))
#define bFM4_GPIO_PFRC_P0                      *((volatile unsigned char*)(0x42DE0600UL))
#define bFM4_GPIO_PFRC_P1                      *((volatile unsigned char*)(0x42DE0604UL))
#define bFM4_GPIO_PFRC_P2                      *((volatile unsigned char*)(0x42DE0608UL))
#define bFM4_GPIO_PFRC_P3                      *((volatile unsigned char*)(0x42DE060CUL))
#define bFM4_GPIO_PFRC_P4                      *((volatile unsigned char*)(0x42DE0610UL))
#define bFM4_GPIO_PFRC_P5                      *((volatile unsigned char*)(0x42DE0614UL))
#define bFM4_GPIO_PFRC_P6                      *((volatile unsigned char*)(0x42DE0618UL))
#define bFM4_GPIO_PFRC_P7                      *((volatile unsigned char*)(0x42DE061CUL))
#define bFM4_GPIO_PFRC_P8                      *((volatile unsigned char*)(0x42DE0620UL))
#define bFM4_GPIO_PFRC_P9                      *((volatile unsigned char*)(0x42DE0624UL))
#define bFM4_GPIO_PFRC_PA                      *((volatile unsigned char*)(0x42DE0628UL))
#define bFM4_GPIO_PFRC_PB                      *((volatile unsigned char*)(0x42DE062CUL))
#define bFM4_GPIO_PFRC_PC                      *((volatile unsigned char*)(0x42DE0630UL))
#define bFM4_GPIO_PFRC_PD                      *((volatile unsigned char*)(0x42DE0634UL))
#define bFM4_GPIO_PFRC_PE                      *((volatile unsigned char*)(0x42DE0638UL))
#define bFM4_GPIO_PFRC_PF                      *((volatile unsigned char*)(0x42DE063CUL))
#define bFM4_GPIO_PFRD_P0                      *((volatile unsigned char*)(0x42DE0680UL))
#define bFM4_GPIO_PFRD_P1                      *((volatile unsigned char*)(0x42DE0684UL))
#define bFM4_GPIO_PFRD_P2                      *((volatile unsigned char*)(0x42DE0688UL))
#define bFM4_GPIO_PFRE_P0                      *((volatile unsigned char*)(0x42DE0700UL))
#define bFM4_GPIO_PFRE_P2                      *((volatile unsigned char*)(0x42DE0708UL))
#define bFM4_GPIO_PFRE_P3                      *((volatile unsigned char*)(0x42DE070CUL))
#define bFM4_GPIO_PFRF_P0                      *((volatile unsigned char*)(0x42DE0780UL))
#define bFM4_GPIO_PFRF_P1                      *((volatile unsigned char*)(0x42DE0784UL))
#define bFM4_GPIO_PFRF_P2                      *((volatile unsigned char*)(0x42DE0788UL))
#define bFM4_GPIO_PFRF_P3                      *((volatile unsigned char*)(0x42DE078CUL))
#define bFM4_GPIO_PFRF_P4                      *((volatile unsigned char*)(0x42DE0790UL))
#define bFM4_GPIO_PFRF_P5                      *((volatile unsigned char*)(0x42DE0794UL))
#define bFM4_GPIO_PFRF_P6                      *((volatile unsigned char*)(0x42DE0798UL))
#define bFM4_GPIO_PFRF_P7                      *((volatile unsigned char*)(0x42DE079CUL))
#define bFM4_GPIO_PFRF_P8                      *((volatile unsigned char*)(0x42DE07A0UL))
#define bFM4_GPIO_PFRF_P9                      *((volatile unsigned char*)(0x42DE07A4UL))
#define bFM4_GPIO_PFRF_PA                      *((volatile unsigned char*)(0x42DE07A8UL))
#define bFM4_GPIO_PFRF_PB                      *((volatile unsigned char*)(0x42DE07ACUL))
#define bFM4_GPIO_PFRF_PC                      *((volatile unsigned char*)(0x42DE07B0UL))
#define bFM4_GPIO_PCR0_P0                      *((volatile unsigned char*)(0x42DE2000UL))
#define bFM4_GPIO_PCR0_P1                      *((volatile unsigned char*)(0x42DE2004UL))
#define bFM4_GPIO_PCR0_P2                      *((volatile unsigned char*)(0x42DE2008UL))
#define bFM4_GPIO_PCR0_P3                      *((volatile unsigned char*)(0x42DE200CUL))
#define bFM4_GPIO_PCR0_P4                      *((volatile unsigned char*)(0x42DE2010UL))
#define bFM4_GPIO_PCR0_P8                      *((volatile unsigned char*)(0x42DE2020UL))
#define bFM4_GPIO_PCR0_P9                      *((volatile unsigned char*)(0x42DE2024UL))
#define bFM4_GPIO_PCR0_PA                      *((volatile unsigned char*)(0x42DE2028UL))
#define bFM4_GPIO_PCR1_P0                      *((volatile unsigned char*)(0x42DE2080UL))
#define bFM4_GPIO_PCR1_P1                      *((volatile unsigned char*)(0x42DE2084UL))
#define bFM4_GPIO_PCR1_P2                      *((volatile unsigned char*)(0x42DE2088UL))
#define bFM4_GPIO_PCR1_P3                      *((volatile unsigned char*)(0x42DE208CUL))
#define bFM4_GPIO_PCR1_P4                      *((volatile unsigned char*)(0x42DE2090UL))
#define bFM4_GPIO_PCR1_P5                      *((volatile unsigned char*)(0x42DE2094UL))
#define bFM4_GPIO_PCR1_P6                      *((volatile unsigned char*)(0x42DE2098UL))
#define bFM4_GPIO_PCR1_P7                      *((volatile unsigned char*)(0x42DE209CUL))
#define bFM4_GPIO_PCR1_P8                      *((volatile unsigned char*)(0x42DE20A0UL))
#define bFM4_GPIO_PCR1_P9                      *((volatile unsigned char*)(0x42DE20A4UL))
#define bFM4_GPIO_PCR1_PA                      *((volatile unsigned char*)(0x42DE20A8UL))
#define bFM4_GPIO_PCR1_PB                      *((volatile unsigned char*)(0x42DE20ACUL))
#define bFM4_GPIO_PCR1_PC                      *((volatile unsigned char*)(0x42DE20B0UL))
#define bFM4_GPIO_PCR1_PD                      *((volatile unsigned char*)(0x42DE20B4UL))
#define bFM4_GPIO_PCR1_PE                      *((volatile unsigned char*)(0x42DE20B8UL))
#define bFM4_GPIO_PCR1_PF                      *((volatile unsigned char*)(0x42DE20BCUL))
#define bFM4_GPIO_PCR2_P0                      *((volatile unsigned char*)(0x42DE2100UL))
#define bFM4_GPIO_PCR2_P1                      *((volatile unsigned char*)(0x42DE2104UL))
#define bFM4_GPIO_PCR2_P2                      *((volatile unsigned char*)(0x42DE2108UL))
#define bFM4_GPIO_PCR2_P3                      *((volatile unsigned char*)(0x42DE210CUL))
#define bFM4_GPIO_PCR2_P4                      *((volatile unsigned char*)(0x42DE2110UL))
#define bFM4_GPIO_PCR2_P5                      *((volatile unsigned char*)(0x42DE2114UL))
#define bFM4_GPIO_PCR2_P6                      *((volatile unsigned char*)(0x42DE2118UL))
#define bFM4_GPIO_PCR2_P7                      *((volatile unsigned char*)(0x42DE211CUL))
#define bFM4_GPIO_PCR2_P8                      *((volatile unsigned char*)(0x42DE2120UL))
#define bFM4_GPIO_PCR2_P9                      *((volatile unsigned char*)(0x42DE2124UL))
#define bFM4_GPIO_PCR2_PA                      *((volatile unsigned char*)(0x42DE2128UL))
#define bFM4_GPIO_PCR3_P0                      *((volatile unsigned char*)(0x42DE2180UL))
#define bFM4_GPIO_PCR3_P1                      *((volatile unsigned char*)(0x42DE2184UL))
#define bFM4_GPIO_PCR3_P2                      *((volatile unsigned char*)(0x42DE2188UL))
#define bFM4_GPIO_PCR3_P3                      *((volatile unsigned char*)(0x42DE218CUL))
#define bFM4_GPIO_PCR3_P4                      *((volatile unsigned char*)(0x42DE2190UL))
#define bFM4_GPIO_PCR3_P5                      *((volatile unsigned char*)(0x42DE2194UL))
#define bFM4_GPIO_PCR3_P6                      *((volatile unsigned char*)(0x42DE2198UL))
#define bFM4_GPIO_PCR3_P7                      *((volatile unsigned char*)(0x42DE219CUL))
#define bFM4_GPIO_PCR3_P8                      *((volatile unsigned char*)(0x42DE21A0UL))
#define bFM4_GPIO_PCR3_P9                      *((volatile unsigned char*)(0x42DE21A4UL))
#define bFM4_GPIO_PCR3_PA                      *((volatile unsigned char*)(0x42DE21A8UL))
#define bFM4_GPIO_PCR3_PB                      *((volatile unsigned char*)(0x42DE21ACUL))
#define bFM4_GPIO_PCR3_PC                      *((volatile unsigned char*)(0x42DE21B0UL))
#define bFM4_GPIO_PCR3_PD                      *((volatile unsigned char*)(0x42DE21B4UL))
#define bFM4_GPIO_PCR3_PE                      *((volatile unsigned char*)(0x42DE21B8UL))
#define bFM4_GPIO_PCR4_P0                      *((volatile unsigned char*)(0x42DE2200UL))
#define bFM4_GPIO_PCR4_P1                      *((volatile unsigned char*)(0x42DE2204UL))
#define bFM4_GPIO_PCR4_P2                      *((volatile unsigned char*)(0x42DE2208UL))
#define bFM4_GPIO_PCR4_P3                      *((volatile unsigned char*)(0x42DE220CUL))
#define bFM4_GPIO_PCR4_P4                      *((volatile unsigned char*)(0x42DE2210UL))
#define bFM4_GPIO_PCR4_P5                      *((volatile unsigned char*)(0x42DE2214UL))
#define bFM4_GPIO_PCR4_P6                      *((volatile unsigned char*)(0x42DE2218UL))
#define bFM4_GPIO_PCR4_P7                      *((volatile unsigned char*)(0x42DE221CUL))
#define bFM4_GPIO_PCR4_P8                      *((volatile unsigned char*)(0x42DE2220UL))
#define bFM4_GPIO_PCR4_P9                      *((volatile unsigned char*)(0x42DE2224UL))
#define bFM4_GPIO_PCR4_PA                      *((volatile unsigned char*)(0x42DE2228UL))
#define bFM4_GPIO_PCR4_PB                      *((volatile unsigned char*)(0x42DE222CUL))
#define bFM4_GPIO_PCR4_PC                      *((volatile unsigned char*)(0x42DE2230UL))
#define bFM4_GPIO_PCR4_PD                      *((volatile unsigned char*)(0x42DE2234UL))
#define bFM4_GPIO_PCR4_PE                      *((volatile unsigned char*)(0x42DE2238UL))
#define bFM4_GPIO_PCR5_P0                      *((volatile unsigned char*)(0x42DE2280UL))
#define bFM4_GPIO_PCR5_P1                      *((volatile unsigned char*)(0x42DE2284UL))
#define bFM4_GPIO_PCR5_P2                      *((volatile unsigned char*)(0x42DE2288UL))
#define bFM4_GPIO_PCR5_P3                      *((volatile unsigned char*)(0x42DE228CUL))
#define bFM4_GPIO_PCR5_P4                      *((volatile unsigned char*)(0x42DE2290UL))
#define bFM4_GPIO_PCR5_P5                      *((volatile unsigned char*)(0x42DE2294UL))
#define bFM4_GPIO_PCR5_P6                      *((volatile unsigned char*)(0x42DE2298UL))
#define bFM4_GPIO_PCR5_P7                      *((volatile unsigned char*)(0x42DE229CUL))
#define bFM4_GPIO_PCR5_P8                      *((volatile unsigned char*)(0x42DE22A0UL))
#define bFM4_GPIO_PCR5_P9                      *((volatile unsigned char*)(0x42DE22A4UL))
#define bFM4_GPIO_PCR5_PA                      *((volatile unsigned char*)(0x42DE22A8UL))
#define bFM4_GPIO_PCR5_PB                      *((volatile unsigned char*)(0x42DE22ACUL))
#define bFM4_GPIO_PCR5_PC                      *((volatile unsigned char*)(0x42DE22B0UL))
#define bFM4_GPIO_PCR5_PD                      *((volatile unsigned char*)(0x42DE22B4UL))
#define bFM4_GPIO_PCR5_PE                      *((volatile unsigned char*)(0x42DE22B8UL))
#define bFM4_GPIO_PCR5_PF                      *((volatile unsigned char*)(0x42DE22BCUL))
#define bFM4_GPIO_PCR6_P0                      *((volatile unsigned char*)(0x42DE2300UL))
#define bFM4_GPIO_PCR6_P1                      *((volatile unsigned char*)(0x42DE2304UL))
#define bFM4_GPIO_PCR6_P2                      *((volatile unsigned char*)(0x42DE2308UL))
#define bFM4_GPIO_PCR6_P3                      *((volatile unsigned char*)(0x42DE230CUL))
#define bFM4_GPIO_PCR6_P4                      *((volatile unsigned char*)(0x42DE2310UL))
#define bFM4_GPIO_PCR6_P5                      *((volatile unsigned char*)(0x42DE2314UL))
#define bFM4_GPIO_PCR6_P6                      *((volatile unsigned char*)(0x42DE2318UL))
#define bFM4_GPIO_PCR6_P7                      *((volatile unsigned char*)(0x42DE231CUL))
#define bFM4_GPIO_PCR6_P8                      *((volatile unsigned char*)(0x42DE2320UL))
#define bFM4_GPIO_PCR6_P9                      *((volatile unsigned char*)(0x42DE2324UL))
#define bFM4_GPIO_PCR6_PA                      *((volatile unsigned char*)(0x42DE2328UL))
#define bFM4_GPIO_PCR6_PB                      *((volatile unsigned char*)(0x42DE232CUL))
#define bFM4_GPIO_PCR6_PC                      *((volatile unsigned char*)(0x42DE2330UL))
#define bFM4_GPIO_PCR6_PD                      *((volatile unsigned char*)(0x42DE2334UL))
#define bFM4_GPIO_PCR6_PE                      *((volatile unsigned char*)(0x42DE2338UL))
#define bFM4_GPIO_PCR7_P0                      *((volatile unsigned char*)(0x42DE2380UL))
#define bFM4_GPIO_PCR7_P1                      *((volatile unsigned char*)(0x42DE2384UL))
#define bFM4_GPIO_PCR7_P2                      *((volatile unsigned char*)(0x42DE2388UL))
#define bFM4_GPIO_PCR7_P3                      *((volatile unsigned char*)(0x42DE238CUL))
#define bFM4_GPIO_PCR7_P4                      *((volatile unsigned char*)(0x42DE2390UL))
#define bFM4_GPIO_PCR7_P5                      *((volatile unsigned char*)(0x42DE2394UL))
#define bFM4_GPIO_PCR7_P6                      *((volatile unsigned char*)(0x42DE2398UL))
#define bFM4_GPIO_PCR7_P7                      *((volatile unsigned char*)(0x42DE239CUL))
#define bFM4_GPIO_PCR7_P8                      *((volatile unsigned char*)(0x42DE23A0UL))
#define bFM4_GPIO_PCR7_P9                      *((volatile unsigned char*)(0x42DE23A4UL))
#define bFM4_GPIO_PCR7_PA                      *((volatile unsigned char*)(0x42DE23A8UL))
#define bFM4_GPIO_PCR7_PB                      *((volatile unsigned char*)(0x42DE23ACUL))
#define bFM4_GPIO_PCR7_PC                      *((volatile unsigned char*)(0x42DE23B0UL))
#define bFM4_GPIO_PCR7_PD                      *((volatile unsigned char*)(0x42DE23B4UL))
#define bFM4_GPIO_PCR7_PE                      *((volatile unsigned char*)(0x42DE23B8UL))
#define bFM4_GPIO_PCR8_P0                      *((volatile unsigned char*)(0x42DE2400UL))
#define bFM4_GPIO_PCR8_P1                      *((volatile unsigned char*)(0x42DE2404UL))
#define bFM4_GPIO_PCR8_P2                      *((volatile unsigned char*)(0x42DE2408UL))
#define bFM4_GPIO_PCR8_P3                      *((volatile unsigned char*)(0x42DE240CUL))
#define bFM4_GPIO_PCR9_P0                      *((volatile unsigned char*)(0x42DE2480UL))
#define bFM4_GPIO_PCR9_P1                      *((volatile unsigned char*)(0x42DE2484UL))
#define bFM4_GPIO_PCR9_P2                      *((volatile unsigned char*)(0x42DE2488UL))
#define bFM4_GPIO_PCR9_P3                      *((volatile unsigned char*)(0x42DE248CUL))
#define bFM4_GPIO_PCR9_P4                      *((volatile unsigned char*)(0x42DE2490UL))
#define bFM4_GPIO_PCR9_P5                      *((volatile unsigned char*)(0x42DE2494UL))
#define bFM4_GPIO_PCR9_P6                      *((volatile unsigned char*)(0x42DE2498UL))
#define bFM4_GPIO_PCR9_P7                      *((volatile unsigned char*)(0x42DE249CUL))
#define bFM4_GPIO_PCRA_P0                      *((volatile unsigned char*)(0x42DE2500UL))
#define bFM4_GPIO_PCRA_P1                      *((volatile unsigned char*)(0x42DE2504UL))
#define bFM4_GPIO_PCRA_P2                      *((volatile unsigned char*)(0x42DE2508UL))
#define bFM4_GPIO_PCRA_P3                      *((volatile unsigned char*)(0x42DE250CUL))
#define bFM4_GPIO_PCRA_P4                      *((volatile unsigned char*)(0x42DE2510UL))
#define bFM4_GPIO_PCRA_P5                      *((volatile unsigned char*)(0x42DE2514UL))
#define bFM4_GPIO_PCRA_P6                      *((volatile unsigned char*)(0x42DE2518UL))
#define bFM4_GPIO_PCRA_P7                      *((volatile unsigned char*)(0x42DE251CUL))
#define bFM4_GPIO_PCRA_P8                      *((volatile unsigned char*)(0x42DE2520UL))
#define bFM4_GPIO_PCRA_P9                      *((volatile unsigned char*)(0x42DE2524UL))
#define bFM4_GPIO_PCRA_PA                      *((volatile unsigned char*)(0x42DE2528UL))
#define bFM4_GPIO_PCRA_PB                      *((volatile unsigned char*)(0x42DE252CUL))
#define bFM4_GPIO_PCRA_PC                      *((volatile unsigned char*)(0x42DE2530UL))
#define bFM4_GPIO_PCRA_PD                      *((volatile unsigned char*)(0x42DE2534UL))
#define bFM4_GPIO_PCRA_PE                      *((volatile unsigned char*)(0x42DE2538UL))
#define bFM4_GPIO_PCRA_PF                      *((volatile unsigned char*)(0x42DE253CUL))
#define bFM4_GPIO_PCRB_P0                      *((volatile unsigned char*)(0x42DE2580UL))
#define bFM4_GPIO_PCRB_P1                      *((volatile unsigned char*)(0x42DE2584UL))
#define bFM4_GPIO_PCRB_P2                      *((volatile unsigned char*)(0x42DE2588UL))
#define bFM4_GPIO_PCRB_P3                      *((volatile unsigned char*)(0x42DE258CUL))
#define bFM4_GPIO_PCRB_P4                      *((volatile unsigned char*)(0x42DE2590UL))
#define bFM4_GPIO_PCRB_P5                      *((volatile unsigned char*)(0x42DE2594UL))
#define bFM4_GPIO_PCRB_P6                      *((volatile unsigned char*)(0x42DE2598UL))
#define bFM4_GPIO_PCRB_P7                      *((volatile unsigned char*)(0x42DE259CUL))
#define bFM4_GPIO_PCRB_P8                      *((volatile unsigned char*)(0x42DE25A0UL))
#define bFM4_GPIO_PCRB_P9                      *((volatile unsigned char*)(0x42DE25A4UL))
#define bFM4_GPIO_PCRB_PA                      *((volatile unsigned char*)(0x42DE25A8UL))
#define bFM4_GPIO_PCRB_PB                      *((volatile unsigned char*)(0x42DE25ACUL))
#define bFM4_GPIO_PCRB_PC                      *((volatile unsigned char*)(0x42DE25B0UL))
#define bFM4_GPIO_PCRB_PD                      *((volatile unsigned char*)(0x42DE25B4UL))
#define bFM4_GPIO_PCRB_PE                      *((volatile unsigned char*)(0x42DE25B8UL))
#define bFM4_GPIO_PCRB_PF                      *((volatile unsigned char*)(0x42DE25BCUL))
#define bFM4_GPIO_PCRC_P0                      *((volatile unsigned char*)(0x42DE2600UL))
#define bFM4_GPIO_PCRC_P1                      *((volatile unsigned char*)(0x42DE2604UL))
#define bFM4_GPIO_PCRC_P2                      *((volatile unsigned char*)(0x42DE2608UL))
#define bFM4_GPIO_PCRC_P3                      *((volatile unsigned char*)(0x42DE260CUL))
#define bFM4_GPIO_PCRC_P4                      *((volatile unsigned char*)(0x42DE2610UL))
#define bFM4_GPIO_PCRC_P5                      *((volatile unsigned char*)(0x42DE2614UL))
#define bFM4_GPIO_PCRC_P6                      *((volatile unsigned char*)(0x42DE2618UL))
#define bFM4_GPIO_PCRC_P7                      *((volatile unsigned char*)(0x42DE261CUL))
#define bFM4_GPIO_PCRC_P8                      *((volatile unsigned char*)(0x42DE2620UL))
#define bFM4_GPIO_PCRC_P9                      *((volatile unsigned char*)(0x42DE2624UL))
#define bFM4_GPIO_PCRC_PA                      *((volatile unsigned char*)(0x42DE2628UL))
#define bFM4_GPIO_PCRC_PB                      *((volatile unsigned char*)(0x42DE262CUL))
#define bFM4_GPIO_PCRC_PC                      *((volatile unsigned char*)(0x42DE2630UL))
#define bFM4_GPIO_PCRC_PD                      *((volatile unsigned char*)(0x42DE2634UL))
#define bFM4_GPIO_PCRC_PE                      *((volatile unsigned char*)(0x42DE2638UL))
#define bFM4_GPIO_PCRC_PF                      *((volatile unsigned char*)(0x42DE263CUL))
#define bFM4_GPIO_PCRD_P0                      *((volatile unsigned char*)(0x42DE2680UL))
#define bFM4_GPIO_PCRD_P1                      *((volatile unsigned char*)(0x42DE2684UL))
#define bFM4_GPIO_PCRD_P2                      *((volatile unsigned char*)(0x42DE2688UL))
#define bFM4_GPIO_PCRE_P0                      *((volatile unsigned char*)(0x42DE2700UL))
#define bFM4_GPIO_PCRE_P2                      *((volatile unsigned char*)(0x42DE2708UL))
#define bFM4_GPIO_PCRE_P3                      *((volatile unsigned char*)(0x42DE270CUL))
#define bFM4_GPIO_PCRF_P0                      *((volatile unsigned char*)(0x42DE2780UL))
#define bFM4_GPIO_PCRF_P1                      *((volatile unsigned char*)(0x42DE2784UL))
#define bFM4_GPIO_PCRF_P2                      *((volatile unsigned char*)(0x42DE2788UL))
#define bFM4_GPIO_PCRF_P3                      *((volatile unsigned char*)(0x42DE278CUL))
#define bFM4_GPIO_PCRF_P4                      *((volatile unsigned char*)(0x42DE2790UL))
#define bFM4_GPIO_PCRF_P5                      *((volatile unsigned char*)(0x42DE2794UL))
#define bFM4_GPIO_PCRF_P6                      *((volatile unsigned char*)(0x42DE2798UL))
#define bFM4_GPIO_PCRF_P7                      *((volatile unsigned char*)(0x42DE279CUL))
#define bFM4_GPIO_PCRF_P8                      *((volatile unsigned char*)(0x42DE27A0UL))
#define bFM4_GPIO_PCRF_P9                      *((volatile unsigned char*)(0x42DE27A4UL))
#define bFM4_GPIO_PCRF_PA                      *((volatile unsigned char*)(0x42DE27A8UL))
#define bFM4_GPIO_PCRF_PB                      *((volatile unsigned char*)(0x42DE27ACUL))
#define bFM4_GPIO_PCRF_PC                      *((volatile unsigned char*)(0x42DE27B0UL))
#define bFM4_GPIO_DDR0_P0                      *((volatile unsigned char*)(0x42DE4000UL))
#define bFM4_GPIO_DDR0_P1                      *((volatile unsigned char*)(0x42DE4004UL))
#define bFM4_GPIO_DDR0_P2                      *((volatile unsigned char*)(0x42DE4008UL))
#define bFM4_GPIO_DDR0_P3                      *((volatile unsigned char*)(0x42DE400CUL))
#define bFM4_GPIO_DDR0_P4                      *((volatile unsigned char*)(0x42DE4010UL))
#define bFM4_GPIO_DDR0_P5                      *((volatile unsigned char*)(0x42DE4014UL))
#define bFM4_GPIO_DDR0_P6                      *((volatile unsigned char*)(0x42DE4018UL))
#define bFM4_GPIO_DDR0_P7                      *((volatile unsigned char*)(0x42DE401CUL))
#define bFM4_GPIO_DDR0_P8                      *((volatile unsigned char*)(0x42DE4020UL))
#define bFM4_GPIO_DDR0_P9                      *((volatile unsigned char*)(0x42DE4024UL))
#define bFM4_GPIO_DDR0_PA                      *((volatile unsigned char*)(0x42DE4028UL))
#define bFM4_GPIO_DDR0_PB                      *((volatile unsigned char*)(0x42DE402CUL))
#define bFM4_GPIO_DDR0_PC                      *((volatile unsigned char*)(0x42DE4030UL))
#define bFM4_GPIO_DDR0_PD                      *((volatile unsigned char*)(0x42DE4034UL))
#define bFM4_GPIO_DDR0_PE                      *((volatile unsigned char*)(0x42DE4038UL))
#define bFM4_GPIO_DDR1_P0                      *((volatile unsigned char*)(0x42DE4080UL))
#define bFM4_GPIO_DDR1_P1                      *((volatile unsigned char*)(0x42DE4084UL))
#define bFM4_GPIO_DDR1_P2                      *((volatile unsigned char*)(0x42DE4088UL))
#define bFM4_GPIO_DDR1_P3                      *((volatile unsigned char*)(0x42DE408CUL))
#define bFM4_GPIO_DDR1_P4                      *((volatile unsigned char*)(0x42DE4090UL))
#define bFM4_GPIO_DDR1_P5                      *((volatile unsigned char*)(0x42DE4094UL))
#define bFM4_GPIO_DDR1_P6                      *((volatile unsigned char*)(0x42DE4098UL))
#define bFM4_GPIO_DDR1_P7                      *((volatile unsigned char*)(0x42DE409CUL))
#define bFM4_GPIO_DDR1_P8                      *((volatile unsigned char*)(0x42DE40A0UL))
#define bFM4_GPIO_DDR1_P9                      *((volatile unsigned char*)(0x42DE40A4UL))
#define bFM4_GPIO_DDR1_PA                      *((volatile unsigned char*)(0x42DE40A8UL))
#define bFM4_GPIO_DDR1_PB                      *((volatile unsigned char*)(0x42DE40ACUL))
#define bFM4_GPIO_DDR1_PC                      *((volatile unsigned char*)(0x42DE40B0UL))
#define bFM4_GPIO_DDR1_PD                      *((volatile unsigned char*)(0x42DE40B4UL))
#define bFM4_GPIO_DDR1_PE                      *((volatile unsigned char*)(0x42DE40B8UL))
#define bFM4_GPIO_DDR1_PF                      *((volatile unsigned char*)(0x42DE40BCUL))
#define bFM4_GPIO_DDR2_P0                      *((volatile unsigned char*)(0x42DE4100UL))
#define bFM4_GPIO_DDR2_P1                      *((volatile unsigned char*)(0x42DE4104UL))
#define bFM4_GPIO_DDR2_P2                      *((volatile unsigned char*)(0x42DE4108UL))
#define bFM4_GPIO_DDR2_P3                      *((volatile unsigned char*)(0x42DE410CUL))
#define bFM4_GPIO_DDR2_P4                      *((volatile unsigned char*)(0x42DE4110UL))
#define bFM4_GPIO_DDR2_P5                      *((volatile unsigned char*)(0x42DE4114UL))
#define bFM4_GPIO_DDR2_P6                      *((volatile unsigned char*)(0x42DE4118UL))
#define bFM4_GPIO_DDR2_P7                      *((volatile unsigned char*)(0x42DE411CUL))
#define bFM4_GPIO_DDR2_P8                      *((volatile unsigned char*)(0x42DE4120UL))
#define bFM4_GPIO_DDR2_P9                      *((volatile unsigned char*)(0x42DE4124UL))
#define bFM4_GPIO_DDR2_PA                      *((volatile unsigned char*)(0x42DE4128UL))
#define bFM4_GPIO_DDR3_P0                      *((volatile unsigned char*)(0x42DE4180UL))
#define bFM4_GPIO_DDR3_P1                      *((volatile unsigned char*)(0x42DE4184UL))
#define bFM4_GPIO_DDR3_P2                      *((volatile unsigned char*)(0x42DE4188UL))
#define bFM4_GPIO_DDR3_P3                      *((volatile unsigned char*)(0x42DE418CUL))
#define bFM4_GPIO_DDR3_P4                      *((volatile unsigned char*)(0x42DE4190UL))
#define bFM4_GPIO_DDR3_P5                      *((volatile unsigned char*)(0x42DE4194UL))
#define bFM4_GPIO_DDR3_P6                      *((volatile unsigned char*)(0x42DE4198UL))
#define bFM4_GPIO_DDR3_P7                      *((volatile unsigned char*)(0x42DE419CUL))
#define bFM4_GPIO_DDR3_P8                      *((volatile unsigned char*)(0x42DE41A0UL))
#define bFM4_GPIO_DDR3_P9                      *((volatile unsigned char*)(0x42DE41A4UL))
#define bFM4_GPIO_DDR3_PA                      *((volatile unsigned char*)(0x42DE41A8UL))
#define bFM4_GPIO_DDR3_PB                      *((volatile unsigned char*)(0x42DE41ACUL))
#define bFM4_GPIO_DDR3_PC                      *((volatile unsigned char*)(0x42DE41B0UL))
#define bFM4_GPIO_DDR3_PD                      *((volatile unsigned char*)(0x42DE41B4UL))
#define bFM4_GPIO_DDR3_PE                      *((volatile unsigned char*)(0x42DE41B8UL))
#define bFM4_GPIO_DDR4_P0                      *((volatile unsigned char*)(0x42DE4200UL))
#define bFM4_GPIO_DDR4_P1                      *((volatile unsigned char*)(0x42DE4204UL))
#define bFM4_GPIO_DDR4_P2                      *((volatile unsigned char*)(0x42DE4208UL))
#define bFM4_GPIO_DDR4_P3                      *((volatile unsigned char*)(0x42DE420CUL))
#define bFM4_GPIO_DDR4_P4                      *((volatile unsigned char*)(0x42DE4210UL))
#define bFM4_GPIO_DDR4_P5                      *((volatile unsigned char*)(0x42DE4214UL))
#define bFM4_GPIO_DDR4_P6                      *((volatile unsigned char*)(0x42DE4218UL))
#define bFM4_GPIO_DDR4_P7                      *((volatile unsigned char*)(0x42DE421CUL))
#define bFM4_GPIO_DDR4_P8                      *((volatile unsigned char*)(0x42DE4220UL))
#define bFM4_GPIO_DDR4_P9                      *((volatile unsigned char*)(0x42DE4224UL))
#define bFM4_GPIO_DDR4_PA                      *((volatile unsigned char*)(0x42DE4228UL))
#define bFM4_GPIO_DDR4_PB                      *((volatile unsigned char*)(0x42DE422CUL))
#define bFM4_GPIO_DDR4_PC                      *((volatile unsigned char*)(0x42DE4230UL))
#define bFM4_GPIO_DDR4_PD                      *((volatile unsigned char*)(0x42DE4234UL))
#define bFM4_GPIO_DDR4_PE                      *((volatile unsigned char*)(0x42DE4238UL))
#define bFM4_GPIO_DDR5_P0                      *((volatile unsigned char*)(0x42DE4280UL))
#define bFM4_GPIO_DDR5_P1                      *((volatile unsigned char*)(0x42DE4284UL))
#define bFM4_GPIO_DDR5_P2                      *((volatile unsigned char*)(0x42DE4288UL))
#define bFM4_GPIO_DDR5_P3                      *((volatile unsigned char*)(0x42DE428CUL))
#define bFM4_GPIO_DDR5_P4                      *((volatile unsigned char*)(0x42DE4290UL))
#define bFM4_GPIO_DDR5_P5                      *((volatile unsigned char*)(0x42DE4294UL))
#define bFM4_GPIO_DDR5_P6                      *((volatile unsigned char*)(0x42DE4298UL))
#define bFM4_GPIO_DDR5_P7                      *((volatile unsigned char*)(0x42DE429CUL))
#define bFM4_GPIO_DDR5_P8                      *((volatile unsigned char*)(0x42DE42A0UL))
#define bFM4_GPIO_DDR5_P9                      *((volatile unsigned char*)(0x42DE42A4UL))
#define bFM4_GPIO_DDR5_PA                      *((volatile unsigned char*)(0x42DE42A8UL))
#define bFM4_GPIO_DDR5_PB                      *((volatile unsigned char*)(0x42DE42ACUL))
#define bFM4_GPIO_DDR5_PC                      *((volatile unsigned char*)(0x42DE42B0UL))
#define bFM4_GPIO_DDR5_PD                      *((volatile unsigned char*)(0x42DE42B4UL))
#define bFM4_GPIO_DDR5_PE                      *((volatile unsigned char*)(0x42DE42B8UL))
#define bFM4_GPIO_DDR5_PF                      *((volatile unsigned char*)(0x42DE42BCUL))
#define bFM4_GPIO_DDR6_P0                      *((volatile unsigned char*)(0x42DE4300UL))
#define bFM4_GPIO_DDR6_P1                      *((volatile unsigned char*)(0x42DE4304UL))
#define bFM4_GPIO_DDR6_P2                      *((volatile unsigned char*)(0x42DE4308UL))
#define bFM4_GPIO_DDR6_P3                      *((volatile unsigned char*)(0x42DE430CUL))
#define bFM4_GPIO_DDR6_P4                      *((volatile unsigned char*)(0x42DE4310UL))
#define bFM4_GPIO_DDR6_P5                      *((volatile unsigned char*)(0x42DE4314UL))
#define bFM4_GPIO_DDR6_P6                      *((volatile unsigned char*)(0x42DE4318UL))
#define bFM4_GPIO_DDR6_P7                      *((volatile unsigned char*)(0x42DE431CUL))
#define bFM4_GPIO_DDR6_P8                      *((volatile unsigned char*)(0x42DE4320UL))
#define bFM4_GPIO_DDR6_P9                      *((volatile unsigned char*)(0x42DE4324UL))
#define bFM4_GPIO_DDR6_PA                      *((volatile unsigned char*)(0x42DE4328UL))
#define bFM4_GPIO_DDR6_PB                      *((volatile unsigned char*)(0x42DE432CUL))
#define bFM4_GPIO_DDR6_PC                      *((volatile unsigned char*)(0x42DE4330UL))
#define bFM4_GPIO_DDR6_PD                      *((volatile unsigned char*)(0x42DE4334UL))
#define bFM4_GPIO_DDR6_PE                      *((volatile unsigned char*)(0x42DE4338UL))
#define bFM4_GPIO_DDR7_P0                      *((volatile unsigned char*)(0x42DE4380UL))
#define bFM4_GPIO_DDR7_P1                      *((volatile unsigned char*)(0x42DE4384UL))
#define bFM4_GPIO_DDR7_P2                      *((volatile unsigned char*)(0x42DE4388UL))
#define bFM4_GPIO_DDR7_P3                      *((volatile unsigned char*)(0x42DE438CUL))
#define bFM4_GPIO_DDR7_P4                      *((volatile unsigned char*)(0x42DE4390UL))
#define bFM4_GPIO_DDR7_P5                      *((volatile unsigned char*)(0x42DE4394UL))
#define bFM4_GPIO_DDR7_P6                      *((volatile unsigned char*)(0x42DE4398UL))
#define bFM4_GPIO_DDR7_P7                      *((volatile unsigned char*)(0x42DE439CUL))
#define bFM4_GPIO_DDR7_P8                      *((volatile unsigned char*)(0x42DE43A0UL))
#define bFM4_GPIO_DDR7_P9                      *((volatile unsigned char*)(0x42DE43A4UL))
#define bFM4_GPIO_DDR7_PA                      *((volatile unsigned char*)(0x42DE43A8UL))
#define bFM4_GPIO_DDR7_PB                      *((volatile unsigned char*)(0x42DE43ACUL))
#define bFM4_GPIO_DDR7_PC                      *((volatile unsigned char*)(0x42DE43B0UL))
#define bFM4_GPIO_DDR7_PD                      *((volatile unsigned char*)(0x42DE43B4UL))
#define bFM4_GPIO_DDR7_PE                      *((volatile unsigned char*)(0x42DE43B8UL))
#define bFM4_GPIO_DDR8_P0                      *((volatile unsigned char*)(0x42DE4400UL))
#define bFM4_GPIO_DDR8_P1                      *((volatile unsigned char*)(0x42DE4404UL))
#define bFM4_GPIO_DDR8_P2                      *((volatile unsigned char*)(0x42DE4408UL))
#define bFM4_GPIO_DDR8_P3                      *((volatile unsigned char*)(0x42DE440CUL))
#define bFM4_GPIO_DDR9_P0                      *((volatile unsigned char*)(0x42DE4480UL))
#define bFM4_GPIO_DDR9_P1                      *((volatile unsigned char*)(0x42DE4484UL))
#define bFM4_GPIO_DDR9_P2                      *((volatile unsigned char*)(0x42DE4488UL))
#define bFM4_GPIO_DDR9_P3                      *((volatile unsigned char*)(0x42DE448CUL))
#define bFM4_GPIO_DDR9_P4                      *((volatile unsigned char*)(0x42DE4490UL))
#define bFM4_GPIO_DDR9_P5                      *((volatile unsigned char*)(0x42DE4494UL))
#define bFM4_GPIO_DDR9_P6                      *((volatile unsigned char*)(0x42DE4498UL))
#define bFM4_GPIO_DDR9_P7                      *((volatile unsigned char*)(0x42DE449CUL))
#define bFM4_GPIO_DDRA_P0                      *((volatile unsigned char*)(0x42DE4500UL))
#define bFM4_GPIO_DDRA_P1                      *((volatile unsigned char*)(0x42DE4504UL))
#define bFM4_GPIO_DDRA_P2                      *((volatile unsigned char*)(0x42DE4508UL))
#define bFM4_GPIO_DDRA_P3                      *((volatile unsigned char*)(0x42DE450CUL))
#define bFM4_GPIO_DDRA_P4                      *((volatile unsigned char*)(0x42DE4510UL))
#define bFM4_GPIO_DDRA_P5                      *((volatile unsigned char*)(0x42DE4514UL))
#define bFM4_GPIO_DDRA_P6                      *((volatile unsigned char*)(0x42DE4518UL))
#define bFM4_GPIO_DDRA_P7                      *((volatile unsigned char*)(0x42DE451CUL))
#define bFM4_GPIO_DDRA_P8                      *((volatile unsigned char*)(0x42DE4520UL))
#define bFM4_GPIO_DDRA_P9                      *((volatile unsigned char*)(0x42DE4524UL))
#define bFM4_GPIO_DDRA_PA                      *((volatile unsigned char*)(0x42DE4528UL))
#define bFM4_GPIO_DDRA_PB                      *((volatile unsigned char*)(0x42DE452CUL))
#define bFM4_GPIO_DDRA_PC                      *((volatile unsigned char*)(0x42DE4530UL))
#define bFM4_GPIO_DDRA_PD                      *((volatile unsigned char*)(0x42DE4534UL))
#define bFM4_GPIO_DDRA_PE                      *((volatile unsigned char*)(0x42DE4538UL))
#define bFM4_GPIO_DDRA_PF                      *((volatile unsigned char*)(0x42DE453CUL))
#define bFM4_GPIO_DDRB_P0                      *((volatile unsigned char*)(0x42DE4580UL))
#define bFM4_GPIO_DDRB_P1                      *((volatile unsigned char*)(0x42DE4584UL))
#define bFM4_GPIO_DDRB_P2                      *((volatile unsigned char*)(0x42DE4588UL))
#define bFM4_GPIO_DDRB_P3                      *((volatile unsigned char*)(0x42DE458CUL))
#define bFM4_GPIO_DDRB_P4                      *((volatile unsigned char*)(0x42DE4590UL))
#define bFM4_GPIO_DDRB_P5                      *((volatile unsigned char*)(0x42DE4594UL))
#define bFM4_GPIO_DDRB_P6                      *((volatile unsigned char*)(0x42DE4598UL))
#define bFM4_GPIO_DDRB_P7                      *((volatile unsigned char*)(0x42DE459CUL))
#define bFM4_GPIO_DDRB_P8                      *((volatile unsigned char*)(0x42DE45A0UL))
#define bFM4_GPIO_DDRB_P9                      *((volatile unsigned char*)(0x42DE45A4UL))
#define bFM4_GPIO_DDRB_PA                      *((volatile unsigned char*)(0x42DE45A8UL))
#define bFM4_GPIO_DDRB_PB                      *((volatile unsigned char*)(0x42DE45ACUL))
#define bFM4_GPIO_DDRB_PC                      *((volatile unsigned char*)(0x42DE45B0UL))
#define bFM4_GPIO_DDRB_PD                      *((volatile unsigned char*)(0x42DE45B4UL))
#define bFM4_GPIO_DDRB_PE                      *((volatile unsigned char*)(0x42DE45B8UL))
#define bFM4_GPIO_DDRB_PF                      *((volatile unsigned char*)(0x42DE45BCUL))
#define bFM4_GPIO_DDRC_P0                      *((volatile unsigned char*)(0x42DE4600UL))
#define bFM4_GPIO_DDRC_P1                      *((volatile unsigned char*)(0x42DE4604UL))
#define bFM4_GPIO_DDRC_P2                      *((volatile unsigned char*)(0x42DE4608UL))
#define bFM4_GPIO_DDRC_P3                      *((volatile unsigned char*)(0x42DE460CUL))
#define bFM4_GPIO_DDRC_P4                      *((volatile unsigned char*)(0x42DE4610UL))
#define bFM4_GPIO_DDRC_P5                      *((volatile unsigned char*)(0x42DE4614UL))
#define bFM4_GPIO_DDRC_P6                      *((volatile unsigned char*)(0x42DE4618UL))
#define bFM4_GPIO_DDRC_P7                      *((volatile unsigned char*)(0x42DE461CUL))
#define bFM4_GPIO_DDRC_P8                      *((volatile unsigned char*)(0x42DE4620UL))
#define bFM4_GPIO_DDRC_P9                      *((volatile unsigned char*)(0x42DE4624UL))
#define bFM4_GPIO_DDRC_PA                      *((volatile unsigned char*)(0x42DE4628UL))
#define bFM4_GPIO_DDRC_PB                      *((volatile unsigned char*)(0x42DE462CUL))
#define bFM4_GPIO_DDRC_PC                      *((volatile unsigned char*)(0x42DE4630UL))
#define bFM4_GPIO_DDRC_PD                      *((volatile unsigned char*)(0x42DE4634UL))
#define bFM4_GPIO_DDRC_PE                      *((volatile unsigned char*)(0x42DE4638UL))
#define bFM4_GPIO_DDRC_PF                      *((volatile unsigned char*)(0x42DE463CUL))
#define bFM4_GPIO_DDRD_P0                      *((volatile unsigned char*)(0x42DE4680UL))
#define bFM4_GPIO_DDRD_P1                      *((volatile unsigned char*)(0x42DE4684UL))
#define bFM4_GPIO_DDRD_P2                      *((volatile unsigned char*)(0x42DE4688UL))
#define bFM4_GPIO_DDRE_P0                      *((volatile unsigned char*)(0x42DE4700UL))
#define bFM4_GPIO_DDRE_P2                      *((volatile unsigned char*)(0x42DE4708UL))
#define bFM4_GPIO_DDRE_P3                      *((volatile unsigned char*)(0x42DE470CUL))
#define bFM4_GPIO_DDRF_P0                      *((volatile unsigned char*)(0x42DE4780UL))
#define bFM4_GPIO_DDRF_P1                      *((volatile unsigned char*)(0x42DE4784UL))
#define bFM4_GPIO_DDRF_P2                      *((volatile unsigned char*)(0x42DE4788UL))
#define bFM4_GPIO_DDRF_P3                      *((volatile unsigned char*)(0x42DE478CUL))
#define bFM4_GPIO_DDRF_P4                      *((volatile unsigned char*)(0x42DE4790UL))
#define bFM4_GPIO_DDRF_P5                      *((volatile unsigned char*)(0x42DE4794UL))
#define bFM4_GPIO_DDRF_P6                      *((volatile unsigned char*)(0x42DE4798UL))
#define bFM4_GPIO_DDRF_P7                      *((volatile unsigned char*)(0x42DE479CUL))
#define bFM4_GPIO_DDRF_P8                      *((volatile unsigned char*)(0x42DE47A0UL))
#define bFM4_GPIO_DDRF_P9                      *((volatile unsigned char*)(0x42DE47A4UL))
#define bFM4_GPIO_DDRF_PA                      *((volatile unsigned char*)(0x42DE47A8UL))
#define bFM4_GPIO_DDRF_PB                      *((volatile unsigned char*)(0x42DE47ACUL))
#define bFM4_GPIO_DDRF_PC                      *((volatile unsigned char*)(0x42DE47B0UL))
#define bFM4_GPIO_PDIR0_P0                     *((volatile unsigned char*)(0x42DE6000UL))
#define bFM4_GPIO_PDIR0_P1                     *((volatile unsigned char*)(0x42DE6004UL))
#define bFM4_GPIO_PDIR0_P2                     *((volatile unsigned char*)(0x42DE6008UL))
#define bFM4_GPIO_PDIR0_P3                     *((volatile unsigned char*)(0x42DE600CUL))
#define bFM4_GPIO_PDIR0_P4                     *((volatile unsigned char*)(0x42DE6010UL))
#define bFM4_GPIO_PDIR0_P5                     *((volatile unsigned char*)(0x42DE6014UL))
#define bFM4_GPIO_PDIR0_P6                     *((volatile unsigned char*)(0x42DE6018UL))
#define bFM4_GPIO_PDIR0_P7                     *((volatile unsigned char*)(0x42DE601CUL))
#define bFM4_GPIO_PDIR0_P8                     *((volatile unsigned char*)(0x42DE6020UL))
#define bFM4_GPIO_PDIR0_P9                     *((volatile unsigned char*)(0x42DE6024UL))
#define bFM4_GPIO_PDIR0_PA                     *((volatile unsigned char*)(0x42DE6028UL))
#define bFM4_GPIO_PDIR0_PB                     *((volatile unsigned char*)(0x42DE602CUL))
#define bFM4_GPIO_PDIR0_PC                     *((volatile unsigned char*)(0x42DE6030UL))
#define bFM4_GPIO_PDIR0_PD                     *((volatile unsigned char*)(0x42DE6034UL))
#define bFM4_GPIO_PDIR0_PE                     *((volatile unsigned char*)(0x42DE6038UL))
#define bFM4_GPIO_PDIR1_P0                     *((volatile unsigned char*)(0x42DE6080UL))
#define bFM4_GPIO_PDIR1_P1                     *((volatile unsigned char*)(0x42DE6084UL))
#define bFM4_GPIO_PDIR1_P2                     *((volatile unsigned char*)(0x42DE6088UL))
#define bFM4_GPIO_PDIR1_P3                     *((volatile unsigned char*)(0x42DE608CUL))
#define bFM4_GPIO_PDIR1_P4                     *((volatile unsigned char*)(0x42DE6090UL))
#define bFM4_GPIO_PDIR1_P5                     *((volatile unsigned char*)(0x42DE6094UL))
#define bFM4_GPIO_PDIR1_P6                     *((volatile unsigned char*)(0x42DE6098UL))
#define bFM4_GPIO_PDIR1_P7                     *((volatile unsigned char*)(0x42DE609CUL))
#define bFM4_GPIO_PDIR1_P8                     *((volatile unsigned char*)(0x42DE60A0UL))
#define bFM4_GPIO_PDIR1_P9                     *((volatile unsigned char*)(0x42DE60A4UL))
#define bFM4_GPIO_PDIR1_PA                     *((volatile unsigned char*)(0x42DE60A8UL))
#define bFM4_GPIO_PDIR1_PB                     *((volatile unsigned char*)(0x42DE60ACUL))
#define bFM4_GPIO_PDIR1_PC                     *((volatile unsigned char*)(0x42DE60B0UL))
#define bFM4_GPIO_PDIR1_PD                     *((volatile unsigned char*)(0x42DE60B4UL))
#define bFM4_GPIO_PDIR1_PE                     *((volatile unsigned char*)(0x42DE60B8UL))
#define bFM4_GPIO_PDIR1_PF                     *((volatile unsigned char*)(0x42DE60BCUL))
#define bFM4_GPIO_PDIR2_P0                     *((volatile unsigned char*)(0x42DE6100UL))
#define bFM4_GPIO_PDIR2_P1                     *((volatile unsigned char*)(0x42DE6104UL))
#define bFM4_GPIO_PDIR2_P2                     *((volatile unsigned char*)(0x42DE6108UL))
#define bFM4_GPIO_PDIR2_P3                     *((volatile unsigned char*)(0x42DE610CUL))
#define bFM4_GPIO_PDIR2_P4                     *((volatile unsigned char*)(0x42DE6110UL))
#define bFM4_GPIO_PDIR2_P5                     *((volatile unsigned char*)(0x42DE6114UL))
#define bFM4_GPIO_PDIR2_P6                     *((volatile unsigned char*)(0x42DE6118UL))
#define bFM4_GPIO_PDIR2_P7                     *((volatile unsigned char*)(0x42DE611CUL))
#define bFM4_GPIO_PDIR2_P8                     *((volatile unsigned char*)(0x42DE6120UL))
#define bFM4_GPIO_PDIR2_P9                     *((volatile unsigned char*)(0x42DE6124UL))
#define bFM4_GPIO_PDIR2_PA                     *((volatile unsigned char*)(0x42DE6128UL))
#define bFM4_GPIO_PDIR3_P0                     *((volatile unsigned char*)(0x42DE6180UL))
#define bFM4_GPIO_PDIR3_P1                     *((volatile unsigned char*)(0x42DE6184UL))
#define bFM4_GPIO_PDIR3_P2                     *((volatile unsigned char*)(0x42DE6188UL))
#define bFM4_GPIO_PDIR3_P3                     *((volatile unsigned char*)(0x42DE618CUL))
#define bFM4_GPIO_PDIR3_P4                     *((volatile unsigned char*)(0x42DE6190UL))
#define bFM4_GPIO_PDIR3_P5                     *((volatile unsigned char*)(0x42DE6194UL))
#define bFM4_GPIO_PDIR3_P6                     *((volatile unsigned char*)(0x42DE6198UL))
#define bFM4_GPIO_PDIR3_P7                     *((volatile unsigned char*)(0x42DE619CUL))
#define bFM4_GPIO_PDIR3_P8                     *((volatile unsigned char*)(0x42DE61A0UL))
#define bFM4_GPIO_PDIR3_P9                     *((volatile unsigned char*)(0x42DE61A4UL))
#define bFM4_GPIO_PDIR3_PA                     *((volatile unsigned char*)(0x42DE61A8UL))
#define bFM4_GPIO_PDIR3_PB                     *((volatile unsigned char*)(0x42DE61ACUL))
#define bFM4_GPIO_PDIR3_PC                     *((volatile unsigned char*)(0x42DE61B0UL))
#define bFM4_GPIO_PDIR3_PD                     *((volatile unsigned char*)(0x42DE61B4UL))
#define bFM4_GPIO_PDIR3_PE                     *((volatile unsigned char*)(0x42DE61B8UL))
#define bFM4_GPIO_PDIR4_P0                     *((volatile unsigned char*)(0x42DE6200UL))
#define bFM4_GPIO_PDIR4_P1                     *((volatile unsigned char*)(0x42DE6204UL))
#define bFM4_GPIO_PDIR4_P2                     *((volatile unsigned char*)(0x42DE6208UL))
#define bFM4_GPIO_PDIR4_P3                     *((volatile unsigned char*)(0x42DE620CUL))
#define bFM4_GPIO_PDIR4_P4                     *((volatile unsigned char*)(0x42DE6210UL))
#define bFM4_GPIO_PDIR4_P5                     *((volatile unsigned char*)(0x42DE6214UL))
#define bFM4_GPIO_PDIR4_P6                     *((volatile unsigned char*)(0x42DE6218UL))
#define bFM4_GPIO_PDIR4_P7                     *((volatile unsigned char*)(0x42DE621CUL))
#define bFM4_GPIO_PDIR4_P8                     *((volatile unsigned char*)(0x42DE6220UL))
#define bFM4_GPIO_PDIR4_P9                     *((volatile unsigned char*)(0x42DE6224UL))
#define bFM4_GPIO_PDIR4_PA                     *((volatile unsigned char*)(0x42DE6228UL))
#define bFM4_GPIO_PDIR4_PB                     *((volatile unsigned char*)(0x42DE622CUL))
#define bFM4_GPIO_PDIR4_PC                     *((volatile unsigned char*)(0x42DE6230UL))
#define bFM4_GPIO_PDIR4_PD                     *((volatile unsigned char*)(0x42DE6234UL))
#define bFM4_GPIO_PDIR4_PE                     *((volatile unsigned char*)(0x42DE6238UL))
#define bFM4_GPIO_PDIR5_P0                     *((volatile unsigned char*)(0x42DE6280UL))
#define bFM4_GPIO_PDIR5_P1                     *((volatile unsigned char*)(0x42DE6284UL))
#define bFM4_GPIO_PDIR5_P2                     *((volatile unsigned char*)(0x42DE6288UL))
#define bFM4_GPIO_PDIR5_P3                     *((volatile unsigned char*)(0x42DE628CUL))
#define bFM4_GPIO_PDIR5_P4                     *((volatile unsigned char*)(0x42DE6290UL))
#define bFM4_GPIO_PDIR5_P5                     *((volatile unsigned char*)(0x42DE6294UL))
#define bFM4_GPIO_PDIR5_P6                     *((volatile unsigned char*)(0x42DE6298UL))
#define bFM4_GPIO_PDIR5_P7                     *((volatile unsigned char*)(0x42DE629CUL))
#define bFM4_GPIO_PDIR5_P8                     *((volatile unsigned char*)(0x42DE62A0UL))
#define bFM4_GPIO_PDIR5_P9                     *((volatile unsigned char*)(0x42DE62A4UL))
#define bFM4_GPIO_PDIR5_PA                     *((volatile unsigned char*)(0x42DE62A8UL))
#define bFM4_GPIO_PDIR5_PB                     *((volatile unsigned char*)(0x42DE62ACUL))
#define bFM4_GPIO_PDIR5_PC                     *((volatile unsigned char*)(0x42DE62B0UL))
#define bFM4_GPIO_PDIR5_PD                     *((volatile unsigned char*)(0x42DE62B4UL))
#define bFM4_GPIO_PDIR5_PE                     *((volatile unsigned char*)(0x42DE62B8UL))
#define bFM4_GPIO_PDIR5_PF                     *((volatile unsigned char*)(0x42DE62BCUL))
#define bFM4_GPIO_PDIR6_P0                     *((volatile unsigned char*)(0x42DE6300UL))
#define bFM4_GPIO_PDIR6_P1                     *((volatile unsigned char*)(0x42DE6304UL))
#define bFM4_GPIO_PDIR6_P2                     *((volatile unsigned char*)(0x42DE6308UL))
#define bFM4_GPIO_PDIR6_P3                     *((volatile unsigned char*)(0x42DE630CUL))
#define bFM4_GPIO_PDIR6_P4                     *((volatile unsigned char*)(0x42DE6310UL))
#define bFM4_GPIO_PDIR6_P5                     *((volatile unsigned char*)(0x42DE6314UL))
#define bFM4_GPIO_PDIR6_P6                     *((volatile unsigned char*)(0x42DE6318UL))
#define bFM4_GPIO_PDIR6_P7                     *((volatile unsigned char*)(0x42DE631CUL))
#define bFM4_GPIO_PDIR6_P8                     *((volatile unsigned char*)(0x42DE6320UL))
#define bFM4_GPIO_PDIR6_P9                     *((volatile unsigned char*)(0x42DE6324UL))
#define bFM4_GPIO_PDIR6_PA                     *((volatile unsigned char*)(0x42DE6328UL))
#define bFM4_GPIO_PDIR6_PB                     *((volatile unsigned char*)(0x42DE632CUL))
#define bFM4_GPIO_PDIR6_PC                     *((volatile unsigned char*)(0x42DE6330UL))
#define bFM4_GPIO_PDIR6_PD                     *((volatile unsigned char*)(0x42DE6334UL))
#define bFM4_GPIO_PDIR6_PE                     *((volatile unsigned char*)(0x42DE6338UL))
#define bFM4_GPIO_PDIR7_P0                     *((volatile unsigned char*)(0x42DE6380UL))
#define bFM4_GPIO_PDIR7_P1                     *((volatile unsigned char*)(0x42DE6384UL))
#define bFM4_GPIO_PDIR7_P2                     *((volatile unsigned char*)(0x42DE6388UL))
#define bFM4_GPIO_PDIR7_P3                     *((volatile unsigned char*)(0x42DE638CUL))
#define bFM4_GPIO_PDIR7_P4                     *((volatile unsigned char*)(0x42DE6390UL))
#define bFM4_GPIO_PDIR7_P5                     *((volatile unsigned char*)(0x42DE6394UL))
#define bFM4_GPIO_PDIR7_P6                     *((volatile unsigned char*)(0x42DE6398UL))
#define bFM4_GPIO_PDIR7_P7                     *((volatile unsigned char*)(0x42DE639CUL))
#define bFM4_GPIO_PDIR7_P8                     *((volatile unsigned char*)(0x42DE63A0UL))
#define bFM4_GPIO_PDIR7_P9                     *((volatile unsigned char*)(0x42DE63A4UL))
#define bFM4_GPIO_PDIR7_PA                     *((volatile unsigned char*)(0x42DE63A8UL))
#define bFM4_GPIO_PDIR7_PB                     *((volatile unsigned char*)(0x42DE63ACUL))
#define bFM4_GPIO_PDIR7_PC                     *((volatile unsigned char*)(0x42DE63B0UL))
#define bFM4_GPIO_PDIR7_PD                     *((volatile unsigned char*)(0x42DE63B4UL))
#define bFM4_GPIO_PDIR7_PE                     *((volatile unsigned char*)(0x42DE63B8UL))
#define bFM4_GPIO_PDIR8_P0                     *((volatile unsigned char*)(0x42DE6400UL))
#define bFM4_GPIO_PDIR8_P1                     *((volatile unsigned char*)(0x42DE6404UL))
#define bFM4_GPIO_PDIR8_P2                     *((volatile unsigned char*)(0x42DE6408UL))
#define bFM4_GPIO_PDIR8_P3                     *((volatile unsigned char*)(0x42DE640CUL))
#define bFM4_GPIO_PDIR9_P0                     *((volatile unsigned char*)(0x42DE6480UL))
#define bFM4_GPIO_PDIR9_P1                     *((volatile unsigned char*)(0x42DE6484UL))
#define bFM4_GPIO_PDIR9_P2                     *((volatile unsigned char*)(0x42DE6488UL))
#define bFM4_GPIO_PDIR9_P3                     *((volatile unsigned char*)(0x42DE648CUL))
#define bFM4_GPIO_PDIR9_P4                     *((volatile unsigned char*)(0x42DE6490UL))
#define bFM4_GPIO_PDIR9_P5                     *((volatile unsigned char*)(0x42DE6494UL))
#define bFM4_GPIO_PDIR9_P6                     *((volatile unsigned char*)(0x42DE6498UL))
#define bFM4_GPIO_PDIR9_P7                     *((volatile unsigned char*)(0x42DE649CUL))
#define bFM4_GPIO_PDIRA_P0                     *((volatile unsigned char*)(0x42DE6500UL))
#define bFM4_GPIO_PDIRA_P1                     *((volatile unsigned char*)(0x42DE6504UL))
#define bFM4_GPIO_PDIRA_P2                     *((volatile unsigned char*)(0x42DE6508UL))
#define bFM4_GPIO_PDIRA_P3                     *((volatile unsigned char*)(0x42DE650CUL))
#define bFM4_GPIO_PDIRA_P4                     *((volatile unsigned char*)(0x42DE6510UL))
#define bFM4_GPIO_PDIRA_P5                     *((volatile unsigned char*)(0x42DE6514UL))
#define bFM4_GPIO_PDIRA_P6                     *((volatile unsigned char*)(0x42DE6518UL))
#define bFM4_GPIO_PDIRA_P7                     *((volatile unsigned char*)(0x42DE651CUL))
#define bFM4_GPIO_PDIRA_P8                     *((volatile unsigned char*)(0x42DE6520UL))
#define bFM4_GPIO_PDIRA_P9                     *((volatile unsigned char*)(0x42DE6524UL))
#define bFM4_GPIO_PDIRA_PA                     *((volatile unsigned char*)(0x42DE6528UL))
#define bFM4_GPIO_PDIRA_PB                     *((volatile unsigned char*)(0x42DE652CUL))
#define bFM4_GPIO_PDIRA_PC                     *((volatile unsigned char*)(0x42DE6530UL))
#define bFM4_GPIO_PDIRA_PD                     *((volatile unsigned char*)(0x42DE6534UL))
#define bFM4_GPIO_PDIRA_PE                     *((volatile unsigned char*)(0x42DE6538UL))
#define bFM4_GPIO_PDIRA_PF                     *((volatile unsigned char*)(0x42DE653CUL))
#define bFM4_GPIO_PDIRB_P0                     *((volatile unsigned char*)(0x42DE6580UL))
#define bFM4_GPIO_PDIRB_P1                     *((volatile unsigned char*)(0x42DE6584UL))
#define bFM4_GPIO_PDIRB_P2                     *((volatile unsigned char*)(0x42DE6588UL))
#define bFM4_GPIO_PDIRB_P3                     *((volatile unsigned char*)(0x42DE658CUL))
#define bFM4_GPIO_PDIRB_P4                     *((volatile unsigned char*)(0x42DE6590UL))
#define bFM4_GPIO_PDIRB_P5                     *((volatile unsigned char*)(0x42DE6594UL))
#define bFM4_GPIO_PDIRB_P6                     *((volatile unsigned char*)(0x42DE6598UL))
#define bFM4_GPIO_PDIRB_P7                     *((volatile unsigned char*)(0x42DE659CUL))
#define bFM4_GPIO_PDIRB_P8                     *((volatile unsigned char*)(0x42DE65A0UL))
#define bFM4_GPIO_PDIRB_P9                     *((volatile unsigned char*)(0x42DE65A4UL))
#define bFM4_GPIO_PDIRB_PA                     *((volatile unsigned char*)(0x42DE65A8UL))
#define bFM4_GPIO_PDIRB_PB                     *((volatile unsigned char*)(0x42DE65ACUL))
#define bFM4_GPIO_PDIRB_PC                     *((volatile unsigned char*)(0x42DE65B0UL))
#define bFM4_GPIO_PDIRB_PD                     *((volatile unsigned char*)(0x42DE65B4UL))
#define bFM4_GPIO_PDIRB_PE                     *((volatile unsigned char*)(0x42DE65B8UL))
#define bFM4_GPIO_PDIRB_PF                     *((volatile unsigned char*)(0x42DE65BCUL))
#define bFM4_GPIO_PDIRC_P0                     *((volatile unsigned char*)(0x42DE6600UL))
#define bFM4_GPIO_PDIRC_P1                     *((volatile unsigned char*)(0x42DE6604UL))
#define bFM4_GPIO_PDIRC_P2                     *((volatile unsigned char*)(0x42DE6608UL))
#define bFM4_GPIO_PDIRC_P3                     *((volatile unsigned char*)(0x42DE660CUL))
#define bFM4_GPIO_PDIRC_P4                     *((volatile unsigned char*)(0x42DE6610UL))
#define bFM4_GPIO_PDIRC_P5                     *((volatile unsigned char*)(0x42DE6614UL))
#define bFM4_GPIO_PDIRC_P6                     *((volatile unsigned char*)(0x42DE6618UL))
#define bFM4_GPIO_PDIRC_P7                     *((volatile unsigned char*)(0x42DE661CUL))
#define bFM4_GPIO_PDIRC_P8                     *((volatile unsigned char*)(0x42DE6620UL))
#define bFM4_GPIO_PDIRC_P9                     *((volatile unsigned char*)(0x42DE6624UL))
#define bFM4_GPIO_PDIRC_PA                     *((volatile unsigned char*)(0x42DE6628UL))
#define bFM4_GPIO_PDIRC_PB                     *((volatile unsigned char*)(0x42DE662CUL))
#define bFM4_GPIO_PDIRC_PC                     *((volatile unsigned char*)(0x42DE6630UL))
#define bFM4_GPIO_PDIRC_PD                     *((volatile unsigned char*)(0x42DE6634UL))
#define bFM4_GPIO_PDIRC_PE                     *((volatile unsigned char*)(0x42DE6638UL))
#define bFM4_GPIO_PDIRC_PF                     *((volatile unsigned char*)(0x42DE663CUL))
#define bFM4_GPIO_PDIRD_P0                     *((volatile unsigned char*)(0x42DE6680UL))
#define bFM4_GPIO_PDIRD_P1                     *((volatile unsigned char*)(0x42DE6684UL))
#define bFM4_GPIO_PDIRD_P2                     *((volatile unsigned char*)(0x42DE6688UL))
#define bFM4_GPIO_PDIRE_P0                     *((volatile unsigned char*)(0x42DE6700UL))
#define bFM4_GPIO_PDIRE_P2                     *((volatile unsigned char*)(0x42DE6708UL))
#define bFM4_GPIO_PDIRE_P3                     *((volatile unsigned char*)(0x42DE670CUL))
#define bFM4_GPIO_PDIRF_P0                     *((volatile unsigned char*)(0x42DE6780UL))
#define bFM4_GPIO_PDIRF_P1                     *((volatile unsigned char*)(0x42DE6784UL))
#define bFM4_GPIO_PDIRF_P2                     *((volatile unsigned char*)(0x42DE6788UL))
#define bFM4_GPIO_PDIRF_P3                     *((volatile unsigned char*)(0x42DE678CUL))
#define bFM4_GPIO_PDIRF_P4                     *((volatile unsigned char*)(0x42DE6790UL))
#define bFM4_GPIO_PDIRF_P5                     *((volatile unsigned char*)(0x42DE6794UL))
#define bFM4_GPIO_PDIRF_P6                     *((volatile unsigned char*)(0x42DE6798UL))
#define bFM4_GPIO_PDIRF_P7                     *((volatile unsigned char*)(0x42DE679CUL))
#define bFM4_GPIO_PDIRF_P8                     *((volatile unsigned char*)(0x42DE67A0UL))
#define bFM4_GPIO_PDIRF_P9                     *((volatile unsigned char*)(0x42DE67A4UL))
#define bFM4_GPIO_PDIRF_PA                     *((volatile unsigned char*)(0x42DE67A8UL))
#define bFM4_GPIO_PDIRF_PB                     *((volatile unsigned char*)(0x42DE67ACUL))
#define bFM4_GPIO_PDIRF_PC                     *((volatile unsigned char*)(0x42DE67B0UL))
#define bFM4_GPIO_PDOR0_P0                     *((volatile unsigned char*)(0x42DE8000UL))
#define bFM4_GPIO_PDOR0_P1                     *((volatile unsigned char*)(0x42DE8004UL))
#define bFM4_GPIO_PDOR0_P2                     *((volatile unsigned char*)(0x42DE8008UL))
#define bFM4_GPIO_PDOR0_P3                     *((volatile unsigned char*)(0x42DE800CUL))
#define bFM4_GPIO_PDOR0_P4                     *((volatile unsigned char*)(0x42DE8010UL))
#define bFM4_GPIO_PDOR0_P5                     *((volatile unsigned char*)(0x42DE8014UL))
#define bFM4_GPIO_PDOR0_P6                     *((volatile unsigned char*)(0x42DE8018UL))
#define bFM4_GPIO_PDOR0_P7                     *((volatile unsigned char*)(0x42DE801CUL))
#define bFM4_GPIO_PDOR0_P8                     *((volatile unsigned char*)(0x42DE8020UL))
#define bFM4_GPIO_PDOR0_P9                     *((volatile unsigned char*)(0x42DE8024UL))
#define bFM4_GPIO_PDOR0_PA                     *((volatile unsigned char*)(0x42DE8028UL))
#define bFM4_GPIO_PDOR0_PB                     *((volatile unsigned char*)(0x42DE802CUL))
#define bFM4_GPIO_PDOR0_PC                     *((volatile unsigned char*)(0x42DE8030UL))
#define bFM4_GPIO_PDOR0_PD                     *((volatile unsigned char*)(0x42DE8034UL))
#define bFM4_GPIO_PDOR0_PE                     *((volatile unsigned char*)(0x42DE8038UL))
#define bFM4_GPIO_PDOR1_P0                     *((volatile unsigned char*)(0x42DE8080UL))
#define bFM4_GPIO_PDOR1_P1                     *((volatile unsigned char*)(0x42DE8084UL))
#define bFM4_GPIO_PDOR1_P2                     *((volatile unsigned char*)(0x42DE8088UL))
#define bFM4_GPIO_PDOR1_P3                     *((volatile unsigned char*)(0x42DE808CUL))
#define bFM4_GPIO_PDOR1_P4                     *((volatile unsigned char*)(0x42DE8090UL))
#define bFM4_GPIO_PDOR1_P5                     *((volatile unsigned char*)(0x42DE8094UL))
#define bFM4_GPIO_PDOR1_P6                     *((volatile unsigned char*)(0x42DE8098UL))
#define bFM4_GPIO_PDOR1_P7                     *((volatile unsigned char*)(0x42DE809CUL))
#define bFM4_GPIO_PDOR1_P8                     *((volatile unsigned char*)(0x42DE80A0UL))
#define bFM4_GPIO_PDOR1_P9                     *((volatile unsigned char*)(0x42DE80A4UL))
#define bFM4_GPIO_PDOR1_PA                     *((volatile unsigned char*)(0x42DE80A8UL))
#define bFM4_GPIO_PDOR1_PB                     *((volatile unsigned char*)(0x42DE80ACUL))
#define bFM4_GPIO_PDOR1_PC                     *((volatile unsigned char*)(0x42DE80B0UL))
#define bFM4_GPIO_PDOR1_PD                     *((volatile unsigned char*)(0x42DE80B4UL))
#define bFM4_GPIO_PDOR1_PE                     *((volatile unsigned char*)(0x42DE80B8UL))
#define bFM4_GPIO_PDOR1_PF                     *((volatile unsigned char*)(0x42DE80BCUL))
#define bFM4_GPIO_PDOR2_P0                     *((volatile unsigned char*)(0x42DE8100UL))
#define bFM4_GPIO_PDOR2_P1                     *((volatile unsigned char*)(0x42DE8104UL))
#define bFM4_GPIO_PDOR2_P2                     *((volatile unsigned char*)(0x42DE8108UL))
#define bFM4_GPIO_PDOR2_P3                     *((volatile unsigned char*)(0x42DE810CUL))
#define bFM4_GPIO_PDOR2_P4                     *((volatile unsigned char*)(0x42DE8110UL))
#define bFM4_GPIO_PDOR2_P5                     *((volatile unsigned char*)(0x42DE8114UL))
#define bFM4_GPIO_PDOR2_P6                     *((volatile unsigned char*)(0x42DE8118UL))
#define bFM4_GPIO_PDOR2_P7                     *((volatile unsigned char*)(0x42DE811CUL))
#define bFM4_GPIO_PDOR2_P8                     *((volatile unsigned char*)(0x42DE8120UL))
#define bFM4_GPIO_PDOR2_P9                     *((volatile unsigned char*)(0x42DE8124UL))
#define bFM4_GPIO_PDOR2_PA                     *((volatile unsigned char*)(0x42DE8128UL))
#define bFM4_GPIO_PDOR3_P0                     *((volatile unsigned char*)(0x42DE8180UL))
#define bFM4_GPIO_PDOR3_P1                     *((volatile unsigned char*)(0x42DE8184UL))
#define bFM4_GPIO_PDOR3_P2                     *((volatile unsigned char*)(0x42DE8188UL))
#define bFM4_GPIO_PDOR3_P3                     *((volatile unsigned char*)(0x42DE818CUL))
#define bFM4_GPIO_PDOR3_P4                     *((volatile unsigned char*)(0x42DE8190UL))
#define bFM4_GPIO_PDOR3_P5                     *((volatile unsigned char*)(0x42DE8194UL))
#define bFM4_GPIO_PDOR3_P6                     *((volatile unsigned char*)(0x42DE8198UL))
#define bFM4_GPIO_PDOR3_P7                     *((volatile unsigned char*)(0x42DE819CUL))
#define bFM4_GPIO_PDOR3_P8                     *((volatile unsigned char*)(0x42DE81A0UL))
#define bFM4_GPIO_PDOR3_P9                     *((volatile unsigned char*)(0x42DE81A4UL))
#define bFM4_GPIO_PDOR3_PA                     *((volatile unsigned char*)(0x42DE81A8UL))
#define bFM4_GPIO_PDOR3_PB                     *((volatile unsigned char*)(0x42DE81ACUL))
#define bFM4_GPIO_PDOR3_PC                     *((volatile unsigned char*)(0x42DE81B0UL))
#define bFM4_GPIO_PDOR3_PD                     *((volatile unsigned char*)(0x42DE81B4UL))
#define bFM4_GPIO_PDOR3_PE                     *((volatile unsigned char*)(0x42DE81B8UL))
#define bFM4_GPIO_PDOR4_P0                     *((volatile unsigned char*)(0x42DE8200UL))
#define bFM4_GPIO_PDOR4_P1                     *((volatile unsigned char*)(0x42DE8204UL))
#define bFM4_GPIO_PDOR4_P2                     *((volatile unsigned char*)(0x42DE8208UL))
#define bFM4_GPIO_PDOR4_P3                     *((volatile unsigned char*)(0x42DE820CUL))
#define bFM4_GPIO_PDOR4_P4                     *((volatile unsigned char*)(0x42DE8210UL))
#define bFM4_GPIO_PDOR4_P5                     *((volatile unsigned char*)(0x42DE8214UL))
#define bFM4_GPIO_PDOR4_P6                     *((volatile unsigned char*)(0x42DE8218UL))
#define bFM4_GPIO_PDOR4_P7                     *((volatile unsigned char*)(0x42DE821CUL))
#define bFM4_GPIO_PDOR4_P8                     *((volatile unsigned char*)(0x42DE8220UL))
#define bFM4_GPIO_PDOR4_P9                     *((volatile unsigned char*)(0x42DE8224UL))
#define bFM4_GPIO_PDOR4_PA                     *((volatile unsigned char*)(0x42DE8228UL))
#define bFM4_GPIO_PDOR4_PB                     *((volatile unsigned char*)(0x42DE822CUL))
#define bFM4_GPIO_PDOR4_PC                     *((volatile unsigned char*)(0x42DE8230UL))
#define bFM4_GPIO_PDOR4_PD                     *((volatile unsigned char*)(0x42DE8234UL))
#define bFM4_GPIO_PDOR4_PE                     *((volatile unsigned char*)(0x42DE8238UL))
#define bFM4_GPIO_PDOR5_P0                     *((volatile unsigned char*)(0x42DE8280UL))
#define bFM4_GPIO_PDOR5_P1                     *((volatile unsigned char*)(0x42DE8284UL))
#define bFM4_GPIO_PDOR5_P2                     *((volatile unsigned char*)(0x42DE8288UL))
#define bFM4_GPIO_PDOR5_P3                     *((volatile unsigned char*)(0x42DE828CUL))
#define bFM4_GPIO_PDOR5_P4                     *((volatile unsigned char*)(0x42DE8290UL))
#define bFM4_GPIO_PDOR5_P5                     *((volatile unsigned char*)(0x42DE8294UL))
#define bFM4_GPIO_PDOR5_P6                     *((volatile unsigned char*)(0x42DE8298UL))
#define bFM4_GPIO_PDOR5_P7                     *((volatile unsigned char*)(0x42DE829CUL))
#define bFM4_GPIO_PDOR5_P8                     *((volatile unsigned char*)(0x42DE82A0UL))
#define bFM4_GPIO_PDOR5_P9                     *((volatile unsigned char*)(0x42DE82A4UL))
#define bFM4_GPIO_PDOR5_PA                     *((volatile unsigned char*)(0x42DE82A8UL))
#define bFM4_GPIO_PDOR5_PB                     *((volatile unsigned char*)(0x42DE82ACUL))
#define bFM4_GPIO_PDOR5_PC                     *((volatile unsigned char*)(0x42DE82B0UL))
#define bFM4_GPIO_PDOR5_PD                     *((volatile unsigned char*)(0x42DE82B4UL))
#define bFM4_GPIO_PDOR5_PE                     *((volatile unsigned char*)(0x42DE82B8UL))
#define bFM4_GPIO_PDOR5_PF                     *((volatile unsigned char*)(0x42DE82BCUL))
#define bFM4_GPIO_PDOR6_P0                     *((volatile unsigned char*)(0x42DE8300UL))
#define bFM4_GPIO_PDOR6_P1                     *((volatile unsigned char*)(0x42DE8304UL))
#define bFM4_GPIO_PDOR6_P2                     *((volatile unsigned char*)(0x42DE8308UL))
#define bFM4_GPIO_PDOR6_P3                     *((volatile unsigned char*)(0x42DE830CUL))
#define bFM4_GPIO_PDOR6_P4                     *((volatile unsigned char*)(0x42DE8310UL))
#define bFM4_GPIO_PDOR6_P5                     *((volatile unsigned char*)(0x42DE8314UL))
#define bFM4_GPIO_PDOR6_P6                     *((volatile unsigned char*)(0x42DE8318UL))
#define bFM4_GPIO_PDOR6_P7                     *((volatile unsigned char*)(0x42DE831CUL))
#define bFM4_GPIO_PDOR6_P8                     *((volatile unsigned char*)(0x42DE8320UL))
#define bFM4_GPIO_PDOR6_P9                     *((volatile unsigned char*)(0x42DE8324UL))
#define bFM4_GPIO_PDOR6_PA                     *((volatile unsigned char*)(0x42DE8328UL))
#define bFM4_GPIO_PDOR6_PB                     *((volatile unsigned char*)(0x42DE832CUL))
#define bFM4_GPIO_PDOR6_PC                     *((volatile unsigned char*)(0x42DE8330UL))
#define bFM4_GPIO_PDOR6_PD                     *((volatile unsigned char*)(0x42DE8334UL))
#define bFM4_GPIO_PDOR6_PE                     *((volatile unsigned char*)(0x42DE8338UL))
#define bFM4_GPIO_PDOR7_P0                     *((volatile unsigned char*)(0x42DE8380UL))
#define bFM4_GPIO_PDOR7_P1                     *((volatile unsigned char*)(0x42DE8384UL))
#define bFM4_GPIO_PDOR7_P2                     *((volatile unsigned char*)(0x42DE8388UL))
#define bFM4_GPIO_PDOR7_P3                     *((volatile unsigned char*)(0x42DE838CUL))
#define bFM4_GPIO_PDOR7_P4                     *((volatile unsigned char*)(0x42DE8390UL))
#define bFM4_GPIO_PDOR7_P5                     *((volatile unsigned char*)(0x42DE8394UL))
#define bFM4_GPIO_PDOR7_P6                     *((volatile unsigned char*)(0x42DE8398UL))
#define bFM4_GPIO_PDOR7_P7                     *((volatile unsigned char*)(0x42DE839CUL))
#define bFM4_GPIO_PDOR7_P8                     *((volatile unsigned char*)(0x42DE83A0UL))
#define bFM4_GPIO_PDOR7_P9                     *((volatile unsigned char*)(0x42DE83A4UL))
#define bFM4_GPIO_PDOR7_PA                     *((volatile unsigned char*)(0x42DE83A8UL))
#define bFM4_GPIO_PDOR7_PB                     *((volatile unsigned char*)(0x42DE83ACUL))
#define bFM4_GPIO_PDOR7_PC                     *((volatile unsigned char*)(0x42DE83B0UL))
#define bFM4_GPIO_PDOR7_PD                     *((volatile unsigned char*)(0x42DE83B4UL))
#define bFM4_GPIO_PDOR7_PE                     *((volatile unsigned char*)(0x42DE83B8UL))
#define bFM4_GPIO_PDOR8_P0                     *((volatile unsigned char*)(0x42DE8400UL))
#define bFM4_GPIO_PDOR8_P1                     *((volatile unsigned char*)(0x42DE8404UL))
#define bFM4_GPIO_PDOR8_P2                     *((volatile unsigned char*)(0x42DE8408UL))
#define bFM4_GPIO_PDOR8_P3                     *((volatile unsigned char*)(0x42DE840CUL))
#define bFM4_GPIO_PDOR9_P0                     *((volatile unsigned char*)(0x42DE8480UL))
#define bFM4_GPIO_PDOR9_P1                     *((volatile unsigned char*)(0x42DE8484UL))
#define bFM4_GPIO_PDOR9_P2                     *((volatile unsigned char*)(0x42DE8488UL))
#define bFM4_GPIO_PDOR9_P3                     *((volatile unsigned char*)(0x42DE848CUL))
#define bFM4_GPIO_PDOR9_P4                     *((volatile unsigned char*)(0x42DE8490UL))
#define bFM4_GPIO_PDOR9_P5                     *((volatile unsigned char*)(0x42DE8494UL))
#define bFM4_GPIO_PDOR9_P6                     *((volatile unsigned char*)(0x42DE8498UL))
#define bFM4_GPIO_PDOR9_P7                     *((volatile unsigned char*)(0x42DE849CUL))
#define bFM4_GPIO_PDORA_P0                     *((volatile unsigned char*)(0x42DE8500UL))
#define bFM4_GPIO_PDORA_P1                     *((volatile unsigned char*)(0x42DE8504UL))
#define bFM4_GPIO_PDORA_P2                     *((volatile unsigned char*)(0x42DE8508UL))
#define bFM4_GPIO_PDORA_P3                     *((volatile unsigned char*)(0x42DE850CUL))
#define bFM4_GPIO_PDORA_P4                     *((volatile unsigned char*)(0x42DE8510UL))
#define bFM4_GPIO_PDORA_P5                     *((volatile unsigned char*)(0x42DE8514UL))
#define bFM4_GPIO_PDORA_P6                     *((volatile unsigned char*)(0x42DE8518UL))
#define bFM4_GPIO_PDORA_P7                     *((volatile unsigned char*)(0x42DE851CUL))
#define bFM4_GPIO_PDORA_P8                     *((volatile unsigned char*)(0x42DE8520UL))
#define bFM4_GPIO_PDORA_P9                     *((volatile unsigned char*)(0x42DE8524UL))
#define bFM4_GPIO_PDORA_PA                     *((volatile unsigned char*)(0x42DE8528UL))
#define bFM4_GPIO_PDORA_PB                     *((volatile unsigned char*)(0x42DE852CUL))
#define bFM4_GPIO_PDORA_PC                     *((volatile unsigned char*)(0x42DE8530UL))
#define bFM4_GPIO_PDORA_PD                     *((volatile unsigned char*)(0x42DE8534UL))
#define bFM4_GPIO_PDORA_PE                     *((volatile unsigned char*)(0x42DE8538UL))
#define bFM4_GPIO_PDORA_PF                     *((volatile unsigned char*)(0x42DE853CUL))
#define bFM4_GPIO_PDORB_P0                     *((volatile unsigned char*)(0x42DE8580UL))
#define bFM4_GPIO_PDORB_P1                     *((volatile unsigned char*)(0x42DE8584UL))
#define bFM4_GPIO_PDORB_P2                     *((volatile unsigned char*)(0x42DE8588UL))
#define bFM4_GPIO_PDORB_P3                     *((volatile unsigned char*)(0x42DE858CUL))
#define bFM4_GPIO_PDORB_P4                     *((volatile unsigned char*)(0x42DE8590UL))
#define bFM4_GPIO_PDORB_P5                     *((volatile unsigned char*)(0x42DE8594UL))
#define bFM4_GPIO_PDORB_P6                     *((volatile unsigned char*)(0x42DE8598UL))
#define bFM4_GPIO_PDORB_P7                     *((volatile unsigned char*)(0x42DE859CUL))
#define bFM4_GPIO_PDORB_P8                     *((volatile unsigned char*)(0x42DE85A0UL))
#define bFM4_GPIO_PDORB_P9                     *((volatile unsigned char*)(0x42DE85A4UL))
#define bFM4_GPIO_PDORB_PA                     *((volatile unsigned char*)(0x42DE85A8UL))
#define bFM4_GPIO_PDORB_PB                     *((volatile unsigned char*)(0x42DE85ACUL))
#define bFM4_GPIO_PDORB_PC                     *((volatile unsigned char*)(0x42DE85B0UL))
#define bFM4_GPIO_PDORB_PD                     *((volatile unsigned char*)(0x42DE85B4UL))
#define bFM4_GPIO_PDORB_PE                     *((volatile unsigned char*)(0x42DE85B8UL))
#define bFM4_GPIO_PDORB_PF                     *((volatile unsigned char*)(0x42DE85BCUL))
#define bFM4_GPIO_PDORC_P0                     *((volatile unsigned char*)(0x42DE8600UL))
#define bFM4_GPIO_PDORC_P1                     *((volatile unsigned char*)(0x42DE8604UL))
#define bFM4_GPIO_PDORC_P2                     *((volatile unsigned char*)(0x42DE8608UL))
#define bFM4_GPIO_PDORC_P3                     *((volatile unsigned char*)(0x42DE860CUL))
#define bFM4_GPIO_PDORC_P4                     *((volatile unsigned char*)(0x42DE8610UL))
#define bFM4_GPIO_PDORC_P5                     *((volatile unsigned char*)(0x42DE8614UL))
#define bFM4_GPIO_PDORC_P6                     *((volatile unsigned char*)(0x42DE8618UL))
#define bFM4_GPIO_PDORC_P7                     *((volatile unsigned char*)(0x42DE861CUL))
#define bFM4_GPIO_PDORC_P8                     *((volatile unsigned char*)(0x42DE8620UL))
#define bFM4_GPIO_PDORC_P9                     *((volatile unsigned char*)(0x42DE8624UL))
#define bFM4_GPIO_PDORC_PA                     *((volatile unsigned char*)(0x42DE8628UL))
#define bFM4_GPIO_PDORC_PB                     *((volatile unsigned char*)(0x42DE862CUL))
#define bFM4_GPIO_PDORC_PC                     *((volatile unsigned char*)(0x42DE8630UL))
#define bFM4_GPIO_PDORC_PD                     *((volatile unsigned char*)(0x42DE8634UL))
#define bFM4_GPIO_PDORC_PE                     *((volatile unsigned char*)(0x42DE8638UL))
#define bFM4_GPIO_PDORC_PF                     *((volatile unsigned char*)(0x42DE863CUL))
#define bFM4_GPIO_PDORD_P0                     *((volatile unsigned char*)(0x42DE8680UL))
#define bFM4_GPIO_PDORD_P1                     *((volatile unsigned char*)(0x42DE8684UL))
#define bFM4_GPIO_PDORD_P2                     *((volatile unsigned char*)(0x42DE8688UL))
#define bFM4_GPIO_PDORE_P0                     *((volatile unsigned char*)(0x42DE8700UL))
#define bFM4_GPIO_PDORE_P2                     *((volatile unsigned char*)(0x42DE8708UL))
#define bFM4_GPIO_PDORE_P3                     *((volatile unsigned char*)(0x42DE870CUL))
#define bFM4_GPIO_PDORF_P0                     *((volatile unsigned char*)(0x42DE8780UL))
#define bFM4_GPIO_PDORF_P1                     *((volatile unsigned char*)(0x42DE8784UL))
#define bFM4_GPIO_PDORF_P2                     *((volatile unsigned char*)(0x42DE8788UL))
#define bFM4_GPIO_PDORF_P3                     *((volatile unsigned char*)(0x42DE878CUL))
#define bFM4_GPIO_PDORF_P4                     *((volatile unsigned char*)(0x42DE8790UL))
#define bFM4_GPIO_PDORF_P5                     *((volatile unsigned char*)(0x42DE8794UL))
#define bFM4_GPIO_PDORF_P6                     *((volatile unsigned char*)(0x42DE8798UL))
#define bFM4_GPIO_PDORF_P7                     *((volatile unsigned char*)(0x42DE879CUL))
#define bFM4_GPIO_PDORF_P8                     *((volatile unsigned char*)(0x42DE87A0UL))
#define bFM4_GPIO_PDORF_P9                     *((volatile unsigned char*)(0x42DE87A4UL))
#define bFM4_GPIO_PDORF_PA                     *((volatile unsigned char*)(0x42DE87A8UL))
#define bFM4_GPIO_PDORF_PB                     *((volatile unsigned char*)(0x42DE87ACUL))
#define bFM4_GPIO_PDORF_PC                     *((volatile unsigned char*)(0x42DE87B0UL))
#define bFM4_GPIO_ADE_AN00                     *((volatile unsigned char*)(0x42DEA000UL))
#define bFM4_GPIO_ADE_AN01                     *((volatile unsigned char*)(0x42DEA004UL))
#define bFM4_GPIO_ADE_AN02                     *((volatile unsigned char*)(0x42DEA008UL))
#define bFM4_GPIO_ADE_AN03                     *((volatile unsigned char*)(0x42DEA00CUL))
#define bFM4_GPIO_ADE_AN04                     *((volatile unsigned char*)(0x42DEA010UL))
#define bFM4_GPIO_ADE_AN05                     *((volatile unsigned char*)(0x42DEA014UL))
#define bFM4_GPIO_ADE_AN06                     *((volatile unsigned char*)(0x42DEA018UL))
#define bFM4_GPIO_ADE_AN07                     *((volatile unsigned char*)(0x42DEA01CUL))
#define bFM4_GPIO_ADE_AN08                     *((volatile unsigned char*)(0x42DEA020UL))
#define bFM4_GPIO_ADE_AN09                     *((volatile unsigned char*)(0x42DEA024UL))
#define bFM4_GPIO_ADE_AN10                     *((volatile unsigned char*)(0x42DEA028UL))
#define bFM4_GPIO_ADE_AN11                     *((volatile unsigned char*)(0x42DEA02CUL))
#define bFM4_GPIO_ADE_AN12                     *((volatile unsigned char*)(0x42DEA030UL))
#define bFM4_GPIO_ADE_AN13                     *((volatile unsigned char*)(0x42DEA034UL))
#define bFM4_GPIO_ADE_AN14                     *((volatile unsigned char*)(0x42DEA038UL))
#define bFM4_GPIO_ADE_AN15                     *((volatile unsigned char*)(0x42DEA03CUL))
#define bFM4_GPIO_ADE_AN16                     *((volatile unsigned char*)(0x42DEA040UL))
#define bFM4_GPIO_ADE_AN17                     *((volatile unsigned char*)(0x42DEA044UL))
#define bFM4_GPIO_ADE_AN18                     *((volatile unsigned char*)(0x42DEA048UL))
#define bFM4_GPIO_ADE_AN19                     *((volatile unsigned char*)(0x42DEA04CUL))
#define bFM4_GPIO_ADE_AN20                     *((volatile unsigned char*)(0x42DEA050UL))
#define bFM4_GPIO_ADE_AN21                     *((volatile unsigned char*)(0x42DEA054UL))
#define bFM4_GPIO_ADE_AN22                     *((volatile unsigned char*)(0x42DEA058UL))
#define bFM4_GPIO_ADE_AN23                     *((volatile unsigned char*)(0x42DEA05CUL))
#define bFM4_GPIO_ADE_AN24                     *((volatile unsigned char*)(0x42DEA060UL))
#define bFM4_GPIO_ADE_AN25                     *((volatile unsigned char*)(0x42DEA064UL))
#define bFM4_GPIO_ADE_AN26                     *((volatile unsigned char*)(0x42DEA068UL))
#define bFM4_GPIO_ADE_AN27                     *((volatile unsigned char*)(0x42DEA06CUL))
#define bFM4_GPIO_ADE_AN28                     *((volatile unsigned char*)(0x42DEA070UL))
#define bFM4_GPIO_ADE_AN29                     *((volatile unsigned char*)(0x42DEA074UL))
#define bFM4_GPIO_ADE_AN30                     *((volatile unsigned char*)(0x42DEA078UL))
#define bFM4_GPIO_ADE_AN31                     *((volatile unsigned char*)(0x42DEA07CUL))
#define bFM4_GPIO_SPSR_MAINXC0                 *((volatile unsigned char*)(0x42DEB008UL))
#define bFM4_GPIO_SPSR_MAINXC1                 *((volatile unsigned char*)(0x42DEB00CUL))
#define bFM4_GPIO_SPSR_USB0C                   *((volatile unsigned char*)(0x42DEB010UL))
#define bFM4_GPIO_SPSR_USB1C                   *((volatile unsigned char*)(0x42DEB014UL))
#define bFM4_GPIO_EPFR00_NMIS                  *((volatile unsigned char*)(0x42DEC000UL))
#define bFM4_GPIO_EPFR00_CROUTE0               *((volatile unsigned char*)(0x42DEC004UL))
#define bFM4_GPIO_EPFR00_CROUTE1               *((volatile unsigned char*)(0x42DEC008UL))
#define bFM4_GPIO_EPFR00_RTCCOE0               *((volatile unsigned char*)(0x42DEC010UL))
#define bFM4_GPIO_EPFR00_RTCCOE1               *((volatile unsigned char*)(0x42DEC014UL))
#define bFM4_GPIO_EPFR00_SUBOUTE0              *((volatile unsigned char*)(0x42DEC018UL))
#define bFM4_GPIO_EPFR00_SUBOUTE1              *((volatile unsigned char*)(0x42DEC01CUL))
#define bFM4_GPIO_EPFR00_USBP0E                *((volatile unsigned char*)(0x42DEC024UL))
#define bFM4_GPIO_EPFR00_USBP1E                *((volatile unsigned char*)(0x42DEC034UL))
#define bFM4_GPIO_EPFR00_JTAGEN0B              *((volatile unsigned char*)(0x42DEC040UL))
#define bFM4_GPIO_EPFR00_JTAGEN1S              *((volatile unsigned char*)(0x42DEC044UL))
#define bFM4_GPIO_EPFR00_TRC0E                 *((volatile unsigned char*)(0x42DEC060UL))
#define bFM4_GPIO_EPFR00_TRC1E                 *((volatile unsigned char*)(0x42DEC064UL))
#define bFM4_GPIO_EPFR00_TRC2E                 *((volatile unsigned char*)(0x42DEC068UL))
#define bFM4_GPIO_EPFR00_TRC3E                 *((volatile unsigned char*)(0x42DEC06CUL))
#define bFM4_GPIO_EPFR01_RTO00E0               *((volatile unsigned char*)(0x42DEC080UL))
#define bFM4_GPIO_EPFR01_RTO00E1               *((volatile unsigned char*)(0x42DEC084UL))
#define bFM4_GPIO_EPFR01_RTO01E0               *((volatile unsigned char*)(0x42DEC088UL))
#define bFM4_GPIO_EPFR01_RTO01E1               *((volatile unsigned char*)(0x42DEC08CUL))
#define bFM4_GPIO_EPFR01_RTO02E0               *((volatile unsigned char*)(0x42DEC090UL))
#define bFM4_GPIO_EPFR01_RTO02E1               *((volatile unsigned char*)(0x42DEC094UL))
#define bFM4_GPIO_EPFR01_RTO03E0               *((volatile unsigned char*)(0x42DEC098UL))
#define bFM4_GPIO_EPFR01_RTO03E1               *((volatile unsigned char*)(0x42DEC09CUL))
#define bFM4_GPIO_EPFR01_RTO04E0               *((volatile unsigned char*)(0x42DEC0A0UL))
#define bFM4_GPIO_EPFR01_RTO04E1               *((volatile unsigned char*)(0x42DEC0A4UL))
#define bFM4_GPIO_EPFR01_RTO05E0               *((volatile unsigned char*)(0x42DEC0A8UL))
#define bFM4_GPIO_EPFR01_RTO05E1               *((volatile unsigned char*)(0x42DEC0ACUL))
#define bFM4_GPIO_EPFR01_DTTI0C                *((volatile unsigned char*)(0x42DEC0B0UL))
#define bFM4_GPIO_EPFR01_DTTI0S0               *((volatile unsigned char*)(0x42DEC0C0UL))
#define bFM4_GPIO_EPFR01_DTTI0S1               *((volatile unsigned char*)(0x42DEC0C4UL))
#define bFM4_GPIO_EPFR01_FRCK0S0               *((volatile unsigned char*)(0x42DEC0C8UL))
#define bFM4_GPIO_EPFR01_FRCK0S1               *((volatile unsigned char*)(0x42DEC0CCUL))
#define bFM4_GPIO_EPFR01_IC00S0                *((volatile unsigned char*)(0x42DEC0D0UL))
#define bFM4_GPIO_EPFR01_IC00S1                *((volatile unsigned char*)(0x42DEC0D4UL))
#define bFM4_GPIO_EPFR01_IC00S2                *((volatile unsigned char*)(0x42DEC0D8UL))
#define bFM4_GPIO_EPFR01_IC01S0                *((volatile unsigned char*)(0x42DEC0DCUL))
#define bFM4_GPIO_EPFR01_IC01S1                *((volatile unsigned char*)(0x42DEC0E0UL))
#define bFM4_GPIO_EPFR01_IC01S2                *((volatile unsigned char*)(0x42DEC0E4UL))
#define bFM4_GPIO_EPFR01_IC02S0                *((volatile unsigned char*)(0x42DEC0E8UL))
#define bFM4_GPIO_EPFR01_IC02S1                *((volatile unsigned char*)(0x42DEC0ECUL))
#define bFM4_GPIO_EPFR01_IC02S2                *((volatile unsigned char*)(0x42DEC0F0UL))
#define bFM4_GPIO_EPFR01_IC03S0                *((volatile unsigned char*)(0x42DEC0F4UL))
#define bFM4_GPIO_EPFR01_IC03S1                *((volatile unsigned char*)(0x42DEC0F8UL))
#define bFM4_GPIO_EPFR01_IC03S2                *((volatile unsigned char*)(0x42DEC0FCUL))
#define bFM4_GPIO_EPFR02_RTO10E0               *((volatile unsigned char*)(0x42DEC100UL))
#define bFM4_GPIO_EPFR02_RTO10E1               *((volatile unsigned char*)(0x42DEC104UL))
#define bFM4_GPIO_EPFR02_RTO11E0               *((volatile unsigned char*)(0x42DEC108UL))
#define bFM4_GPIO_EPFR02_RTO11E1               *((volatile unsigned char*)(0x42DEC10CUL))
#define bFM4_GPIO_EPFR02_RTO12E0               *((volatile unsigned char*)(0x42DEC110UL))
#define bFM4_GPIO_EPFR02_RTO12E1               *((volatile unsigned char*)(0x42DEC114UL))
#define bFM4_GPIO_EPFR02_RTO13E0               *((volatile unsigned char*)(0x42DEC118UL))
#define bFM4_GPIO_EPFR02_RTO13E1               *((volatile unsigned char*)(0x42DEC11CUL))
#define bFM4_GPIO_EPFR02_RTO14E0               *((volatile unsigned char*)(0x42DEC120UL))
#define bFM4_GPIO_EPFR02_RTO14E1               *((volatile unsigned char*)(0x42DEC124UL))
#define bFM4_GPIO_EPFR02_RTO15E0               *((volatile unsigned char*)(0x42DEC128UL))
#define bFM4_GPIO_EPFR02_RTO15E1               *((volatile unsigned char*)(0x42DEC12CUL))
#define bFM4_GPIO_EPFR02_DTTI1C                *((volatile unsigned char*)(0x42DEC130UL))
#define bFM4_GPIO_EPFR02_DTTI1S0               *((volatile unsigned char*)(0x42DEC140UL))
#define bFM4_GPIO_EPFR02_DTTI1S1               *((volatile unsigned char*)(0x42DEC144UL))
#define bFM4_GPIO_EPFR02_FRCK1S0               *((volatile unsigned char*)(0x42DEC148UL))
#define bFM4_GPIO_EPFR02_FRCK1S1               *((volatile unsigned char*)(0x42DEC14CUL))
#define bFM4_GPIO_EPFR02_IC10S0                *((volatile unsigned char*)(0x42DEC150UL))
#define bFM4_GPIO_EPFR02_IC10S1                *((volatile unsigned char*)(0x42DEC154UL))
#define bFM4_GPIO_EPFR02_IC10S2                *((volatile unsigned char*)(0x42DEC158UL))
#define bFM4_GPIO_EPFR02_IC11S0                *((volatile unsigned char*)(0x42DEC15CUL))
#define bFM4_GPIO_EPFR02_IC11S1                *((volatile unsigned char*)(0x42DEC160UL))
#define bFM4_GPIO_EPFR02_IC11S2                *((volatile unsigned char*)(0x42DEC164UL))
#define bFM4_GPIO_EPFR02_IC12S0                *((volatile unsigned char*)(0x42DEC168UL))
#define bFM4_GPIO_EPFR02_IC12S1                *((volatile unsigned char*)(0x42DEC16CUL))
#define bFM4_GPIO_EPFR02_IC12S2                *((volatile unsigned char*)(0x42DEC170UL))
#define bFM4_GPIO_EPFR02_IC13S0                *((volatile unsigned char*)(0x42DEC174UL))
#define bFM4_GPIO_EPFR02_IC13S1                *((volatile unsigned char*)(0x42DEC178UL))
#define bFM4_GPIO_EPFR02_IC13S2                *((volatile unsigned char*)(0x42DEC17CUL))
#define bFM4_GPIO_EPFR03_RTO20E0               *((volatile unsigned char*)(0x42DEC180UL))
#define bFM4_GPIO_EPFR03_RTO20E1               *((volatile unsigned char*)(0x42DEC184UL))
#define bFM4_GPIO_EPFR03_RTO21E0               *((volatile unsigned char*)(0x42DEC188UL))
#define bFM4_GPIO_EPFR03_RTO21E1               *((volatile unsigned char*)(0x42DEC18CUL))
#define bFM4_GPIO_EPFR03_RTO22E0               *((volatile unsigned char*)(0x42DEC190UL))
#define bFM4_GPIO_EPFR03_RTO22E1               *((volatile unsigned char*)(0x42DEC194UL))
#define bFM4_GPIO_EPFR03_RTO23E0               *((volatile unsigned char*)(0x42DEC198UL))
#define bFM4_GPIO_EPFR03_RTO23E1               *((volatile unsigned char*)(0x42DEC19CUL))
#define bFM4_GPIO_EPFR03_RTO24E0               *((volatile unsigned char*)(0x42DEC1A0UL))
#define bFM4_GPIO_EPFR03_RTO24E1               *((volatile unsigned char*)(0x42DEC1A4UL))
#define bFM4_GPIO_EPFR03_RTO25E0               *((volatile unsigned char*)(0x42DEC1A8UL))
#define bFM4_GPIO_EPFR03_RTO25E1               *((volatile unsigned char*)(0x42DEC1ACUL))
#define bFM4_GPIO_EPFR03_DTTI2C                *((volatile unsigned char*)(0x42DEC1B0UL))
#define bFM4_GPIO_EPFR03_DTTI2S0               *((volatile unsigned char*)(0x42DEC1C0UL))
#define bFM4_GPIO_EPFR03_DTTI2S1               *((volatile unsigned char*)(0x42DEC1C4UL))
#define bFM4_GPIO_EPFR03_FRCK2S0               *((volatile unsigned char*)(0x42DEC1C8UL))
#define bFM4_GPIO_EPFR03_FRCK2S1               *((volatile unsigned char*)(0x42DEC1CCUL))
#define bFM4_GPIO_EPFR03_IC20S0                *((volatile unsigned char*)(0x42DEC1D0UL))
#define bFM4_GPIO_EPFR03_IC20S1                *((volatile unsigned char*)(0x42DEC1D4UL))
#define bFM4_GPIO_EPFR03_IC20S2                *((volatile unsigned char*)(0x42DEC1D8UL))
#define bFM4_GPIO_EPFR03_IC21S0                *((volatile unsigned char*)(0x42DEC1DCUL))
#define bFM4_GPIO_EPFR03_IC21S1                *((volatile unsigned char*)(0x42DEC1E0UL))
#define bFM4_GPIO_EPFR03_IC21S2                *((volatile unsigned char*)(0x42DEC1E4UL))
#define bFM4_GPIO_EPFR03_IC22S0                *((volatile unsigned char*)(0x42DEC1E8UL))
#define bFM4_GPIO_EPFR03_IC22S1                *((volatile unsigned char*)(0x42DEC1ECUL))
#define bFM4_GPIO_EPFR03_IC22S2                *((volatile unsigned char*)(0x42DEC1F0UL))
#define bFM4_GPIO_EPFR03_IC23S0                *((volatile unsigned char*)(0x42DEC1F4UL))
#define bFM4_GPIO_EPFR03_IC23S1                *((volatile unsigned char*)(0x42DEC1F8UL))
#define bFM4_GPIO_EPFR03_IC23S2                *((volatile unsigned char*)(0x42DEC1FCUL))
#define bFM4_GPIO_EPFR04_TIOA0E0               *((volatile unsigned char*)(0x42DEC208UL))
#define bFM4_GPIO_EPFR04_TIOA0E1               *((volatile unsigned char*)(0x42DEC20CUL))
#define bFM4_GPIO_EPFR04_TIOB0S0               *((volatile unsigned char*)(0x42DEC210UL))
#define bFM4_GPIO_EPFR04_TIOB0S1               *((volatile unsigned char*)(0x42DEC214UL))
#define bFM4_GPIO_EPFR04_TIOB0S2               *((volatile unsigned char*)(0x42DEC218UL))
#define bFM4_GPIO_EPFR04_TIOA1S0               *((volatile unsigned char*)(0x42DEC220UL))
#define bFM4_GPIO_EPFR04_TIOA1S1               *((volatile unsigned char*)(0x42DEC224UL))
#define bFM4_GPIO_EPFR04_TIOA1E0               *((volatile unsigned char*)(0x42DEC228UL))
#define bFM4_GPIO_EPFR04_TIOA1E1               *((volatile unsigned char*)(0x42DEC22CUL))
#define bFM4_GPIO_EPFR04_TIOB1S0               *((volatile unsigned char*)(0x42DEC230UL))
#define bFM4_GPIO_EPFR04_TIOB1S1               *((volatile unsigned char*)(0x42DEC234UL))
#define bFM4_GPIO_EPFR04_TIOA2E0               *((volatile unsigned char*)(0x42DEC248UL))
#define bFM4_GPIO_EPFR04_TIOA2E1               *((volatile unsigned char*)(0x42DEC24CUL))
#define bFM4_GPIO_EPFR04_TIOB2S0               *((volatile unsigned char*)(0x42DEC250UL))
#define bFM4_GPIO_EPFR04_TIOB2S1               *((volatile unsigned char*)(0x42DEC254UL))
#define bFM4_GPIO_EPFR04_TIOA3S0               *((volatile unsigned char*)(0x42DEC260UL))
#define bFM4_GPIO_EPFR04_TIOA3S1               *((volatile unsigned char*)(0x42DEC264UL))
#define bFM4_GPIO_EPFR04_TIOA3E0               *((volatile unsigned char*)(0x42DEC268UL))
#define bFM4_GPIO_EPFR04_TIOA3E1               *((volatile unsigned char*)(0x42DEC26CUL))
#define bFM4_GPIO_EPFR04_TIOB3S0               *((volatile unsigned char*)(0x42DEC270UL))
#define bFM4_GPIO_EPFR04_TIOB3S1               *((volatile unsigned char*)(0x42DEC274UL))
#define bFM4_GPIO_EPFR05_TIOA4E0               *((volatile unsigned char*)(0x42DEC288UL))
#define bFM4_GPIO_EPFR05_TIOA4E1               *((volatile unsigned char*)(0x42DEC28CUL))
#define bFM4_GPIO_EPFR05_TIOB4S0               *((volatile unsigned char*)(0x42DEC290UL))
#define bFM4_GPIO_EPFR05_TIOB4S1               *((volatile unsigned char*)(0x42DEC294UL))
#define bFM4_GPIO_EPFR05_TIOA5S0               *((volatile unsigned char*)(0x42DEC2A0UL))
#define bFM4_GPIO_EPFR05_TIOA5S1               *((volatile unsigned char*)(0x42DEC2A4UL))
#define bFM4_GPIO_EPFR05_TIOA5E0               *((volatile unsigned char*)(0x42DEC2A8UL))
#define bFM4_GPIO_EPFR05_TIOA5E1               *((volatile unsigned char*)(0x42DEC2ACUL))
#define bFM4_GPIO_EPFR05_TIOB5S0               *((volatile unsigned char*)(0x42DEC2B0UL))
#define bFM4_GPIO_EPFR05_TIOB5S1               *((volatile unsigned char*)(0x42DEC2B4UL))
#define bFM4_GPIO_EPFR05_TIOA6E0               *((volatile unsigned char*)(0x42DEC2C8UL))
#define bFM4_GPIO_EPFR05_TIOA6E1               *((volatile unsigned char*)(0x42DEC2CCUL))
#define bFM4_GPIO_EPFR05_TIOB6S0               *((volatile unsigned char*)(0x42DEC2D0UL))
#define bFM4_GPIO_EPFR05_TIOB6S1               *((volatile unsigned char*)(0x42DEC2D4UL))
#define bFM4_GPIO_EPFR05_TIOA7S0               *((volatile unsigned char*)(0x42DEC2E0UL))
#define bFM4_GPIO_EPFR05_TIOA7S1               *((volatile unsigned char*)(0x42DEC2E4UL))
#define bFM4_GPIO_EPFR05_TIOA7E0               *((volatile unsigned char*)(0x42DEC2E8UL))
#define bFM4_GPIO_EPFR05_TIOA7E1               *((volatile unsigned char*)(0x42DEC2ECUL))
#define bFM4_GPIO_EPFR05_TIOB7S0               *((volatile unsigned char*)(0x42DEC2F0UL))
#define bFM4_GPIO_EPFR05_TIOB7S1               *((volatile unsigned char*)(0x42DEC2F4UL))
#define bFM4_GPIO_EPFR06_EINT00S0              *((volatile unsigned char*)(0x42DEC300UL))
#define bFM4_GPIO_EPFR06_EINT00S1              *((volatile unsigned char*)(0x42DEC304UL))
#define bFM4_GPIO_EPFR06_EINT01S0              *((volatile unsigned char*)(0x42DEC308UL))
#define bFM4_GPIO_EPFR06_EINT01S1              *((volatile unsigned char*)(0x42DEC30CUL))
#define bFM4_GPIO_EPFR06_EINT02S0              *((volatile unsigned char*)(0x42DEC310UL))
#define bFM4_GPIO_EPFR06_EINT02S1              *((volatile unsigned char*)(0x42DEC314UL))
#define bFM4_GPIO_EPFR06_EINT03S0              *((volatile unsigned char*)(0x42DEC318UL))
#define bFM4_GPIO_EPFR06_EINT03S1              *((volatile unsigned char*)(0x42DEC31CUL))
#define bFM4_GPIO_EPFR06_EINT04S0              *((volatile unsigned char*)(0x42DEC320UL))
#define bFM4_GPIO_EPFR06_EINT04S1              *((volatile unsigned char*)(0x42DEC324UL))
#define bFM4_GPIO_EPFR06_EINT05S0              *((volatile unsigned char*)(0x42DEC328UL))
#define bFM4_GPIO_EPFR06_EINT05S1              *((volatile unsigned char*)(0x42DEC32CUL))
#define bFM4_GPIO_EPFR06_EINT06S0              *((volatile unsigned char*)(0x42DEC330UL))
#define bFM4_GPIO_EPFR06_EINT06S1              *((volatile unsigned char*)(0x42DEC334UL))
#define bFM4_GPIO_EPFR06_EINT07S0              *((volatile unsigned char*)(0x42DEC338UL))
#define bFM4_GPIO_EPFR06_EINT07S1              *((volatile unsigned char*)(0x42DEC33CUL))
#define bFM4_GPIO_EPFR06_EINT08S0              *((volatile unsigned char*)(0x42DEC340UL))
#define bFM4_GPIO_EPFR06_EINT08S1              *((volatile unsigned char*)(0x42DEC344UL))
#define bFM4_GPIO_EPFR06_EINT09S0              *((volatile unsigned char*)(0x42DEC348UL))
#define bFM4_GPIO_EPFR06_EINT09S1              *((volatile unsigned char*)(0x42DEC34CUL))
#define bFM4_GPIO_EPFR06_EINT10S0              *((volatile unsigned char*)(0x42DEC350UL))
#define bFM4_GPIO_EPFR06_EINT10S1              *((volatile unsigned char*)(0x42DEC354UL))
#define bFM4_GPIO_EPFR06_EINT11S0              *((volatile unsigned char*)(0x42DEC358UL))
#define bFM4_GPIO_EPFR06_EINT11S1              *((volatile unsigned char*)(0x42DEC35CUL))
#define bFM4_GPIO_EPFR06_EINT12S0              *((volatile unsigned char*)(0x42DEC360UL))
#define bFM4_GPIO_EPFR06_EINT12S1              *((volatile unsigned char*)(0x42DEC364UL))
#define bFM4_GPIO_EPFR06_EINT13S0              *((volatile unsigned char*)(0x42DEC368UL))
#define bFM4_GPIO_EPFR06_EINT13S1              *((volatile unsigned char*)(0x42DEC36CUL))
#define bFM4_GPIO_EPFR06_EINT14S0              *((volatile unsigned char*)(0x42DEC370UL))
#define bFM4_GPIO_EPFR06_EINT14S1              *((volatile unsigned char*)(0x42DEC374UL))
#define bFM4_GPIO_EPFR06_EINT15S0              *((volatile unsigned char*)(0x42DEC378UL))
#define bFM4_GPIO_EPFR06_EINT15S1              *((volatile unsigned char*)(0x42DEC37CUL))
#define bFM4_GPIO_EPFR07_SIN0S0                *((volatile unsigned char*)(0x42DEC390UL))
#define bFM4_GPIO_EPFR07_SIN0S1                *((volatile unsigned char*)(0x42DEC394UL))
#define bFM4_GPIO_EPFR07_SOT0B0                *((volatile unsigned char*)(0x42DEC398UL))
#define bFM4_GPIO_EPFR07_SOT0B1                *((volatile unsigned char*)(0x42DEC39CUL))
#define bFM4_GPIO_EPFR07_SCK0B0                *((volatile unsigned char*)(0x42DEC3A0UL))
#define bFM4_GPIO_EPFR07_SCK0B1                *((volatile unsigned char*)(0x42DEC3A4UL))
#define bFM4_GPIO_EPFR07_SIN1S0                *((volatile unsigned char*)(0x42DEC3A8UL))
#define bFM4_GPIO_EPFR07_SIN1S1                *((volatile unsigned char*)(0x42DEC3ACUL))
#define bFM4_GPIO_EPFR07_SOT1B0                *((volatile unsigned char*)(0x42DEC3B0UL))
#define bFM4_GPIO_EPFR07_SOT1B1                *((volatile unsigned char*)(0x42DEC3B4UL))
#define bFM4_GPIO_EPFR07_SCK1B0                *((volatile unsigned char*)(0x42DEC3B8UL))
#define bFM4_GPIO_EPFR07_SCK1B1                *((volatile unsigned char*)(0x42DEC3BCUL))
#define bFM4_GPIO_EPFR07_SIN2S0                *((volatile unsigned char*)(0x42DEC3C0UL))
#define bFM4_GPIO_EPFR07_SIN2S1                *((volatile unsigned char*)(0x42DEC3C4UL))
#define bFM4_GPIO_EPFR07_SOT2B0                *((volatile unsigned char*)(0x42DEC3C8UL))
#define bFM4_GPIO_EPFR07_SOT2B1                *((volatile unsigned char*)(0x42DEC3CCUL))
#define bFM4_GPIO_EPFR07_SCK2B0                *((volatile unsigned char*)(0x42DEC3D0UL))
#define bFM4_GPIO_EPFR07_SCK2B1                *((volatile unsigned char*)(0x42DEC3D4UL))
#define bFM4_GPIO_EPFR07_SIN3S0                *((volatile unsigned char*)(0x42DEC3D8UL))
#define bFM4_GPIO_EPFR07_SIN3S1                *((volatile unsigned char*)(0x42DEC3DCUL))
#define bFM4_GPIO_EPFR07_SOT3B0                *((volatile unsigned char*)(0x42DEC3E0UL))
#define bFM4_GPIO_EPFR07_SOT3B1                *((volatile unsigned char*)(0x42DEC3E4UL))
#define bFM4_GPIO_EPFR07_SCK3B0                *((volatile unsigned char*)(0x42DEC3E8UL))
#define bFM4_GPIO_EPFR07_SCK3B1                *((volatile unsigned char*)(0x42DEC3ECUL))
#define bFM4_GPIO_EPFR08_RTS4E0                *((volatile unsigned char*)(0x42DEC400UL))
#define bFM4_GPIO_EPFR08_RTS4E1                *((volatile unsigned char*)(0x42DEC404UL))
#define bFM4_GPIO_EPFR08_CTS4S0                *((volatile unsigned char*)(0x42DEC408UL))
#define bFM4_GPIO_EPFR08_CTS4S1                *((volatile unsigned char*)(0x42DEC40CUL))
#define bFM4_GPIO_EPFR08_SIN4S0                *((volatile unsigned char*)(0x42DEC410UL))
#define bFM4_GPIO_EPFR08_SIN4S1                *((volatile unsigned char*)(0x42DEC414UL))
#define bFM4_GPIO_EPFR08_SOT4B0                *((volatile unsigned char*)(0x42DEC418UL))
#define bFM4_GPIO_EPFR08_SOT4B1                *((volatile unsigned char*)(0x42DEC41CUL))
#define bFM4_GPIO_EPFR08_SCK4B0                *((volatile unsigned char*)(0x42DEC420UL))
#define bFM4_GPIO_EPFR08_SCK4B1                *((volatile unsigned char*)(0x42DEC424UL))
#define bFM4_GPIO_EPFR08_SIN5S0                *((volatile unsigned char*)(0x42DEC428UL))
#define bFM4_GPIO_EPFR08_SIN5S1                *((volatile unsigned char*)(0x42DEC42CUL))
#define bFM4_GPIO_EPFR08_SOT5B0                *((volatile unsigned char*)(0x42DEC430UL))
#define bFM4_GPIO_EPFR08_SOT5B1                *((volatile unsigned char*)(0x42DEC434UL))
#define bFM4_GPIO_EPFR08_SCK5B0                *((volatile unsigned char*)(0x42DEC438UL))
#define bFM4_GPIO_EPFR08_SCK5B1                *((volatile unsigned char*)(0x42DEC43CUL))
#define bFM4_GPIO_EPFR08_SIN6S0                *((volatile unsigned char*)(0x42DEC440UL))
#define bFM4_GPIO_EPFR08_SIN6S1                *((volatile unsigned char*)(0x42DEC444UL))
#define bFM4_GPIO_EPFR08_SOT6B0                *((volatile unsigned char*)(0x42DEC448UL))
#define bFM4_GPIO_EPFR08_SOT6B1                *((volatile unsigned char*)(0x42DEC44CUL))
#define bFM4_GPIO_EPFR08_SCK6B0                *((volatile unsigned char*)(0x42DEC450UL))
#define bFM4_GPIO_EPFR08_SCK6B1                *((volatile unsigned char*)(0x42DEC454UL))
#define bFM4_GPIO_EPFR08_SIN7S0                *((volatile unsigned char*)(0x42DEC458UL))
#define bFM4_GPIO_EPFR08_SIN7S1                *((volatile unsigned char*)(0x42DEC45CUL))
#define bFM4_GPIO_EPFR08_SOT7B0                *((volatile unsigned char*)(0x42DEC460UL))
#define bFM4_GPIO_EPFR08_SOT7B1                *((volatile unsigned char*)(0x42DEC464UL))
#define bFM4_GPIO_EPFR08_SCK7B0                *((volatile unsigned char*)(0x42DEC468UL))
#define bFM4_GPIO_EPFR08_SCK7B1                *((volatile unsigned char*)(0x42DEC46CUL))
#define bFM4_GPIO_EPFR08_RTS5E0                *((volatile unsigned char*)(0x42DEC470UL))
#define bFM4_GPIO_EPFR08_RTS5E1                *((volatile unsigned char*)(0x42DEC474UL))
#define bFM4_GPIO_EPFR08_CTS5S0                *((volatile unsigned char*)(0x42DEC478UL))
#define bFM4_GPIO_EPFR08_CTS5S1                *((volatile unsigned char*)(0x42DEC47CUL))
#define bFM4_GPIO_EPFR09_QAIN0S0               *((volatile unsigned char*)(0x42DEC480UL))
#define bFM4_GPIO_EPFR09_QAIN0S1               *((volatile unsigned char*)(0x42DEC484UL))
#define bFM4_GPIO_EPFR09_QBIN0S0               *((volatile unsigned char*)(0x42DEC488UL))
#define bFM4_GPIO_EPFR09_QBIN0S1               *((volatile unsigned char*)(0x42DEC48CUL))
#define bFM4_GPIO_EPFR09_QZIN0S0               *((volatile unsigned char*)(0x42DEC490UL))
#define bFM4_GPIO_EPFR09_QZIN0S1               *((volatile unsigned char*)(0x42DEC494UL))
#define bFM4_GPIO_EPFR09_QAIN1S0               *((volatile unsigned char*)(0x42DEC498UL))
#define bFM4_GPIO_EPFR09_QAIN1S1               *((volatile unsigned char*)(0x42DEC49CUL))
#define bFM4_GPIO_EPFR09_QBIN1S0               *((volatile unsigned char*)(0x42DEC4A0UL))
#define bFM4_GPIO_EPFR09_QBIN1S1               *((volatile unsigned char*)(0x42DEC4A4UL))
#define bFM4_GPIO_EPFR09_QZIN1S0               *((volatile unsigned char*)(0x42DEC4A8UL))
#define bFM4_GPIO_EPFR09_QZIN1S1               *((volatile unsigned char*)(0x42DEC4ACUL))
#define bFM4_GPIO_EPFR09_ADTRG0S0              *((volatile unsigned char*)(0x42DEC4B0UL))
#define bFM4_GPIO_EPFR09_ADTRG0S1              *((volatile unsigned char*)(0x42DEC4B4UL))
#define bFM4_GPIO_EPFR09_ADTRG0S2              *((volatile unsigned char*)(0x42DEC4B8UL))
#define bFM4_GPIO_EPFR09_ADTRG0S3              *((volatile unsigned char*)(0x42DEC4BCUL))
#define bFM4_GPIO_EPFR09_ADTRG1S0              *((volatile unsigned char*)(0x42DEC4C0UL))
#define bFM4_GPIO_EPFR09_ADTRG1S1              *((volatile unsigned char*)(0x42DEC4C4UL))
#define bFM4_GPIO_EPFR09_ADTRG1S2              *((volatile unsigned char*)(0x42DEC4C8UL))
#define bFM4_GPIO_EPFR09_ADTRG1S3              *((volatile unsigned char*)(0x42DEC4CCUL))
#define bFM4_GPIO_EPFR09_ADTRG2S0              *((volatile unsigned char*)(0x42DEC4D0UL))
#define bFM4_GPIO_EPFR09_ADTRG2S1              *((volatile unsigned char*)(0x42DEC4D4UL))
#define bFM4_GPIO_EPFR09_ADTRG2S2              *((volatile unsigned char*)(0x42DEC4D8UL))
#define bFM4_GPIO_EPFR09_ADTRG2S3              *((volatile unsigned char*)(0x42DEC4DCUL))
#define bFM4_GPIO_EPFR09_CRX0S0                *((volatile unsigned char*)(0x42DEC4E0UL))
#define bFM4_GPIO_EPFR09_CRX0S1                *((volatile unsigned char*)(0x42DEC4E4UL))
#define bFM4_GPIO_EPFR09_CTX0E0                *((volatile unsigned char*)(0x42DEC4E8UL))
#define bFM4_GPIO_EPFR09_CTX0E1                *((volatile unsigned char*)(0x42DEC4ECUL))
#define bFM4_GPIO_EPFR09_CRX1S0                *((volatile unsigned char*)(0x42DEC4F0UL))
#define bFM4_GPIO_EPFR09_CRX1S1                *((volatile unsigned char*)(0x42DEC4F4UL))
#define bFM4_GPIO_EPFR09_CTX1E0                *((volatile unsigned char*)(0x42DEC4F8UL))
#define bFM4_GPIO_EPFR09_CTX1E1                *((volatile unsigned char*)(0x42DEC4FCUL))
#define bFM4_GPIO_EPFR10_UEDEFB                *((volatile unsigned char*)(0x42DEC500UL))
#define bFM4_GPIO_EPFR10_UEDTHB                *((volatile unsigned char*)(0x42DEC504UL))
#define bFM4_GPIO_EPFR10_UECLKE                *((volatile unsigned char*)(0x42DEC508UL))
#define bFM4_GPIO_EPFR10_UEWEXE                *((volatile unsigned char*)(0x42DEC50CUL))
#define bFM4_GPIO_EPFR10_UEDQME                *((volatile unsigned char*)(0x42DEC510UL))
#define bFM4_GPIO_EPFR10_UEOEXE                *((volatile unsigned char*)(0x42DEC514UL))
#define bFM4_GPIO_EPFR10_UEFLSE                *((volatile unsigned char*)(0x42DEC518UL))
#define bFM4_GPIO_EPFR10_UECS1E                *((volatile unsigned char*)(0x42DEC51CUL))
#define bFM4_GPIO_EPFR10_UECS2E                *((volatile unsigned char*)(0x42DEC520UL))
#define bFM4_GPIO_EPFR10_UECS3E                *((volatile unsigned char*)(0x42DEC524UL))
#define bFM4_GPIO_EPFR10_UECS4E                *((volatile unsigned char*)(0x42DEC528UL))
#define bFM4_GPIO_EPFR10_UECS5E                *((volatile unsigned char*)(0x42DEC52CUL))
#define bFM4_GPIO_EPFR10_UECS6E                *((volatile unsigned char*)(0x42DEC530UL))
#define bFM4_GPIO_EPFR10_UECS7E                *((volatile unsigned char*)(0x42DEC534UL))
#define bFM4_GPIO_EPFR10_UEAOOE                *((volatile unsigned char*)(0x42DEC538UL))
#define bFM4_GPIO_EPFR10_UEA08E                *((volatile unsigned char*)(0x42DEC53CUL))
#define bFM4_GPIO_EPFR10_UEA09E                *((volatile unsigned char*)(0x42DEC540UL))
#define bFM4_GPIO_EPFR10_UEA10E                *((volatile unsigned char*)(0x42DEC544UL))
#define bFM4_GPIO_EPFR10_UEA11E                *((volatile unsigned char*)(0x42DEC548UL))
#define bFM4_GPIO_EPFR10_UEA12E                *((volatile unsigned char*)(0x42DEC54CUL))
#define bFM4_GPIO_EPFR10_UEA13E                *((volatile unsigned char*)(0x42DEC550UL))
#define bFM4_GPIO_EPFR10_UEA14E                *((volatile unsigned char*)(0x42DEC554UL))
#define bFM4_GPIO_EPFR10_UEA15E                *((volatile unsigned char*)(0x42DEC558UL))
#define bFM4_GPIO_EPFR10_UEA16E                *((volatile unsigned char*)(0x42DEC55CUL))
#define bFM4_GPIO_EPFR10_UEA17E                *((volatile unsigned char*)(0x42DEC560UL))
#define bFM4_GPIO_EPFR10_UEA18E                *((volatile unsigned char*)(0x42DEC564UL))
#define bFM4_GPIO_EPFR10_UEA19E                *((volatile unsigned char*)(0x42DEC568UL))
#define bFM4_GPIO_EPFR10_UEA20E                *((volatile unsigned char*)(0x42DEC56CUL))
#define bFM4_GPIO_EPFR10_UEA21E                *((volatile unsigned char*)(0x42DEC570UL))
#define bFM4_GPIO_EPFR10_UEA22E                *((volatile unsigned char*)(0x42DEC574UL))
#define bFM4_GPIO_EPFR10_UEA23E                *((volatile unsigned char*)(0x42DEC578UL))
#define bFM4_GPIO_EPFR10_UEA24E                *((volatile unsigned char*)(0x42DEC57CUL))
#define bFM4_GPIO_EPFR11_UEALEE                *((volatile unsigned char*)(0x42DEC580UL))
#define bFM4_GPIO_EPFR11_UECS0E                *((volatile unsigned char*)(0x42DEC584UL))
#define bFM4_GPIO_EPFR11_UEA01E                *((volatile unsigned char*)(0x42DEC588UL))
#define bFM4_GPIO_EPFR11_UEA02E                *((volatile unsigned char*)(0x42DEC58CUL))
#define bFM4_GPIO_EPFR11_UEA03E                *((volatile unsigned char*)(0x42DEC590UL))
#define bFM4_GPIO_EPFR11_UEA04E                *((volatile unsigned char*)(0x42DEC594UL))
#define bFM4_GPIO_EPFR11_UEA05E                *((volatile unsigned char*)(0x42DEC598UL))
#define bFM4_GPIO_EPFR11_UEA06E                *((volatile unsigned char*)(0x42DEC59CUL))
#define bFM4_GPIO_EPFR11_UEA07E                *((volatile unsigned char*)(0x42DEC5A0UL))
#define bFM4_GPIO_EPFR11_UED00B                *((volatile unsigned char*)(0x42DEC5A4UL))
#define bFM4_GPIO_EPFR11_UED01B                *((volatile unsigned char*)(0x42DEC5A8UL))
#define bFM4_GPIO_EPFR11_UED02B                *((volatile unsigned char*)(0x42DEC5ACUL))
#define bFM4_GPIO_EPFR11_UED03B                *((volatile unsigned char*)(0x42DEC5B0UL))
#define bFM4_GPIO_EPFR11_UED04B                *((volatile unsigned char*)(0x42DEC5B4UL))
#define bFM4_GPIO_EPFR11_UED05B                *((volatile unsigned char*)(0x42DEC5B8UL))
#define bFM4_GPIO_EPFR11_UED06B                *((volatile unsigned char*)(0x42DEC5BCUL))
#define bFM4_GPIO_EPFR11_UED07B                *((volatile unsigned char*)(0x42DEC5C0UL))
#define bFM4_GPIO_EPFR11_UED08B                *((volatile unsigned char*)(0x42DEC5C4UL))
#define bFM4_GPIO_EPFR11_UED09B                *((volatile unsigned char*)(0x42DEC5C8UL))
#define bFM4_GPIO_EPFR11_UED10B                *((volatile unsigned char*)(0x42DEC5CCUL))
#define bFM4_GPIO_EPFR11_UED11B                *((volatile unsigned char*)(0x42DEC5D0UL))
#define bFM4_GPIO_EPFR11_UED12B                *((volatile unsigned char*)(0x42DEC5D4UL))
#define bFM4_GPIO_EPFR11_UED13B                *((volatile unsigned char*)(0x42DEC5D8UL))
#define bFM4_GPIO_EPFR11_UED14B                *((volatile unsigned char*)(0x42DEC5DCUL))
#define bFM4_GPIO_EPFR11_UED15B                *((volatile unsigned char*)(0x42DEC5E0UL))
#define bFM4_GPIO_EPFR11_UERLC                 *((volatile unsigned char*)(0x42DEC5E4UL))
#define bFM4_GPIO_EPFR12_TIOA8E0               *((volatile unsigned char*)(0x42DEC608UL))
#define bFM4_GPIO_EPFR12_TIOA8E1               *((volatile unsigned char*)(0x42DEC60CUL))
#define bFM4_GPIO_EPFR12_TIOB8S0               *((volatile unsigned char*)(0x42DEC610UL))
#define bFM4_GPIO_EPFR12_TIOB8S1               *((volatile unsigned char*)(0x42DEC614UL))
#define bFM4_GPIO_EPFR12_TIOA9S0               *((volatile unsigned char*)(0x42DEC620UL))
#define bFM4_GPIO_EPFR12_TIOA9S1               *((volatile unsigned char*)(0x42DEC624UL))
#define bFM4_GPIO_EPFR12_TIOA9E0               *((volatile unsigned char*)(0x42DEC628UL))
#define bFM4_GPIO_EPFR12_TIOA9E1               *((volatile unsigned char*)(0x42DEC62CUL))
#define bFM4_GPIO_EPFR12_TIOB9S0               *((volatile unsigned char*)(0x42DEC630UL))
#define bFM4_GPIO_EPFR12_TIOB9S1               *((volatile unsigned char*)(0x42DEC634UL))
#define bFM4_GPIO_EPFR12_TIOA10E0              *((volatile unsigned char*)(0x42DEC648UL))
#define bFM4_GPIO_EPFR12_TIOA10E1              *((volatile unsigned char*)(0x42DEC64CUL))
#define bFM4_GPIO_EPFR12_TIOB10S0              *((volatile unsigned char*)(0x42DEC650UL))
#define bFM4_GPIO_EPFR12_TIOB10S1              *((volatile unsigned char*)(0x42DEC654UL))
#define bFM4_GPIO_EPFR12_TIOA11S0              *((volatile unsigned char*)(0x42DEC660UL))
#define bFM4_GPIO_EPFR12_TIOA11S1              *((volatile unsigned char*)(0x42DEC664UL))
#define bFM4_GPIO_EPFR12_TIOA11E0              *((volatile unsigned char*)(0x42DEC668UL))
#define bFM4_GPIO_EPFR12_TIOA11E1              *((volatile unsigned char*)(0x42DEC66CUL))
#define bFM4_GPIO_EPFR12_TIOB11S0              *((volatile unsigned char*)(0x42DEC670UL))
#define bFM4_GPIO_EPFR12_TIOB11S1              *((volatile unsigned char*)(0x42DEC674UL))
#define bFM4_GPIO_EPFR13_TIOA12E0              *((volatile unsigned char*)(0x42DEC688UL))
#define bFM4_GPIO_EPFR13_TIOA12E1              *((volatile unsigned char*)(0x42DEC68CUL))
#define bFM4_GPIO_EPFR13_TIOB12S0              *((volatile unsigned char*)(0x42DEC690UL))
#define bFM4_GPIO_EPFR13_TIOB12S1              *((volatile unsigned char*)(0x42DEC694UL))
#define bFM4_GPIO_EPFR13_TIOA13S0              *((volatile unsigned char*)(0x42DEC6A0UL))
#define bFM4_GPIO_EPFR13_TIOA13S1              *((volatile unsigned char*)(0x42DEC6A4UL))
#define bFM4_GPIO_EPFR13_TIOA13E0              *((volatile unsigned char*)(0x42DEC6A8UL))
#define bFM4_GPIO_EPFR13_TIOA13E1              *((volatile unsigned char*)(0x42DEC6ACUL))
#define bFM4_GPIO_EPFR13_TIOB13S0              *((volatile unsigned char*)(0x42DEC6B0UL))
#define bFM4_GPIO_EPFR13_TIOB13S1              *((volatile unsigned char*)(0x42DEC6B4UL))
#define bFM4_GPIO_EPFR13_TIOA14E0              *((volatile unsigned char*)(0x42DEC6C8UL))
#define bFM4_GPIO_EPFR13_TIOA14E1              *((volatile unsigned char*)(0x42DEC6CCUL))
#define bFM4_GPIO_EPFR13_TIOB14S0              *((volatile unsigned char*)(0x42DEC6D0UL))
#define bFM4_GPIO_EPFR13_TIOB14S1              *((volatile unsigned char*)(0x42DEC6D4UL))
#define bFM4_GPIO_EPFR13_TIOA15S0              *((volatile unsigned char*)(0x42DEC6E0UL))
#define bFM4_GPIO_EPFR13_TIOA15S1              *((volatile unsigned char*)(0x42DEC6E4UL))
#define bFM4_GPIO_EPFR13_TIOA15E0              *((volatile unsigned char*)(0x42DEC6E8UL))
#define bFM4_GPIO_EPFR13_TIOA15E1              *((volatile unsigned char*)(0x42DEC6ECUL))
#define bFM4_GPIO_EPFR13_TIOB15S0              *((volatile unsigned char*)(0x42DEC6F0UL))
#define bFM4_GPIO_EPFR13_TIOB15S1              *((volatile unsigned char*)(0x42DEC6F4UL))
#define bFM4_GPIO_EPFR14_QAIN2S0               *((volatile unsigned char*)(0x42DEC700UL))
#define bFM4_GPIO_EPFR14_QAIN2S1               *((volatile unsigned char*)(0x42DEC704UL))
#define bFM4_GPIO_EPFR14_QBIN2S0               *((volatile unsigned char*)(0x42DEC708UL))
#define bFM4_GPIO_EPFR14_QBIN2S1               *((volatile unsigned char*)(0x42DEC70CUL))
#define bFM4_GPIO_EPFR14_QZIN2S0               *((volatile unsigned char*)(0x42DEC710UL))
#define bFM4_GPIO_EPFR14_QZIN2S1               *((volatile unsigned char*)(0x42DEC714UL))
#define bFM4_GPIO_EPFR14_E_TD0E                *((volatile unsigned char*)(0x42DEC748UL))
#define bFM4_GPIO_EPFR14_E_TD1E                *((volatile unsigned char*)(0x42DEC74CUL))
#define bFM4_GPIO_EPFR14_E_TE0E                *((volatile unsigned char*)(0x42DEC750UL))
#define bFM4_GPIO_EPFR14_E_TE1E                *((volatile unsigned char*)(0x42DEC754UL))
#define bFM4_GPIO_EPFR14_E_MC0E                *((volatile unsigned char*)(0x42DEC758UL))
#define bFM4_GPIO_EPFR14_E_MC1B                *((volatile unsigned char*)(0x42DEC75CUL))
#define bFM4_GPIO_EPFR14_E_MD0B                *((volatile unsigned char*)(0x42DEC760UL))
#define bFM4_GPIO_EPFR14_E_MD1B                *((volatile unsigned char*)(0x42DEC764UL))
#define bFM4_GPIO_EPFR14_E_CKE                 *((volatile unsigned char*)(0x42DEC768UL))
#define bFM4_GPIO_EPFR14_E_PSE                 *((volatile unsigned char*)(0x42DEC76CUL))
#define bFM4_GPIO_EPFR14_E_SPLC0               *((volatile unsigned char*)(0x42DEC770UL))
#define bFM4_GPIO_EPFR14_E_SPLC1               *((volatile unsigned char*)(0x42DEC774UL))
#define bFM4_GPIO_EPFR15_EINT16S0              *((volatile unsigned char*)(0x42DEC780UL))
#define bFM4_GPIO_EPFR15_EINT16S1              *((volatile unsigned char*)(0x42DEC784UL))
#define bFM4_GPIO_EPFR15_EINT17S0              *((volatile unsigned char*)(0x42DEC788UL))
#define bFM4_GPIO_EPFR15_EINT17S1              *((volatile unsigned char*)(0x42DEC78CUL))
#define bFM4_GPIO_EPFR15_EINT18S0              *((volatile unsigned char*)(0x42DEC790UL))
#define bFM4_GPIO_EPFR15_EINT18S1              *((volatile unsigned char*)(0x42DEC794UL))
#define bFM4_GPIO_EPFR15_EINT19S0              *((volatile unsigned char*)(0x42DEC798UL))
#define bFM4_GPIO_EPFR15_EINT19S1              *((volatile unsigned char*)(0x42DEC79CUL))
#define bFM4_GPIO_EPFR15_EINT20S0              *((volatile unsigned char*)(0x42DEC7A0UL))
#define bFM4_GPIO_EPFR15_EINT20S1              *((volatile unsigned char*)(0x42DEC7A4UL))
#define bFM4_GPIO_EPFR15_EINT21S0              *((volatile unsigned char*)(0x42DEC7A8UL))
#define bFM4_GPIO_EPFR15_EINT21S1              *((volatile unsigned char*)(0x42DEC7ACUL))
#define bFM4_GPIO_EPFR15_EINT22S0              *((volatile unsigned char*)(0x42DEC7B0UL))
#define bFM4_GPIO_EPFR15_EINT22S1              *((volatile unsigned char*)(0x42DEC7B4UL))
#define bFM4_GPIO_EPFR15_EINT23S0              *((volatile unsigned char*)(0x42DEC7B8UL))
#define bFM4_GPIO_EPFR15_EINT23S1              *((volatile unsigned char*)(0x42DEC7BCUL))
#define bFM4_GPIO_EPFR15_EINT24S0              *((volatile unsigned char*)(0x42DEC7C0UL))
#define bFM4_GPIO_EPFR15_EINT24S1              *((volatile unsigned char*)(0x42DEC7C4UL))
#define bFM4_GPIO_EPFR15_EINT25S0              *((volatile unsigned char*)(0x42DEC7C8UL))
#define bFM4_GPIO_EPFR15_EINT25S1              *((volatile unsigned char*)(0x42DEC7CCUL))
#define bFM4_GPIO_EPFR15_EINT26S0              *((volatile unsigned char*)(0x42DEC7D0UL))
#define bFM4_GPIO_EPFR15_EINT26S1              *((volatile unsigned char*)(0x42DEC7D4UL))
#define bFM4_GPIO_EPFR15_EINT27S0              *((volatile unsigned char*)(0x42DEC7D8UL))
#define bFM4_GPIO_EPFR15_EINT27S1              *((volatile unsigned char*)(0x42DEC7DCUL))
#define bFM4_GPIO_EPFR15_EINT28S0              *((volatile unsigned char*)(0x42DEC7E0UL))
#define bFM4_GPIO_EPFR15_EINT28S1              *((volatile unsigned char*)(0x42DEC7E4UL))
#define bFM4_GPIO_EPFR15_EINT29S0              *((volatile unsigned char*)(0x42DEC7E8UL))
#define bFM4_GPIO_EPFR15_EINT29S1              *((volatile unsigned char*)(0x42DEC7ECUL))
#define bFM4_GPIO_EPFR15_EINT30S0              *((volatile unsigned char*)(0x42DEC7F0UL))
#define bFM4_GPIO_EPFR15_EINT30S1              *((volatile unsigned char*)(0x42DEC7F4UL))
#define bFM4_GPIO_EPFR15_EINT31S0              *((volatile unsigned char*)(0x42DEC7F8UL))
#define bFM4_GPIO_EPFR15_EINT31S1              *((volatile unsigned char*)(0x42DEC7FCUL))
#define bFM4_GPIO_EPFR16_SCS6B0                *((volatile unsigned char*)(0x42DEC800UL))
#define bFM4_GPIO_EPFR16_SCS6B1                *((volatile unsigned char*)(0x42DEC804UL))
#define bFM4_GPIO_EPFR16_SCS7B0                *((volatile unsigned char*)(0x42DEC808UL))
#define bFM4_GPIO_EPFR16_SCS7B1                *((volatile unsigned char*)(0x42DEC80CUL))
#define bFM4_GPIO_EPFR16_SIN8S0                *((volatile unsigned char*)(0x42DEC810UL))
#define bFM4_GPIO_EPFR16_SIN8S1                *((volatile unsigned char*)(0x42DEC814UL))
#define bFM4_GPIO_EPFR16_SOT8B0                *((volatile unsigned char*)(0x42DEC818UL))
#define bFM4_GPIO_EPFR16_SOT8B1                *((volatile unsigned char*)(0x42DEC81CUL))
#define bFM4_GPIO_EPFR16_SCK8B0                *((volatile unsigned char*)(0x42DEC820UL))
#define bFM4_GPIO_EPFR16_SCK8B1                *((volatile unsigned char*)(0x42DEC824UL))
#define bFM4_GPIO_EPFR16_SIN9S0                *((volatile unsigned char*)(0x42DEC828UL))
#define bFM4_GPIO_EPFR16_SIN9S1                *((volatile unsigned char*)(0x42DEC82CUL))
#define bFM4_GPIO_EPFR16_SOT9B0                *((volatile unsigned char*)(0x42DEC830UL))
#define bFM4_GPIO_EPFR16_SOT9B1                *((volatile unsigned char*)(0x42DEC834UL))
#define bFM4_GPIO_EPFR16_SCK9B0                *((volatile unsigned char*)(0x42DEC838UL))
#define bFM4_GPIO_EPFR16_SCK9B1                *((volatile unsigned char*)(0x42DEC83CUL))
#define bFM4_GPIO_EPFR16_SIN10S0               *((volatile unsigned char*)(0x42DEC840UL))
#define bFM4_GPIO_EPFR16_SIN10S1               *((volatile unsigned char*)(0x42DEC844UL))
#define bFM4_GPIO_EPFR16_SOT10B0               *((volatile unsigned char*)(0x42DEC848UL))
#define bFM4_GPIO_EPFR16_SOT10B1               *((volatile unsigned char*)(0x42DEC84CUL))
#define bFM4_GPIO_EPFR16_SCK10B0               *((volatile unsigned char*)(0x42DEC850UL))
#define bFM4_GPIO_EPFR16_SCK10B1               *((volatile unsigned char*)(0x42DEC854UL))
#define bFM4_GPIO_EPFR16_SIN11S0               *((volatile unsigned char*)(0x42DEC858UL))
#define bFM4_GPIO_EPFR16_SIN11S1               *((volatile unsigned char*)(0x42DEC85CUL))
#define bFM4_GPIO_EPFR16_SOT11B0               *((volatile unsigned char*)(0x42DEC860UL))
#define bFM4_GPIO_EPFR16_SOT11B1               *((volatile unsigned char*)(0x42DEC864UL))
#define bFM4_GPIO_EPFR16_SCK11B0               *((volatile unsigned char*)(0x42DEC868UL))
#define bFM4_GPIO_EPFR16_SCK11B1               *((volatile unsigned char*)(0x42DEC86CUL))
#define bFM4_GPIO_EPFR16_SFMPAC                *((volatile unsigned char*)(0x42DEC870UL))
#define bFM4_GPIO_EPFR16_SFMPBC                *((volatile unsigned char*)(0x42DEC874UL))
#define bFM4_GPIO_EPFR17_SIN12S0               *((volatile unsigned char*)(0x42DEC890UL))
#define bFM4_GPIO_EPFR17_SIN12S1               *((volatile unsigned char*)(0x42DEC894UL))
#define bFM4_GPIO_EPFR17_SOT12B0               *((volatile unsigned char*)(0x42DEC898UL))
#define bFM4_GPIO_EPFR17_SOT12B1               *((volatile unsigned char*)(0x42DEC89CUL))
#define bFM4_GPIO_EPFR17_SCK12B0               *((volatile unsigned char*)(0x42DEC8A0UL))
#define bFM4_GPIO_EPFR17_SCK12B1               *((volatile unsigned char*)(0x42DEC8A4UL))
#define bFM4_GPIO_EPFR17_SIN13S0               *((volatile unsigned char*)(0x42DEC8A8UL))
#define bFM4_GPIO_EPFR17_SIN13S1               *((volatile unsigned char*)(0x42DEC8ACUL))
#define bFM4_GPIO_EPFR17_SOT13B0               *((volatile unsigned char*)(0x42DEC8B0UL))
#define bFM4_GPIO_EPFR17_SOT13B1               *((volatile unsigned char*)(0x42DEC8B4UL))
#define bFM4_GPIO_EPFR17_SCK13B0               *((volatile unsigned char*)(0x42DEC8B8UL))
#define bFM4_GPIO_EPFR17_SCK13B1               *((volatile unsigned char*)(0x42DEC8BCUL))
#define bFM4_GPIO_EPFR17_SIN14S0               *((volatile unsigned char*)(0x42DEC8C0UL))
#define bFM4_GPIO_EPFR17_SIN14S1               *((volatile unsigned char*)(0x42DEC8C4UL))
#define bFM4_GPIO_EPFR17_SOT14B0               *((volatile unsigned char*)(0x42DEC8C8UL))
#define bFM4_GPIO_EPFR17_SOT14B1               *((volatile unsigned char*)(0x42DEC8CCUL))
#define bFM4_GPIO_EPFR17_SCK14B0               *((volatile unsigned char*)(0x42DEC8D0UL))
#define bFM4_GPIO_EPFR17_SCK14B1               *((volatile unsigned char*)(0x42DEC8D4UL))
#define bFM4_GPIO_EPFR17_SIN15S0               *((volatile unsigned char*)(0x42DEC8D8UL))
#define bFM4_GPIO_EPFR17_SIN15S1               *((volatile unsigned char*)(0x42DEC8DCUL))
#define bFM4_GPIO_EPFR17_SOT15B0               *((volatile unsigned char*)(0x42DEC8E0UL))
#define bFM4_GPIO_EPFR17_SOT15B1               *((volatile unsigned char*)(0x42DEC8E4UL))
#define bFM4_GPIO_EPFR17_SCK15B0               *((volatile unsigned char*)(0x42DEC8E8UL))
#define bFM4_GPIO_EPFR17_SCK15B1               *((volatile unsigned char*)(0x42DEC8ECUL))
#define bFM4_GPIO_EPFR18_CECR0B0               *((volatile unsigned char*)(0x42DEC900UL))
#define bFM4_GPIO_EPFR18_CECR0B1               *((volatile unsigned char*)(0x42DEC904UL))
#define bFM4_GPIO_EPFR18_CECR1B0               *((volatile unsigned char*)(0x42DEC908UL))
#define bFM4_GPIO_EPFR18_CECR1B1               *((volatile unsigned char*)(0x42DEC90CUL))
#define bFM4_GPIO_EPFR18_QAIN3S0               *((volatile unsigned char*)(0x42DEC910UL))
#define bFM4_GPIO_EPFR18_QAIN3S1               *((volatile unsigned char*)(0x42DEC914UL))
#define bFM4_GPIO_EPFR18_QBIN3S0               *((volatile unsigned char*)(0x42DEC918UL))
#define bFM4_GPIO_EPFR18_QBIN3S1               *((volatile unsigned char*)(0x42DEC91CUL))
#define bFM4_GPIO_EPFR18_QZIN3S0               *((volatile unsigned char*)(0x42DEC920UL))
#define bFM4_GPIO_EPFR18_QZIN3S1               *((volatile unsigned char*)(0x42DEC924UL))
#define bFM4_GPIO_EPFR18_SDCLKE0               *((volatile unsigned char*)(0x42DEC938UL))
#define bFM4_GPIO_EPFR18_SDCLKE1               *((volatile unsigned char*)(0x42DEC93CUL))
#define bFM4_GPIO_EPFR18_SDCMDB0               *((volatile unsigned char*)(0x42DEC940UL))
#define bFM4_GPIO_EPFR18_SDCMDB1               *((volatile unsigned char*)(0x42DEC944UL))
#define bFM4_GPIO_EPFR18_SDDATA0B0             *((volatile unsigned char*)(0x42DEC948UL))
#define bFM4_GPIO_EPFR18_SDDATA0B1             *((volatile unsigned char*)(0x42DEC94CUL))
#define bFM4_GPIO_EPFR18_SDDATA1B0             *((volatile unsigned char*)(0x42DEC950UL))
#define bFM4_GPIO_EPFR18_SDDATA1B1             *((volatile unsigned char*)(0x42DEC954UL))
#define bFM4_GPIO_EPFR18_SDDATA2B0             *((volatile unsigned char*)(0x42DEC958UL))
#define bFM4_GPIO_EPFR18_SDDATA2B1             *((volatile unsigned char*)(0x42DEC95CUL))
#define bFM4_GPIO_EPFR18_SDDATA3B0             *((volatile unsigned char*)(0x42DEC960UL))
#define bFM4_GPIO_EPFR18_SDDATA3B1             *((volatile unsigned char*)(0x42DEC964UL))
#define bFM4_GPIO_EPFR18_SDCDS0                *((volatile unsigned char*)(0x42DEC968UL))
#define bFM4_GPIO_EPFR18_SDCDS1                *((volatile unsigned char*)(0x42DEC96CUL))
#define bFM4_GPIO_EPFR18_SDWPS0                *((volatile unsigned char*)(0x42DEC970UL))
#define bFM4_GPIO_EPFR18_SDWPS1                *((volatile unsigned char*)(0x42DEC974UL))
#define bFM4_GPIO_EPFR20_UESMCKE               *((volatile unsigned char*)(0x42DECA00UL))
#define bFM4_GPIO_EPFR20_UESMCEE               *((volatile unsigned char*)(0x42DECA04UL))
#define bFM4_GPIO_EPFR20_UERASE                *((volatile unsigned char*)(0x42DECA08UL))
#define bFM4_GPIO_EPFR20_UECASE                *((volatile unsigned char*)(0x42DECA0CUL))
#define bFM4_GPIO_EPFR20_UEDWEXE               *((volatile unsigned char*)(0x42DECA10UL))
#define bFM4_GPIO_EPFR20_UECSXE                *((volatile unsigned char*)(0x42DECA14UL))
#define bFM4_GPIO_EPFR20_UEDQM2E               *((volatile unsigned char*)(0x42DECA18UL))
#define bFM4_GPIO_EPFR20_UEDQM3E               *((volatile unsigned char*)(0x42DECA1CUL))
#define bFM4_GPIO_EPFR20_UEDTHHB               *((volatile unsigned char*)(0x42DECA20UL))
#define bFM4_GPIO_EPFR20_UED16B                *((volatile unsigned char*)(0x42DECA24UL))
#define bFM4_GPIO_EPFR20_UED17B                *((volatile unsigned char*)(0x42DECA28UL))
#define bFM4_GPIO_EPFR20_UED18B                *((volatile unsigned char*)(0x42DECA2CUL))
#define bFM4_GPIO_EPFR20_UED19B                *((volatile unsigned char*)(0x42DECA30UL))
#define bFM4_GPIO_EPFR20_UED20B                *((volatile unsigned char*)(0x42DECA34UL))
#define bFM4_GPIO_EPFR20_UED21B                *((volatile unsigned char*)(0x42DECA38UL))
#define bFM4_GPIO_EPFR20_UED22B                *((volatile unsigned char*)(0x42DECA3CUL))
#define bFM4_GPIO_EPFR20_UED23B                *((volatile unsigned char*)(0x42DECA40UL))
#define bFM4_GPIO_EPFR20_UED24B                *((volatile unsigned char*)(0x42DECA44UL))
#define bFM4_GPIO_EPFR20_UED25B                *((volatile unsigned char*)(0x42DECA48UL))
#define bFM4_GPIO_EPFR20_UED26B                *((volatile unsigned char*)(0x42DECA4CUL))
#define bFM4_GPIO_EPFR20_UED27B                *((volatile unsigned char*)(0x42DECA50UL))
#define bFM4_GPIO_EPFR20_UED28B                *((volatile unsigned char*)(0x42DECA54UL))
#define bFM4_GPIO_EPFR20_UED29B                *((volatile unsigned char*)(0x42DECA58UL))
#define bFM4_GPIO_EPFR20_UED30B                *((volatile unsigned char*)(0x42DECA5CUL))
#define bFM4_GPIO_EPFR20_UED31B                *((volatile unsigned char*)(0x42DECA60UL))
#define bFM4_GPIO_EPFR23_SCS60E0               *((volatile unsigned char*)(0x42DECB80UL))
#define bFM4_GPIO_EPFR23_SCS60E1               *((volatile unsigned char*)(0x42DECB84UL))
#define bFM4_GPIO_EPFR23_SCS61E0               *((volatile unsigned char*)(0x42DECB88UL))
#define bFM4_GPIO_EPFR23_SCS61E1               *((volatile unsigned char*)(0x42DECB8CUL))
#define bFM4_GPIO_EPFR23_SCS62E0               *((volatile unsigned char*)(0x42DECB90UL))
#define bFM4_GPIO_EPFR23_SCS62E1               *((volatile unsigned char*)(0x42DECB94UL))
#define bFM4_GPIO_EPFR23_SCS63E0               *((volatile unsigned char*)(0x42DECB98UL))
#define bFM4_GPIO_EPFR23_SCS63E1               *((volatile unsigned char*)(0x42DECB9CUL))
#define bFM4_GPIO_EPFR23_SCS70E0               *((volatile unsigned char*)(0x42DECBA0UL))
#define bFM4_GPIO_EPFR23_SCS70E1               *((volatile unsigned char*)(0x42DECBA4UL))
#define bFM4_GPIO_EPFR23_SCS71E0               *((volatile unsigned char*)(0x42DECBA8UL))
#define bFM4_GPIO_EPFR23_SCS71E1               *((volatile unsigned char*)(0x42DECBACUL))
#define bFM4_GPIO_EPFR23_SCS72E0               *((volatile unsigned char*)(0x42DECBB0UL))
#define bFM4_GPIO_EPFR23_SCS72E1               *((volatile unsigned char*)(0x42DECBB4UL))
#define bFM4_GPIO_EPFR23_SCS73E0               *((volatile unsigned char*)(0x42DECBB8UL))
#define bFM4_GPIO_EPFR23_SCS73E1               *((volatile unsigned char*)(0x42DECBBCUL))
#define bFM4_GPIO_EPFR24_I2SM4_MCLK0S0         *((volatile unsigned char*)(0x42DECC00UL))
#define bFM4_GPIO_EPFR24_I2SM4_MCLK0S1         *((volatile unsigned char*)(0x42DECC04UL))
#define bFM4_GPIO_EPFR24_I2SM4_MCLK0E0         *((volatile unsigned char*)(0x42DECC08UL))
#define bFM4_GPIO_EPFR24_I2SM4_MCLK0E1         *((volatile unsigned char*)(0x42DECC0CUL))
#define bFM4_GPIO_EPFR24_I2SM4_SCK0B0          *((volatile unsigned char*)(0x42DECC10UL))
#define bFM4_GPIO_EPFR24_I2SM4_SCK0B1          *((volatile unsigned char*)(0x42DECC14UL))
#define bFM4_GPIO_EPFR24_I2SM4_WS0B0           *((volatile unsigned char*)(0x42DECC18UL))
#define bFM4_GPIO_EPFR24_I2SM4_WS0B1           *((volatile unsigned char*)(0x42DECC1CUL))
#define bFM4_GPIO_EPFR24_I2SM4_SDI0S0          *((volatile unsigned char*)(0x42DECC20UL))
#define bFM4_GPIO_EPFR24_I2SM4_SDI0S1          *((volatile unsigned char*)(0x42DECC24UL))
#define bFM4_GPIO_EPFR24_I2SM4_SDO0E0          *((volatile unsigned char*)(0x42DECC28UL))
#define bFM4_GPIO_EPFR24_I2SM4_SDO0E1          *((volatile unsigned char*)(0x42DECC2CUL))
#define bFM4_GPIO_EPFR25_MCRX2S0               *((volatile unsigned char*)(0x42DECC80UL))
#define bFM4_GPIO_EPFR25_MCRX2S1               *((volatile unsigned char*)(0x42DECC84UL))
#define bFM4_GPIO_EPFR25_MCTX2E0               *((volatile unsigned char*)(0x42DECC88UL))
#define bFM4_GPIO_EPFR25_MCTX2E1               *((volatile unsigned char*)(0x42DECC8CUL))
#define bFM4_GPIO_EPFR26_Q_SCKE0               *((volatile unsigned char*)(0x42DECD00UL))
#define bFM4_GPIO_EPFR26_Q_SCKE1               *((volatile unsigned char*)(0x42DECD04UL))
#define bFM4_GPIO_EPFR26_Q_CS0E0               *((volatile unsigned char*)(0x42DECD08UL))
#define bFM4_GPIO_EPFR26_Q_CS0E1               *((volatile unsigned char*)(0x42DECD0CUL))
#define bFM4_GPIO_EPFR26_Q_CS1E0               *((volatile unsigned char*)(0x42DECD10UL))
#define bFM4_GPIO_EPFR26_Q_CS1E1               *((volatile unsigned char*)(0x42DECD14UL))
#define bFM4_GPIO_EPFR26_Q_CS2E0               *((volatile unsigned char*)(0x42DECD18UL))
#define bFM4_GPIO_EPFR26_Q_CS2E1               *((volatile unsigned char*)(0x42DECD1CUL))
#define bFM4_GPIO_EPFR26_Q_CS3E0               *((volatile unsigned char*)(0x42DECD20UL))
#define bFM4_GPIO_EPFR26_Q_CS3E1               *((volatile unsigned char*)(0x42DECD24UL))
#define bFM4_GPIO_EPFR26_Q_IO0B0               *((volatile unsigned char*)(0x42DECD28UL))
#define bFM4_GPIO_EPFR26_Q_IO0B1               *((volatile unsigned char*)(0x42DECD2CUL))
#define bFM4_GPIO_EPFR26_Q_IO1B0               *((volatile unsigned char*)(0x42DECD30UL))
#define bFM4_GPIO_EPFR26_Q_IO1B1               *((volatile unsigned char*)(0x42DECD34UL))
#define bFM4_GPIO_EPFR26_Q_IO2B0               *((volatile unsigned char*)(0x42DECD38UL))
#define bFM4_GPIO_EPFR26_Q_IO2B1               *((volatile unsigned char*)(0x42DECD3CUL))
#define bFM4_GPIO_EPFR26_Q_IO3B0               *((volatile unsigned char*)(0x42DECD40UL))
#define bFM4_GPIO_EPFR26_Q_IO3B1               *((volatile unsigned char*)(0x42DECD44UL))
#define bFM4_GPIO_PZR0_P0                      *((volatile unsigned char*)(0x42DEE000UL))
#define bFM4_GPIO_PZR0_P1                      *((volatile unsigned char*)(0x42DEE004UL))
#define bFM4_GPIO_PZR0_P2                      *((volatile unsigned char*)(0x42DEE008UL))
#define bFM4_GPIO_PZR0_P3                      *((volatile unsigned char*)(0x42DEE00CUL))
#define bFM4_GPIO_PZR0_P4                      *((volatile unsigned char*)(0x42DEE010UL))
#define bFM4_GPIO_PZR0_P5                      *((volatile unsigned char*)(0x42DEE014UL))
#define bFM4_GPIO_PZR0_P6                      *((volatile unsigned char*)(0x42DEE018UL))
#define bFM4_GPIO_PZR0_P7                      *((volatile unsigned char*)(0x42DEE01CUL))
#define bFM4_GPIO_PZR0_P8                      *((volatile unsigned char*)(0x42DEE020UL))
#define bFM4_GPIO_PZR0_P9                      *((volatile unsigned char*)(0x42DEE024UL))
#define bFM4_GPIO_PZR0_PA                      *((volatile unsigned char*)(0x42DEE028UL))
#define bFM4_GPIO_PZR0_PB                      *((volatile unsigned char*)(0x42DEE02CUL))
#define bFM4_GPIO_PZR0_PC                      *((volatile unsigned char*)(0x42DEE030UL))
#define bFM4_GPIO_PZR0_PD                      *((volatile unsigned char*)(0x42DEE034UL))
#define bFM4_GPIO_PZR0_PE                      *((volatile unsigned char*)(0x42DEE038UL))
#define bFM4_GPIO_PZR1_P0                      *((volatile unsigned char*)(0x42DEE080UL))
#define bFM4_GPIO_PZR1_P1                      *((volatile unsigned char*)(0x42DEE084UL))
#define bFM4_GPIO_PZR1_P2                      *((volatile unsigned char*)(0x42DEE088UL))
#define bFM4_GPIO_PZR1_P3                      *((volatile unsigned char*)(0x42DEE08CUL))
#define bFM4_GPIO_PZR1_P4                      *((volatile unsigned char*)(0x42DEE090UL))
#define bFM4_GPIO_PZR1_P5                      *((volatile unsigned char*)(0x42DEE094UL))
#define bFM4_GPIO_PZR1_P6                      *((volatile unsigned char*)(0x42DEE098UL))
#define bFM4_GPIO_PZR1_P7                      *((volatile unsigned char*)(0x42DEE09CUL))
#define bFM4_GPIO_PZR1_P8                      *((volatile unsigned char*)(0x42DEE0A0UL))
#define bFM4_GPIO_PZR1_P9                      *((volatile unsigned char*)(0x42DEE0A4UL))
#define bFM4_GPIO_PZR1_PA                      *((volatile unsigned char*)(0x42DEE0A8UL))
#define bFM4_GPIO_PZR1_PB                      *((volatile unsigned char*)(0x42DEE0ACUL))
#define bFM4_GPIO_PZR1_PC                      *((volatile unsigned char*)(0x42DEE0B0UL))
#define bFM4_GPIO_PZR1_PD                      *((volatile unsigned char*)(0x42DEE0B4UL))
#define bFM4_GPIO_PZR1_PE                      *((volatile unsigned char*)(0x42DEE0B8UL))
#define bFM4_GPIO_PZR1_PF                      *((volatile unsigned char*)(0x42DEE0BCUL))
#define bFM4_GPIO_PZR2_P0                      *((volatile unsigned char*)(0x42DEE100UL))
#define bFM4_GPIO_PZR2_P1                      *((volatile unsigned char*)(0x42DEE104UL))
#define bFM4_GPIO_PZR2_P2                      *((volatile unsigned char*)(0x42DEE108UL))
#define bFM4_GPIO_PZR2_P3                      *((volatile unsigned char*)(0x42DEE10CUL))
#define bFM4_GPIO_PZR2_P4                      *((volatile unsigned char*)(0x42DEE110UL))
#define bFM4_GPIO_PZR2_P5                      *((volatile unsigned char*)(0x42DEE114UL))
#define bFM4_GPIO_PZR2_P6                      *((volatile unsigned char*)(0x42DEE118UL))
#define bFM4_GPIO_PZR2_P7                      *((volatile unsigned char*)(0x42DEE11CUL))
#define bFM4_GPIO_PZR2_P8                      *((volatile unsigned char*)(0x42DEE120UL))
#define bFM4_GPIO_PZR2_P9                      *((volatile unsigned char*)(0x42DEE124UL))
#define bFM4_GPIO_PZR2_PA                      *((volatile unsigned char*)(0x42DEE128UL))
#define bFM4_GPIO_PZR3_P0                      *((volatile unsigned char*)(0x42DEE180UL))
#define bFM4_GPIO_PZR3_P1                      *((volatile unsigned char*)(0x42DEE184UL))
#define bFM4_GPIO_PZR3_P2                      *((volatile unsigned char*)(0x42DEE188UL))
#define bFM4_GPIO_PZR3_P3                      *((volatile unsigned char*)(0x42DEE18CUL))
#define bFM4_GPIO_PZR3_P4                      *((volatile unsigned char*)(0x42DEE190UL))
#define bFM4_GPIO_PZR3_P5                      *((volatile unsigned char*)(0x42DEE194UL))
#define bFM4_GPIO_PZR3_P6                      *((volatile unsigned char*)(0x42DEE198UL))
#define bFM4_GPIO_PZR3_P7                      *((volatile unsigned char*)(0x42DEE19CUL))
#define bFM4_GPIO_PZR3_P8                      *((volatile unsigned char*)(0x42DEE1A0UL))
#define bFM4_GPIO_PZR3_P9                      *((volatile unsigned char*)(0x42DEE1A4UL))
#define bFM4_GPIO_PZR3_PA                      *((volatile unsigned char*)(0x42DEE1A8UL))
#define bFM4_GPIO_PZR3_PB                      *((volatile unsigned char*)(0x42DEE1ACUL))
#define bFM4_GPIO_PZR3_PC                      *((volatile unsigned char*)(0x42DEE1B0UL))
#define bFM4_GPIO_PZR3_PD                      *((volatile unsigned char*)(0x42DEE1B4UL))
#define bFM4_GPIO_PZR3_PE                      *((volatile unsigned char*)(0x42DEE1B8UL))
#define bFM4_GPIO_PZR4_P0                      *((volatile unsigned char*)(0x42DEE200UL))
#define bFM4_GPIO_PZR4_P1                      *((volatile unsigned char*)(0x42DEE204UL))
#define bFM4_GPIO_PZR4_P2                      *((volatile unsigned char*)(0x42DEE208UL))
#define bFM4_GPIO_PZR4_P3                      *((volatile unsigned char*)(0x42DEE20CUL))
#define bFM4_GPIO_PZR4_P4                      *((volatile unsigned char*)(0x42DEE210UL))
#define bFM4_GPIO_PZR4_P5                      *((volatile unsigned char*)(0x42DEE214UL))
#define bFM4_GPIO_PZR4_P6                      *((volatile unsigned char*)(0x42DEE218UL))
#define bFM4_GPIO_PZR4_P7                      *((volatile unsigned char*)(0x42DEE21CUL))
#define bFM4_GPIO_PZR4_P8                      *((volatile unsigned char*)(0x42DEE220UL))
#define bFM4_GPIO_PZR4_P9                      *((volatile unsigned char*)(0x42DEE224UL))
#define bFM4_GPIO_PZR4_PA                      *((volatile unsigned char*)(0x42DEE228UL))
#define bFM4_GPIO_PZR4_PB                      *((volatile unsigned char*)(0x42DEE22CUL))
#define bFM4_GPIO_PZR4_PC                      *((volatile unsigned char*)(0x42DEE230UL))
#define bFM4_GPIO_PZR4_PD                      *((volatile unsigned char*)(0x42DEE234UL))
#define bFM4_GPIO_PZR4_PE                      *((volatile unsigned char*)(0x42DEE238UL))
#define bFM4_GPIO_PZR5_P0                      *((volatile unsigned char*)(0x42DEE280UL))
#define bFM4_GPIO_PZR5_P1                      *((volatile unsigned char*)(0x42DEE284UL))
#define bFM4_GPIO_PZR5_P2                      *((volatile unsigned char*)(0x42DEE288UL))
#define bFM4_GPIO_PZR5_P3                      *((volatile unsigned char*)(0x42DEE28CUL))
#define bFM4_GPIO_PZR5_P4                      *((volatile unsigned char*)(0x42DEE290UL))
#define bFM4_GPIO_PZR5_P5                      *((volatile unsigned char*)(0x42DEE294UL))
#define bFM4_GPIO_PZR5_P6                      *((volatile unsigned char*)(0x42DEE298UL))
#define bFM4_GPIO_PZR5_P7                      *((volatile unsigned char*)(0x42DEE29CUL))
#define bFM4_GPIO_PZR5_P8                      *((volatile unsigned char*)(0x42DEE2A0UL))
#define bFM4_GPIO_PZR5_P9                      *((volatile unsigned char*)(0x42DEE2A4UL))
#define bFM4_GPIO_PZR5_PA                      *((volatile unsigned char*)(0x42DEE2A8UL))
#define bFM4_GPIO_PZR5_PB                      *((volatile unsigned char*)(0x42DEE2ACUL))
#define bFM4_GPIO_PZR5_PC                      *((volatile unsigned char*)(0x42DEE2B0UL))
#define bFM4_GPIO_PZR5_PD                      *((volatile unsigned char*)(0x42DEE2B4UL))
#define bFM4_GPIO_PZR5_PE                      *((volatile unsigned char*)(0x42DEE2B8UL))
#define bFM4_GPIO_PZR5_PF                      *((volatile unsigned char*)(0x42DEE2BCUL))
#define bFM4_GPIO_PZR6_P0                      *((volatile unsigned char*)(0x42DEE300UL))
#define bFM4_GPIO_PZR6_P1                      *((volatile unsigned char*)(0x42DEE304UL))
#define bFM4_GPIO_PZR6_P2                      *((volatile unsigned char*)(0x42DEE308UL))
#define bFM4_GPIO_PZR6_P3                      *((volatile unsigned char*)(0x42DEE30CUL))
#define bFM4_GPIO_PZR6_P4                      *((volatile unsigned char*)(0x42DEE310UL))
#define bFM4_GPIO_PZR6_P5                      *((volatile unsigned char*)(0x42DEE314UL))
#define bFM4_GPIO_PZR6_P6                      *((volatile unsigned char*)(0x42DEE318UL))
#define bFM4_GPIO_PZR6_P7                      *((volatile unsigned char*)(0x42DEE31CUL))
#define bFM4_GPIO_PZR6_P8                      *((volatile unsigned char*)(0x42DEE320UL))
#define bFM4_GPIO_PZR6_P9                      *((volatile unsigned char*)(0x42DEE324UL))
#define bFM4_GPIO_PZR6_PA                      *((volatile unsigned char*)(0x42DEE328UL))
#define bFM4_GPIO_PZR6_PB                      *((volatile unsigned char*)(0x42DEE32CUL))
#define bFM4_GPIO_PZR6_PC                      *((volatile unsigned char*)(0x42DEE330UL))
#define bFM4_GPIO_PZR6_PD                      *((volatile unsigned char*)(0x42DEE334UL))
#define bFM4_GPIO_PZR6_PE                      *((volatile unsigned char*)(0x42DEE338UL))
#define bFM4_GPIO_PZR7_P0                      *((volatile unsigned char*)(0x42DEE380UL))
#define bFM4_GPIO_PZR7_P1                      *((volatile unsigned char*)(0x42DEE384UL))
#define bFM4_GPIO_PZR7_P2                      *((volatile unsigned char*)(0x42DEE388UL))
#define bFM4_GPIO_PZR7_P3                      *((volatile unsigned char*)(0x42DEE38CUL))
#define bFM4_GPIO_PZR7_P4                      *((volatile unsigned char*)(0x42DEE390UL))
#define bFM4_GPIO_PZR7_P5                      *((volatile unsigned char*)(0x42DEE394UL))
#define bFM4_GPIO_PZR7_P6                      *((volatile unsigned char*)(0x42DEE398UL))
#define bFM4_GPIO_PZR7_P7                      *((volatile unsigned char*)(0x42DEE39CUL))
#define bFM4_GPIO_PZR7_P8                      *((volatile unsigned char*)(0x42DEE3A0UL))
#define bFM4_GPIO_PZR7_P9                      *((volatile unsigned char*)(0x42DEE3A4UL))
#define bFM4_GPIO_PZR7_PA                      *((volatile unsigned char*)(0x42DEE3A8UL))
#define bFM4_GPIO_PZR7_PB                      *((volatile unsigned char*)(0x42DEE3ACUL))
#define bFM4_GPIO_PZR7_PC                      *((volatile unsigned char*)(0x42DEE3B0UL))
#define bFM4_GPIO_PZR7_PD                      *((volatile unsigned char*)(0x42DEE3B4UL))
#define bFM4_GPIO_PZR7_PE                      *((volatile unsigned char*)(0x42DEE3B8UL))
#define bFM4_GPIO_PZR8_P0                      *((volatile unsigned char*)(0x42DEE400UL))
#define bFM4_GPIO_PZR8_P1                      *((volatile unsigned char*)(0x42DEE404UL))
#define bFM4_GPIO_PZR8_P2                      *((volatile unsigned char*)(0x42DEE408UL))
#define bFM4_GPIO_PZR8_P3                      *((volatile unsigned char*)(0x42DEE40CUL))
#define bFM4_GPIO_PZR9_P0                      *((volatile unsigned char*)(0x42DEE480UL))
#define bFM4_GPIO_PZR9_P1                      *((volatile unsigned char*)(0x42DEE484UL))
#define bFM4_GPIO_PZR9_P2                      *((volatile unsigned char*)(0x42DEE488UL))
#define bFM4_GPIO_PZR9_P3                      *((volatile unsigned char*)(0x42DEE48CUL))
#define bFM4_GPIO_PZR9_P4                      *((volatile unsigned char*)(0x42DEE490UL))
#define bFM4_GPIO_PZR9_P5                      *((volatile unsigned char*)(0x42DEE494UL))
#define bFM4_GPIO_PZR9_P6                      *((volatile unsigned char*)(0x42DEE498UL))
#define bFM4_GPIO_PZR9_P7                      *((volatile unsigned char*)(0x42DEE49CUL))
#define bFM4_GPIO_PZRA_P0                      *((volatile unsigned char*)(0x42DEE500UL))
#define bFM4_GPIO_PZRA_P1                      *((volatile unsigned char*)(0x42DEE504UL))
#define bFM4_GPIO_PZRA_P2                      *((volatile unsigned char*)(0x42DEE508UL))
#define bFM4_GPIO_PZRA_P3                      *((volatile unsigned char*)(0x42DEE50CUL))
#define bFM4_GPIO_PZRA_P4                      *((volatile unsigned char*)(0x42DEE510UL))
#define bFM4_GPIO_PZRA_P5                      *((volatile unsigned char*)(0x42DEE514UL))
#define bFM4_GPIO_PZRA_P6                      *((volatile unsigned char*)(0x42DEE518UL))
#define bFM4_GPIO_PZRA_P7                      *((volatile unsigned char*)(0x42DEE51CUL))
#define bFM4_GPIO_PZRA_P8                      *((volatile unsigned char*)(0x42DEE520UL))
#define bFM4_GPIO_PZRA_P9                      *((volatile unsigned char*)(0x42DEE524UL))
#define bFM4_GPIO_PZRA_PA                      *((volatile unsigned char*)(0x42DEE528UL))
#define bFM4_GPIO_PZRA_PB                      *((volatile unsigned char*)(0x42DEE52CUL))
#define bFM4_GPIO_PZRA_PC                      *((volatile unsigned char*)(0x42DEE530UL))
#define bFM4_GPIO_PZRA_PD                      *((volatile unsigned char*)(0x42DEE534UL))
#define bFM4_GPIO_PZRA_PE                      *((volatile unsigned char*)(0x42DEE538UL))
#define bFM4_GPIO_PZRA_PF                      *((volatile unsigned char*)(0x42DEE53CUL))
#define bFM4_GPIO_PZRB_P0                      *((volatile unsigned char*)(0x42DEE580UL))
#define bFM4_GPIO_PZRB_P1                      *((volatile unsigned char*)(0x42DEE584UL))
#define bFM4_GPIO_PZRB_P2                      *((volatile unsigned char*)(0x42DEE588UL))
#define bFM4_GPIO_PZRB_P3                      *((volatile unsigned char*)(0x42DEE58CUL))
#define bFM4_GPIO_PZRB_P4                      *((volatile unsigned char*)(0x42DEE590UL))
#define bFM4_GPIO_PZRB_P5                      *((volatile unsigned char*)(0x42DEE594UL))
#define bFM4_GPIO_PZRB_P6                      *((volatile unsigned char*)(0x42DEE598UL))
#define bFM4_GPIO_PZRB_P7                      *((volatile unsigned char*)(0x42DEE59CUL))
#define bFM4_GPIO_PZRB_P8                      *((volatile unsigned char*)(0x42DEE5A0UL))
#define bFM4_GPIO_PZRB_P9                      *((volatile unsigned char*)(0x42DEE5A4UL))
#define bFM4_GPIO_PZRB_PA                      *((volatile unsigned char*)(0x42DEE5A8UL))
#define bFM4_GPIO_PZRB_PB                      *((volatile unsigned char*)(0x42DEE5ACUL))
#define bFM4_GPIO_PZRB_PC                      *((volatile unsigned char*)(0x42DEE5B0UL))
#define bFM4_GPIO_PZRB_PD                      *((volatile unsigned char*)(0x42DEE5B4UL))
#define bFM4_GPIO_PZRB_PE                      *((volatile unsigned char*)(0x42DEE5B8UL))
#define bFM4_GPIO_PZRB_PF                      *((volatile unsigned char*)(0x42DEE5BCUL))
#define bFM4_GPIO_PZRC_P0                      *((volatile unsigned char*)(0x42DEE600UL))
#define bFM4_GPIO_PZRC_P1                      *((volatile unsigned char*)(0x42DEE604UL))
#define bFM4_GPIO_PZRC_P2                      *((volatile unsigned char*)(0x42DEE608UL))
#define bFM4_GPIO_PZRC_P3                      *((volatile unsigned char*)(0x42DEE60CUL))
#define bFM4_GPIO_PZRC_P4                      *((volatile unsigned char*)(0x42DEE610UL))
#define bFM4_GPIO_PZRC_P5                      *((volatile unsigned char*)(0x42DEE614UL))
#define bFM4_GPIO_PZRC_P6                      *((volatile unsigned char*)(0x42DEE618UL))
#define bFM4_GPIO_PZRC_P7                      *((volatile unsigned char*)(0x42DEE61CUL))
#define bFM4_GPIO_PZRC_P8                      *((volatile unsigned char*)(0x42DEE620UL))
#define bFM4_GPIO_PZRC_P9                      *((volatile unsigned char*)(0x42DEE624UL))
#define bFM4_GPIO_PZRC_PA                      *((volatile unsigned char*)(0x42DEE628UL))
#define bFM4_GPIO_PZRC_PB                      *((volatile unsigned char*)(0x42DEE62CUL))
#define bFM4_GPIO_PZRC_PC                      *((volatile unsigned char*)(0x42DEE630UL))
#define bFM4_GPIO_PZRC_PD                      *((volatile unsigned char*)(0x42DEE634UL))
#define bFM4_GPIO_PZRC_PE                      *((volatile unsigned char*)(0x42DEE638UL))
#define bFM4_GPIO_PZRC_PF                      *((volatile unsigned char*)(0x42DEE63CUL))
#define bFM4_GPIO_PZRD_P0                      *((volatile unsigned char*)(0x42DEE680UL))
#define bFM4_GPIO_PZRD_P1                      *((volatile unsigned char*)(0x42DEE684UL))
#define bFM4_GPIO_PZRD_P2                      *((volatile unsigned char*)(0x42DEE688UL))
#define bFM4_GPIO_PZRE_P0                      *((volatile unsigned char*)(0x42DEE700UL))
#define bFM4_GPIO_PZRE_P2                      *((volatile unsigned char*)(0x42DEE708UL))
#define bFM4_GPIO_PZRE_P3                      *((volatile unsigned char*)(0x42DEE70CUL))
#define bFM4_GPIO_PZRF_P0                      *((volatile unsigned char*)(0x42DEE780UL))
#define bFM4_GPIO_PZRF_P1                      *((volatile unsigned char*)(0x42DEE784UL))
#define bFM4_GPIO_PZRF_P2                      *((volatile unsigned char*)(0x42DEE788UL))
#define bFM4_GPIO_PZRF_P3                      *((volatile unsigned char*)(0x42DEE78CUL))
#define bFM4_GPIO_PZRF_P4                      *((volatile unsigned char*)(0x42DEE790UL))
#define bFM4_GPIO_PZRF_P5                      *((volatile unsigned char*)(0x42DEE794UL))
#define bFM4_GPIO_PZRF_P6                      *((volatile unsigned char*)(0x42DEE798UL))
#define bFM4_GPIO_PZRF_P7                      *((volatile unsigned char*)(0x42DEE79CUL))
#define bFM4_GPIO_PZRF_P8                      *((volatile unsigned char*)(0x42DEE7A0UL))
#define bFM4_GPIO_PZRF_P9                      *((volatile unsigned char*)(0x42DEE7A4UL))
#define bFM4_GPIO_PZRF_PA                      *((volatile unsigned char*)(0x42DEE7A8UL))
#define bFM4_GPIO_PZRF_PB                      *((volatile unsigned char*)(0x42DEE7ACUL))
#define bFM4_GPIO_PZRF_PC                      *((volatile unsigned char*)(0x42DEE7B0UL))
#define bFM4_GPIO_PDSR0_P0                     *((volatile unsigned char*)(0x42DEE800UL))
#define bFM4_GPIO_PDSR0_P1                     *((volatile unsigned char*)(0x42DEE804UL))
#define bFM4_GPIO_PDSR0_P2                     *((volatile unsigned char*)(0x42DEE808UL))
#define bFM4_GPIO_PDSR0_P3                     *((volatile unsigned char*)(0x42DEE80CUL))
#define bFM4_GPIO_PDSR0_P4                     *((volatile unsigned char*)(0x42DEE810UL))
#define bFM4_GPIO_PDSR0_P5                     *((volatile unsigned char*)(0x42DEE814UL))
#define bFM4_GPIO_PDSR0_P6                     *((volatile unsigned char*)(0x42DEE818UL))
#define bFM4_GPIO_PDSR0_P7                     *((volatile unsigned char*)(0x42DEE81CUL))
#define bFM4_GPIO_PDSR0_P8                     *((volatile unsigned char*)(0x42DEE820UL))
#define bFM4_GPIO_PDSR0_P9                     *((volatile unsigned char*)(0x42DEE824UL))
#define bFM4_GPIO_PDSR0_PA                     *((volatile unsigned char*)(0x42DEE828UL))
#define bFM4_GPIO_PDSR0_PB                     *((volatile unsigned char*)(0x42DEE82CUL))
#define bFM4_GPIO_PDSR0_PC                     *((volatile unsigned char*)(0x42DEE830UL))
#define bFM4_GPIO_PDSR0_PD                     *((volatile unsigned char*)(0x42DEE834UL))
#define bFM4_GPIO_PDSR0_PE                     *((volatile unsigned char*)(0x42DEE838UL))
#define bFM4_GPIO_PDSR1_P0                     *((volatile unsigned char*)(0x42DEE880UL))
#define bFM4_GPIO_PDSR1_P1                     *((volatile unsigned char*)(0x42DEE884UL))
#define bFM4_GPIO_PDSR1_P2                     *((volatile unsigned char*)(0x42DEE888UL))
#define bFM4_GPIO_PDSR1_P3                     *((volatile unsigned char*)(0x42DEE88CUL))
#define bFM4_GPIO_PDSR1_P4                     *((volatile unsigned char*)(0x42DEE890UL))
#define bFM4_GPIO_PDSR1_P5                     *((volatile unsigned char*)(0x42DEE894UL))
#define bFM4_GPIO_PDSR1_P6                     *((volatile unsigned char*)(0x42DEE898UL))
#define bFM4_GPIO_PDSR1_P7                     *((volatile unsigned char*)(0x42DEE89CUL))
#define bFM4_GPIO_PDSR1_P8                     *((volatile unsigned char*)(0x42DEE8A0UL))
#define bFM4_GPIO_PDSR1_P9                     *((volatile unsigned char*)(0x42DEE8A4UL))
#define bFM4_GPIO_PDSR1_PA                     *((volatile unsigned char*)(0x42DEE8A8UL))
#define bFM4_GPIO_PDSR1_PB                     *((volatile unsigned char*)(0x42DEE8ACUL))
#define bFM4_GPIO_PDSR1_PC                     *((volatile unsigned char*)(0x42DEE8B0UL))
#define bFM4_GPIO_PDSR1_PD                     *((volatile unsigned char*)(0x42DEE8B4UL))
#define bFM4_GPIO_PDSR1_PE                     *((volatile unsigned char*)(0x42DEE8B8UL))
#define bFM4_GPIO_PDSR1_PF                     *((volatile unsigned char*)(0x42DEE8BCUL))
#define bFM4_GPIO_PDSR2_P0                     *((volatile unsigned char*)(0x42DEE900UL))
#define bFM4_GPIO_PDSR2_P1                     *((volatile unsigned char*)(0x42DEE904UL))
#define bFM4_GPIO_PDSR2_P2                     *((volatile unsigned char*)(0x42DEE908UL))
#define bFM4_GPIO_PDSR2_P3                     *((volatile unsigned char*)(0x42DEE90CUL))
#define bFM4_GPIO_PDSR2_P4                     *((volatile unsigned char*)(0x42DEE910UL))
#define bFM4_GPIO_PDSR2_P5                     *((volatile unsigned char*)(0x42DEE914UL))
#define bFM4_GPIO_PDSR2_P6                     *((volatile unsigned char*)(0x42DEE918UL))
#define bFM4_GPIO_PDSR2_P7                     *((volatile unsigned char*)(0x42DEE91CUL))
#define bFM4_GPIO_PDSR2_P8                     *((volatile unsigned char*)(0x42DEE920UL))
#define bFM4_GPIO_PDSR2_P9                     *((volatile unsigned char*)(0x42DEE924UL))
#define bFM4_GPIO_PDSR2_PA                     *((volatile unsigned char*)(0x42DEE928UL))
#define bFM4_GPIO_PDSR3_P0                     *((volatile unsigned char*)(0x42DEE980UL))
#define bFM4_GPIO_PDSR3_P1                     *((volatile unsigned char*)(0x42DEE984UL))
#define bFM4_GPIO_PDSR3_P2                     *((volatile unsigned char*)(0x42DEE988UL))
#define bFM4_GPIO_PDSR3_P3                     *((volatile unsigned char*)(0x42DEE98CUL))
#define bFM4_GPIO_PDSR3_P4                     *((volatile unsigned char*)(0x42DEE990UL))
#define bFM4_GPIO_PDSR3_P5                     *((volatile unsigned char*)(0x42DEE994UL))
#define bFM4_GPIO_PDSR3_P6                     *((volatile unsigned char*)(0x42DEE998UL))
#define bFM4_GPIO_PDSR3_P7                     *((volatile unsigned char*)(0x42DEE99CUL))
#define bFM4_GPIO_PDSR3_P8                     *((volatile unsigned char*)(0x42DEE9A0UL))
#define bFM4_GPIO_PDSR3_P9                     *((volatile unsigned char*)(0x42DEE9A4UL))
#define bFM4_GPIO_PDSR3_PA                     *((volatile unsigned char*)(0x42DEE9A8UL))
#define bFM4_GPIO_PDSR3_PB                     *((volatile unsigned char*)(0x42DEE9ACUL))
#define bFM4_GPIO_PDSR3_PC                     *((volatile unsigned char*)(0x42DEE9B0UL))
#define bFM4_GPIO_PDSR3_PD                     *((volatile unsigned char*)(0x42DEE9B4UL))
#define bFM4_GPIO_PDSR3_PE                     *((volatile unsigned char*)(0x42DEE9B8UL))
#define bFM4_GPIO_PDSR4_P0                     *((volatile unsigned char*)(0x42DEEA00UL))
#define bFM4_GPIO_PDSR4_P1                     *((volatile unsigned char*)(0x42DEEA04UL))
#define bFM4_GPIO_PDSR4_P2                     *((volatile unsigned char*)(0x42DEEA08UL))
#define bFM4_GPIO_PDSR4_P3                     *((volatile unsigned char*)(0x42DEEA0CUL))
#define bFM4_GPIO_PDSR4_P4                     *((volatile unsigned char*)(0x42DEEA10UL))
#define bFM4_GPIO_PDSR4_P5                     *((volatile unsigned char*)(0x42DEEA14UL))
#define bFM4_GPIO_PDSR4_P6                     *((volatile unsigned char*)(0x42DEEA18UL))
#define bFM4_GPIO_PDSR4_P7                     *((volatile unsigned char*)(0x42DEEA1CUL))
#define bFM4_GPIO_PDSR4_P8                     *((volatile unsigned char*)(0x42DEEA20UL))
#define bFM4_GPIO_PDSR4_P9                     *((volatile unsigned char*)(0x42DEEA24UL))
#define bFM4_GPIO_PDSR4_PA                     *((volatile unsigned char*)(0x42DEEA28UL))
#define bFM4_GPIO_PDSR4_PB                     *((volatile unsigned char*)(0x42DEEA2CUL))
#define bFM4_GPIO_PDSR4_PC                     *((volatile unsigned char*)(0x42DEEA30UL))
#define bFM4_GPIO_PDSR4_PD                     *((volatile unsigned char*)(0x42DEEA34UL))
#define bFM4_GPIO_PDSR4_PE                     *((volatile unsigned char*)(0x42DEEA38UL))
#define bFM4_GPIO_PDSR5_P0                     *((volatile unsigned char*)(0x42DEEA80UL))
#define bFM4_GPIO_PDSR5_P1                     *((volatile unsigned char*)(0x42DEEA84UL))
#define bFM4_GPIO_PDSR5_P2                     *((volatile unsigned char*)(0x42DEEA88UL))
#define bFM4_GPIO_PDSR5_P3                     *((volatile unsigned char*)(0x42DEEA8CUL))
#define bFM4_GPIO_PDSR5_P4                     *((volatile unsigned char*)(0x42DEEA90UL))
#define bFM4_GPIO_PDSR5_P5                     *((volatile unsigned char*)(0x42DEEA94UL))
#define bFM4_GPIO_PDSR5_P6                     *((volatile unsigned char*)(0x42DEEA98UL))
#define bFM4_GPIO_PDSR5_P7                     *((volatile unsigned char*)(0x42DEEA9CUL))
#define bFM4_GPIO_PDSR5_P8                     *((volatile unsigned char*)(0x42DEEAA0UL))
#define bFM4_GPIO_PDSR5_P9                     *((volatile unsigned char*)(0x42DEEAA4UL))
#define bFM4_GPIO_PDSR5_PA                     *((volatile unsigned char*)(0x42DEEAA8UL))
#define bFM4_GPIO_PDSR5_PB                     *((volatile unsigned char*)(0x42DEEAACUL))
#define bFM4_GPIO_PDSR5_PC                     *((volatile unsigned char*)(0x42DEEAB0UL))
#define bFM4_GPIO_PDSR5_PD                     *((volatile unsigned char*)(0x42DEEAB4UL))
#define bFM4_GPIO_PDSR5_PE                     *((volatile unsigned char*)(0x42DEEAB8UL))
#define bFM4_GPIO_PDSR5_PF                     *((volatile unsigned char*)(0x42DEEABCUL))
#define bFM4_GPIO_PDSR6_P0                     *((volatile unsigned char*)(0x42DEEB00UL))
#define bFM4_GPIO_PDSR6_P1                     *((volatile unsigned char*)(0x42DEEB04UL))
#define bFM4_GPIO_PDSR6_P2                     *((volatile unsigned char*)(0x42DEEB08UL))
#define bFM4_GPIO_PDSR6_P3                     *((volatile unsigned char*)(0x42DEEB0CUL))
#define bFM4_GPIO_PDSR6_P4                     *((volatile unsigned char*)(0x42DEEB10UL))
#define bFM4_GPIO_PDSR6_P5                     *((volatile unsigned char*)(0x42DEEB14UL))
#define bFM4_GPIO_PDSR6_P6                     *((volatile unsigned char*)(0x42DEEB18UL))
#define bFM4_GPIO_PDSR6_P7                     *((volatile unsigned char*)(0x42DEEB1CUL))
#define bFM4_GPIO_PDSR6_P8                     *((volatile unsigned char*)(0x42DEEB20UL))
#define bFM4_GPIO_PDSR6_P9                     *((volatile unsigned char*)(0x42DEEB24UL))
#define bFM4_GPIO_PDSR6_PA                     *((volatile unsigned char*)(0x42DEEB28UL))
#define bFM4_GPIO_PDSR6_PB                     *((volatile unsigned char*)(0x42DEEB2CUL))
#define bFM4_GPIO_PDSR6_PC                     *((volatile unsigned char*)(0x42DEEB30UL))
#define bFM4_GPIO_PDSR6_PD                     *((volatile unsigned char*)(0x42DEEB34UL))
#define bFM4_GPIO_PDSR6_PE                     *((volatile unsigned char*)(0x42DEEB38UL))
#define bFM4_GPIO_PDSR7_P0                     *((volatile unsigned char*)(0x42DEEB80UL))
#define bFM4_GPIO_PDSR7_P1                     *((volatile unsigned char*)(0x42DEEB84UL))
#define bFM4_GPIO_PDSR7_P2                     *((volatile unsigned char*)(0x42DEEB88UL))
#define bFM4_GPIO_PDSR7_P3                     *((volatile unsigned char*)(0x42DEEB8CUL))
#define bFM4_GPIO_PDSR7_P4                     *((volatile unsigned char*)(0x42DEEB90UL))
#define bFM4_GPIO_PDSR7_P5                     *((volatile unsigned char*)(0x42DEEB94UL))
#define bFM4_GPIO_PDSR7_P6                     *((volatile unsigned char*)(0x42DEEB98UL))
#define bFM4_GPIO_PDSR7_P7                     *((volatile unsigned char*)(0x42DEEB9CUL))
#define bFM4_GPIO_PDSR7_P8                     *((volatile unsigned char*)(0x42DEEBA0UL))
#define bFM4_GPIO_PDSR7_P9                     *((volatile unsigned char*)(0x42DEEBA4UL))
#define bFM4_GPIO_PDSR7_PA                     *((volatile unsigned char*)(0x42DEEBA8UL))
#define bFM4_GPIO_PDSR7_PB                     *((volatile unsigned char*)(0x42DEEBACUL))
#define bFM4_GPIO_PDSR7_PC                     *((volatile unsigned char*)(0x42DEEBB0UL))
#define bFM4_GPIO_PDSR7_PD                     *((volatile unsigned char*)(0x42DEEBB4UL))
#define bFM4_GPIO_PDSR7_PE                     *((volatile unsigned char*)(0x42DEEBB8UL))
#define bFM4_GPIO_PDSR8_P0                     *((volatile unsigned char*)(0x42DEEC00UL))
#define bFM4_GPIO_PDSR8_P1                     *((volatile unsigned char*)(0x42DEEC04UL))
#define bFM4_GPIO_PDSR8_P2                     *((volatile unsigned char*)(0x42DEEC08UL))
#define bFM4_GPIO_PDSR8_P3                     *((volatile unsigned char*)(0x42DEEC0CUL))
#define bFM4_GPIO_PDSR9_P0                     *((volatile unsigned char*)(0x42DEEC80UL))
#define bFM4_GPIO_PDSR9_P1                     *((volatile unsigned char*)(0x42DEEC84UL))
#define bFM4_GPIO_PDSR9_P2                     *((volatile unsigned char*)(0x42DEEC88UL))
#define bFM4_GPIO_PDSR9_P3                     *((volatile unsigned char*)(0x42DEEC8CUL))
#define bFM4_GPIO_PDSR9_P4                     *((volatile unsigned char*)(0x42DEEC90UL))
#define bFM4_GPIO_PDSR9_P5                     *((volatile unsigned char*)(0x42DEEC94UL))
#define bFM4_GPIO_PDSR9_P6                     *((volatile unsigned char*)(0x42DEEC98UL))
#define bFM4_GPIO_PDSR9_P7                     *((volatile unsigned char*)(0x42DEEC9CUL))
#define bFM4_GPIO_PDSRA_P0                     *((volatile unsigned char*)(0x42DEED00UL))
#define bFM4_GPIO_PDSRA_P1                     *((volatile unsigned char*)(0x42DEED04UL))
#define bFM4_GPIO_PDSRA_P2                     *((volatile unsigned char*)(0x42DEED08UL))
#define bFM4_GPIO_PDSRA_P3                     *((volatile unsigned char*)(0x42DEED0CUL))
#define bFM4_GPIO_PDSRA_P4                     *((volatile unsigned char*)(0x42DEED10UL))
#define bFM4_GPIO_PDSRA_P5                     *((volatile unsigned char*)(0x42DEED14UL))
#define bFM4_GPIO_PDSRA_P6                     *((volatile unsigned char*)(0x42DEED18UL))
#define bFM4_GPIO_PDSRA_P7                     *((volatile unsigned char*)(0x42DEED1CUL))
#define bFM4_GPIO_PDSRA_P8                     *((volatile unsigned char*)(0x42DEED20UL))
#define bFM4_GPIO_PDSRA_P9                     *((volatile unsigned char*)(0x42DEED24UL))
#define bFM4_GPIO_PDSRA_PA                     *((volatile unsigned char*)(0x42DEED28UL))
#define bFM4_GPIO_PDSRA_PB                     *((volatile unsigned char*)(0x42DEED2CUL))
#define bFM4_GPIO_PDSRA_PC                     *((volatile unsigned char*)(0x42DEED30UL))
#define bFM4_GPIO_PDSRA_PD                     *((volatile unsigned char*)(0x42DEED34UL))
#define bFM4_GPIO_PDSRA_PE                     *((volatile unsigned char*)(0x42DEED38UL))
#define bFM4_GPIO_PDSRA_PF                     *((volatile unsigned char*)(0x42DEED3CUL))
#define bFM4_GPIO_PDSRB_P0                     *((volatile unsigned char*)(0x42DEED80UL))
#define bFM4_GPIO_PDSRB_P1                     *((volatile unsigned char*)(0x42DEED84UL))
#define bFM4_GPIO_PDSRB_P2                     *((volatile unsigned char*)(0x42DEED88UL))
#define bFM4_GPIO_PDSRB_P3                     *((volatile unsigned char*)(0x42DEED8CUL))
#define bFM4_GPIO_PDSRB_P4                     *((volatile unsigned char*)(0x42DEED90UL))
#define bFM4_GPIO_PDSRB_P5                     *((volatile unsigned char*)(0x42DEED94UL))
#define bFM4_GPIO_PDSRB_P6                     *((volatile unsigned char*)(0x42DEED98UL))
#define bFM4_GPIO_PDSRB_P7                     *((volatile unsigned char*)(0x42DEED9CUL))
#define bFM4_GPIO_PDSRB_P8                     *((volatile unsigned char*)(0x42DEEDA0UL))
#define bFM4_GPIO_PDSRB_P9                     *((volatile unsigned char*)(0x42DEEDA4UL))
#define bFM4_GPIO_PDSRB_PA                     *((volatile unsigned char*)(0x42DEEDA8UL))
#define bFM4_GPIO_PDSRB_PB                     *((volatile unsigned char*)(0x42DEEDACUL))
#define bFM4_GPIO_PDSRB_PC                     *((volatile unsigned char*)(0x42DEEDB0UL))
#define bFM4_GPIO_PDSRB_PD                     *((volatile unsigned char*)(0x42DEEDB4UL))
#define bFM4_GPIO_PDSRB_PE                     *((volatile unsigned char*)(0x42DEEDB8UL))
#define bFM4_GPIO_PDSRB_PF                     *((volatile unsigned char*)(0x42DEEDBCUL))
#define bFM4_GPIO_PDSRC_P0                     *((volatile unsigned char*)(0x42DEEE00UL))
#define bFM4_GPIO_PDSRC_P1                     *((volatile unsigned char*)(0x42DEEE04UL))
#define bFM4_GPIO_PDSRC_P2                     *((volatile unsigned char*)(0x42DEEE08UL))
#define bFM4_GPIO_PDSRC_P3                     *((volatile unsigned char*)(0x42DEEE0CUL))
#define bFM4_GPIO_PDSRC_P4                     *((volatile unsigned char*)(0x42DEEE10UL))
#define bFM4_GPIO_PDSRC_P5                     *((volatile unsigned char*)(0x42DEEE14UL))
#define bFM4_GPIO_PDSRC_P6                     *((volatile unsigned char*)(0x42DEEE18UL))
#define bFM4_GPIO_PDSRC_P7                     *((volatile unsigned char*)(0x42DEEE1CUL))
#define bFM4_GPIO_PDSRC_P8                     *((volatile unsigned char*)(0x42DEEE20UL))
#define bFM4_GPIO_PDSRC_P9                     *((volatile unsigned char*)(0x42DEEE24UL))
#define bFM4_GPIO_PDSRC_PA                     *((volatile unsigned char*)(0x42DEEE28UL))
#define bFM4_GPIO_PDSRC_PB                     *((volatile unsigned char*)(0x42DEEE2CUL))
#define bFM4_GPIO_PDSRC_PC                     *((volatile unsigned char*)(0x42DEEE30UL))
#define bFM4_GPIO_PDSRC_PD                     *((volatile unsigned char*)(0x42DEEE34UL))
#define bFM4_GPIO_PDSRC_PE                     *((volatile unsigned char*)(0x42DEEE38UL))
#define bFM4_GPIO_PDSRC_PF                     *((volatile unsigned char*)(0x42DEEE3CUL))
#define bFM4_GPIO_PDSRD_P0                     *((volatile unsigned char*)(0x42DEEE80UL))
#define bFM4_GPIO_PDSRD_P1                     *((volatile unsigned char*)(0x42DEEE84UL))
#define bFM4_GPIO_PDSRD_P2                     *((volatile unsigned char*)(0x42DEEE88UL))
#define bFM4_GPIO_PDSRE_P0                     *((volatile unsigned char*)(0x42DEEF00UL))
#define bFM4_GPIO_PDSRE_P2                     *((volatile unsigned char*)(0x42DEEF08UL))
#define bFM4_GPIO_PDSRE_P3                     *((volatile unsigned char*)(0x42DEEF0CUL))
#define bFM4_GPIO_PDSRF_P0                     *((volatile unsigned char*)(0x42DEEF80UL))
#define bFM4_GPIO_PDSRF_P1                     *((volatile unsigned char*)(0x42DEEF84UL))
#define bFM4_GPIO_PDSRF_P2                     *((volatile unsigned char*)(0x42DEEF88UL))
#define bFM4_GPIO_PDSRF_P3                     *((volatile unsigned char*)(0x42DEEF8CUL))
#define bFM4_GPIO_PDSRF_P4                     *((volatile unsigned char*)(0x42DEEF90UL))
#define bFM4_GPIO_PDSRF_P5                     *((volatile unsigned char*)(0x42DEEF94UL))
#define bFM4_GPIO_PDSRF_P6                     *((volatile unsigned char*)(0x42DEEF98UL))
#define bFM4_GPIO_PDSRF_P7                     *((volatile unsigned char*)(0x42DEEF9CUL))
#define bFM4_GPIO_PDSRF_P8                     *((volatile unsigned char*)(0x42DEEFA0UL))
#define bFM4_GPIO_PDSRF_P9                     *((volatile unsigned char*)(0x42DEEFA4UL))
#define bFM4_GPIO_PDSRF_PA                     *((volatile unsigned char*)(0x42DEEFA8UL))
#define bFM4_GPIO_PDSRF_PB                     *((volatile unsigned char*)(0x42DEEFACUL))
#define bFM4_GPIO_PDSRF_PC                     *((volatile unsigned char*)(0x42DEEFB0UL))

/* Low voltage detection registers */
#define bFM4_LVD_LVD_CTL_SVHI0                 *((volatile unsigned char*)(0x426A0008UL))
#define bFM4_LVD_LVD_CTL_SVHI1                 *((volatile unsigned char*)(0x426A000CUL))
#define bFM4_LVD_LVD_CTL_SVHI2                 *((volatile unsigned char*)(0x426A0010UL))
#define bFM4_LVD_LVD_CTL_SVHI3                 *((volatile unsigned char*)(0x426A0014UL))
#define bFM4_LVD_LVD_CTL_SVHI4                 *((volatile unsigned char*)(0x426A0018UL))
#define bFM4_LVD_LVD_CTL_LVDIE                 *((volatile unsigned char*)(0x426A001CUL))
#define bFM4_LVD_LVD_STR_LVDIR                 *((volatile unsigned char*)(0x426A009CUL))
#define bFM4_LVD_LVD_CLR_LVDCL                 *((volatile unsigned char*)(0x426A011CUL))
#define bFM4_LVD_LVD_STR2_LVDIRDY              *((volatile unsigned char*)(0x426A021CUL))

/* DS mode registers */
#define bFM4_DS_RCK_CTL_CECCKE                 *((volatile unsigned char*)(0x426A2084UL))
#define bFM4_DS_PMD_CTL_RTCE                   *((volatile unsigned char*)(0x426B0000UL))
#define bFM4_DS_WRFSR_WINITX                   *((volatile unsigned char*)(0x426B0080UL))
#define bFM4_DS_WRFSR_WLVDH                    *((volatile unsigned char*)(0x426B0084UL))
#define bFM4_DS_WIFSR_WRTCI                    *((volatile unsigned char*)(0x426B0100UL))
#define bFM4_DS_WIFSR_WLVDI                    *((volatile unsigned char*)(0x426B0104UL))
#define bFM4_DS_WIFSR_WUI0                     *((volatile unsigned char*)(0x426B0108UL))
#define bFM4_DS_WIFSR_WUI1                     *((volatile unsigned char*)(0x426B010CUL))
#define bFM4_DS_WIFSR_WUI2                     *((volatile unsigned char*)(0x426B0110UL))
#define bFM4_DS_WIFSR_WUI3                     *((volatile unsigned char*)(0x426B0114UL))
#define bFM4_DS_WIFSR_WUI4                     *((volatile unsigned char*)(0x426B0118UL))
#define bFM4_DS_WIFSR_WUI5                     *((volatile unsigned char*)(0x426B011CUL))
#define bFM4_DS_WIER_WRTCE                     *((volatile unsigned char*)(0x426B0180UL))
#define bFM4_DS_WIER_WLVDE                     *((volatile unsigned char*)(0x426B0184UL))
#define bFM4_DS_WIER_WUI1E                     *((volatile unsigned char*)(0x426B018CUL))
#define bFM4_DS_WIER_WUI2E                     *((volatile unsigned char*)(0x426B0190UL))
#define bFM4_DS_WIER_WUI3E                     *((volatile unsigned char*)(0x426B0194UL))
#define bFM4_DS_WIER_WUI4E                     *((volatile unsigned char*)(0x426B0198UL))
#define bFM4_DS_WIER_WUI5E                     *((volatile unsigned char*)(0x426B019CUL))
#define bFM4_DS_WILVR_WUI1LV                   *((volatile unsigned char*)(0x426B0200UL))
#define bFM4_DS_WILVR_WUI2LV                   *((volatile unsigned char*)(0x426B0204UL))
#define bFM4_DS_WILVR_WUI3LV                   *((volatile unsigned char*)(0x426B0208UL))
#define bFM4_DS_WILVR_WUI4LV                   *((volatile unsigned char*)(0x426B020CUL))
#define bFM4_DS_WILVR_WUI5LV                   *((volatile unsigned char*)(0x426B0210UL))
#define bFM4_DS_DSRAMR_SRAMR0                  *((volatile unsigned char*)(0x426B0280UL))
#define bFM4_DS_DSRAMR_SRAMR1                  *((volatile unsigned char*)(0x426B0284UL))

/* USB clock registers */
#define bFM4_USBCLK_UCCR_UCEN                  *((volatile unsigned char*)(0x426C0000UL))
#define bFM4_USBCLK_UCCR_UCSEL                 *((volatile unsigned char*)(0x426C0004UL))
#define bFM4_USBCLK_UPCR1_UPLLEN               *((volatile unsigned char*)(0x426C0080UL))
#define bFM4_USBCLK_UPCR1_UPINC                *((volatile unsigned char*)(0x426C0084UL))
#define bFM4_USBCLK_UPCR2_UPOWT0               *((volatile unsigned char*)(0x426C0100UL))
#define bFM4_USBCLK_UPCR2_UPOWT1               *((volatile unsigned char*)(0x426C0104UL))
#define bFM4_USBCLK_UPCR2_UPOWT2               *((volatile unsigned char*)(0x426C0108UL))
#define bFM4_USBCLK_UPCR3_UPLLK0               *((volatile unsigned char*)(0x426C0180UL))
#define bFM4_USBCLK_UPCR3_UPLLK1               *((volatile unsigned char*)(0x426C0184UL))
#define bFM4_USBCLK_UPCR3_UPLLK2               *((volatile unsigned char*)(0x426C0188UL))
#define bFM4_USBCLK_UPCR3_UPLLK3               *((volatile unsigned char*)(0x426C018CUL))
#define bFM4_USBCLK_UPCR3_UPLLK4               *((volatile unsigned char*)(0x426C0190UL))
#define bFM4_USBCLK_UPCR4_UPLLN0               *((volatile unsigned char*)(0x426C0200UL))
#define bFM4_USBCLK_UPCR4_UPLLN1               *((volatile unsigned char*)(0x426C0204UL))
#define bFM4_USBCLK_UPCR4_UPLLN2               *((volatile unsigned char*)(0x426C0208UL))
#define bFM4_USBCLK_UPCR4_UPLLN3               *((volatile unsigned char*)(0x426C020CUL))
#define bFM4_USBCLK_UPCR4_UPLLN4               *((volatile unsigned char*)(0x426C0210UL))
#define bFM4_USBCLK_UP_STR_UPRDY               *((volatile unsigned char*)(0x426C0280UL))
#define bFM4_USBCLK_UPINT_ENR_UPCSE            *((volatile unsigned char*)(0x426C0300UL))
#define bFM4_USBCLK_UPINT_CLR_UPCSC            *((volatile unsigned char*)(0x426C0380UL))
#define bFM4_USBCLK_UPINT_STR_UPCSI            *((volatile unsigned char*)(0x426C0400UL))
#define bFM4_USBCLK_USBEN_USBEN                *((volatile unsigned char*)(0x426C0600UL))

/* CAN prescaler register */
#define bFM4_CANPRES_CANPRE_CANPRE0            *((volatile unsigned char*)(0x426E0000UL))
#define bFM4_CANPRES_CANPRE_CANPRE1            *((volatile unsigned char*)(0x426E0004UL))
#define bFM4_CANPRES_CANPRE_CANPRE2            *((volatile unsigned char*)(0x426E0008UL))
#define bFM4_CANPRES_CANPRE_CANPRE3            *((volatile unsigned char*)(0x426E000CUL))

/* MFS UART channel 0 registers */
#define bFM4_MFS0_UART_SMR_SOE                 *((volatile unsigned char*)(0x42700000UL))
#define bFM4_MFS0_UART_SMR_BDS                 *((volatile unsigned char*)(0x42700008UL))
#define bFM4_MFS0_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270000CUL))
#define bFM4_MFS0_UART_SMR_WUCR                *((volatile unsigned char*)(0x42700010UL))
#define bFM4_MFS0_UART_SMR_MD0                 *((volatile unsigned char*)(0x42700014UL))
#define bFM4_MFS0_UART_SMR_MD1                 *((volatile unsigned char*)(0x42700018UL))
#define bFM4_MFS0_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270001CUL))
#define bFM4_MFS0_UART_SCR_TXE                 *((volatile unsigned char*)(0x42700020UL))
#define bFM4_MFS0_UART_SCR_RXE                 *((volatile unsigned char*)(0x42700024UL))
#define bFM4_MFS0_UART_SCR_TBIE                *((volatile unsigned char*)(0x42700028UL))
#define bFM4_MFS0_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270002CUL))
#define bFM4_MFS0_UART_SCR_RIE                 *((volatile unsigned char*)(0x42700030UL))
#define bFM4_MFS0_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270003CUL))
#define bFM4_MFS0_UART_ESCR_L0                 *((volatile unsigned char*)(0x42700080UL))
#define bFM4_MFS0_UART_ESCR_L1                 *((volatile unsigned char*)(0x42700084UL))
#define bFM4_MFS0_UART_ESCR_L2                 *((volatile unsigned char*)(0x42700088UL))
#define bFM4_MFS0_UART_ESCR_P                  *((volatile unsigned char*)(0x4270008CUL))
#define bFM4_MFS0_UART_ESCR_PEN                *((volatile unsigned char*)(0x42700090UL))
#define bFM4_MFS0_UART_ESCR_INV                *((volatile unsigned char*)(0x42700094UL))
#define bFM4_MFS0_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42700098UL))
#define bFM4_MFS0_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270009CUL))
#define bFM4_MFS0_UART_SSR_TBI                 *((volatile unsigned char*)(0x427000A0UL))
#define bFM4_MFS0_UART_SSR_TDRE                *((volatile unsigned char*)(0x427000A4UL))
#define bFM4_MFS0_UART_SSR_RDRF                *((volatile unsigned char*)(0x427000A8UL))
#define bFM4_MFS0_UART_SSR_ORE                 *((volatile unsigned char*)(0x427000ACUL))
#define bFM4_MFS0_UART_SSR_FRE                 *((volatile unsigned char*)(0x427000B0UL))
#define bFM4_MFS0_UART_SSR_PE                  *((volatile unsigned char*)(0x427000B4UL))
#define bFM4_MFS0_UART_SSR_REC                 *((volatile unsigned char*)(0x427000BCUL))
#define bFM4_MFS0_UART_BGR_EXT                 *((volatile unsigned char*)(0x427001BCUL))
#define bFM4_MFS0_UART_BGR1_EXT                *((volatile unsigned char*)(0x427001BCUL))
#define bFM4_MFS0_UART_FCR_FE1                 *((volatile unsigned char*)(0x42700280UL))
#define bFM4_MFS0_UART_FCR_FE2                 *((volatile unsigned char*)(0x42700284UL))
#define bFM4_MFS0_UART_FCR_FCL1                *((volatile unsigned char*)(0x42700288UL))
#define bFM4_MFS0_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270028CUL))
#define bFM4_MFS0_UART_FCR_FSET                *((volatile unsigned char*)(0x42700290UL))
#define bFM4_MFS0_UART_FCR_FLD                 *((volatile unsigned char*)(0x42700294UL))
#define bFM4_MFS0_UART_FCR_FLST                *((volatile unsigned char*)(0x42700298UL))
#define bFM4_MFS0_UART_FCR_FSEL                *((volatile unsigned char*)(0x427002A0UL))
#define bFM4_MFS0_UART_FCR_FTIE                *((volatile unsigned char*)(0x427002A4UL))
#define bFM4_MFS0_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427002A8UL))
#define bFM4_MFS0_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427002ACUL))
#define bFM4_MFS0_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427002B0UL))
#define bFM4_MFS0_UART_FCR0_FE1                *((volatile unsigned char*)(0x42700280UL))
#define bFM4_MFS0_UART_FCR0_FE2                *((volatile unsigned char*)(0x42700284UL))
#define bFM4_MFS0_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42700288UL))
#define bFM4_MFS0_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270028CUL))
#define bFM4_MFS0_UART_FCR0_FSET               *((volatile unsigned char*)(0x42700290UL))
#define bFM4_MFS0_UART_FCR0_FLD                *((volatile unsigned char*)(0x42700294UL))
#define bFM4_MFS0_UART_FCR0_FLST               *((volatile unsigned char*)(0x42700298UL))
#define bFM4_MFS0_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427002A0UL))
#define bFM4_MFS0_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427002A4UL))
#define bFM4_MFS0_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427002A8UL))
#define bFM4_MFS0_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427002ACUL))
#define bFM4_MFS0_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427002B0UL))
#define bFM4_MFS0_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42700300UL))
#define bFM4_MFS0_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42700304UL))
#define bFM4_MFS0_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42700308UL))
#define bFM4_MFS0_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270030CUL))
#define bFM4_MFS0_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42700310UL))
#define bFM4_MFS0_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42700314UL))
#define bFM4_MFS0_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42700318UL))
#define bFM4_MFS0_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270031CUL))
#define bFM4_MFS0_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42700320UL))
#define bFM4_MFS0_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42700324UL))
#define bFM4_MFS0_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42700328UL))
#define bFM4_MFS0_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270032CUL))
#define bFM4_MFS0_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42700330UL))
#define bFM4_MFS0_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42700334UL))
#define bFM4_MFS0_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42700338UL))
#define bFM4_MFS0_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270033CUL))
#define bFM4_MFS0_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42700300UL))
#define bFM4_MFS0_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42700304UL))
#define bFM4_MFS0_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42700308UL))
#define bFM4_MFS0_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270030CUL))
#define bFM4_MFS0_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42700310UL))
#define bFM4_MFS0_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42700314UL))
#define bFM4_MFS0_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42700318UL))
#define bFM4_MFS0_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270031CUL))
#define bFM4_MFS0_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42700320UL))
#define bFM4_MFS0_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42700324UL))
#define bFM4_MFS0_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42700328UL))
#define bFM4_MFS0_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270032CUL))
#define bFM4_MFS0_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42700330UL))
#define bFM4_MFS0_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42700334UL))
#define bFM4_MFS0_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42700338UL))
#define bFM4_MFS0_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270033CUL))

/* MFS CSIO channel 0 registers */
#define bFM4_MFS0_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42700000UL))
#define bFM4_MFS0_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42700004UL))
#define bFM4_MFS0_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42700008UL))
#define bFM4_MFS0_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270000CUL))
#define bFM4_MFS0_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42700014UL))
#define bFM4_MFS0_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42700018UL))
#define bFM4_MFS0_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270001CUL))
#define bFM4_MFS0_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42700020UL))
#define bFM4_MFS0_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42700024UL))
#define bFM4_MFS0_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42700028UL))
#define bFM4_MFS0_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270002CUL))
#define bFM4_MFS0_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42700030UL))
#define bFM4_MFS0_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42700034UL))
#define bFM4_MFS0_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42700038UL))
#define bFM4_MFS0_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270003CUL))
#define bFM4_MFS0_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42700080UL))
#define bFM4_MFS0_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42700084UL))
#define bFM4_MFS0_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42700088UL))
#define bFM4_MFS0_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270008CUL))
#define bFM4_MFS0_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42700090UL))
#define bFM4_MFS0_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42700094UL))
#define bFM4_MFS0_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42700098UL))
#define bFM4_MFS0_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270009CUL))
#define bFM4_MFS0_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427000A0UL))
#define bFM4_MFS0_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427000A4UL))
#define bFM4_MFS0_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427000A8UL))
#define bFM4_MFS0_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427000ACUL))
#define bFM4_MFS0_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427000B0UL))
#define bFM4_MFS0_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427000BCUL))
#define bFM4_MFS0_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42700280UL))
#define bFM4_MFS0_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42700284UL))
#define bFM4_MFS0_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42700288UL))
#define bFM4_MFS0_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270028CUL))
#define bFM4_MFS0_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42700290UL))
#define bFM4_MFS0_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42700294UL))
#define bFM4_MFS0_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42700298UL))
#define bFM4_MFS0_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427002A0UL))
#define bFM4_MFS0_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427002A4UL))
#define bFM4_MFS0_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427002A8UL))
#define bFM4_MFS0_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427002ACUL))
#define bFM4_MFS0_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427002B0UL))
#define bFM4_MFS0_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42700280UL))
#define bFM4_MFS0_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42700284UL))
#define bFM4_MFS0_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42700288UL))
#define bFM4_MFS0_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270028CUL))
#define bFM4_MFS0_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42700290UL))
#define bFM4_MFS0_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42700294UL))
#define bFM4_MFS0_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42700298UL))
#define bFM4_MFS0_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427002A0UL))
#define bFM4_MFS0_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427002A4UL))
#define bFM4_MFS0_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427002A8UL))
#define bFM4_MFS0_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427002ACUL))
#define bFM4_MFS0_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427002B0UL))
#define bFM4_MFS0_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42700300UL))
#define bFM4_MFS0_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42700304UL))
#define bFM4_MFS0_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42700308UL))
#define bFM4_MFS0_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270030CUL))
#define bFM4_MFS0_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42700310UL))
#define bFM4_MFS0_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42700314UL))
#define bFM4_MFS0_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42700318UL))
#define bFM4_MFS0_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270031CUL))
#define bFM4_MFS0_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42700320UL))
#define bFM4_MFS0_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42700324UL))
#define bFM4_MFS0_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42700328UL))
#define bFM4_MFS0_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270032CUL))
#define bFM4_MFS0_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42700330UL))
#define bFM4_MFS0_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42700334UL))
#define bFM4_MFS0_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42700338UL))
#define bFM4_MFS0_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270033CUL))
#define bFM4_MFS0_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42700300UL))
#define bFM4_MFS0_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42700304UL))
#define bFM4_MFS0_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42700308UL))
#define bFM4_MFS0_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270030CUL))
#define bFM4_MFS0_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42700310UL))
#define bFM4_MFS0_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42700314UL))
#define bFM4_MFS0_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42700318UL))
#define bFM4_MFS0_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270031CUL))
#define bFM4_MFS0_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42700320UL))
#define bFM4_MFS0_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42700324UL))
#define bFM4_MFS0_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42700328UL))
#define bFM4_MFS0_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270032CUL))
#define bFM4_MFS0_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42700330UL))
#define bFM4_MFS0_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42700334UL))
#define bFM4_MFS0_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42700338UL))
#define bFM4_MFS0_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270033CUL))
#define bFM4_MFS0_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42700380UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42700384UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42700388UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270038CUL))
#define bFM4_MFS0_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42700390UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42700394UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42700398UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270039CUL))
#define bFM4_MFS0_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427003A0UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427003A4UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427003A8UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427003ACUL))
#define bFM4_MFS0_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427003B0UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427003B4UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427003B8UL))
#define bFM4_MFS0_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427003BCUL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42700400UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42700404UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42700408UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270040CUL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42700410UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42700414UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42700418UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270041CUL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42700420UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42700424UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42700428UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270042CUL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42700430UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42700434UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42700438UL))
#define bFM4_MFS0_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270043CUL))
#define bFM4_MFS0_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42700480UL))
#define bFM4_MFS0_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42700484UL))
#define bFM4_MFS0_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42700488UL))
#define bFM4_MFS0_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270048CUL))
#define bFM4_MFS0_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42700490UL))
#define bFM4_MFS0_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42700498UL))
#define bFM4_MFS0_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270049CUL))
#define bFM4_MFS0_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427004A0UL))
#define bFM4_MFS0_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427004ACUL))
#define bFM4_MFS0_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427004B0UL))
#define bFM4_MFS0_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427004B4UL))
#define bFM4_MFS0_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42700500UL))
#define bFM4_MFS0_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42700504UL))
#define bFM4_MFS0_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42700508UL))
#define bFM4_MFS0_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270050CUL))
#define bFM4_MFS0_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42700510UL))
#define bFM4_MFS0_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42700514UL))
#define bFM4_MFS0_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42700518UL))
#define bFM4_MFS0_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270051CUL))
#define bFM4_MFS0_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42700520UL))
#define bFM4_MFS0_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42700524UL))
#define bFM4_MFS0_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42700528UL))
#define bFM4_MFS0_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270052CUL))
#define bFM4_MFS0_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42700530UL))
#define bFM4_MFS0_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42700534UL))
#define bFM4_MFS0_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42700538UL))
#define bFM4_MFS0_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270053CUL))
#define bFM4_MFS0_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42700580UL))
#define bFM4_MFS0_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42700584UL))
#define bFM4_MFS0_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42700588UL))
#define bFM4_MFS0_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270058CUL))
#define bFM4_MFS0_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42700590UL))
#define bFM4_MFS0_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42700594UL))
#define bFM4_MFS0_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42700598UL))
#define bFM4_MFS0_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270059CUL))
#define bFM4_MFS0_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427005A0UL))
#define bFM4_MFS0_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427005A4UL))
#define bFM4_MFS0_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427005A8UL))
#define bFM4_MFS0_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427005ACUL))
#define bFM4_MFS0_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427005B0UL))
#define bFM4_MFS0_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427005B4UL))
#define bFM4_MFS0_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427005B8UL))
#define bFM4_MFS0_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427005BCUL))
#define bFM4_MFS0_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42700600UL))
#define bFM4_MFS0_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42700604UL))
#define bFM4_MFS0_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42700608UL))
#define bFM4_MFS0_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270060CUL))
#define bFM4_MFS0_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42700610UL))
#define bFM4_MFS0_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42700614UL))
#define bFM4_MFS0_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42700618UL))
#define bFM4_MFS0_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270061CUL))
#define bFM4_MFS0_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42700620UL))
#define bFM4_MFS0_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42700624UL))
#define bFM4_MFS0_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42700628UL))
#define bFM4_MFS0_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270062CUL))
#define bFM4_MFS0_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42700630UL))
#define bFM4_MFS0_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42700634UL))
#define bFM4_MFS0_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42700638UL))
#define bFM4_MFS0_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270063CUL))
#define bFM4_MFS0_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42700680UL))
#define bFM4_MFS0_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42700684UL))
#define bFM4_MFS0_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42700688UL))
#define bFM4_MFS0_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270068CUL))
#define bFM4_MFS0_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42700690UL))
#define bFM4_MFS0_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42700694UL))
#define bFM4_MFS0_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42700698UL))
#define bFM4_MFS0_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270069CUL))
#define bFM4_MFS0_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427006A0UL))
#define bFM4_MFS0_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427006A4UL))
#define bFM4_MFS0_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427006A8UL))
#define bFM4_MFS0_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427006ACUL))
#define bFM4_MFS0_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427006B0UL))
#define bFM4_MFS0_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427006B4UL))
#define bFM4_MFS0_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427006B8UL))
#define bFM4_MFS0_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427006BCUL))
#define bFM4_MFS0_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42700700UL))
#define bFM4_MFS0_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42700704UL))
#define bFM4_MFS0_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42700708UL))
#define bFM4_MFS0_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270070CUL))
#define bFM4_MFS0_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42700710UL))
#define bFM4_MFS0_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42700714UL))
#define bFM4_MFS0_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42700718UL))
#define bFM4_MFS0_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270071CUL))

/* MFS LIN channel 0 registers */
#define bFM4_MFS0_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42700000UL))
#define bFM4_MFS0_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270000CUL))
#define bFM4_MFS0_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42700010UL))
#define bFM4_MFS0_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42700014UL))
#define bFM4_MFS0_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42700018UL))
#define bFM4_MFS0_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270001CUL))
#define bFM4_MFS0_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42700020UL))
#define bFM4_MFS0_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42700024UL))
#define bFM4_MFS0_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42700028UL))
#define bFM4_MFS0_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270002CUL))
#define bFM4_MFS0_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42700030UL))
#define bFM4_MFS0_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42700034UL))
#define bFM4_MFS0_LIN_SCR_MS                   *((volatile unsigned char*)(0x42700038UL))
#define bFM4_MFS0_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270003CUL))
#define bFM4_MFS0_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42700080UL))
#define bFM4_MFS0_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42700084UL))
#define bFM4_MFS0_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42700088UL))
#define bFM4_MFS0_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270008CUL))
#define bFM4_MFS0_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42700090UL))
#define bFM4_MFS0_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42700098UL))
#define bFM4_MFS0_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427000A0UL))
#define bFM4_MFS0_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427000A4UL))
#define bFM4_MFS0_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427000A8UL))
#define bFM4_MFS0_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427000ACUL))
#define bFM4_MFS0_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427000B0UL))
#define bFM4_MFS0_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427000B4UL))
#define bFM4_MFS0_LIN_SSR_REC                  *((volatile unsigned char*)(0x427000BCUL))
#define bFM4_MFS0_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427001BCUL))
#define bFM4_MFS0_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427001BCUL))
#define bFM4_MFS0_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42700280UL))
#define bFM4_MFS0_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42700284UL))
#define bFM4_MFS0_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42700288UL))
#define bFM4_MFS0_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270028CUL))
#define bFM4_MFS0_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42700290UL))
#define bFM4_MFS0_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42700294UL))
#define bFM4_MFS0_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42700298UL))
#define bFM4_MFS0_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427002A0UL))
#define bFM4_MFS0_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427002A4UL))
#define bFM4_MFS0_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427002A8UL))
#define bFM4_MFS0_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427002ACUL))
#define bFM4_MFS0_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427002B0UL))
#define bFM4_MFS0_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42700280UL))
#define bFM4_MFS0_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42700284UL))
#define bFM4_MFS0_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42700288UL))
#define bFM4_MFS0_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270028CUL))
#define bFM4_MFS0_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42700290UL))
#define bFM4_MFS0_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42700294UL))
#define bFM4_MFS0_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42700298UL))
#define bFM4_MFS0_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427002A0UL))
#define bFM4_MFS0_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427002A4UL))
#define bFM4_MFS0_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427002A8UL))
#define bFM4_MFS0_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427002ACUL))
#define bFM4_MFS0_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427002B0UL))
#define bFM4_MFS0_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42700300UL))
#define bFM4_MFS0_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42700304UL))
#define bFM4_MFS0_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42700308UL))
#define bFM4_MFS0_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270030CUL))
#define bFM4_MFS0_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42700310UL))
#define bFM4_MFS0_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42700314UL))
#define bFM4_MFS0_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42700318UL))
#define bFM4_MFS0_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270031CUL))
#define bFM4_MFS0_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42700320UL))
#define bFM4_MFS0_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42700324UL))
#define bFM4_MFS0_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42700328UL))
#define bFM4_MFS0_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270032CUL))
#define bFM4_MFS0_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42700330UL))
#define bFM4_MFS0_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42700334UL))
#define bFM4_MFS0_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42700338UL))
#define bFM4_MFS0_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270033CUL))
#define bFM4_MFS0_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42700300UL))
#define bFM4_MFS0_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42700304UL))
#define bFM4_MFS0_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42700308UL))
#define bFM4_MFS0_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270030CUL))
#define bFM4_MFS0_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42700310UL))
#define bFM4_MFS0_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42700314UL))
#define bFM4_MFS0_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42700318UL))
#define bFM4_MFS0_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270031CUL))
#define bFM4_MFS0_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42700320UL))
#define bFM4_MFS0_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42700324UL))
#define bFM4_MFS0_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42700328UL))
#define bFM4_MFS0_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270032CUL))
#define bFM4_MFS0_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42700330UL))
#define bFM4_MFS0_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42700334UL))
#define bFM4_MFS0_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42700338UL))
#define bFM4_MFS0_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270033CUL))

/* MFS I2C channel 0 registers */
#define bFM4_MFS0_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42700008UL))
#define bFM4_MFS0_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270000CUL))
#define bFM4_MFS0_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42700014UL))
#define bFM4_MFS0_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42700018UL))
#define bFM4_MFS0_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270001CUL))
#define bFM4_MFS0_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42700020UL))
#define bFM4_MFS0_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42700024UL))
#define bFM4_MFS0_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42700028UL))
#define bFM4_MFS0_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270002CUL))
#define bFM4_MFS0_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42700030UL))
#define bFM4_MFS0_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42700034UL))
#define bFM4_MFS0_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42700038UL))
#define bFM4_MFS0_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42700038UL))
#define bFM4_MFS0_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270003CUL))
#define bFM4_MFS0_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42700080UL))
#define bFM4_MFS0_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42700084UL))
#define bFM4_MFS0_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42700088UL))
#define bFM4_MFS0_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270008CUL))
#define bFM4_MFS0_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42700090UL))
#define bFM4_MFS0_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42700094UL))
#define bFM4_MFS0_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42700098UL))
#define bFM4_MFS0_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270009CUL))
#define bFM4_MFS0_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427000A0UL))
#define bFM4_MFS0_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427000A4UL))
#define bFM4_MFS0_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427000A8UL))
#define bFM4_MFS0_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427000ACUL))
#define bFM4_MFS0_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427000B0UL))
#define bFM4_MFS0_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427000B4UL))
#define bFM4_MFS0_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427000B8UL))
#define bFM4_MFS0_I2C_SSR_REC                  *((volatile unsigned char*)(0x427000BCUL))
#define bFM4_MFS0_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42700200UL))
#define bFM4_MFS0_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42700204UL))
#define bFM4_MFS0_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42700208UL))
#define bFM4_MFS0_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270020CUL))
#define bFM4_MFS0_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42700210UL))
#define bFM4_MFS0_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42700214UL))
#define bFM4_MFS0_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42700218UL))
#define bFM4_MFS0_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270021CUL))
#define bFM4_MFS0_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42700220UL))
#define bFM4_MFS0_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42700224UL))
#define bFM4_MFS0_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42700228UL))
#define bFM4_MFS0_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270022CUL))
#define bFM4_MFS0_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42700230UL))
#define bFM4_MFS0_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42700234UL))
#define bFM4_MFS0_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42700238UL))
#define bFM4_MFS0_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270023CUL))
#define bFM4_MFS0_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42700280UL))
#define bFM4_MFS0_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42700284UL))
#define bFM4_MFS0_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42700288UL))
#define bFM4_MFS0_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270028CUL))
#define bFM4_MFS0_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42700290UL))
#define bFM4_MFS0_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42700294UL))
#define bFM4_MFS0_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42700298UL))
#define bFM4_MFS0_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427002A0UL))
#define bFM4_MFS0_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427002A4UL))
#define bFM4_MFS0_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427002A8UL))
#define bFM4_MFS0_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427002ACUL))
#define bFM4_MFS0_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427002B0UL))
#define bFM4_MFS0_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42700280UL))
#define bFM4_MFS0_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42700284UL))
#define bFM4_MFS0_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42700288UL))
#define bFM4_MFS0_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270028CUL))
#define bFM4_MFS0_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42700290UL))
#define bFM4_MFS0_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42700294UL))
#define bFM4_MFS0_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42700298UL))
#define bFM4_MFS0_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427002A0UL))
#define bFM4_MFS0_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427002A4UL))
#define bFM4_MFS0_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427002A8UL))
#define bFM4_MFS0_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427002ACUL))
#define bFM4_MFS0_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427002B0UL))
#define bFM4_MFS0_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42700300UL))
#define bFM4_MFS0_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42700304UL))
#define bFM4_MFS0_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42700308UL))
#define bFM4_MFS0_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270030CUL))
#define bFM4_MFS0_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42700310UL))
#define bFM4_MFS0_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42700314UL))
#define bFM4_MFS0_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42700318UL))
#define bFM4_MFS0_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270031CUL))
#define bFM4_MFS0_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42700320UL))
#define bFM4_MFS0_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42700324UL))
#define bFM4_MFS0_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42700328UL))
#define bFM4_MFS0_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270032CUL))
#define bFM4_MFS0_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42700330UL))
#define bFM4_MFS0_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42700334UL))
#define bFM4_MFS0_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42700338UL))
#define bFM4_MFS0_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270033CUL))
#define bFM4_MFS0_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42700300UL))
#define bFM4_MFS0_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42700304UL))
#define bFM4_MFS0_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42700308UL))
#define bFM4_MFS0_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270030CUL))
#define bFM4_MFS0_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42700310UL))
#define bFM4_MFS0_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42700314UL))
#define bFM4_MFS0_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42700318UL))
#define bFM4_MFS0_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270031CUL))
#define bFM4_MFS0_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42700320UL))
#define bFM4_MFS0_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42700324UL))
#define bFM4_MFS0_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42700328UL))
#define bFM4_MFS0_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270032CUL))
#define bFM4_MFS0_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42700330UL))
#define bFM4_MFS0_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42700334UL))
#define bFM4_MFS0_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42700338UL))
#define bFM4_MFS0_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270033CUL))

/* MFS UART channel 1 registers */
#define bFM4_MFS1_UART_SMR_SOE                 *((volatile unsigned char*)(0x42702000UL))
#define bFM4_MFS1_UART_SMR_BDS                 *((volatile unsigned char*)(0x42702008UL))
#define bFM4_MFS1_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270200CUL))
#define bFM4_MFS1_UART_SMR_WUCR                *((volatile unsigned char*)(0x42702010UL))
#define bFM4_MFS1_UART_SMR_MD0                 *((volatile unsigned char*)(0x42702014UL))
#define bFM4_MFS1_UART_SMR_MD1                 *((volatile unsigned char*)(0x42702018UL))
#define bFM4_MFS1_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270201CUL))
#define bFM4_MFS1_UART_SCR_TXE                 *((volatile unsigned char*)(0x42702020UL))
#define bFM4_MFS1_UART_SCR_RXE                 *((volatile unsigned char*)(0x42702024UL))
#define bFM4_MFS1_UART_SCR_TBIE                *((volatile unsigned char*)(0x42702028UL))
#define bFM4_MFS1_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270202CUL))
#define bFM4_MFS1_UART_SCR_RIE                 *((volatile unsigned char*)(0x42702030UL))
#define bFM4_MFS1_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270203CUL))
#define bFM4_MFS1_UART_ESCR_L0                 *((volatile unsigned char*)(0x42702080UL))
#define bFM4_MFS1_UART_ESCR_L1                 *((volatile unsigned char*)(0x42702084UL))
#define bFM4_MFS1_UART_ESCR_L2                 *((volatile unsigned char*)(0x42702088UL))
#define bFM4_MFS1_UART_ESCR_P                  *((volatile unsigned char*)(0x4270208CUL))
#define bFM4_MFS1_UART_ESCR_PEN                *((volatile unsigned char*)(0x42702090UL))
#define bFM4_MFS1_UART_ESCR_INV                *((volatile unsigned char*)(0x42702094UL))
#define bFM4_MFS1_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42702098UL))
#define bFM4_MFS1_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270209CUL))
#define bFM4_MFS1_UART_SSR_TBI                 *((volatile unsigned char*)(0x427020A0UL))
#define bFM4_MFS1_UART_SSR_TDRE                *((volatile unsigned char*)(0x427020A4UL))
#define bFM4_MFS1_UART_SSR_RDRF                *((volatile unsigned char*)(0x427020A8UL))
#define bFM4_MFS1_UART_SSR_ORE                 *((volatile unsigned char*)(0x427020ACUL))
#define bFM4_MFS1_UART_SSR_FRE                 *((volatile unsigned char*)(0x427020B0UL))
#define bFM4_MFS1_UART_SSR_PE                  *((volatile unsigned char*)(0x427020B4UL))
#define bFM4_MFS1_UART_SSR_REC                 *((volatile unsigned char*)(0x427020BCUL))
#define bFM4_MFS1_UART_BGR_EXT                 *((volatile unsigned char*)(0x427021BCUL))
#define bFM4_MFS1_UART_BGR1_EXT                *((volatile unsigned char*)(0x427021BCUL))
#define bFM4_MFS1_UART_FCR_FE1                 *((volatile unsigned char*)(0x42702280UL))
#define bFM4_MFS1_UART_FCR_FE2                 *((volatile unsigned char*)(0x42702284UL))
#define bFM4_MFS1_UART_FCR_FCL1                *((volatile unsigned char*)(0x42702288UL))
#define bFM4_MFS1_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270228CUL))
#define bFM4_MFS1_UART_FCR_FSET                *((volatile unsigned char*)(0x42702290UL))
#define bFM4_MFS1_UART_FCR_FLD                 *((volatile unsigned char*)(0x42702294UL))
#define bFM4_MFS1_UART_FCR_FLST                *((volatile unsigned char*)(0x42702298UL))
#define bFM4_MFS1_UART_FCR_FSEL                *((volatile unsigned char*)(0x427022A0UL))
#define bFM4_MFS1_UART_FCR_FTIE                *((volatile unsigned char*)(0x427022A4UL))
#define bFM4_MFS1_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427022A8UL))
#define bFM4_MFS1_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427022ACUL))
#define bFM4_MFS1_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427022B0UL))
#define bFM4_MFS1_UART_FCR0_FE1                *((volatile unsigned char*)(0x42702280UL))
#define bFM4_MFS1_UART_FCR0_FE2                *((volatile unsigned char*)(0x42702284UL))
#define bFM4_MFS1_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42702288UL))
#define bFM4_MFS1_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270228CUL))
#define bFM4_MFS1_UART_FCR0_FSET               *((volatile unsigned char*)(0x42702290UL))
#define bFM4_MFS1_UART_FCR0_FLD                *((volatile unsigned char*)(0x42702294UL))
#define bFM4_MFS1_UART_FCR0_FLST               *((volatile unsigned char*)(0x42702298UL))
#define bFM4_MFS1_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427022A0UL))
#define bFM4_MFS1_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427022A4UL))
#define bFM4_MFS1_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427022A8UL))
#define bFM4_MFS1_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427022ACUL))
#define bFM4_MFS1_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427022B0UL))
#define bFM4_MFS1_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42702300UL))
#define bFM4_MFS1_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42702304UL))
#define bFM4_MFS1_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42702308UL))
#define bFM4_MFS1_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270230CUL))
#define bFM4_MFS1_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42702310UL))
#define bFM4_MFS1_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42702314UL))
#define bFM4_MFS1_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42702318UL))
#define bFM4_MFS1_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270231CUL))
#define bFM4_MFS1_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42702320UL))
#define bFM4_MFS1_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42702324UL))
#define bFM4_MFS1_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42702328UL))
#define bFM4_MFS1_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270232CUL))
#define bFM4_MFS1_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42702330UL))
#define bFM4_MFS1_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42702334UL))
#define bFM4_MFS1_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42702338UL))
#define bFM4_MFS1_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270233CUL))
#define bFM4_MFS1_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42702300UL))
#define bFM4_MFS1_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42702304UL))
#define bFM4_MFS1_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42702308UL))
#define bFM4_MFS1_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270230CUL))
#define bFM4_MFS1_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42702310UL))
#define bFM4_MFS1_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42702314UL))
#define bFM4_MFS1_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42702318UL))
#define bFM4_MFS1_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270231CUL))
#define bFM4_MFS1_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42702320UL))
#define bFM4_MFS1_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42702324UL))
#define bFM4_MFS1_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42702328UL))
#define bFM4_MFS1_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270232CUL))
#define bFM4_MFS1_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42702330UL))
#define bFM4_MFS1_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42702334UL))
#define bFM4_MFS1_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42702338UL))
#define bFM4_MFS1_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270233CUL))

/* MFS CSIO channel 1 registers */
#define bFM4_MFS1_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42702000UL))
#define bFM4_MFS1_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42702004UL))
#define bFM4_MFS1_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42702008UL))
#define bFM4_MFS1_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270200CUL))
#define bFM4_MFS1_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42702014UL))
#define bFM4_MFS1_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42702018UL))
#define bFM4_MFS1_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270201CUL))
#define bFM4_MFS1_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42702020UL))
#define bFM4_MFS1_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42702024UL))
#define bFM4_MFS1_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42702028UL))
#define bFM4_MFS1_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270202CUL))
#define bFM4_MFS1_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42702030UL))
#define bFM4_MFS1_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42702034UL))
#define bFM4_MFS1_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42702038UL))
#define bFM4_MFS1_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270203CUL))
#define bFM4_MFS1_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42702080UL))
#define bFM4_MFS1_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42702084UL))
#define bFM4_MFS1_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42702088UL))
#define bFM4_MFS1_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270208CUL))
#define bFM4_MFS1_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42702090UL))
#define bFM4_MFS1_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42702094UL))
#define bFM4_MFS1_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42702098UL))
#define bFM4_MFS1_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270209CUL))
#define bFM4_MFS1_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427020A0UL))
#define bFM4_MFS1_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427020A4UL))
#define bFM4_MFS1_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427020A8UL))
#define bFM4_MFS1_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427020ACUL))
#define bFM4_MFS1_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427020B0UL))
#define bFM4_MFS1_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427020BCUL))
#define bFM4_MFS1_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42702280UL))
#define bFM4_MFS1_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42702284UL))
#define bFM4_MFS1_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42702288UL))
#define bFM4_MFS1_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270228CUL))
#define bFM4_MFS1_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42702290UL))
#define bFM4_MFS1_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42702294UL))
#define bFM4_MFS1_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42702298UL))
#define bFM4_MFS1_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427022A0UL))
#define bFM4_MFS1_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427022A4UL))
#define bFM4_MFS1_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427022A8UL))
#define bFM4_MFS1_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427022ACUL))
#define bFM4_MFS1_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427022B0UL))
#define bFM4_MFS1_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42702280UL))
#define bFM4_MFS1_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42702284UL))
#define bFM4_MFS1_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42702288UL))
#define bFM4_MFS1_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270228CUL))
#define bFM4_MFS1_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42702290UL))
#define bFM4_MFS1_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42702294UL))
#define bFM4_MFS1_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42702298UL))
#define bFM4_MFS1_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427022A0UL))
#define bFM4_MFS1_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427022A4UL))
#define bFM4_MFS1_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427022A8UL))
#define bFM4_MFS1_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427022ACUL))
#define bFM4_MFS1_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427022B0UL))
#define bFM4_MFS1_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42702300UL))
#define bFM4_MFS1_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42702304UL))
#define bFM4_MFS1_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42702308UL))
#define bFM4_MFS1_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270230CUL))
#define bFM4_MFS1_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42702310UL))
#define bFM4_MFS1_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42702314UL))
#define bFM4_MFS1_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42702318UL))
#define bFM4_MFS1_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270231CUL))
#define bFM4_MFS1_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42702320UL))
#define bFM4_MFS1_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42702324UL))
#define bFM4_MFS1_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42702328UL))
#define bFM4_MFS1_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270232CUL))
#define bFM4_MFS1_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42702330UL))
#define bFM4_MFS1_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42702334UL))
#define bFM4_MFS1_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42702338UL))
#define bFM4_MFS1_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270233CUL))
#define bFM4_MFS1_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42702300UL))
#define bFM4_MFS1_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42702304UL))
#define bFM4_MFS1_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42702308UL))
#define bFM4_MFS1_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270230CUL))
#define bFM4_MFS1_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42702310UL))
#define bFM4_MFS1_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42702314UL))
#define bFM4_MFS1_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42702318UL))
#define bFM4_MFS1_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270231CUL))
#define bFM4_MFS1_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42702320UL))
#define bFM4_MFS1_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42702324UL))
#define bFM4_MFS1_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42702328UL))
#define bFM4_MFS1_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270232CUL))
#define bFM4_MFS1_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42702330UL))
#define bFM4_MFS1_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42702334UL))
#define bFM4_MFS1_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42702338UL))
#define bFM4_MFS1_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270233CUL))
#define bFM4_MFS1_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42702380UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42702384UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42702388UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270238CUL))
#define bFM4_MFS1_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42702390UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42702394UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42702398UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270239CUL))
#define bFM4_MFS1_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427023A0UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427023A4UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427023A8UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427023ACUL))
#define bFM4_MFS1_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427023B0UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427023B4UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427023B8UL))
#define bFM4_MFS1_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427023BCUL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42702400UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42702404UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42702408UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270240CUL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42702410UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42702414UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42702418UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270241CUL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42702420UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42702424UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42702428UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270242CUL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42702430UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42702434UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42702438UL))
#define bFM4_MFS1_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270243CUL))
#define bFM4_MFS1_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42702480UL))
#define bFM4_MFS1_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42702484UL))
#define bFM4_MFS1_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42702488UL))
#define bFM4_MFS1_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270248CUL))
#define bFM4_MFS1_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42702490UL))
#define bFM4_MFS1_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42702498UL))
#define bFM4_MFS1_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270249CUL))
#define bFM4_MFS1_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427024A0UL))
#define bFM4_MFS1_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427024ACUL))
#define bFM4_MFS1_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427024B0UL))
#define bFM4_MFS1_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427024B4UL))
#define bFM4_MFS1_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42702500UL))
#define bFM4_MFS1_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42702504UL))
#define bFM4_MFS1_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42702508UL))
#define bFM4_MFS1_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270250CUL))
#define bFM4_MFS1_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42702510UL))
#define bFM4_MFS1_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42702514UL))
#define bFM4_MFS1_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42702518UL))
#define bFM4_MFS1_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270251CUL))
#define bFM4_MFS1_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42702520UL))
#define bFM4_MFS1_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42702524UL))
#define bFM4_MFS1_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42702528UL))
#define bFM4_MFS1_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270252CUL))
#define bFM4_MFS1_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42702530UL))
#define bFM4_MFS1_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42702534UL))
#define bFM4_MFS1_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42702538UL))
#define bFM4_MFS1_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270253CUL))
#define bFM4_MFS1_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42702580UL))
#define bFM4_MFS1_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42702584UL))
#define bFM4_MFS1_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42702588UL))
#define bFM4_MFS1_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270258CUL))
#define bFM4_MFS1_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42702590UL))
#define bFM4_MFS1_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42702594UL))
#define bFM4_MFS1_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42702598UL))
#define bFM4_MFS1_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270259CUL))
#define bFM4_MFS1_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427025A0UL))
#define bFM4_MFS1_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427025A4UL))
#define bFM4_MFS1_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427025A8UL))
#define bFM4_MFS1_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427025ACUL))
#define bFM4_MFS1_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427025B0UL))
#define bFM4_MFS1_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427025B4UL))
#define bFM4_MFS1_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427025B8UL))
#define bFM4_MFS1_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427025BCUL))
#define bFM4_MFS1_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42702600UL))
#define bFM4_MFS1_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42702604UL))
#define bFM4_MFS1_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42702608UL))
#define bFM4_MFS1_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270260CUL))
#define bFM4_MFS1_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42702610UL))
#define bFM4_MFS1_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42702614UL))
#define bFM4_MFS1_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42702618UL))
#define bFM4_MFS1_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270261CUL))
#define bFM4_MFS1_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42702620UL))
#define bFM4_MFS1_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42702624UL))
#define bFM4_MFS1_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42702628UL))
#define bFM4_MFS1_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270262CUL))
#define bFM4_MFS1_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42702630UL))
#define bFM4_MFS1_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42702634UL))
#define bFM4_MFS1_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42702638UL))
#define bFM4_MFS1_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270263CUL))
#define bFM4_MFS1_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42702680UL))
#define bFM4_MFS1_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42702684UL))
#define bFM4_MFS1_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42702688UL))
#define bFM4_MFS1_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270268CUL))
#define bFM4_MFS1_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42702690UL))
#define bFM4_MFS1_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42702694UL))
#define bFM4_MFS1_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42702698UL))
#define bFM4_MFS1_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270269CUL))
#define bFM4_MFS1_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427026A0UL))
#define bFM4_MFS1_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427026A4UL))
#define bFM4_MFS1_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427026A8UL))
#define bFM4_MFS1_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427026ACUL))
#define bFM4_MFS1_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427026B0UL))
#define bFM4_MFS1_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427026B4UL))
#define bFM4_MFS1_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427026B8UL))
#define bFM4_MFS1_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427026BCUL))
#define bFM4_MFS1_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42702700UL))
#define bFM4_MFS1_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42702704UL))
#define bFM4_MFS1_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42702708UL))
#define bFM4_MFS1_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270270CUL))
#define bFM4_MFS1_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42702710UL))
#define bFM4_MFS1_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42702714UL))
#define bFM4_MFS1_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42702718UL))
#define bFM4_MFS1_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270271CUL))

/* MFS LIN channel 1 registers */
#define bFM4_MFS1_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42702000UL))
#define bFM4_MFS1_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270200CUL))
#define bFM4_MFS1_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42702010UL))
#define bFM4_MFS1_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42702014UL))
#define bFM4_MFS1_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42702018UL))
#define bFM4_MFS1_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270201CUL))
#define bFM4_MFS1_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42702020UL))
#define bFM4_MFS1_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42702024UL))
#define bFM4_MFS1_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42702028UL))
#define bFM4_MFS1_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270202CUL))
#define bFM4_MFS1_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42702030UL))
#define bFM4_MFS1_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42702034UL))
#define bFM4_MFS1_LIN_SCR_MS                   *((volatile unsigned char*)(0x42702038UL))
#define bFM4_MFS1_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270203CUL))
#define bFM4_MFS1_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42702080UL))
#define bFM4_MFS1_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42702084UL))
#define bFM4_MFS1_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42702088UL))
#define bFM4_MFS1_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270208CUL))
#define bFM4_MFS1_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42702090UL))
#define bFM4_MFS1_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42702098UL))
#define bFM4_MFS1_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427020A0UL))
#define bFM4_MFS1_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427020A4UL))
#define bFM4_MFS1_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427020A8UL))
#define bFM4_MFS1_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427020ACUL))
#define bFM4_MFS1_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427020B0UL))
#define bFM4_MFS1_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427020B4UL))
#define bFM4_MFS1_LIN_SSR_REC                  *((volatile unsigned char*)(0x427020BCUL))
#define bFM4_MFS1_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427021BCUL))
#define bFM4_MFS1_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427021BCUL))
#define bFM4_MFS1_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42702280UL))
#define bFM4_MFS1_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42702284UL))
#define bFM4_MFS1_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42702288UL))
#define bFM4_MFS1_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270228CUL))
#define bFM4_MFS1_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42702290UL))
#define bFM4_MFS1_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42702294UL))
#define bFM4_MFS1_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42702298UL))
#define bFM4_MFS1_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427022A0UL))
#define bFM4_MFS1_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427022A4UL))
#define bFM4_MFS1_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427022A8UL))
#define bFM4_MFS1_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427022ACUL))
#define bFM4_MFS1_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427022B0UL))
#define bFM4_MFS1_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42702280UL))
#define bFM4_MFS1_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42702284UL))
#define bFM4_MFS1_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42702288UL))
#define bFM4_MFS1_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270228CUL))
#define bFM4_MFS1_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42702290UL))
#define bFM4_MFS1_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42702294UL))
#define bFM4_MFS1_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42702298UL))
#define bFM4_MFS1_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427022A0UL))
#define bFM4_MFS1_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427022A4UL))
#define bFM4_MFS1_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427022A8UL))
#define bFM4_MFS1_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427022ACUL))
#define bFM4_MFS1_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427022B0UL))
#define bFM4_MFS1_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42702300UL))
#define bFM4_MFS1_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42702304UL))
#define bFM4_MFS1_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42702308UL))
#define bFM4_MFS1_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270230CUL))
#define bFM4_MFS1_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42702310UL))
#define bFM4_MFS1_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42702314UL))
#define bFM4_MFS1_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42702318UL))
#define bFM4_MFS1_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270231CUL))
#define bFM4_MFS1_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42702320UL))
#define bFM4_MFS1_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42702324UL))
#define bFM4_MFS1_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42702328UL))
#define bFM4_MFS1_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270232CUL))
#define bFM4_MFS1_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42702330UL))
#define bFM4_MFS1_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42702334UL))
#define bFM4_MFS1_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42702338UL))
#define bFM4_MFS1_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270233CUL))
#define bFM4_MFS1_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42702300UL))
#define bFM4_MFS1_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42702304UL))
#define bFM4_MFS1_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42702308UL))
#define bFM4_MFS1_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270230CUL))
#define bFM4_MFS1_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42702310UL))
#define bFM4_MFS1_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42702314UL))
#define bFM4_MFS1_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42702318UL))
#define bFM4_MFS1_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270231CUL))
#define bFM4_MFS1_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42702320UL))
#define bFM4_MFS1_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42702324UL))
#define bFM4_MFS1_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42702328UL))
#define bFM4_MFS1_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270232CUL))
#define bFM4_MFS1_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42702330UL))
#define bFM4_MFS1_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42702334UL))
#define bFM4_MFS1_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42702338UL))
#define bFM4_MFS1_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270233CUL))

/* MFS I2C channel 1 registers */
#define bFM4_MFS1_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42702008UL))
#define bFM4_MFS1_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270200CUL))
#define bFM4_MFS1_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42702014UL))
#define bFM4_MFS1_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42702018UL))
#define bFM4_MFS1_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270201CUL))
#define bFM4_MFS1_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42702020UL))
#define bFM4_MFS1_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42702024UL))
#define bFM4_MFS1_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42702028UL))
#define bFM4_MFS1_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270202CUL))
#define bFM4_MFS1_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42702030UL))
#define bFM4_MFS1_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42702034UL))
#define bFM4_MFS1_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42702038UL))
#define bFM4_MFS1_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42702038UL))
#define bFM4_MFS1_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270203CUL))
#define bFM4_MFS1_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42702080UL))
#define bFM4_MFS1_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42702084UL))
#define bFM4_MFS1_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42702088UL))
#define bFM4_MFS1_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270208CUL))
#define bFM4_MFS1_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42702090UL))
#define bFM4_MFS1_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42702094UL))
#define bFM4_MFS1_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42702098UL))
#define bFM4_MFS1_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270209CUL))
#define bFM4_MFS1_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427020A0UL))
#define bFM4_MFS1_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427020A4UL))
#define bFM4_MFS1_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427020A8UL))
#define bFM4_MFS1_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427020ACUL))
#define bFM4_MFS1_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427020B0UL))
#define bFM4_MFS1_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427020B4UL))
#define bFM4_MFS1_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427020B8UL))
#define bFM4_MFS1_I2C_SSR_REC                  *((volatile unsigned char*)(0x427020BCUL))
#define bFM4_MFS1_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42702200UL))
#define bFM4_MFS1_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42702204UL))
#define bFM4_MFS1_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42702208UL))
#define bFM4_MFS1_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270220CUL))
#define bFM4_MFS1_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42702210UL))
#define bFM4_MFS1_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42702214UL))
#define bFM4_MFS1_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42702218UL))
#define bFM4_MFS1_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270221CUL))
#define bFM4_MFS1_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42702220UL))
#define bFM4_MFS1_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42702224UL))
#define bFM4_MFS1_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42702228UL))
#define bFM4_MFS1_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270222CUL))
#define bFM4_MFS1_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42702230UL))
#define bFM4_MFS1_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42702234UL))
#define bFM4_MFS1_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42702238UL))
#define bFM4_MFS1_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270223CUL))
#define bFM4_MFS1_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42702280UL))
#define bFM4_MFS1_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42702284UL))
#define bFM4_MFS1_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42702288UL))
#define bFM4_MFS1_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270228CUL))
#define bFM4_MFS1_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42702290UL))
#define bFM4_MFS1_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42702294UL))
#define bFM4_MFS1_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42702298UL))
#define bFM4_MFS1_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427022A0UL))
#define bFM4_MFS1_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427022A4UL))
#define bFM4_MFS1_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427022A8UL))
#define bFM4_MFS1_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427022ACUL))
#define bFM4_MFS1_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427022B0UL))
#define bFM4_MFS1_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42702280UL))
#define bFM4_MFS1_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42702284UL))
#define bFM4_MFS1_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42702288UL))
#define bFM4_MFS1_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270228CUL))
#define bFM4_MFS1_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42702290UL))
#define bFM4_MFS1_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42702294UL))
#define bFM4_MFS1_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42702298UL))
#define bFM4_MFS1_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427022A0UL))
#define bFM4_MFS1_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427022A4UL))
#define bFM4_MFS1_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427022A8UL))
#define bFM4_MFS1_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427022ACUL))
#define bFM4_MFS1_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427022B0UL))
#define bFM4_MFS1_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42702300UL))
#define bFM4_MFS1_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42702304UL))
#define bFM4_MFS1_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42702308UL))
#define bFM4_MFS1_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270230CUL))
#define bFM4_MFS1_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42702310UL))
#define bFM4_MFS1_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42702314UL))
#define bFM4_MFS1_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42702318UL))
#define bFM4_MFS1_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270231CUL))
#define bFM4_MFS1_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42702320UL))
#define bFM4_MFS1_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42702324UL))
#define bFM4_MFS1_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42702328UL))
#define bFM4_MFS1_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270232CUL))
#define bFM4_MFS1_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42702330UL))
#define bFM4_MFS1_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42702334UL))
#define bFM4_MFS1_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42702338UL))
#define bFM4_MFS1_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270233CUL))
#define bFM4_MFS1_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42702300UL))
#define bFM4_MFS1_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42702304UL))
#define bFM4_MFS1_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42702308UL))
#define bFM4_MFS1_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270230CUL))
#define bFM4_MFS1_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42702310UL))
#define bFM4_MFS1_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42702314UL))
#define bFM4_MFS1_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42702318UL))
#define bFM4_MFS1_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270231CUL))
#define bFM4_MFS1_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42702320UL))
#define bFM4_MFS1_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42702324UL))
#define bFM4_MFS1_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42702328UL))
#define bFM4_MFS1_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270232CUL))
#define bFM4_MFS1_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42702330UL))
#define bFM4_MFS1_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42702334UL))
#define bFM4_MFS1_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42702338UL))
#define bFM4_MFS1_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270233CUL))

/* MFS UART channel 2 registers */
#define bFM4_MFS2_UART_SMR_SOE                 *((volatile unsigned char*)(0x42704000UL))
#define bFM4_MFS2_UART_SMR_BDS                 *((volatile unsigned char*)(0x42704008UL))
#define bFM4_MFS2_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270400CUL))
#define bFM4_MFS2_UART_SMR_WUCR                *((volatile unsigned char*)(0x42704010UL))
#define bFM4_MFS2_UART_SMR_MD0                 *((volatile unsigned char*)(0x42704014UL))
#define bFM4_MFS2_UART_SMR_MD1                 *((volatile unsigned char*)(0x42704018UL))
#define bFM4_MFS2_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270401CUL))
#define bFM4_MFS2_UART_SCR_TXE                 *((volatile unsigned char*)(0x42704020UL))
#define bFM4_MFS2_UART_SCR_RXE                 *((volatile unsigned char*)(0x42704024UL))
#define bFM4_MFS2_UART_SCR_TBIE                *((volatile unsigned char*)(0x42704028UL))
#define bFM4_MFS2_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270402CUL))
#define bFM4_MFS2_UART_SCR_RIE                 *((volatile unsigned char*)(0x42704030UL))
#define bFM4_MFS2_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270403CUL))
#define bFM4_MFS2_UART_ESCR_L0                 *((volatile unsigned char*)(0x42704080UL))
#define bFM4_MFS2_UART_ESCR_L1                 *((volatile unsigned char*)(0x42704084UL))
#define bFM4_MFS2_UART_ESCR_L2                 *((volatile unsigned char*)(0x42704088UL))
#define bFM4_MFS2_UART_ESCR_P                  *((volatile unsigned char*)(0x4270408CUL))
#define bFM4_MFS2_UART_ESCR_PEN                *((volatile unsigned char*)(0x42704090UL))
#define bFM4_MFS2_UART_ESCR_INV                *((volatile unsigned char*)(0x42704094UL))
#define bFM4_MFS2_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42704098UL))
#define bFM4_MFS2_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270409CUL))
#define bFM4_MFS2_UART_SSR_TBI                 *((volatile unsigned char*)(0x427040A0UL))
#define bFM4_MFS2_UART_SSR_TDRE                *((volatile unsigned char*)(0x427040A4UL))
#define bFM4_MFS2_UART_SSR_RDRF                *((volatile unsigned char*)(0x427040A8UL))
#define bFM4_MFS2_UART_SSR_ORE                 *((volatile unsigned char*)(0x427040ACUL))
#define bFM4_MFS2_UART_SSR_FRE                 *((volatile unsigned char*)(0x427040B0UL))
#define bFM4_MFS2_UART_SSR_PE                  *((volatile unsigned char*)(0x427040B4UL))
#define bFM4_MFS2_UART_SSR_REC                 *((volatile unsigned char*)(0x427040BCUL))
#define bFM4_MFS2_UART_BGR_EXT                 *((volatile unsigned char*)(0x427041BCUL))
#define bFM4_MFS2_UART_BGR1_EXT                *((volatile unsigned char*)(0x427041BCUL))
#define bFM4_MFS2_UART_FCR_FE1                 *((volatile unsigned char*)(0x42704280UL))
#define bFM4_MFS2_UART_FCR_FE2                 *((volatile unsigned char*)(0x42704284UL))
#define bFM4_MFS2_UART_FCR_FCL1                *((volatile unsigned char*)(0x42704288UL))
#define bFM4_MFS2_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270428CUL))
#define bFM4_MFS2_UART_FCR_FSET                *((volatile unsigned char*)(0x42704290UL))
#define bFM4_MFS2_UART_FCR_FLD                 *((volatile unsigned char*)(0x42704294UL))
#define bFM4_MFS2_UART_FCR_FLST                *((volatile unsigned char*)(0x42704298UL))
#define bFM4_MFS2_UART_FCR_FSEL                *((volatile unsigned char*)(0x427042A0UL))
#define bFM4_MFS2_UART_FCR_FTIE                *((volatile unsigned char*)(0x427042A4UL))
#define bFM4_MFS2_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427042A8UL))
#define bFM4_MFS2_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427042ACUL))
#define bFM4_MFS2_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427042B0UL))
#define bFM4_MFS2_UART_FCR0_FE1                *((volatile unsigned char*)(0x42704280UL))
#define bFM4_MFS2_UART_FCR0_FE2                *((volatile unsigned char*)(0x42704284UL))
#define bFM4_MFS2_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42704288UL))
#define bFM4_MFS2_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270428CUL))
#define bFM4_MFS2_UART_FCR0_FSET               *((volatile unsigned char*)(0x42704290UL))
#define bFM4_MFS2_UART_FCR0_FLD                *((volatile unsigned char*)(0x42704294UL))
#define bFM4_MFS2_UART_FCR0_FLST               *((volatile unsigned char*)(0x42704298UL))
#define bFM4_MFS2_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427042A0UL))
#define bFM4_MFS2_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427042A4UL))
#define bFM4_MFS2_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427042A8UL))
#define bFM4_MFS2_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427042ACUL))
#define bFM4_MFS2_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427042B0UL))
#define bFM4_MFS2_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42704300UL))
#define bFM4_MFS2_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42704304UL))
#define bFM4_MFS2_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42704308UL))
#define bFM4_MFS2_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270430CUL))
#define bFM4_MFS2_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42704310UL))
#define bFM4_MFS2_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42704314UL))
#define bFM4_MFS2_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42704318UL))
#define bFM4_MFS2_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270431CUL))
#define bFM4_MFS2_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42704320UL))
#define bFM4_MFS2_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42704324UL))
#define bFM4_MFS2_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42704328UL))
#define bFM4_MFS2_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270432CUL))
#define bFM4_MFS2_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42704330UL))
#define bFM4_MFS2_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42704334UL))
#define bFM4_MFS2_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42704338UL))
#define bFM4_MFS2_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270433CUL))
#define bFM4_MFS2_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42704300UL))
#define bFM4_MFS2_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42704304UL))
#define bFM4_MFS2_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42704308UL))
#define bFM4_MFS2_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270430CUL))
#define bFM4_MFS2_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42704310UL))
#define bFM4_MFS2_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42704314UL))
#define bFM4_MFS2_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42704318UL))
#define bFM4_MFS2_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270431CUL))
#define bFM4_MFS2_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42704320UL))
#define bFM4_MFS2_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42704324UL))
#define bFM4_MFS2_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42704328UL))
#define bFM4_MFS2_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270432CUL))
#define bFM4_MFS2_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42704330UL))
#define bFM4_MFS2_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42704334UL))
#define bFM4_MFS2_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42704338UL))
#define bFM4_MFS2_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270433CUL))

/* MFS CSIO channel 2 registers */
#define bFM4_MFS2_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42704000UL))
#define bFM4_MFS2_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42704004UL))
#define bFM4_MFS2_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42704008UL))
#define bFM4_MFS2_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270400CUL))
#define bFM4_MFS2_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42704014UL))
#define bFM4_MFS2_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42704018UL))
#define bFM4_MFS2_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270401CUL))
#define bFM4_MFS2_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42704020UL))
#define bFM4_MFS2_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42704024UL))
#define bFM4_MFS2_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42704028UL))
#define bFM4_MFS2_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270402CUL))
#define bFM4_MFS2_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42704030UL))
#define bFM4_MFS2_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42704034UL))
#define bFM4_MFS2_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42704038UL))
#define bFM4_MFS2_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270403CUL))
#define bFM4_MFS2_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42704080UL))
#define bFM4_MFS2_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42704084UL))
#define bFM4_MFS2_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42704088UL))
#define bFM4_MFS2_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270408CUL))
#define bFM4_MFS2_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42704090UL))
#define bFM4_MFS2_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42704094UL))
#define bFM4_MFS2_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42704098UL))
#define bFM4_MFS2_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270409CUL))
#define bFM4_MFS2_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427040A0UL))
#define bFM4_MFS2_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427040A4UL))
#define bFM4_MFS2_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427040A8UL))
#define bFM4_MFS2_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427040ACUL))
#define bFM4_MFS2_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427040B0UL))
#define bFM4_MFS2_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427040BCUL))
#define bFM4_MFS2_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42704280UL))
#define bFM4_MFS2_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42704284UL))
#define bFM4_MFS2_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42704288UL))
#define bFM4_MFS2_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270428CUL))
#define bFM4_MFS2_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42704290UL))
#define bFM4_MFS2_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42704294UL))
#define bFM4_MFS2_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42704298UL))
#define bFM4_MFS2_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427042A0UL))
#define bFM4_MFS2_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427042A4UL))
#define bFM4_MFS2_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427042A8UL))
#define bFM4_MFS2_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427042ACUL))
#define bFM4_MFS2_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427042B0UL))
#define bFM4_MFS2_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42704280UL))
#define bFM4_MFS2_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42704284UL))
#define bFM4_MFS2_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42704288UL))
#define bFM4_MFS2_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270428CUL))
#define bFM4_MFS2_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42704290UL))
#define bFM4_MFS2_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42704294UL))
#define bFM4_MFS2_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42704298UL))
#define bFM4_MFS2_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427042A0UL))
#define bFM4_MFS2_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427042A4UL))
#define bFM4_MFS2_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427042A8UL))
#define bFM4_MFS2_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427042ACUL))
#define bFM4_MFS2_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427042B0UL))
#define bFM4_MFS2_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42704300UL))
#define bFM4_MFS2_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42704304UL))
#define bFM4_MFS2_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42704308UL))
#define bFM4_MFS2_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270430CUL))
#define bFM4_MFS2_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42704310UL))
#define bFM4_MFS2_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42704314UL))
#define bFM4_MFS2_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42704318UL))
#define bFM4_MFS2_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270431CUL))
#define bFM4_MFS2_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42704320UL))
#define bFM4_MFS2_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42704324UL))
#define bFM4_MFS2_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42704328UL))
#define bFM4_MFS2_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270432CUL))
#define bFM4_MFS2_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42704330UL))
#define bFM4_MFS2_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42704334UL))
#define bFM4_MFS2_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42704338UL))
#define bFM4_MFS2_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270433CUL))
#define bFM4_MFS2_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42704300UL))
#define bFM4_MFS2_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42704304UL))
#define bFM4_MFS2_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42704308UL))
#define bFM4_MFS2_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270430CUL))
#define bFM4_MFS2_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42704310UL))
#define bFM4_MFS2_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42704314UL))
#define bFM4_MFS2_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42704318UL))
#define bFM4_MFS2_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270431CUL))
#define bFM4_MFS2_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42704320UL))
#define bFM4_MFS2_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42704324UL))
#define bFM4_MFS2_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42704328UL))
#define bFM4_MFS2_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270432CUL))
#define bFM4_MFS2_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42704330UL))
#define bFM4_MFS2_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42704334UL))
#define bFM4_MFS2_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42704338UL))
#define bFM4_MFS2_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270433CUL))
#define bFM4_MFS2_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42704380UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42704384UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42704388UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270438CUL))
#define bFM4_MFS2_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42704390UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42704394UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42704398UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270439CUL))
#define bFM4_MFS2_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427043A0UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427043A4UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427043A8UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427043ACUL))
#define bFM4_MFS2_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427043B0UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427043B4UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427043B8UL))
#define bFM4_MFS2_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427043BCUL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42704400UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42704404UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42704408UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270440CUL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42704410UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42704414UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42704418UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270441CUL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42704420UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42704424UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42704428UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270442CUL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42704430UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42704434UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42704438UL))
#define bFM4_MFS2_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270443CUL))
#define bFM4_MFS2_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42704480UL))
#define bFM4_MFS2_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42704484UL))
#define bFM4_MFS2_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42704488UL))
#define bFM4_MFS2_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270448CUL))
#define bFM4_MFS2_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42704490UL))
#define bFM4_MFS2_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42704498UL))
#define bFM4_MFS2_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270449CUL))
#define bFM4_MFS2_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427044A0UL))
#define bFM4_MFS2_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427044ACUL))
#define bFM4_MFS2_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427044B0UL))
#define bFM4_MFS2_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427044B4UL))
#define bFM4_MFS2_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42704500UL))
#define bFM4_MFS2_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42704504UL))
#define bFM4_MFS2_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42704508UL))
#define bFM4_MFS2_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270450CUL))
#define bFM4_MFS2_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42704510UL))
#define bFM4_MFS2_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42704514UL))
#define bFM4_MFS2_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42704518UL))
#define bFM4_MFS2_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270451CUL))
#define bFM4_MFS2_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42704520UL))
#define bFM4_MFS2_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42704524UL))
#define bFM4_MFS2_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42704528UL))
#define bFM4_MFS2_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270452CUL))
#define bFM4_MFS2_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42704530UL))
#define bFM4_MFS2_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42704534UL))
#define bFM4_MFS2_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42704538UL))
#define bFM4_MFS2_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270453CUL))
#define bFM4_MFS2_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42704580UL))
#define bFM4_MFS2_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42704584UL))
#define bFM4_MFS2_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42704588UL))
#define bFM4_MFS2_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270458CUL))
#define bFM4_MFS2_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42704590UL))
#define bFM4_MFS2_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42704594UL))
#define bFM4_MFS2_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42704598UL))
#define bFM4_MFS2_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270459CUL))
#define bFM4_MFS2_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427045A0UL))
#define bFM4_MFS2_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427045A4UL))
#define bFM4_MFS2_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427045A8UL))
#define bFM4_MFS2_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427045ACUL))
#define bFM4_MFS2_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427045B0UL))
#define bFM4_MFS2_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427045B4UL))
#define bFM4_MFS2_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427045B8UL))
#define bFM4_MFS2_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427045BCUL))
#define bFM4_MFS2_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42704600UL))
#define bFM4_MFS2_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42704604UL))
#define bFM4_MFS2_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42704608UL))
#define bFM4_MFS2_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270460CUL))
#define bFM4_MFS2_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42704610UL))
#define bFM4_MFS2_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42704614UL))
#define bFM4_MFS2_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42704618UL))
#define bFM4_MFS2_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270461CUL))
#define bFM4_MFS2_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42704620UL))
#define bFM4_MFS2_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42704624UL))
#define bFM4_MFS2_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42704628UL))
#define bFM4_MFS2_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270462CUL))
#define bFM4_MFS2_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42704630UL))
#define bFM4_MFS2_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42704634UL))
#define bFM4_MFS2_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42704638UL))
#define bFM4_MFS2_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270463CUL))
#define bFM4_MFS2_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42704680UL))
#define bFM4_MFS2_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42704684UL))
#define bFM4_MFS2_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42704688UL))
#define bFM4_MFS2_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270468CUL))
#define bFM4_MFS2_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42704690UL))
#define bFM4_MFS2_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42704694UL))
#define bFM4_MFS2_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42704698UL))
#define bFM4_MFS2_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270469CUL))
#define bFM4_MFS2_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427046A0UL))
#define bFM4_MFS2_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427046A4UL))
#define bFM4_MFS2_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427046A8UL))
#define bFM4_MFS2_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427046ACUL))
#define bFM4_MFS2_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427046B0UL))
#define bFM4_MFS2_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427046B4UL))
#define bFM4_MFS2_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427046B8UL))
#define bFM4_MFS2_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427046BCUL))
#define bFM4_MFS2_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42704700UL))
#define bFM4_MFS2_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42704704UL))
#define bFM4_MFS2_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42704708UL))
#define bFM4_MFS2_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270470CUL))
#define bFM4_MFS2_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42704710UL))
#define bFM4_MFS2_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42704714UL))
#define bFM4_MFS2_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42704718UL))
#define bFM4_MFS2_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270471CUL))


/* MFS LIN channel 2 registers */
#define bFM4_MFS2_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42704000UL))
#define bFM4_MFS2_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270400CUL))
#define bFM4_MFS2_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42704010UL))
#define bFM4_MFS2_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42704014UL))
#define bFM4_MFS2_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42704018UL))
#define bFM4_MFS2_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270401CUL))
#define bFM4_MFS2_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42704020UL))
#define bFM4_MFS2_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42704024UL))
#define bFM4_MFS2_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42704028UL))
#define bFM4_MFS2_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270402CUL))
#define bFM4_MFS2_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42704030UL))
#define bFM4_MFS2_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42704034UL))
#define bFM4_MFS2_LIN_SCR_MS                   *((volatile unsigned char*)(0x42704038UL))
#define bFM4_MFS2_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270403CUL))
#define bFM4_MFS2_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42704080UL))
#define bFM4_MFS2_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42704084UL))
#define bFM4_MFS2_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42704088UL))
#define bFM4_MFS2_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270408CUL))
#define bFM4_MFS2_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42704090UL))
#define bFM4_MFS2_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42704098UL))
#define bFM4_MFS2_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427040A0UL))
#define bFM4_MFS2_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427040A4UL))
#define bFM4_MFS2_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427040A8UL))
#define bFM4_MFS2_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427040ACUL))
#define bFM4_MFS2_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427040B0UL))
#define bFM4_MFS2_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427040B4UL))
#define bFM4_MFS2_LIN_SSR_REC                  *((volatile unsigned char*)(0x427040BCUL))
#define bFM4_MFS2_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427041BCUL))
#define bFM4_MFS2_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427041BCUL))
#define bFM4_MFS2_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42704280UL))
#define bFM4_MFS2_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42704284UL))
#define bFM4_MFS2_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42704288UL))
#define bFM4_MFS2_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270428CUL))
#define bFM4_MFS2_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42704290UL))
#define bFM4_MFS2_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42704294UL))
#define bFM4_MFS2_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42704298UL))
#define bFM4_MFS2_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427042A0UL))
#define bFM4_MFS2_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427042A4UL))
#define bFM4_MFS2_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427042A8UL))
#define bFM4_MFS2_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427042ACUL))
#define bFM4_MFS2_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427042B0UL))
#define bFM4_MFS2_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42704280UL))
#define bFM4_MFS2_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42704284UL))
#define bFM4_MFS2_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42704288UL))
#define bFM4_MFS2_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270428CUL))
#define bFM4_MFS2_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42704290UL))
#define bFM4_MFS2_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42704294UL))
#define bFM4_MFS2_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42704298UL))
#define bFM4_MFS2_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427042A0UL))
#define bFM4_MFS2_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427042A4UL))
#define bFM4_MFS2_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427042A8UL))
#define bFM4_MFS2_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427042ACUL))
#define bFM4_MFS2_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427042B0UL))
#define bFM4_MFS2_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42704300UL))
#define bFM4_MFS2_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42704304UL))
#define bFM4_MFS2_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42704308UL))
#define bFM4_MFS2_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270430CUL))
#define bFM4_MFS2_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42704310UL))
#define bFM4_MFS2_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42704314UL))
#define bFM4_MFS2_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42704318UL))
#define bFM4_MFS2_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270431CUL))
#define bFM4_MFS2_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42704320UL))
#define bFM4_MFS2_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42704324UL))
#define bFM4_MFS2_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42704328UL))
#define bFM4_MFS2_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270432CUL))
#define bFM4_MFS2_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42704330UL))
#define bFM4_MFS2_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42704334UL))
#define bFM4_MFS2_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42704338UL))
#define bFM4_MFS2_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270433CUL))
#define bFM4_MFS2_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42704300UL))
#define bFM4_MFS2_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42704304UL))
#define bFM4_MFS2_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42704308UL))
#define bFM4_MFS2_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270430CUL))
#define bFM4_MFS2_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42704310UL))
#define bFM4_MFS2_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42704314UL))
#define bFM4_MFS2_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42704318UL))
#define bFM4_MFS2_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270431CUL))
#define bFM4_MFS2_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42704320UL))
#define bFM4_MFS2_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42704324UL))
#define bFM4_MFS2_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42704328UL))
#define bFM4_MFS2_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270432CUL))
#define bFM4_MFS2_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42704330UL))
#define bFM4_MFS2_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42704334UL))
#define bFM4_MFS2_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42704338UL))
#define bFM4_MFS2_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270433CUL))

/* MFS I2C channel 2 registers */
#define bFM4_MFS2_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42704008UL))
#define bFM4_MFS2_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270400CUL))
#define bFM4_MFS2_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42704014UL))
#define bFM4_MFS2_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42704018UL))
#define bFM4_MFS2_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270401CUL))
#define bFM4_MFS2_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42704020UL))
#define bFM4_MFS2_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42704024UL))
#define bFM4_MFS2_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42704028UL))
#define bFM4_MFS2_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270402CUL))
#define bFM4_MFS2_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42704030UL))
#define bFM4_MFS2_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42704034UL))
#define bFM4_MFS2_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42704038UL))
#define bFM4_MFS2_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42704038UL))
#define bFM4_MFS2_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270403CUL))
#define bFM4_MFS2_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42704080UL))
#define bFM4_MFS2_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42704084UL))
#define bFM4_MFS2_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42704088UL))
#define bFM4_MFS2_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270408CUL))
#define bFM4_MFS2_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42704090UL))
#define bFM4_MFS2_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42704094UL))
#define bFM4_MFS2_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42704098UL))
#define bFM4_MFS2_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270409CUL))
#define bFM4_MFS2_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427040A0UL))
#define bFM4_MFS2_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427040A4UL))
#define bFM4_MFS2_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427040A8UL))
#define bFM4_MFS2_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427040ACUL))
#define bFM4_MFS2_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427040B0UL))
#define bFM4_MFS2_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427040B4UL))
#define bFM4_MFS2_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427040B8UL))
#define bFM4_MFS2_I2C_SSR_REC                  *((volatile unsigned char*)(0x427040BCUL))
#define bFM4_MFS2_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42704200UL))
#define bFM4_MFS2_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42704204UL))
#define bFM4_MFS2_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42704208UL))
#define bFM4_MFS2_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270420CUL))
#define bFM4_MFS2_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42704210UL))
#define bFM4_MFS2_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42704214UL))
#define bFM4_MFS2_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42704218UL))
#define bFM4_MFS2_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270421CUL))
#define bFM4_MFS2_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42704220UL))
#define bFM4_MFS2_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42704224UL))
#define bFM4_MFS2_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42704228UL))
#define bFM4_MFS2_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270422CUL))
#define bFM4_MFS2_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42704230UL))
#define bFM4_MFS2_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42704234UL))
#define bFM4_MFS2_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42704238UL))
#define bFM4_MFS2_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270423CUL))
#define bFM4_MFS2_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42704280UL))
#define bFM4_MFS2_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42704284UL))
#define bFM4_MFS2_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42704288UL))
#define bFM4_MFS2_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270428CUL))
#define bFM4_MFS2_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42704290UL))
#define bFM4_MFS2_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42704294UL))
#define bFM4_MFS2_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42704298UL))
#define bFM4_MFS2_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427042A0UL))
#define bFM4_MFS2_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427042A4UL))
#define bFM4_MFS2_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427042A8UL))
#define bFM4_MFS2_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427042ACUL))
#define bFM4_MFS2_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427042B0UL))
#define bFM4_MFS2_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42704280UL))
#define bFM4_MFS2_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42704284UL))
#define bFM4_MFS2_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42704288UL))
#define bFM4_MFS2_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270428CUL))
#define bFM4_MFS2_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42704290UL))
#define bFM4_MFS2_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42704294UL))
#define bFM4_MFS2_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42704298UL))
#define bFM4_MFS2_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427042A0UL))
#define bFM4_MFS2_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427042A4UL))
#define bFM4_MFS2_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427042A8UL))
#define bFM4_MFS2_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427042ACUL))
#define bFM4_MFS2_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427042B0UL))
#define bFM4_MFS2_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42704300UL))
#define bFM4_MFS2_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42704304UL))
#define bFM4_MFS2_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42704308UL))
#define bFM4_MFS2_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270430CUL))
#define bFM4_MFS2_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42704310UL))
#define bFM4_MFS2_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42704314UL))
#define bFM4_MFS2_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42704318UL))
#define bFM4_MFS2_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270431CUL))
#define bFM4_MFS2_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42704320UL))
#define bFM4_MFS2_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42704324UL))
#define bFM4_MFS2_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42704328UL))
#define bFM4_MFS2_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270432CUL))
#define bFM4_MFS2_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42704330UL))
#define bFM4_MFS2_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42704334UL))
#define bFM4_MFS2_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42704338UL))
#define bFM4_MFS2_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270433CUL))
#define bFM4_MFS2_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42704300UL))
#define bFM4_MFS2_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42704304UL))
#define bFM4_MFS2_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42704308UL))
#define bFM4_MFS2_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270430CUL))
#define bFM4_MFS2_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42704310UL))
#define bFM4_MFS2_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42704314UL))
#define bFM4_MFS2_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42704318UL))
#define bFM4_MFS2_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270431CUL))
#define bFM4_MFS2_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42704320UL))
#define bFM4_MFS2_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42704324UL))
#define bFM4_MFS2_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42704328UL))
#define bFM4_MFS2_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270432CUL))
#define bFM4_MFS2_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42704330UL))
#define bFM4_MFS2_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42704334UL))
#define bFM4_MFS2_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42704338UL))
#define bFM4_MFS2_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270433CUL))

/* MFS UART channel 3 registers */
#define bFM4_MFS3_UART_SMR_SOE                 *((volatile unsigned char*)(0x42706000UL))
#define bFM4_MFS3_UART_SMR_BDS                 *((volatile unsigned char*)(0x42706008UL))
#define bFM4_MFS3_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270600CUL))
#define bFM4_MFS3_UART_SMR_WUCR                *((volatile unsigned char*)(0x42706010UL))
#define bFM4_MFS3_UART_SMR_MD0                 *((volatile unsigned char*)(0x42706014UL))
#define bFM4_MFS3_UART_SMR_MD1                 *((volatile unsigned char*)(0x42706018UL))
#define bFM4_MFS3_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270601CUL))
#define bFM4_MFS3_UART_SCR_TXE                 *((volatile unsigned char*)(0x42706020UL))
#define bFM4_MFS3_UART_SCR_RXE                 *((volatile unsigned char*)(0x42706024UL))
#define bFM4_MFS3_UART_SCR_TBIE                *((volatile unsigned char*)(0x42706028UL))
#define bFM4_MFS3_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270602CUL))
#define bFM4_MFS3_UART_SCR_RIE                 *((volatile unsigned char*)(0x42706030UL))
#define bFM4_MFS3_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270603CUL))
#define bFM4_MFS3_UART_ESCR_L0                 *((volatile unsigned char*)(0x42706080UL))
#define bFM4_MFS3_UART_ESCR_L1                 *((volatile unsigned char*)(0x42706084UL))
#define bFM4_MFS3_UART_ESCR_L2                 *((volatile unsigned char*)(0x42706088UL))
#define bFM4_MFS3_UART_ESCR_P                  *((volatile unsigned char*)(0x4270608CUL))
#define bFM4_MFS3_UART_ESCR_PEN                *((volatile unsigned char*)(0x42706090UL))
#define bFM4_MFS3_UART_ESCR_INV                *((volatile unsigned char*)(0x42706094UL))
#define bFM4_MFS3_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42706098UL))
#define bFM4_MFS3_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270609CUL))
#define bFM4_MFS3_UART_SSR_TBI                 *((volatile unsigned char*)(0x427060A0UL))
#define bFM4_MFS3_UART_SSR_TDRE                *((volatile unsigned char*)(0x427060A4UL))
#define bFM4_MFS3_UART_SSR_RDRF                *((volatile unsigned char*)(0x427060A8UL))
#define bFM4_MFS3_UART_SSR_ORE                 *((volatile unsigned char*)(0x427060ACUL))
#define bFM4_MFS3_UART_SSR_FRE                 *((volatile unsigned char*)(0x427060B0UL))
#define bFM4_MFS3_UART_SSR_PE                  *((volatile unsigned char*)(0x427060B4UL))
#define bFM4_MFS3_UART_SSR_REC                 *((volatile unsigned char*)(0x427060BCUL))
#define bFM4_MFS3_UART_BGR_EXT                 *((volatile unsigned char*)(0x427061BCUL))
#define bFM4_MFS3_UART_BGR1_EXT                *((volatile unsigned char*)(0x427061BCUL))
#define bFM4_MFS3_UART_FCR_FE1                 *((volatile unsigned char*)(0x42706280UL))
#define bFM4_MFS3_UART_FCR_FE2                 *((volatile unsigned char*)(0x42706284UL))
#define bFM4_MFS3_UART_FCR_FCL1                *((volatile unsigned char*)(0x42706288UL))
#define bFM4_MFS3_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270628CUL))
#define bFM4_MFS3_UART_FCR_FSET                *((volatile unsigned char*)(0x42706290UL))
#define bFM4_MFS3_UART_FCR_FLD                 *((volatile unsigned char*)(0x42706294UL))
#define bFM4_MFS3_UART_FCR_FLST                *((volatile unsigned char*)(0x42706298UL))
#define bFM4_MFS3_UART_FCR_FSEL                *((volatile unsigned char*)(0x427062A0UL))
#define bFM4_MFS3_UART_FCR_FTIE                *((volatile unsigned char*)(0x427062A4UL))
#define bFM4_MFS3_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427062A8UL))
#define bFM4_MFS3_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427062ACUL))
#define bFM4_MFS3_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427062B0UL))
#define bFM4_MFS3_UART_FCR0_FE1                *((volatile unsigned char*)(0x42706280UL))
#define bFM4_MFS3_UART_FCR0_FE2                *((volatile unsigned char*)(0x42706284UL))
#define bFM4_MFS3_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42706288UL))
#define bFM4_MFS3_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270628CUL))
#define bFM4_MFS3_UART_FCR0_FSET               *((volatile unsigned char*)(0x42706290UL))
#define bFM4_MFS3_UART_FCR0_FLD                *((volatile unsigned char*)(0x42706294UL))
#define bFM4_MFS3_UART_FCR0_FLST               *((volatile unsigned char*)(0x42706298UL))
#define bFM4_MFS3_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427062A0UL))
#define bFM4_MFS3_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427062A4UL))
#define bFM4_MFS3_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427062A8UL))
#define bFM4_MFS3_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427062ACUL))
#define bFM4_MFS3_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427062B0UL))
#define bFM4_MFS3_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42706300UL))
#define bFM4_MFS3_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42706304UL))
#define bFM4_MFS3_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42706308UL))
#define bFM4_MFS3_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270630CUL))
#define bFM4_MFS3_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42706310UL))
#define bFM4_MFS3_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42706314UL))
#define bFM4_MFS3_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42706318UL))
#define bFM4_MFS3_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270631CUL))
#define bFM4_MFS3_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42706320UL))
#define bFM4_MFS3_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42706324UL))
#define bFM4_MFS3_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42706328UL))
#define bFM4_MFS3_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270632CUL))
#define bFM4_MFS3_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42706330UL))
#define bFM4_MFS3_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42706334UL))
#define bFM4_MFS3_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42706338UL))
#define bFM4_MFS3_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270633CUL))
#define bFM4_MFS3_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42706300UL))
#define bFM4_MFS3_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42706304UL))
#define bFM4_MFS3_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42706308UL))
#define bFM4_MFS3_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270630CUL))
#define bFM4_MFS3_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42706310UL))
#define bFM4_MFS3_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42706314UL))
#define bFM4_MFS3_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42706318UL))
#define bFM4_MFS3_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270631CUL))
#define bFM4_MFS3_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42706320UL))
#define bFM4_MFS3_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42706324UL))
#define bFM4_MFS3_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42706328UL))
#define bFM4_MFS3_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270632CUL))
#define bFM4_MFS3_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42706330UL))
#define bFM4_MFS3_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42706334UL))
#define bFM4_MFS3_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42706338UL))
#define bFM4_MFS3_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270633CUL))

/* MFS CSIO channel 3 registers */
#define bFM4_MFS3_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42706000UL))
#define bFM4_MFS3_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42706004UL))
#define bFM4_MFS3_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42706008UL))
#define bFM4_MFS3_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270600CUL))
#define bFM4_MFS3_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42706014UL))
#define bFM4_MFS3_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42706018UL))
#define bFM4_MFS3_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270601CUL))
#define bFM4_MFS3_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42706020UL))
#define bFM4_MFS3_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42706024UL))
#define bFM4_MFS3_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42706028UL))
#define bFM4_MFS3_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270602CUL))
#define bFM4_MFS3_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42706030UL))
#define bFM4_MFS3_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42706034UL))
#define bFM4_MFS3_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42706038UL))
#define bFM4_MFS3_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270603CUL))
#define bFM4_MFS3_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42706080UL))
#define bFM4_MFS3_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42706084UL))
#define bFM4_MFS3_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42706088UL))
#define bFM4_MFS3_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270608CUL))
#define bFM4_MFS3_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42706090UL))
#define bFM4_MFS3_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42706094UL))
#define bFM4_MFS3_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42706098UL))
#define bFM4_MFS3_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270609CUL))
#define bFM4_MFS3_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427060A0UL))
#define bFM4_MFS3_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427060A4UL))
#define bFM4_MFS3_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427060A8UL))
#define bFM4_MFS3_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427060ACUL))
#define bFM4_MFS3_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427060B0UL))
#define bFM4_MFS3_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427060BCUL))
#define bFM4_MFS3_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42706280UL))
#define bFM4_MFS3_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42706284UL))
#define bFM4_MFS3_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42706288UL))
#define bFM4_MFS3_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270628CUL))
#define bFM4_MFS3_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42706290UL))
#define bFM4_MFS3_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42706294UL))
#define bFM4_MFS3_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42706298UL))
#define bFM4_MFS3_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427062A0UL))
#define bFM4_MFS3_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427062A4UL))
#define bFM4_MFS3_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427062A8UL))
#define bFM4_MFS3_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427062ACUL))
#define bFM4_MFS3_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427062B0UL))
#define bFM4_MFS3_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42706280UL))
#define bFM4_MFS3_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42706284UL))
#define bFM4_MFS3_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42706288UL))
#define bFM4_MFS3_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270628CUL))
#define bFM4_MFS3_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42706290UL))
#define bFM4_MFS3_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42706294UL))
#define bFM4_MFS3_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42706298UL))
#define bFM4_MFS3_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427062A0UL))
#define bFM4_MFS3_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427062A4UL))
#define bFM4_MFS3_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427062A8UL))
#define bFM4_MFS3_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427062ACUL))
#define bFM4_MFS3_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427062B0UL))
#define bFM4_MFS3_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42706300UL))
#define bFM4_MFS3_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42706304UL))
#define bFM4_MFS3_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42706308UL))
#define bFM4_MFS3_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270630CUL))
#define bFM4_MFS3_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42706310UL))
#define bFM4_MFS3_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42706314UL))
#define bFM4_MFS3_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42706318UL))
#define bFM4_MFS3_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270631CUL))
#define bFM4_MFS3_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42706320UL))
#define bFM4_MFS3_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42706324UL))
#define bFM4_MFS3_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42706328UL))
#define bFM4_MFS3_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270632CUL))
#define bFM4_MFS3_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42706330UL))
#define bFM4_MFS3_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42706334UL))
#define bFM4_MFS3_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42706338UL))
#define bFM4_MFS3_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270633CUL))
#define bFM4_MFS3_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42706300UL))
#define bFM4_MFS3_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42706304UL))
#define bFM4_MFS3_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42706308UL))
#define bFM4_MFS3_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270630CUL))
#define bFM4_MFS3_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42706310UL))
#define bFM4_MFS3_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42706314UL))
#define bFM4_MFS3_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42706318UL))
#define bFM4_MFS3_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270631CUL))
#define bFM4_MFS3_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42706320UL))
#define bFM4_MFS3_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42706324UL))
#define bFM4_MFS3_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42706328UL))
#define bFM4_MFS3_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270632CUL))
#define bFM4_MFS3_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42706330UL))
#define bFM4_MFS3_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42706334UL))
#define bFM4_MFS3_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42706338UL))
#define bFM4_MFS3_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270633CUL))
#define bFM4_MFS3_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42706380UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42706384UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42706388UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270638CUL))
#define bFM4_MFS3_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42706390UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42706394UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42706398UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270639CUL))
#define bFM4_MFS3_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427063A0UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427063A4UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427063A8UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427063ACUL))
#define bFM4_MFS3_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427063B0UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427063B4UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427063B8UL))
#define bFM4_MFS3_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427063BCUL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42706400UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42706404UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42706408UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270640CUL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42706410UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42706414UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42706418UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270641CUL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42706420UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42706424UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42706428UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270642CUL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42706430UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42706434UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42706438UL))
#define bFM4_MFS3_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270643CUL))
#define bFM4_MFS3_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42706480UL))
#define bFM4_MFS3_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42706484UL))
#define bFM4_MFS3_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42706488UL))
#define bFM4_MFS3_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270648CUL))
#define bFM4_MFS3_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42706490UL))
#define bFM4_MFS3_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42706498UL))
#define bFM4_MFS3_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270649CUL))
#define bFM4_MFS3_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427064A0UL))
#define bFM4_MFS3_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427064ACUL))
#define bFM4_MFS3_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427064B0UL))
#define bFM4_MFS3_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427064B4UL))
#define bFM4_MFS3_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42706500UL))
#define bFM4_MFS3_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42706504UL))
#define bFM4_MFS3_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42706508UL))
#define bFM4_MFS3_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270650CUL))
#define bFM4_MFS3_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42706510UL))
#define bFM4_MFS3_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42706514UL))
#define bFM4_MFS3_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42706518UL))
#define bFM4_MFS3_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270651CUL))
#define bFM4_MFS3_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42706520UL))
#define bFM4_MFS3_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42706524UL))
#define bFM4_MFS3_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42706528UL))
#define bFM4_MFS3_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270652CUL))
#define bFM4_MFS3_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42706530UL))
#define bFM4_MFS3_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42706534UL))
#define bFM4_MFS3_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42706538UL))
#define bFM4_MFS3_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270653CUL))
#define bFM4_MFS3_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42706580UL))
#define bFM4_MFS3_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42706584UL))
#define bFM4_MFS3_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42706588UL))
#define bFM4_MFS3_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270658CUL))
#define bFM4_MFS3_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42706590UL))
#define bFM4_MFS3_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42706594UL))
#define bFM4_MFS3_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42706598UL))
#define bFM4_MFS3_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270659CUL))
#define bFM4_MFS3_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427065A0UL))
#define bFM4_MFS3_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427065A4UL))
#define bFM4_MFS3_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427065A8UL))
#define bFM4_MFS3_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427065ACUL))
#define bFM4_MFS3_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427065B0UL))
#define bFM4_MFS3_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427065B4UL))
#define bFM4_MFS3_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427065B8UL))
#define bFM4_MFS3_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427065BCUL))
#define bFM4_MFS3_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42706600UL))
#define bFM4_MFS3_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42706604UL))
#define bFM4_MFS3_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42706608UL))
#define bFM4_MFS3_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270660CUL))
#define bFM4_MFS3_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42706610UL))
#define bFM4_MFS3_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42706614UL))
#define bFM4_MFS3_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42706618UL))
#define bFM4_MFS3_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270661CUL))
#define bFM4_MFS3_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42706620UL))
#define bFM4_MFS3_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42706624UL))
#define bFM4_MFS3_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42706628UL))
#define bFM4_MFS3_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270662CUL))
#define bFM4_MFS3_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42706630UL))
#define bFM4_MFS3_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42706634UL))
#define bFM4_MFS3_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42706638UL))
#define bFM4_MFS3_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270663CUL))
#define bFM4_MFS3_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42706680UL))
#define bFM4_MFS3_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42706684UL))
#define bFM4_MFS3_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42706688UL))
#define bFM4_MFS3_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270668CUL))
#define bFM4_MFS3_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42706690UL))
#define bFM4_MFS3_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42706694UL))
#define bFM4_MFS3_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42706698UL))
#define bFM4_MFS3_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270669CUL))
#define bFM4_MFS3_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427066A0UL))
#define bFM4_MFS3_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427066A4UL))
#define bFM4_MFS3_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427066A8UL))
#define bFM4_MFS3_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427066ACUL))
#define bFM4_MFS3_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427066B0UL))
#define bFM4_MFS3_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427066B4UL))
#define bFM4_MFS3_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427066B8UL))
#define bFM4_MFS3_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427066BCUL))
#define bFM4_MFS3_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42706700UL))
#define bFM4_MFS3_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42706704UL))
#define bFM4_MFS3_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42706708UL))
#define bFM4_MFS3_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270670CUL))
#define bFM4_MFS3_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42706710UL))
#define bFM4_MFS3_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42706714UL))
#define bFM4_MFS3_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42706718UL))
#define bFM4_MFS3_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270671CUL))

/* MFS LIN channel 3 registers */
#define bFM4_MFS3_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42706000UL))
#define bFM4_MFS3_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270600CUL))
#define bFM4_MFS3_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42706010UL))
#define bFM4_MFS3_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42706014UL))
#define bFM4_MFS3_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42706018UL))
#define bFM4_MFS3_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270601CUL))
#define bFM4_MFS3_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42706020UL))
#define bFM4_MFS3_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42706024UL))
#define bFM4_MFS3_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42706028UL))
#define bFM4_MFS3_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270602CUL))
#define bFM4_MFS3_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42706030UL))
#define bFM4_MFS3_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42706034UL))
#define bFM4_MFS3_LIN_SCR_MS                   *((volatile unsigned char*)(0x42706038UL))
#define bFM4_MFS3_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270603CUL))
#define bFM4_MFS3_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42706080UL))
#define bFM4_MFS3_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42706084UL))
#define bFM4_MFS3_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42706088UL))
#define bFM4_MFS3_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270608CUL))
#define bFM4_MFS3_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42706090UL))
#define bFM4_MFS3_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42706098UL))
#define bFM4_MFS3_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427060A0UL))
#define bFM4_MFS3_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427060A4UL))
#define bFM4_MFS3_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427060A8UL))
#define bFM4_MFS3_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427060ACUL))
#define bFM4_MFS3_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427060B0UL))
#define bFM4_MFS3_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427060B4UL))
#define bFM4_MFS3_LIN_SSR_REC                  *((volatile unsigned char*)(0x427060BCUL))
#define bFM4_MFS3_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427061BCUL))
#define bFM4_MFS3_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427061BCUL))
#define bFM4_MFS3_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42706280UL))
#define bFM4_MFS3_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42706284UL))
#define bFM4_MFS3_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42706288UL))
#define bFM4_MFS3_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270628CUL))
#define bFM4_MFS3_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42706290UL))
#define bFM4_MFS3_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42706294UL))
#define bFM4_MFS3_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42706298UL))
#define bFM4_MFS3_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427062A0UL))
#define bFM4_MFS3_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427062A4UL))
#define bFM4_MFS3_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427062A8UL))
#define bFM4_MFS3_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427062ACUL))
#define bFM4_MFS3_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427062B0UL))
#define bFM4_MFS3_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42706280UL))
#define bFM4_MFS3_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42706284UL))
#define bFM4_MFS3_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42706288UL))
#define bFM4_MFS3_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270628CUL))
#define bFM4_MFS3_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42706290UL))
#define bFM4_MFS3_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42706294UL))
#define bFM4_MFS3_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42706298UL))
#define bFM4_MFS3_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427062A0UL))
#define bFM4_MFS3_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427062A4UL))
#define bFM4_MFS3_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427062A8UL))
#define bFM4_MFS3_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427062ACUL))
#define bFM4_MFS3_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427062B0UL))
#define bFM4_MFS3_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42706300UL))
#define bFM4_MFS3_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42706304UL))
#define bFM4_MFS3_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42706308UL))
#define bFM4_MFS3_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270630CUL))
#define bFM4_MFS3_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42706310UL))
#define bFM4_MFS3_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42706314UL))
#define bFM4_MFS3_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42706318UL))
#define bFM4_MFS3_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270631CUL))
#define bFM4_MFS3_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42706320UL))
#define bFM4_MFS3_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42706324UL))
#define bFM4_MFS3_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42706328UL))
#define bFM4_MFS3_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270632CUL))
#define bFM4_MFS3_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42706330UL))
#define bFM4_MFS3_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42706334UL))
#define bFM4_MFS3_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42706338UL))
#define bFM4_MFS3_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270633CUL))
#define bFM4_MFS3_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42706300UL))
#define bFM4_MFS3_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42706304UL))
#define bFM4_MFS3_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42706308UL))
#define bFM4_MFS3_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270630CUL))
#define bFM4_MFS3_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42706310UL))
#define bFM4_MFS3_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42706314UL))
#define bFM4_MFS3_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42706318UL))
#define bFM4_MFS3_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270631CUL))
#define bFM4_MFS3_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42706320UL))
#define bFM4_MFS3_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42706324UL))
#define bFM4_MFS3_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42706328UL))
#define bFM4_MFS3_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270632CUL))
#define bFM4_MFS3_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42706330UL))
#define bFM4_MFS3_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42706334UL))
#define bFM4_MFS3_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42706338UL))
#define bFM4_MFS3_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270633CUL))

/* MFS I2C channel 3 registers */
#define bFM4_MFS3_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42706008UL))
#define bFM4_MFS3_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270600CUL))
#define bFM4_MFS3_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42706014UL))
#define bFM4_MFS3_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42706018UL))
#define bFM4_MFS3_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270601CUL))
#define bFM4_MFS3_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42706020UL))
#define bFM4_MFS3_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42706024UL))
#define bFM4_MFS3_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42706028UL))
#define bFM4_MFS3_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270602CUL))
#define bFM4_MFS3_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42706030UL))
#define bFM4_MFS3_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42706034UL))
#define bFM4_MFS3_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42706038UL))
#define bFM4_MFS3_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42706038UL))
#define bFM4_MFS3_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270603CUL))
#define bFM4_MFS3_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42706080UL))
#define bFM4_MFS3_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42706084UL))
#define bFM4_MFS3_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42706088UL))
#define bFM4_MFS3_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270608CUL))
#define bFM4_MFS3_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42706090UL))
#define bFM4_MFS3_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42706094UL))
#define bFM4_MFS3_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42706098UL))
#define bFM4_MFS3_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270609CUL))
#define bFM4_MFS3_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427060A0UL))
#define bFM4_MFS3_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427060A4UL))
#define bFM4_MFS3_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427060A8UL))
#define bFM4_MFS3_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427060ACUL))
#define bFM4_MFS3_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427060B0UL))
#define bFM4_MFS3_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427060B4UL))
#define bFM4_MFS3_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427060B8UL))
#define bFM4_MFS3_I2C_SSR_REC                  *((volatile unsigned char*)(0x427060BCUL))
#define bFM4_MFS3_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42706200UL))
#define bFM4_MFS3_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42706204UL))
#define bFM4_MFS3_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42706208UL))
#define bFM4_MFS3_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270620CUL))
#define bFM4_MFS3_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42706210UL))
#define bFM4_MFS3_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42706214UL))
#define bFM4_MFS3_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42706218UL))
#define bFM4_MFS3_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270621CUL))
#define bFM4_MFS3_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42706220UL))
#define bFM4_MFS3_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42706224UL))
#define bFM4_MFS3_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42706228UL))
#define bFM4_MFS3_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270622CUL))
#define bFM4_MFS3_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42706230UL))
#define bFM4_MFS3_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42706234UL))
#define bFM4_MFS3_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42706238UL))
#define bFM4_MFS3_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270623CUL))
#define bFM4_MFS3_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42706280UL))
#define bFM4_MFS3_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42706284UL))
#define bFM4_MFS3_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42706288UL))
#define bFM4_MFS3_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270628CUL))
#define bFM4_MFS3_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42706290UL))
#define bFM4_MFS3_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42706294UL))
#define bFM4_MFS3_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42706298UL))
#define bFM4_MFS3_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427062A0UL))
#define bFM4_MFS3_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427062A4UL))
#define bFM4_MFS3_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427062A8UL))
#define bFM4_MFS3_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427062ACUL))
#define bFM4_MFS3_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427062B0UL))
#define bFM4_MFS3_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42706280UL))
#define bFM4_MFS3_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42706284UL))
#define bFM4_MFS3_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42706288UL))
#define bFM4_MFS3_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270628CUL))
#define bFM4_MFS3_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42706290UL))
#define bFM4_MFS3_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42706294UL))
#define bFM4_MFS3_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42706298UL))
#define bFM4_MFS3_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427062A0UL))
#define bFM4_MFS3_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427062A4UL))
#define bFM4_MFS3_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427062A8UL))
#define bFM4_MFS3_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427062ACUL))
#define bFM4_MFS3_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427062B0UL))
#define bFM4_MFS3_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42706300UL))
#define bFM4_MFS3_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42706304UL))
#define bFM4_MFS3_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42706308UL))
#define bFM4_MFS3_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270630CUL))
#define bFM4_MFS3_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42706310UL))
#define bFM4_MFS3_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42706314UL))
#define bFM4_MFS3_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42706318UL))
#define bFM4_MFS3_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270631CUL))
#define bFM4_MFS3_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42706320UL))
#define bFM4_MFS3_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42706324UL))
#define bFM4_MFS3_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42706328UL))
#define bFM4_MFS3_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270632CUL))
#define bFM4_MFS3_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42706330UL))
#define bFM4_MFS3_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42706334UL))
#define bFM4_MFS3_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42706338UL))
#define bFM4_MFS3_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270633CUL))
#define bFM4_MFS3_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42706300UL))
#define bFM4_MFS3_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42706304UL))
#define bFM4_MFS3_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42706308UL))
#define bFM4_MFS3_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270630CUL))
#define bFM4_MFS3_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42706310UL))
#define bFM4_MFS3_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42706314UL))
#define bFM4_MFS3_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42706318UL))
#define bFM4_MFS3_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270631CUL))
#define bFM4_MFS3_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42706320UL))
#define bFM4_MFS3_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42706324UL))
#define bFM4_MFS3_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42706328UL))
#define bFM4_MFS3_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270632CUL))
#define bFM4_MFS3_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42706330UL))
#define bFM4_MFS3_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42706334UL))
#define bFM4_MFS3_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42706338UL))
#define bFM4_MFS3_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270633CUL))

/* MFS UART channel 4 registers */
#define bFM4_MFS4_UART_SMR_SOE                 *((volatile unsigned char*)(0x42708000UL))
#define bFM4_MFS4_UART_SMR_BDS                 *((volatile unsigned char*)(0x42708008UL))
#define bFM4_MFS4_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270800CUL))
#define bFM4_MFS4_UART_SMR_WUCR                *((volatile unsigned char*)(0x42708010UL))
#define bFM4_MFS4_UART_SMR_MD0                 *((volatile unsigned char*)(0x42708014UL))
#define bFM4_MFS4_UART_SMR_MD1                 *((volatile unsigned char*)(0x42708018UL))
#define bFM4_MFS4_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270801CUL))
#define bFM4_MFS4_UART_SCR_TXE                 *((volatile unsigned char*)(0x42708020UL))
#define bFM4_MFS4_UART_SCR_RXE                 *((volatile unsigned char*)(0x42708024UL))
#define bFM4_MFS4_UART_SCR_TBIE                *((volatile unsigned char*)(0x42708028UL))
#define bFM4_MFS4_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270802CUL))
#define bFM4_MFS4_UART_SCR_RIE                 *((volatile unsigned char*)(0x42708030UL))
#define bFM4_MFS4_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270803CUL))
#define bFM4_MFS4_UART_ESCR_L0                 *((volatile unsigned char*)(0x42708080UL))
#define bFM4_MFS4_UART_ESCR_L1                 *((volatile unsigned char*)(0x42708084UL))
#define bFM4_MFS4_UART_ESCR_L2                 *((volatile unsigned char*)(0x42708088UL))
#define bFM4_MFS4_UART_ESCR_P                  *((volatile unsigned char*)(0x4270808CUL))
#define bFM4_MFS4_UART_ESCR_PEN                *((volatile unsigned char*)(0x42708090UL))
#define bFM4_MFS4_UART_ESCR_INV                *((volatile unsigned char*)(0x42708094UL))
#define bFM4_MFS4_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42708098UL))
#define bFM4_MFS4_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270809CUL))
#define bFM4_MFS4_UART_SSR_TBI                 *((volatile unsigned char*)(0x427080A0UL))
#define bFM4_MFS4_UART_SSR_TDRE                *((volatile unsigned char*)(0x427080A4UL))
#define bFM4_MFS4_UART_SSR_RDRF                *((volatile unsigned char*)(0x427080A8UL))
#define bFM4_MFS4_UART_SSR_ORE                 *((volatile unsigned char*)(0x427080ACUL))
#define bFM4_MFS4_UART_SSR_FRE                 *((volatile unsigned char*)(0x427080B0UL))
#define bFM4_MFS4_UART_SSR_PE                  *((volatile unsigned char*)(0x427080B4UL))
#define bFM4_MFS4_UART_SSR_REC                 *((volatile unsigned char*)(0x427080BCUL))
#define bFM4_MFS4_UART_BGR_EXT                 *((volatile unsigned char*)(0x427081BCUL))
#define bFM4_MFS4_UART_BGR1_EXT                *((volatile unsigned char*)(0x427081BCUL))
#define bFM4_MFS4_UART_FCR_FE1                 *((volatile unsigned char*)(0x42708280UL))
#define bFM4_MFS4_UART_FCR_FE2                 *((volatile unsigned char*)(0x42708284UL))
#define bFM4_MFS4_UART_FCR_FCL1                *((volatile unsigned char*)(0x42708288UL))
#define bFM4_MFS4_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270828CUL))
#define bFM4_MFS4_UART_FCR_FSET                *((volatile unsigned char*)(0x42708290UL))
#define bFM4_MFS4_UART_FCR_FLD                 *((volatile unsigned char*)(0x42708294UL))
#define bFM4_MFS4_UART_FCR_FLST                *((volatile unsigned char*)(0x42708298UL))
#define bFM4_MFS4_UART_FCR_FSEL                *((volatile unsigned char*)(0x427082A0UL))
#define bFM4_MFS4_UART_FCR_FTIE                *((volatile unsigned char*)(0x427082A4UL))
#define bFM4_MFS4_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427082A8UL))
#define bFM4_MFS4_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427082ACUL))
#define bFM4_MFS4_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427082B0UL))
#define bFM4_MFS4_UART_FCR0_FE1                *((volatile unsigned char*)(0x42708280UL))
#define bFM4_MFS4_UART_FCR0_FE2                *((volatile unsigned char*)(0x42708284UL))
#define bFM4_MFS4_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42708288UL))
#define bFM4_MFS4_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270828CUL))
#define bFM4_MFS4_UART_FCR0_FSET               *((volatile unsigned char*)(0x42708290UL))
#define bFM4_MFS4_UART_FCR0_FLD                *((volatile unsigned char*)(0x42708294UL))
#define bFM4_MFS4_UART_FCR0_FLST               *((volatile unsigned char*)(0x42708298UL))
#define bFM4_MFS4_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427082A0UL))
#define bFM4_MFS4_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427082A4UL))
#define bFM4_MFS4_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427082A8UL))
#define bFM4_MFS4_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427082ACUL))
#define bFM4_MFS4_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427082B0UL))
#define bFM4_MFS4_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42708300UL))
#define bFM4_MFS4_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42708304UL))
#define bFM4_MFS4_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42708308UL))
#define bFM4_MFS4_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270830CUL))
#define bFM4_MFS4_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42708310UL))
#define bFM4_MFS4_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42708314UL))
#define bFM4_MFS4_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42708318UL))
#define bFM4_MFS4_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270831CUL))
#define bFM4_MFS4_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42708320UL))
#define bFM4_MFS4_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42708324UL))
#define bFM4_MFS4_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42708328UL))
#define bFM4_MFS4_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270832CUL))
#define bFM4_MFS4_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42708330UL))
#define bFM4_MFS4_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42708334UL))
#define bFM4_MFS4_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42708338UL))
#define bFM4_MFS4_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270833CUL))
#define bFM4_MFS4_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42708300UL))
#define bFM4_MFS4_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42708304UL))
#define bFM4_MFS4_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42708308UL))
#define bFM4_MFS4_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270830CUL))
#define bFM4_MFS4_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42708310UL))
#define bFM4_MFS4_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42708314UL))
#define bFM4_MFS4_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42708318UL))
#define bFM4_MFS4_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270831CUL))
#define bFM4_MFS4_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42708320UL))
#define bFM4_MFS4_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42708324UL))
#define bFM4_MFS4_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42708328UL))
#define bFM4_MFS4_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270832CUL))
#define bFM4_MFS4_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42708330UL))
#define bFM4_MFS4_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42708334UL))
#define bFM4_MFS4_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42708338UL))
#define bFM4_MFS4_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270833CUL))

/* MFS CSIO channel 4 registers */
#define bFM4_MFS4_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42708000UL))
#define bFM4_MFS4_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42708004UL))
#define bFM4_MFS4_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42708008UL))
#define bFM4_MFS4_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270800CUL))
#define bFM4_MFS4_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42708014UL))
#define bFM4_MFS4_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42708018UL))
#define bFM4_MFS4_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270801CUL))
#define bFM4_MFS4_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42708020UL))
#define bFM4_MFS4_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42708024UL))
#define bFM4_MFS4_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42708028UL))
#define bFM4_MFS4_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270802CUL))
#define bFM4_MFS4_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42708030UL))
#define bFM4_MFS4_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42708034UL))
#define bFM4_MFS4_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42708038UL))
#define bFM4_MFS4_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270803CUL))
#define bFM4_MFS4_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42708080UL))
#define bFM4_MFS4_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42708084UL))
#define bFM4_MFS4_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42708088UL))
#define bFM4_MFS4_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270808CUL))
#define bFM4_MFS4_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42708090UL))
#define bFM4_MFS4_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42708094UL))
#define bFM4_MFS4_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42708098UL))
#define bFM4_MFS4_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270809CUL))
#define bFM4_MFS4_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427080A0UL))
#define bFM4_MFS4_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427080A4UL))
#define bFM4_MFS4_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427080A8UL))
#define bFM4_MFS4_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427080ACUL))
#define bFM4_MFS4_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427080B0UL))
#define bFM4_MFS4_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427080BCUL))
#define bFM4_MFS4_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42708280UL))
#define bFM4_MFS4_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42708284UL))
#define bFM4_MFS4_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42708288UL))
#define bFM4_MFS4_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270828CUL))
#define bFM4_MFS4_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42708290UL))
#define bFM4_MFS4_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42708294UL))
#define bFM4_MFS4_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42708298UL))
#define bFM4_MFS4_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427082A0UL))
#define bFM4_MFS4_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427082A4UL))
#define bFM4_MFS4_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427082A8UL))
#define bFM4_MFS4_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427082ACUL))
#define bFM4_MFS4_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427082B0UL))
#define bFM4_MFS4_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42708280UL))
#define bFM4_MFS4_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42708284UL))
#define bFM4_MFS4_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42708288UL))
#define bFM4_MFS4_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270828CUL))
#define bFM4_MFS4_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42708290UL))
#define bFM4_MFS4_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42708294UL))
#define bFM4_MFS4_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42708298UL))
#define bFM4_MFS4_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427082A0UL))
#define bFM4_MFS4_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427082A4UL))
#define bFM4_MFS4_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427082A8UL))
#define bFM4_MFS4_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427082ACUL))
#define bFM4_MFS4_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427082B0UL))
#define bFM4_MFS4_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42708300UL))
#define bFM4_MFS4_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42708304UL))
#define bFM4_MFS4_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42708308UL))
#define bFM4_MFS4_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270830CUL))
#define bFM4_MFS4_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42708310UL))
#define bFM4_MFS4_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42708314UL))
#define bFM4_MFS4_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42708318UL))
#define bFM4_MFS4_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270831CUL))
#define bFM4_MFS4_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42708320UL))
#define bFM4_MFS4_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42708324UL))
#define bFM4_MFS4_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42708328UL))
#define bFM4_MFS4_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270832CUL))
#define bFM4_MFS4_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42708330UL))
#define bFM4_MFS4_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42708334UL))
#define bFM4_MFS4_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42708338UL))
#define bFM4_MFS4_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270833CUL))
#define bFM4_MFS4_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42708300UL))
#define bFM4_MFS4_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42708304UL))
#define bFM4_MFS4_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42708308UL))
#define bFM4_MFS4_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270830CUL))
#define bFM4_MFS4_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42708310UL))
#define bFM4_MFS4_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42708314UL))
#define bFM4_MFS4_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42708318UL))
#define bFM4_MFS4_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270831CUL))
#define bFM4_MFS4_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42708320UL))
#define bFM4_MFS4_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42708324UL))
#define bFM4_MFS4_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42708328UL))
#define bFM4_MFS4_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270832CUL))
#define bFM4_MFS4_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42708330UL))
#define bFM4_MFS4_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42708334UL))
#define bFM4_MFS4_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42708338UL))
#define bFM4_MFS4_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270833CUL))
#define bFM4_MFS4_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42708380UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42708384UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42708388UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270838CUL))
#define bFM4_MFS4_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42708390UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42708394UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42708398UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270839CUL))
#define bFM4_MFS4_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427083A0UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427083A4UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427083A8UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427083ACUL))
#define bFM4_MFS4_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427083B0UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427083B4UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427083B8UL))
#define bFM4_MFS4_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427083BCUL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42708400UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42708404UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42708408UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270840CUL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42708410UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42708414UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42708418UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270841CUL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42708420UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42708424UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42708428UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270842CUL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42708430UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42708434UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42708438UL))
#define bFM4_MFS4_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270843CUL))
#define bFM4_MFS4_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42708480UL))
#define bFM4_MFS4_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42708484UL))
#define bFM4_MFS4_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42708488UL))
#define bFM4_MFS4_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270848CUL))
#define bFM4_MFS4_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42708490UL))
#define bFM4_MFS4_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42708498UL))
#define bFM4_MFS4_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270849CUL))
#define bFM4_MFS4_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427084A0UL))
#define bFM4_MFS4_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427084ACUL))
#define bFM4_MFS4_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427084B0UL))
#define bFM4_MFS4_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427084B4UL))
#define bFM4_MFS4_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42708500UL))
#define bFM4_MFS4_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42708504UL))
#define bFM4_MFS4_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42708508UL))
#define bFM4_MFS4_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270850CUL))
#define bFM4_MFS4_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42708510UL))
#define bFM4_MFS4_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42708514UL))
#define bFM4_MFS4_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42708518UL))
#define bFM4_MFS4_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270851CUL))
#define bFM4_MFS4_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42708520UL))
#define bFM4_MFS4_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42708524UL))
#define bFM4_MFS4_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42708528UL))
#define bFM4_MFS4_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270852CUL))
#define bFM4_MFS4_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42708530UL))
#define bFM4_MFS4_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42708534UL))
#define bFM4_MFS4_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42708538UL))
#define bFM4_MFS4_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270853CUL))
#define bFM4_MFS4_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42708580UL))
#define bFM4_MFS4_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42708584UL))
#define bFM4_MFS4_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42708588UL))
#define bFM4_MFS4_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270858CUL))
#define bFM4_MFS4_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42708590UL))
#define bFM4_MFS4_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42708594UL))
#define bFM4_MFS4_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42708598UL))
#define bFM4_MFS4_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270859CUL))
#define bFM4_MFS4_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427085A0UL))
#define bFM4_MFS4_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427085A4UL))
#define bFM4_MFS4_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427085A8UL))
#define bFM4_MFS4_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427085ACUL))
#define bFM4_MFS4_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427085B0UL))
#define bFM4_MFS4_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427085B4UL))
#define bFM4_MFS4_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427085B8UL))
#define bFM4_MFS4_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427085BCUL))
#define bFM4_MFS4_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42708600UL))
#define bFM4_MFS4_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42708604UL))
#define bFM4_MFS4_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42708608UL))
#define bFM4_MFS4_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270860CUL))
#define bFM4_MFS4_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42708610UL))
#define bFM4_MFS4_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42708614UL))
#define bFM4_MFS4_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42708618UL))
#define bFM4_MFS4_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270861CUL))
#define bFM4_MFS4_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42708620UL))
#define bFM4_MFS4_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42708624UL))
#define bFM4_MFS4_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42708628UL))
#define bFM4_MFS4_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270862CUL))
#define bFM4_MFS4_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42708630UL))
#define bFM4_MFS4_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42708634UL))
#define bFM4_MFS4_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42708638UL))
#define bFM4_MFS4_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270863CUL))
#define bFM4_MFS4_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42708680UL))
#define bFM4_MFS4_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42708684UL))
#define bFM4_MFS4_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42708688UL))
#define bFM4_MFS4_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270868CUL))
#define bFM4_MFS4_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42708690UL))
#define bFM4_MFS4_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42708694UL))
#define bFM4_MFS4_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42708698UL))
#define bFM4_MFS4_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270869CUL))
#define bFM4_MFS4_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427086A0UL))
#define bFM4_MFS4_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427086A4UL))
#define bFM4_MFS4_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427086A8UL))
#define bFM4_MFS4_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427086ACUL))
#define bFM4_MFS4_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427086B0UL))
#define bFM4_MFS4_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427086B4UL))
#define bFM4_MFS4_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427086B8UL))
#define bFM4_MFS4_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427086BCUL))
#define bFM4_MFS4_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42708700UL))
#define bFM4_MFS4_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42708704UL))
#define bFM4_MFS4_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42708708UL))
#define bFM4_MFS4_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270870CUL))
#define bFM4_MFS4_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42708710UL))
#define bFM4_MFS4_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42708714UL))
#define bFM4_MFS4_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42708718UL))
#define bFM4_MFS4_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270871CUL))

/* MFS LIN channel 4 registers */
#define bFM4_MFS4_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42708000UL))
#define bFM4_MFS4_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270800CUL))
#define bFM4_MFS4_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42708010UL))
#define bFM4_MFS4_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42708014UL))
#define bFM4_MFS4_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42708018UL))
#define bFM4_MFS4_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270801CUL))
#define bFM4_MFS4_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42708020UL))
#define bFM4_MFS4_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42708024UL))
#define bFM4_MFS4_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42708028UL))
#define bFM4_MFS4_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270802CUL))
#define bFM4_MFS4_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42708030UL))
#define bFM4_MFS4_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42708034UL))
#define bFM4_MFS4_LIN_SCR_MS                   *((volatile unsigned char*)(0x42708038UL))
#define bFM4_MFS4_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270803CUL))
#define bFM4_MFS4_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42708080UL))
#define bFM4_MFS4_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42708084UL))
#define bFM4_MFS4_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42708088UL))
#define bFM4_MFS4_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270808CUL))
#define bFM4_MFS4_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42708090UL))
#define bFM4_MFS4_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42708098UL))
#define bFM4_MFS4_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427080A0UL))
#define bFM4_MFS4_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427080A4UL))
#define bFM4_MFS4_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427080A8UL))
#define bFM4_MFS4_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427080ACUL))
#define bFM4_MFS4_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427080B0UL))
#define bFM4_MFS4_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427080B4UL))
#define bFM4_MFS4_LIN_SSR_REC                  *((volatile unsigned char*)(0x427080BCUL))
#define bFM4_MFS4_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427081BCUL))
#define bFM4_MFS4_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427081BCUL))
#define bFM4_MFS4_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42708280UL))
#define bFM4_MFS4_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42708284UL))
#define bFM4_MFS4_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42708288UL))
#define bFM4_MFS4_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270828CUL))
#define bFM4_MFS4_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42708290UL))
#define bFM4_MFS4_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42708294UL))
#define bFM4_MFS4_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42708298UL))
#define bFM4_MFS4_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427082A0UL))
#define bFM4_MFS4_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427082A4UL))
#define bFM4_MFS4_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427082A8UL))
#define bFM4_MFS4_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427082ACUL))
#define bFM4_MFS4_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427082B0UL))
#define bFM4_MFS4_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42708280UL))
#define bFM4_MFS4_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42708284UL))
#define bFM4_MFS4_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42708288UL))
#define bFM4_MFS4_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270828CUL))
#define bFM4_MFS4_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42708290UL))
#define bFM4_MFS4_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42708294UL))
#define bFM4_MFS4_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42708298UL))
#define bFM4_MFS4_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427082A0UL))
#define bFM4_MFS4_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427082A4UL))
#define bFM4_MFS4_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427082A8UL))
#define bFM4_MFS4_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427082ACUL))
#define bFM4_MFS4_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427082B0UL))
#define bFM4_MFS4_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42708300UL))
#define bFM4_MFS4_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42708304UL))
#define bFM4_MFS4_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42708308UL))
#define bFM4_MFS4_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270830CUL))
#define bFM4_MFS4_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42708310UL))
#define bFM4_MFS4_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42708314UL))
#define bFM4_MFS4_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42708318UL))
#define bFM4_MFS4_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270831CUL))
#define bFM4_MFS4_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42708320UL))
#define bFM4_MFS4_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42708324UL))
#define bFM4_MFS4_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42708328UL))
#define bFM4_MFS4_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270832CUL))
#define bFM4_MFS4_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42708330UL))
#define bFM4_MFS4_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42708334UL))
#define bFM4_MFS4_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42708338UL))
#define bFM4_MFS4_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270833CUL))
#define bFM4_MFS4_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42708300UL))
#define bFM4_MFS4_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42708304UL))
#define bFM4_MFS4_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42708308UL))
#define bFM4_MFS4_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270830CUL))
#define bFM4_MFS4_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42708310UL))
#define bFM4_MFS4_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42708314UL))
#define bFM4_MFS4_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42708318UL))
#define bFM4_MFS4_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270831CUL))
#define bFM4_MFS4_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42708320UL))
#define bFM4_MFS4_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42708324UL))
#define bFM4_MFS4_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42708328UL))
#define bFM4_MFS4_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270832CUL))
#define bFM4_MFS4_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42708330UL))
#define bFM4_MFS4_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42708334UL))
#define bFM4_MFS4_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42708338UL))
#define bFM4_MFS4_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270833CUL))

/* MFS I2C channel 4 registers */
#define bFM4_MFS4_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42708008UL))
#define bFM4_MFS4_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270800CUL))
#define bFM4_MFS4_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42708014UL))
#define bFM4_MFS4_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42708018UL))
#define bFM4_MFS4_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270801CUL))
#define bFM4_MFS4_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42708020UL))
#define bFM4_MFS4_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42708024UL))
#define bFM4_MFS4_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42708028UL))
#define bFM4_MFS4_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270802CUL))
#define bFM4_MFS4_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42708030UL))
#define bFM4_MFS4_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42708034UL))
#define bFM4_MFS4_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42708038UL))
#define bFM4_MFS4_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42708038UL))
#define bFM4_MFS4_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270803CUL))
#define bFM4_MFS4_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42708080UL))
#define bFM4_MFS4_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42708084UL))
#define bFM4_MFS4_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42708088UL))
#define bFM4_MFS4_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270808CUL))
#define bFM4_MFS4_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42708090UL))
#define bFM4_MFS4_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42708094UL))
#define bFM4_MFS4_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42708098UL))
#define bFM4_MFS4_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270809CUL))
#define bFM4_MFS4_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427080A0UL))
#define bFM4_MFS4_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427080A4UL))
#define bFM4_MFS4_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427080A8UL))
#define bFM4_MFS4_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427080ACUL))
#define bFM4_MFS4_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427080B0UL))
#define bFM4_MFS4_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427080B4UL))
#define bFM4_MFS4_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427080B8UL))
#define bFM4_MFS4_I2C_SSR_REC                  *((volatile unsigned char*)(0x427080BCUL))
#define bFM4_MFS4_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42708200UL))
#define bFM4_MFS4_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42708204UL))
#define bFM4_MFS4_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42708208UL))
#define bFM4_MFS4_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270820CUL))
#define bFM4_MFS4_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42708210UL))
#define bFM4_MFS4_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42708214UL))
#define bFM4_MFS4_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42708218UL))
#define bFM4_MFS4_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270821CUL))
#define bFM4_MFS4_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42708220UL))
#define bFM4_MFS4_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42708224UL))
#define bFM4_MFS4_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42708228UL))
#define bFM4_MFS4_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270822CUL))
#define bFM4_MFS4_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42708230UL))
#define bFM4_MFS4_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42708234UL))
#define bFM4_MFS4_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42708238UL))
#define bFM4_MFS4_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270823CUL))
#define bFM4_MFS4_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42708280UL))
#define bFM4_MFS4_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42708284UL))
#define bFM4_MFS4_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42708288UL))
#define bFM4_MFS4_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270828CUL))
#define bFM4_MFS4_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42708290UL))
#define bFM4_MFS4_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42708294UL))
#define bFM4_MFS4_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42708298UL))
#define bFM4_MFS4_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427082A0UL))
#define bFM4_MFS4_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427082A4UL))
#define bFM4_MFS4_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427082A8UL))
#define bFM4_MFS4_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427082ACUL))
#define bFM4_MFS4_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427082B0UL))
#define bFM4_MFS4_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42708280UL))
#define bFM4_MFS4_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42708284UL))
#define bFM4_MFS4_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42708288UL))
#define bFM4_MFS4_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270828CUL))
#define bFM4_MFS4_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42708290UL))
#define bFM4_MFS4_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42708294UL))
#define bFM4_MFS4_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42708298UL))
#define bFM4_MFS4_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427082A0UL))
#define bFM4_MFS4_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427082A4UL))
#define bFM4_MFS4_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427082A8UL))
#define bFM4_MFS4_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427082ACUL))
#define bFM4_MFS4_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427082B0UL))
#define bFM4_MFS4_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42708300UL))
#define bFM4_MFS4_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42708304UL))
#define bFM4_MFS4_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42708308UL))
#define bFM4_MFS4_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270830CUL))
#define bFM4_MFS4_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42708310UL))
#define bFM4_MFS4_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42708314UL))
#define bFM4_MFS4_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42708318UL))
#define bFM4_MFS4_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270831CUL))
#define bFM4_MFS4_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42708320UL))
#define bFM4_MFS4_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42708324UL))
#define bFM4_MFS4_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42708328UL))
#define bFM4_MFS4_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270832CUL))
#define bFM4_MFS4_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42708330UL))
#define bFM4_MFS4_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42708334UL))
#define bFM4_MFS4_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42708338UL))
#define bFM4_MFS4_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270833CUL))
#define bFM4_MFS4_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42708300UL))
#define bFM4_MFS4_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42708304UL))
#define bFM4_MFS4_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42708308UL))
#define bFM4_MFS4_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270830CUL))
#define bFM4_MFS4_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42708310UL))
#define bFM4_MFS4_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42708314UL))
#define bFM4_MFS4_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42708318UL))
#define bFM4_MFS4_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270831CUL))
#define bFM4_MFS4_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42708320UL))
#define bFM4_MFS4_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42708324UL))
#define bFM4_MFS4_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42708328UL))
#define bFM4_MFS4_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270832CUL))
#define bFM4_MFS4_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42708330UL))
#define bFM4_MFS4_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42708334UL))
#define bFM4_MFS4_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42708338UL))
#define bFM4_MFS4_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270833CUL))

/* MFS UART channel 5 registers */
#define bFM4_MFS5_UART_SMR_SOE                 *((volatile unsigned char*)(0x4270A000UL))
#define bFM4_MFS5_UART_SMR_BDS                 *((volatile unsigned char*)(0x4270A008UL))
#define bFM4_MFS5_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270A00CUL))
#define bFM4_MFS5_UART_SMR_WUCR                *((volatile unsigned char*)(0x4270A010UL))
#define bFM4_MFS5_UART_SMR_MD0                 *((volatile unsigned char*)(0x4270A014UL))
#define bFM4_MFS5_UART_SMR_MD1                 *((volatile unsigned char*)(0x4270A018UL))
#define bFM4_MFS5_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270A01CUL))
#define bFM4_MFS5_UART_SCR_TXE                 *((volatile unsigned char*)(0x4270A020UL))
#define bFM4_MFS5_UART_SCR_RXE                 *((volatile unsigned char*)(0x4270A024UL))
#define bFM4_MFS5_UART_SCR_TBIE                *((volatile unsigned char*)(0x4270A028UL))
#define bFM4_MFS5_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270A02CUL))
#define bFM4_MFS5_UART_SCR_RIE                 *((volatile unsigned char*)(0x4270A030UL))
#define bFM4_MFS5_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270A03CUL))
#define bFM4_MFS5_UART_ESCR_L0                 *((volatile unsigned char*)(0x4270A080UL))
#define bFM4_MFS5_UART_ESCR_L1                 *((volatile unsigned char*)(0x4270A084UL))
#define bFM4_MFS5_UART_ESCR_L2                 *((volatile unsigned char*)(0x4270A088UL))
#define bFM4_MFS5_UART_ESCR_P                  *((volatile unsigned char*)(0x4270A08CUL))
#define bFM4_MFS5_UART_ESCR_PEN                *((volatile unsigned char*)(0x4270A090UL))
#define bFM4_MFS5_UART_ESCR_INV                *((volatile unsigned char*)(0x4270A094UL))
#define bFM4_MFS5_UART_ESCR_ESBL               *((volatile unsigned char*)(0x4270A098UL))
#define bFM4_MFS5_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270A09CUL))
#define bFM4_MFS5_UART_SSR_TBI                 *((volatile unsigned char*)(0x4270A0A0UL))
#define bFM4_MFS5_UART_SSR_TDRE                *((volatile unsigned char*)(0x4270A0A4UL))
#define bFM4_MFS5_UART_SSR_RDRF                *((volatile unsigned char*)(0x4270A0A8UL))
#define bFM4_MFS5_UART_SSR_ORE                 *((volatile unsigned char*)(0x4270A0ACUL))
#define bFM4_MFS5_UART_SSR_FRE                 *((volatile unsigned char*)(0x4270A0B0UL))
#define bFM4_MFS5_UART_SSR_PE                  *((volatile unsigned char*)(0x4270A0B4UL))
#define bFM4_MFS5_UART_SSR_REC                 *((volatile unsigned char*)(0x4270A0BCUL))
#define bFM4_MFS5_UART_BGR_EXT                 *((volatile unsigned char*)(0x4270A1BCUL))
#define bFM4_MFS5_UART_BGR1_EXT                *((volatile unsigned char*)(0x4270A1BCUL))
#define bFM4_MFS5_UART_FCR_FE1                 *((volatile unsigned char*)(0x4270A280UL))
#define bFM4_MFS5_UART_FCR_FE2                 *((volatile unsigned char*)(0x4270A284UL))
#define bFM4_MFS5_UART_FCR_FCL1                *((volatile unsigned char*)(0x4270A288UL))
#define bFM4_MFS5_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270A28CUL))
#define bFM4_MFS5_UART_FCR_FSET                *((volatile unsigned char*)(0x4270A290UL))
#define bFM4_MFS5_UART_FCR_FLD                 *((volatile unsigned char*)(0x4270A294UL))
#define bFM4_MFS5_UART_FCR_FLST                *((volatile unsigned char*)(0x4270A298UL))
#define bFM4_MFS5_UART_FCR_FSEL                *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM4_MFS5_UART_FCR_FTIE                *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM4_MFS5_UART_FCR_FDRQ                *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM4_MFS5_UART_FCR_FRIIE               *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM4_MFS5_UART_FCR_FLSTE               *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM4_MFS5_UART_FCR0_FE1                *((volatile unsigned char*)(0x4270A280UL))
#define bFM4_MFS5_UART_FCR0_FE2                *((volatile unsigned char*)(0x4270A284UL))
#define bFM4_MFS5_UART_FCR0_FCL1               *((volatile unsigned char*)(0x4270A288UL))
#define bFM4_MFS5_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270A28CUL))
#define bFM4_MFS5_UART_FCR0_FSET               *((volatile unsigned char*)(0x4270A290UL))
#define bFM4_MFS5_UART_FCR0_FLD                *((volatile unsigned char*)(0x4270A294UL))
#define bFM4_MFS5_UART_FCR0_FLST               *((volatile unsigned char*)(0x4270A298UL))
#define bFM4_MFS5_UART_FCR1_FSEL               *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM4_MFS5_UART_FCR1_FTIE               *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM4_MFS5_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM4_MFS5_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM4_MFS5_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM4_MFS5_UART_FBYTE_FD0               *((volatile unsigned char*)(0x4270A300UL))
#define bFM4_MFS5_UART_FBYTE_FD1               *((volatile unsigned char*)(0x4270A304UL))
#define bFM4_MFS5_UART_FBYTE_FD2               *((volatile unsigned char*)(0x4270A308UL))
#define bFM4_MFS5_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270A30CUL))
#define bFM4_MFS5_UART_FBYTE_FD4               *((volatile unsigned char*)(0x4270A310UL))
#define bFM4_MFS5_UART_FBYTE_FD5               *((volatile unsigned char*)(0x4270A314UL))
#define bFM4_MFS5_UART_FBYTE_FD6               *((volatile unsigned char*)(0x4270A318UL))
#define bFM4_MFS5_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270A31CUL))
#define bFM4_MFS5_UART_FBYTE_FD8               *((volatile unsigned char*)(0x4270A320UL))
#define bFM4_MFS5_UART_FBYTE_FD9               *((volatile unsigned char*)(0x4270A324UL))
#define bFM4_MFS5_UART_FBYTE_FD10              *((volatile unsigned char*)(0x4270A328UL))
#define bFM4_MFS5_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270A32CUL))
#define bFM4_MFS5_UART_FBYTE_FD12              *((volatile unsigned char*)(0x4270A330UL))
#define bFM4_MFS5_UART_FBYTE_FD13              *((volatile unsigned char*)(0x4270A334UL))
#define bFM4_MFS5_UART_FBYTE_FD14              *((volatile unsigned char*)(0x4270A338UL))
#define bFM4_MFS5_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270A33CUL))
#define bFM4_MFS5_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x4270A300UL))
#define bFM4_MFS5_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x4270A304UL))
#define bFM4_MFS5_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x4270A308UL))
#define bFM4_MFS5_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270A30CUL))
#define bFM4_MFS5_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x4270A310UL))
#define bFM4_MFS5_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x4270A314UL))
#define bFM4_MFS5_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x4270A318UL))
#define bFM4_MFS5_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270A31CUL))
#define bFM4_MFS5_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x4270A320UL))
#define bFM4_MFS5_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x4270A324UL))
#define bFM4_MFS5_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x4270A328UL))
#define bFM4_MFS5_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270A32CUL))
#define bFM4_MFS5_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x4270A330UL))
#define bFM4_MFS5_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x4270A334UL))
#define bFM4_MFS5_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x4270A338UL))
#define bFM4_MFS5_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270A33CUL))

/* MFS CSIO channel 5 registers */
#define bFM4_MFS5_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x4270A000UL))
#define bFM4_MFS5_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x4270A004UL))
#define bFM4_MFS5_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x4270A008UL))
#define bFM4_MFS5_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270A00CUL))
#define bFM4_MFS5_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x4270A014UL))
#define bFM4_MFS5_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x4270A018UL))
#define bFM4_MFS5_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270A01CUL))
#define bFM4_MFS5_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x4270A020UL))
#define bFM4_MFS5_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x4270A024UL))
#define bFM4_MFS5_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x4270A028UL))
#define bFM4_MFS5_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270A02CUL))
#define bFM4_MFS5_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x4270A030UL))
#define bFM4_MFS5_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x4270A034UL))
#define bFM4_MFS5_CSIO_SCR_MS                  *((volatile unsigned char*)(0x4270A038UL))
#define bFM4_MFS5_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270A03CUL))
#define bFM4_MFS5_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x4270A080UL))
#define bFM4_MFS5_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x4270A084UL))
#define bFM4_MFS5_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x4270A088UL))
#define bFM4_MFS5_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270A08CUL))
#define bFM4_MFS5_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x4270A090UL))
#define bFM4_MFS5_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x4270A094UL))
#define bFM4_MFS5_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x4270A098UL))
#define bFM4_MFS5_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270A09CUL))
#define bFM4_MFS5_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x4270A0A0UL))
#define bFM4_MFS5_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x4270A0A4UL))
#define bFM4_MFS5_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x4270A0A8UL))
#define bFM4_MFS5_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x4270A0ACUL))
#define bFM4_MFS5_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x4270A0B0UL))
#define bFM4_MFS5_CSIO_SSR_REC                 *((volatile unsigned char*)(0x4270A0BCUL))
#define bFM4_MFS5_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x4270A280UL))
#define bFM4_MFS5_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x4270A284UL))
#define bFM4_MFS5_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x4270A288UL))
#define bFM4_MFS5_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270A28CUL))
#define bFM4_MFS5_CSIO_FCR_FSET                *((volatile unsigned char*)(0x4270A290UL))
#define bFM4_MFS5_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x4270A294UL))
#define bFM4_MFS5_CSIO_FCR_FLST                *((volatile unsigned char*)(0x4270A298UL))
#define bFM4_MFS5_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM4_MFS5_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM4_MFS5_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM4_MFS5_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM4_MFS5_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM4_MFS5_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x4270A280UL))
#define bFM4_MFS5_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x4270A284UL))
#define bFM4_MFS5_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x4270A288UL))
#define bFM4_MFS5_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270A28CUL))
#define bFM4_MFS5_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x4270A290UL))
#define bFM4_MFS5_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x4270A294UL))
#define bFM4_MFS5_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x4270A298UL))
#define bFM4_MFS5_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM4_MFS5_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM4_MFS5_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM4_MFS5_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM4_MFS5_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM4_MFS5_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x4270A300UL))
#define bFM4_MFS5_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x4270A304UL))
#define bFM4_MFS5_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x4270A308UL))
#define bFM4_MFS5_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270A30CUL))
#define bFM4_MFS5_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x4270A310UL))
#define bFM4_MFS5_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x4270A314UL))
#define bFM4_MFS5_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x4270A318UL))
#define bFM4_MFS5_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270A31CUL))
#define bFM4_MFS5_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x4270A320UL))
#define bFM4_MFS5_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x4270A324UL))
#define bFM4_MFS5_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x4270A328UL))
#define bFM4_MFS5_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270A32CUL))
#define bFM4_MFS5_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x4270A330UL))
#define bFM4_MFS5_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x4270A334UL))
#define bFM4_MFS5_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x4270A338UL))
#define bFM4_MFS5_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270A33CUL))
#define bFM4_MFS5_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x4270A300UL))
#define bFM4_MFS5_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x4270A304UL))
#define bFM4_MFS5_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x4270A308UL))
#define bFM4_MFS5_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270A30CUL))
#define bFM4_MFS5_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x4270A310UL))
#define bFM4_MFS5_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x4270A314UL))
#define bFM4_MFS5_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x4270A318UL))
#define bFM4_MFS5_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270A31CUL))
#define bFM4_MFS5_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x4270A320UL))
#define bFM4_MFS5_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x4270A324UL))
#define bFM4_MFS5_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x4270A328UL))
#define bFM4_MFS5_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270A32CUL))
#define bFM4_MFS5_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x4270A330UL))
#define bFM4_MFS5_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x4270A334UL))
#define bFM4_MFS5_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x4270A338UL))
#define bFM4_MFS5_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270A33CUL))
#define bFM4_MFS5_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x4270A380UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x4270A384UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x4270A388UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270A38CUL))
#define bFM4_MFS5_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x4270A390UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x4270A394UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x4270A398UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270A39CUL))
#define bFM4_MFS5_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x4270A3A0UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x4270A3A4UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x4270A3A8UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x4270A3ACUL))
#define bFM4_MFS5_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x4270A3B0UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x4270A3B4UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x4270A3B8UL))
#define bFM4_MFS5_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x4270A3BCUL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x4270A400UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x4270A404UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x4270A408UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270A40CUL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x4270A410UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x4270A414UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x4270A418UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270A41CUL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x4270A420UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x4270A424UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x4270A428UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270A42CUL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x4270A430UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x4270A434UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x4270A438UL))
#define bFM4_MFS5_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270A43CUL))
#define bFM4_MFS5_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x4270A480UL))
#define bFM4_MFS5_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x4270A484UL))
#define bFM4_MFS5_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x4270A488UL))
#define bFM4_MFS5_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270A48CUL))
#define bFM4_MFS5_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x4270A490UL))
#define bFM4_MFS5_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x4270A498UL))
#define bFM4_MFS5_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270A49CUL))
#define bFM4_MFS5_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x4270A4A0UL))
#define bFM4_MFS5_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x4270A4ACUL))
#define bFM4_MFS5_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x4270A4B0UL))
#define bFM4_MFS5_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x4270A4B4UL))
#define bFM4_MFS5_CSIO_STMR_TM0                *((volatile unsigned char*)(0x4270A500UL))
#define bFM4_MFS5_CSIO_STMR_TM1                *((volatile unsigned char*)(0x4270A504UL))
#define bFM4_MFS5_CSIO_STMR_TM2                *((volatile unsigned char*)(0x4270A508UL))
#define bFM4_MFS5_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270A50CUL))
#define bFM4_MFS5_CSIO_STMR_TM4                *((volatile unsigned char*)(0x4270A510UL))
#define bFM4_MFS5_CSIO_STMR_TM5                *((volatile unsigned char*)(0x4270A514UL))
#define bFM4_MFS5_CSIO_STMR_TM6                *((volatile unsigned char*)(0x4270A518UL))
#define bFM4_MFS5_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270A51CUL))
#define bFM4_MFS5_CSIO_STMR_TM8                *((volatile unsigned char*)(0x4270A520UL))
#define bFM4_MFS5_CSIO_STMR_TM9                *((volatile unsigned char*)(0x4270A524UL))
#define bFM4_MFS5_CSIO_STMR_TM10               *((volatile unsigned char*)(0x4270A528UL))
#define bFM4_MFS5_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270A52CUL))
#define bFM4_MFS5_CSIO_STMR_TM12               *((volatile unsigned char*)(0x4270A530UL))
#define bFM4_MFS5_CSIO_STMR_TM13               *((volatile unsigned char*)(0x4270A534UL))
#define bFM4_MFS5_CSIO_STMR_TM14               *((volatile unsigned char*)(0x4270A538UL))
#define bFM4_MFS5_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270A53CUL))
#define bFM4_MFS5_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x4270A580UL))
#define bFM4_MFS5_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x4270A584UL))
#define bFM4_MFS5_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x4270A588UL))
#define bFM4_MFS5_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270A58CUL))
#define bFM4_MFS5_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x4270A590UL))
#define bFM4_MFS5_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x4270A594UL))
#define bFM4_MFS5_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x4270A598UL))
#define bFM4_MFS5_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270A59CUL))
#define bFM4_MFS5_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x4270A5A0UL))
#define bFM4_MFS5_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x4270A5A4UL))
#define bFM4_MFS5_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x4270A5A8UL))
#define bFM4_MFS5_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x4270A5ACUL))
#define bFM4_MFS5_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x4270A5B0UL))
#define bFM4_MFS5_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x4270A5B4UL))
#define bFM4_MFS5_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x4270A5B8UL))
#define bFM4_MFS5_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x4270A5BCUL))
#define bFM4_MFS5_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x4270A600UL))
#define bFM4_MFS5_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x4270A604UL))
#define bFM4_MFS5_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x4270A608UL))
#define bFM4_MFS5_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270A60CUL))
#define bFM4_MFS5_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x4270A610UL))
#define bFM4_MFS5_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x4270A614UL))
#define bFM4_MFS5_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x4270A618UL))
#define bFM4_MFS5_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270A61CUL))
#define bFM4_MFS5_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x4270A620UL))
#define bFM4_MFS5_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x4270A624UL))
#define bFM4_MFS5_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x4270A628UL))
#define bFM4_MFS5_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270A62CUL))
#define bFM4_MFS5_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x4270A630UL))
#define bFM4_MFS5_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x4270A634UL))
#define bFM4_MFS5_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x4270A638UL))
#define bFM4_MFS5_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270A63CUL))
#define bFM4_MFS5_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x4270A680UL))
#define bFM4_MFS5_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x4270A684UL))
#define bFM4_MFS5_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x4270A688UL))
#define bFM4_MFS5_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270A68CUL))
#define bFM4_MFS5_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x4270A690UL))
#define bFM4_MFS5_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x4270A694UL))
#define bFM4_MFS5_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x4270A698UL))
#define bFM4_MFS5_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270A69CUL))
#define bFM4_MFS5_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x4270A6A0UL))
#define bFM4_MFS5_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x4270A6A4UL))
#define bFM4_MFS5_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x4270A6A8UL))
#define bFM4_MFS5_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x4270A6ACUL))
#define bFM4_MFS5_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x4270A6B0UL))
#define bFM4_MFS5_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x4270A6B4UL))
#define bFM4_MFS5_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x4270A6B8UL))
#define bFM4_MFS5_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x4270A6BCUL))
#define bFM4_MFS5_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x4270A700UL))
#define bFM4_MFS5_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x4270A704UL))
#define bFM4_MFS5_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x4270A708UL))
#define bFM4_MFS5_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270A70CUL))
#define bFM4_MFS5_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x4270A710UL))
#define bFM4_MFS5_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x4270A714UL))
#define bFM4_MFS5_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x4270A718UL))
#define bFM4_MFS5_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270A71CUL))

/* MFS LIN channel 5 registers */
#define bFM4_MFS5_LIN_SMR_SOE                  *((volatile unsigned char*)(0x4270A000UL))
#define bFM4_MFS5_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270A00CUL))
#define bFM4_MFS5_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x4270A010UL))
#define bFM4_MFS5_LIN_SMR_MD0                  *((volatile unsigned char*)(0x4270A014UL))
#define bFM4_MFS5_LIN_SMR_MD1                  *((volatile unsigned char*)(0x4270A018UL))
#define bFM4_MFS5_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270A01CUL))
#define bFM4_MFS5_LIN_SCR_TXE                  *((volatile unsigned char*)(0x4270A020UL))
#define bFM4_MFS5_LIN_SCR_RXE                  *((volatile unsigned char*)(0x4270A024UL))
#define bFM4_MFS5_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x4270A028UL))
#define bFM4_MFS5_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270A02CUL))
#define bFM4_MFS5_LIN_SCR_RIE                  *((volatile unsigned char*)(0x4270A030UL))
#define bFM4_MFS5_LIN_SCR_LBR                  *((volatile unsigned char*)(0x4270A034UL))
#define bFM4_MFS5_LIN_SCR_MS                   *((volatile unsigned char*)(0x4270A038UL))
#define bFM4_MFS5_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270A03CUL))
#define bFM4_MFS5_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x4270A080UL))
#define bFM4_MFS5_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x4270A084UL))
#define bFM4_MFS5_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x4270A088UL))
#define bFM4_MFS5_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270A08CUL))
#define bFM4_MFS5_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x4270A090UL))
#define bFM4_MFS5_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x4270A098UL))
#define bFM4_MFS5_LIN_SSR_TBI                  *((volatile unsigned char*)(0x4270A0A0UL))
#define bFM4_MFS5_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x4270A0A4UL))
#define bFM4_MFS5_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x4270A0A8UL))
#define bFM4_MFS5_LIN_SSR_ORE                  *((volatile unsigned char*)(0x4270A0ACUL))
#define bFM4_MFS5_LIN_SSR_FRE                  *((volatile unsigned char*)(0x4270A0B0UL))
#define bFM4_MFS5_LIN_SSR_LBD                  *((volatile unsigned char*)(0x4270A0B4UL))
#define bFM4_MFS5_LIN_SSR_REC                  *((volatile unsigned char*)(0x4270A0BCUL))
#define bFM4_MFS5_LIN_BGR_EXT                  *((volatile unsigned char*)(0x4270A1BCUL))
#define bFM4_MFS5_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x4270A1BCUL))
#define bFM4_MFS5_LIN_FCR_FE1                  *((volatile unsigned char*)(0x4270A280UL))
#define bFM4_MFS5_LIN_FCR_FE2                  *((volatile unsigned char*)(0x4270A284UL))
#define bFM4_MFS5_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x4270A288UL))
#define bFM4_MFS5_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270A28CUL))
#define bFM4_MFS5_LIN_FCR_FSET                 *((volatile unsigned char*)(0x4270A290UL))
#define bFM4_MFS5_LIN_FCR_FLD                  *((volatile unsigned char*)(0x4270A294UL))
#define bFM4_MFS5_LIN_FCR_FLST                 *((volatile unsigned char*)(0x4270A298UL))
#define bFM4_MFS5_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM4_MFS5_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM4_MFS5_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM4_MFS5_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM4_MFS5_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM4_MFS5_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x4270A280UL))
#define bFM4_MFS5_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x4270A284UL))
#define bFM4_MFS5_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x4270A288UL))
#define bFM4_MFS5_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270A28CUL))
#define bFM4_MFS5_LIN_FCR0_FSET                *((volatile unsigned char*)(0x4270A290UL))
#define bFM4_MFS5_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x4270A294UL))
#define bFM4_MFS5_LIN_FCR0_FLST                *((volatile unsigned char*)(0x4270A298UL))
#define bFM4_MFS5_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM4_MFS5_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM4_MFS5_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM4_MFS5_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM4_MFS5_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM4_MFS5_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x4270A300UL))
#define bFM4_MFS5_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x4270A304UL))
#define bFM4_MFS5_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x4270A308UL))
#define bFM4_MFS5_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270A30CUL))
#define bFM4_MFS5_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x4270A310UL))
#define bFM4_MFS5_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x4270A314UL))
#define bFM4_MFS5_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x4270A318UL))
#define bFM4_MFS5_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270A31CUL))
#define bFM4_MFS5_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x4270A320UL))
#define bFM4_MFS5_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x4270A324UL))
#define bFM4_MFS5_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x4270A328UL))
#define bFM4_MFS5_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270A32CUL))
#define bFM4_MFS5_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x4270A330UL))
#define bFM4_MFS5_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x4270A334UL))
#define bFM4_MFS5_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x4270A338UL))
#define bFM4_MFS5_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270A33CUL))
#define bFM4_MFS5_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x4270A300UL))
#define bFM4_MFS5_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x4270A304UL))
#define bFM4_MFS5_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x4270A308UL))
#define bFM4_MFS5_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270A30CUL))
#define bFM4_MFS5_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x4270A310UL))
#define bFM4_MFS5_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x4270A314UL))
#define bFM4_MFS5_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x4270A318UL))
#define bFM4_MFS5_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270A31CUL))
#define bFM4_MFS5_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x4270A320UL))
#define bFM4_MFS5_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x4270A324UL))
#define bFM4_MFS5_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x4270A328UL))
#define bFM4_MFS5_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270A32CUL))
#define bFM4_MFS5_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x4270A330UL))
#define bFM4_MFS5_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x4270A334UL))
#define bFM4_MFS5_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x4270A338UL))
#define bFM4_MFS5_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270A33CUL))

/* MFS I2C channel 5 registers */
#define bFM4_MFS5_I2C_SMR_TIE                  *((volatile unsigned char*)(0x4270A008UL))
#define bFM4_MFS5_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270A00CUL))
#define bFM4_MFS5_I2C_SMR_MD0                  *((volatile unsigned char*)(0x4270A014UL))
#define bFM4_MFS5_I2C_SMR_MD1                  *((volatile unsigned char*)(0x4270A018UL))
#define bFM4_MFS5_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270A01CUL))
#define bFM4_MFS5_I2C_IBCR_INT                 *((volatile unsigned char*)(0x4270A020UL))
#define bFM4_MFS5_I2C_IBCR_BER                 *((volatile unsigned char*)(0x4270A024UL))
#define bFM4_MFS5_I2C_IBCR_INTE                *((volatile unsigned char*)(0x4270A028UL))
#define bFM4_MFS5_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270A02CUL))
#define bFM4_MFS5_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x4270A030UL))
#define bFM4_MFS5_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x4270A034UL))
#define bFM4_MFS5_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x4270A038UL))
#define bFM4_MFS5_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x4270A038UL))
#define bFM4_MFS5_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270A03CUL))
#define bFM4_MFS5_I2C_IBSR_BB                  *((volatile unsigned char*)(0x4270A080UL))
#define bFM4_MFS5_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x4270A084UL))
#define bFM4_MFS5_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x4270A088UL))
#define bFM4_MFS5_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270A08CUL))
#define bFM4_MFS5_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x4270A090UL))
#define bFM4_MFS5_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x4270A094UL))
#define bFM4_MFS5_I2C_IBSR_RACK                *((volatile unsigned char*)(0x4270A098UL))
#define bFM4_MFS5_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270A09CUL))
#define bFM4_MFS5_I2C_SSR_TBI                  *((volatile unsigned char*)(0x4270A0A0UL))
#define bFM4_MFS5_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x4270A0A4UL))
#define bFM4_MFS5_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x4270A0A8UL))
#define bFM4_MFS5_I2C_SSR_ORE                  *((volatile unsigned char*)(0x4270A0ACUL))
#define bFM4_MFS5_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x4270A0B0UL))
#define bFM4_MFS5_I2C_SSR_DMA                  *((volatile unsigned char*)(0x4270A0B4UL))
#define bFM4_MFS5_I2C_SSR_TSET                 *((volatile unsigned char*)(0x4270A0B8UL))
#define bFM4_MFS5_I2C_SSR_REC                  *((volatile unsigned char*)(0x4270A0BCUL))
#define bFM4_MFS5_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x4270A200UL))
#define bFM4_MFS5_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x4270A204UL))
#define bFM4_MFS5_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x4270A208UL))
#define bFM4_MFS5_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270A20CUL))
#define bFM4_MFS5_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x4270A210UL))
#define bFM4_MFS5_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x4270A214UL))
#define bFM4_MFS5_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x4270A218UL))
#define bFM4_MFS5_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270A21CUL))
#define bFM4_MFS5_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x4270A220UL))
#define bFM4_MFS5_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x4270A224UL))
#define bFM4_MFS5_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x4270A228UL))
#define bFM4_MFS5_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270A22CUL))
#define bFM4_MFS5_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x4270A230UL))
#define bFM4_MFS5_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x4270A234UL))
#define bFM4_MFS5_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x4270A238UL))
#define bFM4_MFS5_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270A23CUL))
#define bFM4_MFS5_I2C_FCR_FE1                  *((volatile unsigned char*)(0x4270A280UL))
#define bFM4_MFS5_I2C_FCR_FE2                  *((volatile unsigned char*)(0x4270A284UL))
#define bFM4_MFS5_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x4270A288UL))
#define bFM4_MFS5_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270A28CUL))
#define bFM4_MFS5_I2C_FCR_FSET                 *((volatile unsigned char*)(0x4270A290UL))
#define bFM4_MFS5_I2C_FCR_FLD                  *((volatile unsigned char*)(0x4270A294UL))
#define bFM4_MFS5_I2C_FCR_FLST                 *((volatile unsigned char*)(0x4270A298UL))
#define bFM4_MFS5_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM4_MFS5_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM4_MFS5_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM4_MFS5_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM4_MFS5_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM4_MFS5_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x4270A280UL))
#define bFM4_MFS5_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x4270A284UL))
#define bFM4_MFS5_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x4270A288UL))
#define bFM4_MFS5_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270A28CUL))
#define bFM4_MFS5_I2C_FCR0_FSET                *((volatile unsigned char*)(0x4270A290UL))
#define bFM4_MFS5_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x4270A294UL))
#define bFM4_MFS5_I2C_FCR0_FLST                *((volatile unsigned char*)(0x4270A298UL))
#define bFM4_MFS5_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM4_MFS5_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM4_MFS5_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM4_MFS5_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM4_MFS5_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM4_MFS5_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x4270A300UL))
#define bFM4_MFS5_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x4270A304UL))
#define bFM4_MFS5_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x4270A308UL))
#define bFM4_MFS5_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270A30CUL))
#define bFM4_MFS5_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x4270A310UL))
#define bFM4_MFS5_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x4270A314UL))
#define bFM4_MFS5_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x4270A318UL))
#define bFM4_MFS5_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270A31CUL))
#define bFM4_MFS5_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x4270A320UL))
#define bFM4_MFS5_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x4270A324UL))
#define bFM4_MFS5_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x4270A328UL))
#define bFM4_MFS5_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270A32CUL))
#define bFM4_MFS5_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x4270A330UL))
#define bFM4_MFS5_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x4270A334UL))
#define bFM4_MFS5_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x4270A338UL))
#define bFM4_MFS5_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270A33CUL))
#define bFM4_MFS5_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x4270A300UL))
#define bFM4_MFS5_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x4270A304UL))
#define bFM4_MFS5_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x4270A308UL))
#define bFM4_MFS5_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270A30CUL))
#define bFM4_MFS5_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x4270A310UL))
#define bFM4_MFS5_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x4270A314UL))
#define bFM4_MFS5_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x4270A318UL))
#define bFM4_MFS5_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270A31CUL))
#define bFM4_MFS5_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x4270A320UL))
#define bFM4_MFS5_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x4270A324UL))
#define bFM4_MFS5_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x4270A328UL))
#define bFM4_MFS5_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270A32CUL))
#define bFM4_MFS5_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x4270A330UL))
#define bFM4_MFS5_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x4270A334UL))
#define bFM4_MFS5_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x4270A338UL))
#define bFM4_MFS5_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270A33CUL))

/* MFS UART channel 6 registers */
#define bFM4_MFS6_UART_SMR_SOE                 *((volatile unsigned char*)(0x4270C000UL))
#define bFM4_MFS6_UART_SMR_BDS                 *((volatile unsigned char*)(0x4270C008UL))
#define bFM4_MFS6_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270C00CUL))
#define bFM4_MFS6_UART_SMR_WUCR                *((volatile unsigned char*)(0x4270C010UL))
#define bFM4_MFS6_UART_SMR_MD0                 *((volatile unsigned char*)(0x4270C014UL))
#define bFM4_MFS6_UART_SMR_MD1                 *((volatile unsigned char*)(0x4270C018UL))
#define bFM4_MFS6_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270C01CUL))
#define bFM4_MFS6_UART_SCR_TXE                 *((volatile unsigned char*)(0x4270C020UL))
#define bFM4_MFS6_UART_SCR_RXE                 *((volatile unsigned char*)(0x4270C024UL))
#define bFM4_MFS6_UART_SCR_TBIE                *((volatile unsigned char*)(0x4270C028UL))
#define bFM4_MFS6_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270C02CUL))
#define bFM4_MFS6_UART_SCR_RIE                 *((volatile unsigned char*)(0x4270C030UL))
#define bFM4_MFS6_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270C03CUL))
#define bFM4_MFS6_UART_ESCR_L0                 *((volatile unsigned char*)(0x4270C080UL))
#define bFM4_MFS6_UART_ESCR_L1                 *((volatile unsigned char*)(0x4270C084UL))
#define bFM4_MFS6_UART_ESCR_L2                 *((volatile unsigned char*)(0x4270C088UL))
#define bFM4_MFS6_UART_ESCR_P                  *((volatile unsigned char*)(0x4270C08CUL))
#define bFM4_MFS6_UART_ESCR_PEN                *((volatile unsigned char*)(0x4270C090UL))
#define bFM4_MFS6_UART_ESCR_INV                *((volatile unsigned char*)(0x4270C094UL))
#define bFM4_MFS6_UART_ESCR_ESBL               *((volatile unsigned char*)(0x4270C098UL))
#define bFM4_MFS6_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270C09CUL))
#define bFM4_MFS6_UART_SSR_TBI                 *((volatile unsigned char*)(0x4270C0A0UL))
#define bFM4_MFS6_UART_SSR_TDRE                *((volatile unsigned char*)(0x4270C0A4UL))
#define bFM4_MFS6_UART_SSR_RDRF                *((volatile unsigned char*)(0x4270C0A8UL))
#define bFM4_MFS6_UART_SSR_ORE                 *((volatile unsigned char*)(0x4270C0ACUL))
#define bFM4_MFS6_UART_SSR_FRE                 *((volatile unsigned char*)(0x4270C0B0UL))
#define bFM4_MFS6_UART_SSR_PE                  *((volatile unsigned char*)(0x4270C0B4UL))
#define bFM4_MFS6_UART_SSR_REC                 *((volatile unsigned char*)(0x4270C0BCUL))
#define bFM4_MFS6_UART_BGR_EXT                 *((volatile unsigned char*)(0x4270C1BCUL))
#define bFM4_MFS6_UART_BGR1_EXT                *((volatile unsigned char*)(0x4270C1BCUL))
#define bFM4_MFS6_UART_FCR_FE1                 *((volatile unsigned char*)(0x4270C280UL))
#define bFM4_MFS6_UART_FCR_FE2                 *((volatile unsigned char*)(0x4270C284UL))
#define bFM4_MFS6_UART_FCR_FCL1                *((volatile unsigned char*)(0x4270C288UL))
#define bFM4_MFS6_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270C28CUL))
#define bFM4_MFS6_UART_FCR_FSET                *((volatile unsigned char*)(0x4270C290UL))
#define bFM4_MFS6_UART_FCR_FLD                 *((volatile unsigned char*)(0x4270C294UL))
#define bFM4_MFS6_UART_FCR_FLST                *((volatile unsigned char*)(0x4270C298UL))
#define bFM4_MFS6_UART_FCR_FSEL                *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM4_MFS6_UART_FCR_FTIE                *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM4_MFS6_UART_FCR_FDRQ                *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM4_MFS6_UART_FCR_FRIIE               *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM4_MFS6_UART_FCR_FLSTE               *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM4_MFS6_UART_FCR0_FE1                *((volatile unsigned char*)(0x4270C280UL))
#define bFM4_MFS6_UART_FCR0_FE2                *((volatile unsigned char*)(0x4270C284UL))
#define bFM4_MFS6_UART_FCR0_FCL1               *((volatile unsigned char*)(0x4270C288UL))
#define bFM4_MFS6_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270C28CUL))
#define bFM4_MFS6_UART_FCR0_FSET               *((volatile unsigned char*)(0x4270C290UL))
#define bFM4_MFS6_UART_FCR0_FLD                *((volatile unsigned char*)(0x4270C294UL))
#define bFM4_MFS6_UART_FCR0_FLST               *((volatile unsigned char*)(0x4270C298UL))
#define bFM4_MFS6_UART_FCR1_FSEL               *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM4_MFS6_UART_FCR1_FTIE               *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM4_MFS6_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM4_MFS6_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM4_MFS6_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM4_MFS6_UART_FBYTE_FD0               *((volatile unsigned char*)(0x4270C300UL))
#define bFM4_MFS6_UART_FBYTE_FD1               *((volatile unsigned char*)(0x4270C304UL))
#define bFM4_MFS6_UART_FBYTE_FD2               *((volatile unsigned char*)(0x4270C308UL))
#define bFM4_MFS6_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270C30CUL))
#define bFM4_MFS6_UART_FBYTE_FD4               *((volatile unsigned char*)(0x4270C310UL))
#define bFM4_MFS6_UART_FBYTE_FD5               *((volatile unsigned char*)(0x4270C314UL))
#define bFM4_MFS6_UART_FBYTE_FD6               *((volatile unsigned char*)(0x4270C318UL))
#define bFM4_MFS6_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270C31CUL))
#define bFM4_MFS6_UART_FBYTE_FD8               *((volatile unsigned char*)(0x4270C320UL))
#define bFM4_MFS6_UART_FBYTE_FD9               *((volatile unsigned char*)(0x4270C324UL))
#define bFM4_MFS6_UART_FBYTE_FD10              *((volatile unsigned char*)(0x4270C328UL))
#define bFM4_MFS6_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270C32CUL))
#define bFM4_MFS6_UART_FBYTE_FD12              *((volatile unsigned char*)(0x4270C330UL))
#define bFM4_MFS6_UART_FBYTE_FD13              *((volatile unsigned char*)(0x4270C334UL))
#define bFM4_MFS6_UART_FBYTE_FD14              *((volatile unsigned char*)(0x4270C338UL))
#define bFM4_MFS6_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270C33CUL))
#define bFM4_MFS6_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x4270C300UL))
#define bFM4_MFS6_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x4270C304UL))
#define bFM4_MFS6_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x4270C308UL))
#define bFM4_MFS6_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270C30CUL))
#define bFM4_MFS6_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x4270C310UL))
#define bFM4_MFS6_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x4270C314UL))
#define bFM4_MFS6_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x4270C318UL))
#define bFM4_MFS6_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270C31CUL))
#define bFM4_MFS6_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x4270C320UL))
#define bFM4_MFS6_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x4270C324UL))
#define bFM4_MFS6_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x4270C328UL))
#define bFM4_MFS6_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270C32CUL))
#define bFM4_MFS6_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x4270C330UL))
#define bFM4_MFS6_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x4270C334UL))
#define bFM4_MFS6_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x4270C338UL))
#define bFM4_MFS6_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270C33CUL))

/* MFS CSIO channel 6 registers */
#define bFM4_MFS6_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x4270C000UL))
#define bFM4_MFS6_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x4270C004UL))
#define bFM4_MFS6_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x4270C008UL))
#define bFM4_MFS6_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270C00CUL))
#define bFM4_MFS6_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x4270C014UL))
#define bFM4_MFS6_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x4270C018UL))
#define bFM4_MFS6_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270C01CUL))
#define bFM4_MFS6_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x4270C020UL))
#define bFM4_MFS6_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x4270C024UL))
#define bFM4_MFS6_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x4270C028UL))
#define bFM4_MFS6_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270C02CUL))
#define bFM4_MFS6_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x4270C030UL))
#define bFM4_MFS6_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x4270C034UL))
#define bFM4_MFS6_CSIO_SCR_MS                  *((volatile unsigned char*)(0x4270C038UL))
#define bFM4_MFS6_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270C03CUL))
#define bFM4_MFS6_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x4270C080UL))
#define bFM4_MFS6_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x4270C084UL))
#define bFM4_MFS6_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x4270C088UL))
#define bFM4_MFS6_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270C08CUL))
#define bFM4_MFS6_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x4270C090UL))
#define bFM4_MFS6_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x4270C094UL))
#define bFM4_MFS6_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x4270C098UL))
#define bFM4_MFS6_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270C09CUL))
#define bFM4_MFS6_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x4270C0A0UL))
#define bFM4_MFS6_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x4270C0A4UL))
#define bFM4_MFS6_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x4270C0A8UL))
#define bFM4_MFS6_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x4270C0ACUL))
#define bFM4_MFS6_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x4270C0B0UL))
#define bFM4_MFS6_CSIO_SSR_REC                 *((volatile unsigned char*)(0x4270C0BCUL))
#define bFM4_MFS6_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x4270C280UL))
#define bFM4_MFS6_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x4270C284UL))
#define bFM4_MFS6_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x4270C288UL))
#define bFM4_MFS6_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270C28CUL))
#define bFM4_MFS6_CSIO_FCR_FSET                *((volatile unsigned char*)(0x4270C290UL))
#define bFM4_MFS6_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x4270C294UL))
#define bFM4_MFS6_CSIO_FCR_FLST                *((volatile unsigned char*)(0x4270C298UL))
#define bFM4_MFS6_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM4_MFS6_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM4_MFS6_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM4_MFS6_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM4_MFS6_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM4_MFS6_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x4270C280UL))
#define bFM4_MFS6_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x4270C284UL))
#define bFM4_MFS6_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x4270C288UL))
#define bFM4_MFS6_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270C28CUL))
#define bFM4_MFS6_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x4270C290UL))
#define bFM4_MFS6_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x4270C294UL))
#define bFM4_MFS6_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x4270C298UL))
#define bFM4_MFS6_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM4_MFS6_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM4_MFS6_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM4_MFS6_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM4_MFS6_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM4_MFS6_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x4270C300UL))
#define bFM4_MFS6_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x4270C304UL))
#define bFM4_MFS6_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x4270C308UL))
#define bFM4_MFS6_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270C30CUL))
#define bFM4_MFS6_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x4270C310UL))
#define bFM4_MFS6_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x4270C314UL))
#define bFM4_MFS6_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x4270C318UL))
#define bFM4_MFS6_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270C31CUL))
#define bFM4_MFS6_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x4270C320UL))
#define bFM4_MFS6_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x4270C324UL))
#define bFM4_MFS6_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x4270C328UL))
#define bFM4_MFS6_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270C32CUL))
#define bFM4_MFS6_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x4270C330UL))
#define bFM4_MFS6_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x4270C334UL))
#define bFM4_MFS6_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x4270C338UL))
#define bFM4_MFS6_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270C33CUL))
#define bFM4_MFS6_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x4270C300UL))
#define bFM4_MFS6_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x4270C304UL))
#define bFM4_MFS6_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x4270C308UL))
#define bFM4_MFS6_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270C30CUL))
#define bFM4_MFS6_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x4270C310UL))
#define bFM4_MFS6_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x4270C314UL))
#define bFM4_MFS6_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x4270C318UL))
#define bFM4_MFS6_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270C31CUL))
#define bFM4_MFS6_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x4270C320UL))
#define bFM4_MFS6_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x4270C324UL))
#define bFM4_MFS6_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x4270C328UL))
#define bFM4_MFS6_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270C32CUL))
#define bFM4_MFS6_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x4270C330UL))
#define bFM4_MFS6_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x4270C334UL))
#define bFM4_MFS6_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x4270C338UL))
#define bFM4_MFS6_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270C33CUL))
#define bFM4_MFS6_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x4270C380UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x4270C384UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x4270C388UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270C38CUL))
#define bFM4_MFS6_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x4270C390UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x4270C394UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x4270C398UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270C39CUL))
#define bFM4_MFS6_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x4270C3A0UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x4270C3A4UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x4270C3A8UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x4270C3ACUL))
#define bFM4_MFS6_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x4270C3B0UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x4270C3B4UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x4270C3B8UL))
#define bFM4_MFS6_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x4270C3BCUL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x4270C400UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x4270C404UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x4270C408UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270C40CUL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x4270C410UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x4270C414UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x4270C418UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270C41CUL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x4270C420UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x4270C424UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x4270C428UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270C42CUL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x4270C430UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x4270C434UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x4270C438UL))
#define bFM4_MFS6_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270C43CUL))
#define bFM4_MFS6_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x4270C480UL))
#define bFM4_MFS6_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x4270C484UL))
#define bFM4_MFS6_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x4270C488UL))
#define bFM4_MFS6_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270C48CUL))
#define bFM4_MFS6_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x4270C490UL))
#define bFM4_MFS6_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x4270C498UL))
#define bFM4_MFS6_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270C49CUL))
#define bFM4_MFS6_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x4270C4A0UL))
#define bFM4_MFS6_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x4270C4ACUL))
#define bFM4_MFS6_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x4270C4B0UL))
#define bFM4_MFS6_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x4270C4B4UL))
#define bFM4_MFS6_CSIO_STMR_TM0                *((volatile unsigned char*)(0x4270C500UL))
#define bFM4_MFS6_CSIO_STMR_TM1                *((volatile unsigned char*)(0x4270C504UL))
#define bFM4_MFS6_CSIO_STMR_TM2                *((volatile unsigned char*)(0x4270C508UL))
#define bFM4_MFS6_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270C50CUL))
#define bFM4_MFS6_CSIO_STMR_TM4                *((volatile unsigned char*)(0x4270C510UL))
#define bFM4_MFS6_CSIO_STMR_TM5                *((volatile unsigned char*)(0x4270C514UL))
#define bFM4_MFS6_CSIO_STMR_TM6                *((volatile unsigned char*)(0x4270C518UL))
#define bFM4_MFS6_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270C51CUL))
#define bFM4_MFS6_CSIO_STMR_TM8                *((volatile unsigned char*)(0x4270C520UL))
#define bFM4_MFS6_CSIO_STMR_TM9                *((volatile unsigned char*)(0x4270C524UL))
#define bFM4_MFS6_CSIO_STMR_TM10               *((volatile unsigned char*)(0x4270C528UL))
#define bFM4_MFS6_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270C52CUL))
#define bFM4_MFS6_CSIO_STMR_TM12               *((volatile unsigned char*)(0x4270C530UL))
#define bFM4_MFS6_CSIO_STMR_TM13               *((volatile unsigned char*)(0x4270C534UL))
#define bFM4_MFS6_CSIO_STMR_TM14               *((volatile unsigned char*)(0x4270C538UL))
#define bFM4_MFS6_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270C53CUL))
#define bFM4_MFS6_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x4270C580UL))
#define bFM4_MFS6_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x4270C584UL))
#define bFM4_MFS6_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x4270C588UL))
#define bFM4_MFS6_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270C58CUL))
#define bFM4_MFS6_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x4270C590UL))
#define bFM4_MFS6_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x4270C594UL))
#define bFM4_MFS6_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x4270C598UL))
#define bFM4_MFS6_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270C59CUL))
#define bFM4_MFS6_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x4270C5A0UL))
#define bFM4_MFS6_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x4270C5A4UL))
#define bFM4_MFS6_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x4270C5A8UL))
#define bFM4_MFS6_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x4270C5ACUL))
#define bFM4_MFS6_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x4270C5B0UL))
#define bFM4_MFS6_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x4270C5B4UL))
#define bFM4_MFS6_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x4270C5B8UL))
#define bFM4_MFS6_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x4270C5BCUL))
#define bFM4_MFS6_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x4270C600UL))
#define bFM4_MFS6_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x4270C604UL))
#define bFM4_MFS6_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x4270C608UL))
#define bFM4_MFS6_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270C60CUL))
#define bFM4_MFS6_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x4270C610UL))
#define bFM4_MFS6_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x4270C614UL))
#define bFM4_MFS6_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x4270C618UL))
#define bFM4_MFS6_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270C61CUL))
#define bFM4_MFS6_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x4270C620UL))
#define bFM4_MFS6_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x4270C624UL))
#define bFM4_MFS6_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x4270C628UL))
#define bFM4_MFS6_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270C62CUL))
#define bFM4_MFS6_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x4270C630UL))
#define bFM4_MFS6_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x4270C634UL))
#define bFM4_MFS6_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x4270C638UL))
#define bFM4_MFS6_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270C63CUL))
#define bFM4_MFS6_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x4270C680UL))
#define bFM4_MFS6_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x4270C684UL))
#define bFM4_MFS6_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x4270C688UL))
#define bFM4_MFS6_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270C68CUL))
#define bFM4_MFS6_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x4270C690UL))
#define bFM4_MFS6_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x4270C694UL))
#define bFM4_MFS6_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x4270C698UL))
#define bFM4_MFS6_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270C69CUL))
#define bFM4_MFS6_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x4270C6A0UL))
#define bFM4_MFS6_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x4270C6A4UL))
#define bFM4_MFS6_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x4270C6A8UL))
#define bFM4_MFS6_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x4270C6ACUL))
#define bFM4_MFS6_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x4270C6B0UL))
#define bFM4_MFS6_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x4270C6B4UL))
#define bFM4_MFS6_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x4270C6B8UL))
#define bFM4_MFS6_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x4270C6BCUL))
#define bFM4_MFS6_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x4270C700UL))
#define bFM4_MFS6_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x4270C704UL))
#define bFM4_MFS6_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x4270C708UL))
#define bFM4_MFS6_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270C70CUL))
#define bFM4_MFS6_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x4270C710UL))
#define bFM4_MFS6_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x4270C714UL))
#define bFM4_MFS6_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x4270C718UL))
#define bFM4_MFS6_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270C71CUL))

/* MFS LIN channel 6 registers */
#define bFM4_MFS6_LIN_SMR_SOE                  *((volatile unsigned char*)(0x4270C000UL))
#define bFM4_MFS6_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270C00CUL))
#define bFM4_MFS6_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x4270C010UL))
#define bFM4_MFS6_LIN_SMR_MD0                  *((volatile unsigned char*)(0x4270C014UL))
#define bFM4_MFS6_LIN_SMR_MD1                  *((volatile unsigned char*)(0x4270C018UL))
#define bFM4_MFS6_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270C01CUL))
#define bFM4_MFS6_LIN_SCR_TXE                  *((volatile unsigned char*)(0x4270C020UL))
#define bFM4_MFS6_LIN_SCR_RXE                  *((volatile unsigned char*)(0x4270C024UL))
#define bFM4_MFS6_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x4270C028UL))
#define bFM4_MFS6_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270C02CUL))
#define bFM4_MFS6_LIN_SCR_RIE                  *((volatile unsigned char*)(0x4270C030UL))
#define bFM4_MFS6_LIN_SCR_LBR                  *((volatile unsigned char*)(0x4270C034UL))
#define bFM4_MFS6_LIN_SCR_MS                   *((volatile unsigned char*)(0x4270C038UL))
#define bFM4_MFS6_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270C03CUL))
#define bFM4_MFS6_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x4270C080UL))
#define bFM4_MFS6_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x4270C084UL))
#define bFM4_MFS6_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x4270C088UL))
#define bFM4_MFS6_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270C08CUL))
#define bFM4_MFS6_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x4270C090UL))
#define bFM4_MFS6_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x4270C098UL))
#define bFM4_MFS6_LIN_SSR_TBI                  *((volatile unsigned char*)(0x4270C0A0UL))
#define bFM4_MFS6_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x4270C0A4UL))
#define bFM4_MFS6_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x4270C0A8UL))
#define bFM4_MFS6_LIN_SSR_ORE                  *((volatile unsigned char*)(0x4270C0ACUL))
#define bFM4_MFS6_LIN_SSR_FRE                  *((volatile unsigned char*)(0x4270C0B0UL))
#define bFM4_MFS6_LIN_SSR_LBD                  *((volatile unsigned char*)(0x4270C0B4UL))
#define bFM4_MFS6_LIN_SSR_REC                  *((volatile unsigned char*)(0x4270C0BCUL))
#define bFM4_MFS6_LIN_BGR_EXT                  *((volatile unsigned char*)(0x4270C1BCUL))
#define bFM4_MFS6_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x4270C1BCUL))
#define bFM4_MFS6_LIN_FCR_FE1                  *((volatile unsigned char*)(0x4270C280UL))
#define bFM4_MFS6_LIN_FCR_FE2                  *((volatile unsigned char*)(0x4270C284UL))
#define bFM4_MFS6_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x4270C288UL))
#define bFM4_MFS6_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270C28CUL))
#define bFM4_MFS6_LIN_FCR_FSET                 *((volatile unsigned char*)(0x4270C290UL))
#define bFM4_MFS6_LIN_FCR_FLD                  *((volatile unsigned char*)(0x4270C294UL))
#define bFM4_MFS6_LIN_FCR_FLST                 *((volatile unsigned char*)(0x4270C298UL))
#define bFM4_MFS6_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM4_MFS6_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM4_MFS6_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM4_MFS6_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM4_MFS6_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM4_MFS6_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x4270C280UL))
#define bFM4_MFS6_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x4270C284UL))
#define bFM4_MFS6_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x4270C288UL))
#define bFM4_MFS6_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270C28CUL))
#define bFM4_MFS6_LIN_FCR0_FSET                *((volatile unsigned char*)(0x4270C290UL))
#define bFM4_MFS6_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x4270C294UL))
#define bFM4_MFS6_LIN_FCR0_FLST                *((volatile unsigned char*)(0x4270C298UL))
#define bFM4_MFS6_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM4_MFS6_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM4_MFS6_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM4_MFS6_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM4_MFS6_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM4_MFS6_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x4270C300UL))
#define bFM4_MFS6_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x4270C304UL))
#define bFM4_MFS6_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x4270C308UL))
#define bFM4_MFS6_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270C30CUL))
#define bFM4_MFS6_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x4270C310UL))
#define bFM4_MFS6_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x4270C314UL))
#define bFM4_MFS6_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x4270C318UL))
#define bFM4_MFS6_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270C31CUL))
#define bFM4_MFS6_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x4270C320UL))
#define bFM4_MFS6_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x4270C324UL))
#define bFM4_MFS6_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x4270C328UL))
#define bFM4_MFS6_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270C32CUL))
#define bFM4_MFS6_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x4270C330UL))
#define bFM4_MFS6_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x4270C334UL))
#define bFM4_MFS6_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x4270C338UL))
#define bFM4_MFS6_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270C33CUL))
#define bFM4_MFS6_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x4270C300UL))
#define bFM4_MFS6_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x4270C304UL))
#define bFM4_MFS6_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x4270C308UL))
#define bFM4_MFS6_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270C30CUL))
#define bFM4_MFS6_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x4270C310UL))
#define bFM4_MFS6_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x4270C314UL))
#define bFM4_MFS6_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x4270C318UL))
#define bFM4_MFS6_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270C31CUL))
#define bFM4_MFS6_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x4270C320UL))
#define bFM4_MFS6_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x4270C324UL))
#define bFM4_MFS6_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x4270C328UL))
#define bFM4_MFS6_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270C32CUL))
#define bFM4_MFS6_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x4270C330UL))
#define bFM4_MFS6_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x4270C334UL))
#define bFM4_MFS6_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x4270C338UL))
#define bFM4_MFS6_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270C33CUL))

/* MFS I2C channel 6 registers */
#define bFM4_MFS6_I2C_SMR_TIE                  *((volatile unsigned char*)(0x4270C008UL))
#define bFM4_MFS6_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270C00CUL))
#define bFM4_MFS6_I2C_SMR_MD0                  *((volatile unsigned char*)(0x4270C014UL))
#define bFM4_MFS6_I2C_SMR_MD1                  *((volatile unsigned char*)(0x4270C018UL))
#define bFM4_MFS6_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270C01CUL))
#define bFM4_MFS6_I2C_IBCR_INT                 *((volatile unsigned char*)(0x4270C020UL))
#define bFM4_MFS6_I2C_IBCR_BER                 *((volatile unsigned char*)(0x4270C024UL))
#define bFM4_MFS6_I2C_IBCR_INTE                *((volatile unsigned char*)(0x4270C028UL))
#define bFM4_MFS6_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270C02CUL))
#define bFM4_MFS6_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x4270C030UL))
#define bFM4_MFS6_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x4270C034UL))
#define bFM4_MFS6_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x4270C038UL))
#define bFM4_MFS6_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x4270C038UL))
#define bFM4_MFS6_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270C03CUL))
#define bFM4_MFS6_I2C_IBSR_BB                  *((volatile unsigned char*)(0x4270C080UL))
#define bFM4_MFS6_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x4270C084UL))
#define bFM4_MFS6_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x4270C088UL))
#define bFM4_MFS6_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270C08CUL))
#define bFM4_MFS6_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x4270C090UL))
#define bFM4_MFS6_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x4270C094UL))
#define bFM4_MFS6_I2C_IBSR_RACK                *((volatile unsigned char*)(0x4270C098UL))
#define bFM4_MFS6_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270C09CUL))
#define bFM4_MFS6_I2C_SSR_TBI                  *((volatile unsigned char*)(0x4270C0A0UL))
#define bFM4_MFS6_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x4270C0A4UL))
#define bFM4_MFS6_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x4270C0A8UL))
#define bFM4_MFS6_I2C_SSR_ORE                  *((volatile unsigned char*)(0x4270C0ACUL))
#define bFM4_MFS6_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x4270C0B0UL))
#define bFM4_MFS6_I2C_SSR_DMA                  *((volatile unsigned char*)(0x4270C0B4UL))
#define bFM4_MFS6_I2C_SSR_TSET                 *((volatile unsigned char*)(0x4270C0B8UL))
#define bFM4_MFS6_I2C_SSR_REC                  *((volatile unsigned char*)(0x4270C0BCUL))
#define bFM4_MFS6_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x4270C200UL))
#define bFM4_MFS6_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x4270C204UL))
#define bFM4_MFS6_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x4270C208UL))
#define bFM4_MFS6_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270C20CUL))
#define bFM4_MFS6_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x4270C210UL))
#define bFM4_MFS6_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x4270C214UL))
#define bFM4_MFS6_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x4270C218UL))
#define bFM4_MFS6_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270C21CUL))
#define bFM4_MFS6_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x4270C220UL))
#define bFM4_MFS6_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x4270C224UL))
#define bFM4_MFS6_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x4270C228UL))
#define bFM4_MFS6_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270C22CUL))
#define bFM4_MFS6_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x4270C230UL))
#define bFM4_MFS6_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x4270C234UL))
#define bFM4_MFS6_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x4270C238UL))
#define bFM4_MFS6_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270C23CUL))
#define bFM4_MFS6_I2C_FCR_FE1                  *((volatile unsigned char*)(0x4270C280UL))
#define bFM4_MFS6_I2C_FCR_FE2                  *((volatile unsigned char*)(0x4270C284UL))
#define bFM4_MFS6_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x4270C288UL))
#define bFM4_MFS6_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270C28CUL))
#define bFM4_MFS6_I2C_FCR_FSET                 *((volatile unsigned char*)(0x4270C290UL))
#define bFM4_MFS6_I2C_FCR_FLD                  *((volatile unsigned char*)(0x4270C294UL))
#define bFM4_MFS6_I2C_FCR_FLST                 *((volatile unsigned char*)(0x4270C298UL))
#define bFM4_MFS6_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM4_MFS6_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM4_MFS6_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM4_MFS6_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM4_MFS6_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM4_MFS6_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x4270C280UL))
#define bFM4_MFS6_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x4270C284UL))
#define bFM4_MFS6_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x4270C288UL))
#define bFM4_MFS6_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270C28CUL))
#define bFM4_MFS6_I2C_FCR0_FSET                *((volatile unsigned char*)(0x4270C290UL))
#define bFM4_MFS6_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x4270C294UL))
#define bFM4_MFS6_I2C_FCR0_FLST                *((volatile unsigned char*)(0x4270C298UL))
#define bFM4_MFS6_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM4_MFS6_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM4_MFS6_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM4_MFS6_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM4_MFS6_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM4_MFS6_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x4270C300UL))
#define bFM4_MFS6_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x4270C304UL))
#define bFM4_MFS6_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x4270C308UL))
#define bFM4_MFS6_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270C30CUL))
#define bFM4_MFS6_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x4270C310UL))
#define bFM4_MFS6_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x4270C314UL))
#define bFM4_MFS6_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x4270C318UL))
#define bFM4_MFS6_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270C31CUL))
#define bFM4_MFS6_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x4270C320UL))
#define bFM4_MFS6_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x4270C324UL))
#define bFM4_MFS6_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x4270C328UL))
#define bFM4_MFS6_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270C32CUL))
#define bFM4_MFS6_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x4270C330UL))
#define bFM4_MFS6_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x4270C334UL))
#define bFM4_MFS6_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x4270C338UL))
#define bFM4_MFS6_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270C33CUL))
#define bFM4_MFS6_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x4270C300UL))
#define bFM4_MFS6_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x4270C304UL))
#define bFM4_MFS6_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x4270C308UL))
#define bFM4_MFS6_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270C30CUL))
#define bFM4_MFS6_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x4270C310UL))
#define bFM4_MFS6_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x4270C314UL))
#define bFM4_MFS6_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x4270C318UL))
#define bFM4_MFS6_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270C31CUL))
#define bFM4_MFS6_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x4270C320UL))
#define bFM4_MFS6_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x4270C324UL))
#define bFM4_MFS6_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x4270C328UL))
#define bFM4_MFS6_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270C32CUL))
#define bFM4_MFS6_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x4270C330UL))
#define bFM4_MFS6_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x4270C334UL))
#define bFM4_MFS6_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x4270C338UL))
#define bFM4_MFS6_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270C33CUL))

/* MFS UART channel 7 registers */
#define bFM4_MFS7_UART_SMR_SOE                 *((volatile unsigned char*)(0x4270E000UL))
#define bFM4_MFS7_UART_SMR_BDS                 *((volatile unsigned char*)(0x4270E008UL))
#define bFM4_MFS7_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270E00CUL))
#define bFM4_MFS7_UART_SMR_WUCR                *((volatile unsigned char*)(0x4270E010UL))
#define bFM4_MFS7_UART_SMR_MD0                 *((volatile unsigned char*)(0x4270E014UL))
#define bFM4_MFS7_UART_SMR_MD1                 *((volatile unsigned char*)(0x4270E018UL))
#define bFM4_MFS7_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270E01CUL))
#define bFM4_MFS7_UART_SCR_TXE                 *((volatile unsigned char*)(0x4270E020UL))
#define bFM4_MFS7_UART_SCR_RXE                 *((volatile unsigned char*)(0x4270E024UL))
#define bFM4_MFS7_UART_SCR_TBIE                *((volatile unsigned char*)(0x4270E028UL))
#define bFM4_MFS7_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270E02CUL))
#define bFM4_MFS7_UART_SCR_RIE                 *((volatile unsigned char*)(0x4270E030UL))
#define bFM4_MFS7_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270E03CUL))
#define bFM4_MFS7_UART_ESCR_L0                 *((volatile unsigned char*)(0x4270E080UL))
#define bFM4_MFS7_UART_ESCR_L1                 *((volatile unsigned char*)(0x4270E084UL))
#define bFM4_MFS7_UART_ESCR_L2                 *((volatile unsigned char*)(0x4270E088UL))
#define bFM4_MFS7_UART_ESCR_P                  *((volatile unsigned char*)(0x4270E08CUL))
#define bFM4_MFS7_UART_ESCR_PEN                *((volatile unsigned char*)(0x4270E090UL))
#define bFM4_MFS7_UART_ESCR_INV                *((volatile unsigned char*)(0x4270E094UL))
#define bFM4_MFS7_UART_ESCR_ESBL               *((volatile unsigned char*)(0x4270E098UL))
#define bFM4_MFS7_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270E09CUL))
#define bFM4_MFS7_UART_SSR_TBI                 *((volatile unsigned char*)(0x4270E0A0UL))
#define bFM4_MFS7_UART_SSR_TDRE                *((volatile unsigned char*)(0x4270E0A4UL))
#define bFM4_MFS7_UART_SSR_RDRF                *((volatile unsigned char*)(0x4270E0A8UL))
#define bFM4_MFS7_UART_SSR_ORE                 *((volatile unsigned char*)(0x4270E0ACUL))
#define bFM4_MFS7_UART_SSR_FRE                 *((volatile unsigned char*)(0x4270E0B0UL))
#define bFM4_MFS7_UART_SSR_PE                  *((volatile unsigned char*)(0x4270E0B4UL))
#define bFM4_MFS7_UART_SSR_REC                 *((volatile unsigned char*)(0x4270E0BCUL))
#define bFM4_MFS7_UART_BGR_EXT                 *((volatile unsigned char*)(0x4270E1BCUL))
#define bFM4_MFS7_UART_BGR1_EXT                *((volatile unsigned char*)(0x4270E1BCUL))
#define bFM4_MFS7_UART_FCR_FE1                 *((volatile unsigned char*)(0x4270E280UL))
#define bFM4_MFS7_UART_FCR_FE2                 *((volatile unsigned char*)(0x4270E284UL))
#define bFM4_MFS7_UART_FCR_FCL1                *((volatile unsigned char*)(0x4270E288UL))
#define bFM4_MFS7_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270E28CUL))
#define bFM4_MFS7_UART_FCR_FSET                *((volatile unsigned char*)(0x4270E290UL))
#define bFM4_MFS7_UART_FCR_FLD                 *((volatile unsigned char*)(0x4270E294UL))
#define bFM4_MFS7_UART_FCR_FLST                *((volatile unsigned char*)(0x4270E298UL))
#define bFM4_MFS7_UART_FCR_FSEL                *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM4_MFS7_UART_FCR_FTIE                *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM4_MFS7_UART_FCR_FDRQ                *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM4_MFS7_UART_FCR_FRIIE               *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM4_MFS7_UART_FCR_FLSTE               *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM4_MFS7_UART_FCR0_FE1                *((volatile unsigned char*)(0x4270E280UL))
#define bFM4_MFS7_UART_FCR0_FE2                *((volatile unsigned char*)(0x4270E284UL))
#define bFM4_MFS7_UART_FCR0_FCL1               *((volatile unsigned char*)(0x4270E288UL))
#define bFM4_MFS7_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270E28CUL))
#define bFM4_MFS7_UART_FCR0_FSET               *((volatile unsigned char*)(0x4270E290UL))
#define bFM4_MFS7_UART_FCR0_FLD                *((volatile unsigned char*)(0x4270E294UL))
#define bFM4_MFS7_UART_FCR0_FLST               *((volatile unsigned char*)(0x4270E298UL))
#define bFM4_MFS7_UART_FCR1_FSEL               *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM4_MFS7_UART_FCR1_FTIE               *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM4_MFS7_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM4_MFS7_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM4_MFS7_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM4_MFS7_UART_FBYTE_FD0               *((volatile unsigned char*)(0x4270E300UL))
#define bFM4_MFS7_UART_FBYTE_FD1               *((volatile unsigned char*)(0x4270E304UL))
#define bFM4_MFS7_UART_FBYTE_FD2               *((volatile unsigned char*)(0x4270E308UL))
#define bFM4_MFS7_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270E30CUL))
#define bFM4_MFS7_UART_FBYTE_FD4               *((volatile unsigned char*)(0x4270E310UL))
#define bFM4_MFS7_UART_FBYTE_FD5               *((volatile unsigned char*)(0x4270E314UL))
#define bFM4_MFS7_UART_FBYTE_FD6               *((volatile unsigned char*)(0x4270E318UL))
#define bFM4_MFS7_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270E31CUL))
#define bFM4_MFS7_UART_FBYTE_FD8               *((volatile unsigned char*)(0x4270E320UL))
#define bFM4_MFS7_UART_FBYTE_FD9               *((volatile unsigned char*)(0x4270E324UL))
#define bFM4_MFS7_UART_FBYTE_FD10              *((volatile unsigned char*)(0x4270E328UL))
#define bFM4_MFS7_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270E32CUL))
#define bFM4_MFS7_UART_FBYTE_FD12              *((volatile unsigned char*)(0x4270E330UL))
#define bFM4_MFS7_UART_FBYTE_FD13              *((volatile unsigned char*)(0x4270E334UL))
#define bFM4_MFS7_UART_FBYTE_FD14              *((volatile unsigned char*)(0x4270E338UL))
#define bFM4_MFS7_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270E33CUL))
#define bFM4_MFS7_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x4270E300UL))
#define bFM4_MFS7_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x4270E304UL))
#define bFM4_MFS7_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x4270E308UL))
#define bFM4_MFS7_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270E30CUL))
#define bFM4_MFS7_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x4270E310UL))
#define bFM4_MFS7_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x4270E314UL))
#define bFM4_MFS7_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x4270E318UL))
#define bFM4_MFS7_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270E31CUL))
#define bFM4_MFS7_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x4270E320UL))
#define bFM4_MFS7_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x4270E324UL))
#define bFM4_MFS7_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x4270E328UL))
#define bFM4_MFS7_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270E32CUL))
#define bFM4_MFS7_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x4270E330UL))
#define bFM4_MFS7_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x4270E334UL))
#define bFM4_MFS7_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x4270E338UL))
#define bFM4_MFS7_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270E33CUL))

/* MFS CSIO channel 7 registers */
#define bFM4_MFS7_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x4270E000UL))
#define bFM4_MFS7_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x4270E004UL))
#define bFM4_MFS7_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x4270E008UL))
#define bFM4_MFS7_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270E00CUL))
#define bFM4_MFS7_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x4270E014UL))
#define bFM4_MFS7_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x4270E018UL))
#define bFM4_MFS7_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270E01CUL))
#define bFM4_MFS7_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x4270E020UL))
#define bFM4_MFS7_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x4270E024UL))
#define bFM4_MFS7_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x4270E028UL))
#define bFM4_MFS7_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270E02CUL))
#define bFM4_MFS7_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x4270E030UL))
#define bFM4_MFS7_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x4270E034UL))
#define bFM4_MFS7_CSIO_SCR_MS                  *((volatile unsigned char*)(0x4270E038UL))
#define bFM4_MFS7_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270E03CUL))
#define bFM4_MFS7_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x4270E080UL))
#define bFM4_MFS7_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x4270E084UL))
#define bFM4_MFS7_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x4270E088UL))
#define bFM4_MFS7_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270E08CUL))
#define bFM4_MFS7_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x4270E090UL))
#define bFM4_MFS7_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x4270E094UL))
#define bFM4_MFS7_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x4270E098UL))
#define bFM4_MFS7_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270E09CUL))
#define bFM4_MFS7_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x4270E0A0UL))
#define bFM4_MFS7_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x4270E0A4UL))
#define bFM4_MFS7_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x4270E0A8UL))
#define bFM4_MFS7_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x4270E0ACUL))
#define bFM4_MFS7_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x4270E0B0UL))
#define bFM4_MFS7_CSIO_SSR_REC                 *((volatile unsigned char*)(0x4270E0BCUL))
#define bFM4_MFS7_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x4270E280UL))
#define bFM4_MFS7_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x4270E284UL))
#define bFM4_MFS7_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x4270E288UL))
#define bFM4_MFS7_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270E28CUL))
#define bFM4_MFS7_CSIO_FCR_FSET                *((volatile unsigned char*)(0x4270E290UL))
#define bFM4_MFS7_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x4270E294UL))
#define bFM4_MFS7_CSIO_FCR_FLST                *((volatile unsigned char*)(0x4270E298UL))
#define bFM4_MFS7_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM4_MFS7_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM4_MFS7_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM4_MFS7_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM4_MFS7_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM4_MFS7_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x4270E280UL))
#define bFM4_MFS7_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x4270E284UL))
#define bFM4_MFS7_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x4270E288UL))
#define bFM4_MFS7_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270E28CUL))
#define bFM4_MFS7_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x4270E290UL))
#define bFM4_MFS7_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x4270E294UL))
#define bFM4_MFS7_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x4270E298UL))
#define bFM4_MFS7_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM4_MFS7_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM4_MFS7_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM4_MFS7_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM4_MFS7_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM4_MFS7_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x4270E300UL))
#define bFM4_MFS7_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x4270E304UL))
#define bFM4_MFS7_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x4270E308UL))
#define bFM4_MFS7_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270E30CUL))
#define bFM4_MFS7_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x4270E310UL))
#define bFM4_MFS7_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x4270E314UL))
#define bFM4_MFS7_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x4270E318UL))
#define bFM4_MFS7_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270E31CUL))
#define bFM4_MFS7_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x4270E320UL))
#define bFM4_MFS7_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x4270E324UL))
#define bFM4_MFS7_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x4270E328UL))
#define bFM4_MFS7_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270E32CUL))
#define bFM4_MFS7_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x4270E330UL))
#define bFM4_MFS7_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x4270E334UL))
#define bFM4_MFS7_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x4270E338UL))
#define bFM4_MFS7_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270E33CUL))
#define bFM4_MFS7_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x4270E300UL))
#define bFM4_MFS7_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x4270E304UL))
#define bFM4_MFS7_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x4270E308UL))
#define bFM4_MFS7_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270E30CUL))
#define bFM4_MFS7_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x4270E310UL))
#define bFM4_MFS7_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x4270E314UL))
#define bFM4_MFS7_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x4270E318UL))
#define bFM4_MFS7_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270E31CUL))
#define bFM4_MFS7_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x4270E320UL))
#define bFM4_MFS7_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x4270E324UL))
#define bFM4_MFS7_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x4270E328UL))
#define bFM4_MFS7_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270E32CUL))
#define bFM4_MFS7_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x4270E330UL))
#define bFM4_MFS7_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x4270E334UL))
#define bFM4_MFS7_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x4270E338UL))
#define bFM4_MFS7_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270E33CUL))
#define bFM4_MFS7_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x4270E380UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x4270E384UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x4270E388UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270E38CUL))
#define bFM4_MFS7_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x4270E390UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x4270E394UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x4270E398UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270E39CUL))
#define bFM4_MFS7_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x4270E3A0UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x4270E3A4UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x4270E3A8UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x4270E3ACUL))
#define bFM4_MFS7_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x4270E3B0UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x4270E3B4UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x4270E3B8UL))
#define bFM4_MFS7_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x4270E3BCUL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x4270E400UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x4270E404UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x4270E408UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270E40CUL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x4270E410UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x4270E414UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x4270E418UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270E41CUL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x4270E420UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x4270E424UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x4270E428UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270E42CUL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x4270E430UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x4270E434UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x4270E438UL))
#define bFM4_MFS7_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270E43CUL))
#define bFM4_MFS7_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x4270E480UL))
#define bFM4_MFS7_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x4270E484UL))
#define bFM4_MFS7_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x4270E488UL))
#define bFM4_MFS7_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270E48CUL))
#define bFM4_MFS7_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x4270E490UL))
#define bFM4_MFS7_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x4270E498UL))
#define bFM4_MFS7_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270E49CUL))
#define bFM4_MFS7_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x4270E4A0UL))
#define bFM4_MFS7_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x4270E4ACUL))
#define bFM4_MFS7_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x4270E4B0UL))
#define bFM4_MFS7_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x4270E4B4UL))
#define bFM4_MFS7_CSIO_STMR_TM0                *((volatile unsigned char*)(0x4270E500UL))
#define bFM4_MFS7_CSIO_STMR_TM1                *((volatile unsigned char*)(0x4270E504UL))
#define bFM4_MFS7_CSIO_STMR_TM2                *((volatile unsigned char*)(0x4270E508UL))
#define bFM4_MFS7_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270E50CUL))
#define bFM4_MFS7_CSIO_STMR_TM4                *((volatile unsigned char*)(0x4270E510UL))
#define bFM4_MFS7_CSIO_STMR_TM5                *((volatile unsigned char*)(0x4270E514UL))
#define bFM4_MFS7_CSIO_STMR_TM6                *((volatile unsigned char*)(0x4270E518UL))
#define bFM4_MFS7_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270E51CUL))
#define bFM4_MFS7_CSIO_STMR_TM8                *((volatile unsigned char*)(0x4270E520UL))
#define bFM4_MFS7_CSIO_STMR_TM9                *((volatile unsigned char*)(0x4270E524UL))
#define bFM4_MFS7_CSIO_STMR_TM10               *((volatile unsigned char*)(0x4270E528UL))
#define bFM4_MFS7_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270E52CUL))
#define bFM4_MFS7_CSIO_STMR_TM12               *((volatile unsigned char*)(0x4270E530UL))
#define bFM4_MFS7_CSIO_STMR_TM13               *((volatile unsigned char*)(0x4270E534UL))
#define bFM4_MFS7_CSIO_STMR_TM14               *((volatile unsigned char*)(0x4270E538UL))
#define bFM4_MFS7_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270E53CUL))
#define bFM4_MFS7_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x4270E580UL))
#define bFM4_MFS7_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x4270E584UL))
#define bFM4_MFS7_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x4270E588UL))
#define bFM4_MFS7_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270E58CUL))
#define bFM4_MFS7_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x4270E590UL))
#define bFM4_MFS7_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x4270E594UL))
#define bFM4_MFS7_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x4270E598UL))
#define bFM4_MFS7_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270E59CUL))
#define bFM4_MFS7_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x4270E5A0UL))
#define bFM4_MFS7_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x4270E5A4UL))
#define bFM4_MFS7_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x4270E5A8UL))
#define bFM4_MFS7_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x4270E5ACUL))
#define bFM4_MFS7_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x4270E5B0UL))
#define bFM4_MFS7_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x4270E5B4UL))
#define bFM4_MFS7_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x4270E5B8UL))
#define bFM4_MFS7_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x4270E5BCUL))
#define bFM4_MFS7_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x4270E600UL))
#define bFM4_MFS7_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x4270E604UL))
#define bFM4_MFS7_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x4270E608UL))
#define bFM4_MFS7_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270E60CUL))
#define bFM4_MFS7_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x4270E610UL))
#define bFM4_MFS7_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x4270E614UL))
#define bFM4_MFS7_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x4270E618UL))
#define bFM4_MFS7_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270E61CUL))
#define bFM4_MFS7_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x4270E620UL))
#define bFM4_MFS7_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x4270E624UL))
#define bFM4_MFS7_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x4270E628UL))
#define bFM4_MFS7_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270E62CUL))
#define bFM4_MFS7_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x4270E630UL))
#define bFM4_MFS7_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x4270E634UL))
#define bFM4_MFS7_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x4270E638UL))
#define bFM4_MFS7_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270E63CUL))
#define bFM4_MFS7_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x4270E680UL))
#define bFM4_MFS7_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x4270E684UL))
#define bFM4_MFS7_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x4270E688UL))
#define bFM4_MFS7_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270E68CUL))
#define bFM4_MFS7_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x4270E690UL))
#define bFM4_MFS7_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x4270E694UL))
#define bFM4_MFS7_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x4270E698UL))
#define bFM4_MFS7_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270E69CUL))
#define bFM4_MFS7_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x4270E6A0UL))
#define bFM4_MFS7_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x4270E6A4UL))
#define bFM4_MFS7_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x4270E6A8UL))
#define bFM4_MFS7_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x4270E6ACUL))
#define bFM4_MFS7_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x4270E6B0UL))
#define bFM4_MFS7_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x4270E6B4UL))
#define bFM4_MFS7_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x4270E6B8UL))
#define bFM4_MFS7_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x4270E6BCUL))
#define bFM4_MFS7_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x4270E700UL))
#define bFM4_MFS7_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x4270E704UL))
#define bFM4_MFS7_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x4270E708UL))
#define bFM4_MFS7_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270E70CUL))
#define bFM4_MFS7_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x4270E710UL))
#define bFM4_MFS7_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x4270E714UL))
#define bFM4_MFS7_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x4270E718UL))
#define bFM4_MFS7_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270E71CUL))

/* MFS LIN channel 7 registers */
#define bFM4_MFS7_LIN_SMR_SOE                  *((volatile unsigned char*)(0x4270E000UL))
#define bFM4_MFS7_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270E00CUL))
#define bFM4_MFS7_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x4270E010UL))
#define bFM4_MFS7_LIN_SMR_MD0                  *((volatile unsigned char*)(0x4270E014UL))
#define bFM4_MFS7_LIN_SMR_MD1                  *((volatile unsigned char*)(0x4270E018UL))
#define bFM4_MFS7_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270E01CUL))
#define bFM4_MFS7_LIN_SCR_TXE                  *((volatile unsigned char*)(0x4270E020UL))
#define bFM4_MFS7_LIN_SCR_RXE                  *((volatile unsigned char*)(0x4270E024UL))
#define bFM4_MFS7_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x4270E028UL))
#define bFM4_MFS7_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270E02CUL))
#define bFM4_MFS7_LIN_SCR_RIE                  *((volatile unsigned char*)(0x4270E030UL))
#define bFM4_MFS7_LIN_SCR_LBR                  *((volatile unsigned char*)(0x4270E034UL))
#define bFM4_MFS7_LIN_SCR_MS                   *((volatile unsigned char*)(0x4270E038UL))
#define bFM4_MFS7_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270E03CUL))
#define bFM4_MFS7_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x4270E080UL))
#define bFM4_MFS7_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x4270E084UL))
#define bFM4_MFS7_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x4270E088UL))
#define bFM4_MFS7_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270E08CUL))
#define bFM4_MFS7_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x4270E090UL))
#define bFM4_MFS7_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x4270E098UL))
#define bFM4_MFS7_LIN_SSR_TBI                  *((volatile unsigned char*)(0x4270E0A0UL))
#define bFM4_MFS7_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x4270E0A4UL))
#define bFM4_MFS7_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x4270E0A8UL))
#define bFM4_MFS7_LIN_SSR_ORE                  *((volatile unsigned char*)(0x4270E0ACUL))
#define bFM4_MFS7_LIN_SSR_FRE                  *((volatile unsigned char*)(0x4270E0B0UL))
#define bFM4_MFS7_LIN_SSR_LBD                  *((volatile unsigned char*)(0x4270E0B4UL))
#define bFM4_MFS7_LIN_SSR_REC                  *((volatile unsigned char*)(0x4270E0BCUL))
#define bFM4_MFS7_LIN_BGR_EXT                  *((volatile unsigned char*)(0x4270E1BCUL))
#define bFM4_MFS7_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x4270E1BCUL))
#define bFM4_MFS7_LIN_FCR_FE1                  *((volatile unsigned char*)(0x4270E280UL))
#define bFM4_MFS7_LIN_FCR_FE2                  *((volatile unsigned char*)(0x4270E284UL))
#define bFM4_MFS7_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x4270E288UL))
#define bFM4_MFS7_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270E28CUL))
#define bFM4_MFS7_LIN_FCR_FSET                 *((volatile unsigned char*)(0x4270E290UL))
#define bFM4_MFS7_LIN_FCR_FLD                  *((volatile unsigned char*)(0x4270E294UL))
#define bFM4_MFS7_LIN_FCR_FLST                 *((volatile unsigned char*)(0x4270E298UL))
#define bFM4_MFS7_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM4_MFS7_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM4_MFS7_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM4_MFS7_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM4_MFS7_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM4_MFS7_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x4270E280UL))
#define bFM4_MFS7_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x4270E284UL))
#define bFM4_MFS7_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x4270E288UL))
#define bFM4_MFS7_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270E28CUL))
#define bFM4_MFS7_LIN_FCR0_FSET                *((volatile unsigned char*)(0x4270E290UL))
#define bFM4_MFS7_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x4270E294UL))
#define bFM4_MFS7_LIN_FCR0_FLST                *((volatile unsigned char*)(0x4270E298UL))
#define bFM4_MFS7_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM4_MFS7_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM4_MFS7_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM4_MFS7_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM4_MFS7_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM4_MFS7_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x4270E300UL))
#define bFM4_MFS7_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x4270E304UL))
#define bFM4_MFS7_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x4270E308UL))
#define bFM4_MFS7_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270E30CUL))
#define bFM4_MFS7_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x4270E310UL))
#define bFM4_MFS7_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x4270E314UL))
#define bFM4_MFS7_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x4270E318UL))
#define bFM4_MFS7_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270E31CUL))
#define bFM4_MFS7_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x4270E320UL))
#define bFM4_MFS7_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x4270E324UL))
#define bFM4_MFS7_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x4270E328UL))
#define bFM4_MFS7_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270E32CUL))
#define bFM4_MFS7_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x4270E330UL))
#define bFM4_MFS7_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x4270E334UL))
#define bFM4_MFS7_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x4270E338UL))
#define bFM4_MFS7_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270E33CUL))
#define bFM4_MFS7_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x4270E300UL))
#define bFM4_MFS7_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x4270E304UL))
#define bFM4_MFS7_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x4270E308UL))
#define bFM4_MFS7_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270E30CUL))
#define bFM4_MFS7_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x4270E310UL))
#define bFM4_MFS7_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x4270E314UL))
#define bFM4_MFS7_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x4270E318UL))
#define bFM4_MFS7_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270E31CUL))
#define bFM4_MFS7_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x4270E320UL))
#define bFM4_MFS7_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x4270E324UL))
#define bFM4_MFS7_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x4270E328UL))
#define bFM4_MFS7_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270E32CUL))
#define bFM4_MFS7_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x4270E330UL))
#define bFM4_MFS7_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x4270E334UL))
#define bFM4_MFS7_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x4270E338UL))
#define bFM4_MFS7_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270E33CUL))

/* MFS I2C channel 7 registers */
#define bFM4_MFS7_I2C_SMR_TIE                  *((volatile unsigned char*)(0x4270E008UL))
#define bFM4_MFS7_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270E00CUL))
#define bFM4_MFS7_I2C_SMR_MD0                  *((volatile unsigned char*)(0x4270E014UL))
#define bFM4_MFS7_I2C_SMR_MD1                  *((volatile unsigned char*)(0x4270E018UL))
#define bFM4_MFS7_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270E01CUL))
#define bFM4_MFS7_I2C_IBCR_INT                 *((volatile unsigned char*)(0x4270E020UL))
#define bFM4_MFS7_I2C_IBCR_BER                 *((volatile unsigned char*)(0x4270E024UL))
#define bFM4_MFS7_I2C_IBCR_INTE                *((volatile unsigned char*)(0x4270E028UL))
#define bFM4_MFS7_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270E02CUL))
#define bFM4_MFS7_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x4270E030UL))
#define bFM4_MFS7_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x4270E034UL))
#define bFM4_MFS7_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x4270E038UL))
#define bFM4_MFS7_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x4270E038UL))
#define bFM4_MFS7_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270E03CUL))
#define bFM4_MFS7_I2C_IBSR_BB                  *((volatile unsigned char*)(0x4270E080UL))
#define bFM4_MFS7_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x4270E084UL))
#define bFM4_MFS7_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x4270E088UL))
#define bFM4_MFS7_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270E08CUL))
#define bFM4_MFS7_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x4270E090UL))
#define bFM4_MFS7_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x4270E094UL))
#define bFM4_MFS7_I2C_IBSR_RACK                *((volatile unsigned char*)(0x4270E098UL))
#define bFM4_MFS7_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270E09CUL))
#define bFM4_MFS7_I2C_SSR_TBI                  *((volatile unsigned char*)(0x4270E0A0UL))
#define bFM4_MFS7_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x4270E0A4UL))
#define bFM4_MFS7_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x4270E0A8UL))
#define bFM4_MFS7_I2C_SSR_ORE                  *((volatile unsigned char*)(0x4270E0ACUL))
#define bFM4_MFS7_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x4270E0B0UL))
#define bFM4_MFS7_I2C_SSR_DMA                  *((volatile unsigned char*)(0x4270E0B4UL))
#define bFM4_MFS7_I2C_SSR_TSET                 *((volatile unsigned char*)(0x4270E0B8UL))
#define bFM4_MFS7_I2C_SSR_REC                  *((volatile unsigned char*)(0x4270E0BCUL))
#define bFM4_MFS7_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x4270E200UL))
#define bFM4_MFS7_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x4270E204UL))
#define bFM4_MFS7_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x4270E208UL))
#define bFM4_MFS7_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270E20CUL))
#define bFM4_MFS7_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x4270E210UL))
#define bFM4_MFS7_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x4270E214UL))
#define bFM4_MFS7_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x4270E218UL))
#define bFM4_MFS7_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270E21CUL))
#define bFM4_MFS7_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x4270E220UL))
#define bFM4_MFS7_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x4270E224UL))
#define bFM4_MFS7_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x4270E228UL))
#define bFM4_MFS7_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270E22CUL))
#define bFM4_MFS7_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x4270E230UL))
#define bFM4_MFS7_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x4270E234UL))
#define bFM4_MFS7_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x4270E238UL))
#define bFM4_MFS7_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270E23CUL))
#define bFM4_MFS7_I2C_FCR_FE1                  *((volatile unsigned char*)(0x4270E280UL))
#define bFM4_MFS7_I2C_FCR_FE2                  *((volatile unsigned char*)(0x4270E284UL))
#define bFM4_MFS7_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x4270E288UL))
#define bFM4_MFS7_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270E28CUL))
#define bFM4_MFS7_I2C_FCR_FSET                 *((volatile unsigned char*)(0x4270E290UL))
#define bFM4_MFS7_I2C_FCR_FLD                  *((volatile unsigned char*)(0x4270E294UL))
#define bFM4_MFS7_I2C_FCR_FLST                 *((volatile unsigned char*)(0x4270E298UL))
#define bFM4_MFS7_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM4_MFS7_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM4_MFS7_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM4_MFS7_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM4_MFS7_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM4_MFS7_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x4270E280UL))
#define bFM4_MFS7_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x4270E284UL))
#define bFM4_MFS7_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x4270E288UL))
#define bFM4_MFS7_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270E28CUL))
#define bFM4_MFS7_I2C_FCR0_FSET                *((volatile unsigned char*)(0x4270E290UL))
#define bFM4_MFS7_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x4270E294UL))
#define bFM4_MFS7_I2C_FCR0_FLST                *((volatile unsigned char*)(0x4270E298UL))
#define bFM4_MFS7_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM4_MFS7_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM4_MFS7_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM4_MFS7_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM4_MFS7_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM4_MFS7_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x4270E300UL))
#define bFM4_MFS7_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x4270E304UL))
#define bFM4_MFS7_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x4270E308UL))
#define bFM4_MFS7_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270E30CUL))
#define bFM4_MFS7_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x4270E310UL))
#define bFM4_MFS7_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x4270E314UL))
#define bFM4_MFS7_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x4270E318UL))
#define bFM4_MFS7_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270E31CUL))
#define bFM4_MFS7_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x4270E320UL))
#define bFM4_MFS7_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x4270E324UL))
#define bFM4_MFS7_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x4270E328UL))
#define bFM4_MFS7_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270E32CUL))
#define bFM4_MFS7_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x4270E330UL))
#define bFM4_MFS7_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x4270E334UL))
#define bFM4_MFS7_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x4270E338UL))
#define bFM4_MFS7_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270E33CUL))
#define bFM4_MFS7_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x4270E300UL))
#define bFM4_MFS7_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x4270E304UL))
#define bFM4_MFS7_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x4270E308UL))
#define bFM4_MFS7_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270E30CUL))
#define bFM4_MFS7_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x4270E310UL))
#define bFM4_MFS7_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x4270E314UL))
#define bFM4_MFS7_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x4270E318UL))
#define bFM4_MFS7_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270E31CUL))
#define bFM4_MFS7_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x4270E320UL))
#define bFM4_MFS7_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x4270E324UL))
#define bFM4_MFS7_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x4270E328UL))
#define bFM4_MFS7_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270E32CUL))
#define bFM4_MFS7_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x4270E330UL))
#define bFM4_MFS7_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x4270E334UL))
#define bFM4_MFS7_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x4270E338UL))
#define bFM4_MFS7_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270E33CUL))

/* MFS UART channel 8 registers */
#define bFM4_MFS8_UART_SMR_SOE                 *((volatile unsigned char*)(0x42710000UL))
#define bFM4_MFS8_UART_SMR_BDS                 *((volatile unsigned char*)(0x42710008UL))
#define bFM4_MFS8_UART_SMR_SBL                 *((volatile unsigned char*)(0x4271000CUL))
#define bFM4_MFS8_UART_SMR_WUCR                *((volatile unsigned char*)(0x42710010UL))
#define bFM4_MFS8_UART_SMR_MD0                 *((volatile unsigned char*)(0x42710014UL))
#define bFM4_MFS8_UART_SMR_MD1                 *((volatile unsigned char*)(0x42710018UL))
#define bFM4_MFS8_UART_SMR_MD2                 *((volatile unsigned char*)(0x4271001CUL))
#define bFM4_MFS8_UART_SCR_TXE                 *((volatile unsigned char*)(0x42710020UL))
#define bFM4_MFS8_UART_SCR_RXE                 *((volatile unsigned char*)(0x42710024UL))
#define bFM4_MFS8_UART_SCR_TBIE                *((volatile unsigned char*)(0x42710028UL))
#define bFM4_MFS8_UART_SCR_TIE                 *((volatile unsigned char*)(0x4271002CUL))
#define bFM4_MFS8_UART_SCR_RIE                 *((volatile unsigned char*)(0x42710030UL))
#define bFM4_MFS8_UART_SCR_UPCL                *((volatile unsigned char*)(0x4271003CUL))
#define bFM4_MFS8_UART_ESCR_L0                 *((volatile unsigned char*)(0x42710080UL))
#define bFM4_MFS8_UART_ESCR_L1                 *((volatile unsigned char*)(0x42710084UL))
#define bFM4_MFS8_UART_ESCR_L2                 *((volatile unsigned char*)(0x42710088UL))
#define bFM4_MFS8_UART_ESCR_P                  *((volatile unsigned char*)(0x4271008CUL))
#define bFM4_MFS8_UART_ESCR_PEN                *((volatile unsigned char*)(0x42710090UL))
#define bFM4_MFS8_UART_ESCR_INV                *((volatile unsigned char*)(0x42710094UL))
#define bFM4_MFS8_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42710098UL))
#define bFM4_MFS8_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4271009CUL))
#define bFM4_MFS8_UART_SSR_TBI                 *((volatile unsigned char*)(0x427100A0UL))
#define bFM4_MFS8_UART_SSR_TDRE                *((volatile unsigned char*)(0x427100A4UL))
#define bFM4_MFS8_UART_SSR_RDRF                *((volatile unsigned char*)(0x427100A8UL))
#define bFM4_MFS8_UART_SSR_ORE                 *((volatile unsigned char*)(0x427100ACUL))
#define bFM4_MFS8_UART_SSR_FRE                 *((volatile unsigned char*)(0x427100B0UL))
#define bFM4_MFS8_UART_SSR_PE                  *((volatile unsigned char*)(0x427100B4UL))
#define bFM4_MFS8_UART_SSR_REC                 *((volatile unsigned char*)(0x427100BCUL))
#define bFM4_MFS8_UART_BGR_EXT                 *((volatile unsigned char*)(0x427101BCUL))
#define bFM4_MFS8_UART_BGR1_EXT                *((volatile unsigned char*)(0x427101BCUL))
#define bFM4_MFS8_UART_FCR_FE1                 *((volatile unsigned char*)(0x42710280UL))
#define bFM4_MFS8_UART_FCR_FE2                 *((volatile unsigned char*)(0x42710284UL))
#define bFM4_MFS8_UART_FCR_FCL1                *((volatile unsigned char*)(0x42710288UL))
#define bFM4_MFS8_UART_FCR_FCL2                *((volatile unsigned char*)(0x4271028CUL))
#define bFM4_MFS8_UART_FCR_FSET                *((volatile unsigned char*)(0x42710290UL))
#define bFM4_MFS8_UART_FCR_FLD                 *((volatile unsigned char*)(0x42710294UL))
#define bFM4_MFS8_UART_FCR_FLST                *((volatile unsigned char*)(0x42710298UL))
#define bFM4_MFS8_UART_FCR_FSEL                *((volatile unsigned char*)(0x427102A0UL))
#define bFM4_MFS8_UART_FCR_FTIE                *((volatile unsigned char*)(0x427102A4UL))
#define bFM4_MFS8_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427102A8UL))
#define bFM4_MFS8_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427102ACUL))
#define bFM4_MFS8_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427102B0UL))
#define bFM4_MFS8_UART_FCR0_FE1                *((volatile unsigned char*)(0x42710280UL))
#define bFM4_MFS8_UART_FCR0_FE2                *((volatile unsigned char*)(0x42710284UL))
#define bFM4_MFS8_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42710288UL))
#define bFM4_MFS8_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4271028CUL))
#define bFM4_MFS8_UART_FCR0_FSET               *((volatile unsigned char*)(0x42710290UL))
#define bFM4_MFS8_UART_FCR0_FLD                *((volatile unsigned char*)(0x42710294UL))
#define bFM4_MFS8_UART_FCR0_FLST               *((volatile unsigned char*)(0x42710298UL))
#define bFM4_MFS8_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427102A0UL))
#define bFM4_MFS8_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427102A4UL))
#define bFM4_MFS8_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427102A8UL))
#define bFM4_MFS8_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427102ACUL))
#define bFM4_MFS8_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427102B0UL))
#define bFM4_MFS8_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42710300UL))
#define bFM4_MFS8_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42710304UL))
#define bFM4_MFS8_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42710308UL))
#define bFM4_MFS8_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4271030CUL))
#define bFM4_MFS8_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42710310UL))
#define bFM4_MFS8_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42710314UL))
#define bFM4_MFS8_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42710318UL))
#define bFM4_MFS8_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4271031CUL))
#define bFM4_MFS8_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42710320UL))
#define bFM4_MFS8_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42710324UL))
#define bFM4_MFS8_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42710328UL))
#define bFM4_MFS8_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4271032CUL))
#define bFM4_MFS8_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42710330UL))
#define bFM4_MFS8_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42710334UL))
#define bFM4_MFS8_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42710338UL))
#define bFM4_MFS8_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4271033CUL))
#define bFM4_MFS8_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42710300UL))
#define bFM4_MFS8_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42710304UL))
#define bFM4_MFS8_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42710308UL))
#define bFM4_MFS8_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4271030CUL))
#define bFM4_MFS8_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42710310UL))
#define bFM4_MFS8_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42710314UL))
#define bFM4_MFS8_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42710318UL))
#define bFM4_MFS8_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4271031CUL))
#define bFM4_MFS8_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42710320UL))
#define bFM4_MFS8_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42710324UL))
#define bFM4_MFS8_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42710328UL))
#define bFM4_MFS8_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4271032CUL))
#define bFM4_MFS8_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42710330UL))
#define bFM4_MFS8_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42710334UL))
#define bFM4_MFS8_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42710338UL))
#define bFM4_MFS8_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4271033CUL))

/* MFS CSIO channel 8 registers */
#define bFM4_MFS8_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42710000UL))
#define bFM4_MFS8_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42710004UL))
#define bFM4_MFS8_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42710008UL))
#define bFM4_MFS8_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4271000CUL))
#define bFM4_MFS8_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42710014UL))
#define bFM4_MFS8_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42710018UL))
#define bFM4_MFS8_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4271001CUL))
#define bFM4_MFS8_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42710020UL))
#define bFM4_MFS8_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42710024UL))
#define bFM4_MFS8_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42710028UL))
#define bFM4_MFS8_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4271002CUL))
#define bFM4_MFS8_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42710030UL))
#define bFM4_MFS8_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42710034UL))
#define bFM4_MFS8_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42710038UL))
#define bFM4_MFS8_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4271003CUL))
#define bFM4_MFS8_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42710080UL))
#define bFM4_MFS8_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42710084UL))
#define bFM4_MFS8_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42710088UL))
#define bFM4_MFS8_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4271008CUL))
#define bFM4_MFS8_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42710090UL))
#define bFM4_MFS8_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42710094UL))
#define bFM4_MFS8_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42710098UL))
#define bFM4_MFS8_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4271009CUL))
#define bFM4_MFS8_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427100A0UL))
#define bFM4_MFS8_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427100A4UL))
#define bFM4_MFS8_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427100A8UL))
#define bFM4_MFS8_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427100ACUL))
#define bFM4_MFS8_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427100B0UL))
#define bFM4_MFS8_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427100BCUL))
#define bFM4_MFS8_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42710280UL))
#define bFM4_MFS8_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42710284UL))
#define bFM4_MFS8_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42710288UL))
#define bFM4_MFS8_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4271028CUL))
#define bFM4_MFS8_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42710290UL))
#define bFM4_MFS8_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42710294UL))
#define bFM4_MFS8_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42710298UL))
#define bFM4_MFS8_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427102A0UL))
#define bFM4_MFS8_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427102A4UL))
#define bFM4_MFS8_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427102A8UL))
#define bFM4_MFS8_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427102ACUL))
#define bFM4_MFS8_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427102B0UL))
#define bFM4_MFS8_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42710280UL))
#define bFM4_MFS8_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42710284UL))
#define bFM4_MFS8_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42710288UL))
#define bFM4_MFS8_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4271028CUL))
#define bFM4_MFS8_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42710290UL))
#define bFM4_MFS8_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42710294UL))
#define bFM4_MFS8_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42710298UL))
#define bFM4_MFS8_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427102A0UL))
#define bFM4_MFS8_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427102A4UL))
#define bFM4_MFS8_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427102A8UL))
#define bFM4_MFS8_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427102ACUL))
#define bFM4_MFS8_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427102B0UL))
#define bFM4_MFS8_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42710300UL))
#define bFM4_MFS8_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42710304UL))
#define bFM4_MFS8_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42710308UL))
#define bFM4_MFS8_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4271030CUL))
#define bFM4_MFS8_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42710310UL))
#define bFM4_MFS8_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42710314UL))
#define bFM4_MFS8_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42710318UL))
#define bFM4_MFS8_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4271031CUL))
#define bFM4_MFS8_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42710320UL))
#define bFM4_MFS8_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42710324UL))
#define bFM4_MFS8_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42710328UL))
#define bFM4_MFS8_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4271032CUL))
#define bFM4_MFS8_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42710330UL))
#define bFM4_MFS8_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42710334UL))
#define bFM4_MFS8_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42710338UL))
#define bFM4_MFS8_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4271033CUL))
#define bFM4_MFS8_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42710300UL))
#define bFM4_MFS8_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42710304UL))
#define bFM4_MFS8_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42710308UL))
#define bFM4_MFS8_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4271030CUL))
#define bFM4_MFS8_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42710310UL))
#define bFM4_MFS8_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42710314UL))
#define bFM4_MFS8_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42710318UL))
#define bFM4_MFS8_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4271031CUL))
#define bFM4_MFS8_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42710320UL))
#define bFM4_MFS8_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42710324UL))
#define bFM4_MFS8_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42710328UL))
#define bFM4_MFS8_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4271032CUL))
#define bFM4_MFS8_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42710330UL))
#define bFM4_MFS8_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42710334UL))
#define bFM4_MFS8_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42710338UL))
#define bFM4_MFS8_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4271033CUL))
#define bFM4_MFS8_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42710380UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42710384UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42710388UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4271038CUL))
#define bFM4_MFS8_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42710390UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42710394UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42710398UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4271039CUL))
#define bFM4_MFS8_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427103A0UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427103A4UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427103A8UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427103ACUL))
#define bFM4_MFS8_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427103B0UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427103B4UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427103B8UL))
#define bFM4_MFS8_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427103BCUL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42710400UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42710404UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42710408UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4271040CUL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42710410UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42710414UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42710418UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4271041CUL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42710420UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42710424UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42710428UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4271042CUL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42710430UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42710434UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42710438UL))
#define bFM4_MFS8_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4271043CUL))
#define bFM4_MFS8_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42710480UL))
#define bFM4_MFS8_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42710484UL))
#define bFM4_MFS8_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42710488UL))
#define bFM4_MFS8_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4271048CUL))
#define bFM4_MFS8_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42710490UL))
#define bFM4_MFS8_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42710498UL))
#define bFM4_MFS8_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4271049CUL))
#define bFM4_MFS8_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427104A0UL))
#define bFM4_MFS8_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427104ACUL))
#define bFM4_MFS8_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427104B0UL))
#define bFM4_MFS8_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427104B4UL))
#define bFM4_MFS8_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42710500UL))
#define bFM4_MFS8_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42710504UL))
#define bFM4_MFS8_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42710508UL))
#define bFM4_MFS8_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4271050CUL))
#define bFM4_MFS8_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42710510UL))
#define bFM4_MFS8_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42710514UL))
#define bFM4_MFS8_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42710518UL))
#define bFM4_MFS8_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4271051CUL))
#define bFM4_MFS8_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42710520UL))
#define bFM4_MFS8_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42710524UL))
#define bFM4_MFS8_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42710528UL))
#define bFM4_MFS8_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4271052CUL))
#define bFM4_MFS8_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42710530UL))
#define bFM4_MFS8_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42710534UL))
#define bFM4_MFS8_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42710538UL))
#define bFM4_MFS8_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4271053CUL))
#define bFM4_MFS8_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42710580UL))
#define bFM4_MFS8_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42710584UL))
#define bFM4_MFS8_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42710588UL))
#define bFM4_MFS8_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4271058CUL))
#define bFM4_MFS8_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42710590UL))
#define bFM4_MFS8_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42710594UL))
#define bFM4_MFS8_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42710598UL))
#define bFM4_MFS8_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4271059CUL))
#define bFM4_MFS8_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427105A0UL))
#define bFM4_MFS8_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427105A4UL))
#define bFM4_MFS8_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427105A8UL))
#define bFM4_MFS8_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427105ACUL))
#define bFM4_MFS8_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427105B0UL))
#define bFM4_MFS8_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427105B4UL))
#define bFM4_MFS8_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427105B8UL))
#define bFM4_MFS8_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427105BCUL))
#define bFM4_MFS8_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42710600UL))
#define bFM4_MFS8_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42710604UL))
#define bFM4_MFS8_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42710608UL))
#define bFM4_MFS8_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4271060CUL))
#define bFM4_MFS8_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42710610UL))
#define bFM4_MFS8_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42710614UL))
#define bFM4_MFS8_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42710618UL))
#define bFM4_MFS8_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4271061CUL))
#define bFM4_MFS8_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42710620UL))
#define bFM4_MFS8_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42710624UL))
#define bFM4_MFS8_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42710628UL))
#define bFM4_MFS8_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4271062CUL))
#define bFM4_MFS8_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42710630UL))
#define bFM4_MFS8_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42710634UL))
#define bFM4_MFS8_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42710638UL))
#define bFM4_MFS8_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4271063CUL))
#define bFM4_MFS8_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42710680UL))
#define bFM4_MFS8_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42710684UL))
#define bFM4_MFS8_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42710688UL))
#define bFM4_MFS8_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4271068CUL))
#define bFM4_MFS8_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42710690UL))
#define bFM4_MFS8_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42710694UL))
#define bFM4_MFS8_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42710698UL))
#define bFM4_MFS8_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4271069CUL))
#define bFM4_MFS8_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427106A0UL))
#define bFM4_MFS8_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427106A4UL))
#define bFM4_MFS8_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427106A8UL))
#define bFM4_MFS8_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427106ACUL))
#define bFM4_MFS8_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427106B0UL))
#define bFM4_MFS8_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427106B4UL))
#define bFM4_MFS8_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427106B8UL))
#define bFM4_MFS8_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427106BCUL))
#define bFM4_MFS8_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42710700UL))
#define bFM4_MFS8_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42710704UL))
#define bFM4_MFS8_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42710708UL))
#define bFM4_MFS8_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4271070CUL))
#define bFM4_MFS8_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42710710UL))
#define bFM4_MFS8_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42710714UL))
#define bFM4_MFS8_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42710718UL))
#define bFM4_MFS8_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4271071CUL))

/* MFS LIN channel 8 registers */
#define bFM4_MFS8_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42710000UL))
#define bFM4_MFS8_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4271000CUL))
#define bFM4_MFS8_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42710010UL))
#define bFM4_MFS8_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42710014UL))
#define bFM4_MFS8_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42710018UL))
#define bFM4_MFS8_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4271001CUL))
#define bFM4_MFS8_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42710020UL))
#define bFM4_MFS8_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42710024UL))
#define bFM4_MFS8_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42710028UL))
#define bFM4_MFS8_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4271002CUL))
#define bFM4_MFS8_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42710030UL))
#define bFM4_MFS8_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42710034UL))
#define bFM4_MFS8_LIN_SCR_MS                   *((volatile unsigned char*)(0x42710038UL))
#define bFM4_MFS8_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4271003CUL))
#define bFM4_MFS8_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42710080UL))
#define bFM4_MFS8_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42710084UL))
#define bFM4_MFS8_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42710088UL))
#define bFM4_MFS8_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4271008CUL))
#define bFM4_MFS8_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42710090UL))
#define bFM4_MFS8_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42710098UL))
#define bFM4_MFS8_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427100A0UL))
#define bFM4_MFS8_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427100A4UL))
#define bFM4_MFS8_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427100A8UL))
#define bFM4_MFS8_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427100ACUL))
#define bFM4_MFS8_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427100B0UL))
#define bFM4_MFS8_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427100B4UL))
#define bFM4_MFS8_LIN_SSR_REC                  *((volatile unsigned char*)(0x427100BCUL))
#define bFM4_MFS8_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427101BCUL))
#define bFM4_MFS8_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427101BCUL))
#define bFM4_MFS8_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42710280UL))
#define bFM4_MFS8_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42710284UL))
#define bFM4_MFS8_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42710288UL))
#define bFM4_MFS8_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4271028CUL))
#define bFM4_MFS8_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42710290UL))
#define bFM4_MFS8_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42710294UL))
#define bFM4_MFS8_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42710298UL))
#define bFM4_MFS8_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427102A0UL))
#define bFM4_MFS8_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427102A4UL))
#define bFM4_MFS8_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427102A8UL))
#define bFM4_MFS8_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427102ACUL))
#define bFM4_MFS8_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427102B0UL))
#define bFM4_MFS8_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42710280UL))
#define bFM4_MFS8_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42710284UL))
#define bFM4_MFS8_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42710288UL))
#define bFM4_MFS8_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4271028CUL))
#define bFM4_MFS8_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42710290UL))
#define bFM4_MFS8_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42710294UL))
#define bFM4_MFS8_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42710298UL))
#define bFM4_MFS8_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427102A0UL))
#define bFM4_MFS8_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427102A4UL))
#define bFM4_MFS8_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427102A8UL))
#define bFM4_MFS8_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427102ACUL))
#define bFM4_MFS8_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427102B0UL))
#define bFM4_MFS8_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42710300UL))
#define bFM4_MFS8_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42710304UL))
#define bFM4_MFS8_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42710308UL))
#define bFM4_MFS8_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4271030CUL))
#define bFM4_MFS8_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42710310UL))
#define bFM4_MFS8_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42710314UL))
#define bFM4_MFS8_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42710318UL))
#define bFM4_MFS8_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4271031CUL))
#define bFM4_MFS8_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42710320UL))
#define bFM4_MFS8_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42710324UL))
#define bFM4_MFS8_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42710328UL))
#define bFM4_MFS8_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4271032CUL))
#define bFM4_MFS8_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42710330UL))
#define bFM4_MFS8_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42710334UL))
#define bFM4_MFS8_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42710338UL))
#define bFM4_MFS8_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4271033CUL))
#define bFM4_MFS8_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42710300UL))
#define bFM4_MFS8_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42710304UL))
#define bFM4_MFS8_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42710308UL))
#define bFM4_MFS8_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4271030CUL))
#define bFM4_MFS8_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42710310UL))
#define bFM4_MFS8_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42710314UL))
#define bFM4_MFS8_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42710318UL))
#define bFM4_MFS8_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4271031CUL))
#define bFM4_MFS8_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42710320UL))
#define bFM4_MFS8_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42710324UL))
#define bFM4_MFS8_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42710328UL))
#define bFM4_MFS8_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4271032CUL))
#define bFM4_MFS8_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42710330UL))
#define bFM4_MFS8_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42710334UL))
#define bFM4_MFS8_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42710338UL))
#define bFM4_MFS8_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4271033CUL))

/* MFS I2C channel 8 registers */
#define bFM4_MFS8_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42710008UL))
#define bFM4_MFS8_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4271000CUL))
#define bFM4_MFS8_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42710014UL))
#define bFM4_MFS8_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42710018UL))
#define bFM4_MFS8_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4271001CUL))
#define bFM4_MFS8_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42710020UL))
#define bFM4_MFS8_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42710024UL))
#define bFM4_MFS8_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42710028UL))
#define bFM4_MFS8_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4271002CUL))
#define bFM4_MFS8_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42710030UL))
#define bFM4_MFS8_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42710034UL))
#define bFM4_MFS8_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42710038UL))
#define bFM4_MFS8_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42710038UL))
#define bFM4_MFS8_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4271003CUL))
#define bFM4_MFS8_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42710080UL))
#define bFM4_MFS8_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42710084UL))
#define bFM4_MFS8_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42710088UL))
#define bFM4_MFS8_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4271008CUL))
#define bFM4_MFS8_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42710090UL))
#define bFM4_MFS8_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42710094UL))
#define bFM4_MFS8_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42710098UL))
#define bFM4_MFS8_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4271009CUL))
#define bFM4_MFS8_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427100A0UL))
#define bFM4_MFS8_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427100A4UL))
#define bFM4_MFS8_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427100A8UL))
#define bFM4_MFS8_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427100ACUL))
#define bFM4_MFS8_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427100B0UL))
#define bFM4_MFS8_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427100B4UL))
#define bFM4_MFS8_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427100B8UL))
#define bFM4_MFS8_I2C_SSR_REC                  *((volatile unsigned char*)(0x427100BCUL))
#define bFM4_MFS8_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42710200UL))
#define bFM4_MFS8_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42710204UL))
#define bFM4_MFS8_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42710208UL))
#define bFM4_MFS8_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4271020CUL))
#define bFM4_MFS8_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42710210UL))
#define bFM4_MFS8_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42710214UL))
#define bFM4_MFS8_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42710218UL))
#define bFM4_MFS8_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4271021CUL))
#define bFM4_MFS8_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42710220UL))
#define bFM4_MFS8_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42710224UL))
#define bFM4_MFS8_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42710228UL))
#define bFM4_MFS8_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4271022CUL))
#define bFM4_MFS8_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42710230UL))
#define bFM4_MFS8_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42710234UL))
#define bFM4_MFS8_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42710238UL))
#define bFM4_MFS8_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4271023CUL))
#define bFM4_MFS8_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42710280UL))
#define bFM4_MFS8_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42710284UL))
#define bFM4_MFS8_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42710288UL))
#define bFM4_MFS8_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4271028CUL))
#define bFM4_MFS8_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42710290UL))
#define bFM4_MFS8_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42710294UL))
#define bFM4_MFS8_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42710298UL))
#define bFM4_MFS8_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427102A0UL))
#define bFM4_MFS8_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427102A4UL))
#define bFM4_MFS8_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427102A8UL))
#define bFM4_MFS8_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427102ACUL))
#define bFM4_MFS8_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427102B0UL))
#define bFM4_MFS8_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42710280UL))
#define bFM4_MFS8_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42710284UL))
#define bFM4_MFS8_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42710288UL))
#define bFM4_MFS8_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4271028CUL))
#define bFM4_MFS8_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42710290UL))
#define bFM4_MFS8_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42710294UL))
#define bFM4_MFS8_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42710298UL))
#define bFM4_MFS8_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427102A0UL))
#define bFM4_MFS8_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427102A4UL))
#define bFM4_MFS8_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427102A8UL))
#define bFM4_MFS8_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427102ACUL))
#define bFM4_MFS8_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427102B0UL))
#define bFM4_MFS8_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42710300UL))
#define bFM4_MFS8_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42710304UL))
#define bFM4_MFS8_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42710308UL))
#define bFM4_MFS8_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4271030CUL))
#define bFM4_MFS8_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42710310UL))
#define bFM4_MFS8_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42710314UL))
#define bFM4_MFS8_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42710318UL))
#define bFM4_MFS8_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4271031CUL))
#define bFM4_MFS8_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42710320UL))
#define bFM4_MFS8_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42710324UL))
#define bFM4_MFS8_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42710328UL))
#define bFM4_MFS8_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4271032CUL))
#define bFM4_MFS8_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42710330UL))
#define bFM4_MFS8_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42710334UL))
#define bFM4_MFS8_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42710338UL))
#define bFM4_MFS8_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4271033CUL))
#define bFM4_MFS8_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42710300UL))
#define bFM4_MFS8_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42710304UL))
#define bFM4_MFS8_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42710308UL))
#define bFM4_MFS8_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4271030CUL))
#define bFM4_MFS8_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42710310UL))
#define bFM4_MFS8_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42710314UL))
#define bFM4_MFS8_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42710318UL))
#define bFM4_MFS8_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4271031CUL))
#define bFM4_MFS8_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42710320UL))
#define bFM4_MFS8_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42710324UL))
#define bFM4_MFS8_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42710328UL))
#define bFM4_MFS8_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4271032CUL))
#define bFM4_MFS8_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42710330UL))
#define bFM4_MFS8_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42710334UL))
#define bFM4_MFS8_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42710338UL))
#define bFM4_MFS8_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4271033CUL))

/* MFS UART channel 9 registers */
#define bFM4_MFS9_UART_SMR_SOE                 *((volatile unsigned char*)(0x42712000UL))
#define bFM4_MFS9_UART_SMR_BDS                 *((volatile unsigned char*)(0x42712008UL))
#define bFM4_MFS9_UART_SMR_SBL                 *((volatile unsigned char*)(0x4271200CUL))
#define bFM4_MFS9_UART_SMR_WUCR                *((volatile unsigned char*)(0x42712010UL))
#define bFM4_MFS9_UART_SMR_MD0                 *((volatile unsigned char*)(0x42712014UL))
#define bFM4_MFS9_UART_SMR_MD1                 *((volatile unsigned char*)(0x42712018UL))
#define bFM4_MFS9_UART_SMR_MD2                 *((volatile unsigned char*)(0x4271201CUL))
#define bFM4_MFS9_UART_SCR_TXE                 *((volatile unsigned char*)(0x42712020UL))
#define bFM4_MFS9_UART_SCR_RXE                 *((volatile unsigned char*)(0x42712024UL))
#define bFM4_MFS9_UART_SCR_TBIE                *((volatile unsigned char*)(0x42712028UL))
#define bFM4_MFS9_UART_SCR_TIE                 *((volatile unsigned char*)(0x4271202CUL))
#define bFM4_MFS9_UART_SCR_RIE                 *((volatile unsigned char*)(0x42712030UL))
#define bFM4_MFS9_UART_SCR_UPCL                *((volatile unsigned char*)(0x4271203CUL))
#define bFM4_MFS9_UART_ESCR_L0                 *((volatile unsigned char*)(0x42712080UL))
#define bFM4_MFS9_UART_ESCR_L1                 *((volatile unsigned char*)(0x42712084UL))
#define bFM4_MFS9_UART_ESCR_L2                 *((volatile unsigned char*)(0x42712088UL))
#define bFM4_MFS9_UART_ESCR_P                  *((volatile unsigned char*)(0x4271208CUL))
#define bFM4_MFS9_UART_ESCR_PEN                *((volatile unsigned char*)(0x42712090UL))
#define bFM4_MFS9_UART_ESCR_INV                *((volatile unsigned char*)(0x42712094UL))
#define bFM4_MFS9_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42712098UL))
#define bFM4_MFS9_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4271209CUL))
#define bFM4_MFS9_UART_SSR_TBI                 *((volatile unsigned char*)(0x427120A0UL))
#define bFM4_MFS9_UART_SSR_TDRE                *((volatile unsigned char*)(0x427120A4UL))
#define bFM4_MFS9_UART_SSR_RDRF                *((volatile unsigned char*)(0x427120A8UL))
#define bFM4_MFS9_UART_SSR_ORE                 *((volatile unsigned char*)(0x427120ACUL))
#define bFM4_MFS9_UART_SSR_FRE                 *((volatile unsigned char*)(0x427120B0UL))
#define bFM4_MFS9_UART_SSR_PE                  *((volatile unsigned char*)(0x427120B4UL))
#define bFM4_MFS9_UART_SSR_REC                 *((volatile unsigned char*)(0x427120BCUL))
#define bFM4_MFS9_UART_BGR_EXT                 *((volatile unsigned char*)(0x427121BCUL))
#define bFM4_MFS9_UART_BGR1_EXT                *((volatile unsigned char*)(0x427121BCUL))
#define bFM4_MFS9_UART_FCR_FE1                 *((volatile unsigned char*)(0x42712280UL))
#define bFM4_MFS9_UART_FCR_FE2                 *((volatile unsigned char*)(0x42712284UL))
#define bFM4_MFS9_UART_FCR_FCL1                *((volatile unsigned char*)(0x42712288UL))
#define bFM4_MFS9_UART_FCR_FCL2                *((volatile unsigned char*)(0x4271228CUL))
#define bFM4_MFS9_UART_FCR_FSET                *((volatile unsigned char*)(0x42712290UL))
#define bFM4_MFS9_UART_FCR_FLD                 *((volatile unsigned char*)(0x42712294UL))
#define bFM4_MFS9_UART_FCR_FLST                *((volatile unsigned char*)(0x42712298UL))
#define bFM4_MFS9_UART_FCR_FSEL                *((volatile unsigned char*)(0x427122A0UL))
#define bFM4_MFS9_UART_FCR_FTIE                *((volatile unsigned char*)(0x427122A4UL))
#define bFM4_MFS9_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427122A8UL))
#define bFM4_MFS9_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427122ACUL))
#define bFM4_MFS9_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427122B0UL))
#define bFM4_MFS9_UART_FCR0_FE1                *((volatile unsigned char*)(0x42712280UL))
#define bFM4_MFS9_UART_FCR0_FE2                *((volatile unsigned char*)(0x42712284UL))
#define bFM4_MFS9_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42712288UL))
#define bFM4_MFS9_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4271228CUL))
#define bFM4_MFS9_UART_FCR0_FSET               *((volatile unsigned char*)(0x42712290UL))
#define bFM4_MFS9_UART_FCR0_FLD                *((volatile unsigned char*)(0x42712294UL))
#define bFM4_MFS9_UART_FCR0_FLST               *((volatile unsigned char*)(0x42712298UL))
#define bFM4_MFS9_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427122A0UL))
#define bFM4_MFS9_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427122A4UL))
#define bFM4_MFS9_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427122A8UL))
#define bFM4_MFS9_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427122ACUL))
#define bFM4_MFS9_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427122B0UL))
#define bFM4_MFS9_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42712300UL))
#define bFM4_MFS9_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42712304UL))
#define bFM4_MFS9_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42712308UL))
#define bFM4_MFS9_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4271230CUL))
#define bFM4_MFS9_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42712310UL))
#define bFM4_MFS9_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42712314UL))
#define bFM4_MFS9_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42712318UL))
#define bFM4_MFS9_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4271231CUL))
#define bFM4_MFS9_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42712320UL))
#define bFM4_MFS9_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42712324UL))
#define bFM4_MFS9_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42712328UL))
#define bFM4_MFS9_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4271232CUL))
#define bFM4_MFS9_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42712330UL))
#define bFM4_MFS9_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42712334UL))
#define bFM4_MFS9_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42712338UL))
#define bFM4_MFS9_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4271233CUL))
#define bFM4_MFS9_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42712300UL))
#define bFM4_MFS9_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42712304UL))
#define bFM4_MFS9_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42712308UL))
#define bFM4_MFS9_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4271230CUL))
#define bFM4_MFS9_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42712310UL))
#define bFM4_MFS9_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42712314UL))
#define bFM4_MFS9_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42712318UL))
#define bFM4_MFS9_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4271231CUL))
#define bFM4_MFS9_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42712320UL))
#define bFM4_MFS9_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42712324UL))
#define bFM4_MFS9_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42712328UL))
#define bFM4_MFS9_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4271232CUL))
#define bFM4_MFS9_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42712330UL))
#define bFM4_MFS9_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42712334UL))
#define bFM4_MFS9_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42712338UL))
#define bFM4_MFS9_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4271233CUL))

/* MFS CSIO channel 9 registers */
#define bFM4_MFS9_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42712000UL))
#define bFM4_MFS9_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42712004UL))
#define bFM4_MFS9_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42712008UL))
#define bFM4_MFS9_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4271200CUL))
#define bFM4_MFS9_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42712014UL))
#define bFM4_MFS9_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42712018UL))
#define bFM4_MFS9_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4271201CUL))
#define bFM4_MFS9_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42712020UL))
#define bFM4_MFS9_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42712024UL))
#define bFM4_MFS9_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42712028UL))
#define bFM4_MFS9_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4271202CUL))
#define bFM4_MFS9_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42712030UL))
#define bFM4_MFS9_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42712034UL))
#define bFM4_MFS9_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42712038UL))
#define bFM4_MFS9_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4271203CUL))
#define bFM4_MFS9_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42712080UL))
#define bFM4_MFS9_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42712084UL))
#define bFM4_MFS9_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42712088UL))
#define bFM4_MFS9_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4271208CUL))
#define bFM4_MFS9_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42712090UL))
#define bFM4_MFS9_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42712094UL))
#define bFM4_MFS9_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42712098UL))
#define bFM4_MFS9_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4271209CUL))
#define bFM4_MFS9_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427120A0UL))
#define bFM4_MFS9_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427120A4UL))
#define bFM4_MFS9_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427120A8UL))
#define bFM4_MFS9_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427120ACUL))
#define bFM4_MFS9_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427120B0UL))
#define bFM4_MFS9_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427120BCUL))
#define bFM4_MFS9_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42712280UL))
#define bFM4_MFS9_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42712284UL))
#define bFM4_MFS9_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42712288UL))
#define bFM4_MFS9_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4271228CUL))
#define bFM4_MFS9_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42712290UL))
#define bFM4_MFS9_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42712294UL))
#define bFM4_MFS9_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42712298UL))
#define bFM4_MFS9_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427122A0UL))
#define bFM4_MFS9_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427122A4UL))
#define bFM4_MFS9_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427122A8UL))
#define bFM4_MFS9_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427122ACUL))
#define bFM4_MFS9_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427122B0UL))
#define bFM4_MFS9_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42712280UL))
#define bFM4_MFS9_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42712284UL))
#define bFM4_MFS9_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42712288UL))
#define bFM4_MFS9_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4271228CUL))
#define bFM4_MFS9_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42712290UL))
#define bFM4_MFS9_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42712294UL))
#define bFM4_MFS9_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42712298UL))
#define bFM4_MFS9_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427122A0UL))
#define bFM4_MFS9_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427122A4UL))
#define bFM4_MFS9_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427122A8UL))
#define bFM4_MFS9_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427122ACUL))
#define bFM4_MFS9_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427122B0UL))
#define bFM4_MFS9_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42712300UL))
#define bFM4_MFS9_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42712304UL))
#define bFM4_MFS9_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42712308UL))
#define bFM4_MFS9_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4271230CUL))
#define bFM4_MFS9_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42712310UL))
#define bFM4_MFS9_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42712314UL))
#define bFM4_MFS9_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42712318UL))
#define bFM4_MFS9_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4271231CUL))
#define bFM4_MFS9_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42712320UL))
#define bFM4_MFS9_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42712324UL))
#define bFM4_MFS9_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42712328UL))
#define bFM4_MFS9_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4271232CUL))
#define bFM4_MFS9_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42712330UL))
#define bFM4_MFS9_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42712334UL))
#define bFM4_MFS9_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42712338UL))
#define bFM4_MFS9_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4271233CUL))
#define bFM4_MFS9_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42712300UL))
#define bFM4_MFS9_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42712304UL))
#define bFM4_MFS9_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42712308UL))
#define bFM4_MFS9_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4271230CUL))
#define bFM4_MFS9_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42712310UL))
#define bFM4_MFS9_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42712314UL))
#define bFM4_MFS9_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42712318UL))
#define bFM4_MFS9_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4271231CUL))
#define bFM4_MFS9_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42712320UL))
#define bFM4_MFS9_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42712324UL))
#define bFM4_MFS9_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42712328UL))
#define bFM4_MFS9_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4271232CUL))
#define bFM4_MFS9_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42712330UL))
#define bFM4_MFS9_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42712334UL))
#define bFM4_MFS9_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42712338UL))
#define bFM4_MFS9_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4271233CUL))
#define bFM4_MFS9_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42712380UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42712384UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42712388UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4271238CUL))
#define bFM4_MFS9_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42712390UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42712394UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42712398UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4271239CUL))
#define bFM4_MFS9_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427123A0UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427123A4UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427123A8UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427123ACUL))
#define bFM4_MFS9_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427123B0UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427123B4UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427123B8UL))
#define bFM4_MFS9_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427123BCUL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42712400UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42712404UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42712408UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4271240CUL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42712410UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42712414UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42712418UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4271241CUL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42712420UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42712424UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42712428UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4271242CUL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42712430UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42712434UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42712438UL))
#define bFM4_MFS9_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4271243CUL))
#define bFM4_MFS9_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42712480UL))
#define bFM4_MFS9_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42712484UL))
#define bFM4_MFS9_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42712488UL))
#define bFM4_MFS9_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4271248CUL))
#define bFM4_MFS9_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42712490UL))
#define bFM4_MFS9_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42712498UL))
#define bFM4_MFS9_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4271249CUL))
#define bFM4_MFS9_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427124A0UL))
#define bFM4_MFS9_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427124ACUL))
#define bFM4_MFS9_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427124B0UL))
#define bFM4_MFS9_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427124B4UL))
#define bFM4_MFS9_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42712500UL))
#define bFM4_MFS9_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42712504UL))
#define bFM4_MFS9_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42712508UL))
#define bFM4_MFS9_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4271250CUL))
#define bFM4_MFS9_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42712510UL))
#define bFM4_MFS9_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42712514UL))
#define bFM4_MFS9_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42712518UL))
#define bFM4_MFS9_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4271251CUL))
#define bFM4_MFS9_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42712520UL))
#define bFM4_MFS9_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42712524UL))
#define bFM4_MFS9_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42712528UL))
#define bFM4_MFS9_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4271252CUL))
#define bFM4_MFS9_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42712530UL))
#define bFM4_MFS9_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42712534UL))
#define bFM4_MFS9_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42712538UL))
#define bFM4_MFS9_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4271253CUL))
#define bFM4_MFS9_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42712580UL))
#define bFM4_MFS9_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42712584UL))
#define bFM4_MFS9_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42712588UL))
#define bFM4_MFS9_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4271258CUL))
#define bFM4_MFS9_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42712590UL))
#define bFM4_MFS9_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42712594UL))
#define bFM4_MFS9_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42712598UL))
#define bFM4_MFS9_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4271259CUL))
#define bFM4_MFS9_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427125A0UL))
#define bFM4_MFS9_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427125A4UL))
#define bFM4_MFS9_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427125A8UL))
#define bFM4_MFS9_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427125ACUL))
#define bFM4_MFS9_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427125B0UL))
#define bFM4_MFS9_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427125B4UL))
#define bFM4_MFS9_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427125B8UL))
#define bFM4_MFS9_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427125BCUL))
#define bFM4_MFS9_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42712600UL))
#define bFM4_MFS9_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42712604UL))
#define bFM4_MFS9_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42712608UL))
#define bFM4_MFS9_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4271260CUL))
#define bFM4_MFS9_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42712610UL))
#define bFM4_MFS9_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42712614UL))
#define bFM4_MFS9_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42712618UL))
#define bFM4_MFS9_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4271261CUL))
#define bFM4_MFS9_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42712620UL))
#define bFM4_MFS9_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42712624UL))
#define bFM4_MFS9_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42712628UL))
#define bFM4_MFS9_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4271262CUL))
#define bFM4_MFS9_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42712630UL))
#define bFM4_MFS9_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42712634UL))
#define bFM4_MFS9_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42712638UL))
#define bFM4_MFS9_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4271263CUL))
#define bFM4_MFS9_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42712680UL))
#define bFM4_MFS9_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42712684UL))
#define bFM4_MFS9_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42712688UL))
#define bFM4_MFS9_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4271268CUL))
#define bFM4_MFS9_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42712690UL))
#define bFM4_MFS9_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42712694UL))
#define bFM4_MFS9_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42712698UL))
#define bFM4_MFS9_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4271269CUL))
#define bFM4_MFS9_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427126A0UL))
#define bFM4_MFS9_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427126A4UL))
#define bFM4_MFS9_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427126A8UL))
#define bFM4_MFS9_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427126ACUL))
#define bFM4_MFS9_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427126B0UL))
#define bFM4_MFS9_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427126B4UL))
#define bFM4_MFS9_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427126B8UL))
#define bFM4_MFS9_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427126BCUL))
#define bFM4_MFS9_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42712700UL))
#define bFM4_MFS9_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42712704UL))
#define bFM4_MFS9_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42712708UL))
#define bFM4_MFS9_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4271270CUL))
#define bFM4_MFS9_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42712710UL))
#define bFM4_MFS9_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42712714UL))
#define bFM4_MFS9_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42712718UL))
#define bFM4_MFS9_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4271271CUL))

/* MFS LIN channel 9 registers */
#define bFM4_MFS9_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42712000UL))
#define bFM4_MFS9_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4271200CUL))
#define bFM4_MFS9_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42712010UL))
#define bFM4_MFS9_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42712014UL))
#define bFM4_MFS9_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42712018UL))
#define bFM4_MFS9_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4271201CUL))
#define bFM4_MFS9_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42712020UL))
#define bFM4_MFS9_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42712024UL))
#define bFM4_MFS9_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42712028UL))
#define bFM4_MFS9_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4271202CUL))
#define bFM4_MFS9_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42712030UL))
#define bFM4_MFS9_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42712034UL))
#define bFM4_MFS9_LIN_SCR_MS                   *((volatile unsigned char*)(0x42712038UL))
#define bFM4_MFS9_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4271203CUL))
#define bFM4_MFS9_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42712080UL))
#define bFM4_MFS9_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42712084UL))
#define bFM4_MFS9_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42712088UL))
#define bFM4_MFS9_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4271208CUL))
#define bFM4_MFS9_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42712090UL))
#define bFM4_MFS9_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42712098UL))
#define bFM4_MFS9_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427120A0UL))
#define bFM4_MFS9_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427120A4UL))
#define bFM4_MFS9_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427120A8UL))
#define bFM4_MFS9_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427120ACUL))
#define bFM4_MFS9_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427120B0UL))
#define bFM4_MFS9_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427120B4UL))
#define bFM4_MFS9_LIN_SSR_REC                  *((volatile unsigned char*)(0x427120BCUL))
#define bFM4_MFS9_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427121BCUL))
#define bFM4_MFS9_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427121BCUL))
#define bFM4_MFS9_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42712280UL))
#define bFM4_MFS9_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42712284UL))
#define bFM4_MFS9_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42712288UL))
#define bFM4_MFS9_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4271228CUL))
#define bFM4_MFS9_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42712290UL))
#define bFM4_MFS9_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42712294UL))
#define bFM4_MFS9_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42712298UL))
#define bFM4_MFS9_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427122A0UL))
#define bFM4_MFS9_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427122A4UL))
#define bFM4_MFS9_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427122A8UL))
#define bFM4_MFS9_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427122ACUL))
#define bFM4_MFS9_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427122B0UL))
#define bFM4_MFS9_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42712280UL))
#define bFM4_MFS9_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42712284UL))
#define bFM4_MFS9_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42712288UL))
#define bFM4_MFS9_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4271228CUL))
#define bFM4_MFS9_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42712290UL))
#define bFM4_MFS9_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42712294UL))
#define bFM4_MFS9_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42712298UL))
#define bFM4_MFS9_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427122A0UL))
#define bFM4_MFS9_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427122A4UL))
#define bFM4_MFS9_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427122A8UL))
#define bFM4_MFS9_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427122ACUL))
#define bFM4_MFS9_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427122B0UL))
#define bFM4_MFS9_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42712300UL))
#define bFM4_MFS9_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42712304UL))
#define bFM4_MFS9_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42712308UL))
#define bFM4_MFS9_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4271230CUL))
#define bFM4_MFS9_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42712310UL))
#define bFM4_MFS9_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42712314UL))
#define bFM4_MFS9_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42712318UL))
#define bFM4_MFS9_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4271231CUL))
#define bFM4_MFS9_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42712320UL))
#define bFM4_MFS9_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42712324UL))
#define bFM4_MFS9_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42712328UL))
#define bFM4_MFS9_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4271232CUL))
#define bFM4_MFS9_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42712330UL))
#define bFM4_MFS9_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42712334UL))
#define bFM4_MFS9_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42712338UL))
#define bFM4_MFS9_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4271233CUL))
#define bFM4_MFS9_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42712300UL))
#define bFM4_MFS9_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42712304UL))
#define bFM4_MFS9_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42712308UL))
#define bFM4_MFS9_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4271230CUL))
#define bFM4_MFS9_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42712310UL))
#define bFM4_MFS9_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42712314UL))
#define bFM4_MFS9_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42712318UL))
#define bFM4_MFS9_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4271231CUL))
#define bFM4_MFS9_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42712320UL))
#define bFM4_MFS9_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42712324UL))
#define bFM4_MFS9_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42712328UL))
#define bFM4_MFS9_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4271232CUL))
#define bFM4_MFS9_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42712330UL))
#define bFM4_MFS9_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42712334UL))
#define bFM4_MFS9_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42712338UL))
#define bFM4_MFS9_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4271233CUL))

/* MFS I2C channel 9 registers */
#define bFM4_MFS9_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42712008UL))
#define bFM4_MFS9_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4271200CUL))
#define bFM4_MFS9_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42712014UL))
#define bFM4_MFS9_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42712018UL))
#define bFM4_MFS9_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4271201CUL))
#define bFM4_MFS9_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42712020UL))
#define bFM4_MFS9_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42712024UL))
#define bFM4_MFS9_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42712028UL))
#define bFM4_MFS9_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4271202CUL))
#define bFM4_MFS9_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42712030UL))
#define bFM4_MFS9_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42712034UL))
#define bFM4_MFS9_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42712038UL))
#define bFM4_MFS9_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42712038UL))
#define bFM4_MFS9_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4271203CUL))
#define bFM4_MFS9_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42712080UL))
#define bFM4_MFS9_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42712084UL))
#define bFM4_MFS9_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42712088UL))
#define bFM4_MFS9_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4271208CUL))
#define bFM4_MFS9_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42712090UL))
#define bFM4_MFS9_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42712094UL))
#define bFM4_MFS9_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42712098UL))
#define bFM4_MFS9_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4271209CUL))
#define bFM4_MFS9_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427120A0UL))
#define bFM4_MFS9_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427120A4UL))
#define bFM4_MFS9_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427120A8UL))
#define bFM4_MFS9_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427120ACUL))
#define bFM4_MFS9_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427120B0UL))
#define bFM4_MFS9_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427120B4UL))
#define bFM4_MFS9_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427120B8UL))
#define bFM4_MFS9_I2C_SSR_REC                  *((volatile unsigned char*)(0x427120BCUL))
#define bFM4_MFS9_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42712200UL))
#define bFM4_MFS9_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42712204UL))
#define bFM4_MFS9_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42712208UL))
#define bFM4_MFS9_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4271220CUL))
#define bFM4_MFS9_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42712210UL))
#define bFM4_MFS9_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42712214UL))
#define bFM4_MFS9_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42712218UL))
#define bFM4_MFS9_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4271221CUL))
#define bFM4_MFS9_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42712220UL))
#define bFM4_MFS9_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42712224UL))
#define bFM4_MFS9_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42712228UL))
#define bFM4_MFS9_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4271222CUL))
#define bFM4_MFS9_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42712230UL))
#define bFM4_MFS9_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42712234UL))
#define bFM4_MFS9_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42712238UL))
#define bFM4_MFS9_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4271223CUL))
#define bFM4_MFS9_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42712280UL))
#define bFM4_MFS9_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42712284UL))
#define bFM4_MFS9_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42712288UL))
#define bFM4_MFS9_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4271228CUL))
#define bFM4_MFS9_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42712290UL))
#define bFM4_MFS9_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42712294UL))
#define bFM4_MFS9_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42712298UL))
#define bFM4_MFS9_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427122A0UL))
#define bFM4_MFS9_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427122A4UL))
#define bFM4_MFS9_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427122A8UL))
#define bFM4_MFS9_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427122ACUL))
#define bFM4_MFS9_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427122B0UL))
#define bFM4_MFS9_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42712280UL))
#define bFM4_MFS9_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42712284UL))
#define bFM4_MFS9_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42712288UL))
#define bFM4_MFS9_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4271228CUL))
#define bFM4_MFS9_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42712290UL))
#define bFM4_MFS9_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42712294UL))
#define bFM4_MFS9_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42712298UL))
#define bFM4_MFS9_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427122A0UL))
#define bFM4_MFS9_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427122A4UL))
#define bFM4_MFS9_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427122A8UL))
#define bFM4_MFS9_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427122ACUL))
#define bFM4_MFS9_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427122B0UL))
#define bFM4_MFS9_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42712300UL))
#define bFM4_MFS9_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42712304UL))
#define bFM4_MFS9_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42712308UL))
#define bFM4_MFS9_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4271230CUL))
#define bFM4_MFS9_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42712310UL))
#define bFM4_MFS9_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42712314UL))
#define bFM4_MFS9_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42712318UL))
#define bFM4_MFS9_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4271231CUL))
#define bFM4_MFS9_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42712320UL))
#define bFM4_MFS9_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42712324UL))
#define bFM4_MFS9_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42712328UL))
#define bFM4_MFS9_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4271232CUL))
#define bFM4_MFS9_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42712330UL))
#define bFM4_MFS9_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42712334UL))
#define bFM4_MFS9_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42712338UL))
#define bFM4_MFS9_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4271233CUL))
#define bFM4_MFS9_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42712300UL))
#define bFM4_MFS9_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42712304UL))
#define bFM4_MFS9_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42712308UL))
#define bFM4_MFS9_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4271230CUL))
#define bFM4_MFS9_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42712310UL))
#define bFM4_MFS9_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42712314UL))
#define bFM4_MFS9_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42712318UL))
#define bFM4_MFS9_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4271231CUL))
#define bFM4_MFS9_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42712320UL))
#define bFM4_MFS9_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42712324UL))
#define bFM4_MFS9_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42712328UL))
#define bFM4_MFS9_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4271232CUL))
#define bFM4_MFS9_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42712330UL))
#define bFM4_MFS9_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42712334UL))
#define bFM4_MFS9_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42712338UL))
#define bFM4_MFS9_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4271233CUL))

/* MFS UART channel 10 registers */
#define bFM4_MFS10_UART_SMR_SOE                *((volatile unsigned char*)(0x42714000UL))
#define bFM4_MFS10_UART_SMR_BDS                *((volatile unsigned char*)(0x42714008UL))
#define bFM4_MFS10_UART_SMR_SBL                *((volatile unsigned char*)(0x4271400CUL))
#define bFM4_MFS10_UART_SMR_WUCR               *((volatile unsigned char*)(0x42714010UL))
#define bFM4_MFS10_UART_SMR_MD0                *((volatile unsigned char*)(0x42714014UL))
#define bFM4_MFS10_UART_SMR_MD1                *((volatile unsigned char*)(0x42714018UL))
#define bFM4_MFS10_UART_SMR_MD2                *((volatile unsigned char*)(0x4271401CUL))
#define bFM4_MFS10_UART_SCR_TXE                *((volatile unsigned char*)(0x42714020UL))
#define bFM4_MFS10_UART_SCR_RXE                *((volatile unsigned char*)(0x42714024UL))
#define bFM4_MFS10_UART_SCR_TBIE               *((volatile unsigned char*)(0x42714028UL))
#define bFM4_MFS10_UART_SCR_TIE                *((volatile unsigned char*)(0x4271402CUL))
#define bFM4_MFS10_UART_SCR_RIE                *((volatile unsigned char*)(0x42714030UL))
#define bFM4_MFS10_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271403CUL))
#define bFM4_MFS10_UART_ESCR_L0                *((volatile unsigned char*)(0x42714080UL))
#define bFM4_MFS10_UART_ESCR_L1                *((volatile unsigned char*)(0x42714084UL))
#define bFM4_MFS10_UART_ESCR_L2                *((volatile unsigned char*)(0x42714088UL))
#define bFM4_MFS10_UART_ESCR_P                 *((volatile unsigned char*)(0x4271408CUL))
#define bFM4_MFS10_UART_ESCR_PEN               *((volatile unsigned char*)(0x42714090UL))
#define bFM4_MFS10_UART_ESCR_INV               *((volatile unsigned char*)(0x42714094UL))
#define bFM4_MFS10_UART_ESCR_ESBL              *((volatile unsigned char*)(0x42714098UL))
#define bFM4_MFS10_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271409CUL))
#define bFM4_MFS10_UART_SSR_TBI                *((volatile unsigned char*)(0x427140A0UL))
#define bFM4_MFS10_UART_SSR_TDRE               *((volatile unsigned char*)(0x427140A4UL))
#define bFM4_MFS10_UART_SSR_RDRF               *((volatile unsigned char*)(0x427140A8UL))
#define bFM4_MFS10_UART_SSR_ORE                *((volatile unsigned char*)(0x427140ACUL))
#define bFM4_MFS10_UART_SSR_FRE                *((volatile unsigned char*)(0x427140B0UL))
#define bFM4_MFS10_UART_SSR_PE                 *((volatile unsigned char*)(0x427140B4UL))
#define bFM4_MFS10_UART_SSR_REC                *((volatile unsigned char*)(0x427140BCUL))
#define bFM4_MFS10_UART_BGR_EXT                *((volatile unsigned char*)(0x427141BCUL))
#define bFM4_MFS10_UART_BGR1_EXT               *((volatile unsigned char*)(0x427141BCUL))
#define bFM4_MFS10_UART_FCR_FE1                *((volatile unsigned char*)(0x42714280UL))
#define bFM4_MFS10_UART_FCR_FE2                *((volatile unsigned char*)(0x42714284UL))
#define bFM4_MFS10_UART_FCR_FCL1               *((volatile unsigned char*)(0x42714288UL))
#define bFM4_MFS10_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271428CUL))
#define bFM4_MFS10_UART_FCR_FSET               *((volatile unsigned char*)(0x42714290UL))
#define bFM4_MFS10_UART_FCR_FLD                *((volatile unsigned char*)(0x42714294UL))
#define bFM4_MFS10_UART_FCR_FLST               *((volatile unsigned char*)(0x42714298UL))
#define bFM4_MFS10_UART_FCR_FSEL               *((volatile unsigned char*)(0x427142A0UL))
#define bFM4_MFS10_UART_FCR_FTIE               *((volatile unsigned char*)(0x427142A4UL))
#define bFM4_MFS10_UART_FCR_FDRQ               *((volatile unsigned char*)(0x427142A8UL))
#define bFM4_MFS10_UART_FCR_FRIIE              *((volatile unsigned char*)(0x427142ACUL))
#define bFM4_MFS10_UART_FCR_FLSTE              *((volatile unsigned char*)(0x427142B0UL))
#define bFM4_MFS10_UART_FCR0_FE1               *((volatile unsigned char*)(0x42714280UL))
#define bFM4_MFS10_UART_FCR0_FE2               *((volatile unsigned char*)(0x42714284UL))
#define bFM4_MFS10_UART_FCR0_FCL1              *((volatile unsigned char*)(0x42714288UL))
#define bFM4_MFS10_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271428CUL))
#define bFM4_MFS10_UART_FCR0_FSET              *((volatile unsigned char*)(0x42714290UL))
#define bFM4_MFS10_UART_FCR0_FLD               *((volatile unsigned char*)(0x42714294UL))
#define bFM4_MFS10_UART_FCR0_FLST              *((volatile unsigned char*)(0x42714298UL))
#define bFM4_MFS10_UART_FCR1_FSEL              *((volatile unsigned char*)(0x427142A0UL))
#define bFM4_MFS10_UART_FCR1_FTIE              *((volatile unsigned char*)(0x427142A4UL))
#define bFM4_MFS10_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x427142A8UL))
#define bFM4_MFS10_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x427142ACUL))
#define bFM4_MFS10_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x427142B0UL))
#define bFM4_MFS10_UART_FBYTE_FD0              *((volatile unsigned char*)(0x42714300UL))
#define bFM4_MFS10_UART_FBYTE_FD1              *((volatile unsigned char*)(0x42714304UL))
#define bFM4_MFS10_UART_FBYTE_FD2              *((volatile unsigned char*)(0x42714308UL))
#define bFM4_MFS10_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271430CUL))
#define bFM4_MFS10_UART_FBYTE_FD4              *((volatile unsigned char*)(0x42714310UL))
#define bFM4_MFS10_UART_FBYTE_FD5              *((volatile unsigned char*)(0x42714314UL))
#define bFM4_MFS10_UART_FBYTE_FD6              *((volatile unsigned char*)(0x42714318UL))
#define bFM4_MFS10_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271431CUL))
#define bFM4_MFS10_UART_FBYTE_FD8              *((volatile unsigned char*)(0x42714320UL))
#define bFM4_MFS10_UART_FBYTE_FD9              *((volatile unsigned char*)(0x42714324UL))
#define bFM4_MFS10_UART_FBYTE_FD10             *((volatile unsigned char*)(0x42714328UL))
#define bFM4_MFS10_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271432CUL))
#define bFM4_MFS10_UART_FBYTE_FD12             *((volatile unsigned char*)(0x42714330UL))
#define bFM4_MFS10_UART_FBYTE_FD13             *((volatile unsigned char*)(0x42714334UL))
#define bFM4_MFS10_UART_FBYTE_FD14             *((volatile unsigned char*)(0x42714338UL))
#define bFM4_MFS10_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271433CUL))
#define bFM4_MFS10_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x42714300UL))
#define bFM4_MFS10_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x42714304UL))
#define bFM4_MFS10_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x42714308UL))
#define bFM4_MFS10_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271430CUL))
#define bFM4_MFS10_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x42714310UL))
#define bFM4_MFS10_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x42714314UL))
#define bFM4_MFS10_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x42714318UL))
#define bFM4_MFS10_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271431CUL))
#define bFM4_MFS10_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x42714320UL))
#define bFM4_MFS10_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x42714324UL))
#define bFM4_MFS10_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x42714328UL))
#define bFM4_MFS10_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271432CUL))
#define bFM4_MFS10_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x42714330UL))
#define bFM4_MFS10_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x42714334UL))
#define bFM4_MFS10_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x42714338UL))
#define bFM4_MFS10_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271433CUL))

/* MFS CSIO channel 10 registers */
#define bFM4_MFS10_CSIO_SMR_SOE                *((volatile unsigned char*)(0x42714000UL))
#define bFM4_MFS10_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x42714004UL))
#define bFM4_MFS10_CSIO_SMR_BDS                *((volatile unsigned char*)(0x42714008UL))
#define bFM4_MFS10_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271400CUL))
#define bFM4_MFS10_CSIO_SMR_MD0                *((volatile unsigned char*)(0x42714014UL))
#define bFM4_MFS10_CSIO_SMR_MD1                *((volatile unsigned char*)(0x42714018UL))
#define bFM4_MFS10_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271401CUL))
#define bFM4_MFS10_CSIO_SCR_TXE                *((volatile unsigned char*)(0x42714020UL))
#define bFM4_MFS10_CSIO_SCR_RXE                *((volatile unsigned char*)(0x42714024UL))
#define bFM4_MFS10_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x42714028UL))
#define bFM4_MFS10_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271402CUL))
#define bFM4_MFS10_CSIO_SCR_RIE                *((volatile unsigned char*)(0x42714030UL))
#define bFM4_MFS10_CSIO_SCR_SPI                *((volatile unsigned char*)(0x42714034UL))
#define bFM4_MFS10_CSIO_SCR_MS                 *((volatile unsigned char*)(0x42714038UL))
#define bFM4_MFS10_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271403CUL))
#define bFM4_MFS10_CSIO_ESCR_L0                *((volatile unsigned char*)(0x42714080UL))
#define bFM4_MFS10_CSIO_ESCR_L1                *((volatile unsigned char*)(0x42714084UL))
#define bFM4_MFS10_CSIO_ESCR_L2                *((volatile unsigned char*)(0x42714088UL))
#define bFM4_MFS10_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271408CUL))
#define bFM4_MFS10_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x42714090UL))
#define bFM4_MFS10_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x42714094UL))
#define bFM4_MFS10_CSIO_ESCR_L3                *((volatile unsigned char*)(0x42714098UL))
#define bFM4_MFS10_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271409CUL))
#define bFM4_MFS10_CSIO_SSR_TBI                *((volatile unsigned char*)(0x427140A0UL))
#define bFM4_MFS10_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x427140A4UL))
#define bFM4_MFS10_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x427140A8UL))
#define bFM4_MFS10_CSIO_SSR_ORE                *((volatile unsigned char*)(0x427140ACUL))
#define bFM4_MFS10_CSIO_SSR_AWC                *((volatile unsigned char*)(0x427140B0UL))
#define bFM4_MFS10_CSIO_SSR_REC                *((volatile unsigned char*)(0x427140BCUL))
#define bFM4_MFS10_CSIO_FCR_FE1                *((volatile unsigned char*)(0x42714280UL))
#define bFM4_MFS10_CSIO_FCR_FE2                *((volatile unsigned char*)(0x42714284UL))
#define bFM4_MFS10_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x42714288UL))
#define bFM4_MFS10_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271428CUL))
#define bFM4_MFS10_CSIO_FCR_FSET               *((volatile unsigned char*)(0x42714290UL))
#define bFM4_MFS10_CSIO_FCR_FLD                *((volatile unsigned char*)(0x42714294UL))
#define bFM4_MFS10_CSIO_FCR_FLST               *((volatile unsigned char*)(0x42714298UL))
#define bFM4_MFS10_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x427142A0UL))
#define bFM4_MFS10_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x427142A4UL))
#define bFM4_MFS10_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x427142A8UL))
#define bFM4_MFS10_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x427142ACUL))
#define bFM4_MFS10_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x427142B0UL))
#define bFM4_MFS10_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x42714280UL))
#define bFM4_MFS10_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x42714284UL))
#define bFM4_MFS10_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x42714288UL))
#define bFM4_MFS10_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271428CUL))
#define bFM4_MFS10_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x42714290UL))
#define bFM4_MFS10_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x42714294UL))
#define bFM4_MFS10_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x42714298UL))
#define bFM4_MFS10_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x427142A0UL))
#define bFM4_MFS10_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x427142A4UL))
#define bFM4_MFS10_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x427142A8UL))
#define bFM4_MFS10_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x427142ACUL))
#define bFM4_MFS10_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x427142B0UL))
#define bFM4_MFS10_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x42714300UL))
#define bFM4_MFS10_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x42714304UL))
#define bFM4_MFS10_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x42714308UL))
#define bFM4_MFS10_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271430CUL))
#define bFM4_MFS10_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x42714310UL))
#define bFM4_MFS10_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x42714314UL))
#define bFM4_MFS10_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x42714318UL))
#define bFM4_MFS10_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271431CUL))
#define bFM4_MFS10_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x42714320UL))
#define bFM4_MFS10_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x42714324UL))
#define bFM4_MFS10_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x42714328UL))
#define bFM4_MFS10_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271432CUL))
#define bFM4_MFS10_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x42714330UL))
#define bFM4_MFS10_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x42714334UL))
#define bFM4_MFS10_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x42714338UL))
#define bFM4_MFS10_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271433CUL))
#define bFM4_MFS10_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x42714300UL))
#define bFM4_MFS10_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x42714304UL))
#define bFM4_MFS10_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x42714308UL))
#define bFM4_MFS10_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271430CUL))
#define bFM4_MFS10_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x42714310UL))
#define bFM4_MFS10_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x42714314UL))
#define bFM4_MFS10_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x42714318UL))
#define bFM4_MFS10_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271431CUL))
#define bFM4_MFS10_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x42714320UL))
#define bFM4_MFS10_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x42714324UL))
#define bFM4_MFS10_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x42714328UL))
#define bFM4_MFS10_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271432CUL))
#define bFM4_MFS10_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x42714330UL))
#define bFM4_MFS10_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x42714334UL))
#define bFM4_MFS10_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x42714338UL))
#define bFM4_MFS10_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271433CUL))
#define bFM4_MFS10_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x42714380UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x42714384UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x42714388UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271438CUL))
#define bFM4_MFS10_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x42714390UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x42714394UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x42714398UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271439CUL))
#define bFM4_MFS10_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x427143A0UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x427143A4UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x427143A8UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x427143ACUL))
#define bFM4_MFS10_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x427143B0UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x427143B4UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x427143B8UL))
#define bFM4_MFS10_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x427143BCUL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x42714400UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x42714404UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x42714408UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271440CUL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x42714410UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x42714414UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x42714418UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271441CUL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x42714420UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x42714424UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x42714428UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271442CUL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x42714430UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x42714434UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x42714438UL))
#define bFM4_MFS10_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271443CUL))
#define bFM4_MFS10_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x42714480UL))
#define bFM4_MFS10_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x42714484UL))
#define bFM4_MFS10_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x42714488UL))
#define bFM4_MFS10_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271448CUL))
#define bFM4_MFS10_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x42714490UL))
#define bFM4_MFS10_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x42714498UL))
#define bFM4_MFS10_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271449CUL))
#define bFM4_MFS10_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x427144A0UL))
#define bFM4_MFS10_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x427144ACUL))
#define bFM4_MFS10_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x427144B0UL))
#define bFM4_MFS10_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x427144B4UL))
#define bFM4_MFS10_CSIO_STMR_TM0               *((volatile unsigned char*)(0x42714500UL))
#define bFM4_MFS10_CSIO_STMR_TM1               *((volatile unsigned char*)(0x42714504UL))
#define bFM4_MFS10_CSIO_STMR_TM2               *((volatile unsigned char*)(0x42714508UL))
#define bFM4_MFS10_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271450CUL))
#define bFM4_MFS10_CSIO_STMR_TM4               *((volatile unsigned char*)(0x42714510UL))
#define bFM4_MFS10_CSIO_STMR_TM5               *((volatile unsigned char*)(0x42714514UL))
#define bFM4_MFS10_CSIO_STMR_TM6               *((volatile unsigned char*)(0x42714518UL))
#define bFM4_MFS10_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271451CUL))
#define bFM4_MFS10_CSIO_STMR_TM8               *((volatile unsigned char*)(0x42714520UL))
#define bFM4_MFS10_CSIO_STMR_TM9               *((volatile unsigned char*)(0x42714524UL))
#define bFM4_MFS10_CSIO_STMR_TM10              *((volatile unsigned char*)(0x42714528UL))
#define bFM4_MFS10_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271452CUL))
#define bFM4_MFS10_CSIO_STMR_TM12              *((volatile unsigned char*)(0x42714530UL))
#define bFM4_MFS10_CSIO_STMR_TM13              *((volatile unsigned char*)(0x42714534UL))
#define bFM4_MFS10_CSIO_STMR_TM14              *((volatile unsigned char*)(0x42714538UL))
#define bFM4_MFS10_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271453CUL))
#define bFM4_MFS10_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x42714580UL))
#define bFM4_MFS10_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x42714584UL))
#define bFM4_MFS10_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x42714588UL))
#define bFM4_MFS10_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271458CUL))
#define bFM4_MFS10_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x42714590UL))
#define bFM4_MFS10_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x42714594UL))
#define bFM4_MFS10_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x42714598UL))
#define bFM4_MFS10_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271459CUL))
#define bFM4_MFS10_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x427145A0UL))
#define bFM4_MFS10_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x427145A4UL))
#define bFM4_MFS10_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x427145A8UL))
#define bFM4_MFS10_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x427145ACUL))
#define bFM4_MFS10_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x427145B0UL))
#define bFM4_MFS10_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x427145B4UL))
#define bFM4_MFS10_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x427145B8UL))
#define bFM4_MFS10_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x427145BCUL))
#define bFM4_MFS10_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x42714600UL))
#define bFM4_MFS10_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x42714604UL))
#define bFM4_MFS10_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x42714608UL))
#define bFM4_MFS10_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271460CUL))
#define bFM4_MFS10_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x42714610UL))
#define bFM4_MFS10_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x42714614UL))
#define bFM4_MFS10_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x42714618UL))
#define bFM4_MFS10_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271461CUL))
#define bFM4_MFS10_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x42714620UL))
#define bFM4_MFS10_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x42714624UL))
#define bFM4_MFS10_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x42714628UL))
#define bFM4_MFS10_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271462CUL))
#define bFM4_MFS10_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x42714630UL))
#define bFM4_MFS10_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x42714634UL))
#define bFM4_MFS10_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x42714638UL))
#define bFM4_MFS10_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271463CUL))
#define bFM4_MFS10_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x42714680UL))
#define bFM4_MFS10_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x42714684UL))
#define bFM4_MFS10_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x42714688UL))
#define bFM4_MFS10_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271468CUL))
#define bFM4_MFS10_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x42714690UL))
#define bFM4_MFS10_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x42714694UL))
#define bFM4_MFS10_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x42714698UL))
#define bFM4_MFS10_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271469CUL))
#define bFM4_MFS10_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x427146A0UL))
#define bFM4_MFS10_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x427146A4UL))
#define bFM4_MFS10_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x427146A8UL))
#define bFM4_MFS10_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x427146ACUL))
#define bFM4_MFS10_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x427146B0UL))
#define bFM4_MFS10_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x427146B4UL))
#define bFM4_MFS10_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x427146B8UL))
#define bFM4_MFS10_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x427146BCUL))
#define bFM4_MFS10_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x42714700UL))
#define bFM4_MFS10_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x42714704UL))
#define bFM4_MFS10_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x42714708UL))
#define bFM4_MFS10_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271470CUL))
#define bFM4_MFS10_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x42714710UL))
#define bFM4_MFS10_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x42714714UL))
#define bFM4_MFS10_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x42714718UL))
#define bFM4_MFS10_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271471CUL))

/* MFS LIN channel 10 registers */
#define bFM4_MFS10_LIN_SMR_SOE                 *((volatile unsigned char*)(0x42714000UL))
#define bFM4_MFS10_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271400CUL))
#define bFM4_MFS10_LIN_SMR_WUCR                *((volatile unsigned char*)(0x42714010UL))
#define bFM4_MFS10_LIN_SMR_MD0                 *((volatile unsigned char*)(0x42714014UL))
#define bFM4_MFS10_LIN_SMR_MD1                 *((volatile unsigned char*)(0x42714018UL))
#define bFM4_MFS10_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271401CUL))
#define bFM4_MFS10_LIN_SCR_TXE                 *((volatile unsigned char*)(0x42714020UL))
#define bFM4_MFS10_LIN_SCR_RXE                 *((volatile unsigned char*)(0x42714024UL))
#define bFM4_MFS10_LIN_SCR_TBIE                *((volatile unsigned char*)(0x42714028UL))
#define bFM4_MFS10_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271402CUL))
#define bFM4_MFS10_LIN_SCR_RIE                 *((volatile unsigned char*)(0x42714030UL))
#define bFM4_MFS10_LIN_SCR_LBR                 *((volatile unsigned char*)(0x42714034UL))
#define bFM4_MFS10_LIN_SCR_MS                  *((volatile unsigned char*)(0x42714038UL))
#define bFM4_MFS10_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271403CUL))
#define bFM4_MFS10_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x42714080UL))
#define bFM4_MFS10_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x42714084UL))
#define bFM4_MFS10_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x42714088UL))
#define bFM4_MFS10_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271408CUL))
#define bFM4_MFS10_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x42714090UL))
#define bFM4_MFS10_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x42714098UL))
#define bFM4_MFS10_LIN_SSR_TBI                 *((volatile unsigned char*)(0x427140A0UL))
#define bFM4_MFS10_LIN_SSR_TDRE                *((volatile unsigned char*)(0x427140A4UL))
#define bFM4_MFS10_LIN_SSR_RDRF                *((volatile unsigned char*)(0x427140A8UL))
#define bFM4_MFS10_LIN_SSR_ORE                 *((volatile unsigned char*)(0x427140ACUL))
#define bFM4_MFS10_LIN_SSR_FRE                 *((volatile unsigned char*)(0x427140B0UL))
#define bFM4_MFS10_LIN_SSR_LBD                 *((volatile unsigned char*)(0x427140B4UL))
#define bFM4_MFS10_LIN_SSR_REC                 *((volatile unsigned char*)(0x427140BCUL))
#define bFM4_MFS10_LIN_BGR_EXT                 *((volatile unsigned char*)(0x427141BCUL))
#define bFM4_MFS10_LIN_BGR1_EXT                *((volatile unsigned char*)(0x427141BCUL))
#define bFM4_MFS10_LIN_FCR_FE1                 *((volatile unsigned char*)(0x42714280UL))
#define bFM4_MFS10_LIN_FCR_FE2                 *((volatile unsigned char*)(0x42714284UL))
#define bFM4_MFS10_LIN_FCR_FCL1                *((volatile unsigned char*)(0x42714288UL))
#define bFM4_MFS10_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271428CUL))
#define bFM4_MFS10_LIN_FCR_FSET                *((volatile unsigned char*)(0x42714290UL))
#define bFM4_MFS10_LIN_FCR_FLD                 *((volatile unsigned char*)(0x42714294UL))
#define bFM4_MFS10_LIN_FCR_FLST                *((volatile unsigned char*)(0x42714298UL))
#define bFM4_MFS10_LIN_FCR_FSEL                *((volatile unsigned char*)(0x427142A0UL))
#define bFM4_MFS10_LIN_FCR_FTIE                *((volatile unsigned char*)(0x427142A4UL))
#define bFM4_MFS10_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x427142A8UL))
#define bFM4_MFS10_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x427142ACUL))
#define bFM4_MFS10_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x427142B0UL))
#define bFM4_MFS10_LIN_FCR0_FE1                *((volatile unsigned char*)(0x42714280UL))
#define bFM4_MFS10_LIN_FCR0_FE2                *((volatile unsigned char*)(0x42714284UL))
#define bFM4_MFS10_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x42714288UL))
#define bFM4_MFS10_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271428CUL))
#define bFM4_MFS10_LIN_FCR0_FSET               *((volatile unsigned char*)(0x42714290UL))
#define bFM4_MFS10_LIN_FCR0_FLD                *((volatile unsigned char*)(0x42714294UL))
#define bFM4_MFS10_LIN_FCR0_FLST               *((volatile unsigned char*)(0x42714298UL))
#define bFM4_MFS10_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x427142A0UL))
#define bFM4_MFS10_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x427142A4UL))
#define bFM4_MFS10_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x427142A8UL))
#define bFM4_MFS10_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x427142ACUL))
#define bFM4_MFS10_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x427142B0UL))
#define bFM4_MFS10_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x42714300UL))
#define bFM4_MFS10_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x42714304UL))
#define bFM4_MFS10_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x42714308UL))
#define bFM4_MFS10_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271430CUL))
#define bFM4_MFS10_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x42714310UL))
#define bFM4_MFS10_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x42714314UL))
#define bFM4_MFS10_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x42714318UL))
#define bFM4_MFS10_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271431CUL))
#define bFM4_MFS10_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x42714320UL))
#define bFM4_MFS10_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x42714324UL))
#define bFM4_MFS10_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x42714328UL))
#define bFM4_MFS10_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271432CUL))
#define bFM4_MFS10_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x42714330UL))
#define bFM4_MFS10_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x42714334UL))
#define bFM4_MFS10_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x42714338UL))
#define bFM4_MFS10_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271433CUL))
#define bFM4_MFS10_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x42714300UL))
#define bFM4_MFS10_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x42714304UL))
#define bFM4_MFS10_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x42714308UL))
#define bFM4_MFS10_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271430CUL))
#define bFM4_MFS10_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x42714310UL))
#define bFM4_MFS10_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x42714314UL))
#define bFM4_MFS10_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x42714318UL))
#define bFM4_MFS10_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271431CUL))
#define bFM4_MFS10_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x42714320UL))
#define bFM4_MFS10_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x42714324UL))
#define bFM4_MFS10_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x42714328UL))
#define bFM4_MFS10_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271432CUL))
#define bFM4_MFS10_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x42714330UL))
#define bFM4_MFS10_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x42714334UL))
#define bFM4_MFS10_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x42714338UL))
#define bFM4_MFS10_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271433CUL))

/* MFS I2C channel 10 registers */
#define bFM4_MFS10_I2C_SMR_TIE                 *((volatile unsigned char*)(0x42714008UL))
#define bFM4_MFS10_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271400CUL))
#define bFM4_MFS10_I2C_SMR_MD0                 *((volatile unsigned char*)(0x42714014UL))
#define bFM4_MFS10_I2C_SMR_MD1                 *((volatile unsigned char*)(0x42714018UL))
#define bFM4_MFS10_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271401CUL))
#define bFM4_MFS10_I2C_IBCR_INT                *((volatile unsigned char*)(0x42714020UL))
#define bFM4_MFS10_I2C_IBCR_BER                *((volatile unsigned char*)(0x42714024UL))
#define bFM4_MFS10_I2C_IBCR_INTE               *((volatile unsigned char*)(0x42714028UL))
#define bFM4_MFS10_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271402CUL))
#define bFM4_MFS10_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x42714030UL))
#define bFM4_MFS10_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x42714034UL))
#define bFM4_MFS10_I2C_IBCR_ACT                *((volatile unsigned char*)(0x42714038UL))
#define bFM4_MFS10_I2C_IBCR_SCC                *((volatile unsigned char*)(0x42714038UL))
#define bFM4_MFS10_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271403CUL))
#define bFM4_MFS10_I2C_IBSR_BB                 *((volatile unsigned char*)(0x42714080UL))
#define bFM4_MFS10_I2C_IBSR_SPC                *((volatile unsigned char*)(0x42714084UL))
#define bFM4_MFS10_I2C_IBSR_RSC                *((volatile unsigned char*)(0x42714088UL))
#define bFM4_MFS10_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271408CUL))
#define bFM4_MFS10_I2C_IBSR_TRX                *((volatile unsigned char*)(0x42714090UL))
#define bFM4_MFS10_I2C_IBSR_RSA                *((volatile unsigned char*)(0x42714094UL))
#define bFM4_MFS10_I2C_IBSR_RACK               *((volatile unsigned char*)(0x42714098UL))
#define bFM4_MFS10_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271409CUL))
#define bFM4_MFS10_I2C_SSR_TBI                 *((volatile unsigned char*)(0x427140A0UL))
#define bFM4_MFS10_I2C_SSR_TDRE                *((volatile unsigned char*)(0x427140A4UL))
#define bFM4_MFS10_I2C_SSR_RDRF                *((volatile unsigned char*)(0x427140A8UL))
#define bFM4_MFS10_I2C_SSR_ORE                 *((volatile unsigned char*)(0x427140ACUL))
#define bFM4_MFS10_I2C_SSR_TBIE                *((volatile unsigned char*)(0x427140B0UL))
#define bFM4_MFS10_I2C_SSR_DMA                 *((volatile unsigned char*)(0x427140B4UL))
#define bFM4_MFS10_I2C_SSR_TSET                *((volatile unsigned char*)(0x427140B8UL))
#define bFM4_MFS10_I2C_SSR_REC                 *((volatile unsigned char*)(0x427140BCUL))
#define bFM4_MFS10_I2C_ISBA_SA0                *((volatile unsigned char*)(0x42714200UL))
#define bFM4_MFS10_I2C_ISBA_SA1                *((volatile unsigned char*)(0x42714204UL))
#define bFM4_MFS10_I2C_ISBA_SA2                *((volatile unsigned char*)(0x42714208UL))
#define bFM4_MFS10_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271420CUL))
#define bFM4_MFS10_I2C_ISBA_SA4                *((volatile unsigned char*)(0x42714210UL))
#define bFM4_MFS10_I2C_ISBA_SA5                *((volatile unsigned char*)(0x42714214UL))
#define bFM4_MFS10_I2C_ISBA_SA6                *((volatile unsigned char*)(0x42714218UL))
#define bFM4_MFS10_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271421CUL))
#define bFM4_MFS10_I2C_ISMK_SM0                *((volatile unsigned char*)(0x42714220UL))
#define bFM4_MFS10_I2C_ISMK_SM1                *((volatile unsigned char*)(0x42714224UL))
#define bFM4_MFS10_I2C_ISMK_SM2                *((volatile unsigned char*)(0x42714228UL))
#define bFM4_MFS10_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271422CUL))
#define bFM4_MFS10_I2C_ISMK_SM4                *((volatile unsigned char*)(0x42714230UL))
#define bFM4_MFS10_I2C_ISMK_SM5                *((volatile unsigned char*)(0x42714234UL))
#define bFM4_MFS10_I2C_ISMK_SM6                *((volatile unsigned char*)(0x42714238UL))
#define bFM4_MFS10_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271423CUL))
#define bFM4_MFS10_I2C_FCR_FE1                 *((volatile unsigned char*)(0x42714280UL))
#define bFM4_MFS10_I2C_FCR_FE2                 *((volatile unsigned char*)(0x42714284UL))
#define bFM4_MFS10_I2C_FCR_FCL1                *((volatile unsigned char*)(0x42714288UL))
#define bFM4_MFS10_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271428CUL))
#define bFM4_MFS10_I2C_FCR_FSET                *((volatile unsigned char*)(0x42714290UL))
#define bFM4_MFS10_I2C_FCR_FLD                 *((volatile unsigned char*)(0x42714294UL))
#define bFM4_MFS10_I2C_FCR_FLST                *((volatile unsigned char*)(0x42714298UL))
#define bFM4_MFS10_I2C_FCR_FSEL                *((volatile unsigned char*)(0x427142A0UL))
#define bFM4_MFS10_I2C_FCR_FTIE                *((volatile unsigned char*)(0x427142A4UL))
#define bFM4_MFS10_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x427142A8UL))
#define bFM4_MFS10_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x427142ACUL))
#define bFM4_MFS10_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x427142B0UL))
#define bFM4_MFS10_I2C_FCR0_FE1                *((volatile unsigned char*)(0x42714280UL))
#define bFM4_MFS10_I2C_FCR0_FE2                *((volatile unsigned char*)(0x42714284UL))
#define bFM4_MFS10_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x42714288UL))
#define bFM4_MFS10_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271428CUL))
#define bFM4_MFS10_I2C_FCR0_FSET               *((volatile unsigned char*)(0x42714290UL))
#define bFM4_MFS10_I2C_FCR0_FLD                *((volatile unsigned char*)(0x42714294UL))
#define bFM4_MFS10_I2C_FCR0_FLST               *((volatile unsigned char*)(0x42714298UL))
#define bFM4_MFS10_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x427142A0UL))
#define bFM4_MFS10_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x427142A4UL))
#define bFM4_MFS10_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x427142A8UL))
#define bFM4_MFS10_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x427142ACUL))
#define bFM4_MFS10_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x427142B0UL))
#define bFM4_MFS10_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x42714300UL))
#define bFM4_MFS10_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x42714304UL))
#define bFM4_MFS10_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x42714308UL))
#define bFM4_MFS10_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271430CUL))
#define bFM4_MFS10_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x42714310UL))
#define bFM4_MFS10_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x42714314UL))
#define bFM4_MFS10_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x42714318UL))
#define bFM4_MFS10_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271431CUL))
#define bFM4_MFS10_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x42714320UL))
#define bFM4_MFS10_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x42714324UL))
#define bFM4_MFS10_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x42714328UL))
#define bFM4_MFS10_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271432CUL))
#define bFM4_MFS10_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x42714330UL))
#define bFM4_MFS10_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x42714334UL))
#define bFM4_MFS10_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x42714338UL))
#define bFM4_MFS10_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271433CUL))
#define bFM4_MFS10_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x42714300UL))
#define bFM4_MFS10_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x42714304UL))
#define bFM4_MFS10_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x42714308UL))
#define bFM4_MFS10_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271430CUL))
#define bFM4_MFS10_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x42714310UL))
#define bFM4_MFS10_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x42714314UL))
#define bFM4_MFS10_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x42714318UL))
#define bFM4_MFS10_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271431CUL))
#define bFM4_MFS10_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x42714320UL))
#define bFM4_MFS10_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x42714324UL))
#define bFM4_MFS10_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x42714328UL))
#define bFM4_MFS10_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271432CUL))
#define bFM4_MFS10_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x42714330UL))
#define bFM4_MFS10_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x42714334UL))
#define bFM4_MFS10_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x42714338UL))
#define bFM4_MFS10_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271433CUL))

/* MFS UART channel 11 registers */
#define bFM4_MFS11_UART_SMR_SOE                *((volatile unsigned char*)(0x42716000UL))
#define bFM4_MFS11_UART_SMR_BDS                *((volatile unsigned char*)(0x42716008UL))
#define bFM4_MFS11_UART_SMR_SBL                *((volatile unsigned char*)(0x4271600CUL))
#define bFM4_MFS11_UART_SMR_WUCR               *((volatile unsigned char*)(0x42716010UL))
#define bFM4_MFS11_UART_SMR_MD0                *((volatile unsigned char*)(0x42716014UL))
#define bFM4_MFS11_UART_SMR_MD1                *((volatile unsigned char*)(0x42716018UL))
#define bFM4_MFS11_UART_SMR_MD2                *((volatile unsigned char*)(0x4271601CUL))
#define bFM4_MFS11_UART_SCR_TXE                *((volatile unsigned char*)(0x42716020UL))
#define bFM4_MFS11_UART_SCR_RXE                *((volatile unsigned char*)(0x42716024UL))
#define bFM4_MFS11_UART_SCR_TBIE               *((volatile unsigned char*)(0x42716028UL))
#define bFM4_MFS11_UART_SCR_TIE                *((volatile unsigned char*)(0x4271602CUL))
#define bFM4_MFS11_UART_SCR_RIE                *((volatile unsigned char*)(0x42716030UL))
#define bFM4_MFS11_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271603CUL))
#define bFM4_MFS11_UART_ESCR_L0                *((volatile unsigned char*)(0x42716080UL))
#define bFM4_MFS11_UART_ESCR_L1                *((volatile unsigned char*)(0x42716084UL))
#define bFM4_MFS11_UART_ESCR_L2                *((volatile unsigned char*)(0x42716088UL))
#define bFM4_MFS11_UART_ESCR_P                 *((volatile unsigned char*)(0x4271608CUL))
#define bFM4_MFS11_UART_ESCR_PEN               *((volatile unsigned char*)(0x42716090UL))
#define bFM4_MFS11_UART_ESCR_INV               *((volatile unsigned char*)(0x42716094UL))
#define bFM4_MFS11_UART_ESCR_ESBL              *((volatile unsigned char*)(0x42716098UL))
#define bFM4_MFS11_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271609CUL))
#define bFM4_MFS11_UART_SSR_TBI                *((volatile unsigned char*)(0x427160A0UL))
#define bFM4_MFS11_UART_SSR_TDRE               *((volatile unsigned char*)(0x427160A4UL))
#define bFM4_MFS11_UART_SSR_RDRF               *((volatile unsigned char*)(0x427160A8UL))
#define bFM4_MFS11_UART_SSR_ORE                *((volatile unsigned char*)(0x427160ACUL))
#define bFM4_MFS11_UART_SSR_FRE                *((volatile unsigned char*)(0x427160B0UL))
#define bFM4_MFS11_UART_SSR_PE                 *((volatile unsigned char*)(0x427160B4UL))
#define bFM4_MFS11_UART_SSR_REC                *((volatile unsigned char*)(0x427160BCUL))
#define bFM4_MFS11_UART_BGR_EXT                *((volatile unsigned char*)(0x427161BCUL))
#define bFM4_MFS11_UART_BGR1_EXT               *((volatile unsigned char*)(0x427161BCUL))
#define bFM4_MFS11_UART_FCR_FE1                *((volatile unsigned char*)(0x42716280UL))
#define bFM4_MFS11_UART_FCR_FE2                *((volatile unsigned char*)(0x42716284UL))
#define bFM4_MFS11_UART_FCR_FCL1               *((volatile unsigned char*)(0x42716288UL))
#define bFM4_MFS11_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271628CUL))
#define bFM4_MFS11_UART_FCR_FSET               *((volatile unsigned char*)(0x42716290UL))
#define bFM4_MFS11_UART_FCR_FLD                *((volatile unsigned char*)(0x42716294UL))
#define bFM4_MFS11_UART_FCR_FLST               *((volatile unsigned char*)(0x42716298UL))
#define bFM4_MFS11_UART_FCR_FSEL               *((volatile unsigned char*)(0x427162A0UL))
#define bFM4_MFS11_UART_FCR_FTIE               *((volatile unsigned char*)(0x427162A4UL))
#define bFM4_MFS11_UART_FCR_FDRQ               *((volatile unsigned char*)(0x427162A8UL))
#define bFM4_MFS11_UART_FCR_FRIIE              *((volatile unsigned char*)(0x427162ACUL))
#define bFM4_MFS11_UART_FCR_FLSTE              *((volatile unsigned char*)(0x427162B0UL))
#define bFM4_MFS11_UART_FCR0_FE1               *((volatile unsigned char*)(0x42716280UL))
#define bFM4_MFS11_UART_FCR0_FE2               *((volatile unsigned char*)(0x42716284UL))
#define bFM4_MFS11_UART_FCR0_FCL1              *((volatile unsigned char*)(0x42716288UL))
#define bFM4_MFS11_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271628CUL))
#define bFM4_MFS11_UART_FCR0_FSET              *((volatile unsigned char*)(0x42716290UL))
#define bFM4_MFS11_UART_FCR0_FLD               *((volatile unsigned char*)(0x42716294UL))
#define bFM4_MFS11_UART_FCR0_FLST              *((volatile unsigned char*)(0x42716298UL))
#define bFM4_MFS11_UART_FCR1_FSEL              *((volatile unsigned char*)(0x427162A0UL))
#define bFM4_MFS11_UART_FCR1_FTIE              *((volatile unsigned char*)(0x427162A4UL))
#define bFM4_MFS11_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x427162A8UL))
#define bFM4_MFS11_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x427162ACUL))
#define bFM4_MFS11_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x427162B0UL))
#define bFM4_MFS11_UART_FBYTE_FD0              *((volatile unsigned char*)(0x42716300UL))
#define bFM4_MFS11_UART_FBYTE_FD1              *((volatile unsigned char*)(0x42716304UL))
#define bFM4_MFS11_UART_FBYTE_FD2              *((volatile unsigned char*)(0x42716308UL))
#define bFM4_MFS11_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271630CUL))
#define bFM4_MFS11_UART_FBYTE_FD4              *((volatile unsigned char*)(0x42716310UL))
#define bFM4_MFS11_UART_FBYTE_FD5              *((volatile unsigned char*)(0x42716314UL))
#define bFM4_MFS11_UART_FBYTE_FD6              *((volatile unsigned char*)(0x42716318UL))
#define bFM4_MFS11_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271631CUL))
#define bFM4_MFS11_UART_FBYTE_FD8              *((volatile unsigned char*)(0x42716320UL))
#define bFM4_MFS11_UART_FBYTE_FD9              *((volatile unsigned char*)(0x42716324UL))
#define bFM4_MFS11_UART_FBYTE_FD10             *((volatile unsigned char*)(0x42716328UL))
#define bFM4_MFS11_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271632CUL))
#define bFM4_MFS11_UART_FBYTE_FD12             *((volatile unsigned char*)(0x42716330UL))
#define bFM4_MFS11_UART_FBYTE_FD13             *((volatile unsigned char*)(0x42716334UL))
#define bFM4_MFS11_UART_FBYTE_FD14             *((volatile unsigned char*)(0x42716338UL))
#define bFM4_MFS11_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271633CUL))
#define bFM4_MFS11_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x42716300UL))
#define bFM4_MFS11_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x42716304UL))
#define bFM4_MFS11_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x42716308UL))
#define bFM4_MFS11_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271630CUL))
#define bFM4_MFS11_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x42716310UL))
#define bFM4_MFS11_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x42716314UL))
#define bFM4_MFS11_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x42716318UL))
#define bFM4_MFS11_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271631CUL))
#define bFM4_MFS11_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x42716320UL))
#define bFM4_MFS11_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x42716324UL))
#define bFM4_MFS11_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x42716328UL))
#define bFM4_MFS11_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271632CUL))
#define bFM4_MFS11_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x42716330UL))
#define bFM4_MFS11_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x42716334UL))
#define bFM4_MFS11_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x42716338UL))
#define bFM4_MFS11_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271633CUL))

/* MFS CSIO channel 11 registers */
#define bFM4_MFS11_CSIO_SMR_SOE                *((volatile unsigned char*)(0x42716000UL))
#define bFM4_MFS11_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x42716004UL))
#define bFM4_MFS11_CSIO_SMR_BDS                *((volatile unsigned char*)(0x42716008UL))
#define bFM4_MFS11_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271600CUL))
#define bFM4_MFS11_CSIO_SMR_MD0                *((volatile unsigned char*)(0x42716014UL))
#define bFM4_MFS11_CSIO_SMR_MD1                *((volatile unsigned char*)(0x42716018UL))
#define bFM4_MFS11_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271601CUL))
#define bFM4_MFS11_CSIO_SCR_TXE                *((volatile unsigned char*)(0x42716020UL))
#define bFM4_MFS11_CSIO_SCR_RXE                *((volatile unsigned char*)(0x42716024UL))
#define bFM4_MFS11_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x42716028UL))
#define bFM4_MFS11_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271602CUL))
#define bFM4_MFS11_CSIO_SCR_RIE                *((volatile unsigned char*)(0x42716030UL))
#define bFM4_MFS11_CSIO_SCR_SPI                *((volatile unsigned char*)(0x42716034UL))
#define bFM4_MFS11_CSIO_SCR_MS                 *((volatile unsigned char*)(0x42716038UL))
#define bFM4_MFS11_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271603CUL))
#define bFM4_MFS11_CSIO_ESCR_L0                *((volatile unsigned char*)(0x42716080UL))
#define bFM4_MFS11_CSIO_ESCR_L1                *((volatile unsigned char*)(0x42716084UL))
#define bFM4_MFS11_CSIO_ESCR_L2                *((volatile unsigned char*)(0x42716088UL))
#define bFM4_MFS11_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271608CUL))
#define bFM4_MFS11_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x42716090UL))
#define bFM4_MFS11_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x42716094UL))
#define bFM4_MFS11_CSIO_ESCR_L3                *((volatile unsigned char*)(0x42716098UL))
#define bFM4_MFS11_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271609CUL))
#define bFM4_MFS11_CSIO_SSR_TBI                *((volatile unsigned char*)(0x427160A0UL))
#define bFM4_MFS11_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x427160A4UL))
#define bFM4_MFS11_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x427160A8UL))
#define bFM4_MFS11_CSIO_SSR_ORE                *((volatile unsigned char*)(0x427160ACUL))
#define bFM4_MFS11_CSIO_SSR_AWC                *((volatile unsigned char*)(0x427160B0UL))
#define bFM4_MFS11_CSIO_SSR_REC                *((volatile unsigned char*)(0x427160BCUL))
#define bFM4_MFS11_CSIO_FCR_FE1                *((volatile unsigned char*)(0x42716280UL))
#define bFM4_MFS11_CSIO_FCR_FE2                *((volatile unsigned char*)(0x42716284UL))
#define bFM4_MFS11_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x42716288UL))
#define bFM4_MFS11_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271628CUL))
#define bFM4_MFS11_CSIO_FCR_FSET               *((volatile unsigned char*)(0x42716290UL))
#define bFM4_MFS11_CSIO_FCR_FLD                *((volatile unsigned char*)(0x42716294UL))
#define bFM4_MFS11_CSIO_FCR_FLST               *((volatile unsigned char*)(0x42716298UL))
#define bFM4_MFS11_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x427162A0UL))
#define bFM4_MFS11_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x427162A4UL))
#define bFM4_MFS11_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x427162A8UL))
#define bFM4_MFS11_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x427162ACUL))
#define bFM4_MFS11_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x427162B0UL))
#define bFM4_MFS11_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x42716280UL))
#define bFM4_MFS11_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x42716284UL))
#define bFM4_MFS11_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x42716288UL))
#define bFM4_MFS11_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271628CUL))
#define bFM4_MFS11_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x42716290UL))
#define bFM4_MFS11_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x42716294UL))
#define bFM4_MFS11_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x42716298UL))
#define bFM4_MFS11_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x427162A0UL))
#define bFM4_MFS11_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x427162A4UL))
#define bFM4_MFS11_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x427162A8UL))
#define bFM4_MFS11_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x427162ACUL))
#define bFM4_MFS11_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x427162B0UL))
#define bFM4_MFS11_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x42716300UL))
#define bFM4_MFS11_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x42716304UL))
#define bFM4_MFS11_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x42716308UL))
#define bFM4_MFS11_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271630CUL))
#define bFM4_MFS11_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x42716310UL))
#define bFM4_MFS11_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x42716314UL))
#define bFM4_MFS11_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x42716318UL))
#define bFM4_MFS11_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271631CUL))
#define bFM4_MFS11_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x42716320UL))
#define bFM4_MFS11_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x42716324UL))
#define bFM4_MFS11_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x42716328UL))
#define bFM4_MFS11_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271632CUL))
#define bFM4_MFS11_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x42716330UL))
#define bFM4_MFS11_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x42716334UL))
#define bFM4_MFS11_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x42716338UL))
#define bFM4_MFS11_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271633CUL))
#define bFM4_MFS11_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x42716300UL))
#define bFM4_MFS11_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x42716304UL))
#define bFM4_MFS11_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x42716308UL))
#define bFM4_MFS11_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271630CUL))
#define bFM4_MFS11_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x42716310UL))
#define bFM4_MFS11_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x42716314UL))
#define bFM4_MFS11_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x42716318UL))
#define bFM4_MFS11_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271631CUL))
#define bFM4_MFS11_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x42716320UL))
#define bFM4_MFS11_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x42716324UL))
#define bFM4_MFS11_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x42716328UL))
#define bFM4_MFS11_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271632CUL))
#define bFM4_MFS11_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x42716330UL))
#define bFM4_MFS11_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x42716334UL))
#define bFM4_MFS11_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x42716338UL))
#define bFM4_MFS11_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271633CUL))
#define bFM4_MFS11_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x42716380UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x42716384UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x42716388UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271638CUL))
#define bFM4_MFS11_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x42716390UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x42716394UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x42716398UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271639CUL))
#define bFM4_MFS11_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x427163A0UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x427163A4UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x427163A8UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x427163ACUL))
#define bFM4_MFS11_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x427163B0UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x427163B4UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x427163B8UL))
#define bFM4_MFS11_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x427163BCUL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x42716400UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x42716404UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x42716408UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271640CUL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x42716410UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x42716414UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x42716418UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271641CUL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x42716420UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x42716424UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x42716428UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271642CUL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x42716430UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x42716434UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x42716438UL))
#define bFM4_MFS11_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271643CUL))
#define bFM4_MFS11_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x42716480UL))
#define bFM4_MFS11_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x42716484UL))
#define bFM4_MFS11_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x42716488UL))
#define bFM4_MFS11_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271648CUL))
#define bFM4_MFS11_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x42716490UL))
#define bFM4_MFS11_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x42716498UL))
#define bFM4_MFS11_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271649CUL))
#define bFM4_MFS11_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x427164A0UL))
#define bFM4_MFS11_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x427164ACUL))
#define bFM4_MFS11_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x427164B0UL))
#define bFM4_MFS11_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x427164B4UL))
#define bFM4_MFS11_CSIO_STMR_TM0               *((volatile unsigned char*)(0x42716500UL))
#define bFM4_MFS11_CSIO_STMR_TM1               *((volatile unsigned char*)(0x42716504UL))
#define bFM4_MFS11_CSIO_STMR_TM2               *((volatile unsigned char*)(0x42716508UL))
#define bFM4_MFS11_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271650CUL))
#define bFM4_MFS11_CSIO_STMR_TM4               *((volatile unsigned char*)(0x42716510UL))
#define bFM4_MFS11_CSIO_STMR_TM5               *((volatile unsigned char*)(0x42716514UL))
#define bFM4_MFS11_CSIO_STMR_TM6               *((volatile unsigned char*)(0x42716518UL))
#define bFM4_MFS11_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271651CUL))
#define bFM4_MFS11_CSIO_STMR_TM8               *((volatile unsigned char*)(0x42716520UL))
#define bFM4_MFS11_CSIO_STMR_TM9               *((volatile unsigned char*)(0x42716524UL))
#define bFM4_MFS11_CSIO_STMR_TM10              *((volatile unsigned char*)(0x42716528UL))
#define bFM4_MFS11_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271652CUL))
#define bFM4_MFS11_CSIO_STMR_TM12              *((volatile unsigned char*)(0x42716530UL))
#define bFM4_MFS11_CSIO_STMR_TM13              *((volatile unsigned char*)(0x42716534UL))
#define bFM4_MFS11_CSIO_STMR_TM14              *((volatile unsigned char*)(0x42716538UL))
#define bFM4_MFS11_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271653CUL))
#define bFM4_MFS11_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x42716580UL))
#define bFM4_MFS11_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x42716584UL))
#define bFM4_MFS11_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x42716588UL))
#define bFM4_MFS11_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271658CUL))
#define bFM4_MFS11_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x42716590UL))
#define bFM4_MFS11_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x42716594UL))
#define bFM4_MFS11_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x42716598UL))
#define bFM4_MFS11_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271659CUL))
#define bFM4_MFS11_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x427165A0UL))
#define bFM4_MFS11_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x427165A4UL))
#define bFM4_MFS11_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x427165A8UL))
#define bFM4_MFS11_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x427165ACUL))
#define bFM4_MFS11_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x427165B0UL))
#define bFM4_MFS11_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x427165B4UL))
#define bFM4_MFS11_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x427165B8UL))
#define bFM4_MFS11_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x427165BCUL))
#define bFM4_MFS11_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x42716600UL))
#define bFM4_MFS11_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x42716604UL))
#define bFM4_MFS11_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x42716608UL))
#define bFM4_MFS11_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271660CUL))
#define bFM4_MFS11_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x42716610UL))
#define bFM4_MFS11_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x42716614UL))
#define bFM4_MFS11_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x42716618UL))
#define bFM4_MFS11_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271661CUL))
#define bFM4_MFS11_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x42716620UL))
#define bFM4_MFS11_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x42716624UL))
#define bFM4_MFS11_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x42716628UL))
#define bFM4_MFS11_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271662CUL))
#define bFM4_MFS11_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x42716630UL))
#define bFM4_MFS11_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x42716634UL))
#define bFM4_MFS11_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x42716638UL))
#define bFM4_MFS11_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271663CUL))
#define bFM4_MFS11_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x42716680UL))
#define bFM4_MFS11_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x42716684UL))
#define bFM4_MFS11_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x42716688UL))
#define bFM4_MFS11_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271668CUL))
#define bFM4_MFS11_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x42716690UL))
#define bFM4_MFS11_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x42716694UL))
#define bFM4_MFS11_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x42716698UL))
#define bFM4_MFS11_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271669CUL))
#define bFM4_MFS11_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x427166A0UL))
#define bFM4_MFS11_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x427166A4UL))
#define bFM4_MFS11_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x427166A8UL))
#define bFM4_MFS11_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x427166ACUL))
#define bFM4_MFS11_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x427166B0UL))
#define bFM4_MFS11_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x427166B4UL))
#define bFM4_MFS11_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x427166B8UL))
#define bFM4_MFS11_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x427166BCUL))
#define bFM4_MFS11_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x42716700UL))
#define bFM4_MFS11_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x42716704UL))
#define bFM4_MFS11_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x42716708UL))
#define bFM4_MFS11_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271670CUL))
#define bFM4_MFS11_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x42716710UL))
#define bFM4_MFS11_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x42716714UL))
#define bFM4_MFS11_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x42716718UL))
#define bFM4_MFS11_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271671CUL))

/* MFS LIN channel 11 registers */
#define bFM4_MFS11_LIN_SMR_SOE                 *((volatile unsigned char*)(0x42716000UL))
#define bFM4_MFS11_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271600CUL))
#define bFM4_MFS11_LIN_SMR_WUCR                *((volatile unsigned char*)(0x42716010UL))
#define bFM4_MFS11_LIN_SMR_MD0                 *((volatile unsigned char*)(0x42716014UL))
#define bFM4_MFS11_LIN_SMR_MD1                 *((volatile unsigned char*)(0x42716018UL))
#define bFM4_MFS11_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271601CUL))
#define bFM4_MFS11_LIN_SCR_TXE                 *((volatile unsigned char*)(0x42716020UL))
#define bFM4_MFS11_LIN_SCR_RXE                 *((volatile unsigned char*)(0x42716024UL))
#define bFM4_MFS11_LIN_SCR_TBIE                *((volatile unsigned char*)(0x42716028UL))
#define bFM4_MFS11_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271602CUL))
#define bFM4_MFS11_LIN_SCR_RIE                 *((volatile unsigned char*)(0x42716030UL))
#define bFM4_MFS11_LIN_SCR_LBR                 *((volatile unsigned char*)(0x42716034UL))
#define bFM4_MFS11_LIN_SCR_MS                  *((volatile unsigned char*)(0x42716038UL))
#define bFM4_MFS11_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271603CUL))
#define bFM4_MFS11_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x42716080UL))
#define bFM4_MFS11_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x42716084UL))
#define bFM4_MFS11_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x42716088UL))
#define bFM4_MFS11_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271608CUL))
#define bFM4_MFS11_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x42716090UL))
#define bFM4_MFS11_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x42716098UL))
#define bFM4_MFS11_LIN_SSR_TBI                 *((volatile unsigned char*)(0x427160A0UL))
#define bFM4_MFS11_LIN_SSR_TDRE                *((volatile unsigned char*)(0x427160A4UL))
#define bFM4_MFS11_LIN_SSR_RDRF                *((volatile unsigned char*)(0x427160A8UL))
#define bFM4_MFS11_LIN_SSR_ORE                 *((volatile unsigned char*)(0x427160ACUL))
#define bFM4_MFS11_LIN_SSR_FRE                 *((volatile unsigned char*)(0x427160B0UL))
#define bFM4_MFS11_LIN_SSR_LBD                 *((volatile unsigned char*)(0x427160B4UL))
#define bFM4_MFS11_LIN_SSR_REC                 *((volatile unsigned char*)(0x427160BCUL))
#define bFM4_MFS11_LIN_BGR_EXT                 *((volatile unsigned char*)(0x427161BCUL))
#define bFM4_MFS11_LIN_BGR1_EXT                *((volatile unsigned char*)(0x427161BCUL))
#define bFM4_MFS11_LIN_FCR_FE1                 *((volatile unsigned char*)(0x42716280UL))
#define bFM4_MFS11_LIN_FCR_FE2                 *((volatile unsigned char*)(0x42716284UL))
#define bFM4_MFS11_LIN_FCR_FCL1                *((volatile unsigned char*)(0x42716288UL))
#define bFM4_MFS11_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271628CUL))
#define bFM4_MFS11_LIN_FCR_FSET                *((volatile unsigned char*)(0x42716290UL))
#define bFM4_MFS11_LIN_FCR_FLD                 *((volatile unsigned char*)(0x42716294UL))
#define bFM4_MFS11_LIN_FCR_FLST                *((volatile unsigned char*)(0x42716298UL))
#define bFM4_MFS11_LIN_FCR_FSEL                *((volatile unsigned char*)(0x427162A0UL))
#define bFM4_MFS11_LIN_FCR_FTIE                *((volatile unsigned char*)(0x427162A4UL))
#define bFM4_MFS11_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x427162A8UL))
#define bFM4_MFS11_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x427162ACUL))
#define bFM4_MFS11_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x427162B0UL))
#define bFM4_MFS11_LIN_FCR0_FE1                *((volatile unsigned char*)(0x42716280UL))
#define bFM4_MFS11_LIN_FCR0_FE2                *((volatile unsigned char*)(0x42716284UL))
#define bFM4_MFS11_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x42716288UL))
#define bFM4_MFS11_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271628CUL))
#define bFM4_MFS11_LIN_FCR0_FSET               *((volatile unsigned char*)(0x42716290UL))
#define bFM4_MFS11_LIN_FCR0_FLD                *((volatile unsigned char*)(0x42716294UL))
#define bFM4_MFS11_LIN_FCR0_FLST               *((volatile unsigned char*)(0x42716298UL))
#define bFM4_MFS11_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x427162A0UL))
#define bFM4_MFS11_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x427162A4UL))
#define bFM4_MFS11_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x427162A8UL))
#define bFM4_MFS11_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x427162ACUL))
#define bFM4_MFS11_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x427162B0UL))
#define bFM4_MFS11_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x42716300UL))
#define bFM4_MFS11_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x42716304UL))
#define bFM4_MFS11_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x42716308UL))
#define bFM4_MFS11_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271630CUL))
#define bFM4_MFS11_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x42716310UL))
#define bFM4_MFS11_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x42716314UL))
#define bFM4_MFS11_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x42716318UL))
#define bFM4_MFS11_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271631CUL))
#define bFM4_MFS11_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x42716320UL))
#define bFM4_MFS11_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x42716324UL))
#define bFM4_MFS11_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x42716328UL))
#define bFM4_MFS11_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271632CUL))
#define bFM4_MFS11_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x42716330UL))
#define bFM4_MFS11_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x42716334UL))
#define bFM4_MFS11_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x42716338UL))
#define bFM4_MFS11_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271633CUL))
#define bFM4_MFS11_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x42716300UL))
#define bFM4_MFS11_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x42716304UL))
#define bFM4_MFS11_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x42716308UL))
#define bFM4_MFS11_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271630CUL))
#define bFM4_MFS11_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x42716310UL))
#define bFM4_MFS11_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x42716314UL))
#define bFM4_MFS11_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x42716318UL))
#define bFM4_MFS11_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271631CUL))
#define bFM4_MFS11_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x42716320UL))
#define bFM4_MFS11_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x42716324UL))
#define bFM4_MFS11_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x42716328UL))
#define bFM4_MFS11_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271632CUL))
#define bFM4_MFS11_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x42716330UL))
#define bFM4_MFS11_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x42716334UL))
#define bFM4_MFS11_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x42716338UL))
#define bFM4_MFS11_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271633CUL))

/* MFS I2C channel 11 registers */
#define bFM4_MFS11_I2C_SMR_TIE                 *((volatile unsigned char*)(0x42716008UL))
#define bFM4_MFS11_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271600CUL))
#define bFM4_MFS11_I2C_SMR_MD0                 *((volatile unsigned char*)(0x42716014UL))
#define bFM4_MFS11_I2C_SMR_MD1                 *((volatile unsigned char*)(0x42716018UL))
#define bFM4_MFS11_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271601CUL))
#define bFM4_MFS11_I2C_IBCR_INT                *((volatile unsigned char*)(0x42716020UL))
#define bFM4_MFS11_I2C_IBCR_BER                *((volatile unsigned char*)(0x42716024UL))
#define bFM4_MFS11_I2C_IBCR_INTE               *((volatile unsigned char*)(0x42716028UL))
#define bFM4_MFS11_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271602CUL))
#define bFM4_MFS11_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x42716030UL))
#define bFM4_MFS11_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x42716034UL))
#define bFM4_MFS11_I2C_IBCR_ACT                *((volatile unsigned char*)(0x42716038UL))
#define bFM4_MFS11_I2C_IBCR_SCC                *((volatile unsigned char*)(0x42716038UL))
#define bFM4_MFS11_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271603CUL))
#define bFM4_MFS11_I2C_IBSR_BB                 *((volatile unsigned char*)(0x42716080UL))
#define bFM4_MFS11_I2C_IBSR_SPC                *((volatile unsigned char*)(0x42716084UL))
#define bFM4_MFS11_I2C_IBSR_RSC                *((volatile unsigned char*)(0x42716088UL))
#define bFM4_MFS11_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271608CUL))
#define bFM4_MFS11_I2C_IBSR_TRX                *((volatile unsigned char*)(0x42716090UL))
#define bFM4_MFS11_I2C_IBSR_RSA                *((volatile unsigned char*)(0x42716094UL))
#define bFM4_MFS11_I2C_IBSR_RACK               *((volatile unsigned char*)(0x42716098UL))
#define bFM4_MFS11_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271609CUL))
#define bFM4_MFS11_I2C_SSR_TBI                 *((volatile unsigned char*)(0x427160A0UL))
#define bFM4_MFS11_I2C_SSR_TDRE                *((volatile unsigned char*)(0x427160A4UL))
#define bFM4_MFS11_I2C_SSR_RDRF                *((volatile unsigned char*)(0x427160A8UL))
#define bFM4_MFS11_I2C_SSR_ORE                 *((volatile unsigned char*)(0x427160ACUL))
#define bFM4_MFS11_I2C_SSR_TBIE                *((volatile unsigned char*)(0x427160B0UL))
#define bFM4_MFS11_I2C_SSR_DMA                 *((volatile unsigned char*)(0x427160B4UL))
#define bFM4_MFS11_I2C_SSR_TSET                *((volatile unsigned char*)(0x427160B8UL))
#define bFM4_MFS11_I2C_SSR_REC                 *((volatile unsigned char*)(0x427160BCUL))
#define bFM4_MFS11_I2C_ISBA_SA0                *((volatile unsigned char*)(0x42716200UL))
#define bFM4_MFS11_I2C_ISBA_SA1                *((volatile unsigned char*)(0x42716204UL))
#define bFM4_MFS11_I2C_ISBA_SA2                *((volatile unsigned char*)(0x42716208UL))
#define bFM4_MFS11_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271620CUL))
#define bFM4_MFS11_I2C_ISBA_SA4                *((volatile unsigned char*)(0x42716210UL))
#define bFM4_MFS11_I2C_ISBA_SA5                *((volatile unsigned char*)(0x42716214UL))
#define bFM4_MFS11_I2C_ISBA_SA6                *((volatile unsigned char*)(0x42716218UL))
#define bFM4_MFS11_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271621CUL))
#define bFM4_MFS11_I2C_ISMK_SM0                *((volatile unsigned char*)(0x42716220UL))
#define bFM4_MFS11_I2C_ISMK_SM1                *((volatile unsigned char*)(0x42716224UL))
#define bFM4_MFS11_I2C_ISMK_SM2                *((volatile unsigned char*)(0x42716228UL))
#define bFM4_MFS11_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271622CUL))
#define bFM4_MFS11_I2C_ISMK_SM4                *((volatile unsigned char*)(0x42716230UL))
#define bFM4_MFS11_I2C_ISMK_SM5                *((volatile unsigned char*)(0x42716234UL))
#define bFM4_MFS11_I2C_ISMK_SM6                *((volatile unsigned char*)(0x42716238UL))
#define bFM4_MFS11_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271623CUL))
#define bFM4_MFS11_I2C_FCR_FE1                 *((volatile unsigned char*)(0x42716280UL))
#define bFM4_MFS11_I2C_FCR_FE2                 *((volatile unsigned char*)(0x42716284UL))
#define bFM4_MFS11_I2C_FCR_FCL1                *((volatile unsigned char*)(0x42716288UL))
#define bFM4_MFS11_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271628CUL))
#define bFM4_MFS11_I2C_FCR_FSET                *((volatile unsigned char*)(0x42716290UL))
#define bFM4_MFS11_I2C_FCR_FLD                 *((volatile unsigned char*)(0x42716294UL))
#define bFM4_MFS11_I2C_FCR_FLST                *((volatile unsigned char*)(0x42716298UL))
#define bFM4_MFS11_I2C_FCR_FSEL                *((volatile unsigned char*)(0x427162A0UL))
#define bFM4_MFS11_I2C_FCR_FTIE                *((volatile unsigned char*)(0x427162A4UL))
#define bFM4_MFS11_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x427162A8UL))
#define bFM4_MFS11_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x427162ACUL))
#define bFM4_MFS11_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x427162B0UL))
#define bFM4_MFS11_I2C_FCR0_FE1                *((volatile unsigned char*)(0x42716280UL))
#define bFM4_MFS11_I2C_FCR0_FE2                *((volatile unsigned char*)(0x42716284UL))
#define bFM4_MFS11_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x42716288UL))
#define bFM4_MFS11_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271628CUL))
#define bFM4_MFS11_I2C_FCR0_FSET               *((volatile unsigned char*)(0x42716290UL))
#define bFM4_MFS11_I2C_FCR0_FLD                *((volatile unsigned char*)(0x42716294UL))
#define bFM4_MFS11_I2C_FCR0_FLST               *((volatile unsigned char*)(0x42716298UL))
#define bFM4_MFS11_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x427162A0UL))
#define bFM4_MFS11_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x427162A4UL))
#define bFM4_MFS11_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x427162A8UL))
#define bFM4_MFS11_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x427162ACUL))
#define bFM4_MFS11_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x427162B0UL))
#define bFM4_MFS11_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x42716300UL))
#define bFM4_MFS11_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x42716304UL))
#define bFM4_MFS11_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x42716308UL))
#define bFM4_MFS11_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271630CUL))
#define bFM4_MFS11_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x42716310UL))
#define bFM4_MFS11_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x42716314UL))
#define bFM4_MFS11_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x42716318UL))
#define bFM4_MFS11_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271631CUL))
#define bFM4_MFS11_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x42716320UL))
#define bFM4_MFS11_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x42716324UL))
#define bFM4_MFS11_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x42716328UL))
#define bFM4_MFS11_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271632CUL))
#define bFM4_MFS11_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x42716330UL))
#define bFM4_MFS11_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x42716334UL))
#define bFM4_MFS11_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x42716338UL))
#define bFM4_MFS11_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271633CUL))
#define bFM4_MFS11_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x42716300UL))
#define bFM4_MFS11_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x42716304UL))
#define bFM4_MFS11_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x42716308UL))
#define bFM4_MFS11_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271630CUL))
#define bFM4_MFS11_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x42716310UL))
#define bFM4_MFS11_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x42716314UL))
#define bFM4_MFS11_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x42716318UL))
#define bFM4_MFS11_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271631CUL))
#define bFM4_MFS11_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x42716320UL))
#define bFM4_MFS11_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x42716324UL))
#define bFM4_MFS11_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x42716328UL))
#define bFM4_MFS11_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271632CUL))
#define bFM4_MFS11_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x42716330UL))
#define bFM4_MFS11_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x42716334UL))
#define bFM4_MFS11_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x42716338UL))
#define bFM4_MFS11_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271633CUL))

/* MFS UART channel 12 registers */
#define bFM4_MFS12_UART_SMR_SOE                *((volatile unsigned char*)(0x42718000UL))
#define bFM4_MFS12_UART_SMR_BDS                *((volatile unsigned char*)(0x42718008UL))
#define bFM4_MFS12_UART_SMR_SBL                *((volatile unsigned char*)(0x4271800CUL))
#define bFM4_MFS12_UART_SMR_WUCR               *((volatile unsigned char*)(0x42718010UL))
#define bFM4_MFS12_UART_SMR_MD0                *((volatile unsigned char*)(0x42718014UL))
#define bFM4_MFS12_UART_SMR_MD1                *((volatile unsigned char*)(0x42718018UL))
#define bFM4_MFS12_UART_SMR_MD2                *((volatile unsigned char*)(0x4271801CUL))
#define bFM4_MFS12_UART_SCR_TXE                *((volatile unsigned char*)(0x42718020UL))
#define bFM4_MFS12_UART_SCR_RXE                *((volatile unsigned char*)(0x42718024UL))
#define bFM4_MFS12_UART_SCR_TBIE               *((volatile unsigned char*)(0x42718028UL))
#define bFM4_MFS12_UART_SCR_TIE                *((volatile unsigned char*)(0x4271802CUL))
#define bFM4_MFS12_UART_SCR_RIE                *((volatile unsigned char*)(0x42718030UL))
#define bFM4_MFS12_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271803CUL))
#define bFM4_MFS12_UART_ESCR_L0                *((volatile unsigned char*)(0x42718080UL))
#define bFM4_MFS12_UART_ESCR_L1                *((volatile unsigned char*)(0x42718084UL))
#define bFM4_MFS12_UART_ESCR_L2                *((volatile unsigned char*)(0x42718088UL))
#define bFM4_MFS12_UART_ESCR_P                 *((volatile unsigned char*)(0x4271808CUL))
#define bFM4_MFS12_UART_ESCR_PEN               *((volatile unsigned char*)(0x42718090UL))
#define bFM4_MFS12_UART_ESCR_INV               *((volatile unsigned char*)(0x42718094UL))
#define bFM4_MFS12_UART_ESCR_ESBL              *((volatile unsigned char*)(0x42718098UL))
#define bFM4_MFS12_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271809CUL))
#define bFM4_MFS12_UART_SSR_TBI                *((volatile unsigned char*)(0x427180A0UL))
#define bFM4_MFS12_UART_SSR_TDRE               *((volatile unsigned char*)(0x427180A4UL))
#define bFM4_MFS12_UART_SSR_RDRF               *((volatile unsigned char*)(0x427180A8UL))
#define bFM4_MFS12_UART_SSR_ORE                *((volatile unsigned char*)(0x427180ACUL))
#define bFM4_MFS12_UART_SSR_FRE                *((volatile unsigned char*)(0x427180B0UL))
#define bFM4_MFS12_UART_SSR_PE                 *((volatile unsigned char*)(0x427180B4UL))
#define bFM4_MFS12_UART_SSR_REC                *((volatile unsigned char*)(0x427180BCUL))
#define bFM4_MFS12_UART_BGR_EXT                *((volatile unsigned char*)(0x427181BCUL))
#define bFM4_MFS12_UART_BGR1_EXT               *((volatile unsigned char*)(0x427181BCUL))
#define bFM4_MFS12_UART_FCR_FE1                *((volatile unsigned char*)(0x42718280UL))
#define bFM4_MFS12_UART_FCR_FE2                *((volatile unsigned char*)(0x42718284UL))
#define bFM4_MFS12_UART_FCR_FCL1               *((volatile unsigned char*)(0x42718288UL))
#define bFM4_MFS12_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271828CUL))
#define bFM4_MFS12_UART_FCR_FSET               *((volatile unsigned char*)(0x42718290UL))
#define bFM4_MFS12_UART_FCR_FLD                *((volatile unsigned char*)(0x42718294UL))
#define bFM4_MFS12_UART_FCR_FLST               *((volatile unsigned char*)(0x42718298UL))
#define bFM4_MFS12_UART_FCR_FSEL               *((volatile unsigned char*)(0x427182A0UL))
#define bFM4_MFS12_UART_FCR_FTIE               *((volatile unsigned char*)(0x427182A4UL))
#define bFM4_MFS12_UART_FCR_FDRQ               *((volatile unsigned char*)(0x427182A8UL))
#define bFM4_MFS12_UART_FCR_FRIIE              *((volatile unsigned char*)(0x427182ACUL))
#define bFM4_MFS12_UART_FCR_FLSTE              *((volatile unsigned char*)(0x427182B0UL))
#define bFM4_MFS12_UART_FCR0_FE1               *((volatile unsigned char*)(0x42718280UL))
#define bFM4_MFS12_UART_FCR0_FE2               *((volatile unsigned char*)(0x42718284UL))
#define bFM4_MFS12_UART_FCR0_FCL1              *((volatile unsigned char*)(0x42718288UL))
#define bFM4_MFS12_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271828CUL))
#define bFM4_MFS12_UART_FCR0_FSET              *((volatile unsigned char*)(0x42718290UL))
#define bFM4_MFS12_UART_FCR0_FLD               *((volatile unsigned char*)(0x42718294UL))
#define bFM4_MFS12_UART_FCR0_FLST              *((volatile unsigned char*)(0x42718298UL))
#define bFM4_MFS12_UART_FCR1_FSEL              *((volatile unsigned char*)(0x427182A0UL))
#define bFM4_MFS12_UART_FCR1_FTIE              *((volatile unsigned char*)(0x427182A4UL))
#define bFM4_MFS12_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x427182A8UL))
#define bFM4_MFS12_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x427182ACUL))
#define bFM4_MFS12_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x427182B0UL))
#define bFM4_MFS12_UART_FBYTE_FD0              *((volatile unsigned char*)(0x42718300UL))
#define bFM4_MFS12_UART_FBYTE_FD1              *((volatile unsigned char*)(0x42718304UL))
#define bFM4_MFS12_UART_FBYTE_FD2              *((volatile unsigned char*)(0x42718308UL))
#define bFM4_MFS12_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271830CUL))
#define bFM4_MFS12_UART_FBYTE_FD4              *((volatile unsigned char*)(0x42718310UL))
#define bFM4_MFS12_UART_FBYTE_FD5              *((volatile unsigned char*)(0x42718314UL))
#define bFM4_MFS12_UART_FBYTE_FD6              *((volatile unsigned char*)(0x42718318UL))
#define bFM4_MFS12_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271831CUL))
#define bFM4_MFS12_UART_FBYTE_FD8              *((volatile unsigned char*)(0x42718320UL))
#define bFM4_MFS12_UART_FBYTE_FD9              *((volatile unsigned char*)(0x42718324UL))
#define bFM4_MFS12_UART_FBYTE_FD10             *((volatile unsigned char*)(0x42718328UL))
#define bFM4_MFS12_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271832CUL))
#define bFM4_MFS12_UART_FBYTE_FD12             *((volatile unsigned char*)(0x42718330UL))
#define bFM4_MFS12_UART_FBYTE_FD13             *((volatile unsigned char*)(0x42718334UL))
#define bFM4_MFS12_UART_FBYTE_FD14             *((volatile unsigned char*)(0x42718338UL))
#define bFM4_MFS12_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271833CUL))
#define bFM4_MFS12_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x42718300UL))
#define bFM4_MFS12_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x42718304UL))
#define bFM4_MFS12_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x42718308UL))
#define bFM4_MFS12_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271830CUL))
#define bFM4_MFS12_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x42718310UL))
#define bFM4_MFS12_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x42718314UL))
#define bFM4_MFS12_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x42718318UL))
#define bFM4_MFS12_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271831CUL))
#define bFM4_MFS12_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x42718320UL))
#define bFM4_MFS12_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x42718324UL))
#define bFM4_MFS12_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x42718328UL))
#define bFM4_MFS12_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271832CUL))
#define bFM4_MFS12_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x42718330UL))
#define bFM4_MFS12_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x42718334UL))
#define bFM4_MFS12_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x42718338UL))
#define bFM4_MFS12_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271833CUL))

/* MFS CSIO channel 12 registers */
#define bFM4_MFS12_CSIO_SMR_SOE                *((volatile unsigned char*)(0x42718000UL))
#define bFM4_MFS12_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x42718004UL))
#define bFM4_MFS12_CSIO_SMR_BDS                *((volatile unsigned char*)(0x42718008UL))
#define bFM4_MFS12_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271800CUL))
#define bFM4_MFS12_CSIO_SMR_MD0                *((volatile unsigned char*)(0x42718014UL))
#define bFM4_MFS12_CSIO_SMR_MD1                *((volatile unsigned char*)(0x42718018UL))
#define bFM4_MFS12_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271801CUL))
#define bFM4_MFS12_CSIO_SCR_TXE                *((volatile unsigned char*)(0x42718020UL))
#define bFM4_MFS12_CSIO_SCR_RXE                *((volatile unsigned char*)(0x42718024UL))
#define bFM4_MFS12_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x42718028UL))
#define bFM4_MFS12_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271802CUL))
#define bFM4_MFS12_CSIO_SCR_RIE                *((volatile unsigned char*)(0x42718030UL))
#define bFM4_MFS12_CSIO_SCR_SPI                *((volatile unsigned char*)(0x42718034UL))
#define bFM4_MFS12_CSIO_SCR_MS                 *((volatile unsigned char*)(0x42718038UL))
#define bFM4_MFS12_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271803CUL))
#define bFM4_MFS12_CSIO_ESCR_L0                *((volatile unsigned char*)(0x42718080UL))
#define bFM4_MFS12_CSIO_ESCR_L1                *((volatile unsigned char*)(0x42718084UL))
#define bFM4_MFS12_CSIO_ESCR_L2                *((volatile unsigned char*)(0x42718088UL))
#define bFM4_MFS12_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271808CUL))
#define bFM4_MFS12_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x42718090UL))
#define bFM4_MFS12_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x42718094UL))
#define bFM4_MFS12_CSIO_ESCR_L3                *((volatile unsigned char*)(0x42718098UL))
#define bFM4_MFS12_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271809CUL))
#define bFM4_MFS12_CSIO_SSR_TBI                *((volatile unsigned char*)(0x427180A0UL))
#define bFM4_MFS12_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x427180A4UL))
#define bFM4_MFS12_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x427180A8UL))
#define bFM4_MFS12_CSIO_SSR_ORE                *((volatile unsigned char*)(0x427180ACUL))
#define bFM4_MFS12_CSIO_SSR_AWC                *((volatile unsigned char*)(0x427180B0UL))
#define bFM4_MFS12_CSIO_SSR_REC                *((volatile unsigned char*)(0x427180BCUL))
#define bFM4_MFS12_CSIO_FCR_FE1                *((volatile unsigned char*)(0x42718280UL))
#define bFM4_MFS12_CSIO_FCR_FE2                *((volatile unsigned char*)(0x42718284UL))
#define bFM4_MFS12_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x42718288UL))
#define bFM4_MFS12_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271828CUL))
#define bFM4_MFS12_CSIO_FCR_FSET               *((volatile unsigned char*)(0x42718290UL))
#define bFM4_MFS12_CSIO_FCR_FLD                *((volatile unsigned char*)(0x42718294UL))
#define bFM4_MFS12_CSIO_FCR_FLST               *((volatile unsigned char*)(0x42718298UL))
#define bFM4_MFS12_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x427182A0UL))
#define bFM4_MFS12_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x427182A4UL))
#define bFM4_MFS12_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x427182A8UL))
#define bFM4_MFS12_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x427182ACUL))
#define bFM4_MFS12_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x427182B0UL))
#define bFM4_MFS12_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x42718280UL))
#define bFM4_MFS12_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x42718284UL))
#define bFM4_MFS12_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x42718288UL))
#define bFM4_MFS12_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271828CUL))
#define bFM4_MFS12_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x42718290UL))
#define bFM4_MFS12_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x42718294UL))
#define bFM4_MFS12_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x42718298UL))
#define bFM4_MFS12_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x427182A0UL))
#define bFM4_MFS12_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x427182A4UL))
#define bFM4_MFS12_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x427182A8UL))
#define bFM4_MFS12_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x427182ACUL))
#define bFM4_MFS12_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x427182B0UL))
#define bFM4_MFS12_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x42718300UL))
#define bFM4_MFS12_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x42718304UL))
#define bFM4_MFS12_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x42718308UL))
#define bFM4_MFS12_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271830CUL))
#define bFM4_MFS12_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x42718310UL))
#define bFM4_MFS12_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x42718314UL))
#define bFM4_MFS12_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x42718318UL))
#define bFM4_MFS12_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271831CUL))
#define bFM4_MFS12_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x42718320UL))
#define bFM4_MFS12_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x42718324UL))
#define bFM4_MFS12_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x42718328UL))
#define bFM4_MFS12_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271832CUL))
#define bFM4_MFS12_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x42718330UL))
#define bFM4_MFS12_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x42718334UL))
#define bFM4_MFS12_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x42718338UL))
#define bFM4_MFS12_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271833CUL))
#define bFM4_MFS12_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x42718300UL))
#define bFM4_MFS12_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x42718304UL))
#define bFM4_MFS12_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x42718308UL))
#define bFM4_MFS12_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271830CUL))
#define bFM4_MFS12_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x42718310UL))
#define bFM4_MFS12_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x42718314UL))
#define bFM4_MFS12_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x42718318UL))
#define bFM4_MFS12_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271831CUL))
#define bFM4_MFS12_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x42718320UL))
#define bFM4_MFS12_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x42718324UL))
#define bFM4_MFS12_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x42718328UL))
#define bFM4_MFS12_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271832CUL))
#define bFM4_MFS12_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x42718330UL))
#define bFM4_MFS12_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x42718334UL))
#define bFM4_MFS12_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x42718338UL))
#define bFM4_MFS12_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271833CUL))
#define bFM4_MFS12_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x42718380UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x42718384UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x42718388UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271838CUL))
#define bFM4_MFS12_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x42718390UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x42718394UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x42718398UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271839CUL))
#define bFM4_MFS12_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x427183A0UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x427183A4UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x427183A8UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x427183ACUL))
#define bFM4_MFS12_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x427183B0UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x427183B4UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x427183B8UL))
#define bFM4_MFS12_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x427183BCUL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x42718400UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x42718404UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x42718408UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271840CUL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x42718410UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x42718414UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x42718418UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271841CUL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x42718420UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x42718424UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x42718428UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271842CUL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x42718430UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x42718434UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x42718438UL))
#define bFM4_MFS12_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271843CUL))
#define bFM4_MFS12_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x42718480UL))
#define bFM4_MFS12_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x42718484UL))
#define bFM4_MFS12_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x42718488UL))
#define bFM4_MFS12_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271848CUL))
#define bFM4_MFS12_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x42718490UL))
#define bFM4_MFS12_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x42718498UL))
#define bFM4_MFS12_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271849CUL))
#define bFM4_MFS12_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x427184A0UL))
#define bFM4_MFS12_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x427184ACUL))
#define bFM4_MFS12_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x427184B0UL))
#define bFM4_MFS12_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x427184B4UL))
#define bFM4_MFS12_CSIO_STMR_TM0               *((volatile unsigned char*)(0x42718500UL))
#define bFM4_MFS12_CSIO_STMR_TM1               *((volatile unsigned char*)(0x42718504UL))
#define bFM4_MFS12_CSIO_STMR_TM2               *((volatile unsigned char*)(0x42718508UL))
#define bFM4_MFS12_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271850CUL))
#define bFM4_MFS12_CSIO_STMR_TM4               *((volatile unsigned char*)(0x42718510UL))
#define bFM4_MFS12_CSIO_STMR_TM5               *((volatile unsigned char*)(0x42718514UL))
#define bFM4_MFS12_CSIO_STMR_TM6               *((volatile unsigned char*)(0x42718518UL))
#define bFM4_MFS12_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271851CUL))
#define bFM4_MFS12_CSIO_STMR_TM8               *((volatile unsigned char*)(0x42718520UL))
#define bFM4_MFS12_CSIO_STMR_TM9               *((volatile unsigned char*)(0x42718524UL))
#define bFM4_MFS12_CSIO_STMR_TM10              *((volatile unsigned char*)(0x42718528UL))
#define bFM4_MFS12_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271852CUL))
#define bFM4_MFS12_CSIO_STMR_TM12              *((volatile unsigned char*)(0x42718530UL))
#define bFM4_MFS12_CSIO_STMR_TM13              *((volatile unsigned char*)(0x42718534UL))
#define bFM4_MFS12_CSIO_STMR_TM14              *((volatile unsigned char*)(0x42718538UL))
#define bFM4_MFS12_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271853CUL))
#define bFM4_MFS12_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x42718580UL))
#define bFM4_MFS12_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x42718584UL))
#define bFM4_MFS12_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x42718588UL))
#define bFM4_MFS12_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271858CUL))
#define bFM4_MFS12_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x42718590UL))
#define bFM4_MFS12_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x42718594UL))
#define bFM4_MFS12_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x42718598UL))
#define bFM4_MFS12_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271859CUL))
#define bFM4_MFS12_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x427185A0UL))
#define bFM4_MFS12_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x427185A4UL))
#define bFM4_MFS12_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x427185A8UL))
#define bFM4_MFS12_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x427185ACUL))
#define bFM4_MFS12_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x427185B0UL))
#define bFM4_MFS12_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x427185B4UL))
#define bFM4_MFS12_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x427185B8UL))
#define bFM4_MFS12_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x427185BCUL))
#define bFM4_MFS12_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x42718600UL))
#define bFM4_MFS12_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x42718604UL))
#define bFM4_MFS12_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x42718608UL))
#define bFM4_MFS12_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271860CUL))
#define bFM4_MFS12_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x42718610UL))
#define bFM4_MFS12_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x42718614UL))
#define bFM4_MFS12_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x42718618UL))
#define bFM4_MFS12_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271861CUL))
#define bFM4_MFS12_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x42718620UL))
#define bFM4_MFS12_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x42718624UL))
#define bFM4_MFS12_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x42718628UL))
#define bFM4_MFS12_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271862CUL))
#define bFM4_MFS12_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x42718630UL))
#define bFM4_MFS12_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x42718634UL))
#define bFM4_MFS12_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x42718638UL))
#define bFM4_MFS12_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271863CUL))
#define bFM4_MFS12_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x42718680UL))
#define bFM4_MFS12_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x42718684UL))
#define bFM4_MFS12_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x42718688UL))
#define bFM4_MFS12_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271868CUL))
#define bFM4_MFS12_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x42718690UL))
#define bFM4_MFS12_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x42718694UL))
#define bFM4_MFS12_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x42718698UL))
#define bFM4_MFS12_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271869CUL))
#define bFM4_MFS12_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x427186A0UL))
#define bFM4_MFS12_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x427186A4UL))
#define bFM4_MFS12_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x427186A8UL))
#define bFM4_MFS12_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x427186ACUL))
#define bFM4_MFS12_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x427186B0UL))
#define bFM4_MFS12_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x427186B4UL))
#define bFM4_MFS12_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x427186B8UL))
#define bFM4_MFS12_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x427186BCUL))
#define bFM4_MFS12_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x42718700UL))
#define bFM4_MFS12_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x42718704UL))
#define bFM4_MFS12_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x42718708UL))
#define bFM4_MFS12_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271870CUL))
#define bFM4_MFS12_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x42718710UL))
#define bFM4_MFS12_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x42718714UL))
#define bFM4_MFS12_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x42718718UL))
#define bFM4_MFS12_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271871CUL))

/* MFS LIN channel 12 registers */
#define bFM4_MFS12_LIN_SMR_SOE                 *((volatile unsigned char*)(0x42718000UL))
#define bFM4_MFS12_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271800CUL))
#define bFM4_MFS12_LIN_SMR_WUCR                *((volatile unsigned char*)(0x42718010UL))
#define bFM4_MFS12_LIN_SMR_MD0                 *((volatile unsigned char*)(0x42718014UL))
#define bFM4_MFS12_LIN_SMR_MD1                 *((volatile unsigned char*)(0x42718018UL))
#define bFM4_MFS12_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271801CUL))
#define bFM4_MFS12_LIN_SCR_TXE                 *((volatile unsigned char*)(0x42718020UL))
#define bFM4_MFS12_LIN_SCR_RXE                 *((volatile unsigned char*)(0x42718024UL))
#define bFM4_MFS12_LIN_SCR_TBIE                *((volatile unsigned char*)(0x42718028UL))
#define bFM4_MFS12_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271802CUL))
#define bFM4_MFS12_LIN_SCR_RIE                 *((volatile unsigned char*)(0x42718030UL))
#define bFM4_MFS12_LIN_SCR_LBR                 *((volatile unsigned char*)(0x42718034UL))
#define bFM4_MFS12_LIN_SCR_MS                  *((volatile unsigned char*)(0x42718038UL))
#define bFM4_MFS12_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271803CUL))
#define bFM4_MFS12_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x42718080UL))
#define bFM4_MFS12_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x42718084UL))
#define bFM4_MFS12_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x42718088UL))
#define bFM4_MFS12_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271808CUL))
#define bFM4_MFS12_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x42718090UL))
#define bFM4_MFS12_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x42718098UL))
#define bFM4_MFS12_LIN_SSR_TBI                 *((volatile unsigned char*)(0x427180A0UL))
#define bFM4_MFS12_LIN_SSR_TDRE                *((volatile unsigned char*)(0x427180A4UL))
#define bFM4_MFS12_LIN_SSR_RDRF                *((volatile unsigned char*)(0x427180A8UL))
#define bFM4_MFS12_LIN_SSR_ORE                 *((volatile unsigned char*)(0x427180ACUL))
#define bFM4_MFS12_LIN_SSR_FRE                 *((volatile unsigned char*)(0x427180B0UL))
#define bFM4_MFS12_LIN_SSR_LBD                 *((volatile unsigned char*)(0x427180B4UL))
#define bFM4_MFS12_LIN_SSR_REC                 *((volatile unsigned char*)(0x427180BCUL))
#define bFM4_MFS12_LIN_BGR_EXT                 *((volatile unsigned char*)(0x427181BCUL))
#define bFM4_MFS12_LIN_BGR1_EXT                *((volatile unsigned char*)(0x427181BCUL))
#define bFM4_MFS12_LIN_FCR_FE1                 *((volatile unsigned char*)(0x42718280UL))
#define bFM4_MFS12_LIN_FCR_FE2                 *((volatile unsigned char*)(0x42718284UL))
#define bFM4_MFS12_LIN_FCR_FCL1                *((volatile unsigned char*)(0x42718288UL))
#define bFM4_MFS12_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271828CUL))
#define bFM4_MFS12_LIN_FCR_FSET                *((volatile unsigned char*)(0x42718290UL))
#define bFM4_MFS12_LIN_FCR_FLD                 *((volatile unsigned char*)(0x42718294UL))
#define bFM4_MFS12_LIN_FCR_FLST                *((volatile unsigned char*)(0x42718298UL))
#define bFM4_MFS12_LIN_FCR_FSEL                *((volatile unsigned char*)(0x427182A0UL))
#define bFM4_MFS12_LIN_FCR_FTIE                *((volatile unsigned char*)(0x427182A4UL))
#define bFM4_MFS12_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x427182A8UL))
#define bFM4_MFS12_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x427182ACUL))
#define bFM4_MFS12_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x427182B0UL))
#define bFM4_MFS12_LIN_FCR0_FE1                *((volatile unsigned char*)(0x42718280UL))
#define bFM4_MFS12_LIN_FCR0_FE2                *((volatile unsigned char*)(0x42718284UL))
#define bFM4_MFS12_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x42718288UL))
#define bFM4_MFS12_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271828CUL))
#define bFM4_MFS12_LIN_FCR0_FSET               *((volatile unsigned char*)(0x42718290UL))
#define bFM4_MFS12_LIN_FCR0_FLD                *((volatile unsigned char*)(0x42718294UL))
#define bFM4_MFS12_LIN_FCR0_FLST               *((volatile unsigned char*)(0x42718298UL))
#define bFM4_MFS12_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x427182A0UL))
#define bFM4_MFS12_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x427182A4UL))
#define bFM4_MFS12_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x427182A8UL))
#define bFM4_MFS12_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x427182ACUL))
#define bFM4_MFS12_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x427182B0UL))
#define bFM4_MFS12_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x42718300UL))
#define bFM4_MFS12_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x42718304UL))
#define bFM4_MFS12_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x42718308UL))
#define bFM4_MFS12_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271830CUL))
#define bFM4_MFS12_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x42718310UL))
#define bFM4_MFS12_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x42718314UL))
#define bFM4_MFS12_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x42718318UL))
#define bFM4_MFS12_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271831CUL))
#define bFM4_MFS12_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x42718320UL))
#define bFM4_MFS12_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x42718324UL))
#define bFM4_MFS12_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x42718328UL))
#define bFM4_MFS12_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271832CUL))
#define bFM4_MFS12_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x42718330UL))
#define bFM4_MFS12_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x42718334UL))
#define bFM4_MFS12_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x42718338UL))
#define bFM4_MFS12_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271833CUL))
#define bFM4_MFS12_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x42718300UL))
#define bFM4_MFS12_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x42718304UL))
#define bFM4_MFS12_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x42718308UL))
#define bFM4_MFS12_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271830CUL))
#define bFM4_MFS12_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x42718310UL))
#define bFM4_MFS12_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x42718314UL))
#define bFM4_MFS12_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x42718318UL))
#define bFM4_MFS12_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271831CUL))
#define bFM4_MFS12_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x42718320UL))
#define bFM4_MFS12_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x42718324UL))
#define bFM4_MFS12_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x42718328UL))
#define bFM4_MFS12_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271832CUL))
#define bFM4_MFS12_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x42718330UL))
#define bFM4_MFS12_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x42718334UL))
#define bFM4_MFS12_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x42718338UL))
#define bFM4_MFS12_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271833CUL))

/* MFS I2C channel 12 registers */
#define bFM4_MFS12_I2C_SMR_TIE                 *((volatile unsigned char*)(0x42718008UL))
#define bFM4_MFS12_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271800CUL))
#define bFM4_MFS12_I2C_SMR_MD0                 *((volatile unsigned char*)(0x42718014UL))
#define bFM4_MFS12_I2C_SMR_MD1                 *((volatile unsigned char*)(0x42718018UL))
#define bFM4_MFS12_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271801CUL))
#define bFM4_MFS12_I2C_IBCR_INT                *((volatile unsigned char*)(0x42718020UL))
#define bFM4_MFS12_I2C_IBCR_BER                *((volatile unsigned char*)(0x42718024UL))
#define bFM4_MFS12_I2C_IBCR_INTE               *((volatile unsigned char*)(0x42718028UL))
#define bFM4_MFS12_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271802CUL))
#define bFM4_MFS12_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x42718030UL))
#define bFM4_MFS12_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x42718034UL))
#define bFM4_MFS12_I2C_IBCR_ACT                *((volatile unsigned char*)(0x42718038UL))
#define bFM4_MFS12_I2C_IBCR_SCC                *((volatile unsigned char*)(0x42718038UL))
#define bFM4_MFS12_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271803CUL))
#define bFM4_MFS12_I2C_IBSR_BB                 *((volatile unsigned char*)(0x42718080UL))
#define bFM4_MFS12_I2C_IBSR_SPC                *((volatile unsigned char*)(0x42718084UL))
#define bFM4_MFS12_I2C_IBSR_RSC                *((volatile unsigned char*)(0x42718088UL))
#define bFM4_MFS12_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271808CUL))
#define bFM4_MFS12_I2C_IBSR_TRX                *((volatile unsigned char*)(0x42718090UL))
#define bFM4_MFS12_I2C_IBSR_RSA                *((volatile unsigned char*)(0x42718094UL))
#define bFM4_MFS12_I2C_IBSR_RACK               *((volatile unsigned char*)(0x42718098UL))
#define bFM4_MFS12_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271809CUL))
#define bFM4_MFS12_I2C_SSR_TBI                 *((volatile unsigned char*)(0x427180A0UL))
#define bFM4_MFS12_I2C_SSR_TDRE                *((volatile unsigned char*)(0x427180A4UL))
#define bFM4_MFS12_I2C_SSR_RDRF                *((volatile unsigned char*)(0x427180A8UL))
#define bFM4_MFS12_I2C_SSR_ORE                 *((volatile unsigned char*)(0x427180ACUL))
#define bFM4_MFS12_I2C_SSR_TBIE                *((volatile unsigned char*)(0x427180B0UL))
#define bFM4_MFS12_I2C_SSR_DMA                 *((volatile unsigned char*)(0x427180B4UL))
#define bFM4_MFS12_I2C_SSR_TSET                *((volatile unsigned char*)(0x427180B8UL))
#define bFM4_MFS12_I2C_SSR_REC                 *((volatile unsigned char*)(0x427180BCUL))
#define bFM4_MFS12_I2C_ISBA_SA0                *((volatile unsigned char*)(0x42718200UL))
#define bFM4_MFS12_I2C_ISBA_SA1                *((volatile unsigned char*)(0x42718204UL))
#define bFM4_MFS12_I2C_ISBA_SA2                *((volatile unsigned char*)(0x42718208UL))
#define bFM4_MFS12_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271820CUL))
#define bFM4_MFS12_I2C_ISBA_SA4                *((volatile unsigned char*)(0x42718210UL))
#define bFM4_MFS12_I2C_ISBA_SA5                *((volatile unsigned char*)(0x42718214UL))
#define bFM4_MFS12_I2C_ISBA_SA6                *((volatile unsigned char*)(0x42718218UL))
#define bFM4_MFS12_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271821CUL))
#define bFM4_MFS12_I2C_ISMK_SM0                *((volatile unsigned char*)(0x42718220UL))
#define bFM4_MFS12_I2C_ISMK_SM1                *((volatile unsigned char*)(0x42718224UL))
#define bFM4_MFS12_I2C_ISMK_SM2                *((volatile unsigned char*)(0x42718228UL))
#define bFM4_MFS12_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271822CUL))
#define bFM4_MFS12_I2C_ISMK_SM4                *((volatile unsigned char*)(0x42718230UL))
#define bFM4_MFS12_I2C_ISMK_SM5                *((volatile unsigned char*)(0x42718234UL))
#define bFM4_MFS12_I2C_ISMK_SM6                *((volatile unsigned char*)(0x42718238UL))
#define bFM4_MFS12_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271823CUL))
#define bFM4_MFS12_I2C_FCR_FE1                 *((volatile unsigned char*)(0x42718280UL))
#define bFM4_MFS12_I2C_FCR_FE2                 *((volatile unsigned char*)(0x42718284UL))
#define bFM4_MFS12_I2C_FCR_FCL1                *((volatile unsigned char*)(0x42718288UL))
#define bFM4_MFS12_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271828CUL))
#define bFM4_MFS12_I2C_FCR_FSET                *((volatile unsigned char*)(0x42718290UL))
#define bFM4_MFS12_I2C_FCR_FLD                 *((volatile unsigned char*)(0x42718294UL))
#define bFM4_MFS12_I2C_FCR_FLST                *((volatile unsigned char*)(0x42718298UL))
#define bFM4_MFS12_I2C_FCR_FSEL                *((volatile unsigned char*)(0x427182A0UL))
#define bFM4_MFS12_I2C_FCR_FTIE                *((volatile unsigned char*)(0x427182A4UL))
#define bFM4_MFS12_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x427182A8UL))
#define bFM4_MFS12_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x427182ACUL))
#define bFM4_MFS12_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x427182B0UL))
#define bFM4_MFS12_I2C_FCR0_FE1                *((volatile unsigned char*)(0x42718280UL))
#define bFM4_MFS12_I2C_FCR0_FE2                *((volatile unsigned char*)(0x42718284UL))
#define bFM4_MFS12_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x42718288UL))
#define bFM4_MFS12_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271828CUL))
#define bFM4_MFS12_I2C_FCR0_FSET               *((volatile unsigned char*)(0x42718290UL))
#define bFM4_MFS12_I2C_FCR0_FLD                *((volatile unsigned char*)(0x42718294UL))
#define bFM4_MFS12_I2C_FCR0_FLST               *((volatile unsigned char*)(0x42718298UL))
#define bFM4_MFS12_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x427182A0UL))
#define bFM4_MFS12_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x427182A4UL))
#define bFM4_MFS12_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x427182A8UL))
#define bFM4_MFS12_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x427182ACUL))
#define bFM4_MFS12_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x427182B0UL))
#define bFM4_MFS12_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x42718300UL))
#define bFM4_MFS12_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x42718304UL))
#define bFM4_MFS12_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x42718308UL))
#define bFM4_MFS12_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271830CUL))
#define bFM4_MFS12_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x42718310UL))
#define bFM4_MFS12_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x42718314UL))
#define bFM4_MFS12_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x42718318UL))
#define bFM4_MFS12_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271831CUL))
#define bFM4_MFS12_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x42718320UL))
#define bFM4_MFS12_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x42718324UL))
#define bFM4_MFS12_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x42718328UL))
#define bFM4_MFS12_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271832CUL))
#define bFM4_MFS12_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x42718330UL))
#define bFM4_MFS12_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x42718334UL))
#define bFM4_MFS12_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x42718338UL))
#define bFM4_MFS12_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271833CUL))
#define bFM4_MFS12_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x42718300UL))
#define bFM4_MFS12_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x42718304UL))
#define bFM4_MFS12_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x42718308UL))
#define bFM4_MFS12_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271830CUL))
#define bFM4_MFS12_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x42718310UL))
#define bFM4_MFS12_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x42718314UL))
#define bFM4_MFS12_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x42718318UL))
#define bFM4_MFS12_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271831CUL))
#define bFM4_MFS12_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x42718320UL))
#define bFM4_MFS12_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x42718324UL))
#define bFM4_MFS12_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x42718328UL))
#define bFM4_MFS12_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271832CUL))
#define bFM4_MFS12_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x42718330UL))
#define bFM4_MFS12_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x42718334UL))
#define bFM4_MFS12_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x42718338UL))
#define bFM4_MFS12_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271833CUL))

/* MFS UART channel 13 registers */
#define bFM4_MFS13_UART_SMR_SOE                *((volatile unsigned char*)(0x4271A000UL))
#define bFM4_MFS13_UART_SMR_BDS                *((volatile unsigned char*)(0x4271A008UL))
#define bFM4_MFS13_UART_SMR_SBL                *((volatile unsigned char*)(0x4271A00CUL))
#define bFM4_MFS13_UART_SMR_WUCR               *((volatile unsigned char*)(0x4271A010UL))
#define bFM4_MFS13_UART_SMR_MD0                *((volatile unsigned char*)(0x4271A014UL))
#define bFM4_MFS13_UART_SMR_MD1                *((volatile unsigned char*)(0x4271A018UL))
#define bFM4_MFS13_UART_SMR_MD2                *((volatile unsigned char*)(0x4271A01CUL))
#define bFM4_MFS13_UART_SCR_TXE                *((volatile unsigned char*)(0x4271A020UL))
#define bFM4_MFS13_UART_SCR_RXE                *((volatile unsigned char*)(0x4271A024UL))
#define bFM4_MFS13_UART_SCR_TBIE               *((volatile unsigned char*)(0x4271A028UL))
#define bFM4_MFS13_UART_SCR_TIE                *((volatile unsigned char*)(0x4271A02CUL))
#define bFM4_MFS13_UART_SCR_RIE                *((volatile unsigned char*)(0x4271A030UL))
#define bFM4_MFS13_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271A03CUL))
#define bFM4_MFS13_UART_ESCR_L0                *((volatile unsigned char*)(0x4271A080UL))
#define bFM4_MFS13_UART_ESCR_L1                *((volatile unsigned char*)(0x4271A084UL))
#define bFM4_MFS13_UART_ESCR_L2                *((volatile unsigned char*)(0x4271A088UL))
#define bFM4_MFS13_UART_ESCR_P                 *((volatile unsigned char*)(0x4271A08CUL))
#define bFM4_MFS13_UART_ESCR_PEN               *((volatile unsigned char*)(0x4271A090UL))
#define bFM4_MFS13_UART_ESCR_INV               *((volatile unsigned char*)(0x4271A094UL))
#define bFM4_MFS13_UART_ESCR_ESBL              *((volatile unsigned char*)(0x4271A098UL))
#define bFM4_MFS13_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271A09CUL))
#define bFM4_MFS13_UART_SSR_TBI                *((volatile unsigned char*)(0x4271A0A0UL))
#define bFM4_MFS13_UART_SSR_TDRE               *((volatile unsigned char*)(0x4271A0A4UL))
#define bFM4_MFS13_UART_SSR_RDRF               *((volatile unsigned char*)(0x4271A0A8UL))
#define bFM4_MFS13_UART_SSR_ORE                *((volatile unsigned char*)(0x4271A0ACUL))
#define bFM4_MFS13_UART_SSR_FRE                *((volatile unsigned char*)(0x4271A0B0UL))
#define bFM4_MFS13_UART_SSR_PE                 *((volatile unsigned char*)(0x4271A0B4UL))
#define bFM4_MFS13_UART_SSR_REC                *((volatile unsigned char*)(0x4271A0BCUL))
#define bFM4_MFS13_UART_BGR_EXT                *((volatile unsigned char*)(0x4271A1BCUL))
#define bFM4_MFS13_UART_BGR1_EXT               *((volatile unsigned char*)(0x4271A1BCUL))
#define bFM4_MFS13_UART_FCR_FE1                *((volatile unsigned char*)(0x4271A280UL))
#define bFM4_MFS13_UART_FCR_FE2                *((volatile unsigned char*)(0x4271A284UL))
#define bFM4_MFS13_UART_FCR_FCL1               *((volatile unsigned char*)(0x4271A288UL))
#define bFM4_MFS13_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271A28CUL))
#define bFM4_MFS13_UART_FCR_FSET               *((volatile unsigned char*)(0x4271A290UL))
#define bFM4_MFS13_UART_FCR_FLD                *((volatile unsigned char*)(0x4271A294UL))
#define bFM4_MFS13_UART_FCR_FLST               *((volatile unsigned char*)(0x4271A298UL))
#define bFM4_MFS13_UART_FCR_FSEL               *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM4_MFS13_UART_FCR_FTIE               *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM4_MFS13_UART_FCR_FDRQ               *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM4_MFS13_UART_FCR_FRIIE              *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM4_MFS13_UART_FCR_FLSTE              *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM4_MFS13_UART_FCR0_FE1               *((volatile unsigned char*)(0x4271A280UL))
#define bFM4_MFS13_UART_FCR0_FE2               *((volatile unsigned char*)(0x4271A284UL))
#define bFM4_MFS13_UART_FCR0_FCL1              *((volatile unsigned char*)(0x4271A288UL))
#define bFM4_MFS13_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271A28CUL))
#define bFM4_MFS13_UART_FCR0_FSET              *((volatile unsigned char*)(0x4271A290UL))
#define bFM4_MFS13_UART_FCR0_FLD               *((volatile unsigned char*)(0x4271A294UL))
#define bFM4_MFS13_UART_FCR0_FLST              *((volatile unsigned char*)(0x4271A298UL))
#define bFM4_MFS13_UART_FCR1_FSEL              *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM4_MFS13_UART_FCR1_FTIE              *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM4_MFS13_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM4_MFS13_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM4_MFS13_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM4_MFS13_UART_FBYTE_FD0              *((volatile unsigned char*)(0x4271A300UL))
#define bFM4_MFS13_UART_FBYTE_FD1              *((volatile unsigned char*)(0x4271A304UL))
#define bFM4_MFS13_UART_FBYTE_FD2              *((volatile unsigned char*)(0x4271A308UL))
#define bFM4_MFS13_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271A30CUL))
#define bFM4_MFS13_UART_FBYTE_FD4              *((volatile unsigned char*)(0x4271A310UL))
#define bFM4_MFS13_UART_FBYTE_FD5              *((volatile unsigned char*)(0x4271A314UL))
#define bFM4_MFS13_UART_FBYTE_FD6              *((volatile unsigned char*)(0x4271A318UL))
#define bFM4_MFS13_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271A31CUL))
#define bFM4_MFS13_UART_FBYTE_FD8              *((volatile unsigned char*)(0x4271A320UL))
#define bFM4_MFS13_UART_FBYTE_FD9              *((volatile unsigned char*)(0x4271A324UL))
#define bFM4_MFS13_UART_FBYTE_FD10             *((volatile unsigned char*)(0x4271A328UL))
#define bFM4_MFS13_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271A32CUL))
#define bFM4_MFS13_UART_FBYTE_FD12             *((volatile unsigned char*)(0x4271A330UL))
#define bFM4_MFS13_UART_FBYTE_FD13             *((volatile unsigned char*)(0x4271A334UL))
#define bFM4_MFS13_UART_FBYTE_FD14             *((volatile unsigned char*)(0x4271A338UL))
#define bFM4_MFS13_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271A33CUL))
#define bFM4_MFS13_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x4271A300UL))
#define bFM4_MFS13_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x4271A304UL))
#define bFM4_MFS13_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x4271A308UL))
#define bFM4_MFS13_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271A30CUL))
#define bFM4_MFS13_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x4271A310UL))
#define bFM4_MFS13_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x4271A314UL))
#define bFM4_MFS13_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x4271A318UL))
#define bFM4_MFS13_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271A31CUL))
#define bFM4_MFS13_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x4271A320UL))
#define bFM4_MFS13_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x4271A324UL))
#define bFM4_MFS13_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x4271A328UL))
#define bFM4_MFS13_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271A32CUL))
#define bFM4_MFS13_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x4271A330UL))
#define bFM4_MFS13_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x4271A334UL))
#define bFM4_MFS13_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x4271A338UL))
#define bFM4_MFS13_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271A33CUL))

/* MFS CSIO channel 13 registers */
#define bFM4_MFS13_CSIO_SMR_SOE                *((volatile unsigned char*)(0x4271A000UL))
#define bFM4_MFS13_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x4271A004UL))
#define bFM4_MFS13_CSIO_SMR_BDS                *((volatile unsigned char*)(0x4271A008UL))
#define bFM4_MFS13_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271A00CUL))
#define bFM4_MFS13_CSIO_SMR_MD0                *((volatile unsigned char*)(0x4271A014UL))
#define bFM4_MFS13_CSIO_SMR_MD1                *((volatile unsigned char*)(0x4271A018UL))
#define bFM4_MFS13_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271A01CUL))
#define bFM4_MFS13_CSIO_SCR_TXE                *((volatile unsigned char*)(0x4271A020UL))
#define bFM4_MFS13_CSIO_SCR_RXE                *((volatile unsigned char*)(0x4271A024UL))
#define bFM4_MFS13_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x4271A028UL))
#define bFM4_MFS13_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271A02CUL))
#define bFM4_MFS13_CSIO_SCR_RIE                *((volatile unsigned char*)(0x4271A030UL))
#define bFM4_MFS13_CSIO_SCR_SPI                *((volatile unsigned char*)(0x4271A034UL))
#define bFM4_MFS13_CSIO_SCR_MS                 *((volatile unsigned char*)(0x4271A038UL))
#define bFM4_MFS13_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271A03CUL))
#define bFM4_MFS13_CSIO_ESCR_L0                *((volatile unsigned char*)(0x4271A080UL))
#define bFM4_MFS13_CSIO_ESCR_L1                *((volatile unsigned char*)(0x4271A084UL))
#define bFM4_MFS13_CSIO_ESCR_L2                *((volatile unsigned char*)(0x4271A088UL))
#define bFM4_MFS13_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271A08CUL))
#define bFM4_MFS13_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x4271A090UL))
#define bFM4_MFS13_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x4271A094UL))
#define bFM4_MFS13_CSIO_ESCR_L3                *((volatile unsigned char*)(0x4271A098UL))
#define bFM4_MFS13_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271A09CUL))
#define bFM4_MFS13_CSIO_SSR_TBI                *((volatile unsigned char*)(0x4271A0A0UL))
#define bFM4_MFS13_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x4271A0A4UL))
#define bFM4_MFS13_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x4271A0A8UL))
#define bFM4_MFS13_CSIO_SSR_ORE                *((volatile unsigned char*)(0x4271A0ACUL))
#define bFM4_MFS13_CSIO_SSR_AWC                *((volatile unsigned char*)(0x4271A0B0UL))
#define bFM4_MFS13_CSIO_SSR_REC                *((volatile unsigned char*)(0x4271A0BCUL))
#define bFM4_MFS13_CSIO_FCR_FE1                *((volatile unsigned char*)(0x4271A280UL))
#define bFM4_MFS13_CSIO_FCR_FE2                *((volatile unsigned char*)(0x4271A284UL))
#define bFM4_MFS13_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x4271A288UL))
#define bFM4_MFS13_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271A28CUL))
#define bFM4_MFS13_CSIO_FCR_FSET               *((volatile unsigned char*)(0x4271A290UL))
#define bFM4_MFS13_CSIO_FCR_FLD                *((volatile unsigned char*)(0x4271A294UL))
#define bFM4_MFS13_CSIO_FCR_FLST               *((volatile unsigned char*)(0x4271A298UL))
#define bFM4_MFS13_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM4_MFS13_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM4_MFS13_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM4_MFS13_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM4_MFS13_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM4_MFS13_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x4271A280UL))
#define bFM4_MFS13_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x4271A284UL))
#define bFM4_MFS13_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x4271A288UL))
#define bFM4_MFS13_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271A28CUL))
#define bFM4_MFS13_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x4271A290UL))
#define bFM4_MFS13_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x4271A294UL))
#define bFM4_MFS13_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x4271A298UL))
#define bFM4_MFS13_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM4_MFS13_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM4_MFS13_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM4_MFS13_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM4_MFS13_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM4_MFS13_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x4271A300UL))
#define bFM4_MFS13_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x4271A304UL))
#define bFM4_MFS13_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x4271A308UL))
#define bFM4_MFS13_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271A30CUL))
#define bFM4_MFS13_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x4271A310UL))
#define bFM4_MFS13_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x4271A314UL))
#define bFM4_MFS13_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x4271A318UL))
#define bFM4_MFS13_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271A31CUL))
#define bFM4_MFS13_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x4271A320UL))
#define bFM4_MFS13_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x4271A324UL))
#define bFM4_MFS13_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x4271A328UL))
#define bFM4_MFS13_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271A32CUL))
#define bFM4_MFS13_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x4271A330UL))
#define bFM4_MFS13_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x4271A334UL))
#define bFM4_MFS13_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x4271A338UL))
#define bFM4_MFS13_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271A33CUL))
#define bFM4_MFS13_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x4271A300UL))
#define bFM4_MFS13_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x4271A304UL))
#define bFM4_MFS13_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x4271A308UL))
#define bFM4_MFS13_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271A30CUL))
#define bFM4_MFS13_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x4271A310UL))
#define bFM4_MFS13_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x4271A314UL))
#define bFM4_MFS13_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x4271A318UL))
#define bFM4_MFS13_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271A31CUL))
#define bFM4_MFS13_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x4271A320UL))
#define bFM4_MFS13_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x4271A324UL))
#define bFM4_MFS13_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x4271A328UL))
#define bFM4_MFS13_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271A32CUL))
#define bFM4_MFS13_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x4271A330UL))
#define bFM4_MFS13_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x4271A334UL))
#define bFM4_MFS13_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x4271A338UL))
#define bFM4_MFS13_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271A33CUL))
#define bFM4_MFS13_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x4271A380UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x4271A384UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x4271A388UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271A38CUL))
#define bFM4_MFS13_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x4271A390UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x4271A394UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x4271A398UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271A39CUL))
#define bFM4_MFS13_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x4271A3A0UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x4271A3A4UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x4271A3A8UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x4271A3ACUL))
#define bFM4_MFS13_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x4271A3B0UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x4271A3B4UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x4271A3B8UL))
#define bFM4_MFS13_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x4271A3BCUL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x4271A400UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x4271A404UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x4271A408UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271A40CUL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x4271A410UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x4271A414UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x4271A418UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271A41CUL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x4271A420UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x4271A424UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x4271A428UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271A42CUL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x4271A430UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x4271A434UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x4271A438UL))
#define bFM4_MFS13_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271A43CUL))
#define bFM4_MFS13_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x4271A480UL))
#define bFM4_MFS13_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x4271A484UL))
#define bFM4_MFS13_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x4271A488UL))
#define bFM4_MFS13_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271A48CUL))
#define bFM4_MFS13_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x4271A490UL))
#define bFM4_MFS13_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x4271A498UL))
#define bFM4_MFS13_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271A49CUL))
#define bFM4_MFS13_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x4271A4A0UL))
#define bFM4_MFS13_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x4271A4ACUL))
#define bFM4_MFS13_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x4271A4B0UL))
#define bFM4_MFS13_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x4271A4B4UL))
#define bFM4_MFS13_CSIO_STMR_TM0               *((volatile unsigned char*)(0x4271A500UL))
#define bFM4_MFS13_CSIO_STMR_TM1               *((volatile unsigned char*)(0x4271A504UL))
#define bFM4_MFS13_CSIO_STMR_TM2               *((volatile unsigned char*)(0x4271A508UL))
#define bFM4_MFS13_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271A50CUL))
#define bFM4_MFS13_CSIO_STMR_TM4               *((volatile unsigned char*)(0x4271A510UL))
#define bFM4_MFS13_CSIO_STMR_TM5               *((volatile unsigned char*)(0x4271A514UL))
#define bFM4_MFS13_CSIO_STMR_TM6               *((volatile unsigned char*)(0x4271A518UL))
#define bFM4_MFS13_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271A51CUL))
#define bFM4_MFS13_CSIO_STMR_TM8               *((volatile unsigned char*)(0x4271A520UL))
#define bFM4_MFS13_CSIO_STMR_TM9               *((volatile unsigned char*)(0x4271A524UL))
#define bFM4_MFS13_CSIO_STMR_TM10              *((volatile unsigned char*)(0x4271A528UL))
#define bFM4_MFS13_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271A52CUL))
#define bFM4_MFS13_CSIO_STMR_TM12              *((volatile unsigned char*)(0x4271A530UL))
#define bFM4_MFS13_CSIO_STMR_TM13              *((volatile unsigned char*)(0x4271A534UL))
#define bFM4_MFS13_CSIO_STMR_TM14              *((volatile unsigned char*)(0x4271A538UL))
#define bFM4_MFS13_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271A53CUL))
#define bFM4_MFS13_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x4271A580UL))
#define bFM4_MFS13_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x4271A584UL))
#define bFM4_MFS13_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x4271A588UL))
#define bFM4_MFS13_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271A58CUL))
#define bFM4_MFS13_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x4271A590UL))
#define bFM4_MFS13_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x4271A594UL))
#define bFM4_MFS13_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x4271A598UL))
#define bFM4_MFS13_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271A59CUL))
#define bFM4_MFS13_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x4271A5A0UL))
#define bFM4_MFS13_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x4271A5A4UL))
#define bFM4_MFS13_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x4271A5A8UL))
#define bFM4_MFS13_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x4271A5ACUL))
#define bFM4_MFS13_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x4271A5B0UL))
#define bFM4_MFS13_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x4271A5B4UL))
#define bFM4_MFS13_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x4271A5B8UL))
#define bFM4_MFS13_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x4271A5BCUL))
#define bFM4_MFS13_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x4271A600UL))
#define bFM4_MFS13_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x4271A604UL))
#define bFM4_MFS13_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x4271A608UL))
#define bFM4_MFS13_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271A60CUL))
#define bFM4_MFS13_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x4271A610UL))
#define bFM4_MFS13_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x4271A614UL))
#define bFM4_MFS13_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x4271A618UL))
#define bFM4_MFS13_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271A61CUL))
#define bFM4_MFS13_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x4271A620UL))
#define bFM4_MFS13_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x4271A624UL))
#define bFM4_MFS13_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x4271A628UL))
#define bFM4_MFS13_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271A62CUL))
#define bFM4_MFS13_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x4271A630UL))
#define bFM4_MFS13_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x4271A634UL))
#define bFM4_MFS13_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x4271A638UL))
#define bFM4_MFS13_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271A63CUL))
#define bFM4_MFS13_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x4271A680UL))
#define bFM4_MFS13_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x4271A684UL))
#define bFM4_MFS13_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x4271A688UL))
#define bFM4_MFS13_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271A68CUL))
#define bFM4_MFS13_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x4271A690UL))
#define bFM4_MFS13_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x4271A694UL))
#define bFM4_MFS13_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x4271A698UL))
#define bFM4_MFS13_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271A69CUL))
#define bFM4_MFS13_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x4271A6A0UL))
#define bFM4_MFS13_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x4271A6A4UL))
#define bFM4_MFS13_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x4271A6A8UL))
#define bFM4_MFS13_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x4271A6ACUL))
#define bFM4_MFS13_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x4271A6B0UL))
#define bFM4_MFS13_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x4271A6B4UL))
#define bFM4_MFS13_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x4271A6B8UL))
#define bFM4_MFS13_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x4271A6BCUL))
#define bFM4_MFS13_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x4271A700UL))
#define bFM4_MFS13_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x4271A704UL))
#define bFM4_MFS13_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x4271A708UL))
#define bFM4_MFS13_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271A70CUL))
#define bFM4_MFS13_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x4271A710UL))
#define bFM4_MFS13_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x4271A714UL))
#define bFM4_MFS13_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x4271A718UL))
#define bFM4_MFS13_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271A71CUL))

/* MFS LIN channel 13 registers */
#define bFM4_MFS13_LIN_SMR_SOE                 *((volatile unsigned char*)(0x4271A000UL))
#define bFM4_MFS13_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271A00CUL))
#define bFM4_MFS13_LIN_SMR_WUCR                *((volatile unsigned char*)(0x4271A010UL))
#define bFM4_MFS13_LIN_SMR_MD0                 *((volatile unsigned char*)(0x4271A014UL))
#define bFM4_MFS13_LIN_SMR_MD1                 *((volatile unsigned char*)(0x4271A018UL))
#define bFM4_MFS13_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271A01CUL))
#define bFM4_MFS13_LIN_SCR_TXE                 *((volatile unsigned char*)(0x4271A020UL))
#define bFM4_MFS13_LIN_SCR_RXE                 *((volatile unsigned char*)(0x4271A024UL))
#define bFM4_MFS13_LIN_SCR_TBIE                *((volatile unsigned char*)(0x4271A028UL))
#define bFM4_MFS13_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271A02CUL))
#define bFM4_MFS13_LIN_SCR_RIE                 *((volatile unsigned char*)(0x4271A030UL))
#define bFM4_MFS13_LIN_SCR_LBR                 *((volatile unsigned char*)(0x4271A034UL))
#define bFM4_MFS13_LIN_SCR_MS                  *((volatile unsigned char*)(0x4271A038UL))
#define bFM4_MFS13_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271A03CUL))
#define bFM4_MFS13_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x4271A080UL))
#define bFM4_MFS13_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x4271A084UL))
#define bFM4_MFS13_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x4271A088UL))
#define bFM4_MFS13_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271A08CUL))
#define bFM4_MFS13_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x4271A090UL))
#define bFM4_MFS13_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x4271A098UL))
#define bFM4_MFS13_LIN_SSR_TBI                 *((volatile unsigned char*)(0x4271A0A0UL))
#define bFM4_MFS13_LIN_SSR_TDRE                *((volatile unsigned char*)(0x4271A0A4UL))
#define bFM4_MFS13_LIN_SSR_RDRF                *((volatile unsigned char*)(0x4271A0A8UL))
#define bFM4_MFS13_LIN_SSR_ORE                 *((volatile unsigned char*)(0x4271A0ACUL))
#define bFM4_MFS13_LIN_SSR_FRE                 *((volatile unsigned char*)(0x4271A0B0UL))
#define bFM4_MFS13_LIN_SSR_LBD                 *((volatile unsigned char*)(0x4271A0B4UL))
#define bFM4_MFS13_LIN_SSR_REC                 *((volatile unsigned char*)(0x4271A0BCUL))
#define bFM4_MFS13_LIN_BGR_EXT                 *((volatile unsigned char*)(0x4271A1BCUL))
#define bFM4_MFS13_LIN_BGR1_EXT                *((volatile unsigned char*)(0x4271A1BCUL))
#define bFM4_MFS13_LIN_FCR_FE1                 *((volatile unsigned char*)(0x4271A280UL))
#define bFM4_MFS13_LIN_FCR_FE2                 *((volatile unsigned char*)(0x4271A284UL))
#define bFM4_MFS13_LIN_FCR_FCL1                *((volatile unsigned char*)(0x4271A288UL))
#define bFM4_MFS13_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271A28CUL))
#define bFM4_MFS13_LIN_FCR_FSET                *((volatile unsigned char*)(0x4271A290UL))
#define bFM4_MFS13_LIN_FCR_FLD                 *((volatile unsigned char*)(0x4271A294UL))
#define bFM4_MFS13_LIN_FCR_FLST                *((volatile unsigned char*)(0x4271A298UL))
#define bFM4_MFS13_LIN_FCR_FSEL                *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM4_MFS13_LIN_FCR_FTIE                *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM4_MFS13_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM4_MFS13_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM4_MFS13_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM4_MFS13_LIN_FCR0_FE1                *((volatile unsigned char*)(0x4271A280UL))
#define bFM4_MFS13_LIN_FCR0_FE2                *((volatile unsigned char*)(0x4271A284UL))
#define bFM4_MFS13_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x4271A288UL))
#define bFM4_MFS13_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271A28CUL))
#define bFM4_MFS13_LIN_FCR0_FSET               *((volatile unsigned char*)(0x4271A290UL))
#define bFM4_MFS13_LIN_FCR0_FLD                *((volatile unsigned char*)(0x4271A294UL))
#define bFM4_MFS13_LIN_FCR0_FLST               *((volatile unsigned char*)(0x4271A298UL))
#define bFM4_MFS13_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM4_MFS13_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM4_MFS13_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM4_MFS13_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM4_MFS13_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM4_MFS13_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x4271A300UL))
#define bFM4_MFS13_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x4271A304UL))
#define bFM4_MFS13_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x4271A308UL))
#define bFM4_MFS13_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271A30CUL))
#define bFM4_MFS13_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x4271A310UL))
#define bFM4_MFS13_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x4271A314UL))
#define bFM4_MFS13_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x4271A318UL))
#define bFM4_MFS13_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271A31CUL))
#define bFM4_MFS13_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x4271A320UL))
#define bFM4_MFS13_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x4271A324UL))
#define bFM4_MFS13_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x4271A328UL))
#define bFM4_MFS13_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271A32CUL))
#define bFM4_MFS13_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x4271A330UL))
#define bFM4_MFS13_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x4271A334UL))
#define bFM4_MFS13_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x4271A338UL))
#define bFM4_MFS13_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271A33CUL))
#define bFM4_MFS13_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x4271A300UL))
#define bFM4_MFS13_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x4271A304UL))
#define bFM4_MFS13_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x4271A308UL))
#define bFM4_MFS13_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271A30CUL))
#define bFM4_MFS13_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x4271A310UL))
#define bFM4_MFS13_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x4271A314UL))
#define bFM4_MFS13_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x4271A318UL))
#define bFM4_MFS13_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271A31CUL))
#define bFM4_MFS13_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x4271A320UL))
#define bFM4_MFS13_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x4271A324UL))
#define bFM4_MFS13_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x4271A328UL))
#define bFM4_MFS13_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271A32CUL))
#define bFM4_MFS13_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x4271A330UL))
#define bFM4_MFS13_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x4271A334UL))
#define bFM4_MFS13_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x4271A338UL))
#define bFM4_MFS13_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271A33CUL))

/* MFS I2C channel 13 registers */
#define bFM4_MFS13_I2C_SMR_TIE                 *((volatile unsigned char*)(0x4271A008UL))
#define bFM4_MFS13_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271A00CUL))
#define bFM4_MFS13_I2C_SMR_MD0                 *((volatile unsigned char*)(0x4271A014UL))
#define bFM4_MFS13_I2C_SMR_MD1                 *((volatile unsigned char*)(0x4271A018UL))
#define bFM4_MFS13_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271A01CUL))
#define bFM4_MFS13_I2C_IBCR_INT                *((volatile unsigned char*)(0x4271A020UL))
#define bFM4_MFS13_I2C_IBCR_BER                *((volatile unsigned char*)(0x4271A024UL))
#define bFM4_MFS13_I2C_IBCR_INTE               *((volatile unsigned char*)(0x4271A028UL))
#define bFM4_MFS13_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271A02CUL))
#define bFM4_MFS13_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x4271A030UL))
#define bFM4_MFS13_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x4271A034UL))
#define bFM4_MFS13_I2C_IBCR_ACT                *((volatile unsigned char*)(0x4271A038UL))
#define bFM4_MFS13_I2C_IBCR_SCC                *((volatile unsigned char*)(0x4271A038UL))
#define bFM4_MFS13_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271A03CUL))
#define bFM4_MFS13_I2C_IBSR_BB                 *((volatile unsigned char*)(0x4271A080UL))
#define bFM4_MFS13_I2C_IBSR_SPC                *((volatile unsigned char*)(0x4271A084UL))
#define bFM4_MFS13_I2C_IBSR_RSC                *((volatile unsigned char*)(0x4271A088UL))
#define bFM4_MFS13_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271A08CUL))
#define bFM4_MFS13_I2C_IBSR_TRX                *((volatile unsigned char*)(0x4271A090UL))
#define bFM4_MFS13_I2C_IBSR_RSA                *((volatile unsigned char*)(0x4271A094UL))
#define bFM4_MFS13_I2C_IBSR_RACK               *((volatile unsigned char*)(0x4271A098UL))
#define bFM4_MFS13_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271A09CUL))
#define bFM4_MFS13_I2C_SSR_TBI                 *((volatile unsigned char*)(0x4271A0A0UL))
#define bFM4_MFS13_I2C_SSR_TDRE                *((volatile unsigned char*)(0x4271A0A4UL))
#define bFM4_MFS13_I2C_SSR_RDRF                *((volatile unsigned char*)(0x4271A0A8UL))
#define bFM4_MFS13_I2C_SSR_ORE                 *((volatile unsigned char*)(0x4271A0ACUL))
#define bFM4_MFS13_I2C_SSR_TBIE                *((volatile unsigned char*)(0x4271A0B0UL))
#define bFM4_MFS13_I2C_SSR_DMA                 *((volatile unsigned char*)(0x4271A0B4UL))
#define bFM4_MFS13_I2C_SSR_TSET                *((volatile unsigned char*)(0x4271A0B8UL))
#define bFM4_MFS13_I2C_SSR_REC                 *((volatile unsigned char*)(0x4271A0BCUL))
#define bFM4_MFS13_I2C_ISBA_SA0                *((volatile unsigned char*)(0x4271A200UL))
#define bFM4_MFS13_I2C_ISBA_SA1                *((volatile unsigned char*)(0x4271A204UL))
#define bFM4_MFS13_I2C_ISBA_SA2                *((volatile unsigned char*)(0x4271A208UL))
#define bFM4_MFS13_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271A20CUL))
#define bFM4_MFS13_I2C_ISBA_SA4                *((volatile unsigned char*)(0x4271A210UL))
#define bFM4_MFS13_I2C_ISBA_SA5                *((volatile unsigned char*)(0x4271A214UL))
#define bFM4_MFS13_I2C_ISBA_SA6                *((volatile unsigned char*)(0x4271A218UL))
#define bFM4_MFS13_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271A21CUL))
#define bFM4_MFS13_I2C_ISMK_SM0                *((volatile unsigned char*)(0x4271A220UL))
#define bFM4_MFS13_I2C_ISMK_SM1                *((volatile unsigned char*)(0x4271A224UL))
#define bFM4_MFS13_I2C_ISMK_SM2                *((volatile unsigned char*)(0x4271A228UL))
#define bFM4_MFS13_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271A22CUL))
#define bFM4_MFS13_I2C_ISMK_SM4                *((volatile unsigned char*)(0x4271A230UL))
#define bFM4_MFS13_I2C_ISMK_SM5                *((volatile unsigned char*)(0x4271A234UL))
#define bFM4_MFS13_I2C_ISMK_SM6                *((volatile unsigned char*)(0x4271A238UL))
#define bFM4_MFS13_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271A23CUL))
#define bFM4_MFS13_I2C_FCR_FE1                 *((volatile unsigned char*)(0x4271A280UL))
#define bFM4_MFS13_I2C_FCR_FE2                 *((volatile unsigned char*)(0x4271A284UL))
#define bFM4_MFS13_I2C_FCR_FCL1                *((volatile unsigned char*)(0x4271A288UL))
#define bFM4_MFS13_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271A28CUL))
#define bFM4_MFS13_I2C_FCR_FSET                *((volatile unsigned char*)(0x4271A290UL))
#define bFM4_MFS13_I2C_FCR_FLD                 *((volatile unsigned char*)(0x4271A294UL))
#define bFM4_MFS13_I2C_FCR_FLST                *((volatile unsigned char*)(0x4271A298UL))
#define bFM4_MFS13_I2C_FCR_FSEL                *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM4_MFS13_I2C_FCR_FTIE                *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM4_MFS13_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM4_MFS13_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM4_MFS13_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM4_MFS13_I2C_FCR0_FE1                *((volatile unsigned char*)(0x4271A280UL))
#define bFM4_MFS13_I2C_FCR0_FE2                *((volatile unsigned char*)(0x4271A284UL))
#define bFM4_MFS13_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x4271A288UL))
#define bFM4_MFS13_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271A28CUL))
#define bFM4_MFS13_I2C_FCR0_FSET               *((volatile unsigned char*)(0x4271A290UL))
#define bFM4_MFS13_I2C_FCR0_FLD                *((volatile unsigned char*)(0x4271A294UL))
#define bFM4_MFS13_I2C_FCR0_FLST               *((volatile unsigned char*)(0x4271A298UL))
#define bFM4_MFS13_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM4_MFS13_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM4_MFS13_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM4_MFS13_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM4_MFS13_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM4_MFS13_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x4271A300UL))
#define bFM4_MFS13_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x4271A304UL))
#define bFM4_MFS13_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x4271A308UL))
#define bFM4_MFS13_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271A30CUL))
#define bFM4_MFS13_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x4271A310UL))
#define bFM4_MFS13_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x4271A314UL))
#define bFM4_MFS13_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x4271A318UL))
#define bFM4_MFS13_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271A31CUL))
#define bFM4_MFS13_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x4271A320UL))
#define bFM4_MFS13_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x4271A324UL))
#define bFM4_MFS13_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x4271A328UL))
#define bFM4_MFS13_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271A32CUL))
#define bFM4_MFS13_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x4271A330UL))
#define bFM4_MFS13_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x4271A334UL))
#define bFM4_MFS13_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x4271A338UL))
#define bFM4_MFS13_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271A33CUL))
#define bFM4_MFS13_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x4271A300UL))
#define bFM4_MFS13_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x4271A304UL))
#define bFM4_MFS13_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x4271A308UL))
#define bFM4_MFS13_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271A30CUL))
#define bFM4_MFS13_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x4271A310UL))
#define bFM4_MFS13_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x4271A314UL))
#define bFM4_MFS13_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x4271A318UL))
#define bFM4_MFS13_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271A31CUL))
#define bFM4_MFS13_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x4271A320UL))
#define bFM4_MFS13_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x4271A324UL))
#define bFM4_MFS13_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x4271A328UL))
#define bFM4_MFS13_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271A32CUL))
#define bFM4_MFS13_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x4271A330UL))
#define bFM4_MFS13_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x4271A334UL))
#define bFM4_MFS13_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x4271A338UL))
#define bFM4_MFS13_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271A33CUL))

/* MFS UART channel 14 registers */
#define bFM4_MFS14_UART_SMR_SOE                *((volatile unsigned char*)(0x4271C000UL))
#define bFM4_MFS14_UART_SMR_BDS                *((volatile unsigned char*)(0x4271C008UL))
#define bFM4_MFS14_UART_SMR_SBL                *((volatile unsigned char*)(0x4271C00CUL))
#define bFM4_MFS14_UART_SMR_WUCR               *((volatile unsigned char*)(0x4271C010UL))
#define bFM4_MFS14_UART_SMR_MD0                *((volatile unsigned char*)(0x4271C014UL))
#define bFM4_MFS14_UART_SMR_MD1                *((volatile unsigned char*)(0x4271C018UL))
#define bFM4_MFS14_UART_SMR_MD2                *((volatile unsigned char*)(0x4271C01CUL))
#define bFM4_MFS14_UART_SCR_TXE                *((volatile unsigned char*)(0x4271C020UL))
#define bFM4_MFS14_UART_SCR_RXE                *((volatile unsigned char*)(0x4271C024UL))
#define bFM4_MFS14_UART_SCR_TBIE               *((volatile unsigned char*)(0x4271C028UL))
#define bFM4_MFS14_UART_SCR_TIE                *((volatile unsigned char*)(0x4271C02CUL))
#define bFM4_MFS14_UART_SCR_RIE                *((volatile unsigned char*)(0x4271C030UL))
#define bFM4_MFS14_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271C03CUL))
#define bFM4_MFS14_UART_ESCR_L0                *((volatile unsigned char*)(0x4271C080UL))
#define bFM4_MFS14_UART_ESCR_L1                *((volatile unsigned char*)(0x4271C084UL))
#define bFM4_MFS14_UART_ESCR_L2                *((volatile unsigned char*)(0x4271C088UL))
#define bFM4_MFS14_UART_ESCR_P                 *((volatile unsigned char*)(0x4271C08CUL))
#define bFM4_MFS14_UART_ESCR_PEN               *((volatile unsigned char*)(0x4271C090UL))
#define bFM4_MFS14_UART_ESCR_INV               *((volatile unsigned char*)(0x4271C094UL))
#define bFM4_MFS14_UART_ESCR_ESBL              *((volatile unsigned char*)(0x4271C098UL))
#define bFM4_MFS14_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271C09CUL))
#define bFM4_MFS14_UART_SSR_TBI                *((volatile unsigned char*)(0x4271C0A0UL))
#define bFM4_MFS14_UART_SSR_TDRE               *((volatile unsigned char*)(0x4271C0A4UL))
#define bFM4_MFS14_UART_SSR_RDRF               *((volatile unsigned char*)(0x4271C0A8UL))
#define bFM4_MFS14_UART_SSR_ORE                *((volatile unsigned char*)(0x4271C0ACUL))
#define bFM4_MFS14_UART_SSR_FRE                *((volatile unsigned char*)(0x4271C0B0UL))
#define bFM4_MFS14_UART_SSR_PE                 *((volatile unsigned char*)(0x4271C0B4UL))
#define bFM4_MFS14_UART_SSR_REC                *((volatile unsigned char*)(0x4271C0BCUL))
#define bFM4_MFS14_UART_BGR_EXT                *((volatile unsigned char*)(0x4271C1BCUL))
#define bFM4_MFS14_UART_BGR1_EXT               *((volatile unsigned char*)(0x4271C1BCUL))
#define bFM4_MFS14_UART_FCR_FE1                *((volatile unsigned char*)(0x4271C280UL))
#define bFM4_MFS14_UART_FCR_FE2                *((volatile unsigned char*)(0x4271C284UL))
#define bFM4_MFS14_UART_FCR_FCL1               *((volatile unsigned char*)(0x4271C288UL))
#define bFM4_MFS14_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271C28CUL))
#define bFM4_MFS14_UART_FCR_FSET               *((volatile unsigned char*)(0x4271C290UL))
#define bFM4_MFS14_UART_FCR_FLD                *((volatile unsigned char*)(0x4271C294UL))
#define bFM4_MFS14_UART_FCR_FLST               *((volatile unsigned char*)(0x4271C298UL))
#define bFM4_MFS14_UART_FCR_FSEL               *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM4_MFS14_UART_FCR_FTIE               *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM4_MFS14_UART_FCR_FDRQ               *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM4_MFS14_UART_FCR_FRIIE              *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM4_MFS14_UART_FCR_FLSTE              *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM4_MFS14_UART_FCR0_FE1               *((volatile unsigned char*)(0x4271C280UL))
#define bFM4_MFS14_UART_FCR0_FE2               *((volatile unsigned char*)(0x4271C284UL))
#define bFM4_MFS14_UART_FCR0_FCL1              *((volatile unsigned char*)(0x4271C288UL))
#define bFM4_MFS14_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271C28CUL))
#define bFM4_MFS14_UART_FCR0_FSET              *((volatile unsigned char*)(0x4271C290UL))
#define bFM4_MFS14_UART_FCR0_FLD               *((volatile unsigned char*)(0x4271C294UL))
#define bFM4_MFS14_UART_FCR0_FLST              *((volatile unsigned char*)(0x4271C298UL))
#define bFM4_MFS14_UART_FCR1_FSEL              *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM4_MFS14_UART_FCR1_FTIE              *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM4_MFS14_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM4_MFS14_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM4_MFS14_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM4_MFS14_UART_FBYTE_FD0              *((volatile unsigned char*)(0x4271C300UL))
#define bFM4_MFS14_UART_FBYTE_FD1              *((volatile unsigned char*)(0x4271C304UL))
#define bFM4_MFS14_UART_FBYTE_FD2              *((volatile unsigned char*)(0x4271C308UL))
#define bFM4_MFS14_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271C30CUL))
#define bFM4_MFS14_UART_FBYTE_FD4              *((volatile unsigned char*)(0x4271C310UL))
#define bFM4_MFS14_UART_FBYTE_FD5              *((volatile unsigned char*)(0x4271C314UL))
#define bFM4_MFS14_UART_FBYTE_FD6              *((volatile unsigned char*)(0x4271C318UL))
#define bFM4_MFS14_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271C31CUL))
#define bFM4_MFS14_UART_FBYTE_FD8              *((volatile unsigned char*)(0x4271C320UL))
#define bFM4_MFS14_UART_FBYTE_FD9              *((volatile unsigned char*)(0x4271C324UL))
#define bFM4_MFS14_UART_FBYTE_FD10             *((volatile unsigned char*)(0x4271C328UL))
#define bFM4_MFS14_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271C32CUL))
#define bFM4_MFS14_UART_FBYTE_FD12             *((volatile unsigned char*)(0x4271C330UL))
#define bFM4_MFS14_UART_FBYTE_FD13             *((volatile unsigned char*)(0x4271C334UL))
#define bFM4_MFS14_UART_FBYTE_FD14             *((volatile unsigned char*)(0x4271C338UL))
#define bFM4_MFS14_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271C33CUL))
#define bFM4_MFS14_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x4271C300UL))
#define bFM4_MFS14_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x4271C304UL))
#define bFM4_MFS14_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x4271C308UL))
#define bFM4_MFS14_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271C30CUL))
#define bFM4_MFS14_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x4271C310UL))
#define bFM4_MFS14_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x4271C314UL))
#define bFM4_MFS14_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x4271C318UL))
#define bFM4_MFS14_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271C31CUL))
#define bFM4_MFS14_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x4271C320UL))
#define bFM4_MFS14_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x4271C324UL))
#define bFM4_MFS14_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x4271C328UL))
#define bFM4_MFS14_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271C32CUL))
#define bFM4_MFS14_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x4271C330UL))
#define bFM4_MFS14_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x4271C334UL))
#define bFM4_MFS14_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x4271C338UL))
#define bFM4_MFS14_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271C33CUL))

/* MFS CSIO channel 14 registers */
#define bFM4_MFS14_CSIO_SMR_SOE                *((volatile unsigned char*)(0x4271C000UL))
#define bFM4_MFS14_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x4271C004UL))
#define bFM4_MFS14_CSIO_SMR_BDS                *((volatile unsigned char*)(0x4271C008UL))
#define bFM4_MFS14_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271C00CUL))
#define bFM4_MFS14_CSIO_SMR_MD0                *((volatile unsigned char*)(0x4271C014UL))
#define bFM4_MFS14_CSIO_SMR_MD1                *((volatile unsigned char*)(0x4271C018UL))
#define bFM4_MFS14_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271C01CUL))
#define bFM4_MFS14_CSIO_SCR_TXE                *((volatile unsigned char*)(0x4271C020UL))
#define bFM4_MFS14_CSIO_SCR_RXE                *((volatile unsigned char*)(0x4271C024UL))
#define bFM4_MFS14_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x4271C028UL))
#define bFM4_MFS14_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271C02CUL))
#define bFM4_MFS14_CSIO_SCR_RIE                *((volatile unsigned char*)(0x4271C030UL))
#define bFM4_MFS14_CSIO_SCR_SPI                *((volatile unsigned char*)(0x4271C034UL))
#define bFM4_MFS14_CSIO_SCR_MS                 *((volatile unsigned char*)(0x4271C038UL))
#define bFM4_MFS14_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271C03CUL))
#define bFM4_MFS14_CSIO_ESCR_L0                *((volatile unsigned char*)(0x4271C080UL))
#define bFM4_MFS14_CSIO_ESCR_L1                *((volatile unsigned char*)(0x4271C084UL))
#define bFM4_MFS14_CSIO_ESCR_L2                *((volatile unsigned char*)(0x4271C088UL))
#define bFM4_MFS14_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271C08CUL))
#define bFM4_MFS14_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x4271C090UL))
#define bFM4_MFS14_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x4271C094UL))
#define bFM4_MFS14_CSIO_ESCR_L3                *((volatile unsigned char*)(0x4271C098UL))
#define bFM4_MFS14_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271C09CUL))
#define bFM4_MFS14_CSIO_SSR_TBI                *((volatile unsigned char*)(0x4271C0A0UL))
#define bFM4_MFS14_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x4271C0A4UL))
#define bFM4_MFS14_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x4271C0A8UL))
#define bFM4_MFS14_CSIO_SSR_ORE                *((volatile unsigned char*)(0x4271C0ACUL))
#define bFM4_MFS14_CSIO_SSR_AWC                *((volatile unsigned char*)(0x4271C0B0UL))
#define bFM4_MFS14_CSIO_SSR_REC                *((volatile unsigned char*)(0x4271C0BCUL))
#define bFM4_MFS14_CSIO_FCR_FE1                *((volatile unsigned char*)(0x4271C280UL))
#define bFM4_MFS14_CSIO_FCR_FE2                *((volatile unsigned char*)(0x4271C284UL))
#define bFM4_MFS14_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x4271C288UL))
#define bFM4_MFS14_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271C28CUL))
#define bFM4_MFS14_CSIO_FCR_FSET               *((volatile unsigned char*)(0x4271C290UL))
#define bFM4_MFS14_CSIO_FCR_FLD                *((volatile unsigned char*)(0x4271C294UL))
#define bFM4_MFS14_CSIO_FCR_FLST               *((volatile unsigned char*)(0x4271C298UL))
#define bFM4_MFS14_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM4_MFS14_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM4_MFS14_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM4_MFS14_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM4_MFS14_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM4_MFS14_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x4271C280UL))
#define bFM4_MFS14_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x4271C284UL))
#define bFM4_MFS14_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x4271C288UL))
#define bFM4_MFS14_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271C28CUL))
#define bFM4_MFS14_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x4271C290UL))
#define bFM4_MFS14_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x4271C294UL))
#define bFM4_MFS14_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x4271C298UL))
#define bFM4_MFS14_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM4_MFS14_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM4_MFS14_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM4_MFS14_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM4_MFS14_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM4_MFS14_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x4271C300UL))
#define bFM4_MFS14_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x4271C304UL))
#define bFM4_MFS14_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x4271C308UL))
#define bFM4_MFS14_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271C30CUL))
#define bFM4_MFS14_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x4271C310UL))
#define bFM4_MFS14_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x4271C314UL))
#define bFM4_MFS14_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x4271C318UL))
#define bFM4_MFS14_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271C31CUL))
#define bFM4_MFS14_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x4271C320UL))
#define bFM4_MFS14_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x4271C324UL))
#define bFM4_MFS14_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x4271C328UL))
#define bFM4_MFS14_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271C32CUL))
#define bFM4_MFS14_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x4271C330UL))
#define bFM4_MFS14_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x4271C334UL))
#define bFM4_MFS14_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x4271C338UL))
#define bFM4_MFS14_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271C33CUL))
#define bFM4_MFS14_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x4271C300UL))
#define bFM4_MFS14_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x4271C304UL))
#define bFM4_MFS14_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x4271C308UL))
#define bFM4_MFS14_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271C30CUL))
#define bFM4_MFS14_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x4271C310UL))
#define bFM4_MFS14_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x4271C314UL))
#define bFM4_MFS14_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x4271C318UL))
#define bFM4_MFS14_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271C31CUL))
#define bFM4_MFS14_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x4271C320UL))
#define bFM4_MFS14_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x4271C324UL))
#define bFM4_MFS14_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x4271C328UL))
#define bFM4_MFS14_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271C32CUL))
#define bFM4_MFS14_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x4271C330UL))
#define bFM4_MFS14_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x4271C334UL))
#define bFM4_MFS14_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x4271C338UL))
#define bFM4_MFS14_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271C33CUL))
#define bFM4_MFS14_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x4271C380UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x4271C384UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x4271C388UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271C38CUL))
#define bFM4_MFS14_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x4271C390UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x4271C394UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x4271C398UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271C39CUL))
#define bFM4_MFS14_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x4271C3A0UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x4271C3A4UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x4271C3A8UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x4271C3ACUL))
#define bFM4_MFS14_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x4271C3B0UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x4271C3B4UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x4271C3B8UL))
#define bFM4_MFS14_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x4271C3BCUL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x4271C400UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x4271C404UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x4271C408UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271C40CUL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x4271C410UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x4271C414UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x4271C418UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271C41CUL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x4271C420UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x4271C424UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x4271C428UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271C42CUL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x4271C430UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x4271C434UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x4271C438UL))
#define bFM4_MFS14_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271C43CUL))
#define bFM4_MFS14_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x4271C480UL))
#define bFM4_MFS14_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x4271C484UL))
#define bFM4_MFS14_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x4271C488UL))
#define bFM4_MFS14_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271C48CUL))
#define bFM4_MFS14_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x4271C490UL))
#define bFM4_MFS14_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x4271C498UL))
#define bFM4_MFS14_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271C49CUL))
#define bFM4_MFS14_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x4271C4A0UL))
#define bFM4_MFS14_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x4271C4ACUL))
#define bFM4_MFS14_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x4271C4B0UL))
#define bFM4_MFS14_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x4271C4B4UL))
#define bFM4_MFS14_CSIO_STMR_TM0               *((volatile unsigned char*)(0x4271C500UL))
#define bFM4_MFS14_CSIO_STMR_TM1               *((volatile unsigned char*)(0x4271C504UL))
#define bFM4_MFS14_CSIO_STMR_TM2               *((volatile unsigned char*)(0x4271C508UL))
#define bFM4_MFS14_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271C50CUL))
#define bFM4_MFS14_CSIO_STMR_TM4               *((volatile unsigned char*)(0x4271C510UL))
#define bFM4_MFS14_CSIO_STMR_TM5               *((volatile unsigned char*)(0x4271C514UL))
#define bFM4_MFS14_CSIO_STMR_TM6               *((volatile unsigned char*)(0x4271C518UL))
#define bFM4_MFS14_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271C51CUL))
#define bFM4_MFS14_CSIO_STMR_TM8               *((volatile unsigned char*)(0x4271C520UL))
#define bFM4_MFS14_CSIO_STMR_TM9               *((volatile unsigned char*)(0x4271C524UL))
#define bFM4_MFS14_CSIO_STMR_TM10              *((volatile unsigned char*)(0x4271C528UL))
#define bFM4_MFS14_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271C52CUL))
#define bFM4_MFS14_CSIO_STMR_TM12              *((volatile unsigned char*)(0x4271C530UL))
#define bFM4_MFS14_CSIO_STMR_TM13              *((volatile unsigned char*)(0x4271C534UL))
#define bFM4_MFS14_CSIO_STMR_TM14              *((volatile unsigned char*)(0x4271C538UL))
#define bFM4_MFS14_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271C53CUL))
#define bFM4_MFS14_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x4271C580UL))
#define bFM4_MFS14_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x4271C584UL))
#define bFM4_MFS14_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x4271C588UL))
#define bFM4_MFS14_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271C58CUL))
#define bFM4_MFS14_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x4271C590UL))
#define bFM4_MFS14_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x4271C594UL))
#define bFM4_MFS14_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x4271C598UL))
#define bFM4_MFS14_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271C59CUL))
#define bFM4_MFS14_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x4271C5A0UL))
#define bFM4_MFS14_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x4271C5A4UL))
#define bFM4_MFS14_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x4271C5A8UL))
#define bFM4_MFS14_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x4271C5ACUL))
#define bFM4_MFS14_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x4271C5B0UL))
#define bFM4_MFS14_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x4271C5B4UL))
#define bFM4_MFS14_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x4271C5B8UL))
#define bFM4_MFS14_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x4271C5BCUL))
#define bFM4_MFS14_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x4271C600UL))
#define bFM4_MFS14_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x4271C604UL))
#define bFM4_MFS14_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x4271C608UL))
#define bFM4_MFS14_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271C60CUL))
#define bFM4_MFS14_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x4271C610UL))
#define bFM4_MFS14_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x4271C614UL))
#define bFM4_MFS14_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x4271C618UL))
#define bFM4_MFS14_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271C61CUL))
#define bFM4_MFS14_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x4271C620UL))
#define bFM4_MFS14_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x4271C624UL))
#define bFM4_MFS14_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x4271C628UL))
#define bFM4_MFS14_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271C62CUL))
#define bFM4_MFS14_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x4271C630UL))
#define bFM4_MFS14_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x4271C634UL))
#define bFM4_MFS14_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x4271C638UL))
#define bFM4_MFS14_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271C63CUL))
#define bFM4_MFS14_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x4271C680UL))
#define bFM4_MFS14_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x4271C684UL))
#define bFM4_MFS14_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x4271C688UL))
#define bFM4_MFS14_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271C68CUL))
#define bFM4_MFS14_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x4271C690UL))
#define bFM4_MFS14_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x4271C694UL))
#define bFM4_MFS14_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x4271C698UL))
#define bFM4_MFS14_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271C69CUL))
#define bFM4_MFS14_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x4271C6A0UL))
#define bFM4_MFS14_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x4271C6A4UL))
#define bFM4_MFS14_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x4271C6A8UL))
#define bFM4_MFS14_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x4271C6ACUL))
#define bFM4_MFS14_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x4271C6B0UL))
#define bFM4_MFS14_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x4271C6B4UL))
#define bFM4_MFS14_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x4271C6B8UL))
#define bFM4_MFS14_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x4271C6BCUL))
#define bFM4_MFS14_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x4271C700UL))
#define bFM4_MFS14_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x4271C704UL))
#define bFM4_MFS14_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x4271C708UL))
#define bFM4_MFS14_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271C70CUL))
#define bFM4_MFS14_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x4271C710UL))
#define bFM4_MFS14_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x4271C714UL))
#define bFM4_MFS14_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x4271C718UL))
#define bFM4_MFS14_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271C71CUL))

/* MFS LIN channel 14 registers */
#define bFM4_MFS14_LIN_SMR_SOE                 *((volatile unsigned char*)(0x4271C000UL))
#define bFM4_MFS14_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271C00CUL))
#define bFM4_MFS14_LIN_SMR_WUCR                *((volatile unsigned char*)(0x4271C010UL))
#define bFM4_MFS14_LIN_SMR_MD0                 *((volatile unsigned char*)(0x4271C014UL))
#define bFM4_MFS14_LIN_SMR_MD1                 *((volatile unsigned char*)(0x4271C018UL))
#define bFM4_MFS14_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271C01CUL))
#define bFM4_MFS14_LIN_SCR_TXE                 *((volatile unsigned char*)(0x4271C020UL))
#define bFM4_MFS14_LIN_SCR_RXE                 *((volatile unsigned char*)(0x4271C024UL))
#define bFM4_MFS14_LIN_SCR_TBIE                *((volatile unsigned char*)(0x4271C028UL))
#define bFM4_MFS14_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271C02CUL))
#define bFM4_MFS14_LIN_SCR_RIE                 *((volatile unsigned char*)(0x4271C030UL))
#define bFM4_MFS14_LIN_SCR_LBR                 *((volatile unsigned char*)(0x4271C034UL))
#define bFM4_MFS14_LIN_SCR_MS                  *((volatile unsigned char*)(0x4271C038UL))
#define bFM4_MFS14_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271C03CUL))
#define bFM4_MFS14_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x4271C080UL))
#define bFM4_MFS14_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x4271C084UL))
#define bFM4_MFS14_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x4271C088UL))
#define bFM4_MFS14_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271C08CUL))
#define bFM4_MFS14_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x4271C090UL))
#define bFM4_MFS14_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x4271C098UL))
#define bFM4_MFS14_LIN_SSR_TBI                 *((volatile unsigned char*)(0x4271C0A0UL))
#define bFM4_MFS14_LIN_SSR_TDRE                *((volatile unsigned char*)(0x4271C0A4UL))
#define bFM4_MFS14_LIN_SSR_RDRF                *((volatile unsigned char*)(0x4271C0A8UL))
#define bFM4_MFS14_LIN_SSR_ORE                 *((volatile unsigned char*)(0x4271C0ACUL))
#define bFM4_MFS14_LIN_SSR_FRE                 *((volatile unsigned char*)(0x4271C0B0UL))
#define bFM4_MFS14_LIN_SSR_LBD                 *((volatile unsigned char*)(0x4271C0B4UL))
#define bFM4_MFS14_LIN_SSR_REC                 *((volatile unsigned char*)(0x4271C0BCUL))
#define bFM4_MFS14_LIN_BGR_EXT                 *((volatile unsigned char*)(0x4271C1BCUL))
#define bFM4_MFS14_LIN_BGR1_EXT                *((volatile unsigned char*)(0x4271C1BCUL))
#define bFM4_MFS14_LIN_FCR_FE1                 *((volatile unsigned char*)(0x4271C280UL))
#define bFM4_MFS14_LIN_FCR_FE2                 *((volatile unsigned char*)(0x4271C284UL))
#define bFM4_MFS14_LIN_FCR_FCL1                *((volatile unsigned char*)(0x4271C288UL))
#define bFM4_MFS14_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271C28CUL))
#define bFM4_MFS14_LIN_FCR_FSET                *((volatile unsigned char*)(0x4271C290UL))
#define bFM4_MFS14_LIN_FCR_FLD                 *((volatile unsigned char*)(0x4271C294UL))
#define bFM4_MFS14_LIN_FCR_FLST                *((volatile unsigned char*)(0x4271C298UL))
#define bFM4_MFS14_LIN_FCR_FSEL                *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM4_MFS14_LIN_FCR_FTIE                *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM4_MFS14_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM4_MFS14_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM4_MFS14_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM4_MFS14_LIN_FCR0_FE1                *((volatile unsigned char*)(0x4271C280UL))
#define bFM4_MFS14_LIN_FCR0_FE2                *((volatile unsigned char*)(0x4271C284UL))
#define bFM4_MFS14_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x4271C288UL))
#define bFM4_MFS14_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271C28CUL))
#define bFM4_MFS14_LIN_FCR0_FSET               *((volatile unsigned char*)(0x4271C290UL))
#define bFM4_MFS14_LIN_FCR0_FLD                *((volatile unsigned char*)(0x4271C294UL))
#define bFM4_MFS14_LIN_FCR0_FLST               *((volatile unsigned char*)(0x4271C298UL))
#define bFM4_MFS14_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM4_MFS14_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM4_MFS14_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM4_MFS14_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM4_MFS14_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM4_MFS14_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x4271C300UL))
#define bFM4_MFS14_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x4271C304UL))
#define bFM4_MFS14_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x4271C308UL))
#define bFM4_MFS14_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271C30CUL))
#define bFM4_MFS14_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x4271C310UL))
#define bFM4_MFS14_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x4271C314UL))
#define bFM4_MFS14_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x4271C318UL))
#define bFM4_MFS14_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271C31CUL))
#define bFM4_MFS14_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x4271C320UL))
#define bFM4_MFS14_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x4271C324UL))
#define bFM4_MFS14_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x4271C328UL))
#define bFM4_MFS14_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271C32CUL))
#define bFM4_MFS14_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x4271C330UL))
#define bFM4_MFS14_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x4271C334UL))
#define bFM4_MFS14_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x4271C338UL))
#define bFM4_MFS14_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271C33CUL))
#define bFM4_MFS14_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x4271C300UL))
#define bFM4_MFS14_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x4271C304UL))
#define bFM4_MFS14_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x4271C308UL))
#define bFM4_MFS14_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271C30CUL))
#define bFM4_MFS14_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x4271C310UL))
#define bFM4_MFS14_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x4271C314UL))
#define bFM4_MFS14_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x4271C318UL))
#define bFM4_MFS14_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271C31CUL))
#define bFM4_MFS14_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x4271C320UL))
#define bFM4_MFS14_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x4271C324UL))
#define bFM4_MFS14_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x4271C328UL))
#define bFM4_MFS14_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271C32CUL))
#define bFM4_MFS14_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x4271C330UL))
#define bFM4_MFS14_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x4271C334UL))
#define bFM4_MFS14_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x4271C338UL))
#define bFM4_MFS14_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271C33CUL))

/* MFS I2C channel 14 registers */
#define bFM4_MFS14_I2C_SMR_TIE                 *((volatile unsigned char*)(0x4271C008UL))
#define bFM4_MFS14_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271C00CUL))
#define bFM4_MFS14_I2C_SMR_MD0                 *((volatile unsigned char*)(0x4271C014UL))
#define bFM4_MFS14_I2C_SMR_MD1                 *((volatile unsigned char*)(0x4271C018UL))
#define bFM4_MFS14_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271C01CUL))
#define bFM4_MFS14_I2C_IBCR_INT                *((volatile unsigned char*)(0x4271C020UL))
#define bFM4_MFS14_I2C_IBCR_BER                *((volatile unsigned char*)(0x4271C024UL))
#define bFM4_MFS14_I2C_IBCR_INTE               *((volatile unsigned char*)(0x4271C028UL))
#define bFM4_MFS14_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271C02CUL))
#define bFM4_MFS14_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x4271C030UL))
#define bFM4_MFS14_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x4271C034UL))
#define bFM4_MFS14_I2C_IBCR_ACT                *((volatile unsigned char*)(0x4271C038UL))
#define bFM4_MFS14_I2C_IBCR_SCC                *((volatile unsigned char*)(0x4271C038UL))
#define bFM4_MFS14_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271C03CUL))
#define bFM4_MFS14_I2C_IBSR_BB                 *((volatile unsigned char*)(0x4271C080UL))
#define bFM4_MFS14_I2C_IBSR_SPC                *((volatile unsigned char*)(0x4271C084UL))
#define bFM4_MFS14_I2C_IBSR_RSC                *((volatile unsigned char*)(0x4271C088UL))
#define bFM4_MFS14_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271C08CUL))
#define bFM4_MFS14_I2C_IBSR_TRX                *((volatile unsigned char*)(0x4271C090UL))
#define bFM4_MFS14_I2C_IBSR_RSA                *((volatile unsigned char*)(0x4271C094UL))
#define bFM4_MFS14_I2C_IBSR_RACK               *((volatile unsigned char*)(0x4271C098UL))
#define bFM4_MFS14_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271C09CUL))
#define bFM4_MFS14_I2C_SSR_TBI                 *((volatile unsigned char*)(0x4271C0A0UL))
#define bFM4_MFS14_I2C_SSR_TDRE                *((volatile unsigned char*)(0x4271C0A4UL))
#define bFM4_MFS14_I2C_SSR_RDRF                *((volatile unsigned char*)(0x4271C0A8UL))
#define bFM4_MFS14_I2C_SSR_ORE                 *((volatile unsigned char*)(0x4271C0ACUL))
#define bFM4_MFS14_I2C_SSR_TBIE                *((volatile unsigned char*)(0x4271C0B0UL))
#define bFM4_MFS14_I2C_SSR_DMA                 *((volatile unsigned char*)(0x4271C0B4UL))
#define bFM4_MFS14_I2C_SSR_TSET                *((volatile unsigned char*)(0x4271C0B8UL))
#define bFM4_MFS14_I2C_SSR_REC                 *((volatile unsigned char*)(0x4271C0BCUL))
#define bFM4_MFS14_I2C_ISBA_SA0                *((volatile unsigned char*)(0x4271C200UL))
#define bFM4_MFS14_I2C_ISBA_SA1                *((volatile unsigned char*)(0x4271C204UL))
#define bFM4_MFS14_I2C_ISBA_SA2                *((volatile unsigned char*)(0x4271C208UL))
#define bFM4_MFS14_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271C20CUL))
#define bFM4_MFS14_I2C_ISBA_SA4                *((volatile unsigned char*)(0x4271C210UL))
#define bFM4_MFS14_I2C_ISBA_SA5                *((volatile unsigned char*)(0x4271C214UL))
#define bFM4_MFS14_I2C_ISBA_SA6                *((volatile unsigned char*)(0x4271C218UL))
#define bFM4_MFS14_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271C21CUL))
#define bFM4_MFS14_I2C_ISMK_SM0                *((volatile unsigned char*)(0x4271C220UL))
#define bFM4_MFS14_I2C_ISMK_SM1                *((volatile unsigned char*)(0x4271C224UL))
#define bFM4_MFS14_I2C_ISMK_SM2                *((volatile unsigned char*)(0x4271C228UL))
#define bFM4_MFS14_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271C22CUL))
#define bFM4_MFS14_I2C_ISMK_SM4                *((volatile unsigned char*)(0x4271C230UL))
#define bFM4_MFS14_I2C_ISMK_SM5                *((volatile unsigned char*)(0x4271C234UL))
#define bFM4_MFS14_I2C_ISMK_SM6                *((volatile unsigned char*)(0x4271C238UL))
#define bFM4_MFS14_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271C23CUL))
#define bFM4_MFS14_I2C_FCR_FE1                 *((volatile unsigned char*)(0x4271C280UL))
#define bFM4_MFS14_I2C_FCR_FE2                 *((volatile unsigned char*)(0x4271C284UL))
#define bFM4_MFS14_I2C_FCR_FCL1                *((volatile unsigned char*)(0x4271C288UL))
#define bFM4_MFS14_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271C28CUL))
#define bFM4_MFS14_I2C_FCR_FSET                *((volatile unsigned char*)(0x4271C290UL))
#define bFM4_MFS14_I2C_FCR_FLD                 *((volatile unsigned char*)(0x4271C294UL))
#define bFM4_MFS14_I2C_FCR_FLST                *((volatile unsigned char*)(0x4271C298UL))
#define bFM4_MFS14_I2C_FCR_FSEL                *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM4_MFS14_I2C_FCR_FTIE                *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM4_MFS14_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM4_MFS14_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM4_MFS14_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM4_MFS14_I2C_FCR0_FE1                *((volatile unsigned char*)(0x4271C280UL))
#define bFM4_MFS14_I2C_FCR0_FE2                *((volatile unsigned char*)(0x4271C284UL))
#define bFM4_MFS14_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x4271C288UL))
#define bFM4_MFS14_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271C28CUL))
#define bFM4_MFS14_I2C_FCR0_FSET               *((volatile unsigned char*)(0x4271C290UL))
#define bFM4_MFS14_I2C_FCR0_FLD                *((volatile unsigned char*)(0x4271C294UL))
#define bFM4_MFS14_I2C_FCR0_FLST               *((volatile unsigned char*)(0x4271C298UL))
#define bFM4_MFS14_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM4_MFS14_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM4_MFS14_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM4_MFS14_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM4_MFS14_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM4_MFS14_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x4271C300UL))
#define bFM4_MFS14_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x4271C304UL))
#define bFM4_MFS14_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x4271C308UL))
#define bFM4_MFS14_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271C30CUL))
#define bFM4_MFS14_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x4271C310UL))
#define bFM4_MFS14_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x4271C314UL))
#define bFM4_MFS14_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x4271C318UL))
#define bFM4_MFS14_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271C31CUL))
#define bFM4_MFS14_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x4271C320UL))
#define bFM4_MFS14_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x4271C324UL))
#define bFM4_MFS14_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x4271C328UL))
#define bFM4_MFS14_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271C32CUL))
#define bFM4_MFS14_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x4271C330UL))
#define bFM4_MFS14_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x4271C334UL))
#define bFM4_MFS14_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x4271C338UL))
#define bFM4_MFS14_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271C33CUL))
#define bFM4_MFS14_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x4271C300UL))
#define bFM4_MFS14_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x4271C304UL))
#define bFM4_MFS14_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x4271C308UL))
#define bFM4_MFS14_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271C30CUL))
#define bFM4_MFS14_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x4271C310UL))
#define bFM4_MFS14_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x4271C314UL))
#define bFM4_MFS14_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x4271C318UL))
#define bFM4_MFS14_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271C31CUL))
#define bFM4_MFS14_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x4271C320UL))
#define bFM4_MFS14_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x4271C324UL))
#define bFM4_MFS14_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x4271C328UL))
#define bFM4_MFS14_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271C32CUL))
#define bFM4_MFS14_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x4271C330UL))
#define bFM4_MFS14_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x4271C334UL))
#define bFM4_MFS14_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x4271C338UL))
#define bFM4_MFS14_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271C33CUL))

/* MFS UART channel 15 registers */
#define bFM4_MFS15_UART_SMR_SOE                *((volatile unsigned char*)(0x4271E000UL))
#define bFM4_MFS15_UART_SMR_BDS                *((volatile unsigned char*)(0x4271E008UL))
#define bFM4_MFS15_UART_SMR_SBL                *((volatile unsigned char*)(0x4271E00CUL))
#define bFM4_MFS15_UART_SMR_WUCR               *((volatile unsigned char*)(0x4271E010UL))
#define bFM4_MFS15_UART_SMR_MD0                *((volatile unsigned char*)(0x4271E014UL))
#define bFM4_MFS15_UART_SMR_MD1                *((volatile unsigned char*)(0x4271E018UL))
#define bFM4_MFS15_UART_SMR_MD2                *((volatile unsigned char*)(0x4271E01CUL))
#define bFM4_MFS15_UART_SCR_TXE                *((volatile unsigned char*)(0x4271E020UL))
#define bFM4_MFS15_UART_SCR_RXE                *((volatile unsigned char*)(0x4271E024UL))
#define bFM4_MFS15_UART_SCR_TBIE               *((volatile unsigned char*)(0x4271E028UL))
#define bFM4_MFS15_UART_SCR_TIE                *((volatile unsigned char*)(0x4271E02CUL))
#define bFM4_MFS15_UART_SCR_RIE                *((volatile unsigned char*)(0x4271E030UL))
#define bFM4_MFS15_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271E03CUL))
#define bFM4_MFS15_UART_ESCR_L0                *((volatile unsigned char*)(0x4271E080UL))
#define bFM4_MFS15_UART_ESCR_L1                *((volatile unsigned char*)(0x4271E084UL))
#define bFM4_MFS15_UART_ESCR_L2                *((volatile unsigned char*)(0x4271E088UL))
#define bFM4_MFS15_UART_ESCR_P                 *((volatile unsigned char*)(0x4271E08CUL))
#define bFM4_MFS15_UART_ESCR_PEN               *((volatile unsigned char*)(0x4271E090UL))
#define bFM4_MFS15_UART_ESCR_INV               *((volatile unsigned char*)(0x4271E094UL))
#define bFM4_MFS15_UART_ESCR_ESBL              *((volatile unsigned char*)(0x4271E098UL))
#define bFM4_MFS15_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271E09CUL))
#define bFM4_MFS15_UART_SSR_TBI                *((volatile unsigned char*)(0x4271E0A0UL))
#define bFM4_MFS15_UART_SSR_TDRE               *((volatile unsigned char*)(0x4271E0A4UL))
#define bFM4_MFS15_UART_SSR_RDRF               *((volatile unsigned char*)(0x4271E0A8UL))
#define bFM4_MFS15_UART_SSR_ORE                *((volatile unsigned char*)(0x4271E0ACUL))
#define bFM4_MFS15_UART_SSR_FRE                *((volatile unsigned char*)(0x4271E0B0UL))
#define bFM4_MFS15_UART_SSR_PE                 *((volatile unsigned char*)(0x4271E0B4UL))
#define bFM4_MFS15_UART_SSR_REC                *((volatile unsigned char*)(0x4271E0BCUL))
#define bFM4_MFS15_UART_BGR_EXT                *((volatile unsigned char*)(0x4271E1BCUL))
#define bFM4_MFS15_UART_BGR1_EXT               *((volatile unsigned char*)(0x4271E1BCUL))
#define bFM4_MFS15_UART_FCR_FE1                *((volatile unsigned char*)(0x4271E280UL))
#define bFM4_MFS15_UART_FCR_FE2                *((volatile unsigned char*)(0x4271E284UL))
#define bFM4_MFS15_UART_FCR_FCL1               *((volatile unsigned char*)(0x4271E288UL))
#define bFM4_MFS15_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271E28CUL))
#define bFM4_MFS15_UART_FCR_FSET               *((volatile unsigned char*)(0x4271E290UL))
#define bFM4_MFS15_UART_FCR_FLD                *((volatile unsigned char*)(0x4271E294UL))
#define bFM4_MFS15_UART_FCR_FLST               *((volatile unsigned char*)(0x4271E298UL))
#define bFM4_MFS15_UART_FCR_FSEL               *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM4_MFS15_UART_FCR_FTIE               *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM4_MFS15_UART_FCR_FDRQ               *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM4_MFS15_UART_FCR_FRIIE              *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM4_MFS15_UART_FCR_FLSTE              *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM4_MFS15_UART_FCR0_FE1               *((volatile unsigned char*)(0x4271E280UL))
#define bFM4_MFS15_UART_FCR0_FE2               *((volatile unsigned char*)(0x4271E284UL))
#define bFM4_MFS15_UART_FCR0_FCL1              *((volatile unsigned char*)(0x4271E288UL))
#define bFM4_MFS15_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271E28CUL))
#define bFM4_MFS15_UART_FCR0_FSET              *((volatile unsigned char*)(0x4271E290UL))
#define bFM4_MFS15_UART_FCR0_FLD               *((volatile unsigned char*)(0x4271E294UL))
#define bFM4_MFS15_UART_FCR0_FLST              *((volatile unsigned char*)(0x4271E298UL))
#define bFM4_MFS15_UART_FCR1_FSEL              *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM4_MFS15_UART_FCR1_FTIE              *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM4_MFS15_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM4_MFS15_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM4_MFS15_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM4_MFS15_UART_FBYTE_FD0              *((volatile unsigned char*)(0x4271E300UL))
#define bFM4_MFS15_UART_FBYTE_FD1              *((volatile unsigned char*)(0x4271E304UL))
#define bFM4_MFS15_UART_FBYTE_FD2              *((volatile unsigned char*)(0x4271E308UL))
#define bFM4_MFS15_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271E30CUL))
#define bFM4_MFS15_UART_FBYTE_FD4              *((volatile unsigned char*)(0x4271E310UL))
#define bFM4_MFS15_UART_FBYTE_FD5              *((volatile unsigned char*)(0x4271E314UL))
#define bFM4_MFS15_UART_FBYTE_FD6              *((volatile unsigned char*)(0x4271E318UL))
#define bFM4_MFS15_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271E31CUL))
#define bFM4_MFS15_UART_FBYTE_FD8              *((volatile unsigned char*)(0x4271E320UL))
#define bFM4_MFS15_UART_FBYTE_FD9              *((volatile unsigned char*)(0x4271E324UL))
#define bFM4_MFS15_UART_FBYTE_FD10             *((volatile unsigned char*)(0x4271E328UL))
#define bFM4_MFS15_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271E32CUL))
#define bFM4_MFS15_UART_FBYTE_FD12             *((volatile unsigned char*)(0x4271E330UL))
#define bFM4_MFS15_UART_FBYTE_FD13             *((volatile unsigned char*)(0x4271E334UL))
#define bFM4_MFS15_UART_FBYTE_FD14             *((volatile unsigned char*)(0x4271E338UL))
#define bFM4_MFS15_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271E33CUL))
#define bFM4_MFS15_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x4271E300UL))
#define bFM4_MFS15_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x4271E304UL))
#define bFM4_MFS15_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x4271E308UL))
#define bFM4_MFS15_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271E30CUL))
#define bFM4_MFS15_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x4271E310UL))
#define bFM4_MFS15_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x4271E314UL))
#define bFM4_MFS15_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x4271E318UL))
#define bFM4_MFS15_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271E31CUL))
#define bFM4_MFS15_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x4271E320UL))
#define bFM4_MFS15_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x4271E324UL))
#define bFM4_MFS15_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x4271E328UL))
#define bFM4_MFS15_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271E32CUL))
#define bFM4_MFS15_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x4271E330UL))
#define bFM4_MFS15_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x4271E334UL))
#define bFM4_MFS15_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x4271E338UL))
#define bFM4_MFS15_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271E33CUL))

/* MFS CSIO channel 15 registers */
#define bFM4_MFS15_CSIO_SMR_SOE                *((volatile unsigned char*)(0x4271E000UL))
#define bFM4_MFS15_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x4271E004UL))
#define bFM4_MFS15_CSIO_SMR_BDS                *((volatile unsigned char*)(0x4271E008UL))
#define bFM4_MFS15_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271E00CUL))
#define bFM4_MFS15_CSIO_SMR_MD0                *((volatile unsigned char*)(0x4271E014UL))
#define bFM4_MFS15_CSIO_SMR_MD1                *((volatile unsigned char*)(0x4271E018UL))
#define bFM4_MFS15_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271E01CUL))
#define bFM4_MFS15_CSIO_SCR_TXE                *((volatile unsigned char*)(0x4271E020UL))
#define bFM4_MFS15_CSIO_SCR_RXE                *((volatile unsigned char*)(0x4271E024UL))
#define bFM4_MFS15_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x4271E028UL))
#define bFM4_MFS15_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271E02CUL))
#define bFM4_MFS15_CSIO_SCR_RIE                *((volatile unsigned char*)(0x4271E030UL))
#define bFM4_MFS15_CSIO_SCR_SPI                *((volatile unsigned char*)(0x4271E034UL))
#define bFM4_MFS15_CSIO_SCR_MS                 *((volatile unsigned char*)(0x4271E038UL))
#define bFM4_MFS15_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271E03CUL))
#define bFM4_MFS15_CSIO_ESCR_L0                *((volatile unsigned char*)(0x4271E080UL))
#define bFM4_MFS15_CSIO_ESCR_L1                *((volatile unsigned char*)(0x4271E084UL))
#define bFM4_MFS15_CSIO_ESCR_L2                *((volatile unsigned char*)(0x4271E088UL))
#define bFM4_MFS15_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271E08CUL))
#define bFM4_MFS15_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x4271E090UL))
#define bFM4_MFS15_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x4271E094UL))
#define bFM4_MFS15_CSIO_ESCR_L3                *((volatile unsigned char*)(0x4271E098UL))
#define bFM4_MFS15_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271E09CUL))
#define bFM4_MFS15_CSIO_SSR_TBI                *((volatile unsigned char*)(0x4271E0A0UL))
#define bFM4_MFS15_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x4271E0A4UL))
#define bFM4_MFS15_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x4271E0A8UL))
#define bFM4_MFS15_CSIO_SSR_ORE                *((volatile unsigned char*)(0x4271E0ACUL))
#define bFM4_MFS15_CSIO_SSR_AWC                *((volatile unsigned char*)(0x4271E0B0UL))
#define bFM4_MFS15_CSIO_SSR_REC                *((volatile unsigned char*)(0x4271E0BCUL))
#define bFM4_MFS15_CSIO_FCR_FE1                *((volatile unsigned char*)(0x4271E280UL))
#define bFM4_MFS15_CSIO_FCR_FE2                *((volatile unsigned char*)(0x4271E284UL))
#define bFM4_MFS15_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x4271E288UL))
#define bFM4_MFS15_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271E28CUL))
#define bFM4_MFS15_CSIO_FCR_FSET               *((volatile unsigned char*)(0x4271E290UL))
#define bFM4_MFS15_CSIO_FCR_FLD                *((volatile unsigned char*)(0x4271E294UL))
#define bFM4_MFS15_CSIO_FCR_FLST               *((volatile unsigned char*)(0x4271E298UL))
#define bFM4_MFS15_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM4_MFS15_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM4_MFS15_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM4_MFS15_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM4_MFS15_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM4_MFS15_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x4271E280UL))
#define bFM4_MFS15_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x4271E284UL))
#define bFM4_MFS15_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x4271E288UL))
#define bFM4_MFS15_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271E28CUL))
#define bFM4_MFS15_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x4271E290UL))
#define bFM4_MFS15_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x4271E294UL))
#define bFM4_MFS15_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x4271E298UL))
#define bFM4_MFS15_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM4_MFS15_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM4_MFS15_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM4_MFS15_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM4_MFS15_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM4_MFS15_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x4271E300UL))
#define bFM4_MFS15_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x4271E304UL))
#define bFM4_MFS15_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x4271E308UL))
#define bFM4_MFS15_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271E30CUL))
#define bFM4_MFS15_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x4271E310UL))
#define bFM4_MFS15_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x4271E314UL))
#define bFM4_MFS15_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x4271E318UL))
#define bFM4_MFS15_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271E31CUL))
#define bFM4_MFS15_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x4271E320UL))
#define bFM4_MFS15_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x4271E324UL))
#define bFM4_MFS15_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x4271E328UL))
#define bFM4_MFS15_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271E32CUL))
#define bFM4_MFS15_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x4271E330UL))
#define bFM4_MFS15_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x4271E334UL))
#define bFM4_MFS15_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x4271E338UL))
#define bFM4_MFS15_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271E33CUL))
#define bFM4_MFS15_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x4271E300UL))
#define bFM4_MFS15_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x4271E304UL))
#define bFM4_MFS15_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x4271E308UL))
#define bFM4_MFS15_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271E30CUL))
#define bFM4_MFS15_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x4271E310UL))
#define bFM4_MFS15_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x4271E314UL))
#define bFM4_MFS15_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x4271E318UL))
#define bFM4_MFS15_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271E31CUL))
#define bFM4_MFS15_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x4271E320UL))
#define bFM4_MFS15_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x4271E324UL))
#define bFM4_MFS15_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x4271E328UL))
#define bFM4_MFS15_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271E32CUL))
#define bFM4_MFS15_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x4271E330UL))
#define bFM4_MFS15_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x4271E334UL))
#define bFM4_MFS15_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x4271E338UL))
#define bFM4_MFS15_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271E33CUL))
#define bFM4_MFS15_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x4271E380UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x4271E384UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x4271E388UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271E38CUL))
#define bFM4_MFS15_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x4271E390UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x4271E394UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x4271E398UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271E39CUL))
#define bFM4_MFS15_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x4271E3A0UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x4271E3A4UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x4271E3A8UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x4271E3ACUL))
#define bFM4_MFS15_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x4271E3B0UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x4271E3B4UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x4271E3B8UL))
#define bFM4_MFS15_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x4271E3BCUL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x4271E400UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x4271E404UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x4271E408UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271E40CUL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x4271E410UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x4271E414UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x4271E418UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271E41CUL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x4271E420UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x4271E424UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x4271E428UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271E42CUL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x4271E430UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x4271E434UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x4271E438UL))
#define bFM4_MFS15_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271E43CUL))
#define bFM4_MFS15_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x4271E480UL))
#define bFM4_MFS15_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x4271E484UL))
#define bFM4_MFS15_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x4271E488UL))
#define bFM4_MFS15_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271E48CUL))
#define bFM4_MFS15_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x4271E490UL))
#define bFM4_MFS15_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x4271E498UL))
#define bFM4_MFS15_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271E49CUL))
#define bFM4_MFS15_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x4271E4A0UL))
#define bFM4_MFS15_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x4271E4ACUL))
#define bFM4_MFS15_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x4271E4B0UL))
#define bFM4_MFS15_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x4271E4B4UL))
#define bFM4_MFS15_CSIO_STMR_TM0               *((volatile unsigned char*)(0x4271E500UL))
#define bFM4_MFS15_CSIO_STMR_TM1               *((volatile unsigned char*)(0x4271E504UL))
#define bFM4_MFS15_CSIO_STMR_TM2               *((volatile unsigned char*)(0x4271E508UL))
#define bFM4_MFS15_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271E50CUL))
#define bFM4_MFS15_CSIO_STMR_TM4               *((volatile unsigned char*)(0x4271E510UL))
#define bFM4_MFS15_CSIO_STMR_TM5               *((volatile unsigned char*)(0x4271E514UL))
#define bFM4_MFS15_CSIO_STMR_TM6               *((volatile unsigned char*)(0x4271E518UL))
#define bFM4_MFS15_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271E51CUL))
#define bFM4_MFS15_CSIO_STMR_TM8               *((volatile unsigned char*)(0x4271E520UL))
#define bFM4_MFS15_CSIO_STMR_TM9               *((volatile unsigned char*)(0x4271E524UL))
#define bFM4_MFS15_CSIO_STMR_TM10              *((volatile unsigned char*)(0x4271E528UL))
#define bFM4_MFS15_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271E52CUL))
#define bFM4_MFS15_CSIO_STMR_TM12              *((volatile unsigned char*)(0x4271E530UL))
#define bFM4_MFS15_CSIO_STMR_TM13              *((volatile unsigned char*)(0x4271E534UL))
#define bFM4_MFS15_CSIO_STMR_TM14              *((volatile unsigned char*)(0x4271E538UL))
#define bFM4_MFS15_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271E53CUL))
#define bFM4_MFS15_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x4271E580UL))
#define bFM4_MFS15_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x4271E584UL))
#define bFM4_MFS15_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x4271E588UL))
#define bFM4_MFS15_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271E58CUL))
#define bFM4_MFS15_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x4271E590UL))
#define bFM4_MFS15_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x4271E594UL))
#define bFM4_MFS15_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x4271E598UL))
#define bFM4_MFS15_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271E59CUL))
#define bFM4_MFS15_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x4271E5A0UL))
#define bFM4_MFS15_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x4271E5A4UL))
#define bFM4_MFS15_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x4271E5A8UL))
#define bFM4_MFS15_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x4271E5ACUL))
#define bFM4_MFS15_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x4271E5B0UL))
#define bFM4_MFS15_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x4271E5B4UL))
#define bFM4_MFS15_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x4271E5B8UL))
#define bFM4_MFS15_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x4271E5BCUL))
#define bFM4_MFS15_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x4271E600UL))
#define bFM4_MFS15_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x4271E604UL))
#define bFM4_MFS15_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x4271E608UL))
#define bFM4_MFS15_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271E60CUL))
#define bFM4_MFS15_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x4271E610UL))
#define bFM4_MFS15_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x4271E614UL))
#define bFM4_MFS15_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x4271E618UL))
#define bFM4_MFS15_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271E61CUL))
#define bFM4_MFS15_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x4271E620UL))
#define bFM4_MFS15_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x4271E624UL))
#define bFM4_MFS15_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x4271E628UL))
#define bFM4_MFS15_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271E62CUL))
#define bFM4_MFS15_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x4271E630UL))
#define bFM4_MFS15_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x4271E634UL))
#define bFM4_MFS15_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x4271E638UL))
#define bFM4_MFS15_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271E63CUL))
#define bFM4_MFS15_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x4271E680UL))
#define bFM4_MFS15_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x4271E684UL))
#define bFM4_MFS15_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x4271E688UL))
#define bFM4_MFS15_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271E68CUL))
#define bFM4_MFS15_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x4271E690UL))
#define bFM4_MFS15_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x4271E694UL))
#define bFM4_MFS15_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x4271E698UL))
#define bFM4_MFS15_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271E69CUL))
#define bFM4_MFS15_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x4271E6A0UL))
#define bFM4_MFS15_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x4271E6A4UL))
#define bFM4_MFS15_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x4271E6A8UL))
#define bFM4_MFS15_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x4271E6ACUL))
#define bFM4_MFS15_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x4271E6B0UL))
#define bFM4_MFS15_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x4271E6B4UL))
#define bFM4_MFS15_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x4271E6B8UL))
#define bFM4_MFS15_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x4271E6BCUL))
#define bFM4_MFS15_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x4271E700UL))
#define bFM4_MFS15_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x4271E704UL))
#define bFM4_MFS15_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x4271E708UL))
#define bFM4_MFS15_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271E70CUL))
#define bFM4_MFS15_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x4271E710UL))
#define bFM4_MFS15_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x4271E714UL))
#define bFM4_MFS15_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x4271E718UL))
#define bFM4_MFS15_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271E71CUL))

/* MFS LIN channel 15 registers */
#define bFM4_MFS15_LIN_SMR_SOE                 *((volatile unsigned char*)(0x4271E000UL))
#define bFM4_MFS15_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271E00CUL))
#define bFM4_MFS15_LIN_SMR_WUCR                *((volatile unsigned char*)(0x4271E010UL))
#define bFM4_MFS15_LIN_SMR_MD0                 *((volatile unsigned char*)(0x4271E014UL))
#define bFM4_MFS15_LIN_SMR_MD1                 *((volatile unsigned char*)(0x4271E018UL))
#define bFM4_MFS15_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271E01CUL))
#define bFM4_MFS15_LIN_SCR_TXE                 *((volatile unsigned char*)(0x4271E020UL))
#define bFM4_MFS15_LIN_SCR_RXE                 *((volatile unsigned char*)(0x4271E024UL))
#define bFM4_MFS15_LIN_SCR_TBIE                *((volatile unsigned char*)(0x4271E028UL))
#define bFM4_MFS15_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271E02CUL))
#define bFM4_MFS15_LIN_SCR_RIE                 *((volatile unsigned char*)(0x4271E030UL))
#define bFM4_MFS15_LIN_SCR_LBR                 *((volatile unsigned char*)(0x4271E034UL))
#define bFM4_MFS15_LIN_SCR_MS                  *((volatile unsigned char*)(0x4271E038UL))
#define bFM4_MFS15_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271E03CUL))
#define bFM4_MFS15_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x4271E080UL))
#define bFM4_MFS15_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x4271E084UL))
#define bFM4_MFS15_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x4271E088UL))
#define bFM4_MFS15_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271E08CUL))
#define bFM4_MFS15_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x4271E090UL))
#define bFM4_MFS15_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x4271E098UL))
#define bFM4_MFS15_LIN_SSR_TBI                 *((volatile unsigned char*)(0x4271E0A0UL))
#define bFM4_MFS15_LIN_SSR_TDRE                *((volatile unsigned char*)(0x4271E0A4UL))
#define bFM4_MFS15_LIN_SSR_RDRF                *((volatile unsigned char*)(0x4271E0A8UL))
#define bFM4_MFS15_LIN_SSR_ORE                 *((volatile unsigned char*)(0x4271E0ACUL))
#define bFM4_MFS15_LIN_SSR_FRE                 *((volatile unsigned char*)(0x4271E0B0UL))
#define bFM4_MFS15_LIN_SSR_LBD                 *((volatile unsigned char*)(0x4271E0B4UL))
#define bFM4_MFS15_LIN_SSR_REC                 *((volatile unsigned char*)(0x4271E0BCUL))
#define bFM4_MFS15_LIN_BGR_EXT                 *((volatile unsigned char*)(0x4271E1BCUL))
#define bFM4_MFS15_LIN_BGR1_EXT                *((volatile unsigned char*)(0x4271E1BCUL))
#define bFM4_MFS15_LIN_FCR_FE1                 *((volatile unsigned char*)(0x4271E280UL))
#define bFM4_MFS15_LIN_FCR_FE2                 *((volatile unsigned char*)(0x4271E284UL))
#define bFM4_MFS15_LIN_FCR_FCL1                *((volatile unsigned char*)(0x4271E288UL))
#define bFM4_MFS15_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271E28CUL))
#define bFM4_MFS15_LIN_FCR_FSET                *((volatile unsigned char*)(0x4271E290UL))
#define bFM4_MFS15_LIN_FCR_FLD                 *((volatile unsigned char*)(0x4271E294UL))
#define bFM4_MFS15_LIN_FCR_FLST                *((volatile unsigned char*)(0x4271E298UL))
#define bFM4_MFS15_LIN_FCR_FSEL                *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM4_MFS15_LIN_FCR_FTIE                *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM4_MFS15_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM4_MFS15_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM4_MFS15_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM4_MFS15_LIN_FCR0_FE1                *((volatile unsigned char*)(0x4271E280UL))
#define bFM4_MFS15_LIN_FCR0_FE2                *((volatile unsigned char*)(0x4271E284UL))
#define bFM4_MFS15_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x4271E288UL))
#define bFM4_MFS15_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271E28CUL))
#define bFM4_MFS15_LIN_FCR0_FSET               *((volatile unsigned char*)(0x4271E290UL))
#define bFM4_MFS15_LIN_FCR0_FLD                *((volatile unsigned char*)(0x4271E294UL))
#define bFM4_MFS15_LIN_FCR0_FLST               *((volatile unsigned char*)(0x4271E298UL))
#define bFM4_MFS15_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM4_MFS15_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM4_MFS15_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM4_MFS15_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM4_MFS15_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM4_MFS15_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x4271E300UL))
#define bFM4_MFS15_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x4271E304UL))
#define bFM4_MFS15_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x4271E308UL))
#define bFM4_MFS15_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271E30CUL))
#define bFM4_MFS15_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x4271E310UL))
#define bFM4_MFS15_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x4271E314UL))
#define bFM4_MFS15_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x4271E318UL))
#define bFM4_MFS15_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271E31CUL))
#define bFM4_MFS15_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x4271E320UL))
#define bFM4_MFS15_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x4271E324UL))
#define bFM4_MFS15_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x4271E328UL))
#define bFM4_MFS15_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271E32CUL))
#define bFM4_MFS15_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x4271E330UL))
#define bFM4_MFS15_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x4271E334UL))
#define bFM4_MFS15_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x4271E338UL))
#define bFM4_MFS15_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271E33CUL))
#define bFM4_MFS15_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x4271E300UL))
#define bFM4_MFS15_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x4271E304UL))
#define bFM4_MFS15_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x4271E308UL))
#define bFM4_MFS15_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271E30CUL))
#define bFM4_MFS15_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x4271E310UL))
#define bFM4_MFS15_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x4271E314UL))
#define bFM4_MFS15_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x4271E318UL))
#define bFM4_MFS15_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271E31CUL))
#define bFM4_MFS15_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x4271E320UL))
#define bFM4_MFS15_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x4271E324UL))
#define bFM4_MFS15_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x4271E328UL))
#define bFM4_MFS15_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271E32CUL))
#define bFM4_MFS15_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x4271E330UL))
#define bFM4_MFS15_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x4271E334UL))
#define bFM4_MFS15_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x4271E338UL))
#define bFM4_MFS15_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271E33CUL))

/* MFS I2C channel 15 registers */
#define bFM4_MFS15_I2C_SMR_TIE                 *((volatile unsigned char*)(0x4271E008UL))
#define bFM4_MFS15_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271E00CUL))
#define bFM4_MFS15_I2C_SMR_MD0                 *((volatile unsigned char*)(0x4271E014UL))
#define bFM4_MFS15_I2C_SMR_MD1                 *((volatile unsigned char*)(0x4271E018UL))
#define bFM4_MFS15_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271E01CUL))
#define bFM4_MFS15_I2C_IBCR_INT                *((volatile unsigned char*)(0x4271E020UL))
#define bFM4_MFS15_I2C_IBCR_BER                *((volatile unsigned char*)(0x4271E024UL))
#define bFM4_MFS15_I2C_IBCR_INTE               *((volatile unsigned char*)(0x4271E028UL))
#define bFM4_MFS15_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271E02CUL))
#define bFM4_MFS15_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x4271E030UL))
#define bFM4_MFS15_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x4271E034UL))
#define bFM4_MFS15_I2C_IBCR_ACT                *((volatile unsigned char*)(0x4271E038UL))
#define bFM4_MFS15_I2C_IBCR_SCC                *((volatile unsigned char*)(0x4271E038UL))
#define bFM4_MFS15_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271E03CUL))
#define bFM4_MFS15_I2C_IBSR_BB                 *((volatile unsigned char*)(0x4271E080UL))
#define bFM4_MFS15_I2C_IBSR_SPC                *((volatile unsigned char*)(0x4271E084UL))
#define bFM4_MFS15_I2C_IBSR_RSC                *((volatile unsigned char*)(0x4271E088UL))
#define bFM4_MFS15_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271E08CUL))
#define bFM4_MFS15_I2C_IBSR_TRX                *((volatile unsigned char*)(0x4271E090UL))
#define bFM4_MFS15_I2C_IBSR_RSA                *((volatile unsigned char*)(0x4271E094UL))
#define bFM4_MFS15_I2C_IBSR_RACK               *((volatile unsigned char*)(0x4271E098UL))
#define bFM4_MFS15_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271E09CUL))
#define bFM4_MFS15_I2C_SSR_TBI                 *((volatile unsigned char*)(0x4271E0A0UL))
#define bFM4_MFS15_I2C_SSR_TDRE                *((volatile unsigned char*)(0x4271E0A4UL))
#define bFM4_MFS15_I2C_SSR_RDRF                *((volatile unsigned char*)(0x4271E0A8UL))
#define bFM4_MFS15_I2C_SSR_ORE                 *((volatile unsigned char*)(0x4271E0ACUL))
#define bFM4_MFS15_I2C_SSR_TBIE                *((volatile unsigned char*)(0x4271E0B0UL))
#define bFM4_MFS15_I2C_SSR_DMA                 *((volatile unsigned char*)(0x4271E0B4UL))
#define bFM4_MFS15_I2C_SSR_TSET                *((volatile unsigned char*)(0x4271E0B8UL))
#define bFM4_MFS15_I2C_SSR_REC                 *((volatile unsigned char*)(0x4271E0BCUL))
#define bFM4_MFS15_I2C_ISBA_SA0                *((volatile unsigned char*)(0x4271E200UL))
#define bFM4_MFS15_I2C_ISBA_SA1                *((volatile unsigned char*)(0x4271E204UL))
#define bFM4_MFS15_I2C_ISBA_SA2                *((volatile unsigned char*)(0x4271E208UL))
#define bFM4_MFS15_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271E20CUL))
#define bFM4_MFS15_I2C_ISBA_SA4                *((volatile unsigned char*)(0x4271E210UL))
#define bFM4_MFS15_I2C_ISBA_SA5                *((volatile unsigned char*)(0x4271E214UL))
#define bFM4_MFS15_I2C_ISBA_SA6                *((volatile unsigned char*)(0x4271E218UL))
#define bFM4_MFS15_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271E21CUL))
#define bFM4_MFS15_I2C_ISMK_SM0                *((volatile unsigned char*)(0x4271E220UL))
#define bFM4_MFS15_I2C_ISMK_SM1                *((volatile unsigned char*)(0x4271E224UL))
#define bFM4_MFS15_I2C_ISMK_SM2                *((volatile unsigned char*)(0x4271E228UL))
#define bFM4_MFS15_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271E22CUL))
#define bFM4_MFS15_I2C_ISMK_SM4                *((volatile unsigned char*)(0x4271E230UL))
#define bFM4_MFS15_I2C_ISMK_SM5                *((volatile unsigned char*)(0x4271E234UL))
#define bFM4_MFS15_I2C_ISMK_SM6                *((volatile unsigned char*)(0x4271E238UL))
#define bFM4_MFS15_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271E23CUL))
#define bFM4_MFS15_I2C_FCR_FE1                 *((volatile unsigned char*)(0x4271E280UL))
#define bFM4_MFS15_I2C_FCR_FE2                 *((volatile unsigned char*)(0x4271E284UL))
#define bFM4_MFS15_I2C_FCR_FCL1                *((volatile unsigned char*)(0x4271E288UL))
#define bFM4_MFS15_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271E28CUL))
#define bFM4_MFS15_I2C_FCR_FSET                *((volatile unsigned char*)(0x4271E290UL))
#define bFM4_MFS15_I2C_FCR_FLD                 *((volatile unsigned char*)(0x4271E294UL))
#define bFM4_MFS15_I2C_FCR_FLST                *((volatile unsigned char*)(0x4271E298UL))
#define bFM4_MFS15_I2C_FCR_FSEL                *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM4_MFS15_I2C_FCR_FTIE                *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM4_MFS15_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM4_MFS15_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM4_MFS15_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM4_MFS15_I2C_FCR0_FE1                *((volatile unsigned char*)(0x4271E280UL))
#define bFM4_MFS15_I2C_FCR0_FE2                *((volatile unsigned char*)(0x4271E284UL))
#define bFM4_MFS15_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x4271E288UL))
#define bFM4_MFS15_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271E28CUL))
#define bFM4_MFS15_I2C_FCR0_FSET               *((volatile unsigned char*)(0x4271E290UL))
#define bFM4_MFS15_I2C_FCR0_FLD                *((volatile unsigned char*)(0x4271E294UL))
#define bFM4_MFS15_I2C_FCR0_FLST               *((volatile unsigned char*)(0x4271E298UL))
#define bFM4_MFS15_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM4_MFS15_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM4_MFS15_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM4_MFS15_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM4_MFS15_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM4_MFS15_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x4271E300UL))
#define bFM4_MFS15_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x4271E304UL))
#define bFM4_MFS15_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x4271E308UL))
#define bFM4_MFS15_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271E30CUL))
#define bFM4_MFS15_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x4271E310UL))
#define bFM4_MFS15_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x4271E314UL))
#define bFM4_MFS15_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x4271E318UL))
#define bFM4_MFS15_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271E31CUL))
#define bFM4_MFS15_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x4271E320UL))
#define bFM4_MFS15_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x4271E324UL))
#define bFM4_MFS15_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x4271E328UL))
#define bFM4_MFS15_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271E32CUL))
#define bFM4_MFS15_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x4271E330UL))
#define bFM4_MFS15_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x4271E334UL))
#define bFM4_MFS15_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x4271E338UL))
#define bFM4_MFS15_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271E33CUL))
#define bFM4_MFS15_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x4271E300UL))
#define bFM4_MFS15_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x4271E304UL))
#define bFM4_MFS15_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x4271E308UL))
#define bFM4_MFS15_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271E30CUL))
#define bFM4_MFS15_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x4271E310UL))
#define bFM4_MFS15_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x4271E314UL))
#define bFM4_MFS15_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x4271E318UL))
#define bFM4_MFS15_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271E31CUL))
#define bFM4_MFS15_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x4271E320UL))
#define bFM4_MFS15_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x4271E324UL))
#define bFM4_MFS15_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x4271E328UL))
#define bFM4_MFS15_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271E32CUL))
#define bFM4_MFS15_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x4271E330UL))
#define bFM4_MFS15_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x4271E334UL))
#define bFM4_MFS15_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x4271E338UL))
#define bFM4_MFS15_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271E33CUL))

/* CRC registers */
#define bFM4_CRC_CRCCR_INIT                    *((volatile unsigned char*)(0x42720000UL))
#define bFM4_CRC_CRCCR_CRC32                   *((volatile unsigned char*)(0x42720004UL))
#define bFM4_CRC_CRCCR_LTLEND                  *((volatile unsigned char*)(0x42720008UL))
#define bFM4_CRC_CRCCR_LSBFST                  *((volatile unsigned char*)(0x4272000CUL))
#define bFM4_CRC_CRCCR_CRCLTE                  *((volatile unsigned char*)(0x42720010UL))
#define bFM4_CRC_CRCCR_CRCLSF                  *((volatile unsigned char*)(0x42720014UL))
#define bFM4_CRC_CRCCR_FXOR                    *((volatile unsigned char*)(0x42720018UL))

/* Watch counter registers */
#define bFM4_WC_WCRD_CTR0                      *((volatile unsigned char*)(0x42740000UL))
#define bFM4_WC_WCRD_CTR1                      *((volatile unsigned char*)(0x42740004UL))
#define bFM4_WC_WCRD_CTR2                      *((volatile unsigned char*)(0x42740008UL))
#define bFM4_WC_WCRD_CTR3                      *((volatile unsigned char*)(0x4274000CUL))
#define bFM4_WC_WCRD_CTR4                      *((volatile unsigned char*)(0x42740010UL))
#define bFM4_WC_WCRD_CTR5                      *((volatile unsigned char*)(0x42740014UL))
#define bFM4_WC_WCRL_RLC0                      *((volatile unsigned char*)(0x42740020UL))
#define bFM4_WC_WCRL_RLC1                      *((volatile unsigned char*)(0x42740024UL))
#define bFM4_WC_WCRL_RLC2                      *((volatile unsigned char*)(0x42740028UL))
#define bFM4_WC_WCRL_RLC3                      *((volatile unsigned char*)(0x4274002CUL))
#define bFM4_WC_WCRL_RLC4                      *((volatile unsigned char*)(0x42740030UL))
#define bFM4_WC_WCRL_RLC5                      *((volatile unsigned char*)(0x42740034UL))
#define bFM4_WC_WCCR_WCIF                      *((volatile unsigned char*)(0x42740040UL))
#define bFM4_WC_WCCR_WCIE                      *((volatile unsigned char*)(0x42740044UL))
#define bFM4_WC_WCCR_CS0                       *((volatile unsigned char*)(0x42740048UL))
#define bFM4_WC_WCCR_CS1                       *((volatile unsigned char*)(0x4274004CUL))
#define bFM4_WC_WCCR_WCOP                      *((volatile unsigned char*)(0x42740058UL))
#define bFM4_WC_WCCR_WCEN                      *((volatile unsigned char*)(0x4274005CUL))
#define bFM4_WC_CLK_SEL_SEL_IN                 *((volatile unsigned char*)(0x42740200UL))
#define bFM4_WC_CLK_SEL_SEL_OUT                *((volatile unsigned char*)(0x42740220UL))
#define bFM4_WC_CLK_EN_CLK_EN                  *((volatile unsigned char*)(0x42740280UL))
#define bFM4_WC_CLK_EN_CLK_EN_R                *((volatile unsigned char*)(0x42740284UL))

/* Real time clock registers */
#define bFM4_RTC_WTCR10_ST                     *((volatile unsigned char*)(0x42762000UL))
#define bFM4_RTC_WTCR10_RUN                    *((volatile unsigned char*)(0x42762008UL))
#define bFM4_RTC_WTCR10_SRST                   *((volatile unsigned char*)(0x4276200CUL))
#define bFM4_RTC_WTCR10_SCST                   *((volatile unsigned char*)(0x42762010UL))
#define bFM4_RTC_WTCR10_SCRST                  *((volatile unsigned char*)(0x42762014UL))
#define bFM4_RTC_WTCR10_BUSY                   *((volatile unsigned char*)(0x42762018UL))
#define bFM4_RTC_WTCR10_TRANS                  *((volatile unsigned char*)(0x4276201CUL))
#define bFM4_RTC_WTCR11_MIEN                   *((volatile unsigned char*)(0x42762080UL))
#define bFM4_RTC_WTCR11_HEN                    *((volatile unsigned char*)(0x42762084UL))
#define bFM4_RTC_WTCR11_DEN                    *((volatile unsigned char*)(0x42762088UL))
#define bFM4_RTC_WTCR11_MOEN                   *((volatile unsigned char*)(0x4276208CUL))
#define bFM4_RTC_WTCR11_YEN                    *((volatile unsigned char*)(0x42762090UL))
#define bFM4_RTC_WTCR12_INTSSI                 *((volatile unsigned char*)(0x42762100UL))
#define bFM4_RTC_WTCR12_INTSI                  *((volatile unsigned char*)(0x42762104UL))
#define bFM4_RTC_WTCR12_INTMI                  *((volatile unsigned char*)(0x42762108UL))
#define bFM4_RTC_WTCR12_INTHI                  *((volatile unsigned char*)(0x4276210CUL))
#define bFM4_RTC_WTCR12_INTTMI                 *((volatile unsigned char*)(0x42762110UL))
#define bFM4_RTC_WTCR12_INTALI                 *((volatile unsigned char*)(0x42762114UL))
#define bFM4_RTC_WTCR12_INTERI                 *((volatile unsigned char*)(0x42762118UL))
#define bFM4_RTC_WTCR12_INTCRI                 *((volatile unsigned char*)(0x4276211CUL))
#define bFM4_RTC_WTCR13_INTSSIE                *((volatile unsigned char*)(0x42762180UL))
#define bFM4_RTC_WTCR13_INTSIE                 *((volatile unsigned char*)(0x42762184UL))
#define bFM4_RTC_WTCR13_INTMIE                 *((volatile unsigned char*)(0x42762188UL))
#define bFM4_RTC_WTCR13_INTHIE                 *((volatile unsigned char*)(0x4276218CUL))
#define bFM4_RTC_WTCR13_INTTMIE                *((volatile unsigned char*)(0x42762190UL))
#define bFM4_RTC_WTCR13_INTALIE                *((volatile unsigned char*)(0x42762194UL))
#define bFM4_RTC_WTCR13_INTERIE                *((volatile unsigned char*)(0x42762198UL))
#define bFM4_RTC_WTCR13_INTCRIE                *((volatile unsigned char*)(0x4276219CUL))
#define bFM4_RTC_WTCR20_CREAD                  *((volatile unsigned char*)(0x42762200UL))
#define bFM4_RTC_WTCR20_CWRITE                 *((volatile unsigned char*)(0x42762204UL))
#define bFM4_RTC_WTCR20_BREAD                  *((volatile unsigned char*)(0x42762208UL))
#define bFM4_RTC_WTCR20_BWRITE                 *((volatile unsigned char*)(0x4276220CUL))
#define bFM4_RTC_WTCR20_PREAD                  *((volatile unsigned char*)(0x42762210UL))
#define bFM4_RTC_WTCR20_PWRITE                 *((volatile unsigned char*)(0x42762214UL))
#define bFM4_RTC_WTCR21_TMST                   *((volatile unsigned char*)(0x42762280UL))
#define bFM4_RTC_WTCR21_TMEN                   *((volatile unsigned char*)(0x42762284UL))
#define bFM4_RTC_WTCR21_TMRUN                  *((volatile unsigned char*)(0x42762288UL))
#define bFM4_RTC_WTSR_S0                       *((volatile unsigned char*)(0x42762380UL))
#define bFM4_RTC_WTSR_S1                       *((volatile unsigned char*)(0x42762384UL))
#define bFM4_RTC_WTSR_S2                       *((volatile unsigned char*)(0x42762388UL))
#define bFM4_RTC_WTSR_S3                       *((volatile unsigned char*)(0x4276238CUL))
#define bFM4_RTC_WTSR_TS0                      *((volatile unsigned char*)(0x42762390UL))
#define bFM4_RTC_WTSR_TS1                      *((volatile unsigned char*)(0x42762394UL))
#define bFM4_RTC_WTSR_TS2                      *((volatile unsigned char*)(0x42762398UL))
#define bFM4_RTC_WTMIR_MI0                     *((volatile unsigned char*)(0x42762400UL))
#define bFM4_RTC_WTMIR_MI1                     *((volatile unsigned char*)(0x42762404UL))
#define bFM4_RTC_WTMIR_MI2                     *((volatile unsigned char*)(0x42762408UL))
#define bFM4_RTC_WTMIR_MI3                     *((volatile unsigned char*)(0x4276240CUL))
#define bFM4_RTC_WTMIR_TMI0                    *((volatile unsigned char*)(0x42762410UL))
#define bFM4_RTC_WTMIR_TMI1                    *((volatile unsigned char*)(0x42762414UL))
#define bFM4_RTC_WTMIR_TMI2                    *((volatile unsigned char*)(0x42762418UL))
#define bFM4_RTC_WTHR_H0                       *((volatile unsigned char*)(0x42762480UL))
#define bFM4_RTC_WTHR_H1                       *((volatile unsigned char*)(0x42762484UL))
#define bFM4_RTC_WTHR_H2                       *((volatile unsigned char*)(0x42762488UL))
#define bFM4_RTC_WTHR_H3                       *((volatile unsigned char*)(0x4276248CUL))
#define bFM4_RTC_WTHR_TH0                      *((volatile unsigned char*)(0x42762490UL))
#define bFM4_RTC_WTHR_TH1                      *((volatile unsigned char*)(0x42762494UL))
#define bFM4_RTC_WTDR_D0                       *((volatile unsigned char*)(0x42762500UL))
#define bFM4_RTC_WTDR_D1                       *((volatile unsigned char*)(0x42762504UL))
#define bFM4_RTC_WTDR_D2                       *((volatile unsigned char*)(0x42762508UL))
#define bFM4_RTC_WTDR_D3                       *((volatile unsigned char*)(0x4276250CUL))
#define bFM4_RTC_WTDR_TD0                      *((volatile unsigned char*)(0x42762510UL))
#define bFM4_RTC_WTDR_TD1                      *((volatile unsigned char*)(0x42762514UL))
#define bFM4_RTC_WTDW_DW0                      *((volatile unsigned char*)(0x42762580UL))
#define bFM4_RTC_WTDW_DW1                      *((volatile unsigned char*)(0x42762584UL))
#define bFM4_RTC_WTDW_DW2                      *((volatile unsigned char*)(0x42762588UL))
#define bFM4_RTC_WTMOR_MO0                     *((volatile unsigned char*)(0x42762600UL))
#define bFM4_RTC_WTMOR_MO1                     *((volatile unsigned char*)(0x42762604UL))
#define bFM4_RTC_WTMOR_MO2                     *((volatile unsigned char*)(0x42762608UL))
#define bFM4_RTC_WTMOR_MO3                     *((volatile unsigned char*)(0x4276260CUL))
#define bFM4_RTC_WTMOR_TMO                     *((volatile unsigned char*)(0x42762610UL))
#define bFM4_RTC_WTYR_Y0                       *((volatile unsigned char*)(0x42762680UL))
#define bFM4_RTC_WTYR_Y1                       *((volatile unsigned char*)(0x42762684UL))
#define bFM4_RTC_WTYR_Y2                       *((volatile unsigned char*)(0x42762688UL))
#define bFM4_RTC_WTYR_Y3                       *((volatile unsigned char*)(0x4276268CUL))
#define bFM4_RTC_WTYR_TY0                      *((volatile unsigned char*)(0x42762690UL))
#define bFM4_RTC_WTYR_TY1                      *((volatile unsigned char*)(0x42762694UL))
#define bFM4_RTC_WTYR_TY2                      *((volatile unsigned char*)(0x42762698UL))
#define bFM4_RTC_WTYR_TY3                      *((volatile unsigned char*)(0x4276269CUL))
#define bFM4_RTC_ALMIR_AMI0                    *((volatile unsigned char*)(0x42762700UL))
#define bFM4_RTC_ALMIR_AMI1                    *((volatile unsigned char*)(0x42762704UL))
#define bFM4_RTC_ALMIR_AMI2                    *((volatile unsigned char*)(0x42762708UL))
#define bFM4_RTC_ALMIR_AMI3                    *((volatile unsigned char*)(0x4276270CUL))
#define bFM4_RTC_ALMIR_TAMI0                   *((volatile unsigned char*)(0x42762710UL))
#define bFM4_RTC_ALMIR_TAMI1                   *((volatile unsigned char*)(0x42762714UL))
#define bFM4_RTC_ALMIR_TAMI2                   *((volatile unsigned char*)(0x42762718UL))
#define bFM4_RTC_ALHR_AH0                      *((volatile unsigned char*)(0x42762780UL))
#define bFM4_RTC_ALHR_AH1                      *((volatile unsigned char*)(0x42762784UL))
#define bFM4_RTC_ALHR_AH2                      *((volatile unsigned char*)(0x42762788UL))
#define bFM4_RTC_ALHR_AH3                      *((volatile unsigned char*)(0x4276278CUL))
#define bFM4_RTC_ALHR_TAH0                     *((volatile unsigned char*)(0x42762790UL))
#define bFM4_RTC_ALHR_TAH1                     *((volatile unsigned char*)(0x42762794UL))
#define bFM4_RTC_ALDR_AD0                      *((volatile unsigned char*)(0x42762800UL))
#define bFM4_RTC_ALDR_AD1                      *((volatile unsigned char*)(0x42762804UL))
#define bFM4_RTC_ALDR_AD2                      *((volatile unsigned char*)(0x42762808UL))
#define bFM4_RTC_ALDR_AD3                      *((volatile unsigned char*)(0x4276280CUL))
#define bFM4_RTC_ALDR_TAD0                     *((volatile unsigned char*)(0x42762810UL))
#define bFM4_RTC_ALDR_TAD1                     *((volatile unsigned char*)(0x42762814UL))
#define bFM4_RTC_ALMOR_AMO0                    *((volatile unsigned char*)(0x42762880UL))
#define bFM4_RTC_ALMOR_AMO1                    *((volatile unsigned char*)(0x42762884UL))
#define bFM4_RTC_ALMOR_AMO2                    *((volatile unsigned char*)(0x42762888UL))
#define bFM4_RTC_ALMOR_AMO3                    *((volatile unsigned char*)(0x4276288CUL))
#define bFM4_RTC_ALMOR_TAMO                    *((volatile unsigned char*)(0x42762890UL))
#define bFM4_RTC_ALYR_AY0                      *((volatile unsigned char*)(0x42762900UL))
#define bFM4_RTC_ALYR_AY1                      *((volatile unsigned char*)(0x42762904UL))
#define bFM4_RTC_ALYR_AY2                      *((volatile unsigned char*)(0x42762908UL))
#define bFM4_RTC_ALYR_AY3                      *((volatile unsigned char*)(0x4276290CUL))
#define bFM4_RTC_ALYR_TAY0                     *((volatile unsigned char*)(0x42762910UL))
#define bFM4_RTC_ALYR_TAY1                     *((volatile unsigned char*)(0x42762914UL))
#define bFM4_RTC_ALYR_TAY2                     *((volatile unsigned char*)(0x42762918UL))
#define bFM4_RTC_ALYR_TAY3                     *((volatile unsigned char*)(0x4276291CUL))
#define bFM4_RTC_WTTR0_TM0                     *((volatile unsigned char*)(0x42762980UL))
#define bFM4_RTC_WTTR0_TM1                     *((volatile unsigned char*)(0x42762984UL))
#define bFM4_RTC_WTTR0_TM2                     *((volatile unsigned char*)(0x42762988UL))
#define bFM4_RTC_WTTR0_TM3                     *((volatile unsigned char*)(0x4276298CUL))
#define bFM4_RTC_WTTR0_TM4                     *((volatile unsigned char*)(0x42762990UL))
#define bFM4_RTC_WTTR0_TM5                     *((volatile unsigned char*)(0x42762994UL))
#define bFM4_RTC_WTTR0_TM6                     *((volatile unsigned char*)(0x42762998UL))
#define bFM4_RTC_WTTR0_TM7                     *((volatile unsigned char*)(0x4276299CUL))
#define bFM4_RTC_WTTR1_TM8                     *((volatile unsigned char*)(0x42762A00UL))
#define bFM4_RTC_WTTR1_TM9                     *((volatile unsigned char*)(0x42762A04UL))
#define bFM4_RTC_WTTR1_TM10                    *((volatile unsigned char*)(0x42762A08UL))
#define bFM4_RTC_WTTR1_TM11                    *((volatile unsigned char*)(0x42762A0CUL))
#define bFM4_RTC_WTTR1_TM12                    *((volatile unsigned char*)(0x42762A10UL))
#define bFM4_RTC_WTTR1_TM13                    *((volatile unsigned char*)(0x42762A14UL))
#define bFM4_RTC_WTTR1_TM14                    *((volatile unsigned char*)(0x42762A18UL))
#define bFM4_RTC_WTTR1_TM15                    *((volatile unsigned char*)(0x42762A1CUL))
#define bFM4_RTC_WTTR2_TM16                    *((volatile unsigned char*)(0x42762A80UL))
#define bFM4_RTC_WTTR2_TM17                    *((volatile unsigned char*)(0x42762A84UL))
#define bFM4_RTC_WTCAL1_WTCAL10                *((volatile unsigned char*)(0x42762B80UL))
#define bFM4_RTC_WTCAL1_WTCAL11                *((volatile unsigned char*)(0x42762B84UL))
#define bFM4_RTC_WTCALEN_WTCALEN               *((volatile unsigned char*)(0x42762C00UL))
#define bFM4_RTC_WTDIV_WTDIV0                  *((volatile unsigned char*)(0x42762C80UL))
#define bFM4_RTC_WTDIV_WTDIV1                  *((volatile unsigned char*)(0x42762C84UL))
#define bFM4_RTC_WTDIV_WTDIV2                  *((volatile unsigned char*)(0x42762C88UL))
#define bFM4_RTC_WTDIV_WTDIV3                  *((volatile unsigned char*)(0x42762C8CUL))
#define bFM4_RTC_WTDIVEN_WTDIVEN               *((volatile unsigned char*)(0x42762D00UL))
#define bFM4_RTC_WTDIVEN_WTDIVRDY              *((volatile unsigned char*)(0x42762D04UL))
#define bFM4_RTC_WTCALPRD_WTCALPRD0            *((volatile unsigned char*)(0x42762D80UL))
#define bFM4_RTC_WTCALPRD_WTCALPRD1            *((volatile unsigned char*)(0x42762D84UL))
#define bFM4_RTC_WTCALPRD_WTCALPRD2            *((volatile unsigned char*)(0x42762D88UL))
#define bFM4_RTC_WTCALPRD_WTCALPRD3            *((volatile unsigned char*)(0x42762D8CUL))
#define bFM4_RTC_WTCALPRD_WTCALPRD4            *((volatile unsigned char*)(0x42762D90UL))
#define bFM4_RTC_WTCALPRD_WTCALPRD5            *((volatile unsigned char*)(0x42762D94UL))
#define bFM4_RTC_WTCOSEL_WTCOSEL               *((volatile unsigned char*)(0x42762E00UL))
#define bFM4_RTC_VB_CLKDIV_DIV0                *((volatile unsigned char*)(0x42762E80UL))
#define bFM4_RTC_VB_CLKDIV_DIV1                *((volatile unsigned char*)(0x42762E84UL))
#define bFM4_RTC_VB_CLKDIV_DIV2                *((volatile unsigned char*)(0x42762E88UL))
#define bFM4_RTC_VB_CLKDIV_DIV3                *((volatile unsigned char*)(0x42762E8CUL))
#define bFM4_RTC_VB_CLKDIV_DIV4                *((volatile unsigned char*)(0x42762E90UL))
#define bFM4_RTC_VB_CLKDIV_DIV5                *((volatile unsigned char*)(0x42762E94UL))
#define bFM4_RTC_VB_CLKDIV_DIV6                *((volatile unsigned char*)(0x42762E98UL))
#define bFM4_RTC_VB_CLKDIV_DIV7                *((volatile unsigned char*)(0x42762E9CUL))
#define bFM4_RTC_WTOSCCNT_SOSCEX               *((volatile unsigned char*)(0x42762F00UL))
#define bFM4_RTC_WTOSCCNT_SOSCNTL              *((volatile unsigned char*)(0x42762F04UL))
#define bFM4_RTC_BOOST_BOOST0                  *((volatile unsigned char*)(0x42763100UL))
#define bFM4_RTC_BOOST_BOOST1                  *((volatile unsigned char*)(0x42763104UL))
#define bFM4_RTC_EWKUP_WUP0                    *((volatile unsigned char*)(0x42763180UL))
#define bFM4_RTC_VDET_PON                      *((volatile unsigned char*)(0x4276321CUL))
#define bFM4_RTC_HIBRST_HIBRST                 *((volatile unsigned char*)(0x42763300UL))
#define bFM4_RTC_VBPFR_VPFR0                   *((volatile unsigned char*)(0x42763380UL))
#define bFM4_RTC_VBPFR_VPFR1                   *((volatile unsigned char*)(0x42763384UL))
#define bFM4_RTC_VBPFR_VPFR2                   *((volatile unsigned char*)(0x42763388UL))
#define bFM4_RTC_VBPFR_VPFR3                   *((volatile unsigned char*)(0x4276338CUL))
#define bFM4_RTC_VBPFR_SPSR0                   *((volatile unsigned char*)(0x42763390UL))
#define bFM4_RTC_VBPFR_SPSR1                   *((volatile unsigned char*)(0x42763394UL))
#define bFM4_RTC_VBPCR_VPCR0                   *((volatile unsigned char*)(0x42763400UL))
#define bFM4_RTC_VBPCR_VPCR1                   *((volatile unsigned char*)(0x42763404UL))
#define bFM4_RTC_VBPCR_VPCR2                   *((volatile unsigned char*)(0x42763408UL))
#define bFM4_RTC_VBPCR_VPCR3                   *((volatile unsigned char*)(0x4276340CUL))
#define bFM4_RTC_VBDDR_VDDR0                   *((volatile unsigned char*)(0x42763480UL))
#define bFM4_RTC_VBDDR_VDDR1                   *((volatile unsigned char*)(0x42763484UL))
#define bFM4_RTC_VBDDR_VDDR2                   *((volatile unsigned char*)(0x42763488UL))
#define bFM4_RTC_VBDDR_VDDR3                   *((volatile unsigned char*)(0x4276348CUL))
#define bFM4_RTC_VBDIR_VDIR0                   *((volatile unsigned char*)(0x42763500UL))
#define bFM4_RTC_VBDIR_VDIR1                   *((volatile unsigned char*)(0x42763504UL))
#define bFM4_RTC_VBDIR_VDIR2                   *((volatile unsigned char*)(0x42763508UL))
#define bFM4_RTC_VBDIR_VDIR3                   *((volatile unsigned char*)(0x4276350CUL))
#define bFM4_RTC_VBDOR_VDOR0                   *((volatile unsigned char*)(0x42763580UL))
#define bFM4_RTC_VBDOR_VDOR1                   *((volatile unsigned char*)(0x42763584UL))
#define bFM4_RTC_VBDOR_VDOR2                   *((volatile unsigned char*)(0x42763588UL))
#define bFM4_RTC_VBDOR_VDOR3                   *((volatile unsigned char*)(0x4276358CUL))
#define bFM4_RTC_VBPZR_VPZR0                   *((volatile unsigned char*)(0x42763600UL))
#define bFM4_RTC_VBPZR_VPZR1                   *((volatile unsigned char*)(0x42763604UL))

/* Low-speed CR prescaler registers */
#define bFM4_LCR_LCR_PRSLD_LCR_PRSLD0          *((volatile unsigned char*)(0x42780000UL))
#define bFM4_LCR_LCR_PRSLD_LCR_PRSLD1          *((volatile unsigned char*)(0x42780004UL))
#define bFM4_LCR_LCR_PRSLD_LCR_PRSLD2          *((volatile unsigned char*)(0x42780008UL))
#define bFM4_LCR_LCR_PRSLD_LCR_PRSLD3          *((volatile unsigned char*)(0x4278000CUL))
#define bFM4_LCR_LCR_PRSLD_LCR_PRSLD4          *((volatile unsigned char*)(0x42780010UL))
#define bFM4_LCR_LCR_PRSLD_LCR_PRSLD5          *((volatile unsigned char*)(0x42780014UL))

/* Peripheral Clock Gating registers */
#define bFM4_CLK_GATING_CKEN0_MFSCK0           *((volatile unsigned char*)(0x42782000UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK1           *((volatile unsigned char*)(0x42782004UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK2           *((volatile unsigned char*)(0x42782008UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK3           *((volatile unsigned char*)(0x4278200CUL))
#define bFM4_CLK_GATING_CKEN0_MFSCK4           *((volatile unsigned char*)(0x42782010UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK5           *((volatile unsigned char*)(0x42782014UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK6           *((volatile unsigned char*)(0x42782018UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK7           *((volatile unsigned char*)(0x4278201CUL))
#define bFM4_CLK_GATING_CKEN0_MFSCK8           *((volatile unsigned char*)(0x42782020UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK9           *((volatile unsigned char*)(0x42782024UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK10          *((volatile unsigned char*)(0x42782028UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK11          *((volatile unsigned char*)(0x4278202CUL))
#define bFM4_CLK_GATING_CKEN0_MFSCK12          *((volatile unsigned char*)(0x42782030UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK13          *((volatile unsigned char*)(0x42782034UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK14          *((volatile unsigned char*)(0x42782038UL))
#define bFM4_CLK_GATING_CKEN0_MFSCK15          *((volatile unsigned char*)(0x4278203CUL))
#define bFM4_CLK_GATING_CKEN0_ADCCK0           *((volatile unsigned char*)(0x42782040UL))
#define bFM4_CLK_GATING_CKEN0_ADCCK1           *((volatile unsigned char*)(0x42782044UL))
#define bFM4_CLK_GATING_CKEN0_ADCCK2           *((volatile unsigned char*)(0x42782048UL))
#define bFM4_CLK_GATING_CKEN0_ADCCK3           *((volatile unsigned char*)(0x4278204CUL))
#define bFM4_CLK_GATING_CKEN0_DMACK            *((volatile unsigned char*)(0x42782060UL))
#define bFM4_CLK_GATING_CKEN0_EXBCK            *((volatile unsigned char*)(0x42782068UL))
#define bFM4_CLK_GATING_CKEN0_GIOCK            *((volatile unsigned char*)(0x42782070UL))
#define bFM4_CLK_GATING_MRST0_MFSRST0          *((volatile unsigned char*)(0x42782080UL))
#define bFM4_CLK_GATING_MRST0_MFSRST1          *((volatile unsigned char*)(0x42782084UL))
#define bFM4_CLK_GATING_MRST0_MFSRST2          *((volatile unsigned char*)(0x42782088UL))
#define bFM4_CLK_GATING_MRST0_MFSRST3          *((volatile unsigned char*)(0x4278208CUL))
#define bFM4_CLK_GATING_MRST0_MFSRST4          *((volatile unsigned char*)(0x42782090UL))
#define bFM4_CLK_GATING_MRST0_MFSRST5          *((volatile unsigned char*)(0x42782094UL))
#define bFM4_CLK_GATING_MRST0_MFSRST6          *((volatile unsigned char*)(0x42782098UL))
#define bFM4_CLK_GATING_MRST0_MFSRST7          *((volatile unsigned char*)(0x4278209CUL))
#define bFM4_CLK_GATING_MRST0_MFSRST8          *((volatile unsigned char*)(0x427820A0UL))
#define bFM4_CLK_GATING_MRST0_MFSRST9          *((volatile unsigned char*)(0x427820A4UL))
#define bFM4_CLK_GATING_MRST0_MFSRST10         *((volatile unsigned char*)(0x427820A8UL))
#define bFM4_CLK_GATING_MRST0_MFSRST11         *((volatile unsigned char*)(0x427820ACUL))
#define bFM4_CLK_GATING_MRST0_MFSRST12         *((volatile unsigned char*)(0x427820B0UL))
#define bFM4_CLK_GATING_MRST0_MFSRST13         *((volatile unsigned char*)(0x427820B4UL))
#define bFM4_CLK_GATING_MRST0_MFSRST14         *((volatile unsigned char*)(0x427820B8UL))
#define bFM4_CLK_GATING_MRST0_MFSRST15         *((volatile unsigned char*)(0x427820BCUL))
#define bFM4_CLK_GATING_MRST0_ADCRST0          *((volatile unsigned char*)(0x427820C0UL))
#define bFM4_CLK_GATING_MRST0_ADCRST1          *((volatile unsigned char*)(0x427820C4UL))
#define bFM4_CLK_GATING_MRST0_ADCRST2          *((volatile unsigned char*)(0x427820C8UL))
#define bFM4_CLK_GATING_MRST0_ADCRST3          *((volatile unsigned char*)(0x427820CCUL))
#define bFM4_CLK_GATING_MRST0_DMARST           *((volatile unsigned char*)(0x427820E0UL))
#define bFM4_CLK_GATING_MRST0_EXBRST           *((volatile unsigned char*)(0x427820E8UL))
#define bFM4_CLK_GATING_CKEN1_BTMCK0           *((volatile unsigned char*)(0x42782200UL))
#define bFM4_CLK_GATING_CKEN1_BTMCK1           *((volatile unsigned char*)(0x42782204UL))
#define bFM4_CLK_GATING_CKEN1_BTMCK2           *((volatile unsigned char*)(0x42782208UL))
#define bFM4_CLK_GATING_CKEN1_BTMCK3           *((volatile unsigned char*)(0x4278220CUL))
#define bFM4_CLK_GATING_CKEN1_MFTCK0           *((volatile unsigned char*)(0x42782220UL))
#define bFM4_CLK_GATING_CKEN1_MFTCK1           *((volatile unsigned char*)(0x42782224UL))
#define bFM4_CLK_GATING_CKEN1_MFTCK2           *((volatile unsigned char*)(0x42782228UL))
#define bFM4_CLK_GATING_CKEN1_MFTCK3           *((volatile unsigned char*)(0x4278222CUL))
#define bFM4_CLK_GATING_CKEN1_QDUCK0           *((volatile unsigned char*)(0x42782240UL))
#define bFM4_CLK_GATING_CKEN1_QDUCK1           *((volatile unsigned char*)(0x42782244UL))
#define bFM4_CLK_GATING_CKEN1_QDUCK2           *((volatile unsigned char*)(0x42782248UL))
#define bFM4_CLK_GATING_CKEN1_QDUCK3           *((volatile unsigned char*)(0x4278224CUL))
#define bFM4_CLK_GATING_MRST1_BTMRST0          *((volatile unsigned char*)(0x42782280UL))
#define bFM4_CLK_GATING_MRST1_BTMRST1          *((volatile unsigned char*)(0x42782284UL))
#define bFM4_CLK_GATING_MRST1_BTMRST2          *((volatile unsigned char*)(0x42782288UL))
#define bFM4_CLK_GATING_MRST1_BTMRST3          *((volatile unsigned char*)(0x4278228CUL))
#define bFM4_CLK_GATING_MRST1_MFTRST0          *((volatile unsigned char*)(0x427822A0UL))
#define bFM4_CLK_GATING_MRST1_MFTRST1          *((volatile unsigned char*)(0x427822A4UL))
#define bFM4_CLK_GATING_MRST1_MFTRST2          *((volatile unsigned char*)(0x427822A8UL))
#define bFM4_CLK_GATING_MRST1_MFTRST3          *((volatile unsigned char*)(0x427822ACUL))
#define bFM4_CLK_GATING_MRST1_QDURST0          *((volatile unsigned char*)(0x427822C0UL))
#define bFM4_CLK_GATING_MRST1_QDURST1          *((volatile unsigned char*)(0x427822C4UL))
#define bFM4_CLK_GATING_MRST1_QDURST2          *((volatile unsigned char*)(0x427822C8UL))
#define bFM4_CLK_GATING_MRST1_QDURST3          *((volatile unsigned char*)(0x427822CCUL))
#define bFM4_CLK_GATING_CKEN2_USBCK0           *((volatile unsigned char*)(0x42782400UL))
#define bFM4_CLK_GATING_CKEN2_USBCK1           *((volatile unsigned char*)(0x42782404UL))
#define bFM4_CLK_GATING_CKEN2_CANCK0           *((volatile unsigned char*)(0x42782410UL))
#define bFM4_CLK_GATING_CKEN2_CANCK1           *((volatile unsigned char*)(0x42782414UL))
#define bFM4_CLK_GATING_CKEN2_CANCK2           *((volatile unsigned char*)(0x42782418UL))
#define bFM4_CLK_GATING_CKEN2_SDCCK            *((volatile unsigned char*)(0x42782420UL))
#define bFM4_CLK_GATING_CKEN2_I2SCK0           *((volatile unsigned char*)(0x42782440UL))
#define bFM4_CLK_GATING_CKEN2_I2SCK1           *((volatile unsigned char*)(0x42782444UL))
#define bFM4_CLK_GATING_CKEN2_PCRCCK           *((volatile unsigned char*)(0x42782450UL))
#define bFM4_CLK_GATING_CKEN2_CECCK0           *((volatile unsigned char*)(0x42782460UL))
#define bFM4_CLK_GATING_CKEN2_CECCK1           *((volatile unsigned char*)(0x42782464UL))
#define bFM4_CLK_GATING_CKEN2_QSPICK           *((volatile unsigned char*)(0x42782470UL))
#define bFM4_CLK_GATING_MRST2_USBRST0          *((volatile unsigned char*)(0x42782480UL))
#define bFM4_CLK_GATING_MRST2_USBRST1          *((volatile unsigned char*)(0x42782484UL))
#define bFM4_CLK_GATING_MRST2_CANRST0          *((volatile unsigned char*)(0x42782490UL))
#define bFM4_CLK_GATING_MRST2_CANRST1          *((volatile unsigned char*)(0x42782494UL))
#define bFM4_CLK_GATING_MRST2_CANRST2          *((volatile unsigned char*)(0x42782498UL))
#define bFM4_CLK_GATING_MRST2_SDCRST           *((volatile unsigned char*)(0x427824A0UL))
#define bFM4_CLK_GATING_MRST2_I2SRST0          *((volatile unsigned char*)(0x427824C0UL))
#define bFM4_CLK_GATING_MRST2_I2SRST1          *((volatile unsigned char*)(0x427824C4UL))
#define bFM4_CLK_GATING_MRST2_PCRCRST          *((volatile unsigned char*)(0x427824D0UL))
#define bFM4_CLK_GATING_MRST2_CECRST0          *((volatile unsigned char*)(0x427824E0UL))
#define bFM4_CLK_GATING_MRST2_CECRST1          *((volatile unsigned char*)(0x427824E4UL))
#define bFM4_CLK_GATING_MRST2_QSPIRST          *((volatile unsigned char*)(0x427824F0UL))

/* I2S Pre-scalor registers */
#define bFM4_I2SPRE_ICCR_ICEN                  *((volatile unsigned char*)(0x427A0000UL))
#define bFM4_I2SPRE_ICCR_ICSEL                 *((volatile unsigned char*)(0x427A0004UL))
#define bFM4_I2SPRE_IPCR1_IPLLEN               *((volatile unsigned char*)(0x427A0080UL))
#define bFM4_I2SPRE_IPCR2_IPOWT0               *((volatile unsigned char*)(0x427A0100UL))
#define bFM4_I2SPRE_IPCR2_IPOWT1               *((volatile unsigned char*)(0x427A0104UL))
#define bFM4_I2SPRE_IPCR2_IPOWT2               *((volatile unsigned char*)(0x427A0108UL))
#define bFM4_I2SPRE_IPCR3_IPLLK0               *((volatile unsigned char*)(0x427A0180UL))
#define bFM4_I2SPRE_IPCR3_IPLLK1               *((volatile unsigned char*)(0x427A0184UL))
#define bFM4_I2SPRE_IPCR3_IPLLK2               *((volatile unsigned char*)(0x427A0188UL))
#define bFM4_I2SPRE_IPCR3_IPLLK3               *((volatile unsigned char*)(0x427A018CUL))
#define bFM4_I2SPRE_IPCR3_IPLLK4               *((volatile unsigned char*)(0x427A0190UL))
#define bFM4_I2SPRE_IPCR4_IPLLN0               *((volatile unsigned char*)(0x427A0200UL))
#define bFM4_I2SPRE_IPCR4_IPLLN1               *((volatile unsigned char*)(0x427A0204UL))
#define bFM4_I2SPRE_IPCR4_IPLLN2               *((volatile unsigned char*)(0x427A0208UL))
#define bFM4_I2SPRE_IPCR4_IPLLN3               *((volatile unsigned char*)(0x427A020CUL))
#define bFM4_I2SPRE_IPCR4_IPLLN4               *((volatile unsigned char*)(0x427A0210UL))
#define bFM4_I2SPRE_IPCR4_IPLLN5               *((volatile unsigned char*)(0x427A0214UL))
#define bFM4_I2SPRE_IPCR4_IPLLN6               *((volatile unsigned char*)(0x427A0218UL))
#define bFM4_I2SPRE_IP_STR_IPRDY               *((volatile unsigned char*)(0x427A0280UL))
#define bFM4_I2SPRE_IPINT_ENR_IPCSE            *((volatile unsigned char*)(0x427A0300UL))
#define bFM4_I2SPRE_IPINT_CLR_IPCSC            *((volatile unsigned char*)(0x427A0380UL))
#define bFM4_I2SPRE_IPINT_STR_IPCSI            *((volatile unsigned char*)(0x427A0400UL))
#define bFM4_I2SPRE_IPCR5_IPLLM0               *((volatile unsigned char*)(0x427A0480UL))
#define bFM4_I2SPRE_IPCR5_IPLLM1               *((volatile unsigned char*)(0x427A0484UL))
#define bFM4_I2SPRE_IPCR5_IPLLM2               *((volatile unsigned char*)(0x427A0488UL))
#define bFM4_I2SPRE_IPCR5_IPLLM3               *((volatile unsigned char*)(0x427A048CUL))
#define bFM4_I2SPRE_IPCR5_IPLLM4               *((volatile unsigned char*)(0x427A0490UL))
#define bFM4_I2SPRE_IPCR5_IPLLM5               *((volatile unsigned char*)(0x427A0494UL))
#define bFM4_I2SPRE_IPCR5_IPLLM6               *((volatile unsigned char*)(0x427A0498UL))

/* External bus interface registers */
#define bFM4_EXBUS_MODE0_WDTH0                 *((volatile unsigned int*)(0x427E0000UL))
#define bFM4_EXBUS_MODE0_WDTH1                 *((volatile unsigned int*)(0x427E0004UL))
#define bFM4_EXBUS_MODE0_RBMON                 *((volatile unsigned int*)(0x427E0008UL))
#define bFM4_EXBUS_MODE0_WEOFF                 *((volatile unsigned int*)(0x427E000CUL))
#define bFM4_EXBUS_MODE0_NAND                  *((volatile unsigned int*)(0x427E0010UL))
#define bFM4_EXBUS_MODE0_PAGE                  *((volatile unsigned int*)(0x427E0014UL))
#define bFM4_EXBUS_MODE0_RDY                   *((volatile unsigned int*)(0x427E0018UL))
#define bFM4_EXBUS_MODE0_SHRTDOUT              *((volatile unsigned int*)(0x427E001CUL))
#define bFM4_EXBUS_MODE0_MPXMODE               *((volatile unsigned int*)(0x427E0020UL))
#define bFM4_EXBUS_MODE0_ALEINV                *((volatile unsigned int*)(0x427E0024UL))
#define bFM4_EXBUS_MODE0_MPXDOFF               *((volatile unsigned int*)(0x427E002CUL))
#define bFM4_EXBUS_MODE0_MPXCSOF               *((volatile unsigned int*)(0x427E0030UL))
#define bFM4_EXBUS_MODE0_MOEXEUP               *((volatile unsigned int*)(0x427E0034UL))
#define bFM4_EXBUS_MODE1_WDTH0                 *((volatile unsigned int*)(0x427E0080UL))
#define bFM4_EXBUS_MODE1_WDTH1                 *((volatile unsigned int*)(0x427E0084UL))
#define bFM4_EXBUS_MODE1_RBMON                 *((volatile unsigned int*)(0x427E0088UL))
#define bFM4_EXBUS_MODE1_WEOFF                 *((volatile unsigned int*)(0x427E008CUL))
#define bFM4_EXBUS_MODE1_NAND                  *((volatile unsigned int*)(0x427E0090UL))
#define bFM4_EXBUS_MODE1_PAGE                  *((volatile unsigned int*)(0x427E0094UL))
#define bFM4_EXBUS_MODE1_RDY                   *((volatile unsigned int*)(0x427E0098UL))
#define bFM4_EXBUS_MODE1_SHRTDOUT              *((volatile unsigned int*)(0x427E009CUL))
#define bFM4_EXBUS_MODE1_MPXMODE               *((volatile unsigned int*)(0x427E00A0UL))
#define bFM4_EXBUS_MODE1_ALEINV                *((volatile unsigned int*)(0x427E00A4UL))
#define bFM4_EXBUS_MODE1_MPXDOFF               *((volatile unsigned int*)(0x427E00ACUL))
#define bFM4_EXBUS_MODE1_MPXCSOF               *((volatile unsigned int*)(0x427E00B0UL))
#define bFM4_EXBUS_MODE1_MOEXEUP               *((volatile unsigned int*)(0x427E00B4UL))
#define bFM4_EXBUS_MODE2_WDTH0                 *((volatile unsigned int*)(0x427E0100UL))
#define bFM4_EXBUS_MODE2_WDTH1                 *((volatile unsigned int*)(0x427E0104UL))
#define bFM4_EXBUS_MODE2_RBMON                 *((volatile unsigned int*)(0x427E0108UL))
#define bFM4_EXBUS_MODE2_WEOFF                 *((volatile unsigned int*)(0x427E010CUL))
#define bFM4_EXBUS_MODE2_NAND                  *((volatile unsigned int*)(0x427E0110UL))
#define bFM4_EXBUS_MODE2_PAGE                  *((volatile unsigned int*)(0x427E0114UL))
#define bFM4_EXBUS_MODE2_RDY                   *((volatile unsigned int*)(0x427E0118UL))
#define bFM4_EXBUS_MODE2_SHRTDOUT              *((volatile unsigned int*)(0x427E011CUL))
#define bFM4_EXBUS_MODE2_MPXMODE               *((volatile unsigned int*)(0x427E0120UL))
#define bFM4_EXBUS_MODE2_ALEINV                *((volatile unsigned int*)(0x427E0124UL))
#define bFM4_EXBUS_MODE2_MPXDOFF               *((volatile unsigned int*)(0x427E012CUL))
#define bFM4_EXBUS_MODE2_MPXCSOF               *((volatile unsigned int*)(0x427E0130UL))
#define bFM4_EXBUS_MODE2_MOEXEUP               *((volatile unsigned int*)(0x427E0134UL))
#define bFM4_EXBUS_MODE3_WDTH0                 *((volatile unsigned int*)(0x427E0180UL))
#define bFM4_EXBUS_MODE3_WDTH1                 *((volatile unsigned int*)(0x427E0184UL))
#define bFM4_EXBUS_MODE3_RBMON                 *((volatile unsigned int*)(0x427E0188UL))
#define bFM4_EXBUS_MODE3_WEOFF                 *((volatile unsigned int*)(0x427E018CUL))
#define bFM4_EXBUS_MODE3_NAND                  *((volatile unsigned int*)(0x427E0190UL))
#define bFM4_EXBUS_MODE3_PAGE                  *((volatile unsigned int*)(0x427E0194UL))
#define bFM4_EXBUS_MODE3_RDY                   *((volatile unsigned int*)(0x427E0198UL))
#define bFM4_EXBUS_MODE3_SHRTDOUT              *((volatile unsigned int*)(0x427E019CUL))
#define bFM4_EXBUS_MODE3_MPXMODE               *((volatile unsigned int*)(0x427E01A0UL))
#define bFM4_EXBUS_MODE3_ALEINV                *((volatile unsigned int*)(0x427E01A4UL))
#define bFM4_EXBUS_MODE3_MPXDOFF               *((volatile unsigned int*)(0x427E01ACUL))
#define bFM4_EXBUS_MODE3_MPXCSOF               *((volatile unsigned int*)(0x427E01B0UL))
#define bFM4_EXBUS_MODE3_MOEXEUP               *((volatile unsigned int*)(0x427E01B4UL))
#define bFM4_EXBUS_MODE4_WDTH0                 *((volatile unsigned int*)(0x427E0200UL))
#define bFM4_EXBUS_MODE4_WDTH1                 *((volatile unsigned int*)(0x427E0204UL))
#define bFM4_EXBUS_MODE4_RBMON                 *((volatile unsigned int*)(0x427E0208UL))
#define bFM4_EXBUS_MODE4_WEOFF                 *((volatile unsigned int*)(0x427E020CUL))
#define bFM4_EXBUS_MODE4_NAND                  *((volatile unsigned int*)(0x427E0210UL))
#define bFM4_EXBUS_MODE4_PAGE                  *((volatile unsigned int*)(0x427E0214UL))
#define bFM4_EXBUS_MODE4_RDY                   *((volatile unsigned int*)(0x427E0218UL))
#define bFM4_EXBUS_MODE4_SHRTDOUT              *((volatile unsigned int*)(0x427E021CUL))
#define bFM4_EXBUS_MODE4_MPXMODE               *((volatile unsigned int*)(0x427E0220UL))
#define bFM4_EXBUS_MODE4_ALEINV                *((volatile unsigned int*)(0x427E0224UL))
#define bFM4_EXBUS_MODE4_MPXDOFF               *((volatile unsigned int*)(0x427E022CUL))
#define bFM4_EXBUS_MODE4_MPXCSOF               *((volatile unsigned int*)(0x427E0230UL))
#define bFM4_EXBUS_MODE4_MOEXEUP               *((volatile unsigned int*)(0x427E0234UL))
#define bFM4_EXBUS_MODE5_WDTH0                 *((volatile unsigned int*)(0x427E0280UL))
#define bFM4_EXBUS_MODE5_WDTH1                 *((volatile unsigned int*)(0x427E0284UL))
#define bFM4_EXBUS_MODE5_RBMON                 *((volatile unsigned int*)(0x427E0288UL))
#define bFM4_EXBUS_MODE5_WEOFF                 *((volatile unsigned int*)(0x427E028CUL))
#define bFM4_EXBUS_MODE5_NAND                  *((volatile unsigned int*)(0x427E0290UL))
#define bFM4_EXBUS_MODE5_PAGE                  *((volatile unsigned int*)(0x427E0294UL))
#define bFM4_EXBUS_MODE5_RDY                   *((volatile unsigned int*)(0x427E0298UL))
#define bFM4_EXBUS_MODE5_SHRTDOUT              *((volatile unsigned int*)(0x427E029CUL))
#define bFM4_EXBUS_MODE5_MPXMODE               *((volatile unsigned int*)(0x427E02A0UL))
#define bFM4_EXBUS_MODE5_ALEINV                *((volatile unsigned int*)(0x427E02A4UL))
#define bFM4_EXBUS_MODE5_MPXDOFF               *((volatile unsigned int*)(0x427E02ACUL))
#define bFM4_EXBUS_MODE5_MPXCSOF               *((volatile unsigned int*)(0x427E02B0UL))
#define bFM4_EXBUS_MODE5_MOEXEUP               *((volatile unsigned int*)(0x427E02B4UL))
#define bFM4_EXBUS_MODE6_WDTH0                 *((volatile unsigned int*)(0x427E0300UL))
#define bFM4_EXBUS_MODE6_WDTH1                 *((volatile unsigned int*)(0x427E0304UL))
#define bFM4_EXBUS_MODE6_RBMON                 *((volatile unsigned int*)(0x427E0308UL))
#define bFM4_EXBUS_MODE6_WEOFF                 *((volatile unsigned int*)(0x427E030CUL))
#define bFM4_EXBUS_MODE6_NAND                  *((volatile unsigned int*)(0x427E0310UL))
#define bFM4_EXBUS_MODE6_PAGE                  *((volatile unsigned int*)(0x427E0314UL))
#define bFM4_EXBUS_MODE6_RDY                   *((volatile unsigned int*)(0x427E0318UL))
#define bFM4_EXBUS_MODE6_SHRTDOUT              *((volatile unsigned int*)(0x427E031CUL))
#define bFM4_EXBUS_MODE6_MPXMODE               *((volatile unsigned int*)(0x427E0320UL))
#define bFM4_EXBUS_MODE6_ALEINV                *((volatile unsigned int*)(0x427E0324UL))
#define bFM4_EXBUS_MODE6_MPXDOFF               *((volatile unsigned int*)(0x427E032CUL))
#define bFM4_EXBUS_MODE6_MPXCSOF               *((volatile unsigned int*)(0x427E0330UL))
#define bFM4_EXBUS_MODE6_MOEXEUP               *((volatile unsigned int*)(0x427E0334UL))
#define bFM4_EXBUS_MODE7_WDTH0                 *((volatile unsigned int*)(0x427E0380UL))
#define bFM4_EXBUS_MODE7_WDTH1                 *((volatile unsigned int*)(0x427E0384UL))
#define bFM4_EXBUS_MODE7_RBMON                 *((volatile unsigned int*)(0x427E0388UL))
#define bFM4_EXBUS_MODE7_WEOFF                 *((volatile unsigned int*)(0x427E038CUL))
#define bFM4_EXBUS_MODE7_NAND                  *((volatile unsigned int*)(0x427E0390UL))
#define bFM4_EXBUS_MODE7_PAGE                  *((volatile unsigned int*)(0x427E0394UL))
#define bFM4_EXBUS_MODE7_RDY                   *((volatile unsigned int*)(0x427E0398UL))
#define bFM4_EXBUS_MODE7_SHRTDOUT              *((volatile unsigned int*)(0x427E039CUL))
#define bFM4_EXBUS_MODE7_MPXMODE               *((volatile unsigned int*)(0x427E03A0UL))
#define bFM4_EXBUS_MODE7_ALEINV                *((volatile unsigned int*)(0x427E03A4UL))
#define bFM4_EXBUS_MODE7_MPXDOFF               *((volatile unsigned int*)(0x427E03ACUL))
#define bFM4_EXBUS_MODE7_MPXCSOF               *((volatile unsigned int*)(0x427E03B0UL))
#define bFM4_EXBUS_MODE7_MOEXEUP               *((volatile unsigned int*)(0x427E03B4UL))
#define bFM4_EXBUS_TIM0_RACC0                  *((volatile unsigned int*)(0x427E0400UL))
#define bFM4_EXBUS_TIM0_RACC1                  *((volatile unsigned int*)(0x427E0404UL))
#define bFM4_EXBUS_TIM0_RACC2                  *((volatile unsigned int*)(0x427E0408UL))
#define bFM4_EXBUS_TIM0_RACC3                  *((volatile unsigned int*)(0x427E040CUL))
#define bFM4_EXBUS_TIM0_RADC0                  *((volatile unsigned int*)(0x427E0410UL))
#define bFM4_EXBUS_TIM0_RADC1                  *((volatile unsigned int*)(0x427E0414UL))
#define bFM4_EXBUS_TIM0_RADC2                  *((volatile unsigned int*)(0x427E0418UL))
#define bFM4_EXBUS_TIM0_RADC3                  *((volatile unsigned int*)(0x427E041CUL))
#define bFM4_EXBUS_TIM0_FRADC0                 *((volatile unsigned int*)(0x427E0420UL))
#define bFM4_EXBUS_TIM0_FRADC1                 *((volatile unsigned int*)(0x427E0424UL))
#define bFM4_EXBUS_TIM0_FRADC2                 *((volatile unsigned int*)(0x427E0428UL))
#define bFM4_EXBUS_TIM0_FRADC3                 *((volatile unsigned int*)(0x427E042CUL))
#define bFM4_EXBUS_TIM0_RIDLC0                 *((volatile unsigned int*)(0x427E0430UL))
#define bFM4_EXBUS_TIM0_RIDLC1                 *((volatile unsigned int*)(0x427E0434UL))
#define bFM4_EXBUS_TIM0_RIDLC2                 *((volatile unsigned int*)(0x427E0438UL))
#define bFM4_EXBUS_TIM0_RIDLC3                 *((volatile unsigned int*)(0x427E043CUL))
#define bFM4_EXBUS_TIM0_WACC0                  *((volatile unsigned int*)(0x427E0440UL))
#define bFM4_EXBUS_TIM0_WACC1                  *((volatile unsigned int*)(0x427E0444UL))
#define bFM4_EXBUS_TIM0_WACC2                  *((volatile unsigned int*)(0x427E0448UL))
#define bFM4_EXBUS_TIM0_WACC3                  *((volatile unsigned int*)(0x427E044CUL))
#define bFM4_EXBUS_TIM0_WADC0                  *((volatile unsigned int*)(0x427E0450UL))
#define bFM4_EXBUS_TIM0_WADC1                  *((volatile unsigned int*)(0x427E0454UL))
#define bFM4_EXBUS_TIM0_WADC2                  *((volatile unsigned int*)(0x427E0458UL))
#define bFM4_EXBUS_TIM0_WADC3                  *((volatile unsigned int*)(0x427E045CUL))
#define bFM4_EXBUS_TIM0_WWEC0                  *((volatile unsigned int*)(0x427E0460UL))
#define bFM4_EXBUS_TIM0_WWEC1                  *((volatile unsigned int*)(0x427E0464UL))
#define bFM4_EXBUS_TIM0_WWEC2                  *((volatile unsigned int*)(0x427E0468UL))
#define bFM4_EXBUS_TIM0_WWEC3                  *((volatile unsigned int*)(0x427E046CUL))
#define bFM4_EXBUS_TIM0_WIDLC0                 *((volatile unsigned int*)(0x427E0470UL))
#define bFM4_EXBUS_TIM0_WIDLC1                 *((volatile unsigned int*)(0x427E0474UL))
#define bFM4_EXBUS_TIM0_WIDLC2                 *((volatile unsigned int*)(0x427E0478UL))
#define bFM4_EXBUS_TIM0_WIDLC3                 *((volatile unsigned int*)(0x427E047CUL))
#define bFM4_EXBUS_TIM1_RACC0                  *((volatile unsigned int*)(0x427E0480UL))
#define bFM4_EXBUS_TIM1_RACC1                  *((volatile unsigned int*)(0x427E0484UL))
#define bFM4_EXBUS_TIM1_RACC2                  *((volatile unsigned int*)(0x427E0488UL))
#define bFM4_EXBUS_TIM1_RACC3                  *((volatile unsigned int*)(0x427E048CUL))
#define bFM4_EXBUS_TIM1_RADC0                  *((volatile unsigned int*)(0x427E0490UL))
#define bFM4_EXBUS_TIM1_RADC1                  *((volatile unsigned int*)(0x427E0494UL))
#define bFM4_EXBUS_TIM1_RADC2                  *((volatile unsigned int*)(0x427E0498UL))
#define bFM4_EXBUS_TIM1_RADC3                  *((volatile unsigned int*)(0x427E049CUL))
#define bFM4_EXBUS_TIM1_FRADC0                 *((volatile unsigned int*)(0x427E04A0UL))
#define bFM4_EXBUS_TIM1_FRADC1                 *((volatile unsigned int*)(0x427E04A4UL))
#define bFM4_EXBUS_TIM1_FRADC2                 *((volatile unsigned int*)(0x427E04A8UL))
#define bFM4_EXBUS_TIM1_FRADC3                 *((volatile unsigned int*)(0x427E04ACUL))
#define bFM4_EXBUS_TIM1_RIDLC0                 *((volatile unsigned int*)(0x427E04B0UL))
#define bFM4_EXBUS_TIM1_RIDLC1                 *((volatile unsigned int*)(0x427E04B4UL))
#define bFM4_EXBUS_TIM1_RIDLC2                 *((volatile unsigned int*)(0x427E04B8UL))
#define bFM4_EXBUS_TIM1_RIDLC3                 *((volatile unsigned int*)(0x427E04BCUL))
#define bFM4_EXBUS_TIM1_WACC0                  *((volatile unsigned int*)(0x427E04C0UL))
#define bFM4_EXBUS_TIM1_WACC1                  *((volatile unsigned int*)(0x427E04C4UL))
#define bFM4_EXBUS_TIM1_WACC2                  *((volatile unsigned int*)(0x427E04C8UL))
#define bFM4_EXBUS_TIM1_WACC3                  *((volatile unsigned int*)(0x427E04CCUL))
#define bFM4_EXBUS_TIM1_WADC0                  *((volatile unsigned int*)(0x427E04D0UL))
#define bFM4_EXBUS_TIM1_WADC1                  *((volatile unsigned int*)(0x427E04D4UL))
#define bFM4_EXBUS_TIM1_WADC2                  *((volatile unsigned int*)(0x427E04D8UL))
#define bFM4_EXBUS_TIM1_WADC3                  *((volatile unsigned int*)(0x427E04DCUL))
#define bFM4_EXBUS_TIM1_WWEC0                  *((volatile unsigned int*)(0x427E04E0UL))
#define bFM4_EXBUS_TIM1_WWEC1                  *((volatile unsigned int*)(0x427E04E4UL))
#define bFM4_EXBUS_TIM1_WWEC2                  *((volatile unsigned int*)(0x427E04E8UL))
#define bFM4_EXBUS_TIM1_WWEC3                  *((volatile unsigned int*)(0x427E04ECUL))
#define bFM4_EXBUS_TIM1_WIDLC0                 *((volatile unsigned int*)(0x427E04F0UL))
#define bFM4_EXBUS_TIM1_WIDLC1                 *((volatile unsigned int*)(0x427E04F4UL))
#define bFM4_EXBUS_TIM1_WIDLC2                 *((volatile unsigned int*)(0x427E04F8UL))
#define bFM4_EXBUS_TIM1_WIDLC3                 *((volatile unsigned int*)(0x427E04FCUL))
#define bFM4_EXBUS_TIM2_RACC0                  *((volatile unsigned int*)(0x427E0500UL))
#define bFM4_EXBUS_TIM2_RACC1                  *((volatile unsigned int*)(0x427E0504UL))
#define bFM4_EXBUS_TIM2_RACC2                  *((volatile unsigned int*)(0x427E0508UL))
#define bFM4_EXBUS_TIM2_RACC3                  *((volatile unsigned int*)(0x427E050CUL))
#define bFM4_EXBUS_TIM2_RADC0                  *((volatile unsigned int*)(0x427E0510UL))
#define bFM4_EXBUS_TIM2_RADC1                  *((volatile unsigned int*)(0x427E0514UL))
#define bFM4_EXBUS_TIM2_RADC2                  *((volatile unsigned int*)(0x427E0518UL))
#define bFM4_EXBUS_TIM2_RADC3                  *((volatile unsigned int*)(0x427E051CUL))
#define bFM4_EXBUS_TIM2_FRADC0                 *((volatile unsigned int*)(0x427E0520UL))
#define bFM4_EXBUS_TIM2_FRADC1                 *((volatile unsigned int*)(0x427E0524UL))
#define bFM4_EXBUS_TIM2_FRADC2                 *((volatile unsigned int*)(0x427E0528UL))
#define bFM4_EXBUS_TIM2_FRADC3                 *((volatile unsigned int*)(0x427E052CUL))
#define bFM4_EXBUS_TIM2_RIDLC0                 *((volatile unsigned int*)(0x427E0530UL))
#define bFM4_EXBUS_TIM2_RIDLC1                 *((volatile unsigned int*)(0x427E0534UL))
#define bFM4_EXBUS_TIM2_RIDLC2                 *((volatile unsigned int*)(0x427E0538UL))
#define bFM4_EXBUS_TIM2_RIDLC3                 *((volatile unsigned int*)(0x427E053CUL))
#define bFM4_EXBUS_TIM2_WACC0                  *((volatile unsigned int*)(0x427E0540UL))
#define bFM4_EXBUS_TIM2_WACC1                  *((volatile unsigned int*)(0x427E0544UL))
#define bFM4_EXBUS_TIM2_WACC2                  *((volatile unsigned int*)(0x427E0548UL))
#define bFM4_EXBUS_TIM2_WACC3                  *((volatile unsigned int*)(0x427E054CUL))
#define bFM4_EXBUS_TIM2_WADC0                  *((volatile unsigned int*)(0x427E0550UL))
#define bFM4_EXBUS_TIM2_WADC1                  *((volatile unsigned int*)(0x427E0554UL))
#define bFM4_EXBUS_TIM2_WADC2                  *((volatile unsigned int*)(0x427E0558UL))
#define bFM4_EXBUS_TIM2_WADC3                  *((volatile unsigned int*)(0x427E055CUL))
#define bFM4_EXBUS_TIM2_WWEC0                  *((volatile unsigned int*)(0x427E0560UL))
#define bFM4_EXBUS_TIM2_WWEC1                  *((volatile unsigned int*)(0x427E0564UL))
#define bFM4_EXBUS_TIM2_WWEC2                  *((volatile unsigned int*)(0x427E0568UL))
#define bFM4_EXBUS_TIM2_WWEC3                  *((volatile unsigned int*)(0x427E056CUL))
#define bFM4_EXBUS_TIM2_WIDLC0                 *((volatile unsigned int*)(0x427E0570UL))
#define bFM4_EXBUS_TIM2_WIDLC1                 *((volatile unsigned int*)(0x427E0574UL))
#define bFM4_EXBUS_TIM2_WIDLC2                 *((volatile unsigned int*)(0x427E0578UL))
#define bFM4_EXBUS_TIM2_WIDLC3                 *((volatile unsigned int*)(0x427E057CUL))
#define bFM4_EXBUS_TIM3_RACC0                  *((volatile unsigned int*)(0x427E0580UL))
#define bFM4_EXBUS_TIM3_RACC1                  *((volatile unsigned int*)(0x427E0584UL))
#define bFM4_EXBUS_TIM3_RACC2                  *((volatile unsigned int*)(0x427E0588UL))
#define bFM4_EXBUS_TIM3_RACC3                  *((volatile unsigned int*)(0x427E058CUL))
#define bFM4_EXBUS_TIM3_RADC0                  *((volatile unsigned int*)(0x427E0590UL))
#define bFM4_EXBUS_TIM3_RADC1                  *((volatile unsigned int*)(0x427E0594UL))
#define bFM4_EXBUS_TIM3_RADC2                  *((volatile unsigned int*)(0x427E0598UL))
#define bFM4_EXBUS_TIM3_RADC3                  *((volatile unsigned int*)(0x427E059CUL))
#define bFM4_EXBUS_TIM3_FRADC0                 *((volatile unsigned int*)(0x427E05A0UL))
#define bFM4_EXBUS_TIM3_FRADC1                 *((volatile unsigned int*)(0x427E05A4UL))
#define bFM4_EXBUS_TIM3_FRADC2                 *((volatile unsigned int*)(0x427E05A8UL))
#define bFM4_EXBUS_TIM3_FRADC3                 *((volatile unsigned int*)(0x427E05ACUL))
#define bFM4_EXBUS_TIM3_RIDLC0                 *((volatile unsigned int*)(0x427E05B0UL))
#define bFM4_EXBUS_TIM3_RIDLC1                 *((volatile unsigned int*)(0x427E05B4UL))
#define bFM4_EXBUS_TIM3_RIDLC2                 *((volatile unsigned int*)(0x427E05B8UL))
#define bFM4_EXBUS_TIM3_RIDLC3                 *((volatile unsigned int*)(0x427E05BCUL))
#define bFM4_EXBUS_TIM3_WACC0                  *((volatile unsigned int*)(0x427E05C0UL))
#define bFM4_EXBUS_TIM3_WACC1                  *((volatile unsigned int*)(0x427E05C4UL))
#define bFM4_EXBUS_TIM3_WACC2                  *((volatile unsigned int*)(0x427E05C8UL))
#define bFM4_EXBUS_TIM3_WACC3                  *((volatile unsigned int*)(0x427E05CCUL))
#define bFM4_EXBUS_TIM3_WADC0                  *((volatile unsigned int*)(0x427E05D0UL))
#define bFM4_EXBUS_TIM3_WADC1                  *((volatile unsigned int*)(0x427E05D4UL))
#define bFM4_EXBUS_TIM3_WADC2                  *((volatile unsigned int*)(0x427E05D8UL))
#define bFM4_EXBUS_TIM3_WADC3                  *((volatile unsigned int*)(0x427E05DCUL))
#define bFM4_EXBUS_TIM3_WWEC0                  *((volatile unsigned int*)(0x427E05E0UL))
#define bFM4_EXBUS_TIM3_WWEC1                  *((volatile unsigned int*)(0x427E05E4UL))
#define bFM4_EXBUS_TIM3_WWEC2                  *((volatile unsigned int*)(0x427E05E8UL))
#define bFM4_EXBUS_TIM3_WWEC3                  *((volatile unsigned int*)(0x427E05ECUL))
#define bFM4_EXBUS_TIM3_WIDLC0                 *((volatile unsigned int*)(0x427E05F0UL))
#define bFM4_EXBUS_TIM3_WIDLC1                 *((volatile unsigned int*)(0x427E05F4UL))
#define bFM4_EXBUS_TIM3_WIDLC2                 *((volatile unsigned int*)(0x427E05F8UL))
#define bFM4_EXBUS_TIM3_WIDLC3                 *((volatile unsigned int*)(0x427E05FCUL))
#define bFM4_EXBUS_TIM4_RACC0                  *((volatile unsigned int*)(0x427E0600UL))
#define bFM4_EXBUS_TIM4_RACC1                  *((volatile unsigned int*)(0x427E0604UL))
#define bFM4_EXBUS_TIM4_RACC2                  *((volatile unsigned int*)(0x427E0608UL))
#define bFM4_EXBUS_TIM4_RACC3                  *((volatile unsigned int*)(0x427E060CUL))
#define bFM4_EXBUS_TIM4_RADC0                  *((volatile unsigned int*)(0x427E0610UL))
#define bFM4_EXBUS_TIM4_RADC1                  *((volatile unsigned int*)(0x427E0614UL))
#define bFM4_EXBUS_TIM4_RADC2                  *((volatile unsigned int*)(0x427E0618UL))
#define bFM4_EXBUS_TIM4_RADC3                  *((volatile unsigned int*)(0x427E061CUL))
#define bFM4_EXBUS_TIM4_FRADC0                 *((volatile unsigned int*)(0x427E0620UL))
#define bFM4_EXBUS_TIM4_FRADC1                 *((volatile unsigned int*)(0x427E0624UL))
#define bFM4_EXBUS_TIM4_FRADC2                 *((volatile unsigned int*)(0x427E0628UL))
#define bFM4_EXBUS_TIM4_FRADC3                 *((volatile unsigned int*)(0x427E062CUL))
#define bFM4_EXBUS_TIM4_RIDLC0                 *((volatile unsigned int*)(0x427E0630UL))
#define bFM4_EXBUS_TIM4_RIDLC1                 *((volatile unsigned int*)(0x427E0634UL))
#define bFM4_EXBUS_TIM4_RIDLC2                 *((volatile unsigned int*)(0x427E0638UL))
#define bFM4_EXBUS_TIM4_RIDLC3                 *((volatile unsigned int*)(0x427E063CUL))
#define bFM4_EXBUS_TIM4_WACC0                  *((volatile unsigned int*)(0x427E0640UL))
#define bFM4_EXBUS_TIM4_WACC1                  *((volatile unsigned int*)(0x427E0644UL))
#define bFM4_EXBUS_TIM4_WACC2                  *((volatile unsigned int*)(0x427E0648UL))
#define bFM4_EXBUS_TIM4_WACC3                  *((volatile unsigned int*)(0x427E064CUL))
#define bFM4_EXBUS_TIM4_WADC0                  *((volatile unsigned int*)(0x427E0650UL))
#define bFM4_EXBUS_TIM4_WADC1                  *((volatile unsigned int*)(0x427E0654UL))
#define bFM4_EXBUS_TIM4_WADC2                  *((volatile unsigned int*)(0x427E0658UL))
#define bFM4_EXBUS_TIM4_WADC3                  *((volatile unsigned int*)(0x427E065CUL))
#define bFM4_EXBUS_TIM4_WWEC0                  *((volatile unsigned int*)(0x427E0660UL))
#define bFM4_EXBUS_TIM4_WWEC1                  *((volatile unsigned int*)(0x427E0664UL))
#define bFM4_EXBUS_TIM4_WWEC2                  *((volatile unsigned int*)(0x427E0668UL))
#define bFM4_EXBUS_TIM4_WWEC3                  *((volatile unsigned int*)(0x427E066CUL))
#define bFM4_EXBUS_TIM4_WIDLC0                 *((volatile unsigned int*)(0x427E0670UL))
#define bFM4_EXBUS_TIM4_WIDLC1                 *((volatile unsigned int*)(0x427E0674UL))
#define bFM4_EXBUS_TIM4_WIDLC2                 *((volatile unsigned int*)(0x427E0678UL))
#define bFM4_EXBUS_TIM4_WIDLC3                 *((volatile unsigned int*)(0x427E067CUL))
#define bFM4_EXBUS_TIM5_RACC0                  *((volatile unsigned int*)(0x427E0680UL))
#define bFM4_EXBUS_TIM5_RACC1                  *((volatile unsigned int*)(0x427E0684UL))
#define bFM4_EXBUS_TIM5_RACC2                  *((volatile unsigned int*)(0x427E0688UL))
#define bFM4_EXBUS_TIM5_RACC3                  *((volatile unsigned int*)(0x427E068CUL))
#define bFM4_EXBUS_TIM5_RADC0                  *((volatile unsigned int*)(0x427E0690UL))
#define bFM4_EXBUS_TIM5_RADC1                  *((volatile unsigned int*)(0x427E0694UL))
#define bFM4_EXBUS_TIM5_RADC2                  *((volatile unsigned int*)(0x427E0698UL))
#define bFM4_EXBUS_TIM5_RADC3                  *((volatile unsigned int*)(0x427E069CUL))
#define bFM4_EXBUS_TIM5_FRADC0                 *((volatile unsigned int*)(0x427E06A0UL))
#define bFM4_EXBUS_TIM5_FRADC1                 *((volatile unsigned int*)(0x427E06A4UL))
#define bFM4_EXBUS_TIM5_FRADC2                 *((volatile unsigned int*)(0x427E06A8UL))
#define bFM4_EXBUS_TIM5_FRADC3                 *((volatile unsigned int*)(0x427E06ACUL))
#define bFM4_EXBUS_TIM5_RIDLC0                 *((volatile unsigned int*)(0x427E06B0UL))
#define bFM4_EXBUS_TIM5_RIDLC1                 *((volatile unsigned int*)(0x427E06B4UL))
#define bFM4_EXBUS_TIM5_RIDLC2                 *((volatile unsigned int*)(0x427E06B8UL))
#define bFM4_EXBUS_TIM5_RIDLC3                 *((volatile unsigned int*)(0x427E06BCUL))
#define bFM4_EXBUS_TIM5_WACC0                  *((volatile unsigned int*)(0x427E06C0UL))
#define bFM4_EXBUS_TIM5_WACC1                  *((volatile unsigned int*)(0x427E06C4UL))
#define bFM4_EXBUS_TIM5_WACC2                  *((volatile unsigned int*)(0x427E06C8UL))
#define bFM4_EXBUS_TIM5_WACC3                  *((volatile unsigned int*)(0x427E06CCUL))
#define bFM4_EXBUS_TIM5_WADC0                  *((volatile unsigned int*)(0x427E06D0UL))
#define bFM4_EXBUS_TIM5_WADC1                  *((volatile unsigned int*)(0x427E06D4UL))
#define bFM4_EXBUS_TIM5_WADC2                  *((volatile unsigned int*)(0x427E06D8UL))
#define bFM4_EXBUS_TIM5_WADC3                  *((volatile unsigned int*)(0x427E06DCUL))
#define bFM4_EXBUS_TIM5_WWEC0                  *((volatile unsigned int*)(0x427E06E0UL))
#define bFM4_EXBUS_TIM5_WWEC1                  *((volatile unsigned int*)(0x427E06E4UL))
#define bFM4_EXBUS_TIM5_WWEC2                  *((volatile unsigned int*)(0x427E06E8UL))
#define bFM4_EXBUS_TIM5_WWEC3                  *((volatile unsigned int*)(0x427E06ECUL))
#define bFM4_EXBUS_TIM5_WIDLC0                 *((volatile unsigned int*)(0x427E06F0UL))
#define bFM4_EXBUS_TIM5_WIDLC1                 *((volatile unsigned int*)(0x427E06F4UL))
#define bFM4_EXBUS_TIM5_WIDLC2                 *((volatile unsigned int*)(0x427E06F8UL))
#define bFM4_EXBUS_TIM5_WIDLC3                 *((volatile unsigned int*)(0x427E06FCUL))
#define bFM4_EXBUS_TIM6_RACC0                  *((volatile unsigned int*)(0x427E0700UL))
#define bFM4_EXBUS_TIM6_RACC1                  *((volatile unsigned int*)(0x427E0704UL))
#define bFM4_EXBUS_TIM6_RACC2                  *((volatile unsigned int*)(0x427E0708UL))
#define bFM4_EXBUS_TIM6_RACC3                  *((volatile unsigned int*)(0x427E070CUL))
#define bFM4_EXBUS_TIM6_RADC0                  *((volatile unsigned int*)(0x427E0710UL))
#define bFM4_EXBUS_TIM6_RADC1                  *((volatile unsigned int*)(0x427E0714UL))
#define bFM4_EXBUS_TIM6_RADC2                  *((volatile unsigned int*)(0x427E0718UL))
#define bFM4_EXBUS_TIM6_RADC3                  *((volatile unsigned int*)(0x427E071CUL))
#define bFM4_EXBUS_TIM6_FRADC0                 *((volatile unsigned int*)(0x427E0720UL))
#define bFM4_EXBUS_TIM6_FRADC1                 *((volatile unsigned int*)(0x427E0724UL))
#define bFM4_EXBUS_TIM6_FRADC2                 *((volatile unsigned int*)(0x427E0728UL))
#define bFM4_EXBUS_TIM6_FRADC3                 *((volatile unsigned int*)(0x427E072CUL))
#define bFM4_EXBUS_TIM6_RIDLC0                 *((volatile unsigned int*)(0x427E0730UL))
#define bFM4_EXBUS_TIM6_RIDLC1                 *((volatile unsigned int*)(0x427E0734UL))
#define bFM4_EXBUS_TIM6_RIDLC2                 *((volatile unsigned int*)(0x427E0738UL))
#define bFM4_EXBUS_TIM6_RIDLC3                 *((volatile unsigned int*)(0x427E073CUL))
#define bFM4_EXBUS_TIM6_WACC0                  *((volatile unsigned int*)(0x427E0740UL))
#define bFM4_EXBUS_TIM6_WACC1                  *((volatile unsigned int*)(0x427E0744UL))
#define bFM4_EXBUS_TIM6_WACC2                  *((volatile unsigned int*)(0x427E0748UL))
#define bFM4_EXBUS_TIM6_WACC3                  *((volatile unsigned int*)(0x427E074CUL))
#define bFM4_EXBUS_TIM6_WADC0                  *((volatile unsigned int*)(0x427E0750UL))
#define bFM4_EXBUS_TIM6_WADC1                  *((volatile unsigned int*)(0x427E0754UL))
#define bFM4_EXBUS_TIM6_WADC2                  *((volatile unsigned int*)(0x427E0758UL))
#define bFM4_EXBUS_TIM6_WADC3                  *((volatile unsigned int*)(0x427E075CUL))
#define bFM4_EXBUS_TIM6_WWEC0                  *((volatile unsigned int*)(0x427E0760UL))
#define bFM4_EXBUS_TIM6_WWEC1                  *((volatile unsigned int*)(0x427E0764UL))
#define bFM4_EXBUS_TIM6_WWEC2                  *((volatile unsigned int*)(0x427E0768UL))
#define bFM4_EXBUS_TIM6_WWEC3                  *((volatile unsigned int*)(0x427E076CUL))
#define bFM4_EXBUS_TIM6_WIDLC0                 *((volatile unsigned int*)(0x427E0770UL))
#define bFM4_EXBUS_TIM6_WIDLC1                 *((volatile unsigned int*)(0x427E0774UL))
#define bFM4_EXBUS_TIM6_WIDLC2                 *((volatile unsigned int*)(0x427E0778UL))
#define bFM4_EXBUS_TIM6_WIDLC3                 *((volatile unsigned int*)(0x427E077CUL))
#define bFM4_EXBUS_TIM7_RACC0                  *((volatile unsigned int*)(0x427E0780UL))
#define bFM4_EXBUS_TIM7_RACC1                  *((volatile unsigned int*)(0x427E0784UL))
#define bFM4_EXBUS_TIM7_RACC2                  *((volatile unsigned int*)(0x427E0788UL))
#define bFM4_EXBUS_TIM7_RACC3                  *((volatile unsigned int*)(0x427E078CUL))
#define bFM4_EXBUS_TIM7_RADC0                  *((volatile unsigned int*)(0x427E0790UL))
#define bFM4_EXBUS_TIM7_RADC1                  *((volatile unsigned int*)(0x427E0794UL))
#define bFM4_EXBUS_TIM7_RADC2                  *((volatile unsigned int*)(0x427E0798UL))
#define bFM4_EXBUS_TIM7_RADC3                  *((volatile unsigned int*)(0x427E079CUL))
#define bFM4_EXBUS_TIM7_FRADC0                 *((volatile unsigned int*)(0x427E07A0UL))
#define bFM4_EXBUS_TIM7_FRADC1                 *((volatile unsigned int*)(0x427E07A4UL))
#define bFM4_EXBUS_TIM7_FRADC2                 *((volatile unsigned int*)(0x427E07A8UL))
#define bFM4_EXBUS_TIM7_FRADC3                 *((volatile unsigned int*)(0x427E07ACUL))
#define bFM4_EXBUS_TIM7_RIDLC0                 *((volatile unsigned int*)(0x427E07B0UL))
#define bFM4_EXBUS_TIM7_RIDLC1                 *((volatile unsigned int*)(0x427E07B4UL))
#define bFM4_EXBUS_TIM7_RIDLC2                 *((volatile unsigned int*)(0x427E07B8UL))
#define bFM4_EXBUS_TIM7_RIDLC3                 *((volatile unsigned int*)(0x427E07BCUL))
#define bFM4_EXBUS_TIM7_WACC0                  *((volatile unsigned int*)(0x427E07C0UL))
#define bFM4_EXBUS_TIM7_WACC1                  *((volatile unsigned int*)(0x427E07C4UL))
#define bFM4_EXBUS_TIM7_WACC2                  *((volatile unsigned int*)(0x427E07C8UL))
#define bFM4_EXBUS_TIM7_WACC3                  *((volatile unsigned int*)(0x427E07CCUL))
#define bFM4_EXBUS_TIM7_WADC0                  *((volatile unsigned int*)(0x427E07D0UL))
#define bFM4_EXBUS_TIM7_WADC1                  *((volatile unsigned int*)(0x427E07D4UL))
#define bFM4_EXBUS_TIM7_WADC2                  *((volatile unsigned int*)(0x427E07D8UL))
#define bFM4_EXBUS_TIM7_WADC3                  *((volatile unsigned int*)(0x427E07DCUL))
#define bFM4_EXBUS_TIM7_WWEC0                  *((volatile unsigned int*)(0x427E07E0UL))
#define bFM4_EXBUS_TIM7_WWEC1                  *((volatile unsigned int*)(0x427E07E4UL))
#define bFM4_EXBUS_TIM7_WWEC2                  *((volatile unsigned int*)(0x427E07E8UL))
#define bFM4_EXBUS_TIM7_WWEC3                  *((volatile unsigned int*)(0x427E07ECUL))
#define bFM4_EXBUS_TIM7_WIDLC0                 *((volatile unsigned int*)(0x427E07F0UL))
#define bFM4_EXBUS_TIM7_WIDLC1                 *((volatile unsigned int*)(0x427E07F4UL))
#define bFM4_EXBUS_TIM7_WIDLC2                 *((volatile unsigned int*)(0x427E07F8UL))
#define bFM4_EXBUS_TIM7_WIDLC3                 *((volatile unsigned int*)(0x427E07FCUL))
#define bFM4_EXBUS_AREA0_ADDR0                 *((volatile unsigned int*)(0x427E0800UL))
#define bFM4_EXBUS_AREA0_ADDR1                 *((volatile unsigned int*)(0x427E0804UL))
#define bFM4_EXBUS_AREA0_ADDR2                 *((volatile unsigned int*)(0x427E0808UL))
#define bFM4_EXBUS_AREA0_ADDR3                 *((volatile unsigned int*)(0x427E080CUL))
#define bFM4_EXBUS_AREA0_ADDR4                 *((volatile unsigned int*)(0x427E0810UL))
#define bFM4_EXBUS_AREA0_ADDR5                 *((volatile unsigned int*)(0x427E0814UL))
#define bFM4_EXBUS_AREA0_ADDR6                 *((volatile unsigned int*)(0x427E0818UL))
#define bFM4_EXBUS_AREA0_ADDR7                 *((volatile unsigned int*)(0x427E081CUL))
#define bFM4_EXBUS_AREA0_MASK0                 *((volatile unsigned int*)(0x427E0840UL))
#define bFM4_EXBUS_AREA0_MASK1                 *((volatile unsigned int*)(0x427E0844UL))
#define bFM4_EXBUS_AREA0_MASK2                 *((volatile unsigned int*)(0x427E0848UL))
#define bFM4_EXBUS_AREA0_MASK3                 *((volatile unsigned int*)(0x427E084CUL))
#define bFM4_EXBUS_AREA0_MASK4                 *((volatile unsigned int*)(0x427E0850UL))
#define bFM4_EXBUS_AREA0_MASK5                 *((volatile unsigned int*)(0x427E0854UL))
#define bFM4_EXBUS_AREA0_MASK6                 *((volatile unsigned int*)(0x427E0858UL))
#define bFM4_EXBUS_AREA1_ADDR0                 *((volatile unsigned int*)(0x427E0880UL))
#define bFM4_EXBUS_AREA1_ADDR1                 *((volatile unsigned int*)(0x427E0884UL))
#define bFM4_EXBUS_AREA1_ADDR2                 *((volatile unsigned int*)(0x427E0888UL))
#define bFM4_EXBUS_AREA1_ADDR3                 *((volatile unsigned int*)(0x427E088CUL))
#define bFM4_EXBUS_AREA1_ADDR4                 *((volatile unsigned int*)(0x427E0890UL))
#define bFM4_EXBUS_AREA1_ADDR5                 *((volatile unsigned int*)(0x427E0894UL))
#define bFM4_EXBUS_AREA1_ADDR6                 *((volatile unsigned int*)(0x427E0898UL))
#define bFM4_EXBUS_AREA1_ADDR7                 *((volatile unsigned int*)(0x427E089CUL))
#define bFM4_EXBUS_AREA1_MASK0                 *((volatile unsigned int*)(0x427E08C0UL))
#define bFM4_EXBUS_AREA1_MASK1                 *((volatile unsigned int*)(0x427E08C4UL))
#define bFM4_EXBUS_AREA1_MASK2                 *((volatile unsigned int*)(0x427E08C8UL))
#define bFM4_EXBUS_AREA1_MASK3                 *((volatile unsigned int*)(0x427E08CCUL))
#define bFM4_EXBUS_AREA1_MASK4                 *((volatile unsigned int*)(0x427E08D0UL))
#define bFM4_EXBUS_AREA1_MASK5                 *((volatile unsigned int*)(0x427E08D4UL))
#define bFM4_EXBUS_AREA1_MASK6                 *((volatile unsigned int*)(0x427E08D8UL))
#define bFM4_EXBUS_AREA2_ADDR0                 *((volatile unsigned int*)(0x427E0900UL))
#define bFM4_EXBUS_AREA2_ADDR1                 *((volatile unsigned int*)(0x427E0904UL))
#define bFM4_EXBUS_AREA2_ADDR2                 *((volatile unsigned int*)(0x427E0908UL))
#define bFM4_EXBUS_AREA2_ADDR3                 *((volatile unsigned int*)(0x427E090CUL))
#define bFM4_EXBUS_AREA2_ADDR4                 *((volatile unsigned int*)(0x427E0910UL))
#define bFM4_EXBUS_AREA2_ADDR5                 *((volatile unsigned int*)(0x427E0914UL))
#define bFM4_EXBUS_AREA2_ADDR6                 *((volatile unsigned int*)(0x427E0918UL))
#define bFM4_EXBUS_AREA2_ADDR7                 *((volatile unsigned int*)(0x427E091CUL))
#define bFM4_EXBUS_AREA2_MASK0                 *((volatile unsigned int*)(0x427E0940UL))
#define bFM4_EXBUS_AREA2_MASK1                 *((volatile unsigned int*)(0x427E0944UL))
#define bFM4_EXBUS_AREA2_MASK2                 *((volatile unsigned int*)(0x427E0948UL))
#define bFM4_EXBUS_AREA2_MASK3                 *((volatile unsigned int*)(0x427E094CUL))
#define bFM4_EXBUS_AREA2_MASK4                 *((volatile unsigned int*)(0x427E0950UL))
#define bFM4_EXBUS_AREA2_MASK5                 *((volatile unsigned int*)(0x427E0954UL))
#define bFM4_EXBUS_AREA2_MASK6                 *((volatile unsigned int*)(0x427E0958UL))
#define bFM4_EXBUS_AREA3_ADDR0                 *((volatile unsigned int*)(0x427E0980UL))
#define bFM4_EXBUS_AREA3_ADDR1                 *((volatile unsigned int*)(0x427E0984UL))
#define bFM4_EXBUS_AREA3_ADDR2                 *((volatile unsigned int*)(0x427E0988UL))
#define bFM4_EXBUS_AREA3_ADDR3                 *((volatile unsigned int*)(0x427E098CUL))
#define bFM4_EXBUS_AREA3_ADDR4                 *((volatile unsigned int*)(0x427E0990UL))
#define bFM4_EXBUS_AREA3_ADDR5                 *((volatile unsigned int*)(0x427E0994UL))
#define bFM4_EXBUS_AREA3_ADDR6                 *((volatile unsigned int*)(0x427E0998UL))
#define bFM4_EXBUS_AREA3_ADDR7                 *((volatile unsigned int*)(0x427E099CUL))
#define bFM4_EXBUS_AREA3_MASK0                 *((volatile unsigned int*)(0x427E09C0UL))
#define bFM4_EXBUS_AREA3_MASK1                 *((volatile unsigned int*)(0x427E09C4UL))
#define bFM4_EXBUS_AREA3_MASK2                 *((volatile unsigned int*)(0x427E09C8UL))
#define bFM4_EXBUS_AREA3_MASK3                 *((volatile unsigned int*)(0x427E09CCUL))
#define bFM4_EXBUS_AREA3_MASK4                 *((volatile unsigned int*)(0x427E09D0UL))
#define bFM4_EXBUS_AREA3_MASK5                 *((volatile unsigned int*)(0x427E09D4UL))
#define bFM4_EXBUS_AREA3_MASK6                 *((volatile unsigned int*)(0x427E09D8UL))
#define bFM4_EXBUS_AREA4_ADDR0                 *((volatile unsigned int*)(0x427E0A00UL))
#define bFM4_EXBUS_AREA4_ADDR1                 *((volatile unsigned int*)(0x427E0A04UL))
#define bFM4_EXBUS_AREA4_ADDR2                 *((volatile unsigned int*)(0x427E0A08UL))
#define bFM4_EXBUS_AREA4_ADDR3                 *((volatile unsigned int*)(0x427E0A0CUL))
#define bFM4_EXBUS_AREA4_ADDR4                 *((volatile unsigned int*)(0x427E0A10UL))
#define bFM4_EXBUS_AREA4_ADDR5                 *((volatile unsigned int*)(0x427E0A14UL))
#define bFM4_EXBUS_AREA4_ADDR6                 *((volatile unsigned int*)(0x427E0A18UL))
#define bFM4_EXBUS_AREA4_ADDR7                 *((volatile unsigned int*)(0x427E0A1CUL))
#define bFM4_EXBUS_AREA4_MASK0                 *((volatile unsigned int*)(0x427E0A40UL))
#define bFM4_EXBUS_AREA4_MASK1                 *((volatile unsigned int*)(0x427E0A44UL))
#define bFM4_EXBUS_AREA4_MASK2                 *((volatile unsigned int*)(0x427E0A48UL))
#define bFM4_EXBUS_AREA4_MASK3                 *((volatile unsigned int*)(0x427E0A4CUL))
#define bFM4_EXBUS_AREA4_MASK4                 *((volatile unsigned int*)(0x427E0A50UL))
#define bFM4_EXBUS_AREA4_MASK5                 *((volatile unsigned int*)(0x427E0A54UL))
#define bFM4_EXBUS_AREA4_MASK6                 *((volatile unsigned int*)(0x427E0A58UL))
#define bFM4_EXBUS_AREA5_ADDR0                 *((volatile unsigned int*)(0x427E0A80UL))
#define bFM4_EXBUS_AREA5_ADDR1                 *((volatile unsigned int*)(0x427E0A84UL))
#define bFM4_EXBUS_AREA5_ADDR2                 *((volatile unsigned int*)(0x427E0A88UL))
#define bFM4_EXBUS_AREA5_ADDR3                 *((volatile unsigned int*)(0x427E0A8CUL))
#define bFM4_EXBUS_AREA5_ADDR4                 *((volatile unsigned int*)(0x427E0A90UL))
#define bFM4_EXBUS_AREA5_ADDR5                 *((volatile unsigned int*)(0x427E0A94UL))
#define bFM4_EXBUS_AREA5_ADDR6                 *((volatile unsigned int*)(0x427E0A98UL))
#define bFM4_EXBUS_AREA5_ADDR7                 *((volatile unsigned int*)(0x427E0A9CUL))
#define bFM4_EXBUS_AREA5_MASK0                 *((volatile unsigned int*)(0x427E0AC0UL))
#define bFM4_EXBUS_AREA5_MASK1                 *((volatile unsigned int*)(0x427E0AC4UL))
#define bFM4_EXBUS_AREA5_MASK2                 *((volatile unsigned int*)(0x427E0AC8UL))
#define bFM4_EXBUS_AREA5_MASK3                 *((volatile unsigned int*)(0x427E0ACCUL))
#define bFM4_EXBUS_AREA5_MASK4                 *((volatile unsigned int*)(0x427E0AD0UL))
#define bFM4_EXBUS_AREA5_MASK5                 *((volatile unsigned int*)(0x427E0AD4UL))
#define bFM4_EXBUS_AREA5_MASK6                 *((volatile unsigned int*)(0x427E0AD8UL))
#define bFM4_EXBUS_AREA6_ADDR0                 *((volatile unsigned int*)(0x427E0B00UL))
#define bFM4_EXBUS_AREA6_ADDR1                 *((volatile unsigned int*)(0x427E0B04UL))
#define bFM4_EXBUS_AREA6_ADDR2                 *((volatile unsigned int*)(0x427E0B08UL))
#define bFM4_EXBUS_AREA6_ADDR3                 *((volatile unsigned int*)(0x427E0B0CUL))
#define bFM4_EXBUS_AREA6_ADDR4                 *((volatile unsigned int*)(0x427E0B10UL))
#define bFM4_EXBUS_AREA6_ADDR5                 *((volatile unsigned int*)(0x427E0B14UL))
#define bFM4_EXBUS_AREA6_ADDR6                 *((volatile unsigned int*)(0x427E0B18UL))
#define bFM4_EXBUS_AREA6_ADDR7                 *((volatile unsigned int*)(0x427E0B1CUL))
#define bFM4_EXBUS_AREA6_MASK0                 *((volatile unsigned int*)(0x427E0B40UL))
#define bFM4_EXBUS_AREA6_MASK1                 *((volatile unsigned int*)(0x427E0B44UL))
#define bFM4_EXBUS_AREA6_MASK2                 *((volatile unsigned int*)(0x427E0B48UL))
#define bFM4_EXBUS_AREA6_MASK3                 *((volatile unsigned int*)(0x427E0B4CUL))
#define bFM4_EXBUS_AREA6_MASK4                 *((volatile unsigned int*)(0x427E0B50UL))
#define bFM4_EXBUS_AREA6_MASK5                 *((volatile unsigned int*)(0x427E0B54UL))
#define bFM4_EXBUS_AREA6_MASK6                 *((volatile unsigned int*)(0x427E0B58UL))
#define bFM4_EXBUS_AREA7_ADDR0                 *((volatile unsigned int*)(0x427E0B80UL))
#define bFM4_EXBUS_AREA7_ADDR1                 *((volatile unsigned int*)(0x427E0B84UL))
#define bFM4_EXBUS_AREA7_ADDR2                 *((volatile unsigned int*)(0x427E0B88UL))
#define bFM4_EXBUS_AREA7_ADDR3                 *((volatile unsigned int*)(0x427E0B8CUL))
#define bFM4_EXBUS_AREA7_ADDR4                 *((volatile unsigned int*)(0x427E0B90UL))
#define bFM4_EXBUS_AREA7_ADDR5                 *((volatile unsigned int*)(0x427E0B94UL))
#define bFM4_EXBUS_AREA7_ADDR6                 *((volatile unsigned int*)(0x427E0B98UL))
#define bFM4_EXBUS_AREA7_ADDR7                 *((volatile unsigned int*)(0x427E0B9CUL))
#define bFM4_EXBUS_AREA7_MASK0                 *((volatile unsigned int*)(0x427E0BC0UL))
#define bFM4_EXBUS_AREA7_MASK1                 *((volatile unsigned int*)(0x427E0BC4UL))
#define bFM4_EXBUS_AREA7_MASK2                 *((volatile unsigned int*)(0x427E0BC8UL))
#define bFM4_EXBUS_AREA7_MASK3                 *((volatile unsigned int*)(0x427E0BCCUL))
#define bFM4_EXBUS_AREA7_MASK4                 *((volatile unsigned int*)(0x427E0BD0UL))
#define bFM4_EXBUS_AREA7_MASK5                 *((volatile unsigned int*)(0x427E0BD4UL))
#define bFM4_EXBUS_AREA7_MASK6                 *((volatile unsigned int*)(0x427E0BD8UL))
#define bFM4_EXBUS_ATIM0_ALC0                  *((volatile unsigned int*)(0x427E0C00UL))
#define bFM4_EXBUS_ATIM0_ALC1                  *((volatile unsigned int*)(0x427E0C04UL))
#define bFM4_EXBUS_ATIM0_ALC2                  *((volatile unsigned int*)(0x427E0C08UL))
#define bFM4_EXBUS_ATIM0_ALC3                  *((volatile unsigned int*)(0x427E0C0CUL))
#define bFM4_EXBUS_ATIM0_ALES0                 *((volatile unsigned int*)(0x427E0C10UL))
#define bFM4_EXBUS_ATIM0_ALES1                 *((volatile unsigned int*)(0x427E0C14UL))
#define bFM4_EXBUS_ATIM0_ALES2                 *((volatile unsigned int*)(0x427E0C18UL))
#define bFM4_EXBUS_ATIM0_ALES3                 *((volatile unsigned int*)(0x427E0C1CUL))
#define bFM4_EXBUS_ATIM0_ALEW0                 *((volatile unsigned int*)(0x427E0C20UL))
#define bFM4_EXBUS_ATIM0_ALEW1                 *((volatile unsigned int*)(0x427E0C24UL))
#define bFM4_EXBUS_ATIM0_ALEW2                 *((volatile unsigned int*)(0x427E0C28UL))
#define bFM4_EXBUS_ATIM0_ALEW3                 *((volatile unsigned int*)(0x427E0C2CUL))
#define bFM4_EXBUS_ATIM1_ALC0                  *((volatile unsigned int*)(0x427E0C80UL))
#define bFM4_EXBUS_ATIM1_ALC1                  *((volatile unsigned int*)(0x427E0C84UL))
#define bFM4_EXBUS_ATIM1_ALC2                  *((volatile unsigned int*)(0x427E0C88UL))
#define bFM4_EXBUS_ATIM1_ALC3                  *((volatile unsigned int*)(0x427E0C8CUL))
#define bFM4_EXBUS_ATIM1_ALES0                 *((volatile unsigned int*)(0x427E0C90UL))
#define bFM4_EXBUS_ATIM1_ALES1                 *((volatile unsigned int*)(0x427E0C94UL))
#define bFM4_EXBUS_ATIM1_ALES2                 *((volatile unsigned int*)(0x427E0C98UL))
#define bFM4_EXBUS_ATIM1_ALES3                 *((volatile unsigned int*)(0x427E0C9CUL))
#define bFM4_EXBUS_ATIM1_ALEW0                 *((volatile unsigned int*)(0x427E0CA0UL))
#define bFM4_EXBUS_ATIM1_ALEW1                 *((volatile unsigned int*)(0x427E0CA4UL))
#define bFM4_EXBUS_ATIM1_ALEW2                 *((volatile unsigned int*)(0x427E0CA8UL))
#define bFM4_EXBUS_ATIM1_ALEW3                 *((volatile unsigned int*)(0x427E0CACUL))
#define bFM4_EXBUS_ATIM2_ALC0                  *((volatile unsigned int*)(0x427E0D00UL))
#define bFM4_EXBUS_ATIM2_ALC1                  *((volatile unsigned int*)(0x427E0D04UL))
#define bFM4_EXBUS_ATIM2_ALC2                  *((volatile unsigned int*)(0x427E0D08UL))
#define bFM4_EXBUS_ATIM2_ALC3                  *((volatile unsigned int*)(0x427E0D0CUL))
#define bFM4_EXBUS_ATIM2_ALES0                 *((volatile unsigned int*)(0x427E0D10UL))
#define bFM4_EXBUS_ATIM2_ALES1                 *((volatile unsigned int*)(0x427E0D14UL))
#define bFM4_EXBUS_ATIM2_ALES2                 *((volatile unsigned int*)(0x427E0D18UL))
#define bFM4_EXBUS_ATIM2_ALES3                 *((volatile unsigned int*)(0x427E0D1CUL))
#define bFM4_EXBUS_ATIM2_ALEW0                 *((volatile unsigned int*)(0x427E0D20UL))
#define bFM4_EXBUS_ATIM2_ALEW1                 *((volatile unsigned int*)(0x427E0D24UL))
#define bFM4_EXBUS_ATIM2_ALEW2                 *((volatile unsigned int*)(0x427E0D28UL))
#define bFM4_EXBUS_ATIM2_ALEW3                 *((volatile unsigned int*)(0x427E0D2CUL))
#define bFM4_EXBUS_ATIM3_ALC0                  *((volatile unsigned int*)(0x427E0D80UL))
#define bFM4_EXBUS_ATIM3_ALC1                  *((volatile unsigned int*)(0x427E0D84UL))
#define bFM4_EXBUS_ATIM3_ALC2                  *((volatile unsigned int*)(0x427E0D88UL))
#define bFM4_EXBUS_ATIM3_ALC3                  *((volatile unsigned int*)(0x427E0D8CUL))
#define bFM4_EXBUS_ATIM3_ALES0                 *((volatile unsigned int*)(0x427E0D90UL))
#define bFM4_EXBUS_ATIM3_ALES1                 *((volatile unsigned int*)(0x427E0D94UL))
#define bFM4_EXBUS_ATIM3_ALES2                 *((volatile unsigned int*)(0x427E0D98UL))
#define bFM4_EXBUS_ATIM3_ALES3                 *((volatile unsigned int*)(0x427E0D9CUL))
#define bFM4_EXBUS_ATIM3_ALEW0                 *((volatile unsigned int*)(0x427E0DA0UL))
#define bFM4_EXBUS_ATIM3_ALEW1                 *((volatile unsigned int*)(0x427E0DA4UL))
#define bFM4_EXBUS_ATIM3_ALEW2                 *((volatile unsigned int*)(0x427E0DA8UL))
#define bFM4_EXBUS_ATIM3_ALEW3                 *((volatile unsigned int*)(0x427E0DACUL))
#define bFM4_EXBUS_ATIM4_ALC0                  *((volatile unsigned int*)(0x427E0E00UL))
#define bFM4_EXBUS_ATIM4_ALC1                  *((volatile unsigned int*)(0x427E0E04UL))
#define bFM4_EXBUS_ATIM4_ALC2                  *((volatile unsigned int*)(0x427E0E08UL))
#define bFM4_EXBUS_ATIM4_ALC3                  *((volatile unsigned int*)(0x427E0E0CUL))
#define bFM4_EXBUS_ATIM4_ALES0                 *((volatile unsigned int*)(0x427E0E10UL))
#define bFM4_EXBUS_ATIM4_ALES1                 *((volatile unsigned int*)(0x427E0E14UL))
#define bFM4_EXBUS_ATIM4_ALES2                 *((volatile unsigned int*)(0x427E0E18UL))
#define bFM4_EXBUS_ATIM4_ALES3                 *((volatile unsigned int*)(0x427E0E1CUL))
#define bFM4_EXBUS_ATIM4_ALEW0                 *((volatile unsigned int*)(0x427E0E20UL))
#define bFM4_EXBUS_ATIM4_ALEW1                 *((volatile unsigned int*)(0x427E0E24UL))
#define bFM4_EXBUS_ATIM4_ALEW2                 *((volatile unsigned int*)(0x427E0E28UL))
#define bFM4_EXBUS_ATIM4_ALEW3                 *((volatile unsigned int*)(0x427E0E2CUL))
#define bFM4_EXBUS_ATIM5_ALC0                  *((volatile unsigned int*)(0x427E0E80UL))
#define bFM4_EXBUS_ATIM5_ALC1                  *((volatile unsigned int*)(0x427E0E84UL))
#define bFM4_EXBUS_ATIM5_ALC2                  *((volatile unsigned int*)(0x427E0E88UL))
#define bFM4_EXBUS_ATIM5_ALC3                  *((volatile unsigned int*)(0x427E0E8CUL))
#define bFM4_EXBUS_ATIM5_ALES0                 *((volatile unsigned int*)(0x427E0E90UL))
#define bFM4_EXBUS_ATIM5_ALES1                 *((volatile unsigned int*)(0x427E0E94UL))
#define bFM4_EXBUS_ATIM5_ALES2                 *((volatile unsigned int*)(0x427E0E98UL))
#define bFM4_EXBUS_ATIM5_ALES3                 *((volatile unsigned int*)(0x427E0E9CUL))
#define bFM4_EXBUS_ATIM5_ALEW0                 *((volatile unsigned int*)(0x427E0EA0UL))
#define bFM4_EXBUS_ATIM5_ALEW1                 *((volatile unsigned int*)(0x427E0EA4UL))
#define bFM4_EXBUS_ATIM5_ALEW2                 *((volatile unsigned int*)(0x427E0EA8UL))
#define bFM4_EXBUS_ATIM5_ALEW3                 *((volatile unsigned int*)(0x427E0EACUL))
#define bFM4_EXBUS_ATIM6_ALC0                  *((volatile unsigned int*)(0x427E0F00UL))
#define bFM4_EXBUS_ATIM6_ALC1                  *((volatile unsigned int*)(0x427E0F04UL))
#define bFM4_EXBUS_ATIM6_ALC2                  *((volatile unsigned int*)(0x427E0F08UL))
#define bFM4_EXBUS_ATIM6_ALC3                  *((volatile unsigned int*)(0x427E0F0CUL))
#define bFM4_EXBUS_ATIM6_ALES0                 *((volatile unsigned int*)(0x427E0F10UL))
#define bFM4_EXBUS_ATIM6_ALES1                 *((volatile unsigned int*)(0x427E0F14UL))
#define bFM4_EXBUS_ATIM6_ALES2                 *((volatile unsigned int*)(0x427E0F18UL))
#define bFM4_EXBUS_ATIM6_ALES3                 *((volatile unsigned int*)(0x427E0F1CUL))
#define bFM4_EXBUS_ATIM6_ALEW0                 *((volatile unsigned int*)(0x427E0F20UL))
#define bFM4_EXBUS_ATIM6_ALEW1                 *((volatile unsigned int*)(0x427E0F24UL))
#define bFM4_EXBUS_ATIM6_ALEW2                 *((volatile unsigned int*)(0x427E0F28UL))
#define bFM4_EXBUS_ATIM6_ALEW3                 *((volatile unsigned int*)(0x427E0F2CUL))
#define bFM4_EXBUS_ATIM7_ALC0                  *((volatile unsigned int*)(0x427E0F80UL))
#define bFM4_EXBUS_ATIM7_ALC1                  *((volatile unsigned int*)(0x427E0F84UL))
#define bFM4_EXBUS_ATIM7_ALC2                  *((volatile unsigned int*)(0x427E0F88UL))
#define bFM4_EXBUS_ATIM7_ALC3                  *((volatile unsigned int*)(0x427E0F8CUL))
#define bFM4_EXBUS_ATIM7_ALES0                 *((volatile unsigned int*)(0x427E0F90UL))
#define bFM4_EXBUS_ATIM7_ALES1                 *((volatile unsigned int*)(0x427E0F94UL))
#define bFM4_EXBUS_ATIM7_ALES2                 *((volatile unsigned int*)(0x427E0F98UL))
#define bFM4_EXBUS_ATIM7_ALES3                 *((volatile unsigned int*)(0x427E0F9CUL))
#define bFM4_EXBUS_ATIM7_ALEW0                 *((volatile unsigned int*)(0x427E0FA0UL))
#define bFM4_EXBUS_ATIM7_ALEW1                 *((volatile unsigned int*)(0x427E0FA4UL))
#define bFM4_EXBUS_ATIM7_ALEW2                 *((volatile unsigned int*)(0x427E0FA8UL))
#define bFM4_EXBUS_ATIM7_ALEW3                 *((volatile unsigned int*)(0x427E0FACUL))
#define bFM4_EXBUS_SDMODE_SDON                 *((volatile unsigned int*)(0x427E2000UL))
#define bFM4_EXBUS_SDMODE_PDON                 *((volatile unsigned int*)(0x427E2004UL))
#define bFM4_EXBUS_SDMODE_ROFF                 *((volatile unsigned int*)(0x427E2008UL))
#define bFM4_EXBUS_SDMODE_CASEL0               *((volatile unsigned int*)(0x427E2010UL))
#define bFM4_EXBUS_SDMODE_CASEL1               *((volatile unsigned int*)(0x427E2014UL))
#define bFM4_EXBUS_SDMODE_RASEL0               *((volatile unsigned int*)(0x427E2020UL))
#define bFM4_EXBUS_SDMODE_RASEL1               *((volatile unsigned int*)(0x427E2024UL))
#define bFM4_EXBUS_SDMODE_RASEL2               *((volatile unsigned int*)(0x427E2028UL))
#define bFM4_EXBUS_SDMODE_RASEL3               *((volatile unsigned int*)(0x427E202CUL))
#define bFM4_EXBUS_SDMODE_BASEL0               *((volatile unsigned int*)(0x427E2030UL))
#define bFM4_EXBUS_SDMODE_BASEL1               *((volatile unsigned int*)(0x427E2034UL))
#define bFM4_EXBUS_SDMODE_BASEL2               *((volatile unsigned int*)(0x427E2038UL))
#define bFM4_EXBUS_SDMODE_BASEL3               *((volatile unsigned int*)(0x427E203CUL))
#define bFM4_EXBUS_SDMODE_MSDCLKOFF            *((volatile unsigned int*)(0x427E2040UL))
#define bFM4_EXBUS_REFTIM_REFC0                *((volatile unsigned int*)(0x427E2080UL))
#define bFM4_EXBUS_REFTIM_REFC1                *((volatile unsigned int*)(0x427E2084UL))
#define bFM4_EXBUS_REFTIM_REFC2                *((volatile unsigned int*)(0x427E2088UL))
#define bFM4_EXBUS_REFTIM_REFC3                *((volatile unsigned int*)(0x427E208CUL))
#define bFM4_EXBUS_REFTIM_REFC4                *((volatile unsigned int*)(0x427E2090UL))
#define bFM4_EXBUS_REFTIM_REFC5                *((volatile unsigned int*)(0x427E2094UL))
#define bFM4_EXBUS_REFTIM_REFC6                *((volatile unsigned int*)(0x427E2098UL))
#define bFM4_EXBUS_REFTIM_REFC7                *((volatile unsigned int*)(0x427E209CUL))
#define bFM4_EXBUS_REFTIM_REFC8                *((volatile unsigned int*)(0x427E20A0UL))
#define bFM4_EXBUS_REFTIM_REFC9                *((volatile unsigned int*)(0x427E20A4UL))
#define bFM4_EXBUS_REFTIM_REFC10               *((volatile unsigned int*)(0x427E20A8UL))
#define bFM4_EXBUS_REFTIM_REFC11               *((volatile unsigned int*)(0x427E20ACUL))
#define bFM4_EXBUS_REFTIM_REFC12               *((volatile unsigned int*)(0x427E20B0UL))
#define bFM4_EXBUS_REFTIM_REFC13               *((volatile unsigned int*)(0x427E20B4UL))
#define bFM4_EXBUS_REFTIM_REFC14               *((volatile unsigned int*)(0x427E20B8UL))
#define bFM4_EXBUS_REFTIM_REFC15               *((volatile unsigned int*)(0x427E20BCUL))
#define bFM4_EXBUS_REFTIM_NREF0                *((volatile unsigned int*)(0x427E20C0UL))
#define bFM4_EXBUS_REFTIM_NREF1                *((volatile unsigned int*)(0x427E20C4UL))
#define bFM4_EXBUS_REFTIM_NREF2                *((volatile unsigned int*)(0x427E20C8UL))
#define bFM4_EXBUS_REFTIM_NREF3                *((volatile unsigned int*)(0x427E20CCUL))
#define bFM4_EXBUS_REFTIM_NREF4                *((volatile unsigned int*)(0x427E20D0UL))
#define bFM4_EXBUS_REFTIM_NREF5                *((volatile unsigned int*)(0x427E20D4UL))
#define bFM4_EXBUS_REFTIM_NREF6                *((volatile unsigned int*)(0x427E20D8UL))
#define bFM4_EXBUS_REFTIM_NREF7                *((volatile unsigned int*)(0x427E20DCUL))
#define bFM4_EXBUS_REFTIM_PREF                 *((volatile unsigned int*)(0x427E20E0UL))
#define bFM4_EXBUS_PWRDWN_PDC0                 *((volatile unsigned int*)(0x427E2100UL))
#define bFM4_EXBUS_PWRDWN_PDC1                 *((volatile unsigned int*)(0x427E2104UL))
#define bFM4_EXBUS_PWRDWN_PDC2                 *((volatile unsigned int*)(0x427E2108UL))
#define bFM4_EXBUS_PWRDWN_PDC3                 *((volatile unsigned int*)(0x427E210CUL))
#define bFM4_EXBUS_PWRDWN_PDC4                 *((volatile unsigned int*)(0x427E2110UL))
#define bFM4_EXBUS_PWRDWN_PDC5                 *((volatile unsigned int*)(0x427E2114UL))
#define bFM4_EXBUS_PWRDWN_PDC6                 *((volatile unsigned int*)(0x427E2118UL))
#define bFM4_EXBUS_PWRDWN_PDC7                 *((volatile unsigned int*)(0x427E211CUL))
#define bFM4_EXBUS_PWRDWN_PDC8                 *((volatile unsigned int*)(0x427E2120UL))
#define bFM4_EXBUS_PWRDWN_PDC9                 *((volatile unsigned int*)(0x427E2124UL))
#define bFM4_EXBUS_PWRDWN_PDC10                *((volatile unsigned int*)(0x427E2128UL))
#define bFM4_EXBUS_PWRDWN_PDC11                *((volatile unsigned int*)(0x427E212CUL))
#define bFM4_EXBUS_PWRDWN_PDC12                *((volatile unsigned int*)(0x427E2130UL))
#define bFM4_EXBUS_PWRDWN_PDC13                *((volatile unsigned int*)(0x427E2134UL))
#define bFM4_EXBUS_PWRDWN_PDC14                *((volatile unsigned int*)(0x427E2138UL))
#define bFM4_EXBUS_PWRDWN_PDC15                *((volatile unsigned int*)(0x427E213CUL))
#define bFM4_EXBUS_SDTIM_CL0                   *((volatile unsigned int*)(0x427E2180UL))
#define bFM4_EXBUS_SDTIM_CL1                   *((volatile unsigned int*)(0x427E2184UL))
#define bFM4_EXBUS_SDTIM_TRC0                  *((volatile unsigned int*)(0x427E2190UL))
#define bFM4_EXBUS_SDTIM_TRC1                  *((volatile unsigned int*)(0x427E2194UL))
#define bFM4_EXBUS_SDTIM_TRC2                  *((volatile unsigned int*)(0x427E2198UL))
#define bFM4_EXBUS_SDTIM_TRC3                  *((volatile unsigned int*)(0x427E219CUL))
#define bFM4_EXBUS_SDTIM_TRP0                  *((volatile unsigned int*)(0x427E21A0UL))
#define bFM4_EXBUS_SDTIM_TRP1                  *((volatile unsigned int*)(0x427E21A4UL))
#define bFM4_EXBUS_SDTIM_TRP2                  *((volatile unsigned int*)(0x427E21A8UL))
#define bFM4_EXBUS_SDTIM_TRP3                  *((volatile unsigned int*)(0x427E21ACUL))
#define bFM4_EXBUS_SDTIM_TRCD0                 *((volatile unsigned int*)(0x427E21B0UL))
#define bFM4_EXBUS_SDTIM_TRCD1                 *((volatile unsigned int*)(0x427E21B4UL))
#define bFM4_EXBUS_SDTIM_TRCD2                 *((volatile unsigned int*)(0x427E21B8UL))
#define bFM4_EXBUS_SDTIM_TRCD3                 *((volatile unsigned int*)(0x427E21BCUL))
#define bFM4_EXBUS_SDTIM_TRAS0                 *((volatile unsigned int*)(0x427E21C0UL))
#define bFM4_EXBUS_SDTIM_TRAS1                 *((volatile unsigned int*)(0x427E21C4UL))
#define bFM4_EXBUS_SDTIM_TRAS2                 *((volatile unsigned int*)(0x427E21C8UL))
#define bFM4_EXBUS_SDTIM_TRAS3                 *((volatile unsigned int*)(0x427E21CCUL))
#define bFM4_EXBUS_SDTIM_TREFC0                *((volatile unsigned int*)(0x427E21D0UL))
#define bFM4_EXBUS_SDTIM_TREFC1                *((volatile unsigned int*)(0x427E21D4UL))
#define bFM4_EXBUS_SDTIM_TREFC2                *((volatile unsigned int*)(0x427E21D8UL))
#define bFM4_EXBUS_SDTIM_TREFC3                *((volatile unsigned int*)(0x427E21DCUL))
#define bFM4_EXBUS_SDTIM_TDPL0                 *((volatile unsigned int*)(0x427E21E0UL))
#define bFM4_EXBUS_SDTIM_TDPL1                 *((volatile unsigned int*)(0x427E21E4UL))
#define bFM4_EXBUS_SDTIM_BOFF                  *((volatile unsigned int*)(0x427E21FCUL))
#define bFM4_EXBUS_SDCMD_SDAD0                 *((volatile unsigned int*)(0x427E2200UL))
#define bFM4_EXBUS_SDCMD_SDAD1                 *((volatile unsigned int*)(0x427E2204UL))
#define bFM4_EXBUS_SDCMD_SDAD2                 *((volatile unsigned int*)(0x427E2208UL))
#define bFM4_EXBUS_SDCMD_SDAD3                 *((volatile unsigned int*)(0x427E220CUL))
#define bFM4_EXBUS_SDCMD_SDAD4                 *((volatile unsigned int*)(0x427E2210UL))
#define bFM4_EXBUS_SDCMD_SDAD5                 *((volatile unsigned int*)(0x427E2214UL))
#define bFM4_EXBUS_SDCMD_SDAD6                 *((volatile unsigned int*)(0x427E2218UL))
#define bFM4_EXBUS_SDCMD_SDAD7                 *((volatile unsigned int*)(0x427E221CUL))
#define bFM4_EXBUS_SDCMD_SDAD8                 *((volatile unsigned int*)(0x427E2220UL))
#define bFM4_EXBUS_SDCMD_SDAD9                 *((volatile unsigned int*)(0x427E2224UL))
#define bFM4_EXBUS_SDCMD_SDAD10                *((volatile unsigned int*)(0x427E2228UL))
#define bFM4_EXBUS_SDCMD_SDAD11                *((volatile unsigned int*)(0x427E222CUL))
#define bFM4_EXBUS_SDCMD_SDAD12                *((volatile unsigned int*)(0x427E2230UL))
#define bFM4_EXBUS_SDCMD_SDAD13                *((volatile unsigned int*)(0x427E2234UL))
#define bFM4_EXBUS_SDCMD_SDAD14                *((volatile unsigned int*)(0x427E2238UL))
#define bFM4_EXBUS_SDCMD_SDAD15                *((volatile unsigned int*)(0x427E223CUL))
#define bFM4_EXBUS_SDCMD_SDWE                  *((volatile unsigned int*)(0x427E2240UL))
#define bFM4_EXBUS_SDCMD_SDCAS                 *((volatile unsigned int*)(0x427E2244UL))
#define bFM4_EXBUS_SDCMD_SDRAS                 *((volatile unsigned int*)(0x427E2248UL))
#define bFM4_EXBUS_SDCMD_SDCS                  *((volatile unsigned int*)(0x427E224CUL))
#define bFM4_EXBUS_SDCMD_SDCKE                 *((volatile unsigned int*)(0x427E2250UL))
#define bFM4_EXBUS_SDCMD_PEND                  *((volatile unsigned int*)(0x427E227CUL))
#define bFM4_EXBUS_MEMCERR_SFER                *((volatile unsigned int*)(0x427E4000UL))
#define bFM4_EXBUS_MEMCERR_SDER                *((volatile unsigned int*)(0x427E4004UL))
#define bFM4_EXBUS_MEMCERR_SFION               *((volatile unsigned int*)(0x427E4008UL))
#define bFM4_EXBUS_MEMCERR_SDION               *((volatile unsigned int*)(0x427E400CUL))
#define bFM4_EXBUS_DCLKR_MDIV0                 *((volatile unsigned int*)(0x427E6000UL))
#define bFM4_EXBUS_DCLKR_MDIV1                 *((volatile unsigned int*)(0x427E6004UL))
#define bFM4_EXBUS_DCLKR_MDIV2                 *((volatile unsigned int*)(0x427E6008UL))
#define bFM4_EXBUS_DCLKR_MDIV3                 *((volatile unsigned int*)(0x427E600CUL))
#define bFM4_EXBUS_DCLKR_MCLKON                *((volatile unsigned int*)(0x427E6010UL))
#define bFM4_EXBUS_EST_WERR                    *((volatile unsigned int*)(0x427E6080UL))
#define bFM4_EXBUS_WEAD_ADDR0                  *((volatile unsigned int*)(0x427E6100UL))
#define bFM4_EXBUS_WEAD_ADDR1                  *((volatile unsigned int*)(0x427E6104UL))
#define bFM4_EXBUS_WEAD_ADDR2                  *((volatile unsigned int*)(0x427E6108UL))
#define bFM4_EXBUS_WEAD_ADDR3                  *((volatile unsigned int*)(0x427E610CUL))
#define bFM4_EXBUS_WEAD_ADDR4                  *((volatile unsigned int*)(0x427E6110UL))
#define bFM4_EXBUS_WEAD_ADDR5                  *((volatile unsigned int*)(0x427E6114UL))
#define bFM4_EXBUS_WEAD_ADDR6                  *((volatile unsigned int*)(0x427E6118UL))
#define bFM4_EXBUS_WEAD_ADDR7                  *((volatile unsigned int*)(0x427E611CUL))
#define bFM4_EXBUS_WEAD_ADDR8                  *((volatile unsigned int*)(0x427E6120UL))
#define bFM4_EXBUS_WEAD_ADDR9                  *((volatile unsigned int*)(0x427E6124UL))
#define bFM4_EXBUS_WEAD_ADDR10                 *((volatile unsigned int*)(0x427E6128UL))
#define bFM4_EXBUS_WEAD_ADDR11                 *((volatile unsigned int*)(0x427E612CUL))
#define bFM4_EXBUS_WEAD_ADDR12                 *((volatile unsigned int*)(0x427E6130UL))
#define bFM4_EXBUS_WEAD_ADDR13                 *((volatile unsigned int*)(0x427E6134UL))
#define bFM4_EXBUS_WEAD_ADDR14                 *((volatile unsigned int*)(0x427E6138UL))
#define bFM4_EXBUS_WEAD_ADDR15                 *((volatile unsigned int*)(0x427E613CUL))
#define bFM4_EXBUS_WEAD_ADDR16                 *((volatile unsigned int*)(0x427E6140UL))
#define bFM4_EXBUS_WEAD_ADDR17                 *((volatile unsigned int*)(0x427E6144UL))
#define bFM4_EXBUS_WEAD_ADDR18                 *((volatile unsigned int*)(0x427E6148UL))
#define bFM4_EXBUS_WEAD_ADDR19                 *((volatile unsigned int*)(0x427E614CUL))
#define bFM4_EXBUS_WEAD_ADDR20                 *((volatile unsigned int*)(0x427E6150UL))
#define bFM4_EXBUS_WEAD_ADDR21                 *((volatile unsigned int*)(0x427E6154UL))
#define bFM4_EXBUS_WEAD_ADDR22                 *((volatile unsigned int*)(0x427E6158UL))
#define bFM4_EXBUS_WEAD_ADDR23                 *((volatile unsigned int*)(0x427E615CUL))
#define bFM4_EXBUS_WEAD_ADDR24                 *((volatile unsigned int*)(0x427E6160UL))
#define bFM4_EXBUS_WEAD_ADDR25                 *((volatile unsigned int*)(0x427E6164UL))
#define bFM4_EXBUS_WEAD_ADDR26                 *((volatile unsigned int*)(0x427E6168UL))
#define bFM4_EXBUS_WEAD_ADDR27                 *((volatile unsigned int*)(0x427E616CUL))
#define bFM4_EXBUS_WEAD_ADDR28                 *((volatile unsigned int*)(0x427E6170UL))
#define bFM4_EXBUS_WEAD_ADDR29                 *((volatile unsigned int*)(0x427E6174UL))
#define bFM4_EXBUS_WEAD_ADDR30                 *((volatile unsigned int*)(0x427E6178UL))
#define bFM4_EXBUS_WEAD_ADDR31                 *((volatile unsigned int*)(0x427E617CUL))
#define bFM4_EXBUS_ESCLR_WERRCLR               *((volatile unsigned int*)(0x427E6180UL))
#define bFM4_EXBUS_AMODE_WAEN                  *((volatile unsigned int*)(0x427E6200UL))

/* USB channel 0 registers */
#define bFM4_USB0_HCNT_HOST                    *((volatile unsigned char*)(0x42842000UL))
#define bFM4_USB0_HCNT_URST                    *((volatile unsigned char*)(0x42842004UL))
#define bFM4_USB0_HCNT_SOFIRE                  *((volatile unsigned char*)(0x42842008UL))
#define bFM4_USB0_HCNT_DIRE                    *((volatile unsigned char*)(0x4284200CUL))
#define bFM4_USB0_HCNT_CNNIRE                  *((volatile unsigned char*)(0x42842010UL))
#define bFM4_USB0_HCNT_CMPIRE                  *((volatile unsigned char*)(0x42842014UL))
#define bFM4_USB0_HCNT_URIRE                   *((volatile unsigned char*)(0x42842018UL))
#define bFM4_USB0_HCNT_RWKIRE                  *((volatile unsigned char*)(0x4284201CUL))
#define bFM4_USB0_HCNT_RETRY                   *((volatile unsigned char*)(0x42842020UL))
#define bFM4_USB0_HCNT_CANCEL                  *((volatile unsigned char*)(0x42842024UL))
#define bFM4_USB0_HCNT_SOFSTEP                 *((volatile unsigned char*)(0x42842028UL))
#define bFM4_USB0_HCNT0_HOST                   *((volatile unsigned char*)(0x42842000UL))
#define bFM4_USB0_HCNT0_URST                   *((volatile unsigned char*)(0x42842004UL))
#define bFM4_USB0_HCNT0_SOFIRE                 *((volatile unsigned char*)(0x42842008UL))
#define bFM4_USB0_HCNT0_DIRE                   *((volatile unsigned char*)(0x4284200CUL))
#define bFM4_USB0_HCNT0_CNNIRE                 *((volatile unsigned char*)(0x42842010UL))
#define bFM4_USB0_HCNT0_CMPIRE                 *((volatile unsigned char*)(0x42842014UL))
#define bFM4_USB0_HCNT0_URIRE                  *((volatile unsigned char*)(0x42842018UL))
#define bFM4_USB0_HCNT0_RWKIRE                 *((volatile unsigned char*)(0x4284201CUL))
#define bFM4_USB0_HCNT1_RETRY                  *((volatile unsigned char*)(0x42842020UL))
#define bFM4_USB0_HCNT1_CANCEL                 *((volatile unsigned char*)(0x42842024UL))
#define bFM4_USB0_HCNT1_SOFSTEP                *((volatile unsigned char*)(0x42842028UL))
#define bFM4_USB0_HIRQ_SOFIRQ                  *((volatile unsigned char*)(0x42842080UL))
#define bFM4_USB0_HIRQ_DIRQ                    *((volatile unsigned char*)(0x42842084UL))
#define bFM4_USB0_HIRQ_CNNIRQ                  *((volatile unsigned char*)(0x42842088UL))
#define bFM4_USB0_HIRQ_CMPIRQ                  *((volatile unsigned char*)(0x4284208CUL))
#define bFM4_USB0_HIRQ_URIRQ                   *((volatile unsigned char*)(0x42842090UL))
#define bFM4_USB0_HIRQ_RWKIRQ                  *((volatile unsigned char*)(0x42842094UL))
#define bFM4_USB0_HIRQ_TCAN                    *((volatile unsigned char*)(0x4284209CUL))
#define bFM4_USB0_HERR_HS0                     *((volatile unsigned char*)(0x428420A0UL))
#define bFM4_USB0_HERR_HS1                     *((volatile unsigned char*)(0x428420A4UL))
#define bFM4_USB0_HERR_STUFF                   *((volatile unsigned char*)(0x428420A8UL))
#define bFM4_USB0_HERR_TGERR                   *((volatile unsigned char*)(0x428420ACUL))
#define bFM4_USB0_HERR_CRC                     *((volatile unsigned char*)(0x428420B0UL))
#define bFM4_USB0_HERR_TOUT                    *((volatile unsigned char*)(0x428420B4UL))
#define bFM4_USB0_HERR_RERR                    *((volatile unsigned char*)(0x428420B8UL))
#define bFM4_USB0_HERR_LSTOF                   *((volatile unsigned char*)(0x428420BCUL))
#define bFM4_USB0_HSTATE_CSTAT                 *((volatile unsigned char*)(0x42842100UL))
#define bFM4_USB0_HSTATE_TMODE                 *((volatile unsigned char*)(0x42842104UL))
#define bFM4_USB0_HSTATE_SUSP                  *((volatile unsigned char*)(0x42842108UL))
#define bFM4_USB0_HSTATE_SOFBUSY               *((volatile unsigned char*)(0x4284210CUL))
#define bFM4_USB0_HSTATE_CLKSEL                *((volatile unsigned char*)(0x42842110UL))
#define bFM4_USB0_HSTATE_ALIVE                 *((volatile unsigned char*)(0x42842114UL))
#define bFM4_USB0_HFCOMP_FRAMECOMP0            *((volatile unsigned char*)(0x42842120UL))
#define bFM4_USB0_HFCOMP_FRAMECOMP1            *((volatile unsigned char*)(0x42842124UL))
#define bFM4_USB0_HFCOMP_FRAMECOMP2            *((volatile unsigned char*)(0x42842128UL))
#define bFM4_USB0_HFCOMP_FRAMECOMP3            *((volatile unsigned char*)(0x4284212CUL))
#define bFM4_USB0_HFCOMP_FRAMECOMP4            *((volatile unsigned char*)(0x42842130UL))
#define bFM4_USB0_HFCOMP_FRAMECOMP5            *((volatile unsigned char*)(0x42842134UL))
#define bFM4_USB0_HFCOMP_FRAMECOMP6            *((volatile unsigned char*)(0x42842138UL))
#define bFM4_USB0_HFCOMP_FRAMECOMP7            *((volatile unsigned char*)(0x4284213CUL))
#define bFM4_USB0_HRTIMER_RTIMER0              *((volatile unsigned char*)(0x42842180UL))
#define bFM4_USB0_HRTIMER_RTIMER1              *((volatile unsigned char*)(0x42842184UL))
#define bFM4_USB0_HRTIMER_RTIMER2              *((volatile unsigned char*)(0x42842188UL))
#define bFM4_USB0_HRTIMER_RTIMER3              *((volatile unsigned char*)(0x4284218CUL))
#define bFM4_USB0_HRTIMER_RTIMER4              *((volatile unsigned char*)(0x42842190UL))
#define bFM4_USB0_HRTIMER_RTIMER5              *((volatile unsigned char*)(0x42842194UL))
#define bFM4_USB0_HRTIMER_RTIMER6              *((volatile unsigned char*)(0x42842198UL))
#define bFM4_USB0_HRTIMER_RTIMER7              *((volatile unsigned char*)(0x4284219CUL))
#define bFM4_USB0_HRTIMER_RTIMER8              *((volatile unsigned char*)(0x428421A0UL))
#define bFM4_USB0_HRTIMER_RTIMER9              *((volatile unsigned char*)(0x428421A4UL))
#define bFM4_USB0_HRTIMER_RTIMER10             *((volatile unsigned char*)(0x428421A8UL))
#define bFM4_USB0_HRTIMER_RTIMER11             *((volatile unsigned char*)(0x428421ACUL))
#define bFM4_USB0_HRTIMER_RTIMER12             *((volatile unsigned char*)(0x428421B0UL))
#define bFM4_USB0_HRTIMER_RTIMER13             *((volatile unsigned char*)(0x428421B4UL))
#define bFM4_USB0_HRTIMER_RTIMER14             *((volatile unsigned char*)(0x428421B8UL))
#define bFM4_USB0_HRTIMER_RTIMER15             *((volatile unsigned char*)(0x428421BCUL))
#define bFM4_USB0_HRTIMER0_RTIMER00            *((volatile unsigned char*)(0x42842180UL))
#define bFM4_USB0_HRTIMER0_RTIMER01            *((volatile unsigned char*)(0x42842184UL))
#define bFM4_USB0_HRTIMER0_RTIMER02            *((volatile unsigned char*)(0x42842188UL))
#define bFM4_USB0_HRTIMER0_RTIMER03            *((volatile unsigned char*)(0x4284218CUL))
#define bFM4_USB0_HRTIMER0_RTIMER04            *((volatile unsigned char*)(0x42842190UL))
#define bFM4_USB0_HRTIMER0_RTIMER05            *((volatile unsigned char*)(0x42842194UL))
#define bFM4_USB0_HRTIMER0_RTIMER06            *((volatile unsigned char*)(0x42842198UL))
#define bFM4_USB0_HRTIMER0_RTIMER07            *((volatile unsigned char*)(0x4284219CUL))
#define bFM4_USB0_HRTIMER1_RTIMER10            *((volatile unsigned char*)(0x428421A0UL))
#define bFM4_USB0_HRTIMER1_RTIMER11            *((volatile unsigned char*)(0x428421A4UL))
#define bFM4_USB0_HRTIMER1_RTIMER12            *((volatile unsigned char*)(0x428421A8UL))
#define bFM4_USB0_HRTIMER1_RTIMER13            *((volatile unsigned char*)(0x428421ACUL))
#define bFM4_USB0_HRTIMER1_RTIMER14            *((volatile unsigned char*)(0x428421B0UL))
#define bFM4_USB0_HRTIMER1_RTIMER15            *((volatile unsigned char*)(0x428421B4UL))
#define bFM4_USB0_HRTIMER1_RTIMER16            *((volatile unsigned char*)(0x428421B8UL))
#define bFM4_USB0_HRTIMER1_RTIMER17            *((volatile unsigned char*)(0x428421BCUL))
#define bFM4_USB0_HRTIMER2_RTIMER20            *((volatile unsigned char*)(0x42842200UL))
#define bFM4_USB0_HRTIMER2_RTIMER21            *((volatile unsigned char*)(0x42842204UL))
#define bFM4_USB0_HRTIMER2_RTIMER22            *((volatile unsigned char*)(0x42842208UL))
#define bFM4_USB0_HADR_ADDRESS0                *((volatile unsigned char*)(0x42842220UL))
#define bFM4_USB0_HADR_ADDRESS1                *((volatile unsigned char*)(0x42842224UL))
#define bFM4_USB0_HADR_ADDRESS2                *((volatile unsigned char*)(0x42842228UL))
#define bFM4_USB0_HADR_ADDRESS3                *((volatile unsigned char*)(0x4284222CUL))
#define bFM4_USB0_HADR_ADDRESS4                *((volatile unsigned char*)(0x42842230UL))
#define bFM4_USB0_HADR_ADDRESS5                *((volatile unsigned char*)(0x42842234UL))
#define bFM4_USB0_HADR_ADDRESS6                *((volatile unsigned char*)(0x42842238UL))
#define bFM4_USB0_HEOF_EOF0                    *((volatile unsigned char*)(0x42842280UL))
#define bFM4_USB0_HEOF_EOF1                    *((volatile unsigned char*)(0x42842284UL))
#define bFM4_USB0_HEOF_EOF2                    *((volatile unsigned char*)(0x42842288UL))
#define bFM4_USB0_HEOF_EOF3                    *((volatile unsigned char*)(0x4284228CUL))
#define bFM4_USB0_HEOF_EOF4                    *((volatile unsigned char*)(0x42842290UL))
#define bFM4_USB0_HEOF_EOF5                    *((volatile unsigned char*)(0x42842294UL))
#define bFM4_USB0_HEOF_EOF6                    *((volatile unsigned char*)(0x42842298UL))
#define bFM4_USB0_HEOF_EOF7                    *((volatile unsigned char*)(0x4284229CUL))
#define bFM4_USB0_HEOF_EOF8                    *((volatile unsigned char*)(0x428422A0UL))
#define bFM4_USB0_HEOF_EOF9                    *((volatile unsigned char*)(0x428422A4UL))
#define bFM4_USB0_HEOF_EOF10                   *((volatile unsigned char*)(0x428422A8UL))
#define bFM4_USB0_HEOF_EOF11                   *((volatile unsigned char*)(0x428422ACUL))
#define bFM4_USB0_HEOF_EOF12                   *((volatile unsigned char*)(0x428422B0UL))
#define bFM4_USB0_HEOF_EOF13                   *((volatile unsigned char*)(0x428422B4UL))
#define bFM4_USB0_HEOF_EOF14                   *((volatile unsigned char*)(0x428422B8UL))
#define bFM4_USB0_HEOF_EOF15                   *((volatile unsigned char*)(0x428422BCUL))
#define bFM4_USB0_HEOF0_EOF00                  *((volatile unsigned char*)(0x42842280UL))
#define bFM4_USB0_HEOF0_EOF01                  *((volatile unsigned char*)(0x42842284UL))
#define bFM4_USB0_HEOF0_EOF02                  *((volatile unsigned char*)(0x42842288UL))
#define bFM4_USB0_HEOF0_EOF03                  *((volatile unsigned char*)(0x4284228CUL))
#define bFM4_USB0_HEOF0_EOF04                  *((volatile unsigned char*)(0x42842290UL))
#define bFM4_USB0_HEOF0_EOF05                  *((volatile unsigned char*)(0x42842294UL))
#define bFM4_USB0_HEOF0_EOF06                  *((volatile unsigned char*)(0x42842298UL))
#define bFM4_USB0_HEOF0_EOF07                  *((volatile unsigned char*)(0x4284229CUL))
#define bFM4_USB0_HEOF1_EOF10                  *((volatile unsigned char*)(0x428422A0UL))
#define bFM4_USB0_HEOF1_EOF11                  *((volatile unsigned char*)(0x428422A4UL))
#define bFM4_USB0_HEOF1_EOF12                  *((volatile unsigned char*)(0x428422A8UL))
#define bFM4_USB0_HEOF1_EOF13                  *((volatile unsigned char*)(0x428422ACUL))
#define bFM4_USB0_HEOF1_EOF14                  *((volatile unsigned char*)(0x428422B0UL))
#define bFM4_USB0_HEOF1_EOF15                  *((volatile unsigned char*)(0x428422B4UL))
#define bFM4_USB0_HFRAME_FRAME0                *((volatile unsigned char*)(0x42842300UL))
#define bFM4_USB0_HFRAME_FRAME1                *((volatile unsigned char*)(0x42842304UL))
#define bFM4_USB0_HFRAME_FRAME2                *((volatile unsigned char*)(0x42842308UL))
#define bFM4_USB0_HFRAME_FRAME3                *((volatile unsigned char*)(0x4284230CUL))
#define bFM4_USB0_HFRAME_FRAME4                *((volatile unsigned char*)(0x42842310UL))
#define bFM4_USB0_HFRAME_FRAME5                *((volatile unsigned char*)(0x42842314UL))
#define bFM4_USB0_HFRAME_FRAME6                *((volatile unsigned char*)(0x42842318UL))
#define bFM4_USB0_HFRAME_FRAME7                *((volatile unsigned char*)(0x4284231CUL))
#define bFM4_USB0_HFRAME_FRAME8                *((volatile unsigned char*)(0x42842320UL))
#define bFM4_USB0_HFRAME_FRAME9                *((volatile unsigned char*)(0x42842324UL))
#define bFM4_USB0_HFRAME_FRAME10               *((volatile unsigned char*)(0x42842328UL))
#define bFM4_USB0_HFRAME0_FRAME00              *((volatile unsigned char*)(0x42842300UL))
#define bFM4_USB0_HFRAME0_FRAME01              *((volatile unsigned char*)(0x42842304UL))
#define bFM4_USB0_HFRAME0_FRAME02              *((volatile unsigned char*)(0x42842308UL))
#define bFM4_USB0_HFRAME0_FRAME03              *((volatile unsigned char*)(0x4284230CUL))
#define bFM4_USB0_HFRAME0_FRAME04              *((volatile unsigned char*)(0x42842310UL))
#define bFM4_USB0_HFRAME0_FRAME05              *((volatile unsigned char*)(0x42842314UL))
#define bFM4_USB0_HFRAME0_FRAME06              *((volatile unsigned char*)(0x42842318UL))
#define bFM4_USB0_HFRAME0_FRAME07              *((volatile unsigned char*)(0x4284231CUL))
#define bFM4_USB0_HFRAME1_FRAME10              *((volatile unsigned char*)(0x42842320UL))
#define bFM4_USB0_HFRAME1_FRAME11              *((volatile unsigned char*)(0x42842324UL))
#define bFM4_USB0_HFRAME1_FRAME12              *((volatile unsigned char*)(0x42842328UL))
#define bFM4_USB0_HFRAME1_FRAME13              *((volatile unsigned char*)(0x4284232CUL))
#define bFM4_USB0_HTOKEN_ENDPT0                *((volatile unsigned char*)(0x42842380UL))
#define bFM4_USB0_HTOKEN_ENDPT1                *((volatile unsigned char*)(0x42842384UL))
#define bFM4_USB0_HTOKEN_ENDPT2                *((volatile unsigned char*)(0x42842388UL))
#define bFM4_USB0_HTOKEN_ENDPT3                *((volatile unsigned char*)(0x4284238CUL))
#define bFM4_USB0_HTOKEN_TKNEN0                *((volatile unsigned char*)(0x42842390UL))
#define bFM4_USB0_HTOKEN_TKNEN1                *((volatile unsigned char*)(0x42842394UL))
#define bFM4_USB0_HTOKEN_TKNEN2                *((volatile unsigned char*)(0x42842398UL))
#define bFM4_USB0_HTOKEN_TGGL                  *((volatile unsigned char*)(0x4284239CUL))
#define bFM4_USB0_UDCC_PWC                     *((volatile unsigned char*)(0x42842400UL))
#define bFM4_USB0_UDCC_RFBK                    *((volatile unsigned char*)(0x42842404UL))
#define bFM4_USB0_UDCC_STALCLREN               *((volatile unsigned char*)(0x4284240CUL))
#define bFM4_USB0_UDCC_USTP                    *((volatile unsigned char*)(0x42842410UL))
#define bFM4_USB0_UDCC_HCONX                   *((volatile unsigned char*)(0x42842414UL))
#define bFM4_USB0_UDCC_RESUM                   *((volatile unsigned char*)(0x42842418UL))
#define bFM4_USB0_UDCC_RST                     *((volatile unsigned char*)(0x4284241CUL))
#define bFM4_USB0_EP0C_PKS00                   *((volatile unsigned int*)(0x42842480UL))
#define bFM4_USB0_EP0C_PKS01                   *((volatile unsigned int*)(0x42842484UL))
#define bFM4_USB0_EP0C_PKS02                   *((volatile unsigned int*)(0x42842488UL))
#define bFM4_USB0_EP0C_PKS03                   *((volatile unsigned int*)(0x4284248CUL))
#define bFM4_USB0_EP0C_PKS04                   *((volatile unsigned int*)(0x42842490UL))
#define bFM4_USB0_EP0C_PKS05                   *((volatile unsigned int*)(0x42842494UL))
#define bFM4_USB0_EP0C_PKS06                   *((volatile unsigned int*)(0x42842498UL))
#define bFM4_USB0_EP0C_STAL                    *((volatile unsigned int*)(0x428424A4UL))
#define bFM4_USB0_EP1C_PKS10                   *((volatile unsigned int*)(0x42842500UL))
#define bFM4_USB0_EP1C_PKS11                   *((volatile unsigned int*)(0x42842504UL))
#define bFM4_USB0_EP1C_PKS12                   *((volatile unsigned int*)(0x42842508UL))
#define bFM4_USB0_EP1C_PKS13                   *((volatile unsigned int*)(0x4284250CUL))
#define bFM4_USB0_EP1C_PKS14                   *((volatile unsigned int*)(0x42842510UL))
#define bFM4_USB0_EP1C_PKS15                   *((volatile unsigned int*)(0x42842514UL))
#define bFM4_USB0_EP1C_PKS16                   *((volatile unsigned int*)(0x42842518UL))
#define bFM4_USB0_EP1C_PKS17                   *((volatile unsigned int*)(0x4284251CUL))
#define bFM4_USB0_EP1C_PKS18                   *((volatile unsigned int*)(0x42842520UL))
#define bFM4_USB0_EP1C_STAL                    *((volatile unsigned int*)(0x42842524UL))
#define bFM4_USB0_EP1C_NULE                    *((volatile unsigned int*)(0x42842528UL))
#define bFM4_USB0_EP1C_DMAE                    *((volatile unsigned int*)(0x4284252CUL))
#define bFM4_USB0_EP1C_DIR                     *((volatile unsigned int*)(0x42842530UL))
#define bFM4_USB0_EP1C_TYPE0                   *((volatile unsigned int*)(0x42842534UL))
#define bFM4_USB0_EP1C_TYPE1                   *((volatile unsigned int*)(0x42842538UL))
#define bFM4_USB0_EP1C_EPEN                    *((volatile unsigned int*)(0x4284253CUL))
#define bFM4_USB0_EP2C_PKS20                   *((volatile unsigned int*)(0x42842580UL))
#define bFM4_USB0_EP2C_PKS21                   *((volatile unsigned int*)(0x42842584UL))
#define bFM4_USB0_EP2C_PKS22                   *((volatile unsigned int*)(0x42842588UL))
#define bFM4_USB0_EP2C_PKS23                   *((volatile unsigned int*)(0x4284258CUL))
#define bFM4_USB0_EP2C_PKS24                   *((volatile unsigned int*)(0x42842590UL))
#define bFM4_USB0_EP2C_PKS25                   *((volatile unsigned int*)(0x42842594UL))
#define bFM4_USB0_EP2C_PKS26                   *((volatile unsigned int*)(0x42842598UL))
#define bFM4_USB0_EP2C_STAL                    *((volatile unsigned int*)(0x428425A4UL))
#define bFM4_USB0_EP2C_NULE                    *((volatile unsigned int*)(0x428425A8UL))
#define bFM4_USB0_EP2C_DMAE                    *((volatile unsigned int*)(0x428425ACUL))
#define bFM4_USB0_EP2C_DIR                     *((volatile unsigned int*)(0x428425B0UL))
#define bFM4_USB0_EP2C_TYPE0                   *((volatile unsigned int*)(0x428425B4UL))
#define bFM4_USB0_EP2C_TYPE1                   *((volatile unsigned int*)(0x428425B8UL))
#define bFM4_USB0_EP2C_EPEN                    *((volatile unsigned int*)(0x428425BCUL))
#define bFM4_USB0_EP3C_PKS30                   *((volatile unsigned int*)(0x42842600UL))
#define bFM4_USB0_EP3C_PKS31                   *((volatile unsigned int*)(0x42842604UL))
#define bFM4_USB0_EP3C_PKS32                   *((volatile unsigned int*)(0x42842608UL))
#define bFM4_USB0_EP3C_PKS33                   *((volatile unsigned int*)(0x4284260CUL))
#define bFM4_USB0_EP3C_PKS34                   *((volatile unsigned int*)(0x42842610UL))
#define bFM4_USB0_EP3C_PKS35                   *((volatile unsigned int*)(0x42842614UL))
#define bFM4_USB0_EP3C_PKS36                   *((volatile unsigned int*)(0x42842618UL))
#define bFM4_USB0_EP3C_STAL                    *((volatile unsigned int*)(0x42842624UL))
#define bFM4_USB0_EP3C_NULE                    *((volatile unsigned int*)(0x42842628UL))
#define bFM4_USB0_EP3C_DMAE                    *((volatile unsigned int*)(0x4284262CUL))
#define bFM4_USB0_EP3C_DIR                     *((volatile unsigned int*)(0x42842630UL))
#define bFM4_USB0_EP3C_TYPE0                   *((volatile unsigned int*)(0x42842634UL))
#define bFM4_USB0_EP3C_TYPE1                   *((volatile unsigned int*)(0x42842638UL))
#define bFM4_USB0_EP3C_EPEN                    *((volatile unsigned int*)(0x4284263CUL))
#define bFM4_USB0_EP4C_PKS40                   *((volatile unsigned int*)(0x42842680UL))
#define bFM4_USB0_EP4C_PKS41                   *((volatile unsigned int*)(0x42842684UL))
#define bFM4_USB0_EP4C_PKS42                   *((volatile unsigned int*)(0x42842688UL))
#define bFM4_USB0_EP4C_PKS43                   *((volatile unsigned int*)(0x4284268CUL))
#define bFM4_USB0_EP4C_PKS44                   *((volatile unsigned int*)(0x42842690UL))
#define bFM4_USB0_EP4C_PKS45                   *((volatile unsigned int*)(0x42842694UL))
#define bFM4_USB0_EP4C_PKS46                   *((volatile unsigned int*)(0x42842698UL))
#define bFM4_USB0_EP4C_STAL                    *((volatile unsigned int*)(0x428426A4UL))
#define bFM4_USB0_EP4C_NULE                    *((volatile unsigned int*)(0x428426A8UL))
#define bFM4_USB0_EP4C_DMAE                    *((volatile unsigned int*)(0x428426ACUL))
#define bFM4_USB0_EP4C_DIR                     *((volatile unsigned int*)(0x428426B0UL))
#define bFM4_USB0_EP4C_TYPE0                   *((volatile unsigned int*)(0x428426B4UL))
#define bFM4_USB0_EP4C_TYPE1                   *((volatile unsigned int*)(0x428426B8UL))
#define bFM4_USB0_EP4C_EPEN                    *((volatile unsigned int*)(0x428426BCUL))
#define bFM4_USB0_EP5C_PKS50                   *((volatile unsigned int*)(0x42842700UL))
#define bFM4_USB0_EP5C_PKS51                   *((volatile unsigned int*)(0x42842704UL))
#define bFM4_USB0_EP5C_PKS52                   *((volatile unsigned int*)(0x42842708UL))
#define bFM4_USB0_EP5C_PKS53                   *((volatile unsigned int*)(0x4284270CUL))
#define bFM4_USB0_EP5C_PKS54                   *((volatile unsigned int*)(0x42842710UL))
#define bFM4_USB0_EP5C_PKS55                   *((volatile unsigned int*)(0x42842714UL))
#define bFM4_USB0_EP5C_PKS56                   *((volatile unsigned int*)(0x42842718UL))
#define bFM4_USB0_EP5C_STAL                    *((volatile unsigned int*)(0x42842724UL))
#define bFM4_USB0_EP5C_NULE                    *((volatile unsigned int*)(0x42842728UL))
#define bFM4_USB0_EP5C_DMAE                    *((volatile unsigned int*)(0x4284272CUL))
#define bFM4_USB0_EP5C_DIR                     *((volatile unsigned int*)(0x42842730UL))
#define bFM4_USB0_EP5C_TYPE0                   *((volatile unsigned int*)(0x42842734UL))
#define bFM4_USB0_EP5C_TYPE1                   *((volatile unsigned int*)(0x42842738UL))
#define bFM4_USB0_EP5C_EPEN                    *((volatile unsigned int*)(0x4284273CUL))
#define bFM4_USB0_TMSP_TMSP0                   *((volatile unsigned int*)(0x42842780UL))
#define bFM4_USB0_TMSP_TMSP1                   *((volatile unsigned int*)(0x42842784UL))
#define bFM4_USB0_TMSP_TMSP2                   *((volatile unsigned int*)(0x42842788UL))
#define bFM4_USB0_TMSP_TMSP3                   *((volatile unsigned int*)(0x4284278CUL))
#define bFM4_USB0_TMSP_TMSP4                   *((volatile unsigned int*)(0x42842790UL))
#define bFM4_USB0_TMSP_TMSP5                   *((volatile unsigned int*)(0x42842794UL))
#define bFM4_USB0_TMSP_TMSP6                   *((volatile unsigned int*)(0x42842798UL))
#define bFM4_USB0_TMSP_TMSP7                   *((volatile unsigned int*)(0x4284279CUL))
#define bFM4_USB0_TMSP_TMSP8                   *((volatile unsigned int*)(0x428427A0UL))
#define bFM4_USB0_TMSP_TMSP9                   *((volatile unsigned int*)(0x428427A4UL))
#define bFM4_USB0_TMSP_TMSP10                  *((volatile unsigned int*)(0x428427A8UL))
#define bFM4_USB0_UDCS_CONF                    *((volatile unsigned char*)(0x42842800UL))
#define bFM4_USB0_UDCS_SETP                    *((volatile unsigned char*)(0x42842804UL))
#define bFM4_USB0_UDCS_WKUP                    *((volatile unsigned char*)(0x42842808UL))
#define bFM4_USB0_UDCS_BRST                    *((volatile unsigned char*)(0x4284280CUL))
#define bFM4_USB0_UDCS_SOF                     *((volatile unsigned char*)(0x42842810UL))
#define bFM4_USB0_UDCS_SUSP                    *((volatile unsigned char*)(0x42842814UL))
#define bFM4_USB0_UDCIE_CONFIE                 *((volatile unsigned char*)(0x42842820UL))
#define bFM4_USB0_UDCIE_CONFN                  *((volatile unsigned char*)(0x42842824UL))
#define bFM4_USB0_UDCIE_WKUPIE                 *((volatile unsigned char*)(0x42842828UL))
#define bFM4_USB0_UDCIE_BRSTIE                 *((volatile unsigned char*)(0x4284282CUL))
#define bFM4_USB0_UDCIE_SOFIE                  *((volatile unsigned char*)(0x42842830UL))
#define bFM4_USB0_UDCIE_SUSPIE                 *((volatile unsigned char*)(0x42842834UL))
#define bFM4_USB0_EP0IS_DRQI                   *((volatile unsigned int*)(0x428428A8UL))
#define bFM4_USB0_EP0IS_DRQIIE                 *((volatile unsigned int*)(0x428428B8UL))
#define bFM4_USB0_EP0IS_BFINI                  *((volatile unsigned int*)(0x428428BCUL))
#define bFM4_USB0_EP0OS_SIZE0                  *((volatile unsigned int*)(0x42842900UL))
#define bFM4_USB0_EP0OS_SIZE1                  *((volatile unsigned int*)(0x42842904UL))
#define bFM4_USB0_EP0OS_SIZE2                  *((volatile unsigned int*)(0x42842908UL))
#define bFM4_USB0_EP0OS_SIZE3                  *((volatile unsigned int*)(0x4284290CUL))
#define bFM4_USB0_EP0OS_SIZE4                  *((volatile unsigned int*)(0x42842910UL))
#define bFM4_USB0_EP0OS_SIZE5                  *((volatile unsigned int*)(0x42842914UL))
#define bFM4_USB0_EP0OS_SIZE6                  *((volatile unsigned int*)(0x42842918UL))
#define bFM4_USB0_EP0OS_SPK                    *((volatile unsigned int*)(0x42842924UL))
#define bFM4_USB0_EP0OS_DRQO                   *((volatile unsigned int*)(0x42842928UL))
#define bFM4_USB0_EP0OS_SPKIE                  *((volatile unsigned int*)(0x42842934UL))
#define bFM4_USB0_EP0OS_DRQOIE                 *((volatile unsigned int*)(0x42842938UL))
#define bFM4_USB0_EP0OS_BFINI                  *((volatile unsigned int*)(0x4284293CUL))
#define bFM4_USB0_EP1S_SIZE10                  *((volatile unsigned int*)(0x42842980UL))
#define bFM4_USB0_EP1S_SIZE11                  *((volatile unsigned int*)(0x42842984UL))
#define bFM4_USB0_EP1S_SIZE12                  *((volatile unsigned int*)(0x42842988UL))
#define bFM4_USB0_EP1S_SIZE13                  *((volatile unsigned int*)(0x4284298CUL))
#define bFM4_USB0_EP1S_SIZE14                  *((volatile unsigned int*)(0x42842990UL))
#define bFM4_USB0_EP1S_SIZE15                  *((volatile unsigned int*)(0x42842994UL))
#define bFM4_USB0_EP1S_SIZE16                  *((volatile unsigned int*)(0x42842998UL))
#define bFM4_USB0_EP1S_SIZE17                  *((volatile unsigned int*)(0x4284299CUL))
#define bFM4_USB0_EP1S_SIZE18                  *((volatile unsigned int*)(0x428429A0UL))
#define bFM4_USB0_EP1S_SPK                     *((volatile unsigned int*)(0x428429A4UL))
#define bFM4_USB0_EP1S_DRQ                     *((volatile unsigned int*)(0x428429A8UL))
#define bFM4_USB0_EP1S_BUSY                    *((volatile unsigned int*)(0x428429ACUL))
#define bFM4_USB0_EP1S_SPKIE                   *((volatile unsigned int*)(0x428429B4UL))
#define bFM4_USB0_EP1S_DRQIE                   *((volatile unsigned int*)(0x428429B8UL))
#define bFM4_USB0_EP1S_BFINI                   *((volatile unsigned int*)(0x428429BCUL))
#define bFM4_USB0_EP2S_SIZE20                  *((volatile unsigned int*)(0x42842A00UL))
#define bFM4_USB0_EP2S_SIZE21                  *((volatile unsigned int*)(0x42842A04UL))
#define bFM4_USB0_EP2S_SIZE22                  *((volatile unsigned int*)(0x42842A08UL))
#define bFM4_USB0_EP2S_SIZE23                  *((volatile unsigned int*)(0x42842A0CUL))
#define bFM4_USB0_EP2S_SIZE24                  *((volatile unsigned int*)(0x42842A10UL))
#define bFM4_USB0_EP2S_SIZE25                  *((volatile unsigned int*)(0x42842A14UL))
#define bFM4_USB0_EP2S_SIZE26                  *((volatile unsigned int*)(0x42842A18UL))
#define bFM4_USB0_EP2S_SPK                     *((volatile unsigned int*)(0x42842A24UL))
#define bFM4_USB0_EP2S_DRQ                     *((volatile unsigned int*)(0x42842A28UL))
#define bFM4_USB0_EP2S_BUSY                    *((volatile unsigned int*)(0x42842A2CUL))
#define bFM4_USB0_EP2S_SPKIE                   *((volatile unsigned int*)(0x42842A34UL))
#define bFM4_USB0_EP2S_DRQIE                   *((volatile unsigned int*)(0x42842A38UL))
#define bFM4_USB0_EP2S_BFINI                   *((volatile unsigned int*)(0x42842A3CUL))
#define bFM4_USB0_EP3S_SIZE30                  *((volatile unsigned int*)(0x42842A80UL))
#define bFM4_USB0_EP3S_SIZE31                  *((volatile unsigned int*)(0x42842A84UL))
#define bFM4_USB0_EP3S_SIZE32                  *((volatile unsigned int*)(0x42842A88UL))
#define bFM4_USB0_EP3S_SIZE33                  *((volatile unsigned int*)(0x42842A8CUL))
#define bFM4_USB0_EP3S_SIZE34                  *((volatile unsigned int*)(0x42842A90UL))
#define bFM4_USB0_EP3S_SIZE35                  *((volatile unsigned int*)(0x42842A94UL))
#define bFM4_USB0_EP3S_SIZE36                  *((volatile unsigned int*)(0x42842A98UL))
#define bFM4_USB0_EP3S_SPK                     *((volatile unsigned int*)(0x42842AA4UL))
#define bFM4_USB0_EP3S_DRQ                     *((volatile unsigned int*)(0x42842AA8UL))
#define bFM4_USB0_EP3S_BUSY                    *((volatile unsigned int*)(0x42842AACUL))
#define bFM4_USB0_EP3S_SPKIE                   *((volatile unsigned int*)(0x42842AB4UL))
#define bFM4_USB0_EP3S_DRQIE                   *((volatile unsigned int*)(0x42842AB8UL))
#define bFM4_USB0_EP3S_BFINI                   *((volatile unsigned int*)(0x42842ABCUL))
#define bFM4_USB0_EP4S_SIZE40                  *((volatile unsigned int*)(0x42842B00UL))
#define bFM4_USB0_EP4S_SIZE41                  *((volatile unsigned int*)(0x42842B04UL))
#define bFM4_USB0_EP4S_SIZE42                  *((volatile unsigned int*)(0x42842B08UL))
#define bFM4_USB0_EP4S_SIZE43                  *((volatile unsigned int*)(0x42842B0CUL))
#define bFM4_USB0_EP4S_SIZE44                  *((volatile unsigned int*)(0x42842B10UL))
#define bFM4_USB0_EP4S_SIZE45                  *((volatile unsigned int*)(0x42842B14UL))
#define bFM4_USB0_EP4S_SIZE46                  *((volatile unsigned int*)(0x42842B18UL))
#define bFM4_USB0_EP4S_SPK                     *((volatile unsigned int*)(0x42842B24UL))
#define bFM4_USB0_EP4S_DRQ                     *((volatile unsigned int*)(0x42842B28UL))
#define bFM4_USB0_EP4S_BUSY                    *((volatile unsigned int*)(0x42842B2CUL))
#define bFM4_USB0_EP4S_SPKIE                   *((volatile unsigned int*)(0x42842B34UL))
#define bFM4_USB0_EP4S_DRQIE                   *((volatile unsigned int*)(0x42842B38UL))
#define bFM4_USB0_EP4S_BFINI                   *((volatile unsigned int*)(0x42842B3CUL))
#define bFM4_USB0_EP5S_SIZE50                  *((volatile unsigned int*)(0x42842B80UL))
#define bFM4_USB0_EP5S_SIZE51                  *((volatile unsigned int*)(0x42842B84UL))
#define bFM4_USB0_EP5S_SIZE52                  *((volatile unsigned int*)(0x42842B88UL))
#define bFM4_USB0_EP5S_SIZE53                  *((volatile unsigned int*)(0x42842B8CUL))
#define bFM4_USB0_EP5S_SIZE54                  *((volatile unsigned int*)(0x42842B90UL))
#define bFM4_USB0_EP5S_SIZE55                  *((volatile unsigned int*)(0x42842B94UL))
#define bFM4_USB0_EP5S_SIZE56                  *((volatile unsigned int*)(0x42842B98UL))
#define bFM4_USB0_EP5S_SPK                     *((volatile unsigned int*)(0x42842BA4UL))
#define bFM4_USB0_EP5S_DRQ                     *((volatile unsigned int*)(0x42842BA8UL))
#define bFM4_USB0_EP5S_BUSY                    *((volatile unsigned int*)(0x42842BACUL))
#define bFM4_USB0_EP5S_SPKIE                   *((volatile unsigned int*)(0x42842BB4UL))
#define bFM4_USB0_EP5S_DRQIE                   *((volatile unsigned int*)(0x42842BB8UL))
#define bFM4_USB0_EP5S_BFINI                   *((volatile unsigned int*)(0x42842BBCUL))

/* USB channel 1 registers */
#define bFM4_USB1_HCNT_HOST                    *((volatile unsigned char*)(0x42A42000UL))
#define bFM4_USB1_HCNT_URST                    *((volatile unsigned char*)(0x42A42004UL))
#define bFM4_USB1_HCNT_SOFIRE                  *((volatile unsigned char*)(0x42A42008UL))
#define bFM4_USB1_HCNT_DIRE                    *((volatile unsigned char*)(0x42A4200CUL))
#define bFM4_USB1_HCNT_CNNIRE                  *((volatile unsigned char*)(0x42A42010UL))
#define bFM4_USB1_HCNT_CMPIRE                  *((volatile unsigned char*)(0x42A42014UL))
#define bFM4_USB1_HCNT_URIRE                   *((volatile unsigned char*)(0x42A42018UL))
#define bFM4_USB1_HCNT_RWKIRE                  *((volatile unsigned char*)(0x42A4201CUL))
#define bFM4_USB1_HCNT_RETRY                   *((volatile unsigned char*)(0x42A42020UL))
#define bFM4_USB1_HCNT_CANCEL                  *((volatile unsigned char*)(0x42A42024UL))
#define bFM4_USB1_HCNT_SOFSTEP                 *((volatile unsigned char*)(0x42A42028UL))
#define bFM4_USB1_HCNT0_HOST                   *((volatile unsigned char*)(0x42A42000UL))
#define bFM4_USB1_HCNT0_URST                   *((volatile unsigned char*)(0x42A42004UL))
#define bFM4_USB1_HCNT0_SOFIRE                 *((volatile unsigned char*)(0x42A42008UL))
#define bFM4_USB1_HCNT0_DIRE                   *((volatile unsigned char*)(0x42A4200CUL))
#define bFM4_USB1_HCNT0_CNNIRE                 *((volatile unsigned char*)(0x42A42010UL))
#define bFM4_USB1_HCNT0_CMPIRE                 *((volatile unsigned char*)(0x42A42014UL))
#define bFM4_USB1_HCNT0_URIRE                  *((volatile unsigned char*)(0x42A42018UL))
#define bFM4_USB1_HCNT0_RWKIRE                 *((volatile unsigned char*)(0x42A4201CUL))
#define bFM4_USB1_HCNT1_RETRY                  *((volatile unsigned char*)(0x42A42020UL))
#define bFM4_USB1_HCNT1_CANCEL                 *((volatile unsigned char*)(0x42A42024UL))
#define bFM4_USB1_HCNT1_SOFSTEP                *((volatile unsigned char*)(0x42A42028UL))
#define bFM4_USB1_HIRQ_SOFIRQ                  *((volatile unsigned char*)(0x42A42080UL))
#define bFM4_USB1_HIRQ_DIRQ                    *((volatile unsigned char*)(0x42A42084UL))
#define bFM4_USB1_HIRQ_CNNIRQ                  *((volatile unsigned char*)(0x42A42088UL))
#define bFM4_USB1_HIRQ_CMPIRQ                  *((volatile unsigned char*)(0x42A4208CUL))
#define bFM4_USB1_HIRQ_URIRQ                   *((volatile unsigned char*)(0x42A42090UL))
#define bFM4_USB1_HIRQ_RWKIRQ                  *((volatile unsigned char*)(0x42A42094UL))
#define bFM4_USB1_HIRQ_TCAN                    *((volatile unsigned char*)(0x42A4209CUL))
#define bFM4_USB1_HERR_HS0                     *((volatile unsigned char*)(0x42A420A0UL))
#define bFM4_USB1_HERR_HS1                     *((volatile unsigned char*)(0x42A420A4UL))
#define bFM4_USB1_HERR_STUFF                   *((volatile unsigned char*)(0x42A420A8UL))
#define bFM4_USB1_HERR_TGERR                   *((volatile unsigned char*)(0x42A420ACUL))
#define bFM4_USB1_HERR_CRC                     *((volatile unsigned char*)(0x42A420B0UL))
#define bFM4_USB1_HERR_TOUT                    *((volatile unsigned char*)(0x42A420B4UL))
#define bFM4_USB1_HERR_RERR                    *((volatile unsigned char*)(0x42A420B8UL))
#define bFM4_USB1_HERR_LSTOF                   *((volatile unsigned char*)(0x42A420BCUL))
#define bFM4_USB1_HSTATE_CSTAT                 *((volatile unsigned char*)(0x42A42100UL))
#define bFM4_USB1_HSTATE_TMODE                 *((volatile unsigned char*)(0x42A42104UL))
#define bFM4_USB1_HSTATE_SUSP                  *((volatile unsigned char*)(0x42A42108UL))
#define bFM4_USB1_HSTATE_SOFBUSY               *((volatile unsigned char*)(0x42A4210CUL))
#define bFM4_USB1_HSTATE_CLKSEL                *((volatile unsigned char*)(0x42A42110UL))
#define bFM4_USB1_HSTATE_ALIVE                 *((volatile unsigned char*)(0x42A42114UL))
#define bFM4_USB1_HFCOMP_FRAMECOMP0            *((volatile unsigned char*)(0x42A42120UL))
#define bFM4_USB1_HFCOMP_FRAMECOMP1            *((volatile unsigned char*)(0x42A42124UL))
#define bFM4_USB1_HFCOMP_FRAMECOMP2            *((volatile unsigned char*)(0x42A42128UL))
#define bFM4_USB1_HFCOMP_FRAMECOMP3            *((volatile unsigned char*)(0x42A4212CUL))
#define bFM4_USB1_HFCOMP_FRAMECOMP4            *((volatile unsigned char*)(0x42A42130UL))
#define bFM4_USB1_HFCOMP_FRAMECOMP5            *((volatile unsigned char*)(0x42A42134UL))
#define bFM4_USB1_HFCOMP_FRAMECOMP6            *((volatile unsigned char*)(0x42A42138UL))
#define bFM4_USB1_HFCOMP_FRAMECOMP7            *((volatile unsigned char*)(0x42A4213CUL))
#define bFM4_USB1_HRTIMER_RTIMER0              *((volatile unsigned char*)(0x42A42180UL))
#define bFM4_USB1_HRTIMER_RTIMER1              *((volatile unsigned char*)(0x42A42184UL))
#define bFM4_USB1_HRTIMER_RTIMER2              *((volatile unsigned char*)(0x42A42188UL))
#define bFM4_USB1_HRTIMER_RTIMER3              *((volatile unsigned char*)(0x42A4218CUL))
#define bFM4_USB1_HRTIMER_RTIMER4              *((volatile unsigned char*)(0x42A42190UL))
#define bFM4_USB1_HRTIMER_RTIMER5              *((volatile unsigned char*)(0x42A42194UL))
#define bFM4_USB1_HRTIMER_RTIMER6              *((volatile unsigned char*)(0x42A42198UL))
#define bFM4_USB1_HRTIMER_RTIMER7              *((volatile unsigned char*)(0x42A4219CUL))
#define bFM4_USB1_HRTIMER_RTIMER8              *((volatile unsigned char*)(0x42A421A0UL))
#define bFM4_USB1_HRTIMER_RTIMER9              *((volatile unsigned char*)(0x42A421A4UL))
#define bFM4_USB1_HRTIMER_RTIMER10             *((volatile unsigned char*)(0x42A421A8UL))
#define bFM4_USB1_HRTIMER_RTIMER11             *((volatile unsigned char*)(0x42A421ACUL))
#define bFM4_USB1_HRTIMER_RTIMER12             *((volatile unsigned char*)(0x42A421B0UL))
#define bFM4_USB1_HRTIMER_RTIMER13             *((volatile unsigned char*)(0x42A421B4UL))
#define bFM4_USB1_HRTIMER_RTIMER14             *((volatile unsigned char*)(0x42A421B8UL))
#define bFM4_USB1_HRTIMER_RTIMER15             *((volatile unsigned char*)(0x42A421BCUL))
#define bFM4_USB1_HRTIMER0_RTIMER00            *((volatile unsigned char*)(0x42A42180UL))
#define bFM4_USB1_HRTIMER0_RTIMER01            *((volatile unsigned char*)(0x42A42184UL))
#define bFM4_USB1_HRTIMER0_RTIMER02            *((volatile unsigned char*)(0x42A42188UL))
#define bFM4_USB1_HRTIMER0_RTIMER03            *((volatile unsigned char*)(0x42A4218CUL))
#define bFM4_USB1_HRTIMER0_RTIMER04            *((volatile unsigned char*)(0x42A42190UL))
#define bFM4_USB1_HRTIMER0_RTIMER05            *((volatile unsigned char*)(0x42A42194UL))
#define bFM4_USB1_HRTIMER0_RTIMER06            *((volatile unsigned char*)(0x42A42198UL))
#define bFM4_USB1_HRTIMER0_RTIMER07            *((volatile unsigned char*)(0x42A4219CUL))
#define bFM4_USB1_HRTIMER1_RTIMER10            *((volatile unsigned char*)(0x42A421A0UL))
#define bFM4_USB1_HRTIMER1_RTIMER11            *((volatile unsigned char*)(0x42A421A4UL))
#define bFM4_USB1_HRTIMER1_RTIMER12            *((volatile unsigned char*)(0x42A421A8UL))
#define bFM4_USB1_HRTIMER1_RTIMER13            *((volatile unsigned char*)(0x42A421ACUL))
#define bFM4_USB1_HRTIMER1_RTIMER14            *((volatile unsigned char*)(0x42A421B0UL))
#define bFM4_USB1_HRTIMER1_RTIMER15            *((volatile unsigned char*)(0x42A421B4UL))
#define bFM4_USB1_HRTIMER1_RTIMER16            *((volatile unsigned char*)(0x42A421B8UL))
#define bFM4_USB1_HRTIMER1_RTIMER17            *((volatile unsigned char*)(0x42A421BCUL))
#define bFM4_USB1_HRTIMER2_RTIMER20            *((volatile unsigned char*)(0x42A42200UL))
#define bFM4_USB1_HRTIMER2_RTIMER21            *((volatile unsigned char*)(0x42A42204UL))
#define bFM4_USB1_HRTIMER2_RTIMER22            *((volatile unsigned char*)(0x42A42208UL))
#define bFM4_USB1_HADR_ADDRESS0                *((volatile unsigned char*)(0x42A42220UL))
#define bFM4_USB1_HADR_ADDRESS1                *((volatile unsigned char*)(0x42A42224UL))
#define bFM4_USB1_HADR_ADDRESS2                *((volatile unsigned char*)(0x42A42228UL))
#define bFM4_USB1_HADR_ADDRESS3                *((volatile unsigned char*)(0x42A4222CUL))
#define bFM4_USB1_HADR_ADDRESS4                *((volatile unsigned char*)(0x42A42230UL))
#define bFM4_USB1_HADR_ADDRESS5                *((volatile unsigned char*)(0x42A42234UL))
#define bFM4_USB1_HADR_ADDRESS6                *((volatile unsigned char*)(0x42A42238UL))
#define bFM4_USB1_HEOF_EOF0                    *((volatile unsigned char*)(0x42A42280UL))
#define bFM4_USB1_HEOF_EOF1                    *((volatile unsigned char*)(0x42A42284UL))
#define bFM4_USB1_HEOF_EOF2                    *((volatile unsigned char*)(0x42A42288UL))
#define bFM4_USB1_HEOF_EOF3                    *((volatile unsigned char*)(0x42A4228CUL))
#define bFM4_USB1_HEOF_EOF4                    *((volatile unsigned char*)(0x42A42290UL))
#define bFM4_USB1_HEOF_EOF5                    *((volatile unsigned char*)(0x42A42294UL))
#define bFM4_USB1_HEOF_EOF6                    *((volatile unsigned char*)(0x42A42298UL))
#define bFM4_USB1_HEOF_EOF7                    *((volatile unsigned char*)(0x42A4229CUL))
#define bFM4_USB1_HEOF_EOF8                    *((volatile unsigned char*)(0x42A422A0UL))
#define bFM4_USB1_HEOF_EOF9                    *((volatile unsigned char*)(0x42A422A4UL))
#define bFM4_USB1_HEOF_EOF10                   *((volatile unsigned char*)(0x42A422A8UL))
#define bFM4_USB1_HEOF_EOF11                   *((volatile unsigned char*)(0x42A422ACUL))
#define bFM4_USB1_HEOF_EOF12                   *((volatile unsigned char*)(0x42A422B0UL))
#define bFM4_USB1_HEOF_EOF13                   *((volatile unsigned char*)(0x42A422B4UL))
#define bFM4_USB1_HEOF_EOF14                   *((volatile unsigned char*)(0x42A422B8UL))
#define bFM4_USB1_HEOF_EOF15                   *((volatile unsigned char*)(0x42A422BCUL))
#define bFM4_USB1_HEOF0_EOF00                  *((volatile unsigned char*)(0x42A42280UL))
#define bFM4_USB1_HEOF0_EOF01                  *((volatile unsigned char*)(0x42A42284UL))
#define bFM4_USB1_HEOF0_EOF02                  *((volatile unsigned char*)(0x42A42288UL))
#define bFM4_USB1_HEOF0_EOF03                  *((volatile unsigned char*)(0x42A4228CUL))
#define bFM4_USB1_HEOF0_EOF04                  *((volatile unsigned char*)(0x42A42290UL))
#define bFM4_USB1_HEOF0_EOF05                  *((volatile unsigned char*)(0x42A42294UL))
#define bFM4_USB1_HEOF0_EOF06                  *((volatile unsigned char*)(0x42A42298UL))
#define bFM4_USB1_HEOF0_EOF07                  *((volatile unsigned char*)(0x42A4229CUL))
#define bFM4_USB1_HEOF1_EOF10                  *((volatile unsigned char*)(0x42A422A0UL))
#define bFM4_USB1_HEOF1_EOF11                  *((volatile unsigned char*)(0x42A422A4UL))
#define bFM4_USB1_HEOF1_EOF12                  *((volatile unsigned char*)(0x42A422A8UL))
#define bFM4_USB1_HEOF1_EOF13                  *((volatile unsigned char*)(0x42A422ACUL))
#define bFM4_USB1_HEOF1_EOF14                  *((volatile unsigned char*)(0x42A422B0UL))
#define bFM4_USB1_HEOF1_EOF15                  *((volatile unsigned char*)(0x42A422B4UL))
#define bFM4_USB1_HFRAME_FRAME0                *((volatile unsigned char*)(0x42A42300UL))
#define bFM4_USB1_HFRAME_FRAME1                *((volatile unsigned char*)(0x42A42304UL))
#define bFM4_USB1_HFRAME_FRAME2                *((volatile unsigned char*)(0x42A42308UL))
#define bFM4_USB1_HFRAME_FRAME3                *((volatile unsigned char*)(0x42A4230CUL))
#define bFM4_USB1_HFRAME_FRAME4                *((volatile unsigned char*)(0x42A42310UL))
#define bFM4_USB1_HFRAME_FRAME5                *((volatile unsigned char*)(0x42A42314UL))
#define bFM4_USB1_HFRAME_FRAME6                *((volatile unsigned char*)(0x42A42318UL))
#define bFM4_USB1_HFRAME_FRAME7                *((volatile unsigned char*)(0x42A4231CUL))
#define bFM4_USB1_HFRAME_FRAME8                *((volatile unsigned char*)(0x42A42320UL))
#define bFM4_USB1_HFRAME_FRAME9                *((volatile unsigned char*)(0x42A42324UL))
#define bFM4_USB1_HFRAME_FRAME10               *((volatile unsigned char*)(0x42A42328UL))
#define bFM4_USB1_HFRAME0_FRAME00              *((volatile unsigned char*)(0x42A42300UL))
#define bFM4_USB1_HFRAME0_FRAME01              *((volatile unsigned char*)(0x42A42304UL))
#define bFM4_USB1_HFRAME0_FRAME02              *((volatile unsigned char*)(0x42A42308UL))
#define bFM4_USB1_HFRAME0_FRAME03              *((volatile unsigned char*)(0x42A4230CUL))
#define bFM4_USB1_HFRAME0_FRAME04              *((volatile unsigned char*)(0x42A42310UL))
#define bFM4_USB1_HFRAME0_FRAME05              *((volatile unsigned char*)(0x42A42314UL))
#define bFM4_USB1_HFRAME0_FRAME06              *((volatile unsigned char*)(0x42A42318UL))
#define bFM4_USB1_HFRAME0_FRAME07              *((volatile unsigned char*)(0x42A4231CUL))
#define bFM4_USB1_HFRAME1_FRAME10              *((volatile unsigned char*)(0x42A42320UL))
#define bFM4_USB1_HFRAME1_FRAME11              *((volatile unsigned char*)(0x42A42324UL))
#define bFM4_USB1_HFRAME1_FRAME12              *((volatile unsigned char*)(0x42A42328UL))
#define bFM4_USB1_HFRAME1_FRAME13              *((volatile unsigned char*)(0x42A4232CUL))
#define bFM4_USB1_HTOKEN_ENDPT0                *((volatile unsigned char*)(0x42A42380UL))
#define bFM4_USB1_HTOKEN_ENDPT1                *((volatile unsigned char*)(0x42A42384UL))
#define bFM4_USB1_HTOKEN_ENDPT2                *((volatile unsigned char*)(0x42A42388UL))
#define bFM4_USB1_HTOKEN_ENDPT3                *((volatile unsigned char*)(0x42A4238CUL))
#define bFM4_USB1_HTOKEN_TKNEN0                *((volatile unsigned char*)(0x42A42390UL))
#define bFM4_USB1_HTOKEN_TKNEN1                *((volatile unsigned char*)(0x42A42394UL))
#define bFM4_USB1_HTOKEN_TKNEN2                *((volatile unsigned char*)(0x42A42398UL))
#define bFM4_USB1_HTOKEN_TGGL                  *((volatile unsigned char*)(0x42A4239CUL))
#define bFM4_USB1_UDCC_PWC                     *((volatile unsigned char*)(0x42A42400UL))
#define bFM4_USB1_UDCC_RFBK                    *((volatile unsigned char*)(0x42A42404UL))
#define bFM4_USB1_UDCC_STALCLREN               *((volatile unsigned char*)(0x42A4240CUL))
#define bFM4_USB1_UDCC_USTP                    *((volatile unsigned char*)(0x42A42410UL))
#define bFM4_USB1_UDCC_HCONX                   *((volatile unsigned char*)(0x42A42414UL))
#define bFM4_USB1_UDCC_RESUM                   *((volatile unsigned char*)(0x42A42418UL))
#define bFM4_USB1_UDCC_RST                     *((volatile unsigned char*)(0x42A4241CUL))
#define bFM4_USB1_EP0C_PKS00                   *((volatile unsigned int*)(0x42A42480UL))
#define bFM4_USB1_EP0C_PKS01                   *((volatile unsigned int*)(0x42A42484UL))
#define bFM4_USB1_EP0C_PKS02                   *((volatile unsigned int*)(0x42A42488UL))
#define bFM4_USB1_EP0C_PKS03                   *((volatile unsigned int*)(0x42A4248CUL))
#define bFM4_USB1_EP0C_PKS04                   *((volatile unsigned int*)(0x42A42490UL))
#define bFM4_USB1_EP0C_PKS05                   *((volatile unsigned int*)(0x42A42494UL))
#define bFM4_USB1_EP0C_PKS06                   *((volatile unsigned int*)(0x42A42498UL))
#define bFM4_USB1_EP0C_STAL                    *((volatile unsigned int*)(0x42A424A4UL))
#define bFM4_USB1_EP1C_PKS10                   *((volatile unsigned int*)(0x42A42500UL))
#define bFM4_USB1_EP1C_PKS11                   *((volatile unsigned int*)(0x42A42504UL))
#define bFM4_USB1_EP1C_PKS12                   *((volatile unsigned int*)(0x42A42508UL))
#define bFM4_USB1_EP1C_PKS13                   *((volatile unsigned int*)(0x42A4250CUL))
#define bFM4_USB1_EP1C_PKS14                   *((volatile unsigned int*)(0x42A42510UL))
#define bFM4_USB1_EP1C_PKS15                   *((volatile unsigned int*)(0x42A42514UL))
#define bFM4_USB1_EP1C_PKS16                   *((volatile unsigned int*)(0x42A42518UL))
#define bFM4_USB1_EP1C_PKS17                   *((volatile unsigned int*)(0x42A4251CUL))
#define bFM4_USB1_EP1C_PKS18                   *((volatile unsigned int*)(0x42A42520UL))
#define bFM4_USB1_EP1C_STAL                    *((volatile unsigned int*)(0x42A42524UL))
#define bFM4_USB1_EP1C_NULE                    *((volatile unsigned int*)(0x42A42528UL))
#define bFM4_USB1_EP1C_DMAE                    *((volatile unsigned int*)(0x42A4252CUL))
#define bFM4_USB1_EP1C_DIR                     *((volatile unsigned int*)(0x42A42530UL))
#define bFM4_USB1_EP1C_TYPE0                   *((volatile unsigned int*)(0x42A42534UL))
#define bFM4_USB1_EP1C_TYPE1                   *((volatile unsigned int*)(0x42A42538UL))
#define bFM4_USB1_EP1C_EPEN                    *((volatile unsigned int*)(0x42A4253CUL))
#define bFM4_USB1_EP2C_PKS20                   *((volatile unsigned int*)(0x42A42580UL))
#define bFM4_USB1_EP2C_PKS21                   *((volatile unsigned int*)(0x42A42584UL))
#define bFM4_USB1_EP2C_PKS22                   *((volatile unsigned int*)(0x42A42588UL))
#define bFM4_USB1_EP2C_PKS23                   *((volatile unsigned int*)(0x42A4258CUL))
#define bFM4_USB1_EP2C_PKS24                   *((volatile unsigned int*)(0x42A42590UL))
#define bFM4_USB1_EP2C_PKS25                   *((volatile unsigned int*)(0x42A42594UL))
#define bFM4_USB1_EP2C_PKS26                   *((volatile unsigned int*)(0x42A42598UL))
#define bFM4_USB1_EP2C_STAL                    *((volatile unsigned int*)(0x42A425A4UL))
#define bFM4_USB1_EP2C_NULE                    *((volatile unsigned int*)(0x42A425A8UL))
#define bFM4_USB1_EP2C_DMAE                    *((volatile unsigned int*)(0x42A425ACUL))
#define bFM4_USB1_EP2C_DIR                     *((volatile unsigned int*)(0x42A425B0UL))
#define bFM4_USB1_EP2C_TYPE0                   *((volatile unsigned int*)(0x42A425B4UL))
#define bFM4_USB1_EP2C_TYPE1                   *((volatile unsigned int*)(0x42A425B8UL))
#define bFM4_USB1_EP2C_EPEN                    *((volatile unsigned int*)(0x42A425BCUL))
#define bFM4_USB1_EP3C_PKS30                   *((volatile unsigned int*)(0x42A42600UL))
#define bFM4_USB1_EP3C_PKS31                   *((volatile unsigned int*)(0x42A42604UL))
#define bFM4_USB1_EP3C_PKS32                   *((volatile unsigned int*)(0x42A42608UL))
#define bFM4_USB1_EP3C_PKS33                   *((volatile unsigned int*)(0x42A4260CUL))
#define bFM4_USB1_EP3C_PKS34                   *((volatile unsigned int*)(0x42A42610UL))
#define bFM4_USB1_EP3C_PKS35                   *((volatile unsigned int*)(0x42A42614UL))
#define bFM4_USB1_EP3C_PKS36                   *((volatile unsigned int*)(0x42A42618UL))
#define bFM4_USB1_EP3C_STAL                    *((volatile unsigned int*)(0x42A42624UL))
#define bFM4_USB1_EP3C_NULE                    *((volatile unsigned int*)(0x42A42628UL))
#define bFM4_USB1_EP3C_DMAE                    *((volatile unsigned int*)(0x42A4262CUL))
#define bFM4_USB1_EP3C_DIR                     *((volatile unsigned int*)(0x42A42630UL))
#define bFM4_USB1_EP3C_TYPE0                   *((volatile unsigned int*)(0x42A42634UL))
#define bFM4_USB1_EP3C_TYPE1                   *((volatile unsigned int*)(0x42A42638UL))
#define bFM4_USB1_EP3C_EPEN                    *((volatile unsigned int*)(0x42A4263CUL))
#define bFM4_USB1_EP4C_PKS40                   *((volatile unsigned int*)(0x42A42680UL))
#define bFM4_USB1_EP4C_PKS41                   *((volatile unsigned int*)(0x42A42684UL))
#define bFM4_USB1_EP4C_PKS42                   *((volatile unsigned int*)(0x42A42688UL))
#define bFM4_USB1_EP4C_PKS43                   *((volatile unsigned int*)(0x42A4268CUL))
#define bFM4_USB1_EP4C_PKS44                   *((volatile unsigned int*)(0x42A42690UL))
#define bFM4_USB1_EP4C_PKS45                   *((volatile unsigned int*)(0x42A42694UL))
#define bFM4_USB1_EP4C_PKS46                   *((volatile unsigned int*)(0x42A42698UL))
#define bFM4_USB1_EP4C_STAL                    *((volatile unsigned int*)(0x42A426A4UL))
#define bFM4_USB1_EP4C_NULE                    *((volatile unsigned int*)(0x42A426A8UL))
#define bFM4_USB1_EP4C_DMAE                    *((volatile unsigned int*)(0x42A426ACUL))
#define bFM4_USB1_EP4C_DIR                     *((volatile unsigned int*)(0x42A426B0UL))
#define bFM4_USB1_EP4C_TYPE0                   *((volatile unsigned int*)(0x42A426B4UL))
#define bFM4_USB1_EP4C_TYPE1                   *((volatile unsigned int*)(0x42A426B8UL))
#define bFM4_USB1_EP4C_EPEN                    *((volatile unsigned int*)(0x42A426BCUL))
#define bFM4_USB1_EP5C_PKS50                   *((volatile unsigned int*)(0x42A42700UL))
#define bFM4_USB1_EP5C_PKS51                   *((volatile unsigned int*)(0x42A42704UL))
#define bFM4_USB1_EP5C_PKS52                   *((volatile unsigned int*)(0x42A42708UL))
#define bFM4_USB1_EP5C_PKS53                   *((volatile unsigned int*)(0x42A4270CUL))
#define bFM4_USB1_EP5C_PKS54                   *((volatile unsigned int*)(0x42A42710UL))
#define bFM4_USB1_EP5C_PKS55                   *((volatile unsigned int*)(0x42A42714UL))
#define bFM4_USB1_EP5C_PKS56                   *((volatile unsigned int*)(0x42A42718UL))
#define bFM4_USB1_EP5C_STAL                    *((volatile unsigned int*)(0x42A42724UL))
#define bFM4_USB1_EP5C_NULE                    *((volatile unsigned int*)(0x42A42728UL))
#define bFM4_USB1_EP5C_DMAE                    *((volatile unsigned int*)(0x42A4272CUL))
#define bFM4_USB1_EP5C_DIR                     *((volatile unsigned int*)(0x42A42730UL))
#define bFM4_USB1_EP5C_TYPE0                   *((volatile unsigned int*)(0x42A42734UL))
#define bFM4_USB1_EP5C_TYPE1                   *((volatile unsigned int*)(0x42A42738UL))
#define bFM4_USB1_EP5C_EPEN                    *((volatile unsigned int*)(0x42A4273CUL))
#define bFM4_USB1_TMSP_TMSP0                   *((volatile unsigned int*)(0x42A42780UL))
#define bFM4_USB1_TMSP_TMSP1                   *((volatile unsigned int*)(0x42A42784UL))
#define bFM4_USB1_TMSP_TMSP2                   *((volatile unsigned int*)(0x42A42788UL))
#define bFM4_USB1_TMSP_TMSP3                   *((volatile unsigned int*)(0x42A4278CUL))
#define bFM4_USB1_TMSP_TMSP4                   *((volatile unsigned int*)(0x42A42790UL))
#define bFM4_USB1_TMSP_TMSP5                   *((volatile unsigned int*)(0x42A42794UL))
#define bFM4_USB1_TMSP_TMSP6                   *((volatile unsigned int*)(0x42A42798UL))
#define bFM4_USB1_TMSP_TMSP7                   *((volatile unsigned int*)(0x42A4279CUL))
#define bFM4_USB1_TMSP_TMSP8                   *((volatile unsigned int*)(0x42A427A0UL))
#define bFM4_USB1_TMSP_TMSP9                   *((volatile unsigned int*)(0x42A427A4UL))
#define bFM4_USB1_TMSP_TMSP10                  *((volatile unsigned int*)(0x42A427A8UL))
#define bFM4_USB1_UDCS_CONF                    *((volatile unsigned char*)(0x42A42800UL))
#define bFM4_USB1_UDCS_SETP                    *((volatile unsigned char*)(0x42A42804UL))
#define bFM4_USB1_UDCS_WKUP                    *((volatile unsigned char*)(0x42A42808UL))
#define bFM4_USB1_UDCS_BRST                    *((volatile unsigned char*)(0x42A4280CUL))
#define bFM4_USB1_UDCS_SOF                     *((volatile unsigned char*)(0x42A42810UL))
#define bFM4_USB1_UDCS_SUSP                    *((volatile unsigned char*)(0x42A42814UL))
#define bFM4_USB1_UDCIE_CONFIE                 *((volatile unsigned char*)(0x42A42820UL))
#define bFM4_USB1_UDCIE_CONFN                  *((volatile unsigned char*)(0x42A42824UL))
#define bFM4_USB1_UDCIE_WKUPIE                 *((volatile unsigned char*)(0x42A42828UL))
#define bFM4_USB1_UDCIE_BRSTIE                 *((volatile unsigned char*)(0x42A4282CUL))
#define bFM4_USB1_UDCIE_SOFIE                  *((volatile unsigned char*)(0x42A42830UL))
#define bFM4_USB1_UDCIE_SUSPIE                 *((volatile unsigned char*)(0x42A42834UL))
#define bFM4_USB1_EP0IS_DRQI                   *((volatile unsigned int*)(0x42A428A8UL))
#define bFM4_USB1_EP0IS_DRQIIE                 *((volatile unsigned int*)(0x42A428B8UL))
#define bFM4_USB1_EP0IS_BFINI                  *((volatile unsigned int*)(0x42A428BCUL))
#define bFM4_USB1_EP0OS_SIZE0                  *((volatile unsigned int*)(0x42A42900UL))
#define bFM4_USB1_EP0OS_SIZE1                  *((volatile unsigned int*)(0x42A42904UL))
#define bFM4_USB1_EP0OS_SIZE2                  *((volatile unsigned int*)(0x42A42908UL))
#define bFM4_USB1_EP0OS_SIZE3                  *((volatile unsigned int*)(0x42A4290CUL))
#define bFM4_USB1_EP0OS_SIZE4                  *((volatile unsigned int*)(0x42A42910UL))
#define bFM4_USB1_EP0OS_SIZE5                  *((volatile unsigned int*)(0x42A42914UL))
#define bFM4_USB1_EP0OS_SIZE6                  *((volatile unsigned int*)(0x42A42918UL))
#define bFM4_USB1_EP0OS_SPK                    *((volatile unsigned int*)(0x42A42924UL))
#define bFM4_USB1_EP0OS_DRQO                   *((volatile unsigned int*)(0x42A42928UL))
#define bFM4_USB1_EP0OS_SPKIE                  *((volatile unsigned int*)(0x42A42934UL))
#define bFM4_USB1_EP0OS_DRQOIE                 *((volatile unsigned int*)(0x42A42938UL))
#define bFM4_USB1_EP0OS_BFINI                  *((volatile unsigned int*)(0x42A4293CUL))
#define bFM4_USB1_EP1S_SIZE10                  *((volatile unsigned int*)(0x42A42980UL))
#define bFM4_USB1_EP1S_SIZE11                  *((volatile unsigned int*)(0x42A42984UL))
#define bFM4_USB1_EP1S_SIZE12                  *((volatile unsigned int*)(0x42A42988UL))
#define bFM4_USB1_EP1S_SIZE13                  *((volatile unsigned int*)(0x42A4298CUL))
#define bFM4_USB1_EP1S_SIZE14                  *((volatile unsigned int*)(0x42A42990UL))
#define bFM4_USB1_EP1S_SIZE15                  *((volatile unsigned int*)(0x42A42994UL))
#define bFM4_USB1_EP1S_SIZE16                  *((volatile unsigned int*)(0x42A42998UL))
#define bFM4_USB1_EP1S_SIZE17                  *((volatile unsigned int*)(0x42A4299CUL))
#define bFM4_USB1_EP1S_SIZE18                  *((volatile unsigned int*)(0x42A429A0UL))
#define bFM4_USB1_EP1S_SPK                     *((volatile unsigned int*)(0x42A429A4UL))
#define bFM4_USB1_EP1S_DRQ                     *((volatile unsigned int*)(0x42A429A8UL))
#define bFM4_USB1_EP1S_BUSY                    *((volatile unsigned int*)(0x42A429ACUL))
#define bFM4_USB1_EP1S_SPKIE                   *((volatile unsigned int*)(0x42A429B4UL))
#define bFM4_USB1_EP1S_DRQIE                   *((volatile unsigned int*)(0x42A429B8UL))
#define bFM4_USB1_EP1S_BFINI                   *((volatile unsigned int*)(0x42A429BCUL))
#define bFM4_USB1_EP2S_SIZE20                  *((volatile unsigned int*)(0x42A42A00UL))
#define bFM4_USB1_EP2S_SIZE21                  *((volatile unsigned int*)(0x42A42A04UL))
#define bFM4_USB1_EP2S_SIZE22                  *((volatile unsigned int*)(0x42A42A08UL))
#define bFM4_USB1_EP2S_SIZE23                  *((volatile unsigned int*)(0x42A42A0CUL))
#define bFM4_USB1_EP2S_SIZE24                  *((volatile unsigned int*)(0x42A42A10UL))
#define bFM4_USB1_EP2S_SIZE25                  *((volatile unsigned int*)(0x42A42A14UL))
#define bFM4_USB1_EP2S_SIZE26                  *((volatile unsigned int*)(0x42A42A18UL))
#define bFM4_USB1_EP2S_SPK                     *((volatile unsigned int*)(0x42A42A24UL))
#define bFM4_USB1_EP2S_DRQ                     *((volatile unsigned int*)(0x42A42A28UL))
#define bFM4_USB1_EP2S_BUSY                    *((volatile unsigned int*)(0x42A42A2CUL))
#define bFM4_USB1_EP2S_SPKIE                   *((volatile unsigned int*)(0x42A42A34UL))
#define bFM4_USB1_EP2S_DRQIE                   *((volatile unsigned int*)(0x42A42A38UL))
#define bFM4_USB1_EP2S_BFINI                   *((volatile unsigned int*)(0x42A42A3CUL))
#define bFM4_USB1_EP3S_SIZE30                  *((volatile unsigned int*)(0x42A42A80UL))
#define bFM4_USB1_EP3S_SIZE31                  *((volatile unsigned int*)(0x42A42A84UL))
#define bFM4_USB1_EP3S_SIZE32                  *((volatile unsigned int*)(0x42A42A88UL))
#define bFM4_USB1_EP3S_SIZE33                  *((volatile unsigned int*)(0x42A42A8CUL))
#define bFM4_USB1_EP3S_SIZE34                  *((volatile unsigned int*)(0x42A42A90UL))
#define bFM4_USB1_EP3S_SIZE35                  *((volatile unsigned int*)(0x42A42A94UL))
#define bFM4_USB1_EP3S_SIZE36                  *((volatile unsigned int*)(0x42A42A98UL))
#define bFM4_USB1_EP3S_SPK                     *((volatile unsigned int*)(0x42A42AA4UL))
#define bFM4_USB1_EP3S_DRQ                     *((volatile unsigned int*)(0x42A42AA8UL))
#define bFM4_USB1_EP3S_BUSY                    *((volatile unsigned int*)(0x42A42AACUL))
#define bFM4_USB1_EP3S_SPKIE                   *((volatile unsigned int*)(0x42A42AB4UL))
#define bFM4_USB1_EP3S_DRQIE                   *((volatile unsigned int*)(0x42A42AB8UL))
#define bFM4_USB1_EP3S_BFINI                   *((volatile unsigned int*)(0x42A42ABCUL))
#define bFM4_USB1_EP4S_SIZE40                  *((volatile unsigned int*)(0x42A42B00UL))
#define bFM4_USB1_EP4S_SIZE41                  *((volatile unsigned int*)(0x42A42B04UL))
#define bFM4_USB1_EP4S_SIZE42                  *((volatile unsigned int*)(0x42A42B08UL))
#define bFM4_USB1_EP4S_SIZE43                  *((volatile unsigned int*)(0x42A42B0CUL))
#define bFM4_USB1_EP4S_SIZE44                  *((volatile unsigned int*)(0x42A42B10UL))
#define bFM4_USB1_EP4S_SIZE45                  *((volatile unsigned int*)(0x42A42B14UL))
#define bFM4_USB1_EP4S_SIZE46                  *((volatile unsigned int*)(0x42A42B18UL))
#define bFM4_USB1_EP4S_SPK                     *((volatile unsigned int*)(0x42A42B24UL))
#define bFM4_USB1_EP4S_DRQ                     *((volatile unsigned int*)(0x42A42B28UL))
#define bFM4_USB1_EP4S_BUSY                    *((volatile unsigned int*)(0x42A42B2CUL))
#define bFM4_USB1_EP4S_SPKIE                   *((volatile unsigned int*)(0x42A42B34UL))
#define bFM4_USB1_EP4S_DRQIE                   *((volatile unsigned int*)(0x42A42B38UL))
#define bFM4_USB1_EP4S_BFINI                   *((volatile unsigned int*)(0x42A42B3CUL))
#define bFM4_USB1_EP5S_SIZE50                  *((volatile unsigned int*)(0x42A42B80UL))
#define bFM4_USB1_EP5S_SIZE51                  *((volatile unsigned int*)(0x42A42B84UL))
#define bFM4_USB1_EP5S_SIZE52                  *((volatile unsigned int*)(0x42A42B88UL))
#define bFM4_USB1_EP5S_SIZE53                  *((volatile unsigned int*)(0x42A42B8CUL))
#define bFM4_USB1_EP5S_SIZE54                  *((volatile unsigned int*)(0x42A42B90UL))
#define bFM4_USB1_EP5S_SIZE55                  *((volatile unsigned int*)(0x42A42B94UL))
#define bFM4_USB1_EP5S_SIZE56                  *((volatile unsigned int*)(0x42A42B98UL))
#define bFM4_USB1_EP5S_SPK                     *((volatile unsigned int*)(0x42A42BA4UL))
#define bFM4_USB1_EP5S_DRQ                     *((volatile unsigned int*)(0x42A42BA8UL))
#define bFM4_USB1_EP5S_BUSY                    *((volatile unsigned int*)(0x42A42BACUL))
#define bFM4_USB1_EP5S_SPKIE                   *((volatile unsigned int*)(0x42A42BB4UL))
#define bFM4_USB1_EP5S_DRQIE                   *((volatile unsigned int*)(0x42A42BB8UL))
#define bFM4_USB1_EP5S_BFINI                   *((volatile unsigned int*)(0x42A42BBCUL))

/* DMA controller */
#define bFM4_DMAC_DMACR_DH0                    *((volatile unsigned char*)(0x42C00060UL))
#define bFM4_DMAC_DMACR_DH1                    *((volatile unsigned char*)(0x42C00064UL))
#define bFM4_DMAC_DMACR_DH2                    *((volatile unsigned char*)(0x42C00068UL))
#define bFM4_DMAC_DMACR_DH3                    *((volatile unsigned char*)(0x42C0006CUL))
#define bFM4_DMAC_DMACR_PR                     *((volatile unsigned char*)(0x42C00070UL))
#define bFM4_DMAC_DMACR_DS                     *((volatile unsigned char*)(0x42C00078UL))
#define bFM4_DMAC_DMACR_DE                     *((volatile unsigned char*)(0x42C0007CUL))
#define bFM4_DMAC_DMACA0_TC0                   *((volatile unsigned char*)(0x42C00200UL))
#define bFM4_DMAC_DMACA0_TC1                   *((volatile unsigned char*)(0x42C00204UL))
#define bFM4_DMAC_DMACA0_TC2                   *((volatile unsigned char*)(0x42C00208UL))
#define bFM4_DMAC_DMACA0_TC3                   *((volatile unsigned char*)(0x42C0020CUL))
#define bFM4_DMAC_DMACA0_TC4                   *((volatile unsigned char*)(0x42C00210UL))
#define bFM4_DMAC_DMACA0_TC5                   *((volatile unsigned char*)(0x42C00214UL))
#define bFM4_DMAC_DMACA0_TC6                   *((volatile unsigned char*)(0x42C00218UL))
#define bFM4_DMAC_DMACA0_TC7                   *((volatile unsigned char*)(0x42C0021CUL))
#define bFM4_DMAC_DMACA0_TC8                   *((volatile unsigned char*)(0x42C00220UL))
#define bFM4_DMAC_DMACA0_TC9                   *((volatile unsigned char*)(0x42C00224UL))
#define bFM4_DMAC_DMACA0_TC10                  *((volatile unsigned char*)(0x42C00228UL))
#define bFM4_DMAC_DMACA0_TC11                  *((volatile unsigned char*)(0x42C0022CUL))
#define bFM4_DMAC_DMACA0_TC12                  *((volatile unsigned char*)(0x42C00230UL))
#define bFM4_DMAC_DMACA0_TC13                  *((volatile unsigned char*)(0x42C00234UL))
#define bFM4_DMAC_DMACA0_TC14                  *((volatile unsigned char*)(0x42C00238UL))
#define bFM4_DMAC_DMACA0_TC15                  *((volatile unsigned char*)(0x42C0023CUL))
#define bFM4_DMAC_DMACA0_BC0                   *((volatile unsigned char*)(0x42C00240UL))
#define bFM4_DMAC_DMACA0_BC1                   *((volatile unsigned char*)(0x42C00244UL))
#define bFM4_DMAC_DMACA0_BC2                   *((volatile unsigned char*)(0x42C00248UL))
#define bFM4_DMAC_DMACA0_BC3                   *((volatile unsigned char*)(0x42C0024CUL))
#define bFM4_DMAC_DMACA0_IS0                   *((volatile unsigned char*)(0x42C0025CUL))
#define bFM4_DMAC_DMACA0_IS1                   *((volatile unsigned char*)(0x42C00260UL))
#define bFM4_DMAC_DMACA0_IS2                   *((volatile unsigned char*)(0x42C00264UL))
#define bFM4_DMAC_DMACA0_IS3                   *((volatile unsigned char*)(0x42C00268UL))
#define bFM4_DMAC_DMACA0_IS4                   *((volatile unsigned char*)(0x42C0026CUL))
#define bFM4_DMAC_DMACA0_IS5                   *((volatile unsigned char*)(0x42C00270UL))
#define bFM4_DMAC_DMACA0_ST                    *((volatile unsigned char*)(0x42C00274UL))
#define bFM4_DMAC_DMACA0_PB                    *((volatile unsigned char*)(0x42C00278UL))
#define bFM4_DMAC_DMACA0_EB                    *((volatile unsigned char*)(0x42C0027CUL))
#define bFM4_DMAC_DMACB0_EM                    *((volatile unsigned char*)(0x42C00280UL))
#define bFM4_DMAC_DMACB0_SS0                   *((volatile unsigned char*)(0x42C002C0UL))
#define bFM4_DMAC_DMACB0_SS1                   *((volatile unsigned char*)(0x42C002C4UL))
#define bFM4_DMAC_DMACB0_SS2                   *((volatile unsigned char*)(0x42C002C8UL))
#define bFM4_DMAC_DMACB0_CI                    *((volatile unsigned char*)(0x42C002CCUL))
#define bFM4_DMAC_DMACB0_EI                    *((volatile unsigned char*)(0x42C002D0UL))
#define bFM4_DMAC_DMACB0_RD                    *((volatile unsigned char*)(0x42C002D4UL))
#define bFM4_DMAC_DMACB0_RS                    *((volatile unsigned char*)(0x42C002D8UL))
#define bFM4_DMAC_DMACB0_RC                    *((volatile unsigned char*)(0x42C002DCUL))
#define bFM4_DMAC_DMACB0_FD                    *((volatile unsigned char*)(0x42C002E0UL))
#define bFM4_DMAC_DMACB0_FS                    *((volatile unsigned char*)(0x42C002E4UL))
#define bFM4_DMAC_DMACB0_TW0                   *((volatile unsigned char*)(0x42C002E8UL))
#define bFM4_DMAC_DMACB0_TW1                   *((volatile unsigned char*)(0x42C002ECUL))
#define bFM4_DMAC_DMACB0_MS0                   *((volatile unsigned char*)(0x42C002F0UL))
#define bFM4_DMAC_DMACB0_MS1                   *((volatile unsigned char*)(0x42C002F4UL))
#define bFM4_DMAC_DMACA1_TC0                   *((volatile unsigned char*)(0x42C00400UL))
#define bFM4_DMAC_DMACA1_TC1                   *((volatile unsigned char*)(0x42C00404UL))
#define bFM4_DMAC_DMACA1_TC2                   *((volatile unsigned char*)(0x42C00408UL))
#define bFM4_DMAC_DMACA1_TC3                   *((volatile unsigned char*)(0x42C0040CUL))
#define bFM4_DMAC_DMACA1_TC4                   *((volatile unsigned char*)(0x42C00410UL))
#define bFM4_DMAC_DMACA1_TC5                   *((volatile unsigned char*)(0x42C00414UL))
#define bFM4_DMAC_DMACA1_TC6                   *((volatile unsigned char*)(0x42C00418UL))
#define bFM4_DMAC_DMACA1_TC7                   *((volatile unsigned char*)(0x42C0041CUL))
#define bFM4_DMAC_DMACA1_TC8                   *((volatile unsigned char*)(0x42C00420UL))
#define bFM4_DMAC_DMACA1_TC9                   *((volatile unsigned char*)(0x42C00424UL))
#define bFM4_DMAC_DMACA1_TC10                  *((volatile unsigned char*)(0x42C00428UL))
#define bFM4_DMAC_DMACA1_TC11                  *((volatile unsigned char*)(0x42C0042CUL))
#define bFM4_DMAC_DMACA1_TC12                  *((volatile unsigned char*)(0x42C00430UL))
#define bFM4_DMAC_DMACA1_TC13                  *((volatile unsigned char*)(0x42C00434UL))
#define bFM4_DMAC_DMACA1_TC14                  *((volatile unsigned char*)(0x42C00438UL))
#define bFM4_DMAC_DMACA1_TC15                  *((volatile unsigned char*)(0x42C0043CUL))
#define bFM4_DMAC_DMACA1_BC0                   *((volatile unsigned char*)(0x42C00440UL))
#define bFM4_DMAC_DMACA1_BC1                   *((volatile unsigned char*)(0x42C00444UL))
#define bFM4_DMAC_DMACA1_BC2                   *((volatile unsigned char*)(0x42C00448UL))
#define bFM4_DMAC_DMACA1_BC3                   *((volatile unsigned char*)(0x42C0044CUL))
#define bFM4_DMAC_DMACA1_IS0                   *((volatile unsigned char*)(0x42C0045CUL))
#define bFM4_DMAC_DMACA1_IS1                   *((volatile unsigned char*)(0x42C00460UL))
#define bFM4_DMAC_DMACA1_IS2                   *((volatile unsigned char*)(0x42C00464UL))
#define bFM4_DMAC_DMACA1_IS3                   *((volatile unsigned char*)(0x42C00468UL))
#define bFM4_DMAC_DMACA1_IS4                   *((volatile unsigned char*)(0x42C0046CUL))
#define bFM4_DMAC_DMACA1_IS5                   *((volatile unsigned char*)(0x42C00470UL))
#define bFM4_DMAC_DMACA1_ST                    *((volatile unsigned char*)(0x42C00474UL))
#define bFM4_DMAC_DMACA1_PB                    *((volatile unsigned char*)(0x42C00478UL))
#define bFM4_DMAC_DMACA1_EB                    *((volatile unsigned char*)(0x42C0047CUL))
#define bFM4_DMAC_DMACB1_EM                    *((volatile unsigned char*)(0x42C00480UL))
#define bFM4_DMAC_DMACB1_SS0                   *((volatile unsigned char*)(0x42C004C0UL))
#define bFM4_DMAC_DMACB1_SS1                   *((volatile unsigned char*)(0x42C004C4UL))
#define bFM4_DMAC_DMACB1_SS2                   *((volatile unsigned char*)(0x42C004C8UL))
#define bFM4_DMAC_DMACB1_CI                    *((volatile unsigned char*)(0x42C004CCUL))
#define bFM4_DMAC_DMACB1_EI                    *((volatile unsigned char*)(0x42C004D0UL))
#define bFM4_DMAC_DMACB1_RD                    *((volatile unsigned char*)(0x42C004D4UL))
#define bFM4_DMAC_DMACB1_RS                    *((volatile unsigned char*)(0x42C004D8UL))
#define bFM4_DMAC_DMACB1_RC                    *((volatile unsigned char*)(0x42C004DCUL))
#define bFM4_DMAC_DMACB1_FD                    *((volatile unsigned char*)(0x42C004E0UL))
#define bFM4_DMAC_DMACB1_FS                    *((volatile unsigned char*)(0x42C004E4UL))
#define bFM4_DMAC_DMACB1_TW0                   *((volatile unsigned char*)(0x42C004E8UL))
#define bFM4_DMAC_DMACB1_TW1                   *((volatile unsigned char*)(0x42C004ECUL))
#define bFM4_DMAC_DMACB1_MS0                   *((volatile unsigned char*)(0x42C004F0UL))
#define bFM4_DMAC_DMACB1_MS1                   *((volatile unsigned char*)(0x42C004F4UL))
#define bFM4_DMAC_DMACA2_TC0                   *((volatile unsigned char*)(0x42C00600UL))
#define bFM4_DMAC_DMACA2_TC1                   *((volatile unsigned char*)(0x42C00604UL))
#define bFM4_DMAC_DMACA2_TC2                   *((volatile unsigned char*)(0x42C00608UL))
#define bFM4_DMAC_DMACA2_TC3                   *((volatile unsigned char*)(0x42C0060CUL))
#define bFM4_DMAC_DMACA2_TC4                   *((volatile unsigned char*)(0x42C00610UL))
#define bFM4_DMAC_DMACA2_TC5                   *((volatile unsigned char*)(0x42C00614UL))
#define bFM4_DMAC_DMACA2_TC6                   *((volatile unsigned char*)(0x42C00618UL))
#define bFM4_DMAC_DMACA2_TC7                   *((volatile unsigned char*)(0x42C0061CUL))
#define bFM4_DMAC_DMACA2_TC8                   *((volatile unsigned char*)(0x42C00620UL))
#define bFM4_DMAC_DMACA2_TC9                   *((volatile unsigned char*)(0x42C00624UL))
#define bFM4_DMAC_DMACA2_TC10                  *((volatile unsigned char*)(0x42C00628UL))
#define bFM4_DMAC_DMACA2_TC11                  *((volatile unsigned char*)(0x42C0062CUL))
#define bFM4_DMAC_DMACA2_TC12                  *((volatile unsigned char*)(0x42C00630UL))
#define bFM4_DMAC_DMACA2_TC13                  *((volatile unsigned char*)(0x42C00634UL))
#define bFM4_DMAC_DMACA2_TC14                  *((volatile unsigned char*)(0x42C00638UL))
#define bFM4_DMAC_DMACA2_TC15                  *((volatile unsigned char*)(0x42C0063CUL))
#define bFM4_DMAC_DMACA2_BC0                   *((volatile unsigned char*)(0x42C00640UL))
#define bFM4_DMAC_DMACA2_BC1                   *((volatile unsigned char*)(0x42C00644UL))
#define bFM4_DMAC_DMACA2_BC2                   *((volatile unsigned char*)(0x42C00648UL))
#define bFM4_DMAC_DMACA2_BC3                   *((volatile unsigned char*)(0x42C0064CUL))
#define bFM4_DMAC_DMACA2_IS0                   *((volatile unsigned char*)(0x42C0065CUL))
#define bFM4_DMAC_DMACA2_IS1                   *((volatile unsigned char*)(0x42C00660UL))
#define bFM4_DMAC_DMACA2_IS2                   *((volatile unsigned char*)(0x42C00664UL))
#define bFM4_DMAC_DMACA2_IS3                   *((volatile unsigned char*)(0x42C00668UL))
#define bFM4_DMAC_DMACA2_IS4                   *((volatile unsigned char*)(0x42C0066CUL))
#define bFM4_DMAC_DMACA2_IS5                   *((volatile unsigned char*)(0x42C00670UL))
#define bFM4_DMAC_DMACA2_ST                    *((volatile unsigned char*)(0x42C00674UL))
#define bFM4_DMAC_DMACA2_PB                    *((volatile unsigned char*)(0x42C00678UL))
#define bFM4_DMAC_DMACA2_EB                    *((volatile unsigned char*)(0x42C0067CUL))
#define bFM4_DMAC_DMACB2_EM                    *((volatile unsigned char*)(0x42C00680UL))
#define bFM4_DMAC_DMACB2_SS0                   *((volatile unsigned char*)(0x42C006C0UL))
#define bFM4_DMAC_DMACB2_SS1                   *((volatile unsigned char*)(0x42C006C4UL))
#define bFM4_DMAC_DMACB2_SS2                   *((volatile unsigned char*)(0x42C006C8UL))
#define bFM4_DMAC_DMACB2_CI                    *((volatile unsigned char*)(0x42C006CCUL))
#define bFM4_DMAC_DMACB2_EI                    *((volatile unsigned char*)(0x42C006D0UL))
#define bFM4_DMAC_DMACB2_RD                    *((volatile unsigned char*)(0x42C006D4UL))
#define bFM4_DMAC_DMACB2_RS                    *((volatile unsigned char*)(0x42C006D8UL))
#define bFM4_DMAC_DMACB2_RC                    *((volatile unsigned char*)(0x42C006DCUL))
#define bFM4_DMAC_DMACB2_FD                    *((volatile unsigned char*)(0x42C006E0UL))
#define bFM4_DMAC_DMACB2_FS                    *((volatile unsigned char*)(0x42C006E4UL))
#define bFM4_DMAC_DMACB2_TW0                   *((volatile unsigned char*)(0x42C006E8UL))
#define bFM4_DMAC_DMACB2_TW1                   *((volatile unsigned char*)(0x42C006ECUL))
#define bFM4_DMAC_DMACB2_MS0                   *((volatile unsigned char*)(0x42C006F0UL))
#define bFM4_DMAC_DMACB2_MS1                   *((volatile unsigned char*)(0x42C006F4UL))
#define bFM4_DMAC_DMACA3_TC0                   *((volatile unsigned char*)(0x42C00800UL))
#define bFM4_DMAC_DMACA3_TC1                   *((volatile unsigned char*)(0x42C00804UL))
#define bFM4_DMAC_DMACA3_TC2                   *((volatile unsigned char*)(0x42C00808UL))
#define bFM4_DMAC_DMACA3_TC3                   *((volatile unsigned char*)(0x42C0080CUL))
#define bFM4_DMAC_DMACA3_TC4                   *((volatile unsigned char*)(0x42C00810UL))
#define bFM4_DMAC_DMACA3_TC5                   *((volatile unsigned char*)(0x42C00814UL))
#define bFM4_DMAC_DMACA3_TC6                   *((volatile unsigned char*)(0x42C00818UL))
#define bFM4_DMAC_DMACA3_TC7                   *((volatile unsigned char*)(0x42C0081CUL))
#define bFM4_DMAC_DMACA3_TC8                   *((volatile unsigned char*)(0x42C00820UL))
#define bFM4_DMAC_DMACA3_TC9                   *((volatile unsigned char*)(0x42C00824UL))
#define bFM4_DMAC_DMACA3_TC10                  *((volatile unsigned char*)(0x42C00828UL))
#define bFM4_DMAC_DMACA3_TC11                  *((volatile unsigned char*)(0x42C0082CUL))
#define bFM4_DMAC_DMACA3_TC12                  *((volatile unsigned char*)(0x42C00830UL))
#define bFM4_DMAC_DMACA3_TC13                  *((volatile unsigned char*)(0x42C00834UL))
#define bFM4_DMAC_DMACA3_TC14                  *((volatile unsigned char*)(0x42C00838UL))
#define bFM4_DMAC_DMACA3_TC15                  *((volatile unsigned char*)(0x42C0083CUL))
#define bFM4_DMAC_DMACA3_BC0                   *((volatile unsigned char*)(0x42C00840UL))
#define bFM4_DMAC_DMACA3_BC1                   *((volatile unsigned char*)(0x42C00844UL))
#define bFM4_DMAC_DMACA3_BC2                   *((volatile unsigned char*)(0x42C00848UL))
#define bFM4_DMAC_DMACA3_BC3                   *((volatile unsigned char*)(0x42C0084CUL))
#define bFM4_DMAC_DMACA3_IS0                   *((volatile unsigned char*)(0x42C0085CUL))
#define bFM4_DMAC_DMACA3_IS1                   *((volatile unsigned char*)(0x42C00860UL))
#define bFM4_DMAC_DMACA3_IS2                   *((volatile unsigned char*)(0x42C00864UL))
#define bFM4_DMAC_DMACA3_IS3                   *((volatile unsigned char*)(0x42C00868UL))
#define bFM4_DMAC_DMACA3_IS4                   *((volatile unsigned char*)(0x42C0086CUL))
#define bFM4_DMAC_DMACA3_IS5                   *((volatile unsigned char*)(0x42C00870UL))
#define bFM4_DMAC_DMACA3_ST                    *((volatile unsigned char*)(0x42C00874UL))
#define bFM4_DMAC_DMACA3_PB                    *((volatile unsigned char*)(0x42C00878UL))
#define bFM4_DMAC_DMACA3_EB                    *((volatile unsigned char*)(0x42C0087CUL))
#define bFM4_DMAC_DMACB3_EM                    *((volatile unsigned char*)(0x42C00880UL))
#define bFM4_DMAC_DMACB3_SS0                   *((volatile unsigned char*)(0x42C008C0UL))
#define bFM4_DMAC_DMACB3_SS1                   *((volatile unsigned char*)(0x42C008C4UL))
#define bFM4_DMAC_DMACB3_SS2                   *((volatile unsigned char*)(0x42C008C8UL))
#define bFM4_DMAC_DMACB3_CI                    *((volatile unsigned char*)(0x42C008CCUL))
#define bFM4_DMAC_DMACB3_EI                    *((volatile unsigned char*)(0x42C008D0UL))
#define bFM4_DMAC_DMACB3_RD                    *((volatile unsigned char*)(0x42C008D4UL))
#define bFM4_DMAC_DMACB3_RS                    *((volatile unsigned char*)(0x42C008D8UL))
#define bFM4_DMAC_DMACB3_RC                    *((volatile unsigned char*)(0x42C008DCUL))
#define bFM4_DMAC_DMACB3_FD                    *((volatile unsigned char*)(0x42C008E0UL))
#define bFM4_DMAC_DMACB3_FS                    *((volatile unsigned char*)(0x42C008E4UL))
#define bFM4_DMAC_DMACB3_TW0                   *((volatile unsigned char*)(0x42C008E8UL))
#define bFM4_DMAC_DMACB3_TW1                   *((volatile unsigned char*)(0x42C008ECUL))
#define bFM4_DMAC_DMACB3_MS0                   *((volatile unsigned char*)(0x42C008F0UL))
#define bFM4_DMAC_DMACB3_MS1                   *((volatile unsigned char*)(0x42C008F4UL))
#define bFM4_DMAC_DMACA4_TC0                   *((volatile unsigned char*)(0x42C00A00UL))
#define bFM4_DMAC_DMACA4_TC1                   *((volatile unsigned char*)(0x42C00A04UL))
#define bFM4_DMAC_DMACA4_TC2                   *((volatile unsigned char*)(0x42C00A08UL))
#define bFM4_DMAC_DMACA4_TC3                   *((volatile unsigned char*)(0x42C00A0CUL))
#define bFM4_DMAC_DMACA4_TC4                   *((volatile unsigned char*)(0x42C00A10UL))
#define bFM4_DMAC_DMACA4_TC5                   *((volatile unsigned char*)(0x42C00A14UL))
#define bFM4_DMAC_DMACA4_TC6                   *((volatile unsigned char*)(0x42C00A18UL))
#define bFM4_DMAC_DMACA4_TC7                   *((volatile unsigned char*)(0x42C00A1CUL))
#define bFM4_DMAC_DMACA4_TC8                   *((volatile unsigned char*)(0x42C00A20UL))
#define bFM4_DMAC_DMACA4_TC9                   *((volatile unsigned char*)(0x42C00A24UL))
#define bFM4_DMAC_DMACA4_TC10                  *((volatile unsigned char*)(0x42C00A28UL))
#define bFM4_DMAC_DMACA4_TC11                  *((volatile unsigned char*)(0x42C00A2CUL))
#define bFM4_DMAC_DMACA4_TC12                  *((volatile unsigned char*)(0x42C00A30UL))
#define bFM4_DMAC_DMACA4_TC13                  *((volatile unsigned char*)(0x42C00A34UL))
#define bFM4_DMAC_DMACA4_TC14                  *((volatile unsigned char*)(0x42C00A38UL))
#define bFM4_DMAC_DMACA4_TC15                  *((volatile unsigned char*)(0x42C00A3CUL))
#define bFM4_DMAC_DMACA4_BC0                   *((volatile unsigned char*)(0x42C00A40UL))
#define bFM4_DMAC_DMACA4_BC1                   *((volatile unsigned char*)(0x42C00A44UL))
#define bFM4_DMAC_DMACA4_BC2                   *((volatile unsigned char*)(0x42C00A48UL))
#define bFM4_DMAC_DMACA4_BC3                   *((volatile unsigned char*)(0x42C00A4CUL))
#define bFM4_DMAC_DMACA4_IS0                   *((volatile unsigned char*)(0x42C00A5CUL))
#define bFM4_DMAC_DMACA4_IS1                   *((volatile unsigned char*)(0x42C00A60UL))
#define bFM4_DMAC_DMACA4_IS2                   *((volatile unsigned char*)(0x42C00A64UL))
#define bFM4_DMAC_DMACA4_IS3                   *((volatile unsigned char*)(0x42C00A68UL))
#define bFM4_DMAC_DMACA4_IS4                   *((volatile unsigned char*)(0x42C00A6CUL))
#define bFM4_DMAC_DMACA4_IS5                   *((volatile unsigned char*)(0x42C00A70UL))
#define bFM4_DMAC_DMACA4_ST                    *((volatile unsigned char*)(0x42C00A74UL))
#define bFM4_DMAC_DMACA4_PB                    *((volatile unsigned char*)(0x42C00A78UL))
#define bFM4_DMAC_DMACA4_EB                    *((volatile unsigned char*)(0x42C00A7CUL))
#define bFM4_DMAC_DMACB4_EM                    *((volatile unsigned char*)(0x42C00A80UL))
#define bFM4_DMAC_DMACB4_SS0                   *((volatile unsigned char*)(0x42C00AC0UL))
#define bFM4_DMAC_DMACB4_SS1                   *((volatile unsigned char*)(0x42C00AC4UL))
#define bFM4_DMAC_DMACB4_SS2                   *((volatile unsigned char*)(0x42C00AC8UL))
#define bFM4_DMAC_DMACB4_CI                    *((volatile unsigned char*)(0x42C00ACCUL))
#define bFM4_DMAC_DMACB4_EI                    *((volatile unsigned char*)(0x42C00AD0UL))
#define bFM4_DMAC_DMACB4_RD                    *((volatile unsigned char*)(0x42C00AD4UL))
#define bFM4_DMAC_DMACB4_RS                    *((volatile unsigned char*)(0x42C00AD8UL))
#define bFM4_DMAC_DMACB4_RC                    *((volatile unsigned char*)(0x42C00ADCUL))
#define bFM4_DMAC_DMACB4_FD                    *((volatile unsigned char*)(0x42C00AE0UL))
#define bFM4_DMAC_DMACB4_FS                    *((volatile unsigned char*)(0x42C00AE4UL))
#define bFM4_DMAC_DMACB4_TW0                   *((volatile unsigned char*)(0x42C00AE8UL))
#define bFM4_DMAC_DMACB4_TW1                   *((volatile unsigned char*)(0x42C00AECUL))
#define bFM4_DMAC_DMACB4_MS0                   *((volatile unsigned char*)(0x42C00AF0UL))
#define bFM4_DMAC_DMACB4_MS1                   *((volatile unsigned char*)(0x42C00AF4UL))
#define bFM4_DMAC_DMACA5_TC0                   *((volatile unsigned char*)(0x42C00C00UL))
#define bFM4_DMAC_DMACA5_TC1                   *((volatile unsigned char*)(0x42C00C04UL))
#define bFM4_DMAC_DMACA5_TC2                   *((volatile unsigned char*)(0x42C00C08UL))
#define bFM4_DMAC_DMACA5_TC3                   *((volatile unsigned char*)(0x42C00C0CUL))
#define bFM4_DMAC_DMACA5_TC4                   *((volatile unsigned char*)(0x42C00C10UL))
#define bFM4_DMAC_DMACA5_TC5                   *((volatile unsigned char*)(0x42C00C14UL))
#define bFM4_DMAC_DMACA5_TC6                   *((volatile unsigned char*)(0x42C00C18UL))
#define bFM4_DMAC_DMACA5_TC7                   *((volatile unsigned char*)(0x42C00C1CUL))
#define bFM4_DMAC_DMACA5_TC8                   *((volatile unsigned char*)(0x42C00C20UL))
#define bFM4_DMAC_DMACA5_TC9                   *((volatile unsigned char*)(0x42C00C24UL))
#define bFM4_DMAC_DMACA5_TC10                  *((volatile unsigned char*)(0x42C00C28UL))
#define bFM4_DMAC_DMACA5_TC11                  *((volatile unsigned char*)(0x42C00C2CUL))
#define bFM4_DMAC_DMACA5_TC12                  *((volatile unsigned char*)(0x42C00C30UL))
#define bFM4_DMAC_DMACA5_TC13                  *((volatile unsigned char*)(0x42C00C34UL))
#define bFM4_DMAC_DMACA5_TC14                  *((volatile unsigned char*)(0x42C00C38UL))
#define bFM4_DMAC_DMACA5_TC15                  *((volatile unsigned char*)(0x42C00C3CUL))
#define bFM4_DMAC_DMACA5_BC0                   *((volatile unsigned char*)(0x42C00C40UL))
#define bFM4_DMAC_DMACA5_BC1                   *((volatile unsigned char*)(0x42C00C44UL))
#define bFM4_DMAC_DMACA5_BC2                   *((volatile unsigned char*)(0x42C00C48UL))
#define bFM4_DMAC_DMACA5_BC3                   *((volatile unsigned char*)(0x42C00C4CUL))
#define bFM4_DMAC_DMACA5_IS0                   *((volatile unsigned char*)(0x42C00C5CUL))
#define bFM4_DMAC_DMACA5_IS1                   *((volatile unsigned char*)(0x42C00C60UL))
#define bFM4_DMAC_DMACA5_IS2                   *((volatile unsigned char*)(0x42C00C64UL))
#define bFM4_DMAC_DMACA5_IS3                   *((volatile unsigned char*)(0x42C00C68UL))
#define bFM4_DMAC_DMACA5_IS4                   *((volatile unsigned char*)(0x42C00C6CUL))
#define bFM4_DMAC_DMACA5_IS5                   *((volatile unsigned char*)(0x42C00C70UL))
#define bFM4_DMAC_DMACA5_ST                    *((volatile unsigned char*)(0x42C00C74UL))
#define bFM4_DMAC_DMACA5_PB                    *((volatile unsigned char*)(0x42C00C78UL))
#define bFM4_DMAC_DMACA5_EB                    *((volatile unsigned char*)(0x42C00C7CUL))
#define bFM4_DMAC_DMACB5_EM                    *((volatile unsigned char*)(0x42C00C80UL))
#define bFM4_DMAC_DMACB5_SS0                   *((volatile unsigned char*)(0x42C00CC0UL))
#define bFM4_DMAC_DMACB5_SS1                   *((volatile unsigned char*)(0x42C00CC4UL))
#define bFM4_DMAC_DMACB5_SS2                   *((volatile unsigned char*)(0x42C00CC8UL))
#define bFM4_DMAC_DMACB5_CI                    *((volatile unsigned char*)(0x42C00CCCUL))
#define bFM4_DMAC_DMACB5_EI                    *((volatile unsigned char*)(0x42C00CD0UL))
#define bFM4_DMAC_DMACB5_RD                    *((volatile unsigned char*)(0x42C00CD4UL))
#define bFM4_DMAC_DMACB5_RS                    *((volatile unsigned char*)(0x42C00CD8UL))
#define bFM4_DMAC_DMACB5_RC                    *((volatile unsigned char*)(0x42C00CDCUL))
#define bFM4_DMAC_DMACB5_FD                    *((volatile unsigned char*)(0x42C00CE0UL))
#define bFM4_DMAC_DMACB5_FS                    *((volatile unsigned char*)(0x42C00CE4UL))
#define bFM4_DMAC_DMACB5_TW0                   *((volatile unsigned char*)(0x42C00CE8UL))
#define bFM4_DMAC_DMACB5_TW1                   *((volatile unsigned char*)(0x42C00CECUL))
#define bFM4_DMAC_DMACB5_MS0                   *((volatile unsigned char*)(0x42C00CF0UL))
#define bFM4_DMAC_DMACB5_MS1                   *((volatile unsigned char*)(0x42C00CF4UL))
#define bFM4_DMAC_DMACA6_TC0                   *((volatile unsigned char*)(0x42C00E00UL))
#define bFM4_DMAC_DMACA6_TC1                   *((volatile unsigned char*)(0x42C00E04UL))
#define bFM4_DMAC_DMACA6_TC2                   *((volatile unsigned char*)(0x42C00E08UL))
#define bFM4_DMAC_DMACA6_TC3                   *((volatile unsigned char*)(0x42C00E0CUL))
#define bFM4_DMAC_DMACA6_TC4                   *((volatile unsigned char*)(0x42C00E10UL))
#define bFM4_DMAC_DMACA6_TC5                   *((volatile unsigned char*)(0x42C00E14UL))
#define bFM4_DMAC_DMACA6_TC6                   *((volatile unsigned char*)(0x42C00E18UL))
#define bFM4_DMAC_DMACA6_TC7                   *((volatile unsigned char*)(0x42C00E1CUL))
#define bFM4_DMAC_DMACA6_TC8                   *((volatile unsigned char*)(0x42C00E20UL))
#define bFM4_DMAC_DMACA6_TC9                   *((volatile unsigned char*)(0x42C00E24UL))
#define bFM4_DMAC_DMACA6_TC10                  *((volatile unsigned char*)(0x42C00E28UL))
#define bFM4_DMAC_DMACA6_TC11                  *((volatile unsigned char*)(0x42C00E2CUL))
#define bFM4_DMAC_DMACA6_TC12                  *((volatile unsigned char*)(0x42C00E30UL))
#define bFM4_DMAC_DMACA6_TC13                  *((volatile unsigned char*)(0x42C00E34UL))
#define bFM4_DMAC_DMACA6_TC14                  *((volatile unsigned char*)(0x42C00E38UL))
#define bFM4_DMAC_DMACA6_TC15                  *((volatile unsigned char*)(0x42C00E3CUL))
#define bFM4_DMAC_DMACA6_BC0                   *((volatile unsigned char*)(0x42C00E40UL))
#define bFM4_DMAC_DMACA6_BC1                   *((volatile unsigned char*)(0x42C00E44UL))
#define bFM4_DMAC_DMACA6_BC2                   *((volatile unsigned char*)(0x42C00E48UL))
#define bFM4_DMAC_DMACA6_BC3                   *((volatile unsigned char*)(0x42C00E4CUL))
#define bFM4_DMAC_DMACA6_IS0                   *((volatile unsigned char*)(0x42C00E5CUL))
#define bFM4_DMAC_DMACA6_IS1                   *((volatile unsigned char*)(0x42C00E60UL))
#define bFM4_DMAC_DMACA6_IS2                   *((volatile unsigned char*)(0x42C00E64UL))
#define bFM4_DMAC_DMACA6_IS3                   *((volatile unsigned char*)(0x42C00E68UL))
#define bFM4_DMAC_DMACA6_IS4                   *((volatile unsigned char*)(0x42C00E6CUL))
#define bFM4_DMAC_DMACA6_IS5                   *((volatile unsigned char*)(0x42C00E70UL))
#define bFM4_DMAC_DMACA6_ST                    *((volatile unsigned char*)(0x42C00E74UL))
#define bFM4_DMAC_DMACA6_PB                    *((volatile unsigned char*)(0x42C00E78UL))
#define bFM4_DMAC_DMACA6_EB                    *((volatile unsigned char*)(0x42C00E7CUL))
#define bFM4_DMAC_DMACB6_EM                    *((volatile unsigned char*)(0x42C00E80UL))
#define bFM4_DMAC_DMACB6_SS0                   *((volatile unsigned char*)(0x42C00EC0UL))
#define bFM4_DMAC_DMACB6_SS1                   *((volatile unsigned char*)(0x42C00EC4UL))
#define bFM4_DMAC_DMACB6_SS2                   *((volatile unsigned char*)(0x42C00EC8UL))
#define bFM4_DMAC_DMACB6_CI                    *((volatile unsigned char*)(0x42C00ECCUL))
#define bFM4_DMAC_DMACB6_EI                    *((volatile unsigned char*)(0x42C00ED0UL))
#define bFM4_DMAC_DMACB6_RD                    *((volatile unsigned char*)(0x42C00ED4UL))
#define bFM4_DMAC_DMACB6_RS                    *((volatile unsigned char*)(0x42C00ED8UL))
#define bFM4_DMAC_DMACB6_RC                    *((volatile unsigned char*)(0x42C00EDCUL))
#define bFM4_DMAC_DMACB6_FD                    *((volatile unsigned char*)(0x42C00EE0UL))
#define bFM4_DMAC_DMACB6_FS                    *((volatile unsigned char*)(0x42C00EE4UL))
#define bFM4_DMAC_DMACB6_TW0                   *((volatile unsigned char*)(0x42C00EE8UL))
#define bFM4_DMAC_DMACB6_TW1                   *((volatile unsigned char*)(0x42C00EECUL))
#define bFM4_DMAC_DMACB6_MS0                   *((volatile unsigned char*)(0x42C00EF0UL))
#define bFM4_DMAC_DMACB6_MS1                   *((volatile unsigned char*)(0x42C00EF4UL))
#define bFM4_DMAC_DMACA7_TC0                   *((volatile unsigned char*)(0x42C01000UL))
#define bFM4_DMAC_DMACA7_TC1                   *((volatile unsigned char*)(0x42C01004UL))
#define bFM4_DMAC_DMACA7_TC2                   *((volatile unsigned char*)(0x42C01008UL))
#define bFM4_DMAC_DMACA7_TC3                   *((volatile unsigned char*)(0x42C0100CUL))
#define bFM4_DMAC_DMACA7_TC4                   *((volatile unsigned char*)(0x42C01010UL))
#define bFM4_DMAC_DMACA7_TC5                   *((volatile unsigned char*)(0x42C01014UL))
#define bFM4_DMAC_DMACA7_TC6                   *((volatile unsigned char*)(0x42C01018UL))
#define bFM4_DMAC_DMACA7_TC7                   *((volatile unsigned char*)(0x42C0101CUL))
#define bFM4_DMAC_DMACA7_TC8                   *((volatile unsigned char*)(0x42C01020UL))
#define bFM4_DMAC_DMACA7_TC9                   *((volatile unsigned char*)(0x42C01024UL))
#define bFM4_DMAC_DMACA7_TC10                  *((volatile unsigned char*)(0x42C01028UL))
#define bFM4_DMAC_DMACA7_TC11                  *((volatile unsigned char*)(0x42C0102CUL))
#define bFM4_DMAC_DMACA7_TC12                  *((volatile unsigned char*)(0x42C01030UL))
#define bFM4_DMAC_DMACA7_TC13                  *((volatile unsigned char*)(0x42C01034UL))
#define bFM4_DMAC_DMACA7_TC14                  *((volatile unsigned char*)(0x42C01038UL))
#define bFM4_DMAC_DMACA7_TC15                  *((volatile unsigned char*)(0x42C0103CUL))
#define bFM4_DMAC_DMACA7_BC0                   *((volatile unsigned char*)(0x42C01040UL))
#define bFM4_DMAC_DMACA7_BC1                   *((volatile unsigned char*)(0x42C01044UL))
#define bFM4_DMAC_DMACA7_BC2                   *((volatile unsigned char*)(0x42C01048UL))
#define bFM4_DMAC_DMACA7_BC3                   *((volatile unsigned char*)(0x42C0104CUL))
#define bFM4_DMAC_DMACA7_IS0                   *((volatile unsigned char*)(0x42C0105CUL))
#define bFM4_DMAC_DMACA7_IS1                   *((volatile unsigned char*)(0x42C01060UL))
#define bFM4_DMAC_DMACA7_IS2                   *((volatile unsigned char*)(0x42C01064UL))
#define bFM4_DMAC_DMACA7_IS3                   *((volatile unsigned char*)(0x42C01068UL))
#define bFM4_DMAC_DMACA7_IS4                   *((volatile unsigned char*)(0x42C0106CUL))
#define bFM4_DMAC_DMACA7_IS5                   *((volatile unsigned char*)(0x42C01070UL))
#define bFM4_DMAC_DMACA7_ST                    *((volatile unsigned char*)(0x42C01074UL))
#define bFM4_DMAC_DMACA7_PB                    *((volatile unsigned char*)(0x42C01078UL))
#define bFM4_DMAC_DMACA7_EB                    *((volatile unsigned char*)(0x42C0107CUL))
#define bFM4_DMAC_DMACB7_EM                    *((volatile unsigned char*)(0x42C01080UL))
#define bFM4_DMAC_DMACB7_SS0                   *((volatile unsigned char*)(0x42C010C0UL))
#define bFM4_DMAC_DMACB7_SS1                   *((volatile unsigned char*)(0x42C010C4UL))
#define bFM4_DMAC_DMACB7_SS2                   *((volatile unsigned char*)(0x42C010C8UL))
#define bFM4_DMAC_DMACB7_CI                    *((volatile unsigned char*)(0x42C010CCUL))
#define bFM4_DMAC_DMACB7_EI                    *((volatile unsigned char*)(0x42C010D0UL))
#define bFM4_DMAC_DMACB7_RD                    *((volatile unsigned char*)(0x42C010D4UL))
#define bFM4_DMAC_DMACB7_RS                    *((volatile unsigned char*)(0x42C010D8UL))
#define bFM4_DMAC_DMACB7_RC                    *((volatile unsigned char*)(0x42C010DCUL))
#define bFM4_DMAC_DMACB7_FD                    *((volatile unsigned char*)(0x42C010E0UL))
#define bFM4_DMAC_DMACB7_FS                    *((volatile unsigned char*)(0x42C010E4UL))
#define bFM4_DMAC_DMACB7_TW0                   *((volatile unsigned char*)(0x42C010E8UL))
#define bFM4_DMAC_DMACB7_TW1                   *((volatile unsigned char*)(0x42C010ECUL))
#define bFM4_DMAC_DMACB7_MS0                   *((volatile unsigned char*)(0x42C010F0UL))
#define bFM4_DMAC_DMACB7_MS1                   *((volatile unsigned char*)(0x42C010F4UL))

/* CAN channel 0 registers */
#define bFM4_CAN0_CTRLR_INIT                   *((volatile unsigned char*)(0x42C40000UL))
#define bFM4_CAN0_CTRLR_IE                     *((volatile unsigned char*)(0x42C40004UL))
#define bFM4_CAN0_CTRLR_SIE                    *((volatile unsigned char*)(0x42C40008UL))
#define bFM4_CAN0_CTRLR_EIE                    *((volatile unsigned char*)(0x42C4000CUL))
#define bFM4_CAN0_CTRLR_DAR                    *((volatile unsigned char*)(0x42C40014UL))
#define bFM4_CAN0_CTRLR_CCE                    *((volatile unsigned char*)(0x42C40018UL))
#define bFM4_CAN0_CTRLR_TEST                   *((volatile unsigned char*)(0x42C4001CUL))
#define bFM4_CAN0_STATR_LEC0                   *((volatile unsigned char*)(0x42C40040UL))
#define bFM4_CAN0_STATR_LEC1                   *((volatile unsigned char*)(0x42C40044UL))
#define bFM4_CAN0_STATR_LEC2                   *((volatile unsigned char*)(0x42C40048UL))
#define bFM4_CAN0_STATR_TXOK                   *((volatile unsigned char*)(0x42C4004CUL))
#define bFM4_CAN0_STATR_RXOK                   *((volatile unsigned char*)(0x42C40050UL))
#define bFM4_CAN0_STATR_EPASS                  *((volatile unsigned char*)(0x42C40054UL))
#define bFM4_CAN0_STATR_EWARM                  *((volatile unsigned char*)(0x42C40058UL))
#define bFM4_CAN0_STATR_BOFF                   *((volatile unsigned char*)(0x42C4005CUL))
#define bFM4_CAN0_ERRCNT_TEC0                  *((volatile unsigned char*)(0x42C40080UL))
#define bFM4_CAN0_ERRCNT_TEC1                  *((volatile unsigned char*)(0x42C40084UL))
#define bFM4_CAN0_ERRCNT_TEC2                  *((volatile unsigned char*)(0x42C40088UL))
#define bFM4_CAN0_ERRCNT_TEC3                  *((volatile unsigned char*)(0x42C4008CUL))
#define bFM4_CAN0_ERRCNT_TEC4                  *((volatile unsigned char*)(0x42C40090UL))
#define bFM4_CAN0_ERRCNT_TEC5                  *((volatile unsigned char*)(0x42C40094UL))
#define bFM4_CAN0_ERRCNT_TEC6                  *((volatile unsigned char*)(0x42C40098UL))
#define bFM4_CAN0_ERRCNT_TEC7                  *((volatile unsigned char*)(0x42C4009CUL))
#define bFM4_CAN0_ERRCNT_REC0                  *((volatile unsigned char*)(0x42C400A0UL))
#define bFM4_CAN0_ERRCNT_REC1                  *((volatile unsigned char*)(0x42C400A4UL))
#define bFM4_CAN0_ERRCNT_REC2                  *((volatile unsigned char*)(0x42C400A8UL))
#define bFM4_CAN0_ERRCNT_REC3                  *((volatile unsigned char*)(0x42C400ACUL))
#define bFM4_CAN0_ERRCNT_REC4                  *((volatile unsigned char*)(0x42C400B0UL))
#define bFM4_CAN0_ERRCNT_REC5                  *((volatile unsigned char*)(0x42C400B4UL))
#define bFM4_CAN0_ERRCNT_REC6                  *((volatile unsigned char*)(0x42C400B8UL))
#define bFM4_CAN0_ERRCNT_RP                    *((volatile unsigned char*)(0x42C400BCUL))
#define bFM4_CAN0_BTR_BRP0                     *((volatile unsigned char*)(0x42C400C0UL))
#define bFM4_CAN0_BTR_BRP1                     *((volatile unsigned char*)(0x42C400C4UL))
#define bFM4_CAN0_BTR_BRP2                     *((volatile unsigned char*)(0x42C400C8UL))
#define bFM4_CAN0_BTR_BRP3                     *((volatile unsigned char*)(0x42C400CCUL))
#define bFM4_CAN0_BTR_BRP4                     *((volatile unsigned char*)(0x42C400D0UL))
#define bFM4_CAN0_BTR_BRP5                     *((volatile unsigned char*)(0x42C400D4UL))
#define bFM4_CAN0_BTR_SJW0                     *((volatile unsigned char*)(0x42C400D8UL))
#define bFM4_CAN0_BTR_SJW1                     *((volatile unsigned char*)(0x42C400DCUL))
#define bFM4_CAN0_BTR_TSEG10                   *((volatile unsigned char*)(0x42C400E0UL))
#define bFM4_CAN0_BTR_TSEG11                   *((volatile unsigned char*)(0x42C400E4UL))
#define bFM4_CAN0_BTR_TSEG12                   *((volatile unsigned char*)(0x42C400E8UL))
#define bFM4_CAN0_BTR_TSEG13                   *((volatile unsigned char*)(0x42C400ECUL))
#define bFM4_CAN0_BTR_TSEG20                   *((volatile unsigned char*)(0x42C400F0UL))
#define bFM4_CAN0_BTR_TSEG21                   *((volatile unsigned char*)(0x42C400F4UL))
#define bFM4_CAN0_BTR_TSEG22                   *((volatile unsigned char*)(0x42C400F8UL))
#define bFM4_CAN0_INTR_INTID0                  *((volatile unsigned char*)(0x42C40100UL))
#define bFM4_CAN0_INTR_INTID1                  *((volatile unsigned char*)(0x42C40104UL))
#define bFM4_CAN0_INTR_INTID2                  *((volatile unsigned char*)(0x42C40108UL))
#define bFM4_CAN0_INTR_INTID3                  *((volatile unsigned char*)(0x42C4010CUL))
#define bFM4_CAN0_INTR_INTID4                  *((volatile unsigned char*)(0x42C40110UL))
#define bFM4_CAN0_INTR_INTID5                  *((volatile unsigned char*)(0x42C40114UL))
#define bFM4_CAN0_INTR_INTID6                  *((volatile unsigned char*)(0x42C40118UL))
#define bFM4_CAN0_INTR_INTID7                  *((volatile unsigned char*)(0x42C4011CUL))
#define bFM4_CAN0_INTR_INTID8                  *((volatile unsigned char*)(0x42C40120UL))
#define bFM4_CAN0_INTR_INTID9                  *((volatile unsigned char*)(0x42C40124UL))
#define bFM4_CAN0_INTR_INTID10                 *((volatile unsigned char*)(0x42C40128UL))
#define bFM4_CAN0_INTR_INTID11                 *((volatile unsigned char*)(0x42C4012CUL))
#define bFM4_CAN0_INTR_INTID12                 *((volatile unsigned char*)(0x42C40130UL))
#define bFM4_CAN0_INTR_INTID13                 *((volatile unsigned char*)(0x42C40134UL))
#define bFM4_CAN0_INTR_INTID14                 *((volatile unsigned char*)(0x42C40138UL))
#define bFM4_CAN0_INTR_INTID15                 *((volatile unsigned char*)(0x42C4013CUL))
#define bFM4_CAN0_TESTR_BASIC                  *((volatile unsigned char*)(0x42C40148UL))
#define bFM4_CAN0_TESTR_SILENT                 *((volatile unsigned char*)(0x42C4014CUL))
#define bFM4_CAN0_TESTR_LBACK                  *((volatile unsigned char*)(0x42C40150UL))
#define bFM4_CAN0_TESTR_TX0                    *((volatile unsigned char*)(0x42C40154UL))
#define bFM4_CAN0_TESTR_TX1                    *((volatile unsigned char*)(0x42C40158UL))
#define bFM4_CAN0_TESTR_RX                     *((volatile unsigned char*)(0x42C4015CUL))
#define bFM4_CAN0_BRPER_BRPE0                  *((volatile unsigned char*)(0x42C40180UL))
#define bFM4_CAN0_BRPER_BRPE1                  *((volatile unsigned char*)(0x42C40184UL))
#define bFM4_CAN0_BRPER_BRPE2                  *((volatile unsigned char*)(0x42C40188UL))
#define bFM4_CAN0_BRPER_BRPE3                  *((volatile unsigned char*)(0x42C4018CUL))
#define bFM4_CAN0_IF1CREQ_BUSY                 *((volatile unsigned char*)(0x42C4023CUL))
#define bFM4_CAN0_IF1CMSK_DATAB                *((volatile unsigned char*)(0x42C40240UL))
#define bFM4_CAN0_IF1CMSK_DATAA                *((volatile unsigned char*)(0x42C40244UL))
#define bFM4_CAN0_IF1CMSK_TXREST               *((volatile unsigned char*)(0x42C40248UL))
#define bFM4_CAN0_IF1CMSK_NEWDAT               *((volatile unsigned char*)(0x42C40248UL))
#define bFM4_CAN0_IF1CMSK_CIP                  *((volatile unsigned char*)(0x42C4024CUL))
#define bFM4_CAN0_IF1CMSK_CONTROL              *((volatile unsigned char*)(0x42C40250UL))
#define bFM4_CAN0_IF1CMSK_ARB                  *((volatile unsigned char*)(0x42C40254UL))
#define bFM4_CAN0_IF1CMSK_MASK                 *((volatile unsigned char*)(0x42C40258UL))
#define bFM4_CAN0_IF1CMSK_WRRD                 *((volatile unsigned char*)(0x42C4025CUL))
#define bFM4_CAN0_IF1MSK_MDIR                  *((volatile unsigned char*)(0x42C402F8UL))
#define bFM4_CAN0_IF1MSK_MXTD                  *((volatile unsigned char*)(0x42C402FCUL))
#define bFM4_CAN0_IF1MSK2_MDIR                 *((volatile unsigned char*)(0x42C402F8UL))
#define bFM4_CAN0_IF1MSK2_MXTD                 *((volatile unsigned char*)(0x42C402FCUL))
#define bFM4_CAN0_IF1ARB_DIR                   *((volatile unsigned char*)(0x42C40374UL))
#define bFM4_CAN0_IF1ARB_XTD                   *((volatile unsigned char*)(0x42C40378UL))
#define bFM4_CAN0_IF1ARB_MSGVAL                *((volatile unsigned char*)(0x42C4037CUL))
#define bFM4_CAN0_IF1ARB2_DIR                  *((volatile unsigned char*)(0x42C40374UL))
#define bFM4_CAN0_IF1ARB2_XTD                  *((volatile unsigned char*)(0x42C40378UL))
#define bFM4_CAN0_IF1ARB2_MSGVAL               *((volatile unsigned char*)(0x42C4037CUL))
#define bFM4_CAN0_IF1MCTR_DLC0                 *((volatile unsigned char*)(0x42C40380UL))
#define bFM4_CAN0_IF1MCTR_DLC1                 *((volatile unsigned char*)(0x42C40384UL))
#define bFM4_CAN0_IF1MCTR_DLC2                 *((volatile unsigned char*)(0x42C40388UL))
#define bFM4_CAN0_IF1MCTR_DLC3                 *((volatile unsigned char*)(0x42C4038CUL))
#define bFM4_CAN0_IF1MCTR_EOB                  *((volatile unsigned char*)(0x42C4039CUL))
#define bFM4_CAN0_IF1MCTR_TXRQST               *((volatile unsigned char*)(0x42C403A0UL))
#define bFM4_CAN0_IF1MCTR_RMTEN                *((volatile unsigned char*)(0x42C403A4UL))
#define bFM4_CAN0_IF1MCTR_RXIE                 *((volatile unsigned char*)(0x42C403A8UL))
#define bFM4_CAN0_IF1MCTR_TXIE                 *((volatile unsigned char*)(0x42C403ACUL))
#define bFM4_CAN0_IF1MCTR_UMASK                *((volatile unsigned char*)(0x42C403B0UL))
#define bFM4_CAN0_IF1MCTR_INTPND               *((volatile unsigned char*)(0x42C403B4UL))
#define bFM4_CAN0_IF1MCTR_MSGLST               *((volatile unsigned char*)(0x42C403B8UL))
#define bFM4_CAN0_IF1MCTR_NEWDAT               *((volatile unsigned char*)(0x42C403BCUL))
#define bFM4_CAN0_IF2CREQ_BUSY                 *((volatile unsigned char*)(0x42C4083CUL))
#define bFM4_CAN0_IF2CMSK_DATAB                *((volatile unsigned char*)(0x42C40840UL))
#define bFM4_CAN0_IF2CMSK_DATAA                *((volatile unsigned char*)(0x42C40844UL))
#define bFM4_CAN0_IF2CMSK_TXREST               *((volatile unsigned char*)(0x42C40848UL))
#define bFM4_CAN0_IF2CMSK_NEWDAT               *((volatile unsigned char*)(0x42C40848UL))
#define bFM4_CAN0_IF2CMSK_CIP                  *((volatile unsigned char*)(0x42C4084CUL))
#define bFM4_CAN0_IF2CMSK_CONTROL              *((volatile unsigned char*)(0x42C40850UL))
#define bFM4_CAN0_IF2CMSK_ARB                  *((volatile unsigned char*)(0x42C40854UL))
#define bFM4_CAN0_IF2CMSK_MASK                 *((volatile unsigned char*)(0x42C40858UL))
#define bFM4_CAN0_IF2CMSK_WRRD                 *((volatile unsigned char*)(0x42C4085CUL))
#define bFM4_CAN0_IF2MSK_MDIR                  *((volatile unsigned char*)(0x42C408F8UL))
#define bFM4_CAN0_IF2MSK_MXTD                  *((volatile unsigned char*)(0x42C408FCUL))
#define bFM4_CAN0_IF2MSK2_MDIR                 *((volatile unsigned char*)(0x42C408F8UL))
#define bFM4_CAN0_IF2MSK2_MXTD                 *((volatile unsigned char*)(0x42C408FCUL))
#define bFM4_CAN0_IF2ARB_DIR                   *((volatile unsigned char*)(0x42C40974UL))
#define bFM4_CAN0_IF2ARB_XTD                   *((volatile unsigned char*)(0x42C40978UL))
#define bFM4_CAN0_IF2ARB_MSGVAL                *((volatile unsigned char*)(0x42C4097CUL))
#define bFM4_CAN0_IF2ARB2_DIR                  *((volatile unsigned char*)(0x42C40974UL))
#define bFM4_CAN0_IF2ARB2_XTD                  *((volatile unsigned char*)(0x42C40978UL))
#define bFM4_CAN0_IF2ARB2_MSGVAL               *((volatile unsigned char*)(0x42C4097CUL))
#define bFM4_CAN0_IF2MCTR_DLC0                 *((volatile unsigned char*)(0x42C40980UL))
#define bFM4_CAN0_IF2MCTR_DLC1                 *((volatile unsigned char*)(0x42C40984UL))
#define bFM4_CAN0_IF2MCTR_DLC2                 *((volatile unsigned char*)(0x42C40988UL))
#define bFM4_CAN0_IF2MCTR_DLC3                 *((volatile unsigned char*)(0x42C4098CUL))
#define bFM4_CAN0_IF2MCTR_EOB                  *((volatile unsigned char*)(0x42C4099CUL))
#define bFM4_CAN0_IF2MCTR_TXRQST               *((volatile unsigned char*)(0x42C409A0UL))
#define bFM4_CAN0_IF2MCTR_RMTEN                *((volatile unsigned char*)(0x42C409A4UL))
#define bFM4_CAN0_IF2MCTR_RXIE                 *((volatile unsigned char*)(0x42C409A8UL))
#define bFM4_CAN0_IF2MCTR_TXIE                 *((volatile unsigned char*)(0x42C409ACUL))
#define bFM4_CAN0_IF2MCTR_UMASK                *((volatile unsigned char*)(0x42C409B0UL))
#define bFM4_CAN0_IF2MCTR_INTPND               *((volatile unsigned char*)(0x42C409B4UL))
#define bFM4_CAN0_IF2MCTR_MSGLST               *((volatile unsigned char*)(0x42C409B8UL))
#define bFM4_CAN0_IF2MCTR_NEWDAT               *((volatile unsigned char*)(0x42C409BCUL))
#define bFM4_CAN0_TREQR_TXRQST1                *((volatile unsigned char*)(0x42C41000UL))
#define bFM4_CAN0_TREQR_TXRQST2                *((volatile unsigned char*)(0x42C41004UL))
#define bFM4_CAN0_TREQR_TXRQST3                *((volatile unsigned char*)(0x42C41008UL))
#define bFM4_CAN0_TREQR_TXRQST4                *((volatile unsigned char*)(0x42C4100CUL))
#define bFM4_CAN0_TREQR_TXRQST5                *((volatile unsigned char*)(0x42C41010UL))
#define bFM4_CAN0_TREQR_TXRQST6                *((volatile unsigned char*)(0x42C41014UL))
#define bFM4_CAN0_TREQR_TXRQST7                *((volatile unsigned char*)(0x42C41018UL))
#define bFM4_CAN0_TREQR_TXRQST8                *((volatile unsigned char*)(0x42C4101CUL))
#define bFM4_CAN0_TREQR_TXRQST9                *((volatile unsigned char*)(0x42C41020UL))
#define bFM4_CAN0_TREQR_TXRQST10               *((volatile unsigned char*)(0x42C41024UL))
#define bFM4_CAN0_TREQR_TXRQST11               *((volatile unsigned char*)(0x42C41028UL))
#define bFM4_CAN0_TREQR_TXRQST12               *((volatile unsigned char*)(0x42C4102CUL))
#define bFM4_CAN0_TREQR_TXRQST13               *((volatile unsigned char*)(0x42C41030UL))
#define bFM4_CAN0_TREQR_TXRQST14               *((volatile unsigned char*)(0x42C41034UL))
#define bFM4_CAN0_TREQR_TXRQST15               *((volatile unsigned char*)(0x42C41038UL))
#define bFM4_CAN0_TREQR_TXRQST16               *((volatile unsigned char*)(0x42C4103CUL))
#define bFM4_CAN0_TREQR_TXRQST17               *((volatile unsigned char*)(0x42C41040UL))
#define bFM4_CAN0_TREQR_TXRQST18               *((volatile unsigned char*)(0x42C41044UL))
#define bFM4_CAN0_TREQR_TXRQST19               *((volatile unsigned char*)(0x42C41048UL))
#define bFM4_CAN0_TREQR_TXRQST20               *((volatile unsigned char*)(0x42C4104CUL))
#define bFM4_CAN0_TREQR_TXRQST21               *((volatile unsigned char*)(0x42C41050UL))
#define bFM4_CAN0_TREQR_TXRQST22               *((volatile unsigned char*)(0x42C41054UL))
#define bFM4_CAN0_TREQR_TXRQST23               *((volatile unsigned char*)(0x42C41058UL))
#define bFM4_CAN0_TREQR_TXRQST24               *((volatile unsigned char*)(0x42C4105CUL))
#define bFM4_CAN0_TREQR_TXRQST25               *((volatile unsigned char*)(0x42C41060UL))
#define bFM4_CAN0_TREQR_TXRQST26               *((volatile unsigned char*)(0x42C41064UL))
#define bFM4_CAN0_TREQR_TXRQST27               *((volatile unsigned char*)(0x42C41068UL))
#define bFM4_CAN0_TREQR_TXRQST28               *((volatile unsigned char*)(0x42C4106CUL))
#define bFM4_CAN0_TREQR_TXRQST29               *((volatile unsigned char*)(0x42C41070UL))
#define bFM4_CAN0_TREQR_TXRQST30               *((volatile unsigned char*)(0x42C41074UL))
#define bFM4_CAN0_TREQR_TXRQST31               *((volatile unsigned char*)(0x42C41078UL))
#define bFM4_CAN0_TREQR_TXRQST32               *((volatile unsigned char*)(0x42C4107CUL))
#define bFM4_CAN0_TREQR1_TXRQST1               *((volatile unsigned char*)(0x42C41000UL))
#define bFM4_CAN0_TREQR1_TXRQST2               *((volatile unsigned char*)(0x42C41004UL))
#define bFM4_CAN0_TREQR1_TXRQST3               *((volatile unsigned char*)(0x42C41008UL))
#define bFM4_CAN0_TREQR1_TXRQST4               *((volatile unsigned char*)(0x42C4100CUL))
#define bFM4_CAN0_TREQR1_TXRQST5               *((volatile unsigned char*)(0x42C41010UL))
#define bFM4_CAN0_TREQR1_TXRQST6               *((volatile unsigned char*)(0x42C41014UL))
#define bFM4_CAN0_TREQR1_TXRQST7               *((volatile unsigned char*)(0x42C41018UL))
#define bFM4_CAN0_TREQR1_TXRQST8               *((volatile unsigned char*)(0x42C4101CUL))
#define bFM4_CAN0_TREQR1_TXRQST9               *((volatile unsigned char*)(0x42C41020UL))
#define bFM4_CAN0_TREQR1_TXRQST10              *((volatile unsigned char*)(0x42C41024UL))
#define bFM4_CAN0_TREQR1_TXRQST11              *((volatile unsigned char*)(0x42C41028UL))
#define bFM4_CAN0_TREQR1_TXRQST12              *((volatile unsigned char*)(0x42C4102CUL))
#define bFM4_CAN0_TREQR1_TXRQST13              *((volatile unsigned char*)(0x42C41030UL))
#define bFM4_CAN0_TREQR1_TXRQST14              *((volatile unsigned char*)(0x42C41034UL))
#define bFM4_CAN0_TREQR1_TXRQST15              *((volatile unsigned char*)(0x42C41038UL))
#define bFM4_CAN0_TREQR1_TXRQST16              *((volatile unsigned char*)(0x42C4103CUL))
#define bFM4_CAN0_TREQR2_TXRQST17              *((volatile unsigned char*)(0x42C41040UL))
#define bFM4_CAN0_TREQR2_TXRQST18              *((volatile unsigned char*)(0x42C41044UL))
#define bFM4_CAN0_TREQR2_TXRQST19              *((volatile unsigned char*)(0x42C41048UL))
#define bFM4_CAN0_TREQR2_TXRQST20              *((volatile unsigned char*)(0x42C4104CUL))
#define bFM4_CAN0_TREQR2_TXRQST21              *((volatile unsigned char*)(0x42C41050UL))
#define bFM4_CAN0_TREQR2_TXRQST22              *((volatile unsigned char*)(0x42C41054UL))
#define bFM4_CAN0_TREQR2_TXRQST23              *((volatile unsigned char*)(0x42C41058UL))
#define bFM4_CAN0_TREQR2_TXRQST24              *((volatile unsigned char*)(0x42C4105CUL))
#define bFM4_CAN0_TREQR2_TXRQST25              *((volatile unsigned char*)(0x42C41060UL))
#define bFM4_CAN0_TREQR2_TXRQST26              *((volatile unsigned char*)(0x42C41064UL))
#define bFM4_CAN0_TREQR2_TXRQST27              *((volatile unsigned char*)(0x42C41068UL))
#define bFM4_CAN0_TREQR2_TXRQST28              *((volatile unsigned char*)(0x42C4106CUL))
#define bFM4_CAN0_TREQR2_TXRQST29              *((volatile unsigned char*)(0x42C41070UL))
#define bFM4_CAN0_TREQR2_TXRQST30              *((volatile unsigned char*)(0x42C41074UL))
#define bFM4_CAN0_TREQR2_TXRQST31              *((volatile unsigned char*)(0x42C41078UL))
#define bFM4_CAN0_TREQR2_TXRQST32              *((volatile unsigned char*)(0x42C4107CUL))
#define bFM4_CAN0_NEWDT_NEWDAT1                *((volatile unsigned char*)(0x42C41200UL))
#define bFM4_CAN0_NEWDT_NEWDAT2                *((volatile unsigned char*)(0x42C41204UL))
#define bFM4_CAN0_NEWDT_NEWDAT3                *((volatile unsigned char*)(0x42C41208UL))
#define bFM4_CAN0_NEWDT_NEWDAT4                *((volatile unsigned char*)(0x42C4120CUL))
#define bFM4_CAN0_NEWDT_NEWDAT5                *((volatile unsigned char*)(0x42C41210UL))
#define bFM4_CAN0_NEWDT_NEWDAT6                *((volatile unsigned char*)(0x42C41214UL))
#define bFM4_CAN0_NEWDT_NEWDAT7                *((volatile unsigned char*)(0x42C41218UL))
#define bFM4_CAN0_NEWDT_NEWDAT8                *((volatile unsigned char*)(0x42C4121CUL))
#define bFM4_CAN0_NEWDT_NEWDAT9                *((volatile unsigned char*)(0x42C41220UL))
#define bFM4_CAN0_NEWDT_NEWDAT10               *((volatile unsigned char*)(0x42C41224UL))
#define bFM4_CAN0_NEWDT_NEWDAT11               *((volatile unsigned char*)(0x42C41228UL))
#define bFM4_CAN0_NEWDT_NEWDAT12               *((volatile unsigned char*)(0x42C4122CUL))
#define bFM4_CAN0_NEWDT_NEWDAT13               *((volatile unsigned char*)(0x42C41230UL))
#define bFM4_CAN0_NEWDT_NEWDAT14               *((volatile unsigned char*)(0x42C41234UL))
#define bFM4_CAN0_NEWDT_NEWDAT15               *((volatile unsigned char*)(0x42C41238UL))
#define bFM4_CAN0_NEWDT_NEWDAT16               *((volatile unsigned char*)(0x42C4123CUL))
#define bFM4_CAN0_NEWDT_NEWDAT17               *((volatile unsigned char*)(0x42C41240UL))
#define bFM4_CAN0_NEWDT_NEWDAT18               *((volatile unsigned char*)(0x42C41244UL))
#define bFM4_CAN0_NEWDT_NEWDAT19               *((volatile unsigned char*)(0x42C41248UL))
#define bFM4_CAN0_NEWDT_NEWDAT20               *((volatile unsigned char*)(0x42C4124CUL))
#define bFM4_CAN0_NEWDT_NEWDAT21               *((volatile unsigned char*)(0x42C41250UL))
#define bFM4_CAN0_NEWDT_NEWDAT22               *((volatile unsigned char*)(0x42C41254UL))
#define bFM4_CAN0_NEWDT_NEWDAT23               *((volatile unsigned char*)(0x42C41258UL))
#define bFM4_CAN0_NEWDT_NEWDAT24               *((volatile unsigned char*)(0x42C4125CUL))
#define bFM4_CAN0_NEWDT_NEWDAT25               *((volatile unsigned char*)(0x42C41260UL))
#define bFM4_CAN0_NEWDT_NEWDAT26               *((volatile unsigned char*)(0x42C41264UL))
#define bFM4_CAN0_NEWDT_NEWDAT27               *((volatile unsigned char*)(0x42C41268UL))
#define bFM4_CAN0_NEWDT_NEWDAT28               *((volatile unsigned char*)(0x42C4126CUL))
#define bFM4_CAN0_NEWDT_NEWDAT29               *((volatile unsigned char*)(0x42C41270UL))
#define bFM4_CAN0_NEWDT_NEWDAT30               *((volatile unsigned char*)(0x42C41274UL))
#define bFM4_CAN0_NEWDT_NEWDAT31               *((volatile unsigned char*)(0x42C41278UL))
#define bFM4_CAN0_NEWDT_NEWDAT32               *((volatile unsigned char*)(0x42C4127CUL))
#define bFM4_CAN0_NEWDT1_NEWDAT1               *((volatile unsigned char*)(0x42C41200UL))
#define bFM4_CAN0_NEWDT1_NEWDAT2               *((volatile unsigned char*)(0x42C41204UL))
#define bFM4_CAN0_NEWDT1_NEWDAT3               *((volatile unsigned char*)(0x42C41208UL))
#define bFM4_CAN0_NEWDT1_NEWDAT4               *((volatile unsigned char*)(0x42C4120CUL))
#define bFM4_CAN0_NEWDT1_NEWDAT5               *((volatile unsigned char*)(0x42C41210UL))
#define bFM4_CAN0_NEWDT1_NEWDAT6               *((volatile unsigned char*)(0x42C41214UL))
#define bFM4_CAN0_NEWDT1_NEWDAT7               *((volatile unsigned char*)(0x42C41218UL))
#define bFM4_CAN0_NEWDT1_NEWDAT8               *((volatile unsigned char*)(0x42C4121CUL))
#define bFM4_CAN0_NEWDT1_NEWDAT9               *((volatile unsigned char*)(0x42C41220UL))
#define bFM4_CAN0_NEWDT1_NEWDAT10              *((volatile unsigned char*)(0x42C41224UL))
#define bFM4_CAN0_NEWDT1_NEWDAT11              *((volatile unsigned char*)(0x42C41228UL))
#define bFM4_CAN0_NEWDT1_NEWDAT12              *((volatile unsigned char*)(0x42C4122CUL))
#define bFM4_CAN0_NEWDT1_NEWDAT13              *((volatile unsigned char*)(0x42C41230UL))
#define bFM4_CAN0_NEWDT1_NEWDAT14              *((volatile unsigned char*)(0x42C41234UL))
#define bFM4_CAN0_NEWDT1_NEWDAT15              *((volatile unsigned char*)(0x42C41238UL))
#define bFM4_CAN0_NEWDT1_NEWDAT16              *((volatile unsigned char*)(0x42C4123CUL))
#define bFM4_CAN0_NEWDT2_NEWDAT17              *((volatile unsigned char*)(0x42C41240UL))
#define bFM4_CAN0_NEWDT2_NEWDAT18              *((volatile unsigned char*)(0x42C41244UL))
#define bFM4_CAN0_NEWDT2_NEWDAT19              *((volatile unsigned char*)(0x42C41248UL))
#define bFM4_CAN0_NEWDT2_NEWDAT20              *((volatile unsigned char*)(0x42C4124CUL))
#define bFM4_CAN0_NEWDT2_NEWDAT21              *((volatile unsigned char*)(0x42C41250UL))
#define bFM4_CAN0_NEWDT2_NEWDAT22              *((volatile unsigned char*)(0x42C41254UL))
#define bFM4_CAN0_NEWDT2_NEWDAT23              *((volatile unsigned char*)(0x42C41258UL))
#define bFM4_CAN0_NEWDT2_NEWDAT24              *((volatile unsigned char*)(0x42C4125CUL))
#define bFM4_CAN0_NEWDT2_NEWDAT25              *((volatile unsigned char*)(0x42C41260UL))
#define bFM4_CAN0_NEWDT2_NEWDAT26              *((volatile unsigned char*)(0x42C41264UL))
#define bFM4_CAN0_NEWDT2_NEWDAT27              *((volatile unsigned char*)(0x42C41268UL))
#define bFM4_CAN0_NEWDT2_NEWDAT28              *((volatile unsigned char*)(0x42C4126CUL))
#define bFM4_CAN0_NEWDT2_NEWDAT29              *((volatile unsigned char*)(0x42C41270UL))
#define bFM4_CAN0_NEWDT2_NEWDAT30              *((volatile unsigned char*)(0x42C41274UL))
#define bFM4_CAN0_NEWDT2_NEWDAT31              *((volatile unsigned char*)(0x42C41278UL))
#define bFM4_CAN0_NEWDT2_NEWDAT32              *((volatile unsigned char*)(0x42C4127CUL))
#define bFM4_CAN0_INTPND_INTPND1               *((volatile unsigned char*)(0x42C41400UL))
#define bFM4_CAN0_INTPND_INTPND2               *((volatile unsigned char*)(0x42C41404UL))
#define bFM4_CAN0_INTPND_INTPND3               *((volatile unsigned char*)(0x42C41408UL))
#define bFM4_CAN0_INTPND_INTPND4               *((volatile unsigned char*)(0x42C4140CUL))
#define bFM4_CAN0_INTPND_INTPND5               *((volatile unsigned char*)(0x42C41410UL))
#define bFM4_CAN0_INTPND_INTPND6               *((volatile unsigned char*)(0x42C41414UL))
#define bFM4_CAN0_INTPND_INTPND7               *((volatile unsigned char*)(0x42C41418UL))
#define bFM4_CAN0_INTPND_INTPND8               *((volatile unsigned char*)(0x42C4141CUL))
#define bFM4_CAN0_INTPND_INTPND9               *((volatile unsigned char*)(0x42C41420UL))
#define bFM4_CAN0_INTPND_INTPND10              *((volatile unsigned char*)(0x42C41424UL))
#define bFM4_CAN0_INTPND_INTPND11              *((volatile unsigned char*)(0x42C41428UL))
#define bFM4_CAN0_INTPND_INTPND12              *((volatile unsigned char*)(0x42C4142CUL))
#define bFM4_CAN0_INTPND_INTPND13              *((volatile unsigned char*)(0x42C41430UL))
#define bFM4_CAN0_INTPND_INTPND14              *((volatile unsigned char*)(0x42C41434UL))
#define bFM4_CAN0_INTPND_INTPND15              *((volatile unsigned char*)(0x42C41438UL))
#define bFM4_CAN0_INTPND_INTPND16              *((volatile unsigned char*)(0x42C4143CUL))
#define bFM4_CAN0_INTPND_INTPND17              *((volatile unsigned char*)(0x42C41440UL))
#define bFM4_CAN0_INTPND_INTPND18              *((volatile unsigned char*)(0x42C41444UL))
#define bFM4_CAN0_INTPND_INTPND19              *((volatile unsigned char*)(0x42C41448UL))
#define bFM4_CAN0_INTPND_INTPND20              *((volatile unsigned char*)(0x42C4144CUL))
#define bFM4_CAN0_INTPND_INTPND21              *((volatile unsigned char*)(0x42C41450UL))
#define bFM4_CAN0_INTPND_INTPND22              *((volatile unsigned char*)(0x42C41454UL))
#define bFM4_CAN0_INTPND_INTPND23              *((volatile unsigned char*)(0x42C41458UL))
#define bFM4_CAN0_INTPND_INTPND24              *((volatile unsigned char*)(0x42C4145CUL))
#define bFM4_CAN0_INTPND_INTPND25              *((volatile unsigned char*)(0x42C41460UL))
#define bFM4_CAN0_INTPND_INTPND26              *((volatile unsigned char*)(0x42C41464UL))
#define bFM4_CAN0_INTPND_INTPND27              *((volatile unsigned char*)(0x42C41468UL))
#define bFM4_CAN0_INTPND_INTPND28              *((volatile unsigned char*)(0x42C4146CUL))
#define bFM4_CAN0_INTPND_INTPND29              *((volatile unsigned char*)(0x42C41470UL))
#define bFM4_CAN0_INTPND_INTPND30              *((volatile unsigned char*)(0x42C41474UL))
#define bFM4_CAN0_INTPND_INTPND31              *((volatile unsigned char*)(0x42C41478UL))
#define bFM4_CAN0_INTPND_INTPND32              *((volatile unsigned char*)(0x42C4147CUL))
#define bFM4_CAN0_INTPND1_INTPND1              *((volatile unsigned char*)(0x42C41400UL))
#define bFM4_CAN0_INTPND1_INTPND2              *((volatile unsigned char*)(0x42C41404UL))
#define bFM4_CAN0_INTPND1_INTPND3              *((volatile unsigned char*)(0x42C41408UL))
#define bFM4_CAN0_INTPND1_INTPND4              *((volatile unsigned char*)(0x42C4140CUL))
#define bFM4_CAN0_INTPND1_INTPND5              *((volatile unsigned char*)(0x42C41410UL))
#define bFM4_CAN0_INTPND1_INTPND6              *((volatile unsigned char*)(0x42C41414UL))
#define bFM4_CAN0_INTPND1_INTPND7              *((volatile unsigned char*)(0x42C41418UL))
#define bFM4_CAN0_INTPND1_INTPND8              *((volatile unsigned char*)(0x42C4141CUL))
#define bFM4_CAN0_INTPND1_INTPND9              *((volatile unsigned char*)(0x42C41420UL))
#define bFM4_CAN0_INTPND1_INTPND10             *((volatile unsigned char*)(0x42C41424UL))
#define bFM4_CAN0_INTPND1_INTPND11             *((volatile unsigned char*)(0x42C41428UL))
#define bFM4_CAN0_INTPND1_INTPND12             *((volatile unsigned char*)(0x42C4142CUL))
#define bFM4_CAN0_INTPND1_INTPND13             *((volatile unsigned char*)(0x42C41430UL))
#define bFM4_CAN0_INTPND1_INTPND14             *((volatile unsigned char*)(0x42C41434UL))
#define bFM4_CAN0_INTPND1_INTPND15             *((volatile unsigned char*)(0x42C41438UL))
#define bFM4_CAN0_INTPND1_INTPND16             *((volatile unsigned char*)(0x42C4143CUL))
#define bFM4_CAN0_INTPND2_INTPND17             *((volatile unsigned char*)(0x42C41440UL))
#define bFM4_CAN0_INTPND2_INTPND18             *((volatile unsigned char*)(0x42C41444UL))
#define bFM4_CAN0_INTPND2_INTPND19             *((volatile unsigned char*)(0x42C41448UL))
#define bFM4_CAN0_INTPND2_INTPND20             *((volatile unsigned char*)(0x42C4144CUL))
#define bFM4_CAN0_INTPND2_INTPND21             *((volatile unsigned char*)(0x42C41450UL))
#define bFM4_CAN0_INTPND2_INTPND22             *((volatile unsigned char*)(0x42C41454UL))
#define bFM4_CAN0_INTPND2_INTPND23             *((volatile unsigned char*)(0x42C41458UL))
#define bFM4_CAN0_INTPND2_INTPND24             *((volatile unsigned char*)(0x42C4145CUL))
#define bFM4_CAN0_INTPND2_INTPND25             *((volatile unsigned char*)(0x42C41460UL))
#define bFM4_CAN0_INTPND2_INTPND26             *((volatile unsigned char*)(0x42C41464UL))
#define bFM4_CAN0_INTPND2_INTPND27             *((volatile unsigned char*)(0x42C41468UL))
#define bFM4_CAN0_INTPND2_INTPND28             *((volatile unsigned char*)(0x42C4146CUL))
#define bFM4_CAN0_INTPND2_INTPND29             *((volatile unsigned char*)(0x42C41470UL))
#define bFM4_CAN0_INTPND2_INTPND30             *((volatile unsigned char*)(0x42C41474UL))
#define bFM4_CAN0_INTPND2_INTPND31             *((volatile unsigned char*)(0x42C41478UL))
#define bFM4_CAN0_INTPND2_INTPND32             *((volatile unsigned char*)(0x42C4147CUL))
#define bFM4_CAN0_MSGVAL_MSGVAL1               *((volatile unsigned char*)(0x42C41600UL))
#define bFM4_CAN0_MSGVAL_MSGVAL2               *((volatile unsigned char*)(0x42C41604UL))
#define bFM4_CAN0_MSGVAL_MSGVAL3               *((volatile unsigned char*)(0x42C41608UL))
#define bFM4_CAN0_MSGVAL_MSGVAL4               *((volatile unsigned char*)(0x42C4160CUL))
#define bFM4_CAN0_MSGVAL_MSGVAL5               *((volatile unsigned char*)(0x42C41610UL))
#define bFM4_CAN0_MSGVAL_MSGVAL6               *((volatile unsigned char*)(0x42C41614UL))
#define bFM4_CAN0_MSGVAL_MSGVAL7               *((volatile unsigned char*)(0x42C41618UL))
#define bFM4_CAN0_MSGVAL_MSGVAL8               *((volatile unsigned char*)(0x42C4161CUL))
#define bFM4_CAN0_MSGVAL_MSGVAL9               *((volatile unsigned char*)(0x42C41620UL))
#define bFM4_CAN0_MSGVAL_MSGVAL10              *((volatile unsigned char*)(0x42C41624UL))
#define bFM4_CAN0_MSGVAL_MSGVAL11              *((volatile unsigned char*)(0x42C41628UL))
#define bFM4_CAN0_MSGVAL_MSGVAL12              *((volatile unsigned char*)(0x42C4162CUL))
#define bFM4_CAN0_MSGVAL_MSGVAL13              *((volatile unsigned char*)(0x42C41630UL))
#define bFM4_CAN0_MSGVAL_MSGVAL14              *((volatile unsigned char*)(0x42C41634UL))
#define bFM4_CAN0_MSGVAL_MSGVAL15              *((volatile unsigned char*)(0x42C41638UL))
#define bFM4_CAN0_MSGVAL_MSGVAL16              *((volatile unsigned char*)(0x42C4163CUL))
#define bFM4_CAN0_MSGVAL_MSGVAL17              *((volatile unsigned char*)(0x42C41640UL))
#define bFM4_CAN0_MSGVAL_MSGVAL18              *((volatile unsigned char*)(0x42C41644UL))
#define bFM4_CAN0_MSGVAL_MSGVAL19              *((volatile unsigned char*)(0x42C41648UL))
#define bFM4_CAN0_MSGVAL_MSGVAL20              *((volatile unsigned char*)(0x42C4164CUL))
#define bFM4_CAN0_MSGVAL_MSGVAL21              *((volatile unsigned char*)(0x42C41650UL))
#define bFM4_CAN0_MSGVAL_MSGVAL22              *((volatile unsigned char*)(0x42C41654UL))
#define bFM4_CAN0_MSGVAL_MSGVAL23              *((volatile unsigned char*)(0x42C41658UL))
#define bFM4_CAN0_MSGVAL_MSGVAL24              *((volatile unsigned char*)(0x42C4165CUL))
#define bFM4_CAN0_MSGVAL_MSGVAL25              *((volatile unsigned char*)(0x42C41660UL))
#define bFM4_CAN0_MSGVAL_MSGVAL26              *((volatile unsigned char*)(0x42C41664UL))
#define bFM4_CAN0_MSGVAL_MSGVAL27              *((volatile unsigned char*)(0x42C41668UL))
#define bFM4_CAN0_MSGVAL_MSGVAL28              *((volatile unsigned char*)(0x42C4166CUL))
#define bFM4_CAN0_MSGVAL_MSGVAL29              *((volatile unsigned char*)(0x42C41670UL))
#define bFM4_CAN0_MSGVAL_MSGVAL30              *((volatile unsigned char*)(0x42C41674UL))
#define bFM4_CAN0_MSGVAL_MSGVAL31              *((volatile unsigned char*)(0x42C41678UL))
#define bFM4_CAN0_MSGVAL_MSGVAL32              *((volatile unsigned char*)(0x42C4167CUL))
#define bFM4_CAN0_MSGVAL1_MSGVAL1              *((volatile unsigned char*)(0x42C41600UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL2              *((volatile unsigned char*)(0x42C41604UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL3              *((volatile unsigned char*)(0x42C41608UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL4              *((volatile unsigned char*)(0x42C4160CUL))
#define bFM4_CAN0_MSGVAL1_MSGVAL5              *((volatile unsigned char*)(0x42C41610UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL6              *((volatile unsigned char*)(0x42C41614UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL7              *((volatile unsigned char*)(0x42C41618UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL8              *((volatile unsigned char*)(0x42C4161CUL))
#define bFM4_CAN0_MSGVAL1_MSGVAL9              *((volatile unsigned char*)(0x42C41620UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL10             *((volatile unsigned char*)(0x42C41624UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL11             *((volatile unsigned char*)(0x42C41628UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL12             *((volatile unsigned char*)(0x42C4162CUL))
#define bFM4_CAN0_MSGVAL1_MSGVAL13             *((volatile unsigned char*)(0x42C41630UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL14             *((volatile unsigned char*)(0x42C41634UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL15             *((volatile unsigned char*)(0x42C41638UL))
#define bFM4_CAN0_MSGVAL1_MSGVAL16             *((volatile unsigned char*)(0x42C4163CUL))
#define bFM4_CAN0_MSGVAL2_MSGVAL17             *((volatile unsigned char*)(0x42C41640UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL18             *((volatile unsigned char*)(0x42C41644UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL19             *((volatile unsigned char*)(0x42C41648UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL20             *((volatile unsigned char*)(0x42C4164CUL))
#define bFM4_CAN0_MSGVAL2_MSGVAL21             *((volatile unsigned char*)(0x42C41650UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL22             *((volatile unsigned char*)(0x42C41654UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL23             *((volatile unsigned char*)(0x42C41658UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL24             *((volatile unsigned char*)(0x42C4165CUL))
#define bFM4_CAN0_MSGVAL2_MSGVAL25             *((volatile unsigned char*)(0x42C41660UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL26             *((volatile unsigned char*)(0x42C41664UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL27             *((volatile unsigned char*)(0x42C41668UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL28             *((volatile unsigned char*)(0x42C4166CUL))
#define bFM4_CAN0_MSGVAL2_MSGVAL29             *((volatile unsigned char*)(0x42C41670UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL30             *((volatile unsigned char*)(0x42C41674UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL31             *((volatile unsigned char*)(0x42C41678UL))
#define bFM4_CAN0_MSGVAL2_MSGVAL32             *((volatile unsigned char*)(0x42C4167CUL))

/* CAN channel 1 registers */
#define bFM4_CAN1_CTRLR_INIT                   *((volatile unsigned char*)(0x42C60000UL))
#define bFM4_CAN1_CTRLR_IE                     *((volatile unsigned char*)(0x42C60004UL))
#define bFM4_CAN1_CTRLR_SIE                    *((volatile unsigned char*)(0x42C60008UL))
#define bFM4_CAN1_CTRLR_EIE                    *((volatile unsigned char*)(0x42C6000CUL))
#define bFM4_CAN1_CTRLR_DAR                    *((volatile unsigned char*)(0x42C60014UL))
#define bFM4_CAN1_CTRLR_CCE                    *((volatile unsigned char*)(0x42C60018UL))
#define bFM4_CAN1_CTRLR_TEST                   *((volatile unsigned char*)(0x42C6001CUL))
#define bFM4_CAN1_STATR_LEC0                   *((volatile unsigned char*)(0x42C60040UL))
#define bFM4_CAN1_STATR_LEC1                   *((volatile unsigned char*)(0x42C60044UL))
#define bFM4_CAN1_STATR_LEC2                   *((volatile unsigned char*)(0x42C60048UL))
#define bFM4_CAN1_STATR_TXOK                   *((volatile unsigned char*)(0x42C6004CUL))
#define bFM4_CAN1_STATR_RXOK                   *((volatile unsigned char*)(0x42C60050UL))
#define bFM4_CAN1_STATR_EPASS                  *((volatile unsigned char*)(0x42C60054UL))
#define bFM4_CAN1_STATR_EWARM                  *((volatile unsigned char*)(0x42C60058UL))
#define bFM4_CAN1_STATR_BOFF                   *((volatile unsigned char*)(0x42C6005CUL))
#define bFM4_CAN1_ERRCNT_TEC0                  *((volatile unsigned char*)(0x42C60080UL))
#define bFM4_CAN1_ERRCNT_TEC1                  *((volatile unsigned char*)(0x42C60084UL))
#define bFM4_CAN1_ERRCNT_TEC2                  *((volatile unsigned char*)(0x42C60088UL))
#define bFM4_CAN1_ERRCNT_TEC3                  *((volatile unsigned char*)(0x42C6008CUL))
#define bFM4_CAN1_ERRCNT_TEC4                  *((volatile unsigned char*)(0x42C60090UL))
#define bFM4_CAN1_ERRCNT_TEC5                  *((volatile unsigned char*)(0x42C60094UL))
#define bFM4_CAN1_ERRCNT_TEC6                  *((volatile unsigned char*)(0x42C60098UL))
#define bFM4_CAN1_ERRCNT_TEC7                  *((volatile unsigned char*)(0x42C6009CUL))
#define bFM4_CAN1_ERRCNT_REC0                  *((volatile unsigned char*)(0x42C600A0UL))
#define bFM4_CAN1_ERRCNT_REC1                  *((volatile unsigned char*)(0x42C600A4UL))
#define bFM4_CAN1_ERRCNT_REC2                  *((volatile unsigned char*)(0x42C600A8UL))
#define bFM4_CAN1_ERRCNT_REC3                  *((volatile unsigned char*)(0x42C600ACUL))
#define bFM4_CAN1_ERRCNT_REC4                  *((volatile unsigned char*)(0x42C600B0UL))
#define bFM4_CAN1_ERRCNT_REC5                  *((volatile unsigned char*)(0x42C600B4UL))
#define bFM4_CAN1_ERRCNT_REC6                  *((volatile unsigned char*)(0x42C600B8UL))
#define bFM4_CAN1_ERRCNT_RP                    *((volatile unsigned char*)(0x42C600BCUL))
#define bFM4_CAN1_BTR_BRP0                     *((volatile unsigned char*)(0x42C600C0UL))
#define bFM4_CAN1_BTR_BRP1                     *((volatile unsigned char*)(0x42C600C4UL))
#define bFM4_CAN1_BTR_BRP2                     *((volatile unsigned char*)(0x42C600C8UL))
#define bFM4_CAN1_BTR_BRP3                     *((volatile unsigned char*)(0x42C600CCUL))
#define bFM4_CAN1_BTR_BRP4                     *((volatile unsigned char*)(0x42C600D0UL))
#define bFM4_CAN1_BTR_BRP5                     *((volatile unsigned char*)(0x42C600D4UL))
#define bFM4_CAN1_BTR_SJW0                     *((volatile unsigned char*)(0x42C600D8UL))
#define bFM4_CAN1_BTR_SJW1                     *((volatile unsigned char*)(0x42C600DCUL))
#define bFM4_CAN1_BTR_TSEG10                   *((volatile unsigned char*)(0x42C600E0UL))
#define bFM4_CAN1_BTR_TSEG11                   *((volatile unsigned char*)(0x42C600E4UL))
#define bFM4_CAN1_BTR_TSEG12                   *((volatile unsigned char*)(0x42C600E8UL))
#define bFM4_CAN1_BTR_TSEG13                   *((volatile unsigned char*)(0x42C600ECUL))
#define bFM4_CAN1_BTR_TSEG20                   *((volatile unsigned char*)(0x42C600F0UL))
#define bFM4_CAN1_BTR_TSEG21                   *((volatile unsigned char*)(0x42C600F4UL))
#define bFM4_CAN1_BTR_TSEG22                   *((volatile unsigned char*)(0x42C600F8UL))
#define bFM4_CAN1_INTR_INTID0                  *((volatile unsigned char*)(0x42C60100UL))
#define bFM4_CAN1_INTR_INTID1                  *((volatile unsigned char*)(0x42C60104UL))
#define bFM4_CAN1_INTR_INTID2                  *((volatile unsigned char*)(0x42C60108UL))
#define bFM4_CAN1_INTR_INTID3                  *((volatile unsigned char*)(0x42C6010CUL))
#define bFM4_CAN1_INTR_INTID4                  *((volatile unsigned char*)(0x42C60110UL))
#define bFM4_CAN1_INTR_INTID5                  *((volatile unsigned char*)(0x42C60114UL))
#define bFM4_CAN1_INTR_INTID6                  *((volatile unsigned char*)(0x42C60118UL))
#define bFM4_CAN1_INTR_INTID7                  *((volatile unsigned char*)(0x42C6011CUL))
#define bFM4_CAN1_INTR_INTID8                  *((volatile unsigned char*)(0x42C60120UL))
#define bFM4_CAN1_INTR_INTID9                  *((volatile unsigned char*)(0x42C60124UL))
#define bFM4_CAN1_INTR_INTID10                 *((volatile unsigned char*)(0x42C60128UL))
#define bFM4_CAN1_INTR_INTID11                 *((volatile unsigned char*)(0x42C6012CUL))
#define bFM4_CAN1_INTR_INTID12                 *((volatile unsigned char*)(0x42C60130UL))
#define bFM4_CAN1_INTR_INTID13                 *((volatile unsigned char*)(0x42C60134UL))
#define bFM4_CAN1_INTR_INTID14                 *((volatile unsigned char*)(0x42C60138UL))
#define bFM4_CAN1_INTR_INTID15                 *((volatile unsigned char*)(0x42C6013CUL))
#define bFM4_CAN1_TESTR_BASIC                  *((volatile unsigned char*)(0x42C60148UL))
#define bFM4_CAN1_TESTR_SILENT                 *((volatile unsigned char*)(0x42C6014CUL))
#define bFM4_CAN1_TESTR_LBACK                  *((volatile unsigned char*)(0x42C60150UL))
#define bFM4_CAN1_TESTR_TX0                    *((volatile unsigned char*)(0x42C60154UL))
#define bFM4_CAN1_TESTR_TX1                    *((volatile unsigned char*)(0x42C60158UL))
#define bFM4_CAN1_TESTR_RX                     *((volatile unsigned char*)(0x42C6015CUL))
#define bFM4_CAN1_BRPER_BRPE0                  *((volatile unsigned char*)(0x42C60180UL))
#define bFM4_CAN1_BRPER_BRPE1                  *((volatile unsigned char*)(0x42C60184UL))
#define bFM4_CAN1_BRPER_BRPE2                  *((volatile unsigned char*)(0x42C60188UL))
#define bFM4_CAN1_BRPER_BRPE3                  *((volatile unsigned char*)(0x42C6018CUL))
#define bFM4_CAN1_IF1CREQ_BUSY                 *((volatile unsigned char*)(0x42C6023CUL))
#define bFM4_CAN1_IF1CMSK_DATAB                *((volatile unsigned char*)(0x42C60240UL))
#define bFM4_CAN1_IF1CMSK_DATAA                *((volatile unsigned char*)(0x42C60244UL))
#define bFM4_CAN1_IF1CMSK_TXREST               *((volatile unsigned char*)(0x42C60248UL))
#define bFM4_CAN1_IF1CMSK_NEWDAT               *((volatile unsigned char*)(0x42C60248UL))
#define bFM4_CAN1_IF1CMSK_CIP                  *((volatile unsigned char*)(0x42C6024CUL))
#define bFM4_CAN1_IF1CMSK_CONTROL              *((volatile unsigned char*)(0x42C60250UL))
#define bFM4_CAN1_IF1CMSK_ARB                  *((volatile unsigned char*)(0x42C60254UL))
#define bFM4_CAN1_IF1CMSK_MASK                 *((volatile unsigned char*)(0x42C60258UL))
#define bFM4_CAN1_IF1CMSK_WRRD                 *((volatile unsigned char*)(0x42C6025CUL))
#define bFM4_CAN1_IF1MSK_MDIR                  *((volatile unsigned char*)(0x42C602F8UL))
#define bFM4_CAN1_IF1MSK_MXTD                  *((volatile unsigned char*)(0x42C602FCUL))
#define bFM4_CAN1_IF1MSK2_MDIR                 *((volatile unsigned char*)(0x42C602F8UL))
#define bFM4_CAN1_IF1MSK2_MXTD                 *((volatile unsigned char*)(0x42C602FCUL))
#define bFM4_CAN1_IF1ARB_DIR                   *((volatile unsigned char*)(0x42C60374UL))
#define bFM4_CAN1_IF1ARB_XTD                   *((volatile unsigned char*)(0x42C60378UL))
#define bFM4_CAN1_IF1ARB_MSGVAL                *((volatile unsigned char*)(0x42C6037CUL))
#define bFM4_CAN1_IF1ARB2_DIR                  *((volatile unsigned char*)(0x42C60374UL))
#define bFM4_CAN1_IF1ARB2_XTD                  *((volatile unsigned char*)(0x42C60378UL))
#define bFM4_CAN1_IF1ARB2_MSGVAL               *((volatile unsigned char*)(0x42C6037CUL))
#define bFM4_CAN1_IF1MCTR_DLC0                 *((volatile unsigned char*)(0x42C60380UL))
#define bFM4_CAN1_IF1MCTR_DLC1                 *((volatile unsigned char*)(0x42C60384UL))
#define bFM4_CAN1_IF1MCTR_DLC2                 *((volatile unsigned char*)(0x42C60388UL))
#define bFM4_CAN1_IF1MCTR_DLC3                 *((volatile unsigned char*)(0x42C6038CUL))
#define bFM4_CAN1_IF1MCTR_EOB                  *((volatile unsigned char*)(0x42C6039CUL))
#define bFM4_CAN1_IF1MCTR_TXRQST               *((volatile unsigned char*)(0x42C603A0UL))
#define bFM4_CAN1_IF1MCTR_RMTEN                *((volatile unsigned char*)(0x42C603A4UL))
#define bFM4_CAN1_IF1MCTR_RXIE                 *((volatile unsigned char*)(0x42C603A8UL))
#define bFM4_CAN1_IF1MCTR_TXIE                 *((volatile unsigned char*)(0x42C603ACUL))
#define bFM4_CAN1_IF1MCTR_UMASK                *((volatile unsigned char*)(0x42C603B0UL))
#define bFM4_CAN1_IF1MCTR_INTPND               *((volatile unsigned char*)(0x42C603B4UL))
#define bFM4_CAN1_IF1MCTR_MSGLST               *((volatile unsigned char*)(0x42C603B8UL))
#define bFM4_CAN1_IF1MCTR_NEWDAT               *((volatile unsigned char*)(0x42C603BCUL))
#define bFM4_CAN1_IF2CREQ_BUSY                 *((volatile unsigned char*)(0x42C6083CUL))
#define bFM4_CAN1_IF2CMSK_DATAB                *((volatile unsigned char*)(0x42C60840UL))
#define bFM4_CAN1_IF2CMSK_DATAA                *((volatile unsigned char*)(0x42C60844UL))
#define bFM4_CAN1_IF2CMSK_TXREST               *((volatile unsigned char*)(0x42C60848UL))
#define bFM4_CAN1_IF2CMSK_NEWDAT               *((volatile unsigned char*)(0x42C60848UL))
#define bFM4_CAN1_IF2CMSK_CIP                  *((volatile unsigned char*)(0x42C6084CUL))
#define bFM4_CAN1_IF2CMSK_CONTROL              *((volatile unsigned char*)(0x42C60850UL))
#define bFM4_CAN1_IF2CMSK_ARB                  *((volatile unsigned char*)(0x42C60854UL))
#define bFM4_CAN1_IF2CMSK_MASK                 *((volatile unsigned char*)(0x42C60858UL))
#define bFM4_CAN1_IF2CMSK_WRRD                 *((volatile unsigned char*)(0x42C6085CUL))
#define bFM4_CAN1_IF2MSK_MDIR                  *((volatile unsigned char*)(0x42C608F8UL))
#define bFM4_CAN1_IF2MSK_MXTD                  *((volatile unsigned char*)(0x42C608FCUL))
#define bFM4_CAN1_IF2MSK2_MDIR                 *((volatile unsigned char*)(0x42C608F8UL))
#define bFM4_CAN1_IF2MSK2_MXTD                 *((volatile unsigned char*)(0x42C608FCUL))
#define bFM4_CAN1_IF2ARB_DIR                   *((volatile unsigned char*)(0x42C60974UL))
#define bFM4_CAN1_IF2ARB_XTD                   *((volatile unsigned char*)(0x42C60978UL))
#define bFM4_CAN1_IF2ARB_MSGVAL                *((volatile unsigned char*)(0x42C6097CUL))
#define bFM4_CAN1_IF2ARB2_DIR                  *((volatile unsigned char*)(0x42C60974UL))
#define bFM4_CAN1_IF2ARB2_XTD                  *((volatile unsigned char*)(0x42C60978UL))
#define bFM4_CAN1_IF2ARB2_MSGVAL               *((volatile unsigned char*)(0x42C6097CUL))
#define bFM4_CAN1_IF2MCTR_DLC0                 *((volatile unsigned char*)(0x42C60980UL))
#define bFM4_CAN1_IF2MCTR_DLC1                 *((volatile unsigned char*)(0x42C60984UL))
#define bFM4_CAN1_IF2MCTR_DLC2                 *((volatile unsigned char*)(0x42C60988UL))
#define bFM4_CAN1_IF2MCTR_DLC3                 *((volatile unsigned char*)(0x42C6098CUL))
#define bFM4_CAN1_IF2MCTR_EOB                  *((volatile unsigned char*)(0x42C6099CUL))
#define bFM4_CAN1_IF2MCTR_TXRQST               *((volatile unsigned char*)(0x42C609A0UL))
#define bFM4_CAN1_IF2MCTR_RMTEN                *((volatile unsigned char*)(0x42C609A4UL))
#define bFM4_CAN1_IF2MCTR_RXIE                 *((volatile unsigned char*)(0x42C609A8UL))
#define bFM4_CAN1_IF2MCTR_TXIE                 *((volatile unsigned char*)(0x42C609ACUL))
#define bFM4_CAN1_IF2MCTR_UMASK                *((volatile unsigned char*)(0x42C609B0UL))
#define bFM4_CAN1_IF2MCTR_INTPND               *((volatile unsigned char*)(0x42C609B4UL))
#define bFM4_CAN1_IF2MCTR_MSGLST               *((volatile unsigned char*)(0x42C609B8UL))
#define bFM4_CAN1_IF2MCTR_NEWDAT               *((volatile unsigned char*)(0x42C609BCUL))
#define bFM4_CAN1_TREQR_TXRQST1                *((volatile unsigned char*)(0x42C61000UL))
#define bFM4_CAN1_TREQR_TXRQST2                *((volatile unsigned char*)(0x42C61004UL))
#define bFM4_CAN1_TREQR_TXRQST3                *((volatile unsigned char*)(0x42C61008UL))
#define bFM4_CAN1_TREQR_TXRQST4                *((volatile unsigned char*)(0x42C6100CUL))
#define bFM4_CAN1_TREQR_TXRQST5                *((volatile unsigned char*)(0x42C61010UL))
#define bFM4_CAN1_TREQR_TXRQST6                *((volatile unsigned char*)(0x42C61014UL))
#define bFM4_CAN1_TREQR_TXRQST7                *((volatile unsigned char*)(0x42C61018UL))
#define bFM4_CAN1_TREQR_TXRQST8                *((volatile unsigned char*)(0x42C6101CUL))
#define bFM4_CAN1_TREQR_TXRQST9                *((volatile unsigned char*)(0x42C61020UL))
#define bFM4_CAN1_TREQR_TXRQST10               *((volatile unsigned char*)(0x42C61024UL))
#define bFM4_CAN1_TREQR_TXRQST11               *((volatile unsigned char*)(0x42C61028UL))
#define bFM4_CAN1_TREQR_TXRQST12               *((volatile unsigned char*)(0x42C6102CUL))
#define bFM4_CAN1_TREQR_TXRQST13               *((volatile unsigned char*)(0x42C61030UL))
#define bFM4_CAN1_TREQR_TXRQST14               *((volatile unsigned char*)(0x42C61034UL))
#define bFM4_CAN1_TREQR_TXRQST15               *((volatile unsigned char*)(0x42C61038UL))
#define bFM4_CAN1_TREQR_TXRQST16               *((volatile unsigned char*)(0x42C6103CUL))
#define bFM4_CAN1_TREQR_TXRQST17               *((volatile unsigned char*)(0x42C61040UL))
#define bFM4_CAN1_TREQR_TXRQST18               *((volatile unsigned char*)(0x42C61044UL))
#define bFM4_CAN1_TREQR_TXRQST19               *((volatile unsigned char*)(0x42C61048UL))
#define bFM4_CAN1_TREQR_TXRQST20               *((volatile unsigned char*)(0x42C6104CUL))
#define bFM4_CAN1_TREQR_TXRQST21               *((volatile unsigned char*)(0x42C61050UL))
#define bFM4_CAN1_TREQR_TXRQST22               *((volatile unsigned char*)(0x42C61054UL))
#define bFM4_CAN1_TREQR_TXRQST23               *((volatile unsigned char*)(0x42C61058UL))
#define bFM4_CAN1_TREQR_TXRQST24               *((volatile unsigned char*)(0x42C6105CUL))
#define bFM4_CAN1_TREQR_TXRQST25               *((volatile unsigned char*)(0x42C61060UL))
#define bFM4_CAN1_TREQR_TXRQST26               *((volatile unsigned char*)(0x42C61064UL))
#define bFM4_CAN1_TREQR_TXRQST27               *((volatile unsigned char*)(0x42C61068UL))
#define bFM4_CAN1_TREQR_TXRQST28               *((volatile unsigned char*)(0x42C6106CUL))
#define bFM4_CAN1_TREQR_TXRQST29               *((volatile unsigned char*)(0x42C61070UL))
#define bFM4_CAN1_TREQR_TXRQST30               *((volatile unsigned char*)(0x42C61074UL))
#define bFM4_CAN1_TREQR_TXRQST31               *((volatile unsigned char*)(0x42C61078UL))
#define bFM4_CAN1_TREQR_TXRQST32               *((volatile unsigned char*)(0x42C6107CUL))
#define bFM4_CAN1_TREQR1_TXRQST1               *((volatile unsigned char*)(0x42C61000UL))
#define bFM4_CAN1_TREQR1_TXRQST2               *((volatile unsigned char*)(0x42C61004UL))
#define bFM4_CAN1_TREQR1_TXRQST3               *((volatile unsigned char*)(0x42C61008UL))
#define bFM4_CAN1_TREQR1_TXRQST4               *((volatile unsigned char*)(0x42C6100CUL))
#define bFM4_CAN1_TREQR1_TXRQST5               *((volatile unsigned char*)(0x42C61010UL))
#define bFM4_CAN1_TREQR1_TXRQST6               *((volatile unsigned char*)(0x42C61014UL))
#define bFM4_CAN1_TREQR1_TXRQST7               *((volatile unsigned char*)(0x42C61018UL))
#define bFM4_CAN1_TREQR1_TXRQST8               *((volatile unsigned char*)(0x42C6101CUL))
#define bFM4_CAN1_TREQR1_TXRQST9               *((volatile unsigned char*)(0x42C61020UL))
#define bFM4_CAN1_TREQR1_TXRQST10              *((volatile unsigned char*)(0x42C61024UL))
#define bFM4_CAN1_TREQR1_TXRQST11              *((volatile unsigned char*)(0x42C61028UL))
#define bFM4_CAN1_TREQR1_TXRQST12              *((volatile unsigned char*)(0x42C6102CUL))
#define bFM4_CAN1_TREQR1_TXRQST13              *((volatile unsigned char*)(0x42C61030UL))
#define bFM4_CAN1_TREQR1_TXRQST14              *((volatile unsigned char*)(0x42C61034UL))
#define bFM4_CAN1_TREQR1_TXRQST15              *((volatile unsigned char*)(0x42C61038UL))
#define bFM4_CAN1_TREQR1_TXRQST16              *((volatile unsigned char*)(0x42C6103CUL))
#define bFM4_CAN1_TREQR2_TXRQST17              *((volatile unsigned char*)(0x42C61040UL))
#define bFM4_CAN1_TREQR2_TXRQST18              *((volatile unsigned char*)(0x42C61044UL))
#define bFM4_CAN1_TREQR2_TXRQST19              *((volatile unsigned char*)(0x42C61048UL))
#define bFM4_CAN1_TREQR2_TXRQST20              *((volatile unsigned char*)(0x42C6104CUL))
#define bFM4_CAN1_TREQR2_TXRQST21              *((volatile unsigned char*)(0x42C61050UL))
#define bFM4_CAN1_TREQR2_TXRQST22              *((volatile unsigned char*)(0x42C61054UL))
#define bFM4_CAN1_TREQR2_TXRQST23              *((volatile unsigned char*)(0x42C61058UL))
#define bFM4_CAN1_TREQR2_TXRQST24              *((volatile unsigned char*)(0x42C6105CUL))
#define bFM4_CAN1_TREQR2_TXRQST25              *((volatile unsigned char*)(0x42C61060UL))
#define bFM4_CAN1_TREQR2_TXRQST26              *((volatile unsigned char*)(0x42C61064UL))
#define bFM4_CAN1_TREQR2_TXRQST27              *((volatile unsigned char*)(0x42C61068UL))
#define bFM4_CAN1_TREQR2_TXRQST28              *((volatile unsigned char*)(0x42C6106CUL))
#define bFM4_CAN1_TREQR2_TXRQST29              *((volatile unsigned char*)(0x42C61070UL))
#define bFM4_CAN1_TREQR2_TXRQST30              *((volatile unsigned char*)(0x42C61074UL))
#define bFM4_CAN1_TREQR2_TXRQST31              *((volatile unsigned char*)(0x42C61078UL))
#define bFM4_CAN1_TREQR2_TXRQST32              *((volatile unsigned char*)(0x42C6107CUL))
#define bFM4_CAN1_NEWDT_NEWDAT1                *((volatile unsigned char*)(0x42C61200UL))
#define bFM4_CAN1_NEWDT_NEWDAT2                *((volatile unsigned char*)(0x42C61204UL))
#define bFM4_CAN1_NEWDT_NEWDAT3                *((volatile unsigned char*)(0x42C61208UL))
#define bFM4_CAN1_NEWDT_NEWDAT4                *((volatile unsigned char*)(0x42C6120CUL))
#define bFM4_CAN1_NEWDT_NEWDAT5                *((volatile unsigned char*)(0x42C61210UL))
#define bFM4_CAN1_NEWDT_NEWDAT6                *((volatile unsigned char*)(0x42C61214UL))
#define bFM4_CAN1_NEWDT_NEWDAT7                *((volatile unsigned char*)(0x42C61218UL))
#define bFM4_CAN1_NEWDT_NEWDAT8                *((volatile unsigned char*)(0x42C6121CUL))
#define bFM4_CAN1_NEWDT_NEWDAT9                *((volatile unsigned char*)(0x42C61220UL))
#define bFM4_CAN1_NEWDT_NEWDAT10               *((volatile unsigned char*)(0x42C61224UL))
#define bFM4_CAN1_NEWDT_NEWDAT11               *((volatile unsigned char*)(0x42C61228UL))
#define bFM4_CAN1_NEWDT_NEWDAT12               *((volatile unsigned char*)(0x42C6122CUL))
#define bFM4_CAN1_NEWDT_NEWDAT13               *((volatile unsigned char*)(0x42C61230UL))
#define bFM4_CAN1_NEWDT_NEWDAT14               *((volatile unsigned char*)(0x42C61234UL))
#define bFM4_CAN1_NEWDT_NEWDAT15               *((volatile unsigned char*)(0x42C61238UL))
#define bFM4_CAN1_NEWDT_NEWDAT16               *((volatile unsigned char*)(0x42C6123CUL))
#define bFM4_CAN1_NEWDT_NEWDAT17               *((volatile unsigned char*)(0x42C61240UL))
#define bFM4_CAN1_NEWDT_NEWDAT18               *((volatile unsigned char*)(0x42C61244UL))
#define bFM4_CAN1_NEWDT_NEWDAT19               *((volatile unsigned char*)(0x42C61248UL))
#define bFM4_CAN1_NEWDT_NEWDAT20               *((volatile unsigned char*)(0x42C6124CUL))
#define bFM4_CAN1_NEWDT_NEWDAT21               *((volatile unsigned char*)(0x42C61250UL))
#define bFM4_CAN1_NEWDT_NEWDAT22               *((volatile unsigned char*)(0x42C61254UL))
#define bFM4_CAN1_NEWDT_NEWDAT23               *((volatile unsigned char*)(0x42C61258UL))
#define bFM4_CAN1_NEWDT_NEWDAT24               *((volatile unsigned char*)(0x42C6125CUL))
#define bFM4_CAN1_NEWDT_NEWDAT25               *((volatile unsigned char*)(0x42C61260UL))
#define bFM4_CAN1_NEWDT_NEWDAT26               *((volatile unsigned char*)(0x42C61264UL))
#define bFM4_CAN1_NEWDT_NEWDAT27               *((volatile unsigned char*)(0x42C61268UL))
#define bFM4_CAN1_NEWDT_NEWDAT28               *((volatile unsigned char*)(0x42C6126CUL))
#define bFM4_CAN1_NEWDT_NEWDAT29               *((volatile unsigned char*)(0x42C61270UL))
#define bFM4_CAN1_NEWDT_NEWDAT30               *((volatile unsigned char*)(0x42C61274UL))
#define bFM4_CAN1_NEWDT_NEWDAT31               *((volatile unsigned char*)(0x42C61278UL))
#define bFM4_CAN1_NEWDT_NEWDAT32               *((volatile unsigned char*)(0x42C6127CUL))
#define bFM4_CAN1_NEWDT1_NEWDAT1               *((volatile unsigned char*)(0x42C61200UL))
#define bFM4_CAN1_NEWDT1_NEWDAT2               *((volatile unsigned char*)(0x42C61204UL))
#define bFM4_CAN1_NEWDT1_NEWDAT3               *((volatile unsigned char*)(0x42C61208UL))
#define bFM4_CAN1_NEWDT1_NEWDAT4               *((volatile unsigned char*)(0x42C6120CUL))
#define bFM4_CAN1_NEWDT1_NEWDAT5               *((volatile unsigned char*)(0x42C61210UL))
#define bFM4_CAN1_NEWDT1_NEWDAT6               *((volatile unsigned char*)(0x42C61214UL))
#define bFM4_CAN1_NEWDT1_NEWDAT7               *((volatile unsigned char*)(0x42C61218UL))
#define bFM4_CAN1_NEWDT1_NEWDAT8               *((volatile unsigned char*)(0x42C6121CUL))
#define bFM4_CAN1_NEWDT1_NEWDAT9               *((volatile unsigned char*)(0x42C61220UL))
#define bFM4_CAN1_NEWDT1_NEWDAT10              *((volatile unsigned char*)(0x42C61224UL))
#define bFM4_CAN1_NEWDT1_NEWDAT11              *((volatile unsigned char*)(0x42C61228UL))
#define bFM4_CAN1_NEWDT1_NEWDAT12              *((volatile unsigned char*)(0x42C6122CUL))
#define bFM4_CAN1_NEWDT1_NEWDAT13              *((volatile unsigned char*)(0x42C61230UL))
#define bFM4_CAN1_NEWDT1_NEWDAT14              *((volatile unsigned char*)(0x42C61234UL))
#define bFM4_CAN1_NEWDT1_NEWDAT15              *((volatile unsigned char*)(0x42C61238UL))
#define bFM4_CAN1_NEWDT1_NEWDAT16              *((volatile unsigned char*)(0x42C6123CUL))
#define bFM4_CAN1_NEWDT2_NEWDAT17              *((volatile unsigned char*)(0x42C61240UL))
#define bFM4_CAN1_NEWDT2_NEWDAT18              *((volatile unsigned char*)(0x42C61244UL))
#define bFM4_CAN1_NEWDT2_NEWDAT19              *((volatile unsigned char*)(0x42C61248UL))
#define bFM4_CAN1_NEWDT2_NEWDAT20              *((volatile unsigned char*)(0x42C6124CUL))
#define bFM4_CAN1_NEWDT2_NEWDAT21              *((volatile unsigned char*)(0x42C61250UL))
#define bFM4_CAN1_NEWDT2_NEWDAT22              *((volatile unsigned char*)(0x42C61254UL))
#define bFM4_CAN1_NEWDT2_NEWDAT23              *((volatile unsigned char*)(0x42C61258UL))
#define bFM4_CAN1_NEWDT2_NEWDAT24              *((volatile unsigned char*)(0x42C6125CUL))
#define bFM4_CAN1_NEWDT2_NEWDAT25              *((volatile unsigned char*)(0x42C61260UL))
#define bFM4_CAN1_NEWDT2_NEWDAT26              *((volatile unsigned char*)(0x42C61264UL))
#define bFM4_CAN1_NEWDT2_NEWDAT27              *((volatile unsigned char*)(0x42C61268UL))
#define bFM4_CAN1_NEWDT2_NEWDAT28              *((volatile unsigned char*)(0x42C6126CUL))
#define bFM4_CAN1_NEWDT2_NEWDAT29              *((volatile unsigned char*)(0x42C61270UL))
#define bFM4_CAN1_NEWDT2_NEWDAT30              *((volatile unsigned char*)(0x42C61274UL))
#define bFM4_CAN1_NEWDT2_NEWDAT31              *((volatile unsigned char*)(0x42C61278UL))
#define bFM4_CAN1_NEWDT2_NEWDAT32              *((volatile unsigned char*)(0x42C6127CUL))
#define bFM4_CAN1_INTPND_INTPND1               *((volatile unsigned char*)(0x42C61400UL))
#define bFM4_CAN1_INTPND_INTPND2               *((volatile unsigned char*)(0x42C61404UL))
#define bFM4_CAN1_INTPND_INTPND3               *((volatile unsigned char*)(0x42C61408UL))
#define bFM4_CAN1_INTPND_INTPND4               *((volatile unsigned char*)(0x42C6140CUL))
#define bFM4_CAN1_INTPND_INTPND5               *((volatile unsigned char*)(0x42C61410UL))
#define bFM4_CAN1_INTPND_INTPND6               *((volatile unsigned char*)(0x42C61414UL))
#define bFM4_CAN1_INTPND_INTPND7               *((volatile unsigned char*)(0x42C61418UL))
#define bFM4_CAN1_INTPND_INTPND8               *((volatile unsigned char*)(0x42C6141CUL))
#define bFM4_CAN1_INTPND_INTPND9               *((volatile unsigned char*)(0x42C61420UL))
#define bFM4_CAN1_INTPND_INTPND10              *((volatile unsigned char*)(0x42C61424UL))
#define bFM4_CAN1_INTPND_INTPND11              *((volatile unsigned char*)(0x42C61428UL))
#define bFM4_CAN1_INTPND_INTPND12              *((volatile unsigned char*)(0x42C6142CUL))
#define bFM4_CAN1_INTPND_INTPND13              *((volatile unsigned char*)(0x42C61430UL))
#define bFM4_CAN1_INTPND_INTPND14              *((volatile unsigned char*)(0x42C61434UL))
#define bFM4_CAN1_INTPND_INTPND15              *((volatile unsigned char*)(0x42C61438UL))
#define bFM4_CAN1_INTPND_INTPND16              *((volatile unsigned char*)(0x42C6143CUL))
#define bFM4_CAN1_INTPND_INTPND17              *((volatile unsigned char*)(0x42C61440UL))
#define bFM4_CAN1_INTPND_INTPND18              *((volatile unsigned char*)(0x42C61444UL))
#define bFM4_CAN1_INTPND_INTPND19              *((volatile unsigned char*)(0x42C61448UL))
#define bFM4_CAN1_INTPND_INTPND20              *((volatile unsigned char*)(0x42C6144CUL))
#define bFM4_CAN1_INTPND_INTPND21              *((volatile unsigned char*)(0x42C61450UL))
#define bFM4_CAN1_INTPND_INTPND22              *((volatile unsigned char*)(0x42C61454UL))
#define bFM4_CAN1_INTPND_INTPND23              *((volatile unsigned char*)(0x42C61458UL))
#define bFM4_CAN1_INTPND_INTPND24              *((volatile unsigned char*)(0x42C6145CUL))
#define bFM4_CAN1_INTPND_INTPND25              *((volatile unsigned char*)(0x42C61460UL))
#define bFM4_CAN1_INTPND_INTPND26              *((volatile unsigned char*)(0x42C61464UL))
#define bFM4_CAN1_INTPND_INTPND27              *((volatile unsigned char*)(0x42C61468UL))
#define bFM4_CAN1_INTPND_INTPND28              *((volatile unsigned char*)(0x42C6146CUL))
#define bFM4_CAN1_INTPND_INTPND29              *((volatile unsigned char*)(0x42C61470UL))
#define bFM4_CAN1_INTPND_INTPND30              *((volatile unsigned char*)(0x42C61474UL))
#define bFM4_CAN1_INTPND_INTPND31              *((volatile unsigned char*)(0x42C61478UL))
#define bFM4_CAN1_INTPND_INTPND32              *((volatile unsigned char*)(0x42C6147CUL))
#define bFM4_CAN1_INTPND1_INTPND1              *((volatile unsigned char*)(0x42C61400UL))
#define bFM4_CAN1_INTPND1_INTPND2              *((volatile unsigned char*)(0x42C61404UL))
#define bFM4_CAN1_INTPND1_INTPND3              *((volatile unsigned char*)(0x42C61408UL))
#define bFM4_CAN1_INTPND1_INTPND4              *((volatile unsigned char*)(0x42C6140CUL))
#define bFM4_CAN1_INTPND1_INTPND5              *((volatile unsigned char*)(0x42C61410UL))
#define bFM4_CAN1_INTPND1_INTPND6              *((volatile unsigned char*)(0x42C61414UL))
#define bFM4_CAN1_INTPND1_INTPND7              *((volatile unsigned char*)(0x42C61418UL))
#define bFM4_CAN1_INTPND1_INTPND8              *((volatile unsigned char*)(0x42C6141CUL))
#define bFM4_CAN1_INTPND1_INTPND9              *((volatile unsigned char*)(0x42C61420UL))
#define bFM4_CAN1_INTPND1_INTPND10             *((volatile unsigned char*)(0x42C61424UL))
#define bFM4_CAN1_INTPND1_INTPND11             *((volatile unsigned char*)(0x42C61428UL))
#define bFM4_CAN1_INTPND1_INTPND12             *((volatile unsigned char*)(0x42C6142CUL))
#define bFM4_CAN1_INTPND1_INTPND13             *((volatile unsigned char*)(0x42C61430UL))
#define bFM4_CAN1_INTPND1_INTPND14             *((volatile unsigned char*)(0x42C61434UL))
#define bFM4_CAN1_INTPND1_INTPND15             *((volatile unsigned char*)(0x42C61438UL))
#define bFM4_CAN1_INTPND1_INTPND16             *((volatile unsigned char*)(0x42C6143CUL))
#define bFM4_CAN1_INTPND2_INTPND17             *((volatile unsigned char*)(0x42C61440UL))
#define bFM4_CAN1_INTPND2_INTPND18             *((volatile unsigned char*)(0x42C61444UL))
#define bFM4_CAN1_INTPND2_INTPND19             *((volatile unsigned char*)(0x42C61448UL))
#define bFM4_CAN1_INTPND2_INTPND20             *((volatile unsigned char*)(0x42C6144CUL))
#define bFM4_CAN1_INTPND2_INTPND21             *((volatile unsigned char*)(0x42C61450UL))
#define bFM4_CAN1_INTPND2_INTPND22             *((volatile unsigned char*)(0x42C61454UL))
#define bFM4_CAN1_INTPND2_INTPND23             *((volatile unsigned char*)(0x42C61458UL))
#define bFM4_CAN1_INTPND2_INTPND24             *((volatile unsigned char*)(0x42C6145CUL))
#define bFM4_CAN1_INTPND2_INTPND25             *((volatile unsigned char*)(0x42C61460UL))
#define bFM4_CAN1_INTPND2_INTPND26             *((volatile unsigned char*)(0x42C61464UL))
#define bFM4_CAN1_INTPND2_INTPND27             *((volatile unsigned char*)(0x42C61468UL))
#define bFM4_CAN1_INTPND2_INTPND28             *((volatile unsigned char*)(0x42C6146CUL))
#define bFM4_CAN1_INTPND2_INTPND29             *((volatile unsigned char*)(0x42C61470UL))
#define bFM4_CAN1_INTPND2_INTPND30             *((volatile unsigned char*)(0x42C61474UL))
#define bFM4_CAN1_INTPND2_INTPND31             *((volatile unsigned char*)(0x42C61478UL))
#define bFM4_CAN1_INTPND2_INTPND32             *((volatile unsigned char*)(0x42C6147CUL))
#define bFM4_CAN1_MSGVAL_MSGVAL1               *((volatile unsigned char*)(0x42C61600UL))
#define bFM4_CAN1_MSGVAL_MSGVAL2               *((volatile unsigned char*)(0x42C61604UL))
#define bFM4_CAN1_MSGVAL_MSGVAL3               *((volatile unsigned char*)(0x42C61608UL))
#define bFM4_CAN1_MSGVAL_MSGVAL4               *((volatile unsigned char*)(0x42C6160CUL))
#define bFM4_CAN1_MSGVAL_MSGVAL5               *((volatile unsigned char*)(0x42C61610UL))
#define bFM4_CAN1_MSGVAL_MSGVAL6               *((volatile unsigned char*)(0x42C61614UL))
#define bFM4_CAN1_MSGVAL_MSGVAL7               *((volatile unsigned char*)(0x42C61618UL))
#define bFM4_CAN1_MSGVAL_MSGVAL8               *((volatile unsigned char*)(0x42C6161CUL))
#define bFM4_CAN1_MSGVAL_MSGVAL9               *((volatile unsigned char*)(0x42C61620UL))
#define bFM4_CAN1_MSGVAL_MSGVAL10              *((volatile unsigned char*)(0x42C61624UL))
#define bFM4_CAN1_MSGVAL_MSGVAL11              *((volatile unsigned char*)(0x42C61628UL))
#define bFM4_CAN1_MSGVAL_MSGVAL12              *((volatile unsigned char*)(0x42C6162CUL))
#define bFM4_CAN1_MSGVAL_MSGVAL13              *((volatile unsigned char*)(0x42C61630UL))
#define bFM4_CAN1_MSGVAL_MSGVAL14              *((volatile unsigned char*)(0x42C61634UL))
#define bFM4_CAN1_MSGVAL_MSGVAL15              *((volatile unsigned char*)(0x42C61638UL))
#define bFM4_CAN1_MSGVAL_MSGVAL16              *((volatile unsigned char*)(0x42C6163CUL))
#define bFM4_CAN1_MSGVAL_MSGVAL17              *((volatile unsigned char*)(0x42C61640UL))
#define bFM4_CAN1_MSGVAL_MSGVAL18              *((volatile unsigned char*)(0x42C61644UL))
#define bFM4_CAN1_MSGVAL_MSGVAL19              *((volatile unsigned char*)(0x42C61648UL))
#define bFM4_CAN1_MSGVAL_MSGVAL20              *((volatile unsigned char*)(0x42C6164CUL))
#define bFM4_CAN1_MSGVAL_MSGVAL21              *((volatile unsigned char*)(0x42C61650UL))
#define bFM4_CAN1_MSGVAL_MSGVAL22              *((volatile unsigned char*)(0x42C61654UL))
#define bFM4_CAN1_MSGVAL_MSGVAL23              *((volatile unsigned char*)(0x42C61658UL))
#define bFM4_CAN1_MSGVAL_MSGVAL24              *((volatile unsigned char*)(0x42C6165CUL))
#define bFM4_CAN1_MSGVAL_MSGVAL25              *((volatile unsigned char*)(0x42C61660UL))
#define bFM4_CAN1_MSGVAL_MSGVAL26              *((volatile unsigned char*)(0x42C61664UL))
#define bFM4_CAN1_MSGVAL_MSGVAL27              *((volatile unsigned char*)(0x42C61668UL))
#define bFM4_CAN1_MSGVAL_MSGVAL28              *((volatile unsigned char*)(0x42C6166CUL))
#define bFM4_CAN1_MSGVAL_MSGVAL29              *((volatile unsigned char*)(0x42C61670UL))
#define bFM4_CAN1_MSGVAL_MSGVAL30              *((volatile unsigned char*)(0x42C61674UL))
#define bFM4_CAN1_MSGVAL_MSGVAL31              *((volatile unsigned char*)(0x42C61678UL))
#define bFM4_CAN1_MSGVAL_MSGVAL32              *((volatile unsigned char*)(0x42C6167CUL))
#define bFM4_CAN1_MSGVAL1_MSGVAL1              *((volatile unsigned char*)(0x42C61600UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL2              *((volatile unsigned char*)(0x42C61604UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL3              *((volatile unsigned char*)(0x42C61608UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL4              *((volatile unsigned char*)(0x42C6160CUL))
#define bFM4_CAN1_MSGVAL1_MSGVAL5              *((volatile unsigned char*)(0x42C61610UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL6              *((volatile unsigned char*)(0x42C61614UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL7              *((volatile unsigned char*)(0x42C61618UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL8              *((volatile unsigned char*)(0x42C6161CUL))
#define bFM4_CAN1_MSGVAL1_MSGVAL9              *((volatile unsigned char*)(0x42C61620UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL10             *((volatile unsigned char*)(0x42C61624UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL11             *((volatile unsigned char*)(0x42C61628UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL12             *((volatile unsigned char*)(0x42C6162CUL))
#define bFM4_CAN1_MSGVAL1_MSGVAL13             *((volatile unsigned char*)(0x42C61630UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL14             *((volatile unsigned char*)(0x42C61634UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL15             *((volatile unsigned char*)(0x42C61638UL))
#define bFM4_CAN1_MSGVAL1_MSGVAL16             *((volatile unsigned char*)(0x42C6163CUL))
#define bFM4_CAN1_MSGVAL2_MSGVAL17             *((volatile unsigned char*)(0x42C61640UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL18             *((volatile unsigned char*)(0x42C61644UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL19             *((volatile unsigned char*)(0x42C61648UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL20             *((volatile unsigned char*)(0x42C6164CUL))
#define bFM4_CAN1_MSGVAL2_MSGVAL21             *((volatile unsigned char*)(0x42C61650UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL22             *((volatile unsigned char*)(0x42C61654UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL23             *((volatile unsigned char*)(0x42C61658UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL24             *((volatile unsigned char*)(0x42C6165CUL))
#define bFM4_CAN1_MSGVAL2_MSGVAL25             *((volatile unsigned char*)(0x42C61660UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL26             *((volatile unsigned char*)(0x42C61664UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL27             *((volatile unsigned char*)(0x42C61668UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL28             *((volatile unsigned char*)(0x42C6166CUL))
#define bFM4_CAN1_MSGVAL2_MSGVAL29             *((volatile unsigned char*)(0x42C61670UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL30             *((volatile unsigned char*)(0x42C61674UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL31             *((volatile unsigned char*)(0x42C61678UL))
#define bFM4_CAN1_MSGVAL2_MSGVAL32             *((volatile unsigned char*)(0x42C6167CUL))

/* Ethernet MAC 0 registers */
#define bFM4_ETHERNET_MAC0_MCR_RE              *((volatile unsigned char*)(0x42C80008UL))
#define bFM4_ETHERNET_MAC0_MCR_TE              *((volatile unsigned char*)(0x42C8000CUL))
#define bFM4_ETHERNET_MAC0_MCR_DC              *((volatile unsigned char*)(0x42C80010UL))
#define bFM4_ETHERNET_MAC0_MCR_BL0             *((volatile unsigned char*)(0x42C80014UL))
#define bFM4_ETHERNET_MAC0_MCR_BL1             *((volatile unsigned char*)(0x42C80018UL))
#define bFM4_ETHERNET_MAC0_MCR_ACS             *((volatile unsigned char*)(0x42C8001CUL))
#define bFM4_ETHERNET_MAC0_MCR_LUD             *((volatile unsigned char*)(0x42C80020UL))
#define bFM4_ETHERNET_MAC0_MCR_DR              *((volatile unsigned char*)(0x42C80024UL))
#define bFM4_ETHERNET_MAC0_MCR_IPC             *((volatile unsigned char*)(0x42C80028UL))
#define bFM4_ETHERNET_MAC0_MCR_DM              *((volatile unsigned char*)(0x42C8002CUL))
#define bFM4_ETHERNET_MAC0_MCR_LM              *((volatile unsigned char*)(0x42C80030UL))
#define bFM4_ETHERNET_MAC0_MCR_DO              *((volatile unsigned char*)(0x42C80034UL))
#define bFM4_ETHERNET_MAC0_MCR_FES             *((volatile unsigned char*)(0x42C80038UL))
#define bFM4_ETHERNET_MAC0_MCR_PS              *((volatile unsigned char*)(0x42C8003CUL))
#define bFM4_ETHERNET_MAC0_MCR_DCRS            *((volatile unsigned char*)(0x42C80040UL))
#define bFM4_ETHERNET_MAC0_MCR_IFG0            *((volatile unsigned char*)(0x42C80044UL))
#define bFM4_ETHERNET_MAC0_MCR_IFG1            *((volatile unsigned char*)(0x42C80048UL))
#define bFM4_ETHERNET_MAC0_MCR_IFG2            *((volatile unsigned char*)(0x42C8004CUL))
#define bFM4_ETHERNET_MAC0_MCR_JE              *((volatile unsigned char*)(0x42C80050UL))
#define bFM4_ETHERNET_MAC0_MCR_BE              *((volatile unsigned char*)(0x42C80054UL))
#define bFM4_ETHERNET_MAC0_MCR_JD              *((volatile unsigned char*)(0x42C80058UL))
#define bFM4_ETHERNET_MAC0_MCR_WD              *((volatile unsigned char*)(0x42C8005CUL))
#define bFM4_ETHERNET_MAC0_MCR_TC              *((volatile unsigned char*)(0x42C80060UL))
#define bFM4_ETHERNET_MAC0_MCR_CST             *((volatile unsigned char*)(0x42C80064UL))
#define bFM4_ETHERNET_MAC0_MFFR_PR             *((volatile unsigned char*)(0x42C80080UL))
#define bFM4_ETHERNET_MAC0_MFFR_HUC            *((volatile unsigned char*)(0x42C80084UL))
#define bFM4_ETHERNET_MAC0_MFFR_HMC            *((volatile unsigned char*)(0x42C80088UL))
#define bFM4_ETHERNET_MAC0_MFFR_DAIF           *((volatile unsigned char*)(0x42C8008CUL))
#define bFM4_ETHERNET_MAC0_MFFR_PM             *((volatile unsigned char*)(0x42C80090UL))
#define bFM4_ETHERNET_MAC0_MFFR_DB             *((volatile unsigned char*)(0x42C80094UL))
#define bFM4_ETHERNET_MAC0_MFFR_PCF0           *((volatile unsigned char*)(0x42C80098UL))
#define bFM4_ETHERNET_MAC0_MFFR_PCF1           *((volatile unsigned char*)(0x42C8009CUL))
#define bFM4_ETHERNET_MAC0_MFFR_SAIF           *((volatile unsigned char*)(0x42C800A0UL))
#define bFM4_ETHERNET_MAC0_MFFR_SAF            *((volatile unsigned char*)(0x42C800A4UL))
#define bFM4_ETHERNET_MAC0_MFFR_HPF            *((volatile unsigned char*)(0x42C800A8UL))
#define bFM4_ETHERNET_MAC0_MFFR_RA             *((volatile unsigned char*)(0x42C800FCUL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH0          *((volatile unsigned char*)(0x42C80100UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH1          *((volatile unsigned char*)(0x42C80104UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH2          *((volatile unsigned char*)(0x42C80108UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH3          *((volatile unsigned char*)(0x42C8010CUL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH4          *((volatile unsigned char*)(0x42C80110UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH5          *((volatile unsigned char*)(0x42C80114UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH6          *((volatile unsigned char*)(0x42C80118UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH7          *((volatile unsigned char*)(0x42C8011CUL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH8          *((volatile unsigned char*)(0x42C80120UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH9          *((volatile unsigned char*)(0x42C80124UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH10         *((volatile unsigned char*)(0x42C80128UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH11         *((volatile unsigned char*)(0x42C8012CUL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH12         *((volatile unsigned char*)(0x42C80130UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH13         *((volatile unsigned char*)(0x42C80134UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH14         *((volatile unsigned char*)(0x42C80138UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH15         *((volatile unsigned char*)(0x42C8013CUL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH16         *((volatile unsigned char*)(0x42C80140UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH17         *((volatile unsigned char*)(0x42C80144UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH18         *((volatile unsigned char*)(0x42C80148UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH19         *((volatile unsigned char*)(0x42C8014CUL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH20         *((volatile unsigned char*)(0x42C80150UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH21         *((volatile unsigned char*)(0x42C80154UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH22         *((volatile unsigned char*)(0x42C80158UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH23         *((volatile unsigned char*)(0x42C8015CUL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH24         *((volatile unsigned char*)(0x42C80160UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH25         *((volatile unsigned char*)(0x42C80164UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH26         *((volatile unsigned char*)(0x42C80168UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH27         *((volatile unsigned char*)(0x42C8016CUL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH28         *((volatile unsigned char*)(0x42C80170UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH29         *((volatile unsigned char*)(0x42C80174UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH30         *((volatile unsigned char*)(0x42C80178UL))
#define bFM4_ETHERNET_MAC0_MHTRH_HTH31         *((volatile unsigned char*)(0x42C8017CUL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL0          *((volatile unsigned char*)(0x42C80180UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL1          *((volatile unsigned char*)(0x42C80184UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL2          *((volatile unsigned char*)(0x42C80188UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL3          *((volatile unsigned char*)(0x42C8018CUL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL4          *((volatile unsigned char*)(0x42C80190UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL5          *((volatile unsigned char*)(0x42C80194UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL6          *((volatile unsigned char*)(0x42C80198UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL7          *((volatile unsigned char*)(0x42C8019CUL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL8          *((volatile unsigned char*)(0x42C801A0UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL9          *((volatile unsigned char*)(0x42C801A4UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL10         *((volatile unsigned char*)(0x42C801A8UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL11         *((volatile unsigned char*)(0x42C801ACUL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL12         *((volatile unsigned char*)(0x42C801B0UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL13         *((volatile unsigned char*)(0x42C801B4UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL14         *((volatile unsigned char*)(0x42C801B8UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL15         *((volatile unsigned char*)(0x42C801BCUL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL16         *((volatile unsigned char*)(0x42C801C0UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL17         *((volatile unsigned char*)(0x42C801C4UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL18         *((volatile unsigned char*)(0x42C801C8UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL19         *((volatile unsigned char*)(0x42C801CCUL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL20         *((volatile unsigned char*)(0x42C801D0UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL21         *((volatile unsigned char*)(0x42C801D4UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL22         *((volatile unsigned char*)(0x42C801D8UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL23         *((volatile unsigned char*)(0x42C801DCUL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL24         *((volatile unsigned char*)(0x42C801E0UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL25         *((volatile unsigned char*)(0x42C801E4UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL26         *((volatile unsigned char*)(0x42C801E8UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL27         *((volatile unsigned char*)(0x42C801ECUL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL28         *((volatile unsigned char*)(0x42C801F0UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL29         *((volatile unsigned char*)(0x42C801F4UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL30         *((volatile unsigned char*)(0x42C801F8UL))
#define bFM4_ETHERNET_MAC0_MHTRL_HTL31         *((volatile unsigned char*)(0x42C801FCUL))
#define bFM4_ETHERNET_MAC0_GAR_GB              *((volatile unsigned char*)(0x42C80200UL))
#define bFM4_ETHERNET_MAC0_GAR_GW              *((volatile unsigned char*)(0x42C80204UL))
#define bFM4_ETHERNET_MAC0_GAR_CR0             *((volatile unsigned char*)(0x42C80208UL))
#define bFM4_ETHERNET_MAC0_GAR_CR1             *((volatile unsigned char*)(0x42C8020CUL))
#define bFM4_ETHERNET_MAC0_GAR_CR2             *((volatile unsigned char*)(0x42C80210UL))
#define bFM4_ETHERNET_MAC0_GAR_CR3             *((volatile unsigned char*)(0x42C80214UL))
#define bFM4_ETHERNET_MAC0_GAR_GR0             *((volatile unsigned char*)(0x42C80218UL))
#define bFM4_ETHERNET_MAC0_GAR_GR1             *((volatile unsigned char*)(0x42C8021CUL))
#define bFM4_ETHERNET_MAC0_GAR_GR2             *((volatile unsigned char*)(0x42C80220UL))
#define bFM4_ETHERNET_MAC0_GAR_GR3             *((volatile unsigned char*)(0x42C80224UL))
#define bFM4_ETHERNET_MAC0_GAR_GR4             *((volatile unsigned char*)(0x42C80228UL))
#define bFM4_ETHERNET_MAC0_GAR_PA0             *((volatile unsigned char*)(0x42C8022CUL))
#define bFM4_ETHERNET_MAC0_GAR_PA1             *((volatile unsigned char*)(0x42C80230UL))
#define bFM4_ETHERNET_MAC0_GAR_PA2             *((volatile unsigned char*)(0x42C80234UL))
#define bFM4_ETHERNET_MAC0_GAR_PA3             *((volatile unsigned char*)(0x42C80238UL))
#define bFM4_ETHERNET_MAC0_GAR_PA4             *((volatile unsigned char*)(0x42C8023CUL))
#define bFM4_ETHERNET_MAC0_GDR_GD0             *((volatile unsigned char*)(0x42C80280UL))
#define bFM4_ETHERNET_MAC0_GDR_GD1             *((volatile unsigned char*)(0x42C80284UL))
#define bFM4_ETHERNET_MAC0_GDR_GD2             *((volatile unsigned char*)(0x42C80288UL))
#define bFM4_ETHERNET_MAC0_GDR_GD3             *((volatile unsigned char*)(0x42C8028CUL))
#define bFM4_ETHERNET_MAC0_GDR_GD4             *((volatile unsigned char*)(0x42C80290UL))
#define bFM4_ETHERNET_MAC0_GDR_GD5             *((volatile unsigned char*)(0x42C80294UL))
#define bFM4_ETHERNET_MAC0_GDR_GD6             *((volatile unsigned char*)(0x42C80298UL))
#define bFM4_ETHERNET_MAC0_GDR_GD7             *((volatile unsigned char*)(0x42C8029CUL))
#define bFM4_ETHERNET_MAC0_GDR_GD8             *((volatile unsigned char*)(0x42C802A0UL))
#define bFM4_ETHERNET_MAC0_GDR_GD9             *((volatile unsigned char*)(0x42C802A4UL))
#define bFM4_ETHERNET_MAC0_GDR_GD10            *((volatile unsigned char*)(0x42C802A8UL))
#define bFM4_ETHERNET_MAC0_GDR_GD11            *((volatile unsigned char*)(0x42C802ACUL))
#define bFM4_ETHERNET_MAC0_GDR_GD12            *((volatile unsigned char*)(0x42C802B0UL))
#define bFM4_ETHERNET_MAC0_GDR_GD13            *((volatile unsigned char*)(0x42C802B4UL))
#define bFM4_ETHERNET_MAC0_GDR_GD14            *((volatile unsigned char*)(0x42C802B8UL))
#define bFM4_ETHERNET_MAC0_GDR_GD15            *((volatile unsigned char*)(0x42C802BCUL))
#define bFM4_ETHERNET_MAC0_FCR_FCB_BPA         *((volatile unsigned char*)(0x42C80300UL))
#define bFM4_ETHERNET_MAC0_FCR_TFE             *((volatile unsigned char*)(0x42C80304UL))
#define bFM4_ETHERNET_MAC0_FCR_RFE             *((volatile unsigned char*)(0x42C80308UL))
#define bFM4_ETHERNET_MAC0_FCR_UP              *((volatile unsigned char*)(0x42C8030CUL))
#define bFM4_ETHERNET_MAC0_FCR_PLT0            *((volatile unsigned char*)(0x42C80310UL))
#define bFM4_ETHERNET_MAC0_FCR_PLT1            *((volatile unsigned char*)(0x42C80314UL))
#define bFM4_ETHERNET_MAC0_FCR_DZPQ            *((volatile unsigned char*)(0x42C8031CUL))
#define bFM4_ETHERNET_MAC0_FCR_PT0             *((volatile unsigned char*)(0x42C80340UL))
#define bFM4_ETHERNET_MAC0_FCR_PT1             *((volatile unsigned char*)(0x42C80344UL))
#define bFM4_ETHERNET_MAC0_FCR_PT2             *((volatile unsigned char*)(0x42C80348UL))
#define bFM4_ETHERNET_MAC0_FCR_PT3             *((volatile unsigned char*)(0x42C8034CUL))
#define bFM4_ETHERNET_MAC0_FCR_PT4             *((volatile unsigned char*)(0x42C80350UL))
#define bFM4_ETHERNET_MAC0_FCR_PT5             *((volatile unsigned char*)(0x42C80354UL))
#define bFM4_ETHERNET_MAC0_FCR_PT6             *((volatile unsigned char*)(0x42C80358UL))
#define bFM4_ETHERNET_MAC0_FCR_PT7             *((volatile unsigned char*)(0x42C8035CUL))
#define bFM4_ETHERNET_MAC0_FCR_PT8             *((volatile unsigned char*)(0x42C80360UL))
#define bFM4_ETHERNET_MAC0_FCR_PT9             *((volatile unsigned char*)(0x42C80364UL))
#define bFM4_ETHERNET_MAC0_FCR_PT10            *((volatile unsigned char*)(0x42C80368UL))
#define bFM4_ETHERNET_MAC0_FCR_PT11            *((volatile unsigned char*)(0x42C8036CUL))
#define bFM4_ETHERNET_MAC0_FCR_PT12            *((volatile unsigned char*)(0x42C80370UL))
#define bFM4_ETHERNET_MAC0_FCR_PT13            *((volatile unsigned char*)(0x42C80374UL))
#define bFM4_ETHERNET_MAC0_FCR_PT14            *((volatile unsigned char*)(0x42C80378UL))
#define bFM4_ETHERNET_MAC0_FCR_PT15            *((volatile unsigned char*)(0x42C8037CUL))
#define bFM4_ETHERNET_MAC0_VTR_VL0             *((volatile unsigned char*)(0x42C80380UL))
#define bFM4_ETHERNET_MAC0_VTR_VL1             *((volatile unsigned char*)(0x42C80384UL))
#define bFM4_ETHERNET_MAC0_VTR_VL2             *((volatile unsigned char*)(0x42C80388UL))
#define bFM4_ETHERNET_MAC0_VTR_VL3             *((volatile unsigned char*)(0x42C8038CUL))
#define bFM4_ETHERNET_MAC0_VTR_VL4             *((volatile unsigned char*)(0x42C80390UL))
#define bFM4_ETHERNET_MAC0_VTR_VL5             *((volatile unsigned char*)(0x42C80394UL))
#define bFM4_ETHERNET_MAC0_VTR_VL6             *((volatile unsigned char*)(0x42C80398UL))
#define bFM4_ETHERNET_MAC0_VTR_VL7             *((volatile unsigned char*)(0x42C8039CUL))
#define bFM4_ETHERNET_MAC0_VTR_VL8             *((volatile unsigned char*)(0x42C803A0UL))
#define bFM4_ETHERNET_MAC0_VTR_VL9             *((volatile unsigned char*)(0x42C803A4UL))
#define bFM4_ETHERNET_MAC0_VTR_VL10            *((volatile unsigned char*)(0x42C803A8UL))
#define bFM4_ETHERNET_MAC0_VTR_VL11            *((volatile unsigned char*)(0x42C803ACUL))
#define bFM4_ETHERNET_MAC0_VTR_VL12            *((volatile unsigned char*)(0x42C803B0UL))
#define bFM4_ETHERNET_MAC0_VTR_VL13            *((volatile unsigned char*)(0x42C803B4UL))
#define bFM4_ETHERNET_MAC0_VTR_VL14            *((volatile unsigned char*)(0x42C803B8UL))
#define bFM4_ETHERNET_MAC0_VTR_VL15            *((volatile unsigned char*)(0x42C803BCUL))
#define bFM4_ETHERNET_MAC0_VTR_ETV             *((volatile unsigned char*)(0x42C803C0UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR0        *((volatile unsigned char*)(0x42C80500UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR1        *((volatile unsigned char*)(0x42C80504UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR2        *((volatile unsigned char*)(0x42C80508UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR3        *((volatile unsigned char*)(0x42C8050CUL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR4        *((volatile unsigned char*)(0x42C80510UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR5        *((volatile unsigned char*)(0x42C80514UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR6        *((volatile unsigned char*)(0x42C80518UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR7        *((volatile unsigned char*)(0x42C8051CUL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR8        *((volatile unsigned char*)(0x42C80520UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR9        *((volatile unsigned char*)(0x42C80524UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR10       *((volatile unsigned char*)(0x42C80528UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR11       *((volatile unsigned char*)(0x42C8052CUL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR12       *((volatile unsigned char*)(0x42C80530UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR13       *((volatile unsigned char*)(0x42C80534UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR14       *((volatile unsigned char*)(0x42C80538UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR15       *((volatile unsigned char*)(0x42C8053CUL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR16       *((volatile unsigned char*)(0x42C80540UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR17       *((volatile unsigned char*)(0x42C80544UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR18       *((volatile unsigned char*)(0x42C80548UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR19       *((volatile unsigned char*)(0x42C8054CUL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR20       *((volatile unsigned char*)(0x42C80550UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR21       *((volatile unsigned char*)(0x42C80554UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR22       *((volatile unsigned char*)(0x42C80558UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR23       *((volatile unsigned char*)(0x42C8055CUL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR24       *((volatile unsigned char*)(0x42C80560UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR25       *((volatile unsigned char*)(0x42C80564UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR26       *((volatile unsigned char*)(0x42C80568UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR27       *((volatile unsigned char*)(0x42C8056CUL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR28       *((volatile unsigned char*)(0x42C80570UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR29       *((volatile unsigned char*)(0x42C80574UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR30       *((volatile unsigned char*)(0x42C80578UL))
#define bFM4_ETHERNET_MAC0_RWFFR_RWFFR31       *((volatile unsigned char*)(0x42C8057CUL))
#define bFM4_ETHERNET_MAC0_PMTR_PD             *((volatile unsigned char*)(0x42C80580UL))
#define bFM4_ETHERNET_MAC0_PMTR_MPE            *((volatile unsigned char*)(0x42C80584UL))
#define bFM4_ETHERNET_MAC0_PMTR_WFE            *((volatile unsigned char*)(0x42C80588UL))
#define bFM4_ETHERNET_MAC0_PMTR_MPR            *((volatile unsigned char*)(0x42C80594UL))
#define bFM4_ETHERNET_MAC0_PMTR_WPR            *((volatile unsigned char*)(0x42C80598UL))
#define bFM4_ETHERNET_MAC0_PMTR_GU             *((volatile unsigned char*)(0x42C805A4UL))
#define bFM4_ETHERNET_MAC0_PMTR_RWFFRPR        *((volatile unsigned char*)(0x42C805FCUL))
#define bFM4_ETHERNET_MAC0_LPICSR_TLPIEN       *((volatile unsigned char*)(0x42C80600UL))
#define bFM4_ETHERNET_MAC0_LPICSR_TLPIEX       *((volatile unsigned char*)(0x42C80604UL))
#define bFM4_ETHERNET_MAC0_LPICSR_RLPIEN       *((volatile unsigned char*)(0x42C80608UL))
#define bFM4_ETHERNET_MAC0_LPICSR_RLPIEX       *((volatile unsigned char*)(0x42C8060CUL))
#define bFM4_ETHERNET_MAC0_LPICSR_TLPIST       *((volatile unsigned char*)(0x42C80620UL))
#define bFM4_ETHERNET_MAC0_LPICSR_RLPIST       *((volatile unsigned char*)(0x42C80624UL))
#define bFM4_ETHERNET_MAC0_LPICSR_LPIEN        *((volatile unsigned char*)(0x42C80640UL))
#define bFM4_ETHERNET_MAC0_LPICSR_PLS          *((volatile unsigned char*)(0x42C80644UL))
#define bFM4_ETHERNET_MAC0_LPICSR_PLSEN        *((volatile unsigned char*)(0x42C80648UL))
#define bFM4_ETHERNET_MAC0_LPICSR_LPITXA       *((volatile unsigned char*)(0x42C8064CUL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT0         *((volatile unsigned char*)(0x42C80680UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT1         *((volatile unsigned char*)(0x42C80684UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT2         *((volatile unsigned char*)(0x42C80688UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT3         *((volatile unsigned char*)(0x42C8068CUL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT4         *((volatile unsigned char*)(0x42C80690UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT5         *((volatile unsigned char*)(0x42C80694UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT6         *((volatile unsigned char*)(0x42C80698UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT7         *((volatile unsigned char*)(0x42C8069CUL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT8         *((volatile unsigned char*)(0x42C806A0UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT9         *((volatile unsigned char*)(0x42C806A4UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT10        *((volatile unsigned char*)(0x42C806A8UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT11        *((volatile unsigned char*)(0x42C806ACUL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT12        *((volatile unsigned char*)(0x42C806B0UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT13        *((volatile unsigned char*)(0x42C806B4UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT14        *((volatile unsigned char*)(0x42C806B8UL))
#define bFM4_ETHERNET_MAC0_LPITCR_TWT15        *((volatile unsigned char*)(0x42C806BCUL))
#define bFM4_ETHERNET_MAC0_LPITCR_LIT0         *((volatile unsigned char*)(0x42C806C0UL))
#define bFM4_ETHERNET_MAC0_LPITCR_LIT1         *((volatile unsigned char*)(0x42C806C4UL))
#define bFM4_ETHERNET_MAC0_LPITCR_LIT2         *((volatile unsigned char*)(0x42C806C8UL))
#define bFM4_ETHERNET_MAC0_LPITCR_LIT3         *((volatile unsigned char*)(0x42C806CCUL))
#define bFM4_ETHERNET_MAC0_LPITCR_LIT4         *((volatile unsigned char*)(0x42C806D0UL))
#define bFM4_ETHERNET_MAC0_LPITCR_LIT5         *((volatile unsigned char*)(0x42C806D4UL))
#define bFM4_ETHERNET_MAC0_LPITCR_LIT6         *((volatile unsigned char*)(0x42C806D8UL))
#define bFM4_ETHERNET_MAC0_LPITCR_LIT7         *((volatile unsigned char*)(0x42C806DCUL))
#define bFM4_ETHERNET_MAC0_LPITCR_LIT8         *((volatile unsigned char*)(0x42C806E0UL))
#define bFM4_ETHERNET_MAC0_LPITCR_LIT9         *((volatile unsigned char*)(0x42C806E4UL))
#define bFM4_ETHERNET_MAC0_ISR_RGIS            *((volatile unsigned char*)(0x42C80700UL))
#define bFM4_ETHERNET_MAC0_ISR_PIS             *((volatile unsigned char*)(0x42C8070CUL))
#define bFM4_ETHERNET_MAC0_ISR_MIS             *((volatile unsigned char*)(0x42C80710UL))
#define bFM4_ETHERNET_MAC0_ISR_RIS             *((volatile unsigned char*)(0x42C80714UL))
#define bFM4_ETHERNET_MAC0_ISR_TIS             *((volatile unsigned char*)(0x42C80718UL))
#define bFM4_ETHERNET_MAC0_ISR_COIS            *((volatile unsigned char*)(0x42C8071CUL))
#define bFM4_ETHERNET_MAC0_ISR_TSIS            *((volatile unsigned char*)(0x42C80724UL))
#define bFM4_ETHERNET_MAC0_ISR_LPIIS           *((volatile unsigned char*)(0x42C80728UL))
#define bFM4_ETHERNET_MAC0_IMR_RGIM            *((volatile unsigned char*)(0x42C80780UL))
#define bFM4_ETHERNET_MAC0_IMR_PIM             *((volatile unsigned char*)(0x42C8078CUL))
#define bFM4_ETHERNET_MAC0_IMR_TSIM            *((volatile unsigned char*)(0x42C807A4UL))
#define bFM4_ETHERNET_MAC0_IMR_LPIIM           *((volatile unsigned char*)(0x42C807A8UL))
#define bFM4_ETHERNET_MAC0_MAR0H_MO            *((volatile unsigned char*)(0x42C8087CUL))
#define bFM4_ETHERNET_MAC0_MAR1H_MBC0          *((volatile unsigned char*)(0x42C80960UL))
#define bFM4_ETHERNET_MAC0_MAR1H_MBC1          *((volatile unsigned char*)(0x42C80964UL))
#define bFM4_ETHERNET_MAC0_MAR1H_MBC2          *((volatile unsigned char*)(0x42C80968UL))
#define bFM4_ETHERNET_MAC0_MAR1H_MBC3          *((volatile unsigned char*)(0x42C8096CUL))
#define bFM4_ETHERNET_MAC0_MAR1H_MBC4          *((volatile unsigned char*)(0x42C80970UL))
#define bFM4_ETHERNET_MAC0_MAR1H_MBC5          *((volatile unsigned char*)(0x42C80974UL))
#define bFM4_ETHERNET_MAC0_MAR1H_SA            *((volatile unsigned char*)(0x42C80978UL))
#define bFM4_ETHERNET_MAC0_MAR2H_MBC0          *((volatile unsigned char*)(0x42C80A60UL))
#define bFM4_ETHERNET_MAC0_MAR2H_MBC1          *((volatile unsigned char*)(0x42C80A64UL))
#define bFM4_ETHERNET_MAC0_MAR2H_MBC2          *((volatile unsigned char*)(0x42C80A68UL))
#define bFM4_ETHERNET_MAC0_MAR2H_MBC3          *((volatile unsigned char*)(0x42C80A6CUL))
#define bFM4_ETHERNET_MAC0_MAR2H_MBC4          *((volatile unsigned char*)(0x42C80A70UL))
#define bFM4_ETHERNET_MAC0_MAR2H_MBC5          *((volatile unsigned char*)(0x42C80A74UL))
#define bFM4_ETHERNET_MAC0_MAR2H_SA            *((volatile unsigned char*)(0x42C80A78UL))
#define bFM4_ETHERNET_MAC0_MAR3H_MBC0          *((volatile unsigned char*)(0x42C80B60UL))
#define bFM4_ETHERNET_MAC0_MAR3H_MBC1          *((volatile unsigned char*)(0x42C80B64UL))
#define bFM4_ETHERNET_MAC0_MAR3H_MBC2          *((volatile unsigned char*)(0x42C80B68UL))
#define bFM4_ETHERNET_MAC0_MAR3H_MBC3          *((volatile unsigned char*)(0x42C80B6CUL))
#define bFM4_ETHERNET_MAC0_MAR3H_MBC4          *((volatile unsigned char*)(0x42C80B70UL))
#define bFM4_ETHERNET_MAC0_MAR3H_MBC5          *((volatile unsigned char*)(0x42C80B74UL))
#define bFM4_ETHERNET_MAC0_MAR3H_SA            *((volatile unsigned char*)(0x42C80B78UL))
#define bFM4_ETHERNET_MAC0_MAR4H_MBC0          *((volatile unsigned char*)(0x42C80C60UL))
#define bFM4_ETHERNET_MAC0_MAR4H_MBC1          *((volatile unsigned char*)(0x42C80C64UL))
#define bFM4_ETHERNET_MAC0_MAR4H_MBC2          *((volatile unsigned char*)(0x42C80C68UL))
#define bFM4_ETHERNET_MAC0_MAR4H_MBC3          *((volatile unsigned char*)(0x42C80C6CUL))
#define bFM4_ETHERNET_MAC0_MAR4H_MBC4          *((volatile unsigned char*)(0x42C80C70UL))
#define bFM4_ETHERNET_MAC0_MAR4H_MBC5          *((volatile unsigned char*)(0x42C80C74UL))
#define bFM4_ETHERNET_MAC0_MAR4H_SA            *((volatile unsigned char*)(0x42C80C78UL))
#define bFM4_ETHERNET_MAC0_MAR5H_MBC0          *((volatile unsigned char*)(0x42C80D60UL))
#define bFM4_ETHERNET_MAC0_MAR5H_MBC1          *((volatile unsigned char*)(0x42C80D64UL))
#define bFM4_ETHERNET_MAC0_MAR5H_MBC2          *((volatile unsigned char*)(0x42C80D68UL))
#define bFM4_ETHERNET_MAC0_MAR5H_MBC3          *((volatile unsigned char*)(0x42C80D6CUL))
#define bFM4_ETHERNET_MAC0_MAR5H_MBC4          *((volatile unsigned char*)(0x42C80D70UL))
#define bFM4_ETHERNET_MAC0_MAR5H_MBC5          *((volatile unsigned char*)(0x42C80D74UL))
#define bFM4_ETHERNET_MAC0_MAR5H_SA            *((volatile unsigned char*)(0x42C80D78UL))
#define bFM4_ETHERNET_MAC0_MAR6H_MBC0          *((volatile unsigned char*)(0x42C80E60UL))
#define bFM4_ETHERNET_MAC0_MAR6H_MBC1          *((volatile unsigned char*)(0x42C80E64UL))
#define bFM4_ETHERNET_MAC0_MAR6H_MBC2          *((volatile unsigned char*)(0x42C80E68UL))
#define bFM4_ETHERNET_MAC0_MAR6H_MBC3          *((volatile unsigned char*)(0x42C80E6CUL))
#define bFM4_ETHERNET_MAC0_MAR6H_MBC4          *((volatile unsigned char*)(0x42C80E70UL))
#define bFM4_ETHERNET_MAC0_MAR6H_MBC5          *((volatile unsigned char*)(0x42C80E74UL))
#define bFM4_ETHERNET_MAC0_MAR6H_SA            *((volatile unsigned char*)(0x42C80E78UL))
#define bFM4_ETHERNET_MAC0_MAR7H_MBC0          *((volatile unsigned char*)(0x42C80F60UL))
#define bFM4_ETHERNET_MAC0_MAR7H_MBC1          *((volatile unsigned char*)(0x42C80F64UL))
#define bFM4_ETHERNET_MAC0_MAR7H_MBC2          *((volatile unsigned char*)(0x42C80F68UL))
#define bFM4_ETHERNET_MAC0_MAR7H_MBC3          *((volatile unsigned char*)(0x42C80F6CUL))
#define bFM4_ETHERNET_MAC0_MAR7H_MBC4          *((volatile unsigned char*)(0x42C80F70UL))
#define bFM4_ETHERNET_MAC0_MAR7H_MBC5          *((volatile unsigned char*)(0x42C80F74UL))
#define bFM4_ETHERNET_MAC0_MAR7H_SA            *((volatile unsigned char*)(0x42C80F78UL))
#define bFM4_ETHERNET_MAC0_MAR8H_MBC0          *((volatile unsigned char*)(0x42C81060UL))
#define bFM4_ETHERNET_MAC0_MAR8H_MBC1          *((volatile unsigned char*)(0x42C81064UL))
#define bFM4_ETHERNET_MAC0_MAR8H_MBC2          *((volatile unsigned char*)(0x42C81068UL))
#define bFM4_ETHERNET_MAC0_MAR8H_MBC3          *((volatile unsigned char*)(0x42C8106CUL))
#define bFM4_ETHERNET_MAC0_MAR8H_MBC4          *((volatile unsigned char*)(0x42C81070UL))
#define bFM4_ETHERNET_MAC0_MAR8H_MBC5          *((volatile unsigned char*)(0x42C81074UL))
#define bFM4_ETHERNET_MAC0_MAR8H_SA            *((volatile unsigned char*)(0x42C81078UL))
#define bFM4_ETHERNET_MAC0_MAR9H_MBC0          *((volatile unsigned char*)(0x42C81160UL))
#define bFM4_ETHERNET_MAC0_MAR9H_MBC1          *((volatile unsigned char*)(0x42C81164UL))
#define bFM4_ETHERNET_MAC0_MAR9H_MBC2          *((volatile unsigned char*)(0x42C81168UL))
#define bFM4_ETHERNET_MAC0_MAR9H_MBC3          *((volatile unsigned char*)(0x42C8116CUL))
#define bFM4_ETHERNET_MAC0_MAR9H_MBC4          *((volatile unsigned char*)(0x42C81170UL))
#define bFM4_ETHERNET_MAC0_MAR9H_MBC5          *((volatile unsigned char*)(0x42C81174UL))
#define bFM4_ETHERNET_MAC0_MAR9H_SA            *((volatile unsigned char*)(0x42C81178UL))
#define bFM4_ETHERNET_MAC0_MAR10H_MBC0         *((volatile unsigned char*)(0x42C81260UL))
#define bFM4_ETHERNET_MAC0_MAR10H_MBC1         *((volatile unsigned char*)(0x42C81264UL))
#define bFM4_ETHERNET_MAC0_MAR10H_MBC2         *((volatile unsigned char*)(0x42C81268UL))
#define bFM4_ETHERNET_MAC0_MAR10H_MBC3         *((volatile unsigned char*)(0x42C8126CUL))
#define bFM4_ETHERNET_MAC0_MAR10H_MBC4         *((volatile unsigned char*)(0x42C81270UL))
#define bFM4_ETHERNET_MAC0_MAR10H_MBC5         *((volatile unsigned char*)(0x42C81274UL))
#define bFM4_ETHERNET_MAC0_MAR10H_SA           *((volatile unsigned char*)(0x42C81278UL))
#define bFM4_ETHERNET_MAC0_MAR11H_MBC0         *((volatile unsigned char*)(0x42C81360UL))
#define bFM4_ETHERNET_MAC0_MAR11H_MBC1         *((volatile unsigned char*)(0x42C81364UL))
#define bFM4_ETHERNET_MAC0_MAR11H_MBC2         *((volatile unsigned char*)(0x42C81368UL))
#define bFM4_ETHERNET_MAC0_MAR11H_MBC3         *((volatile unsigned char*)(0x42C8136CUL))
#define bFM4_ETHERNET_MAC0_MAR11H_MBC4         *((volatile unsigned char*)(0x42C81370UL))
#define bFM4_ETHERNET_MAC0_MAR11H_MBC5         *((volatile unsigned char*)(0x42C81374UL))
#define bFM4_ETHERNET_MAC0_MAR11H_SA           *((volatile unsigned char*)(0x42C81378UL))
#define bFM4_ETHERNET_MAC0_MAR12H_MBC0         *((volatile unsigned char*)(0x42C81460UL))
#define bFM4_ETHERNET_MAC0_MAR12H_MBC1         *((volatile unsigned char*)(0x42C81464UL))
#define bFM4_ETHERNET_MAC0_MAR12H_MBC2         *((volatile unsigned char*)(0x42C81468UL))
#define bFM4_ETHERNET_MAC0_MAR12H_MBC3         *((volatile unsigned char*)(0x42C8146CUL))
#define bFM4_ETHERNET_MAC0_MAR12H_MBC4         *((volatile unsigned char*)(0x42C81470UL))
#define bFM4_ETHERNET_MAC0_MAR12H_MBC5         *((volatile unsigned char*)(0x42C81474UL))
#define bFM4_ETHERNET_MAC0_MAR12H_SA           *((volatile unsigned char*)(0x42C81478UL))
#define bFM4_ETHERNET_MAC0_MAR13H_MBC0         *((volatile unsigned char*)(0x42C81560UL))
#define bFM4_ETHERNET_MAC0_MAR13H_MBC1         *((volatile unsigned char*)(0x42C81564UL))
#define bFM4_ETHERNET_MAC0_MAR13H_MBC2         *((volatile unsigned char*)(0x42C81568UL))
#define bFM4_ETHERNET_MAC0_MAR13H_MBC3         *((volatile unsigned char*)(0x42C8156CUL))
#define bFM4_ETHERNET_MAC0_MAR13H_MBC4         *((volatile unsigned char*)(0x42C81570UL))
#define bFM4_ETHERNET_MAC0_MAR13H_MBC5         *((volatile unsigned char*)(0x42C81574UL))
#define bFM4_ETHERNET_MAC0_MAR13H_SA           *((volatile unsigned char*)(0x42C81578UL))
#define bFM4_ETHERNET_MAC0_MAR14H_MBC0         *((volatile unsigned char*)(0x42C81660UL))
#define bFM4_ETHERNET_MAC0_MAR14H_MBC1         *((volatile unsigned char*)(0x42C81664UL))
#define bFM4_ETHERNET_MAC0_MAR14H_MBC2         *((volatile unsigned char*)(0x42C81668UL))
#define bFM4_ETHERNET_MAC0_MAR14H_MBC3         *((volatile unsigned char*)(0x42C8166CUL))
#define bFM4_ETHERNET_MAC0_MAR14H_MBC4         *((volatile unsigned char*)(0x42C81670UL))
#define bFM4_ETHERNET_MAC0_MAR14H_MBC5         *((volatile unsigned char*)(0x42C81674UL))
#define bFM4_ETHERNET_MAC0_MAR14H_SA           *((volatile unsigned char*)(0x42C81678UL))
#define bFM4_ETHERNET_MAC0_MAR15H_MBC0         *((volatile unsigned char*)(0x42C81760UL))
#define bFM4_ETHERNET_MAC0_MAR15H_MBC1         *((volatile unsigned char*)(0x42C81764UL))
#define bFM4_ETHERNET_MAC0_MAR15H_MBC2         *((volatile unsigned char*)(0x42C81768UL))
#define bFM4_ETHERNET_MAC0_MAR15H_MBC3         *((volatile unsigned char*)(0x42C8176CUL))
#define bFM4_ETHERNET_MAC0_MAR15H_MBC4         *((volatile unsigned char*)(0x42C81770UL))
#define bFM4_ETHERNET_MAC0_MAR15H_MBC5         *((volatile unsigned char*)(0x42C81774UL))
#define bFM4_ETHERNET_MAC0_MAR15H_SA           *((volatile unsigned char*)(0x42C81778UL))
#define bFM4_ETHERNET_MAC0_RGSR_LM             *((volatile unsigned char*)(0x42C81B00UL))
#define bFM4_ETHERNET_MAC0_RGSR_LSP0           *((volatile unsigned char*)(0x42C81B04UL))
#define bFM4_ETHERNET_MAC0_RGSR_LSP1           *((volatile unsigned char*)(0x42C81B08UL))
#define bFM4_ETHERNET_MAC0_RGSR_LS             *((volatile unsigned char*)(0x42C81B0CUL))
#define bFM4_ETHERNET_MAC0_TSCR_TSE            *((volatile unsigned char*)(0x42C8E000UL))
#define bFM4_ETHERNET_MAC0_TSCR_TFCU           *((volatile unsigned char*)(0x42C8E004UL))
#define bFM4_ETHERNET_MAC0_TSCR_TSI            *((volatile unsigned char*)(0x42C8E008UL))
#define bFM4_ETHERNET_MAC0_TSCR_TSU            *((volatile unsigned char*)(0x42C8E00CUL))
#define bFM4_ETHERNET_MAC0_TSCR_TITE           *((volatile unsigned char*)(0x42C8E010UL))
#define bFM4_ETHERNET_MAC0_TSCR_TARU           *((volatile unsigned char*)(0x42C8E014UL))
#define bFM4_ETHERNET_MAC0_TSCR_TSEA           *((volatile unsigned char*)(0x42C8E020UL))
#define bFM4_ETHERNET_MAC0_TSCR_TSDB           *((volatile unsigned char*)(0x42C8E024UL))
#define bFM4_ETHERNET_MAC0_TSCR_TSV2E          *((volatile unsigned char*)(0x42C8E028UL))
#define bFM4_ETHERNET_MAC0_TSCR_TETSP          *((volatile unsigned char*)(0x42C8E02CUL))
#define bFM4_ETHERNET_MAC0_TSCR_TSIP6E         *((volatile unsigned char*)(0x42C8E030UL))
#define bFM4_ETHERNET_MAC0_TSCR_TSIP4E         *((volatile unsigned char*)(0x42C8E034UL))
#define bFM4_ETHERNET_MAC0_TSCR_TETSEM         *((volatile unsigned char*)(0x42C8E038UL))
#define bFM4_ETHERNET_MAC0_TSCR_TSMRM          *((volatile unsigned char*)(0x42C8E03CUL))
#define bFM4_ETHERNET_MAC0_TSCR_TSPS0          *((volatile unsigned char*)(0x42C8E040UL))
#define bFM4_ETHERNET_MAC0_TSCR_TSPS1          *((volatile unsigned char*)(0x42C8E044UL))
#define bFM4_ETHERNET_MAC0_TSCR_TSENMF         *((volatile unsigned char*)(0x42C8E048UL))
#define bFM4_ETHERNET_MAC0_TSCR_ATSFC          *((volatile unsigned char*)(0x42C8E060UL))
#define bFM4_ETHERNET_MAC0_SSIR_SSINC0         *((volatile unsigned char*)(0x42C8E080UL))
#define bFM4_ETHERNET_MAC0_SSIR_SSINC1         *((volatile unsigned char*)(0x42C8E084UL))
#define bFM4_ETHERNET_MAC0_SSIR_SSINC2         *((volatile unsigned char*)(0x42C8E088UL))
#define bFM4_ETHERNET_MAC0_SSIR_SSINC3         *((volatile unsigned char*)(0x42C8E08CUL))
#define bFM4_ETHERNET_MAC0_SSIR_SSINC4         *((volatile unsigned char*)(0x42C8E090UL))
#define bFM4_ETHERNET_MAC0_SSIR_SSINC5         *((volatile unsigned char*)(0x42C8E094UL))
#define bFM4_ETHERNET_MAC0_SSIR_SSINC6         *((volatile unsigned char*)(0x42C8E098UL))
#define bFM4_ETHERNET_MAC0_SSIR_SSINC7         *((volatile unsigned char*)(0x42C8E09CUL))
#define bFM4_ETHERNET_MAC0_STSR_TSS0           *((volatile unsigned char*)(0x42C8E100UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS1           *((volatile unsigned char*)(0x42C8E104UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS2           *((volatile unsigned char*)(0x42C8E108UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS3           *((volatile unsigned char*)(0x42C8E10CUL))
#define bFM4_ETHERNET_MAC0_STSR_TSS4           *((volatile unsigned char*)(0x42C8E110UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS5           *((volatile unsigned char*)(0x42C8E114UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS6           *((volatile unsigned char*)(0x42C8E118UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS7           *((volatile unsigned char*)(0x42C8E11CUL))
#define bFM4_ETHERNET_MAC0_STSR_TSS8           *((volatile unsigned char*)(0x42C8E120UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS9           *((volatile unsigned char*)(0x42C8E124UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS10          *((volatile unsigned char*)(0x42C8E128UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS11          *((volatile unsigned char*)(0x42C8E12CUL))
#define bFM4_ETHERNET_MAC0_STSR_TSS12          *((volatile unsigned char*)(0x42C8E130UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS13          *((volatile unsigned char*)(0x42C8E134UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS14          *((volatile unsigned char*)(0x42C8E138UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS15          *((volatile unsigned char*)(0x42C8E13CUL))
#define bFM4_ETHERNET_MAC0_STSR_TSS16          *((volatile unsigned char*)(0x42C8E140UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS17          *((volatile unsigned char*)(0x42C8E144UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS18          *((volatile unsigned char*)(0x42C8E148UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS19          *((volatile unsigned char*)(0x42C8E14CUL))
#define bFM4_ETHERNET_MAC0_STSR_TSS20          *((volatile unsigned char*)(0x42C8E150UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS21          *((volatile unsigned char*)(0x42C8E154UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS22          *((volatile unsigned char*)(0x42C8E158UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS23          *((volatile unsigned char*)(0x42C8E15CUL))
#define bFM4_ETHERNET_MAC0_STSR_TSS24          *((volatile unsigned char*)(0x42C8E160UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS25          *((volatile unsigned char*)(0x42C8E164UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS26          *((volatile unsigned char*)(0x42C8E168UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS27          *((volatile unsigned char*)(0x42C8E16CUL))
#define bFM4_ETHERNET_MAC0_STSR_TSS28          *((volatile unsigned char*)(0x42C8E170UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS29          *((volatile unsigned char*)(0x42C8E174UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS30          *((volatile unsigned char*)(0x42C8E178UL))
#define bFM4_ETHERNET_MAC0_STSR_TSS31          *((volatile unsigned char*)(0x42C8E17CUL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS0          *((volatile unsigned char*)(0x42C8E180UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS1          *((volatile unsigned char*)(0x42C8E184UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS2          *((volatile unsigned char*)(0x42C8E188UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS3          *((volatile unsigned char*)(0x42C8E18CUL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS4          *((volatile unsigned char*)(0x42C8E190UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS5          *((volatile unsigned char*)(0x42C8E194UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS6          *((volatile unsigned char*)(0x42C8E198UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS7          *((volatile unsigned char*)(0x42C8E19CUL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS8          *((volatile unsigned char*)(0x42C8E1A0UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS9          *((volatile unsigned char*)(0x42C8E1A4UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS10         *((volatile unsigned char*)(0x42C8E1A8UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS11         *((volatile unsigned char*)(0x42C8E1ACUL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS12         *((volatile unsigned char*)(0x42C8E1B0UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS13         *((volatile unsigned char*)(0x42C8E1B4UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS14         *((volatile unsigned char*)(0x42C8E1B8UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS15         *((volatile unsigned char*)(0x42C8E1BCUL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS16         *((volatile unsigned char*)(0x42C8E1C0UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS17         *((volatile unsigned char*)(0x42C8E1C4UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS18         *((volatile unsigned char*)(0x42C8E1C8UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS19         *((volatile unsigned char*)(0x42C8E1CCUL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS20         *((volatile unsigned char*)(0x42C8E1D0UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS21         *((volatile unsigned char*)(0x42C8E1D4UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS22         *((volatile unsigned char*)(0x42C8E1D8UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS23         *((volatile unsigned char*)(0x42C8E1DCUL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS24         *((volatile unsigned char*)(0x42C8E1E0UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS25         *((volatile unsigned char*)(0x42C8E1E4UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS26         *((volatile unsigned char*)(0x42C8E1E8UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS27         *((volatile unsigned char*)(0x42C8E1ECUL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS28         *((volatile unsigned char*)(0x42C8E1F0UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS29         *((volatile unsigned char*)(0x42C8E1F4UL))
#define bFM4_ETHERNET_MAC0_STNR_TSSS30         *((volatile unsigned char*)(0x42C8E1F8UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS0          *((volatile unsigned char*)(0x42C8E200UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS1          *((volatile unsigned char*)(0x42C8E204UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS2          *((volatile unsigned char*)(0x42C8E208UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS3          *((volatile unsigned char*)(0x42C8E20CUL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS4          *((volatile unsigned char*)(0x42C8E210UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS5          *((volatile unsigned char*)(0x42C8E214UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS6          *((volatile unsigned char*)(0x42C8E218UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS7          *((volatile unsigned char*)(0x42C8E21CUL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS8          *((volatile unsigned char*)(0x42C8E220UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS9          *((volatile unsigned char*)(0x42C8E224UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS10         *((volatile unsigned char*)(0x42C8E228UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS11         *((volatile unsigned char*)(0x42C8E22CUL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS12         *((volatile unsigned char*)(0x42C8E230UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS13         *((volatile unsigned char*)(0x42C8E234UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS14         *((volatile unsigned char*)(0x42C8E238UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS15         *((volatile unsigned char*)(0x42C8E23CUL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS16         *((volatile unsigned char*)(0x42C8E240UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS17         *((volatile unsigned char*)(0x42C8E244UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS18         *((volatile unsigned char*)(0x42C8E248UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS19         *((volatile unsigned char*)(0x42C8E24CUL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS20         *((volatile unsigned char*)(0x42C8E250UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS21         *((volatile unsigned char*)(0x42C8E254UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS22         *((volatile unsigned char*)(0x42C8E258UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS23         *((volatile unsigned char*)(0x42C8E25CUL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS24         *((volatile unsigned char*)(0x42C8E260UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS25         *((volatile unsigned char*)(0x42C8E264UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS26         *((volatile unsigned char*)(0x42C8E268UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS27         *((volatile unsigned char*)(0x42C8E26CUL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS28         *((volatile unsigned char*)(0x42C8E270UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS29         *((volatile unsigned char*)(0x42C8E274UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS30         *((volatile unsigned char*)(0x42C8E278UL))
#define bFM4_ETHERNET_MAC0_STSUR_TSS31         *((volatile unsigned char*)(0x42C8E27CUL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS0         *((volatile unsigned char*)(0x42C8E280UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS1         *((volatile unsigned char*)(0x42C8E284UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS2         *((volatile unsigned char*)(0x42C8E288UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS3         *((volatile unsigned char*)(0x42C8E28CUL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS4         *((volatile unsigned char*)(0x42C8E290UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS5         *((volatile unsigned char*)(0x42C8E294UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS6         *((volatile unsigned char*)(0x42C8E298UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS7         *((volatile unsigned char*)(0x42C8E29CUL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS8         *((volatile unsigned char*)(0x42C8E2A0UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS9         *((volatile unsigned char*)(0x42C8E2A4UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS10        *((volatile unsigned char*)(0x42C8E2A8UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS11        *((volatile unsigned char*)(0x42C8E2ACUL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS12        *((volatile unsigned char*)(0x42C8E2B0UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS13        *((volatile unsigned char*)(0x42C8E2B4UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS14        *((volatile unsigned char*)(0x42C8E2B8UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS15        *((volatile unsigned char*)(0x42C8E2BCUL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS16        *((volatile unsigned char*)(0x42C8E2C0UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS17        *((volatile unsigned char*)(0x42C8E2C4UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS18        *((volatile unsigned char*)(0x42C8E2C8UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS19        *((volatile unsigned char*)(0x42C8E2CCUL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS20        *((volatile unsigned char*)(0x42C8E2D0UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS21        *((volatile unsigned char*)(0x42C8E2D4UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS22        *((volatile unsigned char*)(0x42C8E2D8UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS23        *((volatile unsigned char*)(0x42C8E2DCUL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS24        *((volatile unsigned char*)(0x42C8E2E0UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS25        *((volatile unsigned char*)(0x42C8E2E4UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS26        *((volatile unsigned char*)(0x42C8E2E8UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS27        *((volatile unsigned char*)(0x42C8E2ECUL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS28        *((volatile unsigned char*)(0x42C8E2F0UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS29        *((volatile unsigned char*)(0x42C8E2F4UL))
#define bFM4_ETHERNET_MAC0_STNUR_TSSS30        *((volatile unsigned char*)(0x42C8E2F8UL))
#define bFM4_ETHERNET_MAC0_STNUR_ADDSUB        *((volatile unsigned char*)(0x42C8E2FCUL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR0          *((volatile unsigned char*)(0x42C8E300UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR1          *((volatile unsigned char*)(0x42C8E304UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR2          *((volatile unsigned char*)(0x42C8E308UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR3          *((volatile unsigned char*)(0x42C8E30CUL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR4          *((volatile unsigned char*)(0x42C8E310UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR5          *((volatile unsigned char*)(0x42C8E314UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR6          *((volatile unsigned char*)(0x42C8E318UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR7          *((volatile unsigned char*)(0x42C8E31CUL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR8          *((volatile unsigned char*)(0x42C8E320UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR9          *((volatile unsigned char*)(0x42C8E324UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR10         *((volatile unsigned char*)(0x42C8E328UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR11         *((volatile unsigned char*)(0x42C8E32CUL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR12         *((volatile unsigned char*)(0x42C8E330UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR13         *((volatile unsigned char*)(0x42C8E334UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR14         *((volatile unsigned char*)(0x42C8E338UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR15         *((volatile unsigned char*)(0x42C8E33CUL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR16         *((volatile unsigned char*)(0x42C8E340UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR17         *((volatile unsigned char*)(0x42C8E344UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR18         *((volatile unsigned char*)(0x42C8E348UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR19         *((volatile unsigned char*)(0x42C8E34CUL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR20         *((volatile unsigned char*)(0x42C8E350UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR21         *((volatile unsigned char*)(0x42C8E354UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR22         *((volatile unsigned char*)(0x42C8E358UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR23         *((volatile unsigned char*)(0x42C8E35CUL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR24         *((volatile unsigned char*)(0x42C8E360UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR25         *((volatile unsigned char*)(0x42C8E364UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR26         *((volatile unsigned char*)(0x42C8E368UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR27         *((volatile unsigned char*)(0x42C8E36CUL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR28         *((volatile unsigned char*)(0x42C8E370UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR29         *((volatile unsigned char*)(0x42C8E374UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR30         *((volatile unsigned char*)(0x42C8E378UL))
#define bFM4_ETHERNET_MAC0_TSAR_TSAR31         *((volatile unsigned char*)(0x42C8E37CUL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR0          *((volatile unsigned char*)(0x42C8E380UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR1          *((volatile unsigned char*)(0x42C8E384UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR2          *((volatile unsigned char*)(0x42C8E388UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR3          *((volatile unsigned char*)(0x42C8E38CUL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR4          *((volatile unsigned char*)(0x42C8E390UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR5          *((volatile unsigned char*)(0x42C8E394UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR6          *((volatile unsigned char*)(0x42C8E398UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR7          *((volatile unsigned char*)(0x42C8E39CUL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR8          *((volatile unsigned char*)(0x42C8E3A0UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR9          *((volatile unsigned char*)(0x42C8E3A4UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR10         *((volatile unsigned char*)(0x42C8E3A8UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR11         *((volatile unsigned char*)(0x42C8E3ACUL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR12         *((volatile unsigned char*)(0x42C8E3B0UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR13         *((volatile unsigned char*)(0x42C8E3B4UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR14         *((volatile unsigned char*)(0x42C8E3B8UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR15         *((volatile unsigned char*)(0x42C8E3BCUL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR16         *((volatile unsigned char*)(0x42C8E3C0UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR17         *((volatile unsigned char*)(0x42C8E3C4UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR18         *((volatile unsigned char*)(0x42C8E3C8UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR19         *((volatile unsigned char*)(0x42C8E3CCUL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR20         *((volatile unsigned char*)(0x42C8E3D0UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR21         *((volatile unsigned char*)(0x42C8E3D4UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR22         *((volatile unsigned char*)(0x42C8E3D8UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR23         *((volatile unsigned char*)(0x42C8E3DCUL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR24         *((volatile unsigned char*)(0x42C8E3E0UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR25         *((volatile unsigned char*)(0x42C8E3E4UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR26         *((volatile unsigned char*)(0x42C8E3E8UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR27         *((volatile unsigned char*)(0x42C8E3ECUL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR28         *((volatile unsigned char*)(0x42C8E3F0UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR29         *((volatile unsigned char*)(0x42C8E3F4UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR30         *((volatile unsigned char*)(0x42C8E3F8UL))
#define bFM4_ETHERNET_MAC0_TTSR_TSTR31         *((volatile unsigned char*)(0x42C8E3FCUL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR0          *((volatile unsigned char*)(0x42C8E400UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR1          *((volatile unsigned char*)(0x42C8E404UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR2          *((volatile unsigned char*)(0x42C8E408UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR3          *((volatile unsigned char*)(0x42C8E40CUL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR4          *((volatile unsigned char*)(0x42C8E410UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR5          *((volatile unsigned char*)(0x42C8E414UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR6          *((volatile unsigned char*)(0x42C8E418UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR7          *((volatile unsigned char*)(0x42C8E41CUL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR8          *((volatile unsigned char*)(0x42C8E420UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR9          *((volatile unsigned char*)(0x42C8E424UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR10         *((volatile unsigned char*)(0x42C8E428UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR11         *((volatile unsigned char*)(0x42C8E42CUL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR12         *((volatile unsigned char*)(0x42C8E430UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR13         *((volatile unsigned char*)(0x42C8E434UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR14         *((volatile unsigned char*)(0x42C8E438UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR15         *((volatile unsigned char*)(0x42C8E43CUL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR16         *((volatile unsigned char*)(0x42C8E440UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR17         *((volatile unsigned char*)(0x42C8E444UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR18         *((volatile unsigned char*)(0x42C8E448UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR19         *((volatile unsigned char*)(0x42C8E44CUL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR20         *((volatile unsigned char*)(0x42C8E450UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR21         *((volatile unsigned char*)(0x42C8E454UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR22         *((volatile unsigned char*)(0x42C8E458UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR23         *((volatile unsigned char*)(0x42C8E45CUL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR24         *((volatile unsigned char*)(0x42C8E460UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR25         *((volatile unsigned char*)(0x42C8E464UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR26         *((volatile unsigned char*)(0x42C8E468UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR27         *((volatile unsigned char*)(0x42C8E46CUL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR28         *((volatile unsigned char*)(0x42C8E470UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR29         *((volatile unsigned char*)(0x42C8E474UL))
#define bFM4_ETHERNET_MAC0_TTNR_TSTR30         *((volatile unsigned char*)(0x42C8E478UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR0       *((volatile unsigned char*)(0x42C8E480UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR1       *((volatile unsigned char*)(0x42C8E484UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR2       *((volatile unsigned char*)(0x42C8E488UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR3       *((volatile unsigned char*)(0x42C8E48CUL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR4       *((volatile unsigned char*)(0x42C8E490UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR5       *((volatile unsigned char*)(0x42C8E494UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR6       *((volatile unsigned char*)(0x42C8E498UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR7       *((volatile unsigned char*)(0x42C8E49CUL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR8       *((volatile unsigned char*)(0x42C8E4A0UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR9       *((volatile unsigned char*)(0x42C8E4A4UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR10      *((volatile unsigned char*)(0x42C8E4A8UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR11      *((volatile unsigned char*)(0x42C8E4ACUL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR12      *((volatile unsigned char*)(0x42C8E4B0UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR13      *((volatile unsigned char*)(0x42C8E4B4UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR14      *((volatile unsigned char*)(0x42C8E4B8UL))
#define bFM4_ETHERNET_MAC0_STHWSR_TSHWR15      *((volatile unsigned char*)(0x42C8E4BCUL))
#define bFM4_ETHERNET_MAC0_TSR_TSSOVF          *((volatile unsigned char*)(0x42C8E500UL))
#define bFM4_ETHERNET_MAC0_TSR_TSTART          *((volatile unsigned char*)(0x42C8E504UL))
#define bFM4_ETHERNET_MAC0_TSR_ATSTS           *((volatile unsigned char*)(0x42C8E508UL))
#define bFM4_ETHERNET_MAC0_TSR_TRGTER          *((volatile unsigned char*)(0x42C8E50CUL))
#define bFM4_ETHERNET_MAC0_TSR_ATSSTM          *((volatile unsigned char*)(0x42C8E560UL))
#define bFM4_ETHERNET_MAC0_TSR_ATSNS0          *((volatile unsigned char*)(0x42C8E564UL))
#define bFM4_ETHERNET_MAC0_TSR_ATSNS1          *((volatile unsigned char*)(0x42C8E568UL))
#define bFM4_ETHERNET_MAC0_TSR_ATSNS2          *((volatile unsigned char*)(0x42C8E56CUL))
#define bFM4_ETHERNET_MAC0_PPSCR_PPSCTRL0      *((volatile unsigned char*)(0x42C8E580UL))
#define bFM4_ETHERNET_MAC0_PPSCR_PPSCTRL1      *((volatile unsigned char*)(0x42C8E584UL))
#define bFM4_ETHERNET_MAC0_PPSCR_PPSCTRL2      *((volatile unsigned char*)(0x42C8E588UL))
#define bFM4_ETHERNET_MAC0_PPSCR_PPSCTRL3      *((volatile unsigned char*)(0x42C8E58CUL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN0           *((volatile unsigned char*)(0x42C8E600UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN1           *((volatile unsigned char*)(0x42C8E604UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN2           *((volatile unsigned char*)(0x42C8E608UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN3           *((volatile unsigned char*)(0x42C8E60CUL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN4           *((volatile unsigned char*)(0x42C8E610UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN5           *((volatile unsigned char*)(0x42C8E614UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN6           *((volatile unsigned char*)(0x42C8E618UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN7           *((volatile unsigned char*)(0x42C8E61CUL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN8           *((volatile unsigned char*)(0x42C8E620UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN9           *((volatile unsigned char*)(0x42C8E624UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN10          *((volatile unsigned char*)(0x42C8E628UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN11          *((volatile unsigned char*)(0x42C8E62CUL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN12          *((volatile unsigned char*)(0x42C8E630UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN13          *((volatile unsigned char*)(0x42C8E634UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN14          *((volatile unsigned char*)(0x42C8E638UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN15          *((volatile unsigned char*)(0x42C8E63CUL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN16          *((volatile unsigned char*)(0x42C8E640UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN17          *((volatile unsigned char*)(0x42C8E644UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN18          *((volatile unsigned char*)(0x42C8E648UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN19          *((volatile unsigned char*)(0x42C8E64CUL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN20          *((volatile unsigned char*)(0x42C8E650UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN21          *((volatile unsigned char*)(0x42C8E654UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN22          *((volatile unsigned char*)(0x42C8E658UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN23          *((volatile unsigned char*)(0x42C8E65CUL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN24          *((volatile unsigned char*)(0x42C8E660UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN25          *((volatile unsigned char*)(0x42C8E664UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN26          *((volatile unsigned char*)(0x42C8E668UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN27          *((volatile unsigned char*)(0x42C8E66CUL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN28          *((volatile unsigned char*)(0x42C8E670UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN29          *((volatile unsigned char*)(0x42C8E674UL))
#define bFM4_ETHERNET_MAC0_ATNR_ATN30          *((volatile unsigned char*)(0x42C8E678UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS0           *((volatile unsigned char*)(0x42C8E680UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS1           *((volatile unsigned char*)(0x42C8E684UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS2           *((volatile unsigned char*)(0x42C8E688UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS3           *((volatile unsigned char*)(0x42C8E68CUL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS4           *((volatile unsigned char*)(0x42C8E690UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS5           *((volatile unsigned char*)(0x42C8E694UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS6           *((volatile unsigned char*)(0x42C8E698UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS7           *((volatile unsigned char*)(0x42C8E69CUL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS8           *((volatile unsigned char*)(0x42C8E6A0UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS9           *((volatile unsigned char*)(0x42C8E6A4UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS10          *((volatile unsigned char*)(0x42C8E6A8UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS11          *((volatile unsigned char*)(0x42C8E6ACUL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS12          *((volatile unsigned char*)(0x42C8E6B0UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS13          *((volatile unsigned char*)(0x42C8E6B4UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS14          *((volatile unsigned char*)(0x42C8E6B8UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS15          *((volatile unsigned char*)(0x42C8E6BCUL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS16          *((volatile unsigned char*)(0x42C8E6C0UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS17          *((volatile unsigned char*)(0x42C8E6C4UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS18          *((volatile unsigned char*)(0x42C8E6C8UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS19          *((volatile unsigned char*)(0x42C8E6CCUL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS20          *((volatile unsigned char*)(0x42C8E6D0UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS21          *((volatile unsigned char*)(0x42C8E6D4UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS22          *((volatile unsigned char*)(0x42C8E6D8UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS23          *((volatile unsigned char*)(0x42C8E6DCUL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS24          *((volatile unsigned char*)(0x42C8E6E0UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS25          *((volatile unsigned char*)(0x42C8E6E4UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS26          *((volatile unsigned char*)(0x42C8E6E8UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS27          *((volatile unsigned char*)(0x42C8E6ECUL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS28          *((volatile unsigned char*)(0x42C8E6F0UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS29          *((volatile unsigned char*)(0x42C8E6F4UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS30          *((volatile unsigned char*)(0x42C8E6F8UL))
#define bFM4_ETHERNET_MAC0_ATSR_ATS31          *((volatile unsigned char*)(0x42C8E6FCUL))
#define bFM4_ETHERNET_MAC0_MAR16H_MBC0         *((volatile unsigned char*)(0x42C90060UL))
#define bFM4_ETHERNET_MAC0_MAR16H_MBC1         *((volatile unsigned char*)(0x42C90064UL))
#define bFM4_ETHERNET_MAC0_MAR16H_MBC2         *((volatile unsigned char*)(0x42C90068UL))
#define bFM4_ETHERNET_MAC0_MAR16H_MBC3         *((volatile unsigned char*)(0x42C9006CUL))
#define bFM4_ETHERNET_MAC0_MAR16H_MBC4         *((volatile unsigned char*)(0x42C90070UL))
#define bFM4_ETHERNET_MAC0_MAR16H_MBC5         *((volatile unsigned char*)(0x42C90074UL))
#define bFM4_ETHERNET_MAC0_MAR16H_SA           *((volatile unsigned char*)(0x42C90078UL))
#define bFM4_ETHERNET_MAC0_MAR17H_MBC0         *((volatile unsigned char*)(0x42C90160UL))
#define bFM4_ETHERNET_MAC0_MAR17H_MBC1         *((volatile unsigned char*)(0x42C90164UL))
#define bFM4_ETHERNET_MAC0_MAR17H_MBC2         *((volatile unsigned char*)(0x42C90168UL))
#define bFM4_ETHERNET_MAC0_MAR17H_MBC3         *((volatile unsigned char*)(0x42C9016CUL))
#define bFM4_ETHERNET_MAC0_MAR17H_MBC4         *((volatile unsigned char*)(0x42C90170UL))
#define bFM4_ETHERNET_MAC0_MAR17H_MBC5         *((volatile unsigned char*)(0x42C90174UL))
#define bFM4_ETHERNET_MAC0_MAR17H_SA           *((volatile unsigned char*)(0x42C90178UL))
#define bFM4_ETHERNET_MAC0_MAR18H_MBC0         *((volatile unsigned char*)(0x42C90260UL))
#define bFM4_ETHERNET_MAC0_MAR18H_MBC1         *((volatile unsigned char*)(0x42C90264UL))
#define bFM4_ETHERNET_MAC0_MAR18H_MBC2         *((volatile unsigned char*)(0x42C90268UL))
#define bFM4_ETHERNET_MAC0_MAR18H_MBC3         *((volatile unsigned char*)(0x42C9026CUL))
#define bFM4_ETHERNET_MAC0_MAR18H_MBC4         *((volatile unsigned char*)(0x42C90270UL))
#define bFM4_ETHERNET_MAC0_MAR18H_MBC5         *((volatile unsigned char*)(0x42C90274UL))
#define bFM4_ETHERNET_MAC0_MAR18H_SA           *((volatile unsigned char*)(0x42C90278UL))
#define bFM4_ETHERNET_MAC0_MAR19H_MBC0         *((volatile unsigned char*)(0x42C90360UL))
#define bFM4_ETHERNET_MAC0_MAR19H_MBC1         *((volatile unsigned char*)(0x42C90364UL))
#define bFM4_ETHERNET_MAC0_MAR19H_MBC2         *((volatile unsigned char*)(0x42C90368UL))
#define bFM4_ETHERNET_MAC0_MAR19H_MBC3         *((volatile unsigned char*)(0x42C9036CUL))
#define bFM4_ETHERNET_MAC0_MAR19H_MBC4         *((volatile unsigned char*)(0x42C90370UL))
#define bFM4_ETHERNET_MAC0_MAR19H_MBC5         *((volatile unsigned char*)(0x42C90374UL))
#define bFM4_ETHERNET_MAC0_MAR19H_SA           *((volatile unsigned char*)(0x42C90378UL))
#define bFM4_ETHERNET_MAC0_MAR20H_MBC0         *((volatile unsigned char*)(0x42C90460UL))
#define bFM4_ETHERNET_MAC0_MAR20H_MBC1         *((volatile unsigned char*)(0x42C90464UL))
#define bFM4_ETHERNET_MAC0_MAR20H_MBC2         *((volatile unsigned char*)(0x42C90468UL))
#define bFM4_ETHERNET_MAC0_MAR20H_MBC3         *((volatile unsigned char*)(0x42C9046CUL))
#define bFM4_ETHERNET_MAC0_MAR20H_MBC4         *((volatile unsigned char*)(0x42C90470UL))
#define bFM4_ETHERNET_MAC0_MAR20H_MBC5         *((volatile unsigned char*)(0x42C90474UL))
#define bFM4_ETHERNET_MAC0_MAR20H_SA           *((volatile unsigned char*)(0x42C90478UL))
#define bFM4_ETHERNET_MAC0_MAR21H_MBC0         *((volatile unsigned char*)(0x42C90560UL))
#define bFM4_ETHERNET_MAC0_MAR21H_MBC1         *((volatile unsigned char*)(0x42C90564UL))
#define bFM4_ETHERNET_MAC0_MAR21H_MBC2         *((volatile unsigned char*)(0x42C90568UL))
#define bFM4_ETHERNET_MAC0_MAR21H_MBC3         *((volatile unsigned char*)(0x42C9056CUL))
#define bFM4_ETHERNET_MAC0_MAR21H_MBC4         *((volatile unsigned char*)(0x42C90570UL))
#define bFM4_ETHERNET_MAC0_MAR21H_MBC5         *((volatile unsigned char*)(0x42C90574UL))
#define bFM4_ETHERNET_MAC0_MAR21H_SA           *((volatile unsigned char*)(0x42C90578UL))
#define bFM4_ETHERNET_MAC0_MAR22H_MBC0         *((volatile unsigned char*)(0x42C90660UL))
#define bFM4_ETHERNET_MAC0_MAR22H_MBC1         *((volatile unsigned char*)(0x42C90664UL))
#define bFM4_ETHERNET_MAC0_MAR22H_MBC2         *((volatile unsigned char*)(0x42C90668UL))
#define bFM4_ETHERNET_MAC0_MAR22H_MBC3         *((volatile unsigned char*)(0x42C9066CUL))
#define bFM4_ETHERNET_MAC0_MAR22H_MBC4         *((volatile unsigned char*)(0x42C90670UL))
#define bFM4_ETHERNET_MAC0_MAR22H_MBC5         *((volatile unsigned char*)(0x42C90674UL))
#define bFM4_ETHERNET_MAC0_MAR22H_SA           *((volatile unsigned char*)(0x42C90678UL))
#define bFM4_ETHERNET_MAC0_MAR23H_MBC0         *((volatile unsigned char*)(0x42C90760UL))
#define bFM4_ETHERNET_MAC0_MAR23H_MBC1         *((volatile unsigned char*)(0x42C90764UL))
#define bFM4_ETHERNET_MAC0_MAR23H_MBC2         *((volatile unsigned char*)(0x42C90768UL))
#define bFM4_ETHERNET_MAC0_MAR23H_MBC3         *((volatile unsigned char*)(0x42C9076CUL))
#define bFM4_ETHERNET_MAC0_MAR23H_MBC4         *((volatile unsigned char*)(0x42C90770UL))
#define bFM4_ETHERNET_MAC0_MAR23H_MBC5         *((volatile unsigned char*)(0x42C90774UL))
#define bFM4_ETHERNET_MAC0_MAR23H_SA           *((volatile unsigned char*)(0x42C90778UL))
#define bFM4_ETHERNET_MAC0_MAR24H_MBC0         *((volatile unsigned char*)(0x42C90860UL))
#define bFM4_ETHERNET_MAC0_MAR24H_MBC1         *((volatile unsigned char*)(0x42C90864UL))
#define bFM4_ETHERNET_MAC0_MAR24H_MBC2         *((volatile unsigned char*)(0x42C90868UL))
#define bFM4_ETHERNET_MAC0_MAR24H_MBC3         *((volatile unsigned char*)(0x42C9086CUL))
#define bFM4_ETHERNET_MAC0_MAR24H_MBC4         *((volatile unsigned char*)(0x42C90870UL))
#define bFM4_ETHERNET_MAC0_MAR24H_MBC5         *((volatile unsigned char*)(0x42C90874UL))
#define bFM4_ETHERNET_MAC0_MAR24H_SA           *((volatile unsigned char*)(0x42C90878UL))
#define bFM4_ETHERNET_MAC0_MAR25H_MBC0         *((volatile unsigned char*)(0x42C90960UL))
#define bFM4_ETHERNET_MAC0_MAR25H_MBC1         *((volatile unsigned char*)(0x42C90964UL))
#define bFM4_ETHERNET_MAC0_MAR25H_MBC2         *((volatile unsigned char*)(0x42C90968UL))
#define bFM4_ETHERNET_MAC0_MAR25H_MBC3         *((volatile unsigned char*)(0x42C9096CUL))
#define bFM4_ETHERNET_MAC0_MAR25H_MBC4         *((volatile unsigned char*)(0x42C90970UL))
#define bFM4_ETHERNET_MAC0_MAR25H_MBC5         *((volatile unsigned char*)(0x42C90974UL))
#define bFM4_ETHERNET_MAC0_MAR25H_SA           *((volatile unsigned char*)(0x42C90978UL))
#define bFM4_ETHERNET_MAC0_MAR26H_MBC0         *((volatile unsigned char*)(0x42C90A60UL))
#define bFM4_ETHERNET_MAC0_MAR26H_MBC1         *((volatile unsigned char*)(0x42C90A64UL))
#define bFM4_ETHERNET_MAC0_MAR26H_MBC2         *((volatile unsigned char*)(0x42C90A68UL))
#define bFM4_ETHERNET_MAC0_MAR26H_MBC3         *((volatile unsigned char*)(0x42C90A6CUL))
#define bFM4_ETHERNET_MAC0_MAR26H_MBC4         *((volatile unsigned char*)(0x42C90A70UL))
#define bFM4_ETHERNET_MAC0_MAR26H_MBC5         *((volatile unsigned char*)(0x42C90A74UL))
#define bFM4_ETHERNET_MAC0_MAR26H_SA           *((volatile unsigned char*)(0x42C90A78UL))
#define bFM4_ETHERNET_MAC0_MAR27H_MBC0         *((volatile unsigned char*)(0x42C90B60UL))
#define bFM4_ETHERNET_MAC0_MAR27H_MBC1         *((volatile unsigned char*)(0x42C90B64UL))
#define bFM4_ETHERNET_MAC0_MAR27H_MBC2         *((volatile unsigned char*)(0x42C90B68UL))
#define bFM4_ETHERNET_MAC0_MAR27H_MBC3         *((volatile unsigned char*)(0x42C90B6CUL))
#define bFM4_ETHERNET_MAC0_MAR27H_MBC4         *((volatile unsigned char*)(0x42C90B70UL))
#define bFM4_ETHERNET_MAC0_MAR27H_MBC5         *((volatile unsigned char*)(0x42C90B74UL))
#define bFM4_ETHERNET_MAC0_MAR27H_SA           *((volatile unsigned char*)(0x42C90B78UL))
#define bFM4_ETHERNET_MAC0_MAR28H_MBC0         *((volatile unsigned char*)(0x42C90C60UL))
#define bFM4_ETHERNET_MAC0_MAR28H_MBC1         *((volatile unsigned char*)(0x42C90C64UL))
#define bFM4_ETHERNET_MAC0_MAR28H_MBC2         *((volatile unsigned char*)(0x42C90C68UL))
#define bFM4_ETHERNET_MAC0_MAR28H_MBC3         *((volatile unsigned char*)(0x42C90C6CUL))
#define bFM4_ETHERNET_MAC0_MAR28H_MBC4         *((volatile unsigned char*)(0x42C90C70UL))
#define bFM4_ETHERNET_MAC0_MAR28H_MBC5         *((volatile unsigned char*)(0x42C90C74UL))
#define bFM4_ETHERNET_MAC0_MAR28H_SA           *((volatile unsigned char*)(0x42C90C78UL))
#define bFM4_ETHERNET_MAC0_MAR29H_MBC0         *((volatile unsigned char*)(0x42C90D60UL))
#define bFM4_ETHERNET_MAC0_MAR29H_MBC1         *((volatile unsigned char*)(0x42C90D64UL))
#define bFM4_ETHERNET_MAC0_MAR29H_MBC2         *((volatile unsigned char*)(0x42C90D68UL))
#define bFM4_ETHERNET_MAC0_MAR29H_MBC3         *((volatile unsigned char*)(0x42C90D6CUL))
#define bFM4_ETHERNET_MAC0_MAR29H_MBC4         *((volatile unsigned char*)(0x42C90D70UL))
#define bFM4_ETHERNET_MAC0_MAR29H_MBC5         *((volatile unsigned char*)(0x42C90D74UL))
#define bFM4_ETHERNET_MAC0_MAR29H_SA           *((volatile unsigned char*)(0x42C90D78UL))
#define bFM4_ETHERNET_MAC0_MAR30H_MBC0         *((volatile unsigned char*)(0x42C90E60UL))
#define bFM4_ETHERNET_MAC0_MAR30H_MBC1         *((volatile unsigned char*)(0x42C90E64UL))
#define bFM4_ETHERNET_MAC0_MAR30H_MBC2         *((volatile unsigned char*)(0x42C90E68UL))
#define bFM4_ETHERNET_MAC0_MAR30H_MBC3         *((volatile unsigned char*)(0x42C90E6CUL))
#define bFM4_ETHERNET_MAC0_MAR30H_MBC4         *((volatile unsigned char*)(0x42C90E70UL))
#define bFM4_ETHERNET_MAC0_MAR30H_MBC5         *((volatile unsigned char*)(0x42C90E74UL))
#define bFM4_ETHERNET_MAC0_MAR30H_SA           *((volatile unsigned char*)(0x42C90E78UL))
#define bFM4_ETHERNET_MAC0_MAR31H_MBC0         *((volatile unsigned char*)(0x42C90F60UL))
#define bFM4_ETHERNET_MAC0_MAR31H_MBC1         *((volatile unsigned char*)(0x42C90F64UL))
#define bFM4_ETHERNET_MAC0_MAR31H_MBC2         *((volatile unsigned char*)(0x42C90F68UL))
#define bFM4_ETHERNET_MAC0_MAR31H_MBC3         *((volatile unsigned char*)(0x42C90F6CUL))
#define bFM4_ETHERNET_MAC0_MAR31H_MBC4         *((volatile unsigned char*)(0x42C90F70UL))
#define bFM4_ETHERNET_MAC0_MAR31H_MBC5         *((volatile unsigned char*)(0x42C90F74UL))
#define bFM4_ETHERNET_MAC0_MAR31H_SA           *((volatile unsigned char*)(0x42C90F78UL))
#define bFM4_ETHERNET_MAC0_BMR_SWR             *((volatile unsigned char*)(0x42CA0000UL))
#define bFM4_ETHERNET_MAC0_BMR_DA              *((volatile unsigned char*)(0x42CA0004UL))
#define bFM4_ETHERNET_MAC0_BMR_DSL0            *((volatile unsigned char*)(0x42CA0008UL))
#define bFM4_ETHERNET_MAC0_BMR_DSL1            *((volatile unsigned char*)(0x42CA000CUL))
#define bFM4_ETHERNET_MAC0_BMR_DSL2            *((volatile unsigned char*)(0x42CA0010UL))
#define bFM4_ETHERNET_MAC0_BMR_DSL3            *((volatile unsigned char*)(0x42CA0014UL))
#define bFM4_ETHERNET_MAC0_BMR_DSL4            *((volatile unsigned char*)(0x42CA0018UL))
#define bFM4_ETHERNET_MAC0_BMR_ATDS            *((volatile unsigned char*)(0x42CA001CUL))
#define bFM4_ETHERNET_MAC0_BMR_PBL0            *((volatile unsigned char*)(0x42CA0020UL))
#define bFM4_ETHERNET_MAC0_BMR_PBL1            *((volatile unsigned char*)(0x42CA0024UL))
#define bFM4_ETHERNET_MAC0_BMR_PBL2            *((volatile unsigned char*)(0x42CA0028UL))
#define bFM4_ETHERNET_MAC0_BMR_PBL3            *((volatile unsigned char*)(0x42CA002CUL))
#define bFM4_ETHERNET_MAC0_BMR_PBL4            *((volatile unsigned char*)(0x42CA0030UL))
#define bFM4_ETHERNET_MAC0_BMR_PBL5            *((volatile unsigned char*)(0x42CA0034UL))
#define bFM4_ETHERNET_MAC0_BMR_PR0             *((volatile unsigned char*)(0x42CA0038UL))
#define bFM4_ETHERNET_MAC0_BMR_PR1             *((volatile unsigned char*)(0x42CA003CUL))
#define bFM4_ETHERNET_MAC0_BMR_FB              *((volatile unsigned char*)(0x42CA0040UL))
#define bFM4_ETHERNET_MAC0_BMR_RPBL0           *((volatile unsigned char*)(0x42CA0044UL))
#define bFM4_ETHERNET_MAC0_BMR_RPBL1           *((volatile unsigned char*)(0x42CA0048UL))
#define bFM4_ETHERNET_MAC0_BMR_RPBL2           *((volatile unsigned char*)(0x42CA004CUL))
#define bFM4_ETHERNET_MAC0_BMR_RPBL3           *((volatile unsigned char*)(0x42CA0050UL))
#define bFM4_ETHERNET_MAC0_BMR_RPBL4           *((volatile unsigned char*)(0x42CA0054UL))
#define bFM4_ETHERNET_MAC0_BMR_RPBL5           *((volatile unsigned char*)(0x42CA0058UL))
#define bFM4_ETHERNET_MAC0_BMR_USP             *((volatile unsigned char*)(0x42CA005CUL))
#define bFM4_ETHERNET_MAC0_BMR_8XPBL           *((volatile unsigned char*)(0x42CA0060UL))
#define bFM4_ETHERNET_MAC0_BMR_AAL             *((volatile unsigned char*)(0x42CA0064UL))
#define bFM4_ETHERNET_MAC0_BMR_MB              *((volatile unsigned char*)(0x42CA0068UL))
#define bFM4_ETHERNET_MAC0_BMR_TXPR            *((volatile unsigned char*)(0x42CA006CUL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD0           *((volatile unsigned char*)(0x42CA0080UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD1           *((volatile unsigned char*)(0x42CA0084UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD2           *((volatile unsigned char*)(0x42CA0088UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD3           *((volatile unsigned char*)(0x42CA008CUL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD4           *((volatile unsigned char*)(0x42CA0090UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD5           *((volatile unsigned char*)(0x42CA0094UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD6           *((volatile unsigned char*)(0x42CA0098UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD7           *((volatile unsigned char*)(0x42CA009CUL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD8           *((volatile unsigned char*)(0x42CA00A0UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD9           *((volatile unsigned char*)(0x42CA00A4UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD10          *((volatile unsigned char*)(0x42CA00A8UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD11          *((volatile unsigned char*)(0x42CA00ACUL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD12          *((volatile unsigned char*)(0x42CA00B0UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD13          *((volatile unsigned char*)(0x42CA00B4UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD14          *((volatile unsigned char*)(0x42CA00B8UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD15          *((volatile unsigned char*)(0x42CA00BCUL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD16          *((volatile unsigned char*)(0x42CA00C0UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD17          *((volatile unsigned char*)(0x42CA00C4UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD18          *((volatile unsigned char*)(0x42CA00C8UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD19          *((volatile unsigned char*)(0x42CA00CCUL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD20          *((volatile unsigned char*)(0x42CA00D0UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD21          *((volatile unsigned char*)(0x42CA00D4UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD22          *((volatile unsigned char*)(0x42CA00D8UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD23          *((volatile unsigned char*)(0x42CA00DCUL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD24          *((volatile unsigned char*)(0x42CA00E0UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD25          *((volatile unsigned char*)(0x42CA00E4UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD26          *((volatile unsigned char*)(0x42CA00E8UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD27          *((volatile unsigned char*)(0x42CA00ECUL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD28          *((volatile unsigned char*)(0x42CA00F0UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD29          *((volatile unsigned char*)(0x42CA00F4UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD30          *((volatile unsigned char*)(0x42CA00F8UL))
#define bFM4_ETHERNET_MAC0_TPDR_TPD31          *((volatile unsigned char*)(0x42CA00FCUL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD0           *((volatile unsigned char*)(0x42CA0100UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD1           *((volatile unsigned char*)(0x42CA0104UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD2           *((volatile unsigned char*)(0x42CA0108UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD3           *((volatile unsigned char*)(0x42CA010CUL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD4           *((volatile unsigned char*)(0x42CA0110UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD5           *((volatile unsigned char*)(0x42CA0114UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD6           *((volatile unsigned char*)(0x42CA0118UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD7           *((volatile unsigned char*)(0x42CA011CUL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD8           *((volatile unsigned char*)(0x42CA0120UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD9           *((volatile unsigned char*)(0x42CA0124UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD10          *((volatile unsigned char*)(0x42CA0128UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD11          *((volatile unsigned char*)(0x42CA012CUL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD12          *((volatile unsigned char*)(0x42CA0130UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD13          *((volatile unsigned char*)(0x42CA0134UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD14          *((volatile unsigned char*)(0x42CA0138UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD15          *((volatile unsigned char*)(0x42CA013CUL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD16          *((volatile unsigned char*)(0x42CA0140UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD17          *((volatile unsigned char*)(0x42CA0144UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD18          *((volatile unsigned char*)(0x42CA0148UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD19          *((volatile unsigned char*)(0x42CA014CUL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD20          *((volatile unsigned char*)(0x42CA0150UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD21          *((volatile unsigned char*)(0x42CA0154UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD22          *((volatile unsigned char*)(0x42CA0158UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD23          *((volatile unsigned char*)(0x42CA015CUL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD24          *((volatile unsigned char*)(0x42CA0160UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD25          *((volatile unsigned char*)(0x42CA0164UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD26          *((volatile unsigned char*)(0x42CA0168UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD27          *((volatile unsigned char*)(0x42CA016CUL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD28          *((volatile unsigned char*)(0x42CA0170UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD29          *((volatile unsigned char*)(0x42CA0174UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD30          *((volatile unsigned char*)(0x42CA0178UL))
#define bFM4_ETHERNET_MAC0_RPDR_RPD31          *((volatile unsigned char*)(0x42CA017CUL))
#define bFM4_ETHERNET_MAC0_SR_TI               *((volatile unsigned char*)(0x42CA0280UL))
#define bFM4_ETHERNET_MAC0_SR_TPS              *((volatile unsigned char*)(0x42CA0284UL))
#define bFM4_ETHERNET_MAC0_SR_TU               *((volatile unsigned char*)(0x42CA0288UL))
#define bFM4_ETHERNET_MAC0_SR_TJT              *((volatile unsigned char*)(0x42CA028CUL))
#define bFM4_ETHERNET_MAC0_SR_OVF              *((volatile unsigned char*)(0x42CA0290UL))
#define bFM4_ETHERNET_MAC0_SR_UNF              *((volatile unsigned char*)(0x42CA0294UL))
#define bFM4_ETHERNET_MAC0_SR_RI               *((volatile unsigned char*)(0x42CA0298UL))
#define bFM4_ETHERNET_MAC0_SR_RU               *((volatile unsigned char*)(0x42CA029CUL))
#define bFM4_ETHERNET_MAC0_SR_RPS              *((volatile unsigned char*)(0x42CA02A0UL))
#define bFM4_ETHERNET_MAC0_SR_RWT              *((volatile unsigned char*)(0x42CA02A4UL))
#define bFM4_ETHERNET_MAC0_SR_ETI              *((volatile unsigned char*)(0x42CA02A8UL))
#define bFM4_ETHERNET_MAC0_SR_FBI              *((volatile unsigned char*)(0x42CA02B4UL))
#define bFM4_ETHERNET_MAC0_SR_ERI              *((volatile unsigned char*)(0x42CA02B8UL))
#define bFM4_ETHERNET_MAC0_SR_AIS              *((volatile unsigned char*)(0x42CA02BCUL))
#define bFM4_ETHERNET_MAC0_SR_NIS              *((volatile unsigned char*)(0x42CA02C0UL))
#define bFM4_ETHERNET_MAC0_SR_RS0              *((volatile unsigned char*)(0x42CA02C4UL))
#define bFM4_ETHERNET_MAC0_SR_RS1              *((volatile unsigned char*)(0x42CA02C8UL))
#define bFM4_ETHERNET_MAC0_SR_RS2              *((volatile unsigned char*)(0x42CA02CCUL))
#define bFM4_ETHERNET_MAC0_SR_TS0              *((volatile unsigned char*)(0x42CA02D0UL))
#define bFM4_ETHERNET_MAC0_SR_TS1              *((volatile unsigned char*)(0x42CA02D4UL))
#define bFM4_ETHERNET_MAC0_SR_TS2              *((volatile unsigned char*)(0x42CA02D8UL))
#define bFM4_ETHERNET_MAC0_SR_EB0              *((volatile unsigned char*)(0x42CA02DCUL))
#define bFM4_ETHERNET_MAC0_SR_EB1              *((volatile unsigned char*)(0x42CA02E0UL))
#define bFM4_ETHERNET_MAC0_SR_EB2              *((volatile unsigned char*)(0x42CA02E4UL))
#define bFM4_ETHERNET_MAC0_SR_GLI              *((volatile unsigned char*)(0x42CA02E8UL))
#define bFM4_ETHERNET_MAC0_SR_GMI              *((volatile unsigned char*)(0x42CA02ECUL))
#define bFM4_ETHERNET_MAC0_SR_GPI              *((volatile unsigned char*)(0x42CA02F0UL))
#define bFM4_ETHERNET_MAC0_SR_TTI              *((volatile unsigned char*)(0x42CA02F4UL))
#define bFM4_ETHERNET_MAC0_SR_GLPII            *((volatile unsigned char*)(0x42CA02F8UL))
#define bFM4_ETHERNET_MAC0_OMR_SR              *((volatile unsigned char*)(0x42CA0304UL))
#define bFM4_ETHERNET_MAC0_OMR_OSF             *((volatile unsigned char*)(0x42CA0308UL))
#define bFM4_ETHERNET_MAC0_OMR_RTC0            *((volatile unsigned char*)(0x42CA030CUL))
#define bFM4_ETHERNET_MAC0_OMR_RTC1            *((volatile unsigned char*)(0x42CA0310UL))
#define bFM4_ETHERNET_MAC0_OMR_FUF             *((volatile unsigned char*)(0x42CA0318UL))
#define bFM4_ETHERNET_MAC0_OMR_FEF             *((volatile unsigned char*)(0x42CA031CUL))
#define bFM4_ETHERNET_MAC0_OMR_ST              *((volatile unsigned char*)(0x42CA0334UL))
#define bFM4_ETHERNET_MAC0_OMR_TTC0            *((volatile unsigned char*)(0x42CA0338UL))
#define bFM4_ETHERNET_MAC0_OMR_TTC1            *((volatile unsigned char*)(0x42CA033CUL))
#define bFM4_ETHERNET_MAC0_OMR_TTC2            *((volatile unsigned char*)(0x42CA0340UL))
#define bFM4_ETHERNET_MAC0_OMR_FTF             *((volatile unsigned char*)(0x42CA0350UL))
#define bFM4_ETHERNET_MAC0_OMR_TSF             *((volatile unsigned char*)(0x42CA0354UL))
#define bFM4_ETHERNET_MAC0_OMR_DFF             *((volatile unsigned char*)(0x42CA0360UL))
#define bFM4_ETHERNET_MAC0_OMR_RSF             *((volatile unsigned char*)(0x42CA0364UL))
#define bFM4_ETHERNET_MAC0_OMR_DT              *((volatile unsigned char*)(0x42CA0368UL))
#define bFM4_ETHERNET_MAC0_IER_TIE             *((volatile unsigned char*)(0x42CA0380UL))
#define bFM4_ETHERNET_MAC0_IER_TSE             *((volatile unsigned char*)(0x42CA0384UL))
#define bFM4_ETHERNET_MAC0_IER_TUE             *((volatile unsigned char*)(0x42CA0388UL))
#define bFM4_ETHERNET_MAC0_IER_TJE             *((volatile unsigned char*)(0x42CA038CUL))
#define bFM4_ETHERNET_MAC0_IER_OVE             *((volatile unsigned char*)(0x42CA0390UL))
#define bFM4_ETHERNET_MAC0_IER_UNE             *((volatile unsigned char*)(0x42CA0394UL))
#define bFM4_ETHERNET_MAC0_IER_RIE             *((volatile unsigned char*)(0x42CA0398UL))
#define bFM4_ETHERNET_MAC0_IER_RUE             *((volatile unsigned char*)(0x42CA039CUL))
#define bFM4_ETHERNET_MAC0_IER_RSE             *((volatile unsigned char*)(0x42CA03A0UL))
#define bFM4_ETHERNET_MAC0_IER_RWE             *((volatile unsigned char*)(0x42CA03A4UL))
#define bFM4_ETHERNET_MAC0_IER_ETE             *((volatile unsigned char*)(0x42CA03A8UL))
#define bFM4_ETHERNET_MAC0_IER_FBE             *((volatile unsigned char*)(0x42CA03B4UL))
#define bFM4_ETHERNET_MAC0_IER_ERE             *((volatile unsigned char*)(0x42CA03B8UL))
#define bFM4_ETHERNET_MAC0_IER_AIE             *((volatile unsigned char*)(0x42CA03BCUL))
#define bFM4_ETHERNET_MAC0_IER_NIE             *((volatile unsigned char*)(0x42CA03C0UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH0        *((volatile unsigned char*)(0x42CA0400UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH1        *((volatile unsigned char*)(0x42CA0404UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH2        *((volatile unsigned char*)(0x42CA0408UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH3        *((volatile unsigned char*)(0x42CA040CUL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH4        *((volatile unsigned char*)(0x42CA0410UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH5        *((volatile unsigned char*)(0x42CA0414UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH6        *((volatile unsigned char*)(0x42CA0418UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH7        *((volatile unsigned char*)(0x42CA041CUL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH8        *((volatile unsigned char*)(0x42CA0420UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH9        *((volatile unsigned char*)(0x42CA0424UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH10       *((volatile unsigned char*)(0x42CA0428UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH11       *((volatile unsigned char*)(0x42CA042CUL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH12       *((volatile unsigned char*)(0x42CA0430UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH13       *((volatile unsigned char*)(0x42CA0434UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH14       *((volatile unsigned char*)(0x42CA0438UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFH15       *((volatile unsigned char*)(0x42CA043CUL))
#define bFM4_ETHERNET_MAC0_MFBOCR_ONMFH        *((volatile unsigned char*)(0x42CA0440UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF0        *((volatile unsigned char*)(0x42CA0444UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF1        *((volatile unsigned char*)(0x42CA0448UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF2        *((volatile unsigned char*)(0x42CA044CUL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF3        *((volatile unsigned char*)(0x42CA0450UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF4        *((volatile unsigned char*)(0x42CA0454UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF5        *((volatile unsigned char*)(0x42CA0458UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF6        *((volatile unsigned char*)(0x42CA045CUL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF7        *((volatile unsigned char*)(0x42CA0460UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF8        *((volatile unsigned char*)(0x42CA0464UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF9        *((volatile unsigned char*)(0x42CA0468UL))
#define bFM4_ETHERNET_MAC0_MFBOCR_NMFF10       *((volatile unsigned char*)(0x42CA046CUL))
#define bFM4_ETHERNET_MAC0_MFBOCR_ONMFF        *((volatile unsigned char*)(0x42CA0470UL))
#define bFM4_ETHERNET_MAC0_RIWTR_RIWT0         *((volatile unsigned char*)(0x42CA0480UL))
#define bFM4_ETHERNET_MAC0_RIWTR_RIWT1         *((volatile unsigned char*)(0x42CA0484UL))
#define bFM4_ETHERNET_MAC0_RIWTR_RIWT2         *((volatile unsigned char*)(0x42CA0488UL))
#define bFM4_ETHERNET_MAC0_RIWTR_RIWT3         *((volatile unsigned char*)(0x42CA048CUL))
#define bFM4_ETHERNET_MAC0_RIWTR_RIWT4         *((volatile unsigned char*)(0x42CA0490UL))
#define bFM4_ETHERNET_MAC0_RIWTR_RIWT5         *((volatile unsigned char*)(0x42CA0494UL))
#define bFM4_ETHERNET_MAC0_RIWTR_RIWT6         *((volatile unsigned char*)(0x42CA0498UL))
#define bFM4_ETHERNET_MAC0_RIWTR_RIWT7         *((volatile unsigned char*)(0x42CA049CUL))
#define bFM4_ETHERNET_MAC0_AHBSR_AHBS          *((volatile unsigned char*)(0x42CA0580UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP0        *((volatile unsigned char*)(0x42CA0900UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP1        *((volatile unsigned char*)(0x42CA0904UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP2        *((volatile unsigned char*)(0x42CA0908UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP3        *((volatile unsigned char*)(0x42CA090CUL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP4        *((volatile unsigned char*)(0x42CA0910UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP5        *((volatile unsigned char*)(0x42CA0914UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP6        *((volatile unsigned char*)(0x42CA0918UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP7        *((volatile unsigned char*)(0x42CA091CUL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP8        *((volatile unsigned char*)(0x42CA0920UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP9        *((volatile unsigned char*)(0x42CA0924UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP10       *((volatile unsigned char*)(0x42CA0928UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP11       *((volatile unsigned char*)(0x42CA092CUL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP12       *((volatile unsigned char*)(0x42CA0930UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP13       *((volatile unsigned char*)(0x42CA0934UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP14       *((volatile unsigned char*)(0x42CA0938UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP15       *((volatile unsigned char*)(0x42CA093CUL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP16       *((volatile unsigned char*)(0x42CA0940UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP17       *((volatile unsigned char*)(0x42CA0944UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP18       *((volatile unsigned char*)(0x42CA0948UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP19       *((volatile unsigned char*)(0x42CA094CUL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP20       *((volatile unsigned char*)(0x42CA0950UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP21       *((volatile unsigned char*)(0x42CA0954UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP22       *((volatile unsigned char*)(0x42CA0958UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP23       *((volatile unsigned char*)(0x42CA095CUL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP24       *((volatile unsigned char*)(0x42CA0960UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP25       *((volatile unsigned char*)(0x42CA0964UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP26       *((volatile unsigned char*)(0x42CA0968UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP27       *((volatile unsigned char*)(0x42CA096CUL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP28       *((volatile unsigned char*)(0x42CA0970UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP29       *((volatile unsigned char*)(0x42CA0974UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP30       *((volatile unsigned char*)(0x42CA0978UL))
#define bFM4_ETHERNET_MAC0_CHTDR_HTDAP31       *((volatile unsigned char*)(0x42CA097CUL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP0        *((volatile unsigned char*)(0x42CA0980UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP1        *((volatile unsigned char*)(0x42CA0984UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP2        *((volatile unsigned char*)(0x42CA0988UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP3        *((volatile unsigned char*)(0x42CA098CUL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP4        *((volatile unsigned char*)(0x42CA0990UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP5        *((volatile unsigned char*)(0x42CA0994UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP6        *((volatile unsigned char*)(0x42CA0998UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP7        *((volatile unsigned char*)(0x42CA099CUL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP8        *((volatile unsigned char*)(0x42CA09A0UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP9        *((volatile unsigned char*)(0x42CA09A4UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP10       *((volatile unsigned char*)(0x42CA09A8UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP11       *((volatile unsigned char*)(0x42CA09ACUL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP12       *((volatile unsigned char*)(0x42CA09B0UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP13       *((volatile unsigned char*)(0x42CA09B4UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP14       *((volatile unsigned char*)(0x42CA09B8UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP15       *((volatile unsigned char*)(0x42CA09BCUL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP16       *((volatile unsigned char*)(0x42CA09C0UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP17       *((volatile unsigned char*)(0x42CA09C4UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP18       *((volatile unsigned char*)(0x42CA09C8UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP19       *((volatile unsigned char*)(0x42CA09CCUL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP20       *((volatile unsigned char*)(0x42CA09D0UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP21       *((volatile unsigned char*)(0x42CA09D4UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP22       *((volatile unsigned char*)(0x42CA09D8UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP23       *((volatile unsigned char*)(0x42CA09DCUL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP24       *((volatile unsigned char*)(0x42CA09E0UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP25       *((volatile unsigned char*)(0x42CA09E4UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP26       *((volatile unsigned char*)(0x42CA09E8UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP27       *((volatile unsigned char*)(0x42CA09ECUL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP28       *((volatile unsigned char*)(0x42CA09F0UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP29       *((volatile unsigned char*)(0x42CA09F4UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP30       *((volatile unsigned char*)(0x42CA09F8UL))
#define bFM4_ETHERNET_MAC0_CHRDR_HRDAP31       *((volatile unsigned char*)(0x42CA09FCUL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR0       *((volatile unsigned char*)(0x42CA0A00UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR1       *((volatile unsigned char*)(0x42CA0A04UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR2       *((volatile unsigned char*)(0x42CA0A08UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR3       *((volatile unsigned char*)(0x42CA0A0CUL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR4       *((volatile unsigned char*)(0x42CA0A10UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR5       *((volatile unsigned char*)(0x42CA0A14UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR6       *((volatile unsigned char*)(0x42CA0A18UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR7       *((volatile unsigned char*)(0x42CA0A1CUL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR8       *((volatile unsigned char*)(0x42CA0A20UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR9       *((volatile unsigned char*)(0x42CA0A24UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR10      *((volatile unsigned char*)(0x42CA0A28UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR11      *((volatile unsigned char*)(0x42CA0A2CUL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR12      *((volatile unsigned char*)(0x42CA0A30UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR13      *((volatile unsigned char*)(0x42CA0A34UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR14      *((volatile unsigned char*)(0x42CA0A38UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR15      *((volatile unsigned char*)(0x42CA0A3CUL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR16      *((volatile unsigned char*)(0x42CA0A40UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR17      *((volatile unsigned char*)(0x42CA0A44UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR18      *((volatile unsigned char*)(0x42CA0A48UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR19      *((volatile unsigned char*)(0x42CA0A4CUL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR20      *((volatile unsigned char*)(0x42CA0A50UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR21      *((volatile unsigned char*)(0x42CA0A54UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR22      *((volatile unsigned char*)(0x42CA0A58UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR23      *((volatile unsigned char*)(0x42CA0A5CUL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR24      *((volatile unsigned char*)(0x42CA0A60UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR25      *((volatile unsigned char*)(0x42CA0A64UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR26      *((volatile unsigned char*)(0x42CA0A68UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR27      *((volatile unsigned char*)(0x42CA0A6CUL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR28      *((volatile unsigned char*)(0x42CA0A70UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR29      *((volatile unsigned char*)(0x42CA0A74UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR30      *((volatile unsigned char*)(0x42CA0A78UL))
#define bFM4_ETHERNET_MAC0_CHTBAR_HTBAR31      *((volatile unsigned char*)(0x42CA0A7CUL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR0       *((volatile unsigned char*)(0x42CA0A80UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR1       *((volatile unsigned char*)(0x42CA0A84UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR2       *((volatile unsigned char*)(0x42CA0A88UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR3       *((volatile unsigned char*)(0x42CA0A8CUL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR4       *((volatile unsigned char*)(0x42CA0A90UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR5       *((volatile unsigned char*)(0x42CA0A94UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR6       *((volatile unsigned char*)(0x42CA0A98UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR7       *((volatile unsigned char*)(0x42CA0A9CUL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR8       *((volatile unsigned char*)(0x42CA0AA0UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR9       *((volatile unsigned char*)(0x42CA0AA4UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR10      *((volatile unsigned char*)(0x42CA0AA8UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR11      *((volatile unsigned char*)(0x42CA0AACUL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR12      *((volatile unsigned char*)(0x42CA0AB0UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR13      *((volatile unsigned char*)(0x42CA0AB4UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR14      *((volatile unsigned char*)(0x42CA0AB8UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR15      *((volatile unsigned char*)(0x42CA0ABCUL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR16      *((volatile unsigned char*)(0x42CA0AC0UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR17      *((volatile unsigned char*)(0x42CA0AC4UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR18      *((volatile unsigned char*)(0x42CA0AC8UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR19      *((volatile unsigned char*)(0x42CA0ACCUL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR20      *((volatile unsigned char*)(0x42CA0AD0UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR21      *((volatile unsigned char*)(0x42CA0AD4UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR22      *((volatile unsigned char*)(0x42CA0AD8UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR23      *((volatile unsigned char*)(0x42CA0ADCUL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR24      *((volatile unsigned char*)(0x42CA0AE0UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR25      *((volatile unsigned char*)(0x42CA0AE4UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR26      *((volatile unsigned char*)(0x42CA0AE8UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR27      *((volatile unsigned char*)(0x42CA0AECUL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR28      *((volatile unsigned char*)(0x42CA0AF0UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR29      *((volatile unsigned char*)(0x42CA0AF4UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR30      *((volatile unsigned char*)(0x42CA0AF8UL))
#define bFM4_ETHERNET_MAC0_CHRBAR_HRBAR31      *((volatile unsigned char*)(0x42CA0AFCUL))

/* Ethernet MAC control registers */
#define bFM4_ETHERNET_CONTROL_ETH_MODE_IFMODE  *((volatile unsigned char*)(0x42CC0000UL))
#define bFM4_ETHERNET_CONTROL_ETH_MODE_RST0    *((volatile unsigned char*)(0x42CC0020UL))
#define bFM4_ETHERNET_CONTROL_ETH_MODE_RST1    *((volatile unsigned char*)(0x42CC0024UL))
#define bFM4_ETHERNET_CONTROL_ETH_MODE_PPSSEL  *((volatile unsigned char*)(0x42CC0070UL))
#define bFM4_ETHERNET_CONTROL_ETH_CLKG_MACEN0  *((volatile unsigned char*)(0x42CC0100UL))
#define bFM4_ETHERNET_CONTROL_ETH_CLKG_MACEN1  *((volatile unsigned char*)(0x42CC0104UL))

/* I2S interface ch.0 registers */
#define bFM4_I2S0_RXFDAT_RXDATA0               *((volatile unsigned char*)(0x42D80000UL))
#define bFM4_I2S0_RXFDAT_RXDATA1               *((volatile unsigned char*)(0x42D80004UL))
#define bFM4_I2S0_RXFDAT_RXDATA2               *((volatile unsigned char*)(0x42D80008UL))
#define bFM4_I2S0_RXFDAT_RXDATA3               *((volatile unsigned char*)(0x42D8000CUL))
#define bFM4_I2S0_RXFDAT_RXDATA4               *((volatile unsigned char*)(0x42D80010UL))
#define bFM4_I2S0_RXFDAT_RXDATA5               *((volatile unsigned char*)(0x42D80014UL))
#define bFM4_I2S0_RXFDAT_RXDATA6               *((volatile unsigned char*)(0x42D80018UL))
#define bFM4_I2S0_RXFDAT_RXDATA7               *((volatile unsigned char*)(0x42D8001CUL))
#define bFM4_I2S0_RXFDAT_RXDATA8               *((volatile unsigned char*)(0x42D80020UL))
#define bFM4_I2S0_RXFDAT_RXDATA9               *((volatile unsigned char*)(0x42D80024UL))
#define bFM4_I2S0_RXFDAT_RXDATA10              *((volatile unsigned char*)(0x42D80028UL))
#define bFM4_I2S0_RXFDAT_RXDATA11              *((volatile unsigned char*)(0x42D8002CUL))
#define bFM4_I2S0_RXFDAT_RXDATA12              *((volatile unsigned char*)(0x42D80030UL))
#define bFM4_I2S0_RXFDAT_RXDATA13              *((volatile unsigned char*)(0x42D80034UL))
#define bFM4_I2S0_RXFDAT_RXDATA14              *((volatile unsigned char*)(0x42D80038UL))
#define bFM4_I2S0_RXFDAT_RXDATA15              *((volatile unsigned char*)(0x42D8003CUL))
#define bFM4_I2S0_RXFDAT_RXDATA16              *((volatile unsigned char*)(0x42D80040UL))
#define bFM4_I2S0_RXFDAT_RXDATA17              *((volatile unsigned char*)(0x42D80044UL))
#define bFM4_I2S0_RXFDAT_RXDATA18              *((volatile unsigned char*)(0x42D80048UL))
#define bFM4_I2S0_RXFDAT_RXDATA19              *((volatile unsigned char*)(0x42D8004CUL))
#define bFM4_I2S0_RXFDAT_RXDATA20              *((volatile unsigned char*)(0x42D80050UL))
#define bFM4_I2S0_RXFDAT_RXDATA21              *((volatile unsigned char*)(0x42D80054UL))
#define bFM4_I2S0_RXFDAT_RXDATA22              *((volatile unsigned char*)(0x42D80058UL))
#define bFM4_I2S0_RXFDAT_RXDATA23              *((volatile unsigned char*)(0x42D8005CUL))
#define bFM4_I2S0_RXFDAT_RXDATA24              *((volatile unsigned char*)(0x42D80060UL))
#define bFM4_I2S0_RXFDAT_RXDATA25              *((volatile unsigned char*)(0x42D80064UL))
#define bFM4_I2S0_RXFDAT_RXDATA26              *((volatile unsigned char*)(0x42D80068UL))
#define bFM4_I2S0_RXFDAT_RXDATA27              *((volatile unsigned char*)(0x42D8006CUL))
#define bFM4_I2S0_RXFDAT_RXDATA28              *((volatile unsigned char*)(0x42D80070UL))
#define bFM4_I2S0_RXFDAT_RXDATA29              *((volatile unsigned char*)(0x42D80074UL))
#define bFM4_I2S0_RXFDAT_RXDATA30              *((volatile unsigned char*)(0x42D80078UL))
#define bFM4_I2S0_RXFDAT_RXDATA31              *((volatile unsigned char*)(0x42D8007CUL))
#define bFM4_I2S0_TXFDAT_TXDATA0               *((volatile unsigned char*)(0x42D80080UL))
#define bFM4_I2S0_TXFDAT_TXDATA1               *((volatile unsigned char*)(0x42D80084UL))
#define bFM4_I2S0_TXFDAT_TXDATA2               *((volatile unsigned char*)(0x42D80088UL))
#define bFM4_I2S0_TXFDAT_TXDATA3               *((volatile unsigned char*)(0x42D8008CUL))
#define bFM4_I2S0_TXFDAT_TXDATA4               *((volatile unsigned char*)(0x42D80090UL))
#define bFM4_I2S0_TXFDAT_TXDATA5               *((volatile unsigned char*)(0x42D80094UL))
#define bFM4_I2S0_TXFDAT_TXDATA6               *((volatile unsigned char*)(0x42D80098UL))
#define bFM4_I2S0_TXFDAT_TXDATA7               *((volatile unsigned char*)(0x42D8009CUL))
#define bFM4_I2S0_TXFDAT_TXDATA8               *((volatile unsigned char*)(0x42D800A0UL))
#define bFM4_I2S0_TXFDAT_TXDATA9               *((volatile unsigned char*)(0x42D800A4UL))
#define bFM4_I2S0_TXFDAT_TXDATA10              *((volatile unsigned char*)(0x42D800A8UL))
#define bFM4_I2S0_TXFDAT_TXDATA11              *((volatile unsigned char*)(0x42D800ACUL))
#define bFM4_I2S0_TXFDAT_TXDATA12              *((volatile unsigned char*)(0x42D800B0UL))
#define bFM4_I2S0_TXFDAT_TXDATA13              *((volatile unsigned char*)(0x42D800B4UL))
#define bFM4_I2S0_TXFDAT_TXDATA14              *((volatile unsigned char*)(0x42D800B8UL))
#define bFM4_I2S0_TXFDAT_TXDATA15              *((volatile unsigned char*)(0x42D800BCUL))
#define bFM4_I2S0_TXFDAT_TXDATA16              *((volatile unsigned char*)(0x42D800C0UL))
#define bFM4_I2S0_TXFDAT_TXDATA17              *((volatile unsigned char*)(0x42D800C4UL))
#define bFM4_I2S0_TXFDAT_TXDATA18              *((volatile unsigned char*)(0x42D800C8UL))
#define bFM4_I2S0_TXFDAT_TXDATA19              *((volatile unsigned char*)(0x42D800CCUL))
#define bFM4_I2S0_TXFDAT_TXDATA20              *((volatile unsigned char*)(0x42D800D0UL))
#define bFM4_I2S0_TXFDAT_TXDATA21              *((volatile unsigned char*)(0x42D800D4UL))
#define bFM4_I2S0_TXFDAT_TXDATA22              *((volatile unsigned char*)(0x42D800D8UL))
#define bFM4_I2S0_TXFDAT_TXDATA23              *((volatile unsigned char*)(0x42D800DCUL))
#define bFM4_I2S0_TXFDAT_TXDATA24              *((volatile unsigned char*)(0x42D800E0UL))
#define bFM4_I2S0_TXFDAT_TXDATA25              *((volatile unsigned char*)(0x42D800E4UL))
#define bFM4_I2S0_TXFDAT_TXDATA26              *((volatile unsigned char*)(0x42D800E8UL))
#define bFM4_I2S0_TXFDAT_TXDATA27              *((volatile unsigned char*)(0x42D800ECUL))
#define bFM4_I2S0_TXFDAT_TXDATA28              *((volatile unsigned char*)(0x42D800F0UL))
#define bFM4_I2S0_TXFDAT_TXDATA29              *((volatile unsigned char*)(0x42D800F4UL))
#define bFM4_I2S0_TXFDAT_TXDATA30              *((volatile unsigned char*)(0x42D800F8UL))
#define bFM4_I2S0_TXFDAT_TXDATA31              *((volatile unsigned char*)(0x42D800FCUL))
#define bFM4_I2S0_CNTREG_FSPL                  *((volatile unsigned char*)(0x42D80100UL))
#define bFM4_I2S0_CNTREG_FSLN                  *((volatile unsigned char*)(0x42D80104UL))
#define bFM4_I2S0_CNTREG_FSPH                  *((volatile unsigned char*)(0x42D80108UL))
#define bFM4_I2S0_CNTREG_CPOL                  *((volatile unsigned char*)(0x42D8010CUL))
#define bFM4_I2S0_CNTREG_SMPL                  *((volatile unsigned char*)(0x42D80110UL))
#define bFM4_I2S0_CNTREG_RXDIS                 *((volatile unsigned char*)(0x42D80114UL))
#define bFM4_I2S0_CNTREG_TXDIS                 *((volatile unsigned char*)(0x42D80118UL))
#define bFM4_I2S0_CNTREG_MLSB                  *((volatile unsigned char*)(0x42D8011CUL))
#define bFM4_I2S0_CNTREG_FRUN                  *((volatile unsigned char*)(0x42D80120UL))
#define bFM4_I2S0_CNTREG_BEXT                  *((volatile unsigned char*)(0x42D80124UL))
#define bFM4_I2S0_CNTREG_ECKM                  *((volatile unsigned char*)(0x42D80128UL))
#define bFM4_I2S0_CNTREG_RHLL                  *((volatile unsigned char*)(0x42D8012CUL))
#define bFM4_I2S0_CNTREG_SBFN                  *((volatile unsigned char*)(0x42D80130UL))
#define bFM4_I2S0_CNTREG_MSMD                  *((volatile unsigned char*)(0x42D80134UL))
#define bFM4_I2S0_CNTREG_MSKB                  *((volatile unsigned char*)(0x42D80138UL))
#define bFM4_I2S0_CNTREG_OVHD0                 *((volatile unsigned char*)(0x42D80140UL))
#define bFM4_I2S0_CNTREG_OVHD1                 *((volatile unsigned char*)(0x42D80144UL))
#define bFM4_I2S0_CNTREG_OVHD2                 *((volatile unsigned char*)(0x42D80148UL))
#define bFM4_I2S0_CNTREG_OVHD3                 *((volatile unsigned char*)(0x42D8014CUL))
#define bFM4_I2S0_CNTREG_OVHD4                 *((volatile unsigned char*)(0x42D80150UL))
#define bFM4_I2S0_CNTREG_OVHD5                 *((volatile unsigned char*)(0x42D80154UL))
#define bFM4_I2S0_CNTREG_OVHD6                 *((volatile unsigned char*)(0x42D80158UL))
#define bFM4_I2S0_CNTREG_OVHD7                 *((volatile unsigned char*)(0x42D8015CUL))
#define bFM4_I2S0_CNTREG_OVHD8                 *((volatile unsigned char*)(0x42D80160UL))
#define bFM4_I2S0_CNTREG_OVHD9                 *((volatile unsigned char*)(0x42D80164UL))
#define bFM4_I2S0_CNTREG_CKRT0                 *((volatile unsigned char*)(0x42D80168UL))
#define bFM4_I2S0_CNTREG_CKRT1                 *((volatile unsigned char*)(0x42D8016CUL))
#define bFM4_I2S0_CNTREG_CKRT2                 *((volatile unsigned char*)(0x42D80170UL))
#define bFM4_I2S0_CNTREG_CKRT3                 *((volatile unsigned char*)(0x42D80174UL))
#define bFM4_I2S0_CNTREG_CKRT4                 *((volatile unsigned char*)(0x42D80178UL))
#define bFM4_I2S0_CNTREG_CKRT5                 *((volatile unsigned char*)(0x42D8017CUL))
#define bFM4_I2S0_MCR0REG_S0WDL0               *((volatile unsigned char*)(0x42D80180UL))
#define bFM4_I2S0_MCR0REG_S0WDL1               *((volatile unsigned char*)(0x42D80184UL))
#define bFM4_I2S0_MCR0REG_S0WDL2               *((volatile unsigned char*)(0x42D80188UL))
#define bFM4_I2S0_MCR0REG_S0WDL3               *((volatile unsigned char*)(0x42D8018CUL))
#define bFM4_I2S0_MCR0REG_S0WDL4               *((volatile unsigned char*)(0x42D80190UL))
#define bFM4_I2S0_MCR0REG_S0CHL0               *((volatile unsigned char*)(0x42D80194UL))
#define bFM4_I2S0_MCR0REG_S0CHL1               *((volatile unsigned char*)(0x42D80198UL))
#define bFM4_I2S0_MCR0REG_S0CHL2               *((volatile unsigned char*)(0x42D8019CUL))
#define bFM4_I2S0_MCR0REG_S0CHL3               *((volatile unsigned char*)(0x42D801A0UL))
#define bFM4_I2S0_MCR0REG_S0CHL4               *((volatile unsigned char*)(0x42D801A4UL))
#define bFM4_I2S0_MCR0REG_S0CHN0               *((volatile unsigned char*)(0x42D801A8UL))
#define bFM4_I2S0_MCR0REG_S0CHN1               *((volatile unsigned char*)(0x42D801ACUL))
#define bFM4_I2S0_MCR0REG_S0CHN2               *((volatile unsigned char*)(0x42D801B0UL))
#define bFM4_I2S0_MCR0REG_S0CHN3               *((volatile unsigned char*)(0x42D801B4UL))
#define bFM4_I2S0_MCR0REG_S0CHN4               *((volatile unsigned char*)(0x42D801B8UL))
#define bFM4_I2S0_MCR0REG_S1WDL0               *((volatile unsigned char*)(0x42D801C0UL))
#define bFM4_I2S0_MCR0REG_S1WDL1               *((volatile unsigned char*)(0x42D801C4UL))
#define bFM4_I2S0_MCR0REG_S1WDL2               *((volatile unsigned char*)(0x42D801C8UL))
#define bFM4_I2S0_MCR0REG_S1WDL3               *((volatile unsigned char*)(0x42D801CCUL))
#define bFM4_I2S0_MCR0REG_S1WDL4               *((volatile unsigned char*)(0x42D801D0UL))
#define bFM4_I2S0_MCR0REG_S1CHL0               *((volatile unsigned char*)(0x42D801D4UL))
#define bFM4_I2S0_MCR0REG_S1CHL1               *((volatile unsigned char*)(0x42D801D8UL))
#define bFM4_I2S0_MCR0REG_S1CHL2               *((volatile unsigned char*)(0x42D801DCUL))
#define bFM4_I2S0_MCR0REG_S1CHL3               *((volatile unsigned char*)(0x42D801E0UL))
#define bFM4_I2S0_MCR0REG_S1CHL4               *((volatile unsigned char*)(0x42D801E4UL))
#define bFM4_I2S0_MCR0REG_S1CHN0               *((volatile unsigned char*)(0x42D801E8UL))
#define bFM4_I2S0_MCR0REG_S1CHN1               *((volatile unsigned char*)(0x42D801ECUL))
#define bFM4_I2S0_MCR0REG_S1CHN2               *((volatile unsigned char*)(0x42D801F0UL))
#define bFM4_I2S0_MCR0REG_S1CHN3               *((volatile unsigned char*)(0x42D801F4UL))
#define bFM4_I2S0_MCR0REG_S1CHN4               *((volatile unsigned char*)(0x42D801F8UL))
#define bFM4_I2S0_MCR1REG_S0CH00               *((volatile unsigned char*)(0x42D80200UL))
#define bFM4_I2S0_MCR1REG_S0CH01               *((volatile unsigned char*)(0x42D80204UL))
#define bFM4_I2S0_MCR1REG_S0CH02               *((volatile unsigned char*)(0x42D80208UL))
#define bFM4_I2S0_MCR1REG_S0CH03               *((volatile unsigned char*)(0x42D8020CUL))
#define bFM4_I2S0_MCR1REG_S0CH04               *((volatile unsigned char*)(0x42D80210UL))
#define bFM4_I2S0_MCR1REG_S0CH05               *((volatile unsigned char*)(0x42D80214UL))
#define bFM4_I2S0_MCR1REG_S0CH06               *((volatile unsigned char*)(0x42D80218UL))
#define bFM4_I2S0_MCR1REG_S0CH07               *((volatile unsigned char*)(0x42D8021CUL))
#define bFM4_I2S0_MCR1REG_S0CH08               *((volatile unsigned char*)(0x42D80220UL))
#define bFM4_I2S0_MCR1REG_S0CH09               *((volatile unsigned char*)(0x42D80224UL))
#define bFM4_I2S0_MCR1REG_S0CH10               *((volatile unsigned char*)(0x42D80228UL))
#define bFM4_I2S0_MCR1REG_S0CH11               *((volatile unsigned char*)(0x42D8022CUL))
#define bFM4_I2S0_MCR1REG_S0CH12               *((volatile unsigned char*)(0x42D80230UL))
#define bFM4_I2S0_MCR1REG_S0CH13               *((volatile unsigned char*)(0x42D80234UL))
#define bFM4_I2S0_MCR1REG_S0CH14               *((volatile unsigned char*)(0x42D80238UL))
#define bFM4_I2S0_MCR1REG_S0CH15               *((volatile unsigned char*)(0x42D8023CUL))
#define bFM4_I2S0_MCR1REG_S0CH16               *((volatile unsigned char*)(0x42D80240UL))
#define bFM4_I2S0_MCR1REG_S0CH17               *((volatile unsigned char*)(0x42D80244UL))
#define bFM4_I2S0_MCR1REG_S0CH18               *((volatile unsigned char*)(0x42D80248UL))
#define bFM4_I2S0_MCR1REG_S0CH19               *((volatile unsigned char*)(0x42D8024CUL))
#define bFM4_I2S0_MCR1REG_S0CH20               *((volatile unsigned char*)(0x42D80250UL))
#define bFM4_I2S0_MCR1REG_S0CH21               *((volatile unsigned char*)(0x42D80254UL))
#define bFM4_I2S0_MCR1REG_S0CH22               *((volatile unsigned char*)(0x42D80258UL))
#define bFM4_I2S0_MCR1REG_S0CH23               *((volatile unsigned char*)(0x42D8025CUL))
#define bFM4_I2S0_MCR1REG_S0CH24               *((volatile unsigned char*)(0x42D80260UL))
#define bFM4_I2S0_MCR1REG_S0CH25               *((volatile unsigned char*)(0x42D80264UL))
#define bFM4_I2S0_MCR1REG_S0CH26               *((volatile unsigned char*)(0x42D80268UL))
#define bFM4_I2S0_MCR1REG_S0CH27               *((volatile unsigned char*)(0x42D8026CUL))
#define bFM4_I2S0_MCR1REG_S0CH28               *((volatile unsigned char*)(0x42D80270UL))
#define bFM4_I2S0_MCR1REG_S0CH29               *((volatile unsigned char*)(0x42D80274UL))
#define bFM4_I2S0_MCR1REG_S0CH30               *((volatile unsigned char*)(0x42D80278UL))
#define bFM4_I2S0_MCR1REG_S0CH31               *((volatile unsigned char*)(0x42D8027CUL))
#define bFM4_I2S0_MCR2REG_S1CH00               *((volatile unsigned char*)(0x42D80280UL))
#define bFM4_I2S0_MCR2REG_S1CH01               *((volatile unsigned char*)(0x42D80284UL))
#define bFM4_I2S0_MCR2REG_S1CH02               *((volatile unsigned char*)(0x42D80288UL))
#define bFM4_I2S0_MCR2REG_S1CH03               *((volatile unsigned char*)(0x42D8028CUL))
#define bFM4_I2S0_MCR2REG_S1CH04               *((volatile unsigned char*)(0x42D80290UL))
#define bFM4_I2S0_MCR2REG_S1CH05               *((volatile unsigned char*)(0x42D80294UL))
#define bFM4_I2S0_MCR2REG_S1CH06               *((volatile unsigned char*)(0x42D80298UL))
#define bFM4_I2S0_MCR2REG_S1CH07               *((volatile unsigned char*)(0x42D8029CUL))
#define bFM4_I2S0_MCR2REG_S1CH08               *((volatile unsigned char*)(0x42D802A0UL))
#define bFM4_I2S0_MCR2REG_S1CH09               *((volatile unsigned char*)(0x42D802A4UL))
#define bFM4_I2S0_MCR2REG_S1CH10               *((volatile unsigned char*)(0x42D802A8UL))
#define bFM4_I2S0_MCR2REG_S1CH11               *((volatile unsigned char*)(0x42D802ACUL))
#define bFM4_I2S0_MCR2REG_S1CH12               *((volatile unsigned char*)(0x42D802B0UL))
#define bFM4_I2S0_MCR2REG_S1CH13               *((volatile unsigned char*)(0x42D802B4UL))
#define bFM4_I2S0_MCR2REG_S1CH14               *((volatile unsigned char*)(0x42D802B8UL))
#define bFM4_I2S0_MCR2REG_S1CH15               *((volatile unsigned char*)(0x42D802BCUL))
#define bFM4_I2S0_MCR2REG_S1CH16               *((volatile unsigned char*)(0x42D802C0UL))
#define bFM4_I2S0_MCR2REG_S1CH17               *((volatile unsigned char*)(0x42D802C4UL))
#define bFM4_I2S0_MCR2REG_S1CH18               *((volatile unsigned char*)(0x42D802C8UL))
#define bFM4_I2S0_MCR2REG_S1CH19               *((volatile unsigned char*)(0x42D802CCUL))
#define bFM4_I2S0_MCR2REG_S1CH20               *((volatile unsigned char*)(0x42D802D0UL))
#define bFM4_I2S0_MCR2REG_S1CH21               *((volatile unsigned char*)(0x42D802D4UL))
#define bFM4_I2S0_MCR2REG_S1CH22               *((volatile unsigned char*)(0x42D802D8UL))
#define bFM4_I2S0_MCR2REG_S1CH23               *((volatile unsigned char*)(0x42D802DCUL))
#define bFM4_I2S0_MCR2REG_S1CH24               *((volatile unsigned char*)(0x42D802E0UL))
#define bFM4_I2S0_MCR2REG_S1CH25               *((volatile unsigned char*)(0x42D802E4UL))
#define bFM4_I2S0_MCR2REG_S1CH26               *((volatile unsigned char*)(0x42D802E8UL))
#define bFM4_I2S0_MCR2REG_S1CH27               *((volatile unsigned char*)(0x42D802ECUL))
#define bFM4_I2S0_MCR2REG_S1CH28               *((volatile unsigned char*)(0x42D802F0UL))
#define bFM4_I2S0_MCR2REG_S1CH29               *((volatile unsigned char*)(0x42D802F4UL))
#define bFM4_I2S0_MCR2REG_S1CH30               *((volatile unsigned char*)(0x42D802F8UL))
#define bFM4_I2S0_MCR2REG_S1CH31               *((volatile unsigned char*)(0x42D802FCUL))
#define bFM4_I2S0_OPRREG_START                 *((volatile unsigned char*)(0x42D80300UL))
#define bFM4_I2S0_OPRREG_TXENB                 *((volatile unsigned char*)(0x42D80340UL))
#define bFM4_I2S0_OPRREG_RXENB                 *((volatile unsigned char*)(0x42D80360UL))
#define bFM4_I2S0_SRST_SRST                    *((volatile unsigned char*)(0x42D80380UL))
#define bFM4_I2S0_INTCNT_RFTH0                 *((volatile unsigned char*)(0x42D80400UL))
#define bFM4_I2S0_INTCNT_RFTH1                 *((volatile unsigned char*)(0x42D80404UL))
#define bFM4_I2S0_INTCNT_RFTH2                 *((volatile unsigned char*)(0x42D80408UL))
#define bFM4_I2S0_INTCNT_RFTH3                 *((volatile unsigned char*)(0x42D8040CUL))
#define bFM4_I2S0_INTCNT_RPTMR0                *((volatile unsigned char*)(0x42D80410UL))
#define bFM4_I2S0_INTCNT_RPTMR1                *((volatile unsigned char*)(0x42D80414UL))
#define bFM4_I2S0_INTCNT_TFTH0                 *((volatile unsigned char*)(0x42D80420UL))
#define bFM4_I2S0_INTCNT_TFTH1                 *((volatile unsigned char*)(0x42D80424UL))
#define bFM4_I2S0_INTCNT_TFTH2                 *((volatile unsigned char*)(0x42D80428UL))
#define bFM4_I2S0_INTCNT_TFTH3                 *((volatile unsigned char*)(0x42D8042CUL))
#define bFM4_I2S0_INTCNT_RXFIM                 *((volatile unsigned char*)(0x42D80440UL))
#define bFM4_I2S0_INTCNT_RXFDM                 *((volatile unsigned char*)(0x42D80444UL))
#define bFM4_I2S0_INTCNT_EOPM                  *((volatile unsigned char*)(0x42D80448UL))
#define bFM4_I2S0_INTCNT_RXOVM                 *((volatile unsigned char*)(0x42D8044CUL))
#define bFM4_I2S0_INTCNT_RXUDM                 *((volatile unsigned char*)(0x42D80450UL))
#define bFM4_I2S0_INTCNT_RBERM                 *((volatile unsigned char*)(0x42D80454UL))
#define bFM4_I2S0_INTCNT_TXFIM                 *((volatile unsigned char*)(0x42D80460UL))
#define bFM4_I2S0_INTCNT_TXFDM                 *((volatile unsigned char*)(0x42D80464UL))
#define bFM4_I2S0_INTCNT_TXOVM                 *((volatile unsigned char*)(0x42D80468UL))
#define bFM4_I2S0_INTCNT_TXUD0M                *((volatile unsigned char*)(0x42D8046CUL))
#define bFM4_I2S0_INTCNT_FERRM                 *((volatile unsigned char*)(0x42D80470UL))
#define bFM4_I2S0_INTCNT_TBERM                 *((volatile unsigned char*)(0x42D80474UL))
#define bFM4_I2S0_INTCNT_TXUD1M                *((volatile unsigned char*)(0x42D80478UL))
#define bFM4_I2S0_STATUS_RXNUM0                *((volatile unsigned char*)(0x42D80480UL))
#define bFM4_I2S0_STATUS_RXNUM1                *((volatile unsigned char*)(0x42D80484UL))
#define bFM4_I2S0_STATUS_RXNUM2                *((volatile unsigned char*)(0x42D80488UL))
#define bFM4_I2S0_STATUS_RXNUM3                *((volatile unsigned char*)(0x42D8048CUL))
#define bFM4_I2S0_STATUS_RXNUM4                *((volatile unsigned char*)(0x42D80490UL))
#define bFM4_I2S0_STATUS_RXNUM5                *((volatile unsigned char*)(0x42D80494UL))
#define bFM4_I2S0_STATUS_RXNUM6                *((volatile unsigned char*)(0x42D80498UL))
#define bFM4_I2S0_STATUS_RXNUM7                *((volatile unsigned char*)(0x42D8049CUL))
#define bFM4_I2S0_STATUS_TXNUM0                *((volatile unsigned char*)(0x42D804A0UL))
#define bFM4_I2S0_STATUS_TXNUM1                *((volatile unsigned char*)(0x42D804A4UL))
#define bFM4_I2S0_STATUS_TXNUM2                *((volatile unsigned char*)(0x42D804A8UL))
#define bFM4_I2S0_STATUS_TXNUM3                *((volatile unsigned char*)(0x42D804ACUL))
#define bFM4_I2S0_STATUS_TXNUM4                *((volatile unsigned char*)(0x42D804B0UL))
#define bFM4_I2S0_STATUS_TXNUM5                *((volatile unsigned char*)(0x42D804B4UL))
#define bFM4_I2S0_STATUS_TXNUM6                *((volatile unsigned char*)(0x42D804B8UL))
#define bFM4_I2S0_STATUS_TXNUM7                *((volatile unsigned char*)(0x42D804BCUL))
#define bFM4_I2S0_STATUS_RXFI                  *((volatile unsigned char*)(0x42D804C0UL))
#define bFM4_I2S0_STATUS_TXFI                  *((volatile unsigned char*)(0x42D804C4UL))
#define bFM4_I2S0_STATUS_BSY                   *((volatile unsigned char*)(0x42D804C8UL))
#define bFM4_I2S0_STATUS_EOPI                  *((volatile unsigned char*)(0x42D804CCUL))
#define bFM4_I2S0_STATUS_RXOVR                 *((volatile unsigned char*)(0x42D804E0UL))
#define bFM4_I2S0_STATUS_RXUDR                 *((volatile unsigned char*)(0x42D804E4UL))
#define bFM4_I2S0_STATUS_TXOVR                 *((volatile unsigned char*)(0x42D804E8UL))
#define bFM4_I2S0_STATUS_TXUDR0                *((volatile unsigned char*)(0x42D804ECUL))
#define bFM4_I2S0_STATUS_TXUDR1                *((volatile unsigned char*)(0x42D804F0UL))
#define bFM4_I2S0_STATUS_FERR                  *((volatile unsigned char*)(0x42D804F4UL))
#define bFM4_I2S0_STATUS_RBERR                 *((volatile unsigned char*)(0x42D804F8UL))
#define bFM4_I2S0_STATUS_TBERR                 *((volatile unsigned char*)(0x42D804FCUL))
#define bFM4_I2S0_DMAACT_RDMACT                *((volatile unsigned char*)(0x42D80500UL))
#define bFM4_I2S0_DMAACT_RL1E0                 *((volatile unsigned char*)(0x42D80520UL))
#define bFM4_I2S0_DMAACT_TDMACT                *((volatile unsigned char*)(0x42D80540UL))
#define bFM4_I2S0_DMAACT_TL1E0                 *((volatile unsigned char*)(0x42D80560UL))
#define bFM4_I2S0_TSTREG_LBMD                  *((volatile unsigned char*)(0x42D80580UL))

/* SD IF registers */
#define bFM4_SDIF_STRSFMD_DMAEN                *((volatile unsigned char*)(0x42dc0180UL))
#define bFM4_SDIF_STRSFMD_BLCKCNTEN            *((volatile unsigned char*)(0x42dc0184UL))
#define bFM4_SDIF_STRSFMD_DTTRSFDIR            *((volatile unsigned char*)(0x42dc0190UL))
#define bFM4_SDIF_STRSFMD_BLCKCNTSEL           *((volatile unsigned char*)(0x42dc0194UL))
#define bFM4_SDIF_SCMMD_CMDCRCCHKE             *((volatile unsigned char*)(0x42dc01cCUL))
#define bFM4_SDIF_SCMMD_CMDIDXCHKE             *((volatile unsigned char*)(0x42dc01d0UL))
#define bFM4_SDIF_SCMMD_DATPRESSEL             *((volatile unsigned char*)(0x42dc01d4UL))
#define bFM4_SDIF_SPRSTAT_CMDINH               *((volatile unsigned char*)(0x42dc0480UL))
#define bFM4_SDIF_SPRSTAT_CMDDAYTINH           *((volatile unsigned char*)(0x42dc0484UL))
#define bFM4_SDIF_SPRSTAT_DATLNACT             *((volatile unsigned char*)(0x42dc0488UL))
#define bFM4_SDIF_SPRSTAT_RETUNEREQ            *((volatile unsigned char*)(0x42dc048CUL))
#define bFM4_SDIF_SPRSTAT_WRTRSFACT            *((volatile unsigned char*)(0x42dc04a0UL))
#define bFM4_SDIF_SPRSTAT_RDTRSFACT            *((volatile unsigned char*)(0x42dc04a4UL))
#define bFM4_SDIF_SPRSTAT_BUFWREN              *((volatile unsigned char*)(0x42dc04a8UL))
#define bFM4_SDIF_SPRSTAT_BUFRDEN              *((volatile unsigned char*)(0x42dc04aCUL))
#define bFM4_SDIF_SPRSTAT_CARDINS              *((volatile unsigned char*)(0x42dc04c0UL))
#define bFM4_SDIF_SPRSTAT_CARDSTB              *((volatile unsigned char*)(0x42dc04c4UL))
#define bFM4_SDIF_SPRSTAT_CARDDET              *((volatile unsigned char*)(0x42dc04c8UL))
#define bFM4_SDIF_SPRSTAT_WPPINLVL             *((volatile unsigned char*)(0x42dc04cCUL))
#define bFM4_SDIF_SPRSTAT_CMDLNSGN             *((volatile unsigned char*)(0x42dc04e0UL))
#define bFM4_SDIF_SHCTL1_LEDCTRL               *((volatile unsigned char*)(0x42dc0500UL))
#define bFM4_SDIF_SHCTL1_DATAWIDTH             *((volatile unsigned char*)(0x42dc0504UL))
#define bFM4_SDIF_SHCTL1_HIGHSPDEN             *((volatile unsigned char*)(0x42dc0508UL))
#define bFM4_SDIF_SHCTL1_EXTDTWIDTH            *((volatile unsigned char*)(0x42dc0514UL))
#define bFM4_SDIF_SHCTL1_CDTSTLVL              *((volatile unsigned char*)(0x42dc0518UL))
#define bFM4_SDIF_SHCTL1_CDSGNSEL              *((volatile unsigned char*)(0x42dc051CUL))
#define bFM4_SDIF_SPWRCTL_SDBUSPWR             *((volatile unsigned char*)(0x42dc0520UL))
#define bFM4_SDIF_SBLKGPCTL_BLCKGSTPREQ        *((volatile unsigned char*)(0x42dc0540UL))
#define bFM4_SDIF_SBLKGPCTL_CONTREQ            *((volatile unsigned char*)(0x42dc0544UL))
#define bFM4_SDIF_SBLKGPCTL_RDWAITCTL          *((volatile unsigned char*)(0x42dc0548UL))
#define bFM4_SDIF_SBLKGPCTL_BLCKGAPINT         *((volatile unsigned char*)(0x42dc054CUL))
#define bFM4_SDIF_SWKUPCTL_WKUPEVNTEN0         *((volatile unsigned char*)(0x42dc0560UL))
#define bFM4_SDIF_SWKUPCTL_WKUPEVNTEN1         *((volatile unsigned char*)(0x42dc0564UL))
#define bFM4_SDIF_SWKUPCTL_WKUPEVNTEN2         *((volatile unsigned char*)(0x42dc0568UL))
#define bFM4_SDIF_SCLKCTL_INTLCLCKEN           *((volatile unsigned char*)(0x42dc0580UL))
#define bFM4_SDIF_SCLKCTL_INTLCLCKST           *((volatile unsigned char*)(0x42dc0584UL))
#define bFM4_SDIF_SCLKCTL_SDCLCKEN             *((volatile unsigned char*)(0x42dc0588UL))
#define bFM4_SDIF_SCLKCTL_CLCKGENSEL           *((volatile unsigned char*)(0x42dc0594UL))
#define bFM4_SDIF_SSRST_SWRSTALL               *((volatile unsigned char*)(0x42dc05e0UL))
#define bFM4_SDIF_SSRST_SWRSTCMDLN             *((volatile unsigned char*)(0x42dc05e4UL))
#define bFM4_SDIF_SSRST_SWRSTDATLN             *((volatile unsigned char*)(0x42dc05e8UL))
#define bFM4_SDIF_SNINTST_CMDCMPLT             *((volatile unsigned char*)(0x42dc0600UL))
#define bFM4_SDIF_SNINTST_TRSFCMPLT            *((volatile unsigned char*)(0x42dc0604UL))
#define bFM4_SDIF_SNINTST_BLCKGEVNT            *((volatile unsigned char*)(0x42dc0608UL))
#define bFM4_SDIF_SNINTST_DMAINT               *((volatile unsigned char*)(0x42dc060CUL))
#define bFM4_SDIF_SNINTST_BUFWRRDY             *((volatile unsigned char*)(0x42dc0610UL))
#define bFM4_SDIF_SNINTST_BUFRDRDY             *((volatile unsigned char*)(0x42dc0614UL))
#define bFM4_SDIF_SNINTST_CARDINS              *((volatile unsigned char*)(0x42dc0618UL))
#define bFM4_SDIF_SNINTST_CARDRMV              *((volatile unsigned char*)(0x42dc061CUL))
#define bFM4_SDIF_SNINTST_CARDINT              *((volatile unsigned char*)(0x42dc0620UL))
#define bFM4_SDIF_SNINTST_INT_A                *((volatile unsigned char*)(0x42dc0624UL))
#define bFM4_SDIF_SNINTST_INT_B                *((volatile unsigned char*)(0x42dc0628UL))
#define bFM4_SDIF_SNINTST_INT_C                *((volatile unsigned char*)(0x42dc062CUL))
#define bFM4_SDIF_SNINTST_RETUNEEVT            *((volatile unsigned char*)(0x42dc0630UL))
#define bFM4_SDIF_SNINTST_ERRORINT             *((volatile unsigned char*)(0x42dc063CUL))
#define bFM4_SDIF_SEINTST_CMDTOERR             *((volatile unsigned char*)(0x42dc0640UL))
#define bFM4_SDIF_SEINTST_CMDCRCERR            *((volatile unsigned char*)(0x42dc0644UL))
#define bFM4_SDIF_SEINTST_CMDEBERR             *((volatile unsigned char*)(0x42dc0648UL))
#define bFM4_SDIF_SEINTST_CMDIDXERR            *((volatile unsigned char*)(0x42dc064CUL))
#define bFM4_SDIF_SEINTST_DTTOERR              *((volatile unsigned char*)(0x42dc0650UL))
#define bFM4_SDIF_SEINTST_DTEBERR              *((volatile unsigned char*)(0x42dc0654UL))
#define bFM4_SDIF_SEINTST_DTCRCERR             *((volatile unsigned char*)(0x42dc0658UL))
#define bFM4_SDIF_SEINTST_CRTLMTERR            *((volatile unsigned char*)(0x42dc065CUL))
#define bFM4_SDIF_SEINTST_ACMD12ERR            *((volatile unsigned char*)(0x42dc0660UL))
#define bFM4_SDIF_SEINTST_ADMAERR              *((volatile unsigned char*)(0x42dc0664UL))
#define bFM4_SDIF_SEINTST_TUNINGERR            *((volatile unsigned char*)(0x42dc0668UL))
#define bFM4_SDIF_SEINTST_BTACKERR             *((volatile unsigned char*)(0x42dc0670UL))
#define bFM4_SDIF_SEINTST_ACMD19ERR            *((volatile unsigned char*)(0x42dc0674UL))
#define bFM4_SDIF_SEINTST_AHBMSTERR            *((volatile unsigned char*)(0x42dc0678UL))
#define bFM4_SDIF_SNINTSTE_CMDCMPLTS           *((volatile unsigned char*)(0x42dc0680UL))
#define bFM4_SDIF_SNINTSTE_TRSFCMPLTS          *((volatile unsigned char*)(0x42dc0684UL))
#define bFM4_SDIF_SNINTSTE_BLCKGEVNTS          *((volatile unsigned char*)(0x42dc0688UL))
#define bFM4_SDIF_SNINTSTE_DMAINTS             *((volatile unsigned char*)(0x42dc068CUL))
#define bFM4_SDIF_SNINTSTE_BUFWRRDYS           *((volatile unsigned char*)(0x42dc0690UL))
#define bFM4_SDIF_SNINTSTE_BUFRDRDYS           *((volatile unsigned char*)(0x42dc0694UL))
#define bFM4_SDIF_SNINTSTE_CARDINSS            *((volatile unsigned char*)(0x42dc0698UL))
#define bFM4_SDIF_SNINTSTE_CARDRMVS            *((volatile unsigned char*)(0x42dc069CUL))
#define bFM4_SDIF_SNINTSTE_CARDINTS            *((volatile unsigned char*)(0x42dc06a0UL))
#define bFM4_SDIF_SNINTSTE_INT_AS              *((volatile unsigned char*)(0x42dc06a4UL))
#define bFM4_SDIF_SNINTSTE_INT_BS              *((volatile unsigned char*)(0x42dc06a8UL))
#define bFM4_SDIF_SNINTSTE_INT_CS              *((volatile unsigned char*)(0x42dc06aCUL))
#define bFM4_SDIF_SNINTSTE_RETUNEEVTS          *((volatile unsigned char*)(0x42dc06b0UL))
#define bFM4_SDIF_SEINTSTE_CMDTOERRS           *((volatile unsigned char*)(0x42dc06c0UL))
#define bFM4_SDIF_SEINTSTE_CMDCRCERRS          *((volatile unsigned char*)(0x42dc06c4UL))
#define bFM4_SDIF_SEINTSTE_CMDEBERRS           *((volatile unsigned char*)(0x42dc06c8UL))
#define bFM4_SDIF_SEINTSTE_CMDIDXERRS          *((volatile unsigned char*)(0x42dc06cCUL))
#define bFM4_SDIF_SEINTSTE_DTTOERRS            *((volatile unsigned char*)(0x42dc06d0UL))
#define bFM4_SDIF_SEINTSTE_DTEBERRS            *((volatile unsigned char*)(0x42dc06d4UL))
#define bFM4_SDIF_SEINTSTE_DTCRCERRS           *((volatile unsigned char*)(0x42dc06d8UL))
#define bFM4_SDIF_SEINTSTE_CRTLMTERRS          *((volatile unsigned char*)(0x42dc06dCUL))
#define bFM4_SDIF_SEINTSTE_ACMD12ERRS          *((volatile unsigned char*)(0x42dc06e0UL))
#define bFM4_SDIF_SEINTSTE_ADMAERRS            *((volatile unsigned char*)(0x42dc06e4UL))
#define bFM4_SDIF_SEINTSTE_TUNINGERRS          *((volatile unsigned char*)(0x42dc06e8UL))
#define bFM4_SDIF_SEINTSTE_BTACKERRS           *((volatile unsigned char*)(0x42dc06f0UL))
#define bFM4_SDIF_SEINTSTE_ACMD19ERRS          *((volatile unsigned char*)(0x42dc06f4UL))
#define bFM4_SDIF_SEINTSTE_AHBMSTERRS          *((volatile unsigned char*)(0x42dc06f8UL))
#define bFM4_SDIF_SNINTSGE_CMDCMPLTG           *((volatile unsigned char*)(0x42dc0700UL))
#define bFM4_SDIF_SNINTSGE_TRSFCMPLTG          *((volatile unsigned char*)(0x42dc0704UL))
#define bFM4_SDIF_SNINTSGE_BLCKGEVNTG          *((volatile unsigned char*)(0x42dc0708UL))
#define bFM4_SDIF_SNINTSGE_DMAINTG             *((volatile unsigned char*)(0x42dc070CUL))
#define bFM4_SDIF_SNINTSGE_BUFWRRDYG           *((volatile unsigned char*)(0x42dc0710UL))
#define bFM4_SDIF_SNINTSGE_BUFRDRDYG           *((volatile unsigned char*)(0x42dc0714UL))
#define bFM4_SDIF_SNINTSGE_CARDINSG            *((volatile unsigned char*)(0x42dc0718UL))
#define bFM4_SDIF_SNINTSGE_CARDRMVG            *((volatile unsigned char*)(0x42dc071CUL))
#define bFM4_SDIF_SNINTSGE_CARDINTG            *((volatile unsigned char*)(0x42dc0720UL))
#define bFM4_SDIF_SNINTSGE_INT_AG              *((volatile unsigned char*)(0x42dc0724UL))
#define bFM4_SDIF_SNINTSGE_INT_BG              *((volatile unsigned char*)(0x42dc0728UL))
#define bFM4_SDIF_SNINTSGE_INT_CG              *((volatile unsigned char*)(0x42dc072CUL))
#define bFM4_SDIF_SNINTSGE_RETUNEEVTG          *((volatile unsigned char*)(0x42dc0730UL))
#define bFM4_SDIF_SEINTSGE_CMDTOERRG           *((volatile unsigned char*)(0x42dc0740UL))
#define bFM4_SDIF_SEINTSGE_CMDCRCERRG          *((volatile unsigned char*)(0x42dc0744UL))
#define bFM4_SDIF_SEINTSGE_CMDEBERRG           *((volatile unsigned char*)(0x42dc0748UL))
#define bFM4_SDIF_SEINTSGE_CMDIDXERRG          *((volatile unsigned char*)(0x42dc074CUL))
#define bFM4_SDIF_SEINTSGE_DTTOERRG            *((volatile unsigned char*)(0x42dc0750UL))
#define bFM4_SDIF_SEINTSGE_DTEBERRG            *((volatile unsigned char*)(0x42dc0754UL))
#define bFM4_SDIF_SEINTSGE_DTCRCERRG           *((volatile unsigned char*)(0x42dc0758UL))
#define bFM4_SDIF_SEINTSGE_CRTLMTERRG          *((volatile unsigned char*)(0x42dc075CUL))
#define bFM4_SDIF_SEINTSGE_ACMD12ERRG          *((volatile unsigned char*)(0x42dc0760UL))
#define bFM4_SDIF_SEINTSGE_ADMAERRG            *((volatile unsigned char*)(0x42dc0764UL))
#define bFM4_SDIF_SEINTSGE_TUNINGERRG          *((volatile unsigned char*)(0x42dc0768UL))
#define bFM4_SDIF_SEINTSGE_BTACKERRG           *((volatile unsigned char*)(0x42dc0770UL))
#define bFM4_SDIF_SEINTSGE_ACMD19ERRG          *((volatile unsigned char*)(0x42dc0774UL))
#define bFM4_SDIF_SEINTSGE_AHBMSTERRG          *((volatile unsigned char*)(0x42dc0778UL))
#define bFM4_SDIF_SACMDEST_ACMD12NOEX          *((volatile unsigned char*)(0x42dc0780UL))
#define bFM4_SDIF_SACMDEST_ACMDTOERR           *((volatile unsigned char*)(0x42dc0784UL))
#define bFM4_SDIF_SACMDEST_ACMDCRCERR          *((volatile unsigned char*)(0x42dc0788UL))
#define bFM4_SDIF_SACMDEST_ACMDEBERR           *((volatile unsigned char*)(0x42dc078CUL))
#define bFM4_SDIF_SACMDEST_ACMDIDXERR          *((volatile unsigned char*)(0x42dc0790UL))
#define bFM4_SDIF_SACMDEST_CMDND12ERR          *((volatile unsigned char*)(0x42dc079CUL))
#define bFM4_SDIF_SHCTL2_V18SGNEN              *((volatile unsigned char*)(0x42dc07cCUL))
#define bFM4_SDIF_SHCTL2_DOTUING               *((volatile unsigned char*)(0x42dc07d8UL))
#define bFM4_SDIF_SHCTL2_SMPCLKSEK             *((volatile unsigned char*)(0x42dc07dCUL))
#define bFM4_SDIF_SHCTL2_ASYINTEN              *((volatile unsigned char*)(0x42dc07f8UL))
#define bFM4_SDIF_SHCTL2_PREVALEN              *((volatile unsigned char*)(0x42dc07fCUL))
#define bFM4_SDIF_CAPBLTY0_TOCLKUNIT           *((volatile unsigned char*)(0x42dc081CUL))
#define bFM4_SDIF_CAPBLTY1_EMBD8BIT            *((volatile unsigned char*)(0x42dc0848UL))
#define bFM4_SDIF_CAPBLTY1_ADMA2SPT            *((volatile unsigned char*)(0x42dc084CUL))
#define bFM4_SDIF_CAPBLTY1_HGHSPDSPT           *((volatile unsigned char*)(0x42dc0854UL))
#define bFM4_SDIF_CAPBLTY1_SDMASPT             *((volatile unsigned char*)(0x42dc0858UL))
#define bFM4_SDIF_CAPBLTY1_LWPWRSPT            *((volatile unsigned char*)(0x42dc085CUL))
#define bFM4_SDIF_CAPBLTY1_V33SPT              *((volatile unsigned char*)(0x42dc0860UL))
#define bFM4_SDIF_CAPBLTY1_V30SPT              *((volatile unsigned char*)(0x42dc0864UL))
#define bFM4_SDIF_CAPBLTY1_V18SPT              *((volatile unsigned char*)(0x42dc0868UL))
#define bFM4_SDIF_CAPBLTY1_BUS64SPT            *((volatile unsigned char*)(0x42dc0870UL))
#define bFM4_SDIF_CAPBLTY1_ASYINTSPT           *((volatile unsigned char*)(0x42dc0874UL))
#define bFM4_SDIF_CAPBLTY2_SDR50SPT            *((volatile unsigned char*)(0x42dc0880UL))
#define bFM4_SDIF_CAPBLTY2_SDR104SPT           *((volatile unsigned char*)(0x42dc0884UL))
#define bFM4_SDIF_CAPBLTY2_DDR50SPT            *((volatile unsigned char*)(0x42dc0888UL))
#define bFM4_SDIF_CAPBLTY2_DRVTPASPT           *((volatile unsigned char*)(0x42dc0890UL))
#define bFM4_SDIF_CAPBLTY2_DRVTPBSPT           *((volatile unsigned char*)(0x42dc0894UL))
#define bFM4_SDIF_CAPBLTY2_DRVTPCSPT           *((volatile unsigned char*)(0x42dc0898UL))
#define bFM4_SDIF_CAPBLTY2_USETNSDR50          *((volatile unsigned char*)(0x42dc08b4UL))
#define bFM4_SDIF_FEACEST_FEVNT12ND            *((volatile unsigned char*)(0x42dc0a00UL))
#define bFM4_SDIF_FEACEST_FEVNTTO              *((volatile unsigned char*)(0x42dc0a04UL))
#define bFM4_SDIF_FEACEST_FEVNTCRC             *((volatile unsigned char*)(0x42dc0a08UL))
#define bFM4_SDIF_FEACEST_FEVNTEB              *((volatile unsigned char*)(0x42dc0a0CUL))
#define bFM4_SDIF_FEACEST_FEVNTIDX             *((volatile unsigned char*)(0x42dc0a10UL))
#define bFM4_SDIF_FEACEST_FEVNTCMD12           *((volatile unsigned char*)(0x42dc0a1CUL))
#define bFM4_SDIF_SFEEIST_FETOERR              *((volatile unsigned char*)(0x42dc0a40UL))
#define bFM4_SDIF_SFEEIST_FECRCERR             *((volatile unsigned char*)(0x42dc0a44UL))
#define bFM4_SDIF_SFEEIST_FEEBERR              *((volatile unsigned char*)(0x42dc0a48UL))
#define bFM4_SDIF_SFEEIST_FEIDXERR             *((volatile unsigned char*)(0x42dc0a4CUL))
#define bFM4_SDIF_SFEEIST_FEDTOTERR            *((volatile unsigned char*)(0x42dc0a50UL))
#define bFM4_SDIF_SFEEIST_FEDTCRCERR           *((volatile unsigned char*)(0x42dc0a54UL))
#define bFM4_SDIF_SFEEIST_FEDTEBERR            *((volatile unsigned char*)(0x42dc0a58UL))
#define bFM4_SDIF_SFEEIST_FECRLTERR            *((volatile unsigned char*)(0x42dc0a5CUL))
#define bFM4_SDIF_SFEEIST_FEA12ERR             *((volatile unsigned char*)(0x42dc0a60UL))
#define bFM4_SDIF_SFEEIST_FEADMAERR            *((volatile unsigned char*)(0x42dc0a64UL))
#define bFM4_SDIF_SFEEIST_FETUNEERR            *((volatile unsigned char*)(0x42dc0a68UL))
#define bFM4_SDIF_SFEEIST_FEACKERR             *((volatile unsigned char*)(0x42dc0a70UL))
#define bFM4_SDIF_SFEEIST_FEA19ERR             *((volatile unsigned char*)(0x42dc0a74UL))
#define bFM4_SDIF_SFEEIST_FEAHBMSERR           *((volatile unsigned char*)(0x42dc0a78UL))
#define bFM4_SDIF_ADMAEST_ADMALENME            *((volatile unsigned char*)(0x42dc0a88UL))
#define bFM4_SDIF_SPRVAL0_CGSELVAL             *((volatile unsigned char*)(0x42dc0c28UL))
#define bFM4_SDIF_SPRVAL1_CGSELVAL             *((volatile unsigned char*)(0x42dc0c68UL))
#define bFM4_SDIF_SPRVAL2_CGSELVAL             *((volatile unsigned char*)(0x42dc0ca8UL))
#define bFM4_SDIF_SPRVAL3_CGSELVAL             *((volatile unsigned char*)(0x42dc0ce8UL))
#define bFM4_SDIF_SPRVAL4_CGSELVAL             *((volatile unsigned char*)(0x42dc0d28UL))
#define bFM4_SDIF_SPRVAL5_CGSELVAL             *((volatile unsigned char*)(0x42dc0d68UL))
#define bFM4_SDIF_SPRVAL6_CGSELVAL             *((volatile unsigned char*)(0x42dc0da8UL))
#define bFM4_SDIF_SPRVAL7_CGSELVAL             *((volatile unsigned char*)(0x42dc0de8UL))
#define bFM4_SDIF_AHBCFGL_SINEN                *((volatile unsigned char*)(0x42dc200CUL))
#define bFM4_SDIF_AHBCFGL_BSLOCK               *((volatile unsigned char*)(0x42dc2010UL))
#define bFM4_SDIF_AHBCFGL_BSLOCKSEL            *((volatile unsigned char*)(0x42dc2014UL))
#define bFM4_SDIF_AHBCFGL_ENDIANSEL            *((volatile unsigned char*)(0x42dc2018UL))
#define bFM4_SDIF_SPWSWCL_ATPWRSWEN            *((volatile unsigned char*)(0x42dc2080UL))
#define bFM4_SDIF_SPWSWCL_IOREGSEL             *((volatile unsigned char*)(0x42dc2084UL))
#define bFM4_SDIF_STUNSETL_TNPHSELEN           *((volatile unsigned char*)(0x42dc2120UL))
#define bFM4_SDIF_STUNSETL_TNERRBDSEL          *((volatile unsigned char*)(0x42dc2124UL))
#define bFM4_SDIF_STUNSETL_RETNTAPSEL          *((volatile unsigned char*)(0x42dc2128UL))
#define bFM4_SDIF_STUNSETH_CMDCFCHKDS          *((volatile unsigned char*)(0x42dc2140UL))
#define bFM4_SDIF_PSWISTL_INT5MS               *((volatile unsigned char*)(0x42dc2300UL))
#define bFM4_SDIF_PSWISTL_INT1MS               *((volatile unsigned char*)(0x42dc2304UL))
#define bFM4_SDIF_PSWISTEL_INT5MSSTS           *((volatile unsigned char*)(0x42dc2380UL))
#define bFM4_SDIF_PSWISTEL_INT1MSSTS           *((volatile unsigned char*)(0x42dc2384UL))
#define bFM4_SDIF_PSWISGEL_INT5MSSGEN          *((volatile unsigned char*)(0x42dc2400UL))
#define bFM4_SDIF_PSWISGEL_INT1MSSGEN          *((volatile unsigned char*)(0x42dc2404UL))
#define bFM4_SDIF_MMCSDCL_LCKRSTESD            *((volatile unsigned char*)(0x42dc2480UL))
#define bFM4_SDIF_MMCSDCL_RSTMMC               *((volatile unsigned char*)(0x42dc2484UL))
#define bFM4_SDIF_MMCSDCL_VCCCTLMMC            *((volatile unsigned char*)(0x42dc2488UL))
#define bFM4_SDIF_MMCSDCL_VCCQCTLMMC           *((volatile unsigned char*)(0x42dc248CUL))
#define bFM4_SDIF_MMCSDCL_MMCDDRSEL            *((volatile unsigned char*)(0x42dc24a0UL))
#define bFM4_SDIF_MMCSDCL_CMDDATDLY            *((volatile unsigned char*)(0x42dc24a4UL))
#define bFM4_SDIF_MMCSDCH_BTACKENMMC           *((volatile unsigned char*)(0x42dc24c0UL))
#define bFM4_SDIF_MMCSDCH_BTABTENMMC           *((volatile unsigned char*)(0x42dc24c4UL))
#define bFM4_SDIF_MMCSDCH_BTMDENMMC            *((volatile unsigned char*)(0x42dc24c8UL))
#define bFM4_SDIF_MCWIRQC0_WTIRQEN             *((volatile unsigned char*)(0x42dc2500UL))
#define bFM4_SDIF_MCWIRQC0_WTIRQST             *((volatile unsigned char*)(0x42dc2504UL))

/* CAN FD registers */
#define bFM4_CANFD_CREL_DAY0                   *((volatile unsigned char*)(0x42E00000UL))
#define bFM4_CANFD_CREL_DAY1                   *((volatile unsigned char*)(0x42E00004UL))
#define bFM4_CANFD_CREL_DAY2                   *((volatile unsigned char*)(0x42E00008UL))
#define bFM4_CANFD_CREL_DAY3                   *((volatile unsigned char*)(0x42E0000CUL))
#define bFM4_CANFD_CREL_DAY4                   *((volatile unsigned char*)(0x42E00010UL))
#define bFM4_CANFD_CREL_DAY5                   *((volatile unsigned char*)(0x42E00014UL))
#define bFM4_CANFD_CREL_DAY6                   *((volatile unsigned char*)(0x42E00018UL))
#define bFM4_CANFD_CREL_DAY7                   *((volatile unsigned char*)(0x42E0001CUL))
#define bFM4_CANFD_CREL_MON0                   *((volatile unsigned char*)(0x42E00020UL))
#define bFM4_CANFD_CREL_MON1                   *((volatile unsigned char*)(0x42E00024UL))
#define bFM4_CANFD_CREL_MON2                   *((volatile unsigned char*)(0x42E00028UL))
#define bFM4_CANFD_CREL_MON3                   *((volatile unsigned char*)(0x42E0002CUL))
#define bFM4_CANFD_CREL_MON4                   *((volatile unsigned char*)(0x42E00030UL))
#define bFM4_CANFD_CREL_MON5                   *((volatile unsigned char*)(0x42E00034UL))
#define bFM4_CANFD_CREL_MON6                   *((volatile unsigned char*)(0x42E00038UL))
#define bFM4_CANFD_CREL_MON7                   *((volatile unsigned char*)(0x42E0003CUL))
#define bFM4_CANFD_CREL_YEAR0                  *((volatile unsigned char*)(0x42E00040UL))
#define bFM4_CANFD_CREL_YEAR1                  *((volatile unsigned char*)(0x42E00044UL))
#define bFM4_CANFD_CREL_YEAR2                  *((volatile unsigned char*)(0x42E00048UL))
#define bFM4_CANFD_CREL_YEAR3                  *((volatile unsigned char*)(0x42E0004CUL))
#define bFM4_CANFD_CREL_SUBSTEP0               *((volatile unsigned char*)(0x42E00050UL))
#define bFM4_CANFD_CREL_SUBSTEP1               *((volatile unsigned char*)(0x42E00054UL))
#define bFM4_CANFD_CREL_SUBSTEP2               *((volatile unsigned char*)(0x42E00058UL))
#define bFM4_CANFD_CREL_SUBSTEP3               *((volatile unsigned char*)(0x42E0005CUL))
#define bFM4_CANFD_CREL_STEP0                  *((volatile unsigned char*)(0x42E00060UL))
#define bFM4_CANFD_CREL_STEP1                  *((volatile unsigned char*)(0x42E00064UL))
#define bFM4_CANFD_CREL_STEP2                  *((volatile unsigned char*)(0x42E00068UL))
#define bFM4_CANFD_CREL_STEP3                  *((volatile unsigned char*)(0x42E0006CUL))
#define bFM4_CANFD_CREL_REL0                   *((volatile unsigned char*)(0x42E00070UL))
#define bFM4_CANFD_CREL_REL1                   *((volatile unsigned char*)(0x42E00074UL))
#define bFM4_CANFD_CREL_REL2                   *((volatile unsigned char*)(0x42E00078UL))
#define bFM4_CANFD_CREL_REL3                   *((volatile unsigned char*)(0x42E0007CUL))
#define bFM4_CANFD_ENDN_ETV0                   *((volatile unsigned char*)(0x42E00080UL))
#define bFM4_CANFD_ENDN_ETV1                   *((volatile unsigned char*)(0x42E00084UL))
#define bFM4_CANFD_ENDN_ETV2                   *((volatile unsigned char*)(0x42E00088UL))
#define bFM4_CANFD_ENDN_ETV3                   *((volatile unsigned char*)(0x42E0008CUL))
#define bFM4_CANFD_ENDN_ETV4                   *((volatile unsigned char*)(0x42E00090UL))
#define bFM4_CANFD_ENDN_ETV5                   *((volatile unsigned char*)(0x42E00094UL))
#define bFM4_CANFD_ENDN_ETV6                   *((volatile unsigned char*)(0x42E00098UL))
#define bFM4_CANFD_ENDN_ETV7                   *((volatile unsigned char*)(0x42E0009CUL))
#define bFM4_CANFD_ENDN_ETV8                   *((volatile unsigned char*)(0x42E000A0UL))
#define bFM4_CANFD_ENDN_ETV9                   *((volatile unsigned char*)(0x42E000A4UL))
#define bFM4_CANFD_ENDN_ETV10                  *((volatile unsigned char*)(0x42E000A8UL))
#define bFM4_CANFD_ENDN_ETV11                  *((volatile unsigned char*)(0x42E000ACUL))
#define bFM4_CANFD_ENDN_ETV12                  *((volatile unsigned char*)(0x42E000B0UL))
#define bFM4_CANFD_ENDN_ETV13                  *((volatile unsigned char*)(0x42E000B4UL))
#define bFM4_CANFD_ENDN_ETV14                  *((volatile unsigned char*)(0x42E000B8UL))
#define bFM4_CANFD_ENDN_ETV15                  *((volatile unsigned char*)(0x42E000BCUL))
#define bFM4_CANFD_ENDN_ETV16                  *((volatile unsigned char*)(0x42E000C0UL))
#define bFM4_CANFD_ENDN_ETV17                  *((volatile unsigned char*)(0x42E000C4UL))
#define bFM4_CANFD_ENDN_ETV18                  *((volatile unsigned char*)(0x42E000C8UL))
#define bFM4_CANFD_ENDN_ETV19                  *((volatile unsigned char*)(0x42E000CCUL))
#define bFM4_CANFD_ENDN_ETV20                  *((volatile unsigned char*)(0x42E000D0UL))
#define bFM4_CANFD_ENDN_ETV21                  *((volatile unsigned char*)(0x42E000D4UL))
#define bFM4_CANFD_ENDN_ETV22                  *((volatile unsigned char*)(0x42E000D8UL))
#define bFM4_CANFD_ENDN_ETV23                  *((volatile unsigned char*)(0x42E000DCUL))
#define bFM4_CANFD_ENDN_ETV24                  *((volatile unsigned char*)(0x42E000E0UL))
#define bFM4_CANFD_ENDN_ETV25                  *((volatile unsigned char*)(0x42E000E4UL))
#define bFM4_CANFD_ENDN_ETV26                  *((volatile unsigned char*)(0x42E000E8UL))
#define bFM4_CANFD_ENDN_ETV27                  *((volatile unsigned char*)(0x42E000ECUL))
#define bFM4_CANFD_ENDN_ETV28                  *((volatile unsigned char*)(0x42E000F0UL))
#define bFM4_CANFD_ENDN_ETV29                  *((volatile unsigned char*)(0x42E000F4UL))
#define bFM4_CANFD_ENDN_ETV30                  *((volatile unsigned char*)(0x42E000F8UL))
#define bFM4_CANFD_ENDN_ETV31                  *((volatile unsigned char*)(0x42E000FCUL))
#define bFM4_CANFD_FBTP_FSJW0                  *((volatile unsigned char*)(0x42E00180UL))
#define bFM4_CANFD_FBTP_FSJW1                  *((volatile unsigned char*)(0x42E00184UL))
#define bFM4_CANFD_FBTP_FTSEG20                *((volatile unsigned char*)(0x42E00190UL))
#define bFM4_CANFD_FBTP_FTSEG21                *((volatile unsigned char*)(0x42E00194UL))
#define bFM4_CANFD_FBTP_FTSEG22                *((volatile unsigned char*)(0x42E00198UL))
#define bFM4_CANFD_FBTP_FTSEG10                *((volatile unsigned char*)(0x42E001A0UL))
#define bFM4_CANFD_FBTP_FTSEG11                *((volatile unsigned char*)(0x42E001A4UL))
#define bFM4_CANFD_FBTP_FTSEG12                *((volatile unsigned char*)(0x42E001A8UL))
#define bFM4_CANFD_FBTP_FTSEG13                *((volatile unsigned char*)(0x42E001ACUL))
#define bFM4_CANFD_FBTP_FBRP0                  *((volatile unsigned char*)(0x42E001C0UL))
#define bFM4_CANFD_FBTP_FBRP1                  *((volatile unsigned char*)(0x42E001C4UL))
#define bFM4_CANFD_FBTP_FBRP2                  *((volatile unsigned char*)(0x42E001C8UL))
#define bFM4_CANFD_FBTP_FBRP3                  *((volatile unsigned char*)(0x42E001CCUL))
#define bFM4_CANFD_FBTP_FBRP4                  *((volatile unsigned char*)(0x42E001D0UL))
#define bFM4_CANFD_FBTP_TDC                    *((volatile unsigned char*)(0x42E001DCUL))
#define bFM4_CANFD_FBTP_TDCO0                  *((volatile unsigned char*)(0x42E001E0UL))
#define bFM4_CANFD_FBTP_TDCO1                  *((volatile unsigned char*)(0x42E001E4UL))
#define bFM4_CANFD_FBTP_TDCO2                  *((volatile unsigned char*)(0x42E001E8UL))
#define bFM4_CANFD_FBTP_TDCO3                  *((volatile unsigned char*)(0x42E001ECUL))
#define bFM4_CANFD_FBTP_TDCO4                  *((volatile unsigned char*)(0x42E001F0UL))
#define bFM4_CANFD_TEST_LBCK                   *((volatile unsigned char*)(0x42E00210UL))
#define bFM4_CANFD_TEST_TX0                    *((volatile unsigned char*)(0x42E00214UL))
#define bFM4_CANFD_TEST_TX1                    *((volatile unsigned char*)(0x42E00218UL))
#define bFM4_CANFD_TEST_RX                     *((volatile unsigned char*)(0x42E0021CUL))
#define bFM4_CANFD_TEST_TDCV0                  *((volatile unsigned char*)(0x42E00220UL))
#define bFM4_CANFD_TEST_TDCV1                  *((volatile unsigned char*)(0x42E00224UL))
#define bFM4_CANFD_TEST_TDCV2                  *((volatile unsigned char*)(0x42E00228UL))
#define bFM4_CANFD_TEST_TDCV3                  *((volatile unsigned char*)(0x42E0022CUL))
#define bFM4_CANFD_TEST_TDCV4                  *((volatile unsigned char*)(0x42E00230UL))
#define bFM4_CANFD_TEST_TDCV5                  *((volatile unsigned char*)(0x42E00234UL))
#define bFM4_CANFD_RWD_WDC0                    *((volatile unsigned char*)(0x42E00280UL))
#define bFM4_CANFD_RWD_WDC1                    *((volatile unsigned char*)(0x42E00284UL))
#define bFM4_CANFD_RWD_WDC2                    *((volatile unsigned char*)(0x42E00288UL))
#define bFM4_CANFD_RWD_WDC3                    *((volatile unsigned char*)(0x42E0028CUL))
#define bFM4_CANFD_RWD_WDC4                    *((volatile unsigned char*)(0x42E00290UL))
#define bFM4_CANFD_RWD_WDC5                    *((volatile unsigned char*)(0x42E00294UL))
#define bFM4_CANFD_RWD_WDC6                    *((volatile unsigned char*)(0x42E00298UL))
#define bFM4_CANFD_RWD_WDC7                    *((volatile unsigned char*)(0x42E0029CUL))
#define bFM4_CANFD_RWD_WDV0                    *((volatile unsigned char*)(0x42E002A0UL))
#define bFM4_CANFD_RWD_WDV1                    *((volatile unsigned char*)(0x42E002A4UL))
#define bFM4_CANFD_RWD_WDV2                    *((volatile unsigned char*)(0x42E002A8UL))
#define bFM4_CANFD_RWD_WDV3                    *((volatile unsigned char*)(0x42E002ACUL))
#define bFM4_CANFD_RWD_WDV4                    *((volatile unsigned char*)(0x42E002B0UL))
#define bFM4_CANFD_RWD_WDV5                    *((volatile unsigned char*)(0x42E002B4UL))
#define bFM4_CANFD_RWD_WDV6                    *((volatile unsigned char*)(0x42E002B8UL))
#define bFM4_CANFD_RWD_WDV7                    *((volatile unsigned char*)(0x42E002BCUL))
#define bFM4_CANFD_CCCR_INIT                   *((volatile unsigned char*)(0x42E00300UL))
#define bFM4_CANFD_CCCR_CCE                    *((volatile unsigned char*)(0x42E00304UL))
#define bFM4_CANFD_CCCR_ASM                    *((volatile unsigned char*)(0x42E00308UL))
#define bFM4_CANFD_CCCR_CSA                    *((volatile unsigned char*)(0x42E0030CUL))
#define bFM4_CANFD_CCCR_CSR                    *((volatile unsigned char*)(0x42E00310UL))
#define bFM4_CANFD_CCCR_MON                    *((volatile unsigned char*)(0x42E00314UL))
#define bFM4_CANFD_CCCR_DAR                    *((volatile unsigned char*)(0x42E00318UL))
#define bFM4_CANFD_CCCR_TEST                   *((volatile unsigned char*)(0x42E0031CUL))
#define bFM4_CANFD_CCCR_CME0                   *((volatile unsigned char*)(0x42E00320UL))
#define bFM4_CANFD_CCCR_CME1                   *((volatile unsigned char*)(0x42E00324UL))
#define bFM4_CANFD_CCCR_CMR0                   *((volatile unsigned char*)(0x42E00328UL))
#define bFM4_CANFD_CCCR_CMR1                   *((volatile unsigned char*)(0x42E0032CUL))
#define bFM4_CANFD_CCCR_FDO                    *((volatile unsigned char*)(0x42E00330UL))
#define bFM4_CANFD_CCCR_FDBS                   *((volatile unsigned char*)(0x42E00334UL))
#define bFM4_CANFD_CCCR_TXP                    *((volatile unsigned char*)(0x42E00338UL))
#define bFM4_CANFD_BTP_SJW0                    *((volatile unsigned char*)(0x42E00380UL))
#define bFM4_CANFD_BTP_SJW1                    *((volatile unsigned char*)(0x42E00384UL))
#define bFM4_CANFD_BTP_SJW2                    *((volatile unsigned char*)(0x42E00388UL))
#define bFM4_CANFD_BTP_SJW3                    *((volatile unsigned char*)(0x42E0038CUL))
#define bFM4_CANFD_BTP_TSEG20                  *((volatile unsigned char*)(0x42E00390UL))
#define bFM4_CANFD_BTP_TSEG21                  *((volatile unsigned char*)(0x42E00394UL))
#define bFM4_CANFD_BTP_TSEG22                  *((volatile unsigned char*)(0x42E00398UL))
#define bFM4_CANFD_BTP_TSEG23                  *((volatile unsigned char*)(0x42E0039CUL))
#define bFM4_CANFD_BTP_TSEG10                  *((volatile unsigned char*)(0x42E003A0UL))
#define bFM4_CANFD_BTP_TSEG11                  *((volatile unsigned char*)(0x42E003A4UL))
#define bFM4_CANFD_BTP_TSEG12                  *((volatile unsigned char*)(0x42E003A8UL))
#define bFM4_CANFD_BTP_TSEG13                  *((volatile unsigned char*)(0x42E003ACUL))
#define bFM4_CANFD_BTP_TSEG14                  *((volatile unsigned char*)(0x42E003B0UL))
#define bFM4_CANFD_BTP_TSEG15                  *((volatile unsigned char*)(0x42E003B4UL))
#define bFM4_CANFD_BTP_BRP0                    *((volatile unsigned char*)(0x42E003C0UL))
#define bFM4_CANFD_BTP_BRP1                    *((volatile unsigned char*)(0x42E003C4UL))
#define bFM4_CANFD_BTP_BRP2                    *((volatile unsigned char*)(0x42E003C8UL))
#define bFM4_CANFD_BTP_BRP3                    *((volatile unsigned char*)(0x42E003CCUL))
#define bFM4_CANFD_BTP_BRP4                    *((volatile unsigned char*)(0x42E003D0UL))
#define bFM4_CANFD_BTP_BRP5                    *((volatile unsigned char*)(0x42E003D4UL))
#define bFM4_CANFD_BTP_BRP6                    *((volatile unsigned char*)(0x42E003D8UL))
#define bFM4_CANFD_BTP_BRP7                    *((volatile unsigned char*)(0x42E003DCUL))
#define bFM4_CANFD_BTP_BRP8                    *((volatile unsigned char*)(0x42E003E0UL))
#define bFM4_CANFD_BTP_BRP9                    *((volatile unsigned char*)(0x42E003E4UL))
#define bFM4_CANFD_TSCC_TSS0                   *((volatile unsigned char*)(0x42E00400UL))
#define bFM4_CANFD_TSCC_TSS1                   *((volatile unsigned char*)(0x42E00404UL))
#define bFM4_CANFD_TSCC_TCP0                   *((volatile unsigned char*)(0x42E00440UL))
#define bFM4_CANFD_TSCC_TCP1                   *((volatile unsigned char*)(0x42E00444UL))
#define bFM4_CANFD_TSCC_TCP2                   *((volatile unsigned char*)(0x42E00448UL))
#define bFM4_CANFD_TSCC_TCP3                   *((volatile unsigned char*)(0x42E0044CUL))
#define bFM4_CANFD_TSCV_TSC0                   *((volatile unsigned char*)(0x42E00480UL))
#define bFM4_CANFD_TSCV_TSC1                   *((volatile unsigned char*)(0x42E00484UL))
#define bFM4_CANFD_TSCV_TSC2                   *((volatile unsigned char*)(0x42E00488UL))
#define bFM4_CANFD_TSCV_TSC3                   *((volatile unsigned char*)(0x42E0048CUL))
#define bFM4_CANFD_TSCV_TSC4                   *((volatile unsigned char*)(0x42E00490UL))
#define bFM4_CANFD_TSCV_TSC5                   *((volatile unsigned char*)(0x42E00494UL))
#define bFM4_CANFD_TSCV_TSC6                   *((volatile unsigned char*)(0x42E00498UL))
#define bFM4_CANFD_TSCV_TSC7                   *((volatile unsigned char*)(0x42E0049CUL))
#define bFM4_CANFD_TSCV_TSC8                   *((volatile unsigned char*)(0x42E004A0UL))
#define bFM4_CANFD_TSCV_TSC9                   *((volatile unsigned char*)(0x42E004A4UL))
#define bFM4_CANFD_TSCV_TSC10                  *((volatile unsigned char*)(0x42E004A8UL))
#define bFM4_CANFD_TSCV_TSC11                  *((volatile unsigned char*)(0x42E004ACUL))
#define bFM4_CANFD_TSCV_TSC12                  *((volatile unsigned char*)(0x42E004B0UL))
#define bFM4_CANFD_TSCV_TSC13                  *((volatile unsigned char*)(0x42E004B4UL))
#define bFM4_CANFD_TSCV_TSC14                  *((volatile unsigned char*)(0x42E004B8UL))
#define bFM4_CANFD_TSCV_TSC15                  *((volatile unsigned char*)(0x42E004BCUL))
#define bFM4_CANFD_TOCC_ETOC                   *((volatile unsigned char*)(0x42E00500UL))
#define bFM4_CANFD_TOCC_TOS0                   *((volatile unsigned char*)(0x42E00504UL))
#define bFM4_CANFD_TOCC_TOS1                   *((volatile unsigned char*)(0x42E00508UL))
#define bFM4_CANFD_TOCC_TOP0                   *((volatile unsigned char*)(0x42E00540UL))
#define bFM4_CANFD_TOCC_TOP1                   *((volatile unsigned char*)(0x42E00544UL))
#define bFM4_CANFD_TOCC_TOP2                   *((volatile unsigned char*)(0x42E00548UL))
#define bFM4_CANFD_TOCC_TOP3                   *((volatile unsigned char*)(0x42E0054CUL))
#define bFM4_CANFD_TOCC_TOP4                   *((volatile unsigned char*)(0x42E00550UL))
#define bFM4_CANFD_TOCC_TOP5                   *((volatile unsigned char*)(0x42E00554UL))
#define bFM4_CANFD_TOCC_TOP6                   *((volatile unsigned char*)(0x42E00558UL))
#define bFM4_CANFD_TOCC_TOP7                   *((volatile unsigned char*)(0x42E0055CUL))
#define bFM4_CANFD_TOCC_TOP8                   *((volatile unsigned char*)(0x42E00560UL))
#define bFM4_CANFD_TOCC_TOP9                   *((volatile unsigned char*)(0x42E00564UL))
#define bFM4_CANFD_TOCC_TOP10                  *((volatile unsigned char*)(0x42E00568UL))
#define bFM4_CANFD_TOCC_TOP11                  *((volatile unsigned char*)(0x42E0056CUL))
#define bFM4_CANFD_TOCC_TOP12                  *((volatile unsigned char*)(0x42E00570UL))
#define bFM4_CANFD_TOCC_TOP13                  *((volatile unsigned char*)(0x42E00574UL))
#define bFM4_CANFD_TOCC_TOP14                  *((volatile unsigned char*)(0x42E00578UL))
#define bFM4_CANFD_TOCC_TOP15                  *((volatile unsigned char*)(0x42E0057CUL))
#define bFM4_CANFD_TOCV_TOC0                   *((volatile unsigned char*)(0x42E00580UL))
#define bFM4_CANFD_TOCV_TOC1                   *((volatile unsigned char*)(0x42E00584UL))
#define bFM4_CANFD_TOCV_TOC2                   *((volatile unsigned char*)(0x42E00588UL))
#define bFM4_CANFD_TOCV_TOC3                   *((volatile unsigned char*)(0x42E0058CUL))
#define bFM4_CANFD_TOCV_TOC4                   *((volatile unsigned char*)(0x42E00590UL))
#define bFM4_CANFD_TOCV_TOC5                   *((volatile unsigned char*)(0x42E00594UL))
#define bFM4_CANFD_TOCV_TOC6                   *((volatile unsigned char*)(0x42E00598UL))
#define bFM4_CANFD_TOCV_TOC7                   *((volatile unsigned char*)(0x42E0059CUL))
#define bFM4_CANFD_TOCV_TOC8                   *((volatile unsigned char*)(0x42E005A0UL))
#define bFM4_CANFD_TOCV_TOC9                   *((volatile unsigned char*)(0x42E005A4UL))
#define bFM4_CANFD_TOCV_TOC10                  *((volatile unsigned char*)(0x42E005A8UL))
#define bFM4_CANFD_TOCV_TOC11                  *((volatile unsigned char*)(0x42E005ACUL))
#define bFM4_CANFD_TOCV_TOC12                  *((volatile unsigned char*)(0x42E005B0UL))
#define bFM4_CANFD_TOCV_TOC13                  *((volatile unsigned char*)(0x42E005B4UL))
#define bFM4_CANFD_TOCV_TOC14                  *((volatile unsigned char*)(0x42E005B8UL))
#define bFM4_CANFD_TOCV_TOC15                  *((volatile unsigned char*)(0x42E005BCUL))
#define bFM4_CANFD_ECR_TEC0                    *((volatile unsigned char*)(0x42E00800UL))
#define bFM4_CANFD_ECR_TEC1                    *((volatile unsigned char*)(0x42E00804UL))
#define bFM4_CANFD_ECR_TEC2                    *((volatile unsigned char*)(0x42E00808UL))
#define bFM4_CANFD_ECR_TEC3                    *((volatile unsigned char*)(0x42E0080CUL))
#define bFM4_CANFD_ECR_TEC4                    *((volatile unsigned char*)(0x42E00810UL))
#define bFM4_CANFD_ECR_TEC5                    *((volatile unsigned char*)(0x42E00814UL))
#define bFM4_CANFD_ECR_TEC6                    *((volatile unsigned char*)(0x42E00818UL))
#define bFM4_CANFD_ECR_TEC7                    *((volatile unsigned char*)(0x42E0081CUL))
#define bFM4_CANFD_ECR_REC0                    *((volatile unsigned char*)(0x42E00820UL))
#define bFM4_CANFD_ECR_REC1                    *((volatile unsigned char*)(0x42E00824UL))
#define bFM4_CANFD_ECR_REC2                    *((volatile unsigned char*)(0x42E00828UL))
#define bFM4_CANFD_ECR_REC3                    *((volatile unsigned char*)(0x42E0082CUL))
#define bFM4_CANFD_ECR_REC4                    *((volatile unsigned char*)(0x42E00830UL))
#define bFM4_CANFD_ECR_REC5                    *((volatile unsigned char*)(0x42E00834UL))
#define bFM4_CANFD_ECR_REC6                    *((volatile unsigned char*)(0x42E00838UL))
#define bFM4_CANFD_ECR_RP                      *((volatile unsigned char*)(0x42E0083CUL))
#define bFM4_CANFD_ECR_CEL0                    *((volatile unsigned char*)(0x42E00840UL))
#define bFM4_CANFD_ECR_CEL1                    *((volatile unsigned char*)(0x42E00844UL))
#define bFM4_CANFD_ECR_CEL2                    *((volatile unsigned char*)(0x42E00848UL))
#define bFM4_CANFD_ECR_CEL3                    *((volatile unsigned char*)(0x42E0084CUL))
#define bFM4_CANFD_ECR_CEL4                    *((volatile unsigned char*)(0x42E00850UL))
#define bFM4_CANFD_ECR_CEL5                    *((volatile unsigned char*)(0x42E00854UL))
#define bFM4_CANFD_ECR_CEL6                    *((volatile unsigned char*)(0x42E00858UL))
#define bFM4_CANFD_ECR_CEL7                    *((volatile unsigned char*)(0x42E0085CUL))
#define bFM4_CANFD_PSR_LEC0                    *((volatile unsigned char*)(0x42E00880UL))
#define bFM4_CANFD_PSR_LEC1                    *((volatile unsigned char*)(0x42E00884UL))
#define bFM4_CANFD_PSR_LEC2                    *((volatile unsigned char*)(0x42E00888UL))
#define bFM4_CANFD_PSR_ACT0                    *((volatile unsigned char*)(0x42E0088CUL))
#define bFM4_CANFD_PSR_ACT1                    *((volatile unsigned char*)(0x42E00890UL))
#define bFM4_CANFD_PSR_EP                      *((volatile unsigned char*)(0x42E00894UL))
#define bFM4_CANFD_PSR_EW                      *((volatile unsigned char*)(0x42E00898UL))
#define bFM4_CANFD_PSR_BO                      *((volatile unsigned char*)(0x42E0089CUL))
#define bFM4_CANFD_PSR_FLEC0                   *((volatile unsigned char*)(0x42E008A0UL))
#define bFM4_CANFD_PSR_FLEC1                   *((volatile unsigned char*)(0x42E008A4UL))
#define bFM4_CANFD_PSR_FLEC2                   *((volatile unsigned char*)(0x42E008A8UL))
#define bFM4_CANFD_PSR_RESI                    *((volatile unsigned char*)(0x42E008ACUL))
#define bFM4_CANFD_PSR_RBRS                    *((volatile unsigned char*)(0x42E008B0UL))
#define bFM4_CANFD_PSR_REDL                    *((volatile unsigned char*)(0x42E008B4UL))
#define bFM4_CANFD_IR_RF0N                     *((volatile unsigned char*)(0x42E00A00UL))
#define bFM4_CANFD_IR_RF0W                     *((volatile unsigned char*)(0x42E00A04UL))
#define bFM4_CANFD_IR_RF0F                     *((volatile unsigned char*)(0x42E00A08UL))
#define bFM4_CANFD_IR_RF0L                     *((volatile unsigned char*)(0x42E00A0CUL))
#define bFM4_CANFD_IR_RF1N                     *((volatile unsigned char*)(0x42E00A10UL))
#define bFM4_CANFD_IR_RF1W                     *((volatile unsigned char*)(0x42E00A14UL))
#define bFM4_CANFD_IR_RF1F                     *((volatile unsigned char*)(0x42E00A18UL))
#define bFM4_CANFD_IR_RF1L                     *((volatile unsigned char*)(0x42E00A1CUL))
#define bFM4_CANFD_IR_HPM                      *((volatile unsigned char*)(0x42E00A20UL))
#define bFM4_CANFD_IR_TC                       *((volatile unsigned char*)(0x42E00A24UL))
#define bFM4_CANFD_IR_TCF                      *((volatile unsigned char*)(0x42E00A28UL))
#define bFM4_CANFD_IR_TFE                      *((volatile unsigned char*)(0x42E00A2CUL))
#define bFM4_CANFD_IR_TEFN                     *((volatile unsigned char*)(0x42E00A30UL))
#define bFM4_CANFD_IR_TEFW                     *((volatile unsigned char*)(0x42E00A34UL))
#define bFM4_CANFD_IR_TEFF                     *((volatile unsigned char*)(0x42E00A38UL))
#define bFM4_CANFD_IR_TEFL                     *((volatile unsigned char*)(0x42E00A3CUL))
#define bFM4_CANFD_IR_TSW                      *((volatile unsigned char*)(0x42E00A40UL))
#define bFM4_CANFD_IR_MRAF                     *((volatile unsigned char*)(0x42E00A44UL))
#define bFM4_CANFD_IR_TOO                      *((volatile unsigned char*)(0x42E00A48UL))
#define bFM4_CANFD_IR_DRX                      *((volatile unsigned char*)(0x42E00A4CUL))
#define bFM4_CANFD_IR_BEC                      *((volatile unsigned char*)(0x42E00A50UL))
#define bFM4_CANFD_IR_BEU                      *((volatile unsigned char*)(0x42E00A54UL))
#define bFM4_CANFD_IR_ELO                      *((volatile unsigned char*)(0x42E00A58UL))
#define bFM4_CANFD_IR_EP                       *((volatile unsigned char*)(0x42E00A5CUL))
#define bFM4_CANFD_IR_EW                       *((volatile unsigned char*)(0x42E00A60UL))
#define bFM4_CANFD_IR_BO                       *((volatile unsigned char*)(0x42E00A64UL))
#define bFM4_CANFD_IR_WDI                      *((volatile unsigned char*)(0x42E00A68UL))
#define bFM4_CANFD_IR_CRCE                     *((volatile unsigned char*)(0x42E00A6CUL))
#define bFM4_CANFD_IR_BE                       *((volatile unsigned char*)(0x42E00A70UL))
#define bFM4_CANFD_IR_ACKE                     *((volatile unsigned char*)(0x42E00A74UL))
#define bFM4_CANFD_IR_FOE                      *((volatile unsigned char*)(0x42E00A78UL))
#define bFM4_CANFD_IR_STE                      *((volatile unsigned char*)(0x42E00A7CUL))
#define bFM4_CANFD_IE_RF0NE                    *((volatile unsigned char*)(0x42E00A80UL))
#define bFM4_CANFD_IE_RF0WE                    *((volatile unsigned char*)(0x42E00A84UL))
#define bFM4_CANFD_IE_RF0FE                    *((volatile unsigned char*)(0x42E00A88UL))
#define bFM4_CANFD_IE_RF0LE                    *((volatile unsigned char*)(0x42E00A8CUL))
#define bFM4_CANFD_IE_RF1NE                    *((volatile unsigned char*)(0x42E00A90UL))
#define bFM4_CANFD_IE_RF1WE                    *((volatile unsigned char*)(0x42E00A94UL))
#define bFM4_CANFD_IE_RF1FE                    *((volatile unsigned char*)(0x42E00A98UL))
#define bFM4_CANFD_IE_RF1LE                    *((volatile unsigned char*)(0x42E00A9CUL))
#define bFM4_CANFD_IE_HPME                     *((volatile unsigned char*)(0x42E00AA0UL))
#define bFM4_CANFD_IE_TCE                      *((volatile unsigned char*)(0x42E00AA4UL))
#define bFM4_CANFD_IE_TCFE                     *((volatile unsigned char*)(0x42E00AA8UL))
#define bFM4_CANFD_IE_TFEE                     *((volatile unsigned char*)(0x42E00AACUL))
#define bFM4_CANFD_IE_TEFNE                    *((volatile unsigned char*)(0x42E00AB0UL))
#define bFM4_CANFD_IE_TEFWE                    *((volatile unsigned char*)(0x42E00AB4UL))
#define bFM4_CANFD_IE_TEFFE                    *((volatile unsigned char*)(0x42E00AB8UL))
#define bFM4_CANFD_IE_TEFLE                    *((volatile unsigned char*)(0x42E00ABCUL))
#define bFM4_CANFD_IE_TSWE                     *((volatile unsigned char*)(0x42E00AC0UL))
#define bFM4_CANFD_IE_MRAFE                    *((volatile unsigned char*)(0x42E00AC4UL))
#define bFM4_CANFD_IE_TOOE                     *((volatile unsigned char*)(0x42E00AC8UL))
#define bFM4_CANFD_IE_DRXE                     *((volatile unsigned char*)(0x42E00ACCUL))
#define bFM4_CANFD_IE_BECE                     *((volatile unsigned char*)(0x42E00AD0UL))
#define bFM4_CANFD_IE_BEUE                     *((volatile unsigned char*)(0x42E00AD4UL))
#define bFM4_CANFD_IE_ELOE                     *((volatile unsigned char*)(0x42E00AD8UL))
#define bFM4_CANFD_IE_EPE                      *((volatile unsigned char*)(0x42E00ADCUL))
#define bFM4_CANFD_IE_EWE                      *((volatile unsigned char*)(0x42E00AE0UL))
#define bFM4_CANFD_IE_BOE                      *((volatile unsigned char*)(0x42E00AE4UL))
#define bFM4_CANFD_IE_WDIE                     *((volatile unsigned char*)(0x42E00AE8UL))
#define bFM4_CANFD_IE_CRCEE                    *((volatile unsigned char*)(0x42E00AECUL))
#define bFM4_CANFD_IE_BEE                      *((volatile unsigned char*)(0x42E00AF0UL))
#define bFM4_CANFD_IE_ACKEE                    *((volatile unsigned char*)(0x42E00AF4UL))
#define bFM4_CANFD_IE_FOEE                     *((volatile unsigned char*)(0x42E00AF8UL))
#define bFM4_CANFD_IE_STEE                     *((volatile unsigned char*)(0x42E00AFCUL))
#define bFM4_CANFD_ILS_RF0NL                   *((volatile unsigned char*)(0x42E00B00UL))
#define bFM4_CANFD_ILS_RF0WL                   *((volatile unsigned char*)(0x42E00B04UL))
#define bFM4_CANFD_ILS_RF0FL                   *((volatile unsigned char*)(0x42E00B08UL))
#define bFM4_CANFD_ILS_RF0LL                   *((volatile unsigned char*)(0x42E00B0CUL))
#define bFM4_CANFD_ILS_RF1NL                   *((volatile unsigned char*)(0x42E00B10UL))
#define bFM4_CANFD_ILS_RF1WL                   *((volatile unsigned char*)(0x42E00B14UL))
#define bFM4_CANFD_ILS_RF1FL                   *((volatile unsigned char*)(0x42E00B18UL))
#define bFM4_CANFD_ILS_RF1LL                   *((volatile unsigned char*)(0x42E00B1CUL))
#define bFM4_CANFD_ILS_HPML                    *((volatile unsigned char*)(0x42E00B20UL))
#define bFM4_CANFD_ILS_TCL                     *((volatile unsigned char*)(0x42E00B24UL))
#define bFM4_CANFD_ILS_TCFL                    *((volatile unsigned char*)(0x42E00B28UL))
#define bFM4_CANFD_ILS_TFEL                    *((volatile unsigned char*)(0x42E00B2CUL))
#define bFM4_CANFD_ILS_TEFNL                   *((volatile unsigned char*)(0x42E00B30UL))
#define bFM4_CANFD_ILS_TEFWL                   *((volatile unsigned char*)(0x42E00B34UL))
#define bFM4_CANFD_ILS_TEFFL                   *((volatile unsigned char*)(0x42E00B38UL))
#define bFM4_CANFD_ILS_TEFLL                   *((volatile unsigned char*)(0x42E00B3CUL))
#define bFM4_CANFD_ILS_TSWL                    *((volatile unsigned char*)(0x42E00B40UL))
#define bFM4_CANFD_ILS_MRAFL                   *((volatile unsigned char*)(0x42E00B44UL))
#define bFM4_CANFD_ILS_TOOL                    *((volatile unsigned char*)(0x42E00B48UL))
#define bFM4_CANFD_ILS_DRXL                    *((volatile unsigned char*)(0x42E00B4CUL))
#define bFM4_CANFD_ILS_BECL                    *((volatile unsigned char*)(0x42E00B50UL))
#define bFM4_CANFD_ILS_BEUL                    *((volatile unsigned char*)(0x42E00B54UL))
#define bFM4_CANFD_ILS_ELOL                    *((volatile unsigned char*)(0x42E00B58UL))
#define bFM4_CANFD_ILS_EPL                     *((volatile unsigned char*)(0x42E00B5CUL))
#define bFM4_CANFD_ILS_EWL                     *((volatile unsigned char*)(0x42E00B60UL))
#define bFM4_CANFD_ILS_BOL                     *((volatile unsigned char*)(0x42E00B64UL))
#define bFM4_CANFD_ILS_WDIL                    *((volatile unsigned char*)(0x42E00B68UL))
#define bFM4_CANFD_ILS_CRCEL                   *((volatile unsigned char*)(0x42E00B6CUL))
#define bFM4_CANFD_ILS_BEL                     *((volatile unsigned char*)(0x42E00B70UL))
#define bFM4_CANFD_ILS_ACKEL                   *((volatile unsigned char*)(0x42E00B74UL))
#define bFM4_CANFD_ILS_FOEL                    *((volatile unsigned char*)(0x42E00B78UL))
#define bFM4_CANFD_ILS_STEL                    *((volatile unsigned char*)(0x42E00B7CUL))
#define bFM4_CANFD_ILE_EINT0                   *((volatile unsigned char*)(0x42E00B80UL))
#define bFM4_CANFD_ILE_EINT1                   *((volatile unsigned char*)(0x42E00B84UL))
#define bFM4_CANFD_GFC_RRFE                    *((volatile unsigned char*)(0x42E01000UL))
#define bFM4_CANFD_GFC_RRFS                    *((volatile unsigned char*)(0x42E01004UL))
#define bFM4_CANFD_GFC_ANFE0                   *((volatile unsigned char*)(0x42E01008UL))
#define bFM4_CANFD_GFC_ANFE1                   *((volatile unsigned char*)(0x42E0100CUL))
#define bFM4_CANFD_GFC_ANFS0                   *((volatile unsigned char*)(0x42E01010UL))
#define bFM4_CANFD_GFC_ANFS1                   *((volatile unsigned char*)(0x42E01014UL))
#define bFM4_CANFD_SIDFC_FLSSA0                *((volatile unsigned char*)(0x42E01088UL))
#define bFM4_CANFD_SIDFC_FLSSA1                *((volatile unsigned char*)(0x42E0108CUL))
#define bFM4_CANFD_SIDFC_FLSSA2                *((volatile unsigned char*)(0x42E01090UL))
#define bFM4_CANFD_SIDFC_FLSSA3                *((volatile unsigned char*)(0x42E01094UL))
#define bFM4_CANFD_SIDFC_FLSSA4                *((volatile unsigned char*)(0x42E01098UL))
#define bFM4_CANFD_SIDFC_FLSSA5                *((volatile unsigned char*)(0x42E0109CUL))
#define bFM4_CANFD_SIDFC_FLSSA6                *((volatile unsigned char*)(0x42E010A0UL))
#define bFM4_CANFD_SIDFC_FLSSA7                *((volatile unsigned char*)(0x42E010A4UL))
#define bFM4_CANFD_SIDFC_FLSSA8                *((volatile unsigned char*)(0x42E010A8UL))
#define bFM4_CANFD_SIDFC_FLSSA9                *((volatile unsigned char*)(0x42E010ACUL))
#define bFM4_CANFD_SIDFC_FLSSA10               *((volatile unsigned char*)(0x42E010B0UL))
#define bFM4_CANFD_SIDFC_FLSSA11               *((volatile unsigned char*)(0x42E010B4UL))
#define bFM4_CANFD_SIDFC_FLSSA12               *((volatile unsigned char*)(0x42E010B8UL))
#define bFM4_CANFD_SIDFC_FLSSA13               *((volatile unsigned char*)(0x42E010BCUL))
#define bFM4_CANFD_SIDFC_LSS0                  *((volatile unsigned char*)(0x42E010C0UL))
#define bFM4_CANFD_SIDFC_LSS1                  *((volatile unsigned char*)(0x42E010C4UL))
#define bFM4_CANFD_SIDFC_LSS2                  *((volatile unsigned char*)(0x42E010C8UL))
#define bFM4_CANFD_SIDFC_LSS3                  *((volatile unsigned char*)(0x42E010CCUL))
#define bFM4_CANFD_SIDFC_LSS4                  *((volatile unsigned char*)(0x42E010D0UL))
#define bFM4_CANFD_SIDFC_LSS5                  *((volatile unsigned char*)(0x42E010D4UL))
#define bFM4_CANFD_SIDFC_LSS6                  *((volatile unsigned char*)(0x42E010D8UL))
#define bFM4_CANFD_SIDFC_LSS7                  *((volatile unsigned char*)(0x42E010DCUL))
#define bFM4_CANFD_XIDFC_FLESA0                *((volatile unsigned char*)(0x42E01108UL))
#define bFM4_CANFD_XIDFC_FLESA1                *((volatile unsigned char*)(0x42E0110CUL))
#define bFM4_CANFD_XIDFC_FLESA2                *((volatile unsigned char*)(0x42E01110UL))
#define bFM4_CANFD_XIDFC_FLESA3                *((volatile unsigned char*)(0x42E01114UL))
#define bFM4_CANFD_XIDFC_FLESA4                *((volatile unsigned char*)(0x42E01118UL))
#define bFM4_CANFD_XIDFC_FLESA5                *((volatile unsigned char*)(0x42E0111CUL))
#define bFM4_CANFD_XIDFC_FLESA6                *((volatile unsigned char*)(0x42E01120UL))
#define bFM4_CANFD_XIDFC_FLESA7                *((volatile unsigned char*)(0x42E01124UL))
#define bFM4_CANFD_XIDFC_FLESA8                *((volatile unsigned char*)(0x42E01128UL))
#define bFM4_CANFD_XIDFC_FLESA9                *((volatile unsigned char*)(0x42E0112CUL))
#define bFM4_CANFD_XIDFC_FLESA10               *((volatile unsigned char*)(0x42E01130UL))
#define bFM4_CANFD_XIDFC_FLESA11               *((volatile unsigned char*)(0x42E01134UL))
#define bFM4_CANFD_XIDFC_FLESA12               *((volatile unsigned char*)(0x42E01138UL))
#define bFM4_CANFD_XIDFC_FLESA13               *((volatile unsigned char*)(0x42E0113CUL))
#define bFM4_CANFD_XIDFC_LSE0                  *((volatile unsigned char*)(0x42E01140UL))
#define bFM4_CANFD_XIDFC_LSE1                  *((volatile unsigned char*)(0x42E01144UL))
#define bFM4_CANFD_XIDFC_LSE2                  *((volatile unsigned char*)(0x42E01148UL))
#define bFM4_CANFD_XIDFC_LSE3                  *((volatile unsigned char*)(0x42E0114CUL))
#define bFM4_CANFD_XIDFC_LSE4                  *((volatile unsigned char*)(0x42E01150UL))
#define bFM4_CANFD_XIDFC_LSE5                  *((volatile unsigned char*)(0x42E01154UL))
#define bFM4_CANFD_XIDFC_LSE6                  *((volatile unsigned char*)(0x42E01158UL))
#define bFM4_CANFD_XIDAM_EIDM0                 *((volatile unsigned char*)(0x42E01200UL))
#define bFM4_CANFD_XIDAM_EIDM1                 *((volatile unsigned char*)(0x42E01204UL))
#define bFM4_CANFD_XIDAM_EIDM2                 *((volatile unsigned char*)(0x42E01208UL))
#define bFM4_CANFD_XIDAM_EIDM3                 *((volatile unsigned char*)(0x42E0120CUL))
#define bFM4_CANFD_XIDAM_EIDM4                 *((volatile unsigned char*)(0x42E01210UL))
#define bFM4_CANFD_XIDAM_EIDM5                 *((volatile unsigned char*)(0x42E01214UL))
#define bFM4_CANFD_XIDAM_EIDM6                 *((volatile unsigned char*)(0x42E01218UL))
#define bFM4_CANFD_XIDAM_EIDM7                 *((volatile unsigned char*)(0x42E0121CUL))
#define bFM4_CANFD_XIDAM_EIDM8                 *((volatile unsigned char*)(0x42E01220UL))
#define bFM4_CANFD_XIDAM_EIDM9                 *((volatile unsigned char*)(0x42E01224UL))
#define bFM4_CANFD_XIDAM_EIDM10                *((volatile unsigned char*)(0x42E01228UL))
#define bFM4_CANFD_XIDAM_EIDM11                *((volatile unsigned char*)(0x42E0122CUL))
#define bFM4_CANFD_XIDAM_EIDM12                *((volatile unsigned char*)(0x42E01230UL))
#define bFM4_CANFD_XIDAM_EIDM13                *((volatile unsigned char*)(0x42E01234UL))
#define bFM4_CANFD_XIDAM_EIDM14                *((volatile unsigned char*)(0x42E01238UL))
#define bFM4_CANFD_XIDAM_EIDM15                *((volatile unsigned char*)(0x42E0123CUL))
#define bFM4_CANFD_XIDAM_EIDM16                *((volatile unsigned char*)(0x42E01240UL))
#define bFM4_CANFD_XIDAM_EIDM17                *((volatile unsigned char*)(0x42E01244UL))
#define bFM4_CANFD_XIDAM_EIDM18                *((volatile unsigned char*)(0x42E01248UL))
#define bFM4_CANFD_XIDAM_EIDM19                *((volatile unsigned char*)(0x42E0124CUL))
#define bFM4_CANFD_XIDAM_EIDM20                *((volatile unsigned char*)(0x42E01250UL))
#define bFM4_CANFD_XIDAM_EIDM21                *((volatile unsigned char*)(0x42E01254UL))
#define bFM4_CANFD_XIDAM_EIDM22                *((volatile unsigned char*)(0x42E01258UL))
#define bFM4_CANFD_XIDAM_EIDM23                *((volatile unsigned char*)(0x42E0125CUL))
#define bFM4_CANFD_XIDAM_EIDM24                *((volatile unsigned char*)(0x42E01260UL))
#define bFM4_CANFD_XIDAM_EIDM25                *((volatile unsigned char*)(0x42E01264UL))
#define bFM4_CANFD_XIDAM_EIDM26                *((volatile unsigned char*)(0x42E01268UL))
#define bFM4_CANFD_XIDAM_EIDM27                *((volatile unsigned char*)(0x42E0126CUL))
#define bFM4_CANFD_XIDAM_EIDM28                *((volatile unsigned char*)(0x42E01270UL))
#define bFM4_CANFD_HPMS_BIDX0                  *((volatile unsigned char*)(0x42E01280UL))
#define bFM4_CANFD_HPMS_BIDX1                  *((volatile unsigned char*)(0x42E01284UL))
#define bFM4_CANFD_HPMS_BIDX2                  *((volatile unsigned char*)(0x42E01288UL))
#define bFM4_CANFD_HPMS_BIDX3                  *((volatile unsigned char*)(0x42E0128CUL))
#define bFM4_CANFD_HPMS_BIDX4                  *((volatile unsigned char*)(0x42E01290UL))
#define bFM4_CANFD_HPMS_BIDX5                  *((volatile unsigned char*)(0x42E01294UL))
#define bFM4_CANFD_HPMS_MSI0                   *((volatile unsigned char*)(0x42E01298UL))
#define bFM4_CANFD_HPMS_MSI1                   *((volatile unsigned char*)(0x42E0129CUL))
#define bFM4_CANFD_HPMS_FIDX0                  *((volatile unsigned char*)(0x42E012A0UL))
#define bFM4_CANFD_HPMS_FIDX1                  *((volatile unsigned char*)(0x42E012A4UL))
#define bFM4_CANFD_HPMS_FIDX2                  *((volatile unsigned char*)(0x42E012A8UL))
#define bFM4_CANFD_HPMS_FIDX3                  *((volatile unsigned char*)(0x42E012ACUL))
#define bFM4_CANFD_HPMS_FIDX4                  *((volatile unsigned char*)(0x42E012B0UL))
#define bFM4_CANFD_HPMS_FIDX5                  *((volatile unsigned char*)(0x42E012B4UL))
#define bFM4_CANFD_HPMS_FIDX6                  *((volatile unsigned char*)(0x42E012B8UL))
#define bFM4_CANFD_HPMS_FLST                   *((volatile unsigned char*)(0x42E012BCUL))
#define bFM4_CANFD_NDAT1_ND0                   *((volatile unsigned char*)(0x42E01300UL))
#define bFM4_CANFD_NDAT1_ND1                   *((volatile unsigned char*)(0x42E01304UL))
#define bFM4_CANFD_NDAT1_ND2                   *((volatile unsigned char*)(0x42E01308UL))
#define bFM4_CANFD_NDAT1_ND3                   *((volatile unsigned char*)(0x42E0130CUL))
#define bFM4_CANFD_NDAT1_ND4                   *((volatile unsigned char*)(0x42E01310UL))
#define bFM4_CANFD_NDAT1_ND5                   *((volatile unsigned char*)(0x42E01314UL))
#define bFM4_CANFD_NDAT1_ND6                   *((volatile unsigned char*)(0x42E01318UL))
#define bFM4_CANFD_NDAT1_ND7                   *((volatile unsigned char*)(0x42E0131CUL))
#define bFM4_CANFD_NDAT1_ND8                   *((volatile unsigned char*)(0x42E01320UL))
#define bFM4_CANFD_NDAT1_ND9                   *((volatile unsigned char*)(0x42E01324UL))
#define bFM4_CANFD_NDAT1_ND10                  *((volatile unsigned char*)(0x42E01328UL))
#define bFM4_CANFD_NDAT1_ND11                  *((volatile unsigned char*)(0x42E0132CUL))
#define bFM4_CANFD_NDAT1_ND12                  *((volatile unsigned char*)(0x42E01330UL))
#define bFM4_CANFD_NDAT1_ND13                  *((volatile unsigned char*)(0x42E01334UL))
#define bFM4_CANFD_NDAT1_ND14                  *((volatile unsigned char*)(0x42E01338UL))
#define bFM4_CANFD_NDAT1_ND15                  *((volatile unsigned char*)(0x42E0133CUL))
#define bFM4_CANFD_NDAT1_ND16                  *((volatile unsigned char*)(0x42E01340UL))
#define bFM4_CANFD_NDAT1_ND17                  *((volatile unsigned char*)(0x42E01344UL))
#define bFM4_CANFD_NDAT1_ND18                  *((volatile unsigned char*)(0x42E01348UL))
#define bFM4_CANFD_NDAT1_ND19                  *((volatile unsigned char*)(0x42E0134CUL))
#define bFM4_CANFD_NDAT1_ND20                  *((volatile unsigned char*)(0x42E01350UL))
#define bFM4_CANFD_NDAT1_ND21                  *((volatile unsigned char*)(0x42E01354UL))
#define bFM4_CANFD_NDAT1_ND22                  *((volatile unsigned char*)(0x42E01358UL))
#define bFM4_CANFD_NDAT1_ND23                  *((volatile unsigned char*)(0x42E0135CUL))
#define bFM4_CANFD_NDAT1_ND24                  *((volatile unsigned char*)(0x42E01360UL))
#define bFM4_CANFD_NDAT1_ND25                  *((volatile unsigned char*)(0x42E01364UL))
#define bFM4_CANFD_NDAT1_ND26                  *((volatile unsigned char*)(0x42E01368UL))
#define bFM4_CANFD_NDAT1_ND27                  *((volatile unsigned char*)(0x42E0136CUL))
#define bFM4_CANFD_NDAT1_ND28                  *((volatile unsigned char*)(0x42E01370UL))
#define bFM4_CANFD_NDAT1_ND29                  *((volatile unsigned char*)(0x42E01374UL))
#define bFM4_CANFD_NDAT1_ND30                  *((volatile unsigned char*)(0x42E01378UL))
#define bFM4_CANFD_NDAT1_ND31                  *((volatile unsigned char*)(0x42E0137CUL))
#define bFM4_CANFD_NDAT2_ND32                  *((volatile unsigned char*)(0x42E01380UL))
#define bFM4_CANFD_NDAT2_ND33                  *((volatile unsigned char*)(0x42E01384UL))
#define bFM4_CANFD_NDAT2_ND34                  *((volatile unsigned char*)(0x42E01388UL))
#define bFM4_CANFD_NDAT2_ND35                  *((volatile unsigned char*)(0x42E0138CUL))
#define bFM4_CANFD_NDAT2_ND36                  *((volatile unsigned char*)(0x42E01390UL))
#define bFM4_CANFD_NDAT2_ND37                  *((volatile unsigned char*)(0x42E01394UL))
#define bFM4_CANFD_NDAT2_ND38                  *((volatile unsigned char*)(0x42E01398UL))
#define bFM4_CANFD_NDAT2_ND39                  *((volatile unsigned char*)(0x42E0139CUL))
#define bFM4_CANFD_NDAT2_ND40                  *((volatile unsigned char*)(0x42E013A0UL))
#define bFM4_CANFD_NDAT2_ND41                  *((volatile unsigned char*)(0x42E013A4UL))
#define bFM4_CANFD_NDAT2_ND42                  *((volatile unsigned char*)(0x42E013A8UL))
#define bFM4_CANFD_NDAT2_ND43                  *((volatile unsigned char*)(0x42E013ACUL))
#define bFM4_CANFD_NDAT2_ND44                  *((volatile unsigned char*)(0x42E013B0UL))
#define bFM4_CANFD_NDAT2_ND45                  *((volatile unsigned char*)(0x42E013B4UL))
#define bFM4_CANFD_NDAT2_ND46                  *((volatile unsigned char*)(0x42E013B8UL))
#define bFM4_CANFD_NDAT2_ND47                  *((volatile unsigned char*)(0x42E013BCUL))
#define bFM4_CANFD_NDAT2_ND48                  *((volatile unsigned char*)(0x42E013C0UL))
#define bFM4_CANFD_NDAT2_ND49                  *((volatile unsigned char*)(0x42E013C4UL))
#define bFM4_CANFD_NDAT2_ND50                  *((volatile unsigned char*)(0x42E013C8UL))
#define bFM4_CANFD_NDAT2_ND51                  *((volatile unsigned char*)(0x42E013CCUL))
#define bFM4_CANFD_NDAT2_ND52                  *((volatile unsigned char*)(0x42E013D0UL))
#define bFM4_CANFD_NDAT2_ND53                  *((volatile unsigned char*)(0x42E013D4UL))
#define bFM4_CANFD_NDAT2_ND54                  *((volatile unsigned char*)(0x42E013D8UL))
#define bFM4_CANFD_NDAT2_ND55                  *((volatile unsigned char*)(0x42E013DCUL))
#define bFM4_CANFD_NDAT2_ND56                  *((volatile unsigned char*)(0x42E013E0UL))
#define bFM4_CANFD_NDAT2_ND57                  *((volatile unsigned char*)(0x42E013E4UL))
#define bFM4_CANFD_NDAT2_ND58                  *((volatile unsigned char*)(0x42E013E8UL))
#define bFM4_CANFD_NDAT2_ND59                  *((volatile unsigned char*)(0x42E013ECUL))
#define bFM4_CANFD_NDAT2_ND60                  *((volatile unsigned char*)(0x42E013F0UL))
#define bFM4_CANFD_NDAT2_ND61                  *((volatile unsigned char*)(0x42E013F4UL))
#define bFM4_CANFD_NDAT2_ND62                  *((volatile unsigned char*)(0x42E013F8UL))
#define bFM4_CANFD_NDAT2_ND63                  *((volatile unsigned char*)(0x42E013FCUL))
#define bFM4_CANFD_RXF0C_F0SA0                 *((volatile unsigned char*)(0x42E01408UL))
#define bFM4_CANFD_RXF0C_F0SA1                 *((volatile unsigned char*)(0x42E0140CUL))
#define bFM4_CANFD_RXF0C_F0SA2                 *((volatile unsigned char*)(0x42E01410UL))
#define bFM4_CANFD_RXF0C_F0SA3                 *((volatile unsigned char*)(0x42E01414UL))
#define bFM4_CANFD_RXF0C_F0SA4                 *((volatile unsigned char*)(0x42E01418UL))
#define bFM4_CANFD_RXF0C_F0SA5                 *((volatile unsigned char*)(0x42E0141CUL))
#define bFM4_CANFD_RXF0C_F0SA6                 *((volatile unsigned char*)(0x42E01420UL))
#define bFM4_CANFD_RXF0C_F0SA7                 *((volatile unsigned char*)(0x42E01424UL))
#define bFM4_CANFD_RXF0C_F0SA8                 *((volatile unsigned char*)(0x42E01428UL))
#define bFM4_CANFD_RXF0C_F0SA9                 *((volatile unsigned char*)(0x42E0142CUL))
#define bFM4_CANFD_RXF0C_F0SA10                *((volatile unsigned char*)(0x42E01430UL))
#define bFM4_CANFD_RXF0C_F0SA11                *((volatile unsigned char*)(0x42E01434UL))
#define bFM4_CANFD_RXF0C_F0SA12                *((volatile unsigned char*)(0x42E01438UL))
#define bFM4_CANFD_RXF0C_F0SA13                *((volatile unsigned char*)(0x42E0143CUL))
#define bFM4_CANFD_RXF0C_F0S0                  *((volatile unsigned char*)(0x42E01440UL))
#define bFM4_CANFD_RXF0C_F0S1                  *((volatile unsigned char*)(0x42E01444UL))
#define bFM4_CANFD_RXF0C_F0S2                  *((volatile unsigned char*)(0x42E01448UL))
#define bFM4_CANFD_RXF0C_F0S3                  *((volatile unsigned char*)(0x42E0144CUL))
#define bFM4_CANFD_RXF0C_F0S4                  *((volatile unsigned char*)(0x42E01450UL))
#define bFM4_CANFD_RXF0C_F0S5                  *((volatile unsigned char*)(0x42E01454UL))
#define bFM4_CANFD_RXF0C_F0S6                  *((volatile unsigned char*)(0x42E01458UL))
#define bFM4_CANFD_RXF0C_F0WM0                 *((volatile unsigned char*)(0x42E01460UL))
#define bFM4_CANFD_RXF0C_F0WM1                 *((volatile unsigned char*)(0x42E01464UL))
#define bFM4_CANFD_RXF0C_F0WM2                 *((volatile unsigned char*)(0x42E01468UL))
#define bFM4_CANFD_RXF0C_F0WM3                 *((volatile unsigned char*)(0x42E0146CUL))
#define bFM4_CANFD_RXF0C_F0WM4                 *((volatile unsigned char*)(0x42E01470UL))
#define bFM4_CANFD_RXF0C_F0WM5                 *((volatile unsigned char*)(0x42E01474UL))
#define bFM4_CANFD_RXF0C_F0WM6                 *((volatile unsigned char*)(0x42E01478UL))
#define bFM4_CANFD_RXF0C_F0OM                  *((volatile unsigned char*)(0x42E0147CUL))
#define bFM4_CANFD_RXF0S_F0FL0                 *((volatile unsigned char*)(0x42E01480UL))
#define bFM4_CANFD_RXF0S_F0FL1                 *((volatile unsigned char*)(0x42E01484UL))
#define bFM4_CANFD_RXF0S_F0FL2                 *((volatile unsigned char*)(0x42E01488UL))
#define bFM4_CANFD_RXF0S_F0FL3                 *((volatile unsigned char*)(0x42E0148CUL))
#define bFM4_CANFD_RXF0S_F0FL4                 *((volatile unsigned char*)(0x42E01490UL))
#define bFM4_CANFD_RXF0S_F0FL5                 *((volatile unsigned char*)(0x42E01494UL))
#define bFM4_CANFD_RXF0S_F0FL6                 *((volatile unsigned char*)(0x42E01498UL))
#define bFM4_CANFD_RXF0S_F0GI0                 *((volatile unsigned char*)(0x42E014A0UL))
#define bFM4_CANFD_RXF0S_F0GI1                 *((volatile unsigned char*)(0x42E014A4UL))
#define bFM4_CANFD_RXF0S_F0GI2                 *((volatile unsigned char*)(0x42E014A8UL))
#define bFM4_CANFD_RXF0S_F0GI3                 *((volatile unsigned char*)(0x42E014ACUL))
#define bFM4_CANFD_RXF0S_F0GI4                 *((volatile unsigned char*)(0x42E014B0UL))
#define bFM4_CANFD_RXF0S_F0GI5                 *((volatile unsigned char*)(0x42E014B4UL))
#define bFM4_CANFD_RXF0S_F0PI0                 *((volatile unsigned char*)(0x42E014C0UL))
#define bFM4_CANFD_RXF0S_F0PI1                 *((volatile unsigned char*)(0x42E014C4UL))
#define bFM4_CANFD_RXF0S_F0PI2                 *((volatile unsigned char*)(0x42E014C8UL))
#define bFM4_CANFD_RXF0S_F0PI3                 *((volatile unsigned char*)(0x42E014CCUL))
#define bFM4_CANFD_RXF0S_F0PI4                 *((volatile unsigned char*)(0x42E014D0UL))
#define bFM4_CANFD_RXF0S_F0PI5                 *((volatile unsigned char*)(0x42E014D4UL))
#define bFM4_CANFD_RXF0S_F0F                   *((volatile unsigned char*)(0x42E014E0UL))
#define bFM4_CANFD_RXF0S_RF0L                  *((volatile unsigned char*)(0x42E014E4UL))
#define bFM4_CANFD_RXF0A_F0AI0                 *((volatile unsigned char*)(0x42E01500UL))
#define bFM4_CANFD_RXF0A_F0AI1                 *((volatile unsigned char*)(0x42E01504UL))
#define bFM4_CANFD_RXF0A_F0AI2                 *((volatile unsigned char*)(0x42E01508UL))
#define bFM4_CANFD_RXF0A_F0AI3                 *((volatile unsigned char*)(0x42E0150CUL))
#define bFM4_CANFD_RXF0A_F0AI4                 *((volatile unsigned char*)(0x42E01510UL))
#define bFM4_CANFD_RXF0A_F0AI5                 *((volatile unsigned char*)(0x42E01514UL))
#define bFM4_CANFD_RXBC_RBSA0                  *((volatile unsigned char*)(0x42E01588UL))
#define bFM4_CANFD_RXBC_RBSA1                  *((volatile unsigned char*)(0x42E0158CUL))
#define bFM4_CANFD_RXBC_RBSA2                  *((volatile unsigned char*)(0x42E01590UL))
#define bFM4_CANFD_RXBC_RBSA3                  *((volatile unsigned char*)(0x42E01594UL))
#define bFM4_CANFD_RXBC_RBSA4                  *((volatile unsigned char*)(0x42E01598UL))
#define bFM4_CANFD_RXBC_RBSA5                  *((volatile unsigned char*)(0x42E0159CUL))
#define bFM4_CANFD_RXBC_RBSA6                  *((volatile unsigned char*)(0x42E015A0UL))
#define bFM4_CANFD_RXBC_RBSA7                  *((volatile unsigned char*)(0x42E015A4UL))
#define bFM4_CANFD_RXBC_RBSA8                  *((volatile unsigned char*)(0x42E015A8UL))
#define bFM4_CANFD_RXBC_RBSA9                  *((volatile unsigned char*)(0x42E015ACUL))
#define bFM4_CANFD_RXBC_RBSA10                 *((volatile unsigned char*)(0x42E015B0UL))
#define bFM4_CANFD_RXBC_RBSA11                 *((volatile unsigned char*)(0x42E015B4UL))
#define bFM4_CANFD_RXBC_RBSA12                 *((volatile unsigned char*)(0x42E015B8UL))
#define bFM4_CANFD_RXBC_RBSA13                 *((volatile unsigned char*)(0x42E015BCUL))
#define bFM4_CANFD_RXF1C_F1SA0                 *((volatile unsigned char*)(0x42E01608UL))
#define bFM4_CANFD_RXF1C_F1SA1                 *((volatile unsigned char*)(0x42E0160CUL))
#define bFM4_CANFD_RXF1C_F1SA2                 *((volatile unsigned char*)(0x42E01610UL))
#define bFM4_CANFD_RXF1C_F1SA3                 *((volatile unsigned char*)(0x42E01614UL))
#define bFM4_CANFD_RXF1C_F1SA4                 *((volatile unsigned char*)(0x42E01618UL))
#define bFM4_CANFD_RXF1C_F1SA5                 *((volatile unsigned char*)(0x42E0161CUL))
#define bFM4_CANFD_RXF1C_F1SA6                 *((volatile unsigned char*)(0x42E01620UL))
#define bFM4_CANFD_RXF1C_F1SA7                 *((volatile unsigned char*)(0x42E01624UL))
#define bFM4_CANFD_RXF1C_F1SA8                 *((volatile unsigned char*)(0x42E01628UL))
#define bFM4_CANFD_RXF1C_F1SA9                 *((volatile unsigned char*)(0x42E0162CUL))
#define bFM4_CANFD_RXF1C_F1SA10                *((volatile unsigned char*)(0x42E01630UL))
#define bFM4_CANFD_RXF1C_F1SA11                *((volatile unsigned char*)(0x42E01634UL))
#define bFM4_CANFD_RXF1C_F1SA12                *((volatile unsigned char*)(0x42E01638UL))
#define bFM4_CANFD_RXF1C_F1SA13                *((volatile unsigned char*)(0x42E0163CUL))
#define bFM4_CANFD_RXF1C_F1S0                  *((volatile unsigned char*)(0x42E01640UL))
#define bFM4_CANFD_RXF1C_F1S1                  *((volatile unsigned char*)(0x42E01644UL))
#define bFM4_CANFD_RXF1C_F1S2                  *((volatile unsigned char*)(0x42E01648UL))
#define bFM4_CANFD_RXF1C_F1S3                  *((volatile unsigned char*)(0x42E0164CUL))
#define bFM4_CANFD_RXF1C_F1S4                  *((volatile unsigned char*)(0x42E01650UL))
#define bFM4_CANFD_RXF1C_F1S5                  *((volatile unsigned char*)(0x42E01654UL))
#define bFM4_CANFD_RXF1C_F1S6                  *((volatile unsigned char*)(0x42E01658UL))
#define bFM4_CANFD_RXF1C_F1WM0                 *((volatile unsigned char*)(0x42E01660UL))
#define bFM4_CANFD_RXF1C_F1WM1                 *((volatile unsigned char*)(0x42E01664UL))
#define bFM4_CANFD_RXF1C_F1WM2                 *((volatile unsigned char*)(0x42E01668UL))
#define bFM4_CANFD_RXF1C_F1WM3                 *((volatile unsigned char*)(0x42E0166CUL))
#define bFM4_CANFD_RXF1C_F1WM4                 *((volatile unsigned char*)(0x42E01670UL))
#define bFM4_CANFD_RXF1C_F1WM5                 *((volatile unsigned char*)(0x42E01674UL))
#define bFM4_CANFD_RXF1C_F1WM6                 *((volatile unsigned char*)(0x42E01678UL))
#define bFM4_CANFD_RXF1C_F1OM                  *((volatile unsigned char*)(0x42E0167CUL))
#define bFM4_CANFD_RXF1S_F1FL0                 *((volatile unsigned char*)(0x42E01680UL))
#define bFM4_CANFD_RXF1S_F1FL1                 *((volatile unsigned char*)(0x42E01684UL))
#define bFM4_CANFD_RXF1S_F1FL2                 *((volatile unsigned char*)(0x42E01688UL))
#define bFM4_CANFD_RXF1S_F1FL3                 *((volatile unsigned char*)(0x42E0168CUL))
#define bFM4_CANFD_RXF1S_F1FL4                 *((volatile unsigned char*)(0x42E01690UL))
#define bFM4_CANFD_RXF1S_F1FL5                 *((volatile unsigned char*)(0x42E01694UL))
#define bFM4_CANFD_RXF1S_F1FL6                 *((volatile unsigned char*)(0x42E01698UL))
#define bFM4_CANFD_RXF1S_F1GI0                 *((volatile unsigned char*)(0x42E016A0UL))
#define bFM4_CANFD_RXF1S_F1GI1                 *((volatile unsigned char*)(0x42E016A4UL))
#define bFM4_CANFD_RXF1S_F1GI2                 *((volatile unsigned char*)(0x42E016A8UL))
#define bFM4_CANFD_RXF1S_F1GI3                 *((volatile unsigned char*)(0x42E016ACUL))
#define bFM4_CANFD_RXF1S_F1GI4                 *((volatile unsigned char*)(0x42E016B0UL))
#define bFM4_CANFD_RXF1S_F1GI5                 *((volatile unsigned char*)(0x42E016B4UL))
#define bFM4_CANFD_RXF1S_F1PI0                 *((volatile unsigned char*)(0x42E016C0UL))
#define bFM4_CANFD_RXF1S_F1PI1                 *((volatile unsigned char*)(0x42E016C4UL))
#define bFM4_CANFD_RXF1S_F1PI2                 *((volatile unsigned char*)(0x42E016C8UL))
#define bFM4_CANFD_RXF1S_F1PI3                 *((volatile unsigned char*)(0x42E016CCUL))
#define bFM4_CANFD_RXF1S_F1PI4                 *((volatile unsigned char*)(0x42E016D0UL))
#define bFM4_CANFD_RXF1S_F1PI5                 *((volatile unsigned char*)(0x42E016D4UL))
#define bFM4_CANFD_RXF1S_F1F                   *((volatile unsigned char*)(0x42E016E0UL))
#define bFM4_CANFD_RXF1S_RF1L                  *((volatile unsigned char*)(0x42E016E4UL))
#define bFM4_CANFD_RXF1S_DMS0                  *((volatile unsigned char*)(0x42E016F8UL))
#define bFM4_CANFD_RXF1S_DMS1                  *((volatile unsigned char*)(0x42E016FCUL))
#define bFM4_CANFD_RXF1A_F1AI0                 *((volatile unsigned char*)(0x42E01700UL))
#define bFM4_CANFD_RXF1A_F1AI1                 *((volatile unsigned char*)(0x42E01704UL))
#define bFM4_CANFD_RXF1A_F1AI2                 *((volatile unsigned char*)(0x42E01708UL))
#define bFM4_CANFD_RXF1A_F1AI3                 *((volatile unsigned char*)(0x42E0170CUL))
#define bFM4_CANFD_RXF1A_F1AI4                 *((volatile unsigned char*)(0x42E01710UL))
#define bFM4_CANFD_RXF1A_F1AI5                 *((volatile unsigned char*)(0x42E01714UL))
#define bFM4_CANFD_RXESC_F0DS0                 *((volatile unsigned char*)(0x42E01780UL))
#define bFM4_CANFD_RXESC_F0DS1                 *((volatile unsigned char*)(0x42E01784UL))
#define bFM4_CANFD_RXESC_F0DS2                 *((volatile unsigned char*)(0x42E01788UL))
#define bFM4_CANFD_RXESC_F1DS0                 *((volatile unsigned char*)(0x42E01790UL))
#define bFM4_CANFD_RXESC_F1DS1                 *((volatile unsigned char*)(0x42E01794UL))
#define bFM4_CANFD_RXESC_F1DS2                 *((volatile unsigned char*)(0x42E01798UL))
#define bFM4_CANFD_RXESC_RBDS0                 *((volatile unsigned char*)(0x42E017A0UL))
#define bFM4_CANFD_RXESC_RBDS1                 *((volatile unsigned char*)(0x42E017A4UL))
#define bFM4_CANFD_RXESC_RBDS2                 *((volatile unsigned char*)(0x42E017A8UL))
#define bFM4_CANFD_TXBC_TBSA0                  *((volatile unsigned char*)(0x42E01808UL))
#define bFM4_CANFD_TXBC_TBSA1                  *((volatile unsigned char*)(0x42E0180CUL))
#define bFM4_CANFD_TXBC_TBSA2                  *((volatile unsigned char*)(0x42E01810UL))
#define bFM4_CANFD_TXBC_TBSA3                  *((volatile unsigned char*)(0x42E01814UL))
#define bFM4_CANFD_TXBC_TBSA4                  *((volatile unsigned char*)(0x42E01818UL))
#define bFM4_CANFD_TXBC_TBSA5                  *((volatile unsigned char*)(0x42E0181CUL))
#define bFM4_CANFD_TXBC_TBSA6                  *((volatile unsigned char*)(0x42E01820UL))
#define bFM4_CANFD_TXBC_TBSA7                  *((volatile unsigned char*)(0x42E01824UL))
#define bFM4_CANFD_TXBC_TBSA8                  *((volatile unsigned char*)(0x42E01828UL))
#define bFM4_CANFD_TXBC_TBSA9                  *((volatile unsigned char*)(0x42E0182CUL))
#define bFM4_CANFD_TXBC_TBSA10                 *((volatile unsigned char*)(0x42E01830UL))
#define bFM4_CANFD_TXBC_TBSA11                 *((volatile unsigned char*)(0x42E01834UL))
#define bFM4_CANFD_TXBC_TBSA12                 *((volatile unsigned char*)(0x42E01838UL))
#define bFM4_CANFD_TXBC_TBSA13                 *((volatile unsigned char*)(0x42E0183CUL))
#define bFM4_CANFD_TXBC_NDTB0                  *((volatile unsigned char*)(0x42E01840UL))
#define bFM4_CANFD_TXBC_NDTB1                  *((volatile unsigned char*)(0x42E01844UL))
#define bFM4_CANFD_TXBC_NDTB2                  *((volatile unsigned char*)(0x42E01848UL))
#define bFM4_CANFD_TXBC_NDTB3                  *((volatile unsigned char*)(0x42E0184CUL))
#define bFM4_CANFD_TXBC_NDTB4                  *((volatile unsigned char*)(0x42E01850UL))
#define bFM4_CANFD_TXBC_NDTB5                  *((volatile unsigned char*)(0x42E01854UL))
#define bFM4_CANFD_TXBC_TFQS0                  *((volatile unsigned char*)(0x42E01860UL))
#define bFM4_CANFD_TXBC_TFQS1                  *((volatile unsigned char*)(0x42E01864UL))
#define bFM4_CANFD_TXBC_TFQS2                  *((volatile unsigned char*)(0x42E01868UL))
#define bFM4_CANFD_TXBC_TFQS3                  *((volatile unsigned char*)(0x42E0186CUL))
#define bFM4_CANFD_TXBC_TFQS4                  *((volatile unsigned char*)(0x42E01870UL))
#define bFM4_CANFD_TXBC_TFQS5                  *((volatile unsigned char*)(0x42E01874UL))
#define bFM4_CANFD_TXBC_TFQM                   *((volatile unsigned char*)(0x42E01878UL))
#define bFM4_CANFD_TXFQS_TFFL0                 *((volatile unsigned char*)(0x42E01880UL))
#define bFM4_CANFD_TXFQS_TFFL1                 *((volatile unsigned char*)(0x42E01884UL))
#define bFM4_CANFD_TXFQS_TFFL2                 *((volatile unsigned char*)(0x42E01888UL))
#define bFM4_CANFD_TXFQS_TFFL3                 *((volatile unsigned char*)(0x42E0188CUL))
#define bFM4_CANFD_TXFQS_TFFL4                 *((volatile unsigned char*)(0x42E01890UL))
#define bFM4_CANFD_TXFQS_TFFL5                 *((volatile unsigned char*)(0x42E01894UL))
#define bFM4_CANFD_TXFQS_TFGI0                 *((volatile unsigned char*)(0x42E018A0UL))
#define bFM4_CANFD_TXFQS_TFGI1                 *((volatile unsigned char*)(0x42E018A4UL))
#define bFM4_CANFD_TXFQS_TFGI2                 *((volatile unsigned char*)(0x42E018A8UL))
#define bFM4_CANFD_TXFQS_TFGI3                 *((volatile unsigned char*)(0x42E018ACUL))
#define bFM4_CANFD_TXFQS_TFGI4                 *((volatile unsigned char*)(0x42E018B0UL))
#define bFM4_CANFD_TXFQS_TFQPI0                *((volatile unsigned char*)(0x42E018C0UL))
#define bFM4_CANFD_TXFQS_TFQPI1                *((volatile unsigned char*)(0x42E018C4UL))
#define bFM4_CANFD_TXFQS_TFQPI2                *((volatile unsigned char*)(0x42E018C8UL))
#define bFM4_CANFD_TXFQS_TFQPI3                *((volatile unsigned char*)(0x42E018CCUL))
#define bFM4_CANFD_TXFQS_TFQPI4                *((volatile unsigned char*)(0x42E018D0UL))
#define bFM4_CANFD_TXFQS_TFQF                  *((volatile unsigned char*)(0x42E018D4UL))
#define bFM4_CANFD_TXESC_TBDS0                 *((volatile unsigned char*)(0x42E01900UL))
#define bFM4_CANFD_TXESC_TBDS1                 *((volatile unsigned char*)(0x42E01904UL))
#define bFM4_CANFD_TXESC_TBDS2                 *((volatile unsigned char*)(0x42E01908UL))
#define bFM4_CANFD_TXBRP_TRP0                  *((volatile unsigned char*)(0x42E01980UL))
#define bFM4_CANFD_TXBRP_TRP1                  *((volatile unsigned char*)(0x42E01984UL))
#define bFM4_CANFD_TXBRP_TRP2                  *((volatile unsigned char*)(0x42E01988UL))
#define bFM4_CANFD_TXBRP_TRP3                  *((volatile unsigned char*)(0x42E0198CUL))
#define bFM4_CANFD_TXBRP_TRP4                  *((volatile unsigned char*)(0x42E01990UL))
#define bFM4_CANFD_TXBRP_TRP5                  *((volatile unsigned char*)(0x42E01994UL))
#define bFM4_CANFD_TXBRP_TRP6                  *((volatile unsigned char*)(0x42E01998UL))
#define bFM4_CANFD_TXBRP_TRP7                  *((volatile unsigned char*)(0x42E0199CUL))
#define bFM4_CANFD_TXBRP_TRP8                  *((volatile unsigned char*)(0x42E019A0UL))
#define bFM4_CANFD_TXBRP_TRP9                  *((volatile unsigned char*)(0x42E019A4UL))
#define bFM4_CANFD_TXBRP_TRP10                 *((volatile unsigned char*)(0x42E019A8UL))
#define bFM4_CANFD_TXBRP_TRP11                 *((volatile unsigned char*)(0x42E019ACUL))
#define bFM4_CANFD_TXBRP_TRP12                 *((volatile unsigned char*)(0x42E019B0UL))
#define bFM4_CANFD_TXBRP_TRP13                 *((volatile unsigned char*)(0x42E019B4UL))
#define bFM4_CANFD_TXBRP_TRP14                 *((volatile unsigned char*)(0x42E019B8UL))
#define bFM4_CANFD_TXBRP_TRP15                 *((volatile unsigned char*)(0x42E019BCUL))
#define bFM4_CANFD_TXBRP_TRP16                 *((volatile unsigned char*)(0x42E019C0UL))
#define bFM4_CANFD_TXBRP_TRP17                 *((volatile unsigned char*)(0x42E019C4UL))
#define bFM4_CANFD_TXBRP_TRP18                 *((volatile unsigned char*)(0x42E019C8UL))
#define bFM4_CANFD_TXBRP_TRP19                 *((volatile unsigned char*)(0x42E019CCUL))
#define bFM4_CANFD_TXBRP_TRP20                 *((volatile unsigned char*)(0x42E019D0UL))
#define bFM4_CANFD_TXBRP_TRP21                 *((volatile unsigned char*)(0x42E019D4UL))
#define bFM4_CANFD_TXBRP_TRP22                 *((volatile unsigned char*)(0x42E019D8UL))
#define bFM4_CANFD_TXBRP_TRP23                 *((volatile unsigned char*)(0x42E019DCUL))
#define bFM4_CANFD_TXBRP_TRP24                 *((volatile unsigned char*)(0x42E019E0UL))
#define bFM4_CANFD_TXBRP_TRP25                 *((volatile unsigned char*)(0x42E019E4UL))
#define bFM4_CANFD_TXBRP_TRP26                 *((volatile unsigned char*)(0x42E019E8UL))
#define bFM4_CANFD_TXBRP_TRP27                 *((volatile unsigned char*)(0x42E019ECUL))
#define bFM4_CANFD_TXBRP_TRP28                 *((volatile unsigned char*)(0x42E019F0UL))
#define bFM4_CANFD_TXBRP_TRP29                 *((volatile unsigned char*)(0x42E019F4UL))
#define bFM4_CANFD_TXBRP_TRP30                 *((volatile unsigned char*)(0x42E019F8UL))
#define bFM4_CANFD_TXBRP_TRP31                 *((volatile unsigned char*)(0x42E019FCUL))
#define bFM4_CANFD_TXBAR_AR0                   *((volatile unsigned char*)(0x42E01A00UL))
#define bFM4_CANFD_TXBAR_AR1                   *((volatile unsigned char*)(0x42E01A04UL))
#define bFM4_CANFD_TXBAR_AR2                   *((volatile unsigned char*)(0x42E01A08UL))
#define bFM4_CANFD_TXBAR_AR3                   *((volatile unsigned char*)(0x42E01A0CUL))
#define bFM4_CANFD_TXBAR_AR4                   *((volatile unsigned char*)(0x42E01A10UL))
#define bFM4_CANFD_TXBAR_AR5                   *((volatile unsigned char*)(0x42E01A14UL))
#define bFM4_CANFD_TXBAR_AR6                   *((volatile unsigned char*)(0x42E01A18UL))
#define bFM4_CANFD_TXBAR_AR7                   *((volatile unsigned char*)(0x42E01A1CUL))
#define bFM4_CANFD_TXBAR_AR8                   *((volatile unsigned char*)(0x42E01A20UL))
#define bFM4_CANFD_TXBAR_AR9                   *((volatile unsigned char*)(0x42E01A24UL))
#define bFM4_CANFD_TXBAR_AR10                  *((volatile unsigned char*)(0x42E01A28UL))
#define bFM4_CANFD_TXBAR_AR11                  *((volatile unsigned char*)(0x42E01A2CUL))
#define bFM4_CANFD_TXBAR_AR12                  *((volatile unsigned char*)(0x42E01A30UL))
#define bFM4_CANFD_TXBAR_AR13                  *((volatile unsigned char*)(0x42E01A34UL))
#define bFM4_CANFD_TXBAR_AR14                  *((volatile unsigned char*)(0x42E01A38UL))
#define bFM4_CANFD_TXBAR_AR15                  *((volatile unsigned char*)(0x42E01A3CUL))
#define bFM4_CANFD_TXBAR_AR16                  *((volatile unsigned char*)(0x42E01A40UL))
#define bFM4_CANFD_TXBAR_AR17                  *((volatile unsigned char*)(0x42E01A44UL))
#define bFM4_CANFD_TXBAR_AR18                  *((volatile unsigned char*)(0x42E01A48UL))
#define bFM4_CANFD_TXBAR_AR19                  *((volatile unsigned char*)(0x42E01A4CUL))
#define bFM4_CANFD_TXBAR_AR20                  *((volatile unsigned char*)(0x42E01A50UL))
#define bFM4_CANFD_TXBAR_AR21                  *((volatile unsigned char*)(0x42E01A54UL))
#define bFM4_CANFD_TXBAR_AR22                  *((volatile unsigned char*)(0x42E01A58UL))
#define bFM4_CANFD_TXBAR_AR23                  *((volatile unsigned char*)(0x42E01A5CUL))
#define bFM4_CANFD_TXBAR_AR24                  *((volatile unsigned char*)(0x42E01A60UL))
#define bFM4_CANFD_TXBAR_AR25                  *((volatile unsigned char*)(0x42E01A64UL))
#define bFM4_CANFD_TXBAR_AR26                  *((volatile unsigned char*)(0x42E01A68UL))
#define bFM4_CANFD_TXBAR_AR27                  *((volatile unsigned char*)(0x42E01A6CUL))
#define bFM4_CANFD_TXBAR_AR28                  *((volatile unsigned char*)(0x42E01A70UL))
#define bFM4_CANFD_TXBAR_AR29                  *((volatile unsigned char*)(0x42E01A74UL))
#define bFM4_CANFD_TXBAR_AR30                  *((volatile unsigned char*)(0x42E01A78UL))
#define bFM4_CANFD_TXBAR_AR31                  *((volatile unsigned char*)(0x42E01A7CUL))
#define bFM4_CANFD_TXBCR_CR0                   *((volatile unsigned char*)(0x42E01A80UL))
#define bFM4_CANFD_TXBCR_CR1                   *((volatile unsigned char*)(0x42E01A84UL))
#define bFM4_CANFD_TXBCR_CR2                   *((volatile unsigned char*)(0x42E01A88UL))
#define bFM4_CANFD_TXBCR_CR3                   *((volatile unsigned char*)(0x42E01A8CUL))
#define bFM4_CANFD_TXBCR_CR4                   *((volatile unsigned char*)(0x42E01A90UL))
#define bFM4_CANFD_TXBCR_CR5                   *((volatile unsigned char*)(0x42E01A94UL))
#define bFM4_CANFD_TXBCR_CR6                   *((volatile unsigned char*)(0x42E01A98UL))
#define bFM4_CANFD_TXBCR_CR7                   *((volatile unsigned char*)(0x42E01A9CUL))
#define bFM4_CANFD_TXBCR_CR8                   *((volatile unsigned char*)(0x42E01AA0UL))
#define bFM4_CANFD_TXBCR_CR9                   *((volatile unsigned char*)(0x42E01AA4UL))
#define bFM4_CANFD_TXBCR_CR10                  *((volatile unsigned char*)(0x42E01AA8UL))
#define bFM4_CANFD_TXBCR_CR11                  *((volatile unsigned char*)(0x42E01AACUL))
#define bFM4_CANFD_TXBCR_CR12                  *((volatile unsigned char*)(0x42E01AB0UL))
#define bFM4_CANFD_TXBCR_CR13                  *((volatile unsigned char*)(0x42E01AB4UL))
#define bFM4_CANFD_TXBCR_CR14                  *((volatile unsigned char*)(0x42E01AB8UL))
#define bFM4_CANFD_TXBCR_CR15                  *((volatile unsigned char*)(0x42E01ABCUL))
#define bFM4_CANFD_TXBCR_CR16                  *((volatile unsigned char*)(0x42E01AC0UL))
#define bFM4_CANFD_TXBCR_CR17                  *((volatile unsigned char*)(0x42E01AC4UL))
#define bFM4_CANFD_TXBCR_CR18                  *((volatile unsigned char*)(0x42E01AC8UL))
#define bFM4_CANFD_TXBCR_CR19                  *((volatile unsigned char*)(0x42E01ACCUL))
#define bFM4_CANFD_TXBCR_CR20                  *((volatile unsigned char*)(0x42E01AD0UL))
#define bFM4_CANFD_TXBCR_CR21                  *((volatile unsigned char*)(0x42E01AD4UL))
#define bFM4_CANFD_TXBCR_CR22                  *((volatile unsigned char*)(0x42E01AD8UL))
#define bFM4_CANFD_TXBCR_CR23                  *((volatile unsigned char*)(0x42E01ADCUL))
#define bFM4_CANFD_TXBCR_CR24                  *((volatile unsigned char*)(0x42E01AE0UL))
#define bFM4_CANFD_TXBCR_CR25                  *((volatile unsigned char*)(0x42E01AE4UL))
#define bFM4_CANFD_TXBCR_CR26                  *((volatile unsigned char*)(0x42E01AE8UL))
#define bFM4_CANFD_TXBCR_CR27                  *((volatile unsigned char*)(0x42E01AECUL))
#define bFM4_CANFD_TXBCR_CR28                  *((volatile unsigned char*)(0x42E01AF0UL))
#define bFM4_CANFD_TXBCR_CR29                  *((volatile unsigned char*)(0x42E01AF4UL))
#define bFM4_CANFD_TXBCR_CR30                  *((volatile unsigned char*)(0x42E01AF8UL))
#define bFM4_CANFD_TXBCR_CR31                  *((volatile unsigned char*)(0x42E01AFCUL))
#define bFM4_CANFD_TXBTO_TO0                   *((volatile unsigned char*)(0x42E01B00UL))
#define bFM4_CANFD_TXBTO_TO1                   *((volatile unsigned char*)(0x42E01B04UL))
#define bFM4_CANFD_TXBTO_TO2                   *((volatile unsigned char*)(0x42E01B08UL))
#define bFM4_CANFD_TXBTO_TO3                   *((volatile unsigned char*)(0x42E01B0CUL))
#define bFM4_CANFD_TXBTO_TO4                   *((volatile unsigned char*)(0x42E01B10UL))
#define bFM4_CANFD_TXBTO_TO5                   *((volatile unsigned char*)(0x42E01B14UL))
#define bFM4_CANFD_TXBTO_TO6                   *((volatile unsigned char*)(0x42E01B18UL))
#define bFM4_CANFD_TXBTO_TO7                   *((volatile unsigned char*)(0x42E01B1CUL))
#define bFM4_CANFD_TXBTO_TO8                   *((volatile unsigned char*)(0x42E01B20UL))
#define bFM4_CANFD_TXBTO_TO9                   *((volatile unsigned char*)(0x42E01B24UL))
#define bFM4_CANFD_TXBTO_TO10                  *((volatile unsigned char*)(0x42E01B28UL))
#define bFM4_CANFD_TXBTO_TO11                  *((volatile unsigned char*)(0x42E01B2CUL))
#define bFM4_CANFD_TXBTO_TO12                  *((volatile unsigned char*)(0x42E01B30UL))
#define bFM4_CANFD_TXBTO_TO13                  *((volatile unsigned char*)(0x42E01B34UL))
#define bFM4_CANFD_TXBTO_TO14                  *((volatile unsigned char*)(0x42E01B38UL))
#define bFM4_CANFD_TXBTO_TO15                  *((volatile unsigned char*)(0x42E01B3CUL))
#define bFM4_CANFD_TXBTO_TO16                  *((volatile unsigned char*)(0x42E01B40UL))
#define bFM4_CANFD_TXBTO_TO17                  *((volatile unsigned char*)(0x42E01B44UL))
#define bFM4_CANFD_TXBTO_TO18                  *((volatile unsigned char*)(0x42E01B48UL))
#define bFM4_CANFD_TXBTO_TO19                  *((volatile unsigned char*)(0x42E01B4CUL))
#define bFM4_CANFD_TXBTO_TO20                  *((volatile unsigned char*)(0x42E01B50UL))
#define bFM4_CANFD_TXBTO_TO21                  *((volatile unsigned char*)(0x42E01B54UL))
#define bFM4_CANFD_TXBTO_TO22                  *((volatile unsigned char*)(0x42E01B58UL))
#define bFM4_CANFD_TXBTO_TO23                  *((volatile unsigned char*)(0x42E01B5CUL))
#define bFM4_CANFD_TXBTO_TO24                  *((volatile unsigned char*)(0x42E01B60UL))
#define bFM4_CANFD_TXBTO_TO25                  *((volatile unsigned char*)(0x42E01B64UL))
#define bFM4_CANFD_TXBTO_TO26                  *((volatile unsigned char*)(0x42E01B68UL))
#define bFM4_CANFD_TXBTO_TO27                  *((volatile unsigned char*)(0x42E01B6CUL))
#define bFM4_CANFD_TXBTO_TO28                  *((volatile unsigned char*)(0x42E01B70UL))
#define bFM4_CANFD_TXBTO_TO29                  *((volatile unsigned char*)(0x42E01B74UL))
#define bFM4_CANFD_TXBTO_TO30                  *((volatile unsigned char*)(0x42E01B78UL))
#define bFM4_CANFD_TXBTO_TO31                  *((volatile unsigned char*)(0x42E01B7CUL))
#define bFM4_CANFD_TXBCF_CF0                   *((volatile unsigned char*)(0x42E01B80UL))
#define bFM4_CANFD_TXBCF_CF1                   *((volatile unsigned char*)(0x42E01B84UL))
#define bFM4_CANFD_TXBCF_CF2                   *((volatile unsigned char*)(0x42E01B88UL))
#define bFM4_CANFD_TXBCF_CF3                   *((volatile unsigned char*)(0x42E01B8CUL))
#define bFM4_CANFD_TXBCF_CF4                   *((volatile unsigned char*)(0x42E01B90UL))
#define bFM4_CANFD_TXBCF_CF5                   *((volatile unsigned char*)(0x42E01B94UL))
#define bFM4_CANFD_TXBCF_CF6                   *((volatile unsigned char*)(0x42E01B98UL))
#define bFM4_CANFD_TXBCF_CF7                   *((volatile unsigned char*)(0x42E01B9CUL))
#define bFM4_CANFD_TXBCF_CF8                   *((volatile unsigned char*)(0x42E01BA0UL))
#define bFM4_CANFD_TXBCF_CF9                   *((volatile unsigned char*)(0x42E01BA4UL))
#define bFM4_CANFD_TXBCF_CF10                  *((volatile unsigned char*)(0x42E01BA8UL))
#define bFM4_CANFD_TXBCF_CF11                  *((volatile unsigned char*)(0x42E01BACUL))
#define bFM4_CANFD_TXBCF_CF12                  *((volatile unsigned char*)(0x42E01BB0UL))
#define bFM4_CANFD_TXBCF_CF13                  *((volatile unsigned char*)(0x42E01BB4UL))
#define bFM4_CANFD_TXBCF_CF14                  *((volatile unsigned char*)(0x42E01BB8UL))
#define bFM4_CANFD_TXBCF_CF15                  *((volatile unsigned char*)(0x42E01BBCUL))
#define bFM4_CANFD_TXBCF_CF16                  *((volatile unsigned char*)(0x42E01BC0UL))
#define bFM4_CANFD_TXBCF_CF17                  *((volatile unsigned char*)(0x42E01BC4UL))
#define bFM4_CANFD_TXBCF_CF18                  *((volatile unsigned char*)(0x42E01BC8UL))
#define bFM4_CANFD_TXBCF_CF19                  *((volatile unsigned char*)(0x42E01BCCUL))
#define bFM4_CANFD_TXBCF_CF20                  *((volatile unsigned char*)(0x42E01BD0UL))
#define bFM4_CANFD_TXBCF_CF21                  *((volatile unsigned char*)(0x42E01BD4UL))
#define bFM4_CANFD_TXBCF_CF22                  *((volatile unsigned char*)(0x42E01BD8UL))
#define bFM4_CANFD_TXBCF_CF23                  *((volatile unsigned char*)(0x42E01BDCUL))
#define bFM4_CANFD_TXBCF_CF24                  *((volatile unsigned char*)(0x42E01BE0UL))
#define bFM4_CANFD_TXBCF_CF25                  *((volatile unsigned char*)(0x42E01BE4UL))
#define bFM4_CANFD_TXBCF_CF26                  *((volatile unsigned char*)(0x42E01BE8UL))
#define bFM4_CANFD_TXBCF_CF27                  *((volatile unsigned char*)(0x42E01BECUL))
#define bFM4_CANFD_TXBCF_CF28                  *((volatile unsigned char*)(0x42E01BF0UL))
#define bFM4_CANFD_TXBCF_CF29                  *((volatile unsigned char*)(0x42E01BF4UL))
#define bFM4_CANFD_TXBCF_CF30                  *((volatile unsigned char*)(0x42E01BF8UL))
#define bFM4_CANFD_TXBCF_CF31                  *((volatile unsigned char*)(0x42E01BFCUL))
#define bFM4_CANFD_TXBTIE_TIE0                 *((volatile unsigned char*)(0x42E01C00UL))
#define bFM4_CANFD_TXBTIE_TIE1                 *((volatile unsigned char*)(0x42E01C04UL))
#define bFM4_CANFD_TXBTIE_TIE2                 *((volatile unsigned char*)(0x42E01C08UL))
#define bFM4_CANFD_TXBTIE_TIE3                 *((volatile unsigned char*)(0x42E01C0CUL))
#define bFM4_CANFD_TXBTIE_TIE4                 *((volatile unsigned char*)(0x42E01C10UL))
#define bFM4_CANFD_TXBTIE_TIE5                 *((volatile unsigned char*)(0x42E01C14UL))
#define bFM4_CANFD_TXBTIE_TIE6                 *((volatile unsigned char*)(0x42E01C18UL))
#define bFM4_CANFD_TXBTIE_TIE7                 *((volatile unsigned char*)(0x42E01C1CUL))
#define bFM4_CANFD_TXBTIE_TIE8                 *((volatile unsigned char*)(0x42E01C20UL))
#define bFM4_CANFD_TXBTIE_TIE9                 *((volatile unsigned char*)(0x42E01C24UL))
#define bFM4_CANFD_TXBTIE_TIE10                *((volatile unsigned char*)(0x42E01C28UL))
#define bFM4_CANFD_TXBTIE_TIE11                *((volatile unsigned char*)(0x42E01C2CUL))
#define bFM4_CANFD_TXBTIE_TIE12                *((volatile unsigned char*)(0x42E01C30UL))
#define bFM4_CANFD_TXBTIE_TIE13                *((volatile unsigned char*)(0x42E01C34UL))
#define bFM4_CANFD_TXBTIE_TIE14                *((volatile unsigned char*)(0x42E01C38UL))
#define bFM4_CANFD_TXBTIE_TIE15                *((volatile unsigned char*)(0x42E01C3CUL))
#define bFM4_CANFD_TXBTIE_TIE16                *((volatile unsigned char*)(0x42E01C40UL))
#define bFM4_CANFD_TXBTIE_TIE17                *((volatile unsigned char*)(0x42E01C44UL))
#define bFM4_CANFD_TXBTIE_TIE18                *((volatile unsigned char*)(0x42E01C48UL))
#define bFM4_CANFD_TXBTIE_TIE19                *((volatile unsigned char*)(0x42E01C4CUL))
#define bFM4_CANFD_TXBTIE_TIE20                *((volatile unsigned char*)(0x42E01C50UL))
#define bFM4_CANFD_TXBTIE_TIE21                *((volatile unsigned char*)(0x42E01C54UL))
#define bFM4_CANFD_TXBTIE_TIE22                *((volatile unsigned char*)(0x42E01C58UL))
#define bFM4_CANFD_TXBTIE_TIE23                *((volatile unsigned char*)(0x42E01C5CUL))
#define bFM4_CANFD_TXBTIE_TIE24                *((volatile unsigned char*)(0x42E01C60UL))
#define bFM4_CANFD_TXBTIE_TIE25                *((volatile unsigned char*)(0x42E01C64UL))
#define bFM4_CANFD_TXBTIE_TIE26                *((volatile unsigned char*)(0x42E01C68UL))
#define bFM4_CANFD_TXBTIE_TIE27                *((volatile unsigned char*)(0x42E01C6CUL))
#define bFM4_CANFD_TXBTIE_TIE28                *((volatile unsigned char*)(0x42E01C70UL))
#define bFM4_CANFD_TXBTIE_TIE29                *((volatile unsigned char*)(0x42E01C74UL))
#define bFM4_CANFD_TXBTIE_TIE30                *((volatile unsigned char*)(0x42E01C78UL))
#define bFM4_CANFD_TXBTIE_TIE31                *((volatile unsigned char*)(0x42E01C7CUL))
#define bFM4_CANFD_TXBCIE_CFIE0                *((volatile unsigned char*)(0x42E01C80UL))
#define bFM4_CANFD_TXBCIE_CFIE1                *((volatile unsigned char*)(0x42E01C84UL))
#define bFM4_CANFD_TXBCIE_CFIE2                *((volatile unsigned char*)(0x42E01C88UL))
#define bFM4_CANFD_TXBCIE_CFIE3                *((volatile unsigned char*)(0x42E01C8CUL))
#define bFM4_CANFD_TXBCIE_CFIE4                *((volatile unsigned char*)(0x42E01C90UL))
#define bFM4_CANFD_TXBCIE_CFIE5                *((volatile unsigned char*)(0x42E01C94UL))
#define bFM4_CANFD_TXBCIE_CFIE6                *((volatile unsigned char*)(0x42E01C98UL))
#define bFM4_CANFD_TXBCIE_CFIE7                *((volatile unsigned char*)(0x42E01C9CUL))
#define bFM4_CANFD_TXBCIE_CFIE8                *((volatile unsigned char*)(0x42E01CA0UL))
#define bFM4_CANFD_TXBCIE_CFIE9                *((volatile unsigned char*)(0x42E01CA4UL))
#define bFM4_CANFD_TXBCIE_CFIE10               *((volatile unsigned char*)(0x42E01CA8UL))
#define bFM4_CANFD_TXBCIE_CFIE11               *((volatile unsigned char*)(0x42E01CACUL))
#define bFM4_CANFD_TXBCIE_CFIE12               *((volatile unsigned char*)(0x42E01CB0UL))
#define bFM4_CANFD_TXBCIE_CFIE13               *((volatile unsigned char*)(0x42E01CB4UL))
#define bFM4_CANFD_TXBCIE_CFIE14               *((volatile unsigned char*)(0x42E01CB8UL))
#define bFM4_CANFD_TXBCIE_CFIE15               *((volatile unsigned char*)(0x42E01CBCUL))
#define bFM4_CANFD_TXBCIE_CFIE16               *((volatile unsigned char*)(0x42E01CC0UL))
#define bFM4_CANFD_TXBCIE_CFIE17               *((volatile unsigned char*)(0x42E01CC4UL))
#define bFM4_CANFD_TXBCIE_CFIE18               *((volatile unsigned char*)(0x42E01CC8UL))
#define bFM4_CANFD_TXBCIE_CFIE19               *((volatile unsigned char*)(0x42E01CCCUL))
#define bFM4_CANFD_TXBCIE_CFIE20               *((volatile unsigned char*)(0x42E01CD0UL))
#define bFM4_CANFD_TXBCIE_CFIE21               *((volatile unsigned char*)(0x42E01CD4UL))
#define bFM4_CANFD_TXBCIE_CFIE22               *((volatile unsigned char*)(0x42E01CD8UL))
#define bFM4_CANFD_TXBCIE_CFIE23               *((volatile unsigned char*)(0x42E01CDCUL))
#define bFM4_CANFD_TXBCIE_CFIE24               *((volatile unsigned char*)(0x42E01CE0UL))
#define bFM4_CANFD_TXBCIE_CFIE25               *((volatile unsigned char*)(0x42E01CE4UL))
#define bFM4_CANFD_TXBCIE_CFIE26               *((volatile unsigned char*)(0x42E01CE8UL))
#define bFM4_CANFD_TXBCIE_CFIE27               *((volatile unsigned char*)(0x42E01CECUL))
#define bFM4_CANFD_TXBCIE_CFIE28               *((volatile unsigned char*)(0x42E01CF0UL))
#define bFM4_CANFD_TXBCIE_CFIE29               *((volatile unsigned char*)(0x42E01CF4UL))
#define bFM4_CANFD_TXBCIE_CFIE30               *((volatile unsigned char*)(0x42E01CF8UL))
#define bFM4_CANFD_TXBCIE_CFIE31               *((volatile unsigned char*)(0x42E01CFCUL))
#define bFM4_CANFD_TXEFC_EFSA0                 *((volatile unsigned char*)(0x42E01E08UL))
#define bFM4_CANFD_TXEFC_EFSA1                 *((volatile unsigned char*)(0x42E01E0CUL))
#define bFM4_CANFD_TXEFC_EFSA2                 *((volatile unsigned char*)(0x42E01E10UL))
#define bFM4_CANFD_TXEFC_EFSA3                 *((volatile unsigned char*)(0x42E01E14UL))
#define bFM4_CANFD_TXEFC_EFSA4                 *((volatile unsigned char*)(0x42E01E18UL))
#define bFM4_CANFD_TXEFC_EFSA5                 *((volatile unsigned char*)(0x42E01E1CUL))
#define bFM4_CANFD_TXEFC_EFSA6                 *((volatile unsigned char*)(0x42E01E20UL))
#define bFM4_CANFD_TXEFC_EFSA7                 *((volatile unsigned char*)(0x42E01E24UL))
#define bFM4_CANFD_TXEFC_EFSA8                 *((volatile unsigned char*)(0x42E01E28UL))
#define bFM4_CANFD_TXEFC_EFSA9                 *((volatile unsigned char*)(0x42E01E2CUL))
#define bFM4_CANFD_TXEFC_EFSA10                *((volatile unsigned char*)(0x42E01E30UL))
#define bFM4_CANFD_TXEFC_EFSA11                *((volatile unsigned char*)(0x42E01E34UL))
#define bFM4_CANFD_TXEFC_EFSA12                *((volatile unsigned char*)(0x42E01E38UL))
#define bFM4_CANFD_TXEFC_EFSA13                *((volatile unsigned char*)(0x42E01E3CUL))
#define bFM4_CANFD_TXEFC_EFS0                  *((volatile unsigned char*)(0x42E01E40UL))
#define bFM4_CANFD_TXEFC_EFS1                  *((volatile unsigned char*)(0x42E01E44UL))
#define bFM4_CANFD_TXEFC_EFS2                  *((volatile unsigned char*)(0x42E01E48UL))
#define bFM4_CANFD_TXEFC_EFS3                  *((volatile unsigned char*)(0x42E01E4CUL))
#define bFM4_CANFD_TXEFC_EFS4                  *((volatile unsigned char*)(0x42E01E50UL))
#define bFM4_CANFD_TXEFC_EFS5                  *((volatile unsigned char*)(0x42E01E54UL))
#define bFM4_CANFD_TXEFC_EFWM0                 *((volatile unsigned char*)(0x42E01E60UL))
#define bFM4_CANFD_TXEFC_EFWM1                 *((volatile unsigned char*)(0x42E01E64UL))
#define bFM4_CANFD_TXEFC_EFWM2                 *((volatile unsigned char*)(0x42E01E68UL))
#define bFM4_CANFD_TXEFC_EFWM3                 *((volatile unsigned char*)(0x42E01E6CUL))
#define bFM4_CANFD_TXEFC_EFWM4                 *((volatile unsigned char*)(0x42E01E70UL))
#define bFM4_CANFD_TXEFC_EFWM5                 *((volatile unsigned char*)(0x42E01E74UL))
#define bFM4_CANFD_TXFS_EFFL0                  *((volatile unsigned char*)(0x42E01E80UL))
#define bFM4_CANFD_TXFS_EFFL1                  *((volatile unsigned char*)(0x42E01E84UL))
#define bFM4_CANFD_TXFS_EFFL2                  *((volatile unsigned char*)(0x42E01E88UL))
#define bFM4_CANFD_TXFS_EFFL3                  *((volatile unsigned char*)(0x42E01E8CUL))
#define bFM4_CANFD_TXFS_EFFL4                  *((volatile unsigned char*)(0x42E01E90UL))
#define bFM4_CANFD_TXFS_EFFL5                  *((volatile unsigned char*)(0x42E01E94UL))
#define bFM4_CANFD_TXFS_EFGI0                  *((volatile unsigned char*)(0x42E01EA0UL))
#define bFM4_CANFD_TXFS_EFGI1                  *((volatile unsigned char*)(0x42E01EA4UL))
#define bFM4_CANFD_TXFS_EFGI2                  *((volatile unsigned char*)(0x42E01EA8UL))
#define bFM4_CANFD_TXFS_EFGI3                  *((volatile unsigned char*)(0x42E01EACUL))
#define bFM4_CANFD_TXFS_EFGI4                  *((volatile unsigned char*)(0x42E01EB0UL))
#define bFM4_CANFD_TXFS_EFPI0                  *((volatile unsigned char*)(0x42E01EC0UL))
#define bFM4_CANFD_TXFS_EFPI1                  *((volatile unsigned char*)(0x42E01EC4UL))
#define bFM4_CANFD_TXFS_EFPI2                  *((volatile unsigned char*)(0x42E01EC8UL))
#define bFM4_CANFD_TXFS_EFPI3                  *((volatile unsigned char*)(0x42E01ECCUL))
#define bFM4_CANFD_TXFS_EFPI4                  *((volatile unsigned char*)(0x42E01ED0UL))
#define bFM4_CANFD_TXFS_EFF                    *((volatile unsigned char*)(0x42E01EE0UL))
#define bFM4_CANFD_TXFS_TEFL                   *((volatile unsigned char*)(0x42E01EE4UL))
#define bFM4_CANFD_TXFA_EFAI0                  *((volatile unsigned char*)(0x42E01F00UL))
#define bFM4_CANFD_TXFA_EFAI1                  *((volatile unsigned char*)(0x42E01F04UL))
#define bFM4_CANFD_TXFA_EFAI2                  *((volatile unsigned char*)(0x42E01F08UL))
#define bFM4_CANFD_TXFA_EFAI3                  *((volatile unsigned char*)(0x42E01F0CUL))
#define bFM4_CANFD_TXFA_EFAI4                  *((volatile unsigned char*)(0x42E01F10UL))
#define bFM4_CANFD_FDECR_SEIE                  *((volatile unsigned char*)(0x42E04000UL))
#define bFM4_CANFD_FDECR_DEIE                  *((volatile unsigned char*)(0x42E04004UL))
#define bFM4_CANFD_FDECR_CEREN                 *((volatile unsigned char*)(0x42E04008UL))
#define bFM4_CANFD_FDECR_CEIV                  *((volatile unsigned char*)(0x42E0400CUL))
#define bFM4_CANFD_FDESR_SEI                   *((volatile unsigned char*)(0x42E04020UL))
#define bFM4_CANFD_FDESR_DEI                   *((volatile unsigned char*)(0x42E04024UL))
#define bFM4_CANFD_FDSEAR_SRA0                 *((volatile unsigned char*)(0x42E04040UL))
#define bFM4_CANFD_FDSEAR_SRA1                 *((volatile unsigned char*)(0x42E04044UL))
#define bFM4_CANFD_FDSEAR_SRA2                 *((volatile unsigned char*)(0x42E04048UL))
#define bFM4_CANFD_FDSEAR_SRA3                 *((volatile unsigned char*)(0x42E0404CUL))
#define bFM4_CANFD_FDSEAR_SRA4                 *((volatile unsigned char*)(0x42E04050UL))
#define bFM4_CANFD_FDSEAR_SRA5                 *((volatile unsigned char*)(0x42E04054UL))
#define bFM4_CANFD_FDSEAR_SRA6                 *((volatile unsigned char*)(0x42E04058UL))
#define bFM4_CANFD_FDSEAR_SRA7                 *((volatile unsigned char*)(0x42E0405CUL))
#define bFM4_CANFD_FDSEAR_SRA8                 *((volatile unsigned char*)(0x42E04060UL))
#define bFM4_CANFD_FDSEAR_SRA9                 *((volatile unsigned char*)(0x42E04064UL))
#define bFM4_CANFD_FDSEAR_SRA10                *((volatile unsigned char*)(0x42E04068UL))
#define bFM4_CANFD_FDSEAR_SRA11                *((volatile unsigned char*)(0x42E0406CUL))
#define bFM4_CANFD_FDSEAR_SRA12                *((volatile unsigned char*)(0x42E04070UL))
#define bFM4_CANFD_FDSEAR_SRA13                *((volatile unsigned char*)(0x42E04074UL))
#define bFM4_CANFD_FDSEAR_SRA14                *((volatile unsigned char*)(0x42E04078UL))
#define bFM4_CANFD_FDSEAR_SRA15                *((volatile unsigned char*)(0x42E0407CUL))
#define bFM4_CANFD_FDESCR_SEIC                 *((volatile unsigned char*)(0x42E040A0UL))
#define bFM4_CANFD_FDESCR_DEIC                 *((volatile unsigned char*)(0x42E040A4UL))
#define bFM4_CANFD_FDDEAR_DRA0                 *((volatile unsigned char*)(0x42E040C0UL))
#define bFM4_CANFD_FDDEAR_DRA1                 *((volatile unsigned char*)(0x42E040C4UL))
#define bFM4_CANFD_FDDEAR_DRA2                 *((volatile unsigned char*)(0x42E040C8UL))
#define bFM4_CANFD_FDDEAR_DRA3                 *((volatile unsigned char*)(0x42E040CCUL))
#define bFM4_CANFD_FDDEAR_DRA4                 *((volatile unsigned char*)(0x42E040D0UL))
#define bFM4_CANFD_FDDEAR_DRA5                 *((volatile unsigned char*)(0x42E040D4UL))
#define bFM4_CANFD_FDDEAR_DRA6                 *((volatile unsigned char*)(0x42E040D8UL))
#define bFM4_CANFD_FDDEAR_DRA7                 *((volatile unsigned char*)(0x42E040DCUL))
#define bFM4_CANFD_FDDEAR_DRA8                 *((volatile unsigned char*)(0x42E040E0UL))
#define bFM4_CANFD_FDDEAR_DRA9                 *((volatile unsigned char*)(0x42E040E4UL))
#define bFM4_CANFD_FDDEAR_DRA10                *((volatile unsigned char*)(0x42E040E8UL))
#define bFM4_CANFD_FDDEAR_DRA11                *((volatile unsigned char*)(0x42E040ECUL))
#define bFM4_CANFD_FDDEAR_DRA12                *((volatile unsigned char*)(0x42E040F0UL))
#define bFM4_CANFD_FDDEAR_DRA13                *((volatile unsigned char*)(0x42E040F4UL))
#define bFM4_CANFD_FDDEAR_DRA14                *((volatile unsigned char*)(0x42E040F8UL))
#define bFM4_CANFD_FDDEAR_DRA15                *((volatile unsigned char*)(0x42E040FCUL))
#define bFM4_CANFD_TSCNTR_CCLR                 *((volatile unsigned char*)(0x42E04200UL))
#define bFM4_CANFD_TSMDR_CNTEN                 *((volatile unsigned char*)(0x42E04240UL))
#define bFM4_CANFD_TSDIVR_CDIV0                *((volatile unsigned char*)(0x42E04280UL))
#define bFM4_CANFD_TSDIVR_CDIV1                *((volatile unsigned char*)(0x42E04284UL))
#define bFM4_CANFD_TSDIVR_CDIV2                *((volatile unsigned char*)(0x42E04288UL))
#define bFM4_CANFD_TSDIVR_CDIV3                *((volatile unsigned char*)(0x42E0428CUL))
#define bFM4_CANFD_TSDIVR_CDIV4                *((volatile unsigned char*)(0x42E04290UL))
#define bFM4_CANFD_TSDIVR_CDIV5                *((volatile unsigned char*)(0x42E04294UL))
#define bFM4_CANFD_TSDIVR_CDIV6                *((volatile unsigned char*)(0x42E04298UL))
#define bFM4_CANFD_TSDIVR_CDIV7                *((volatile unsigned char*)(0x42E0429CUL))
#define bFM4_CANFD_TSDIVR_CDIV8                *((volatile unsigned char*)(0x42E042A0UL))
#define bFM4_CANFD_TSDIVR_CDIV9                *((volatile unsigned char*)(0x42E042A4UL))
#define bFM4_CANFD_TSDIVR_CDIV10               *((volatile unsigned char*)(0x42E042A8UL))
#define bFM4_CANFD_TSDIVR_CDIV11               *((volatile unsigned char*)(0x42E042ACUL))
#define bFM4_CANFD_TSDIVR_CDIV12               *((volatile unsigned char*)(0x42E042B0UL))
#define bFM4_CANFD_TSDIVR_CDIV13               *((volatile unsigned char*)(0x42E042B4UL))
#define bFM4_CANFD_TSDIVR_CDIV14               *((volatile unsigned char*)(0x42E042B8UL))
#define bFM4_CANFD_TSDIVR_CDIV15               *((volatile unsigned char*)(0x42E042BCUL))
#define bFM4_CANFD_TSCDTR_CNT0                 *((volatile unsigned char*)(0x42E04300UL))
#define bFM4_CANFD_TSCDTR_CNT1                 *((volatile unsigned char*)(0x42E04304UL))
#define bFM4_CANFD_TSCDTR_CNT2                 *((volatile unsigned char*)(0x42E04308UL))
#define bFM4_CANFD_TSCDTR_CNT3                 *((volatile unsigned char*)(0x42E0430CUL))
#define bFM4_CANFD_TSCDTR_CNT4                 *((volatile unsigned char*)(0x42E04310UL))
#define bFM4_CANFD_TSCDTR_CNT5                 *((volatile unsigned char*)(0x42E04314UL))
#define bFM4_CANFD_TSCDTR_CNT6                 *((volatile unsigned char*)(0x42E04318UL))
#define bFM4_CANFD_TSCDTR_CNT7                 *((volatile unsigned char*)(0x42E0431CUL))
#define bFM4_CANFD_TSCDTR_CNT8                 *((volatile unsigned char*)(0x42E04320UL))
#define bFM4_CANFD_TSCDTR_CNT9                 *((volatile unsigned char*)(0x42E04324UL))
#define bFM4_CANFD_TSCDTR_CNT10                *((volatile unsigned char*)(0x42E04328UL))
#define bFM4_CANFD_TSCDTR_CNT11                *((volatile unsigned char*)(0x42E0432CUL))
#define bFM4_CANFD_TSCDTR_CNT12                *((volatile unsigned char*)(0x42E04330UL))
#define bFM4_CANFD_TSCDTR_CNT13                *((volatile unsigned char*)(0x42E04334UL))
#define bFM4_CANFD_TSCDTR_CNT14                *((volatile unsigned char*)(0x42E04338UL))
#define bFM4_CANFD_TSCDTR_CNT15                *((volatile unsigned char*)(0x42E0433CUL))
#define bFM4_CANFD_TSCPCLR_CMP0                *((volatile unsigned char*)(0x42E04340UL))
#define bFM4_CANFD_TSCPCLR_CMP1                *((volatile unsigned char*)(0x42E04344UL))
#define bFM4_CANFD_TSCPCLR_CMP2                *((volatile unsigned char*)(0x42E04348UL))
#define bFM4_CANFD_TSCPCLR_CMP3                *((volatile unsigned char*)(0x42E0434CUL))
#define bFM4_CANFD_TSCPCLR_CMP4                *((volatile unsigned char*)(0x42E04350UL))
#define bFM4_CANFD_TSCPCLR_CMP5                *((volatile unsigned char*)(0x42E04354UL))
#define bFM4_CANFD_TSCPCLR_CMP6                *((volatile unsigned char*)(0x42E04358UL))
#define bFM4_CANFD_TSCPCLR_CMP7                *((volatile unsigned char*)(0x42E0435CUL))
#define bFM4_CANFD_TSCPCLR_CMP8                *((volatile unsigned char*)(0x42E04360UL))
#define bFM4_CANFD_TSCPCLR_CMP9                *((volatile unsigned char*)(0x42E04364UL))
#define bFM4_CANFD_TSCPCLR_CMP10               *((volatile unsigned char*)(0x42E04368UL))
#define bFM4_CANFD_TSCPCLR_CMP11               *((volatile unsigned char*)(0x42E0436CUL))
#define bFM4_CANFD_TSCPCLR_CMP12               *((volatile unsigned char*)(0x42E04370UL))
#define bFM4_CANFD_TSCPCLR_CMP13               *((volatile unsigned char*)(0x42E04374UL))
#define bFM4_CANFD_TSCPCLR_CMP14               *((volatile unsigned char*)(0x42E04378UL))
#define bFM4_CANFD_TSCPCLR_CMP15               *((volatile unsigned char*)(0x42E0437CUL))

/* Programable-CRC registers */
#define bFM4_PCRC_PRGCRC_CFG_CIRQCLR           *((volatile unsigned char*)(0x43000180UL))
#define bFM4_PCRC_PRGCRC_CFG_FO0               *((volatile unsigned char*)(0x430001A0UL))
#define bFM4_PCRC_PRGCRC_CFG_FO1               *((volatile unsigned char*)(0x430001A4UL))
#define bFM4_PCRC_PRGCRC_CFG_FI0               *((volatile unsigned char*)(0x430001A8UL))
#define bFM4_PCRC_PRGCRC_CFG_FI1               *((volatile unsigned char*)(0x430001ACUL))
#define bFM4_PCRC_PRGCRC_CFG_TEST0             *((volatile unsigned char*)(0x430001C0UL))
#define bFM4_PCRC_PRGCRC_CFG_TEST1             *((volatile unsigned char*)(0x430001C4UL))
#define bFM4_PCRC_PRGCRC_CFG_TEST2             *((volatile unsigned char*)(0x430001C8UL))
#define bFM4_PCRC_PRGCRC_CFG_TEST3             *((volatile unsigned char*)(0x430001CCUL))
#define bFM4_PCRC_PRGCRC_CFG_TEST4             *((volatile unsigned char*)(0x430001D0UL))
#define bFM4_PCRC_PRGCRC_CFG_TEST5             *((volatile unsigned char*)(0x430001D4UL))
#define bFM4_PCRC_PRGCRC_CFG_SZ0               *((volatile unsigned char*)(0x430001D8UL))
#define bFM4_PCRC_PRGCRC_CFG_SZ1               *((volatile unsigned char*)(0x430001DCUL))
#define bFM4_PCRC_PRGCRC_CFG_CIRQ              *((volatile unsigned char*)(0x430001E0UL))
#define bFM4_PCRC_PRGCRC_CFG_CIEN              *((volatile unsigned char*)(0x430001E4UL))
#define bFM4_PCRC_PRGCRC_CFG_CDEN              *((volatile unsigned char*)(0x430001E8UL))
#define bFM4_PCRC_PRGCRC_CFG_LOCK              *((volatile unsigned char*)(0x430001F0UL))

/* High-Speed Quad SPI registers */
#define bFM4_HSSPI_MCTRL_MEN                   *((volatile unsigned char*)(0x1242000000UL))
#define bFM4_HSSPI_MCTRL_CSEN                  *((volatile unsigned char*)(0x1242000004UL))
#define bFM4_HSSPI_MCTRL_MES                   *((volatile unsigned char*)(0x1242000010UL))
#define bFM4_HSSPI_MCTRL_SYNCON                *((volatile unsigned char*)(0x1242000014UL))
#define bFM4_HSSPI_PCC0_CPHA                   *((volatile unsigned char*)(0x1242000080UL))
#define bFM4_HSSPI_PCC0_CPOL                   *((volatile unsigned char*)(0x1242000084UL))
#define bFM4_HSSPI_PCC0_ACES                   *((volatile unsigned char*)(0x1242000088UL))
#define bFM4_HSSPI_PCC0_RTM                    *((volatile unsigned char*)(0x124200008CUL))
#define bFM4_HSSPI_PCC0_SSPOL                  *((volatile unsigned char*)(0x1242000090UL))
#define bFM4_HSSPI_PCC0_SS2CD0                 *((volatile unsigned char*)(0x1242000094UL))
#define bFM4_HSSPI_PCC0_SS2CD1                 *((volatile unsigned char*)(0x1242000098UL))
#define bFM4_HSSPI_PCC0_SDIR                   *((volatile unsigned char*)(0x124200009CUL))
#define bFM4_HSSPI_PCC0_SENDIAN                *((volatile unsigned char*)(0x12420000A0UL))
#define bFM4_HSSPI_PCC0_CDRS0                  *((volatile unsigned char*)(0x12420000A4UL))
#define bFM4_HSSPI_PCC0_CDRS1                  *((volatile unsigned char*)(0x12420000A8UL))
#define bFM4_HSSPI_PCC0_CDRS2                  *((volatile unsigned char*)(0x12420000ACUL))
#define bFM4_HSSPI_PCC0_CDRS3                  *((volatile unsigned char*)(0x12420000B0UL))
#define bFM4_HSSPI_PCC0_CDRS4                  *((volatile unsigned char*)(0x12420000B4UL))
#define bFM4_HSSPI_PCC0_CDRS5                  *((volatile unsigned char*)(0x12420000B8UL))
#define bFM4_HSSPI_PCC0_CDRS6                  *((volatile unsigned char*)(0x12420000BCUL))
#define bFM4_HSSPI_PCC0_SAFESYNC               *((volatile unsigned char*)(0x12420000C0UL))
#define bFM4_HSSPI_PCC0_WRDSEL0                *((volatile unsigned char*)(0x12420000C4UL))
#define bFM4_HSSPI_PCC0_WRDSEL1                *((volatile unsigned char*)(0x12420000C8UL))
#define bFM4_HSSPI_PCC0_WRDSEL2                *((volatile unsigned char*)(0x12420000CCUL))
#define bFM4_HSSPI_PCC0_WRDSEL3                *((volatile unsigned char*)(0x12420000D0UL))
#define bFM4_HSSPI_PCC0_RDDSEL0                *((volatile unsigned char*)(0x12420000D4UL))
#define bFM4_HSSPI_PCC0_RDDSEL1                *((volatile unsigned char*)(0x12420000D8UL))
#define bFM4_HSSPI_PCC1_CPHA                   *((volatile unsigned char*)(0x1242000100UL))
#define bFM4_HSSPI_PCC1_CPOL                   *((volatile unsigned char*)(0x1242000104UL))
#define bFM4_HSSPI_PCC1_ACES                   *((volatile unsigned char*)(0x1242000108UL))
#define bFM4_HSSPI_PCC1_RTM                    *((volatile unsigned char*)(0x124200010CUL))
#define bFM4_HSSPI_PCC1_SSPOL                  *((volatile unsigned char*)(0x1242000110UL))
#define bFM4_HSSPI_PCC1_SS2CD0                 *((volatile unsigned char*)(0x1242000114UL))
#define bFM4_HSSPI_PCC1_SS2CD1                 *((volatile unsigned char*)(0x1242000118UL))
#define bFM4_HSSPI_PCC1_SDIR                   *((volatile unsigned char*)(0x124200011CUL))
#define bFM4_HSSPI_PCC1_SENDIAN                *((volatile unsigned char*)(0x1242000120UL))
#define bFM4_HSSPI_PCC1_CDRS0                  *((volatile unsigned char*)(0x1242000124UL))
#define bFM4_HSSPI_PCC1_CDRS1                  *((volatile unsigned char*)(0x1242000128UL))
#define bFM4_HSSPI_PCC1_CDRS2                  *((volatile unsigned char*)(0x124200012CUL))
#define bFM4_HSSPI_PCC1_CDRS3                  *((volatile unsigned char*)(0x1242000130UL))
#define bFM4_HSSPI_PCC1_CDRS4                  *((volatile unsigned char*)(0x1242000134UL))
#define bFM4_HSSPI_PCC1_CDRS5                  *((volatile unsigned char*)(0x1242000138UL))
#define bFM4_HSSPI_PCC1_CDRS6                  *((volatile unsigned char*)(0x124200013CUL))
#define bFM4_HSSPI_PCC1_SAFESYNC               *((volatile unsigned char*)(0x1242000140UL))
#define bFM4_HSSPI_PCC1_WRDSEL0                *((volatile unsigned char*)(0x1242000144UL))
#define bFM4_HSSPI_PCC1_WRDSEL1                *((volatile unsigned char*)(0x1242000148UL))
#define bFM4_HSSPI_PCC1_WRDSEL2                *((volatile unsigned char*)(0x124200014CUL))
#define bFM4_HSSPI_PCC1_WRDSEL3                *((volatile unsigned char*)(0x1242000150UL))
#define bFM4_HSSPI_PCC1_RDDSEL0                *((volatile unsigned char*)(0x1242000154UL))
#define bFM4_HSSPI_PCC1_RDDSEL1                *((volatile unsigned char*)(0x1242000158UL))
#define bFM4_HSSPI_PCC2_CPHA                   *((volatile unsigned char*)(0x1242000180UL))
#define bFM4_HSSPI_PCC2_CPOL                   *((volatile unsigned char*)(0x1242000184UL))
#define bFM4_HSSPI_PCC2_ACES                   *((volatile unsigned char*)(0x1242000188UL))
#define bFM4_HSSPI_PCC2_RTM                    *((volatile unsigned char*)(0x124200018CUL))
#define bFM4_HSSPI_PCC2_SSPOL                  *((volatile unsigned char*)(0x1242000190UL))
#define bFM4_HSSPI_PCC2_SS2CD0                 *((volatile unsigned char*)(0x1242000194UL))
#define bFM4_HSSPI_PCC2_SS2CD1                 *((volatile unsigned char*)(0x1242000198UL))
#define bFM4_HSSPI_PCC2_SDIR                   *((volatile unsigned char*)(0x124200019CUL))
#define bFM4_HSSPI_PCC2_SENDIAN                *((volatile unsigned char*)(0x12420001A0UL))
#define bFM4_HSSPI_PCC2_CDRS0                  *((volatile unsigned char*)(0x12420001A4UL))
#define bFM4_HSSPI_PCC2_CDRS1                  *((volatile unsigned char*)(0x12420001A8UL))
#define bFM4_HSSPI_PCC2_CDRS2                  *((volatile unsigned char*)(0x12420001ACUL))
#define bFM4_HSSPI_PCC2_CDRS3                  *((volatile unsigned char*)(0x12420001B0UL))
#define bFM4_HSSPI_PCC2_CDRS4                  *((volatile unsigned char*)(0x12420001B4UL))
#define bFM4_HSSPI_PCC2_CDRS5                  *((volatile unsigned char*)(0x12420001B8UL))
#define bFM4_HSSPI_PCC2_CDRS6                  *((volatile unsigned char*)(0x12420001BCUL))
#define bFM4_HSSPI_PCC2_SAFESYNC               *((volatile unsigned char*)(0x12420001C0UL))
#define bFM4_HSSPI_PCC2_WRDSEL0                *((volatile unsigned char*)(0x12420001C4UL))
#define bFM4_HSSPI_PCC2_WRDSEL1                *((volatile unsigned char*)(0x12420001C8UL))
#define bFM4_HSSPI_PCC2_WRDSEL2                *((volatile unsigned char*)(0x12420001CCUL))
#define bFM4_HSSPI_PCC2_WRDSEL3                *((volatile unsigned char*)(0x12420001D0UL))
#define bFM4_HSSPI_PCC2_RDDSEL0                *((volatile unsigned char*)(0x12420001D4UL))
#define bFM4_HSSPI_PCC2_RDDSEL1                *((volatile unsigned char*)(0x12420001D8UL))
#define bFM4_HSSPI_PCC3_CPHA                   *((volatile unsigned char*)(0x1242000200UL))
#define bFM4_HSSPI_PCC3_CPOL                   *((volatile unsigned char*)(0x1242000204UL))
#define bFM4_HSSPI_PCC3_ACES                   *((volatile unsigned char*)(0x1242000208UL))
#define bFM4_HSSPI_PCC3_RTM                    *((volatile unsigned char*)(0x124200020CUL))
#define bFM4_HSSPI_PCC3_SSPOL                  *((volatile unsigned char*)(0x1242000210UL))
#define bFM4_HSSPI_PCC3_SS2CD0                 *((volatile unsigned char*)(0x1242000214UL))
#define bFM4_HSSPI_PCC3_SS2CD1                 *((volatile unsigned char*)(0x1242000218UL))
#define bFM4_HSSPI_PCC3_SDIR                   *((volatile unsigned char*)(0x124200021CUL))
#define bFM4_HSSPI_PCC3_SENDIAN                *((volatile unsigned char*)(0x1242000220UL))
#define bFM4_HSSPI_PCC3_CDRS0                  *((volatile unsigned char*)(0x1242000224UL))
#define bFM4_HSSPI_PCC3_CDRS1                  *((volatile unsigned char*)(0x1242000228UL))
#define bFM4_HSSPI_PCC3_CDRS2                  *((volatile unsigned char*)(0x124200022CUL))
#define bFM4_HSSPI_PCC3_CDRS3                  *((volatile unsigned char*)(0x1242000230UL))
#define bFM4_HSSPI_PCC3_CDRS4                  *((volatile unsigned char*)(0x1242000234UL))
#define bFM4_HSSPI_PCC3_CDRS5                  *((volatile unsigned char*)(0x1242000238UL))
#define bFM4_HSSPI_PCC3_CDRS6                  *((volatile unsigned char*)(0x124200023CUL))
#define bFM4_HSSPI_PCC3_SAFESYNC               *((volatile unsigned char*)(0x1242000240UL))
#define bFM4_HSSPI_PCC3_WRDSEL0                *((volatile unsigned char*)(0x1242000244UL))
#define bFM4_HSSPI_PCC3_WRDSEL1                *((volatile unsigned char*)(0x1242000248UL))
#define bFM4_HSSPI_PCC3_WRDSEL2                *((volatile unsigned char*)(0x124200024CUL))
#define bFM4_HSSPI_PCC3_WRDSEL3                *((volatile unsigned char*)(0x1242000250UL))
#define bFM4_HSSPI_PCC3_RDDSEL0                *((volatile unsigned char*)(0x1242000254UL))
#define bFM4_HSSPI_PCC3_RDDSEL1                *((volatile unsigned char*)(0x1242000258UL))
#define bFM4_HSSPI_TXF_TFFS                    *((volatile unsigned char*)(0x1242000280UL))
#define bFM4_HSSPI_TXF_TFES                    *((volatile unsigned char*)(0x1242000284UL))
#define bFM4_HSSPI_TXF_TFOS                    *((volatile unsigned char*)(0x1242000288UL))
#define bFM4_HSSPI_TXF_TFUS                    *((volatile unsigned char*)(0x124200028CUL))
#define bFM4_HSSPI_TXF_TFLETS                  *((volatile unsigned char*)(0x1242000290UL))
#define bFM4_HSSPI_TXF_TFMTS                   *((volatile unsigned char*)(0x1242000294UL))
#define bFM4_HSSPI_TXF_TSSRS                   *((volatile unsigned char*)(0x1242000298UL))
#define bFM4_HSSPI_TXE_TFFE                    *((volatile unsigned char*)(0x1242000300UL))
#define bFM4_HSSPI_TXE_TFEE                    *((volatile unsigned char*)(0x1242000304UL))
#define bFM4_HSSPI_TXE_TFOE                    *((volatile unsigned char*)(0x1242000308UL))
#define bFM4_HSSPI_TXE_TFUE                    *((volatile unsigned char*)(0x124200030CUL))
#define bFM4_HSSPI_TXE_TFLETE                  *((volatile unsigned char*)(0x1242000310UL))
#define bFM4_HSSPI_TXE_TFMTE                   *((volatile unsigned char*)(0x1242000314UL))
#define bFM4_HSSPI_TXE_TSSRE                   *((volatile unsigned char*)(0x1242000318UL))
#define bFM4_HSSPI_TXC_TFFC                    *((volatile unsigned char*)(0x1242000380UL))
#define bFM4_HSSPI_TXC_TFEC                    *((volatile unsigned char*)(0x1242000384UL))
#define bFM4_HSSPI_TXC_TFOC                    *((volatile unsigned char*)(0x1242000388UL))
#define bFM4_HSSPI_TXC_TFUC                    *((volatile unsigned char*)(0x124200038CUL))
#define bFM4_HSSPI_TXC_TFLETC                  *((volatile unsigned char*)(0x1242000390UL))
#define bFM4_HSSPI_TXC_TFMTC                   *((volatile unsigned char*)(0x1242000394UL))
#define bFM4_HSSPI_TXC_TSSRC                   *((volatile unsigned char*)(0x1242000398UL))
#define bFM4_HSSPI_RXF_RFFS                    *((volatile unsigned char*)(0x1242000400UL))
#define bFM4_HSSPI_RXF_RFES                    *((volatile unsigned char*)(0x1242000404UL))
#define bFM4_HSSPI_RXF_RFOS                    *((volatile unsigned char*)(0x1242000408UL))
#define bFM4_HSSPI_RXF_RFUS                    *((volatile unsigned char*)(0x124200040CUL))
#define bFM4_HSSPI_RXF_RFLETS                  *((volatile unsigned char*)(0x1242000410UL))
#define bFM4_HSSPI_RXF_RFMTS                   *((volatile unsigned char*)(0x1242000414UL))
#define bFM4_HSSPI_RXF_RSSRS                   *((volatile unsigned char*)(0x1242000418UL))
#define bFM4_HSSPI_RXE_RFFE                    *((volatile unsigned char*)(0x1242000480UL))
#define bFM4_HSSPI_RXE_RFEE                    *((volatile unsigned char*)(0x1242000484UL))
#define bFM4_HSSPI_RXE_RFOE                    *((volatile unsigned char*)(0x1242000488UL))
#define bFM4_HSSPI_RXE_RFUE                    *((volatile unsigned char*)(0x124200048CUL))
#define bFM4_HSSPI_RXE_RFLETE                  *((volatile unsigned char*)(0x1242000490UL))
#define bFM4_HSSPI_RXE_RFMTE                   *((volatile unsigned char*)(0x1242000494UL))
#define bFM4_HSSPI_RXE_RSSRE                   *((volatile unsigned char*)(0x1242000498UL))
#define bFM4_HSSPI_RXC_RFFC                    *((volatile unsigned char*)(0x1242000500UL))
#define bFM4_HSSPI_RXC_RFEC                    *((volatile unsigned char*)(0x1242000504UL))
#define bFM4_HSSPI_RXC_RFOC                    *((volatile unsigned char*)(0x1242000508UL))
#define bFM4_HSSPI_RXC_RFUC                    *((volatile unsigned char*)(0x124200050CUL))
#define bFM4_HSSPI_RXC_RFLETC                  *((volatile unsigned char*)(0x1242000510UL))
#define bFM4_HSSPI_RXC_RFMTC                   *((volatile unsigned char*)(0x1242000514UL))
#define bFM4_HSSPI_RXC_RSSRC                   *((volatile unsigned char*)(0x1242000518UL))
#define bFM4_HSSPI_FAULTF_UMAFS                *((volatile unsigned char*)(0x1242000580UL))
#define bFM4_HSSPI_FAULTF_WAFS                 *((volatile unsigned char*)(0x1242000584UL))
#define bFM4_HSSPI_FAULTF_PVFS                 *((volatile unsigned char*)(0x1242000588UL))
#define bFM4_HSSPI_FAULTF_DWCBSFS              *((volatile unsigned char*)(0x124200058CUL))
#define bFM4_HSSPI_FAULTF_DRCBSFS              *((volatile unsigned char*)(0x1242000590UL))
#define bFM4_HSSPI_FAULTC_UMAFC                *((volatile unsigned char*)(0x1242000600UL))
#define bFM4_HSSPI_FAULTC_WAFC                 *((volatile unsigned char*)(0x1242000604UL))
#define bFM4_HSSPI_FAULTC_PVFC                 *((volatile unsigned char*)(0x1242000608UL))
#define bFM4_HSSPI_FAULTC_DWCBSFC              *((volatile unsigned char*)(0x124200060CUL))
#define bFM4_HSSPI_FAULTC_DRCBSFC              *((volatile unsigned char*)(0x1242000610UL))
#define bFM4_HSSPI_DMCFG_SSDC                  *((volatile unsigned char*)(0x1242000684UL))
#define bFM4_HSSPI_DMDMAEN_RXDMAEN             *((volatile unsigned char*)(0x12420006A0UL))
#define bFM4_HSSPI_DMDMAEN_TXDMAEN             *((volatile unsigned char*)(0x12420006A4UL))
#define bFM4_HSSPI_DMSTART_START               *((volatile unsigned char*)(0x1242000700UL))
#define bFM4_HSSPI_DMSTOP_STOP                 *((volatile unsigned char*)(0x1242000720UL))
#define bFM4_HSSPI_DMPSEL_PSEL0                *((volatile unsigned char*)(0x1242000740UL))
#define bFM4_HSSPI_DMPSEL_PSEL1                *((volatile unsigned char*)(0x1242000744UL))
#define bFM4_HSSPI_DMTRP_TRP0                  *((volatile unsigned char*)(0x1242000760UL))
#define bFM4_HSSPI_DMTRP_TRP1                  *((volatile unsigned char*)(0x1242000764UL))
#define bFM4_HSSPI_DMTRP_TRP2                  *((volatile unsigned char*)(0x1242000768UL))
#define bFM4_HSSPI_DMTRP_TRP3                  *((volatile unsigned char*)(0x124200076CUL))
#define bFM4_HSSPI_DMSTATUS_RXACTIVE           *((volatile unsigned char*)(0x1242000800UL))
#define bFM4_HSSPI_DMSTATUS_TXACTIVE           *((volatile unsigned char*)(0x1242000804UL))
#define bFM4_HSSPI_DMSTATUS_RXFLEVEL0          *((volatile unsigned char*)(0x1242000820UL))
#define bFM4_HSSPI_DMSTATUS_RXFLEVEL1          *((volatile unsigned char*)(0x1242000824UL))
#define bFM4_HSSPI_DMSTATUS_RXFLEVEL2          *((volatile unsigned char*)(0x1242000828UL))
#define bFM4_HSSPI_DMSTATUS_RXFLEVEL3          *((volatile unsigned char*)(0x124200082CUL))
#define bFM4_HSSPI_DMSTATUS_RXFLEVEL4          *((volatile unsigned char*)(0x1242000830UL))
#define bFM4_HSSPI_DMSTATUS_TXFLEVEL0          *((volatile unsigned char*)(0x1242000840UL))
#define bFM4_HSSPI_DMSTATUS_TXFLEVEL1          *((volatile unsigned char*)(0x1242000844UL))
#define bFM4_HSSPI_DMSTATUS_TXFLEVEL2          *((volatile unsigned char*)(0x1242000848UL))
#define bFM4_HSSPI_DMSTATUS_TXFLEVEL3          *((volatile unsigned char*)(0x124200084CUL))
#define bFM4_HSSPI_DMSTATUS_TXFLEVEL4          *((volatile unsigned char*)(0x1242000850UL))
#define bFM4_HSSPI_FIFOCFG_RXFTH0              *((volatile unsigned char*)(0x1242000980UL))
#define bFM4_HSSPI_FIFOCFG_RXFTH1              *((volatile unsigned char*)(0x1242000984UL))
#define bFM4_HSSPI_FIFOCFG_RXFTH2              *((volatile unsigned char*)(0x1242000988UL))
#define bFM4_HSSPI_FIFOCFG_RXFTH3              *((volatile unsigned char*)(0x124200098CUL))
#define bFM4_HSSPI_FIFOCFG_TXFTH0              *((volatile unsigned char*)(0x1242000990UL))
#define bFM4_HSSPI_FIFOCFG_TXFTH1              *((volatile unsigned char*)(0x1242000994UL))
#define bFM4_HSSPI_FIFOCFG_TXFTH2              *((volatile unsigned char*)(0x1242000998UL))
#define bFM4_HSSPI_FIFOCFG_TXFTH3              *((volatile unsigned char*)(0x124200099CUL))
#define bFM4_HSSPI_FIFOCFG_FWIDTH0             *((volatile unsigned char*)(0x12420009A0UL))
#define bFM4_HSSPI_FIFOCFG_FWIDTH1             *((volatile unsigned char*)(0x12420009A4UL))
#define bFM4_HSSPI_FIFOCFG_TXCTRL              *((volatile unsigned char*)(0x12420009A8UL))
#define bFM4_HSSPI_FIFOCFG_RXFLSH              *((volatile unsigned char*)(0x12420009ACUL))
#define bFM4_HSSPI_FIFOCFG_TXFLSH              *((volatile unsigned char*)(0x12420009B0UL))
#define bFM4_HSSPI_CSCFG_SRAM                  *((volatile unsigned char*)(0x1242001A00UL))
#define bFM4_HSSPI_CSCFG_MBM0                  *((volatile unsigned char*)(0x1242001A04UL))
#define bFM4_HSSPI_CSCFG_MBM1                  *((volatile unsigned char*)(0x1242001A08UL))
#define bFM4_HSSPI_CSCFG_SSEL0EN               *((volatile unsigned char*)(0x1242001A20UL))
#define bFM4_HSSPI_CSCFG_SSEL1EN               *((volatile unsigned char*)(0x1242001A24UL))
#define bFM4_HSSPI_CSCFG_SSEL2EN               *((volatile unsigned char*)(0x1242001A28UL))
#define bFM4_HSSPI_CSCFG_SSEL3EN               *((volatile unsigned char*)(0x1242001A2CUL))
#define bFM4_HSSPI_CSCFG_MSEL0                 *((volatile unsigned char*)(0x1242001A40UL))
#define bFM4_HSSPI_CSCFG_MSEL1                 *((volatile unsigned char*)(0x1242001A44UL))
#define bFM4_HSSPI_CSCFG_MSEL2                 *((volatile unsigned char*)(0x1242001A48UL))
#define bFM4_HSSPI_CSCFG_MSEL3                 *((volatile unsigned char*)(0x1242001A4CUL))
#define bFM4_HSSPI_RDCSDC0_DEC                 *((volatile unsigned char*)(0x1242001B80UL))
#define bFM4_HSSPI_RDCSDC0_TRP0                *((volatile unsigned char*)(0x1242001B84UL))
#define bFM4_HSSPI_RDCSDC0_TRP1                *((volatile unsigned char*)(0x1242001B88UL))
#define bFM4_HSSPI_RDCSDC0_CONT                *((volatile unsigned char*)(0x1242001B8CUL))
#define bFM4_HSSPI_RDCSDC1_DEC                 *((volatile unsigned char*)(0x1242001BC0UL))
#define bFM4_HSSPI_RDCSDC1_TRP0                *((volatile unsigned char*)(0x1242001BC4UL))
#define bFM4_HSSPI_RDCSDC1_TRP1                *((volatile unsigned char*)(0x1242001BC8UL))
#define bFM4_HSSPI_RDCSDC1_CONT                *((volatile unsigned char*)(0x1242001BCCUL))
#define bFM4_HSSPI_RDCSDC2_DEC                 *((volatile unsigned char*)(0x1242001C00UL))
#define bFM4_HSSPI_RDCSDC2_TRP0                *((volatile unsigned char*)(0x1242001C04UL))
#define bFM4_HSSPI_RDCSDC2_TRP1                *((volatile unsigned char*)(0x1242001C08UL))
#define bFM4_HSSPI_RDCSDC2_CONT                *((volatile unsigned char*)(0x1242001C0CUL))
#define bFM4_HSSPI_RDCSDC3_DEC                 *((volatile unsigned char*)(0x1242001C40UL))
#define bFM4_HSSPI_RDCSDC3_TRP0                *((volatile unsigned char*)(0x1242001C44UL))
#define bFM4_HSSPI_RDCSDC3_TRP1                *((volatile unsigned char*)(0x1242001C48UL))
#define bFM4_HSSPI_RDCSDC3_CONT                *((volatile unsigned char*)(0x1242001C4CUL))
#define bFM4_HSSPI_RDCSDC4_DEC                 *((volatile unsigned char*)(0x1242001C80UL))
#define bFM4_HSSPI_RDCSDC4_TRP0                *((volatile unsigned char*)(0x1242001C84UL))
#define bFM4_HSSPI_RDCSDC4_TRP1                *((volatile unsigned char*)(0x1242001C88UL))
#define bFM4_HSSPI_RDCSDC4_CONT                *((volatile unsigned char*)(0x1242001C8CUL))
#define bFM4_HSSPI_RDCSDC5_DEC                 *((volatile unsigned char*)(0x1242001CC0UL))
#define bFM4_HSSPI_RDCSDC5_TRP0                *((volatile unsigned char*)(0x1242001CC4UL))
#define bFM4_HSSPI_RDCSDC5_TRP1                *((volatile unsigned char*)(0x1242001CC8UL))
#define bFM4_HSSPI_RDCSDC5_CONT                *((volatile unsigned char*)(0x1242001CCCUL))
#define bFM4_HSSPI_RDCSDC6_DEC                 *((volatile unsigned char*)(0x1242001D00UL))
#define bFM4_HSSPI_RDCSDC6_TRP0                *((volatile unsigned char*)(0x1242001D04UL))
#define bFM4_HSSPI_RDCSDC6_TRP1                *((volatile unsigned char*)(0x1242001D08UL))
#define bFM4_HSSPI_RDCSDC6_CONT                *((volatile unsigned char*)(0x1242001D0CUL))
#define bFM4_HSSPI_RDCSDC7_DEC                 *((volatile unsigned char*)(0x1242001D40UL))
#define bFM4_HSSPI_RDCSDC7_TRP0                *((volatile unsigned char*)(0x1242001D44UL))
#define bFM4_HSSPI_RDCSDC7_TRP1                *((volatile unsigned char*)(0x1242001D48UL))
#define bFM4_HSSPI_RDCSDC7_CONT                *((volatile unsigned char*)(0x1242001D4CUL))
#define bFM4_HSSPI_WRCSDC0_DEC                 *((volatile unsigned char*)(0x1242001D80UL))
#define bFM4_HSSPI_WRCSDC0_TRP0                *((volatile unsigned char*)(0x1242001D84UL))
#define bFM4_HSSPI_WRCSDC0_TRP1                *((volatile unsigned char*)(0x1242001D88UL))
#define bFM4_HSSPI_WRCSDC0_CONT                *((volatile unsigned char*)(0x1242001D8CUL))
#define bFM4_HSSPI_WRCSDC1_DEC                 *((volatile unsigned char*)(0x1242001DC0UL))
#define bFM4_HSSPI_WRCSDC1_TRP0                *((volatile unsigned char*)(0x1242001DC4UL))
#define bFM4_HSSPI_WRCSDC1_TRP1                *((volatile unsigned char*)(0x1242001DC8UL))
#define bFM4_HSSPI_WRCSDC1_CONT                *((volatile unsigned char*)(0x1242001DCCUL))
#define bFM4_HSSPI_WRCSDC2_DEC                 *((volatile unsigned char*)(0x1242001E00UL))
#define bFM4_HSSPI_WRCSDC2_TRP0                *((volatile unsigned char*)(0x1242001E04UL))
#define bFM4_HSSPI_WRCSDC2_TRP1                *((volatile unsigned char*)(0x1242001E08UL))
#define bFM4_HSSPI_WRCSDC2_CONT                *((volatile unsigned char*)(0x1242001E0CUL))
#define bFM4_HSSPI_WRCSDC3_DEC                 *((volatile unsigned char*)(0x1242001E40UL))
#define bFM4_HSSPI_WRCSDC3_TRP0                *((volatile unsigned char*)(0x1242001E44UL))
#define bFM4_HSSPI_WRCSDC3_TRP1                *((volatile unsigned char*)(0x1242001E48UL))
#define bFM4_HSSPI_WRCSDC3_CONT                *((volatile unsigned char*)(0x1242001E4CUL))
#define bFM4_HSSPI_WRCSDC4_DEC                 *((volatile unsigned char*)(0x1242001E80UL))
#define bFM4_HSSPI_WRCSDC4_TRP0                *((volatile unsigned char*)(0x1242001E84UL))
#define bFM4_HSSPI_WRCSDC4_TRP1                *((volatile unsigned char*)(0x1242001E88UL))
#define bFM4_HSSPI_WRCSDC4_CONT                *((volatile unsigned char*)(0x1242001E8CUL))
#define bFM4_HSSPI_WRCSDC5_DEC                 *((volatile unsigned char*)(0x1242001EC0UL))
#define bFM4_HSSPI_WRCSDC5_TRP0                *((volatile unsigned char*)(0x1242001EC4UL))
#define bFM4_HSSPI_WRCSDC5_TRP1                *((volatile unsigned char*)(0x1242001EC8UL))
#define bFM4_HSSPI_WRCSDC5_CONT                *((volatile unsigned char*)(0x1242001ECCUL))
#define bFM4_HSSPI_WRCSDC6_DEC                 *((volatile unsigned char*)(0x1242001F00UL))
#define bFM4_HSSPI_WRCSDC6_TRP0                *((volatile unsigned char*)(0x1242001F04UL))
#define bFM4_HSSPI_WRCSDC6_TRP1                *((volatile unsigned char*)(0x1242001F08UL))
#define bFM4_HSSPI_WRCSDC6_CONT                *((volatile unsigned char*)(0x1242001F0CUL))
#define bFM4_HSSPI_WRCSDC7_DEC                 *((volatile unsigned char*)(0x1242001F40UL))
#define bFM4_HSSPI_WRCSDC7_TRP0                *((volatile unsigned char*)(0x1242001F44UL))
#define bFM4_HSSPI_WRCSDC7_TRP1                *((volatile unsigned char*)(0x1242001F48UL))
#define bFM4_HSSPI_WRCSDC7_CONT                *((volatile unsigned char*)(0x1242001F4CUL))
#define bFM4_HSSPI_DBCNT_RXDBEN                *((volatile unsigned char*)(0x1242008080UL))
#define bFM4_HSSPI_DBCNT_TXDBEN                *((volatile unsigned char*)(0x1242008084UL))

/******************************************************************************
 * Peripheral memory map
 ******************************************************************************/
#define FM_FLASH_BASE        (0x00000000UL)                 /* Flash Base                             */
#define FM_PERIPH_BASE       (0x40000000UL)                 /* Peripheral  Base                       */
#define FM_HSQSPI_BASE       (0xD0000000UL)                 /* High-Speed Quad SPI Base               */
#define FM_CM3_BASE          (0xE0100000UL)                 /* CM3 Private                            */

#define FM_FLASH_IF_BASE     (FM_PERIPH_BASE + 0x00000UL)  /* Flash interface registers              */
#define FM_UNIQUE_ID_BASE    (FM_PERIPH_BASE + 0x00200UL)  /* Unique ID registers                    */
#define FM_ECC_CAPTURE_BASE  (FM_PERIPH_BASE + 0x00300UL)  /* ECC Capture address registers          */
#define FM_DUALFLASH_IF_BASE (FM_PERIPH_BASE + 0x00400UL)  /* Dual Flash interface registers         */
#define FM_CRG_BASE          (FM_PERIPH_BASE + 0x10000UL)  /* Clock and reset registers              */
#define FM_HWWDT_BASE        (FM_PERIPH_BASE + 0x11000UL)  /* Hardware watchdog registers            */
#define FM_SWWDT_BASE        (FM_PERIPH_BASE + 0x12000UL)  /* Software watchdog registers            */
#define FM_DTIM_BASE         (FM_PERIPH_BASE + 0x15000UL)  /* Dual timer 1/2 registers               */
#define FM_MFT0_FRT_BASE     (FM_PERIPH_BASE + 0x20100UL)  /* Multifunction Timer unit 0 Free Running Timer registers */
#define FM_MFT0_OCU_BASE     (FM_PERIPH_BASE + 0x20100UL)  /* Multifunction Timer unit 0 Output Compare Unit registers */
#define FM_MFT0_WFG_BASE     (FM_PERIPH_BASE + 0x20100UL)  /* Multifunction Timer unit 0 Waveform Generator and Noise Canceler registers */
#define FM_MFT0_ICU_BASE     (FM_PERIPH_BASE + 0x20100UL)  /* Multifunction Timer unit 0 Input Capture Unit registers */
#define FM_MFT0_ADCMP_BASE   (FM_PERIPH_BASE + 0x20100UL)  /* Multifunction Timer unit 0 ADC Start Compare Unit registers */
#define FM_MFT1_FRT_BASE     (FM_PERIPH_BASE + 0x21100UL)  /* Multifunction Timer unit 1 Free Running Timer registers */
#define FM_MFT1_OCU_BASE     (FM_PERIPH_BASE + 0x21100UL)  /* Multifunction Timer unit 1 Output Compare Unit registers */
#define FM_MFT1_WFG_BASE     (FM_PERIPH_BASE + 0x21100UL)  /* Multifunction Timer unit 1 Waveform Generator and Noise Canceler registers */
#define FM_MFT1_ICU_BASE     (FM_PERIPH_BASE + 0x21100UL)  /* Multifunction Timer unit 1 Input Capture Unit registers */
#define FM_MFT1_ADCMP_BASE   (FM_PERIPH_BASE + 0x21100UL)  /* Multifunction Timer unit 1 ADC Start Compare Unit registers */
#define FM_MFT2_FRT_BASE     (FM_PERIPH_BASE + 0x22100UL)  /* Multifunction Timer unit 2 Free Running Timer registers */
#define FM_MFT2_OCU_BASE     (FM_PERIPH_BASE + 0x22100UL)  /* Multifunction Timer unit 2 Output Compare Unit registers */
#define FM_MFT2_WFG_BASE     (FM_PERIPH_BASE + 0x22100UL)  /* Multifunction Timer unit 2 Waveform Generator and Noise Canceler registers */
#define FM_MFT2_ICU_BASE     (FM_PERIPH_BASE + 0x22100UL)  /* Multifunction Timer unit 2 Input Capture Unit registers */
#define FM_MFT2_ADCMP_BASE   (FM_PERIPH_BASE + 0x22100UL)  /* Multifunction Timer unit 2 ADC Start Compare Unit registers */
#define FM_MFT_PPG_BASE      (FM_PERIPH_BASE + 0x24000UL)  /* Multifunction Timer PPG registers      */
#define FM_BT0_PPG_BASE      (FM_PERIPH_BASE + 0x25000UL)  /* Base Timer 0 PPG registers             */
#define FM_BT0_PWM_BASE      (FM_PERIPH_BASE + 0x25000UL)  /* Base Timer 0 PWM registers             */
#define FM_BT0_RT_BASE       (FM_PERIPH_BASE + 0x25000UL)  /* Base Timer 0 RT registers              */
#define FM_BT0_PWC_BASE      (FM_PERIPH_BASE + 0x25000UL)  /* Base Timer 0 PWC registers             */
#define FM_BT1_PPG_BASE      (FM_PERIPH_BASE + 0x25040UL)  /* Base Timer 1 PPG registers             */
#define FM_BT1_PWM_BASE      (FM_PERIPH_BASE + 0x25040UL)  /* Base Timer 1 PWM registers             */
#define FM_BT1_RT_BASE       (FM_PERIPH_BASE + 0x25040UL)  /* Base Timer 1 RT registers              */
#define FM_BT1_PWC_BASE      (FM_PERIPH_BASE + 0x25040UL)  /* Base Timer 1 PWC registers             */
#define FM_BT2_PPG_BASE      (FM_PERIPH_BASE + 0x25080UL)  /* Base Timer 2 PPG registers             */
#define FM_BT2_PWM_BASE      (FM_PERIPH_BASE + 0x25080UL)  /* Base Timer 2 PWM registers             */
#define FM_BT2_RT_BASE       (FM_PERIPH_BASE + 0x25080UL)  /* Base Timer 2 RT registers              */
#define FM_BT2_PWC_BASE      (FM_PERIPH_BASE + 0x25080UL)  /* Base Timer 2 PWC registers             */
#define FM_BT3_PPG_BASE      (FM_PERIPH_BASE + 0x250C0UL)  /* Base Timer 3 PPG registers             */
#define FM_BT3_PWM_BASE      (FM_PERIPH_BASE + 0x250C0UL)  /* Base Timer 3 PWM registers             */
#define FM_BT3_RT_BASE       (FM_PERIPH_BASE + 0x250C0UL)  /* Base Timer 3 RT registers              */
#define FM_BT3_PWC_BASE      (FM_PERIPH_BASE + 0x250C0UL)  /* Base Timer 3 PWC registers             */
#define FM_BT4_PPG_BASE      (FM_PERIPH_BASE + 0x25200UL)  /* Base Timer 4 PPG registers             */
#define FM_BT4_PWM_BASE      (FM_PERIPH_BASE + 0x25200UL)  /* Base Timer 4 PWM registers             */
#define FM_BT4_RT_BASE       (FM_PERIPH_BASE + 0x25200UL)  /* Base Timer 4 RT registers              */
#define FM_BT4_PWC_BASE      (FM_PERIPH_BASE + 0x25200UL)  /* Base Timer 4 PWC registers             */
#define FM_BT5_PPG_BASE      (FM_PERIPH_BASE + 0x25240UL)  /* Base Timer 5 PPG registers             */
#define FM_BT5_PWM_BASE      (FM_PERIPH_BASE + 0x25240UL)  /* Base Timer 5 PWM registers             */
#define FM_BT5_RT_BASE       (FM_PERIPH_BASE + 0x25240UL)  /* Base Timer 5 RT registers              */
#define FM_BT5_PWC_BASE      (FM_PERIPH_BASE + 0x25240UL)  /* Base Timer 5 PWC registers             */
#define FM_BT6_PPG_BASE      (FM_PERIPH_BASE + 0x25280UL)  /* Base Timer 6 PPG registers             */
#define FM_BT6_PWM_BASE      (FM_PERIPH_BASE + 0x25280UL)  /* Base Timer 6 PWM registers             */
#define FM_BT6_RT_BASE       (FM_PERIPH_BASE + 0x25280UL)  /* Base Timer 6 RT registers              */
#define FM_BT6_PWC_BASE      (FM_PERIPH_BASE + 0x25280UL)  /* Base Timer 6 PWC registers             */
#define FM_BT7_PPG_BASE      (FM_PERIPH_BASE + 0x252C0UL)  /* Base Timer 7 PPG registers             */
#define FM_BT7_PWM_BASE      (FM_PERIPH_BASE + 0x252C0UL)  /* Base Timer 7 PWM registers             */
#define FM_BT7_RT_BASE       (FM_PERIPH_BASE + 0x252C0UL)  /* Base Timer 7 RT registers              */
#define FM_BT7_PWC_BASE      (FM_PERIPH_BASE + 0x252C0UL)  /* Base Timer 7 PWC registers             */
#define FM_BTIOSEL03_BASE    (FM_PERIPH_BASE + 0x25100UL)  /* Base Timer I/O selector channel 0 - channel 3 registers */
#define FM_BTIOSEL47_BASE    (FM_PERIPH_BASE + 0x25300UL)  /* Base Timer I/O selector channel 4 - channel 7 registers */
#define FM_BT8_PPG_BASE      (FM_PERIPH_BASE + 0x25400UL)  /* Base Timer 8 PPG registers             */
#define FM_BT8_PWM_BASE      (FM_PERIPH_BASE + 0x25400UL)  /* Base Timer 8 PWM registers             */
#define FM_BT8_RT_BASE       (FM_PERIPH_BASE + 0x25400UL)  /* Base Timer 8 RT registers              */
#define FM_BT8_PWC_BASE      (FM_PERIPH_BASE + 0x25400UL)  /* Base Timer 8 PWC registers             */
#define FM_BT9_PPG_BASE      (FM_PERIPH_BASE + 0x25440UL)  /* Base Timer 9 PPG registers             */
#define FM_BT9_PWM_BASE      (FM_PERIPH_BASE + 0x25440UL)  /* Base Timer 9 PWM registers             */
#define FM_BT9_RT_BASE       (FM_PERIPH_BASE + 0x25440UL)  /* Base Timer 9 RT registers              */
#define FM_BT9_PWC_BASE      (FM_PERIPH_BASE + 0x25440UL)  /* Base Timer 9 PWC registers             */
#define FM_BT10_PPG_BASE     (FM_PERIPH_BASE + 0x25480UL)  /* Base Timer 10 PPG registers            */
#define FM_BT10_PWM_BASE     (FM_PERIPH_BASE + 0x25480UL)  /* Base Timer 10 PWM registers            */
#define FM_BT10_RT_BASE      (FM_PERIPH_BASE + 0x25480UL)  /* Base Timer 10 RT registers             */
#define FM_BT10_PWC_BASE     (FM_PERIPH_BASE + 0x25480UL)  /* Base Timer 10 PWC registers            */
#define FM_BT11_PPG_BASE     (FM_PERIPH_BASE + 0x254C0UL)  /* Base Timer 11 PPG registers            */
#define FM_BT11_PWM_BASE     (FM_PERIPH_BASE + 0x254C0UL)  /* Base Timer 11 PWM registers            */
#define FM_BT11_RT_BASE      (FM_PERIPH_BASE + 0x254C0UL)  /* Base Timer 11 RT registers             */
#define FM_BT11_PWC_BASE     (FM_PERIPH_BASE + 0x254C0UL)  /* Base Timer 11 PWC registers            */
#define FM_BT12_PPG_BASE     (FM_PERIPH_BASE + 0x25600UL)  /* Base Timer 8 PPG registers             */
#define FM_BT12_PWM_BASE     (FM_PERIPH_BASE + 0x25600UL)  /* Base Timer 8 PWM registers             */
#define FM_BT12_RT_BASE      (FM_PERIPH_BASE + 0x25600UL)  /* Base Timer 8 RT registers              */
#define FM_BT12_PWC_BASE     (FM_PERIPH_BASE + 0x25600UL)  /* Base Timer 8 PWC registers             */
#define FM_BT13_PPG_BASE     (FM_PERIPH_BASE + 0x25640UL)  /* Base Timer 9 PPG registers             */
#define FM_BT13_PWM_BASE     (FM_PERIPH_BASE + 0x25640UL)  /* Base Timer 9 PWM registers             */
#define FM_BT13_RT_BASE      (FM_PERIPH_BASE + 0x25640UL)  /* Base Timer 9 RT registers              */
#define FM_BT13_PWC_BASE     (FM_PERIPH_BASE + 0x25640UL)  /* Base Timer 9 PWC registers             */
#define FM_BT14_PPG_BASE     (FM_PERIPH_BASE + 0x25680UL)  /* Base Timer 10 PPG registers            */
#define FM_BT14_PWM_BASE     (FM_PERIPH_BASE + 0x25680UL)  /* Base Timer 10 PWM registers            */
#define FM_BT14_RT_BASE      (FM_PERIPH_BASE + 0x25680UL)  /* Base Timer 10 RT registers             */
#define FM_BT14_PWC_BASE     (FM_PERIPH_BASE + 0x25680UL)  /* Base Timer 10 PWC registers            */
#define FM_BT15_PPG_BASE     (FM_PERIPH_BASE + 0x256C0UL)  /* Base Timer 11 PPG registers            */
#define FM_BT15_PWM_BASE     (FM_PERIPH_BASE + 0x256C0UL)  /* Base Timer 11 PWM registers            */
#define FM_BT15_RT_BASE      (FM_PERIPH_BASE + 0x256C0UL)  /* Base Timer 11 RT registers             */
#define FM_BT15_PWC_BASE     (FM_PERIPH_BASE + 0x256C0UL)  /* Base Timer 11 PWC registers            */
#define FM_BTIOSEL8B_BASE    (FM_PERIPH_BASE + 0x25500UL)  /* Base Timer I/O selector channel 8 - channel 11 registers */
#define FM_BTIOSELCF_BASE    (FM_PERIPH_BASE + 0x25700UL)  /* Base Timer I/O selector channel 12 - channel 15 registers */
#define FM_SBSSR_BASE        (FM_PERIPH_BASE + 0x25FFCUL)  /* Software based Simulation Startup (Base Timer) register */
#define FM_QPRC0_BASE        (FM_PERIPH_BASE + 0x26000UL)  /* Quad position and revolution counter channel 0 registers */
#define FM_QPRC1_BASE        (FM_PERIPH_BASE + 0x26040UL)  /* Quad position and revolution counter channel 1 registers */
#define FM_QPRC2_BASE        (FM_PERIPH_BASE + 0x26080UL)  /* Quad position and revolution counter channel 2 registers */
#define FM_QPRC3_BASE        (FM_PERIPH_BASE + 0x260C0UL)  /* Quad position and revolution counter channel 3 registers */
#define FM_QPRC0_NF_BASE     (FM_PERIPH_BASE + 0x26100UL)  /* Quad position and revolution counter channel 0 noise filter registers */
#define FM_QPRC1_NF_BASE     (FM_PERIPH_BASE + 0x26110UL)  /* Quad position and revolution counter channel 0 noise filter registers */
#define FM_QPRC2_NF_BASE     (FM_PERIPH_BASE + 0x26120UL)  /* Quad position and revolution counter channel 0 noise filter registers */
#define FM_QPRC3_NF_BASE     (FM_PERIPH_BASE + 0x26130UL)  /* Quad position and revolution counter channel 0 noise filter registers */
#define FM_ADC0_BASE         (FM_PERIPH_BASE + 0x27000UL)  /* 12-bit ADC unit 0 registers            */
#define FM_ADC1_BASE         (FM_PERIPH_BASE + 0x27100UL)  /* 12-bit ADC unit 1 registers            */
#define FM_ADC2_BASE         (FM_PERIPH_BASE + 0x27200UL)  /* 12-bit ADC unit 2 registers            */
#define FM_DAC0_BASE         (FM_PERIPH_BASE + 0x33000UL)  /* 12-bit DAC uint 0 registers            */
#define FM_DAC1_BASE         (FM_PERIPH_BASE + 0x33008UL)  /* 12-bit DAC uint 1 registers            */
#define FM_CRTRIM_BASE       (FM_PERIPH_BASE + 0x2E000UL)  /* CR trimming registers                  */
#define FM_EXTI_BASE         (FM_PERIPH_BASE + 0x30000UL)  /* External interrupt registers           */
#define FM_INTREQ_BASE       (FM_PERIPH_BASE + 0x31000UL)  /* Interrupt request read registers       */
#define FM_IRQSEL_BASE       (FM_PERIPH_BASE + 0x31110UL)  /* Interrupt Selector                     */
#define FM_HDMICEC0_BASE     (FM_PERIPH_BASE + 0x34000UL)  /* HDMI-CEC ch.0 registers                */
#define FM_HDMICEC1_BASE     (FM_PERIPH_BASE + 0x34100UL)  /* HDMI-CEC ch.1 registers                */
#define FM_GPIO_BASE         (FM_PERIPH_BASE + 0x6F000UL)  /* General purpose I/O registers          */
#define FM_LVD_BASE          (FM_PERIPH_BASE + 0x35000UL)  /* Low voltage detection registers        */
#define FM_DS_BASE           (FM_PERIPH_BASE + 0x35100UL)  /* Deep standby mode registers            */
#define FM_USBETHERNETCLK_BASE (FM_PERIPH_BASE + 0x36000UL)  /* USB & Ethernet clock registers       */
#define FM_CANPRES_BASE      (FM_PERIPH_BASE + 0x37000UL)  /* CAN prescaler register                 */
#define FM_MFS0_BASE         (FM_PERIPH_BASE + 0x38000UL)  /* MFS channel 0 registers                */
#define FM_MFS1_BASE         (FM_PERIPH_BASE + 0x38100UL)  /* MFS channel 1 registers                */
#define FM_MFS2_BASE         (FM_PERIPH_BASE + 0x38200UL)  /* MFS channel 2 registers                */
#define FM_MFS3_BASE         (FM_PERIPH_BASE + 0x38300UL)  /* MFS channel 3 registers                */
#define FM_MFS4_BASE         (FM_PERIPH_BASE + 0x38400UL)  /* MFS channel 4 registers                */
#define FM_MFS5_BASE         (FM_PERIPH_BASE + 0x38500UL)  /* MFS channel 5 registers                */
#define FM_MFS6_BASE         (FM_PERIPH_BASE + 0x38600UL)  /* MFS channel 6 registers                */
#define FM_MFS7_BASE         (FM_PERIPH_BASE + 0x38700UL)  /* MFS channel 7 registers                */
#define FM_MFS8_BASE         (FM_PERIPH_BASE + 0x38800UL)  /* MFS channel 8 registers                */
#define FM_MFS9_BASE         (FM_PERIPH_BASE + 0x38900UL)  /* MFS channel 9 registers                */
#define FM_MFS10_BASE        (FM_PERIPH_BASE + 0x38A00UL)  /* MFS channel 10 registers               */
#define FM_MFS11_BASE        (FM_PERIPH_BASE + 0x38B00UL)  /* MFS channel 11 registers               */
#define FM_MFS12_BASE        (FM_PERIPH_BASE + 0x38C00UL)  /* MFS channel 12 registers               */
#define FM_MFS13_BASE        (FM_PERIPH_BASE + 0x38D00UL)  /* MFS channel 13 registers               */
#define FM_MFS14_BASE        (FM_PERIPH_BASE + 0x38E00UL)  /* MFS channel 14 registers               */
#define FM_MFS15_BASE        (FM_PERIPH_BASE + 0x38F00UL)  /* MFS channel 15 registers               */
#define FM_MFS_NFC_BASE      (FM_PERIPH_BASE + 0x38FFFF0)  /* JUST A RANDOM ADDRESS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
#define FM_CRC_BASE          (FM_PERIPH_BASE + 0x39000UL)  /* CRC registers                          */
#define FM_WC_BASE           (FM_PERIPH_BASE + 0x3A000UL)  /* Watch counter registers                */
#define FM_RTC_BASE          (FM_PERIPH_BASE + 0x3B100UL)  /* RTC registers                          */
#define FM_LCR_BASE          (FM_PERIPH_BASE + 0x3C000UL)  /* Low-speed CR prescaler registers       */
#define FM_CLK_GATING_BASE   (FM_PERIPH_BASE + 0x3C100UL)  /* Peripheral Clock Gating registers      */
#define FM_PLL_CONTROL_BASE  (FM_PERIPH_BASE + 0x3C800UL)  /* Main PLL Control registers             */
#define FM_I2SPRE_BASE       (FM_PERIPH_BASE + 0x3D000UL)  /* I2S Pre-scalor registers               */
#define FM_EXBUS_BASE        (FM_PERIPH_BASE + 0x3F000UL)  /* External bus interface registers       */
#define FM_USB0_BASE         (FM_PERIPH_BASE + 0x42100UL)  /* USB channel 0 registers                */
#define FM_USB1_BASE         (FM_PERIPH_BASE + 0x52100UL)  /* USB channel 0 registers                */
#define FM_DMAC_BASE         (FM_PERIPH_BASE + 0x60000UL)  /* DMA controller                         */
#define FM_DSTC_BASE         (FM_PERIPH_BASE + 0x61000UL)  /* DSTC controller                        */
#define FM_CAN0_BASE         (FM_PERIPH_BASE + 0x62000UL)  /* CAN channel 0 registers                */
#define FM_CAN1_BASE         (FM_PERIPH_BASE + 0x63000UL)  /* CAN channel 1 registers                */
#define FM_ETHERNET_MAC0_BASE    (FM_PERIPH_BASE + 0x64000UL) /* Ethernet MAC 0 registers            */
#define FM_ETHERNET_CONTROL_BASE (FM_PERIPH_BASE + 0x66000UL) /* Ethernet MAC control registers      */
#define FM_I2S0_BASE         (FM_PERIPH_BASE + 0x6C000UL)  /* I2S interface ch.0 registers           */
#define FM_SDIF_BASE         (FM_PERIPH_BASE + 0x6E000UL)  /* SDIF registers                         */
#define FM_CANFD_BASE        (FM_PERIPH_BASE + 0x70000UL)  /* CAN FD registers                       */
#define FM_PCRC_BASE         (FM_PERIPH_BASE + 0x80000UL)  /* Programable-CRC registers              */
#define FM_HSSPI_BASE        (FM_HSQSPI_BASE + 0x00000UL)  /* High-Speed Quad SPI registers          */

/******************************************************************************
 * Peripheral declaration
 ******************************************************************************/
#define FM_FLASH_IF    ((FM_FLASH_IF_TypeDef *)FM_FLASH_IF_BASE)
#define FM_UNIQUE_ID   ((FM_UNIQUE_ID_TypeDef *)FM_UNIQUE_ID_BASE)
#define FM_ECC_CAPTURE ((FM_ECC_CAPTURE_TypeDef *)FM_ECC_CAPTURE_BASE)
#define FM_DUALFLASH_IF ((FM_DUALFLASH_IF_TypeDef *)FM_DUALFLASH_IF_BASE)
#define FM_CRG         ((FM_CRG_TypeDef *)FM_CRG_BASE)
#define FM_HWWDT       ((FM_HWWDT_TypeDef *)FM_HWWDT_BASE)
#define FM_SWWDT       ((FM_SWWDT_TypeDef *)FM_SWWDT_BASE)
#define FM_DTIM        ((FM_DTIM_TypeDef *)FM_DTIM_BASE)
#define FM_MFT0_FRT    ((FM_MFT_FRT_TypeDef *)FM_MFT0_FRT_BASE)
#define FM_MFT0_OCU    ((FM_MFT_OCU_TypeDef *)FM_MFT0_OCU_BASE)
#define FM_MFT0_WFG    ((FM_MFT_WFG_TypeDef *)FM_MFT0_WFG_BASE)
#define FM_MFT0_ICU    ((FM_MFT_ICU_TypeDef *)FM_MFT0_ICU_BASE)
#define FM_MFT0_ADCMP  ((FM_MFT_ADCMP_TypeDef *)FM_MFT0_ADCMP_BASE)
#define FM_MFT1_FRT    ((FM_MFT_FRT_TypeDef *)FM_MFT1_FRT_BASE)
#define FM_MFT1_OCU    ((FM_MFT_OCU_TypeDef *)FM_MFT1_OCU_BASE)
#define FM_MFT1_WFG    ((FM_MFT_WFG_TypeDef *)FM_MFT1_WFG_BASE)
#define FM_MFT1_ICU    ((FM_MFT_ICU_TypeDef *)FM_MFT1_ICU_BASE)
#define FM_MFT1_ADCMP  ((FM_MFT_ADCMP_TypeDef *)FM_MFT1_ADCMP_BASE)
#define FM_MFT2_FRT    ((FM_MFT_FRT_TypeDef *)FM_MFT2_FRT_BASE)
#define FM_MFT2_OCU    ((FM_MFT_OCU_TypeDef *)FM_MFT2_OCU_BASE)
#define FM_MFT2_WFG    ((FM_MFT_WFG_TypeDef *)FM_MFT2_WFG_BASE)
#define FM_MFT2_ICU    ((FM_MFT_ICU_TypeDef *)FM_MFT2_ICU_BASE)
#define FM_MFT2_ADCMP  ((FM_MFT_ADCMP_TypeDef *)FM_MFT2_ADCMP_BASE)
#define FM_MFT_PPG     ((FM_MFT_PPG_TypeDef *)FM_MFT_PPG_BASE)
#define FM_BT0_PPG     ((FM_BT_PPG_TypeDef *)FM_BT0_PPG_BASE)
#define FM_BT0_PWM     ((FM_BT_PWM_TypeDef *)FM_BT0_PWM_BASE)
#define FM_BT0_RT      ((FM_BT_RT_TypeDef *)FM_BT0_RT_BASE)
#define FM_BT0_PWC     ((FM_BT_PWC_TypeDef *)FM_BT0_PWC_BASE)
#define FM_BT1_PPG     ((FM_BT_PPG_TypeDef *)FM_BT1_PPG_BASE)
#define FM_BT1_PWM     ((FM_BT_PWM_TypeDef *)FM_BT1_PWM_BASE)
#define FM_BT1_RT      ((FM_BT_RT_TypeDef *)FM_BT1_RT_BASE)
#define FM_BT1_PWC     ((FM_BT_PWC_TypeDef *)FM_BT1_PWC_BASE)
#define FM_BT2_PPG     ((FM_BT_PPG_TypeDef *)FM_BT2_PPG_BASE)
#define FM_BT2_PWM     ((FM_BT_PWM_TypeDef *)FM_BT2_PWM_BASE)
#define FM_BT2_RT      ((FM_BT_RT_TypeDef *)FM_BT2_RT_BASE)
#define FM_BT2_PWC     ((FM_BT_PWC_TypeDef *)FM_BT2_PWC_BASE)
#define FM_BT3_PPG     ((FM_BT_PPG_TypeDef *)FM_BT3_PPG_BASE)
#define FM_BT3_PWM     ((FM_BT_PWM_TypeDef *)FM_BT3_PWM_BASE)
#define FM_BT3_RT      ((FM_BT_RT_TypeDef *)FM_BT3_RT_BASE)
#define FM_BT3_PWC     ((FM_BT_PWC_TypeDef *)FM_BT3_PWC_BASE)
#define FM_BT4_PPG     ((FM_BT_PPG_TypeDef *)FM_BT4_PPG_BASE)
#define FM_BT4_PWM     ((FM_BT_PWM_TypeDef *)FM_BT4_PWM_BASE)
#define FM_BT4_RT      ((FM_BT_RT_TypeDef *)FM_BT4_RT_BASE)
#define FM_BT4_PWC     ((FM_BT_PWC_TypeDef *)FM_BT4_PWC_BASE)
#define FM_BT5_PPG     ((FM_BT_PPG_TypeDef *)FM_BT5_PPG_BASE)
#define FM_BT5_PWM     ((FM_BT_PWM_TypeDef *)FM_BT5_PWM_BASE)
#define FM_BT5_RT      ((FM_BT_RT_TypeDef *)FM_BT5_RT_BASE)
#define FM_BT5_PWC     ((FM_BT_PWC_TypeDef *)FM_BT5_PWC_BASE)
#define FM_BT6_PPG     ((FM_BT_PPG_TypeDef *)FM_BT6_PPG_BASE)
#define FM_BT6_PWM     ((FM_BT_PWM_TypeDef *)FM_BT6_PWM_BASE)
#define FM_BT6_RT      ((FM_BT_RT_TypeDef *)FM_BT6_RT_BASE)
#define FM_BT6_PWC     ((FM_BT_PWC_TypeDef *)FM_BT6_PWC_BASE)
#define FM_BT7_PPG     ((FM_BT_PPG_TypeDef *)FM_BT7_PPG_BASE)
#define FM_BT7_PWM     ((FM_BT_PWM_TypeDef *)FM_BT7_PWM_BASE)
#define FM_BT7_RT      ((FM_BT_RT_TypeDef *)FM_BT7_RT_BASE)
#define FM_BT7_PWC     ((FM_BT_PWC_TypeDef *)FM_BT7_PWC_BASE)
#define FM_BTIOSEL03   ((FM_BTIOSEL03_TypeDef *)FM_BTIOSEL03_BASE)
#define FM_BTIOSEL47   ((FM_BTIOSEL47_TypeDef *)FM_BTIOSEL47_BASE)
#define FM_BT8_PPG     ((FM_BT_PPG_TypeDef *)FM_BT8_PPG_BASE)
#define FM_BT8_PWM     ((FM_BT_PWM_TypeDef *)FM_BT8_PWM_BASE)
#define FM_BT8_RT      ((FM_BT_RT_TypeDef *)FM_BT8_RT_BASE)
#define FM_BT8_PWC     ((FM_BT_PWC_TypeDef *)FM_BT8_PWC_BASE)
#define FM_BT9_PPG     ((FM_BT_PPG_TypeDef *)FM_BT9_PPG_BASE)
#define FM_BT9_PWM     ((FM_BT_PWM_TypeDef *)FM_BT9_PWM_BASE)
#define FM_BT9_RT      ((FM_BT_RT_TypeDef *)FM_BT9_RT_BASE)
#define FM_BT9_PWC     ((FM_BT_PWC_TypeDef *)FM_BT9_PWC_BASE)
#define FM_BT10_PPG    ((FM_BT_PPG_TypeDef *)FM_BT10_PPG_BASE)
#define FM_BT10_PWM    ((FM_BT_PWM_TypeDef *)FM_BT10_PWM_BASE)
#define FM_BT10_RT     ((FM_BT_RT_TypeDef *)FM_BT10_RT_BASE)
#define FM_BT10_PWC    ((FM_BT_PWC_TypeDef *)FM_BT10_PWC_BASE)
#define FM_BT11_PPG    ((FM_BT_PPG_TypeDef *)FM_BT11_PPG_BASE)
#define FM_BT11_PWM    ((FM_BT_PWM_TypeDef *)FM_BT11_PWM_BASE)
#define FM_BT11_RT     ((FM_BT_RT_TypeDef *)FM_BT11_RT_BASE)
#define FM_BT11_PWC    ((FM_BT_PWC_TypeDef *)FM_BT11_PWC_BASE)
#define FM_BT12_PPG    ((FM_BT_PPG_TypeDef *)FM_BT12_PPG_BASE)
#define FM_BT12_PWM    ((FM_BT_PWM_TypeDef *)FM_BT12_PWM_BASE)
#define FM_BT12_RT     ((FM_BT_RT_TypeDef *)FM_BT12_RT_BASE)
#define FM_BT12_PWC    ((FM_BT_PWC_TypeDef *)FM_BT12_PWC_BASE)
#define FM_BT13_PPG    ((FM_BT_PPG_TypeDef *)FM_BT13_PPG_BASE)
#define FM_BT13_PWM    ((FM_BT_PWM_TypeDef *)FM_BT13_PWM_BASE)
#define FM_BT13_RT     ((FM_BT_RT_TypeDef *)FM_BT13_RT_BASE)
#define FM_BT13_PWC    ((FM_BT_PWC_TypeDef *)FM_BT13_PWC_BASE)
#define FM_BT14_PPG    ((FM_BT_PPG_TypeDef *)FM_BT14_PPG_BASE)
#define FM_BT14_PWM    ((FM_BT_PWM_TypeDef *)FM_BT14_PWM_BASE)
#define FM_BT14_RT     ((FM_BT_RT_TypeDef *)FM_BT14_RT_BASE)
#define FM_BT14_PWC    ((FM_BT_PWC_TypeDef *)FM_BT14_PWC_BASE)
#define FM_BT15_PPG    ((FM_BT_PPG_TypeDef *)FM_BT15_PPG_BASE)
#define FM_BT15_PWM    ((FM_BT_PWM_TypeDef *)FM_BT15_PWM_BASE)
#define FM_BT15_RT     ((FM_BT_RT_TypeDef *)FM_BT15_RT_BASE)
#define FM_BT15_PWC    ((FM_BT_PWC_TypeDef *)FM_BT15_PWC_BASE)
#define FM_BTIOSEL8B   ((FM_BTIOSEL8B_TypeDef *)FM_BTIOSEL8B_BASE)
#define FM_BTIOSELCF   ((FM_BTIOSELCF_TypeDef *)FM_BTIOSELCF_BASE)
#define FM_SBSSR       ((FM_SBSSR_TypeDef *)FM_SBSSR_BASE)
#define FM_QPRC0       ((FM_QPRC_TypeDef *)FM_QPRC0_BASE)
#define FM_QPRC1       ((FM_QPRC_TypeDef *)FM_QPRC1_BASE)
#define FM_QPRC2       ((FM_QPRC_TypeDef *)FM_QPRC2_BASE)
#define FM_QPRC3       ((FM_QPRC_TypeDef *)FM_QPRC3_BASE)
#define FM_QPRC0_NF    ((FM_QPRC_NF_TypeDef *)FM_QPRC0_NF_BASE)
#define FM_QPRC1_NF    ((FM_QPRC_NF_TypeDef *)FM_QPRC1_NF_BASE)
#define FM_QPRC2_NF    ((FM_QPRC_NF_TypeDef *)FM_QPRC2_NF_BASE)
#define FM_QPRC3_NF    ((FM_QPRC_NF_TypeDef *)FM_QPRC3_NF_BASE)
#define FM_ADC0        ((FM_ADC_TypeDef *)FM_ADC0_BASE)
#define FM_ADC1        ((FM_ADC_TypeDef *)FM_ADC1_BASE)
#define FM_ADC2        ((FM_ADC_TypeDef *)FM_ADC2_BASE)
#define FM_DAC0        ((FM_DAC_TypeDef *)FM_DAC0_BASE)
#define FM_DAC1        ((FM_DAC_TypeDef *)FM_DAC1_BASE)
#define FM_CRTRIM      ((FM_CRTRIM_TypeDef *)FM_CRTRIM_BASE)
#define FM_EXTI        ((FM_EXTI_TypeDef *)FM_EXTI_BASE)
#define FM_INTREQ      ((FM_INTREQ_TypeDef *)FM_INTREQ_BASE)
#define FM_IRQSEL      ((FM_IRQSEL_TypeDef *)FM_IRQSEL_BASE)
#define FM_HDMICEC0    ((FM_HDMICEC_TypeDef *)FM_HDMICEC0_BASE)
#define FM_HDMICEC1    ((FM_HDMICEC_TypeDef *)FM_HDMICEC1_BASE)
#define FM_GPIO        ((FM_GPIO_TypeDef *)FM_GPIO_BASE)
#define FM_LVD         ((FM_LVD_TypeDef *)FM_LVD_BASE)
#define FM_DS          ((FM_DS_TypeDef *)FM_DS_BASE)
#define FM_USBETHERNETCLK ((FM_USBETHERNETCLK_TypeDef *)FM_USBETHERNETCLK_BASE)
#define FM_CANPRES     ((FM_CANPRE_TypeDef *)FM_CANPRES_BASE)
#define FM_MFS0        ((FM_MFS_TypeDef *)FM_MFS0_BASE)
#define FM_MFS1        ((FM_MFS_TypeDef *)FM_MFS1_BASE)
#define FM_MFS2        ((FM_MFS_TypeDef *)FM_MFS2_BASE)
#define FM_MFS3        ((FM_MFS_TypeDef *)FM_MFS3_BASE)
#define FM_MFS4        ((FM_MFS_TypeDef *)FM_MFS4_BASE)
#define FM_MFS5        ((FM_MFS_TypeDef *)FM_MFS5_BASE)
#define FM_MFS6        ((FM_MFS_TypeDef *)FM_MFS6_BASE)
#define FM_MFS7        ((FM_MFS_TypeDef *)FM_MFS7_BASE)
#define FM_MFS8        ((FM_MFS_TypeDef *)FM_MFS8_BASE)
#define FM_MFS9        ((FM_MFS_TypeDef *)FM_MFS9_BASE)
#define FM_MFS10       ((FM_MFS_TypeDef *)FM_MFS10_BASE)
#define FM_MFS11       ((FM_MFS_TypeDef *)FM_MFS11_BASE)
#define FM_MFS12       ((FM_MFS_TypeDef *)FM_MFS12_BASE)
#define FM_MFS13       ((FM_MFS_TypeDef *)FM_MFS13_BASE)
#define FM_MFS14       ((FM_MFS_TypeDef *)FM_MFS14_BASE)
#define FM_MFS15       ((FM_MFS_TypeDef *)FM_MFS15_BASE)
#define FM_CRC         ((FM_CRC_TypeDef *)FM_CRC_BASE)
#define FM_WC          ((FM_WC_TypeDef *)FM_WC_BASE)
#define FM_RTC         ((FM_RTC_TypeDef *)FM_RTC_BASE)
#define FM_LCR         ((FM_LCR_TypeDef *)FM_LCR_BASE)
#define FM_CLK_GATING  ((FM_CLK_GATING_TypeDef *)FM_CLK_GATING_BASE)
#define FM_PLL_CONTROL ((FM_PLL_CONTROL_TypeDef *)FM_PLL_CONTROL_BASE)
#define FM_I2SPRE      ((FM_I2SPRE_TypeDef *)FM_I2SPRE_BASE)
#define FM_EXBUS       ((FM_EXBUS_TypeDef *)FM_EXBUS_BASE)
#define FM_USB0        ((FM_USB_TypeDef *)FM_USB0_BASE)
#define FM_USB1        ((FM_USB_TypeDef *)FM_USB1_BASE)
#define FM_DMAC        ((FM_DMAC_TypeDef *)FM_DMAC_BASE)
#define FM_DSTC        ((FM_DSTC_TypeDef *)FM_DSTC_BASE)
#define FM_CAN0        ((FM_CAN_TypeDef *)FM_CAN0_BASE)
#define FM_CAN1        ((FM_CAN_TypeDef *)FM_CAN1_BASE)
#define FM_ETHERNET_MAC0 ((FM_ETHERNET_MAC_TypeDef *)FM_ETHERNET_MAC0_BASE)
#define FM_ETHERNET_CONTROL ((FM_ETHERNET_CONTROL_TypeDef *)FM_ETHERNET_CONTROL_BASE)
#define FM_I2S0        ((FM_I2S_TypeDef *)FM_I2S0_BASE)
#define FM_SDIF        ((FM_SDIF_TypeDef *)FM_SDIF_BASE)
#define FM_CANFD       ((FM_CANFD_TypeDef *)FM_CANFD_BASE)
#define FM_PCRC        ((FM_PCRC_TypeDef *)FM_PCRC_BASE)
#define FM_HSSPI       ((FM_HSSPI_TypeDef *)FM_HSSPI_BASE)

/******************************************************************************
 * Peripheral Bit Band Alias declaration
 ******************************************************************************/

/* Flash interface registers */
#define bFM_FLASH_IF_FASZR_ASZ0               *((volatile unsigned char*)(0x42000000UL))
#define bFM_FLASH_IF_FASZR_ASZ1               *((volatile unsigned char*)(0x42000004UL))
#define bFM_FLASH_IF_FRWTR_RWT0               *((volatile unsigned char*)(0x42000080UL))
#define bFM_FLASH_IF_FRWTR_RWT1               *((volatile unsigned char*)(0x42000084UL))
#define bFM_FLASH_IF_FSTR_RDY                 *((volatile unsigned char*)(0x42000100UL))
#define bFM_FLASH_IF_FSTR_HNG                 *((volatile unsigned char*)(0x42000104UL))
#define bFM_FLASH_IF_FSTR_ERR                 *((volatile unsigned char*)(0x42000108UL))
#define bFM_FLASH_IF_FSYNDN_SD0               *((volatile unsigned char*)(0x42000200UL))
#define bFM_FLASH_IF_FSYNDN_SD1               *((volatile unsigned char*)(0x42000204UL))
#define bFM_FLASH_IF_FSYNDN_SD2               *((volatile unsigned char*)(0x42000208UL))
#define bFM_FLASH_IF_FBFCR_BE                 *((volatile unsigned char*)(0x42000280UL))
#define bFM_FLASH_IF_FBFCR_BS                 *((volatile unsigned char*)(0x42000284UL))
#define bFM_FLASH_IF_FICR_RDYIE               *((volatile unsigned char*)(0x42000400UL))
#define bFM_FLASH_IF_FICR_HANGIE              *((volatile unsigned char*)(0x42000404UL))
#define bFM_FLASH_IF_FICR_ERRIE               *((volatile unsigned char*)(0x42000408UL))
#define bFM_FLASH_IF_FISR_RDYIF               *((volatile unsigned char*)(0x42000480UL))
#define bFM_FLASH_IF_FISR_HANGIF              *((volatile unsigned char*)(0x42000484UL))
#define bFM_FLASH_IF_FISR_ERRIF               *((volatile unsigned char*)(0x42000488UL))
#define bFM_FLASH_IF_FICLR_RDYIC              *((volatile unsigned char*)(0x42000500UL))
#define bFM_FLASH_IF_FICLR_HANGIC             *((volatile unsigned char*)(0x42000504UL))
#define bFM_FLASH_IF_FICLR_ERRIC              *((volatile unsigned char*)(0x42000508UL))
#define bFM_FLASH_IF_DFCTRLR_DFE              *((volatile unsigned char*)(0x42000600UL))
#define bFM_FLASH_IF_DFCTRLR_RME              *((volatile unsigned char*)(0x42000604UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY0            *((volatile unsigned char*)(0x42000640UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY1            *((volatile unsigned char*)(0x42000644UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY2            *((volatile unsigned char*)(0x42000648UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY3            *((volatile unsigned char*)(0x4200064CUL))
#define bFM_FLASH_IF_DFCTRLR_WKEY4            *((volatile unsigned char*)(0x42000650UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY5            *((volatile unsigned char*)(0x42000654UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY6            *((volatile unsigned char*)(0x42000658UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY7            *((volatile unsigned char*)(0x4200065CUL))
#define bFM_FLASH_IF_DFCTRLR_WKEY8            *((volatile unsigned char*)(0x42000660UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY9            *((volatile unsigned char*)(0x42000664UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY10           *((volatile unsigned char*)(0x42000668UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY11           *((volatile unsigned char*)(0x4200066CUL))
#define bFM_FLASH_IF_DFCTRLR_WKEY12           *((volatile unsigned char*)(0x42000670UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY13           *((volatile unsigned char*)(0x42000674UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY14           *((volatile unsigned char*)(0x42000678UL))
#define bFM_FLASH_IF_DFCTRLR_WKEY15           *((volatile unsigned char*)(0x4200067CUL))
#define bFM_FLASH_IF_CRTRMM_TRMM0             *((volatile unsigned char*)(0x42002000UL))
#define bFM_FLASH_IF_CRTRMM_TRMM1             *((volatile unsigned char*)(0x42002004UL))
#define bFM_FLASH_IF_CRTRMM_TRMM2             *((volatile unsigned char*)(0x42002008UL))
#define bFM_FLASH_IF_CRTRMM_TRMM3             *((volatile unsigned char*)(0x4200200CUL))
#define bFM_FLASH_IF_CRTRMM_TRMM4             *((volatile unsigned char*)(0x42002010UL))
#define bFM_FLASH_IF_CRTRMM_TRMM5             *((volatile unsigned char*)(0x42002014UL))
#define bFM_FLASH_IF_CRTRMM_TRMM6             *((volatile unsigned char*)(0x42002018UL))
#define bFM_FLASH_IF_CRTRMM_TRMM7             *((volatile unsigned char*)(0x4200201CUL))
#define bFM_FLASH_IF_CRTRMM_TRMM8             *((volatile unsigned char*)(0x42002020UL))
#define bFM_FLASH_IF_CRTRMM_TRMM9             *((volatile unsigned char*)(0x42002024UL))
#define bFM_FLASH_IF_CRTRMM_TTRMM0            *((volatile unsigned char*)(0x42002040UL))
#define bFM_FLASH_IF_CRTRMM_TTRMM1            *((volatile unsigned char*)(0x42002044UL))
#define bFM_FLASH_IF_CRTRMM_TTRMM2            *((volatile unsigned char*)(0x42002048UL))
#define bFM_FLASH_IF_CRTRMM_TTRMM3            *((volatile unsigned char*)(0x4200204CUL))
#define bFM_FLASH_IF_CRTRMM_TTRMM4            *((volatile unsigned char*)(0x42002050UL))
#define bFM_FLASH_IF_FGPDM1_GPD10             *((volatile unsigned char*)(0x42002200UL))
#define bFM_FLASH_IF_FGPDM1_GPD11             *((volatile unsigned char*)(0x42002204UL))
#define bFM_FLASH_IF_FGPDM1_GPD12             *((volatile unsigned char*)(0x42002208UL))
#define bFM_FLASH_IF_FGPDM1_GPD13             *((volatile unsigned char*)(0x4200220CUL))
#define bFM_FLASH_IF_FGPDM1_GPD14             *((volatile unsigned char*)(0x42002210UL))
#define bFM_FLASH_IF_FGPDM1_GPD15             *((volatile unsigned char*)(0x42002214UL))
#define bFM_FLASH_IF_FGPDM1_GPD16             *((volatile unsigned char*)(0x42002218UL))
#define bFM_FLASH_IF_FGPDM1_GPD17             *((volatile unsigned char*)(0x4200221CUL))
#define bFM_FLASH_IF_FGPDM1_GPD18             *((volatile unsigned char*)(0x42002220UL))
#define bFM_FLASH_IF_FGPDM1_GPD19             *((volatile unsigned char*)(0x42002224UL))
#define bFM_FLASH_IF_FGPDM1_GPD110            *((volatile unsigned char*)(0x42002228UL))
#define bFM_FLASH_IF_FGPDM1_GPD111            *((volatile unsigned char*)(0x4200222CUL))
#define bFM_FLASH_IF_FGPDM1_GPD112            *((volatile unsigned char*)(0x42002230UL))
#define bFM_FLASH_IF_FGPDM1_GPD113            *((volatile unsigned char*)(0x42002234UL))
#define bFM_FLASH_IF_FGPDM1_GPD114            *((volatile unsigned char*)(0x42002238UL))
#define bFM_FLASH_IF_FGPDM1_GPD115            *((volatile unsigned char*)(0x4200223CUL))
#define bFM_FLASH_IF_FGPDM1_GPD116            *((volatile unsigned char*)(0x42002240UL))
#define bFM_FLASH_IF_FGPDM1_GPD117            *((volatile unsigned char*)(0x42002244UL))
#define bFM_FLASH_IF_FGPDM1_GPD118            *((volatile unsigned char*)(0x42002248UL))
#define bFM_FLASH_IF_FGPDM1_GPD119            *((volatile unsigned char*)(0x4200224CUL))
#define bFM_FLASH_IF_FGPDM1_GPD120            *((volatile unsigned char*)(0x42002250UL))
#define bFM_FLASH_IF_FGPDM1_GPD121            *((volatile unsigned char*)(0x42002254UL))
#define bFM_FLASH_IF_FGPDM1_GPD122            *((volatile unsigned char*)(0x42002258UL))
#define bFM_FLASH_IF_FGPDM1_GPD123            *((volatile unsigned char*)(0x4200225CUL))
#define bFM_FLASH_IF_FGPDM1_GPD124            *((volatile unsigned char*)(0x42002260UL))
#define bFM_FLASH_IF_FGPDM1_GPD125            *((volatile unsigned char*)(0x42002264UL))
#define bFM_FLASH_IF_FGPDM1_GPD126            *((volatile unsigned char*)(0x42002268UL))
#define bFM_FLASH_IF_FGPDM1_GPD127            *((volatile unsigned char*)(0x4200226CUL))
#define bFM_FLASH_IF_FGPDM1_GPD128            *((volatile unsigned char*)(0x42002270UL))
#define bFM_FLASH_IF_FGPDM1_GPD129            *((volatile unsigned char*)(0x42002274UL))
#define bFM_FLASH_IF_FGPDM1_GPD130            *((volatile unsigned char*)(0x42002278UL))
#define bFM_FLASH_IF_FGPDM1_GPD131            *((volatile unsigned char*)(0x4200227CUL))
#define bFM_FLASH_IF_FGPDM2_GPD20             *((volatile unsigned char*)(0x42002280UL))
#define bFM_FLASH_IF_FGPDM2_GPD21             *((volatile unsigned char*)(0x42002284UL))
#define bFM_FLASH_IF_FGPDM2_GPD22             *((volatile unsigned char*)(0x42002288UL))
#define bFM_FLASH_IF_FGPDM2_GPD23             *((volatile unsigned char*)(0x4200228CUL))
#define bFM_FLASH_IF_FGPDM2_GPD24             *((volatile unsigned char*)(0x42002290UL))
#define bFM_FLASH_IF_FGPDM2_GPD25             *((volatile unsigned char*)(0x42002294UL))
#define bFM_FLASH_IF_FGPDM2_GPD26             *((volatile unsigned char*)(0x42002298UL))
#define bFM_FLASH_IF_FGPDM2_GPD27             *((volatile unsigned char*)(0x4200229CUL))
#define bFM_FLASH_IF_FGPDM2_GPD28             *((volatile unsigned char*)(0x420022A0UL))
#define bFM_FLASH_IF_FGPDM2_GPD29             *((volatile unsigned char*)(0x420022A4UL))
#define bFM_FLASH_IF_FGPDM2_GPD210            *((volatile unsigned char*)(0x420022A8UL))
#define bFM_FLASH_IF_FGPDM2_GPD211            *((volatile unsigned char*)(0x420022ACUL))
#define bFM_FLASH_IF_FGPDM2_GPD212            *((volatile unsigned char*)(0x420022B0UL))
#define bFM_FLASH_IF_FGPDM2_GPD213            *((volatile unsigned char*)(0x420022B4UL))
#define bFM_FLASH_IF_FGPDM2_GPD214            *((volatile unsigned char*)(0x420022B8UL))
#define bFM_FLASH_IF_FGPDM2_GPD215            *((volatile unsigned char*)(0x420022BCUL))
#define bFM_FLASH_IF_FGPDM2_GPD216            *((volatile unsigned char*)(0x420022C0UL))
#define bFM_FLASH_IF_FGPDM2_GPD217            *((volatile unsigned char*)(0x420022C4UL))
#define bFM_FLASH_IF_FGPDM2_GPD218            *((volatile unsigned char*)(0x420022C8UL))
#define bFM_FLASH_IF_FGPDM2_GPD219            *((volatile unsigned char*)(0x420022CCUL))
#define bFM_FLASH_IF_FGPDM2_GPD220            *((volatile unsigned char*)(0x420022D0UL))
#define bFM_FLASH_IF_FGPDM2_GPD221            *((volatile unsigned char*)(0x420022D4UL))
#define bFM_FLASH_IF_FGPDM2_GPD222            *((volatile unsigned char*)(0x420022D8UL))
#define bFM_FLASH_IF_FGPDM2_GPD223            *((volatile unsigned char*)(0x420022DCUL))
#define bFM_FLASH_IF_FGPDM2_GPD224            *((volatile unsigned char*)(0x420022E0UL))
#define bFM_FLASH_IF_FGPDM2_GPD225            *((volatile unsigned char*)(0x420022E4UL))
#define bFM_FLASH_IF_FGPDM2_GPD226            *((volatile unsigned char*)(0x420022E8UL))
#define bFM_FLASH_IF_FGPDM2_GPD227            *((volatile unsigned char*)(0x420022ECUL))
#define bFM_FLASH_IF_FGPDM2_GPD228            *((volatile unsigned char*)(0x420022F0UL))
#define bFM_FLASH_IF_FGPDM2_GPD229            *((volatile unsigned char*)(0x420022F4UL))
#define bFM_FLASH_IF_FGPDM2_GPD230            *((volatile unsigned char*)(0x420022F8UL))
#define bFM_FLASH_IF_FGPDM2_GPD231            *((volatile unsigned char*)(0x420022FCUL))
#define bFM_FLASH_IF_FGPDM3_GPD30             *((volatile unsigned char*)(0x42002300UL))
#define bFM_FLASH_IF_FGPDM3_GPD31             *((volatile unsigned char*)(0x42002304UL))
#define bFM_FLASH_IF_FGPDM3_GPD32             *((volatile unsigned char*)(0x42002308UL))
#define bFM_FLASH_IF_FGPDM3_GPD33             *((volatile unsigned char*)(0x4200230CUL))
#define bFM_FLASH_IF_FGPDM3_GPD34             *((volatile unsigned char*)(0x42002310UL))
#define bFM_FLASH_IF_FGPDM3_GPD35             *((volatile unsigned char*)(0x42002314UL))
#define bFM_FLASH_IF_FGPDM3_GPD36             *((volatile unsigned char*)(0x42002318UL))
#define bFM_FLASH_IF_FGPDM3_GPD37             *((volatile unsigned char*)(0x4200231CUL))
#define bFM_FLASH_IF_FGPDM3_GPD38             *((volatile unsigned char*)(0x42002320UL))
#define bFM_FLASH_IF_FGPDM3_GPD39             *((volatile unsigned char*)(0x42002324UL))
#define bFM_FLASH_IF_FGPDM3_GPD310            *((volatile unsigned char*)(0x42002328UL))
#define bFM_FLASH_IF_FGPDM3_GPD311            *((volatile unsigned char*)(0x4200232CUL))
#define bFM_FLASH_IF_FGPDM3_GPD312            *((volatile unsigned char*)(0x42002330UL))
#define bFM_FLASH_IF_FGPDM3_GPD313            *((volatile unsigned char*)(0x42002334UL))
#define bFM_FLASH_IF_FGPDM3_GPD314            *((volatile unsigned char*)(0x42002338UL))
#define bFM_FLASH_IF_FGPDM3_GPD315            *((volatile unsigned char*)(0x4200233CUL))
#define bFM_FLASH_IF_FGPDM3_GPD316            *((volatile unsigned char*)(0x42002340UL))
#define bFM_FLASH_IF_FGPDM3_GPD317            *((volatile unsigned char*)(0x42002344UL))
#define bFM_FLASH_IF_FGPDM3_GPD318            *((volatile unsigned char*)(0x42002348UL))
#define bFM_FLASH_IF_FGPDM3_GPD319            *((volatile unsigned char*)(0x4200234CUL))
#define bFM_FLASH_IF_FGPDM3_GPD320            *((volatile unsigned char*)(0x42002350UL))
#define bFM_FLASH_IF_FGPDM3_GPD321            *((volatile unsigned char*)(0x42002354UL))
#define bFM_FLASH_IF_FGPDM3_GPD322            *((volatile unsigned char*)(0x42002358UL))
#define bFM_FLASH_IF_FGPDM3_GPD323            *((volatile unsigned char*)(0x4200235CUL))
#define bFM_FLASH_IF_FGPDM3_GPD324            *((volatile unsigned char*)(0x42002360UL))
#define bFM_FLASH_IF_FGPDM3_GPD325            *((volatile unsigned char*)(0x42002364UL))
#define bFM_FLASH_IF_FGPDM3_GPD326            *((volatile unsigned char*)(0x42002368UL))
#define bFM_FLASH_IF_FGPDM3_GPD327            *((volatile unsigned char*)(0x4200236CUL))
#define bFM_FLASH_IF_FGPDM3_GPD328            *((volatile unsigned char*)(0x42002370UL))
#define bFM_FLASH_IF_FGPDM3_GPD329            *((volatile unsigned char*)(0x42002374UL))
#define bFM_FLASH_IF_FGPDM3_GPD330            *((volatile unsigned char*)(0x42002378UL))
#define bFM_FLASH_IF_FGPDM3_GPD331            *((volatile unsigned char*)(0x4200237CUL))
#define bFM_FLASH_IF_FGPDM4_GPD40             *((volatile unsigned char*)(0x42002380UL))
#define bFM_FLASH_IF_FGPDM4_GPD41             *((volatile unsigned char*)(0x42002384UL))
#define bFM_FLASH_IF_FGPDM4_GPD42             *((volatile unsigned char*)(0x42002388UL))
#define bFM_FLASH_IF_FGPDM4_GPD43             *((volatile unsigned char*)(0x4200238CUL))
#define bFM_FLASH_IF_FGPDM4_GPD44             *((volatile unsigned char*)(0x42002390UL))
#define bFM_FLASH_IF_FGPDM4_GPD45             *((volatile unsigned char*)(0x42002394UL))
#define bFM_FLASH_IF_FGPDM4_GPD46             *((volatile unsigned char*)(0x42002398UL))
#define bFM_FLASH_IF_FGPDM4_GPD47             *((volatile unsigned char*)(0x4200239CUL))
#define bFM_FLASH_IF_FGPDM4_GPD48             *((volatile unsigned char*)(0x420023A0UL))
#define bFM_FLASH_IF_FGPDM4_GPD49             *((volatile unsigned char*)(0x420023A4UL))
#define bFM_FLASH_IF_FGPDM4_GPD410            *((volatile unsigned char*)(0x420023A8UL))
#define bFM_FLASH_IF_FGPDM4_GPD411            *((volatile unsigned char*)(0x420023ACUL))
#define bFM_FLASH_IF_FGPDM4_GPD412            *((volatile unsigned char*)(0x420023B0UL))
#define bFM_FLASH_IF_FGPDM4_GPD413            *((volatile unsigned char*)(0x420023B4UL))
#define bFM_FLASH_IF_FGPDM4_GPD414            *((volatile unsigned char*)(0x420023B8UL))
#define bFM_FLASH_IF_FGPDM4_GPD415            *((volatile unsigned char*)(0x420023BCUL))
#define bFM_FLASH_IF_FGPDM4_GPD416            *((volatile unsigned char*)(0x420023C0UL))
#define bFM_FLASH_IF_FGPDM4_GPD417            *((volatile unsigned char*)(0x420023C4UL))
#define bFM_FLASH_IF_FGPDM4_GPD418            *((volatile unsigned char*)(0x420023C8UL))
#define bFM_FLASH_IF_FGPDM4_GPD419            *((volatile unsigned char*)(0x420023CCUL))
#define bFM_FLASH_IF_FGPDM4_GPD420            *((volatile unsigned char*)(0x420023D0UL))
#define bFM_FLASH_IF_FGPDM4_GPD421            *((volatile unsigned char*)(0x420023D4UL))
#define bFM_FLASH_IF_FGPDM4_GPD422            *((volatile unsigned char*)(0x420023D8UL))
#define bFM_FLASH_IF_FGPDM4_GPD423            *((volatile unsigned char*)(0x420023DCUL))
#define bFM_FLASH_IF_FGPDM4_GPD424            *((volatile unsigned char*)(0x420023E0UL))
#define bFM_FLASH_IF_FGPDM4_GPD425            *((volatile unsigned char*)(0x420023E4UL))
#define bFM_FLASH_IF_FGPDM4_GPD426            *((volatile unsigned char*)(0x420023E8UL))
#define bFM_FLASH_IF_FGPDM4_GPD427            *((volatile unsigned char*)(0x420023ECUL))
#define bFM_FLASH_IF_FGPDM4_GPD428            *((volatile unsigned char*)(0x420023F0UL))
#define bFM_FLASH_IF_FGPDM4_GPD429            *((volatile unsigned char*)(0x420023F4UL))
#define bFM_FLASH_IF_FGPDM4_GPD430            *((volatile unsigned char*)(0x420023F8UL))
#define bFM_FLASH_IF_FGPDM4_GPD431            *((volatile unsigned char*)(0x420023FCUL))

/* Dual Flash interface registers */
#define bFM_DUALFLASH_IF_DFASZR_DASZ0         *((volatile unsigned char*)(0x42008000UL))
#define bFM_DUALFLASH_IF_DFASZR_DASZ1         *((volatile unsigned char*)(0x42008004UL))
#define bFM_DUALFLASH_IF_DFRWTR_DRWT0         *((volatile unsigned char*)(0x42008080UL))
#define bFM_DUALFLASH_IF_DFRWTR_DRWT1         *((volatile unsigned char*)(0x42008084UL))
#define bFM_DUALFLASH_IF_DFSTR_DFRDY          *((volatile unsigned char*)(0x42008100UL))
#define bFM_DUALFLASH_IF_DFSTR_DFHNG          *((volatile unsigned char*)(0x42008104UL))
#define bFM_DUALFLASH_IF_DFSTR_DFERR          *((volatile unsigned char*)(0x42008108UL))

/* Unique ID registers */
#define bFM_UNIQUE_ID_UIDR0_UID0              *((volatile unsigned int*)(0x42004010UL))
#define bFM_UNIQUE_ID_UIDR0_UID1              *((volatile unsigned int*)(0x42004014UL))
#define bFM_UNIQUE_ID_UIDR0_UID2              *((volatile unsigned int*)(0x42004018UL))
#define bFM_UNIQUE_ID_UIDR0_UID3              *((volatile unsigned int*)(0x4200401CUL))
#define bFM_UNIQUE_ID_UIDR0_UID4              *((volatile unsigned int*)(0x42004020UL))
#define bFM_UNIQUE_ID_UIDR0_UID5              *((volatile unsigned int*)(0x42004024UL))
#define bFM_UNIQUE_ID_UIDR0_UID6              *((volatile unsigned int*)(0x42004028UL))
#define bFM_UNIQUE_ID_UIDR0_UID7              *((volatile unsigned int*)(0x4200402CUL))
#define bFM_UNIQUE_ID_UIDR0_UID8              *((volatile unsigned int*)(0x42004030UL))
#define bFM_UNIQUE_ID_UIDR0_UID9              *((volatile unsigned int*)(0x42004034UL))
#define bFM_UNIQUE_ID_UIDR0_UID10             *((volatile unsigned int*)(0x42004038UL))
#define bFM_UNIQUE_ID_UIDR0_UID11             *((volatile unsigned int*)(0x4200403CUL))
#define bFM_UNIQUE_ID_UIDR0_UID12             *((volatile unsigned int*)(0x42004040UL))
#define bFM_UNIQUE_ID_UIDR0_UID13             *((volatile unsigned int*)(0x42004044UL))
#define bFM_UNIQUE_ID_UIDR0_UID14             *((volatile unsigned int*)(0x42004048UL))
#define bFM_UNIQUE_ID_UIDR0_UID15             *((volatile unsigned int*)(0x4200404CUL))
#define bFM_UNIQUE_ID_UIDR0_UID16             *((volatile unsigned int*)(0x42004050UL))
#define bFM_UNIQUE_ID_UIDR0_UID17             *((volatile unsigned int*)(0x42004054UL))
#define bFM_UNIQUE_ID_UIDR0_UID18             *((volatile unsigned int*)(0x42004058UL))
#define bFM_UNIQUE_ID_UIDR0_UID19             *((volatile unsigned int*)(0x4200405CUL))
#define bFM_UNIQUE_ID_UIDR0_UID20             *((volatile unsigned int*)(0x42004060UL))
#define bFM_UNIQUE_ID_UIDR0_UID21             *((volatile unsigned int*)(0x42004064UL))
#define bFM_UNIQUE_ID_UIDR0_UID22             *((volatile unsigned int*)(0x42004068UL))
#define bFM_UNIQUE_ID_UIDR0_UID23             *((volatile unsigned int*)(0x4200406CUL))
#define bFM_UNIQUE_ID_UIDR0_UID24             *((volatile unsigned int*)(0x42004070UL))
#define bFM_UNIQUE_ID_UIDR0_UID25             *((volatile unsigned int*)(0x42004074UL))
#define bFM_UNIQUE_ID_UIDR0_UID26             *((volatile unsigned int*)(0x42004078UL))
#define bFM_UNIQUE_ID_UIDR0_UID27             *((volatile unsigned int*)(0x4200407CUL))
#define bFM_UNIQUE_ID_UIDR1_UID28             *((volatile unsigned int*)(0x42004080UL))
#define bFM_UNIQUE_ID_UIDR1_UID29             *((volatile unsigned int*)(0x42004084UL))
#define bFM_UNIQUE_ID_UIDR1_UID30             *((volatile unsigned int*)(0x42004088UL))
#define bFM_UNIQUE_ID_UIDR1_UID31             *((volatile unsigned int*)(0x4200408CUL))
#define bFM_UNIQUE_ID_UIDR1_UID32             *((volatile unsigned int*)(0x42004090UL))
#define bFM_UNIQUE_ID_UIDR1_UID33             *((volatile unsigned int*)(0x42004094UL))
#define bFM_UNIQUE_ID_UIDR1_UID34             *((volatile unsigned int*)(0x42004098UL))
#define bFM_UNIQUE_ID_UIDR1_UID35             *((volatile unsigned int*)(0x4200409CUL))
#define bFM_UNIQUE_ID_UIDR1_UID36             *((volatile unsigned int*)(0x420040A0UL))
#define bFM_UNIQUE_ID_UIDR1_UID37             *((volatile unsigned int*)(0x420040A4UL))
#define bFM_UNIQUE_ID_UIDR1_UID38             *((volatile unsigned int*)(0x420040A8UL))
#define bFM_UNIQUE_ID_UIDR1_UID39             *((volatile unsigned int*)(0x420040ACUL))
#define bFM_UNIQUE_ID_UIDR1_UID40             *((volatile unsigned int*)(0x420040B0UL))

/* ECC_CAPTURE registers */
#define bFM_ECC_CAPTURE_FERRAD_ERRAD0         *((volatile unsigned int*)(0x42006000UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD1         *((volatile unsigned int*)(0x42006004UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD2         *((volatile unsigned int*)(0x42006008UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD3         *((volatile unsigned int*)(0x4200600CUL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD4         *((volatile unsigned int*)(0x42006010UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD5         *((volatile unsigned int*)(0x42006014UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD6         *((volatile unsigned int*)(0x42006018UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD7         *((volatile unsigned int*)(0x4200601CUL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD8         *((volatile unsigned int*)(0x42006020UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD9         *((volatile unsigned int*)(0x42006024UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD10        *((volatile unsigned int*)(0x42006028UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD11        *((volatile unsigned int*)(0x4200602CUL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD12        *((volatile unsigned int*)(0x42006030UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD13        *((volatile unsigned int*)(0x42006034UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD14        *((volatile unsigned int*)(0x42006038UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD15        *((volatile unsigned int*)(0x4200603CUL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD16        *((volatile unsigned int*)(0x42006040UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD17        *((volatile unsigned int*)(0x42006044UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD18        *((volatile unsigned int*)(0x42006048UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD19        *((volatile unsigned int*)(0x4200604CUL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD20        *((volatile unsigned int*)(0x42006050UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD21        *((volatile unsigned int*)(0x42006054UL))
#define bFM_ECC_CAPTURE_FERRAD_ERRAD22        *((volatile unsigned int*)(0x42006058UL))

/* Clock and reset registers */
#define bFM_CRG_SCM_CTL_MOSCE                 *((volatile unsigned int*)(0x42200004UL))
#define bFM_CRG_SCM_CTL_SOSCE                 *((volatile unsigned int*)(0x4220000CUL))
#define bFM_CRG_SCM_CTL_PLLE                  *((volatile unsigned int*)(0x42200010UL))
#define bFM_CRG_SCM_CTL_RCS0                  *((volatile unsigned int*)(0x42200014UL))
#define bFM_CRG_SCM_CTL_RCS1                  *((volatile unsigned int*)(0x42200018UL))
#define bFM_CRG_SCM_CTL_RCS2                  *((volatile unsigned int*)(0x4220001CUL))
#define bFM_CRG_SCM_STR_MORDY                 *((volatile unsigned int*)(0x42200084UL))
#define bFM_CRG_SCM_STR_SORDY                 *((volatile unsigned int*)(0x4220008CUL))
#define bFM_CRG_SCM_STR_PLRDY                 *((volatile unsigned int*)(0x42200090UL))
#define bFM_CRG_SCM_STR_RCM0                  *((volatile unsigned int*)(0x42200094UL))
#define bFM_CRG_SCM_STR_RCM1                  *((volatile unsigned int*)(0x42200098UL))
#define bFM_CRG_SCM_STR_RCM2                  *((volatile unsigned int*)(0x4220009CUL))
#define bFM_CRG_RST_STR_PONR                  *((volatile unsigned int*)(0x42200180UL))
#define bFM_CRG_RST_STR_INITX                 *((volatile unsigned int*)(0x42200184UL))
#define bFM_CRG_RST_STR_SWDT                  *((volatile unsigned int*)(0x42200190UL))
#define bFM_CRG_RST_STR_HWDT                  *((volatile unsigned int*)(0x42200194UL))
#define bFM_CRG_RST_STR_CSVR                  *((volatile unsigned int*)(0x42200198UL))
#define bFM_CRG_RST_STR_FCSR                  *((volatile unsigned int*)(0x4220019CUL))
#define bFM_CRG_RST_STR_SRST                  *((volatile unsigned int*)(0x422001A0UL))
#define bFM_CRG_BSC_PSR_BSR0                  *((volatile unsigned int*)(0x42200200UL))
#define bFM_CRG_BSC_PSR_BSR1                  *((volatile unsigned int*)(0x42200204UL))
#define bFM_CRG_BSC_PSR_BSR2                  *((volatile unsigned int*)(0x42200208UL))
#define bFM_CRG_APBC0_PSR_APBC00              *((volatile unsigned int*)(0x42200280UL))
#define bFM_CRG_APBC0_PSR_APBC01              *((volatile unsigned int*)(0x42200284UL))
#define bFM_CRG_APBC1_PSR_APBC10              *((volatile unsigned int*)(0x42200300UL))
#define bFM_CRG_APBC1_PSR_APBC11              *((volatile unsigned int*)(0x42200304UL))
#define bFM_CRG_APBC1_PSR_APBC1RST            *((volatile unsigned int*)(0x42200310UL))
#define bFM_CRG_APBC1_PSR_APBC1EN             *((volatile unsigned int*)(0x4220031CUL))
#define bFM_CRG_APBC2_PSR_APBC20              *((volatile unsigned int*)(0x42200380UL))
#define bFM_CRG_APBC2_PSR_APBC21              *((volatile unsigned int*)(0x42200384UL))
#define bFM_CRG_APBC2_PSR_APBC2RST            *((volatile unsigned int*)(0x42200390UL))
#define bFM_CRG_APBC2_PSR_APBC2EN             *((volatile unsigned int*)(0x4220039CUL))
#define bFM_CRG_SWC_PSR_SWDS0                 *((volatile unsigned int*)(0x42200400UL))
#define bFM_CRG_SWC_PSR_SWDS1                 *((volatile unsigned int*)(0x42200404UL))
#define bFM_CRG_TTC_PSR_TTC0                  *((volatile unsigned int*)(0x42200500UL))
#define bFM_CRG_TTC_PSR_TTC1                  *((volatile unsigned int*)(0x42200504UL))
#define bFM_CRG_CSW_TMR_MOWT0                 *((volatile unsigned int*)(0x42200600UL))
#define bFM_CRG_CSW_TMR_MOWT1                 *((volatile unsigned int*)(0x42200604UL))
#define bFM_CRG_CSW_TMR_MOWT2                 *((volatile unsigned int*)(0x42200608UL))
#define bFM_CRG_CSW_TMR_MOWT3                 *((volatile unsigned int*)(0x4220060CUL))
#define bFM_CRG_CSW_TMR_SOWT0                 *((volatile unsigned int*)(0x42200610UL))
#define bFM_CRG_CSW_TMR_SOWT1                 *((volatile unsigned int*)(0x42200614UL))
#define bFM_CRG_CSW_TMR_SOWT2                 *((volatile unsigned int*)(0x42200618UL))
#define bFM_CRG_CSW_TMR_SOWT3                 *((volatile unsigned int*)(0x4220061CUL))
#define bFM_CRG_PSW_TMR_POWT0                 *((volatile unsigned int*)(0x42200680UL))
#define bFM_CRG_PSW_TMR_POWT1                 *((volatile unsigned int*)(0x42200684UL))
#define bFM_CRG_PSW_TMR_POWT2                 *((volatile unsigned int*)(0x42200688UL))
#define bFM_CRG_PSW_TMR_PINC                  *((volatile unsigned int*)(0x42200690UL))
#define bFM_CRG_PLL_CTL1_PLLM0                *((volatile unsigned int*)(0x42200700UL))
#define bFM_CRG_PLL_CTL1_PLLM1                *((volatile unsigned int*)(0x42200704UL))
#define bFM_CRG_PLL_CTL1_PLLM2                *((volatile unsigned int*)(0x42200708UL))
#define bFM_CRG_PLL_CTL1_PLLM3                *((volatile unsigned int*)(0x4220070CUL))
#define bFM_CRG_PLL_CTL1_PLLK0                *((volatile unsigned int*)(0x42200710UL))
#define bFM_CRG_PLL_CTL1_PLLK1                *((volatile unsigned int*)(0x42200714UL))
#define bFM_CRG_PLL_CTL1_PLLK2                *((volatile unsigned int*)(0x42200718UL))
#define bFM_CRG_PLL_CTL1_PLLK3                *((volatile unsigned int*)(0x4220071CUL))
#define bFM_CRG_PLL_CTL2_PLLN0                *((volatile unsigned int*)(0x42200780UL))
#define bFM_CRG_PLL_CTL2_PLLN1                *((volatile unsigned int*)(0x42200784UL))
#define bFM_CRG_PLL_CTL2_PLLN2                *((volatile unsigned int*)(0x42200788UL))
#define bFM_CRG_PLL_CTL2_PLLN3                *((volatile unsigned int*)(0x4220078CUL))
#define bFM_CRG_PLL_CTL2_PLLN4                *((volatile unsigned int*)(0x42200790UL))
#define bFM_CRG_PLL_CTL2_PLLN5                *((volatile unsigned int*)(0x42200794UL))
#define bFM_CRG_CSV_CTL_MCSVE                 *((volatile unsigned int*)(0x42200800UL))
#define bFM_CRG_CSV_CTL_SCSVE                 *((volatile unsigned int*)(0x42200804UL))
#define bFM_CRG_CSV_CTL_FCSDE                 *((volatile unsigned int*)(0x42200820UL))
#define bFM_CRG_CSV_CTL_FCSRE                 *((volatile unsigned int*)(0x42200824UL))
#define bFM_CRG_CSV_CTL_FCD0                  *((volatile unsigned int*)(0x42200830UL))
#define bFM_CRG_CSV_CTL_FCD1                  *((volatile unsigned int*)(0x42200834UL))
#define bFM_CRG_CSV_CTL_FCD2                  *((volatile unsigned int*)(0x42200838UL))
#define bFM_CRG_CSV_STR_MCMF                  *((volatile unsigned int*)(0x42200880UL))
#define bFM_CRG_CSV_STR_SCMF                  *((volatile unsigned int*)(0x42200884UL))
#define bFM_CRG_DBWDT_CTL_DPSWBE              *((volatile unsigned int*)(0x42200A94UL))
#define bFM_CRG_DBWDT_CTL_DPHWBE              *((volatile unsigned int*)(0x42200A9CUL))
#define bFM_CRG_INT_ENR_MCSE                  *((volatile unsigned int*)(0x42200C00UL))
#define bFM_CRG_INT_ENR_SCSE                  *((volatile unsigned int*)(0x42200C04UL))
#define bFM_CRG_INT_ENR_PCSE                  *((volatile unsigned int*)(0x42200C08UL))
#define bFM_CRG_INT_ENR_FCSE                  *((volatile unsigned int*)(0x42200C14UL))
#define bFM_CRG_INT_STR_MCSI                  *((volatile unsigned int*)(0x42200C80UL))
#define bFM_CRG_INT_STR_SCSI                  *((volatile unsigned int*)(0x42200C84UL))
#define bFM_CRG_INT_STR_PCSI                  *((volatile unsigned int*)(0x42200C88UL))
#define bFM_CRG_INT_STR_FCSI                  *((volatile unsigned int*)(0x42200C94UL))
#define bFM_CRG_INT_CLR_MCSC                  *((volatile unsigned int*)(0x42200D00UL))
#define bFM_CRG_INT_CLR_SCSC                  *((volatile unsigned int*)(0x42200D04UL))
#define bFM_CRG_INT_CLR_PCSC                  *((volatile unsigned int*)(0x42200D08UL))
#define bFM_CRG_INT_CLR_FCSC                  *((volatile unsigned int*)(0x42200D14UL))

/* Hardware watchdog registers */
#define bFM_HWWDT_WDG_CTL_INTEN               *((volatile unsigned int*)(0x42220100UL))
#define bFM_HWWDT_WDG_CTL_RESEN               *((volatile unsigned int*)(0x42220104UL))
#define bFM_HWWDT_WDG_RIS_RIS                 *((volatile unsigned int*)(0x42220200UL))

/* Software watchdog registers */
#define bFM_SWWDT_WDOGCONTROL_INTEN           *((volatile unsigned int*)(0x42240100UL))
#define bFM_SWWDT_WDOGCONTROL_RESEN           *((volatile unsigned int*)(0x42240104UL))
#define bFM_SWWDT_WDOGCONTROL_TWD0            *((volatile unsigned int*)(0x42240108UL))
#define bFM_SWWDT_WDOGCONTROL_TWD1            *((volatile unsigned int*)(0x4224010CUL))
#define bFM_SWWDT_WDOGCONTROL_SPM             *((volatile unsigned int*)(0x42240110UL))
#define bFM_SWWDT_WDOGRIS_RIS                 *((volatile unsigned int*)(0x42240200UL))
#define bFM_SWWDT_WDOGSPMC_TGR                *((volatile unsigned int*)(0x42240300UL))

/* Dual timer 1/2 registers */
#define bFM_DTIM_TIMER1CONTROL_ONESHOT        *((volatile unsigned int*)(0x422A0100UL))
#define bFM_DTIM_TIMER1CONTROL_TIMERSIZE      *((volatile unsigned int*)(0x422A0104UL))
#define bFM_DTIM_TIMER1CONTROL_TIMERPRE0      *((volatile unsigned int*)(0x422A0108UL))
#define bFM_DTIM_TIMER1CONTROL_TIMERPRE1      *((volatile unsigned int*)(0x422A010CUL))
#define bFM_DTIM_TIMER1CONTROL_INTENABLE      *((volatile unsigned int*)(0x422A0114UL))
#define bFM_DTIM_TIMER1CONTROL_TIMERMODE      *((volatile unsigned int*)(0x422A0118UL))
#define bFM_DTIM_TIMER1CONTROL_TIMEREN        *((volatile unsigned int*)(0x422A011CUL))
#define bFM_DTIM_TIMER1RIS_TIMERXRIS          *((volatile unsigned int*)(0x422A0200UL))
#define bFM_DTIM_TIMER1MIS_TIMERXRIS          *((volatile unsigned int*)(0x422A0280UL))
#define bFM_DTIM_TIMER2CONTROL_ONESHOT        *((volatile unsigned int*)(0x422A0500UL))
#define bFM_DTIM_TIMER2CONTROL_TIMERSIZE      *((volatile unsigned int*)(0x422A0504UL))
#define bFM_DTIM_TIMER2CONTROL_TIMERPRE0      *((volatile unsigned int*)(0x422A0508UL))
#define bFM_DTIM_TIMER2CONTROL_TIMERPRE1      *((volatile unsigned int*)(0x422A050CUL))
#define bFM_DTIM_TIMER2CONTROL_INTENABLE      *((volatile unsigned int*)(0x422A0514UL))
#define bFM_DTIM_TIMER2CONTROL_TIMERMODE      *((volatile unsigned int*)(0x422A0518UL))
#define bFM_DTIM_TIMER2CONTROL_TIMEREN        *((volatile unsigned int*)(0x422A051CUL))
#define bFM_DTIM_TIMER2RIS_TIMERXRIS          *((volatile unsigned int*)(0x422A0600UL))
#define bFM_DTIM_TIMER2MIS_TIMERXRIS          *((volatile unsigned int*)(0x422A0680UL))

/* Multifunction Timer unit 0 Free Running Timer registers */
#define bFM_MFT0_FRT_TCSA0_CLK0               *((volatile unsigned char*)(0x42402900UL))
#define bFM_MFT0_FRT_TCSA0_CLK1               *((volatile unsigned char*)(0x42402904UL))
#define bFM_MFT0_FRT_TCSA0_CLK2               *((volatile unsigned char*)(0x42402908UL))
#define bFM_MFT0_FRT_TCSA0_CLK3               *((volatile unsigned char*)(0x4240290CUL))
#define bFM_MFT0_FRT_TCSA0_SCLR               *((volatile unsigned char*)(0x42402910UL))
#define bFM_MFT0_FRT_TCSA0_MODE               *((volatile unsigned char*)(0x42402914UL))
#define bFM_MFT0_FRT_TCSA0_STOP               *((volatile unsigned char*)(0x42402918UL))
#define bFM_MFT0_FRT_TCSA0_BFE                *((volatile unsigned char*)(0x4240291CUL))
#define bFM_MFT0_FRT_TCSA0_ICRE               *((volatile unsigned char*)(0x42402920UL))
#define bFM_MFT0_FRT_TCSA0_ICLR               *((volatile unsigned char*)(0x42402924UL))
#define bFM_MFT0_FRT_TCSA0_IRQZE              *((volatile unsigned char*)(0x42402934UL))
#define bFM_MFT0_FRT_TCSA0_IRQZF              *((volatile unsigned char*)(0x42402938UL))
#define bFM_MFT0_FRT_TCSA0_ECKE               *((volatile unsigned char*)(0x4240293CUL))
#define bFM_MFT0_FRT_TCSC0_MSZI0              *((volatile unsigned char*)(0x42402940UL))
#define bFM_MFT0_FRT_TCSC0_MSZI1              *((volatile unsigned char*)(0x42402944UL))
#define bFM_MFT0_FRT_TCSC0_MSZI2              *((volatile unsigned char*)(0x42402948UL))
#define bFM_MFT0_FRT_TCSC0_MSZI3              *((volatile unsigned char*)(0x4240294CUL))
#define bFM_MFT0_FRT_TCSC0_MSPI0              *((volatile unsigned char*)(0x42402950UL))
#define bFM_MFT0_FRT_TCSC0_MSPI1              *((volatile unsigned char*)(0x42402954UL))
#define bFM_MFT0_FRT_TCSC0_MSPI2              *((volatile unsigned char*)(0x42402958UL))
#define bFM_MFT0_FRT_TCSC0_MSPI3              *((volatile unsigned char*)(0x4240295CUL))
#define bFM_MFT0_FRT_TCSC0_MSZC0              *((volatile unsigned char*)(0x42402960UL))
#define bFM_MFT0_FRT_TCSC0_MSZC1              *((volatile unsigned char*)(0x42402964UL))
#define bFM_MFT0_FRT_TCSC0_MSZC2              *((volatile unsigned char*)(0x42402968UL))
#define bFM_MFT0_FRT_TCSC0_MSZC3              *((volatile unsigned char*)(0x4240296CUL))
#define bFM_MFT0_FRT_TCSC0_MSPC0              *((volatile unsigned char*)(0x42402970UL))
#define bFM_MFT0_FRT_TCSC0_MSPC1              *((volatile unsigned char*)(0x42402974UL))
#define bFM_MFT0_FRT_TCSC0_MSPC2              *((volatile unsigned char*)(0x42402978UL))
#define bFM_MFT0_FRT_TCSC0_MSPC3              *((volatile unsigned char*)(0x4240297CUL))
#define bFM_MFT0_FRT_TCSA1_CLK0               *((volatile unsigned char*)(0x42402A80UL))
#define bFM_MFT0_FRT_TCSA1_CLK1               *((volatile unsigned char*)(0x42402A84UL))
#define bFM_MFT0_FRT_TCSA1_CLK2               *((volatile unsigned char*)(0x42402A88UL))
#define bFM_MFT0_FRT_TCSA1_CLK3               *((volatile unsigned char*)(0x42402A8CUL))
#define bFM_MFT0_FRT_TCSA1_SCLR               *((volatile unsigned char*)(0x42402A90UL))
#define bFM_MFT0_FRT_TCSA1_MODE               *((volatile unsigned char*)(0x42402A94UL))
#define bFM_MFT0_FRT_TCSA1_STOP               *((volatile unsigned char*)(0x42402A98UL))
#define bFM_MFT0_FRT_TCSA1_BFE                *((volatile unsigned char*)(0x42402A9CUL))
#define bFM_MFT0_FRT_TCSA1_ICRE               *((volatile unsigned char*)(0x42402AA0UL))
#define bFM_MFT0_FRT_TCSA1_ICLR               *((volatile unsigned char*)(0x42402AA4UL))
#define bFM_MFT0_FRT_TCSA1_IRQZE              *((volatile unsigned char*)(0x42402AB4UL))
#define bFM_MFT0_FRT_TCSA1_IRQZF              *((volatile unsigned char*)(0x42402AB8UL))
#define bFM_MFT0_FRT_TCSA1_ECKE               *((volatile unsigned char*)(0x42402ABCUL))
#define bFM_MFT0_FRT_TCSC1_MSZI0              *((volatile unsigned char*)(0x42402AC0UL))
#define bFM_MFT0_FRT_TCSC1_MSZI1              *((volatile unsigned char*)(0x42402AC4UL))
#define bFM_MFT0_FRT_TCSC1_MSZI2              *((volatile unsigned char*)(0x42402AC8UL))
#define bFM_MFT0_FRT_TCSC1_MSZI3              *((volatile unsigned char*)(0x42402ACCUL))
#define bFM_MFT0_FRT_TCSC1_MSPI0              *((volatile unsigned char*)(0x42402AD0UL))
#define bFM_MFT0_FRT_TCSC1_MSPI1              *((volatile unsigned char*)(0x42402AD4UL))
#define bFM_MFT0_FRT_TCSC1_MSPI2              *((volatile unsigned char*)(0x42402AD8UL))
#define bFM_MFT0_FRT_TCSC1_MSPI3              *((volatile unsigned char*)(0x42402ADCUL))
#define bFM_MFT0_FRT_TCSC1_MSZC0              *((volatile unsigned char*)(0x42402AE0UL))
#define bFM_MFT0_FRT_TCSC1_MSZC1              *((volatile unsigned char*)(0x42402AE4UL))
#define bFM_MFT0_FRT_TCSC1_MSZC2              *((volatile unsigned char*)(0x42402AE8UL))
#define bFM_MFT0_FRT_TCSC1_MSZC3              *((volatile unsigned char*)(0x42402AECUL))
#define bFM_MFT0_FRT_TCSC1_MSPC0              *((volatile unsigned char*)(0x42402AF0UL))
#define bFM_MFT0_FRT_TCSC1_MSPC1              *((volatile unsigned char*)(0x42402AF4UL))
#define bFM_MFT0_FRT_TCSC1_MSPC2              *((volatile unsigned char*)(0x42402AF8UL))
#define bFM_MFT0_FRT_TCSC1_MSPC3              *((volatile unsigned char*)(0x42402AFCUL))
#define bFM_MFT0_FRT_TCSA2_CLK0               *((volatile unsigned char*)(0x42402C00UL))
#define bFM_MFT0_FRT_TCSA2_CLK1               *((volatile unsigned char*)(0x42402C04UL))
#define bFM_MFT0_FRT_TCSA2_CLK2               *((volatile unsigned char*)(0x42402C08UL))
#define bFM_MFT0_FRT_TCSA2_CLK3               *((volatile unsigned char*)(0x42402C0CUL))
#define bFM_MFT0_FRT_TCSA2_SCLR               *((volatile unsigned char*)(0x42402C10UL))
#define bFM_MFT0_FRT_TCSA2_MODE               *((volatile unsigned char*)(0x42402C14UL))
#define bFM_MFT0_FRT_TCSA2_STOP               *((volatile unsigned char*)(0x42402C18UL))
#define bFM_MFT0_FRT_TCSA2_BFE                *((volatile unsigned char*)(0x42402C1CUL))
#define bFM_MFT0_FRT_TCSA2_ICRE               *((volatile unsigned char*)(0x42402C20UL))
#define bFM_MFT0_FRT_TCSA2_ICLR               *((volatile unsigned char*)(0x42402C24UL))
#define bFM_MFT0_FRT_TCSA2_IRQZE              *((volatile unsigned char*)(0x42402C34UL))
#define bFM_MFT0_FRT_TCSA2_IRQZF              *((volatile unsigned char*)(0x42402C38UL))
#define bFM_MFT0_FRT_TCSA2_ECKE               *((volatile unsigned char*)(0x42402C3CUL))
#define bFM_MFT0_FRT_TCSC2_MSZI0              *((volatile unsigned char*)(0x42402C40UL))
#define bFM_MFT0_FRT_TCSC2_MSZI1              *((volatile unsigned char*)(0x42402C44UL))
#define bFM_MFT0_FRT_TCSC2_MSZI2              *((volatile unsigned char*)(0x42402C48UL))
#define bFM_MFT0_FRT_TCSC2_MSZI3              *((volatile unsigned char*)(0x42402C4CUL))
#define bFM_MFT0_FRT_TCSC2_MSPI0              *((volatile unsigned char*)(0x42402C50UL))
#define bFM_MFT0_FRT_TCSC2_MSPI1              *((volatile unsigned char*)(0x42402C54UL))
#define bFM_MFT0_FRT_TCSC2_MSPI2              *((volatile unsigned char*)(0x42402C58UL))
#define bFM_MFT0_FRT_TCSC2_MSPI3              *((volatile unsigned char*)(0x42402C5CUL))
#define bFM_MFT0_FRT_TCSC2_MSZC0              *((volatile unsigned char*)(0x42402C60UL))
#define bFM_MFT0_FRT_TCSC2_MSZC1              *((volatile unsigned char*)(0x42402C64UL))
#define bFM_MFT0_FRT_TCSC2_MSZC2              *((volatile unsigned char*)(0x42402C68UL))
#define bFM_MFT0_FRT_TCSC2_MSZC3              *((volatile unsigned char*)(0x42402C6CUL))
#define bFM_MFT0_FRT_TCSC2_MSPC0              *((volatile unsigned char*)(0x42402C70UL))
#define bFM_MFT0_FRT_TCSC2_MSPC1              *((volatile unsigned char*)(0x42402C74UL))
#define bFM_MFT0_FRT_TCSC2_MSPC2              *((volatile unsigned char*)(0x42402C78UL))
#define bFM_MFT0_FRT_TCSC2_MSPC3              *((volatile unsigned char*)(0x42402C7CUL))
#define bFM_MFT0_FRT_TCAL_STOP00              *((volatile unsigned char*)(0x42402C80UL))
#define bFM_MFT0_FRT_TCAL_STOP01              *((volatile unsigned char*)(0x42402C84UL))
#define bFM_MFT0_FRT_TCAL_STOP02              *((volatile unsigned char*)(0x42402C88UL))
#define bFM_MFT0_FRT_TCAL_STOP10              *((volatile unsigned char*)(0x42402C8CUL))
#define bFM_MFT0_FRT_TCAL_STOP11              *((volatile unsigned char*)(0x42402C90UL))
#define bFM_MFT0_FRT_TCAL_STOP12              *((volatile unsigned char*)(0x42402C94UL))
#define bFM_MFT0_FRT_TCAL_STOP20              *((volatile unsigned char*)(0x42402C98UL))
#define bFM_MFT0_FRT_TCAL_STOP21              *((volatile unsigned char*)(0x42402C9CUL))
#define bFM_MFT0_FRT_TCAL_STOP22              *((volatile unsigned char*)(0x42402CA0UL))
#define bFM_MFT0_FRT_TCAL_SCLR00              *((volatile unsigned char*)(0x42402CC0UL))
#define bFM_MFT0_FRT_TCAL_SCLR01              *((volatile unsigned char*)(0x42402CC4UL))
#define bFM_MFT0_FRT_TCAL_SCLR02              *((volatile unsigned char*)(0x42402CC8UL))
#define bFM_MFT0_FRT_TCAL_SCLR10              *((volatile unsigned char*)(0x42402CCCUL))
#define bFM_MFT0_FRT_TCAL_SCLR11              *((volatile unsigned char*)(0x42402CD0UL))
#define bFM_MFT0_FRT_TCAL_SCLR12              *((volatile unsigned char*)(0x42402CD4UL))
#define bFM_MFT0_FRT_TCAL_SCLR20              *((volatile unsigned char*)(0x42402CD8UL))
#define bFM_MFT0_FRT_TCAL_SCLR21              *((volatile unsigned char*)(0x42402CDCUL))
#define bFM_MFT0_FRT_TCAL_SCLR22              *((volatile unsigned char*)(0x42402CE0UL))
#define bFM_MFT0_FRT_TCSD_OFMD1               *((volatile unsigned char*)(0x42403D80UL))
#define bFM_MFT0_FRT_TCSD_OFMD2               *((volatile unsigned char*)(0x42403D84UL))

/* Multifunction Timer unit 0 Output Compare Unit registers */
#define bFM_MFT0_OCU_OCSA10_CST0              *((volatile unsigned char*)(0x42402300UL))
#define bFM_MFT0_OCU_OCSA10_CST1              *((volatile unsigned char*)(0x42402304UL))
#define bFM_MFT0_OCU_OCSA10_IOE0              *((volatile unsigned char*)(0x42402310UL))
#define bFM_MFT0_OCU_OCSA10_IOE1              *((volatile unsigned char*)(0x42402314UL))
#define bFM_MFT0_OCU_OCSA10_IOP0              *((volatile unsigned char*)(0x42402318UL))
#define bFM_MFT0_OCU_OCSA10_IOP1              *((volatile unsigned char*)(0x4240231CUL))
#define bFM_MFT0_OCU_OCSB10_OTD0              *((volatile unsigned char*)(0x42402320UL))
#define bFM_MFT0_OCU_OCSB10_OTD1              *((volatile unsigned char*)(0x42402324UL))
#define bFM_MFT0_OCU_OCSB10_CMOD              *((volatile unsigned char*)(0x42402330UL))
#define bFM_MFT0_OCU_OCSB10_FM4               *((volatile unsigned char*)(0x4240233CUL))
#define bFM_MFT0_OCU_OCSD10_OCCP0BUFE0        *((volatile unsigned char*)(0x42402340UL))
#define bFM_MFT0_OCU_OCSD10_OCCP0BUFE1        *((volatile unsigned char*)(0x42402344UL))
#define bFM_MFT0_OCU_OCSD10_OCCP1BUFE0        *((volatile unsigned char*)(0x42402348UL))
#define bFM_MFT0_OCU_OCSD10_OCCP1BUFE1        *((volatile unsigned char*)(0x4240234CUL))
#define bFM_MFT0_OCU_OCSD10_OCSE0BUFE0        *((volatile unsigned char*)(0x42402350UL))
#define bFM_MFT0_OCU_OCSD10_OCSE0BUFE1        *((volatile unsigned char*)(0x42402354UL))
#define bFM_MFT0_OCU_OCSD10_OCSE1BUFE0        *((volatile unsigned char*)(0x42402358UL))
#define bFM_MFT0_OCU_OCSD10_OCSE1BUFE1        *((volatile unsigned char*)(0x4240235CUL))
#define bFM_MFT0_OCU_OCSD10_OPBM0             *((volatile unsigned char*)(0x42402360UL))
#define bFM_MFT0_OCU_OCSD10_OPBM1             *((volatile unsigned char*)(0x42402364UL))
#define bFM_MFT0_OCU_OCSD10_OEBM0             *((volatile unsigned char*)(0x42402368UL))
#define bFM_MFT0_OCU_OCSD10_OEBM1             *((volatile unsigned char*)(0x4240236CUL))
#define bFM_MFT0_OCU_OCSD10_OFEX0             *((volatile unsigned char*)(0x42402370UL))
#define bFM_MFT0_OCU_OCSD10_OFEX1             *((volatile unsigned char*)(0x42402374UL))
#define bFM_MFT0_OCU_OCSA32_CST0              *((volatile unsigned char*)(0x42402380UL))
#define bFM_MFT0_OCU_OCSA32_CST1              *((volatile unsigned char*)(0x42402384UL))
#define bFM_MFT0_OCU_OCSA32_IOE0              *((volatile unsigned char*)(0x42402390UL))
#define bFM_MFT0_OCU_OCSA32_IOE1              *((volatile unsigned char*)(0x42402394UL))
#define bFM_MFT0_OCU_OCSA32_IOP0              *((volatile unsigned char*)(0x42402398UL))
#define bFM_MFT0_OCU_OCSA32_IOP1              *((volatile unsigned char*)(0x4240239CUL))
#define bFM_MFT0_OCU_OCSB32_OTD0              *((volatile unsigned char*)(0x424023A0UL))
#define bFM_MFT0_OCU_OCSB32_OTD1              *((volatile unsigned char*)(0x424023A4UL))
#define bFM_MFT0_OCU_OCSB32_CMOD              *((volatile unsigned char*)(0x424023B0UL))
#define bFM_MFT0_OCU_OCSB32_FM4               *((volatile unsigned char*)(0x424023BCUL))
#define bFM_MFT0_OCU_OCSD32_OCCP2BUFE0        *((volatile unsigned char*)(0x424023C0UL))
#define bFM_MFT0_OCU_OCSD32_OCCP2BUFE1        *((volatile unsigned char*)(0x424023C4UL))
#define bFM_MFT0_OCU_OCSD32_OCCP3BUFE0        *((volatile unsigned char*)(0x424023C8UL))
#define bFM_MFT0_OCU_OCSD32_OCCP3BUFE1        *((volatile unsigned char*)(0x424023CCUL))
#define bFM_MFT0_OCU_OCSD32_OCSE2BUFE0        *((volatile unsigned char*)(0x424023D0UL))
#define bFM_MFT0_OCU_OCSD32_OCSE2BUFE1        *((volatile unsigned char*)(0x424023D4UL))
#define bFM_MFT0_OCU_OCSD32_OCSE3BUFE0        *((volatile unsigned char*)(0x424023D8UL))
#define bFM_MFT0_OCU_OCSD32_OCSE3BUFE1        *((volatile unsigned char*)(0x424023DCUL))
#define bFM_MFT0_OCU_OCSD32_OPBM2             *((volatile unsigned char*)(0x424023E0UL))
#define bFM_MFT0_OCU_OCSD32_OPBM3             *((volatile unsigned char*)(0x424023E4UL))
#define bFM_MFT0_OCU_OCSD32_OEBM2             *((volatile unsigned char*)(0x424023E8UL))
#define bFM_MFT0_OCU_OCSD32_OEBM3             *((volatile unsigned char*)(0x424023ECUL))
#define bFM_MFT0_OCU_OCSD32_OFEX2             *((volatile unsigned char*)(0x424023F0UL))
#define bFM_MFT0_OCU_OCSD32_OFEX3             *((volatile unsigned char*)(0x424023F4UL))
#define bFM_MFT0_OCU_OCSA54_CST0              *((volatile unsigned char*)(0x42402400UL))
#define bFM_MFT0_OCU_OCSA54_CST1              *((volatile unsigned char*)(0x42402404UL))
#define bFM_MFT0_OCU_OCSA54_IOE0              *((volatile unsigned char*)(0x42402410UL))
#define bFM_MFT0_OCU_OCSA54_IOE1              *((volatile unsigned char*)(0x42402414UL))
#define bFM_MFT0_OCU_OCSA54_IOP0              *((volatile unsigned char*)(0x42402418UL))
#define bFM_MFT0_OCU_OCSA54_IOP1              *((volatile unsigned char*)(0x4240241CUL))
#define bFM_MFT0_OCU_OCSB54_OTD0              *((volatile unsigned char*)(0x42402420UL))
#define bFM_MFT0_OCU_OCSB54_OTD1              *((volatile unsigned char*)(0x42402424UL))
#define bFM_MFT0_OCU_OCSB54_CMOD              *((volatile unsigned char*)(0x42402430UL))
#define bFM_MFT0_OCU_OCSB54_FM4               *((volatile unsigned char*)(0x4240243CUL))
#define bFM_MFT0_OCU_OCSD54_OCCP4BUFE0        *((volatile unsigned char*)(0x42402440UL))
#define bFM_MFT0_OCU_OCSD54_OCCP4BUFE1        *((volatile unsigned char*)(0x42402444UL))
#define bFM_MFT0_OCU_OCSD54_OCCP5BUFE0        *((volatile unsigned char*)(0x42402448UL))
#define bFM_MFT0_OCU_OCSD54_OCCP5BUFE1        *((volatile unsigned char*)(0x4240244CUL))
#define bFM_MFT0_OCU_OCSD54_OCSE4BUFE0        *((volatile unsigned char*)(0x42402450UL))
#define bFM_MFT0_OCU_OCSD54_OCSE4BUFE1        *((volatile unsigned char*)(0x42402454UL))
#define bFM_MFT0_OCU_OCSD54_OCSE5BUFE0        *((volatile unsigned char*)(0x42402458UL))
#define bFM_MFT0_OCU_OCSD54_OCSE5BUFE1        *((volatile unsigned char*)(0x4240245CUL))
#define bFM_MFT0_OCU_OCSD54_OPBM4             *((volatile unsigned char*)(0x42402460UL))
#define bFM_MFT0_OCU_OCSD54_OPBM5             *((volatile unsigned char*)(0x42402464UL))
#define bFM_MFT0_OCU_OCSD54_OEBM4             *((volatile unsigned char*)(0x42402468UL))
#define bFM_MFT0_OCU_OCSD54_OEBM5             *((volatile unsigned char*)(0x4240246CUL))
#define bFM_MFT0_OCU_OCSD54_OFEX4             *((volatile unsigned char*)(0x42402470UL))
#define bFM_MFT0_OCU_OCSD54_OFEX5             *((volatile unsigned char*)(0x42402474UL))
#define bFM_MFT0_OCU_OCSC_MOD0                *((volatile unsigned char*)(0x424024A0UL))
#define bFM_MFT0_OCU_OCSC_MOD1                *((volatile unsigned char*)(0x424024A4UL))
#define bFM_MFT0_OCU_OCSC_MOD2                *((volatile unsigned char*)(0x424024A8UL))
#define bFM_MFT0_OCU_OCSC_MOD3                *((volatile unsigned char*)(0x424024ACUL))
#define bFM_MFT0_OCU_OCSC_MOD4                *((volatile unsigned char*)(0x424024B0UL))
#define bFM_MFT0_OCU_OCSC_MOD5                *((volatile unsigned char*)(0x424024B4UL))
#define bFM_MFT0_OCU_OCFS10_FSO00             *((volatile unsigned char*)(0x42402D00UL))
#define bFM_MFT0_OCU_OCFS10_FSO01             *((volatile unsigned char*)(0x42402D04UL))
#define bFM_MFT0_OCU_OCFS10_FSO02             *((volatile unsigned char*)(0x42402D08UL))
#define bFM_MFT0_OCU_OCFS10_FSO03             *((volatile unsigned char*)(0x42402D0CUL))
#define bFM_MFT0_OCU_OCFS10_FSO10             *((volatile unsigned char*)(0x42402D10UL))
#define bFM_MFT0_OCU_OCFS10_FSO11             *((volatile unsigned char*)(0x42402D14UL))
#define bFM_MFT0_OCU_OCFS10_FSO12             *((volatile unsigned char*)(0x42402D18UL))
#define bFM_MFT0_OCU_OCFS10_FSO13             *((volatile unsigned char*)(0x42402D1CUL))
#define bFM_MFT0_OCU_OCFS32_FSO00             *((volatile unsigned char*)(0x42402D20UL))
#define bFM_MFT0_OCU_OCFS32_FSO01             *((volatile unsigned char*)(0x42402D24UL))
#define bFM_MFT0_OCU_OCFS32_FSO02             *((volatile unsigned char*)(0x42402D28UL))
#define bFM_MFT0_OCU_OCFS32_FSO03             *((volatile unsigned char*)(0x42402D2CUL))
#define bFM_MFT0_OCU_OCFS32_FSO10             *((volatile unsigned char*)(0x42402D30UL))
#define bFM_MFT0_OCU_OCFS32_FSO11             *((volatile unsigned char*)(0x42402D34UL))
#define bFM_MFT0_OCU_OCFS32_FSO12             *((volatile unsigned char*)(0x42402D38UL))
#define bFM_MFT0_OCU_OCFS32_FSO13             *((volatile unsigned char*)(0x42402D3CUL))
#define bFM_MFT0_OCU_OCFS54_FSO00             *((volatile unsigned char*)(0x42402D40UL))
#define bFM_MFT0_OCU_OCFS54_FSO01             *((volatile unsigned char*)(0x42402D44UL))
#define bFM_MFT0_OCU_OCFS54_FSO02             *((volatile unsigned char*)(0x42402D48UL))
#define bFM_MFT0_OCU_OCFS54_FSO03             *((volatile unsigned char*)(0x42402D4CUL))
#define bFM_MFT0_OCU_OCFS54_FSO10             *((volatile unsigned char*)(0x42402D50UL))
#define bFM_MFT0_OCU_OCFS54_FSO11             *((volatile unsigned char*)(0x42402D54UL))
#define bFM_MFT0_OCU_OCFS54_FSO12             *((volatile unsigned char*)(0x42402D58UL))
#define bFM_MFT0_OCU_OCFS54_FSO13             *((volatile unsigned char*)(0x42402D5CUL))

/* Multifunction Timer unit 0 Waveform Generator and Noise Canceler registers */
#define bFM_MFT0_WFG_WFSA10_DCK0              *((volatile unsigned char*)(0x42403480UL))
#define bFM_MFT0_WFG_WFSA10_DCK1              *((volatile unsigned char*)(0x42403484UL))
#define bFM_MFT0_WFG_WFSA10_DCK2              *((volatile unsigned char*)(0x42403488UL))
#define bFM_MFT0_WFG_WFSA10_GTEN0             *((volatile unsigned char*)(0x42403498UL))
#define bFM_MFT0_WFG_WFSA10_GTEN1             *((volatile unsigned char*)(0x4240349CUL))
#define bFM_MFT0_WFG_WFSA10_PSEL0             *((volatile unsigned char*)(0x424034A0UL))
#define bFM_MFT0_WFG_WFSA10_PSEL1             *((volatile unsigned char*)(0x424034A4UL))
#define bFM_MFT0_WFG_WFSA10_PGEN0             *((volatile unsigned char*)(0x424034A8UL))
#define bFM_MFT0_WFG_WFSA10_PGEN1             *((volatile unsigned char*)(0x424034ACUL))
#define bFM_MFT0_WFG_WFSA32_DCK0              *((volatile unsigned char*)(0x42403500UL))
#define bFM_MFT0_WFG_WFSA32_DCK1              *((volatile unsigned char*)(0x42403504UL))
#define bFM_MFT0_WFG_WFSA32_DCK2              *((volatile unsigned char*)(0x42403508UL))
#define bFM_MFT0_WFG_WFSA32_GTEN0             *((volatile unsigned char*)(0x42403518UL))
#define bFM_MFT0_WFG_WFSA32_GTEN1             *((volatile unsigned char*)(0x4240351CUL))
#define bFM_MFT0_WFG_WFSA32_PSEL0             *((volatile unsigned char*)(0x42403520UL))
#define bFM_MFT0_WFG_WFSA32_PSEL1             *((volatile unsigned char*)(0x42403524UL))
#define bFM_MFT0_WFG_WFSA32_PGEN0             *((volatile unsigned char*)(0x42403528UL))
#define bFM_MFT0_WFG_WFSA32_PGEN1             *((volatile unsigned char*)(0x4240352CUL))
#define bFM_MFT0_WFG_WFSA54_DCK0              *((volatile unsigned char*)(0x42403580UL))
#define bFM_MFT0_WFG_WFSA54_DCK1              *((volatile unsigned char*)(0x42403584UL))
#define bFM_MFT0_WFG_WFSA54_DCK2              *((volatile unsigned char*)(0x42403588UL))
#define bFM_MFT0_WFG_WFSA54_GTEN0             *((volatile unsigned char*)(0x42403598UL))
#define bFM_MFT0_WFG_WFSA54_GTEN1             *((volatile unsigned char*)(0x4240359CUL))
#define bFM_MFT0_WFG_WFSA54_PSEL0             *((volatile unsigned char*)(0x424035A0UL))
#define bFM_MFT0_WFG_WFSA54_PSEL1             *((volatile unsigned char*)(0x424035A4UL))
#define bFM_MFT0_WFG_WFSA54_PGEN0             *((volatile unsigned char*)(0x424035A8UL))
#define bFM_MFT0_WFG_WFSA54_PGEN1             *((volatile unsigned char*)(0x424035ACUL))
#define bFM_MFT0_WFG_WFIR_DTIFA               *((volatile unsigned char*)(0x42403600UL))
#define bFM_MFT0_WFG_WFIR_DTICA               *((volatile unsigned char*)(0x42403604UL))
#define bFM_MFT0_WFG_WFIR_DTIFB               *((volatile unsigned char*)(0x42403608UL))
#define bFM_MFT0_WFG_WFIR_DTICB               *((volatile unsigned char*)(0x4240360CUL))
#define bFM_MFT0_WFG_WFIR_TMIF10              *((volatile unsigned char*)(0x42403610UL))
#define bFM_MFT0_WFG_WFIR_TMIC10              *((volatile unsigned char*)(0x42403614UL))
#define bFM_MFT0_WFG_WFIR_TMIE10              *((volatile unsigned char*)(0x42403618UL))
#define bFM_MFT0_WFG_WFIR_TMIS10              *((volatile unsigned char*)(0x4240361CUL))
#define bFM_MFT0_WFG_WFIR_TMIF32              *((volatile unsigned char*)(0x42403620UL))
#define bFM_MFT0_WFG_WFIR_TMIC32              *((volatile unsigned char*)(0x42403624UL))
#define bFM_MFT0_WFG_WFIR_TMIE32              *((volatile unsigned char*)(0x42403628UL))
#define bFM_MFT0_WFG_WFIR_TMIS32              *((volatile unsigned char*)(0x4240362CUL))
#define bFM_MFT0_WFG_WFIR_TMIF54              *((volatile unsigned char*)(0x42403630UL))
#define bFM_MFT0_WFG_WFIR_TMIC54              *((volatile unsigned char*)(0x42403634UL))
#define bFM_MFT0_WFG_WFIR_TMIE54              *((volatile unsigned char*)(0x42403638UL))
#define bFM_MFT0_WFG_WFIR_TMIS54              *((volatile unsigned char*)(0x4240363CUL))
#define bFM_MFT0_WFG_NZCL_DTIEA               *((volatile unsigned char*)(0x42403680UL))
#define bFM_MFT0_WFG_NZCL_NWS0                *((volatile unsigned char*)(0x42403684UL))
#define bFM_MFT0_WFG_NZCL_NWS1                *((volatile unsigned char*)(0x42403688UL))
#define bFM_MFT0_WFG_NZCL_NWS2                *((volatile unsigned char*)(0x4240368CUL))
#define bFM_MFT0_WFG_NZCL_SDTI                *((volatile unsigned char*)(0x42403690UL))
#define bFM_MFT0_WFG_NZCL_DTIEB               *((volatile unsigned char*)(0x42403694UL))
#define bFM_MFT0_WFG_NZCL_DHOLD               *((volatile unsigned char*)(0x4240369CUL))
#define bFM_MFT0_WFG_NZCL_DIMA                *((volatile unsigned char*)(0x424036A0UL))
#define bFM_MFT0_WFG_NZCL_DIMB                *((volatile unsigned char*)(0x424036A4UL))
#define bFM_MFT0_WFG_NZCL_WIM10               *((volatile unsigned char*)(0x424036B0UL))
#define bFM_MFT0_WFG_NZCL_WIM32               *((volatile unsigned char*)(0x424036B4UL))
#define bFM_MFT0_WFG_NZCL_WIM54               *((volatile unsigned char*)(0x424036B8UL))

/* Multifunction Timer unit 0 Input Capture Unit registers */
#define bFM_MFT0_ICU_ICFS10_FSI00             *((volatile unsigned char*)(0x42402D80UL))
#define bFM_MFT0_ICU_ICFS10_FSI01             *((volatile unsigned char*)(0x42402D84UL))
#define bFM_MFT0_ICU_ICFS10_FSI02             *((volatile unsigned char*)(0x42402D88UL))
#define bFM_MFT0_ICU_ICFS10_FSI03             *((volatile unsigned char*)(0x42402D8CUL))
#define bFM_MFT0_ICU_ICFS10_FSI10             *((volatile unsigned char*)(0x42402D90UL))
#define bFM_MFT0_ICU_ICFS10_FSI11             *((volatile unsigned char*)(0x42402D94UL))
#define bFM_MFT0_ICU_ICFS10_FSI12             *((volatile unsigned char*)(0x42402D98UL))
#define bFM_MFT0_ICU_ICFS10_FSI13             *((volatile unsigned char*)(0x42402D9CUL))
#define bFM_MFT0_ICU_ICFS32_FSI00             *((volatile unsigned char*)(0x42402DA0UL))
#define bFM_MFT0_ICU_ICFS32_FSI01             *((volatile unsigned char*)(0x42402DA4UL))
#define bFM_MFT0_ICU_ICFS32_FSI02             *((volatile unsigned char*)(0x42402DA8UL))
#define bFM_MFT0_ICU_ICFS32_FSI03             *((volatile unsigned char*)(0x42402DACUL))
#define bFM_MFT0_ICU_ICFS32_FSI10             *((volatile unsigned char*)(0x42402DB0UL))
#define bFM_MFT0_ICU_ICFS32_FSI11             *((volatile unsigned char*)(0x42402DB4UL))
#define bFM_MFT0_ICU_ICFS32_FSI12             *((volatile unsigned char*)(0x42402DB8UL))
#define bFM_MFT0_ICU_ICFS32_FSI13             *((volatile unsigned char*)(0x42402DBCUL))
#define bFM_MFT0_ICU_ICSA10_EG00              *((volatile unsigned char*)(0x42403080UL))
#define bFM_MFT0_ICU_ICSA10_EG01              *((volatile unsigned char*)(0x42403084UL))
#define bFM_MFT0_ICU_ICSA10_EG10              *((volatile unsigned char*)(0x42403088UL))
#define bFM_MFT0_ICU_ICSA10_EG11              *((volatile unsigned char*)(0x4240308CUL))
#define bFM_MFT0_ICU_ICSA10_ICE0              *((volatile unsigned char*)(0x42403090UL))
#define bFM_MFT0_ICU_ICSA10_ICE1              *((volatile unsigned char*)(0x42403094UL))
#define bFM_MFT0_ICU_ICSA10_ICP0              *((volatile unsigned char*)(0x42403098UL))
#define bFM_MFT0_ICU_ICSA10_ICP1              *((volatile unsigned char*)(0x4240309CUL))
#define bFM_MFT0_ICU_ICSB10_IEI0              *((volatile unsigned char*)(0x424030A0UL))
#define bFM_MFT0_ICU_ICSB10_IEI1              *((volatile unsigned char*)(0x424030A4UL))
#define bFM_MFT0_ICU_ICSA32_EG00              *((volatile unsigned char*)(0x42403100UL))
#define bFM_MFT0_ICU_ICSA32_EG01              *((volatile unsigned char*)(0x42403104UL))
#define bFM_MFT0_ICU_ICSA32_EG10              *((volatile unsigned char*)(0x42403108UL))
#define bFM_MFT0_ICU_ICSA32_EG11              *((volatile unsigned char*)(0x4240310CUL))
#define bFM_MFT0_ICU_ICSA32_ICE0              *((volatile unsigned char*)(0x42403110UL))
#define bFM_MFT0_ICU_ICSA32_ICE1              *((volatile unsigned char*)(0x42403114UL))
#define bFM_MFT0_ICU_ICSA32_ICP0              *((volatile unsigned char*)(0x42403118UL))
#define bFM_MFT0_ICU_ICSA32_ICP1              *((volatile unsigned char*)(0x4240311CUL))
#define bFM_MFT0_ICU_ICSB32_IEI0              *((volatile unsigned char*)(0x42403120UL))
#define bFM_MFT0_ICU_ICSB32_IEI1              *((volatile unsigned char*)(0x42403124UL))

/* Multifunction Timer unit 0 ADC Start Compare Unit registers */
#define bFM_MFT0_ADCMP_ACSC0_BUFE0            *((volatile unsigned char*)(0x42403A80UL))
#define bFM_MFT0_ADCMP_ACSC0_BUFE1            *((volatile unsigned char*)(0x42403A84UL))
#define bFM_MFT0_ADCMP_ACSC0_ADSEL0           *((volatile unsigned char*)(0x42403A88UL))
#define bFM_MFT0_ADCMP_ACSC0_ADSEL1           *((volatile unsigned char*)(0x42403A8CUL))
#define bFM_MFT0_ADCMP_ACSC0_ADSEL2           *((volatile unsigned char*)(0x42403A90UL))
#define bFM_MFT0_ADCMP_ACSC0_APBM             *((volatile unsigned char*)(0x42403A94UL))
#define bFM_MFT0_ADCMP_ACSD0_AMOD             *((volatile unsigned char*)(0x42403AA0UL))
#define bFM_MFT0_ADCMP_ACSD0_OCUS             *((volatile unsigned char*)(0x42403AA4UL))
#define bFM_MFT0_ADCMP_ACSD0_DE               *((volatile unsigned char*)(0x42403AB0UL))
#define bFM_MFT0_ADCMP_ACSD0_PE               *((volatile unsigned char*)(0x42403AB4UL))
#define bFM_MFT0_ADCMP_ACSD0_UE               *((volatile unsigned char*)(0x42403AB8UL))
#define bFM_MFT0_ADCMP_ACSD0_ZE               *((volatile unsigned char*)(0x42403ABCUL))
#define bFM_MFT0_ADCMP_ACMC0_AMC0             *((volatile unsigned char*)(0x42403AC0UL))
#define bFM_MFT0_ADCMP_ACMC0_AMC1             *((volatile unsigned char*)(0x42403AC4UL))
#define bFM_MFT0_ADCMP_ACMC0_AMC2             *((volatile unsigned char*)(0x42403AC8UL))
#define bFM_MFT0_ADCMP_ACMC0_AMC3             *((volatile unsigned char*)(0x42403ACCUL))
#define bFM_MFT0_ADCMP_ACMC0_MZCE             *((volatile unsigned char*)(0x42403AD8UL))
#define bFM_MFT0_ADCMP_ACMC0_MPCE             *((volatile unsigned char*)(0x42403ADCUL))
#define bFM_MFT0_ADCMP_ACSC1_BUFE0            *((volatile unsigned char*)(0x42403B00UL))
#define bFM_MFT0_ADCMP_ACSC1_BUFE1            *((volatile unsigned char*)(0x42403B04UL))
#define bFM_MFT0_ADCMP_ACSC1_ADSEL0           *((volatile unsigned char*)(0x42403B08UL))
#define bFM_MFT0_ADCMP_ACSC1_ADSEL1           *((volatile unsigned char*)(0x42403B0CUL))
#define bFM_MFT0_ADCMP_ACSC1_ADSEL2           *((volatile unsigned char*)(0x42403B10UL))
#define bFM_MFT0_ADCMP_ACSC1_APBM             *((volatile unsigned char*)(0x42403B14UL))
#define bFM_MFT0_ADCMP_ACSD1_AMOD             *((volatile unsigned char*)(0x42403B20UL))
#define bFM_MFT0_ADCMP_ACSD1_OCUS             *((volatile unsigned char*)(0x42403B24UL))
#define bFM_MFT0_ADCMP_ACSD1_DE               *((volatile unsigned char*)(0x42403B30UL))
#define bFM_MFT0_ADCMP_ACSD1_PE               *((volatile unsigned char*)(0x42403B34UL))
#define bFM_MFT0_ADCMP_ACSD1_UE               *((volatile unsigned char*)(0x42403B38UL))
#define bFM_MFT0_ADCMP_ACSD1_ZE               *((volatile unsigned char*)(0x42403B3CUL))
#define bFM_MFT0_ADCMP_ACMC1_AMC0             *((volatile unsigned char*)(0x42403B40UL))
#define bFM_MFT0_ADCMP_ACMC1_AMC1             *((volatile unsigned char*)(0x42403B44UL))
#define bFM_MFT0_ADCMP_ACMC1_AMC2             *((volatile unsigned char*)(0x42403B48UL))
#define bFM_MFT0_ADCMP_ACMC1_AMC3             *((volatile unsigned char*)(0x42403B4CUL))
#define bFM_MFT0_ADCMP_ACMC1_MZCE             *((volatile unsigned char*)(0x42403B58UL))
#define bFM_MFT0_ADCMP_ACMC1_MPCE             *((volatile unsigned char*)(0x42403B5CUL))
#define bFM_MFT0_ADCMP_ACSC2_BUFE0            *((volatile unsigned char*)(0x42403B80UL))
#define bFM_MFT0_ADCMP_ACSC2_BUFE1            *((volatile unsigned char*)(0x42403B84UL))
#define bFM_MFT0_ADCMP_ACSC2_ADSEL0           *((volatile unsigned char*)(0x42403B88UL))
#define bFM_MFT0_ADCMP_ACSC2_ADSEL1           *((volatile unsigned char*)(0x42403B8CUL))
#define bFM_MFT0_ADCMP_ACSC2_ADSEL2           *((volatile unsigned char*)(0x42403B90UL))
#define bFM_MFT0_ADCMP_ACSC2_APBM             *((volatile unsigned char*)(0x42403B94UL))
#define bFM_MFT0_ADCMP_ACSD2_AMOD             *((volatile unsigned char*)(0x42403BA0UL))
#define bFM_MFT0_ADCMP_ACSD2_OCUS             *((volatile unsigned char*)(0x42403BA4UL))
#define bFM_MFT0_ADCMP_ACSD2_DE               *((volatile unsigned char*)(0x42403BB0UL))
#define bFM_MFT0_ADCMP_ACSD2_PE               *((volatile unsigned char*)(0x42403BB4UL))
#define bFM_MFT0_ADCMP_ACSD2_UE               *((volatile unsigned char*)(0x42403BB8UL))
#define bFM_MFT0_ADCMP_ACSD2_ZE               *((volatile unsigned char*)(0x42403BBCUL))
#define bFM_MFT0_ADCMP_ACMC2_AMC0             *((volatile unsigned char*)(0x42403BC0UL))
#define bFM_MFT0_ADCMP_ACMC2_AMC1             *((volatile unsigned char*)(0x42403BC4UL))
#define bFM_MFT0_ADCMP_ACMC2_AMC2             *((volatile unsigned char*)(0x42403BC8UL))
#define bFM_MFT0_ADCMP_ACMC2_AMC3             *((volatile unsigned char*)(0x42403BCCUL))
#define bFM_MFT0_ADCMP_ACMC2_MZCE             *((volatile unsigned char*)(0x42403BD8UL))
#define bFM_MFT0_ADCMP_ACMC2_MPCE             *((volatile unsigned char*)(0x42403BDCUL))
#define bFM_MFT0_ADCMP_ACSC3_BUFE0            *((volatile unsigned char*)(0x42403C00UL))
#define bFM_MFT0_ADCMP_ACSC3_BUFE1            *((volatile unsigned char*)(0x42403C04UL))
#define bFM_MFT0_ADCMP_ACSC3_ADSEL0           *((volatile unsigned char*)(0x42403C08UL))
#define bFM_MFT0_ADCMP_ACSC3_ADSEL1           *((volatile unsigned char*)(0x42403C0CUL))
#define bFM_MFT0_ADCMP_ACSC3_ADSEL2           *((volatile unsigned char*)(0x42403C10UL))
#define bFM_MFT0_ADCMP_ACSC3_APBM             *((volatile unsigned char*)(0x42403C14UL))
#define bFM_MFT0_ADCMP_ACSD3_AMOD             *((volatile unsigned char*)(0x42403C20UL))
#define bFM_MFT0_ADCMP_ACSD3_OCUS             *((volatile unsigned char*)(0x42403C24UL))
#define bFM_MFT0_ADCMP_ACSD3_DE               *((volatile unsigned char*)(0x42403C30UL))
#define bFM_MFT0_ADCMP_ACSD3_PE               *((volatile unsigned char*)(0x42403C34UL))
#define bFM_MFT0_ADCMP_ACSD3_UE               *((volatile unsigned char*)(0x42403C38UL))
#define bFM_MFT0_ADCMP_ACSD3_ZE               *((volatile unsigned char*)(0x42403C3CUL))
#define bFM_MFT0_ADCMP_ACMC3_AMC0             *((volatile unsigned char*)(0x42403C40UL))
#define bFM_MFT0_ADCMP_ACMC3_AMC1             *((volatile unsigned char*)(0x42403C44UL))
#define bFM_MFT0_ADCMP_ACMC3_AMC2             *((volatile unsigned char*)(0x42403C48UL))
#define bFM_MFT0_ADCMP_ACMC3_AMC3             *((volatile unsigned char*)(0x42403C4CUL))
#define bFM_MFT0_ADCMP_ACMC3_MZCE             *((volatile unsigned char*)(0x42403C58UL))
#define bFM_MFT0_ADCMP_ACMC3_MPCE             *((volatile unsigned char*)(0x42403C5CUL))
#define bFM_MFT0_ADCMP_ACSC4_BUFE0            *((volatile unsigned char*)(0x42403C80UL))
#define bFM_MFT0_ADCMP_ACSC4_BUFE1            *((volatile unsigned char*)(0x42403C84UL))
#define bFM_MFT0_ADCMP_ACSC4_ADSEL0           *((volatile unsigned char*)(0x42403C88UL))
#define bFM_MFT0_ADCMP_ACSC4_ADSEL1           *((volatile unsigned char*)(0x42403C8CUL))
#define bFM_MFT0_ADCMP_ACSC4_ADSEL2           *((volatile unsigned char*)(0x42403C90UL))
#define bFM_MFT0_ADCMP_ACSC4_APBM             *((volatile unsigned char*)(0x42403C94UL))
#define bFM_MFT0_ADCMP_ACSD4_AMOD             *((volatile unsigned char*)(0x42403CA0UL))
#define bFM_MFT0_ADCMP_ACSD4_OCUS             *((volatile unsigned char*)(0x42403CA4UL))
#define bFM_MFT0_ADCMP_ACSD4_DE               *((volatile unsigned char*)(0x42403CB0UL))
#define bFM_MFT0_ADCMP_ACSD4_PE               *((volatile unsigned char*)(0x42403CB4UL))
#define bFM_MFT0_ADCMP_ACSD4_UE               *((volatile unsigned char*)(0x42403CB8UL))
#define bFM_MFT0_ADCMP_ACSD4_ZE               *((volatile unsigned char*)(0x42403CBCUL))
#define bFM_MFT0_ADCMP_ACMC4_AMC0             *((volatile unsigned char*)(0x42403CC0UL))
#define bFM_MFT0_ADCMP_ACMC4_AMC1             *((volatile unsigned char*)(0x42403CC4UL))
#define bFM_MFT0_ADCMP_ACMC4_AMC2             *((volatile unsigned char*)(0x42403CC8UL))
#define bFM_MFT0_ADCMP_ACMC4_AMC3             *((volatile unsigned char*)(0x42403CCCUL))
#define bFM_MFT0_ADCMP_ACMC4_MZCE             *((volatile unsigned char*)(0x42403CD8UL))
#define bFM_MFT0_ADCMP_ACMC4_MPCE             *((volatile unsigned char*)(0x42403CDCUL))
#define bFM_MFT0_ADCMP_ACSC5_BUFE0            *((volatile unsigned char*)(0x42403D00UL))
#define bFM_MFT0_ADCMP_ACSC5_BUFE1            *((volatile unsigned char*)(0x42403D04UL))
#define bFM_MFT0_ADCMP_ACSC5_ADSEL0           *((volatile unsigned char*)(0x42403D08UL))
#define bFM_MFT0_ADCMP_ACSC5_ADSEL1           *((volatile unsigned char*)(0x42403D0CUL))
#define bFM_MFT0_ADCMP_ACSC5_ADSEL2           *((volatile unsigned char*)(0x42403D10UL))
#define bFM_MFT0_ADCMP_ACSC5_APBM             *((volatile unsigned char*)(0x42403D14UL))
#define bFM_MFT0_ADCMP_ACSD5_AMOD             *((volatile unsigned char*)(0x42403D20UL))
#define bFM_MFT0_ADCMP_ACSD5_OCUS             *((volatile unsigned char*)(0x42403D24UL))
#define bFM_MFT0_ADCMP_ACSD5_DE               *((volatile unsigned char*)(0x42403D30UL))
#define bFM_MFT0_ADCMP_ACSD5_PE               *((volatile unsigned char*)(0x42403D34UL))
#define bFM_MFT0_ADCMP_ACSD5_UE               *((volatile unsigned char*)(0x42403D38UL))
#define bFM_MFT0_ADCMP_ACSD5_ZE               *((volatile unsigned char*)(0x42403D3CUL))
#define bFM_MFT0_ADCMP_ACMC5_AMC0             *((volatile unsigned char*)(0x42403D40UL))
#define bFM_MFT0_ADCMP_ACMC5_AMC1             *((volatile unsigned char*)(0x42403D44UL))
#define bFM_MFT0_ADCMP_ACMC5_AMC2             *((volatile unsigned char*)(0x42403D48UL))
#define bFM_MFT0_ADCMP_ACMC5_AMC3             *((volatile unsigned char*)(0x42403D4CUL))
#define bFM_MFT0_ADCMP_ACMC5_MZCE             *((volatile unsigned char*)(0x42403D58UL))
#define bFM_MFT0_ADCMP_ACMC5_MPCE             *((volatile unsigned char*)(0x42403D5CUL))

/* Multifunction Timer unit 1 Free Running Timer registers */
#define bFM_MFT1_FRT_TCSA0_CLK0               *((volatile unsigned char*)(0x42422900UL))
#define bFM_MFT1_FRT_TCSA0_CLK1               *((volatile unsigned char*)(0x42422904UL))
#define bFM_MFT1_FRT_TCSA0_CLK2               *((volatile unsigned char*)(0x42422908UL))
#define bFM_MFT1_FRT_TCSA0_CLK3               *((volatile unsigned char*)(0x4242290CUL))
#define bFM_MFT1_FRT_TCSA0_SCLR               *((volatile unsigned char*)(0x42422910UL))
#define bFM_MFT1_FRT_TCSA0_MODE               *((volatile unsigned char*)(0x42422914UL))
#define bFM_MFT1_FRT_TCSA0_STOP               *((volatile unsigned char*)(0x42422918UL))
#define bFM_MFT1_FRT_TCSA0_BFE                *((volatile unsigned char*)(0x4242291CUL))
#define bFM_MFT1_FRT_TCSA0_ICRE               *((volatile unsigned char*)(0x42422920UL))
#define bFM_MFT1_FRT_TCSA0_ICLR               *((volatile unsigned char*)(0x42422924UL))
#define bFM_MFT1_FRT_TCSA0_IRQZE              *((volatile unsigned char*)(0x42422934UL))
#define bFM_MFT1_FRT_TCSA0_IRQZF              *((volatile unsigned char*)(0x42422938UL))
#define bFM_MFT1_FRT_TCSA0_ECKE               *((volatile unsigned char*)(0x4242293CUL))
#define bFM_MFT1_FRT_TCSC0_MSZI0              *((volatile unsigned char*)(0x42422940UL))
#define bFM_MFT1_FRT_TCSC0_MSZI1              *((volatile unsigned char*)(0x42422944UL))
#define bFM_MFT1_FRT_TCSC0_MSZI2              *((volatile unsigned char*)(0x42422948UL))
#define bFM_MFT1_FRT_TCSC0_MSZI3              *((volatile unsigned char*)(0x4242294CUL))
#define bFM_MFT1_FRT_TCSC0_MSPI0              *((volatile unsigned char*)(0x42422950UL))
#define bFM_MFT1_FRT_TCSC0_MSPI1              *((volatile unsigned char*)(0x42422954UL))
#define bFM_MFT1_FRT_TCSC0_MSPI2              *((volatile unsigned char*)(0x42422958UL))
#define bFM_MFT1_FRT_TCSC0_MSPI3              *((volatile unsigned char*)(0x4242295CUL))
#define bFM_MFT1_FRT_TCSC0_MSZC0              *((volatile unsigned char*)(0x42422960UL))
#define bFM_MFT1_FRT_TCSC0_MSZC1              *((volatile unsigned char*)(0x42422964UL))
#define bFM_MFT1_FRT_TCSC0_MSZC2              *((volatile unsigned char*)(0x42422968UL))
#define bFM_MFT1_FRT_TCSC0_MSZC3              *((volatile unsigned char*)(0x4242296CUL))
#define bFM_MFT1_FRT_TCSC0_MSPC0              *((volatile unsigned char*)(0x42422970UL))
#define bFM_MFT1_FRT_TCSC0_MSPC1              *((volatile unsigned char*)(0x42422974UL))
#define bFM_MFT1_FRT_TCSC0_MSPC2              *((volatile unsigned char*)(0x42422978UL))
#define bFM_MFT1_FRT_TCSC0_MSPC3              *((volatile unsigned char*)(0x4242297CUL))
#define bFM_MFT1_FRT_TCSA1_CLK0               *((volatile unsigned char*)(0x42422A80UL))
#define bFM_MFT1_FRT_TCSA1_CLK1               *((volatile unsigned char*)(0x42422A84UL))
#define bFM_MFT1_FRT_TCSA1_CLK2               *((volatile unsigned char*)(0x42422A88UL))
#define bFM_MFT1_FRT_TCSA1_CLK3               *((volatile unsigned char*)(0x42422A8CUL))
#define bFM_MFT1_FRT_TCSA1_SCLR               *((volatile unsigned char*)(0x42422A90UL))
#define bFM_MFT1_FRT_TCSA1_MODE               *((volatile unsigned char*)(0x42422A94UL))
#define bFM_MFT1_FRT_TCSA1_STOP               *((volatile unsigned char*)(0x42422A98UL))
#define bFM_MFT1_FRT_TCSA1_BFE                *((volatile unsigned char*)(0x42422A9CUL))
#define bFM_MFT1_FRT_TCSA1_ICRE               *((volatile unsigned char*)(0x42422AA0UL))
#define bFM_MFT1_FRT_TCSA1_ICLR               *((volatile unsigned char*)(0x42422AA4UL))
#define bFM_MFT1_FRT_TCSA1_IRQZE              *((volatile unsigned char*)(0x42422AB4UL))
#define bFM_MFT1_FRT_TCSA1_IRQZF              *((volatile unsigned char*)(0x42422AB8UL))
#define bFM_MFT1_FRT_TCSA1_ECKE               *((volatile unsigned char*)(0x42422ABCUL))
#define bFM_MFT1_FRT_TCSC1_MSZI0              *((volatile unsigned char*)(0x42422AC0UL))
#define bFM_MFT1_FRT_TCSC1_MSZI1              *((volatile unsigned char*)(0x42422AC4UL))
#define bFM_MFT1_FRT_TCSC1_MSZI2              *((volatile unsigned char*)(0x42422AC8UL))
#define bFM_MFT1_FRT_TCSC1_MSZI3              *((volatile unsigned char*)(0x42422ACCUL))
#define bFM_MFT1_FRT_TCSC1_MSPI0              *((volatile unsigned char*)(0x42422AD0UL))
#define bFM_MFT1_FRT_TCSC1_MSPI1              *((volatile unsigned char*)(0x42422AD4UL))
#define bFM_MFT1_FRT_TCSC1_MSPI2              *((volatile unsigned char*)(0x42422AD8UL))
#define bFM_MFT1_FRT_TCSC1_MSPI3              *((volatile unsigned char*)(0x42422ADCUL))
#define bFM_MFT1_FRT_TCSC1_MSZC0              *((volatile unsigned char*)(0x42422AE0UL))
#define bFM_MFT1_FRT_TCSC1_MSZC1              *((volatile unsigned char*)(0x42422AE4UL))
#define bFM_MFT1_FRT_TCSC1_MSZC2              *((volatile unsigned char*)(0x42422AE8UL))
#define bFM_MFT1_FRT_TCSC1_MSZC3              *((volatile unsigned char*)(0x42422AECUL))
#define bFM_MFT1_FRT_TCSC1_MSPC0              *((volatile unsigned char*)(0x42422AF0UL))
#define bFM_MFT1_FRT_TCSC1_MSPC1              *((volatile unsigned char*)(0x42422AF4UL))
#define bFM_MFT1_FRT_TCSC1_MSPC2              *((volatile unsigned char*)(0x42422AF8UL))
#define bFM_MFT1_FRT_TCSC1_MSPC3              *((volatile unsigned char*)(0x42422AFCUL))
#define bFM_MFT1_FRT_TCSA2_CLK0               *((volatile unsigned char*)(0x42422C00UL))
#define bFM_MFT1_FRT_TCSA2_CLK1               *((volatile unsigned char*)(0x42422C04UL))
#define bFM_MFT1_FRT_TCSA2_CLK2               *((volatile unsigned char*)(0x42422C08UL))
#define bFM_MFT1_FRT_TCSA2_CLK3               *((volatile unsigned char*)(0x42422C0CUL))
#define bFM_MFT1_FRT_TCSA2_SCLR               *((volatile unsigned char*)(0x42422C10UL))
#define bFM_MFT1_FRT_TCSA2_MODE               *((volatile unsigned char*)(0x42422C14UL))
#define bFM_MFT1_FRT_TCSA2_STOP               *((volatile unsigned char*)(0x42422C18UL))
#define bFM_MFT1_FRT_TCSA2_BFE                *((volatile unsigned char*)(0x42422C1CUL))
#define bFM_MFT1_FRT_TCSA2_ICRE               *((volatile unsigned char*)(0x42422C20UL))
#define bFM_MFT1_FRT_TCSA2_ICLR               *((volatile unsigned char*)(0x42422C24UL))
#define bFM_MFT1_FRT_TCSA2_IRQZE              *((volatile unsigned char*)(0x42422C34UL))
#define bFM_MFT1_FRT_TCSA2_IRQZF              *((volatile unsigned char*)(0x42422C38UL))
#define bFM_MFT1_FRT_TCSA2_ECKE               *((volatile unsigned char*)(0x42422C3CUL))
#define bFM_MFT1_FRT_TCSC2_MSZI0              *((volatile unsigned char*)(0x42422C40UL))
#define bFM_MFT1_FRT_TCSC2_MSZI1              *((volatile unsigned char*)(0x42422C44UL))
#define bFM_MFT1_FRT_TCSC2_MSZI2              *((volatile unsigned char*)(0x42422C48UL))
#define bFM_MFT1_FRT_TCSC2_MSZI3              *((volatile unsigned char*)(0x42422C4CUL))
#define bFM_MFT1_FRT_TCSC2_MSPI0              *((volatile unsigned char*)(0x42422C50UL))
#define bFM_MFT1_FRT_TCSC2_MSPI1              *((volatile unsigned char*)(0x42422C54UL))
#define bFM_MFT1_FRT_TCSC2_MSPI2              *((volatile unsigned char*)(0x42422C58UL))
#define bFM_MFT1_FRT_TCSC2_MSPI3              *((volatile unsigned char*)(0x42422C5CUL))
#define bFM_MFT1_FRT_TCSC2_MSZC0              *((volatile unsigned char*)(0x42422C60UL))
#define bFM_MFT1_FRT_TCSC2_MSZC1              *((volatile unsigned char*)(0x42422C64UL))
#define bFM_MFT1_FRT_TCSC2_MSZC2              *((volatile unsigned char*)(0x42422C68UL))
#define bFM_MFT1_FRT_TCSC2_MSZC3              *((volatile unsigned char*)(0x42422C6CUL))
#define bFM_MFT1_FRT_TCSC2_MSPC0              *((volatile unsigned char*)(0x42422C70UL))
#define bFM_MFT1_FRT_TCSC2_MSPC1              *((volatile unsigned char*)(0x42422C74UL))
#define bFM_MFT1_FRT_TCSC2_MSPC2              *((volatile unsigned char*)(0x42422C78UL))
#define bFM_MFT1_FRT_TCSC2_MSPC3              *((volatile unsigned char*)(0x42422C7CUL))
#define bFM_MFT1_FRT_TCAL_STOP00              *((volatile unsigned char*)(0x42422C80UL))
#define bFM_MFT1_FRT_TCAL_STOP01              *((volatile unsigned char*)(0x42422C84UL))
#define bFM_MFT1_FRT_TCAL_STOP02              *((volatile unsigned char*)(0x42422C88UL))
#define bFM_MFT1_FRT_TCAL_STOP10              *((volatile unsigned char*)(0x42422C8CUL))
#define bFM_MFT1_FRT_TCAL_STOP11              *((volatile unsigned char*)(0x42422C90UL))
#define bFM_MFT1_FRT_TCAL_STOP12              *((volatile unsigned char*)(0x42422C94UL))
#define bFM_MFT1_FRT_TCAL_STOP20              *((volatile unsigned char*)(0x42422C98UL))
#define bFM_MFT1_FRT_TCAL_STOP21              *((volatile unsigned char*)(0x42422C9CUL))
#define bFM_MFT1_FRT_TCAL_STOP22              *((volatile unsigned char*)(0x42422CA0UL))
#define bFM_MFT1_FRT_TCAL_SCLR00              *((volatile unsigned char*)(0x42422CC0UL))
#define bFM_MFT1_FRT_TCAL_SCLR01              *((volatile unsigned char*)(0x42422CC4UL))
#define bFM_MFT1_FRT_TCAL_SCLR02              *((volatile unsigned char*)(0x42422CC8UL))
#define bFM_MFT1_FRT_TCAL_SCLR10              *((volatile unsigned char*)(0x42422CCCUL))
#define bFM_MFT1_FRT_TCAL_SCLR11              *((volatile unsigned char*)(0x42422CD0UL))
#define bFM_MFT1_FRT_TCAL_SCLR12              *((volatile unsigned char*)(0x42422CD4UL))
#define bFM_MFT1_FRT_TCAL_SCLR20              *((volatile unsigned char*)(0x42422CD8UL))
#define bFM_MFT1_FRT_TCAL_SCLR21              *((volatile unsigned char*)(0x42422CDCUL))
#define bFM_MFT1_FRT_TCAL_SCLR22              *((volatile unsigned char*)(0x42422CE0UL))
#define bFM_MFT1_FRT_TCSD_OFMD1               *((volatile unsigned char*)(0x42423D80UL))
#define bFM_MFT1_FRT_TCSD_OFMD2               *((volatile unsigned char*)(0x42423D84UL))

/* Multifunction Timer unit 1 Output Compare Unit registers */
#define bFM_MFT1_OCU_OCSA10_CST0              *((volatile unsigned char*)(0x42422300UL))
#define bFM_MFT1_OCU_OCSA10_CST1              *((volatile unsigned char*)(0x42422304UL))
#define bFM_MFT1_OCU_OCSA10_IOE0              *((volatile unsigned char*)(0x42422310UL))
#define bFM_MFT1_OCU_OCSA10_IOE1              *((volatile unsigned char*)(0x42422314UL))
#define bFM_MFT1_OCU_OCSA10_IOP0              *((volatile unsigned char*)(0x42422318UL))
#define bFM_MFT1_OCU_OCSA10_IOP1              *((volatile unsigned char*)(0x4242231CUL))
#define bFM_MFT1_OCU_OCSB10_OTD0              *((volatile unsigned char*)(0x42422320UL))
#define bFM_MFT1_OCU_OCSB10_OTD1              *((volatile unsigned char*)(0x42422324UL))
#define bFM_MFT1_OCU_OCSB10_CMOD              *((volatile unsigned char*)(0x42422330UL))
#define bFM_MFT1_OCU_OCSB10_FM4               *((volatile unsigned char*)(0x4242233CUL))
#define bFM_MFT1_OCU_OCSD10_OCCP0BUFE0        *((volatile unsigned char*)(0x42422340UL))
#define bFM_MFT1_OCU_OCSD10_OCCP0BUFE1        *((volatile unsigned char*)(0x42422344UL))
#define bFM_MFT1_OCU_OCSD10_OCCP1BUFE0        *((volatile unsigned char*)(0x42422348UL))
#define bFM_MFT1_OCU_OCSD10_OCCP1BUFE1        *((volatile unsigned char*)(0x4242234CUL))
#define bFM_MFT1_OCU_OCSD10_OCSE0BUFE0        *((volatile unsigned char*)(0x42422350UL))
#define bFM_MFT1_OCU_OCSD10_OCSE0BUFE1        *((volatile unsigned char*)(0x42422354UL))
#define bFM_MFT1_OCU_OCSD10_OCSE1BUFE0        *((volatile unsigned char*)(0x42422358UL))
#define bFM_MFT1_OCU_OCSD10_OCSE1BUFE1        *((volatile unsigned char*)(0x4242235CUL))
#define bFM_MFT1_OCU_OCSD10_OPBM0             *((volatile unsigned char*)(0x42422360UL))
#define bFM_MFT1_OCU_OCSD10_OPBM1             *((volatile unsigned char*)(0x42422364UL))
#define bFM_MFT1_OCU_OCSD10_OEBM0             *((volatile unsigned char*)(0x42422368UL))
#define bFM_MFT1_OCU_OCSD10_OEBM1             *((volatile unsigned char*)(0x4242236CUL))
#define bFM_MFT1_OCU_OCSD10_OFEX0             *((volatile unsigned char*)(0x42422370UL))
#define bFM_MFT1_OCU_OCSD10_OFEX1             *((volatile unsigned char*)(0x42422374UL))
#define bFM_MFT1_OCU_OCSA32_CST0              *((volatile unsigned char*)(0x42422380UL))
#define bFM_MFT1_OCU_OCSA32_CST1              *((volatile unsigned char*)(0x42422384UL))
#define bFM_MFT1_OCU_OCSA32_IOE0              *((volatile unsigned char*)(0x42422390UL))
#define bFM_MFT1_OCU_OCSA32_IOE1              *((volatile unsigned char*)(0x42422394UL))
#define bFM_MFT1_OCU_OCSA32_IOP0              *((volatile unsigned char*)(0x42422398UL))
#define bFM_MFT1_OCU_OCSA32_IOP1              *((volatile unsigned char*)(0x4242239CUL))
#define bFM_MFT1_OCU_OCSB32_OTD0              *((volatile unsigned char*)(0x424223A0UL))
#define bFM_MFT1_OCU_OCSB32_OTD1              *((volatile unsigned char*)(0x424223A4UL))
#define bFM_MFT1_OCU_OCSB32_CMOD              *((volatile unsigned char*)(0x424223B0UL))
#define bFM_MFT1_OCU_OCSB32_FM4               *((volatile unsigned char*)(0x424223BCUL))
#define bFM_MFT1_OCU_OCSD32_OCCP2BUFE0        *((volatile unsigned char*)(0x424223C0UL))
#define bFM_MFT1_OCU_OCSD32_OCCP2BUFE1        *((volatile unsigned char*)(0x424223C4UL))
#define bFM_MFT1_OCU_OCSD32_OCCP3BUFE0        *((volatile unsigned char*)(0x424223C8UL))
#define bFM_MFT1_OCU_OCSD32_OCCP3BUFE1        *((volatile unsigned char*)(0x424223CCUL))
#define bFM_MFT1_OCU_OCSD32_OCSE2BUFE0        *((volatile unsigned char*)(0x424223D0UL))
#define bFM_MFT1_OCU_OCSD32_OCSE2BUFE1        *((volatile unsigned char*)(0x424223D4UL))
#define bFM_MFT1_OCU_OCSD32_OCSE3BUFE0        *((volatile unsigned char*)(0x424223D8UL))
#define bFM_MFT1_OCU_OCSD32_OCSE3BUFE1        *((volatile unsigned char*)(0x424223DCUL))
#define bFM_MFT1_OCU_OCSD32_OPBM2             *((volatile unsigned char*)(0x424223E0UL))
#define bFM_MFT1_OCU_OCSD32_OPBM3             *((volatile unsigned char*)(0x424223E4UL))
#define bFM_MFT1_OCU_OCSD32_OEBM2             *((volatile unsigned char*)(0x424223E8UL))
#define bFM_MFT1_OCU_OCSD32_OEBM3             *((volatile unsigned char*)(0x424223ECUL))
#define bFM_MFT1_OCU_OCSD32_OFEX2             *((volatile unsigned char*)(0x424223F0UL))
#define bFM_MFT1_OCU_OCSD32_OFEX3             *((volatile unsigned char*)(0x424223F4UL))
#define bFM_MFT1_OCU_OCSA54_CST0              *((volatile unsigned char*)(0x42422400UL))
#define bFM_MFT1_OCU_OCSA54_CST1              *((volatile unsigned char*)(0x42422404UL))
#define bFM_MFT1_OCU_OCSA54_IOE0              *((volatile unsigned char*)(0x42422410UL))
#define bFM_MFT1_OCU_OCSA54_IOE1              *((volatile unsigned char*)(0x42422414UL))
#define bFM_MFT1_OCU_OCSA54_IOP0              *((volatile unsigned char*)(0x42422418UL))
#define bFM_MFT1_OCU_OCSA54_IOP1              *((volatile unsigned char*)(0x4242241CUL))
#define bFM_MFT1_OCU_OCSB54_OTD0              *((volatile unsigned char*)(0x42422420UL))
#define bFM_MFT1_OCU_OCSB54_OTD1              *((volatile unsigned char*)(0x42422424UL))
#define bFM_MFT1_OCU_OCSB54_CMOD              *((volatile unsigned char*)(0x42422430UL))
#define bFM_MFT1_OCU_OCSB54_FM4               *((volatile unsigned char*)(0x4242243CUL))
#define bFM_MFT1_OCU_OCSD54_OCCP4BUFE0        *((volatile unsigned char*)(0x42422440UL))
#define bFM_MFT1_OCU_OCSD54_OCCP4BUFE1        *((volatile unsigned char*)(0x42422444UL))
#define bFM_MFT1_OCU_OCSD54_OCCP5BUFE0        *((volatile unsigned char*)(0x42422448UL))
#define bFM_MFT1_OCU_OCSD54_OCCP5BUFE1        *((volatile unsigned char*)(0x4242244CUL))
#define bFM_MFT1_OCU_OCSD54_OCSE4BUFE0        *((volatile unsigned char*)(0x42422450UL))
#define bFM_MFT1_OCU_OCSD54_OCSE4BUFE1        *((volatile unsigned char*)(0x42422454UL))
#define bFM_MFT1_OCU_OCSD54_OCSE5BUFE0        *((volatile unsigned char*)(0x42422458UL))
#define bFM_MFT1_OCU_OCSD54_OCSE5BUFE1        *((volatile unsigned char*)(0x4242245CUL))
#define bFM_MFT1_OCU_OCSD54_OPBM4             *((volatile unsigned char*)(0x42422460UL))
#define bFM_MFT1_OCU_OCSD54_OPBM5             *((volatile unsigned char*)(0x42422464UL))
#define bFM_MFT1_OCU_OCSD54_OEBM4             *((volatile unsigned char*)(0x42422468UL))
#define bFM_MFT1_OCU_OCSD54_OEBM5             *((volatile unsigned char*)(0x4242246CUL))
#define bFM_MFT1_OCU_OCSD54_OFEX4             *((volatile unsigned char*)(0x42422470UL))
#define bFM_MFT1_OCU_OCSD54_OFEX5             *((volatile unsigned char*)(0x42422474UL))
#define bFM_MFT1_OCU_OCSC_MOD0                *((volatile unsigned char*)(0x424224A0UL))
#define bFM_MFT1_OCU_OCSC_MOD1                *((volatile unsigned char*)(0x424224A4UL))
#define bFM_MFT1_OCU_OCSC_MOD2                *((volatile unsigned char*)(0x424224A8UL))
#define bFM_MFT1_OCU_OCSC_MOD3                *((volatile unsigned char*)(0x424224ACUL))
#define bFM_MFT1_OCU_OCSC_MOD4                *((volatile unsigned char*)(0x424224B0UL))
#define bFM_MFT1_OCU_OCSC_MOD5                *((volatile unsigned char*)(0x424224B4UL))
#define bFM_MFT1_OCU_OCFS10_FSO00             *((volatile unsigned char*)(0x42422D00UL))
#define bFM_MFT1_OCU_OCFS10_FSO01             *((volatile unsigned char*)(0x42422D04UL))
#define bFM_MFT1_OCU_OCFS10_FSO02             *((volatile unsigned char*)(0x42422D08UL))
#define bFM_MFT1_OCU_OCFS10_FSO03             *((volatile unsigned char*)(0x42422D0CUL))
#define bFM_MFT1_OCU_OCFS10_FSO10             *((volatile unsigned char*)(0x42422D10UL))
#define bFM_MFT1_OCU_OCFS10_FSO11             *((volatile unsigned char*)(0x42422D14UL))
#define bFM_MFT1_OCU_OCFS10_FSO12             *((volatile unsigned char*)(0x42422D18UL))
#define bFM_MFT1_OCU_OCFS10_FSO13             *((volatile unsigned char*)(0x42422D1CUL))
#define bFM_MFT1_OCU_OCFS32_FSO00             *((volatile unsigned char*)(0x42422D20UL))
#define bFM_MFT1_OCU_OCFS32_FSO01             *((volatile unsigned char*)(0x42422D24UL))
#define bFM_MFT1_OCU_OCFS32_FSO02             *((volatile unsigned char*)(0x42422D28UL))
#define bFM_MFT1_OCU_OCFS32_FSO03             *((volatile unsigned char*)(0x42422D2CUL))
#define bFM_MFT1_OCU_OCFS32_FSO10             *((volatile unsigned char*)(0x42422D30UL))
#define bFM_MFT1_OCU_OCFS32_FSO11             *((volatile unsigned char*)(0x42422D34UL))
#define bFM_MFT1_OCU_OCFS32_FSO12             *((volatile unsigned char*)(0x42422D38UL))
#define bFM_MFT1_OCU_OCFS32_FSO13             *((volatile unsigned char*)(0x42422D3CUL))
#define bFM_MFT1_OCU_OCFS54_FSO00             *((volatile unsigned char*)(0x42422D40UL))
#define bFM_MFT1_OCU_OCFS54_FSO01             *((volatile unsigned char*)(0x42422D44UL))
#define bFM_MFT1_OCU_OCFS54_FSO02             *((volatile unsigned char*)(0x42422D48UL))
#define bFM_MFT1_OCU_OCFS54_FSO03             *((volatile unsigned char*)(0x42422D4CUL))
#define bFM_MFT1_OCU_OCFS54_FSO10             *((volatile unsigned char*)(0x42422D50UL))
#define bFM_MFT1_OCU_OCFS54_FSO11             *((volatile unsigned char*)(0x42422D54UL))
#define bFM_MFT1_OCU_OCFS54_FSO12             *((volatile unsigned char*)(0x42422D58UL))
#define bFM_MFT1_OCU_OCFS54_FSO13             *((volatile unsigned char*)(0x42422D5CUL))

/* Multifunction Timer unit 1 Waveform Generator and Noise Canceler registers */
#define bFM_MFT1_WFG_WFSA10_DCK0              *((volatile unsigned char*)(0x42423480UL))
#define bFM_MFT1_WFG_WFSA10_DCK1              *((volatile unsigned char*)(0x42423484UL))
#define bFM_MFT1_WFG_WFSA10_DCK2              *((volatile unsigned char*)(0x42423488UL))
#define bFM_MFT1_WFG_WFSA10_GTEN0             *((volatile unsigned char*)(0x42423498UL))
#define bFM_MFT1_WFG_WFSA10_GTEN1             *((volatile unsigned char*)(0x4242349CUL))
#define bFM_MFT1_WFG_WFSA10_PSEL0             *((volatile unsigned char*)(0x424234A0UL))
#define bFM_MFT1_WFG_WFSA10_PSEL1             *((volatile unsigned char*)(0x424234A4UL))
#define bFM_MFT1_WFG_WFSA10_PGEN0             *((volatile unsigned char*)(0x424234A8UL))
#define bFM_MFT1_WFG_WFSA10_PGEN1             *((volatile unsigned char*)(0x424234ACUL))
#define bFM_MFT1_WFG_WFSA32_DCK0              *((volatile unsigned char*)(0x42423500UL))
#define bFM_MFT1_WFG_WFSA32_DCK1              *((volatile unsigned char*)(0x42423504UL))
#define bFM_MFT1_WFG_WFSA32_DCK2              *((volatile unsigned char*)(0x42423508UL))
#define bFM_MFT1_WFG_WFSA32_GTEN0             *((volatile unsigned char*)(0x42423518UL))
#define bFM_MFT1_WFG_WFSA32_GTEN1             *((volatile unsigned char*)(0x4242351CUL))
#define bFM_MFT1_WFG_WFSA32_PSEL0             *((volatile unsigned char*)(0x42423520UL))
#define bFM_MFT1_WFG_WFSA32_PSEL1             *((volatile unsigned char*)(0x42423524UL))
#define bFM_MFT1_WFG_WFSA32_PGEN0             *((volatile unsigned char*)(0x42423528UL))
#define bFM_MFT1_WFG_WFSA32_PGEN1             *((volatile unsigned char*)(0x4242352CUL))
#define bFM_MFT1_WFG_WFSA54_DCK0              *((volatile unsigned char*)(0x42423580UL))
#define bFM_MFT1_WFG_WFSA54_DCK1              *((volatile unsigned char*)(0x42423584UL))
#define bFM_MFT1_WFG_WFSA54_DCK2              *((volatile unsigned char*)(0x42423588UL))
#define bFM_MFT1_WFG_WFSA54_GTEN0             *((volatile unsigned char*)(0x42423598UL))
#define bFM_MFT1_WFG_WFSA54_GTEN1             *((volatile unsigned char*)(0x4242359CUL))
#define bFM_MFT1_WFG_WFSA54_PSEL0             *((volatile unsigned char*)(0x424235A0UL))
#define bFM_MFT1_WFG_WFSA54_PSEL1             *((volatile unsigned char*)(0x424235A4UL))
#define bFM_MFT1_WFG_WFSA54_PGEN0             *((volatile unsigned char*)(0x424235A8UL))
#define bFM_MFT1_WFG_WFSA54_PGEN1             *((volatile unsigned char*)(0x424235ACUL))
#define bFM_MFT1_WFG_WFIR_DTIFA               *((volatile unsigned char*)(0x42423600UL))
#define bFM_MFT1_WFG_WFIR_DTICA               *((volatile unsigned char*)(0x42423604UL))
#define bFM_MFT1_WFG_WFIR_DTIFB               *((volatile unsigned char*)(0x42423608UL))
#define bFM_MFT1_WFG_WFIR_DTICB               *((volatile unsigned char*)(0x4242360CUL))
#define bFM_MFT1_WFG_WFIR_TMIF10              *((volatile unsigned char*)(0x42423610UL))
#define bFM_MFT1_WFG_WFIR_TMIC10              *((volatile unsigned char*)(0x42423614UL))
#define bFM_MFT1_WFG_WFIR_TMIE10              *((volatile unsigned char*)(0x42423618UL))
#define bFM_MFT1_WFG_WFIR_TMIS10              *((volatile unsigned char*)(0x4242361CUL))
#define bFM_MFT1_WFG_WFIR_TMIF32              *((volatile unsigned char*)(0x42423620UL))
#define bFM_MFT1_WFG_WFIR_TMIC32              *((volatile unsigned char*)(0x42423624UL))
#define bFM_MFT1_WFG_WFIR_TMIE32              *((volatile unsigned char*)(0x42423628UL))
#define bFM_MFT1_WFG_WFIR_TMIS32              *((volatile unsigned char*)(0x4242362CUL))
#define bFM_MFT1_WFG_WFIR_TMIF54              *((volatile unsigned char*)(0x42423630UL))
#define bFM_MFT1_WFG_WFIR_TMIC54              *((volatile unsigned char*)(0x42423634UL))
#define bFM_MFT1_WFG_WFIR_TMIE54              *((volatile unsigned char*)(0x42423638UL))
#define bFM_MFT1_WFG_WFIR_TMIS54              *((volatile unsigned char*)(0x4242363CUL))
#define bFM_MFT1_WFG_NZCL_DTIEA               *((volatile unsigned char*)(0x42423680UL))
#define bFM_MFT1_WFG_NZCL_NWS0                *((volatile unsigned char*)(0x42423684UL))
#define bFM_MFT1_WFG_NZCL_NWS1                *((volatile unsigned char*)(0x42423688UL))
#define bFM_MFT1_WFG_NZCL_NWS2                *((volatile unsigned char*)(0x4242368CUL))
#define bFM_MFT1_WFG_NZCL_SDTI                *((volatile unsigned char*)(0x42423690UL))
#define bFM_MFT1_WFG_NZCL_DTIEB               *((volatile unsigned char*)(0x42423694UL))
#define bFM_MFT1_WFG_NZCL_DHOLD               *((volatile unsigned char*)(0x4242369CUL))
#define bFM_MFT1_WFG_NZCL_DIMA                *((volatile unsigned char*)(0x424236A0UL))
#define bFM_MFT1_WFG_NZCL_DIMB                *((volatile unsigned char*)(0x424236A4UL))
#define bFM_MFT1_WFG_NZCL_WIM10               *((volatile unsigned char*)(0x424236B0UL))
#define bFM_MFT1_WFG_NZCL_WIM32               *((volatile unsigned char*)(0x424236B4UL))
#define bFM_MFT1_WFG_NZCL_WIM54               *((volatile unsigned char*)(0x424236B8UL))

/* Multifunction Timer unit 1 Input Capture Unit registers */
#define bFM_MFT1_ICU_ICFS10_FSI00             *((volatile unsigned char*)(0x42422D80UL))
#define bFM_MFT1_ICU_ICFS10_FSI01             *((volatile unsigned char*)(0x42422D84UL))
#define bFM_MFT1_ICU_ICFS10_FSI02             *((volatile unsigned char*)(0x42422D88UL))
#define bFM_MFT1_ICU_ICFS10_FSI03             *((volatile unsigned char*)(0x42422D8CUL))
#define bFM_MFT1_ICU_ICFS10_FSI10             *((volatile unsigned char*)(0x42422D90UL))
#define bFM_MFT1_ICU_ICFS10_FSI11             *((volatile unsigned char*)(0x42422D94UL))
#define bFM_MFT1_ICU_ICFS10_FSI12             *((volatile unsigned char*)(0x42422D98UL))
#define bFM_MFT1_ICU_ICFS10_FSI13             *((volatile unsigned char*)(0x42422D9CUL))
#define bFM_MFT1_ICU_ICFS32_FSI00             *((volatile unsigned char*)(0x42422DA0UL))
#define bFM_MFT1_ICU_ICFS32_FSI01             *((volatile unsigned char*)(0x42422DA4UL))
#define bFM_MFT1_ICU_ICFS32_FSI02             *((volatile unsigned char*)(0x42422DA8UL))
#define bFM_MFT1_ICU_ICFS32_FSI03             *((volatile unsigned char*)(0x42422DACUL))
#define bFM_MFT1_ICU_ICFS32_FSI10             *((volatile unsigned char*)(0x42422DB0UL))
#define bFM_MFT1_ICU_ICFS32_FSI11             *((volatile unsigned char*)(0x42422DB4UL))
#define bFM_MFT1_ICU_ICFS32_FSI12             *((volatile unsigned char*)(0x42422DB8UL))
#define bFM_MFT1_ICU_ICFS32_FSI13             *((volatile unsigned char*)(0x42422DBCUL))
#define bFM_MFT1_ICU_ICSA10_EG00              *((volatile unsigned char*)(0x42423080UL))
#define bFM_MFT1_ICU_ICSA10_EG01              *((volatile unsigned char*)(0x42423084UL))
#define bFM_MFT1_ICU_ICSA10_EG10              *((volatile unsigned char*)(0x42423088UL))
#define bFM_MFT1_ICU_ICSA10_EG11              *((volatile unsigned char*)(0x4242308CUL))
#define bFM_MFT1_ICU_ICSA10_ICE0              *((volatile unsigned char*)(0x42423090UL))
#define bFM_MFT1_ICU_ICSA10_ICE1              *((volatile unsigned char*)(0x42423094UL))
#define bFM_MFT1_ICU_ICSA10_ICP0              *((volatile unsigned char*)(0x42423098UL))
#define bFM_MFT1_ICU_ICSA10_ICP1              *((volatile unsigned char*)(0x4242309CUL))
#define bFM_MFT1_ICU_ICSB10_IEI0              *((volatile unsigned char*)(0x424230A0UL))
#define bFM_MFT1_ICU_ICSB10_IEI1              *((volatile unsigned char*)(0x424230A4UL))
#define bFM_MFT1_ICU_ICSA32_EG00              *((volatile unsigned char*)(0x42423100UL))
#define bFM_MFT1_ICU_ICSA32_EG01              *((volatile unsigned char*)(0x42423104UL))
#define bFM_MFT1_ICU_ICSA32_EG10              *((volatile unsigned char*)(0x42423108UL))
#define bFM_MFT1_ICU_ICSA32_EG11              *((volatile unsigned char*)(0x4242310CUL))
#define bFM_MFT1_ICU_ICSA32_ICE0              *((volatile unsigned char*)(0x42423110UL))
#define bFM_MFT1_ICU_ICSA32_ICE1              *((volatile unsigned char*)(0x42423114UL))
#define bFM_MFT1_ICU_ICSA32_ICP0              *((volatile unsigned char*)(0x42423118UL))
#define bFM_MFT1_ICU_ICSA32_ICP1              *((volatile unsigned char*)(0x4242311CUL))
#define bFM_MFT1_ICU_ICSB32_IEI0              *((volatile unsigned char*)(0x42423120UL))
#define bFM_MFT1_ICU_ICSB32_IEI1              *((volatile unsigned char*)(0x42423124UL))

/* Multifunction Timer unit 1 ADC Start Compare Unit registers */
#define bFM_MFT1_ADCMP_ACSC0_BUFE0            *((volatile unsigned char*)(0x42423A80UL))
#define bFM_MFT1_ADCMP_ACSC0_BUFE1            *((volatile unsigned char*)(0x42423A84UL))
#define bFM_MFT1_ADCMP_ACSC0_ADSEL0           *((volatile unsigned char*)(0x42423A88UL))
#define bFM_MFT1_ADCMP_ACSC0_ADSEL1           *((volatile unsigned char*)(0x42423A8CUL))
#define bFM_MFT1_ADCMP_ACSC0_ADSEL2           *((volatile unsigned char*)(0x42423A90UL))
#define bFM_MFT1_ADCMP_ACSC0_APBM             *((volatile unsigned char*)(0x42423A94UL))
#define bFM_MFT1_ADCMP_ACSD0_AMOD             *((volatile unsigned char*)(0x42423AA0UL))
#define bFM_MFT1_ADCMP_ACSD0_OCUS             *((volatile unsigned char*)(0x42423AA4UL))
#define bFM_MFT1_ADCMP_ACSD0_DE               *((volatile unsigned char*)(0x42423AB0UL))
#define bFM_MFT1_ADCMP_ACSD0_PE               *((volatile unsigned char*)(0x42423AB4UL))
#define bFM_MFT1_ADCMP_ACSD0_UE               *((volatile unsigned char*)(0x42423AB8UL))
#define bFM_MFT1_ADCMP_ACSD0_ZE               *((volatile unsigned char*)(0x42423ABCUL))
#define bFM_MFT1_ADCMP_ACMC0_AMC0             *((volatile unsigned char*)(0x42423AC0UL))
#define bFM_MFT1_ADCMP_ACMC0_AMC1             *((volatile unsigned char*)(0x42423AC4UL))
#define bFM_MFT1_ADCMP_ACMC0_AMC2             *((volatile unsigned char*)(0x42423AC8UL))
#define bFM_MFT1_ADCMP_ACMC0_AMC3             *((volatile unsigned char*)(0x42423ACCUL))
#define bFM_MFT1_ADCMP_ACMC0_MZCE             *((volatile unsigned char*)(0x42423AD8UL))
#define bFM_MFT1_ADCMP_ACMC0_MPCE             *((volatile unsigned char*)(0x42423ADCUL))
#define bFM_MFT1_ADCMP_ACSC1_BUFE0            *((volatile unsigned char*)(0x42423B00UL))
#define bFM_MFT1_ADCMP_ACSC1_BUFE1            *((volatile unsigned char*)(0x42423B04UL))
#define bFM_MFT1_ADCMP_ACSC1_ADSEL0           *((volatile unsigned char*)(0x42423B08UL))
#define bFM_MFT1_ADCMP_ACSC1_ADSEL1           *((volatile unsigned char*)(0x42423B0CUL))
#define bFM_MFT1_ADCMP_ACSC1_ADSEL2           *((volatile unsigned char*)(0x42423B10UL))
#define bFM_MFT1_ADCMP_ACSC1_APBM             *((volatile unsigned char*)(0x42423B14UL))
#define bFM_MFT1_ADCMP_ACSD1_AMOD             *((volatile unsigned char*)(0x42423B20UL))
#define bFM_MFT1_ADCMP_ACSD1_OCUS             *((volatile unsigned char*)(0x42423B24UL))
#define bFM_MFT1_ADCMP_ACSD1_DE               *((volatile unsigned char*)(0x42423B30UL))
#define bFM_MFT1_ADCMP_ACSD1_PE               *((volatile unsigned char*)(0x42423B34UL))
#define bFM_MFT1_ADCMP_ACSD1_UE               *((volatile unsigned char*)(0x42423B38UL))
#define bFM_MFT1_ADCMP_ACSD1_ZE               *((volatile unsigned char*)(0x42423B3CUL))
#define bFM_MFT1_ADCMP_ACMC1_AMC0             *((volatile unsigned char*)(0x42423B40UL))
#define bFM_MFT1_ADCMP_ACMC1_AMC1             *((volatile unsigned char*)(0x42423B44UL))
#define bFM_MFT1_ADCMP_ACMC1_AMC2             *((volatile unsigned char*)(0x42423B48UL))
#define bFM_MFT1_ADCMP_ACMC1_AMC3             *((volatile unsigned char*)(0x42423B4CUL))
#define bFM_MFT1_ADCMP_ACMC1_MZCE             *((volatile unsigned char*)(0x42423B58UL))
#define bFM_MFT1_ADCMP_ACMC1_MPCE             *((volatile unsigned char*)(0x42423B5CUL))
#define bFM_MFT1_ADCMP_ACSC2_BUFE0            *((volatile unsigned char*)(0x42423B80UL))
#define bFM_MFT1_ADCMP_ACSC2_BUFE1            *((volatile unsigned char*)(0x42423B84UL))
#define bFM_MFT1_ADCMP_ACSC2_ADSEL0           *((volatile unsigned char*)(0x42423B88UL))
#define bFM_MFT1_ADCMP_ACSC2_ADSEL1           *((volatile unsigned char*)(0x42423B8CUL))
#define bFM_MFT1_ADCMP_ACSC2_ADSEL2           *((volatile unsigned char*)(0x42423B90UL))
#define bFM_MFT1_ADCMP_ACSC2_APBM             *((volatile unsigned char*)(0x42423B94UL))
#define bFM_MFT1_ADCMP_ACSD2_AMOD             *((volatile unsigned char*)(0x42423BA0UL))
#define bFM_MFT1_ADCMP_ACSD2_OCUS             *((volatile unsigned char*)(0x42423BA4UL))
#define bFM_MFT1_ADCMP_ACSD2_DE               *((volatile unsigned char*)(0x42423BB0UL))
#define bFM_MFT1_ADCMP_ACSD2_PE               *((volatile unsigned char*)(0x42423BB4UL))
#define bFM_MFT1_ADCMP_ACSD2_UE               *((volatile unsigned char*)(0x42423BB8UL))
#define bFM_MFT1_ADCMP_ACSD2_ZE               *((volatile unsigned char*)(0x42423BBCUL))
#define bFM_MFT1_ADCMP_ACMC2_AMC0             *((volatile unsigned char*)(0x42423BC0UL))
#define bFM_MFT1_ADCMP_ACMC2_AMC1             *((volatile unsigned char*)(0x42423BC4UL))
#define bFM_MFT1_ADCMP_ACMC2_AMC2             *((volatile unsigned char*)(0x42423BC8UL))
#define bFM_MFT1_ADCMP_ACMC2_AMC3             *((volatile unsigned char*)(0x42423BCCUL))
#define bFM_MFT1_ADCMP_ACMC2_MZCE             *((volatile unsigned char*)(0x42423BD8UL))
#define bFM_MFT1_ADCMP_ACMC2_MPCE             *((volatile unsigned char*)(0x42423BDCUL))
#define bFM_MFT1_ADCMP_ACSC3_BUFE0            *((volatile unsigned char*)(0x42423C00UL))
#define bFM_MFT1_ADCMP_ACSC3_BUFE1            *((volatile unsigned char*)(0x42423C04UL))
#define bFM_MFT1_ADCMP_ACSC3_ADSEL0           *((volatile unsigned char*)(0x42423C08UL))
#define bFM_MFT1_ADCMP_ACSC3_ADSEL1           *((volatile unsigned char*)(0x42423C0CUL))
#define bFM_MFT1_ADCMP_ACSC3_ADSEL2           *((volatile unsigned char*)(0x42423C10UL))
#define bFM_MFT1_ADCMP_ACSC3_APBM             *((volatile unsigned char*)(0x42423C14UL))
#define bFM_MFT1_ADCMP_ACSD3_AMOD             *((volatile unsigned char*)(0x42423C20UL))
#define bFM_MFT1_ADCMP_ACSD3_OCUS             *((volatile unsigned char*)(0x42423C24UL))
#define bFM_MFT1_ADCMP_ACSD3_DE               *((volatile unsigned char*)(0x42423C30UL))
#define bFM_MFT1_ADCMP_ACSD3_PE               *((volatile unsigned char*)(0x42423C34UL))
#define bFM_MFT1_ADCMP_ACSD3_UE               *((volatile unsigned char*)(0x42423C38UL))
#define bFM_MFT1_ADCMP_ACSD3_ZE               *((volatile unsigned char*)(0x42423C3CUL))
#define bFM_MFT1_ADCMP_ACMC3_AMC0             *((volatile unsigned char*)(0x42423C40UL))
#define bFM_MFT1_ADCMP_ACMC3_AMC1             *((volatile unsigned char*)(0x42423C44UL))
#define bFM_MFT1_ADCMP_ACMC3_AMC2             *((volatile unsigned char*)(0x42423C48UL))
#define bFM_MFT1_ADCMP_ACMC3_AMC3             *((volatile unsigned char*)(0x42423C4CUL))
#define bFM_MFT1_ADCMP_ACMC3_MZCE             *((volatile unsigned char*)(0x42423C58UL))
#define bFM_MFT1_ADCMP_ACMC3_MPCE             *((volatile unsigned char*)(0x42423C5CUL))
#define bFM_MFT1_ADCMP_ACSC4_BUFE0            *((volatile unsigned char*)(0x42423C80UL))
#define bFM_MFT1_ADCMP_ACSC4_BUFE1            *((volatile unsigned char*)(0x42423C84UL))
#define bFM_MFT1_ADCMP_ACSC4_ADSEL0           *((volatile unsigned char*)(0x42423C88UL))
#define bFM_MFT1_ADCMP_ACSC4_ADSEL1           *((volatile unsigned char*)(0x42423C8CUL))
#define bFM_MFT1_ADCMP_ACSC4_ADSEL2           *((volatile unsigned char*)(0x42423C90UL))
#define bFM_MFT1_ADCMP_ACSC4_APBM             *((volatile unsigned char*)(0x42423C94UL))
#define bFM_MFT1_ADCMP_ACSD4_AMOD             *((volatile unsigned char*)(0x42423CA0UL))
#define bFM_MFT1_ADCMP_ACSD4_OCUS             *((volatile unsigned char*)(0x42423CA4UL))
#define bFM_MFT1_ADCMP_ACSD4_DE               *((volatile unsigned char*)(0x42423CB0UL))
#define bFM_MFT1_ADCMP_ACSD4_PE               *((volatile unsigned char*)(0x42423CB4UL))
#define bFM_MFT1_ADCMP_ACSD4_UE               *((volatile unsigned char*)(0x42423CB8UL))
#define bFM_MFT1_ADCMP_ACSD4_ZE               *((volatile unsigned char*)(0x42423CBCUL))
#define bFM_MFT1_ADCMP_ACMC4_AMC0             *((volatile unsigned char*)(0x42423CC0UL))
#define bFM_MFT1_ADCMP_ACMC4_AMC1             *((volatile unsigned char*)(0x42423CC4UL))
#define bFM_MFT1_ADCMP_ACMC4_AMC2             *((volatile unsigned char*)(0x42423CC8UL))
#define bFM_MFT1_ADCMP_ACMC4_AMC3             *((volatile unsigned char*)(0x42423CCCUL))
#define bFM_MFT1_ADCMP_ACMC4_MZCE             *((volatile unsigned char*)(0x42423CD8UL))
#define bFM_MFT1_ADCMP_ACMC4_MPCE             *((volatile unsigned char*)(0x42423CDCUL))
#define bFM_MFT1_ADCMP_ACSC5_BUFE0            *((volatile unsigned char*)(0x42423D00UL))
#define bFM_MFT1_ADCMP_ACSC5_BUFE1            *((volatile unsigned char*)(0x42423D04UL))
#define bFM_MFT1_ADCMP_ACSC5_ADSEL0           *((volatile unsigned char*)(0x42423D08UL))
#define bFM_MFT1_ADCMP_ACSC5_ADSEL1           *((volatile unsigned char*)(0x42423D0CUL))
#define bFM_MFT1_ADCMP_ACSC5_ADSEL2           *((volatile unsigned char*)(0x42423D10UL))
#define bFM_MFT1_ADCMP_ACSC5_APBM             *((volatile unsigned char*)(0x42423D14UL))
#define bFM_MFT1_ADCMP_ACSD5_AMOD             *((volatile unsigned char*)(0x42423D20UL))
#define bFM_MFT1_ADCMP_ACSD5_OCUS             *((volatile unsigned char*)(0x42423D24UL))
#define bFM_MFT1_ADCMP_ACSD5_DE               *((volatile unsigned char*)(0x42423D30UL))
#define bFM_MFT1_ADCMP_ACSD5_PE               *((volatile unsigned char*)(0x42423D34UL))
#define bFM_MFT1_ADCMP_ACSD5_UE               *((volatile unsigned char*)(0x42423D38UL))
#define bFM_MFT1_ADCMP_ACSD5_ZE               *((volatile unsigned char*)(0x42423D3CUL))
#define bFM_MFT1_ADCMP_ACMC5_AMC0             *((volatile unsigned char*)(0x42423D40UL))
#define bFM_MFT1_ADCMP_ACMC5_AMC1             *((volatile unsigned char*)(0x42423D44UL))
#define bFM_MFT1_ADCMP_ACMC5_AMC2             *((volatile unsigned char*)(0x42423D48UL))
#define bFM_MFT1_ADCMP_ACMC5_AMC3             *((volatile unsigned char*)(0x42423D4CUL))
#define bFM_MFT1_ADCMP_ACMC5_MZCE             *((volatile unsigned char*)(0x42423D58UL))
#define bFM_MFT1_ADCMP_ACMC5_MPCE             *((volatile unsigned char*)(0x42423D5CUL))

/* Multifunction Timer unit 2 Free Running Timer registers */
#define bFM_MFT2_FRT_TCSA0_CLK0               *((volatile unsigned char*)(0x42442900UL))
#define bFM_MFT2_FRT_TCSA0_CLK1               *((volatile unsigned char*)(0x42442904UL))
#define bFM_MFT2_FRT_TCSA0_CLK2               *((volatile unsigned char*)(0x42442908UL))
#define bFM_MFT2_FRT_TCSA0_CLK3               *((volatile unsigned char*)(0x4244290CUL))
#define bFM_MFT2_FRT_TCSA0_SCLR               *((volatile unsigned char*)(0x42442910UL))
#define bFM_MFT2_FRT_TCSA0_MODE               *((volatile unsigned char*)(0x42442914UL))
#define bFM_MFT2_FRT_TCSA0_STOP               *((volatile unsigned char*)(0x42442918UL))
#define bFM_MFT2_FRT_TCSA0_BFE                *((volatile unsigned char*)(0x4244291CUL))
#define bFM_MFT2_FRT_TCSA0_ICRE               *((volatile unsigned char*)(0x42442920UL))
#define bFM_MFT2_FRT_TCSA0_ICLR               *((volatile unsigned char*)(0x42442924UL))
#define bFM_MFT2_FRT_TCSA0_IRQZE              *((volatile unsigned char*)(0x42442934UL))
#define bFM_MFT2_FRT_TCSA0_IRQZF              *((volatile unsigned char*)(0x42442938UL))
#define bFM_MFT2_FRT_TCSA0_ECKE               *((volatile unsigned char*)(0x4244293CUL))
#define bFM_MFT2_FRT_TCSC0_MSZI0              *((volatile unsigned char*)(0x42442940UL))
#define bFM_MFT2_FRT_TCSC0_MSZI1              *((volatile unsigned char*)(0x42442944UL))
#define bFM_MFT2_FRT_TCSC0_MSZI2              *((volatile unsigned char*)(0x42442948UL))
#define bFM_MFT2_FRT_TCSC0_MSZI3              *((volatile unsigned char*)(0x4244294CUL))
#define bFM_MFT2_FRT_TCSC0_MSPI0              *((volatile unsigned char*)(0x42442950UL))
#define bFM_MFT2_FRT_TCSC0_MSPI1              *((volatile unsigned char*)(0x42442954UL))
#define bFM_MFT2_FRT_TCSC0_MSPI2              *((volatile unsigned char*)(0x42442958UL))
#define bFM_MFT2_FRT_TCSC0_MSPI3              *((volatile unsigned char*)(0x4244295CUL))
#define bFM_MFT2_FRT_TCSC0_MSZC0              *((volatile unsigned char*)(0x42442960UL))
#define bFM_MFT2_FRT_TCSC0_MSZC1              *((volatile unsigned char*)(0x42442964UL))
#define bFM_MFT2_FRT_TCSC0_MSZC2              *((volatile unsigned char*)(0x42442968UL))
#define bFM_MFT2_FRT_TCSC0_MSZC3              *((volatile unsigned char*)(0x4244296CUL))
#define bFM_MFT2_FRT_TCSC0_MSPC0              *((volatile unsigned char*)(0x42442970UL))
#define bFM_MFT2_FRT_TCSC0_MSPC1              *((volatile unsigned char*)(0x42442974UL))
#define bFM_MFT2_FRT_TCSC0_MSPC2              *((volatile unsigned char*)(0x42442978UL))
#define bFM_MFT2_FRT_TCSC0_MSPC3              *((volatile unsigned char*)(0x4244297CUL))
#define bFM_MFT2_FRT_TCSA1_CLK0               *((volatile unsigned char*)(0x42442A80UL))
#define bFM_MFT2_FRT_TCSA1_CLK1               *((volatile unsigned char*)(0x42442A84UL))
#define bFM_MFT2_FRT_TCSA1_CLK2               *((volatile unsigned char*)(0x42442A88UL))
#define bFM_MFT2_FRT_TCSA1_CLK3               *((volatile unsigned char*)(0x42442A8CUL))
#define bFM_MFT2_FRT_TCSA1_SCLR               *((volatile unsigned char*)(0x42442A90UL))
#define bFM_MFT2_FRT_TCSA1_MODE               *((volatile unsigned char*)(0x42442A94UL))
#define bFM_MFT2_FRT_TCSA1_STOP               *((volatile unsigned char*)(0x42442A98UL))
#define bFM_MFT2_FRT_TCSA1_BFE                *((volatile unsigned char*)(0x42442A9CUL))
#define bFM_MFT2_FRT_TCSA1_ICRE               *((volatile unsigned char*)(0x42442AA0UL))
#define bFM_MFT2_FRT_TCSA1_ICLR               *((volatile unsigned char*)(0x42442AA4UL))
#define bFM_MFT2_FRT_TCSA1_IRQZE              *((volatile unsigned char*)(0x42442AB4UL))
#define bFM_MFT2_FRT_TCSA1_IRQZF              *((volatile unsigned char*)(0x42442AB8UL))
#define bFM_MFT2_FRT_TCSA1_ECKE               *((volatile unsigned char*)(0x42442ABCUL))
#define bFM_MFT2_FRT_TCSC1_MSZI0              *((volatile unsigned char*)(0x42442AC0UL))
#define bFM_MFT2_FRT_TCSC1_MSZI1              *((volatile unsigned char*)(0x42442AC4UL))
#define bFM_MFT2_FRT_TCSC1_MSZI2              *((volatile unsigned char*)(0x42442AC8UL))
#define bFM_MFT2_FRT_TCSC1_MSZI3              *((volatile unsigned char*)(0x42442ACCUL))
#define bFM_MFT2_FRT_TCSC1_MSPI0              *((volatile unsigned char*)(0x42442AD0UL))
#define bFM_MFT2_FRT_TCSC1_MSPI1              *((volatile unsigned char*)(0x42442AD4UL))
#define bFM_MFT2_FRT_TCSC1_MSPI2              *((volatile unsigned char*)(0x42442AD8UL))
#define bFM_MFT2_FRT_TCSC1_MSPI3              *((volatile unsigned char*)(0x42442ADCUL))
#define bFM_MFT2_FRT_TCSC1_MSZC0              *((volatile unsigned char*)(0x42442AE0UL))
#define bFM_MFT2_FRT_TCSC1_MSZC1              *((volatile unsigned char*)(0x42442AE4UL))
#define bFM_MFT2_FRT_TCSC1_MSZC2              *((volatile unsigned char*)(0x42442AE8UL))
#define bFM_MFT2_FRT_TCSC1_MSZC3              *((volatile unsigned char*)(0x42442AECUL))
#define bFM_MFT2_FRT_TCSC1_MSPC0              *((volatile unsigned char*)(0x42442AF0UL))
#define bFM_MFT2_FRT_TCSC1_MSPC1              *((volatile unsigned char*)(0x42442AF4UL))
#define bFM_MFT2_FRT_TCSC1_MSPC2              *((volatile unsigned char*)(0x42442AF8UL))
#define bFM_MFT2_FRT_TCSC1_MSPC3              *((volatile unsigned char*)(0x42442AFCUL))
#define bFM_MFT2_FRT_TCSA2_CLK0               *((volatile unsigned char*)(0x42442C00UL))
#define bFM_MFT2_FRT_TCSA2_CLK1               *((volatile unsigned char*)(0x42442C04UL))
#define bFM_MFT2_FRT_TCSA2_CLK2               *((volatile unsigned char*)(0x42442C08UL))
#define bFM_MFT2_FRT_TCSA2_CLK3               *((volatile unsigned char*)(0x42442C0CUL))
#define bFM_MFT2_FRT_TCSA2_SCLR               *((volatile unsigned char*)(0x42442C10UL))
#define bFM_MFT2_FRT_TCSA2_MODE               *((volatile unsigned char*)(0x42442C14UL))
#define bFM_MFT2_FRT_TCSA2_STOP               *((volatile unsigned char*)(0x42442C18UL))
#define bFM_MFT2_FRT_TCSA2_BFE                *((volatile unsigned char*)(0x42442C1CUL))
#define bFM_MFT2_FRT_TCSA2_ICRE               *((volatile unsigned char*)(0x42442C20UL))
#define bFM_MFT2_FRT_TCSA2_ICLR               *((volatile unsigned char*)(0x42442C24UL))
#define bFM_MFT2_FRT_TCSA2_IRQZE              *((volatile unsigned char*)(0x42442C34UL))
#define bFM_MFT2_FRT_TCSA2_IRQZF              *((volatile unsigned char*)(0x42442C38UL))
#define bFM_MFT2_FRT_TCSA2_ECKE               *((volatile unsigned char*)(0x42442C3CUL))
#define bFM_MFT2_FRT_TCSC2_MSZI0              *((volatile unsigned char*)(0x42442C40UL))
#define bFM_MFT2_FRT_TCSC2_MSZI1              *((volatile unsigned char*)(0x42442C44UL))
#define bFM_MFT2_FRT_TCSC2_MSZI2              *((volatile unsigned char*)(0x42442C48UL))
#define bFM_MFT2_FRT_TCSC2_MSZI3              *((volatile unsigned char*)(0x42442C4CUL))
#define bFM_MFT2_FRT_TCSC2_MSPI0              *((volatile unsigned char*)(0x42442C50UL))
#define bFM_MFT2_FRT_TCSC2_MSPI1              *((volatile unsigned char*)(0x42442C54UL))
#define bFM_MFT2_FRT_TCSC2_MSPI2              *((volatile unsigned char*)(0x42442C58UL))
#define bFM_MFT2_FRT_TCSC2_MSPI3              *((volatile unsigned char*)(0x42442C5CUL))
#define bFM_MFT2_FRT_TCSC2_MSZC0              *((volatile unsigned char*)(0x42442C60UL))
#define bFM_MFT2_FRT_TCSC2_MSZC1              *((volatile unsigned char*)(0x42442C64UL))
#define bFM_MFT2_FRT_TCSC2_MSZC2              *((volatile unsigned char*)(0x42442C68UL))
#define bFM_MFT2_FRT_TCSC2_MSZC3              *((volatile unsigned char*)(0x42442C6CUL))
#define bFM_MFT2_FRT_TCSC2_MSPC0              *((volatile unsigned char*)(0x42442C70UL))
#define bFM_MFT2_FRT_TCSC2_MSPC1              *((volatile unsigned char*)(0x42442C74UL))
#define bFM_MFT2_FRT_TCSC2_MSPC2              *((volatile unsigned char*)(0x42442C78UL))
#define bFM_MFT2_FRT_TCSC2_MSPC3              *((volatile unsigned char*)(0x42442C7CUL))
#define bFM_MFT2_FRT_TCAL_STOP00              *((volatile unsigned char*)(0x42442C80UL))
#define bFM_MFT2_FRT_TCAL_STOP01              *((volatile unsigned char*)(0x42442C84UL))
#define bFM_MFT2_FRT_TCAL_STOP02              *((volatile unsigned char*)(0x42442C88UL))
#define bFM_MFT2_FRT_TCAL_STOP10              *((volatile unsigned char*)(0x42442C8CUL))
#define bFM_MFT2_FRT_TCAL_STOP11              *((volatile unsigned char*)(0x42442C90UL))
#define bFM_MFT2_FRT_TCAL_STOP12              *((volatile unsigned char*)(0x42442C94UL))
#define bFM_MFT2_FRT_TCAL_STOP20              *((volatile unsigned char*)(0x42442C98UL))
#define bFM_MFT2_FRT_TCAL_STOP21              *((volatile unsigned char*)(0x42442C9CUL))
#define bFM_MFT2_FRT_TCAL_STOP22              *((volatile unsigned char*)(0x42442CA0UL))
#define bFM_MFT2_FRT_TCAL_SCLR00              *((volatile unsigned char*)(0x42442CC0UL))
#define bFM_MFT2_FRT_TCAL_SCLR01              *((volatile unsigned char*)(0x42442CC4UL))
#define bFM_MFT2_FRT_TCAL_SCLR02              *((volatile unsigned char*)(0x42442CC8UL))
#define bFM_MFT2_FRT_TCAL_SCLR10              *((volatile unsigned char*)(0x42442CCCUL))
#define bFM_MFT2_FRT_TCAL_SCLR11              *((volatile unsigned char*)(0x42442CD0UL))
#define bFM_MFT2_FRT_TCAL_SCLR12              *((volatile unsigned char*)(0x42442CD4UL))
#define bFM_MFT2_FRT_TCAL_SCLR20              *((volatile unsigned char*)(0x42442CD8UL))
#define bFM_MFT2_FRT_TCAL_SCLR21              *((volatile unsigned char*)(0x42442CDCUL))
#define bFM_MFT2_FRT_TCAL_SCLR22              *((volatile unsigned char*)(0x42442CE0UL))
#define bFM_MFT2_FRT_TCSD_OFMD1               *((volatile unsigned char*)(0x42443D80UL))
#define bFM_MFT2_FRT_TCSD_OFMD2               *((volatile unsigned char*)(0x42443D84UL))

/* Multifunction Timer unit 2 Output Compare Unit registers */
#define bFM_MFT2_OCU_OCSA10_CST0              *((volatile unsigned char*)(0x42442300UL))
#define bFM_MFT2_OCU_OCSA10_CST1              *((volatile unsigned char*)(0x42442304UL))
#define bFM_MFT2_OCU_OCSA10_IOE0              *((volatile unsigned char*)(0x42442310UL))
#define bFM_MFT2_OCU_OCSA10_IOE1              *((volatile unsigned char*)(0x42442314UL))
#define bFM_MFT2_OCU_OCSA10_IOP0              *((volatile unsigned char*)(0x42442318UL))
#define bFM_MFT2_OCU_OCSA10_IOP1              *((volatile unsigned char*)(0x4244231CUL))
#define bFM_MFT2_OCU_OCSB10_OTD0              *((volatile unsigned char*)(0x42442320UL))
#define bFM_MFT2_OCU_OCSB10_OTD1              *((volatile unsigned char*)(0x42442324UL))
#define bFM_MFT2_OCU_OCSB10_CMOD              *((volatile unsigned char*)(0x42442330UL))
#define bFM_MFT2_OCU_OCSB10_FM4               *((volatile unsigned char*)(0x4244233CUL))
#define bFM_MFT2_OCU_OCSD10_OCCP0BUFE0        *((volatile unsigned char*)(0x42442340UL))
#define bFM_MFT2_OCU_OCSD10_OCCP0BUFE1        *((volatile unsigned char*)(0x42442344UL))
#define bFM_MFT2_OCU_OCSD10_OCCP1BUFE0        *((volatile unsigned char*)(0x42442348UL))
#define bFM_MFT2_OCU_OCSD10_OCCP1BUFE1        *((volatile unsigned char*)(0x4244234CUL))
#define bFM_MFT2_OCU_OCSD10_OCSE0BUFE0        *((volatile unsigned char*)(0x42442350UL))
#define bFM_MFT2_OCU_OCSD10_OCSE0BUFE1        *((volatile unsigned char*)(0x42442354UL))
#define bFM_MFT2_OCU_OCSD10_OCSE1BUFE0        *((volatile unsigned char*)(0x42442358UL))
#define bFM_MFT2_OCU_OCSD10_OCSE1BUFE1        *((volatile unsigned char*)(0x4244235CUL))
#define bFM_MFT2_OCU_OCSD10_OPBM0             *((volatile unsigned char*)(0x42442360UL))
#define bFM_MFT2_OCU_OCSD10_OPBM1             *((volatile unsigned char*)(0x42442364UL))
#define bFM_MFT2_OCU_OCSD10_OEBM0             *((volatile unsigned char*)(0x42442368UL))
#define bFM_MFT2_OCU_OCSD10_OEBM1             *((volatile unsigned char*)(0x4244236CUL))
#define bFM_MFT2_OCU_OCSD10_OFEX0             *((volatile unsigned char*)(0x42442370UL))
#define bFM_MFT2_OCU_OCSD10_OFEX1             *((volatile unsigned char*)(0x42442374UL))
#define bFM_MFT2_OCU_OCSA32_CST0              *((volatile unsigned char*)(0x42442380UL))
#define bFM_MFT2_OCU_OCSA32_CST1              *((volatile unsigned char*)(0x42442384UL))
#define bFM_MFT2_OCU_OCSA32_IOE0              *((volatile unsigned char*)(0x42442390UL))
#define bFM_MFT2_OCU_OCSA32_IOE1              *((volatile unsigned char*)(0x42442394UL))
#define bFM_MFT2_OCU_OCSA32_IOP0              *((volatile unsigned char*)(0x42442398UL))
#define bFM_MFT2_OCU_OCSA32_IOP1              *((volatile unsigned char*)(0x4244239CUL))
#define bFM_MFT2_OCU_OCSB32_OTD0              *((volatile unsigned char*)(0x424423A0UL))
#define bFM_MFT2_OCU_OCSB32_OTD1              *((volatile unsigned char*)(0x424423A4UL))
#define bFM_MFT2_OCU_OCSB32_CMOD              *((volatile unsigned char*)(0x424423B0UL))
#define bFM_MFT2_OCU_OCSB32_FM4               *((volatile unsigned char*)(0x424423BCUL))
#define bFM_MFT2_OCU_OCSD32_OCCP2BUFE0        *((volatile unsigned char*)(0x424423C0UL))
#define bFM_MFT2_OCU_OCSD32_OCCP2BUFE1        *((volatile unsigned char*)(0x424423C4UL))
#define bFM_MFT2_OCU_OCSD32_OCCP3BUFE0        *((volatile unsigned char*)(0x424423C8UL))
#define bFM_MFT2_OCU_OCSD32_OCCP3BUFE1        *((volatile unsigned char*)(0x424423CCUL))
#define bFM_MFT2_OCU_OCSD32_OCSE2BUFE0        *((volatile unsigned char*)(0x424423D0UL))
#define bFM_MFT2_OCU_OCSD32_OCSE2BUFE1        *((volatile unsigned char*)(0x424423D4UL))
#define bFM_MFT2_OCU_OCSD32_OCSE3BUFE0        *((volatile unsigned char*)(0x424423D8UL))
#define bFM_MFT2_OCU_OCSD32_OCSE3BUFE1        *((volatile unsigned char*)(0x424423DCUL))
#define bFM_MFT2_OCU_OCSD32_OPBM2             *((volatile unsigned char*)(0x424423E0UL))
#define bFM_MFT2_OCU_OCSD32_OPBM3             *((volatile unsigned char*)(0x424423E4UL))
#define bFM_MFT2_OCU_OCSD32_OEBM2             *((volatile unsigned char*)(0x424423E8UL))
#define bFM_MFT2_OCU_OCSD32_OEBM3             *((volatile unsigned char*)(0x424423ECUL))
#define bFM_MFT2_OCU_OCSD32_OFEX2             *((volatile unsigned char*)(0x424423F0UL))
#define bFM_MFT2_OCU_OCSD32_OFEX3             *((volatile unsigned char*)(0x424423F4UL))
#define bFM_MFT2_OCU_OCSA54_CST0              *((volatile unsigned char*)(0x42442400UL))
#define bFM_MFT2_OCU_OCSA54_CST1              *((volatile unsigned char*)(0x42442404UL))
#define bFM_MFT2_OCU_OCSA54_IOE0              *((volatile unsigned char*)(0x42442410UL))
#define bFM_MFT2_OCU_OCSA54_IOE1              *((volatile unsigned char*)(0x42442414UL))
#define bFM_MFT2_OCU_OCSA54_IOP0              *((volatile unsigned char*)(0x42442418UL))
#define bFM_MFT2_OCU_OCSA54_IOP1              *((volatile unsigned char*)(0x4244241CUL))
#define bFM_MFT2_OCU_OCSB54_OTD0              *((volatile unsigned char*)(0x42442420UL))
#define bFM_MFT2_OCU_OCSB54_OTD1              *((volatile unsigned char*)(0x42442424UL))
#define bFM_MFT2_OCU_OCSB54_CMOD              *((volatile unsigned char*)(0x42442430UL))
#define bFM_MFT2_OCU_OCSB54_FM4               *((volatile unsigned char*)(0x4244243CUL))
#define bFM_MFT2_OCU_OCSD54_OCCP4BUFE0        *((volatile unsigned char*)(0x42442440UL))
#define bFM_MFT2_OCU_OCSD54_OCCP4BUFE1        *((volatile unsigned char*)(0x42442444UL))
#define bFM_MFT2_OCU_OCSD54_OCCP5BUFE0        *((volatile unsigned char*)(0x42442448UL))
#define bFM_MFT2_OCU_OCSD54_OCCP5BUFE1        *((volatile unsigned char*)(0x4244244CUL))
#define bFM_MFT2_OCU_OCSD54_OCSE4BUFE0        *((volatile unsigned char*)(0x42442450UL))
#define bFM_MFT2_OCU_OCSD54_OCSE4BUFE1        *((volatile unsigned char*)(0x42442454UL))
#define bFM_MFT2_OCU_OCSD54_OCSE5BUFE0        *((volatile unsigned char*)(0x42442458UL))
#define bFM_MFT2_OCU_OCSD54_OCSE5BUFE1        *((volatile unsigned char*)(0x4244245CUL))
#define bFM_MFT2_OCU_OCSD54_OPBM4             *((volatile unsigned char*)(0x42442460UL))
#define bFM_MFT2_OCU_OCSD54_OPBM5             *((volatile unsigned char*)(0x42442464UL))
#define bFM_MFT2_OCU_OCSD54_OEBM4             *((volatile unsigned char*)(0x42442468UL))
#define bFM_MFT2_OCU_OCSD54_OEBM5             *((volatile unsigned char*)(0x4244246CUL))
#define bFM_MFT2_OCU_OCSD54_OFEX4             *((volatile unsigned char*)(0x42442470UL))
#define bFM_MFT2_OCU_OCSD54_OFEX5             *((volatile unsigned char*)(0x42442474UL))
#define bFM_MFT2_OCU_OCSC_MOD0                *((volatile unsigned char*)(0x424424A0UL))
#define bFM_MFT2_OCU_OCSC_MOD1                *((volatile unsigned char*)(0x424424A4UL))
#define bFM_MFT2_OCU_OCSC_MOD2                *((volatile unsigned char*)(0x424424A8UL))
#define bFM_MFT2_OCU_OCSC_MOD3                *((volatile unsigned char*)(0x424424ACUL))
#define bFM_MFT2_OCU_OCSC_MOD4                *((volatile unsigned char*)(0x424424B0UL))
#define bFM_MFT2_OCU_OCSC_MOD5                *((volatile unsigned char*)(0x424424B4UL))
#define bFM_MFT2_OCU_OCFS10_FSO00             *((volatile unsigned char*)(0x42442D00UL))
#define bFM_MFT2_OCU_OCFS10_FSO01             *((volatile unsigned char*)(0x42442D04UL))
#define bFM_MFT2_OCU_OCFS10_FSO02             *((volatile unsigned char*)(0x42442D08UL))
#define bFM_MFT2_OCU_OCFS10_FSO03             *((volatile unsigned char*)(0x42442D0CUL))
#define bFM_MFT2_OCU_OCFS10_FSO10             *((volatile unsigned char*)(0x42442D10UL))
#define bFM_MFT2_OCU_OCFS10_FSO11             *((volatile unsigned char*)(0x42442D14UL))
#define bFM_MFT2_OCU_OCFS10_FSO12             *((volatile unsigned char*)(0x42442D18UL))
#define bFM_MFT2_OCU_OCFS10_FSO13             *((volatile unsigned char*)(0x42442D1CUL))
#define bFM_MFT2_OCU_OCFS32_FSO00             *((volatile unsigned char*)(0x42442D20UL))
#define bFM_MFT2_OCU_OCFS32_FSO01             *((volatile unsigned char*)(0x42442D24UL))
#define bFM_MFT2_OCU_OCFS32_FSO02             *((volatile unsigned char*)(0x42442D28UL))
#define bFM_MFT2_OCU_OCFS32_FSO03             *((volatile unsigned char*)(0x42442D2CUL))
#define bFM_MFT2_OCU_OCFS32_FSO10             *((volatile unsigned char*)(0x42442D30UL))
#define bFM_MFT2_OCU_OCFS32_FSO11             *((volatile unsigned char*)(0x42442D34UL))
#define bFM_MFT2_OCU_OCFS32_FSO12             *((volatile unsigned char*)(0x42442D38UL))
#define bFM_MFT2_OCU_OCFS32_FSO13             *((volatile unsigned char*)(0x42442D3CUL))
#define bFM_MFT2_OCU_OCFS54_FSO00             *((volatile unsigned char*)(0x42442D40UL))
#define bFM_MFT2_OCU_OCFS54_FSO01             *((volatile unsigned char*)(0x42442D44UL))
#define bFM_MFT2_OCU_OCFS54_FSO02             *((volatile unsigned char*)(0x42442D48UL))
#define bFM_MFT2_OCU_OCFS54_FSO03             *((volatile unsigned char*)(0x42442D4CUL))
#define bFM_MFT2_OCU_OCFS54_FSO10             *((volatile unsigned char*)(0x42442D50UL))
#define bFM_MFT2_OCU_OCFS54_FSO11             *((volatile unsigned char*)(0x42442D54UL))
#define bFM_MFT2_OCU_OCFS54_FSO12             *((volatile unsigned char*)(0x42442D58UL))
#define bFM_MFT2_OCU_OCFS54_FSO13             *((volatile unsigned char*)(0x42442D5CUL))

/* Multifunction Timer unit 2 Waveform Generator and Noise Canceler registers */
#define bFM_MFT2_WFG_WFSA10_DCK0              *((volatile unsigned char*)(0x42443480UL))
#define bFM_MFT2_WFG_WFSA10_DCK1              *((volatile unsigned char*)(0x42443484UL))
#define bFM_MFT2_WFG_WFSA10_DCK2              *((volatile unsigned char*)(0x42443488UL))
#define bFM_MFT2_WFG_WFSA10_GTEN0             *((volatile unsigned char*)(0x42443498UL))
#define bFM_MFT2_WFG_WFSA10_GTEN1             *((volatile unsigned char*)(0x4244349CUL))
#define bFM_MFT2_WFG_WFSA10_PSEL0             *((volatile unsigned char*)(0x424434A0UL))
#define bFM_MFT2_WFG_WFSA10_PSEL1             *((volatile unsigned char*)(0x424434A4UL))
#define bFM_MFT2_WFG_WFSA10_PGEN0             *((volatile unsigned char*)(0x424434A8UL))
#define bFM_MFT2_WFG_WFSA10_PGEN1             *((volatile unsigned char*)(0x424434ACUL))
#define bFM_MFT2_WFG_WFSA32_DCK0              *((volatile unsigned char*)(0x42443500UL))
#define bFM_MFT2_WFG_WFSA32_DCK1              *((volatile unsigned char*)(0x42443504UL))
#define bFM_MFT2_WFG_WFSA32_DCK2              *((volatile unsigned char*)(0x42443508UL))
#define bFM_MFT2_WFG_WFSA32_GTEN0             *((volatile unsigned char*)(0x42443518UL))
#define bFM_MFT2_WFG_WFSA32_GTEN1             *((volatile unsigned char*)(0x4244351CUL))
#define bFM_MFT2_WFG_WFSA32_PSEL0             *((volatile unsigned char*)(0x42443520UL))
#define bFM_MFT2_WFG_WFSA32_PSEL1             *((volatile unsigned char*)(0x42443524UL))
#define bFM_MFT2_WFG_WFSA32_PGEN0             *((volatile unsigned char*)(0x42443528UL))
#define bFM_MFT2_WFG_WFSA32_PGEN1             *((volatile unsigned char*)(0x4244352CUL))
#define bFM_MFT2_WFG_WFSA54_DCK0              *((volatile unsigned char*)(0x42443580UL))
#define bFM_MFT2_WFG_WFSA54_DCK1              *((volatile unsigned char*)(0x42443584UL))
#define bFM_MFT2_WFG_WFSA54_DCK2              *((volatile unsigned char*)(0x42443588UL))
#define bFM_MFT2_WFG_WFSA54_GTEN0             *((volatile unsigned char*)(0x42443598UL))
#define bFM_MFT2_WFG_WFSA54_GTEN1             *((volatile unsigned char*)(0x4244359CUL))
#define bFM_MFT2_WFG_WFSA54_PSEL0             *((volatile unsigned char*)(0x424435A0UL))
#define bFM_MFT2_WFG_WFSA54_PSEL1             *((volatile unsigned char*)(0x424435A4UL))
#define bFM_MFT2_WFG_WFSA54_PGEN0             *((volatile unsigned char*)(0x424435A8UL))
#define bFM_MFT2_WFG_WFSA54_PGEN1             *((volatile unsigned char*)(0x424435ACUL))
#define bFM_MFT2_WFG_WFIR_DTIFA               *((volatile unsigned char*)(0x42443600UL))
#define bFM_MFT2_WFG_WFIR_DTICA               *((volatile unsigned char*)(0x42443604UL))
#define bFM_MFT2_WFG_WFIR_DTIFB               *((volatile unsigned char*)(0x42443608UL))
#define bFM_MFT2_WFG_WFIR_DTICB               *((volatile unsigned char*)(0x4244360CUL))
#define bFM_MFT2_WFG_WFIR_TMIF10              *((volatile unsigned char*)(0x42443610UL))
#define bFM_MFT2_WFG_WFIR_TMIC10              *((volatile unsigned char*)(0x42443614UL))
#define bFM_MFT2_WFG_WFIR_TMIE10              *((volatile unsigned char*)(0x42443618UL))
#define bFM_MFT2_WFG_WFIR_TMIS10              *((volatile unsigned char*)(0x4244361CUL))
#define bFM_MFT2_WFG_WFIR_TMIF32              *((volatile unsigned char*)(0x42443620UL))
#define bFM_MFT2_WFG_WFIR_TMIC32              *((volatile unsigned char*)(0x42443624UL))
#define bFM_MFT2_WFG_WFIR_TMIE32              *((volatile unsigned char*)(0x42443628UL))
#define bFM_MFT2_WFG_WFIR_TMIS32              *((volatile unsigned char*)(0x4244362CUL))
#define bFM_MFT2_WFG_WFIR_TMIF54              *((volatile unsigned char*)(0x42443630UL))
#define bFM_MFT2_WFG_WFIR_TMIC54              *((volatile unsigned char*)(0x42443634UL))
#define bFM_MFT2_WFG_WFIR_TMIE54              *((volatile unsigned char*)(0x42443638UL))
#define bFM_MFT2_WFG_WFIR_TMIS54              *((volatile unsigned char*)(0x4244363CUL))
#define bFM_MFT2_WFG_NZCL_DTIEA               *((volatile unsigned char*)(0x42443680UL))
#define bFM_MFT2_WFG_NZCL_NWS0                *((volatile unsigned char*)(0x42443684UL))
#define bFM_MFT2_WFG_NZCL_NWS1                *((volatile unsigned char*)(0x42443688UL))
#define bFM_MFT2_WFG_NZCL_NWS2                *((volatile unsigned char*)(0x4244368CUL))
#define bFM_MFT2_WFG_NZCL_SDTI                *((volatile unsigned char*)(0x42443690UL))
#define bFM_MFT2_WFG_NZCL_DTIEB               *((volatile unsigned char*)(0x42443694UL))
#define bFM_MFT2_WFG_NZCL_DHOLD               *((volatile unsigned char*)(0x4244369CUL))
#define bFM_MFT2_WFG_NZCL_DIMA                *((volatile unsigned char*)(0x424436A0UL))
#define bFM_MFT2_WFG_NZCL_DIMB                *((volatile unsigned char*)(0x424436A4UL))
#define bFM_MFT2_WFG_NZCL_WIM10               *((volatile unsigned char*)(0x424436B0UL))
#define bFM_MFT2_WFG_NZCL_WIM32               *((volatile unsigned char*)(0x424436B4UL))
#define bFM_MFT2_WFG_NZCL_WIM54               *((volatile unsigned char*)(0x424436B8UL))

/* Multifunction Timer unit 2 Input Capture Unit registers */
#define bFM_MFT2_ICU_ICFS10_FSI00             *((volatile unsigned char*)(0x42442D80UL))
#define bFM_MFT2_ICU_ICFS10_FSI01             *((volatile unsigned char*)(0x42442D84UL))
#define bFM_MFT2_ICU_ICFS10_FSI02             *((volatile unsigned char*)(0x42442D88UL))
#define bFM_MFT2_ICU_ICFS10_FSI03             *((volatile unsigned char*)(0x42442D8CUL))
#define bFM_MFT2_ICU_ICFS10_FSI10             *((volatile unsigned char*)(0x42442D90UL))
#define bFM_MFT2_ICU_ICFS10_FSI11             *((volatile unsigned char*)(0x42442D94UL))
#define bFM_MFT2_ICU_ICFS10_FSI12             *((volatile unsigned char*)(0x42442D98UL))
#define bFM_MFT2_ICU_ICFS10_FSI13             *((volatile unsigned char*)(0x42442D9CUL))
#define bFM_MFT2_ICU_ICFS32_FSI00             *((volatile unsigned char*)(0x42442DA0UL))
#define bFM_MFT2_ICU_ICFS32_FSI01             *((volatile unsigned char*)(0x42442DA4UL))
#define bFM_MFT2_ICU_ICFS32_FSI02             *((volatile unsigned char*)(0x42442DA8UL))
#define bFM_MFT2_ICU_ICFS32_FSI03             *((volatile unsigned char*)(0x42442DACUL))
#define bFM_MFT2_ICU_ICFS32_FSI10             *((volatile unsigned char*)(0x42442DB0UL))
#define bFM_MFT2_ICU_ICFS32_FSI11             *((volatile unsigned char*)(0x42442DB4UL))
#define bFM_MFT2_ICU_ICFS32_FSI12             *((volatile unsigned char*)(0x42442DB8UL))
#define bFM_MFT2_ICU_ICFS32_FSI13             *((volatile unsigned char*)(0x42442DBCUL))
#define bFM_MFT2_ICU_ICSA10_EG00              *((volatile unsigned char*)(0x42443080UL))
#define bFM_MFT2_ICU_ICSA10_EG01              *((volatile unsigned char*)(0x42443084UL))
#define bFM_MFT2_ICU_ICSA10_EG10              *((volatile unsigned char*)(0x42443088UL))
#define bFM_MFT2_ICU_ICSA10_EG11              *((volatile unsigned char*)(0x4244308CUL))
#define bFM_MFT2_ICU_ICSA10_ICE0              *((volatile unsigned char*)(0x42443090UL))
#define bFM_MFT2_ICU_ICSA10_ICE1              *((volatile unsigned char*)(0x42443094UL))
#define bFM_MFT2_ICU_ICSA10_ICP0              *((volatile unsigned char*)(0x42443098UL))
#define bFM_MFT2_ICU_ICSA10_ICP1              *((volatile unsigned char*)(0x4244309CUL))
#define bFM_MFT2_ICU_ICSB10_IEI0              *((volatile unsigned char*)(0x424430A0UL))
#define bFM_MFT2_ICU_ICSB10_IEI1              *((volatile unsigned char*)(0x424430A4UL))
#define bFM_MFT2_ICU_ICSA32_EG00              *((volatile unsigned char*)(0x42443100UL))
#define bFM_MFT2_ICU_ICSA32_EG01              *((volatile unsigned char*)(0x42443104UL))
#define bFM_MFT2_ICU_ICSA32_EG10              *((volatile unsigned char*)(0x42443108UL))
#define bFM_MFT2_ICU_ICSA32_EG11              *((volatile unsigned char*)(0x4244310CUL))
#define bFM_MFT2_ICU_ICSA32_ICE0              *((volatile unsigned char*)(0x42443110UL))
#define bFM_MFT2_ICU_ICSA32_ICE1              *((volatile unsigned char*)(0x42443114UL))
#define bFM_MFT2_ICU_ICSA32_ICP0              *((volatile unsigned char*)(0x42443118UL))
#define bFM_MFT2_ICU_ICSA32_ICP1              *((volatile unsigned char*)(0x4244311CUL))
#define bFM_MFT2_ICU_ICSB32_IEI0              *((volatile unsigned char*)(0x42443120UL))
#define bFM_MFT2_ICU_ICSB32_IEI1              *((volatile unsigned char*)(0x42443124UL))

/* Multifunction Timer unit 2 ADC Start Compare Unit registers */
#define bFM_MFT2_ADCMP_ACSC0_BUFE0            *((volatile unsigned char*)(0x42443A80UL))
#define bFM_MFT2_ADCMP_ACSC0_BUFE1            *((volatile unsigned char*)(0x42443A84UL))
#define bFM_MFT2_ADCMP_ACSC0_ADSEL0           *((volatile unsigned char*)(0x42443A88UL))
#define bFM_MFT2_ADCMP_ACSC0_ADSEL1           *((volatile unsigned char*)(0x42443A8CUL))
#define bFM_MFT2_ADCMP_ACSC0_ADSEL2           *((volatile unsigned char*)(0x42443A90UL))
#define bFM_MFT2_ADCMP_ACSC0_APBM             *((volatile unsigned char*)(0x42443A94UL))
#define bFM_MFT2_ADCMP_ACSD0_AMOD             *((volatile unsigned char*)(0x42443AA0UL))
#define bFM_MFT2_ADCMP_ACSD0_OCUS             *((volatile unsigned char*)(0x42443AA4UL))
#define bFM_MFT2_ADCMP_ACSD0_DE               *((volatile unsigned char*)(0x42443AB0UL))
#define bFM_MFT2_ADCMP_ACSD0_PE               *((volatile unsigned char*)(0x42443AB4UL))
#define bFM_MFT2_ADCMP_ACSD0_UE               *((volatile unsigned char*)(0x42443AB8UL))
#define bFM_MFT2_ADCMP_ACSD0_ZE               *((volatile unsigned char*)(0x42443ABCUL))
#define bFM_MFT2_ADCMP_ACMC0_AMC0             *((volatile unsigned char*)(0x42443AC0UL))
#define bFM_MFT2_ADCMP_ACMC0_AMC1             *((volatile unsigned char*)(0x42443AC4UL))
#define bFM_MFT2_ADCMP_ACMC0_AMC2             *((volatile unsigned char*)(0x42443AC8UL))
#define bFM_MFT2_ADCMP_ACMC0_AMC3             *((volatile unsigned char*)(0x42443ACCUL))
#define bFM_MFT2_ADCMP_ACMC0_MZCE             *((volatile unsigned char*)(0x42443AD8UL))
#define bFM_MFT2_ADCMP_ACMC0_MPCE             *((volatile unsigned char*)(0x42443ADCUL))
#define bFM_MFT2_ADCMP_ACSC1_BUFE0            *((volatile unsigned char*)(0x42443B00UL))
#define bFM_MFT2_ADCMP_ACSC1_BUFE1            *((volatile unsigned char*)(0x42443B04UL))
#define bFM_MFT2_ADCMP_ACSC1_ADSEL0           *((volatile unsigned char*)(0x42443B08UL))
#define bFM_MFT2_ADCMP_ACSC1_ADSEL1           *((volatile unsigned char*)(0x42443B0CUL))
#define bFM_MFT2_ADCMP_ACSC1_ADSEL2           *((volatile unsigned char*)(0x42443B10UL))
#define bFM_MFT2_ADCMP_ACSC1_APBM             *((volatile unsigned char*)(0x42443B14UL))
#define bFM_MFT2_ADCMP_ACSD1_AMOD             *((volatile unsigned char*)(0x42443B20UL))
#define bFM_MFT2_ADCMP_ACSD1_OCUS             *((volatile unsigned char*)(0x42443B24UL))
#define bFM_MFT2_ADCMP_ACSD1_DE               *((volatile unsigned char*)(0x42443B30UL))
#define bFM_MFT2_ADCMP_ACSD1_PE               *((volatile unsigned char*)(0x42443B34UL))
#define bFM_MFT2_ADCMP_ACSD1_UE               *((volatile unsigned char*)(0x42443B38UL))
#define bFM_MFT2_ADCMP_ACSD1_ZE               *((volatile unsigned char*)(0x42443B3CUL))
#define bFM_MFT2_ADCMP_ACMC1_AMC0             *((volatile unsigned char*)(0x42443B40UL))
#define bFM_MFT2_ADCMP_ACMC1_AMC1             *((volatile unsigned char*)(0x42443B44UL))
#define bFM_MFT2_ADCMP_ACMC1_AMC2             *((volatile unsigned char*)(0x42443B48UL))
#define bFM_MFT2_ADCMP_ACMC1_AMC3             *((volatile unsigned char*)(0x42443B4CUL))
#define bFM_MFT2_ADCMP_ACMC1_MZCE             *((volatile unsigned char*)(0x42443B58UL))
#define bFM_MFT2_ADCMP_ACMC1_MPCE             *((volatile unsigned char*)(0x42443B5CUL))
#define bFM_MFT2_ADCMP_ACSC2_BUFE0            *((volatile unsigned char*)(0x42443B80UL))
#define bFM_MFT2_ADCMP_ACSC2_BUFE1            *((volatile unsigned char*)(0x42443B84UL))
#define bFM_MFT2_ADCMP_ACSC2_ADSEL0           *((volatile unsigned char*)(0x42443B88UL))
#define bFM_MFT2_ADCMP_ACSC2_ADSEL1           *((volatile unsigned char*)(0x42443B8CUL))
#define bFM_MFT2_ADCMP_ACSC2_ADSEL2           *((volatile unsigned char*)(0x42443B90UL))
#define bFM_MFT2_ADCMP_ACSC2_APBM             *((volatile unsigned char*)(0x42443B94UL))
#define bFM_MFT2_ADCMP_ACSD2_AMOD             *((volatile unsigned char*)(0x42443BA0UL))
#define bFM_MFT2_ADCMP_ACSD2_OCUS             *((volatile unsigned char*)(0x42443BA4UL))
#define bFM_MFT2_ADCMP_ACSD2_DE               *((volatile unsigned char*)(0x42443BB0UL))
#define bFM_MFT2_ADCMP_ACSD2_PE               *((volatile unsigned char*)(0x42443BB4UL))
#define bFM_MFT2_ADCMP_ACSD2_UE               *((volatile unsigned char*)(0x42443BB8UL))
#define bFM_MFT2_ADCMP_ACSD2_ZE               *((volatile unsigned char*)(0x42443BBCUL))
#define bFM_MFT2_ADCMP_ACMC2_AMC0             *((volatile unsigned char*)(0x42443BC0UL))
#define bFM_MFT2_ADCMP_ACMC2_AMC1             *((volatile unsigned char*)(0x42443BC4UL))
#define bFM_MFT2_ADCMP_ACMC2_AMC2             *((volatile unsigned char*)(0x42443BC8UL))
#define bFM_MFT2_ADCMP_ACMC2_AMC3             *((volatile unsigned char*)(0x42443BCCUL))
#define bFM_MFT2_ADCMP_ACMC2_MZCE             *((volatile unsigned char*)(0x42443BD8UL))
#define bFM_MFT2_ADCMP_ACMC2_MPCE             *((volatile unsigned char*)(0x42443BDCUL))
#define bFM_MFT2_ADCMP_ACSC3_BUFE0            *((volatile unsigned char*)(0x42443C00UL))
#define bFM_MFT2_ADCMP_ACSC3_BUFE1            *((volatile unsigned char*)(0x42443C04UL))
#define bFM_MFT2_ADCMP_ACSC3_ADSEL0           *((volatile unsigned char*)(0x42443C08UL))
#define bFM_MFT2_ADCMP_ACSC3_ADSEL1           *((volatile unsigned char*)(0x42443C0CUL))
#define bFM_MFT2_ADCMP_ACSC3_ADSEL2           *((volatile unsigned char*)(0x42443C10UL))
#define bFM_MFT2_ADCMP_ACSC3_APBM             *((volatile unsigned char*)(0x42443C14UL))
#define bFM_MFT2_ADCMP_ACSD3_AMOD             *((volatile unsigned char*)(0x42443C20UL))
#define bFM_MFT2_ADCMP_ACSD3_OCUS             *((volatile unsigned char*)(0x42443C24UL))
#define bFM_MFT2_ADCMP_ACSD3_DE               *((volatile unsigned char*)(0x42443C30UL))
#define bFM_MFT2_ADCMP_ACSD3_PE               *((volatile unsigned char*)(0x42443C34UL))
#define bFM_MFT2_ADCMP_ACSD3_UE               *((volatile unsigned char*)(0x42443C38UL))
#define bFM_MFT2_ADCMP_ACSD3_ZE               *((volatile unsigned char*)(0x42443C3CUL))
#define bFM_MFT2_ADCMP_ACMC3_AMC0             *((volatile unsigned char*)(0x42443C40UL))
#define bFM_MFT2_ADCMP_ACMC3_AMC1             *((volatile unsigned char*)(0x42443C44UL))
#define bFM_MFT2_ADCMP_ACMC3_AMC2             *((volatile unsigned char*)(0x42443C48UL))
#define bFM_MFT2_ADCMP_ACMC3_AMC3             *((volatile unsigned char*)(0x42443C4CUL))
#define bFM_MFT2_ADCMP_ACMC3_MZCE             *((volatile unsigned char*)(0x42443C58UL))
#define bFM_MFT2_ADCMP_ACMC3_MPCE             *((volatile unsigned char*)(0x42443C5CUL))
#define bFM_MFT2_ADCMP_ACSC4_BUFE0            *((volatile unsigned char*)(0x42443C80UL))
#define bFM_MFT2_ADCMP_ACSC4_BUFE1            *((volatile unsigned char*)(0x42443C84UL))
#define bFM_MFT2_ADCMP_ACSC4_ADSEL0           *((volatile unsigned char*)(0x42443C88UL))
#define bFM_MFT2_ADCMP_ACSC4_ADSEL1           *((volatile unsigned char*)(0x42443C8CUL))
#define bFM_MFT2_ADCMP_ACSC4_ADSEL2           *((volatile unsigned char*)(0x42443C90UL))
#define bFM_MFT2_ADCMP_ACSC4_APBM             *((volatile unsigned char*)(0x42443C94UL))
#define bFM_MFT2_ADCMP_ACSD4_AMOD             *((volatile unsigned char*)(0x42443CA0UL))
#define bFM_MFT2_ADCMP_ACSD4_OCUS             *((volatile unsigned char*)(0x42443CA4UL))
#define bFM_MFT2_ADCMP_ACSD4_DE               *((volatile unsigned char*)(0x42443CB0UL))
#define bFM_MFT2_ADCMP_ACSD4_PE               *((volatile unsigned char*)(0x42443CB4UL))
#define bFM_MFT2_ADCMP_ACSD4_UE               *((volatile unsigned char*)(0x42443CB8UL))
#define bFM_MFT2_ADCMP_ACSD4_ZE               *((volatile unsigned char*)(0x42443CBCUL))
#define bFM_MFT2_ADCMP_ACMC4_AMC0             *((volatile unsigned char*)(0x42443CC0UL))
#define bFM_MFT2_ADCMP_ACMC4_AMC1             *((volatile unsigned char*)(0x42443CC4UL))
#define bFM_MFT2_ADCMP_ACMC4_AMC2             *((volatile unsigned char*)(0x42443CC8UL))
#define bFM_MFT2_ADCMP_ACMC4_AMC3             *((volatile unsigned char*)(0x42443CCCUL))
#define bFM_MFT2_ADCMP_ACMC4_MZCE             *((volatile unsigned char*)(0x42443CD8UL))
#define bFM_MFT2_ADCMP_ACMC4_MPCE             *((volatile unsigned char*)(0x42443CDCUL))
#define bFM_MFT2_ADCMP_ACSC5_BUFE0            *((volatile unsigned char*)(0x42443D00UL))
#define bFM_MFT2_ADCMP_ACSC5_BUFE1            *((volatile unsigned char*)(0x42443D04UL))
#define bFM_MFT2_ADCMP_ACSC5_ADSEL0           *((volatile unsigned char*)(0x42443D08UL))
#define bFM_MFT2_ADCMP_ACSC5_ADSEL1           *((volatile unsigned char*)(0x42443D0CUL))
#define bFM_MFT2_ADCMP_ACSC5_ADSEL2           *((volatile unsigned char*)(0x42443D10UL))
#define bFM_MFT2_ADCMP_ACSC5_APBM             *((volatile unsigned char*)(0x42443D14UL))
#define bFM_MFT2_ADCMP_ACSD5_AMOD             *((volatile unsigned char*)(0x42443D20UL))
#define bFM_MFT2_ADCMP_ACSD5_OCUS             *((volatile unsigned char*)(0x42443D24UL))
#define bFM_MFT2_ADCMP_ACSD5_DE               *((volatile unsigned char*)(0x42443D30UL))
#define bFM_MFT2_ADCMP_ACSD5_PE               *((volatile unsigned char*)(0x42443D34UL))
#define bFM_MFT2_ADCMP_ACSD5_UE               *((volatile unsigned char*)(0x42443D38UL))
#define bFM_MFT2_ADCMP_ACSD5_ZE               *((volatile unsigned char*)(0x42443D3CUL))
#define bFM_MFT2_ADCMP_ACMC5_AMC0             *((volatile unsigned char*)(0x42443D40UL))
#define bFM_MFT2_ADCMP_ACMC5_AMC1             *((volatile unsigned char*)(0x42443D44UL))
#define bFM_MFT2_ADCMP_ACMC5_AMC2             *((volatile unsigned char*)(0x42443D48UL))
#define bFM_MFT2_ADCMP_ACMC5_AMC3             *((volatile unsigned char*)(0x42443D4CUL))
#define bFM_MFT2_ADCMP_ACMC5_MZCE             *((volatile unsigned char*)(0x42443D58UL))
#define bFM_MFT2_ADCMP_ACMC5_MPCE             *((volatile unsigned char*)(0x42443D5CUL))

/* Multifunction Timer PPG registers */
#define bFM_MFT_PPG_TTCR0_STR0                *((volatile unsigned char*)(0x42480020UL))
#define bFM_MFT_PPG_TTCR0_MONI0               *((volatile unsigned char*)(0x42480024UL))
#define bFM_MFT_PPG_TTCR0_CS00                *((volatile unsigned char*)(0x42480028UL))
#define bFM_MFT_PPG_TTCR0_CS01                *((volatile unsigned char*)(0x4248002CUL))
#define bFM_MFT_PPG_TTCR0_TRG0O               *((volatile unsigned char*)(0x42480030UL))
#define bFM_MFT_PPG_TTCR0_TRG2O               *((volatile unsigned char*)(0x42480034UL))
#define bFM_MFT_PPG_TTCR0_TRG4O               *((volatile unsigned char*)(0x42480038UL))
#define bFM_MFT_PPG_TTCR0_TRG6O               *((volatile unsigned char*)(0x4248003CUL))
#define bFM_MFT_PPG_TTCR1_STR1                *((volatile unsigned char*)(0x42480420UL))
#define bFM_MFT_PPG_TTCR1_MONI1               *((volatile unsigned char*)(0x42480424UL))
#define bFM_MFT_PPG_TTCR1_CS10                *((volatile unsigned char*)(0x42480428UL))
#define bFM_MFT_PPG_TTCR1_CS11                *((volatile unsigned char*)(0x4248042CUL))
#define bFM_MFT_PPG_TTCR1_TRG1O               *((volatile unsigned char*)(0x42480430UL))
#define bFM_MFT_PPG_TTCR1_TRG3O               *((volatile unsigned char*)(0x42480434UL))
#define bFM_MFT_PPG_TTCR1_TRG5O               *((volatile unsigned char*)(0x42480438UL))
#define bFM_MFT_PPG_TTCR1_TRG7O               *((volatile unsigned char*)(0x4248043CUL))
#define bFM_MFT_PPG_TTCR2_STR2                *((volatile unsigned char*)(0x42480820UL))
#define bFM_MFT_PPG_TTCR2_MONI2               *((volatile unsigned char*)(0x42480824UL))
#define bFM_MFT_PPG_TTCR2_CS20                *((volatile unsigned char*)(0x42480828UL))
#define bFM_MFT_PPG_TTCR2_CS21                *((volatile unsigned char*)(0x4248082CUL))
#define bFM_MFT_PPG_TTCR2_TRG16O              *((volatile unsigned char*)(0x42480830UL))
#define bFM_MFT_PPG_TTCR2_TRG18O              *((volatile unsigned char*)(0x42480834UL))
#define bFM_MFT_PPG_TTCR2_TRG20O              *((volatile unsigned char*)(0x42480838UL))
#define bFM_MFT_PPG_TTCR2_TRG22O              *((volatile unsigned char*)(0x4248083CUL))
#define bFM_MFT_PPG_TRG_PEN00                 *((volatile unsigned char*)(0x42482000UL))
#define bFM_MFT_PPG_TRG_PEN01                 *((volatile unsigned char*)(0x42482004UL))
#define bFM_MFT_PPG_TRG_PEN02                 *((volatile unsigned char*)(0x42482008UL))
#define bFM_MFT_PPG_TRG_PEN03                 *((volatile unsigned char*)(0x4248200CUL))
#define bFM_MFT_PPG_TRG_PEN04                 *((volatile unsigned char*)(0x42482010UL))
#define bFM_MFT_PPG_TRG_PEN05                 *((volatile unsigned char*)(0x42482014UL))
#define bFM_MFT_PPG_TRG_PEN06                 *((volatile unsigned char*)(0x42482018UL))
#define bFM_MFT_PPG_TRG_PEN07                 *((volatile unsigned char*)(0x4248201CUL))
#define bFM_MFT_PPG_TRG_PEN08                 *((volatile unsigned char*)(0x42482020UL))
#define bFM_MFT_PPG_TRG_PEN09                 *((volatile unsigned char*)(0x42482024UL))
#define bFM_MFT_PPG_TRG_PEN10                 *((volatile unsigned char*)(0x42482028UL))
#define bFM_MFT_PPG_TRG_PEN11                 *((volatile unsigned char*)(0x4248202CUL))
#define bFM_MFT_PPG_TRG_PEN12                 *((volatile unsigned char*)(0x42482030UL))
#define bFM_MFT_PPG_TRG_PEN13                 *((volatile unsigned char*)(0x42482034UL))
#define bFM_MFT_PPG_TRG_PEN14                 *((volatile unsigned char*)(0x42482038UL))
#define bFM_MFT_PPG_TRG_PEN15                 *((volatile unsigned char*)(0x4248203CUL))
#define bFM_MFT_PPG_REVC_REV00                *((volatile unsigned char*)(0x42482080UL))
#define bFM_MFT_PPG_REVC_REV01                *((volatile unsigned char*)(0x42482084UL))
#define bFM_MFT_PPG_REVC_REV02                *((volatile unsigned char*)(0x42482088UL))
#define bFM_MFT_PPG_REVC_REV03                *((volatile unsigned char*)(0x4248208CUL))
#define bFM_MFT_PPG_REVC_REV04                *((volatile unsigned char*)(0x42482090UL))
#define bFM_MFT_PPG_REVC_REV05                *((volatile unsigned char*)(0x42482094UL))
#define bFM_MFT_PPG_REVC_REV06                *((volatile unsigned char*)(0x42482098UL))
#define bFM_MFT_PPG_REVC_REV07                *((volatile unsigned char*)(0x4248209CUL))
#define bFM_MFT_PPG_REVC_REV08                *((volatile unsigned char*)(0x424820A0UL))
#define bFM_MFT_PPG_REVC_REV09                *((volatile unsigned char*)(0x424820A4UL))
#define bFM_MFT_PPG_REVC_REV10                *((volatile unsigned char*)(0x424820A8UL))
#define bFM_MFT_PPG_REVC_REV11                *((volatile unsigned char*)(0x424820ACUL))
#define bFM_MFT_PPG_REVC_REV12                *((volatile unsigned char*)(0x424820B0UL))
#define bFM_MFT_PPG_REVC_REV13                *((volatile unsigned char*)(0x424820B4UL))
#define bFM_MFT_PPG_REVC_REV14                *((volatile unsigned char*)(0x424820B8UL))
#define bFM_MFT_PPG_REVC_REV15                *((volatile unsigned char*)(0x424820BCUL))
#define bFM_MFT_PPG_TRG1_PEN16                *((volatile unsigned char*)(0x42482800UL))
#define bFM_MFT_PPG_TRG1_PEN17                *((volatile unsigned char*)(0x42482804UL))
#define bFM_MFT_PPG_TRG1_PEN18                *((volatile unsigned char*)(0x42482808UL))
#define bFM_MFT_PPG_TRG1_PEN19                *((volatile unsigned char*)(0x4248280CUL))
#define bFM_MFT_PPG_TRG1_PEN20                *((volatile unsigned char*)(0x42482810UL))
#define bFM_MFT_PPG_TRG1_PEN21                *((volatile unsigned char*)(0x42482814UL))
#define bFM_MFT_PPG_TRG1_PEN22                *((volatile unsigned char*)(0x42482818UL))
#define bFM_MFT_PPG_TRG1_PEN23                *((volatile unsigned char*)(0x4248281CUL))
#define bFM_MFT_PPG_REVC1_REV16               *((volatile unsigned char*)(0x42482880UL))
#define bFM_MFT_PPG_REVC1_REV17               *((volatile unsigned char*)(0x42482884UL))
#define bFM_MFT_PPG_REVC1_REV18               *((volatile unsigned char*)(0x42482888UL))
#define bFM_MFT_PPG_REVC1_REV19               *((volatile unsigned char*)(0x4248288CUL))
#define bFM_MFT_PPG_REVC1_REV20               *((volatile unsigned char*)(0x42482890UL))
#define bFM_MFT_PPG_REVC1_REV21               *((volatile unsigned char*)(0x42482894UL))
#define bFM_MFT_PPG_REVC1_REV22               *((volatile unsigned char*)(0x42482898UL))
#define bFM_MFT_PPG_REVC1_REV23               *((volatile unsigned char*)(0x4248289CUL))
#define bFM_MFT_PPG_PPGC1_TTRG                *((volatile unsigned char*)(0x42484000UL))
#define bFM_MFT_PPG_PPGC1_PCS0                *((volatile unsigned char*)(0x4248400CUL))
#define bFM_MFT_PPG_PPGC1_PCS1                *((volatile unsigned char*)(0x42484010UL))
#define bFM_MFT_PPG_PPGC1_INTM                *((volatile unsigned char*)(0x42484014UL))
#define bFM_MFT_PPG_PPGC1_PUF                 *((volatile unsigned char*)(0x42484018UL))
#define bFM_MFT_PPG_PPGC1_PIE                 *((volatile unsigned char*)(0x4248401CUL))
#define bFM_MFT_PPG_PPGC0_TTRG                *((volatile unsigned char*)(0x42484020UL))
#define bFM_MFT_PPG_PPGC0_PCS0                *((volatile unsigned char*)(0x4248402CUL))
#define bFM_MFT_PPG_PPGC0_PCS1                *((volatile unsigned char*)(0x42484030UL))
#define bFM_MFT_PPG_PPGC0_INTM                *((volatile unsigned char*)(0x42484034UL))
#define bFM_MFT_PPG_PPGC0_PUF                 *((volatile unsigned char*)(0x42484038UL))
#define bFM_MFT_PPG_PPGC0_PIE                 *((volatile unsigned char*)(0x4248403CUL))
#define bFM_MFT_PPG_PPGC3_TTRG                *((volatile unsigned char*)(0x42484080UL))
#define bFM_MFT_PPG_PPGC3_PCS0                *((volatile unsigned char*)(0x4248408CUL))
#define bFM_MFT_PPG_PPGC3_PCS1                *((volatile unsigned char*)(0x42484090UL))
#define bFM_MFT_PPG_PPGC3_INTM                *((volatile unsigned char*)(0x42484094UL))
#define bFM_MFT_PPG_PPGC3_PUF                 *((volatile unsigned char*)(0x42484098UL))
#define bFM_MFT_PPG_PPGC3_PIE                 *((volatile unsigned char*)(0x4248409CUL))
#define bFM_MFT_PPG_PPGC2_TTRG                *((volatile unsigned char*)(0x424840A0UL))
#define bFM_MFT_PPG_PPGC2_PCS0                *((volatile unsigned char*)(0x424840ACUL))
#define bFM_MFT_PPG_PPGC2_PCS1                *((volatile unsigned char*)(0x424840B0UL))
#define bFM_MFT_PPG_PPGC2_INTM                *((volatile unsigned char*)(0x424840B4UL))
#define bFM_MFT_PPG_PPGC2_PUF                 *((volatile unsigned char*)(0x424840B8UL))
#define bFM_MFT_PPG_PPGC2_PIE                 *((volatile unsigned char*)(0x424840BCUL))
#define bFM_MFT_PPG_GATEC0_EDGE0              *((volatile unsigned char*)(0x42484300UL))
#define bFM_MFT_PPG_GATEC0_STRG0              *((volatile unsigned char*)(0x42484304UL))
#define bFM_MFT_PPG_GATEC0_EDGE2              *((volatile unsigned char*)(0x42484310UL))
#define bFM_MFT_PPG_GATEC0_STRG2              *((volatile unsigned char*)(0x42484314UL))
#define bFM_MFT_PPG_PPGC5_TTRG                *((volatile unsigned char*)(0x42484800UL))
#define bFM_MFT_PPG_PPGC5_PCS0                *((volatile unsigned char*)(0x4248480CUL))
#define bFM_MFT_PPG_PPGC5_PCS1                *((volatile unsigned char*)(0x42484810UL))
#define bFM_MFT_PPG_PPGC5_INTM                *((volatile unsigned char*)(0x42484814UL))
#define bFM_MFT_PPG_PPGC5_PUF                 *((volatile unsigned char*)(0x42484818UL))
#define bFM_MFT_PPG_PPGC5_PIE                 *((volatile unsigned char*)(0x4248481CUL))
#define bFM_MFT_PPG_PPGC4_TTRG                *((volatile unsigned char*)(0x42484820UL))
#define bFM_MFT_PPG_PPGC4_PCS0                *((volatile unsigned char*)(0x4248482CUL))
#define bFM_MFT_PPG_PPGC4_PCS1                *((volatile unsigned char*)(0x42484830UL))
#define bFM_MFT_PPG_PPGC4_INTM                *((volatile unsigned char*)(0x42484834UL))
#define bFM_MFT_PPG_PPGC4_PUF                 *((volatile unsigned char*)(0x42484838UL))
#define bFM_MFT_PPG_PPGC4_PIE                 *((volatile unsigned char*)(0x4248483CUL))
#define bFM_MFT_PPG_PPGC7_TTRG                *((volatile unsigned char*)(0x42484880UL))
#define bFM_MFT_PPG_PPGC7_PCS0                *((volatile unsigned char*)(0x4248488CUL))
#define bFM_MFT_PPG_PPGC7_PCS1                *((volatile unsigned char*)(0x42484890UL))
#define bFM_MFT_PPG_PPGC7_INTM                *((volatile unsigned char*)(0x42484894UL))
#define bFM_MFT_PPG_PPGC7_PUF                 *((volatile unsigned char*)(0x42484898UL))
#define bFM_MFT_PPG_PPGC7_PIE                 *((volatile unsigned char*)(0x4248489CUL))
#define bFM_MFT_PPG_PPGC6_TTRG                *((volatile unsigned char*)(0x424848A0UL))
#define bFM_MFT_PPG_PPGC6_PCS0                *((volatile unsigned char*)(0x424848ACUL))
#define bFM_MFT_PPG_PPGC6_PCS1                *((volatile unsigned char*)(0x424848B0UL))
#define bFM_MFT_PPG_PPGC6_INTM                *((volatile unsigned char*)(0x424848B4UL))
#define bFM_MFT_PPG_PPGC6_PUF                 *((volatile unsigned char*)(0x424848B8UL))
#define bFM_MFT_PPG_PPGC6_PIE                 *((volatile unsigned char*)(0x424848BCUL))
#define bFM_MFT_PPG_GATEC4_EDGE4              *((volatile unsigned char*)(0x42484B00UL))
#define bFM_MFT_PPG_GATEC4_STRG4              *((volatile unsigned char*)(0x42484B04UL))
#define bFM_MFT_PPG_GATEC4_EDGE6              *((volatile unsigned char*)(0x42484B10UL))
#define bFM_MFT_PPG_GATEC4_STRG6              *((volatile unsigned char*)(0x42484B14UL))
#define bFM_MFT_PPG_PPGC9_TTRG                *((volatile unsigned char*)(0x42485000UL))
#define bFM_MFT_PPG_PPGC9_PCS0                *((volatile unsigned char*)(0x4248500CUL))
#define bFM_MFT_PPG_PPGC9_PCS1                *((volatile unsigned char*)(0x42485010UL))
#define bFM_MFT_PPG_PPGC9_INTM                *((volatile unsigned char*)(0x42485014UL))
#define bFM_MFT_PPG_PPGC9_PUF                 *((volatile unsigned char*)(0x42485018UL))
#define bFM_MFT_PPG_PPGC9_PIE                 *((volatile unsigned char*)(0x4248501CUL))
#define bFM_MFT_PPG_PPGC8_TTRG                *((volatile unsigned char*)(0x42485020UL))
#define bFM_MFT_PPG_PPGC8_PCS0                *((volatile unsigned char*)(0x4248502CUL))
#define bFM_MFT_PPG_PPGC8_PCS1                *((volatile unsigned char*)(0x42485030UL))
#define bFM_MFT_PPG_PPGC8_INTM                *((volatile unsigned char*)(0x42485034UL))
#define bFM_MFT_PPG_PPGC8_PUF                 *((volatile unsigned char*)(0x42485038UL))
#define bFM_MFT_PPG_PPGC8_PIE                 *((volatile unsigned char*)(0x4248503CUL))
#define bFM_MFT_PPG_PPGC11_TTRG               *((volatile unsigned char*)(0x42485080UL))
#define bFM_MFT_PPG_PPGC11_PCS0               *((volatile unsigned char*)(0x4248508CUL))
#define bFM_MFT_PPG_PPGC11_PCS1               *((volatile unsigned char*)(0x42485090UL))
#define bFM_MFT_PPG_PPGC11_INTM               *((volatile unsigned char*)(0x42485094UL))
#define bFM_MFT_PPG_PPGC11_PUF                *((volatile unsigned char*)(0x42485098UL))
#define bFM_MFT_PPG_PPGC11_PIE                *((volatile unsigned char*)(0x4248509CUL))
#define bFM_MFT_PPG_PPGC10_TTRG               *((volatile unsigned char*)(0x424850A0UL))
#define bFM_MFT_PPG_PPGC10_PCS0               *((volatile unsigned char*)(0x424850ACUL))
#define bFM_MFT_PPG_PPGC10_PCS1               *((volatile unsigned char*)(0x424850B0UL))
#define bFM_MFT_PPG_PPGC10_INTM               *((volatile unsigned char*)(0x424850B4UL))
#define bFM_MFT_PPG_PPGC10_PUF                *((volatile unsigned char*)(0x424850B8UL))
#define bFM_MFT_PPG_PPGC10_PIE                *((volatile unsigned char*)(0x424850BCUL))
#define bFM_MFT_PPG_GATEC8_EDGE8              *((volatile unsigned char*)(0x42485300UL))
#define bFM_MFT_PPG_GATEC8_STRG8              *((volatile unsigned char*)(0x42485304UL))
#define bFM_MFT_PPG_GATEC8_EDGE10             *((volatile unsigned char*)(0x42485310UL))
#define bFM_MFT_PPG_GATEC8_STRG10             *((volatile unsigned char*)(0x42485314UL))
#define bFM_MFT_PPG_PPGC13_TTRG               *((volatile unsigned char*)(0x42485800UL))
#define bFM_MFT_PPG_PPGC13_PCS0               *((volatile unsigned char*)(0x4248580CUL))
#define bFM_MFT_PPG_PPGC13_PCS1               *((volatile unsigned char*)(0x42485810UL))
#define bFM_MFT_PPG_PPGC13_INTM               *((volatile unsigned char*)(0x42485814UL))
#define bFM_MFT_PPG_PPGC13_PUF                *((volatile unsigned char*)(0x42485818UL))
#define bFM_MFT_PPG_PPGC13_PIE                *((volatile unsigned char*)(0x4248581CUL))
#define bFM_MFT_PPG_PPGC12_TTRG               *((volatile unsigned char*)(0x42485820UL))
#define bFM_MFT_PPG_PPGC12_PCS0               *((volatile unsigned char*)(0x4248582CUL))
#define bFM_MFT_PPG_PPGC12_PCS1               *((volatile unsigned char*)(0x42485830UL))
#define bFM_MFT_PPG_PPGC12_INTM               *((volatile unsigned char*)(0x42485834UL))
#define bFM_MFT_PPG_PPGC12_PUF                *((volatile unsigned char*)(0x42485838UL))
#define bFM_MFT_PPG_PPGC12_PIE                *((volatile unsigned char*)(0x4248583CUL))
#define bFM_MFT_PPG_PPGC15_TTRG               *((volatile unsigned char*)(0x42485880UL))
#define bFM_MFT_PPG_PPGC15_PCS0               *((volatile unsigned char*)(0x4248588CUL))
#define bFM_MFT_PPG_PPGC15_PCS1               *((volatile unsigned char*)(0x42485890UL))
#define bFM_MFT_PPG_PPGC15_INTM               *((volatile unsigned char*)(0x42485894UL))
#define bFM_MFT_PPG_PPGC15_PUF                *((volatile unsigned char*)(0x42485898UL))
#define bFM_MFT_PPG_PPGC15_PIE                *((volatile unsigned char*)(0x4248589CUL))
#define bFM_MFT_PPG_PPGC14_TTRG               *((volatile unsigned char*)(0x424858A0UL))
#define bFM_MFT_PPG_PPGC14_PCS0               *((volatile unsigned char*)(0x424858ACUL))
#define bFM_MFT_PPG_PPGC14_PCS1               *((volatile unsigned char*)(0x424858B0UL))
#define bFM_MFT_PPG_PPGC14_INTM               *((volatile unsigned char*)(0x424858B4UL))
#define bFM_MFT_PPG_PPGC14_PUF                *((volatile unsigned char*)(0x424858B8UL))
#define bFM_MFT_PPG_PPGC14_PIE                *((volatile unsigned char*)(0x424858BCUL))
#define bFM_MFT_PPG_GATEC12_EDGE12            *((volatile unsigned char*)(0x42485B00UL))
#define bFM_MFT_PPG_GATEC12_STRG12            *((volatile unsigned char*)(0x42485B04UL))
#define bFM_MFT_PPG_GATEC12_EDGE14            *((volatile unsigned char*)(0x42485B10UL))
#define bFM_MFT_PPG_GATEC12_STRG14            *((volatile unsigned char*)(0x42485B14UL))
#define bFM_MFT_PPG_PPGC17_TTRG               *((volatile unsigned char*)(0x42486000UL))
#define bFM_MFT_PPG_PPGC17_PCS0               *((volatile unsigned char*)(0x4248600CUL))
#define bFM_MFT_PPG_PPGC17_PCS1               *((volatile unsigned char*)(0x42486010UL))
#define bFM_MFT_PPG_PPGC17_INTM               *((volatile unsigned char*)(0x42486014UL))
#define bFM_MFT_PPG_PPGC17_PUF                *((volatile unsigned char*)(0x42486018UL))
#define bFM_MFT_PPG_PPGC17_PIE                *((volatile unsigned char*)(0x4248601CUL))
#define bFM_MFT_PPG_PPGC16_TTRG               *((volatile unsigned char*)(0x42486020UL))
#define bFM_MFT_PPG_PPGC16_PCS0               *((volatile unsigned char*)(0x4248602CUL))
#define bFM_MFT_PPG_PPGC16_PCS1               *((volatile unsigned char*)(0x42486030UL))
#define bFM_MFT_PPG_PPGC16_INTM               *((volatile unsigned char*)(0x42486034UL))
#define bFM_MFT_PPG_PPGC16_PUF                *((volatile unsigned char*)(0x42486038UL))
#define bFM_MFT_PPG_PPGC16_PIE                *((volatile unsigned char*)(0x4248603CUL))
#define bFM_MFT_PPG_PPGC19_TTRG               *((volatile unsigned char*)(0x42486080UL))
#define bFM_MFT_PPG_PPGC19_PCS0               *((volatile unsigned char*)(0x4248608CUL))
#define bFM_MFT_PPG_PPGC19_PCS1               *((volatile unsigned char*)(0x42486090UL))
#define bFM_MFT_PPG_PPGC19_INTM               *((volatile unsigned char*)(0x42486094UL))
#define bFM_MFT_PPG_PPGC19_PUF                *((volatile unsigned char*)(0x42486098UL))
#define bFM_MFT_PPG_PPGC19_PIE                *((volatile unsigned char*)(0x4248609CUL))
#define bFM_MFT_PPG_PPGC18_TTRG               *((volatile unsigned char*)(0x424860A0UL))
#define bFM_MFT_PPG_PPGC18_PCS0               *((volatile unsigned char*)(0x424860ACUL))
#define bFM_MFT_PPG_PPGC18_PCS1               *((volatile unsigned char*)(0x424860B0UL))
#define bFM_MFT_PPG_PPGC18_INTM               *((volatile unsigned char*)(0x424860B4UL))
#define bFM_MFT_PPG_PPGC18_PUF                *((volatile unsigned char*)(0x424860B8UL))
#define bFM_MFT_PPG_PPGC18_PIE                *((volatile unsigned char*)(0x424860BCUL))
#define bFM_MFT_PPG_GATEC16_EDGE16            *((volatile unsigned char*)(0x42486300UL))
#define bFM_MFT_PPG_GATEC16_STRG16            *((volatile unsigned char*)(0x42486304UL))
#define bFM_MFT_PPG_GATEC16_EDGE18            *((volatile unsigned char*)(0x42486310UL))
#define bFM_MFT_PPG_GATEC16_STRG18            *((volatile unsigned char*)(0x42486314UL))
#define bFM_MFT_PPG_PPGC21_TTRG               *((volatile unsigned char*)(0x42486800UL))
#define bFM_MFT_PPG_PPGC21_PCS0               *((volatile unsigned char*)(0x4248680CUL))
#define bFM_MFT_PPG_PPGC21_PCS1               *((volatile unsigned char*)(0x42486810UL))
#define bFM_MFT_PPG_PPGC21_INTM               *((volatile unsigned char*)(0x42486814UL))
#define bFM_MFT_PPG_PPGC21_PUF                *((volatile unsigned char*)(0x42486818UL))
#define bFM_MFT_PPG_PPGC21_PIE                *((volatile unsigned char*)(0x4248681CUL))
#define bFM_MFT_PPG_PPGC20_TTRG               *((volatile unsigned char*)(0x42486820UL))
#define bFM_MFT_PPG_PPGC20_PCS0               *((volatile unsigned char*)(0x4248682CUL))
#define bFM_MFT_PPG_PPGC20_PCS1               *((volatile unsigned char*)(0x42486830UL))
#define bFM_MFT_PPG_PPGC20_INTM               *((volatile unsigned char*)(0x42486834UL))
#define bFM_MFT_PPG_PPGC20_PUF                *((volatile unsigned char*)(0x42486838UL))
#define bFM_MFT_PPG_PPGC20_PIE                *((volatile unsigned char*)(0x4248683CUL))
#define bFM_MFT_PPG_PPGC23_TTRG               *((volatile unsigned char*)(0x42486880UL))
#define bFM_MFT_PPG_PPGC23_PCS0               *((volatile unsigned char*)(0x4248688CUL))
#define bFM_MFT_PPG_PPGC23_PCS1               *((volatile unsigned char*)(0x42486890UL))
#define bFM_MFT_PPG_PPGC23_INTM               *((volatile unsigned char*)(0x42486894UL))
#define bFM_MFT_PPG_PPGC23_PUF                *((volatile unsigned char*)(0x42486898UL))
#define bFM_MFT_PPG_PPGC23_PIE                *((volatile unsigned char*)(0x4248689CUL))
#define bFM_MFT_PPG_PPGC22_TTRG               *((volatile unsigned char*)(0x424868A0UL))
#define bFM_MFT_PPG_PPGC22_PCS0               *((volatile unsigned char*)(0x424868ACUL))
#define bFM_MFT_PPG_PPGC22_PCS1               *((volatile unsigned char*)(0x424868B0UL))
#define bFM_MFT_PPG_PPGC22_INTM               *((volatile unsigned char*)(0x424868B4UL))
#define bFM_MFT_PPG_PPGC22_PUF                *((volatile unsigned char*)(0x424868B8UL))
#define bFM_MFT_PPG_PPGC22_PIE                *((volatile unsigned char*)(0x424868BCUL))
#define bFM_MFT_PPG_GATEC20_EDGE20            *((volatile unsigned char*)(0x42486B00UL))
#define bFM_MFT_PPG_GATEC20_STRG20            *((volatile unsigned char*)(0x42486B04UL))
#define bFM_MFT_PPG_GATEC20_EDGE22            *((volatile unsigned char*)(0x42486B10UL))
#define bFM_MFT_PPG_GATEC20_STRG22            *((volatile unsigned char*)(0x42486B14UL))

/* Base Timer 0 PPG registers */
#define bFM_BT0_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A0180UL))
#define bFM_BT0_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0184UL))
#define bFM_BT0_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0188UL))
#define bFM_BT0_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A018CUL))
#define bFM_BT0_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0190UL))
#define bFM_BT0_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0194UL))
#define bFM_BT0_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0198UL))
#define bFM_BT0_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A01A0UL))
#define bFM_BT0_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A01A4UL))
#define bFM_BT0_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A01A8UL))
#define bFM_BT0_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A01ACUL))
#define bFM_BT0_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A01B0UL))
#define bFM_BT0_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A01B4UL))
#define bFM_BT0_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A01B8UL))
#define bFM_BT0_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A0200UL))
#define bFM_BT0_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A0208UL))
#define bFM_BT0_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A0210UL))
#define bFM_BT0_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A0218UL))
#define bFM_BT0_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0220UL))

/* Base Timer 0 PWM registers */
#define bFM_BT0_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A0180UL))
#define bFM_BT0_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0184UL))
#define bFM_BT0_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0188UL))
#define bFM_BT0_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A018CUL))
#define bFM_BT0_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0190UL))
#define bFM_BT0_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0194UL))
#define bFM_BT0_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0198UL))
#define bFM_BT0_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A01A0UL))
#define bFM_BT0_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A01A4UL))
#define bFM_BT0_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A01A8UL))
#define bFM_BT0_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A01ACUL))
#define bFM_BT0_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A01B0UL))
#define bFM_BT0_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A01B4UL))
#define bFM_BT0_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A01B8UL))
#define bFM_BT0_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A0200UL))
#define bFM_BT0_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A0204UL))
#define bFM_BT0_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A0208UL))
#define bFM_BT0_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A0210UL))
#define bFM_BT0_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A0214UL))
#define bFM_BT0_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A0218UL))
#define bFM_BT0_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0220UL))

/* Base Timer 0 RT registers */
#define bFM_BT0_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A0180UL))
#define bFM_BT0_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A0184UL))
#define bFM_BT0_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A0188UL))
#define bFM_BT0_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A018CUL))
#define bFM_BT0_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A0190UL))
#define bFM_BT0_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A0194UL))
#define bFM_BT0_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A0198UL))
#define bFM_BT0_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A019CUL))
#define bFM_BT0_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A01A0UL))
#define bFM_BT0_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A01A4UL))
#define bFM_BT0_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A01B0UL))
#define bFM_BT0_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A01B4UL))
#define bFM_BT0_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A01B8UL))
#define bFM_BT0_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A0200UL))
#define bFM_BT0_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A0208UL))
#define bFM_BT0_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A0210UL))
#define bFM_BT0_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A0218UL))
#define bFM_BT0_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A0220UL))

/* Base Timer 0 PWC registers */
#define bFM_BT0_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0184UL))
#define bFM_BT0_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0188UL))
#define bFM_BT0_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0190UL))
#define bFM_BT0_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0194UL))
#define bFM_BT0_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0198UL))
#define bFM_BT0_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A019CUL))
#define bFM_BT0_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A01A0UL))
#define bFM_BT0_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A01A4UL))
#define bFM_BT0_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A01A8UL))
#define bFM_BT0_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A01B0UL))
#define bFM_BT0_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A01B4UL))
#define bFM_BT0_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A01B8UL))
#define bFM_BT0_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A0200UL))
#define bFM_BT0_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A0208UL))
#define bFM_BT0_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A0210UL))
#define bFM_BT0_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A0218UL))
#define bFM_BT0_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A021CUL))
#define bFM_BT0_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0220UL))

/* Base Timer 1 PPG registers */
#define bFM_BT1_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A0980UL))
#define bFM_BT1_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0984UL))
#define bFM_BT1_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0988UL))
#define bFM_BT1_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A098CUL))
#define bFM_BT1_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0990UL))
#define bFM_BT1_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0994UL))
#define bFM_BT1_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0998UL))
#define bFM_BT1_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A09A0UL))
#define bFM_BT1_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A09A4UL))
#define bFM_BT1_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A09A8UL))
#define bFM_BT1_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A09ACUL))
#define bFM_BT1_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A09B0UL))
#define bFM_BT1_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A09B4UL))
#define bFM_BT1_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A09B8UL))
#define bFM_BT1_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A0A00UL))
#define bFM_BT1_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A0A08UL))
#define bFM_BT1_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A0A10UL))
#define bFM_BT1_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A0A18UL))
#define bFM_BT1_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0A20UL))

/* Base Timer 1 PWM registers */
#define bFM_BT1_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A0980UL))
#define bFM_BT1_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0984UL))
#define bFM_BT1_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0988UL))
#define bFM_BT1_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A098CUL))
#define bFM_BT1_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0990UL))
#define bFM_BT1_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0994UL))
#define bFM_BT1_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0998UL))
#define bFM_BT1_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A09A0UL))
#define bFM_BT1_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A09A4UL))
#define bFM_BT1_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A09A8UL))
#define bFM_BT1_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A09ACUL))
#define bFM_BT1_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A09B0UL))
#define bFM_BT1_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A09B4UL))
#define bFM_BT1_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A09B8UL))
#define bFM_BT1_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A0A00UL))
#define bFM_BT1_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A0A04UL))
#define bFM_BT1_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A0A08UL))
#define bFM_BT1_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A0A10UL))
#define bFM_BT1_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A0A14UL))
#define bFM_BT1_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A0A18UL))
#define bFM_BT1_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0A20UL))

/* Base Timer 1 RT registers */
#define bFM_BT1_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A0980UL))
#define bFM_BT1_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A0984UL))
#define bFM_BT1_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A0988UL))
#define bFM_BT1_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A098CUL))
#define bFM_BT1_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A0990UL))
#define bFM_BT1_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A0994UL))
#define bFM_BT1_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A0998UL))
#define bFM_BT1_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A099CUL))
#define bFM_BT1_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A09A0UL))
#define bFM_BT1_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A09A4UL))
#define bFM_BT1_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A09B0UL))
#define bFM_BT1_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A09B4UL))
#define bFM_BT1_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A09B8UL))
#define bFM_BT1_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A0A00UL))
#define bFM_BT1_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A0A08UL))
#define bFM_BT1_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A0A10UL))
#define bFM_BT1_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A0A18UL))
#define bFM_BT1_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A0A20UL))

/* Base Timer 1 PWC registers */
#define bFM_BT1_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A0984UL))
#define bFM_BT1_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A0988UL))
#define bFM_BT1_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A0990UL))
#define bFM_BT1_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A0994UL))
#define bFM_BT1_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A0998UL))
#define bFM_BT1_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A099CUL))
#define bFM_BT1_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A09A0UL))
#define bFM_BT1_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A09A4UL))
#define bFM_BT1_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A09A8UL))
#define bFM_BT1_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A09B0UL))
#define bFM_BT1_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A09B4UL))
#define bFM_BT1_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A09B8UL))
#define bFM_BT1_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A0A00UL))
#define bFM_BT1_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A0A08UL))
#define bFM_BT1_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A0A10UL))
#define bFM_BT1_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A0A18UL))
#define bFM_BT1_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A0A1CUL))
#define bFM_BT1_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A0A20UL))

/* Base Timer 2 PPG registers */
#define bFM_BT2_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A1180UL))
#define bFM_BT2_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1184UL))
#define bFM_BT2_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1188UL))
#define bFM_BT2_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A118CUL))
#define bFM_BT2_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1190UL))
#define bFM_BT2_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1194UL))
#define bFM_BT2_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1198UL))
#define bFM_BT2_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A11A0UL))
#define bFM_BT2_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A11A4UL))
#define bFM_BT2_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A11A8UL))
#define bFM_BT2_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A11ACUL))
#define bFM_BT2_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A11B0UL))
#define bFM_BT2_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A11B4UL))
#define bFM_BT2_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A11B8UL))
#define bFM_BT2_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A1200UL))
#define bFM_BT2_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A1208UL))
#define bFM_BT2_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A1210UL))
#define bFM_BT2_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A1218UL))
#define bFM_BT2_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1220UL))

/* Base Timer 2 PWM registers */
#define bFM_BT2_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A1180UL))
#define bFM_BT2_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1184UL))
#define bFM_BT2_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1188UL))
#define bFM_BT2_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A118CUL))
#define bFM_BT2_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1190UL))
#define bFM_BT2_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1194UL))
#define bFM_BT2_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1198UL))
#define bFM_BT2_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A11A0UL))
#define bFM_BT2_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A11A4UL))
#define bFM_BT2_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A11A8UL))
#define bFM_BT2_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A11ACUL))
#define bFM_BT2_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A11B0UL))
#define bFM_BT2_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A11B4UL))
#define bFM_BT2_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A11B8UL))
#define bFM_BT2_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A1200UL))
#define bFM_BT2_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A1204UL))
#define bFM_BT2_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A1208UL))
#define bFM_BT2_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A1210UL))
#define bFM_BT2_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A1214UL))
#define bFM_BT2_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A1218UL))
#define bFM_BT2_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1220UL))

/* Base Timer 2 RT registers */
#define bFM_BT2_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A1180UL))
#define bFM_BT2_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A1184UL))
#define bFM_BT2_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A1188UL))
#define bFM_BT2_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A118CUL))
#define bFM_BT2_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A1190UL))
#define bFM_BT2_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A1194UL))
#define bFM_BT2_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A1198UL))
#define bFM_BT2_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A119CUL))
#define bFM_BT2_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A11A0UL))
#define bFM_BT2_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A11A4UL))
#define bFM_BT2_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A11B0UL))
#define bFM_BT2_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A11B4UL))
#define bFM_BT2_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A11B8UL))
#define bFM_BT2_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A1200UL))
#define bFM_BT2_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A1208UL))
#define bFM_BT2_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A1210UL))
#define bFM_BT2_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A1218UL))
#define bFM_BT2_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A1220UL))

/* Base Timer 2 PWC registers */
#define bFM_BT2_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1184UL))
#define bFM_BT2_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1188UL))
#define bFM_BT2_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1190UL))
#define bFM_BT2_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1194UL))
#define bFM_BT2_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1198UL))
#define bFM_BT2_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A119CUL))
#define bFM_BT2_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A11A0UL))
#define bFM_BT2_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A11A4UL))
#define bFM_BT2_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A11A8UL))
#define bFM_BT2_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A11B0UL))
#define bFM_BT2_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A11B4UL))
#define bFM_BT2_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A11B8UL))
#define bFM_BT2_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A1200UL))
#define bFM_BT2_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A1208UL))
#define bFM_BT2_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A1210UL))
#define bFM_BT2_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A1218UL))
#define bFM_BT2_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A121CUL))
#define bFM_BT2_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1220UL))

/* Base Timer 3 PPG registers */
#define bFM_BT3_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A1980UL))
#define bFM_BT3_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1984UL))
#define bFM_BT3_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1988UL))
#define bFM_BT3_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A198CUL))
#define bFM_BT3_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1990UL))
#define bFM_BT3_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1994UL))
#define bFM_BT3_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1998UL))
#define bFM_BT3_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A19A0UL))
#define bFM_BT3_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A19A4UL))
#define bFM_BT3_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A19A8UL))
#define bFM_BT3_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A19ACUL))
#define bFM_BT3_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A19B0UL))
#define bFM_BT3_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A19B4UL))
#define bFM_BT3_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A19B8UL))
#define bFM_BT3_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A1A00UL))
#define bFM_BT3_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A1A08UL))
#define bFM_BT3_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A1A10UL))
#define bFM_BT3_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A1A18UL))
#define bFM_BT3_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1A20UL))

/* Base Timer 3 PWM registers */
#define bFM_BT3_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A1980UL))
#define bFM_BT3_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1984UL))
#define bFM_BT3_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1988UL))
#define bFM_BT3_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A198CUL))
#define bFM_BT3_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1990UL))
#define bFM_BT3_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1994UL))
#define bFM_BT3_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1998UL))
#define bFM_BT3_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A19A0UL))
#define bFM_BT3_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A19A4UL))
#define bFM_BT3_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A19A8UL))
#define bFM_BT3_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A19ACUL))
#define bFM_BT3_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A19B0UL))
#define bFM_BT3_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A19B4UL))
#define bFM_BT3_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A19B8UL))
#define bFM_BT3_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A1A00UL))
#define bFM_BT3_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A1A04UL))
#define bFM_BT3_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A1A08UL))
#define bFM_BT3_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A1A10UL))
#define bFM_BT3_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A1A14UL))
#define bFM_BT3_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A1A18UL))
#define bFM_BT3_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1A20UL))

/* Base Timer 3 RT registers */
#define bFM_BT3_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A1980UL))
#define bFM_BT3_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A1984UL))
#define bFM_BT3_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A1988UL))
#define bFM_BT3_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A198CUL))
#define bFM_BT3_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A1990UL))
#define bFM_BT3_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A1994UL))
#define bFM_BT3_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A1998UL))
#define bFM_BT3_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A199CUL))
#define bFM_BT3_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A19A0UL))
#define bFM_BT3_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A19A4UL))
#define bFM_BT3_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A19B0UL))
#define bFM_BT3_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A19B4UL))
#define bFM_BT3_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A19B8UL))
#define bFM_BT3_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A1A00UL))
#define bFM_BT3_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A1A08UL))
#define bFM_BT3_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A1A10UL))
#define bFM_BT3_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A1A18UL))
#define bFM_BT3_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A1A20UL))

/* Base Timer 3 PWC registers */
#define bFM_BT3_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A1984UL))
#define bFM_BT3_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A1988UL))
#define bFM_BT3_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A1990UL))
#define bFM_BT3_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A1994UL))
#define bFM_BT3_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A1998UL))
#define bFM_BT3_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A199CUL))
#define bFM_BT3_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A19A0UL))
#define bFM_BT3_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A19A4UL))
#define bFM_BT3_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A19A8UL))
#define bFM_BT3_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A19B0UL))
#define bFM_BT3_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A19B4UL))
#define bFM_BT3_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A19B8UL))
#define bFM_BT3_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A1A00UL))
#define bFM_BT3_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A1A08UL))
#define bFM_BT3_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A1A10UL))
#define bFM_BT3_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A1A18UL))
#define bFM_BT3_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A1A1CUL))
#define bFM_BT3_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A1A20UL))

/* Base Timer 4 PPG registers */
#define bFM_BT4_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A4180UL))
#define bFM_BT4_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4184UL))
#define bFM_BT4_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4188UL))
#define bFM_BT4_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A418CUL))
#define bFM_BT4_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4190UL))
#define bFM_BT4_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4194UL))
#define bFM_BT4_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4198UL))
#define bFM_BT4_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A41A0UL))
#define bFM_BT4_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A41A4UL))
#define bFM_BT4_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A41A8UL))
#define bFM_BT4_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A41ACUL))
#define bFM_BT4_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A41B0UL))
#define bFM_BT4_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A41B4UL))
#define bFM_BT4_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A41B8UL))
#define bFM_BT4_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A4200UL))
#define bFM_BT4_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A4208UL))
#define bFM_BT4_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A4210UL))
#define bFM_BT4_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A4218UL))
#define bFM_BT4_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4220UL))

/* Base Timer 4 PWM registers */
#define bFM_BT4_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A4180UL))
#define bFM_BT4_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4184UL))
#define bFM_BT4_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4188UL))
#define bFM_BT4_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A418CUL))
#define bFM_BT4_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4190UL))
#define bFM_BT4_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4194UL))
#define bFM_BT4_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4198UL))
#define bFM_BT4_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A41A0UL))
#define bFM_BT4_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A41A4UL))
#define bFM_BT4_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A41A8UL))
#define bFM_BT4_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A41ACUL))
#define bFM_BT4_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A41B0UL))
#define bFM_BT4_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A41B4UL))
#define bFM_BT4_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A41B8UL))
#define bFM_BT4_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A4200UL))
#define bFM_BT4_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A4204UL))
#define bFM_BT4_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A4208UL))
#define bFM_BT4_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A4210UL))
#define bFM_BT4_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A4214UL))
#define bFM_BT4_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A4218UL))
#define bFM_BT4_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4220UL))

/* Base Timer 4 RT registers */
#define bFM_BT4_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A4180UL))
#define bFM_BT4_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A4184UL))
#define bFM_BT4_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A4188UL))
#define bFM_BT4_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A418CUL))
#define bFM_BT4_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A4190UL))
#define bFM_BT4_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A4194UL))
#define bFM_BT4_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A4198UL))
#define bFM_BT4_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A419CUL))
#define bFM_BT4_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A41A0UL))
#define bFM_BT4_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A41A4UL))
#define bFM_BT4_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A41B0UL))
#define bFM_BT4_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A41B4UL))
#define bFM_BT4_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A41B8UL))
#define bFM_BT4_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A4200UL))
#define bFM_BT4_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A4208UL))
#define bFM_BT4_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A4210UL))
#define bFM_BT4_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A4218UL))
#define bFM_BT4_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A4220UL))

/* Base Timer 4 PWC registers */
#define bFM_BT4_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4184UL))
#define bFM_BT4_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4188UL))
#define bFM_BT4_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4190UL))
#define bFM_BT4_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4194UL))
#define bFM_BT4_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4198UL))
#define bFM_BT4_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A419CUL))
#define bFM_BT4_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A41A0UL))
#define bFM_BT4_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A41A4UL))
#define bFM_BT4_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A41A8UL))
#define bFM_BT4_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A41B0UL))
#define bFM_BT4_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A41B4UL))
#define bFM_BT4_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A41B8UL))
#define bFM_BT4_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A4200UL))
#define bFM_BT4_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A4208UL))
#define bFM_BT4_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A4210UL))
#define bFM_BT4_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A4218UL))
#define bFM_BT4_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A421CUL))
#define bFM_BT4_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4220UL))

/* Base Timer 5 PPG registers */
#define bFM_BT5_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A4980UL))
#define bFM_BT5_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4984UL))
#define bFM_BT5_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4988UL))
#define bFM_BT5_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A498CUL))
#define bFM_BT5_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4990UL))
#define bFM_BT5_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4994UL))
#define bFM_BT5_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4998UL))
#define bFM_BT5_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A49A0UL))
#define bFM_BT5_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A49A4UL))
#define bFM_BT5_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A49A8UL))
#define bFM_BT5_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A49ACUL))
#define bFM_BT5_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A49B0UL))
#define bFM_BT5_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A49B4UL))
#define bFM_BT5_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A49B8UL))
#define bFM_BT5_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A4A00UL))
#define bFM_BT5_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A4A08UL))
#define bFM_BT5_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A4A10UL))
#define bFM_BT5_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A4A18UL))
#define bFM_BT5_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4A20UL))

/* Base Timer 5 PWM registers */
#define bFM_BT5_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A4980UL))
#define bFM_BT5_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4984UL))
#define bFM_BT5_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4988UL))
#define bFM_BT5_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A498CUL))
#define bFM_BT5_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4990UL))
#define bFM_BT5_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4994UL))
#define bFM_BT5_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4998UL))
#define bFM_BT5_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A49A0UL))
#define bFM_BT5_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A49A4UL))
#define bFM_BT5_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A49A8UL))
#define bFM_BT5_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A49ACUL))
#define bFM_BT5_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A49B0UL))
#define bFM_BT5_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A49B4UL))
#define bFM_BT5_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A49B8UL))
#define bFM_BT5_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A4A00UL))
#define bFM_BT5_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A4A04UL))
#define bFM_BT5_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A4A08UL))
#define bFM_BT5_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A4A10UL))
#define bFM_BT5_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A4A14UL))
#define bFM_BT5_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A4A18UL))
#define bFM_BT5_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4A20UL))

/* Base Timer 5 RT registers */
#define bFM_BT5_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A4980UL))
#define bFM_BT5_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A4984UL))
#define bFM_BT5_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A4988UL))
#define bFM_BT5_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A498CUL))
#define bFM_BT5_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A4990UL))
#define bFM_BT5_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A4994UL))
#define bFM_BT5_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A4998UL))
#define bFM_BT5_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A499CUL))
#define bFM_BT5_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A49A0UL))
#define bFM_BT5_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A49A4UL))
#define bFM_BT5_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A49B0UL))
#define bFM_BT5_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A49B4UL))
#define bFM_BT5_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A49B8UL))
#define bFM_BT5_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A4A00UL))
#define bFM_BT5_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A4A08UL))
#define bFM_BT5_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A4A10UL))
#define bFM_BT5_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A4A18UL))
#define bFM_BT5_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A4A20UL))

/* Base Timer 5 PWC registers */
#define bFM_BT5_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A4984UL))
#define bFM_BT5_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A4988UL))
#define bFM_BT5_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A4990UL))
#define bFM_BT5_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A4994UL))
#define bFM_BT5_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A4998UL))
#define bFM_BT5_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A499CUL))
#define bFM_BT5_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A49A0UL))
#define bFM_BT5_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A49A4UL))
#define bFM_BT5_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A49A8UL))
#define bFM_BT5_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A49B0UL))
#define bFM_BT5_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A49B4UL))
#define bFM_BT5_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A49B8UL))
#define bFM_BT5_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A4A00UL))
#define bFM_BT5_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A4A08UL))
#define bFM_BT5_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A4A10UL))
#define bFM_BT5_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A4A18UL))
#define bFM_BT5_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A4A1CUL))
#define bFM_BT5_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A4A20UL))

/* Base Timer 6 PPG registers */
#define bFM_BT6_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A5180UL))
#define bFM_BT6_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5184UL))
#define bFM_BT6_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5188UL))
#define bFM_BT6_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A518CUL))
#define bFM_BT6_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5190UL))
#define bFM_BT6_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5194UL))
#define bFM_BT6_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5198UL))
#define bFM_BT6_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A51A0UL))
#define bFM_BT6_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A51A4UL))
#define bFM_BT6_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A51A8UL))
#define bFM_BT6_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A51ACUL))
#define bFM_BT6_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A51B0UL))
#define bFM_BT6_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A51B4UL))
#define bFM_BT6_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A51B8UL))
#define bFM_BT6_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A5200UL))
#define bFM_BT6_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A5208UL))
#define bFM_BT6_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A5210UL))
#define bFM_BT6_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A5218UL))
#define bFM_BT6_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5220UL))

/* Base Timer 6 PWM registers */
#define bFM_BT6_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A5180UL))
#define bFM_BT6_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5184UL))
#define bFM_BT6_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5188UL))
#define bFM_BT6_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A518CUL))
#define bFM_BT6_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5190UL))
#define bFM_BT6_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5194UL))
#define bFM_BT6_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5198UL))
#define bFM_BT6_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A51A0UL))
#define bFM_BT6_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A51A4UL))
#define bFM_BT6_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A51A8UL))
#define bFM_BT6_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A51ACUL))
#define bFM_BT6_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A51B0UL))
#define bFM_BT6_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A51B4UL))
#define bFM_BT6_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A51B8UL))
#define bFM_BT6_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A5200UL))
#define bFM_BT6_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A5204UL))
#define bFM_BT6_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A5208UL))
#define bFM_BT6_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A5210UL))
#define bFM_BT6_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A5214UL))
#define bFM_BT6_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A5218UL))
#define bFM_BT6_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5220UL))

/* Base Timer 6 RT registers */
#define bFM_BT6_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A5180UL))
#define bFM_BT6_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A5184UL))
#define bFM_BT6_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A5188UL))
#define bFM_BT6_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A518CUL))
#define bFM_BT6_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A5190UL))
#define bFM_BT6_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A5194UL))
#define bFM_BT6_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A5198UL))
#define bFM_BT6_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A519CUL))
#define bFM_BT6_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A51A0UL))
#define bFM_BT6_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A51A4UL))
#define bFM_BT6_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A51B0UL))
#define bFM_BT6_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A51B4UL))
#define bFM_BT6_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A51B8UL))
#define bFM_BT6_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A5200UL))
#define bFM_BT6_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A5208UL))
#define bFM_BT6_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A5210UL))
#define bFM_BT6_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A5218UL))
#define bFM_BT6_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A5220UL))

/* Base Timer 6 PWC registers */
#define bFM_BT6_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5184UL))
#define bFM_BT6_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5188UL))
#define bFM_BT6_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5190UL))
#define bFM_BT6_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5194UL))
#define bFM_BT6_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5198UL))
#define bFM_BT6_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A519CUL))
#define bFM_BT6_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A51A0UL))
#define bFM_BT6_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A51A4UL))
#define bFM_BT6_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A51A8UL))
#define bFM_BT6_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A51B0UL))
#define bFM_BT6_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A51B4UL))
#define bFM_BT6_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A51B8UL))
#define bFM_BT6_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A5200UL))
#define bFM_BT6_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A5208UL))
#define bFM_BT6_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A5210UL))
#define bFM_BT6_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A5218UL))
#define bFM_BT6_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A521CUL))
#define bFM_BT6_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5220UL))

/* Base Timer 7 PPG registers */
#define bFM_BT7_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A5980UL))
#define bFM_BT7_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5984UL))
#define bFM_BT7_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5988UL))
#define bFM_BT7_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A598CUL))
#define bFM_BT7_PPG_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5990UL))
#define bFM_BT7_PPG_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5994UL))
#define bFM_BT7_PPG_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5998UL))
#define bFM_BT7_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A59A0UL))
#define bFM_BT7_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A59A4UL))
#define bFM_BT7_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A59A8UL))
#define bFM_BT7_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A59ACUL))
#define bFM_BT7_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A59B0UL))
#define bFM_BT7_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A59B4UL))
#define bFM_BT7_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A59B8UL))
#define bFM_BT7_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A5A00UL))
#define bFM_BT7_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A5A08UL))
#define bFM_BT7_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A5A10UL))
#define bFM_BT7_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A5A18UL))
#define bFM_BT7_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5A20UL))

/* Base Timer 7 PWM registers */
#define bFM_BT7_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A5980UL))
#define bFM_BT7_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5984UL))
#define bFM_BT7_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5988UL))
#define bFM_BT7_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A598CUL))
#define bFM_BT7_PWM_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5990UL))
#define bFM_BT7_PWM_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5994UL))
#define bFM_BT7_PWM_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5998UL))
#define bFM_BT7_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A59A0UL))
#define bFM_BT7_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A59A4UL))
#define bFM_BT7_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A59A8UL))
#define bFM_BT7_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A59ACUL))
#define bFM_BT7_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A59B0UL))
#define bFM_BT7_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A59B4UL))
#define bFM_BT7_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A59B8UL))
#define bFM_BT7_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A5A00UL))
#define bFM_BT7_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A5A04UL))
#define bFM_BT7_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A5A08UL))
#define bFM_BT7_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A5A10UL))
#define bFM_BT7_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A5A14UL))
#define bFM_BT7_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A5A18UL))
#define bFM_BT7_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5A20UL))

/* Base Timer 7 RT registers */
#define bFM_BT7_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A5980UL))
#define bFM_BT7_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A5984UL))
#define bFM_BT7_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A5988UL))
#define bFM_BT7_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A598CUL))
#define bFM_BT7_RT_TMCR_FMD0                  *((volatile unsigned char*)(0x424A5990UL))
#define bFM_BT7_RT_TMCR_FMD1                  *((volatile unsigned char*)(0x424A5994UL))
#define bFM_BT7_RT_TMCR_FMD2                  *((volatile unsigned char*)(0x424A5998UL))
#define bFM_BT7_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A599CUL))
#define bFM_BT7_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A59A0UL))
#define bFM_BT7_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A59A4UL))
#define bFM_BT7_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A59B0UL))
#define bFM_BT7_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A59B4UL))
#define bFM_BT7_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A59B8UL))
#define bFM_BT7_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A5A00UL))
#define bFM_BT7_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A5A08UL))
#define bFM_BT7_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A5A10UL))
#define bFM_BT7_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A5A18UL))
#define bFM_BT7_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A5A20UL))

/* Base Timer 7 PWC registers */
#define bFM_BT7_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A5984UL))
#define bFM_BT7_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A5988UL))
#define bFM_BT7_PWC_TMCR_FMD0                 *((volatile unsigned char*)(0x424A5990UL))
#define bFM_BT7_PWC_TMCR_FMD1                 *((volatile unsigned char*)(0x424A5994UL))
#define bFM_BT7_PWC_TMCR_FMD2                 *((volatile unsigned char*)(0x424A5998UL))
#define bFM_BT7_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A599CUL))
#define bFM_BT7_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A59A0UL))
#define bFM_BT7_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A59A4UL))
#define bFM_BT7_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A59A8UL))
#define bFM_BT7_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A59B0UL))
#define bFM_BT7_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A59B4UL))
#define bFM_BT7_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A59B8UL))
#define bFM_BT7_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A5A00UL))
#define bFM_BT7_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A5A08UL))
#define bFM_BT7_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A5A10UL))
#define bFM_BT7_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A5A18UL))
#define bFM_BT7_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A5A1CUL))
#define bFM_BT7_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A5A20UL))

/* Base Timer I/O selector channel 0 - channel 3 registers */
#define bFM_BTIOSEL03_BTSEL0123_SEL01_0       *((volatile unsigned char*)(0x424A2020UL))
#define bFM_BTIOSEL03_BTSEL0123_SEL01_1       *((volatile unsigned char*)(0x424A2024UL))
#define bFM_BTIOSEL03_BTSEL0123_SEL01_2       *((volatile unsigned char*)(0x424A2028UL))
#define bFM_BTIOSEL03_BTSEL0123_SEL01_3       *((volatile unsigned char*)(0x424A202CUL))
#define bFM_BTIOSEL03_BTSEL0123_SEL23_0       *((volatile unsigned char*)(0x424A2030UL))
#define bFM_BTIOSEL03_BTSEL0123_SEL23_1       *((volatile unsigned char*)(0x424A2034UL))
#define bFM_BTIOSEL03_BTSEL0123_SEL23_2       *((volatile unsigned char*)(0x424A2038UL))
#define bFM_BTIOSEL03_BTSEL0123_SEL23_3       *((volatile unsigned char*)(0x424A203CUL))

/* Base Timer I/O selector channel 4 - channel 7 registers */
#define bFM_BTIOSEL47_BTSEL4567_SEL45_0       *((volatile unsigned char*)(0x424A6020UL))
#define bFM_BTIOSEL47_BTSEL4567_SEL45_1       *((volatile unsigned char*)(0x424A6024UL))
#define bFM_BTIOSEL47_BTSEL4567_SEL45_2       *((volatile unsigned char*)(0x424A6028UL))
#define bFM_BTIOSEL47_BTSEL4567_SEL45_3       *((volatile unsigned char*)(0x424A602CUL))
#define bFM_BTIOSEL47_BTSEL4567_SEL67_0       *((volatile unsigned char*)(0x424A6030UL))
#define bFM_BTIOSEL47_BTSEL4567_SEL67_1       *((volatile unsigned char*)(0x424A6034UL))
#define bFM_BTIOSEL47_BTSEL4567_SEL67_2       *((volatile unsigned char*)(0x424A6038UL))
#define bFM_BTIOSEL47_BTSEL4567_SEL67_3       *((volatile unsigned char*)(0x424A603CUL))

/* Base Timer 8 PPG registers */
#define bFM_BT8_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A8180UL))
#define bFM_BT8_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8184UL))
#define bFM_BT8_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8188UL))
#define bFM_BT8_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A818CUL))
#define bFM_BT8_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A81A0UL))
#define bFM_BT8_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A81A4UL))
#define bFM_BT8_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A81A8UL))
#define bFM_BT8_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A81ACUL))
#define bFM_BT8_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A81B0UL))
#define bFM_BT8_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A81B4UL))
#define bFM_BT8_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A81B8UL))
#define bFM_BT8_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A8200UL))
#define bFM_BT8_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A8208UL))
#define bFM_BT8_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A8210UL))
#define bFM_BT8_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A8218UL))
#define bFM_BT8_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8220UL))

/* Base Timer 8 PWM registers */
#define bFM_BT8_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A8180UL))
#define bFM_BT8_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8184UL))
#define bFM_BT8_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8188UL))
#define bFM_BT8_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A818CUL))
#define bFM_BT8_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A81A0UL))
#define bFM_BT8_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A81A4UL))
#define bFM_BT8_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A81A8UL))
#define bFM_BT8_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A81ACUL))
#define bFM_BT8_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A81B0UL))
#define bFM_BT8_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A81B4UL))
#define bFM_BT8_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A81B8UL))
#define bFM_BT8_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A8200UL))
#define bFM_BT8_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A8204UL))
#define bFM_BT8_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A8208UL))
#define bFM_BT8_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A8210UL))
#define bFM_BT8_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A8214UL))
#define bFM_BT8_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A8218UL))
#define bFM_BT8_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8220UL))

/* Base Timer 8 RT registers */
#define bFM_BT8_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A8180UL))
#define bFM_BT8_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A8184UL))
#define bFM_BT8_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A8188UL))
#define bFM_BT8_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A818CUL))
#define bFM_BT8_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A819CUL))
#define bFM_BT8_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A81A0UL))
#define bFM_BT8_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A81A4UL))
#define bFM_BT8_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A81B0UL))
#define bFM_BT8_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A81B4UL))
#define bFM_BT8_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A81B8UL))
#define bFM_BT8_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A8200UL))
#define bFM_BT8_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A8208UL))
#define bFM_BT8_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A8210UL))
#define bFM_BT8_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A8218UL))
#define bFM_BT8_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A8220UL))

/* Base Timer 8 PWC registers */
#define bFM_BT8_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8184UL))
#define bFM_BT8_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8188UL))
#define bFM_BT8_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A819CUL))
#define bFM_BT8_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A81A0UL))
#define bFM_BT8_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A81A4UL))
#define bFM_BT8_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A81A8UL))
#define bFM_BT8_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A81B0UL))
#define bFM_BT8_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A81B4UL))
#define bFM_BT8_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A81B8UL))
#define bFM_BT8_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A8200UL))
#define bFM_BT8_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A8208UL))
#define bFM_BT8_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A8210UL))
#define bFM_BT8_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A8218UL))
#define bFM_BT8_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A821CUL))
#define bFM_BT8_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8220UL))

/* Base Timer 9 PPG registers */
#define bFM_BT9_PPG_TMCR_STRG                 *((volatile unsigned char*)(0x424A8980UL))
#define bFM_BT9_PPG_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8984UL))
#define bFM_BT9_PPG_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8988UL))
#define bFM_BT9_PPG_TMCR_OSEL                 *((volatile unsigned char*)(0x424A898CUL))
#define bFM_BT9_PPG_TMCR_EGS0                 *((volatile unsigned char*)(0x424A89A0UL))
#define bFM_BT9_PPG_TMCR_EGS1                 *((volatile unsigned char*)(0x424A89A4UL))
#define bFM_BT9_PPG_TMCR_PMSK                 *((volatile unsigned char*)(0x424A89A8UL))
#define bFM_BT9_PPG_TMCR_RTGEN                *((volatile unsigned char*)(0x424A89ACUL))
#define bFM_BT9_PPG_TMCR_CKS0                 *((volatile unsigned char*)(0x424A89B0UL))
#define bFM_BT9_PPG_TMCR_CKS1                 *((volatile unsigned char*)(0x424A89B4UL))
#define bFM_BT9_PPG_TMCR_CKS2                 *((volatile unsigned char*)(0x424A89B8UL))
#define bFM_BT9_PPG_STC_UDIR                  *((volatile unsigned char*)(0x424A8A00UL))
#define bFM_BT9_PPG_STC_TGIR                  *((volatile unsigned char*)(0x424A8A08UL))
#define bFM_BT9_PPG_STC_UDIE                  *((volatile unsigned char*)(0x424A8A10UL))
#define bFM_BT9_PPG_STC_TGIE                  *((volatile unsigned char*)(0x424A8A18UL))
#define bFM_BT9_PPG_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8A20UL))

/* Base Timer 9 PWM registers */
#define bFM_BT9_PWM_TMCR_STRG                 *((volatile unsigned char*)(0x424A8980UL))
#define bFM_BT9_PWM_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8984UL))
#define bFM_BT9_PWM_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8988UL))
#define bFM_BT9_PWM_TMCR_OSEL                 *((volatile unsigned char*)(0x424A898CUL))
#define bFM_BT9_PWM_TMCR_EGS0                 *((volatile unsigned char*)(0x424A89A0UL))
#define bFM_BT9_PWM_TMCR_EGS1                 *((volatile unsigned char*)(0x424A89A4UL))
#define bFM_BT9_PWM_TMCR_PMSK                 *((volatile unsigned char*)(0x424A89A8UL))
#define bFM_BT9_PWM_TMCR_RTGEN                *((volatile unsigned char*)(0x424A89ACUL))
#define bFM_BT9_PWM_TMCR_CKS0                 *((volatile unsigned char*)(0x424A89B0UL))
#define bFM_BT9_PWM_TMCR_CKS1                 *((volatile unsigned char*)(0x424A89B4UL))
#define bFM_BT9_PWM_TMCR_CKS2                 *((volatile unsigned char*)(0x424A89B8UL))
#define bFM_BT9_PWM_STC_UDIR                  *((volatile unsigned char*)(0x424A8A00UL))
#define bFM_BT9_PWM_STC_DTIR                  *((volatile unsigned char*)(0x424A8A04UL))
#define bFM_BT9_PWM_STC_TGIR                  *((volatile unsigned char*)(0x424A8A08UL))
#define bFM_BT9_PWM_STC_UDIE                  *((volatile unsigned char*)(0x424A8A10UL))
#define bFM_BT9_PWM_STC_DTIE                  *((volatile unsigned char*)(0x424A8A14UL))
#define bFM_BT9_PWM_STC_TGIE                  *((volatile unsigned char*)(0x424A8A18UL))
#define bFM_BT9_PWM_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8A20UL))

/* Base Timer 9 RT registers */
#define bFM_BT9_RT_TMCR_STRG                  *((volatile unsigned char*)(0x424A8980UL))
#define bFM_BT9_RT_TMCR_CTEN                  *((volatile unsigned char*)(0x424A8984UL))
#define bFM_BT9_RT_TMCR_MDSE                  *((volatile unsigned char*)(0x424A8988UL))
#define bFM_BT9_RT_TMCR_OSEL                  *((volatile unsigned char*)(0x424A898CUL))
#define bFM_BT9_RT_TMCR_T32                   *((volatile unsigned char*)(0x424A899CUL))
#define bFM_BT9_RT_TMCR_EGS0                  *((volatile unsigned char*)(0x424A89A0UL))
#define bFM_BT9_RT_TMCR_EGS1                  *((volatile unsigned char*)(0x424A89A4UL))
#define bFM_BT9_RT_TMCR_CKS0                  *((volatile unsigned char*)(0x424A89B0UL))
#define bFM_BT9_RT_TMCR_CKS1                  *((volatile unsigned char*)(0x424A89B4UL))
#define bFM_BT9_RT_TMCR_CKS2                  *((volatile unsigned char*)(0x424A89B8UL))
#define bFM_BT9_RT_STC_UDIR                   *((volatile unsigned char*)(0x424A8A00UL))
#define bFM_BT9_RT_STC_TGIR                   *((volatile unsigned char*)(0x424A8A08UL))
#define bFM_BT9_RT_STC_UDIE                   *((volatile unsigned char*)(0x424A8A10UL))
#define bFM_BT9_RT_STC_TGIE                   *((volatile unsigned char*)(0x424A8A18UL))
#define bFM_BT9_RT_TMCR2_CKS3                 *((volatile unsigned char*)(0x424A8A20UL))

/* Base Timer 9 PWC registers */
#define bFM_BT9_PWC_TMCR_CTEN                 *((volatile unsigned char*)(0x424A8984UL))
#define bFM_BT9_PWC_TMCR_MDSE                 *((volatile unsigned char*)(0x424A8988UL))
#define bFM_BT9_PWC_TMCR_T32                  *((volatile unsigned char*)(0x424A899CUL))
#define bFM_BT9_PWC_TMCR_EGS0                 *((volatile unsigned char*)(0x424A89A0UL))
#define bFM_BT9_PWC_TMCR_EGS1                 *((volatile unsigned char*)(0x424A89A4UL))
#define bFM_BT9_PWC_TMCR_EGS2                 *((volatile unsigned char*)(0x424A89A8UL))
#define bFM_BT9_PWC_TMCR_CKS0                 *((volatile unsigned char*)(0x424A89B0UL))
#define bFM_BT9_PWC_TMCR_CKS1                 *((volatile unsigned char*)(0x424A89B4UL))
#define bFM_BT9_PWC_TMCR_CKS2                 *((volatile unsigned char*)(0x424A89B8UL))
#define bFM_BT9_PWC_STC_OVIR                  *((volatile unsigned char*)(0x424A8A00UL))
#define bFM_BT9_PWC_STC_EDIR                  *((volatile unsigned char*)(0x424A8A08UL))
#define bFM_BT9_PWC_STC_OVIE                  *((volatile unsigned char*)(0x424A8A10UL))
#define bFM_BT9_PWC_STC_EDIE                  *((volatile unsigned char*)(0x424A8A18UL))
#define bFM_BT9_PWC_STC_ERR                   *((volatile unsigned char*)(0x424A8A1CUL))
#define bFM_BT9_PWC_TMCR2_CKS3                *((volatile unsigned char*)(0x424A8A20UL))

/* Base Timer 10 PPG registers */
#define bFM_BT10_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424A9180UL))
#define bFM_BT10_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424A9184UL))
#define bFM_BT10_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424A9188UL))
#define bFM_BT10_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424A918CUL))
#define bFM_BT10_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424A91A0UL))
#define bFM_BT10_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424A91A4UL))
#define bFM_BT10_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424A91A8UL))
#define bFM_BT10_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424A91ACUL))
#define bFM_BT10_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424A91B0UL))
#define bFM_BT10_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424A91B4UL))
#define bFM_BT10_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424A91B8UL))
#define bFM_BT10_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424A9200UL))
#define bFM_BT10_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424A9208UL))
#define bFM_BT10_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424A9210UL))
#define bFM_BT10_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424A9218UL))
#define bFM_BT10_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9220UL))

/* Base Timer 10 PWM registers */
#define bFM_BT10_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424A9180UL))
#define bFM_BT10_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424A9184UL))
#define bFM_BT10_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424A9188UL))
#define bFM_BT10_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424A918CUL))
#define bFM_BT10_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424A91A0UL))
#define bFM_BT10_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424A91A4UL))
#define bFM_BT10_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424A91A8UL))
#define bFM_BT10_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424A91ACUL))
#define bFM_BT10_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424A91B0UL))
#define bFM_BT10_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424A91B4UL))
#define bFM_BT10_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424A91B8UL))
#define bFM_BT10_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424A9200UL))
#define bFM_BT10_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424A9204UL))
#define bFM_BT10_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424A9208UL))
#define bFM_BT10_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424A9210UL))
#define bFM_BT10_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424A9214UL))
#define bFM_BT10_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424A9218UL))
#define bFM_BT10_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9220UL))

/* Base Timer 10 RT registers */
#define bFM_BT10_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424A9180UL))
#define bFM_BT10_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424A9184UL))
#define bFM_BT10_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424A9188UL))
#define bFM_BT10_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424A918CUL))
#define bFM_BT10_RT_TMCR_T32                  *((volatile unsigned char*)(0x424A919CUL))
#define bFM_BT10_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424A91A0UL))
#define bFM_BT10_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424A91A4UL))
#define bFM_BT10_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424A91B0UL))
#define bFM_BT10_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424A91B4UL))
#define bFM_BT10_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424A91B8UL))
#define bFM_BT10_RT_STC_UDIR                  *((volatile unsigned char*)(0x424A9200UL))
#define bFM_BT10_RT_STC_TGIR                  *((volatile unsigned char*)(0x424A9208UL))
#define bFM_BT10_RT_STC_UDIE                  *((volatile unsigned char*)(0x424A9210UL))
#define bFM_BT10_RT_STC_TGIE                  *((volatile unsigned char*)(0x424A9218UL))
#define bFM_BT10_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424A9220UL))

/* Base Timer 10 PWC registers */
#define bFM_BT10_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424A9184UL))
#define bFM_BT10_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424A9188UL))
#define bFM_BT10_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424A919CUL))
#define bFM_BT10_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424A91A0UL))
#define bFM_BT10_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424A91A4UL))
#define bFM_BT10_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424A91A8UL))
#define bFM_BT10_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424A91B0UL))
#define bFM_BT10_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424A91B4UL))
#define bFM_BT10_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424A91B8UL))
#define bFM_BT10_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424A9200UL))
#define bFM_BT10_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424A9208UL))
#define bFM_BT10_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424A9210UL))
#define bFM_BT10_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424A9218UL))
#define bFM_BT10_PWC_STC_ERR                  *((volatile unsigned char*)(0x424A921CUL))
#define bFM_BT10_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9220UL))

/* Base Timer 11 PPG registers */
#define bFM_BT11_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424A9980UL))
#define bFM_BT11_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424A9984UL))
#define bFM_BT11_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424A9988UL))
#define bFM_BT11_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424A998CUL))
#define bFM_BT11_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424A99A0UL))
#define bFM_BT11_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424A99A4UL))
#define bFM_BT11_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424A99A8UL))
#define bFM_BT11_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424A99ACUL))
#define bFM_BT11_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424A99B0UL))
#define bFM_BT11_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424A99B4UL))
#define bFM_BT11_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424A99B8UL))
#define bFM_BT11_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424A9A00UL))
#define bFM_BT11_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424A9A08UL))
#define bFM_BT11_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424A9A10UL))
#define bFM_BT11_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424A9A18UL))
#define bFM_BT11_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9A20UL))

/* Base Timer 11 PWM registers */
#define bFM_BT11_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424A9980UL))
#define bFM_BT11_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424A9984UL))
#define bFM_BT11_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424A9988UL))
#define bFM_BT11_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424A998CUL))
#define bFM_BT11_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424A99A0UL))
#define bFM_BT11_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424A99A4UL))
#define bFM_BT11_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424A99A8UL))
#define bFM_BT11_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424A99ACUL))
#define bFM_BT11_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424A99B0UL))
#define bFM_BT11_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424A99B4UL))
#define bFM_BT11_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424A99B8UL))
#define bFM_BT11_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424A9A00UL))
#define bFM_BT11_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424A9A04UL))
#define bFM_BT11_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424A9A08UL))
#define bFM_BT11_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424A9A10UL))
#define bFM_BT11_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424A9A14UL))
#define bFM_BT11_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424A9A18UL))
#define bFM_BT11_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9A20UL))

/* Base Timer 11 RT registers */
#define bFM_BT11_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424A9980UL))
#define bFM_BT11_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424A9984UL))
#define bFM_BT11_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424A9988UL))
#define bFM_BT11_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424A998CUL))
#define bFM_BT11_RT_TMCR_T32                  *((volatile unsigned char*)(0x424A999CUL))
#define bFM_BT11_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424A99A0UL))
#define bFM_BT11_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424A99A4UL))
#define bFM_BT11_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424A99B0UL))
#define bFM_BT11_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424A99B4UL))
#define bFM_BT11_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424A99B8UL))
#define bFM_BT11_RT_STC_UDIR                  *((volatile unsigned char*)(0x424A9A00UL))
#define bFM_BT11_RT_STC_TGIR                  *((volatile unsigned char*)(0x424A9A08UL))
#define bFM_BT11_RT_STC_UDIE                  *((volatile unsigned char*)(0x424A9A10UL))
#define bFM_BT11_RT_STC_TGIE                  *((volatile unsigned char*)(0x424A9A18UL))
#define bFM_BT11_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424A9A20UL))

/* Base Timer 11 PWC registers */
#define bFM_BT11_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424A9984UL))
#define bFM_BT11_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424A9988UL))
#define bFM_BT11_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424A999CUL))
#define bFM_BT11_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424A99A0UL))
#define bFM_BT11_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424A99A4UL))
#define bFM_BT11_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424A99A8UL))
#define bFM_BT11_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424A99B0UL))
#define bFM_BT11_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424A99B4UL))
#define bFM_BT11_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424A99B8UL))
#define bFM_BT11_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424A9A00UL))
#define bFM_BT11_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424A9A08UL))
#define bFM_BT11_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424A9A10UL))
#define bFM_BT11_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424A9A18UL))
#define bFM_BT11_PWC_STC_ERR                  *((volatile unsigned char*)(0x424A9A1CUL))
#define bFM_BT11_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424A9A20UL))

/* Base Timer 12 PPG registers */
#define bFM_BT12_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424AC180UL))
#define bFM_BT12_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424AC184UL))
#define bFM_BT12_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424AC188UL))
#define bFM_BT12_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424AC18CUL))
#define bFM_BT12_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424AC1A0UL))
#define bFM_BT12_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424AC1A4UL))
#define bFM_BT12_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424AC1A8UL))
#define bFM_BT12_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424AC1ACUL))
#define bFM_BT12_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424AC1B0UL))
#define bFM_BT12_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424AC1B4UL))
#define bFM_BT12_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424AC1B8UL))
#define bFM_BT12_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424AC200UL))
#define bFM_BT12_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424AC208UL))
#define bFM_BT12_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424AC210UL))
#define bFM_BT12_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424AC218UL))
#define bFM_BT12_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424AC220UL))

/* Base Timer 12 PWM registers */
#define bFM_BT12_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424AC180UL))
#define bFM_BT12_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424AC184UL))
#define bFM_BT12_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424AC188UL))
#define bFM_BT12_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424AC18CUL))
#define bFM_BT12_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424AC1A0UL))
#define bFM_BT12_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424AC1A4UL))
#define bFM_BT12_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424AC1A8UL))
#define bFM_BT12_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424AC1ACUL))
#define bFM_BT12_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424AC1B0UL))
#define bFM_BT12_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424AC1B4UL))
#define bFM_BT12_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424AC1B8UL))
#define bFM_BT12_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424AC200UL))
#define bFM_BT12_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424AC204UL))
#define bFM_BT12_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424AC208UL))
#define bFM_BT12_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424AC210UL))
#define bFM_BT12_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424AC214UL))
#define bFM_BT12_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424AC218UL))
#define bFM_BT12_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424AC220UL))

/* Base Timer 12 RT registers */
#define bFM_BT12_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424AC180UL))
#define bFM_BT12_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424AC184UL))
#define bFM_BT12_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424AC188UL))
#define bFM_BT12_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424AC18CUL))
#define bFM_BT12_RT_TMCR_T32                  *((volatile unsigned char*)(0x424AC19CUL))
#define bFM_BT12_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424AC1A0UL))
#define bFM_BT12_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424AC1A4UL))
#define bFM_BT12_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424AC1B0UL))
#define bFM_BT12_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424AC1B4UL))
#define bFM_BT12_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424AC1B8UL))
#define bFM_BT12_RT_STC_UDIR                  *((volatile unsigned char*)(0x424AC200UL))
#define bFM_BT12_RT_STC_TGIR                  *((volatile unsigned char*)(0x424AC208UL))
#define bFM_BT12_RT_STC_UDIE                  *((volatile unsigned char*)(0x424AC210UL))
#define bFM_BT12_RT_STC_TGIE                  *((volatile unsigned char*)(0x424AC218UL))
#define bFM_BT12_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424AC220UL))

/* Base Timer 12 PWC registers */
#define bFM_BT12_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424AC184UL))
#define bFM_BT12_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424AC188UL))
#define bFM_BT12_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424AC19CUL))
#define bFM_BT12_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424AC1A0UL))
#define bFM_BT12_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424AC1A4UL))
#define bFM_BT12_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424AC1A8UL))
#define bFM_BT12_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424AC1B0UL))
#define bFM_BT12_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424AC1B4UL))
#define bFM_BT12_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424AC1B8UL))
#define bFM_BT12_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424AC200UL))
#define bFM_BT12_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424AC208UL))
#define bFM_BT12_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424AC210UL))
#define bFM_BT12_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424AC218UL))
#define bFM_BT12_PWC_STC_ERR                  *((volatile unsigned char*)(0x424AC21CUL))
#define bFM_BT12_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424AC220UL))

/* Base Timer 13 PPG registers */
#define bFM_BT13_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424AC980UL))
#define bFM_BT13_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424AC984UL))
#define bFM_BT13_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424AC988UL))
#define bFM_BT13_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424AC98CUL))
#define bFM_BT13_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424AC9A0UL))
#define bFM_BT13_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424AC9A4UL))
#define bFM_BT13_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424AC9A8UL))
#define bFM_BT13_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424AC9ACUL))
#define bFM_BT13_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424AC9B0UL))
#define bFM_BT13_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424AC9B4UL))
#define bFM_BT13_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424AC9B8UL))
#define bFM_BT13_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424ACA00UL))
#define bFM_BT13_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424ACA08UL))
#define bFM_BT13_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424ACA10UL))
#define bFM_BT13_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424ACA18UL))
#define bFM_BT13_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424ACA20UL))

/* Base Timer 13 PWM registers */
#define bFM_BT13_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424AC980UL))
#define bFM_BT13_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424AC984UL))
#define bFM_BT13_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424AC988UL))
#define bFM_BT13_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424AC98CUL))
#define bFM_BT13_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424AC9A0UL))
#define bFM_BT13_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424AC9A4UL))
#define bFM_BT13_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424AC9A8UL))
#define bFM_BT13_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424AC9ACUL))
#define bFM_BT13_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424AC9B0UL))
#define bFM_BT13_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424AC9B4UL))
#define bFM_BT13_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424AC9B8UL))
#define bFM_BT13_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424ACA00UL))
#define bFM_BT13_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424ACA04UL))
#define bFM_BT13_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424ACA08UL))
#define bFM_BT13_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424ACA10UL))
#define bFM_BT13_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424ACA14UL))
#define bFM_BT13_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424ACA18UL))
#define bFM_BT13_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424ACA20UL))

/* Base Timer 13 RT registers */
#define bFM_BT13_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424AC980UL))
#define bFM_BT13_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424AC984UL))
#define bFM_BT13_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424AC988UL))
#define bFM_BT13_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424AC98CUL))
#define bFM_BT13_RT_TMCR_T32                  *((volatile unsigned char*)(0x424AC99CUL))
#define bFM_BT13_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424AC9A0UL))
#define bFM_BT13_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424AC9A4UL))
#define bFM_BT13_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424AC9B0UL))
#define bFM_BT13_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424AC9B4UL))
#define bFM_BT13_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424AC9B8UL))
#define bFM_BT13_RT_STC_UDIR                  *((volatile unsigned char*)(0x424ACA00UL))
#define bFM_BT13_RT_STC_TGIR                  *((volatile unsigned char*)(0x424ACA08UL))
#define bFM_BT13_RT_STC_UDIE                  *((volatile unsigned char*)(0x424ACA10UL))
#define bFM_BT13_RT_STC_TGIE                  *((volatile unsigned char*)(0x424ACA18UL))
#define bFM_BT13_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424ACA20UL))

/* Base Timer 13 PWC registers */
#define bFM_BT13_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424AC984UL))
#define bFM_BT13_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424AC988UL))
#define bFM_BT13_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424AC99CUL))
#define bFM_BT13_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424AC9A0UL))
#define bFM_BT13_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424AC9A4UL))
#define bFM_BT13_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424AC9A8UL))
#define bFM_BT13_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424AC9B0UL))
#define bFM_BT13_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424AC9B4UL))
#define bFM_BT13_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424AC9B8UL))
#define bFM_BT13_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424ACA00UL))
#define bFM_BT13_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424ACA08UL))
#define bFM_BT13_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424ACA10UL))
#define bFM_BT13_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424ACA18UL))
#define bFM_BT13_PWC_STC_ERR                  *((volatile unsigned char*)(0x424ACA1CUL))
#define bFM_BT13_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424ACA20UL))

/* Base Timer 14 PPG registers */
#define bFM_BT14_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424AD180UL))
#define bFM_BT14_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424AD184UL))
#define bFM_BT14_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424AD188UL))
#define bFM_BT14_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424AD18CUL))
#define bFM_BT14_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424AD1A0UL))
#define bFM_BT14_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424AD1A4UL))
#define bFM_BT14_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424AD1A8UL))
#define bFM_BT14_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424AD1ACUL))
#define bFM_BT14_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424AD1B0UL))
#define bFM_BT14_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424AD1B4UL))
#define bFM_BT14_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424AD1B8UL))
#define bFM_BT14_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424AD200UL))
#define bFM_BT14_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424AD208UL))
#define bFM_BT14_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424AD210UL))
#define bFM_BT14_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424AD218UL))
#define bFM_BT14_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424AD220UL))

/* Base Timer 14 PWM registers */
#define bFM_BT14_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424AD180UL))
#define bFM_BT14_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424AD184UL))
#define bFM_BT14_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424AD188UL))
#define bFM_BT14_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424AD18CUL))
#define bFM_BT14_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424AD1A0UL))
#define bFM_BT14_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424AD1A4UL))
#define bFM_BT14_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424AD1A8UL))
#define bFM_BT14_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424AD1ACUL))
#define bFM_BT14_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424AD1B0UL))
#define bFM_BT14_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424AD1B4UL))
#define bFM_BT14_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424AD1B8UL))
#define bFM_BT14_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424AD200UL))
#define bFM_BT14_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424AD204UL))
#define bFM_BT14_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424AD208UL))
#define bFM_BT14_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424AD210UL))
#define bFM_BT14_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424AD214UL))
#define bFM_BT14_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424AD218UL))
#define bFM_BT14_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424AD220UL))

/* Base Timer 14 RT registers */
#define bFM_BT14_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424AD180UL))
#define bFM_BT14_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424AD184UL))
#define bFM_BT14_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424AD188UL))
#define bFM_BT14_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424AD18CUL))
#define bFM_BT14_RT_TMCR_T32                  *((volatile unsigned char*)(0x424AD19CUL))
#define bFM_BT14_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424AD1A0UL))
#define bFM_BT14_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424AD1A4UL))
#define bFM_BT14_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424AD1B0UL))
#define bFM_BT14_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424AD1B4UL))
#define bFM_BT14_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424AD1B8UL))
#define bFM_BT14_RT_STC_UDIR                  *((volatile unsigned char*)(0x424AD200UL))
#define bFM_BT14_RT_STC_TGIR                  *((volatile unsigned char*)(0x424AD208UL))
#define bFM_BT14_RT_STC_UDIE                  *((volatile unsigned char*)(0x424AD210UL))
#define bFM_BT14_RT_STC_TGIE                  *((volatile unsigned char*)(0x424AD218UL))
#define bFM_BT14_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424AD220UL))

/* Base Timer 14 PWC registers */
#define bFM_BT14_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424AD184UL))
#define bFM_BT14_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424AD188UL))
#define bFM_BT14_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424AD19CUL))
#define bFM_BT14_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424AD1A0UL))
#define bFM_BT14_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424AD1A4UL))
#define bFM_BT14_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424AD1A8UL))
#define bFM_BT14_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424AD1B0UL))
#define bFM_BT14_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424AD1B4UL))
#define bFM_BT14_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424AD1B8UL))
#define bFM_BT14_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424AD200UL))
#define bFM_BT14_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424AD208UL))
#define bFM_BT14_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424AD210UL))
#define bFM_BT14_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424AD218UL))
#define bFM_BT14_PWC_STC_ERR                  *((volatile unsigned char*)(0x424AD21CUL))
#define bFM_BT14_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424AD220UL))

/* Base Timer 15 PPG registers */
#define bFM_BT15_PPG_TMCR_STRG                *((volatile unsigned char*)(0x424AD980UL))
#define bFM_BT15_PPG_TMCR_CTEN                *((volatile unsigned char*)(0x424AD984UL))
#define bFM_BT15_PPG_TMCR_MDSE                *((volatile unsigned char*)(0x424AD988UL))
#define bFM_BT15_PPG_TMCR_OSEL                *((volatile unsigned char*)(0x424AD98CUL))
#define bFM_BT15_PPG_TMCR_EGS0                *((volatile unsigned char*)(0x424AD9A0UL))
#define bFM_BT15_PPG_TMCR_EGS1                *((volatile unsigned char*)(0x424AD9A4UL))
#define bFM_BT15_PPG_TMCR_PMSK                *((volatile unsigned char*)(0x424AD9A8UL))
#define bFM_BT15_PPG_TMCR_RTGEN               *((volatile unsigned char*)(0x424AD9ACUL))
#define bFM_BT15_PPG_TMCR_CKS0                *((volatile unsigned char*)(0x424AD9B0UL))
#define bFM_BT15_PPG_TMCR_CKS1                *((volatile unsigned char*)(0x424AD9B4UL))
#define bFM_BT15_PPG_TMCR_CKS2                *((volatile unsigned char*)(0x424AD9B8UL))
#define bFM_BT15_PPG_STC_UDIR                 *((volatile unsigned char*)(0x424ADA00UL))
#define bFM_BT15_PPG_STC_TGIR                 *((volatile unsigned char*)(0x424ADA08UL))
#define bFM_BT15_PPG_STC_UDIE                 *((volatile unsigned char*)(0x424ADA10UL))
#define bFM_BT15_PPG_STC_TGIE                 *((volatile unsigned char*)(0x424ADA18UL))
#define bFM_BT15_PPG_TMCR2_CKS3               *((volatile unsigned char*)(0x424ADA20UL))

/* Base Timer 15 PWM registers */
#define bFM_BT15_PWM_TMCR_STRG                *((volatile unsigned char*)(0x424AD980UL))
#define bFM_BT15_PWM_TMCR_CTEN                *((volatile unsigned char*)(0x424AD984UL))
#define bFM_BT15_PWM_TMCR_MDSE                *((volatile unsigned char*)(0x424AD988UL))
#define bFM_BT15_PWM_TMCR_OSEL                *((volatile unsigned char*)(0x424AD98CUL))
#define bFM_BT15_PWM_TMCR_EGS0                *((volatile unsigned char*)(0x424AD9A0UL))
#define bFM_BT15_PWM_TMCR_EGS1                *((volatile unsigned char*)(0x424AD9A4UL))
#define bFM_BT15_PWM_TMCR_PMSK                *((volatile unsigned char*)(0x424AD9A8UL))
#define bFM_BT15_PWM_TMCR_RTGEN               *((volatile unsigned char*)(0x424AD9ACUL))
#define bFM_BT15_PWM_TMCR_CKS0                *((volatile unsigned char*)(0x424AD9B0UL))
#define bFM_BT15_PWM_TMCR_CKS1                *((volatile unsigned char*)(0x424AD9B4UL))
#define bFM_BT15_PWM_TMCR_CKS2                *((volatile unsigned char*)(0x424AD9B8UL))
#define bFM_BT15_PWM_STC_UDIR                 *((volatile unsigned char*)(0x424ADA00UL))
#define bFM_BT15_PWM_STC_DTIR                 *((volatile unsigned char*)(0x424ADA04UL))
#define bFM_BT15_PWM_STC_TGIR                 *((volatile unsigned char*)(0x424ADA08UL))
#define bFM_BT15_PWM_STC_UDIE                 *((volatile unsigned char*)(0x424ADA10UL))
#define bFM_BT15_PWM_STC_DTIE                 *((volatile unsigned char*)(0x424ADA14UL))
#define bFM_BT15_PWM_STC_TGIE                 *((volatile unsigned char*)(0x424ADA18UL))
#define bFM_BT15_PWM_TMCR2_CKS3               *((volatile unsigned char*)(0x424ADA20UL))

/* Base Timer 15 RT registers */
#define bFM_BT15_RT_TMCR_STRG                 *((volatile unsigned char*)(0x424AD980UL))
#define bFM_BT15_RT_TMCR_CTEN                 *((volatile unsigned char*)(0x424AD984UL))
#define bFM_BT15_RT_TMCR_MDSE                 *((volatile unsigned char*)(0x424AD988UL))
#define bFM_BT15_RT_TMCR_OSEL                 *((volatile unsigned char*)(0x424AD98CUL))
#define bFM_BT15_RT_TMCR_T32                  *((volatile unsigned char*)(0x424AD99CUL))
#define bFM_BT15_RT_TMCR_EGS0                 *((volatile unsigned char*)(0x424AD9A0UL))
#define bFM_BT15_RT_TMCR_EGS1                 *((volatile unsigned char*)(0x424AD9A4UL))
#define bFM_BT15_RT_TMCR_CKS0                 *((volatile unsigned char*)(0x424AD9B0UL))
#define bFM_BT15_RT_TMCR_CKS1                 *((volatile unsigned char*)(0x424AD9B4UL))
#define bFM_BT15_RT_TMCR_CKS2                 *((volatile unsigned char*)(0x424AD9B8UL))
#define bFM_BT15_RT_STC_UDIR                  *((volatile unsigned char*)(0x424ADA00UL))
#define bFM_BT15_RT_STC_TGIR                  *((volatile unsigned char*)(0x424ADA08UL))
#define bFM_BT15_RT_STC_UDIE                  *((volatile unsigned char*)(0x424ADA10UL))
#define bFM_BT15_RT_STC_TGIE                  *((volatile unsigned char*)(0x424ADA18UL))
#define bFM_BT15_RT_TMCR2_CKS3                *((volatile unsigned char*)(0x424ADA20UL))

/* Base Timer 15 PWC registers */
#define bFM_BT15_PWC_TMCR_CTEN                *((volatile unsigned char*)(0x424AD984UL))
#define bFM_BT15_PWC_TMCR_MDSE                *((volatile unsigned char*)(0x424AD988UL))
#define bFM_BT15_PWC_TMCR_T32                 *((volatile unsigned char*)(0x424AD99CUL))
#define bFM_BT15_PWC_TMCR_EGS0                *((volatile unsigned char*)(0x424AD9A0UL))
#define bFM_BT15_PWC_TMCR_EGS1                *((volatile unsigned char*)(0x424AD9A4UL))
#define bFM_BT15_PWC_TMCR_EGS2                *((volatile unsigned char*)(0x424AD9A8UL))
#define bFM_BT15_PWC_TMCR_CKS0                *((volatile unsigned char*)(0x424AD9B0UL))
#define bFM_BT15_PWC_TMCR_CKS1                *((volatile unsigned char*)(0x424AD9B4UL))
#define bFM_BT15_PWC_TMCR_CKS2                *((volatile unsigned char*)(0x424AD9B8UL))
#define bFM_BT15_PWC_STC_OVIR                 *((volatile unsigned char*)(0x424ADA00UL))
#define bFM_BT15_PWC_STC_EDIR                 *((volatile unsigned char*)(0x424ADA08UL))
#define bFM_BT15_PWC_STC_OVIE                 *((volatile unsigned char*)(0x424ADA10UL))
#define bFM_BT15_PWC_STC_EDIE                 *((volatile unsigned char*)(0x424ADA18UL))
#define bFM_BT15_PWC_STC_ERR                  *((volatile unsigned char*)(0x424ADA1CUL))
#define bFM_BT15_PWC_TMCR2_CKS3               *((volatile unsigned char*)(0x424ADA20UL))

/* Base Timer I/O selector channel 8 - channel 11 registers */
#define bFM_BTIOSEL8B_BTSEL89AB_SEL89_0       *((volatile unsigned char*)(0x424AA020UL))
#define bFM_BTIOSEL8B_BTSEL89AB_SEL89_1       *((volatile unsigned char*)(0x424AA024UL))
#define bFM_BTIOSEL8B_BTSEL89AB_SEL89_2       *((volatile unsigned char*)(0x424AA028UL))
#define bFM_BTIOSEL8B_BTSEL89AB_SEL89_3       *((volatile unsigned char*)(0x424AA02CUL))
#define bFM_BTIOSEL8B_BTSEL89AB_SELAB_0       *((volatile unsigned char*)(0x424AA030UL))
#define bFM_BTIOSEL8B_BTSEL89AB_SELAB_1       *((volatile unsigned char*)(0x424AA034UL))
#define bFM_BTIOSEL8B_BTSEL89AB_SELAB_2       *((volatile unsigned char*)(0x424AA038UL))
#define bFM_BTIOSEL8B_BTSEL89AB_SELAB_3       *((volatile unsigned char*)(0x424AA03CUL))

/* Base Timer I/O selector channel 12 - channel 15 registers */
#define bFM_BTIOSELCF_BTSELCDEF_SELCD_0       *((volatile unsigned char*)(0x424AE020UL))
#define bFM_BTIOSELCF_BTSELCDEF_SELCD_1       *((volatile unsigned char*)(0x424AE024UL))
#define bFM_BTIOSELCF_BTSELCDEF_SELCD_2       *((volatile unsigned char*)(0x424AE028UL))
#define bFM_BTIOSELCF_BTSELCDEF_SELCD_3       *((volatile unsigned char*)(0x424AE02CUL))
#define bFM_BTIOSELCF_BTSELCDEF_SELEF_0       *((volatile unsigned char*)(0x424AE030UL))
#define bFM_BTIOSELCF_BTSELCDEF_SELEF_1       *((volatile unsigned char*)(0x424AE034UL))
#define bFM_BTIOSELCF_BTSELCDEF_SELEF_2       *((volatile unsigned char*)(0x424AE038UL))
#define bFM_BTIOSELCF_BTSELCDEF_SELEF_3       *((volatile unsigned char*)(0x424AE03CUL))

/* Software based Simulation Startup (Base Timer) register */

/* Quad position and revolution counter channel 0 registers */
#define bFM_QPRC0_QICR_QPCMIE                 *((volatile unsigned char*)(0x424C0280UL))
#define bFM_QPRC0_QICR_QPCMF                  *((volatile unsigned char*)(0x424C0284UL))
#define bFM_QPRC0_QICR_QPRCMIE                *((volatile unsigned char*)(0x424C0288UL))
#define bFM_QPRC0_QICR_QPRCMF                 *((volatile unsigned char*)(0x424C028CUL))
#define bFM_QPRC0_QICR_OUZIE                  *((volatile unsigned char*)(0x424C0290UL))
#define bFM_QPRC0_QICR_UFDF                   *((volatile unsigned char*)(0x424C0294UL))
#define bFM_QPRC0_QICR_OFDF                   *((volatile unsigned char*)(0x424C0298UL))
#define bFM_QPRC0_QICR_ZIIF                   *((volatile unsigned char*)(0x424C029CUL))
#define bFM_QPRC0_QICR_CDCIE                  *((volatile unsigned char*)(0x424C02A0UL))
#define bFM_QPRC0_QICR_CDCF                   *((volatile unsigned char*)(0x424C02A4UL))
#define bFM_QPRC0_QICR_DIRPC                  *((volatile unsigned char*)(0x424C02A8UL))
#define bFM_QPRC0_QICR_DIROU                  *((volatile unsigned char*)(0x424C02ACUL))
#define bFM_QPRC0_QICR_QPCNRCMIE              *((volatile unsigned char*)(0x424C02B0UL))
#define bFM_QPRC0_QICR_QPCNRCMF               *((volatile unsigned char*)(0x424C02B4UL))
#define bFM_QPRC0_QICRL_QPCMIE                *((volatile unsigned char*)(0x424C0280UL))
#define bFM_QPRC0_QICRL_QPCMF                 *((volatile unsigned char*)(0x424C0284UL))
#define bFM_QPRC0_QICRL_QPRCMIE               *((volatile unsigned char*)(0x424C0288UL))
#define bFM_QPRC0_QICRL_QPRCMF                *((volatile unsigned char*)(0x424C028CUL))
#define bFM_QPRC0_QICRL_OUZIE                 *((volatile unsigned char*)(0x424C0290UL))
#define bFM_QPRC0_QICRL_UFDF                  *((volatile unsigned char*)(0x424C0294UL))
#define bFM_QPRC0_QICRL_OFDF                  *((volatile unsigned char*)(0x424C0298UL))
#define bFM_QPRC0_QICRL_ZIIF                  *((volatile unsigned char*)(0x424C029CUL))
#define bFM_QPRC0_QICRH_CDCIE                 *((volatile unsigned char*)(0x424C02A0UL))
#define bFM_QPRC0_QICRH_CDCF                  *((volatile unsigned char*)(0x424C02A4UL))
#define bFM_QPRC0_QICRH_DIRPC                 *((volatile unsigned char*)(0x424C02A8UL))
#define bFM_QPRC0_QICRH_DIROU                 *((volatile unsigned char*)(0x424C02ACUL))
#define bFM_QPRC0_QICRH_QPCNRCMIE             *((volatile unsigned char*)(0x424C02B0UL))
#define bFM_QPRC0_QICRH_QPCNRCMF              *((volatile unsigned char*)(0x424C02B4UL))
#define bFM_QPRC0_QCR_PCM0                    *((volatile unsigned char*)(0x424C0300UL))
#define bFM_QPRC0_QCR_PCM1                    *((volatile unsigned char*)(0x424C0304UL))
#define bFM_QPRC0_QCR_RCM0                    *((volatile unsigned char*)(0x424C0308UL))
#define bFM_QPRC0_QCR_RCM1                    *((volatile unsigned char*)(0x424C030CUL))
#define bFM_QPRC0_QCR_PSTP                    *((volatile unsigned char*)(0x424C0310UL))
#define bFM_QPRC0_QCR_CGSC                    *((volatile unsigned char*)(0x424C0314UL))
#define bFM_QPRC0_QCR_RSEL                    *((volatile unsigned char*)(0x424C0318UL))
#define bFM_QPRC0_QCR_SWAP                    *((volatile unsigned char*)(0x424C031CUL))
#define bFM_QPRC0_QCR_PCRM0                   *((volatile unsigned char*)(0x424C0320UL))
#define bFM_QPRC0_QCR_PCRM1                   *((volatile unsigned char*)(0x424C0324UL))
#define bFM_QPRC0_QCR_AES0                    *((volatile unsigned char*)(0x424C0328UL))
#define bFM_QPRC0_QCR_AES1                    *((volatile unsigned char*)(0x424C032CUL))
#define bFM_QPRC0_QCR_BES0                    *((volatile unsigned char*)(0x424C0330UL))
#define bFM_QPRC0_QCR_BES1                    *((volatile unsigned char*)(0x424C0334UL))
#define bFM_QPRC0_QCR_CGE0                    *((volatile unsigned char*)(0x424C0338UL))
#define bFM_QPRC0_QCR_CGE1                    *((volatile unsigned char*)(0x424C033CUL))
#define bFM_QPRC0_QCRL_PCM0                   *((volatile unsigned char*)(0x424C0300UL))
#define bFM_QPRC0_QCRL_PCM1                   *((volatile unsigned char*)(0x424C0304UL))
#define bFM_QPRC0_QCRL_RCM0                   *((volatile unsigned char*)(0x424C0308UL))
#define bFM_QPRC0_QCRL_RCM1                   *((volatile unsigned char*)(0x424C030CUL))
#define bFM_QPRC0_QCRL_PSTP                   *((volatile unsigned char*)(0x424C0310UL))
#define bFM_QPRC0_QCRL_CGSC                   *((volatile unsigned char*)(0x424C0314UL))
#define bFM_QPRC0_QCRL_RSEL                   *((volatile unsigned char*)(0x424C0318UL))
#define bFM_QPRC0_QCRL_SWAP                   *((volatile unsigned char*)(0x424C031CUL))
#define bFM_QPRC0_QCRH_PCRM0                  *((volatile unsigned char*)(0x424C0320UL))
#define bFM_QPRC0_QCRH_PCRM1                  *((volatile unsigned char*)(0x424C0324UL))
#define bFM_QPRC0_QCRH_AES0                   *((volatile unsigned char*)(0x424C0328UL))
#define bFM_QPRC0_QCRH_AES1                   *((volatile unsigned char*)(0x424C032CUL))
#define bFM_QPRC0_QCRH_BES0                   *((volatile unsigned char*)(0x424C0330UL))
#define bFM_QPRC0_QCRH_BES1                   *((volatile unsigned char*)(0x424C0334UL))
#define bFM_QPRC0_QCRH_CGE0                   *((volatile unsigned char*)(0x424C0338UL))
#define bFM_QPRC0_QCRH_CGE1                   *((volatile unsigned char*)(0x424C033CUL))
#define bFM_QPRC0_QECR_ORNGMD                 *((volatile unsigned char*)(0x424C0380UL))
#define bFM_QPRC0_QECR_ORNGF                  *((volatile unsigned char*)(0x424C0384UL))
#define bFM_QPRC0_QECR_ORNGIE                 *((volatile unsigned char*)(0x424C0388UL))
#define bFM_QPRC0_QECR_PEC                    *((volatile unsigned char*)(0x424C038CUL))

/* Quad position and revolution counter channel 1 registers */
#define bFM_QPRC1_QICR_QPCMIE                 *((volatile unsigned char*)(0x424C0A80UL))
#define bFM_QPRC1_QICR_QPCMF                  *((volatile unsigned char*)(0x424C0A84UL))
#define bFM_QPRC1_QICR_QPRCMIE                *((volatile unsigned char*)(0x424C0A88UL))
#define bFM_QPRC1_QICR_QPRCMF                 *((volatile unsigned char*)(0x424C0A8CUL))
#define bFM_QPRC1_QICR_OUZIE                  *((volatile unsigned char*)(0x424C0A90UL))
#define bFM_QPRC1_QICR_UFDF                   *((volatile unsigned char*)(0x424C0A94UL))
#define bFM_QPRC1_QICR_OFDF                   *((volatile unsigned char*)(0x424C0A98UL))
#define bFM_QPRC1_QICR_ZIIF                   *((volatile unsigned char*)(0x424C0A9CUL))
#define bFM_QPRC1_QICR_CDCIE                  *((volatile unsigned char*)(0x424C0AA0UL))
#define bFM_QPRC1_QICR_CDCF                   *((volatile unsigned char*)(0x424C0AA4UL))
#define bFM_QPRC1_QICR_DIRPC                  *((volatile unsigned char*)(0x424C0AA8UL))
#define bFM_QPRC1_QICR_DIROU                  *((volatile unsigned char*)(0x424C0AACUL))
#define bFM_QPRC1_QICR_QPCNRCMIE              *((volatile unsigned char*)(0x424C0AB0UL))
#define bFM_QPRC1_QICR_QPCNRCMF               *((volatile unsigned char*)(0x424C0AB4UL))
#define bFM_QPRC1_QICRL_QPCMIE                *((volatile unsigned char*)(0x424C0A80UL))
#define bFM_QPRC1_QICRL_QPCMF                 *((volatile unsigned char*)(0x424C0A84UL))
#define bFM_QPRC1_QICRL_QPRCMIE               *((volatile unsigned char*)(0x424C0A88UL))
#define bFM_QPRC1_QICRL_QPRCMF                *((volatile unsigned char*)(0x424C0A8CUL))
#define bFM_QPRC1_QICRL_OUZIE                 *((volatile unsigned char*)(0x424C0A90UL))
#define bFM_QPRC1_QICRL_UFDF                  *((volatile unsigned char*)(0x424C0A94UL))
#define bFM_QPRC1_QICRL_OFDF                  *((volatile unsigned char*)(0x424C0A98UL))
#define bFM_QPRC1_QICRL_ZIIF                  *((volatile unsigned char*)(0x424C0A9CUL))
#define bFM_QPRC1_QICRH_CDCIE                 *((volatile unsigned char*)(0x424C0AA0UL))
#define bFM_QPRC1_QICRH_CDCF                  *((volatile unsigned char*)(0x424C0AA4UL))
#define bFM_QPRC1_QICRH_DIRPC                 *((volatile unsigned char*)(0x424C0AA8UL))
#define bFM_QPRC1_QICRH_DIROU                 *((volatile unsigned char*)(0x424C0AACUL))
#define bFM_QPRC1_QICRH_QPCNRCMIE             *((volatile unsigned char*)(0x424C0AB0UL))
#define bFM_QPRC1_QICRH_QPCNRCMF              *((volatile unsigned char*)(0x424C0AB4UL))
#define bFM_QPRC1_QCR_PCM0                    *((volatile unsigned char*)(0x424C0B00UL))
#define bFM_QPRC1_QCR_PCM1                    *((volatile unsigned char*)(0x424C0B04UL))
#define bFM_QPRC1_QCR_RCM0                    *((volatile unsigned char*)(0x424C0B08UL))
#define bFM_QPRC1_QCR_RCM1                    *((volatile unsigned char*)(0x424C0B0CUL))
#define bFM_QPRC1_QCR_PSTP                    *((volatile unsigned char*)(0x424C0B10UL))
#define bFM_QPRC1_QCR_CGSC                    *((volatile unsigned char*)(0x424C0B14UL))
#define bFM_QPRC1_QCR_RSEL                    *((volatile unsigned char*)(0x424C0B18UL))
#define bFM_QPRC1_QCR_SWAP                    *((volatile unsigned char*)(0x424C0B1CUL))
#define bFM_QPRC1_QCR_PCRM0                   *((volatile unsigned char*)(0x424C0B20UL))
#define bFM_QPRC1_QCR_PCRM1                   *((volatile unsigned char*)(0x424C0B24UL))
#define bFM_QPRC1_QCR_AES0                    *((volatile unsigned char*)(0x424C0B28UL))
#define bFM_QPRC1_QCR_AES1                    *((volatile unsigned char*)(0x424C0B2CUL))
#define bFM_QPRC1_QCR_BES0                    *((volatile unsigned char*)(0x424C0B30UL))
#define bFM_QPRC1_QCR_BES1                    *((volatile unsigned char*)(0x424C0B34UL))
#define bFM_QPRC1_QCR_CGE0                    *((volatile unsigned char*)(0x424C0B38UL))
#define bFM_QPRC1_QCR_CGE1                    *((volatile unsigned char*)(0x424C0B3CUL))
#define bFM_QPRC1_QCRL_PCM0                   *((volatile unsigned char*)(0x424C0B00UL))
#define bFM_QPRC1_QCRL_PCM1                   *((volatile unsigned char*)(0x424C0B04UL))
#define bFM_QPRC1_QCRL_RCM0                   *((volatile unsigned char*)(0x424C0B08UL))
#define bFM_QPRC1_QCRL_RCM1                   *((volatile unsigned char*)(0x424C0B0CUL))
#define bFM_QPRC1_QCRL_PSTP                   *((volatile unsigned char*)(0x424C0B10UL))
#define bFM_QPRC1_QCRL_CGSC                   *((volatile unsigned char*)(0x424C0B14UL))
#define bFM_QPRC1_QCRL_RSEL                   *((volatile unsigned char*)(0x424C0B18UL))
#define bFM_QPRC1_QCRL_SWAP                   *((volatile unsigned char*)(0x424C0B1CUL))
#define bFM_QPRC1_QCRH_PCRM0                  *((volatile unsigned char*)(0x424C0B20UL))
#define bFM_QPRC1_QCRH_PCRM1                  *((volatile unsigned char*)(0x424C0B24UL))
#define bFM_QPRC1_QCRH_AES0                   *((volatile unsigned char*)(0x424C0B28UL))
#define bFM_QPRC1_QCRH_AES1                   *((volatile unsigned char*)(0x424C0B2CUL))
#define bFM_QPRC1_QCRH_BES0                   *((volatile unsigned char*)(0x424C0B30UL))
#define bFM_QPRC1_QCRH_BES1                   *((volatile unsigned char*)(0x424C0B34UL))
#define bFM_QPRC1_QCRH_CGE0                   *((volatile unsigned char*)(0x424C0B38UL))
#define bFM_QPRC1_QCRH_CGE1                   *((volatile unsigned char*)(0x424C0B3CUL))
#define bFM_QPRC1_QECR_ORNGMD                 *((volatile unsigned char*)(0x424C0B80UL))
#define bFM_QPRC1_QECR_ORNGF                  *((volatile unsigned char*)(0x424C0B84UL))
#define bFM_QPRC1_QECR_ORNGIE                 *((volatile unsigned char*)(0x424C0B88UL))

/* Quad position and revolution counter channel 2 registers */
#define bFM_QPRC2_QICR_QPCMIE                 *((volatile unsigned char*)(0x424C1280UL))
#define bFM_QPRC2_QICR_QPCMF                  *((volatile unsigned char*)(0x424C1284UL))
#define bFM_QPRC2_QICR_QPRCMIE                *((volatile unsigned char*)(0x424C1288UL))
#define bFM_QPRC2_QICR_QPRCMF                 *((volatile unsigned char*)(0x424C128CUL))
#define bFM_QPRC2_QICR_OUZIE                  *((volatile unsigned char*)(0x424C1290UL))
#define bFM_QPRC2_QICR_UFDF                   *((volatile unsigned char*)(0x424C1294UL))
#define bFM_QPRC2_QICR_OFDF                   *((volatile unsigned char*)(0x424C1298UL))
#define bFM_QPRC2_QICR_ZIIF                   *((volatile unsigned char*)(0x424C129CUL))
#define bFM_QPRC2_QICR_CDCIE                  *((volatile unsigned char*)(0x424C12A0UL))
#define bFM_QPRC2_QICR_CDCF                   *((volatile unsigned char*)(0x424C12A4UL))
#define bFM_QPRC2_QICR_DIRPC                  *((volatile unsigned char*)(0x424C12A8UL))
#define bFM_QPRC2_QICR_DIROU                  *((volatile unsigned char*)(0x424C12ACUL))
#define bFM_QPRC2_QICR_QPCNRCMIE              *((volatile unsigned char*)(0x424C12B0UL))
#define bFM_QPRC2_QICR_QPCNRCMF               *((volatile unsigned char*)(0x424C12B4UL))
#define bFM_QPRC2_QICRL_QPCMIE                *((volatile unsigned char*)(0x424C1280UL))
#define bFM_QPRC2_QICRL_QPCMF                 *((volatile unsigned char*)(0x424C1284UL))
#define bFM_QPRC2_QICRL_QPRCMIE               *((volatile unsigned char*)(0x424C1288UL))
#define bFM_QPRC2_QICRL_QPRCMF                *((volatile unsigned char*)(0x424C128CUL))
#define bFM_QPRC2_QICRL_OUZIE                 *((volatile unsigned char*)(0x424C1290UL))
#define bFM_QPRC2_QICRL_UFDF                  *((volatile unsigned char*)(0x424C1294UL))
#define bFM_QPRC2_QICRL_OFDF                  *((volatile unsigned char*)(0x424C1298UL))
#define bFM_QPRC2_QICRL_ZIIF                  *((volatile unsigned char*)(0x424C129CUL))
#define bFM_QPRC2_QICRH_CDCIE                 *((volatile unsigned char*)(0x424C12A0UL))
#define bFM_QPRC2_QICRH_CDCF                  *((volatile unsigned char*)(0x424C12A4UL))
#define bFM_QPRC2_QICRH_DIRPC                 *((volatile unsigned char*)(0x424C12A8UL))
#define bFM_QPRC2_QICRH_DIROU                 *((volatile unsigned char*)(0x424C12ACUL))
#define bFM_QPRC2_QICRH_QPCNRCMIE             *((volatile unsigned char*)(0x424C12B0UL))
#define bFM_QPRC2_QICRH_QPCNRCMF              *((volatile unsigned char*)(0x424C12B4UL))
#define bFM_QPRC2_QCR_PCM0                    *((volatile unsigned char*)(0x424C1300UL))
#define bFM_QPRC2_QCR_PCM1                    *((volatile unsigned char*)(0x424C1304UL))
#define bFM_QPRC2_QCR_RCM0                    *((volatile unsigned char*)(0x424C1308UL))
#define bFM_QPRC2_QCR_RCM1                    *((volatile unsigned char*)(0x424C130CUL))
#define bFM_QPRC2_QCR_PSTP                    *((volatile unsigned char*)(0x424C1310UL))
#define bFM_QPRC2_QCR_CGSC                    *((volatile unsigned char*)(0x424C1314UL))
#define bFM_QPRC2_QCR_RSEL                    *((volatile unsigned char*)(0x424C1318UL))
#define bFM_QPRC2_QCR_SWAP                    *((volatile unsigned char*)(0x424C131CUL))
#define bFM_QPRC2_QCR_PCRM0                   *((volatile unsigned char*)(0x424C1320UL))
#define bFM_QPRC2_QCR_PCRM1                   *((volatile unsigned char*)(0x424C1324UL))
#define bFM_QPRC2_QCR_AES0                    *((volatile unsigned char*)(0x424C1328UL))
#define bFM_QPRC2_QCR_AES1                    *((volatile unsigned char*)(0x424C132CUL))
#define bFM_QPRC2_QCR_BES0                    *((volatile unsigned char*)(0x424C1330UL))
#define bFM_QPRC2_QCR_BES1                    *((volatile unsigned char*)(0x424C1334UL))
#define bFM_QPRC2_QCR_CGE0                    *((volatile unsigned char*)(0x424C1338UL))
#define bFM_QPRC2_QCR_CGE1                    *((volatile unsigned char*)(0x424C133CUL))
#define bFM_QPRC2_QCRL_PCM0                   *((volatile unsigned char*)(0x424C1300UL))
#define bFM_QPRC2_QCRL_PCM1                   *((volatile unsigned char*)(0x424C1304UL))
#define bFM_QPRC2_QCRL_RCM0                   *((volatile unsigned char*)(0x424C1308UL))
#define bFM_QPRC2_QCRL_RCM1                   *((volatile unsigned char*)(0x424C130CUL))
#define bFM_QPRC2_QCRL_PSTP                   *((volatile unsigned char*)(0x424C1310UL))
#define bFM_QPRC2_QCRL_CGSC                   *((volatile unsigned char*)(0x424C1314UL))
#define bFM_QPRC2_QCRL_RSEL                   *((volatile unsigned char*)(0x424C1318UL))
#define bFM_QPRC2_QCRL_SWAP                   *((volatile unsigned char*)(0x424C131CUL))
#define bFM_QPRC2_QCRH_PCRM0                  *((volatile unsigned char*)(0x424C1320UL))
#define bFM_QPRC2_QCRH_PCRM1                  *((volatile unsigned char*)(0x424C1324UL))
#define bFM_QPRC2_QCRH_AES0                   *((volatile unsigned char*)(0x424C1328UL))
#define bFM_QPRC2_QCRH_AES1                   *((volatile unsigned char*)(0x424C132CUL))
#define bFM_QPRC2_QCRH_BES0                   *((volatile unsigned char*)(0x424C1330UL))
#define bFM_QPRC2_QCRH_BES1                   *((volatile unsigned char*)(0x424C1334UL))
#define bFM_QPRC2_QCRH_CGE0                   *((volatile unsigned char*)(0x424C1338UL))
#define bFM_QPRC2_QCRH_CGE1                   *((volatile unsigned char*)(0x424C133CUL))
#define bFM_QPRC2_QECR_ORNGMD                 *((volatile unsigned char*)(0x424C1380UL))
#define bFM_QPRC2_QECR_ORNGF                  *((volatile unsigned char*)(0x424C1384UL))
#define bFM_QPRC2_QECR_ORNGIE                 *((volatile unsigned char*)(0x424C1388UL))

/* Quad position and revolution counter channel 3 registers */
#define bFM_QPRC3_QICR_QPCMIE                 *((volatile unsigned char*)(0x424c1a80UL))
#define bFM_QPRC3_QICR_QPCMF                  *((volatile unsigned char*)(0x424c1a84UL))
#define bFM_QPRC3_QICR_QPRCMIE                *((volatile unsigned char*)(0x424c1a88UL))
#define bFM_QPRC3_QICR_QPRCMF                 *((volatile unsigned char*)(0x424c1a8CUL))
#define bFM_QPRC3_QICR_OUZIE                  *((volatile unsigned char*)(0x424c1a90UL))
#define bFM_QPRC3_QICR_UFDF                   *((volatile unsigned char*)(0x424c1a94UL))
#define bFM_QPRC3_QICR_OFDF                   *((volatile unsigned char*)(0x424c1a98UL))
#define bFM_QPRC3_QICR_ZIIF                   *((volatile unsigned char*)(0x424c1a9CUL))
#define bFM_QPRC3_QICR_CDCIE                  *((volatile unsigned char*)(0x424c1aa0UL))
#define bFM_QPRC3_QICR_CDCF                   *((volatile unsigned char*)(0x424c1aa4UL))
#define bFM_QPRC3_QICR_DIRPC                  *((volatile unsigned char*)(0x424c1aa8UL))
#define bFM_QPRC3_QICR_DIROU                  *((volatile unsigned char*)(0x424c1aaCUL))
#define bFM_QPRC3_QICR_QPCNRCMIE              *((volatile unsigned char*)(0x424c1ab0UL))
#define bFM_QPRC3_QICR_QPCNRCMF               *((volatile unsigned char*)(0x424c1ab4UL))
#define bFM_QPRC3_QCR_PCM0                    *((volatile unsigned char*)(0x424c1b00UL))
#define bFM_QPRC3_QCR_PCM1                    *((volatile unsigned char*)(0x424c1b04UL))
#define bFM_QPRC3_QCR_RCM0                    *((volatile unsigned char*)(0x424c1b08UL))
#define bFM_QPRC3_QCR_RCM1                    *((volatile unsigned char*)(0x424c1b0CUL))
#define bFM_QPRC3_QCR_PSTP                    *((volatile unsigned char*)(0x424c1b10UL))
#define bFM_QPRC3_QCR_CGSC                    *((volatile unsigned char*)(0x424c1b14UL))
#define bFM_QPRC3_QCR_RSEL                    *((volatile unsigned char*)(0x424c1b18UL))
#define bFM_QPRC3_QCR_SWAP                    *((volatile unsigned char*)(0x424c1b1CUL))
#define bFM_QPRC3_QCR_PCRM0                   *((volatile unsigned char*)(0x424c1b20UL))
#define bFM_QPRC3_QCR_PCRM1                   *((volatile unsigned char*)(0x424c1b24UL))
#define bFM_QPRC3_QCR_AES0                    *((volatile unsigned char*)(0x424c1b28UL))
#define bFM_QPRC3_QCR_AES1                    *((volatile unsigned char*)(0x424c1b2CUL))
#define bFM_QPRC3_QCR_BES0                    *((volatile unsigned char*)(0x424c1b30UL))
#define bFM_QPRC3_QCR_BES1                    *((volatile unsigned char*)(0x424c1b34UL))
#define bFM_QPRC3_QCR_CGE0                    *((volatile unsigned char*)(0x424c1b38UL))
#define bFM_QPRC3_QCR_CGE1                    *((volatile unsigned char*)(0x424c1b3CUL))
#define bFM_QPRC3_QECR_ORNGMD                 *((volatile unsigned char*)(0x424c1b80UL))
#define bFM_QPRC3_QECR_ORNGF                  *((volatile unsigned char*)(0x424c1b84UL))
#define bFM_QPRC3_QECR_ORNGIE                 *((volatile unsigned char*)(0x424c1b88UL))

/* QPRC NF channel 0 registers */
#define bFM_QPRC0_NF_NFCTLA_AINLV             *((volatile unsigned char*)(0x424c2010UL))
#define bFM_QPRC0_NF_NFCTLA_AINMD             *((volatile unsigned char*)(0x424c2014UL))
#define bFM_QPRC0_NF_NFCTLB_BINLV             *((volatile unsigned char*)(0x424c2090UL))
#define bFM_QPRC0_NF_NFCTLB_BINMD             *((volatile unsigned char*)(0x424c2094UL))
#define bFM_QPRC0_NF_NFRCTLZ_ZINLV            *((volatile unsigned char*)(0x424c2110UL))
#define bFM_QPRC0_NF_NFRCTLZ_ZINMD            *((volatile unsigned char*)(0x424c2114UL))

/* QPRC NF channel 1 registers */
#define bFM_QPRC1_NF_NFCTLA_AINLV             *((volatile unsigned char*)(0x424c2210UL))
#define bFM_QPRC1_NF_NFCTLA_AINMD             *((volatile unsigned char*)(0x424c2214UL))
#define bFM_QPRC1_NF_NFCTLB_BINLV             *((volatile unsigned char*)(0x424c2290UL))
#define bFM_QPRC1_NF_NFCTLB_BINMD             *((volatile unsigned char*)(0x424c2294UL))
#define bFM_QPRC1_NF_NFRCTLZ_ZINLV            *((volatile unsigned char*)(0x424c2310UL))
#define bFM_QPRC1_NF_NFRCTLZ_ZINMD            *((volatile unsigned char*)(0x424c2314UL))

/* QPRC NF channel 2 registers */
#define bFM_QPRC2_NF_NFCTLA_AINLV             *((volatile unsigned char*)(0x424c2410UL))
#define bFM_QPRC2_NF_NFCTLA_AINMD             *((volatile unsigned char*)(0x424c2414UL))
#define bFM_QPRC2_NF_NFCTLB_BINLV             *((volatile unsigned char*)(0x424c2490UL))
#define bFM_QPRC2_NF_NFCTLB_BINMD             *((volatile unsigned char*)(0x424c2494UL))
#define bFM_QPRC2_NF_NFRCTLZ_ZINLV            *((volatile unsigned char*)(0x424c2510UL))
#define bFM_QPRC2_NF_NFRCTLZ_ZINMD            *((volatile unsigned char*)(0x424c2514UL))

/* QPRC NF channel 3 registers */
#define bFM_QPRC3_NF_NFCTLA_AINLV             *((volatile unsigned char*)(0x424c2610UL))
#define bFM_QPRC3_NF_NFCTLA_AINMD             *((volatile unsigned char*)(0x424c2614UL))
#define bFM_QPRC3_NF_NFCTLB_BINLV             *((volatile unsigned char*)(0x424c2690UL))
#define bFM_QPRC3_NF_NFCTLB_BINMD             *((volatile unsigned char*)(0x424c2694UL))
#define bFM_QPRC3_NF_NFRCTLZ_ZINLV            *((volatile unsigned char*)(0x424c2710UL))
#define bFM_QPRC3_NF_NFRCTLZ_ZINMD            *((volatile unsigned char*)(0x424c2714UL))

/* 12-bit ADC unit 0 registers */
#define bFM_ADC0_ADSR_SCS                     *((volatile unsigned char*)(0x424E0000UL))
#define bFM_ADC0_ADSR_PCS                     *((volatile unsigned char*)(0x424E0004UL))
#define bFM_ADC0_ADSR_PCNS                    *((volatile unsigned char*)(0x424E0008UL))
#define bFM_ADC0_ADSR_FDAS                    *((volatile unsigned char*)(0x424E0018UL))
#define bFM_ADC0_ADSR_ADSTP                   *((volatile unsigned char*)(0x424E001CUL))
#define bFM_ADC0_ADCR_OVRIE                   *((volatile unsigned char*)(0x424E0020UL))
#define bFM_ADC0_ADCR_CMPIE                   *((volatile unsigned char*)(0x424E0024UL))
#define bFM_ADC0_ADCR_PCIE                    *((volatile unsigned char*)(0x424E0028UL))
#define bFM_ADC0_ADCR_SCIE                    *((volatile unsigned char*)(0x424E002CUL))
#define bFM_ADC0_ADCR_CMPIF                   *((volatile unsigned char*)(0x424E0034UL))
#define bFM_ADC0_ADCR_PCIF                    *((volatile unsigned char*)(0x424E0038UL))
#define bFM_ADC0_ADCR_SCIF                    *((volatile unsigned char*)(0x424E003CUL))
#define bFM_ADC0_SFNS_SFS0                    *((volatile unsigned char*)(0x424E0100UL))
#define bFM_ADC0_SFNS_SFS1                    *((volatile unsigned char*)(0x424E0104UL))
#define bFM_ADC0_SFNS_SFS2                    *((volatile unsigned char*)(0x424E0108UL))
#define bFM_ADC0_SFNS_SFS3                    *((volatile unsigned char*)(0x424E010CUL))
#define bFM_ADC0_SCCR_SSTR                    *((volatile unsigned char*)(0x424E0120UL))
#define bFM_ADC0_SCCR_SHEN                    *((volatile unsigned char*)(0x424E0124UL))
#define bFM_ADC0_SCCR_RPT                     *((volatile unsigned char*)(0x424E0128UL))
#define bFM_ADC0_SCCR_SFCLR                   *((volatile unsigned char*)(0x424E0130UL))
#define bFM_ADC0_SCCR_SOVR                    *((volatile unsigned char*)(0x424E0134UL))
#define bFM_ADC0_SCCR_SFUL                    *((volatile unsigned char*)(0x424E0138UL))
#define bFM_ADC0_SCCR_SEMP                    *((volatile unsigned char*)(0x424E013CUL))
#define bFM_ADC0_SCFD_SC0                     *((volatile unsigned char*)(0x424E0180UL))
#define bFM_ADC0_SCFD_SC1                     *((volatile unsigned char*)(0x424E0184UL))
#define bFM_ADC0_SCFD_SC2                     *((volatile unsigned char*)(0x424E0188UL))
#define bFM_ADC0_SCFD_SC3                     *((volatile unsigned char*)(0x424E018CUL))
#define bFM_ADC0_SCFD_SC4                     *((volatile unsigned char*)(0x424E0190UL))
#define bFM_ADC0_SCFD_RS0                     *((volatile unsigned char*)(0x424E01A0UL))
#define bFM_ADC0_SCFD_RS1                     *((volatile unsigned char*)(0x424E01A4UL))
#define bFM_ADC0_SCFD_INVL                    *((volatile unsigned char*)(0x424E01B0UL))
#define bFM_ADC0_SCFD_SD0                     *((volatile unsigned char*)(0x424E01D0UL))
#define bFM_ADC0_SCFD_SD1                     *((volatile unsigned char*)(0x424E01D4UL))
#define bFM_ADC0_SCFD_SD2                     *((volatile unsigned char*)(0x424E01D8UL))
#define bFM_ADC0_SCFD_SD3                     *((volatile unsigned char*)(0x424E01DCUL))
#define bFM_ADC0_SCFD_SD4                     *((volatile unsigned char*)(0x424E01E0UL))
#define bFM_ADC0_SCFD_SD5                     *((volatile unsigned char*)(0x424E01E4UL))
#define bFM_ADC0_SCFD_SD6                     *((volatile unsigned char*)(0x424E01E8UL))
#define bFM_ADC0_SCFD_SD7                     *((volatile unsigned char*)(0x424E01ECUL))
#define bFM_ADC0_SCFD_SD8                     *((volatile unsigned char*)(0x424E01F0UL))
#define bFM_ADC0_SCFD_SD9                     *((volatile unsigned char*)(0x424E01F4UL))
#define bFM_ADC0_SCFD_SD10                    *((volatile unsigned char*)(0x424E01F8UL))
#define bFM_ADC0_SCFD_SD11                    *((volatile unsigned char*)(0x424E01FCUL))
#define bFM_ADC0_SCFDL_SC0                    *((volatile unsigned char*)(0x424E0180UL))
#define bFM_ADC0_SCFDL_SC1                    *((volatile unsigned char*)(0x424E0184UL))
#define bFM_ADC0_SCFDL_SC2                    *((volatile unsigned char*)(0x424E0188UL))
#define bFM_ADC0_SCFDL_SC3                    *((volatile unsigned char*)(0x424E018CUL))
#define bFM_ADC0_SCFDL_SC4                    *((volatile unsigned char*)(0x424E0190UL))
#define bFM_ADC0_SCFDL_RS0                    *((volatile unsigned char*)(0x424E01A0UL))
#define bFM_ADC0_SCFDL_RS1                    *((volatile unsigned char*)(0x424E01A4UL))
#define bFM_ADC0_SCFDL_INVL                   *((volatile unsigned char*)(0x424E01B0UL))
#define bFM_ADC0_SCFDH_SD0                    *((volatile unsigned char*)(0x424E01D0UL))
#define bFM_ADC0_SCFDH_SD1                    *((volatile unsigned char*)(0x424E01D4UL))
#define bFM_ADC0_SCFDH_SD2                    *((volatile unsigned char*)(0x424E01D8UL))
#define bFM_ADC0_SCFDH_SD3                    *((volatile unsigned char*)(0x424E01DCUL))
#define bFM_ADC0_SCFDH_SD4                    *((volatile unsigned char*)(0x424E01E0UL))
#define bFM_ADC0_SCFDH_SD5                    *((volatile unsigned char*)(0x424E01E4UL))
#define bFM_ADC0_SCFDH_SD6                    *((volatile unsigned char*)(0x424E01E8UL))
#define bFM_ADC0_SCFDH_SD7                    *((volatile unsigned char*)(0x424E01ECUL))
#define bFM_ADC0_SCFDH_SD8                    *((volatile unsigned char*)(0x424E01F0UL))
#define bFM_ADC0_SCFDH_SD9                    *((volatile unsigned char*)(0x424E01F4UL))
#define bFM_ADC0_SCFDH_SD10                   *((volatile unsigned char*)(0x424E01F8UL))
#define bFM_ADC0_SCFDH_SD11                   *((volatile unsigned char*)(0x424E01FCUL))
#define bFM_ADC0_SCIS23_AN16                  *((volatile unsigned char*)(0x424E0200UL))
#define bFM_ADC0_SCIS23_AN17                  *((volatile unsigned char*)(0x424E0204UL))
#define bFM_ADC0_SCIS23_AN18                  *((volatile unsigned char*)(0x424E0208UL))
#define bFM_ADC0_SCIS23_AN19                  *((volatile unsigned char*)(0x424E020CUL))
#define bFM_ADC0_SCIS23_AN20                  *((volatile unsigned char*)(0x424E0210UL))
#define bFM_ADC0_SCIS23_AN21                  *((volatile unsigned char*)(0x424E0214UL))
#define bFM_ADC0_SCIS23_AN22                  *((volatile unsigned char*)(0x424E0218UL))
#define bFM_ADC0_SCIS23_AN23                  *((volatile unsigned char*)(0x424E021CUL))
#define bFM_ADC0_SCIS23_AN24                  *((volatile unsigned char*)(0x424E0220UL))
#define bFM_ADC0_SCIS23_AN25                  *((volatile unsigned char*)(0x424E0224UL))
#define bFM_ADC0_SCIS23_AN26                  *((volatile unsigned char*)(0x424E0228UL))
#define bFM_ADC0_SCIS23_AN27                  *((volatile unsigned char*)(0x424E022CUL))
#define bFM_ADC0_SCIS23_AN28                  *((volatile unsigned char*)(0x424E0230UL))
#define bFM_ADC0_SCIS23_AN29                  *((volatile unsigned char*)(0x424E0234UL))
#define bFM_ADC0_SCIS23_AN30                  *((volatile unsigned char*)(0x424E0238UL))
#define bFM_ADC0_SCIS23_AN31                  *((volatile unsigned char*)(0x424E023CUL))
#define bFM_ADC0_SCIS2_AN16                   *((volatile unsigned char*)(0x424E0200UL))
#define bFM_ADC0_SCIS2_AN17                   *((volatile unsigned char*)(0x424E0204UL))
#define bFM_ADC0_SCIS2_AN18                   *((volatile unsigned char*)(0x424E0208UL))
#define bFM_ADC0_SCIS2_AN19                   *((volatile unsigned char*)(0x424E020CUL))
#define bFM_ADC0_SCIS2_AN20                   *((volatile unsigned char*)(0x424E0210UL))
#define bFM_ADC0_SCIS2_AN21                   *((volatile unsigned char*)(0x424E0214UL))
#define bFM_ADC0_SCIS2_AN22                   *((volatile unsigned char*)(0x424E0218UL))
#define bFM_ADC0_SCIS2_AN23                   *((volatile unsigned char*)(0x424E021CUL))
#define bFM_ADC0_SCIS3_AN24                   *((volatile unsigned char*)(0x424E0220UL))
#define bFM_ADC0_SCIS3_AN25                   *((volatile unsigned char*)(0x424E0224UL))
#define bFM_ADC0_SCIS3_AN26                   *((volatile unsigned char*)(0x424E0228UL))
#define bFM_ADC0_SCIS3_AN27                   *((volatile unsigned char*)(0x424E022CUL))
#define bFM_ADC0_SCIS3_AN28                   *((volatile unsigned char*)(0x424E0230UL))
#define bFM_ADC0_SCIS3_AN29                   *((volatile unsigned char*)(0x424E0234UL))
#define bFM_ADC0_SCIS3_AN30                   *((volatile unsigned char*)(0x424E0238UL))
#define bFM_ADC0_SCIS3_AN31                   *((volatile unsigned char*)(0x424E023CUL))
#define bFM_ADC0_SCIS01_AN0                   *((volatile unsigned char*)(0x424E0280UL))
#define bFM_ADC0_SCIS01_AN1                   *((volatile unsigned char*)(0x424E0284UL))
#define bFM_ADC0_SCIS01_AN2                   *((volatile unsigned char*)(0x424E0288UL))
#define bFM_ADC0_SCIS01_AN3                   *((volatile unsigned char*)(0x424E028CUL))
#define bFM_ADC0_SCIS01_AN4                   *((volatile unsigned char*)(0x424E0290UL))
#define bFM_ADC0_SCIS01_AN5                   *((volatile unsigned char*)(0x424E0294UL))
#define bFM_ADC0_SCIS01_AN6                   *((volatile unsigned char*)(0x424E0298UL))
#define bFM_ADC0_SCIS01_AN7                   *((volatile unsigned char*)(0x424E029CUL))
#define bFM_ADC0_SCIS01_AN8                   *((volatile unsigned char*)(0x424E02A0UL))
#define bFM_ADC0_SCIS01_AN9                   *((volatile unsigned char*)(0x424E02A4UL))
#define bFM_ADC0_SCIS01_AN10                  *((volatile unsigned char*)(0x424E02A8UL))
#define bFM_ADC0_SCIS01_AN11                  *((volatile unsigned char*)(0x424E02ACUL))
#define bFM_ADC0_SCIS01_AN12                  *((volatile unsigned char*)(0x424E02B0UL))
#define bFM_ADC0_SCIS01_AN13                  *((volatile unsigned char*)(0x424E02B4UL))
#define bFM_ADC0_SCIS01_AN14                  *((volatile unsigned char*)(0x424E02B8UL))
#define bFM_ADC0_SCIS01_AN15                  *((volatile unsigned char*)(0x424E02BCUL))
#define bFM_ADC0_SCIS0_AN0                    *((volatile unsigned char*)(0x424E0280UL))
#define bFM_ADC0_SCIS0_AN1                    *((volatile unsigned char*)(0x424E0284UL))
#define bFM_ADC0_SCIS0_AN2                    *((volatile unsigned char*)(0x424E0288UL))
#define bFM_ADC0_SCIS0_AN3                    *((volatile unsigned char*)(0x424E028CUL))
#define bFM_ADC0_SCIS0_AN4                    *((volatile unsigned char*)(0x424E0290UL))
#define bFM_ADC0_SCIS0_AN5                    *((volatile unsigned char*)(0x424E0294UL))
#define bFM_ADC0_SCIS0_AN6                    *((volatile unsigned char*)(0x424E0298UL))
#define bFM_ADC0_SCIS0_AN7                    *((volatile unsigned char*)(0x424E029CUL))
#define bFM_ADC0_SCIS1_AN8                    *((volatile unsigned char*)(0x424E02A0UL))
#define bFM_ADC0_SCIS1_AN9                    *((volatile unsigned char*)(0x424E02A4UL))
#define bFM_ADC0_SCIS1_AN10                   *((volatile unsigned char*)(0x424E02A8UL))
#define bFM_ADC0_SCIS1_AN11                   *((volatile unsigned char*)(0x424E02ACUL))
#define bFM_ADC0_SCIS1_AN12                   *((volatile unsigned char*)(0x424E02B0UL))
#define bFM_ADC0_SCIS1_AN13                   *((volatile unsigned char*)(0x424E02B4UL))
#define bFM_ADC0_SCIS1_AN14                   *((volatile unsigned char*)(0x424E02B8UL))
#define bFM_ADC0_SCIS1_AN15                   *((volatile unsigned char*)(0x424E02BCUL))
#define bFM_ADC0_PFNS_PFS0                    *((volatile unsigned char*)(0x424E0300UL))
#define bFM_ADC0_PFNS_PFS1                    *((volatile unsigned char*)(0x424E0304UL))
#define bFM_ADC0_PFNS_TEST0                   *((volatile unsigned char*)(0x424E0310UL))
#define bFM_ADC0_PFNS_TEST1                   *((volatile unsigned char*)(0x424E0314UL))
#define bFM_ADC0_PCCR_PSTR                    *((volatile unsigned char*)(0x424E0320UL))
#define bFM_ADC0_PCCR_PHEN                    *((volatile unsigned char*)(0x424E0324UL))
#define bFM_ADC0_PCCR_PEEN                    *((volatile unsigned char*)(0x424E0328UL))
#define bFM_ADC0_PCCR_ESCE                    *((volatile unsigned char*)(0x424E032CUL))
#define bFM_ADC0_PCCR_PFCLR                   *((volatile unsigned char*)(0x424E0330UL))
#define bFM_ADC0_PCCR_POVR                    *((volatile unsigned char*)(0x424E0334UL))
#define bFM_ADC0_PCCR_PFUL                    *((volatile unsigned char*)(0x424E0338UL))
#define bFM_ADC0_PCCR_PEMP                    *((volatile unsigned char*)(0x424E033CUL))
#define bFM_ADC0_PCFD_PC0                     *((volatile unsigned char*)(0x424E0380UL))
#define bFM_ADC0_PCFD_PC1                     *((volatile unsigned char*)(0x424E0384UL))
#define bFM_ADC0_PCFD_PC2                     *((volatile unsigned char*)(0x424E0388UL))
#define bFM_ADC0_PCFD_PC3                     *((volatile unsigned char*)(0x424E038CUL))
#define bFM_ADC0_PCFD_PC4                     *((volatile unsigned char*)(0x424E0390UL))
#define bFM_ADC0_PCFD_RS0                     *((volatile unsigned char*)(0x424E03A0UL))
#define bFM_ADC0_PCFD_RS1                     *((volatile unsigned char*)(0x424E03A4UL))
#define bFM_ADC0_PCFD_RS2                     *((volatile unsigned char*)(0x424E03A8UL))
#define bFM_ADC0_PCFD_INVL                    *((volatile unsigned char*)(0x424E03B0UL))
#define bFM_ADC0_PCFD_PD0                     *((volatile unsigned char*)(0x424E03D0UL))
#define bFM_ADC0_PCFD_PD1                     *((volatile unsigned char*)(0x424E03D4UL))
#define bFM_ADC0_PCFD_PD2                     *((volatile unsigned char*)(0x424E03D8UL))
#define bFM_ADC0_PCFD_PD3                     *((volatile unsigned char*)(0x424E03DCUL))
#define bFM_ADC0_PCFD_PD4                     *((volatile unsigned char*)(0x424E03E0UL))
#define bFM_ADC0_PCFD_PD5                     *((volatile unsigned char*)(0x424E03E4UL))
#define bFM_ADC0_PCFD_PD6                     *((volatile unsigned char*)(0x424E03E8UL))
#define bFM_ADC0_PCFD_PD7                     *((volatile unsigned char*)(0x424E03ECUL))
#define bFM_ADC0_PCFD_PD8                     *((volatile unsigned char*)(0x424E03F0UL))
#define bFM_ADC0_PCFD_PD9                     *((volatile unsigned char*)(0x424E03F4UL))
#define bFM_ADC0_PCFD_PD10                    *((volatile unsigned char*)(0x424E03F8UL))
#define bFM_ADC0_PCFD_PD11                    *((volatile unsigned char*)(0x424E03FCUL))
#define bFM_ADC0_PCFDL_PC0                    *((volatile unsigned char*)(0x424E0380UL))
#define bFM_ADC0_PCFDL_PC1                    *((volatile unsigned char*)(0x424E0384UL))
#define bFM_ADC0_PCFDL_PC2                    *((volatile unsigned char*)(0x424E0388UL))
#define bFM_ADC0_PCFDL_PC3                    *((volatile unsigned char*)(0x424E038CUL))
#define bFM_ADC0_PCFDL_PC4                    *((volatile unsigned char*)(0x424E0390UL))
#define bFM_ADC0_PCFDL_RS0                    *((volatile unsigned char*)(0x424E03A0UL))
#define bFM_ADC0_PCFDL_RS1                    *((volatile unsigned char*)(0x424E03A4UL))
#define bFM_ADC0_PCFDL_RS2                    *((volatile unsigned char*)(0x424E03A8UL))
#define bFM_ADC0_PCFDL_INVL                   *((volatile unsigned char*)(0x424E03B0UL))
#define bFM_ADC0_PCFDH_PD0                    *((volatile unsigned char*)(0x424E03D0UL))
#define bFM_ADC0_PCFDH_PD1                    *((volatile unsigned char*)(0x424E03D4UL))
#define bFM_ADC0_PCFDH_PD2                    *((volatile unsigned char*)(0x424E03D8UL))
#define bFM_ADC0_PCFDH_PD3                    *((volatile unsigned char*)(0x424E03DCUL))
#define bFM_ADC0_PCFDH_PD4                    *((volatile unsigned char*)(0x424E03E0UL))
#define bFM_ADC0_PCFDH_PD5                    *((volatile unsigned char*)(0x424E03E4UL))
#define bFM_ADC0_PCFDH_PD6                    *((volatile unsigned char*)(0x424E03E8UL))
#define bFM_ADC0_PCFDH_PD7                    *((volatile unsigned char*)(0x424E03ECUL))
#define bFM_ADC0_PCFDH_PD8                    *((volatile unsigned char*)(0x424E03F0UL))
#define bFM_ADC0_PCFDH_PD9                    *((volatile unsigned char*)(0x424E03F4UL))
#define bFM_ADC0_PCFDH_PD10                   *((volatile unsigned char*)(0x424E03F8UL))
#define bFM_ADC0_PCFDH_PD11                   *((volatile unsigned char*)(0x424E03FCUL))
#define bFM_ADC0_PCIS_P1A0                    *((volatile unsigned char*)(0x424E0400UL))
#define bFM_ADC0_PCIS_P1A1                    *((volatile unsigned char*)(0x424E0404UL))
#define bFM_ADC0_PCIS_P1A2                    *((volatile unsigned char*)(0x424E0408UL))
#define bFM_ADC0_PCIS_P2A0                    *((volatile unsigned char*)(0x424E040CUL))
#define bFM_ADC0_PCIS_P2A1                    *((volatile unsigned char*)(0x424E0410UL))
#define bFM_ADC0_PCIS_P2A2                    *((volatile unsigned char*)(0x424E0414UL))
#define bFM_ADC0_PCIS_P2A3                    *((volatile unsigned char*)(0x424E0418UL))
#define bFM_ADC0_PCIS_P2A4                    *((volatile unsigned char*)(0x424E041CUL))
#define bFM_ADC0_CMPCR_CCH0                   *((volatile unsigned char*)(0x424E0480UL))
#define bFM_ADC0_CMPCR_CCH1                   *((volatile unsigned char*)(0x424E0484UL))
#define bFM_ADC0_CMPCR_CCH2                   *((volatile unsigned char*)(0x424E0488UL))
#define bFM_ADC0_CMPCR_CCH3                   *((volatile unsigned char*)(0x424E048CUL))
#define bFM_ADC0_CMPCR_CCH4                   *((volatile unsigned char*)(0x424E0490UL))
#define bFM_ADC0_CMPCR_CMD0                   *((volatile unsigned char*)(0x424E0494UL))
#define bFM_ADC0_CMPCR_CMD1                   *((volatile unsigned char*)(0x424E0498UL))
#define bFM_ADC0_CMPCR_CMPEN                  *((volatile unsigned char*)(0x424E049CUL))
#define bFM_ADC0_CMPD_CMAD2                   *((volatile unsigned char*)(0x424E04D8UL))
#define bFM_ADC0_CMPD_CMAD3                   *((volatile unsigned char*)(0x424E04DCUL))
#define bFM_ADC0_CMPD_CMAD4                   *((volatile unsigned char*)(0x424E04E0UL))
#define bFM_ADC0_CMPD_CMAD5                   *((volatile unsigned char*)(0x424E04E4UL))
#define bFM_ADC0_CMPD_CMAD6                   *((volatile unsigned char*)(0x424E04E8UL))
#define bFM_ADC0_CMPD_CMAD7                   *((volatile unsigned char*)(0x424E04ECUL))
#define bFM_ADC0_CMPD_CMAD8                   *((volatile unsigned char*)(0x424E04F0UL))
#define bFM_ADC0_CMPD_CMAD9                   *((volatile unsigned char*)(0x424E04F4UL))
#define bFM_ADC0_CMPD_CMAD10                  *((volatile unsigned char*)(0x424E04F8UL))
#define bFM_ADC0_CMPD_CMAD11                  *((volatile unsigned char*)(0x424E04FCUL))
#define bFM_ADC0_ADSS23_TS16                  *((volatile unsigned char*)(0x424E0500UL))
#define bFM_ADC0_ADSS23_TS17                  *((volatile unsigned char*)(0x424E0504UL))
#define bFM_ADC0_ADSS23_TS18                  *((volatile unsigned char*)(0x424E0508UL))
#define bFM_ADC0_ADSS23_TS19                  *((volatile unsigned char*)(0x424E050CUL))
#define bFM_ADC0_ADSS23_TS20                  *((volatile unsigned char*)(0x424E0510UL))
#define bFM_ADC0_ADSS23_TS21                  *((volatile unsigned char*)(0x424E0514UL))
#define bFM_ADC0_ADSS23_TS22                  *((volatile unsigned char*)(0x424E0518UL))
#define bFM_ADC0_ADSS23_TS23                  *((volatile unsigned char*)(0x424E051CUL))
#define bFM_ADC0_ADSS23_TS24                  *((volatile unsigned char*)(0x424E0520UL))
#define bFM_ADC0_ADSS23_TS25                  *((volatile unsigned char*)(0x424E0524UL))
#define bFM_ADC0_ADSS23_TS26                  *((volatile unsigned char*)(0x424E0528UL))
#define bFM_ADC0_ADSS23_TS27                  *((volatile unsigned char*)(0x424E052CUL))
#define bFM_ADC0_ADSS23_TS28                  *((volatile unsigned char*)(0x424E0530UL))
#define bFM_ADC0_ADSS23_TS29                  *((volatile unsigned char*)(0x424E0534UL))
#define bFM_ADC0_ADSS23_TS30                  *((volatile unsigned char*)(0x424E0538UL))
#define bFM_ADC0_ADSS23_TS31                  *((volatile unsigned char*)(0x424E053CUL))
#define bFM_ADC0_ADSS2_TS16                   *((volatile unsigned char*)(0x424E0500UL))
#define bFM_ADC0_ADSS2_TS17                   *((volatile unsigned char*)(0x424E0504UL))
#define bFM_ADC0_ADSS2_TS18                   *((volatile unsigned char*)(0x424E0508UL))
#define bFM_ADC0_ADSS2_TS19                   *((volatile unsigned char*)(0x424E050CUL))
#define bFM_ADC0_ADSS2_TS20                   *((volatile unsigned char*)(0x424E0510UL))
#define bFM_ADC0_ADSS2_TS21                   *((volatile unsigned char*)(0x424E0514UL))
#define bFM_ADC0_ADSS2_TS22                   *((volatile unsigned char*)(0x424E0518UL))
#define bFM_ADC0_ADSS2_TS23                   *((volatile unsigned char*)(0x424E051CUL))
#define bFM_ADC0_ADSS3_TS24                   *((volatile unsigned char*)(0x424E0520UL))
#define bFM_ADC0_ADSS3_TS25                   *((volatile unsigned char*)(0x424E0524UL))
#define bFM_ADC0_ADSS3_TS26                   *((volatile unsigned char*)(0x424E0528UL))
#define bFM_ADC0_ADSS3_TS27                   *((volatile unsigned char*)(0x424E052CUL))
#define bFM_ADC0_ADSS3_TS28                   *((volatile unsigned char*)(0x424E0530UL))
#define bFM_ADC0_ADSS3_TS29                   *((volatile unsigned char*)(0x424E0534UL))
#define bFM_ADC0_ADSS3_TS30                   *((volatile unsigned char*)(0x424E0538UL))
#define bFM_ADC0_ADSS3_TS31                   *((volatile unsigned char*)(0x424E053CUL))
#define bFM_ADC0_ADSS01_TS0                   *((volatile unsigned char*)(0x424E0580UL))
#define bFM_ADC0_ADSS01_TS1                   *((volatile unsigned char*)(0x424E0584UL))
#define bFM_ADC0_ADSS01_TS2                   *((volatile unsigned char*)(0x424E0588UL))
#define bFM_ADC0_ADSS01_TS3                   *((volatile unsigned char*)(0x424E058CUL))
#define bFM_ADC0_ADSS01_TS4                   *((volatile unsigned char*)(0x424E0590UL))
#define bFM_ADC0_ADSS01_TS5                   *((volatile unsigned char*)(0x424E0594UL))
#define bFM_ADC0_ADSS01_TS6                   *((volatile unsigned char*)(0x424E0598UL))
#define bFM_ADC0_ADSS01_TS7                   *((volatile unsigned char*)(0x424E059CUL))
#define bFM_ADC0_ADSS01_TS8                   *((volatile unsigned char*)(0x424E05A0UL))
#define bFM_ADC0_ADSS01_TS9                   *((volatile unsigned char*)(0x424E05A4UL))
#define bFM_ADC0_ADSS01_TS10                  *((volatile unsigned char*)(0x424E05A8UL))
#define bFM_ADC0_ADSS01_TS11                  *((volatile unsigned char*)(0x424E05ACUL))
#define bFM_ADC0_ADSS01_TS12                  *((volatile unsigned char*)(0x424E05B0UL))
#define bFM_ADC0_ADSS01_TS13                  *((volatile unsigned char*)(0x424E05B4UL))
#define bFM_ADC0_ADSS01_TS14                  *((volatile unsigned char*)(0x424E05B8UL))
#define bFM_ADC0_ADSS01_TS15                  *((volatile unsigned char*)(0x424E05BCUL))
#define bFM_ADC0_ADSS0_TS0                    *((volatile unsigned char*)(0x424E0580UL))
#define bFM_ADC0_ADSS0_TS1                    *((volatile unsigned char*)(0x424E0584UL))
#define bFM_ADC0_ADSS0_TS2                    *((volatile unsigned char*)(0x424E0588UL))
#define bFM_ADC0_ADSS0_TS3                    *((volatile unsigned char*)(0x424E058CUL))
#define bFM_ADC0_ADSS0_TS4                    *((volatile unsigned char*)(0x424E0590UL))
#define bFM_ADC0_ADSS0_TS5                    *((volatile unsigned char*)(0x424E0594UL))
#define bFM_ADC0_ADSS0_TS6                    *((volatile unsigned char*)(0x424E0598UL))
#define bFM_ADC0_ADSS0_TS7                    *((volatile unsigned char*)(0x424E059CUL))
#define bFM_ADC0_ADSS1_TS8                    *((volatile unsigned char*)(0x424E05A0UL))
#define bFM_ADC0_ADSS1_TS9                    *((volatile unsigned char*)(0x424E05A4UL))
#define bFM_ADC0_ADSS1_TS10                   *((volatile unsigned char*)(0x424E05A8UL))
#define bFM_ADC0_ADSS1_TS11                   *((volatile unsigned char*)(0x424E05ACUL))
#define bFM_ADC0_ADSS1_TS12                   *((volatile unsigned char*)(0x424E05B0UL))
#define bFM_ADC0_ADSS1_TS13                   *((volatile unsigned char*)(0x424E05B4UL))
#define bFM_ADC0_ADSS1_TS14                   *((volatile unsigned char*)(0x424E05B8UL))
#define bFM_ADC0_ADSS1_TS15                   *((volatile unsigned char*)(0x424E05BCUL))
#define bFM_ADC0_ADST01_ST10                  *((volatile unsigned char*)(0x424E0600UL))
#define bFM_ADC0_ADST01_ST11                  *((volatile unsigned char*)(0x424E0604UL))
#define bFM_ADC0_ADST01_ST12                  *((volatile unsigned char*)(0x424E0608UL))
#define bFM_ADC0_ADST01_ST13                  *((volatile unsigned char*)(0x424E060CUL))
#define bFM_ADC0_ADST01_ST14                  *((volatile unsigned char*)(0x424E0610UL))
#define bFM_ADC0_ADST01_STX10                 *((volatile unsigned char*)(0x424E0614UL))
#define bFM_ADC0_ADST01_STX11                 *((volatile unsigned char*)(0x424E0618UL))
#define bFM_ADC0_ADST01_STX12                 *((volatile unsigned char*)(0x424E061CUL))
#define bFM_ADC0_ADST01_ST00                  *((volatile unsigned char*)(0x424E0620UL))
#define bFM_ADC0_ADST01_ST01                  *((volatile unsigned char*)(0x424E0624UL))
#define bFM_ADC0_ADST01_ST02                  *((volatile unsigned char*)(0x424E0628UL))
#define bFM_ADC0_ADST01_ST03                  *((volatile unsigned char*)(0x424E062CUL))
#define bFM_ADC0_ADST01_ST04                  *((volatile unsigned char*)(0x424E0630UL))
#define bFM_ADC0_ADST01_STX00                 *((volatile unsigned char*)(0x424E0634UL))
#define bFM_ADC0_ADST01_STX01                 *((volatile unsigned char*)(0x424E0638UL))
#define bFM_ADC0_ADST01_STX02                 *((volatile unsigned char*)(0x424E063CUL))
#define bFM_ADC0_ADST1_ST10                   *((volatile unsigned char*)(0x424E0600UL))
#define bFM_ADC0_ADST1_ST11                   *((volatile unsigned char*)(0x424E0604UL))
#define bFM_ADC0_ADST1_ST12                   *((volatile unsigned char*)(0x424E0608UL))
#define bFM_ADC0_ADST1_ST13                   *((volatile unsigned char*)(0x424E060CUL))
#define bFM_ADC0_ADST1_ST14                   *((volatile unsigned char*)(0x424E0610UL))
#define bFM_ADC0_ADST1_STX10                  *((volatile unsigned char*)(0x424E0614UL))
#define bFM_ADC0_ADST1_STX11                  *((volatile unsigned char*)(0x424E0618UL))
#define bFM_ADC0_ADST1_STX12                  *((volatile unsigned char*)(0x424E061CUL))
#define bFM_ADC0_ADST0_ST00                   *((volatile unsigned char*)(0x424E0620UL))
#define bFM_ADC0_ADST0_ST01                   *((volatile unsigned char*)(0x424E0624UL))
#define bFM_ADC0_ADST0_ST02                   *((volatile unsigned char*)(0x424E0628UL))
#define bFM_ADC0_ADST0_ST03                   *((volatile unsigned char*)(0x424E062CUL))
#define bFM_ADC0_ADST0_ST04                   *((volatile unsigned char*)(0x424E0630UL))
#define bFM_ADC0_ADST0_STX00                  *((volatile unsigned char*)(0x424E0634UL))
#define bFM_ADC0_ADST0_STX01                  *((volatile unsigned char*)(0x424E0638UL))
#define bFM_ADC0_ADST0_STX02                  *((volatile unsigned char*)(0x424E063CUL))
#define bFM_ADC0_ADCT_CT0                     *((volatile unsigned char*)(0x424E0680UL))
#define bFM_ADC0_ADCT_CT1                     *((volatile unsigned char*)(0x424E0684UL))
#define bFM_ADC0_ADCT_CT2                     *((volatile unsigned char*)(0x424E0688UL))
#define bFM_ADC0_PRTSL_PRTSL0                 *((volatile unsigned char*)(0x424E0700UL))
#define bFM_ADC0_PRTSL_PRTSL1                 *((volatile unsigned char*)(0x424E0704UL))
#define bFM_ADC0_PRTSL_PRTSL2                 *((volatile unsigned char*)(0x424E0708UL))
#define bFM_ADC0_PRTSL_PRTSL3                 *((volatile unsigned char*)(0x424E070CUL))
#define bFM_ADC0_SCTSL_SCTSL0                 *((volatile unsigned char*)(0x424E0720UL))
#define bFM_ADC0_SCTSL_SCTSL1                 *((volatile unsigned char*)(0x424E0724UL))
#define bFM_ADC0_SCTSL_SCTSL2                 *((volatile unsigned char*)(0x424E0728UL))
#define bFM_ADC0_SCTSL_SCTSL3                 *((volatile unsigned char*)(0x424E072CUL))
#define bFM_ADC0_ADCEN_ENBL                   *((volatile unsigned char*)(0x424E0780UL))
#define bFM_ADC0_ADCEN_READY                  *((volatile unsigned char*)(0x424E0784UL))

/* 12-bit ADC unit 1 registers */
#define bFM_ADC1_ADSR_SCS                     *((volatile unsigned char*)(0x424E2000UL))
#define bFM_ADC1_ADSR_PCS                     *((volatile unsigned char*)(0x424E2004UL))
#define bFM_ADC1_ADSR_PCNS                    *((volatile unsigned char*)(0x424E2008UL))
#define bFM_ADC1_ADSR_FDAS                    *((volatile unsigned char*)(0x424E2018UL))
#define bFM_ADC1_ADSR_ADSTP                   *((volatile unsigned char*)(0x424E201CUL))
#define bFM_ADC1_ADCR_OVRIE                   *((volatile unsigned char*)(0x424E2020UL))
#define bFM_ADC1_ADCR_CMPIE                   *((volatile unsigned char*)(0x424E2024UL))
#define bFM_ADC1_ADCR_PCIE                    *((volatile unsigned char*)(0x424E2028UL))
#define bFM_ADC1_ADCR_SCIE                    *((volatile unsigned char*)(0x424E202CUL))
#define bFM_ADC1_ADCR_CMPIF                   *((volatile unsigned char*)(0x424E2034UL))
#define bFM_ADC1_ADCR_PCIF                    *((volatile unsigned char*)(0x424E2038UL))
#define bFM_ADC1_ADCR_SCIF                    *((volatile unsigned char*)(0x424E203CUL))
#define bFM_ADC1_SFNS_SFS0                    *((volatile unsigned char*)(0x424E2100UL))
#define bFM_ADC1_SFNS_SFS1                    *((volatile unsigned char*)(0x424E2104UL))
#define bFM_ADC1_SFNS_SFS2                    *((volatile unsigned char*)(0x424E2108UL))
#define bFM_ADC1_SFNS_SFS3                    *((volatile unsigned char*)(0x424E210CUL))
#define bFM_ADC1_SCCR_SSTR                    *((volatile unsigned char*)(0x424E2120UL))
#define bFM_ADC1_SCCR_SHEN                    *((volatile unsigned char*)(0x424E2124UL))
#define bFM_ADC1_SCCR_RPT                     *((volatile unsigned char*)(0x424E2128UL))
#define bFM_ADC1_SCCR_SFCLR                   *((volatile unsigned char*)(0x424E2130UL))
#define bFM_ADC1_SCCR_SOVR                    *((volatile unsigned char*)(0x424E2134UL))
#define bFM_ADC1_SCCR_SFUL                    *((volatile unsigned char*)(0x424E2138UL))
#define bFM_ADC1_SCCR_SEMP                    *((volatile unsigned char*)(0x424E213CUL))
#define bFM_ADC1_SCFD_SC0                     *((volatile unsigned char*)(0x424E2180UL))
#define bFM_ADC1_SCFD_SC1                     *((volatile unsigned char*)(0x424E2184UL))
#define bFM_ADC1_SCFD_SC2                     *((volatile unsigned char*)(0x424E2188UL))
#define bFM_ADC1_SCFD_SC3                     *((volatile unsigned char*)(0x424E218CUL))
#define bFM_ADC1_SCFD_SC4                     *((volatile unsigned char*)(0x424E2190UL))
#define bFM_ADC1_SCFD_RS0                     *((volatile unsigned char*)(0x424E21A0UL))
#define bFM_ADC1_SCFD_RS1                     *((volatile unsigned char*)(0x424E21A4UL))
#define bFM_ADC1_SCFD_INVL                    *((volatile unsigned char*)(0x424E21B0UL))
#define bFM_ADC1_SCFD_SD0                     *((volatile unsigned char*)(0x424E21D0UL))
#define bFM_ADC1_SCFD_SD1                     *((volatile unsigned char*)(0x424E21D4UL))
#define bFM_ADC1_SCFD_SD2                     *((volatile unsigned char*)(0x424E21D8UL))
#define bFM_ADC1_SCFD_SD3                     *((volatile unsigned char*)(0x424E21DCUL))
#define bFM_ADC1_SCFD_SD4                     *((volatile unsigned char*)(0x424E21E0UL))
#define bFM_ADC1_SCFD_SD5                     *((volatile unsigned char*)(0x424E21E4UL))
#define bFM_ADC1_SCFD_SD6                     *((volatile unsigned char*)(0x424E21E8UL))
#define bFM_ADC1_SCFD_SD7                     *((volatile unsigned char*)(0x424E21ECUL))
#define bFM_ADC1_SCFD_SD8                     *((volatile unsigned char*)(0x424E21F0UL))
#define bFM_ADC1_SCFD_SD9                     *((volatile unsigned char*)(0x424E21F4UL))
#define bFM_ADC1_SCFD_SD10                    *((volatile unsigned char*)(0x424E21F8UL))
#define bFM_ADC1_SCFD_SD11                    *((volatile unsigned char*)(0x424E21FCUL))
#define bFM_ADC1_SCFDL_SC0                    *((volatile unsigned char*)(0x424E2180UL))
#define bFM_ADC1_SCFDL_SC1                    *((volatile unsigned char*)(0x424E2184UL))
#define bFM_ADC1_SCFDL_SC2                    *((volatile unsigned char*)(0x424E2188UL))
#define bFM_ADC1_SCFDL_SC3                    *((volatile unsigned char*)(0x424E218CUL))
#define bFM_ADC1_SCFDL_SC4                    *((volatile unsigned char*)(0x424E2190UL))
#define bFM_ADC1_SCFDL_RS0                    *((volatile unsigned char*)(0x424E21A0UL))
#define bFM_ADC1_SCFDL_RS1                    *((volatile unsigned char*)(0x424E21A4UL))
#define bFM_ADC1_SCFDL_INVL                   *((volatile unsigned char*)(0x424E21B0UL))
#define bFM_ADC1_SCFDH_SD0                    *((volatile unsigned char*)(0x424E21D0UL))
#define bFM_ADC1_SCFDH_SD1                    *((volatile unsigned char*)(0x424E21D4UL))
#define bFM_ADC1_SCFDH_SD2                    *((volatile unsigned char*)(0x424E21D8UL))
#define bFM_ADC1_SCFDH_SD3                    *((volatile unsigned char*)(0x424E21DCUL))
#define bFM_ADC1_SCFDH_SD4                    *((volatile unsigned char*)(0x424E21E0UL))
#define bFM_ADC1_SCFDH_SD5                    *((volatile unsigned char*)(0x424E21E4UL))
#define bFM_ADC1_SCFDH_SD6                    *((volatile unsigned char*)(0x424E21E8UL))
#define bFM_ADC1_SCFDH_SD7                    *((volatile unsigned char*)(0x424E21ECUL))
#define bFM_ADC1_SCFDH_SD8                    *((volatile unsigned char*)(0x424E21F0UL))
#define bFM_ADC1_SCFDH_SD9                    *((volatile unsigned char*)(0x424E21F4UL))
#define bFM_ADC1_SCFDH_SD10                   *((volatile unsigned char*)(0x424E21F8UL))
#define bFM_ADC1_SCFDH_SD11                   *((volatile unsigned char*)(0x424E21FCUL))
#define bFM_ADC1_SCIS23_AN16                  *((volatile unsigned char*)(0x424E2200UL))
#define bFM_ADC1_SCIS23_AN17                  *((volatile unsigned char*)(0x424E2204UL))
#define bFM_ADC1_SCIS23_AN18                  *((volatile unsigned char*)(0x424E2208UL))
#define bFM_ADC1_SCIS23_AN19                  *((volatile unsigned char*)(0x424E220CUL))
#define bFM_ADC1_SCIS23_AN20                  *((volatile unsigned char*)(0x424E2210UL))
#define bFM_ADC1_SCIS23_AN21                  *((volatile unsigned char*)(0x424E2214UL))
#define bFM_ADC1_SCIS23_AN22                  *((volatile unsigned char*)(0x424E2218UL))
#define bFM_ADC1_SCIS23_AN23                  *((volatile unsigned char*)(0x424E221CUL))
#define bFM_ADC1_SCIS23_AN24                  *((volatile unsigned char*)(0x424E2220UL))
#define bFM_ADC1_SCIS23_AN25                  *((volatile unsigned char*)(0x424E2224UL))
#define bFM_ADC1_SCIS23_AN26                  *((volatile unsigned char*)(0x424E2228UL))
#define bFM_ADC1_SCIS23_AN27                  *((volatile unsigned char*)(0x424E222CUL))
#define bFM_ADC1_SCIS23_AN28                  *((volatile unsigned char*)(0x424E2230UL))
#define bFM_ADC1_SCIS23_AN29                  *((volatile unsigned char*)(0x424E2234UL))
#define bFM_ADC1_SCIS23_AN30                  *((volatile unsigned char*)(0x424E2238UL))
#define bFM_ADC1_SCIS23_AN31                  *((volatile unsigned char*)(0x424E223CUL))
#define bFM_ADC1_SCIS2_AN16                   *((volatile unsigned char*)(0x424E2200UL))
#define bFM_ADC1_SCIS2_AN17                   *((volatile unsigned char*)(0x424E2204UL))
#define bFM_ADC1_SCIS2_AN18                   *((volatile unsigned char*)(0x424E2208UL))
#define bFM_ADC1_SCIS2_AN19                   *((volatile unsigned char*)(0x424E220CUL))
#define bFM_ADC1_SCIS2_AN20                   *((volatile unsigned char*)(0x424E2210UL))
#define bFM_ADC1_SCIS2_AN21                   *((volatile unsigned char*)(0x424E2214UL))
#define bFM_ADC1_SCIS2_AN22                   *((volatile unsigned char*)(0x424E2218UL))
#define bFM_ADC1_SCIS2_AN23                   *((volatile unsigned char*)(0x424E221CUL))
#define bFM_ADC1_SCIS3_AN24                   *((volatile unsigned char*)(0x424E2220UL))
#define bFM_ADC1_SCIS3_AN25                   *((volatile unsigned char*)(0x424E2224UL))
#define bFM_ADC1_SCIS3_AN26                   *((volatile unsigned char*)(0x424E2228UL))
#define bFM_ADC1_SCIS3_AN27                   *((volatile unsigned char*)(0x424E222CUL))
#define bFM_ADC1_SCIS3_AN28                   *((volatile unsigned char*)(0x424E2230UL))
#define bFM_ADC1_SCIS3_AN29                   *((volatile unsigned char*)(0x424E2234UL))
#define bFM_ADC1_SCIS3_AN30                   *((volatile unsigned char*)(0x424E2238UL))
#define bFM_ADC1_SCIS3_AN31                   *((volatile unsigned char*)(0x424E223CUL))
#define bFM_ADC1_SCIS01_AN0                   *((volatile unsigned char*)(0x424E2280UL))
#define bFM_ADC1_SCIS01_AN1                   *((volatile unsigned char*)(0x424E2284UL))
#define bFM_ADC1_SCIS01_AN2                   *((volatile unsigned char*)(0x424E2288UL))
#define bFM_ADC1_SCIS01_AN3                   *((volatile unsigned char*)(0x424E228CUL))
#define bFM_ADC1_SCIS01_AN4                   *((volatile unsigned char*)(0x424E2290UL))
#define bFM_ADC1_SCIS01_AN5                   *((volatile unsigned char*)(0x424E2294UL))
#define bFM_ADC1_SCIS01_AN6                   *((volatile unsigned char*)(0x424E2298UL))
#define bFM_ADC1_SCIS01_AN7                   *((volatile unsigned char*)(0x424E229CUL))
#define bFM_ADC1_SCIS01_AN8                   *((volatile unsigned char*)(0x424E22A0UL))
#define bFM_ADC1_SCIS01_AN9                   *((volatile unsigned char*)(0x424E22A4UL))
#define bFM_ADC1_SCIS01_AN10                  *((volatile unsigned char*)(0x424E22A8UL))
#define bFM_ADC1_SCIS01_AN11                  *((volatile unsigned char*)(0x424E22ACUL))
#define bFM_ADC1_SCIS01_AN12                  *((volatile unsigned char*)(0x424E22B0UL))
#define bFM_ADC1_SCIS01_AN13                  *((volatile unsigned char*)(0x424E22B4UL))
#define bFM_ADC1_SCIS01_AN14                  *((volatile unsigned char*)(0x424E22B8UL))
#define bFM_ADC1_SCIS01_AN15                  *((volatile unsigned char*)(0x424E22BCUL))
#define bFM_ADC1_SCIS0_AN0                    *((volatile unsigned char*)(0x424E2280UL))
#define bFM_ADC1_SCIS0_AN1                    *((volatile unsigned char*)(0x424E2284UL))
#define bFM_ADC1_SCIS0_AN2                    *((volatile unsigned char*)(0x424E2288UL))
#define bFM_ADC1_SCIS0_AN3                    *((volatile unsigned char*)(0x424E228CUL))
#define bFM_ADC1_SCIS0_AN4                    *((volatile unsigned char*)(0x424E2290UL))
#define bFM_ADC1_SCIS0_AN5                    *((volatile unsigned char*)(0x424E2294UL))
#define bFM_ADC1_SCIS0_AN6                    *((volatile unsigned char*)(0x424E2298UL))
#define bFM_ADC1_SCIS0_AN7                    *((volatile unsigned char*)(0x424E229CUL))
#define bFM_ADC1_SCIS1_AN8                    *((volatile unsigned char*)(0x424E22A0UL))
#define bFM_ADC1_SCIS1_AN9                    *((volatile unsigned char*)(0x424E22A4UL))
#define bFM_ADC1_SCIS1_AN10                   *((volatile unsigned char*)(0x424E22A8UL))
#define bFM_ADC1_SCIS1_AN11                   *((volatile unsigned char*)(0x424E22ACUL))
#define bFM_ADC1_SCIS1_AN12                   *((volatile unsigned char*)(0x424E22B0UL))
#define bFM_ADC1_SCIS1_AN13                   *((volatile unsigned char*)(0x424E22B4UL))
#define bFM_ADC1_SCIS1_AN14                   *((volatile unsigned char*)(0x424E22B8UL))
#define bFM_ADC1_SCIS1_AN15                   *((volatile unsigned char*)(0x424E22BCUL))
#define bFM_ADC1_PFNS_PFS0                    *((volatile unsigned char*)(0x424E2300UL))
#define bFM_ADC1_PFNS_PFS1                    *((volatile unsigned char*)(0x424E2304UL))
#define bFM_ADC1_PFNS_TEST0                   *((volatile unsigned char*)(0x424E2310UL))
#define bFM_ADC1_PFNS_TEST1                   *((volatile unsigned char*)(0x424E2314UL))
#define bFM_ADC1_PCCR_PSTR                    *((volatile unsigned char*)(0x424E2320UL))
#define bFM_ADC1_PCCR_PHEN                    *((volatile unsigned char*)(0x424E2324UL))
#define bFM_ADC1_PCCR_PEEN                    *((volatile unsigned char*)(0x424E2328UL))
#define bFM_ADC1_PCCR_ESCE                    *((volatile unsigned char*)(0x424E232CUL))
#define bFM_ADC1_PCCR_PFCLR                   *((volatile unsigned char*)(0x424E2330UL))
#define bFM_ADC1_PCCR_POVR                    *((volatile unsigned char*)(0x424E2334UL))
#define bFM_ADC1_PCCR_PFUL                    *((volatile unsigned char*)(0x424E2338UL))
#define bFM_ADC1_PCCR_PEMP                    *((volatile unsigned char*)(0x424E233CUL))
#define bFM_ADC1_PCFD_PC0                     *((volatile unsigned char*)(0x424E2380UL))
#define bFM_ADC1_PCFD_PC1                     *((volatile unsigned char*)(0x424E2384UL))
#define bFM_ADC1_PCFD_PC2                     *((volatile unsigned char*)(0x424E2388UL))
#define bFM_ADC1_PCFD_PC3                     *((volatile unsigned char*)(0x424E238CUL))
#define bFM_ADC1_PCFD_PC4                     *((volatile unsigned char*)(0x424E2390UL))
#define bFM_ADC1_PCFD_RS0                     *((volatile unsigned char*)(0x424E23A0UL))
#define bFM_ADC1_PCFD_RS1                     *((volatile unsigned char*)(0x424E23A4UL))
#define bFM_ADC1_PCFD_RS2                     *((volatile unsigned char*)(0x424E23A8UL))
#define bFM_ADC1_PCFD_INVL                    *((volatile unsigned char*)(0x424E23B0UL))
#define bFM_ADC1_PCFD_PD0                     *((volatile unsigned char*)(0x424E23D0UL))
#define bFM_ADC1_PCFD_PD1                     *((volatile unsigned char*)(0x424E23D4UL))
#define bFM_ADC1_PCFD_PD2                     *((volatile unsigned char*)(0x424E23D8UL))
#define bFM_ADC1_PCFD_PD3                     *((volatile unsigned char*)(0x424E23DCUL))
#define bFM_ADC1_PCFD_PD4                     *((volatile unsigned char*)(0x424E23E0UL))
#define bFM_ADC1_PCFD_PD5                     *((volatile unsigned char*)(0x424E23E4UL))
#define bFM_ADC1_PCFD_PD6                     *((volatile unsigned char*)(0x424E23E8UL))
#define bFM_ADC1_PCFD_PD7                     *((volatile unsigned char*)(0x424E23ECUL))
#define bFM_ADC1_PCFD_PD8                     *((volatile unsigned char*)(0x424E23F0UL))
#define bFM_ADC1_PCFD_PD9                     *((volatile unsigned char*)(0x424E23F4UL))
#define bFM_ADC1_PCFD_PD10                    *((volatile unsigned char*)(0x424E23F8UL))
#define bFM_ADC1_PCFD_PD11                    *((volatile unsigned char*)(0x424E23FCUL))
#define bFM_ADC1_PCFDL_PC0                    *((volatile unsigned char*)(0x424E2380UL))
#define bFM_ADC1_PCFDL_PC1                    *((volatile unsigned char*)(0x424E2384UL))
#define bFM_ADC1_PCFDL_PC2                    *((volatile unsigned char*)(0x424E2388UL))
#define bFM_ADC1_PCFDL_PC3                    *((volatile unsigned char*)(0x424E238CUL))
#define bFM_ADC1_PCFDL_PC4                    *((volatile unsigned char*)(0x424E2390UL))
#define bFM_ADC1_PCFDL_RS0                    *((volatile unsigned char*)(0x424E23A0UL))
#define bFM_ADC1_PCFDL_RS1                    *((volatile unsigned char*)(0x424E23A4UL))
#define bFM_ADC1_PCFDL_RS2                    *((volatile unsigned char*)(0x424E23A8UL))
#define bFM_ADC1_PCFDL_INVL                   *((volatile unsigned char*)(0x424E23B0UL))
#define bFM_ADC1_PCFDH_PD0                    *((volatile unsigned char*)(0x424E23D0UL))
#define bFM_ADC1_PCFDH_PD1                    *((volatile unsigned char*)(0x424E23D4UL))
#define bFM_ADC1_PCFDH_PD2                    *((volatile unsigned char*)(0x424E23D8UL))
#define bFM_ADC1_PCFDH_PD3                    *((volatile unsigned char*)(0x424E23DCUL))
#define bFM_ADC1_PCFDH_PD4                    *((volatile unsigned char*)(0x424E23E0UL))
#define bFM_ADC1_PCFDH_PD5                    *((volatile unsigned char*)(0x424E23E4UL))
#define bFM_ADC1_PCFDH_PD6                    *((volatile unsigned char*)(0x424E23E8UL))
#define bFM_ADC1_PCFDH_PD7                    *((volatile unsigned char*)(0x424E23ECUL))
#define bFM_ADC1_PCFDH_PD8                    *((volatile unsigned char*)(0x424E23F0UL))
#define bFM_ADC1_PCFDH_PD9                    *((volatile unsigned char*)(0x424E23F4UL))
#define bFM_ADC1_PCFDH_PD10                   *((volatile unsigned char*)(0x424E23F8UL))
#define bFM_ADC1_PCFDH_PD11                   *((volatile unsigned char*)(0x424E23FCUL))
#define bFM_ADC1_PCIS_P1A0                    *((volatile unsigned char*)(0x424E2400UL))
#define bFM_ADC1_PCIS_P1A1                    *((volatile unsigned char*)(0x424E2404UL))
#define bFM_ADC1_PCIS_P1A2                    *((volatile unsigned char*)(0x424E2408UL))
#define bFM_ADC1_PCIS_P2A0                    *((volatile unsigned char*)(0x424E240CUL))
#define bFM_ADC1_PCIS_P2A1                    *((volatile unsigned char*)(0x424E2410UL))
#define bFM_ADC1_PCIS_P2A2                    *((volatile unsigned char*)(0x424E2414UL))
#define bFM_ADC1_PCIS_P2A3                    *((volatile unsigned char*)(0x424E2418UL))
#define bFM_ADC1_PCIS_P2A4                    *((volatile unsigned char*)(0x424E241CUL))
#define bFM_ADC1_CMPCR_CCH0                   *((volatile unsigned char*)(0x424E2480UL))
#define bFM_ADC1_CMPCR_CCH1                   *((volatile unsigned char*)(0x424E2484UL))
#define bFM_ADC1_CMPCR_CCH2                   *((volatile unsigned char*)(0x424E2488UL))
#define bFM_ADC1_CMPCR_CCH3                   *((volatile unsigned char*)(0x424E248CUL))
#define bFM_ADC1_CMPCR_CCH4                   *((volatile unsigned char*)(0x424E2490UL))
#define bFM_ADC1_CMPCR_CMD0                   *((volatile unsigned char*)(0x424E2494UL))
#define bFM_ADC1_CMPCR_CMD1                   *((volatile unsigned char*)(0x424E2498UL))
#define bFM_ADC1_CMPCR_CMPEN                  *((volatile unsigned char*)(0x424E249CUL))
#define bFM_ADC1_CMPD_CMAD2                   *((volatile unsigned char*)(0x424E24D8UL))
#define bFM_ADC1_CMPD_CMAD3                   *((volatile unsigned char*)(0x424E24DCUL))
#define bFM_ADC1_CMPD_CMAD4                   *((volatile unsigned char*)(0x424E24E0UL))
#define bFM_ADC1_CMPD_CMAD5                   *((volatile unsigned char*)(0x424E24E4UL))
#define bFM_ADC1_CMPD_CMAD6                   *((volatile unsigned char*)(0x424E24E8UL))
#define bFM_ADC1_CMPD_CMAD7                   *((volatile unsigned char*)(0x424E24ECUL))
#define bFM_ADC1_CMPD_CMAD8                   *((volatile unsigned char*)(0x424E24F0UL))
#define bFM_ADC1_CMPD_CMAD9                   *((volatile unsigned char*)(0x424E24F4UL))
#define bFM_ADC1_CMPD_CMAD10                  *((volatile unsigned char*)(0x424E24F8UL))
#define bFM_ADC1_CMPD_CMAD11                  *((volatile unsigned char*)(0x424E24FCUL))
#define bFM_ADC1_ADSS23_TS16                  *((volatile unsigned char*)(0x424E2500UL))
#define bFM_ADC1_ADSS23_TS17                  *((volatile unsigned char*)(0x424E2504UL))
#define bFM_ADC1_ADSS23_TS18                  *((volatile unsigned char*)(0x424E2508UL))
#define bFM_ADC1_ADSS23_TS19                  *((volatile unsigned char*)(0x424E250CUL))
#define bFM_ADC1_ADSS23_TS20                  *((volatile unsigned char*)(0x424E2510UL))
#define bFM_ADC1_ADSS23_TS21                  *((volatile unsigned char*)(0x424E2514UL))
#define bFM_ADC1_ADSS23_TS22                  *((volatile unsigned char*)(0x424E2518UL))
#define bFM_ADC1_ADSS23_TS23                  *((volatile unsigned char*)(0x424E251CUL))
#define bFM_ADC1_ADSS23_TS24                  *((volatile unsigned char*)(0x424E2520UL))
#define bFM_ADC1_ADSS23_TS25                  *((volatile unsigned char*)(0x424E2524UL))
#define bFM_ADC1_ADSS23_TS26                  *((volatile unsigned char*)(0x424E2528UL))
#define bFM_ADC1_ADSS23_TS27                  *((volatile unsigned char*)(0x424E252CUL))
#define bFM_ADC1_ADSS23_TS28                  *((volatile unsigned char*)(0x424E2530UL))
#define bFM_ADC1_ADSS23_TS29                  *((volatile unsigned char*)(0x424E2534UL))
#define bFM_ADC1_ADSS23_TS30                  *((volatile unsigned char*)(0x424E2538UL))
#define bFM_ADC1_ADSS23_TS31                  *((volatile unsigned char*)(0x424E253CUL))
#define bFM_ADC1_ADSS2_TS16                   *((volatile unsigned char*)(0x424E2500UL))
#define bFM_ADC1_ADSS2_TS17                   *((volatile unsigned char*)(0x424E2504UL))
#define bFM_ADC1_ADSS2_TS18                   *((volatile unsigned char*)(0x424E2508UL))
#define bFM_ADC1_ADSS2_TS19                   *((volatile unsigned char*)(0x424E250CUL))
#define bFM_ADC1_ADSS2_TS20                   *((volatile unsigned char*)(0x424E2510UL))
#define bFM_ADC1_ADSS2_TS21                   *((volatile unsigned char*)(0x424E2514UL))
#define bFM_ADC1_ADSS2_TS22                   *((volatile unsigned char*)(0x424E2518UL))
#define bFM_ADC1_ADSS2_TS23                   *((volatile unsigned char*)(0x424E251CUL))
#define bFM_ADC1_ADSS3_TS24                   *((volatile unsigned char*)(0x424E2520UL))
#define bFM_ADC1_ADSS3_TS25                   *((volatile unsigned char*)(0x424E2524UL))
#define bFM_ADC1_ADSS3_TS26                   *((volatile unsigned char*)(0x424E2528UL))
#define bFM_ADC1_ADSS3_TS27                   *((volatile unsigned char*)(0x424E252CUL))
#define bFM_ADC1_ADSS3_TS28                   *((volatile unsigned char*)(0x424E2530UL))
#define bFM_ADC1_ADSS3_TS29                   *((volatile unsigned char*)(0x424E2534UL))
#define bFM_ADC1_ADSS3_TS30                   *((volatile unsigned char*)(0x424E2538UL))
#define bFM_ADC1_ADSS3_TS31                   *((volatile unsigned char*)(0x424E253CUL))
#define bFM_ADC1_ADSS01_TS0                   *((volatile unsigned char*)(0x424E2580UL))
#define bFM_ADC1_ADSS01_TS1                   *((volatile unsigned char*)(0x424E2584UL))
#define bFM_ADC1_ADSS01_TS2                   *((volatile unsigned char*)(0x424E2588UL))
#define bFM_ADC1_ADSS01_TS3                   *((volatile unsigned char*)(0x424E258CUL))
#define bFM_ADC1_ADSS01_TS4                   *((volatile unsigned char*)(0x424E2590UL))
#define bFM_ADC1_ADSS01_TS5                   *((volatile unsigned char*)(0x424E2594UL))
#define bFM_ADC1_ADSS01_TS6                   *((volatile unsigned char*)(0x424E2598UL))
#define bFM_ADC1_ADSS01_TS7                   *((volatile unsigned char*)(0x424E259CUL))
#define bFM_ADC1_ADSS01_TS8                   *((volatile unsigned char*)(0x424E25A0UL))
#define bFM_ADC1_ADSS01_TS9                   *((volatile unsigned char*)(0x424E25A4UL))
#define bFM_ADC1_ADSS01_TS10                  *((volatile unsigned char*)(0x424E25A8UL))
#define bFM_ADC1_ADSS01_TS11                  *((volatile unsigned char*)(0x424E25ACUL))
#define bFM_ADC1_ADSS01_TS12                  *((volatile unsigned char*)(0x424E25B0UL))
#define bFM_ADC1_ADSS01_TS13                  *((volatile unsigned char*)(0x424E25B4UL))
#define bFM_ADC1_ADSS01_TS14                  *((volatile unsigned char*)(0x424E25B8UL))
#define bFM_ADC1_ADSS01_TS15                  *((volatile unsigned char*)(0x424E25BCUL))
#define bFM_ADC1_ADSS0_TS0                    *((volatile unsigned char*)(0x424E2580UL))
#define bFM_ADC1_ADSS0_TS1                    *((volatile unsigned char*)(0x424E2584UL))
#define bFM_ADC1_ADSS0_TS2                    *((volatile unsigned char*)(0x424E2588UL))
#define bFM_ADC1_ADSS0_TS3                    *((volatile unsigned char*)(0x424E258CUL))
#define bFM_ADC1_ADSS0_TS4                    *((volatile unsigned char*)(0x424E2590UL))
#define bFM_ADC1_ADSS0_TS5                    *((volatile unsigned char*)(0x424E2594UL))
#define bFM_ADC1_ADSS0_TS6                    *((volatile unsigned char*)(0x424E2598UL))
#define bFM_ADC1_ADSS0_TS7                    *((volatile unsigned char*)(0x424E259CUL))
#define bFM_ADC1_ADSS1_TS8                    *((volatile unsigned char*)(0x424E25A0UL))
#define bFM_ADC1_ADSS1_TS9                    *((volatile unsigned char*)(0x424E25A4UL))
#define bFM_ADC1_ADSS1_TS10                   *((volatile unsigned char*)(0x424E25A8UL))
#define bFM_ADC1_ADSS1_TS11                   *((volatile unsigned char*)(0x424E25ACUL))
#define bFM_ADC1_ADSS1_TS12                   *((volatile unsigned char*)(0x424E25B0UL))
#define bFM_ADC1_ADSS1_TS13                   *((volatile unsigned char*)(0x424E25B4UL))
#define bFM_ADC1_ADSS1_TS14                   *((volatile unsigned char*)(0x424E25B8UL))
#define bFM_ADC1_ADSS1_TS15                   *((volatile unsigned char*)(0x424E25BCUL))
#define bFM_ADC1_ADST01_ST10                  *((volatile unsigned char*)(0x424E2600UL))
#define bFM_ADC1_ADST01_ST11                  *((volatile unsigned char*)(0x424E2604UL))
#define bFM_ADC1_ADST01_ST12                  *((volatile unsigned char*)(0x424E2608UL))
#define bFM_ADC1_ADST01_ST13                  *((volatile unsigned char*)(0x424E260CUL))
#define bFM_ADC1_ADST01_ST14                  *((volatile unsigned char*)(0x424E2610UL))
#define bFM_ADC1_ADST01_STX10                 *((volatile unsigned char*)(0x424E2614UL))
#define bFM_ADC1_ADST01_STX11                 *((volatile unsigned char*)(0x424E2618UL))
#define bFM_ADC1_ADST01_STX12                 *((volatile unsigned char*)(0x424E261CUL))
#define bFM_ADC1_ADST01_ST00                  *((volatile unsigned char*)(0x424E2620UL))
#define bFM_ADC1_ADST01_ST01                  *((volatile unsigned char*)(0x424E2624UL))
#define bFM_ADC1_ADST01_ST02                  *((volatile unsigned char*)(0x424E2628UL))
#define bFM_ADC1_ADST01_ST03                  *((volatile unsigned char*)(0x424E262CUL))
#define bFM_ADC1_ADST01_ST04                  *((volatile unsigned char*)(0x424E2630UL))
#define bFM_ADC1_ADST01_STX00                 *((volatile unsigned char*)(0x424E2634UL))
#define bFM_ADC1_ADST01_STX01                 *((volatile unsigned char*)(0x424E2638UL))
#define bFM_ADC1_ADST01_STX02                 *((volatile unsigned char*)(0x424E263CUL))
#define bFM_ADC1_ADST1_ST10                   *((volatile unsigned char*)(0x424E2600UL))
#define bFM_ADC1_ADST1_ST11                   *((volatile unsigned char*)(0x424E2604UL))
#define bFM_ADC1_ADST1_ST12                   *((volatile unsigned char*)(0x424E2608UL))
#define bFM_ADC1_ADST1_ST13                   *((volatile unsigned char*)(0x424E260CUL))
#define bFM_ADC1_ADST1_ST14                   *((volatile unsigned char*)(0x424E2610UL))
#define bFM_ADC1_ADST1_STX10                  *((volatile unsigned char*)(0x424E2614UL))
#define bFM_ADC1_ADST1_STX11                  *((volatile unsigned char*)(0x424E2618UL))
#define bFM_ADC1_ADST1_STX12                  *((volatile unsigned char*)(0x424E261CUL))
#define bFM_ADC1_ADST0_ST00                   *((volatile unsigned char*)(0x424E2620UL))
#define bFM_ADC1_ADST0_ST01                   *((volatile unsigned char*)(0x424E2624UL))
#define bFM_ADC1_ADST0_ST02                   *((volatile unsigned char*)(0x424E2628UL))
#define bFM_ADC1_ADST0_ST03                   *((volatile unsigned char*)(0x424E262CUL))
#define bFM_ADC1_ADST0_ST04                   *((volatile unsigned char*)(0x424E2630UL))
#define bFM_ADC1_ADST0_STX00                  *((volatile unsigned char*)(0x424E2634UL))
#define bFM_ADC1_ADST0_STX01                  *((volatile unsigned char*)(0x424E2638UL))
#define bFM_ADC1_ADST0_STX02                  *((volatile unsigned char*)(0x424E263CUL))
#define bFM_ADC1_ADCT_CT0                     *((volatile unsigned char*)(0x424E2680UL))
#define bFM_ADC1_ADCT_CT1                     *((volatile unsigned char*)(0x424E2684UL))
#define bFM_ADC1_ADCT_CT2                     *((volatile unsigned char*)(0x424E2688UL))
#define bFM_ADC1_PRTSL_PRTSL0                 *((volatile unsigned char*)(0x424E2700UL))
#define bFM_ADC1_PRTSL_PRTSL1                 *((volatile unsigned char*)(0x424E2704UL))
#define bFM_ADC1_PRTSL_PRTSL2                 *((volatile unsigned char*)(0x424E2708UL))
#define bFM_ADC1_PRTSL_PRTSL3                 *((volatile unsigned char*)(0x424E270CUL))
#define bFM_ADC1_SCTSL_SCTSL0                 *((volatile unsigned char*)(0x424E2720UL))
#define bFM_ADC1_SCTSL_SCTSL1                 *((volatile unsigned char*)(0x424E2724UL))
#define bFM_ADC1_SCTSL_SCTSL2                 *((volatile unsigned char*)(0x424E2728UL))
#define bFM_ADC1_SCTSL_SCTSL3                 *((volatile unsigned char*)(0x424E272CUL))
#define bFM_ADC1_ADCEN_ENBL                   *((volatile unsigned char*)(0x424E2780UL))
#define bFM_ADC1_ADCEN_READY                  *((volatile unsigned char*)(0x424E2784UL))

/* 12-bit ADC unit 2 registers */
#define bFM_ADC2_ADSR_SCS                     *((volatile unsigned char*)(0x424E4000UL))
#define bFM_ADC2_ADSR_PCS                     *((volatile unsigned char*)(0x424E4004UL))
#define bFM_ADC2_ADSR_PCNS                    *((volatile unsigned char*)(0x424E4008UL))
#define bFM_ADC2_ADSR_FDAS                    *((volatile unsigned char*)(0x424E4018UL))
#define bFM_ADC2_ADSR_ADSTP                   *((volatile unsigned char*)(0x424E401CUL))
#define bFM_ADC2_ADCR_OVRIE                   *((volatile unsigned char*)(0x424E4020UL))
#define bFM_ADC2_ADCR_CMPIE                   *((volatile unsigned char*)(0x424E4024UL))
#define bFM_ADC2_ADCR_PCIE                    *((volatile unsigned char*)(0x424E4028UL))
#define bFM_ADC2_ADCR_SCIE                    *((volatile unsigned char*)(0x424E402CUL))
#define bFM_ADC2_ADCR_CMPIF                   *((volatile unsigned char*)(0x424E4034UL))
#define bFM_ADC2_ADCR_PCIF                    *((volatile unsigned char*)(0x424E4038UL))
#define bFM_ADC2_ADCR_SCIF                    *((volatile unsigned char*)(0x424E403CUL))
#define bFM_ADC2_SFNS_SFS0                    *((volatile unsigned char*)(0x424E4100UL))
#define bFM_ADC2_SFNS_SFS1                    *((volatile unsigned char*)(0x424E4104UL))
#define bFM_ADC2_SFNS_SFS2                    *((volatile unsigned char*)(0x424E4108UL))
#define bFM_ADC2_SFNS_SFS3                    *((volatile unsigned char*)(0x424E410CUL))
#define bFM_ADC2_SCCR_SSTR                    *((volatile unsigned char*)(0x424E4120UL))
#define bFM_ADC2_SCCR_SHEN                    *((volatile unsigned char*)(0x424E4124UL))
#define bFM_ADC2_SCCR_RPT                     *((volatile unsigned char*)(0x424E4128UL))
#define bFM_ADC2_SCCR_SFCLR                   *((volatile unsigned char*)(0x424E4130UL))
#define bFM_ADC2_SCCR_SOVR                    *((volatile unsigned char*)(0x424E4134UL))
#define bFM_ADC2_SCCR_SFUL                    *((volatile unsigned char*)(0x424E4138UL))
#define bFM_ADC2_SCCR_SEMP                    *((volatile unsigned char*)(0x424E413CUL))
#define bFM_ADC2_SCFD_SC0                     *((volatile unsigned char*)(0x424E4180UL))
#define bFM_ADC2_SCFD_SC1                     *((volatile unsigned char*)(0x424E4184UL))
#define bFM_ADC2_SCFD_SC2                     *((volatile unsigned char*)(0x424E4188UL))
#define bFM_ADC2_SCFD_SC3                     *((volatile unsigned char*)(0x424E418CUL))
#define bFM_ADC2_SCFD_SC4                     *((volatile unsigned char*)(0x424E4190UL))
#define bFM_ADC2_SCFD_RS0                     *((volatile unsigned char*)(0x424E41A0UL))
#define bFM_ADC2_SCFD_RS1                     *((volatile unsigned char*)(0x424E41A4UL))
#define bFM_ADC2_SCFD_INVL                    *((volatile unsigned char*)(0x424E41B0UL))
#define bFM_ADC2_SCFD_SD0                     *((volatile unsigned char*)(0x424E41D0UL))
#define bFM_ADC2_SCFD_SD1                     *((volatile unsigned char*)(0x424E41D4UL))
#define bFM_ADC2_SCFD_SD2                     *((volatile unsigned char*)(0x424E41D8UL))
#define bFM_ADC2_SCFD_SD3                     *((volatile unsigned char*)(0x424E41DCUL))
#define bFM_ADC2_SCFD_SD4                     *((volatile unsigned char*)(0x424E41E0UL))
#define bFM_ADC2_SCFD_SD5                     *((volatile unsigned char*)(0x424E41E4UL))
#define bFM_ADC2_SCFD_SD6                     *((volatile unsigned char*)(0x424E41E8UL))
#define bFM_ADC2_SCFD_SD7                     *((volatile unsigned char*)(0x424E41ECUL))
#define bFM_ADC2_SCFD_SD8                     *((volatile unsigned char*)(0x424E41F0UL))
#define bFM_ADC2_SCFD_SD9                     *((volatile unsigned char*)(0x424E41F4UL))
#define bFM_ADC2_SCFD_SD10                    *((volatile unsigned char*)(0x424E41F8UL))
#define bFM_ADC2_SCFD_SD11                    *((volatile unsigned char*)(0x424E41FCUL))
#define bFM_ADC2_SCFDL_SC0                    *((volatile unsigned char*)(0x424E4180UL))
#define bFM_ADC2_SCFDL_SC1                    *((volatile unsigned char*)(0x424E4184UL))
#define bFM_ADC2_SCFDL_SC2                    *((volatile unsigned char*)(0x424E4188UL))
#define bFM_ADC2_SCFDL_SC3                    *((volatile unsigned char*)(0x424E418CUL))
#define bFM_ADC2_SCFDL_SC4                    *((volatile unsigned char*)(0x424E4190UL))
#define bFM_ADC2_SCFDL_RS0                    *((volatile unsigned char*)(0x424E41A0UL))
#define bFM_ADC2_SCFDL_RS1                    *((volatile unsigned char*)(0x424E41A4UL))
#define bFM_ADC2_SCFDL_INVL                   *((volatile unsigned char*)(0x424E41B0UL))
#define bFM_ADC2_SCFDH_SD0                    *((volatile unsigned char*)(0x424E41D0UL))
#define bFM_ADC2_SCFDH_SD1                    *((volatile unsigned char*)(0x424E41D4UL))
#define bFM_ADC2_SCFDH_SD2                    *((volatile unsigned char*)(0x424E41D8UL))
#define bFM_ADC2_SCFDH_SD3                    *((volatile unsigned char*)(0x424E41DCUL))
#define bFM_ADC2_SCFDH_SD4                    *((volatile unsigned char*)(0x424E41E0UL))
#define bFM_ADC2_SCFDH_SD5                    *((volatile unsigned char*)(0x424E41E4UL))
#define bFM_ADC2_SCFDH_SD6                    *((volatile unsigned char*)(0x424E41E8UL))
#define bFM_ADC2_SCFDH_SD7                    *((volatile unsigned char*)(0x424E41ECUL))
#define bFM_ADC2_SCFDH_SD8                    *((volatile unsigned char*)(0x424E41F0UL))
#define bFM_ADC2_SCFDH_SD9                    *((volatile unsigned char*)(0x424E41F4UL))
#define bFM_ADC2_SCFDH_SD10                   *((volatile unsigned char*)(0x424E41F8UL))
#define bFM_ADC2_SCFDH_SD11                   *((volatile unsigned char*)(0x424E41FCUL))
#define bFM_ADC2_SCIS23_AN16                  *((volatile unsigned char*)(0x424E4200UL))
#define bFM_ADC2_SCIS23_AN17                  *((volatile unsigned char*)(0x424E4204UL))
#define bFM_ADC2_SCIS23_AN18                  *((volatile unsigned char*)(0x424E4208UL))
#define bFM_ADC2_SCIS23_AN19                  *((volatile unsigned char*)(0x424E420CUL))
#define bFM_ADC2_SCIS23_AN20                  *((volatile unsigned char*)(0x424E4210UL))
#define bFM_ADC2_SCIS23_AN21                  *((volatile unsigned char*)(0x424E4214UL))
#define bFM_ADC2_SCIS23_AN22                  *((volatile unsigned char*)(0x424E4218UL))
#define bFM_ADC2_SCIS23_AN23                  *((volatile unsigned char*)(0x424E421CUL))
#define bFM_ADC2_SCIS23_AN24                  *((volatile unsigned char*)(0x424E4220UL))
#define bFM_ADC2_SCIS23_AN25                  *((volatile unsigned char*)(0x424E4224UL))
#define bFM_ADC2_SCIS23_AN26                  *((volatile unsigned char*)(0x424E4228UL))
#define bFM_ADC2_SCIS23_AN27                  *((volatile unsigned char*)(0x424E422CUL))
#define bFM_ADC2_SCIS23_AN28                  *((volatile unsigned char*)(0x424E4230UL))
#define bFM_ADC2_SCIS23_AN29                  *((volatile unsigned char*)(0x424E4234UL))
#define bFM_ADC2_SCIS23_AN30                  *((volatile unsigned char*)(0x424E4238UL))
#define bFM_ADC2_SCIS23_AN31                  *((volatile unsigned char*)(0x424E423CUL))
#define bFM_ADC2_SCIS2_AN16                   *((volatile unsigned char*)(0x424E4200UL))
#define bFM_ADC2_SCIS2_AN17                   *((volatile unsigned char*)(0x424E4204UL))
#define bFM_ADC2_SCIS2_AN18                   *((volatile unsigned char*)(0x424E4208UL))
#define bFM_ADC2_SCIS2_AN19                   *((volatile unsigned char*)(0x424E420CUL))
#define bFM_ADC2_SCIS2_AN20                   *((volatile unsigned char*)(0x424E4210UL))
#define bFM_ADC2_SCIS2_AN21                   *((volatile unsigned char*)(0x424E4214UL))
#define bFM_ADC2_SCIS2_AN22                   *((volatile unsigned char*)(0x424E4218UL))
#define bFM_ADC2_SCIS2_AN23                   *((volatile unsigned char*)(0x424E421CUL))
#define bFM_ADC2_SCIS3_AN24                   *((volatile unsigned char*)(0x424E4220UL))
#define bFM_ADC2_SCIS3_AN25                   *((volatile unsigned char*)(0x424E4224UL))
#define bFM_ADC2_SCIS3_AN26                   *((volatile unsigned char*)(0x424E4228UL))
#define bFM_ADC2_SCIS3_AN27                   *((volatile unsigned char*)(0x424E422CUL))
#define bFM_ADC2_SCIS3_AN28                   *((volatile unsigned char*)(0x424E4230UL))
#define bFM_ADC2_SCIS3_AN29                   *((volatile unsigned char*)(0x424E4234UL))
#define bFM_ADC2_SCIS3_AN30                   *((volatile unsigned char*)(0x424E4238UL))
#define bFM_ADC2_SCIS3_AN31                   *((volatile unsigned char*)(0x424E423CUL))
#define bFM_ADC2_SCIS01_AN0                   *((volatile unsigned char*)(0x424E4280UL))
#define bFM_ADC2_SCIS01_AN1                   *((volatile unsigned char*)(0x424E4284UL))
#define bFM_ADC2_SCIS01_AN2                   *((volatile unsigned char*)(0x424E4288UL))
#define bFM_ADC2_SCIS01_AN3                   *((volatile unsigned char*)(0x424E428CUL))
#define bFM_ADC2_SCIS01_AN4                   *((volatile unsigned char*)(0x424E4290UL))
#define bFM_ADC2_SCIS01_AN5                   *((volatile unsigned char*)(0x424E4294UL))
#define bFM_ADC2_SCIS01_AN6                   *((volatile unsigned char*)(0x424E4298UL))
#define bFM_ADC2_SCIS01_AN7                   *((volatile unsigned char*)(0x424E429CUL))
#define bFM_ADC2_SCIS01_AN8                   *((volatile unsigned char*)(0x424E42A0UL))
#define bFM_ADC2_SCIS01_AN9                   *((volatile unsigned char*)(0x424E42A4UL))
#define bFM_ADC2_SCIS01_AN10                  *((volatile unsigned char*)(0x424E42A8UL))
#define bFM_ADC2_SCIS01_AN11                  *((volatile unsigned char*)(0x424E42ACUL))
#define bFM_ADC2_SCIS01_AN12                  *((volatile unsigned char*)(0x424E42B0UL))
#define bFM_ADC2_SCIS01_AN13                  *((volatile unsigned char*)(0x424E42B4UL))
#define bFM_ADC2_SCIS01_AN14                  *((volatile unsigned char*)(0x424E42B8UL))
#define bFM_ADC2_SCIS01_AN15                  *((volatile unsigned char*)(0x424E42BCUL))
#define bFM_ADC2_SCIS0_AN0                    *((volatile unsigned char*)(0x424E4280UL))
#define bFM_ADC2_SCIS0_AN1                    *((volatile unsigned char*)(0x424E4284UL))
#define bFM_ADC2_SCIS0_AN2                    *((volatile unsigned char*)(0x424E4288UL))
#define bFM_ADC2_SCIS0_AN3                    *((volatile unsigned char*)(0x424E428CUL))
#define bFM_ADC2_SCIS0_AN4                    *((volatile unsigned char*)(0x424E4290UL))
#define bFM_ADC2_SCIS0_AN5                    *((volatile unsigned char*)(0x424E4294UL))
#define bFM_ADC2_SCIS0_AN6                    *((volatile unsigned char*)(0x424E4298UL))
#define bFM_ADC2_SCIS0_AN7                    *((volatile unsigned char*)(0x424E429CUL))
#define bFM_ADC2_SCIS1_AN8                    *((volatile unsigned char*)(0x424E42A0UL))
#define bFM_ADC2_SCIS1_AN9                    *((volatile unsigned char*)(0x424E42A4UL))
#define bFM_ADC2_SCIS1_AN10                   *((volatile unsigned char*)(0x424E42A8UL))
#define bFM_ADC2_SCIS1_AN11                   *((volatile unsigned char*)(0x424E42ACUL))
#define bFM_ADC2_SCIS1_AN12                   *((volatile unsigned char*)(0x424E42B0UL))
#define bFM_ADC2_SCIS1_AN13                   *((volatile unsigned char*)(0x424E42B4UL))
#define bFM_ADC2_SCIS1_AN14                   *((volatile unsigned char*)(0x424E42B8UL))
#define bFM_ADC2_SCIS1_AN15                   *((volatile unsigned char*)(0x424E42BCUL))
#define bFM_ADC2_PFNS_PFS0                    *((volatile unsigned char*)(0x424E4300UL))
#define bFM_ADC2_PFNS_PFS1                    *((volatile unsigned char*)(0x424E4304UL))
#define bFM_ADC2_PFNS_TEST0                   *((volatile unsigned char*)(0x424E4310UL))
#define bFM_ADC2_PFNS_TEST1                   *((volatile unsigned char*)(0x424E4314UL))
#define bFM_ADC2_PCCR_PSTR                    *((volatile unsigned char*)(0x424E4320UL))
#define bFM_ADC2_PCCR_PHEN                    *((volatile unsigned char*)(0x424E4324UL))
#define bFM_ADC2_PCCR_PEEN                    *((volatile unsigned char*)(0x424E4328UL))
#define bFM_ADC2_PCCR_ESCE                    *((volatile unsigned char*)(0x424E432CUL))
#define bFM_ADC2_PCCR_PFCLR                   *((volatile unsigned char*)(0x424E4330UL))
#define bFM_ADC2_PCCR_POVR                    *((volatile unsigned char*)(0x424E4334UL))
#define bFM_ADC2_PCCR_PFUL                    *((volatile unsigned char*)(0x424E4338UL))
#define bFM_ADC2_PCCR_PEMP                    *((volatile unsigned char*)(0x424E433CUL))
#define bFM_ADC2_PCFD_PC0                     *((volatile unsigned char*)(0x424E4380UL))
#define bFM_ADC2_PCFD_PC1                     *((volatile unsigned char*)(0x424E4384UL))
#define bFM_ADC2_PCFD_PC2                     *((volatile unsigned char*)(0x424E4388UL))
#define bFM_ADC2_PCFD_PC3                     *((volatile unsigned char*)(0x424E438CUL))
#define bFM_ADC2_PCFD_PC4                     *((volatile unsigned char*)(0x424E4390UL))
#define bFM_ADC2_PCFD_RS0                     *((volatile unsigned char*)(0x424E43A0UL))
#define bFM_ADC2_PCFD_RS1                     *((volatile unsigned char*)(0x424E43A4UL))
#define bFM_ADC2_PCFD_RS2                     *((volatile unsigned char*)(0x424E43A8UL))
#define bFM_ADC2_PCFD_INVL                    *((volatile unsigned char*)(0x424E43B0UL))
#define bFM_ADC2_PCFD_PD0                     *((volatile unsigned char*)(0x424E43D0UL))
#define bFM_ADC2_PCFD_PD1                     *((volatile unsigned char*)(0x424E43D4UL))
#define bFM_ADC2_PCFD_PD2                     *((volatile unsigned char*)(0x424E43D8UL))
#define bFM_ADC2_PCFD_PD3                     *((volatile unsigned char*)(0x424E43DCUL))
#define bFM_ADC2_PCFD_PD4                     *((volatile unsigned char*)(0x424E43E0UL))
#define bFM_ADC2_PCFD_PD5                     *((volatile unsigned char*)(0x424E43E4UL))
#define bFM_ADC2_PCFD_PD6                     *((volatile unsigned char*)(0x424E43E8UL))
#define bFM_ADC2_PCFD_PD7                     *((volatile unsigned char*)(0x424E43ECUL))
#define bFM_ADC2_PCFD_PD8                     *((volatile unsigned char*)(0x424E43F0UL))
#define bFM_ADC2_PCFD_PD9                     *((volatile unsigned char*)(0x424E43F4UL))
#define bFM_ADC2_PCFD_PD10                    *((volatile unsigned char*)(0x424E43F8UL))
#define bFM_ADC2_PCFD_PD11                    *((volatile unsigned char*)(0x424E43FCUL))
#define bFM_ADC2_PCFDL_PC0                    *((volatile unsigned char*)(0x424E4380UL))
#define bFM_ADC2_PCFDL_PC1                    *((volatile unsigned char*)(0x424E4384UL))
#define bFM_ADC2_PCFDL_PC2                    *((volatile unsigned char*)(0x424E4388UL))
#define bFM_ADC2_PCFDL_PC3                    *((volatile unsigned char*)(0x424E438CUL))
#define bFM_ADC2_PCFDL_PC4                    *((volatile unsigned char*)(0x424E4390UL))
#define bFM_ADC2_PCFDL_RS0                    *((volatile unsigned char*)(0x424E43A0UL))
#define bFM_ADC2_PCFDL_RS1                    *((volatile unsigned char*)(0x424E43A4UL))
#define bFM_ADC2_PCFDL_RS2                    *((volatile unsigned char*)(0x424E43A8UL))
#define bFM_ADC2_PCFDL_INVL                   *((volatile unsigned char*)(0x424E43B0UL))
#define bFM_ADC2_PCFDH_PD0                    *((volatile unsigned char*)(0x424E43D0UL))
#define bFM_ADC2_PCFDH_PD1                    *((volatile unsigned char*)(0x424E43D4UL))
#define bFM_ADC2_PCFDH_PD2                    *((volatile unsigned char*)(0x424E43D8UL))
#define bFM_ADC2_PCFDH_PD3                    *((volatile unsigned char*)(0x424E43DCUL))
#define bFM_ADC2_PCFDH_PD4                    *((volatile unsigned char*)(0x424E43E0UL))
#define bFM_ADC2_PCFDH_PD5                    *((volatile unsigned char*)(0x424E43E4UL))
#define bFM_ADC2_PCFDH_PD6                    *((volatile unsigned char*)(0x424E43E8UL))
#define bFM_ADC2_PCFDH_PD7                    *((volatile unsigned char*)(0x424E43ECUL))
#define bFM_ADC2_PCFDH_PD8                    *((volatile unsigned char*)(0x424E43F0UL))
#define bFM_ADC2_PCFDH_PD9                    *((volatile unsigned char*)(0x424E43F4UL))
#define bFM_ADC2_PCFDH_PD10                   *((volatile unsigned char*)(0x424E43F8UL))
#define bFM_ADC2_PCFDH_PD11                   *((volatile unsigned char*)(0x424E43FCUL))
#define bFM_ADC2_PCIS_P1A0                    *((volatile unsigned char*)(0x424E4400UL))
#define bFM_ADC2_PCIS_P1A1                    *((volatile unsigned char*)(0x424E4404UL))
#define bFM_ADC2_PCIS_P1A2                    *((volatile unsigned char*)(0x424E4408UL))
#define bFM_ADC2_PCIS_P2A0                    *((volatile unsigned char*)(0x424E440CUL))
#define bFM_ADC2_PCIS_P2A1                    *((volatile unsigned char*)(0x424E4410UL))
#define bFM_ADC2_PCIS_P2A2                    *((volatile unsigned char*)(0x424E4414UL))
#define bFM_ADC2_PCIS_P2A3                    *((volatile unsigned char*)(0x424E4418UL))
#define bFM_ADC2_PCIS_P2A4                    *((volatile unsigned char*)(0x424E441CUL))
#define bFM_ADC2_CMPCR_CCH0                   *((volatile unsigned char*)(0x424E4480UL))
#define bFM_ADC2_CMPCR_CCH1                   *((volatile unsigned char*)(0x424E4484UL))
#define bFM_ADC2_CMPCR_CCH2                   *((volatile unsigned char*)(0x424E4488UL))
#define bFM_ADC2_CMPCR_CCH3                   *((volatile unsigned char*)(0x424E448CUL))
#define bFM_ADC2_CMPCR_CCH4                   *((volatile unsigned char*)(0x424E4490UL))
#define bFM_ADC2_CMPCR_CMD0                   *((volatile unsigned char*)(0x424E4494UL))
#define bFM_ADC2_CMPCR_CMD1                   *((volatile unsigned char*)(0x424E4498UL))
#define bFM_ADC2_CMPCR_CMPEN                  *((volatile unsigned char*)(0x424E449CUL))
#define bFM_ADC2_CMPD_CMAD2                   *((volatile unsigned char*)(0x424E44D8UL))
#define bFM_ADC2_CMPD_CMAD3                   *((volatile unsigned char*)(0x424E44DCUL))
#define bFM_ADC2_CMPD_CMAD4                   *((volatile unsigned char*)(0x424E44E0UL))
#define bFM_ADC2_CMPD_CMAD5                   *((volatile unsigned char*)(0x424E44E4UL))
#define bFM_ADC2_CMPD_CMAD6                   *((volatile unsigned char*)(0x424E44E8UL))
#define bFM_ADC2_CMPD_CMAD7                   *((volatile unsigned char*)(0x424E44ECUL))
#define bFM_ADC2_CMPD_CMAD8                   *((volatile unsigned char*)(0x424E44F0UL))
#define bFM_ADC2_CMPD_CMAD9                   *((volatile unsigned char*)(0x424E44F4UL))
#define bFM_ADC2_CMPD_CMAD10                  *((volatile unsigned char*)(0x424E44F8UL))
#define bFM_ADC2_CMPD_CMAD11                  *((volatile unsigned char*)(0x424E44FCUL))
#define bFM_ADC2_ADSS23_TS16                  *((volatile unsigned char*)(0x424E4500UL))
#define bFM_ADC2_ADSS23_TS17                  *((volatile unsigned char*)(0x424E4504UL))
#define bFM_ADC2_ADSS23_TS18                  *((volatile unsigned char*)(0x424E4508UL))
#define bFM_ADC2_ADSS23_TS19                  *((volatile unsigned char*)(0x424E450CUL))
#define bFM_ADC2_ADSS23_TS20                  *((volatile unsigned char*)(0x424E4510UL))
#define bFM_ADC2_ADSS23_TS21                  *((volatile unsigned char*)(0x424E4514UL))
#define bFM_ADC2_ADSS23_TS22                  *((volatile unsigned char*)(0x424E4518UL))
#define bFM_ADC2_ADSS23_TS23                  *((volatile unsigned char*)(0x424E451CUL))
#define bFM_ADC2_ADSS23_TS24                  *((volatile unsigned char*)(0x424E4520UL))
#define bFM_ADC2_ADSS23_TS25                  *((volatile unsigned char*)(0x424E4524UL))
#define bFM_ADC2_ADSS23_TS26                  *((volatile unsigned char*)(0x424E4528UL))
#define bFM_ADC2_ADSS23_TS27                  *((volatile unsigned char*)(0x424E452CUL))
#define bFM_ADC2_ADSS23_TS28                  *((volatile unsigned char*)(0x424E4530UL))
#define bFM_ADC2_ADSS23_TS29                  *((volatile unsigned char*)(0x424E4534UL))
#define bFM_ADC2_ADSS23_TS30                  *((volatile unsigned char*)(0x424E4538UL))
#define bFM_ADC2_ADSS23_TS31                  *((volatile unsigned char*)(0x424E453CUL))
#define bFM_ADC2_ADSS2_TS16                   *((volatile unsigned char*)(0x424E4500UL))
#define bFM_ADC2_ADSS2_TS17                   *((volatile unsigned char*)(0x424E4504UL))
#define bFM_ADC2_ADSS2_TS18                   *((volatile unsigned char*)(0x424E4508UL))
#define bFM_ADC2_ADSS2_TS19                   *((volatile unsigned char*)(0x424E450CUL))
#define bFM_ADC2_ADSS2_TS20                   *((volatile unsigned char*)(0x424E4510UL))
#define bFM_ADC2_ADSS2_TS21                   *((volatile unsigned char*)(0x424E4514UL))
#define bFM_ADC2_ADSS2_TS22                   *((volatile unsigned char*)(0x424E4518UL))
#define bFM_ADC2_ADSS2_TS23                   *((volatile unsigned char*)(0x424E451CUL))
#define bFM_ADC2_ADSS3_TS24                   *((volatile unsigned char*)(0x424E4520UL))
#define bFM_ADC2_ADSS3_TS25                   *((volatile unsigned char*)(0x424E4524UL))
#define bFM_ADC2_ADSS3_TS26                   *((volatile unsigned char*)(0x424E4528UL))
#define bFM_ADC2_ADSS3_TS27                   *((volatile unsigned char*)(0x424E452CUL))
#define bFM_ADC2_ADSS3_TS28                   *((volatile unsigned char*)(0x424E4530UL))
#define bFM_ADC2_ADSS3_TS29                   *((volatile unsigned char*)(0x424E4534UL))
#define bFM_ADC2_ADSS3_TS30                   *((volatile unsigned char*)(0x424E4538UL))
#define bFM_ADC2_ADSS3_TS31                   *((volatile unsigned char*)(0x424E453CUL))
#define bFM_ADC2_ADSS01_TS0                   *((volatile unsigned char*)(0x424E4580UL))
#define bFM_ADC2_ADSS01_TS1                   *((volatile unsigned char*)(0x424E4584UL))
#define bFM_ADC2_ADSS01_TS2                   *((volatile unsigned char*)(0x424E4588UL))
#define bFM_ADC2_ADSS01_TS3                   *((volatile unsigned char*)(0x424E458CUL))
#define bFM_ADC2_ADSS01_TS4                   *((volatile unsigned char*)(0x424E4590UL))
#define bFM_ADC2_ADSS01_TS5                   *((volatile unsigned char*)(0x424E4594UL))
#define bFM_ADC2_ADSS01_TS6                   *((volatile unsigned char*)(0x424E4598UL))
#define bFM_ADC2_ADSS01_TS7                   *((volatile unsigned char*)(0x424E459CUL))
#define bFM_ADC2_ADSS01_TS8                   *((volatile unsigned char*)(0x424E45A0UL))
#define bFM_ADC2_ADSS01_TS9                   *((volatile unsigned char*)(0x424E45A4UL))
#define bFM_ADC2_ADSS01_TS10                  *((volatile unsigned char*)(0x424E45A8UL))
#define bFM_ADC2_ADSS01_TS11                  *((volatile unsigned char*)(0x424E45ACUL))
#define bFM_ADC2_ADSS01_TS12                  *((volatile unsigned char*)(0x424E45B0UL))
#define bFM_ADC2_ADSS01_TS13                  *((volatile unsigned char*)(0x424E45B4UL))
#define bFM_ADC2_ADSS01_TS14                  *((volatile unsigned char*)(0x424E45B8UL))
#define bFM_ADC2_ADSS01_TS15                  *((volatile unsigned char*)(0x424E45BCUL))
#define bFM_ADC2_ADSS0_TS0                    *((volatile unsigned char*)(0x424E4580UL))
#define bFM_ADC2_ADSS0_TS1                    *((volatile unsigned char*)(0x424E4584UL))
#define bFM_ADC2_ADSS0_TS2                    *((volatile unsigned char*)(0x424E4588UL))
#define bFM_ADC2_ADSS0_TS3                    *((volatile unsigned char*)(0x424E458CUL))
#define bFM_ADC2_ADSS0_TS4                    *((volatile unsigned char*)(0x424E4590UL))
#define bFM_ADC2_ADSS0_TS5                    *((volatile unsigned char*)(0x424E4594UL))
#define bFM_ADC2_ADSS0_TS6                    *((volatile unsigned char*)(0x424E4598UL))
#define bFM_ADC2_ADSS0_TS7                    *((volatile unsigned char*)(0x424E459CUL))
#define bFM_ADC2_ADSS1_TS8                    *((volatile unsigned char*)(0x424E45A0UL))
#define bFM_ADC2_ADSS1_TS9                    *((volatile unsigned char*)(0x424E45A4UL))
#define bFM_ADC2_ADSS1_TS10                   *((volatile unsigned char*)(0x424E45A8UL))
#define bFM_ADC2_ADSS1_TS11                   *((volatile unsigned char*)(0x424E45ACUL))
#define bFM_ADC2_ADSS1_TS12                   *((volatile unsigned char*)(0x424E45B0UL))
#define bFM_ADC2_ADSS1_TS13                   *((volatile unsigned char*)(0x424E45B4UL))
#define bFM_ADC2_ADSS1_TS14                   *((volatile unsigned char*)(0x424E45B8UL))
#define bFM_ADC2_ADSS1_TS15                   *((volatile unsigned char*)(0x424E45BCUL))
#define bFM_ADC2_ADST01_ST10                  *((volatile unsigned char*)(0x424E4600UL))
#define bFM_ADC2_ADST01_ST11                  *((volatile unsigned char*)(0x424E4604UL))
#define bFM_ADC2_ADST01_ST12                  *((volatile unsigned char*)(0x424E4608UL))
#define bFM_ADC2_ADST01_ST13                  *((volatile unsigned char*)(0x424E460CUL))
#define bFM_ADC2_ADST01_ST14                  *((volatile unsigned char*)(0x424E4610UL))
#define bFM_ADC2_ADST01_STX10                 *((volatile unsigned char*)(0x424E4614UL))
#define bFM_ADC2_ADST01_STX11                 *((volatile unsigned char*)(0x424E4618UL))
#define bFM_ADC2_ADST01_STX12                 *((volatile unsigned char*)(0x424E461CUL))
#define bFM_ADC2_ADST01_ST00                  *((volatile unsigned char*)(0x424E4620UL))
#define bFM_ADC2_ADST01_ST01                  *((volatile unsigned char*)(0x424E4624UL))
#define bFM_ADC2_ADST01_ST02                  *((volatile unsigned char*)(0x424E4628UL))
#define bFM_ADC2_ADST01_ST03                  *((volatile unsigned char*)(0x424E462CUL))
#define bFM_ADC2_ADST01_ST04                  *((volatile unsigned char*)(0x424E4630UL))
#define bFM_ADC2_ADST01_STX00                 *((volatile unsigned char*)(0x424E4634UL))
#define bFM_ADC2_ADST01_STX01                 *((volatile unsigned char*)(0x424E4638UL))
#define bFM_ADC2_ADST01_STX02                 *((volatile unsigned char*)(0x424E463CUL))
#define bFM_ADC2_ADST1_ST10                   *((volatile unsigned char*)(0x424E4600UL))
#define bFM_ADC2_ADST1_ST11                   *((volatile unsigned char*)(0x424E4604UL))
#define bFM_ADC2_ADST1_ST12                   *((volatile unsigned char*)(0x424E4608UL))
#define bFM_ADC2_ADST1_ST13                   *((volatile unsigned char*)(0x424E460CUL))
#define bFM_ADC2_ADST1_ST14                   *((volatile unsigned char*)(0x424E4610UL))
#define bFM_ADC2_ADST1_STX10                  *((volatile unsigned char*)(0x424E4614UL))
#define bFM_ADC2_ADST1_STX11                  *((volatile unsigned char*)(0x424E4618UL))
#define bFM_ADC2_ADST1_STX12                  *((volatile unsigned char*)(0x424E461CUL))
#define bFM_ADC2_ADST0_ST00                   *((volatile unsigned char*)(0x424E4620UL))
#define bFM_ADC2_ADST0_ST01                   *((volatile unsigned char*)(0x424E4624UL))
#define bFM_ADC2_ADST0_ST02                   *((volatile unsigned char*)(0x424E4628UL))
#define bFM_ADC2_ADST0_ST03                   *((volatile unsigned char*)(0x424E462CUL))
#define bFM_ADC2_ADST0_ST04                   *((volatile unsigned char*)(0x424E4630UL))
#define bFM_ADC2_ADST0_STX00                  *((volatile unsigned char*)(0x424E4634UL))
#define bFM_ADC2_ADST0_STX01                  *((volatile unsigned char*)(0x424E4638UL))
#define bFM_ADC2_ADST0_STX02                  *((volatile unsigned char*)(0x424E463CUL))
#define bFM_ADC2_ADCT_CT0                     *((volatile unsigned char*)(0x424E4680UL))
#define bFM_ADC2_ADCT_CT1                     *((volatile unsigned char*)(0x424E4684UL))
#define bFM_ADC2_ADCT_CT2                     *((volatile unsigned char*)(0x424E4688UL))
#define bFM_ADC2_PRTSL_PRTSL0                 *((volatile unsigned char*)(0x424E4700UL))
#define bFM_ADC2_PRTSL_PRTSL1                 *((volatile unsigned char*)(0x424E4704UL))
#define bFM_ADC2_PRTSL_PRTSL2                 *((volatile unsigned char*)(0x424E4708UL))
#define bFM_ADC2_PRTSL_PRTSL3                 *((volatile unsigned char*)(0x424E470CUL))
#define bFM_ADC2_SCTSL_SCTSL0                 *((volatile unsigned char*)(0x424E4720UL))
#define bFM_ADC2_SCTSL_SCTSL1                 *((volatile unsigned char*)(0x424E4724UL))
#define bFM_ADC2_SCTSL_SCTSL2                 *((volatile unsigned char*)(0x424E4728UL))
#define bFM_ADC2_SCTSL_SCTSL3                 *((volatile unsigned char*)(0x424E472CUL))
#define bFM_ADC2_ADCEN_ENBL                   *((volatile unsigned char*)(0x424E4780UL))
#define bFM_ADC2_ADCEN_READY                  *((volatile unsigned char*)(0x424E4784UL))

/* CR trimming registers */
#define bFM_CRTRIM_MCR_PSR_CSR0               *((volatile unsigned char*)(0x425C0000UL))
#define bFM_CRTRIM_MCR_PSR_CSR1               *((volatile unsigned char*)(0x425C0004UL))
#define bFM_CRTRIM_MCR_PSR_CSR2               *((volatile unsigned char*)(0x425C0008UL))
#define bFM_CRTRIM_MCR_FTRM_TRD0              *((volatile unsigned char*)(0x425C0080UL))
#define bFM_CRTRIM_MCR_FTRM_TRD1              *((volatile unsigned char*)(0x425C0084UL))
#define bFM_CRTRIM_MCR_FTRM_TRD2              *((volatile unsigned char*)(0x425C0088UL))
#define bFM_CRTRIM_MCR_FTRM_TRD3              *((volatile unsigned char*)(0x425C008CUL))
#define bFM_CRTRIM_MCR_FTRM_TRD4              *((volatile unsigned char*)(0x425C0090UL))
#define bFM_CRTRIM_MCR_FTRM_TRD5              *((volatile unsigned char*)(0x425C0094UL))
#define bFM_CRTRIM_MCR_FTRM_TRD6              *((volatile unsigned char*)(0x425C0098UL))
#define bFM_CRTRIM_MCR_FTRM_TRD7              *((volatile unsigned char*)(0x425C009CUL))
#define bFM_CRTRIM_MCR_FTRM_TRD8              *((volatile unsigned char*)(0x425C00A0UL))
#define bFM_CRTRIM_MCR_FTRM_TRD9              *((volatile unsigned char*)(0x425C00A4UL))
#define bFM_CRTRIM_MCR_TTRM_TRT0              *((volatile unsigned char*)(0x425C0100UL))
#define bFM_CRTRIM_MCR_TTRM_TRT1              *((volatile unsigned char*)(0x425C0104UL))
#define bFM_CRTRIM_MCR_TTRM_TRT2              *((volatile unsigned char*)(0x425C0108UL))
#define bFM_CRTRIM_MCR_TTRM_TRT3              *((volatile unsigned char*)(0x425C010CUL))
#define bFM_CRTRIM_MCR_TTRM_TRT4              *((volatile unsigned char*)(0x425C0110UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK0            *((volatile unsigned int*)(0x425C0180UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK1            *((volatile unsigned int*)(0x425C0184UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK2            *((volatile unsigned int*)(0x425C0188UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK3            *((volatile unsigned int*)(0x425C018CUL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK4            *((volatile unsigned int*)(0x425C0190UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK5            *((volatile unsigned int*)(0x425C0194UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK6            *((volatile unsigned int*)(0x425C0198UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK7            *((volatile unsigned int*)(0x425C019CUL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK8            *((volatile unsigned int*)(0x425C01A0UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK9            *((volatile unsigned int*)(0x425C01A4UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK10           *((volatile unsigned int*)(0x425C01A8UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK11           *((volatile unsigned int*)(0x425C01ACUL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK12           *((volatile unsigned int*)(0x425C01B0UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK13           *((volatile unsigned int*)(0x425C01B4UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK14           *((volatile unsigned int*)(0x425C01B8UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK15           *((volatile unsigned int*)(0x425C01BCUL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK16           *((volatile unsigned int*)(0x425C01C0UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK17           *((volatile unsigned int*)(0x425C01C4UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK18           *((volatile unsigned int*)(0x425C01C8UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK19           *((volatile unsigned int*)(0x425C01CCUL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK20           *((volatile unsigned int*)(0x425C01D0UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK21           *((volatile unsigned int*)(0x425C01D4UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK22           *((volatile unsigned int*)(0x425C01D8UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK23           *((volatile unsigned int*)(0x425C01DCUL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK24           *((volatile unsigned int*)(0x425C01E0UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK25           *((volatile unsigned int*)(0x425C01E4UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK26           *((volatile unsigned int*)(0x425C01E8UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK27           *((volatile unsigned int*)(0x425C01ECUL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK28           *((volatile unsigned int*)(0x425C01F0UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK29           *((volatile unsigned int*)(0x425C01F4UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK30           *((volatile unsigned int*)(0x425C01F8UL))
#define bFM_CRTRIM_MCR_RLR_TRMLCK31           *((volatile unsigned int*)(0x425C01FCUL))

/* External interrupt registers */
#define bFM_EXTI_ENIR_EN0                     *((volatile unsigned char*)(0x42600000UL))
#define bFM_EXTI_ENIR_EN1                     *((volatile unsigned char*)(0x42600004UL))
#define bFM_EXTI_ENIR_EN2                     *((volatile unsigned char*)(0x42600008UL))
#define bFM_EXTI_ENIR_EN3                     *((volatile unsigned char*)(0x4260000CUL))
#define bFM_EXTI_ENIR_EN4                     *((volatile unsigned char*)(0x42600010UL))
#define bFM_EXTI_ENIR_EN5                     *((volatile unsigned char*)(0x42600014UL))
#define bFM_EXTI_ENIR_EN6                     *((volatile unsigned char*)(0x42600018UL))
#define bFM_EXTI_ENIR_EN7                     *((volatile unsigned char*)(0x4260001CUL))
#define bFM_EXTI_ENIR_EN8                     *((volatile unsigned char*)(0x42600020UL))
#define bFM_EXTI_ENIR_EN9                     *((volatile unsigned char*)(0x42600024UL))
#define bFM_EXTI_ENIR_EN10                    *((volatile unsigned char*)(0x42600028UL))
#define bFM_EXTI_ENIR_EN11                    *((volatile unsigned char*)(0x4260002CUL))
#define bFM_EXTI_ENIR_EN12                    *((volatile unsigned char*)(0x42600030UL))
#define bFM_EXTI_ENIR_EN13                    *((volatile unsigned char*)(0x42600034UL))
#define bFM_EXTI_ENIR_EN14                    *((volatile unsigned char*)(0x42600038UL))
#define bFM_EXTI_ENIR_EN15                    *((volatile unsigned char*)(0x4260003CUL))
#define bFM_EXTI_ENIR_EN16                    *((volatile unsigned char*)(0x42600040UL))
#define bFM_EXTI_ENIR_EN17                    *((volatile unsigned char*)(0x42600044UL))
#define bFM_EXTI_ENIR_EN18                    *((volatile unsigned char*)(0x42600048UL))
#define bFM_EXTI_ENIR_EN19                    *((volatile unsigned char*)(0x4260004CUL))
#define bFM_EXTI_ENIR_EN20                    *((volatile unsigned char*)(0x42600050UL))
#define bFM_EXTI_ENIR_EN21                    *((volatile unsigned char*)(0x42600054UL))
#define bFM_EXTI_ENIR_EN22                    *((volatile unsigned char*)(0x42600058UL))
#define bFM_EXTI_ENIR_EN23                    *((volatile unsigned char*)(0x4260005CUL))
#define bFM_EXTI_ENIR_EN24                    *((volatile unsigned char*)(0x42600060UL))
#define bFM_EXTI_ENIR_EN25                    *((volatile unsigned char*)(0x42600064UL))
#define bFM_EXTI_ENIR_EN26                    *((volatile unsigned char*)(0x42600068UL))
#define bFM_EXTI_ENIR_EN27                    *((volatile unsigned char*)(0x4260006CUL))
#define bFM_EXTI_ENIR_EN28                    *((volatile unsigned char*)(0x42600070UL))
#define bFM_EXTI_ENIR_EN29                    *((volatile unsigned char*)(0x42600074UL))
#define bFM_EXTI_ENIR_EN30                    *((volatile unsigned char*)(0x42600078UL))
#define bFM_EXTI_ENIR_EN31                    *((volatile unsigned char*)(0x4260007CUL))
#define bFM_EXTI_EIRR_ER0                     *((volatile unsigned char*)(0x42600080UL))
#define bFM_EXTI_EIRR_ER1                     *((volatile unsigned char*)(0x42600084UL))
#define bFM_EXTI_EIRR_ER2                     *((volatile unsigned char*)(0x42600088UL))
#define bFM_EXTI_EIRR_ER3                     *((volatile unsigned char*)(0x4260008CUL))
#define bFM_EXTI_EIRR_ER4                     *((volatile unsigned char*)(0x42600090UL))
#define bFM_EXTI_EIRR_ER5                     *((volatile unsigned char*)(0x42600094UL))
#define bFM_EXTI_EIRR_ER6                     *((volatile unsigned char*)(0x42600098UL))
#define bFM_EXTI_EIRR_ER7                     *((volatile unsigned char*)(0x4260009CUL))
#define bFM_EXTI_EIRR_ER8                     *((volatile unsigned char*)(0x426000A0UL))
#define bFM_EXTI_EIRR_ER9                     *((volatile unsigned char*)(0x426000A4UL))
#define bFM_EXTI_EIRR_ER10                    *((volatile unsigned char*)(0x426000A8UL))
#define bFM_EXTI_EIRR_ER11                    *((volatile unsigned char*)(0x426000ACUL))
#define bFM_EXTI_EIRR_ER12                    *((volatile unsigned char*)(0x426000B0UL))
#define bFM_EXTI_EIRR_ER13                    *((volatile unsigned char*)(0x426000B4UL))
#define bFM_EXTI_EIRR_ER14                    *((volatile unsigned char*)(0x426000B8UL))
#define bFM_EXTI_EIRR_ER15                    *((volatile unsigned char*)(0x426000BCUL))
#define bFM_EXTI_EIRR_ER16                    *((volatile unsigned char*)(0x426000C0UL))
#define bFM_EXTI_EIRR_ER17                    *((volatile unsigned char*)(0x426000C4UL))
#define bFM_EXTI_EIRR_ER18                    *((volatile unsigned char*)(0x426000C8UL))
#define bFM_EXTI_EIRR_ER19                    *((volatile unsigned char*)(0x426000CCUL))
#define bFM_EXTI_EIRR_ER20                    *((volatile unsigned char*)(0x426000D0UL))
#define bFM_EXTI_EIRR_ER21                    *((volatile unsigned char*)(0x426000D4UL))
#define bFM_EXTI_EIRR_ER22                    *((volatile unsigned char*)(0x426000D8UL))
#define bFM_EXTI_EIRR_ER23                    *((volatile unsigned char*)(0x426000DCUL))
#define bFM_EXTI_EIRR_ER24                    *((volatile unsigned char*)(0x426000E0UL))
#define bFM_EXTI_EIRR_ER25                    *((volatile unsigned char*)(0x426000E4UL))
#define bFM_EXTI_EIRR_ER26                    *((volatile unsigned char*)(0x426000E8UL))
#define bFM_EXTI_EIRR_ER27                    *((volatile unsigned char*)(0x426000ECUL))
#define bFM_EXTI_EIRR_ER28                    *((volatile unsigned char*)(0x426000F0UL))
#define bFM_EXTI_EIRR_ER29                    *((volatile unsigned char*)(0x426000F4UL))
#define bFM_EXTI_EIRR_ER30                    *((volatile unsigned char*)(0x426000F8UL))
#define bFM_EXTI_EIRR_ER31                    *((volatile unsigned char*)(0x426000FCUL))
#define bFM_EXTI_EICL_ECL0                    *((volatile unsigned char*)(0x42600100UL))
#define bFM_EXTI_EICL_ECL1                    *((volatile unsigned char*)(0x42600104UL))
#define bFM_EXTI_EICL_ECL2                    *((volatile unsigned char*)(0x42600108UL))
#define bFM_EXTI_EICL_ECL3                    *((volatile unsigned char*)(0x4260010CUL))
#define bFM_EXTI_EICL_ECL4                    *((volatile unsigned char*)(0x42600110UL))
#define bFM_EXTI_EICL_ECL5                    *((volatile unsigned char*)(0x42600114UL))
#define bFM_EXTI_EICL_ECL6                    *((volatile unsigned char*)(0x42600118UL))
#define bFM_EXTI_EICL_ECL7                    *((volatile unsigned char*)(0x4260011CUL))
#define bFM_EXTI_EICL_ECL8                    *((volatile unsigned char*)(0x42600120UL))
#define bFM_EXTI_EICL_ECL9                    *((volatile unsigned char*)(0x42600124UL))
#define bFM_EXTI_EICL_ECL10                   *((volatile unsigned char*)(0x42600128UL))
#define bFM_EXTI_EICL_ECL11                   *((volatile unsigned char*)(0x4260012CUL))
#define bFM_EXTI_EICL_ECL12                   *((volatile unsigned char*)(0x42600130UL))
#define bFM_EXTI_EICL_ECL13                   *((volatile unsigned char*)(0x42600134UL))
#define bFM_EXTI_EICL_ECL14                   *((volatile unsigned char*)(0x42600138UL))
#define bFM_EXTI_EICL_ECL15                   *((volatile unsigned char*)(0x4260013CUL))
#define bFM_EXTI_EICL_ECL16                   *((volatile unsigned char*)(0x42600140UL))
#define bFM_EXTI_EICL_ECL17                   *((volatile unsigned char*)(0x42600144UL))
#define bFM_EXTI_EICL_ECL18                   *((volatile unsigned char*)(0x42600148UL))
#define bFM_EXTI_EICL_ECL19                   *((volatile unsigned char*)(0x4260014CUL))
#define bFM_EXTI_EICL_ECL20                   *((volatile unsigned char*)(0x42600150UL))
#define bFM_EXTI_EICL_ECL21                   *((volatile unsigned char*)(0x42600154UL))
#define bFM_EXTI_EICL_ECL22                   *((volatile unsigned char*)(0x42600158UL))
#define bFM_EXTI_EICL_ECL23                   *((volatile unsigned char*)(0x4260015CUL))
#define bFM_EXTI_EICL_ECL24                   *((volatile unsigned char*)(0x42600160UL))
#define bFM_EXTI_EICL_ECL25                   *((volatile unsigned char*)(0x42600164UL))
#define bFM_EXTI_EICL_ECL26                   *((volatile unsigned char*)(0x42600168UL))
#define bFM_EXTI_EICL_ECL27                   *((volatile unsigned char*)(0x4260016CUL))
#define bFM_EXTI_EICL_ECL28                   *((volatile unsigned char*)(0x42600170UL))
#define bFM_EXTI_EICL_ECL29                   *((volatile unsigned char*)(0x42600174UL))
#define bFM_EXTI_EICL_ECL30                   *((volatile unsigned char*)(0x42600178UL))
#define bFM_EXTI_EICL_ECL31                   *((volatile unsigned char*)(0x4260017CUL))
#define bFM_EXTI_ELVR_LA0                     *((volatile unsigned char*)(0x42600180UL))
#define bFM_EXTI_ELVR_LB0                     *((volatile unsigned char*)(0x42600184UL))
#define bFM_EXTI_ELVR_LA1                     *((volatile unsigned char*)(0x42600188UL))
#define bFM_EXTI_ELVR_LB1                     *((volatile unsigned char*)(0x4260018CUL))
#define bFM_EXTI_ELVR_LA2                     *((volatile unsigned char*)(0x42600190UL))
#define bFM_EXTI_ELVR_LB2                     *((volatile unsigned char*)(0x42600194UL))
#define bFM_EXTI_ELVR_LA3                     *((volatile unsigned char*)(0x42600198UL))
#define bFM_EXTI_ELVR_LB3                     *((volatile unsigned char*)(0x4260019CUL))
#define bFM_EXTI_ELVR_LA4                     *((volatile unsigned char*)(0x426001A0UL))
#define bFM_EXTI_ELVR_LB4                     *((volatile unsigned char*)(0x426001A4UL))
#define bFM_EXTI_ELVR_LA5                     *((volatile unsigned char*)(0x426001A8UL))
#define bFM_EXTI_ELVR_LB5                     *((volatile unsigned char*)(0x426001ACUL))
#define bFM_EXTI_ELVR_LA6                     *((volatile unsigned char*)(0x426001B0UL))
#define bFM_EXTI_ELVR_LB6                     *((volatile unsigned char*)(0x426001B4UL))
#define bFM_EXTI_ELVR_LA7                     *((volatile unsigned char*)(0x426001B8UL))
#define bFM_EXTI_ELVR_LB7                     *((volatile unsigned char*)(0x426001BCUL))
#define bFM_EXTI_ELVR_LA8                     *((volatile unsigned char*)(0x426001C0UL))
#define bFM_EXTI_ELVR_LB8                     *((volatile unsigned char*)(0x426001C4UL))
#define bFM_EXTI_ELVR_LA9                     *((volatile unsigned char*)(0x426001C8UL))
#define bFM_EXTI_ELVR_LB9                     *((volatile unsigned char*)(0x426001CCUL))
#define bFM_EXTI_ELVR_LA10                    *((volatile unsigned char*)(0x426001D0UL))
#define bFM_EXTI_ELVR_LB10                    *((volatile unsigned char*)(0x426001D4UL))
#define bFM_EXTI_ELVR_LA11                    *((volatile unsigned char*)(0x426001D8UL))
#define bFM_EXTI_ELVR_LB11                    *((volatile unsigned char*)(0x426001DCUL))
#define bFM_EXTI_ELVR_LA12                    *((volatile unsigned char*)(0x426001E0UL))
#define bFM_EXTI_ELVR_LB12                    *((volatile unsigned char*)(0x426001E4UL))
#define bFM_EXTI_ELVR_LA13                    *((volatile unsigned char*)(0x426001E8UL))
#define bFM_EXTI_ELVR_LB13                    *((volatile unsigned char*)(0x426001ECUL))
#define bFM_EXTI_ELVR_LA14                    *((volatile unsigned char*)(0x426001F0UL))
#define bFM_EXTI_ELVR_LB14                    *((volatile unsigned char*)(0x426001F4UL))
#define bFM_EXTI_ELVR_LA15                    *((volatile unsigned char*)(0x426001F8UL))
#define bFM_EXTI_ELVR_LB15                    *((volatile unsigned char*)(0x426001FCUL))
#define bFM_EXTI_ELVR1_LA16                   *((volatile unsigned char*)(0x42600200UL))
#define bFM_EXTI_ELVR1_LB16                   *((volatile unsigned char*)(0x42600204UL))
#define bFM_EXTI_ELVR1_LA17                   *((volatile unsigned char*)(0x42600208UL))
#define bFM_EXTI_ELVR1_LB17                   *((volatile unsigned char*)(0x4260020CUL))
#define bFM_EXTI_ELVR1_LA18                   *((volatile unsigned char*)(0x42600210UL))
#define bFM_EXTI_ELVR1_LB18                   *((volatile unsigned char*)(0x42600214UL))
#define bFM_EXTI_ELVR1_LA19                   *((volatile unsigned char*)(0x42600218UL))
#define bFM_EXTI_ELVR1_LB19                   *((volatile unsigned char*)(0x4260021CUL))
#define bFM_EXTI_ELVR1_LA20                   *((volatile unsigned char*)(0x42600220UL))
#define bFM_EXTI_ELVR1_LB20                   *((volatile unsigned char*)(0x42600224UL))
#define bFM_EXTI_ELVR1_LA21                   *((volatile unsigned char*)(0x42600228UL))
#define bFM_EXTI_ELVR1_LB21                   *((volatile unsigned char*)(0x4260022CUL))
#define bFM_EXTI_ELVR1_LA22                   *((volatile unsigned char*)(0x42600230UL))
#define bFM_EXTI_ELVR1_LB22                   *((volatile unsigned char*)(0x42600234UL))
#define bFM_EXTI_ELVR1_LA23                   *((volatile unsigned char*)(0x42600238UL))
#define bFM_EXTI_ELVR1_LB23                   *((volatile unsigned char*)(0x4260023CUL))
#define bFM_EXTI_ELVR1_LA24                   *((volatile unsigned char*)(0x42600240UL))
#define bFM_EXTI_ELVR1_LB24                   *((volatile unsigned char*)(0x42600244UL))
#define bFM_EXTI_ELVR1_LA25                   *((volatile unsigned char*)(0x42600248UL))
#define bFM_EXTI_ELVR1_LB25                   *((volatile unsigned char*)(0x4260024CUL))
#define bFM_EXTI_ELVR1_LA26                   *((volatile unsigned char*)(0x42600250UL))
#define bFM_EXTI_ELVR1_LB26                   *((volatile unsigned char*)(0x42600254UL))
#define bFM_EXTI_ELVR1_LA27                   *((volatile unsigned char*)(0x42600258UL))
#define bFM_EXTI_ELVR1_LB27                   *((volatile unsigned char*)(0x4260025CUL))
#define bFM_EXTI_ELVR1_LA28                   *((volatile unsigned char*)(0x42600260UL))
#define bFM_EXTI_ELVR1_LB28                   *((volatile unsigned char*)(0x42600264UL))
#define bFM_EXTI_ELVR1_LA29                   *((volatile unsigned char*)(0x42600268UL))
#define bFM_EXTI_ELVR1_LB29                   *((volatile unsigned char*)(0x4260026CUL))
#define bFM_EXTI_ELVR1_LA30                   *((volatile unsigned char*)(0x42600270UL))
#define bFM_EXTI_ELVR1_LB30                   *((volatile unsigned char*)(0x42600274UL))
#define bFM_EXTI_ELVR1_LA31                   *((volatile unsigned char*)(0x42600278UL))
#define bFM_EXTI_ELVR1_LB31                   *((volatile unsigned char*)(0x4260027CUL))
#define bFM_EXTI_NMIRR_NR                     *((volatile unsigned char*)(0x42600280UL))
#define bFM_EXTI_NMICL_NCL                    *((volatile unsigned char*)(0x42600300UL))

/* Interrupt request read registers */
#define bFM_INTREQ_DRQSEL_USBEP1              *((volatile unsigned char*)(0x42620000UL))
#define bFM_INTREQ_DRQSEL_USBEP2              *((volatile unsigned char*)(0x42620004UL))
#define bFM_INTREQ_DRQSEL_USBEP3              *((volatile unsigned char*)(0x42620008UL))
#define bFM_INTREQ_DRQSEL_USBEP4              *((volatile unsigned char*)(0x4262000CUL))
#define bFM_INTREQ_DRQSEL_USBEP5              *((volatile unsigned char*)(0x42620010UL))
#define bFM_INTREQ_DRQSEL_ADCSCAN0            *((volatile unsigned char*)(0x42620014UL))
#define bFM_INTREQ_DRQSEL_ADCSCAN1            *((volatile unsigned char*)(0x42620018UL))
#define bFM_INTREQ_DRQSEL_ADCSCAN2            *((volatile unsigned char*)(0x4262001CUL))
#define bFM_INTREQ_DRQSEL_IRQ0BT0             *((volatile unsigned char*)(0x42620020UL))
#define bFM_INTREQ_DRQSEL_IRQ0BT2             *((volatile unsigned char*)(0x42620024UL))
#define bFM_INTREQ_DRQSEL_IRQ0BT4             *((volatile unsigned char*)(0x42620028UL))
#define bFM_INTREQ_DRQSEL_IRQ0BT6             *((volatile unsigned char*)(0x4262002CUL))
#define bFM_INTREQ_DRQSEL_MFS0RX              *((volatile unsigned char*)(0x42620030UL))
#define bFM_INTREQ_DRQSEL_MFS0TX              *((volatile unsigned char*)(0x42620034UL))
#define bFM_INTREQ_DRQSEL_MFS1RX              *((volatile unsigned char*)(0x42620038UL))
#define bFM_INTREQ_DRQSEL_MFS1TX              *((volatile unsigned char*)(0x4262003CUL))
#define bFM_INTREQ_DRQSEL_MFS2RX              *((volatile unsigned char*)(0x42620040UL))
#define bFM_INTREQ_DRQSEL_MFS2TX              *((volatile unsigned char*)(0x42620044UL))
#define bFM_INTREQ_DRQSEL_MFS3RX              *((volatile unsigned char*)(0x42620048UL))
#define bFM_INTREQ_DRQSEL_MFS3TX              *((volatile unsigned char*)(0x4262004CUL))
#define bFM_INTREQ_DRQSEL_MFS4RX              *((volatile unsigned char*)(0x42620050UL))
#define bFM_INTREQ_DRQSEL_MFS4TX              *((volatile unsigned char*)(0x42620054UL))
#define bFM_INTREQ_DRQSEL_MFS5RX              *((volatile unsigned char*)(0x42620058UL))
#define bFM_INTREQ_DRQSEL_MFS5TX              *((volatile unsigned char*)(0x4262005CUL))
#define bFM_INTREQ_DRQSEL_MFS6RX              *((volatile unsigned char*)(0x42620060UL))
#define bFM_INTREQ_DRQSEL_MFS6TX              *((volatile unsigned char*)(0x42620064UL))
#define bFM_INTREQ_DRQSEL_MFS7RX              *((volatile unsigned char*)(0x42620068UL))
#define bFM_INTREQ_DRQSEL_MFS7TX              *((volatile unsigned char*)(0x4262006CUL))
#define bFM_INTREQ_DRQSEL_EXINT0              *((volatile unsigned char*)(0x42620070UL))
#define bFM_INTREQ_DRQSEL_EXINT1              *((volatile unsigned char*)(0x42620074UL))
#define bFM_INTREQ_DRQSEL_EXINT2              *((volatile unsigned char*)(0x42620078UL))
#define bFM_INTREQ_DRQSEL_EXINT3              *((volatile unsigned char*)(0x4262007CUL))
#define bFM_INTREQ_ODDPKS_ODDPKS0             *((volatile unsigned char*)(0x42620200UL))
#define bFM_INTREQ_ODDPKS_ODDPKS1             *((volatile unsigned char*)(0x42620204UL))
#define bFM_INTREQ_ODDPKS_ODDPKS2             *((volatile unsigned char*)(0x42620208UL))
#define bFM_INTREQ_ODDPKS_ODDPKS3             *((volatile unsigned char*)(0x4262020CUL))
#define bFM_INTREQ_ODDPKS_ODDPKS4             *((volatile unsigned char*)(0x42620210UL))
#define bFM_INTREQ_ODDPKS1_ODDPKS10           *((volatile unsigned char*)(0x42620280UL))
#define bFM_INTREQ_ODDPKS1_ODDPKS11           *((volatile unsigned char*)(0x42620284UL))
#define bFM_INTREQ_ODDPKS1_ODDPKS12           *((volatile unsigned char*)(0x42620288UL))
#define bFM_INTREQ_ODDPKS1_ODDPKS13           *((volatile unsigned char*)(0x4262028CUL))
#define bFM_INTREQ_ODDPKS1_ODDPKS14           *((volatile unsigned char*)(0x42620290UL))
#define bFM_INTREQ_IRQ003SEL_SELIRQ0          *((volatile unsigned char*)(0x42622200UL))
#define bFM_INTREQ_IRQ003SEL_SELIRQ1          *((volatile unsigned char*)(0x42622204UL))
#define bFM_INTREQ_IRQ003SEL_SELIRQ2          *((volatile unsigned char*)(0x42622208UL))
#define bFM_INTREQ_IRQ003SEL_SELIRQ3          *((volatile unsigned char*)(0x4262220CUL))
#define bFM_INTREQ_IRQ003SEL_SELIRQ4          *((volatile unsigned char*)(0x42622210UL))
#define bFM_INTREQ_IRQ003SEL_SELIRQ5          *((volatile unsigned char*)(0x42622214UL))
#define bFM_INTREQ_IRQ003SEL_SELIRQ6          *((volatile unsigned char*)(0x42622218UL))
#define bFM_INTREQ_IRQ003SEL_SELIRQ7          *((volatile unsigned char*)(0x4262221CUL))
#define bFM_INTREQ_IRQ003SEL_SELBIT0          *((volatile unsigned char*)(0x42622240UL))
#define bFM_INTREQ_IRQ003SEL_SELBIT1          *((volatile unsigned char*)(0x42622244UL))
#define bFM_INTREQ_IRQ003SEL_SELBIT2          *((volatile unsigned char*)(0x42622248UL))
#define bFM_INTREQ_IRQ003SEL_SELBIT3          *((volatile unsigned char*)(0x4262224CUL))
#define bFM_INTREQ_IRQ003SEL_SELBIT4          *((volatile unsigned char*)(0x42622250UL))
#define bFM_INTREQ_IRQ003SEL_SELBIT5          *((volatile unsigned char*)(0x42622254UL))
#define bFM_INTREQ_IRQ003SEL_SELBIT6          *((volatile unsigned char*)(0x42622258UL))
#define bFM_INTREQ_IRQ003SEL_SELBIT7          *((volatile unsigned char*)(0x4262225CUL))
#define bFM_INTREQ_IRQ004SEL_SELIRQ0          *((volatile unsigned char*)(0x42622280UL))
#define bFM_INTREQ_IRQ004SEL_SELIRQ1          *((volatile unsigned char*)(0x42622284UL))
#define bFM_INTREQ_IRQ004SEL_SELIRQ2          *((volatile unsigned char*)(0x42622288UL))
#define bFM_INTREQ_IRQ004SEL_SELIRQ3          *((volatile unsigned char*)(0x4262228CUL))
#define bFM_INTREQ_IRQ004SEL_SELIRQ4          *((volatile unsigned char*)(0x42622290UL))
#define bFM_INTREQ_IRQ004SEL_SELIRQ5          *((volatile unsigned char*)(0x42622294UL))
#define bFM_INTREQ_IRQ004SEL_SELIRQ6          *((volatile unsigned char*)(0x42622298UL))
#define bFM_INTREQ_IRQ004SEL_SELIRQ7          *((volatile unsigned char*)(0x4262229CUL))
#define bFM_INTREQ_IRQ004SEL_SELBIT0          *((volatile unsigned char*)(0x426222C0UL))
#define bFM_INTREQ_IRQ004SEL_SELBIT1          *((volatile unsigned char*)(0x426222C4UL))
#define bFM_INTREQ_IRQ004SEL_SELBIT2          *((volatile unsigned char*)(0x426222C8UL))
#define bFM_INTREQ_IRQ004SEL_SELBIT3          *((volatile unsigned char*)(0x426222CCUL))
#define bFM_INTREQ_IRQ004SEL_SELBIT4          *((volatile unsigned char*)(0x426222D0UL))
#define bFM_INTREQ_IRQ004SEL_SELBIT5          *((volatile unsigned char*)(0x426222D4UL))
#define bFM_INTREQ_IRQ004SEL_SELBIT6          *((volatile unsigned char*)(0x426222D8UL))
#define bFM_INTREQ_IRQ004SEL_SELBIT7          *((volatile unsigned char*)(0x426222DCUL))
#define bFM_INTREQ_IRQ005SEL_SELIRQ0          *((volatile unsigned char*)(0x42622300UL))
#define bFM_INTREQ_IRQ005SEL_SELIRQ1          *((volatile unsigned char*)(0x42622304UL))
#define bFM_INTREQ_IRQ005SEL_SELIRQ2          *((volatile unsigned char*)(0x42622308UL))
#define bFM_INTREQ_IRQ005SEL_SELIRQ3          *((volatile unsigned char*)(0x4262230CUL))
#define bFM_INTREQ_IRQ005SEL_SELIRQ4          *((volatile unsigned char*)(0x42622310UL))
#define bFM_INTREQ_IRQ005SEL_SELIRQ5          *((volatile unsigned char*)(0x42622314UL))
#define bFM_INTREQ_IRQ005SEL_SELIRQ6          *((volatile unsigned char*)(0x42622318UL))
#define bFM_INTREQ_IRQ005SEL_SELIRQ7          *((volatile unsigned char*)(0x4262231CUL))
#define bFM_INTREQ_IRQ005SEL_SELBIT0          *((volatile unsigned char*)(0x42622340UL))
#define bFM_INTREQ_IRQ005SEL_SELBIT1          *((volatile unsigned char*)(0x42622344UL))
#define bFM_INTREQ_IRQ005SEL_SELBIT2          *((volatile unsigned char*)(0x42622348UL))
#define bFM_INTREQ_IRQ005SEL_SELBIT3          *((volatile unsigned char*)(0x4262234CUL))
#define bFM_INTREQ_IRQ005SEL_SELBIT4          *((volatile unsigned char*)(0x42622350UL))
#define bFM_INTREQ_IRQ005SEL_SELBIT5          *((volatile unsigned char*)(0x42622354UL))
#define bFM_INTREQ_IRQ005SEL_SELBIT6          *((volatile unsigned char*)(0x42622358UL))
#define bFM_INTREQ_IRQ005SEL_SELBIT7          *((volatile unsigned char*)(0x4262235CUL))
#define bFM_INTREQ_IRQ006SEL_SELIRQ0          *((volatile unsigned char*)(0x42622380UL))
#define bFM_INTREQ_IRQ006SEL_SELIRQ1          *((volatile unsigned char*)(0x42622384UL))
#define bFM_INTREQ_IRQ006SEL_SELIRQ2          *((volatile unsigned char*)(0x42622388UL))
#define bFM_INTREQ_IRQ006SEL_SELIRQ3          *((volatile unsigned char*)(0x4262238CUL))
#define bFM_INTREQ_IRQ006SEL_SELIRQ4          *((volatile unsigned char*)(0x42622390UL))
#define bFM_INTREQ_IRQ006SEL_SELIRQ5          *((volatile unsigned char*)(0x42622394UL))
#define bFM_INTREQ_IRQ006SEL_SELIRQ6          *((volatile unsigned char*)(0x42622398UL))
#define bFM_INTREQ_IRQ006SEL_SELIRQ7          *((volatile unsigned char*)(0x4262239CUL))
#define bFM_INTREQ_IRQ006SEL_SELBIT0          *((volatile unsigned char*)(0x426223C0UL))
#define bFM_INTREQ_IRQ006SEL_SELBIT1          *((volatile unsigned char*)(0x426223C4UL))
#define bFM_INTREQ_IRQ006SEL_SELBIT2          *((volatile unsigned char*)(0x426223C8UL))
#define bFM_INTREQ_IRQ006SEL_SELBIT3          *((volatile unsigned char*)(0x426223CCUL))
#define bFM_INTREQ_IRQ006SEL_SELBIT4          *((volatile unsigned char*)(0x426223D0UL))
#define bFM_INTREQ_IRQ006SEL_SELBIT5          *((volatile unsigned char*)(0x426223D4UL))
#define bFM_INTREQ_IRQ006SEL_SELBIT6          *((volatile unsigned char*)(0x426223D8UL))
#define bFM_INTREQ_IRQ006SEL_SELBIT7          *((volatile unsigned char*)(0x426223DCUL))
#define bFM_INTREQ_IRQ007SEL_SELIRQ0          *((volatile unsigned char*)(0x42622400UL))
#define bFM_INTREQ_IRQ007SEL_SELIRQ1          *((volatile unsigned char*)(0x42622404UL))
#define bFM_INTREQ_IRQ007SEL_SELIRQ2          *((volatile unsigned char*)(0x42622408UL))
#define bFM_INTREQ_IRQ007SEL_SELIRQ3          *((volatile unsigned char*)(0x4262240CUL))
#define bFM_INTREQ_IRQ007SEL_SELIRQ4          *((volatile unsigned char*)(0x42622410UL))
#define bFM_INTREQ_IRQ007SEL_SELIRQ5          *((volatile unsigned char*)(0x42622414UL))
#define bFM_INTREQ_IRQ007SEL_SELIRQ6          *((volatile unsigned char*)(0x42622418UL))
#define bFM_INTREQ_IRQ007SEL_SELIRQ7          *((volatile unsigned char*)(0x4262241CUL))
#define bFM_INTREQ_IRQ007SEL_SELBIT0          *((volatile unsigned char*)(0x42622440UL))
#define bFM_INTREQ_IRQ007SEL_SELBIT1          *((volatile unsigned char*)(0x42622444UL))
#define bFM_INTREQ_IRQ007SEL_SELBIT2          *((volatile unsigned char*)(0x42622448UL))
#define bFM_INTREQ_IRQ007SEL_SELBIT3          *((volatile unsigned char*)(0x4262244CUL))
#define bFM_INTREQ_IRQ007SEL_SELBIT4          *((volatile unsigned char*)(0x42622450UL))
#define bFM_INTREQ_IRQ007SEL_SELBIT5          *((volatile unsigned char*)(0x42622454UL))
#define bFM_INTREQ_IRQ007SEL_SELBIT6          *((volatile unsigned char*)(0x42622458UL))
#define bFM_INTREQ_IRQ007SEL_SELBIT7          *((volatile unsigned char*)(0x4262245CUL))
#define bFM_INTREQ_IRQ008SEL_SELIRQ0          *((volatile unsigned char*)(0x42622480UL))
#define bFM_INTREQ_IRQ008SEL_SELIRQ1          *((volatile unsigned char*)(0x42622484UL))
#define bFM_INTREQ_IRQ008SEL_SELIRQ2          *((volatile unsigned char*)(0x42622488UL))
#define bFM_INTREQ_IRQ008SEL_SELIRQ3          *((volatile unsigned char*)(0x4262248CUL))
#define bFM_INTREQ_IRQ008SEL_SELIRQ4          *((volatile unsigned char*)(0x42622490UL))
#define bFM_INTREQ_IRQ008SEL_SELIRQ5          *((volatile unsigned char*)(0x42622494UL))
#define bFM_INTREQ_IRQ008SEL_SELIRQ6          *((volatile unsigned char*)(0x42622498UL))
#define bFM_INTREQ_IRQ008SEL_SELIRQ7          *((volatile unsigned char*)(0x4262249CUL))
#define bFM_INTREQ_IRQ008SEL_SELBIT0          *((volatile unsigned char*)(0x426224C0UL))
#define bFM_INTREQ_IRQ008SEL_SELBIT1          *((volatile unsigned char*)(0x426224C4UL))
#define bFM_INTREQ_IRQ008SEL_SELBIT2          *((volatile unsigned char*)(0x426224C8UL))
#define bFM_INTREQ_IRQ008SEL_SELBIT3          *((volatile unsigned char*)(0x426224CCUL))
#define bFM_INTREQ_IRQ008SEL_SELBIT4          *((volatile unsigned char*)(0x426224D0UL))
#define bFM_INTREQ_IRQ008SEL_SELBIT5          *((volatile unsigned char*)(0x426224D4UL))
#define bFM_INTREQ_IRQ008SEL_SELBIT6          *((volatile unsigned char*)(0x426224D8UL))
#define bFM_INTREQ_IRQ008SEL_SELBIT7          *((volatile unsigned char*)(0x426224DCUL))
#define bFM_INTREQ_IRQ009SEL_SELIRQ0          *((volatile unsigned char*)(0x42622500UL))
#define bFM_INTREQ_IRQ009SEL_SELIRQ1          *((volatile unsigned char*)(0x42622504UL))
#define bFM_INTREQ_IRQ009SEL_SELIRQ2          *((volatile unsigned char*)(0x42622508UL))
#define bFM_INTREQ_IRQ009SEL_SELIRQ3          *((volatile unsigned char*)(0x4262250CUL))
#define bFM_INTREQ_IRQ009SEL_SELIRQ4          *((volatile unsigned char*)(0x42622510UL))
#define bFM_INTREQ_IRQ009SEL_SELIRQ5          *((volatile unsigned char*)(0x42622514UL))
#define bFM_INTREQ_IRQ009SEL_SELIRQ6          *((volatile unsigned char*)(0x42622518UL))
#define bFM_INTREQ_IRQ009SEL_SELIRQ7          *((volatile unsigned char*)(0x4262251CUL))
#define bFM_INTREQ_IRQ009SEL_SELBIT0          *((volatile unsigned char*)(0x42622540UL))
#define bFM_INTREQ_IRQ009SEL_SELBIT1          *((volatile unsigned char*)(0x42622544UL))
#define bFM_INTREQ_IRQ009SEL_SELBIT2          *((volatile unsigned char*)(0x42622548UL))
#define bFM_INTREQ_IRQ009SEL_SELBIT3          *((volatile unsigned char*)(0x4262254CUL))
#define bFM_INTREQ_IRQ009SEL_SELBIT4          *((volatile unsigned char*)(0x42622550UL))
#define bFM_INTREQ_IRQ009SEL_SELBIT5          *((volatile unsigned char*)(0x42622554UL))
#define bFM_INTREQ_IRQ009SEL_SELBIT6          *((volatile unsigned char*)(0x42622558UL))
#define bFM_INTREQ_IRQ009SEL_SELBIT7          *((volatile unsigned char*)(0x4262255CUL))
#define bFM_INTREQ_IRQ010SEL_SELIRQ0          *((volatile unsigned char*)(0x42622580UL))
#define bFM_INTREQ_IRQ010SEL_SELIRQ1          *((volatile unsigned char*)(0x42622584UL))
#define bFM_INTREQ_IRQ010SEL_SELIRQ2          *((volatile unsigned char*)(0x42622588UL))
#define bFM_INTREQ_IRQ010SEL_SELIRQ3          *((volatile unsigned char*)(0x4262258CUL))
#define bFM_INTREQ_IRQ010SEL_SELIRQ4          *((volatile unsigned char*)(0x42622590UL))
#define bFM_INTREQ_IRQ010SEL_SELIRQ5          *((volatile unsigned char*)(0x42622594UL))
#define bFM_INTREQ_IRQ010SEL_SELIRQ6          *((volatile unsigned char*)(0x42622598UL))
#define bFM_INTREQ_IRQ010SEL_SELIRQ7          *((volatile unsigned char*)(0x4262259CUL))
#define bFM_INTREQ_IRQ010SEL_SELBIT0          *((volatile unsigned char*)(0x426225C0UL))
#define bFM_INTREQ_IRQ010SEL_SELBIT1          *((volatile unsigned char*)(0x426225C4UL))
#define bFM_INTREQ_IRQ010SEL_SELBIT2          *((volatile unsigned char*)(0x426225C8UL))
#define bFM_INTREQ_IRQ010SEL_SELBIT3          *((volatile unsigned char*)(0x426225CCUL))
#define bFM_INTREQ_IRQ010SEL_SELBIT4          *((volatile unsigned char*)(0x426225D0UL))
#define bFM_INTREQ_IRQ010SEL_SELBIT5          *((volatile unsigned char*)(0x426225D4UL))
#define bFM_INTREQ_IRQ010SEL_SELBIT6          *((volatile unsigned char*)(0x426225D8UL))
#define bFM_INTREQ_IRQ010SEL_SELBIT7          *((volatile unsigned char*)(0x426225DCUL))
#define bFM_INTREQ_EXC02MON_NMI               *((volatile unsigned char*)(0x42624000UL))
#define bFM_INTREQ_EXC02MON_HWINT             *((volatile unsigned char*)(0x42624004UL))
#define bFM_INTREQ_IRQ000MON_FCSINT           *((volatile unsigned char*)(0x42624080UL))
#define bFM_INTREQ_IRQ001MON_SWWDTINT         *((volatile unsigned char*)(0x42624100UL))
#define bFM_INTREQ_IRQ002MON_LVDINT           *((volatile unsigned char*)(0x42624180UL))
#define bFM_INTREQ_IRQ003MON_IRQBIT0          *((volatile unsigned char*)(0x42624200UL))
#define bFM_INTREQ_IRQ003MON_IRQBIT1          *((volatile unsigned char*)(0x42624204UL))
#define bFM_INTREQ_IRQ003MON_IRQBIT2          *((volatile unsigned char*)(0x42624208UL))
#define bFM_INTREQ_IRQ003MON_IRQBIT3          *((volatile unsigned char*)(0x4262420CUL))
#define bFM_INTREQ_IRQ003MON_IRQBIT4          *((volatile unsigned char*)(0x42624210UL))
#define bFM_INTREQ_IRQ003MON_IRQBIT5          *((volatile unsigned char*)(0x42624214UL))
#define bFM_INTREQ_IRQ003MON_IRQBIT6          *((volatile unsigned char*)(0x42624218UL))
#define bFM_INTREQ_IRQ003MON_IRQBIT7          *((volatile unsigned char*)(0x4262421CUL))
#define bFM_INTREQ_IRQ004MON_IRQBIT0          *((volatile unsigned char*)(0x42624280UL))
#define bFM_INTREQ_IRQ004MON_IRQBIT1          *((volatile unsigned char*)(0x42624284UL))
#define bFM_INTREQ_IRQ004MON_IRQBIT2          *((volatile unsigned char*)(0x42624288UL))
#define bFM_INTREQ_IRQ004MON_IRQBIT3          *((volatile unsigned char*)(0x4262428CUL))
#define bFM_INTREQ_IRQ004MON_IRQBIT4          *((volatile unsigned char*)(0x42624290UL))
#define bFM_INTREQ_IRQ004MON_IRQBIT5          *((volatile unsigned char*)(0x42624294UL))
#define bFM_INTREQ_IRQ004MON_IRQBIT6          *((volatile unsigned char*)(0x42624298UL))
#define bFM_INTREQ_IRQ004MON_IRQBIT7          *((volatile unsigned char*)(0x4262429CUL))
#define bFM_INTREQ_IRQ005MON_IRQBIT0          *((volatile unsigned char*)(0x42624300UL))
#define bFM_INTREQ_IRQ005MON_IRQBIT1          *((volatile unsigned char*)(0x42624304UL))
#define bFM_INTREQ_IRQ005MON_IRQBIT2          *((volatile unsigned char*)(0x42624308UL))
#define bFM_INTREQ_IRQ005MON_IRQBIT3          *((volatile unsigned char*)(0x4262430CUL))
#define bFM_INTREQ_IRQ005MON_IRQBIT4          *((volatile unsigned char*)(0x42624310UL))
#define bFM_INTREQ_IRQ005MON_IRQBIT5          *((volatile unsigned char*)(0x42624314UL))
#define bFM_INTREQ_IRQ005MON_IRQBIT6          *((volatile unsigned char*)(0x42624318UL))
#define bFM_INTREQ_IRQ005MON_IRQBIT7          *((volatile unsigned char*)(0x4262431CUL))
#define bFM_INTREQ_IRQ006MON_IRQBIT0          *((volatile unsigned char*)(0x42624380UL))
#define bFM_INTREQ_IRQ006MON_IRQBIT1          *((volatile unsigned char*)(0x42624384UL))
#define bFM_INTREQ_IRQ006MON_IRQBIT2          *((volatile unsigned char*)(0x42624388UL))
#define bFM_INTREQ_IRQ006MON_IRQBIT3          *((volatile unsigned char*)(0x4262438CUL))
#define bFM_INTREQ_IRQ006MON_IRQBIT4          *((volatile unsigned char*)(0x42624390UL))
#define bFM_INTREQ_IRQ006MON_IRQBIT5          *((volatile unsigned char*)(0x42624394UL))
#define bFM_INTREQ_IRQ006MON_IRQBIT6          *((volatile unsigned char*)(0x42624398UL))
#define bFM_INTREQ_IRQ006MON_IRQBIT7          *((volatile unsigned char*)(0x4262439CUL))
#define bFM_INTREQ_IRQ007MON_IRQBIT0          *((volatile unsigned char*)(0x42624400UL))
#define bFM_INTREQ_IRQ007MON_IRQBIT1          *((volatile unsigned char*)(0x42624404UL))
#define bFM_INTREQ_IRQ007MON_IRQBIT2          *((volatile unsigned char*)(0x42624408UL))
#define bFM_INTREQ_IRQ007MON_IRQBIT3          *((volatile unsigned char*)(0x4262440CUL))
#define bFM_INTREQ_IRQ007MON_IRQBIT4          *((volatile unsigned char*)(0x42624410UL))
#define bFM_INTREQ_IRQ007MON_IRQBIT5          *((volatile unsigned char*)(0x42624414UL))
#define bFM_INTREQ_IRQ007MON_IRQBIT6          *((volatile unsigned char*)(0x42624418UL))
#define bFM_INTREQ_IRQ007MON_IRQBIT7          *((volatile unsigned char*)(0x4262441CUL))
#define bFM_INTREQ_IRQ008MON_IRQBIT0          *((volatile unsigned char*)(0x42624480UL))
#define bFM_INTREQ_IRQ008MON_IRQBIT1          *((volatile unsigned char*)(0x42624484UL))
#define bFM_INTREQ_IRQ008MON_IRQBIT2          *((volatile unsigned char*)(0x42624488UL))
#define bFM_INTREQ_IRQ008MON_IRQBIT3          *((volatile unsigned char*)(0x4262448CUL))
#define bFM_INTREQ_IRQ008MON_IRQBIT4          *((volatile unsigned char*)(0x42624490UL))
#define bFM_INTREQ_IRQ008MON_IRQBIT5          *((volatile unsigned char*)(0x42624494UL))
#define bFM_INTREQ_IRQ008MON_IRQBIT6          *((volatile unsigned char*)(0x42624498UL))
#define bFM_INTREQ_IRQ008MON_IRQBIT7          *((volatile unsigned char*)(0x4262449CUL))
#define bFM_INTREQ_IRQ009MON_IRQBIT0          *((volatile unsigned char*)(0x42624500UL))
#define bFM_INTREQ_IRQ009MON_IRQBIT1          *((volatile unsigned char*)(0x42624504UL))
#define bFM_INTREQ_IRQ009MON_IRQBIT2          *((volatile unsigned char*)(0x42624508UL))
#define bFM_INTREQ_IRQ009MON_IRQBIT3          *((volatile unsigned char*)(0x4262450CUL))
#define bFM_INTREQ_IRQ009MON_IRQBIT4          *((volatile unsigned char*)(0x42624510UL))
#define bFM_INTREQ_IRQ009MON_IRQBIT5          *((volatile unsigned char*)(0x42624514UL))
#define bFM_INTREQ_IRQ009MON_IRQBIT6          *((volatile unsigned char*)(0x42624518UL))
#define bFM_INTREQ_IRQ009MON_IRQBIT7          *((volatile unsigned char*)(0x4262451CUL))
#define bFM_INTREQ_IRQ010MON_IRQBIT0          *((volatile unsigned char*)(0x42624580UL))
#define bFM_INTREQ_IRQ010MON_IRQBIT1          *((volatile unsigned char*)(0x42624584UL))
#define bFM_INTREQ_IRQ010MON_IRQBIT2          *((volatile unsigned char*)(0x42624588UL))
#define bFM_INTREQ_IRQ010MON_IRQBIT3          *((volatile unsigned char*)(0x4262458CUL))
#define bFM_INTREQ_IRQ010MON_IRQBIT4          *((volatile unsigned char*)(0x42624590UL))
#define bFM_INTREQ_IRQ010MON_IRQBIT5          *((volatile unsigned char*)(0x42624594UL))
#define bFM_INTREQ_IRQ010MON_IRQBIT6          *((volatile unsigned char*)(0x42624598UL))
#define bFM_INTREQ_IRQ010MON_IRQBIT7          *((volatile unsigned char*)(0x4262459CUL))
#define bFM_INTREQ_IRQ011MON_EXTINT           *((volatile unsigned char*)(0x42624600UL))
#define bFM_INTREQ_IRQ012MON_EXTINT           *((volatile unsigned char*)(0x42624680UL))
#define bFM_INTREQ_IRQ013MON_EXTINT           *((volatile unsigned char*)(0x42624700UL))
#define bFM_INTREQ_IRQ014MON_EXTINT           *((volatile unsigned char*)(0x42624780UL))
#define bFM_INTREQ_IRQ015MON_EXTINT           *((volatile unsigned char*)(0x42624800UL))
#define bFM_INTREQ_IRQ016MON_EXTINT           *((volatile unsigned char*)(0x42624880UL))
#define bFM_INTREQ_IRQ017MON_EXTINT           *((volatile unsigned char*)(0x42624900UL))
#define bFM_INTREQ_IRQ018MON_EXTINT           *((volatile unsigned char*)(0x42624980UL))
#define bFM_INTREQ_IRQ019MON_QUDINT0          *((volatile unsigned char*)(0x42624A00UL))
#define bFM_INTREQ_IRQ019MON_QUDINT1          *((volatile unsigned char*)(0x42624A04UL))
#define bFM_INTREQ_IRQ019MON_QUDINT2          *((volatile unsigned char*)(0x42624A08UL))
#define bFM_INTREQ_IRQ019MON_QUDINT3          *((volatile unsigned char*)(0x42624A0CUL))
#define bFM_INTREQ_IRQ019MON_QUDINT4          *((volatile unsigned char*)(0x42624A10UL))
#define bFM_INTREQ_IRQ019MON_QUDINT5          *((volatile unsigned char*)(0x42624A14UL))
#define bFM_INTREQ_IRQ020MON_QUDINT0          *((volatile unsigned char*)(0x42624A80UL))
#define bFM_INTREQ_IRQ020MON_QUDINT1          *((volatile unsigned char*)(0x42624A84UL))
#define bFM_INTREQ_IRQ020MON_QUDINT2          *((volatile unsigned char*)(0x42624A88UL))
#define bFM_INTREQ_IRQ020MON_QUDINT3          *((volatile unsigned char*)(0x42624A8CUL))
#define bFM_INTREQ_IRQ020MON_QUDINT4          *((volatile unsigned char*)(0x42624A90UL))
#define bFM_INTREQ_IRQ020MON_QUDINT5          *((volatile unsigned char*)(0x42624A94UL))
#define bFM_INTREQ_IRQ021MON_WAVEINT0         *((volatile unsigned char*)(0x42624B00UL))
#define bFM_INTREQ_IRQ021MON_WAVEINT1         *((volatile unsigned char*)(0x42624B04UL))
#define bFM_INTREQ_IRQ021MON_WAVEINT2         *((volatile unsigned char*)(0x42624B08UL))
#define bFM_INTREQ_IRQ021MON_WAVEINT3         *((volatile unsigned char*)(0x42624B0CUL))
#define bFM_INTREQ_IRQ022MON_WAVEINT0         *((volatile unsigned char*)(0x42624B80UL))
#define bFM_INTREQ_IRQ022MON_WAVEINT1         *((volatile unsigned char*)(0x42624B84UL))
#define bFM_INTREQ_IRQ022MON_WAVEINT2         *((volatile unsigned char*)(0x42624B88UL))
#define bFM_INTREQ_IRQ022MON_WAVEINT3         *((volatile unsigned char*)(0x42624B8CUL))
#define bFM_INTREQ_IRQ023MON_WAVEINT0         *((volatile unsigned char*)(0x42624C00UL))
#define bFM_INTREQ_IRQ023MON_WAVEINT1         *((volatile unsigned char*)(0x42624C04UL))
#define bFM_INTREQ_IRQ023MON_WAVEINT2         *((volatile unsigned char*)(0x42624C08UL))
#define bFM_INTREQ_IRQ023MON_WAVEINT3         *((volatile unsigned char*)(0x42624C0CUL))
#define bFM_INTREQ_IRQ024MON_FRT_PEAK_INT0    *((volatile unsigned char*)(0x42624C80UL))
#define bFM_INTREQ_IRQ024MON_FRT_PEAK_INT1    *((volatile unsigned char*)(0x42624C84UL))
#define bFM_INTREQ_IRQ024MON_FRT_PEAK_INT2    *((volatile unsigned char*)(0x42624C88UL))
#define bFM_INTREQ_IRQ025MON_FRT_ZERO_INT0    *((volatile unsigned char*)(0x42624D00UL))
#define bFM_INTREQ_IRQ025MON_FRT_ZERO_INT1    *((volatile unsigned char*)(0x42624D04UL))
#define bFM_INTREQ_IRQ025MON_FRT_ZERO_INT2    *((volatile unsigned char*)(0x42624D08UL))
#define bFM_INTREQ_IRQ026MON_ICUINT0          *((volatile unsigned char*)(0x42624D80UL))
#define bFM_INTREQ_IRQ026MON_ICUINT1          *((volatile unsigned char*)(0x42624D84UL))
#define bFM_INTREQ_IRQ026MON_ICUINT2          *((volatile unsigned char*)(0x42624D88UL))
#define bFM_INTREQ_IRQ026MON_ICUINT3          *((volatile unsigned char*)(0x42624D8CUL))
#define bFM_INTREQ_IRQ027MON_OCUINT0          *((volatile unsigned char*)(0x42624E00UL))
#define bFM_INTREQ_IRQ027MON_OCUINT1          *((volatile unsigned char*)(0x42624E04UL))
#define bFM_INTREQ_IRQ027MON_OCUINT2          *((volatile unsigned char*)(0x42624E08UL))
#define bFM_INTREQ_IRQ027MON_OCUINT3          *((volatile unsigned char*)(0x42624E0CUL))
#define bFM_INTREQ_IRQ027MON_OCUINT4          *((volatile unsigned char*)(0x42624E10UL))
#define bFM_INTREQ_IRQ027MON_OCUINT5          *((volatile unsigned char*)(0x42624E14UL))
#define bFM_INTREQ_IRQ028MON_FRT_PEAK_INT0    *((volatile unsigned char*)(0x42624E80UL))
#define bFM_INTREQ_IRQ028MON_FRT_PEAK_INT1    *((volatile unsigned char*)(0x42624E84UL))
#define bFM_INTREQ_IRQ028MON_FRT_PEAK_INT2    *((volatile unsigned char*)(0x42624E88UL))
#define bFM_INTREQ_IRQ029MON_FRT_ZERO_INT0    *((volatile unsigned char*)(0x42624F00UL))
#define bFM_INTREQ_IRQ029MON_FRT_ZERO_INT1    *((volatile unsigned char*)(0x42624F04UL))
#define bFM_INTREQ_IRQ029MON_FRT_ZERO_INT2    *((volatile unsigned char*)(0x42624F08UL))
#define bFM_INTREQ_IRQ030MON_ICUINT0          *((volatile unsigned char*)(0x42624F80UL))
#define bFM_INTREQ_IRQ030MON_ICUINT1          *((volatile unsigned char*)(0x42624F84UL))
#define bFM_INTREQ_IRQ030MON_ICUINT2          *((volatile unsigned char*)(0x42624F88UL))
#define bFM_INTREQ_IRQ030MON_ICUINT3          *((volatile unsigned char*)(0x42624F8CUL))
#define bFM_INTREQ_IRQ031MON_OCUINT0          *((volatile unsigned char*)(0x42625000UL))
#define bFM_INTREQ_IRQ031MON_OCUINT1          *((volatile unsigned char*)(0x42625004UL))
#define bFM_INTREQ_IRQ031MON_OCUINT2          *((volatile unsigned char*)(0x42625008UL))
#define bFM_INTREQ_IRQ031MON_OCUINT3          *((volatile unsigned char*)(0x4262500CUL))
#define bFM_INTREQ_IRQ031MON_OCUINT4          *((volatile unsigned char*)(0x42625010UL))
#define bFM_INTREQ_IRQ031MON_OCUINT5          *((volatile unsigned char*)(0x42625014UL))
#define bFM_INTREQ_IRQ032MON_FRT_PEAK_INT0    *((volatile unsigned char*)(0x42625080UL))
#define bFM_INTREQ_IRQ032MON_FRT_PEAK_INT1    *((volatile unsigned char*)(0x42625084UL))
#define bFM_INTREQ_IRQ032MON_FRT_PEAK_INT2    *((volatile unsigned char*)(0x42625088UL))
#define bFM_INTREQ_IRQ033MON_FRT_ZERO_INT0    *((volatile unsigned char*)(0x42625100UL))
#define bFM_INTREQ_IRQ033MON_FRT_ZERO_INT1    *((volatile unsigned char*)(0x42625104UL))
#define bFM_INTREQ_IRQ033MON_FRT_ZERO_INT2    *((volatile unsigned char*)(0x42625108UL))
#define bFM_INTREQ_IRQ034MON_ICUINT0          *((volatile unsigned char*)(0x42625180UL))
#define bFM_INTREQ_IRQ034MON_ICUINT1          *((volatile unsigned char*)(0x42625184UL))
#define bFM_INTREQ_IRQ034MON_ICUINT2          *((volatile unsigned char*)(0x42625188UL))
#define bFM_INTREQ_IRQ034MON_ICUINT3          *((volatile unsigned char*)(0x4262518CUL))
#define bFM_INTREQ_IRQ035MON_OCUINT0          *((volatile unsigned char*)(0x42625200UL))
#define bFM_INTREQ_IRQ035MON_OCUINT1          *((volatile unsigned char*)(0x42625204UL))
#define bFM_INTREQ_IRQ035MON_OCUINT2          *((volatile unsigned char*)(0x42625208UL))
#define bFM_INTREQ_IRQ035MON_OCUINT3          *((volatile unsigned char*)(0x4262520CUL))
#define bFM_INTREQ_IRQ035MON_OCUINT4          *((volatile unsigned char*)(0x42625210UL))
#define bFM_INTREQ_IRQ035MON_OCUINT5          *((volatile unsigned char*)(0x42625214UL))
#define bFM_INTREQ_IRQ036MON_PPGINT0          *((volatile unsigned char*)(0x42625280UL))
#define bFM_INTREQ_IRQ036MON_PPGINT1          *((volatile unsigned char*)(0x42625284UL))
#define bFM_INTREQ_IRQ036MON_PPGINT2          *((volatile unsigned char*)(0x42625288UL))
#define bFM_INTREQ_IRQ037MON_PPGINT0          *((volatile unsigned char*)(0x42625300UL))
#define bFM_INTREQ_IRQ037MON_PPGINT1          *((volatile unsigned char*)(0x42625304UL))
#define bFM_INTREQ_IRQ037MON_PPGINT2          *((volatile unsigned char*)(0x42625308UL))
#define bFM_INTREQ_IRQ038MON_PPGINT0          *((volatile unsigned char*)(0x42625380UL))
#define bFM_INTREQ_IRQ038MON_PPGINT1          *((volatile unsigned char*)(0x42625384UL))
#define bFM_INTREQ_IRQ038MON_PPGINT2          *((volatile unsigned char*)(0x42625388UL))
#define bFM_INTREQ_IRQ039MON_BTINT0           *((volatile unsigned char*)(0x42625400UL))
#define bFM_INTREQ_IRQ039MON_BTINT1           *((volatile unsigned char*)(0x42625404UL))
#define bFM_INTREQ_IRQ040MON_BTINT0           *((volatile unsigned char*)(0x42625480UL))
#define bFM_INTREQ_IRQ040MON_BTINT1           *((volatile unsigned char*)(0x42625484UL))
#define bFM_INTREQ_IRQ041MON_BTINT0           *((volatile unsigned char*)(0x42625500UL))
#define bFM_INTREQ_IRQ041MON_BTINT1           *((volatile unsigned char*)(0x42625504UL))
#define bFM_INTREQ_IRQ042MON_BTINT0           *((volatile unsigned char*)(0x42625580UL))
#define bFM_INTREQ_IRQ042MON_BTINT1           *((volatile unsigned char*)(0x42625584UL))
#define bFM_INTREQ_IRQ043MON_BTINT0           *((volatile unsigned char*)(0x42625600UL))
#define bFM_INTREQ_IRQ043MON_BTINT1           *((volatile unsigned char*)(0x42625604UL))
#define bFM_INTREQ_IRQ044MON_BTINT0           *((volatile unsigned char*)(0x42625680UL))
#define bFM_INTREQ_IRQ044MON_BTINT1           *((volatile unsigned char*)(0x42625684UL))
#define bFM_INTREQ_IRQ045MON_BTINT0           *((volatile unsigned char*)(0x42625700UL))
#define bFM_INTREQ_IRQ045MON_BTINT1           *((volatile unsigned char*)(0x42625704UL))
#define bFM_INTREQ_IRQ046MON_BTINT0           *((volatile unsigned char*)(0x42625780UL))
#define bFM_INTREQ_IRQ046MON_BTINT1           *((volatile unsigned char*)(0x42625784UL))
#define bFM_INTREQ_IRQ047MON_TIMINT1          *((volatile unsigned char*)(0x42625800UL))
#define bFM_INTREQ_IRQ047MON_TIMINT2          *((volatile unsigned char*)(0x42625804UL))
#define bFM_INTREQ_IRQ048MON_WCINT            *((volatile unsigned char*)(0x42625880UL))
#define bFM_INTREQ_IRQ049MON_BMEMCS           *((volatile unsigned char*)(0x42625900UL))
#define bFM_INTREQ_IRQ050MON_RTCINT           *((volatile unsigned char*)(0x42625980UL))
#define bFM_INTREQ_IRQ051MON_EXTINT           *((volatile unsigned char*)(0x42625A00UL))
#define bFM_INTREQ_IRQ052MON_EXTINT           *((volatile unsigned char*)(0x42625A80UL))
#define bFM_INTREQ_IRQ053MON_EXTINT           *((volatile unsigned char*)(0x42625B00UL))
#define bFM_INTREQ_IRQ054MON_EXTINT           *((volatile unsigned char*)(0x42625B80UL))
#define bFM_INTREQ_IRQ055MON_EXTINT           *((volatile unsigned char*)(0x42625C00UL))
#define bFM_INTREQ_IRQ056MON_EXTINT           *((volatile unsigned char*)(0x42625C80UL))
#define bFM_INTREQ_IRQ057MON_EXTINT           *((volatile unsigned char*)(0x42625D00UL))
#define bFM_INTREQ_IRQ058MON_EXTINT           *((volatile unsigned char*)(0x42625D80UL))
#define bFM_INTREQ_IRQ059MON_MOSCINT          *((volatile unsigned char*)(0x42625E00UL))
#define bFM_INTREQ_IRQ059MON_SOSCINT          *((volatile unsigned char*)(0x42625E04UL))
#define bFM_INTREQ_IRQ059MON_MPLLINT          *((volatile unsigned char*)(0x42625E08UL))
#define bFM_INTREQ_IRQ059MON_UPLLINT          *((volatile unsigned char*)(0x42625E0CUL))
#define bFM_INTREQ_IRQ059MON_IPLLINT          *((volatile unsigned char*)(0x42625E10UL))
#define bFM_INTREQ_IRQ060MON_MFSRINT          *((volatile unsigned char*)(0x42625E80UL))
#define bFM_INTREQ_IRQ061MON_MFSINT0          *((volatile unsigned char*)(0x42625F00UL))
#define bFM_INTREQ_IRQ061MON_MFSINT1          *((volatile unsigned char*)(0x42625F04UL))
#define bFM_INTREQ_IRQ062MON_MFSRINT          *((volatile unsigned char*)(0x42625F80UL))
#define bFM_INTREQ_IRQ063MON_MFSINT0          *((volatile unsigned char*)(0x42626000UL))
#define bFM_INTREQ_IRQ063MON_MFSINT1          *((volatile unsigned char*)(0x42626004UL))
#define bFM_INTREQ_IRQ064MON_MFSRINT          *((volatile unsigned char*)(0x42626080UL))
#define bFM_INTREQ_IRQ065MON_MFSINT0          *((volatile unsigned char*)(0x42626100UL))
#define bFM_INTREQ_IRQ065MON_MFSINT1          *((volatile unsigned char*)(0x42626104UL))
#define bFM_INTREQ_IRQ066MON_MFSRINT          *((volatile unsigned char*)(0x42626180UL))
#define bFM_INTREQ_IRQ067MON_MFSINT0          *((volatile unsigned char*)(0x42626200UL))
#define bFM_INTREQ_IRQ067MON_MFSINT1          *((volatile unsigned char*)(0x42626204UL))
#define bFM_INTREQ_IRQ068MON_MFSRINT          *((volatile unsigned char*)(0x42626280UL))
#define bFM_INTREQ_IRQ069MON_MFSINT0          *((volatile unsigned char*)(0x42626300UL))
#define bFM_INTREQ_IRQ069MON_MFSINT1          *((volatile unsigned char*)(0x42626304UL))
#define bFM_INTREQ_IRQ070MON_MFSRINT          *((volatile unsigned char*)(0x42626380UL))
#define bFM_INTREQ_IRQ071MON_MFSINT0          *((volatile unsigned char*)(0x42626400UL))
#define bFM_INTREQ_IRQ071MON_MFSINT1          *((volatile unsigned char*)(0x42626404UL))
#define bFM_INTREQ_IRQ072MON_MFSRINT          *((volatile unsigned char*)(0x42626480UL))
#define bFM_INTREQ_IRQ073MON_MFSINT0          *((volatile unsigned char*)(0x42626500UL))
#define bFM_INTREQ_IRQ073MON_MFSINT1          *((volatile unsigned char*)(0x42626504UL))
#define bFM_INTREQ_IRQ074MON_MFSRINT          *((volatile unsigned char*)(0x42626580UL))
#define bFM_INTREQ_IRQ075MON_MFSINT0          *((volatile unsigned char*)(0x42626600UL))
#define bFM_INTREQ_IRQ075MON_MFSINT1          *((volatile unsigned char*)(0x42626604UL))
#define bFM_INTREQ_IRQ076MON_ADCINT0          *((volatile unsigned char*)(0x42626680UL))
#define bFM_INTREQ_IRQ076MON_ADCINT1          *((volatile unsigned char*)(0x42626684UL))
#define bFM_INTREQ_IRQ076MON_ADCINT2          *((volatile unsigned char*)(0x42626688UL))
#define bFM_INTREQ_IRQ076MON_ADCINT3          *((volatile unsigned char*)(0x4262668CUL))
#define bFM_INTREQ_IRQ076MON_ADCINT4          *((volatile unsigned char*)(0x42626690UL))
#define bFM_INTREQ_IRQ077MON_ADCINT0          *((volatile unsigned char*)(0x42626700UL))
#define bFM_INTREQ_IRQ077MON_ADCINT1          *((volatile unsigned char*)(0x42626704UL))
#define bFM_INTREQ_IRQ077MON_ADCINT2          *((volatile unsigned char*)(0x42626708UL))
#define bFM_INTREQ_IRQ077MON_ADCINT3          *((volatile unsigned char*)(0x4262670CUL))
#define bFM_INTREQ_IRQ077MON_ADCINT4          *((volatile unsigned char*)(0x42626710UL))
#define bFM_INTREQ_IRQ078MON_USB_DRQ_INT0     *((volatile unsigned char*)(0x42626780UL))
#define bFM_INTREQ_IRQ078MON_USB_DRQ_INT1     *((volatile unsigned char*)(0x42626784UL))
#define bFM_INTREQ_IRQ078MON_USB_DRQ_INT2     *((volatile unsigned char*)(0x42626788UL))
#define bFM_INTREQ_IRQ078MON_USB_DRQ_INT3     *((volatile unsigned char*)(0x4262678CUL))
#define bFM_INTREQ_IRQ078MON_USB_DRQ_INT4     *((volatile unsigned char*)(0x42626790UL))
#define bFM_INTREQ_IRQ079MON_USB_INT0         *((volatile unsigned char*)(0x42626800UL))
#define bFM_INTREQ_IRQ079MON_USB_INT1         *((volatile unsigned char*)(0x42626804UL))
#define bFM_INTREQ_IRQ079MON_USB_INT2         *((volatile unsigned char*)(0x42626808UL))
#define bFM_INTREQ_IRQ079MON_USB_INT3         *((volatile unsigned char*)(0x4262680CUL))
#define bFM_INTREQ_IRQ079MON_USB_INT4         *((volatile unsigned char*)(0x42626810UL))
#define bFM_INTREQ_IRQ079MON_USB_INT5         *((volatile unsigned char*)(0x42626814UL))
#define bFM_INTREQ_IRQ080MON_CANINT           *((volatile unsigned char*)(0x42626880UL))
#define bFM_INTREQ_IRQ081MON_CANINT           *((volatile unsigned char*)(0x42626900UL))
#define bFM_INTREQ_IRQ081MON_CANDEINT         *((volatile unsigned char*)(0x42626904UL))
#define bFM_INTREQ_IRQ081MON_CANSEINT         *((volatile unsigned char*)(0x42626908UL))
#define bFM_INTREQ_IRQ081MON_CAN0INT          *((volatile unsigned char*)(0x4262690CUL))
#define bFM_INTREQ_IRQ081MON_CAN1INT          *((volatile unsigned char*)(0x42626910UL))
#define bFM_INTREQ_IRQ082MON_MACSBD           *((volatile unsigned char*)(0x42626980UL))
#define bFM_INTREQ_IRQ082MON_MACPMT           *((volatile unsigned char*)(0x42626984UL))
#define bFM_INTREQ_IRQ082MON_MACLPI           *((volatile unsigned char*)(0x42626988UL))
#define bFM_INTREQ_IRQ083MON_DMACINT          *((volatile unsigned char*)(0x42626A00UL))
#define bFM_INTREQ_IRQ084MON_DMACINT          *((volatile unsigned char*)(0x42626A80UL))
#define bFM_INTREQ_IRQ085MON_DMACINT          *((volatile unsigned char*)(0x42626B00UL))
#define bFM_INTREQ_IRQ086MON_DMACINT          *((volatile unsigned char*)(0x42626B80UL))
#define bFM_INTREQ_IRQ087MON_DMACINT          *((volatile unsigned char*)(0x42626C00UL))
#define bFM_INTREQ_IRQ088MON_DMACINT          *((volatile unsigned char*)(0x42626C80UL))
#define bFM_INTREQ_IRQ089MON_DMACINT          *((volatile unsigned char*)(0x42626D00UL))
#define bFM_INTREQ_IRQ090MON_DMACINT          *((volatile unsigned char*)(0x42626D80UL))
#define bFM_INTREQ_IRQ091MON_DSTCINT0         *((volatile unsigned char*)(0x42626E00UL))
#define bFM_INTREQ_IRQ091MON_DSTCINT1         *((volatile unsigned char*)(0x42626E04UL))
#define bFM_INTREQ_IRQ092MON_EXTINT0          *((volatile unsigned char*)(0x42626E80UL))
#define bFM_INTREQ_IRQ092MON_EXTINT1          *((volatile unsigned char*)(0x42626E84UL))
#define bFM_INTREQ_IRQ092MON_EXTINT2          *((volatile unsigned char*)(0x42626E88UL))
#define bFM_INTREQ_IRQ092MON_EXTINT3          *((volatile unsigned char*)(0x42626E8CUL))
#define bFM_INTREQ_IRQ093MON_EXTINT0          *((volatile unsigned char*)(0x42626F00UL))
#define bFM_INTREQ_IRQ093MON_EXTINT1          *((volatile unsigned char*)(0x42626F04UL))
#define bFM_INTREQ_IRQ093MON_EXTINT2          *((volatile unsigned char*)(0x42626F08UL))
#define bFM_INTREQ_IRQ093MON_EXTINT3          *((volatile unsigned char*)(0x42626F0CUL))
#define bFM_INTREQ_IRQ094MON_EXTINT0          *((volatile unsigned char*)(0x42626F80UL))
#define bFM_INTREQ_IRQ094MON_EXTINT1          *((volatile unsigned char*)(0x42626F84UL))
#define bFM_INTREQ_IRQ094MON_EXTINT2          *((volatile unsigned char*)(0x42626F88UL))
#define bFM_INTREQ_IRQ094MON_EXTINT3          *((volatile unsigned char*)(0x42626F8CUL))
#define bFM_INTREQ_IRQ095MON_EXTINT0          *((volatile unsigned char*)(0x42627000UL))
#define bFM_INTREQ_IRQ095MON_EXTINT1          *((volatile unsigned char*)(0x42627004UL))
#define bFM_INTREQ_IRQ095MON_EXTINT2          *((volatile unsigned char*)(0x42627008UL))
#define bFM_INTREQ_IRQ095MON_EXTINT3          *((volatile unsigned char*)(0x4262700CUL))
#define bFM_INTREQ_IRQ096MON_QUDINT0          *((volatile unsigned char*)(0x42627080UL))
#define bFM_INTREQ_IRQ096MON_QUDINT1          *((volatile unsigned char*)(0x42627084UL))
#define bFM_INTREQ_IRQ096MON_QUDINT2          *((volatile unsigned char*)(0x42627088UL))
#define bFM_INTREQ_IRQ096MON_QUDINT3          *((volatile unsigned char*)(0x4262708CUL))
#define bFM_INTREQ_IRQ096MON_QUDINT4          *((volatile unsigned char*)(0x42627090UL))
#define bFM_INTREQ_IRQ096MON_QUDINT5          *((volatile unsigned char*)(0x42627094UL))
#define bFM_INTREQ_IRQ097MON_QUDINT0          *((volatile unsigned char*)(0x42627100UL))
#define bFM_INTREQ_IRQ097MON_QUDINT1          *((volatile unsigned char*)(0x42627104UL))
#define bFM_INTREQ_IRQ097MON_QUDINT2          *((volatile unsigned char*)(0x42627108UL))
#define bFM_INTREQ_IRQ097MON_QUDINT3          *((volatile unsigned char*)(0x4262710CUL))
#define bFM_INTREQ_IRQ097MON_QUDINT4          *((volatile unsigned char*)(0x42627110UL))
#define bFM_INTREQ_IRQ097MON_QUDINT5          *((volatile unsigned char*)(0x42627114UL))
#define bFM_INTREQ_IRQ098MON_BTINT0           *((volatile unsigned char*)(0x42627180UL))
#define bFM_INTREQ_IRQ098MON_BTINT1           *((volatile unsigned char*)(0x42627184UL))
#define bFM_INTREQ_IRQ099MON_BTINT0           *((volatile unsigned char*)(0x42627200UL))
#define bFM_INTREQ_IRQ099MON_BTINT1           *((volatile unsigned char*)(0x42627204UL))
#define bFM_INTREQ_IRQ100MON_BTINT0           *((volatile unsigned char*)(0x42627280UL))
#define bFM_INTREQ_IRQ100MON_BTINT1           *((volatile unsigned char*)(0x42627284UL))
#define bFM_INTREQ_IRQ101MON_BTINT0           *((volatile unsigned char*)(0x42627300UL))
#define bFM_INTREQ_IRQ101MON_BTINT1           *((volatile unsigned char*)(0x42627304UL))
#define bFM_INTREQ_IRQ102MON_BTINT0           *((volatile unsigned char*)(0x42627380UL))
#define bFM_INTREQ_IRQ102MON_BTINT1           *((volatile unsigned char*)(0x42627384UL))
#define bFM_INTREQ_IRQ102MON_BTINT2           *((volatile unsigned char*)(0x42627388UL))
#define bFM_INTREQ_IRQ102MON_BTINT3           *((volatile unsigned char*)(0x4262738CUL))
#define bFM_INTREQ_IRQ102MON_BTINT4           *((volatile unsigned char*)(0x42627390UL))
#define bFM_INTREQ_IRQ102MON_BTINT5           *((volatile unsigned char*)(0x42627394UL))
#define bFM_INTREQ_IRQ102MON_BTINT6           *((volatile unsigned char*)(0x42627398UL))
#define bFM_INTREQ_IRQ102MON_BTINT7           *((volatile unsigned char*)(0x4262739CUL))
#define bFM_INTREQ_IRQ103MON_MFSRINT          *((volatile unsigned char*)(0x42627400UL))
#define bFM_INTREQ_IRQ104MON_MFSINT0          *((volatile unsigned char*)(0x42627480UL))
#define bFM_INTREQ_IRQ104MON_MFSINT1          *((volatile unsigned char*)(0x42627484UL))
#define bFM_INTREQ_IRQ105MON_MFSRINT          *((volatile unsigned char*)(0x42627500UL))
#define bFM_INTREQ_IRQ106MON_MFSINT0          *((volatile unsigned char*)(0x42627580UL))
#define bFM_INTREQ_IRQ106MON_MFSINT1          *((volatile unsigned char*)(0x42627584UL))
#define bFM_INTREQ_IRQ107MON_MFSRINT          *((volatile unsigned char*)(0x42627600UL))
#define bFM_INTREQ_IRQ108MON_MFSINT0          *((volatile unsigned char*)(0x42627680UL))
#define bFM_INTREQ_IRQ108MON_MFSINT1          *((volatile unsigned char*)(0x42627684UL))
#define bFM_INTREQ_IRQ109MON_MFSRINT          *((volatile unsigned char*)(0x42627700UL))
#define bFM_INTREQ_IRQ110MON_MFSINT0          *((volatile unsigned char*)(0x42627780UL))
#define bFM_INTREQ_IRQ110MON_MFSINT1          *((volatile unsigned char*)(0x42627784UL))
#define bFM_INTREQ_IRQ111MON_ADCINT0          *((volatile unsigned char*)(0x42627800UL))
#define bFM_INTREQ_IRQ111MON_ADCINT1          *((volatile unsigned char*)(0x42627804UL))
#define bFM_INTREQ_IRQ111MON_ADCINT2          *((volatile unsigned char*)(0x42627808UL))
#define bFM_INTREQ_IRQ111MON_ADCINT3          *((volatile unsigned char*)(0x4262780CUL))
#define bFM_INTREQ_IRQ111MON_ADCINT4          *((volatile unsigned char*)(0x42627810UL))
#define bFM_INTREQ_IRQ112MON_I2SDINT0         *((volatile unsigned char*)(0x42627880UL))
#define bFM_INTREQ_IRQ112MON_I2SDINT1         *((volatile unsigned char*)(0x42627884UL))
#define bFM_INTREQ_IRQ112MON_QSPIDINT0        *((volatile unsigned char*)(0x42627888UL))
#define bFM_INTREQ_IRQ112MON_QSPIDINT1        *((volatile unsigned char*)(0x4262788CUL))
#define bFM_INTREQ_IRQ112MON_PCRCDINT         *((volatile unsigned char*)(0x42627890UL))
#define bFM_INTREQ_IRQ112MON_CANDINT          *((volatile unsigned char*)(0x42627894UL))
#define bFM_INTREQ_IRQ113MON_USB_DRQ_INT0     *((volatile unsigned char*)(0x42627900UL))
#define bFM_INTREQ_IRQ113MON_USB_DRQ_INT1     *((volatile unsigned char*)(0x42627904UL))
#define bFM_INTREQ_IRQ113MON_USB_DRQ_INT2     *((volatile unsigned char*)(0x42627908UL))
#define bFM_INTREQ_IRQ113MON_USB_DRQ_INT3     *((volatile unsigned char*)(0x4262790CUL))
#define bFM_INTREQ_IRQ113MON_USB_DRQ_INT4     *((volatile unsigned char*)(0x42627910UL))
#define bFM_INTREQ_IRQ113MON_RCEC0INT         *((volatile unsigned char*)(0x42627914UL))
#define bFM_INTREQ_IRQ114MON_USB_INT0         *((volatile unsigned char*)(0x42627980UL))
#define bFM_INTREQ_IRQ114MON_USB_INT1         *((volatile unsigned char*)(0x42627984UL))
#define bFM_INTREQ_IRQ114MON_USB_INT2         *((volatile unsigned char*)(0x42627988UL))
#define bFM_INTREQ_IRQ114MON_USB_INT3         *((volatile unsigned char*)(0x4262798CUL))
#define bFM_INTREQ_IRQ114MON_USB_INT4         *((volatile unsigned char*)(0x42627990UL))
#define bFM_INTREQ_IRQ114MON_USB_INT5         *((volatile unsigned char*)(0x42627994UL))
#define bFM_INTREQ_IRQ114MON_RCEC1INT         *((volatile unsigned char*)(0x42627998UL))
#define bFM_INTREQ_IRQ115MON_QSPIINT0         *((volatile unsigned char*)(0x42627A00UL))
#define bFM_INTREQ_IRQ115MON_QSPIINT1         *((volatile unsigned char*)(0x42627A04UL))
#define bFM_INTREQ_IRQ115MON_QSPIINT2         *((volatile unsigned char*)(0x42627A08UL))
#define bFM_INTREQ_IRQ117MON_I2SINT           *((volatile unsigned char*)(0x42627B00UL))
#define bFM_INTREQ_IRQ117MON_PRGCRC           *((volatile unsigned char*)(0x42627B04UL))
#define bFM_INTREQ_IRQ118MON_SDINT0           *((volatile unsigned char*)(0x42627B80UL))
#define bFM_INTREQ_IRQ118MON_SDINT1           *((volatile unsigned char*)(0x42627B84UL))
#define bFM_INTREQ_IRQ119MON_FLINT            *((volatile unsigned char*)(0x42627C00UL))
#define bFM_INTREQ_IRQ120MON_MFSRINT          *((volatile unsigned char*)(0x42627C80UL))
#define bFM_INTREQ_IRQ121MON_MFSINT0          *((volatile unsigned char*)(0x42627D00UL))
#define bFM_INTREQ_IRQ121MON_MFSINT1          *((volatile unsigned char*)(0x42627D04UL))
#define bFM_INTREQ_IRQ122MON_MFSRINT          *((volatile unsigned char*)(0x42627D80UL))
#define bFM_INTREQ_IRQ123MON_MFSINT0          *((volatile unsigned char*)(0x42627E00UL))
#define bFM_INTREQ_IRQ123MON_MFSINT1          *((volatile unsigned char*)(0x42627E04UL))
#define bFM_INTREQ_IRQ124MON_MFSRINT          *((volatile unsigned char*)(0x42627E80UL))
#define bFM_INTREQ_IRQ125MON_MFSINT0          *((volatile unsigned char*)(0x42627F00UL))
#define bFM_INTREQ_IRQ125MON_MFSINT1          *((volatile unsigned char*)(0x42627F04UL))
#define bFM_INTREQ_IRQ126MON_MFSRINT          *((volatile unsigned char*)(0x42627F80UL))
#define bFM_INTREQ_IRQ127MON_MFSINT0          *((volatile unsigned char*)(0x42628000UL))
#define bFM_INTREQ_IRQ127MON_MFSINT1          *((volatile unsigned char*)(0x42628004UL))

/* 12-bit DAC unit 0 registers */
#define bFM_DAC0_DACR_DAE                     *((volatile unsigned char*)(0x42660000UL))
#define bFM_DAC0_DACR_DRDY                    *((volatile unsigned char*)(0x42660004UL))
#define bFM_DAC0_DACR_DAC10                   *((volatile unsigned char*)(0x42660010UL))
#define bFM_DAC0_DACR_DDAS                    *((volatile unsigned char*)(0x42660014UL))
#define bFM_DAC0_DADR_DA0                     *((volatile unsigned short*)(0x42660080UL))
#define bFM_DAC0_DADR_DA1                     *((volatile unsigned short*)(0x42660084UL))
#define bFM_DAC0_DADR_DA2                     *((volatile unsigned short*)(0x42660088UL))
#define bFM_DAC0_DADR_DA3                     *((volatile unsigned short*)(0x4266008CUL))
#define bFM_DAC0_DADR_DA4                     *((volatile unsigned short*)(0x42660090UL))
#define bFM_DAC0_DADR_DA5                     *((volatile unsigned short*)(0x42660094UL))
#define bFM_DAC0_DADR_DA6                     *((volatile unsigned short*)(0x42660098UL))
#define bFM_DAC0_DADR_DA7                     *((volatile unsigned short*)(0x4266009CUL))
#define bFM_DAC0_DADR_DA8                     *((volatile unsigned short*)(0x426600A0UL))
#define bFM_DAC0_DADR_DA9                     *((volatile unsigned short*)(0x426600A4UL))
#define bFM_DAC0_DADR_DA10                    *((volatile unsigned short*)(0x426600A8UL))
#define bFM_DAC0_DADR_DA11                    *((volatile unsigned short*)(0x426600ACUL))

/* 12-bit DAC unit 1 registers */
#define bFM_DAC1_DACR_DAE                     *((volatile unsigned char*)(0x42660100UL))
#define bFM_DAC1_DACR_DRDY                    *((volatile unsigned char*)(0x42660104UL))
#define bFM_DAC1_DACR_DAC10                   *((volatile unsigned char*)(0x42660110UL))
#define bFM_DAC1_DACR_DDAS                    *((volatile unsigned char*)(0x42660114UL))
#define bFM_DAC1_DADR_DA0                     *((volatile unsigned short*)(0x42660180UL))
#define bFM_DAC1_DADR_DA1                     *((volatile unsigned short*)(0x42660184UL))
#define bFM_DAC1_DADR_DA2                     *((volatile unsigned short*)(0x42660188UL))
#define bFM_DAC1_DADR_DA3                     *((volatile unsigned short*)(0x4266018CUL))
#define bFM_DAC1_DADR_DA4                     *((volatile unsigned short*)(0x42660190UL))
#define bFM_DAC1_DADR_DA5                     *((volatile unsigned short*)(0x42660194UL))
#define bFM_DAC1_DADR_DA6                     *((volatile unsigned short*)(0x42660198UL))
#define bFM_DAC1_DADR_DA7                     *((volatile unsigned short*)(0x4266019CUL))
#define bFM_DAC1_DADR_DA8                     *((volatile unsigned short*)(0x426601A0UL))
#define bFM_DAC1_DADR_DA9                     *((volatile unsigned short*)(0x426601A4UL))
#define bFM_DAC1_DADR_DA10                    *((volatile unsigned short*)(0x426601A8UL))
#define bFM_DAC1_DADR_DA11                    *((volatile unsigned short*)(0x426601ACUL))

/* HDMI-CEC ch.0 registers */
#define bFM_HDMICEC0_TXCTRL_TXEN              *((volatile unsigned char*)(0x42680000UL))
#define bFM_HDMICEC0_TXCTRL_START             *((volatile unsigned char*)(0x42680008UL))
#define bFM_HDMICEC0_TXCTRL_EOM               *((volatile unsigned char*)(0x4268000CUL))
#define bFM_HDMICEC0_TXCTRL_ITSTEN            *((volatile unsigned char*)(0x42680010UL))
#define bFM_HDMICEC0_TXCTRL_IBREN             *((volatile unsigned char*)(0x42680014UL))
#define bFM_HDMICEC0_TXDATA_TXDATA0           *((volatile unsigned char*)(0x42680080UL))
#define bFM_HDMICEC0_TXDATA_TXDATA1           *((volatile unsigned char*)(0x42680084UL))
#define bFM_HDMICEC0_TXDATA_TXDATA2           *((volatile unsigned char*)(0x42680088UL))
#define bFM_HDMICEC0_TXDATA_TXDATA3           *((volatile unsigned char*)(0x4268008CUL))
#define bFM_HDMICEC0_TXDATA_TXDATA4           *((volatile unsigned char*)(0x42680090UL))
#define bFM_HDMICEC0_TXDATA_TXDATA5           *((volatile unsigned char*)(0x42680094UL))
#define bFM_HDMICEC0_TXDATA_TXDATA6           *((volatile unsigned char*)(0x42680098UL))
#define bFM_HDMICEC0_TXDATA_TXDATA7           *((volatile unsigned char*)(0x4268009CUL))
#define bFM_HDMICEC0_TXSTS_ACKSV              *((volatile unsigned char*)(0x42680100UL))
#define bFM_HDMICEC0_TXSTS_ITST               *((volatile unsigned char*)(0x42680110UL))
#define bFM_HDMICEC0_TXSTS_IBR                *((volatile unsigned char*)(0x42680114UL))
#define bFM_HDMICEC0_SFREE_SFREE0             *((volatile unsigned char*)(0x42680180UL))
#define bFM_HDMICEC0_SFREE_SFREE1             *((volatile unsigned char*)(0x42680184UL))
#define bFM_HDMICEC0_SFREE_SFREE2             *((volatile unsigned char*)(0x42680188UL))
#define bFM_HDMICEC0_SFREE_SFREE3             *((volatile unsigned char*)(0x4268018CUL))
#define bFM_HDMICEC0_RCST_OVF                 *((volatile unsigned char*)(0x42680800UL))
#define bFM_HDMICEC0_RCST_EOM                 *((volatile unsigned char*)(0x42680804UL))
#define bFM_HDMICEC0_RCST_ACK                 *((volatile unsigned char*)(0x42680808UL))
#define bFM_HDMICEC0_RCST_ST                  *((volatile unsigned char*)(0x4268080CUL))
#define bFM_HDMICEC0_RCST_OVFSEL              *((volatile unsigned char*)(0x42680810UL))
#define bFM_HDMICEC0_RCST_OVFIE               *((volatile unsigned char*)(0x42680814UL))
#define bFM_HDMICEC0_RCST_ACKIE               *((volatile unsigned char*)(0x42680818UL))
#define bFM_HDMICEC0_RCST_STIE                *((volatile unsigned char*)(0x4268081CUL))
#define bFM_HDMICEC0_RCCR_EN                  *((volatile unsigned char*)(0x42680820UL))
#define bFM_HDMICEC0_RCCR_ADRCE               *((volatile unsigned char*)(0x4268082CUL))
#define bFM_HDMICEC0_RCCR_THSEL               *((volatile unsigned char*)(0x4268083CUL))
#define bFM_HDMICEC0_RCCKD_CKDIV0             *((volatile unsigned short*)(0x42680B00UL))
#define bFM_HDMICEC0_RCCKD_CKDIV1             *((volatile unsigned short*)(0x42680B04UL))
#define bFM_HDMICEC0_RCCKD_CKDIV2             *((volatile unsigned short*)(0x42680B08UL))
#define bFM_HDMICEC0_RCCKD_CKDIV3             *((volatile unsigned short*)(0x42680B0CUL))
#define bFM_HDMICEC0_RCCKD_CKDIV4             *((volatile unsigned short*)(0x42680B10UL))
#define bFM_HDMICEC0_RCCKD_CKDIV5             *((volatile unsigned short*)(0x42680B14UL))
#define bFM_HDMICEC0_RCCKD_CKDIV6             *((volatile unsigned short*)(0x42680B18UL))
#define bFM_HDMICEC0_RCCKD_CKDIV7             *((volatile unsigned short*)(0x42680B1CUL))
#define bFM_HDMICEC0_RCCKD_CKDIV8             *((volatile unsigned short*)(0x42680B20UL))
#define bFM_HDMICEC0_RCCKD_CKDIV9             *((volatile unsigned short*)(0x42680B24UL))
#define bFM_HDMICEC0_RCCKD_CKDIV10            *((volatile unsigned short*)(0x42680B28UL))
#define bFM_HDMICEC0_RCCKD_CKDIV11            *((volatile unsigned short*)(0x42680B2CUL))
#define bFM_HDMICEC0_RCCKD_CKSEL              *((volatile unsigned short*)(0x42680B30UL))
#define bFM_HDMICEC0_RCRC_RC                  *((volatile unsigned char*)(0x42680BA0UL))
#define bFM_HDMICEC0_RCRC_RCIE                *((volatile unsigned char*)(0x42680BB0UL))
#define bFM_HDMICEC0_RCLE_LES                 *((volatile unsigned char*)(0x42680C20UL))
#define bFM_HDMICEC0_RCLE_LEL                 *((volatile unsigned char*)(0x42680C24UL))
#define bFM_HDMICEC0_RCLE_EPE                 *((volatile unsigned char*)(0x42680C2CUL))
#define bFM_HDMICEC0_RCLE_LESE                *((volatile unsigned char*)(0x42680C30UL))
#define bFM_HDMICEC0_RCLE_LELE                *((volatile unsigned char*)(0x42680C34UL))
#define bFM_HDMICEC0_RCLE_LESIE               *((volatile unsigned char*)(0x42680C38UL))
#define bFM_HDMICEC0_RCLE_LELIE               *((volatile unsigned char*)(0x42680C3CUL))

/* HDMI-CEC ch.1 registers */
#define bFM_HDMICEC1_TXCTRL_TXEN              *((volatile unsigned char*)(0x42682000UL))
#define bFM_HDMICEC1_TXCTRL_START             *((volatile unsigned char*)(0x42682008UL))
#define bFM_HDMICEC1_TXCTRL_EOM               *((volatile unsigned char*)(0x4268200CUL))
#define bFM_HDMICEC1_TXCTRL_ITSTEN            *((volatile unsigned char*)(0x42682010UL))
#define bFM_HDMICEC1_TXCTRL_IBREN             *((volatile unsigned char*)(0x42682014UL))
#define bFM_HDMICEC1_TXDATA_TXDATA0           *((volatile unsigned char*)(0x42682080UL))
#define bFM_HDMICEC1_TXDATA_TXDATA1           *((volatile unsigned char*)(0x42682084UL))
#define bFM_HDMICEC1_TXDATA_TXDATA2           *((volatile unsigned char*)(0x42682088UL))
#define bFM_HDMICEC1_TXDATA_TXDATA3           *((volatile unsigned char*)(0x4268208CUL))
#define bFM_HDMICEC1_TXDATA_TXDATA4           *((volatile unsigned char*)(0x42682090UL))
#define bFM_HDMICEC1_TXDATA_TXDATA5           *((volatile unsigned char*)(0x42682094UL))
#define bFM_HDMICEC1_TXDATA_TXDATA6           *((volatile unsigned char*)(0x42682098UL))
#define bFM_HDMICEC1_TXDATA_TXDATA7           *((volatile unsigned char*)(0x4268209CUL))
#define bFM_HDMICEC1_TXSTS_ACKSV              *((volatile unsigned char*)(0x42682100UL))
#define bFM_HDMICEC1_TXSTS_ITST               *((volatile unsigned char*)(0x42682110UL))
#define bFM_HDMICEC1_TXSTS_IBR                *((volatile unsigned char*)(0x42682114UL))
#define bFM_HDMICEC1_SFREE_SFREE0             *((volatile unsigned char*)(0x42682180UL))
#define bFM_HDMICEC1_SFREE_SFREE1             *((volatile unsigned char*)(0x42682184UL))
#define bFM_HDMICEC1_SFREE_SFREE2             *((volatile unsigned char*)(0x42682188UL))
#define bFM_HDMICEC1_SFREE_SFREE3             *((volatile unsigned char*)(0x4268218CUL))
#define bFM_HDMICEC1_RCST_OVF                 *((volatile unsigned char*)(0x42682800UL))
#define bFM_HDMICEC1_RCST_EOM                 *((volatile unsigned char*)(0x42682804UL))
#define bFM_HDMICEC1_RCST_ACK                 *((volatile unsigned char*)(0x42682808UL))
#define bFM_HDMICEC1_RCST_ST                  *((volatile unsigned char*)(0x4268280CUL))
#define bFM_HDMICEC1_RCST_OVFSEL              *((volatile unsigned char*)(0x42682810UL))
#define bFM_HDMICEC1_RCST_OVFIE               *((volatile unsigned char*)(0x42682814UL))
#define bFM_HDMICEC1_RCST_ACKIE               *((volatile unsigned char*)(0x42682818UL))
#define bFM_HDMICEC1_RCST_STIE                *((volatile unsigned char*)(0x4268281CUL))
#define bFM_HDMICEC1_RCCR_EN                  *((volatile unsigned char*)(0x42682820UL))
#define bFM_HDMICEC1_RCCR_ADRCE               *((volatile unsigned char*)(0x4268282CUL))
#define bFM_HDMICEC1_RCCR_THSEL               *((volatile unsigned char*)(0x4268283CUL))
#define bFM_HDMICEC1_RCCKD_CKDIV0             *((volatile unsigned short*)(0x42682B00UL))
#define bFM_HDMICEC1_RCCKD_CKDIV1             *((volatile unsigned short*)(0x42682B04UL))
#define bFM_HDMICEC1_RCCKD_CKDIV2             *((volatile unsigned short*)(0x42682B08UL))
#define bFM_HDMICEC1_RCCKD_CKDIV3             *((volatile unsigned short*)(0x42682B0CUL))
#define bFM_HDMICEC1_RCCKD_CKDIV4             *((volatile unsigned short*)(0x42682B10UL))
#define bFM_HDMICEC1_RCCKD_CKDIV5             *((volatile unsigned short*)(0x42682B14UL))
#define bFM_HDMICEC1_RCCKD_CKDIV6             *((volatile unsigned short*)(0x42682B18UL))
#define bFM_HDMICEC1_RCCKD_CKDIV7             *((volatile unsigned short*)(0x42682B1CUL))
#define bFM_HDMICEC1_RCCKD_CKDIV8             *((volatile unsigned short*)(0x42682B20UL))
#define bFM_HDMICEC1_RCCKD_CKDIV9             *((volatile unsigned short*)(0x42682B24UL))
#define bFM_HDMICEC1_RCCKD_CKDIV10            *((volatile unsigned short*)(0x42682B28UL))
#define bFM_HDMICEC1_RCCKD_CKDIV11            *((volatile unsigned short*)(0x42682B2CUL))
#define bFM_HDMICEC1_RCCKD_CKSEL              *((volatile unsigned short*)(0x42682B30UL))
#define bFM_HDMICEC1_RCRC_RC                  *((volatile unsigned char*)(0x42682BA0UL))
#define bFM_HDMICEC1_RCRC_RCIE                *((volatile unsigned char*)(0x42682BB0UL))
#define bFM_HDMICEC1_RCLE_LES                 *((volatile unsigned char*)(0x42682C20UL))
#define bFM_HDMICEC1_RCLE_LEL                 *((volatile unsigned char*)(0x42682C24UL))
#define bFM_HDMICEC1_RCLE_EPE                 *((volatile unsigned char*)(0x42682C2CUL))
#define bFM_HDMICEC1_RCLE_LESE                *((volatile unsigned char*)(0x42682C30UL))
#define bFM_HDMICEC1_RCLE_LELE                *((volatile unsigned char*)(0x42682C34UL))
#define bFM_HDMICEC1_RCLE_LESIE               *((volatile unsigned char*)(0x42682C38UL))
#define bFM_HDMICEC1_RCLE_LELIE               *((volatile unsigned char*)(0x42682C3CUL))

/* General purpose I/O registers */
#define bFM_GPIO_PFR0_P0                      *((volatile unsigned char*)(0x42DE0000UL))
#define bFM_GPIO_PFR0_P1                      *((volatile unsigned char*)(0x42DE0004UL))
#define bFM_GPIO_PFR0_P2                      *((volatile unsigned char*)(0x42DE0008UL))
#define bFM_GPIO_PFR0_P3                      *((volatile unsigned char*)(0x42DE000CUL))
#define bFM_GPIO_PFR0_P4                      *((volatile unsigned char*)(0x42DE0010UL))
#define bFM_GPIO_PFR0_P8                      *((volatile unsigned char*)(0x42DE0020UL))
#define bFM_GPIO_PFR0_P9                      *((volatile unsigned char*)(0x42DE0024UL))
#define bFM_GPIO_PFR0_PA                      *((volatile unsigned char*)(0x42DE0028UL))
#define bFM_GPIO_PFR1_P0                      *((volatile unsigned char*)(0x42DE0080UL))
#define bFM_GPIO_PFR1_P1                      *((volatile unsigned char*)(0x42DE0084UL))
#define bFM_GPIO_PFR1_P2                      *((volatile unsigned char*)(0x42DE0088UL))
#define bFM_GPIO_PFR1_P3                      *((volatile unsigned char*)(0x42DE008CUL))
#define bFM_GPIO_PFR1_P4                      *((volatile unsigned char*)(0x42DE0090UL))
#define bFM_GPIO_PFR1_P5                      *((volatile unsigned char*)(0x42DE0094UL))
#define bFM_GPIO_PFR1_P6                      *((volatile unsigned char*)(0x42DE0098UL))
#define bFM_GPIO_PFR1_P7                      *((volatile unsigned char*)(0x42DE009CUL))
#define bFM_GPIO_PFR1_P8                      *((volatile unsigned char*)(0x42DE00A0UL))
#define bFM_GPIO_PFR1_P9                      *((volatile unsigned char*)(0x42DE00A4UL))
#define bFM_GPIO_PFR1_PA                      *((volatile unsigned char*)(0x42DE00A8UL))
#define bFM_GPIO_PFR1_PB                      *((volatile unsigned char*)(0x42DE00ACUL))
#define bFM_GPIO_PFR1_PC                      *((volatile unsigned char*)(0x42DE00B0UL))
#define bFM_GPIO_PFR1_PD                      *((volatile unsigned char*)(0x42DE00B4UL))
#define bFM_GPIO_PFR1_PE                      *((volatile unsigned char*)(0x42DE00B8UL))
#define bFM_GPIO_PFR1_PF                      *((volatile unsigned char*)(0x42DE00BCUL))
#define bFM_GPIO_PFR2_P0                      *((volatile unsigned char*)(0x42DE0100UL))
#define bFM_GPIO_PFR2_P1                      *((volatile unsigned char*)(0x42DE0104UL))
#define bFM_GPIO_PFR2_P2                      *((volatile unsigned char*)(0x42DE0108UL))
#define bFM_GPIO_PFR2_P3                      *((volatile unsigned char*)(0x42DE010CUL))
#define bFM_GPIO_PFR2_P4                      *((volatile unsigned char*)(0x42DE0110UL))
#define bFM_GPIO_PFR2_P5                      *((volatile unsigned char*)(0x42DE0114UL))
#define bFM_GPIO_PFR2_P6                      *((volatile unsigned char*)(0x42DE0118UL))
#define bFM_GPIO_PFR2_P7                      *((volatile unsigned char*)(0x42DE011CUL))
#define bFM_GPIO_PFR2_P8                      *((volatile unsigned char*)(0x42DE0120UL))
#define bFM_GPIO_PFR2_P9                      *((volatile unsigned char*)(0x42DE0124UL))
#define bFM_GPIO_PFR2_PA                      *((volatile unsigned char*)(0x42DE0128UL))
#define bFM_GPIO_PFR3_P0                      *((volatile unsigned char*)(0x42DE0180UL))
#define bFM_GPIO_PFR3_P1                      *((volatile unsigned char*)(0x42DE0184UL))
#define bFM_GPIO_PFR3_P2                      *((volatile unsigned char*)(0x42DE0188UL))
#define bFM_GPIO_PFR3_P3                      *((volatile unsigned char*)(0x42DE018CUL))
#define bFM_GPIO_PFR3_P4                      *((volatile unsigned char*)(0x42DE0190UL))
#define bFM_GPIO_PFR3_P5                      *((volatile unsigned char*)(0x42DE0194UL))
#define bFM_GPIO_PFR3_P6                      *((volatile unsigned char*)(0x42DE0198UL))
#define bFM_GPIO_PFR3_P7                      *((volatile unsigned char*)(0x42DE019CUL))
#define bFM_GPIO_PFR3_P8                      *((volatile unsigned char*)(0x42DE01A0UL))
#define bFM_GPIO_PFR3_P9                      *((volatile unsigned char*)(0x42DE01A4UL))
#define bFM_GPIO_PFR3_PA                      *((volatile unsigned char*)(0x42DE01A8UL))
#define bFM_GPIO_PFR3_PB                      *((volatile unsigned char*)(0x42DE01ACUL))
#define bFM_GPIO_PFR3_PC                      *((volatile unsigned char*)(0x42DE01B0UL))
#define bFM_GPIO_PFR3_PD                      *((volatile unsigned char*)(0x42DE01B4UL))
#define bFM_GPIO_PFR3_PE                      *((volatile unsigned char*)(0x42DE01B8UL))
#define bFM_GPIO_PFR4_P0                      *((volatile unsigned char*)(0x42DE0200UL))
#define bFM_GPIO_PFR4_P1                      *((volatile unsigned char*)(0x42DE0204UL))
#define bFM_GPIO_PFR4_P2                      *((volatile unsigned char*)(0x42DE0208UL))
#define bFM_GPIO_PFR4_P3                      *((volatile unsigned char*)(0x42DE020CUL))
#define bFM_GPIO_PFR4_P4                      *((volatile unsigned char*)(0x42DE0210UL))
#define bFM_GPIO_PFR4_P5                      *((volatile unsigned char*)(0x42DE0214UL))
#define bFM_GPIO_PFR4_P6                      *((volatile unsigned char*)(0x42DE0218UL))
#define bFM_GPIO_PFR4_P7                      *((volatile unsigned char*)(0x42DE021CUL))
#define bFM_GPIO_PFR4_P8                      *((volatile unsigned char*)(0x42DE0220UL))
#define bFM_GPIO_PFR4_P9                      *((volatile unsigned char*)(0x42DE0224UL))
#define bFM_GPIO_PFR4_PA                      *((volatile unsigned char*)(0x42DE0228UL))
#define bFM_GPIO_PFR4_PB                      *((volatile unsigned char*)(0x42DE022CUL))
#define bFM_GPIO_PFR4_PC                      *((volatile unsigned char*)(0x42DE0230UL))
#define bFM_GPIO_PFR4_PD                      *((volatile unsigned char*)(0x42DE0234UL))
#define bFM_GPIO_PFR4_PE                      *((volatile unsigned char*)(0x42DE0238UL))
#define bFM_GPIO_PFR5_P0                      *((volatile unsigned char*)(0x42DE0280UL))
#define bFM_GPIO_PFR5_P1                      *((volatile unsigned char*)(0x42DE0284UL))
#define bFM_GPIO_PFR5_P2                      *((volatile unsigned char*)(0x42DE0288UL))
#define bFM_GPIO_PFR5_P3                      *((volatile unsigned char*)(0x42DE028CUL))
#define bFM_GPIO_PFR5_P4                      *((volatile unsigned char*)(0x42DE0290UL))
#define bFM_GPIO_PFR5_P5                      *((volatile unsigned char*)(0x42DE0294UL))
#define bFM_GPIO_PFR5_P6                      *((volatile unsigned char*)(0x42DE0298UL))
#define bFM_GPIO_PFR5_P7                      *((volatile unsigned char*)(0x42DE029CUL))
#define bFM_GPIO_PFR5_P8                      *((volatile unsigned char*)(0x42DE02A0UL))
#define bFM_GPIO_PFR5_P9                      *((volatile unsigned char*)(0x42DE02A4UL))
#define bFM_GPIO_PFR5_PA                      *((volatile unsigned char*)(0x42DE02A8UL))
#define bFM_GPIO_PFR5_PB                      *((volatile unsigned char*)(0x42DE02ACUL))
#define bFM_GPIO_PFR5_PC                      *((volatile unsigned char*)(0x42DE02B0UL))
#define bFM_GPIO_PFR5_PD                      *((volatile unsigned char*)(0x42DE02B4UL))
#define bFM_GPIO_PFR5_PE                      *((volatile unsigned char*)(0x42DE02B8UL))
#define bFM_GPIO_PFR5_PF                      *((volatile unsigned char*)(0x42DE02BCUL))
#define bFM_GPIO_PFR6_P0                      *((volatile unsigned char*)(0x42DE0300UL))
#define bFM_GPIO_PFR6_P1                      *((volatile unsigned char*)(0x42DE0304UL))
#define bFM_GPIO_PFR6_P2                      *((volatile unsigned char*)(0x42DE0308UL))
#define bFM_GPIO_PFR6_P3                      *((volatile unsigned char*)(0x42DE030CUL))
#define bFM_GPIO_PFR6_P4                      *((volatile unsigned char*)(0x42DE0310UL))
#define bFM_GPIO_PFR6_P5                      *((volatile unsigned char*)(0x42DE0314UL))
#define bFM_GPIO_PFR6_P6                      *((volatile unsigned char*)(0x42DE0318UL))
#define bFM_GPIO_PFR6_P7                      *((volatile unsigned char*)(0x42DE031CUL))
#define bFM_GPIO_PFR6_P8                      *((volatile unsigned char*)(0x42DE0320UL))
#define bFM_GPIO_PFR6_P9                      *((volatile unsigned char*)(0x42DE0324UL))
#define bFM_GPIO_PFR6_PA                      *((volatile unsigned char*)(0x42DE0328UL))
#define bFM_GPIO_PFR6_PB                      *((volatile unsigned char*)(0x42DE032CUL))
#define bFM_GPIO_PFR6_PC                      *((volatile unsigned char*)(0x42DE0330UL))
#define bFM_GPIO_PFR6_PD                      *((volatile unsigned char*)(0x42DE0334UL))
#define bFM_GPIO_PFR6_PE                      *((volatile unsigned char*)(0x42DE0338UL))
#define bFM_GPIO_PFR7_P0                      *((volatile unsigned char*)(0x42DE0380UL))
#define bFM_GPIO_PFR7_P1                      *((volatile unsigned char*)(0x42DE0384UL))
#define bFM_GPIO_PFR7_P2                      *((volatile unsigned char*)(0x42DE0388UL))
#define bFM_GPIO_PFR7_P3                      *((volatile unsigned char*)(0x42DE038CUL))
#define bFM_GPIO_PFR7_P4                      *((volatile unsigned char*)(0x42DE0390UL))
#define bFM_GPIO_PFR7_P5                      *((volatile unsigned char*)(0x42DE0394UL))
#define bFM_GPIO_PFR7_P6                      *((volatile unsigned char*)(0x42DE0398UL))
#define bFM_GPIO_PFR7_P7                      *((volatile unsigned char*)(0x42DE039CUL))
#define bFM_GPIO_PFR7_P8                      *((volatile unsigned char*)(0x42DE03A0UL))
#define bFM_GPIO_PFR7_P9                      *((volatile unsigned char*)(0x42DE03A4UL))
#define bFM_GPIO_PFR7_PA                      *((volatile unsigned char*)(0x42DE03A8UL))
#define bFM_GPIO_PFR7_PB                      *((volatile unsigned char*)(0x42DE03ACUL))
#define bFM_GPIO_PFR7_PC                      *((volatile unsigned char*)(0x42DE03B0UL))
#define bFM_GPIO_PFR7_PD                      *((volatile unsigned char*)(0x42DE03B4UL))
#define bFM_GPIO_PFR7_PE                      *((volatile unsigned char*)(0x42DE03B8UL))
#define bFM_GPIO_PFR8_P0                      *((volatile unsigned char*)(0x42DE0400UL))
#define bFM_GPIO_PFR8_P1                      *((volatile unsigned char*)(0x42DE0404UL))
#define bFM_GPIO_PFR8_P2                      *((volatile unsigned char*)(0x42DE0408UL))
#define bFM_GPIO_PFR8_P3                      *((volatile unsigned char*)(0x42DE040CUL))
#define bFM_GPIO_PFR9_P0                      *((volatile unsigned char*)(0x42DE0480UL))
#define bFM_GPIO_PFR9_P1                      *((volatile unsigned char*)(0x42DE0484UL))
#define bFM_GPIO_PFR9_P2                      *((volatile unsigned char*)(0x42DE0488UL))
#define bFM_GPIO_PFR9_P3                      *((volatile unsigned char*)(0x42DE048CUL))
#define bFM_GPIO_PFR9_P4                      *((volatile unsigned char*)(0x42DE0490UL))
#define bFM_GPIO_PFR9_P5                      *((volatile unsigned char*)(0x42DE0494UL))
#define bFM_GPIO_PFR9_P6                      *((volatile unsigned char*)(0x42DE0498UL))
#define bFM_GPIO_PFR9_P7                      *((volatile unsigned char*)(0x42DE049CUL))
#define bFM_GPIO_PFRA_P0                      *((volatile unsigned char*)(0x42DE0500UL))
#define bFM_GPIO_PFRA_P1                      *((volatile unsigned char*)(0x42DE0504UL))
#define bFM_GPIO_PFRA_P2                      *((volatile unsigned char*)(0x42DE0508UL))
#define bFM_GPIO_PFRA_P3                      *((volatile unsigned char*)(0x42DE050CUL))
#define bFM_GPIO_PFRA_P4                      *((volatile unsigned char*)(0x42DE0510UL))
#define bFM_GPIO_PFRA_P5                      *((volatile unsigned char*)(0x42DE0514UL))
#define bFM_GPIO_PFRA_P6                      *((volatile unsigned char*)(0x42DE0518UL))
#define bFM_GPIO_PFRA_P7                      *((volatile unsigned char*)(0x42DE051CUL))
#define bFM_GPIO_PFRA_P8                      *((volatile unsigned char*)(0x42DE0520UL))
#define bFM_GPIO_PFRA_P9                      *((volatile unsigned char*)(0x42DE0524UL))
#define bFM_GPIO_PFRA_PA                      *((volatile unsigned char*)(0x42DE0528UL))
#define bFM_GPIO_PFRA_PB                      *((volatile unsigned char*)(0x42DE052CUL))
#define bFM_GPIO_PFRA_PC                      *((volatile unsigned char*)(0x42DE0530UL))
#define bFM_GPIO_PFRA_PD                      *((volatile unsigned char*)(0x42DE0534UL))
#define bFM_GPIO_PFRA_PE                      *((volatile unsigned char*)(0x42DE0538UL))
#define bFM_GPIO_PFRA_PF                      *((volatile unsigned char*)(0x42DE053CUL))
#define bFM_GPIO_PFRB_P0                      *((volatile unsigned char*)(0x42DE0580UL))
#define bFM_GPIO_PFRB_P1                      *((volatile unsigned char*)(0x42DE0584UL))
#define bFM_GPIO_PFRB_P2                      *((volatile unsigned char*)(0x42DE0588UL))
#define bFM_GPIO_PFRB_P3                      *((volatile unsigned char*)(0x42DE058CUL))
#define bFM_GPIO_PFRB_P4                      *((volatile unsigned char*)(0x42DE0590UL))
#define bFM_GPIO_PFRB_P5                      *((volatile unsigned char*)(0x42DE0594UL))
#define bFM_GPIO_PFRB_P6                      *((volatile unsigned char*)(0x42DE0598UL))
#define bFM_GPIO_PFRB_P7                      *((volatile unsigned char*)(0x42DE059CUL))
#define bFM_GPIO_PFRB_P8                      *((volatile unsigned char*)(0x42DE05A0UL))
#define bFM_GPIO_PFRB_P9                      *((volatile unsigned char*)(0x42DE05A4UL))
#define bFM_GPIO_PFRB_PA                      *((volatile unsigned char*)(0x42DE05A8UL))
#define bFM_GPIO_PFRB_PB                      *((volatile unsigned char*)(0x42DE05ACUL))
#define bFM_GPIO_PFRB_PC                      *((volatile unsigned char*)(0x42DE05B0UL))
#define bFM_GPIO_PFRB_PD                      *((volatile unsigned char*)(0x42DE05B4UL))
#define bFM_GPIO_PFRB_PE                      *((volatile unsigned char*)(0x42DE05B8UL))
#define bFM_GPIO_PFRB_PF                      *((volatile unsigned char*)(0x42DE05BCUL))
#define bFM_GPIO_PFRC_P0                      *((volatile unsigned char*)(0x42DE0600UL))
#define bFM_GPIO_PFRC_P1                      *((volatile unsigned char*)(0x42DE0604UL))
#define bFM_GPIO_PFRC_P2                      *((volatile unsigned char*)(0x42DE0608UL))
#define bFM_GPIO_PFRC_P3                      *((volatile unsigned char*)(0x42DE060CUL))
#define bFM_GPIO_PFRC_P4                      *((volatile unsigned char*)(0x42DE0610UL))
#define bFM_GPIO_PFRC_P5                      *((volatile unsigned char*)(0x42DE0614UL))
#define bFM_GPIO_PFRC_P6                      *((volatile unsigned char*)(0x42DE0618UL))
#define bFM_GPIO_PFRC_P7                      *((volatile unsigned char*)(0x42DE061CUL))
#define bFM_GPIO_PFRC_P8                      *((volatile unsigned char*)(0x42DE0620UL))
#define bFM_GPIO_PFRC_P9                      *((volatile unsigned char*)(0x42DE0624UL))
#define bFM_GPIO_PFRC_PA                      *((volatile unsigned char*)(0x42DE0628UL))
#define bFM_GPIO_PFRC_PB                      *((volatile unsigned char*)(0x42DE062CUL))
#define bFM_GPIO_PFRC_PC                      *((volatile unsigned char*)(0x42DE0630UL))
#define bFM_GPIO_PFRC_PD                      *((volatile unsigned char*)(0x42DE0634UL))
#define bFM_GPIO_PFRC_PE                      *((volatile unsigned char*)(0x42DE0638UL))
#define bFM_GPIO_PFRC_PF                      *((volatile unsigned char*)(0x42DE063CUL))
#define bFM_GPIO_PFRD_P0                      *((volatile unsigned char*)(0x42DE0680UL))
#define bFM_GPIO_PFRD_P1                      *((volatile unsigned char*)(0x42DE0684UL))
#define bFM_GPIO_PFRD_P2                      *((volatile unsigned char*)(0x42DE0688UL))
#define bFM_GPIO_PFRE_P0                      *((volatile unsigned char*)(0x42DE0700UL))
#define bFM_GPIO_PFRE_P2                      *((volatile unsigned char*)(0x42DE0708UL))
#define bFM_GPIO_PFRE_P3                      *((volatile unsigned char*)(0x42DE070CUL))
#define bFM_GPIO_PFRF_P0                      *((volatile unsigned char*)(0x42DE0780UL))
#define bFM_GPIO_PFRF_P1                      *((volatile unsigned char*)(0x42DE0784UL))
#define bFM_GPIO_PFRF_P2                      *((volatile unsigned char*)(0x42DE0788UL))
#define bFM_GPIO_PFRF_P3                      *((volatile unsigned char*)(0x42DE078CUL))
#define bFM_GPIO_PFRF_P4                      *((volatile unsigned char*)(0x42DE0790UL))
#define bFM_GPIO_PFRF_P5                      *((volatile unsigned char*)(0x42DE0794UL))
#define bFM_GPIO_PFRF_P6                      *((volatile unsigned char*)(0x42DE0798UL))
#define bFM_GPIO_PFRF_P7                      *((volatile unsigned char*)(0x42DE079CUL))
#define bFM_GPIO_PFRF_P8                      *((volatile unsigned char*)(0x42DE07A0UL))
#define bFM_GPIO_PFRF_P9                      *((volatile unsigned char*)(0x42DE07A4UL))
#define bFM_GPIO_PFRF_PA                      *((volatile unsigned char*)(0x42DE07A8UL))
#define bFM_GPIO_PFRF_PB                      *((volatile unsigned char*)(0x42DE07ACUL))
#define bFM_GPIO_PFRF_PC                      *((volatile unsigned char*)(0x42DE07B0UL))
#define bFM_GPIO_PCR0_P0                      *((volatile unsigned char*)(0x42DE2000UL))
#define bFM_GPIO_PCR0_P1                      *((volatile unsigned char*)(0x42DE2004UL))
#define bFM_GPIO_PCR0_P2                      *((volatile unsigned char*)(0x42DE2008UL))
#define bFM_GPIO_PCR0_P3                      *((volatile unsigned char*)(0x42DE200CUL))
#define bFM_GPIO_PCR0_P4                      *((volatile unsigned char*)(0x42DE2010UL))
#define bFM_GPIO_PCR0_P8                      *((volatile unsigned char*)(0x42DE2020UL))
#define bFM_GPIO_PCR0_P9                      *((volatile unsigned char*)(0x42DE2024UL))
#define bFM_GPIO_PCR0_PA                      *((volatile unsigned char*)(0x42DE2028UL))
#define bFM_GPIO_PCR1_P0                      *((volatile unsigned char*)(0x42DE2080UL))
#define bFM_GPIO_PCR1_P1                      *((volatile unsigned char*)(0x42DE2084UL))
#define bFM_GPIO_PCR1_P2                      *((volatile unsigned char*)(0x42DE2088UL))
#define bFM_GPIO_PCR1_P3                      *((volatile unsigned char*)(0x42DE208CUL))
#define bFM_GPIO_PCR1_P4                      *((volatile unsigned char*)(0x42DE2090UL))
#define bFM_GPIO_PCR1_P5                      *((volatile unsigned char*)(0x42DE2094UL))
#define bFM_GPIO_PCR1_P6                      *((volatile unsigned char*)(0x42DE2098UL))
#define bFM_GPIO_PCR1_P7                      *((volatile unsigned char*)(0x42DE209CUL))
#define bFM_GPIO_PCR1_P8                      *((volatile unsigned char*)(0x42DE20A0UL))
#define bFM_GPIO_PCR1_P9                      *((volatile unsigned char*)(0x42DE20A4UL))
#define bFM_GPIO_PCR1_PA                      *((volatile unsigned char*)(0x42DE20A8UL))
#define bFM_GPIO_PCR1_PB                      *((volatile unsigned char*)(0x42DE20ACUL))
#define bFM_GPIO_PCR1_PC                      *((volatile unsigned char*)(0x42DE20B0UL))
#define bFM_GPIO_PCR1_PD                      *((volatile unsigned char*)(0x42DE20B4UL))
#define bFM_GPIO_PCR1_PE                      *((volatile unsigned char*)(0x42DE20B8UL))
#define bFM_GPIO_PCR1_PF                      *((volatile unsigned char*)(0x42DE20BCUL))
#define bFM_GPIO_PCR2_P0                      *((volatile unsigned char*)(0x42DE2100UL))
#define bFM_GPIO_PCR2_P1                      *((volatile unsigned char*)(0x42DE2104UL))
#define bFM_GPIO_PCR2_P2                      *((volatile unsigned char*)(0x42DE2108UL))
#define bFM_GPIO_PCR2_P3                      *((volatile unsigned char*)(0x42DE210CUL))
#define bFM_GPIO_PCR2_P4                      *((volatile unsigned char*)(0x42DE2110UL))
#define bFM_GPIO_PCR2_P5                      *((volatile unsigned char*)(0x42DE2114UL))
#define bFM_GPIO_PCR2_P6                      *((volatile unsigned char*)(0x42DE2118UL))
#define bFM_GPIO_PCR2_P7                      *((volatile unsigned char*)(0x42DE211CUL))
#define bFM_GPIO_PCR2_P8                      *((volatile unsigned char*)(0x42DE2120UL))
#define bFM_GPIO_PCR2_P9                      *((volatile unsigned char*)(0x42DE2124UL))
#define bFM_GPIO_PCR2_PA                      *((volatile unsigned char*)(0x42DE2128UL))
#define bFM_GPIO_PCR3_P0                      *((volatile unsigned char*)(0x42DE2180UL))
#define bFM_GPIO_PCR3_P1                      *((volatile unsigned char*)(0x42DE2184UL))
#define bFM_GPIO_PCR3_P2                      *((volatile unsigned char*)(0x42DE2188UL))
#define bFM_GPIO_PCR3_P3                      *((volatile unsigned char*)(0x42DE218CUL))
#define bFM_GPIO_PCR3_P4                      *((volatile unsigned char*)(0x42DE2190UL))
#define bFM_GPIO_PCR3_P5                      *((volatile unsigned char*)(0x42DE2194UL))
#define bFM_GPIO_PCR3_P6                      *((volatile unsigned char*)(0x42DE2198UL))
#define bFM_GPIO_PCR3_P7                      *((volatile unsigned char*)(0x42DE219CUL))
#define bFM_GPIO_PCR3_P8                      *((volatile unsigned char*)(0x42DE21A0UL))
#define bFM_GPIO_PCR3_P9                      *((volatile unsigned char*)(0x42DE21A4UL))
#define bFM_GPIO_PCR3_PA                      *((volatile unsigned char*)(0x42DE21A8UL))
#define bFM_GPIO_PCR3_PB                      *((volatile unsigned char*)(0x42DE21ACUL))
#define bFM_GPIO_PCR3_PC                      *((volatile unsigned char*)(0x42DE21B0UL))
#define bFM_GPIO_PCR3_PD                      *((volatile unsigned char*)(0x42DE21B4UL))
#define bFM_GPIO_PCR3_PE                      *((volatile unsigned char*)(0x42DE21B8UL))
#define bFM_GPIO_PCR4_P0                      *((volatile unsigned char*)(0x42DE2200UL))
#define bFM_GPIO_PCR4_P1                      *((volatile unsigned char*)(0x42DE2204UL))
#define bFM_GPIO_PCR4_P2                      *((volatile unsigned char*)(0x42DE2208UL))
#define bFM_GPIO_PCR4_P3                      *((volatile unsigned char*)(0x42DE220CUL))
#define bFM_GPIO_PCR4_P4                      *((volatile unsigned char*)(0x42DE2210UL))
#define bFM_GPIO_PCR4_P5                      *((volatile unsigned char*)(0x42DE2214UL))
#define bFM_GPIO_PCR4_P6                      *((volatile unsigned char*)(0x42DE2218UL))
#define bFM_GPIO_PCR4_P7                      *((volatile unsigned char*)(0x42DE221CUL))
#define bFM_GPIO_PCR4_P8                      *((volatile unsigned char*)(0x42DE2220UL))
#define bFM_GPIO_PCR4_P9                      *((volatile unsigned char*)(0x42DE2224UL))
#define bFM_GPIO_PCR4_PA                      *((volatile unsigned char*)(0x42DE2228UL))
#define bFM_GPIO_PCR4_PB                      *((volatile unsigned char*)(0x42DE222CUL))
#define bFM_GPIO_PCR4_PC                      *((volatile unsigned char*)(0x42DE2230UL))
#define bFM_GPIO_PCR4_PD                      *((volatile unsigned char*)(0x42DE2234UL))
#define bFM_GPIO_PCR4_PE                      *((volatile unsigned char*)(0x42DE2238UL))
#define bFM_GPIO_PCR5_P0                      *((volatile unsigned char*)(0x42DE2280UL))
#define bFM_GPIO_PCR5_P1                      *((volatile unsigned char*)(0x42DE2284UL))
#define bFM_GPIO_PCR5_P2                      *((volatile unsigned char*)(0x42DE2288UL))
#define bFM_GPIO_PCR5_P3                      *((volatile unsigned char*)(0x42DE228CUL))
#define bFM_GPIO_PCR5_P4                      *((volatile unsigned char*)(0x42DE2290UL))
#define bFM_GPIO_PCR5_P5                      *((volatile unsigned char*)(0x42DE2294UL))
#define bFM_GPIO_PCR5_P6                      *((volatile unsigned char*)(0x42DE2298UL))
#define bFM_GPIO_PCR5_P7                      *((volatile unsigned char*)(0x42DE229CUL))
#define bFM_GPIO_PCR5_P8                      *((volatile unsigned char*)(0x42DE22A0UL))
#define bFM_GPIO_PCR5_P9                      *((volatile unsigned char*)(0x42DE22A4UL))
#define bFM_GPIO_PCR5_PA                      *((volatile unsigned char*)(0x42DE22A8UL))
#define bFM_GPIO_PCR5_PB                      *((volatile unsigned char*)(0x42DE22ACUL))
#define bFM_GPIO_PCR5_PC                      *((volatile unsigned char*)(0x42DE22B0UL))
#define bFM_GPIO_PCR5_PD                      *((volatile unsigned char*)(0x42DE22B4UL))
#define bFM_GPIO_PCR5_PE                      *((volatile unsigned char*)(0x42DE22B8UL))
#define bFM_GPIO_PCR5_PF                      *((volatile unsigned char*)(0x42DE22BCUL))
#define bFM_GPIO_PCR6_P0                      *((volatile unsigned char*)(0x42DE2300UL))
#define bFM_GPIO_PCR6_P1                      *((volatile unsigned char*)(0x42DE2304UL))
#define bFM_GPIO_PCR6_P2                      *((volatile unsigned char*)(0x42DE2308UL))
#define bFM_GPIO_PCR6_P3                      *((volatile unsigned char*)(0x42DE230CUL))
#define bFM_GPIO_PCR6_P4                      *((volatile unsigned char*)(0x42DE2310UL))
#define bFM_GPIO_PCR6_P5                      *((volatile unsigned char*)(0x42DE2314UL))
#define bFM_GPIO_PCR6_P6                      *((volatile unsigned char*)(0x42DE2318UL))
#define bFM_GPIO_PCR6_P7                      *((volatile unsigned char*)(0x42DE231CUL))
#define bFM_GPIO_PCR6_P8                      *((volatile unsigned char*)(0x42DE2320UL))
#define bFM_GPIO_PCR6_P9                      *((volatile unsigned char*)(0x42DE2324UL))
#define bFM_GPIO_PCR6_PA                      *((volatile unsigned char*)(0x42DE2328UL))
#define bFM_GPIO_PCR6_PB                      *((volatile unsigned char*)(0x42DE232CUL))
#define bFM_GPIO_PCR6_PC                      *((volatile unsigned char*)(0x42DE2330UL))
#define bFM_GPIO_PCR6_PD                      *((volatile unsigned char*)(0x42DE2334UL))
#define bFM_GPIO_PCR6_PE                      *((volatile unsigned char*)(0x42DE2338UL))
#define bFM_GPIO_PCR7_P0                      *((volatile unsigned char*)(0x42DE2380UL))
#define bFM_GPIO_PCR7_P1                      *((volatile unsigned char*)(0x42DE2384UL))
#define bFM_GPIO_PCR7_P2                      *((volatile unsigned char*)(0x42DE2388UL))
#define bFM_GPIO_PCR7_P3                      *((volatile unsigned char*)(0x42DE238CUL))
#define bFM_GPIO_PCR7_P4                      *((volatile unsigned char*)(0x42DE2390UL))
#define bFM_GPIO_PCR7_P5                      *((volatile unsigned char*)(0x42DE2394UL))
#define bFM_GPIO_PCR7_P6                      *((volatile unsigned char*)(0x42DE2398UL))
#define bFM_GPIO_PCR7_P7                      *((volatile unsigned char*)(0x42DE239CUL))
#define bFM_GPIO_PCR7_P8                      *((volatile unsigned char*)(0x42DE23A0UL))
#define bFM_GPIO_PCR7_P9                      *((volatile unsigned char*)(0x42DE23A4UL))
#define bFM_GPIO_PCR7_PA                      *((volatile unsigned char*)(0x42DE23A8UL))
#define bFM_GPIO_PCR7_PB                      *((volatile unsigned char*)(0x42DE23ACUL))
#define bFM_GPIO_PCR7_PC                      *((volatile unsigned char*)(0x42DE23B0UL))
#define bFM_GPIO_PCR7_PD                      *((volatile unsigned char*)(0x42DE23B4UL))
#define bFM_GPIO_PCR7_PE                      *((volatile unsigned char*)(0x42DE23B8UL))
#define bFM_GPIO_PCR8_P0                      *((volatile unsigned char*)(0x42DE2400UL))
#define bFM_GPIO_PCR8_P1                      *((volatile unsigned char*)(0x42DE2404UL))
#define bFM_GPIO_PCR8_P2                      *((volatile unsigned char*)(0x42DE2408UL))
#define bFM_GPIO_PCR8_P3                      *((volatile unsigned char*)(0x42DE240CUL))
#define bFM_GPIO_PCR9_P0                      *((volatile unsigned char*)(0x42DE2480UL))
#define bFM_GPIO_PCR9_P1                      *((volatile unsigned char*)(0x42DE2484UL))
#define bFM_GPIO_PCR9_P2                      *((volatile unsigned char*)(0x42DE2488UL))
#define bFM_GPIO_PCR9_P3                      *((volatile unsigned char*)(0x42DE248CUL))
#define bFM_GPIO_PCR9_P4                      *((volatile unsigned char*)(0x42DE2490UL))
#define bFM_GPIO_PCR9_P5                      *((volatile unsigned char*)(0x42DE2494UL))
#define bFM_GPIO_PCR9_P6                      *((volatile unsigned char*)(0x42DE2498UL))
#define bFM_GPIO_PCR9_P7                      *((volatile unsigned char*)(0x42DE249CUL))
#define bFM_GPIO_PCRA_P0                      *((volatile unsigned char*)(0x42DE2500UL))
#define bFM_GPIO_PCRA_P1                      *((volatile unsigned char*)(0x42DE2504UL))
#define bFM_GPIO_PCRA_P2                      *((volatile unsigned char*)(0x42DE2508UL))
#define bFM_GPIO_PCRA_P3                      *((volatile unsigned char*)(0x42DE250CUL))
#define bFM_GPIO_PCRA_P4                      *((volatile unsigned char*)(0x42DE2510UL))
#define bFM_GPIO_PCRA_P5                      *((volatile unsigned char*)(0x42DE2514UL))
#define bFM_GPIO_PCRA_P6                      *((volatile unsigned char*)(0x42DE2518UL))
#define bFM_GPIO_PCRA_P7                      *((volatile unsigned char*)(0x42DE251CUL))
#define bFM_GPIO_PCRA_P8                      *((volatile unsigned char*)(0x42DE2520UL))
#define bFM_GPIO_PCRA_P9                      *((volatile unsigned char*)(0x42DE2524UL))
#define bFM_GPIO_PCRA_PA                      *((volatile unsigned char*)(0x42DE2528UL))
#define bFM_GPIO_PCRA_PB                      *((volatile unsigned char*)(0x42DE252CUL))
#define bFM_GPIO_PCRA_PC                      *((volatile unsigned char*)(0x42DE2530UL))
#define bFM_GPIO_PCRA_PD                      *((volatile unsigned char*)(0x42DE2534UL))
#define bFM_GPIO_PCRA_PE                      *((volatile unsigned char*)(0x42DE2538UL))
#define bFM_GPIO_PCRA_PF                      *((volatile unsigned char*)(0x42DE253CUL))
#define bFM_GPIO_PCRB_P0                      *((volatile unsigned char*)(0x42DE2580UL))
#define bFM_GPIO_PCRB_P1                      *((volatile unsigned char*)(0x42DE2584UL))
#define bFM_GPIO_PCRB_P2                      *((volatile unsigned char*)(0x42DE2588UL))
#define bFM_GPIO_PCRB_P3                      *((volatile unsigned char*)(0x42DE258CUL))
#define bFM_GPIO_PCRB_P4                      *((volatile unsigned char*)(0x42DE2590UL))
#define bFM_GPIO_PCRB_P5                      *((volatile unsigned char*)(0x42DE2594UL))
#define bFM_GPIO_PCRB_P6                      *((volatile unsigned char*)(0x42DE2598UL))
#define bFM_GPIO_PCRB_P7                      *((volatile unsigned char*)(0x42DE259CUL))
#define bFM_GPIO_PCRB_P8                      *((volatile unsigned char*)(0x42DE25A0UL))
#define bFM_GPIO_PCRB_P9                      *((volatile unsigned char*)(0x42DE25A4UL))
#define bFM_GPIO_PCRB_PA                      *((volatile unsigned char*)(0x42DE25A8UL))
#define bFM_GPIO_PCRB_PB                      *((volatile unsigned char*)(0x42DE25ACUL))
#define bFM_GPIO_PCRB_PC                      *((volatile unsigned char*)(0x42DE25B0UL))
#define bFM_GPIO_PCRB_PD                      *((volatile unsigned char*)(0x42DE25B4UL))
#define bFM_GPIO_PCRB_PE                      *((volatile unsigned char*)(0x42DE25B8UL))
#define bFM_GPIO_PCRB_PF                      *((volatile unsigned char*)(0x42DE25BCUL))
#define bFM_GPIO_PCRC_P0                      *((volatile unsigned char*)(0x42DE2600UL))
#define bFM_GPIO_PCRC_P1                      *((volatile unsigned char*)(0x42DE2604UL))
#define bFM_GPIO_PCRC_P2                      *((volatile unsigned char*)(0x42DE2608UL))
#define bFM_GPIO_PCRC_P3                      *((volatile unsigned char*)(0x42DE260CUL))
#define bFM_GPIO_PCRC_P4                      *((volatile unsigned char*)(0x42DE2610UL))
#define bFM_GPIO_PCRC_P5                      *((volatile unsigned char*)(0x42DE2614UL))
#define bFM_GPIO_PCRC_P6                      *((volatile unsigned char*)(0x42DE2618UL))
#define bFM_GPIO_PCRC_P7                      *((volatile unsigned char*)(0x42DE261CUL))
#define bFM_GPIO_PCRC_P8                      *((volatile unsigned char*)(0x42DE2620UL))
#define bFM_GPIO_PCRC_P9                      *((volatile unsigned char*)(0x42DE2624UL))
#define bFM_GPIO_PCRC_PA                      *((volatile unsigned char*)(0x42DE2628UL))
#define bFM_GPIO_PCRC_PB                      *((volatile unsigned char*)(0x42DE262CUL))
#define bFM_GPIO_PCRC_PC                      *((volatile unsigned char*)(0x42DE2630UL))
#define bFM_GPIO_PCRC_PD                      *((volatile unsigned char*)(0x42DE2634UL))
#define bFM_GPIO_PCRC_PE                      *((volatile unsigned char*)(0x42DE2638UL))
#define bFM_GPIO_PCRC_PF                      *((volatile unsigned char*)(0x42DE263CUL))
#define bFM_GPIO_PCRD_P0                      *((volatile unsigned char*)(0x42DE2680UL))
#define bFM_GPIO_PCRD_P1                      *((volatile unsigned char*)(0x42DE2684UL))
#define bFM_GPIO_PCRD_P2                      *((volatile unsigned char*)(0x42DE2688UL))
#define bFM_GPIO_PCRE_P0                      *((volatile unsigned char*)(0x42DE2700UL))
#define bFM_GPIO_PCRE_P2                      *((volatile unsigned char*)(0x42DE2708UL))
#define bFM_GPIO_PCRE_P3                      *((volatile unsigned char*)(0x42DE270CUL))
#define bFM_GPIO_PCRF_P0                      *((volatile unsigned char*)(0x42DE2780UL))
#define bFM_GPIO_PCRF_P1                      *((volatile unsigned char*)(0x42DE2784UL))
#define bFM_GPIO_PCRF_P2                      *((volatile unsigned char*)(0x42DE2788UL))
#define bFM_GPIO_PCRF_P3                      *((volatile unsigned char*)(0x42DE278CUL))
#define bFM_GPIO_PCRF_P4                      *((volatile unsigned char*)(0x42DE2790UL))
#define bFM_GPIO_PCRF_P5                      *((volatile unsigned char*)(0x42DE2794UL))
#define bFM_GPIO_PCRF_P6                      *((volatile unsigned char*)(0x42DE2798UL))
#define bFM_GPIO_PCRF_P7                      *((volatile unsigned char*)(0x42DE279CUL))
#define bFM_GPIO_PCRF_P8                      *((volatile unsigned char*)(0x42DE27A0UL))
#define bFM_GPIO_PCRF_P9                      *((volatile unsigned char*)(0x42DE27A4UL))
#define bFM_GPIO_PCRF_PA                      *((volatile unsigned char*)(0x42DE27A8UL))
#define bFM_GPIO_PCRF_PB                      *((volatile unsigned char*)(0x42DE27ACUL))
#define bFM_GPIO_PCRF_PC                      *((volatile unsigned char*)(0x42DE27B0UL))
#define bFM_GPIO_DDR0_P0                      *((volatile unsigned char*)(0x42DE4000UL))
#define bFM_GPIO_DDR0_P1                      *((volatile unsigned char*)(0x42DE4004UL))
#define bFM_GPIO_DDR0_P2                      *((volatile unsigned char*)(0x42DE4008UL))
#define bFM_GPIO_DDR0_P3                      *((volatile unsigned char*)(0x42DE400CUL))
#define bFM_GPIO_DDR0_P4                      *((volatile unsigned char*)(0x42DE4010UL))
#define bFM_GPIO_DDR0_P5                      *((volatile unsigned char*)(0x42DE4014UL))
#define bFM_GPIO_DDR0_P6                      *((volatile unsigned char*)(0x42DE4018UL))
#define bFM_GPIO_DDR0_P7                      *((volatile unsigned char*)(0x42DE401CUL))
#define bFM_GPIO_DDR0_P8                      *((volatile unsigned char*)(0x42DE4020UL))
#define bFM_GPIO_DDR0_P9                      *((volatile unsigned char*)(0x42DE4024UL))
#define bFM_GPIO_DDR0_PA                      *((volatile unsigned char*)(0x42DE4028UL))
#define bFM_GPIO_DDR0_PB                      *((volatile unsigned char*)(0x42DE402CUL))
#define bFM_GPIO_DDR0_PC                      *((volatile unsigned char*)(0x42DE4030UL))
#define bFM_GPIO_DDR0_PD                      *((volatile unsigned char*)(0x42DE4034UL))
#define bFM_GPIO_DDR0_PE                      *((volatile unsigned char*)(0x42DE4038UL))
#define bFM_GPIO_DDR1_P0                      *((volatile unsigned char*)(0x42DE4080UL))
#define bFM_GPIO_DDR1_P1                      *((volatile unsigned char*)(0x42DE4084UL))
#define bFM_GPIO_DDR1_P2                      *((volatile unsigned char*)(0x42DE4088UL))
#define bFM_GPIO_DDR1_P3                      *((volatile unsigned char*)(0x42DE408CUL))
#define bFM_GPIO_DDR1_P4                      *((volatile unsigned char*)(0x42DE4090UL))
#define bFM_GPIO_DDR1_P5                      *((volatile unsigned char*)(0x42DE4094UL))
#define bFM_GPIO_DDR1_P6                      *((volatile unsigned char*)(0x42DE4098UL))
#define bFM_GPIO_DDR1_P7                      *((volatile unsigned char*)(0x42DE409CUL))
#define bFM_GPIO_DDR1_P8                      *((volatile unsigned char*)(0x42DE40A0UL))
#define bFM_GPIO_DDR1_P9                      *((volatile unsigned char*)(0x42DE40A4UL))
#define bFM_GPIO_DDR1_PA                      *((volatile unsigned char*)(0x42DE40A8UL))
#define bFM_GPIO_DDR1_PB                      *((volatile unsigned char*)(0x42DE40ACUL))
#define bFM_GPIO_DDR1_PC                      *((volatile unsigned char*)(0x42DE40B0UL))
#define bFM_GPIO_DDR1_PD                      *((volatile unsigned char*)(0x42DE40B4UL))
#define bFM_GPIO_DDR1_PE                      *((volatile unsigned char*)(0x42DE40B8UL))
#define bFM_GPIO_DDR1_PF                      *((volatile unsigned char*)(0x42DE40BCUL))
#define bFM_GPIO_DDR2_P0                      *((volatile unsigned char*)(0x42DE4100UL))
#define bFM_GPIO_DDR2_P1                      *((volatile unsigned char*)(0x42DE4104UL))
#define bFM_GPIO_DDR2_P2                      *((volatile unsigned char*)(0x42DE4108UL))
#define bFM_GPIO_DDR2_P3                      *((volatile unsigned char*)(0x42DE410CUL))
#define bFM_GPIO_DDR2_P4                      *((volatile unsigned char*)(0x42DE4110UL))
#define bFM_GPIO_DDR2_P5                      *((volatile unsigned char*)(0x42DE4114UL))
#define bFM_GPIO_DDR2_P6                      *((volatile unsigned char*)(0x42DE4118UL))
#define bFM_GPIO_DDR2_P7                      *((volatile unsigned char*)(0x42DE411CUL))
#define bFM_GPIO_DDR2_P8                      *((volatile unsigned char*)(0x42DE4120UL))
#define bFM_GPIO_DDR2_P9                      *((volatile unsigned char*)(0x42DE4124UL))
#define bFM_GPIO_DDR2_PA                      *((volatile unsigned char*)(0x42DE4128UL))
#define bFM_GPIO_DDR3_P0                      *((volatile unsigned char*)(0x42DE4180UL))
#define bFM_GPIO_DDR3_P1                      *((volatile unsigned char*)(0x42DE4184UL))
#define bFM_GPIO_DDR3_P2                      *((volatile unsigned char*)(0x42DE4188UL))
#define bFM_GPIO_DDR3_P3                      *((volatile unsigned char*)(0x42DE418CUL))
#define bFM_GPIO_DDR3_P4                      *((volatile unsigned char*)(0x42DE4190UL))
#define bFM_GPIO_DDR3_P5                      *((volatile unsigned char*)(0x42DE4194UL))
#define bFM_GPIO_DDR3_P6                      *((volatile unsigned char*)(0x42DE4198UL))
#define bFM_GPIO_DDR3_P7                      *((volatile unsigned char*)(0x42DE419CUL))
#define bFM_GPIO_DDR3_P8                      *((volatile unsigned char*)(0x42DE41A0UL))
#define bFM_GPIO_DDR3_P9                      *((volatile unsigned char*)(0x42DE41A4UL))
#define bFM_GPIO_DDR3_PA                      *((volatile unsigned char*)(0x42DE41A8UL))
#define bFM_GPIO_DDR3_PB                      *((volatile unsigned char*)(0x42DE41ACUL))
#define bFM_GPIO_DDR3_PC                      *((volatile unsigned char*)(0x42DE41B0UL))
#define bFM_GPIO_DDR3_PD                      *((volatile unsigned char*)(0x42DE41B4UL))
#define bFM_GPIO_DDR3_PE                      *((volatile unsigned char*)(0x42DE41B8UL))
#define bFM_GPIO_DDR4_P0                      *((volatile unsigned char*)(0x42DE4200UL))
#define bFM_GPIO_DDR4_P1                      *((volatile unsigned char*)(0x42DE4204UL))
#define bFM_GPIO_DDR4_P2                      *((volatile unsigned char*)(0x42DE4208UL))
#define bFM_GPIO_DDR4_P3                      *((volatile unsigned char*)(0x42DE420CUL))
#define bFM_GPIO_DDR4_P4                      *((volatile unsigned char*)(0x42DE4210UL))
#define bFM_GPIO_DDR4_P5                      *((volatile unsigned char*)(0x42DE4214UL))
#define bFM_GPIO_DDR4_P6                      *((volatile unsigned char*)(0x42DE4218UL))
#define bFM_GPIO_DDR4_P7                      *((volatile unsigned char*)(0x42DE421CUL))
#define bFM_GPIO_DDR4_P8                      *((volatile unsigned char*)(0x42DE4220UL))
#define bFM_GPIO_DDR4_P9                      *((volatile unsigned char*)(0x42DE4224UL))
#define bFM_GPIO_DDR4_PA                      *((volatile unsigned char*)(0x42DE4228UL))
#define bFM_GPIO_DDR4_PB                      *((volatile unsigned char*)(0x42DE422CUL))
#define bFM_GPIO_DDR4_PC                      *((volatile unsigned char*)(0x42DE4230UL))
#define bFM_GPIO_DDR4_PD                      *((volatile unsigned char*)(0x42DE4234UL))
#define bFM_GPIO_DDR4_PE                      *((volatile unsigned char*)(0x42DE4238UL))
#define bFM_GPIO_DDR5_P0                      *((volatile unsigned char*)(0x42DE4280UL))
#define bFM_GPIO_DDR5_P1                      *((volatile unsigned char*)(0x42DE4284UL))
#define bFM_GPIO_DDR5_P2                      *((volatile unsigned char*)(0x42DE4288UL))
#define bFM_GPIO_DDR5_P3                      *((volatile unsigned char*)(0x42DE428CUL))
#define bFM_GPIO_DDR5_P4                      *((volatile unsigned char*)(0x42DE4290UL))
#define bFM_GPIO_DDR5_P5                      *((volatile unsigned char*)(0x42DE4294UL))
#define bFM_GPIO_DDR5_P6                      *((volatile unsigned char*)(0x42DE4298UL))
#define bFM_GPIO_DDR5_P7                      *((volatile unsigned char*)(0x42DE429CUL))
#define bFM_GPIO_DDR5_P8                      *((volatile unsigned char*)(0x42DE42A0UL))
#define bFM_GPIO_DDR5_P9                      *((volatile unsigned char*)(0x42DE42A4UL))
#define bFM_GPIO_DDR5_PA                      *((volatile unsigned char*)(0x42DE42A8UL))
#define bFM_GPIO_DDR5_PB                      *((volatile unsigned char*)(0x42DE42ACUL))
#define bFM_GPIO_DDR5_PC                      *((volatile unsigned char*)(0x42DE42B0UL))
#define bFM_GPIO_DDR5_PD                      *((volatile unsigned char*)(0x42DE42B4UL))
#define bFM_GPIO_DDR5_PE                      *((volatile unsigned char*)(0x42DE42B8UL))
#define bFM_GPIO_DDR5_PF                      *((volatile unsigned char*)(0x42DE42BCUL))
#define bFM_GPIO_DDR6_P0                      *((volatile unsigned char*)(0x42DE4300UL))
#define bFM_GPIO_DDR6_P1                      *((volatile unsigned char*)(0x42DE4304UL))
#define bFM_GPIO_DDR6_P2                      *((volatile unsigned char*)(0x42DE4308UL))
#define bFM_GPIO_DDR6_P3                      *((volatile unsigned char*)(0x42DE430CUL))
#define bFM_GPIO_DDR6_P4                      *((volatile unsigned char*)(0x42DE4310UL))
#define bFM_GPIO_DDR6_P5                      *((volatile unsigned char*)(0x42DE4314UL))
#define bFM_GPIO_DDR6_P6                      *((volatile unsigned char*)(0x42DE4318UL))
#define bFM_GPIO_DDR6_P7                      *((volatile unsigned char*)(0x42DE431CUL))
#define bFM_GPIO_DDR6_P8                      *((volatile unsigned char*)(0x42DE4320UL))
#define bFM_GPIO_DDR6_P9                      *((volatile unsigned char*)(0x42DE4324UL))
#define bFM_GPIO_DDR6_PA                      *((volatile unsigned char*)(0x42DE4328UL))
#define bFM_GPIO_DDR6_PB                      *((volatile unsigned char*)(0x42DE432CUL))
#define bFM_GPIO_DDR6_PC                      *((volatile unsigned char*)(0x42DE4330UL))
#define bFM_GPIO_DDR6_PD                      *((volatile unsigned char*)(0x42DE4334UL))
#define bFM_GPIO_DDR6_PE                      *((volatile unsigned char*)(0x42DE4338UL))
#define bFM_GPIO_DDR7_P0                      *((volatile unsigned char*)(0x42DE4380UL))
#define bFM_GPIO_DDR7_P1                      *((volatile unsigned char*)(0x42DE4384UL))
#define bFM_GPIO_DDR7_P2                      *((volatile unsigned char*)(0x42DE4388UL))
#define bFM_GPIO_DDR7_P3                      *((volatile unsigned char*)(0x42DE438CUL))
#define bFM_GPIO_DDR7_P4                      *((volatile unsigned char*)(0x42DE4390UL))
#define bFM_GPIO_DDR7_P5                      *((volatile unsigned char*)(0x42DE4394UL))
#define bFM_GPIO_DDR7_P6                      *((volatile unsigned char*)(0x42DE4398UL))
#define bFM_GPIO_DDR7_P7                      *((volatile unsigned char*)(0x42DE439CUL))
#define bFM_GPIO_DDR7_P8                      *((volatile unsigned char*)(0x42DE43A0UL))
#define bFM_GPIO_DDR7_P9                      *((volatile unsigned char*)(0x42DE43A4UL))
#define bFM_GPIO_DDR7_PA                      *((volatile unsigned char*)(0x42DE43A8UL))
#define bFM_GPIO_DDR7_PB                      *((volatile unsigned char*)(0x42DE43ACUL))
#define bFM_GPIO_DDR7_PC                      *((volatile unsigned char*)(0x42DE43B0UL))
#define bFM_GPIO_DDR7_PD                      *((volatile unsigned char*)(0x42DE43B4UL))
#define bFM_GPIO_DDR7_PE                      *((volatile unsigned char*)(0x42DE43B8UL))
#define bFM_GPIO_DDR8_P0                      *((volatile unsigned char*)(0x42DE4400UL))
#define bFM_GPIO_DDR8_P1                      *((volatile unsigned char*)(0x42DE4404UL))
#define bFM_GPIO_DDR8_P2                      *((volatile unsigned char*)(0x42DE4408UL))
#define bFM_GPIO_DDR8_P3                      *((volatile unsigned char*)(0x42DE440CUL))
#define bFM_GPIO_DDR9_P0                      *((volatile unsigned char*)(0x42DE4480UL))
#define bFM_GPIO_DDR9_P1                      *((volatile unsigned char*)(0x42DE4484UL))
#define bFM_GPIO_DDR9_P2                      *((volatile unsigned char*)(0x42DE4488UL))
#define bFM_GPIO_DDR9_P3                      *((volatile unsigned char*)(0x42DE448CUL))
#define bFM_GPIO_DDR9_P4                      *((volatile unsigned char*)(0x42DE4490UL))
#define bFM_GPIO_DDR9_P5                      *((volatile unsigned char*)(0x42DE4494UL))
#define bFM_GPIO_DDR9_P6                      *((volatile unsigned char*)(0x42DE4498UL))
#define bFM_GPIO_DDR9_P7                      *((volatile unsigned char*)(0x42DE449CUL))
#define bFM_GPIO_DDRA_P0                      *((volatile unsigned char*)(0x42DE4500UL))
#define bFM_GPIO_DDRA_P1                      *((volatile unsigned char*)(0x42DE4504UL))
#define bFM_GPIO_DDRA_P2                      *((volatile unsigned char*)(0x42DE4508UL))
#define bFM_GPIO_DDRA_P3                      *((volatile unsigned char*)(0x42DE450CUL))
#define bFM_GPIO_DDRA_P4                      *((volatile unsigned char*)(0x42DE4510UL))
#define bFM_GPIO_DDRA_P5                      *((volatile unsigned char*)(0x42DE4514UL))
#define bFM_GPIO_DDRA_P6                      *((volatile unsigned char*)(0x42DE4518UL))
#define bFM_GPIO_DDRA_P7                      *((volatile unsigned char*)(0x42DE451CUL))
#define bFM_GPIO_DDRA_P8                      *((volatile unsigned char*)(0x42DE4520UL))
#define bFM_GPIO_DDRA_P9                      *((volatile unsigned char*)(0x42DE4524UL))
#define bFM_GPIO_DDRA_PA                      *((volatile unsigned char*)(0x42DE4528UL))
#define bFM_GPIO_DDRA_PB                      *((volatile unsigned char*)(0x42DE452CUL))
#define bFM_GPIO_DDRA_PC                      *((volatile unsigned char*)(0x42DE4530UL))
#define bFM_GPIO_DDRA_PD                      *((volatile unsigned char*)(0x42DE4534UL))
#define bFM_GPIO_DDRA_PE                      *((volatile unsigned char*)(0x42DE4538UL))
#define bFM_GPIO_DDRA_PF                      *((volatile unsigned char*)(0x42DE453CUL))
#define bFM_GPIO_DDRB_P0                      *((volatile unsigned char*)(0x42DE4580UL))
#define bFM_GPIO_DDRB_P1                      *((volatile unsigned char*)(0x42DE4584UL))
#define bFM_GPIO_DDRB_P2                      *((volatile unsigned char*)(0x42DE4588UL))
#define bFM_GPIO_DDRB_P3                      *((volatile unsigned char*)(0x42DE458CUL))
#define bFM_GPIO_DDRB_P4                      *((volatile unsigned char*)(0x42DE4590UL))
#define bFM_GPIO_DDRB_P5                      *((volatile unsigned char*)(0x42DE4594UL))
#define bFM_GPIO_DDRB_P6                      *((volatile unsigned char*)(0x42DE4598UL))
#define bFM_GPIO_DDRB_P7                      *((volatile unsigned char*)(0x42DE459CUL))
#define bFM_GPIO_DDRB_P8                      *((volatile unsigned char*)(0x42DE45A0UL))
#define bFM_GPIO_DDRB_P9                      *((volatile unsigned char*)(0x42DE45A4UL))
#define bFM_GPIO_DDRB_PA                      *((volatile unsigned char*)(0x42DE45A8UL))
#define bFM_GPIO_DDRB_PB                      *((volatile unsigned char*)(0x42DE45ACUL))
#define bFM_GPIO_DDRB_PC                      *((volatile unsigned char*)(0x42DE45B0UL))
#define bFM_GPIO_DDRB_PD                      *((volatile unsigned char*)(0x42DE45B4UL))
#define bFM_GPIO_DDRB_PE                      *((volatile unsigned char*)(0x42DE45B8UL))
#define bFM_GPIO_DDRB_PF                      *((volatile unsigned char*)(0x42DE45BCUL))
#define bFM_GPIO_DDRC_P0                      *((volatile unsigned char*)(0x42DE4600UL))
#define bFM_GPIO_DDRC_P1                      *((volatile unsigned char*)(0x42DE4604UL))
#define bFM_GPIO_DDRC_P2                      *((volatile unsigned char*)(0x42DE4608UL))
#define bFM_GPIO_DDRC_P3                      *((volatile unsigned char*)(0x42DE460CUL))
#define bFM_GPIO_DDRC_P4                      *((volatile unsigned char*)(0x42DE4610UL))
#define bFM_GPIO_DDRC_P5                      *((volatile unsigned char*)(0x42DE4614UL))
#define bFM_GPIO_DDRC_P6                      *((volatile unsigned char*)(0x42DE4618UL))
#define bFM_GPIO_DDRC_P7                      *((volatile unsigned char*)(0x42DE461CUL))
#define bFM_GPIO_DDRC_P8                      *((volatile unsigned char*)(0x42DE4620UL))
#define bFM_GPIO_DDRC_P9                      *((volatile unsigned char*)(0x42DE4624UL))
#define bFM_GPIO_DDRC_PA                      *((volatile unsigned char*)(0x42DE4628UL))
#define bFM_GPIO_DDRC_PB                      *((volatile unsigned char*)(0x42DE462CUL))
#define bFM_GPIO_DDRC_PC                      *((volatile unsigned char*)(0x42DE4630UL))
#define bFM_GPIO_DDRC_PD                      *((volatile unsigned char*)(0x42DE4634UL))
#define bFM_GPIO_DDRC_PE                      *((volatile unsigned char*)(0x42DE4638UL))
#define bFM_GPIO_DDRC_PF                      *((volatile unsigned char*)(0x42DE463CUL))
#define bFM_GPIO_DDRD_P0                      *((volatile unsigned char*)(0x42DE4680UL))
#define bFM_GPIO_DDRD_P1                      *((volatile unsigned char*)(0x42DE4684UL))
#define bFM_GPIO_DDRD_P2                      *((volatile unsigned char*)(0x42DE4688UL))
#define bFM_GPIO_DDRE_P0                      *((volatile unsigned char*)(0x42DE4700UL))
#define bFM_GPIO_DDRE_P2                      *((volatile unsigned char*)(0x42DE4708UL))
#define bFM_GPIO_DDRE_P3                      *((volatile unsigned char*)(0x42DE470CUL))
#define bFM_GPIO_DDRF_P0                      *((volatile unsigned char*)(0x42DE4780UL))
#define bFM_GPIO_DDRF_P1                      *((volatile unsigned char*)(0x42DE4784UL))
#define bFM_GPIO_DDRF_P2                      *((volatile unsigned char*)(0x42DE4788UL))
#define bFM_GPIO_DDRF_P3                      *((volatile unsigned char*)(0x42DE478CUL))
#define bFM_GPIO_DDRF_P4                      *((volatile unsigned char*)(0x42DE4790UL))
#define bFM_GPIO_DDRF_P5                      *((volatile unsigned char*)(0x42DE4794UL))
#define bFM_GPIO_DDRF_P6                      *((volatile unsigned char*)(0x42DE4798UL))
#define bFM_GPIO_DDRF_P7                      *((volatile unsigned char*)(0x42DE479CUL))
#define bFM_GPIO_DDRF_P8                      *((volatile unsigned char*)(0x42DE47A0UL))
#define bFM_GPIO_DDRF_P9                      *((volatile unsigned char*)(0x42DE47A4UL))
#define bFM_GPIO_DDRF_PA                      *((volatile unsigned char*)(0x42DE47A8UL))
#define bFM_GPIO_DDRF_PB                      *((volatile unsigned char*)(0x42DE47ACUL))
#define bFM_GPIO_DDRF_PC                      *((volatile unsigned char*)(0x42DE47B0UL))
#define bFM_GPIO_PDIR0_P0                     *((volatile unsigned char*)(0x42DE6000UL))
#define bFM_GPIO_PDIR0_P1                     *((volatile unsigned char*)(0x42DE6004UL))
#define bFM_GPIO_PDIR0_P2                     *((volatile unsigned char*)(0x42DE6008UL))
#define bFM_GPIO_PDIR0_P3                     *((volatile unsigned char*)(0x42DE600CUL))
#define bFM_GPIO_PDIR0_P4                     *((volatile unsigned char*)(0x42DE6010UL))
#define bFM_GPIO_PDIR0_P5                     *((volatile unsigned char*)(0x42DE6014UL))
#define bFM_GPIO_PDIR0_P6                     *((volatile unsigned char*)(0x42DE6018UL))
#define bFM_GPIO_PDIR0_P7                     *((volatile unsigned char*)(0x42DE601CUL))
#define bFM_GPIO_PDIR0_P8                     *((volatile unsigned char*)(0x42DE6020UL))
#define bFM_GPIO_PDIR0_P9                     *((volatile unsigned char*)(0x42DE6024UL))
#define bFM_GPIO_PDIR0_PA                     *((volatile unsigned char*)(0x42DE6028UL))
#define bFM_GPIO_PDIR0_PB                     *((volatile unsigned char*)(0x42DE602CUL))
#define bFM_GPIO_PDIR0_PC                     *((volatile unsigned char*)(0x42DE6030UL))
#define bFM_GPIO_PDIR0_PD                     *((volatile unsigned char*)(0x42DE6034UL))
#define bFM_GPIO_PDIR0_PE                     *((volatile unsigned char*)(0x42DE6038UL))
#define bFM_GPIO_PDIR1_P0                     *((volatile unsigned char*)(0x42DE6080UL))
#define bFM_GPIO_PDIR1_P1                     *((volatile unsigned char*)(0x42DE6084UL))
#define bFM_GPIO_PDIR1_P2                     *((volatile unsigned char*)(0x42DE6088UL))
#define bFM_GPIO_PDIR1_P3                     *((volatile unsigned char*)(0x42DE608CUL))
#define bFM_GPIO_PDIR1_P4                     *((volatile unsigned char*)(0x42DE6090UL))
#define bFM_GPIO_PDIR1_P5                     *((volatile unsigned char*)(0x42DE6094UL))
#define bFM_GPIO_PDIR1_P6                     *((volatile unsigned char*)(0x42DE6098UL))
#define bFM_GPIO_PDIR1_P7                     *((volatile unsigned char*)(0x42DE609CUL))
#define bFM_GPIO_PDIR1_P8                     *((volatile unsigned char*)(0x42DE60A0UL))
#define bFM_GPIO_PDIR1_P9                     *((volatile unsigned char*)(0x42DE60A4UL))
#define bFM_GPIO_PDIR1_PA                     *((volatile unsigned char*)(0x42DE60A8UL))
#define bFM_GPIO_PDIR1_PB                     *((volatile unsigned char*)(0x42DE60ACUL))
#define bFM_GPIO_PDIR1_PC                     *((volatile unsigned char*)(0x42DE60B0UL))
#define bFM_GPIO_PDIR1_PD                     *((volatile unsigned char*)(0x42DE60B4UL))
#define bFM_GPIO_PDIR1_PE                     *((volatile unsigned char*)(0x42DE60B8UL))
#define bFM_GPIO_PDIR1_PF                     *((volatile unsigned char*)(0x42DE60BCUL))
#define bFM_GPIO_PDIR2_P0                     *((volatile unsigned char*)(0x42DE6100UL))
#define bFM_GPIO_PDIR2_P1                     *((volatile unsigned char*)(0x42DE6104UL))
#define bFM_GPIO_PDIR2_P2                     *((volatile unsigned char*)(0x42DE6108UL))
#define bFM_GPIO_PDIR2_P3                     *((volatile unsigned char*)(0x42DE610CUL))
#define bFM_GPIO_PDIR2_P4                     *((volatile unsigned char*)(0x42DE6110UL))
#define bFM_GPIO_PDIR2_P5                     *((volatile unsigned char*)(0x42DE6114UL))
#define bFM_GPIO_PDIR2_P6                     *((volatile unsigned char*)(0x42DE6118UL))
#define bFM_GPIO_PDIR2_P7                     *((volatile unsigned char*)(0x42DE611CUL))
#define bFM_GPIO_PDIR2_P8                     *((volatile unsigned char*)(0x42DE6120UL))
#define bFM_GPIO_PDIR2_P9                     *((volatile unsigned char*)(0x42DE6124UL))
#define bFM_GPIO_PDIR2_PA                     *((volatile unsigned char*)(0x42DE6128UL))
#define bFM_GPIO_PDIR3_P0                     *((volatile unsigned char*)(0x42DE6180UL))
#define bFM_GPIO_PDIR3_P1                     *((volatile unsigned char*)(0x42DE6184UL))
#define bFM_GPIO_PDIR3_P2                     *((volatile unsigned char*)(0x42DE6188UL))
#define bFM_GPIO_PDIR3_P3                     *((volatile unsigned char*)(0x42DE618CUL))
#define bFM_GPIO_PDIR3_P4                     *((volatile unsigned char*)(0x42DE6190UL))
#define bFM_GPIO_PDIR3_P5                     *((volatile unsigned char*)(0x42DE6194UL))
#define bFM_GPIO_PDIR3_P6                     *((volatile unsigned char*)(0x42DE6198UL))
#define bFM_GPIO_PDIR3_P7                     *((volatile unsigned char*)(0x42DE619CUL))
#define bFM_GPIO_PDIR3_P8                     *((volatile unsigned char*)(0x42DE61A0UL))
#define bFM_GPIO_PDIR3_P9                     *((volatile unsigned char*)(0x42DE61A4UL))
#define bFM_GPIO_PDIR3_PA                     *((volatile unsigned char*)(0x42DE61A8UL))
#define bFM_GPIO_PDIR3_PB                     *((volatile unsigned char*)(0x42DE61ACUL))
#define bFM_GPIO_PDIR3_PC                     *((volatile unsigned char*)(0x42DE61B0UL))
#define bFM_GPIO_PDIR3_PD                     *((volatile unsigned char*)(0x42DE61B4UL))
#define bFM_GPIO_PDIR3_PE                     *((volatile unsigned char*)(0x42DE61B8UL))
#define bFM_GPIO_PDIR4_P0                     *((volatile unsigned char*)(0x42DE6200UL))
#define bFM_GPIO_PDIR4_P1                     *((volatile unsigned char*)(0x42DE6204UL))
#define bFM_GPIO_PDIR4_P2                     *((volatile unsigned char*)(0x42DE6208UL))
#define bFM_GPIO_PDIR4_P3                     *((volatile unsigned char*)(0x42DE620CUL))
#define bFM_GPIO_PDIR4_P4                     *((volatile unsigned char*)(0x42DE6210UL))
#define bFM_GPIO_PDIR4_P5                     *((volatile unsigned char*)(0x42DE6214UL))
#define bFM_GPIO_PDIR4_P6                     *((volatile unsigned char*)(0x42DE6218UL))
#define bFM_GPIO_PDIR4_P7                     *((volatile unsigned char*)(0x42DE621CUL))
#define bFM_GPIO_PDIR4_P8                     *((volatile unsigned char*)(0x42DE6220UL))
#define bFM_GPIO_PDIR4_P9                     *((volatile unsigned char*)(0x42DE6224UL))
#define bFM_GPIO_PDIR4_PA                     *((volatile unsigned char*)(0x42DE6228UL))
#define bFM_GPIO_PDIR4_PB                     *((volatile unsigned char*)(0x42DE622CUL))
#define bFM_GPIO_PDIR4_PC                     *((volatile unsigned char*)(0x42DE6230UL))
#define bFM_GPIO_PDIR4_PD                     *((volatile unsigned char*)(0x42DE6234UL))
#define bFM_GPIO_PDIR4_PE                     *((volatile unsigned char*)(0x42DE6238UL))
#define bFM_GPIO_PDIR5_P0                     *((volatile unsigned char*)(0x42DE6280UL))
#define bFM_GPIO_PDIR5_P1                     *((volatile unsigned char*)(0x42DE6284UL))
#define bFM_GPIO_PDIR5_P2                     *((volatile unsigned char*)(0x42DE6288UL))
#define bFM_GPIO_PDIR5_P3                     *((volatile unsigned char*)(0x42DE628CUL))
#define bFM_GPIO_PDIR5_P4                     *((volatile unsigned char*)(0x42DE6290UL))
#define bFM_GPIO_PDIR5_P5                     *((volatile unsigned char*)(0x42DE6294UL))
#define bFM_GPIO_PDIR5_P6                     *((volatile unsigned char*)(0x42DE6298UL))
#define bFM_GPIO_PDIR5_P7                     *((volatile unsigned char*)(0x42DE629CUL))
#define bFM_GPIO_PDIR5_P8                     *((volatile unsigned char*)(0x42DE62A0UL))
#define bFM_GPIO_PDIR5_P9                     *((volatile unsigned char*)(0x42DE62A4UL))
#define bFM_GPIO_PDIR5_PA                     *((volatile unsigned char*)(0x42DE62A8UL))
#define bFM_GPIO_PDIR5_PB                     *((volatile unsigned char*)(0x42DE62ACUL))
#define bFM_GPIO_PDIR5_PC                     *((volatile unsigned char*)(0x42DE62B0UL))
#define bFM_GPIO_PDIR5_PD                     *((volatile unsigned char*)(0x42DE62B4UL))
#define bFM_GPIO_PDIR5_PE                     *((volatile unsigned char*)(0x42DE62B8UL))
#define bFM_GPIO_PDIR5_PF                     *((volatile unsigned char*)(0x42DE62BCUL))
#define bFM_GPIO_PDIR6_P0                     *((volatile unsigned char*)(0x42DE6300UL))
#define bFM_GPIO_PDIR6_P1                     *((volatile unsigned char*)(0x42DE6304UL))
#define bFM_GPIO_PDIR6_P2                     *((volatile unsigned char*)(0x42DE6308UL))
#define bFM_GPIO_PDIR6_P3                     *((volatile unsigned char*)(0x42DE630CUL))
#define bFM_GPIO_PDIR6_P4                     *((volatile unsigned char*)(0x42DE6310UL))
#define bFM_GPIO_PDIR6_P5                     *((volatile unsigned char*)(0x42DE6314UL))
#define bFM_GPIO_PDIR6_P6                     *((volatile unsigned char*)(0x42DE6318UL))
#define bFM_GPIO_PDIR6_P7                     *((volatile unsigned char*)(0x42DE631CUL))
#define bFM_GPIO_PDIR6_P8                     *((volatile unsigned char*)(0x42DE6320UL))
#define bFM_GPIO_PDIR6_P9                     *((volatile unsigned char*)(0x42DE6324UL))
#define bFM_GPIO_PDIR6_PA                     *((volatile unsigned char*)(0x42DE6328UL))
#define bFM_GPIO_PDIR6_PB                     *((volatile unsigned char*)(0x42DE632CUL))
#define bFM_GPIO_PDIR6_PC                     *((volatile unsigned char*)(0x42DE6330UL))
#define bFM_GPIO_PDIR6_PD                     *((volatile unsigned char*)(0x42DE6334UL))
#define bFM_GPIO_PDIR6_PE                     *((volatile unsigned char*)(0x42DE6338UL))
#define bFM_GPIO_PDIR7_P0                     *((volatile unsigned char*)(0x42DE6380UL))
#define bFM_GPIO_PDIR7_P1                     *((volatile unsigned char*)(0x42DE6384UL))
#define bFM_GPIO_PDIR7_P2                     *((volatile unsigned char*)(0x42DE6388UL))
#define bFM_GPIO_PDIR7_P3                     *((volatile unsigned char*)(0x42DE638CUL))
#define bFM_GPIO_PDIR7_P4                     *((volatile unsigned char*)(0x42DE6390UL))
#define bFM_GPIO_PDIR7_P5                     *((volatile unsigned char*)(0x42DE6394UL))
#define bFM_GPIO_PDIR7_P6                     *((volatile unsigned char*)(0x42DE6398UL))
#define bFM_GPIO_PDIR7_P7                     *((volatile unsigned char*)(0x42DE639CUL))
#define bFM_GPIO_PDIR7_P8                     *((volatile unsigned char*)(0x42DE63A0UL))
#define bFM_GPIO_PDIR7_P9                     *((volatile unsigned char*)(0x42DE63A4UL))
#define bFM_GPIO_PDIR7_PA                     *((volatile unsigned char*)(0x42DE63A8UL))
#define bFM_GPIO_PDIR7_PB                     *((volatile unsigned char*)(0x42DE63ACUL))
#define bFM_GPIO_PDIR7_PC                     *((volatile unsigned char*)(0x42DE63B0UL))
#define bFM_GPIO_PDIR7_PD                     *((volatile unsigned char*)(0x42DE63B4UL))
#define bFM_GPIO_PDIR7_PE                     *((volatile unsigned char*)(0x42DE63B8UL))
#define bFM_GPIO_PDIR8_P0                     *((volatile unsigned char*)(0x42DE6400UL))
#define bFM_GPIO_PDIR8_P1                     *((volatile unsigned char*)(0x42DE6404UL))
#define bFM_GPIO_PDIR8_P2                     *((volatile unsigned char*)(0x42DE6408UL))
#define bFM_GPIO_PDIR8_P3                     *((volatile unsigned char*)(0x42DE640CUL))
#define bFM_GPIO_PDIR9_P0                     *((volatile unsigned char*)(0x42DE6480UL))
#define bFM_GPIO_PDIR9_P1                     *((volatile unsigned char*)(0x42DE6484UL))
#define bFM_GPIO_PDIR9_P2                     *((volatile unsigned char*)(0x42DE6488UL))
#define bFM_GPIO_PDIR9_P3                     *((volatile unsigned char*)(0x42DE648CUL))
#define bFM_GPIO_PDIR9_P4                     *((volatile unsigned char*)(0x42DE6490UL))
#define bFM_GPIO_PDIR9_P5                     *((volatile unsigned char*)(0x42DE6494UL))
#define bFM_GPIO_PDIR9_P6                     *((volatile unsigned char*)(0x42DE6498UL))
#define bFM_GPIO_PDIR9_P7                     *((volatile unsigned char*)(0x42DE649CUL))
#define bFM_GPIO_PDIRA_P0                     *((volatile unsigned char*)(0x42DE6500UL))
#define bFM_GPIO_PDIRA_P1                     *((volatile unsigned char*)(0x42DE6504UL))
#define bFM_GPIO_PDIRA_P2                     *((volatile unsigned char*)(0x42DE6508UL))
#define bFM_GPIO_PDIRA_P3                     *((volatile unsigned char*)(0x42DE650CUL))
#define bFM_GPIO_PDIRA_P4                     *((volatile unsigned char*)(0x42DE6510UL))
#define bFM_GPIO_PDIRA_P5                     *((volatile unsigned char*)(0x42DE6514UL))
#define bFM_GPIO_PDIRA_P6                     *((volatile unsigned char*)(0x42DE6518UL))
#define bFM_GPIO_PDIRA_P7                     *((volatile unsigned char*)(0x42DE651CUL))
#define bFM_GPIO_PDIRA_P8                     *((volatile unsigned char*)(0x42DE6520UL))
#define bFM_GPIO_PDIRA_P9                     *((volatile unsigned char*)(0x42DE6524UL))
#define bFM_GPIO_PDIRA_PA                     *((volatile unsigned char*)(0x42DE6528UL))
#define bFM_GPIO_PDIRA_PB                     *((volatile unsigned char*)(0x42DE652CUL))
#define bFM_GPIO_PDIRA_PC                     *((volatile unsigned char*)(0x42DE6530UL))
#define bFM_GPIO_PDIRA_PD                     *((volatile unsigned char*)(0x42DE6534UL))
#define bFM_GPIO_PDIRA_PE                     *((volatile unsigned char*)(0x42DE6538UL))
#define bFM_GPIO_PDIRA_PF                     *((volatile unsigned char*)(0x42DE653CUL))
#define bFM_GPIO_PDIRB_P0                     *((volatile unsigned char*)(0x42DE6580UL))
#define bFM_GPIO_PDIRB_P1                     *((volatile unsigned char*)(0x42DE6584UL))
#define bFM_GPIO_PDIRB_P2                     *((volatile unsigned char*)(0x42DE6588UL))
#define bFM_GPIO_PDIRB_P3                     *((volatile unsigned char*)(0x42DE658CUL))
#define bFM_GPIO_PDIRB_P4                     *((volatile unsigned char*)(0x42DE6590UL))
#define bFM_GPIO_PDIRB_P5                     *((volatile unsigned char*)(0x42DE6594UL))
#define bFM_GPIO_PDIRB_P6                     *((volatile unsigned char*)(0x42DE6598UL))
#define bFM_GPIO_PDIRB_P7                     *((volatile unsigned char*)(0x42DE659CUL))
#define bFM_GPIO_PDIRB_P8                     *((volatile unsigned char*)(0x42DE65A0UL))
#define bFM_GPIO_PDIRB_P9                     *((volatile unsigned char*)(0x42DE65A4UL))
#define bFM_GPIO_PDIRB_PA                     *((volatile unsigned char*)(0x42DE65A8UL))
#define bFM_GPIO_PDIRB_PB                     *((volatile unsigned char*)(0x42DE65ACUL))
#define bFM_GPIO_PDIRB_PC                     *((volatile unsigned char*)(0x42DE65B0UL))
#define bFM_GPIO_PDIRB_PD                     *((volatile unsigned char*)(0x42DE65B4UL))
#define bFM_GPIO_PDIRB_PE                     *((volatile unsigned char*)(0x42DE65B8UL))
#define bFM_GPIO_PDIRB_PF                     *((volatile unsigned char*)(0x42DE65BCUL))
#define bFM_GPIO_PDIRC_P0                     *((volatile unsigned char*)(0x42DE6600UL))
#define bFM_GPIO_PDIRC_P1                     *((volatile unsigned char*)(0x42DE6604UL))
#define bFM_GPIO_PDIRC_P2                     *((volatile unsigned char*)(0x42DE6608UL))
#define bFM_GPIO_PDIRC_P3                     *((volatile unsigned char*)(0x42DE660CUL))
#define bFM_GPIO_PDIRC_P4                     *((volatile unsigned char*)(0x42DE6610UL))
#define bFM_GPIO_PDIRC_P5                     *((volatile unsigned char*)(0x42DE6614UL))
#define bFM_GPIO_PDIRC_P6                     *((volatile unsigned char*)(0x42DE6618UL))
#define bFM_GPIO_PDIRC_P7                     *((volatile unsigned char*)(0x42DE661CUL))
#define bFM_GPIO_PDIRC_P8                     *((volatile unsigned char*)(0x42DE6620UL))
#define bFM_GPIO_PDIRC_P9                     *((volatile unsigned char*)(0x42DE6624UL))
#define bFM_GPIO_PDIRC_PA                     *((volatile unsigned char*)(0x42DE6628UL))
#define bFM_GPIO_PDIRC_PB                     *((volatile unsigned char*)(0x42DE662CUL))
#define bFM_GPIO_PDIRC_PC                     *((volatile unsigned char*)(0x42DE6630UL))
#define bFM_GPIO_PDIRC_PD                     *((volatile unsigned char*)(0x42DE6634UL))
#define bFM_GPIO_PDIRC_PE                     *((volatile unsigned char*)(0x42DE6638UL))
#define bFM_GPIO_PDIRC_PF                     *((volatile unsigned char*)(0x42DE663CUL))
#define bFM_GPIO_PDIRD_P0                     *((volatile unsigned char*)(0x42DE6680UL))
#define bFM_GPIO_PDIRD_P1                     *((volatile unsigned char*)(0x42DE6684UL))
#define bFM_GPIO_PDIRD_P2                     *((volatile unsigned char*)(0x42DE6688UL))
#define bFM_GPIO_PDIRE_P0                     *((volatile unsigned char*)(0x42DE6700UL))
#define bFM_GPIO_PDIRE_P2                     *((volatile unsigned char*)(0x42DE6708UL))
#define bFM_GPIO_PDIRE_P3                     *((volatile unsigned char*)(0x42DE670CUL))
#define bFM_GPIO_PDIRF_P0                     *((volatile unsigned char*)(0x42DE6780UL))
#define bFM_GPIO_PDIRF_P1                     *((volatile unsigned char*)(0x42DE6784UL))
#define bFM_GPIO_PDIRF_P2                     *((volatile unsigned char*)(0x42DE6788UL))
#define bFM_GPIO_PDIRF_P3                     *((volatile unsigned char*)(0x42DE678CUL))
#define bFM_GPIO_PDIRF_P4                     *((volatile unsigned char*)(0x42DE6790UL))
#define bFM_GPIO_PDIRF_P5                     *((volatile unsigned char*)(0x42DE6794UL))
#define bFM_GPIO_PDIRF_P6                     *((volatile unsigned char*)(0x42DE6798UL))
#define bFM_GPIO_PDIRF_P7                     *((volatile unsigned char*)(0x42DE679CUL))
#define bFM_GPIO_PDIRF_P8                     *((volatile unsigned char*)(0x42DE67A0UL))
#define bFM_GPIO_PDIRF_P9                     *((volatile unsigned char*)(0x42DE67A4UL))
#define bFM_GPIO_PDIRF_PA                     *((volatile unsigned char*)(0x42DE67A8UL))
#define bFM_GPIO_PDIRF_PB                     *((volatile unsigned char*)(0x42DE67ACUL))
#define bFM_GPIO_PDIRF_PC                     *((volatile unsigned char*)(0x42DE67B0UL))
#define bFM_GPIO_PDOR0_P0                     *((volatile unsigned char*)(0x42DE8000UL))
#define bFM_GPIO_PDOR0_P1                     *((volatile unsigned char*)(0x42DE8004UL))
#define bFM_GPIO_PDOR0_P2                     *((volatile unsigned char*)(0x42DE8008UL))
#define bFM_GPIO_PDOR0_P3                     *((volatile unsigned char*)(0x42DE800CUL))
#define bFM_GPIO_PDOR0_P4                     *((volatile unsigned char*)(0x42DE8010UL))
#define bFM_GPIO_PDOR0_P5                     *((volatile unsigned char*)(0x42DE8014UL))
#define bFM_GPIO_PDOR0_P6                     *((volatile unsigned char*)(0x42DE8018UL))
#define bFM_GPIO_PDOR0_P7                     *((volatile unsigned char*)(0x42DE801CUL))
#define bFM_GPIO_PDOR0_P8                     *((volatile unsigned char*)(0x42DE8020UL))
#define bFM_GPIO_PDOR0_P9                     *((volatile unsigned char*)(0x42DE8024UL))
#define bFM_GPIO_PDOR0_PA                     *((volatile unsigned char*)(0x42DE8028UL))
#define bFM_GPIO_PDOR0_PB                     *((volatile unsigned char*)(0x42DE802CUL))
#define bFM_GPIO_PDOR0_PC                     *((volatile unsigned char*)(0x42DE8030UL))
#define bFM_GPIO_PDOR0_PD                     *((volatile unsigned char*)(0x42DE8034UL))
#define bFM_GPIO_PDOR0_PE                     *((volatile unsigned char*)(0x42DE8038UL))
#define bFM_GPIO_PDOR1_P0                     *((volatile unsigned char*)(0x42DE8080UL))
#define bFM_GPIO_PDOR1_P1                     *((volatile unsigned char*)(0x42DE8084UL))
#define bFM_GPIO_PDOR1_P2                     *((volatile unsigned char*)(0x42DE8088UL))
#define bFM_GPIO_PDOR1_P3                     *((volatile unsigned char*)(0x42DE808CUL))
#define bFM_GPIO_PDOR1_P4                     *((volatile unsigned char*)(0x42DE8090UL))
#define bFM_GPIO_PDOR1_P5                     *((volatile unsigned char*)(0x42DE8094UL))
#define bFM_GPIO_PDOR1_P6                     *((volatile unsigned char*)(0x42DE8098UL))
#define bFM_GPIO_PDOR1_P7                     *((volatile unsigned char*)(0x42DE809CUL))
#define bFM_GPIO_PDOR1_P8                     *((volatile unsigned char*)(0x42DE80A0UL))
#define bFM_GPIO_PDOR1_P9                     *((volatile unsigned char*)(0x42DE80A4UL))
#define bFM_GPIO_PDOR1_PA                     *((volatile unsigned char*)(0x42DE80A8UL))
#define bFM_GPIO_PDOR1_PB                     *((volatile unsigned char*)(0x42DE80ACUL))
#define bFM_GPIO_PDOR1_PC                     *((volatile unsigned char*)(0x42DE80B0UL))
#define bFM_GPIO_PDOR1_PD                     *((volatile unsigned char*)(0x42DE80B4UL))
#define bFM_GPIO_PDOR1_PE                     *((volatile unsigned char*)(0x42DE80B8UL))
#define bFM_GPIO_PDOR1_PF                     *((volatile unsigned char*)(0x42DE80BCUL))
#define bFM_GPIO_PDOR2_P0                     *((volatile unsigned char*)(0x42DE8100UL))
#define bFM_GPIO_PDOR2_P1                     *((volatile unsigned char*)(0x42DE8104UL))
#define bFM_GPIO_PDOR2_P2                     *((volatile unsigned char*)(0x42DE8108UL))
#define bFM_GPIO_PDOR2_P3                     *((volatile unsigned char*)(0x42DE810CUL))
#define bFM_GPIO_PDOR2_P4                     *((volatile unsigned char*)(0x42DE8110UL))
#define bFM_GPIO_PDOR2_P5                     *((volatile unsigned char*)(0x42DE8114UL))
#define bFM_GPIO_PDOR2_P6                     *((volatile unsigned char*)(0x42DE8118UL))
#define bFM_GPIO_PDOR2_P7                     *((volatile unsigned char*)(0x42DE811CUL))
#define bFM_GPIO_PDOR2_P8                     *((volatile unsigned char*)(0x42DE8120UL))
#define bFM_GPIO_PDOR2_P9                     *((volatile unsigned char*)(0x42DE8124UL))
#define bFM_GPIO_PDOR2_PA                     *((volatile unsigned char*)(0x42DE8128UL))
#define bFM_GPIO_PDOR3_P0                     *((volatile unsigned char*)(0x42DE8180UL))
#define bFM_GPIO_PDOR3_P1                     *((volatile unsigned char*)(0x42DE8184UL))
#define bFM_GPIO_PDOR3_P2                     *((volatile unsigned char*)(0x42DE8188UL))
#define bFM_GPIO_PDOR3_P3                     *((volatile unsigned char*)(0x42DE818CUL))
#define bFM_GPIO_PDOR3_P4                     *((volatile unsigned char*)(0x42DE8190UL))
#define bFM_GPIO_PDOR3_P5                     *((volatile unsigned char*)(0x42DE8194UL))
#define bFM_GPIO_PDOR3_P6                     *((volatile unsigned char*)(0x42DE8198UL))
#define bFM_GPIO_PDOR3_P7                     *((volatile unsigned char*)(0x42DE819CUL))
#define bFM_GPIO_PDOR3_P8                     *((volatile unsigned char*)(0x42DE81A0UL))
#define bFM_GPIO_PDOR3_P9                     *((volatile unsigned char*)(0x42DE81A4UL))
#define bFM_GPIO_PDOR3_PA                     *((volatile unsigned char*)(0x42DE81A8UL))
#define bFM_GPIO_PDOR3_PB                     *((volatile unsigned char*)(0x42DE81ACUL))
#define bFM_GPIO_PDOR3_PC                     *((volatile unsigned char*)(0x42DE81B0UL))
#define bFM_GPIO_PDOR3_PD                     *((volatile unsigned char*)(0x42DE81B4UL))
#define bFM_GPIO_PDOR3_PE                     *((volatile unsigned char*)(0x42DE81B8UL))
#define bFM_GPIO_PDOR4_P0                     *((volatile unsigned char*)(0x42DE8200UL))
#define bFM_GPIO_PDOR4_P1                     *((volatile unsigned char*)(0x42DE8204UL))
#define bFM_GPIO_PDOR4_P2                     *((volatile unsigned char*)(0x42DE8208UL))
#define bFM_GPIO_PDOR4_P3                     *((volatile unsigned char*)(0x42DE820CUL))
#define bFM_GPIO_PDOR4_P4                     *((volatile unsigned char*)(0x42DE8210UL))
#define bFM_GPIO_PDOR4_P5                     *((volatile unsigned char*)(0x42DE8214UL))
#define bFM_GPIO_PDOR4_P6                     *((volatile unsigned char*)(0x42DE8218UL))
#define bFM_GPIO_PDOR4_P7                     *((volatile unsigned char*)(0x42DE821CUL))
#define bFM_GPIO_PDOR4_P8                     *((volatile unsigned char*)(0x42DE8220UL))
#define bFM_GPIO_PDOR4_P9                     *((volatile unsigned char*)(0x42DE8224UL))
#define bFM_GPIO_PDOR4_PA                     *((volatile unsigned char*)(0x42DE8228UL))
#define bFM_GPIO_PDOR4_PB                     *((volatile unsigned char*)(0x42DE822CUL))
#define bFM_GPIO_PDOR4_PC                     *((volatile unsigned char*)(0x42DE8230UL))
#define bFM_GPIO_PDOR4_PD                     *((volatile unsigned char*)(0x42DE8234UL))
#define bFM_GPIO_PDOR4_PE                     *((volatile unsigned char*)(0x42DE8238UL))
#define bFM_GPIO_PDOR5_P0                     *((volatile unsigned char*)(0x42DE8280UL))
#define bFM_GPIO_PDOR5_P1                     *((volatile unsigned char*)(0x42DE8284UL))
#define bFM_GPIO_PDOR5_P2                     *((volatile unsigned char*)(0x42DE8288UL))
#define bFM_GPIO_PDOR5_P3                     *((volatile unsigned char*)(0x42DE828CUL))
#define bFM_GPIO_PDOR5_P4                     *((volatile unsigned char*)(0x42DE8290UL))
#define bFM_GPIO_PDOR5_P5                     *((volatile unsigned char*)(0x42DE8294UL))
#define bFM_GPIO_PDOR5_P6                     *((volatile unsigned char*)(0x42DE8298UL))
#define bFM_GPIO_PDOR5_P7                     *((volatile unsigned char*)(0x42DE829CUL))
#define bFM_GPIO_PDOR5_P8                     *((volatile unsigned char*)(0x42DE82A0UL))
#define bFM_GPIO_PDOR5_P9                     *((volatile unsigned char*)(0x42DE82A4UL))
#define bFM_GPIO_PDOR5_PA                     *((volatile unsigned char*)(0x42DE82A8UL))
#define bFM_GPIO_PDOR5_PB                     *((volatile unsigned char*)(0x42DE82ACUL))
#define bFM_GPIO_PDOR5_PC                     *((volatile unsigned char*)(0x42DE82B0UL))
#define bFM_GPIO_PDOR5_PD                     *((volatile unsigned char*)(0x42DE82B4UL))
#define bFM_GPIO_PDOR5_PE                     *((volatile unsigned char*)(0x42DE82B8UL))
#define bFM_GPIO_PDOR5_PF                     *((volatile unsigned char*)(0x42DE82BCUL))
#define bFM_GPIO_PDOR6_P0                     *((volatile unsigned char*)(0x42DE8300UL))
#define bFM_GPIO_PDOR6_P1                     *((volatile unsigned char*)(0x42DE8304UL))
#define bFM_GPIO_PDOR6_P2                     *((volatile unsigned char*)(0x42DE8308UL))
#define bFM_GPIO_PDOR6_P3                     *((volatile unsigned char*)(0x42DE830CUL))
#define bFM_GPIO_PDOR6_P4                     *((volatile unsigned char*)(0x42DE8310UL))
#define bFM_GPIO_PDOR6_P5                     *((volatile unsigned char*)(0x42DE8314UL))
#define bFM_GPIO_PDOR6_P6                     *((volatile unsigned char*)(0x42DE8318UL))
#define bFM_GPIO_PDOR6_P7                     *((volatile unsigned char*)(0x42DE831CUL))
#define bFM_GPIO_PDOR6_P8                     *((volatile unsigned char*)(0x42DE8320UL))
#define bFM_GPIO_PDOR6_P9                     *((volatile unsigned char*)(0x42DE8324UL))
#define bFM_GPIO_PDOR6_PA                     *((volatile unsigned char*)(0x42DE8328UL))
#define bFM_GPIO_PDOR6_PB                     *((volatile unsigned char*)(0x42DE832CUL))
#define bFM_GPIO_PDOR6_PC                     *((volatile unsigned char*)(0x42DE8330UL))
#define bFM_GPIO_PDOR6_PD                     *((volatile unsigned char*)(0x42DE8334UL))
#define bFM_GPIO_PDOR6_PE                     *((volatile unsigned char*)(0x42DE8338UL))
#define bFM_GPIO_PDOR7_P0                     *((volatile unsigned char*)(0x42DE8380UL))
#define bFM_GPIO_PDOR7_P1                     *((volatile unsigned char*)(0x42DE8384UL))
#define bFM_GPIO_PDOR7_P2                     *((volatile unsigned char*)(0x42DE8388UL))
#define bFM_GPIO_PDOR7_P3                     *((volatile unsigned char*)(0x42DE838CUL))
#define bFM_GPIO_PDOR7_P4                     *((volatile unsigned char*)(0x42DE8390UL))
#define bFM_GPIO_PDOR7_P5                     *((volatile unsigned char*)(0x42DE8394UL))
#define bFM_GPIO_PDOR7_P6                     *((volatile unsigned char*)(0x42DE8398UL))
#define bFM_GPIO_PDOR7_P7                     *((volatile unsigned char*)(0x42DE839CUL))
#define bFM_GPIO_PDOR7_P8                     *((volatile unsigned char*)(0x42DE83A0UL))
#define bFM_GPIO_PDOR7_P9                     *((volatile unsigned char*)(0x42DE83A4UL))
#define bFM_GPIO_PDOR7_PA                     *((volatile unsigned char*)(0x42DE83A8UL))
#define bFM_GPIO_PDOR7_PB                     *((volatile unsigned char*)(0x42DE83ACUL))
#define bFM_GPIO_PDOR7_PC                     *((volatile unsigned char*)(0x42DE83B0UL))
#define bFM_GPIO_PDOR7_PD                     *((volatile unsigned char*)(0x42DE83B4UL))
#define bFM_GPIO_PDOR7_PE                     *((volatile unsigned char*)(0x42DE83B8UL))
#define bFM_GPIO_PDOR8_P0                     *((volatile unsigned char*)(0x42DE8400UL))
#define bFM_GPIO_PDOR8_P1                     *((volatile unsigned char*)(0x42DE8404UL))
#define bFM_GPIO_PDOR8_P2                     *((volatile unsigned char*)(0x42DE8408UL))
#define bFM_GPIO_PDOR8_P3                     *((volatile unsigned char*)(0x42DE840CUL))
#define bFM_GPIO_PDOR9_P0                     *((volatile unsigned char*)(0x42DE8480UL))
#define bFM_GPIO_PDOR9_P1                     *((volatile unsigned char*)(0x42DE8484UL))
#define bFM_GPIO_PDOR9_P2                     *((volatile unsigned char*)(0x42DE8488UL))
#define bFM_GPIO_PDOR9_P3                     *((volatile unsigned char*)(0x42DE848CUL))
#define bFM_GPIO_PDOR9_P4                     *((volatile unsigned char*)(0x42DE8490UL))
#define bFM_GPIO_PDOR9_P5                     *((volatile unsigned char*)(0x42DE8494UL))
#define bFM_GPIO_PDOR9_P6                     *((volatile unsigned char*)(0x42DE8498UL))
#define bFM_GPIO_PDOR9_P7                     *((volatile unsigned char*)(0x42DE849CUL))
#define bFM_GPIO_PDORA_P0                     *((volatile unsigned char*)(0x42DE8500UL))
#define bFM_GPIO_PDORA_P1                     *((volatile unsigned char*)(0x42DE8504UL))
#define bFM_GPIO_PDORA_P2                     *((volatile unsigned char*)(0x42DE8508UL))
#define bFM_GPIO_PDORA_P3                     *((volatile unsigned char*)(0x42DE850CUL))
#define bFM_GPIO_PDORA_P4                     *((volatile unsigned char*)(0x42DE8510UL))
#define bFM_GPIO_PDORA_P5                     *((volatile unsigned char*)(0x42DE8514UL))
#define bFM_GPIO_PDORA_P6                     *((volatile unsigned char*)(0x42DE8518UL))
#define bFM_GPIO_PDORA_P7                     *((volatile unsigned char*)(0x42DE851CUL))
#define bFM_GPIO_PDORA_P8                     *((volatile unsigned char*)(0x42DE8520UL))
#define bFM_GPIO_PDORA_P9                     *((volatile unsigned char*)(0x42DE8524UL))
#define bFM_GPIO_PDORA_PA                     *((volatile unsigned char*)(0x42DE8528UL))
#define bFM_GPIO_PDORA_PB                     *((volatile unsigned char*)(0x42DE852CUL))
#define bFM_GPIO_PDORA_PC                     *((volatile unsigned char*)(0x42DE8530UL))
#define bFM_GPIO_PDORA_PD                     *((volatile unsigned char*)(0x42DE8534UL))
#define bFM_GPIO_PDORA_PE                     *((volatile unsigned char*)(0x42DE8538UL))
#define bFM_GPIO_PDORA_PF                     *((volatile unsigned char*)(0x42DE853CUL))
#define bFM_GPIO_PDORB_P0                     *((volatile unsigned char*)(0x42DE8580UL))
#define bFM_GPIO_PDORB_P1                     *((volatile unsigned char*)(0x42DE8584UL))
#define bFM_GPIO_PDORB_P2                     *((volatile unsigned char*)(0x42DE8588UL))
#define bFM_GPIO_PDORB_P3                     *((volatile unsigned char*)(0x42DE858CUL))
#define bFM_GPIO_PDORB_P4                     *((volatile unsigned char*)(0x42DE8590UL))
#define bFM_GPIO_PDORB_P5                     *((volatile unsigned char*)(0x42DE8594UL))
#define bFM_GPIO_PDORB_P6                     *((volatile unsigned char*)(0x42DE8598UL))
#define bFM_GPIO_PDORB_P7                     *((volatile unsigned char*)(0x42DE859CUL))
#define bFM_GPIO_PDORB_P8                     *((volatile unsigned char*)(0x42DE85A0UL))
#define bFM_GPIO_PDORB_P9                     *((volatile unsigned char*)(0x42DE85A4UL))
#define bFM_GPIO_PDORB_PA                     *((volatile unsigned char*)(0x42DE85A8UL))
#define bFM_GPIO_PDORB_PB                     *((volatile unsigned char*)(0x42DE85ACUL))
#define bFM_GPIO_PDORB_PC                     *((volatile unsigned char*)(0x42DE85B0UL))
#define bFM_GPIO_PDORB_PD                     *((volatile unsigned char*)(0x42DE85B4UL))
#define bFM_GPIO_PDORB_PE                     *((volatile unsigned char*)(0x42DE85B8UL))
#define bFM_GPIO_PDORB_PF                     *((volatile unsigned char*)(0x42DE85BCUL))
#define bFM_GPIO_PDORC_P0                     *((volatile unsigned char*)(0x42DE8600UL))
#define bFM_GPIO_PDORC_P1                     *((volatile unsigned char*)(0x42DE8604UL))
#define bFM_GPIO_PDORC_P2                     *((volatile unsigned char*)(0x42DE8608UL))
#define bFM_GPIO_PDORC_P3                     *((volatile unsigned char*)(0x42DE860CUL))
#define bFM_GPIO_PDORC_P4                     *((volatile unsigned char*)(0x42DE8610UL))
#define bFM_GPIO_PDORC_P5                     *((volatile unsigned char*)(0x42DE8614UL))
#define bFM_GPIO_PDORC_P6                     *((volatile unsigned char*)(0x42DE8618UL))
#define bFM_GPIO_PDORC_P7                     *((volatile unsigned char*)(0x42DE861CUL))
#define bFM_GPIO_PDORC_P8                     *((volatile unsigned char*)(0x42DE8620UL))
#define bFM_GPIO_PDORC_P9                     *((volatile unsigned char*)(0x42DE8624UL))
#define bFM_GPIO_PDORC_PA                     *((volatile unsigned char*)(0x42DE8628UL))
#define bFM_GPIO_PDORC_PB                     *((volatile unsigned char*)(0x42DE862CUL))
#define bFM_GPIO_PDORC_PC                     *((volatile unsigned char*)(0x42DE8630UL))
#define bFM_GPIO_PDORC_PD                     *((volatile unsigned char*)(0x42DE8634UL))
#define bFM_GPIO_PDORC_PE                     *((volatile unsigned char*)(0x42DE8638UL))
#define bFM_GPIO_PDORC_PF                     *((volatile unsigned char*)(0x42DE863CUL))
#define bFM_GPIO_PDORD_P0                     *((volatile unsigned char*)(0x42DE8680UL))
#define bFM_GPIO_PDORD_P1                     *((volatile unsigned char*)(0x42DE8684UL))
#define bFM_GPIO_PDORD_P2                     *((volatile unsigned char*)(0x42DE8688UL))
#define bFM_GPIO_PDORE_P0                     *((volatile unsigned char*)(0x42DE8700UL))
#define bFM_GPIO_PDORE_P2                     *((volatile unsigned char*)(0x42DE8708UL))
#define bFM_GPIO_PDORE_P3                     *((volatile unsigned char*)(0x42DE870CUL))
#define bFM_GPIO_PDORF_P0                     *((volatile unsigned char*)(0x42DE8780UL))
#define bFM_GPIO_PDORF_P1                     *((volatile unsigned char*)(0x42DE8784UL))
#define bFM_GPIO_PDORF_P2                     *((volatile unsigned char*)(0x42DE8788UL))
#define bFM_GPIO_PDORF_P3                     *((volatile unsigned char*)(0x42DE878CUL))
#define bFM_GPIO_PDORF_P4                     *((volatile unsigned char*)(0x42DE8790UL))
#define bFM_GPIO_PDORF_P5                     *((volatile unsigned char*)(0x42DE8794UL))
#define bFM_GPIO_PDORF_P6                     *((volatile unsigned char*)(0x42DE8798UL))
#define bFM_GPIO_PDORF_P7                     *((volatile unsigned char*)(0x42DE879CUL))
#define bFM_GPIO_PDORF_P8                     *((volatile unsigned char*)(0x42DE87A0UL))
#define bFM_GPIO_PDORF_P9                     *((volatile unsigned char*)(0x42DE87A4UL))
#define bFM_GPIO_PDORF_PA                     *((volatile unsigned char*)(0x42DE87A8UL))
#define bFM_GPIO_PDORF_PB                     *((volatile unsigned char*)(0x42DE87ACUL))
#define bFM_GPIO_PDORF_PC                     *((volatile unsigned char*)(0x42DE87B0UL))
#define bFM_GPIO_ADE_AN00                     *((volatile unsigned char*)(0x42DEA000UL))
#define bFM_GPIO_ADE_AN01                     *((volatile unsigned char*)(0x42DEA004UL))
#define bFM_GPIO_ADE_AN02                     *((volatile unsigned char*)(0x42DEA008UL))
#define bFM_GPIO_ADE_AN03                     *((volatile unsigned char*)(0x42DEA00CUL))
#define bFM_GPIO_ADE_AN04                     *((volatile unsigned char*)(0x42DEA010UL))
#define bFM_GPIO_ADE_AN05                     *((volatile unsigned char*)(0x42DEA014UL))
#define bFM_GPIO_ADE_AN06                     *((volatile unsigned char*)(0x42DEA018UL))
#define bFM_GPIO_ADE_AN07                     *((volatile unsigned char*)(0x42DEA01CUL))
#define bFM_GPIO_ADE_AN08                     *((volatile unsigned char*)(0x42DEA020UL))
#define bFM_GPIO_ADE_AN09                     *((volatile unsigned char*)(0x42DEA024UL))
#define bFM_GPIO_ADE_AN10                     *((volatile unsigned char*)(0x42DEA028UL))
#define bFM_GPIO_ADE_AN11                     *((volatile unsigned char*)(0x42DEA02CUL))
#define bFM_GPIO_ADE_AN12                     *((volatile unsigned char*)(0x42DEA030UL))
#define bFM_GPIO_ADE_AN13                     *((volatile unsigned char*)(0x42DEA034UL))
#define bFM_GPIO_ADE_AN14                     *((volatile unsigned char*)(0x42DEA038UL))
#define bFM_GPIO_ADE_AN15                     *((volatile unsigned char*)(0x42DEA03CUL))
#define bFM_GPIO_ADE_AN16                     *((volatile unsigned char*)(0x42DEA040UL))
#define bFM_GPIO_ADE_AN17                     *((volatile unsigned char*)(0x42DEA044UL))
#define bFM_GPIO_ADE_AN18                     *((volatile unsigned char*)(0x42DEA048UL))
#define bFM_GPIO_ADE_AN19                     *((volatile unsigned char*)(0x42DEA04CUL))
#define bFM_GPIO_ADE_AN20                     *((volatile unsigned char*)(0x42DEA050UL))
#define bFM_GPIO_ADE_AN21                     *((volatile unsigned char*)(0x42DEA054UL))
#define bFM_GPIO_ADE_AN22                     *((volatile unsigned char*)(0x42DEA058UL))
#define bFM_GPIO_ADE_AN23                     *((volatile unsigned char*)(0x42DEA05CUL))
#define bFM_GPIO_ADE_AN24                     *((volatile unsigned char*)(0x42DEA060UL))
#define bFM_GPIO_ADE_AN25                     *((volatile unsigned char*)(0x42DEA064UL))
#define bFM_GPIO_ADE_AN26                     *((volatile unsigned char*)(0x42DEA068UL))
#define bFM_GPIO_ADE_AN27                     *((volatile unsigned char*)(0x42DEA06CUL))
#define bFM_GPIO_ADE_AN28                     *((volatile unsigned char*)(0x42DEA070UL))
#define bFM_GPIO_ADE_AN29                     *((volatile unsigned char*)(0x42DEA074UL))
#define bFM_GPIO_ADE_AN30                     *((volatile unsigned char*)(0x42DEA078UL))
#define bFM_GPIO_ADE_AN31                     *((volatile unsigned char*)(0x42DEA07CUL))
#define bFM_GPIO_SPSR_MAINXC0                 *((volatile unsigned char*)(0x42DEB008UL))
#define bFM_GPIO_SPSR_MAINXC1                 *((volatile unsigned char*)(0x42DEB00CUL))
#define bFM_GPIO_SPSR_USB0C                   *((volatile unsigned char*)(0x42DEB010UL))
#define bFM_GPIO_SPSR_USB1C                   *((volatile unsigned char*)(0x42DEB014UL))
#define bFM_GPIO_EPFR00_NMIS                  *((volatile unsigned char*)(0x42DEC000UL))
#define bFM_GPIO_EPFR00_CROUTE0               *((volatile unsigned char*)(0x42DEC004UL))
#define bFM_GPIO_EPFR00_CROUTE1               *((volatile unsigned char*)(0x42DEC008UL))
#define bFM_GPIO_EPFR00_RTCCOE0               *((volatile unsigned char*)(0x42DEC010UL))
#define bFM_GPIO_EPFR00_RTCCOE1               *((volatile unsigned char*)(0x42DEC014UL))
#define bFM_GPIO_EPFR00_SUBOUTE0              *((volatile unsigned char*)(0x42DEC018UL))
#define bFM_GPIO_EPFR00_SUBOUTE1              *((volatile unsigned char*)(0x42DEC01CUL))
#define bFM_GPIO_EPFR00_USBP0E                *((volatile unsigned char*)(0x42DEC024UL))
#define bFM_GPIO_EPFR00_USBP1E                *((volatile unsigned char*)(0x42DEC034UL))
#define bFM_GPIO_EPFR00_JTAGEN0B              *((volatile unsigned char*)(0x42DEC040UL))
#define bFM_GPIO_EPFR00_JTAGEN1S              *((volatile unsigned char*)(0x42DEC044UL))
#define bFM_GPIO_EPFR00_TRC0E                 *((volatile unsigned char*)(0x42DEC060UL))
#define bFM_GPIO_EPFR00_TRC1E                 *((volatile unsigned char*)(0x42DEC064UL))
#define bFM_GPIO_EPFR00_TRC2E                 *((volatile unsigned char*)(0x42DEC068UL))
#define bFM_GPIO_EPFR00_TRC3E                 *((volatile unsigned char*)(0x42DEC06CUL))
#define bFM_GPIO_EPFR01_RTO00E0               *((volatile unsigned char*)(0x42DEC080UL))
#define bFM_GPIO_EPFR01_RTO00E1               *((volatile unsigned char*)(0x42DEC084UL))
#define bFM_GPIO_EPFR01_RTO01E0               *((volatile unsigned char*)(0x42DEC088UL))
#define bFM_GPIO_EPFR01_RTO01E1               *((volatile unsigned char*)(0x42DEC08CUL))
#define bFM_GPIO_EPFR01_RTO02E0               *((volatile unsigned char*)(0x42DEC090UL))
#define bFM_GPIO_EPFR01_RTO02E1               *((volatile unsigned char*)(0x42DEC094UL))
#define bFM_GPIO_EPFR01_RTO03E0               *((volatile unsigned char*)(0x42DEC098UL))
#define bFM_GPIO_EPFR01_RTO03E1               *((volatile unsigned char*)(0x42DEC09CUL))
#define bFM_GPIO_EPFR01_RTO04E0               *((volatile unsigned char*)(0x42DEC0A0UL))
#define bFM_GPIO_EPFR01_RTO04E1               *((volatile unsigned char*)(0x42DEC0A4UL))
#define bFM_GPIO_EPFR01_RTO05E0               *((volatile unsigned char*)(0x42DEC0A8UL))
#define bFM_GPIO_EPFR01_RTO05E1               *((volatile unsigned char*)(0x42DEC0ACUL))
#define bFM_GPIO_EPFR01_DTTI0C                *((volatile unsigned char*)(0x42DEC0B0UL))
#define bFM_GPIO_EPFR01_DTTI0S0               *((volatile unsigned char*)(0x42DEC0C0UL))
#define bFM_GPIO_EPFR01_DTTI0S1               *((volatile unsigned char*)(0x42DEC0C4UL))
#define bFM_GPIO_EPFR01_FRCK0S0               *((volatile unsigned char*)(0x42DEC0C8UL))
#define bFM_GPIO_EPFR01_FRCK0S1               *((volatile unsigned char*)(0x42DEC0CCUL))
#define bFM_GPIO_EPFR01_IC00S0                *((volatile unsigned char*)(0x42DEC0D0UL))
#define bFM_GPIO_EPFR01_IC00S1                *((volatile unsigned char*)(0x42DEC0D4UL))
#define bFM_GPIO_EPFR01_IC00S2                *((volatile unsigned char*)(0x42DEC0D8UL))
#define bFM_GPIO_EPFR01_IC01S0                *((volatile unsigned char*)(0x42DEC0DCUL))
#define bFM_GPIO_EPFR01_IC01S1                *((volatile unsigned char*)(0x42DEC0E0UL))
#define bFM_GPIO_EPFR01_IC01S2                *((volatile unsigned char*)(0x42DEC0E4UL))
#define bFM_GPIO_EPFR01_IC02S0                *((volatile unsigned char*)(0x42DEC0E8UL))
#define bFM_GPIO_EPFR01_IC02S1                *((volatile unsigned char*)(0x42DEC0ECUL))
#define bFM_GPIO_EPFR01_IC02S2                *((volatile unsigned char*)(0x42DEC0F0UL))
#define bFM_GPIO_EPFR01_IC03S0                *((volatile unsigned char*)(0x42DEC0F4UL))
#define bFM_GPIO_EPFR01_IC03S1                *((volatile unsigned char*)(0x42DEC0F8UL))
#define bFM_GPIO_EPFR01_IC03S2                *((volatile unsigned char*)(0x42DEC0FCUL))
#define bFM_GPIO_EPFR02_RTO10E0               *((volatile unsigned char*)(0x42DEC100UL))
#define bFM_GPIO_EPFR02_RTO10E1               *((volatile unsigned char*)(0x42DEC104UL))
#define bFM_GPIO_EPFR02_RTO11E0               *((volatile unsigned char*)(0x42DEC108UL))
#define bFM_GPIO_EPFR02_RTO11E1               *((volatile unsigned char*)(0x42DEC10CUL))
#define bFM_GPIO_EPFR02_RTO12E0               *((volatile unsigned char*)(0x42DEC110UL))
#define bFM_GPIO_EPFR02_RTO12E1               *((volatile unsigned char*)(0x42DEC114UL))
#define bFM_GPIO_EPFR02_RTO13E0               *((volatile unsigned char*)(0x42DEC118UL))
#define bFM_GPIO_EPFR02_RTO13E1               *((volatile unsigned char*)(0x42DEC11CUL))
#define bFM_GPIO_EPFR02_RTO14E0               *((volatile unsigned char*)(0x42DEC120UL))
#define bFM_GPIO_EPFR02_RTO14E1               *((volatile unsigned char*)(0x42DEC124UL))
#define bFM_GPIO_EPFR02_RTO15E0               *((volatile unsigned char*)(0x42DEC128UL))
#define bFM_GPIO_EPFR02_RTO15E1               *((volatile unsigned char*)(0x42DEC12CUL))
#define bFM_GPIO_EPFR02_DTTI1C                *((volatile unsigned char*)(0x42DEC130UL))
#define bFM_GPIO_EPFR02_DTTI1S0               *((volatile unsigned char*)(0x42DEC140UL))
#define bFM_GPIO_EPFR02_DTTI1S1               *((volatile unsigned char*)(0x42DEC144UL))
#define bFM_GPIO_EPFR02_FRCK1S0               *((volatile unsigned char*)(0x42DEC148UL))
#define bFM_GPIO_EPFR02_FRCK1S1               *((volatile unsigned char*)(0x42DEC14CUL))
#define bFM_GPIO_EPFR02_IC10S0                *((volatile unsigned char*)(0x42DEC150UL))
#define bFM_GPIO_EPFR02_IC10S1                *((volatile unsigned char*)(0x42DEC154UL))
#define bFM_GPIO_EPFR02_IC10S2                *((volatile unsigned char*)(0x42DEC158UL))
#define bFM_GPIO_EPFR02_IC11S0                *((volatile unsigned char*)(0x42DEC15CUL))
#define bFM_GPIO_EPFR02_IC11S1                *((volatile unsigned char*)(0x42DEC160UL))
#define bFM_GPIO_EPFR02_IC11S2                *((volatile unsigned char*)(0x42DEC164UL))
#define bFM_GPIO_EPFR02_IC12S0                *((volatile unsigned char*)(0x42DEC168UL))
#define bFM_GPIO_EPFR02_IC12S1                *((volatile unsigned char*)(0x42DEC16CUL))
#define bFM_GPIO_EPFR02_IC12S2                *((volatile unsigned char*)(0x42DEC170UL))
#define bFM_GPIO_EPFR02_IC13S0                *((volatile unsigned char*)(0x42DEC174UL))
#define bFM_GPIO_EPFR02_IC13S1                *((volatile unsigned char*)(0x42DEC178UL))
#define bFM_GPIO_EPFR02_IC13S2                *((volatile unsigned char*)(0x42DEC17CUL))
#define bFM_GPIO_EPFR03_RTO20E0               *((volatile unsigned char*)(0x42DEC180UL))
#define bFM_GPIO_EPFR03_RTO20E1               *((volatile unsigned char*)(0x42DEC184UL))
#define bFM_GPIO_EPFR03_RTO21E0               *((volatile unsigned char*)(0x42DEC188UL))
#define bFM_GPIO_EPFR03_RTO21E1               *((volatile unsigned char*)(0x42DEC18CUL))
#define bFM_GPIO_EPFR03_RTO22E0               *((volatile unsigned char*)(0x42DEC190UL))
#define bFM_GPIO_EPFR03_RTO22E1               *((volatile unsigned char*)(0x42DEC194UL))
#define bFM_GPIO_EPFR03_RTO23E0               *((volatile unsigned char*)(0x42DEC198UL))
#define bFM_GPIO_EPFR03_RTO23E1               *((volatile unsigned char*)(0x42DEC19CUL))
#define bFM_GPIO_EPFR03_RTO24E0               *((volatile unsigned char*)(0x42DEC1A0UL))
#define bFM_GPIO_EPFR03_RTO24E1               *((volatile unsigned char*)(0x42DEC1A4UL))
#define bFM_GPIO_EPFR03_RTO25E0               *((volatile unsigned char*)(0x42DEC1A8UL))
#define bFM_GPIO_EPFR03_RTO25E1               *((volatile unsigned char*)(0x42DEC1ACUL))
#define bFM_GPIO_EPFR03_DTTI2C                *((volatile unsigned char*)(0x42DEC1B0UL))
#define bFM_GPIO_EPFR03_DTTI2S0               *((volatile unsigned char*)(0x42DEC1C0UL))
#define bFM_GPIO_EPFR03_DTTI2S1               *((volatile unsigned char*)(0x42DEC1C4UL))
#define bFM_GPIO_EPFR03_FRCK2S0               *((volatile unsigned char*)(0x42DEC1C8UL))
#define bFM_GPIO_EPFR03_FRCK2S1               *((volatile unsigned char*)(0x42DEC1CCUL))
#define bFM_GPIO_EPFR03_IC20S0                *((volatile unsigned char*)(0x42DEC1D0UL))
#define bFM_GPIO_EPFR03_IC20S1                *((volatile unsigned char*)(0x42DEC1D4UL))
#define bFM_GPIO_EPFR03_IC20S2                *((volatile unsigned char*)(0x42DEC1D8UL))
#define bFM_GPIO_EPFR03_IC21S0                *((volatile unsigned char*)(0x42DEC1DCUL))
#define bFM_GPIO_EPFR03_IC21S1                *((volatile unsigned char*)(0x42DEC1E0UL))
#define bFM_GPIO_EPFR03_IC21S2                *((volatile unsigned char*)(0x42DEC1E4UL))
#define bFM_GPIO_EPFR03_IC22S0                *((volatile unsigned char*)(0x42DEC1E8UL))
#define bFM_GPIO_EPFR03_IC22S1                *((volatile unsigned char*)(0x42DEC1ECUL))
#define bFM_GPIO_EPFR03_IC22S2                *((volatile unsigned char*)(0x42DEC1F0UL))
#define bFM_GPIO_EPFR03_IC23S0                *((volatile unsigned char*)(0x42DEC1F4UL))
#define bFM_GPIO_EPFR03_IC23S1                *((volatile unsigned char*)(0x42DEC1F8UL))
#define bFM_GPIO_EPFR03_IC23S2                *((volatile unsigned char*)(0x42DEC1FCUL))
#define bFM_GPIO_EPFR04_TIOA0E0               *((volatile unsigned char*)(0x42DEC208UL))
#define bFM_GPIO_EPFR04_TIOA0E1               *((volatile unsigned char*)(0x42DEC20CUL))
#define bFM_GPIO_EPFR04_TIOB0S0               *((volatile unsigned char*)(0x42DEC210UL))
#define bFM_GPIO_EPFR04_TIOB0S1               *((volatile unsigned char*)(0x42DEC214UL))
#define bFM_GPIO_EPFR04_TIOB0S2               *((volatile unsigned char*)(0x42DEC218UL))
#define bFM_GPIO_EPFR04_TIOA1S0               *((volatile unsigned char*)(0x42DEC220UL))
#define bFM_GPIO_EPFR04_TIOA1S1               *((volatile unsigned char*)(0x42DEC224UL))
#define bFM_GPIO_EPFR04_TIOA1E0               *((volatile unsigned char*)(0x42DEC228UL))
#define bFM_GPIO_EPFR04_TIOA1E1               *((volatile unsigned char*)(0x42DEC22CUL))
#define bFM_GPIO_EPFR04_TIOB1S0               *((volatile unsigned char*)(0x42DEC230UL))
#define bFM_GPIO_EPFR04_TIOB1S1               *((volatile unsigned char*)(0x42DEC234UL))
#define bFM_GPIO_EPFR04_TIOA2E0               *((volatile unsigned char*)(0x42DEC248UL))
#define bFM_GPIO_EPFR04_TIOA2E1               *((volatile unsigned char*)(0x42DEC24CUL))
#define bFM_GPIO_EPFR04_TIOB2S0               *((volatile unsigned char*)(0x42DEC250UL))
#define bFM_GPIO_EPFR04_TIOB2S1               *((volatile unsigned char*)(0x42DEC254UL))
#define bFM_GPIO_EPFR04_TIOA3S0               *((volatile unsigned char*)(0x42DEC260UL))
#define bFM_GPIO_EPFR04_TIOA3S1               *((volatile unsigned char*)(0x42DEC264UL))
#define bFM_GPIO_EPFR04_TIOA3E0               *((volatile unsigned char*)(0x42DEC268UL))
#define bFM_GPIO_EPFR04_TIOA3E1               *((volatile unsigned char*)(0x42DEC26CUL))
#define bFM_GPIO_EPFR04_TIOB3S0               *((volatile unsigned char*)(0x42DEC270UL))
#define bFM_GPIO_EPFR04_TIOB3S1               *((volatile unsigned char*)(0x42DEC274UL))
#define bFM_GPIO_EPFR05_TIOA4E0               *((volatile unsigned char*)(0x42DEC288UL))
#define bFM_GPIO_EPFR05_TIOA4E1               *((volatile unsigned char*)(0x42DEC28CUL))
#define bFM_GPIO_EPFR05_TIOB4S0               *((volatile unsigned char*)(0x42DEC290UL))
#define bFM_GPIO_EPFR05_TIOB4S1               *((volatile unsigned char*)(0x42DEC294UL))
#define bFM_GPIO_EPFR05_TIOA5S0               *((volatile unsigned char*)(0x42DEC2A0UL))
#define bFM_GPIO_EPFR05_TIOA5S1               *((volatile unsigned char*)(0x42DEC2A4UL))
#define bFM_GPIO_EPFR05_TIOA5E0               *((volatile unsigned char*)(0x42DEC2A8UL))
#define bFM_GPIO_EPFR05_TIOA5E1               *((volatile unsigned char*)(0x42DEC2ACUL))
#define bFM_GPIO_EPFR05_TIOB5S0               *((volatile unsigned char*)(0x42DEC2B0UL))
#define bFM_GPIO_EPFR05_TIOB5S1               *((volatile unsigned char*)(0x42DEC2B4UL))
#define bFM_GPIO_EPFR05_TIOA6E0               *((volatile unsigned char*)(0x42DEC2C8UL))
#define bFM_GPIO_EPFR05_TIOA6E1               *((volatile unsigned char*)(0x42DEC2CCUL))
#define bFM_GPIO_EPFR05_TIOB6S0               *((volatile unsigned char*)(0x42DEC2D0UL))
#define bFM_GPIO_EPFR05_TIOB6S1               *((volatile unsigned char*)(0x42DEC2D4UL))
#define bFM_GPIO_EPFR05_TIOA7S0               *((volatile unsigned char*)(0x42DEC2E0UL))
#define bFM_GPIO_EPFR05_TIOA7S1               *((volatile unsigned char*)(0x42DEC2E4UL))
#define bFM_GPIO_EPFR05_TIOA7E0               *((volatile unsigned char*)(0x42DEC2E8UL))
#define bFM_GPIO_EPFR05_TIOA7E1               *((volatile unsigned char*)(0x42DEC2ECUL))
#define bFM_GPIO_EPFR05_TIOB7S0               *((volatile unsigned char*)(0x42DEC2F0UL))
#define bFM_GPIO_EPFR05_TIOB7S1               *((volatile unsigned char*)(0x42DEC2F4UL))
#define bFM_GPIO_EPFR06_EINT00S0              *((volatile unsigned char*)(0x42DEC300UL))
#define bFM_GPIO_EPFR06_EINT00S1              *((volatile unsigned char*)(0x42DEC304UL))
#define bFM_GPIO_EPFR06_EINT01S0              *((volatile unsigned char*)(0x42DEC308UL))
#define bFM_GPIO_EPFR06_EINT01S1              *((volatile unsigned char*)(0x42DEC30CUL))
#define bFM_GPIO_EPFR06_EINT02S0              *((volatile unsigned char*)(0x42DEC310UL))
#define bFM_GPIO_EPFR06_EINT02S1              *((volatile unsigned char*)(0x42DEC314UL))
#define bFM_GPIO_EPFR06_EINT03S0              *((volatile unsigned char*)(0x42DEC318UL))
#define bFM_GPIO_EPFR06_EINT03S1              *((volatile unsigned char*)(0x42DEC31CUL))
#define bFM_GPIO_EPFR06_EINT04S0              *((volatile unsigned char*)(0x42DEC320UL))
#define bFM_GPIO_EPFR06_EINT04S1              *((volatile unsigned char*)(0x42DEC324UL))
#define bFM_GPIO_EPFR06_EINT05S0              *((volatile unsigned char*)(0x42DEC328UL))
#define bFM_GPIO_EPFR06_EINT05S1              *((volatile unsigned char*)(0x42DEC32CUL))
#define bFM_GPIO_EPFR06_EINT06S0              *((volatile unsigned char*)(0x42DEC330UL))
#define bFM_GPIO_EPFR06_EINT06S1              *((volatile unsigned char*)(0x42DEC334UL))
#define bFM_GPIO_EPFR06_EINT07S0              *((volatile unsigned char*)(0x42DEC338UL))
#define bFM_GPIO_EPFR06_EINT07S1              *((volatile unsigned char*)(0x42DEC33CUL))
#define bFM_GPIO_EPFR06_EINT08S0              *((volatile unsigned char*)(0x42DEC340UL))
#define bFM_GPIO_EPFR06_EINT08S1              *((volatile unsigned char*)(0x42DEC344UL))
#define bFM_GPIO_EPFR06_EINT09S0              *((volatile unsigned char*)(0x42DEC348UL))
#define bFM_GPIO_EPFR06_EINT09S1              *((volatile unsigned char*)(0x42DEC34CUL))
#define bFM_GPIO_EPFR06_EINT10S0              *((volatile unsigned char*)(0x42DEC350UL))
#define bFM_GPIO_EPFR06_EINT10S1              *((volatile unsigned char*)(0x42DEC354UL))
#define bFM_GPIO_EPFR06_EINT11S0              *((volatile unsigned char*)(0x42DEC358UL))
#define bFM_GPIO_EPFR06_EINT11S1              *((volatile unsigned char*)(0x42DEC35CUL))
#define bFM_GPIO_EPFR06_EINT12S0              *((volatile unsigned char*)(0x42DEC360UL))
#define bFM_GPIO_EPFR06_EINT12S1              *((volatile unsigned char*)(0x42DEC364UL))
#define bFM_GPIO_EPFR06_EINT13S0              *((volatile unsigned char*)(0x42DEC368UL))
#define bFM_GPIO_EPFR06_EINT13S1              *((volatile unsigned char*)(0x42DEC36CUL))
#define bFM_GPIO_EPFR06_EINT14S0              *((volatile unsigned char*)(0x42DEC370UL))
#define bFM_GPIO_EPFR06_EINT14S1              *((volatile unsigned char*)(0x42DEC374UL))
#define bFM_GPIO_EPFR06_EINT15S0              *((volatile unsigned char*)(0x42DEC378UL))
#define bFM_GPIO_EPFR06_EINT15S1              *((volatile unsigned char*)(0x42DEC37CUL))
#define bFM_GPIO_EPFR07_SIN0S0                *((volatile unsigned char*)(0x42DEC390UL))
#define bFM_GPIO_EPFR07_SIN0S1                *((volatile unsigned char*)(0x42DEC394UL))
#define bFM_GPIO_EPFR07_SOT0B0                *((volatile unsigned char*)(0x42DEC398UL))
#define bFM_GPIO_EPFR07_SOT0B1                *((volatile unsigned char*)(0x42DEC39CUL))
#define bFM_GPIO_EPFR07_SCK0B0                *((volatile unsigned char*)(0x42DEC3A0UL))
#define bFM_GPIO_EPFR07_SCK0B1                *((volatile unsigned char*)(0x42DEC3A4UL))
#define bFM_GPIO_EPFR07_SIN1S0                *((volatile unsigned char*)(0x42DEC3A8UL))
#define bFM_GPIO_EPFR07_SIN1S1                *((volatile unsigned char*)(0x42DEC3ACUL))
#define bFM_GPIO_EPFR07_SOT1B0                *((volatile unsigned char*)(0x42DEC3B0UL))
#define bFM_GPIO_EPFR07_SOT1B1                *((volatile unsigned char*)(0x42DEC3B4UL))
#define bFM_GPIO_EPFR07_SCK1B0                *((volatile unsigned char*)(0x42DEC3B8UL))
#define bFM_GPIO_EPFR07_SCK1B1                *((volatile unsigned char*)(0x42DEC3BCUL))
#define bFM_GPIO_EPFR07_SIN2S0                *((volatile unsigned char*)(0x42DEC3C0UL))
#define bFM_GPIO_EPFR07_SIN2S1                *((volatile unsigned char*)(0x42DEC3C4UL))
#define bFM_GPIO_EPFR07_SOT2B0                *((volatile unsigned char*)(0x42DEC3C8UL))
#define bFM_GPIO_EPFR07_SOT2B1                *((volatile unsigned char*)(0x42DEC3CCUL))
#define bFM_GPIO_EPFR07_SCK2B0                *((volatile unsigned char*)(0x42DEC3D0UL))
#define bFM_GPIO_EPFR07_SCK2B1                *((volatile unsigned char*)(0x42DEC3D4UL))
#define bFM_GPIO_EPFR07_SIN3S0                *((volatile unsigned char*)(0x42DEC3D8UL))
#define bFM_GPIO_EPFR07_SIN3S1                *((volatile unsigned char*)(0x42DEC3DCUL))
#define bFM_GPIO_EPFR07_SOT3B0                *((volatile unsigned char*)(0x42DEC3E0UL))
#define bFM_GPIO_EPFR07_SOT3B1                *((volatile unsigned char*)(0x42DEC3E4UL))
#define bFM_GPIO_EPFR07_SCK3B0                *((volatile unsigned char*)(0x42DEC3E8UL))
#define bFM_GPIO_EPFR07_SCK3B1                *((volatile unsigned char*)(0x42DEC3ECUL))
#define bFM_GPIO_EPFR08_RTS4E0                *((volatile unsigned char*)(0x42DEC400UL))
#define bFM_GPIO_EPFR08_RTS4E1                *((volatile unsigned char*)(0x42DEC404UL))
#define bFM_GPIO_EPFR08_CTS4S0                *((volatile unsigned char*)(0x42DEC408UL))
#define bFM_GPIO_EPFR08_CTS4S1                *((volatile unsigned char*)(0x42DEC40CUL))
#define bFM_GPIO_EPFR08_SIN4S0                *((volatile unsigned char*)(0x42DEC410UL))
#define bFM_GPIO_EPFR08_SIN4S1                *((volatile unsigned char*)(0x42DEC414UL))
#define bFM_GPIO_EPFR08_SOT4B0                *((volatile unsigned char*)(0x42DEC418UL))
#define bFM_GPIO_EPFR08_SOT4B1                *((volatile unsigned char*)(0x42DEC41CUL))
#define bFM_GPIO_EPFR08_SCK4B0                *((volatile unsigned char*)(0x42DEC420UL))
#define bFM_GPIO_EPFR08_SCK4B1                *((volatile unsigned char*)(0x42DEC424UL))
#define bFM_GPIO_EPFR08_SIN5S0                *((volatile unsigned char*)(0x42DEC428UL))
#define bFM_GPIO_EPFR08_SIN5S1                *((volatile unsigned char*)(0x42DEC42CUL))
#define bFM_GPIO_EPFR08_SOT5B0                *((volatile unsigned char*)(0x42DEC430UL))
#define bFM_GPIO_EPFR08_SOT5B1                *((volatile unsigned char*)(0x42DEC434UL))
#define bFM_GPIO_EPFR08_SCK5B0                *((volatile unsigned char*)(0x42DEC438UL))
#define bFM_GPIO_EPFR08_SCK5B1                *((volatile unsigned char*)(0x42DEC43CUL))
#define bFM_GPIO_EPFR08_SIN6S0                *((volatile unsigned char*)(0x42DEC440UL))
#define bFM_GPIO_EPFR08_SIN6S1                *((volatile unsigned char*)(0x42DEC444UL))
#define bFM_GPIO_EPFR08_SOT6B0                *((volatile unsigned char*)(0x42DEC448UL))
#define bFM_GPIO_EPFR08_SOT6B1                *((volatile unsigned char*)(0x42DEC44CUL))
#define bFM_GPIO_EPFR08_SCK6B0                *((volatile unsigned char*)(0x42DEC450UL))
#define bFM_GPIO_EPFR08_SCK6B1                *((volatile unsigned char*)(0x42DEC454UL))
#define bFM_GPIO_EPFR08_SIN7S0                *((volatile unsigned char*)(0x42DEC458UL))
#define bFM_GPIO_EPFR08_SIN7S1                *((volatile unsigned char*)(0x42DEC45CUL))
#define bFM_GPIO_EPFR08_SOT7B0                *((volatile unsigned char*)(0x42DEC460UL))
#define bFM_GPIO_EPFR08_SOT7B1                *((volatile unsigned char*)(0x42DEC464UL))
#define bFM_GPIO_EPFR08_SCK7B0                *((volatile unsigned char*)(0x42DEC468UL))
#define bFM_GPIO_EPFR08_SCK7B1                *((volatile unsigned char*)(0x42DEC46CUL))
#define bFM_GPIO_EPFR08_RTS5E0                *((volatile unsigned char*)(0x42DEC470UL))
#define bFM_GPIO_EPFR08_RTS5E1                *((volatile unsigned char*)(0x42DEC474UL))
#define bFM_GPIO_EPFR08_CTS5S0                *((volatile unsigned char*)(0x42DEC478UL))
#define bFM_GPIO_EPFR08_CTS5S1                *((volatile unsigned char*)(0x42DEC47CUL))
#define bFM_GPIO_EPFR09_QAIN0S0               *((volatile unsigned char*)(0x42DEC480UL))
#define bFM_GPIO_EPFR09_QAIN0S1               *((volatile unsigned char*)(0x42DEC484UL))
#define bFM_GPIO_EPFR09_QBIN0S0               *((volatile unsigned char*)(0x42DEC488UL))
#define bFM_GPIO_EPFR09_QBIN0S1               *((volatile unsigned char*)(0x42DEC48CUL))
#define bFM_GPIO_EPFR09_QZIN0S0               *((volatile unsigned char*)(0x42DEC490UL))
#define bFM_GPIO_EPFR09_QZIN0S1               *((volatile unsigned char*)(0x42DEC494UL))
#define bFM_GPIO_EPFR09_QAIN1S0               *((volatile unsigned char*)(0x42DEC498UL))
#define bFM_GPIO_EPFR09_QAIN1S1               *((volatile unsigned char*)(0x42DEC49CUL))
#define bFM_GPIO_EPFR09_QBIN1S0               *((volatile unsigned char*)(0x42DEC4A0UL))
#define bFM_GPIO_EPFR09_QBIN1S1               *((volatile unsigned char*)(0x42DEC4A4UL))
#define bFM_GPIO_EPFR09_QZIN1S0               *((volatile unsigned char*)(0x42DEC4A8UL))
#define bFM_GPIO_EPFR09_QZIN1S1               *((volatile unsigned char*)(0x42DEC4ACUL))
#define bFM_GPIO_EPFR09_ADTRG0S0              *((volatile unsigned char*)(0x42DEC4B0UL))
#define bFM_GPIO_EPFR09_ADTRG0S1              *((volatile unsigned char*)(0x42DEC4B4UL))
#define bFM_GPIO_EPFR09_ADTRG0S2              *((volatile unsigned char*)(0x42DEC4B8UL))
#define bFM_GPIO_EPFR09_ADTRG0S3              *((volatile unsigned char*)(0x42DEC4BCUL))
#define bFM_GPIO_EPFR09_ADTRG1S0              *((volatile unsigned char*)(0x42DEC4C0UL))
#define bFM_GPIO_EPFR09_ADTRG1S1              *((volatile unsigned char*)(0x42DEC4C4UL))
#define bFM_GPIO_EPFR09_ADTRG1S2              *((volatile unsigned char*)(0x42DEC4C8UL))
#define bFM_GPIO_EPFR09_ADTRG1S3              *((volatile unsigned char*)(0x42DEC4CCUL))
#define bFM_GPIO_EPFR09_ADTRG2S0              *((volatile unsigned char*)(0x42DEC4D0UL))
#define bFM_GPIO_EPFR09_ADTRG2S1              *((volatile unsigned char*)(0x42DEC4D4UL))
#define bFM_GPIO_EPFR09_ADTRG2S2              *((volatile unsigned char*)(0x42DEC4D8UL))
#define bFM_GPIO_EPFR09_ADTRG2S3              *((volatile unsigned char*)(0x42DEC4DCUL))
#define bFM_GPIO_EPFR09_CRX0S0                *((volatile unsigned char*)(0x42DEC4E0UL))
#define bFM_GPIO_EPFR09_CRX0S1                *((volatile unsigned char*)(0x42DEC4E4UL))
#define bFM_GPIO_EPFR09_CTX0E0                *((volatile unsigned char*)(0x42DEC4E8UL))
#define bFM_GPIO_EPFR09_CTX0E1                *((volatile unsigned char*)(0x42DEC4ECUL))
#define bFM_GPIO_EPFR09_CRX1S0                *((volatile unsigned char*)(0x42DEC4F0UL))
#define bFM_GPIO_EPFR09_CRX1S1                *((volatile unsigned char*)(0x42DEC4F4UL))
#define bFM_GPIO_EPFR09_CTX1E0                *((volatile unsigned char*)(0x42DEC4F8UL))
#define bFM_GPIO_EPFR09_CTX1E1                *((volatile unsigned char*)(0x42DEC4FCUL))
#define bFM_GPIO_EPFR10_UEDEFB                *((volatile unsigned char*)(0x42DEC500UL))
#define bFM_GPIO_EPFR10_UEDTHB                *((volatile unsigned char*)(0x42DEC504UL))
#define bFM_GPIO_EPFR10_UECLKE                *((volatile unsigned char*)(0x42DEC508UL))
#define bFM_GPIO_EPFR10_UEWEXE                *((volatile unsigned char*)(0x42DEC50CUL))
#define bFM_GPIO_EPFR10_UEDQME                *((volatile unsigned char*)(0x42DEC510UL))
#define bFM_GPIO_EPFR10_UEOEXE                *((volatile unsigned char*)(0x42DEC514UL))
#define bFM_GPIO_EPFR10_UEFLSE                *((volatile unsigned char*)(0x42DEC518UL))
#define bFM_GPIO_EPFR10_UECS1E                *((volatile unsigned char*)(0x42DEC51CUL))
#define bFM_GPIO_EPFR10_UECS2E                *((volatile unsigned char*)(0x42DEC520UL))
#define bFM_GPIO_EPFR10_UECS3E                *((volatile unsigned char*)(0x42DEC524UL))
#define bFM_GPIO_EPFR10_UECS4E                *((volatile unsigned char*)(0x42DEC528UL))
#define bFM_GPIO_EPFR10_UECS5E                *((volatile unsigned char*)(0x42DEC52CUL))
#define bFM_GPIO_EPFR10_UECS6E                *((volatile unsigned char*)(0x42DEC530UL))
#define bFM_GPIO_EPFR10_UECS7E                *((volatile unsigned char*)(0x42DEC534UL))
#define bFM_GPIO_EPFR10_UEAOOE                *((volatile unsigned char*)(0x42DEC538UL))
#define bFM_GPIO_EPFR10_UEA08E                *((volatile unsigned char*)(0x42DEC53CUL))
#define bFM_GPIO_EPFR10_UEA09E                *((volatile unsigned char*)(0x42DEC540UL))
#define bFM_GPIO_EPFR10_UEA10E                *((volatile unsigned char*)(0x42DEC544UL))
#define bFM_GPIO_EPFR10_UEA11E                *((volatile unsigned char*)(0x42DEC548UL))
#define bFM_GPIO_EPFR10_UEA12E                *((volatile unsigned char*)(0x42DEC54CUL))
#define bFM_GPIO_EPFR10_UEA13E                *((volatile unsigned char*)(0x42DEC550UL))
#define bFM_GPIO_EPFR10_UEA14E                *((volatile unsigned char*)(0x42DEC554UL))
#define bFM_GPIO_EPFR10_UEA15E                *((volatile unsigned char*)(0x42DEC558UL))
#define bFM_GPIO_EPFR10_UEA16E                *((volatile unsigned char*)(0x42DEC55CUL))
#define bFM_GPIO_EPFR10_UEA17E                *((volatile unsigned char*)(0x42DEC560UL))
#define bFM_GPIO_EPFR10_UEA18E                *((volatile unsigned char*)(0x42DEC564UL))
#define bFM_GPIO_EPFR10_UEA19E                *((volatile unsigned char*)(0x42DEC568UL))
#define bFM_GPIO_EPFR10_UEA20E                *((volatile unsigned char*)(0x42DEC56CUL))
#define bFM_GPIO_EPFR10_UEA21E                *((volatile unsigned char*)(0x42DEC570UL))
#define bFM_GPIO_EPFR10_UEA22E                *((volatile unsigned char*)(0x42DEC574UL))
#define bFM_GPIO_EPFR10_UEA23E                *((volatile unsigned char*)(0x42DEC578UL))
#define bFM_GPIO_EPFR10_UEA24E                *((volatile unsigned char*)(0x42DEC57CUL))
#define bFM_GPIO_EPFR11_UEALEE                *((volatile unsigned char*)(0x42DEC580UL))
#define bFM_GPIO_EPFR11_UECS0E                *((volatile unsigned char*)(0x42DEC584UL))
#define bFM_GPIO_EPFR11_UEA01E                *((volatile unsigned char*)(0x42DEC588UL))
#define bFM_GPIO_EPFR11_UEA02E                *((volatile unsigned char*)(0x42DEC58CUL))
#define bFM_GPIO_EPFR11_UEA03E                *((volatile unsigned char*)(0x42DEC590UL))
#define bFM_GPIO_EPFR11_UEA04E                *((volatile unsigned char*)(0x42DEC594UL))
#define bFM_GPIO_EPFR11_UEA05E                *((volatile unsigned char*)(0x42DEC598UL))
#define bFM_GPIO_EPFR11_UEA06E                *((volatile unsigned char*)(0x42DEC59CUL))
#define bFM_GPIO_EPFR11_UEA07E                *((volatile unsigned char*)(0x42DEC5A0UL))
#define bFM_GPIO_EPFR11_UED00B                *((volatile unsigned char*)(0x42DEC5A4UL))
#define bFM_GPIO_EPFR11_UED01B                *((volatile unsigned char*)(0x42DEC5A8UL))
#define bFM_GPIO_EPFR11_UED02B                *((volatile unsigned char*)(0x42DEC5ACUL))
#define bFM_GPIO_EPFR11_UED03B                *((volatile unsigned char*)(0x42DEC5B0UL))
#define bFM_GPIO_EPFR11_UED04B                *((volatile unsigned char*)(0x42DEC5B4UL))
#define bFM_GPIO_EPFR11_UED05B                *((volatile unsigned char*)(0x42DEC5B8UL))
#define bFM_GPIO_EPFR11_UED06B                *((volatile unsigned char*)(0x42DEC5BCUL))
#define bFM_GPIO_EPFR11_UED07B                *((volatile unsigned char*)(0x42DEC5C0UL))
#define bFM_GPIO_EPFR11_UED08B                *((volatile unsigned char*)(0x42DEC5C4UL))
#define bFM_GPIO_EPFR11_UED09B                *((volatile unsigned char*)(0x42DEC5C8UL))
#define bFM_GPIO_EPFR11_UED10B                *((volatile unsigned char*)(0x42DEC5CCUL))
#define bFM_GPIO_EPFR11_UED11B                *((volatile unsigned char*)(0x42DEC5D0UL))
#define bFM_GPIO_EPFR11_UED12B                *((volatile unsigned char*)(0x42DEC5D4UL))
#define bFM_GPIO_EPFR11_UED13B                *((volatile unsigned char*)(0x42DEC5D8UL))
#define bFM_GPIO_EPFR11_UED14B                *((volatile unsigned char*)(0x42DEC5DCUL))
#define bFM_GPIO_EPFR11_UED15B                *((volatile unsigned char*)(0x42DEC5E0UL))
#define bFM_GPIO_EPFR11_UERLC                 *((volatile unsigned char*)(0x42DEC5E4UL))
#define bFM_GPIO_EPFR12_TIOA8E0               *((volatile unsigned char*)(0x42DEC608UL))
#define bFM_GPIO_EPFR12_TIOA8E1               *((volatile unsigned char*)(0x42DEC60CUL))
#define bFM_GPIO_EPFR12_TIOB8S0               *((volatile unsigned char*)(0x42DEC610UL))
#define bFM_GPIO_EPFR12_TIOB8S1               *((volatile unsigned char*)(0x42DEC614UL))
#define bFM_GPIO_EPFR12_TIOA9S0               *((volatile unsigned char*)(0x42DEC620UL))
#define bFM_GPIO_EPFR12_TIOA9S1               *((volatile unsigned char*)(0x42DEC624UL))
#define bFM_GPIO_EPFR12_TIOA9E0               *((volatile unsigned char*)(0x42DEC628UL))
#define bFM_GPIO_EPFR12_TIOA9E1               *((volatile unsigned char*)(0x42DEC62CUL))
#define bFM_GPIO_EPFR12_TIOB9S0               *((volatile unsigned char*)(0x42DEC630UL))
#define bFM_GPIO_EPFR12_TIOB9S1               *((volatile unsigned char*)(0x42DEC634UL))
#define bFM_GPIO_EPFR12_TIOA10E0              *((volatile unsigned char*)(0x42DEC648UL))
#define bFM_GPIO_EPFR12_TIOA10E1              *((volatile unsigned char*)(0x42DEC64CUL))
#define bFM_GPIO_EPFR12_TIOB10S0              *((volatile unsigned char*)(0x42DEC650UL))
#define bFM_GPIO_EPFR12_TIOB10S1              *((volatile unsigned char*)(0x42DEC654UL))
#define bFM_GPIO_EPFR12_TIOA11S0              *((volatile unsigned char*)(0x42DEC660UL))
#define bFM_GPIO_EPFR12_TIOA11S1              *((volatile unsigned char*)(0x42DEC664UL))
#define bFM_GPIO_EPFR12_TIOA11E0              *((volatile unsigned char*)(0x42DEC668UL))
#define bFM_GPIO_EPFR12_TIOA11E1              *((volatile unsigned char*)(0x42DEC66CUL))
#define bFM_GPIO_EPFR12_TIOB11S0              *((volatile unsigned char*)(0x42DEC670UL))
#define bFM_GPIO_EPFR12_TIOB11S1              *((volatile unsigned char*)(0x42DEC674UL))
#define bFM_GPIO_EPFR13_TIOA12E0              *((volatile unsigned char*)(0x42DEC688UL))
#define bFM_GPIO_EPFR13_TIOA12E1              *((volatile unsigned char*)(0x42DEC68CUL))
#define bFM_GPIO_EPFR13_TIOB12S0              *((volatile unsigned char*)(0x42DEC690UL))
#define bFM_GPIO_EPFR13_TIOB12S1              *((volatile unsigned char*)(0x42DEC694UL))
#define bFM_GPIO_EPFR13_TIOA13S0              *((volatile unsigned char*)(0x42DEC6A0UL))
#define bFM_GPIO_EPFR13_TIOA13S1              *((volatile unsigned char*)(0x42DEC6A4UL))
#define bFM_GPIO_EPFR13_TIOA13E0              *((volatile unsigned char*)(0x42DEC6A8UL))
#define bFM_GPIO_EPFR13_TIOA13E1              *((volatile unsigned char*)(0x42DEC6ACUL))
#define bFM_GPIO_EPFR13_TIOB13S0              *((volatile unsigned char*)(0x42DEC6B0UL))
#define bFM_GPIO_EPFR13_TIOB13S1              *((volatile unsigned char*)(0x42DEC6B4UL))
#define bFM_GPIO_EPFR13_TIOA14E0              *((volatile unsigned char*)(0x42DEC6C8UL))
#define bFM_GPIO_EPFR13_TIOA14E1              *((volatile unsigned char*)(0x42DEC6CCUL))
#define bFM_GPIO_EPFR13_TIOB14S0              *((volatile unsigned char*)(0x42DEC6D0UL))
#define bFM_GPIO_EPFR13_TIOB14S1              *((volatile unsigned char*)(0x42DEC6D4UL))
#define bFM_GPIO_EPFR13_TIOA15S0              *((volatile unsigned char*)(0x42DEC6E0UL))
#define bFM_GPIO_EPFR13_TIOA15S1              *((volatile unsigned char*)(0x42DEC6E4UL))
#define bFM_GPIO_EPFR13_TIOA15E0              *((volatile unsigned char*)(0x42DEC6E8UL))
#define bFM_GPIO_EPFR13_TIOA15E1              *((volatile unsigned char*)(0x42DEC6ECUL))
#define bFM_GPIO_EPFR13_TIOB15S0              *((volatile unsigned char*)(0x42DEC6F0UL))
#define bFM_GPIO_EPFR13_TIOB15S1              *((volatile unsigned char*)(0x42DEC6F4UL))
#define bFM_GPIO_EPFR14_QAIN2S0               *((volatile unsigned char*)(0x42DEC700UL))
#define bFM_GPIO_EPFR14_QAIN2S1               *((volatile unsigned char*)(0x42DEC704UL))
#define bFM_GPIO_EPFR14_QBIN2S0               *((volatile unsigned char*)(0x42DEC708UL))
#define bFM_GPIO_EPFR14_QBIN2S1               *((volatile unsigned char*)(0x42DEC70CUL))
#define bFM_GPIO_EPFR14_QZIN2S0               *((volatile unsigned char*)(0x42DEC710UL))
#define bFM_GPIO_EPFR14_QZIN2S1               *((volatile unsigned char*)(0x42DEC714UL))
#define bFM_GPIO_EPFR14_E_TD0E                *((volatile unsigned char*)(0x42DEC748UL))
#define bFM_GPIO_EPFR14_E_TD1E                *((volatile unsigned char*)(0x42DEC74CUL))
#define bFM_GPIO_EPFR14_E_TE0E                *((volatile unsigned char*)(0x42DEC750UL))
#define bFM_GPIO_EPFR14_E_TE1E                *((volatile unsigned char*)(0x42DEC754UL))
#define bFM_GPIO_EPFR14_E_MC0E                *((volatile unsigned char*)(0x42DEC758UL))
#define bFM_GPIO_EPFR14_E_MC1B                *((volatile unsigned char*)(0x42DEC75CUL))
#define bFM_GPIO_EPFR14_E_MD0B                *((volatile unsigned char*)(0x42DEC760UL))
#define bFM_GPIO_EPFR14_E_MD1B                *((volatile unsigned char*)(0x42DEC764UL))
#define bFM_GPIO_EPFR14_E_CKE                 *((volatile unsigned char*)(0x42DEC768UL))
#define bFM_GPIO_EPFR14_E_PSE                 *((volatile unsigned char*)(0x42DEC76CUL))
#define bFM_GPIO_EPFR14_E_SPLC0               *((volatile unsigned char*)(0x42DEC770UL))
#define bFM_GPIO_EPFR14_E_SPLC1               *((volatile unsigned char*)(0x42DEC774UL))
#define bFM_GPIO_EPFR15_EINT16S0              *((volatile unsigned char*)(0x42DEC780UL))
#define bFM_GPIO_EPFR15_EINT16S1              *((volatile unsigned char*)(0x42DEC784UL))
#define bFM_GPIO_EPFR15_EINT17S0              *((volatile unsigned char*)(0x42DEC788UL))
#define bFM_GPIO_EPFR15_EINT17S1              *((volatile unsigned char*)(0x42DEC78CUL))
#define bFM_GPIO_EPFR15_EINT18S0              *((volatile unsigned char*)(0x42DEC790UL))
#define bFM_GPIO_EPFR15_EINT18S1              *((volatile unsigned char*)(0x42DEC794UL))
#define bFM_GPIO_EPFR15_EINT19S0              *((volatile unsigned char*)(0x42DEC798UL))
#define bFM_GPIO_EPFR15_EINT19S1              *((volatile unsigned char*)(0x42DEC79CUL))
#define bFM_GPIO_EPFR15_EINT20S0              *((volatile unsigned char*)(0x42DEC7A0UL))
#define bFM_GPIO_EPFR15_EINT20S1              *((volatile unsigned char*)(0x42DEC7A4UL))
#define bFM_GPIO_EPFR15_EINT21S0              *((volatile unsigned char*)(0x42DEC7A8UL))
#define bFM_GPIO_EPFR15_EINT21S1              *((volatile unsigned char*)(0x42DEC7ACUL))
#define bFM_GPIO_EPFR15_EINT22S0              *((volatile unsigned char*)(0x42DEC7B0UL))
#define bFM_GPIO_EPFR15_EINT22S1              *((volatile unsigned char*)(0x42DEC7B4UL))
#define bFM_GPIO_EPFR15_EINT23S0              *((volatile unsigned char*)(0x42DEC7B8UL))
#define bFM_GPIO_EPFR15_EINT23S1              *((volatile unsigned char*)(0x42DEC7BCUL))
#define bFM_GPIO_EPFR15_EINT24S0              *((volatile unsigned char*)(0x42DEC7C0UL))
#define bFM_GPIO_EPFR15_EINT24S1              *((volatile unsigned char*)(0x42DEC7C4UL))
#define bFM_GPIO_EPFR15_EINT25S0              *((volatile unsigned char*)(0x42DEC7C8UL))
#define bFM_GPIO_EPFR15_EINT25S1              *((volatile unsigned char*)(0x42DEC7CCUL))
#define bFM_GPIO_EPFR15_EINT26S0              *((volatile unsigned char*)(0x42DEC7D0UL))
#define bFM_GPIO_EPFR15_EINT26S1              *((volatile unsigned char*)(0x42DEC7D4UL))
#define bFM_GPIO_EPFR15_EINT27S0              *((volatile unsigned char*)(0x42DEC7D8UL))
#define bFM_GPIO_EPFR15_EINT27S1              *((volatile unsigned char*)(0x42DEC7DCUL))
#define bFM_GPIO_EPFR15_EINT28S0              *((volatile unsigned char*)(0x42DEC7E0UL))
#define bFM_GPIO_EPFR15_EINT28S1              *((volatile unsigned char*)(0x42DEC7E4UL))
#define bFM_GPIO_EPFR15_EINT29S0              *((volatile unsigned char*)(0x42DEC7E8UL))
#define bFM_GPIO_EPFR15_EINT29S1              *((volatile unsigned char*)(0x42DEC7ECUL))
#define bFM_GPIO_EPFR15_EINT30S0              *((volatile unsigned char*)(0x42DEC7F0UL))
#define bFM_GPIO_EPFR15_EINT30S1              *((volatile unsigned char*)(0x42DEC7F4UL))
#define bFM_GPIO_EPFR15_EINT31S0              *((volatile unsigned char*)(0x42DEC7F8UL))
#define bFM_GPIO_EPFR15_EINT31S1              *((volatile unsigned char*)(0x42DEC7FCUL))
#define bFM_GPIO_EPFR16_SCS6B0                *((volatile unsigned char*)(0x42DEC800UL))
#define bFM_GPIO_EPFR16_SCS6B1                *((volatile unsigned char*)(0x42DEC804UL))
#define bFM_GPIO_EPFR16_SCS7B0                *((volatile unsigned char*)(0x42DEC808UL))
#define bFM_GPIO_EPFR16_SCS7B1                *((volatile unsigned char*)(0x42DEC80CUL))
#define bFM_GPIO_EPFR16_SIN8S0                *((volatile unsigned char*)(0x42DEC810UL))
#define bFM_GPIO_EPFR16_SIN8S1                *((volatile unsigned char*)(0x42DEC814UL))
#define bFM_GPIO_EPFR16_SOT8B0                *((volatile unsigned char*)(0x42DEC818UL))
#define bFM_GPIO_EPFR16_SOT8B1                *((volatile unsigned char*)(0x42DEC81CUL))
#define bFM_GPIO_EPFR16_SCK8B0                *((volatile unsigned char*)(0x42DEC820UL))
#define bFM_GPIO_EPFR16_SCK8B1                *((volatile unsigned char*)(0x42DEC824UL))
#define bFM_GPIO_EPFR16_SIN9S0                *((volatile unsigned char*)(0x42DEC828UL))
#define bFM_GPIO_EPFR16_SIN9S1                *((volatile unsigned char*)(0x42DEC82CUL))
#define bFM_GPIO_EPFR16_SOT9B0                *((volatile unsigned char*)(0x42DEC830UL))
#define bFM_GPIO_EPFR16_SOT9B1                *((volatile unsigned char*)(0x42DEC834UL))
#define bFM_GPIO_EPFR16_SCK9B0                *((volatile unsigned char*)(0x42DEC838UL))
#define bFM_GPIO_EPFR16_SCK9B1                *((volatile unsigned char*)(0x42DEC83CUL))
#define bFM_GPIO_EPFR16_SIN10S0               *((volatile unsigned char*)(0x42DEC840UL))
#define bFM_GPIO_EPFR16_SIN10S1               *((volatile unsigned char*)(0x42DEC844UL))
#define bFM_GPIO_EPFR16_SOT10B0               *((volatile unsigned char*)(0x42DEC848UL))
#define bFM_GPIO_EPFR16_SOT10B1               *((volatile unsigned char*)(0x42DEC84CUL))
#define bFM_GPIO_EPFR16_SCK10B0               *((volatile unsigned char*)(0x42DEC850UL))
#define bFM_GPIO_EPFR16_SCK10B1               *((volatile unsigned char*)(0x42DEC854UL))
#define bFM_GPIO_EPFR16_SIN11S0               *((volatile unsigned char*)(0x42DEC858UL))
#define bFM_GPIO_EPFR16_SIN11S1               *((volatile unsigned char*)(0x42DEC85CUL))
#define bFM_GPIO_EPFR16_SOT11B0               *((volatile unsigned char*)(0x42DEC860UL))
#define bFM_GPIO_EPFR16_SOT11B1               *((volatile unsigned char*)(0x42DEC864UL))
#define bFM_GPIO_EPFR16_SCK11B0               *((volatile unsigned char*)(0x42DEC868UL))
#define bFM_GPIO_EPFR16_SCK11B1               *((volatile unsigned char*)(0x42DEC86CUL))
#define bFM_GPIO_EPFR16_SFMPAC                *((volatile unsigned char*)(0x42DEC870UL))
#define bFM_GPIO_EPFR16_SFMPBC                *((volatile unsigned char*)(0x42DEC874UL))
#define bFM_GPIO_EPFR17_SIN12S0               *((volatile unsigned char*)(0x42DEC890UL))
#define bFM_GPIO_EPFR17_SIN12S1               *((volatile unsigned char*)(0x42DEC894UL))
#define bFM_GPIO_EPFR17_SOT12B0               *((volatile unsigned char*)(0x42DEC898UL))
#define bFM_GPIO_EPFR17_SOT12B1               *((volatile unsigned char*)(0x42DEC89CUL))
#define bFM_GPIO_EPFR17_SCK12B0               *((volatile unsigned char*)(0x42DEC8A0UL))
#define bFM_GPIO_EPFR17_SCK12B1               *((volatile unsigned char*)(0x42DEC8A4UL))
#define bFM_GPIO_EPFR17_SIN13S0               *((volatile unsigned char*)(0x42DEC8A8UL))
#define bFM_GPIO_EPFR17_SIN13S1               *((volatile unsigned char*)(0x42DEC8ACUL))
#define bFM_GPIO_EPFR17_SOT13B0               *((volatile unsigned char*)(0x42DEC8B0UL))
#define bFM_GPIO_EPFR17_SOT13B1               *((volatile unsigned char*)(0x42DEC8B4UL))
#define bFM_GPIO_EPFR17_SCK13B0               *((volatile unsigned char*)(0x42DEC8B8UL))
#define bFM_GPIO_EPFR17_SCK13B1               *((volatile unsigned char*)(0x42DEC8BCUL))
#define bFM_GPIO_EPFR17_SIN14S0               *((volatile unsigned char*)(0x42DEC8C0UL))
#define bFM_GPIO_EPFR17_SIN14S1               *((volatile unsigned char*)(0x42DEC8C4UL))
#define bFM_GPIO_EPFR17_SOT14B0               *((volatile unsigned char*)(0x42DEC8C8UL))
#define bFM_GPIO_EPFR17_SOT14B1               *((volatile unsigned char*)(0x42DEC8CCUL))
#define bFM_GPIO_EPFR17_SCK14B0               *((volatile unsigned char*)(0x42DEC8D0UL))
#define bFM_GPIO_EPFR17_SCK14B1               *((volatile unsigned char*)(0x42DEC8D4UL))
#define bFM_GPIO_EPFR17_SIN15S0               *((volatile unsigned char*)(0x42DEC8D8UL))
#define bFM_GPIO_EPFR17_SIN15S1               *((volatile unsigned char*)(0x42DEC8DCUL))
#define bFM_GPIO_EPFR17_SOT15B0               *((volatile unsigned char*)(0x42DEC8E0UL))
#define bFM_GPIO_EPFR17_SOT15B1               *((volatile unsigned char*)(0x42DEC8E4UL))
#define bFM_GPIO_EPFR17_SCK15B0               *((volatile unsigned char*)(0x42DEC8E8UL))
#define bFM_GPIO_EPFR17_SCK15B1               *((volatile unsigned char*)(0x42DEC8ECUL))
#define bFM_GPIO_EPFR18_CECR0B0               *((volatile unsigned char*)(0x42DEC900UL))
#define bFM_GPIO_EPFR18_CECR0B1               *((volatile unsigned char*)(0x42DEC904UL))
#define bFM_GPIO_EPFR18_CECR1B0               *((volatile unsigned char*)(0x42DEC908UL))
#define bFM_GPIO_EPFR18_CECR1B1               *((volatile unsigned char*)(0x42DEC90CUL))
#define bFM_GPIO_EPFR18_QAIN3S0               *((volatile unsigned char*)(0x42DEC910UL))
#define bFM_GPIO_EPFR18_QAIN3S1               *((volatile unsigned char*)(0x42DEC914UL))
#define bFM_GPIO_EPFR18_QBIN3S0               *((volatile unsigned char*)(0x42DEC918UL))
#define bFM_GPIO_EPFR18_QBIN3S1               *((volatile unsigned char*)(0x42DEC91CUL))
#define bFM_GPIO_EPFR18_QZIN3S0               *((volatile unsigned char*)(0x42DEC920UL))
#define bFM_GPIO_EPFR18_QZIN3S1               *((volatile unsigned char*)(0x42DEC924UL))
#define bFM_GPIO_EPFR18_SDCLKE0               *((volatile unsigned char*)(0x42DEC938UL))
#define bFM_GPIO_EPFR18_SDCLKE1               *((volatile unsigned char*)(0x42DEC93CUL))
#define bFM_GPIO_EPFR18_SDCMDB0               *((volatile unsigned char*)(0x42DEC940UL))
#define bFM_GPIO_EPFR18_SDCMDB1               *((volatile unsigned char*)(0x42DEC944UL))
#define bFM_GPIO_EPFR18_SDDATA0B0             *((volatile unsigned char*)(0x42DEC948UL))
#define bFM_GPIO_EPFR18_SDDATA0B1             *((volatile unsigned char*)(0x42DEC94CUL))
#define bFM_GPIO_EPFR18_SDDATA1B0             *((volatile unsigned char*)(0x42DEC950UL))
#define bFM_GPIO_EPFR18_SDDATA1B1             *((volatile unsigned char*)(0x42DEC954UL))
#define bFM_GPIO_EPFR18_SDDATA2B0             *((volatile unsigned char*)(0x42DEC958UL))
#define bFM_GPIO_EPFR18_SDDATA2B1             *((volatile unsigned char*)(0x42DEC95CUL))
#define bFM_GPIO_EPFR18_SDDATA3B0             *((volatile unsigned char*)(0x42DEC960UL))
#define bFM_GPIO_EPFR18_SDDATA3B1             *((volatile unsigned char*)(0x42DEC964UL))
#define bFM_GPIO_EPFR18_SDCDS0                *((volatile unsigned char*)(0x42DEC968UL))
#define bFM_GPIO_EPFR18_SDCDS1                *((volatile unsigned char*)(0x42DEC96CUL))
#define bFM_GPIO_EPFR18_SDWPS0                *((volatile unsigned char*)(0x42DEC970UL))
#define bFM_GPIO_EPFR18_SDWPS1                *((volatile unsigned char*)(0x42DEC974UL))
#define bFM_GPIO_EPFR20_UESMCKE               *((volatile unsigned char*)(0x42DECA00UL))
#define bFM_GPIO_EPFR20_UESMCEE               *((volatile unsigned char*)(0x42DECA04UL))
#define bFM_GPIO_EPFR20_UERASE                *((volatile unsigned char*)(0x42DECA08UL))
#define bFM_GPIO_EPFR20_UECASE                *((volatile unsigned char*)(0x42DECA0CUL))
#define bFM_GPIO_EPFR20_UEDWEXE               *((volatile unsigned char*)(0x42DECA10UL))
#define bFM_GPIO_EPFR20_UECSXE                *((volatile unsigned char*)(0x42DECA14UL))
#define bFM_GPIO_EPFR20_UEDQM2E               *((volatile unsigned char*)(0x42DECA18UL))
#define bFM_GPIO_EPFR20_UEDQM3E               *((volatile unsigned char*)(0x42DECA1CUL))
#define bFM_GPIO_EPFR20_UEDTHHB               *((volatile unsigned char*)(0x42DECA20UL))
#define bFM_GPIO_EPFR20_UED16B                *((volatile unsigned char*)(0x42DECA24UL))
#define bFM_GPIO_EPFR20_UED17B                *((volatile unsigned char*)(0x42DECA28UL))
#define bFM_GPIO_EPFR20_UED18B                *((volatile unsigned char*)(0x42DECA2CUL))
#define bFM_GPIO_EPFR20_UED19B                *((volatile unsigned char*)(0x42DECA30UL))
#define bFM_GPIO_EPFR20_UED20B                *((volatile unsigned char*)(0x42DECA34UL))
#define bFM_GPIO_EPFR20_UED21B                *((volatile unsigned char*)(0x42DECA38UL))
#define bFM_GPIO_EPFR20_UED22B                *((volatile unsigned char*)(0x42DECA3CUL))
#define bFM_GPIO_EPFR20_UED23B                *((volatile unsigned char*)(0x42DECA40UL))
#define bFM_GPIO_EPFR20_UED24B                *((volatile unsigned char*)(0x42DECA44UL))
#define bFM_GPIO_EPFR20_UED25B                *((volatile unsigned char*)(0x42DECA48UL))
#define bFM_GPIO_EPFR20_UED26B                *((volatile unsigned char*)(0x42DECA4CUL))
#define bFM_GPIO_EPFR20_UED27B                *((volatile unsigned char*)(0x42DECA50UL))
#define bFM_GPIO_EPFR20_UED28B                *((volatile unsigned char*)(0x42DECA54UL))
#define bFM_GPIO_EPFR20_UED29B                *((volatile unsigned char*)(0x42DECA58UL))
#define bFM_GPIO_EPFR20_UED30B                *((volatile unsigned char*)(0x42DECA5CUL))
#define bFM_GPIO_EPFR20_UED31B                *((volatile unsigned char*)(0x42DECA60UL))
#define bFM_GPIO_EPFR23_SCS60E0               *((volatile unsigned char*)(0x42DECB80UL))
#define bFM_GPIO_EPFR23_SCS60E1               *((volatile unsigned char*)(0x42DECB84UL))
#define bFM_GPIO_EPFR23_SCS61E0               *((volatile unsigned char*)(0x42DECB88UL))
#define bFM_GPIO_EPFR23_SCS61E1               *((volatile unsigned char*)(0x42DECB8CUL))
#define bFM_GPIO_EPFR23_SCS62E0               *((volatile unsigned char*)(0x42DECB90UL))
#define bFM_GPIO_EPFR23_SCS62E1               *((volatile unsigned char*)(0x42DECB94UL))
#define bFM_GPIO_EPFR23_SCS63E0               *((volatile unsigned char*)(0x42DECB98UL))
#define bFM_GPIO_EPFR23_SCS63E1               *((volatile unsigned char*)(0x42DECB9CUL))
#define bFM_GPIO_EPFR23_SCS70E0               *((volatile unsigned char*)(0x42DECBA0UL))
#define bFM_GPIO_EPFR23_SCS70E1               *((volatile unsigned char*)(0x42DECBA4UL))
#define bFM_GPIO_EPFR23_SCS71E0               *((volatile unsigned char*)(0x42DECBA8UL))
#define bFM_GPIO_EPFR23_SCS71E1               *((volatile unsigned char*)(0x42DECBACUL))
#define bFM_GPIO_EPFR23_SCS72E0               *((volatile unsigned char*)(0x42DECBB0UL))
#define bFM_GPIO_EPFR23_SCS72E1               *((volatile unsigned char*)(0x42DECBB4UL))
#define bFM_GPIO_EPFR23_SCS73E0               *((volatile unsigned char*)(0x42DECBB8UL))
#define bFM_GPIO_EPFR23_SCS73E1               *((volatile unsigned char*)(0x42DECBBCUL))
#define bFM_GPIO_EPFR24_I2SM4_MCLK0S0         *((volatile unsigned char*)(0x42DECC00UL))
#define bFM_GPIO_EPFR24_I2SM4_MCLK0S1         *((volatile unsigned char*)(0x42DECC04UL))
#define bFM_GPIO_EPFR24_I2SM4_MCLK0E0         *((volatile unsigned char*)(0x42DECC08UL))
#define bFM_GPIO_EPFR24_I2SM4_MCLK0E1         *((volatile unsigned char*)(0x42DECC0CUL))
#define bFM_GPIO_EPFR24_I2SM4_SCK0B0          *((volatile unsigned char*)(0x42DECC10UL))
#define bFM_GPIO_EPFR24_I2SM4_SCK0B1          *((volatile unsigned char*)(0x42DECC14UL))
#define bFM_GPIO_EPFR24_I2SM4_WS0B0           *((volatile unsigned char*)(0x42DECC18UL))
#define bFM_GPIO_EPFR24_I2SM4_WS0B1           *((volatile unsigned char*)(0x42DECC1CUL))
#define bFM_GPIO_EPFR24_I2SM4_SDI0S0          *((volatile unsigned char*)(0x42DECC20UL))
#define bFM_GPIO_EPFR24_I2SM4_SDI0S1          *((volatile unsigned char*)(0x42DECC24UL))
#define bFM_GPIO_EPFR24_I2SM4_SDO0E0          *((volatile unsigned char*)(0x42DECC28UL))
#define bFM_GPIO_EPFR24_I2SM4_SDO0E1          *((volatile unsigned char*)(0x42DECC2CUL))
#define bFM_GPIO_EPFR25_MCRX2S0               *((volatile unsigned char*)(0x42DECC80UL))
#define bFM_GPIO_EPFR25_MCRX2S1               *((volatile unsigned char*)(0x42DECC84UL))
#define bFM_GPIO_EPFR25_MCTX2E0               *((volatile unsigned char*)(0x42DECC88UL))
#define bFM_GPIO_EPFR25_MCTX2E1               *((volatile unsigned char*)(0x42DECC8CUL))
#define bFM_GPIO_EPFR26_Q_SCKE0               *((volatile unsigned char*)(0x42DECD00UL))
#define bFM_GPIO_EPFR26_Q_SCKE1               *((volatile unsigned char*)(0x42DECD04UL))
#define bFM_GPIO_EPFR26_Q_CS0E0               *((volatile unsigned char*)(0x42DECD08UL))
#define bFM_GPIO_EPFR26_Q_CS0E1               *((volatile unsigned char*)(0x42DECD0CUL))
#define bFM_GPIO_EPFR26_Q_CS1E0               *((volatile unsigned char*)(0x42DECD10UL))
#define bFM_GPIO_EPFR26_Q_CS1E1               *((volatile unsigned char*)(0x42DECD14UL))
#define bFM_GPIO_EPFR26_Q_CS2E0               *((volatile unsigned char*)(0x42DECD18UL))
#define bFM_GPIO_EPFR26_Q_CS2E1               *((volatile unsigned char*)(0x42DECD1CUL))
#define bFM_GPIO_EPFR26_Q_CS3E0               *((volatile unsigned char*)(0x42DECD20UL))
#define bFM_GPIO_EPFR26_Q_CS3E1               *((volatile unsigned char*)(0x42DECD24UL))
#define bFM_GPIO_EPFR26_Q_IO0B0               *((volatile unsigned char*)(0x42DECD28UL))
#define bFM_GPIO_EPFR26_Q_IO0B1               *((volatile unsigned char*)(0x42DECD2CUL))
#define bFM_GPIO_EPFR26_Q_IO1B0               *((volatile unsigned char*)(0x42DECD30UL))
#define bFM_GPIO_EPFR26_Q_IO1B1               *((volatile unsigned char*)(0x42DECD34UL))
#define bFM_GPIO_EPFR26_Q_IO2B0               *((volatile unsigned char*)(0x42DECD38UL))
#define bFM_GPIO_EPFR26_Q_IO2B1               *((volatile unsigned char*)(0x42DECD3CUL))
#define bFM_GPIO_EPFR26_Q_IO3B0               *((volatile unsigned char*)(0x42DECD40UL))
#define bFM_GPIO_EPFR26_Q_IO3B1               *((volatile unsigned char*)(0x42DECD44UL))
#define bFM_GPIO_PZR0_P0                      *((volatile unsigned char*)(0x42DEE000UL))
#define bFM_GPIO_PZR0_P1                      *((volatile unsigned char*)(0x42DEE004UL))
#define bFM_GPIO_PZR0_P2                      *((volatile unsigned char*)(0x42DEE008UL))
#define bFM_GPIO_PZR0_P3                      *((volatile unsigned char*)(0x42DEE00CUL))
#define bFM_GPIO_PZR0_P4                      *((volatile unsigned char*)(0x42DEE010UL))
#define bFM_GPIO_PZR0_P5                      *((volatile unsigned char*)(0x42DEE014UL))
#define bFM_GPIO_PZR0_P6                      *((volatile unsigned char*)(0x42DEE018UL))
#define bFM_GPIO_PZR0_P7                      *((volatile unsigned char*)(0x42DEE01CUL))
#define bFM_GPIO_PZR0_P8                      *((volatile unsigned char*)(0x42DEE020UL))
#define bFM_GPIO_PZR0_P9                      *((volatile unsigned char*)(0x42DEE024UL))
#define bFM_GPIO_PZR0_PA                      *((volatile unsigned char*)(0x42DEE028UL))
#define bFM_GPIO_PZR0_PB                      *((volatile unsigned char*)(0x42DEE02CUL))
#define bFM_GPIO_PZR0_PC                      *((volatile unsigned char*)(0x42DEE030UL))
#define bFM_GPIO_PZR0_PD                      *((volatile unsigned char*)(0x42DEE034UL))
#define bFM_GPIO_PZR0_PE                      *((volatile unsigned char*)(0x42DEE038UL))
#define bFM_GPIO_PZR1_P0                      *((volatile unsigned char*)(0x42DEE080UL))
#define bFM_GPIO_PZR1_P1                      *((volatile unsigned char*)(0x42DEE084UL))
#define bFM_GPIO_PZR1_P2                      *((volatile unsigned char*)(0x42DEE088UL))
#define bFM_GPIO_PZR1_P3                      *((volatile unsigned char*)(0x42DEE08CUL))
#define bFM_GPIO_PZR1_P4                      *((volatile unsigned char*)(0x42DEE090UL))
#define bFM_GPIO_PZR1_P5                      *((volatile unsigned char*)(0x42DEE094UL))
#define bFM_GPIO_PZR1_P6                      *((volatile unsigned char*)(0x42DEE098UL))
#define bFM_GPIO_PZR1_P7                      *((volatile unsigned char*)(0x42DEE09CUL))
#define bFM_GPIO_PZR1_P8                      *((volatile unsigned char*)(0x42DEE0A0UL))
#define bFM_GPIO_PZR1_P9                      *((volatile unsigned char*)(0x42DEE0A4UL))
#define bFM_GPIO_PZR1_PA                      *((volatile unsigned char*)(0x42DEE0A8UL))
#define bFM_GPIO_PZR1_PB                      *((volatile unsigned char*)(0x42DEE0ACUL))
#define bFM_GPIO_PZR1_PC                      *((volatile unsigned char*)(0x42DEE0B0UL))
#define bFM_GPIO_PZR1_PD                      *((volatile unsigned char*)(0x42DEE0B4UL))
#define bFM_GPIO_PZR1_PE                      *((volatile unsigned char*)(0x42DEE0B8UL))
#define bFM_GPIO_PZR1_PF                      *((volatile unsigned char*)(0x42DEE0BCUL))
#define bFM_GPIO_PZR2_P0                      *((volatile unsigned char*)(0x42DEE100UL))
#define bFM_GPIO_PZR2_P1                      *((volatile unsigned char*)(0x42DEE104UL))
#define bFM_GPIO_PZR2_P2                      *((volatile unsigned char*)(0x42DEE108UL))
#define bFM_GPIO_PZR2_P3                      *((volatile unsigned char*)(0x42DEE10CUL))
#define bFM_GPIO_PZR2_P4                      *((volatile unsigned char*)(0x42DEE110UL))
#define bFM_GPIO_PZR2_P5                      *((volatile unsigned char*)(0x42DEE114UL))
#define bFM_GPIO_PZR2_P6                      *((volatile unsigned char*)(0x42DEE118UL))
#define bFM_GPIO_PZR2_P7                      *((volatile unsigned char*)(0x42DEE11CUL))
#define bFM_GPIO_PZR2_P8                      *((volatile unsigned char*)(0x42DEE120UL))
#define bFM_GPIO_PZR2_P9                      *((volatile unsigned char*)(0x42DEE124UL))
#define bFM_GPIO_PZR2_PA                      *((volatile unsigned char*)(0x42DEE128UL))
#define bFM_GPIO_PZR3_P0                      *((volatile unsigned char*)(0x42DEE180UL))
#define bFM_GPIO_PZR3_P1                      *((volatile unsigned char*)(0x42DEE184UL))
#define bFM_GPIO_PZR3_P2                      *((volatile unsigned char*)(0x42DEE188UL))
#define bFM_GPIO_PZR3_P3                      *((volatile unsigned char*)(0x42DEE18CUL))
#define bFM_GPIO_PZR3_P4                      *((volatile unsigned char*)(0x42DEE190UL))
#define bFM_GPIO_PZR3_P5                      *((volatile unsigned char*)(0x42DEE194UL))
#define bFM_GPIO_PZR3_P6                      *((volatile unsigned char*)(0x42DEE198UL))
#define bFM_GPIO_PZR3_P7                      *((volatile unsigned char*)(0x42DEE19CUL))
#define bFM_GPIO_PZR3_P8                      *((volatile unsigned char*)(0x42DEE1A0UL))
#define bFM_GPIO_PZR3_P9                      *((volatile unsigned char*)(0x42DEE1A4UL))
#define bFM_GPIO_PZR3_PA                      *((volatile unsigned char*)(0x42DEE1A8UL))
#define bFM_GPIO_PZR3_PB                      *((volatile unsigned char*)(0x42DEE1ACUL))
#define bFM_GPIO_PZR3_PC                      *((volatile unsigned char*)(0x42DEE1B0UL))
#define bFM_GPIO_PZR3_PD                      *((volatile unsigned char*)(0x42DEE1B4UL))
#define bFM_GPIO_PZR3_PE                      *((volatile unsigned char*)(0x42DEE1B8UL))
#define bFM_GPIO_PZR4_P0                      *((volatile unsigned char*)(0x42DEE200UL))
#define bFM_GPIO_PZR4_P1                      *((volatile unsigned char*)(0x42DEE204UL))
#define bFM_GPIO_PZR4_P2                      *((volatile unsigned char*)(0x42DEE208UL))
#define bFM_GPIO_PZR4_P3                      *((volatile unsigned char*)(0x42DEE20CUL))
#define bFM_GPIO_PZR4_P4                      *((volatile unsigned char*)(0x42DEE210UL))
#define bFM_GPIO_PZR4_P5                      *((volatile unsigned char*)(0x42DEE214UL))
#define bFM_GPIO_PZR4_P6                      *((volatile unsigned char*)(0x42DEE218UL))
#define bFM_GPIO_PZR4_P7                      *((volatile unsigned char*)(0x42DEE21CUL))
#define bFM_GPIO_PZR4_P8                      *((volatile unsigned char*)(0x42DEE220UL))
#define bFM_GPIO_PZR4_P9                      *((volatile unsigned char*)(0x42DEE224UL))
#define bFM_GPIO_PZR4_PA                      *((volatile unsigned char*)(0x42DEE228UL))
#define bFM_GPIO_PZR4_PB                      *((volatile unsigned char*)(0x42DEE22CUL))
#define bFM_GPIO_PZR4_PC                      *((volatile unsigned char*)(0x42DEE230UL))
#define bFM_GPIO_PZR4_PD                      *((volatile unsigned char*)(0x42DEE234UL))
#define bFM_GPIO_PZR4_PE                      *((volatile unsigned char*)(0x42DEE238UL))
#define bFM_GPIO_PZR5_P0                      *((volatile unsigned char*)(0x42DEE280UL))
#define bFM_GPIO_PZR5_P1                      *((volatile unsigned char*)(0x42DEE284UL))
#define bFM_GPIO_PZR5_P2                      *((volatile unsigned char*)(0x42DEE288UL))
#define bFM_GPIO_PZR5_P3                      *((volatile unsigned char*)(0x42DEE28CUL))
#define bFM_GPIO_PZR5_P4                      *((volatile unsigned char*)(0x42DEE290UL))
#define bFM_GPIO_PZR5_P5                      *((volatile unsigned char*)(0x42DEE294UL))
#define bFM_GPIO_PZR5_P6                      *((volatile unsigned char*)(0x42DEE298UL))
#define bFM_GPIO_PZR5_P7                      *((volatile unsigned char*)(0x42DEE29CUL))
#define bFM_GPIO_PZR5_P8                      *((volatile unsigned char*)(0x42DEE2A0UL))
#define bFM_GPIO_PZR5_P9                      *((volatile unsigned char*)(0x42DEE2A4UL))
#define bFM_GPIO_PZR5_PA                      *((volatile unsigned char*)(0x42DEE2A8UL))
#define bFM_GPIO_PZR5_PB                      *((volatile unsigned char*)(0x42DEE2ACUL))
#define bFM_GPIO_PZR5_PC                      *((volatile unsigned char*)(0x42DEE2B0UL))
#define bFM_GPIO_PZR5_PD                      *((volatile unsigned char*)(0x42DEE2B4UL))
#define bFM_GPIO_PZR5_PE                      *((volatile unsigned char*)(0x42DEE2B8UL))
#define bFM_GPIO_PZR5_PF                      *((volatile unsigned char*)(0x42DEE2BCUL))
#define bFM_GPIO_PZR6_P0                      *((volatile unsigned char*)(0x42DEE300UL))
#define bFM_GPIO_PZR6_P1                      *((volatile unsigned char*)(0x42DEE304UL))
#define bFM_GPIO_PZR6_P2                      *((volatile unsigned char*)(0x42DEE308UL))
#define bFM_GPIO_PZR6_P3                      *((volatile unsigned char*)(0x42DEE30CUL))
#define bFM_GPIO_PZR6_P4                      *((volatile unsigned char*)(0x42DEE310UL))
#define bFM_GPIO_PZR6_P5                      *((volatile unsigned char*)(0x42DEE314UL))
#define bFM_GPIO_PZR6_P6                      *((volatile unsigned char*)(0x42DEE318UL))
#define bFM_GPIO_PZR6_P7                      *((volatile unsigned char*)(0x42DEE31CUL))
#define bFM_GPIO_PZR6_P8                      *((volatile unsigned char*)(0x42DEE320UL))
#define bFM_GPIO_PZR6_P9                      *((volatile unsigned char*)(0x42DEE324UL))
#define bFM_GPIO_PZR6_PA                      *((volatile unsigned char*)(0x42DEE328UL))
#define bFM_GPIO_PZR6_PB                      *((volatile unsigned char*)(0x42DEE32CUL))
#define bFM_GPIO_PZR6_PC                      *((volatile unsigned char*)(0x42DEE330UL))
#define bFM_GPIO_PZR6_PD                      *((volatile unsigned char*)(0x42DEE334UL))
#define bFM_GPIO_PZR6_PE                      *((volatile unsigned char*)(0x42DEE338UL))
#define bFM_GPIO_PZR7_P0                      *((volatile unsigned char*)(0x42DEE380UL))
#define bFM_GPIO_PZR7_P1                      *((volatile unsigned char*)(0x42DEE384UL))
#define bFM_GPIO_PZR7_P2                      *((volatile unsigned char*)(0x42DEE388UL))
#define bFM_GPIO_PZR7_P3                      *((volatile unsigned char*)(0x42DEE38CUL))
#define bFM_GPIO_PZR7_P4                      *((volatile unsigned char*)(0x42DEE390UL))
#define bFM_GPIO_PZR7_P5                      *((volatile unsigned char*)(0x42DEE394UL))
#define bFM_GPIO_PZR7_P6                      *((volatile unsigned char*)(0x42DEE398UL))
#define bFM_GPIO_PZR7_P7                      *((volatile unsigned char*)(0x42DEE39CUL))
#define bFM_GPIO_PZR7_P8                      *((volatile unsigned char*)(0x42DEE3A0UL))
#define bFM_GPIO_PZR7_P9                      *((volatile unsigned char*)(0x42DEE3A4UL))
#define bFM_GPIO_PZR7_PA                      *((volatile unsigned char*)(0x42DEE3A8UL))
#define bFM_GPIO_PZR7_PB                      *((volatile unsigned char*)(0x42DEE3ACUL))
#define bFM_GPIO_PZR7_PC                      *((volatile unsigned char*)(0x42DEE3B0UL))
#define bFM_GPIO_PZR7_PD                      *((volatile unsigned char*)(0x42DEE3B4UL))
#define bFM_GPIO_PZR7_PE                      *((volatile unsigned char*)(0x42DEE3B8UL))
#define bFM_GPIO_PZR8_P0                      *((volatile unsigned char*)(0x42DEE400UL))
#define bFM_GPIO_PZR8_P1                      *((volatile unsigned char*)(0x42DEE404UL))
#define bFM_GPIO_PZR8_P2                      *((volatile unsigned char*)(0x42DEE408UL))
#define bFM_GPIO_PZR8_P3                      *((volatile unsigned char*)(0x42DEE40CUL))
#define bFM_GPIO_PZR9_P0                      *((volatile unsigned char*)(0x42DEE480UL))
#define bFM_GPIO_PZR9_P1                      *((volatile unsigned char*)(0x42DEE484UL))
#define bFM_GPIO_PZR9_P2                      *((volatile unsigned char*)(0x42DEE488UL))
#define bFM_GPIO_PZR9_P3                      *((volatile unsigned char*)(0x42DEE48CUL))
#define bFM_GPIO_PZR9_P4                      *((volatile unsigned char*)(0x42DEE490UL))
#define bFM_GPIO_PZR9_P5                      *((volatile unsigned char*)(0x42DEE494UL))
#define bFM_GPIO_PZR9_P6                      *((volatile unsigned char*)(0x42DEE498UL))
#define bFM_GPIO_PZR9_P7                      *((volatile unsigned char*)(0x42DEE49CUL))
#define bFM_GPIO_PZRA_P0                      *((volatile unsigned char*)(0x42DEE500UL))
#define bFM_GPIO_PZRA_P1                      *((volatile unsigned char*)(0x42DEE504UL))
#define bFM_GPIO_PZRA_P2                      *((volatile unsigned char*)(0x42DEE508UL))
#define bFM_GPIO_PZRA_P3                      *((volatile unsigned char*)(0x42DEE50CUL))
#define bFM_GPIO_PZRA_P4                      *((volatile unsigned char*)(0x42DEE510UL))
#define bFM_GPIO_PZRA_P5                      *((volatile unsigned char*)(0x42DEE514UL))
#define bFM_GPIO_PZRA_P6                      *((volatile unsigned char*)(0x42DEE518UL))
#define bFM_GPIO_PZRA_P7                      *((volatile unsigned char*)(0x42DEE51CUL))
#define bFM_GPIO_PZRA_P8                      *((volatile unsigned char*)(0x42DEE520UL))
#define bFM_GPIO_PZRA_P9                      *((volatile unsigned char*)(0x42DEE524UL))
#define bFM_GPIO_PZRA_PA                      *((volatile unsigned char*)(0x42DEE528UL))
#define bFM_GPIO_PZRA_PB                      *((volatile unsigned char*)(0x42DEE52CUL))
#define bFM_GPIO_PZRA_PC                      *((volatile unsigned char*)(0x42DEE530UL))
#define bFM_GPIO_PZRA_PD                      *((volatile unsigned char*)(0x42DEE534UL))
#define bFM_GPIO_PZRA_PE                      *((volatile unsigned char*)(0x42DEE538UL))
#define bFM_GPIO_PZRA_PF                      *((volatile unsigned char*)(0x42DEE53CUL))
#define bFM_GPIO_PZRB_P0                      *((volatile unsigned char*)(0x42DEE580UL))
#define bFM_GPIO_PZRB_P1                      *((volatile unsigned char*)(0x42DEE584UL))
#define bFM_GPIO_PZRB_P2                      *((volatile unsigned char*)(0x42DEE588UL))
#define bFM_GPIO_PZRB_P3                      *((volatile unsigned char*)(0x42DEE58CUL))
#define bFM_GPIO_PZRB_P4                      *((volatile unsigned char*)(0x42DEE590UL))
#define bFM_GPIO_PZRB_P5                      *((volatile unsigned char*)(0x42DEE594UL))
#define bFM_GPIO_PZRB_P6                      *((volatile unsigned char*)(0x42DEE598UL))
#define bFM_GPIO_PZRB_P7                      *((volatile unsigned char*)(0x42DEE59CUL))
#define bFM_GPIO_PZRB_P8                      *((volatile unsigned char*)(0x42DEE5A0UL))
#define bFM_GPIO_PZRB_P9                      *((volatile unsigned char*)(0x42DEE5A4UL))
#define bFM_GPIO_PZRB_PA                      *((volatile unsigned char*)(0x42DEE5A8UL))
#define bFM_GPIO_PZRB_PB                      *((volatile unsigned char*)(0x42DEE5ACUL))
#define bFM_GPIO_PZRB_PC                      *((volatile unsigned char*)(0x42DEE5B0UL))
#define bFM_GPIO_PZRB_PD                      *((volatile unsigned char*)(0x42DEE5B4UL))
#define bFM_GPIO_PZRB_PE                      *((volatile unsigned char*)(0x42DEE5B8UL))
#define bFM_GPIO_PZRB_PF                      *((volatile unsigned char*)(0x42DEE5BCUL))
#define bFM_GPIO_PZRC_P0                      *((volatile unsigned char*)(0x42DEE600UL))
#define bFM_GPIO_PZRC_P1                      *((volatile unsigned char*)(0x42DEE604UL))
#define bFM_GPIO_PZRC_P2                      *((volatile unsigned char*)(0x42DEE608UL))
#define bFM_GPIO_PZRC_P3                      *((volatile unsigned char*)(0x42DEE60CUL))
#define bFM_GPIO_PZRC_P4                      *((volatile unsigned char*)(0x42DEE610UL))
#define bFM_GPIO_PZRC_P5                      *((volatile unsigned char*)(0x42DEE614UL))
#define bFM_GPIO_PZRC_P6                      *((volatile unsigned char*)(0x42DEE618UL))
#define bFM_GPIO_PZRC_P7                      *((volatile unsigned char*)(0x42DEE61CUL))
#define bFM_GPIO_PZRC_P8                      *((volatile unsigned char*)(0x42DEE620UL))
#define bFM_GPIO_PZRC_P9                      *((volatile unsigned char*)(0x42DEE624UL))
#define bFM_GPIO_PZRC_PA                      *((volatile unsigned char*)(0x42DEE628UL))
#define bFM_GPIO_PZRC_PB                      *((volatile unsigned char*)(0x42DEE62CUL))
#define bFM_GPIO_PZRC_PC                      *((volatile unsigned char*)(0x42DEE630UL))
#define bFM_GPIO_PZRC_PD                      *((volatile unsigned char*)(0x42DEE634UL))
#define bFM_GPIO_PZRC_PE                      *((volatile unsigned char*)(0x42DEE638UL))
#define bFM_GPIO_PZRC_PF                      *((volatile unsigned char*)(0x42DEE63CUL))
#define bFM_GPIO_PZRD_P0                      *((volatile unsigned char*)(0x42DEE680UL))
#define bFM_GPIO_PZRD_P1                      *((volatile unsigned char*)(0x42DEE684UL))
#define bFM_GPIO_PZRD_P2                      *((volatile unsigned char*)(0x42DEE688UL))
#define bFM_GPIO_PZRE_P0                      *((volatile unsigned char*)(0x42DEE700UL))
#define bFM_GPIO_PZRE_P2                      *((volatile unsigned char*)(0x42DEE708UL))
#define bFM_GPIO_PZRE_P3                      *((volatile unsigned char*)(0x42DEE70CUL))
#define bFM_GPIO_PZRF_P0                      *((volatile unsigned char*)(0x42DEE780UL))
#define bFM_GPIO_PZRF_P1                      *((volatile unsigned char*)(0x42DEE784UL))
#define bFM_GPIO_PZRF_P2                      *((volatile unsigned char*)(0x42DEE788UL))
#define bFM_GPIO_PZRF_P3                      *((volatile unsigned char*)(0x42DEE78CUL))
#define bFM_GPIO_PZRF_P4                      *((volatile unsigned char*)(0x42DEE790UL))
#define bFM_GPIO_PZRF_P5                      *((volatile unsigned char*)(0x42DEE794UL))
#define bFM_GPIO_PZRF_P6                      *((volatile unsigned char*)(0x42DEE798UL))
#define bFM_GPIO_PZRF_P7                      *((volatile unsigned char*)(0x42DEE79CUL))
#define bFM_GPIO_PZRF_P8                      *((volatile unsigned char*)(0x42DEE7A0UL))
#define bFM_GPIO_PZRF_P9                      *((volatile unsigned char*)(0x42DEE7A4UL))
#define bFM_GPIO_PZRF_PA                      *((volatile unsigned char*)(0x42DEE7A8UL))
#define bFM_GPIO_PZRF_PB                      *((volatile unsigned char*)(0x42DEE7ACUL))
#define bFM_GPIO_PZRF_PC                      *((volatile unsigned char*)(0x42DEE7B0UL))
#define bFM_GPIO_PDSR0_P0                     *((volatile unsigned char*)(0x42DEE800UL))
#define bFM_GPIO_PDSR0_P1                     *((volatile unsigned char*)(0x42DEE804UL))
#define bFM_GPIO_PDSR0_P2                     *((volatile unsigned char*)(0x42DEE808UL))
#define bFM_GPIO_PDSR0_P3                     *((volatile unsigned char*)(0x42DEE80CUL))
#define bFM_GPIO_PDSR0_P4                     *((volatile unsigned char*)(0x42DEE810UL))
#define bFM_GPIO_PDSR0_P5                     *((volatile unsigned char*)(0x42DEE814UL))
#define bFM_GPIO_PDSR0_P6                     *((volatile unsigned char*)(0x42DEE818UL))
#define bFM_GPIO_PDSR0_P7                     *((volatile unsigned char*)(0x42DEE81CUL))
#define bFM_GPIO_PDSR0_P8                     *((volatile unsigned char*)(0x42DEE820UL))
#define bFM_GPIO_PDSR0_P9                     *((volatile unsigned char*)(0x42DEE824UL))
#define bFM_GPIO_PDSR0_PA                     *((volatile unsigned char*)(0x42DEE828UL))
#define bFM_GPIO_PDSR0_PB                     *((volatile unsigned char*)(0x42DEE82CUL))
#define bFM_GPIO_PDSR0_PC                     *((volatile unsigned char*)(0x42DEE830UL))
#define bFM_GPIO_PDSR0_PD                     *((volatile unsigned char*)(0x42DEE834UL))
#define bFM_GPIO_PDSR0_PE                     *((volatile unsigned char*)(0x42DEE838UL))
#define bFM_GPIO_PDSR1_P0                     *((volatile unsigned char*)(0x42DEE880UL))
#define bFM_GPIO_PDSR1_P1                     *((volatile unsigned char*)(0x42DEE884UL))
#define bFM_GPIO_PDSR1_P2                     *((volatile unsigned char*)(0x42DEE888UL))
#define bFM_GPIO_PDSR1_P3                     *((volatile unsigned char*)(0x42DEE88CUL))
#define bFM_GPIO_PDSR1_P4                     *((volatile unsigned char*)(0x42DEE890UL))
#define bFM_GPIO_PDSR1_P5                     *((volatile unsigned char*)(0x42DEE894UL))
#define bFM_GPIO_PDSR1_P6                     *((volatile unsigned char*)(0x42DEE898UL))
#define bFM_GPIO_PDSR1_P7                     *((volatile unsigned char*)(0x42DEE89CUL))
#define bFM_GPIO_PDSR1_P8                     *((volatile unsigned char*)(0x42DEE8A0UL))
#define bFM_GPIO_PDSR1_P9                     *((volatile unsigned char*)(0x42DEE8A4UL))
#define bFM_GPIO_PDSR1_PA                     *((volatile unsigned char*)(0x42DEE8A8UL))
#define bFM_GPIO_PDSR1_PB                     *((volatile unsigned char*)(0x42DEE8ACUL))
#define bFM_GPIO_PDSR1_PC                     *((volatile unsigned char*)(0x42DEE8B0UL))
#define bFM_GPIO_PDSR1_PD                     *((volatile unsigned char*)(0x42DEE8B4UL))
#define bFM_GPIO_PDSR1_PE                     *((volatile unsigned char*)(0x42DEE8B8UL))
#define bFM_GPIO_PDSR1_PF                     *((volatile unsigned char*)(0x42DEE8BCUL))
#define bFM_GPIO_PDSR2_P0                     *((volatile unsigned char*)(0x42DEE900UL))
#define bFM_GPIO_PDSR2_P1                     *((volatile unsigned char*)(0x42DEE904UL))
#define bFM_GPIO_PDSR2_P2                     *((volatile unsigned char*)(0x42DEE908UL))
#define bFM_GPIO_PDSR2_P3                     *((volatile unsigned char*)(0x42DEE90CUL))
#define bFM_GPIO_PDSR2_P4                     *((volatile unsigned char*)(0x42DEE910UL))
#define bFM_GPIO_PDSR2_P5                     *((volatile unsigned char*)(0x42DEE914UL))
#define bFM_GPIO_PDSR2_P6                     *((volatile unsigned char*)(0x42DEE918UL))
#define bFM_GPIO_PDSR2_P7                     *((volatile unsigned char*)(0x42DEE91CUL))
#define bFM_GPIO_PDSR2_P8                     *((volatile unsigned char*)(0x42DEE920UL))
#define bFM_GPIO_PDSR2_P9                     *((volatile unsigned char*)(0x42DEE924UL))
#define bFM_GPIO_PDSR2_PA                     *((volatile unsigned char*)(0x42DEE928UL))
#define bFM_GPIO_PDSR3_P0                     *((volatile unsigned char*)(0x42DEE980UL))
#define bFM_GPIO_PDSR3_P1                     *((volatile unsigned char*)(0x42DEE984UL))
#define bFM_GPIO_PDSR3_P2                     *((volatile unsigned char*)(0x42DEE988UL))
#define bFM_GPIO_PDSR3_P3                     *((volatile unsigned char*)(0x42DEE98CUL))
#define bFM_GPIO_PDSR3_P4                     *((volatile unsigned char*)(0x42DEE990UL))
#define bFM_GPIO_PDSR3_P5                     *((volatile unsigned char*)(0x42DEE994UL))
#define bFM_GPIO_PDSR3_P6                     *((volatile unsigned char*)(0x42DEE998UL))
#define bFM_GPIO_PDSR3_P7                     *((volatile unsigned char*)(0x42DEE99CUL))
#define bFM_GPIO_PDSR3_P8                     *((volatile unsigned char*)(0x42DEE9A0UL))
#define bFM_GPIO_PDSR3_P9                     *((volatile unsigned char*)(0x42DEE9A4UL))
#define bFM_GPIO_PDSR3_PA                     *((volatile unsigned char*)(0x42DEE9A8UL))
#define bFM_GPIO_PDSR3_PB                     *((volatile unsigned char*)(0x42DEE9ACUL))
#define bFM_GPIO_PDSR3_PC                     *((volatile unsigned char*)(0x42DEE9B0UL))
#define bFM_GPIO_PDSR3_PD                     *((volatile unsigned char*)(0x42DEE9B4UL))
#define bFM_GPIO_PDSR3_PE                     *((volatile unsigned char*)(0x42DEE9B8UL))
#define bFM_GPIO_PDSR4_P0                     *((volatile unsigned char*)(0x42DEEA00UL))
#define bFM_GPIO_PDSR4_P1                     *((volatile unsigned char*)(0x42DEEA04UL))
#define bFM_GPIO_PDSR4_P2                     *((volatile unsigned char*)(0x42DEEA08UL))
#define bFM_GPIO_PDSR4_P3                     *((volatile unsigned char*)(0x42DEEA0CUL))
#define bFM_GPIO_PDSR4_P4                     *((volatile unsigned char*)(0x42DEEA10UL))
#define bFM_GPIO_PDSR4_P5                     *((volatile unsigned char*)(0x42DEEA14UL))
#define bFM_GPIO_PDSR4_P6                     *((volatile unsigned char*)(0x42DEEA18UL))
#define bFM_GPIO_PDSR4_P7                     *((volatile unsigned char*)(0x42DEEA1CUL))
#define bFM_GPIO_PDSR4_P8                     *((volatile unsigned char*)(0x42DEEA20UL))
#define bFM_GPIO_PDSR4_P9                     *((volatile unsigned char*)(0x42DEEA24UL))
#define bFM_GPIO_PDSR4_PA                     *((volatile unsigned char*)(0x42DEEA28UL))
#define bFM_GPIO_PDSR4_PB                     *((volatile unsigned char*)(0x42DEEA2CUL))
#define bFM_GPIO_PDSR4_PC                     *((volatile unsigned char*)(0x42DEEA30UL))
#define bFM_GPIO_PDSR4_PD                     *((volatile unsigned char*)(0x42DEEA34UL))
#define bFM_GPIO_PDSR4_PE                     *((volatile unsigned char*)(0x42DEEA38UL))
#define bFM_GPIO_PDSR5_P0                     *((volatile unsigned char*)(0x42DEEA80UL))
#define bFM_GPIO_PDSR5_P1                     *((volatile unsigned char*)(0x42DEEA84UL))
#define bFM_GPIO_PDSR5_P2                     *((volatile unsigned char*)(0x42DEEA88UL))
#define bFM_GPIO_PDSR5_P3                     *((volatile unsigned char*)(0x42DEEA8CUL))
#define bFM_GPIO_PDSR5_P4                     *((volatile unsigned char*)(0x42DEEA90UL))
#define bFM_GPIO_PDSR5_P5                     *((volatile unsigned char*)(0x42DEEA94UL))
#define bFM_GPIO_PDSR5_P6                     *((volatile unsigned char*)(0x42DEEA98UL))
#define bFM_GPIO_PDSR5_P7                     *((volatile unsigned char*)(0x42DEEA9CUL))
#define bFM_GPIO_PDSR5_P8                     *((volatile unsigned char*)(0x42DEEAA0UL))
#define bFM_GPIO_PDSR5_P9                     *((volatile unsigned char*)(0x42DEEAA4UL))
#define bFM_GPIO_PDSR5_PA                     *((volatile unsigned char*)(0x42DEEAA8UL))
#define bFM_GPIO_PDSR5_PB                     *((volatile unsigned char*)(0x42DEEAACUL))
#define bFM_GPIO_PDSR5_PC                     *((volatile unsigned char*)(0x42DEEAB0UL))
#define bFM_GPIO_PDSR5_PD                     *((volatile unsigned char*)(0x42DEEAB4UL))
#define bFM_GPIO_PDSR5_PE                     *((volatile unsigned char*)(0x42DEEAB8UL))
#define bFM_GPIO_PDSR5_PF                     *((volatile unsigned char*)(0x42DEEABCUL))
#define bFM_GPIO_PDSR6_P0                     *((volatile unsigned char*)(0x42DEEB00UL))
#define bFM_GPIO_PDSR6_P1                     *((volatile unsigned char*)(0x42DEEB04UL))
#define bFM_GPIO_PDSR6_P2                     *((volatile unsigned char*)(0x42DEEB08UL))
#define bFM_GPIO_PDSR6_P3                     *((volatile unsigned char*)(0x42DEEB0CUL))
#define bFM_GPIO_PDSR6_P4                     *((volatile unsigned char*)(0x42DEEB10UL))
#define bFM_GPIO_PDSR6_P5                     *((volatile unsigned char*)(0x42DEEB14UL))
#define bFM_GPIO_PDSR6_P6                     *((volatile unsigned char*)(0x42DEEB18UL))
#define bFM_GPIO_PDSR6_P7                     *((volatile unsigned char*)(0x42DEEB1CUL))
#define bFM_GPIO_PDSR6_P8                     *((volatile unsigned char*)(0x42DEEB20UL))
#define bFM_GPIO_PDSR6_P9                     *((volatile unsigned char*)(0x42DEEB24UL))
#define bFM_GPIO_PDSR6_PA                     *((volatile unsigned char*)(0x42DEEB28UL))
#define bFM_GPIO_PDSR6_PB                     *((volatile unsigned char*)(0x42DEEB2CUL))
#define bFM_GPIO_PDSR6_PC                     *((volatile unsigned char*)(0x42DEEB30UL))
#define bFM_GPIO_PDSR6_PD                     *((volatile unsigned char*)(0x42DEEB34UL))
#define bFM_GPIO_PDSR6_PE                     *((volatile unsigned char*)(0x42DEEB38UL))
#define bFM_GPIO_PDSR7_P0                     *((volatile unsigned char*)(0x42DEEB80UL))
#define bFM_GPIO_PDSR7_P1                     *((volatile unsigned char*)(0x42DEEB84UL))
#define bFM_GPIO_PDSR7_P2                     *((volatile unsigned char*)(0x42DEEB88UL))
#define bFM_GPIO_PDSR7_P3                     *((volatile unsigned char*)(0x42DEEB8CUL))
#define bFM_GPIO_PDSR7_P4                     *((volatile unsigned char*)(0x42DEEB90UL))
#define bFM_GPIO_PDSR7_P5                     *((volatile unsigned char*)(0x42DEEB94UL))
#define bFM_GPIO_PDSR7_P6                     *((volatile unsigned char*)(0x42DEEB98UL))
#define bFM_GPIO_PDSR7_P7                     *((volatile unsigned char*)(0x42DEEB9CUL))
#define bFM_GPIO_PDSR7_P8                     *((volatile unsigned char*)(0x42DEEBA0UL))
#define bFM_GPIO_PDSR7_P9                     *((volatile unsigned char*)(0x42DEEBA4UL))
#define bFM_GPIO_PDSR7_PA                     *((volatile unsigned char*)(0x42DEEBA8UL))
#define bFM_GPIO_PDSR7_PB                     *((volatile unsigned char*)(0x42DEEBACUL))
#define bFM_GPIO_PDSR7_PC                     *((volatile unsigned char*)(0x42DEEBB0UL))
#define bFM_GPIO_PDSR7_PD                     *((volatile unsigned char*)(0x42DEEBB4UL))
#define bFM_GPIO_PDSR7_PE                     *((volatile unsigned char*)(0x42DEEBB8UL))
#define bFM_GPIO_PDSR8_P0                     *((volatile unsigned char*)(0x42DEEC00UL))
#define bFM_GPIO_PDSR8_P1                     *((volatile unsigned char*)(0x42DEEC04UL))
#define bFM_GPIO_PDSR8_P2                     *((volatile unsigned char*)(0x42DEEC08UL))
#define bFM_GPIO_PDSR8_P3                     *((volatile unsigned char*)(0x42DEEC0CUL))
#define bFM_GPIO_PDSR9_P0                     *((volatile unsigned char*)(0x42DEEC80UL))
#define bFM_GPIO_PDSR9_P1                     *((volatile unsigned char*)(0x42DEEC84UL))
#define bFM_GPIO_PDSR9_P2                     *((volatile unsigned char*)(0x42DEEC88UL))
#define bFM_GPIO_PDSR9_P3                     *((volatile unsigned char*)(0x42DEEC8CUL))
#define bFM_GPIO_PDSR9_P4                     *((volatile unsigned char*)(0x42DEEC90UL))
#define bFM_GPIO_PDSR9_P5                     *((volatile unsigned char*)(0x42DEEC94UL))
#define bFM_GPIO_PDSR9_P6                     *((volatile unsigned char*)(0x42DEEC98UL))
#define bFM_GPIO_PDSR9_P7                     *((volatile unsigned char*)(0x42DEEC9CUL))
#define bFM_GPIO_PDSRA_P0                     *((volatile unsigned char*)(0x42DEED00UL))
#define bFM_GPIO_PDSRA_P1                     *((volatile unsigned char*)(0x42DEED04UL))
#define bFM_GPIO_PDSRA_P2                     *((volatile unsigned char*)(0x42DEED08UL))
#define bFM_GPIO_PDSRA_P3                     *((volatile unsigned char*)(0x42DEED0CUL))
#define bFM_GPIO_PDSRA_P4                     *((volatile unsigned char*)(0x42DEED10UL))
#define bFM_GPIO_PDSRA_P5                     *((volatile unsigned char*)(0x42DEED14UL))
#define bFM_GPIO_PDSRA_P6                     *((volatile unsigned char*)(0x42DEED18UL))
#define bFM_GPIO_PDSRA_P7                     *((volatile unsigned char*)(0x42DEED1CUL))
#define bFM_GPIO_PDSRA_P8                     *((volatile unsigned char*)(0x42DEED20UL))
#define bFM_GPIO_PDSRA_P9                     *((volatile unsigned char*)(0x42DEED24UL))
#define bFM_GPIO_PDSRA_PA                     *((volatile unsigned char*)(0x42DEED28UL))
#define bFM_GPIO_PDSRA_PB                     *((volatile unsigned char*)(0x42DEED2CUL))
#define bFM_GPIO_PDSRA_PC                     *((volatile unsigned char*)(0x42DEED30UL))
#define bFM_GPIO_PDSRA_PD                     *((volatile unsigned char*)(0x42DEED34UL))
#define bFM_GPIO_PDSRA_PE                     *((volatile unsigned char*)(0x42DEED38UL))
#define bFM_GPIO_PDSRA_PF                     *((volatile unsigned char*)(0x42DEED3CUL))
#define bFM_GPIO_PDSRB_P0                     *((volatile unsigned char*)(0x42DEED80UL))
#define bFM_GPIO_PDSRB_P1                     *((volatile unsigned char*)(0x42DEED84UL))
#define bFM_GPIO_PDSRB_P2                     *((volatile unsigned char*)(0x42DEED88UL))
#define bFM_GPIO_PDSRB_P3                     *((volatile unsigned char*)(0x42DEED8CUL))
#define bFM_GPIO_PDSRB_P4                     *((volatile unsigned char*)(0x42DEED90UL))
#define bFM_GPIO_PDSRB_P5                     *((volatile unsigned char*)(0x42DEED94UL))
#define bFM_GPIO_PDSRB_P6                     *((volatile unsigned char*)(0x42DEED98UL))
#define bFM_GPIO_PDSRB_P7                     *((volatile unsigned char*)(0x42DEED9CUL))
#define bFM_GPIO_PDSRB_P8                     *((volatile unsigned char*)(0x42DEEDA0UL))
#define bFM_GPIO_PDSRB_P9                     *((volatile unsigned char*)(0x42DEEDA4UL))
#define bFM_GPIO_PDSRB_PA                     *((volatile unsigned char*)(0x42DEEDA8UL))
#define bFM_GPIO_PDSRB_PB                     *((volatile unsigned char*)(0x42DEEDACUL))
#define bFM_GPIO_PDSRB_PC                     *((volatile unsigned char*)(0x42DEEDB0UL))
#define bFM_GPIO_PDSRB_PD                     *((volatile unsigned char*)(0x42DEEDB4UL))
#define bFM_GPIO_PDSRB_PE                     *((volatile unsigned char*)(0x42DEEDB8UL))
#define bFM_GPIO_PDSRB_PF                     *((volatile unsigned char*)(0x42DEEDBCUL))
#define bFM_GPIO_PDSRC_P0                     *((volatile unsigned char*)(0x42DEEE00UL))
#define bFM_GPIO_PDSRC_P1                     *((volatile unsigned char*)(0x42DEEE04UL))
#define bFM_GPIO_PDSRC_P2                     *((volatile unsigned char*)(0x42DEEE08UL))
#define bFM_GPIO_PDSRC_P3                     *((volatile unsigned char*)(0x42DEEE0CUL))
#define bFM_GPIO_PDSRC_P4                     *((volatile unsigned char*)(0x42DEEE10UL))
#define bFM_GPIO_PDSRC_P5                     *((volatile unsigned char*)(0x42DEEE14UL))
#define bFM_GPIO_PDSRC_P6                     *((volatile unsigned char*)(0x42DEEE18UL))
#define bFM_GPIO_PDSRC_P7                     *((volatile unsigned char*)(0x42DEEE1CUL))
#define bFM_GPIO_PDSRC_P8                     *((volatile unsigned char*)(0x42DEEE20UL))
#define bFM_GPIO_PDSRC_P9                     *((volatile unsigned char*)(0x42DEEE24UL))
#define bFM_GPIO_PDSRC_PA                     *((volatile unsigned char*)(0x42DEEE28UL))
#define bFM_GPIO_PDSRC_PB                     *((volatile unsigned char*)(0x42DEEE2CUL))
#define bFM_GPIO_PDSRC_PC                     *((volatile unsigned char*)(0x42DEEE30UL))
#define bFM_GPIO_PDSRC_PD                     *((volatile unsigned char*)(0x42DEEE34UL))
#define bFM_GPIO_PDSRC_PE                     *((volatile unsigned char*)(0x42DEEE38UL))
#define bFM_GPIO_PDSRC_PF                     *((volatile unsigned char*)(0x42DEEE3CUL))
#define bFM_GPIO_PDSRD_P0                     *((volatile unsigned char*)(0x42DEEE80UL))
#define bFM_GPIO_PDSRD_P1                     *((volatile unsigned char*)(0x42DEEE84UL))
#define bFM_GPIO_PDSRD_P2                     *((volatile unsigned char*)(0x42DEEE88UL))
#define bFM_GPIO_PDSRE_P0                     *((volatile unsigned char*)(0x42DEEF00UL))
#define bFM_GPIO_PDSRE_P2                     *((volatile unsigned char*)(0x42DEEF08UL))
#define bFM_GPIO_PDSRE_P3                     *((volatile unsigned char*)(0x42DEEF0CUL))
#define bFM_GPIO_PDSRF_P0                     *((volatile unsigned char*)(0x42DEEF80UL))
#define bFM_GPIO_PDSRF_P1                     *((volatile unsigned char*)(0x42DEEF84UL))
#define bFM_GPIO_PDSRF_P2                     *((volatile unsigned char*)(0x42DEEF88UL))
#define bFM_GPIO_PDSRF_P3                     *((volatile unsigned char*)(0x42DEEF8CUL))
#define bFM_GPIO_PDSRF_P4                     *((volatile unsigned char*)(0x42DEEF90UL))
#define bFM_GPIO_PDSRF_P5                     *((volatile unsigned char*)(0x42DEEF94UL))
#define bFM_GPIO_PDSRF_P6                     *((volatile unsigned char*)(0x42DEEF98UL))
#define bFM_GPIO_PDSRF_P7                     *((volatile unsigned char*)(0x42DEEF9CUL))
#define bFM_GPIO_PDSRF_P8                     *((volatile unsigned char*)(0x42DEEFA0UL))
#define bFM_GPIO_PDSRF_P9                     *((volatile unsigned char*)(0x42DEEFA4UL))
#define bFM_GPIO_PDSRF_PA                     *((volatile unsigned char*)(0x42DEEFA8UL))
#define bFM_GPIO_PDSRF_PB                     *((volatile unsigned char*)(0x42DEEFACUL))
#define bFM_GPIO_PDSRF_PC                     *((volatile unsigned char*)(0x42DEEFB0UL))

/* Low voltage detection registers */
#define bFM_LVD_LVD_CTL_SVHI0                 *((volatile unsigned char*)(0x426A0008UL))
#define bFM_LVD_LVD_CTL_SVHI1                 *((volatile unsigned char*)(0x426A000CUL))
#define bFM_LVD_LVD_CTL_SVHI2                 *((volatile unsigned char*)(0x426A0010UL))
#define bFM_LVD_LVD_CTL_SVHI3                 *((volatile unsigned char*)(0x426A0014UL))
#define bFM_LVD_LVD_CTL_SVHI4                 *((volatile unsigned char*)(0x426A0018UL))
#define bFM_LVD_LVD_CTL_LVDIE                 *((volatile unsigned char*)(0x426A001CUL))
#define bFM_LVD_LVD_STR_LVDIR                 *((volatile unsigned char*)(0x426A009CUL))
#define bFM_LVD_LVD_CLR_LVDCL                 *((volatile unsigned char*)(0x426A011CUL))
#define bFM_LVD_LVD_STR2_LVDIRDY              *((volatile unsigned char*)(0x426A021CUL))

/* DS mode registers */
#define bFM_DS_RCK_CTL_CECCKE                 *((volatile unsigned char*)(0x426A2084UL))
#define bFM_DS_PMD_CTL_RTCE                   *((volatile unsigned char*)(0x426B0000UL))
#define bFM_DS_WRFSR_WINITX                   *((volatile unsigned char*)(0x426B0080UL))
#define bFM_DS_WRFSR_WLVDH                    *((volatile unsigned char*)(0x426B0084UL))
#define bFM_DS_WIFSR_WRTCI                    *((volatile unsigned char*)(0x426B0100UL))
#define bFM_DS_WIFSR_WLVDI                    *((volatile unsigned char*)(0x426B0104UL))
#define bFM_DS_WIFSR_WUI0                     *((volatile unsigned char*)(0x426B0108UL))
#define bFM_DS_WIFSR_WUI1                     *((volatile unsigned char*)(0x426B010CUL))
#define bFM_DS_WIFSR_WUI2                     *((volatile unsigned char*)(0x426B0110UL))
#define bFM_DS_WIFSR_WUI3                     *((volatile unsigned char*)(0x426B0114UL))
#define bFM_DS_WIFSR_WUI4                     *((volatile unsigned char*)(0x426B0118UL))
#define bFM_DS_WIFSR_WUI5                     *((volatile unsigned char*)(0x426B011CUL))
#define bFM_DS_WIER_WRTCE                     *((volatile unsigned char*)(0x426B0180UL))
#define bFM_DS_WIER_WLVDE                     *((volatile unsigned char*)(0x426B0184UL))
#define bFM_DS_WIER_WUI1E                     *((volatile unsigned char*)(0x426B018CUL))
#define bFM_DS_WIER_WUI2E                     *((volatile unsigned char*)(0x426B0190UL))
#define bFM_DS_WIER_WUI3E                     *((volatile unsigned char*)(0x426B0194UL))
#define bFM_DS_WIER_WUI4E                     *((volatile unsigned char*)(0x426B0198UL))
#define bFM_DS_WIER_WUI5E                     *((volatile unsigned char*)(0x426B019CUL))
#define bFM_DS_WILVR_WUI1LV                   *((volatile unsigned char*)(0x426B0200UL))
#define bFM_DS_WILVR_WUI2LV                   *((volatile unsigned char*)(0x426B0204UL))
#define bFM_DS_WILVR_WUI3LV                   *((volatile unsigned char*)(0x426B0208UL))
#define bFM_DS_WILVR_WUI4LV                   *((volatile unsigned char*)(0x426B020CUL))
#define bFM_DS_WILVR_WUI5LV                   *((volatile unsigned char*)(0x426B0210UL))
#define bFM_DS_DSRAMR_SRAMR0                  *((volatile unsigned char*)(0x426B0280UL))
#define bFM_DS_DSRAMR_SRAMR1                  *((volatile unsigned char*)(0x426B0284UL))

/* USB clock registers */
#define bFM_USBCLK_UCCR_UCEN                  *((volatile unsigned char*)(0x426C0000UL))
#define bFM_USBCLK_UCCR_UCSEL                 *((volatile unsigned char*)(0x426C0004UL))
#define bFM_USBCLK_UPCR1_UPLLEN               *((volatile unsigned char*)(0x426C0080UL))
#define bFM_USBCLK_UPCR1_UPINC                *((volatile unsigned char*)(0x426C0084UL))
#define bFM_USBCLK_UPCR2_UPOWT0               *((volatile unsigned char*)(0x426C0100UL))
#define bFM_USBCLK_UPCR2_UPOWT1               *((volatile unsigned char*)(0x426C0104UL))
#define bFM_USBCLK_UPCR2_UPOWT2               *((volatile unsigned char*)(0x426C0108UL))
#define bFM_USBCLK_UPCR3_UPLLK0               *((volatile unsigned char*)(0x426C0180UL))
#define bFM_USBCLK_UPCR3_UPLLK1               *((volatile unsigned char*)(0x426C0184UL))
#define bFM_USBCLK_UPCR3_UPLLK2               *((volatile unsigned char*)(0x426C0188UL))
#define bFM_USBCLK_UPCR3_UPLLK3               *((volatile unsigned char*)(0x426C018CUL))
#define bFM_USBCLK_UPCR3_UPLLK4               *((volatile unsigned char*)(0x426C0190UL))
#define bFM_USBCLK_UPCR4_UPLLN0               *((volatile unsigned char*)(0x426C0200UL))
#define bFM_USBCLK_UPCR4_UPLLN1               *((volatile unsigned char*)(0x426C0204UL))
#define bFM_USBCLK_UPCR4_UPLLN2               *((volatile unsigned char*)(0x426C0208UL))
#define bFM_USBCLK_UPCR4_UPLLN3               *((volatile unsigned char*)(0x426C020CUL))
#define bFM_USBCLK_UPCR4_UPLLN4               *((volatile unsigned char*)(0x426C0210UL))
#define bFM_USBCLK_UP_STR_UPRDY               *((volatile unsigned char*)(0x426C0280UL))
#define bFM_USBCLK_UPINT_ENR_UPCSE            *((volatile unsigned char*)(0x426C0300UL))
#define bFM_USBCLK_UPINT_CLR_UPCSC            *((volatile unsigned char*)(0x426C0380UL))
#define bFM_USBCLK_UPINT_STR_UPCSI            *((volatile unsigned char*)(0x426C0400UL))
#define bFM_USBCLK_USBEN_USBEN                *((volatile unsigned char*)(0x426C0600UL))

/* CAN prescaler register */
#define bFM_CANPRES_CANPRE_CANPRE0            *((volatile unsigned char*)(0x426E0000UL))
#define bFM_CANPRES_CANPRE_CANPRE1            *((volatile unsigned char*)(0x426E0004UL))
#define bFM_CANPRES_CANPRE_CANPRE2            *((volatile unsigned char*)(0x426E0008UL))
#define bFM_CANPRES_CANPRE_CANPRE3            *((volatile unsigned char*)(0x426E000CUL))

/* MFS UART channel 0 registers */
#define bFM_MFS0_UART_SMR_SOE                 *((volatile unsigned char*)(0x42700000UL))
#define bFM_MFS0_UART_SMR_BDS                 *((volatile unsigned char*)(0x42700008UL))
#define bFM_MFS0_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270000CUL))
#define bFM_MFS0_UART_SMR_WUCR                *((volatile unsigned char*)(0x42700010UL))
#define bFM_MFS0_UART_SMR_MD0                 *((volatile unsigned char*)(0x42700014UL))
#define bFM_MFS0_UART_SMR_MD1                 *((volatile unsigned char*)(0x42700018UL))
#define bFM_MFS0_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270001CUL))
#define bFM_MFS0_UART_SCR_TXE                 *((volatile unsigned char*)(0x42700020UL))
#define bFM_MFS0_UART_SCR_RXE                 *((volatile unsigned char*)(0x42700024UL))
#define bFM_MFS0_UART_SCR_TBIE                *((volatile unsigned char*)(0x42700028UL))
#define bFM_MFS0_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270002CUL))
#define bFM_MFS0_UART_SCR_RIE                 *((volatile unsigned char*)(0x42700030UL))
#define bFM_MFS0_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270003CUL))
#define bFM_MFS0_UART_ESCR_L0                 *((volatile unsigned char*)(0x42700080UL))
#define bFM_MFS0_UART_ESCR_L1                 *((volatile unsigned char*)(0x42700084UL))
#define bFM_MFS0_UART_ESCR_L2                 *((volatile unsigned char*)(0x42700088UL))
#define bFM_MFS0_UART_ESCR_P                  *((volatile unsigned char*)(0x4270008CUL))
#define bFM_MFS0_UART_ESCR_PEN                *((volatile unsigned char*)(0x42700090UL))
#define bFM_MFS0_UART_ESCR_INV                *((volatile unsigned char*)(0x42700094UL))
#define bFM_MFS0_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42700098UL))
#define bFM_MFS0_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270009CUL))
#define bFM_MFS0_UART_SSR_TBI                 *((volatile unsigned char*)(0x427000A0UL))
#define bFM_MFS0_UART_SSR_TDRE                *((volatile unsigned char*)(0x427000A4UL))
#define bFM_MFS0_UART_SSR_RDRF                *((volatile unsigned char*)(0x427000A8UL))
#define bFM_MFS0_UART_SSR_ORE                 *((volatile unsigned char*)(0x427000ACUL))
#define bFM_MFS0_UART_SSR_FRE                 *((volatile unsigned char*)(0x427000B0UL))
#define bFM_MFS0_UART_SSR_PE                  *((volatile unsigned char*)(0x427000B4UL))
#define bFM_MFS0_UART_SSR_REC                 *((volatile unsigned char*)(0x427000BCUL))
#define bFM_MFS0_UART_BGR_EXT                 *((volatile unsigned char*)(0x427001BCUL))
#define bFM_MFS0_UART_BGR1_EXT                *((volatile unsigned char*)(0x427001BCUL))
#define bFM_MFS0_UART_FCR_FE1                 *((volatile unsigned char*)(0x42700280UL))
#define bFM_MFS0_UART_FCR_FE2                 *((volatile unsigned char*)(0x42700284UL))
#define bFM_MFS0_UART_FCR_FCL1                *((volatile unsigned char*)(0x42700288UL))
#define bFM_MFS0_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270028CUL))
#define bFM_MFS0_UART_FCR_FSET                *((volatile unsigned char*)(0x42700290UL))
#define bFM_MFS0_UART_FCR_FLD                 *((volatile unsigned char*)(0x42700294UL))
#define bFM_MFS0_UART_FCR_FLST                *((volatile unsigned char*)(0x42700298UL))
#define bFM_MFS0_UART_FCR_FSEL                *((volatile unsigned char*)(0x427002A0UL))
#define bFM_MFS0_UART_FCR_FTIE                *((volatile unsigned char*)(0x427002A4UL))
#define bFM_MFS0_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427002A8UL))
#define bFM_MFS0_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427002ACUL))
#define bFM_MFS0_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427002B0UL))
#define bFM_MFS0_UART_FCR0_FE1                *((volatile unsigned char*)(0x42700280UL))
#define bFM_MFS0_UART_FCR0_FE2                *((volatile unsigned char*)(0x42700284UL))
#define bFM_MFS0_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42700288UL))
#define bFM_MFS0_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270028CUL))
#define bFM_MFS0_UART_FCR0_FSET               *((volatile unsigned char*)(0x42700290UL))
#define bFM_MFS0_UART_FCR0_FLD                *((volatile unsigned char*)(0x42700294UL))
#define bFM_MFS0_UART_FCR0_FLST               *((volatile unsigned char*)(0x42700298UL))
#define bFM_MFS0_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427002A0UL))
#define bFM_MFS0_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427002A4UL))
#define bFM_MFS0_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427002A8UL))
#define bFM_MFS0_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427002ACUL))
#define bFM_MFS0_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427002B0UL))
#define bFM_MFS0_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42700300UL))
#define bFM_MFS0_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42700304UL))
#define bFM_MFS0_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42700308UL))
#define bFM_MFS0_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270030CUL))
#define bFM_MFS0_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42700310UL))
#define bFM_MFS0_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42700314UL))
#define bFM_MFS0_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42700318UL))
#define bFM_MFS0_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270031CUL))
#define bFM_MFS0_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42700320UL))
#define bFM_MFS0_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42700324UL))
#define bFM_MFS0_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42700328UL))
#define bFM_MFS0_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270032CUL))
#define bFM_MFS0_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42700330UL))
#define bFM_MFS0_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42700334UL))
#define bFM_MFS0_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42700338UL))
#define bFM_MFS0_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270033CUL))
#define bFM_MFS0_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42700300UL))
#define bFM_MFS0_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42700304UL))
#define bFM_MFS0_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42700308UL))
#define bFM_MFS0_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270030CUL))
#define bFM_MFS0_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42700310UL))
#define bFM_MFS0_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42700314UL))
#define bFM_MFS0_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42700318UL))
#define bFM_MFS0_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270031CUL))
#define bFM_MFS0_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42700320UL))
#define bFM_MFS0_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42700324UL))
#define bFM_MFS0_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42700328UL))
#define bFM_MFS0_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270032CUL))
#define bFM_MFS0_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42700330UL))
#define bFM_MFS0_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42700334UL))
#define bFM_MFS0_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42700338UL))
#define bFM_MFS0_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270033CUL))

/* MFS CSIO channel 0 registers */
#define bFM_MFS0_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42700000UL))
#define bFM_MFS0_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42700004UL))
#define bFM_MFS0_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42700008UL))
#define bFM_MFS0_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270000CUL))
#define bFM_MFS0_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42700014UL))
#define bFM_MFS0_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42700018UL))
#define bFM_MFS0_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270001CUL))
#define bFM_MFS0_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42700020UL))
#define bFM_MFS0_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42700024UL))
#define bFM_MFS0_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42700028UL))
#define bFM_MFS0_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270002CUL))
#define bFM_MFS0_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42700030UL))
#define bFM_MFS0_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42700034UL))
#define bFM_MFS0_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42700038UL))
#define bFM_MFS0_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270003CUL))
#define bFM_MFS0_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42700080UL))
#define bFM_MFS0_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42700084UL))
#define bFM_MFS0_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42700088UL))
#define bFM_MFS0_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270008CUL))
#define bFM_MFS0_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42700090UL))
#define bFM_MFS0_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42700094UL))
#define bFM_MFS0_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42700098UL))
#define bFM_MFS0_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270009CUL))
#define bFM_MFS0_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427000A0UL))
#define bFM_MFS0_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427000A4UL))
#define bFM_MFS0_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427000A8UL))
#define bFM_MFS0_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427000ACUL))
#define bFM_MFS0_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427000B0UL))
#define bFM_MFS0_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427000BCUL))
#define bFM_MFS0_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42700280UL))
#define bFM_MFS0_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42700284UL))
#define bFM_MFS0_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42700288UL))
#define bFM_MFS0_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270028CUL))
#define bFM_MFS0_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42700290UL))
#define bFM_MFS0_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42700294UL))
#define bFM_MFS0_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42700298UL))
#define bFM_MFS0_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427002A0UL))
#define bFM_MFS0_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427002A4UL))
#define bFM_MFS0_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427002A8UL))
#define bFM_MFS0_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427002ACUL))
#define bFM_MFS0_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427002B0UL))
#define bFM_MFS0_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42700280UL))
#define bFM_MFS0_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42700284UL))
#define bFM_MFS0_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42700288UL))
#define bFM_MFS0_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270028CUL))
#define bFM_MFS0_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42700290UL))
#define bFM_MFS0_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42700294UL))
#define bFM_MFS0_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42700298UL))
#define bFM_MFS0_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427002A0UL))
#define bFM_MFS0_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427002A4UL))
#define bFM_MFS0_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427002A8UL))
#define bFM_MFS0_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427002ACUL))
#define bFM_MFS0_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427002B0UL))
#define bFM_MFS0_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42700300UL))
#define bFM_MFS0_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42700304UL))
#define bFM_MFS0_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42700308UL))
#define bFM_MFS0_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270030CUL))
#define bFM_MFS0_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42700310UL))
#define bFM_MFS0_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42700314UL))
#define bFM_MFS0_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42700318UL))
#define bFM_MFS0_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270031CUL))
#define bFM_MFS0_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42700320UL))
#define bFM_MFS0_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42700324UL))
#define bFM_MFS0_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42700328UL))
#define bFM_MFS0_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270032CUL))
#define bFM_MFS0_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42700330UL))
#define bFM_MFS0_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42700334UL))
#define bFM_MFS0_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42700338UL))
#define bFM_MFS0_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270033CUL))
#define bFM_MFS0_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42700300UL))
#define bFM_MFS0_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42700304UL))
#define bFM_MFS0_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42700308UL))
#define bFM_MFS0_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270030CUL))
#define bFM_MFS0_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42700310UL))
#define bFM_MFS0_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42700314UL))
#define bFM_MFS0_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42700318UL))
#define bFM_MFS0_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270031CUL))
#define bFM_MFS0_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42700320UL))
#define bFM_MFS0_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42700324UL))
#define bFM_MFS0_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42700328UL))
#define bFM_MFS0_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270032CUL))
#define bFM_MFS0_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42700330UL))
#define bFM_MFS0_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42700334UL))
#define bFM_MFS0_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42700338UL))
#define bFM_MFS0_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270033CUL))
#define bFM_MFS0_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42700380UL))
#define bFM_MFS0_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42700384UL))
#define bFM_MFS0_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42700388UL))
#define bFM_MFS0_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270038CUL))
#define bFM_MFS0_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42700390UL))
#define bFM_MFS0_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42700394UL))
#define bFM_MFS0_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42700398UL))
#define bFM_MFS0_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270039CUL))
#define bFM_MFS0_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427003A0UL))
#define bFM_MFS0_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427003A4UL))
#define bFM_MFS0_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427003A8UL))
#define bFM_MFS0_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427003ACUL))
#define bFM_MFS0_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427003B0UL))
#define bFM_MFS0_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427003B4UL))
#define bFM_MFS0_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427003B8UL))
#define bFM_MFS0_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427003BCUL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42700400UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42700404UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42700408UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270040CUL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42700410UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42700414UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42700418UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270041CUL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42700420UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42700424UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42700428UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270042CUL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42700430UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42700434UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42700438UL))
#define bFM_MFS0_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270043CUL))
#define bFM_MFS0_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42700480UL))
#define bFM_MFS0_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42700484UL))
#define bFM_MFS0_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42700488UL))
#define bFM_MFS0_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270048CUL))
#define bFM_MFS0_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42700490UL))
#define bFM_MFS0_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42700498UL))
#define bFM_MFS0_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270049CUL))
#define bFM_MFS0_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427004A0UL))
#define bFM_MFS0_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427004ACUL))
#define bFM_MFS0_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427004B0UL))
#define bFM_MFS0_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427004B4UL))
#define bFM_MFS0_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42700500UL))
#define bFM_MFS0_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42700504UL))
#define bFM_MFS0_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42700508UL))
#define bFM_MFS0_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270050CUL))
#define bFM_MFS0_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42700510UL))
#define bFM_MFS0_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42700514UL))
#define bFM_MFS0_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42700518UL))
#define bFM_MFS0_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270051CUL))
#define bFM_MFS0_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42700520UL))
#define bFM_MFS0_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42700524UL))
#define bFM_MFS0_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42700528UL))
#define bFM_MFS0_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270052CUL))
#define bFM_MFS0_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42700530UL))
#define bFM_MFS0_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42700534UL))
#define bFM_MFS0_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42700538UL))
#define bFM_MFS0_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270053CUL))
#define bFM_MFS0_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42700580UL))
#define bFM_MFS0_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42700584UL))
#define bFM_MFS0_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42700588UL))
#define bFM_MFS0_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270058CUL))
#define bFM_MFS0_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42700590UL))
#define bFM_MFS0_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42700594UL))
#define bFM_MFS0_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42700598UL))
#define bFM_MFS0_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270059CUL))
#define bFM_MFS0_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427005A0UL))
#define bFM_MFS0_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427005A4UL))
#define bFM_MFS0_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427005A8UL))
#define bFM_MFS0_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427005ACUL))
#define bFM_MFS0_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427005B0UL))
#define bFM_MFS0_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427005B4UL))
#define bFM_MFS0_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427005B8UL))
#define bFM_MFS0_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427005BCUL))
#define bFM_MFS0_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42700600UL))
#define bFM_MFS0_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42700604UL))
#define bFM_MFS0_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42700608UL))
#define bFM_MFS0_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270060CUL))
#define bFM_MFS0_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42700610UL))
#define bFM_MFS0_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42700614UL))
#define bFM_MFS0_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42700618UL))
#define bFM_MFS0_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270061CUL))
#define bFM_MFS0_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42700620UL))
#define bFM_MFS0_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42700624UL))
#define bFM_MFS0_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42700628UL))
#define bFM_MFS0_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270062CUL))
#define bFM_MFS0_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42700630UL))
#define bFM_MFS0_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42700634UL))
#define bFM_MFS0_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42700638UL))
#define bFM_MFS0_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270063CUL))
#define bFM_MFS0_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42700680UL))
#define bFM_MFS0_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42700684UL))
#define bFM_MFS0_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42700688UL))
#define bFM_MFS0_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270068CUL))
#define bFM_MFS0_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42700690UL))
#define bFM_MFS0_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42700694UL))
#define bFM_MFS0_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42700698UL))
#define bFM_MFS0_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270069CUL))
#define bFM_MFS0_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427006A0UL))
#define bFM_MFS0_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427006A4UL))
#define bFM_MFS0_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427006A8UL))
#define bFM_MFS0_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427006ACUL))
#define bFM_MFS0_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427006B0UL))
#define bFM_MFS0_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427006B4UL))
#define bFM_MFS0_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427006B8UL))
#define bFM_MFS0_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427006BCUL))
#define bFM_MFS0_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42700700UL))
#define bFM_MFS0_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42700704UL))
#define bFM_MFS0_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42700708UL))
#define bFM_MFS0_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270070CUL))
#define bFM_MFS0_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42700710UL))
#define bFM_MFS0_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42700714UL))
#define bFM_MFS0_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42700718UL))
#define bFM_MFS0_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270071CUL))

/* MFS LIN channel 0 registers */
#define bFM_MFS0_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42700000UL))
#define bFM_MFS0_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270000CUL))
#define bFM_MFS0_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42700010UL))
#define bFM_MFS0_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42700014UL))
#define bFM_MFS0_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42700018UL))
#define bFM_MFS0_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270001CUL))
#define bFM_MFS0_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42700020UL))
#define bFM_MFS0_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42700024UL))
#define bFM_MFS0_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42700028UL))
#define bFM_MFS0_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270002CUL))
#define bFM_MFS0_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42700030UL))
#define bFM_MFS0_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42700034UL))
#define bFM_MFS0_LIN_SCR_MS                   *((volatile unsigned char*)(0x42700038UL))
#define bFM_MFS0_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270003CUL))
#define bFM_MFS0_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42700080UL))
#define bFM_MFS0_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42700084UL))
#define bFM_MFS0_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42700088UL))
#define bFM_MFS0_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270008CUL))
#define bFM_MFS0_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42700090UL))
#define bFM_MFS0_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42700098UL))
#define bFM_MFS0_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427000A0UL))
#define bFM_MFS0_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427000A4UL))
#define bFM_MFS0_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427000A8UL))
#define bFM_MFS0_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427000ACUL))
#define bFM_MFS0_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427000B0UL))
#define bFM_MFS0_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427000B4UL))
#define bFM_MFS0_LIN_SSR_REC                  *((volatile unsigned char*)(0x427000BCUL))
#define bFM_MFS0_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427001BCUL))
#define bFM_MFS0_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427001BCUL))
#define bFM_MFS0_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42700280UL))
#define bFM_MFS0_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42700284UL))
#define bFM_MFS0_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42700288UL))
#define bFM_MFS0_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270028CUL))
#define bFM_MFS0_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42700290UL))
#define bFM_MFS0_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42700294UL))
#define bFM_MFS0_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42700298UL))
#define bFM_MFS0_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427002A0UL))
#define bFM_MFS0_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427002A4UL))
#define bFM_MFS0_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427002A8UL))
#define bFM_MFS0_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427002ACUL))
#define bFM_MFS0_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427002B0UL))
#define bFM_MFS0_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42700280UL))
#define bFM_MFS0_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42700284UL))
#define bFM_MFS0_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42700288UL))
#define bFM_MFS0_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270028CUL))
#define bFM_MFS0_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42700290UL))
#define bFM_MFS0_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42700294UL))
#define bFM_MFS0_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42700298UL))
#define bFM_MFS0_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427002A0UL))
#define bFM_MFS0_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427002A4UL))
#define bFM_MFS0_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427002A8UL))
#define bFM_MFS0_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427002ACUL))
#define bFM_MFS0_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427002B0UL))
#define bFM_MFS0_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42700300UL))
#define bFM_MFS0_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42700304UL))
#define bFM_MFS0_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42700308UL))
#define bFM_MFS0_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270030CUL))
#define bFM_MFS0_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42700310UL))
#define bFM_MFS0_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42700314UL))
#define bFM_MFS0_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42700318UL))
#define bFM_MFS0_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270031CUL))
#define bFM_MFS0_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42700320UL))
#define bFM_MFS0_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42700324UL))
#define bFM_MFS0_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42700328UL))
#define bFM_MFS0_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270032CUL))
#define bFM_MFS0_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42700330UL))
#define bFM_MFS0_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42700334UL))
#define bFM_MFS0_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42700338UL))
#define bFM_MFS0_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270033CUL))
#define bFM_MFS0_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42700300UL))
#define bFM_MFS0_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42700304UL))
#define bFM_MFS0_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42700308UL))
#define bFM_MFS0_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270030CUL))
#define bFM_MFS0_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42700310UL))
#define bFM_MFS0_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42700314UL))
#define bFM_MFS0_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42700318UL))
#define bFM_MFS0_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270031CUL))
#define bFM_MFS0_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42700320UL))
#define bFM_MFS0_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42700324UL))
#define bFM_MFS0_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42700328UL))
#define bFM_MFS0_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270032CUL))
#define bFM_MFS0_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42700330UL))
#define bFM_MFS0_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42700334UL))
#define bFM_MFS0_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42700338UL))
#define bFM_MFS0_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270033CUL))

/* MFS I2C channel 0 registers */
#define bFM_MFS0_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42700008UL))
#define bFM_MFS0_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270000CUL))
#define bFM_MFS0_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42700014UL))
#define bFM_MFS0_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42700018UL))
#define bFM_MFS0_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270001CUL))
#define bFM_MFS0_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42700020UL))
#define bFM_MFS0_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42700024UL))
#define bFM_MFS0_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42700028UL))
#define bFM_MFS0_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270002CUL))
#define bFM_MFS0_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42700030UL))
#define bFM_MFS0_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42700034UL))
#define bFM_MFS0_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42700038UL))
#define bFM_MFS0_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42700038UL))
#define bFM_MFS0_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270003CUL))
#define bFM_MFS0_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42700080UL))
#define bFM_MFS0_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42700084UL))
#define bFM_MFS0_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42700088UL))
#define bFM_MFS0_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270008CUL))
#define bFM_MFS0_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42700090UL))
#define bFM_MFS0_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42700094UL))
#define bFM_MFS0_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42700098UL))
#define bFM_MFS0_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270009CUL))
#define bFM_MFS0_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427000A0UL))
#define bFM_MFS0_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427000A4UL))
#define bFM_MFS0_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427000A8UL))
#define bFM_MFS0_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427000ACUL))
#define bFM_MFS0_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427000B0UL))
#define bFM_MFS0_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427000B4UL))
#define bFM_MFS0_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427000B8UL))
#define bFM_MFS0_I2C_SSR_REC                  *((volatile unsigned char*)(0x427000BCUL))
#define bFM_MFS0_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42700200UL))
#define bFM_MFS0_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42700204UL))
#define bFM_MFS0_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42700208UL))
#define bFM_MFS0_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270020CUL))
#define bFM_MFS0_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42700210UL))
#define bFM_MFS0_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42700214UL))
#define bFM_MFS0_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42700218UL))
#define bFM_MFS0_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270021CUL))
#define bFM_MFS0_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42700220UL))
#define bFM_MFS0_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42700224UL))
#define bFM_MFS0_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42700228UL))
#define bFM_MFS0_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270022CUL))
#define bFM_MFS0_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42700230UL))
#define bFM_MFS0_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42700234UL))
#define bFM_MFS0_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42700238UL))
#define bFM_MFS0_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270023CUL))
#define bFM_MFS0_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42700280UL))
#define bFM_MFS0_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42700284UL))
#define bFM_MFS0_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42700288UL))
#define bFM_MFS0_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270028CUL))
#define bFM_MFS0_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42700290UL))
#define bFM_MFS0_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42700294UL))
#define bFM_MFS0_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42700298UL))
#define bFM_MFS0_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427002A0UL))
#define bFM_MFS0_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427002A4UL))
#define bFM_MFS0_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427002A8UL))
#define bFM_MFS0_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427002ACUL))
#define bFM_MFS0_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427002B0UL))
#define bFM_MFS0_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42700280UL))
#define bFM_MFS0_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42700284UL))
#define bFM_MFS0_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42700288UL))
#define bFM_MFS0_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270028CUL))
#define bFM_MFS0_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42700290UL))
#define bFM_MFS0_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42700294UL))
#define bFM_MFS0_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42700298UL))
#define bFM_MFS0_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427002A0UL))
#define bFM_MFS0_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427002A4UL))
#define bFM_MFS0_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427002A8UL))
#define bFM_MFS0_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427002ACUL))
#define bFM_MFS0_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427002B0UL))
#define bFM_MFS0_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42700300UL))
#define bFM_MFS0_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42700304UL))
#define bFM_MFS0_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42700308UL))
#define bFM_MFS0_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270030CUL))
#define bFM_MFS0_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42700310UL))
#define bFM_MFS0_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42700314UL))
#define bFM_MFS0_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42700318UL))
#define bFM_MFS0_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270031CUL))
#define bFM_MFS0_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42700320UL))
#define bFM_MFS0_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42700324UL))
#define bFM_MFS0_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42700328UL))
#define bFM_MFS0_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270032CUL))
#define bFM_MFS0_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42700330UL))
#define bFM_MFS0_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42700334UL))
#define bFM_MFS0_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42700338UL))
#define bFM_MFS0_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270033CUL))
#define bFM_MFS0_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42700300UL))
#define bFM_MFS0_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42700304UL))
#define bFM_MFS0_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42700308UL))
#define bFM_MFS0_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270030CUL))
#define bFM_MFS0_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42700310UL))
#define bFM_MFS0_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42700314UL))
#define bFM_MFS0_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42700318UL))
#define bFM_MFS0_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270031CUL))
#define bFM_MFS0_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42700320UL))
#define bFM_MFS0_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42700324UL))
#define bFM_MFS0_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42700328UL))
#define bFM_MFS0_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270032CUL))
#define bFM_MFS0_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42700330UL))
#define bFM_MFS0_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42700334UL))
#define bFM_MFS0_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42700338UL))
#define bFM_MFS0_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270033CUL))

/* MFS UART channel 1 registers */
#define bFM_MFS1_UART_SMR_SOE                 *((volatile unsigned char*)(0x42702000UL))
#define bFM_MFS1_UART_SMR_BDS                 *((volatile unsigned char*)(0x42702008UL))
#define bFM_MFS1_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270200CUL))
#define bFM_MFS1_UART_SMR_WUCR                *((volatile unsigned char*)(0x42702010UL))
#define bFM_MFS1_UART_SMR_MD0                 *((volatile unsigned char*)(0x42702014UL))
#define bFM_MFS1_UART_SMR_MD1                 *((volatile unsigned char*)(0x42702018UL))
#define bFM_MFS1_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270201CUL))
#define bFM_MFS1_UART_SCR_TXE                 *((volatile unsigned char*)(0x42702020UL))
#define bFM_MFS1_UART_SCR_RXE                 *((volatile unsigned char*)(0x42702024UL))
#define bFM_MFS1_UART_SCR_TBIE                *((volatile unsigned char*)(0x42702028UL))
#define bFM_MFS1_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270202CUL))
#define bFM_MFS1_UART_SCR_RIE                 *((volatile unsigned char*)(0x42702030UL))
#define bFM_MFS1_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270203CUL))
#define bFM_MFS1_UART_ESCR_L0                 *((volatile unsigned char*)(0x42702080UL))
#define bFM_MFS1_UART_ESCR_L1                 *((volatile unsigned char*)(0x42702084UL))
#define bFM_MFS1_UART_ESCR_L2                 *((volatile unsigned char*)(0x42702088UL))
#define bFM_MFS1_UART_ESCR_P                  *((volatile unsigned char*)(0x4270208CUL))
#define bFM_MFS1_UART_ESCR_PEN                *((volatile unsigned char*)(0x42702090UL))
#define bFM_MFS1_UART_ESCR_INV                *((volatile unsigned char*)(0x42702094UL))
#define bFM_MFS1_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42702098UL))
#define bFM_MFS1_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270209CUL))
#define bFM_MFS1_UART_SSR_TBI                 *((volatile unsigned char*)(0x427020A0UL))
#define bFM_MFS1_UART_SSR_TDRE                *((volatile unsigned char*)(0x427020A4UL))
#define bFM_MFS1_UART_SSR_RDRF                *((volatile unsigned char*)(0x427020A8UL))
#define bFM_MFS1_UART_SSR_ORE                 *((volatile unsigned char*)(0x427020ACUL))
#define bFM_MFS1_UART_SSR_FRE                 *((volatile unsigned char*)(0x427020B0UL))
#define bFM_MFS1_UART_SSR_PE                  *((volatile unsigned char*)(0x427020B4UL))
#define bFM_MFS1_UART_SSR_REC                 *((volatile unsigned char*)(0x427020BCUL))
#define bFM_MFS1_UART_BGR_EXT                 *((volatile unsigned char*)(0x427021BCUL))
#define bFM_MFS1_UART_BGR1_EXT                *((volatile unsigned char*)(0x427021BCUL))
#define bFM_MFS1_UART_FCR_FE1                 *((volatile unsigned char*)(0x42702280UL))
#define bFM_MFS1_UART_FCR_FE2                 *((volatile unsigned char*)(0x42702284UL))
#define bFM_MFS1_UART_FCR_FCL1                *((volatile unsigned char*)(0x42702288UL))
#define bFM_MFS1_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270228CUL))
#define bFM_MFS1_UART_FCR_FSET                *((volatile unsigned char*)(0x42702290UL))
#define bFM_MFS1_UART_FCR_FLD                 *((volatile unsigned char*)(0x42702294UL))
#define bFM_MFS1_UART_FCR_FLST                *((volatile unsigned char*)(0x42702298UL))
#define bFM_MFS1_UART_FCR_FSEL                *((volatile unsigned char*)(0x427022A0UL))
#define bFM_MFS1_UART_FCR_FTIE                *((volatile unsigned char*)(0x427022A4UL))
#define bFM_MFS1_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427022A8UL))
#define bFM_MFS1_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427022ACUL))
#define bFM_MFS1_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427022B0UL))
#define bFM_MFS1_UART_FCR0_FE1                *((volatile unsigned char*)(0x42702280UL))
#define bFM_MFS1_UART_FCR0_FE2                *((volatile unsigned char*)(0x42702284UL))
#define bFM_MFS1_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42702288UL))
#define bFM_MFS1_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270228CUL))
#define bFM_MFS1_UART_FCR0_FSET               *((volatile unsigned char*)(0x42702290UL))
#define bFM_MFS1_UART_FCR0_FLD                *((volatile unsigned char*)(0x42702294UL))
#define bFM_MFS1_UART_FCR0_FLST               *((volatile unsigned char*)(0x42702298UL))
#define bFM_MFS1_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427022A0UL))
#define bFM_MFS1_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427022A4UL))
#define bFM_MFS1_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427022A8UL))
#define bFM_MFS1_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427022ACUL))
#define bFM_MFS1_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427022B0UL))
#define bFM_MFS1_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42702300UL))
#define bFM_MFS1_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42702304UL))
#define bFM_MFS1_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42702308UL))
#define bFM_MFS1_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270230CUL))
#define bFM_MFS1_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42702310UL))
#define bFM_MFS1_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42702314UL))
#define bFM_MFS1_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42702318UL))
#define bFM_MFS1_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270231CUL))
#define bFM_MFS1_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42702320UL))
#define bFM_MFS1_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42702324UL))
#define bFM_MFS1_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42702328UL))
#define bFM_MFS1_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270232CUL))
#define bFM_MFS1_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42702330UL))
#define bFM_MFS1_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42702334UL))
#define bFM_MFS1_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42702338UL))
#define bFM_MFS1_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270233CUL))
#define bFM_MFS1_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42702300UL))
#define bFM_MFS1_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42702304UL))
#define bFM_MFS1_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42702308UL))
#define bFM_MFS1_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270230CUL))
#define bFM_MFS1_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42702310UL))
#define bFM_MFS1_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42702314UL))
#define bFM_MFS1_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42702318UL))
#define bFM_MFS1_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270231CUL))
#define bFM_MFS1_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42702320UL))
#define bFM_MFS1_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42702324UL))
#define bFM_MFS1_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42702328UL))
#define bFM_MFS1_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270232CUL))
#define bFM_MFS1_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42702330UL))
#define bFM_MFS1_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42702334UL))
#define bFM_MFS1_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42702338UL))
#define bFM_MFS1_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270233CUL))

/* MFS CSIO channel 1 registers */
#define bFM_MFS1_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42702000UL))
#define bFM_MFS1_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42702004UL))
#define bFM_MFS1_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42702008UL))
#define bFM_MFS1_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270200CUL))
#define bFM_MFS1_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42702014UL))
#define bFM_MFS1_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42702018UL))
#define bFM_MFS1_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270201CUL))
#define bFM_MFS1_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42702020UL))
#define bFM_MFS1_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42702024UL))
#define bFM_MFS1_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42702028UL))
#define bFM_MFS1_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270202CUL))
#define bFM_MFS1_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42702030UL))
#define bFM_MFS1_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42702034UL))
#define bFM_MFS1_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42702038UL))
#define bFM_MFS1_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270203CUL))
#define bFM_MFS1_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42702080UL))
#define bFM_MFS1_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42702084UL))
#define bFM_MFS1_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42702088UL))
#define bFM_MFS1_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270208CUL))
#define bFM_MFS1_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42702090UL))
#define bFM_MFS1_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42702094UL))
#define bFM_MFS1_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42702098UL))
#define bFM_MFS1_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270209CUL))
#define bFM_MFS1_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427020A0UL))
#define bFM_MFS1_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427020A4UL))
#define bFM_MFS1_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427020A8UL))
#define bFM_MFS1_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427020ACUL))
#define bFM_MFS1_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427020B0UL))
#define bFM_MFS1_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427020BCUL))
#define bFM_MFS1_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42702280UL))
#define bFM_MFS1_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42702284UL))
#define bFM_MFS1_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42702288UL))
#define bFM_MFS1_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270228CUL))
#define bFM_MFS1_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42702290UL))
#define bFM_MFS1_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42702294UL))
#define bFM_MFS1_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42702298UL))
#define bFM_MFS1_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427022A0UL))
#define bFM_MFS1_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427022A4UL))
#define bFM_MFS1_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427022A8UL))
#define bFM_MFS1_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427022ACUL))
#define bFM_MFS1_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427022B0UL))
#define bFM_MFS1_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42702280UL))
#define bFM_MFS1_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42702284UL))
#define bFM_MFS1_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42702288UL))
#define bFM_MFS1_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270228CUL))
#define bFM_MFS1_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42702290UL))
#define bFM_MFS1_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42702294UL))
#define bFM_MFS1_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42702298UL))
#define bFM_MFS1_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427022A0UL))
#define bFM_MFS1_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427022A4UL))
#define bFM_MFS1_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427022A8UL))
#define bFM_MFS1_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427022ACUL))
#define bFM_MFS1_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427022B0UL))
#define bFM_MFS1_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42702300UL))
#define bFM_MFS1_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42702304UL))
#define bFM_MFS1_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42702308UL))
#define bFM_MFS1_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270230CUL))
#define bFM_MFS1_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42702310UL))
#define bFM_MFS1_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42702314UL))
#define bFM_MFS1_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42702318UL))
#define bFM_MFS1_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270231CUL))
#define bFM_MFS1_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42702320UL))
#define bFM_MFS1_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42702324UL))
#define bFM_MFS1_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42702328UL))
#define bFM_MFS1_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270232CUL))
#define bFM_MFS1_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42702330UL))
#define bFM_MFS1_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42702334UL))
#define bFM_MFS1_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42702338UL))
#define bFM_MFS1_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270233CUL))
#define bFM_MFS1_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42702300UL))
#define bFM_MFS1_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42702304UL))
#define bFM_MFS1_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42702308UL))
#define bFM_MFS1_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270230CUL))
#define bFM_MFS1_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42702310UL))
#define bFM_MFS1_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42702314UL))
#define bFM_MFS1_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42702318UL))
#define bFM_MFS1_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270231CUL))
#define bFM_MFS1_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42702320UL))
#define bFM_MFS1_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42702324UL))
#define bFM_MFS1_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42702328UL))
#define bFM_MFS1_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270232CUL))
#define bFM_MFS1_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42702330UL))
#define bFM_MFS1_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42702334UL))
#define bFM_MFS1_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42702338UL))
#define bFM_MFS1_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270233CUL))
#define bFM_MFS1_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42702380UL))
#define bFM_MFS1_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42702384UL))
#define bFM_MFS1_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42702388UL))
#define bFM_MFS1_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270238CUL))
#define bFM_MFS1_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42702390UL))
#define bFM_MFS1_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42702394UL))
#define bFM_MFS1_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42702398UL))
#define bFM_MFS1_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270239CUL))
#define bFM_MFS1_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427023A0UL))
#define bFM_MFS1_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427023A4UL))
#define bFM_MFS1_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427023A8UL))
#define bFM_MFS1_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427023ACUL))
#define bFM_MFS1_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427023B0UL))
#define bFM_MFS1_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427023B4UL))
#define bFM_MFS1_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427023B8UL))
#define bFM_MFS1_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427023BCUL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42702400UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42702404UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42702408UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270240CUL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42702410UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42702414UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42702418UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270241CUL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42702420UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42702424UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42702428UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270242CUL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42702430UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42702434UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42702438UL))
#define bFM_MFS1_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270243CUL))
#define bFM_MFS1_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42702480UL))
#define bFM_MFS1_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42702484UL))
#define bFM_MFS1_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42702488UL))
#define bFM_MFS1_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270248CUL))
#define bFM_MFS1_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42702490UL))
#define bFM_MFS1_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42702498UL))
#define bFM_MFS1_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270249CUL))
#define bFM_MFS1_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427024A0UL))
#define bFM_MFS1_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427024ACUL))
#define bFM_MFS1_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427024B0UL))
#define bFM_MFS1_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427024B4UL))
#define bFM_MFS1_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42702500UL))
#define bFM_MFS1_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42702504UL))
#define bFM_MFS1_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42702508UL))
#define bFM_MFS1_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270250CUL))
#define bFM_MFS1_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42702510UL))
#define bFM_MFS1_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42702514UL))
#define bFM_MFS1_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42702518UL))
#define bFM_MFS1_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270251CUL))
#define bFM_MFS1_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42702520UL))
#define bFM_MFS1_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42702524UL))
#define bFM_MFS1_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42702528UL))
#define bFM_MFS1_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270252CUL))
#define bFM_MFS1_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42702530UL))
#define bFM_MFS1_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42702534UL))
#define bFM_MFS1_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42702538UL))
#define bFM_MFS1_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270253CUL))
#define bFM_MFS1_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42702580UL))
#define bFM_MFS1_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42702584UL))
#define bFM_MFS1_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42702588UL))
#define bFM_MFS1_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270258CUL))
#define bFM_MFS1_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42702590UL))
#define bFM_MFS1_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42702594UL))
#define bFM_MFS1_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42702598UL))
#define bFM_MFS1_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270259CUL))
#define bFM_MFS1_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427025A0UL))
#define bFM_MFS1_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427025A4UL))
#define bFM_MFS1_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427025A8UL))
#define bFM_MFS1_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427025ACUL))
#define bFM_MFS1_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427025B0UL))
#define bFM_MFS1_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427025B4UL))
#define bFM_MFS1_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427025B8UL))
#define bFM_MFS1_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427025BCUL))
#define bFM_MFS1_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42702600UL))
#define bFM_MFS1_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42702604UL))
#define bFM_MFS1_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42702608UL))
#define bFM_MFS1_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270260CUL))
#define bFM_MFS1_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42702610UL))
#define bFM_MFS1_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42702614UL))
#define bFM_MFS1_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42702618UL))
#define bFM_MFS1_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270261CUL))
#define bFM_MFS1_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42702620UL))
#define bFM_MFS1_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42702624UL))
#define bFM_MFS1_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42702628UL))
#define bFM_MFS1_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270262CUL))
#define bFM_MFS1_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42702630UL))
#define bFM_MFS1_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42702634UL))
#define bFM_MFS1_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42702638UL))
#define bFM_MFS1_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270263CUL))
#define bFM_MFS1_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42702680UL))
#define bFM_MFS1_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42702684UL))
#define bFM_MFS1_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42702688UL))
#define bFM_MFS1_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270268CUL))
#define bFM_MFS1_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42702690UL))
#define bFM_MFS1_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42702694UL))
#define bFM_MFS1_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42702698UL))
#define bFM_MFS1_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270269CUL))
#define bFM_MFS1_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427026A0UL))
#define bFM_MFS1_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427026A4UL))
#define bFM_MFS1_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427026A8UL))
#define bFM_MFS1_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427026ACUL))
#define bFM_MFS1_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427026B0UL))
#define bFM_MFS1_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427026B4UL))
#define bFM_MFS1_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427026B8UL))
#define bFM_MFS1_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427026BCUL))
#define bFM_MFS1_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42702700UL))
#define bFM_MFS1_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42702704UL))
#define bFM_MFS1_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42702708UL))
#define bFM_MFS1_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270270CUL))
#define bFM_MFS1_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42702710UL))
#define bFM_MFS1_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42702714UL))
#define bFM_MFS1_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42702718UL))
#define bFM_MFS1_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270271CUL))

/* MFS LIN channel 1 registers */
#define bFM_MFS1_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42702000UL))
#define bFM_MFS1_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270200CUL))
#define bFM_MFS1_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42702010UL))
#define bFM_MFS1_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42702014UL))
#define bFM_MFS1_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42702018UL))
#define bFM_MFS1_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270201CUL))
#define bFM_MFS1_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42702020UL))
#define bFM_MFS1_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42702024UL))
#define bFM_MFS1_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42702028UL))
#define bFM_MFS1_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270202CUL))
#define bFM_MFS1_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42702030UL))
#define bFM_MFS1_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42702034UL))
#define bFM_MFS1_LIN_SCR_MS                   *((volatile unsigned char*)(0x42702038UL))
#define bFM_MFS1_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270203CUL))
#define bFM_MFS1_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42702080UL))
#define bFM_MFS1_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42702084UL))
#define bFM_MFS1_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42702088UL))
#define bFM_MFS1_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270208CUL))
#define bFM_MFS1_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42702090UL))
#define bFM_MFS1_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42702098UL))
#define bFM_MFS1_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427020A0UL))
#define bFM_MFS1_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427020A4UL))
#define bFM_MFS1_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427020A8UL))
#define bFM_MFS1_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427020ACUL))
#define bFM_MFS1_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427020B0UL))
#define bFM_MFS1_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427020B4UL))
#define bFM_MFS1_LIN_SSR_REC                  *((volatile unsigned char*)(0x427020BCUL))
#define bFM_MFS1_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427021BCUL))
#define bFM_MFS1_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427021BCUL))
#define bFM_MFS1_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42702280UL))
#define bFM_MFS1_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42702284UL))
#define bFM_MFS1_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42702288UL))
#define bFM_MFS1_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270228CUL))
#define bFM_MFS1_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42702290UL))
#define bFM_MFS1_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42702294UL))
#define bFM_MFS1_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42702298UL))
#define bFM_MFS1_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427022A0UL))
#define bFM_MFS1_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427022A4UL))
#define bFM_MFS1_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427022A8UL))
#define bFM_MFS1_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427022ACUL))
#define bFM_MFS1_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427022B0UL))
#define bFM_MFS1_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42702280UL))
#define bFM_MFS1_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42702284UL))
#define bFM_MFS1_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42702288UL))
#define bFM_MFS1_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270228CUL))
#define bFM_MFS1_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42702290UL))
#define bFM_MFS1_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42702294UL))
#define bFM_MFS1_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42702298UL))
#define bFM_MFS1_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427022A0UL))
#define bFM_MFS1_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427022A4UL))
#define bFM_MFS1_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427022A8UL))
#define bFM_MFS1_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427022ACUL))
#define bFM_MFS1_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427022B0UL))
#define bFM_MFS1_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42702300UL))
#define bFM_MFS1_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42702304UL))
#define bFM_MFS1_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42702308UL))
#define bFM_MFS1_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270230CUL))
#define bFM_MFS1_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42702310UL))
#define bFM_MFS1_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42702314UL))
#define bFM_MFS1_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42702318UL))
#define bFM_MFS1_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270231CUL))
#define bFM_MFS1_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42702320UL))
#define bFM_MFS1_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42702324UL))
#define bFM_MFS1_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42702328UL))
#define bFM_MFS1_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270232CUL))
#define bFM_MFS1_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42702330UL))
#define bFM_MFS1_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42702334UL))
#define bFM_MFS1_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42702338UL))
#define bFM_MFS1_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270233CUL))
#define bFM_MFS1_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42702300UL))
#define bFM_MFS1_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42702304UL))
#define bFM_MFS1_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42702308UL))
#define bFM_MFS1_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270230CUL))
#define bFM_MFS1_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42702310UL))
#define bFM_MFS1_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42702314UL))
#define bFM_MFS1_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42702318UL))
#define bFM_MFS1_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270231CUL))
#define bFM_MFS1_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42702320UL))
#define bFM_MFS1_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42702324UL))
#define bFM_MFS1_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42702328UL))
#define bFM_MFS1_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270232CUL))
#define bFM_MFS1_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42702330UL))
#define bFM_MFS1_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42702334UL))
#define bFM_MFS1_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42702338UL))
#define bFM_MFS1_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270233CUL))

/* MFS I2C channel 1 registers */
#define bFM_MFS1_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42702008UL))
#define bFM_MFS1_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270200CUL))
#define bFM_MFS1_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42702014UL))
#define bFM_MFS1_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42702018UL))
#define bFM_MFS1_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270201CUL))
#define bFM_MFS1_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42702020UL))
#define bFM_MFS1_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42702024UL))
#define bFM_MFS1_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42702028UL))
#define bFM_MFS1_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270202CUL))
#define bFM_MFS1_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42702030UL))
#define bFM_MFS1_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42702034UL))
#define bFM_MFS1_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42702038UL))
#define bFM_MFS1_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42702038UL))
#define bFM_MFS1_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270203CUL))
#define bFM_MFS1_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42702080UL))
#define bFM_MFS1_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42702084UL))
#define bFM_MFS1_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42702088UL))
#define bFM_MFS1_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270208CUL))
#define bFM_MFS1_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42702090UL))
#define bFM_MFS1_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42702094UL))
#define bFM_MFS1_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42702098UL))
#define bFM_MFS1_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270209CUL))
#define bFM_MFS1_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427020A0UL))
#define bFM_MFS1_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427020A4UL))
#define bFM_MFS1_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427020A8UL))
#define bFM_MFS1_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427020ACUL))
#define bFM_MFS1_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427020B0UL))
#define bFM_MFS1_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427020B4UL))
#define bFM_MFS1_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427020B8UL))
#define bFM_MFS1_I2C_SSR_REC                  *((volatile unsigned char*)(0x427020BCUL))
#define bFM_MFS1_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42702200UL))
#define bFM_MFS1_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42702204UL))
#define bFM_MFS1_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42702208UL))
#define bFM_MFS1_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270220CUL))
#define bFM_MFS1_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42702210UL))
#define bFM_MFS1_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42702214UL))
#define bFM_MFS1_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42702218UL))
#define bFM_MFS1_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270221CUL))
#define bFM_MFS1_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42702220UL))
#define bFM_MFS1_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42702224UL))
#define bFM_MFS1_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42702228UL))
#define bFM_MFS1_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270222CUL))
#define bFM_MFS1_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42702230UL))
#define bFM_MFS1_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42702234UL))
#define bFM_MFS1_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42702238UL))
#define bFM_MFS1_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270223CUL))
#define bFM_MFS1_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42702280UL))
#define bFM_MFS1_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42702284UL))
#define bFM_MFS1_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42702288UL))
#define bFM_MFS1_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270228CUL))
#define bFM_MFS1_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42702290UL))
#define bFM_MFS1_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42702294UL))
#define bFM_MFS1_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42702298UL))
#define bFM_MFS1_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427022A0UL))
#define bFM_MFS1_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427022A4UL))
#define bFM_MFS1_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427022A8UL))
#define bFM_MFS1_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427022ACUL))
#define bFM_MFS1_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427022B0UL))
#define bFM_MFS1_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42702280UL))
#define bFM_MFS1_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42702284UL))
#define bFM_MFS1_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42702288UL))
#define bFM_MFS1_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270228CUL))
#define bFM_MFS1_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42702290UL))
#define bFM_MFS1_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42702294UL))
#define bFM_MFS1_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42702298UL))
#define bFM_MFS1_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427022A0UL))
#define bFM_MFS1_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427022A4UL))
#define bFM_MFS1_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427022A8UL))
#define bFM_MFS1_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427022ACUL))
#define bFM_MFS1_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427022B0UL))
#define bFM_MFS1_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42702300UL))
#define bFM_MFS1_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42702304UL))
#define bFM_MFS1_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42702308UL))
#define bFM_MFS1_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270230CUL))
#define bFM_MFS1_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42702310UL))
#define bFM_MFS1_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42702314UL))
#define bFM_MFS1_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42702318UL))
#define bFM_MFS1_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270231CUL))
#define bFM_MFS1_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42702320UL))
#define bFM_MFS1_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42702324UL))
#define bFM_MFS1_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42702328UL))
#define bFM_MFS1_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270232CUL))
#define bFM_MFS1_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42702330UL))
#define bFM_MFS1_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42702334UL))
#define bFM_MFS1_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42702338UL))
#define bFM_MFS1_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270233CUL))
#define bFM_MFS1_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42702300UL))
#define bFM_MFS1_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42702304UL))
#define bFM_MFS1_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42702308UL))
#define bFM_MFS1_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270230CUL))
#define bFM_MFS1_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42702310UL))
#define bFM_MFS1_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42702314UL))
#define bFM_MFS1_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42702318UL))
#define bFM_MFS1_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270231CUL))
#define bFM_MFS1_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42702320UL))
#define bFM_MFS1_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42702324UL))
#define bFM_MFS1_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42702328UL))
#define bFM_MFS1_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270232CUL))
#define bFM_MFS1_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42702330UL))
#define bFM_MFS1_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42702334UL))
#define bFM_MFS1_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42702338UL))
#define bFM_MFS1_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270233CUL))

/* MFS UART channel 2 registers */
#define bFM_MFS2_UART_SMR_SOE                 *((volatile unsigned char*)(0x42704000UL))
#define bFM_MFS2_UART_SMR_BDS                 *((volatile unsigned char*)(0x42704008UL))
#define bFM_MFS2_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270400CUL))
#define bFM_MFS2_UART_SMR_WUCR                *((volatile unsigned char*)(0x42704010UL))
#define bFM_MFS2_UART_SMR_MD0                 *((volatile unsigned char*)(0x42704014UL))
#define bFM_MFS2_UART_SMR_MD1                 *((volatile unsigned char*)(0x42704018UL))
#define bFM_MFS2_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270401CUL))
#define bFM_MFS2_UART_SCR_TXE                 *((volatile unsigned char*)(0x42704020UL))
#define bFM_MFS2_UART_SCR_RXE                 *((volatile unsigned char*)(0x42704024UL))
#define bFM_MFS2_UART_SCR_TBIE                *((volatile unsigned char*)(0x42704028UL))
#define bFM_MFS2_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270402CUL))
#define bFM_MFS2_UART_SCR_RIE                 *((volatile unsigned char*)(0x42704030UL))
#define bFM_MFS2_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270403CUL))
#define bFM_MFS2_UART_ESCR_L0                 *((volatile unsigned char*)(0x42704080UL))
#define bFM_MFS2_UART_ESCR_L1                 *((volatile unsigned char*)(0x42704084UL))
#define bFM_MFS2_UART_ESCR_L2                 *((volatile unsigned char*)(0x42704088UL))
#define bFM_MFS2_UART_ESCR_P                  *((volatile unsigned char*)(0x4270408CUL))
#define bFM_MFS2_UART_ESCR_PEN                *((volatile unsigned char*)(0x42704090UL))
#define bFM_MFS2_UART_ESCR_INV                *((volatile unsigned char*)(0x42704094UL))
#define bFM_MFS2_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42704098UL))
#define bFM_MFS2_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270409CUL))
#define bFM_MFS2_UART_SSR_TBI                 *((volatile unsigned char*)(0x427040A0UL))
#define bFM_MFS2_UART_SSR_TDRE                *((volatile unsigned char*)(0x427040A4UL))
#define bFM_MFS2_UART_SSR_RDRF                *((volatile unsigned char*)(0x427040A8UL))
#define bFM_MFS2_UART_SSR_ORE                 *((volatile unsigned char*)(0x427040ACUL))
#define bFM_MFS2_UART_SSR_FRE                 *((volatile unsigned char*)(0x427040B0UL))
#define bFM_MFS2_UART_SSR_PE                  *((volatile unsigned char*)(0x427040B4UL))
#define bFM_MFS2_UART_SSR_REC                 *((volatile unsigned char*)(0x427040BCUL))
#define bFM_MFS2_UART_BGR_EXT                 *((volatile unsigned char*)(0x427041BCUL))
#define bFM_MFS2_UART_BGR1_EXT                *((volatile unsigned char*)(0x427041BCUL))
#define bFM_MFS2_UART_FCR_FE1                 *((volatile unsigned char*)(0x42704280UL))
#define bFM_MFS2_UART_FCR_FE2                 *((volatile unsigned char*)(0x42704284UL))
#define bFM_MFS2_UART_FCR_FCL1                *((volatile unsigned char*)(0x42704288UL))
#define bFM_MFS2_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270428CUL))
#define bFM_MFS2_UART_FCR_FSET                *((volatile unsigned char*)(0x42704290UL))
#define bFM_MFS2_UART_FCR_FLD                 *((volatile unsigned char*)(0x42704294UL))
#define bFM_MFS2_UART_FCR_FLST                *((volatile unsigned char*)(0x42704298UL))
#define bFM_MFS2_UART_FCR_FSEL                *((volatile unsigned char*)(0x427042A0UL))
#define bFM_MFS2_UART_FCR_FTIE                *((volatile unsigned char*)(0x427042A4UL))
#define bFM_MFS2_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427042A8UL))
#define bFM_MFS2_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427042ACUL))
#define bFM_MFS2_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427042B0UL))
#define bFM_MFS2_UART_FCR0_FE1                *((volatile unsigned char*)(0x42704280UL))
#define bFM_MFS2_UART_FCR0_FE2                *((volatile unsigned char*)(0x42704284UL))
#define bFM_MFS2_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42704288UL))
#define bFM_MFS2_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270428CUL))
#define bFM_MFS2_UART_FCR0_FSET               *((volatile unsigned char*)(0x42704290UL))
#define bFM_MFS2_UART_FCR0_FLD                *((volatile unsigned char*)(0x42704294UL))
#define bFM_MFS2_UART_FCR0_FLST               *((volatile unsigned char*)(0x42704298UL))
#define bFM_MFS2_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427042A0UL))
#define bFM_MFS2_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427042A4UL))
#define bFM_MFS2_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427042A8UL))
#define bFM_MFS2_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427042ACUL))
#define bFM_MFS2_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427042B0UL))
#define bFM_MFS2_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42704300UL))
#define bFM_MFS2_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42704304UL))
#define bFM_MFS2_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42704308UL))
#define bFM_MFS2_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270430CUL))
#define bFM_MFS2_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42704310UL))
#define bFM_MFS2_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42704314UL))
#define bFM_MFS2_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42704318UL))
#define bFM_MFS2_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270431CUL))
#define bFM_MFS2_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42704320UL))
#define bFM_MFS2_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42704324UL))
#define bFM_MFS2_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42704328UL))
#define bFM_MFS2_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270432CUL))
#define bFM_MFS2_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42704330UL))
#define bFM_MFS2_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42704334UL))
#define bFM_MFS2_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42704338UL))
#define bFM_MFS2_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270433CUL))
#define bFM_MFS2_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42704300UL))
#define bFM_MFS2_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42704304UL))
#define bFM_MFS2_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42704308UL))
#define bFM_MFS2_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270430CUL))
#define bFM_MFS2_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42704310UL))
#define bFM_MFS2_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42704314UL))
#define bFM_MFS2_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42704318UL))
#define bFM_MFS2_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270431CUL))
#define bFM_MFS2_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42704320UL))
#define bFM_MFS2_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42704324UL))
#define bFM_MFS2_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42704328UL))
#define bFM_MFS2_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270432CUL))
#define bFM_MFS2_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42704330UL))
#define bFM_MFS2_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42704334UL))
#define bFM_MFS2_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42704338UL))
#define bFM_MFS2_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270433CUL))

/* MFS CSIO channel 2 registers */
#define bFM_MFS2_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42704000UL))
#define bFM_MFS2_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42704004UL))
#define bFM_MFS2_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42704008UL))
#define bFM_MFS2_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270400CUL))
#define bFM_MFS2_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42704014UL))
#define bFM_MFS2_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42704018UL))
#define bFM_MFS2_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270401CUL))
#define bFM_MFS2_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42704020UL))
#define bFM_MFS2_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42704024UL))
#define bFM_MFS2_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42704028UL))
#define bFM_MFS2_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270402CUL))
#define bFM_MFS2_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42704030UL))
#define bFM_MFS2_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42704034UL))
#define bFM_MFS2_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42704038UL))
#define bFM_MFS2_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270403CUL))
#define bFM_MFS2_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42704080UL))
#define bFM_MFS2_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42704084UL))
#define bFM_MFS2_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42704088UL))
#define bFM_MFS2_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270408CUL))
#define bFM_MFS2_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42704090UL))
#define bFM_MFS2_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42704094UL))
#define bFM_MFS2_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42704098UL))
#define bFM_MFS2_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270409CUL))
#define bFM_MFS2_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427040A0UL))
#define bFM_MFS2_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427040A4UL))
#define bFM_MFS2_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427040A8UL))
#define bFM_MFS2_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427040ACUL))
#define bFM_MFS2_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427040B0UL))
#define bFM_MFS2_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427040BCUL))
#define bFM_MFS2_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42704280UL))
#define bFM_MFS2_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42704284UL))
#define bFM_MFS2_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42704288UL))
#define bFM_MFS2_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270428CUL))
#define bFM_MFS2_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42704290UL))
#define bFM_MFS2_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42704294UL))
#define bFM_MFS2_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42704298UL))
#define bFM_MFS2_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427042A0UL))
#define bFM_MFS2_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427042A4UL))
#define bFM_MFS2_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427042A8UL))
#define bFM_MFS2_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427042ACUL))
#define bFM_MFS2_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427042B0UL))
#define bFM_MFS2_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42704280UL))
#define bFM_MFS2_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42704284UL))
#define bFM_MFS2_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42704288UL))
#define bFM_MFS2_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270428CUL))
#define bFM_MFS2_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42704290UL))
#define bFM_MFS2_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42704294UL))
#define bFM_MFS2_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42704298UL))
#define bFM_MFS2_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427042A0UL))
#define bFM_MFS2_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427042A4UL))
#define bFM_MFS2_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427042A8UL))
#define bFM_MFS2_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427042ACUL))
#define bFM_MFS2_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427042B0UL))
#define bFM_MFS2_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42704300UL))
#define bFM_MFS2_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42704304UL))
#define bFM_MFS2_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42704308UL))
#define bFM_MFS2_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270430CUL))
#define bFM_MFS2_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42704310UL))
#define bFM_MFS2_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42704314UL))
#define bFM_MFS2_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42704318UL))
#define bFM_MFS2_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270431CUL))
#define bFM_MFS2_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42704320UL))
#define bFM_MFS2_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42704324UL))
#define bFM_MFS2_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42704328UL))
#define bFM_MFS2_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270432CUL))
#define bFM_MFS2_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42704330UL))
#define bFM_MFS2_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42704334UL))
#define bFM_MFS2_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42704338UL))
#define bFM_MFS2_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270433CUL))
#define bFM_MFS2_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42704300UL))
#define bFM_MFS2_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42704304UL))
#define bFM_MFS2_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42704308UL))
#define bFM_MFS2_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270430CUL))
#define bFM_MFS2_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42704310UL))
#define bFM_MFS2_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42704314UL))
#define bFM_MFS2_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42704318UL))
#define bFM_MFS2_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270431CUL))
#define bFM_MFS2_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42704320UL))
#define bFM_MFS2_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42704324UL))
#define bFM_MFS2_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42704328UL))
#define bFM_MFS2_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270432CUL))
#define bFM_MFS2_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42704330UL))
#define bFM_MFS2_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42704334UL))
#define bFM_MFS2_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42704338UL))
#define bFM_MFS2_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270433CUL))
#define bFM_MFS2_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42704380UL))
#define bFM_MFS2_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42704384UL))
#define bFM_MFS2_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42704388UL))
#define bFM_MFS2_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270438CUL))
#define bFM_MFS2_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42704390UL))
#define bFM_MFS2_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42704394UL))
#define bFM_MFS2_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42704398UL))
#define bFM_MFS2_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270439CUL))
#define bFM_MFS2_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427043A0UL))
#define bFM_MFS2_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427043A4UL))
#define bFM_MFS2_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427043A8UL))
#define bFM_MFS2_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427043ACUL))
#define bFM_MFS2_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427043B0UL))
#define bFM_MFS2_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427043B4UL))
#define bFM_MFS2_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427043B8UL))
#define bFM_MFS2_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427043BCUL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42704400UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42704404UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42704408UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270440CUL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42704410UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42704414UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42704418UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270441CUL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42704420UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42704424UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42704428UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270442CUL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42704430UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42704434UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42704438UL))
#define bFM_MFS2_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270443CUL))
#define bFM_MFS2_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42704480UL))
#define bFM_MFS2_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42704484UL))
#define bFM_MFS2_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42704488UL))
#define bFM_MFS2_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270448CUL))
#define bFM_MFS2_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42704490UL))
#define bFM_MFS2_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42704498UL))
#define bFM_MFS2_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270449CUL))
#define bFM_MFS2_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427044A0UL))
#define bFM_MFS2_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427044ACUL))
#define bFM_MFS2_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427044B0UL))
#define bFM_MFS2_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427044B4UL))
#define bFM_MFS2_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42704500UL))
#define bFM_MFS2_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42704504UL))
#define bFM_MFS2_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42704508UL))
#define bFM_MFS2_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270450CUL))
#define bFM_MFS2_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42704510UL))
#define bFM_MFS2_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42704514UL))
#define bFM_MFS2_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42704518UL))
#define bFM_MFS2_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270451CUL))
#define bFM_MFS2_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42704520UL))
#define bFM_MFS2_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42704524UL))
#define bFM_MFS2_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42704528UL))
#define bFM_MFS2_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270452CUL))
#define bFM_MFS2_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42704530UL))
#define bFM_MFS2_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42704534UL))
#define bFM_MFS2_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42704538UL))
#define bFM_MFS2_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270453CUL))
#define bFM_MFS2_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42704580UL))
#define bFM_MFS2_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42704584UL))
#define bFM_MFS2_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42704588UL))
#define bFM_MFS2_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270458CUL))
#define bFM_MFS2_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42704590UL))
#define bFM_MFS2_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42704594UL))
#define bFM_MFS2_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42704598UL))
#define bFM_MFS2_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270459CUL))
#define bFM_MFS2_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427045A0UL))
#define bFM_MFS2_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427045A4UL))
#define bFM_MFS2_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427045A8UL))
#define bFM_MFS2_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427045ACUL))
#define bFM_MFS2_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427045B0UL))
#define bFM_MFS2_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427045B4UL))
#define bFM_MFS2_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427045B8UL))
#define bFM_MFS2_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427045BCUL))
#define bFM_MFS2_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42704600UL))
#define bFM_MFS2_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42704604UL))
#define bFM_MFS2_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42704608UL))
#define bFM_MFS2_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270460CUL))
#define bFM_MFS2_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42704610UL))
#define bFM_MFS2_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42704614UL))
#define bFM_MFS2_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42704618UL))
#define bFM_MFS2_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270461CUL))
#define bFM_MFS2_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42704620UL))
#define bFM_MFS2_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42704624UL))
#define bFM_MFS2_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42704628UL))
#define bFM_MFS2_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270462CUL))
#define bFM_MFS2_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42704630UL))
#define bFM_MFS2_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42704634UL))
#define bFM_MFS2_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42704638UL))
#define bFM_MFS2_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270463CUL))
#define bFM_MFS2_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42704680UL))
#define bFM_MFS2_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42704684UL))
#define bFM_MFS2_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42704688UL))
#define bFM_MFS2_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270468CUL))
#define bFM_MFS2_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42704690UL))
#define bFM_MFS2_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42704694UL))
#define bFM_MFS2_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42704698UL))
#define bFM_MFS2_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270469CUL))
#define bFM_MFS2_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427046A0UL))
#define bFM_MFS2_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427046A4UL))
#define bFM_MFS2_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427046A8UL))
#define bFM_MFS2_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427046ACUL))
#define bFM_MFS2_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427046B0UL))
#define bFM_MFS2_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427046B4UL))
#define bFM_MFS2_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427046B8UL))
#define bFM_MFS2_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427046BCUL))
#define bFM_MFS2_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42704700UL))
#define bFM_MFS2_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42704704UL))
#define bFM_MFS2_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42704708UL))
#define bFM_MFS2_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270470CUL))
#define bFM_MFS2_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42704710UL))
#define bFM_MFS2_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42704714UL))
#define bFM_MFS2_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42704718UL))
#define bFM_MFS2_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270471CUL))


/* MFS LIN channel 2 registers */
#define bFM_MFS2_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42704000UL))
#define bFM_MFS2_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270400CUL))
#define bFM_MFS2_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42704010UL))
#define bFM_MFS2_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42704014UL))
#define bFM_MFS2_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42704018UL))
#define bFM_MFS2_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270401CUL))
#define bFM_MFS2_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42704020UL))
#define bFM_MFS2_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42704024UL))
#define bFM_MFS2_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42704028UL))
#define bFM_MFS2_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270402CUL))
#define bFM_MFS2_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42704030UL))
#define bFM_MFS2_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42704034UL))
#define bFM_MFS2_LIN_SCR_MS                   *((volatile unsigned char*)(0x42704038UL))
#define bFM_MFS2_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270403CUL))
#define bFM_MFS2_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42704080UL))
#define bFM_MFS2_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42704084UL))
#define bFM_MFS2_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42704088UL))
#define bFM_MFS2_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270408CUL))
#define bFM_MFS2_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42704090UL))
#define bFM_MFS2_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42704098UL))
#define bFM_MFS2_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427040A0UL))
#define bFM_MFS2_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427040A4UL))
#define bFM_MFS2_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427040A8UL))
#define bFM_MFS2_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427040ACUL))
#define bFM_MFS2_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427040B0UL))
#define bFM_MFS2_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427040B4UL))
#define bFM_MFS2_LIN_SSR_REC                  *((volatile unsigned char*)(0x427040BCUL))
#define bFM_MFS2_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427041BCUL))
#define bFM_MFS2_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427041BCUL))
#define bFM_MFS2_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42704280UL))
#define bFM_MFS2_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42704284UL))
#define bFM_MFS2_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42704288UL))
#define bFM_MFS2_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270428CUL))
#define bFM_MFS2_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42704290UL))
#define bFM_MFS2_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42704294UL))
#define bFM_MFS2_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42704298UL))
#define bFM_MFS2_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427042A0UL))
#define bFM_MFS2_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427042A4UL))
#define bFM_MFS2_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427042A8UL))
#define bFM_MFS2_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427042ACUL))
#define bFM_MFS2_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427042B0UL))
#define bFM_MFS2_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42704280UL))
#define bFM_MFS2_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42704284UL))
#define bFM_MFS2_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42704288UL))
#define bFM_MFS2_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270428CUL))
#define bFM_MFS2_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42704290UL))
#define bFM_MFS2_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42704294UL))
#define bFM_MFS2_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42704298UL))
#define bFM_MFS2_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427042A0UL))
#define bFM_MFS2_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427042A4UL))
#define bFM_MFS2_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427042A8UL))
#define bFM_MFS2_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427042ACUL))
#define bFM_MFS2_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427042B0UL))
#define bFM_MFS2_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42704300UL))
#define bFM_MFS2_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42704304UL))
#define bFM_MFS2_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42704308UL))
#define bFM_MFS2_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270430CUL))
#define bFM_MFS2_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42704310UL))
#define bFM_MFS2_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42704314UL))
#define bFM_MFS2_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42704318UL))
#define bFM_MFS2_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270431CUL))
#define bFM_MFS2_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42704320UL))
#define bFM_MFS2_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42704324UL))
#define bFM_MFS2_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42704328UL))
#define bFM_MFS2_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270432CUL))
#define bFM_MFS2_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42704330UL))
#define bFM_MFS2_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42704334UL))
#define bFM_MFS2_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42704338UL))
#define bFM_MFS2_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270433CUL))
#define bFM_MFS2_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42704300UL))
#define bFM_MFS2_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42704304UL))
#define bFM_MFS2_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42704308UL))
#define bFM_MFS2_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270430CUL))
#define bFM_MFS2_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42704310UL))
#define bFM_MFS2_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42704314UL))
#define bFM_MFS2_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42704318UL))
#define bFM_MFS2_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270431CUL))
#define bFM_MFS2_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42704320UL))
#define bFM_MFS2_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42704324UL))
#define bFM_MFS2_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42704328UL))
#define bFM_MFS2_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270432CUL))
#define bFM_MFS2_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42704330UL))
#define bFM_MFS2_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42704334UL))
#define bFM_MFS2_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42704338UL))
#define bFM_MFS2_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270433CUL))

/* MFS I2C channel 2 registers */
#define bFM_MFS2_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42704008UL))
#define bFM_MFS2_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270400CUL))
#define bFM_MFS2_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42704014UL))
#define bFM_MFS2_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42704018UL))
#define bFM_MFS2_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270401CUL))
#define bFM_MFS2_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42704020UL))
#define bFM_MFS2_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42704024UL))
#define bFM_MFS2_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42704028UL))
#define bFM_MFS2_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270402CUL))
#define bFM_MFS2_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42704030UL))
#define bFM_MFS2_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42704034UL))
#define bFM_MFS2_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42704038UL))
#define bFM_MFS2_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42704038UL))
#define bFM_MFS2_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270403CUL))
#define bFM_MFS2_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42704080UL))
#define bFM_MFS2_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42704084UL))
#define bFM_MFS2_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42704088UL))
#define bFM_MFS2_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270408CUL))
#define bFM_MFS2_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42704090UL))
#define bFM_MFS2_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42704094UL))
#define bFM_MFS2_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42704098UL))
#define bFM_MFS2_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270409CUL))
#define bFM_MFS2_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427040A0UL))
#define bFM_MFS2_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427040A4UL))
#define bFM_MFS2_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427040A8UL))
#define bFM_MFS2_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427040ACUL))
#define bFM_MFS2_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427040B0UL))
#define bFM_MFS2_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427040B4UL))
#define bFM_MFS2_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427040B8UL))
#define bFM_MFS2_I2C_SSR_REC                  *((volatile unsigned char*)(0x427040BCUL))
#define bFM_MFS2_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42704200UL))
#define bFM_MFS2_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42704204UL))
#define bFM_MFS2_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42704208UL))
#define bFM_MFS2_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270420CUL))
#define bFM_MFS2_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42704210UL))
#define bFM_MFS2_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42704214UL))
#define bFM_MFS2_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42704218UL))
#define bFM_MFS2_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270421CUL))
#define bFM_MFS2_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42704220UL))
#define bFM_MFS2_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42704224UL))
#define bFM_MFS2_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42704228UL))
#define bFM_MFS2_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270422CUL))
#define bFM_MFS2_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42704230UL))
#define bFM_MFS2_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42704234UL))
#define bFM_MFS2_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42704238UL))
#define bFM_MFS2_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270423CUL))
#define bFM_MFS2_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42704280UL))
#define bFM_MFS2_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42704284UL))
#define bFM_MFS2_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42704288UL))
#define bFM_MFS2_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270428CUL))
#define bFM_MFS2_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42704290UL))
#define bFM_MFS2_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42704294UL))
#define bFM_MFS2_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42704298UL))
#define bFM_MFS2_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427042A0UL))
#define bFM_MFS2_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427042A4UL))
#define bFM_MFS2_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427042A8UL))
#define bFM_MFS2_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427042ACUL))
#define bFM_MFS2_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427042B0UL))
#define bFM_MFS2_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42704280UL))
#define bFM_MFS2_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42704284UL))
#define bFM_MFS2_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42704288UL))
#define bFM_MFS2_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270428CUL))
#define bFM_MFS2_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42704290UL))
#define bFM_MFS2_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42704294UL))
#define bFM_MFS2_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42704298UL))
#define bFM_MFS2_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427042A0UL))
#define bFM_MFS2_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427042A4UL))
#define bFM_MFS2_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427042A8UL))
#define bFM_MFS2_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427042ACUL))
#define bFM_MFS2_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427042B0UL))
#define bFM_MFS2_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42704300UL))
#define bFM_MFS2_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42704304UL))
#define bFM_MFS2_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42704308UL))
#define bFM_MFS2_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270430CUL))
#define bFM_MFS2_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42704310UL))
#define bFM_MFS2_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42704314UL))
#define bFM_MFS2_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42704318UL))
#define bFM_MFS2_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270431CUL))
#define bFM_MFS2_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42704320UL))
#define bFM_MFS2_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42704324UL))
#define bFM_MFS2_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42704328UL))
#define bFM_MFS2_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270432CUL))
#define bFM_MFS2_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42704330UL))
#define bFM_MFS2_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42704334UL))
#define bFM_MFS2_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42704338UL))
#define bFM_MFS2_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270433CUL))
#define bFM_MFS2_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42704300UL))
#define bFM_MFS2_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42704304UL))
#define bFM_MFS2_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42704308UL))
#define bFM_MFS2_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270430CUL))
#define bFM_MFS2_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42704310UL))
#define bFM_MFS2_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42704314UL))
#define bFM_MFS2_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42704318UL))
#define bFM_MFS2_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270431CUL))
#define bFM_MFS2_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42704320UL))
#define bFM_MFS2_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42704324UL))
#define bFM_MFS2_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42704328UL))
#define bFM_MFS2_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270432CUL))
#define bFM_MFS2_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42704330UL))
#define bFM_MFS2_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42704334UL))
#define bFM_MFS2_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42704338UL))
#define bFM_MFS2_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270433CUL))

/* MFS UART channel 3 registers */
#define bFM_MFS3_UART_SMR_SOE                 *((volatile unsigned char*)(0x42706000UL))
#define bFM_MFS3_UART_SMR_BDS                 *((volatile unsigned char*)(0x42706008UL))
#define bFM_MFS3_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270600CUL))
#define bFM_MFS3_UART_SMR_WUCR                *((volatile unsigned char*)(0x42706010UL))
#define bFM_MFS3_UART_SMR_MD0                 *((volatile unsigned char*)(0x42706014UL))
#define bFM_MFS3_UART_SMR_MD1                 *((volatile unsigned char*)(0x42706018UL))
#define bFM_MFS3_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270601CUL))
#define bFM_MFS3_UART_SCR_TXE                 *((volatile unsigned char*)(0x42706020UL))
#define bFM_MFS3_UART_SCR_RXE                 *((volatile unsigned char*)(0x42706024UL))
#define bFM_MFS3_UART_SCR_TBIE                *((volatile unsigned char*)(0x42706028UL))
#define bFM_MFS3_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270602CUL))
#define bFM_MFS3_UART_SCR_RIE                 *((volatile unsigned char*)(0x42706030UL))
#define bFM_MFS3_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270603CUL))
#define bFM_MFS3_UART_ESCR_L0                 *((volatile unsigned char*)(0x42706080UL))
#define bFM_MFS3_UART_ESCR_L1                 *((volatile unsigned char*)(0x42706084UL))
#define bFM_MFS3_UART_ESCR_L2                 *((volatile unsigned char*)(0x42706088UL))
#define bFM_MFS3_UART_ESCR_P                  *((volatile unsigned char*)(0x4270608CUL))
#define bFM_MFS3_UART_ESCR_PEN                *((volatile unsigned char*)(0x42706090UL))
#define bFM_MFS3_UART_ESCR_INV                *((volatile unsigned char*)(0x42706094UL))
#define bFM_MFS3_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42706098UL))
#define bFM_MFS3_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270609CUL))
#define bFM_MFS3_UART_SSR_TBI                 *((volatile unsigned char*)(0x427060A0UL))
#define bFM_MFS3_UART_SSR_TDRE                *((volatile unsigned char*)(0x427060A4UL))
#define bFM_MFS3_UART_SSR_RDRF                *((volatile unsigned char*)(0x427060A8UL))
#define bFM_MFS3_UART_SSR_ORE                 *((volatile unsigned char*)(0x427060ACUL))
#define bFM_MFS3_UART_SSR_FRE                 *((volatile unsigned char*)(0x427060B0UL))
#define bFM_MFS3_UART_SSR_PE                  *((volatile unsigned char*)(0x427060B4UL))
#define bFM_MFS3_UART_SSR_REC                 *((volatile unsigned char*)(0x427060BCUL))
#define bFM_MFS3_UART_BGR_EXT                 *((volatile unsigned char*)(0x427061BCUL))
#define bFM_MFS3_UART_BGR1_EXT                *((volatile unsigned char*)(0x427061BCUL))
#define bFM_MFS3_UART_FCR_FE1                 *((volatile unsigned char*)(0x42706280UL))
#define bFM_MFS3_UART_FCR_FE2                 *((volatile unsigned char*)(0x42706284UL))
#define bFM_MFS3_UART_FCR_FCL1                *((volatile unsigned char*)(0x42706288UL))
#define bFM_MFS3_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270628CUL))
#define bFM_MFS3_UART_FCR_FSET                *((volatile unsigned char*)(0x42706290UL))
#define bFM_MFS3_UART_FCR_FLD                 *((volatile unsigned char*)(0x42706294UL))
#define bFM_MFS3_UART_FCR_FLST                *((volatile unsigned char*)(0x42706298UL))
#define bFM_MFS3_UART_FCR_FSEL                *((volatile unsigned char*)(0x427062A0UL))
#define bFM_MFS3_UART_FCR_FTIE                *((volatile unsigned char*)(0x427062A4UL))
#define bFM_MFS3_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427062A8UL))
#define bFM_MFS3_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427062ACUL))
#define bFM_MFS3_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427062B0UL))
#define bFM_MFS3_UART_FCR0_FE1                *((volatile unsigned char*)(0x42706280UL))
#define bFM_MFS3_UART_FCR0_FE2                *((volatile unsigned char*)(0x42706284UL))
#define bFM_MFS3_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42706288UL))
#define bFM_MFS3_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270628CUL))
#define bFM_MFS3_UART_FCR0_FSET               *((volatile unsigned char*)(0x42706290UL))
#define bFM_MFS3_UART_FCR0_FLD                *((volatile unsigned char*)(0x42706294UL))
#define bFM_MFS3_UART_FCR0_FLST               *((volatile unsigned char*)(0x42706298UL))
#define bFM_MFS3_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427062A0UL))
#define bFM_MFS3_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427062A4UL))
#define bFM_MFS3_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427062A8UL))
#define bFM_MFS3_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427062ACUL))
#define bFM_MFS3_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427062B0UL))
#define bFM_MFS3_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42706300UL))
#define bFM_MFS3_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42706304UL))
#define bFM_MFS3_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42706308UL))
#define bFM_MFS3_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270630CUL))
#define bFM_MFS3_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42706310UL))
#define bFM_MFS3_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42706314UL))
#define bFM_MFS3_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42706318UL))
#define bFM_MFS3_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270631CUL))
#define bFM_MFS3_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42706320UL))
#define bFM_MFS3_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42706324UL))
#define bFM_MFS3_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42706328UL))
#define bFM_MFS3_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270632CUL))
#define bFM_MFS3_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42706330UL))
#define bFM_MFS3_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42706334UL))
#define bFM_MFS3_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42706338UL))
#define bFM_MFS3_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270633CUL))
#define bFM_MFS3_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42706300UL))
#define bFM_MFS3_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42706304UL))
#define bFM_MFS3_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42706308UL))
#define bFM_MFS3_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270630CUL))
#define bFM_MFS3_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42706310UL))
#define bFM_MFS3_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42706314UL))
#define bFM_MFS3_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42706318UL))
#define bFM_MFS3_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270631CUL))
#define bFM_MFS3_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42706320UL))
#define bFM_MFS3_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42706324UL))
#define bFM_MFS3_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42706328UL))
#define bFM_MFS3_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270632CUL))
#define bFM_MFS3_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42706330UL))
#define bFM_MFS3_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42706334UL))
#define bFM_MFS3_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42706338UL))
#define bFM_MFS3_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270633CUL))

/* MFS CSIO channel 3 registers */
#define bFM_MFS3_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42706000UL))
#define bFM_MFS3_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42706004UL))
#define bFM_MFS3_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42706008UL))
#define bFM_MFS3_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270600CUL))
#define bFM_MFS3_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42706014UL))
#define bFM_MFS3_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42706018UL))
#define bFM_MFS3_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270601CUL))
#define bFM_MFS3_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42706020UL))
#define bFM_MFS3_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42706024UL))
#define bFM_MFS3_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42706028UL))
#define bFM_MFS3_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270602CUL))
#define bFM_MFS3_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42706030UL))
#define bFM_MFS3_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42706034UL))
#define bFM_MFS3_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42706038UL))
#define bFM_MFS3_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270603CUL))
#define bFM_MFS3_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42706080UL))
#define bFM_MFS3_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42706084UL))
#define bFM_MFS3_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42706088UL))
#define bFM_MFS3_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270608CUL))
#define bFM_MFS3_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42706090UL))
#define bFM_MFS3_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42706094UL))
#define bFM_MFS3_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42706098UL))
#define bFM_MFS3_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270609CUL))
#define bFM_MFS3_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427060A0UL))
#define bFM_MFS3_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427060A4UL))
#define bFM_MFS3_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427060A8UL))
#define bFM_MFS3_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427060ACUL))
#define bFM_MFS3_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427060B0UL))
#define bFM_MFS3_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427060BCUL))
#define bFM_MFS3_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42706280UL))
#define bFM_MFS3_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42706284UL))
#define bFM_MFS3_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42706288UL))
#define bFM_MFS3_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270628CUL))
#define bFM_MFS3_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42706290UL))
#define bFM_MFS3_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42706294UL))
#define bFM_MFS3_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42706298UL))
#define bFM_MFS3_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427062A0UL))
#define bFM_MFS3_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427062A4UL))
#define bFM_MFS3_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427062A8UL))
#define bFM_MFS3_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427062ACUL))
#define bFM_MFS3_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427062B0UL))
#define bFM_MFS3_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42706280UL))
#define bFM_MFS3_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42706284UL))
#define bFM_MFS3_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42706288UL))
#define bFM_MFS3_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270628CUL))
#define bFM_MFS3_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42706290UL))
#define bFM_MFS3_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42706294UL))
#define bFM_MFS3_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42706298UL))
#define bFM_MFS3_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427062A0UL))
#define bFM_MFS3_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427062A4UL))
#define bFM_MFS3_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427062A8UL))
#define bFM_MFS3_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427062ACUL))
#define bFM_MFS3_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427062B0UL))
#define bFM_MFS3_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42706300UL))
#define bFM_MFS3_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42706304UL))
#define bFM_MFS3_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42706308UL))
#define bFM_MFS3_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270630CUL))
#define bFM_MFS3_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42706310UL))
#define bFM_MFS3_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42706314UL))
#define bFM_MFS3_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42706318UL))
#define bFM_MFS3_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270631CUL))
#define bFM_MFS3_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42706320UL))
#define bFM_MFS3_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42706324UL))
#define bFM_MFS3_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42706328UL))
#define bFM_MFS3_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270632CUL))
#define bFM_MFS3_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42706330UL))
#define bFM_MFS3_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42706334UL))
#define bFM_MFS3_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42706338UL))
#define bFM_MFS3_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270633CUL))
#define bFM_MFS3_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42706300UL))
#define bFM_MFS3_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42706304UL))
#define bFM_MFS3_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42706308UL))
#define bFM_MFS3_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270630CUL))
#define bFM_MFS3_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42706310UL))
#define bFM_MFS3_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42706314UL))
#define bFM_MFS3_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42706318UL))
#define bFM_MFS3_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270631CUL))
#define bFM_MFS3_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42706320UL))
#define bFM_MFS3_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42706324UL))
#define bFM_MFS3_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42706328UL))
#define bFM_MFS3_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270632CUL))
#define bFM_MFS3_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42706330UL))
#define bFM_MFS3_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42706334UL))
#define bFM_MFS3_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42706338UL))
#define bFM_MFS3_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270633CUL))
#define bFM_MFS3_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42706380UL))
#define bFM_MFS3_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42706384UL))
#define bFM_MFS3_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42706388UL))
#define bFM_MFS3_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270638CUL))
#define bFM_MFS3_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42706390UL))
#define bFM_MFS3_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42706394UL))
#define bFM_MFS3_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42706398UL))
#define bFM_MFS3_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270639CUL))
#define bFM_MFS3_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427063A0UL))
#define bFM_MFS3_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427063A4UL))
#define bFM_MFS3_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427063A8UL))
#define bFM_MFS3_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427063ACUL))
#define bFM_MFS3_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427063B0UL))
#define bFM_MFS3_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427063B4UL))
#define bFM_MFS3_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427063B8UL))
#define bFM_MFS3_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427063BCUL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42706400UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42706404UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42706408UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270640CUL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42706410UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42706414UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42706418UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270641CUL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42706420UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42706424UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42706428UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270642CUL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42706430UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42706434UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42706438UL))
#define bFM_MFS3_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270643CUL))
#define bFM_MFS3_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42706480UL))
#define bFM_MFS3_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42706484UL))
#define bFM_MFS3_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42706488UL))
#define bFM_MFS3_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270648CUL))
#define bFM_MFS3_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42706490UL))
#define bFM_MFS3_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42706498UL))
#define bFM_MFS3_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270649CUL))
#define bFM_MFS3_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427064A0UL))
#define bFM_MFS3_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427064ACUL))
#define bFM_MFS3_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427064B0UL))
#define bFM_MFS3_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427064B4UL))
#define bFM_MFS3_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42706500UL))
#define bFM_MFS3_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42706504UL))
#define bFM_MFS3_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42706508UL))
#define bFM_MFS3_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270650CUL))
#define bFM_MFS3_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42706510UL))
#define bFM_MFS3_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42706514UL))
#define bFM_MFS3_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42706518UL))
#define bFM_MFS3_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270651CUL))
#define bFM_MFS3_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42706520UL))
#define bFM_MFS3_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42706524UL))
#define bFM_MFS3_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42706528UL))
#define bFM_MFS3_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270652CUL))
#define bFM_MFS3_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42706530UL))
#define bFM_MFS3_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42706534UL))
#define bFM_MFS3_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42706538UL))
#define bFM_MFS3_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270653CUL))
#define bFM_MFS3_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42706580UL))
#define bFM_MFS3_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42706584UL))
#define bFM_MFS3_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42706588UL))
#define bFM_MFS3_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270658CUL))
#define bFM_MFS3_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42706590UL))
#define bFM_MFS3_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42706594UL))
#define bFM_MFS3_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42706598UL))
#define bFM_MFS3_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270659CUL))
#define bFM_MFS3_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427065A0UL))
#define bFM_MFS3_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427065A4UL))
#define bFM_MFS3_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427065A8UL))
#define bFM_MFS3_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427065ACUL))
#define bFM_MFS3_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427065B0UL))
#define bFM_MFS3_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427065B4UL))
#define bFM_MFS3_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427065B8UL))
#define bFM_MFS3_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427065BCUL))
#define bFM_MFS3_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42706600UL))
#define bFM_MFS3_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42706604UL))
#define bFM_MFS3_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42706608UL))
#define bFM_MFS3_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270660CUL))
#define bFM_MFS3_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42706610UL))
#define bFM_MFS3_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42706614UL))
#define bFM_MFS3_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42706618UL))
#define bFM_MFS3_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270661CUL))
#define bFM_MFS3_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42706620UL))
#define bFM_MFS3_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42706624UL))
#define bFM_MFS3_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42706628UL))
#define bFM_MFS3_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270662CUL))
#define bFM_MFS3_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42706630UL))
#define bFM_MFS3_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42706634UL))
#define bFM_MFS3_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42706638UL))
#define bFM_MFS3_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270663CUL))
#define bFM_MFS3_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42706680UL))
#define bFM_MFS3_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42706684UL))
#define bFM_MFS3_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42706688UL))
#define bFM_MFS3_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270668CUL))
#define bFM_MFS3_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42706690UL))
#define bFM_MFS3_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42706694UL))
#define bFM_MFS3_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42706698UL))
#define bFM_MFS3_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270669CUL))
#define bFM_MFS3_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427066A0UL))
#define bFM_MFS3_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427066A4UL))
#define bFM_MFS3_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427066A8UL))
#define bFM_MFS3_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427066ACUL))
#define bFM_MFS3_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427066B0UL))
#define bFM_MFS3_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427066B4UL))
#define bFM_MFS3_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427066B8UL))
#define bFM_MFS3_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427066BCUL))
#define bFM_MFS3_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42706700UL))
#define bFM_MFS3_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42706704UL))
#define bFM_MFS3_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42706708UL))
#define bFM_MFS3_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270670CUL))
#define bFM_MFS3_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42706710UL))
#define bFM_MFS3_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42706714UL))
#define bFM_MFS3_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42706718UL))
#define bFM_MFS3_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270671CUL))

/* MFS LIN channel 3 registers */
#define bFM_MFS3_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42706000UL))
#define bFM_MFS3_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270600CUL))
#define bFM_MFS3_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42706010UL))
#define bFM_MFS3_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42706014UL))
#define bFM_MFS3_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42706018UL))
#define bFM_MFS3_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270601CUL))
#define bFM_MFS3_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42706020UL))
#define bFM_MFS3_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42706024UL))
#define bFM_MFS3_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42706028UL))
#define bFM_MFS3_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270602CUL))
#define bFM_MFS3_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42706030UL))
#define bFM_MFS3_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42706034UL))
#define bFM_MFS3_LIN_SCR_MS                   *((volatile unsigned char*)(0x42706038UL))
#define bFM_MFS3_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270603CUL))
#define bFM_MFS3_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42706080UL))
#define bFM_MFS3_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42706084UL))
#define bFM_MFS3_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42706088UL))
#define bFM_MFS3_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270608CUL))
#define bFM_MFS3_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42706090UL))
#define bFM_MFS3_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42706098UL))
#define bFM_MFS3_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427060A0UL))
#define bFM_MFS3_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427060A4UL))
#define bFM_MFS3_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427060A8UL))
#define bFM_MFS3_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427060ACUL))
#define bFM_MFS3_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427060B0UL))
#define bFM_MFS3_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427060B4UL))
#define bFM_MFS3_LIN_SSR_REC                  *((volatile unsigned char*)(0x427060BCUL))
#define bFM_MFS3_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427061BCUL))
#define bFM_MFS3_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427061BCUL))
#define bFM_MFS3_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42706280UL))
#define bFM_MFS3_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42706284UL))
#define bFM_MFS3_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42706288UL))
#define bFM_MFS3_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270628CUL))
#define bFM_MFS3_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42706290UL))
#define bFM_MFS3_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42706294UL))
#define bFM_MFS3_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42706298UL))
#define bFM_MFS3_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427062A0UL))
#define bFM_MFS3_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427062A4UL))
#define bFM_MFS3_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427062A8UL))
#define bFM_MFS3_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427062ACUL))
#define bFM_MFS3_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427062B0UL))
#define bFM_MFS3_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42706280UL))
#define bFM_MFS3_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42706284UL))
#define bFM_MFS3_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42706288UL))
#define bFM_MFS3_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270628CUL))
#define bFM_MFS3_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42706290UL))
#define bFM_MFS3_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42706294UL))
#define bFM_MFS3_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42706298UL))
#define bFM_MFS3_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427062A0UL))
#define bFM_MFS3_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427062A4UL))
#define bFM_MFS3_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427062A8UL))
#define bFM_MFS3_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427062ACUL))
#define bFM_MFS3_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427062B0UL))
#define bFM_MFS3_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42706300UL))
#define bFM_MFS3_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42706304UL))
#define bFM_MFS3_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42706308UL))
#define bFM_MFS3_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270630CUL))
#define bFM_MFS3_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42706310UL))
#define bFM_MFS3_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42706314UL))
#define bFM_MFS3_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42706318UL))
#define bFM_MFS3_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270631CUL))
#define bFM_MFS3_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42706320UL))
#define bFM_MFS3_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42706324UL))
#define bFM_MFS3_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42706328UL))
#define bFM_MFS3_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270632CUL))
#define bFM_MFS3_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42706330UL))
#define bFM_MFS3_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42706334UL))
#define bFM_MFS3_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42706338UL))
#define bFM_MFS3_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270633CUL))
#define bFM_MFS3_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42706300UL))
#define bFM_MFS3_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42706304UL))
#define bFM_MFS3_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42706308UL))
#define bFM_MFS3_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270630CUL))
#define bFM_MFS3_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42706310UL))
#define bFM_MFS3_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42706314UL))
#define bFM_MFS3_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42706318UL))
#define bFM_MFS3_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270631CUL))
#define bFM_MFS3_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42706320UL))
#define bFM_MFS3_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42706324UL))
#define bFM_MFS3_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42706328UL))
#define bFM_MFS3_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270632CUL))
#define bFM_MFS3_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42706330UL))
#define bFM_MFS3_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42706334UL))
#define bFM_MFS3_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42706338UL))
#define bFM_MFS3_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270633CUL))

/* MFS I2C channel 3 registers */
#define bFM_MFS3_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42706008UL))
#define bFM_MFS3_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270600CUL))
#define bFM_MFS3_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42706014UL))
#define bFM_MFS3_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42706018UL))
#define bFM_MFS3_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270601CUL))
#define bFM_MFS3_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42706020UL))
#define bFM_MFS3_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42706024UL))
#define bFM_MFS3_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42706028UL))
#define bFM_MFS3_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270602CUL))
#define bFM_MFS3_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42706030UL))
#define bFM_MFS3_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42706034UL))
#define bFM_MFS3_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42706038UL))
#define bFM_MFS3_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42706038UL))
#define bFM_MFS3_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270603CUL))
#define bFM_MFS3_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42706080UL))
#define bFM_MFS3_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42706084UL))
#define bFM_MFS3_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42706088UL))
#define bFM_MFS3_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270608CUL))
#define bFM_MFS3_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42706090UL))
#define bFM_MFS3_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42706094UL))
#define bFM_MFS3_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42706098UL))
#define bFM_MFS3_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270609CUL))
#define bFM_MFS3_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427060A0UL))
#define bFM_MFS3_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427060A4UL))
#define bFM_MFS3_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427060A8UL))
#define bFM_MFS3_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427060ACUL))
#define bFM_MFS3_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427060B0UL))
#define bFM_MFS3_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427060B4UL))
#define bFM_MFS3_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427060B8UL))
#define bFM_MFS3_I2C_SSR_REC                  *((volatile unsigned char*)(0x427060BCUL))
#define bFM_MFS3_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42706200UL))
#define bFM_MFS3_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42706204UL))
#define bFM_MFS3_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42706208UL))
#define bFM_MFS3_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270620CUL))
#define bFM_MFS3_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42706210UL))
#define bFM_MFS3_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42706214UL))
#define bFM_MFS3_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42706218UL))
#define bFM_MFS3_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270621CUL))
#define bFM_MFS3_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42706220UL))
#define bFM_MFS3_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42706224UL))
#define bFM_MFS3_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42706228UL))
#define bFM_MFS3_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270622CUL))
#define bFM_MFS3_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42706230UL))
#define bFM_MFS3_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42706234UL))
#define bFM_MFS3_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42706238UL))
#define bFM_MFS3_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270623CUL))
#define bFM_MFS3_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42706280UL))
#define bFM_MFS3_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42706284UL))
#define bFM_MFS3_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42706288UL))
#define bFM_MFS3_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270628CUL))
#define bFM_MFS3_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42706290UL))
#define bFM_MFS3_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42706294UL))
#define bFM_MFS3_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42706298UL))
#define bFM_MFS3_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427062A0UL))
#define bFM_MFS3_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427062A4UL))
#define bFM_MFS3_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427062A8UL))
#define bFM_MFS3_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427062ACUL))
#define bFM_MFS3_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427062B0UL))
#define bFM_MFS3_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42706280UL))
#define bFM_MFS3_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42706284UL))
#define bFM_MFS3_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42706288UL))
#define bFM_MFS3_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270628CUL))
#define bFM_MFS3_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42706290UL))
#define bFM_MFS3_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42706294UL))
#define bFM_MFS3_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42706298UL))
#define bFM_MFS3_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427062A0UL))
#define bFM_MFS3_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427062A4UL))
#define bFM_MFS3_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427062A8UL))
#define bFM_MFS3_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427062ACUL))
#define bFM_MFS3_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427062B0UL))
#define bFM_MFS3_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42706300UL))
#define bFM_MFS3_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42706304UL))
#define bFM_MFS3_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42706308UL))
#define bFM_MFS3_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270630CUL))
#define bFM_MFS3_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42706310UL))
#define bFM_MFS3_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42706314UL))
#define bFM_MFS3_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42706318UL))
#define bFM_MFS3_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270631CUL))
#define bFM_MFS3_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42706320UL))
#define bFM_MFS3_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42706324UL))
#define bFM_MFS3_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42706328UL))
#define bFM_MFS3_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270632CUL))
#define bFM_MFS3_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42706330UL))
#define bFM_MFS3_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42706334UL))
#define bFM_MFS3_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42706338UL))
#define bFM_MFS3_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270633CUL))
#define bFM_MFS3_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42706300UL))
#define bFM_MFS3_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42706304UL))
#define bFM_MFS3_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42706308UL))
#define bFM_MFS3_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270630CUL))
#define bFM_MFS3_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42706310UL))
#define bFM_MFS3_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42706314UL))
#define bFM_MFS3_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42706318UL))
#define bFM_MFS3_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270631CUL))
#define bFM_MFS3_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42706320UL))
#define bFM_MFS3_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42706324UL))
#define bFM_MFS3_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42706328UL))
#define bFM_MFS3_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270632CUL))
#define bFM_MFS3_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42706330UL))
#define bFM_MFS3_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42706334UL))
#define bFM_MFS3_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42706338UL))
#define bFM_MFS3_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270633CUL))

/* MFS UART channel 4 registers */
#define bFM_MFS4_UART_SMR_SOE                 *((volatile unsigned char*)(0x42708000UL))
#define bFM_MFS4_UART_SMR_BDS                 *((volatile unsigned char*)(0x42708008UL))
#define bFM_MFS4_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270800CUL))
#define bFM_MFS4_UART_SMR_WUCR                *((volatile unsigned char*)(0x42708010UL))
#define bFM_MFS4_UART_SMR_MD0                 *((volatile unsigned char*)(0x42708014UL))
#define bFM_MFS4_UART_SMR_MD1                 *((volatile unsigned char*)(0x42708018UL))
#define bFM_MFS4_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270801CUL))
#define bFM_MFS4_UART_SCR_TXE                 *((volatile unsigned char*)(0x42708020UL))
#define bFM_MFS4_UART_SCR_RXE                 *((volatile unsigned char*)(0x42708024UL))
#define bFM_MFS4_UART_SCR_TBIE                *((volatile unsigned char*)(0x42708028UL))
#define bFM_MFS4_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270802CUL))
#define bFM_MFS4_UART_SCR_RIE                 *((volatile unsigned char*)(0x42708030UL))
#define bFM_MFS4_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270803CUL))
#define bFM_MFS4_UART_ESCR_L0                 *((volatile unsigned char*)(0x42708080UL))
#define bFM_MFS4_UART_ESCR_L1                 *((volatile unsigned char*)(0x42708084UL))
#define bFM_MFS4_UART_ESCR_L2                 *((volatile unsigned char*)(0x42708088UL))
#define bFM_MFS4_UART_ESCR_P                  *((volatile unsigned char*)(0x4270808CUL))
#define bFM_MFS4_UART_ESCR_PEN                *((volatile unsigned char*)(0x42708090UL))
#define bFM_MFS4_UART_ESCR_INV                *((volatile unsigned char*)(0x42708094UL))
#define bFM_MFS4_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42708098UL))
#define bFM_MFS4_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270809CUL))
#define bFM_MFS4_UART_SSR_TBI                 *((volatile unsigned char*)(0x427080A0UL))
#define bFM_MFS4_UART_SSR_TDRE                *((volatile unsigned char*)(0x427080A4UL))
#define bFM_MFS4_UART_SSR_RDRF                *((volatile unsigned char*)(0x427080A8UL))
#define bFM_MFS4_UART_SSR_ORE                 *((volatile unsigned char*)(0x427080ACUL))
#define bFM_MFS4_UART_SSR_FRE                 *((volatile unsigned char*)(0x427080B0UL))
#define bFM_MFS4_UART_SSR_PE                  *((volatile unsigned char*)(0x427080B4UL))
#define bFM_MFS4_UART_SSR_REC                 *((volatile unsigned char*)(0x427080BCUL))
#define bFM_MFS4_UART_BGR_EXT                 *((volatile unsigned char*)(0x427081BCUL))
#define bFM_MFS4_UART_BGR1_EXT                *((volatile unsigned char*)(0x427081BCUL))
#define bFM_MFS4_UART_FCR_FE1                 *((volatile unsigned char*)(0x42708280UL))
#define bFM_MFS4_UART_FCR_FE2                 *((volatile unsigned char*)(0x42708284UL))
#define bFM_MFS4_UART_FCR_FCL1                *((volatile unsigned char*)(0x42708288UL))
#define bFM_MFS4_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270828CUL))
#define bFM_MFS4_UART_FCR_FSET                *((volatile unsigned char*)(0x42708290UL))
#define bFM_MFS4_UART_FCR_FLD                 *((volatile unsigned char*)(0x42708294UL))
#define bFM_MFS4_UART_FCR_FLST                *((volatile unsigned char*)(0x42708298UL))
#define bFM_MFS4_UART_FCR_FSEL                *((volatile unsigned char*)(0x427082A0UL))
#define bFM_MFS4_UART_FCR_FTIE                *((volatile unsigned char*)(0x427082A4UL))
#define bFM_MFS4_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427082A8UL))
#define bFM_MFS4_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427082ACUL))
#define bFM_MFS4_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427082B0UL))
#define bFM_MFS4_UART_FCR0_FE1                *((volatile unsigned char*)(0x42708280UL))
#define bFM_MFS4_UART_FCR0_FE2                *((volatile unsigned char*)(0x42708284UL))
#define bFM_MFS4_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42708288UL))
#define bFM_MFS4_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270828CUL))
#define bFM_MFS4_UART_FCR0_FSET               *((volatile unsigned char*)(0x42708290UL))
#define bFM_MFS4_UART_FCR0_FLD                *((volatile unsigned char*)(0x42708294UL))
#define bFM_MFS4_UART_FCR0_FLST               *((volatile unsigned char*)(0x42708298UL))
#define bFM_MFS4_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427082A0UL))
#define bFM_MFS4_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427082A4UL))
#define bFM_MFS4_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427082A8UL))
#define bFM_MFS4_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427082ACUL))
#define bFM_MFS4_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427082B0UL))
#define bFM_MFS4_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42708300UL))
#define bFM_MFS4_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42708304UL))
#define bFM_MFS4_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42708308UL))
#define bFM_MFS4_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270830CUL))
#define bFM_MFS4_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42708310UL))
#define bFM_MFS4_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42708314UL))
#define bFM_MFS4_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42708318UL))
#define bFM_MFS4_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270831CUL))
#define bFM_MFS4_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42708320UL))
#define bFM_MFS4_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42708324UL))
#define bFM_MFS4_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42708328UL))
#define bFM_MFS4_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270832CUL))
#define bFM_MFS4_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42708330UL))
#define bFM_MFS4_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42708334UL))
#define bFM_MFS4_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42708338UL))
#define bFM_MFS4_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270833CUL))
#define bFM_MFS4_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42708300UL))
#define bFM_MFS4_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42708304UL))
#define bFM_MFS4_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42708308UL))
#define bFM_MFS4_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270830CUL))
#define bFM_MFS4_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42708310UL))
#define bFM_MFS4_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42708314UL))
#define bFM_MFS4_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42708318UL))
#define bFM_MFS4_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270831CUL))
#define bFM_MFS4_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42708320UL))
#define bFM_MFS4_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42708324UL))
#define bFM_MFS4_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42708328UL))
#define bFM_MFS4_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270832CUL))
#define bFM_MFS4_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42708330UL))
#define bFM_MFS4_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42708334UL))
#define bFM_MFS4_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42708338UL))
#define bFM_MFS4_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270833CUL))

/* MFS CSIO channel 4 registers */
#define bFM_MFS4_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42708000UL))
#define bFM_MFS4_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42708004UL))
#define bFM_MFS4_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42708008UL))
#define bFM_MFS4_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270800CUL))
#define bFM_MFS4_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42708014UL))
#define bFM_MFS4_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42708018UL))
#define bFM_MFS4_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270801CUL))
#define bFM_MFS4_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42708020UL))
#define bFM_MFS4_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42708024UL))
#define bFM_MFS4_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42708028UL))
#define bFM_MFS4_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270802CUL))
#define bFM_MFS4_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42708030UL))
#define bFM_MFS4_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42708034UL))
#define bFM_MFS4_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42708038UL))
#define bFM_MFS4_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270803CUL))
#define bFM_MFS4_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42708080UL))
#define bFM_MFS4_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42708084UL))
#define bFM_MFS4_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42708088UL))
#define bFM_MFS4_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270808CUL))
#define bFM_MFS4_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42708090UL))
#define bFM_MFS4_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42708094UL))
#define bFM_MFS4_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42708098UL))
#define bFM_MFS4_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270809CUL))
#define bFM_MFS4_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427080A0UL))
#define bFM_MFS4_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427080A4UL))
#define bFM_MFS4_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427080A8UL))
#define bFM_MFS4_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427080ACUL))
#define bFM_MFS4_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427080B0UL))
#define bFM_MFS4_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427080BCUL))
#define bFM_MFS4_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42708280UL))
#define bFM_MFS4_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42708284UL))
#define bFM_MFS4_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42708288UL))
#define bFM_MFS4_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270828CUL))
#define bFM_MFS4_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42708290UL))
#define bFM_MFS4_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42708294UL))
#define bFM_MFS4_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42708298UL))
#define bFM_MFS4_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427082A0UL))
#define bFM_MFS4_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427082A4UL))
#define bFM_MFS4_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427082A8UL))
#define bFM_MFS4_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427082ACUL))
#define bFM_MFS4_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427082B0UL))
#define bFM_MFS4_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42708280UL))
#define bFM_MFS4_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42708284UL))
#define bFM_MFS4_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42708288UL))
#define bFM_MFS4_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270828CUL))
#define bFM_MFS4_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42708290UL))
#define bFM_MFS4_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42708294UL))
#define bFM_MFS4_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42708298UL))
#define bFM_MFS4_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427082A0UL))
#define bFM_MFS4_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427082A4UL))
#define bFM_MFS4_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427082A8UL))
#define bFM_MFS4_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427082ACUL))
#define bFM_MFS4_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427082B0UL))
#define bFM_MFS4_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42708300UL))
#define bFM_MFS4_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42708304UL))
#define bFM_MFS4_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42708308UL))
#define bFM_MFS4_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270830CUL))
#define bFM_MFS4_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42708310UL))
#define bFM_MFS4_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42708314UL))
#define bFM_MFS4_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42708318UL))
#define bFM_MFS4_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270831CUL))
#define bFM_MFS4_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42708320UL))
#define bFM_MFS4_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42708324UL))
#define bFM_MFS4_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42708328UL))
#define bFM_MFS4_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270832CUL))
#define bFM_MFS4_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42708330UL))
#define bFM_MFS4_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42708334UL))
#define bFM_MFS4_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42708338UL))
#define bFM_MFS4_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270833CUL))
#define bFM_MFS4_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42708300UL))
#define bFM_MFS4_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42708304UL))
#define bFM_MFS4_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42708308UL))
#define bFM_MFS4_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270830CUL))
#define bFM_MFS4_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42708310UL))
#define bFM_MFS4_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42708314UL))
#define bFM_MFS4_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42708318UL))
#define bFM_MFS4_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270831CUL))
#define bFM_MFS4_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42708320UL))
#define bFM_MFS4_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42708324UL))
#define bFM_MFS4_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42708328UL))
#define bFM_MFS4_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270832CUL))
#define bFM_MFS4_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42708330UL))
#define bFM_MFS4_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42708334UL))
#define bFM_MFS4_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42708338UL))
#define bFM_MFS4_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270833CUL))
#define bFM_MFS4_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42708380UL))
#define bFM_MFS4_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42708384UL))
#define bFM_MFS4_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42708388UL))
#define bFM_MFS4_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270838CUL))
#define bFM_MFS4_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42708390UL))
#define bFM_MFS4_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42708394UL))
#define bFM_MFS4_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42708398UL))
#define bFM_MFS4_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270839CUL))
#define bFM_MFS4_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427083A0UL))
#define bFM_MFS4_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427083A4UL))
#define bFM_MFS4_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427083A8UL))
#define bFM_MFS4_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427083ACUL))
#define bFM_MFS4_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427083B0UL))
#define bFM_MFS4_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427083B4UL))
#define bFM_MFS4_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427083B8UL))
#define bFM_MFS4_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427083BCUL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42708400UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42708404UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42708408UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270840CUL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42708410UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42708414UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42708418UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270841CUL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42708420UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42708424UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42708428UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270842CUL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42708430UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42708434UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42708438UL))
#define bFM_MFS4_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270843CUL))
#define bFM_MFS4_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42708480UL))
#define bFM_MFS4_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42708484UL))
#define bFM_MFS4_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42708488UL))
#define bFM_MFS4_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270848CUL))
#define bFM_MFS4_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42708490UL))
#define bFM_MFS4_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42708498UL))
#define bFM_MFS4_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270849CUL))
#define bFM_MFS4_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427084A0UL))
#define bFM_MFS4_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427084ACUL))
#define bFM_MFS4_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427084B0UL))
#define bFM_MFS4_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427084B4UL))
#define bFM_MFS4_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42708500UL))
#define bFM_MFS4_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42708504UL))
#define bFM_MFS4_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42708508UL))
#define bFM_MFS4_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270850CUL))
#define bFM_MFS4_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42708510UL))
#define bFM_MFS4_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42708514UL))
#define bFM_MFS4_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42708518UL))
#define bFM_MFS4_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270851CUL))
#define bFM_MFS4_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42708520UL))
#define bFM_MFS4_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42708524UL))
#define bFM_MFS4_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42708528UL))
#define bFM_MFS4_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270852CUL))
#define bFM_MFS4_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42708530UL))
#define bFM_MFS4_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42708534UL))
#define bFM_MFS4_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42708538UL))
#define bFM_MFS4_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270853CUL))
#define bFM_MFS4_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42708580UL))
#define bFM_MFS4_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42708584UL))
#define bFM_MFS4_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42708588UL))
#define bFM_MFS4_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270858CUL))
#define bFM_MFS4_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42708590UL))
#define bFM_MFS4_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42708594UL))
#define bFM_MFS4_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42708598UL))
#define bFM_MFS4_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270859CUL))
#define bFM_MFS4_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427085A0UL))
#define bFM_MFS4_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427085A4UL))
#define bFM_MFS4_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427085A8UL))
#define bFM_MFS4_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427085ACUL))
#define bFM_MFS4_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427085B0UL))
#define bFM_MFS4_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427085B4UL))
#define bFM_MFS4_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427085B8UL))
#define bFM_MFS4_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427085BCUL))
#define bFM_MFS4_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42708600UL))
#define bFM_MFS4_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42708604UL))
#define bFM_MFS4_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42708608UL))
#define bFM_MFS4_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270860CUL))
#define bFM_MFS4_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42708610UL))
#define bFM_MFS4_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42708614UL))
#define bFM_MFS4_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42708618UL))
#define bFM_MFS4_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270861CUL))
#define bFM_MFS4_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42708620UL))
#define bFM_MFS4_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42708624UL))
#define bFM_MFS4_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42708628UL))
#define bFM_MFS4_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270862CUL))
#define bFM_MFS4_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42708630UL))
#define bFM_MFS4_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42708634UL))
#define bFM_MFS4_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42708638UL))
#define bFM_MFS4_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270863CUL))
#define bFM_MFS4_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42708680UL))
#define bFM_MFS4_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42708684UL))
#define bFM_MFS4_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42708688UL))
#define bFM_MFS4_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270868CUL))
#define bFM_MFS4_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42708690UL))
#define bFM_MFS4_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42708694UL))
#define bFM_MFS4_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42708698UL))
#define bFM_MFS4_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270869CUL))
#define bFM_MFS4_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427086A0UL))
#define bFM_MFS4_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427086A4UL))
#define bFM_MFS4_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427086A8UL))
#define bFM_MFS4_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427086ACUL))
#define bFM_MFS4_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427086B0UL))
#define bFM_MFS4_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427086B4UL))
#define bFM_MFS4_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427086B8UL))
#define bFM_MFS4_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427086BCUL))
#define bFM_MFS4_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42708700UL))
#define bFM_MFS4_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42708704UL))
#define bFM_MFS4_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42708708UL))
#define bFM_MFS4_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270870CUL))
#define bFM_MFS4_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42708710UL))
#define bFM_MFS4_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42708714UL))
#define bFM_MFS4_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42708718UL))
#define bFM_MFS4_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270871CUL))

/* MFS LIN channel 4 registers */
#define bFM_MFS4_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42708000UL))
#define bFM_MFS4_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270800CUL))
#define bFM_MFS4_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42708010UL))
#define bFM_MFS4_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42708014UL))
#define bFM_MFS4_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42708018UL))
#define bFM_MFS4_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270801CUL))
#define bFM_MFS4_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42708020UL))
#define bFM_MFS4_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42708024UL))
#define bFM_MFS4_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42708028UL))
#define bFM_MFS4_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270802CUL))
#define bFM_MFS4_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42708030UL))
#define bFM_MFS4_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42708034UL))
#define bFM_MFS4_LIN_SCR_MS                   *((volatile unsigned char*)(0x42708038UL))
#define bFM_MFS4_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270803CUL))
#define bFM_MFS4_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42708080UL))
#define bFM_MFS4_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42708084UL))
#define bFM_MFS4_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42708088UL))
#define bFM_MFS4_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270808CUL))
#define bFM_MFS4_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42708090UL))
#define bFM_MFS4_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42708098UL))
#define bFM_MFS4_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427080A0UL))
#define bFM_MFS4_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427080A4UL))
#define bFM_MFS4_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427080A8UL))
#define bFM_MFS4_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427080ACUL))
#define bFM_MFS4_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427080B0UL))
#define bFM_MFS4_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427080B4UL))
#define bFM_MFS4_LIN_SSR_REC                  *((volatile unsigned char*)(0x427080BCUL))
#define bFM_MFS4_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427081BCUL))
#define bFM_MFS4_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427081BCUL))
#define bFM_MFS4_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42708280UL))
#define bFM_MFS4_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42708284UL))
#define bFM_MFS4_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42708288UL))
#define bFM_MFS4_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270828CUL))
#define bFM_MFS4_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42708290UL))
#define bFM_MFS4_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42708294UL))
#define bFM_MFS4_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42708298UL))
#define bFM_MFS4_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427082A0UL))
#define bFM_MFS4_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427082A4UL))
#define bFM_MFS4_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427082A8UL))
#define bFM_MFS4_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427082ACUL))
#define bFM_MFS4_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427082B0UL))
#define bFM_MFS4_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42708280UL))
#define bFM_MFS4_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42708284UL))
#define bFM_MFS4_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42708288UL))
#define bFM_MFS4_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270828CUL))
#define bFM_MFS4_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42708290UL))
#define bFM_MFS4_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42708294UL))
#define bFM_MFS4_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42708298UL))
#define bFM_MFS4_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427082A0UL))
#define bFM_MFS4_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427082A4UL))
#define bFM_MFS4_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427082A8UL))
#define bFM_MFS4_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427082ACUL))
#define bFM_MFS4_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427082B0UL))
#define bFM_MFS4_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42708300UL))
#define bFM_MFS4_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42708304UL))
#define bFM_MFS4_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42708308UL))
#define bFM_MFS4_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270830CUL))
#define bFM_MFS4_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42708310UL))
#define bFM_MFS4_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42708314UL))
#define bFM_MFS4_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42708318UL))
#define bFM_MFS4_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270831CUL))
#define bFM_MFS4_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42708320UL))
#define bFM_MFS4_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42708324UL))
#define bFM_MFS4_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42708328UL))
#define bFM_MFS4_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270832CUL))
#define bFM_MFS4_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42708330UL))
#define bFM_MFS4_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42708334UL))
#define bFM_MFS4_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42708338UL))
#define bFM_MFS4_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270833CUL))
#define bFM_MFS4_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42708300UL))
#define bFM_MFS4_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42708304UL))
#define bFM_MFS4_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42708308UL))
#define bFM_MFS4_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270830CUL))
#define bFM_MFS4_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42708310UL))
#define bFM_MFS4_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42708314UL))
#define bFM_MFS4_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42708318UL))
#define bFM_MFS4_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270831CUL))
#define bFM_MFS4_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42708320UL))
#define bFM_MFS4_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42708324UL))
#define bFM_MFS4_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42708328UL))
#define bFM_MFS4_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270832CUL))
#define bFM_MFS4_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42708330UL))
#define bFM_MFS4_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42708334UL))
#define bFM_MFS4_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42708338UL))
#define bFM_MFS4_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270833CUL))

/* MFS I2C channel 4 registers */
#define bFM_MFS4_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42708008UL))
#define bFM_MFS4_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270800CUL))
#define bFM_MFS4_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42708014UL))
#define bFM_MFS4_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42708018UL))
#define bFM_MFS4_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270801CUL))
#define bFM_MFS4_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42708020UL))
#define bFM_MFS4_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42708024UL))
#define bFM_MFS4_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42708028UL))
#define bFM_MFS4_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270802CUL))
#define bFM_MFS4_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42708030UL))
#define bFM_MFS4_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42708034UL))
#define bFM_MFS4_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42708038UL))
#define bFM_MFS4_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42708038UL))
#define bFM_MFS4_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270803CUL))
#define bFM_MFS4_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42708080UL))
#define bFM_MFS4_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42708084UL))
#define bFM_MFS4_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42708088UL))
#define bFM_MFS4_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270808CUL))
#define bFM_MFS4_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42708090UL))
#define bFM_MFS4_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42708094UL))
#define bFM_MFS4_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42708098UL))
#define bFM_MFS4_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270809CUL))
#define bFM_MFS4_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427080A0UL))
#define bFM_MFS4_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427080A4UL))
#define bFM_MFS4_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427080A8UL))
#define bFM_MFS4_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427080ACUL))
#define bFM_MFS4_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427080B0UL))
#define bFM_MFS4_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427080B4UL))
#define bFM_MFS4_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427080B8UL))
#define bFM_MFS4_I2C_SSR_REC                  *((volatile unsigned char*)(0x427080BCUL))
#define bFM_MFS4_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42708200UL))
#define bFM_MFS4_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42708204UL))
#define bFM_MFS4_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42708208UL))
#define bFM_MFS4_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270820CUL))
#define bFM_MFS4_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42708210UL))
#define bFM_MFS4_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42708214UL))
#define bFM_MFS4_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42708218UL))
#define bFM_MFS4_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270821CUL))
#define bFM_MFS4_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42708220UL))
#define bFM_MFS4_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42708224UL))
#define bFM_MFS4_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42708228UL))
#define bFM_MFS4_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270822CUL))
#define bFM_MFS4_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42708230UL))
#define bFM_MFS4_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42708234UL))
#define bFM_MFS4_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42708238UL))
#define bFM_MFS4_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270823CUL))
#define bFM_MFS4_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42708280UL))
#define bFM_MFS4_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42708284UL))
#define bFM_MFS4_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42708288UL))
#define bFM_MFS4_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270828CUL))
#define bFM_MFS4_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42708290UL))
#define bFM_MFS4_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42708294UL))
#define bFM_MFS4_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42708298UL))
#define bFM_MFS4_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427082A0UL))
#define bFM_MFS4_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427082A4UL))
#define bFM_MFS4_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427082A8UL))
#define bFM_MFS4_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427082ACUL))
#define bFM_MFS4_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427082B0UL))
#define bFM_MFS4_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42708280UL))
#define bFM_MFS4_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42708284UL))
#define bFM_MFS4_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42708288UL))
#define bFM_MFS4_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270828CUL))
#define bFM_MFS4_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42708290UL))
#define bFM_MFS4_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42708294UL))
#define bFM_MFS4_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42708298UL))
#define bFM_MFS4_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427082A0UL))
#define bFM_MFS4_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427082A4UL))
#define bFM_MFS4_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427082A8UL))
#define bFM_MFS4_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427082ACUL))
#define bFM_MFS4_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427082B0UL))
#define bFM_MFS4_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42708300UL))
#define bFM_MFS4_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42708304UL))
#define bFM_MFS4_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42708308UL))
#define bFM_MFS4_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270830CUL))
#define bFM_MFS4_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42708310UL))
#define bFM_MFS4_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42708314UL))
#define bFM_MFS4_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42708318UL))
#define bFM_MFS4_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270831CUL))
#define bFM_MFS4_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42708320UL))
#define bFM_MFS4_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42708324UL))
#define bFM_MFS4_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42708328UL))
#define bFM_MFS4_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270832CUL))
#define bFM_MFS4_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42708330UL))
#define bFM_MFS4_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42708334UL))
#define bFM_MFS4_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42708338UL))
#define bFM_MFS4_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270833CUL))
#define bFM_MFS4_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42708300UL))
#define bFM_MFS4_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42708304UL))
#define bFM_MFS4_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42708308UL))
#define bFM_MFS4_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270830CUL))
#define bFM_MFS4_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42708310UL))
#define bFM_MFS4_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42708314UL))
#define bFM_MFS4_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42708318UL))
#define bFM_MFS4_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270831CUL))
#define bFM_MFS4_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42708320UL))
#define bFM_MFS4_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42708324UL))
#define bFM_MFS4_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42708328UL))
#define bFM_MFS4_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270832CUL))
#define bFM_MFS4_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42708330UL))
#define bFM_MFS4_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42708334UL))
#define bFM_MFS4_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42708338UL))
#define bFM_MFS4_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270833CUL))

/* MFS UART channel 5 registers */
#define bFM_MFS5_UART_SMR_SOE                 *((volatile unsigned char*)(0x4270A000UL))
#define bFM_MFS5_UART_SMR_BDS                 *((volatile unsigned char*)(0x4270A008UL))
#define bFM_MFS5_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270A00CUL))
#define bFM_MFS5_UART_SMR_WUCR                *((volatile unsigned char*)(0x4270A010UL))
#define bFM_MFS5_UART_SMR_MD0                 *((volatile unsigned char*)(0x4270A014UL))
#define bFM_MFS5_UART_SMR_MD1                 *((volatile unsigned char*)(0x4270A018UL))
#define bFM_MFS5_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270A01CUL))
#define bFM_MFS5_UART_SCR_TXE                 *((volatile unsigned char*)(0x4270A020UL))
#define bFM_MFS5_UART_SCR_RXE                 *((volatile unsigned char*)(0x4270A024UL))
#define bFM_MFS5_UART_SCR_TBIE                *((volatile unsigned char*)(0x4270A028UL))
#define bFM_MFS5_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270A02CUL))
#define bFM_MFS5_UART_SCR_RIE                 *((volatile unsigned char*)(0x4270A030UL))
#define bFM_MFS5_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270A03CUL))
#define bFM_MFS5_UART_ESCR_L0                 *((volatile unsigned char*)(0x4270A080UL))
#define bFM_MFS5_UART_ESCR_L1                 *((volatile unsigned char*)(0x4270A084UL))
#define bFM_MFS5_UART_ESCR_L2                 *((volatile unsigned char*)(0x4270A088UL))
#define bFM_MFS5_UART_ESCR_P                  *((volatile unsigned char*)(0x4270A08CUL))
#define bFM_MFS5_UART_ESCR_PEN                *((volatile unsigned char*)(0x4270A090UL))
#define bFM_MFS5_UART_ESCR_INV                *((volatile unsigned char*)(0x4270A094UL))
#define bFM_MFS5_UART_ESCR_ESBL               *((volatile unsigned char*)(0x4270A098UL))
#define bFM_MFS5_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270A09CUL))
#define bFM_MFS5_UART_SSR_TBI                 *((volatile unsigned char*)(0x4270A0A0UL))
#define bFM_MFS5_UART_SSR_TDRE                *((volatile unsigned char*)(0x4270A0A4UL))
#define bFM_MFS5_UART_SSR_RDRF                *((volatile unsigned char*)(0x4270A0A8UL))
#define bFM_MFS5_UART_SSR_ORE                 *((volatile unsigned char*)(0x4270A0ACUL))
#define bFM_MFS5_UART_SSR_FRE                 *((volatile unsigned char*)(0x4270A0B0UL))
#define bFM_MFS5_UART_SSR_PE                  *((volatile unsigned char*)(0x4270A0B4UL))
#define bFM_MFS5_UART_SSR_REC                 *((volatile unsigned char*)(0x4270A0BCUL))
#define bFM_MFS5_UART_BGR_EXT                 *((volatile unsigned char*)(0x4270A1BCUL))
#define bFM_MFS5_UART_BGR1_EXT                *((volatile unsigned char*)(0x4270A1BCUL))
#define bFM_MFS5_UART_FCR_FE1                 *((volatile unsigned char*)(0x4270A280UL))
#define bFM_MFS5_UART_FCR_FE2                 *((volatile unsigned char*)(0x4270A284UL))
#define bFM_MFS5_UART_FCR_FCL1                *((volatile unsigned char*)(0x4270A288UL))
#define bFM_MFS5_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270A28CUL))
#define bFM_MFS5_UART_FCR_FSET                *((volatile unsigned char*)(0x4270A290UL))
#define bFM_MFS5_UART_FCR_FLD                 *((volatile unsigned char*)(0x4270A294UL))
#define bFM_MFS5_UART_FCR_FLST                *((volatile unsigned char*)(0x4270A298UL))
#define bFM_MFS5_UART_FCR_FSEL                *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM_MFS5_UART_FCR_FTIE                *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM_MFS5_UART_FCR_FDRQ                *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM_MFS5_UART_FCR_FRIIE               *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM_MFS5_UART_FCR_FLSTE               *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM_MFS5_UART_FCR0_FE1                *((volatile unsigned char*)(0x4270A280UL))
#define bFM_MFS5_UART_FCR0_FE2                *((volatile unsigned char*)(0x4270A284UL))
#define bFM_MFS5_UART_FCR0_FCL1               *((volatile unsigned char*)(0x4270A288UL))
#define bFM_MFS5_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270A28CUL))
#define bFM_MFS5_UART_FCR0_FSET               *((volatile unsigned char*)(0x4270A290UL))
#define bFM_MFS5_UART_FCR0_FLD                *((volatile unsigned char*)(0x4270A294UL))
#define bFM_MFS5_UART_FCR0_FLST               *((volatile unsigned char*)(0x4270A298UL))
#define bFM_MFS5_UART_FCR1_FSEL               *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM_MFS5_UART_FCR1_FTIE               *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM_MFS5_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM_MFS5_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM_MFS5_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM_MFS5_UART_FBYTE_FD0               *((volatile unsigned char*)(0x4270A300UL))
#define bFM_MFS5_UART_FBYTE_FD1               *((volatile unsigned char*)(0x4270A304UL))
#define bFM_MFS5_UART_FBYTE_FD2               *((volatile unsigned char*)(0x4270A308UL))
#define bFM_MFS5_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270A30CUL))
#define bFM_MFS5_UART_FBYTE_FD4               *((volatile unsigned char*)(0x4270A310UL))
#define bFM_MFS5_UART_FBYTE_FD5               *((volatile unsigned char*)(0x4270A314UL))
#define bFM_MFS5_UART_FBYTE_FD6               *((volatile unsigned char*)(0x4270A318UL))
#define bFM_MFS5_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270A31CUL))
#define bFM_MFS5_UART_FBYTE_FD8               *((volatile unsigned char*)(0x4270A320UL))
#define bFM_MFS5_UART_FBYTE_FD9               *((volatile unsigned char*)(0x4270A324UL))
#define bFM_MFS5_UART_FBYTE_FD10              *((volatile unsigned char*)(0x4270A328UL))
#define bFM_MFS5_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270A32CUL))
#define bFM_MFS5_UART_FBYTE_FD12              *((volatile unsigned char*)(0x4270A330UL))
#define bFM_MFS5_UART_FBYTE_FD13              *((volatile unsigned char*)(0x4270A334UL))
#define bFM_MFS5_UART_FBYTE_FD14              *((volatile unsigned char*)(0x4270A338UL))
#define bFM_MFS5_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270A33CUL))
#define bFM_MFS5_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x4270A300UL))
#define bFM_MFS5_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x4270A304UL))
#define bFM_MFS5_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x4270A308UL))
#define bFM_MFS5_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270A30CUL))
#define bFM_MFS5_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x4270A310UL))
#define bFM_MFS5_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x4270A314UL))
#define bFM_MFS5_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x4270A318UL))
#define bFM_MFS5_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270A31CUL))
#define bFM_MFS5_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x4270A320UL))
#define bFM_MFS5_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x4270A324UL))
#define bFM_MFS5_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x4270A328UL))
#define bFM_MFS5_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270A32CUL))
#define bFM_MFS5_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x4270A330UL))
#define bFM_MFS5_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x4270A334UL))
#define bFM_MFS5_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x4270A338UL))
#define bFM_MFS5_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270A33CUL))

/* MFS CSIO channel 5 registers */
#define bFM_MFS5_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x4270A000UL))
#define bFM_MFS5_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x4270A004UL))
#define bFM_MFS5_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x4270A008UL))
#define bFM_MFS5_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270A00CUL))
#define bFM_MFS5_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x4270A014UL))
#define bFM_MFS5_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x4270A018UL))
#define bFM_MFS5_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270A01CUL))
#define bFM_MFS5_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x4270A020UL))
#define bFM_MFS5_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x4270A024UL))
#define bFM_MFS5_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x4270A028UL))
#define bFM_MFS5_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270A02CUL))
#define bFM_MFS5_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x4270A030UL))
#define bFM_MFS5_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x4270A034UL))
#define bFM_MFS5_CSIO_SCR_MS                  *((volatile unsigned char*)(0x4270A038UL))
#define bFM_MFS5_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270A03CUL))
#define bFM_MFS5_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x4270A080UL))
#define bFM_MFS5_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x4270A084UL))
#define bFM_MFS5_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x4270A088UL))
#define bFM_MFS5_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270A08CUL))
#define bFM_MFS5_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x4270A090UL))
#define bFM_MFS5_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x4270A094UL))
#define bFM_MFS5_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x4270A098UL))
#define bFM_MFS5_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270A09CUL))
#define bFM_MFS5_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x4270A0A0UL))
#define bFM_MFS5_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x4270A0A4UL))
#define bFM_MFS5_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x4270A0A8UL))
#define bFM_MFS5_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x4270A0ACUL))
#define bFM_MFS5_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x4270A0B0UL))
#define bFM_MFS5_CSIO_SSR_REC                 *((volatile unsigned char*)(0x4270A0BCUL))
#define bFM_MFS5_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x4270A280UL))
#define bFM_MFS5_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x4270A284UL))
#define bFM_MFS5_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x4270A288UL))
#define bFM_MFS5_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270A28CUL))
#define bFM_MFS5_CSIO_FCR_FSET                *((volatile unsigned char*)(0x4270A290UL))
#define bFM_MFS5_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x4270A294UL))
#define bFM_MFS5_CSIO_FCR_FLST                *((volatile unsigned char*)(0x4270A298UL))
#define bFM_MFS5_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM_MFS5_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM_MFS5_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM_MFS5_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM_MFS5_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM_MFS5_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x4270A280UL))
#define bFM_MFS5_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x4270A284UL))
#define bFM_MFS5_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x4270A288UL))
#define bFM_MFS5_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270A28CUL))
#define bFM_MFS5_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x4270A290UL))
#define bFM_MFS5_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x4270A294UL))
#define bFM_MFS5_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x4270A298UL))
#define bFM_MFS5_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM_MFS5_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM_MFS5_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM_MFS5_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM_MFS5_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM_MFS5_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x4270A300UL))
#define bFM_MFS5_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x4270A304UL))
#define bFM_MFS5_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x4270A308UL))
#define bFM_MFS5_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270A30CUL))
#define bFM_MFS5_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x4270A310UL))
#define bFM_MFS5_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x4270A314UL))
#define bFM_MFS5_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x4270A318UL))
#define bFM_MFS5_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270A31CUL))
#define bFM_MFS5_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x4270A320UL))
#define bFM_MFS5_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x4270A324UL))
#define bFM_MFS5_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x4270A328UL))
#define bFM_MFS5_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270A32CUL))
#define bFM_MFS5_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x4270A330UL))
#define bFM_MFS5_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x4270A334UL))
#define bFM_MFS5_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x4270A338UL))
#define bFM_MFS5_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270A33CUL))
#define bFM_MFS5_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x4270A300UL))
#define bFM_MFS5_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x4270A304UL))
#define bFM_MFS5_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x4270A308UL))
#define bFM_MFS5_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270A30CUL))
#define bFM_MFS5_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x4270A310UL))
#define bFM_MFS5_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x4270A314UL))
#define bFM_MFS5_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x4270A318UL))
#define bFM_MFS5_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270A31CUL))
#define bFM_MFS5_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x4270A320UL))
#define bFM_MFS5_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x4270A324UL))
#define bFM_MFS5_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x4270A328UL))
#define bFM_MFS5_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270A32CUL))
#define bFM_MFS5_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x4270A330UL))
#define bFM_MFS5_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x4270A334UL))
#define bFM_MFS5_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x4270A338UL))
#define bFM_MFS5_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270A33CUL))
#define bFM_MFS5_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x4270A380UL))
#define bFM_MFS5_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x4270A384UL))
#define bFM_MFS5_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x4270A388UL))
#define bFM_MFS5_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270A38CUL))
#define bFM_MFS5_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x4270A390UL))
#define bFM_MFS5_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x4270A394UL))
#define bFM_MFS5_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x4270A398UL))
#define bFM_MFS5_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270A39CUL))
#define bFM_MFS5_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x4270A3A0UL))
#define bFM_MFS5_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x4270A3A4UL))
#define bFM_MFS5_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x4270A3A8UL))
#define bFM_MFS5_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x4270A3ACUL))
#define bFM_MFS5_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x4270A3B0UL))
#define bFM_MFS5_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x4270A3B4UL))
#define bFM_MFS5_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x4270A3B8UL))
#define bFM_MFS5_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x4270A3BCUL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x4270A400UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x4270A404UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x4270A408UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270A40CUL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x4270A410UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x4270A414UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x4270A418UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270A41CUL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x4270A420UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x4270A424UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x4270A428UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270A42CUL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x4270A430UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x4270A434UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x4270A438UL))
#define bFM_MFS5_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270A43CUL))
#define bFM_MFS5_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x4270A480UL))
#define bFM_MFS5_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x4270A484UL))
#define bFM_MFS5_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x4270A488UL))
#define bFM_MFS5_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270A48CUL))
#define bFM_MFS5_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x4270A490UL))
#define bFM_MFS5_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x4270A498UL))
#define bFM_MFS5_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270A49CUL))
#define bFM_MFS5_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x4270A4A0UL))
#define bFM_MFS5_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x4270A4ACUL))
#define bFM_MFS5_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x4270A4B0UL))
#define bFM_MFS5_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x4270A4B4UL))
#define bFM_MFS5_CSIO_STMR_TM0                *((volatile unsigned char*)(0x4270A500UL))
#define bFM_MFS5_CSIO_STMR_TM1                *((volatile unsigned char*)(0x4270A504UL))
#define bFM_MFS5_CSIO_STMR_TM2                *((volatile unsigned char*)(0x4270A508UL))
#define bFM_MFS5_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270A50CUL))
#define bFM_MFS5_CSIO_STMR_TM4                *((volatile unsigned char*)(0x4270A510UL))
#define bFM_MFS5_CSIO_STMR_TM5                *((volatile unsigned char*)(0x4270A514UL))
#define bFM_MFS5_CSIO_STMR_TM6                *((volatile unsigned char*)(0x4270A518UL))
#define bFM_MFS5_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270A51CUL))
#define bFM_MFS5_CSIO_STMR_TM8                *((volatile unsigned char*)(0x4270A520UL))
#define bFM_MFS5_CSIO_STMR_TM9                *((volatile unsigned char*)(0x4270A524UL))
#define bFM_MFS5_CSIO_STMR_TM10               *((volatile unsigned char*)(0x4270A528UL))
#define bFM_MFS5_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270A52CUL))
#define bFM_MFS5_CSIO_STMR_TM12               *((volatile unsigned char*)(0x4270A530UL))
#define bFM_MFS5_CSIO_STMR_TM13               *((volatile unsigned char*)(0x4270A534UL))
#define bFM_MFS5_CSIO_STMR_TM14               *((volatile unsigned char*)(0x4270A538UL))
#define bFM_MFS5_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270A53CUL))
#define bFM_MFS5_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x4270A580UL))
#define bFM_MFS5_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x4270A584UL))
#define bFM_MFS5_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x4270A588UL))
#define bFM_MFS5_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270A58CUL))
#define bFM_MFS5_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x4270A590UL))
#define bFM_MFS5_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x4270A594UL))
#define bFM_MFS5_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x4270A598UL))
#define bFM_MFS5_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270A59CUL))
#define bFM_MFS5_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x4270A5A0UL))
#define bFM_MFS5_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x4270A5A4UL))
#define bFM_MFS5_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x4270A5A8UL))
#define bFM_MFS5_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x4270A5ACUL))
#define bFM_MFS5_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x4270A5B0UL))
#define bFM_MFS5_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x4270A5B4UL))
#define bFM_MFS5_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x4270A5B8UL))
#define bFM_MFS5_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x4270A5BCUL))
#define bFM_MFS5_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x4270A600UL))
#define bFM_MFS5_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x4270A604UL))
#define bFM_MFS5_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x4270A608UL))
#define bFM_MFS5_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270A60CUL))
#define bFM_MFS5_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x4270A610UL))
#define bFM_MFS5_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x4270A614UL))
#define bFM_MFS5_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x4270A618UL))
#define bFM_MFS5_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270A61CUL))
#define bFM_MFS5_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x4270A620UL))
#define bFM_MFS5_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x4270A624UL))
#define bFM_MFS5_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x4270A628UL))
#define bFM_MFS5_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270A62CUL))
#define bFM_MFS5_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x4270A630UL))
#define bFM_MFS5_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x4270A634UL))
#define bFM_MFS5_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x4270A638UL))
#define bFM_MFS5_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270A63CUL))
#define bFM_MFS5_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x4270A680UL))
#define bFM_MFS5_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x4270A684UL))
#define bFM_MFS5_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x4270A688UL))
#define bFM_MFS5_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270A68CUL))
#define bFM_MFS5_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x4270A690UL))
#define bFM_MFS5_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x4270A694UL))
#define bFM_MFS5_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x4270A698UL))
#define bFM_MFS5_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270A69CUL))
#define bFM_MFS5_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x4270A6A0UL))
#define bFM_MFS5_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x4270A6A4UL))
#define bFM_MFS5_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x4270A6A8UL))
#define bFM_MFS5_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x4270A6ACUL))
#define bFM_MFS5_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x4270A6B0UL))
#define bFM_MFS5_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x4270A6B4UL))
#define bFM_MFS5_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x4270A6B8UL))
#define bFM_MFS5_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x4270A6BCUL))
#define bFM_MFS5_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x4270A700UL))
#define bFM_MFS5_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x4270A704UL))
#define bFM_MFS5_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x4270A708UL))
#define bFM_MFS5_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270A70CUL))
#define bFM_MFS5_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x4270A710UL))
#define bFM_MFS5_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x4270A714UL))
#define bFM_MFS5_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x4270A718UL))
#define bFM_MFS5_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270A71CUL))

/* MFS LIN channel 5 registers */
#define bFM_MFS5_LIN_SMR_SOE                  *((volatile unsigned char*)(0x4270A000UL))
#define bFM_MFS5_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270A00CUL))
#define bFM_MFS5_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x4270A010UL))
#define bFM_MFS5_LIN_SMR_MD0                  *((volatile unsigned char*)(0x4270A014UL))
#define bFM_MFS5_LIN_SMR_MD1                  *((volatile unsigned char*)(0x4270A018UL))
#define bFM_MFS5_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270A01CUL))
#define bFM_MFS5_LIN_SCR_TXE                  *((volatile unsigned char*)(0x4270A020UL))
#define bFM_MFS5_LIN_SCR_RXE                  *((volatile unsigned char*)(0x4270A024UL))
#define bFM_MFS5_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x4270A028UL))
#define bFM_MFS5_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270A02CUL))
#define bFM_MFS5_LIN_SCR_RIE                  *((volatile unsigned char*)(0x4270A030UL))
#define bFM_MFS5_LIN_SCR_LBR                  *((volatile unsigned char*)(0x4270A034UL))
#define bFM_MFS5_LIN_SCR_MS                   *((volatile unsigned char*)(0x4270A038UL))
#define bFM_MFS5_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270A03CUL))
#define bFM_MFS5_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x4270A080UL))
#define bFM_MFS5_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x4270A084UL))
#define bFM_MFS5_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x4270A088UL))
#define bFM_MFS5_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270A08CUL))
#define bFM_MFS5_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x4270A090UL))
#define bFM_MFS5_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x4270A098UL))
#define bFM_MFS5_LIN_SSR_TBI                  *((volatile unsigned char*)(0x4270A0A0UL))
#define bFM_MFS5_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x4270A0A4UL))
#define bFM_MFS5_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x4270A0A8UL))
#define bFM_MFS5_LIN_SSR_ORE                  *((volatile unsigned char*)(0x4270A0ACUL))
#define bFM_MFS5_LIN_SSR_FRE                  *((volatile unsigned char*)(0x4270A0B0UL))
#define bFM_MFS5_LIN_SSR_LBD                  *((volatile unsigned char*)(0x4270A0B4UL))
#define bFM_MFS5_LIN_SSR_REC                  *((volatile unsigned char*)(0x4270A0BCUL))
#define bFM_MFS5_LIN_BGR_EXT                  *((volatile unsigned char*)(0x4270A1BCUL))
#define bFM_MFS5_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x4270A1BCUL))
#define bFM_MFS5_LIN_FCR_FE1                  *((volatile unsigned char*)(0x4270A280UL))
#define bFM_MFS5_LIN_FCR_FE2                  *((volatile unsigned char*)(0x4270A284UL))
#define bFM_MFS5_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x4270A288UL))
#define bFM_MFS5_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270A28CUL))
#define bFM_MFS5_LIN_FCR_FSET                 *((volatile unsigned char*)(0x4270A290UL))
#define bFM_MFS5_LIN_FCR_FLD                  *((volatile unsigned char*)(0x4270A294UL))
#define bFM_MFS5_LIN_FCR_FLST                 *((volatile unsigned char*)(0x4270A298UL))
#define bFM_MFS5_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM_MFS5_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM_MFS5_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM_MFS5_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM_MFS5_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM_MFS5_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x4270A280UL))
#define bFM_MFS5_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x4270A284UL))
#define bFM_MFS5_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x4270A288UL))
#define bFM_MFS5_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270A28CUL))
#define bFM_MFS5_LIN_FCR0_FSET                *((volatile unsigned char*)(0x4270A290UL))
#define bFM_MFS5_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x4270A294UL))
#define bFM_MFS5_LIN_FCR0_FLST                *((volatile unsigned char*)(0x4270A298UL))
#define bFM_MFS5_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM_MFS5_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM_MFS5_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM_MFS5_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM_MFS5_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM_MFS5_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x4270A300UL))
#define bFM_MFS5_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x4270A304UL))
#define bFM_MFS5_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x4270A308UL))
#define bFM_MFS5_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270A30CUL))
#define bFM_MFS5_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x4270A310UL))
#define bFM_MFS5_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x4270A314UL))
#define bFM_MFS5_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x4270A318UL))
#define bFM_MFS5_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270A31CUL))
#define bFM_MFS5_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x4270A320UL))
#define bFM_MFS5_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x4270A324UL))
#define bFM_MFS5_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x4270A328UL))
#define bFM_MFS5_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270A32CUL))
#define bFM_MFS5_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x4270A330UL))
#define bFM_MFS5_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x4270A334UL))
#define bFM_MFS5_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x4270A338UL))
#define bFM_MFS5_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270A33CUL))
#define bFM_MFS5_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x4270A300UL))
#define bFM_MFS5_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x4270A304UL))
#define bFM_MFS5_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x4270A308UL))
#define bFM_MFS5_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270A30CUL))
#define bFM_MFS5_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x4270A310UL))
#define bFM_MFS5_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x4270A314UL))
#define bFM_MFS5_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x4270A318UL))
#define bFM_MFS5_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270A31CUL))
#define bFM_MFS5_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x4270A320UL))
#define bFM_MFS5_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x4270A324UL))
#define bFM_MFS5_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x4270A328UL))
#define bFM_MFS5_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270A32CUL))
#define bFM_MFS5_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x4270A330UL))
#define bFM_MFS5_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x4270A334UL))
#define bFM_MFS5_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x4270A338UL))
#define bFM_MFS5_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270A33CUL))

/* MFS I2C channel 5 registers */
#define bFM_MFS5_I2C_SMR_TIE                  *((volatile unsigned char*)(0x4270A008UL))
#define bFM_MFS5_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270A00CUL))
#define bFM_MFS5_I2C_SMR_MD0                  *((volatile unsigned char*)(0x4270A014UL))
#define bFM_MFS5_I2C_SMR_MD1                  *((volatile unsigned char*)(0x4270A018UL))
#define bFM_MFS5_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270A01CUL))
#define bFM_MFS5_I2C_IBCR_INT                 *((volatile unsigned char*)(0x4270A020UL))
#define bFM_MFS5_I2C_IBCR_BER                 *((volatile unsigned char*)(0x4270A024UL))
#define bFM_MFS5_I2C_IBCR_INTE                *((volatile unsigned char*)(0x4270A028UL))
#define bFM_MFS5_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270A02CUL))
#define bFM_MFS5_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x4270A030UL))
#define bFM_MFS5_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x4270A034UL))
#define bFM_MFS5_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x4270A038UL))
#define bFM_MFS5_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x4270A038UL))
#define bFM_MFS5_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270A03CUL))
#define bFM_MFS5_I2C_IBSR_BB                  *((volatile unsigned char*)(0x4270A080UL))
#define bFM_MFS5_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x4270A084UL))
#define bFM_MFS5_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x4270A088UL))
#define bFM_MFS5_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270A08CUL))
#define bFM_MFS5_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x4270A090UL))
#define bFM_MFS5_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x4270A094UL))
#define bFM_MFS5_I2C_IBSR_RACK                *((volatile unsigned char*)(0x4270A098UL))
#define bFM_MFS5_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270A09CUL))
#define bFM_MFS5_I2C_SSR_TBI                  *((volatile unsigned char*)(0x4270A0A0UL))
#define bFM_MFS5_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x4270A0A4UL))
#define bFM_MFS5_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x4270A0A8UL))
#define bFM_MFS5_I2C_SSR_ORE                  *((volatile unsigned char*)(0x4270A0ACUL))
#define bFM_MFS5_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x4270A0B0UL))
#define bFM_MFS5_I2C_SSR_DMA                  *((volatile unsigned char*)(0x4270A0B4UL))
#define bFM_MFS5_I2C_SSR_TSET                 *((volatile unsigned char*)(0x4270A0B8UL))
#define bFM_MFS5_I2C_SSR_REC                  *((volatile unsigned char*)(0x4270A0BCUL))
#define bFM_MFS5_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x4270A200UL))
#define bFM_MFS5_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x4270A204UL))
#define bFM_MFS5_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x4270A208UL))
#define bFM_MFS5_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270A20CUL))
#define bFM_MFS5_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x4270A210UL))
#define bFM_MFS5_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x4270A214UL))
#define bFM_MFS5_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x4270A218UL))
#define bFM_MFS5_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270A21CUL))
#define bFM_MFS5_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x4270A220UL))
#define bFM_MFS5_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x4270A224UL))
#define bFM_MFS5_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x4270A228UL))
#define bFM_MFS5_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270A22CUL))
#define bFM_MFS5_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x4270A230UL))
#define bFM_MFS5_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x4270A234UL))
#define bFM_MFS5_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x4270A238UL))
#define bFM_MFS5_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270A23CUL))
#define bFM_MFS5_I2C_FCR_FE1                  *((volatile unsigned char*)(0x4270A280UL))
#define bFM_MFS5_I2C_FCR_FE2                  *((volatile unsigned char*)(0x4270A284UL))
#define bFM_MFS5_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x4270A288UL))
#define bFM_MFS5_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270A28CUL))
#define bFM_MFS5_I2C_FCR_FSET                 *((volatile unsigned char*)(0x4270A290UL))
#define bFM_MFS5_I2C_FCR_FLD                  *((volatile unsigned char*)(0x4270A294UL))
#define bFM_MFS5_I2C_FCR_FLST                 *((volatile unsigned char*)(0x4270A298UL))
#define bFM_MFS5_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM_MFS5_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM_MFS5_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM_MFS5_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM_MFS5_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM_MFS5_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x4270A280UL))
#define bFM_MFS5_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x4270A284UL))
#define bFM_MFS5_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x4270A288UL))
#define bFM_MFS5_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270A28CUL))
#define bFM_MFS5_I2C_FCR0_FSET                *((volatile unsigned char*)(0x4270A290UL))
#define bFM_MFS5_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x4270A294UL))
#define bFM_MFS5_I2C_FCR0_FLST                *((volatile unsigned char*)(0x4270A298UL))
#define bFM_MFS5_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x4270A2A0UL))
#define bFM_MFS5_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x4270A2A4UL))
#define bFM_MFS5_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x4270A2A8UL))
#define bFM_MFS5_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x4270A2ACUL))
#define bFM_MFS5_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x4270A2B0UL))
#define bFM_MFS5_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x4270A300UL))
#define bFM_MFS5_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x4270A304UL))
#define bFM_MFS5_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x4270A308UL))
#define bFM_MFS5_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270A30CUL))
#define bFM_MFS5_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x4270A310UL))
#define bFM_MFS5_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x4270A314UL))
#define bFM_MFS5_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x4270A318UL))
#define bFM_MFS5_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270A31CUL))
#define bFM_MFS5_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x4270A320UL))
#define bFM_MFS5_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x4270A324UL))
#define bFM_MFS5_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x4270A328UL))
#define bFM_MFS5_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270A32CUL))
#define bFM_MFS5_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x4270A330UL))
#define bFM_MFS5_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x4270A334UL))
#define bFM_MFS5_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x4270A338UL))
#define bFM_MFS5_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270A33CUL))
#define bFM_MFS5_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x4270A300UL))
#define bFM_MFS5_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x4270A304UL))
#define bFM_MFS5_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x4270A308UL))
#define bFM_MFS5_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270A30CUL))
#define bFM_MFS5_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x4270A310UL))
#define bFM_MFS5_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x4270A314UL))
#define bFM_MFS5_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x4270A318UL))
#define bFM_MFS5_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270A31CUL))
#define bFM_MFS5_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x4270A320UL))
#define bFM_MFS5_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x4270A324UL))
#define bFM_MFS5_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x4270A328UL))
#define bFM_MFS5_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270A32CUL))
#define bFM_MFS5_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x4270A330UL))
#define bFM_MFS5_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x4270A334UL))
#define bFM_MFS5_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x4270A338UL))
#define bFM_MFS5_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270A33CUL))

/* MFS UART channel 6 registers */
#define bFM_MFS6_UART_SMR_SOE                 *((volatile unsigned char*)(0x4270C000UL))
#define bFM_MFS6_UART_SMR_BDS                 *((volatile unsigned char*)(0x4270C008UL))
#define bFM_MFS6_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270C00CUL))
#define bFM_MFS6_UART_SMR_WUCR                *((volatile unsigned char*)(0x4270C010UL))
#define bFM_MFS6_UART_SMR_MD0                 *((volatile unsigned char*)(0x4270C014UL))
#define bFM_MFS6_UART_SMR_MD1                 *((volatile unsigned char*)(0x4270C018UL))
#define bFM_MFS6_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270C01CUL))
#define bFM_MFS6_UART_SCR_TXE                 *((volatile unsigned char*)(0x4270C020UL))
#define bFM_MFS6_UART_SCR_RXE                 *((volatile unsigned char*)(0x4270C024UL))
#define bFM_MFS6_UART_SCR_TBIE                *((volatile unsigned char*)(0x4270C028UL))
#define bFM_MFS6_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270C02CUL))
#define bFM_MFS6_UART_SCR_RIE                 *((volatile unsigned char*)(0x4270C030UL))
#define bFM_MFS6_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270C03CUL))
#define bFM_MFS6_UART_ESCR_L0                 *((volatile unsigned char*)(0x4270C080UL))
#define bFM_MFS6_UART_ESCR_L1                 *((volatile unsigned char*)(0x4270C084UL))
#define bFM_MFS6_UART_ESCR_L2                 *((volatile unsigned char*)(0x4270C088UL))
#define bFM_MFS6_UART_ESCR_P                  *((volatile unsigned char*)(0x4270C08CUL))
#define bFM_MFS6_UART_ESCR_PEN                *((volatile unsigned char*)(0x4270C090UL))
#define bFM_MFS6_UART_ESCR_INV                *((volatile unsigned char*)(0x4270C094UL))
#define bFM_MFS6_UART_ESCR_ESBL               *((volatile unsigned char*)(0x4270C098UL))
#define bFM_MFS6_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270C09CUL))
#define bFM_MFS6_UART_SSR_TBI                 *((volatile unsigned char*)(0x4270C0A0UL))
#define bFM_MFS6_UART_SSR_TDRE                *((volatile unsigned char*)(0x4270C0A4UL))
#define bFM_MFS6_UART_SSR_RDRF                *((volatile unsigned char*)(0x4270C0A8UL))
#define bFM_MFS6_UART_SSR_ORE                 *((volatile unsigned char*)(0x4270C0ACUL))
#define bFM_MFS6_UART_SSR_FRE                 *((volatile unsigned char*)(0x4270C0B0UL))
#define bFM_MFS6_UART_SSR_PE                  *((volatile unsigned char*)(0x4270C0B4UL))
#define bFM_MFS6_UART_SSR_REC                 *((volatile unsigned char*)(0x4270C0BCUL))
#define bFM_MFS6_UART_BGR_EXT                 *((volatile unsigned char*)(0x4270C1BCUL))
#define bFM_MFS6_UART_BGR1_EXT                *((volatile unsigned char*)(0x4270C1BCUL))
#define bFM_MFS6_UART_FCR_FE1                 *((volatile unsigned char*)(0x4270C280UL))
#define bFM_MFS6_UART_FCR_FE2                 *((volatile unsigned char*)(0x4270C284UL))
#define bFM_MFS6_UART_FCR_FCL1                *((volatile unsigned char*)(0x4270C288UL))
#define bFM_MFS6_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270C28CUL))
#define bFM_MFS6_UART_FCR_FSET                *((volatile unsigned char*)(0x4270C290UL))
#define bFM_MFS6_UART_FCR_FLD                 *((volatile unsigned char*)(0x4270C294UL))
#define bFM_MFS6_UART_FCR_FLST                *((volatile unsigned char*)(0x4270C298UL))
#define bFM_MFS6_UART_FCR_FSEL                *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM_MFS6_UART_FCR_FTIE                *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM_MFS6_UART_FCR_FDRQ                *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM_MFS6_UART_FCR_FRIIE               *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM_MFS6_UART_FCR_FLSTE               *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM_MFS6_UART_FCR0_FE1                *((volatile unsigned char*)(0x4270C280UL))
#define bFM_MFS6_UART_FCR0_FE2                *((volatile unsigned char*)(0x4270C284UL))
#define bFM_MFS6_UART_FCR0_FCL1               *((volatile unsigned char*)(0x4270C288UL))
#define bFM_MFS6_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270C28CUL))
#define bFM_MFS6_UART_FCR0_FSET               *((volatile unsigned char*)(0x4270C290UL))
#define bFM_MFS6_UART_FCR0_FLD                *((volatile unsigned char*)(0x4270C294UL))
#define bFM_MFS6_UART_FCR0_FLST               *((volatile unsigned char*)(0x4270C298UL))
#define bFM_MFS6_UART_FCR1_FSEL               *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM_MFS6_UART_FCR1_FTIE               *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM_MFS6_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM_MFS6_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM_MFS6_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM_MFS6_UART_FBYTE_FD0               *((volatile unsigned char*)(0x4270C300UL))
#define bFM_MFS6_UART_FBYTE_FD1               *((volatile unsigned char*)(0x4270C304UL))
#define bFM_MFS6_UART_FBYTE_FD2               *((volatile unsigned char*)(0x4270C308UL))
#define bFM_MFS6_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270C30CUL))
#define bFM_MFS6_UART_FBYTE_FD4               *((volatile unsigned char*)(0x4270C310UL))
#define bFM_MFS6_UART_FBYTE_FD5               *((volatile unsigned char*)(0x4270C314UL))
#define bFM_MFS6_UART_FBYTE_FD6               *((volatile unsigned char*)(0x4270C318UL))
#define bFM_MFS6_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270C31CUL))
#define bFM_MFS6_UART_FBYTE_FD8               *((volatile unsigned char*)(0x4270C320UL))
#define bFM_MFS6_UART_FBYTE_FD9               *((volatile unsigned char*)(0x4270C324UL))
#define bFM_MFS6_UART_FBYTE_FD10              *((volatile unsigned char*)(0x4270C328UL))
#define bFM_MFS6_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270C32CUL))
#define bFM_MFS6_UART_FBYTE_FD12              *((volatile unsigned char*)(0x4270C330UL))
#define bFM_MFS6_UART_FBYTE_FD13              *((volatile unsigned char*)(0x4270C334UL))
#define bFM_MFS6_UART_FBYTE_FD14              *((volatile unsigned char*)(0x4270C338UL))
#define bFM_MFS6_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270C33CUL))
#define bFM_MFS6_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x4270C300UL))
#define bFM_MFS6_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x4270C304UL))
#define bFM_MFS6_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x4270C308UL))
#define bFM_MFS6_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270C30CUL))
#define bFM_MFS6_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x4270C310UL))
#define bFM_MFS6_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x4270C314UL))
#define bFM_MFS6_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x4270C318UL))
#define bFM_MFS6_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270C31CUL))
#define bFM_MFS6_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x4270C320UL))
#define bFM_MFS6_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x4270C324UL))
#define bFM_MFS6_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x4270C328UL))
#define bFM_MFS6_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270C32CUL))
#define bFM_MFS6_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x4270C330UL))
#define bFM_MFS6_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x4270C334UL))
#define bFM_MFS6_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x4270C338UL))
#define bFM_MFS6_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270C33CUL))

/* MFS CSIO channel 6 registers */
#define bFM_MFS6_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x4270C000UL))
#define bFM_MFS6_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x4270C004UL))
#define bFM_MFS6_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x4270C008UL))
#define bFM_MFS6_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270C00CUL))
#define bFM_MFS6_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x4270C014UL))
#define bFM_MFS6_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x4270C018UL))
#define bFM_MFS6_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270C01CUL))
#define bFM_MFS6_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x4270C020UL))
#define bFM_MFS6_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x4270C024UL))
#define bFM_MFS6_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x4270C028UL))
#define bFM_MFS6_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270C02CUL))
#define bFM_MFS6_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x4270C030UL))
#define bFM_MFS6_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x4270C034UL))
#define bFM_MFS6_CSIO_SCR_MS                  *((volatile unsigned char*)(0x4270C038UL))
#define bFM_MFS6_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270C03CUL))
#define bFM_MFS6_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x4270C080UL))
#define bFM_MFS6_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x4270C084UL))
#define bFM_MFS6_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x4270C088UL))
#define bFM_MFS6_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270C08CUL))
#define bFM_MFS6_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x4270C090UL))
#define bFM_MFS6_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x4270C094UL))
#define bFM_MFS6_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x4270C098UL))
#define bFM_MFS6_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270C09CUL))
#define bFM_MFS6_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x4270C0A0UL))
#define bFM_MFS6_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x4270C0A4UL))
#define bFM_MFS6_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x4270C0A8UL))
#define bFM_MFS6_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x4270C0ACUL))
#define bFM_MFS6_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x4270C0B0UL))
#define bFM_MFS6_CSIO_SSR_REC                 *((volatile unsigned char*)(0x4270C0BCUL))
#define bFM_MFS6_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x4270C280UL))
#define bFM_MFS6_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x4270C284UL))
#define bFM_MFS6_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x4270C288UL))
#define bFM_MFS6_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270C28CUL))
#define bFM_MFS6_CSIO_FCR_FSET                *((volatile unsigned char*)(0x4270C290UL))
#define bFM_MFS6_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x4270C294UL))
#define bFM_MFS6_CSIO_FCR_FLST                *((volatile unsigned char*)(0x4270C298UL))
#define bFM_MFS6_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM_MFS6_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM_MFS6_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM_MFS6_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM_MFS6_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM_MFS6_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x4270C280UL))
#define bFM_MFS6_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x4270C284UL))
#define bFM_MFS6_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x4270C288UL))
#define bFM_MFS6_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270C28CUL))
#define bFM_MFS6_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x4270C290UL))
#define bFM_MFS6_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x4270C294UL))
#define bFM_MFS6_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x4270C298UL))
#define bFM_MFS6_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM_MFS6_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM_MFS6_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM_MFS6_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM_MFS6_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM_MFS6_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x4270C300UL))
#define bFM_MFS6_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x4270C304UL))
#define bFM_MFS6_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x4270C308UL))
#define bFM_MFS6_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270C30CUL))
#define bFM_MFS6_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x4270C310UL))
#define bFM_MFS6_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x4270C314UL))
#define bFM_MFS6_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x4270C318UL))
#define bFM_MFS6_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270C31CUL))
#define bFM_MFS6_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x4270C320UL))
#define bFM_MFS6_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x4270C324UL))
#define bFM_MFS6_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x4270C328UL))
#define bFM_MFS6_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270C32CUL))
#define bFM_MFS6_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x4270C330UL))
#define bFM_MFS6_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x4270C334UL))
#define bFM_MFS6_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x4270C338UL))
#define bFM_MFS6_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270C33CUL))
#define bFM_MFS6_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x4270C300UL))
#define bFM_MFS6_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x4270C304UL))
#define bFM_MFS6_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x4270C308UL))
#define bFM_MFS6_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270C30CUL))
#define bFM_MFS6_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x4270C310UL))
#define bFM_MFS6_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x4270C314UL))
#define bFM_MFS6_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x4270C318UL))
#define bFM_MFS6_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270C31CUL))
#define bFM_MFS6_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x4270C320UL))
#define bFM_MFS6_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x4270C324UL))
#define bFM_MFS6_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x4270C328UL))
#define bFM_MFS6_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270C32CUL))
#define bFM_MFS6_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x4270C330UL))
#define bFM_MFS6_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x4270C334UL))
#define bFM_MFS6_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x4270C338UL))
#define bFM_MFS6_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270C33CUL))
#define bFM_MFS6_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x4270C380UL))
#define bFM_MFS6_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x4270C384UL))
#define bFM_MFS6_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x4270C388UL))
#define bFM_MFS6_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270C38CUL))
#define bFM_MFS6_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x4270C390UL))
#define bFM_MFS6_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x4270C394UL))
#define bFM_MFS6_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x4270C398UL))
#define bFM_MFS6_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270C39CUL))
#define bFM_MFS6_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x4270C3A0UL))
#define bFM_MFS6_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x4270C3A4UL))
#define bFM_MFS6_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x4270C3A8UL))
#define bFM_MFS6_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x4270C3ACUL))
#define bFM_MFS6_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x4270C3B0UL))
#define bFM_MFS6_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x4270C3B4UL))
#define bFM_MFS6_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x4270C3B8UL))
#define bFM_MFS6_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x4270C3BCUL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x4270C400UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x4270C404UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x4270C408UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270C40CUL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x4270C410UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x4270C414UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x4270C418UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270C41CUL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x4270C420UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x4270C424UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x4270C428UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270C42CUL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x4270C430UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x4270C434UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x4270C438UL))
#define bFM_MFS6_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270C43CUL))
#define bFM_MFS6_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x4270C480UL))
#define bFM_MFS6_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x4270C484UL))
#define bFM_MFS6_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x4270C488UL))
#define bFM_MFS6_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270C48CUL))
#define bFM_MFS6_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x4270C490UL))
#define bFM_MFS6_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x4270C498UL))
#define bFM_MFS6_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270C49CUL))
#define bFM_MFS6_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x4270C4A0UL))
#define bFM_MFS6_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x4270C4ACUL))
#define bFM_MFS6_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x4270C4B0UL))
#define bFM_MFS6_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x4270C4B4UL))
#define bFM_MFS6_CSIO_STMR_TM0                *((volatile unsigned char*)(0x4270C500UL))
#define bFM_MFS6_CSIO_STMR_TM1                *((volatile unsigned char*)(0x4270C504UL))
#define bFM_MFS6_CSIO_STMR_TM2                *((volatile unsigned char*)(0x4270C508UL))
#define bFM_MFS6_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270C50CUL))
#define bFM_MFS6_CSIO_STMR_TM4                *((volatile unsigned char*)(0x4270C510UL))
#define bFM_MFS6_CSIO_STMR_TM5                *((volatile unsigned char*)(0x4270C514UL))
#define bFM_MFS6_CSIO_STMR_TM6                *((volatile unsigned char*)(0x4270C518UL))
#define bFM_MFS6_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270C51CUL))
#define bFM_MFS6_CSIO_STMR_TM8                *((volatile unsigned char*)(0x4270C520UL))
#define bFM_MFS6_CSIO_STMR_TM9                *((volatile unsigned char*)(0x4270C524UL))
#define bFM_MFS6_CSIO_STMR_TM10               *((volatile unsigned char*)(0x4270C528UL))
#define bFM_MFS6_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270C52CUL))
#define bFM_MFS6_CSIO_STMR_TM12               *((volatile unsigned char*)(0x4270C530UL))
#define bFM_MFS6_CSIO_STMR_TM13               *((volatile unsigned char*)(0x4270C534UL))
#define bFM_MFS6_CSIO_STMR_TM14               *((volatile unsigned char*)(0x4270C538UL))
#define bFM_MFS6_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270C53CUL))
#define bFM_MFS6_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x4270C580UL))
#define bFM_MFS6_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x4270C584UL))
#define bFM_MFS6_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x4270C588UL))
#define bFM_MFS6_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270C58CUL))
#define bFM_MFS6_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x4270C590UL))
#define bFM_MFS6_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x4270C594UL))
#define bFM_MFS6_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x4270C598UL))
#define bFM_MFS6_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270C59CUL))
#define bFM_MFS6_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x4270C5A0UL))
#define bFM_MFS6_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x4270C5A4UL))
#define bFM_MFS6_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x4270C5A8UL))
#define bFM_MFS6_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x4270C5ACUL))
#define bFM_MFS6_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x4270C5B0UL))
#define bFM_MFS6_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x4270C5B4UL))
#define bFM_MFS6_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x4270C5B8UL))
#define bFM_MFS6_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x4270C5BCUL))
#define bFM_MFS6_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x4270C600UL))
#define bFM_MFS6_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x4270C604UL))
#define bFM_MFS6_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x4270C608UL))
#define bFM_MFS6_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270C60CUL))
#define bFM_MFS6_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x4270C610UL))
#define bFM_MFS6_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x4270C614UL))
#define bFM_MFS6_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x4270C618UL))
#define bFM_MFS6_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270C61CUL))
#define bFM_MFS6_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x4270C620UL))
#define bFM_MFS6_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x4270C624UL))
#define bFM_MFS6_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x4270C628UL))
#define bFM_MFS6_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270C62CUL))
#define bFM_MFS6_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x4270C630UL))
#define bFM_MFS6_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x4270C634UL))
#define bFM_MFS6_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x4270C638UL))
#define bFM_MFS6_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270C63CUL))
#define bFM_MFS6_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x4270C680UL))
#define bFM_MFS6_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x4270C684UL))
#define bFM_MFS6_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x4270C688UL))
#define bFM_MFS6_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270C68CUL))
#define bFM_MFS6_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x4270C690UL))
#define bFM_MFS6_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x4270C694UL))
#define bFM_MFS6_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x4270C698UL))
#define bFM_MFS6_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270C69CUL))
#define bFM_MFS6_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x4270C6A0UL))
#define bFM_MFS6_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x4270C6A4UL))
#define bFM_MFS6_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x4270C6A8UL))
#define bFM_MFS6_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x4270C6ACUL))
#define bFM_MFS6_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x4270C6B0UL))
#define bFM_MFS6_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x4270C6B4UL))
#define bFM_MFS6_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x4270C6B8UL))
#define bFM_MFS6_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x4270C6BCUL))
#define bFM_MFS6_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x4270C700UL))
#define bFM_MFS6_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x4270C704UL))
#define bFM_MFS6_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x4270C708UL))
#define bFM_MFS6_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270C70CUL))
#define bFM_MFS6_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x4270C710UL))
#define bFM_MFS6_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x4270C714UL))
#define bFM_MFS6_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x4270C718UL))
#define bFM_MFS6_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270C71CUL))

/* MFS LIN channel 6 registers */
#define bFM_MFS6_LIN_SMR_SOE                  *((volatile unsigned char*)(0x4270C000UL))
#define bFM_MFS6_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270C00CUL))
#define bFM_MFS6_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x4270C010UL))
#define bFM_MFS6_LIN_SMR_MD0                  *((volatile unsigned char*)(0x4270C014UL))
#define bFM_MFS6_LIN_SMR_MD1                  *((volatile unsigned char*)(0x4270C018UL))
#define bFM_MFS6_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270C01CUL))
#define bFM_MFS6_LIN_SCR_TXE                  *((volatile unsigned char*)(0x4270C020UL))
#define bFM_MFS6_LIN_SCR_RXE                  *((volatile unsigned char*)(0x4270C024UL))
#define bFM_MFS6_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x4270C028UL))
#define bFM_MFS6_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270C02CUL))
#define bFM_MFS6_LIN_SCR_RIE                  *((volatile unsigned char*)(0x4270C030UL))
#define bFM_MFS6_LIN_SCR_LBR                  *((volatile unsigned char*)(0x4270C034UL))
#define bFM_MFS6_LIN_SCR_MS                   *((volatile unsigned char*)(0x4270C038UL))
#define bFM_MFS6_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270C03CUL))
#define bFM_MFS6_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x4270C080UL))
#define bFM_MFS6_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x4270C084UL))
#define bFM_MFS6_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x4270C088UL))
#define bFM_MFS6_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270C08CUL))
#define bFM_MFS6_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x4270C090UL))
#define bFM_MFS6_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x4270C098UL))
#define bFM_MFS6_LIN_SSR_TBI                  *((volatile unsigned char*)(0x4270C0A0UL))
#define bFM_MFS6_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x4270C0A4UL))
#define bFM_MFS6_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x4270C0A8UL))
#define bFM_MFS6_LIN_SSR_ORE                  *((volatile unsigned char*)(0x4270C0ACUL))
#define bFM_MFS6_LIN_SSR_FRE                  *((volatile unsigned char*)(0x4270C0B0UL))
#define bFM_MFS6_LIN_SSR_LBD                  *((volatile unsigned char*)(0x4270C0B4UL))
#define bFM_MFS6_LIN_SSR_REC                  *((volatile unsigned char*)(0x4270C0BCUL))
#define bFM_MFS6_LIN_BGR_EXT                  *((volatile unsigned char*)(0x4270C1BCUL))
#define bFM_MFS6_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x4270C1BCUL))
#define bFM_MFS6_LIN_FCR_FE1                  *((volatile unsigned char*)(0x4270C280UL))
#define bFM_MFS6_LIN_FCR_FE2                  *((volatile unsigned char*)(0x4270C284UL))
#define bFM_MFS6_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x4270C288UL))
#define bFM_MFS6_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270C28CUL))
#define bFM_MFS6_LIN_FCR_FSET                 *((volatile unsigned char*)(0x4270C290UL))
#define bFM_MFS6_LIN_FCR_FLD                  *((volatile unsigned char*)(0x4270C294UL))
#define bFM_MFS6_LIN_FCR_FLST                 *((volatile unsigned char*)(0x4270C298UL))
#define bFM_MFS6_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM_MFS6_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM_MFS6_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM_MFS6_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM_MFS6_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM_MFS6_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x4270C280UL))
#define bFM_MFS6_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x4270C284UL))
#define bFM_MFS6_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x4270C288UL))
#define bFM_MFS6_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270C28CUL))
#define bFM_MFS6_LIN_FCR0_FSET                *((volatile unsigned char*)(0x4270C290UL))
#define bFM_MFS6_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x4270C294UL))
#define bFM_MFS6_LIN_FCR0_FLST                *((volatile unsigned char*)(0x4270C298UL))
#define bFM_MFS6_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM_MFS6_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM_MFS6_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM_MFS6_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM_MFS6_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM_MFS6_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x4270C300UL))
#define bFM_MFS6_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x4270C304UL))
#define bFM_MFS6_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x4270C308UL))
#define bFM_MFS6_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270C30CUL))
#define bFM_MFS6_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x4270C310UL))
#define bFM_MFS6_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x4270C314UL))
#define bFM_MFS6_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x4270C318UL))
#define bFM_MFS6_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270C31CUL))
#define bFM_MFS6_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x4270C320UL))
#define bFM_MFS6_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x4270C324UL))
#define bFM_MFS6_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x4270C328UL))
#define bFM_MFS6_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270C32CUL))
#define bFM_MFS6_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x4270C330UL))
#define bFM_MFS6_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x4270C334UL))
#define bFM_MFS6_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x4270C338UL))
#define bFM_MFS6_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270C33CUL))
#define bFM_MFS6_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x4270C300UL))
#define bFM_MFS6_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x4270C304UL))
#define bFM_MFS6_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x4270C308UL))
#define bFM_MFS6_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270C30CUL))
#define bFM_MFS6_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x4270C310UL))
#define bFM_MFS6_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x4270C314UL))
#define bFM_MFS6_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x4270C318UL))
#define bFM_MFS6_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270C31CUL))
#define bFM_MFS6_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x4270C320UL))
#define bFM_MFS6_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x4270C324UL))
#define bFM_MFS6_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x4270C328UL))
#define bFM_MFS6_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270C32CUL))
#define bFM_MFS6_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x4270C330UL))
#define bFM_MFS6_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x4270C334UL))
#define bFM_MFS6_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x4270C338UL))
#define bFM_MFS6_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270C33CUL))

/* MFS I2C channel 6 registers */
#define bFM_MFS6_I2C_SMR_TIE                  *((volatile unsigned char*)(0x4270C008UL))
#define bFM_MFS6_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270C00CUL))
#define bFM_MFS6_I2C_SMR_MD0                  *((volatile unsigned char*)(0x4270C014UL))
#define bFM_MFS6_I2C_SMR_MD1                  *((volatile unsigned char*)(0x4270C018UL))
#define bFM_MFS6_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270C01CUL))
#define bFM_MFS6_I2C_IBCR_INT                 *((volatile unsigned char*)(0x4270C020UL))
#define bFM_MFS6_I2C_IBCR_BER                 *((volatile unsigned char*)(0x4270C024UL))
#define bFM_MFS6_I2C_IBCR_INTE                *((volatile unsigned char*)(0x4270C028UL))
#define bFM_MFS6_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270C02CUL))
#define bFM_MFS6_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x4270C030UL))
#define bFM_MFS6_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x4270C034UL))
#define bFM_MFS6_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x4270C038UL))
#define bFM_MFS6_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x4270C038UL))
#define bFM_MFS6_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270C03CUL))
#define bFM_MFS6_I2C_IBSR_BB                  *((volatile unsigned char*)(0x4270C080UL))
#define bFM_MFS6_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x4270C084UL))
#define bFM_MFS6_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x4270C088UL))
#define bFM_MFS6_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270C08CUL))
#define bFM_MFS6_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x4270C090UL))
#define bFM_MFS6_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x4270C094UL))
#define bFM_MFS6_I2C_IBSR_RACK                *((volatile unsigned char*)(0x4270C098UL))
#define bFM_MFS6_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270C09CUL))
#define bFM_MFS6_I2C_SSR_TBI                  *((volatile unsigned char*)(0x4270C0A0UL))
#define bFM_MFS6_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x4270C0A4UL))
#define bFM_MFS6_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x4270C0A8UL))
#define bFM_MFS6_I2C_SSR_ORE                  *((volatile unsigned char*)(0x4270C0ACUL))
#define bFM_MFS6_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x4270C0B0UL))
#define bFM_MFS6_I2C_SSR_DMA                  *((volatile unsigned char*)(0x4270C0B4UL))
#define bFM_MFS6_I2C_SSR_TSET                 *((volatile unsigned char*)(0x4270C0B8UL))
#define bFM_MFS6_I2C_SSR_REC                  *((volatile unsigned char*)(0x4270C0BCUL))
#define bFM_MFS6_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x4270C200UL))
#define bFM_MFS6_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x4270C204UL))
#define bFM_MFS6_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x4270C208UL))
#define bFM_MFS6_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270C20CUL))
#define bFM_MFS6_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x4270C210UL))
#define bFM_MFS6_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x4270C214UL))
#define bFM_MFS6_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x4270C218UL))
#define bFM_MFS6_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270C21CUL))
#define bFM_MFS6_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x4270C220UL))
#define bFM_MFS6_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x4270C224UL))
#define bFM_MFS6_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x4270C228UL))
#define bFM_MFS6_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270C22CUL))
#define bFM_MFS6_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x4270C230UL))
#define bFM_MFS6_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x4270C234UL))
#define bFM_MFS6_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x4270C238UL))
#define bFM_MFS6_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270C23CUL))
#define bFM_MFS6_I2C_FCR_FE1                  *((volatile unsigned char*)(0x4270C280UL))
#define bFM_MFS6_I2C_FCR_FE2                  *((volatile unsigned char*)(0x4270C284UL))
#define bFM_MFS6_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x4270C288UL))
#define bFM_MFS6_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270C28CUL))
#define bFM_MFS6_I2C_FCR_FSET                 *((volatile unsigned char*)(0x4270C290UL))
#define bFM_MFS6_I2C_FCR_FLD                  *((volatile unsigned char*)(0x4270C294UL))
#define bFM_MFS6_I2C_FCR_FLST                 *((volatile unsigned char*)(0x4270C298UL))
#define bFM_MFS6_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM_MFS6_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM_MFS6_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM_MFS6_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM_MFS6_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM_MFS6_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x4270C280UL))
#define bFM_MFS6_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x4270C284UL))
#define bFM_MFS6_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x4270C288UL))
#define bFM_MFS6_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270C28CUL))
#define bFM_MFS6_I2C_FCR0_FSET                *((volatile unsigned char*)(0x4270C290UL))
#define bFM_MFS6_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x4270C294UL))
#define bFM_MFS6_I2C_FCR0_FLST                *((volatile unsigned char*)(0x4270C298UL))
#define bFM_MFS6_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x4270C2A0UL))
#define bFM_MFS6_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x4270C2A4UL))
#define bFM_MFS6_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x4270C2A8UL))
#define bFM_MFS6_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x4270C2ACUL))
#define bFM_MFS6_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x4270C2B0UL))
#define bFM_MFS6_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x4270C300UL))
#define bFM_MFS6_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x4270C304UL))
#define bFM_MFS6_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x4270C308UL))
#define bFM_MFS6_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270C30CUL))
#define bFM_MFS6_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x4270C310UL))
#define bFM_MFS6_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x4270C314UL))
#define bFM_MFS6_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x4270C318UL))
#define bFM_MFS6_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270C31CUL))
#define bFM_MFS6_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x4270C320UL))
#define bFM_MFS6_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x4270C324UL))
#define bFM_MFS6_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x4270C328UL))
#define bFM_MFS6_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270C32CUL))
#define bFM_MFS6_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x4270C330UL))
#define bFM_MFS6_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x4270C334UL))
#define bFM_MFS6_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x4270C338UL))
#define bFM_MFS6_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270C33CUL))
#define bFM_MFS6_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x4270C300UL))
#define bFM_MFS6_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x4270C304UL))
#define bFM_MFS6_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x4270C308UL))
#define bFM_MFS6_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270C30CUL))
#define bFM_MFS6_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x4270C310UL))
#define bFM_MFS6_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x4270C314UL))
#define bFM_MFS6_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x4270C318UL))
#define bFM_MFS6_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270C31CUL))
#define bFM_MFS6_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x4270C320UL))
#define bFM_MFS6_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x4270C324UL))
#define bFM_MFS6_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x4270C328UL))
#define bFM_MFS6_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270C32CUL))
#define bFM_MFS6_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x4270C330UL))
#define bFM_MFS6_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x4270C334UL))
#define bFM_MFS6_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x4270C338UL))
#define bFM_MFS6_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270C33CUL))

/* MFS UART channel 7 registers */
#define bFM_MFS7_UART_SMR_SOE                 *((volatile unsigned char*)(0x4270E000UL))
#define bFM_MFS7_UART_SMR_BDS                 *((volatile unsigned char*)(0x4270E008UL))
#define bFM_MFS7_UART_SMR_SBL                 *((volatile unsigned char*)(0x4270E00CUL))
#define bFM_MFS7_UART_SMR_WUCR                *((volatile unsigned char*)(0x4270E010UL))
#define bFM_MFS7_UART_SMR_MD0                 *((volatile unsigned char*)(0x4270E014UL))
#define bFM_MFS7_UART_SMR_MD1                 *((volatile unsigned char*)(0x4270E018UL))
#define bFM_MFS7_UART_SMR_MD2                 *((volatile unsigned char*)(0x4270E01CUL))
#define bFM_MFS7_UART_SCR_TXE                 *((volatile unsigned char*)(0x4270E020UL))
#define bFM_MFS7_UART_SCR_RXE                 *((volatile unsigned char*)(0x4270E024UL))
#define bFM_MFS7_UART_SCR_TBIE                *((volatile unsigned char*)(0x4270E028UL))
#define bFM_MFS7_UART_SCR_TIE                 *((volatile unsigned char*)(0x4270E02CUL))
#define bFM_MFS7_UART_SCR_RIE                 *((volatile unsigned char*)(0x4270E030UL))
#define bFM_MFS7_UART_SCR_UPCL                *((volatile unsigned char*)(0x4270E03CUL))
#define bFM_MFS7_UART_ESCR_L0                 *((volatile unsigned char*)(0x4270E080UL))
#define bFM_MFS7_UART_ESCR_L1                 *((volatile unsigned char*)(0x4270E084UL))
#define bFM_MFS7_UART_ESCR_L2                 *((volatile unsigned char*)(0x4270E088UL))
#define bFM_MFS7_UART_ESCR_P                  *((volatile unsigned char*)(0x4270E08CUL))
#define bFM_MFS7_UART_ESCR_PEN                *((volatile unsigned char*)(0x4270E090UL))
#define bFM_MFS7_UART_ESCR_INV                *((volatile unsigned char*)(0x4270E094UL))
#define bFM_MFS7_UART_ESCR_ESBL               *((volatile unsigned char*)(0x4270E098UL))
#define bFM_MFS7_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4270E09CUL))
#define bFM_MFS7_UART_SSR_TBI                 *((volatile unsigned char*)(0x4270E0A0UL))
#define bFM_MFS7_UART_SSR_TDRE                *((volatile unsigned char*)(0x4270E0A4UL))
#define bFM_MFS7_UART_SSR_RDRF                *((volatile unsigned char*)(0x4270E0A8UL))
#define bFM_MFS7_UART_SSR_ORE                 *((volatile unsigned char*)(0x4270E0ACUL))
#define bFM_MFS7_UART_SSR_FRE                 *((volatile unsigned char*)(0x4270E0B0UL))
#define bFM_MFS7_UART_SSR_PE                  *((volatile unsigned char*)(0x4270E0B4UL))
#define bFM_MFS7_UART_SSR_REC                 *((volatile unsigned char*)(0x4270E0BCUL))
#define bFM_MFS7_UART_BGR_EXT                 *((volatile unsigned char*)(0x4270E1BCUL))
#define bFM_MFS7_UART_BGR1_EXT                *((volatile unsigned char*)(0x4270E1BCUL))
#define bFM_MFS7_UART_FCR_FE1                 *((volatile unsigned char*)(0x4270E280UL))
#define bFM_MFS7_UART_FCR_FE2                 *((volatile unsigned char*)(0x4270E284UL))
#define bFM_MFS7_UART_FCR_FCL1                *((volatile unsigned char*)(0x4270E288UL))
#define bFM_MFS7_UART_FCR_FCL2                *((volatile unsigned char*)(0x4270E28CUL))
#define bFM_MFS7_UART_FCR_FSET                *((volatile unsigned char*)(0x4270E290UL))
#define bFM_MFS7_UART_FCR_FLD                 *((volatile unsigned char*)(0x4270E294UL))
#define bFM_MFS7_UART_FCR_FLST                *((volatile unsigned char*)(0x4270E298UL))
#define bFM_MFS7_UART_FCR_FSEL                *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM_MFS7_UART_FCR_FTIE                *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM_MFS7_UART_FCR_FDRQ                *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM_MFS7_UART_FCR_FRIIE               *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM_MFS7_UART_FCR_FLSTE               *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM_MFS7_UART_FCR0_FE1                *((volatile unsigned char*)(0x4270E280UL))
#define bFM_MFS7_UART_FCR0_FE2                *((volatile unsigned char*)(0x4270E284UL))
#define bFM_MFS7_UART_FCR0_FCL1               *((volatile unsigned char*)(0x4270E288UL))
#define bFM_MFS7_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4270E28CUL))
#define bFM_MFS7_UART_FCR0_FSET               *((volatile unsigned char*)(0x4270E290UL))
#define bFM_MFS7_UART_FCR0_FLD                *((volatile unsigned char*)(0x4270E294UL))
#define bFM_MFS7_UART_FCR0_FLST               *((volatile unsigned char*)(0x4270E298UL))
#define bFM_MFS7_UART_FCR1_FSEL               *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM_MFS7_UART_FCR1_FTIE               *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM_MFS7_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM_MFS7_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM_MFS7_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM_MFS7_UART_FBYTE_FD0               *((volatile unsigned char*)(0x4270E300UL))
#define bFM_MFS7_UART_FBYTE_FD1               *((volatile unsigned char*)(0x4270E304UL))
#define bFM_MFS7_UART_FBYTE_FD2               *((volatile unsigned char*)(0x4270E308UL))
#define bFM_MFS7_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4270E30CUL))
#define bFM_MFS7_UART_FBYTE_FD4               *((volatile unsigned char*)(0x4270E310UL))
#define bFM_MFS7_UART_FBYTE_FD5               *((volatile unsigned char*)(0x4270E314UL))
#define bFM_MFS7_UART_FBYTE_FD6               *((volatile unsigned char*)(0x4270E318UL))
#define bFM_MFS7_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4270E31CUL))
#define bFM_MFS7_UART_FBYTE_FD8               *((volatile unsigned char*)(0x4270E320UL))
#define bFM_MFS7_UART_FBYTE_FD9               *((volatile unsigned char*)(0x4270E324UL))
#define bFM_MFS7_UART_FBYTE_FD10              *((volatile unsigned char*)(0x4270E328UL))
#define bFM_MFS7_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4270E32CUL))
#define bFM_MFS7_UART_FBYTE_FD12              *((volatile unsigned char*)(0x4270E330UL))
#define bFM_MFS7_UART_FBYTE_FD13              *((volatile unsigned char*)(0x4270E334UL))
#define bFM_MFS7_UART_FBYTE_FD14              *((volatile unsigned char*)(0x4270E338UL))
#define bFM_MFS7_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4270E33CUL))
#define bFM_MFS7_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x4270E300UL))
#define bFM_MFS7_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x4270E304UL))
#define bFM_MFS7_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x4270E308UL))
#define bFM_MFS7_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4270E30CUL))
#define bFM_MFS7_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x4270E310UL))
#define bFM_MFS7_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x4270E314UL))
#define bFM_MFS7_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x4270E318UL))
#define bFM_MFS7_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4270E31CUL))
#define bFM_MFS7_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x4270E320UL))
#define bFM_MFS7_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x4270E324UL))
#define bFM_MFS7_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x4270E328UL))
#define bFM_MFS7_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4270E32CUL))
#define bFM_MFS7_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x4270E330UL))
#define bFM_MFS7_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x4270E334UL))
#define bFM_MFS7_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x4270E338UL))
#define bFM_MFS7_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4270E33CUL))

/* MFS CSIO channel 7 registers */
#define bFM_MFS7_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x4270E000UL))
#define bFM_MFS7_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x4270E004UL))
#define bFM_MFS7_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x4270E008UL))
#define bFM_MFS7_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4270E00CUL))
#define bFM_MFS7_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x4270E014UL))
#define bFM_MFS7_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x4270E018UL))
#define bFM_MFS7_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4270E01CUL))
#define bFM_MFS7_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x4270E020UL))
#define bFM_MFS7_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x4270E024UL))
#define bFM_MFS7_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x4270E028UL))
#define bFM_MFS7_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4270E02CUL))
#define bFM_MFS7_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x4270E030UL))
#define bFM_MFS7_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x4270E034UL))
#define bFM_MFS7_CSIO_SCR_MS                  *((volatile unsigned char*)(0x4270E038UL))
#define bFM_MFS7_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4270E03CUL))
#define bFM_MFS7_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x4270E080UL))
#define bFM_MFS7_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x4270E084UL))
#define bFM_MFS7_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x4270E088UL))
#define bFM_MFS7_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4270E08CUL))
#define bFM_MFS7_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x4270E090UL))
#define bFM_MFS7_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x4270E094UL))
#define bFM_MFS7_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x4270E098UL))
#define bFM_MFS7_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4270E09CUL))
#define bFM_MFS7_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x4270E0A0UL))
#define bFM_MFS7_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x4270E0A4UL))
#define bFM_MFS7_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x4270E0A8UL))
#define bFM_MFS7_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x4270E0ACUL))
#define bFM_MFS7_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x4270E0B0UL))
#define bFM_MFS7_CSIO_SSR_REC                 *((volatile unsigned char*)(0x4270E0BCUL))
#define bFM_MFS7_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x4270E280UL))
#define bFM_MFS7_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x4270E284UL))
#define bFM_MFS7_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x4270E288UL))
#define bFM_MFS7_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4270E28CUL))
#define bFM_MFS7_CSIO_FCR_FSET                *((volatile unsigned char*)(0x4270E290UL))
#define bFM_MFS7_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x4270E294UL))
#define bFM_MFS7_CSIO_FCR_FLST                *((volatile unsigned char*)(0x4270E298UL))
#define bFM_MFS7_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM_MFS7_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM_MFS7_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM_MFS7_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM_MFS7_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM_MFS7_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x4270E280UL))
#define bFM_MFS7_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x4270E284UL))
#define bFM_MFS7_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x4270E288UL))
#define bFM_MFS7_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4270E28CUL))
#define bFM_MFS7_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x4270E290UL))
#define bFM_MFS7_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x4270E294UL))
#define bFM_MFS7_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x4270E298UL))
#define bFM_MFS7_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM_MFS7_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM_MFS7_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM_MFS7_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM_MFS7_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM_MFS7_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x4270E300UL))
#define bFM_MFS7_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x4270E304UL))
#define bFM_MFS7_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x4270E308UL))
#define bFM_MFS7_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4270E30CUL))
#define bFM_MFS7_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x4270E310UL))
#define bFM_MFS7_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x4270E314UL))
#define bFM_MFS7_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x4270E318UL))
#define bFM_MFS7_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4270E31CUL))
#define bFM_MFS7_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x4270E320UL))
#define bFM_MFS7_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x4270E324UL))
#define bFM_MFS7_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x4270E328UL))
#define bFM_MFS7_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4270E32CUL))
#define bFM_MFS7_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x4270E330UL))
#define bFM_MFS7_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x4270E334UL))
#define bFM_MFS7_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x4270E338UL))
#define bFM_MFS7_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4270E33CUL))
#define bFM_MFS7_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x4270E300UL))
#define bFM_MFS7_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x4270E304UL))
#define bFM_MFS7_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x4270E308UL))
#define bFM_MFS7_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4270E30CUL))
#define bFM_MFS7_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x4270E310UL))
#define bFM_MFS7_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x4270E314UL))
#define bFM_MFS7_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x4270E318UL))
#define bFM_MFS7_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4270E31CUL))
#define bFM_MFS7_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x4270E320UL))
#define bFM_MFS7_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x4270E324UL))
#define bFM_MFS7_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x4270E328UL))
#define bFM_MFS7_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4270E32CUL))
#define bFM_MFS7_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x4270E330UL))
#define bFM_MFS7_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x4270E334UL))
#define bFM_MFS7_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x4270E338UL))
#define bFM_MFS7_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4270E33CUL))
#define bFM_MFS7_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x4270E380UL))
#define bFM_MFS7_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x4270E384UL))
#define bFM_MFS7_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x4270E388UL))
#define bFM_MFS7_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4270E38CUL))
#define bFM_MFS7_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x4270E390UL))
#define bFM_MFS7_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x4270E394UL))
#define bFM_MFS7_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x4270E398UL))
#define bFM_MFS7_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4270E39CUL))
#define bFM_MFS7_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x4270E3A0UL))
#define bFM_MFS7_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x4270E3A4UL))
#define bFM_MFS7_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x4270E3A8UL))
#define bFM_MFS7_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x4270E3ACUL))
#define bFM_MFS7_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x4270E3B0UL))
#define bFM_MFS7_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x4270E3B4UL))
#define bFM_MFS7_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x4270E3B8UL))
#define bFM_MFS7_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x4270E3BCUL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x4270E400UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x4270E404UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x4270E408UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4270E40CUL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x4270E410UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x4270E414UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x4270E418UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4270E41CUL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x4270E420UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x4270E424UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x4270E428UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4270E42CUL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x4270E430UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x4270E434UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x4270E438UL))
#define bFM_MFS7_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4270E43CUL))
#define bFM_MFS7_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x4270E480UL))
#define bFM_MFS7_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x4270E484UL))
#define bFM_MFS7_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x4270E488UL))
#define bFM_MFS7_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4270E48CUL))
#define bFM_MFS7_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x4270E490UL))
#define bFM_MFS7_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x4270E498UL))
#define bFM_MFS7_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4270E49CUL))
#define bFM_MFS7_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x4270E4A0UL))
#define bFM_MFS7_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x4270E4ACUL))
#define bFM_MFS7_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x4270E4B0UL))
#define bFM_MFS7_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x4270E4B4UL))
#define bFM_MFS7_CSIO_STMR_TM0                *((volatile unsigned char*)(0x4270E500UL))
#define bFM_MFS7_CSIO_STMR_TM1                *((volatile unsigned char*)(0x4270E504UL))
#define bFM_MFS7_CSIO_STMR_TM2                *((volatile unsigned char*)(0x4270E508UL))
#define bFM_MFS7_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4270E50CUL))
#define bFM_MFS7_CSIO_STMR_TM4                *((volatile unsigned char*)(0x4270E510UL))
#define bFM_MFS7_CSIO_STMR_TM5                *((volatile unsigned char*)(0x4270E514UL))
#define bFM_MFS7_CSIO_STMR_TM6                *((volatile unsigned char*)(0x4270E518UL))
#define bFM_MFS7_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4270E51CUL))
#define bFM_MFS7_CSIO_STMR_TM8                *((volatile unsigned char*)(0x4270E520UL))
#define bFM_MFS7_CSIO_STMR_TM9                *((volatile unsigned char*)(0x4270E524UL))
#define bFM_MFS7_CSIO_STMR_TM10               *((volatile unsigned char*)(0x4270E528UL))
#define bFM_MFS7_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4270E52CUL))
#define bFM_MFS7_CSIO_STMR_TM12               *((volatile unsigned char*)(0x4270E530UL))
#define bFM_MFS7_CSIO_STMR_TM13               *((volatile unsigned char*)(0x4270E534UL))
#define bFM_MFS7_CSIO_STMR_TM14               *((volatile unsigned char*)(0x4270E538UL))
#define bFM_MFS7_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4270E53CUL))
#define bFM_MFS7_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x4270E580UL))
#define bFM_MFS7_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x4270E584UL))
#define bFM_MFS7_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x4270E588UL))
#define bFM_MFS7_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4270E58CUL))
#define bFM_MFS7_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x4270E590UL))
#define bFM_MFS7_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x4270E594UL))
#define bFM_MFS7_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x4270E598UL))
#define bFM_MFS7_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4270E59CUL))
#define bFM_MFS7_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x4270E5A0UL))
#define bFM_MFS7_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x4270E5A4UL))
#define bFM_MFS7_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x4270E5A8UL))
#define bFM_MFS7_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x4270E5ACUL))
#define bFM_MFS7_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x4270E5B0UL))
#define bFM_MFS7_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x4270E5B4UL))
#define bFM_MFS7_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x4270E5B8UL))
#define bFM_MFS7_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x4270E5BCUL))
#define bFM_MFS7_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x4270E600UL))
#define bFM_MFS7_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x4270E604UL))
#define bFM_MFS7_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x4270E608UL))
#define bFM_MFS7_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4270E60CUL))
#define bFM_MFS7_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x4270E610UL))
#define bFM_MFS7_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x4270E614UL))
#define bFM_MFS7_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x4270E618UL))
#define bFM_MFS7_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4270E61CUL))
#define bFM_MFS7_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x4270E620UL))
#define bFM_MFS7_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x4270E624UL))
#define bFM_MFS7_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x4270E628UL))
#define bFM_MFS7_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4270E62CUL))
#define bFM_MFS7_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x4270E630UL))
#define bFM_MFS7_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x4270E634UL))
#define bFM_MFS7_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x4270E638UL))
#define bFM_MFS7_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4270E63CUL))
#define bFM_MFS7_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x4270E680UL))
#define bFM_MFS7_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x4270E684UL))
#define bFM_MFS7_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x4270E688UL))
#define bFM_MFS7_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4270E68CUL))
#define bFM_MFS7_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x4270E690UL))
#define bFM_MFS7_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x4270E694UL))
#define bFM_MFS7_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x4270E698UL))
#define bFM_MFS7_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4270E69CUL))
#define bFM_MFS7_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x4270E6A0UL))
#define bFM_MFS7_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x4270E6A4UL))
#define bFM_MFS7_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x4270E6A8UL))
#define bFM_MFS7_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x4270E6ACUL))
#define bFM_MFS7_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x4270E6B0UL))
#define bFM_MFS7_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x4270E6B4UL))
#define bFM_MFS7_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x4270E6B8UL))
#define bFM_MFS7_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x4270E6BCUL))
#define bFM_MFS7_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x4270E700UL))
#define bFM_MFS7_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x4270E704UL))
#define bFM_MFS7_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x4270E708UL))
#define bFM_MFS7_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4270E70CUL))
#define bFM_MFS7_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x4270E710UL))
#define bFM_MFS7_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x4270E714UL))
#define bFM_MFS7_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x4270E718UL))
#define bFM_MFS7_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4270E71CUL))

/* MFS LIN channel 7 registers */
#define bFM_MFS7_LIN_SMR_SOE                  *((volatile unsigned char*)(0x4270E000UL))
#define bFM_MFS7_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4270E00CUL))
#define bFM_MFS7_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x4270E010UL))
#define bFM_MFS7_LIN_SMR_MD0                  *((volatile unsigned char*)(0x4270E014UL))
#define bFM_MFS7_LIN_SMR_MD1                  *((volatile unsigned char*)(0x4270E018UL))
#define bFM_MFS7_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4270E01CUL))
#define bFM_MFS7_LIN_SCR_TXE                  *((volatile unsigned char*)(0x4270E020UL))
#define bFM_MFS7_LIN_SCR_RXE                  *((volatile unsigned char*)(0x4270E024UL))
#define bFM_MFS7_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x4270E028UL))
#define bFM_MFS7_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4270E02CUL))
#define bFM_MFS7_LIN_SCR_RIE                  *((volatile unsigned char*)(0x4270E030UL))
#define bFM_MFS7_LIN_SCR_LBR                  *((volatile unsigned char*)(0x4270E034UL))
#define bFM_MFS7_LIN_SCR_MS                   *((volatile unsigned char*)(0x4270E038UL))
#define bFM_MFS7_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4270E03CUL))
#define bFM_MFS7_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x4270E080UL))
#define bFM_MFS7_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x4270E084UL))
#define bFM_MFS7_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x4270E088UL))
#define bFM_MFS7_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4270E08CUL))
#define bFM_MFS7_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x4270E090UL))
#define bFM_MFS7_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x4270E098UL))
#define bFM_MFS7_LIN_SSR_TBI                  *((volatile unsigned char*)(0x4270E0A0UL))
#define bFM_MFS7_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x4270E0A4UL))
#define bFM_MFS7_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x4270E0A8UL))
#define bFM_MFS7_LIN_SSR_ORE                  *((volatile unsigned char*)(0x4270E0ACUL))
#define bFM_MFS7_LIN_SSR_FRE                  *((volatile unsigned char*)(0x4270E0B0UL))
#define bFM_MFS7_LIN_SSR_LBD                  *((volatile unsigned char*)(0x4270E0B4UL))
#define bFM_MFS7_LIN_SSR_REC                  *((volatile unsigned char*)(0x4270E0BCUL))
#define bFM_MFS7_LIN_BGR_EXT                  *((volatile unsigned char*)(0x4270E1BCUL))
#define bFM_MFS7_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x4270E1BCUL))
#define bFM_MFS7_LIN_FCR_FE1                  *((volatile unsigned char*)(0x4270E280UL))
#define bFM_MFS7_LIN_FCR_FE2                  *((volatile unsigned char*)(0x4270E284UL))
#define bFM_MFS7_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x4270E288UL))
#define bFM_MFS7_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4270E28CUL))
#define bFM_MFS7_LIN_FCR_FSET                 *((volatile unsigned char*)(0x4270E290UL))
#define bFM_MFS7_LIN_FCR_FLD                  *((volatile unsigned char*)(0x4270E294UL))
#define bFM_MFS7_LIN_FCR_FLST                 *((volatile unsigned char*)(0x4270E298UL))
#define bFM_MFS7_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM_MFS7_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM_MFS7_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM_MFS7_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM_MFS7_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM_MFS7_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x4270E280UL))
#define bFM_MFS7_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x4270E284UL))
#define bFM_MFS7_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x4270E288UL))
#define bFM_MFS7_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4270E28CUL))
#define bFM_MFS7_LIN_FCR0_FSET                *((volatile unsigned char*)(0x4270E290UL))
#define bFM_MFS7_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x4270E294UL))
#define bFM_MFS7_LIN_FCR0_FLST                *((volatile unsigned char*)(0x4270E298UL))
#define bFM_MFS7_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM_MFS7_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM_MFS7_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM_MFS7_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM_MFS7_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM_MFS7_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x4270E300UL))
#define bFM_MFS7_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x4270E304UL))
#define bFM_MFS7_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x4270E308UL))
#define bFM_MFS7_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4270E30CUL))
#define bFM_MFS7_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x4270E310UL))
#define bFM_MFS7_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x4270E314UL))
#define bFM_MFS7_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x4270E318UL))
#define bFM_MFS7_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4270E31CUL))
#define bFM_MFS7_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x4270E320UL))
#define bFM_MFS7_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x4270E324UL))
#define bFM_MFS7_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x4270E328UL))
#define bFM_MFS7_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4270E32CUL))
#define bFM_MFS7_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x4270E330UL))
#define bFM_MFS7_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x4270E334UL))
#define bFM_MFS7_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x4270E338UL))
#define bFM_MFS7_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4270E33CUL))
#define bFM_MFS7_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x4270E300UL))
#define bFM_MFS7_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x4270E304UL))
#define bFM_MFS7_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x4270E308UL))
#define bFM_MFS7_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4270E30CUL))
#define bFM_MFS7_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x4270E310UL))
#define bFM_MFS7_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x4270E314UL))
#define bFM_MFS7_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x4270E318UL))
#define bFM_MFS7_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4270E31CUL))
#define bFM_MFS7_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x4270E320UL))
#define bFM_MFS7_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x4270E324UL))
#define bFM_MFS7_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x4270E328UL))
#define bFM_MFS7_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4270E32CUL))
#define bFM_MFS7_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x4270E330UL))
#define bFM_MFS7_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x4270E334UL))
#define bFM_MFS7_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x4270E338UL))
#define bFM_MFS7_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4270E33CUL))

/* MFS I2C channel 7 registers */
#define bFM_MFS7_I2C_SMR_TIE                  *((volatile unsigned char*)(0x4270E008UL))
#define bFM_MFS7_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4270E00CUL))
#define bFM_MFS7_I2C_SMR_MD0                  *((volatile unsigned char*)(0x4270E014UL))
#define bFM_MFS7_I2C_SMR_MD1                  *((volatile unsigned char*)(0x4270E018UL))
#define bFM_MFS7_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4270E01CUL))
#define bFM_MFS7_I2C_IBCR_INT                 *((volatile unsigned char*)(0x4270E020UL))
#define bFM_MFS7_I2C_IBCR_BER                 *((volatile unsigned char*)(0x4270E024UL))
#define bFM_MFS7_I2C_IBCR_INTE                *((volatile unsigned char*)(0x4270E028UL))
#define bFM_MFS7_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4270E02CUL))
#define bFM_MFS7_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x4270E030UL))
#define bFM_MFS7_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x4270E034UL))
#define bFM_MFS7_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x4270E038UL))
#define bFM_MFS7_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x4270E038UL))
#define bFM_MFS7_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4270E03CUL))
#define bFM_MFS7_I2C_IBSR_BB                  *((volatile unsigned char*)(0x4270E080UL))
#define bFM_MFS7_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x4270E084UL))
#define bFM_MFS7_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x4270E088UL))
#define bFM_MFS7_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4270E08CUL))
#define bFM_MFS7_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x4270E090UL))
#define bFM_MFS7_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x4270E094UL))
#define bFM_MFS7_I2C_IBSR_RACK                *((volatile unsigned char*)(0x4270E098UL))
#define bFM_MFS7_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4270E09CUL))
#define bFM_MFS7_I2C_SSR_TBI                  *((volatile unsigned char*)(0x4270E0A0UL))
#define bFM_MFS7_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x4270E0A4UL))
#define bFM_MFS7_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x4270E0A8UL))
#define bFM_MFS7_I2C_SSR_ORE                  *((volatile unsigned char*)(0x4270E0ACUL))
#define bFM_MFS7_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x4270E0B0UL))
#define bFM_MFS7_I2C_SSR_DMA                  *((volatile unsigned char*)(0x4270E0B4UL))
#define bFM_MFS7_I2C_SSR_TSET                 *((volatile unsigned char*)(0x4270E0B8UL))
#define bFM_MFS7_I2C_SSR_REC                  *((volatile unsigned char*)(0x4270E0BCUL))
#define bFM_MFS7_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x4270E200UL))
#define bFM_MFS7_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x4270E204UL))
#define bFM_MFS7_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x4270E208UL))
#define bFM_MFS7_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4270E20CUL))
#define bFM_MFS7_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x4270E210UL))
#define bFM_MFS7_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x4270E214UL))
#define bFM_MFS7_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x4270E218UL))
#define bFM_MFS7_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4270E21CUL))
#define bFM_MFS7_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x4270E220UL))
#define bFM_MFS7_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x4270E224UL))
#define bFM_MFS7_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x4270E228UL))
#define bFM_MFS7_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4270E22CUL))
#define bFM_MFS7_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x4270E230UL))
#define bFM_MFS7_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x4270E234UL))
#define bFM_MFS7_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x4270E238UL))
#define bFM_MFS7_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4270E23CUL))
#define bFM_MFS7_I2C_FCR_FE1                  *((volatile unsigned char*)(0x4270E280UL))
#define bFM_MFS7_I2C_FCR_FE2                  *((volatile unsigned char*)(0x4270E284UL))
#define bFM_MFS7_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x4270E288UL))
#define bFM_MFS7_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4270E28CUL))
#define bFM_MFS7_I2C_FCR_FSET                 *((volatile unsigned char*)(0x4270E290UL))
#define bFM_MFS7_I2C_FCR_FLD                  *((volatile unsigned char*)(0x4270E294UL))
#define bFM_MFS7_I2C_FCR_FLST                 *((volatile unsigned char*)(0x4270E298UL))
#define bFM_MFS7_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM_MFS7_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM_MFS7_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM_MFS7_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM_MFS7_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM_MFS7_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x4270E280UL))
#define bFM_MFS7_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x4270E284UL))
#define bFM_MFS7_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x4270E288UL))
#define bFM_MFS7_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4270E28CUL))
#define bFM_MFS7_I2C_FCR0_FSET                *((volatile unsigned char*)(0x4270E290UL))
#define bFM_MFS7_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x4270E294UL))
#define bFM_MFS7_I2C_FCR0_FLST                *((volatile unsigned char*)(0x4270E298UL))
#define bFM_MFS7_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x4270E2A0UL))
#define bFM_MFS7_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x4270E2A4UL))
#define bFM_MFS7_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x4270E2A8UL))
#define bFM_MFS7_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x4270E2ACUL))
#define bFM_MFS7_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x4270E2B0UL))
#define bFM_MFS7_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x4270E300UL))
#define bFM_MFS7_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x4270E304UL))
#define bFM_MFS7_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x4270E308UL))
#define bFM_MFS7_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4270E30CUL))
#define bFM_MFS7_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x4270E310UL))
#define bFM_MFS7_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x4270E314UL))
#define bFM_MFS7_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x4270E318UL))
#define bFM_MFS7_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4270E31CUL))
#define bFM_MFS7_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x4270E320UL))
#define bFM_MFS7_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x4270E324UL))
#define bFM_MFS7_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x4270E328UL))
#define bFM_MFS7_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4270E32CUL))
#define bFM_MFS7_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x4270E330UL))
#define bFM_MFS7_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x4270E334UL))
#define bFM_MFS7_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x4270E338UL))
#define bFM_MFS7_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4270E33CUL))
#define bFM_MFS7_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x4270E300UL))
#define bFM_MFS7_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x4270E304UL))
#define bFM_MFS7_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x4270E308UL))
#define bFM_MFS7_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4270E30CUL))
#define bFM_MFS7_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x4270E310UL))
#define bFM_MFS7_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x4270E314UL))
#define bFM_MFS7_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x4270E318UL))
#define bFM_MFS7_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4270E31CUL))
#define bFM_MFS7_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x4270E320UL))
#define bFM_MFS7_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x4270E324UL))
#define bFM_MFS7_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x4270E328UL))
#define bFM_MFS7_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4270E32CUL))
#define bFM_MFS7_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x4270E330UL))
#define bFM_MFS7_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x4270E334UL))
#define bFM_MFS7_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x4270E338UL))
#define bFM_MFS7_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4270E33CUL))

/* MFS UART channel 8 registers */
#define bFM_MFS8_UART_SMR_SOE                 *((volatile unsigned char*)(0x42710000UL))
#define bFM_MFS8_UART_SMR_BDS                 *((volatile unsigned char*)(0x42710008UL))
#define bFM_MFS8_UART_SMR_SBL                 *((volatile unsigned char*)(0x4271000CUL))
#define bFM_MFS8_UART_SMR_WUCR                *((volatile unsigned char*)(0x42710010UL))
#define bFM_MFS8_UART_SMR_MD0                 *((volatile unsigned char*)(0x42710014UL))
#define bFM_MFS8_UART_SMR_MD1                 *((volatile unsigned char*)(0x42710018UL))
#define bFM_MFS8_UART_SMR_MD2                 *((volatile unsigned char*)(0x4271001CUL))
#define bFM_MFS8_UART_SCR_TXE                 *((volatile unsigned char*)(0x42710020UL))
#define bFM_MFS8_UART_SCR_RXE                 *((volatile unsigned char*)(0x42710024UL))
#define bFM_MFS8_UART_SCR_TBIE                *((volatile unsigned char*)(0x42710028UL))
#define bFM_MFS8_UART_SCR_TIE                 *((volatile unsigned char*)(0x4271002CUL))
#define bFM_MFS8_UART_SCR_RIE                 *((volatile unsigned char*)(0x42710030UL))
#define bFM_MFS8_UART_SCR_UPCL                *((volatile unsigned char*)(0x4271003CUL))
#define bFM_MFS8_UART_ESCR_L0                 *((volatile unsigned char*)(0x42710080UL))
#define bFM_MFS8_UART_ESCR_L1                 *((volatile unsigned char*)(0x42710084UL))
#define bFM_MFS8_UART_ESCR_L2                 *((volatile unsigned char*)(0x42710088UL))
#define bFM_MFS8_UART_ESCR_P                  *((volatile unsigned char*)(0x4271008CUL))
#define bFM_MFS8_UART_ESCR_PEN                *((volatile unsigned char*)(0x42710090UL))
#define bFM_MFS8_UART_ESCR_INV                *((volatile unsigned char*)(0x42710094UL))
#define bFM_MFS8_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42710098UL))
#define bFM_MFS8_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4271009CUL))
#define bFM_MFS8_UART_SSR_TBI                 *((volatile unsigned char*)(0x427100A0UL))
#define bFM_MFS8_UART_SSR_TDRE                *((volatile unsigned char*)(0x427100A4UL))
#define bFM_MFS8_UART_SSR_RDRF                *((volatile unsigned char*)(0x427100A8UL))
#define bFM_MFS8_UART_SSR_ORE                 *((volatile unsigned char*)(0x427100ACUL))
#define bFM_MFS8_UART_SSR_FRE                 *((volatile unsigned char*)(0x427100B0UL))
#define bFM_MFS8_UART_SSR_PE                  *((volatile unsigned char*)(0x427100B4UL))
#define bFM_MFS8_UART_SSR_REC                 *((volatile unsigned char*)(0x427100BCUL))
#define bFM_MFS8_UART_BGR_EXT                 *((volatile unsigned char*)(0x427101BCUL))
#define bFM_MFS8_UART_BGR1_EXT                *((volatile unsigned char*)(0x427101BCUL))
#define bFM_MFS8_UART_FCR_FE1                 *((volatile unsigned char*)(0x42710280UL))
#define bFM_MFS8_UART_FCR_FE2                 *((volatile unsigned char*)(0x42710284UL))
#define bFM_MFS8_UART_FCR_FCL1                *((volatile unsigned char*)(0x42710288UL))
#define bFM_MFS8_UART_FCR_FCL2                *((volatile unsigned char*)(0x4271028CUL))
#define bFM_MFS8_UART_FCR_FSET                *((volatile unsigned char*)(0x42710290UL))
#define bFM_MFS8_UART_FCR_FLD                 *((volatile unsigned char*)(0x42710294UL))
#define bFM_MFS8_UART_FCR_FLST                *((volatile unsigned char*)(0x42710298UL))
#define bFM_MFS8_UART_FCR_FSEL                *((volatile unsigned char*)(0x427102A0UL))
#define bFM_MFS8_UART_FCR_FTIE                *((volatile unsigned char*)(0x427102A4UL))
#define bFM_MFS8_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427102A8UL))
#define bFM_MFS8_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427102ACUL))
#define bFM_MFS8_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427102B0UL))
#define bFM_MFS8_UART_FCR0_FE1                *((volatile unsigned char*)(0x42710280UL))
#define bFM_MFS8_UART_FCR0_FE2                *((volatile unsigned char*)(0x42710284UL))
#define bFM_MFS8_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42710288UL))
#define bFM_MFS8_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4271028CUL))
#define bFM_MFS8_UART_FCR0_FSET               *((volatile unsigned char*)(0x42710290UL))
#define bFM_MFS8_UART_FCR0_FLD                *((volatile unsigned char*)(0x42710294UL))
#define bFM_MFS8_UART_FCR0_FLST               *((volatile unsigned char*)(0x42710298UL))
#define bFM_MFS8_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427102A0UL))
#define bFM_MFS8_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427102A4UL))
#define bFM_MFS8_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427102A8UL))
#define bFM_MFS8_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427102ACUL))
#define bFM_MFS8_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427102B0UL))
#define bFM_MFS8_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42710300UL))
#define bFM_MFS8_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42710304UL))
#define bFM_MFS8_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42710308UL))
#define bFM_MFS8_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4271030CUL))
#define bFM_MFS8_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42710310UL))
#define bFM_MFS8_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42710314UL))
#define bFM_MFS8_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42710318UL))
#define bFM_MFS8_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4271031CUL))
#define bFM_MFS8_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42710320UL))
#define bFM_MFS8_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42710324UL))
#define bFM_MFS8_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42710328UL))
#define bFM_MFS8_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4271032CUL))
#define bFM_MFS8_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42710330UL))
#define bFM_MFS8_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42710334UL))
#define bFM_MFS8_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42710338UL))
#define bFM_MFS8_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4271033CUL))
#define bFM_MFS8_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42710300UL))
#define bFM_MFS8_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42710304UL))
#define bFM_MFS8_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42710308UL))
#define bFM_MFS8_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4271030CUL))
#define bFM_MFS8_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42710310UL))
#define bFM_MFS8_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42710314UL))
#define bFM_MFS8_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42710318UL))
#define bFM_MFS8_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4271031CUL))
#define bFM_MFS8_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42710320UL))
#define bFM_MFS8_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42710324UL))
#define bFM_MFS8_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42710328UL))
#define bFM_MFS8_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4271032CUL))
#define bFM_MFS8_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42710330UL))
#define bFM_MFS8_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42710334UL))
#define bFM_MFS8_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42710338UL))
#define bFM_MFS8_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4271033CUL))

/* MFS CSIO channel 8 registers */
#define bFM_MFS8_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42710000UL))
#define bFM_MFS8_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42710004UL))
#define bFM_MFS8_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42710008UL))
#define bFM_MFS8_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4271000CUL))
#define bFM_MFS8_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42710014UL))
#define bFM_MFS8_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42710018UL))
#define bFM_MFS8_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4271001CUL))
#define bFM_MFS8_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42710020UL))
#define bFM_MFS8_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42710024UL))
#define bFM_MFS8_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42710028UL))
#define bFM_MFS8_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4271002CUL))
#define bFM_MFS8_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42710030UL))
#define bFM_MFS8_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42710034UL))
#define bFM_MFS8_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42710038UL))
#define bFM_MFS8_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4271003CUL))
#define bFM_MFS8_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42710080UL))
#define bFM_MFS8_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42710084UL))
#define bFM_MFS8_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42710088UL))
#define bFM_MFS8_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4271008CUL))
#define bFM_MFS8_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42710090UL))
#define bFM_MFS8_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42710094UL))
#define bFM_MFS8_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42710098UL))
#define bFM_MFS8_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4271009CUL))
#define bFM_MFS8_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427100A0UL))
#define bFM_MFS8_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427100A4UL))
#define bFM_MFS8_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427100A8UL))
#define bFM_MFS8_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427100ACUL))
#define bFM_MFS8_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427100B0UL))
#define bFM_MFS8_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427100BCUL))
#define bFM_MFS8_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42710280UL))
#define bFM_MFS8_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42710284UL))
#define bFM_MFS8_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42710288UL))
#define bFM_MFS8_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4271028CUL))
#define bFM_MFS8_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42710290UL))
#define bFM_MFS8_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42710294UL))
#define bFM_MFS8_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42710298UL))
#define bFM_MFS8_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427102A0UL))
#define bFM_MFS8_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427102A4UL))
#define bFM_MFS8_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427102A8UL))
#define bFM_MFS8_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427102ACUL))
#define bFM_MFS8_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427102B0UL))
#define bFM_MFS8_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42710280UL))
#define bFM_MFS8_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42710284UL))
#define bFM_MFS8_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42710288UL))
#define bFM_MFS8_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4271028CUL))
#define bFM_MFS8_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42710290UL))
#define bFM_MFS8_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42710294UL))
#define bFM_MFS8_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42710298UL))
#define bFM_MFS8_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427102A0UL))
#define bFM_MFS8_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427102A4UL))
#define bFM_MFS8_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427102A8UL))
#define bFM_MFS8_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427102ACUL))
#define bFM_MFS8_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427102B0UL))
#define bFM_MFS8_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42710300UL))
#define bFM_MFS8_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42710304UL))
#define bFM_MFS8_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42710308UL))
#define bFM_MFS8_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4271030CUL))
#define bFM_MFS8_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42710310UL))
#define bFM_MFS8_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42710314UL))
#define bFM_MFS8_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42710318UL))
#define bFM_MFS8_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4271031CUL))
#define bFM_MFS8_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42710320UL))
#define bFM_MFS8_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42710324UL))
#define bFM_MFS8_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42710328UL))
#define bFM_MFS8_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4271032CUL))
#define bFM_MFS8_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42710330UL))
#define bFM_MFS8_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42710334UL))
#define bFM_MFS8_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42710338UL))
#define bFM_MFS8_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4271033CUL))
#define bFM_MFS8_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42710300UL))
#define bFM_MFS8_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42710304UL))
#define bFM_MFS8_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42710308UL))
#define bFM_MFS8_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4271030CUL))
#define bFM_MFS8_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42710310UL))
#define bFM_MFS8_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42710314UL))
#define bFM_MFS8_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42710318UL))
#define bFM_MFS8_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4271031CUL))
#define bFM_MFS8_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42710320UL))
#define bFM_MFS8_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42710324UL))
#define bFM_MFS8_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42710328UL))
#define bFM_MFS8_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4271032CUL))
#define bFM_MFS8_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42710330UL))
#define bFM_MFS8_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42710334UL))
#define bFM_MFS8_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42710338UL))
#define bFM_MFS8_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4271033CUL))
#define bFM_MFS8_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42710380UL))
#define bFM_MFS8_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42710384UL))
#define bFM_MFS8_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42710388UL))
#define bFM_MFS8_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4271038CUL))
#define bFM_MFS8_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42710390UL))
#define bFM_MFS8_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42710394UL))
#define bFM_MFS8_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42710398UL))
#define bFM_MFS8_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4271039CUL))
#define bFM_MFS8_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427103A0UL))
#define bFM_MFS8_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427103A4UL))
#define bFM_MFS8_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427103A8UL))
#define bFM_MFS8_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427103ACUL))
#define bFM_MFS8_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427103B0UL))
#define bFM_MFS8_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427103B4UL))
#define bFM_MFS8_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427103B8UL))
#define bFM_MFS8_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427103BCUL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42710400UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42710404UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42710408UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4271040CUL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42710410UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42710414UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42710418UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4271041CUL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42710420UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42710424UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42710428UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4271042CUL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42710430UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42710434UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42710438UL))
#define bFM_MFS8_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4271043CUL))
#define bFM_MFS8_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42710480UL))
#define bFM_MFS8_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42710484UL))
#define bFM_MFS8_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42710488UL))
#define bFM_MFS8_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4271048CUL))
#define bFM_MFS8_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42710490UL))
#define bFM_MFS8_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42710498UL))
#define bFM_MFS8_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4271049CUL))
#define bFM_MFS8_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427104A0UL))
#define bFM_MFS8_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427104ACUL))
#define bFM_MFS8_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427104B0UL))
#define bFM_MFS8_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427104B4UL))
#define bFM_MFS8_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42710500UL))
#define bFM_MFS8_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42710504UL))
#define bFM_MFS8_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42710508UL))
#define bFM_MFS8_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4271050CUL))
#define bFM_MFS8_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42710510UL))
#define bFM_MFS8_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42710514UL))
#define bFM_MFS8_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42710518UL))
#define bFM_MFS8_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4271051CUL))
#define bFM_MFS8_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42710520UL))
#define bFM_MFS8_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42710524UL))
#define bFM_MFS8_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42710528UL))
#define bFM_MFS8_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4271052CUL))
#define bFM_MFS8_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42710530UL))
#define bFM_MFS8_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42710534UL))
#define bFM_MFS8_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42710538UL))
#define bFM_MFS8_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4271053CUL))
#define bFM_MFS8_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42710580UL))
#define bFM_MFS8_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42710584UL))
#define bFM_MFS8_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42710588UL))
#define bFM_MFS8_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4271058CUL))
#define bFM_MFS8_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42710590UL))
#define bFM_MFS8_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42710594UL))
#define bFM_MFS8_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42710598UL))
#define bFM_MFS8_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4271059CUL))
#define bFM_MFS8_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427105A0UL))
#define bFM_MFS8_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427105A4UL))
#define bFM_MFS8_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427105A8UL))
#define bFM_MFS8_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427105ACUL))
#define bFM_MFS8_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427105B0UL))
#define bFM_MFS8_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427105B4UL))
#define bFM_MFS8_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427105B8UL))
#define bFM_MFS8_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427105BCUL))
#define bFM_MFS8_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42710600UL))
#define bFM_MFS8_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42710604UL))
#define bFM_MFS8_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42710608UL))
#define bFM_MFS8_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4271060CUL))
#define bFM_MFS8_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42710610UL))
#define bFM_MFS8_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42710614UL))
#define bFM_MFS8_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42710618UL))
#define bFM_MFS8_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4271061CUL))
#define bFM_MFS8_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42710620UL))
#define bFM_MFS8_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42710624UL))
#define bFM_MFS8_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42710628UL))
#define bFM_MFS8_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4271062CUL))
#define bFM_MFS8_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42710630UL))
#define bFM_MFS8_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42710634UL))
#define bFM_MFS8_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42710638UL))
#define bFM_MFS8_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4271063CUL))
#define bFM_MFS8_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42710680UL))
#define bFM_MFS8_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42710684UL))
#define bFM_MFS8_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42710688UL))
#define bFM_MFS8_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4271068CUL))
#define bFM_MFS8_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42710690UL))
#define bFM_MFS8_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42710694UL))
#define bFM_MFS8_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42710698UL))
#define bFM_MFS8_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4271069CUL))
#define bFM_MFS8_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427106A0UL))
#define bFM_MFS8_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427106A4UL))
#define bFM_MFS8_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427106A8UL))
#define bFM_MFS8_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427106ACUL))
#define bFM_MFS8_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427106B0UL))
#define bFM_MFS8_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427106B4UL))
#define bFM_MFS8_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427106B8UL))
#define bFM_MFS8_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427106BCUL))
#define bFM_MFS8_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42710700UL))
#define bFM_MFS8_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42710704UL))
#define bFM_MFS8_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42710708UL))
#define bFM_MFS8_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4271070CUL))
#define bFM_MFS8_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42710710UL))
#define bFM_MFS8_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42710714UL))
#define bFM_MFS8_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42710718UL))
#define bFM_MFS8_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4271071CUL))

/* MFS LIN channel 8 registers */
#define bFM_MFS8_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42710000UL))
#define bFM_MFS8_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4271000CUL))
#define bFM_MFS8_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42710010UL))
#define bFM_MFS8_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42710014UL))
#define bFM_MFS8_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42710018UL))
#define bFM_MFS8_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4271001CUL))
#define bFM_MFS8_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42710020UL))
#define bFM_MFS8_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42710024UL))
#define bFM_MFS8_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42710028UL))
#define bFM_MFS8_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4271002CUL))
#define bFM_MFS8_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42710030UL))
#define bFM_MFS8_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42710034UL))
#define bFM_MFS8_LIN_SCR_MS                   *((volatile unsigned char*)(0x42710038UL))
#define bFM_MFS8_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4271003CUL))
#define bFM_MFS8_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42710080UL))
#define bFM_MFS8_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42710084UL))
#define bFM_MFS8_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42710088UL))
#define bFM_MFS8_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4271008CUL))
#define bFM_MFS8_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42710090UL))
#define bFM_MFS8_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42710098UL))
#define bFM_MFS8_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427100A0UL))
#define bFM_MFS8_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427100A4UL))
#define bFM_MFS8_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427100A8UL))
#define bFM_MFS8_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427100ACUL))
#define bFM_MFS8_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427100B0UL))
#define bFM_MFS8_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427100B4UL))
#define bFM_MFS8_LIN_SSR_REC                  *((volatile unsigned char*)(0x427100BCUL))
#define bFM_MFS8_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427101BCUL))
#define bFM_MFS8_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427101BCUL))
#define bFM_MFS8_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42710280UL))
#define bFM_MFS8_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42710284UL))
#define bFM_MFS8_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42710288UL))
#define bFM_MFS8_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4271028CUL))
#define bFM_MFS8_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42710290UL))
#define bFM_MFS8_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42710294UL))
#define bFM_MFS8_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42710298UL))
#define bFM_MFS8_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427102A0UL))
#define bFM_MFS8_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427102A4UL))
#define bFM_MFS8_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427102A8UL))
#define bFM_MFS8_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427102ACUL))
#define bFM_MFS8_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427102B0UL))
#define bFM_MFS8_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42710280UL))
#define bFM_MFS8_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42710284UL))
#define bFM_MFS8_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42710288UL))
#define bFM_MFS8_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4271028CUL))
#define bFM_MFS8_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42710290UL))
#define bFM_MFS8_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42710294UL))
#define bFM_MFS8_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42710298UL))
#define bFM_MFS8_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427102A0UL))
#define bFM_MFS8_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427102A4UL))
#define bFM_MFS8_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427102A8UL))
#define bFM_MFS8_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427102ACUL))
#define bFM_MFS8_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427102B0UL))
#define bFM_MFS8_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42710300UL))
#define bFM_MFS8_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42710304UL))
#define bFM_MFS8_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42710308UL))
#define bFM_MFS8_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4271030CUL))
#define bFM_MFS8_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42710310UL))
#define bFM_MFS8_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42710314UL))
#define bFM_MFS8_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42710318UL))
#define bFM_MFS8_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4271031CUL))
#define bFM_MFS8_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42710320UL))
#define bFM_MFS8_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42710324UL))
#define bFM_MFS8_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42710328UL))
#define bFM_MFS8_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4271032CUL))
#define bFM_MFS8_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42710330UL))
#define bFM_MFS8_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42710334UL))
#define bFM_MFS8_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42710338UL))
#define bFM_MFS8_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4271033CUL))
#define bFM_MFS8_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42710300UL))
#define bFM_MFS8_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42710304UL))
#define bFM_MFS8_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42710308UL))
#define bFM_MFS8_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4271030CUL))
#define bFM_MFS8_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42710310UL))
#define bFM_MFS8_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42710314UL))
#define bFM_MFS8_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42710318UL))
#define bFM_MFS8_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4271031CUL))
#define bFM_MFS8_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42710320UL))
#define bFM_MFS8_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42710324UL))
#define bFM_MFS8_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42710328UL))
#define bFM_MFS8_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4271032CUL))
#define bFM_MFS8_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42710330UL))
#define bFM_MFS8_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42710334UL))
#define bFM_MFS8_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42710338UL))
#define bFM_MFS8_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4271033CUL))

/* MFS I2C channel 8 registers */
#define bFM_MFS8_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42710008UL))
#define bFM_MFS8_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4271000CUL))
#define bFM_MFS8_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42710014UL))
#define bFM_MFS8_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42710018UL))
#define bFM_MFS8_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4271001CUL))
#define bFM_MFS8_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42710020UL))
#define bFM_MFS8_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42710024UL))
#define bFM_MFS8_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42710028UL))
#define bFM_MFS8_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4271002CUL))
#define bFM_MFS8_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42710030UL))
#define bFM_MFS8_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42710034UL))
#define bFM_MFS8_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42710038UL))
#define bFM_MFS8_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42710038UL))
#define bFM_MFS8_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4271003CUL))
#define bFM_MFS8_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42710080UL))
#define bFM_MFS8_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42710084UL))
#define bFM_MFS8_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42710088UL))
#define bFM_MFS8_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4271008CUL))
#define bFM_MFS8_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42710090UL))
#define bFM_MFS8_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42710094UL))
#define bFM_MFS8_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42710098UL))
#define bFM_MFS8_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4271009CUL))
#define bFM_MFS8_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427100A0UL))
#define bFM_MFS8_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427100A4UL))
#define bFM_MFS8_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427100A8UL))
#define bFM_MFS8_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427100ACUL))
#define bFM_MFS8_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427100B0UL))
#define bFM_MFS8_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427100B4UL))
#define bFM_MFS8_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427100B8UL))
#define bFM_MFS8_I2C_SSR_REC                  *((volatile unsigned char*)(0x427100BCUL))
#define bFM_MFS8_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42710200UL))
#define bFM_MFS8_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42710204UL))
#define bFM_MFS8_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42710208UL))
#define bFM_MFS8_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4271020CUL))
#define bFM_MFS8_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42710210UL))
#define bFM_MFS8_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42710214UL))
#define bFM_MFS8_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42710218UL))
#define bFM_MFS8_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4271021CUL))
#define bFM_MFS8_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42710220UL))
#define bFM_MFS8_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42710224UL))
#define bFM_MFS8_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42710228UL))
#define bFM_MFS8_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4271022CUL))
#define bFM_MFS8_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42710230UL))
#define bFM_MFS8_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42710234UL))
#define bFM_MFS8_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42710238UL))
#define bFM_MFS8_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4271023CUL))
#define bFM_MFS8_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42710280UL))
#define bFM_MFS8_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42710284UL))
#define bFM_MFS8_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42710288UL))
#define bFM_MFS8_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4271028CUL))
#define bFM_MFS8_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42710290UL))
#define bFM_MFS8_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42710294UL))
#define bFM_MFS8_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42710298UL))
#define bFM_MFS8_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427102A0UL))
#define bFM_MFS8_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427102A4UL))
#define bFM_MFS8_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427102A8UL))
#define bFM_MFS8_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427102ACUL))
#define bFM_MFS8_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427102B0UL))
#define bFM_MFS8_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42710280UL))
#define bFM_MFS8_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42710284UL))
#define bFM_MFS8_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42710288UL))
#define bFM_MFS8_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4271028CUL))
#define bFM_MFS8_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42710290UL))
#define bFM_MFS8_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42710294UL))
#define bFM_MFS8_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42710298UL))
#define bFM_MFS8_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427102A0UL))
#define bFM_MFS8_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427102A4UL))
#define bFM_MFS8_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427102A8UL))
#define bFM_MFS8_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427102ACUL))
#define bFM_MFS8_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427102B0UL))
#define bFM_MFS8_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42710300UL))
#define bFM_MFS8_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42710304UL))
#define bFM_MFS8_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42710308UL))
#define bFM_MFS8_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4271030CUL))
#define bFM_MFS8_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42710310UL))
#define bFM_MFS8_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42710314UL))
#define bFM_MFS8_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42710318UL))
#define bFM_MFS8_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4271031CUL))
#define bFM_MFS8_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42710320UL))
#define bFM_MFS8_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42710324UL))
#define bFM_MFS8_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42710328UL))
#define bFM_MFS8_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4271032CUL))
#define bFM_MFS8_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42710330UL))
#define bFM_MFS8_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42710334UL))
#define bFM_MFS8_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42710338UL))
#define bFM_MFS8_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4271033CUL))
#define bFM_MFS8_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42710300UL))
#define bFM_MFS8_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42710304UL))
#define bFM_MFS8_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42710308UL))
#define bFM_MFS8_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4271030CUL))
#define bFM_MFS8_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42710310UL))
#define bFM_MFS8_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42710314UL))
#define bFM_MFS8_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42710318UL))
#define bFM_MFS8_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4271031CUL))
#define bFM_MFS8_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42710320UL))
#define bFM_MFS8_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42710324UL))
#define bFM_MFS8_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42710328UL))
#define bFM_MFS8_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4271032CUL))
#define bFM_MFS8_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42710330UL))
#define bFM_MFS8_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42710334UL))
#define bFM_MFS8_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42710338UL))
#define bFM_MFS8_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4271033CUL))

/* MFS UART channel 9 registers */
#define bFM_MFS9_UART_SMR_SOE                 *((volatile unsigned char*)(0x42712000UL))
#define bFM_MFS9_UART_SMR_BDS                 *((volatile unsigned char*)(0x42712008UL))
#define bFM_MFS9_UART_SMR_SBL                 *((volatile unsigned char*)(0x4271200CUL))
#define bFM_MFS9_UART_SMR_WUCR                *((volatile unsigned char*)(0x42712010UL))
#define bFM_MFS9_UART_SMR_MD0                 *((volatile unsigned char*)(0x42712014UL))
#define bFM_MFS9_UART_SMR_MD1                 *((volatile unsigned char*)(0x42712018UL))
#define bFM_MFS9_UART_SMR_MD2                 *((volatile unsigned char*)(0x4271201CUL))
#define bFM_MFS9_UART_SCR_TXE                 *((volatile unsigned char*)(0x42712020UL))
#define bFM_MFS9_UART_SCR_RXE                 *((volatile unsigned char*)(0x42712024UL))
#define bFM_MFS9_UART_SCR_TBIE                *((volatile unsigned char*)(0x42712028UL))
#define bFM_MFS9_UART_SCR_TIE                 *((volatile unsigned char*)(0x4271202CUL))
#define bFM_MFS9_UART_SCR_RIE                 *((volatile unsigned char*)(0x42712030UL))
#define bFM_MFS9_UART_SCR_UPCL                *((volatile unsigned char*)(0x4271203CUL))
#define bFM_MFS9_UART_ESCR_L0                 *((volatile unsigned char*)(0x42712080UL))
#define bFM_MFS9_UART_ESCR_L1                 *((volatile unsigned char*)(0x42712084UL))
#define bFM_MFS9_UART_ESCR_L2                 *((volatile unsigned char*)(0x42712088UL))
#define bFM_MFS9_UART_ESCR_P                  *((volatile unsigned char*)(0x4271208CUL))
#define bFM_MFS9_UART_ESCR_PEN                *((volatile unsigned char*)(0x42712090UL))
#define bFM_MFS9_UART_ESCR_INV                *((volatile unsigned char*)(0x42712094UL))
#define bFM_MFS9_UART_ESCR_ESBL               *((volatile unsigned char*)(0x42712098UL))
#define bFM_MFS9_UART_ESCR_FLWEN              *((volatile unsigned char*)(0x4271209CUL))
#define bFM_MFS9_UART_SSR_TBI                 *((volatile unsigned char*)(0x427120A0UL))
#define bFM_MFS9_UART_SSR_TDRE                *((volatile unsigned char*)(0x427120A4UL))
#define bFM_MFS9_UART_SSR_RDRF                *((volatile unsigned char*)(0x427120A8UL))
#define bFM_MFS9_UART_SSR_ORE                 *((volatile unsigned char*)(0x427120ACUL))
#define bFM_MFS9_UART_SSR_FRE                 *((volatile unsigned char*)(0x427120B0UL))
#define bFM_MFS9_UART_SSR_PE                  *((volatile unsigned char*)(0x427120B4UL))
#define bFM_MFS9_UART_SSR_REC                 *((volatile unsigned char*)(0x427120BCUL))
#define bFM_MFS9_UART_BGR_EXT                 *((volatile unsigned char*)(0x427121BCUL))
#define bFM_MFS9_UART_BGR1_EXT                *((volatile unsigned char*)(0x427121BCUL))
#define bFM_MFS9_UART_FCR_FE1                 *((volatile unsigned char*)(0x42712280UL))
#define bFM_MFS9_UART_FCR_FE2                 *((volatile unsigned char*)(0x42712284UL))
#define bFM_MFS9_UART_FCR_FCL1                *((volatile unsigned char*)(0x42712288UL))
#define bFM_MFS9_UART_FCR_FCL2                *((volatile unsigned char*)(0x4271228CUL))
#define bFM_MFS9_UART_FCR_FSET                *((volatile unsigned char*)(0x42712290UL))
#define bFM_MFS9_UART_FCR_FLD                 *((volatile unsigned char*)(0x42712294UL))
#define bFM_MFS9_UART_FCR_FLST                *((volatile unsigned char*)(0x42712298UL))
#define bFM_MFS9_UART_FCR_FSEL                *((volatile unsigned char*)(0x427122A0UL))
#define bFM_MFS9_UART_FCR_FTIE                *((volatile unsigned char*)(0x427122A4UL))
#define bFM_MFS9_UART_FCR_FDRQ                *((volatile unsigned char*)(0x427122A8UL))
#define bFM_MFS9_UART_FCR_FRIIE               *((volatile unsigned char*)(0x427122ACUL))
#define bFM_MFS9_UART_FCR_FLSTE               *((volatile unsigned char*)(0x427122B0UL))
#define bFM_MFS9_UART_FCR0_FE1                *((volatile unsigned char*)(0x42712280UL))
#define bFM_MFS9_UART_FCR0_FE2                *((volatile unsigned char*)(0x42712284UL))
#define bFM_MFS9_UART_FCR0_FCL1               *((volatile unsigned char*)(0x42712288UL))
#define bFM_MFS9_UART_FCR0_FCL2               *((volatile unsigned char*)(0x4271228CUL))
#define bFM_MFS9_UART_FCR0_FSET               *((volatile unsigned char*)(0x42712290UL))
#define bFM_MFS9_UART_FCR0_FLD                *((volatile unsigned char*)(0x42712294UL))
#define bFM_MFS9_UART_FCR0_FLST               *((volatile unsigned char*)(0x42712298UL))
#define bFM_MFS9_UART_FCR1_FSEL               *((volatile unsigned char*)(0x427122A0UL))
#define bFM_MFS9_UART_FCR1_FTIE               *((volatile unsigned char*)(0x427122A4UL))
#define bFM_MFS9_UART_FCR1_FDRQ               *((volatile unsigned char*)(0x427122A8UL))
#define bFM_MFS9_UART_FCR1_FRIIE              *((volatile unsigned char*)(0x427122ACUL))
#define bFM_MFS9_UART_FCR1_FLSTE              *((volatile unsigned char*)(0x427122B0UL))
#define bFM_MFS9_UART_FBYTE_FD0               *((volatile unsigned char*)(0x42712300UL))
#define bFM_MFS9_UART_FBYTE_FD1               *((volatile unsigned char*)(0x42712304UL))
#define bFM_MFS9_UART_FBYTE_FD2               *((volatile unsigned char*)(0x42712308UL))
#define bFM_MFS9_UART_FBYTE_FD3               *((volatile unsigned char*)(0x4271230CUL))
#define bFM_MFS9_UART_FBYTE_FD4               *((volatile unsigned char*)(0x42712310UL))
#define bFM_MFS9_UART_FBYTE_FD5               *((volatile unsigned char*)(0x42712314UL))
#define bFM_MFS9_UART_FBYTE_FD6               *((volatile unsigned char*)(0x42712318UL))
#define bFM_MFS9_UART_FBYTE_FD7               *((volatile unsigned char*)(0x4271231CUL))
#define bFM_MFS9_UART_FBYTE_FD8               *((volatile unsigned char*)(0x42712320UL))
#define bFM_MFS9_UART_FBYTE_FD9               *((volatile unsigned char*)(0x42712324UL))
#define bFM_MFS9_UART_FBYTE_FD10              *((volatile unsigned char*)(0x42712328UL))
#define bFM_MFS9_UART_FBYTE_FD11              *((volatile unsigned char*)(0x4271232CUL))
#define bFM_MFS9_UART_FBYTE_FD12              *((volatile unsigned char*)(0x42712330UL))
#define bFM_MFS9_UART_FBYTE_FD13              *((volatile unsigned char*)(0x42712334UL))
#define bFM_MFS9_UART_FBYTE_FD14              *((volatile unsigned char*)(0x42712338UL))
#define bFM_MFS9_UART_FBYTE_FD15              *((volatile unsigned char*)(0x4271233CUL))
#define bFM_MFS9_UART_FBYTE1_FD0              *((volatile unsigned char*)(0x42712300UL))
#define bFM_MFS9_UART_FBYTE1_FD1              *((volatile unsigned char*)(0x42712304UL))
#define bFM_MFS9_UART_FBYTE1_FD2              *((volatile unsigned char*)(0x42712308UL))
#define bFM_MFS9_UART_FBYTE1_FD3              *((volatile unsigned char*)(0x4271230CUL))
#define bFM_MFS9_UART_FBYTE1_FD4              *((volatile unsigned char*)(0x42712310UL))
#define bFM_MFS9_UART_FBYTE1_FD5              *((volatile unsigned char*)(0x42712314UL))
#define bFM_MFS9_UART_FBYTE1_FD6              *((volatile unsigned char*)(0x42712318UL))
#define bFM_MFS9_UART_FBYTE1_FD7              *((volatile unsigned char*)(0x4271231CUL))
#define bFM_MFS9_UART_FBYTE2_FD8              *((volatile unsigned char*)(0x42712320UL))
#define bFM_MFS9_UART_FBYTE2_FD9              *((volatile unsigned char*)(0x42712324UL))
#define bFM_MFS9_UART_FBYTE2_FD10             *((volatile unsigned char*)(0x42712328UL))
#define bFM_MFS9_UART_FBYTE2_FD11             *((volatile unsigned char*)(0x4271232CUL))
#define bFM_MFS9_UART_FBYTE2_FD12             *((volatile unsigned char*)(0x42712330UL))
#define bFM_MFS9_UART_FBYTE2_FD13             *((volatile unsigned char*)(0x42712334UL))
#define bFM_MFS9_UART_FBYTE2_FD14             *((volatile unsigned char*)(0x42712338UL))
#define bFM_MFS9_UART_FBYTE2_FD15             *((volatile unsigned char*)(0x4271233CUL))

/* MFS CSIO channel 9 registers */
#define bFM_MFS9_CSIO_SMR_SOE                 *((volatile unsigned char*)(0x42712000UL))
#define bFM_MFS9_CSIO_SMR_SCKE                *((volatile unsigned char*)(0x42712004UL))
#define bFM_MFS9_CSIO_SMR_BDS                 *((volatile unsigned char*)(0x42712008UL))
#define bFM_MFS9_CSIO_SMR_SCINV               *((volatile unsigned char*)(0x4271200CUL))
#define bFM_MFS9_CSIO_SMR_MD0                 *((volatile unsigned char*)(0x42712014UL))
#define bFM_MFS9_CSIO_SMR_MD1                 *((volatile unsigned char*)(0x42712018UL))
#define bFM_MFS9_CSIO_SMR_MD2                 *((volatile unsigned char*)(0x4271201CUL))
#define bFM_MFS9_CSIO_SCR_TXE                 *((volatile unsigned char*)(0x42712020UL))
#define bFM_MFS9_CSIO_SCR_RXE                 *((volatile unsigned char*)(0x42712024UL))
#define bFM_MFS9_CSIO_SCR_TBIE                *((volatile unsigned char*)(0x42712028UL))
#define bFM_MFS9_CSIO_SCR_TIE                 *((volatile unsigned char*)(0x4271202CUL))
#define bFM_MFS9_CSIO_SCR_RIE                 *((volatile unsigned char*)(0x42712030UL))
#define bFM_MFS9_CSIO_SCR_SPI                 *((volatile unsigned char*)(0x42712034UL))
#define bFM_MFS9_CSIO_SCR_MS                  *((volatile unsigned char*)(0x42712038UL))
#define bFM_MFS9_CSIO_SCR_UPCL                *((volatile unsigned char*)(0x4271203CUL))
#define bFM_MFS9_CSIO_ESCR_L0                 *((volatile unsigned char*)(0x42712080UL))
#define bFM_MFS9_CSIO_ESCR_L1                 *((volatile unsigned char*)(0x42712084UL))
#define bFM_MFS9_CSIO_ESCR_L2                 *((volatile unsigned char*)(0x42712088UL))
#define bFM_MFS9_CSIO_ESCR_WT0                *((volatile unsigned char*)(0x4271208CUL))
#define bFM_MFS9_CSIO_ESCR_WT1                *((volatile unsigned char*)(0x42712090UL))
#define bFM_MFS9_CSIO_ESCR_CSFE               *((volatile unsigned char*)(0x42712094UL))
#define bFM_MFS9_CSIO_ESCR_L3                 *((volatile unsigned char*)(0x42712098UL))
#define bFM_MFS9_CSIO_ESCR_SOP                *((volatile unsigned char*)(0x4271209CUL))
#define bFM_MFS9_CSIO_SSR_TBI                 *((volatile unsigned char*)(0x427120A0UL))
#define bFM_MFS9_CSIO_SSR_TDRE                *((volatile unsigned char*)(0x427120A4UL))
#define bFM_MFS9_CSIO_SSR_RDRF                *((volatile unsigned char*)(0x427120A8UL))
#define bFM_MFS9_CSIO_SSR_ORE                 *((volatile unsigned char*)(0x427120ACUL))
#define bFM_MFS9_CSIO_SSR_AWC                 *((volatile unsigned char*)(0x427120B0UL))
#define bFM_MFS9_CSIO_SSR_REC                 *((volatile unsigned char*)(0x427120BCUL))
#define bFM_MFS9_CSIO_FCR_FE1                 *((volatile unsigned char*)(0x42712280UL))
#define bFM_MFS9_CSIO_FCR_FE2                 *((volatile unsigned char*)(0x42712284UL))
#define bFM_MFS9_CSIO_FCR_FCL1                *((volatile unsigned char*)(0x42712288UL))
#define bFM_MFS9_CSIO_FCR_FCL2                *((volatile unsigned char*)(0x4271228CUL))
#define bFM_MFS9_CSIO_FCR_FSET                *((volatile unsigned char*)(0x42712290UL))
#define bFM_MFS9_CSIO_FCR_FLD                 *((volatile unsigned char*)(0x42712294UL))
#define bFM_MFS9_CSIO_FCR_FLST                *((volatile unsigned char*)(0x42712298UL))
#define bFM_MFS9_CSIO_FCR_FSEL                *((volatile unsigned char*)(0x427122A0UL))
#define bFM_MFS9_CSIO_FCR_FTIE                *((volatile unsigned char*)(0x427122A4UL))
#define bFM_MFS9_CSIO_FCR_FDRQ                *((volatile unsigned char*)(0x427122A8UL))
#define bFM_MFS9_CSIO_FCR_FRIIE               *((volatile unsigned char*)(0x427122ACUL))
#define bFM_MFS9_CSIO_FCR_FLSTE               *((volatile unsigned char*)(0x427122B0UL))
#define bFM_MFS9_CSIO_FCR0_FE1                *((volatile unsigned char*)(0x42712280UL))
#define bFM_MFS9_CSIO_FCR0_FE2                *((volatile unsigned char*)(0x42712284UL))
#define bFM_MFS9_CSIO_FCR0_FCL1               *((volatile unsigned char*)(0x42712288UL))
#define bFM_MFS9_CSIO_FCR0_FCL2               *((volatile unsigned char*)(0x4271228CUL))
#define bFM_MFS9_CSIO_FCR0_FSET               *((volatile unsigned char*)(0x42712290UL))
#define bFM_MFS9_CSIO_FCR0_FLD                *((volatile unsigned char*)(0x42712294UL))
#define bFM_MFS9_CSIO_FCR0_FLST               *((volatile unsigned char*)(0x42712298UL))
#define bFM_MFS9_CSIO_FCR1_FSEL               *((volatile unsigned char*)(0x427122A0UL))
#define bFM_MFS9_CSIO_FCR1_FTIE               *((volatile unsigned char*)(0x427122A4UL))
#define bFM_MFS9_CSIO_FCR1_FDRQ               *((volatile unsigned char*)(0x427122A8UL))
#define bFM_MFS9_CSIO_FCR1_FRIIE              *((volatile unsigned char*)(0x427122ACUL))
#define bFM_MFS9_CSIO_FCR1_FLSTE              *((volatile unsigned char*)(0x427122B0UL))
#define bFM_MFS9_CSIO_FBYTE_FD0               *((volatile unsigned char*)(0x42712300UL))
#define bFM_MFS9_CSIO_FBYTE_FD1               *((volatile unsigned char*)(0x42712304UL))
#define bFM_MFS9_CSIO_FBYTE_FD2               *((volatile unsigned char*)(0x42712308UL))
#define bFM_MFS9_CSIO_FBYTE_FD3               *((volatile unsigned char*)(0x4271230CUL))
#define bFM_MFS9_CSIO_FBYTE_FD4               *((volatile unsigned char*)(0x42712310UL))
#define bFM_MFS9_CSIO_FBYTE_FD5               *((volatile unsigned char*)(0x42712314UL))
#define bFM_MFS9_CSIO_FBYTE_FD6               *((volatile unsigned char*)(0x42712318UL))
#define bFM_MFS9_CSIO_FBYTE_FD7               *((volatile unsigned char*)(0x4271231CUL))
#define bFM_MFS9_CSIO_FBYTE_FD8               *((volatile unsigned char*)(0x42712320UL))
#define bFM_MFS9_CSIO_FBYTE_FD9               *((volatile unsigned char*)(0x42712324UL))
#define bFM_MFS9_CSIO_FBYTE_FD10              *((volatile unsigned char*)(0x42712328UL))
#define bFM_MFS9_CSIO_FBYTE_FD11              *((volatile unsigned char*)(0x4271232CUL))
#define bFM_MFS9_CSIO_FBYTE_FD12              *((volatile unsigned char*)(0x42712330UL))
#define bFM_MFS9_CSIO_FBYTE_FD13              *((volatile unsigned char*)(0x42712334UL))
#define bFM_MFS9_CSIO_FBYTE_FD14              *((volatile unsigned char*)(0x42712338UL))
#define bFM_MFS9_CSIO_FBYTE_FD15              *((volatile unsigned char*)(0x4271233CUL))
#define bFM_MFS9_CSIO_FBYTE1_FD0              *((volatile unsigned char*)(0x42712300UL))
#define bFM_MFS9_CSIO_FBYTE1_FD1              *((volatile unsigned char*)(0x42712304UL))
#define bFM_MFS9_CSIO_FBYTE1_FD2              *((volatile unsigned char*)(0x42712308UL))
#define bFM_MFS9_CSIO_FBYTE1_FD3              *((volatile unsigned char*)(0x4271230CUL))
#define bFM_MFS9_CSIO_FBYTE1_FD4              *((volatile unsigned char*)(0x42712310UL))
#define bFM_MFS9_CSIO_FBYTE1_FD5              *((volatile unsigned char*)(0x42712314UL))
#define bFM_MFS9_CSIO_FBYTE1_FD6              *((volatile unsigned char*)(0x42712318UL))
#define bFM_MFS9_CSIO_FBYTE1_FD7              *((volatile unsigned char*)(0x4271231CUL))
#define bFM_MFS9_CSIO_FBYTE2_FD8              *((volatile unsigned char*)(0x42712320UL))
#define bFM_MFS9_CSIO_FBYTE2_FD9              *((volatile unsigned char*)(0x42712324UL))
#define bFM_MFS9_CSIO_FBYTE2_FD10             *((volatile unsigned char*)(0x42712328UL))
#define bFM_MFS9_CSIO_FBYTE2_FD11             *((volatile unsigned char*)(0x4271232CUL))
#define bFM_MFS9_CSIO_FBYTE2_FD12             *((volatile unsigned char*)(0x42712330UL))
#define bFM_MFS9_CSIO_FBYTE2_FD13             *((volatile unsigned char*)(0x42712334UL))
#define bFM_MFS9_CSIO_FBYTE2_FD14             *((volatile unsigned char*)(0x42712338UL))
#define bFM_MFS9_CSIO_FBYTE2_FD15             *((volatile unsigned char*)(0x4271233CUL))
#define bFM_MFS9_CSIO_SCSTR10_CSHD0           *((volatile unsigned char*)(0x42712380UL))
#define bFM_MFS9_CSIO_SCSTR10_CSHD1           *((volatile unsigned char*)(0x42712384UL))
#define bFM_MFS9_CSIO_SCSTR10_CSHD2           *((volatile unsigned char*)(0x42712388UL))
#define bFM_MFS9_CSIO_SCSTR10_CSHD3           *((volatile unsigned char*)(0x4271238CUL))
#define bFM_MFS9_CSIO_SCSTR10_CSHD4           *((volatile unsigned char*)(0x42712390UL))
#define bFM_MFS9_CSIO_SCSTR10_CSHD5           *((volatile unsigned char*)(0x42712394UL))
#define bFM_MFS9_CSIO_SCSTR10_CSHD6           *((volatile unsigned char*)(0x42712398UL))
#define bFM_MFS9_CSIO_SCSTR10_CSHD7           *((volatile unsigned char*)(0x4271239CUL))
#define bFM_MFS9_CSIO_SCSTR10_CSSU0           *((volatile unsigned char*)(0x427123A0UL))
#define bFM_MFS9_CSIO_SCSTR10_CSSU1           *((volatile unsigned char*)(0x427123A4UL))
#define bFM_MFS9_CSIO_SCSTR10_CSSU2           *((volatile unsigned char*)(0x427123A8UL))
#define bFM_MFS9_CSIO_SCSTR10_CSSU3           *((volatile unsigned char*)(0x427123ACUL))
#define bFM_MFS9_CSIO_SCSTR10_CSSU4           *((volatile unsigned char*)(0x427123B0UL))
#define bFM_MFS9_CSIO_SCSTR10_CSSU5           *((volatile unsigned char*)(0x427123B4UL))
#define bFM_MFS9_CSIO_SCSTR10_CSSU6           *((volatile unsigned char*)(0x427123B8UL))
#define bFM_MFS9_CSIO_SCSTR10_CSSU7           *((volatile unsigned char*)(0x427123BCUL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS0           *((volatile unsigned char*)(0x42712400UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS1           *((volatile unsigned char*)(0x42712404UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS2           *((volatile unsigned char*)(0x42712408UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS3           *((volatile unsigned char*)(0x4271240CUL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS4           *((volatile unsigned char*)(0x42712410UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS5           *((volatile unsigned char*)(0x42712414UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS6           *((volatile unsigned char*)(0x42712418UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS7           *((volatile unsigned char*)(0x4271241CUL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS8           *((volatile unsigned char*)(0x42712420UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS9           *((volatile unsigned char*)(0x42712424UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS10          *((volatile unsigned char*)(0x42712428UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS11          *((volatile unsigned char*)(0x4271242CUL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS12          *((volatile unsigned char*)(0x42712430UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS13          *((volatile unsigned char*)(0x42712434UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS14          *((volatile unsigned char*)(0x42712438UL))
#define bFM_MFS9_CSIO_SCSTR32_CSDS15          *((volatile unsigned char*)(0x4271243CUL))
#define bFM_MFS9_CSIO_SACSR_TMRE              *((volatile unsigned char*)(0x42712480UL))
#define bFM_MFS9_CSIO_SACSR_TDIV0             *((volatile unsigned char*)(0x42712484UL))
#define bFM_MFS9_CSIO_SACSR_TDIV1             *((volatile unsigned char*)(0x42712488UL))
#define bFM_MFS9_CSIO_SACSR_TDIV2             *((volatile unsigned char*)(0x4271248CUL))
#define bFM_MFS9_CSIO_SACSR_TDIV3             *((volatile unsigned char*)(0x42712490UL))
#define bFM_MFS9_CSIO_SACSR_TSYNE             *((volatile unsigned char*)(0x42712498UL))
#define bFM_MFS9_CSIO_SACSR_TINTE             *((volatile unsigned char*)(0x4271249CUL))
#define bFM_MFS9_CSIO_SACSR_TINT              *((volatile unsigned char*)(0x427124A0UL))
#define bFM_MFS9_CSIO_SACSR_CSE               *((volatile unsigned char*)(0x427124ACUL))
#define bFM_MFS9_CSIO_SACSR_CSEIE             *((volatile unsigned char*)(0x427124B0UL))
#define bFM_MFS9_CSIO_SACSR_TBEEN             *((volatile unsigned char*)(0x427124B4UL))
#define bFM_MFS9_CSIO_STMR_TM0                *((volatile unsigned char*)(0x42712500UL))
#define bFM_MFS9_CSIO_STMR_TM1                *((volatile unsigned char*)(0x42712504UL))
#define bFM_MFS9_CSIO_STMR_TM2                *((volatile unsigned char*)(0x42712508UL))
#define bFM_MFS9_CSIO_STMR_TM3                *((volatile unsigned char*)(0x4271250CUL))
#define bFM_MFS9_CSIO_STMR_TM4                *((volatile unsigned char*)(0x42712510UL))
#define bFM_MFS9_CSIO_STMR_TM5                *((volatile unsigned char*)(0x42712514UL))
#define bFM_MFS9_CSIO_STMR_TM6                *((volatile unsigned char*)(0x42712518UL))
#define bFM_MFS9_CSIO_STMR_TM7                *((volatile unsigned char*)(0x4271251CUL))
#define bFM_MFS9_CSIO_STMR_TM8                *((volatile unsigned char*)(0x42712520UL))
#define bFM_MFS9_CSIO_STMR_TM9                *((volatile unsigned char*)(0x42712524UL))
#define bFM_MFS9_CSIO_STMR_TM10               *((volatile unsigned char*)(0x42712528UL))
#define bFM_MFS9_CSIO_STMR_TM11               *((volatile unsigned char*)(0x4271252CUL))
#define bFM_MFS9_CSIO_STMR_TM12               *((volatile unsigned char*)(0x42712530UL))
#define bFM_MFS9_CSIO_STMR_TM13               *((volatile unsigned char*)(0x42712534UL))
#define bFM_MFS9_CSIO_STMR_TM14               *((volatile unsigned char*)(0x42712538UL))
#define bFM_MFS9_CSIO_STMR_TM15               *((volatile unsigned char*)(0x4271253CUL))
#define bFM_MFS9_CSIO_STMCR_TC0               *((volatile unsigned char*)(0x42712580UL))
#define bFM_MFS9_CSIO_STMCR_TC1               *((volatile unsigned char*)(0x42712584UL))
#define bFM_MFS9_CSIO_STMCR_TC2               *((volatile unsigned char*)(0x42712588UL))
#define bFM_MFS9_CSIO_STMCR_TC3               *((volatile unsigned char*)(0x4271258CUL))
#define bFM_MFS9_CSIO_STMCR_TC4               *((volatile unsigned char*)(0x42712590UL))
#define bFM_MFS9_CSIO_STMCR_TC5               *((volatile unsigned char*)(0x42712594UL))
#define bFM_MFS9_CSIO_STMCR_TC6               *((volatile unsigned char*)(0x42712598UL))
#define bFM_MFS9_CSIO_STMCR_TC7               *((volatile unsigned char*)(0x4271259CUL))
#define bFM_MFS9_CSIO_STMCR_TC8               *((volatile unsigned char*)(0x427125A0UL))
#define bFM_MFS9_CSIO_STMCR_TC9               *((volatile unsigned char*)(0x427125A4UL))
#define bFM_MFS9_CSIO_STMCR_TC10              *((volatile unsigned char*)(0x427125A8UL))
#define bFM_MFS9_CSIO_STMCR_TC11              *((volatile unsigned char*)(0x427125ACUL))
#define bFM_MFS9_CSIO_STMCR_TC12              *((volatile unsigned char*)(0x427125B0UL))
#define bFM_MFS9_CSIO_STMCR_TC13              *((volatile unsigned char*)(0x427125B4UL))
#define bFM_MFS9_CSIO_STMCR_TC14              *((volatile unsigned char*)(0x427125B8UL))
#define bFM_MFS9_CSIO_STMCR_TC15              *((volatile unsigned char*)(0x427125BCUL))
#define bFM_MFS9_CSIO_SCSCR_CSOE              *((volatile unsigned char*)(0x42712600UL))
#define bFM_MFS9_CSIO_SCSCR_CSEN0             *((volatile unsigned char*)(0x42712604UL))
#define bFM_MFS9_CSIO_SCSCR_CSEN1             *((volatile unsigned char*)(0x42712608UL))
#define bFM_MFS9_CSIO_SCSCR_CSEN2             *((volatile unsigned char*)(0x4271260CUL))
#define bFM_MFS9_CSIO_SCSCR_CSEN3             *((volatile unsigned char*)(0x42712610UL))
#define bFM_MFS9_CSIO_SCSCR_CSLVL             *((volatile unsigned char*)(0x42712614UL))
#define bFM_MFS9_CSIO_SCSCR_CDIV0             *((volatile unsigned char*)(0x42712618UL))
#define bFM_MFS9_CSIO_SCSCR_CDIV1             *((volatile unsigned char*)(0x4271261CUL))
#define bFM_MFS9_CSIO_SCSCR_CDIV2             *((volatile unsigned char*)(0x42712620UL))
#define bFM_MFS9_CSIO_SCSCR_SCAM              *((volatile unsigned char*)(0x42712624UL))
#define bFM_MFS9_CSIO_SCSCR_SCD0              *((volatile unsigned char*)(0x42712628UL))
#define bFM_MFS9_CSIO_SCSCR_SCD1              *((volatile unsigned char*)(0x4271262CUL))
#define bFM_MFS9_CSIO_SCSCR_SED0              *((volatile unsigned char*)(0x42712630UL))
#define bFM_MFS9_CSIO_SCSCR_SED1              *((volatile unsigned char*)(0x42712634UL))
#define bFM_MFS9_CSIO_SCSCR_SST0              *((volatile unsigned char*)(0x42712638UL))
#define bFM_MFS9_CSIO_SCSCR_SST1              *((volatile unsigned char*)(0x4271263CUL))
#define bFM_MFS9_CSIO_SCSFR0_CS1L0            *((volatile unsigned char*)(0x42712680UL))
#define bFM_MFS9_CSIO_SCSFR0_CS1L1            *((volatile unsigned char*)(0x42712684UL))
#define bFM_MFS9_CSIO_SCSFR0_CS1L2            *((volatile unsigned char*)(0x42712688UL))
#define bFM_MFS9_CSIO_SCSFR0_CS1L3            *((volatile unsigned char*)(0x4271268CUL))
#define bFM_MFS9_CSIO_SCSFR0_CS1L4            *((volatile unsigned char*)(0x42712690UL))
#define bFM_MFS9_CSIO_SCSFR0_CS1SPI           *((volatile unsigned char*)(0x42712694UL))
#define bFM_MFS9_CSIO_SCSFR0_CS1SCINV         *((volatile unsigned char*)(0x42712698UL))
#define bFM_MFS9_CSIO_SCSFR0_CS1CSLVL         *((volatile unsigned char*)(0x4271269CUL))
#define bFM_MFS9_CSIO_SCSFR1_CS2L0            *((volatile unsigned char*)(0x427126A0UL))
#define bFM_MFS9_CSIO_SCSFR1_CS2L1            *((volatile unsigned char*)(0x427126A4UL))
#define bFM_MFS9_CSIO_SCSFR1_CS2L2            *((volatile unsigned char*)(0x427126A8UL))
#define bFM_MFS9_CSIO_SCSFR1_CS2L3            *((volatile unsigned char*)(0x427126ACUL))
#define bFM_MFS9_CSIO_SCSFR1_CS2L4            *((volatile unsigned char*)(0x427126B0UL))
#define bFM_MFS9_CSIO_SCSFR1_CS2SPI           *((volatile unsigned char*)(0x427126B4UL))
#define bFM_MFS9_CSIO_SCSFR1_CS2SCINV         *((volatile unsigned char*)(0x427126B8UL))
#define bFM_MFS9_CSIO_SCSFR1_CS2CSLVL         *((volatile unsigned char*)(0x427126BCUL))
#define bFM_MFS9_CSIO_SCSFR2_CS3L0            *((volatile unsigned char*)(0x42712700UL))
#define bFM_MFS9_CSIO_SCSFR2_CS3L1            *((volatile unsigned char*)(0x42712704UL))
#define bFM_MFS9_CSIO_SCSFR2_CS3L2            *((volatile unsigned char*)(0x42712708UL))
#define bFM_MFS9_CSIO_SCSFR2_CS3L3            *((volatile unsigned char*)(0x4271270CUL))
#define bFM_MFS9_CSIO_SCSFR2_CS3L4            *((volatile unsigned char*)(0x42712710UL))
#define bFM_MFS9_CSIO_SCSFR2_CS3SPI           *((volatile unsigned char*)(0x42712714UL))
#define bFM_MFS9_CSIO_SCSFR2_CS3SCINV         *((volatile unsigned char*)(0x42712718UL))
#define bFM_MFS9_CSIO_SCSFR2_CS3CSLVL         *((volatile unsigned char*)(0x4271271CUL))

/* MFS LIN channel 9 registers */
#define bFM_MFS9_LIN_SMR_SOE                  *((volatile unsigned char*)(0x42712000UL))
#define bFM_MFS9_LIN_SMR_SBL                  *((volatile unsigned char*)(0x4271200CUL))
#define bFM_MFS9_LIN_SMR_WUCR                 *((volatile unsigned char*)(0x42712010UL))
#define bFM_MFS9_LIN_SMR_MD0                  *((volatile unsigned char*)(0x42712014UL))
#define bFM_MFS9_LIN_SMR_MD1                  *((volatile unsigned char*)(0x42712018UL))
#define bFM_MFS9_LIN_SMR_MD2                  *((volatile unsigned char*)(0x4271201CUL))
#define bFM_MFS9_LIN_SCR_TXE                  *((volatile unsigned char*)(0x42712020UL))
#define bFM_MFS9_LIN_SCR_RXE                  *((volatile unsigned char*)(0x42712024UL))
#define bFM_MFS9_LIN_SCR_TBIE                 *((volatile unsigned char*)(0x42712028UL))
#define bFM_MFS9_LIN_SCR_TIE                  *((volatile unsigned char*)(0x4271202CUL))
#define bFM_MFS9_LIN_SCR_RIE                  *((volatile unsigned char*)(0x42712030UL))
#define bFM_MFS9_LIN_SCR_LBR                  *((volatile unsigned char*)(0x42712034UL))
#define bFM_MFS9_LIN_SCR_MS                   *((volatile unsigned char*)(0x42712038UL))
#define bFM_MFS9_LIN_SCR_UPCL                 *((volatile unsigned char*)(0x4271203CUL))
#define bFM_MFS9_LIN_ESCR_DEL0                *((volatile unsigned char*)(0x42712080UL))
#define bFM_MFS9_LIN_ESCR_DEL1                *((volatile unsigned char*)(0x42712084UL))
#define bFM_MFS9_LIN_ESCR_LBL0                *((volatile unsigned char*)(0x42712088UL))
#define bFM_MFS9_LIN_ESCR_LBL1                *((volatile unsigned char*)(0x4271208CUL))
#define bFM_MFS9_LIN_ESCR_LBIE                *((volatile unsigned char*)(0x42712090UL))
#define bFM_MFS9_LIN_ESCR_ESBL                *((volatile unsigned char*)(0x42712098UL))
#define bFM_MFS9_LIN_SSR_TBI                  *((volatile unsigned char*)(0x427120A0UL))
#define bFM_MFS9_LIN_SSR_TDRE                 *((volatile unsigned char*)(0x427120A4UL))
#define bFM_MFS9_LIN_SSR_RDRF                 *((volatile unsigned char*)(0x427120A8UL))
#define bFM_MFS9_LIN_SSR_ORE                  *((volatile unsigned char*)(0x427120ACUL))
#define bFM_MFS9_LIN_SSR_FRE                  *((volatile unsigned char*)(0x427120B0UL))
#define bFM_MFS9_LIN_SSR_LBD                  *((volatile unsigned char*)(0x427120B4UL))
#define bFM_MFS9_LIN_SSR_REC                  *((volatile unsigned char*)(0x427120BCUL))
#define bFM_MFS9_LIN_BGR_EXT                  *((volatile unsigned char*)(0x427121BCUL))
#define bFM_MFS9_LIN_BGR1_EXT                 *((volatile unsigned char*)(0x427121BCUL))
#define bFM_MFS9_LIN_FCR_FE1                  *((volatile unsigned char*)(0x42712280UL))
#define bFM_MFS9_LIN_FCR_FE2                  *((volatile unsigned char*)(0x42712284UL))
#define bFM_MFS9_LIN_FCR_FCL1                 *((volatile unsigned char*)(0x42712288UL))
#define bFM_MFS9_LIN_FCR_FCL2                 *((volatile unsigned char*)(0x4271228CUL))
#define bFM_MFS9_LIN_FCR_FSET                 *((volatile unsigned char*)(0x42712290UL))
#define bFM_MFS9_LIN_FCR_FLD                  *((volatile unsigned char*)(0x42712294UL))
#define bFM_MFS9_LIN_FCR_FLST                 *((volatile unsigned char*)(0x42712298UL))
#define bFM_MFS9_LIN_FCR_FSEL                 *((volatile unsigned char*)(0x427122A0UL))
#define bFM_MFS9_LIN_FCR_FTIE                 *((volatile unsigned char*)(0x427122A4UL))
#define bFM_MFS9_LIN_FCR_FDRQ                 *((volatile unsigned char*)(0x427122A8UL))
#define bFM_MFS9_LIN_FCR_FRIIE                *((volatile unsigned char*)(0x427122ACUL))
#define bFM_MFS9_LIN_FCR_FLSTE                *((volatile unsigned char*)(0x427122B0UL))
#define bFM_MFS9_LIN_FCR0_FE1                 *((volatile unsigned char*)(0x42712280UL))
#define bFM_MFS9_LIN_FCR0_FE2                 *((volatile unsigned char*)(0x42712284UL))
#define bFM_MFS9_LIN_FCR0_FCL1                *((volatile unsigned char*)(0x42712288UL))
#define bFM_MFS9_LIN_FCR0_FCL2                *((volatile unsigned char*)(0x4271228CUL))
#define bFM_MFS9_LIN_FCR0_FSET                *((volatile unsigned char*)(0x42712290UL))
#define bFM_MFS9_LIN_FCR0_FLD                 *((volatile unsigned char*)(0x42712294UL))
#define bFM_MFS9_LIN_FCR0_FLST                *((volatile unsigned char*)(0x42712298UL))
#define bFM_MFS9_LIN_FCR1_FSEL                *((volatile unsigned char*)(0x427122A0UL))
#define bFM_MFS9_LIN_FCR1_FTIE                *((volatile unsigned char*)(0x427122A4UL))
#define bFM_MFS9_LIN_FCR1_FDRQ                *((volatile unsigned char*)(0x427122A8UL))
#define bFM_MFS9_LIN_FCR1_FRIIE               *((volatile unsigned char*)(0x427122ACUL))
#define bFM_MFS9_LIN_FCR1_FLSTE               *((volatile unsigned char*)(0x427122B0UL))
#define bFM_MFS9_LIN_FBYTE_FD0                *((volatile unsigned char*)(0x42712300UL))
#define bFM_MFS9_LIN_FBYTE_FD1                *((volatile unsigned char*)(0x42712304UL))
#define bFM_MFS9_LIN_FBYTE_FD2                *((volatile unsigned char*)(0x42712308UL))
#define bFM_MFS9_LIN_FBYTE_FD3                *((volatile unsigned char*)(0x4271230CUL))
#define bFM_MFS9_LIN_FBYTE_FD4                *((volatile unsigned char*)(0x42712310UL))
#define bFM_MFS9_LIN_FBYTE_FD5                *((volatile unsigned char*)(0x42712314UL))
#define bFM_MFS9_LIN_FBYTE_FD6                *((volatile unsigned char*)(0x42712318UL))
#define bFM_MFS9_LIN_FBYTE_FD7                *((volatile unsigned char*)(0x4271231CUL))
#define bFM_MFS9_LIN_FBYTE_FD8                *((volatile unsigned char*)(0x42712320UL))
#define bFM_MFS9_LIN_FBYTE_FD9                *((volatile unsigned char*)(0x42712324UL))
#define bFM_MFS9_LIN_FBYTE_FD10               *((volatile unsigned char*)(0x42712328UL))
#define bFM_MFS9_LIN_FBYTE_FD11               *((volatile unsigned char*)(0x4271232CUL))
#define bFM_MFS9_LIN_FBYTE_FD12               *((volatile unsigned char*)(0x42712330UL))
#define bFM_MFS9_LIN_FBYTE_FD13               *((volatile unsigned char*)(0x42712334UL))
#define bFM_MFS9_LIN_FBYTE_FD14               *((volatile unsigned char*)(0x42712338UL))
#define bFM_MFS9_LIN_FBYTE_FD15               *((volatile unsigned char*)(0x4271233CUL))
#define bFM_MFS9_LIN_FBYTE1_FD0               *((volatile unsigned char*)(0x42712300UL))
#define bFM_MFS9_LIN_FBYTE1_FD1               *((volatile unsigned char*)(0x42712304UL))
#define bFM_MFS9_LIN_FBYTE1_FD2               *((volatile unsigned char*)(0x42712308UL))
#define bFM_MFS9_LIN_FBYTE1_FD3               *((volatile unsigned char*)(0x4271230CUL))
#define bFM_MFS9_LIN_FBYTE1_FD4               *((volatile unsigned char*)(0x42712310UL))
#define bFM_MFS9_LIN_FBYTE1_FD5               *((volatile unsigned char*)(0x42712314UL))
#define bFM_MFS9_LIN_FBYTE1_FD6               *((volatile unsigned char*)(0x42712318UL))
#define bFM_MFS9_LIN_FBYTE1_FD7               *((volatile unsigned char*)(0x4271231CUL))
#define bFM_MFS9_LIN_FBYTE2_FD8               *((volatile unsigned char*)(0x42712320UL))
#define bFM_MFS9_LIN_FBYTE2_FD9               *((volatile unsigned char*)(0x42712324UL))
#define bFM_MFS9_LIN_FBYTE2_FD10              *((volatile unsigned char*)(0x42712328UL))
#define bFM_MFS9_LIN_FBYTE2_FD11              *((volatile unsigned char*)(0x4271232CUL))
#define bFM_MFS9_LIN_FBYTE2_FD12              *((volatile unsigned char*)(0x42712330UL))
#define bFM_MFS9_LIN_FBYTE2_FD13              *((volatile unsigned char*)(0x42712334UL))
#define bFM_MFS9_LIN_FBYTE2_FD14              *((volatile unsigned char*)(0x42712338UL))
#define bFM_MFS9_LIN_FBYTE2_FD15              *((volatile unsigned char*)(0x4271233CUL))

/* MFS I2C channel 9 registers */
#define bFM_MFS9_I2C_SMR_TIE                  *((volatile unsigned char*)(0x42712008UL))
#define bFM_MFS9_I2C_SMR_RIE                  *((volatile unsigned char*)(0x4271200CUL))
#define bFM_MFS9_I2C_SMR_MD0                  *((volatile unsigned char*)(0x42712014UL))
#define bFM_MFS9_I2C_SMR_MD1                  *((volatile unsigned char*)(0x42712018UL))
#define bFM_MFS9_I2C_SMR_MD2                  *((volatile unsigned char*)(0x4271201CUL))
#define bFM_MFS9_I2C_IBCR_INT                 *((volatile unsigned char*)(0x42712020UL))
#define bFM_MFS9_I2C_IBCR_BER                 *((volatile unsigned char*)(0x42712024UL))
#define bFM_MFS9_I2C_IBCR_INTE                *((volatile unsigned char*)(0x42712028UL))
#define bFM_MFS9_I2C_IBCR_CNDE                *((volatile unsigned char*)(0x4271202CUL))
#define bFM_MFS9_I2C_IBCR_WSEL                *((volatile unsigned char*)(0x42712030UL))
#define bFM_MFS9_I2C_IBCR_ACKE                *((volatile unsigned char*)(0x42712034UL))
#define bFM_MFS9_I2C_IBCR_ACT                 *((volatile unsigned char*)(0x42712038UL))
#define bFM_MFS9_I2C_IBCR_SCC                 *((volatile unsigned char*)(0x42712038UL))
#define bFM_MFS9_I2C_IBCR_MSS                 *((volatile unsigned char*)(0x4271203CUL))
#define bFM_MFS9_I2C_IBSR_BB                  *((volatile unsigned char*)(0x42712080UL))
#define bFM_MFS9_I2C_IBSR_SPC                 *((volatile unsigned char*)(0x42712084UL))
#define bFM_MFS9_I2C_IBSR_RSC                 *((volatile unsigned char*)(0x42712088UL))
#define bFM_MFS9_I2C_IBSR_AL                  *((volatile unsigned char*)(0x4271208CUL))
#define bFM_MFS9_I2C_IBSR_TRX                 *((volatile unsigned char*)(0x42712090UL))
#define bFM_MFS9_I2C_IBSR_RSA                 *((volatile unsigned char*)(0x42712094UL))
#define bFM_MFS9_I2C_IBSR_RACK                *((volatile unsigned char*)(0x42712098UL))
#define bFM_MFS9_I2C_IBSR_FBT                 *((volatile unsigned char*)(0x4271209CUL))
#define bFM_MFS9_I2C_SSR_TBI                  *((volatile unsigned char*)(0x427120A0UL))
#define bFM_MFS9_I2C_SSR_TDRE                 *((volatile unsigned char*)(0x427120A4UL))
#define bFM_MFS9_I2C_SSR_RDRF                 *((volatile unsigned char*)(0x427120A8UL))
#define bFM_MFS9_I2C_SSR_ORE                  *((volatile unsigned char*)(0x427120ACUL))
#define bFM_MFS9_I2C_SSR_TBIE                 *((volatile unsigned char*)(0x427120B0UL))
#define bFM_MFS9_I2C_SSR_DMA                  *((volatile unsigned char*)(0x427120B4UL))
#define bFM_MFS9_I2C_SSR_TSET                 *((volatile unsigned char*)(0x427120B8UL))
#define bFM_MFS9_I2C_SSR_REC                  *((volatile unsigned char*)(0x427120BCUL))
#define bFM_MFS9_I2C_ISBA_SA0                 *((volatile unsigned char*)(0x42712200UL))
#define bFM_MFS9_I2C_ISBA_SA1                 *((volatile unsigned char*)(0x42712204UL))
#define bFM_MFS9_I2C_ISBA_SA2                 *((volatile unsigned char*)(0x42712208UL))
#define bFM_MFS9_I2C_ISBA_SA3                 *((volatile unsigned char*)(0x4271220CUL))
#define bFM_MFS9_I2C_ISBA_SA4                 *((volatile unsigned char*)(0x42712210UL))
#define bFM_MFS9_I2C_ISBA_SA5                 *((volatile unsigned char*)(0x42712214UL))
#define bFM_MFS9_I2C_ISBA_SA6                 *((volatile unsigned char*)(0x42712218UL))
#define bFM_MFS9_I2C_ISBA_SAEN                *((volatile unsigned char*)(0x4271221CUL))
#define bFM_MFS9_I2C_ISMK_SM0                 *((volatile unsigned char*)(0x42712220UL))
#define bFM_MFS9_I2C_ISMK_SM1                 *((volatile unsigned char*)(0x42712224UL))
#define bFM_MFS9_I2C_ISMK_SM2                 *((volatile unsigned char*)(0x42712228UL))
#define bFM_MFS9_I2C_ISMK_SM3                 *((volatile unsigned char*)(0x4271222CUL))
#define bFM_MFS9_I2C_ISMK_SM4                 *((volatile unsigned char*)(0x42712230UL))
#define bFM_MFS9_I2C_ISMK_SM5                 *((volatile unsigned char*)(0x42712234UL))
#define bFM_MFS9_I2C_ISMK_SM6                 *((volatile unsigned char*)(0x42712238UL))
#define bFM_MFS9_I2C_ISMK_EN                  *((volatile unsigned char*)(0x4271223CUL))
#define bFM_MFS9_I2C_FCR_FE1                  *((volatile unsigned char*)(0x42712280UL))
#define bFM_MFS9_I2C_FCR_FE2                  *((volatile unsigned char*)(0x42712284UL))
#define bFM_MFS9_I2C_FCR_FCL1                 *((volatile unsigned char*)(0x42712288UL))
#define bFM_MFS9_I2C_FCR_FCL2                 *((volatile unsigned char*)(0x4271228CUL))
#define bFM_MFS9_I2C_FCR_FSET                 *((volatile unsigned char*)(0x42712290UL))
#define bFM_MFS9_I2C_FCR_FLD                  *((volatile unsigned char*)(0x42712294UL))
#define bFM_MFS9_I2C_FCR_FLST                 *((volatile unsigned char*)(0x42712298UL))
#define bFM_MFS9_I2C_FCR_FSEL                 *((volatile unsigned char*)(0x427122A0UL))
#define bFM_MFS9_I2C_FCR_FTIE                 *((volatile unsigned char*)(0x427122A4UL))
#define bFM_MFS9_I2C_FCR_FDRQ                 *((volatile unsigned char*)(0x427122A8UL))
#define bFM_MFS9_I2C_FCR_FRIIE                *((volatile unsigned char*)(0x427122ACUL))
#define bFM_MFS9_I2C_FCR_FLSTE                *((volatile unsigned char*)(0x427122B0UL))
#define bFM_MFS9_I2C_FCR0_FE1                 *((volatile unsigned char*)(0x42712280UL))
#define bFM_MFS9_I2C_FCR0_FE2                 *((volatile unsigned char*)(0x42712284UL))
#define bFM_MFS9_I2C_FCR0_FCL1                *((volatile unsigned char*)(0x42712288UL))
#define bFM_MFS9_I2C_FCR0_FCL2                *((volatile unsigned char*)(0x4271228CUL))
#define bFM_MFS9_I2C_FCR0_FSET                *((volatile unsigned char*)(0x42712290UL))
#define bFM_MFS9_I2C_FCR0_FLD                 *((volatile unsigned char*)(0x42712294UL))
#define bFM_MFS9_I2C_FCR0_FLST                *((volatile unsigned char*)(0x42712298UL))
#define bFM_MFS9_I2C_FCR1_FSEL                *((volatile unsigned char*)(0x427122A0UL))
#define bFM_MFS9_I2C_FCR1_FTIE                *((volatile unsigned char*)(0x427122A4UL))
#define bFM_MFS9_I2C_FCR1_FDRQ                *((volatile unsigned char*)(0x427122A8UL))
#define bFM_MFS9_I2C_FCR1_FRIIE               *((volatile unsigned char*)(0x427122ACUL))
#define bFM_MFS9_I2C_FCR1_FLSTE               *((volatile unsigned char*)(0x427122B0UL))
#define bFM_MFS9_I2C_FBYTE_FD0                *((volatile unsigned char*)(0x42712300UL))
#define bFM_MFS9_I2C_FBYTE_FD1                *((volatile unsigned char*)(0x42712304UL))
#define bFM_MFS9_I2C_FBYTE_FD2                *((volatile unsigned char*)(0x42712308UL))
#define bFM_MFS9_I2C_FBYTE_FD3                *((volatile unsigned char*)(0x4271230CUL))
#define bFM_MFS9_I2C_FBYTE_FD4                *((volatile unsigned char*)(0x42712310UL))
#define bFM_MFS9_I2C_FBYTE_FD5                *((volatile unsigned char*)(0x42712314UL))
#define bFM_MFS9_I2C_FBYTE_FD6                *((volatile unsigned char*)(0x42712318UL))
#define bFM_MFS9_I2C_FBYTE_FD7                *((volatile unsigned char*)(0x4271231CUL))
#define bFM_MFS9_I2C_FBYTE_FD8                *((volatile unsigned char*)(0x42712320UL))
#define bFM_MFS9_I2C_FBYTE_FD9                *((volatile unsigned char*)(0x42712324UL))
#define bFM_MFS9_I2C_FBYTE_FD10               *((volatile unsigned char*)(0x42712328UL))
#define bFM_MFS9_I2C_FBYTE_FD11               *((volatile unsigned char*)(0x4271232CUL))
#define bFM_MFS9_I2C_FBYTE_FD12               *((volatile unsigned char*)(0x42712330UL))
#define bFM_MFS9_I2C_FBYTE_FD13               *((volatile unsigned char*)(0x42712334UL))
#define bFM_MFS9_I2C_FBYTE_FD14               *((volatile unsigned char*)(0x42712338UL))
#define bFM_MFS9_I2C_FBYTE_FD15               *((volatile unsigned char*)(0x4271233CUL))
#define bFM_MFS9_I2C_FBYTE1_FD0               *((volatile unsigned char*)(0x42712300UL))
#define bFM_MFS9_I2C_FBYTE1_FD1               *((volatile unsigned char*)(0x42712304UL))
#define bFM_MFS9_I2C_FBYTE1_FD2               *((volatile unsigned char*)(0x42712308UL))
#define bFM_MFS9_I2C_FBYTE1_FD3               *((volatile unsigned char*)(0x4271230CUL))
#define bFM_MFS9_I2C_FBYTE1_FD4               *((volatile unsigned char*)(0x42712310UL))
#define bFM_MFS9_I2C_FBYTE1_FD5               *((volatile unsigned char*)(0x42712314UL))
#define bFM_MFS9_I2C_FBYTE1_FD6               *((volatile unsigned char*)(0x42712318UL))
#define bFM_MFS9_I2C_FBYTE1_FD7               *((volatile unsigned char*)(0x4271231CUL))
#define bFM_MFS9_I2C_FBYTE2_FD8               *((volatile unsigned char*)(0x42712320UL))
#define bFM_MFS9_I2C_FBYTE2_FD9               *((volatile unsigned char*)(0x42712324UL))
#define bFM_MFS9_I2C_FBYTE2_FD10              *((volatile unsigned char*)(0x42712328UL))
#define bFM_MFS9_I2C_FBYTE2_FD11              *((volatile unsigned char*)(0x4271232CUL))
#define bFM_MFS9_I2C_FBYTE2_FD12              *((volatile unsigned char*)(0x42712330UL))
#define bFM_MFS9_I2C_FBYTE2_FD13              *((volatile unsigned char*)(0x42712334UL))
#define bFM_MFS9_I2C_FBYTE2_FD14              *((volatile unsigned char*)(0x42712338UL))
#define bFM_MFS9_I2C_FBYTE2_FD15              *((volatile unsigned char*)(0x4271233CUL))

/* MFS UART channel 10 registers */
#define bFM_MFS10_UART_SMR_SOE                *((volatile unsigned char*)(0x42714000UL))
#define bFM_MFS10_UART_SMR_BDS                *((volatile unsigned char*)(0x42714008UL))
#define bFM_MFS10_UART_SMR_SBL                *((volatile unsigned char*)(0x4271400CUL))
#define bFM_MFS10_UART_SMR_WUCR               *((volatile unsigned char*)(0x42714010UL))
#define bFM_MFS10_UART_SMR_MD0                *((volatile unsigned char*)(0x42714014UL))
#define bFM_MFS10_UART_SMR_MD1                *((volatile unsigned char*)(0x42714018UL))
#define bFM_MFS10_UART_SMR_MD2                *((volatile unsigned char*)(0x4271401CUL))
#define bFM_MFS10_UART_SCR_TXE                *((volatile unsigned char*)(0x42714020UL))
#define bFM_MFS10_UART_SCR_RXE                *((volatile unsigned char*)(0x42714024UL))
#define bFM_MFS10_UART_SCR_TBIE               *((volatile unsigned char*)(0x42714028UL))
#define bFM_MFS10_UART_SCR_TIE                *((volatile unsigned char*)(0x4271402CUL))
#define bFM_MFS10_UART_SCR_RIE                *((volatile unsigned char*)(0x42714030UL))
#define bFM_MFS10_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271403CUL))
#define bFM_MFS10_UART_ESCR_L0                *((volatile unsigned char*)(0x42714080UL))
#define bFM_MFS10_UART_ESCR_L1                *((volatile unsigned char*)(0x42714084UL))
#define bFM_MFS10_UART_ESCR_L2                *((volatile unsigned char*)(0x42714088UL))
#define bFM_MFS10_UART_ESCR_P                 *((volatile unsigned char*)(0x4271408CUL))
#define bFM_MFS10_UART_ESCR_PEN               *((volatile unsigned char*)(0x42714090UL))
#define bFM_MFS10_UART_ESCR_INV               *((volatile unsigned char*)(0x42714094UL))
#define bFM_MFS10_UART_ESCR_ESBL              *((volatile unsigned char*)(0x42714098UL))
#define bFM_MFS10_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271409CUL))
#define bFM_MFS10_UART_SSR_TBI                *((volatile unsigned char*)(0x427140A0UL))
#define bFM_MFS10_UART_SSR_TDRE               *((volatile unsigned char*)(0x427140A4UL))
#define bFM_MFS10_UART_SSR_RDRF               *((volatile unsigned char*)(0x427140A8UL))
#define bFM_MFS10_UART_SSR_ORE                *((volatile unsigned char*)(0x427140ACUL))
#define bFM_MFS10_UART_SSR_FRE                *((volatile unsigned char*)(0x427140B0UL))
#define bFM_MFS10_UART_SSR_PE                 *((volatile unsigned char*)(0x427140B4UL))
#define bFM_MFS10_UART_SSR_REC                *((volatile unsigned char*)(0x427140BCUL))
#define bFM_MFS10_UART_BGR_EXT                *((volatile unsigned char*)(0x427141BCUL))
#define bFM_MFS10_UART_BGR1_EXT               *((volatile unsigned char*)(0x427141BCUL))
#define bFM_MFS10_UART_FCR_FE1                *((volatile unsigned char*)(0x42714280UL))
#define bFM_MFS10_UART_FCR_FE2                *((volatile unsigned char*)(0x42714284UL))
#define bFM_MFS10_UART_FCR_FCL1               *((volatile unsigned char*)(0x42714288UL))
#define bFM_MFS10_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271428CUL))
#define bFM_MFS10_UART_FCR_FSET               *((volatile unsigned char*)(0x42714290UL))
#define bFM_MFS10_UART_FCR_FLD                *((volatile unsigned char*)(0x42714294UL))
#define bFM_MFS10_UART_FCR_FLST               *((volatile unsigned char*)(0x42714298UL))
#define bFM_MFS10_UART_FCR_FSEL               *((volatile unsigned char*)(0x427142A0UL))
#define bFM_MFS10_UART_FCR_FTIE               *((volatile unsigned char*)(0x427142A4UL))
#define bFM_MFS10_UART_FCR_FDRQ               *((volatile unsigned char*)(0x427142A8UL))
#define bFM_MFS10_UART_FCR_FRIIE              *((volatile unsigned char*)(0x427142ACUL))
#define bFM_MFS10_UART_FCR_FLSTE              *((volatile unsigned char*)(0x427142B0UL))
#define bFM_MFS10_UART_FCR0_FE1               *((volatile unsigned char*)(0x42714280UL))
#define bFM_MFS10_UART_FCR0_FE2               *((volatile unsigned char*)(0x42714284UL))
#define bFM_MFS10_UART_FCR0_FCL1              *((volatile unsigned char*)(0x42714288UL))
#define bFM_MFS10_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271428CUL))
#define bFM_MFS10_UART_FCR0_FSET              *((volatile unsigned char*)(0x42714290UL))
#define bFM_MFS10_UART_FCR0_FLD               *((volatile unsigned char*)(0x42714294UL))
#define bFM_MFS10_UART_FCR0_FLST              *((volatile unsigned char*)(0x42714298UL))
#define bFM_MFS10_UART_FCR1_FSEL              *((volatile unsigned char*)(0x427142A0UL))
#define bFM_MFS10_UART_FCR1_FTIE              *((volatile unsigned char*)(0x427142A4UL))
#define bFM_MFS10_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x427142A8UL))
#define bFM_MFS10_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x427142ACUL))
#define bFM_MFS10_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x427142B0UL))
#define bFM_MFS10_UART_FBYTE_FD0              *((volatile unsigned char*)(0x42714300UL))
#define bFM_MFS10_UART_FBYTE_FD1              *((volatile unsigned char*)(0x42714304UL))
#define bFM_MFS10_UART_FBYTE_FD2              *((volatile unsigned char*)(0x42714308UL))
#define bFM_MFS10_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271430CUL))
#define bFM_MFS10_UART_FBYTE_FD4              *((volatile unsigned char*)(0x42714310UL))
#define bFM_MFS10_UART_FBYTE_FD5              *((volatile unsigned char*)(0x42714314UL))
#define bFM_MFS10_UART_FBYTE_FD6              *((volatile unsigned char*)(0x42714318UL))
#define bFM_MFS10_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271431CUL))
#define bFM_MFS10_UART_FBYTE_FD8              *((volatile unsigned char*)(0x42714320UL))
#define bFM_MFS10_UART_FBYTE_FD9              *((volatile unsigned char*)(0x42714324UL))
#define bFM_MFS10_UART_FBYTE_FD10             *((volatile unsigned char*)(0x42714328UL))
#define bFM_MFS10_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271432CUL))
#define bFM_MFS10_UART_FBYTE_FD12             *((volatile unsigned char*)(0x42714330UL))
#define bFM_MFS10_UART_FBYTE_FD13             *((volatile unsigned char*)(0x42714334UL))
#define bFM_MFS10_UART_FBYTE_FD14             *((volatile unsigned char*)(0x42714338UL))
#define bFM_MFS10_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271433CUL))
#define bFM_MFS10_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x42714300UL))
#define bFM_MFS10_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x42714304UL))
#define bFM_MFS10_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x42714308UL))
#define bFM_MFS10_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271430CUL))
#define bFM_MFS10_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x42714310UL))
#define bFM_MFS10_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x42714314UL))
#define bFM_MFS10_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x42714318UL))
#define bFM_MFS10_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271431CUL))
#define bFM_MFS10_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x42714320UL))
#define bFM_MFS10_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x42714324UL))
#define bFM_MFS10_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x42714328UL))
#define bFM_MFS10_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271432CUL))
#define bFM_MFS10_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x42714330UL))
#define bFM_MFS10_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x42714334UL))
#define bFM_MFS10_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x42714338UL))
#define bFM_MFS10_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271433CUL))

/* MFS CSIO channel 10 registers */
#define bFM_MFS10_CSIO_SMR_SOE                *((volatile unsigned char*)(0x42714000UL))
#define bFM_MFS10_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x42714004UL))
#define bFM_MFS10_CSIO_SMR_BDS                *((volatile unsigned char*)(0x42714008UL))
#define bFM_MFS10_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271400CUL))
#define bFM_MFS10_CSIO_SMR_MD0                *((volatile unsigned char*)(0x42714014UL))
#define bFM_MFS10_CSIO_SMR_MD1                *((volatile unsigned char*)(0x42714018UL))
#define bFM_MFS10_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271401CUL))
#define bFM_MFS10_CSIO_SCR_TXE                *((volatile unsigned char*)(0x42714020UL))
#define bFM_MFS10_CSIO_SCR_RXE                *((volatile unsigned char*)(0x42714024UL))
#define bFM_MFS10_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x42714028UL))
#define bFM_MFS10_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271402CUL))
#define bFM_MFS10_CSIO_SCR_RIE                *((volatile unsigned char*)(0x42714030UL))
#define bFM_MFS10_CSIO_SCR_SPI                *((volatile unsigned char*)(0x42714034UL))
#define bFM_MFS10_CSIO_SCR_MS                 *((volatile unsigned char*)(0x42714038UL))
#define bFM_MFS10_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271403CUL))
#define bFM_MFS10_CSIO_ESCR_L0                *((volatile unsigned char*)(0x42714080UL))
#define bFM_MFS10_CSIO_ESCR_L1                *((volatile unsigned char*)(0x42714084UL))
#define bFM_MFS10_CSIO_ESCR_L2                *((volatile unsigned char*)(0x42714088UL))
#define bFM_MFS10_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271408CUL))
#define bFM_MFS10_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x42714090UL))
#define bFM_MFS10_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x42714094UL))
#define bFM_MFS10_CSIO_ESCR_L3                *((volatile unsigned char*)(0x42714098UL))
#define bFM_MFS10_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271409CUL))
#define bFM_MFS10_CSIO_SSR_TBI                *((volatile unsigned char*)(0x427140A0UL))
#define bFM_MFS10_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x427140A4UL))
#define bFM_MFS10_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x427140A8UL))
#define bFM_MFS10_CSIO_SSR_ORE                *((volatile unsigned char*)(0x427140ACUL))
#define bFM_MFS10_CSIO_SSR_AWC                *((volatile unsigned char*)(0x427140B0UL))
#define bFM_MFS10_CSIO_SSR_REC                *((volatile unsigned char*)(0x427140BCUL))
#define bFM_MFS10_CSIO_FCR_FE1                *((volatile unsigned char*)(0x42714280UL))
#define bFM_MFS10_CSIO_FCR_FE2                *((volatile unsigned char*)(0x42714284UL))
#define bFM_MFS10_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x42714288UL))
#define bFM_MFS10_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271428CUL))
#define bFM_MFS10_CSIO_FCR_FSET               *((volatile unsigned char*)(0x42714290UL))
#define bFM_MFS10_CSIO_FCR_FLD                *((volatile unsigned char*)(0x42714294UL))
#define bFM_MFS10_CSIO_FCR_FLST               *((volatile unsigned char*)(0x42714298UL))
#define bFM_MFS10_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x427142A0UL))
#define bFM_MFS10_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x427142A4UL))
#define bFM_MFS10_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x427142A8UL))
#define bFM_MFS10_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x427142ACUL))
#define bFM_MFS10_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x427142B0UL))
#define bFM_MFS10_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x42714280UL))
#define bFM_MFS10_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x42714284UL))
#define bFM_MFS10_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x42714288UL))
#define bFM_MFS10_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271428CUL))
#define bFM_MFS10_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x42714290UL))
#define bFM_MFS10_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x42714294UL))
#define bFM_MFS10_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x42714298UL))
#define bFM_MFS10_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x427142A0UL))
#define bFM_MFS10_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x427142A4UL))
#define bFM_MFS10_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x427142A8UL))
#define bFM_MFS10_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x427142ACUL))
#define bFM_MFS10_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x427142B0UL))
#define bFM_MFS10_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x42714300UL))
#define bFM_MFS10_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x42714304UL))
#define bFM_MFS10_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x42714308UL))
#define bFM_MFS10_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271430CUL))
#define bFM_MFS10_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x42714310UL))
#define bFM_MFS10_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x42714314UL))
#define bFM_MFS10_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x42714318UL))
#define bFM_MFS10_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271431CUL))
#define bFM_MFS10_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x42714320UL))
#define bFM_MFS10_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x42714324UL))
#define bFM_MFS10_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x42714328UL))
#define bFM_MFS10_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271432CUL))
#define bFM_MFS10_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x42714330UL))
#define bFM_MFS10_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x42714334UL))
#define bFM_MFS10_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x42714338UL))
#define bFM_MFS10_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271433CUL))
#define bFM_MFS10_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x42714300UL))
#define bFM_MFS10_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x42714304UL))
#define bFM_MFS10_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x42714308UL))
#define bFM_MFS10_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271430CUL))
#define bFM_MFS10_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x42714310UL))
#define bFM_MFS10_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x42714314UL))
#define bFM_MFS10_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x42714318UL))
#define bFM_MFS10_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271431CUL))
#define bFM_MFS10_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x42714320UL))
#define bFM_MFS10_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x42714324UL))
#define bFM_MFS10_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x42714328UL))
#define bFM_MFS10_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271432CUL))
#define bFM_MFS10_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x42714330UL))
#define bFM_MFS10_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x42714334UL))
#define bFM_MFS10_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x42714338UL))
#define bFM_MFS10_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271433CUL))
#define bFM_MFS10_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x42714380UL))
#define bFM_MFS10_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x42714384UL))
#define bFM_MFS10_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x42714388UL))
#define bFM_MFS10_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271438CUL))
#define bFM_MFS10_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x42714390UL))
#define bFM_MFS10_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x42714394UL))
#define bFM_MFS10_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x42714398UL))
#define bFM_MFS10_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271439CUL))
#define bFM_MFS10_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x427143A0UL))
#define bFM_MFS10_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x427143A4UL))
#define bFM_MFS10_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x427143A8UL))
#define bFM_MFS10_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x427143ACUL))
#define bFM_MFS10_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x427143B0UL))
#define bFM_MFS10_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x427143B4UL))
#define bFM_MFS10_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x427143B8UL))
#define bFM_MFS10_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x427143BCUL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x42714400UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x42714404UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x42714408UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271440CUL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x42714410UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x42714414UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x42714418UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271441CUL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x42714420UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x42714424UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x42714428UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271442CUL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x42714430UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x42714434UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x42714438UL))
#define bFM_MFS10_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271443CUL))
#define bFM_MFS10_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x42714480UL))
#define bFM_MFS10_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x42714484UL))
#define bFM_MFS10_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x42714488UL))
#define bFM_MFS10_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271448CUL))
#define bFM_MFS10_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x42714490UL))
#define bFM_MFS10_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x42714498UL))
#define bFM_MFS10_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271449CUL))
#define bFM_MFS10_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x427144A0UL))
#define bFM_MFS10_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x427144ACUL))
#define bFM_MFS10_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x427144B0UL))
#define bFM_MFS10_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x427144B4UL))
#define bFM_MFS10_CSIO_STMR_TM0               *((volatile unsigned char*)(0x42714500UL))
#define bFM_MFS10_CSIO_STMR_TM1               *((volatile unsigned char*)(0x42714504UL))
#define bFM_MFS10_CSIO_STMR_TM2               *((volatile unsigned char*)(0x42714508UL))
#define bFM_MFS10_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271450CUL))
#define bFM_MFS10_CSIO_STMR_TM4               *((volatile unsigned char*)(0x42714510UL))
#define bFM_MFS10_CSIO_STMR_TM5               *((volatile unsigned char*)(0x42714514UL))
#define bFM_MFS10_CSIO_STMR_TM6               *((volatile unsigned char*)(0x42714518UL))
#define bFM_MFS10_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271451CUL))
#define bFM_MFS10_CSIO_STMR_TM8               *((volatile unsigned char*)(0x42714520UL))
#define bFM_MFS10_CSIO_STMR_TM9               *((volatile unsigned char*)(0x42714524UL))
#define bFM_MFS10_CSIO_STMR_TM10              *((volatile unsigned char*)(0x42714528UL))
#define bFM_MFS10_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271452CUL))
#define bFM_MFS10_CSIO_STMR_TM12              *((volatile unsigned char*)(0x42714530UL))
#define bFM_MFS10_CSIO_STMR_TM13              *((volatile unsigned char*)(0x42714534UL))
#define bFM_MFS10_CSIO_STMR_TM14              *((volatile unsigned char*)(0x42714538UL))
#define bFM_MFS10_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271453CUL))
#define bFM_MFS10_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x42714580UL))
#define bFM_MFS10_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x42714584UL))
#define bFM_MFS10_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x42714588UL))
#define bFM_MFS10_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271458CUL))
#define bFM_MFS10_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x42714590UL))
#define bFM_MFS10_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x42714594UL))
#define bFM_MFS10_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x42714598UL))
#define bFM_MFS10_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271459CUL))
#define bFM_MFS10_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x427145A0UL))
#define bFM_MFS10_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x427145A4UL))
#define bFM_MFS10_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x427145A8UL))
#define bFM_MFS10_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x427145ACUL))
#define bFM_MFS10_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x427145B0UL))
#define bFM_MFS10_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x427145B4UL))
#define bFM_MFS10_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x427145B8UL))
#define bFM_MFS10_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x427145BCUL))
#define bFM_MFS10_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x42714600UL))
#define bFM_MFS10_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x42714604UL))
#define bFM_MFS10_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x42714608UL))
#define bFM_MFS10_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271460CUL))
#define bFM_MFS10_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x42714610UL))
#define bFM_MFS10_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x42714614UL))
#define bFM_MFS10_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x42714618UL))
#define bFM_MFS10_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271461CUL))
#define bFM_MFS10_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x42714620UL))
#define bFM_MFS10_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x42714624UL))
#define bFM_MFS10_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x42714628UL))
#define bFM_MFS10_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271462CUL))
#define bFM_MFS10_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x42714630UL))
#define bFM_MFS10_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x42714634UL))
#define bFM_MFS10_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x42714638UL))
#define bFM_MFS10_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271463CUL))
#define bFM_MFS10_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x42714680UL))
#define bFM_MFS10_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x42714684UL))
#define bFM_MFS10_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x42714688UL))
#define bFM_MFS10_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271468CUL))
#define bFM_MFS10_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x42714690UL))
#define bFM_MFS10_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x42714694UL))
#define bFM_MFS10_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x42714698UL))
#define bFM_MFS10_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271469CUL))
#define bFM_MFS10_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x427146A0UL))
#define bFM_MFS10_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x427146A4UL))
#define bFM_MFS10_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x427146A8UL))
#define bFM_MFS10_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x427146ACUL))
#define bFM_MFS10_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x427146B0UL))
#define bFM_MFS10_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x427146B4UL))
#define bFM_MFS10_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x427146B8UL))
#define bFM_MFS10_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x427146BCUL))
#define bFM_MFS10_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x42714700UL))
#define bFM_MFS10_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x42714704UL))
#define bFM_MFS10_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x42714708UL))
#define bFM_MFS10_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271470CUL))
#define bFM_MFS10_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x42714710UL))
#define bFM_MFS10_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x42714714UL))
#define bFM_MFS10_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x42714718UL))
#define bFM_MFS10_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271471CUL))

/* MFS LIN channel 10 registers */
#define bFM_MFS10_LIN_SMR_SOE                 *((volatile unsigned char*)(0x42714000UL))
#define bFM_MFS10_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271400CUL))
#define bFM_MFS10_LIN_SMR_WUCR                *((volatile unsigned char*)(0x42714010UL))
#define bFM_MFS10_LIN_SMR_MD0                 *((volatile unsigned char*)(0x42714014UL))
#define bFM_MFS10_LIN_SMR_MD1                 *((volatile unsigned char*)(0x42714018UL))
#define bFM_MFS10_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271401CUL))
#define bFM_MFS10_LIN_SCR_TXE                 *((volatile unsigned char*)(0x42714020UL))
#define bFM_MFS10_LIN_SCR_RXE                 *((volatile unsigned char*)(0x42714024UL))
#define bFM_MFS10_LIN_SCR_TBIE                *((volatile unsigned char*)(0x42714028UL))
#define bFM_MFS10_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271402CUL))
#define bFM_MFS10_LIN_SCR_RIE                 *((volatile unsigned char*)(0x42714030UL))
#define bFM_MFS10_LIN_SCR_LBR                 *((volatile unsigned char*)(0x42714034UL))
#define bFM_MFS10_LIN_SCR_MS                  *((volatile unsigned char*)(0x42714038UL))
#define bFM_MFS10_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271403CUL))
#define bFM_MFS10_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x42714080UL))
#define bFM_MFS10_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x42714084UL))
#define bFM_MFS10_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x42714088UL))
#define bFM_MFS10_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271408CUL))
#define bFM_MFS10_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x42714090UL))
#define bFM_MFS10_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x42714098UL))
#define bFM_MFS10_LIN_SSR_TBI                 *((volatile unsigned char*)(0x427140A0UL))
#define bFM_MFS10_LIN_SSR_TDRE                *((volatile unsigned char*)(0x427140A4UL))
#define bFM_MFS10_LIN_SSR_RDRF                *((volatile unsigned char*)(0x427140A8UL))
#define bFM_MFS10_LIN_SSR_ORE                 *((volatile unsigned char*)(0x427140ACUL))
#define bFM_MFS10_LIN_SSR_FRE                 *((volatile unsigned char*)(0x427140B0UL))
#define bFM_MFS10_LIN_SSR_LBD                 *((volatile unsigned char*)(0x427140B4UL))
#define bFM_MFS10_LIN_SSR_REC                 *((volatile unsigned char*)(0x427140BCUL))
#define bFM_MFS10_LIN_BGR_EXT                 *((volatile unsigned char*)(0x427141BCUL))
#define bFM_MFS10_LIN_BGR1_EXT                *((volatile unsigned char*)(0x427141BCUL))
#define bFM_MFS10_LIN_FCR_FE1                 *((volatile unsigned char*)(0x42714280UL))
#define bFM_MFS10_LIN_FCR_FE2                 *((volatile unsigned char*)(0x42714284UL))
#define bFM_MFS10_LIN_FCR_FCL1                *((volatile unsigned char*)(0x42714288UL))
#define bFM_MFS10_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271428CUL))
#define bFM_MFS10_LIN_FCR_FSET                *((volatile unsigned char*)(0x42714290UL))
#define bFM_MFS10_LIN_FCR_FLD                 *((volatile unsigned char*)(0x42714294UL))
#define bFM_MFS10_LIN_FCR_FLST                *((volatile unsigned char*)(0x42714298UL))
#define bFM_MFS10_LIN_FCR_FSEL                *((volatile unsigned char*)(0x427142A0UL))
#define bFM_MFS10_LIN_FCR_FTIE                *((volatile unsigned char*)(0x427142A4UL))
#define bFM_MFS10_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x427142A8UL))
#define bFM_MFS10_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x427142ACUL))
#define bFM_MFS10_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x427142B0UL))
#define bFM_MFS10_LIN_FCR0_FE1                *((volatile unsigned char*)(0x42714280UL))
#define bFM_MFS10_LIN_FCR0_FE2                *((volatile unsigned char*)(0x42714284UL))
#define bFM_MFS10_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x42714288UL))
#define bFM_MFS10_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271428CUL))
#define bFM_MFS10_LIN_FCR0_FSET               *((volatile unsigned char*)(0x42714290UL))
#define bFM_MFS10_LIN_FCR0_FLD                *((volatile unsigned char*)(0x42714294UL))
#define bFM_MFS10_LIN_FCR0_FLST               *((volatile unsigned char*)(0x42714298UL))
#define bFM_MFS10_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x427142A0UL))
#define bFM_MFS10_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x427142A4UL))
#define bFM_MFS10_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x427142A8UL))
#define bFM_MFS10_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x427142ACUL))
#define bFM_MFS10_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x427142B0UL))
#define bFM_MFS10_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x42714300UL))
#define bFM_MFS10_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x42714304UL))
#define bFM_MFS10_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x42714308UL))
#define bFM_MFS10_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271430CUL))
#define bFM_MFS10_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x42714310UL))
#define bFM_MFS10_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x42714314UL))
#define bFM_MFS10_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x42714318UL))
#define bFM_MFS10_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271431CUL))
#define bFM_MFS10_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x42714320UL))
#define bFM_MFS10_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x42714324UL))
#define bFM_MFS10_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x42714328UL))
#define bFM_MFS10_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271432CUL))
#define bFM_MFS10_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x42714330UL))
#define bFM_MFS10_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x42714334UL))
#define bFM_MFS10_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x42714338UL))
#define bFM_MFS10_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271433CUL))
#define bFM_MFS10_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x42714300UL))
#define bFM_MFS10_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x42714304UL))
#define bFM_MFS10_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x42714308UL))
#define bFM_MFS10_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271430CUL))
#define bFM_MFS10_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x42714310UL))
#define bFM_MFS10_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x42714314UL))
#define bFM_MFS10_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x42714318UL))
#define bFM_MFS10_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271431CUL))
#define bFM_MFS10_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x42714320UL))
#define bFM_MFS10_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x42714324UL))
#define bFM_MFS10_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x42714328UL))
#define bFM_MFS10_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271432CUL))
#define bFM_MFS10_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x42714330UL))
#define bFM_MFS10_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x42714334UL))
#define bFM_MFS10_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x42714338UL))
#define bFM_MFS10_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271433CUL))

/* MFS I2C channel 10 registers */
#define bFM_MFS10_I2C_SMR_TIE                 *((volatile unsigned char*)(0x42714008UL))
#define bFM_MFS10_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271400CUL))
#define bFM_MFS10_I2C_SMR_MD0                 *((volatile unsigned char*)(0x42714014UL))
#define bFM_MFS10_I2C_SMR_MD1                 *((volatile unsigned char*)(0x42714018UL))
#define bFM_MFS10_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271401CUL))
#define bFM_MFS10_I2C_IBCR_INT                *((volatile unsigned char*)(0x42714020UL))
#define bFM_MFS10_I2C_IBCR_BER                *((volatile unsigned char*)(0x42714024UL))
#define bFM_MFS10_I2C_IBCR_INTE               *((volatile unsigned char*)(0x42714028UL))
#define bFM_MFS10_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271402CUL))
#define bFM_MFS10_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x42714030UL))
#define bFM_MFS10_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x42714034UL))
#define bFM_MFS10_I2C_IBCR_ACT                *((volatile unsigned char*)(0x42714038UL))
#define bFM_MFS10_I2C_IBCR_SCC                *((volatile unsigned char*)(0x42714038UL))
#define bFM_MFS10_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271403CUL))
#define bFM_MFS10_I2C_IBSR_BB                 *((volatile unsigned char*)(0x42714080UL))
#define bFM_MFS10_I2C_IBSR_SPC                *((volatile unsigned char*)(0x42714084UL))
#define bFM_MFS10_I2C_IBSR_RSC                *((volatile unsigned char*)(0x42714088UL))
#define bFM_MFS10_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271408CUL))
#define bFM_MFS10_I2C_IBSR_TRX                *((volatile unsigned char*)(0x42714090UL))
#define bFM_MFS10_I2C_IBSR_RSA                *((volatile unsigned char*)(0x42714094UL))
#define bFM_MFS10_I2C_IBSR_RACK               *((volatile unsigned char*)(0x42714098UL))
#define bFM_MFS10_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271409CUL))
#define bFM_MFS10_I2C_SSR_TBI                 *((volatile unsigned char*)(0x427140A0UL))
#define bFM_MFS10_I2C_SSR_TDRE                *((volatile unsigned char*)(0x427140A4UL))
#define bFM_MFS10_I2C_SSR_RDRF                *((volatile unsigned char*)(0x427140A8UL))
#define bFM_MFS10_I2C_SSR_ORE                 *((volatile unsigned char*)(0x427140ACUL))
#define bFM_MFS10_I2C_SSR_TBIE                *((volatile unsigned char*)(0x427140B0UL))
#define bFM_MFS10_I2C_SSR_DMA                 *((volatile unsigned char*)(0x427140B4UL))
#define bFM_MFS10_I2C_SSR_TSET                *((volatile unsigned char*)(0x427140B8UL))
#define bFM_MFS10_I2C_SSR_REC                 *((volatile unsigned char*)(0x427140BCUL))
#define bFM_MFS10_I2C_ISBA_SA0                *((volatile unsigned char*)(0x42714200UL))
#define bFM_MFS10_I2C_ISBA_SA1                *((volatile unsigned char*)(0x42714204UL))
#define bFM_MFS10_I2C_ISBA_SA2                *((volatile unsigned char*)(0x42714208UL))
#define bFM_MFS10_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271420CUL))
#define bFM_MFS10_I2C_ISBA_SA4                *((volatile unsigned char*)(0x42714210UL))
#define bFM_MFS10_I2C_ISBA_SA5                *((volatile unsigned char*)(0x42714214UL))
#define bFM_MFS10_I2C_ISBA_SA6                *((volatile unsigned char*)(0x42714218UL))
#define bFM_MFS10_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271421CUL))
#define bFM_MFS10_I2C_ISMK_SM0                *((volatile unsigned char*)(0x42714220UL))
#define bFM_MFS10_I2C_ISMK_SM1                *((volatile unsigned char*)(0x42714224UL))
#define bFM_MFS10_I2C_ISMK_SM2                *((volatile unsigned char*)(0x42714228UL))
#define bFM_MFS10_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271422CUL))
#define bFM_MFS10_I2C_ISMK_SM4                *((volatile unsigned char*)(0x42714230UL))
#define bFM_MFS10_I2C_ISMK_SM5                *((volatile unsigned char*)(0x42714234UL))
#define bFM_MFS10_I2C_ISMK_SM6                *((volatile unsigned char*)(0x42714238UL))
#define bFM_MFS10_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271423CUL))
#define bFM_MFS10_I2C_FCR_FE1                 *((volatile unsigned char*)(0x42714280UL))
#define bFM_MFS10_I2C_FCR_FE2                 *((volatile unsigned char*)(0x42714284UL))
#define bFM_MFS10_I2C_FCR_FCL1                *((volatile unsigned char*)(0x42714288UL))
#define bFM_MFS10_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271428CUL))
#define bFM_MFS10_I2C_FCR_FSET                *((volatile unsigned char*)(0x42714290UL))
#define bFM_MFS10_I2C_FCR_FLD                 *((volatile unsigned char*)(0x42714294UL))
#define bFM_MFS10_I2C_FCR_FLST                *((volatile unsigned char*)(0x42714298UL))
#define bFM_MFS10_I2C_FCR_FSEL                *((volatile unsigned char*)(0x427142A0UL))
#define bFM_MFS10_I2C_FCR_FTIE                *((volatile unsigned char*)(0x427142A4UL))
#define bFM_MFS10_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x427142A8UL))
#define bFM_MFS10_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x427142ACUL))
#define bFM_MFS10_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x427142B0UL))
#define bFM_MFS10_I2C_FCR0_FE1                *((volatile unsigned char*)(0x42714280UL))
#define bFM_MFS10_I2C_FCR0_FE2                *((volatile unsigned char*)(0x42714284UL))
#define bFM_MFS10_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x42714288UL))
#define bFM_MFS10_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271428CUL))
#define bFM_MFS10_I2C_FCR0_FSET               *((volatile unsigned char*)(0x42714290UL))
#define bFM_MFS10_I2C_FCR0_FLD                *((volatile unsigned char*)(0x42714294UL))
#define bFM_MFS10_I2C_FCR0_FLST               *((volatile unsigned char*)(0x42714298UL))
#define bFM_MFS10_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x427142A0UL))
#define bFM_MFS10_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x427142A4UL))
#define bFM_MFS10_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x427142A8UL))
#define bFM_MFS10_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x427142ACUL))
#define bFM_MFS10_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x427142B0UL))
#define bFM_MFS10_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x42714300UL))
#define bFM_MFS10_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x42714304UL))
#define bFM_MFS10_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x42714308UL))
#define bFM_MFS10_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271430CUL))
#define bFM_MFS10_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x42714310UL))
#define bFM_MFS10_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x42714314UL))
#define bFM_MFS10_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x42714318UL))
#define bFM_MFS10_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271431CUL))
#define bFM_MFS10_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x42714320UL))
#define bFM_MFS10_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x42714324UL))
#define bFM_MFS10_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x42714328UL))
#define bFM_MFS10_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271432CUL))
#define bFM_MFS10_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x42714330UL))
#define bFM_MFS10_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x42714334UL))
#define bFM_MFS10_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x42714338UL))
#define bFM_MFS10_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271433CUL))
#define bFM_MFS10_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x42714300UL))
#define bFM_MFS10_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x42714304UL))
#define bFM_MFS10_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x42714308UL))
#define bFM_MFS10_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271430CUL))
#define bFM_MFS10_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x42714310UL))
#define bFM_MFS10_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x42714314UL))
#define bFM_MFS10_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x42714318UL))
#define bFM_MFS10_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271431CUL))
#define bFM_MFS10_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x42714320UL))
#define bFM_MFS10_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x42714324UL))
#define bFM_MFS10_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x42714328UL))
#define bFM_MFS10_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271432CUL))
#define bFM_MFS10_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x42714330UL))
#define bFM_MFS10_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x42714334UL))
#define bFM_MFS10_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x42714338UL))
#define bFM_MFS10_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271433CUL))

/* MFS UART channel 11 registers */
#define bFM_MFS11_UART_SMR_SOE                *((volatile unsigned char*)(0x42716000UL))
#define bFM_MFS11_UART_SMR_BDS                *((volatile unsigned char*)(0x42716008UL))
#define bFM_MFS11_UART_SMR_SBL                *((volatile unsigned char*)(0x4271600CUL))
#define bFM_MFS11_UART_SMR_WUCR               *((volatile unsigned char*)(0x42716010UL))
#define bFM_MFS11_UART_SMR_MD0                *((volatile unsigned char*)(0x42716014UL))
#define bFM_MFS11_UART_SMR_MD1                *((volatile unsigned char*)(0x42716018UL))
#define bFM_MFS11_UART_SMR_MD2                *((volatile unsigned char*)(0x4271601CUL))
#define bFM_MFS11_UART_SCR_TXE                *((volatile unsigned char*)(0x42716020UL))
#define bFM_MFS11_UART_SCR_RXE                *((volatile unsigned char*)(0x42716024UL))
#define bFM_MFS11_UART_SCR_TBIE               *((volatile unsigned char*)(0x42716028UL))
#define bFM_MFS11_UART_SCR_TIE                *((volatile unsigned char*)(0x4271602CUL))
#define bFM_MFS11_UART_SCR_RIE                *((volatile unsigned char*)(0x42716030UL))
#define bFM_MFS11_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271603CUL))
#define bFM_MFS11_UART_ESCR_L0                *((volatile unsigned char*)(0x42716080UL))
#define bFM_MFS11_UART_ESCR_L1                *((volatile unsigned char*)(0x42716084UL))
#define bFM_MFS11_UART_ESCR_L2                *((volatile unsigned char*)(0x42716088UL))
#define bFM_MFS11_UART_ESCR_P                 *((volatile unsigned char*)(0x4271608CUL))
#define bFM_MFS11_UART_ESCR_PEN               *((volatile unsigned char*)(0x42716090UL))
#define bFM_MFS11_UART_ESCR_INV               *((volatile unsigned char*)(0x42716094UL))
#define bFM_MFS11_UART_ESCR_ESBL              *((volatile unsigned char*)(0x42716098UL))
#define bFM_MFS11_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271609CUL))
#define bFM_MFS11_UART_SSR_TBI                *((volatile unsigned char*)(0x427160A0UL))
#define bFM_MFS11_UART_SSR_TDRE               *((volatile unsigned char*)(0x427160A4UL))
#define bFM_MFS11_UART_SSR_RDRF               *((volatile unsigned char*)(0x427160A8UL))
#define bFM_MFS11_UART_SSR_ORE                *((volatile unsigned char*)(0x427160ACUL))
#define bFM_MFS11_UART_SSR_FRE                *((volatile unsigned char*)(0x427160B0UL))
#define bFM_MFS11_UART_SSR_PE                 *((volatile unsigned char*)(0x427160B4UL))
#define bFM_MFS11_UART_SSR_REC                *((volatile unsigned char*)(0x427160BCUL))
#define bFM_MFS11_UART_BGR_EXT                *((volatile unsigned char*)(0x427161BCUL))
#define bFM_MFS11_UART_BGR1_EXT               *((volatile unsigned char*)(0x427161BCUL))
#define bFM_MFS11_UART_FCR_FE1                *((volatile unsigned char*)(0x42716280UL))
#define bFM_MFS11_UART_FCR_FE2                *((volatile unsigned char*)(0x42716284UL))
#define bFM_MFS11_UART_FCR_FCL1               *((volatile unsigned char*)(0x42716288UL))
#define bFM_MFS11_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271628CUL))
#define bFM_MFS11_UART_FCR_FSET               *((volatile unsigned char*)(0x42716290UL))
#define bFM_MFS11_UART_FCR_FLD                *((volatile unsigned char*)(0x42716294UL))
#define bFM_MFS11_UART_FCR_FLST               *((volatile unsigned char*)(0x42716298UL))
#define bFM_MFS11_UART_FCR_FSEL               *((volatile unsigned char*)(0x427162A0UL))
#define bFM_MFS11_UART_FCR_FTIE               *((volatile unsigned char*)(0x427162A4UL))
#define bFM_MFS11_UART_FCR_FDRQ               *((volatile unsigned char*)(0x427162A8UL))
#define bFM_MFS11_UART_FCR_FRIIE              *((volatile unsigned char*)(0x427162ACUL))
#define bFM_MFS11_UART_FCR_FLSTE              *((volatile unsigned char*)(0x427162B0UL))
#define bFM_MFS11_UART_FCR0_FE1               *((volatile unsigned char*)(0x42716280UL))
#define bFM_MFS11_UART_FCR0_FE2               *((volatile unsigned char*)(0x42716284UL))
#define bFM_MFS11_UART_FCR0_FCL1              *((volatile unsigned char*)(0x42716288UL))
#define bFM_MFS11_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271628CUL))
#define bFM_MFS11_UART_FCR0_FSET              *((volatile unsigned char*)(0x42716290UL))
#define bFM_MFS11_UART_FCR0_FLD               *((volatile unsigned char*)(0x42716294UL))
#define bFM_MFS11_UART_FCR0_FLST              *((volatile unsigned char*)(0x42716298UL))
#define bFM_MFS11_UART_FCR1_FSEL              *((volatile unsigned char*)(0x427162A0UL))
#define bFM_MFS11_UART_FCR1_FTIE              *((volatile unsigned char*)(0x427162A4UL))
#define bFM_MFS11_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x427162A8UL))
#define bFM_MFS11_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x427162ACUL))
#define bFM_MFS11_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x427162B0UL))
#define bFM_MFS11_UART_FBYTE_FD0              *((volatile unsigned char*)(0x42716300UL))
#define bFM_MFS11_UART_FBYTE_FD1              *((volatile unsigned char*)(0x42716304UL))
#define bFM_MFS11_UART_FBYTE_FD2              *((volatile unsigned char*)(0x42716308UL))
#define bFM_MFS11_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271630CUL))
#define bFM_MFS11_UART_FBYTE_FD4              *((volatile unsigned char*)(0x42716310UL))
#define bFM_MFS11_UART_FBYTE_FD5              *((volatile unsigned char*)(0x42716314UL))
#define bFM_MFS11_UART_FBYTE_FD6              *((volatile unsigned char*)(0x42716318UL))
#define bFM_MFS11_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271631CUL))
#define bFM_MFS11_UART_FBYTE_FD8              *((volatile unsigned char*)(0x42716320UL))
#define bFM_MFS11_UART_FBYTE_FD9              *((volatile unsigned char*)(0x42716324UL))
#define bFM_MFS11_UART_FBYTE_FD10             *((volatile unsigned char*)(0x42716328UL))
#define bFM_MFS11_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271632CUL))
#define bFM_MFS11_UART_FBYTE_FD12             *((volatile unsigned char*)(0x42716330UL))
#define bFM_MFS11_UART_FBYTE_FD13             *((volatile unsigned char*)(0x42716334UL))
#define bFM_MFS11_UART_FBYTE_FD14             *((volatile unsigned char*)(0x42716338UL))
#define bFM_MFS11_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271633CUL))
#define bFM_MFS11_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x42716300UL))
#define bFM_MFS11_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x42716304UL))
#define bFM_MFS11_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x42716308UL))
#define bFM_MFS11_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271630CUL))
#define bFM_MFS11_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x42716310UL))
#define bFM_MFS11_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x42716314UL))
#define bFM_MFS11_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x42716318UL))
#define bFM_MFS11_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271631CUL))
#define bFM_MFS11_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x42716320UL))
#define bFM_MFS11_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x42716324UL))
#define bFM_MFS11_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x42716328UL))
#define bFM_MFS11_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271632CUL))
#define bFM_MFS11_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x42716330UL))
#define bFM_MFS11_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x42716334UL))
#define bFM_MFS11_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x42716338UL))
#define bFM_MFS11_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271633CUL))

/* MFS CSIO channel 11 registers */
#define bFM_MFS11_CSIO_SMR_SOE                *((volatile unsigned char*)(0x42716000UL))
#define bFM_MFS11_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x42716004UL))
#define bFM_MFS11_CSIO_SMR_BDS                *((volatile unsigned char*)(0x42716008UL))
#define bFM_MFS11_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271600CUL))
#define bFM_MFS11_CSIO_SMR_MD0                *((volatile unsigned char*)(0x42716014UL))
#define bFM_MFS11_CSIO_SMR_MD1                *((volatile unsigned char*)(0x42716018UL))
#define bFM_MFS11_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271601CUL))
#define bFM_MFS11_CSIO_SCR_TXE                *((volatile unsigned char*)(0x42716020UL))
#define bFM_MFS11_CSIO_SCR_RXE                *((volatile unsigned char*)(0x42716024UL))
#define bFM_MFS11_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x42716028UL))
#define bFM_MFS11_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271602CUL))
#define bFM_MFS11_CSIO_SCR_RIE                *((volatile unsigned char*)(0x42716030UL))
#define bFM_MFS11_CSIO_SCR_SPI                *((volatile unsigned char*)(0x42716034UL))
#define bFM_MFS11_CSIO_SCR_MS                 *((volatile unsigned char*)(0x42716038UL))
#define bFM_MFS11_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271603CUL))
#define bFM_MFS11_CSIO_ESCR_L0                *((volatile unsigned char*)(0x42716080UL))
#define bFM_MFS11_CSIO_ESCR_L1                *((volatile unsigned char*)(0x42716084UL))
#define bFM_MFS11_CSIO_ESCR_L2                *((volatile unsigned char*)(0x42716088UL))
#define bFM_MFS11_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271608CUL))
#define bFM_MFS11_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x42716090UL))
#define bFM_MFS11_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x42716094UL))
#define bFM_MFS11_CSIO_ESCR_L3                *((volatile unsigned char*)(0x42716098UL))
#define bFM_MFS11_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271609CUL))
#define bFM_MFS11_CSIO_SSR_TBI                *((volatile unsigned char*)(0x427160A0UL))
#define bFM_MFS11_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x427160A4UL))
#define bFM_MFS11_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x427160A8UL))
#define bFM_MFS11_CSIO_SSR_ORE                *((volatile unsigned char*)(0x427160ACUL))
#define bFM_MFS11_CSIO_SSR_AWC                *((volatile unsigned char*)(0x427160B0UL))
#define bFM_MFS11_CSIO_SSR_REC                *((volatile unsigned char*)(0x427160BCUL))
#define bFM_MFS11_CSIO_FCR_FE1                *((volatile unsigned char*)(0x42716280UL))
#define bFM_MFS11_CSIO_FCR_FE2                *((volatile unsigned char*)(0x42716284UL))
#define bFM_MFS11_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x42716288UL))
#define bFM_MFS11_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271628CUL))
#define bFM_MFS11_CSIO_FCR_FSET               *((volatile unsigned char*)(0x42716290UL))
#define bFM_MFS11_CSIO_FCR_FLD                *((volatile unsigned char*)(0x42716294UL))
#define bFM_MFS11_CSIO_FCR_FLST               *((volatile unsigned char*)(0x42716298UL))
#define bFM_MFS11_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x427162A0UL))
#define bFM_MFS11_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x427162A4UL))
#define bFM_MFS11_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x427162A8UL))
#define bFM_MFS11_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x427162ACUL))
#define bFM_MFS11_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x427162B0UL))
#define bFM_MFS11_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x42716280UL))
#define bFM_MFS11_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x42716284UL))
#define bFM_MFS11_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x42716288UL))
#define bFM_MFS11_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271628CUL))
#define bFM_MFS11_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x42716290UL))
#define bFM_MFS11_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x42716294UL))
#define bFM_MFS11_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x42716298UL))
#define bFM_MFS11_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x427162A0UL))
#define bFM_MFS11_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x427162A4UL))
#define bFM_MFS11_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x427162A8UL))
#define bFM_MFS11_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x427162ACUL))
#define bFM_MFS11_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x427162B0UL))
#define bFM_MFS11_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x42716300UL))
#define bFM_MFS11_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x42716304UL))
#define bFM_MFS11_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x42716308UL))
#define bFM_MFS11_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271630CUL))
#define bFM_MFS11_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x42716310UL))
#define bFM_MFS11_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x42716314UL))
#define bFM_MFS11_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x42716318UL))
#define bFM_MFS11_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271631CUL))
#define bFM_MFS11_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x42716320UL))
#define bFM_MFS11_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x42716324UL))
#define bFM_MFS11_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x42716328UL))
#define bFM_MFS11_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271632CUL))
#define bFM_MFS11_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x42716330UL))
#define bFM_MFS11_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x42716334UL))
#define bFM_MFS11_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x42716338UL))
#define bFM_MFS11_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271633CUL))
#define bFM_MFS11_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x42716300UL))
#define bFM_MFS11_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x42716304UL))
#define bFM_MFS11_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x42716308UL))
#define bFM_MFS11_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271630CUL))
#define bFM_MFS11_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x42716310UL))
#define bFM_MFS11_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x42716314UL))
#define bFM_MFS11_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x42716318UL))
#define bFM_MFS11_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271631CUL))
#define bFM_MFS11_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x42716320UL))
#define bFM_MFS11_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x42716324UL))
#define bFM_MFS11_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x42716328UL))
#define bFM_MFS11_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271632CUL))
#define bFM_MFS11_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x42716330UL))
#define bFM_MFS11_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x42716334UL))
#define bFM_MFS11_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x42716338UL))
#define bFM_MFS11_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271633CUL))
#define bFM_MFS11_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x42716380UL))
#define bFM_MFS11_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x42716384UL))
#define bFM_MFS11_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x42716388UL))
#define bFM_MFS11_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271638CUL))
#define bFM_MFS11_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x42716390UL))
#define bFM_MFS11_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x42716394UL))
#define bFM_MFS11_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x42716398UL))
#define bFM_MFS11_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271639CUL))
#define bFM_MFS11_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x427163A0UL))
#define bFM_MFS11_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x427163A4UL))
#define bFM_MFS11_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x427163A8UL))
#define bFM_MFS11_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x427163ACUL))
#define bFM_MFS11_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x427163B0UL))
#define bFM_MFS11_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x427163B4UL))
#define bFM_MFS11_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x427163B8UL))
#define bFM_MFS11_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x427163BCUL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x42716400UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x42716404UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x42716408UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271640CUL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x42716410UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x42716414UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x42716418UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271641CUL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x42716420UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x42716424UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x42716428UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271642CUL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x42716430UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x42716434UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x42716438UL))
#define bFM_MFS11_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271643CUL))
#define bFM_MFS11_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x42716480UL))
#define bFM_MFS11_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x42716484UL))
#define bFM_MFS11_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x42716488UL))
#define bFM_MFS11_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271648CUL))
#define bFM_MFS11_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x42716490UL))
#define bFM_MFS11_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x42716498UL))
#define bFM_MFS11_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271649CUL))
#define bFM_MFS11_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x427164A0UL))
#define bFM_MFS11_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x427164ACUL))
#define bFM_MFS11_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x427164B0UL))
#define bFM_MFS11_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x427164B4UL))
#define bFM_MFS11_CSIO_STMR_TM0               *((volatile unsigned char*)(0x42716500UL))
#define bFM_MFS11_CSIO_STMR_TM1               *((volatile unsigned char*)(0x42716504UL))
#define bFM_MFS11_CSIO_STMR_TM2               *((volatile unsigned char*)(0x42716508UL))
#define bFM_MFS11_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271650CUL))
#define bFM_MFS11_CSIO_STMR_TM4               *((volatile unsigned char*)(0x42716510UL))
#define bFM_MFS11_CSIO_STMR_TM5               *((volatile unsigned char*)(0x42716514UL))
#define bFM_MFS11_CSIO_STMR_TM6               *((volatile unsigned char*)(0x42716518UL))
#define bFM_MFS11_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271651CUL))
#define bFM_MFS11_CSIO_STMR_TM8               *((volatile unsigned char*)(0x42716520UL))
#define bFM_MFS11_CSIO_STMR_TM9               *((volatile unsigned char*)(0x42716524UL))
#define bFM_MFS11_CSIO_STMR_TM10              *((volatile unsigned char*)(0x42716528UL))
#define bFM_MFS11_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271652CUL))
#define bFM_MFS11_CSIO_STMR_TM12              *((volatile unsigned char*)(0x42716530UL))
#define bFM_MFS11_CSIO_STMR_TM13              *((volatile unsigned char*)(0x42716534UL))
#define bFM_MFS11_CSIO_STMR_TM14              *((volatile unsigned char*)(0x42716538UL))
#define bFM_MFS11_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271653CUL))
#define bFM_MFS11_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x42716580UL))
#define bFM_MFS11_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x42716584UL))
#define bFM_MFS11_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x42716588UL))
#define bFM_MFS11_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271658CUL))
#define bFM_MFS11_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x42716590UL))
#define bFM_MFS11_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x42716594UL))
#define bFM_MFS11_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x42716598UL))
#define bFM_MFS11_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271659CUL))
#define bFM_MFS11_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x427165A0UL))
#define bFM_MFS11_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x427165A4UL))
#define bFM_MFS11_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x427165A8UL))
#define bFM_MFS11_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x427165ACUL))
#define bFM_MFS11_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x427165B0UL))
#define bFM_MFS11_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x427165B4UL))
#define bFM_MFS11_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x427165B8UL))
#define bFM_MFS11_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x427165BCUL))
#define bFM_MFS11_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x42716600UL))
#define bFM_MFS11_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x42716604UL))
#define bFM_MFS11_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x42716608UL))
#define bFM_MFS11_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271660CUL))
#define bFM_MFS11_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x42716610UL))
#define bFM_MFS11_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x42716614UL))
#define bFM_MFS11_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x42716618UL))
#define bFM_MFS11_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271661CUL))
#define bFM_MFS11_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x42716620UL))
#define bFM_MFS11_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x42716624UL))
#define bFM_MFS11_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x42716628UL))
#define bFM_MFS11_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271662CUL))
#define bFM_MFS11_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x42716630UL))
#define bFM_MFS11_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x42716634UL))
#define bFM_MFS11_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x42716638UL))
#define bFM_MFS11_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271663CUL))
#define bFM_MFS11_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x42716680UL))
#define bFM_MFS11_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x42716684UL))
#define bFM_MFS11_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x42716688UL))
#define bFM_MFS11_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271668CUL))
#define bFM_MFS11_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x42716690UL))
#define bFM_MFS11_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x42716694UL))
#define bFM_MFS11_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x42716698UL))
#define bFM_MFS11_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271669CUL))
#define bFM_MFS11_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x427166A0UL))
#define bFM_MFS11_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x427166A4UL))
#define bFM_MFS11_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x427166A8UL))
#define bFM_MFS11_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x427166ACUL))
#define bFM_MFS11_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x427166B0UL))
#define bFM_MFS11_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x427166B4UL))
#define bFM_MFS11_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x427166B8UL))
#define bFM_MFS11_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x427166BCUL))
#define bFM_MFS11_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x42716700UL))
#define bFM_MFS11_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x42716704UL))
#define bFM_MFS11_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x42716708UL))
#define bFM_MFS11_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271670CUL))
#define bFM_MFS11_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x42716710UL))
#define bFM_MFS11_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x42716714UL))
#define bFM_MFS11_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x42716718UL))
#define bFM_MFS11_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271671CUL))

/* MFS LIN channel 11 registers */
#define bFM_MFS11_LIN_SMR_SOE                 *((volatile unsigned char*)(0x42716000UL))
#define bFM_MFS11_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271600CUL))
#define bFM_MFS11_LIN_SMR_WUCR                *((volatile unsigned char*)(0x42716010UL))
#define bFM_MFS11_LIN_SMR_MD0                 *((volatile unsigned char*)(0x42716014UL))
#define bFM_MFS11_LIN_SMR_MD1                 *((volatile unsigned char*)(0x42716018UL))
#define bFM_MFS11_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271601CUL))
#define bFM_MFS11_LIN_SCR_TXE                 *((volatile unsigned char*)(0x42716020UL))
#define bFM_MFS11_LIN_SCR_RXE                 *((volatile unsigned char*)(0x42716024UL))
#define bFM_MFS11_LIN_SCR_TBIE                *((volatile unsigned char*)(0x42716028UL))
#define bFM_MFS11_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271602CUL))
#define bFM_MFS11_LIN_SCR_RIE                 *((volatile unsigned char*)(0x42716030UL))
#define bFM_MFS11_LIN_SCR_LBR                 *((volatile unsigned char*)(0x42716034UL))
#define bFM_MFS11_LIN_SCR_MS                  *((volatile unsigned char*)(0x42716038UL))
#define bFM_MFS11_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271603CUL))
#define bFM_MFS11_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x42716080UL))
#define bFM_MFS11_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x42716084UL))
#define bFM_MFS11_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x42716088UL))
#define bFM_MFS11_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271608CUL))
#define bFM_MFS11_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x42716090UL))
#define bFM_MFS11_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x42716098UL))
#define bFM_MFS11_LIN_SSR_TBI                 *((volatile unsigned char*)(0x427160A0UL))
#define bFM_MFS11_LIN_SSR_TDRE                *((volatile unsigned char*)(0x427160A4UL))
#define bFM_MFS11_LIN_SSR_RDRF                *((volatile unsigned char*)(0x427160A8UL))
#define bFM_MFS11_LIN_SSR_ORE                 *((volatile unsigned char*)(0x427160ACUL))
#define bFM_MFS11_LIN_SSR_FRE                 *((volatile unsigned char*)(0x427160B0UL))
#define bFM_MFS11_LIN_SSR_LBD                 *((volatile unsigned char*)(0x427160B4UL))
#define bFM_MFS11_LIN_SSR_REC                 *((volatile unsigned char*)(0x427160BCUL))
#define bFM_MFS11_LIN_BGR_EXT                 *((volatile unsigned char*)(0x427161BCUL))
#define bFM_MFS11_LIN_BGR1_EXT                *((volatile unsigned char*)(0x427161BCUL))
#define bFM_MFS11_LIN_FCR_FE1                 *((volatile unsigned char*)(0x42716280UL))
#define bFM_MFS11_LIN_FCR_FE2                 *((volatile unsigned char*)(0x42716284UL))
#define bFM_MFS11_LIN_FCR_FCL1                *((volatile unsigned char*)(0x42716288UL))
#define bFM_MFS11_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271628CUL))
#define bFM_MFS11_LIN_FCR_FSET                *((volatile unsigned char*)(0x42716290UL))
#define bFM_MFS11_LIN_FCR_FLD                 *((volatile unsigned char*)(0x42716294UL))
#define bFM_MFS11_LIN_FCR_FLST                *((volatile unsigned char*)(0x42716298UL))
#define bFM_MFS11_LIN_FCR_FSEL                *((volatile unsigned char*)(0x427162A0UL))
#define bFM_MFS11_LIN_FCR_FTIE                *((volatile unsigned char*)(0x427162A4UL))
#define bFM_MFS11_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x427162A8UL))
#define bFM_MFS11_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x427162ACUL))
#define bFM_MFS11_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x427162B0UL))
#define bFM_MFS11_LIN_FCR0_FE1                *((volatile unsigned char*)(0x42716280UL))
#define bFM_MFS11_LIN_FCR0_FE2                *((volatile unsigned char*)(0x42716284UL))
#define bFM_MFS11_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x42716288UL))
#define bFM_MFS11_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271628CUL))
#define bFM_MFS11_LIN_FCR0_FSET               *((volatile unsigned char*)(0x42716290UL))
#define bFM_MFS11_LIN_FCR0_FLD                *((volatile unsigned char*)(0x42716294UL))
#define bFM_MFS11_LIN_FCR0_FLST               *((volatile unsigned char*)(0x42716298UL))
#define bFM_MFS11_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x427162A0UL))
#define bFM_MFS11_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x427162A4UL))
#define bFM_MFS11_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x427162A8UL))
#define bFM_MFS11_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x427162ACUL))
#define bFM_MFS11_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x427162B0UL))
#define bFM_MFS11_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x42716300UL))
#define bFM_MFS11_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x42716304UL))
#define bFM_MFS11_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x42716308UL))
#define bFM_MFS11_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271630CUL))
#define bFM_MFS11_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x42716310UL))
#define bFM_MFS11_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x42716314UL))
#define bFM_MFS11_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x42716318UL))
#define bFM_MFS11_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271631CUL))
#define bFM_MFS11_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x42716320UL))
#define bFM_MFS11_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x42716324UL))
#define bFM_MFS11_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x42716328UL))
#define bFM_MFS11_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271632CUL))
#define bFM_MFS11_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x42716330UL))
#define bFM_MFS11_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x42716334UL))
#define bFM_MFS11_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x42716338UL))
#define bFM_MFS11_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271633CUL))
#define bFM_MFS11_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x42716300UL))
#define bFM_MFS11_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x42716304UL))
#define bFM_MFS11_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x42716308UL))
#define bFM_MFS11_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271630CUL))
#define bFM_MFS11_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x42716310UL))
#define bFM_MFS11_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x42716314UL))
#define bFM_MFS11_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x42716318UL))
#define bFM_MFS11_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271631CUL))
#define bFM_MFS11_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x42716320UL))
#define bFM_MFS11_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x42716324UL))
#define bFM_MFS11_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x42716328UL))
#define bFM_MFS11_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271632CUL))
#define bFM_MFS11_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x42716330UL))
#define bFM_MFS11_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x42716334UL))
#define bFM_MFS11_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x42716338UL))
#define bFM_MFS11_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271633CUL))

/* MFS I2C channel 11 registers */
#define bFM_MFS11_I2C_SMR_TIE                 *((volatile unsigned char*)(0x42716008UL))
#define bFM_MFS11_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271600CUL))
#define bFM_MFS11_I2C_SMR_MD0                 *((volatile unsigned char*)(0x42716014UL))
#define bFM_MFS11_I2C_SMR_MD1                 *((volatile unsigned char*)(0x42716018UL))
#define bFM_MFS11_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271601CUL))
#define bFM_MFS11_I2C_IBCR_INT                *((volatile unsigned char*)(0x42716020UL))
#define bFM_MFS11_I2C_IBCR_BER                *((volatile unsigned char*)(0x42716024UL))
#define bFM_MFS11_I2C_IBCR_INTE               *((volatile unsigned char*)(0x42716028UL))
#define bFM_MFS11_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271602CUL))
#define bFM_MFS11_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x42716030UL))
#define bFM_MFS11_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x42716034UL))
#define bFM_MFS11_I2C_IBCR_ACT                *((volatile unsigned char*)(0x42716038UL))
#define bFM_MFS11_I2C_IBCR_SCC                *((volatile unsigned char*)(0x42716038UL))
#define bFM_MFS11_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271603CUL))
#define bFM_MFS11_I2C_IBSR_BB                 *((volatile unsigned char*)(0x42716080UL))
#define bFM_MFS11_I2C_IBSR_SPC                *((volatile unsigned char*)(0x42716084UL))
#define bFM_MFS11_I2C_IBSR_RSC                *((volatile unsigned char*)(0x42716088UL))
#define bFM_MFS11_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271608CUL))
#define bFM_MFS11_I2C_IBSR_TRX                *((volatile unsigned char*)(0x42716090UL))
#define bFM_MFS11_I2C_IBSR_RSA                *((volatile unsigned char*)(0x42716094UL))
#define bFM_MFS11_I2C_IBSR_RACK               *((volatile unsigned char*)(0x42716098UL))
#define bFM_MFS11_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271609CUL))
#define bFM_MFS11_I2C_SSR_TBI                 *((volatile unsigned char*)(0x427160A0UL))
#define bFM_MFS11_I2C_SSR_TDRE                *((volatile unsigned char*)(0x427160A4UL))
#define bFM_MFS11_I2C_SSR_RDRF                *((volatile unsigned char*)(0x427160A8UL))
#define bFM_MFS11_I2C_SSR_ORE                 *((volatile unsigned char*)(0x427160ACUL))
#define bFM_MFS11_I2C_SSR_TBIE                *((volatile unsigned char*)(0x427160B0UL))
#define bFM_MFS11_I2C_SSR_DMA                 *((volatile unsigned char*)(0x427160B4UL))
#define bFM_MFS11_I2C_SSR_TSET                *((volatile unsigned char*)(0x427160B8UL))
#define bFM_MFS11_I2C_SSR_REC                 *((volatile unsigned char*)(0x427160BCUL))
#define bFM_MFS11_I2C_ISBA_SA0                *((volatile unsigned char*)(0x42716200UL))
#define bFM_MFS11_I2C_ISBA_SA1                *((volatile unsigned char*)(0x42716204UL))
#define bFM_MFS11_I2C_ISBA_SA2                *((volatile unsigned char*)(0x42716208UL))
#define bFM_MFS11_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271620CUL))
#define bFM_MFS11_I2C_ISBA_SA4                *((volatile unsigned char*)(0x42716210UL))
#define bFM_MFS11_I2C_ISBA_SA5                *((volatile unsigned char*)(0x42716214UL))
#define bFM_MFS11_I2C_ISBA_SA6                *((volatile unsigned char*)(0x42716218UL))
#define bFM_MFS11_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271621CUL))
#define bFM_MFS11_I2C_ISMK_SM0                *((volatile unsigned char*)(0x42716220UL))
#define bFM_MFS11_I2C_ISMK_SM1                *((volatile unsigned char*)(0x42716224UL))
#define bFM_MFS11_I2C_ISMK_SM2                *((volatile unsigned char*)(0x42716228UL))
#define bFM_MFS11_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271622CUL))
#define bFM_MFS11_I2C_ISMK_SM4                *((volatile unsigned char*)(0x42716230UL))
#define bFM_MFS11_I2C_ISMK_SM5                *((volatile unsigned char*)(0x42716234UL))
#define bFM_MFS11_I2C_ISMK_SM6                *((volatile unsigned char*)(0x42716238UL))
#define bFM_MFS11_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271623CUL))
#define bFM_MFS11_I2C_FCR_FE1                 *((volatile unsigned char*)(0x42716280UL))
#define bFM_MFS11_I2C_FCR_FE2                 *((volatile unsigned char*)(0x42716284UL))
#define bFM_MFS11_I2C_FCR_FCL1                *((volatile unsigned char*)(0x42716288UL))
#define bFM_MFS11_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271628CUL))
#define bFM_MFS11_I2C_FCR_FSET                *((volatile unsigned char*)(0x42716290UL))
#define bFM_MFS11_I2C_FCR_FLD                 *((volatile unsigned char*)(0x42716294UL))
#define bFM_MFS11_I2C_FCR_FLST                *((volatile unsigned char*)(0x42716298UL))
#define bFM_MFS11_I2C_FCR_FSEL                *((volatile unsigned char*)(0x427162A0UL))
#define bFM_MFS11_I2C_FCR_FTIE                *((volatile unsigned char*)(0x427162A4UL))
#define bFM_MFS11_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x427162A8UL))
#define bFM_MFS11_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x427162ACUL))
#define bFM_MFS11_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x427162B0UL))
#define bFM_MFS11_I2C_FCR0_FE1                *((volatile unsigned char*)(0x42716280UL))
#define bFM_MFS11_I2C_FCR0_FE2                *((volatile unsigned char*)(0x42716284UL))
#define bFM_MFS11_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x42716288UL))
#define bFM_MFS11_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271628CUL))
#define bFM_MFS11_I2C_FCR0_FSET               *((volatile unsigned char*)(0x42716290UL))
#define bFM_MFS11_I2C_FCR0_FLD                *((volatile unsigned char*)(0x42716294UL))
#define bFM_MFS11_I2C_FCR0_FLST               *((volatile unsigned char*)(0x42716298UL))
#define bFM_MFS11_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x427162A0UL))
#define bFM_MFS11_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x427162A4UL))
#define bFM_MFS11_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x427162A8UL))
#define bFM_MFS11_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x427162ACUL))
#define bFM_MFS11_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x427162B0UL))
#define bFM_MFS11_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x42716300UL))
#define bFM_MFS11_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x42716304UL))
#define bFM_MFS11_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x42716308UL))
#define bFM_MFS11_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271630CUL))
#define bFM_MFS11_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x42716310UL))
#define bFM_MFS11_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x42716314UL))
#define bFM_MFS11_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x42716318UL))
#define bFM_MFS11_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271631CUL))
#define bFM_MFS11_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x42716320UL))
#define bFM_MFS11_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x42716324UL))
#define bFM_MFS11_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x42716328UL))
#define bFM_MFS11_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271632CUL))
#define bFM_MFS11_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x42716330UL))
#define bFM_MFS11_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x42716334UL))
#define bFM_MFS11_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x42716338UL))
#define bFM_MFS11_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271633CUL))
#define bFM_MFS11_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x42716300UL))
#define bFM_MFS11_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x42716304UL))
#define bFM_MFS11_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x42716308UL))
#define bFM_MFS11_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271630CUL))
#define bFM_MFS11_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x42716310UL))
#define bFM_MFS11_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x42716314UL))
#define bFM_MFS11_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x42716318UL))
#define bFM_MFS11_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271631CUL))
#define bFM_MFS11_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x42716320UL))
#define bFM_MFS11_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x42716324UL))
#define bFM_MFS11_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x42716328UL))
#define bFM_MFS11_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271632CUL))
#define bFM_MFS11_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x42716330UL))
#define bFM_MFS11_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x42716334UL))
#define bFM_MFS11_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x42716338UL))
#define bFM_MFS11_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271633CUL))

/* MFS UART channel 12 registers */
#define bFM_MFS12_UART_SMR_SOE                *((volatile unsigned char*)(0x42718000UL))
#define bFM_MFS12_UART_SMR_BDS                *((volatile unsigned char*)(0x42718008UL))
#define bFM_MFS12_UART_SMR_SBL                *((volatile unsigned char*)(0x4271800CUL))
#define bFM_MFS12_UART_SMR_WUCR               *((volatile unsigned char*)(0x42718010UL))
#define bFM_MFS12_UART_SMR_MD0                *((volatile unsigned char*)(0x42718014UL))
#define bFM_MFS12_UART_SMR_MD1                *((volatile unsigned char*)(0x42718018UL))
#define bFM_MFS12_UART_SMR_MD2                *((volatile unsigned char*)(0x4271801CUL))
#define bFM_MFS12_UART_SCR_TXE                *((volatile unsigned char*)(0x42718020UL))
#define bFM_MFS12_UART_SCR_RXE                *((volatile unsigned char*)(0x42718024UL))
#define bFM_MFS12_UART_SCR_TBIE               *((volatile unsigned char*)(0x42718028UL))
#define bFM_MFS12_UART_SCR_TIE                *((volatile unsigned char*)(0x4271802CUL))
#define bFM_MFS12_UART_SCR_RIE                *((volatile unsigned char*)(0x42718030UL))
#define bFM_MFS12_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271803CUL))
#define bFM_MFS12_UART_ESCR_L0                *((volatile unsigned char*)(0x42718080UL))
#define bFM_MFS12_UART_ESCR_L1                *((volatile unsigned char*)(0x42718084UL))
#define bFM_MFS12_UART_ESCR_L2                *((volatile unsigned char*)(0x42718088UL))
#define bFM_MFS12_UART_ESCR_P                 *((volatile unsigned char*)(0x4271808CUL))
#define bFM_MFS12_UART_ESCR_PEN               *((volatile unsigned char*)(0x42718090UL))
#define bFM_MFS12_UART_ESCR_INV               *((volatile unsigned char*)(0x42718094UL))
#define bFM_MFS12_UART_ESCR_ESBL              *((volatile unsigned char*)(0x42718098UL))
#define bFM_MFS12_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271809CUL))
#define bFM_MFS12_UART_SSR_TBI                *((volatile unsigned char*)(0x427180A0UL))
#define bFM_MFS12_UART_SSR_TDRE               *((volatile unsigned char*)(0x427180A4UL))
#define bFM_MFS12_UART_SSR_RDRF               *((volatile unsigned char*)(0x427180A8UL))
#define bFM_MFS12_UART_SSR_ORE                *((volatile unsigned char*)(0x427180ACUL))
#define bFM_MFS12_UART_SSR_FRE                *((volatile unsigned char*)(0x427180B0UL))
#define bFM_MFS12_UART_SSR_PE                 *((volatile unsigned char*)(0x427180B4UL))
#define bFM_MFS12_UART_SSR_REC                *((volatile unsigned char*)(0x427180BCUL))
#define bFM_MFS12_UART_BGR_EXT                *((volatile unsigned char*)(0x427181BCUL))
#define bFM_MFS12_UART_BGR1_EXT               *((volatile unsigned char*)(0x427181BCUL))
#define bFM_MFS12_UART_FCR_FE1                *((volatile unsigned char*)(0x42718280UL))
#define bFM_MFS12_UART_FCR_FE2                *((volatile unsigned char*)(0x42718284UL))
#define bFM_MFS12_UART_FCR_FCL1               *((volatile unsigned char*)(0x42718288UL))
#define bFM_MFS12_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271828CUL))
#define bFM_MFS12_UART_FCR_FSET               *((volatile unsigned char*)(0x42718290UL))
#define bFM_MFS12_UART_FCR_FLD                *((volatile unsigned char*)(0x42718294UL))
#define bFM_MFS12_UART_FCR_FLST               *((volatile unsigned char*)(0x42718298UL))
#define bFM_MFS12_UART_FCR_FSEL               *((volatile unsigned char*)(0x427182A0UL))
#define bFM_MFS12_UART_FCR_FTIE               *((volatile unsigned char*)(0x427182A4UL))
#define bFM_MFS12_UART_FCR_FDRQ               *((volatile unsigned char*)(0x427182A8UL))
#define bFM_MFS12_UART_FCR_FRIIE              *((volatile unsigned char*)(0x427182ACUL))
#define bFM_MFS12_UART_FCR_FLSTE              *((volatile unsigned char*)(0x427182B0UL))
#define bFM_MFS12_UART_FCR0_FE1               *((volatile unsigned char*)(0x42718280UL))
#define bFM_MFS12_UART_FCR0_FE2               *((volatile unsigned char*)(0x42718284UL))
#define bFM_MFS12_UART_FCR0_FCL1              *((volatile unsigned char*)(0x42718288UL))
#define bFM_MFS12_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271828CUL))
#define bFM_MFS12_UART_FCR0_FSET              *((volatile unsigned char*)(0x42718290UL))
#define bFM_MFS12_UART_FCR0_FLD               *((volatile unsigned char*)(0x42718294UL))
#define bFM_MFS12_UART_FCR0_FLST              *((volatile unsigned char*)(0x42718298UL))
#define bFM_MFS12_UART_FCR1_FSEL              *((volatile unsigned char*)(0x427182A0UL))
#define bFM_MFS12_UART_FCR1_FTIE              *((volatile unsigned char*)(0x427182A4UL))
#define bFM_MFS12_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x427182A8UL))
#define bFM_MFS12_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x427182ACUL))
#define bFM_MFS12_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x427182B0UL))
#define bFM_MFS12_UART_FBYTE_FD0              *((volatile unsigned char*)(0x42718300UL))
#define bFM_MFS12_UART_FBYTE_FD1              *((volatile unsigned char*)(0x42718304UL))
#define bFM_MFS12_UART_FBYTE_FD2              *((volatile unsigned char*)(0x42718308UL))
#define bFM_MFS12_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271830CUL))
#define bFM_MFS12_UART_FBYTE_FD4              *((volatile unsigned char*)(0x42718310UL))
#define bFM_MFS12_UART_FBYTE_FD5              *((volatile unsigned char*)(0x42718314UL))
#define bFM_MFS12_UART_FBYTE_FD6              *((volatile unsigned char*)(0x42718318UL))
#define bFM_MFS12_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271831CUL))
#define bFM_MFS12_UART_FBYTE_FD8              *((volatile unsigned char*)(0x42718320UL))
#define bFM_MFS12_UART_FBYTE_FD9              *((volatile unsigned char*)(0x42718324UL))
#define bFM_MFS12_UART_FBYTE_FD10             *((volatile unsigned char*)(0x42718328UL))
#define bFM_MFS12_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271832CUL))
#define bFM_MFS12_UART_FBYTE_FD12             *((volatile unsigned char*)(0x42718330UL))
#define bFM_MFS12_UART_FBYTE_FD13             *((volatile unsigned char*)(0x42718334UL))
#define bFM_MFS12_UART_FBYTE_FD14             *((volatile unsigned char*)(0x42718338UL))
#define bFM_MFS12_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271833CUL))
#define bFM_MFS12_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x42718300UL))
#define bFM_MFS12_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x42718304UL))
#define bFM_MFS12_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x42718308UL))
#define bFM_MFS12_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271830CUL))
#define bFM_MFS12_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x42718310UL))
#define bFM_MFS12_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x42718314UL))
#define bFM_MFS12_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x42718318UL))
#define bFM_MFS12_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271831CUL))
#define bFM_MFS12_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x42718320UL))
#define bFM_MFS12_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x42718324UL))
#define bFM_MFS12_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x42718328UL))
#define bFM_MFS12_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271832CUL))
#define bFM_MFS12_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x42718330UL))
#define bFM_MFS12_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x42718334UL))
#define bFM_MFS12_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x42718338UL))
#define bFM_MFS12_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271833CUL))

/* MFS CSIO channel 12 registers */
#define bFM_MFS12_CSIO_SMR_SOE                *((volatile unsigned char*)(0x42718000UL))
#define bFM_MFS12_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x42718004UL))
#define bFM_MFS12_CSIO_SMR_BDS                *((volatile unsigned char*)(0x42718008UL))
#define bFM_MFS12_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271800CUL))
#define bFM_MFS12_CSIO_SMR_MD0                *((volatile unsigned char*)(0x42718014UL))
#define bFM_MFS12_CSIO_SMR_MD1                *((volatile unsigned char*)(0x42718018UL))
#define bFM_MFS12_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271801CUL))
#define bFM_MFS12_CSIO_SCR_TXE                *((volatile unsigned char*)(0x42718020UL))
#define bFM_MFS12_CSIO_SCR_RXE                *((volatile unsigned char*)(0x42718024UL))
#define bFM_MFS12_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x42718028UL))
#define bFM_MFS12_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271802CUL))
#define bFM_MFS12_CSIO_SCR_RIE                *((volatile unsigned char*)(0x42718030UL))
#define bFM_MFS12_CSIO_SCR_SPI                *((volatile unsigned char*)(0x42718034UL))
#define bFM_MFS12_CSIO_SCR_MS                 *((volatile unsigned char*)(0x42718038UL))
#define bFM_MFS12_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271803CUL))
#define bFM_MFS12_CSIO_ESCR_L0                *((volatile unsigned char*)(0x42718080UL))
#define bFM_MFS12_CSIO_ESCR_L1                *((volatile unsigned char*)(0x42718084UL))
#define bFM_MFS12_CSIO_ESCR_L2                *((volatile unsigned char*)(0x42718088UL))
#define bFM_MFS12_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271808CUL))
#define bFM_MFS12_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x42718090UL))
#define bFM_MFS12_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x42718094UL))
#define bFM_MFS12_CSIO_ESCR_L3                *((volatile unsigned char*)(0x42718098UL))
#define bFM_MFS12_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271809CUL))
#define bFM_MFS12_CSIO_SSR_TBI                *((volatile unsigned char*)(0x427180A0UL))
#define bFM_MFS12_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x427180A4UL))
#define bFM_MFS12_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x427180A8UL))
#define bFM_MFS12_CSIO_SSR_ORE                *((volatile unsigned char*)(0x427180ACUL))
#define bFM_MFS12_CSIO_SSR_AWC                *((volatile unsigned char*)(0x427180B0UL))
#define bFM_MFS12_CSIO_SSR_REC                *((volatile unsigned char*)(0x427180BCUL))
#define bFM_MFS12_CSIO_FCR_FE1                *((volatile unsigned char*)(0x42718280UL))
#define bFM_MFS12_CSIO_FCR_FE2                *((volatile unsigned char*)(0x42718284UL))
#define bFM_MFS12_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x42718288UL))
#define bFM_MFS12_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271828CUL))
#define bFM_MFS12_CSIO_FCR_FSET               *((volatile unsigned char*)(0x42718290UL))
#define bFM_MFS12_CSIO_FCR_FLD                *((volatile unsigned char*)(0x42718294UL))
#define bFM_MFS12_CSIO_FCR_FLST               *((volatile unsigned char*)(0x42718298UL))
#define bFM_MFS12_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x427182A0UL))
#define bFM_MFS12_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x427182A4UL))
#define bFM_MFS12_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x427182A8UL))
#define bFM_MFS12_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x427182ACUL))
#define bFM_MFS12_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x427182B0UL))
#define bFM_MFS12_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x42718280UL))
#define bFM_MFS12_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x42718284UL))
#define bFM_MFS12_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x42718288UL))
#define bFM_MFS12_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271828CUL))
#define bFM_MFS12_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x42718290UL))
#define bFM_MFS12_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x42718294UL))
#define bFM_MFS12_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x42718298UL))
#define bFM_MFS12_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x427182A0UL))
#define bFM_MFS12_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x427182A4UL))
#define bFM_MFS12_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x427182A8UL))
#define bFM_MFS12_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x427182ACUL))
#define bFM_MFS12_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x427182B0UL))
#define bFM_MFS12_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x42718300UL))
#define bFM_MFS12_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x42718304UL))
#define bFM_MFS12_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x42718308UL))
#define bFM_MFS12_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271830CUL))
#define bFM_MFS12_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x42718310UL))
#define bFM_MFS12_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x42718314UL))
#define bFM_MFS12_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x42718318UL))
#define bFM_MFS12_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271831CUL))
#define bFM_MFS12_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x42718320UL))
#define bFM_MFS12_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x42718324UL))
#define bFM_MFS12_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x42718328UL))
#define bFM_MFS12_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271832CUL))
#define bFM_MFS12_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x42718330UL))
#define bFM_MFS12_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x42718334UL))
#define bFM_MFS12_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x42718338UL))
#define bFM_MFS12_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271833CUL))
#define bFM_MFS12_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x42718300UL))
#define bFM_MFS12_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x42718304UL))
#define bFM_MFS12_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x42718308UL))
#define bFM_MFS12_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271830CUL))
#define bFM_MFS12_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x42718310UL))
#define bFM_MFS12_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x42718314UL))
#define bFM_MFS12_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x42718318UL))
#define bFM_MFS12_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271831CUL))
#define bFM_MFS12_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x42718320UL))
#define bFM_MFS12_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x42718324UL))
#define bFM_MFS12_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x42718328UL))
#define bFM_MFS12_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271832CUL))
#define bFM_MFS12_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x42718330UL))
#define bFM_MFS12_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x42718334UL))
#define bFM_MFS12_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x42718338UL))
#define bFM_MFS12_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271833CUL))
#define bFM_MFS12_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x42718380UL))
#define bFM_MFS12_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x42718384UL))
#define bFM_MFS12_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x42718388UL))
#define bFM_MFS12_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271838CUL))
#define bFM_MFS12_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x42718390UL))
#define bFM_MFS12_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x42718394UL))
#define bFM_MFS12_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x42718398UL))
#define bFM_MFS12_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271839CUL))
#define bFM_MFS12_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x427183A0UL))
#define bFM_MFS12_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x427183A4UL))
#define bFM_MFS12_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x427183A8UL))
#define bFM_MFS12_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x427183ACUL))
#define bFM_MFS12_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x427183B0UL))
#define bFM_MFS12_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x427183B4UL))
#define bFM_MFS12_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x427183B8UL))
#define bFM_MFS12_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x427183BCUL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x42718400UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x42718404UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x42718408UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271840CUL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x42718410UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x42718414UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x42718418UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271841CUL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x42718420UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x42718424UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x42718428UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271842CUL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x42718430UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x42718434UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x42718438UL))
#define bFM_MFS12_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271843CUL))
#define bFM_MFS12_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x42718480UL))
#define bFM_MFS12_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x42718484UL))
#define bFM_MFS12_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x42718488UL))
#define bFM_MFS12_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271848CUL))
#define bFM_MFS12_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x42718490UL))
#define bFM_MFS12_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x42718498UL))
#define bFM_MFS12_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271849CUL))
#define bFM_MFS12_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x427184A0UL))
#define bFM_MFS12_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x427184ACUL))
#define bFM_MFS12_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x427184B0UL))
#define bFM_MFS12_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x427184B4UL))
#define bFM_MFS12_CSIO_STMR_TM0               *((volatile unsigned char*)(0x42718500UL))
#define bFM_MFS12_CSIO_STMR_TM1               *((volatile unsigned char*)(0x42718504UL))
#define bFM_MFS12_CSIO_STMR_TM2               *((volatile unsigned char*)(0x42718508UL))
#define bFM_MFS12_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271850CUL))
#define bFM_MFS12_CSIO_STMR_TM4               *((volatile unsigned char*)(0x42718510UL))
#define bFM_MFS12_CSIO_STMR_TM5               *((volatile unsigned char*)(0x42718514UL))
#define bFM_MFS12_CSIO_STMR_TM6               *((volatile unsigned char*)(0x42718518UL))
#define bFM_MFS12_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271851CUL))
#define bFM_MFS12_CSIO_STMR_TM8               *((volatile unsigned char*)(0x42718520UL))
#define bFM_MFS12_CSIO_STMR_TM9               *((volatile unsigned char*)(0x42718524UL))
#define bFM_MFS12_CSIO_STMR_TM10              *((volatile unsigned char*)(0x42718528UL))
#define bFM_MFS12_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271852CUL))
#define bFM_MFS12_CSIO_STMR_TM12              *((volatile unsigned char*)(0x42718530UL))
#define bFM_MFS12_CSIO_STMR_TM13              *((volatile unsigned char*)(0x42718534UL))
#define bFM_MFS12_CSIO_STMR_TM14              *((volatile unsigned char*)(0x42718538UL))
#define bFM_MFS12_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271853CUL))
#define bFM_MFS12_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x42718580UL))
#define bFM_MFS12_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x42718584UL))
#define bFM_MFS12_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x42718588UL))
#define bFM_MFS12_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271858CUL))
#define bFM_MFS12_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x42718590UL))
#define bFM_MFS12_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x42718594UL))
#define bFM_MFS12_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x42718598UL))
#define bFM_MFS12_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271859CUL))
#define bFM_MFS12_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x427185A0UL))
#define bFM_MFS12_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x427185A4UL))
#define bFM_MFS12_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x427185A8UL))
#define bFM_MFS12_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x427185ACUL))
#define bFM_MFS12_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x427185B0UL))
#define bFM_MFS12_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x427185B4UL))
#define bFM_MFS12_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x427185B8UL))
#define bFM_MFS12_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x427185BCUL))
#define bFM_MFS12_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x42718600UL))
#define bFM_MFS12_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x42718604UL))
#define bFM_MFS12_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x42718608UL))
#define bFM_MFS12_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271860CUL))
#define bFM_MFS12_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x42718610UL))
#define bFM_MFS12_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x42718614UL))
#define bFM_MFS12_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x42718618UL))
#define bFM_MFS12_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271861CUL))
#define bFM_MFS12_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x42718620UL))
#define bFM_MFS12_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x42718624UL))
#define bFM_MFS12_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x42718628UL))
#define bFM_MFS12_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271862CUL))
#define bFM_MFS12_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x42718630UL))
#define bFM_MFS12_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x42718634UL))
#define bFM_MFS12_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x42718638UL))
#define bFM_MFS12_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271863CUL))
#define bFM_MFS12_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x42718680UL))
#define bFM_MFS12_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x42718684UL))
#define bFM_MFS12_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x42718688UL))
#define bFM_MFS12_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271868CUL))
#define bFM_MFS12_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x42718690UL))
#define bFM_MFS12_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x42718694UL))
#define bFM_MFS12_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x42718698UL))
#define bFM_MFS12_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271869CUL))
#define bFM_MFS12_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x427186A0UL))
#define bFM_MFS12_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x427186A4UL))
#define bFM_MFS12_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x427186A8UL))
#define bFM_MFS12_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x427186ACUL))
#define bFM_MFS12_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x427186B0UL))
#define bFM_MFS12_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x427186B4UL))
#define bFM_MFS12_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x427186B8UL))
#define bFM_MFS12_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x427186BCUL))
#define bFM_MFS12_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x42718700UL))
#define bFM_MFS12_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x42718704UL))
#define bFM_MFS12_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x42718708UL))
#define bFM_MFS12_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271870CUL))
#define bFM_MFS12_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x42718710UL))
#define bFM_MFS12_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x42718714UL))
#define bFM_MFS12_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x42718718UL))
#define bFM_MFS12_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271871CUL))

/* MFS LIN channel 12 registers */
#define bFM_MFS12_LIN_SMR_SOE                 *((volatile unsigned char*)(0x42718000UL))
#define bFM_MFS12_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271800CUL))
#define bFM_MFS12_LIN_SMR_WUCR                *((volatile unsigned char*)(0x42718010UL))
#define bFM_MFS12_LIN_SMR_MD0                 *((volatile unsigned char*)(0x42718014UL))
#define bFM_MFS12_LIN_SMR_MD1                 *((volatile unsigned char*)(0x42718018UL))
#define bFM_MFS12_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271801CUL))
#define bFM_MFS12_LIN_SCR_TXE                 *((volatile unsigned char*)(0x42718020UL))
#define bFM_MFS12_LIN_SCR_RXE                 *((volatile unsigned char*)(0x42718024UL))
#define bFM_MFS12_LIN_SCR_TBIE                *((volatile unsigned char*)(0x42718028UL))
#define bFM_MFS12_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271802CUL))
#define bFM_MFS12_LIN_SCR_RIE                 *((volatile unsigned char*)(0x42718030UL))
#define bFM_MFS12_LIN_SCR_LBR                 *((volatile unsigned char*)(0x42718034UL))
#define bFM_MFS12_LIN_SCR_MS                  *((volatile unsigned char*)(0x42718038UL))
#define bFM_MFS12_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271803CUL))
#define bFM_MFS12_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x42718080UL))
#define bFM_MFS12_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x42718084UL))
#define bFM_MFS12_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x42718088UL))
#define bFM_MFS12_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271808CUL))
#define bFM_MFS12_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x42718090UL))
#define bFM_MFS12_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x42718098UL))
#define bFM_MFS12_LIN_SSR_TBI                 *((volatile unsigned char*)(0x427180A0UL))
#define bFM_MFS12_LIN_SSR_TDRE                *((volatile unsigned char*)(0x427180A4UL))
#define bFM_MFS12_LIN_SSR_RDRF                *((volatile unsigned char*)(0x427180A8UL))
#define bFM_MFS12_LIN_SSR_ORE                 *((volatile unsigned char*)(0x427180ACUL))
#define bFM_MFS12_LIN_SSR_FRE                 *((volatile unsigned char*)(0x427180B0UL))
#define bFM_MFS12_LIN_SSR_LBD                 *((volatile unsigned char*)(0x427180B4UL))
#define bFM_MFS12_LIN_SSR_REC                 *((volatile unsigned char*)(0x427180BCUL))
#define bFM_MFS12_LIN_BGR_EXT                 *((volatile unsigned char*)(0x427181BCUL))
#define bFM_MFS12_LIN_BGR1_EXT                *((volatile unsigned char*)(0x427181BCUL))
#define bFM_MFS12_LIN_FCR_FE1                 *((volatile unsigned char*)(0x42718280UL))
#define bFM_MFS12_LIN_FCR_FE2                 *((volatile unsigned char*)(0x42718284UL))
#define bFM_MFS12_LIN_FCR_FCL1                *((volatile unsigned char*)(0x42718288UL))
#define bFM_MFS12_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271828CUL))
#define bFM_MFS12_LIN_FCR_FSET                *((volatile unsigned char*)(0x42718290UL))
#define bFM_MFS12_LIN_FCR_FLD                 *((volatile unsigned char*)(0x42718294UL))
#define bFM_MFS12_LIN_FCR_FLST                *((volatile unsigned char*)(0x42718298UL))
#define bFM_MFS12_LIN_FCR_FSEL                *((volatile unsigned char*)(0x427182A0UL))
#define bFM_MFS12_LIN_FCR_FTIE                *((volatile unsigned char*)(0x427182A4UL))
#define bFM_MFS12_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x427182A8UL))
#define bFM_MFS12_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x427182ACUL))
#define bFM_MFS12_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x427182B0UL))
#define bFM_MFS12_LIN_FCR0_FE1                *((volatile unsigned char*)(0x42718280UL))
#define bFM_MFS12_LIN_FCR0_FE2                *((volatile unsigned char*)(0x42718284UL))
#define bFM_MFS12_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x42718288UL))
#define bFM_MFS12_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271828CUL))
#define bFM_MFS12_LIN_FCR0_FSET               *((volatile unsigned char*)(0x42718290UL))
#define bFM_MFS12_LIN_FCR0_FLD                *((volatile unsigned char*)(0x42718294UL))
#define bFM_MFS12_LIN_FCR0_FLST               *((volatile unsigned char*)(0x42718298UL))
#define bFM_MFS12_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x427182A0UL))
#define bFM_MFS12_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x427182A4UL))
#define bFM_MFS12_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x427182A8UL))
#define bFM_MFS12_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x427182ACUL))
#define bFM_MFS12_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x427182B0UL))
#define bFM_MFS12_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x42718300UL))
#define bFM_MFS12_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x42718304UL))
#define bFM_MFS12_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x42718308UL))
#define bFM_MFS12_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271830CUL))
#define bFM_MFS12_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x42718310UL))
#define bFM_MFS12_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x42718314UL))
#define bFM_MFS12_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x42718318UL))
#define bFM_MFS12_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271831CUL))
#define bFM_MFS12_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x42718320UL))
#define bFM_MFS12_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x42718324UL))
#define bFM_MFS12_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x42718328UL))
#define bFM_MFS12_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271832CUL))
#define bFM_MFS12_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x42718330UL))
#define bFM_MFS12_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x42718334UL))
#define bFM_MFS12_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x42718338UL))
#define bFM_MFS12_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271833CUL))
#define bFM_MFS12_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x42718300UL))
#define bFM_MFS12_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x42718304UL))
#define bFM_MFS12_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x42718308UL))
#define bFM_MFS12_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271830CUL))
#define bFM_MFS12_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x42718310UL))
#define bFM_MFS12_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x42718314UL))
#define bFM_MFS12_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x42718318UL))
#define bFM_MFS12_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271831CUL))
#define bFM_MFS12_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x42718320UL))
#define bFM_MFS12_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x42718324UL))
#define bFM_MFS12_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x42718328UL))
#define bFM_MFS12_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271832CUL))
#define bFM_MFS12_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x42718330UL))
#define bFM_MFS12_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x42718334UL))
#define bFM_MFS12_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x42718338UL))
#define bFM_MFS12_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271833CUL))

/* MFS I2C channel 12 registers */
#define bFM_MFS12_I2C_SMR_TIE                 *((volatile unsigned char*)(0x42718008UL))
#define bFM_MFS12_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271800CUL))
#define bFM_MFS12_I2C_SMR_MD0                 *((volatile unsigned char*)(0x42718014UL))
#define bFM_MFS12_I2C_SMR_MD1                 *((volatile unsigned char*)(0x42718018UL))
#define bFM_MFS12_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271801CUL))
#define bFM_MFS12_I2C_IBCR_INT                *((volatile unsigned char*)(0x42718020UL))
#define bFM_MFS12_I2C_IBCR_BER                *((volatile unsigned char*)(0x42718024UL))
#define bFM_MFS12_I2C_IBCR_INTE               *((volatile unsigned char*)(0x42718028UL))
#define bFM_MFS12_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271802CUL))
#define bFM_MFS12_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x42718030UL))
#define bFM_MFS12_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x42718034UL))
#define bFM_MFS12_I2C_IBCR_ACT                *((volatile unsigned char*)(0x42718038UL))
#define bFM_MFS12_I2C_IBCR_SCC                *((volatile unsigned char*)(0x42718038UL))
#define bFM_MFS12_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271803CUL))
#define bFM_MFS12_I2C_IBSR_BB                 *((volatile unsigned char*)(0x42718080UL))
#define bFM_MFS12_I2C_IBSR_SPC                *((volatile unsigned char*)(0x42718084UL))
#define bFM_MFS12_I2C_IBSR_RSC                *((volatile unsigned char*)(0x42718088UL))
#define bFM_MFS12_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271808CUL))
#define bFM_MFS12_I2C_IBSR_TRX                *((volatile unsigned char*)(0x42718090UL))
#define bFM_MFS12_I2C_IBSR_RSA                *((volatile unsigned char*)(0x42718094UL))
#define bFM_MFS12_I2C_IBSR_RACK               *((volatile unsigned char*)(0x42718098UL))
#define bFM_MFS12_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271809CUL))
#define bFM_MFS12_I2C_SSR_TBI                 *((volatile unsigned char*)(0x427180A0UL))
#define bFM_MFS12_I2C_SSR_TDRE                *((volatile unsigned char*)(0x427180A4UL))
#define bFM_MFS12_I2C_SSR_RDRF                *((volatile unsigned char*)(0x427180A8UL))
#define bFM_MFS12_I2C_SSR_ORE                 *((volatile unsigned char*)(0x427180ACUL))
#define bFM_MFS12_I2C_SSR_TBIE                *((volatile unsigned char*)(0x427180B0UL))
#define bFM_MFS12_I2C_SSR_DMA                 *((volatile unsigned char*)(0x427180B4UL))
#define bFM_MFS12_I2C_SSR_TSET                *((volatile unsigned char*)(0x427180B8UL))
#define bFM_MFS12_I2C_SSR_REC                 *((volatile unsigned char*)(0x427180BCUL))
#define bFM_MFS12_I2C_ISBA_SA0                *((volatile unsigned char*)(0x42718200UL))
#define bFM_MFS12_I2C_ISBA_SA1                *((volatile unsigned char*)(0x42718204UL))
#define bFM_MFS12_I2C_ISBA_SA2                *((volatile unsigned char*)(0x42718208UL))
#define bFM_MFS12_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271820CUL))
#define bFM_MFS12_I2C_ISBA_SA4                *((volatile unsigned char*)(0x42718210UL))
#define bFM_MFS12_I2C_ISBA_SA5                *((volatile unsigned char*)(0x42718214UL))
#define bFM_MFS12_I2C_ISBA_SA6                *((volatile unsigned char*)(0x42718218UL))
#define bFM_MFS12_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271821CUL))
#define bFM_MFS12_I2C_ISMK_SM0                *((volatile unsigned char*)(0x42718220UL))
#define bFM_MFS12_I2C_ISMK_SM1                *((volatile unsigned char*)(0x42718224UL))
#define bFM_MFS12_I2C_ISMK_SM2                *((volatile unsigned char*)(0x42718228UL))
#define bFM_MFS12_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271822CUL))
#define bFM_MFS12_I2C_ISMK_SM4                *((volatile unsigned char*)(0x42718230UL))
#define bFM_MFS12_I2C_ISMK_SM5                *((volatile unsigned char*)(0x42718234UL))
#define bFM_MFS12_I2C_ISMK_SM6                *((volatile unsigned char*)(0x42718238UL))
#define bFM_MFS12_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271823CUL))
#define bFM_MFS12_I2C_FCR_FE1                 *((volatile unsigned char*)(0x42718280UL))
#define bFM_MFS12_I2C_FCR_FE2                 *((volatile unsigned char*)(0x42718284UL))
#define bFM_MFS12_I2C_FCR_FCL1                *((volatile unsigned char*)(0x42718288UL))
#define bFM_MFS12_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271828CUL))
#define bFM_MFS12_I2C_FCR_FSET                *((volatile unsigned char*)(0x42718290UL))
#define bFM_MFS12_I2C_FCR_FLD                 *((volatile unsigned char*)(0x42718294UL))
#define bFM_MFS12_I2C_FCR_FLST                *((volatile unsigned char*)(0x42718298UL))
#define bFM_MFS12_I2C_FCR_FSEL                *((volatile unsigned char*)(0x427182A0UL))
#define bFM_MFS12_I2C_FCR_FTIE                *((volatile unsigned char*)(0x427182A4UL))
#define bFM_MFS12_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x427182A8UL))
#define bFM_MFS12_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x427182ACUL))
#define bFM_MFS12_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x427182B0UL))
#define bFM_MFS12_I2C_FCR0_FE1                *((volatile unsigned char*)(0x42718280UL))
#define bFM_MFS12_I2C_FCR0_FE2                *((volatile unsigned char*)(0x42718284UL))
#define bFM_MFS12_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x42718288UL))
#define bFM_MFS12_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271828CUL))
#define bFM_MFS12_I2C_FCR0_FSET               *((volatile unsigned char*)(0x42718290UL))
#define bFM_MFS12_I2C_FCR0_FLD                *((volatile unsigned char*)(0x42718294UL))
#define bFM_MFS12_I2C_FCR0_FLST               *((volatile unsigned char*)(0x42718298UL))
#define bFM_MFS12_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x427182A0UL))
#define bFM_MFS12_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x427182A4UL))
#define bFM_MFS12_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x427182A8UL))
#define bFM_MFS12_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x427182ACUL))
#define bFM_MFS12_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x427182B0UL))
#define bFM_MFS12_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x42718300UL))
#define bFM_MFS12_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x42718304UL))
#define bFM_MFS12_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x42718308UL))
#define bFM_MFS12_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271830CUL))
#define bFM_MFS12_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x42718310UL))
#define bFM_MFS12_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x42718314UL))
#define bFM_MFS12_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x42718318UL))
#define bFM_MFS12_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271831CUL))
#define bFM_MFS12_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x42718320UL))
#define bFM_MFS12_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x42718324UL))
#define bFM_MFS12_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x42718328UL))
#define bFM_MFS12_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271832CUL))
#define bFM_MFS12_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x42718330UL))
#define bFM_MFS12_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x42718334UL))
#define bFM_MFS12_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x42718338UL))
#define bFM_MFS12_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271833CUL))
#define bFM_MFS12_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x42718300UL))
#define bFM_MFS12_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x42718304UL))
#define bFM_MFS12_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x42718308UL))
#define bFM_MFS12_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271830CUL))
#define bFM_MFS12_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x42718310UL))
#define bFM_MFS12_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x42718314UL))
#define bFM_MFS12_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x42718318UL))
#define bFM_MFS12_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271831CUL))
#define bFM_MFS12_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x42718320UL))
#define bFM_MFS12_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x42718324UL))
#define bFM_MFS12_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x42718328UL))
#define bFM_MFS12_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271832CUL))
#define bFM_MFS12_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x42718330UL))
#define bFM_MFS12_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x42718334UL))
#define bFM_MFS12_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x42718338UL))
#define bFM_MFS12_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271833CUL))

/* MFS UART channel 13 registers */
#define bFM_MFS13_UART_SMR_SOE                *((volatile unsigned char*)(0x4271A000UL))
#define bFM_MFS13_UART_SMR_BDS                *((volatile unsigned char*)(0x4271A008UL))
#define bFM_MFS13_UART_SMR_SBL                *((volatile unsigned char*)(0x4271A00CUL))
#define bFM_MFS13_UART_SMR_WUCR               *((volatile unsigned char*)(0x4271A010UL))
#define bFM_MFS13_UART_SMR_MD0                *((volatile unsigned char*)(0x4271A014UL))
#define bFM_MFS13_UART_SMR_MD1                *((volatile unsigned char*)(0x4271A018UL))
#define bFM_MFS13_UART_SMR_MD2                *((volatile unsigned char*)(0x4271A01CUL))
#define bFM_MFS13_UART_SCR_TXE                *((volatile unsigned char*)(0x4271A020UL))
#define bFM_MFS13_UART_SCR_RXE                *((volatile unsigned char*)(0x4271A024UL))
#define bFM_MFS13_UART_SCR_TBIE               *((volatile unsigned char*)(0x4271A028UL))
#define bFM_MFS13_UART_SCR_TIE                *((volatile unsigned char*)(0x4271A02CUL))
#define bFM_MFS13_UART_SCR_RIE                *((volatile unsigned char*)(0x4271A030UL))
#define bFM_MFS13_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271A03CUL))
#define bFM_MFS13_UART_ESCR_L0                *((volatile unsigned char*)(0x4271A080UL))
#define bFM_MFS13_UART_ESCR_L1                *((volatile unsigned char*)(0x4271A084UL))
#define bFM_MFS13_UART_ESCR_L2                *((volatile unsigned char*)(0x4271A088UL))
#define bFM_MFS13_UART_ESCR_P                 *((volatile unsigned char*)(0x4271A08CUL))
#define bFM_MFS13_UART_ESCR_PEN               *((volatile unsigned char*)(0x4271A090UL))
#define bFM_MFS13_UART_ESCR_INV               *((volatile unsigned char*)(0x4271A094UL))
#define bFM_MFS13_UART_ESCR_ESBL              *((volatile unsigned char*)(0x4271A098UL))
#define bFM_MFS13_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271A09CUL))
#define bFM_MFS13_UART_SSR_TBI                *((volatile unsigned char*)(0x4271A0A0UL))
#define bFM_MFS13_UART_SSR_TDRE               *((volatile unsigned char*)(0x4271A0A4UL))
#define bFM_MFS13_UART_SSR_RDRF               *((volatile unsigned char*)(0x4271A0A8UL))
#define bFM_MFS13_UART_SSR_ORE                *((volatile unsigned char*)(0x4271A0ACUL))
#define bFM_MFS13_UART_SSR_FRE                *((volatile unsigned char*)(0x4271A0B0UL))
#define bFM_MFS13_UART_SSR_PE                 *((volatile unsigned char*)(0x4271A0B4UL))
#define bFM_MFS13_UART_SSR_REC                *((volatile unsigned char*)(0x4271A0BCUL))
#define bFM_MFS13_UART_BGR_EXT                *((volatile unsigned char*)(0x4271A1BCUL))
#define bFM_MFS13_UART_BGR1_EXT               *((volatile unsigned char*)(0x4271A1BCUL))
#define bFM_MFS13_UART_FCR_FE1                *((volatile unsigned char*)(0x4271A280UL))
#define bFM_MFS13_UART_FCR_FE2                *((volatile unsigned char*)(0x4271A284UL))
#define bFM_MFS13_UART_FCR_FCL1               *((volatile unsigned char*)(0x4271A288UL))
#define bFM_MFS13_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271A28CUL))
#define bFM_MFS13_UART_FCR_FSET               *((volatile unsigned char*)(0x4271A290UL))
#define bFM_MFS13_UART_FCR_FLD                *((volatile unsigned char*)(0x4271A294UL))
#define bFM_MFS13_UART_FCR_FLST               *((volatile unsigned char*)(0x4271A298UL))
#define bFM_MFS13_UART_FCR_FSEL               *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM_MFS13_UART_FCR_FTIE               *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM_MFS13_UART_FCR_FDRQ               *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM_MFS13_UART_FCR_FRIIE              *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM_MFS13_UART_FCR_FLSTE              *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM_MFS13_UART_FCR0_FE1               *((volatile unsigned char*)(0x4271A280UL))
#define bFM_MFS13_UART_FCR0_FE2               *((volatile unsigned char*)(0x4271A284UL))
#define bFM_MFS13_UART_FCR0_FCL1              *((volatile unsigned char*)(0x4271A288UL))
#define bFM_MFS13_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271A28CUL))
#define bFM_MFS13_UART_FCR0_FSET              *((volatile unsigned char*)(0x4271A290UL))
#define bFM_MFS13_UART_FCR0_FLD               *((volatile unsigned char*)(0x4271A294UL))
#define bFM_MFS13_UART_FCR0_FLST              *((volatile unsigned char*)(0x4271A298UL))
#define bFM_MFS13_UART_FCR1_FSEL              *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM_MFS13_UART_FCR1_FTIE              *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM_MFS13_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM_MFS13_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM_MFS13_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM_MFS13_UART_FBYTE_FD0              *((volatile unsigned char*)(0x4271A300UL))
#define bFM_MFS13_UART_FBYTE_FD1              *((volatile unsigned char*)(0x4271A304UL))
#define bFM_MFS13_UART_FBYTE_FD2              *((volatile unsigned char*)(0x4271A308UL))
#define bFM_MFS13_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271A30CUL))
#define bFM_MFS13_UART_FBYTE_FD4              *((volatile unsigned char*)(0x4271A310UL))
#define bFM_MFS13_UART_FBYTE_FD5              *((volatile unsigned char*)(0x4271A314UL))
#define bFM_MFS13_UART_FBYTE_FD6              *((volatile unsigned char*)(0x4271A318UL))
#define bFM_MFS13_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271A31CUL))
#define bFM_MFS13_UART_FBYTE_FD8              *((volatile unsigned char*)(0x4271A320UL))
#define bFM_MFS13_UART_FBYTE_FD9              *((volatile unsigned char*)(0x4271A324UL))
#define bFM_MFS13_UART_FBYTE_FD10             *((volatile unsigned char*)(0x4271A328UL))
#define bFM_MFS13_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271A32CUL))
#define bFM_MFS13_UART_FBYTE_FD12             *((volatile unsigned char*)(0x4271A330UL))
#define bFM_MFS13_UART_FBYTE_FD13             *((volatile unsigned char*)(0x4271A334UL))
#define bFM_MFS13_UART_FBYTE_FD14             *((volatile unsigned char*)(0x4271A338UL))
#define bFM_MFS13_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271A33CUL))
#define bFM_MFS13_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x4271A300UL))
#define bFM_MFS13_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x4271A304UL))
#define bFM_MFS13_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x4271A308UL))
#define bFM_MFS13_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271A30CUL))
#define bFM_MFS13_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x4271A310UL))
#define bFM_MFS13_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x4271A314UL))
#define bFM_MFS13_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x4271A318UL))
#define bFM_MFS13_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271A31CUL))
#define bFM_MFS13_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x4271A320UL))
#define bFM_MFS13_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x4271A324UL))
#define bFM_MFS13_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x4271A328UL))
#define bFM_MFS13_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271A32CUL))
#define bFM_MFS13_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x4271A330UL))
#define bFM_MFS13_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x4271A334UL))
#define bFM_MFS13_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x4271A338UL))
#define bFM_MFS13_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271A33CUL))

/* MFS CSIO channel 13 registers */
#define bFM_MFS13_CSIO_SMR_SOE                *((volatile unsigned char*)(0x4271A000UL))
#define bFM_MFS13_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x4271A004UL))
#define bFM_MFS13_CSIO_SMR_BDS                *((volatile unsigned char*)(0x4271A008UL))
#define bFM_MFS13_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271A00CUL))
#define bFM_MFS13_CSIO_SMR_MD0                *((volatile unsigned char*)(0x4271A014UL))
#define bFM_MFS13_CSIO_SMR_MD1                *((volatile unsigned char*)(0x4271A018UL))
#define bFM_MFS13_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271A01CUL))
#define bFM_MFS13_CSIO_SCR_TXE                *((volatile unsigned char*)(0x4271A020UL))
#define bFM_MFS13_CSIO_SCR_RXE                *((volatile unsigned char*)(0x4271A024UL))
#define bFM_MFS13_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x4271A028UL))
#define bFM_MFS13_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271A02CUL))
#define bFM_MFS13_CSIO_SCR_RIE                *((volatile unsigned char*)(0x4271A030UL))
#define bFM_MFS13_CSIO_SCR_SPI                *((volatile unsigned char*)(0x4271A034UL))
#define bFM_MFS13_CSIO_SCR_MS                 *((volatile unsigned char*)(0x4271A038UL))
#define bFM_MFS13_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271A03CUL))
#define bFM_MFS13_CSIO_ESCR_L0                *((volatile unsigned char*)(0x4271A080UL))
#define bFM_MFS13_CSIO_ESCR_L1                *((volatile unsigned char*)(0x4271A084UL))
#define bFM_MFS13_CSIO_ESCR_L2                *((volatile unsigned char*)(0x4271A088UL))
#define bFM_MFS13_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271A08CUL))
#define bFM_MFS13_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x4271A090UL))
#define bFM_MFS13_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x4271A094UL))
#define bFM_MFS13_CSIO_ESCR_L3                *((volatile unsigned char*)(0x4271A098UL))
#define bFM_MFS13_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271A09CUL))
#define bFM_MFS13_CSIO_SSR_TBI                *((volatile unsigned char*)(0x4271A0A0UL))
#define bFM_MFS13_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x4271A0A4UL))
#define bFM_MFS13_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x4271A0A8UL))
#define bFM_MFS13_CSIO_SSR_ORE                *((volatile unsigned char*)(0x4271A0ACUL))
#define bFM_MFS13_CSIO_SSR_AWC                *((volatile unsigned char*)(0x4271A0B0UL))
#define bFM_MFS13_CSIO_SSR_REC                *((volatile unsigned char*)(0x4271A0BCUL))
#define bFM_MFS13_CSIO_FCR_FE1                *((volatile unsigned char*)(0x4271A280UL))
#define bFM_MFS13_CSIO_FCR_FE2                *((volatile unsigned char*)(0x4271A284UL))
#define bFM_MFS13_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x4271A288UL))
#define bFM_MFS13_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271A28CUL))
#define bFM_MFS13_CSIO_FCR_FSET               *((volatile unsigned char*)(0x4271A290UL))
#define bFM_MFS13_CSIO_FCR_FLD                *((volatile unsigned char*)(0x4271A294UL))
#define bFM_MFS13_CSIO_FCR_FLST               *((volatile unsigned char*)(0x4271A298UL))
#define bFM_MFS13_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM_MFS13_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM_MFS13_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM_MFS13_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM_MFS13_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM_MFS13_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x4271A280UL))
#define bFM_MFS13_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x4271A284UL))
#define bFM_MFS13_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x4271A288UL))
#define bFM_MFS13_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271A28CUL))
#define bFM_MFS13_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x4271A290UL))
#define bFM_MFS13_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x4271A294UL))
#define bFM_MFS13_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x4271A298UL))
#define bFM_MFS13_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM_MFS13_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM_MFS13_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM_MFS13_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM_MFS13_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM_MFS13_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x4271A300UL))
#define bFM_MFS13_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x4271A304UL))
#define bFM_MFS13_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x4271A308UL))
#define bFM_MFS13_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271A30CUL))
#define bFM_MFS13_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x4271A310UL))
#define bFM_MFS13_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x4271A314UL))
#define bFM_MFS13_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x4271A318UL))
#define bFM_MFS13_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271A31CUL))
#define bFM_MFS13_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x4271A320UL))
#define bFM_MFS13_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x4271A324UL))
#define bFM_MFS13_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x4271A328UL))
#define bFM_MFS13_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271A32CUL))
#define bFM_MFS13_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x4271A330UL))
#define bFM_MFS13_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x4271A334UL))
#define bFM_MFS13_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x4271A338UL))
#define bFM_MFS13_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271A33CUL))
#define bFM_MFS13_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x4271A300UL))
#define bFM_MFS13_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x4271A304UL))
#define bFM_MFS13_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x4271A308UL))
#define bFM_MFS13_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271A30CUL))
#define bFM_MFS13_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x4271A310UL))
#define bFM_MFS13_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x4271A314UL))
#define bFM_MFS13_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x4271A318UL))
#define bFM_MFS13_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271A31CUL))
#define bFM_MFS13_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x4271A320UL))
#define bFM_MFS13_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x4271A324UL))
#define bFM_MFS13_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x4271A328UL))
#define bFM_MFS13_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271A32CUL))
#define bFM_MFS13_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x4271A330UL))
#define bFM_MFS13_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x4271A334UL))
#define bFM_MFS13_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x4271A338UL))
#define bFM_MFS13_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271A33CUL))
#define bFM_MFS13_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x4271A380UL))
#define bFM_MFS13_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x4271A384UL))
#define bFM_MFS13_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x4271A388UL))
#define bFM_MFS13_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271A38CUL))
#define bFM_MFS13_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x4271A390UL))
#define bFM_MFS13_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x4271A394UL))
#define bFM_MFS13_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x4271A398UL))
#define bFM_MFS13_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271A39CUL))
#define bFM_MFS13_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x4271A3A0UL))
#define bFM_MFS13_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x4271A3A4UL))
#define bFM_MFS13_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x4271A3A8UL))
#define bFM_MFS13_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x4271A3ACUL))
#define bFM_MFS13_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x4271A3B0UL))
#define bFM_MFS13_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x4271A3B4UL))
#define bFM_MFS13_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x4271A3B8UL))
#define bFM_MFS13_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x4271A3BCUL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x4271A400UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x4271A404UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x4271A408UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271A40CUL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x4271A410UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x4271A414UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x4271A418UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271A41CUL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x4271A420UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x4271A424UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x4271A428UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271A42CUL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x4271A430UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x4271A434UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x4271A438UL))
#define bFM_MFS13_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271A43CUL))
#define bFM_MFS13_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x4271A480UL))
#define bFM_MFS13_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x4271A484UL))
#define bFM_MFS13_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x4271A488UL))
#define bFM_MFS13_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271A48CUL))
#define bFM_MFS13_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x4271A490UL))
#define bFM_MFS13_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x4271A498UL))
#define bFM_MFS13_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271A49CUL))
#define bFM_MFS13_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x4271A4A0UL))
#define bFM_MFS13_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x4271A4ACUL))
#define bFM_MFS13_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x4271A4B0UL))
#define bFM_MFS13_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x4271A4B4UL))
#define bFM_MFS13_CSIO_STMR_TM0               *((volatile unsigned char*)(0x4271A500UL))
#define bFM_MFS13_CSIO_STMR_TM1               *((volatile unsigned char*)(0x4271A504UL))
#define bFM_MFS13_CSIO_STMR_TM2               *((volatile unsigned char*)(0x4271A508UL))
#define bFM_MFS13_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271A50CUL))
#define bFM_MFS13_CSIO_STMR_TM4               *((volatile unsigned char*)(0x4271A510UL))
#define bFM_MFS13_CSIO_STMR_TM5               *((volatile unsigned char*)(0x4271A514UL))
#define bFM_MFS13_CSIO_STMR_TM6               *((volatile unsigned char*)(0x4271A518UL))
#define bFM_MFS13_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271A51CUL))
#define bFM_MFS13_CSIO_STMR_TM8               *((volatile unsigned char*)(0x4271A520UL))
#define bFM_MFS13_CSIO_STMR_TM9               *((volatile unsigned char*)(0x4271A524UL))
#define bFM_MFS13_CSIO_STMR_TM10              *((volatile unsigned char*)(0x4271A528UL))
#define bFM_MFS13_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271A52CUL))
#define bFM_MFS13_CSIO_STMR_TM12              *((volatile unsigned char*)(0x4271A530UL))
#define bFM_MFS13_CSIO_STMR_TM13              *((volatile unsigned char*)(0x4271A534UL))
#define bFM_MFS13_CSIO_STMR_TM14              *((volatile unsigned char*)(0x4271A538UL))
#define bFM_MFS13_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271A53CUL))
#define bFM_MFS13_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x4271A580UL))
#define bFM_MFS13_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x4271A584UL))
#define bFM_MFS13_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x4271A588UL))
#define bFM_MFS13_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271A58CUL))
#define bFM_MFS13_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x4271A590UL))
#define bFM_MFS13_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x4271A594UL))
#define bFM_MFS13_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x4271A598UL))
#define bFM_MFS13_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271A59CUL))
#define bFM_MFS13_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x4271A5A0UL))
#define bFM_MFS13_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x4271A5A4UL))
#define bFM_MFS13_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x4271A5A8UL))
#define bFM_MFS13_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x4271A5ACUL))
#define bFM_MFS13_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x4271A5B0UL))
#define bFM_MFS13_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x4271A5B4UL))
#define bFM_MFS13_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x4271A5B8UL))
#define bFM_MFS13_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x4271A5BCUL))
#define bFM_MFS13_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x4271A600UL))
#define bFM_MFS13_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x4271A604UL))
#define bFM_MFS13_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x4271A608UL))
#define bFM_MFS13_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271A60CUL))
#define bFM_MFS13_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x4271A610UL))
#define bFM_MFS13_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x4271A614UL))
#define bFM_MFS13_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x4271A618UL))
#define bFM_MFS13_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271A61CUL))
#define bFM_MFS13_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x4271A620UL))
#define bFM_MFS13_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x4271A624UL))
#define bFM_MFS13_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x4271A628UL))
#define bFM_MFS13_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271A62CUL))
#define bFM_MFS13_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x4271A630UL))
#define bFM_MFS13_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x4271A634UL))
#define bFM_MFS13_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x4271A638UL))
#define bFM_MFS13_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271A63CUL))
#define bFM_MFS13_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x4271A680UL))
#define bFM_MFS13_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x4271A684UL))
#define bFM_MFS13_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x4271A688UL))
#define bFM_MFS13_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271A68CUL))
#define bFM_MFS13_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x4271A690UL))
#define bFM_MFS13_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x4271A694UL))
#define bFM_MFS13_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x4271A698UL))
#define bFM_MFS13_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271A69CUL))
#define bFM_MFS13_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x4271A6A0UL))
#define bFM_MFS13_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x4271A6A4UL))
#define bFM_MFS13_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x4271A6A8UL))
#define bFM_MFS13_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x4271A6ACUL))
#define bFM_MFS13_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x4271A6B0UL))
#define bFM_MFS13_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x4271A6B4UL))
#define bFM_MFS13_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x4271A6B8UL))
#define bFM_MFS13_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x4271A6BCUL))
#define bFM_MFS13_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x4271A700UL))
#define bFM_MFS13_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x4271A704UL))
#define bFM_MFS13_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x4271A708UL))
#define bFM_MFS13_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271A70CUL))
#define bFM_MFS13_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x4271A710UL))
#define bFM_MFS13_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x4271A714UL))
#define bFM_MFS13_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x4271A718UL))
#define bFM_MFS13_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271A71CUL))

/* MFS LIN channel 13 registers */
#define bFM_MFS13_LIN_SMR_SOE                 *((volatile unsigned char*)(0x4271A000UL))
#define bFM_MFS13_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271A00CUL))
#define bFM_MFS13_LIN_SMR_WUCR                *((volatile unsigned char*)(0x4271A010UL))
#define bFM_MFS13_LIN_SMR_MD0                 *((volatile unsigned char*)(0x4271A014UL))
#define bFM_MFS13_LIN_SMR_MD1                 *((volatile unsigned char*)(0x4271A018UL))
#define bFM_MFS13_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271A01CUL))
#define bFM_MFS13_LIN_SCR_TXE                 *((volatile unsigned char*)(0x4271A020UL))
#define bFM_MFS13_LIN_SCR_RXE                 *((volatile unsigned char*)(0x4271A024UL))
#define bFM_MFS13_LIN_SCR_TBIE                *((volatile unsigned char*)(0x4271A028UL))
#define bFM_MFS13_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271A02CUL))
#define bFM_MFS13_LIN_SCR_RIE                 *((volatile unsigned char*)(0x4271A030UL))
#define bFM_MFS13_LIN_SCR_LBR                 *((volatile unsigned char*)(0x4271A034UL))
#define bFM_MFS13_LIN_SCR_MS                  *((volatile unsigned char*)(0x4271A038UL))
#define bFM_MFS13_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271A03CUL))
#define bFM_MFS13_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x4271A080UL))
#define bFM_MFS13_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x4271A084UL))
#define bFM_MFS13_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x4271A088UL))
#define bFM_MFS13_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271A08CUL))
#define bFM_MFS13_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x4271A090UL))
#define bFM_MFS13_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x4271A098UL))
#define bFM_MFS13_LIN_SSR_TBI                 *((volatile unsigned char*)(0x4271A0A0UL))
#define bFM_MFS13_LIN_SSR_TDRE                *((volatile unsigned char*)(0x4271A0A4UL))
#define bFM_MFS13_LIN_SSR_RDRF                *((volatile unsigned char*)(0x4271A0A8UL))
#define bFM_MFS13_LIN_SSR_ORE                 *((volatile unsigned char*)(0x4271A0ACUL))
#define bFM_MFS13_LIN_SSR_FRE                 *((volatile unsigned char*)(0x4271A0B0UL))
#define bFM_MFS13_LIN_SSR_LBD                 *((volatile unsigned char*)(0x4271A0B4UL))
#define bFM_MFS13_LIN_SSR_REC                 *((volatile unsigned char*)(0x4271A0BCUL))
#define bFM_MFS13_LIN_BGR_EXT                 *((volatile unsigned char*)(0x4271A1BCUL))
#define bFM_MFS13_LIN_BGR1_EXT                *((volatile unsigned char*)(0x4271A1BCUL))
#define bFM_MFS13_LIN_FCR_FE1                 *((volatile unsigned char*)(0x4271A280UL))
#define bFM_MFS13_LIN_FCR_FE2                 *((volatile unsigned char*)(0x4271A284UL))
#define bFM_MFS13_LIN_FCR_FCL1                *((volatile unsigned char*)(0x4271A288UL))
#define bFM_MFS13_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271A28CUL))
#define bFM_MFS13_LIN_FCR_FSET                *((volatile unsigned char*)(0x4271A290UL))
#define bFM_MFS13_LIN_FCR_FLD                 *((volatile unsigned char*)(0x4271A294UL))
#define bFM_MFS13_LIN_FCR_FLST                *((volatile unsigned char*)(0x4271A298UL))
#define bFM_MFS13_LIN_FCR_FSEL                *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM_MFS13_LIN_FCR_FTIE                *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM_MFS13_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM_MFS13_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM_MFS13_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM_MFS13_LIN_FCR0_FE1                *((volatile unsigned char*)(0x4271A280UL))
#define bFM_MFS13_LIN_FCR0_FE2                *((volatile unsigned char*)(0x4271A284UL))
#define bFM_MFS13_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x4271A288UL))
#define bFM_MFS13_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271A28CUL))
#define bFM_MFS13_LIN_FCR0_FSET               *((volatile unsigned char*)(0x4271A290UL))
#define bFM_MFS13_LIN_FCR0_FLD                *((volatile unsigned char*)(0x4271A294UL))
#define bFM_MFS13_LIN_FCR0_FLST               *((volatile unsigned char*)(0x4271A298UL))
#define bFM_MFS13_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM_MFS13_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM_MFS13_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM_MFS13_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM_MFS13_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM_MFS13_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x4271A300UL))
#define bFM_MFS13_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x4271A304UL))
#define bFM_MFS13_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x4271A308UL))
#define bFM_MFS13_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271A30CUL))
#define bFM_MFS13_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x4271A310UL))
#define bFM_MFS13_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x4271A314UL))
#define bFM_MFS13_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x4271A318UL))
#define bFM_MFS13_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271A31CUL))
#define bFM_MFS13_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x4271A320UL))
#define bFM_MFS13_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x4271A324UL))
#define bFM_MFS13_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x4271A328UL))
#define bFM_MFS13_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271A32CUL))
#define bFM_MFS13_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x4271A330UL))
#define bFM_MFS13_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x4271A334UL))
#define bFM_MFS13_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x4271A338UL))
#define bFM_MFS13_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271A33CUL))
#define bFM_MFS13_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x4271A300UL))
#define bFM_MFS13_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x4271A304UL))
#define bFM_MFS13_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x4271A308UL))
#define bFM_MFS13_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271A30CUL))
#define bFM_MFS13_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x4271A310UL))
#define bFM_MFS13_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x4271A314UL))
#define bFM_MFS13_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x4271A318UL))
#define bFM_MFS13_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271A31CUL))
#define bFM_MFS13_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x4271A320UL))
#define bFM_MFS13_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x4271A324UL))
#define bFM_MFS13_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x4271A328UL))
#define bFM_MFS13_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271A32CUL))
#define bFM_MFS13_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x4271A330UL))
#define bFM_MFS13_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x4271A334UL))
#define bFM_MFS13_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x4271A338UL))
#define bFM_MFS13_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271A33CUL))

/* MFS I2C channel 13 registers */
#define bFM_MFS13_I2C_SMR_TIE                 *((volatile unsigned char*)(0x4271A008UL))
#define bFM_MFS13_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271A00CUL))
#define bFM_MFS13_I2C_SMR_MD0                 *((volatile unsigned char*)(0x4271A014UL))
#define bFM_MFS13_I2C_SMR_MD1                 *((volatile unsigned char*)(0x4271A018UL))
#define bFM_MFS13_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271A01CUL))
#define bFM_MFS13_I2C_IBCR_INT                *((volatile unsigned char*)(0x4271A020UL))
#define bFM_MFS13_I2C_IBCR_BER                *((volatile unsigned char*)(0x4271A024UL))
#define bFM_MFS13_I2C_IBCR_INTE               *((volatile unsigned char*)(0x4271A028UL))
#define bFM_MFS13_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271A02CUL))
#define bFM_MFS13_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x4271A030UL))
#define bFM_MFS13_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x4271A034UL))
#define bFM_MFS13_I2C_IBCR_ACT                *((volatile unsigned char*)(0x4271A038UL))
#define bFM_MFS13_I2C_IBCR_SCC                *((volatile unsigned char*)(0x4271A038UL))
#define bFM_MFS13_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271A03CUL))
#define bFM_MFS13_I2C_IBSR_BB                 *((volatile unsigned char*)(0x4271A080UL))
#define bFM_MFS13_I2C_IBSR_SPC                *((volatile unsigned char*)(0x4271A084UL))
#define bFM_MFS13_I2C_IBSR_RSC                *((volatile unsigned char*)(0x4271A088UL))
#define bFM_MFS13_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271A08CUL))
#define bFM_MFS13_I2C_IBSR_TRX                *((volatile unsigned char*)(0x4271A090UL))
#define bFM_MFS13_I2C_IBSR_RSA                *((volatile unsigned char*)(0x4271A094UL))
#define bFM_MFS13_I2C_IBSR_RACK               *((volatile unsigned char*)(0x4271A098UL))
#define bFM_MFS13_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271A09CUL))
#define bFM_MFS13_I2C_SSR_TBI                 *((volatile unsigned char*)(0x4271A0A0UL))
#define bFM_MFS13_I2C_SSR_TDRE                *((volatile unsigned char*)(0x4271A0A4UL))
#define bFM_MFS13_I2C_SSR_RDRF                *((volatile unsigned char*)(0x4271A0A8UL))
#define bFM_MFS13_I2C_SSR_ORE                 *((volatile unsigned char*)(0x4271A0ACUL))
#define bFM_MFS13_I2C_SSR_TBIE                *((volatile unsigned char*)(0x4271A0B0UL))
#define bFM_MFS13_I2C_SSR_DMA                 *((volatile unsigned char*)(0x4271A0B4UL))
#define bFM_MFS13_I2C_SSR_TSET                *((volatile unsigned char*)(0x4271A0B8UL))
#define bFM_MFS13_I2C_SSR_REC                 *((volatile unsigned char*)(0x4271A0BCUL))
#define bFM_MFS13_I2C_ISBA_SA0                *((volatile unsigned char*)(0x4271A200UL))
#define bFM_MFS13_I2C_ISBA_SA1                *((volatile unsigned char*)(0x4271A204UL))
#define bFM_MFS13_I2C_ISBA_SA2                *((volatile unsigned char*)(0x4271A208UL))
#define bFM_MFS13_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271A20CUL))
#define bFM_MFS13_I2C_ISBA_SA4                *((volatile unsigned char*)(0x4271A210UL))
#define bFM_MFS13_I2C_ISBA_SA5                *((volatile unsigned char*)(0x4271A214UL))
#define bFM_MFS13_I2C_ISBA_SA6                *((volatile unsigned char*)(0x4271A218UL))
#define bFM_MFS13_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271A21CUL))
#define bFM_MFS13_I2C_ISMK_SM0                *((volatile unsigned char*)(0x4271A220UL))
#define bFM_MFS13_I2C_ISMK_SM1                *((volatile unsigned char*)(0x4271A224UL))
#define bFM_MFS13_I2C_ISMK_SM2                *((volatile unsigned char*)(0x4271A228UL))
#define bFM_MFS13_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271A22CUL))
#define bFM_MFS13_I2C_ISMK_SM4                *((volatile unsigned char*)(0x4271A230UL))
#define bFM_MFS13_I2C_ISMK_SM5                *((volatile unsigned char*)(0x4271A234UL))
#define bFM_MFS13_I2C_ISMK_SM6                *((volatile unsigned char*)(0x4271A238UL))
#define bFM_MFS13_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271A23CUL))
#define bFM_MFS13_I2C_FCR_FE1                 *((volatile unsigned char*)(0x4271A280UL))
#define bFM_MFS13_I2C_FCR_FE2                 *((volatile unsigned char*)(0x4271A284UL))
#define bFM_MFS13_I2C_FCR_FCL1                *((volatile unsigned char*)(0x4271A288UL))
#define bFM_MFS13_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271A28CUL))
#define bFM_MFS13_I2C_FCR_FSET                *((volatile unsigned char*)(0x4271A290UL))
#define bFM_MFS13_I2C_FCR_FLD                 *((volatile unsigned char*)(0x4271A294UL))
#define bFM_MFS13_I2C_FCR_FLST                *((volatile unsigned char*)(0x4271A298UL))
#define bFM_MFS13_I2C_FCR_FSEL                *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM_MFS13_I2C_FCR_FTIE                *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM_MFS13_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM_MFS13_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM_MFS13_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM_MFS13_I2C_FCR0_FE1                *((volatile unsigned char*)(0x4271A280UL))
#define bFM_MFS13_I2C_FCR0_FE2                *((volatile unsigned char*)(0x4271A284UL))
#define bFM_MFS13_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x4271A288UL))
#define bFM_MFS13_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271A28CUL))
#define bFM_MFS13_I2C_FCR0_FSET               *((volatile unsigned char*)(0x4271A290UL))
#define bFM_MFS13_I2C_FCR0_FLD                *((volatile unsigned char*)(0x4271A294UL))
#define bFM_MFS13_I2C_FCR0_FLST               *((volatile unsigned char*)(0x4271A298UL))
#define bFM_MFS13_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x4271A2A0UL))
#define bFM_MFS13_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x4271A2A4UL))
#define bFM_MFS13_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x4271A2A8UL))
#define bFM_MFS13_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x4271A2ACUL))
#define bFM_MFS13_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x4271A2B0UL))
#define bFM_MFS13_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x4271A300UL))
#define bFM_MFS13_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x4271A304UL))
#define bFM_MFS13_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x4271A308UL))
#define bFM_MFS13_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271A30CUL))
#define bFM_MFS13_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x4271A310UL))
#define bFM_MFS13_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x4271A314UL))
#define bFM_MFS13_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x4271A318UL))
#define bFM_MFS13_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271A31CUL))
#define bFM_MFS13_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x4271A320UL))
#define bFM_MFS13_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x4271A324UL))
#define bFM_MFS13_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x4271A328UL))
#define bFM_MFS13_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271A32CUL))
#define bFM_MFS13_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x4271A330UL))
#define bFM_MFS13_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x4271A334UL))
#define bFM_MFS13_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x4271A338UL))
#define bFM_MFS13_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271A33CUL))
#define bFM_MFS13_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x4271A300UL))
#define bFM_MFS13_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x4271A304UL))
#define bFM_MFS13_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x4271A308UL))
#define bFM_MFS13_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271A30CUL))
#define bFM_MFS13_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x4271A310UL))
#define bFM_MFS13_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x4271A314UL))
#define bFM_MFS13_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x4271A318UL))
#define bFM_MFS13_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271A31CUL))
#define bFM_MFS13_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x4271A320UL))
#define bFM_MFS13_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x4271A324UL))
#define bFM_MFS13_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x4271A328UL))
#define bFM_MFS13_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271A32CUL))
#define bFM_MFS13_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x4271A330UL))
#define bFM_MFS13_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x4271A334UL))
#define bFM_MFS13_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x4271A338UL))
#define bFM_MFS13_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271A33CUL))

/* MFS UART channel 14 registers */
#define bFM_MFS14_UART_SMR_SOE                *((volatile unsigned char*)(0x4271C000UL))
#define bFM_MFS14_UART_SMR_BDS                *((volatile unsigned char*)(0x4271C008UL))
#define bFM_MFS14_UART_SMR_SBL                *((volatile unsigned char*)(0x4271C00CUL))
#define bFM_MFS14_UART_SMR_WUCR               *((volatile unsigned char*)(0x4271C010UL))
#define bFM_MFS14_UART_SMR_MD0                *((volatile unsigned char*)(0x4271C014UL))
#define bFM_MFS14_UART_SMR_MD1                *((volatile unsigned char*)(0x4271C018UL))
#define bFM_MFS14_UART_SMR_MD2                *((volatile unsigned char*)(0x4271C01CUL))
#define bFM_MFS14_UART_SCR_TXE                *((volatile unsigned char*)(0x4271C020UL))
#define bFM_MFS14_UART_SCR_RXE                *((volatile unsigned char*)(0x4271C024UL))
#define bFM_MFS14_UART_SCR_TBIE               *((volatile unsigned char*)(0x4271C028UL))
#define bFM_MFS14_UART_SCR_TIE                *((volatile unsigned char*)(0x4271C02CUL))
#define bFM_MFS14_UART_SCR_RIE                *((volatile unsigned char*)(0x4271C030UL))
#define bFM_MFS14_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271C03CUL))
#define bFM_MFS14_UART_ESCR_L0                *((volatile unsigned char*)(0x4271C080UL))
#define bFM_MFS14_UART_ESCR_L1                *((volatile unsigned char*)(0x4271C084UL))
#define bFM_MFS14_UART_ESCR_L2                *((volatile unsigned char*)(0x4271C088UL))
#define bFM_MFS14_UART_ESCR_P                 *((volatile unsigned char*)(0x4271C08CUL))
#define bFM_MFS14_UART_ESCR_PEN               *((volatile unsigned char*)(0x4271C090UL))
#define bFM_MFS14_UART_ESCR_INV               *((volatile unsigned char*)(0x4271C094UL))
#define bFM_MFS14_UART_ESCR_ESBL              *((volatile unsigned char*)(0x4271C098UL))
#define bFM_MFS14_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271C09CUL))
#define bFM_MFS14_UART_SSR_TBI                *((volatile unsigned char*)(0x4271C0A0UL))
#define bFM_MFS14_UART_SSR_TDRE               *((volatile unsigned char*)(0x4271C0A4UL))
#define bFM_MFS14_UART_SSR_RDRF               *((volatile unsigned char*)(0x4271C0A8UL))
#define bFM_MFS14_UART_SSR_ORE                *((volatile unsigned char*)(0x4271C0ACUL))
#define bFM_MFS14_UART_SSR_FRE                *((volatile unsigned char*)(0x4271C0B0UL))
#define bFM_MFS14_UART_SSR_PE                 *((volatile unsigned char*)(0x4271C0B4UL))
#define bFM_MFS14_UART_SSR_REC                *((volatile unsigned char*)(0x4271C0BCUL))
#define bFM_MFS14_UART_BGR_EXT                *((volatile unsigned char*)(0x4271C1BCUL))
#define bFM_MFS14_UART_BGR1_EXT               *((volatile unsigned char*)(0x4271C1BCUL))
#define bFM_MFS14_UART_FCR_FE1                *((volatile unsigned char*)(0x4271C280UL))
#define bFM_MFS14_UART_FCR_FE2                *((volatile unsigned char*)(0x4271C284UL))
#define bFM_MFS14_UART_FCR_FCL1               *((volatile unsigned char*)(0x4271C288UL))
#define bFM_MFS14_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271C28CUL))
#define bFM_MFS14_UART_FCR_FSET               *((volatile unsigned char*)(0x4271C290UL))
#define bFM_MFS14_UART_FCR_FLD                *((volatile unsigned char*)(0x4271C294UL))
#define bFM_MFS14_UART_FCR_FLST               *((volatile unsigned char*)(0x4271C298UL))
#define bFM_MFS14_UART_FCR_FSEL               *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM_MFS14_UART_FCR_FTIE               *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM_MFS14_UART_FCR_FDRQ               *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM_MFS14_UART_FCR_FRIIE              *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM_MFS14_UART_FCR_FLSTE              *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM_MFS14_UART_FCR0_FE1               *((volatile unsigned char*)(0x4271C280UL))
#define bFM_MFS14_UART_FCR0_FE2               *((volatile unsigned char*)(0x4271C284UL))
#define bFM_MFS14_UART_FCR0_FCL1              *((volatile unsigned char*)(0x4271C288UL))
#define bFM_MFS14_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271C28CUL))
#define bFM_MFS14_UART_FCR0_FSET              *((volatile unsigned char*)(0x4271C290UL))
#define bFM_MFS14_UART_FCR0_FLD               *((volatile unsigned char*)(0x4271C294UL))
#define bFM_MFS14_UART_FCR0_FLST              *((volatile unsigned char*)(0x4271C298UL))
#define bFM_MFS14_UART_FCR1_FSEL              *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM_MFS14_UART_FCR1_FTIE              *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM_MFS14_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM_MFS14_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM_MFS14_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM_MFS14_UART_FBYTE_FD0              *((volatile unsigned char*)(0x4271C300UL))
#define bFM_MFS14_UART_FBYTE_FD1              *((volatile unsigned char*)(0x4271C304UL))
#define bFM_MFS14_UART_FBYTE_FD2              *((volatile unsigned char*)(0x4271C308UL))
#define bFM_MFS14_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271C30CUL))
#define bFM_MFS14_UART_FBYTE_FD4              *((volatile unsigned char*)(0x4271C310UL))
#define bFM_MFS14_UART_FBYTE_FD5              *((volatile unsigned char*)(0x4271C314UL))
#define bFM_MFS14_UART_FBYTE_FD6              *((volatile unsigned char*)(0x4271C318UL))
#define bFM_MFS14_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271C31CUL))
#define bFM_MFS14_UART_FBYTE_FD8              *((volatile unsigned char*)(0x4271C320UL))
#define bFM_MFS14_UART_FBYTE_FD9              *((volatile unsigned char*)(0x4271C324UL))
#define bFM_MFS14_UART_FBYTE_FD10             *((volatile unsigned char*)(0x4271C328UL))
#define bFM_MFS14_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271C32CUL))
#define bFM_MFS14_UART_FBYTE_FD12             *((volatile unsigned char*)(0x4271C330UL))
#define bFM_MFS14_UART_FBYTE_FD13             *((volatile unsigned char*)(0x4271C334UL))
#define bFM_MFS14_UART_FBYTE_FD14             *((volatile unsigned char*)(0x4271C338UL))
#define bFM_MFS14_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271C33CUL))
#define bFM_MFS14_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x4271C300UL))
#define bFM_MFS14_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x4271C304UL))
#define bFM_MFS14_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x4271C308UL))
#define bFM_MFS14_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271C30CUL))
#define bFM_MFS14_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x4271C310UL))
#define bFM_MFS14_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x4271C314UL))
#define bFM_MFS14_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x4271C318UL))
#define bFM_MFS14_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271C31CUL))
#define bFM_MFS14_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x4271C320UL))
#define bFM_MFS14_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x4271C324UL))
#define bFM_MFS14_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x4271C328UL))
#define bFM_MFS14_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271C32CUL))
#define bFM_MFS14_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x4271C330UL))
#define bFM_MFS14_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x4271C334UL))
#define bFM_MFS14_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x4271C338UL))
#define bFM_MFS14_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271C33CUL))

/* MFS CSIO channel 14 registers */
#define bFM_MFS14_CSIO_SMR_SOE                *((volatile unsigned char*)(0x4271C000UL))
#define bFM_MFS14_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x4271C004UL))
#define bFM_MFS14_CSIO_SMR_BDS                *((volatile unsigned char*)(0x4271C008UL))
#define bFM_MFS14_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271C00CUL))
#define bFM_MFS14_CSIO_SMR_MD0                *((volatile unsigned char*)(0x4271C014UL))
#define bFM_MFS14_CSIO_SMR_MD1                *((volatile unsigned char*)(0x4271C018UL))
#define bFM_MFS14_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271C01CUL))
#define bFM_MFS14_CSIO_SCR_TXE                *((volatile unsigned char*)(0x4271C020UL))
#define bFM_MFS14_CSIO_SCR_RXE                *((volatile unsigned char*)(0x4271C024UL))
#define bFM_MFS14_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x4271C028UL))
#define bFM_MFS14_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271C02CUL))
#define bFM_MFS14_CSIO_SCR_RIE                *((volatile unsigned char*)(0x4271C030UL))
#define bFM_MFS14_CSIO_SCR_SPI                *((volatile unsigned char*)(0x4271C034UL))
#define bFM_MFS14_CSIO_SCR_MS                 *((volatile unsigned char*)(0x4271C038UL))
#define bFM_MFS14_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271C03CUL))
#define bFM_MFS14_CSIO_ESCR_L0                *((volatile unsigned char*)(0x4271C080UL))
#define bFM_MFS14_CSIO_ESCR_L1                *((volatile unsigned char*)(0x4271C084UL))
#define bFM_MFS14_CSIO_ESCR_L2                *((volatile unsigned char*)(0x4271C088UL))
#define bFM_MFS14_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271C08CUL))
#define bFM_MFS14_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x4271C090UL))
#define bFM_MFS14_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x4271C094UL))
#define bFM_MFS14_CSIO_ESCR_L3                *((volatile unsigned char*)(0x4271C098UL))
#define bFM_MFS14_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271C09CUL))
#define bFM_MFS14_CSIO_SSR_TBI                *((volatile unsigned char*)(0x4271C0A0UL))
#define bFM_MFS14_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x4271C0A4UL))
#define bFM_MFS14_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x4271C0A8UL))
#define bFM_MFS14_CSIO_SSR_ORE                *((volatile unsigned char*)(0x4271C0ACUL))
#define bFM_MFS14_CSIO_SSR_AWC                *((volatile unsigned char*)(0x4271C0B0UL))
#define bFM_MFS14_CSIO_SSR_REC                *((volatile unsigned char*)(0x4271C0BCUL))
#define bFM_MFS14_CSIO_FCR_FE1                *((volatile unsigned char*)(0x4271C280UL))
#define bFM_MFS14_CSIO_FCR_FE2                *((volatile unsigned char*)(0x4271C284UL))
#define bFM_MFS14_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x4271C288UL))
#define bFM_MFS14_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271C28CUL))
#define bFM_MFS14_CSIO_FCR_FSET               *((volatile unsigned char*)(0x4271C290UL))
#define bFM_MFS14_CSIO_FCR_FLD                *((volatile unsigned char*)(0x4271C294UL))
#define bFM_MFS14_CSIO_FCR_FLST               *((volatile unsigned char*)(0x4271C298UL))
#define bFM_MFS14_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM_MFS14_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM_MFS14_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM_MFS14_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM_MFS14_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM_MFS14_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x4271C280UL))
#define bFM_MFS14_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x4271C284UL))
#define bFM_MFS14_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x4271C288UL))
#define bFM_MFS14_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271C28CUL))
#define bFM_MFS14_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x4271C290UL))
#define bFM_MFS14_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x4271C294UL))
#define bFM_MFS14_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x4271C298UL))
#define bFM_MFS14_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM_MFS14_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM_MFS14_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM_MFS14_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM_MFS14_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM_MFS14_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x4271C300UL))
#define bFM_MFS14_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x4271C304UL))
#define bFM_MFS14_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x4271C308UL))
#define bFM_MFS14_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271C30CUL))
#define bFM_MFS14_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x4271C310UL))
#define bFM_MFS14_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x4271C314UL))
#define bFM_MFS14_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x4271C318UL))
#define bFM_MFS14_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271C31CUL))
#define bFM_MFS14_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x4271C320UL))
#define bFM_MFS14_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x4271C324UL))
#define bFM_MFS14_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x4271C328UL))
#define bFM_MFS14_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271C32CUL))
#define bFM_MFS14_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x4271C330UL))
#define bFM_MFS14_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x4271C334UL))
#define bFM_MFS14_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x4271C338UL))
#define bFM_MFS14_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271C33CUL))
#define bFM_MFS14_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x4271C300UL))
#define bFM_MFS14_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x4271C304UL))
#define bFM_MFS14_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x4271C308UL))
#define bFM_MFS14_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271C30CUL))
#define bFM_MFS14_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x4271C310UL))
#define bFM_MFS14_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x4271C314UL))
#define bFM_MFS14_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x4271C318UL))
#define bFM_MFS14_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271C31CUL))
#define bFM_MFS14_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x4271C320UL))
#define bFM_MFS14_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x4271C324UL))
#define bFM_MFS14_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x4271C328UL))
#define bFM_MFS14_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271C32CUL))
#define bFM_MFS14_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x4271C330UL))
#define bFM_MFS14_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x4271C334UL))
#define bFM_MFS14_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x4271C338UL))
#define bFM_MFS14_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271C33CUL))
#define bFM_MFS14_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x4271C380UL))
#define bFM_MFS14_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x4271C384UL))
#define bFM_MFS14_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x4271C388UL))
#define bFM_MFS14_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271C38CUL))
#define bFM_MFS14_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x4271C390UL))
#define bFM_MFS14_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x4271C394UL))
#define bFM_MFS14_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x4271C398UL))
#define bFM_MFS14_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271C39CUL))
#define bFM_MFS14_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x4271C3A0UL))
#define bFM_MFS14_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x4271C3A4UL))
#define bFM_MFS14_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x4271C3A8UL))
#define bFM_MFS14_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x4271C3ACUL))
#define bFM_MFS14_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x4271C3B0UL))
#define bFM_MFS14_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x4271C3B4UL))
#define bFM_MFS14_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x4271C3B8UL))
#define bFM_MFS14_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x4271C3BCUL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x4271C400UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x4271C404UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x4271C408UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271C40CUL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x4271C410UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x4271C414UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x4271C418UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271C41CUL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x4271C420UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x4271C424UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x4271C428UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271C42CUL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x4271C430UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x4271C434UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x4271C438UL))
#define bFM_MFS14_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271C43CUL))
#define bFM_MFS14_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x4271C480UL))
#define bFM_MFS14_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x4271C484UL))
#define bFM_MFS14_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x4271C488UL))
#define bFM_MFS14_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271C48CUL))
#define bFM_MFS14_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x4271C490UL))
#define bFM_MFS14_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x4271C498UL))
#define bFM_MFS14_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271C49CUL))
#define bFM_MFS14_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x4271C4A0UL))
#define bFM_MFS14_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x4271C4ACUL))
#define bFM_MFS14_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x4271C4B0UL))
#define bFM_MFS14_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x4271C4B4UL))
#define bFM_MFS14_CSIO_STMR_TM0               *((volatile unsigned char*)(0x4271C500UL))
#define bFM_MFS14_CSIO_STMR_TM1               *((volatile unsigned char*)(0x4271C504UL))
#define bFM_MFS14_CSIO_STMR_TM2               *((volatile unsigned char*)(0x4271C508UL))
#define bFM_MFS14_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271C50CUL))
#define bFM_MFS14_CSIO_STMR_TM4               *((volatile unsigned char*)(0x4271C510UL))
#define bFM_MFS14_CSIO_STMR_TM5               *((volatile unsigned char*)(0x4271C514UL))
#define bFM_MFS14_CSIO_STMR_TM6               *((volatile unsigned char*)(0x4271C518UL))
#define bFM_MFS14_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271C51CUL))
#define bFM_MFS14_CSIO_STMR_TM8               *((volatile unsigned char*)(0x4271C520UL))
#define bFM_MFS14_CSIO_STMR_TM9               *((volatile unsigned char*)(0x4271C524UL))
#define bFM_MFS14_CSIO_STMR_TM10              *((volatile unsigned char*)(0x4271C528UL))
#define bFM_MFS14_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271C52CUL))
#define bFM_MFS14_CSIO_STMR_TM12              *((volatile unsigned char*)(0x4271C530UL))
#define bFM_MFS14_CSIO_STMR_TM13              *((volatile unsigned char*)(0x4271C534UL))
#define bFM_MFS14_CSIO_STMR_TM14              *((volatile unsigned char*)(0x4271C538UL))
#define bFM_MFS14_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271C53CUL))
#define bFM_MFS14_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x4271C580UL))
#define bFM_MFS14_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x4271C584UL))
#define bFM_MFS14_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x4271C588UL))
#define bFM_MFS14_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271C58CUL))
#define bFM_MFS14_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x4271C590UL))
#define bFM_MFS14_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x4271C594UL))
#define bFM_MFS14_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x4271C598UL))
#define bFM_MFS14_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271C59CUL))
#define bFM_MFS14_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x4271C5A0UL))
#define bFM_MFS14_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x4271C5A4UL))
#define bFM_MFS14_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x4271C5A8UL))
#define bFM_MFS14_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x4271C5ACUL))
#define bFM_MFS14_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x4271C5B0UL))
#define bFM_MFS14_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x4271C5B4UL))
#define bFM_MFS14_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x4271C5B8UL))
#define bFM_MFS14_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x4271C5BCUL))
#define bFM_MFS14_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x4271C600UL))
#define bFM_MFS14_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x4271C604UL))
#define bFM_MFS14_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x4271C608UL))
#define bFM_MFS14_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271C60CUL))
#define bFM_MFS14_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x4271C610UL))
#define bFM_MFS14_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x4271C614UL))
#define bFM_MFS14_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x4271C618UL))
#define bFM_MFS14_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271C61CUL))
#define bFM_MFS14_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x4271C620UL))
#define bFM_MFS14_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x4271C624UL))
#define bFM_MFS14_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x4271C628UL))
#define bFM_MFS14_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271C62CUL))
#define bFM_MFS14_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x4271C630UL))
#define bFM_MFS14_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x4271C634UL))
#define bFM_MFS14_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x4271C638UL))
#define bFM_MFS14_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271C63CUL))
#define bFM_MFS14_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x4271C680UL))
#define bFM_MFS14_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x4271C684UL))
#define bFM_MFS14_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x4271C688UL))
#define bFM_MFS14_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271C68CUL))
#define bFM_MFS14_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x4271C690UL))
#define bFM_MFS14_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x4271C694UL))
#define bFM_MFS14_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x4271C698UL))
#define bFM_MFS14_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271C69CUL))
#define bFM_MFS14_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x4271C6A0UL))
#define bFM_MFS14_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x4271C6A4UL))
#define bFM_MFS14_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x4271C6A8UL))
#define bFM_MFS14_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x4271C6ACUL))
#define bFM_MFS14_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x4271C6B0UL))
#define bFM_MFS14_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x4271C6B4UL))
#define bFM_MFS14_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x4271C6B8UL))
#define bFM_MFS14_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x4271C6BCUL))
#define bFM_MFS14_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x4271C700UL))
#define bFM_MFS14_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x4271C704UL))
#define bFM_MFS14_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x4271C708UL))
#define bFM_MFS14_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271C70CUL))
#define bFM_MFS14_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x4271C710UL))
#define bFM_MFS14_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x4271C714UL))
#define bFM_MFS14_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x4271C718UL))
#define bFM_MFS14_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271C71CUL))

/* MFS LIN channel 14 registers */
#define bFM_MFS14_LIN_SMR_SOE                 *((volatile unsigned char*)(0x4271C000UL))
#define bFM_MFS14_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271C00CUL))
#define bFM_MFS14_LIN_SMR_WUCR                *((volatile unsigned char*)(0x4271C010UL))
#define bFM_MFS14_LIN_SMR_MD0                 *((volatile unsigned char*)(0x4271C014UL))
#define bFM_MFS14_LIN_SMR_MD1                 *((volatile unsigned char*)(0x4271C018UL))
#define bFM_MFS14_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271C01CUL))
#define bFM_MFS14_LIN_SCR_TXE                 *((volatile unsigned char*)(0x4271C020UL))
#define bFM_MFS14_LIN_SCR_RXE                 *((volatile unsigned char*)(0x4271C024UL))
#define bFM_MFS14_LIN_SCR_TBIE                *((volatile unsigned char*)(0x4271C028UL))
#define bFM_MFS14_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271C02CUL))
#define bFM_MFS14_LIN_SCR_RIE                 *((volatile unsigned char*)(0x4271C030UL))
#define bFM_MFS14_LIN_SCR_LBR                 *((volatile unsigned char*)(0x4271C034UL))
#define bFM_MFS14_LIN_SCR_MS                  *((volatile unsigned char*)(0x4271C038UL))
#define bFM_MFS14_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271C03CUL))
#define bFM_MFS14_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x4271C080UL))
#define bFM_MFS14_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x4271C084UL))
#define bFM_MFS14_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x4271C088UL))
#define bFM_MFS14_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271C08CUL))
#define bFM_MFS14_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x4271C090UL))
#define bFM_MFS14_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x4271C098UL))
#define bFM_MFS14_LIN_SSR_TBI                 *((volatile unsigned char*)(0x4271C0A0UL))
#define bFM_MFS14_LIN_SSR_TDRE                *((volatile unsigned char*)(0x4271C0A4UL))
#define bFM_MFS14_LIN_SSR_RDRF                *((volatile unsigned char*)(0x4271C0A8UL))
#define bFM_MFS14_LIN_SSR_ORE                 *((volatile unsigned char*)(0x4271C0ACUL))
#define bFM_MFS14_LIN_SSR_FRE                 *((volatile unsigned char*)(0x4271C0B0UL))
#define bFM_MFS14_LIN_SSR_LBD                 *((volatile unsigned char*)(0x4271C0B4UL))
#define bFM_MFS14_LIN_SSR_REC                 *((volatile unsigned char*)(0x4271C0BCUL))
#define bFM_MFS14_LIN_BGR_EXT                 *((volatile unsigned char*)(0x4271C1BCUL))
#define bFM_MFS14_LIN_BGR1_EXT                *((volatile unsigned char*)(0x4271C1BCUL))
#define bFM_MFS14_LIN_FCR_FE1                 *((volatile unsigned char*)(0x4271C280UL))
#define bFM_MFS14_LIN_FCR_FE2                 *((volatile unsigned char*)(0x4271C284UL))
#define bFM_MFS14_LIN_FCR_FCL1                *((volatile unsigned char*)(0x4271C288UL))
#define bFM_MFS14_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271C28CUL))
#define bFM_MFS14_LIN_FCR_FSET                *((volatile unsigned char*)(0x4271C290UL))
#define bFM_MFS14_LIN_FCR_FLD                 *((volatile unsigned char*)(0x4271C294UL))
#define bFM_MFS14_LIN_FCR_FLST                *((volatile unsigned char*)(0x4271C298UL))
#define bFM_MFS14_LIN_FCR_FSEL                *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM_MFS14_LIN_FCR_FTIE                *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM_MFS14_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM_MFS14_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM_MFS14_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM_MFS14_LIN_FCR0_FE1                *((volatile unsigned char*)(0x4271C280UL))
#define bFM_MFS14_LIN_FCR0_FE2                *((volatile unsigned char*)(0x4271C284UL))
#define bFM_MFS14_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x4271C288UL))
#define bFM_MFS14_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271C28CUL))
#define bFM_MFS14_LIN_FCR0_FSET               *((volatile unsigned char*)(0x4271C290UL))
#define bFM_MFS14_LIN_FCR0_FLD                *((volatile unsigned char*)(0x4271C294UL))
#define bFM_MFS14_LIN_FCR0_FLST               *((volatile unsigned char*)(0x4271C298UL))
#define bFM_MFS14_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM_MFS14_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM_MFS14_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM_MFS14_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM_MFS14_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM_MFS14_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x4271C300UL))
#define bFM_MFS14_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x4271C304UL))
#define bFM_MFS14_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x4271C308UL))
#define bFM_MFS14_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271C30CUL))
#define bFM_MFS14_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x4271C310UL))
#define bFM_MFS14_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x4271C314UL))
#define bFM_MFS14_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x4271C318UL))
#define bFM_MFS14_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271C31CUL))
#define bFM_MFS14_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x4271C320UL))
#define bFM_MFS14_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x4271C324UL))
#define bFM_MFS14_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x4271C328UL))
#define bFM_MFS14_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271C32CUL))
#define bFM_MFS14_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x4271C330UL))
#define bFM_MFS14_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x4271C334UL))
#define bFM_MFS14_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x4271C338UL))
#define bFM_MFS14_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271C33CUL))
#define bFM_MFS14_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x4271C300UL))
#define bFM_MFS14_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x4271C304UL))
#define bFM_MFS14_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x4271C308UL))
#define bFM_MFS14_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271C30CUL))
#define bFM_MFS14_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x4271C310UL))
#define bFM_MFS14_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x4271C314UL))
#define bFM_MFS14_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x4271C318UL))
#define bFM_MFS14_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271C31CUL))
#define bFM_MFS14_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x4271C320UL))
#define bFM_MFS14_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x4271C324UL))
#define bFM_MFS14_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x4271C328UL))
#define bFM_MFS14_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271C32CUL))
#define bFM_MFS14_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x4271C330UL))
#define bFM_MFS14_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x4271C334UL))
#define bFM_MFS14_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x4271C338UL))
#define bFM_MFS14_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271C33CUL))

/* MFS I2C channel 14 registers */
#define bFM_MFS14_I2C_SMR_TIE                 *((volatile unsigned char*)(0x4271C008UL))
#define bFM_MFS14_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271C00CUL))
#define bFM_MFS14_I2C_SMR_MD0                 *((volatile unsigned char*)(0x4271C014UL))
#define bFM_MFS14_I2C_SMR_MD1                 *((volatile unsigned char*)(0x4271C018UL))
#define bFM_MFS14_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271C01CUL))
#define bFM_MFS14_I2C_IBCR_INT                *((volatile unsigned char*)(0x4271C020UL))
#define bFM_MFS14_I2C_IBCR_BER                *((volatile unsigned char*)(0x4271C024UL))
#define bFM_MFS14_I2C_IBCR_INTE               *((volatile unsigned char*)(0x4271C028UL))
#define bFM_MFS14_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271C02CUL))
#define bFM_MFS14_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x4271C030UL))
#define bFM_MFS14_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x4271C034UL))
#define bFM_MFS14_I2C_IBCR_ACT                *((volatile unsigned char*)(0x4271C038UL))
#define bFM_MFS14_I2C_IBCR_SCC                *((volatile unsigned char*)(0x4271C038UL))
#define bFM_MFS14_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271C03CUL))
#define bFM_MFS14_I2C_IBSR_BB                 *((volatile unsigned char*)(0x4271C080UL))
#define bFM_MFS14_I2C_IBSR_SPC                *((volatile unsigned char*)(0x4271C084UL))
#define bFM_MFS14_I2C_IBSR_RSC                *((volatile unsigned char*)(0x4271C088UL))
#define bFM_MFS14_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271C08CUL))
#define bFM_MFS14_I2C_IBSR_TRX                *((volatile unsigned char*)(0x4271C090UL))
#define bFM_MFS14_I2C_IBSR_RSA                *((volatile unsigned char*)(0x4271C094UL))
#define bFM_MFS14_I2C_IBSR_RACK               *((volatile unsigned char*)(0x4271C098UL))
#define bFM_MFS14_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271C09CUL))
#define bFM_MFS14_I2C_SSR_TBI                 *((volatile unsigned char*)(0x4271C0A0UL))
#define bFM_MFS14_I2C_SSR_TDRE                *((volatile unsigned char*)(0x4271C0A4UL))
#define bFM_MFS14_I2C_SSR_RDRF                *((volatile unsigned char*)(0x4271C0A8UL))
#define bFM_MFS14_I2C_SSR_ORE                 *((volatile unsigned char*)(0x4271C0ACUL))
#define bFM_MFS14_I2C_SSR_TBIE                *((volatile unsigned char*)(0x4271C0B0UL))
#define bFM_MFS14_I2C_SSR_DMA                 *((volatile unsigned char*)(0x4271C0B4UL))
#define bFM_MFS14_I2C_SSR_TSET                *((volatile unsigned char*)(0x4271C0B8UL))
#define bFM_MFS14_I2C_SSR_REC                 *((volatile unsigned char*)(0x4271C0BCUL))
#define bFM_MFS14_I2C_ISBA_SA0                *((volatile unsigned char*)(0x4271C200UL))
#define bFM_MFS14_I2C_ISBA_SA1                *((volatile unsigned char*)(0x4271C204UL))
#define bFM_MFS14_I2C_ISBA_SA2                *((volatile unsigned char*)(0x4271C208UL))
#define bFM_MFS14_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271C20CUL))
#define bFM_MFS14_I2C_ISBA_SA4                *((volatile unsigned char*)(0x4271C210UL))
#define bFM_MFS14_I2C_ISBA_SA5                *((volatile unsigned char*)(0x4271C214UL))
#define bFM_MFS14_I2C_ISBA_SA6                *((volatile unsigned char*)(0x4271C218UL))
#define bFM_MFS14_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271C21CUL))
#define bFM_MFS14_I2C_ISMK_SM0                *((volatile unsigned char*)(0x4271C220UL))
#define bFM_MFS14_I2C_ISMK_SM1                *((volatile unsigned char*)(0x4271C224UL))
#define bFM_MFS14_I2C_ISMK_SM2                *((volatile unsigned char*)(0x4271C228UL))
#define bFM_MFS14_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271C22CUL))
#define bFM_MFS14_I2C_ISMK_SM4                *((volatile unsigned char*)(0x4271C230UL))
#define bFM_MFS14_I2C_ISMK_SM5                *((volatile unsigned char*)(0x4271C234UL))
#define bFM_MFS14_I2C_ISMK_SM6                *((volatile unsigned char*)(0x4271C238UL))
#define bFM_MFS14_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271C23CUL))
#define bFM_MFS14_I2C_FCR_FE1                 *((volatile unsigned char*)(0x4271C280UL))
#define bFM_MFS14_I2C_FCR_FE2                 *((volatile unsigned char*)(0x4271C284UL))
#define bFM_MFS14_I2C_FCR_FCL1                *((volatile unsigned char*)(0x4271C288UL))
#define bFM_MFS14_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271C28CUL))
#define bFM_MFS14_I2C_FCR_FSET                *((volatile unsigned char*)(0x4271C290UL))
#define bFM_MFS14_I2C_FCR_FLD                 *((volatile unsigned char*)(0x4271C294UL))
#define bFM_MFS14_I2C_FCR_FLST                *((volatile unsigned char*)(0x4271C298UL))
#define bFM_MFS14_I2C_FCR_FSEL                *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM_MFS14_I2C_FCR_FTIE                *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM_MFS14_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM_MFS14_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM_MFS14_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM_MFS14_I2C_FCR0_FE1                *((volatile unsigned char*)(0x4271C280UL))
#define bFM_MFS14_I2C_FCR0_FE2                *((volatile unsigned char*)(0x4271C284UL))
#define bFM_MFS14_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x4271C288UL))
#define bFM_MFS14_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271C28CUL))
#define bFM_MFS14_I2C_FCR0_FSET               *((volatile unsigned char*)(0x4271C290UL))
#define bFM_MFS14_I2C_FCR0_FLD                *((volatile unsigned char*)(0x4271C294UL))
#define bFM_MFS14_I2C_FCR0_FLST               *((volatile unsigned char*)(0x4271C298UL))
#define bFM_MFS14_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x4271C2A0UL))
#define bFM_MFS14_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x4271C2A4UL))
#define bFM_MFS14_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x4271C2A8UL))
#define bFM_MFS14_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x4271C2ACUL))
#define bFM_MFS14_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x4271C2B0UL))
#define bFM_MFS14_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x4271C300UL))
#define bFM_MFS14_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x4271C304UL))
#define bFM_MFS14_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x4271C308UL))
#define bFM_MFS14_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271C30CUL))
#define bFM_MFS14_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x4271C310UL))
#define bFM_MFS14_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x4271C314UL))
#define bFM_MFS14_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x4271C318UL))
#define bFM_MFS14_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271C31CUL))
#define bFM_MFS14_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x4271C320UL))
#define bFM_MFS14_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x4271C324UL))
#define bFM_MFS14_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x4271C328UL))
#define bFM_MFS14_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271C32CUL))
#define bFM_MFS14_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x4271C330UL))
#define bFM_MFS14_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x4271C334UL))
#define bFM_MFS14_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x4271C338UL))
#define bFM_MFS14_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271C33CUL))
#define bFM_MFS14_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x4271C300UL))
#define bFM_MFS14_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x4271C304UL))
#define bFM_MFS14_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x4271C308UL))
#define bFM_MFS14_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271C30CUL))
#define bFM_MFS14_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x4271C310UL))
#define bFM_MFS14_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x4271C314UL))
#define bFM_MFS14_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x4271C318UL))
#define bFM_MFS14_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271C31CUL))
#define bFM_MFS14_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x4271C320UL))
#define bFM_MFS14_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x4271C324UL))
#define bFM_MFS14_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x4271C328UL))
#define bFM_MFS14_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271C32CUL))
#define bFM_MFS14_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x4271C330UL))
#define bFM_MFS14_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x4271C334UL))
#define bFM_MFS14_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x4271C338UL))
#define bFM_MFS14_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271C33CUL))

/* MFS UART channel 15 registers */
#define bFM_MFS15_UART_SMR_SOE                *((volatile unsigned char*)(0x4271E000UL))
#define bFM_MFS15_UART_SMR_BDS                *((volatile unsigned char*)(0x4271E008UL))
#define bFM_MFS15_UART_SMR_SBL                *((volatile unsigned char*)(0x4271E00CUL))
#define bFM_MFS15_UART_SMR_WUCR               *((volatile unsigned char*)(0x4271E010UL))
#define bFM_MFS15_UART_SMR_MD0                *((volatile unsigned char*)(0x4271E014UL))
#define bFM_MFS15_UART_SMR_MD1                *((volatile unsigned char*)(0x4271E018UL))
#define bFM_MFS15_UART_SMR_MD2                *((volatile unsigned char*)(0x4271E01CUL))
#define bFM_MFS15_UART_SCR_TXE                *((volatile unsigned char*)(0x4271E020UL))
#define bFM_MFS15_UART_SCR_RXE                *((volatile unsigned char*)(0x4271E024UL))
#define bFM_MFS15_UART_SCR_TBIE               *((volatile unsigned char*)(0x4271E028UL))
#define bFM_MFS15_UART_SCR_TIE                *((volatile unsigned char*)(0x4271E02CUL))
#define bFM_MFS15_UART_SCR_RIE                *((volatile unsigned char*)(0x4271E030UL))
#define bFM_MFS15_UART_SCR_UPCL               *((volatile unsigned char*)(0x4271E03CUL))
#define bFM_MFS15_UART_ESCR_L0                *((volatile unsigned char*)(0x4271E080UL))
#define bFM_MFS15_UART_ESCR_L1                *((volatile unsigned char*)(0x4271E084UL))
#define bFM_MFS15_UART_ESCR_L2                *((volatile unsigned char*)(0x4271E088UL))
#define bFM_MFS15_UART_ESCR_P                 *((volatile unsigned char*)(0x4271E08CUL))
#define bFM_MFS15_UART_ESCR_PEN               *((volatile unsigned char*)(0x4271E090UL))
#define bFM_MFS15_UART_ESCR_INV               *((volatile unsigned char*)(0x4271E094UL))
#define bFM_MFS15_UART_ESCR_ESBL              *((volatile unsigned char*)(0x4271E098UL))
#define bFM_MFS15_UART_ESCR_FLWEN             *((volatile unsigned char*)(0x4271E09CUL))
#define bFM_MFS15_UART_SSR_TBI                *((volatile unsigned char*)(0x4271E0A0UL))
#define bFM_MFS15_UART_SSR_TDRE               *((volatile unsigned char*)(0x4271E0A4UL))
#define bFM_MFS15_UART_SSR_RDRF               *((volatile unsigned char*)(0x4271E0A8UL))
#define bFM_MFS15_UART_SSR_ORE                *((volatile unsigned char*)(0x4271E0ACUL))
#define bFM_MFS15_UART_SSR_FRE                *((volatile unsigned char*)(0x4271E0B0UL))
#define bFM_MFS15_UART_SSR_PE                 *((volatile unsigned char*)(0x4271E0B4UL))
#define bFM_MFS15_UART_SSR_REC                *((volatile unsigned char*)(0x4271E0BCUL))
#define bFM_MFS15_UART_BGR_EXT                *((volatile unsigned char*)(0x4271E1BCUL))
#define bFM_MFS15_UART_BGR1_EXT               *((volatile unsigned char*)(0x4271E1BCUL))
#define bFM_MFS15_UART_FCR_FE1                *((volatile unsigned char*)(0x4271E280UL))
#define bFM_MFS15_UART_FCR_FE2                *((volatile unsigned char*)(0x4271E284UL))
#define bFM_MFS15_UART_FCR_FCL1               *((volatile unsigned char*)(0x4271E288UL))
#define bFM_MFS15_UART_FCR_FCL2               *((volatile unsigned char*)(0x4271E28CUL))
#define bFM_MFS15_UART_FCR_FSET               *((volatile unsigned char*)(0x4271E290UL))
#define bFM_MFS15_UART_FCR_FLD                *((volatile unsigned char*)(0x4271E294UL))
#define bFM_MFS15_UART_FCR_FLST               *((volatile unsigned char*)(0x4271E298UL))
#define bFM_MFS15_UART_FCR_FSEL               *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM_MFS15_UART_FCR_FTIE               *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM_MFS15_UART_FCR_FDRQ               *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM_MFS15_UART_FCR_FRIIE              *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM_MFS15_UART_FCR_FLSTE              *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM_MFS15_UART_FCR0_FE1               *((volatile unsigned char*)(0x4271E280UL))
#define bFM_MFS15_UART_FCR0_FE2               *((volatile unsigned char*)(0x4271E284UL))
#define bFM_MFS15_UART_FCR0_FCL1              *((volatile unsigned char*)(0x4271E288UL))
#define bFM_MFS15_UART_FCR0_FCL2              *((volatile unsigned char*)(0x4271E28CUL))
#define bFM_MFS15_UART_FCR0_FSET              *((volatile unsigned char*)(0x4271E290UL))
#define bFM_MFS15_UART_FCR0_FLD               *((volatile unsigned char*)(0x4271E294UL))
#define bFM_MFS15_UART_FCR0_FLST              *((volatile unsigned char*)(0x4271E298UL))
#define bFM_MFS15_UART_FCR1_FSEL              *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM_MFS15_UART_FCR1_FTIE              *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM_MFS15_UART_FCR1_FDRQ              *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM_MFS15_UART_FCR1_FRIIE             *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM_MFS15_UART_FCR1_FLSTE             *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM_MFS15_UART_FBYTE_FD0              *((volatile unsigned char*)(0x4271E300UL))
#define bFM_MFS15_UART_FBYTE_FD1              *((volatile unsigned char*)(0x4271E304UL))
#define bFM_MFS15_UART_FBYTE_FD2              *((volatile unsigned char*)(0x4271E308UL))
#define bFM_MFS15_UART_FBYTE_FD3              *((volatile unsigned char*)(0x4271E30CUL))
#define bFM_MFS15_UART_FBYTE_FD4              *((volatile unsigned char*)(0x4271E310UL))
#define bFM_MFS15_UART_FBYTE_FD5              *((volatile unsigned char*)(0x4271E314UL))
#define bFM_MFS15_UART_FBYTE_FD6              *((volatile unsigned char*)(0x4271E318UL))
#define bFM_MFS15_UART_FBYTE_FD7              *((volatile unsigned char*)(0x4271E31CUL))
#define bFM_MFS15_UART_FBYTE_FD8              *((volatile unsigned char*)(0x4271E320UL))
#define bFM_MFS15_UART_FBYTE_FD9              *((volatile unsigned char*)(0x4271E324UL))
#define bFM_MFS15_UART_FBYTE_FD10             *((volatile unsigned char*)(0x4271E328UL))
#define bFM_MFS15_UART_FBYTE_FD11             *((volatile unsigned char*)(0x4271E32CUL))
#define bFM_MFS15_UART_FBYTE_FD12             *((volatile unsigned char*)(0x4271E330UL))
#define bFM_MFS15_UART_FBYTE_FD13             *((volatile unsigned char*)(0x4271E334UL))
#define bFM_MFS15_UART_FBYTE_FD14             *((volatile unsigned char*)(0x4271E338UL))
#define bFM_MFS15_UART_FBYTE_FD15             *((volatile unsigned char*)(0x4271E33CUL))
#define bFM_MFS15_UART_FBYTE1_FD0             *((volatile unsigned char*)(0x4271E300UL))
#define bFM_MFS15_UART_FBYTE1_FD1             *((volatile unsigned char*)(0x4271E304UL))
#define bFM_MFS15_UART_FBYTE1_FD2             *((volatile unsigned char*)(0x4271E308UL))
#define bFM_MFS15_UART_FBYTE1_FD3             *((volatile unsigned char*)(0x4271E30CUL))
#define bFM_MFS15_UART_FBYTE1_FD4             *((volatile unsigned char*)(0x4271E310UL))
#define bFM_MFS15_UART_FBYTE1_FD5             *((volatile unsigned char*)(0x4271E314UL))
#define bFM_MFS15_UART_FBYTE1_FD6             *((volatile unsigned char*)(0x4271E318UL))
#define bFM_MFS15_UART_FBYTE1_FD7             *((volatile unsigned char*)(0x4271E31CUL))
#define bFM_MFS15_UART_FBYTE2_FD8             *((volatile unsigned char*)(0x4271E320UL))
#define bFM_MFS15_UART_FBYTE2_FD9             *((volatile unsigned char*)(0x4271E324UL))
#define bFM_MFS15_UART_FBYTE2_FD10            *((volatile unsigned char*)(0x4271E328UL))
#define bFM_MFS15_UART_FBYTE2_FD11            *((volatile unsigned char*)(0x4271E32CUL))
#define bFM_MFS15_UART_FBYTE2_FD12            *((volatile unsigned char*)(0x4271E330UL))
#define bFM_MFS15_UART_FBYTE2_FD13            *((volatile unsigned char*)(0x4271E334UL))
#define bFM_MFS15_UART_FBYTE2_FD14            *((volatile unsigned char*)(0x4271E338UL))
#define bFM_MFS15_UART_FBYTE2_FD15            *((volatile unsigned char*)(0x4271E33CUL))

/* MFS CSIO channel 15 registers */
#define bFM_MFS15_CSIO_SMR_SOE                *((volatile unsigned char*)(0x4271E000UL))
#define bFM_MFS15_CSIO_SMR_SCKE               *((volatile unsigned char*)(0x4271E004UL))
#define bFM_MFS15_CSIO_SMR_BDS                *((volatile unsigned char*)(0x4271E008UL))
#define bFM_MFS15_CSIO_SMR_SCINV              *((volatile unsigned char*)(0x4271E00CUL))
#define bFM_MFS15_CSIO_SMR_MD0                *((volatile unsigned char*)(0x4271E014UL))
#define bFM_MFS15_CSIO_SMR_MD1                *((volatile unsigned char*)(0x4271E018UL))
#define bFM_MFS15_CSIO_SMR_MD2                *((volatile unsigned char*)(0x4271E01CUL))
#define bFM_MFS15_CSIO_SCR_TXE                *((volatile unsigned char*)(0x4271E020UL))
#define bFM_MFS15_CSIO_SCR_RXE                *((volatile unsigned char*)(0x4271E024UL))
#define bFM_MFS15_CSIO_SCR_TBIE               *((volatile unsigned char*)(0x4271E028UL))
#define bFM_MFS15_CSIO_SCR_TIE                *((volatile unsigned char*)(0x4271E02CUL))
#define bFM_MFS15_CSIO_SCR_RIE                *((volatile unsigned char*)(0x4271E030UL))
#define bFM_MFS15_CSIO_SCR_SPI                *((volatile unsigned char*)(0x4271E034UL))
#define bFM_MFS15_CSIO_SCR_MS                 *((volatile unsigned char*)(0x4271E038UL))
#define bFM_MFS15_CSIO_SCR_UPCL               *((volatile unsigned char*)(0x4271E03CUL))
#define bFM_MFS15_CSIO_ESCR_L0                *((volatile unsigned char*)(0x4271E080UL))
#define bFM_MFS15_CSIO_ESCR_L1                *((volatile unsigned char*)(0x4271E084UL))
#define bFM_MFS15_CSIO_ESCR_L2                *((volatile unsigned char*)(0x4271E088UL))
#define bFM_MFS15_CSIO_ESCR_WT0               *((volatile unsigned char*)(0x4271E08CUL))
#define bFM_MFS15_CSIO_ESCR_WT1               *((volatile unsigned char*)(0x4271E090UL))
#define bFM_MFS15_CSIO_ESCR_CSFE              *((volatile unsigned char*)(0x4271E094UL))
#define bFM_MFS15_CSIO_ESCR_L3                *((volatile unsigned char*)(0x4271E098UL))
#define bFM_MFS15_CSIO_ESCR_SOP               *((volatile unsigned char*)(0x4271E09CUL))
#define bFM_MFS15_CSIO_SSR_TBI                *((volatile unsigned char*)(0x4271E0A0UL))
#define bFM_MFS15_CSIO_SSR_TDRE               *((volatile unsigned char*)(0x4271E0A4UL))
#define bFM_MFS15_CSIO_SSR_RDRF               *((volatile unsigned char*)(0x4271E0A8UL))
#define bFM_MFS15_CSIO_SSR_ORE                *((volatile unsigned char*)(0x4271E0ACUL))
#define bFM_MFS15_CSIO_SSR_AWC                *((volatile unsigned char*)(0x4271E0B0UL))
#define bFM_MFS15_CSIO_SSR_REC                *((volatile unsigned char*)(0x4271E0BCUL))
#define bFM_MFS15_CSIO_FCR_FE1                *((volatile unsigned char*)(0x4271E280UL))
#define bFM_MFS15_CSIO_FCR_FE2                *((volatile unsigned char*)(0x4271E284UL))
#define bFM_MFS15_CSIO_FCR_FCL1               *((volatile unsigned char*)(0x4271E288UL))
#define bFM_MFS15_CSIO_FCR_FCL2               *((volatile unsigned char*)(0x4271E28CUL))
#define bFM_MFS15_CSIO_FCR_FSET               *((volatile unsigned char*)(0x4271E290UL))
#define bFM_MFS15_CSIO_FCR_FLD                *((volatile unsigned char*)(0x4271E294UL))
#define bFM_MFS15_CSIO_FCR_FLST               *((volatile unsigned char*)(0x4271E298UL))
#define bFM_MFS15_CSIO_FCR_FSEL               *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM_MFS15_CSIO_FCR_FTIE               *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM_MFS15_CSIO_FCR_FDRQ               *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM_MFS15_CSIO_FCR_FRIIE              *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM_MFS15_CSIO_FCR_FLSTE              *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM_MFS15_CSIO_FCR0_FE1               *((volatile unsigned char*)(0x4271E280UL))
#define bFM_MFS15_CSIO_FCR0_FE2               *((volatile unsigned char*)(0x4271E284UL))
#define bFM_MFS15_CSIO_FCR0_FCL1              *((volatile unsigned char*)(0x4271E288UL))
#define bFM_MFS15_CSIO_FCR0_FCL2              *((volatile unsigned char*)(0x4271E28CUL))
#define bFM_MFS15_CSIO_FCR0_FSET              *((volatile unsigned char*)(0x4271E290UL))
#define bFM_MFS15_CSIO_FCR0_FLD               *((volatile unsigned char*)(0x4271E294UL))
#define bFM_MFS15_CSIO_FCR0_FLST              *((volatile unsigned char*)(0x4271E298UL))
#define bFM_MFS15_CSIO_FCR1_FSEL              *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM_MFS15_CSIO_FCR1_FTIE              *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM_MFS15_CSIO_FCR1_FDRQ              *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM_MFS15_CSIO_FCR1_FRIIE             *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM_MFS15_CSIO_FCR1_FLSTE             *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM_MFS15_CSIO_FBYTE_FD0              *((volatile unsigned char*)(0x4271E300UL))
#define bFM_MFS15_CSIO_FBYTE_FD1              *((volatile unsigned char*)(0x4271E304UL))
#define bFM_MFS15_CSIO_FBYTE_FD2              *((volatile unsigned char*)(0x4271E308UL))
#define bFM_MFS15_CSIO_FBYTE_FD3              *((volatile unsigned char*)(0x4271E30CUL))
#define bFM_MFS15_CSIO_FBYTE_FD4              *((volatile unsigned char*)(0x4271E310UL))
#define bFM_MFS15_CSIO_FBYTE_FD5              *((volatile unsigned char*)(0x4271E314UL))
#define bFM_MFS15_CSIO_FBYTE_FD6              *((volatile unsigned char*)(0x4271E318UL))
#define bFM_MFS15_CSIO_FBYTE_FD7              *((volatile unsigned char*)(0x4271E31CUL))
#define bFM_MFS15_CSIO_FBYTE_FD8              *((volatile unsigned char*)(0x4271E320UL))
#define bFM_MFS15_CSIO_FBYTE_FD9              *((volatile unsigned char*)(0x4271E324UL))
#define bFM_MFS15_CSIO_FBYTE_FD10             *((volatile unsigned char*)(0x4271E328UL))
#define bFM_MFS15_CSIO_FBYTE_FD11             *((volatile unsigned char*)(0x4271E32CUL))
#define bFM_MFS15_CSIO_FBYTE_FD12             *((volatile unsigned char*)(0x4271E330UL))
#define bFM_MFS15_CSIO_FBYTE_FD13             *((volatile unsigned char*)(0x4271E334UL))
#define bFM_MFS15_CSIO_FBYTE_FD14             *((volatile unsigned char*)(0x4271E338UL))
#define bFM_MFS15_CSIO_FBYTE_FD15             *((volatile unsigned char*)(0x4271E33CUL))
#define bFM_MFS15_CSIO_FBYTE1_FD0             *((volatile unsigned char*)(0x4271E300UL))
#define bFM_MFS15_CSIO_FBYTE1_FD1             *((volatile unsigned char*)(0x4271E304UL))
#define bFM_MFS15_CSIO_FBYTE1_FD2             *((volatile unsigned char*)(0x4271E308UL))
#define bFM_MFS15_CSIO_FBYTE1_FD3             *((volatile unsigned char*)(0x4271E30CUL))
#define bFM_MFS15_CSIO_FBYTE1_FD4             *((volatile unsigned char*)(0x4271E310UL))
#define bFM_MFS15_CSIO_FBYTE1_FD5             *((volatile unsigned char*)(0x4271E314UL))
#define bFM_MFS15_CSIO_FBYTE1_FD6             *((volatile unsigned char*)(0x4271E318UL))
#define bFM_MFS15_CSIO_FBYTE1_FD7             *((volatile unsigned char*)(0x4271E31CUL))
#define bFM_MFS15_CSIO_FBYTE2_FD8             *((volatile unsigned char*)(0x4271E320UL))
#define bFM_MFS15_CSIO_FBYTE2_FD9             *((volatile unsigned char*)(0x4271E324UL))
#define bFM_MFS15_CSIO_FBYTE2_FD10            *((volatile unsigned char*)(0x4271E328UL))
#define bFM_MFS15_CSIO_FBYTE2_FD11            *((volatile unsigned char*)(0x4271E32CUL))
#define bFM_MFS15_CSIO_FBYTE2_FD12            *((volatile unsigned char*)(0x4271E330UL))
#define bFM_MFS15_CSIO_FBYTE2_FD13            *((volatile unsigned char*)(0x4271E334UL))
#define bFM_MFS15_CSIO_FBYTE2_FD14            *((volatile unsigned char*)(0x4271E338UL))
#define bFM_MFS15_CSIO_FBYTE2_FD15            *((volatile unsigned char*)(0x4271E33CUL))
#define bFM_MFS15_CSIO_SCSTR10_CSHD0          *((volatile unsigned char*)(0x4271E380UL))
#define bFM_MFS15_CSIO_SCSTR10_CSHD1          *((volatile unsigned char*)(0x4271E384UL))
#define bFM_MFS15_CSIO_SCSTR10_CSHD2          *((volatile unsigned char*)(0x4271E388UL))
#define bFM_MFS15_CSIO_SCSTR10_CSHD3          *((volatile unsigned char*)(0x4271E38CUL))
#define bFM_MFS15_CSIO_SCSTR10_CSHD4          *((volatile unsigned char*)(0x4271E390UL))
#define bFM_MFS15_CSIO_SCSTR10_CSHD5          *((volatile unsigned char*)(0x4271E394UL))
#define bFM_MFS15_CSIO_SCSTR10_CSHD6          *((volatile unsigned char*)(0x4271E398UL))
#define bFM_MFS15_CSIO_SCSTR10_CSHD7          *((volatile unsigned char*)(0x4271E39CUL))
#define bFM_MFS15_CSIO_SCSTR10_CSSU0          *((volatile unsigned char*)(0x4271E3A0UL))
#define bFM_MFS15_CSIO_SCSTR10_CSSU1          *((volatile unsigned char*)(0x4271E3A4UL))
#define bFM_MFS15_CSIO_SCSTR10_CSSU2          *((volatile unsigned char*)(0x4271E3A8UL))
#define bFM_MFS15_CSIO_SCSTR10_CSSU3          *((volatile unsigned char*)(0x4271E3ACUL))
#define bFM_MFS15_CSIO_SCSTR10_CSSU4          *((volatile unsigned char*)(0x4271E3B0UL))
#define bFM_MFS15_CSIO_SCSTR10_CSSU5          *((volatile unsigned char*)(0x4271E3B4UL))
#define bFM_MFS15_CSIO_SCSTR10_CSSU6          *((volatile unsigned char*)(0x4271E3B8UL))
#define bFM_MFS15_CSIO_SCSTR10_CSSU7          *((volatile unsigned char*)(0x4271E3BCUL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS0          *((volatile unsigned char*)(0x4271E400UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS1          *((volatile unsigned char*)(0x4271E404UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS2          *((volatile unsigned char*)(0x4271E408UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS3          *((volatile unsigned char*)(0x4271E40CUL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS4          *((volatile unsigned char*)(0x4271E410UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS5          *((volatile unsigned char*)(0x4271E414UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS6          *((volatile unsigned char*)(0x4271E418UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS7          *((volatile unsigned char*)(0x4271E41CUL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS8          *((volatile unsigned char*)(0x4271E420UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS9          *((volatile unsigned char*)(0x4271E424UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS10         *((volatile unsigned char*)(0x4271E428UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS11         *((volatile unsigned char*)(0x4271E42CUL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS12         *((volatile unsigned char*)(0x4271E430UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS13         *((volatile unsigned char*)(0x4271E434UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS14         *((volatile unsigned char*)(0x4271E438UL))
#define bFM_MFS15_CSIO_SCSTR32_CSDS15         *((volatile unsigned char*)(0x4271E43CUL))
#define bFM_MFS15_CSIO_SACSR_TMRE             *((volatile unsigned char*)(0x4271E480UL))
#define bFM_MFS15_CSIO_SACSR_TDIV0            *((volatile unsigned char*)(0x4271E484UL))
#define bFM_MFS15_CSIO_SACSR_TDIV1            *((volatile unsigned char*)(0x4271E488UL))
#define bFM_MFS15_CSIO_SACSR_TDIV2            *((volatile unsigned char*)(0x4271E48CUL))
#define bFM_MFS15_CSIO_SACSR_TDIV3            *((volatile unsigned char*)(0x4271E490UL))
#define bFM_MFS15_CSIO_SACSR_TSYNE            *((volatile unsigned char*)(0x4271E498UL))
#define bFM_MFS15_CSIO_SACSR_TINTE            *((volatile unsigned char*)(0x4271E49CUL))
#define bFM_MFS15_CSIO_SACSR_TINT             *((volatile unsigned char*)(0x4271E4A0UL))
#define bFM_MFS15_CSIO_SACSR_CSE              *((volatile unsigned char*)(0x4271E4ACUL))
#define bFM_MFS15_CSIO_SACSR_CSEIE            *((volatile unsigned char*)(0x4271E4B0UL))
#define bFM_MFS15_CSIO_SACSR_TBEEN            *((volatile unsigned char*)(0x4271E4B4UL))
#define bFM_MFS15_CSIO_STMR_TM0               *((volatile unsigned char*)(0x4271E500UL))
#define bFM_MFS15_CSIO_STMR_TM1               *((volatile unsigned char*)(0x4271E504UL))
#define bFM_MFS15_CSIO_STMR_TM2               *((volatile unsigned char*)(0x4271E508UL))
#define bFM_MFS15_CSIO_STMR_TM3               *((volatile unsigned char*)(0x4271E50CUL))
#define bFM_MFS15_CSIO_STMR_TM4               *((volatile unsigned char*)(0x4271E510UL))
#define bFM_MFS15_CSIO_STMR_TM5               *((volatile unsigned char*)(0x4271E514UL))
#define bFM_MFS15_CSIO_STMR_TM6               *((volatile unsigned char*)(0x4271E518UL))
#define bFM_MFS15_CSIO_STMR_TM7               *((volatile unsigned char*)(0x4271E51CUL))
#define bFM_MFS15_CSIO_STMR_TM8               *((volatile unsigned char*)(0x4271E520UL))
#define bFM_MFS15_CSIO_STMR_TM9               *((volatile unsigned char*)(0x4271E524UL))
#define bFM_MFS15_CSIO_STMR_TM10              *((volatile unsigned char*)(0x4271E528UL))
#define bFM_MFS15_CSIO_STMR_TM11              *((volatile unsigned char*)(0x4271E52CUL))
#define bFM_MFS15_CSIO_STMR_TM12              *((volatile unsigned char*)(0x4271E530UL))
#define bFM_MFS15_CSIO_STMR_TM13              *((volatile unsigned char*)(0x4271E534UL))
#define bFM_MFS15_CSIO_STMR_TM14              *((volatile unsigned char*)(0x4271E538UL))
#define bFM_MFS15_CSIO_STMR_TM15              *((volatile unsigned char*)(0x4271E53CUL))
#define bFM_MFS15_CSIO_STMCR_TC0              *((volatile unsigned char*)(0x4271E580UL))
#define bFM_MFS15_CSIO_STMCR_TC1              *((volatile unsigned char*)(0x4271E584UL))
#define bFM_MFS15_CSIO_STMCR_TC2              *((volatile unsigned char*)(0x4271E588UL))
#define bFM_MFS15_CSIO_STMCR_TC3              *((volatile unsigned char*)(0x4271E58CUL))
#define bFM_MFS15_CSIO_STMCR_TC4              *((volatile unsigned char*)(0x4271E590UL))
#define bFM_MFS15_CSIO_STMCR_TC5              *((volatile unsigned char*)(0x4271E594UL))
#define bFM_MFS15_CSIO_STMCR_TC6              *((volatile unsigned char*)(0x4271E598UL))
#define bFM_MFS15_CSIO_STMCR_TC7              *((volatile unsigned char*)(0x4271E59CUL))
#define bFM_MFS15_CSIO_STMCR_TC8              *((volatile unsigned char*)(0x4271E5A0UL))
#define bFM_MFS15_CSIO_STMCR_TC9              *((volatile unsigned char*)(0x4271E5A4UL))
#define bFM_MFS15_CSIO_STMCR_TC10             *((volatile unsigned char*)(0x4271E5A8UL))
#define bFM_MFS15_CSIO_STMCR_TC11             *((volatile unsigned char*)(0x4271E5ACUL))
#define bFM_MFS15_CSIO_STMCR_TC12             *((volatile unsigned char*)(0x4271E5B0UL))
#define bFM_MFS15_CSIO_STMCR_TC13             *((volatile unsigned char*)(0x4271E5B4UL))
#define bFM_MFS15_CSIO_STMCR_TC14             *((volatile unsigned char*)(0x4271E5B8UL))
#define bFM_MFS15_CSIO_STMCR_TC15             *((volatile unsigned char*)(0x4271E5BCUL))
#define bFM_MFS15_CSIO_SCSCR_CSOE             *((volatile unsigned char*)(0x4271E600UL))
#define bFM_MFS15_CSIO_SCSCR_CSEN0            *((volatile unsigned char*)(0x4271E604UL))
#define bFM_MFS15_CSIO_SCSCR_CSEN1            *((volatile unsigned char*)(0x4271E608UL))
#define bFM_MFS15_CSIO_SCSCR_CSEN2            *((volatile unsigned char*)(0x4271E60CUL))
#define bFM_MFS15_CSIO_SCSCR_CSEN3            *((volatile unsigned char*)(0x4271E610UL))
#define bFM_MFS15_CSIO_SCSCR_CSLVL            *((volatile unsigned char*)(0x4271E614UL))
#define bFM_MFS15_CSIO_SCSCR_CDIV0            *((volatile unsigned char*)(0x4271E618UL))
#define bFM_MFS15_CSIO_SCSCR_CDIV1            *((volatile unsigned char*)(0x4271E61CUL))
#define bFM_MFS15_CSIO_SCSCR_CDIV2            *((volatile unsigned char*)(0x4271E620UL))
#define bFM_MFS15_CSIO_SCSCR_SCAM             *((volatile unsigned char*)(0x4271E624UL))
#define bFM_MFS15_CSIO_SCSCR_SCD0             *((volatile unsigned char*)(0x4271E628UL))
#define bFM_MFS15_CSIO_SCSCR_SCD1             *((volatile unsigned char*)(0x4271E62CUL))
#define bFM_MFS15_CSIO_SCSCR_SED0             *((volatile unsigned char*)(0x4271E630UL))
#define bFM_MFS15_CSIO_SCSCR_SED1             *((volatile unsigned char*)(0x4271E634UL))
#define bFM_MFS15_CSIO_SCSCR_SST0             *((volatile unsigned char*)(0x4271E638UL))
#define bFM_MFS15_CSIO_SCSCR_SST1             *((volatile unsigned char*)(0x4271E63CUL))
#define bFM_MFS15_CSIO_SCSFR0_CS1L0           *((volatile unsigned char*)(0x4271E680UL))
#define bFM_MFS15_CSIO_SCSFR0_CS1L1           *((volatile unsigned char*)(0x4271E684UL))
#define bFM_MFS15_CSIO_SCSFR0_CS1L2           *((volatile unsigned char*)(0x4271E688UL))
#define bFM_MFS15_CSIO_SCSFR0_CS1L3           *((volatile unsigned char*)(0x4271E68CUL))
#define bFM_MFS15_CSIO_SCSFR0_CS1L4           *((volatile unsigned char*)(0x4271E690UL))
#define bFM_MFS15_CSIO_SCSFR0_CS1SPI          *((volatile unsigned char*)(0x4271E694UL))
#define bFM_MFS15_CSIO_SCSFR0_CS1SCINV        *((volatile unsigned char*)(0x4271E698UL))
#define bFM_MFS15_CSIO_SCSFR0_CS1CSLVL        *((volatile unsigned char*)(0x4271E69CUL))
#define bFM_MFS15_CSIO_SCSFR1_CS2L0           *((volatile unsigned char*)(0x4271E6A0UL))
#define bFM_MFS15_CSIO_SCSFR1_CS2L1           *((volatile unsigned char*)(0x4271E6A4UL))
#define bFM_MFS15_CSIO_SCSFR1_CS2L2           *((volatile unsigned char*)(0x4271E6A8UL))
#define bFM_MFS15_CSIO_SCSFR1_CS2L3           *((volatile unsigned char*)(0x4271E6ACUL))
#define bFM_MFS15_CSIO_SCSFR1_CS2L4           *((volatile unsigned char*)(0x4271E6B0UL))
#define bFM_MFS15_CSIO_SCSFR1_CS2SPI          *((volatile unsigned char*)(0x4271E6B4UL))
#define bFM_MFS15_CSIO_SCSFR1_CS2SCINV        *((volatile unsigned char*)(0x4271E6B8UL))
#define bFM_MFS15_CSIO_SCSFR1_CS2CSLVL        *((volatile unsigned char*)(0x4271E6BCUL))
#define bFM_MFS15_CSIO_SCSFR2_CS3L0           *((volatile unsigned char*)(0x4271E700UL))
#define bFM_MFS15_CSIO_SCSFR2_CS3L1           *((volatile unsigned char*)(0x4271E704UL))
#define bFM_MFS15_CSIO_SCSFR2_CS3L2           *((volatile unsigned char*)(0x4271E708UL))
#define bFM_MFS15_CSIO_SCSFR2_CS3L3           *((volatile unsigned char*)(0x4271E70CUL))
#define bFM_MFS15_CSIO_SCSFR2_CS3L4           *((volatile unsigned char*)(0x4271E710UL))
#define bFM_MFS15_CSIO_SCSFR2_CS3SPI          *((volatile unsigned char*)(0x4271E714UL))
#define bFM_MFS15_CSIO_SCSFR2_CS3SCINV        *((volatile unsigned char*)(0x4271E718UL))
#define bFM_MFS15_CSIO_SCSFR2_CS3CSLVL        *((volatile unsigned char*)(0x4271E71CUL))

/* MFS LIN channel 15 registers */
#define bFM_MFS15_LIN_SMR_SOE                 *((volatile unsigned char*)(0x4271E000UL))
#define bFM_MFS15_LIN_SMR_SBL                 *((volatile unsigned char*)(0x4271E00CUL))
#define bFM_MFS15_LIN_SMR_WUCR                *((volatile unsigned char*)(0x4271E010UL))
#define bFM_MFS15_LIN_SMR_MD0                 *((volatile unsigned char*)(0x4271E014UL))
#define bFM_MFS15_LIN_SMR_MD1                 *((volatile unsigned char*)(0x4271E018UL))
#define bFM_MFS15_LIN_SMR_MD2                 *((volatile unsigned char*)(0x4271E01CUL))
#define bFM_MFS15_LIN_SCR_TXE                 *((volatile unsigned char*)(0x4271E020UL))
#define bFM_MFS15_LIN_SCR_RXE                 *((volatile unsigned char*)(0x4271E024UL))
#define bFM_MFS15_LIN_SCR_TBIE                *((volatile unsigned char*)(0x4271E028UL))
#define bFM_MFS15_LIN_SCR_TIE                 *((volatile unsigned char*)(0x4271E02CUL))
#define bFM_MFS15_LIN_SCR_RIE                 *((volatile unsigned char*)(0x4271E030UL))
#define bFM_MFS15_LIN_SCR_LBR                 *((volatile unsigned char*)(0x4271E034UL))
#define bFM_MFS15_LIN_SCR_MS                  *((volatile unsigned char*)(0x4271E038UL))
#define bFM_MFS15_LIN_SCR_UPCL                *((volatile unsigned char*)(0x4271E03CUL))
#define bFM_MFS15_LIN_ESCR_DEL0               *((volatile unsigned char*)(0x4271E080UL))
#define bFM_MFS15_LIN_ESCR_DEL1               *((volatile unsigned char*)(0x4271E084UL))
#define bFM_MFS15_LIN_ESCR_LBL0               *((volatile unsigned char*)(0x4271E088UL))
#define bFM_MFS15_LIN_ESCR_LBL1               *((volatile unsigned char*)(0x4271E08CUL))
#define bFM_MFS15_LIN_ESCR_LBIE               *((volatile unsigned char*)(0x4271E090UL))
#define bFM_MFS15_LIN_ESCR_ESBL               *((volatile unsigned char*)(0x4271E098UL))
#define bFM_MFS15_LIN_SSR_TBI                 *((volatile unsigned char*)(0x4271E0A0UL))
#define bFM_MFS15_LIN_SSR_TDRE                *((volatile unsigned char*)(0x4271E0A4UL))
#define bFM_MFS15_LIN_SSR_RDRF                *((volatile unsigned char*)(0x4271E0A8UL))
#define bFM_MFS15_LIN_SSR_ORE                 *((volatile unsigned char*)(0x4271E0ACUL))
#define bFM_MFS15_LIN_SSR_FRE                 *((volatile unsigned char*)(0x4271E0B0UL))
#define bFM_MFS15_LIN_SSR_LBD                 *((volatile unsigned char*)(0x4271E0B4UL))
#define bFM_MFS15_LIN_SSR_REC                 *((volatile unsigned char*)(0x4271E0BCUL))
#define bFM_MFS15_LIN_BGR_EXT                 *((volatile unsigned char*)(0x4271E1BCUL))
#define bFM_MFS15_LIN_BGR1_EXT                *((volatile unsigned char*)(0x4271E1BCUL))
#define bFM_MFS15_LIN_FCR_FE1                 *((volatile unsigned char*)(0x4271E280UL))
#define bFM_MFS15_LIN_FCR_FE2                 *((volatile unsigned char*)(0x4271E284UL))
#define bFM_MFS15_LIN_FCR_FCL1                *((volatile unsigned char*)(0x4271E288UL))
#define bFM_MFS15_LIN_FCR_FCL2                *((volatile unsigned char*)(0x4271E28CUL))
#define bFM_MFS15_LIN_FCR_FSET                *((volatile unsigned char*)(0x4271E290UL))
#define bFM_MFS15_LIN_FCR_FLD                 *((volatile unsigned char*)(0x4271E294UL))
#define bFM_MFS15_LIN_FCR_FLST                *((volatile unsigned char*)(0x4271E298UL))
#define bFM_MFS15_LIN_FCR_FSEL                *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM_MFS15_LIN_FCR_FTIE                *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM_MFS15_LIN_FCR_FDRQ                *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM_MFS15_LIN_FCR_FRIIE               *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM_MFS15_LIN_FCR_FLSTE               *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM_MFS15_LIN_FCR0_FE1                *((volatile unsigned char*)(0x4271E280UL))
#define bFM_MFS15_LIN_FCR0_FE2                *((volatile unsigned char*)(0x4271E284UL))
#define bFM_MFS15_LIN_FCR0_FCL1               *((volatile unsigned char*)(0x4271E288UL))
#define bFM_MFS15_LIN_FCR0_FCL2               *((volatile unsigned char*)(0x4271E28CUL))
#define bFM_MFS15_LIN_FCR0_FSET               *((volatile unsigned char*)(0x4271E290UL))
#define bFM_MFS15_LIN_FCR0_FLD                *((volatile unsigned char*)(0x4271E294UL))
#define bFM_MFS15_LIN_FCR0_FLST               *((volatile unsigned char*)(0x4271E298UL))
#define bFM_MFS15_LIN_FCR1_FSEL               *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM_MFS15_LIN_FCR1_FTIE               *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM_MFS15_LIN_FCR1_FDRQ               *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM_MFS15_LIN_FCR1_FRIIE              *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM_MFS15_LIN_FCR1_FLSTE              *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM_MFS15_LIN_FBYTE_FD0               *((volatile unsigned char*)(0x4271E300UL))
#define bFM_MFS15_LIN_FBYTE_FD1               *((volatile unsigned char*)(0x4271E304UL))
#define bFM_MFS15_LIN_FBYTE_FD2               *((volatile unsigned char*)(0x4271E308UL))
#define bFM_MFS15_LIN_FBYTE_FD3               *((volatile unsigned char*)(0x4271E30CUL))
#define bFM_MFS15_LIN_FBYTE_FD4               *((volatile unsigned char*)(0x4271E310UL))
#define bFM_MFS15_LIN_FBYTE_FD5               *((volatile unsigned char*)(0x4271E314UL))
#define bFM_MFS15_LIN_FBYTE_FD6               *((volatile unsigned char*)(0x4271E318UL))
#define bFM_MFS15_LIN_FBYTE_FD7               *((volatile unsigned char*)(0x4271E31CUL))
#define bFM_MFS15_LIN_FBYTE_FD8               *((volatile unsigned char*)(0x4271E320UL))
#define bFM_MFS15_LIN_FBYTE_FD9               *((volatile unsigned char*)(0x4271E324UL))
#define bFM_MFS15_LIN_FBYTE_FD10              *((volatile unsigned char*)(0x4271E328UL))
#define bFM_MFS15_LIN_FBYTE_FD11              *((volatile unsigned char*)(0x4271E32CUL))
#define bFM_MFS15_LIN_FBYTE_FD12              *((volatile unsigned char*)(0x4271E330UL))
#define bFM_MFS15_LIN_FBYTE_FD13              *((volatile unsigned char*)(0x4271E334UL))
#define bFM_MFS15_LIN_FBYTE_FD14              *((volatile unsigned char*)(0x4271E338UL))
#define bFM_MFS15_LIN_FBYTE_FD15              *((volatile unsigned char*)(0x4271E33CUL))
#define bFM_MFS15_LIN_FBYTE1_FD0              *((volatile unsigned char*)(0x4271E300UL))
#define bFM_MFS15_LIN_FBYTE1_FD1              *((volatile unsigned char*)(0x4271E304UL))
#define bFM_MFS15_LIN_FBYTE1_FD2              *((volatile unsigned char*)(0x4271E308UL))
#define bFM_MFS15_LIN_FBYTE1_FD3              *((volatile unsigned char*)(0x4271E30CUL))
#define bFM_MFS15_LIN_FBYTE1_FD4              *((volatile unsigned char*)(0x4271E310UL))
#define bFM_MFS15_LIN_FBYTE1_FD5              *((volatile unsigned char*)(0x4271E314UL))
#define bFM_MFS15_LIN_FBYTE1_FD6              *((volatile unsigned char*)(0x4271E318UL))
#define bFM_MFS15_LIN_FBYTE1_FD7              *((volatile unsigned char*)(0x4271E31CUL))
#define bFM_MFS15_LIN_FBYTE2_FD8              *((volatile unsigned char*)(0x4271E320UL))
#define bFM_MFS15_LIN_FBYTE2_FD9              *((volatile unsigned char*)(0x4271E324UL))
#define bFM_MFS15_LIN_FBYTE2_FD10             *((volatile unsigned char*)(0x4271E328UL))
#define bFM_MFS15_LIN_FBYTE2_FD11             *((volatile unsigned char*)(0x4271E32CUL))
#define bFM_MFS15_LIN_FBYTE2_FD12             *((volatile unsigned char*)(0x4271E330UL))
#define bFM_MFS15_LIN_FBYTE2_FD13             *((volatile unsigned char*)(0x4271E334UL))
#define bFM_MFS15_LIN_FBYTE2_FD14             *((volatile unsigned char*)(0x4271E338UL))
#define bFM_MFS15_LIN_FBYTE2_FD15             *((volatile unsigned char*)(0x4271E33CUL))

/* MFS I2C channel 15 registers */
#define bFM_MFS15_I2C_SMR_TIE                 *((volatile unsigned char*)(0x4271E008UL))
#define bFM_MFS15_I2C_SMR_RIE                 *((volatile unsigned char*)(0x4271E00CUL))
#define bFM_MFS15_I2C_SMR_MD0                 *((volatile unsigned char*)(0x4271E014UL))
#define bFM_MFS15_I2C_SMR_MD1                 *((volatile unsigned char*)(0x4271E018UL))
#define bFM_MFS15_I2C_SMR_MD2                 *((volatile unsigned char*)(0x4271E01CUL))
#define bFM_MFS15_I2C_IBCR_INT                *((volatile unsigned char*)(0x4271E020UL))
#define bFM_MFS15_I2C_IBCR_BER                *((volatile unsigned char*)(0x4271E024UL))
#define bFM_MFS15_I2C_IBCR_INTE               *((volatile unsigned char*)(0x4271E028UL))
#define bFM_MFS15_I2C_IBCR_CNDE               *((volatile unsigned char*)(0x4271E02CUL))
#define bFM_MFS15_I2C_IBCR_WSEL               *((volatile unsigned char*)(0x4271E030UL))
#define bFM_MFS15_I2C_IBCR_ACKE               *((volatile unsigned char*)(0x4271E034UL))
#define bFM_MFS15_I2C_IBCR_ACT                *((volatile unsigned char*)(0x4271E038UL))
#define bFM_MFS15_I2C_IBCR_SCC                *((volatile unsigned char*)(0x4271E038UL))
#define bFM_MFS15_I2C_IBCR_MSS                *((volatile unsigned char*)(0x4271E03CUL))
#define bFM_MFS15_I2C_IBSR_BB                 *((volatile unsigned char*)(0x4271E080UL))
#define bFM_MFS15_I2C_IBSR_SPC                *((volatile unsigned char*)(0x4271E084UL))
#define bFM_MFS15_I2C_IBSR_RSC                *((volatile unsigned char*)(0x4271E088UL))
#define bFM_MFS15_I2C_IBSR_AL                 *((volatile unsigned char*)(0x4271E08CUL))
#define bFM_MFS15_I2C_IBSR_TRX                *((volatile unsigned char*)(0x4271E090UL))
#define bFM_MFS15_I2C_IBSR_RSA                *((volatile unsigned char*)(0x4271E094UL))
#define bFM_MFS15_I2C_IBSR_RACK               *((volatile unsigned char*)(0x4271E098UL))
#define bFM_MFS15_I2C_IBSR_FBT                *((volatile unsigned char*)(0x4271E09CUL))
#define bFM_MFS15_I2C_SSR_TBI                 *((volatile unsigned char*)(0x4271E0A0UL))
#define bFM_MFS15_I2C_SSR_TDRE                *((volatile unsigned char*)(0x4271E0A4UL))
#define bFM_MFS15_I2C_SSR_RDRF                *((volatile unsigned char*)(0x4271E0A8UL))
#define bFM_MFS15_I2C_SSR_ORE                 *((volatile unsigned char*)(0x4271E0ACUL))
#define bFM_MFS15_I2C_SSR_TBIE                *((volatile unsigned char*)(0x4271E0B0UL))
#define bFM_MFS15_I2C_SSR_DMA                 *((volatile unsigned char*)(0x4271E0B4UL))
#define bFM_MFS15_I2C_SSR_TSET                *((volatile unsigned char*)(0x4271E0B8UL))
#define bFM_MFS15_I2C_SSR_REC                 *((volatile unsigned char*)(0x4271E0BCUL))
#define bFM_MFS15_I2C_ISBA_SA0                *((volatile unsigned char*)(0x4271E200UL))
#define bFM_MFS15_I2C_ISBA_SA1                *((volatile unsigned char*)(0x4271E204UL))
#define bFM_MFS15_I2C_ISBA_SA2                *((volatile unsigned char*)(0x4271E208UL))
#define bFM_MFS15_I2C_ISBA_SA3                *((volatile unsigned char*)(0x4271E20CUL))
#define bFM_MFS15_I2C_ISBA_SA4                *((volatile unsigned char*)(0x4271E210UL))
#define bFM_MFS15_I2C_ISBA_SA5                *((volatile unsigned char*)(0x4271E214UL))
#define bFM_MFS15_I2C_ISBA_SA6                *((volatile unsigned char*)(0x4271E218UL))
#define bFM_MFS15_I2C_ISBA_SAEN               *((volatile unsigned char*)(0x4271E21CUL))
#define bFM_MFS15_I2C_ISMK_SM0                *((volatile unsigned char*)(0x4271E220UL))
#define bFM_MFS15_I2C_ISMK_SM1                *((volatile unsigned char*)(0x4271E224UL))
#define bFM_MFS15_I2C_ISMK_SM2                *((volatile unsigned char*)(0x4271E228UL))
#define bFM_MFS15_I2C_ISMK_SM3                *((volatile unsigned char*)(0x4271E22CUL))
#define bFM_MFS15_I2C_ISMK_SM4                *((volatile unsigned char*)(0x4271E230UL))
#define bFM_MFS15_I2C_ISMK_SM5                *((volatile unsigned char*)(0x4271E234UL))
#define bFM_MFS15_I2C_ISMK_SM6                *((volatile unsigned char*)(0x4271E238UL))
#define bFM_MFS15_I2C_ISMK_EN                 *((volatile unsigned char*)(0x4271E23CUL))
#define bFM_MFS15_I2C_FCR_FE1                 *((volatile unsigned char*)(0x4271E280UL))
#define bFM_MFS15_I2C_FCR_FE2                 *((volatile unsigned char*)(0x4271E284UL))
#define bFM_MFS15_I2C_FCR_FCL1                *((volatile unsigned char*)(0x4271E288UL))
#define bFM_MFS15_I2C_FCR_FCL2                *((volatile unsigned char*)(0x4271E28CUL))
#define bFM_MFS15_I2C_FCR_FSET                *((volatile unsigned char*)(0x4271E290UL))
#define bFM_MFS15_I2C_FCR_FLD                 *((volatile unsigned char*)(0x4271E294UL))
#define bFM_MFS15_I2C_FCR_FLST                *((volatile unsigned char*)(0x4271E298UL))
#define bFM_MFS15_I2C_FCR_FSEL                *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM_MFS15_I2C_FCR_FTIE                *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM_MFS15_I2C_FCR_FDRQ                *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM_MFS15_I2C_FCR_FRIIE               *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM_MFS15_I2C_FCR_FLSTE               *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM_MFS15_I2C_FCR0_FE1                *((volatile unsigned char*)(0x4271E280UL))
#define bFM_MFS15_I2C_FCR0_FE2                *((volatile unsigned char*)(0x4271E284UL))
#define bFM_MFS15_I2C_FCR0_FCL1               *((volatile unsigned char*)(0x4271E288UL))
#define bFM_MFS15_I2C_FCR0_FCL2               *((volatile unsigned char*)(0x4271E28CUL))
#define bFM_MFS15_I2C_FCR0_FSET               *((volatile unsigned char*)(0x4271E290UL))
#define bFM_MFS15_I2C_FCR0_FLD                *((volatile unsigned char*)(0x4271E294UL))
#define bFM_MFS15_I2C_FCR0_FLST               *((volatile unsigned char*)(0x4271E298UL))
#define bFM_MFS15_I2C_FCR1_FSEL               *((volatile unsigned char*)(0x4271E2A0UL))
#define bFM_MFS15_I2C_FCR1_FTIE               *((volatile unsigned char*)(0x4271E2A4UL))
#define bFM_MFS15_I2C_FCR1_FDRQ               *((volatile unsigned char*)(0x4271E2A8UL))
#define bFM_MFS15_I2C_FCR1_FRIIE              *((volatile unsigned char*)(0x4271E2ACUL))
#define bFM_MFS15_I2C_FCR1_FLSTE              *((volatile unsigned char*)(0x4271E2B0UL))
#define bFM_MFS15_I2C_FBYTE_FD0               *((volatile unsigned char*)(0x4271E300UL))
#define bFM_MFS15_I2C_FBYTE_FD1               *((volatile unsigned char*)(0x4271E304UL))
#define bFM_MFS15_I2C_FBYTE_FD2               *((volatile unsigned char*)(0x4271E308UL))
#define bFM_MFS15_I2C_FBYTE_FD3               *((volatile unsigned char*)(0x4271E30CUL))
#define bFM_MFS15_I2C_FBYTE_FD4               *((volatile unsigned char*)(0x4271E310UL))
#define bFM_MFS15_I2C_FBYTE_FD5               *((volatile unsigned char*)(0x4271E314UL))
#define bFM_MFS15_I2C_FBYTE_FD6               *((volatile unsigned char*)(0x4271E318UL))
#define bFM_MFS15_I2C_FBYTE_FD7               *((volatile unsigned char*)(0x4271E31CUL))
#define bFM_MFS15_I2C_FBYTE_FD8               *((volatile unsigned char*)(0x4271E320UL))
#define bFM_MFS15_I2C_FBYTE_FD9               *((volatile unsigned char*)(0x4271E324UL))
#define bFM_MFS15_I2C_FBYTE_FD10              *((volatile unsigned char*)(0x4271E328UL))
#define bFM_MFS15_I2C_FBYTE_FD11              *((volatile unsigned char*)(0x4271E32CUL))
#define bFM_MFS15_I2C_FBYTE_FD12              *((volatile unsigned char*)(0x4271E330UL))
#define bFM_MFS15_I2C_FBYTE_FD13              *((volatile unsigned char*)(0x4271E334UL))
#define bFM_MFS15_I2C_FBYTE_FD14              *((volatile unsigned char*)(0x4271E338UL))
#define bFM_MFS15_I2C_FBYTE_FD15              *((volatile unsigned char*)(0x4271E33CUL))
#define bFM_MFS15_I2C_FBYTE1_FD0              *((volatile unsigned char*)(0x4271E300UL))
#define bFM_MFS15_I2C_FBYTE1_FD1              *((volatile unsigned char*)(0x4271E304UL))
#define bFM_MFS15_I2C_FBYTE1_FD2              *((volatile unsigned char*)(0x4271E308UL))
#define bFM_MFS15_I2C_FBYTE1_FD3              *((volatile unsigned char*)(0x4271E30CUL))
#define bFM_MFS15_I2C_FBYTE1_FD4              *((volatile unsigned char*)(0x4271E310UL))
#define bFM_MFS15_I2C_FBYTE1_FD5              *((volatile unsigned char*)(0x4271E314UL))
#define bFM_MFS15_I2C_FBYTE1_FD6              *((volatile unsigned char*)(0x4271E318UL))
#define bFM_MFS15_I2C_FBYTE1_FD7              *((volatile unsigned char*)(0x4271E31CUL))
#define bFM_MFS15_I2C_FBYTE2_FD8              *((volatile unsigned char*)(0x4271E320UL))
#define bFM_MFS15_I2C_FBYTE2_FD9              *((volatile unsigned char*)(0x4271E324UL))
#define bFM_MFS15_I2C_FBYTE2_FD10             *((volatile unsigned char*)(0x4271E328UL))
#define bFM_MFS15_I2C_FBYTE2_FD11             *((volatile unsigned char*)(0x4271E32CUL))
#define bFM_MFS15_I2C_FBYTE2_FD12             *((volatile unsigned char*)(0x4271E330UL))
#define bFM_MFS15_I2C_FBYTE2_FD13             *((volatile unsigned char*)(0x4271E334UL))
#define bFM_MFS15_I2C_FBYTE2_FD14             *((volatile unsigned char*)(0x4271E338UL))
#define bFM_MFS15_I2C_FBYTE2_FD15             *((volatile unsigned char*)(0x4271E33CUL))

/* CRC registers */
#define bFM_CRC_CRCCR_INIT                    *((volatile unsigned char*)(0x42720000UL))
#define bFM_CRC_CRCCR_CRC32                   *((volatile unsigned char*)(0x42720004UL))
#define bFM_CRC_CRCCR_LTLEND                  *((volatile unsigned char*)(0x42720008UL))
#define bFM_CRC_CRCCR_LSBFST                  *((volatile unsigned char*)(0x4272000CUL))
#define bFM_CRC_CRCCR_CRCLTE                  *((volatile unsigned char*)(0x42720010UL))
#define bFM_CRC_CRCCR_CRCLSF                  *((volatile unsigned char*)(0x42720014UL))
#define bFM_CRC_CRCCR_FXOR                    *((volatile unsigned char*)(0x42720018UL))

/* Watch counter registers */
#define bFM_WC_WCRD_CTR0                      *((volatile unsigned char*)(0x42740000UL))
#define bFM_WC_WCRD_CTR1                      *((volatile unsigned char*)(0x42740004UL))
#define bFM_WC_WCRD_CTR2                      *((volatile unsigned char*)(0x42740008UL))
#define bFM_WC_WCRD_CTR3                      *((volatile unsigned char*)(0x4274000CUL))
#define bFM_WC_WCRD_CTR4                      *((volatile unsigned char*)(0x42740010UL))
#define bFM_WC_WCRD_CTR5                      *((volatile unsigned char*)(0x42740014UL))
#define bFM_WC_WCRL_RLC0                      *((volatile unsigned char*)(0x42740020UL))
#define bFM_WC_WCRL_RLC1                      *((volatile unsigned char*)(0x42740024UL))
#define bFM_WC_WCRL_RLC2                      *((volatile unsigned char*)(0x42740028UL))
#define bFM_WC_WCRL_RLC3                      *((volatile unsigned char*)(0x4274002CUL))
#define bFM_WC_WCRL_RLC4                      *((volatile unsigned char*)(0x42740030UL))
#define bFM_WC_WCRL_RLC5                      *((volatile unsigned char*)(0x42740034UL))
#define bFM_WC_WCCR_WCIF                      *((volatile unsigned char*)(0x42740040UL))
#define bFM_WC_WCCR_WCIE                      *((volatile unsigned char*)(0x42740044UL))
#define bFM_WC_WCCR_CS0                       *((volatile unsigned char*)(0x42740048UL))
#define bFM_WC_WCCR_CS1                       *((volatile unsigned char*)(0x4274004CUL))
#define bFM_WC_WCCR_WCOP                      *((volatile unsigned char*)(0x42740058UL))
#define bFM_WC_WCCR_WCEN                      *((volatile unsigned char*)(0x4274005CUL))
#define bFM_WC_CLK_SEL_SEL_IN                 *((volatile unsigned char*)(0x42740200UL))
#define bFM_WC_CLK_SEL_SEL_OUT                *((volatile unsigned char*)(0x42740220UL))
#define bFM_WC_CLK_EN_CLK_EN                  *((volatile unsigned char*)(0x42740280UL))
#define bFM_WC_CLK_EN_CLK_EN_R                *((volatile unsigned char*)(0x42740284UL))

/* Real time clock registers */
#define bFM_RTC_WTCR10_ST                     *((volatile unsigned char*)(0x42762000UL))
#define bFM_RTC_WTCR10_RUN                    *((volatile unsigned char*)(0x42762008UL))
#define bFM_RTC_WTCR10_SRST                   *((volatile unsigned char*)(0x4276200CUL))
#define bFM_RTC_WTCR10_SCST                   *((volatile unsigned char*)(0x42762010UL))
#define bFM_RTC_WTCR10_SCRST                  *((volatile unsigned char*)(0x42762014UL))
#define bFM_RTC_WTCR10_BUSY                   *((volatile unsigned char*)(0x42762018UL))
#define bFM_RTC_WTCR10_TRANS                  *((volatile unsigned char*)(0x4276201CUL))
#define bFM_RTC_WTCR11_MIEN                   *((volatile unsigned char*)(0x42762080UL))
#define bFM_RTC_WTCR11_HEN                    *((volatile unsigned char*)(0x42762084UL))
#define bFM_RTC_WTCR11_DEN                    *((volatile unsigned char*)(0x42762088UL))
#define bFM_RTC_WTCR11_MOEN                   *((volatile unsigned char*)(0x4276208CUL))
#define bFM_RTC_WTCR11_YEN                    *((volatile unsigned char*)(0x42762090UL))
#define bFM_RTC_WTCR12_INTSSI                 *((volatile unsigned char*)(0x42762100UL))
#define bFM_RTC_WTCR12_INTSI                  *((volatile unsigned char*)(0x42762104UL))
#define bFM_RTC_WTCR12_INTMI                  *((volatile unsigned char*)(0x42762108UL))
#define bFM_RTC_WTCR12_INTHI                  *((volatile unsigned char*)(0x4276210CUL))
#define bFM_RTC_WTCR12_INTTMI                 *((volatile unsigned char*)(0x42762110UL))
#define bFM_RTC_WTCR12_INTALI                 *((volatile unsigned char*)(0x42762114UL))
#define bFM_RTC_WTCR12_INTERI                 *((volatile unsigned char*)(0x42762118UL))
#define bFM_RTC_WTCR12_INTCRI                 *((volatile unsigned char*)(0x4276211CUL))
#define bFM_RTC_WTCR13_INTSSIE                *((volatile unsigned char*)(0x42762180UL))
#define bFM_RTC_WTCR13_INTSIE                 *((volatile unsigned char*)(0x42762184UL))
#define bFM_RTC_WTCR13_INTMIE                 *((volatile unsigned char*)(0x42762188UL))
#define bFM_RTC_WTCR13_INTHIE                 *((volatile unsigned char*)(0x4276218CUL))
#define bFM_RTC_WTCR13_INTTMIE                *((volatile unsigned char*)(0x42762190UL))
#define bFM_RTC_WTCR13_INTALIE                *((volatile unsigned char*)(0x42762194UL))
#define bFM_RTC_WTCR13_INTERIE                *((volatile unsigned char*)(0x42762198UL))
#define bFM_RTC_WTCR13_INTCRIE                *((volatile unsigned char*)(0x4276219CUL))
#define bFM_RTC_WTCR20_CREAD                  *((volatile unsigned char*)(0x42762200UL))
#define bFM_RTC_WTCR20_CWRITE                 *((volatile unsigned char*)(0x42762204UL))
#define bFM_RTC_WTCR20_BREAD                  *((volatile unsigned char*)(0x42762208UL))
#define bFM_RTC_WTCR20_BWRITE                 *((volatile unsigned char*)(0x4276220CUL))
#define bFM_RTC_WTCR20_PREAD                  *((volatile unsigned char*)(0x42762210UL))
#define bFM_RTC_WTCR20_PWRITE                 *((volatile unsigned char*)(0x42762214UL))
#define bFM_RTC_WTCR21_TMST                   *((volatile unsigned char*)(0x42762280UL))
#define bFM_RTC_WTCR21_TMEN                   *((volatile unsigned char*)(0x42762284UL))
#define bFM_RTC_WTCR21_TMRUN                  *((volatile unsigned char*)(0x42762288UL))
#define bFM_RTC_WTSR_S0                       *((volatile unsigned char*)(0x42762380UL))
#define bFM_RTC_WTSR_S1                       *((volatile unsigned char*)(0x42762384UL))
#define bFM_RTC_WTSR_S2                       *((volatile unsigned char*)(0x42762388UL))
#define bFM_RTC_WTSR_S3                       *((volatile unsigned char*)(0x4276238CUL))
#define bFM_RTC_WTSR_TS0                      *((volatile unsigned char*)(0x42762390UL))
#define bFM_RTC_WTSR_TS1                      *((volatile unsigned char*)(0x42762394UL))
#define bFM_RTC_WTSR_TS2                      *((volatile unsigned char*)(0x42762398UL))
#define bFM_RTC_WTMIR_MI0                     *((volatile unsigned char*)(0x42762400UL))
#define bFM_RTC_WTMIR_MI1                     *((volatile unsigned char*)(0x42762404UL))
#define bFM_RTC_WTMIR_MI2                     *((volatile unsigned char*)(0x42762408UL))
#define bFM_RTC_WTMIR_MI3                     *((volatile unsigned char*)(0x4276240CUL))
#define bFM_RTC_WTMIR_TMI0                    *((volatile unsigned char*)(0x42762410UL))
#define bFM_RTC_WTMIR_TMI1                    *((volatile unsigned char*)(0x42762414UL))
#define bFM_RTC_WTMIR_TMI2                    *((volatile unsigned char*)(0x42762418UL))
#define bFM_RTC_WTHR_H0                       *((volatile unsigned char*)(0x42762480UL))
#define bFM_RTC_WTHR_H1                       *((volatile unsigned char*)(0x42762484UL))
#define bFM_RTC_WTHR_H2                       *((volatile unsigned char*)(0x42762488UL))
#define bFM_RTC_WTHR_H3                       *((volatile unsigned char*)(0x4276248CUL))
#define bFM_RTC_WTHR_TH0                      *((volatile unsigned char*)(0x42762490UL))
#define bFM_RTC_WTHR_TH1                      *((volatile unsigned char*)(0x42762494UL))
#define bFM_RTC_WTDR_D0                       *((volatile unsigned char*)(0x42762500UL))
#define bFM_RTC_WTDR_D1                       *((volatile unsigned char*)(0x42762504UL))
#define bFM_RTC_WTDR_D2                       *((volatile unsigned char*)(0x42762508UL))
#define bFM_RTC_WTDR_D3                       *((volatile unsigned char*)(0x4276250CUL))
#define bFM_RTC_WTDR_TD0                      *((volatile unsigned char*)(0x42762510UL))
#define bFM_RTC_WTDR_TD1                      *((volatile unsigned char*)(0x42762514UL))
#define bFM_RTC_WTDW_DW0                      *((volatile unsigned char*)(0x42762580UL))
#define bFM_RTC_WTDW_DW1                      *((volatile unsigned char*)(0x42762584UL))
#define bFM_RTC_WTDW_DW2                      *((volatile unsigned char*)(0x42762588UL))
#define bFM_RTC_WTMOR_MO0                     *((volatile unsigned char*)(0x42762600UL))
#define bFM_RTC_WTMOR_MO1                     *((volatile unsigned char*)(0x42762604UL))
#define bFM_RTC_WTMOR_MO2                     *((volatile unsigned char*)(0x42762608UL))
#define bFM_RTC_WTMOR_MO3                     *((volatile unsigned char*)(0x4276260CUL))
#define bFM_RTC_WTMOR_TMO                     *((volatile unsigned char*)(0x42762610UL))
#define bFM_RTC_WTYR_Y0                       *((volatile unsigned char*)(0x42762680UL))
#define bFM_RTC_WTYR_Y1                       *((volatile unsigned char*)(0x42762684UL))
#define bFM_RTC_WTYR_Y2                       *((volatile unsigned char*)(0x42762688UL))
#define bFM_RTC_WTYR_Y3                       *((volatile unsigned char*)(0x4276268CUL))
#define bFM_RTC_WTYR_TY0                      *((volatile unsigned char*)(0x42762690UL))
#define bFM_RTC_WTYR_TY1                      *((volatile unsigned char*)(0x42762694UL))
#define bFM_RTC_WTYR_TY2                      *((volatile unsigned char*)(0x42762698UL))
#define bFM_RTC_WTYR_TY3                      *((volatile unsigned char*)(0x4276269CUL))
#define bFM_RTC_ALMIR_AMI0                    *((volatile unsigned char*)(0x42762700UL))
#define bFM_RTC_ALMIR_AMI1                    *((volatile unsigned char*)(0x42762704UL))
#define bFM_RTC_ALMIR_AMI2                    *((volatile unsigned char*)(0x42762708UL))
#define bFM_RTC_ALMIR_AMI3                    *((volatile unsigned char*)(0x4276270CUL))
#define bFM_RTC_ALMIR_TAMI0                   *((volatile unsigned char*)(0x42762710UL))
#define bFM_RTC_ALMIR_TAMI1                   *((volatile unsigned char*)(0x42762714UL))
#define bFM_RTC_ALMIR_TAMI2                   *((volatile unsigned char*)(0x42762718UL))
#define bFM_RTC_ALHR_AH0                      *((volatile unsigned char*)(0x42762780UL))
#define bFM_RTC_ALHR_AH1                      *((volatile unsigned char*)(0x42762784UL))
#define bFM_RTC_ALHR_AH2                      *((volatile unsigned char*)(0x42762788UL))
#define bFM_RTC_ALHR_AH3                      *((volatile unsigned char*)(0x4276278CUL))
#define bFM_RTC_ALHR_TAH0                     *((volatile unsigned char*)(0x42762790UL))
#define bFM_RTC_ALHR_TAH1                     *((volatile unsigned char*)(0x42762794UL))
#define bFM_RTC_ALDR_AD0                      *((volatile unsigned char*)(0x42762800UL))
#define bFM_RTC_ALDR_AD1                      *((volatile unsigned char*)(0x42762804UL))
#define bFM_RTC_ALDR_AD2                      *((volatile unsigned char*)(0x42762808UL))
#define bFM_RTC_ALDR_AD3                      *((volatile unsigned char*)(0x4276280CUL))
#define bFM_RTC_ALDR_TAD0                     *((volatile unsigned char*)(0x42762810UL))
#define bFM_RTC_ALDR_TAD1                     *((volatile unsigned char*)(0x42762814UL))
#define bFM_RTC_ALMOR_AMO0                    *((volatile unsigned char*)(0x42762880UL))
#define bFM_RTC_ALMOR_AMO1                    *((volatile unsigned char*)(0x42762884UL))
#define bFM_RTC_ALMOR_AMO2                    *((volatile unsigned char*)(0x42762888UL))
#define bFM_RTC_ALMOR_AMO3                    *((volatile unsigned char*)(0x4276288CUL))
#define bFM_RTC_ALMOR_TAMO                    *((volatile unsigned char*)(0x42762890UL))
#define bFM_RTC_ALYR_AY0                      *((volatile unsigned char*)(0x42762900UL))
#define bFM_RTC_ALYR_AY1                      *((volatile unsigned char*)(0x42762904UL))
#define bFM_RTC_ALYR_AY2                      *((volatile unsigned char*)(0x42762908UL))
#define bFM_RTC_ALYR_AY3                      *((volatile unsigned char*)(0x4276290CUL))
#define bFM_RTC_ALYR_TAY0                     *((volatile unsigned char*)(0x42762910UL))
#define bFM_RTC_ALYR_TAY1                     *((volatile unsigned char*)(0x42762914UL))
#define bFM_RTC_ALYR_TAY2                     *((volatile unsigned char*)(0x42762918UL))
#define bFM_RTC_ALYR_TAY3                     *((volatile unsigned char*)(0x4276291CUL))
#define bFM_RTC_WTTR0_TM0                     *((volatile unsigned char*)(0x42762980UL))
#define bFM_RTC_WTTR0_TM1                     *((volatile unsigned char*)(0x42762984UL))
#define bFM_RTC_WTTR0_TM2                     *((volatile unsigned char*)(0x42762988UL))
#define bFM_RTC_WTTR0_TM3                     *((volatile unsigned char*)(0x4276298CUL))
#define bFM_RTC_WTTR0_TM4                     *((volatile unsigned char*)(0x42762990UL))
#define bFM_RTC_WTTR0_TM5                     *((volatile unsigned char*)(0x42762994UL))
#define bFM_RTC_WTTR0_TM6                     *((volatile unsigned char*)(0x42762998UL))
#define bFM_RTC_WTTR0_TM7                     *((volatile unsigned char*)(0x4276299CUL))
#define bFM_RTC_WTTR1_TM8                     *((volatile unsigned char*)(0x42762A00UL))
#define bFM_RTC_WTTR1_TM9                     *((volatile unsigned char*)(0x42762A04UL))
#define bFM_RTC_WTTR1_TM10                    *((volatile unsigned char*)(0x42762A08UL))
#define bFM_RTC_WTTR1_TM11                    *((volatile unsigned char*)(0x42762A0CUL))
#define bFM_RTC_WTTR1_TM12                    *((volatile unsigned char*)(0x42762A10UL))
#define bFM_RTC_WTTR1_TM13                    *((volatile unsigned char*)(0x42762A14UL))
#define bFM_RTC_WTTR1_TM14                    *((volatile unsigned char*)(0x42762A18UL))
#define bFM_RTC_WTTR1_TM15                    *((volatile unsigned char*)(0x42762A1CUL))
#define bFM_RTC_WTTR2_TM16                    *((volatile unsigned char*)(0x42762A80UL))
#define bFM_RTC_WTTR2_TM17                    *((volatile unsigned char*)(0x42762A84UL))
#define bFM_RTC_WTCAL1_WTCAL10                *((volatile unsigned char*)(0x42762B80UL))
#define bFM_RTC_WTCAL1_WTCAL11                *((volatile unsigned char*)(0x42762B84UL))
#define bFM_RTC_WTCALEN_WTCALEN               *((volatile unsigned char*)(0x42762C00UL))
#define bFM_RTC_WTDIV_WTDIV0                  *((volatile unsigned char*)(0x42762C80UL))
#define bFM_RTC_WTDIV_WTDIV1                  *((volatile unsigned char*)(0x42762C84UL))
#define bFM_RTC_WTDIV_WTDIV2                  *((volatile unsigned char*)(0x42762C88UL))
#define bFM_RTC_WTDIV_WTDIV3                  *((volatile unsigned char*)(0x42762C8CUL))
#define bFM_RTC_WTDIVEN_WTDIVEN               *((volatile unsigned char*)(0x42762D00UL))
#define bFM_RTC_WTDIVEN_WTDIVRDY              *((volatile unsigned char*)(0x42762D04UL))
#define bFM_RTC_WTCALPRD_WTCALPRD0            *((volatile unsigned char*)(0x42762D80UL))
#define bFM_RTC_WTCALPRD_WTCALPRD1            *((volatile unsigned char*)(0x42762D84UL))
#define bFM_RTC_WTCALPRD_WTCALPRD2            *((volatile unsigned char*)(0x42762D88UL))
#define bFM_RTC_WTCALPRD_WTCALPRD3            *((volatile unsigned char*)(0x42762D8CUL))
#define bFM_RTC_WTCALPRD_WTCALPRD4            *((volatile unsigned char*)(0x42762D90UL))
#define bFM_RTC_WTCALPRD_WTCALPRD5            *((volatile unsigned char*)(0x42762D94UL))
#define bFM_RTC_WTCOSEL_WTCOSEL               *((volatile unsigned char*)(0x42762E00UL))
#define bFM_RTC_VB_CLKDIV_DIV0                *((volatile unsigned char*)(0x42762E80UL))
#define bFM_RTC_VB_CLKDIV_DIV1                *((volatile unsigned char*)(0x42762E84UL))
#define bFM_RTC_VB_CLKDIV_DIV2                *((volatile unsigned char*)(0x42762E88UL))
#define bFM_RTC_VB_CLKDIV_DIV3                *((volatile unsigned char*)(0x42762E8CUL))
#define bFM_RTC_VB_CLKDIV_DIV4                *((volatile unsigned char*)(0x42762E90UL))
#define bFM_RTC_VB_CLKDIV_DIV5                *((volatile unsigned char*)(0x42762E94UL))
#define bFM_RTC_VB_CLKDIV_DIV6                *((volatile unsigned char*)(0x42762E98UL))
#define bFM_RTC_VB_CLKDIV_DIV7                *((volatile unsigned char*)(0x42762E9CUL))
#define bFM_RTC_WTOSCCNT_SOSCEX               *((volatile unsigned char*)(0x42762F00UL))
#define bFM_RTC_WTOSCCNT_SOSCNTL              *((volatile unsigned char*)(0x42762F04UL))
#define bFM_RTC_BOOST_BOOST0                  *((volatile unsigned char*)(0x42763100UL))
#define bFM_RTC_BOOST_BOOST1                  *((volatile unsigned char*)(0x42763104UL))
#define bFM_RTC_EWKUP_WUP0                    *((volatile unsigned char*)(0x42763180UL))
#define bFM_RTC_VDET_PON                      *((volatile unsigned char*)(0x4276321CUL))
#define bFM_RTC_HIBRST_HIBRST                 *((volatile unsigned char*)(0x42763300UL))
#define bFM_RTC_VBPFR_VPFR0                   *((volatile unsigned char*)(0x42763380UL))
#define bFM_RTC_VBPFR_VPFR1                   *((volatile unsigned char*)(0x42763384UL))
#define bFM_RTC_VBPFR_VPFR2                   *((volatile unsigned char*)(0x42763388UL))
#define bFM_RTC_VBPFR_VPFR3                   *((volatile unsigned char*)(0x4276338CUL))
#define bFM_RTC_VBPFR_SPSR0                   *((volatile unsigned char*)(0x42763390UL))
#define bFM_RTC_VBPFR_SPSR1                   *((volatile unsigned char*)(0x42763394UL))
#define bFM_RTC_VBPCR_VPCR0                   *((volatile unsigned char*)(0x42763400UL))
#define bFM_RTC_VBPCR_VPCR1                   *((volatile unsigned char*)(0x42763404UL))
#define bFM_RTC_VBPCR_VPCR2                   *((volatile unsigned char*)(0x42763408UL))
#define bFM_RTC_VBPCR_VPCR3                   *((volatile unsigned char*)(0x4276340CUL))
#define bFM_RTC_VBDDR_VDDR0                   *((volatile unsigned char*)(0x42763480UL))
#define bFM_RTC_VBDDR_VDDR1                   *((volatile unsigned char*)(0x42763484UL))
#define bFM_RTC_VBDDR_VDDR2                   *((volatile unsigned char*)(0x42763488UL))
#define bFM_RTC_VBDDR_VDDR3                   *((volatile unsigned char*)(0x4276348CUL))
#define bFM_RTC_VBDIR_VDIR0                   *((volatile unsigned char*)(0x42763500UL))
#define bFM_RTC_VBDIR_VDIR1                   *((volatile unsigned char*)(0x42763504UL))
#define bFM_RTC_VBDIR_VDIR2                   *((volatile unsigned char*)(0x42763508UL))
#define bFM_RTC_VBDIR_VDIR3                   *((volatile unsigned char*)(0x4276350CUL))
#define bFM_RTC_VBDOR_VDOR0                   *((volatile unsigned char*)(0x42763580UL))
#define bFM_RTC_VBDOR_VDOR1                   *((volatile unsigned char*)(0x42763584UL))
#define bFM_RTC_VBDOR_VDOR2                   *((volatile unsigned char*)(0x42763588UL))
#define bFM_RTC_VBDOR_VDOR3                   *((volatile unsigned char*)(0x4276358CUL))
#define bFM_RTC_VBPZR_VPZR0                   *((volatile unsigned char*)(0x42763600UL))
#define bFM_RTC_VBPZR_VPZR1                   *((volatile unsigned char*)(0x42763604UL))

/* Low-speed CR prescaler registers */
#define bFM_LCR_LCR_PRSLD_LCR_PRSLD0          *((volatile unsigned char*)(0x42780000UL))
#define bFM_LCR_LCR_PRSLD_LCR_PRSLD1          *((volatile unsigned char*)(0x42780004UL))
#define bFM_LCR_LCR_PRSLD_LCR_PRSLD2          *((volatile unsigned char*)(0x42780008UL))
#define bFM_LCR_LCR_PRSLD_LCR_PRSLD3          *((volatile unsigned char*)(0x4278000CUL))
#define bFM_LCR_LCR_PRSLD_LCR_PRSLD4          *((volatile unsigned char*)(0x42780010UL))
#define bFM_LCR_LCR_PRSLD_LCR_PRSLD5          *((volatile unsigned char*)(0x42780014UL))

/* Peripheral Clock Gating registers */
#define bFM_CLK_GATING_CKEN0_MFSCK0           *((volatile unsigned char*)(0x42782000UL))
#define bFM_CLK_GATING_CKEN0_MFSCK1           *((volatile unsigned char*)(0x42782004UL))
#define bFM_CLK_GATING_CKEN0_MFSCK2           *((volatile unsigned char*)(0x42782008UL))
#define bFM_CLK_GATING_CKEN0_MFSCK3           *((volatile unsigned char*)(0x4278200CUL))
#define bFM_CLK_GATING_CKEN0_MFSCK4           *((volatile unsigned char*)(0x42782010UL))
#define bFM_CLK_GATING_CKEN0_MFSCK5           *((volatile unsigned char*)(0x42782014UL))
#define bFM_CLK_GATING_CKEN0_MFSCK6           *((volatile unsigned char*)(0x42782018UL))
#define bFM_CLK_GATING_CKEN0_MFSCK7           *((volatile unsigned char*)(0x4278201CUL))
#define bFM_CLK_GATING_CKEN0_MFSCK8           *((volatile unsigned char*)(0x42782020UL))
#define bFM_CLK_GATING_CKEN0_MFSCK9           *((volatile unsigned char*)(0x42782024UL))
#define bFM_CLK_GATING_CKEN0_MFSCK10          *((volatile unsigned char*)(0x42782028UL))
#define bFM_CLK_GATING_CKEN0_MFSCK11          *((volatile unsigned char*)(0x4278202CUL))
#define bFM_CLK_GATING_CKEN0_MFSCK12          *((volatile unsigned char*)(0x42782030UL))
#define bFM_CLK_GATING_CKEN0_MFSCK13          *((volatile unsigned char*)(0x42782034UL))
#define bFM_CLK_GATING_CKEN0_MFSCK14          *((volatile unsigned char*)(0x42782038UL))
#define bFM_CLK_GATING_CKEN0_MFSCK15          *((volatile unsigned char*)(0x4278203CUL))
#define bFM_CLK_GATING_CKEN0_ADCCK0           *((volatile unsigned char*)(0x42782040UL))
#define bFM_CLK_GATING_CKEN0_ADCCK1           *((volatile unsigned char*)(0x42782044UL))
#define bFM_CLK_GATING_CKEN0_ADCCK2           *((volatile unsigned char*)(0x42782048UL))
#define bFM_CLK_GATING_CKEN0_ADCCK3           *((volatile unsigned char*)(0x4278204CUL))
#define bFM_CLK_GATING_CKEN0_DMACK            *((volatile unsigned char*)(0x42782060UL))
#define bFM_CLK_GATING_CKEN0_EXBCK            *((volatile unsigned char*)(0x42782068UL))
#define bFM_CLK_GATING_CKEN0_GIOCK            *((volatile unsigned char*)(0x42782070UL))
#define bFM_CLK_GATING_MRST0_MFSRST0          *((volatile unsigned char*)(0x42782080UL))
#define bFM_CLK_GATING_MRST0_MFSRST1          *((volatile unsigned char*)(0x42782084UL))
#define bFM_CLK_GATING_MRST0_MFSRST2          *((volatile unsigned char*)(0x42782088UL))
#define bFM_CLK_GATING_MRST0_MFSRST3          *((volatile unsigned char*)(0x4278208CUL))
#define bFM_CLK_GATING_MRST0_MFSRST4          *((volatile unsigned char*)(0x42782090UL))
#define bFM_CLK_GATING_MRST0_MFSRST5          *((volatile unsigned char*)(0x42782094UL))
#define bFM_CLK_GATING_MRST0_MFSRST6          *((volatile unsigned char*)(0x42782098UL))
#define bFM_CLK_GATING_MRST0_MFSRST7          *((volatile unsigned char*)(0x4278209CUL))
#define bFM_CLK_GATING_MRST0_MFSRST8          *((volatile unsigned char*)(0x427820A0UL))
#define bFM_CLK_GATING_MRST0_MFSRST9          *((volatile unsigned char*)(0x427820A4UL))
#define bFM_CLK_GATING_MRST0_MFSRST10         *((volatile unsigned char*)(0x427820A8UL))
#define bFM_CLK_GATING_MRST0_MFSRST11         *((volatile unsigned char*)(0x427820ACUL))
#define bFM_CLK_GATING_MRST0_MFSRST12         *((volatile unsigned char*)(0x427820B0UL))
#define bFM_CLK_GATING_MRST0_MFSRST13         *((volatile unsigned char*)(0x427820B4UL))
#define bFM_CLK_GATING_MRST0_MFSRST14         *((volatile unsigned char*)(0x427820B8UL))
#define bFM_CLK_GATING_MRST0_MFSRST15         *((volatile unsigned char*)(0x427820BCUL))
#define bFM_CLK_GATING_MRST0_ADCRST0          *((volatile unsigned char*)(0x427820C0UL))
#define bFM_CLK_GATING_MRST0_ADCRST1          *((volatile unsigned char*)(0x427820C4UL))
#define bFM_CLK_GATING_MRST0_ADCRST2          *((volatile unsigned char*)(0x427820C8UL))
#define bFM_CLK_GATING_MRST0_ADCRST3          *((volatile unsigned char*)(0x427820CCUL))
#define bFM_CLK_GATING_MRST0_DMARST           *((volatile unsigned char*)(0x427820E0UL))
#define bFM_CLK_GATING_MRST0_EXBRST           *((volatile unsigned char*)(0x427820E8UL))
#define bFM_CLK_GATING_CKEN1_BTMCK0           *((volatile unsigned char*)(0x42782200UL))
#define bFM_CLK_GATING_CKEN1_BTMCK1           *((volatile unsigned char*)(0x42782204UL))
#define bFM_CLK_GATING_CKEN1_BTMCK2           *((volatile unsigned char*)(0x42782208UL))
#define bFM_CLK_GATING_CKEN1_BTMCK3           *((volatile unsigned char*)(0x4278220CUL))
#define bFM_CLK_GATING_CKEN1_MFTCK0           *((volatile unsigned char*)(0x42782220UL))
#define bFM_CLK_GATING_CKEN1_MFTCK1           *((volatile unsigned char*)(0x42782224UL))
#define bFM_CLK_GATING_CKEN1_MFTCK2           *((volatile unsigned char*)(0x42782228UL))
#define bFM_CLK_GATING_CKEN1_MFTCK3           *((volatile unsigned char*)(0x4278222CUL))
#define bFM_CLK_GATING_CKEN1_QDUCK0           *((volatile unsigned char*)(0x42782240UL))
#define bFM_CLK_GATING_CKEN1_QDUCK1           *((volatile unsigned char*)(0x42782244UL))
#define bFM_CLK_GATING_CKEN1_QDUCK2           *((volatile unsigned char*)(0x42782248UL))
#define bFM_CLK_GATING_CKEN1_QDUCK3           *((volatile unsigned char*)(0x4278224CUL))
#define bFM_CLK_GATING_MRST1_BTMRST0          *((volatile unsigned char*)(0x42782280UL))
#define bFM_CLK_GATING_MRST1_BTMRST1          *((volatile unsigned char*)(0x42782284UL))
#define bFM_CLK_GATING_MRST1_BTMRST2          *((volatile unsigned char*)(0x42782288UL))
#define bFM_CLK_GATING_MRST1_BTMRST3          *((volatile unsigned char*)(0x4278228CUL))
#define bFM_CLK_GATING_MRST1_MFTRST0          *((volatile unsigned char*)(0x427822A0UL))
#define bFM_CLK_GATING_MRST1_MFTRST1          *((volatile unsigned char*)(0x427822A4UL))
#define bFM_CLK_GATING_MRST1_MFTRST2          *((volatile unsigned char*)(0x427822A8UL))
#define bFM_CLK_GATING_MRST1_MFTRST3          *((volatile unsigned char*)(0x427822ACUL))
#define bFM_CLK_GATING_MRST1_QDURST0          *((volatile unsigned char*)(0x427822C0UL))
#define bFM_CLK_GATING_MRST1_QDURST1          *((volatile unsigned char*)(0x427822C4UL))
#define bFM_CLK_GATING_MRST1_QDURST2          *((volatile unsigned char*)(0x427822C8UL))
#define bFM_CLK_GATING_MRST1_QDURST3          *((volatile unsigned char*)(0x427822CCUL))
#define bFM_CLK_GATING_CKEN2_USBCK0           *((volatile unsigned char*)(0x42782400UL))
#define bFM_CLK_GATING_CKEN2_USBCK1           *((volatile unsigned char*)(0x42782404UL))
#define bFM_CLK_GATING_CKEN2_CANCK0           *((volatile unsigned char*)(0x42782410UL))
#define bFM_CLK_GATING_CKEN2_CANCK1           *((volatile unsigned char*)(0x42782414UL))
#define bFM_CLK_GATING_CKEN2_CANCK2           *((volatile unsigned char*)(0x42782418UL))
#define bFM_CLK_GATING_CKEN2_SDCCK            *((volatile unsigned char*)(0x42782420UL))
#define bFM_CLK_GATING_CKEN2_I2SCK0           *((volatile unsigned char*)(0x42782440UL))
#define bFM_CLK_GATING_CKEN2_I2SCK1           *((volatile unsigned char*)(0x42782444UL))
#define bFM_CLK_GATING_CKEN2_PCRCCK           *((volatile unsigned char*)(0x42782450UL))
#define bFM_CLK_GATING_CKEN2_CECCK0           *((volatile unsigned char*)(0x42782460UL))
#define bFM_CLK_GATING_CKEN2_CECCK1           *((volatile unsigned char*)(0x42782464UL))
#define bFM_CLK_GATING_CKEN2_QSPICK           *((volatile unsigned char*)(0x42782470UL))
#define bFM_CLK_GATING_MRST2_USBRST0          *((volatile unsigned char*)(0x42782480UL))
#define bFM_CLK_GATING_MRST2_USBRST1          *((volatile unsigned char*)(0x42782484UL))
#define bFM_CLK_GATING_MRST2_CANRST0          *((volatile unsigned char*)(0x42782490UL))
#define bFM_CLK_GATING_MRST2_CANRST1          *((volatile unsigned char*)(0x42782494UL))
#define bFM_CLK_GATING_MRST2_CANRST2          *((volatile unsigned char*)(0x42782498UL))
#define bFM_CLK_GATING_MRST2_SDCRST           *((volatile unsigned char*)(0x427824A0UL))
#define bFM_CLK_GATING_MRST2_I2SRST0          *((volatile unsigned char*)(0x427824C0UL))
#define bFM_CLK_GATING_MRST2_I2SRST1          *((volatile unsigned char*)(0x427824C4UL))
#define bFM_CLK_GATING_MRST2_PCRCRST          *((volatile unsigned char*)(0x427824D0UL))
#define bFM_CLK_GATING_MRST2_CECRST0          *((volatile unsigned char*)(0x427824E0UL))
#define bFM_CLK_GATING_MRST2_CECRST1          *((volatile unsigned char*)(0x427824E4UL))
#define bFM_CLK_GATING_MRST2_QSPIRST          *((volatile unsigned char*)(0x427824F0UL))

/* I2S Pre-scalor registers */
#define bFM_I2SPRE_ICCR_ICEN                  *((volatile unsigned char*)(0x427A0000UL))
#define bFM_I2SPRE_ICCR_ICSEL                 *((volatile unsigned char*)(0x427A0004UL))
#define bFM_I2SPRE_IPCR1_IPLLEN               *((volatile unsigned char*)(0x427A0080UL))
#define bFM_I2SPRE_IPCR2_IPOWT0               *((volatile unsigned char*)(0x427A0100UL))
#define bFM_I2SPRE_IPCR2_IPOWT1               *((volatile unsigned char*)(0x427A0104UL))
#define bFM_I2SPRE_IPCR2_IPOWT2               *((volatile unsigned char*)(0x427A0108UL))
#define bFM_I2SPRE_IPCR3_IPLLK0               *((volatile unsigned char*)(0x427A0180UL))
#define bFM_I2SPRE_IPCR3_IPLLK1               *((volatile unsigned char*)(0x427A0184UL))
#define bFM_I2SPRE_IPCR3_IPLLK2               *((volatile unsigned char*)(0x427A0188UL))
#define bFM_I2SPRE_IPCR3_IPLLK3               *((volatile unsigned char*)(0x427A018CUL))
#define bFM_I2SPRE_IPCR3_IPLLK4               *((volatile unsigned char*)(0x427A0190UL))
#define bFM_I2SPRE_IPCR4_IPLLN0               *((volatile unsigned char*)(0x427A0200UL))
#define bFM_I2SPRE_IPCR4_IPLLN1               *((volatile unsigned char*)(0x427A0204UL))
#define bFM_I2SPRE_IPCR4_IPLLN2               *((volatile unsigned char*)(0x427A0208UL))
#define bFM_I2SPRE_IPCR4_IPLLN3               *((volatile unsigned char*)(0x427A020CUL))
#define bFM_I2SPRE_IPCR4_IPLLN4               *((volatile unsigned char*)(0x427A0210UL))
#define bFM_I2SPRE_IPCR4_IPLLN5               *((volatile unsigned char*)(0x427A0214UL))
#define bFM_I2SPRE_IPCR4_IPLLN6               *((volatile unsigned char*)(0x427A0218UL))
#define bFM_I2SPRE_IP_STR_IPRDY               *((volatile unsigned char*)(0x427A0280UL))
#define bFM_I2SPRE_IPINT_ENR_IPCSE            *((volatile unsigned char*)(0x427A0300UL))
#define bFM_I2SPRE_IPINT_CLR_IPCSC            *((volatile unsigned char*)(0x427A0380UL))
#define bFM_I2SPRE_IPINT_STR_IPCSI            *((volatile unsigned char*)(0x427A0400UL))
#define bFM_I2SPRE_IPCR5_IPLLM0               *((volatile unsigned char*)(0x427A0480UL))
#define bFM_I2SPRE_IPCR5_IPLLM1               *((volatile unsigned char*)(0x427A0484UL))
#define bFM_I2SPRE_IPCR5_IPLLM2               *((volatile unsigned char*)(0x427A0488UL))
#define bFM_I2SPRE_IPCR5_IPLLM3               *((volatile unsigned char*)(0x427A048CUL))
#define bFM_I2SPRE_IPCR5_IPLLM4               *((volatile unsigned char*)(0x427A0490UL))
#define bFM_I2SPRE_IPCR5_IPLLM5               *((volatile unsigned char*)(0x427A0494UL))
#define bFM_I2SPRE_IPCR5_IPLLM6               *((volatile unsigned char*)(0x427A0498UL))

/* External bus interface registers */
#define bFM_EXBUS_MODE0_WDTH0                 *((volatile unsigned int*)(0x427E0000UL))
#define bFM_EXBUS_MODE0_WDTH1                 *((volatile unsigned int*)(0x427E0004UL))
#define bFM_EXBUS_MODE0_RBMON                 *((volatile unsigned int*)(0x427E0008UL))
#define bFM_EXBUS_MODE0_WEOFF                 *((volatile unsigned int*)(0x427E000CUL))
#define bFM_EXBUS_MODE0_NAND                  *((volatile unsigned int*)(0x427E0010UL))
#define bFM_EXBUS_MODE0_PAGE                  *((volatile unsigned int*)(0x427E0014UL))
#define bFM_EXBUS_MODE0_RDY                   *((volatile unsigned int*)(0x427E0018UL))
#define bFM_EXBUS_MODE0_SHRTDOUT              *((volatile unsigned int*)(0x427E001CUL))
#define bFM_EXBUS_MODE0_MPXMODE               *((volatile unsigned int*)(0x427E0020UL))
#define bFM_EXBUS_MODE0_ALEINV                *((volatile unsigned int*)(0x427E0024UL))
#define bFM_EXBUS_MODE0_MPXDOFF               *((volatile unsigned int*)(0x427E002CUL))
#define bFM_EXBUS_MODE0_MPXCSOF               *((volatile unsigned int*)(0x427E0030UL))
#define bFM_EXBUS_MODE0_MOEXEUP               *((volatile unsigned int*)(0x427E0034UL))
#define bFM_EXBUS_MODE1_WDTH0                 *((volatile unsigned int*)(0x427E0080UL))
#define bFM_EXBUS_MODE1_WDTH1                 *((volatile unsigned int*)(0x427E0084UL))
#define bFM_EXBUS_MODE1_RBMON                 *((volatile unsigned int*)(0x427E0088UL))
#define bFM_EXBUS_MODE1_WEOFF                 *((volatile unsigned int*)(0x427E008CUL))
#define bFM_EXBUS_MODE1_NAND                  *((volatile unsigned int*)(0x427E0090UL))
#define bFM_EXBUS_MODE1_PAGE                  *((volatile unsigned int*)(0x427E0094UL))
#define bFM_EXBUS_MODE1_RDY                   *((volatile unsigned int*)(0x427E0098UL))
#define bFM_EXBUS_MODE1_SHRTDOUT              *((volatile unsigned int*)(0x427E009CUL))
#define bFM_EXBUS_MODE1_MPXMODE               *((volatile unsigned int*)(0x427E00A0UL))
#define bFM_EXBUS_MODE1_ALEINV                *((volatile unsigned int*)(0x427E00A4UL))
#define bFM_EXBUS_MODE1_MPXDOFF               *((volatile unsigned int*)(0x427E00ACUL))
#define bFM_EXBUS_MODE1_MPXCSOF               *((volatile unsigned int*)(0x427E00B0UL))
#define bFM_EXBUS_MODE1_MOEXEUP               *((volatile unsigned int*)(0x427E00B4UL))
#define bFM_EXBUS_MODE2_WDTH0                 *((volatile unsigned int*)(0x427E0100UL))
#define bFM_EXBUS_MODE2_WDTH1                 *((volatile unsigned int*)(0x427E0104UL))
#define bFM_EXBUS_MODE2_RBMON                 *((volatile unsigned int*)(0x427E0108UL))
#define bFM_EXBUS_MODE2_WEOFF                 *((volatile unsigned int*)(0x427E010CUL))
#define bFM_EXBUS_MODE2_NAND                  *((volatile unsigned int*)(0x427E0110UL))
#define bFM_EXBUS_MODE2_PAGE                  *((volatile unsigned int*)(0x427E0114UL))
#define bFM_EXBUS_MODE2_RDY                   *((volatile unsigned int*)(0x427E0118UL))
#define bFM_EXBUS_MODE2_SHRTDOUT              *((volatile unsigned int*)(0x427E011CUL))
#define bFM_EXBUS_MODE2_MPXMODE               *((volatile unsigned int*)(0x427E0120UL))
#define bFM_EXBUS_MODE2_ALEINV                *((volatile unsigned int*)(0x427E0124UL))
#define bFM_EXBUS_MODE2_MPXDOFF               *((volatile unsigned int*)(0x427E012CUL))
#define bFM_EXBUS_MODE2_MPXCSOF               *((volatile unsigned int*)(0x427E0130UL))
#define bFM_EXBUS_MODE2_MOEXEUP               *((volatile unsigned int*)(0x427E0134UL))
#define bFM_EXBUS_MODE3_WDTH0                 *((volatile unsigned int*)(0x427E0180UL))
#define bFM_EXBUS_MODE3_WDTH1                 *((volatile unsigned int*)(0x427E0184UL))
#define bFM_EXBUS_MODE3_RBMON                 *((volatile unsigned int*)(0x427E0188UL))
#define bFM_EXBUS_MODE3_WEOFF                 *((volatile unsigned int*)(0x427E018CUL))
#define bFM_EXBUS_MODE3_NAND                  *((volatile unsigned int*)(0x427E0190UL))
#define bFM_EXBUS_MODE3_PAGE                  *((volatile unsigned int*)(0x427E0194UL))
#define bFM_EXBUS_MODE3_RDY                   *((volatile unsigned int*)(0x427E0198UL))
#define bFM_EXBUS_MODE3_SHRTDOUT              *((volatile unsigned int*)(0x427E019CUL))
#define bFM_EXBUS_MODE3_MPXMODE               *((volatile unsigned int*)(0x427E01A0UL))
#define bFM_EXBUS_MODE3_ALEINV                *((volatile unsigned int*)(0x427E01A4UL))
#define bFM_EXBUS_MODE3_MPXDOFF               *((volatile unsigned int*)(0x427E01ACUL))
#define bFM_EXBUS_MODE3_MPXCSOF               *((volatile unsigned int*)(0x427E01B0UL))
#define bFM_EXBUS_MODE3_MOEXEUP               *((volatile unsigned int*)(0x427E01B4UL))
#define bFM_EXBUS_MODE4_WDTH0                 *((volatile unsigned int*)(0x427E0200UL))
#define bFM_EXBUS_MODE4_WDTH1                 *((volatile unsigned int*)(0x427E0204UL))
#define bFM_EXBUS_MODE4_RBMON                 *((volatile unsigned int*)(0x427E0208UL))
#define bFM_EXBUS_MODE4_WEOFF                 *((volatile unsigned int*)(0x427E020CUL))
#define bFM_EXBUS_MODE4_NAND                  *((volatile unsigned int*)(0x427E0210UL))
#define bFM_EXBUS_MODE4_PAGE                  *((volatile unsigned int*)(0x427E0214UL))
#define bFM_EXBUS_MODE4_RDY                   *((volatile unsigned int*)(0x427E0218UL))
#define bFM_EXBUS_MODE4_SHRTDOUT              *((volatile unsigned int*)(0x427E021CUL))
#define bFM_EXBUS_MODE4_MPXMODE               *((volatile unsigned int*)(0x427E0220UL))
#define bFM_EXBUS_MODE4_ALEINV                *((volatile unsigned int*)(0x427E0224UL))
#define bFM_EXBUS_MODE4_MPXDOFF               *((volatile unsigned int*)(0x427E022CUL))
#define bFM_EXBUS_MODE4_MPXCSOF               *((volatile unsigned int*)(0x427E0230UL))
#define bFM_EXBUS_MODE4_MOEXEUP               *((volatile unsigned int*)(0x427E0234UL))
#define bFM_EXBUS_MODE5_WDTH0                 *((volatile unsigned int*)(0x427E0280UL))
#define bFM_EXBUS_MODE5_WDTH1                 *((volatile unsigned int*)(0x427E0284UL))
#define bFM_EXBUS_MODE5_RBMON                 *((volatile unsigned int*)(0x427E0288UL))
#define bFM_EXBUS_MODE5_WEOFF                 *((volatile unsigned int*)(0x427E028CUL))
#define bFM_EXBUS_MODE5_NAND                  *((volatile unsigned int*)(0x427E0290UL))
#define bFM_EXBUS_MODE5_PAGE                  *((volatile unsigned int*)(0x427E0294UL))
#define bFM_EXBUS_MODE5_RDY                   *((volatile unsigned int*)(0x427E0298UL))
#define bFM_EXBUS_MODE5_SHRTDOUT              *((volatile unsigned int*)(0x427E029CUL))
#define bFM_EXBUS_MODE5_MPXMODE               *((volatile unsigned int*)(0x427E02A0UL))
#define bFM_EXBUS_MODE5_ALEINV                *((volatile unsigned int*)(0x427E02A4UL))
#define bFM_EXBUS_MODE5_MPXDOFF               *((volatile unsigned int*)(0x427E02ACUL))
#define bFM_EXBUS_MODE5_MPXCSOF               *((volatile unsigned int*)(0x427E02B0UL))
#define bFM_EXBUS_MODE5_MOEXEUP               *((volatile unsigned int*)(0x427E02B4UL))
#define bFM_EXBUS_MODE6_WDTH0                 *((volatile unsigned int*)(0x427E0300UL))
#define bFM_EXBUS_MODE6_WDTH1                 *((volatile unsigned int*)(0x427E0304UL))
#define bFM_EXBUS_MODE6_RBMON                 *((volatile unsigned int*)(0x427E0308UL))
#define bFM_EXBUS_MODE6_WEOFF                 *((volatile unsigned int*)(0x427E030CUL))
#define bFM_EXBUS_MODE6_NAND                  *((volatile unsigned int*)(0x427E0310UL))
#define bFM_EXBUS_MODE6_PAGE                  *((volatile unsigned int*)(0x427E0314UL))
#define bFM_EXBUS_MODE6_RDY                   *((volatile unsigned int*)(0x427E0318UL))
#define bFM_EXBUS_MODE6_SHRTDOUT              *((volatile unsigned int*)(0x427E031CUL))
#define bFM_EXBUS_MODE6_MPXMODE               *((volatile unsigned int*)(0x427E0320UL))
#define bFM_EXBUS_MODE6_ALEINV                *((volatile unsigned int*)(0x427E0324UL))
#define bFM_EXBUS_MODE6_MPXDOFF               *((volatile unsigned int*)(0x427E032CUL))
#define bFM_EXBUS_MODE6_MPXCSOF               *((volatile unsigned int*)(0x427E0330UL))
#define bFM_EXBUS_MODE6_MOEXEUP               *((volatile unsigned int*)(0x427E0334UL))
#define bFM_EXBUS_MODE7_WDTH0                 *((volatile unsigned int*)(0x427E0380UL))
#define bFM_EXBUS_MODE7_WDTH1                 *((volatile unsigned int*)(0x427E0384UL))
#define bFM_EXBUS_MODE7_RBMON                 *((volatile unsigned int*)(0x427E0388UL))
#define bFM_EXBUS_MODE7_WEOFF                 *((volatile unsigned int*)(0x427E038CUL))
#define bFM_EXBUS_MODE7_NAND                  *((volatile unsigned int*)(0x427E0390UL))
#define bFM_EXBUS_MODE7_PAGE                  *((volatile unsigned int*)(0x427E0394UL))
#define bFM_EXBUS_MODE7_RDY                   *((volatile unsigned int*)(0x427E0398UL))
#define bFM_EXBUS_MODE7_SHRTDOUT              *((volatile unsigned int*)(0x427E039CUL))
#define bFM_EXBUS_MODE7_MPXMODE               *((volatile unsigned int*)(0x427E03A0UL))
#define bFM_EXBUS_MODE7_ALEINV                *((volatile unsigned int*)(0x427E03A4UL))
#define bFM_EXBUS_MODE7_MPXDOFF               *((volatile unsigned int*)(0x427E03ACUL))
#define bFM_EXBUS_MODE7_MPXCSOF               *((volatile unsigned int*)(0x427E03B0UL))
#define bFM_EXBUS_MODE7_MOEXEUP               *((volatile unsigned int*)(0x427E03B4UL))
#define bFM_EXBUS_TIM0_RACC0                  *((volatile unsigned int*)(0x427E0400UL))
#define bFM_EXBUS_TIM0_RACC1                  *((volatile unsigned int*)(0x427E0404UL))
#define bFM_EXBUS_TIM0_RACC2                  *((volatile unsigned int*)(0x427E0408UL))
#define bFM_EXBUS_TIM0_RACC3                  *((volatile unsigned int*)(0x427E040CUL))
#define bFM_EXBUS_TIM0_RADC0                  *((volatile unsigned int*)(0x427E0410UL))
#define bFM_EXBUS_TIM0_RADC1                  *((volatile unsigned int*)(0x427E0414UL))
#define bFM_EXBUS_TIM0_RADC2                  *((volatile unsigned int*)(0x427E0418UL))
#define bFM_EXBUS_TIM0_RADC3                  *((volatile unsigned int*)(0x427E041CUL))
#define bFM_EXBUS_TIM0_FRADC0                 *((volatile unsigned int*)(0x427E0420UL))
#define bFM_EXBUS_TIM0_FRADC1                 *((volatile unsigned int*)(0x427E0424UL))
#define bFM_EXBUS_TIM0_FRADC2                 *((volatile unsigned int*)(0x427E0428UL))
#define bFM_EXBUS_TIM0_FRADC3                 *((volatile unsigned int*)(0x427E042CUL))
#define bFM_EXBUS_TIM0_RIDLC0                 *((volatile unsigned int*)(0x427E0430UL))
#define bFM_EXBUS_TIM0_RIDLC1                 *((volatile unsigned int*)(0x427E0434UL))
#define bFM_EXBUS_TIM0_RIDLC2                 *((volatile unsigned int*)(0x427E0438UL))
#define bFM_EXBUS_TIM0_RIDLC3                 *((volatile unsigned int*)(0x427E043CUL))
#define bFM_EXBUS_TIM0_WACC0                  *((volatile unsigned int*)(0x427E0440UL))
#define bFM_EXBUS_TIM0_WACC1                  *((volatile unsigned int*)(0x427E0444UL))
#define bFM_EXBUS_TIM0_WACC2                  *((volatile unsigned int*)(0x427E0448UL))
#define bFM_EXBUS_TIM0_WACC3                  *((volatile unsigned int*)(0x427E044CUL))
#define bFM_EXBUS_TIM0_WADC0                  *((volatile unsigned int*)(0x427E0450UL))
#define bFM_EXBUS_TIM0_WADC1                  *((volatile unsigned int*)(0x427E0454UL))
#define bFM_EXBUS_TIM0_WADC2                  *((volatile unsigned int*)(0x427E0458UL))
#define bFM_EXBUS_TIM0_WADC3                  *((volatile unsigned int*)(0x427E045CUL))
#define bFM_EXBUS_TIM0_WWEC0                  *((volatile unsigned int*)(0x427E0460UL))
#define bFM_EXBUS_TIM0_WWEC1                  *((volatile unsigned int*)(0x427E0464UL))
#define bFM_EXBUS_TIM0_WWEC2                  *((volatile unsigned int*)(0x427E0468UL))
#define bFM_EXBUS_TIM0_WWEC3                  *((volatile unsigned int*)(0x427E046CUL))
#define bFM_EXBUS_TIM0_WIDLC0                 *((volatile unsigned int*)(0x427E0470UL))
#define bFM_EXBUS_TIM0_WIDLC1                 *((volatile unsigned int*)(0x427E0474UL))
#define bFM_EXBUS_TIM0_WIDLC2                 *((volatile unsigned int*)(0x427E0478UL))
#define bFM_EXBUS_TIM0_WIDLC3                 *((volatile unsigned int*)(0x427E047CUL))
#define bFM_EXBUS_TIM1_RACC0                  *((volatile unsigned int*)(0x427E0480UL))
#define bFM_EXBUS_TIM1_RACC1                  *((volatile unsigned int*)(0x427E0484UL))
#define bFM_EXBUS_TIM1_RACC2                  *((volatile unsigned int*)(0x427E0488UL))
#define bFM_EXBUS_TIM1_RACC3                  *((volatile unsigned int*)(0x427E048CUL))
#define bFM_EXBUS_TIM1_RADC0                  *((volatile unsigned int*)(0x427E0490UL))
#define bFM_EXBUS_TIM1_RADC1                  *((volatile unsigned int*)(0x427E0494UL))
#define bFM_EXBUS_TIM1_RADC2                  *((volatile unsigned int*)(0x427E0498UL))
#define bFM_EXBUS_TIM1_RADC3                  *((volatile unsigned int*)(0x427E049CUL))
#define bFM_EXBUS_TIM1_FRADC0                 *((volatile unsigned int*)(0x427E04A0UL))
#define bFM_EXBUS_TIM1_FRADC1                 *((volatile unsigned int*)(0x427E04A4UL))
#define bFM_EXBUS_TIM1_FRADC2                 *((volatile unsigned int*)(0x427E04A8UL))
#define bFM_EXBUS_TIM1_FRADC3                 *((volatile unsigned int*)(0x427E04ACUL))
#define bFM_EXBUS_TIM1_RIDLC0                 *((volatile unsigned int*)(0x427E04B0UL))
#define bFM_EXBUS_TIM1_RIDLC1                 *((volatile unsigned int*)(0x427E04B4UL))
#define bFM_EXBUS_TIM1_RIDLC2                 *((volatile unsigned int*)(0x427E04B8UL))
#define bFM_EXBUS_TIM1_RIDLC3                 *((volatile unsigned int*)(0x427E04BCUL))
#define bFM_EXBUS_TIM1_WACC0                  *((volatile unsigned int*)(0x427E04C0UL))
#define bFM_EXBUS_TIM1_WACC1                  *((volatile unsigned int*)(0x427E04C4UL))
#define bFM_EXBUS_TIM1_WACC2                  *((volatile unsigned int*)(0x427E04C8UL))
#define bFM_EXBUS_TIM1_WACC3                  *((volatile unsigned int*)(0x427E04CCUL))
#define bFM_EXBUS_TIM1_WADC0                  *((volatile unsigned int*)(0x427E04D0UL))
#define bFM_EXBUS_TIM1_WADC1                  *((volatile unsigned int*)(0x427E04D4UL))
#define bFM_EXBUS_TIM1_WADC2                  *((volatile unsigned int*)(0x427E04D8UL))
#define bFM_EXBUS_TIM1_WADC3                  *((volatile unsigned int*)(0x427E04DCUL))
#define bFM_EXBUS_TIM1_WWEC0                  *((volatile unsigned int*)(0x427E04E0UL))
#define bFM_EXBUS_TIM1_WWEC1                  *((volatile unsigned int*)(0x427E04E4UL))
#define bFM_EXBUS_TIM1_WWEC2                  *((volatile unsigned int*)(0x427E04E8UL))
#define bFM_EXBUS_TIM1_WWEC3                  *((volatile unsigned int*)(0x427E04ECUL))
#define bFM_EXBUS_TIM1_WIDLC0                 *((volatile unsigned int*)(0x427E04F0UL))
#define bFM_EXBUS_TIM1_WIDLC1                 *((volatile unsigned int*)(0x427E04F4UL))
#define bFM_EXBUS_TIM1_WIDLC2                 *((volatile unsigned int*)(0x427E04F8UL))
#define bFM_EXBUS_TIM1_WIDLC3                 *((volatile unsigned int*)(0x427E04FCUL))
#define bFM_EXBUS_TIM2_RACC0                  *((volatile unsigned int*)(0x427E0500UL))
#define bFM_EXBUS_TIM2_RACC1                  *((volatile unsigned int*)(0x427E0504UL))
#define bFM_EXBUS_TIM2_RACC2                  *((volatile unsigned int*)(0x427E0508UL))
#define bFM_EXBUS_TIM2_RACC3                  *((volatile unsigned int*)(0x427E050CUL))
#define bFM_EXBUS_TIM2_RADC0                  *((volatile unsigned int*)(0x427E0510UL))
#define bFM_EXBUS_TIM2_RADC1                  *((volatile unsigned int*)(0x427E0514UL))
#define bFM_EXBUS_TIM2_RADC2                  *((volatile unsigned int*)(0x427E0518UL))
#define bFM_EXBUS_TIM2_RADC3                  *((volatile unsigned int*)(0x427E051CUL))
#define bFM_EXBUS_TIM2_FRADC0                 *((volatile unsigned int*)(0x427E0520UL))
#define bFM_EXBUS_TIM2_FRADC1                 *((volatile unsigned int*)(0x427E0524UL))
#define bFM_EXBUS_TIM2_FRADC2                 *((volatile unsigned int*)(0x427E0528UL))
#define bFM_EXBUS_TIM2_FRADC3                 *((volatile unsigned int*)(0x427E052CUL))
#define bFM_EXBUS_TIM2_RIDLC0                 *((volatile unsigned int*)(0x427E0530UL))
#define bFM_EXBUS_TIM2_RIDLC1                 *((volatile unsigned int*)(0x427E0534UL))
#define bFM_EXBUS_TIM2_RIDLC2                 *((volatile unsigned int*)(0x427E0538UL))
#define bFM_EXBUS_TIM2_RIDLC3                 *((volatile unsigned int*)(0x427E053CUL))
#define bFM_EXBUS_TIM2_WACC0                  *((volatile unsigned int*)(0x427E0540UL))
#define bFM_EXBUS_TIM2_WACC1                  *((volatile unsigned int*)(0x427E0544UL))
#define bFM_EXBUS_TIM2_WACC2                  *((volatile unsigned int*)(0x427E0548UL))
#define bFM_EXBUS_TIM2_WACC3                  *((volatile unsigned int*)(0x427E054CUL))
#define bFM_EXBUS_TIM2_WADC0                  *((volatile unsigned int*)(0x427E0550UL))
#define bFM_EXBUS_TIM2_WADC1                  *((volatile unsigned int*)(0x427E0554UL))
#define bFM_EXBUS_TIM2_WADC2                  *((volatile unsigned int*)(0x427E0558UL))
#define bFM_EXBUS_TIM2_WADC3                  *((volatile unsigned int*)(0x427E055CUL))
#define bFM_EXBUS_TIM2_WWEC0                  *((volatile unsigned int*)(0x427E0560UL))
#define bFM_EXBUS_TIM2_WWEC1                  *((volatile unsigned int*)(0x427E0564UL))
#define bFM_EXBUS_TIM2_WWEC2                  *((volatile unsigned int*)(0x427E0568UL))
#define bFM_EXBUS_TIM2_WWEC3                  *((volatile unsigned int*)(0x427E056CUL))
#define bFM_EXBUS_TIM2_WIDLC0                 *((volatile unsigned int*)(0x427E0570UL))
#define bFM_EXBUS_TIM2_WIDLC1                 *((volatile unsigned int*)(0x427E0574UL))
#define bFM_EXBUS_TIM2_WIDLC2                 *((volatile unsigned int*)(0x427E0578UL))
#define bFM_EXBUS_TIM2_WIDLC3                 *((volatile unsigned int*)(0x427E057CUL))
#define bFM_EXBUS_TIM3_RACC0                  *((volatile unsigned int*)(0x427E0580UL))
#define bFM_EXBUS_TIM3_RACC1                  *((volatile unsigned int*)(0x427E0584UL))
#define bFM_EXBUS_TIM3_RACC2                  *((volatile unsigned int*)(0x427E0588UL))
#define bFM_EXBUS_TIM3_RACC3                  *((volatile unsigned int*)(0x427E058CUL))
#define bFM_EXBUS_TIM3_RADC0                  *((volatile unsigned int*)(0x427E0590UL))
#define bFM_EXBUS_TIM3_RADC1                  *((volatile unsigned int*)(0x427E0594UL))
#define bFM_EXBUS_TIM3_RADC2                  *((volatile unsigned int*)(0x427E0598UL))
#define bFM_EXBUS_TIM3_RADC3                  *((volatile unsigned int*)(0x427E059CUL))
#define bFM_EXBUS_TIM3_FRADC0                 *((volatile unsigned int*)(0x427E05A0UL))
#define bFM_EXBUS_TIM3_FRADC1                 *((volatile unsigned int*)(0x427E05A4UL))
#define bFM_EXBUS_TIM3_FRADC2                 *((volatile unsigned int*)(0x427E05A8UL))
#define bFM_EXBUS_TIM3_FRADC3                 *((volatile unsigned int*)(0x427E05ACUL))
#define bFM_EXBUS_TIM3_RIDLC0                 *((volatile unsigned int*)(0x427E05B0UL))
#define bFM_EXBUS_TIM3_RIDLC1                 *((volatile unsigned int*)(0x427E05B4UL))
#define bFM_EXBUS_TIM3_RIDLC2                 *((volatile unsigned int*)(0x427E05B8UL))
#define bFM_EXBUS_TIM3_RIDLC3                 *((volatile unsigned int*)(0x427E05BCUL))
#define bFM_EXBUS_TIM3_WACC0                  *((volatile unsigned int*)(0x427E05C0UL))
#define bFM_EXBUS_TIM3_WACC1                  *((volatile unsigned int*)(0x427E05C4UL))
#define bFM_EXBUS_TIM3_WACC2                  *((volatile unsigned int*)(0x427E05C8UL))
#define bFM_EXBUS_TIM3_WACC3                  *((volatile unsigned int*)(0x427E05CCUL))
#define bFM_EXBUS_TIM3_WADC0                  *((volatile unsigned int*)(0x427E05D0UL))
#define bFM_EXBUS_TIM3_WADC1                  *((volatile unsigned int*)(0x427E05D4UL))
#define bFM_EXBUS_TIM3_WADC2                  *((volatile unsigned int*)(0x427E05D8UL))
#define bFM_EXBUS_TIM3_WADC3                  *((volatile unsigned int*)(0x427E05DCUL))
#define bFM_EXBUS_TIM3_WWEC0                  *((volatile unsigned int*)(0x427E05E0UL))
#define bFM_EXBUS_TIM3_WWEC1                  *((volatile unsigned int*)(0x427E05E4UL))
#define bFM_EXBUS_TIM3_WWEC2                  *((volatile unsigned int*)(0x427E05E8UL))
#define bFM_EXBUS_TIM3_WWEC3                  *((volatile unsigned int*)(0x427E05ECUL))
#define bFM_EXBUS_TIM3_WIDLC0                 *((volatile unsigned int*)(0x427E05F0UL))
#define bFM_EXBUS_TIM3_WIDLC1                 *((volatile unsigned int*)(0x427E05F4UL))
#define bFM_EXBUS_TIM3_WIDLC2                 *((volatile unsigned int*)(0x427E05F8UL))
#define bFM_EXBUS_TIM3_WIDLC3                 *((volatile unsigned int*)(0x427E05FCUL))
#define bFM_EXBUS_TIM4_RACC0                  *((volatile unsigned int*)(0x427E0600UL))
#define bFM_EXBUS_TIM4_RACC1                  *((volatile unsigned int*)(0x427E0604UL))
#define bFM_EXBUS_TIM4_RACC2                  *((volatile unsigned int*)(0x427E0608UL))
#define bFM_EXBUS_TIM4_RACC3                  *((volatile unsigned int*)(0x427E060CUL))
#define bFM_EXBUS_TIM4_RADC0                  *((volatile unsigned int*)(0x427E0610UL))
#define bFM_EXBUS_TIM4_RADC1                  *((volatile unsigned int*)(0x427E0614UL))
#define bFM_EXBUS_TIM4_RADC2                  *((volatile unsigned int*)(0x427E0618UL))
#define bFM_EXBUS_TIM4_RADC3                  *((volatile unsigned int*)(0x427E061CUL))
#define bFM_EXBUS_TIM4_FRADC0                 *((volatile unsigned int*)(0x427E0620UL))
#define bFM_EXBUS_TIM4_FRADC1                 *((volatile unsigned int*)(0x427E0624UL))
#define bFM_EXBUS_TIM4_FRADC2                 *((volatile unsigned int*)(0x427E0628UL))
#define bFM_EXBUS_TIM4_FRADC3                 *((volatile unsigned int*)(0x427E062CUL))
#define bFM_EXBUS_TIM4_RIDLC0                 *((volatile unsigned int*)(0x427E0630UL))
#define bFM_EXBUS_TIM4_RIDLC1                 *((volatile unsigned int*)(0x427E0634UL))
#define bFM_EXBUS_TIM4_RIDLC2                 *((volatile unsigned int*)(0x427E0638UL))
#define bFM_EXBUS_TIM4_RIDLC3                 *((volatile unsigned int*)(0x427E063CUL))
#define bFM_EXBUS_TIM4_WACC0                  *((volatile unsigned int*)(0x427E0640UL))
#define bFM_EXBUS_TIM4_WACC1                  *((volatile unsigned int*)(0x427E0644UL))
#define bFM_EXBUS_TIM4_WACC2                  *((volatile unsigned int*)(0x427E0648UL))
#define bFM_EXBUS_TIM4_WACC3                  *((volatile unsigned int*)(0x427E064CUL))
#define bFM_EXBUS_TIM4_WADC0                  *((volatile unsigned int*)(0x427E0650UL))
#define bFM_EXBUS_TIM4_WADC1                  *((volatile unsigned int*)(0x427E0654UL))
#define bFM_EXBUS_TIM4_WADC2                  *((volatile unsigned int*)(0x427E0658UL))
#define bFM_EXBUS_TIM4_WADC3                  *((volatile unsigned int*)(0x427E065CUL))
#define bFM_EXBUS_TIM4_WWEC0                  *((volatile unsigned int*)(0x427E0660UL))
#define bFM_EXBUS_TIM4_WWEC1                  *((volatile unsigned int*)(0x427E0664UL))
#define bFM_EXBUS_TIM4_WWEC2                  *((volatile unsigned int*)(0x427E0668UL))
#define bFM_EXBUS_TIM4_WWEC3                  *((volatile unsigned int*)(0x427E066CUL))
#define bFM_EXBUS_TIM4_WIDLC0                 *((volatile unsigned int*)(0x427E0670UL))
#define bFM_EXBUS_TIM4_WIDLC1                 *((volatile unsigned int*)(0x427E0674UL))
#define bFM_EXBUS_TIM4_WIDLC2                 *((volatile unsigned int*)(0x427E0678UL))
#define bFM_EXBUS_TIM4_WIDLC3                 *((volatile unsigned int*)(0x427E067CUL))
#define bFM_EXBUS_TIM5_RACC0                  *((volatile unsigned int*)(0x427E0680UL))
#define bFM_EXBUS_TIM5_RACC1                  *((volatile unsigned int*)(0x427E0684UL))
#define bFM_EXBUS_TIM5_RACC2                  *((volatile unsigned int*)(0x427E0688UL))
#define bFM_EXBUS_TIM5_RACC3                  *((volatile unsigned int*)(0x427E068CUL))
#define bFM_EXBUS_TIM5_RADC0                  *((volatile unsigned int*)(0x427E0690UL))
#define bFM_EXBUS_TIM5_RADC1                  *((volatile unsigned int*)(0x427E0694UL))
#define bFM_EXBUS_TIM5_RADC2                  *((volatile unsigned int*)(0x427E0698UL))
#define bFM_EXBUS_TIM5_RADC3                  *((volatile unsigned int*)(0x427E069CUL))
#define bFM_EXBUS_TIM5_FRADC0                 *((volatile unsigned int*)(0x427E06A0UL))
#define bFM_EXBUS_TIM5_FRADC1                 *((volatile unsigned int*)(0x427E06A4UL))
#define bFM_EXBUS_TIM5_FRADC2                 *((volatile unsigned int*)(0x427E06A8UL))
#define bFM_EXBUS_TIM5_FRADC3                 *((volatile unsigned int*)(0x427E06ACUL))
#define bFM_EXBUS_TIM5_RIDLC0                 *((volatile unsigned int*)(0x427E06B0UL))
#define bFM_EXBUS_TIM5_RIDLC1                 *((volatile unsigned int*)(0x427E06B4UL))
#define bFM_EXBUS_TIM5_RIDLC2                 *((volatile unsigned int*)(0x427E06B8UL))
#define bFM_EXBUS_TIM5_RIDLC3                 *((volatile unsigned int*)(0x427E06BCUL))
#define bFM_EXBUS_TIM5_WACC0                  *((volatile unsigned int*)(0x427E06C0UL))
#define bFM_EXBUS_TIM5_WACC1                  *((volatile unsigned int*)(0x427E06C4UL))
#define bFM_EXBUS_TIM5_WACC2                  *((volatile unsigned int*)(0x427E06C8UL))
#define bFM_EXBUS_TIM5_WACC3                  *((volatile unsigned int*)(0x427E06CCUL))
#define bFM_EXBUS_TIM5_WADC0                  *((volatile unsigned int*)(0x427E06D0UL))
#define bFM_EXBUS_TIM5_WADC1                  *((volatile unsigned int*)(0x427E06D4UL))
#define bFM_EXBUS_TIM5_WADC2                  *((volatile unsigned int*)(0x427E06D8UL))
#define bFM_EXBUS_TIM5_WADC3                  *((volatile unsigned int*)(0x427E06DCUL))
#define bFM_EXBUS_TIM5_WWEC0                  *((volatile unsigned int*)(0x427E06E0UL))
#define bFM_EXBUS_TIM5_WWEC1                  *((volatile unsigned int*)(0x427E06E4UL))
#define bFM_EXBUS_TIM5_WWEC2                  *((volatile unsigned int*)(0x427E06E8UL))
#define bFM_EXBUS_TIM5_WWEC3                  *((volatile unsigned int*)(0x427E06ECUL))
#define bFM_EXBUS_TIM5_WIDLC0                 *((volatile unsigned int*)(0x427E06F0UL))
#define bFM_EXBUS_TIM5_WIDLC1                 *((volatile unsigned int*)(0x427E06F4UL))
#define bFM_EXBUS_TIM5_WIDLC2                 *((volatile unsigned int*)(0x427E06F8UL))
#define bFM_EXBUS_TIM5_WIDLC3                 *((volatile unsigned int*)(0x427E06FCUL))
#define bFM_EXBUS_TIM6_RACC0                  *((volatile unsigned int*)(0x427E0700UL))
#define bFM_EXBUS_TIM6_RACC1                  *((volatile unsigned int*)(0x427E0704UL))
#define bFM_EXBUS_TIM6_RACC2                  *((volatile unsigned int*)(0x427E0708UL))
#define bFM_EXBUS_TIM6_RACC3                  *((volatile unsigned int*)(0x427E070CUL))
#define bFM_EXBUS_TIM6_RADC0                  *((volatile unsigned int*)(0x427E0710UL))
#define bFM_EXBUS_TIM6_RADC1                  *((volatile unsigned int*)(0x427E0714UL))
#define bFM_EXBUS_TIM6_RADC2                  *((volatile unsigned int*)(0x427E0718UL))
#define bFM_EXBUS_TIM6_RADC3                  *((volatile unsigned int*)(0x427E071CUL))
#define bFM_EXBUS_TIM6_FRADC0                 *((volatile unsigned int*)(0x427E0720UL))
#define bFM_EXBUS_TIM6_FRADC1                 *((volatile unsigned int*)(0x427E0724UL))
#define bFM_EXBUS_TIM6_FRADC2                 *((volatile unsigned int*)(0x427E0728UL))
#define bFM_EXBUS_TIM6_FRADC3                 *((volatile unsigned int*)(0x427E072CUL))
#define bFM_EXBUS_TIM6_RIDLC0                 *((volatile unsigned int*)(0x427E0730UL))
#define bFM_EXBUS_TIM6_RIDLC1                 *((volatile unsigned int*)(0x427E0734UL))
#define bFM_EXBUS_TIM6_RIDLC2                 *((volatile unsigned int*)(0x427E0738UL))
#define bFM_EXBUS_TIM6_RIDLC3                 *((volatile unsigned int*)(0x427E073CUL))
#define bFM_EXBUS_TIM6_WACC0                  *((volatile unsigned int*)(0x427E0740UL))
#define bFM_EXBUS_TIM6_WACC1                  *((volatile unsigned int*)(0x427E0744UL))
#define bFM_EXBUS_TIM6_WACC2                  *((volatile unsigned int*)(0x427E0748UL))
#define bFM_EXBUS_TIM6_WACC3                  *((volatile unsigned int*)(0x427E074CUL))
#define bFM_EXBUS_TIM6_WADC0                  *((volatile unsigned int*)(0x427E0750UL))
#define bFM_EXBUS_TIM6_WADC1                  *((volatile unsigned int*)(0x427E0754UL))
#define bFM_EXBUS_TIM6_WADC2                  *((volatile unsigned int*)(0x427E0758UL))
#define bFM_EXBUS_TIM6_WADC3                  *((volatile unsigned int*)(0x427E075CUL))
#define bFM_EXBUS_TIM6_WWEC0                  *((volatile unsigned int*)(0x427E0760UL))
#define bFM_EXBUS_TIM6_WWEC1                  *((volatile unsigned int*)(0x427E0764UL))
#define bFM_EXBUS_TIM6_WWEC2                  *((volatile unsigned int*)(0x427E0768UL))
#define bFM_EXBUS_TIM6_WWEC3                  *((volatile unsigned int*)(0x427E076CUL))
#define bFM_EXBUS_TIM6_WIDLC0                 *((volatile unsigned int*)(0x427E0770UL))
#define bFM_EXBUS_TIM6_WIDLC1                 *((volatile unsigned int*)(0x427E0774UL))
#define bFM_EXBUS_TIM6_WIDLC2                 *((volatile unsigned int*)(0x427E0778UL))
#define bFM_EXBUS_TIM6_WIDLC3                 *((volatile unsigned int*)(0x427E077CUL))
#define bFM_EXBUS_TIM7_RACC0                  *((volatile unsigned int*)(0x427E0780UL))
#define bFM_EXBUS_TIM7_RACC1                  *((volatile unsigned int*)(0x427E0784UL))
#define bFM_EXBUS_TIM7_RACC2                  *((volatile unsigned int*)(0x427E0788UL))
#define bFM_EXBUS_TIM7_RACC3                  *((volatile unsigned int*)(0x427E078CUL))
#define bFM_EXBUS_TIM7_RADC0                  *((volatile unsigned int*)(0x427E0790UL))
#define bFM_EXBUS_TIM7_RADC1                  *((volatile unsigned int*)(0x427E0794UL))
#define bFM_EXBUS_TIM7_RADC2                  *((volatile unsigned int*)(0x427E0798UL))
#define bFM_EXBUS_TIM7_RADC3                  *((volatile unsigned int*)(0x427E079CUL))
#define bFM_EXBUS_TIM7_FRADC0                 *((volatile unsigned int*)(0x427E07A0UL))
#define bFM_EXBUS_TIM7_FRADC1                 *((volatile unsigned int*)(0x427E07A4UL))
#define bFM_EXBUS_TIM7_FRADC2                 *((volatile unsigned int*)(0x427E07A8UL))
#define bFM_EXBUS_TIM7_FRADC3                 *((volatile unsigned int*)(0x427E07ACUL))
#define bFM_EXBUS_TIM7_RIDLC0                 *((volatile unsigned int*)(0x427E07B0UL))
#define bFM_EXBUS_TIM7_RIDLC1                 *((volatile unsigned int*)(0x427E07B4UL))
#define bFM_EXBUS_TIM7_RIDLC2                 *((volatile unsigned int*)(0x427E07B8UL))
#define bFM_EXBUS_TIM7_RIDLC3                 *((volatile unsigned int*)(0x427E07BCUL))
#define bFM_EXBUS_TIM7_WACC0                  *((volatile unsigned int*)(0x427E07C0UL))
#define bFM_EXBUS_TIM7_WACC1                  *((volatile unsigned int*)(0x427E07C4UL))
#define bFM_EXBUS_TIM7_WACC2                  *((volatile unsigned int*)(0x427E07C8UL))
#define bFM_EXBUS_TIM7_WACC3                  *((volatile unsigned int*)(0x427E07CCUL))
#define bFM_EXBUS_TIM7_WADC0                  *((volatile unsigned int*)(0x427E07D0UL))
#define bFM_EXBUS_TIM7_WADC1                  *((volatile unsigned int*)(0x427E07D4UL))
#define bFM_EXBUS_TIM7_WADC2                  *((volatile unsigned int*)(0x427E07D8UL))
#define bFM_EXBUS_TIM7_WADC3                  *((volatile unsigned int*)(0x427E07DCUL))
#define bFM_EXBUS_TIM7_WWEC0                  *((volatile unsigned int*)(0x427E07E0UL))
#define bFM_EXBUS_TIM7_WWEC1                  *((volatile unsigned int*)(0x427E07E4UL))
#define bFM_EXBUS_TIM7_WWEC2                  *((volatile unsigned int*)(0x427E07E8UL))
#define bFM_EXBUS_TIM7_WWEC3                  *((volatile unsigned int*)(0x427E07ECUL))
#define bFM_EXBUS_TIM7_WIDLC0                 *((volatile unsigned int*)(0x427E07F0UL))
#define bFM_EXBUS_TIM7_WIDLC1                 *((volatile unsigned int*)(0x427E07F4UL))
#define bFM_EXBUS_TIM7_WIDLC2                 *((volatile unsigned int*)(0x427E07F8UL))
#define bFM_EXBUS_TIM7_WIDLC3                 *((volatile unsigned int*)(0x427E07FCUL))
#define bFM_EXBUS_AREA0_ADDR0                 *((volatile unsigned int*)(0x427E0800UL))
#define bFM_EXBUS_AREA0_ADDR1                 *((volatile unsigned int*)(0x427E0804UL))
#define bFM_EXBUS_AREA0_ADDR2                 *((volatile unsigned int*)(0x427E0808UL))
#define bFM_EXBUS_AREA0_ADDR3                 *((volatile unsigned int*)(0x427E080CUL))
#define bFM_EXBUS_AREA0_ADDR4                 *((volatile unsigned int*)(0x427E0810UL))
#define bFM_EXBUS_AREA0_ADDR5                 *((volatile unsigned int*)(0x427E0814UL))
#define bFM_EXBUS_AREA0_ADDR6                 *((volatile unsigned int*)(0x427E0818UL))
#define bFM_EXBUS_AREA0_ADDR7                 *((volatile unsigned int*)(0x427E081CUL))
#define bFM_EXBUS_AREA0_MASK0                 *((volatile unsigned int*)(0x427E0840UL))
#define bFM_EXBUS_AREA0_MASK1                 *((volatile unsigned int*)(0x427E0844UL))
#define bFM_EXBUS_AREA0_MASK2                 *((volatile unsigned int*)(0x427E0848UL))
#define bFM_EXBUS_AREA0_MASK3                 *((volatile unsigned int*)(0x427E084CUL))
#define bFM_EXBUS_AREA0_MASK4                 *((volatile unsigned int*)(0x427E0850UL))
#define bFM_EXBUS_AREA0_MASK5                 *((volatile unsigned int*)(0x427E0854UL))
#define bFM_EXBUS_AREA0_MASK6                 *((volatile unsigned int*)(0x427E0858UL))
#define bFM_EXBUS_AREA1_ADDR0                 *((volatile unsigned int*)(0x427E0880UL))
#define bFM_EXBUS_AREA1_ADDR1                 *((volatile unsigned int*)(0x427E0884UL))
#define bFM_EXBUS_AREA1_ADDR2                 *((volatile unsigned int*)(0x427E0888UL))
#define bFM_EXBUS_AREA1_ADDR3                 *((volatile unsigned int*)(0x427E088CUL))
#define bFM_EXBUS_AREA1_ADDR4                 *((volatile unsigned int*)(0x427E0890UL))
#define bFM_EXBUS_AREA1_ADDR5                 *((volatile unsigned int*)(0x427E0894UL))
#define bFM_EXBUS_AREA1_ADDR6                 *((volatile unsigned int*)(0x427E0898UL))
#define bFM_EXBUS_AREA1_ADDR7                 *((volatile unsigned int*)(0x427E089CUL))
#define bFM_EXBUS_AREA1_MASK0                 *((volatile unsigned int*)(0x427E08C0UL))
#define bFM_EXBUS_AREA1_MASK1                 *((volatile unsigned int*)(0x427E08C4UL))
#define bFM_EXBUS_AREA1_MASK2                 *((volatile unsigned int*)(0x427E08C8UL))
#define bFM_EXBUS_AREA1_MASK3                 *((volatile unsigned int*)(0x427E08CCUL))
#define bFM_EXBUS_AREA1_MASK4                 *((volatile unsigned int*)(0x427E08D0UL))
#define bFM_EXBUS_AREA1_MASK5                 *((volatile unsigned int*)(0x427E08D4UL))
#define bFM_EXBUS_AREA1_MASK6                 *((volatile unsigned int*)(0x427E08D8UL))
#define bFM_EXBUS_AREA2_ADDR0                 *((volatile unsigned int*)(0x427E0900UL))
#define bFM_EXBUS_AREA2_ADDR1                 *((volatile unsigned int*)(0x427E0904UL))
#define bFM_EXBUS_AREA2_ADDR2                 *((volatile unsigned int*)(0x427E0908UL))
#define bFM_EXBUS_AREA2_ADDR3                 *((volatile unsigned int*)(0x427E090CUL))
#define bFM_EXBUS_AREA2_ADDR4                 *((volatile unsigned int*)(0x427E0910UL))
#define bFM_EXBUS_AREA2_ADDR5                 *((volatile unsigned int*)(0x427E0914UL))
#define bFM_EXBUS_AREA2_ADDR6                 *((volatile unsigned int*)(0x427E0918UL))
#define bFM_EXBUS_AREA2_ADDR7                 *((volatile unsigned int*)(0x427E091CUL))
#define bFM_EXBUS_AREA2_MASK0                 *((volatile unsigned int*)(0x427E0940UL))
#define bFM_EXBUS_AREA2_MASK1                 *((volatile unsigned int*)(0x427E0944UL))
#define bFM_EXBUS_AREA2_MASK2                 *((volatile unsigned int*)(0x427E0948UL))
#define bFM_EXBUS_AREA2_MASK3                 *((volatile unsigned int*)(0x427E094CUL))
#define bFM_EXBUS_AREA2_MASK4                 *((volatile unsigned int*)(0x427E0950UL))
#define bFM_EXBUS_AREA2_MASK5                 *((volatile unsigned int*)(0x427E0954UL))
#define bFM_EXBUS_AREA2_MASK6                 *((volatile unsigned int*)(0x427E0958UL))
#define bFM_EXBUS_AREA3_ADDR0                 *((volatile unsigned int*)(0x427E0980UL))
#define bFM_EXBUS_AREA3_ADDR1                 *((volatile unsigned int*)(0x427E0984UL))
#define bFM_EXBUS_AREA3_ADDR2                 *((volatile unsigned int*)(0x427E0988UL))
#define bFM_EXBUS_AREA3_ADDR3                 *((volatile unsigned int*)(0x427E098CUL))
#define bFM_EXBUS_AREA3_ADDR4                 *((volatile unsigned int*)(0x427E0990UL))
#define bFM_EXBUS_AREA3_ADDR5                 *((volatile unsigned int*)(0x427E0994UL))
#define bFM_EXBUS_AREA3_ADDR6                 *((volatile unsigned int*)(0x427E0998UL))
#define bFM_EXBUS_AREA3_ADDR7                 *((volatile unsigned int*)(0x427E099CUL))
#define bFM_EXBUS_AREA3_MASK0                 *((volatile unsigned int*)(0x427E09C0UL))
#define bFM_EXBUS_AREA3_MASK1                 *((volatile unsigned int*)(0x427E09C4UL))
#define bFM_EXBUS_AREA3_MASK2                 *((volatile unsigned int*)(0x427E09C8UL))
#define bFM_EXBUS_AREA3_MASK3                 *((volatile unsigned int*)(0x427E09CCUL))
#define bFM_EXBUS_AREA3_MASK4                 *((volatile unsigned int*)(0x427E09D0UL))
#define bFM_EXBUS_AREA3_MASK5                 *((volatile unsigned int*)(0x427E09D4UL))
#define bFM_EXBUS_AREA3_MASK6                 *((volatile unsigned int*)(0x427E09D8UL))
#define bFM_EXBUS_AREA4_ADDR0                 *((volatile unsigned int*)(0x427E0A00UL))
#define bFM_EXBUS_AREA4_ADDR1                 *((volatile unsigned int*)(0x427E0A04UL))
#define bFM_EXBUS_AREA4_ADDR2                 *((volatile unsigned int*)(0x427E0A08UL))
#define bFM_EXBUS_AREA4_ADDR3                 *((volatile unsigned int*)(0x427E0A0CUL))
#define bFM_EXBUS_AREA4_ADDR4                 *((volatile unsigned int*)(0x427E0A10UL))
#define bFM_EXBUS_AREA4_ADDR5                 *((volatile unsigned int*)(0x427E0A14UL))
#define bFM_EXBUS_AREA4_ADDR6                 *((volatile unsigned int*)(0x427E0A18UL))
#define bFM_EXBUS_AREA4_ADDR7                 *((volatile unsigned int*)(0x427E0A1CUL))
#define bFM_EXBUS_AREA4_MASK0                 *((volatile unsigned int*)(0x427E0A40UL))
#define bFM_EXBUS_AREA4_MASK1                 *((volatile unsigned int*)(0x427E0A44UL))
#define bFM_EXBUS_AREA4_MASK2                 *((volatile unsigned int*)(0x427E0A48UL))
#define bFM_EXBUS_AREA4_MASK3                 *((volatile unsigned int*)(0x427E0A4CUL))
#define bFM_EXBUS_AREA4_MASK4                 *((volatile unsigned int*)(0x427E0A50UL))
#define bFM_EXBUS_AREA4_MASK5                 *((volatile unsigned int*)(0x427E0A54UL))
#define bFM_EXBUS_AREA4_MASK6                 *((volatile unsigned int*)(0x427E0A58UL))
#define bFM_EXBUS_AREA5_ADDR0                 *((volatile unsigned int*)(0x427E0A80UL))
#define bFM_EXBUS_AREA5_ADDR1                 *((volatile unsigned int*)(0x427E0A84UL))
#define bFM_EXBUS_AREA5_ADDR2                 *((volatile unsigned int*)(0x427E0A88UL))
#define bFM_EXBUS_AREA5_ADDR3                 *((volatile unsigned int*)(0x427E0A8CUL))
#define bFM_EXBUS_AREA5_ADDR4                 *((volatile unsigned int*)(0x427E0A90UL))
#define bFM_EXBUS_AREA5_ADDR5                 *((volatile unsigned int*)(0x427E0A94UL))
#define bFM_EXBUS_AREA5_ADDR6                 *((volatile unsigned int*)(0x427E0A98UL))
#define bFM_EXBUS_AREA5_ADDR7                 *((volatile unsigned int*)(0x427E0A9CUL))
#define bFM_EXBUS_AREA5_MASK0                 *((volatile unsigned int*)(0x427E0AC0UL))
#define bFM_EXBUS_AREA5_MASK1                 *((volatile unsigned int*)(0x427E0AC4UL))
#define bFM_EXBUS_AREA5_MASK2                 *((volatile unsigned int*)(0x427E0AC8UL))
#define bFM_EXBUS_AREA5_MASK3                 *((volatile unsigned int*)(0x427E0ACCUL))
#define bFM_EXBUS_AREA5_MASK4                 *((volatile unsigned int*)(0x427E0AD0UL))
#define bFM_EXBUS_AREA5_MASK5                 *((volatile unsigned int*)(0x427E0AD4UL))
#define bFM_EXBUS_AREA5_MASK6                 *((volatile unsigned int*)(0x427E0AD8UL))
#define bFM_EXBUS_AREA6_ADDR0                 *((volatile unsigned int*)(0x427E0B00UL))
#define bFM_EXBUS_AREA6_ADDR1                 *((volatile unsigned int*)(0x427E0B04UL))
#define bFM_EXBUS_AREA6_ADDR2                 *((volatile unsigned int*)(0x427E0B08UL))
#define bFM_EXBUS_AREA6_ADDR3                 *((volatile unsigned int*)(0x427E0B0CUL))
#define bFM_EXBUS_AREA6_ADDR4                 *((volatile unsigned int*)(0x427E0B10UL))
#define bFM_EXBUS_AREA6_ADDR5                 *((volatile unsigned int*)(0x427E0B14UL))
#define bFM_EXBUS_AREA6_ADDR6                 *((volatile unsigned int*)(0x427E0B18UL))
#define bFM_EXBUS_AREA6_ADDR7                 *((volatile unsigned int*)(0x427E0B1CUL))
#define bFM_EXBUS_AREA6_MASK0                 *((volatile unsigned int*)(0x427E0B40UL))
#define bFM_EXBUS_AREA6_MASK1                 *((volatile unsigned int*)(0x427E0B44UL))
#define bFM_EXBUS_AREA6_MASK2                 *((volatile unsigned int*)(0x427E0B48UL))
#define bFM_EXBUS_AREA6_MASK3                 *((volatile unsigned int*)(0x427E0B4CUL))
#define bFM_EXBUS_AREA6_MASK4                 *((volatile unsigned int*)(0x427E0B50UL))
#define bFM_EXBUS_AREA6_MASK5                 *((volatile unsigned int*)(0x427E0B54UL))
#define bFM_EXBUS_AREA6_MASK6                 *((volatile unsigned int*)(0x427E0B58UL))
#define bFM_EXBUS_AREA7_ADDR0                 *((volatile unsigned int*)(0x427E0B80UL))
#define bFM_EXBUS_AREA7_ADDR1                 *((volatile unsigned int*)(0x427E0B84UL))
#define bFM_EXBUS_AREA7_ADDR2                 *((volatile unsigned int*)(0x427E0B88UL))
#define bFM_EXBUS_AREA7_ADDR3                 *((volatile unsigned int*)(0x427E0B8CUL))
#define bFM_EXBUS_AREA7_ADDR4                 *((volatile unsigned int*)(0x427E0B90UL))
#define bFM_EXBUS_AREA7_ADDR5                 *((volatile unsigned int*)(0x427E0B94UL))
#define bFM_EXBUS_AREA7_ADDR6                 *((volatile unsigned int*)(0x427E0B98UL))
#define bFM_EXBUS_AREA7_ADDR7                 *((volatile unsigned int*)(0x427E0B9CUL))
#define bFM_EXBUS_AREA7_MASK0                 *((volatile unsigned int*)(0x427E0BC0UL))
#define bFM_EXBUS_AREA7_MASK1                 *((volatile unsigned int*)(0x427E0BC4UL))
#define bFM_EXBUS_AREA7_MASK2                 *((volatile unsigned int*)(0x427E0BC8UL))
#define bFM_EXBUS_AREA7_MASK3                 *((volatile unsigned int*)(0x427E0BCCUL))
#define bFM_EXBUS_AREA7_MASK4                 *((volatile unsigned int*)(0x427E0BD0UL))
#define bFM_EXBUS_AREA7_MASK5                 *((volatile unsigned int*)(0x427E0BD4UL))
#define bFM_EXBUS_AREA7_MASK6                 *((volatile unsigned int*)(0x427E0BD8UL))
#define bFM_EXBUS_ATIM0_ALC0                  *((volatile unsigned int*)(0x427E0C00UL))
#define bFM_EXBUS_ATIM0_ALC1                  *((volatile unsigned int*)(0x427E0C04UL))
#define bFM_EXBUS_ATIM0_ALC2                  *((volatile unsigned int*)(0x427E0C08UL))
#define bFM_EXBUS_ATIM0_ALC3                  *((volatile unsigned int*)(0x427E0C0CUL))
#define bFM_EXBUS_ATIM0_ALES0                 *((volatile unsigned int*)(0x427E0C10UL))
#define bFM_EXBUS_ATIM0_ALES1                 *((volatile unsigned int*)(0x427E0C14UL))
#define bFM_EXBUS_ATIM0_ALES2                 *((volatile unsigned int*)(0x427E0C18UL))
#define bFM_EXBUS_ATIM0_ALES3                 *((volatile unsigned int*)(0x427E0C1CUL))
#define bFM_EXBUS_ATIM0_ALEW0                 *((volatile unsigned int*)(0x427E0C20UL))
#define bFM_EXBUS_ATIM0_ALEW1                 *((volatile unsigned int*)(0x427E0C24UL))
#define bFM_EXBUS_ATIM0_ALEW2                 *((volatile unsigned int*)(0x427E0C28UL))
#define bFM_EXBUS_ATIM0_ALEW3                 *((volatile unsigned int*)(0x427E0C2CUL))
#define bFM_EXBUS_ATIM1_ALC0                  *((volatile unsigned int*)(0x427E0C80UL))
#define bFM_EXBUS_ATIM1_ALC1                  *((volatile unsigned int*)(0x427E0C84UL))
#define bFM_EXBUS_ATIM1_ALC2                  *((volatile unsigned int*)(0x427E0C88UL))
#define bFM_EXBUS_ATIM1_ALC3                  *((volatile unsigned int*)(0x427E0C8CUL))
#define bFM_EXBUS_ATIM1_ALES0                 *((volatile unsigned int*)(0x427E0C90UL))
#define bFM_EXBUS_ATIM1_ALES1                 *((volatile unsigned int*)(0x427E0C94UL))
#define bFM_EXBUS_ATIM1_ALES2                 *((volatile unsigned int*)(0x427E0C98UL))
#define bFM_EXBUS_ATIM1_ALES3                 *((volatile unsigned int*)(0x427E0C9CUL))
#define bFM_EXBUS_ATIM1_ALEW0                 *((volatile unsigned int*)(0x427E0CA0UL))
#define bFM_EXBUS_ATIM1_ALEW1                 *((volatile unsigned int*)(0x427E0CA4UL))
#define bFM_EXBUS_ATIM1_ALEW2                 *((volatile unsigned int*)(0x427E0CA8UL))
#define bFM_EXBUS_ATIM1_ALEW3                 *((volatile unsigned int*)(0x427E0CACUL))
#define bFM_EXBUS_ATIM2_ALC0                  *((volatile unsigned int*)(0x427E0D00UL))
#define bFM_EXBUS_ATIM2_ALC1                  *((volatile unsigned int*)(0x427E0D04UL))
#define bFM_EXBUS_ATIM2_ALC2                  *((volatile unsigned int*)(0x427E0D08UL))
#define bFM_EXBUS_ATIM2_ALC3                  *((volatile unsigned int*)(0x427E0D0CUL))
#define bFM_EXBUS_ATIM2_ALES0                 *((volatile unsigned int*)(0x427E0D10UL))
#define bFM_EXBUS_ATIM2_ALES1                 *((volatile unsigned int*)(0x427E0D14UL))
#define bFM_EXBUS_ATIM2_ALES2                 *((volatile unsigned int*)(0x427E0D18UL))
#define bFM_EXBUS_ATIM2_ALES3                 *((volatile unsigned int*)(0x427E0D1CUL))
#define bFM_EXBUS_ATIM2_ALEW0                 *((volatile unsigned int*)(0x427E0D20UL))
#define bFM_EXBUS_ATIM2_ALEW1                 *((volatile unsigned int*)(0x427E0D24UL))
#define bFM_EXBUS_ATIM2_ALEW2                 *((volatile unsigned int*)(0x427E0D28UL))
#define bFM_EXBUS_ATIM2_ALEW3                 *((volatile unsigned int*)(0x427E0D2CUL))
#define bFM_EXBUS_ATIM3_ALC0                  *((volatile unsigned int*)(0x427E0D80UL))
#define bFM_EXBUS_ATIM3_ALC1                  *((volatile unsigned int*)(0x427E0D84UL))
#define bFM_EXBUS_ATIM3_ALC2                  *((volatile unsigned int*)(0x427E0D88UL))
#define bFM_EXBUS_ATIM3_ALC3                  *((volatile unsigned int*)(0x427E0D8CUL))
#define bFM_EXBUS_ATIM3_ALES0                 *((volatile unsigned int*)(0x427E0D90UL))
#define bFM_EXBUS_ATIM3_ALES1                 *((volatile unsigned int*)(0x427E0D94UL))
#define bFM_EXBUS_ATIM3_ALES2                 *((volatile unsigned int*)(0x427E0D98UL))
#define bFM_EXBUS_ATIM3_ALES3                 *((volatile unsigned int*)(0x427E0D9CUL))
#define bFM_EXBUS_ATIM3_ALEW0                 *((volatile unsigned int*)(0x427E0DA0UL))
#define bFM_EXBUS_ATIM3_ALEW1                 *((volatile unsigned int*)(0x427E0DA4UL))
#define bFM_EXBUS_ATIM3_ALEW2                 *((volatile unsigned int*)(0x427E0DA8UL))
#define bFM_EXBUS_ATIM3_ALEW3                 *((volatile unsigned int*)(0x427E0DACUL))
#define bFM_EXBUS_ATIM4_ALC0                  *((volatile unsigned int*)(0x427E0E00UL))
#define bFM_EXBUS_ATIM4_ALC1                  *((volatile unsigned int*)(0x427E0E04UL))
#define bFM_EXBUS_ATIM4_ALC2                  *((volatile unsigned int*)(0x427E0E08UL))
#define bFM_EXBUS_ATIM4_ALC3                  *((volatile unsigned int*)(0x427E0E0CUL))
#define bFM_EXBUS_ATIM4_ALES0                 *((volatile unsigned int*)(0x427E0E10UL))
#define bFM_EXBUS_ATIM4_ALES1                 *((volatile unsigned int*)(0x427E0E14UL))
#define bFM_EXBUS_ATIM4_ALES2                 *((volatile unsigned int*)(0x427E0E18UL))
#define bFM_EXBUS_ATIM4_ALES3                 *((volatile unsigned int*)(0x427E0E1CUL))
#define bFM_EXBUS_ATIM4_ALEW0                 *((volatile unsigned int*)(0x427E0E20UL))
#define bFM_EXBUS_ATIM4_ALEW1                 *((volatile unsigned int*)(0x427E0E24UL))
#define bFM_EXBUS_ATIM4_ALEW2                 *((volatile unsigned int*)(0x427E0E28UL))
#define bFM_EXBUS_ATIM4_ALEW3                 *((volatile unsigned int*)(0x427E0E2CUL))
#define bFM_EXBUS_ATIM5_ALC0                  *((volatile unsigned int*)(0x427E0E80UL))
#define bFM_EXBUS_ATIM5_ALC1                  *((volatile unsigned int*)(0x427E0E84UL))
#define bFM_EXBUS_ATIM5_ALC2                  *((volatile unsigned int*)(0x427E0E88UL))
#define bFM_EXBUS_ATIM5_ALC3                  *((volatile unsigned int*)(0x427E0E8CUL))
#define bFM_EXBUS_ATIM5_ALES0                 *((volatile unsigned int*)(0x427E0E90UL))
#define bFM_EXBUS_ATIM5_ALES1                 *((volatile unsigned int*)(0x427E0E94UL))
#define bFM_EXBUS_ATIM5_ALES2                 *((volatile unsigned int*)(0x427E0E98UL))
#define bFM_EXBUS_ATIM5_ALES3                 *((volatile unsigned int*)(0x427E0E9CUL))
#define bFM_EXBUS_ATIM5_ALEW0                 *((volatile unsigned int*)(0x427E0EA0UL))
#define bFM_EXBUS_ATIM5_ALEW1                 *((volatile unsigned int*)(0x427E0EA4UL))
#define bFM_EXBUS_ATIM5_ALEW2                 *((volatile unsigned int*)(0x427E0EA8UL))
#define bFM_EXBUS_ATIM5_ALEW3                 *((volatile unsigned int*)(0x427E0EACUL))
#define bFM_EXBUS_ATIM6_ALC0                  *((volatile unsigned int*)(0x427E0F00UL))
#define bFM_EXBUS_ATIM6_ALC1                  *((volatile unsigned int*)(0x427E0F04UL))
#define bFM_EXBUS_ATIM6_ALC2                  *((volatile unsigned int*)(0x427E0F08UL))
#define bFM_EXBUS_ATIM6_ALC3                  *((volatile unsigned int*)(0x427E0F0CUL))
#define bFM_EXBUS_ATIM6_ALES0                 *((volatile unsigned int*)(0x427E0F10UL))
#define bFM_EXBUS_ATIM6_ALES1                 *((volatile unsigned int*)(0x427E0F14UL))
#define bFM_EXBUS_ATIM6_ALES2                 *((volatile unsigned int*)(0x427E0F18UL))
#define bFM_EXBUS_ATIM6_ALES3                 *((volatile unsigned int*)(0x427E0F1CUL))
#define bFM_EXBUS_ATIM6_ALEW0                 *((volatile unsigned int*)(0x427E0F20UL))
#define bFM_EXBUS_ATIM6_ALEW1                 *((volatile unsigned int*)(0x427E0F24UL))
#define bFM_EXBUS_ATIM6_ALEW2                 *((volatile unsigned int*)(0x427E0F28UL))
#define bFM_EXBUS_ATIM6_ALEW3                 *((volatile unsigned int*)(0x427E0F2CUL))
#define bFM_EXBUS_ATIM7_ALC0                  *((volatile unsigned int*)(0x427E0F80UL))
#define bFM_EXBUS_ATIM7_ALC1                  *((volatile unsigned int*)(0x427E0F84UL))
#define bFM_EXBUS_ATIM7_ALC2                  *((volatile unsigned int*)(0x427E0F88UL))
#define bFM_EXBUS_ATIM7_ALC3                  *((volatile unsigned int*)(0x427E0F8CUL))
#define bFM_EXBUS_ATIM7_ALES0                 *((volatile unsigned int*)(0x427E0F90UL))
#define bFM_EXBUS_ATIM7_ALES1                 *((volatile unsigned int*)(0x427E0F94UL))
#define bFM_EXBUS_ATIM7_ALES2                 *((volatile unsigned int*)(0x427E0F98UL))
#define bFM_EXBUS_ATIM7_ALES3                 *((volatile unsigned int*)(0x427E0F9CUL))
#define bFM_EXBUS_ATIM7_ALEW0                 *((volatile unsigned int*)(0x427E0FA0UL))
#define bFM_EXBUS_ATIM7_ALEW1                 *((volatile unsigned int*)(0x427E0FA4UL))
#define bFM_EXBUS_ATIM7_ALEW2                 *((volatile unsigned int*)(0x427E0FA8UL))
#define bFM_EXBUS_ATIM7_ALEW3                 *((volatile unsigned int*)(0x427E0FACUL))
#define bFM_EXBUS_SDMODE_SDON                 *((volatile unsigned int*)(0x427E2000UL))
#define bFM_EXBUS_SDMODE_PDON                 *((volatile unsigned int*)(0x427E2004UL))
#define bFM_EXBUS_SDMODE_ROFF                 *((volatile unsigned int*)(0x427E2008UL))
#define bFM_EXBUS_SDMODE_CASEL0               *((volatile unsigned int*)(0x427E2010UL))
#define bFM_EXBUS_SDMODE_CASEL1               *((volatile unsigned int*)(0x427E2014UL))
#define bFM_EXBUS_SDMODE_RASEL0               *((volatile unsigned int*)(0x427E2020UL))
#define bFM_EXBUS_SDMODE_RASEL1               *((volatile unsigned int*)(0x427E2024UL))
#define bFM_EXBUS_SDMODE_RASEL2               *((volatile unsigned int*)(0x427E2028UL))
#define bFM_EXBUS_SDMODE_RASEL3               *((volatile unsigned int*)(0x427E202CUL))
#define bFM_EXBUS_SDMODE_BASEL0               *((volatile unsigned int*)(0x427E2030UL))
#define bFM_EXBUS_SDMODE_BASEL1               *((volatile unsigned int*)(0x427E2034UL))
#define bFM_EXBUS_SDMODE_BASEL2               *((volatile unsigned int*)(0x427E2038UL))
#define bFM_EXBUS_SDMODE_BASEL3               *((volatile unsigned int*)(0x427E203CUL))
#define bFM_EXBUS_SDMODE_MSDCLKOFF            *((volatile unsigned int*)(0x427E2040UL))
#define bFM_EXBUS_REFTIM_REFC0                *((volatile unsigned int*)(0x427E2080UL))
#define bFM_EXBUS_REFTIM_REFC1                *((volatile unsigned int*)(0x427E2084UL))
#define bFM_EXBUS_REFTIM_REFC2                *((volatile unsigned int*)(0x427E2088UL))
#define bFM_EXBUS_REFTIM_REFC3                *((volatile unsigned int*)(0x427E208CUL))
#define bFM_EXBUS_REFTIM_REFC4                *((volatile unsigned int*)(0x427E2090UL))
#define bFM_EXBUS_REFTIM_REFC5                *((volatile unsigned int*)(0x427E2094UL))
#define bFM_EXBUS_REFTIM_REFC6                *((volatile unsigned int*)(0x427E2098UL))
#define bFM_EXBUS_REFTIM_REFC7                *((volatile unsigned int*)(0x427E209CUL))
#define bFM_EXBUS_REFTIM_REFC8                *((volatile unsigned int*)(0x427E20A0UL))
#define bFM_EXBUS_REFTIM_REFC9                *((volatile unsigned int*)(0x427E20A4UL))
#define bFM_EXBUS_REFTIM_REFC10               *((volatile unsigned int*)(0x427E20A8UL))
#define bFM_EXBUS_REFTIM_REFC11               *((volatile unsigned int*)(0x427E20ACUL))
#define bFM_EXBUS_REFTIM_REFC12               *((volatile unsigned int*)(0x427E20B0UL))
#define bFM_EXBUS_REFTIM_REFC13               *((volatile unsigned int*)(0x427E20B4UL))
#define bFM_EXBUS_REFTIM_REFC14               *((volatile unsigned int*)(0x427E20B8UL))
#define bFM_EXBUS_REFTIM_REFC15               *((volatile unsigned int*)(0x427E20BCUL))
#define bFM_EXBUS_REFTIM_NREF0                *((volatile unsigned int*)(0x427E20C0UL))
#define bFM_EXBUS_REFTIM_NREF1                *((volatile unsigned int*)(0x427E20C4UL))
#define bFM_EXBUS_REFTIM_NREF2                *((volatile unsigned int*)(0x427E20C8UL))
#define bFM_EXBUS_REFTIM_NREF3                *((volatile unsigned int*)(0x427E20CCUL))
#define bFM_EXBUS_REFTIM_NREF4                *((volatile unsigned int*)(0x427E20D0UL))
#define bFM_EXBUS_REFTIM_NREF5                *((volatile unsigned int*)(0x427E20D4UL))
#define bFM_EXBUS_REFTIM_NREF6                *((volatile unsigned int*)(0x427E20D8UL))
#define bFM_EXBUS_REFTIM_NREF7                *((volatile unsigned int*)(0x427E20DCUL))
#define bFM_EXBUS_REFTIM_PREF                 *((volatile unsigned int*)(0x427E20E0UL))
#define bFM_EXBUS_PWRDWN_PDC0                 *((volatile unsigned int*)(0x427E2100UL))
#define bFM_EXBUS_PWRDWN_PDC1                 *((volatile unsigned int*)(0x427E2104UL))
#define bFM_EXBUS_PWRDWN_PDC2                 *((volatile unsigned int*)(0x427E2108UL))
#define bFM_EXBUS_PWRDWN_PDC3                 *((volatile unsigned int*)(0x427E210CUL))
#define bFM_EXBUS_PWRDWN_PDC4                 *((volatile unsigned int*)(0x427E2110UL))
#define bFM_EXBUS_PWRDWN_PDC5                 *((volatile unsigned int*)(0x427E2114UL))
#define bFM_EXBUS_PWRDWN_PDC6                 *((volatile unsigned int*)(0x427E2118UL))
#define bFM_EXBUS_PWRDWN_PDC7                 *((volatile unsigned int*)(0x427E211CUL))
#define bFM_EXBUS_PWRDWN_PDC8                 *((volatile unsigned int*)(0x427E2120UL))
#define bFM_EXBUS_PWRDWN_PDC9                 *((volatile unsigned int*)(0x427E2124UL))
#define bFM_EXBUS_PWRDWN_PDC10                *((volatile unsigned int*)(0x427E2128UL))
#define bFM_EXBUS_PWRDWN_PDC11                *((volatile unsigned int*)(0x427E212CUL))
#define bFM_EXBUS_PWRDWN_PDC12                *((volatile unsigned int*)(0x427E2130UL))
#define bFM_EXBUS_PWRDWN_PDC13                *((volatile unsigned int*)(0x427E2134UL))
#define bFM_EXBUS_PWRDWN_PDC14                *((volatile unsigned int*)(0x427E2138UL))
#define bFM_EXBUS_PWRDWN_PDC15                *((volatile unsigned int*)(0x427E213CUL))
#define bFM_EXBUS_SDTIM_CL0                   *((volatile unsigned int*)(0x427E2180UL))
#define bFM_EXBUS_SDTIM_CL1                   *((volatile unsigned int*)(0x427E2184UL))
#define bFM_EXBUS_SDTIM_TRC0                  *((volatile unsigned int*)(0x427E2190UL))
#define bFM_EXBUS_SDTIM_TRC1                  *((volatile unsigned int*)(0x427E2194UL))
#define bFM_EXBUS_SDTIM_TRC2                  *((volatile unsigned int*)(0x427E2198UL))
#define bFM_EXBUS_SDTIM_TRC3                  *((volatile unsigned int*)(0x427E219CUL))
#define bFM_EXBUS_SDTIM_TRP0                  *((volatile unsigned int*)(0x427E21A0UL))
#define bFM_EXBUS_SDTIM_TRP1                  *((volatile unsigned int*)(0x427E21A4UL))
#define bFM_EXBUS_SDTIM_TRP2                  *((volatile unsigned int*)(0x427E21A8UL))
#define bFM_EXBUS_SDTIM_TRP3                  *((volatile unsigned int*)(0x427E21ACUL))
#define bFM_EXBUS_SDTIM_TRCD0                 *((volatile unsigned int*)(0x427E21B0UL))
#define bFM_EXBUS_SDTIM_TRCD1                 *((volatile unsigned int*)(0x427E21B4UL))
#define bFM_EXBUS_SDTIM_TRCD2                 *((volatile unsigned int*)(0x427E21B8UL))
#define bFM_EXBUS_SDTIM_TRCD3                 *((volatile unsigned int*)(0x427E21BCUL))
#define bFM_EXBUS_SDTIM_TRAS0                 *((volatile unsigned int*)(0x427E21C0UL))
#define bFM_EXBUS_SDTIM_TRAS1                 *((volatile unsigned int*)(0x427E21C4UL))
#define bFM_EXBUS_SDTIM_TRAS2                 *((volatile unsigned int*)(0x427E21C8UL))
#define bFM_EXBUS_SDTIM_TRAS3                 *((volatile unsigned int*)(0x427E21CCUL))
#define bFM_EXBUS_SDTIM_TREFC0                *((volatile unsigned int*)(0x427E21D0UL))
#define bFM_EXBUS_SDTIM_TREFC1                *((volatile unsigned int*)(0x427E21D4UL))
#define bFM_EXBUS_SDTIM_TREFC2                *((volatile unsigned int*)(0x427E21D8UL))
#define bFM_EXBUS_SDTIM_TREFC3                *((volatile unsigned int*)(0x427E21DCUL))
#define bFM_EXBUS_SDTIM_TDPL0                 *((volatile unsigned int*)(0x427E21E0UL))
#define bFM_EXBUS_SDTIM_TDPL1                 *((volatile unsigned int*)(0x427E21E4UL))
#define bFM_EXBUS_SDTIM_BOFF                  *((volatile unsigned int*)(0x427E21FCUL))
#define bFM_EXBUS_SDCMD_SDAD0                 *((volatile unsigned int*)(0x427E2200UL))
#define bFM_EXBUS_SDCMD_SDAD1                 *((volatile unsigned int*)(0x427E2204UL))
#define bFM_EXBUS_SDCMD_SDAD2                 *((volatile unsigned int*)(0x427E2208UL))
#define bFM_EXBUS_SDCMD_SDAD3                 *((volatile unsigned int*)(0x427E220CUL))
#define bFM_EXBUS_SDCMD_SDAD4                 *((volatile unsigned int*)(0x427E2210UL))
#define bFM_EXBUS_SDCMD_SDAD5                 *((volatile unsigned int*)(0x427E2214UL))
#define bFM_EXBUS_SDCMD_SDAD6                 *((volatile unsigned int*)(0x427E2218UL))
#define bFM_EXBUS_SDCMD_SDAD7                 *((volatile unsigned int*)(0x427E221CUL))
#define bFM_EXBUS_SDCMD_SDAD8                 *((volatile unsigned int*)(0x427E2220UL))
#define bFM_EXBUS_SDCMD_SDAD9                 *((volatile unsigned int*)(0x427E2224UL))
#define bFM_EXBUS_SDCMD_SDAD10                *((volatile unsigned int*)(0x427E2228UL))
#define bFM_EXBUS_SDCMD_SDAD11                *((volatile unsigned int*)(0x427E222CUL))
#define bFM_EXBUS_SDCMD_SDAD12                *((volatile unsigned int*)(0x427E2230UL))
#define bFM_EXBUS_SDCMD_SDAD13                *((volatile unsigned int*)(0x427E2234UL))
#define bFM_EXBUS_SDCMD_SDAD14                *((volatile unsigned int*)(0x427E2238UL))
#define bFM_EXBUS_SDCMD_SDAD15                *((volatile unsigned int*)(0x427E223CUL))
#define bFM_EXBUS_SDCMD_SDWE                  *((volatile unsigned int*)(0x427E2240UL))
#define bFM_EXBUS_SDCMD_SDCAS                 *((volatile unsigned int*)(0x427E2244UL))
#define bFM_EXBUS_SDCMD_SDRAS                 *((volatile unsigned int*)(0x427E2248UL))
#define bFM_EXBUS_SDCMD_SDCS                  *((volatile unsigned int*)(0x427E224CUL))
#define bFM_EXBUS_SDCMD_SDCKE                 *((volatile unsigned int*)(0x427E2250UL))
#define bFM_EXBUS_SDCMD_PEND                  *((volatile unsigned int*)(0x427E227CUL))
#define bFM_EXBUS_MEMCERR_SFER                *((volatile unsigned int*)(0x427E4000UL))
#define bFM_EXBUS_MEMCERR_SDER                *((volatile unsigned int*)(0x427E4004UL))
#define bFM_EXBUS_MEMCERR_SFION               *((volatile unsigned int*)(0x427E4008UL))
#define bFM_EXBUS_MEMCERR_SDION               *((volatile unsigned int*)(0x427E400CUL))
#define bFM_EXBUS_DCLKR_MDIV0                 *((volatile unsigned int*)(0x427E6000UL))
#define bFM_EXBUS_DCLKR_MDIV1                 *((volatile unsigned int*)(0x427E6004UL))
#define bFM_EXBUS_DCLKR_MDIV2                 *((volatile unsigned int*)(0x427E6008UL))
#define bFM_EXBUS_DCLKR_MDIV3                 *((volatile unsigned int*)(0x427E600CUL))
#define bFM_EXBUS_DCLKR_MCLKON                *((volatile unsigned int*)(0x427E6010UL))
#define bFM_EXBUS_EST_WERR                    *((volatile unsigned int*)(0x427E6080UL))
#define bFM_EXBUS_WEAD_ADDR0                  *((volatile unsigned int*)(0x427E6100UL))
#define bFM_EXBUS_WEAD_ADDR1                  *((volatile unsigned int*)(0x427E6104UL))
#define bFM_EXBUS_WEAD_ADDR2                  *((volatile unsigned int*)(0x427E6108UL))
#define bFM_EXBUS_WEAD_ADDR3                  *((volatile unsigned int*)(0x427E610CUL))
#define bFM_EXBUS_WEAD_ADDR4                  *((volatile unsigned int*)(0x427E6110UL))
#define bFM_EXBUS_WEAD_ADDR5                  *((volatile unsigned int*)(0x427E6114UL))
#define bFM_EXBUS_WEAD_ADDR6                  *((volatile unsigned int*)(0x427E6118UL))
#define bFM_EXBUS_WEAD_ADDR7                  *((volatile unsigned int*)(0x427E611CUL))
#define bFM_EXBUS_WEAD_ADDR8                  *((volatile unsigned int*)(0x427E6120UL))
#define bFM_EXBUS_WEAD_ADDR9                  *((volatile unsigned int*)(0x427E6124UL))
#define bFM_EXBUS_WEAD_ADDR10                 *((volatile unsigned int*)(0x427E6128UL))
#define bFM_EXBUS_WEAD_ADDR11                 *((volatile unsigned int*)(0x427E612CUL))
#define bFM_EXBUS_WEAD_ADDR12                 *((volatile unsigned int*)(0x427E6130UL))
#define bFM_EXBUS_WEAD_ADDR13                 *((volatile unsigned int*)(0x427E6134UL))
#define bFM_EXBUS_WEAD_ADDR14                 *((volatile unsigned int*)(0x427E6138UL))
#define bFM_EXBUS_WEAD_ADDR15                 *((volatile unsigned int*)(0x427E613CUL))
#define bFM_EXBUS_WEAD_ADDR16                 *((volatile unsigned int*)(0x427E6140UL))
#define bFM_EXBUS_WEAD_ADDR17                 *((volatile unsigned int*)(0x427E6144UL))
#define bFM_EXBUS_WEAD_ADDR18                 *((volatile unsigned int*)(0x427E6148UL))
#define bFM_EXBUS_WEAD_ADDR19                 *((volatile unsigned int*)(0x427E614CUL))
#define bFM_EXBUS_WEAD_ADDR20                 *((volatile unsigned int*)(0x427E6150UL))
#define bFM_EXBUS_WEAD_ADDR21                 *((volatile unsigned int*)(0x427E6154UL))
#define bFM_EXBUS_WEAD_ADDR22                 *((volatile unsigned int*)(0x427E6158UL))
#define bFM_EXBUS_WEAD_ADDR23                 *((volatile unsigned int*)(0x427E615CUL))
#define bFM_EXBUS_WEAD_ADDR24                 *((volatile unsigned int*)(0x427E6160UL))
#define bFM_EXBUS_WEAD_ADDR25                 *((volatile unsigned int*)(0x427E6164UL))
#define bFM_EXBUS_WEAD_ADDR26                 *((volatile unsigned int*)(0x427E6168UL))
#define bFM_EXBUS_WEAD_ADDR27                 *((volatile unsigned int*)(0x427E616CUL))
#define bFM_EXBUS_WEAD_ADDR28                 *((volatile unsigned int*)(0x427E6170UL))
#define bFM_EXBUS_WEAD_ADDR29                 *((volatile unsigned int*)(0x427E6174UL))
#define bFM_EXBUS_WEAD_ADDR30                 *((volatile unsigned int*)(0x427E6178UL))
#define bFM_EXBUS_WEAD_ADDR31                 *((volatile unsigned int*)(0x427E617CUL))
#define bFM_EXBUS_ESCLR_WERRCLR               *((volatile unsigned int*)(0x427E6180UL))
#define bFM_EXBUS_AMODE_WAEN                  *((volatile unsigned int*)(0x427E6200UL))

/* USB channel 0 registers */
#define bFM_USB0_HCNT_HOST                    *((volatile unsigned char*)(0x42842000UL))
#define bFM_USB0_HCNT_URST                    *((volatile unsigned char*)(0x42842004UL))
#define bFM_USB0_HCNT_SOFIRE                  *((volatile unsigned char*)(0x42842008UL))
#define bFM_USB0_HCNT_DIRE                    *((volatile unsigned char*)(0x4284200CUL))
#define bFM_USB0_HCNT_CNNIRE                  *((volatile unsigned char*)(0x42842010UL))
#define bFM_USB0_HCNT_CMPIRE                  *((volatile unsigned char*)(0x42842014UL))
#define bFM_USB0_HCNT_URIRE                   *((volatile unsigned char*)(0x42842018UL))
#define bFM_USB0_HCNT_RWKIRE                  *((volatile unsigned char*)(0x4284201CUL))
#define bFM_USB0_HCNT_RETRY                   *((volatile unsigned char*)(0x42842020UL))
#define bFM_USB0_HCNT_CANCEL                  *((volatile unsigned char*)(0x42842024UL))
#define bFM_USB0_HCNT_SOFSTEP                 *((volatile unsigned char*)(0x42842028UL))
#define bFM_USB0_HCNT0_HOST                   *((volatile unsigned char*)(0x42842000UL))
#define bFM_USB0_HCNT0_URST                   *((volatile unsigned char*)(0x42842004UL))
#define bFM_USB0_HCNT0_SOFIRE                 *((volatile unsigned char*)(0x42842008UL))
#define bFM_USB0_HCNT0_DIRE                   *((volatile unsigned char*)(0x4284200CUL))
#define bFM_USB0_HCNT0_CNNIRE                 *((volatile unsigned char*)(0x42842010UL))
#define bFM_USB0_HCNT0_CMPIRE                 *((volatile unsigned char*)(0x42842014UL))
#define bFM_USB0_HCNT0_URIRE                  *((volatile unsigned char*)(0x42842018UL))
#define bFM_USB0_HCNT0_RWKIRE                 *((volatile unsigned char*)(0x4284201CUL))
#define bFM_USB0_HCNT1_RETRY                  *((volatile unsigned char*)(0x42842020UL))
#define bFM_USB0_HCNT1_CANCEL                 *((volatile unsigned char*)(0x42842024UL))
#define bFM_USB0_HCNT1_SOFSTEP                *((volatile unsigned char*)(0x42842028UL))
#define bFM_USB0_HIRQ_SOFIRQ                  *((volatile unsigned char*)(0x42842080UL))
#define bFM_USB0_HIRQ_DIRQ                    *((volatile unsigned char*)(0x42842084UL))
#define bFM_USB0_HIRQ_CNNIRQ                  *((volatile unsigned char*)(0x42842088UL))
#define bFM_USB0_HIRQ_CMPIRQ                  *((volatile unsigned char*)(0x4284208CUL))
#define bFM_USB0_HIRQ_URIRQ                   *((volatile unsigned char*)(0x42842090UL))
#define bFM_USB0_HIRQ_RWKIRQ                  *((volatile unsigned char*)(0x42842094UL))
#define bFM_USB0_HIRQ_TCAN                    *((volatile unsigned char*)(0x4284209CUL))
#define bFM_USB0_HERR_HS0                     *((volatile unsigned char*)(0x428420A0UL))
#define bFM_USB0_HERR_HS1                     *((volatile unsigned char*)(0x428420A4UL))
#define bFM_USB0_HERR_STUFF                   *((volatile unsigned char*)(0x428420A8UL))
#define bFM_USB0_HERR_TGERR                   *((volatile unsigned char*)(0x428420ACUL))
#define bFM_USB0_HERR_CRC                     *((volatile unsigned char*)(0x428420B0UL))
#define bFM_USB0_HERR_TOUT                    *((volatile unsigned char*)(0x428420B4UL))
#define bFM_USB0_HERR_RERR                    *((volatile unsigned char*)(0x428420B8UL))
#define bFM_USB0_HERR_LSTOF                   *((volatile unsigned char*)(0x428420BCUL))
#define bFM_USB0_HSTATE_CSTAT                 *((volatile unsigned char*)(0x42842100UL))
#define bFM_USB0_HSTATE_TMODE                 *((volatile unsigned char*)(0x42842104UL))
#define bFM_USB0_HSTATE_SUSP                  *((volatile unsigned char*)(0x42842108UL))
#define bFM_USB0_HSTATE_SOFBUSY               *((volatile unsigned char*)(0x4284210CUL))
#define bFM_USB0_HSTATE_CLKSEL                *((volatile unsigned char*)(0x42842110UL))
#define bFM_USB0_HSTATE_ALIVE                 *((volatile unsigned char*)(0x42842114UL))
#define bFM_USB0_HFCOMP_FRAMECOMP0            *((volatile unsigned char*)(0x42842120UL))
#define bFM_USB0_HFCOMP_FRAMECOMP1            *((volatile unsigned char*)(0x42842124UL))
#define bFM_USB0_HFCOMP_FRAMECOMP2            *((volatile unsigned char*)(0x42842128UL))
#define bFM_USB0_HFCOMP_FRAMECOMP3            *((volatile unsigned char*)(0x4284212CUL))
#define bFM_USB0_HFCOMP_FRAMECOMP4            *((volatile unsigned char*)(0x42842130UL))
#define bFM_USB0_HFCOMP_FRAMECOMP5            *((volatile unsigned char*)(0x42842134UL))
#define bFM_USB0_HFCOMP_FRAMECOMP6            *((volatile unsigned char*)(0x42842138UL))
#define bFM_USB0_HFCOMP_FRAMECOMP7            *((volatile unsigned char*)(0x4284213CUL))
#define bFM_USB0_HRTIMER_RTIMER0              *((volatile unsigned char*)(0x42842180UL))
#define bFM_USB0_HRTIMER_RTIMER1              *((volatile unsigned char*)(0x42842184UL))
#define bFM_USB0_HRTIMER_RTIMER2              *((volatile unsigned char*)(0x42842188UL))
#define bFM_USB0_HRTIMER_RTIMER3              *((volatile unsigned char*)(0x4284218CUL))
#define bFM_USB0_HRTIMER_RTIMER4              *((volatile unsigned char*)(0x42842190UL))
#define bFM_USB0_HRTIMER_RTIMER5              *((volatile unsigned char*)(0x42842194UL))
#define bFM_USB0_HRTIMER_RTIMER6              *((volatile unsigned char*)(0x42842198UL))
#define bFM_USB0_HRTIMER_RTIMER7              *((volatile unsigned char*)(0x4284219CUL))
#define bFM_USB0_HRTIMER_RTIMER8              *((volatile unsigned char*)(0x428421A0UL))
#define bFM_USB0_HRTIMER_RTIMER9              *((volatile unsigned char*)(0x428421A4UL))
#define bFM_USB0_HRTIMER_RTIMER10             *((volatile unsigned char*)(0x428421A8UL))
#define bFM_USB0_HRTIMER_RTIMER11             *((volatile unsigned char*)(0x428421ACUL))
#define bFM_USB0_HRTIMER_RTIMER12             *((volatile unsigned char*)(0x428421B0UL))
#define bFM_USB0_HRTIMER_RTIMER13             *((volatile unsigned char*)(0x428421B4UL))
#define bFM_USB0_HRTIMER_RTIMER14             *((volatile unsigned char*)(0x428421B8UL))
#define bFM_USB0_HRTIMER_RTIMER15             *((volatile unsigned char*)(0x428421BCUL))
#define bFM_USB0_HRTIMER0_RTIMER00            *((volatile unsigned char*)(0x42842180UL))
#define bFM_USB0_HRTIMER0_RTIMER01            *((volatile unsigned char*)(0x42842184UL))
#define bFM_USB0_HRTIMER0_RTIMER02            *((volatile unsigned char*)(0x42842188UL))
#define bFM_USB0_HRTIMER0_RTIMER03            *((volatile unsigned char*)(0x4284218CUL))
#define bFM_USB0_HRTIMER0_RTIMER04            *((volatile unsigned char*)(0x42842190UL))
#define bFM_USB0_HRTIMER0_RTIMER05            *((volatile unsigned char*)(0x42842194UL))
#define bFM_USB0_HRTIMER0_RTIMER06            *((volatile unsigned char*)(0x42842198UL))
#define bFM_USB0_HRTIMER0_RTIMER07            *((volatile unsigned char*)(0x4284219CUL))
#define bFM_USB0_HRTIMER1_RTIMER10            *((volatile unsigned char*)(0x428421A0UL))
#define bFM_USB0_HRTIMER1_RTIMER11            *((volatile unsigned char*)(0x428421A4UL))
#define bFM_USB0_HRTIMER1_RTIMER12            *((volatile unsigned char*)(0x428421A8UL))
#define bFM_USB0_HRTIMER1_RTIMER13            *((volatile unsigned char*)(0x428421ACUL))
#define bFM_USB0_HRTIMER1_RTIMER14            *((volatile unsigned char*)(0x428421B0UL))
#define bFM_USB0_HRTIMER1_RTIMER15            *((volatile unsigned char*)(0x428421B4UL))
#define bFM_USB0_HRTIMER1_RTIMER16            *((volatile unsigned char*)(0x428421B8UL))
#define bFM_USB0_HRTIMER1_RTIMER17            *((volatile unsigned char*)(0x428421BCUL))
#define bFM_USB0_HRTIMER2_RTIMER20            *((volatile unsigned char*)(0x42842200UL))
#define bFM_USB0_HRTIMER2_RTIMER21            *((volatile unsigned char*)(0x42842204UL))
#define bFM_USB0_HRTIMER2_RTIMER22            *((volatile unsigned char*)(0x42842208UL))
#define bFM_USB0_HADR_ADDRESS0                *((volatile unsigned char*)(0x42842220UL))
#define bFM_USB0_HADR_ADDRESS1                *((volatile unsigned char*)(0x42842224UL))
#define bFM_USB0_HADR_ADDRESS2                *((volatile unsigned char*)(0x42842228UL))
#define bFM_USB0_HADR_ADDRESS3                *((volatile unsigned char*)(0x4284222CUL))
#define bFM_USB0_HADR_ADDRESS4                *((volatile unsigned char*)(0x42842230UL))
#define bFM_USB0_HADR_ADDRESS5                *((volatile unsigned char*)(0x42842234UL))
#define bFM_USB0_HADR_ADDRESS6                *((volatile unsigned char*)(0x42842238UL))
#define bFM_USB0_HEOF_EOF0                    *((volatile unsigned char*)(0x42842280UL))
#define bFM_USB0_HEOF_EOF1                    *((volatile unsigned char*)(0x42842284UL))
#define bFM_USB0_HEOF_EOF2                    *((volatile unsigned char*)(0x42842288UL))
#define bFM_USB0_HEOF_EOF3                    *((volatile unsigned char*)(0x4284228CUL))
#define bFM_USB0_HEOF_EOF4                    *((volatile unsigned char*)(0x42842290UL))
#define bFM_USB0_HEOF_EOF5                    *((volatile unsigned char*)(0x42842294UL))
#define bFM_USB0_HEOF_EOF6                    *((volatile unsigned char*)(0x42842298UL))
#define bFM_USB0_HEOF_EOF7                    *((volatile unsigned char*)(0x4284229CUL))
#define bFM_USB0_HEOF_EOF8                    *((volatile unsigned char*)(0x428422A0UL))
#define bFM_USB0_HEOF_EOF9                    *((volatile unsigned char*)(0x428422A4UL))
#define bFM_USB0_HEOF_EOF10                   *((volatile unsigned char*)(0x428422A8UL))
#define bFM_USB0_HEOF_EOF11                   *((volatile unsigned char*)(0x428422ACUL))
#define bFM_USB0_HEOF_EOF12                   *((volatile unsigned char*)(0x428422B0UL))
#define bFM_USB0_HEOF_EOF13                   *((volatile unsigned char*)(0x428422B4UL))
#define bFM_USB0_HEOF_EOF14                   *((volatile unsigned char*)(0x428422B8UL))
#define bFM_USB0_HEOF_EOF15                   *((volatile unsigned char*)(0x428422BCUL))
#define bFM_USB0_HEOF0_EOF00                  *((volatile unsigned char*)(0x42842280UL))
#define bFM_USB0_HEOF0_EOF01                  *((volatile unsigned char*)(0x42842284UL))
#define bFM_USB0_HEOF0_EOF02                  *((volatile unsigned char*)(0x42842288UL))
#define bFM_USB0_HEOF0_EOF03                  *((volatile unsigned char*)(0x4284228CUL))
#define bFM_USB0_HEOF0_EOF04                  *((volatile unsigned char*)(0x42842290UL))
#define bFM_USB0_HEOF0_EOF05                  *((volatile unsigned char*)(0x42842294UL))
#define bFM_USB0_HEOF0_EOF06                  *((volatile unsigned char*)(0x42842298UL))
#define bFM_USB0_HEOF0_EOF07                  *((volatile unsigned char*)(0x4284229CUL))
#define bFM_USB0_HEOF1_EOF10                  *((volatile unsigned char*)(0x428422A0UL))
#define bFM_USB0_HEOF1_EOF11                  *((volatile unsigned char*)(0x428422A4UL))
#define bFM_USB0_HEOF1_EOF12                  *((volatile unsigned char*)(0x428422A8UL))
#define bFM_USB0_HEOF1_EOF13                  *((volatile unsigned char*)(0x428422ACUL))
#define bFM_USB0_HEOF1_EOF14                  *((volatile unsigned char*)(0x428422B0UL))
#define bFM_USB0_HEOF1_EOF15                  *((volatile unsigned char*)(0x428422B4UL))
#define bFM_USB0_HFRAME_FRAME0                *((volatile unsigned char*)(0x42842300UL))
#define bFM_USB0_HFRAME_FRAME1                *((volatile unsigned char*)(0x42842304UL))
#define bFM_USB0_HFRAME_FRAME2                *((volatile unsigned char*)(0x42842308UL))
#define bFM_USB0_HFRAME_FRAME3                *((volatile unsigned char*)(0x4284230CUL))
#define bFM_USB0_HFRAME_FRAME4                *((volatile unsigned char*)(0x42842310UL))
#define bFM_USB0_HFRAME_FRAME5                *((volatile unsigned char*)(0x42842314UL))
#define bFM_USB0_HFRAME_FRAME6                *((volatile unsigned char*)(0x42842318UL))
#define bFM_USB0_HFRAME_FRAME7                *((volatile unsigned char*)(0x4284231CUL))
#define bFM_USB0_HFRAME_FRAME8                *((volatile unsigned char*)(0x42842320UL))
#define bFM_USB0_HFRAME_FRAME9                *((volatile unsigned char*)(0x42842324UL))
#define bFM_USB0_HFRAME_FRAME10               *((volatile unsigned char*)(0x42842328UL))
#define bFM_USB0_HFRAME0_FRAME00              *((volatile unsigned char*)(0x42842300UL))
#define bFM_USB0_HFRAME0_FRAME01              *((volatile unsigned char*)(0x42842304UL))
#define bFM_USB0_HFRAME0_FRAME02              *((volatile unsigned char*)(0x42842308UL))
#define bFM_USB0_HFRAME0_FRAME03              *((volatile unsigned char*)(0x4284230CUL))
#define bFM_USB0_HFRAME0_FRAME04              *((volatile unsigned char*)(0x42842310UL))
#define bFM_USB0_HFRAME0_FRAME05              *((volatile unsigned char*)(0x42842314UL))
#define bFM_USB0_HFRAME0_FRAME06              *((volatile unsigned char*)(0x42842318UL))
#define bFM_USB0_HFRAME0_FRAME07              *((volatile unsigned char*)(0x4284231CUL))
#define bFM_USB0_HFRAME1_FRAME10              *((volatile unsigned char*)(0x42842320UL))
#define bFM_USB0_HFRAME1_FRAME11              *((volatile unsigned char*)(0x42842324UL))
#define bFM_USB0_HFRAME1_FRAME12              *((volatile unsigned char*)(0x42842328UL))
#define bFM_USB0_HFRAME1_FRAME13              *((volatile unsigned char*)(0x4284232CUL))
#define bFM_USB0_HTOKEN_ENDPT0                *((volatile unsigned char*)(0x42842380UL))
#define bFM_USB0_HTOKEN_ENDPT1                *((volatile unsigned char*)(0x42842384UL))
#define bFM_USB0_HTOKEN_ENDPT2                *((volatile unsigned char*)(0x42842388UL))
#define bFM_USB0_HTOKEN_ENDPT3                *((volatile unsigned char*)(0x4284238CUL))
#define bFM_USB0_HTOKEN_TKNEN0                *((volatile unsigned char*)(0x42842390UL))
#define bFM_USB0_HTOKEN_TKNEN1                *((volatile unsigned char*)(0x42842394UL))
#define bFM_USB0_HTOKEN_TKNEN2                *((volatile unsigned char*)(0x42842398UL))
#define bFM_USB0_HTOKEN_TGGL                  *((volatile unsigned char*)(0x4284239CUL))
#define bFM_USB0_UDCC_PWC                     *((volatile unsigned char*)(0x42842400UL))
#define bFM_USB0_UDCC_RFBK                    *((volatile unsigned char*)(0x42842404UL))
#define bFM_USB0_UDCC_STALCLREN               *((volatile unsigned char*)(0x4284240CUL))
#define bFM_USB0_UDCC_USTP                    *((volatile unsigned char*)(0x42842410UL))
#define bFM_USB0_UDCC_HCONX                   *((volatile unsigned char*)(0x42842414UL))
#define bFM_USB0_UDCC_RESUM                   *((volatile unsigned char*)(0x42842418UL))
#define bFM_USB0_UDCC_RST                     *((volatile unsigned char*)(0x4284241CUL))
#define bFM_USB0_EP0C_PKS00                   *((volatile unsigned int*)(0x42842480UL))
#define bFM_USB0_EP0C_PKS01                   *((volatile unsigned int*)(0x42842484UL))
#define bFM_USB0_EP0C_PKS02                   *((volatile unsigned int*)(0x42842488UL))
#define bFM_USB0_EP0C_PKS03                   *((volatile unsigned int*)(0x4284248CUL))
#define bFM_USB0_EP0C_PKS04                   *((volatile unsigned int*)(0x42842490UL))
#define bFM_USB0_EP0C_PKS05                   *((volatile unsigned int*)(0x42842494UL))
#define bFM_USB0_EP0C_PKS06                   *((volatile unsigned int*)(0x42842498UL))
#define bFM_USB0_EP0C_STAL                    *((volatile unsigned int*)(0x428424A4UL))
#define bFM_USB0_EP1C_PKS10                   *((volatile unsigned int*)(0x42842500UL))
#define bFM_USB0_EP1C_PKS11                   *((volatile unsigned int*)(0x42842504UL))
#define bFM_USB0_EP1C_PKS12                   *((volatile unsigned int*)(0x42842508UL))
#define bFM_USB0_EP1C_PKS13                   *((volatile unsigned int*)(0x4284250CUL))
#define bFM_USB0_EP1C_PKS14                   *((volatile unsigned int*)(0x42842510UL))
#define bFM_USB0_EP1C_PKS15                   *((volatile unsigned int*)(0x42842514UL))
#define bFM_USB0_EP1C_PKS16                   *((volatile unsigned int*)(0x42842518UL))
#define bFM_USB0_EP1C_PKS17                   *((volatile unsigned int*)(0x4284251CUL))
#define bFM_USB0_EP1C_PKS18                   *((volatile unsigned int*)(0x42842520UL))
#define bFM_USB0_EP1C_STAL                    *((volatile unsigned int*)(0x42842524UL))
#define bFM_USB0_EP1C_NULE                    *((volatile unsigned int*)(0x42842528UL))
#define bFM_USB0_EP1C_DMAE                    *((volatile unsigned int*)(0x4284252CUL))
#define bFM_USB0_EP1C_DIR                     *((volatile unsigned int*)(0x42842530UL))
#define bFM_USB0_EP1C_TYPE0                   *((volatile unsigned int*)(0x42842534UL))
#define bFM_USB0_EP1C_TYPE1                   *((volatile unsigned int*)(0x42842538UL))
#define bFM_USB0_EP1C_EPEN                    *((volatile unsigned int*)(0x4284253CUL))
#define bFM_USB0_EP2C_PKS20                   *((volatile unsigned int*)(0x42842580UL))
#define bFM_USB0_EP2C_PKS21                   *((volatile unsigned int*)(0x42842584UL))
#define bFM_USB0_EP2C_PKS22                   *((volatile unsigned int*)(0x42842588UL))
#define bFM_USB0_EP2C_PKS23                   *((volatile unsigned int*)(0x4284258CUL))
#define bFM_USB0_EP2C_PKS24                   *((volatile unsigned int*)(0x42842590UL))
#define bFM_USB0_EP2C_PKS25                   *((volatile unsigned int*)(0x42842594UL))
#define bFM_USB0_EP2C_PKS26                   *((volatile unsigned int*)(0x42842598UL))
#define bFM_USB0_EP2C_STAL                    *((volatile unsigned int*)(0x428425A4UL))
#define bFM_USB0_EP2C_NULE                    *((volatile unsigned int*)(0x428425A8UL))
#define bFM_USB0_EP2C_DMAE                    *((volatile unsigned int*)(0x428425ACUL))
#define bFM_USB0_EP2C_DIR                     *((volatile unsigned int*)(0x428425B0UL))
#define bFM_USB0_EP2C_TYPE0                   *((volatile unsigned int*)(0x428425B4UL))
#define bFM_USB0_EP2C_TYPE1                   *((volatile unsigned int*)(0x428425B8UL))
#define bFM_USB0_EP2C_EPEN                    *((volatile unsigned int*)(0x428425BCUL))
#define bFM_USB0_EP3C_PKS30                   *((volatile unsigned int*)(0x42842600UL))
#define bFM_USB0_EP3C_PKS31                   *((volatile unsigned int*)(0x42842604UL))
#define bFM_USB0_EP3C_PKS32                   *((volatile unsigned int*)(0x42842608UL))
#define bFM_USB0_EP3C_PKS33                   *((volatile unsigned int*)(0x4284260CUL))
#define bFM_USB0_EP3C_PKS34                   *((volatile unsigned int*)(0x42842610UL))
#define bFM_USB0_EP3C_PKS35                   *((volatile unsigned int*)(0x42842614UL))
#define bFM_USB0_EP3C_PKS36                   *((volatile unsigned int*)(0x42842618UL))
#define bFM_USB0_EP3C_STAL                    *((volatile unsigned int*)(0x42842624UL))
#define bFM_USB0_EP3C_NULE                    *((volatile unsigned int*)(0x42842628UL))
#define bFM_USB0_EP3C_DMAE                    *((volatile unsigned int*)(0x4284262CUL))
#define bFM_USB0_EP3C_DIR                     *((volatile unsigned int*)(0x42842630UL))
#define bFM_USB0_EP3C_TYPE0                   *((volatile unsigned int*)(0x42842634UL))
#define bFM_USB0_EP3C_TYPE1                   *((volatile unsigned int*)(0x42842638UL))
#define bFM_USB0_EP3C_EPEN                    *((volatile unsigned int*)(0x4284263CUL))
#define bFM_USB0_EP4C_PKS40                   *((volatile unsigned int*)(0x42842680UL))
#define bFM_USB0_EP4C_PKS41                   *((volatile unsigned int*)(0x42842684UL))
#define bFM_USB0_EP4C_PKS42                   *((volatile unsigned int*)(0x42842688UL))
#define bFM_USB0_EP4C_PKS43                   *((volatile unsigned int*)(0x4284268CUL))
#define bFM_USB0_EP4C_PKS44                   *((volatile unsigned int*)(0x42842690UL))
#define bFM_USB0_EP4C_PKS45                   *((volatile unsigned int*)(0x42842694UL))
#define bFM_USB0_EP4C_PKS46                   *((volatile unsigned int*)(0x42842698UL))
#define bFM_USB0_EP4C_STAL                    *((volatile unsigned int*)(0x428426A4UL))
#define bFM_USB0_EP4C_NULE                    *((volatile unsigned int*)(0x428426A8UL))
#define bFM_USB0_EP4C_DMAE                    *((volatile unsigned int*)(0x428426ACUL))
#define bFM_USB0_EP4C_DIR                     *((volatile unsigned int*)(0x428426B0UL))
#define bFM_USB0_EP4C_TYPE0                   *((volatile unsigned int*)(0x428426B4UL))
#define bFM_USB0_EP4C_TYPE1                   *((volatile unsigned int*)(0x428426B8UL))
#define bFM_USB0_EP4C_EPEN                    *((volatile unsigned int*)(0x428426BCUL))
#define bFM_USB0_EP5C_PKS50                   *((volatile unsigned int*)(0x42842700UL))
#define bFM_USB0_EP5C_PKS51                   *((volatile unsigned int*)(0x42842704UL))
#define bFM_USB0_EP5C_PKS52                   *((volatile unsigned int*)(0x42842708UL))
#define bFM_USB0_EP5C_PKS53                   *((volatile unsigned int*)(0x4284270CUL))
#define bFM_USB0_EP5C_PKS54                   *((volatile unsigned int*)(0x42842710UL))
#define bFM_USB0_EP5C_PKS55                   *((volatile unsigned int*)(0x42842714UL))
#define bFM_USB0_EP5C_PKS56                   *((volatile unsigned int*)(0x42842718UL))
#define bFM_USB0_EP5C_STAL                    *((volatile unsigned int*)(0x42842724UL))
#define bFM_USB0_EP5C_NULE                    *((volatile unsigned int*)(0x42842728UL))
#define bFM_USB0_EP5C_DMAE                    *((volatile unsigned int*)(0x4284272CUL))
#define bFM_USB0_EP5C_DIR                     *((volatile unsigned int*)(0x42842730UL))
#define bFM_USB0_EP5C_TYPE0                   *((volatile unsigned int*)(0x42842734UL))
#define bFM_USB0_EP5C_TYPE1                   *((volatile unsigned int*)(0x42842738UL))
#define bFM_USB0_EP5C_EPEN                    *((volatile unsigned int*)(0x4284273CUL))
#define bFM_USB0_TMSP_TMSP0                   *((volatile unsigned int*)(0x42842780UL))
#define bFM_USB0_TMSP_TMSP1                   *((volatile unsigned int*)(0x42842784UL))
#define bFM_USB0_TMSP_TMSP2                   *((volatile unsigned int*)(0x42842788UL))
#define bFM_USB0_TMSP_TMSP3                   *((volatile unsigned int*)(0x4284278CUL))
#define bFM_USB0_TMSP_TMSP4                   *((volatile unsigned int*)(0x42842790UL))
#define bFM_USB0_TMSP_TMSP5                   *((volatile unsigned int*)(0x42842794UL))
#define bFM_USB0_TMSP_TMSP6                   *((volatile unsigned int*)(0x42842798UL))
#define bFM_USB0_TMSP_TMSP7                   *((volatile unsigned int*)(0x4284279CUL))
#define bFM_USB0_TMSP_TMSP8                   *((volatile unsigned int*)(0x428427A0UL))
#define bFM_USB0_TMSP_TMSP9                   *((volatile unsigned int*)(0x428427A4UL))
#define bFM_USB0_TMSP_TMSP10                  *((volatile unsigned int*)(0x428427A8UL))
#define bFM_USB0_UDCS_CONF                    *((volatile unsigned char*)(0x42842800UL))
#define bFM_USB0_UDCS_SETP                    *((volatile unsigned char*)(0x42842804UL))
#define bFM_USB0_UDCS_WKUP                    *((volatile unsigned char*)(0x42842808UL))
#define bFM_USB0_UDCS_BRST                    *((volatile unsigned char*)(0x4284280CUL))
#define bFM_USB0_UDCS_SOF                     *((volatile unsigned char*)(0x42842810UL))
#define bFM_USB0_UDCS_SUSP                    *((volatile unsigned char*)(0x42842814UL))
#define bFM_USB0_UDCIE_CONFIE                 *((volatile unsigned char*)(0x42842820UL))
#define bFM_USB0_UDCIE_CONFN                  *((volatile unsigned char*)(0x42842824UL))
#define bFM_USB0_UDCIE_WKUPIE                 *((volatile unsigned char*)(0x42842828UL))
#define bFM_USB0_UDCIE_BRSTIE                 *((volatile unsigned char*)(0x4284282CUL))
#define bFM_USB0_UDCIE_SOFIE                  *((volatile unsigned char*)(0x42842830UL))
#define bFM_USB0_UDCIE_SUSPIE                 *((volatile unsigned char*)(0x42842834UL))
#define bFM_USB0_EP0IS_DRQI                   *((volatile unsigned int*)(0x428428A8UL))
#define bFM_USB0_EP0IS_DRQIIE                 *((volatile unsigned int*)(0x428428B8UL))
#define bFM_USB0_EP0IS_BFINI                  *((volatile unsigned int*)(0x428428BCUL))
#define bFM_USB0_EP0OS_SIZE0                  *((volatile unsigned int*)(0x42842900UL))
#define bFM_USB0_EP0OS_SIZE1                  *((volatile unsigned int*)(0x42842904UL))
#define bFM_USB0_EP0OS_SIZE2                  *((volatile unsigned int*)(0x42842908UL))
#define bFM_USB0_EP0OS_SIZE3                  *((volatile unsigned int*)(0x4284290CUL))
#define bFM_USB0_EP0OS_SIZE4                  *((volatile unsigned int*)(0x42842910UL))
#define bFM_USB0_EP0OS_SIZE5                  *((volatile unsigned int*)(0x42842914UL))
#define bFM_USB0_EP0OS_SIZE6                  *((volatile unsigned int*)(0x42842918UL))
#define bFM_USB0_EP0OS_SPK                    *((volatile unsigned int*)(0x42842924UL))
#define bFM_USB0_EP0OS_DRQO                   *((volatile unsigned int*)(0x42842928UL))
#define bFM_USB0_EP0OS_SPKIE                  *((volatile unsigned int*)(0x42842934UL))
#define bFM_USB0_EP0OS_DRQOIE                 *((volatile unsigned int*)(0x42842938UL))
#define bFM_USB0_EP0OS_BFINI                  *((volatile unsigned int*)(0x4284293CUL))
#define bFM_USB0_EP1S_SIZE10                  *((volatile unsigned int*)(0x42842980UL))
#define bFM_USB0_EP1S_SIZE11                  *((volatile unsigned int*)(0x42842984UL))
#define bFM_USB0_EP1S_SIZE12                  *((volatile unsigned int*)(0x42842988UL))
#define bFM_USB0_EP1S_SIZE13                  *((volatile unsigned int*)(0x4284298CUL))
#define bFM_USB0_EP1S_SIZE14                  *((volatile unsigned int*)(0x42842990UL))
#define bFM_USB0_EP1S_SIZE15                  *((volatile unsigned int*)(0x42842994UL))
#define bFM_USB0_EP1S_SIZE16                  *((volatile unsigned int*)(0x42842998UL))
#define bFM_USB0_EP1S_SIZE17                  *((volatile unsigned int*)(0x4284299CUL))
#define bFM_USB0_EP1S_SIZE18                  *((volatile unsigned int*)(0x428429A0UL))
#define bFM_USB0_EP1S_SPK                     *((volatile unsigned int*)(0x428429A4UL))
#define bFM_USB0_EP1S_DRQ                     *((volatile unsigned int*)(0x428429A8UL))
#define bFM_USB0_EP1S_BUSY                    *((volatile unsigned int*)(0x428429ACUL))
#define bFM_USB0_EP1S_SPKIE                   *((volatile unsigned int*)(0x428429B4UL))
#define bFM_USB0_EP1S_DRQIE                   *((volatile unsigned int*)(0x428429B8UL))
#define bFM_USB0_EP1S_BFINI                   *((volatile unsigned int*)(0x428429BCUL))
#define bFM_USB0_EP2S_SIZE20                  *((volatile unsigned int*)(0x42842A00UL))
#define bFM_USB0_EP2S_SIZE21                  *((volatile unsigned int*)(0x42842A04UL))
#define bFM_USB0_EP2S_SIZE22                  *((volatile unsigned int*)(0x42842A08UL))
#define bFM_USB0_EP2S_SIZE23                  *((volatile unsigned int*)(0x42842A0CUL))
#define bFM_USB0_EP2S_SIZE24                  *((volatile unsigned int*)(0x42842A10UL))
#define bFM_USB0_EP2S_SIZE25                  *((volatile unsigned int*)(0x42842A14UL))
#define bFM_USB0_EP2S_SIZE26                  *((volatile unsigned int*)(0x42842A18UL))
#define bFM_USB0_EP2S_SPK                     *((volatile unsigned int*)(0x42842A24UL))
#define bFM_USB0_EP2S_DRQ                     *((volatile unsigned int*)(0x42842A28UL))
#define bFM_USB0_EP2S_BUSY                    *((volatile unsigned int*)(0x42842A2CUL))
#define bFM_USB0_EP2S_SPKIE                   *((volatile unsigned int*)(0x42842A34UL))
#define bFM_USB0_EP2S_DRQIE                   *((volatile unsigned int*)(0x42842A38UL))
#define bFM_USB0_EP2S_BFINI                   *((volatile unsigned int*)(0x42842A3CUL))
#define bFM_USB0_EP3S_SIZE30                  *((volatile unsigned int*)(0x42842A80UL))
#define bFM_USB0_EP3S_SIZE31                  *((volatile unsigned int*)(0x42842A84UL))
#define bFM_USB0_EP3S_SIZE32                  *((volatile unsigned int*)(0x42842A88UL))
#define bFM_USB0_EP3S_SIZE33                  *((volatile unsigned int*)(0x42842A8CUL))
#define bFM_USB0_EP3S_SIZE34                  *((volatile unsigned int*)(0x42842A90UL))
#define bFM_USB0_EP3S_SIZE35                  *((volatile unsigned int*)(0x42842A94UL))
#define bFM_USB0_EP3S_SIZE36                  *((volatile unsigned int*)(0x42842A98UL))
#define bFM_USB0_EP3S_SPK                     *((volatile unsigned int*)(0x42842AA4UL))
#define bFM_USB0_EP3S_DRQ                     *((volatile unsigned int*)(0x42842AA8UL))
#define bFM_USB0_EP3S_BUSY                    *((volatile unsigned int*)(0x42842AACUL))
#define bFM_USB0_EP3S_SPKIE                   *((volatile unsigned int*)(0x42842AB4UL))
#define bFM_USB0_EP3S_DRQIE                   *((volatile unsigned int*)(0x42842AB8UL))
#define bFM_USB0_EP3S_BFINI                   *((volatile unsigned int*)(0x42842ABCUL))
#define bFM_USB0_EP4S_SIZE40                  *((volatile unsigned int*)(0x42842B00UL))
#define bFM_USB0_EP4S_SIZE41                  *((volatile unsigned int*)(0x42842B04UL))
#define bFM_USB0_EP4S_SIZE42                  *((volatile unsigned int*)(0x42842B08UL))
#define bFM_USB0_EP4S_SIZE43                  *((volatile unsigned int*)(0x42842B0CUL))
#define bFM_USB0_EP4S_SIZE44                  *((volatile unsigned int*)(0x42842B10UL))
#define bFM_USB0_EP4S_SIZE45                  *((volatile unsigned int*)(0x42842B14UL))
#define bFM_USB0_EP4S_SIZE46                  *((volatile unsigned int*)(0x42842B18UL))
#define bFM_USB0_EP4S_SPK                     *((volatile unsigned int*)(0x42842B24UL))
#define bFM_USB0_EP4S_DRQ                     *((volatile unsigned int*)(0x42842B28UL))
#define bFM_USB0_EP4S_BUSY                    *((volatile unsigned int*)(0x42842B2CUL))
#define bFM_USB0_EP4S_SPKIE                   *((volatile unsigned int*)(0x42842B34UL))
#define bFM_USB0_EP4S_DRQIE                   *((volatile unsigned int*)(0x42842B38UL))
#define bFM_USB0_EP4S_BFINI                   *((volatile unsigned int*)(0x42842B3CUL))
#define bFM_USB0_EP5S_SIZE50                  *((volatile unsigned int*)(0x42842B80UL))
#define bFM_USB0_EP5S_SIZE51                  *((volatile unsigned int*)(0x42842B84UL))
#define bFM_USB0_EP5S_SIZE52                  *((volatile unsigned int*)(0x42842B88UL))
#define bFM_USB0_EP5S_SIZE53                  *((volatile unsigned int*)(0x42842B8CUL))
#define bFM_USB0_EP5S_SIZE54                  *((volatile unsigned int*)(0x42842B90UL))
#define bFM_USB0_EP5S_SIZE55                  *((volatile unsigned int*)(0x42842B94UL))
#define bFM_USB0_EP5S_SIZE56                  *((volatile unsigned int*)(0x42842B98UL))
#define bFM_USB0_EP5S_SPK                     *((volatile unsigned int*)(0x42842BA4UL))
#define bFM_USB0_EP5S_DRQ                     *((volatile unsigned int*)(0x42842BA8UL))
#define bFM_USB0_EP5S_BUSY                    *((volatile unsigned int*)(0x42842BACUL))
#define bFM_USB0_EP5S_SPKIE                   *((volatile unsigned int*)(0x42842BB4UL))
#define bFM_USB0_EP5S_DRQIE                   *((volatile unsigned int*)(0x42842BB8UL))
#define bFM_USB0_EP5S_BFINI                   *((volatile unsigned int*)(0x42842BBCUL))

/* USB channel 1 registers */
#define bFM_USB1_HCNT_HOST                    *((volatile unsigned char*)(0x42A42000UL))
#define bFM_USB1_HCNT_URST                    *((volatile unsigned char*)(0x42A42004UL))
#define bFM_USB1_HCNT_SOFIRE                  *((volatile unsigned char*)(0x42A42008UL))
#define bFM_USB1_HCNT_DIRE                    *((volatile unsigned char*)(0x42A4200CUL))
#define bFM_USB1_HCNT_CNNIRE                  *((volatile unsigned char*)(0x42A42010UL))
#define bFM_USB1_HCNT_CMPIRE                  *((volatile unsigned char*)(0x42A42014UL))
#define bFM_USB1_HCNT_URIRE                   *((volatile unsigned char*)(0x42A42018UL))
#define bFM_USB1_HCNT_RWKIRE                  *((volatile unsigned char*)(0x42A4201CUL))
#define bFM_USB1_HCNT_RETRY                   *((volatile unsigned char*)(0x42A42020UL))
#define bFM_USB1_HCNT_CANCEL                  *((volatile unsigned char*)(0x42A42024UL))
#define bFM_USB1_HCNT_SOFSTEP                 *((volatile unsigned char*)(0x42A42028UL))
#define bFM_USB1_HCNT0_HOST                   *((volatile unsigned char*)(0x42A42000UL))
#define bFM_USB1_HCNT0_URST                   *((volatile unsigned char*)(0x42A42004UL))
#define bFM_USB1_HCNT0_SOFIRE                 *((volatile unsigned char*)(0x42A42008UL))
#define bFM_USB1_HCNT0_DIRE                   *((volatile unsigned char*)(0x42A4200CUL))
#define bFM_USB1_HCNT0_CNNIRE                 *((volatile unsigned char*)(0x42A42010UL))
#define bFM_USB1_HCNT0_CMPIRE                 *((volatile unsigned char*)(0x42A42014UL))
#define bFM_USB1_HCNT0_URIRE                  *((volatile unsigned char*)(0x42A42018UL))
#define bFM_USB1_HCNT0_RWKIRE                 *((volatile unsigned char*)(0x42A4201CUL))
#define bFM_USB1_HCNT1_RETRY                  *((volatile unsigned char*)(0x42A42020UL))
#define bFM_USB1_HCNT1_CANCEL                 *((volatile unsigned char*)(0x42A42024UL))
#define bFM_USB1_HCNT1_SOFSTEP                *((volatile unsigned char*)(0x42A42028UL))
#define bFM_USB1_HIRQ_SOFIRQ                  *((volatile unsigned char*)(0x42A42080UL))
#define bFM_USB1_HIRQ_DIRQ                    *((volatile unsigned char*)(0x42A42084UL))
#define bFM_USB1_HIRQ_CNNIRQ                  *((volatile unsigned char*)(0x42A42088UL))
#define bFM_USB1_HIRQ_CMPIRQ                  *((volatile unsigned char*)(0x42A4208CUL))
#define bFM_USB1_HIRQ_URIRQ                   *((volatile unsigned char*)(0x42A42090UL))
#define bFM_USB1_HIRQ_RWKIRQ                  *((volatile unsigned char*)(0x42A42094UL))
#define bFM_USB1_HIRQ_TCAN                    *((volatile unsigned char*)(0x42A4209CUL))
#define bFM_USB1_HERR_HS0                     *((volatile unsigned char*)(0x42A420A0UL))
#define bFM_USB1_HERR_HS1                     *((volatile unsigned char*)(0x42A420A4UL))
#define bFM_USB1_HERR_STUFF                   *((volatile unsigned char*)(0x42A420A8UL))
#define bFM_USB1_HERR_TGERR                   *((volatile unsigned char*)(0x42A420ACUL))
#define bFM_USB1_HERR_CRC                     *((volatile unsigned char*)(0x42A420B0UL))
#define bFM_USB1_HERR_TOUT                    *((volatile unsigned char*)(0x42A420B4UL))
#define bFM_USB1_HERR_RERR                    *((volatile unsigned char*)(0x42A420B8UL))
#define bFM_USB1_HERR_LSTOF                   *((volatile unsigned char*)(0x42A420BCUL))
#define bFM_USB1_HSTATE_CSTAT                 *((volatile unsigned char*)(0x42A42100UL))
#define bFM_USB1_HSTATE_TMODE                 *((volatile unsigned char*)(0x42A42104UL))
#define bFM_USB1_HSTATE_SUSP                  *((volatile unsigned char*)(0x42A42108UL))
#define bFM_USB1_HSTATE_SOFBUSY               *((volatile unsigned char*)(0x42A4210CUL))
#define bFM_USB1_HSTATE_CLKSEL                *((volatile unsigned char*)(0x42A42110UL))
#define bFM_USB1_HSTATE_ALIVE                 *((volatile unsigned char*)(0x42A42114UL))
#define bFM_USB1_HFCOMP_FRAMECOMP0            *((volatile unsigned char*)(0x42A42120UL))
#define bFM_USB1_HFCOMP_FRAMECOMP1            *((volatile unsigned char*)(0x42A42124UL))
#define bFM_USB1_HFCOMP_FRAMECOMP2            *((volatile unsigned char*)(0x42A42128UL))
#define bFM_USB1_HFCOMP_FRAMECOMP3            *((volatile unsigned char*)(0x42A4212CUL))
#define bFM_USB1_HFCOMP_FRAMECOMP4            *((volatile unsigned char*)(0x42A42130UL))
#define bFM_USB1_HFCOMP_FRAMECOMP5            *((volatile unsigned char*)(0x42A42134UL))
#define bFM_USB1_HFCOMP_FRAMECOMP6            *((volatile unsigned char*)(0x42A42138UL))
#define bFM_USB1_HFCOMP_FRAMECOMP7            *((volatile unsigned char*)(0x42A4213CUL))
#define bFM_USB1_HRTIMER_RTIMER0              *((volatile unsigned char*)(0x42A42180UL))
#define bFM_USB1_HRTIMER_RTIMER1              *((volatile unsigned char*)(0x42A42184UL))
#define bFM_USB1_HRTIMER_RTIMER2              *((volatile unsigned char*)(0x42A42188UL))
#define bFM_USB1_HRTIMER_RTIMER3              *((volatile unsigned char*)(0x42A4218CUL))
#define bFM_USB1_HRTIMER_RTIMER4              *((volatile unsigned char*)(0x42A42190UL))
#define bFM_USB1_HRTIMER_RTIMER5              *((volatile unsigned char*)(0x42A42194UL))
#define bFM_USB1_HRTIMER_RTIMER6              *((volatile unsigned char*)(0x42A42198UL))
#define bFM_USB1_HRTIMER_RTIMER7              *((volatile unsigned char*)(0x42A4219CUL))
#define bFM_USB1_HRTIMER_RTIMER8              *((volatile unsigned char*)(0x42A421A0UL))
#define bFM_USB1_HRTIMER_RTIMER9              *((volatile unsigned char*)(0x42A421A4UL))
#define bFM_USB1_HRTIMER_RTIMER10             *((volatile unsigned char*)(0x42A421A8UL))
#define bFM_USB1_HRTIMER_RTIMER11             *((volatile unsigned char*)(0x42A421ACUL))
#define bFM_USB1_HRTIMER_RTIMER12             *((volatile unsigned char*)(0x42A421B0UL))
#define bFM_USB1_HRTIMER_RTIMER13             *((volatile unsigned char*)(0x42A421B4UL))
#define bFM_USB1_HRTIMER_RTIMER14             *((volatile unsigned char*)(0x42A421B8UL))
#define bFM_USB1_HRTIMER_RTIMER15             *((volatile unsigned char*)(0x42A421BCUL))
#define bFM_USB1_HRTIMER0_RTIMER00            *((volatile unsigned char*)(0x42A42180UL))
#define bFM_USB1_HRTIMER0_RTIMER01            *((volatile unsigned char*)(0x42A42184UL))
#define bFM_USB1_HRTIMER0_RTIMER02            *((volatile unsigned char*)(0x42A42188UL))
#define bFM_USB1_HRTIMER0_RTIMER03            *((volatile unsigned char*)(0x42A4218CUL))
#define bFM_USB1_HRTIMER0_RTIMER04            *((volatile unsigned char*)(0x42A42190UL))
#define bFM_USB1_HRTIMER0_RTIMER05            *((volatile unsigned char*)(0x42A42194UL))
#define bFM_USB1_HRTIMER0_RTIMER06            *((volatile unsigned char*)(0x42A42198UL))
#define bFM_USB1_HRTIMER0_RTIMER07            *((volatile unsigned char*)(0x42A4219CUL))
#define bFM_USB1_HRTIMER1_RTIMER10            *((volatile unsigned char*)(0x42A421A0UL))
#define bFM_USB1_HRTIMER1_RTIMER11            *((volatile unsigned char*)(0x42A421A4UL))
#define bFM_USB1_HRTIMER1_RTIMER12            *((volatile unsigned char*)(0x42A421A8UL))
#define bFM_USB1_HRTIMER1_RTIMER13            *((volatile unsigned char*)(0x42A421ACUL))
#define bFM_USB1_HRTIMER1_RTIMER14            *((volatile unsigned char*)(0x42A421B0UL))
#define bFM_USB1_HRTIMER1_RTIMER15            *((volatile unsigned char*)(0x42A421B4UL))
#define bFM_USB1_HRTIMER1_RTIMER16            *((volatile unsigned char*)(0x42A421B8UL))
#define bFM_USB1_HRTIMER1_RTIMER17            *((volatile unsigned char*)(0x42A421BCUL))
#define bFM_USB1_HRTIMER2_RTIMER20            *((volatile unsigned char*)(0x42A42200UL))
#define bFM_USB1_HRTIMER2_RTIMER21            *((volatile unsigned char*)(0x42A42204UL))
#define bFM_USB1_HRTIMER2_RTIMER22            *((volatile unsigned char*)(0x42A42208UL))
#define bFM_USB1_HADR_ADDRESS0                *((volatile unsigned char*)(0x42A42220UL))
#define bFM_USB1_HADR_ADDRESS1                *((volatile unsigned char*)(0x42A42224UL))
#define bFM_USB1_HADR_ADDRESS2                *((volatile unsigned char*)(0x42A42228UL))
#define bFM_USB1_HADR_ADDRESS3                *((volatile unsigned char*)(0x42A4222CUL))
#define bFM_USB1_HADR_ADDRESS4                *((volatile unsigned char*)(0x42A42230UL))
#define bFM_USB1_HADR_ADDRESS5                *((volatile unsigned char*)(0x42A42234UL))
#define bFM_USB1_HADR_ADDRESS6                *((volatile unsigned char*)(0x42A42238UL))
#define bFM_USB1_HEOF_EOF0                    *((volatile unsigned char*)(0x42A42280UL))
#define bFM_USB1_HEOF_EOF1                    *((volatile unsigned char*)(0x42A42284UL))
#define bFM_USB1_HEOF_EOF2                    *((volatile unsigned char*)(0x42A42288UL))
#define bFM_USB1_HEOF_EOF3                    *((volatile unsigned char*)(0x42A4228CUL))
#define bFM_USB1_HEOF_EOF4                    *((volatile unsigned char*)(0x42A42290UL))
#define bFM_USB1_HEOF_EOF5                    *((volatile unsigned char*)(0x42A42294UL))
#define bFM_USB1_HEOF_EOF6                    *((volatile unsigned char*)(0x42A42298UL))
#define bFM_USB1_HEOF_EOF7                    *((volatile unsigned char*)(0x42A4229CUL))
#define bFM_USB1_HEOF_EOF8                    *((volatile unsigned char*)(0x42A422A0UL))
#define bFM_USB1_HEOF_EOF9                    *((volatile unsigned char*)(0x42A422A4UL))
#define bFM_USB1_HEOF_EOF10                   *((volatile unsigned char*)(0x42A422A8UL))
#define bFM_USB1_HEOF_EOF11                   *((volatile unsigned char*)(0x42A422ACUL))
#define bFM_USB1_HEOF_EOF12                   *((volatile unsigned char*)(0x42A422B0UL))
#define bFM_USB1_HEOF_EOF13                   *((volatile unsigned char*)(0x42A422B4UL))
#define bFM_USB1_HEOF_EOF14                   *((volatile unsigned char*)(0x42A422B8UL))
#define bFM_USB1_HEOF_EOF15                   *((volatile unsigned char*)(0x42A422BCUL))
#define bFM_USB1_HEOF0_EOF00                  *((volatile unsigned char*)(0x42A42280UL))
#define bFM_USB1_HEOF0_EOF01                  *((volatile unsigned char*)(0x42A42284UL))
#define bFM_USB1_HEOF0_EOF02                  *((volatile unsigned char*)(0x42A42288UL))
#define bFM_USB1_HEOF0_EOF03                  *((volatile unsigned char*)(0x42A4228CUL))
#define bFM_USB1_HEOF0_EOF04                  *((volatile unsigned char*)(0x42A42290UL))
#define bFM_USB1_HEOF0_EOF05                  *((volatile unsigned char*)(0x42A42294UL))
#define bFM_USB1_HEOF0_EOF06                  *((volatile unsigned char*)(0x42A42298UL))
#define bFM_USB1_HEOF0_EOF07                  *((volatile unsigned char*)(0x42A4229CUL))
#define bFM_USB1_HEOF1_EOF10                  *((volatile unsigned char*)(0x42A422A0UL))
#define bFM_USB1_HEOF1_EOF11                  *((volatile unsigned char*)(0x42A422A4UL))
#define bFM_USB1_HEOF1_EOF12                  *((volatile unsigned char*)(0x42A422A8UL))
#define bFM_USB1_HEOF1_EOF13                  *((volatile unsigned char*)(0x42A422ACUL))
#define bFM_USB1_HEOF1_EOF14                  *((volatile unsigned char*)(0x42A422B0UL))
#define bFM_USB1_HEOF1_EOF15                  *((volatile unsigned char*)(0x42A422B4UL))
#define bFM_USB1_HFRAME_FRAME0                *((volatile unsigned char*)(0x42A42300UL))
#define bFM_USB1_HFRAME_FRAME1                *((volatile unsigned char*)(0x42A42304UL))
#define bFM_USB1_HFRAME_FRAME2                *((volatile unsigned char*)(0x42A42308UL))
#define bFM_USB1_HFRAME_FRAME3                *((volatile unsigned char*)(0x42A4230CUL))
#define bFM_USB1_HFRAME_FRAME4                *((volatile unsigned char*)(0x42A42310UL))
#define bFM_USB1_HFRAME_FRAME5                *((volatile unsigned char*)(0x42A42314UL))
#define bFM_USB1_HFRAME_FRAME6                *((volatile unsigned char*)(0x42A42318UL))
#define bFM_USB1_HFRAME_FRAME7                *((volatile unsigned char*)(0x42A4231CUL))
#define bFM_USB1_HFRAME_FRAME8                *((volatile unsigned char*)(0x42A42320UL))
#define bFM_USB1_HFRAME_FRAME9                *((volatile unsigned char*)(0x42A42324UL))
#define bFM_USB1_HFRAME_FRAME10               *((volatile unsigned char*)(0x42A42328UL))
#define bFM_USB1_HFRAME0_FRAME00              *((volatile unsigned char*)(0x42A42300UL))
#define bFM_USB1_HFRAME0_FRAME01              *((volatile unsigned char*)(0x42A42304UL))
#define bFM_USB1_HFRAME0_FRAME02              *((volatile unsigned char*)(0x42A42308UL))
#define bFM_USB1_HFRAME0_FRAME03              *((volatile unsigned char*)(0x42A4230CUL))
#define bFM_USB1_HFRAME0_FRAME04              *((volatile unsigned char*)(0x42A42310UL))
#define bFM_USB1_HFRAME0_FRAME05              *((volatile unsigned char*)(0x42A42314UL))
#define bFM_USB1_HFRAME0_FRAME06              *((volatile unsigned char*)(0x42A42318UL))
#define bFM_USB1_HFRAME0_FRAME07              *((volatile unsigned char*)(0x42A4231CUL))
#define bFM_USB1_HFRAME1_FRAME10              *((volatile unsigned char*)(0x42A42320UL))
#define bFM_USB1_HFRAME1_FRAME11              *((volatile unsigned char*)(0x42A42324UL))
#define bFM_USB1_HFRAME1_FRAME12              *((volatile unsigned char*)(0x42A42328UL))
#define bFM_USB1_HFRAME1_FRAME13              *((volatile unsigned char*)(0x42A4232CUL))
#define bFM_USB1_HTOKEN_ENDPT0                *((volatile unsigned char*)(0x42A42380UL))
#define bFM_USB1_HTOKEN_ENDPT1                *((volatile unsigned char*)(0x42A42384UL))
#define bFM_USB1_HTOKEN_ENDPT2                *((volatile unsigned char*)(0x42A42388UL))
#define bFM_USB1_HTOKEN_ENDPT3                *((volatile unsigned char*)(0x42A4238CUL))
#define bFM_USB1_HTOKEN_TKNEN0                *((volatile unsigned char*)(0x42A42390UL))
#define bFM_USB1_HTOKEN_TKNEN1                *((volatile unsigned char*)(0x42A42394UL))
#define bFM_USB1_HTOKEN_TKNEN2                *((volatile unsigned char*)(0x42A42398UL))
#define bFM_USB1_HTOKEN_TGGL                  *((volatile unsigned char*)(0x42A4239CUL))
#define bFM_USB1_UDCC_PWC                     *((volatile unsigned char*)(0x42A42400UL))
#define bFM_USB1_UDCC_RFBK                    *((volatile unsigned char*)(0x42A42404UL))
#define bFM_USB1_UDCC_STALCLREN               *((volatile unsigned char*)(0x42A4240CUL))
#define bFM_USB1_UDCC_USTP                    *((volatile unsigned char*)(0x42A42410UL))
#define bFM_USB1_UDCC_HCONX                   *((volatile unsigned char*)(0x42A42414UL))
#define bFM_USB1_UDCC_RESUM                   *((volatile unsigned char*)(0x42A42418UL))
#define bFM_USB1_UDCC_RST                     *((volatile unsigned char*)(0x42A4241CUL))
#define bFM_USB1_EP0C_PKS00                   *((volatile unsigned int*)(0x42A42480UL))
#define bFM_USB1_EP0C_PKS01                   *((volatile unsigned int*)(0x42A42484UL))
#define bFM_USB1_EP0C_PKS02                   *((volatile unsigned int*)(0x42A42488UL))
#define bFM_USB1_EP0C_PKS03                   *((volatile unsigned int*)(0x42A4248CUL))
#define bFM_USB1_EP0C_PKS04                   *((volatile unsigned int*)(0x42A42490UL))
#define bFM_USB1_EP0C_PKS05                   *((volatile unsigned int*)(0x42A42494UL))
#define bFM_USB1_EP0C_PKS06                   *((volatile unsigned int*)(0x42A42498UL))
#define bFM_USB1_EP0C_STAL                    *((volatile unsigned int*)(0x42A424A4UL))
#define bFM_USB1_EP1C_PKS10                   *((volatile unsigned int*)(0x42A42500UL))
#define bFM_USB1_EP1C_PKS11                   *((volatile unsigned int*)(0x42A42504UL))
#define bFM_USB1_EP1C_PKS12                   *((volatile unsigned int*)(0x42A42508UL))
#define bFM_USB1_EP1C_PKS13                   *((volatile unsigned int*)(0x42A4250CUL))
#define bFM_USB1_EP1C_PKS14                   *((volatile unsigned int*)(0x42A42510UL))
#define bFM_USB1_EP1C_PKS15                   *((volatile unsigned int*)(0x42A42514UL))
#define bFM_USB1_EP1C_PKS16                   *((volatile unsigned int*)(0x42A42518UL))
#define bFM_USB1_EP1C_PKS17                   *((volatile unsigned int*)(0x42A4251CUL))
#define bFM_USB1_EP1C_PKS18                   *((volatile unsigned int*)(0x42A42520UL))
#define bFM_USB1_EP1C_STAL                    *((volatile unsigned int*)(0x42A42524UL))
#define bFM_USB1_EP1C_NULE                    *((volatile unsigned int*)(0x42A42528UL))
#define bFM_USB1_EP1C_DMAE                    *((volatile unsigned int*)(0x42A4252CUL))
#define bFM_USB1_EP1C_DIR                     *((volatile unsigned int*)(0x42A42530UL))
#define bFM_USB1_EP1C_TYPE0                   *((volatile unsigned int*)(0x42A42534UL))
#define bFM_USB1_EP1C_TYPE1                   *((volatile unsigned int*)(0x42A42538UL))
#define bFM_USB1_EP1C_EPEN                    *((volatile unsigned int*)(0x42A4253CUL))
#define bFM_USB1_EP2C_PKS20                   *((volatile unsigned int*)(0x42A42580UL))
#define bFM_USB1_EP2C_PKS21                   *((volatile unsigned int*)(0x42A42584UL))
#define bFM_USB1_EP2C_PKS22                   *((volatile unsigned int*)(0x42A42588UL))
#define bFM_USB1_EP2C_PKS23                   *((volatile unsigned int*)(0x42A4258CUL))
#define bFM_USB1_EP2C_PKS24                   *((volatile unsigned int*)(0x42A42590UL))
#define bFM_USB1_EP2C_PKS25                   *((volatile unsigned int*)(0x42A42594UL))
#define bFM_USB1_EP2C_PKS26                   *((volatile unsigned int*)(0x42A42598UL))
#define bFM_USB1_EP2C_STAL                    *((volatile unsigned int*)(0x42A425A4UL))
#define bFM_USB1_EP2C_NULE                    *((volatile unsigned int*)(0x42A425A8UL))
#define bFM_USB1_EP2C_DMAE                    *((volatile unsigned int*)(0x42A425ACUL))
#define bFM_USB1_EP2C_DIR                     *((volatile unsigned int*)(0x42A425B0UL))
#define bFM_USB1_EP2C_TYPE0                   *((volatile unsigned int*)(0x42A425B4UL))
#define bFM_USB1_EP2C_TYPE1                   *((volatile unsigned int*)(0x42A425B8UL))
#define bFM_USB1_EP2C_EPEN                    *((volatile unsigned int*)(0x42A425BCUL))
#define bFM_USB1_EP3C_PKS30                   *((volatile unsigned int*)(0x42A42600UL))
#define bFM_USB1_EP3C_PKS31                   *((volatile unsigned int*)(0x42A42604UL))
#define bFM_USB1_EP3C_PKS32                   *((volatile unsigned int*)(0x42A42608UL))
#define bFM_USB1_EP3C_PKS33                   *((volatile unsigned int*)(0x42A4260CUL))
#define bFM_USB1_EP3C_PKS34                   *((volatile unsigned int*)(0x42A42610UL))
#define bFM_USB1_EP3C_PKS35                   *((volatile unsigned int*)(0x42A42614UL))
#define bFM_USB1_EP3C_PKS36                   *((volatile unsigned int*)(0x42A42618UL))
#define bFM_USB1_EP3C_STAL                    *((volatile unsigned int*)(0x42A42624UL))
#define bFM_USB1_EP3C_NULE                    *((volatile unsigned int*)(0x42A42628UL))
#define bFM_USB1_EP3C_DMAE                    *((volatile unsigned int*)(0x42A4262CUL))
#define bFM_USB1_EP3C_DIR                     *((volatile unsigned int*)(0x42A42630UL))
#define bFM_USB1_EP3C_TYPE0                   *((volatile unsigned int*)(0x42A42634UL))
#define bFM_USB1_EP3C_TYPE1                   *((volatile unsigned int*)(0x42A42638UL))
#define bFM_USB1_EP3C_EPEN                    *((volatile unsigned int*)(0x42A4263CUL))
#define bFM_USB1_EP4C_PKS40                   *((volatile unsigned int*)(0x42A42680UL))
#define bFM_USB1_EP4C_PKS41                   *((volatile unsigned int*)(0x42A42684UL))
#define bFM_USB1_EP4C_PKS42                   *((volatile unsigned int*)(0x42A42688UL))
#define bFM_USB1_EP4C_PKS43                   *((volatile unsigned int*)(0x42A4268CUL))
#define bFM_USB1_EP4C_PKS44                   *((volatile unsigned int*)(0x42A42690UL))
#define bFM_USB1_EP4C_PKS45                   *((volatile unsigned int*)(0x42A42694UL))
#define bFM_USB1_EP4C_PKS46                   *((volatile unsigned int*)(0x42A42698UL))
#define bFM_USB1_EP4C_STAL                    *((volatile unsigned int*)(0x42A426A4UL))
#define bFM_USB1_EP4C_NULE                    *((volatile unsigned int*)(0x42A426A8UL))
#define bFM_USB1_EP4C_DMAE                    *((volatile unsigned int*)(0x42A426ACUL))
#define bFM_USB1_EP4C_DIR                     *((volatile unsigned int*)(0x42A426B0UL))
#define bFM_USB1_EP4C_TYPE0                   *((volatile unsigned int*)(0x42A426B4UL))
#define bFM_USB1_EP4C_TYPE1                   *((volatile unsigned int*)(0x42A426B8UL))
#define bFM_USB1_EP4C_EPEN                    *((volatile unsigned int*)(0x42A426BCUL))
#define bFM_USB1_EP5C_PKS50                   *((volatile unsigned int*)(0x42A42700UL))
#define bFM_USB1_EP5C_PKS51                   *((volatile unsigned int*)(0x42A42704UL))
#define bFM_USB1_EP5C_PKS52                   *((volatile unsigned int*)(0x42A42708UL))
#define bFM_USB1_EP5C_PKS53                   *((volatile unsigned int*)(0x42A4270CUL))
#define bFM_USB1_EP5C_PKS54                   *((volatile unsigned int*)(0x42A42710UL))
#define bFM_USB1_EP5C_PKS55                   *((volatile unsigned int*)(0x42A42714UL))
#define bFM_USB1_EP5C_PKS56                   *((volatile unsigned int*)(0x42A42718UL))
#define bFM_USB1_EP5C_STAL                    *((volatile unsigned int*)(0x42A42724UL))
#define bFM_USB1_EP5C_NULE                    *((volatile unsigned int*)(0x42A42728UL))
#define bFM_USB1_EP5C_DMAE                    *((volatile unsigned int*)(0x42A4272CUL))
#define bFM_USB1_EP5C_DIR                     *((volatile unsigned int*)(0x42A42730UL))
#define bFM_USB1_EP5C_TYPE0                   *((volatile unsigned int*)(0x42A42734UL))
#define bFM_USB1_EP5C_TYPE1                   *((volatile unsigned int*)(0x42A42738UL))
#define bFM_USB1_EP5C_EPEN                    *((volatile unsigned int*)(0x42A4273CUL))
#define bFM_USB1_TMSP_TMSP0                   *((volatile unsigned int*)(0x42A42780UL))
#define bFM_USB1_TMSP_TMSP1                   *((volatile unsigned int*)(0x42A42784UL))
#define bFM_USB1_TMSP_TMSP2                   *((volatile unsigned int*)(0x42A42788UL))
#define bFM_USB1_TMSP_TMSP3                   *((volatile unsigned int*)(0x42A4278CUL))
#define bFM_USB1_TMSP_TMSP4                   *((volatile unsigned int*)(0x42A42790UL))
#define bFM_USB1_TMSP_TMSP5                   *((volatile unsigned int*)(0x42A42794UL))
#define bFM_USB1_TMSP_TMSP6                   *((volatile unsigned int*)(0x42A42798UL))
#define bFM_USB1_TMSP_TMSP7                   *((volatile unsigned int*)(0x42A4279CUL))
#define bFM_USB1_TMSP_TMSP8                   *((volatile unsigned int*)(0x42A427A0UL))
#define bFM_USB1_TMSP_TMSP9                   *((volatile unsigned int*)(0x42A427A4UL))
#define bFM_USB1_TMSP_TMSP10                  *((volatile unsigned int*)(0x42A427A8UL))
#define bFM_USB1_UDCS_CONF                    *((volatile unsigned char*)(0x42A42800UL))
#define bFM_USB1_UDCS_SETP                    *((volatile unsigned char*)(0x42A42804UL))
#define bFM_USB1_UDCS_WKUP                    *((volatile unsigned char*)(0x42A42808UL))
#define bFM_USB1_UDCS_BRST                    *((volatile unsigned char*)(0x42A4280CUL))
#define bFM_USB1_UDCS_SOF                     *((volatile unsigned char*)(0x42A42810UL))
#define bFM_USB1_UDCS_SUSP                    *((volatile unsigned char*)(0x42A42814UL))
#define bFM_USB1_UDCIE_CONFIE                 *((volatile unsigned char*)(0x42A42820UL))
#define bFM_USB1_UDCIE_CONFN                  *((volatile unsigned char*)(0x42A42824UL))
#define bFM_USB1_UDCIE_WKUPIE                 *((volatile unsigned char*)(0x42A42828UL))
#define bFM_USB1_UDCIE_BRSTIE                 *((volatile unsigned char*)(0x42A4282CUL))
#define bFM_USB1_UDCIE_SOFIE                  *((volatile unsigned char*)(0x42A42830UL))
#define bFM_USB1_UDCIE_SUSPIE                 *((volatile unsigned char*)(0x42A42834UL))
#define bFM_USB1_EP0IS_DRQI                   *((volatile unsigned int*)(0x42A428A8UL))
#define bFM_USB1_EP0IS_DRQIIE                 *((volatile unsigned int*)(0x42A428B8UL))
#define bFM_USB1_EP0IS_BFINI                  *((volatile unsigned int*)(0x42A428BCUL))
#define bFM_USB1_EP0OS_SIZE0                  *((volatile unsigned int*)(0x42A42900UL))
#define bFM_USB1_EP0OS_SIZE1                  *((volatile unsigned int*)(0x42A42904UL))
#define bFM_USB1_EP0OS_SIZE2                  *((volatile unsigned int*)(0x42A42908UL))
#define bFM_USB1_EP0OS_SIZE3                  *((volatile unsigned int*)(0x42A4290CUL))
#define bFM_USB1_EP0OS_SIZE4                  *((volatile unsigned int*)(0x42A42910UL))
#define bFM_USB1_EP0OS_SIZE5                  *((volatile unsigned int*)(0x42A42914UL))
#define bFM_USB1_EP0OS_SIZE6                  *((volatile unsigned int*)(0x42A42918UL))
#define bFM_USB1_EP0OS_SPK                    *((volatile unsigned int*)(0x42A42924UL))
#define bFM_USB1_EP0OS_DRQO                   *((volatile unsigned int*)(0x42A42928UL))
#define bFM_USB1_EP0OS_SPKIE                  *((volatile unsigned int*)(0x42A42934UL))
#define bFM_USB1_EP0OS_DRQOIE                 *((volatile unsigned int*)(0x42A42938UL))
#define bFM_USB1_EP0OS_BFINI                  *((volatile unsigned int*)(0x42A4293CUL))
#define bFM_USB1_EP1S_SIZE10                  *((volatile unsigned int*)(0x42A42980UL))
#define bFM_USB1_EP1S_SIZE11                  *((volatile unsigned int*)(0x42A42984UL))
#define bFM_USB1_EP1S_SIZE12                  *((volatile unsigned int*)(0x42A42988UL))
#define bFM_USB1_EP1S_SIZE13                  *((volatile unsigned int*)(0x42A4298CUL))
#define bFM_USB1_EP1S_SIZE14                  *((volatile unsigned int*)(0x42A42990UL))
#define bFM_USB1_EP1S_SIZE15                  *((volatile unsigned int*)(0x42A42994UL))
#define bFM_USB1_EP1S_SIZE16                  *((volatile unsigned int*)(0x42A42998UL))
#define bFM_USB1_EP1S_SIZE17                  *((volatile unsigned int*)(0x42A4299CUL))
#define bFM_USB1_EP1S_SIZE18                  *((volatile unsigned int*)(0x42A429A0UL))
#define bFM_USB1_EP1S_SPK                     *((volatile unsigned int*)(0x42A429A4UL))
#define bFM_USB1_EP1S_DRQ                     *((volatile unsigned int*)(0x42A429A8UL))
#define bFM_USB1_EP1S_BUSY                    *((volatile unsigned int*)(0x42A429ACUL))
#define bFM_USB1_EP1S_SPKIE                   *((volatile unsigned int*)(0x42A429B4UL))
#define bFM_USB1_EP1S_DRQIE                   *((volatile unsigned int*)(0x42A429B8UL))
#define bFM_USB1_EP1S_BFINI                   *((volatile unsigned int*)(0x42A429BCUL))
#define bFM_USB1_EP2S_SIZE20                  *((volatile unsigned int*)(0x42A42A00UL))
#define bFM_USB1_EP2S_SIZE21                  *((volatile unsigned int*)(0x42A42A04UL))
#define bFM_USB1_EP2S_SIZE22                  *((volatile unsigned int*)(0x42A42A08UL))
#define bFM_USB1_EP2S_SIZE23                  *((volatile unsigned int*)(0x42A42A0CUL))
#define bFM_USB1_EP2S_SIZE24                  *((volatile unsigned int*)(0x42A42A10UL))
#define bFM_USB1_EP2S_SIZE25                  *((volatile unsigned int*)(0x42A42A14UL))
#define bFM_USB1_EP2S_SIZE26                  *((volatile unsigned int*)(0x42A42A18UL))
#define bFM_USB1_EP2S_SPK                     *((volatile unsigned int*)(0x42A42A24UL))
#define bFM_USB1_EP2S_DRQ                     *((volatile unsigned int*)(0x42A42A28UL))
#define bFM_USB1_EP2S_BUSY                    *((volatile unsigned int*)(0x42A42A2CUL))
#define bFM_USB1_EP2S_SPKIE                   *((volatile unsigned int*)(0x42A42A34UL))
#define bFM_USB1_EP2S_DRQIE                   *((volatile unsigned int*)(0x42A42A38UL))
#define bFM_USB1_EP2S_BFINI                   *((volatile unsigned int*)(0x42A42A3CUL))
#define bFM_USB1_EP3S_SIZE30                  *((volatile unsigned int*)(0x42A42A80UL))
#define bFM_USB1_EP3S_SIZE31                  *((volatile unsigned int*)(0x42A42A84UL))
#define bFM_USB1_EP3S_SIZE32                  *((volatile unsigned int*)(0x42A42A88UL))
#define bFM_USB1_EP3S_SIZE33                  *((volatile unsigned int*)(0x42A42A8CUL))
#define bFM_USB1_EP3S_SIZE34                  *((volatile unsigned int*)(0x42A42A90UL))
#define bFM_USB1_EP3S_SIZE35                  *((volatile unsigned int*)(0x42A42A94UL))
#define bFM_USB1_EP3S_SIZE36                  *((volatile unsigned int*)(0x42A42A98UL))
#define bFM_USB1_EP3S_SPK                     *((volatile unsigned int*)(0x42A42AA4UL))
#define bFM_USB1_EP3S_DRQ                     *((volatile unsigned int*)(0x42A42AA8UL))
#define bFM_USB1_EP3S_BUSY                    *((volatile unsigned int*)(0x42A42AACUL))
#define bFM_USB1_EP3S_SPKIE                   *((volatile unsigned int*)(0x42A42AB4UL))
#define bFM_USB1_EP3S_DRQIE                   *((volatile unsigned int*)(0x42A42AB8UL))
#define bFM_USB1_EP3S_BFINI                   *((volatile unsigned int*)(0x42A42ABCUL))
#define bFM_USB1_EP4S_SIZE40                  *((volatile unsigned int*)(0x42A42B00UL))
#define bFM_USB1_EP4S_SIZE41                  *((volatile unsigned int*)(0x42A42B04UL))
#define bFM_USB1_EP4S_SIZE42                  *((volatile unsigned int*)(0x42A42B08UL))
#define bFM_USB1_EP4S_SIZE43                  *((volatile unsigned int*)(0x42A42B0CUL))
#define bFM_USB1_EP4S_SIZE44                  *((volatile unsigned int*)(0x42A42B10UL))
#define bFM_USB1_EP4S_SIZE45                  *((volatile unsigned int*)(0x42A42B14UL))
#define bFM_USB1_EP4S_SIZE46                  *((volatile unsigned int*)(0x42A42B18UL))
#define bFM_USB1_EP4S_SPK                     *((volatile unsigned int*)(0x42A42B24UL))
#define bFM_USB1_EP4S_DRQ                     *((volatile unsigned int*)(0x42A42B28UL))
#define bFM_USB1_EP4S_BUSY                    *((volatile unsigned int*)(0x42A42B2CUL))
#define bFM_USB1_EP4S_SPKIE                   *((volatile unsigned int*)(0x42A42B34UL))
#define bFM_USB1_EP4S_DRQIE                   *((volatile unsigned int*)(0x42A42B38UL))
#define bFM_USB1_EP4S_BFINI                   *((volatile unsigned int*)(0x42A42B3CUL))
#define bFM_USB1_EP5S_SIZE50                  *((volatile unsigned int*)(0x42A42B80UL))
#define bFM_USB1_EP5S_SIZE51                  *((volatile unsigned int*)(0x42A42B84UL))
#define bFM_USB1_EP5S_SIZE52                  *((volatile unsigned int*)(0x42A42B88UL))
#define bFM_USB1_EP5S_SIZE53                  *((volatile unsigned int*)(0x42A42B8CUL))
#define bFM_USB1_EP5S_SIZE54                  *((volatile unsigned int*)(0x42A42B90UL))
#define bFM_USB1_EP5S_SIZE55                  *((volatile unsigned int*)(0x42A42B94UL))
#define bFM_USB1_EP5S_SIZE56                  *((volatile unsigned int*)(0x42A42B98UL))
#define bFM_USB1_EP5S_SPK                     *((volatile unsigned int*)(0x42A42BA4UL))
#define bFM_USB1_EP5S_DRQ                     *((volatile unsigned int*)(0x42A42BA8UL))
#define bFM_USB1_EP5S_BUSY                    *((volatile unsigned int*)(0x42A42BACUL))
#define bFM_USB1_EP5S_SPKIE                   *((volatile unsigned int*)(0x42A42BB4UL))
#define bFM_USB1_EP5S_DRQIE                   *((volatile unsigned int*)(0x42A42BB8UL))
#define bFM_USB1_EP5S_BFINI                   *((volatile unsigned int*)(0x42A42BBCUL))

/* DMA controller */
#define bFM_DMAC_DMACR_DH0                    *((volatile unsigned char*)(0x42C00060UL))
#define bFM_DMAC_DMACR_DH1                    *((volatile unsigned char*)(0x42C00064UL))
#define bFM_DMAC_DMACR_DH2                    *((volatile unsigned char*)(0x42C00068UL))
#define bFM_DMAC_DMACR_DH3                    *((volatile unsigned char*)(0x42C0006CUL))
#define bFM_DMAC_DMACR_PR                     *((volatile unsigned char*)(0x42C00070UL))
#define bFM_DMAC_DMACR_DS                     *((volatile unsigned char*)(0x42C00078UL))
#define bFM_DMAC_DMACR_DE                     *((volatile unsigned char*)(0x42C0007CUL))
#define bFM_DMAC_DMACA0_TC0                   *((volatile unsigned char*)(0x42C00200UL))
#define bFM_DMAC_DMACA0_TC1                   *((volatile unsigned char*)(0x42C00204UL))
#define bFM_DMAC_DMACA0_TC2                   *((volatile unsigned char*)(0x42C00208UL))
#define bFM_DMAC_DMACA0_TC3                   *((volatile unsigned char*)(0x42C0020CUL))
#define bFM_DMAC_DMACA0_TC4                   *((volatile unsigned char*)(0x42C00210UL))
#define bFM_DMAC_DMACA0_TC5                   *((volatile unsigned char*)(0x42C00214UL))
#define bFM_DMAC_DMACA0_TC6                   *((volatile unsigned char*)(0x42C00218UL))
#define bFM_DMAC_DMACA0_TC7                   *((volatile unsigned char*)(0x42C0021CUL))
#define bFM_DMAC_DMACA0_TC8                   *((volatile unsigned char*)(0x42C00220UL))
#define bFM_DMAC_DMACA0_TC9                   *((volatile unsigned char*)(0x42C00224UL))
#define bFM_DMAC_DMACA0_TC10                  *((volatile unsigned char*)(0x42C00228UL))
#define bFM_DMAC_DMACA0_TC11                  *((volatile unsigned char*)(0x42C0022CUL))
#define bFM_DMAC_DMACA0_TC12                  *((volatile unsigned char*)(0x42C00230UL))
#define bFM_DMAC_DMACA0_TC13                  *((volatile unsigned char*)(0x42C00234UL))
#define bFM_DMAC_DMACA0_TC14                  *((volatile unsigned char*)(0x42C00238UL))
#define bFM_DMAC_DMACA0_TC15                  *((volatile unsigned char*)(0x42C0023CUL))
#define bFM_DMAC_DMACA0_BC0                   *((volatile unsigned char*)(0x42C00240UL))
#define bFM_DMAC_DMACA0_BC1                   *((volatile unsigned char*)(0x42C00244UL))
#define bFM_DMAC_DMACA0_BC2                   *((volatile unsigned char*)(0x42C00248UL))
#define bFM_DMAC_DMACA0_BC3                   *((volatile unsigned char*)(0x42C0024CUL))
#define bFM_DMAC_DMACA0_IS0                   *((volatile unsigned char*)(0x42C0025CUL))
#define bFM_DMAC_DMACA0_IS1                   *((volatile unsigned char*)(0x42C00260UL))
#define bFM_DMAC_DMACA0_IS2                   *((volatile unsigned char*)(0x42C00264UL))
#define bFM_DMAC_DMACA0_IS3                   *((volatile unsigned char*)(0x42C00268UL))
#define bFM_DMAC_DMACA0_IS4                   *((volatile unsigned char*)(0x42C0026CUL))
#define bFM_DMAC_DMACA0_IS5                   *((volatile unsigned char*)(0x42C00270UL))
#define bFM_DMAC_DMACA0_ST                    *((volatile unsigned char*)(0x42C00274UL))
#define bFM_DMAC_DMACA0_PB                    *((volatile unsigned char*)(0x42C00278UL))
#define bFM_DMAC_DMACA0_EB                    *((volatile unsigned char*)(0x42C0027CUL))
#define bFM_DMAC_DMACB0_EM                    *((volatile unsigned char*)(0x42C00280UL))
#define bFM_DMAC_DMACB0_SS0                   *((volatile unsigned char*)(0x42C002C0UL))
#define bFM_DMAC_DMACB0_SS1                   *((volatile unsigned char*)(0x42C002C4UL))
#define bFM_DMAC_DMACB0_SS2                   *((volatile unsigned char*)(0x42C002C8UL))
#define bFM_DMAC_DMACB0_CI                    *((volatile unsigned char*)(0x42C002CCUL))
#define bFM_DMAC_DMACB0_EI                    *((volatile unsigned char*)(0x42C002D0UL))
#define bFM_DMAC_DMACB0_RD                    *((volatile unsigned char*)(0x42C002D4UL))
#define bFM_DMAC_DMACB0_RS                    *((volatile unsigned char*)(0x42C002D8UL))
#define bFM_DMAC_DMACB0_RC                    *((volatile unsigned char*)(0x42C002DCUL))
#define bFM_DMAC_DMACB0_FD                    *((volatile unsigned char*)(0x42C002E0UL))
#define bFM_DMAC_DMACB0_FS                    *((volatile unsigned char*)(0x42C002E4UL))
#define bFM_DMAC_DMACB0_TW0                   *((volatile unsigned char*)(0x42C002E8UL))
#define bFM_DMAC_DMACB0_TW1                   *((volatile unsigned char*)(0x42C002ECUL))
#define bFM_DMAC_DMACB0_MS0                   *((volatile unsigned char*)(0x42C002F0UL))
#define bFM_DMAC_DMACB0_MS1                   *((volatile unsigned char*)(0x42C002F4UL))
#define bFM_DMAC_DMACA1_TC0                   *((volatile unsigned char*)(0x42C00400UL))
#define bFM_DMAC_DMACA1_TC1                   *((volatile unsigned char*)(0x42C00404UL))
#define bFM_DMAC_DMACA1_TC2                   *((volatile unsigned char*)(0x42C00408UL))
#define bFM_DMAC_DMACA1_TC3                   *((volatile unsigned char*)(0x42C0040CUL))
#define bFM_DMAC_DMACA1_TC4                   *((volatile unsigned char*)(0x42C00410UL))
#define bFM_DMAC_DMACA1_TC5                   *((volatile unsigned char*)(0x42C00414UL))
#define bFM_DMAC_DMACA1_TC6                   *((volatile unsigned char*)(0x42C00418UL))
#define bFM_DMAC_DMACA1_TC7                   *((volatile unsigned char*)(0x42C0041CUL))
#define bFM_DMAC_DMACA1_TC8                   *((volatile unsigned char*)(0x42C00420UL))
#define bFM_DMAC_DMACA1_TC9                   *((volatile unsigned char*)(0x42C00424UL))
#define bFM_DMAC_DMACA1_TC10                  *((volatile unsigned char*)(0x42C00428UL))
#define bFM_DMAC_DMACA1_TC11                  *((volatile unsigned char*)(0x42C0042CUL))
#define bFM_DMAC_DMACA1_TC12                  *((volatile unsigned char*)(0x42C00430UL))
#define bFM_DMAC_DMACA1_TC13                  *((volatile unsigned char*)(0x42C00434UL))
#define bFM_DMAC_DMACA1_TC14                  *((volatile unsigned char*)(0x42C00438UL))
#define bFM_DMAC_DMACA1_TC15                  *((volatile unsigned char*)(0x42C0043CUL))
#define bFM_DMAC_DMACA1_BC0                   *((volatile unsigned char*)(0x42C00440UL))
#define bFM_DMAC_DMACA1_BC1                   *((volatile unsigned char*)(0x42C00444UL))
#define bFM_DMAC_DMACA1_BC2                   *((volatile unsigned char*)(0x42C00448UL))
#define bFM_DMAC_DMACA1_BC3                   *((volatile unsigned char*)(0x42C0044CUL))
#define bFM_DMAC_DMACA1_IS0                   *((volatile unsigned char*)(0x42C0045CUL))
#define bFM_DMAC_DMACA1_IS1                   *((volatile unsigned char*)(0x42C00460UL))
#define bFM_DMAC_DMACA1_IS2                   *((volatile unsigned char*)(0x42C00464UL))
#define bFM_DMAC_DMACA1_IS3                   *((volatile unsigned char*)(0x42C00468UL))
#define bFM_DMAC_DMACA1_IS4                   *((volatile unsigned char*)(0x42C0046CUL))
#define bFM_DMAC_DMACA1_IS5                   *((volatile unsigned char*)(0x42C00470UL))
#define bFM_DMAC_DMACA1_ST                    *((volatile unsigned char*)(0x42C00474UL))
#define bFM_DMAC_DMACA1_PB                    *((volatile unsigned char*)(0x42C00478UL))
#define bFM_DMAC_DMACA1_EB                    *((volatile unsigned char*)(0x42C0047CUL))
#define bFM_DMAC_DMACB1_EM                    *((volatile unsigned char*)(0x42C00480UL))
#define bFM_DMAC_DMACB1_SS0                   *((volatile unsigned char*)(0x42C004C0UL))
#define bFM_DMAC_DMACB1_SS1                   *((volatile unsigned char*)(0x42C004C4UL))
#define bFM_DMAC_DMACB1_SS2                   *((volatile unsigned char*)(0x42C004C8UL))
#define bFM_DMAC_DMACB1_CI                    *((volatile unsigned char*)(0x42C004CCUL))
#define bFM_DMAC_DMACB1_EI                    *((volatile unsigned char*)(0x42C004D0UL))
#define bFM_DMAC_DMACB1_RD                    *((volatile unsigned char*)(0x42C004D4UL))
#define bFM_DMAC_DMACB1_RS                    *((volatile unsigned char*)(0x42C004D8UL))
#define bFM_DMAC_DMACB1_RC                    *((volatile unsigned char*)(0x42C004DCUL))
#define bFM_DMAC_DMACB1_FD                    *((volatile unsigned char*)(0x42C004E0UL))
#define bFM_DMAC_DMACB1_FS                    *((volatile unsigned char*)(0x42C004E4UL))
#define bFM_DMAC_DMACB1_TW0                   *((volatile unsigned char*)(0x42C004E8UL))
#define bFM_DMAC_DMACB1_TW1                   *((volatile unsigned char*)(0x42C004ECUL))
#define bFM_DMAC_DMACB1_MS0                   *((volatile unsigned char*)(0x42C004F0UL))
#define bFM_DMAC_DMACB1_MS1                   *((volatile unsigned char*)(0x42C004F4UL))
#define bFM_DMAC_DMACA2_TC0                   *((volatile unsigned char*)(0x42C00600UL))
#define bFM_DMAC_DMACA2_TC1                   *((volatile unsigned char*)(0x42C00604UL))
#define bFM_DMAC_DMACA2_TC2                   *((volatile unsigned char*)(0x42C00608UL))
#define bFM_DMAC_DMACA2_TC3                   *((volatile unsigned char*)(0x42C0060CUL))
#define bFM_DMAC_DMACA2_TC4                   *((volatile unsigned char*)(0x42C00610UL))
#define bFM_DMAC_DMACA2_TC5                   *((volatile unsigned char*)(0x42C00614UL))
#define bFM_DMAC_DMACA2_TC6                   *((volatile unsigned char*)(0x42C00618UL))
#define bFM_DMAC_DMACA2_TC7                   *((volatile unsigned char*)(0x42C0061CUL))
#define bFM_DMAC_DMACA2_TC8                   *((volatile unsigned char*)(0x42C00620UL))
#define bFM_DMAC_DMACA2_TC9                   *((volatile unsigned char*)(0x42C00624UL))
#define bFM_DMAC_DMACA2_TC10                  *((volatile unsigned char*)(0x42C00628UL))
#define bFM_DMAC_DMACA2_TC11                  *((volatile unsigned char*)(0x42C0062CUL))
#define bFM_DMAC_DMACA2_TC12                  *((volatile unsigned char*)(0x42C00630UL))
#define bFM_DMAC_DMACA2_TC13                  *((volatile unsigned char*)(0x42C00634UL))
#define bFM_DMAC_DMACA2_TC14                  *((volatile unsigned char*)(0x42C00638UL))
#define bFM_DMAC_DMACA2_TC15                  *((volatile unsigned char*)(0x42C0063CUL))
#define bFM_DMAC_DMACA2_BC0                   *((volatile unsigned char*)(0x42C00640UL))
#define bFM_DMAC_DMACA2_BC1                   *((volatile unsigned char*)(0x42C00644UL))
#define bFM_DMAC_DMACA2_BC2                   *((volatile unsigned char*)(0x42C00648UL))
#define bFM_DMAC_DMACA2_BC3                   *((volatile unsigned char*)(0x42C0064CUL))
#define bFM_DMAC_DMACA2_IS0                   *((volatile unsigned char*)(0x42C0065CUL))
#define bFM_DMAC_DMACA2_IS1                   *((volatile unsigned char*)(0x42C00660UL))
#define bFM_DMAC_DMACA2_IS2                   *((volatile unsigned char*)(0x42C00664UL))
#define bFM_DMAC_DMACA2_IS3                   *((volatile unsigned char*)(0x42C00668UL))
#define bFM_DMAC_DMACA2_IS4                   *((volatile unsigned char*)(0x42C0066CUL))
#define bFM_DMAC_DMACA2_IS5                   *((volatile unsigned char*)(0x42C00670UL))
#define bFM_DMAC_DMACA2_ST                    *((volatile unsigned char*)(0x42C00674UL))
#define bFM_DMAC_DMACA2_PB                    *((volatile unsigned char*)(0x42C00678UL))
#define bFM_DMAC_DMACA2_EB                    *((volatile unsigned char*)(0x42C0067CUL))
#define bFM_DMAC_DMACB2_EM                    *((volatile unsigned char*)(0x42C00680UL))
#define bFM_DMAC_DMACB2_SS0                   *((volatile unsigned char*)(0x42C006C0UL))
#define bFM_DMAC_DMACB2_SS1                   *((volatile unsigned char*)(0x42C006C4UL))
#define bFM_DMAC_DMACB2_SS2                   *((volatile unsigned char*)(0x42C006C8UL))
#define bFM_DMAC_DMACB2_CI                    *((volatile unsigned char*)(0x42C006CCUL))
#define bFM_DMAC_DMACB2_EI                    *((volatile unsigned char*)(0x42C006D0UL))
#define bFM_DMAC_DMACB2_RD                    *((volatile unsigned char*)(0x42C006D4UL))
#define bFM_DMAC_DMACB2_RS                    *((volatile unsigned char*)(0x42C006D8UL))
#define bFM_DMAC_DMACB2_RC                    *((volatile unsigned char*)(0x42C006DCUL))
#define bFM_DMAC_DMACB2_FD                    *((volatile unsigned char*)(0x42C006E0UL))
#define bFM_DMAC_DMACB2_FS                    *((volatile unsigned char*)(0x42C006E4UL))
#define bFM_DMAC_DMACB2_TW0                   *((volatile unsigned char*)(0x42C006E8UL))
#define bFM_DMAC_DMACB2_TW1                   *((volatile unsigned char*)(0x42C006ECUL))
#define bFM_DMAC_DMACB2_MS0                   *((volatile unsigned char*)(0x42C006F0UL))
#define bFM_DMAC_DMACB2_MS1                   *((volatile unsigned char*)(0x42C006F4UL))
#define bFM_DMAC_DMACA3_TC0                   *((volatile unsigned char*)(0x42C00800UL))
#define bFM_DMAC_DMACA3_TC1                   *((volatile unsigned char*)(0x42C00804UL))
#define bFM_DMAC_DMACA3_TC2                   *((volatile unsigned char*)(0x42C00808UL))
#define bFM_DMAC_DMACA3_TC3                   *((volatile unsigned char*)(0x42C0080CUL))
#define bFM_DMAC_DMACA3_TC4                   *((volatile unsigned char*)(0x42C00810UL))
#define bFM_DMAC_DMACA3_TC5                   *((volatile unsigned char*)(0x42C00814UL))
#define bFM_DMAC_DMACA3_TC6                   *((volatile unsigned char*)(0x42C00818UL))
#define bFM_DMAC_DMACA3_TC7                   *((volatile unsigned char*)(0x42C0081CUL))
#define bFM_DMAC_DMACA3_TC8                   *((volatile unsigned char*)(0x42C00820UL))
#define bFM_DMAC_DMACA3_TC9                   *((volatile unsigned char*)(0x42C00824UL))
#define bFM_DMAC_DMACA3_TC10                  *((volatile unsigned char*)(0x42C00828UL))
#define bFM_DMAC_DMACA3_TC11                  *((volatile unsigned char*)(0x42C0082CUL))
#define bFM_DMAC_DMACA3_TC12                  *((volatile unsigned char*)(0x42C00830UL))
#define bFM_DMAC_DMACA3_TC13                  *((volatile unsigned char*)(0x42C00834UL))
#define bFM_DMAC_DMACA3_TC14                  *((volatile unsigned char*)(0x42C00838UL))
#define bFM_DMAC_DMACA3_TC15                  *((volatile unsigned char*)(0x42C0083CUL))
#define bFM_DMAC_DMACA3_BC0                   *((volatile unsigned char*)(0x42C00840UL))
#define bFM_DMAC_DMACA3_BC1                   *((volatile unsigned char*)(0x42C00844UL))
#define bFM_DMAC_DMACA3_BC2                   *((volatile unsigned char*)(0x42C00848UL))
#define bFM_DMAC_DMACA3_BC3                   *((volatile unsigned char*)(0x42C0084CUL))
#define bFM_DMAC_DMACA3_IS0                   *((volatile unsigned char*)(0x42C0085CUL))
#define bFM_DMAC_DMACA3_IS1                   *((volatile unsigned char*)(0x42C00860UL))
#define bFM_DMAC_DMACA3_IS2                   *((volatile unsigned char*)(0x42C00864UL))
#define bFM_DMAC_DMACA3_IS3                   *((volatile unsigned char*)(0x42C00868UL))
#define bFM_DMAC_DMACA3_IS4                   *((volatile unsigned char*)(0x42C0086CUL))
#define bFM_DMAC_DMACA3_IS5                   *((volatile unsigned char*)(0x42C00870UL))
#define bFM_DMAC_DMACA3_ST                    *((volatile unsigned char*)(0x42C00874UL))
#define bFM_DMAC_DMACA3_PB                    *((volatile unsigned char*)(0x42C00878UL))
#define bFM_DMAC_DMACA3_EB                    *((volatile unsigned char*)(0x42C0087CUL))
#define bFM_DMAC_DMACB3_EM                    *((volatile unsigned char*)(0x42C00880UL))
#define bFM_DMAC_DMACB3_SS0                   *((volatile unsigned char*)(0x42C008C0UL))
#define bFM_DMAC_DMACB3_SS1                   *((volatile unsigned char*)(0x42C008C4UL))
#define bFM_DMAC_DMACB3_SS2                   *((volatile unsigned char*)(0x42C008C8UL))
#define bFM_DMAC_DMACB3_CI                    *((volatile unsigned char*)(0x42C008CCUL))
#define bFM_DMAC_DMACB3_EI                    *((volatile unsigned char*)(0x42C008D0UL))
#define bFM_DMAC_DMACB3_RD                    *((volatile unsigned char*)(0x42C008D4UL))
#define bFM_DMAC_DMACB3_RS                    *((volatile unsigned char*)(0x42C008D8UL))
#define bFM_DMAC_DMACB3_RC                    *((volatile unsigned char*)(0x42C008DCUL))
#define bFM_DMAC_DMACB3_FD                    *((volatile unsigned char*)(0x42C008E0UL))
#define bFM_DMAC_DMACB3_FS                    *((volatile unsigned char*)(0x42C008E4UL))
#define bFM_DMAC_DMACB3_TW0                   *((volatile unsigned char*)(0x42C008E8UL))
#define bFM_DMAC_DMACB3_TW1                   *((volatile unsigned char*)(0x42C008ECUL))
#define bFM_DMAC_DMACB3_MS0                   *((volatile unsigned char*)(0x42C008F0UL))
#define bFM_DMAC_DMACB3_MS1                   *((volatile unsigned char*)(0x42C008F4UL))
#define bFM_DMAC_DMACA4_TC0                   *((volatile unsigned char*)(0x42C00A00UL))
#define bFM_DMAC_DMACA4_TC1                   *((volatile unsigned char*)(0x42C00A04UL))
#define bFM_DMAC_DMACA4_TC2                   *((volatile unsigned char*)(0x42C00A08UL))
#define bFM_DMAC_DMACA4_TC3                   *((volatile unsigned char*)(0x42C00A0CUL))
#define bFM_DMAC_DMACA4_TC4                   *((volatile unsigned char*)(0x42C00A10UL))
#define bFM_DMAC_DMACA4_TC5                   *((volatile unsigned char*)(0x42C00A14UL))
#define bFM_DMAC_DMACA4_TC6                   *((volatile unsigned char*)(0x42C00A18UL))
#define bFM_DMAC_DMACA4_TC7                   *((volatile unsigned char*)(0x42C00A1CUL))
#define bFM_DMAC_DMACA4_TC8                   *((volatile unsigned char*)(0x42C00A20UL))
#define bFM_DMAC_DMACA4_TC9                   *((volatile unsigned char*)(0x42C00A24UL))
#define bFM_DMAC_DMACA4_TC10                  *((volatile unsigned char*)(0x42C00A28UL))
#define bFM_DMAC_DMACA4_TC11                  *((volatile unsigned char*)(0x42C00A2CUL))
#define bFM_DMAC_DMACA4_TC12                  *((volatile unsigned char*)(0x42C00A30UL))
#define bFM_DMAC_DMACA4_TC13                  *((volatile unsigned char*)(0x42C00A34UL))
#define bFM_DMAC_DMACA4_TC14                  *((volatile unsigned char*)(0x42C00A38UL))
#define bFM_DMAC_DMACA4_TC15                  *((volatile unsigned char*)(0x42C00A3CUL))
#define bFM_DMAC_DMACA4_BC0                   *((volatile unsigned char*)(0x42C00A40UL))
#define bFM_DMAC_DMACA4_BC1                   *((volatile unsigned char*)(0x42C00A44UL))
#define bFM_DMAC_DMACA4_BC2                   *((volatile unsigned char*)(0x42C00A48UL))
#define bFM_DMAC_DMACA4_BC3                   *((volatile unsigned char*)(0x42C00A4CUL))
#define bFM_DMAC_DMACA4_IS0                   *((volatile unsigned char*)(0x42C00A5CUL))
#define bFM_DMAC_DMACA4_IS1                   *((volatile unsigned char*)(0x42C00A60UL))
#define bFM_DMAC_DMACA4_IS2                   *((volatile unsigned char*)(0x42C00A64UL))
#define bFM_DMAC_DMACA4_IS3                   *((volatile unsigned char*)(0x42C00A68UL))
#define bFM_DMAC_DMACA4_IS4                   *((volatile unsigned char*)(0x42C00A6CUL))
#define bFM_DMAC_DMACA4_IS5                   *((volatile unsigned char*)(0x42C00A70UL))
#define bFM_DMAC_DMACA4_ST                    *((volatile unsigned char*)(0x42C00A74UL))
#define bFM_DMAC_DMACA4_PB                    *((volatile unsigned char*)(0x42C00A78UL))
#define bFM_DMAC_DMACA4_EB                    *((volatile unsigned char*)(0x42C00A7CUL))
#define bFM_DMAC_DMACB4_EM                    *((volatile unsigned char*)(0x42C00A80UL))
#define bFM_DMAC_DMACB4_SS0                   *((volatile unsigned char*)(0x42C00AC0UL))
#define bFM_DMAC_DMACB4_SS1                   *((volatile unsigned char*)(0x42C00AC4UL))
#define bFM_DMAC_DMACB4_SS2                   *((volatile unsigned char*)(0x42C00AC8UL))
#define bFM_DMAC_DMACB4_CI                    *((volatile unsigned char*)(0x42C00ACCUL))
#define bFM_DMAC_DMACB4_EI                    *((volatile unsigned char*)(0x42C00AD0UL))
#define bFM_DMAC_DMACB4_RD                    *((volatile unsigned char*)(0x42C00AD4UL))
#define bFM_DMAC_DMACB4_RS                    *((volatile unsigned char*)(0x42C00AD8UL))
#define bFM_DMAC_DMACB4_RC                    *((volatile unsigned char*)(0x42C00ADCUL))
#define bFM_DMAC_DMACB4_FD                    *((volatile unsigned char*)(0x42C00AE0UL))
#define bFM_DMAC_DMACB4_FS                    *((volatile unsigned char*)(0x42C00AE4UL))
#define bFM_DMAC_DMACB4_TW0                   *((volatile unsigned char*)(0x42C00AE8UL))
#define bFM_DMAC_DMACB4_TW1                   *((volatile unsigned char*)(0x42C00AECUL))
#define bFM_DMAC_DMACB4_MS0                   *((volatile unsigned char*)(0x42C00AF0UL))
#define bFM_DMAC_DMACB4_MS1                   *((volatile unsigned char*)(0x42C00AF4UL))
#define bFM_DMAC_DMACA5_TC0                   *((volatile unsigned char*)(0x42C00C00UL))
#define bFM_DMAC_DMACA5_TC1                   *((volatile unsigned char*)(0x42C00C04UL))
#define bFM_DMAC_DMACA5_TC2                   *((volatile unsigned char*)(0x42C00C08UL))
#define bFM_DMAC_DMACA5_TC3                   *((volatile unsigned char*)(0x42C00C0CUL))
#define bFM_DMAC_DMACA5_TC4                   *((volatile unsigned char*)(0x42C00C10UL))
#define bFM_DMAC_DMACA5_TC5                   *((volatile unsigned char*)(0x42C00C14UL))
#define bFM_DMAC_DMACA5_TC6                   *((volatile unsigned char*)(0x42C00C18UL))
#define bFM_DMAC_DMACA5_TC7                   *((volatile unsigned char*)(0x42C00C1CUL))
#define bFM_DMAC_DMACA5_TC8                   *((volatile unsigned char*)(0x42C00C20UL))
#define bFM_DMAC_DMACA5_TC9                   *((volatile unsigned char*)(0x42C00C24UL))
#define bFM_DMAC_DMACA5_TC10                  *((volatile unsigned char*)(0x42C00C28UL))
#define bFM_DMAC_DMACA5_TC11                  *((volatile unsigned char*)(0x42C00C2CUL))
#define bFM_DMAC_DMACA5_TC12                  *((volatile unsigned char*)(0x42C00C30UL))
#define bFM_DMAC_DMACA5_TC13                  *((volatile unsigned char*)(0x42C00C34UL))
#define bFM_DMAC_DMACA5_TC14                  *((volatile unsigned char*)(0x42C00C38UL))
#define bFM_DMAC_DMACA5_TC15                  *((volatile unsigned char*)(0x42C00C3CUL))
#define bFM_DMAC_DMACA5_BC0                   *((volatile unsigned char*)(0x42C00C40UL))
#define bFM_DMAC_DMACA5_BC1                   *((volatile unsigned char*)(0x42C00C44UL))
#define bFM_DMAC_DMACA5_BC2                   *((volatile unsigned char*)(0x42C00C48UL))
#define bFM_DMAC_DMACA5_BC3                   *((volatile unsigned char*)(0x42C00C4CUL))
#define bFM_DMAC_DMACA5_IS0                   *((volatile unsigned char*)(0x42C00C5CUL))
#define bFM_DMAC_DMACA5_IS1                   *((volatile unsigned char*)(0x42C00C60UL))
#define bFM_DMAC_DMACA5_IS2                   *((volatile unsigned char*)(0x42C00C64UL))
#define bFM_DMAC_DMACA5_IS3                   *((volatile unsigned char*)(0x42C00C68UL))
#define bFM_DMAC_DMACA5_IS4                   *((volatile unsigned char*)(0x42C00C6CUL))
#define bFM_DMAC_DMACA5_IS5                   *((volatile unsigned char*)(0x42C00C70UL))
#define bFM_DMAC_DMACA5_ST                    *((volatile unsigned char*)(0x42C00C74UL))
#define bFM_DMAC_DMACA5_PB                    *((volatile unsigned char*)(0x42C00C78UL))
#define bFM_DMAC_DMACA5_EB                    *((volatile unsigned char*)(0x42C00C7CUL))
#define bFM_DMAC_DMACB5_EM                    *((volatile unsigned char*)(0x42C00C80UL))
#define bFM_DMAC_DMACB5_SS0                   *((volatile unsigned char*)(0x42C00CC0UL))
#define bFM_DMAC_DMACB5_SS1                   *((volatile unsigned char*)(0x42C00CC4UL))
#define bFM_DMAC_DMACB5_SS2                   *((volatile unsigned char*)(0x42C00CC8UL))
#define bFM_DMAC_DMACB5_CI                    *((volatile unsigned char*)(0x42C00CCCUL))
#define bFM_DMAC_DMACB5_EI                    *((volatile unsigned char*)(0x42C00CD0UL))
#define bFM_DMAC_DMACB5_RD                    *((volatile unsigned char*)(0x42C00CD4UL))
#define bFM_DMAC_DMACB5_RS                    *((volatile unsigned char*)(0x42C00CD8UL))
#define bFM_DMAC_DMACB5_RC                    *((volatile unsigned char*)(0x42C00CDCUL))
#define bFM_DMAC_DMACB5_FD                    *((volatile unsigned char*)(0x42C00CE0UL))
#define bFM_DMAC_DMACB5_FS                    *((volatile unsigned char*)(0x42C00CE4UL))
#define bFM_DMAC_DMACB5_TW0                   *((volatile unsigned char*)(0x42C00CE8UL))
#define bFM_DMAC_DMACB5_TW1                   *((volatile unsigned char*)(0x42C00CECUL))
#define bFM_DMAC_DMACB5_MS0                   *((volatile unsigned char*)(0x42C00CF0UL))
#define bFM_DMAC_DMACB5_MS1                   *((volatile unsigned char*)(0x42C00CF4UL))
#define bFM_DMAC_DMACA6_TC0                   *((volatile unsigned char*)(0x42C00E00UL))
#define bFM_DMAC_DMACA6_TC1                   *((volatile unsigned char*)(0x42C00E04UL))
#define bFM_DMAC_DMACA6_TC2                   *((volatile unsigned char*)(0x42C00E08UL))
#define bFM_DMAC_DMACA6_TC3                   *((volatile unsigned char*)(0x42C00E0CUL))
#define bFM_DMAC_DMACA6_TC4                   *((volatile unsigned char*)(0x42C00E10UL))
#define bFM_DMAC_DMACA6_TC5                   *((volatile unsigned char*)(0x42C00E14UL))
#define bFM_DMAC_DMACA6_TC6                   *((volatile unsigned char*)(0x42C00E18UL))
#define bFM_DMAC_DMACA6_TC7                   *((volatile unsigned char*)(0x42C00E1CUL))
#define bFM_DMAC_DMACA6_TC8                   *((volatile unsigned char*)(0x42C00E20UL))
#define bFM_DMAC_DMACA6_TC9                   *((volatile unsigned char*)(0x42C00E24UL))
#define bFM_DMAC_DMACA6_TC10                  *((volatile unsigned char*)(0x42C00E28UL))
#define bFM_DMAC_DMACA6_TC11                  *((volatile unsigned char*)(0x42C00E2CUL))
#define bFM_DMAC_DMACA6_TC12                  *((volatile unsigned char*)(0x42C00E30UL))
#define bFM_DMAC_DMACA6_TC13                  *((volatile unsigned char*)(0x42C00E34UL))
#define bFM_DMAC_DMACA6_TC14                  *((volatile unsigned char*)(0x42C00E38UL))
#define bFM_DMAC_DMACA6_TC15                  *((volatile unsigned char*)(0x42C00E3CUL))
#define bFM_DMAC_DMACA6_BC0                   *((volatile unsigned char*)(0x42C00E40UL))
#define bFM_DMAC_DMACA6_BC1                   *((volatile unsigned char*)(0x42C00E44UL))
#define bFM_DMAC_DMACA6_BC2                   *((volatile unsigned char*)(0x42C00E48UL))
#define bFM_DMAC_DMACA6_BC3                   *((volatile unsigned char*)(0x42C00E4CUL))
#define bFM_DMAC_DMACA6_IS0                   *((volatile unsigned char*)(0x42C00E5CUL))
#define bFM_DMAC_DMACA6_IS1                   *((volatile unsigned char*)(0x42C00E60UL))
#define bFM_DMAC_DMACA6_IS2                   *((volatile unsigned char*)(0x42C00E64UL))
#define bFM_DMAC_DMACA6_IS3                   *((volatile unsigned char*)(0x42C00E68UL))
#define bFM_DMAC_DMACA6_IS4                   *((volatile unsigned char*)(0x42C00E6CUL))
#define bFM_DMAC_DMACA6_IS5                   *((volatile unsigned char*)(0x42C00E70UL))
#define bFM_DMAC_DMACA6_ST                    *((volatile unsigned char*)(0x42C00E74UL))
#define bFM_DMAC_DMACA6_PB                    *((volatile unsigned char*)(0x42C00E78UL))
#define bFM_DMAC_DMACA6_EB                    *((volatile unsigned char*)(0x42C00E7CUL))
#define bFM_DMAC_DMACB6_EM                    *((volatile unsigned char*)(0x42C00E80UL))
#define bFM_DMAC_DMACB6_SS0                   *((volatile unsigned char*)(0x42C00EC0UL))
#define bFM_DMAC_DMACB6_SS1                   *((volatile unsigned char*)(0x42C00EC4UL))
#define bFM_DMAC_DMACB6_SS2                   *((volatile unsigned char*)(0x42C00EC8UL))
#define bFM_DMAC_DMACB6_CI                    *((volatile unsigned char*)(0x42C00ECCUL))
#define bFM_DMAC_DMACB6_EI                    *((volatile unsigned char*)(0x42C00ED0UL))
#define bFM_DMAC_DMACB6_RD                    *((volatile unsigned char*)(0x42C00ED4UL))
#define bFM_DMAC_DMACB6_RS                    *((volatile unsigned char*)(0x42C00ED8UL))
#define bFM_DMAC_DMACB6_RC                    *((volatile unsigned char*)(0x42C00EDCUL))
#define bFM_DMAC_DMACB6_FD                    *((volatile unsigned char*)(0x42C00EE0UL))
#define bFM_DMAC_DMACB6_FS                    *((volatile unsigned char*)(0x42C00EE4UL))
#define bFM_DMAC_DMACB6_TW0                   *((volatile unsigned char*)(0x42C00EE8UL))
#define bFM_DMAC_DMACB6_TW1                   *((volatile unsigned char*)(0x42C00EECUL))
#define bFM_DMAC_DMACB6_MS0                   *((volatile unsigned char*)(0x42C00EF0UL))
#define bFM_DMAC_DMACB6_MS1                   *((volatile unsigned char*)(0x42C00EF4UL))
#define bFM_DMAC_DMACA7_TC0                   *((volatile unsigned char*)(0x42C01000UL))
#define bFM_DMAC_DMACA7_TC1                   *((volatile unsigned char*)(0x42C01004UL))
#define bFM_DMAC_DMACA7_TC2                   *((volatile unsigned char*)(0x42C01008UL))
#define bFM_DMAC_DMACA7_TC3                   *((volatile unsigned char*)(0x42C0100CUL))
#define bFM_DMAC_DMACA7_TC4                   *((volatile unsigned char*)(0x42C01010UL))
#define bFM_DMAC_DMACA7_TC5                   *((volatile unsigned char*)(0x42C01014UL))
#define bFM_DMAC_DMACA7_TC6                   *((volatile unsigned char*)(0x42C01018UL))
#define bFM_DMAC_DMACA7_TC7                   *((volatile unsigned char*)(0x42C0101CUL))
#define bFM_DMAC_DMACA7_TC8                   *((volatile unsigned char*)(0x42C01020UL))
#define bFM_DMAC_DMACA7_TC9                   *((volatile unsigned char*)(0x42C01024UL))
#define bFM_DMAC_DMACA7_TC10                  *((volatile unsigned char*)(0x42C01028UL))
#define bFM_DMAC_DMACA7_TC11                  *((volatile unsigned char*)(0x42C0102CUL))
#define bFM_DMAC_DMACA7_TC12                  *((volatile unsigned char*)(0x42C01030UL))
#define bFM_DMAC_DMACA7_TC13                  *((volatile unsigned char*)(0x42C01034UL))
#define bFM_DMAC_DMACA7_TC14                  *((volatile unsigned char*)(0x42C01038UL))
#define bFM_DMAC_DMACA7_TC15                  *((volatile unsigned char*)(0x42C0103CUL))
#define bFM_DMAC_DMACA7_BC0                   *((volatile unsigned char*)(0x42C01040UL))
#define bFM_DMAC_DMACA7_BC1                   *((volatile unsigned char*)(0x42C01044UL))
#define bFM_DMAC_DMACA7_BC2                   *((volatile unsigned char*)(0x42C01048UL))
#define bFM_DMAC_DMACA7_BC3                   *((volatile unsigned char*)(0x42C0104CUL))
#define bFM_DMAC_DMACA7_IS0                   *((volatile unsigned char*)(0x42C0105CUL))
#define bFM_DMAC_DMACA7_IS1                   *((volatile unsigned char*)(0x42C01060UL))
#define bFM_DMAC_DMACA7_IS2                   *((volatile unsigned char*)(0x42C01064UL))
#define bFM_DMAC_DMACA7_IS3                   *((volatile unsigned char*)(0x42C01068UL))
#define bFM_DMAC_DMACA7_IS4                   *((volatile unsigned char*)(0x42C0106CUL))
#define bFM_DMAC_DMACA7_IS5                   *((volatile unsigned char*)(0x42C01070UL))
#define bFM_DMAC_DMACA7_ST                    *((volatile unsigned char*)(0x42C01074UL))
#define bFM_DMAC_DMACA7_PB                    *((volatile unsigned char*)(0x42C01078UL))
#define bFM_DMAC_DMACA7_EB                    *((volatile unsigned char*)(0x42C0107CUL))
#define bFM_DMAC_DMACB7_EM                    *((volatile unsigned char*)(0x42C01080UL))
#define bFM_DMAC_DMACB7_SS0                   *((volatile unsigned char*)(0x42C010C0UL))
#define bFM_DMAC_DMACB7_SS1                   *((volatile unsigned char*)(0x42C010C4UL))
#define bFM_DMAC_DMACB7_SS2                   *((volatile unsigned char*)(0x42C010C8UL))
#define bFM_DMAC_DMACB7_CI                    *((volatile unsigned char*)(0x42C010CCUL))
#define bFM_DMAC_DMACB7_EI                    *((volatile unsigned char*)(0x42C010D0UL))
#define bFM_DMAC_DMACB7_RD                    *((volatile unsigned char*)(0x42C010D4UL))
#define bFM_DMAC_DMACB7_RS                    *((volatile unsigned char*)(0x42C010D8UL))
#define bFM_DMAC_DMACB7_RC                    *((volatile unsigned char*)(0x42C010DCUL))
#define bFM_DMAC_DMACB7_FD                    *((volatile unsigned char*)(0x42C010E0UL))
#define bFM_DMAC_DMACB7_FS                    *((volatile unsigned char*)(0x42C010E4UL))
#define bFM_DMAC_DMACB7_TW0                   *((volatile unsigned char*)(0x42C010E8UL))
#define bFM_DMAC_DMACB7_TW1                   *((volatile unsigned char*)(0x42C010ECUL))
#define bFM_DMAC_DMACB7_MS0                   *((volatile unsigned char*)(0x42C010F0UL))
#define bFM_DMAC_DMACB7_MS1                   *((volatile unsigned char*)(0x42C010F4UL))

/* CAN channel 0 registers */
#define bFM_CAN0_CTRLR_INIT                   *((volatile unsigned char*)(0x42C40000UL))
#define bFM_CAN0_CTRLR_IE                     *((volatile unsigned char*)(0x42C40004UL))
#define bFM_CAN0_CTRLR_SIE                    *((volatile unsigned char*)(0x42C40008UL))
#define bFM_CAN0_CTRLR_EIE                    *((volatile unsigned char*)(0x42C4000CUL))
#define bFM_CAN0_CTRLR_DAR                    *((volatile unsigned char*)(0x42C40014UL))
#define bFM_CAN0_CTRLR_CCE                    *((volatile unsigned char*)(0x42C40018UL))
#define bFM_CAN0_CTRLR_TEST                   *((volatile unsigned char*)(0x42C4001CUL))
#define bFM_CAN0_STATR_LEC0                   *((volatile unsigned char*)(0x42C40040UL))
#define bFM_CAN0_STATR_LEC1                   *((volatile unsigned char*)(0x42C40044UL))
#define bFM_CAN0_STATR_LEC2                   *((volatile unsigned char*)(0x42C40048UL))
#define bFM_CAN0_STATR_TXOK                   *((volatile unsigned char*)(0x42C4004CUL))
#define bFM_CAN0_STATR_RXOK                   *((volatile unsigned char*)(0x42C40050UL))
#define bFM_CAN0_STATR_EPASS                  *((volatile unsigned char*)(0x42C40054UL))
#define bFM_CAN0_STATR_EWARM                  *((volatile unsigned char*)(0x42C40058UL))
#define bFM_CAN0_STATR_BOFF                   *((volatile unsigned char*)(0x42C4005CUL))
#define bFM_CAN0_ERRCNT_TEC0                  *((volatile unsigned char*)(0x42C40080UL))
#define bFM_CAN0_ERRCNT_TEC1                  *((volatile unsigned char*)(0x42C40084UL))
#define bFM_CAN0_ERRCNT_TEC2                  *((volatile unsigned char*)(0x42C40088UL))
#define bFM_CAN0_ERRCNT_TEC3                  *((volatile unsigned char*)(0x42C4008CUL))
#define bFM_CAN0_ERRCNT_TEC4                  *((volatile unsigned char*)(0x42C40090UL))
#define bFM_CAN0_ERRCNT_TEC5                  *((volatile unsigned char*)(0x42C40094UL))
#define bFM_CAN0_ERRCNT_TEC6                  *((volatile unsigned char*)(0x42C40098UL))
#define bFM_CAN0_ERRCNT_TEC7                  *((volatile unsigned char*)(0x42C4009CUL))
#define bFM_CAN0_ERRCNT_REC0                  *((volatile unsigned char*)(0x42C400A0UL))
#define bFM_CAN0_ERRCNT_REC1                  *((volatile unsigned char*)(0x42C400A4UL))
#define bFM_CAN0_ERRCNT_REC2                  *((volatile unsigned char*)(0x42C400A8UL))
#define bFM_CAN0_ERRCNT_REC3                  *((volatile unsigned char*)(0x42C400ACUL))
#define bFM_CAN0_ERRCNT_REC4                  *((volatile unsigned char*)(0x42C400B0UL))
#define bFM_CAN0_ERRCNT_REC5                  *((volatile unsigned char*)(0x42C400B4UL))
#define bFM_CAN0_ERRCNT_REC6                  *((volatile unsigned char*)(0x42C400B8UL))
#define bFM_CAN0_ERRCNT_RP                    *((volatile unsigned char*)(0x42C400BCUL))
#define bFM_CAN0_BTR_BRP0                     *((volatile unsigned char*)(0x42C400C0UL))
#define bFM_CAN0_BTR_BRP1                     *((volatile unsigned char*)(0x42C400C4UL))
#define bFM_CAN0_BTR_BRP2                     *((volatile unsigned char*)(0x42C400C8UL))
#define bFM_CAN0_BTR_BRP3                     *((volatile unsigned char*)(0x42C400CCUL))
#define bFM_CAN0_BTR_BRP4                     *((volatile unsigned char*)(0x42C400D0UL))
#define bFM_CAN0_BTR_BRP5                     *((volatile unsigned char*)(0x42C400D4UL))
#define bFM_CAN0_BTR_SJW0                     *((volatile unsigned char*)(0x42C400D8UL))
#define bFM_CAN0_BTR_SJW1                     *((volatile unsigned char*)(0x42C400DCUL))
#define bFM_CAN0_BTR_TSEG10                   *((volatile unsigned char*)(0x42C400E0UL))
#define bFM_CAN0_BTR_TSEG11                   *((volatile unsigned char*)(0x42C400E4UL))
#define bFM_CAN0_BTR_TSEG12                   *((volatile unsigned char*)(0x42C400E8UL))
#define bFM_CAN0_BTR_TSEG13                   *((volatile unsigned char*)(0x42C400ECUL))
#define bFM_CAN0_BTR_TSEG20                   *((volatile unsigned char*)(0x42C400F0UL))
#define bFM_CAN0_BTR_TSEG21                   *((volatile unsigned char*)(0x42C400F4UL))
#define bFM_CAN0_BTR_TSEG22                   *((volatile unsigned char*)(0x42C400F8UL))
#define bFM_CAN0_INTR_INTID0                  *((volatile unsigned char*)(0x42C40100UL))
#define bFM_CAN0_INTR_INTID1                  *((volatile unsigned char*)(0x42C40104UL))
#define bFM_CAN0_INTR_INTID2                  *((volatile unsigned char*)(0x42C40108UL))
#define bFM_CAN0_INTR_INTID3                  *((volatile unsigned char*)(0x42C4010CUL))
#define bFM_CAN0_INTR_INTID4                  *((volatile unsigned char*)(0x42C40110UL))
#define bFM_CAN0_INTR_INTID5                  *((volatile unsigned char*)(0x42C40114UL))
#define bFM_CAN0_INTR_INTID6                  *((volatile unsigned char*)(0x42C40118UL))
#define bFM_CAN0_INTR_INTID7                  *((volatile unsigned char*)(0x42C4011CUL))
#define bFM_CAN0_INTR_INTID8                  *((volatile unsigned char*)(0x42C40120UL))
#define bFM_CAN0_INTR_INTID9                  *((volatile unsigned char*)(0x42C40124UL))
#define bFM_CAN0_INTR_INTID10                 *((volatile unsigned char*)(0x42C40128UL))
#define bFM_CAN0_INTR_INTID11                 *((volatile unsigned char*)(0x42C4012CUL))
#define bFM_CAN0_INTR_INTID12                 *((volatile unsigned char*)(0x42C40130UL))
#define bFM_CAN0_INTR_INTID13                 *((volatile unsigned char*)(0x42C40134UL))
#define bFM_CAN0_INTR_INTID14                 *((volatile unsigned char*)(0x42C40138UL))
#define bFM_CAN0_INTR_INTID15                 *((volatile unsigned char*)(0x42C4013CUL))
#define bFM_CAN0_TESTR_BASIC                  *((volatile unsigned char*)(0x42C40148UL))
#define bFM_CAN0_TESTR_SILENT                 *((volatile unsigned char*)(0x42C4014CUL))
#define bFM_CAN0_TESTR_LBACK                  *((volatile unsigned char*)(0x42C40150UL))
#define bFM_CAN0_TESTR_TX0                    *((volatile unsigned char*)(0x42C40154UL))
#define bFM_CAN0_TESTR_TX1                    *((volatile unsigned char*)(0x42C40158UL))
#define bFM_CAN0_TESTR_RX                     *((volatile unsigned char*)(0x42C4015CUL))
#define bFM_CAN0_BRPER_BRPE0                  *((volatile unsigned char*)(0x42C40180UL))
#define bFM_CAN0_BRPER_BRPE1                  *((volatile unsigned char*)(0x42C40184UL))
#define bFM_CAN0_BRPER_BRPE2                  *((volatile unsigned char*)(0x42C40188UL))
#define bFM_CAN0_BRPER_BRPE3                  *((volatile unsigned char*)(0x42C4018CUL))
#define bFM_CAN0_IF1CREQ_BUSY                 *((volatile unsigned char*)(0x42C4023CUL))
#define bFM_CAN0_IF1CMSK_DATAB                *((volatile unsigned char*)(0x42C40240UL))
#define bFM_CAN0_IF1CMSK_DATAA                *((volatile unsigned char*)(0x42C40244UL))
#define bFM_CAN0_IF1CMSK_TXREST               *((volatile unsigned char*)(0x42C40248UL))
#define bFM_CAN0_IF1CMSK_NEWDAT               *((volatile unsigned char*)(0x42C40248UL))
#define bFM_CAN0_IF1CMSK_CIP                  *((volatile unsigned char*)(0x42C4024CUL))
#define bFM_CAN0_IF1CMSK_CONTROL              *((volatile unsigned char*)(0x42C40250UL))
#define bFM_CAN0_IF1CMSK_ARB                  *((volatile unsigned char*)(0x42C40254UL))
#define bFM_CAN0_IF1CMSK_MASK                 *((volatile unsigned char*)(0x42C40258UL))
#define bFM_CAN0_IF1CMSK_WRRD                 *((volatile unsigned char*)(0x42C4025CUL))
#define bFM_CAN0_IF1MSK_MDIR                  *((volatile unsigned char*)(0x42C402F8UL))
#define bFM_CAN0_IF1MSK_MXTD                  *((volatile unsigned char*)(0x42C402FCUL))
#define bFM_CAN0_IF1MSK2_MDIR                 *((volatile unsigned char*)(0x42C402F8UL))
#define bFM_CAN0_IF1MSK2_MXTD                 *((volatile unsigned char*)(0x42C402FCUL))
#define bFM_CAN0_IF1ARB_DIR                   *((volatile unsigned char*)(0x42C40374UL))
#define bFM_CAN0_IF1ARB_XTD                   *((volatile unsigned char*)(0x42C40378UL))
#define bFM_CAN0_IF1ARB_MSGVAL                *((volatile unsigned char*)(0x42C4037CUL))
#define bFM_CAN0_IF1ARB2_DIR                  *((volatile unsigned char*)(0x42C40374UL))
#define bFM_CAN0_IF1ARB2_XTD                  *((volatile unsigned char*)(0x42C40378UL))
#define bFM_CAN0_IF1ARB2_MSGVAL               *((volatile unsigned char*)(0x42C4037CUL))
#define bFM_CAN0_IF1MCTR_DLC0                 *((volatile unsigned char*)(0x42C40380UL))
#define bFM_CAN0_IF1MCTR_DLC1                 *((volatile unsigned char*)(0x42C40384UL))
#define bFM_CAN0_IF1MCTR_DLC2                 *((volatile unsigned char*)(0x42C40388UL))
#define bFM_CAN0_IF1MCTR_DLC3                 *((volatile unsigned char*)(0x42C4038CUL))
#define bFM_CAN0_IF1MCTR_EOB                  *((volatile unsigned char*)(0x42C4039CUL))
#define bFM_CAN0_IF1MCTR_TXRQST               *((volatile unsigned char*)(0x42C403A0UL))
#define bFM_CAN0_IF1MCTR_RMTEN                *((volatile unsigned char*)(0x42C403A4UL))
#define bFM_CAN0_IF1MCTR_RXIE                 *((volatile unsigned char*)(0x42C403A8UL))
#define bFM_CAN0_IF1MCTR_TXIE                 *((volatile unsigned char*)(0x42C403ACUL))
#define bFM_CAN0_IF1MCTR_UMASK                *((volatile unsigned char*)(0x42C403B0UL))
#define bFM_CAN0_IF1MCTR_INTPND               *((volatile unsigned char*)(0x42C403B4UL))
#define bFM_CAN0_IF1MCTR_MSGLST               *((volatile unsigned char*)(0x42C403B8UL))
#define bFM_CAN0_IF1MCTR_NEWDAT               *((volatile unsigned char*)(0x42C403BCUL))
#define bFM_CAN0_IF2CREQ_BUSY                 *((volatile unsigned char*)(0x42C4083CUL))
#define bFM_CAN0_IF2CMSK_DATAB                *((volatile unsigned char*)(0x42C40840UL))
#define bFM_CAN0_IF2CMSK_DATAA                *((volatile unsigned char*)(0x42C40844UL))
#define bFM_CAN0_IF2CMSK_TXREST               *((volatile unsigned char*)(0x42C40848UL))
#define bFM_CAN0_IF2CMSK_NEWDAT               *((volatile unsigned char*)(0x42C40848UL))
#define bFM_CAN0_IF2CMSK_CIP                  *((volatile unsigned char*)(0x42C4084CUL))
#define bFM_CAN0_IF2CMSK_CONTROL              *((volatile unsigned char*)(0x42C40850UL))
#define bFM_CAN0_IF2CMSK_ARB                  *((volatile unsigned char*)(0x42C40854UL))
#define bFM_CAN0_IF2CMSK_MASK                 *((volatile unsigned char*)(0x42C40858UL))
#define bFM_CAN0_IF2CMSK_WRRD                 *((volatile unsigned char*)(0x42C4085CUL))
#define bFM_CAN0_IF2MSK_MDIR                  *((volatile unsigned char*)(0x42C408F8UL))
#define bFM_CAN0_IF2MSK_MXTD                  *((volatile unsigned char*)(0x42C408FCUL))
#define bFM_CAN0_IF2MSK2_MDIR                 *((volatile unsigned char*)(0x42C408F8UL))
#define bFM_CAN0_IF2MSK2_MXTD                 *((volatile unsigned char*)(0x42C408FCUL))
#define bFM_CAN0_IF2ARB_DIR                   *((volatile unsigned char*)(0x42C40974UL))
#define bFM_CAN0_IF2ARB_XTD                   *((volatile unsigned char*)(0x42C40978UL))
#define bFM_CAN0_IF2ARB_MSGVAL                *((volatile unsigned char*)(0x42C4097CUL))
#define bFM_CAN0_IF2ARB2_DIR                  *((volatile unsigned char*)(0x42C40974UL))
#define bFM_CAN0_IF2ARB2_XTD                  *((volatile unsigned char*)(0x42C40978UL))
#define bFM_CAN0_IF2ARB2_MSGVAL               *((volatile unsigned char*)(0x42C4097CUL))
#define bFM_CAN0_IF2MCTR_DLC0                 *((volatile unsigned char*)(0x42C40980UL))
#define bFM_CAN0_IF2MCTR_DLC1                 *((volatile unsigned char*)(0x42C40984UL))
#define bFM_CAN0_IF2MCTR_DLC2                 *((volatile unsigned char*)(0x42C40988UL))
#define bFM_CAN0_IF2MCTR_DLC3                 *((volatile unsigned char*)(0x42C4098CUL))
#define bFM_CAN0_IF2MCTR_EOB                  *((volatile unsigned char*)(0x42C4099CUL))
#define bFM_CAN0_IF2MCTR_TXRQST               *((volatile unsigned char*)(0x42C409A0UL))
#define bFM_CAN0_IF2MCTR_RMTEN                *((volatile unsigned char*)(0x42C409A4UL))
#define bFM_CAN0_IF2MCTR_RXIE                 *((volatile unsigned char*)(0x42C409A8UL))
#define bFM_CAN0_IF2MCTR_TXIE                 *((volatile unsigned char*)(0x42C409ACUL))
#define bFM_CAN0_IF2MCTR_UMASK                *((volatile unsigned char*)(0x42C409B0UL))
#define bFM_CAN0_IF2MCTR_INTPND               *((volatile unsigned char*)(0x42C409B4UL))
#define bFM_CAN0_IF2MCTR_MSGLST               *((volatile unsigned char*)(0x42C409B8UL))
#define bFM_CAN0_IF2MCTR_NEWDAT               *((volatile unsigned char*)(0x42C409BCUL))
#define bFM_CAN0_TREQR_TXRQST1                *((volatile unsigned char*)(0x42C41000UL))
#define bFM_CAN0_TREQR_TXRQST2                *((volatile unsigned char*)(0x42C41004UL))
#define bFM_CAN0_TREQR_TXRQST3                *((volatile unsigned char*)(0x42C41008UL))
#define bFM_CAN0_TREQR_TXRQST4                *((volatile unsigned char*)(0x42C4100CUL))
#define bFM_CAN0_TREQR_TXRQST5                *((volatile unsigned char*)(0x42C41010UL))
#define bFM_CAN0_TREQR_TXRQST6                *((volatile unsigned char*)(0x42C41014UL))
#define bFM_CAN0_TREQR_TXRQST7                *((volatile unsigned char*)(0x42C41018UL))
#define bFM_CAN0_TREQR_TXRQST8                *((volatile unsigned char*)(0x42C4101CUL))
#define bFM_CAN0_TREQR_TXRQST9                *((volatile unsigned char*)(0x42C41020UL))
#define bFM_CAN0_TREQR_TXRQST10               *((volatile unsigned char*)(0x42C41024UL))
#define bFM_CAN0_TREQR_TXRQST11               *((volatile unsigned char*)(0x42C41028UL))
#define bFM_CAN0_TREQR_TXRQST12               *((volatile unsigned char*)(0x42C4102CUL))
#define bFM_CAN0_TREQR_TXRQST13               *((volatile unsigned char*)(0x42C41030UL))
#define bFM_CAN0_TREQR_TXRQST14               *((volatile unsigned char*)(0x42C41034UL))
#define bFM_CAN0_TREQR_TXRQST15               *((volatile unsigned char*)(0x42C41038UL))
#define bFM_CAN0_TREQR_TXRQST16               *((volatile unsigned char*)(0x42C4103CUL))
#define bFM_CAN0_TREQR_TXRQST17               *((volatile unsigned char*)(0x42C41040UL))
#define bFM_CAN0_TREQR_TXRQST18               *((volatile unsigned char*)(0x42C41044UL))
#define bFM_CAN0_TREQR_TXRQST19               *((volatile unsigned char*)(0x42C41048UL))
#define bFM_CAN0_TREQR_TXRQST20               *((volatile unsigned char*)(0x42C4104CUL))
#define bFM_CAN0_TREQR_TXRQST21               *((volatile unsigned char*)(0x42C41050UL))
#define bFM_CAN0_TREQR_TXRQST22               *((volatile unsigned char*)(0x42C41054UL))
#define bFM_CAN0_TREQR_TXRQST23               *((volatile unsigned char*)(0x42C41058UL))
#define bFM_CAN0_TREQR_TXRQST24               *((volatile unsigned char*)(0x42C4105CUL))
#define bFM_CAN0_TREQR_TXRQST25               *((volatile unsigned char*)(0x42C41060UL))
#define bFM_CAN0_TREQR_TXRQST26               *((volatile unsigned char*)(0x42C41064UL))
#define bFM_CAN0_TREQR_TXRQST27               *((volatile unsigned char*)(0x42C41068UL))
#define bFM_CAN0_TREQR_TXRQST28               *((volatile unsigned char*)(0x42C4106CUL))
#define bFM_CAN0_TREQR_TXRQST29               *((volatile unsigned char*)(0x42C41070UL))
#define bFM_CAN0_TREQR_TXRQST30               *((volatile unsigned char*)(0x42C41074UL))
#define bFM_CAN0_TREQR_TXRQST31               *((volatile unsigned char*)(0x42C41078UL))
#define bFM_CAN0_TREQR_TXRQST32               *((volatile unsigned char*)(0x42C4107CUL))
#define bFM_CAN0_TREQR1_TXRQST1               *((volatile unsigned char*)(0x42C41000UL))
#define bFM_CAN0_TREQR1_TXRQST2               *((volatile unsigned char*)(0x42C41004UL))
#define bFM_CAN0_TREQR1_TXRQST3               *((volatile unsigned char*)(0x42C41008UL))
#define bFM_CAN0_TREQR1_TXRQST4               *((volatile unsigned char*)(0x42C4100CUL))
#define bFM_CAN0_TREQR1_TXRQST5               *((volatile unsigned char*)(0x42C41010UL))
#define bFM_CAN0_TREQR1_TXRQST6               *((volatile unsigned char*)(0x42C41014UL))
#define bFM_CAN0_TREQR1_TXRQST7               *((volatile unsigned char*)(0x42C41018UL))
#define bFM_CAN0_TREQR1_TXRQST8               *((volatile unsigned char*)(0x42C4101CUL))
#define bFM_CAN0_TREQR1_TXRQST9               *((volatile unsigned char*)(0x42C41020UL))
#define bFM_CAN0_TREQR1_TXRQST10              *((volatile unsigned char*)(0x42C41024UL))
#define bFM_CAN0_TREQR1_TXRQST11              *((volatile unsigned char*)(0x42C41028UL))
#define bFM_CAN0_TREQR1_TXRQST12              *((volatile unsigned char*)(0x42C4102CUL))
#define bFM_CAN0_TREQR1_TXRQST13              *((volatile unsigned char*)(0x42C41030UL))
#define bFM_CAN0_TREQR1_TXRQST14              *((volatile unsigned char*)(0x42C41034UL))
#define bFM_CAN0_TREQR1_TXRQST15              *((volatile unsigned char*)(0x42C41038UL))
#define bFM_CAN0_TREQR1_TXRQST16              *((volatile unsigned char*)(0x42C4103CUL))
#define bFM_CAN0_TREQR2_TXRQST17              *((volatile unsigned char*)(0x42C41040UL))
#define bFM_CAN0_TREQR2_TXRQST18              *((volatile unsigned char*)(0x42C41044UL))
#define bFM_CAN0_TREQR2_TXRQST19              *((volatile unsigned char*)(0x42C41048UL))
#define bFM_CAN0_TREQR2_TXRQST20              *((volatile unsigned char*)(0x42C4104CUL))
#define bFM_CAN0_TREQR2_TXRQST21              *((volatile unsigned char*)(0x42C41050UL))
#define bFM_CAN0_TREQR2_TXRQST22              *((volatile unsigned char*)(0x42C41054UL))
#define bFM_CAN0_TREQR2_TXRQST23              *((volatile unsigned char*)(0x42C41058UL))
#define bFM_CAN0_TREQR2_TXRQST24              *((volatile unsigned char*)(0x42C4105CUL))
#define bFM_CAN0_TREQR2_TXRQST25              *((volatile unsigned char*)(0x42C41060UL))
#define bFM_CAN0_TREQR2_TXRQST26              *((volatile unsigned char*)(0x42C41064UL))
#define bFM_CAN0_TREQR2_TXRQST27              *((volatile unsigned char*)(0x42C41068UL))
#define bFM_CAN0_TREQR2_TXRQST28              *((volatile unsigned char*)(0x42C4106CUL))
#define bFM_CAN0_TREQR2_TXRQST29              *((volatile unsigned char*)(0x42C41070UL))
#define bFM_CAN0_TREQR2_TXRQST30              *((volatile unsigned char*)(0x42C41074UL))
#define bFM_CAN0_TREQR2_TXRQST31              *((volatile unsigned char*)(0x42C41078UL))
#define bFM_CAN0_TREQR2_TXRQST32              *((volatile unsigned char*)(0x42C4107CUL))
#define bFM_CAN0_NEWDT_NEWDAT1                *((volatile unsigned char*)(0x42C41200UL))
#define bFM_CAN0_NEWDT_NEWDAT2                *((volatile unsigned char*)(0x42C41204UL))
#define bFM_CAN0_NEWDT_NEWDAT3                *((volatile unsigned char*)(0x42C41208UL))
#define bFM_CAN0_NEWDT_NEWDAT4                *((volatile unsigned char*)(0x42C4120CUL))
#define bFM_CAN0_NEWDT_NEWDAT5                *((volatile unsigned char*)(0x42C41210UL))
#define bFM_CAN0_NEWDT_NEWDAT6                *((volatile unsigned char*)(0x42C41214UL))
#define bFM_CAN0_NEWDT_NEWDAT7                *((volatile unsigned char*)(0x42C41218UL))
#define bFM_CAN0_NEWDT_NEWDAT8                *((volatile unsigned char*)(0x42C4121CUL))
#define bFM_CAN0_NEWDT_NEWDAT9                *((volatile unsigned char*)(0x42C41220UL))
#define bFM_CAN0_NEWDT_NEWDAT10               *((volatile unsigned char*)(0x42C41224UL))
#define bFM_CAN0_NEWDT_NEWDAT11               *((volatile unsigned char*)(0x42C41228UL))
#define bFM_CAN0_NEWDT_NEWDAT12               *((volatile unsigned char*)(0x42C4122CUL))
#define bFM_CAN0_NEWDT_NEWDAT13               *((volatile unsigned char*)(0x42C41230UL))
#define bFM_CAN0_NEWDT_NEWDAT14               *((volatile unsigned char*)(0x42C41234UL))
#define bFM_CAN0_NEWDT_NEWDAT15               *((volatile unsigned char*)(0x42C41238UL))
#define bFM_CAN0_NEWDT_NEWDAT16               *((volatile unsigned char*)(0x42C4123CUL))
#define bFM_CAN0_NEWDT_NEWDAT17               *((volatile unsigned char*)(0x42C41240UL))
#define bFM_CAN0_NEWDT_NEWDAT18               *((volatile unsigned char*)(0x42C41244UL))
#define bFM_CAN0_NEWDT_NEWDAT19               *((volatile unsigned char*)(0x42C41248UL))
#define bFM_CAN0_NEWDT_NEWDAT20               *((volatile unsigned char*)(0x42C4124CUL))
#define bFM_CAN0_NEWDT_NEWDAT21               *((volatile unsigned char*)(0x42C41250UL))
#define bFM_CAN0_NEWDT_NEWDAT22               *((volatile unsigned char*)(0x42C41254UL))
#define bFM_CAN0_NEWDT_NEWDAT23               *((volatile unsigned char*)(0x42C41258UL))
#define bFM_CAN0_NEWDT_NEWDAT24               *((volatile unsigned char*)(0x42C4125CUL))
#define bFM_CAN0_NEWDT_NEWDAT25               *((volatile unsigned char*)(0x42C41260UL))
#define bFM_CAN0_NEWDT_NEWDAT26               *((volatile unsigned char*)(0x42C41264UL))
#define bFM_CAN0_NEWDT_NEWDAT27               *((volatile unsigned char*)(0x42C41268UL))
#define bFM_CAN0_NEWDT_NEWDAT28               *((volatile unsigned char*)(0x42C4126CUL))
#define bFM_CAN0_NEWDT_NEWDAT29               *((volatile unsigned char*)(0x42C41270UL))
#define bFM_CAN0_NEWDT_NEWDAT30               *((volatile unsigned char*)(0x42C41274UL))
#define bFM_CAN0_NEWDT_NEWDAT31               *((volatile unsigned char*)(0x42C41278UL))
#define bFM_CAN0_NEWDT_NEWDAT32               *((volatile unsigned char*)(0x42C4127CUL))
#define bFM_CAN0_NEWDT1_NEWDAT1               *((volatile unsigned char*)(0x42C41200UL))
#define bFM_CAN0_NEWDT1_NEWDAT2               *((volatile unsigned char*)(0x42C41204UL))
#define bFM_CAN0_NEWDT1_NEWDAT3               *((volatile unsigned char*)(0x42C41208UL))
#define bFM_CAN0_NEWDT1_NEWDAT4               *((volatile unsigned char*)(0x42C4120CUL))
#define bFM_CAN0_NEWDT1_NEWDAT5               *((volatile unsigned char*)(0x42C41210UL))
#define bFM_CAN0_NEWDT1_NEWDAT6               *((volatile unsigned char*)(0x42C41214UL))
#define bFM_CAN0_NEWDT1_NEWDAT7               *((volatile unsigned char*)(0x42C41218UL))
#define bFM_CAN0_NEWDT1_NEWDAT8               *((volatile unsigned char*)(0x42C4121CUL))
#define bFM_CAN0_NEWDT1_NEWDAT9               *((volatile unsigned char*)(0x42C41220UL))
#define bFM_CAN0_NEWDT1_NEWDAT10              *((volatile unsigned char*)(0x42C41224UL))
#define bFM_CAN0_NEWDT1_NEWDAT11              *((volatile unsigned char*)(0x42C41228UL))
#define bFM_CAN0_NEWDT1_NEWDAT12              *((volatile unsigned char*)(0x42C4122CUL))
#define bFM_CAN0_NEWDT1_NEWDAT13              *((volatile unsigned char*)(0x42C41230UL))
#define bFM_CAN0_NEWDT1_NEWDAT14              *((volatile unsigned char*)(0x42C41234UL))
#define bFM_CAN0_NEWDT1_NEWDAT15              *((volatile unsigned char*)(0x42C41238UL))
#define bFM_CAN0_NEWDT1_NEWDAT16              *((volatile unsigned char*)(0x42C4123CUL))
#define bFM_CAN0_NEWDT2_NEWDAT17              *((volatile unsigned char*)(0x42C41240UL))
#define bFM_CAN0_NEWDT2_NEWDAT18              *((volatile unsigned char*)(0x42C41244UL))
#define bFM_CAN0_NEWDT2_NEWDAT19              *((volatile unsigned char*)(0x42C41248UL))
#define bFM_CAN0_NEWDT2_NEWDAT20              *((volatile unsigned char*)(0x42C4124CUL))
#define bFM_CAN0_NEWDT2_NEWDAT21              *((volatile unsigned char*)(0x42C41250UL))
#define bFM_CAN0_NEWDT2_NEWDAT22              *((volatile unsigned char*)(0x42C41254UL))
#define bFM_CAN0_NEWDT2_NEWDAT23              *((volatile unsigned char*)(0x42C41258UL))
#define bFM_CAN0_NEWDT2_NEWDAT24              *((volatile unsigned char*)(0x42C4125CUL))
#define bFM_CAN0_NEWDT2_NEWDAT25              *((volatile unsigned char*)(0x42C41260UL))
#define bFM_CAN0_NEWDT2_NEWDAT26              *((volatile unsigned char*)(0x42C41264UL))
#define bFM_CAN0_NEWDT2_NEWDAT27              *((volatile unsigned char*)(0x42C41268UL))
#define bFM_CAN0_NEWDT2_NEWDAT28              *((volatile unsigned char*)(0x42C4126CUL))
#define bFM_CAN0_NEWDT2_NEWDAT29              *((volatile unsigned char*)(0x42C41270UL))
#define bFM_CAN0_NEWDT2_NEWDAT30              *((volatile unsigned char*)(0x42C41274UL))
#define bFM_CAN0_NEWDT2_NEWDAT31              *((volatile unsigned char*)(0x42C41278UL))
#define bFM_CAN0_NEWDT2_NEWDAT32              *((volatile unsigned char*)(0x42C4127CUL))
#define bFM_CAN0_INTPND_INTPND1               *((volatile unsigned char*)(0x42C41400UL))
#define bFM_CAN0_INTPND_INTPND2               *((volatile unsigned char*)(0x42C41404UL))
#define bFM_CAN0_INTPND_INTPND3               *((volatile unsigned char*)(0x42C41408UL))
#define bFM_CAN0_INTPND_INTPND4               *((volatile unsigned char*)(0x42C4140CUL))
#define bFM_CAN0_INTPND_INTPND5               *((volatile unsigned char*)(0x42C41410UL))
#define bFM_CAN0_INTPND_INTPND6               *((volatile unsigned char*)(0x42C41414UL))
#define bFM_CAN0_INTPND_INTPND7               *((volatile unsigned char*)(0x42C41418UL))
#define bFM_CAN0_INTPND_INTPND8               *((volatile unsigned char*)(0x42C4141CUL))
#define bFM_CAN0_INTPND_INTPND9               *((volatile unsigned char*)(0x42C41420UL))
#define bFM_CAN0_INTPND_INTPND10              *((volatile unsigned char*)(0x42C41424UL))
#define bFM_CAN0_INTPND_INTPND11              *((volatile unsigned char*)(0x42C41428UL))
#define bFM_CAN0_INTPND_INTPND12              *((volatile unsigned char*)(0x42C4142CUL))
#define bFM_CAN0_INTPND_INTPND13              *((volatile unsigned char*)(0x42C41430UL))
#define bFM_CAN0_INTPND_INTPND14              *((volatile unsigned char*)(0x42C41434UL))
#define bFM_CAN0_INTPND_INTPND15              *((volatile unsigned char*)(0x42C41438UL))
#define bFM_CAN0_INTPND_INTPND16              *((volatile unsigned char*)(0x42C4143CUL))
#define bFM_CAN0_INTPND_INTPND17              *((volatile unsigned char*)(0x42C41440UL))
#define bFM_CAN0_INTPND_INTPND18              *((volatile unsigned char*)(0x42C41444UL))
#define bFM_CAN0_INTPND_INTPND19              *((volatile unsigned char*)(0x42C41448UL))
#define bFM_CAN0_INTPND_INTPND20              *((volatile unsigned char*)(0x42C4144CUL))
#define bFM_CAN0_INTPND_INTPND21              *((volatile unsigned char*)(0x42C41450UL))
#define bFM_CAN0_INTPND_INTPND22              *((volatile unsigned char*)(0x42C41454UL))
#define bFM_CAN0_INTPND_INTPND23              *((volatile unsigned char*)(0x42C41458UL))
#define bFM_CAN0_INTPND_INTPND24              *((volatile unsigned char*)(0x42C4145CUL))
#define bFM_CAN0_INTPND_INTPND25              *((volatile unsigned char*)(0x42C41460UL))
#define bFM_CAN0_INTPND_INTPND26              *((volatile unsigned char*)(0x42C41464UL))
#define bFM_CAN0_INTPND_INTPND27              *((volatile unsigned char*)(0x42C41468UL))
#define bFM_CAN0_INTPND_INTPND28              *((volatile unsigned char*)(0x42C4146CUL))
#define bFM_CAN0_INTPND_INTPND29              *((volatile unsigned char*)(0x42C41470UL))
#define bFM_CAN0_INTPND_INTPND30              *((volatile unsigned char*)(0x42C41474UL))
#define bFM_CAN0_INTPND_INTPND31              *((volatile unsigned char*)(0x42C41478UL))
#define bFM_CAN0_INTPND_INTPND32              *((volatile unsigned char*)(0x42C4147CUL))
#define bFM_CAN0_INTPND1_INTPND1              *((volatile unsigned char*)(0x42C41400UL))
#define bFM_CAN0_INTPND1_INTPND2              *((volatile unsigned char*)(0x42C41404UL))
#define bFM_CAN0_INTPND1_INTPND3              *((volatile unsigned char*)(0x42C41408UL))
#define bFM_CAN0_INTPND1_INTPND4              *((volatile unsigned char*)(0x42C4140CUL))
#define bFM_CAN0_INTPND1_INTPND5              *((volatile unsigned char*)(0x42C41410UL))
#define bFM_CAN0_INTPND1_INTPND6              *((volatile unsigned char*)(0x42C41414UL))
#define bFM_CAN0_INTPND1_INTPND7              *((volatile unsigned char*)(0x42C41418UL))
#define bFM_CAN0_INTPND1_INTPND8              *((volatile unsigned char*)(0x42C4141CUL))
#define bFM_CAN0_INTPND1_INTPND9              *((volatile unsigned char*)(0x42C41420UL))
#define bFM_CAN0_INTPND1_INTPND10             *((volatile unsigned char*)(0x42C41424UL))
#define bFM_CAN0_INTPND1_INTPND11             *((volatile unsigned char*)(0x42C41428UL))
#define bFM_CAN0_INTPND1_INTPND12             *((volatile unsigned char*)(0x42C4142CUL))
#define bFM_CAN0_INTPND1_INTPND13             *((volatile unsigned char*)(0x42C41430UL))
#define bFM_CAN0_INTPND1_INTPND14             *((volatile unsigned char*)(0x42C41434UL))
#define bFM_CAN0_INTPND1_INTPND15             *((volatile unsigned char*)(0x42C41438UL))
#define bFM_CAN0_INTPND1_INTPND16             *((volatile unsigned char*)(0x42C4143CUL))
#define bFM_CAN0_INTPND2_INTPND17             *((volatile unsigned char*)(0x42C41440UL))
#define bFM_CAN0_INTPND2_INTPND18             *((volatile unsigned char*)(0x42C41444UL))
#define bFM_CAN0_INTPND2_INTPND19             *((volatile unsigned char*)(0x42C41448UL))
#define bFM_CAN0_INTPND2_INTPND20             *((volatile unsigned char*)(0x42C4144CUL))
#define bFM_CAN0_INTPND2_INTPND21             *((volatile unsigned char*)(0x42C41450UL))
#define bFM_CAN0_INTPND2_INTPND22             *((volatile unsigned char*)(0x42C41454UL))
#define bFM_CAN0_INTPND2_INTPND23             *((volatile unsigned char*)(0x42C41458UL))
#define bFM_CAN0_INTPND2_INTPND24             *((volatile unsigned char*)(0x42C4145CUL))
#define bFM_CAN0_INTPND2_INTPND25             *((volatile unsigned char*)(0x42C41460UL))
#define bFM_CAN0_INTPND2_INTPND26             *((volatile unsigned char*)(0x42C41464UL))
#define bFM_CAN0_INTPND2_INTPND27             *((volatile unsigned char*)(0x42C41468UL))
#define bFM_CAN0_INTPND2_INTPND28             *((volatile unsigned char*)(0x42C4146CUL))
#define bFM_CAN0_INTPND2_INTPND29             *((volatile unsigned char*)(0x42C41470UL))
#define bFM_CAN0_INTPND2_INTPND30             *((volatile unsigned char*)(0x42C41474UL))
#define bFM_CAN0_INTPND2_INTPND31             *((volatile unsigned char*)(0x42C41478UL))
#define bFM_CAN0_INTPND2_INTPND32             *((volatile unsigned char*)(0x42C4147CUL))
#define bFM_CAN0_MSGVAL_MSGVAL1               *((volatile unsigned char*)(0x42C41600UL))
#define bFM_CAN0_MSGVAL_MSGVAL2               *((volatile unsigned char*)(0x42C41604UL))
#define bFM_CAN0_MSGVAL_MSGVAL3               *((volatile unsigned char*)(0x42C41608UL))
#define bFM_CAN0_MSGVAL_MSGVAL4               *((volatile unsigned char*)(0x42C4160CUL))
#define bFM_CAN0_MSGVAL_MSGVAL5               *((volatile unsigned char*)(0x42C41610UL))
#define bFM_CAN0_MSGVAL_MSGVAL6               *((volatile unsigned char*)(0x42C41614UL))
#define bFM_CAN0_MSGVAL_MSGVAL7               *((volatile unsigned char*)(0x42C41618UL))
#define bFM_CAN0_MSGVAL_MSGVAL8               *((volatile unsigned char*)(0x42C4161CUL))
#define bFM_CAN0_MSGVAL_MSGVAL9               *((volatile unsigned char*)(0x42C41620UL))
#define bFM_CAN0_MSGVAL_MSGVAL10              *((volatile unsigned char*)(0x42C41624UL))
#define bFM_CAN0_MSGVAL_MSGVAL11              *((volatile unsigned char*)(0x42C41628UL))
#define bFM_CAN0_MSGVAL_MSGVAL12              *((volatile unsigned char*)(0x42C4162CUL))
#define bFM_CAN0_MSGVAL_MSGVAL13              *((volatile unsigned char*)(0x42C41630UL))
#define bFM_CAN0_MSGVAL_MSGVAL14              *((volatile unsigned char*)(0x42C41634UL))
#define bFM_CAN0_MSGVAL_MSGVAL15              *((volatile unsigned char*)(0x42C41638UL))
#define bFM_CAN0_MSGVAL_MSGVAL16              *((volatile unsigned char*)(0x42C4163CUL))
#define bFM_CAN0_MSGVAL_MSGVAL17              *((volatile unsigned char*)(0x42C41640UL))
#define bFM_CAN0_MSGVAL_MSGVAL18              *((volatile unsigned char*)(0x42C41644UL))
#define bFM_CAN0_MSGVAL_MSGVAL19              *((volatile unsigned char*)(0x42C41648UL))
#define bFM_CAN0_MSGVAL_MSGVAL20              *((volatile unsigned char*)(0x42C4164CUL))
#define bFM_CAN0_MSGVAL_MSGVAL21              *((volatile unsigned char*)(0x42C41650UL))
#define bFM_CAN0_MSGVAL_MSGVAL22              *((volatile unsigned char*)(0x42C41654UL))
#define bFM_CAN0_MSGVAL_MSGVAL23              *((volatile unsigned char*)(0x42C41658UL))
#define bFM_CAN0_MSGVAL_MSGVAL24              *((volatile unsigned char*)(0x42C4165CUL))
#define bFM_CAN0_MSGVAL_MSGVAL25              *((volatile unsigned char*)(0x42C41660UL))
#define bFM_CAN0_MSGVAL_MSGVAL26              *((volatile unsigned char*)(0x42C41664UL))
#define bFM_CAN0_MSGVAL_MSGVAL27              *((volatile unsigned char*)(0x42C41668UL))
#define bFM_CAN0_MSGVAL_MSGVAL28              *((volatile unsigned char*)(0x42C4166CUL))
#define bFM_CAN0_MSGVAL_MSGVAL29              *((volatile unsigned char*)(0x42C41670UL))
#define bFM_CAN0_MSGVAL_MSGVAL30              *((volatile unsigned char*)(0x42C41674UL))
#define bFM_CAN0_MSGVAL_MSGVAL31              *((volatile unsigned char*)(0x42C41678UL))
#define bFM_CAN0_MSGVAL_MSGVAL32              *((volatile unsigned char*)(0x42C4167CUL))
#define bFM_CAN0_MSGVAL1_MSGVAL1              *((volatile unsigned char*)(0x42C41600UL))
#define bFM_CAN0_MSGVAL1_MSGVAL2              *((volatile unsigned char*)(0x42C41604UL))
#define bFM_CAN0_MSGVAL1_MSGVAL3              *((volatile unsigned char*)(0x42C41608UL))
#define bFM_CAN0_MSGVAL1_MSGVAL4              *((volatile unsigned char*)(0x42C4160CUL))
#define bFM_CAN0_MSGVAL1_MSGVAL5              *((volatile unsigned char*)(0x42C41610UL))
#define bFM_CAN0_MSGVAL1_MSGVAL6              *((volatile unsigned char*)(0x42C41614UL))
#define bFM_CAN0_MSGVAL1_MSGVAL7              *((volatile unsigned char*)(0x42C41618UL))
#define bFM_CAN0_MSGVAL1_MSGVAL8              *((volatile unsigned char*)(0x42C4161CUL))
#define bFM_CAN0_MSGVAL1_MSGVAL9              *((volatile unsigned char*)(0x42C41620UL))
#define bFM_CAN0_MSGVAL1_MSGVAL10             *((volatile unsigned char*)(0x42C41624UL))
#define bFM_CAN0_MSGVAL1_MSGVAL11             *((volatile unsigned char*)(0x42C41628UL))
#define bFM_CAN0_MSGVAL1_MSGVAL12             *((volatile unsigned char*)(0x42C4162CUL))
#define bFM_CAN0_MSGVAL1_MSGVAL13             *((volatile unsigned char*)(0x42C41630UL))
#define bFM_CAN0_MSGVAL1_MSGVAL14             *((volatile unsigned char*)(0x42C41634UL))
#define bFM_CAN0_MSGVAL1_MSGVAL15             *((volatile unsigned char*)(0x42C41638UL))
#define bFM_CAN0_MSGVAL1_MSGVAL16             *((volatile unsigned char*)(0x42C4163CUL))
#define bFM_CAN0_MSGVAL2_MSGVAL17             *((volatile unsigned char*)(0x42C41640UL))
#define bFM_CAN0_MSGVAL2_MSGVAL18             *((volatile unsigned char*)(0x42C41644UL))
#define bFM_CAN0_MSGVAL2_MSGVAL19             *((volatile unsigned char*)(0x42C41648UL))
#define bFM_CAN0_MSGVAL2_MSGVAL20             *((volatile unsigned char*)(0x42C4164CUL))
#define bFM_CAN0_MSGVAL2_MSGVAL21             *((volatile unsigned char*)(0x42C41650UL))
#define bFM_CAN0_MSGVAL2_MSGVAL22             *((volatile unsigned char*)(0x42C41654UL))
#define bFM_CAN0_MSGVAL2_MSGVAL23             *((volatile unsigned char*)(0x42C41658UL))
#define bFM_CAN0_MSGVAL2_MSGVAL24             *((volatile unsigned char*)(0x42C4165CUL))
#define bFM_CAN0_MSGVAL2_MSGVAL25             *((volatile unsigned char*)(0x42C41660UL))
#define bFM_CAN0_MSGVAL2_MSGVAL26             *((volatile unsigned char*)(0x42C41664UL))
#define bFM_CAN0_MSGVAL2_MSGVAL27             *((volatile unsigned char*)(0x42C41668UL))
#define bFM_CAN0_MSGVAL2_MSGVAL28             *((volatile unsigned char*)(0x42C4166CUL))
#define bFM_CAN0_MSGVAL2_MSGVAL29             *((volatile unsigned char*)(0x42C41670UL))
#define bFM_CAN0_MSGVAL2_MSGVAL30             *((volatile unsigned char*)(0x42C41674UL))
#define bFM_CAN0_MSGVAL2_MSGVAL31             *((volatile unsigned char*)(0x42C41678UL))
#define bFM_CAN0_MSGVAL2_MSGVAL32             *((volatile unsigned char*)(0x42C4167CUL))

/* CAN channel 1 registers */
#define bFM_CAN1_CTRLR_INIT                   *((volatile unsigned char*)(0x42C60000UL))
#define bFM_CAN1_CTRLR_IE                     *((volatile unsigned char*)(0x42C60004UL))
#define bFM_CAN1_CTRLR_SIE                    *((volatile unsigned char*)(0x42C60008UL))
#define bFM_CAN1_CTRLR_EIE                    *((volatile unsigned char*)(0x42C6000CUL))
#define bFM_CAN1_CTRLR_DAR                    *((volatile unsigned char*)(0x42C60014UL))
#define bFM_CAN1_CTRLR_CCE                    *((volatile unsigned char*)(0x42C60018UL))
#define bFM_CAN1_CTRLR_TEST                   *((volatile unsigned char*)(0x42C6001CUL))
#define bFM_CAN1_STATR_LEC0                   *((volatile unsigned char*)(0x42C60040UL))
#define bFM_CAN1_STATR_LEC1                   *((volatile unsigned char*)(0x42C60044UL))
#define bFM_CAN1_STATR_LEC2                   *((volatile unsigned char*)(0x42C60048UL))
#define bFM_CAN1_STATR_TXOK                   *((volatile unsigned char*)(0x42C6004CUL))
#define bFM_CAN1_STATR_RXOK                   *((volatile unsigned char*)(0x42C60050UL))
#define bFM_CAN1_STATR_EPASS                  *((volatile unsigned char*)(0x42C60054UL))
#define bFM_CAN1_STATR_EWARM                  *((volatile unsigned char*)(0x42C60058UL))
#define bFM_CAN1_STATR_BOFF                   *((volatile unsigned char*)(0x42C6005CUL))
#define bFM_CAN1_ERRCNT_TEC0                  *((volatile unsigned char*)(0x42C60080UL))
#define bFM_CAN1_ERRCNT_TEC1                  *((volatile unsigned char*)(0x42C60084UL))
#define bFM_CAN1_ERRCNT_TEC2                  *((volatile unsigned char*)(0x42C60088UL))
#define bFM_CAN1_ERRCNT_TEC3                  *((volatile unsigned char*)(0x42C6008CUL))
#define bFM_CAN1_ERRCNT_TEC4                  *((volatile unsigned char*)(0x42C60090UL))
#define bFM_CAN1_ERRCNT_TEC5                  *((volatile unsigned char*)(0x42C60094UL))
#define bFM_CAN1_ERRCNT_TEC6                  *((volatile unsigned char*)(0x42C60098UL))
#define bFM_CAN1_ERRCNT_TEC7                  *((volatile unsigned char*)(0x42C6009CUL))
#define bFM_CAN1_ERRCNT_REC0                  *((volatile unsigned char*)(0x42C600A0UL))
#define bFM_CAN1_ERRCNT_REC1                  *((volatile unsigned char*)(0x42C600A4UL))
#define bFM_CAN1_ERRCNT_REC2                  *((volatile unsigned char*)(0x42C600A8UL))
#define bFM_CAN1_ERRCNT_REC3                  *((volatile unsigned char*)(0x42C600ACUL))
#define bFM_CAN1_ERRCNT_REC4                  *((volatile unsigned char*)(0x42C600B0UL))
#define bFM_CAN1_ERRCNT_REC5                  *((volatile unsigned char*)(0x42C600B4UL))
#define bFM_CAN1_ERRCNT_REC6                  *((volatile unsigned char*)(0x42C600B8UL))
#define bFM_CAN1_ERRCNT_RP                    *((volatile unsigned char*)(0x42C600BCUL))
#define bFM_CAN1_BTR_BRP0                     *((volatile unsigned char*)(0x42C600C0UL))
#define bFM_CAN1_BTR_BRP1                     *((volatile unsigned char*)(0x42C600C4UL))
#define bFM_CAN1_BTR_BRP2                     *((volatile unsigned char*)(0x42C600C8UL))
#define bFM_CAN1_BTR_BRP3                     *((volatile unsigned char*)(0x42C600CCUL))
#define bFM_CAN1_BTR_BRP4                     *((volatile unsigned char*)(0x42C600D0UL))
#define bFM_CAN1_BTR_BRP5                     *((volatile unsigned char*)(0x42C600D4UL))
#define bFM_CAN1_BTR_SJW0                     *((volatile unsigned char*)(0x42C600D8UL))
#define bFM_CAN1_BTR_SJW1                     *((volatile unsigned char*)(0x42C600DCUL))
#define bFM_CAN1_BTR_TSEG10                   *((volatile unsigned char*)(0x42C600E0UL))
#define bFM_CAN1_BTR_TSEG11                   *((volatile unsigned char*)(0x42C600E4UL))
#define bFM_CAN1_BTR_TSEG12                   *((volatile unsigned char*)(0x42C600E8UL))
#define bFM_CAN1_BTR_TSEG13                   *((volatile unsigned char*)(0x42C600ECUL))
#define bFM_CAN1_BTR_TSEG20                   *((volatile unsigned char*)(0x42C600F0UL))
#define bFM_CAN1_BTR_TSEG21                   *((volatile unsigned char*)(0x42C600F4UL))
#define bFM_CAN1_BTR_TSEG22                   *((volatile unsigned char*)(0x42C600F8UL))
#define bFM_CAN1_INTR_INTID0                  *((volatile unsigned char*)(0x42C60100UL))
#define bFM_CAN1_INTR_INTID1                  *((volatile unsigned char*)(0x42C60104UL))
#define bFM_CAN1_INTR_INTID2                  *((volatile unsigned char*)(0x42C60108UL))
#define bFM_CAN1_INTR_INTID3                  *((volatile unsigned char*)(0x42C6010CUL))
#define bFM_CAN1_INTR_INTID4                  *((volatile unsigned char*)(0x42C60110UL))
#define bFM_CAN1_INTR_INTID5                  *((volatile unsigned char*)(0x42C60114UL))
#define bFM_CAN1_INTR_INTID6                  *((volatile unsigned char*)(0x42C60118UL))
#define bFM_CAN1_INTR_INTID7                  *((volatile unsigned char*)(0x42C6011CUL))
#define bFM_CAN1_INTR_INTID8                  *((volatile unsigned char*)(0x42C60120UL))
#define bFM_CAN1_INTR_INTID9                  *((volatile unsigned char*)(0x42C60124UL))
#define bFM_CAN1_INTR_INTID10                 *((volatile unsigned char*)(0x42C60128UL))
#define bFM_CAN1_INTR_INTID11                 *((volatile unsigned char*)(0x42C6012CUL))
#define bFM_CAN1_INTR_INTID12                 *((volatile unsigned char*)(0x42C60130UL))
#define bFM_CAN1_INTR_INTID13                 *((volatile unsigned char*)(0x42C60134UL))
#define bFM_CAN1_INTR_INTID14                 *((volatile unsigned char*)(0x42C60138UL))
#define bFM_CAN1_INTR_INTID15                 *((volatile unsigned char*)(0x42C6013CUL))
#define bFM_CAN1_TESTR_BASIC                  *((volatile unsigned char*)(0x42C60148UL))
#define bFM_CAN1_TESTR_SILENT                 *((volatile unsigned char*)(0x42C6014CUL))
#define bFM_CAN1_TESTR_LBACK                  *((volatile unsigned char*)(0x42C60150UL))
#define bFM_CAN1_TESTR_TX0                    *((volatile unsigned char*)(0x42C60154UL))
#define bFM_CAN1_TESTR_TX1                    *((volatile unsigned char*)(0x42C60158UL))
#define bFM_CAN1_TESTR_RX                     *((volatile unsigned char*)(0x42C6015CUL))
#define bFM_CAN1_BRPER_BRPE0                  *((volatile unsigned char*)(0x42C60180UL))
#define bFM_CAN1_BRPER_BRPE1                  *((volatile unsigned char*)(0x42C60184UL))
#define bFM_CAN1_BRPER_BRPE2                  *((volatile unsigned char*)(0x42C60188UL))
#define bFM_CAN1_BRPER_BRPE3                  *((volatile unsigned char*)(0x42C6018CUL))
#define bFM_CAN1_IF1CREQ_BUSY                 *((volatile unsigned char*)(0x42C6023CUL))
#define bFM_CAN1_IF1CMSK_DATAB                *((volatile unsigned char*)(0x42C60240UL))
#define bFM_CAN1_IF1CMSK_DATAA                *((volatile unsigned char*)(0x42C60244UL))
#define bFM_CAN1_IF1CMSK_TXREST               *((volatile unsigned char*)(0x42C60248UL))
#define bFM_CAN1_IF1CMSK_NEWDAT               *((volatile unsigned char*)(0x42C60248UL))
#define bFM_CAN1_IF1CMSK_CIP                  *((volatile unsigned char*)(0x42C6024CUL))
#define bFM_CAN1_IF1CMSK_CONTROL              *((volatile unsigned char*)(0x42C60250UL))
#define bFM_CAN1_IF1CMSK_ARB                  *((volatile unsigned char*)(0x42C60254UL))
#define bFM_CAN1_IF1CMSK_MASK                 *((volatile unsigned char*)(0x42C60258UL))
#define bFM_CAN1_IF1CMSK_WRRD                 *((volatile unsigned char*)(0x42C6025CUL))
#define bFM_CAN1_IF1MSK_MDIR                  *((volatile unsigned char*)(0x42C602F8UL))
#define bFM_CAN1_IF1MSK_MXTD                  *((volatile unsigned char*)(0x42C602FCUL))
#define bFM_CAN1_IF1MSK2_MDIR                 *((volatile unsigned char*)(0x42C602F8UL))
#define bFM_CAN1_IF1MSK2_MXTD                 *((volatile unsigned char*)(0x42C602FCUL))
#define bFM_CAN1_IF1ARB_DIR                   *((volatile unsigned char*)(0x42C60374UL))
#define bFM_CAN1_IF1ARB_XTD                   *((volatile unsigned char*)(0x42C60378UL))
#define bFM_CAN1_IF1ARB_MSGVAL                *((volatile unsigned char*)(0x42C6037CUL))
#define bFM_CAN1_IF1ARB2_DIR                  *((volatile unsigned char*)(0x42C60374UL))
#define bFM_CAN1_IF1ARB2_XTD                  *((volatile unsigned char*)(0x42C60378UL))
#define bFM_CAN1_IF1ARB2_MSGVAL               *((volatile unsigned char*)(0x42C6037CUL))
#define bFM_CAN1_IF1MCTR_DLC0                 *((volatile unsigned char*)(0x42C60380UL))
#define bFM_CAN1_IF1MCTR_DLC1                 *((volatile unsigned char*)(0x42C60384UL))
#define bFM_CAN1_IF1MCTR_DLC2                 *((volatile unsigned char*)(0x42C60388UL))
#define bFM_CAN1_IF1MCTR_DLC3                 *((volatile unsigned char*)(0x42C6038CUL))
#define bFM_CAN1_IF1MCTR_EOB                  *((volatile unsigned char*)(0x42C6039CUL))
#define bFM_CAN1_IF1MCTR_TXRQST               *((volatile unsigned char*)(0x42C603A0UL))
#define bFM_CAN1_IF1MCTR_RMTEN                *((volatile unsigned char*)(0x42C603A4UL))
#define bFM_CAN1_IF1MCTR_RXIE                 *((volatile unsigned char*)(0x42C603A8UL))
#define bFM_CAN1_IF1MCTR_TXIE                 *((volatile unsigned char*)(0x42C603ACUL))
#define bFM_CAN1_IF1MCTR_UMASK                *((volatile unsigned char*)(0x42C603B0UL))
#define bFM_CAN1_IF1MCTR_INTPND               *((volatile unsigned char*)(0x42C603B4UL))
#define bFM_CAN1_IF1MCTR_MSGLST               *((volatile unsigned char*)(0x42C603B8UL))
#define bFM_CAN1_IF1MCTR_NEWDAT               *((volatile unsigned char*)(0x42C603BCUL))
#define bFM_CAN1_IF2CREQ_BUSY                 *((volatile unsigned char*)(0x42C6083CUL))
#define bFM_CAN1_IF2CMSK_DATAB                *((volatile unsigned char*)(0x42C60840UL))
#define bFM_CAN1_IF2CMSK_DATAA                *((volatile unsigned char*)(0x42C60844UL))
#define bFM_CAN1_IF2CMSK_TXREST               *((volatile unsigned char*)(0x42C60848UL))
#define bFM_CAN1_IF2CMSK_NEWDAT               *((volatile unsigned char*)(0x42C60848UL))
#define bFM_CAN1_IF2CMSK_CIP                  *((volatile unsigned char*)(0x42C6084CUL))
#define bFM_CAN1_IF2CMSK_CONTROL              *((volatile unsigned char*)(0x42C60850UL))
#define bFM_CAN1_IF2CMSK_ARB                  *((volatile unsigned char*)(0x42C60854UL))
#define bFM_CAN1_IF2CMSK_MASK                 *((volatile unsigned char*)(0x42C60858UL))
#define bFM_CAN1_IF2CMSK_WRRD                 *((volatile unsigned char*)(0x42C6085CUL))
#define bFM_CAN1_IF2MSK_MDIR                  *((volatile unsigned char*)(0x42C608F8UL))
#define bFM_CAN1_IF2MSK_MXTD                  *((volatile unsigned char*)(0x42C608FCUL))
#define bFM_CAN1_IF2MSK2_MDIR                 *((volatile unsigned char*)(0x42C608F8UL))
#define bFM_CAN1_IF2MSK2_MXTD                 *((volatile unsigned char*)(0x42C608FCUL))
#define bFM_CAN1_IF2ARB_DIR                   *((volatile unsigned char*)(0x42C60974UL))
#define bFM_CAN1_IF2ARB_XTD                   *((volatile unsigned char*)(0x42C60978UL))
#define bFM_CAN1_IF2ARB_MSGVAL                *((volatile unsigned char*)(0x42C6097CUL))
#define bFM_CAN1_IF2ARB2_DIR                  *((volatile unsigned char*)(0x42C60974UL))
#define bFM_CAN1_IF2ARB2_XTD                  *((volatile unsigned char*)(0x42C60978UL))
#define bFM_CAN1_IF2ARB2_MSGVAL               *((volatile unsigned char*)(0x42C6097CUL))
#define bFM_CAN1_IF2MCTR_DLC0                 *((volatile unsigned char*)(0x42C60980UL))
#define bFM_CAN1_IF2MCTR_DLC1                 *((volatile unsigned char*)(0x42C60984UL))
#define bFM_CAN1_IF2MCTR_DLC2                 *((volatile unsigned char*)(0x42C60988UL))
#define bFM_CAN1_IF2MCTR_DLC3                 *((volatile unsigned char*)(0x42C6098CUL))
#define bFM_CAN1_IF2MCTR_EOB                  *((volatile unsigned char*)(0x42C6099CUL))
#define bFM_CAN1_IF2MCTR_TXRQST               *((volatile unsigned char*)(0x42C609A0UL))
#define bFM_CAN1_IF2MCTR_RMTEN                *((volatile unsigned char*)(0x42C609A4UL))
#define bFM_CAN1_IF2MCTR_RXIE                 *((volatile unsigned char*)(0x42C609A8UL))
#define bFM_CAN1_IF2MCTR_TXIE                 *((volatile unsigned char*)(0x42C609ACUL))
#define bFM_CAN1_IF2MCTR_UMASK                *((volatile unsigned char*)(0x42C609B0UL))
#define bFM_CAN1_IF2MCTR_INTPND               *((volatile unsigned char*)(0x42C609B4UL))
#define bFM_CAN1_IF2MCTR_MSGLST               *((volatile unsigned char*)(0x42C609B8UL))
#define bFM_CAN1_IF2MCTR_NEWDAT               *((volatile unsigned char*)(0x42C609BCUL))
#define bFM_CAN1_TREQR_TXRQST1                *((volatile unsigned char*)(0x42C61000UL))
#define bFM_CAN1_TREQR_TXRQST2                *((volatile unsigned char*)(0x42C61004UL))
#define bFM_CAN1_TREQR_TXRQST3                *((volatile unsigned char*)(0x42C61008UL))
#define bFM_CAN1_TREQR_TXRQST4                *((volatile unsigned char*)(0x42C6100CUL))
#define bFM_CAN1_TREQR_TXRQST5                *((volatile unsigned char*)(0x42C61010UL))
#define bFM_CAN1_TREQR_TXRQST6                *((volatile unsigned char*)(0x42C61014UL))
#define bFM_CAN1_TREQR_TXRQST7                *((volatile unsigned char*)(0x42C61018UL))
#define bFM_CAN1_TREQR_TXRQST8                *((volatile unsigned char*)(0x42C6101CUL))
#define bFM_CAN1_TREQR_TXRQST9                *((volatile unsigned char*)(0x42C61020UL))
#define bFM_CAN1_TREQR_TXRQST10               *((volatile unsigned char*)(0x42C61024UL))
#define bFM_CAN1_TREQR_TXRQST11               *((volatile unsigned char*)(0x42C61028UL))
#define bFM_CAN1_TREQR_TXRQST12               *((volatile unsigned char*)(0x42C6102CUL))
#define bFM_CAN1_TREQR_TXRQST13               *((volatile unsigned char*)(0x42C61030UL))
#define bFM_CAN1_TREQR_TXRQST14               *((volatile unsigned char*)(0x42C61034UL))
#define bFM_CAN1_TREQR_TXRQST15               *((volatile unsigned char*)(0x42C61038UL))
#define bFM_CAN1_TREQR_TXRQST16               *((volatile unsigned char*)(0x42C6103CUL))
#define bFM_CAN1_TREQR_TXRQST17               *((volatile unsigned char*)(0x42C61040UL))
#define bFM_CAN1_TREQR_TXRQST18               *((volatile unsigned char*)(0x42C61044UL))
#define bFM_CAN1_TREQR_TXRQST19               *((volatile unsigned char*)(0x42C61048UL))
#define bFM_CAN1_TREQR_TXRQST20               *((volatile unsigned char*)(0x42C6104CUL))
#define bFM_CAN1_TREQR_TXRQST21               *((volatile unsigned char*)(0x42C61050UL))
#define bFM_CAN1_TREQR_TXRQST22               *((volatile unsigned char*)(0x42C61054UL))
#define bFM_CAN1_TREQR_TXRQST23               *((volatile unsigned char*)(0x42C61058UL))
#define bFM_CAN1_TREQR_TXRQST24               *((volatile unsigned char*)(0x42C6105CUL))
#define bFM_CAN1_TREQR_TXRQST25               *((volatile unsigned char*)(0x42C61060UL))
#define bFM_CAN1_TREQR_TXRQST26               *((volatile unsigned char*)(0x42C61064UL))
#define bFM_CAN1_TREQR_TXRQST27               *((volatile unsigned char*)(0x42C61068UL))
#define bFM_CAN1_TREQR_TXRQST28               *((volatile unsigned char*)(0x42C6106CUL))
#define bFM_CAN1_TREQR_TXRQST29               *((volatile unsigned char*)(0x42C61070UL))
#define bFM_CAN1_TREQR_TXRQST30               *((volatile unsigned char*)(0x42C61074UL))
#define bFM_CAN1_TREQR_TXRQST31               *((volatile unsigned char*)(0x42C61078UL))
#define bFM_CAN1_TREQR_TXRQST32               *((volatile unsigned char*)(0x42C6107CUL))
#define bFM_CAN1_TREQR1_TXRQST1               *((volatile unsigned char*)(0x42C61000UL))
#define bFM_CAN1_TREQR1_TXRQST2               *((volatile unsigned char*)(0x42C61004UL))
#define bFM_CAN1_TREQR1_TXRQST3               *((volatile unsigned char*)(0x42C61008UL))
#define bFM_CAN1_TREQR1_TXRQST4               *((volatile unsigned char*)(0x42C6100CUL))
#define bFM_CAN1_TREQR1_TXRQST5               *((volatile unsigned char*)(0x42C61010UL))
#define bFM_CAN1_TREQR1_TXRQST6               *((volatile unsigned char*)(0x42C61014UL))
#define bFM_CAN1_TREQR1_TXRQST7               *((volatile unsigned char*)(0x42C61018UL))
#define bFM_CAN1_TREQR1_TXRQST8               *((volatile unsigned char*)(0x42C6101CUL))
#define bFM_CAN1_TREQR1_TXRQST9               *((volatile unsigned char*)(0x42C61020UL))
#define bFM_CAN1_TREQR1_TXRQST10              *((volatile unsigned char*)(0x42C61024UL))
#define bFM_CAN1_TREQR1_TXRQST11              *((volatile unsigned char*)(0x42C61028UL))
#define bFM_CAN1_TREQR1_TXRQST12              *((volatile unsigned char*)(0x42C6102CUL))
#define bFM_CAN1_TREQR1_TXRQST13              *((volatile unsigned char*)(0x42C61030UL))
#define bFM_CAN1_TREQR1_TXRQST14              *((volatile unsigned char*)(0x42C61034UL))
#define bFM_CAN1_TREQR1_TXRQST15              *((volatile unsigned char*)(0x42C61038UL))
#define bFM_CAN1_TREQR1_TXRQST16              *((volatile unsigned char*)(0x42C6103CUL))
#define bFM_CAN1_TREQR2_TXRQST17              *((volatile unsigned char*)(0x42C61040UL))
#define bFM_CAN1_TREQR2_TXRQST18              *((volatile unsigned char*)(0x42C61044UL))
#define bFM_CAN1_TREQR2_TXRQST19              *((volatile unsigned char*)(0x42C61048UL))
#define bFM_CAN1_TREQR2_TXRQST20              *((volatile unsigned char*)(0x42C6104CUL))
#define bFM_CAN1_TREQR2_TXRQST21              *((volatile unsigned char*)(0x42C61050UL))
#define bFM_CAN1_TREQR2_TXRQST22              *((volatile unsigned char*)(0x42C61054UL))
#define bFM_CAN1_TREQR2_TXRQST23              *((volatile unsigned char*)(0x42C61058UL))
#define bFM_CAN1_TREQR2_TXRQST24              *((volatile unsigned char*)(0x42C6105CUL))
#define bFM_CAN1_TREQR2_TXRQST25              *((volatile unsigned char*)(0x42C61060UL))
#define bFM_CAN1_TREQR2_TXRQST26              *((volatile unsigned char*)(0x42C61064UL))
#define bFM_CAN1_TREQR2_TXRQST27              *((volatile unsigned char*)(0x42C61068UL))
#define bFM_CAN1_TREQR2_TXRQST28              *((volatile unsigned char*)(0x42C6106CUL))
#define bFM_CAN1_TREQR2_TXRQST29              *((volatile unsigned char*)(0x42C61070UL))
#define bFM_CAN1_TREQR2_TXRQST30              *((volatile unsigned char*)(0x42C61074UL))
#define bFM_CAN1_TREQR2_TXRQST31              *((volatile unsigned char*)(0x42C61078UL))
#define bFM_CAN1_TREQR2_TXRQST32              *((volatile unsigned char*)(0x42C6107CUL))
#define bFM_CAN1_NEWDT_NEWDAT1                *((volatile unsigned char*)(0x42C61200UL))
#define bFM_CAN1_NEWDT_NEWDAT2                *((volatile unsigned char*)(0x42C61204UL))
#define bFM_CAN1_NEWDT_NEWDAT3                *((volatile unsigned char*)(0x42C61208UL))
#define bFM_CAN1_NEWDT_NEWDAT4                *((volatile unsigned char*)(0x42C6120CUL))
#define bFM_CAN1_NEWDT_NEWDAT5                *((volatile unsigned char*)(0x42C61210UL))
#define bFM_CAN1_NEWDT_NEWDAT6                *((volatile unsigned char*)(0x42C61214UL))
#define bFM_CAN1_NEWDT_NEWDAT7                *((volatile unsigned char*)(0x42C61218UL))
#define bFM_CAN1_NEWDT_NEWDAT8                *((volatile unsigned char*)(0x42C6121CUL))
#define bFM_CAN1_NEWDT_NEWDAT9                *((volatile unsigned char*)(0x42C61220UL))
#define bFM_CAN1_NEWDT_NEWDAT10               *((volatile unsigned char*)(0x42C61224UL))
#define bFM_CAN1_NEWDT_NEWDAT11               *((volatile unsigned char*)(0x42C61228UL))
#define bFM_CAN1_NEWDT_NEWDAT12               *((volatile unsigned char*)(0x42C6122CUL))
#define bFM_CAN1_NEWDT_NEWDAT13               *((volatile unsigned char*)(0x42C61230UL))
#define bFM_CAN1_NEWDT_NEWDAT14               *((volatile unsigned char*)(0x42C61234UL))
#define bFM_CAN1_NEWDT_NEWDAT15               *((volatile unsigned char*)(0x42C61238UL))
#define bFM_CAN1_NEWDT_NEWDAT16               *((volatile unsigned char*)(0x42C6123CUL))
#define bFM_CAN1_NEWDT_NEWDAT17               *((volatile unsigned char*)(0x42C61240UL))
#define bFM_CAN1_NEWDT_NEWDAT18               *((volatile unsigned char*)(0x42C61244UL))
#define bFM_CAN1_NEWDT_NEWDAT19               *((volatile unsigned char*)(0x42C61248UL))
#define bFM_CAN1_NEWDT_NEWDAT20               *((volatile unsigned char*)(0x42C6124CUL))
#define bFM_CAN1_NEWDT_NEWDAT21               *((volatile unsigned char*)(0x42C61250UL))
#define bFM_CAN1_NEWDT_NEWDAT22               *((volatile unsigned char*)(0x42C61254UL))
#define bFM_CAN1_NEWDT_NEWDAT23               *((volatile unsigned char*)(0x42C61258UL))
#define bFM_CAN1_NEWDT_NEWDAT24               *((volatile unsigned char*)(0x42C6125CUL))
#define bFM_CAN1_NEWDT_NEWDAT25               *((volatile unsigned char*)(0x42C61260UL))
#define bFM_CAN1_NEWDT_NEWDAT26               *((volatile unsigned char*)(0x42C61264UL))
#define bFM_CAN1_NEWDT_NEWDAT27               *((volatile unsigned char*)(0x42C61268UL))
#define bFM_CAN1_NEWDT_NEWDAT28               *((volatile unsigned char*)(0x42C6126CUL))
#define bFM_CAN1_NEWDT_NEWDAT29               *((volatile unsigned char*)(0x42C61270UL))
#define bFM_CAN1_NEWDT_NEWDAT30               *((volatile unsigned char*)(0x42C61274UL))
#define bFM_CAN1_NEWDT_NEWDAT31               *((volatile unsigned char*)(0x42C61278UL))
#define bFM_CAN1_NEWDT_NEWDAT32               *((volatile unsigned char*)(0x42C6127CUL))
#define bFM_CAN1_NEWDT1_NEWDAT1               *((volatile unsigned char*)(0x42C61200UL))
#define bFM_CAN1_NEWDT1_NEWDAT2               *((volatile unsigned char*)(0x42C61204UL))
#define bFM_CAN1_NEWDT1_NEWDAT3               *((volatile unsigned char*)(0x42C61208UL))
#define bFM_CAN1_NEWDT1_NEWDAT4               *((volatile unsigned char*)(0x42C6120CUL))
#define bFM_CAN1_NEWDT1_NEWDAT5               *((volatile unsigned char*)(0x42C61210UL))
#define bFM_CAN1_NEWDT1_NEWDAT6               *((volatile unsigned char*)(0x42C61214UL))
#define bFM_CAN1_NEWDT1_NEWDAT7               *((volatile unsigned char*)(0x42C61218UL))
#define bFM_CAN1_NEWDT1_NEWDAT8               *((volatile unsigned char*)(0x42C6121CUL))
#define bFM_CAN1_NEWDT1_NEWDAT9               *((volatile unsigned char*)(0x42C61220UL))
#define bFM_CAN1_NEWDT1_NEWDAT10              *((volatile unsigned char*)(0x42C61224UL))
#define bFM_CAN1_NEWDT1_NEWDAT11              *((volatile unsigned char*)(0x42C61228UL))
#define bFM_CAN1_NEWDT1_NEWDAT12              *((volatile unsigned char*)(0x42C6122CUL))
#define bFM_CAN1_NEWDT1_NEWDAT13              *((volatile unsigned char*)(0x42C61230UL))
#define bFM_CAN1_NEWDT1_NEWDAT14              *((volatile unsigned char*)(0x42C61234UL))
#define bFM_CAN1_NEWDT1_NEWDAT15              *((volatile unsigned char*)(0x42C61238UL))
#define bFM_CAN1_NEWDT1_NEWDAT16              *((volatile unsigned char*)(0x42C6123CUL))
#define bFM_CAN1_NEWDT2_NEWDAT17              *((volatile unsigned char*)(0x42C61240UL))
#define bFM_CAN1_NEWDT2_NEWDAT18              *((volatile unsigned char*)(0x42C61244UL))
#define bFM_CAN1_NEWDT2_NEWDAT19              *((volatile unsigned char*)(0x42C61248UL))
#define bFM_CAN1_NEWDT2_NEWDAT20              *((volatile unsigned char*)(0x42C6124CUL))
#define bFM_CAN1_NEWDT2_NEWDAT21              *((volatile unsigned char*)(0x42C61250UL))
#define bFM_CAN1_NEWDT2_NEWDAT22              *((volatile unsigned char*)(0x42C61254UL))
#define bFM_CAN1_NEWDT2_NEWDAT23              *((volatile unsigned char*)(0x42C61258UL))
#define bFM_CAN1_NEWDT2_NEWDAT24              *((volatile unsigned char*)(0x42C6125CUL))
#define bFM_CAN1_NEWDT2_NEWDAT25              *((volatile unsigned char*)(0x42C61260UL))
#define bFM_CAN1_NEWDT2_NEWDAT26              *((volatile unsigned char*)(0x42C61264UL))
#define bFM_CAN1_NEWDT2_NEWDAT27              *((volatile unsigned char*)(0x42C61268UL))
#define bFM_CAN1_NEWDT2_NEWDAT28              *((volatile unsigned char*)(0x42C6126CUL))
#define bFM_CAN1_NEWDT2_NEWDAT29              *((volatile unsigned char*)(0x42C61270UL))
#define bFM_CAN1_NEWDT2_NEWDAT30              *((volatile unsigned char*)(0x42C61274UL))
#define bFM_CAN1_NEWDT2_NEWDAT31              *((volatile unsigned char*)(0x42C61278UL))
#define bFM_CAN1_NEWDT2_NEWDAT32              *((volatile unsigned char*)(0x42C6127CUL))
#define bFM_CAN1_INTPND_INTPND1               *((volatile unsigned char*)(0x42C61400UL))
#define bFM_CAN1_INTPND_INTPND2               *((volatile unsigned char*)(0x42C61404UL))
#define bFM_CAN1_INTPND_INTPND3               *((volatile unsigned char*)(0x42C61408UL))
#define bFM_CAN1_INTPND_INTPND4               *((volatile unsigned char*)(0x42C6140CUL))
#define bFM_CAN1_INTPND_INTPND5               *((volatile unsigned char*)(0x42C61410UL))
#define bFM_CAN1_INTPND_INTPND6               *((volatile unsigned char*)(0x42C61414UL))
#define bFM_CAN1_INTPND_INTPND7               *((volatile unsigned char*)(0x42C61418UL))
#define bFM_CAN1_INTPND_INTPND8               *((volatile unsigned char*)(0x42C6141CUL))
#define bFM_CAN1_INTPND_INTPND9               *((volatile unsigned char*)(0x42C61420UL))
#define bFM_CAN1_INTPND_INTPND10              *((volatile unsigned char*)(0x42C61424UL))
#define bFM_CAN1_INTPND_INTPND11              *((volatile unsigned char*)(0x42C61428UL))
#define bFM_CAN1_INTPND_INTPND12              *((volatile unsigned char*)(0x42C6142CUL))
#define bFM_CAN1_INTPND_INTPND13              *((volatile unsigned char*)(0x42C61430UL))
#define bFM_CAN1_INTPND_INTPND14              *((volatile unsigned char*)(0x42C61434UL))
#define bFM_CAN1_INTPND_INTPND15              *((volatile unsigned char*)(0x42C61438UL))
#define bFM_CAN1_INTPND_INTPND16              *((volatile unsigned char*)(0x42C6143CUL))
#define bFM_CAN1_INTPND_INTPND17              *((volatile unsigned char*)(0x42C61440UL))
#define bFM_CAN1_INTPND_INTPND18              *((volatile unsigned char*)(0x42C61444UL))
#define bFM_CAN1_INTPND_INTPND19              *((volatile unsigned char*)(0x42C61448UL))
#define bFM_CAN1_INTPND_INTPND20              *((volatile unsigned char*)(0x42C6144CUL))
#define bFM_CAN1_INTPND_INTPND21              *((volatile unsigned char*)(0x42C61450UL))
#define bFM_CAN1_INTPND_INTPND22              *((volatile unsigned char*)(0x42C61454UL))
#define bFM_CAN1_INTPND_INTPND23              *((volatile unsigned char*)(0x42C61458UL))
#define bFM_CAN1_INTPND_INTPND24              *((volatile unsigned char*)(0x42C6145CUL))
#define bFM_CAN1_INTPND_INTPND25              *((volatile unsigned char*)(0x42C61460UL))
#define bFM_CAN1_INTPND_INTPND26              *((volatile unsigned char*)(0x42C61464UL))
#define bFM_CAN1_INTPND_INTPND27              *((volatile unsigned char*)(0x42C61468UL))
#define bFM_CAN1_INTPND_INTPND28              *((volatile unsigned char*)(0x42C6146CUL))
#define bFM_CAN1_INTPND_INTPND29              *((volatile unsigned char*)(0x42C61470UL))
#define bFM_CAN1_INTPND_INTPND30              *((volatile unsigned char*)(0x42C61474UL))
#define bFM_CAN1_INTPND_INTPND31              *((volatile unsigned char*)(0x42C61478UL))
#define bFM_CAN1_INTPND_INTPND32              *((volatile unsigned char*)(0x42C6147CUL))
#define bFM_CAN1_INTPND1_INTPND1              *((volatile unsigned char*)(0x42C61400UL))
#define bFM_CAN1_INTPND1_INTPND2              *((volatile unsigned char*)(0x42C61404UL))
#define bFM_CAN1_INTPND1_INTPND3              *((volatile unsigned char*)(0x42C61408UL))
#define bFM_CAN1_INTPND1_INTPND4              *((volatile unsigned char*)(0x42C6140CUL))
#define bFM_CAN1_INTPND1_INTPND5              *((volatile unsigned char*)(0x42C61410UL))
#define bFM_CAN1_INTPND1_INTPND6              *((volatile unsigned char*)(0x42C61414UL))
#define bFM_CAN1_INTPND1_INTPND7              *((volatile unsigned char*)(0x42C61418UL))
#define bFM_CAN1_INTPND1_INTPND8              *((volatile unsigned char*)(0x42C6141CUL))
#define bFM_CAN1_INTPND1_INTPND9              *((volatile unsigned char*)(0x42C61420UL))
#define bFM_CAN1_INTPND1_INTPND10             *((volatile unsigned char*)(0x42C61424UL))
#define bFM_CAN1_INTPND1_INTPND11             *((volatile unsigned char*)(0x42C61428UL))
#define bFM_CAN1_INTPND1_INTPND12             *((volatile unsigned char*)(0x42C6142CUL))
#define bFM_CAN1_INTPND1_INTPND13             *((volatile unsigned char*)(0x42C61430UL))
#define bFM_CAN1_INTPND1_INTPND14             *((volatile unsigned char*)(0x42C61434UL))
#define bFM_CAN1_INTPND1_INTPND15             *((volatile unsigned char*)(0x42C61438UL))
#define bFM_CAN1_INTPND1_INTPND16             *((volatile unsigned char*)(0x42C6143CUL))
#define bFM_CAN1_INTPND2_INTPND17             *((volatile unsigned char*)(0x42C61440UL))
#define bFM_CAN1_INTPND2_INTPND18             *((volatile unsigned char*)(0x42C61444UL))
#define bFM_CAN1_INTPND2_INTPND19             *((volatile unsigned char*)(0x42C61448UL))
#define bFM_CAN1_INTPND2_INTPND20             *((volatile unsigned char*)(0x42C6144CUL))
#define bFM_CAN1_INTPND2_INTPND21             *((volatile unsigned char*)(0x42C61450UL))
#define bFM_CAN1_INTPND2_INTPND22             *((volatile unsigned char*)(0x42C61454UL))
#define bFM_CAN1_INTPND2_INTPND23             *((volatile unsigned char*)(0x42C61458UL))
#define bFM_CAN1_INTPND2_INTPND24             *((volatile unsigned char*)(0x42C6145CUL))
#define bFM_CAN1_INTPND2_INTPND25             *((volatile unsigned char*)(0x42C61460UL))
#define bFM_CAN1_INTPND2_INTPND26             *((volatile unsigned char*)(0x42C61464UL))
#define bFM_CAN1_INTPND2_INTPND27             *((volatile unsigned char*)(0x42C61468UL))
#define bFM_CAN1_INTPND2_INTPND28             *((volatile unsigned char*)(0x42C6146CUL))
#define bFM_CAN1_INTPND2_INTPND29             *((volatile unsigned char*)(0x42C61470UL))
#define bFM_CAN1_INTPND2_INTPND30             *((volatile unsigned char*)(0x42C61474UL))
#define bFM_CAN1_INTPND2_INTPND31             *((volatile unsigned char*)(0x42C61478UL))
#define bFM_CAN1_INTPND2_INTPND32             *((volatile unsigned char*)(0x42C6147CUL))
#define bFM_CAN1_MSGVAL_MSGVAL1               *((volatile unsigned char*)(0x42C61600UL))
#define bFM_CAN1_MSGVAL_MSGVAL2               *((volatile unsigned char*)(0x42C61604UL))
#define bFM_CAN1_MSGVAL_MSGVAL3               *((volatile unsigned char*)(0x42C61608UL))
#define bFM_CAN1_MSGVAL_MSGVAL4               *((volatile unsigned char*)(0x42C6160CUL))
#define bFM_CAN1_MSGVAL_MSGVAL5               *((volatile unsigned char*)(0x42C61610UL))
#define bFM_CAN1_MSGVAL_MSGVAL6               *((volatile unsigned char*)(0x42C61614UL))
#define bFM_CAN1_MSGVAL_MSGVAL7               *((volatile unsigned char*)(0x42C61618UL))
#define bFM_CAN1_MSGVAL_MSGVAL8               *((volatile unsigned char*)(0x42C6161CUL))
#define bFM_CAN1_MSGVAL_MSGVAL9               *((volatile unsigned char*)(0x42C61620UL))
#define bFM_CAN1_MSGVAL_MSGVAL10              *((volatile unsigned char*)(0x42C61624UL))
#define bFM_CAN1_MSGVAL_MSGVAL11              *((volatile unsigned char*)(0x42C61628UL))
#define bFM_CAN1_MSGVAL_MSGVAL12              *((volatile unsigned char*)(0x42C6162CUL))
#define bFM_CAN1_MSGVAL_MSGVAL13              *((volatile unsigned char*)(0x42C61630UL))
#define bFM_CAN1_MSGVAL_MSGVAL14              *((volatile unsigned char*)(0x42C61634UL))
#define bFM_CAN1_MSGVAL_MSGVAL15              *((volatile unsigned char*)(0x42C61638UL))
#define bFM_CAN1_MSGVAL_MSGVAL16              *((volatile unsigned char*)(0x42C6163CUL))
#define bFM_CAN1_MSGVAL_MSGVAL17              *((volatile unsigned char*)(0x42C61640UL))
#define bFM_CAN1_MSGVAL_MSGVAL18              *((volatile unsigned char*)(0x42C61644UL))
#define bFM_CAN1_MSGVAL_MSGVAL19              *((volatile unsigned char*)(0x42C61648UL))
#define bFM_CAN1_MSGVAL_MSGVAL20              *((volatile unsigned char*)(0x42C6164CUL))
#define bFM_CAN1_MSGVAL_MSGVAL21              *((volatile unsigned char*)(0x42C61650UL))
#define bFM_CAN1_MSGVAL_MSGVAL22              *((volatile unsigned char*)(0x42C61654UL))
#define bFM_CAN1_MSGVAL_MSGVAL23              *((volatile unsigned char*)(0x42C61658UL))
#define bFM_CAN1_MSGVAL_MSGVAL24              *((volatile unsigned char*)(0x42C6165CUL))
#define bFM_CAN1_MSGVAL_MSGVAL25              *((volatile unsigned char*)(0x42C61660UL))
#define bFM_CAN1_MSGVAL_MSGVAL26              *((volatile unsigned char*)(0x42C61664UL))
#define bFM_CAN1_MSGVAL_MSGVAL27              *((volatile unsigned char*)(0x42C61668UL))
#define bFM_CAN1_MSGVAL_MSGVAL28              *((volatile unsigned char*)(0x42C6166CUL))
#define bFM_CAN1_MSGVAL_MSGVAL29              *((volatile unsigned char*)(0x42C61670UL))
#define bFM_CAN1_MSGVAL_MSGVAL30              *((volatile unsigned char*)(0x42C61674UL))
#define bFM_CAN1_MSGVAL_MSGVAL31              *((volatile unsigned char*)(0x42C61678UL))
#define bFM_CAN1_MSGVAL_MSGVAL32              *((volatile unsigned char*)(0x42C6167CUL))
#define bFM_CAN1_MSGVAL1_MSGVAL1              *((volatile unsigned char*)(0x42C61600UL))
#define bFM_CAN1_MSGVAL1_MSGVAL2              *((volatile unsigned char*)(0x42C61604UL))
#define bFM_CAN1_MSGVAL1_MSGVAL3              *((volatile unsigned char*)(0x42C61608UL))
#define bFM_CAN1_MSGVAL1_MSGVAL4              *((volatile unsigned char*)(0x42C6160CUL))
#define bFM_CAN1_MSGVAL1_MSGVAL5              *((volatile unsigned char*)(0x42C61610UL))
#define bFM_CAN1_MSGVAL1_MSGVAL6              *((volatile unsigned char*)(0x42C61614UL))
#define bFM_CAN1_MSGVAL1_MSGVAL7              *((volatile unsigned char*)(0x42C61618UL))
#define bFM_CAN1_MSGVAL1_MSGVAL8              *((volatile unsigned char*)(0x42C6161CUL))
#define bFM_CAN1_MSGVAL1_MSGVAL9              *((volatile unsigned char*)(0x42C61620UL))
#define bFM_CAN1_MSGVAL1_MSGVAL10             *((volatile unsigned char*)(0x42C61624UL))
#define bFM_CAN1_MSGVAL1_MSGVAL11             *((volatile unsigned char*)(0x42C61628UL))
#define bFM_CAN1_MSGVAL1_MSGVAL12             *((volatile unsigned char*)(0x42C6162CUL))
#define bFM_CAN1_MSGVAL1_MSGVAL13             *((volatile unsigned char*)(0x42C61630UL))
#define bFM_CAN1_MSGVAL1_MSGVAL14             *((volatile unsigned char*)(0x42C61634UL))
#define bFM_CAN1_MSGVAL1_MSGVAL15             *((volatile unsigned char*)(0x42C61638UL))
#define bFM_CAN1_MSGVAL1_MSGVAL16             *((volatile unsigned char*)(0x42C6163CUL))
#define bFM_CAN1_MSGVAL2_MSGVAL17             *((volatile unsigned char*)(0x42C61640UL))
#define bFM_CAN1_MSGVAL2_MSGVAL18             *((volatile unsigned char*)(0x42C61644UL))
#define bFM_CAN1_MSGVAL2_MSGVAL19             *((volatile unsigned char*)(0x42C61648UL))
#define bFM_CAN1_MSGVAL2_MSGVAL20             *((volatile unsigned char*)(0x42C6164CUL))
#define bFM_CAN1_MSGVAL2_MSGVAL21             *((volatile unsigned char*)(0x42C61650UL))
#define bFM_CAN1_MSGVAL2_MSGVAL22             *((volatile unsigned char*)(0x42C61654UL))
#define bFM_CAN1_MSGVAL2_MSGVAL23             *((volatile unsigned char*)(0x42C61658UL))
#define bFM_CAN1_MSGVAL2_MSGVAL24             *((volatile unsigned char*)(0x42C6165CUL))
#define bFM_CAN1_MSGVAL2_MSGVAL25             *((volatile unsigned char*)(0x42C61660UL))
#define bFM_CAN1_MSGVAL2_MSGVAL26             *((volatile unsigned char*)(0x42C61664UL))
#define bFM_CAN1_MSGVAL2_MSGVAL27             *((volatile unsigned char*)(0x42C61668UL))
#define bFM_CAN1_MSGVAL2_MSGVAL28             *((volatile unsigned char*)(0x42C6166CUL))
#define bFM_CAN1_MSGVAL2_MSGVAL29             *((volatile unsigned char*)(0x42C61670UL))
#define bFM_CAN1_MSGVAL2_MSGVAL30             *((volatile unsigned char*)(0x42C61674UL))
#define bFM_CAN1_MSGVAL2_MSGVAL31             *((volatile unsigned char*)(0x42C61678UL))
#define bFM_CAN1_MSGVAL2_MSGVAL32             *((volatile unsigned char*)(0x42C6167CUL))

/* Ethernet MAC 0 registers */
#define bFM_ETHERNET_MAC0_MCR_RE              *((volatile unsigned char*)(0x42C80008UL))
#define bFM_ETHERNET_MAC0_MCR_TE              *((volatile unsigned char*)(0x42C8000CUL))
#define bFM_ETHERNET_MAC0_MCR_DC              *((volatile unsigned char*)(0x42C80010UL))
#define bFM_ETHERNET_MAC0_MCR_BL0             *((volatile unsigned char*)(0x42C80014UL))
#define bFM_ETHERNET_MAC0_MCR_BL1             *((volatile unsigned char*)(0x42C80018UL))
#define bFM_ETHERNET_MAC0_MCR_ACS             *((volatile unsigned char*)(0x42C8001CUL))
#define bFM_ETHERNET_MAC0_MCR_LUD             *((volatile unsigned char*)(0x42C80020UL))
#define bFM_ETHERNET_MAC0_MCR_DR              *((volatile unsigned char*)(0x42C80024UL))
#define bFM_ETHERNET_MAC0_MCR_IPC             *((volatile unsigned char*)(0x42C80028UL))
#define bFM_ETHERNET_MAC0_MCR_DM              *((volatile unsigned char*)(0x42C8002CUL))
#define bFM_ETHERNET_MAC0_MCR_LM              *((volatile unsigned char*)(0x42C80030UL))
#define bFM_ETHERNET_MAC0_MCR_DO              *((volatile unsigned char*)(0x42C80034UL))
#define bFM_ETHERNET_MAC0_MCR_FES             *((volatile unsigned char*)(0x42C80038UL))
#define bFM_ETHERNET_MAC0_MCR_PS              *((volatile unsigned char*)(0x42C8003CUL))
#define bFM_ETHERNET_MAC0_MCR_DCRS            *((volatile unsigned char*)(0x42C80040UL))
#define bFM_ETHERNET_MAC0_MCR_IFG0            *((volatile unsigned char*)(0x42C80044UL))
#define bFM_ETHERNET_MAC0_MCR_IFG1            *((volatile unsigned char*)(0x42C80048UL))
#define bFM_ETHERNET_MAC0_MCR_IFG2            *((volatile unsigned char*)(0x42C8004CUL))
#define bFM_ETHERNET_MAC0_MCR_JE              *((volatile unsigned char*)(0x42C80050UL))
#define bFM_ETHERNET_MAC0_MCR_BE              *((volatile unsigned char*)(0x42C80054UL))
#define bFM_ETHERNET_MAC0_MCR_JD              *((volatile unsigned char*)(0x42C80058UL))
#define bFM_ETHERNET_MAC0_MCR_WD              *((volatile unsigned char*)(0x42C8005CUL))
#define bFM_ETHERNET_MAC0_MCR_TC              *((volatile unsigned char*)(0x42C80060UL))
#define bFM_ETHERNET_MAC0_MCR_CST             *((volatile unsigned char*)(0x42C80064UL))
#define bFM_ETHERNET_MAC0_MFFR_PR             *((volatile unsigned char*)(0x42C80080UL))
#define bFM_ETHERNET_MAC0_MFFR_HUC            *((volatile unsigned char*)(0x42C80084UL))
#define bFM_ETHERNET_MAC0_MFFR_HMC            *((volatile unsigned char*)(0x42C80088UL))
#define bFM_ETHERNET_MAC0_MFFR_DAIF           *((volatile unsigned char*)(0x42C8008CUL))
#define bFM_ETHERNET_MAC0_MFFR_PM             *((volatile unsigned char*)(0x42C80090UL))
#define bFM_ETHERNET_MAC0_MFFR_DB             *((volatile unsigned char*)(0x42C80094UL))
#define bFM_ETHERNET_MAC0_MFFR_PCF0           *((volatile unsigned char*)(0x42C80098UL))
#define bFM_ETHERNET_MAC0_MFFR_PCF1           *((volatile unsigned char*)(0x42C8009CUL))
#define bFM_ETHERNET_MAC0_MFFR_SAIF           *((volatile unsigned char*)(0x42C800A0UL))
#define bFM_ETHERNET_MAC0_MFFR_SAF            *((volatile unsigned char*)(0x42C800A4UL))
#define bFM_ETHERNET_MAC0_MFFR_HPF            *((volatile unsigned char*)(0x42C800A8UL))
#define bFM_ETHERNET_MAC0_MFFR_RA             *((volatile unsigned char*)(0x42C800FCUL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH0          *((volatile unsigned char*)(0x42C80100UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH1          *((volatile unsigned char*)(0x42C80104UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH2          *((volatile unsigned char*)(0x42C80108UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH3          *((volatile unsigned char*)(0x42C8010CUL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH4          *((volatile unsigned char*)(0x42C80110UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH5          *((volatile unsigned char*)(0x42C80114UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH6          *((volatile unsigned char*)(0x42C80118UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH7          *((volatile unsigned char*)(0x42C8011CUL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH8          *((volatile unsigned char*)(0x42C80120UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH9          *((volatile unsigned char*)(0x42C80124UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH10         *((volatile unsigned char*)(0x42C80128UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH11         *((volatile unsigned char*)(0x42C8012CUL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH12         *((volatile unsigned char*)(0x42C80130UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH13         *((volatile unsigned char*)(0x42C80134UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH14         *((volatile unsigned char*)(0x42C80138UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH15         *((volatile unsigned char*)(0x42C8013CUL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH16         *((volatile unsigned char*)(0x42C80140UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH17         *((volatile unsigned char*)(0x42C80144UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH18         *((volatile unsigned char*)(0x42C80148UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH19         *((volatile unsigned char*)(0x42C8014CUL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH20         *((volatile unsigned char*)(0x42C80150UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH21         *((volatile unsigned char*)(0x42C80154UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH22         *((volatile unsigned char*)(0x42C80158UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH23         *((volatile unsigned char*)(0x42C8015CUL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH24         *((volatile unsigned char*)(0x42C80160UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH25         *((volatile unsigned char*)(0x42C80164UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH26         *((volatile unsigned char*)(0x42C80168UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH27         *((volatile unsigned char*)(0x42C8016CUL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH28         *((volatile unsigned char*)(0x42C80170UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH29         *((volatile unsigned char*)(0x42C80174UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH30         *((volatile unsigned char*)(0x42C80178UL))
#define bFM_ETHERNET_MAC0_MHTRH_HTH31         *((volatile unsigned char*)(0x42C8017CUL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL0          *((volatile unsigned char*)(0x42C80180UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL1          *((volatile unsigned char*)(0x42C80184UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL2          *((volatile unsigned char*)(0x42C80188UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL3          *((volatile unsigned char*)(0x42C8018CUL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL4          *((volatile unsigned char*)(0x42C80190UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL5          *((volatile unsigned char*)(0x42C80194UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL6          *((volatile unsigned char*)(0x42C80198UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL7          *((volatile unsigned char*)(0x42C8019CUL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL8          *((volatile unsigned char*)(0x42C801A0UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL9          *((volatile unsigned char*)(0x42C801A4UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL10         *((volatile unsigned char*)(0x42C801A8UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL11         *((volatile unsigned char*)(0x42C801ACUL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL12         *((volatile unsigned char*)(0x42C801B0UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL13         *((volatile unsigned char*)(0x42C801B4UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL14         *((volatile unsigned char*)(0x42C801B8UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL15         *((volatile unsigned char*)(0x42C801BCUL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL16         *((volatile unsigned char*)(0x42C801C0UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL17         *((volatile unsigned char*)(0x42C801C4UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL18         *((volatile unsigned char*)(0x42C801C8UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL19         *((volatile unsigned char*)(0x42C801CCUL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL20         *((volatile unsigned char*)(0x42C801D0UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL21         *((volatile unsigned char*)(0x42C801D4UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL22         *((volatile unsigned char*)(0x42C801D8UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL23         *((volatile unsigned char*)(0x42C801DCUL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL24         *((volatile unsigned char*)(0x42C801E0UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL25         *((volatile unsigned char*)(0x42C801E4UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL26         *((volatile unsigned char*)(0x42C801E8UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL27         *((volatile unsigned char*)(0x42C801ECUL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL28         *((volatile unsigned char*)(0x42C801F0UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL29         *((volatile unsigned char*)(0x42C801F4UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL30         *((volatile unsigned char*)(0x42C801F8UL))
#define bFM_ETHERNET_MAC0_MHTRL_HTL31         *((volatile unsigned char*)(0x42C801FCUL))
#define bFM_ETHERNET_MAC0_GAR_GB              *((volatile unsigned char*)(0x42C80200UL))
#define bFM_ETHERNET_MAC0_GAR_GW              *((volatile unsigned char*)(0x42C80204UL))
#define bFM_ETHERNET_MAC0_GAR_CR0             *((volatile unsigned char*)(0x42C80208UL))
#define bFM_ETHERNET_MAC0_GAR_CR1             *((volatile unsigned char*)(0x42C8020CUL))
#define bFM_ETHERNET_MAC0_GAR_CR2             *((volatile unsigned char*)(0x42C80210UL))
#define bFM_ETHERNET_MAC0_GAR_CR3             *((volatile unsigned char*)(0x42C80214UL))
#define bFM_ETHERNET_MAC0_GAR_GR0             *((volatile unsigned char*)(0x42C80218UL))
#define bFM_ETHERNET_MAC0_GAR_GR1             *((volatile unsigned char*)(0x42C8021CUL))
#define bFM_ETHERNET_MAC0_GAR_GR2             *((volatile unsigned char*)(0x42C80220UL))
#define bFM_ETHERNET_MAC0_GAR_GR3             *((volatile unsigned char*)(0x42C80224UL))
#define bFM_ETHERNET_MAC0_GAR_GR4             *((volatile unsigned char*)(0x42C80228UL))
#define bFM_ETHERNET_MAC0_GAR_PA0             *((volatile unsigned char*)(0x42C8022CUL))
#define bFM_ETHERNET_MAC0_GAR_PA1             *((volatile unsigned char*)(0x42C80230UL))
#define bFM_ETHERNET_MAC0_GAR_PA2             *((volatile unsigned char*)(0x42C80234UL))
#define bFM_ETHERNET_MAC0_GAR_PA3             *((volatile unsigned char*)(0x42C80238UL))
#define bFM_ETHERNET_MAC0_GAR_PA4             *((volatile unsigned char*)(0x42C8023CUL))
#define bFM_ETHERNET_MAC0_GDR_GD0             *((volatile unsigned char*)(0x42C80280UL))
#define bFM_ETHERNET_MAC0_GDR_GD1             *((volatile unsigned char*)(0x42C80284UL))
#define bFM_ETHERNET_MAC0_GDR_GD2             *((volatile unsigned char*)(0x42C80288UL))
#define bFM_ETHERNET_MAC0_GDR_GD3             *((volatile unsigned char*)(0x42C8028CUL))
#define bFM_ETHERNET_MAC0_GDR_GD4             *((volatile unsigned char*)(0x42C80290UL))
#define bFM_ETHERNET_MAC0_GDR_GD5             *((volatile unsigned char*)(0x42C80294UL))
#define bFM_ETHERNET_MAC0_GDR_GD6             *((volatile unsigned char*)(0x42C80298UL))
#define bFM_ETHERNET_MAC0_GDR_GD7             *((volatile unsigned char*)(0x42C8029CUL))
#define bFM_ETHERNET_MAC0_GDR_GD8             *((volatile unsigned char*)(0x42C802A0UL))
#define bFM_ETHERNET_MAC0_GDR_GD9             *((volatile unsigned char*)(0x42C802A4UL))
#define bFM_ETHERNET_MAC0_GDR_GD10            *((volatile unsigned char*)(0x42C802A8UL))
#define bFM_ETHERNET_MAC0_GDR_GD11            *((volatile unsigned char*)(0x42C802ACUL))
#define bFM_ETHERNET_MAC0_GDR_GD12            *((volatile unsigned char*)(0x42C802B0UL))
#define bFM_ETHERNET_MAC0_GDR_GD13            *((volatile unsigned char*)(0x42C802B4UL))
#define bFM_ETHERNET_MAC0_GDR_GD14            *((volatile unsigned char*)(0x42C802B8UL))
#define bFM_ETHERNET_MAC0_GDR_GD15            *((volatile unsigned char*)(0x42C802BCUL))
#define bFM_ETHERNET_MAC0_FCR_FCB_BPA         *((volatile unsigned char*)(0x42C80300UL))
#define bFM_ETHERNET_MAC0_FCR_TFE             *((volatile unsigned char*)(0x42C80304UL))
#define bFM_ETHERNET_MAC0_FCR_RFE             *((volatile unsigned char*)(0x42C80308UL))
#define bFM_ETHERNET_MAC0_FCR_UP              *((volatile unsigned char*)(0x42C8030CUL))
#define bFM_ETHERNET_MAC0_FCR_PLT0            *((volatile unsigned char*)(0x42C80310UL))
#define bFM_ETHERNET_MAC0_FCR_PLT1            *((volatile unsigned char*)(0x42C80314UL))
#define bFM_ETHERNET_MAC0_FCR_DZPQ            *((volatile unsigned char*)(0x42C8031CUL))
#define bFM_ETHERNET_MAC0_FCR_PT0             *((volatile unsigned char*)(0x42C80340UL))
#define bFM_ETHERNET_MAC0_FCR_PT1             *((volatile unsigned char*)(0x42C80344UL))
#define bFM_ETHERNET_MAC0_FCR_PT2             *((volatile unsigned char*)(0x42C80348UL))
#define bFM_ETHERNET_MAC0_FCR_PT3             *((volatile unsigned char*)(0x42C8034CUL))
#define bFM_ETHERNET_MAC0_FCR_PT4             *((volatile unsigned char*)(0x42C80350UL))
#define bFM_ETHERNET_MAC0_FCR_PT5             *((volatile unsigned char*)(0x42C80354UL))
#define bFM_ETHERNET_MAC0_FCR_PT6             *((volatile unsigned char*)(0x42C80358UL))
#define bFM_ETHERNET_MAC0_FCR_PT7             *((volatile unsigned char*)(0x42C8035CUL))
#define bFM_ETHERNET_MAC0_FCR_PT8             *((volatile unsigned char*)(0x42C80360UL))
#define bFM_ETHERNET_MAC0_FCR_PT9             *((volatile unsigned char*)(0x42C80364UL))
#define bFM_ETHERNET_MAC0_FCR_PT10            *((volatile unsigned char*)(0x42C80368UL))
#define bFM_ETHERNET_MAC0_FCR_PT11            *((volatile unsigned char*)(0x42C8036CUL))
#define bFM_ETHERNET_MAC0_FCR_PT12            *((volatile unsigned char*)(0x42C80370UL))
#define bFM_ETHERNET_MAC0_FCR_PT13            *((volatile unsigned char*)(0x42C80374UL))
#define bFM_ETHERNET_MAC0_FCR_PT14            *((volatile unsigned char*)(0x42C80378UL))
#define bFM_ETHERNET_MAC0_FCR_PT15            *((volatile unsigned char*)(0x42C8037CUL))
#define bFM_ETHERNET_MAC0_VTR_VL0             *((volatile unsigned char*)(0x42C80380UL))
#define bFM_ETHERNET_MAC0_VTR_VL1             *((volatile unsigned char*)(0x42C80384UL))
#define bFM_ETHERNET_MAC0_VTR_VL2             *((volatile unsigned char*)(0x42C80388UL))
#define bFM_ETHERNET_MAC0_VTR_VL3             *((volatile unsigned char*)(0x42C8038CUL))
#define bFM_ETHERNET_MAC0_VTR_VL4             *((volatile unsigned char*)(0x42C80390UL))
#define bFM_ETHERNET_MAC0_VTR_VL5             *((volatile unsigned char*)(0x42C80394UL))
#define bFM_ETHERNET_MAC0_VTR_VL6             *((volatile unsigned char*)(0x42C80398UL))
#define bFM_ETHERNET_MAC0_VTR_VL7             *((volatile unsigned char*)(0x42C8039CUL))
#define bFM_ETHERNET_MAC0_VTR_VL8             *((volatile unsigned char*)(0x42C803A0UL))
#define bFM_ETHERNET_MAC0_VTR_VL9             *((volatile unsigned char*)(0x42C803A4UL))
#define bFM_ETHERNET_MAC0_VTR_VL10            *((volatile unsigned char*)(0x42C803A8UL))
#define bFM_ETHERNET_MAC0_VTR_VL11            *((volatile unsigned char*)(0x42C803ACUL))
#define bFM_ETHERNET_MAC0_VTR_VL12            *((volatile unsigned char*)(0x42C803B0UL))
#define bFM_ETHERNET_MAC0_VTR_VL13            *((volatile unsigned char*)(0x42C803B4UL))
#define bFM_ETHERNET_MAC0_VTR_VL14            *((volatile unsigned char*)(0x42C803B8UL))
#define bFM_ETHERNET_MAC0_VTR_VL15            *((volatile unsigned char*)(0x42C803BCUL))
#define bFM_ETHERNET_MAC0_VTR_ETV             *((volatile unsigned char*)(0x42C803C0UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR0        *((volatile unsigned char*)(0x42C80500UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR1        *((volatile unsigned char*)(0x42C80504UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR2        *((volatile unsigned char*)(0x42C80508UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR3        *((volatile unsigned char*)(0x42C8050CUL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR4        *((volatile unsigned char*)(0x42C80510UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR5        *((volatile unsigned char*)(0x42C80514UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR6        *((volatile unsigned char*)(0x42C80518UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR7        *((volatile unsigned char*)(0x42C8051CUL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR8        *((volatile unsigned char*)(0x42C80520UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR9        *((volatile unsigned char*)(0x42C80524UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR10       *((volatile unsigned char*)(0x42C80528UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR11       *((volatile unsigned char*)(0x42C8052CUL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR12       *((volatile unsigned char*)(0x42C80530UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR13       *((volatile unsigned char*)(0x42C80534UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR14       *((volatile unsigned char*)(0x42C80538UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR15       *((volatile unsigned char*)(0x42C8053CUL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR16       *((volatile unsigned char*)(0x42C80540UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR17       *((volatile unsigned char*)(0x42C80544UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR18       *((volatile unsigned char*)(0x42C80548UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR19       *((volatile unsigned char*)(0x42C8054CUL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR20       *((volatile unsigned char*)(0x42C80550UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR21       *((volatile unsigned char*)(0x42C80554UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR22       *((volatile unsigned char*)(0x42C80558UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR23       *((volatile unsigned char*)(0x42C8055CUL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR24       *((volatile unsigned char*)(0x42C80560UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR25       *((volatile unsigned char*)(0x42C80564UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR26       *((volatile unsigned char*)(0x42C80568UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR27       *((volatile unsigned char*)(0x42C8056CUL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR28       *((volatile unsigned char*)(0x42C80570UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR29       *((volatile unsigned char*)(0x42C80574UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR30       *((volatile unsigned char*)(0x42C80578UL))
#define bFM_ETHERNET_MAC0_RWFFR_RWFFR31       *((volatile unsigned char*)(0x42C8057CUL))
#define bFM_ETHERNET_MAC0_PMTR_PD             *((volatile unsigned char*)(0x42C80580UL))
#define bFM_ETHERNET_MAC0_PMTR_MPE            *((volatile unsigned char*)(0x42C80584UL))
#define bFM_ETHERNET_MAC0_PMTR_WFE            *((volatile unsigned char*)(0x42C80588UL))
#define bFM_ETHERNET_MAC0_PMTR_MPR            *((volatile unsigned char*)(0x42C80594UL))
#define bFM_ETHERNET_MAC0_PMTR_WPR            *((volatile unsigned char*)(0x42C80598UL))
#define bFM_ETHERNET_MAC0_PMTR_GU             *((volatile unsigned char*)(0x42C805A4UL))
#define bFM_ETHERNET_MAC0_PMTR_RWFFRPR        *((volatile unsigned char*)(0x42C805FCUL))
#define bFM_ETHERNET_MAC0_LPICSR_TLPIEN       *((volatile unsigned char*)(0x42C80600UL))
#define bFM_ETHERNET_MAC0_LPICSR_TLPIEX       *((volatile unsigned char*)(0x42C80604UL))
#define bFM_ETHERNET_MAC0_LPICSR_RLPIEN       *((volatile unsigned char*)(0x42C80608UL))
#define bFM_ETHERNET_MAC0_LPICSR_RLPIEX       *((volatile unsigned char*)(0x42C8060CUL))
#define bFM_ETHERNET_MAC0_LPICSR_TLPIST       *((volatile unsigned char*)(0x42C80620UL))
#define bFM_ETHERNET_MAC0_LPICSR_RLPIST       *((volatile unsigned char*)(0x42C80624UL))
#define bFM_ETHERNET_MAC0_LPICSR_LPIEN        *((volatile unsigned char*)(0x42C80640UL))
#define bFM_ETHERNET_MAC0_LPICSR_PLS          *((volatile unsigned char*)(0x42C80644UL))
#define bFM_ETHERNET_MAC0_LPICSR_PLSEN        *((volatile unsigned char*)(0x42C80648UL))
#define bFM_ETHERNET_MAC0_LPICSR_LPITXA       *((volatile unsigned char*)(0x42C8064CUL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT0         *((volatile unsigned char*)(0x42C80680UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT1         *((volatile unsigned char*)(0x42C80684UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT2         *((volatile unsigned char*)(0x42C80688UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT3         *((volatile unsigned char*)(0x42C8068CUL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT4         *((volatile unsigned char*)(0x42C80690UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT5         *((volatile unsigned char*)(0x42C80694UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT6         *((volatile unsigned char*)(0x42C80698UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT7         *((volatile unsigned char*)(0x42C8069CUL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT8         *((volatile unsigned char*)(0x42C806A0UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT9         *((volatile unsigned char*)(0x42C806A4UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT10        *((volatile unsigned char*)(0x42C806A8UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT11        *((volatile unsigned char*)(0x42C806ACUL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT12        *((volatile unsigned char*)(0x42C806B0UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT13        *((volatile unsigned char*)(0x42C806B4UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT14        *((volatile unsigned char*)(0x42C806B8UL))
#define bFM_ETHERNET_MAC0_LPITCR_TWT15        *((volatile unsigned char*)(0x42C806BCUL))
#define bFM_ETHERNET_MAC0_LPITCR_LIT0         *((volatile unsigned char*)(0x42C806C0UL))
#define bFM_ETHERNET_MAC0_LPITCR_LIT1         *((volatile unsigned char*)(0x42C806C4UL))
#define bFM_ETHERNET_MAC0_LPITCR_LIT2         *((volatile unsigned char*)(0x42C806C8UL))
#define bFM_ETHERNET_MAC0_LPITCR_LIT3         *((volatile unsigned char*)(0x42C806CCUL))
#define bFM_ETHERNET_MAC0_LPITCR_LIT4         *((volatile unsigned char*)(0x42C806D0UL))
#define bFM_ETHERNET_MAC0_LPITCR_LIT5         *((volatile unsigned char*)(0x42C806D4UL))
#define bFM_ETHERNET_MAC0_LPITCR_LIT6         *((volatile unsigned char*)(0x42C806D8UL))
#define bFM_ETHERNET_MAC0_LPITCR_LIT7         *((volatile unsigned char*)(0x42C806DCUL))
#define bFM_ETHERNET_MAC0_LPITCR_LIT8         *((volatile unsigned char*)(0x42C806E0UL))
#define bFM_ETHERNET_MAC0_LPITCR_LIT9         *((volatile unsigned char*)(0x42C806E4UL))
#define bFM_ETHERNET_MAC0_ISR_RGIS            *((volatile unsigned char*)(0x42C80700UL))
#define bFM_ETHERNET_MAC0_ISR_PIS             *((volatile unsigned char*)(0x42C8070CUL))
#define bFM_ETHERNET_MAC0_ISR_MIS             *((volatile unsigned char*)(0x42C80710UL))
#define bFM_ETHERNET_MAC0_ISR_RIS             *((volatile unsigned char*)(0x42C80714UL))
#define bFM_ETHERNET_MAC0_ISR_TIS             *((volatile unsigned char*)(0x42C80718UL))
#define bFM_ETHERNET_MAC0_ISR_COIS            *((volatile unsigned char*)(0x42C8071CUL))
#define bFM_ETHERNET_MAC0_ISR_TSIS            *((volatile unsigned char*)(0x42C80724UL))
#define bFM_ETHERNET_MAC0_ISR_LPIIS           *((volatile unsigned char*)(0x42C80728UL))
#define bFM_ETHERNET_MAC0_IMR_RGIM            *((volatile unsigned char*)(0x42C80780UL))
#define bFM_ETHERNET_MAC0_IMR_PIM             *((volatile unsigned char*)(0x42C8078CUL))
#define bFM_ETHERNET_MAC0_IMR_TSIM            *((volatile unsigned char*)(0x42C807A4UL))
#define bFM_ETHERNET_MAC0_IMR_LPIIM           *((volatile unsigned char*)(0x42C807A8UL))
#define bFM_ETHERNET_MAC0_MAR0H_MO            *((volatile unsigned char*)(0x42C8087CUL))
#define bFM_ETHERNET_MAC0_MAR1H_MBC0          *((volatile unsigned char*)(0x42C80960UL))
#define bFM_ETHERNET_MAC0_MAR1H_MBC1          *((volatile unsigned char*)(0x42C80964UL))
#define bFM_ETHERNET_MAC0_MAR1H_MBC2          *((volatile unsigned char*)(0x42C80968UL))
#define bFM_ETHERNET_MAC0_MAR1H_MBC3          *((volatile unsigned char*)(0x42C8096CUL))
#define bFM_ETHERNET_MAC0_MAR1H_MBC4          *((volatile unsigned char*)(0x42C80970UL))
#define bFM_ETHERNET_MAC0_MAR1H_MBC5          *((volatile unsigned char*)(0x42C80974UL))
#define bFM_ETHERNET_MAC0_MAR1H_SA            *((volatile unsigned char*)(0x42C80978UL))
#define bFM_ETHERNET_MAC0_MAR2H_MBC0          *((volatile unsigned char*)(0x42C80A60UL))
#define bFM_ETHERNET_MAC0_MAR2H_MBC1          *((volatile unsigned char*)(0x42C80A64UL))
#define bFM_ETHERNET_MAC0_MAR2H_MBC2          *((volatile unsigned char*)(0x42C80A68UL))
#define bFM_ETHERNET_MAC0_MAR2H_MBC3          *((volatile unsigned char*)(0x42C80A6CUL))
#define bFM_ETHERNET_MAC0_MAR2H_MBC4          *((volatile unsigned char*)(0x42C80A70UL))
#define bFM_ETHERNET_MAC0_MAR2H_MBC5          *((volatile unsigned char*)(0x42C80A74UL))
#define bFM_ETHERNET_MAC0_MAR2H_SA            *((volatile unsigned char*)(0x42C80A78UL))
#define bFM_ETHERNET_MAC0_MAR3H_MBC0          *((volatile unsigned char*)(0x42C80B60UL))
#define bFM_ETHERNET_MAC0_MAR3H_MBC1          *((volatile unsigned char*)(0x42C80B64UL))
#define bFM_ETHERNET_MAC0_MAR3H_MBC2          *((volatile unsigned char*)(0x42C80B68UL))
#define bFM_ETHERNET_MAC0_MAR3H_MBC3          *((volatile unsigned char*)(0x42C80B6CUL))
#define bFM_ETHERNET_MAC0_MAR3H_MBC4          *((volatile unsigned char*)(0x42C80B70UL))
#define bFM_ETHERNET_MAC0_MAR3H_MBC5          *((volatile unsigned char*)(0x42C80B74UL))
#define bFM_ETHERNET_MAC0_MAR3H_SA            *((volatile unsigned char*)(0x42C80B78UL))
#define bFM_ETHERNET_MAC0_MAR4H_MBC0          *((volatile unsigned char*)(0x42C80C60UL))
#define bFM_ETHERNET_MAC0_MAR4H_MBC1          *((volatile unsigned char*)(0x42C80C64UL))
#define bFM_ETHERNET_MAC0_MAR4H_MBC2          *((volatile unsigned char*)(0x42C80C68UL))
#define bFM_ETHERNET_MAC0_MAR4H_MBC3          *((volatile unsigned char*)(0x42C80C6CUL))
#define bFM_ETHERNET_MAC0_MAR4H_MBC4          *((volatile unsigned char*)(0x42C80C70UL))
#define bFM_ETHERNET_MAC0_MAR4H_MBC5          *((volatile unsigned char*)(0x42C80C74UL))
#define bFM_ETHERNET_MAC0_MAR4H_SA            *((volatile unsigned char*)(0x42C80C78UL))
#define bFM_ETHERNET_MAC0_MAR5H_MBC0          *((volatile unsigned char*)(0x42C80D60UL))
#define bFM_ETHERNET_MAC0_MAR5H_MBC1          *((volatile unsigned char*)(0x42C80D64UL))
#define bFM_ETHERNET_MAC0_MAR5H_MBC2          *((volatile unsigned char*)(0x42C80D68UL))
#define bFM_ETHERNET_MAC0_MAR5H_MBC3          *((volatile unsigned char*)(0x42C80D6CUL))
#define bFM_ETHERNET_MAC0_MAR5H_MBC4          *((volatile unsigned char*)(0x42C80D70UL))
#define bFM_ETHERNET_MAC0_MAR5H_MBC5          *((volatile unsigned char*)(0x42C80D74UL))
#define bFM_ETHERNET_MAC0_MAR5H_SA            *((volatile unsigned char*)(0x42C80D78UL))
#define bFM_ETHERNET_MAC0_MAR6H_MBC0          *((volatile unsigned char*)(0x42C80E60UL))
#define bFM_ETHERNET_MAC0_MAR6H_MBC1          *((volatile unsigned char*)(0x42C80E64UL))
#define bFM_ETHERNET_MAC0_MAR6H_MBC2          *((volatile unsigned char*)(0x42C80E68UL))
#define bFM_ETHERNET_MAC0_MAR6H_MBC3          *((volatile unsigned char*)(0x42C80E6CUL))
#define bFM_ETHERNET_MAC0_MAR6H_MBC4          *((volatile unsigned char*)(0x42C80E70UL))
#define bFM_ETHERNET_MAC0_MAR6H_MBC5          *((volatile unsigned char*)(0x42C80E74UL))
#define bFM_ETHERNET_MAC0_MAR6H_SA            *((volatile unsigned char*)(0x42C80E78UL))
#define bFM_ETHERNET_MAC0_MAR7H_MBC0          *((volatile unsigned char*)(0x42C80F60UL))
#define bFM_ETHERNET_MAC0_MAR7H_MBC1          *((volatile unsigned char*)(0x42C80F64UL))
#define bFM_ETHERNET_MAC0_MAR7H_MBC2          *((volatile unsigned char*)(0x42C80F68UL))
#define bFM_ETHERNET_MAC0_MAR7H_MBC3          *((volatile unsigned char*)(0x42C80F6CUL))
#define bFM_ETHERNET_MAC0_MAR7H_MBC4          *((volatile unsigned char*)(0x42C80F70UL))
#define bFM_ETHERNET_MAC0_MAR7H_MBC5          *((volatile unsigned char*)(0x42C80F74UL))
#define bFM_ETHERNET_MAC0_MAR7H_SA            *((volatile unsigned char*)(0x42C80F78UL))
#define bFM_ETHERNET_MAC0_MAR8H_MBC0          *((volatile unsigned char*)(0x42C81060UL))
#define bFM_ETHERNET_MAC0_MAR8H_MBC1          *((volatile unsigned char*)(0x42C81064UL))
#define bFM_ETHERNET_MAC0_MAR8H_MBC2          *((volatile unsigned char*)(0x42C81068UL))
#define bFM_ETHERNET_MAC0_MAR8H_MBC3          *((volatile unsigned char*)(0x42C8106CUL))
#define bFM_ETHERNET_MAC0_MAR8H_MBC4          *((volatile unsigned char*)(0x42C81070UL))
#define bFM_ETHERNET_MAC0_MAR8H_MBC5          *((volatile unsigned char*)(0x42C81074UL))
#define bFM_ETHERNET_MAC0_MAR8H_SA            *((volatile unsigned char*)(0x42C81078UL))
#define bFM_ETHERNET_MAC0_MAR9H_MBC0          *((volatile unsigned char*)(0x42C81160UL))
#define bFM_ETHERNET_MAC0_MAR9H_MBC1          *((volatile unsigned char*)(0x42C81164UL))
#define bFM_ETHERNET_MAC0_MAR9H_MBC2          *((volatile unsigned char*)(0x42C81168UL))
#define bFM_ETHERNET_MAC0_MAR9H_MBC3          *((volatile unsigned char*)(0x42C8116CUL))
#define bFM_ETHERNET_MAC0_MAR9H_MBC4          *((volatile unsigned char*)(0x42C81170UL))
#define bFM_ETHERNET_MAC0_MAR9H_MBC5          *((volatile unsigned char*)(0x42C81174UL))
#define bFM_ETHERNET_MAC0_MAR9H_SA            *((volatile unsigned char*)(0x42C81178UL))
#define bFM_ETHERNET_MAC0_MAR10H_MBC0         *((volatile unsigned char*)(0x42C81260UL))
#define bFM_ETHERNET_MAC0_MAR10H_MBC1         *((volatile unsigned char*)(0x42C81264UL))
#define bFM_ETHERNET_MAC0_MAR10H_MBC2         *((volatile unsigned char*)(0x42C81268UL))
#define bFM_ETHERNET_MAC0_MAR10H_MBC3         *((volatile unsigned char*)(0x42C8126CUL))
#define bFM_ETHERNET_MAC0_MAR10H_MBC4         *((volatile unsigned char*)(0x42C81270UL))
#define bFM_ETHERNET_MAC0_MAR10H_MBC5         *((volatile unsigned char*)(0x42C81274UL))
#define bFM_ETHERNET_MAC0_MAR10H_SA           *((volatile unsigned char*)(0x42C81278UL))
#define bFM_ETHERNET_MAC0_MAR11H_MBC0         *((volatile unsigned char*)(0x42C81360UL))
#define bFM_ETHERNET_MAC0_MAR11H_MBC1         *((volatile unsigned char*)(0x42C81364UL))
#define bFM_ETHERNET_MAC0_MAR11H_MBC2         *((volatile unsigned char*)(0x42C81368UL))
#define bFM_ETHERNET_MAC0_MAR11H_MBC3         *((volatile unsigned char*)(0x42C8136CUL))
#define bFM_ETHERNET_MAC0_MAR11H_MBC4         *((volatile unsigned char*)(0x42C81370UL))
#define bFM_ETHERNET_MAC0_MAR11H_MBC5         *((volatile unsigned char*)(0x42C81374UL))
#define bFM_ETHERNET_MAC0_MAR11H_SA           *((volatile unsigned char*)(0x42C81378UL))
#define bFM_ETHERNET_MAC0_MAR12H_MBC0         *((volatile unsigned char*)(0x42C81460UL))
#define bFM_ETHERNET_MAC0_MAR12H_MBC1         *((volatile unsigned char*)(0x42C81464UL))
#define bFM_ETHERNET_MAC0_MAR12H_MBC2         *((volatile unsigned char*)(0x42C81468UL))
#define bFM_ETHERNET_MAC0_MAR12H_MBC3         *((volatile unsigned char*)(0x42C8146CUL))
#define bFM_ETHERNET_MAC0_MAR12H_MBC4         *((volatile unsigned char*)(0x42C81470UL))
#define bFM_ETHERNET_MAC0_MAR12H_MBC5         *((volatile unsigned char*)(0x42C81474UL))
#define bFM_ETHERNET_MAC0_MAR12H_SA           *((volatile unsigned char*)(0x42C81478UL))
#define bFM_ETHERNET_MAC0_MAR13H_MBC0         *((volatile unsigned char*)(0x42C81560UL))
#define bFM_ETHERNET_MAC0_MAR13H_MBC1         *((volatile unsigned char*)(0x42C81564UL))
#define bFM_ETHERNET_MAC0_MAR13H_MBC2         *((volatile unsigned char*)(0x42C81568UL))
#define bFM_ETHERNET_MAC0_MAR13H_MBC3         *((volatile unsigned char*)(0x42C8156CUL))
#define bFM_ETHERNET_MAC0_MAR13H_MBC4         *((volatile unsigned char*)(0x42C81570UL))
#define bFM_ETHERNET_MAC0_MAR13H_MBC5         *((volatile unsigned char*)(0x42C81574UL))
#define bFM_ETHERNET_MAC0_MAR13H_SA           *((volatile unsigned char*)(0x42C81578UL))
#define bFM_ETHERNET_MAC0_MAR14H_MBC0         *((volatile unsigned char*)(0x42C81660UL))
#define bFM_ETHERNET_MAC0_MAR14H_MBC1         *((volatile unsigned char*)(0x42C81664UL))
#define bFM_ETHERNET_MAC0_MAR14H_MBC2         *((volatile unsigned char*)(0x42C81668UL))
#define bFM_ETHERNET_MAC0_MAR14H_MBC3         *((volatile unsigned char*)(0x42C8166CUL))
#define bFM_ETHERNET_MAC0_MAR14H_MBC4         *((volatile unsigned char*)(0x42C81670UL))
#define bFM_ETHERNET_MAC0_MAR14H_MBC5         *((volatile unsigned char*)(0x42C81674UL))
#define bFM_ETHERNET_MAC0_MAR14H_SA           *((volatile unsigned char*)(0x42C81678UL))
#define bFM_ETHERNET_MAC0_MAR15H_MBC0         *((volatile unsigned char*)(0x42C81760UL))
#define bFM_ETHERNET_MAC0_MAR15H_MBC1         *((volatile unsigned char*)(0x42C81764UL))
#define bFM_ETHERNET_MAC0_MAR15H_MBC2         *((volatile unsigned char*)(0x42C81768UL))
#define bFM_ETHERNET_MAC0_MAR15H_MBC3         *((volatile unsigned char*)(0x42C8176CUL))
#define bFM_ETHERNET_MAC0_MAR15H_MBC4         *((volatile unsigned char*)(0x42C81770UL))
#define bFM_ETHERNET_MAC0_MAR15H_MBC5         *((volatile unsigned char*)(0x42C81774UL))
#define bFM_ETHERNET_MAC0_MAR15H_SA           *((volatile unsigned char*)(0x42C81778UL))
#define bFM_ETHERNET_MAC0_RGSR_LM             *((volatile unsigned char*)(0x42C81B00UL))
#define bFM_ETHERNET_MAC0_RGSR_LSP0           *((volatile unsigned char*)(0x42C81B04UL))
#define bFM_ETHERNET_MAC0_RGSR_LSP1           *((volatile unsigned char*)(0x42C81B08UL))
#define bFM_ETHERNET_MAC0_RGSR_LS             *((volatile unsigned char*)(0x42C81B0CUL))
#define bFM_ETHERNET_MAC0_TSCR_TSE            *((volatile unsigned char*)(0x42C8E000UL))
#define bFM_ETHERNET_MAC0_TSCR_TFCU           *((volatile unsigned char*)(0x42C8E004UL))
#define bFM_ETHERNET_MAC0_TSCR_TSI            *((volatile unsigned char*)(0x42C8E008UL))
#define bFM_ETHERNET_MAC0_TSCR_TSU            *((volatile unsigned char*)(0x42C8E00CUL))
#define bFM_ETHERNET_MAC0_TSCR_TITE           *((volatile unsigned char*)(0x42C8E010UL))
#define bFM_ETHERNET_MAC0_TSCR_TARU           *((volatile unsigned char*)(0x42C8E014UL))
#define bFM_ETHERNET_MAC0_TSCR_TSEA           *((volatile unsigned char*)(0x42C8E020UL))
#define bFM_ETHERNET_MAC0_TSCR_TSDB           *((volatile unsigned char*)(0x42C8E024UL))
#define bFM_ETHERNET_MAC0_TSCR_TSV2E          *((volatile unsigned char*)(0x42C8E028UL))
#define bFM_ETHERNET_MAC0_TSCR_TETSP          *((volatile unsigned char*)(0x42C8E02CUL))
#define bFM_ETHERNET_MAC0_TSCR_TSIP6E         *((volatile unsigned char*)(0x42C8E030UL))
#define bFM_ETHERNET_MAC0_TSCR_TSIP4E         *((volatile unsigned char*)(0x42C8E034UL))
#define bFM_ETHERNET_MAC0_TSCR_TETSEM         *((volatile unsigned char*)(0x42C8E038UL))
#define bFM_ETHERNET_MAC0_TSCR_TSMRM          *((volatile unsigned char*)(0x42C8E03CUL))
#define bFM_ETHERNET_MAC0_TSCR_TSPS0          *((volatile unsigned char*)(0x42C8E040UL))
#define bFM_ETHERNET_MAC0_TSCR_TSPS1          *((volatile unsigned char*)(0x42C8E044UL))
#define bFM_ETHERNET_MAC0_TSCR_TSENMF         *((volatile unsigned char*)(0x42C8E048UL))
#define bFM_ETHERNET_MAC0_TSCR_ATSFC          *((volatile unsigned char*)(0x42C8E060UL))
#define bFM_ETHERNET_MAC0_SSIR_SSINC0         *((volatile unsigned char*)(0x42C8E080UL))
#define bFM_ETHERNET_MAC0_SSIR_SSINC1         *((volatile unsigned char*)(0x42C8E084UL))
#define bFM_ETHERNET_MAC0_SSIR_SSINC2         *((volatile unsigned char*)(0x42C8E088UL))
#define bFM_ETHERNET_MAC0_SSIR_SSINC3         *((volatile unsigned char*)(0x42C8E08CUL))
#define bFM_ETHERNET_MAC0_SSIR_SSINC4         *((volatile unsigned char*)(0x42C8E090UL))
#define bFM_ETHERNET_MAC0_SSIR_SSINC5         *((volatile unsigned char*)(0x42C8E094UL))
#define bFM_ETHERNET_MAC0_SSIR_SSINC6         *((volatile unsigned char*)(0x42C8E098UL))
#define bFM_ETHERNET_MAC0_SSIR_SSINC7         *((volatile unsigned char*)(0x42C8E09CUL))
#define bFM_ETHERNET_MAC0_STSR_TSS0           *((volatile unsigned char*)(0x42C8E100UL))
#define bFM_ETHERNET_MAC0_STSR_TSS1           *((volatile unsigned char*)(0x42C8E104UL))
#define bFM_ETHERNET_MAC0_STSR_TSS2           *((volatile unsigned char*)(0x42C8E108UL))
#define bFM_ETHERNET_MAC0_STSR_TSS3           *((volatile unsigned char*)(0x42C8E10CUL))
#define bFM_ETHERNET_MAC0_STSR_TSS4           *((volatile unsigned char*)(0x42C8E110UL))
#define bFM_ETHERNET_MAC0_STSR_TSS5           *((volatile unsigned char*)(0x42C8E114UL))
#define bFM_ETHERNET_MAC0_STSR_TSS6           *((volatile unsigned char*)(0x42C8E118UL))
#define bFM_ETHERNET_MAC0_STSR_TSS7           *((volatile unsigned char*)(0x42C8E11CUL))
#define bFM_ETHERNET_MAC0_STSR_TSS8           *((volatile unsigned char*)(0x42C8E120UL))
#define bFM_ETHERNET_MAC0_STSR_TSS9           *((volatile unsigned char*)(0x42C8E124UL))
#define bFM_ETHERNET_MAC0_STSR_TSS10          *((volatile unsigned char*)(0x42C8E128UL))
#define bFM_ETHERNET_MAC0_STSR_TSS11          *((volatile unsigned char*)(0x42C8E12CUL))
#define bFM_ETHERNET_MAC0_STSR_TSS12          *((volatile unsigned char*)(0x42C8E130UL))
#define bFM_ETHERNET_MAC0_STSR_TSS13          *((volatile unsigned char*)(0x42C8E134UL))
#define bFM_ETHERNET_MAC0_STSR_TSS14          *((volatile unsigned char*)(0x42C8E138UL))
#define bFM_ETHERNET_MAC0_STSR_TSS15          *((volatile unsigned char*)(0x42C8E13CUL))
#define bFM_ETHERNET_MAC0_STSR_TSS16          *((volatile unsigned char*)(0x42C8E140UL))
#define bFM_ETHERNET_MAC0_STSR_TSS17          *((volatile unsigned char*)(0x42C8E144UL))
#define bFM_ETHERNET_MAC0_STSR_TSS18          *((volatile unsigned char*)(0x42C8E148UL))
#define bFM_ETHERNET_MAC0_STSR_TSS19          *((volatile unsigned char*)(0x42C8E14CUL))
#define bFM_ETHERNET_MAC0_STSR_TSS20          *((volatile unsigned char*)(0x42C8E150UL))
#define bFM_ETHERNET_MAC0_STSR_TSS21          *((volatile unsigned char*)(0x42C8E154UL))
#define bFM_ETHERNET_MAC0_STSR_TSS22          *((volatile unsigned char*)(0x42C8E158UL))
#define bFM_ETHERNET_MAC0_STSR_TSS23          *((volatile unsigned char*)(0x42C8E15CUL))
#define bFM_ETHERNET_MAC0_STSR_TSS24          *((volatile unsigned char*)(0x42C8E160UL))
#define bFM_ETHERNET_MAC0_STSR_TSS25          *((volatile unsigned char*)(0x42C8E164UL))
#define bFM_ETHERNET_MAC0_STSR_TSS26          *((volatile unsigned char*)(0x42C8E168UL))
#define bFM_ETHERNET_MAC0_STSR_TSS27          *((volatile unsigned char*)(0x42C8E16CUL))
#define bFM_ETHERNET_MAC0_STSR_TSS28          *((volatile unsigned char*)(0x42C8E170UL))
#define bFM_ETHERNET_MAC0_STSR_TSS29          *((volatile unsigned char*)(0x42C8E174UL))
#define bFM_ETHERNET_MAC0_STSR_TSS30          *((volatile unsigned char*)(0x42C8E178UL))
#define bFM_ETHERNET_MAC0_STSR_TSS31          *((volatile unsigned char*)(0x42C8E17CUL))
#define bFM_ETHERNET_MAC0_STNR_TSSS0          *((volatile unsigned char*)(0x42C8E180UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS1          *((volatile unsigned char*)(0x42C8E184UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS2          *((volatile unsigned char*)(0x42C8E188UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS3          *((volatile unsigned char*)(0x42C8E18CUL))
#define bFM_ETHERNET_MAC0_STNR_TSSS4          *((volatile unsigned char*)(0x42C8E190UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS5          *((volatile unsigned char*)(0x42C8E194UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS6          *((volatile unsigned char*)(0x42C8E198UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS7          *((volatile unsigned char*)(0x42C8E19CUL))
#define bFM_ETHERNET_MAC0_STNR_TSSS8          *((volatile unsigned char*)(0x42C8E1A0UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS9          *((volatile unsigned char*)(0x42C8E1A4UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS10         *((volatile unsigned char*)(0x42C8E1A8UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS11         *((volatile unsigned char*)(0x42C8E1ACUL))
#define bFM_ETHERNET_MAC0_STNR_TSSS12         *((volatile unsigned char*)(0x42C8E1B0UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS13         *((volatile unsigned char*)(0x42C8E1B4UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS14         *((volatile unsigned char*)(0x42C8E1B8UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS15         *((volatile unsigned char*)(0x42C8E1BCUL))
#define bFM_ETHERNET_MAC0_STNR_TSSS16         *((volatile unsigned char*)(0x42C8E1C0UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS17         *((volatile unsigned char*)(0x42C8E1C4UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS18         *((volatile unsigned char*)(0x42C8E1C8UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS19         *((volatile unsigned char*)(0x42C8E1CCUL))
#define bFM_ETHERNET_MAC0_STNR_TSSS20         *((volatile unsigned char*)(0x42C8E1D0UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS21         *((volatile unsigned char*)(0x42C8E1D4UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS22         *((volatile unsigned char*)(0x42C8E1D8UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS23         *((volatile unsigned char*)(0x42C8E1DCUL))
#define bFM_ETHERNET_MAC0_STNR_TSSS24         *((volatile unsigned char*)(0x42C8E1E0UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS25         *((volatile unsigned char*)(0x42C8E1E4UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS26         *((volatile unsigned char*)(0x42C8E1E8UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS27         *((volatile unsigned char*)(0x42C8E1ECUL))
#define bFM_ETHERNET_MAC0_STNR_TSSS28         *((volatile unsigned char*)(0x42C8E1F0UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS29         *((volatile unsigned char*)(0x42C8E1F4UL))
#define bFM_ETHERNET_MAC0_STNR_TSSS30         *((volatile unsigned char*)(0x42C8E1F8UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS0          *((volatile unsigned char*)(0x42C8E200UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS1          *((volatile unsigned char*)(0x42C8E204UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS2          *((volatile unsigned char*)(0x42C8E208UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS3          *((volatile unsigned char*)(0x42C8E20CUL))
#define bFM_ETHERNET_MAC0_STSUR_TSS4          *((volatile unsigned char*)(0x42C8E210UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS5          *((volatile unsigned char*)(0x42C8E214UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS6          *((volatile unsigned char*)(0x42C8E218UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS7          *((volatile unsigned char*)(0x42C8E21CUL))
#define bFM_ETHERNET_MAC0_STSUR_TSS8          *((volatile unsigned char*)(0x42C8E220UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS9          *((volatile unsigned char*)(0x42C8E224UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS10         *((volatile unsigned char*)(0x42C8E228UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS11         *((volatile unsigned char*)(0x42C8E22CUL))
#define bFM_ETHERNET_MAC0_STSUR_TSS12         *((volatile unsigned char*)(0x42C8E230UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS13         *((volatile unsigned char*)(0x42C8E234UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS14         *((volatile unsigned char*)(0x42C8E238UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS15         *((volatile unsigned char*)(0x42C8E23CUL))
#define bFM_ETHERNET_MAC0_STSUR_TSS16         *((volatile unsigned char*)(0x42C8E240UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS17         *((volatile unsigned char*)(0x42C8E244UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS18         *((volatile unsigned char*)(0x42C8E248UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS19         *((volatile unsigned char*)(0x42C8E24CUL))
#define bFM_ETHERNET_MAC0_STSUR_TSS20         *((volatile unsigned char*)(0x42C8E250UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS21         *((volatile unsigned char*)(0x42C8E254UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS22         *((volatile unsigned char*)(0x42C8E258UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS23         *((volatile unsigned char*)(0x42C8E25CUL))
#define bFM_ETHERNET_MAC0_STSUR_TSS24         *((volatile unsigned char*)(0x42C8E260UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS25         *((volatile unsigned char*)(0x42C8E264UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS26         *((volatile unsigned char*)(0x42C8E268UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS27         *((volatile unsigned char*)(0x42C8E26CUL))
#define bFM_ETHERNET_MAC0_STSUR_TSS28         *((volatile unsigned char*)(0x42C8E270UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS29         *((volatile unsigned char*)(0x42C8E274UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS30         *((volatile unsigned char*)(0x42C8E278UL))
#define bFM_ETHERNET_MAC0_STSUR_TSS31         *((volatile unsigned char*)(0x42C8E27CUL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS0         *((volatile unsigned char*)(0x42C8E280UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS1         *((volatile unsigned char*)(0x42C8E284UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS2         *((volatile unsigned char*)(0x42C8E288UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS3         *((volatile unsigned char*)(0x42C8E28CUL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS4         *((volatile unsigned char*)(0x42C8E290UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS5         *((volatile unsigned char*)(0x42C8E294UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS6         *((volatile unsigned char*)(0x42C8E298UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS7         *((volatile unsigned char*)(0x42C8E29CUL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS8         *((volatile unsigned char*)(0x42C8E2A0UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS9         *((volatile unsigned char*)(0x42C8E2A4UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS10        *((volatile unsigned char*)(0x42C8E2A8UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS11        *((volatile unsigned char*)(0x42C8E2ACUL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS12        *((volatile unsigned char*)(0x42C8E2B0UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS13        *((volatile unsigned char*)(0x42C8E2B4UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS14        *((volatile unsigned char*)(0x42C8E2B8UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS15        *((volatile unsigned char*)(0x42C8E2BCUL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS16        *((volatile unsigned char*)(0x42C8E2C0UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS17        *((volatile unsigned char*)(0x42C8E2C4UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS18        *((volatile unsigned char*)(0x42C8E2C8UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS19        *((volatile unsigned char*)(0x42C8E2CCUL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS20        *((volatile unsigned char*)(0x42C8E2D0UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS21        *((volatile unsigned char*)(0x42C8E2D4UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS22        *((volatile unsigned char*)(0x42C8E2D8UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS23        *((volatile unsigned char*)(0x42C8E2DCUL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS24        *((volatile unsigned char*)(0x42C8E2E0UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS25        *((volatile unsigned char*)(0x42C8E2E4UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS26        *((volatile unsigned char*)(0x42C8E2E8UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS27        *((volatile unsigned char*)(0x42C8E2ECUL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS28        *((volatile unsigned char*)(0x42C8E2F0UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS29        *((volatile unsigned char*)(0x42C8E2F4UL))
#define bFM_ETHERNET_MAC0_STNUR_TSSS30        *((volatile unsigned char*)(0x42C8E2F8UL))
#define bFM_ETHERNET_MAC0_STNUR_ADDSUB        *((volatile unsigned char*)(0x42C8E2FCUL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR0          *((volatile unsigned char*)(0x42C8E300UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR1          *((volatile unsigned char*)(0x42C8E304UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR2          *((volatile unsigned char*)(0x42C8E308UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR3          *((volatile unsigned char*)(0x42C8E30CUL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR4          *((volatile unsigned char*)(0x42C8E310UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR5          *((volatile unsigned char*)(0x42C8E314UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR6          *((volatile unsigned char*)(0x42C8E318UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR7          *((volatile unsigned char*)(0x42C8E31CUL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR8          *((volatile unsigned char*)(0x42C8E320UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR9          *((volatile unsigned char*)(0x42C8E324UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR10         *((volatile unsigned char*)(0x42C8E328UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR11         *((volatile unsigned char*)(0x42C8E32CUL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR12         *((volatile unsigned char*)(0x42C8E330UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR13         *((volatile unsigned char*)(0x42C8E334UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR14         *((volatile unsigned char*)(0x42C8E338UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR15         *((volatile unsigned char*)(0x42C8E33CUL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR16         *((volatile unsigned char*)(0x42C8E340UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR17         *((volatile unsigned char*)(0x42C8E344UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR18         *((volatile unsigned char*)(0x42C8E348UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR19         *((volatile unsigned char*)(0x42C8E34CUL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR20         *((volatile unsigned char*)(0x42C8E350UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR21         *((volatile unsigned char*)(0x42C8E354UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR22         *((volatile unsigned char*)(0x42C8E358UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR23         *((volatile unsigned char*)(0x42C8E35CUL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR24         *((volatile unsigned char*)(0x42C8E360UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR25         *((volatile unsigned char*)(0x42C8E364UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR26         *((volatile unsigned char*)(0x42C8E368UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR27         *((volatile unsigned char*)(0x42C8E36CUL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR28         *((volatile unsigned char*)(0x42C8E370UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR29         *((volatile unsigned char*)(0x42C8E374UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR30         *((volatile unsigned char*)(0x42C8E378UL))
#define bFM_ETHERNET_MAC0_TSAR_TSAR31         *((volatile unsigned char*)(0x42C8E37CUL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR0          *((volatile unsigned char*)(0x42C8E380UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR1          *((volatile unsigned char*)(0x42C8E384UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR2          *((volatile unsigned char*)(0x42C8E388UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR3          *((volatile unsigned char*)(0x42C8E38CUL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR4          *((volatile unsigned char*)(0x42C8E390UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR5          *((volatile unsigned char*)(0x42C8E394UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR6          *((volatile unsigned char*)(0x42C8E398UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR7          *((volatile unsigned char*)(0x42C8E39CUL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR8          *((volatile unsigned char*)(0x42C8E3A0UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR9          *((volatile unsigned char*)(0x42C8E3A4UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR10         *((volatile unsigned char*)(0x42C8E3A8UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR11         *((volatile unsigned char*)(0x42C8E3ACUL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR12         *((volatile unsigned char*)(0x42C8E3B0UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR13         *((volatile unsigned char*)(0x42C8E3B4UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR14         *((volatile unsigned char*)(0x42C8E3B8UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR15         *((volatile unsigned char*)(0x42C8E3BCUL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR16         *((volatile unsigned char*)(0x42C8E3C0UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR17         *((volatile unsigned char*)(0x42C8E3C4UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR18         *((volatile unsigned char*)(0x42C8E3C8UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR19         *((volatile unsigned char*)(0x42C8E3CCUL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR20         *((volatile unsigned char*)(0x42C8E3D0UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR21         *((volatile unsigned char*)(0x42C8E3D4UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR22         *((volatile unsigned char*)(0x42C8E3D8UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR23         *((volatile unsigned char*)(0x42C8E3DCUL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR24         *((volatile unsigned char*)(0x42C8E3E0UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR25         *((volatile unsigned char*)(0x42C8E3E4UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR26         *((volatile unsigned char*)(0x42C8E3E8UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR27         *((volatile unsigned char*)(0x42C8E3ECUL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR28         *((volatile unsigned char*)(0x42C8E3F0UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR29         *((volatile unsigned char*)(0x42C8E3F4UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR30         *((volatile unsigned char*)(0x42C8E3F8UL))
#define bFM_ETHERNET_MAC0_TTSR_TSTR31         *((volatile unsigned char*)(0x42C8E3FCUL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR0          *((volatile unsigned char*)(0x42C8E400UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR1          *((volatile unsigned char*)(0x42C8E404UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR2          *((volatile unsigned char*)(0x42C8E408UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR3          *((volatile unsigned char*)(0x42C8E40CUL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR4          *((volatile unsigned char*)(0x42C8E410UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR5          *((volatile unsigned char*)(0x42C8E414UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR6          *((volatile unsigned char*)(0x42C8E418UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR7          *((volatile unsigned char*)(0x42C8E41CUL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR8          *((volatile unsigned char*)(0x42C8E420UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR9          *((volatile unsigned char*)(0x42C8E424UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR10         *((volatile unsigned char*)(0x42C8E428UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR11         *((volatile unsigned char*)(0x42C8E42CUL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR12         *((volatile unsigned char*)(0x42C8E430UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR13         *((volatile unsigned char*)(0x42C8E434UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR14         *((volatile unsigned char*)(0x42C8E438UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR15         *((volatile unsigned char*)(0x42C8E43CUL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR16         *((volatile unsigned char*)(0x42C8E440UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR17         *((volatile unsigned char*)(0x42C8E444UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR18         *((volatile unsigned char*)(0x42C8E448UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR19         *((volatile unsigned char*)(0x42C8E44CUL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR20         *((volatile unsigned char*)(0x42C8E450UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR21         *((volatile unsigned char*)(0x42C8E454UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR22         *((volatile unsigned char*)(0x42C8E458UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR23         *((volatile unsigned char*)(0x42C8E45CUL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR24         *((volatile unsigned char*)(0x42C8E460UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR25         *((volatile unsigned char*)(0x42C8E464UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR26         *((volatile unsigned char*)(0x42C8E468UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR27         *((volatile unsigned char*)(0x42C8E46CUL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR28         *((volatile unsigned char*)(0x42C8E470UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR29         *((volatile unsigned char*)(0x42C8E474UL))
#define bFM_ETHERNET_MAC0_TTNR_TSTR30         *((volatile unsigned char*)(0x42C8E478UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR0       *((volatile unsigned char*)(0x42C8E480UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR1       *((volatile unsigned char*)(0x42C8E484UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR2       *((volatile unsigned char*)(0x42C8E488UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR3       *((volatile unsigned char*)(0x42C8E48CUL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR4       *((volatile unsigned char*)(0x42C8E490UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR5       *((volatile unsigned char*)(0x42C8E494UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR6       *((volatile unsigned char*)(0x42C8E498UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR7       *((volatile unsigned char*)(0x42C8E49CUL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR8       *((volatile unsigned char*)(0x42C8E4A0UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR9       *((volatile unsigned char*)(0x42C8E4A4UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR10      *((volatile unsigned char*)(0x42C8E4A8UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR11      *((volatile unsigned char*)(0x42C8E4ACUL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR12      *((volatile unsigned char*)(0x42C8E4B0UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR13      *((volatile unsigned char*)(0x42C8E4B4UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR14      *((volatile unsigned char*)(0x42C8E4B8UL))
#define bFM_ETHERNET_MAC0_STHWSR_TSHWR15      *((volatile unsigned char*)(0x42C8E4BCUL))
#define bFM_ETHERNET_MAC0_TSR_TSSOVF          *((volatile unsigned char*)(0x42C8E500UL))
#define bFM_ETHERNET_MAC0_TSR_TSTART          *((volatile unsigned char*)(0x42C8E504UL))
#define bFM_ETHERNET_MAC0_TSR_ATSTS           *((volatile unsigned char*)(0x42C8E508UL))
#define bFM_ETHERNET_MAC0_TSR_TRGTER          *((volatile unsigned char*)(0x42C8E50CUL))
#define bFM_ETHERNET_MAC0_TSR_ATSSTM          *((volatile unsigned char*)(0x42C8E560UL))
#define bFM_ETHERNET_MAC0_TSR_ATSNS0          *((volatile unsigned char*)(0x42C8E564UL))
#define bFM_ETHERNET_MAC0_TSR_ATSNS1          *((volatile unsigned char*)(0x42C8E568UL))
#define bFM_ETHERNET_MAC0_TSR_ATSNS2          *((volatile unsigned char*)(0x42C8E56CUL))
#define bFM_ETHERNET_MAC0_PPSCR_PPSCTRL0      *((volatile unsigned char*)(0x42C8E580UL))
#define bFM_ETHERNET_MAC0_PPSCR_PPSCTRL1      *((volatile unsigned char*)(0x42C8E584UL))
#define bFM_ETHERNET_MAC0_PPSCR_PPSCTRL2      *((volatile unsigned char*)(0x42C8E588UL))
#define bFM_ETHERNET_MAC0_PPSCR_PPSCTRL3      *((volatile unsigned char*)(0x42C8E58CUL))
#define bFM_ETHERNET_MAC0_ATNR_ATN0           *((volatile unsigned char*)(0x42C8E600UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN1           *((volatile unsigned char*)(0x42C8E604UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN2           *((volatile unsigned char*)(0x42C8E608UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN3           *((volatile unsigned char*)(0x42C8E60CUL))
#define bFM_ETHERNET_MAC0_ATNR_ATN4           *((volatile unsigned char*)(0x42C8E610UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN5           *((volatile unsigned char*)(0x42C8E614UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN6           *((volatile unsigned char*)(0x42C8E618UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN7           *((volatile unsigned char*)(0x42C8E61CUL))
#define bFM_ETHERNET_MAC0_ATNR_ATN8           *((volatile unsigned char*)(0x42C8E620UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN9           *((volatile unsigned char*)(0x42C8E624UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN10          *((volatile unsigned char*)(0x42C8E628UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN11          *((volatile unsigned char*)(0x42C8E62CUL))
#define bFM_ETHERNET_MAC0_ATNR_ATN12          *((volatile unsigned char*)(0x42C8E630UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN13          *((volatile unsigned char*)(0x42C8E634UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN14          *((volatile unsigned char*)(0x42C8E638UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN15          *((volatile unsigned char*)(0x42C8E63CUL))
#define bFM_ETHERNET_MAC0_ATNR_ATN16          *((volatile unsigned char*)(0x42C8E640UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN17          *((volatile unsigned char*)(0x42C8E644UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN18          *((volatile unsigned char*)(0x42C8E648UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN19          *((volatile unsigned char*)(0x42C8E64CUL))
#define bFM_ETHERNET_MAC0_ATNR_ATN20          *((volatile unsigned char*)(0x42C8E650UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN21          *((volatile unsigned char*)(0x42C8E654UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN22          *((volatile unsigned char*)(0x42C8E658UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN23          *((volatile unsigned char*)(0x42C8E65CUL))
#define bFM_ETHERNET_MAC0_ATNR_ATN24          *((volatile unsigned char*)(0x42C8E660UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN25          *((volatile unsigned char*)(0x42C8E664UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN26          *((volatile unsigned char*)(0x42C8E668UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN27          *((volatile unsigned char*)(0x42C8E66CUL))
#define bFM_ETHERNET_MAC0_ATNR_ATN28          *((volatile unsigned char*)(0x42C8E670UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN29          *((volatile unsigned char*)(0x42C8E674UL))
#define bFM_ETHERNET_MAC0_ATNR_ATN30          *((volatile unsigned char*)(0x42C8E678UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS0           *((volatile unsigned char*)(0x42C8E680UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS1           *((volatile unsigned char*)(0x42C8E684UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS2           *((volatile unsigned char*)(0x42C8E688UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS3           *((volatile unsigned char*)(0x42C8E68CUL))
#define bFM_ETHERNET_MAC0_ATSR_ATS4           *((volatile unsigned char*)(0x42C8E690UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS5           *((volatile unsigned char*)(0x42C8E694UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS6           *((volatile unsigned char*)(0x42C8E698UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS7           *((volatile unsigned char*)(0x42C8E69CUL))
#define bFM_ETHERNET_MAC0_ATSR_ATS8           *((volatile unsigned char*)(0x42C8E6A0UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS9           *((volatile unsigned char*)(0x42C8E6A4UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS10          *((volatile unsigned char*)(0x42C8E6A8UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS11          *((volatile unsigned char*)(0x42C8E6ACUL))
#define bFM_ETHERNET_MAC0_ATSR_ATS12          *((volatile unsigned char*)(0x42C8E6B0UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS13          *((volatile unsigned char*)(0x42C8E6B4UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS14          *((volatile unsigned char*)(0x42C8E6B8UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS15          *((volatile unsigned char*)(0x42C8E6BCUL))
#define bFM_ETHERNET_MAC0_ATSR_ATS16          *((volatile unsigned char*)(0x42C8E6C0UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS17          *((volatile unsigned char*)(0x42C8E6C4UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS18          *((volatile unsigned char*)(0x42C8E6C8UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS19          *((volatile unsigned char*)(0x42C8E6CCUL))
#define bFM_ETHERNET_MAC0_ATSR_ATS20          *((volatile unsigned char*)(0x42C8E6D0UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS21          *((volatile unsigned char*)(0x42C8E6D4UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS22          *((volatile unsigned char*)(0x42C8E6D8UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS23          *((volatile unsigned char*)(0x42C8E6DCUL))
#define bFM_ETHERNET_MAC0_ATSR_ATS24          *((volatile unsigned char*)(0x42C8E6E0UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS25          *((volatile unsigned char*)(0x42C8E6E4UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS26          *((volatile unsigned char*)(0x42C8E6E8UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS27          *((volatile unsigned char*)(0x42C8E6ECUL))
#define bFM_ETHERNET_MAC0_ATSR_ATS28          *((volatile unsigned char*)(0x42C8E6F0UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS29          *((volatile unsigned char*)(0x42C8E6F4UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS30          *((volatile unsigned char*)(0x42C8E6F8UL))
#define bFM_ETHERNET_MAC0_ATSR_ATS31          *((volatile unsigned char*)(0x42C8E6FCUL))
#define bFM_ETHERNET_MAC0_MAR16H_MBC0         *((volatile unsigned char*)(0x42C90060UL))
#define bFM_ETHERNET_MAC0_MAR16H_MBC1         *((volatile unsigned char*)(0x42C90064UL))
#define bFM_ETHERNET_MAC0_MAR16H_MBC2         *((volatile unsigned char*)(0x42C90068UL))
#define bFM_ETHERNET_MAC0_MAR16H_MBC3         *((volatile unsigned char*)(0x42C9006CUL))
#define bFM_ETHERNET_MAC0_MAR16H_MBC4         *((volatile unsigned char*)(0x42C90070UL))
#define bFM_ETHERNET_MAC0_MAR16H_MBC5         *((volatile unsigned char*)(0x42C90074UL))
#define bFM_ETHERNET_MAC0_MAR16H_SA           *((volatile unsigned char*)(0x42C90078UL))
#define bFM_ETHERNET_MAC0_MAR17H_MBC0         *((volatile unsigned char*)(0x42C90160UL))
#define bFM_ETHERNET_MAC0_MAR17H_MBC1         *((volatile unsigned char*)(0x42C90164UL))
#define bFM_ETHERNET_MAC0_MAR17H_MBC2         *((volatile unsigned char*)(0x42C90168UL))
#define bFM_ETHERNET_MAC0_MAR17H_MBC3         *((volatile unsigned char*)(0x42C9016CUL))
#define bFM_ETHERNET_MAC0_MAR17H_MBC4         *((volatile unsigned char*)(0x42C90170UL))
#define bFM_ETHERNET_MAC0_MAR17H_MBC5         *((volatile unsigned char*)(0x42C90174UL))
#define bFM_ETHERNET_MAC0_MAR17H_SA           *((volatile unsigned char*)(0x42C90178UL))
#define bFM_ETHERNET_MAC0_MAR18H_MBC0         *((volatile unsigned char*)(0x42C90260UL))
#define bFM_ETHERNET_MAC0_MAR18H_MBC1         *((volatile unsigned char*)(0x42C90264UL))
#define bFM_ETHERNET_MAC0_MAR18H_MBC2         *((volatile unsigned char*)(0x42C90268UL))
#define bFM_ETHERNET_MAC0_MAR18H_MBC3         *((volatile unsigned char*)(0x42C9026CUL))
#define bFM_ETHERNET_MAC0_MAR18H_MBC4         *((volatile unsigned char*)(0x42C90270UL))
#define bFM_ETHERNET_MAC0_MAR18H_MBC5         *((volatile unsigned char*)(0x42C90274UL))
#define bFM_ETHERNET_MAC0_MAR18H_SA           *((volatile unsigned char*)(0x42C90278UL))
#define bFM_ETHERNET_MAC0_MAR19H_MBC0         *((volatile unsigned char*)(0x42C90360UL))
#define bFM_ETHERNET_MAC0_MAR19H_MBC1         *((volatile unsigned char*)(0x42C90364UL))
#define bFM_ETHERNET_MAC0_MAR19H_MBC2         *((volatile unsigned char*)(0x42C90368UL))
#define bFM_ETHERNET_MAC0_MAR19H_MBC3         *((volatile unsigned char*)(0x42C9036CUL))
#define bFM_ETHERNET_MAC0_MAR19H_MBC4         *((volatile unsigned char*)(0x42C90370UL))
#define bFM_ETHERNET_MAC0_MAR19H_MBC5         *((volatile unsigned char*)(0x42C90374UL))
#define bFM_ETHERNET_MAC0_MAR19H_SA           *((volatile unsigned char*)(0x42C90378UL))
#define bFM_ETHERNET_MAC0_MAR20H_MBC0         *((volatile unsigned char*)(0x42C90460UL))
#define bFM_ETHERNET_MAC0_MAR20H_MBC1         *((volatile unsigned char*)(0x42C90464UL))
#define bFM_ETHERNET_MAC0_MAR20H_MBC2         *((volatile unsigned char*)(0x42C90468UL))
#define bFM_ETHERNET_MAC0_MAR20H_MBC3         *((volatile unsigned char*)(0x42C9046CUL))
#define bFM_ETHERNET_MAC0_MAR20H_MBC4         *((volatile unsigned char*)(0x42C90470UL))
#define bFM_ETHERNET_MAC0_MAR20H_MBC5         *((volatile unsigned char*)(0x42C90474UL))
#define bFM_ETHERNET_MAC0_MAR20H_SA           *((volatile unsigned char*)(0x42C90478UL))
#define bFM_ETHERNET_MAC0_MAR21H_MBC0         *((volatile unsigned char*)(0x42C90560UL))
#define bFM_ETHERNET_MAC0_MAR21H_MBC1         *((volatile unsigned char*)(0x42C90564UL))
#define bFM_ETHERNET_MAC0_MAR21H_MBC2         *((volatile unsigned char*)(0x42C90568UL))
#define bFM_ETHERNET_MAC0_MAR21H_MBC3         *((volatile unsigned char*)(0x42C9056CUL))
#define bFM_ETHERNET_MAC0_MAR21H_MBC4         *((volatile unsigned char*)(0x42C90570UL))
#define bFM_ETHERNET_MAC0_MAR21H_MBC5         *((volatile unsigned char*)(0x42C90574UL))
#define bFM_ETHERNET_MAC0_MAR21H_SA           *((volatile unsigned char*)(0x42C90578UL))
#define bFM_ETHERNET_MAC0_MAR22H_MBC0         *((volatile unsigned char*)(0x42C90660UL))
#define bFM_ETHERNET_MAC0_MAR22H_MBC1         *((volatile unsigned char*)(0x42C90664UL))
#define bFM_ETHERNET_MAC0_MAR22H_MBC2         *((volatile unsigned char*)(0x42C90668UL))
#define bFM_ETHERNET_MAC0_MAR22H_MBC3         *((volatile unsigned char*)(0x42C9066CUL))
#define bFM_ETHERNET_MAC0_MAR22H_MBC4         *((volatile unsigned char*)(0x42C90670UL))
#define bFM_ETHERNET_MAC0_MAR22H_MBC5         *((volatile unsigned char*)(0x42C90674UL))
#define bFM_ETHERNET_MAC0_MAR22H_SA           *((volatile unsigned char*)(0x42C90678UL))
#define bFM_ETHERNET_MAC0_MAR23H_MBC0         *((volatile unsigned char*)(0x42C90760UL))
#define bFM_ETHERNET_MAC0_MAR23H_MBC1         *((volatile unsigned char*)(0x42C90764UL))
#define bFM_ETHERNET_MAC0_MAR23H_MBC2         *((volatile unsigned char*)(0x42C90768UL))
#define bFM_ETHERNET_MAC0_MAR23H_MBC3         *((volatile unsigned char*)(0x42C9076CUL))
#define bFM_ETHERNET_MAC0_MAR23H_MBC4         *((volatile unsigned char*)(0x42C90770UL))
#define bFM_ETHERNET_MAC0_MAR23H_MBC5         *((volatile unsigned char*)(0x42C90774UL))
#define bFM_ETHERNET_MAC0_MAR23H_SA           *((volatile unsigned char*)(0x42C90778UL))
#define bFM_ETHERNET_MAC0_MAR24H_MBC0         *((volatile unsigned char*)(0x42C90860UL))
#define bFM_ETHERNET_MAC0_MAR24H_MBC1         *((volatile unsigned char*)(0x42C90864UL))
#define bFM_ETHERNET_MAC0_MAR24H_MBC2         *((volatile unsigned char*)(0x42C90868UL))
#define bFM_ETHERNET_MAC0_MAR24H_MBC3         *((volatile unsigned char*)(0x42C9086CUL))
#define bFM_ETHERNET_MAC0_MAR24H_MBC4         *((volatile unsigned char*)(0x42C90870UL))
#define bFM_ETHERNET_MAC0_MAR24H_MBC5         *((volatile unsigned char*)(0x42C90874UL))
#define bFM_ETHERNET_MAC0_MAR24H_SA           *((volatile unsigned char*)(0x42C90878UL))
#define bFM_ETHERNET_MAC0_MAR25H_MBC0         *((volatile unsigned char*)(0x42C90960UL))
#define bFM_ETHERNET_MAC0_MAR25H_MBC1         *((volatile unsigned char*)(0x42C90964UL))
#define bFM_ETHERNET_MAC0_MAR25H_MBC2         *((volatile unsigned char*)(0x42C90968UL))
#define bFM_ETHERNET_MAC0_MAR25H_MBC3         *((volatile unsigned char*)(0x42C9096CUL))
#define bFM_ETHERNET_MAC0_MAR25H_MBC4         *((volatile unsigned char*)(0x42C90970UL))
#define bFM_ETHERNET_MAC0_MAR25H_MBC5         *((volatile unsigned char*)(0x42C90974UL))
#define bFM_ETHERNET_MAC0_MAR25H_SA           *((volatile unsigned char*)(0x42C90978UL))
#define bFM_ETHERNET_MAC0_MAR26H_MBC0         *((volatile unsigned char*)(0x42C90A60UL))
#define bFM_ETHERNET_MAC0_MAR26H_MBC1         *((volatile unsigned char*)(0x42C90A64UL))
#define bFM_ETHERNET_MAC0_MAR26H_MBC2         *((volatile unsigned char*)(0x42C90A68UL))
#define bFM_ETHERNET_MAC0_MAR26H_MBC3         *((volatile unsigned char*)(0x42C90A6CUL))
#define bFM_ETHERNET_MAC0_MAR26H_MBC4         *((volatile unsigned char*)(0x42C90A70UL))
#define bFM_ETHERNET_MAC0_MAR26H_MBC5         *((volatile unsigned char*)(0x42C90A74UL))
#define bFM_ETHERNET_MAC0_MAR26H_SA           *((volatile unsigned char*)(0x42C90A78UL))
#define bFM_ETHERNET_MAC0_MAR27H_MBC0         *((volatile unsigned char*)(0x42C90B60UL))
#define bFM_ETHERNET_MAC0_MAR27H_MBC1         *((volatile unsigned char*)(0x42C90B64UL))
#define bFM_ETHERNET_MAC0_MAR27H_MBC2         *((volatile unsigned char*)(0x42C90B68UL))
#define bFM_ETHERNET_MAC0_MAR27H_MBC3         *((volatile unsigned char*)(0x42C90B6CUL))
#define bFM_ETHERNET_MAC0_MAR27H_MBC4         *((volatile unsigned char*)(0x42C90B70UL))
#define bFM_ETHERNET_MAC0_MAR27H_MBC5         *((volatile unsigned char*)(0x42C90B74UL))
#define bFM_ETHERNET_MAC0_MAR27H_SA           *((volatile unsigned char*)(0x42C90B78UL))
#define bFM_ETHERNET_MAC0_MAR28H_MBC0         *((volatile unsigned char*)(0x42C90C60UL))
#define bFM_ETHERNET_MAC0_MAR28H_MBC1         *((volatile unsigned char*)(0x42C90C64UL))
#define bFM_ETHERNET_MAC0_MAR28H_MBC2         *((volatile unsigned char*)(0x42C90C68UL))
#define bFM_ETHERNET_MAC0_MAR28H_MBC3         *((volatile unsigned char*)(0x42C90C6CUL))
#define bFM_ETHERNET_MAC0_MAR28H_MBC4         *((volatile unsigned char*)(0x42C90C70UL))
#define bFM_ETHERNET_MAC0_MAR28H_MBC5         *((volatile unsigned char*)(0x42C90C74UL))
#define bFM_ETHERNET_MAC0_MAR28H_SA           *((volatile unsigned char*)(0x42C90C78UL))
#define bFM_ETHERNET_MAC0_MAR29H_MBC0         *((volatile unsigned char*)(0x42C90D60UL))
#define bFM_ETHERNET_MAC0_MAR29H_MBC1         *((volatile unsigned char*)(0x42C90D64UL))
#define bFM_ETHERNET_MAC0_MAR29H_MBC2         *((volatile unsigned char*)(0x42C90D68UL))
#define bFM_ETHERNET_MAC0_MAR29H_MBC3         *((volatile unsigned char*)(0x42C90D6CUL))
#define bFM_ETHERNET_MAC0_MAR29H_MBC4         *((volatile unsigned char*)(0x42C90D70UL))
#define bFM_ETHERNET_MAC0_MAR29H_MBC5         *((volatile unsigned char*)(0x42C90D74UL))
#define bFM_ETHERNET_MAC0_MAR29H_SA           *((volatile unsigned char*)(0x42C90D78UL))
#define bFM_ETHERNET_MAC0_MAR30H_MBC0         *((volatile unsigned char*)(0x42C90E60UL))
#define bFM_ETHERNET_MAC0_MAR30H_MBC1         *((volatile unsigned char*)(0x42C90E64UL))
#define bFM_ETHERNET_MAC0_MAR30H_MBC2         *((volatile unsigned char*)(0x42C90E68UL))
#define bFM_ETHERNET_MAC0_MAR30H_MBC3         *((volatile unsigned char*)(0x42C90E6CUL))
#define bFM_ETHERNET_MAC0_MAR30H_MBC4         *((volatile unsigned char*)(0x42C90E70UL))
#define bFM_ETHERNET_MAC0_MAR30H_MBC5         *((volatile unsigned char*)(0x42C90E74UL))
#define bFM_ETHERNET_MAC0_MAR30H_SA           *((volatile unsigned char*)(0x42C90E78UL))
#define bFM_ETHERNET_MAC0_MAR31H_MBC0         *((volatile unsigned char*)(0x42C90F60UL))
#define bFM_ETHERNET_MAC0_MAR31H_MBC1         *((volatile unsigned char*)(0x42C90F64UL))
#define bFM_ETHERNET_MAC0_MAR31H_MBC2         *((volatile unsigned char*)(0x42C90F68UL))
#define bFM_ETHERNET_MAC0_MAR31H_MBC3         *((volatile unsigned char*)(0x42C90F6CUL))
#define bFM_ETHERNET_MAC0_MAR31H_MBC4         *((volatile unsigned char*)(0x42C90F70UL))
#define bFM_ETHERNET_MAC0_MAR31H_MBC5         *((volatile unsigned char*)(0x42C90F74UL))
#define bFM_ETHERNET_MAC0_MAR31H_SA           *((volatile unsigned char*)(0x42C90F78UL))
#define bFM_ETHERNET_MAC0_BMR_SWR             *((volatile unsigned char*)(0x42CA0000UL))
#define bFM_ETHERNET_MAC0_BMR_DA              *((volatile unsigned char*)(0x42CA0004UL))
#define bFM_ETHERNET_MAC0_BMR_DSL0            *((volatile unsigned char*)(0x42CA0008UL))
#define bFM_ETHERNET_MAC0_BMR_DSL1            *((volatile unsigned char*)(0x42CA000CUL))
#define bFM_ETHERNET_MAC0_BMR_DSL2            *((volatile unsigned char*)(0x42CA0010UL))
#define bFM_ETHERNET_MAC0_BMR_DSL3            *((volatile unsigned char*)(0x42CA0014UL))
#define bFM_ETHERNET_MAC0_BMR_DSL4            *((volatile unsigned char*)(0x42CA0018UL))
#define bFM_ETHERNET_MAC0_BMR_ATDS            *((volatile unsigned char*)(0x42CA001CUL))
#define bFM_ETHERNET_MAC0_BMR_PBL0            *((volatile unsigned char*)(0x42CA0020UL))
#define bFM_ETHERNET_MAC0_BMR_PBL1            *((volatile unsigned char*)(0x42CA0024UL))
#define bFM_ETHERNET_MAC0_BMR_PBL2            *((volatile unsigned char*)(0x42CA0028UL))
#define bFM_ETHERNET_MAC0_BMR_PBL3            *((volatile unsigned char*)(0x42CA002CUL))
#define bFM_ETHERNET_MAC0_BMR_PBL4            *((volatile unsigned char*)(0x42CA0030UL))
#define bFM_ETHERNET_MAC0_BMR_PBL5            *((volatile unsigned char*)(0x42CA0034UL))
#define bFM_ETHERNET_MAC0_BMR_PR0             *((volatile unsigned char*)(0x42CA0038UL))
#define bFM_ETHERNET_MAC0_BMR_PR1             *((volatile unsigned char*)(0x42CA003CUL))
#define bFM_ETHERNET_MAC0_BMR_FB              *((volatile unsigned char*)(0x42CA0040UL))
#define bFM_ETHERNET_MAC0_BMR_RPBL0           *((volatile unsigned char*)(0x42CA0044UL))
#define bFM_ETHERNET_MAC0_BMR_RPBL1           *((volatile unsigned char*)(0x42CA0048UL))
#define bFM_ETHERNET_MAC0_BMR_RPBL2           *((volatile unsigned char*)(0x42CA004CUL))
#define bFM_ETHERNET_MAC0_BMR_RPBL3           *((volatile unsigned char*)(0x42CA0050UL))
#define bFM_ETHERNET_MAC0_BMR_RPBL4           *((volatile unsigned char*)(0x42CA0054UL))
#define bFM_ETHERNET_MAC0_BMR_RPBL5           *((volatile unsigned char*)(0x42CA0058UL))
#define bFM_ETHERNET_MAC0_BMR_USP             *((volatile unsigned char*)(0x42CA005CUL))
#define bFM_ETHERNET_MAC0_BMR_8XPBL           *((volatile unsigned char*)(0x42CA0060UL))
#define bFM_ETHERNET_MAC0_BMR_AAL             *((volatile unsigned char*)(0x42CA0064UL))
#define bFM_ETHERNET_MAC0_BMR_MB              *((volatile unsigned char*)(0x42CA0068UL))
#define bFM_ETHERNET_MAC0_BMR_TXPR            *((volatile unsigned char*)(0x42CA006CUL))
#define bFM_ETHERNET_MAC0_TPDR_TPD0           *((volatile unsigned char*)(0x42CA0080UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD1           *((volatile unsigned char*)(0x42CA0084UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD2           *((volatile unsigned char*)(0x42CA0088UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD3           *((volatile unsigned char*)(0x42CA008CUL))
#define bFM_ETHERNET_MAC0_TPDR_TPD4           *((volatile unsigned char*)(0x42CA0090UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD5           *((volatile unsigned char*)(0x42CA0094UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD6           *((volatile unsigned char*)(0x42CA0098UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD7           *((volatile unsigned char*)(0x42CA009CUL))
#define bFM_ETHERNET_MAC0_TPDR_TPD8           *((volatile unsigned char*)(0x42CA00A0UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD9           *((volatile unsigned char*)(0x42CA00A4UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD10          *((volatile unsigned char*)(0x42CA00A8UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD11          *((volatile unsigned char*)(0x42CA00ACUL))
#define bFM_ETHERNET_MAC0_TPDR_TPD12          *((volatile unsigned char*)(0x42CA00B0UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD13          *((volatile unsigned char*)(0x42CA00B4UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD14          *((volatile unsigned char*)(0x42CA00B8UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD15          *((volatile unsigned char*)(0x42CA00BCUL))
#define bFM_ETHERNET_MAC0_TPDR_TPD16          *((volatile unsigned char*)(0x42CA00C0UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD17          *((volatile unsigned char*)(0x42CA00C4UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD18          *((volatile unsigned char*)(0x42CA00C8UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD19          *((volatile unsigned char*)(0x42CA00CCUL))
#define bFM_ETHERNET_MAC0_TPDR_TPD20          *((volatile unsigned char*)(0x42CA00D0UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD21          *((volatile unsigned char*)(0x42CA00D4UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD22          *((volatile unsigned char*)(0x42CA00D8UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD23          *((volatile unsigned char*)(0x42CA00DCUL))
#define bFM_ETHERNET_MAC0_TPDR_TPD24          *((volatile unsigned char*)(0x42CA00E0UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD25          *((volatile unsigned char*)(0x42CA00E4UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD26          *((volatile unsigned char*)(0x42CA00E8UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD27          *((volatile unsigned char*)(0x42CA00ECUL))
#define bFM_ETHERNET_MAC0_TPDR_TPD28          *((volatile unsigned char*)(0x42CA00F0UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD29          *((volatile unsigned char*)(0x42CA00F4UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD30          *((volatile unsigned char*)(0x42CA00F8UL))
#define bFM_ETHERNET_MAC0_TPDR_TPD31          *((volatile unsigned char*)(0x42CA00FCUL))
#define bFM_ETHERNET_MAC0_RPDR_RPD0           *((volatile unsigned char*)(0x42CA0100UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD1           *((volatile unsigned char*)(0x42CA0104UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD2           *((volatile unsigned char*)(0x42CA0108UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD3           *((volatile unsigned char*)(0x42CA010CUL))
#define bFM_ETHERNET_MAC0_RPDR_RPD4           *((volatile unsigned char*)(0x42CA0110UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD5           *((volatile unsigned char*)(0x42CA0114UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD6           *((volatile unsigned char*)(0x42CA0118UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD7           *((volatile unsigned char*)(0x42CA011CUL))
#define bFM_ETHERNET_MAC0_RPDR_RPD8           *((volatile unsigned char*)(0x42CA0120UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD9           *((volatile unsigned char*)(0x42CA0124UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD10          *((volatile unsigned char*)(0x42CA0128UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD11          *((volatile unsigned char*)(0x42CA012CUL))
#define bFM_ETHERNET_MAC0_RPDR_RPD12          *((volatile unsigned char*)(0x42CA0130UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD13          *((volatile unsigned char*)(0x42CA0134UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD14          *((volatile unsigned char*)(0x42CA0138UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD15          *((volatile unsigned char*)(0x42CA013CUL))
#define bFM_ETHERNET_MAC0_RPDR_RPD16          *((volatile unsigned char*)(0x42CA0140UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD17          *((volatile unsigned char*)(0x42CA0144UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD18          *((volatile unsigned char*)(0x42CA0148UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD19          *((volatile unsigned char*)(0x42CA014CUL))
#define bFM_ETHERNET_MAC0_RPDR_RPD20          *((volatile unsigned char*)(0x42CA0150UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD21          *((volatile unsigned char*)(0x42CA0154UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD22          *((volatile unsigned char*)(0x42CA0158UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD23          *((volatile unsigned char*)(0x42CA015CUL))
#define bFM_ETHERNET_MAC0_RPDR_RPD24          *((volatile unsigned char*)(0x42CA0160UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD25          *((volatile unsigned char*)(0x42CA0164UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD26          *((volatile unsigned char*)(0x42CA0168UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD27          *((volatile unsigned char*)(0x42CA016CUL))
#define bFM_ETHERNET_MAC0_RPDR_RPD28          *((volatile unsigned char*)(0x42CA0170UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD29          *((volatile unsigned char*)(0x42CA0174UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD30          *((volatile unsigned char*)(0x42CA0178UL))
#define bFM_ETHERNET_MAC0_RPDR_RPD31          *((volatile unsigned char*)(0x42CA017CUL))
#define bFM_ETHERNET_MAC0_SR_TI               *((volatile unsigned char*)(0x42CA0280UL))
#define bFM_ETHERNET_MAC0_SR_TPS              *((volatile unsigned char*)(0x42CA0284UL))
#define bFM_ETHERNET_MAC0_SR_TU               *((volatile unsigned char*)(0x42CA0288UL))
#define bFM_ETHERNET_MAC0_SR_TJT              *((volatile unsigned char*)(0x42CA028CUL))
#define bFM_ETHERNET_MAC0_SR_OVF              *((volatile unsigned char*)(0x42CA0290UL))
#define bFM_ETHERNET_MAC0_SR_UNF              *((volatile unsigned char*)(0x42CA0294UL))
#define bFM_ETHERNET_MAC0_SR_RI               *((volatile unsigned char*)(0x42CA0298UL))
#define bFM_ETHERNET_MAC0_SR_RU               *((volatile unsigned char*)(0x42CA029CUL))
#define bFM_ETHERNET_MAC0_SR_RPS              *((volatile unsigned char*)(0x42CA02A0UL))
#define bFM_ETHERNET_MAC0_SR_RWT              *((volatile unsigned char*)(0x42CA02A4UL))
#define bFM_ETHERNET_MAC0_SR_ETI              *((volatile unsigned char*)(0x42CA02A8UL))
#define bFM_ETHERNET_MAC0_SR_FBI              *((volatile unsigned char*)(0x42CA02B4UL))
#define bFM_ETHERNET_MAC0_SR_ERI              *((volatile unsigned char*)(0x42CA02B8UL))
#define bFM_ETHERNET_MAC0_SR_AIS              *((volatile unsigned char*)(0x42CA02BCUL))
#define bFM_ETHERNET_MAC0_SR_NIS              *((volatile unsigned char*)(0x42CA02C0UL))
#define bFM_ETHERNET_MAC0_SR_RS0              *((volatile unsigned char*)(0x42CA02C4UL))
#define bFM_ETHERNET_MAC0_SR_RS1              *((volatile unsigned char*)(0x42CA02C8UL))
#define bFM_ETHERNET_MAC0_SR_RS2              *((volatile unsigned char*)(0x42CA02CCUL))
#define bFM_ETHERNET_MAC0_SR_TS0              *((volatile unsigned char*)(0x42CA02D0UL))
#define bFM_ETHERNET_MAC0_SR_TS1              *((volatile unsigned char*)(0x42CA02D4UL))
#define bFM_ETHERNET_MAC0_SR_TS2              *((volatile unsigned char*)(0x42CA02D8UL))
#define bFM_ETHERNET_MAC0_SR_EB0              *((volatile unsigned char*)(0x42CA02DCUL))
#define bFM_ETHERNET_MAC0_SR_EB1              *((volatile unsigned char*)(0x42CA02E0UL))
#define bFM_ETHERNET_MAC0_SR_EB2              *((volatile unsigned char*)(0x42CA02E4UL))
#define bFM_ETHERNET_MAC0_SR_GLI              *((volatile unsigned char*)(0x42CA02E8UL))
#define bFM_ETHERNET_MAC0_SR_GMI              *((volatile unsigned char*)(0x42CA02ECUL))
#define bFM_ETHERNET_MAC0_SR_GPI              *((volatile unsigned char*)(0x42CA02F0UL))
#define bFM_ETHERNET_MAC0_SR_TTI              *((volatile unsigned char*)(0x42CA02F4UL))
#define bFM_ETHERNET_MAC0_SR_GLPII            *((volatile unsigned char*)(0x42CA02F8UL))
#define bFM_ETHERNET_MAC0_OMR_SR              *((volatile unsigned char*)(0x42CA0304UL))
#define bFM_ETHERNET_MAC0_OMR_OSF             *((volatile unsigned char*)(0x42CA0308UL))
#define bFM_ETHERNET_MAC0_OMR_RTC0            *((volatile unsigned char*)(0x42CA030CUL))
#define bFM_ETHERNET_MAC0_OMR_RTC1            *((volatile unsigned char*)(0x42CA0310UL))
#define bFM_ETHERNET_MAC0_OMR_FUF             *((volatile unsigned char*)(0x42CA0318UL))
#define bFM_ETHERNET_MAC0_OMR_FEF             *((volatile unsigned char*)(0x42CA031CUL))
#define bFM_ETHERNET_MAC0_OMR_ST              *((volatile unsigned char*)(0x42CA0334UL))
#define bFM_ETHERNET_MAC0_OMR_TTC0            *((volatile unsigned char*)(0x42CA0338UL))
#define bFM_ETHERNET_MAC0_OMR_TTC1            *((volatile unsigned char*)(0x42CA033CUL))
#define bFM_ETHERNET_MAC0_OMR_TTC2            *((volatile unsigned char*)(0x42CA0340UL))
#define bFM_ETHERNET_MAC0_OMR_FTF             *((volatile unsigned char*)(0x42CA0350UL))
#define bFM_ETHERNET_MAC0_OMR_TSF             *((volatile unsigned char*)(0x42CA0354UL))
#define bFM_ETHERNET_MAC0_OMR_DFF             *((volatile unsigned char*)(0x42CA0360UL))
#define bFM_ETHERNET_MAC0_OMR_RSF             *((volatile unsigned char*)(0x42CA0364UL))
#define bFM_ETHERNET_MAC0_OMR_DT              *((volatile unsigned char*)(0x42CA0368UL))
#define bFM_ETHERNET_MAC0_IER_TIE             *((volatile unsigned char*)(0x42CA0380UL))
#define bFM_ETHERNET_MAC0_IER_TSE             *((volatile unsigned char*)(0x42CA0384UL))
#define bFM_ETHERNET_MAC0_IER_TUE             *((volatile unsigned char*)(0x42CA0388UL))
#define bFM_ETHERNET_MAC0_IER_TJE             *((volatile unsigned char*)(0x42CA038CUL))
#define bFM_ETHERNET_MAC0_IER_OVE             *((volatile unsigned char*)(0x42CA0390UL))
#define bFM_ETHERNET_MAC0_IER_UNE             *((volatile unsigned char*)(0x42CA0394UL))
#define bFM_ETHERNET_MAC0_IER_RIE             *((volatile unsigned char*)(0x42CA0398UL))
#define bFM_ETHERNET_MAC0_IER_RUE             *((volatile unsigned char*)(0x42CA039CUL))
#define bFM_ETHERNET_MAC0_IER_RSE             *((volatile unsigned char*)(0x42CA03A0UL))
#define bFM_ETHERNET_MAC0_IER_RWE             *((volatile unsigned char*)(0x42CA03A4UL))
#define bFM_ETHERNET_MAC0_IER_ETE             *((volatile unsigned char*)(0x42CA03A8UL))
#define bFM_ETHERNET_MAC0_IER_FBE             *((volatile unsigned char*)(0x42CA03B4UL))
#define bFM_ETHERNET_MAC0_IER_ERE             *((volatile unsigned char*)(0x42CA03B8UL))
#define bFM_ETHERNET_MAC0_IER_AIE             *((volatile unsigned char*)(0x42CA03BCUL))
#define bFM_ETHERNET_MAC0_IER_NIE             *((volatile unsigned char*)(0x42CA03C0UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH0        *((volatile unsigned char*)(0x42CA0400UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH1        *((volatile unsigned char*)(0x42CA0404UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH2        *((volatile unsigned char*)(0x42CA0408UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH3        *((volatile unsigned char*)(0x42CA040CUL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH4        *((volatile unsigned char*)(0x42CA0410UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH5        *((volatile unsigned char*)(0x42CA0414UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH6        *((volatile unsigned char*)(0x42CA0418UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH7        *((volatile unsigned char*)(0x42CA041CUL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH8        *((volatile unsigned char*)(0x42CA0420UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH9        *((volatile unsigned char*)(0x42CA0424UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH10       *((volatile unsigned char*)(0x42CA0428UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH11       *((volatile unsigned char*)(0x42CA042CUL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH12       *((volatile unsigned char*)(0x42CA0430UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH13       *((volatile unsigned char*)(0x42CA0434UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH14       *((volatile unsigned char*)(0x42CA0438UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFH15       *((volatile unsigned char*)(0x42CA043CUL))
#define bFM_ETHERNET_MAC0_MFBOCR_ONMFH        *((volatile unsigned char*)(0x42CA0440UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF0        *((volatile unsigned char*)(0x42CA0444UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF1        *((volatile unsigned char*)(0x42CA0448UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF2        *((volatile unsigned char*)(0x42CA044CUL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF3        *((volatile unsigned char*)(0x42CA0450UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF4        *((volatile unsigned char*)(0x42CA0454UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF5        *((volatile unsigned char*)(0x42CA0458UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF6        *((volatile unsigned char*)(0x42CA045CUL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF7        *((volatile unsigned char*)(0x42CA0460UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF8        *((volatile unsigned char*)(0x42CA0464UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF9        *((volatile unsigned char*)(0x42CA0468UL))
#define bFM_ETHERNET_MAC0_MFBOCR_NMFF10       *((volatile unsigned char*)(0x42CA046CUL))
#define bFM_ETHERNET_MAC0_MFBOCR_ONMFF        *((volatile unsigned char*)(0x42CA0470UL))
#define bFM_ETHERNET_MAC0_RIWTR_RIWT0         *((volatile unsigned char*)(0x42CA0480UL))
#define bFM_ETHERNET_MAC0_RIWTR_RIWT1         *((volatile unsigned char*)(0x42CA0484UL))
#define bFM_ETHERNET_MAC0_RIWTR_RIWT2         *((volatile unsigned char*)(0x42CA0488UL))
#define bFM_ETHERNET_MAC0_RIWTR_RIWT3         *((volatile unsigned char*)(0x42CA048CUL))
#define bFM_ETHERNET_MAC0_RIWTR_RIWT4         *((volatile unsigned char*)(0x42CA0490UL))
#define bFM_ETHERNET_MAC0_RIWTR_RIWT5         *((volatile unsigned char*)(0x42CA0494UL))
#define bFM_ETHERNET_MAC0_RIWTR_RIWT6         *((volatile unsigned char*)(0x42CA0498UL))
#define bFM_ETHERNET_MAC0_RIWTR_RIWT7         *((volatile unsigned char*)(0x42CA049CUL))
#define bFM_ETHERNET_MAC0_AHBSR_AHBS          *((volatile unsigned char*)(0x42CA0580UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP0        *((volatile unsigned char*)(0x42CA0900UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP1        *((volatile unsigned char*)(0x42CA0904UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP2        *((volatile unsigned char*)(0x42CA0908UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP3        *((volatile unsigned char*)(0x42CA090CUL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP4        *((volatile unsigned char*)(0x42CA0910UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP5        *((volatile unsigned char*)(0x42CA0914UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP6        *((volatile unsigned char*)(0x42CA0918UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP7        *((volatile unsigned char*)(0x42CA091CUL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP8        *((volatile unsigned char*)(0x42CA0920UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP9        *((volatile unsigned char*)(0x42CA0924UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP10       *((volatile unsigned char*)(0x42CA0928UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP11       *((volatile unsigned char*)(0x42CA092CUL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP12       *((volatile unsigned char*)(0x42CA0930UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP13       *((volatile unsigned char*)(0x42CA0934UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP14       *((volatile unsigned char*)(0x42CA0938UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP15       *((volatile unsigned char*)(0x42CA093CUL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP16       *((volatile unsigned char*)(0x42CA0940UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP17       *((volatile unsigned char*)(0x42CA0944UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP18       *((volatile unsigned char*)(0x42CA0948UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP19       *((volatile unsigned char*)(0x42CA094CUL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP20       *((volatile unsigned char*)(0x42CA0950UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP21       *((volatile unsigned char*)(0x42CA0954UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP22       *((volatile unsigned char*)(0x42CA0958UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP23       *((volatile unsigned char*)(0x42CA095CUL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP24       *((volatile unsigned char*)(0x42CA0960UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP25       *((volatile unsigned char*)(0x42CA0964UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP26       *((volatile unsigned char*)(0x42CA0968UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP27       *((volatile unsigned char*)(0x42CA096CUL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP28       *((volatile unsigned char*)(0x42CA0970UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP29       *((volatile unsigned char*)(0x42CA0974UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP30       *((volatile unsigned char*)(0x42CA0978UL))
#define bFM_ETHERNET_MAC0_CHTDR_HTDAP31       *((volatile unsigned char*)(0x42CA097CUL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP0        *((volatile unsigned char*)(0x42CA0980UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP1        *((volatile unsigned char*)(0x42CA0984UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP2        *((volatile unsigned char*)(0x42CA0988UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP3        *((volatile unsigned char*)(0x42CA098CUL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP4        *((volatile unsigned char*)(0x42CA0990UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP5        *((volatile unsigned char*)(0x42CA0994UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP6        *((volatile unsigned char*)(0x42CA0998UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP7        *((volatile unsigned char*)(0x42CA099CUL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP8        *((volatile unsigned char*)(0x42CA09A0UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP9        *((volatile unsigned char*)(0x42CA09A4UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP10       *((volatile unsigned char*)(0x42CA09A8UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP11       *((volatile unsigned char*)(0x42CA09ACUL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP12       *((volatile unsigned char*)(0x42CA09B0UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP13       *((volatile unsigned char*)(0x42CA09B4UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP14       *((volatile unsigned char*)(0x42CA09B8UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP15       *((volatile unsigned char*)(0x42CA09BCUL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP16       *((volatile unsigned char*)(0x42CA09C0UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP17       *((volatile unsigned char*)(0x42CA09C4UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP18       *((volatile unsigned char*)(0x42CA09C8UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP19       *((volatile unsigned char*)(0x42CA09CCUL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP20       *((volatile unsigned char*)(0x42CA09D0UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP21       *((volatile unsigned char*)(0x42CA09D4UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP22       *((volatile unsigned char*)(0x42CA09D8UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP23       *((volatile unsigned char*)(0x42CA09DCUL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP24       *((volatile unsigned char*)(0x42CA09E0UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP25       *((volatile unsigned char*)(0x42CA09E4UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP26       *((volatile unsigned char*)(0x42CA09E8UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP27       *((volatile unsigned char*)(0x42CA09ECUL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP28       *((volatile unsigned char*)(0x42CA09F0UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP29       *((volatile unsigned char*)(0x42CA09F4UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP30       *((volatile unsigned char*)(0x42CA09F8UL))
#define bFM_ETHERNET_MAC0_CHRDR_HRDAP31       *((volatile unsigned char*)(0x42CA09FCUL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR0       *((volatile unsigned char*)(0x42CA0A00UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR1       *((volatile unsigned char*)(0x42CA0A04UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR2       *((volatile unsigned char*)(0x42CA0A08UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR3       *((volatile unsigned char*)(0x42CA0A0CUL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR4       *((volatile unsigned char*)(0x42CA0A10UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR5       *((volatile unsigned char*)(0x42CA0A14UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR6       *((volatile unsigned char*)(0x42CA0A18UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR7       *((volatile unsigned char*)(0x42CA0A1CUL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR8       *((volatile unsigned char*)(0x42CA0A20UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR9       *((volatile unsigned char*)(0x42CA0A24UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR10      *((volatile unsigned char*)(0x42CA0A28UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR11      *((volatile unsigned char*)(0x42CA0A2CUL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR12      *((volatile unsigned char*)(0x42CA0A30UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR13      *((volatile unsigned char*)(0x42CA0A34UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR14      *((volatile unsigned char*)(0x42CA0A38UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR15      *((volatile unsigned char*)(0x42CA0A3CUL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR16      *((volatile unsigned char*)(0x42CA0A40UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR17      *((volatile unsigned char*)(0x42CA0A44UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR18      *((volatile unsigned char*)(0x42CA0A48UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR19      *((volatile unsigned char*)(0x42CA0A4CUL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR20      *((volatile unsigned char*)(0x42CA0A50UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR21      *((volatile unsigned char*)(0x42CA0A54UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR22      *((volatile unsigned char*)(0x42CA0A58UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR23      *((volatile unsigned char*)(0x42CA0A5CUL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR24      *((volatile unsigned char*)(0x42CA0A60UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR25      *((volatile unsigned char*)(0x42CA0A64UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR26      *((volatile unsigned char*)(0x42CA0A68UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR27      *((volatile unsigned char*)(0x42CA0A6CUL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR28      *((volatile unsigned char*)(0x42CA0A70UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR29      *((volatile unsigned char*)(0x42CA0A74UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR30      *((volatile unsigned char*)(0x42CA0A78UL))
#define bFM_ETHERNET_MAC0_CHTBAR_HTBAR31      *((volatile unsigned char*)(0x42CA0A7CUL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR0       *((volatile unsigned char*)(0x42CA0A80UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR1       *((volatile unsigned char*)(0x42CA0A84UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR2       *((volatile unsigned char*)(0x42CA0A88UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR3       *((volatile unsigned char*)(0x42CA0A8CUL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR4       *((volatile unsigned char*)(0x42CA0A90UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR5       *((volatile unsigned char*)(0x42CA0A94UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR6       *((volatile unsigned char*)(0x42CA0A98UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR7       *((volatile unsigned char*)(0x42CA0A9CUL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR8       *((volatile unsigned char*)(0x42CA0AA0UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR9       *((volatile unsigned char*)(0x42CA0AA4UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR10      *((volatile unsigned char*)(0x42CA0AA8UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR11      *((volatile unsigned char*)(0x42CA0AACUL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR12      *((volatile unsigned char*)(0x42CA0AB0UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR13      *((volatile unsigned char*)(0x42CA0AB4UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR14      *((volatile unsigned char*)(0x42CA0AB8UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR15      *((volatile unsigned char*)(0x42CA0ABCUL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR16      *((volatile unsigned char*)(0x42CA0AC0UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR17      *((volatile unsigned char*)(0x42CA0AC4UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR18      *((volatile unsigned char*)(0x42CA0AC8UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR19      *((volatile unsigned char*)(0x42CA0ACCUL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR20      *((volatile unsigned char*)(0x42CA0AD0UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR21      *((volatile unsigned char*)(0x42CA0AD4UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR22      *((volatile unsigned char*)(0x42CA0AD8UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR23      *((volatile unsigned char*)(0x42CA0ADCUL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR24      *((volatile unsigned char*)(0x42CA0AE0UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR25      *((volatile unsigned char*)(0x42CA0AE4UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR26      *((volatile unsigned char*)(0x42CA0AE8UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR27      *((volatile unsigned char*)(0x42CA0AECUL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR28      *((volatile unsigned char*)(0x42CA0AF0UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR29      *((volatile unsigned char*)(0x42CA0AF4UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR30      *((volatile unsigned char*)(0x42CA0AF8UL))
#define bFM_ETHERNET_MAC0_CHRBAR_HRBAR31      *((volatile unsigned char*)(0x42CA0AFCUL))

/* Ethernet MAC control registers */
#define bFM_ETHERNET_CONTROL_ETH_MODE_IFMODE  *((volatile unsigned char*)(0x42CC0000UL))
#define bFM_ETHERNET_CONTROL_ETH_MODE_RST0    *((volatile unsigned char*)(0x42CC0020UL))
#define bFM_ETHERNET_CONTROL_ETH_MODE_RST1    *((volatile unsigned char*)(0x42CC0024UL))
#define bFM_ETHERNET_CONTROL_ETH_MODE_PPSSEL  *((volatile unsigned char*)(0x42CC0070UL))
#define bFM_ETHERNET_CONTROL_ETH_CLKG_MACEN0  *((volatile unsigned char*)(0x42CC0100UL))
#define bFM_ETHERNET_CONTROL_ETH_CLKG_MACEN1  *((volatile unsigned char*)(0x42CC0104UL))

/* I2S interface ch.0 registers */
#define bFM_I2S0_RXFDAT_RXDATA0               *((volatile unsigned char*)(0x42D80000UL))
#define bFM_I2S0_RXFDAT_RXDATA1               *((volatile unsigned char*)(0x42D80004UL))
#define bFM_I2S0_RXFDAT_RXDATA2               *((volatile unsigned char*)(0x42D80008UL))
#define bFM_I2S0_RXFDAT_RXDATA3               *((volatile unsigned char*)(0x42D8000CUL))
#define bFM_I2S0_RXFDAT_RXDATA4               *((volatile unsigned char*)(0x42D80010UL))
#define bFM_I2S0_RXFDAT_RXDATA5               *((volatile unsigned char*)(0x42D80014UL))
#define bFM_I2S0_RXFDAT_RXDATA6               *((volatile unsigned char*)(0x42D80018UL))
#define bFM_I2S0_RXFDAT_RXDATA7               *((volatile unsigned char*)(0x42D8001CUL))
#define bFM_I2S0_RXFDAT_RXDATA8               *((volatile unsigned char*)(0x42D80020UL))
#define bFM_I2S0_RXFDAT_RXDATA9               *((volatile unsigned char*)(0x42D80024UL))
#define bFM_I2S0_RXFDAT_RXDATA10              *((volatile unsigned char*)(0x42D80028UL))
#define bFM_I2S0_RXFDAT_RXDATA11              *((volatile unsigned char*)(0x42D8002CUL))
#define bFM_I2S0_RXFDAT_RXDATA12              *((volatile unsigned char*)(0x42D80030UL))
#define bFM_I2S0_RXFDAT_RXDATA13              *((volatile unsigned char*)(0x42D80034UL))
#define bFM_I2S0_RXFDAT_RXDATA14              *((volatile unsigned char*)(0x42D80038UL))
#define bFM_I2S0_RXFDAT_RXDATA15              *((volatile unsigned char*)(0x42D8003CUL))
#define bFM_I2S0_RXFDAT_RXDATA16              *((volatile unsigned char*)(0x42D80040UL))
#define bFM_I2S0_RXFDAT_RXDATA17              *((volatile unsigned char*)(0x42D80044UL))
#define bFM_I2S0_RXFDAT_RXDATA18              *((volatile unsigned char*)(0x42D80048UL))
#define bFM_I2S0_RXFDAT_RXDATA19              *((volatile unsigned char*)(0x42D8004CUL))
#define bFM_I2S0_RXFDAT_RXDATA20              *((volatile unsigned char*)(0x42D80050UL))
#define bFM_I2S0_RXFDAT_RXDATA21              *((volatile unsigned char*)(0x42D80054UL))
#define bFM_I2S0_RXFDAT_RXDATA22              *((volatile unsigned char*)(0x42D80058UL))
#define bFM_I2S0_RXFDAT_RXDATA23              *((volatile unsigned char*)(0x42D8005CUL))
#define bFM_I2S0_RXFDAT_RXDATA24              *((volatile unsigned char*)(0x42D80060UL))
#define bFM_I2S0_RXFDAT_RXDATA25              *((volatile unsigned char*)(0x42D80064UL))
#define bFM_I2S0_RXFDAT_RXDATA26              *((volatile unsigned char*)(0x42D80068UL))
#define bFM_I2S0_RXFDAT_RXDATA27              *((volatile unsigned char*)(0x42D8006CUL))
#define bFM_I2S0_RXFDAT_RXDATA28              *((volatile unsigned char*)(0x42D80070UL))
#define bFM_I2S0_RXFDAT_RXDATA29              *((volatile unsigned char*)(0x42D80074UL))
#define bFM_I2S0_RXFDAT_RXDATA30              *((volatile unsigned char*)(0x42D80078UL))
#define bFM_I2S0_RXFDAT_RXDATA31              *((volatile unsigned char*)(0x42D8007CUL))
#define bFM_I2S0_TXFDAT_TXDATA0               *((volatile unsigned char*)(0x42D80080UL))
#define bFM_I2S0_TXFDAT_TXDATA1               *((volatile unsigned char*)(0x42D80084UL))
#define bFM_I2S0_TXFDAT_TXDATA2               *((volatile unsigned char*)(0x42D80088UL))
#define bFM_I2S0_TXFDAT_TXDATA3               *((volatile unsigned char*)(0x42D8008CUL))
#define bFM_I2S0_TXFDAT_TXDATA4               *((volatile unsigned char*)(0x42D80090UL))
#define bFM_I2S0_TXFDAT_TXDATA5               *((volatile unsigned char*)(0x42D80094UL))
#define bFM_I2S0_TXFDAT_TXDATA6               *((volatile unsigned char*)(0x42D80098UL))
#define bFM_I2S0_TXFDAT_TXDATA7               *((volatile unsigned char*)(0x42D8009CUL))
#define bFM_I2S0_TXFDAT_TXDATA8               *((volatile unsigned char*)(0x42D800A0UL))
#define bFM_I2S0_TXFDAT_TXDATA9               *((volatile unsigned char*)(0x42D800A4UL))
#define bFM_I2S0_TXFDAT_TXDATA10              *((volatile unsigned char*)(0x42D800A8UL))
#define bFM_I2S0_TXFDAT_TXDATA11              *((volatile unsigned char*)(0x42D800ACUL))
#define bFM_I2S0_TXFDAT_TXDATA12              *((volatile unsigned char*)(0x42D800B0UL))
#define bFM_I2S0_TXFDAT_TXDATA13              *((volatile unsigned char*)(0x42D800B4UL))
#define bFM_I2S0_TXFDAT_TXDATA14              *((volatile unsigned char*)(0x42D800B8UL))
#define bFM_I2S0_TXFDAT_TXDATA15              *((volatile unsigned char*)(0x42D800BCUL))
#define bFM_I2S0_TXFDAT_TXDATA16              *((volatile unsigned char*)(0x42D800C0UL))
#define bFM_I2S0_TXFDAT_TXDATA17              *((volatile unsigned char*)(0x42D800C4UL))
#define bFM_I2S0_TXFDAT_TXDATA18              *((volatile unsigned char*)(0x42D800C8UL))
#define bFM_I2S0_TXFDAT_TXDATA19              *((volatile unsigned char*)(0x42D800CCUL))
#define bFM_I2S0_TXFDAT_TXDATA20              *((volatile unsigned char*)(0x42D800D0UL))
#define bFM_I2S0_TXFDAT_TXDATA21              *((volatile unsigned char*)(0x42D800D4UL))
#define bFM_I2S0_TXFDAT_TXDATA22              *((volatile unsigned char*)(0x42D800D8UL))
#define bFM_I2S0_TXFDAT_TXDATA23              *((volatile unsigned char*)(0x42D800DCUL))
#define bFM_I2S0_TXFDAT_TXDATA24              *((volatile unsigned char*)(0x42D800E0UL))
#define bFM_I2S0_TXFDAT_TXDATA25              *((volatile unsigned char*)(0x42D800E4UL))
#define bFM_I2S0_TXFDAT_TXDATA26              *((volatile unsigned char*)(0x42D800E8UL))
#define bFM_I2S0_TXFDAT_TXDATA27              *((volatile unsigned char*)(0x42D800ECUL))
#define bFM_I2S0_TXFDAT_TXDATA28              *((volatile unsigned char*)(0x42D800F0UL))
#define bFM_I2S0_TXFDAT_TXDATA29              *((volatile unsigned char*)(0x42D800F4UL))
#define bFM_I2S0_TXFDAT_TXDATA30              *((volatile unsigned char*)(0x42D800F8UL))
#define bFM_I2S0_TXFDAT_TXDATA31              *((volatile unsigned char*)(0x42D800FCUL))
#define bFM_I2S0_CNTREG_FSPL                  *((volatile unsigned char*)(0x42D80100UL))
#define bFM_I2S0_CNTREG_FSLN                  *((volatile unsigned char*)(0x42D80104UL))
#define bFM_I2S0_CNTREG_FSPH                  *((volatile unsigned char*)(0x42D80108UL))
#define bFM_I2S0_CNTREG_CPOL                  *((volatile unsigned char*)(0x42D8010CUL))
#define bFM_I2S0_CNTREG_SMPL                  *((volatile unsigned char*)(0x42D80110UL))
#define bFM_I2S0_CNTREG_RXDIS                 *((volatile unsigned char*)(0x42D80114UL))
#define bFM_I2S0_CNTREG_TXDIS                 *((volatile unsigned char*)(0x42D80118UL))
#define bFM_I2S0_CNTREG_MLSB                  *((volatile unsigned char*)(0x42D8011CUL))
#define bFM_I2S0_CNTREG_FRUN                  *((volatile unsigned char*)(0x42D80120UL))
#define bFM_I2S0_CNTREG_BEXT                  *((volatile unsigned char*)(0x42D80124UL))
#define bFM_I2S0_CNTREG_ECKM                  *((volatile unsigned char*)(0x42D80128UL))
#define bFM_I2S0_CNTREG_RHLL                  *((volatile unsigned char*)(0x42D8012CUL))
#define bFM_I2S0_CNTREG_SBFN                  *((volatile unsigned char*)(0x42D80130UL))
#define bFM_I2S0_CNTREG_MSMD                  *((volatile unsigned char*)(0x42D80134UL))
#define bFM_I2S0_CNTREG_MSKB                  *((volatile unsigned char*)(0x42D80138UL))
#define bFM_I2S0_CNTREG_OVHD0                 *((volatile unsigned char*)(0x42D80140UL))
#define bFM_I2S0_CNTREG_OVHD1                 *((volatile unsigned char*)(0x42D80144UL))
#define bFM_I2S0_CNTREG_OVHD2                 *((volatile unsigned char*)(0x42D80148UL))
#define bFM_I2S0_CNTREG_OVHD3                 *((volatile unsigned char*)(0x42D8014CUL))
#define bFM_I2S0_CNTREG_OVHD4                 *((volatile unsigned char*)(0x42D80150UL))
#define bFM_I2S0_CNTREG_OVHD5                 *((volatile unsigned char*)(0x42D80154UL))
#define bFM_I2S0_CNTREG_OVHD6                 *((volatile unsigned char*)(0x42D80158UL))
#define bFM_I2S0_CNTREG_OVHD7                 *((volatile unsigned char*)(0x42D8015CUL))
#define bFM_I2S0_CNTREG_OVHD8                 *((volatile unsigned char*)(0x42D80160UL))
#define bFM_I2S0_CNTREG_OVHD9                 *((volatile unsigned char*)(0x42D80164UL))
#define bFM_I2S0_CNTREG_CKRT0                 *((volatile unsigned char*)(0x42D80168UL))
#define bFM_I2S0_CNTREG_CKRT1                 *((volatile unsigned char*)(0x42D8016CUL))
#define bFM_I2S0_CNTREG_CKRT2                 *((volatile unsigned char*)(0x42D80170UL))
#define bFM_I2S0_CNTREG_CKRT3                 *((volatile unsigned char*)(0x42D80174UL))
#define bFM_I2S0_CNTREG_CKRT4                 *((volatile unsigned char*)(0x42D80178UL))
#define bFM_I2S0_CNTREG_CKRT5                 *((volatile unsigned char*)(0x42D8017CUL))
#define bFM_I2S0_MCR0REG_S0WDL0               *((volatile unsigned char*)(0x42D80180UL))
#define bFM_I2S0_MCR0REG_S0WDL1               *((volatile unsigned char*)(0x42D80184UL))
#define bFM_I2S0_MCR0REG_S0WDL2               *((volatile unsigned char*)(0x42D80188UL))
#define bFM_I2S0_MCR0REG_S0WDL3               *((volatile unsigned char*)(0x42D8018CUL))
#define bFM_I2S0_MCR0REG_S0WDL4               *((volatile unsigned char*)(0x42D80190UL))
#define bFM_I2S0_MCR0REG_S0CHL0               *((volatile unsigned char*)(0x42D80194UL))
#define bFM_I2S0_MCR0REG_S0CHL1               *((volatile unsigned char*)(0x42D80198UL))
#define bFM_I2S0_MCR0REG_S0CHL2               *((volatile unsigned char*)(0x42D8019CUL))
#define bFM_I2S0_MCR0REG_S0CHL3               *((volatile unsigned char*)(0x42D801A0UL))
#define bFM_I2S0_MCR0REG_S0CHL4               *((volatile unsigned char*)(0x42D801A4UL))
#define bFM_I2S0_MCR0REG_S0CHN0               *((volatile unsigned char*)(0x42D801A8UL))
#define bFM_I2S0_MCR0REG_S0CHN1               *((volatile unsigned char*)(0x42D801ACUL))
#define bFM_I2S0_MCR0REG_S0CHN2               *((volatile unsigned char*)(0x42D801B0UL))
#define bFM_I2S0_MCR0REG_S0CHN3               *((volatile unsigned char*)(0x42D801B4UL))
#define bFM_I2S0_MCR0REG_S0CHN4               *((volatile unsigned char*)(0x42D801B8UL))
#define bFM_I2S0_MCR0REG_S1WDL0               *((volatile unsigned char*)(0x42D801C0UL))
#define bFM_I2S0_MCR0REG_S1WDL1               *((volatile unsigned char*)(0x42D801C4UL))
#define bFM_I2S0_MCR0REG_S1WDL2               *((volatile unsigned char*)(0x42D801C8UL))
#define bFM_I2S0_MCR0REG_S1WDL3               *((volatile unsigned char*)(0x42D801CCUL))
#define bFM_I2S0_MCR0REG_S1WDL4               *((volatile unsigned char*)(0x42D801D0UL))
#define bFM_I2S0_MCR0REG_S1CHL0               *((volatile unsigned char*)(0x42D801D4UL))
#define bFM_I2S0_MCR0REG_S1CHL1               *((volatile unsigned char*)(0x42D801D8UL))
#define bFM_I2S0_MCR0REG_S1CHL2               *((volatile unsigned char*)(0x42D801DCUL))
#define bFM_I2S0_MCR0REG_S1CHL3               *((volatile unsigned char*)(0x42D801E0UL))
#define bFM_I2S0_MCR0REG_S1CHL4               *((volatile unsigned char*)(0x42D801E4UL))
#define bFM_I2S0_MCR0REG_S1CHN0               *((volatile unsigned char*)(0x42D801E8UL))
#define bFM_I2S0_MCR0REG_S1CHN1               *((volatile unsigned char*)(0x42D801ECUL))
#define bFM_I2S0_MCR0REG_S1CHN2               *((volatile unsigned char*)(0x42D801F0UL))
#define bFM_I2S0_MCR0REG_S1CHN3               *((volatile unsigned char*)(0x42D801F4UL))
#define bFM_I2S0_MCR0REG_S1CHN4               *((volatile unsigned char*)(0x42D801F8UL))
#define bFM_I2S0_MCR1REG_S0CH00               *((volatile unsigned char*)(0x42D80200UL))
#define bFM_I2S0_MCR1REG_S0CH01               *((volatile unsigned char*)(0x42D80204UL))
#define bFM_I2S0_MCR1REG_S0CH02               *((volatile unsigned char*)(0x42D80208UL))
#define bFM_I2S0_MCR1REG_S0CH03               *((volatile unsigned char*)(0x42D8020CUL))
#define bFM_I2S0_MCR1REG_S0CH04               *((volatile unsigned char*)(0x42D80210UL))
#define bFM_I2S0_MCR1REG_S0CH05               *((volatile unsigned char*)(0x42D80214UL))
#define bFM_I2S0_MCR1REG_S0CH06               *((volatile unsigned char*)(0x42D80218UL))
#define bFM_I2S0_MCR1REG_S0CH07               *((volatile unsigned char*)(0x42D8021CUL))
#define bFM_I2S0_MCR1REG_S0CH08               *((volatile unsigned char*)(0x42D80220UL))
#define bFM_I2S0_MCR1REG_S0CH09               *((volatile unsigned char*)(0x42D80224UL))
#define bFM_I2S0_MCR1REG_S0CH10               *((volatile unsigned char*)(0x42D80228UL))
#define bFM_I2S0_MCR1REG_S0CH11               *((volatile unsigned char*)(0x42D8022CUL))
#define bFM_I2S0_MCR1REG_S0CH12               *((volatile unsigned char*)(0x42D80230UL))
#define bFM_I2S0_MCR1REG_S0CH13               *((volatile unsigned char*)(0x42D80234UL))
#define bFM_I2S0_MCR1REG_S0CH14               *((volatile unsigned char*)(0x42D80238UL))
#define bFM_I2S0_MCR1REG_S0CH15               *((volatile unsigned char*)(0x42D8023CUL))
#define bFM_I2S0_MCR1REG_S0CH16               *((volatile unsigned char*)(0x42D80240UL))
#define bFM_I2S0_MCR1REG_S0CH17               *((volatile unsigned char*)(0x42D80244UL))
#define bFM_I2S0_MCR1REG_S0CH18               *((volatile unsigned char*)(0x42D80248UL))
#define bFM_I2S0_MCR1REG_S0CH19               *((volatile unsigned char*)(0x42D8024CUL))
#define bFM_I2S0_MCR1REG_S0CH20               *((volatile unsigned char*)(0x42D80250UL))
#define bFM_I2S0_MCR1REG_S0CH21               *((volatile unsigned char*)(0x42D80254UL))
#define bFM_I2S0_MCR1REG_S0CH22               *((volatile unsigned char*)(0x42D80258UL))
#define bFM_I2S0_MCR1REG_S0CH23               *((volatile unsigned char*)(0x42D8025CUL))
#define bFM_I2S0_MCR1REG_S0CH24               *((volatile unsigned char*)(0x42D80260UL))
#define bFM_I2S0_MCR1REG_S0CH25               *((volatile unsigned char*)(0x42D80264UL))
#define bFM_I2S0_MCR1REG_S0CH26               *((volatile unsigned char*)(0x42D80268UL))
#define bFM_I2S0_MCR1REG_S0CH27               *((volatile unsigned char*)(0x42D8026CUL))
#define bFM_I2S0_MCR1REG_S0CH28               *((volatile unsigned char*)(0x42D80270UL))
#define bFM_I2S0_MCR1REG_S0CH29               *((volatile unsigned char*)(0x42D80274UL))
#define bFM_I2S0_MCR1REG_S0CH30               *((volatile unsigned char*)(0x42D80278UL))
#define bFM_I2S0_MCR1REG_S0CH31               *((volatile unsigned char*)(0x42D8027CUL))
#define bFM_I2S0_MCR2REG_S1CH00               *((volatile unsigned char*)(0x42D80280UL))
#define bFM_I2S0_MCR2REG_S1CH01               *((volatile unsigned char*)(0x42D80284UL))
#define bFM_I2S0_MCR2REG_S1CH02               *((volatile unsigned char*)(0x42D80288UL))
#define bFM_I2S0_MCR2REG_S1CH03               *((volatile unsigned char*)(0x42D8028CUL))
#define bFM_I2S0_MCR2REG_S1CH04               *((volatile unsigned char*)(0x42D80290UL))
#define bFM_I2S0_MCR2REG_S1CH05               *((volatile unsigned char*)(0x42D80294UL))
#define bFM_I2S0_MCR2REG_S1CH06               *((volatile unsigned char*)(0x42D80298UL))
#define bFM_I2S0_MCR2REG_S1CH07               *((volatile unsigned char*)(0x42D8029CUL))
#define bFM_I2S0_MCR2REG_S1CH08               *((volatile unsigned char*)(0x42D802A0UL))
#define bFM_I2S0_MCR2REG_S1CH09               *((volatile unsigned char*)(0x42D802A4UL))
#define bFM_I2S0_MCR2REG_S1CH10               *((volatile unsigned char*)(0x42D802A8UL))
#define bFM_I2S0_MCR2REG_S1CH11               *((volatile unsigned char*)(0x42D802ACUL))
#define bFM_I2S0_MCR2REG_S1CH12               *((volatile unsigned char*)(0x42D802B0UL))
#define bFM_I2S0_MCR2REG_S1CH13               *((volatile unsigned char*)(0x42D802B4UL))
#define bFM_I2S0_MCR2REG_S1CH14               *((volatile unsigned char*)(0x42D802B8UL))
#define bFM_I2S0_MCR2REG_S1CH15               *((volatile unsigned char*)(0x42D802BCUL))
#define bFM_I2S0_MCR2REG_S1CH16               *((volatile unsigned char*)(0x42D802C0UL))
#define bFM_I2S0_MCR2REG_S1CH17               *((volatile unsigned char*)(0x42D802C4UL))
#define bFM_I2S0_MCR2REG_S1CH18               *((volatile unsigned char*)(0x42D802C8UL))
#define bFM_I2S0_MCR2REG_S1CH19               *((volatile unsigned char*)(0x42D802CCUL))
#define bFM_I2S0_MCR2REG_S1CH20               *((volatile unsigned char*)(0x42D802D0UL))
#define bFM_I2S0_MCR2REG_S1CH21               *((volatile unsigned char*)(0x42D802D4UL))
#define bFM_I2S0_MCR2REG_S1CH22               *((volatile unsigned char*)(0x42D802D8UL))
#define bFM_I2S0_MCR2REG_S1CH23               *((volatile unsigned char*)(0x42D802DCUL))
#define bFM_I2S0_MCR2REG_S1CH24               *((volatile unsigned char*)(0x42D802E0UL))
#define bFM_I2S0_MCR2REG_S1CH25               *((volatile unsigned char*)(0x42D802E4UL))
#define bFM_I2S0_MCR2REG_S1CH26               *((volatile unsigned char*)(0x42D802E8UL))
#define bFM_I2S0_MCR2REG_S1CH27               *((volatile unsigned char*)(0x42D802ECUL))
#define bFM_I2S0_MCR2REG_S1CH28               *((volatile unsigned char*)(0x42D802F0UL))
#define bFM_I2S0_MCR2REG_S1CH29               *((volatile unsigned char*)(0x42D802F4UL))
#define bFM_I2S0_MCR2REG_S1CH30               *((volatile unsigned char*)(0x42D802F8UL))
#define bFM_I2S0_MCR2REG_S1CH31               *((volatile unsigned char*)(0x42D802FCUL))
#define bFM_I2S0_OPRREG_START                 *((volatile unsigned char*)(0x42D80300UL))
#define bFM_I2S0_OPRREG_TXENB                 *((volatile unsigned char*)(0x42D80340UL))
#define bFM_I2S0_OPRREG_RXENB                 *((volatile unsigned char*)(0x42D80360UL))
#define bFM_I2S0_SRST_SRST                    *((volatile unsigned char*)(0x42D80380UL))
#define bFM_I2S0_INTCNT_RFTH0                 *((volatile unsigned char*)(0x42D80400UL))
#define bFM_I2S0_INTCNT_RFTH1                 *((volatile unsigned char*)(0x42D80404UL))
#define bFM_I2S0_INTCNT_RFTH2                 *((volatile unsigned char*)(0x42D80408UL))
#define bFM_I2S0_INTCNT_RFTH3                 *((volatile unsigned char*)(0x42D8040CUL))
#define bFM_I2S0_INTCNT_RPTMR0                *((volatile unsigned char*)(0x42D80410UL))
#define bFM_I2S0_INTCNT_RPTMR1                *((volatile unsigned char*)(0x42D80414UL))
#define bFM_I2S0_INTCNT_TFTH0                 *((volatile unsigned char*)(0x42D80420UL))
#define bFM_I2S0_INTCNT_TFTH1                 *((volatile unsigned char*)(0x42D80424UL))
#define bFM_I2S0_INTCNT_TFTH2                 *((volatile unsigned char*)(0x42D80428UL))
#define bFM_I2S0_INTCNT_TFTH3                 *((volatile unsigned char*)(0x42D8042CUL))
#define bFM_I2S0_INTCNT_RXFIM                 *((volatile unsigned char*)(0x42D80440UL))
#define bFM_I2S0_INTCNT_RXFDM                 *((volatile unsigned char*)(0x42D80444UL))
#define bFM_I2S0_INTCNT_EOPM                  *((volatile unsigned char*)(0x42D80448UL))
#define bFM_I2S0_INTCNT_RXOVM                 *((volatile unsigned char*)(0x42D8044CUL))
#define bFM_I2S0_INTCNT_RXUDM                 *((volatile unsigned char*)(0x42D80450UL))
#define bFM_I2S0_INTCNT_RBERM                 *((volatile unsigned char*)(0x42D80454UL))
#define bFM_I2S0_INTCNT_TXFIM                 *((volatile unsigned char*)(0x42D80460UL))
#define bFM_I2S0_INTCNT_TXFDM                 *((volatile unsigned char*)(0x42D80464UL))
#define bFM_I2S0_INTCNT_TXOVM                 *((volatile unsigned char*)(0x42D80468UL))
#define bFM_I2S0_INTCNT_TXUD0M                *((volatile unsigned char*)(0x42D8046CUL))
#define bFM_I2S0_INTCNT_FERRM                 *((volatile unsigned char*)(0x42D80470UL))
#define bFM_I2S0_INTCNT_TBERM                 *((volatile unsigned char*)(0x42D80474UL))
#define bFM_I2S0_INTCNT_TXUD1M                *((volatile unsigned char*)(0x42D80478UL))
#define bFM_I2S0_STATUS_RXNUM0                *((volatile unsigned char*)(0x42D80480UL))
#define bFM_I2S0_STATUS_RXNUM1                *((volatile unsigned char*)(0x42D80484UL))
#define bFM_I2S0_STATUS_RXNUM2                *((volatile unsigned char*)(0x42D80488UL))
#define bFM_I2S0_STATUS_RXNUM3                *((volatile unsigned char*)(0x42D8048CUL))
#define bFM_I2S0_STATUS_RXNUM4                *((volatile unsigned char*)(0x42D80490UL))
#define bFM_I2S0_STATUS_RXNUM5                *((volatile unsigned char*)(0x42D80494UL))
#define bFM_I2S0_STATUS_RXNUM6                *((volatile unsigned char*)(0x42D80498UL))
#define bFM_I2S0_STATUS_RXNUM7                *((volatile unsigned char*)(0x42D8049CUL))
#define bFM_I2S0_STATUS_TXNUM0                *((volatile unsigned char*)(0x42D804A0UL))
#define bFM_I2S0_STATUS_TXNUM1                *((volatile unsigned char*)(0x42D804A4UL))
#define bFM_I2S0_STATUS_TXNUM2                *((volatile unsigned char*)(0x42D804A8UL))
#define bFM_I2S0_STATUS_TXNUM3                *((volatile unsigned char*)(0x42D804ACUL))
#define bFM_I2S0_STATUS_TXNUM4                *((volatile unsigned char*)(0x42D804B0UL))
#define bFM_I2S0_STATUS_TXNUM5                *((volatile unsigned char*)(0x42D804B4UL))
#define bFM_I2S0_STATUS_TXNUM6                *((volatile unsigned char*)(0x42D804B8UL))
#define bFM_I2S0_STATUS_TXNUM7                *((volatile unsigned char*)(0x42D804BCUL))
#define bFM_I2S0_STATUS_RXFI                  *((volatile unsigned char*)(0x42D804C0UL))
#define bFM_I2S0_STATUS_TXFI                  *((volatile unsigned char*)(0x42D804C4UL))
#define bFM_I2S0_STATUS_BSY                   *((volatile unsigned char*)(0x42D804C8UL))
#define bFM_I2S0_STATUS_EOPI                  *((volatile unsigned char*)(0x42D804CCUL))
#define bFM_I2S0_STATUS_RXOVR                 *((volatile unsigned char*)(0x42D804E0UL))
#define bFM_I2S0_STATUS_RXUDR                 *((volatile unsigned char*)(0x42D804E4UL))
#define bFM_I2S0_STATUS_TXOVR                 *((volatile unsigned char*)(0x42D804E8UL))
#define bFM_I2S0_STATUS_TXUDR0                *((volatile unsigned char*)(0x42D804ECUL))
#define bFM_I2S0_STATUS_TXUDR1                *((volatile unsigned char*)(0x42D804F0UL))
#define bFM_I2S0_STATUS_FERR                  *((volatile unsigned char*)(0x42D804F4UL))
#define bFM_I2S0_STATUS_RBERR                 *((volatile unsigned char*)(0x42D804F8UL))
#define bFM_I2S0_STATUS_TBERR                 *((volatile unsigned char*)(0x42D804FCUL))
#define bFM_I2S0_DMAACT_RDMACT                *((volatile unsigned char*)(0x42D80500UL))
#define bFM_I2S0_DMAACT_RL1E0                 *((volatile unsigned char*)(0x42D80520UL))
#define bFM_I2S0_DMAACT_TDMACT                *((volatile unsigned char*)(0x42D80540UL))
#define bFM_I2S0_DMAACT_TL1E0                 *((volatile unsigned char*)(0x42D80560UL))
#define bFM_I2S0_TSTREG_LBMD                  *((volatile unsigned char*)(0x42D80580UL))

/* SD IF registers */
#define bFM_SDIF_STRSFMD_DMAEN                *((volatile unsigned char*)(0x42dc0180UL))
#define bFM_SDIF_STRSFMD_BLCKCNTEN            *((volatile unsigned char*)(0x42dc0184UL))
#define bFM_SDIF_STRSFMD_DTTRSFDIR            *((volatile unsigned char*)(0x42dc0190UL))
#define bFM_SDIF_STRSFMD_BLCKCNTSEL           *((volatile unsigned char*)(0x42dc0194UL))
#define bFM_SDIF_SCMMD_CMDCRCCHKE             *((volatile unsigned char*)(0x42dc01cCUL))
#define bFM_SDIF_SCMMD_CMDIDXCHKE             *((volatile unsigned char*)(0x42dc01d0UL))
#define bFM_SDIF_SCMMD_DATPRESSEL             *((volatile unsigned char*)(0x42dc01d4UL))
#define bFM_SDIF_SPRSTAT_CMDINH               *((volatile unsigned char*)(0x42dc0480UL))
#define bFM_SDIF_SPRSTAT_CMDDAYTINH           *((volatile unsigned char*)(0x42dc0484UL))
#define bFM_SDIF_SPRSTAT_DATLNACT             *((volatile unsigned char*)(0x42dc0488UL))
#define bFM_SDIF_SPRSTAT_RETUNEREQ            *((volatile unsigned char*)(0x42dc048CUL))
#define bFM_SDIF_SPRSTAT_WRTRSFACT            *((volatile unsigned char*)(0x42dc04a0UL))
#define bFM_SDIF_SPRSTAT_RDTRSFACT            *((volatile unsigned char*)(0x42dc04a4UL))
#define bFM_SDIF_SPRSTAT_BUFWREN              *((volatile unsigned char*)(0x42dc04a8UL))
#define bFM_SDIF_SPRSTAT_BUFRDEN              *((volatile unsigned char*)(0x42dc04aCUL))
#define bFM_SDIF_SPRSTAT_CARDINS              *((volatile unsigned char*)(0x42dc04c0UL))
#define bFM_SDIF_SPRSTAT_CARDSTB              *((volatile unsigned char*)(0x42dc04c4UL))
#define bFM_SDIF_SPRSTAT_CARDDET              *((volatile unsigned char*)(0x42dc04c8UL))
#define bFM_SDIF_SPRSTAT_WPPINLVL             *((volatile unsigned char*)(0x42dc04cCUL))
#define bFM_SDIF_SPRSTAT_CMDLNSGN             *((volatile unsigned char*)(0x42dc04e0UL))
#define bFM_SDIF_SHCTL1_LEDCTRL               *((volatile unsigned char*)(0x42dc0500UL))
#define bFM_SDIF_SHCTL1_DATAWIDTH             *((volatile unsigned char*)(0x42dc0504UL))
#define bFM_SDIF_SHCTL1_HIGHSPDEN             *((volatile unsigned char*)(0x42dc0508UL))
#define bFM_SDIF_SHCTL1_EXTDTWIDTH            *((volatile unsigned char*)(0x42dc0514UL))
#define bFM_SDIF_SHCTL1_CDTSTLVL              *((volatile unsigned char*)(0x42dc0518UL))
#define bFM_SDIF_SHCTL1_CDSGNSEL              *((volatile unsigned char*)(0x42dc051CUL))
#define bFM_SDIF_SPWRCTL_SDBUSPWR             *((volatile unsigned char*)(0x42dc0520UL))
#define bFM_SDIF_SBLKGPCTL_BLCKGSTPREQ        *((volatile unsigned char*)(0x42dc0540UL))
#define bFM_SDIF_SBLKGPCTL_CONTREQ            *((volatile unsigned char*)(0x42dc0544UL))
#define bFM_SDIF_SBLKGPCTL_RDWAITCTL          *((volatile unsigned char*)(0x42dc0548UL))
#define bFM_SDIF_SBLKGPCTL_BLCKGAPINT         *((volatile unsigned char*)(0x42dc054CUL))
#define bFM_SDIF_SWKUPCTL_WKUPEVNTEN0         *((volatile unsigned char*)(0x42dc0560UL))
#define bFM_SDIF_SWKUPCTL_WKUPEVNTEN1         *((volatile unsigned char*)(0x42dc0564UL))
#define bFM_SDIF_SWKUPCTL_WKUPEVNTEN2         *((volatile unsigned char*)(0x42dc0568UL))
#define bFM_SDIF_SCLKCTL_INTLCLCKEN           *((volatile unsigned char*)(0x42dc0580UL))
#define bFM_SDIF_SCLKCTL_INTLCLCKST           *((volatile unsigned char*)(0x42dc0584UL))
#define bFM_SDIF_SCLKCTL_SDCLCKEN             *((volatile unsigned char*)(0x42dc0588UL))
#define bFM_SDIF_SCLKCTL_CLCKGENSEL           *((volatile unsigned char*)(0x42dc0594UL))
#define bFM_SDIF_SSRST_SWRSTALL               *((volatile unsigned char*)(0x42dc05e0UL))
#define bFM_SDIF_SSRST_SWRSTCMDLN             *((volatile unsigned char*)(0x42dc05e4UL))
#define bFM_SDIF_SSRST_SWRSTDATLN             *((volatile unsigned char*)(0x42dc05e8UL))
#define bFM_SDIF_SNINTST_CMDCMPLT             *((volatile unsigned char*)(0x42dc0600UL))
#define bFM_SDIF_SNINTST_TRSFCMPLT            *((volatile unsigned char*)(0x42dc0604UL))
#define bFM_SDIF_SNINTST_BLCKGEVNT            *((volatile unsigned char*)(0x42dc0608UL))
#define bFM_SDIF_SNINTST_DMAINT               *((volatile unsigned char*)(0x42dc060CUL))
#define bFM_SDIF_SNINTST_BUFWRRDY             *((volatile unsigned char*)(0x42dc0610UL))
#define bFM_SDIF_SNINTST_BUFRDRDY             *((volatile unsigned char*)(0x42dc0614UL))
#define bFM_SDIF_SNINTST_CARDINS              *((volatile unsigned char*)(0x42dc0618UL))
#define bFM_SDIF_SNINTST_CARDRMV              *((volatile unsigned char*)(0x42dc061CUL))
#define bFM_SDIF_SNINTST_CARDINT              *((volatile unsigned char*)(0x42dc0620UL))
#define bFM_SDIF_SNINTST_INT_A                *((volatile unsigned char*)(0x42dc0624UL))
#define bFM_SDIF_SNINTST_INT_B                *((volatile unsigned char*)(0x42dc0628UL))
#define bFM_SDIF_SNINTST_INT_C                *((volatile unsigned char*)(0x42dc062CUL))
#define bFM_SDIF_SNINTST_RETUNEEVT            *((volatile unsigned char*)(0x42dc0630UL))
#define bFM_SDIF_SNINTST_ERRORINT             *((volatile unsigned char*)(0x42dc063CUL))
#define bFM_SDIF_SEINTST_CMDTOERR             *((volatile unsigned char*)(0x42dc0640UL))
#define bFM_SDIF_SEINTST_CMDCRCERR            *((volatile unsigned char*)(0x42dc0644UL))
#define bFM_SDIF_SEINTST_CMDEBERR             *((volatile unsigned char*)(0x42dc0648UL))
#define bFM_SDIF_SEINTST_CMDIDXERR            *((volatile unsigned char*)(0x42dc064CUL))
#define bFM_SDIF_SEINTST_DTTOERR              *((volatile unsigned char*)(0x42dc0650UL))
#define bFM_SDIF_SEINTST_DTEBERR              *((volatile unsigned char*)(0x42dc0654UL))
#define bFM_SDIF_SEINTST_DTCRCERR             *((volatile unsigned char*)(0x42dc0658UL))
#define bFM_SDIF_SEINTST_CRTLMTERR            *((volatile unsigned char*)(0x42dc065CUL))
#define bFM_SDIF_SEINTST_ACMD12ERR            *((volatile unsigned char*)(0x42dc0660UL))
#define bFM_SDIF_SEINTST_ADMAERR              *((volatile unsigned char*)(0x42dc0664UL))
#define bFM_SDIF_SEINTST_TUNINGERR            *((volatile unsigned char*)(0x42dc0668UL))
#define bFM_SDIF_SEINTST_BTACKERR             *((volatile unsigned char*)(0x42dc0670UL))
#define bFM_SDIF_SEINTST_ACMD19ERR            *((volatile unsigned char*)(0x42dc0674UL))
#define bFM_SDIF_SEINTST_AHBMSTERR            *((volatile unsigned char*)(0x42dc0678UL))
#define bFM_SDIF_SNINTSTE_CMDCMPLTS           *((volatile unsigned char*)(0x42dc0680UL))
#define bFM_SDIF_SNINTSTE_TRSFCMPLTS          *((volatile unsigned char*)(0x42dc0684UL))
#define bFM_SDIF_SNINTSTE_BLCKGEVNTS          *((volatile unsigned char*)(0x42dc0688UL))
#define bFM_SDIF_SNINTSTE_DMAINTS             *((volatile unsigned char*)(0x42dc068CUL))
#define bFM_SDIF_SNINTSTE_BUFWRRDYS           *((volatile unsigned char*)(0x42dc0690UL))
#define bFM_SDIF_SNINTSTE_BUFRDRDYS           *((volatile unsigned char*)(0x42dc0694UL))
#define bFM_SDIF_SNINTSTE_CARDINSS            *((volatile unsigned char*)(0x42dc0698UL))
#define bFM_SDIF_SNINTSTE_CARDRMVS            *((volatile unsigned char*)(0x42dc069CUL))
#define bFM_SDIF_SNINTSTE_CARDINTS            *((volatile unsigned char*)(0x42dc06a0UL))
#define bFM_SDIF_SNINTSTE_INT_AS              *((volatile unsigned char*)(0x42dc06a4UL))
#define bFM_SDIF_SNINTSTE_INT_BS              *((volatile unsigned char*)(0x42dc06a8UL))
#define bFM_SDIF_SNINTSTE_INT_CS              *((volatile unsigned char*)(0x42dc06aCUL))
#define bFM_SDIF_SNINTSTE_RETUNEEVTS          *((volatile unsigned char*)(0x42dc06b0UL))
#define bFM_SDIF_SEINTSTE_CMDTOERRS           *((volatile unsigned char*)(0x42dc06c0UL))
#define bFM_SDIF_SEINTSTE_CMDCRCERRS          *((volatile unsigned char*)(0x42dc06c4UL))
#define bFM_SDIF_SEINTSTE_CMDEBERRS           *((volatile unsigned char*)(0x42dc06c8UL))
#define bFM_SDIF_SEINTSTE_CMDIDXERRS          *((volatile unsigned char*)(0x42dc06cCUL))
#define bFM_SDIF_SEINTSTE_DTTOERRS            *((volatile unsigned char*)(0x42dc06d0UL))
#define bFM_SDIF_SEINTSTE_DTEBERRS            *((volatile unsigned char*)(0x42dc06d4UL))
#define bFM_SDIF_SEINTSTE_DTCRCERRS           *((volatile unsigned char*)(0x42dc06d8UL))
#define bFM_SDIF_SEINTSTE_CRTLMTERRS          *((volatile unsigned char*)(0x42dc06dCUL))
#define bFM_SDIF_SEINTSTE_ACMD12ERRS          *((volatile unsigned char*)(0x42dc06e0UL))
#define bFM_SDIF_SEINTSTE_ADMAERRS            *((volatile unsigned char*)(0x42dc06e4UL))
#define bFM_SDIF_SEINTSTE_TUNINGERRS          *((volatile unsigned char*)(0x42dc06e8UL))
#define bFM_SDIF_SEINTSTE_BTACKERRS           *((volatile unsigned char*)(0x42dc06f0UL))
#define bFM_SDIF_SEINTSTE_ACMD19ERRS          *((volatile unsigned char*)(0x42dc06f4UL))
#define bFM_SDIF_SEINTSTE_AHBMSTERRS          *((volatile unsigned char*)(0x42dc06f8UL))
#define bFM_SDIF_SNINTSGE_CMDCMPLTG           *((volatile unsigned char*)(0x42dc0700UL))
#define bFM_SDIF_SNINTSGE_TRSFCMPLTG          *((volatile unsigned char*)(0x42dc0704UL))
#define bFM_SDIF_SNINTSGE_BLCKGEVNTG          *((volatile unsigned char*)(0x42dc0708UL))
#define bFM_SDIF_SNINTSGE_DMAINTG             *((volatile unsigned char*)(0x42dc070CUL))
#define bFM_SDIF_SNINTSGE_BUFWRRDYG           *((volatile unsigned char*)(0x42dc0710UL))
#define bFM_SDIF_SNINTSGE_BUFRDRDYG           *((volatile unsigned char*)(0x42dc0714UL))
#define bFM_SDIF_SNINTSGE_CARDINSG            *((volatile unsigned char*)(0x42dc0718UL))
#define bFM_SDIF_SNINTSGE_CARDRMVG            *((volatile unsigned char*)(0x42dc071CUL))
#define bFM_SDIF_SNINTSGE_CARDINTG            *((volatile unsigned char*)(0x42dc0720UL))
#define bFM_SDIF_SNINTSGE_INT_AG              *((volatile unsigned char*)(0x42dc0724UL))
#define bFM_SDIF_SNINTSGE_INT_BG              *((volatile unsigned char*)(0x42dc0728UL))
#define bFM_SDIF_SNINTSGE_INT_CG              *((volatile unsigned char*)(0x42dc072CUL))
#define bFM_SDIF_SNINTSGE_RETUNEEVTG          *((volatile unsigned char*)(0x42dc0730UL))
#define bFM_SDIF_SEINTSGE_CMDTOERRG           *((volatile unsigned char*)(0x42dc0740UL))
#define bFM_SDIF_SEINTSGE_CMDCRCERRG          *((volatile unsigned char*)(0x42dc0744UL))
#define bFM_SDIF_SEINTSGE_CMDEBERRG           *((volatile unsigned char*)(0x42dc0748UL))
#define bFM_SDIF_SEINTSGE_CMDIDXERRG          *((volatile unsigned char*)(0x42dc074CUL))
#define bFM_SDIF_SEINTSGE_DTTOERRG            *((volatile unsigned char*)(0x42dc0750UL))
#define bFM_SDIF_SEINTSGE_DTEBERRG            *((volatile unsigned char*)(0x42dc0754UL))
#define bFM_SDIF_SEINTSGE_DTCRCERRG           *((volatile unsigned char*)(0x42dc0758UL))
#define bFM_SDIF_SEINTSGE_CRTLMTERRG          *((volatile unsigned char*)(0x42dc075CUL))
#define bFM_SDIF_SEINTSGE_ACMD12ERRG          *((volatile unsigned char*)(0x42dc0760UL))
#define bFM_SDIF_SEINTSGE_ADMAERRG            *((volatile unsigned char*)(0x42dc0764UL))
#define bFM_SDIF_SEINTSGE_TUNINGERRG          *((volatile unsigned char*)(0x42dc0768UL))
#define bFM_SDIF_SEINTSGE_BTACKERRG           *((volatile unsigned char*)(0x42dc0770UL))
#define bFM_SDIF_SEINTSGE_ACMD19ERRG          *((volatile unsigned char*)(0x42dc0774UL))
#define bFM_SDIF_SEINTSGE_AHBMSTERRG          *((volatile unsigned char*)(0x42dc0778UL))
#define bFM_SDIF_SACMDEST_ACMD12NOEX          *((volatile unsigned char*)(0x42dc0780UL))
#define bFM_SDIF_SACMDEST_ACMDTOERR           *((volatile unsigned char*)(0x42dc0784UL))
#define bFM_SDIF_SACMDEST_ACMDCRCERR          *((volatile unsigned char*)(0x42dc0788UL))
#define bFM_SDIF_SACMDEST_ACMDEBERR           *((volatile unsigned char*)(0x42dc078CUL))
#define bFM_SDIF_SACMDEST_ACMDIDXERR          *((volatile unsigned char*)(0x42dc0790UL))
#define bFM_SDIF_SACMDEST_CMDND12ERR          *((volatile unsigned char*)(0x42dc079CUL))
#define bFM_SDIF_SHCTL2_V18SGNEN              *((volatile unsigned char*)(0x42dc07cCUL))
#define bFM_SDIF_SHCTL2_DOTUING               *((volatile unsigned char*)(0x42dc07d8UL))
#define bFM_SDIF_SHCTL2_SMPCLKSEK             *((volatile unsigned char*)(0x42dc07dCUL))
#define bFM_SDIF_SHCTL2_ASYINTEN              *((volatile unsigned char*)(0x42dc07f8UL))
#define bFM_SDIF_SHCTL2_PREVALEN              *((volatile unsigned char*)(0x42dc07fCUL))
#define bFM_SDIF_CAPBLTY0_TOCLKUNIT           *((volatile unsigned char*)(0x42dc081CUL))
#define bFM_SDIF_CAPBLTY1_EMBD8BIT            *((volatile unsigned char*)(0x42dc0848UL))
#define bFM_SDIF_CAPBLTY1_ADMA2SPT            *((volatile unsigned char*)(0x42dc084CUL))
#define bFM_SDIF_CAPBLTY1_HGHSPDSPT           *((volatile unsigned char*)(0x42dc0854UL))
#define bFM_SDIF_CAPBLTY1_SDMASPT             *((volatile unsigned char*)(0x42dc0858UL))
#define bFM_SDIF_CAPBLTY1_LWPWRSPT            *((volatile unsigned char*)(0x42dc085CUL))
#define bFM_SDIF_CAPBLTY1_V33SPT              *((volatile unsigned char*)(0x42dc0860UL))
#define bFM_SDIF_CAPBLTY1_V30SPT              *((volatile unsigned char*)(0x42dc0864UL))
#define bFM_SDIF_CAPBLTY1_V18SPT              *((volatile unsigned char*)(0x42dc0868UL))
#define bFM_SDIF_CAPBLTY1_BUS64SPT            *((volatile unsigned char*)(0x42dc0870UL))
#define bFM_SDIF_CAPBLTY1_ASYINTSPT           *((volatile unsigned char*)(0x42dc0874UL))
#define bFM_SDIF_CAPBLTY2_SDR50SPT            *((volatile unsigned char*)(0x42dc0880UL))
#define bFM_SDIF_CAPBLTY2_SDR104SPT           *((volatile unsigned char*)(0x42dc0884UL))
#define bFM_SDIF_CAPBLTY2_DDR50SPT            *((volatile unsigned char*)(0x42dc0888UL))
#define bFM_SDIF_CAPBLTY2_DRVTPASPT           *((volatile unsigned char*)(0x42dc0890UL))
#define bFM_SDIF_CAPBLTY2_DRVTPBSPT           *((volatile unsigned char*)(0x42dc0894UL))
#define bFM_SDIF_CAPBLTY2_DRVTPCSPT           *((volatile unsigned char*)(0x42dc0898UL))
#define bFM_SDIF_CAPBLTY2_USETNSDR50          *((volatile unsigned char*)(0x42dc08b4UL))
#define bFM_SDIF_FEACEST_FEVNT12ND            *((volatile unsigned char*)(0x42dc0a00UL))
#define bFM_SDIF_FEACEST_FEVNTTO              *((volatile unsigned char*)(0x42dc0a04UL))
#define bFM_SDIF_FEACEST_FEVNTCRC             *((volatile unsigned char*)(0x42dc0a08UL))
#define bFM_SDIF_FEACEST_FEVNTEB              *((volatile unsigned char*)(0x42dc0a0CUL))
#define bFM_SDIF_FEACEST_FEVNTIDX             *((volatile unsigned char*)(0x42dc0a10UL))
#define bFM_SDIF_FEACEST_FEVNTCMD12           *((volatile unsigned char*)(0x42dc0a1CUL))
#define bFM_SDIF_SFEEIST_FETOERR              *((volatile unsigned char*)(0x42dc0a40UL))
#define bFM_SDIF_SFEEIST_FECRCERR             *((volatile unsigned char*)(0x42dc0a44UL))
#define bFM_SDIF_SFEEIST_FEEBERR              *((volatile unsigned char*)(0x42dc0a48UL))
#define bFM_SDIF_SFEEIST_FEIDXERR             *((volatile unsigned char*)(0x42dc0a4CUL))
#define bFM_SDIF_SFEEIST_FEDTOTERR            *((volatile unsigned char*)(0x42dc0a50UL))
#define bFM_SDIF_SFEEIST_FEDTCRCERR           *((volatile unsigned char*)(0x42dc0a54UL))
#define bFM_SDIF_SFEEIST_FEDTEBERR            *((volatile unsigned char*)(0x42dc0a58UL))
#define bFM_SDIF_SFEEIST_FECRLTERR            *((volatile unsigned char*)(0x42dc0a5CUL))
#define bFM_SDIF_SFEEIST_FEA12ERR             *((volatile unsigned char*)(0x42dc0a60UL))
#define bFM_SDIF_SFEEIST_FEADMAERR            *((volatile unsigned char*)(0x42dc0a64UL))
#define bFM_SDIF_SFEEIST_FETUNEERR            *((volatile unsigned char*)(0x42dc0a68UL))
#define bFM_SDIF_SFEEIST_FEACKERR             *((volatile unsigned char*)(0x42dc0a70UL))
#define bFM_SDIF_SFEEIST_FEA19ERR             *((volatile unsigned char*)(0x42dc0a74UL))
#define bFM_SDIF_SFEEIST_FEAHBMSERR           *((volatile unsigned char*)(0x42dc0a78UL))
#define bFM_SDIF_ADMAEST_ADMALENME            *((volatile unsigned char*)(0x42dc0a88UL))
#define bFM_SDIF_SPRVAL0_CGSELVAL             *((volatile unsigned char*)(0x42dc0c28UL))
#define bFM_SDIF_SPRVAL1_CGSELVAL             *((volatile unsigned char*)(0x42dc0c68UL))
#define bFM_SDIF_SPRVAL2_CGSELVAL             *((volatile unsigned char*)(0x42dc0ca8UL))
#define bFM_SDIF_SPRVAL3_CGSELVAL             *((volatile unsigned char*)(0x42dc0ce8UL))
#define bFM_SDIF_SPRVAL4_CGSELVAL             *((volatile unsigned char*)(0x42dc0d28UL))
#define bFM_SDIF_SPRVAL5_CGSELVAL             *((volatile unsigned char*)(0x42dc0d68UL))
#define bFM_SDIF_SPRVAL6_CGSELVAL             *((volatile unsigned char*)(0x42dc0da8UL))
#define bFM_SDIF_SPRVAL7_CGSELVAL             *((volatile unsigned char*)(0x42dc0de8UL))
#define bFM_SDIF_AHBCFGL_SINEN                *((volatile unsigned char*)(0x42dc200CUL))
#define bFM_SDIF_AHBCFGL_BSLOCK               *((volatile unsigned char*)(0x42dc2010UL))
#define bFM_SDIF_AHBCFGL_BSLOCKSEL            *((volatile unsigned char*)(0x42dc2014UL))
#define bFM_SDIF_AHBCFGL_ENDIANSEL            *((volatile unsigned char*)(0x42dc2018UL))
#define bFM_SDIF_SPWSWCL_ATPWRSWEN            *((volatile unsigned char*)(0x42dc2080UL))
#define bFM_SDIF_SPWSWCL_IOREGSEL             *((volatile unsigned char*)(0x42dc2084UL))
#define bFM_SDIF_STUNSETL_TNPHSELEN           *((volatile unsigned char*)(0x42dc2120UL))
#define bFM_SDIF_STUNSETL_TNERRBDSEL          *((volatile unsigned char*)(0x42dc2124UL))
#define bFM_SDIF_STUNSETL_RETNTAPSEL          *((volatile unsigned char*)(0x42dc2128UL))
#define bFM_SDIF_STUNSETH_CMDCFCHKDS          *((volatile unsigned char*)(0x42dc2140UL))
#define bFM_SDIF_PSWISTL_INT5MS               *((volatile unsigned char*)(0x42dc2300UL))
#define bFM_SDIF_PSWISTL_INT1MS               *((volatile unsigned char*)(0x42dc2304UL))
#define bFM_SDIF_PSWISTEL_INT5MSSTS           *((volatile unsigned char*)(0x42dc2380UL))
#define bFM_SDIF_PSWISTEL_INT1MSSTS           *((volatile unsigned char*)(0x42dc2384UL))
#define bFM_SDIF_PSWISGEL_INT5MSSGEN          *((volatile unsigned char*)(0x42dc2400UL))
#define bFM_SDIF_PSWISGEL_INT1MSSGEN          *((volatile unsigned char*)(0x42dc2404UL))
#define bFM_SDIF_MMCSDCL_LCKRSTESD            *((volatile unsigned char*)(0x42dc2480UL))
#define bFM_SDIF_MMCSDCL_RSTMMC               *((volatile unsigned char*)(0x42dc2484UL))
#define bFM_SDIF_MMCSDCL_VCCCTLMMC            *((volatile unsigned char*)(0x42dc2488UL))
#define bFM_SDIF_MMCSDCL_VCCQCTLMMC           *((volatile unsigned char*)(0x42dc248CUL))
#define bFM_SDIF_MMCSDCL_MMCDDRSEL            *((volatile unsigned char*)(0x42dc24a0UL))
#define bFM_SDIF_MMCSDCL_CMDDATDLY            *((volatile unsigned char*)(0x42dc24a4UL))
#define bFM_SDIF_MMCSDCH_BTACKENMMC           *((volatile unsigned char*)(0x42dc24c0UL))
#define bFM_SDIF_MMCSDCH_BTABTENMMC           *((volatile unsigned char*)(0x42dc24c4UL))
#define bFM_SDIF_MMCSDCH_BTMDENMMC            *((volatile unsigned char*)(0x42dc24c8UL))
#define bFM_SDIF_MCWIRQC0_WTIRQEN             *((volatile unsigned char*)(0x42dc2500UL))
#define bFM_SDIF_MCWIRQC0_WTIRQST             *((volatile unsigned char*)(0x42dc2504UL))

/* CAN FD registers */
#define bFM_CANFD_CREL_DAY0                   *((volatile unsigned char*)(0x42E00000UL))
#define bFM_CANFD_CREL_DAY1                   *((volatile unsigned char*)(0x42E00004UL))
#define bFM_CANFD_CREL_DAY2                   *((volatile unsigned char*)(0x42E00008UL))
#define bFM_CANFD_CREL_DAY3                   *((volatile unsigned char*)(0x42E0000CUL))
#define bFM_CANFD_CREL_DAY4                   *((volatile unsigned char*)(0x42E00010UL))
#define bFM_CANFD_CREL_DAY5                   *((volatile unsigned char*)(0x42E00014UL))
#define bFM_CANFD_CREL_DAY6                   *((volatile unsigned char*)(0x42E00018UL))
#define bFM_CANFD_CREL_DAY7                   *((volatile unsigned char*)(0x42E0001CUL))
#define bFM_CANFD_CREL_MON0                   *((volatile unsigned char*)(0x42E00020UL))
#define bFM_CANFD_CREL_MON1                   *((volatile unsigned char*)(0x42E00024UL))
#define bFM_CANFD_CREL_MON2                   *((volatile unsigned char*)(0x42E00028UL))
#define bFM_CANFD_CREL_MON3                   *((volatile unsigned char*)(0x42E0002CUL))
#define bFM_CANFD_CREL_MON4                   *((volatile unsigned char*)(0x42E00030UL))
#define bFM_CANFD_CREL_MON5                   *((volatile unsigned char*)(0x42E00034UL))
#define bFM_CANFD_CREL_MON6                   *((volatile unsigned char*)(0x42E00038UL))
#define bFM_CANFD_CREL_MON7                   *((volatile unsigned char*)(0x42E0003CUL))
#define bFM_CANFD_CREL_YEAR0                  *((volatile unsigned char*)(0x42E00040UL))
#define bFM_CANFD_CREL_YEAR1                  *((volatile unsigned char*)(0x42E00044UL))
#define bFM_CANFD_CREL_YEAR2                  *((volatile unsigned char*)(0x42E00048UL))
#define bFM_CANFD_CREL_YEAR3                  *((volatile unsigned char*)(0x42E0004CUL))
#define bFM_CANFD_CREL_SUBSTEP0               *((volatile unsigned char*)(0x42E00050UL))
#define bFM_CANFD_CREL_SUBSTEP1               *((volatile unsigned char*)(0x42E00054UL))
#define bFM_CANFD_CREL_SUBSTEP2               *((volatile unsigned char*)(0x42E00058UL))
#define bFM_CANFD_CREL_SUBSTEP3               *((volatile unsigned char*)(0x42E0005CUL))
#define bFM_CANFD_CREL_STEP0                  *((volatile unsigned char*)(0x42E00060UL))
#define bFM_CANFD_CREL_STEP1                  *((volatile unsigned char*)(0x42E00064UL))
#define bFM_CANFD_CREL_STEP2                  *((volatile unsigned char*)(0x42E00068UL))
#define bFM_CANFD_CREL_STEP3                  *((volatile unsigned char*)(0x42E0006CUL))
#define bFM_CANFD_CREL_REL0                   *((volatile unsigned char*)(0x42E00070UL))
#define bFM_CANFD_CREL_REL1                   *((volatile unsigned char*)(0x42E00074UL))
#define bFM_CANFD_CREL_REL2                   *((volatile unsigned char*)(0x42E00078UL))
#define bFM_CANFD_CREL_REL3                   *((volatile unsigned char*)(0x42E0007CUL))
#define bFM_CANFD_ENDN_ETV0                   *((volatile unsigned char*)(0x42E00080UL))
#define bFM_CANFD_ENDN_ETV1                   *((volatile unsigned char*)(0x42E00084UL))
#define bFM_CANFD_ENDN_ETV2                   *((volatile unsigned char*)(0x42E00088UL))
#define bFM_CANFD_ENDN_ETV3                   *((volatile unsigned char*)(0x42E0008CUL))
#define bFM_CANFD_ENDN_ETV4                   *((volatile unsigned char*)(0x42E00090UL))
#define bFM_CANFD_ENDN_ETV5                   *((volatile unsigned char*)(0x42E00094UL))
#define bFM_CANFD_ENDN_ETV6                   *((volatile unsigned char*)(0x42E00098UL))
#define bFM_CANFD_ENDN_ETV7                   *((volatile unsigned char*)(0x42E0009CUL))
#define bFM_CANFD_ENDN_ETV8                   *((volatile unsigned char*)(0x42E000A0UL))
#define bFM_CANFD_ENDN_ETV9                   *((volatile unsigned char*)(0x42E000A4UL))
#define bFM_CANFD_ENDN_ETV10                  *((volatile unsigned char*)(0x42E000A8UL))
#define bFM_CANFD_ENDN_ETV11                  *((volatile unsigned char*)(0x42E000ACUL))
#define bFM_CANFD_ENDN_ETV12                  *((volatile unsigned char*)(0x42E000B0UL))
#define bFM_CANFD_ENDN_ETV13                  *((volatile unsigned char*)(0x42E000B4UL))
#define bFM_CANFD_ENDN_ETV14                  *((volatile unsigned char*)(0x42E000B8UL))
#define bFM_CANFD_ENDN_ETV15                  *((volatile unsigned char*)(0x42E000BCUL))
#define bFM_CANFD_ENDN_ETV16                  *((volatile unsigned char*)(0x42E000C0UL))
#define bFM_CANFD_ENDN_ETV17                  *((volatile unsigned char*)(0x42E000C4UL))
#define bFM_CANFD_ENDN_ETV18                  *((volatile unsigned char*)(0x42E000C8UL))
#define bFM_CANFD_ENDN_ETV19                  *((volatile unsigned char*)(0x42E000CCUL))
#define bFM_CANFD_ENDN_ETV20                  *((volatile unsigned char*)(0x42E000D0UL))
#define bFM_CANFD_ENDN_ETV21                  *((volatile unsigned char*)(0x42E000D4UL))
#define bFM_CANFD_ENDN_ETV22                  *((volatile unsigned char*)(0x42E000D8UL))
#define bFM_CANFD_ENDN_ETV23                  *((volatile unsigned char*)(0x42E000DCUL))
#define bFM_CANFD_ENDN_ETV24                  *((volatile unsigned char*)(0x42E000E0UL))
#define bFM_CANFD_ENDN_ETV25                  *((volatile unsigned char*)(0x42E000E4UL))
#define bFM_CANFD_ENDN_ETV26                  *((volatile unsigned char*)(0x42E000E8UL))
#define bFM_CANFD_ENDN_ETV27                  *((volatile unsigned char*)(0x42E000ECUL))
#define bFM_CANFD_ENDN_ETV28                  *((volatile unsigned char*)(0x42E000F0UL))
#define bFM_CANFD_ENDN_ETV29                  *((volatile unsigned char*)(0x42E000F4UL))
#define bFM_CANFD_ENDN_ETV30                  *((volatile unsigned char*)(0x42E000F8UL))
#define bFM_CANFD_ENDN_ETV31                  *((volatile unsigned char*)(0x42E000FCUL))
#define bFM_CANFD_FBTP_FSJW0                  *((volatile unsigned char*)(0x42E00180UL))
#define bFM_CANFD_FBTP_FSJW1                  *((volatile unsigned char*)(0x42E00184UL))
#define bFM_CANFD_FBTP_FTSEG20                *((volatile unsigned char*)(0x42E00190UL))
#define bFM_CANFD_FBTP_FTSEG21                *((volatile unsigned char*)(0x42E00194UL))
#define bFM_CANFD_FBTP_FTSEG22                *((volatile unsigned char*)(0x42E00198UL))
#define bFM_CANFD_FBTP_FTSEG10                *((volatile unsigned char*)(0x42E001A0UL))
#define bFM_CANFD_FBTP_FTSEG11                *((volatile unsigned char*)(0x42E001A4UL))
#define bFM_CANFD_FBTP_FTSEG12                *((volatile unsigned char*)(0x42E001A8UL))
#define bFM_CANFD_FBTP_FTSEG13                *((volatile unsigned char*)(0x42E001ACUL))
#define bFM_CANFD_FBTP_FBRP0                  *((volatile unsigned char*)(0x42E001C0UL))
#define bFM_CANFD_FBTP_FBRP1                  *((volatile unsigned char*)(0x42E001C4UL))
#define bFM_CANFD_FBTP_FBRP2                  *((volatile unsigned char*)(0x42E001C8UL))
#define bFM_CANFD_FBTP_FBRP3                  *((volatile unsigned char*)(0x42E001CCUL))
#define bFM_CANFD_FBTP_FBRP4                  *((volatile unsigned char*)(0x42E001D0UL))
#define bFM_CANFD_FBTP_TDC                    *((volatile unsigned char*)(0x42E001DCUL))
#define bFM_CANFD_FBTP_TDCO0                  *((volatile unsigned char*)(0x42E001E0UL))
#define bFM_CANFD_FBTP_TDCO1                  *((volatile unsigned char*)(0x42E001E4UL))
#define bFM_CANFD_FBTP_TDCO2                  *((volatile unsigned char*)(0x42E001E8UL))
#define bFM_CANFD_FBTP_TDCO3                  *((volatile unsigned char*)(0x42E001ECUL))
#define bFM_CANFD_FBTP_TDCO4                  *((volatile unsigned char*)(0x42E001F0UL))
#define bFM_CANFD_TEST_LBCK                   *((volatile unsigned char*)(0x42E00210UL))
#define bFM_CANFD_TEST_TX0                    *((volatile unsigned char*)(0x42E00214UL))
#define bFM_CANFD_TEST_TX1                    *((volatile unsigned char*)(0x42E00218UL))
#define bFM_CANFD_TEST_RX                     *((volatile unsigned char*)(0x42E0021CUL))
#define bFM_CANFD_TEST_TDCV0                  *((volatile unsigned char*)(0x42E00220UL))
#define bFM_CANFD_TEST_TDCV1                  *((volatile unsigned char*)(0x42E00224UL))
#define bFM_CANFD_TEST_TDCV2                  *((volatile unsigned char*)(0x42E00228UL))
#define bFM_CANFD_TEST_TDCV3                  *((volatile unsigned char*)(0x42E0022CUL))
#define bFM_CANFD_TEST_TDCV4                  *((volatile unsigned char*)(0x42E00230UL))
#define bFM_CANFD_TEST_TDCV5                  *((volatile unsigned char*)(0x42E00234UL))
#define bFM_CANFD_RWD_WDC0                    *((volatile unsigned char*)(0x42E00280UL))
#define bFM_CANFD_RWD_WDC1                    *((volatile unsigned char*)(0x42E00284UL))
#define bFM_CANFD_RWD_WDC2                    *((volatile unsigned char*)(0x42E00288UL))
#define bFM_CANFD_RWD_WDC3                    *((volatile unsigned char*)(0x42E0028CUL))
#define bFM_CANFD_RWD_WDC4                    *((volatile unsigned char*)(0x42E00290UL))
#define bFM_CANFD_RWD_WDC5                    *((volatile unsigned char*)(0x42E00294UL))
#define bFM_CANFD_RWD_WDC6                    *((volatile unsigned char*)(0x42E00298UL))
#define bFM_CANFD_RWD_WDC7                    *((volatile unsigned char*)(0x42E0029CUL))
#define bFM_CANFD_RWD_WDV0                    *((volatile unsigned char*)(0x42E002A0UL))
#define bFM_CANFD_RWD_WDV1                    *((volatile unsigned char*)(0x42E002A4UL))
#define bFM_CANFD_RWD_WDV2                    *((volatile unsigned char*)(0x42E002A8UL))
#define bFM_CANFD_RWD_WDV3                    *((volatile unsigned char*)(0x42E002ACUL))
#define bFM_CANFD_RWD_WDV4                    *((volatile unsigned char*)(0x42E002B0UL))
#define bFM_CANFD_RWD_WDV5                    *((volatile unsigned char*)(0x42E002B4UL))
#define bFM_CANFD_RWD_WDV6                    *((volatile unsigned char*)(0x42E002B8UL))
#define bFM_CANFD_RWD_WDV7                    *((volatile unsigned char*)(0x42E002BCUL))
#define bFM_CANFD_CCCR_INIT                   *((volatile unsigned char*)(0x42E00300UL))
#define bFM_CANFD_CCCR_CCE                    *((volatile unsigned char*)(0x42E00304UL))
#define bFM_CANFD_CCCR_ASM                    *((volatile unsigned char*)(0x42E00308UL))
#define bFM_CANFD_CCCR_CSA                    *((volatile unsigned char*)(0x42E0030CUL))
#define bFM_CANFD_CCCR_CSR                    *((volatile unsigned char*)(0x42E00310UL))
#define bFM_CANFD_CCCR_MON                    *((volatile unsigned char*)(0x42E00314UL))
#define bFM_CANFD_CCCR_DAR                    *((volatile unsigned char*)(0x42E00318UL))
#define bFM_CANFD_CCCR_TEST                   *((volatile unsigned char*)(0x42E0031CUL))
#define bFM_CANFD_CCCR_CME0                   *((volatile unsigned char*)(0x42E00320UL))
#define bFM_CANFD_CCCR_CME1                   *((volatile unsigned char*)(0x42E00324UL))
#define bFM_CANFD_CCCR_CMR0                   *((volatile unsigned char*)(0x42E00328UL))
#define bFM_CANFD_CCCR_CMR1                   *((volatile unsigned char*)(0x42E0032CUL))
#define bFM_CANFD_CCCR_FDO                    *((volatile unsigned char*)(0x42E00330UL))
#define bFM_CANFD_CCCR_FDBS                   *((volatile unsigned char*)(0x42E00334UL))
#define bFM_CANFD_CCCR_TXP                    *((volatile unsigned char*)(0x42E00338UL))
#define bFM_CANFD_BTP_SJW0                    *((volatile unsigned char*)(0x42E00380UL))
#define bFM_CANFD_BTP_SJW1                    *((volatile unsigned char*)(0x42E00384UL))
#define bFM_CANFD_BTP_SJW2                    *((volatile unsigned char*)(0x42E00388UL))
#define bFM_CANFD_BTP_SJW3                    *((volatile unsigned char*)(0x42E0038CUL))
#define bFM_CANFD_BTP_TSEG20                  *((volatile unsigned char*)(0x42E00390UL))
#define bFM_CANFD_BTP_TSEG21                  *((volatile unsigned char*)(0x42E00394UL))
#define bFM_CANFD_BTP_TSEG22                  *((volatile unsigned char*)(0x42E00398UL))
#define bFM_CANFD_BTP_TSEG23                  *((volatile unsigned char*)(0x42E0039CUL))
#define bFM_CANFD_BTP_TSEG10                  *((volatile unsigned char*)(0x42E003A0UL))
#define bFM_CANFD_BTP_TSEG11                  *((volatile unsigned char*)(0x42E003A4UL))
#define bFM_CANFD_BTP_TSEG12                  *((volatile unsigned char*)(0x42E003A8UL))
#define bFM_CANFD_BTP_TSEG13                  *((volatile unsigned char*)(0x42E003ACUL))
#define bFM_CANFD_BTP_TSEG14                  *((volatile unsigned char*)(0x42E003B0UL))
#define bFM_CANFD_BTP_TSEG15                  *((volatile unsigned char*)(0x42E003B4UL))
#define bFM_CANFD_BTP_BRP0                    *((volatile unsigned char*)(0x42E003C0UL))
#define bFM_CANFD_BTP_BRP1                    *((volatile unsigned char*)(0x42E003C4UL))
#define bFM_CANFD_BTP_BRP2                    *((volatile unsigned char*)(0x42E003C8UL))
#define bFM_CANFD_BTP_BRP3                    *((volatile unsigned char*)(0x42E003CCUL))
#define bFM_CANFD_BTP_BRP4                    *((volatile unsigned char*)(0x42E003D0UL))
#define bFM_CANFD_BTP_BRP5                    *((volatile unsigned char*)(0x42E003D4UL))
#define bFM_CANFD_BTP_BRP6                    *((volatile unsigned char*)(0x42E003D8UL))
#define bFM_CANFD_BTP_BRP7                    *((volatile unsigned char*)(0x42E003DCUL))
#define bFM_CANFD_BTP_BRP8                    *((volatile unsigned char*)(0x42E003E0UL))
#define bFM_CANFD_BTP_BRP9                    *((volatile unsigned char*)(0x42E003E4UL))
#define bFM_CANFD_TSCC_TSS0                   *((volatile unsigned char*)(0x42E00400UL))
#define bFM_CANFD_TSCC_TSS1                   *((volatile unsigned char*)(0x42E00404UL))
#define bFM_CANFD_TSCC_TCP0                   *((volatile unsigned char*)(0x42E00440UL))
#define bFM_CANFD_TSCC_TCP1                   *((volatile unsigned char*)(0x42E00444UL))
#define bFM_CANFD_TSCC_TCP2                   *((volatile unsigned char*)(0x42E00448UL))
#define bFM_CANFD_TSCC_TCP3                   *((volatile unsigned char*)(0x42E0044CUL))
#define bFM_CANFD_TSCV_TSC0                   *((volatile unsigned char*)(0x42E00480UL))
#define bFM_CANFD_TSCV_TSC1                   *((volatile unsigned char*)(0x42E00484UL))
#define bFM_CANFD_TSCV_TSC2                   *((volatile unsigned char*)(0x42E00488UL))
#define bFM_CANFD_TSCV_TSC3                   *((volatile unsigned char*)(0x42E0048CUL))
#define bFM_CANFD_TSCV_TSC4                   *((volatile unsigned char*)(0x42E00490UL))
#define bFM_CANFD_TSCV_TSC5                   *((volatile unsigned char*)(0x42E00494UL))
#define bFM_CANFD_TSCV_TSC6                   *((volatile unsigned char*)(0x42E00498UL))
#define bFM_CANFD_TSCV_TSC7                   *((volatile unsigned char*)(0x42E0049CUL))
#define bFM_CANFD_TSCV_TSC8                   *((volatile unsigned char*)(0x42E004A0UL))
#define bFM_CANFD_TSCV_TSC9                   *((volatile unsigned char*)(0x42E004A4UL))
#define bFM_CANFD_TSCV_TSC10                  *((volatile unsigned char*)(0x42E004A8UL))
#define bFM_CANFD_TSCV_TSC11                  *((volatile unsigned char*)(0x42E004ACUL))
#define bFM_CANFD_TSCV_TSC12                  *((volatile unsigned char*)(0x42E004B0UL))
#define bFM_CANFD_TSCV_TSC13                  *((volatile unsigned char*)(0x42E004B4UL))
#define bFM_CANFD_TSCV_TSC14                  *((volatile unsigned char*)(0x42E004B8UL))
#define bFM_CANFD_TSCV_TSC15                  *((volatile unsigned char*)(0x42E004BCUL))
#define bFM_CANFD_TOCC_ETOC                   *((volatile unsigned char*)(0x42E00500UL))
#define bFM_CANFD_TOCC_TOS0                   *((volatile unsigned char*)(0x42E00504UL))
#define bFM_CANFD_TOCC_TOS1                   *((volatile unsigned char*)(0x42E00508UL))
#define bFM_CANFD_TOCC_TOP0                   *((volatile unsigned char*)(0x42E00540UL))
#define bFM_CANFD_TOCC_TOP1                   *((volatile unsigned char*)(0x42E00544UL))
#define bFM_CANFD_TOCC_TOP2                   *((volatile unsigned char*)(0x42E00548UL))
#define bFM_CANFD_TOCC_TOP3                   *((volatile unsigned char*)(0x42E0054CUL))
#define bFM_CANFD_TOCC_TOP4                   *((volatile unsigned char*)(0x42E00550UL))
#define bFM_CANFD_TOCC_TOP5                   *((volatile unsigned char*)(0x42E00554UL))
#define bFM_CANFD_TOCC_TOP6                   *((volatile unsigned char*)(0x42E00558UL))
#define bFM_CANFD_TOCC_TOP7                   *((volatile unsigned char*)(0x42E0055CUL))
#define bFM_CANFD_TOCC_TOP8                   *((volatile unsigned char*)(0x42E00560UL))
#define bFM_CANFD_TOCC_TOP9                   *((volatile unsigned char*)(0x42E00564UL))
#define bFM_CANFD_TOCC_TOP10                  *((volatile unsigned char*)(0x42E00568UL))
#define bFM_CANFD_TOCC_TOP11                  *((volatile unsigned char*)(0x42E0056CUL))
#define bFM_CANFD_TOCC_TOP12                  *((volatile unsigned char*)(0x42E00570UL))
#define bFM_CANFD_TOCC_TOP13                  *((volatile unsigned char*)(0x42E00574UL))
#define bFM_CANFD_TOCC_TOP14                  *((volatile unsigned char*)(0x42E00578UL))
#define bFM_CANFD_TOCC_TOP15                  *((volatile unsigned char*)(0x42E0057CUL))
#define bFM_CANFD_TOCV_TOC0                   *((volatile unsigned char*)(0x42E00580UL))
#define bFM_CANFD_TOCV_TOC1                   *((volatile unsigned char*)(0x42E00584UL))
#define bFM_CANFD_TOCV_TOC2                   *((volatile unsigned char*)(0x42E00588UL))
#define bFM_CANFD_TOCV_TOC3                   *((volatile unsigned char*)(0x42E0058CUL))
#define bFM_CANFD_TOCV_TOC4                   *((volatile unsigned char*)(0x42E00590UL))
#define bFM_CANFD_TOCV_TOC5                   *((volatile unsigned char*)(0x42E00594UL))
#define bFM_CANFD_TOCV_TOC6                   *((volatile unsigned char*)(0x42E00598UL))
#define bFM_CANFD_TOCV_TOC7                   *((volatile unsigned char*)(0x42E0059CUL))
#define bFM_CANFD_TOCV_TOC8                   *((volatile unsigned char*)(0x42E005A0UL))
#define bFM_CANFD_TOCV_TOC9                   *((volatile unsigned char*)(0x42E005A4UL))
#define bFM_CANFD_TOCV_TOC10                  *((volatile unsigned char*)(0x42E005A8UL))
#define bFM_CANFD_TOCV_TOC11                  *((volatile unsigned char*)(0x42E005ACUL))
#define bFM_CANFD_TOCV_TOC12                  *((volatile unsigned char*)(0x42E005B0UL))
#define bFM_CANFD_TOCV_TOC13                  *((volatile unsigned char*)(0x42E005B4UL))
#define bFM_CANFD_TOCV_TOC14                  *((volatile unsigned char*)(0x42E005B8UL))
#define bFM_CANFD_TOCV_TOC15                  *((volatile unsigned char*)(0x42E005BCUL))
#define bFM_CANFD_ECR_TEC0                    *((volatile unsigned char*)(0x42E00800UL))
#define bFM_CANFD_ECR_TEC1                    *((volatile unsigned char*)(0x42E00804UL))
#define bFM_CANFD_ECR_TEC2                    *((volatile unsigned char*)(0x42E00808UL))
#define bFM_CANFD_ECR_TEC3                    *((volatile unsigned char*)(0x42E0080CUL))
#define bFM_CANFD_ECR_TEC4                    *((volatile unsigned char*)(0x42E00810UL))
#define bFM_CANFD_ECR_TEC5                    *((volatile unsigned char*)(0x42E00814UL))
#define bFM_CANFD_ECR_TEC6                    *((volatile unsigned char*)(0x42E00818UL))
#define bFM_CANFD_ECR_TEC7                    *((volatile unsigned char*)(0x42E0081CUL))
#define bFM_CANFD_ECR_REC0                    *((volatile unsigned char*)(0x42E00820UL))
#define bFM_CANFD_ECR_REC1                    *((volatile unsigned char*)(0x42E00824UL))
#define bFM_CANFD_ECR_REC2                    *((volatile unsigned char*)(0x42E00828UL))
#define bFM_CANFD_ECR_REC3                    *((volatile unsigned char*)(0x42E0082CUL))
#define bFM_CANFD_ECR_REC4                    *((volatile unsigned char*)(0x42E00830UL))
#define bFM_CANFD_ECR_REC5                    *((volatile unsigned char*)(0x42E00834UL))
#define bFM_CANFD_ECR_REC6                    *((volatile unsigned char*)(0x42E00838UL))
#define bFM_CANFD_ECR_RP                      *((volatile unsigned char*)(0x42E0083CUL))
#define bFM_CANFD_ECR_CEL0                    *((volatile unsigned char*)(0x42E00840UL))
#define bFM_CANFD_ECR_CEL1                    *((volatile unsigned char*)(0x42E00844UL))
#define bFM_CANFD_ECR_CEL2                    *((volatile unsigned char*)(0x42E00848UL))
#define bFM_CANFD_ECR_CEL3                    *((volatile unsigned char*)(0x42E0084CUL))
#define bFM_CANFD_ECR_CEL4                    *((volatile unsigned char*)(0x42E00850UL))
#define bFM_CANFD_ECR_CEL5                    *((volatile unsigned char*)(0x42E00854UL))
#define bFM_CANFD_ECR_CEL6                    *((volatile unsigned char*)(0x42E00858UL))
#define bFM_CANFD_ECR_CEL7                    *((volatile unsigned char*)(0x42E0085CUL))
#define bFM_CANFD_PSR_LEC0                    *((volatile unsigned char*)(0x42E00880UL))
#define bFM_CANFD_PSR_LEC1                    *((volatile unsigned char*)(0x42E00884UL))
#define bFM_CANFD_PSR_LEC2                    *((volatile unsigned char*)(0x42E00888UL))
#define bFM_CANFD_PSR_ACT0                    *((volatile unsigned char*)(0x42E0088CUL))
#define bFM_CANFD_PSR_ACT1                    *((volatile unsigned char*)(0x42E00890UL))
#define bFM_CANFD_PSR_EP                      *((volatile unsigned char*)(0x42E00894UL))
#define bFM_CANFD_PSR_EW                      *((volatile unsigned char*)(0x42E00898UL))
#define bFM_CANFD_PSR_BO                      *((volatile unsigned char*)(0x42E0089CUL))
#define bFM_CANFD_PSR_FLEC0                   *((volatile unsigned char*)(0x42E008A0UL))
#define bFM_CANFD_PSR_FLEC1                   *((volatile unsigned char*)(0x42E008A4UL))
#define bFM_CANFD_PSR_FLEC2                   *((volatile unsigned char*)(0x42E008A8UL))
#define bFM_CANFD_PSR_RESI                    *((volatile unsigned char*)(0x42E008ACUL))
#define bFM_CANFD_PSR_RBRS                    *((volatile unsigned char*)(0x42E008B0UL))
#define bFM_CANFD_PSR_REDL                    *((volatile unsigned char*)(0x42E008B4UL))
#define bFM_CANFD_IR_RF0N                     *((volatile unsigned char*)(0x42E00A00UL))
#define bFM_CANFD_IR_RF0W                     *((volatile unsigned char*)(0x42E00A04UL))
#define bFM_CANFD_IR_RF0F                     *((volatile unsigned char*)(0x42E00A08UL))
#define bFM_CANFD_IR_RF0L                     *((volatile unsigned char*)(0x42E00A0CUL))
#define bFM_CANFD_IR_RF1N                     *((volatile unsigned char*)(0x42E00A10UL))
#define bFM_CANFD_IR_RF1W                     *((volatile unsigned char*)(0x42E00A14UL))
#define bFM_CANFD_IR_RF1F                     *((volatile unsigned char*)(0x42E00A18UL))
#define bFM_CANFD_IR_RF1L                     *((volatile unsigned char*)(0x42E00A1CUL))
#define bFM_CANFD_IR_HPM                      *((volatile unsigned char*)(0x42E00A20UL))
#define bFM_CANFD_IR_TC                       *((volatile unsigned char*)(0x42E00A24UL))
#define bFM_CANFD_IR_TCF                      *((volatile unsigned char*)(0x42E00A28UL))
#define bFM_CANFD_IR_TFE                      *((volatile unsigned char*)(0x42E00A2CUL))
#define bFM_CANFD_IR_TEFN                     *((volatile unsigned char*)(0x42E00A30UL))
#define bFM_CANFD_IR_TEFW                     *((volatile unsigned char*)(0x42E00A34UL))
#define bFM_CANFD_IR_TEFF                     *((volatile unsigned char*)(0x42E00A38UL))
#define bFM_CANFD_IR_TEFL                     *((volatile unsigned char*)(0x42E00A3CUL))
#define bFM_CANFD_IR_TSW                      *((volatile unsigned char*)(0x42E00A40UL))
#define bFM_CANFD_IR_MRAF                     *((volatile unsigned char*)(0x42E00A44UL))
#define bFM_CANFD_IR_TOO                      *((volatile unsigned char*)(0x42E00A48UL))
#define bFM_CANFD_IR_DRX                      *((volatile unsigned char*)(0x42E00A4CUL))
#define bFM_CANFD_IR_BEC                      *((volatile unsigned char*)(0x42E00A50UL))
#define bFM_CANFD_IR_BEU                      *((volatile unsigned char*)(0x42E00A54UL))
#define bFM_CANFD_IR_ELO                      *((volatile unsigned char*)(0x42E00A58UL))
#define bFM_CANFD_IR_EP                       *((volatile unsigned char*)(0x42E00A5CUL))
#define bFM_CANFD_IR_EW                       *((volatile unsigned char*)(0x42E00A60UL))
#define bFM_CANFD_IR_BO                       *((volatile unsigned char*)(0x42E00A64UL))
#define bFM_CANFD_IR_WDI                      *((volatile unsigned char*)(0x42E00A68UL))
#define bFM_CANFD_IR_CRCE                     *((volatile unsigned char*)(0x42E00A6CUL))
#define bFM_CANFD_IR_BE                       *((volatile unsigned char*)(0x42E00A70UL))
#define bFM_CANFD_IR_ACKE                     *((volatile unsigned char*)(0x42E00A74UL))
#define bFM_CANFD_IR_FOE                      *((volatile unsigned char*)(0x42E00A78UL))
#define bFM_CANFD_IR_STE                      *((volatile unsigned char*)(0x42E00A7CUL))
#define bFM_CANFD_IE_RF0NE                    *((volatile unsigned char*)(0x42E00A80UL))
#define bFM_CANFD_IE_RF0WE                    *((volatile unsigned char*)(0x42E00A84UL))
#define bFM_CANFD_IE_RF0FE                    *((volatile unsigned char*)(0x42E00A88UL))
#define bFM_CANFD_IE_RF0LE                    *((volatile unsigned char*)(0x42E00A8CUL))
#define bFM_CANFD_IE_RF1NE                    *((volatile unsigned char*)(0x42E00A90UL))
#define bFM_CANFD_IE_RF1WE                    *((volatile unsigned char*)(0x42E00A94UL))
#define bFM_CANFD_IE_RF1FE                    *((volatile unsigned char*)(0x42E00A98UL))
#define bFM_CANFD_IE_RF1LE                    *((volatile unsigned char*)(0x42E00A9CUL))
#define bFM_CANFD_IE_HPME                     *((volatile unsigned char*)(0x42E00AA0UL))
#define bFM_CANFD_IE_TCE                      *((volatile unsigned char*)(0x42E00AA4UL))
#define bFM_CANFD_IE_TCFE                     *((volatile unsigned char*)(0x42E00AA8UL))
#define bFM_CANFD_IE_TFEE                     *((volatile unsigned char*)(0x42E00AACUL))
#define bFM_CANFD_IE_TEFNE                    *((volatile unsigned char*)(0x42E00AB0UL))
#define bFM_CANFD_IE_TEFWE                    *((volatile unsigned char*)(0x42E00AB4UL))
#define bFM_CANFD_IE_TEFFE                    *((volatile unsigned char*)(0x42E00AB8UL))
#define bFM_CANFD_IE_TEFLE                    *((volatile unsigned char*)(0x42E00ABCUL))
#define bFM_CANFD_IE_TSWE                     *((volatile unsigned char*)(0x42E00AC0UL))
#define bFM_CANFD_IE_MRAFE                    *((volatile unsigned char*)(0x42E00AC4UL))
#define bFM_CANFD_IE_TOOE                     *((volatile unsigned char*)(0x42E00AC8UL))
#define bFM_CANFD_IE_DRXE                     *((volatile unsigned char*)(0x42E00ACCUL))
#define bFM_CANFD_IE_BECE                     *((volatile unsigned char*)(0x42E00AD0UL))
#define bFM_CANFD_IE_BEUE                     *((volatile unsigned char*)(0x42E00AD4UL))
#define bFM_CANFD_IE_ELOE                     *((volatile unsigned char*)(0x42E00AD8UL))
#define bFM_CANFD_IE_EPE                      *((volatile unsigned char*)(0x42E00ADCUL))
#define bFM_CANFD_IE_EWE                      *((volatile unsigned char*)(0x42E00AE0UL))
#define bFM_CANFD_IE_BOE                      *((volatile unsigned char*)(0x42E00AE4UL))
#define bFM_CANFD_IE_WDIE                     *((volatile unsigned char*)(0x42E00AE8UL))
#define bFM_CANFD_IE_CRCEE                    *((volatile unsigned char*)(0x42E00AECUL))
#define bFM_CANFD_IE_BEE                      *((volatile unsigned char*)(0x42E00AF0UL))
#define bFM_CANFD_IE_ACKEE                    *((volatile unsigned char*)(0x42E00AF4UL))
#define bFM_CANFD_IE_FOEE                     *((volatile unsigned char*)(0x42E00AF8UL))
#define bFM_CANFD_IE_STEE                     *((volatile unsigned char*)(0x42E00AFCUL))
#define bFM_CANFD_ILS_RF0NL                   *((volatile unsigned char*)(0x42E00B00UL))
#define bFM_CANFD_ILS_RF0WL                   *((volatile unsigned char*)(0x42E00B04UL))
#define bFM_CANFD_ILS_RF0FL                   *((volatile unsigned char*)(0x42E00B08UL))
#define bFM_CANFD_ILS_RF0LL                   *((volatile unsigned char*)(0x42E00B0CUL))
#define bFM_CANFD_ILS_RF1NL                   *((volatile unsigned char*)(0x42E00B10UL))
#define bFM_CANFD_ILS_RF1WL                   *((volatile unsigned char*)(0x42E00B14UL))
#define bFM_CANFD_ILS_RF1FL                   *((volatile unsigned char*)(0x42E00B18UL))
#define bFM_CANFD_ILS_RF1LL                   *((volatile unsigned char*)(0x42E00B1CUL))
#define bFM_CANFD_ILS_HPML                    *((volatile unsigned char*)(0x42E00B20UL))
#define bFM_CANFD_ILS_TCL                     *((volatile unsigned char*)(0x42E00B24UL))
#define bFM_CANFD_ILS_TCFL                    *((volatile unsigned char*)(0x42E00B28UL))
#define bFM_CANFD_ILS_TFEL                    *((volatile unsigned char*)(0x42E00B2CUL))
#define bFM_CANFD_ILS_TEFNL                   *((volatile unsigned char*)(0x42E00B30UL))
#define bFM_CANFD_ILS_TEFWL                   *((volatile unsigned char*)(0x42E00B34UL))
#define bFM_CANFD_ILS_TEFFL                   *((volatile unsigned char*)(0x42E00B38UL))
#define bFM_CANFD_ILS_TEFLL                   *((volatile unsigned char*)(0x42E00B3CUL))
#define bFM_CANFD_ILS_TSWL                    *((volatile unsigned char*)(0x42E00B40UL))
#define bFM_CANFD_ILS_MRAFL                   *((volatile unsigned char*)(0x42E00B44UL))
#define bFM_CANFD_ILS_TOOL                    *((volatile unsigned char*)(0x42E00B48UL))
#define bFM_CANFD_ILS_DRXL                    *((volatile unsigned char*)(0x42E00B4CUL))
#define bFM_CANFD_ILS_BECL                    *((volatile unsigned char*)(0x42E00B50UL))
#define bFM_CANFD_ILS_BEUL                    *((volatile unsigned char*)(0x42E00B54UL))
#define bFM_CANFD_ILS_ELOL                    *((volatile unsigned char*)(0x42E00B58UL))
#define bFM_CANFD_ILS_EPL                     *((volatile unsigned char*)(0x42E00B5CUL))
#define bFM_CANFD_ILS_EWL                     *((volatile unsigned char*)(0x42E00B60UL))
#define bFM_CANFD_ILS_BOL                     *((volatile unsigned char*)(0x42E00B64UL))
#define bFM_CANFD_ILS_WDIL                    *((volatile unsigned char*)(0x42E00B68UL))
#define bFM_CANFD_ILS_CRCEL                   *((volatile unsigned char*)(0x42E00B6CUL))
#define bFM_CANFD_ILS_BEL                     *((volatile unsigned char*)(0x42E00B70UL))
#define bFM_CANFD_ILS_ACKEL                   *((volatile unsigned char*)(0x42E00B74UL))
#define bFM_CANFD_ILS_FOEL                    *((volatile unsigned char*)(0x42E00B78UL))
#define bFM_CANFD_ILS_STEL                    *((volatile unsigned char*)(0x42E00B7CUL))
#define bFM_CANFD_ILE_EINT0                   *((volatile unsigned char*)(0x42E00B80UL))
#define bFM_CANFD_ILE_EINT1                   *((volatile unsigned char*)(0x42E00B84UL))
#define bFM_CANFD_GFC_RRFE                    *((volatile unsigned char*)(0x42E01000UL))
#define bFM_CANFD_GFC_RRFS                    *((volatile unsigned char*)(0x42E01004UL))
#define bFM_CANFD_GFC_ANFE0                   *((volatile unsigned char*)(0x42E01008UL))
#define bFM_CANFD_GFC_ANFE1                   *((volatile unsigned char*)(0x42E0100CUL))
#define bFM_CANFD_GFC_ANFS0                   *((volatile unsigned char*)(0x42E01010UL))
#define bFM_CANFD_GFC_ANFS1                   *((volatile unsigned char*)(0x42E01014UL))
#define bFM_CANFD_SIDFC_FLSSA0                *((volatile unsigned char*)(0x42E01088UL))
#define bFM_CANFD_SIDFC_FLSSA1                *((volatile unsigned char*)(0x42E0108CUL))
#define bFM_CANFD_SIDFC_FLSSA2                *((volatile unsigned char*)(0x42E01090UL))
#define bFM_CANFD_SIDFC_FLSSA3                *((volatile unsigned char*)(0x42E01094UL))
#define bFM_CANFD_SIDFC_FLSSA4                *((volatile unsigned char*)(0x42E01098UL))
#define bFM_CANFD_SIDFC_FLSSA5                *((volatile unsigned char*)(0x42E0109CUL))
#define bFM_CANFD_SIDFC_FLSSA6                *((volatile unsigned char*)(0x42E010A0UL))
#define bFM_CANFD_SIDFC_FLSSA7                *((volatile unsigned char*)(0x42E010A4UL))
#define bFM_CANFD_SIDFC_FLSSA8                *((volatile unsigned char*)(0x42E010A8UL))
#define bFM_CANFD_SIDFC_FLSSA9                *((volatile unsigned char*)(0x42E010ACUL))
#define bFM_CANFD_SIDFC_FLSSA10               *((volatile unsigned char*)(0x42E010B0UL))
#define bFM_CANFD_SIDFC_FLSSA11               *((volatile unsigned char*)(0x42E010B4UL))
#define bFM_CANFD_SIDFC_FLSSA12               *((volatile unsigned char*)(0x42E010B8UL))
#define bFM_CANFD_SIDFC_FLSSA13               *((volatile unsigned char*)(0x42E010BCUL))
#define bFM_CANFD_SIDFC_LSS0                  *((volatile unsigned char*)(0x42E010C0UL))
#define bFM_CANFD_SIDFC_LSS1                  *((volatile unsigned char*)(0x42E010C4UL))
#define bFM_CANFD_SIDFC_LSS2                  *((volatile unsigned char*)(0x42E010C8UL))
#define bFM_CANFD_SIDFC_LSS3                  *((volatile unsigned char*)(0x42E010CCUL))
#define bFM_CANFD_SIDFC_LSS4                  *((volatile unsigned char*)(0x42E010D0UL))
#define bFM_CANFD_SIDFC_LSS5                  *((volatile unsigned char*)(0x42E010D4UL))
#define bFM_CANFD_SIDFC_LSS6                  *((volatile unsigned char*)(0x42E010D8UL))
#define bFM_CANFD_SIDFC_LSS7                  *((volatile unsigned char*)(0x42E010DCUL))
#define bFM_CANFD_XIDFC_FLESA0                *((volatile unsigned char*)(0x42E01108UL))
#define bFM_CANFD_XIDFC_FLESA1                *((volatile unsigned char*)(0x42E0110CUL))
#define bFM_CANFD_XIDFC_FLESA2                *((volatile unsigned char*)(0x42E01110UL))
#define bFM_CANFD_XIDFC_FLESA3                *((volatile unsigned char*)(0x42E01114UL))
#define bFM_CANFD_XIDFC_FLESA4                *((volatile unsigned char*)(0x42E01118UL))
#define bFM_CANFD_XIDFC_FLESA5                *((volatile unsigned char*)(0x42E0111CUL))
#define bFM_CANFD_XIDFC_FLESA6                *((volatile unsigned char*)(0x42E01120UL))
#define bFM_CANFD_XIDFC_FLESA7                *((volatile unsigned char*)(0x42E01124UL))
#define bFM_CANFD_XIDFC_FLESA8                *((volatile unsigned char*)(0x42E01128UL))
#define bFM_CANFD_XIDFC_FLESA9                *((volatile unsigned char*)(0x42E0112CUL))
#define bFM_CANFD_XIDFC_FLESA10               *((volatile unsigned char*)(0x42E01130UL))
#define bFM_CANFD_XIDFC_FLESA11               *((volatile unsigned char*)(0x42E01134UL))
#define bFM_CANFD_XIDFC_FLESA12               *((volatile unsigned char*)(0x42E01138UL))
#define bFM_CANFD_XIDFC_FLESA13               *((volatile unsigned char*)(0x42E0113CUL))
#define bFM_CANFD_XIDFC_LSE0                  *((volatile unsigned char*)(0x42E01140UL))
#define bFM_CANFD_XIDFC_LSE1                  *((volatile unsigned char*)(0x42E01144UL))
#define bFM_CANFD_XIDFC_LSE2                  *((volatile unsigned char*)(0x42E01148UL))
#define bFM_CANFD_XIDFC_LSE3                  *((volatile unsigned char*)(0x42E0114CUL))
#define bFM_CANFD_XIDFC_LSE4                  *((volatile unsigned char*)(0x42E01150UL))
#define bFM_CANFD_XIDFC_LSE5                  *((volatile unsigned char*)(0x42E01154UL))
#define bFM_CANFD_XIDFC_LSE6                  *((volatile unsigned char*)(0x42E01158UL))
#define bFM_CANFD_XIDAM_EIDM0                 *((volatile unsigned char*)(0x42E01200UL))
#define bFM_CANFD_XIDAM_EIDM1                 *((volatile unsigned char*)(0x42E01204UL))
#define bFM_CANFD_XIDAM_EIDM2                 *((volatile unsigned char*)(0x42E01208UL))
#define bFM_CANFD_XIDAM_EIDM3                 *((volatile unsigned char*)(0x42E0120CUL))
#define bFM_CANFD_XIDAM_EIDM4                 *((volatile unsigned char*)(0x42E01210UL))
#define bFM_CANFD_XIDAM_EIDM5                 *((volatile unsigned char*)(0x42E01214UL))
#define bFM_CANFD_XIDAM_EIDM6                 *((volatile unsigned char*)(0x42E01218UL))
#define bFM_CANFD_XIDAM_EIDM7                 *((volatile unsigned char*)(0x42E0121CUL))
#define bFM_CANFD_XIDAM_EIDM8                 *((volatile unsigned char*)(0x42E01220UL))
#define bFM_CANFD_XIDAM_EIDM9                 *((volatile unsigned char*)(0x42E01224UL))
#define bFM_CANFD_XIDAM_EIDM10                *((volatile unsigned char*)(0x42E01228UL))
#define bFM_CANFD_XIDAM_EIDM11                *((volatile unsigned char*)(0x42E0122CUL))
#define bFM_CANFD_XIDAM_EIDM12                *((volatile unsigned char*)(0x42E01230UL))
#define bFM_CANFD_XIDAM_EIDM13                *((volatile unsigned char*)(0x42E01234UL))
#define bFM_CANFD_XIDAM_EIDM14                *((volatile unsigned char*)(0x42E01238UL))
#define bFM_CANFD_XIDAM_EIDM15                *((volatile unsigned char*)(0x42E0123CUL))
#define bFM_CANFD_XIDAM_EIDM16                *((volatile unsigned char*)(0x42E01240UL))
#define bFM_CANFD_XIDAM_EIDM17                *((volatile unsigned char*)(0x42E01244UL))
#define bFM_CANFD_XIDAM_EIDM18                *((volatile unsigned char*)(0x42E01248UL))
#define bFM_CANFD_XIDAM_EIDM19                *((volatile unsigned char*)(0x42E0124CUL))
#define bFM_CANFD_XIDAM_EIDM20                *((volatile unsigned char*)(0x42E01250UL))
#define bFM_CANFD_XIDAM_EIDM21                *((volatile unsigned char*)(0x42E01254UL))
#define bFM_CANFD_XIDAM_EIDM22                *((volatile unsigned char*)(0x42E01258UL))
#define bFM_CANFD_XIDAM_EIDM23                *((volatile unsigned char*)(0x42E0125CUL))
#define bFM_CANFD_XIDAM_EIDM24                *((volatile unsigned char*)(0x42E01260UL))
#define bFM_CANFD_XIDAM_EIDM25                *((volatile unsigned char*)(0x42E01264UL))
#define bFM_CANFD_XIDAM_EIDM26                *((volatile unsigned char*)(0x42E01268UL))
#define bFM_CANFD_XIDAM_EIDM27                *((volatile unsigned char*)(0x42E0126CUL))
#define bFM_CANFD_XIDAM_EIDM28                *((volatile unsigned char*)(0x42E01270UL))
#define bFM_CANFD_HPMS_BIDX0                  *((volatile unsigned char*)(0x42E01280UL))
#define bFM_CANFD_HPMS_BIDX1                  *((volatile unsigned char*)(0x42E01284UL))
#define bFM_CANFD_HPMS_BIDX2                  *((volatile unsigned char*)(0x42E01288UL))
#define bFM_CANFD_HPMS_BIDX3                  *((volatile unsigned char*)(0x42E0128CUL))
#define bFM_CANFD_HPMS_BIDX4                  *((volatile unsigned char*)(0x42E01290UL))
#define bFM_CANFD_HPMS_BIDX5                  *((volatile unsigned char*)(0x42E01294UL))
#define bFM_CANFD_HPMS_MSI0                   *((volatile unsigned char*)(0x42E01298UL))
#define bFM_CANFD_HPMS_MSI1                   *((volatile unsigned char*)(0x42E0129CUL))
#define bFM_CANFD_HPMS_FIDX0                  *((volatile unsigned char*)(0x42E012A0UL))
#define bFM_CANFD_HPMS_FIDX1                  *((volatile unsigned char*)(0x42E012A4UL))
#define bFM_CANFD_HPMS_FIDX2                  *((volatile unsigned char*)(0x42E012A8UL))
#define bFM_CANFD_HPMS_FIDX3                  *((volatile unsigned char*)(0x42E012ACUL))
#define bFM_CANFD_HPMS_FIDX4                  *((volatile unsigned char*)(0x42E012B0UL))
#define bFM_CANFD_HPMS_FIDX5                  *((volatile unsigned char*)(0x42E012B4UL))
#define bFM_CANFD_HPMS_FIDX6                  *((volatile unsigned char*)(0x42E012B8UL))
#define bFM_CANFD_HPMS_FLST                   *((volatile unsigned char*)(0x42E012BCUL))
#define bFM_CANFD_NDAT1_ND0                   *((volatile unsigned char*)(0x42E01300UL))
#define bFM_CANFD_NDAT1_ND1                   *((volatile unsigned char*)(0x42E01304UL))
#define bFM_CANFD_NDAT1_ND2                   *((volatile unsigned char*)(0x42E01308UL))
#define bFM_CANFD_NDAT1_ND3                   *((volatile unsigned char*)(0x42E0130CUL))
#define bFM_CANFD_NDAT1_ND4                   *((volatile unsigned char*)(0x42E01310UL))
#define bFM_CANFD_NDAT1_ND5                   *((volatile unsigned char*)(0x42E01314UL))
#define bFM_CANFD_NDAT1_ND6                   *((volatile unsigned char*)(0x42E01318UL))
#define bFM_CANFD_NDAT1_ND7                   *((volatile unsigned char*)(0x42E0131CUL))
#define bFM_CANFD_NDAT1_ND8                   *((volatile unsigned char*)(0x42E01320UL))
#define bFM_CANFD_NDAT1_ND9                   *((volatile unsigned char*)(0x42E01324UL))
#define bFM_CANFD_NDAT1_ND10                  *((volatile unsigned char*)(0x42E01328UL))
#define bFM_CANFD_NDAT1_ND11                  *((volatile unsigned char*)(0x42E0132CUL))
#define bFM_CANFD_NDAT1_ND12                  *((volatile unsigned char*)(0x42E01330UL))
#define bFM_CANFD_NDAT1_ND13                  *((volatile unsigned char*)(0x42E01334UL))
#define bFM_CANFD_NDAT1_ND14                  *((volatile unsigned char*)(0x42E01338UL))
#define bFM_CANFD_NDAT1_ND15                  *((volatile unsigned char*)(0x42E0133CUL))
#define bFM_CANFD_NDAT1_ND16                  *((volatile unsigned char*)(0x42E01340UL))
#define bFM_CANFD_NDAT1_ND17                  *((volatile unsigned char*)(0x42E01344UL))
#define bFM_CANFD_NDAT1_ND18                  *((volatile unsigned char*)(0x42E01348UL))
#define bFM_CANFD_NDAT1_ND19                  *((volatile unsigned char*)(0x42E0134CUL))
#define bFM_CANFD_NDAT1_ND20                  *((volatile unsigned char*)(0x42E01350UL))
#define bFM_CANFD_NDAT1_ND21                  *((volatile unsigned char*)(0x42E01354UL))
#define bFM_CANFD_NDAT1_ND22                  *((volatile unsigned char*)(0x42E01358UL))
#define bFM_CANFD_NDAT1_ND23                  *((volatile unsigned char*)(0x42E0135CUL))
#define bFM_CANFD_NDAT1_ND24                  *((volatile unsigned char*)(0x42E01360UL))
#define bFM_CANFD_NDAT1_ND25                  *((volatile unsigned char*)(0x42E01364UL))
#define bFM_CANFD_NDAT1_ND26                  *((volatile unsigned char*)(0x42E01368UL))
#define bFM_CANFD_NDAT1_ND27                  *((volatile unsigned char*)(0x42E0136CUL))
#define bFM_CANFD_NDAT1_ND28                  *((volatile unsigned char*)(0x42E01370UL))
#define bFM_CANFD_NDAT1_ND29                  *((volatile unsigned char*)(0x42E01374UL))
#define bFM_CANFD_NDAT1_ND30                  *((volatile unsigned char*)(0x42E01378UL))
#define bFM_CANFD_NDAT1_ND31                  *((volatile unsigned char*)(0x42E0137CUL))
#define bFM_CANFD_NDAT2_ND32                  *((volatile unsigned char*)(0x42E01380UL))
#define bFM_CANFD_NDAT2_ND33                  *((volatile unsigned char*)(0x42E01384UL))
#define bFM_CANFD_NDAT2_ND34                  *((volatile unsigned char*)(0x42E01388UL))
#define bFM_CANFD_NDAT2_ND35                  *((volatile unsigned char*)(0x42E0138CUL))
#define bFM_CANFD_NDAT2_ND36                  *((volatile unsigned char*)(0x42E01390UL))
#define bFM_CANFD_NDAT2_ND37                  *((volatile unsigned char*)(0x42E01394UL))
#define bFM_CANFD_NDAT2_ND38                  *((volatile unsigned char*)(0x42E01398UL))
#define bFM_CANFD_NDAT2_ND39                  *((volatile unsigned char*)(0x42E0139CUL))
#define bFM_CANFD_NDAT2_ND40                  *((volatile unsigned char*)(0x42E013A0UL))
#define bFM_CANFD_NDAT2_ND41                  *((volatile unsigned char*)(0x42E013A4UL))
#define bFM_CANFD_NDAT2_ND42                  *((volatile unsigned char*)(0x42E013A8UL))
#define bFM_CANFD_NDAT2_ND43                  *((volatile unsigned char*)(0x42E013ACUL))
#define bFM_CANFD_NDAT2_ND44                  *((volatile unsigned char*)(0x42E013B0UL))
#define bFM_CANFD_NDAT2_ND45                  *((volatile unsigned char*)(0x42E013B4UL))
#define bFM_CANFD_NDAT2_ND46                  *((volatile unsigned char*)(0x42E013B8UL))
#define bFM_CANFD_NDAT2_ND47                  *((volatile unsigned char*)(0x42E013BCUL))
#define bFM_CANFD_NDAT2_ND48                  *((volatile unsigned char*)(0x42E013C0UL))
#define bFM_CANFD_NDAT2_ND49                  *((volatile unsigned char*)(0x42E013C4UL))
#define bFM_CANFD_NDAT2_ND50                  *((volatile unsigned char*)(0x42E013C8UL))
#define bFM_CANFD_NDAT2_ND51                  *((volatile unsigned char*)(0x42E013CCUL))
#define bFM_CANFD_NDAT2_ND52                  *((volatile unsigned char*)(0x42E013D0UL))
#define bFM_CANFD_NDAT2_ND53                  *((volatile unsigned char*)(0x42E013D4UL))
#define bFM_CANFD_NDAT2_ND54                  *((volatile unsigned char*)(0x42E013D8UL))
#define bFM_CANFD_NDAT2_ND55                  *((volatile unsigned char*)(0x42E013DCUL))
#define bFM_CANFD_NDAT2_ND56                  *((volatile unsigned char*)(0x42E013E0UL))
#define bFM_CANFD_NDAT2_ND57                  *((volatile unsigned char*)(0x42E013E4UL))
#define bFM_CANFD_NDAT2_ND58                  *((volatile unsigned char*)(0x42E013E8UL))
#define bFM_CANFD_NDAT2_ND59                  *((volatile unsigned char*)(0x42E013ECUL))
#define bFM_CANFD_NDAT2_ND60                  *((volatile unsigned char*)(0x42E013F0UL))
#define bFM_CANFD_NDAT2_ND61                  *((volatile unsigned char*)(0x42E013F4UL))
#define bFM_CANFD_NDAT2_ND62                  *((volatile unsigned char*)(0x42E013F8UL))
#define bFM_CANFD_NDAT2_ND63                  *((volatile unsigned char*)(0x42E013FCUL))
#define bFM_CANFD_RXF0C_F0SA0                 *((volatile unsigned char*)(0x42E01408UL))
#define bFM_CANFD_RXF0C_F0SA1                 *((volatile unsigned char*)(0x42E0140CUL))
#define bFM_CANFD_RXF0C_F0SA2                 *((volatile unsigned char*)(0x42E01410UL))
#define bFM_CANFD_RXF0C_F0SA3                 *((volatile unsigned char*)(0x42E01414UL))
#define bFM_CANFD_RXF0C_F0SA4                 *((volatile unsigned char*)(0x42E01418UL))
#define bFM_CANFD_RXF0C_F0SA5                 *((volatile unsigned char*)(0x42E0141CUL))
#define bFM_CANFD_RXF0C_F0SA6                 *((volatile unsigned char*)(0x42E01420UL))
#define bFM_CANFD_RXF0C_F0SA7                 *((volatile unsigned char*)(0x42E01424UL))
#define bFM_CANFD_RXF0C_F0SA8                 *((volatile unsigned char*)(0x42E01428UL))
#define bFM_CANFD_RXF0C_F0SA9                 *((volatile unsigned char*)(0x42E0142CUL))
#define bFM_CANFD_RXF0C_F0SA10                *((volatile unsigned char*)(0x42E01430UL))
#define bFM_CANFD_RXF0C_F0SA11                *((volatile unsigned char*)(0x42E01434UL))
#define bFM_CANFD_RXF0C_F0SA12                *((volatile unsigned char*)(0x42E01438UL))
#define bFM_CANFD_RXF0C_F0SA13                *((volatile unsigned char*)(0x42E0143CUL))
#define bFM_CANFD_RXF0C_F0S0                  *((volatile unsigned char*)(0x42E01440UL))
#define bFM_CANFD_RXF0C_F0S1                  *((volatile unsigned char*)(0x42E01444UL))
#define bFM_CANFD_RXF0C_F0S2                  *((volatile unsigned char*)(0x42E01448UL))
#define bFM_CANFD_RXF0C_F0S3                  *((volatile unsigned char*)(0x42E0144CUL))
#define bFM_CANFD_RXF0C_F0S4                  *((volatile unsigned char*)(0x42E01450UL))
#define bFM_CANFD_RXF0C_F0S5                  *((volatile unsigned char*)(0x42E01454UL))
#define bFM_CANFD_RXF0C_F0S6                  *((volatile unsigned char*)(0x42E01458UL))
#define bFM_CANFD_RXF0C_F0WM0                 *((volatile unsigned char*)(0x42E01460UL))
#define bFM_CANFD_RXF0C_F0WM1                 *((volatile unsigned char*)(0x42E01464UL))
#define bFM_CANFD_RXF0C_F0WM2                 *((volatile unsigned char*)(0x42E01468UL))
#define bFM_CANFD_RXF0C_F0WM3                 *((volatile unsigned char*)(0x42E0146CUL))
#define bFM_CANFD_RXF0C_F0WM4                 *((volatile unsigned char*)(0x42E01470UL))
#define bFM_CANFD_RXF0C_F0WM5                 *((volatile unsigned char*)(0x42E01474UL))
#define bFM_CANFD_RXF0C_F0WM6                 *((volatile unsigned char*)(0x42E01478UL))
#define bFM_CANFD_RXF0C_F0OM                  *((volatile unsigned char*)(0x42E0147CUL))
#define bFM_CANFD_RXF0S_F0FL0                 *((volatile unsigned char*)(0x42E01480UL))
#define bFM_CANFD_RXF0S_F0FL1                 *((volatile unsigned char*)(0x42E01484UL))
#define bFM_CANFD_RXF0S_F0FL2                 *((volatile unsigned char*)(0x42E01488UL))
#define bFM_CANFD_RXF0S_F0FL3                 *((volatile unsigned char*)(0x42E0148CUL))
#define bFM_CANFD_RXF0S_F0FL4                 *((volatile unsigned char*)(0x42E01490UL))
#define bFM_CANFD_RXF0S_F0FL5                 *((volatile unsigned char*)(0x42E01494UL))
#define bFM_CANFD_RXF0S_F0FL6                 *((volatile unsigned char*)(0x42E01498UL))
#define bFM_CANFD_RXF0S_F0GI0                 *((volatile unsigned char*)(0x42E014A0UL))
#define bFM_CANFD_RXF0S_F0GI1                 *((volatile unsigned char*)(0x42E014A4UL))
#define bFM_CANFD_RXF0S_F0GI2                 *((volatile unsigned char*)(0x42E014A8UL))
#define bFM_CANFD_RXF0S_F0GI3                 *((volatile unsigned char*)(0x42E014ACUL))
#define bFM_CANFD_RXF0S_F0GI4                 *((volatile unsigned char*)(0x42E014B0UL))
#define bFM_CANFD_RXF0S_F0GI5                 *((volatile unsigned char*)(0x42E014B4UL))
#define bFM_CANFD_RXF0S_F0PI0                 *((volatile unsigned char*)(0x42E014C0UL))
#define bFM_CANFD_RXF0S_F0PI1                 *((volatile unsigned char*)(0x42E014C4UL))
#define bFM_CANFD_RXF0S_F0PI2                 *((volatile unsigned char*)(0x42E014C8UL))
#define bFM_CANFD_RXF0S_F0PI3                 *((volatile unsigned char*)(0x42E014CCUL))
#define bFM_CANFD_RXF0S_F0PI4                 *((volatile unsigned char*)(0x42E014D0UL))
#define bFM_CANFD_RXF0S_F0PI5                 *((volatile unsigned char*)(0x42E014D4UL))
#define bFM_CANFD_RXF0S_F0F                   *((volatile unsigned char*)(0x42E014E0UL))
#define bFM_CANFD_RXF0S_RF0L                  *((volatile unsigned char*)(0x42E014E4UL))
#define bFM_CANFD_RXF0A_F0AI0                 *((volatile unsigned char*)(0x42E01500UL))
#define bFM_CANFD_RXF0A_F0AI1                 *((volatile unsigned char*)(0x42E01504UL))
#define bFM_CANFD_RXF0A_F0AI2                 *((volatile unsigned char*)(0x42E01508UL))
#define bFM_CANFD_RXF0A_F0AI3                 *((volatile unsigned char*)(0x42E0150CUL))
#define bFM_CANFD_RXF0A_F0AI4                 *((volatile unsigned char*)(0x42E01510UL))
#define bFM_CANFD_RXF0A_F0AI5                 *((volatile unsigned char*)(0x42E01514UL))
#define bFM_CANFD_RXBC_RBSA0                  *((volatile unsigned char*)(0x42E01588UL))
#define bFM_CANFD_RXBC_RBSA1                  *((volatile unsigned char*)(0x42E0158CUL))
#define bFM_CANFD_RXBC_RBSA2                  *((volatile unsigned char*)(0x42E01590UL))
#define bFM_CANFD_RXBC_RBSA3                  *((volatile unsigned char*)(0x42E01594UL))
#define bFM_CANFD_RXBC_RBSA4                  *((volatile unsigned char*)(0x42E01598UL))
#define bFM_CANFD_RXBC_RBSA5                  *((volatile unsigned char*)(0x42E0159CUL))
#define bFM_CANFD_RXBC_RBSA6                  *((volatile unsigned char*)(0x42E015A0UL))
#define bFM_CANFD_RXBC_RBSA7                  *((volatile unsigned char*)(0x42E015A4UL))
#define bFM_CANFD_RXBC_RBSA8                  *((volatile unsigned char*)(0x42E015A8UL))
#define bFM_CANFD_RXBC_RBSA9                  *((volatile unsigned char*)(0x42E015ACUL))
#define bFM_CANFD_RXBC_RBSA10                 *((volatile unsigned char*)(0x42E015B0UL))
#define bFM_CANFD_RXBC_RBSA11                 *((volatile unsigned char*)(0x42E015B4UL))
#define bFM_CANFD_RXBC_RBSA12                 *((volatile unsigned char*)(0x42E015B8UL))
#define bFM_CANFD_RXBC_RBSA13                 *((volatile unsigned char*)(0x42E015BCUL))
#define bFM_CANFD_RXF1C_F1SA0                 *((volatile unsigned char*)(0x42E01608UL))
#define bFM_CANFD_RXF1C_F1SA1                 *((volatile unsigned char*)(0x42E0160CUL))
#define bFM_CANFD_RXF1C_F1SA2                 *((volatile unsigned char*)(0x42E01610UL))
#define bFM_CANFD_RXF1C_F1SA3                 *((volatile unsigned char*)(0x42E01614UL))
#define bFM_CANFD_RXF1C_F1SA4                 *((volatile unsigned char*)(0x42E01618UL))
#define bFM_CANFD_RXF1C_F1SA5                 *((volatile unsigned char*)(0x42E0161CUL))
#define bFM_CANFD_RXF1C_F1SA6                 *((volatile unsigned char*)(0x42E01620UL))
#define bFM_CANFD_RXF1C_F1SA7                 *((volatile unsigned char*)(0x42E01624UL))
#define bFM_CANFD_RXF1C_F1SA8                 *((volatile unsigned char*)(0x42E01628UL))
#define bFM_CANFD_RXF1C_F1SA9                 *((volatile unsigned char*)(0x42E0162CUL))
#define bFM_CANFD_RXF1C_F1SA10                *((volatile unsigned char*)(0x42E01630UL))
#define bFM_CANFD_RXF1C_F1SA11                *((volatile unsigned char*)(0x42E01634UL))
#define bFM_CANFD_RXF1C_F1SA12                *((volatile unsigned char*)(0x42E01638UL))
#define bFM_CANFD_RXF1C_F1SA13                *((volatile unsigned char*)(0x42E0163CUL))
#define bFM_CANFD_RXF1C_F1S0                  *((volatile unsigned char*)(0x42E01640UL))
#define bFM_CANFD_RXF1C_F1S1                  *((volatile unsigned char*)(0x42E01644UL))
#define bFM_CANFD_RXF1C_F1S2                  *((volatile unsigned char*)(0x42E01648UL))
#define bFM_CANFD_RXF1C_F1S3                  *((volatile unsigned char*)(0x42E0164CUL))
#define bFM_CANFD_RXF1C_F1S4                  *((volatile unsigned char*)(0x42E01650UL))
#define bFM_CANFD_RXF1C_F1S5                  *((volatile unsigned char*)(0x42E01654UL))
#define bFM_CANFD_RXF1C_F1S6                  *((volatile unsigned char*)(0x42E01658UL))
#define bFM_CANFD_RXF1C_F1WM0                 *((volatile unsigned char*)(0x42E01660UL))
#define bFM_CANFD_RXF1C_F1WM1                 *((volatile unsigned char*)(0x42E01664UL))
#define bFM_CANFD_RXF1C_F1WM2                 *((volatile unsigned char*)(0x42E01668UL))
#define bFM_CANFD_RXF1C_F1WM3                 *((volatile unsigned char*)(0x42E0166CUL))
#define bFM_CANFD_RXF1C_F1WM4                 *((volatile unsigned char*)(0x42E01670UL))
#define bFM_CANFD_RXF1C_F1WM5                 *((volatile unsigned char*)(0x42E01674UL))
#define bFM_CANFD_RXF1C_F1WM6                 *((volatile unsigned char*)(0x42E01678UL))
#define bFM_CANFD_RXF1C_F1OM                  *((volatile unsigned char*)(0x42E0167CUL))
#define bFM_CANFD_RXF1S_F1FL0                 *((volatile unsigned char*)(0x42E01680UL))
#define bFM_CANFD_RXF1S_F1FL1                 *((volatile unsigned char*)(0x42E01684UL))
#define bFM_CANFD_RXF1S_F1FL2                 *((volatile unsigned char*)(0x42E01688UL))
#define bFM_CANFD_RXF1S_F1FL3                 *((volatile unsigned char*)(0x42E0168CUL))
#define bFM_CANFD_RXF1S_F1FL4                 *((volatile unsigned char*)(0x42E01690UL))
#define bFM_CANFD_RXF1S_F1FL5                 *((volatile unsigned char*)(0x42E01694UL))
#define bFM_CANFD_RXF1S_F1FL6                 *((volatile unsigned char*)(0x42E01698UL))
#define bFM_CANFD_RXF1S_F1GI0                 *((volatile unsigned char*)(0x42E016A0UL))
#define bFM_CANFD_RXF1S_F1GI1                 *((volatile unsigned char*)(0x42E016A4UL))
#define bFM_CANFD_RXF1S_F1GI2                 *((volatile unsigned char*)(0x42E016A8UL))
#define bFM_CANFD_RXF1S_F1GI3                 *((volatile unsigned char*)(0x42E016ACUL))
#define bFM_CANFD_RXF1S_F1GI4                 *((volatile unsigned char*)(0x42E016B0UL))
#define bFM_CANFD_RXF1S_F1GI5                 *((volatile unsigned char*)(0x42E016B4UL))
#define bFM_CANFD_RXF1S_F1PI0                 *((volatile unsigned char*)(0x42E016C0UL))
#define bFM_CANFD_RXF1S_F1PI1                 *((volatile unsigned char*)(0x42E016C4UL))
#define bFM_CANFD_RXF1S_F1PI2                 *((volatile unsigned char*)(0x42E016C8UL))
#define bFM_CANFD_RXF1S_F1PI3                 *((volatile unsigned char*)(0x42E016CCUL))
#define bFM_CANFD_RXF1S_F1PI4                 *((volatile unsigned char*)(0x42E016D0UL))
#define bFM_CANFD_RXF1S_F1PI5                 *((volatile unsigned char*)(0x42E016D4UL))
#define bFM_CANFD_RXF1S_F1F                   *((volatile unsigned char*)(0x42E016E0UL))
#define bFM_CANFD_RXF1S_RF1L                  *((volatile unsigned char*)(0x42E016E4UL))
#define bFM_CANFD_RXF1S_DMS0                  *((volatile unsigned char*)(0x42E016F8UL))
#define bFM_CANFD_RXF1S_DMS1                  *((volatile unsigned char*)(0x42E016FCUL))
#define bFM_CANFD_RXF1A_F1AI0                 *((volatile unsigned char*)(0x42E01700UL))
#define bFM_CANFD_RXF1A_F1AI1                 *((volatile unsigned char*)(0x42E01704UL))
#define bFM_CANFD_RXF1A_F1AI2                 *((volatile unsigned char*)(0x42E01708UL))
#define bFM_CANFD_RXF1A_F1AI3                 *((volatile unsigned char*)(0x42E0170CUL))
#define bFM_CANFD_RXF1A_F1AI4                 *((volatile unsigned char*)(0x42E01710UL))
#define bFM_CANFD_RXF1A_F1AI5                 *((volatile unsigned char*)(0x42E01714UL))
#define bFM_CANFD_RXESC_F0DS0                 *((volatile unsigned char*)(0x42E01780UL))
#define bFM_CANFD_RXESC_F0DS1                 *((volatile unsigned char*)(0x42E01784UL))
#define bFM_CANFD_RXESC_F0DS2                 *((volatile unsigned char*)(0x42E01788UL))
#define bFM_CANFD_RXESC_F1DS0                 *((volatile unsigned char*)(0x42E01790UL))
#define bFM_CANFD_RXESC_F1DS1                 *((volatile unsigned char*)(0x42E01794UL))
#define bFM_CANFD_RXESC_F1DS2                 *((volatile unsigned char*)(0x42E01798UL))
#define bFM_CANFD_RXESC_RBDS0                 *((volatile unsigned char*)(0x42E017A0UL))
#define bFM_CANFD_RXESC_RBDS1                 *((volatile unsigned char*)(0x42E017A4UL))
#define bFM_CANFD_RXESC_RBDS2                 *((volatile unsigned char*)(0x42E017A8UL))
#define bFM_CANFD_TXBC_TBSA0                  *((volatile unsigned char*)(0x42E01808UL))
#define bFM_CANFD_TXBC_TBSA1                  *((volatile unsigned char*)(0x42E0180CUL))
#define bFM_CANFD_TXBC_TBSA2                  *((volatile unsigned char*)(0x42E01810UL))
#define bFM_CANFD_TXBC_TBSA3                  *((volatile unsigned char*)(0x42E01814UL))
#define bFM_CANFD_TXBC_TBSA4                  *((volatile unsigned char*)(0x42E01818UL))
#define bFM_CANFD_TXBC_TBSA5                  *((volatile unsigned char*)(0x42E0181CUL))
#define bFM_CANFD_TXBC_TBSA6                  *((volatile unsigned char*)(0x42E01820UL))
#define bFM_CANFD_TXBC_TBSA7                  *((volatile unsigned char*)(0x42E01824UL))
#define bFM_CANFD_TXBC_TBSA8                  *((volatile unsigned char*)(0x42E01828UL))
#define bFM_CANFD_TXBC_TBSA9                  *((volatile unsigned char*)(0x42E0182CUL))
#define bFM_CANFD_TXBC_TBSA10                 *((volatile unsigned char*)(0x42E01830UL))
#define bFM_CANFD_TXBC_TBSA11                 *((volatile unsigned char*)(0x42E01834UL))
#define bFM_CANFD_TXBC_TBSA12                 *((volatile unsigned char*)(0x42E01838UL))
#define bFM_CANFD_TXBC_TBSA13                 *((volatile unsigned char*)(0x42E0183CUL))
#define bFM_CANFD_TXBC_NDTB0                  *((volatile unsigned char*)(0x42E01840UL))
#define bFM_CANFD_TXBC_NDTB1                  *((volatile unsigned char*)(0x42E01844UL))
#define bFM_CANFD_TXBC_NDTB2                  *((volatile unsigned char*)(0x42E01848UL))
#define bFM_CANFD_TXBC_NDTB3                  *((volatile unsigned char*)(0x42E0184CUL))
#define bFM_CANFD_TXBC_NDTB4                  *((volatile unsigned char*)(0x42E01850UL))
#define bFM_CANFD_TXBC_NDTB5                  *((volatile unsigned char*)(0x42E01854UL))
#define bFM_CANFD_TXBC_TFQS0                  *((volatile unsigned char*)(0x42E01860UL))
#define bFM_CANFD_TXBC_TFQS1                  *((volatile unsigned char*)(0x42E01864UL))
#define bFM_CANFD_TXBC_TFQS2                  *((volatile unsigned char*)(0x42E01868UL))
#define bFM_CANFD_TXBC_TFQS3                  *((volatile unsigned char*)(0x42E0186CUL))
#define bFM_CANFD_TXBC_TFQS4                  *((volatile unsigned char*)(0x42E01870UL))
#define bFM_CANFD_TXBC_TFQS5                  *((volatile unsigned char*)(0x42E01874UL))
#define bFM_CANFD_TXBC_TFQM                   *((volatile unsigned char*)(0x42E01878UL))
#define bFM_CANFD_TXFQS_TFFL0                 *((volatile unsigned char*)(0x42E01880UL))
#define bFM_CANFD_TXFQS_TFFL1                 *((volatile unsigned char*)(0x42E01884UL))
#define bFM_CANFD_TXFQS_TFFL2                 *((volatile unsigned char*)(0x42E01888UL))
#define bFM_CANFD_TXFQS_TFFL3                 *((volatile unsigned char*)(0x42E0188CUL))
#define bFM_CANFD_TXFQS_TFFL4                 *((volatile unsigned char*)(0x42E01890UL))
#define bFM_CANFD_TXFQS_TFFL5                 *((volatile unsigned char*)(0x42E01894UL))
#define bFM_CANFD_TXFQS_TFGI0                 *((volatile unsigned char*)(0x42E018A0UL))
#define bFM_CANFD_TXFQS_TFGI1                 *((volatile unsigned char*)(0x42E018A4UL))
#define bFM_CANFD_TXFQS_TFGI2                 *((volatile unsigned char*)(0x42E018A8UL))
#define bFM_CANFD_TXFQS_TFGI3                 *((volatile unsigned char*)(0x42E018ACUL))
#define bFM_CANFD_TXFQS_TFGI4                 *((volatile unsigned char*)(0x42E018B0UL))
#define bFM_CANFD_TXFQS_TFQPI0                *((volatile unsigned char*)(0x42E018C0UL))
#define bFM_CANFD_TXFQS_TFQPI1                *((volatile unsigned char*)(0x42E018C4UL))
#define bFM_CANFD_TXFQS_TFQPI2                *((volatile unsigned char*)(0x42E018C8UL))
#define bFM_CANFD_TXFQS_TFQPI3                *((volatile unsigned char*)(0x42E018CCUL))
#define bFM_CANFD_TXFQS_TFQPI4                *((volatile unsigned char*)(0x42E018D0UL))
#define bFM_CANFD_TXFQS_TFQF                  *((volatile unsigned char*)(0x42E018D4UL))
#define bFM_CANFD_TXESC_TBDS0                 *((volatile unsigned char*)(0x42E01900UL))
#define bFM_CANFD_TXESC_TBDS1                 *((volatile unsigned char*)(0x42E01904UL))
#define bFM_CANFD_TXESC_TBDS2                 *((volatile unsigned char*)(0x42E01908UL))
#define bFM_CANFD_TXBRP_TRP0                  *((volatile unsigned char*)(0x42E01980UL))
#define bFM_CANFD_TXBRP_TRP1                  *((volatile unsigned char*)(0x42E01984UL))
#define bFM_CANFD_TXBRP_TRP2                  *((volatile unsigned char*)(0x42E01988UL))
#define bFM_CANFD_TXBRP_TRP3                  *((volatile unsigned char*)(0x42E0198CUL))
#define bFM_CANFD_TXBRP_TRP4                  *((volatile unsigned char*)(0x42E01990UL))
#define bFM_CANFD_TXBRP_TRP5                  *((volatile unsigned char*)(0x42E01994UL))
#define bFM_CANFD_TXBRP_TRP6                  *((volatile unsigned char*)(0x42E01998UL))
#define bFM_CANFD_TXBRP_TRP7                  *((volatile unsigned char*)(0x42E0199CUL))
#define bFM_CANFD_TXBRP_TRP8                  *((volatile unsigned char*)(0x42E019A0UL))
#define bFM_CANFD_TXBRP_TRP9                  *((volatile unsigned char*)(0x42E019A4UL))
#define bFM_CANFD_TXBRP_TRP10                 *((volatile unsigned char*)(0x42E019A8UL))
#define bFM_CANFD_TXBRP_TRP11                 *((volatile unsigned char*)(0x42E019ACUL))
#define bFM_CANFD_TXBRP_TRP12                 *((volatile unsigned char*)(0x42E019B0UL))
#define bFM_CANFD_TXBRP_TRP13                 *((volatile unsigned char*)(0x42E019B4UL))
#define bFM_CANFD_TXBRP_TRP14                 *((volatile unsigned char*)(0x42E019B8UL))
#define bFM_CANFD_TXBRP_TRP15                 *((volatile unsigned char*)(0x42E019BCUL))
#define bFM_CANFD_TXBRP_TRP16                 *((volatile unsigned char*)(0x42E019C0UL))
#define bFM_CANFD_TXBRP_TRP17                 *((volatile unsigned char*)(0x42E019C4UL))
#define bFM_CANFD_TXBRP_TRP18                 *((volatile unsigned char*)(0x42E019C8UL))
#define bFM_CANFD_TXBRP_TRP19                 *((volatile unsigned char*)(0x42E019CCUL))
#define bFM_CANFD_TXBRP_TRP20                 *((volatile unsigned char*)(0x42E019D0UL))
#define bFM_CANFD_TXBRP_TRP21                 *((volatile unsigned char*)(0x42E019D4UL))
#define bFM_CANFD_TXBRP_TRP22                 *((volatile unsigned char*)(0x42E019D8UL))
#define bFM_CANFD_TXBRP_TRP23                 *((volatile unsigned char*)(0x42E019DCUL))
#define bFM_CANFD_TXBRP_TRP24                 *((volatile unsigned char*)(0x42E019E0UL))
#define bFM_CANFD_TXBRP_TRP25                 *((volatile unsigned char*)(0x42E019E4UL))
#define bFM_CANFD_TXBRP_TRP26                 *((volatile unsigned char*)(0x42E019E8UL))
#define bFM_CANFD_TXBRP_TRP27                 *((volatile unsigned char*)(0x42E019ECUL))
#define bFM_CANFD_TXBRP_TRP28                 *((volatile unsigned char*)(0x42E019F0UL))
#define bFM_CANFD_TXBRP_TRP29                 *((volatile unsigned char*)(0x42E019F4UL))
#define bFM_CANFD_TXBRP_TRP30                 *((volatile unsigned char*)(0x42E019F8UL))
#define bFM_CANFD_TXBRP_TRP31                 *((volatile unsigned char*)(0x42E019FCUL))
#define bFM_CANFD_TXBAR_AR0                   *((volatile unsigned char*)(0x42E01A00UL))
#define bFM_CANFD_TXBAR_AR1                   *((volatile unsigned char*)(0x42E01A04UL))
#define bFM_CANFD_TXBAR_AR2                   *((volatile unsigned char*)(0x42E01A08UL))
#define bFM_CANFD_TXBAR_AR3                   *((volatile unsigned char*)(0x42E01A0CUL))
#define bFM_CANFD_TXBAR_AR4                   *((volatile unsigned char*)(0x42E01A10UL))
#define bFM_CANFD_TXBAR_AR5                   *((volatile unsigned char*)(0x42E01A14UL))
#define bFM_CANFD_TXBAR_AR6                   *((volatile unsigned char*)(0x42E01A18UL))
#define bFM_CANFD_TXBAR_AR7                   *((volatile unsigned char*)(0x42E01A1CUL))
#define bFM_CANFD_TXBAR_AR8                   *((volatile unsigned char*)(0x42E01A20UL))
#define bFM_CANFD_TXBAR_AR9                   *((volatile unsigned char*)(0x42E01A24UL))
#define bFM_CANFD_TXBAR_AR10                  *((volatile unsigned char*)(0x42E01A28UL))
#define bFM_CANFD_TXBAR_AR11                  *((volatile unsigned char*)(0x42E01A2CUL))
#define bFM_CANFD_TXBAR_AR12                  *((volatile unsigned char*)(0x42E01A30UL))
#define bFM_CANFD_TXBAR_AR13                  *((volatile unsigned char*)(0x42E01A34UL))
#define bFM_CANFD_TXBAR_AR14                  *((volatile unsigned char*)(0x42E01A38UL))
#define bFM_CANFD_TXBAR_AR15                  *((volatile unsigned char*)(0x42E01A3CUL))
#define bFM_CANFD_TXBAR_AR16                  *((volatile unsigned char*)(0x42E01A40UL))
#define bFM_CANFD_TXBAR_AR17                  *((volatile unsigned char*)(0x42E01A44UL))
#define bFM_CANFD_TXBAR_AR18                  *((volatile unsigned char*)(0x42E01A48UL))
#define bFM_CANFD_TXBAR_AR19                  *((volatile unsigned char*)(0x42E01A4CUL))
#define bFM_CANFD_TXBAR_AR20                  *((volatile unsigned char*)(0x42E01A50UL))
#define bFM_CANFD_TXBAR_AR21                  *((volatile unsigned char*)(0x42E01A54UL))
#define bFM_CANFD_TXBAR_AR22                  *((volatile unsigned char*)(0x42E01A58UL))
#define bFM_CANFD_TXBAR_AR23                  *((volatile unsigned char*)(0x42E01A5CUL))
#define bFM_CANFD_TXBAR_AR24                  *((volatile unsigned char*)(0x42E01A60UL))
#define bFM_CANFD_TXBAR_AR25                  *((volatile unsigned char*)(0x42E01A64UL))
#define bFM_CANFD_TXBAR_AR26                  *((volatile unsigned char*)(0x42E01A68UL))
#define bFM_CANFD_TXBAR_AR27                  *((volatile unsigned char*)(0x42E01A6CUL))
#define bFM_CANFD_TXBAR_AR28                  *((volatile unsigned char*)(0x42E01A70UL))
#define bFM_CANFD_TXBAR_AR29                  *((volatile unsigned char*)(0x42E01A74UL))
#define bFM_CANFD_TXBAR_AR30                  *((volatile unsigned char*)(0x42E01A78UL))
#define bFM_CANFD_TXBAR_AR31                  *((volatile unsigned char*)(0x42E01A7CUL))
#define bFM_CANFD_TXBCR_CR0                   *((volatile unsigned char*)(0x42E01A80UL))
#define bFM_CANFD_TXBCR_CR1                   *((volatile unsigned char*)(0x42E01A84UL))
#define bFM_CANFD_TXBCR_CR2                   *((volatile unsigned char*)(0x42E01A88UL))
#define bFM_CANFD_TXBCR_CR3                   *((volatile unsigned char*)(0x42E01A8CUL))
#define bFM_CANFD_TXBCR_CR4                   *((volatile unsigned char*)(0x42E01A90UL))
#define bFM_CANFD_TXBCR_CR5                   *((volatile unsigned char*)(0x42E01A94UL))
#define bFM_CANFD_TXBCR_CR6                   *((volatile unsigned char*)(0x42E01A98UL))
#define bFM_CANFD_TXBCR_CR7                   *((volatile unsigned char*)(0x42E01A9CUL))
#define bFM_CANFD_TXBCR_CR8                   *((volatile unsigned char*)(0x42E01AA0UL))
#define bFM_CANFD_TXBCR_CR9                   *((volatile unsigned char*)(0x42E01AA4UL))
#define bFM_CANFD_TXBCR_CR10                  *((volatile unsigned char*)(0x42E01AA8UL))
#define bFM_CANFD_TXBCR_CR11                  *((volatile unsigned char*)(0x42E01AACUL))
#define bFM_CANFD_TXBCR_CR12                  *((volatile unsigned char*)(0x42E01AB0UL))
#define bFM_CANFD_TXBCR_CR13                  *((volatile unsigned char*)(0x42E01AB4UL))
#define bFM_CANFD_TXBCR_CR14                  *((volatile unsigned char*)(0x42E01AB8UL))
#define bFM_CANFD_TXBCR_CR15                  *((volatile unsigned char*)(0x42E01ABCUL))
#define bFM_CANFD_TXBCR_CR16                  *((volatile unsigned char*)(0x42E01AC0UL))
#define bFM_CANFD_TXBCR_CR17                  *((volatile unsigned char*)(0x42E01AC4UL))
#define bFM_CANFD_TXBCR_CR18                  *((volatile unsigned char*)(0x42E01AC8UL))
#define bFM_CANFD_TXBCR_CR19                  *((volatile unsigned char*)(0x42E01ACCUL))
#define bFM_CANFD_TXBCR_CR20                  *((volatile unsigned char*)(0x42E01AD0UL))
#define bFM_CANFD_TXBCR_CR21                  *((volatile unsigned char*)(0x42E01AD4UL))
#define bFM_CANFD_TXBCR_CR22                  *((volatile unsigned char*)(0x42E01AD8UL))
#define bFM_CANFD_TXBCR_CR23                  *((volatile unsigned char*)(0x42E01ADCUL))
#define bFM_CANFD_TXBCR_CR24                  *((volatile unsigned char*)(0x42E01AE0UL))
#define bFM_CANFD_TXBCR_CR25                  *((volatile unsigned char*)(0x42E01AE4UL))
#define bFM_CANFD_TXBCR_CR26                  *((volatile unsigned char*)(0x42E01AE8UL))
#define bFM_CANFD_TXBCR_CR27                  *((volatile unsigned char*)(0x42E01AECUL))
#define bFM_CANFD_TXBCR_CR28                  *((volatile unsigned char*)(0x42E01AF0UL))
#define bFM_CANFD_TXBCR_CR29                  *((volatile unsigned char*)(0x42E01AF4UL))
#define bFM_CANFD_TXBCR_CR30                  *((volatile unsigned char*)(0x42E01AF8UL))
#define bFM_CANFD_TXBCR_CR31                  *((volatile unsigned char*)(0x42E01AFCUL))
#define bFM_CANFD_TXBTO_TO0                   *((volatile unsigned char*)(0x42E01B00UL))
#define bFM_CANFD_TXBTO_TO1                   *((volatile unsigned char*)(0x42E01B04UL))
#define bFM_CANFD_TXBTO_TO2                   *((volatile unsigned char*)(0x42E01B08UL))
#define bFM_CANFD_TXBTO_TO3                   *((volatile unsigned char*)(0x42E01B0CUL))
#define bFM_CANFD_TXBTO_TO4                   *((volatile unsigned char*)(0x42E01B10UL))
#define bFM_CANFD_TXBTO_TO5                   *((volatile unsigned char*)(0x42E01B14UL))
#define bFM_CANFD_TXBTO_TO6                   *((volatile unsigned char*)(0x42E01B18UL))
#define bFM_CANFD_TXBTO_TO7                   *((volatile unsigned char*)(0x42E01B1CUL))
#define bFM_CANFD_TXBTO_TO8                   *((volatile unsigned char*)(0x42E01B20UL))
#define bFM_CANFD_TXBTO_TO9                   *((volatile unsigned char*)(0x42E01B24UL))
#define bFM_CANFD_TXBTO_TO10                  *((volatile unsigned char*)(0x42E01B28UL))
#define bFM_CANFD_TXBTO_TO11                  *((volatile unsigned char*)(0x42E01B2CUL))
#define bFM_CANFD_TXBTO_TO12                  *((volatile unsigned char*)(0x42E01B30UL))
#define bFM_CANFD_TXBTO_TO13                  *((volatile unsigned char*)(0x42E01B34UL))
#define bFM_CANFD_TXBTO_TO14                  *((volatile unsigned char*)(0x42E01B38UL))
#define bFM_CANFD_TXBTO_TO15                  *((volatile unsigned char*)(0x42E01B3CUL))
#define bFM_CANFD_TXBTO_TO16                  *((volatile unsigned char*)(0x42E01B40UL))
#define bFM_CANFD_TXBTO_TO17                  *((volatile unsigned char*)(0x42E01B44UL))
#define bFM_CANFD_TXBTO_TO18                  *((volatile unsigned char*)(0x42E01B48UL))
#define bFM_CANFD_TXBTO_TO19                  *((volatile unsigned char*)(0x42E01B4CUL))
#define bFM_CANFD_TXBTO_TO20                  *((volatile unsigned char*)(0x42E01B50UL))
#define bFM_CANFD_TXBTO_TO21                  *((volatile unsigned char*)(0x42E01B54UL))
#define bFM_CANFD_TXBTO_TO22                  *((volatile unsigned char*)(0x42E01B58UL))
#define bFM_CANFD_TXBTO_TO23                  *((volatile unsigned char*)(0x42E01B5CUL))
#define bFM_CANFD_TXBTO_TO24                  *((volatile unsigned char*)(0x42E01B60UL))
#define bFM_CANFD_TXBTO_TO25                  *((volatile unsigned char*)(0x42E01B64UL))
#define bFM_CANFD_TXBTO_TO26                  *((volatile unsigned char*)(0x42E01B68UL))
#define bFM_CANFD_TXBTO_TO27                  *((volatile unsigned char*)(0x42E01B6CUL))
#define bFM_CANFD_TXBTO_TO28                  *((volatile unsigned char*)(0x42E01B70UL))
#define bFM_CANFD_TXBTO_TO29                  *((volatile unsigned char*)(0x42E01B74UL))
#define bFM_CANFD_TXBTO_TO30                  *((volatile unsigned char*)(0x42E01B78UL))
#define bFM_CANFD_TXBTO_TO31                  *((volatile unsigned char*)(0x42E01B7CUL))
#define bFM_CANFD_TXBCF_CF0                   *((volatile unsigned char*)(0x42E01B80UL))
#define bFM_CANFD_TXBCF_CF1                   *((volatile unsigned char*)(0x42E01B84UL))
#define bFM_CANFD_TXBCF_CF2                   *((volatile unsigned char*)(0x42E01B88UL))
#define bFM_CANFD_TXBCF_CF3                   *((volatile unsigned char*)(0x42E01B8CUL))
#define bFM_CANFD_TXBCF_CF4                   *((volatile unsigned char*)(0x42E01B90UL))
#define bFM_CANFD_TXBCF_CF5                   *((volatile unsigned char*)(0x42E01B94UL))
#define bFM_CANFD_TXBCF_CF6                   *((volatile unsigned char*)(0x42E01B98UL))
#define bFM_CANFD_TXBCF_CF7                   *((volatile unsigned char*)(0x42E01B9CUL))
#define bFM_CANFD_TXBCF_CF8                   *((volatile unsigned char*)(0x42E01BA0UL))
#define bFM_CANFD_TXBCF_CF9                   *((volatile unsigned char*)(0x42E01BA4UL))
#define bFM_CANFD_TXBCF_CF10                  *((volatile unsigned char*)(0x42E01BA8UL))
#define bFM_CANFD_TXBCF_CF11                  *((volatile unsigned char*)(0x42E01BACUL))
#define bFM_CANFD_TXBCF_CF12                  *((volatile unsigned char*)(0x42E01BB0UL))
#define bFM_CANFD_TXBCF_CF13                  *((volatile unsigned char*)(0x42E01BB4UL))
#define bFM_CANFD_TXBCF_CF14                  *((volatile unsigned char*)(0x42E01BB8UL))
#define bFM_CANFD_TXBCF_CF15                  *((volatile unsigned char*)(0x42E01BBCUL))
#define bFM_CANFD_TXBCF_CF16                  *((volatile unsigned char*)(0x42E01BC0UL))
#define bFM_CANFD_TXBCF_CF17                  *((volatile unsigned char*)(0x42E01BC4UL))
#define bFM_CANFD_TXBCF_CF18                  *((volatile unsigned char*)(0x42E01BC8UL))
#define bFM_CANFD_TXBCF_CF19                  *((volatile unsigned char*)(0x42E01BCCUL))
#define bFM_CANFD_TXBCF_CF20                  *((volatile unsigned char*)(0x42E01BD0UL))
#define bFM_CANFD_TXBCF_CF21                  *((volatile unsigned char*)(0x42E01BD4UL))
#define bFM_CANFD_TXBCF_CF22                  *((volatile unsigned char*)(0x42E01BD8UL))
#define bFM_CANFD_TXBCF_CF23                  *((volatile unsigned char*)(0x42E01BDCUL))
#define bFM_CANFD_TXBCF_CF24                  *((volatile unsigned char*)(0x42E01BE0UL))
#define bFM_CANFD_TXBCF_CF25                  *((volatile unsigned char*)(0x42E01BE4UL))
#define bFM_CANFD_TXBCF_CF26                  *((volatile unsigned char*)(0x42E01BE8UL))
#define bFM_CANFD_TXBCF_CF27                  *((volatile unsigned char*)(0x42E01BECUL))
#define bFM_CANFD_TXBCF_CF28                  *((volatile unsigned char*)(0x42E01BF0UL))
#define bFM_CANFD_TXBCF_CF29                  *((volatile unsigned char*)(0x42E01BF4UL))
#define bFM_CANFD_TXBCF_CF30                  *((volatile unsigned char*)(0x42E01BF8UL))
#define bFM_CANFD_TXBCF_CF31                  *((volatile unsigned char*)(0x42E01BFCUL))
#define bFM_CANFD_TXBTIE_TIE0                 *((volatile unsigned char*)(0x42E01C00UL))
#define bFM_CANFD_TXBTIE_TIE1                 *((volatile unsigned char*)(0x42E01C04UL))
#define bFM_CANFD_TXBTIE_TIE2                 *((volatile unsigned char*)(0x42E01C08UL))
#define bFM_CANFD_TXBTIE_TIE3                 *((volatile unsigned char*)(0x42E01C0CUL))
#define bFM_CANFD_TXBTIE_TIE4                 *((volatile unsigned char*)(0x42E01C10UL))
#define bFM_CANFD_TXBTIE_TIE5                 *((volatile unsigned char*)(0x42E01C14UL))
#define bFM_CANFD_TXBTIE_TIE6                 *((volatile unsigned char*)(0x42E01C18UL))
#define bFM_CANFD_TXBTIE_TIE7                 *((volatile unsigned char*)(0x42E01C1CUL))
#define bFM_CANFD_TXBTIE_TIE8                 *((volatile unsigned char*)(0x42E01C20UL))
#define bFM_CANFD_TXBTIE_TIE9                 *((volatile unsigned char*)(0x42E01C24UL))
#define bFM_CANFD_TXBTIE_TIE10                *((volatile unsigned char*)(0x42E01C28UL))
#define bFM_CANFD_TXBTIE_TIE11                *((volatile unsigned char*)(0x42E01C2CUL))
#define bFM_CANFD_TXBTIE_TIE12                *((volatile unsigned char*)(0x42E01C30UL))
#define bFM_CANFD_TXBTIE_TIE13                *((volatile unsigned char*)(0x42E01C34UL))
#define bFM_CANFD_TXBTIE_TIE14                *((volatile unsigned char*)(0x42E01C38UL))
#define bFM_CANFD_TXBTIE_TIE15                *((volatile unsigned char*)(0x42E01C3CUL))
#define bFM_CANFD_TXBTIE_TIE16                *((volatile unsigned char*)(0x42E01C40UL))
#define bFM_CANFD_TXBTIE_TIE17                *((volatile unsigned char*)(0x42E01C44UL))
#define bFM_CANFD_TXBTIE_TIE18                *((volatile unsigned char*)(0x42E01C48UL))
#define bFM_CANFD_TXBTIE_TIE19                *((volatile unsigned char*)(0x42E01C4CUL))
#define bFM_CANFD_TXBTIE_TIE20                *((volatile unsigned char*)(0x42E01C50UL))
#define bFM_CANFD_TXBTIE_TIE21                *((volatile unsigned char*)(0x42E01C54UL))
#define bFM_CANFD_TXBTIE_TIE22                *((volatile unsigned char*)(0x42E01C58UL))
#define bFM_CANFD_TXBTIE_TIE23                *((volatile unsigned char*)(0x42E01C5CUL))
#define bFM_CANFD_TXBTIE_TIE24                *((volatile unsigned char*)(0x42E01C60UL))
#define bFM_CANFD_TXBTIE_TIE25                *((volatile unsigned char*)(0x42E01C64UL))
#define bFM_CANFD_TXBTIE_TIE26                *((volatile unsigned char*)(0x42E01C68UL))
#define bFM_CANFD_TXBTIE_TIE27                *((volatile unsigned char*)(0x42E01C6CUL))
#define bFM_CANFD_TXBTIE_TIE28                *((volatile unsigned char*)(0x42E01C70UL))
#define bFM_CANFD_TXBTIE_TIE29                *((volatile unsigned char*)(0x42E01C74UL))
#define bFM_CANFD_TXBTIE_TIE30                *((volatile unsigned char*)(0x42E01C78UL))
#define bFM_CANFD_TXBTIE_TIE31                *((volatile unsigned char*)(0x42E01C7CUL))
#define bFM_CANFD_TXBCIE_CFIE0                *((volatile unsigned char*)(0x42E01C80UL))
#define bFM_CANFD_TXBCIE_CFIE1                *((volatile unsigned char*)(0x42E01C84UL))
#define bFM_CANFD_TXBCIE_CFIE2                *((volatile unsigned char*)(0x42E01C88UL))
#define bFM_CANFD_TXBCIE_CFIE3                *((volatile unsigned char*)(0x42E01C8CUL))
#define bFM_CANFD_TXBCIE_CFIE4                *((volatile unsigned char*)(0x42E01C90UL))
#define bFM_CANFD_TXBCIE_CFIE5                *((volatile unsigned char*)(0x42E01C94UL))
#define bFM_CANFD_TXBCIE_CFIE6                *((volatile unsigned char*)(0x42E01C98UL))
#define bFM_CANFD_TXBCIE_CFIE7                *((volatile unsigned char*)(0x42E01C9CUL))
#define bFM_CANFD_TXBCIE_CFIE8                *((volatile unsigned char*)(0x42E01CA0UL))
#define bFM_CANFD_TXBCIE_CFIE9                *((volatile unsigned char*)(0x42E01CA4UL))
#define bFM_CANFD_TXBCIE_CFIE10               *((volatile unsigned char*)(0x42E01CA8UL))
#define bFM_CANFD_TXBCIE_CFIE11               *((volatile unsigned char*)(0x42E01CACUL))
#define bFM_CANFD_TXBCIE_CFIE12               *((volatile unsigned char*)(0x42E01CB0UL))
#define bFM_CANFD_TXBCIE_CFIE13               *((volatile unsigned char*)(0x42E01CB4UL))
#define bFM_CANFD_TXBCIE_CFIE14               *((volatile unsigned char*)(0x42E01CB8UL))
#define bFM_CANFD_TXBCIE_CFIE15               *((volatile unsigned char*)(0x42E01CBCUL))
#define bFM_CANFD_TXBCIE_CFIE16               *((volatile unsigned char*)(0x42E01CC0UL))
#define bFM_CANFD_TXBCIE_CFIE17               *((volatile unsigned char*)(0x42E01CC4UL))
#define bFM_CANFD_TXBCIE_CFIE18               *((volatile unsigned char*)(0x42E01CC8UL))
#define bFM_CANFD_TXBCIE_CFIE19               *((volatile unsigned char*)(0x42E01CCCUL))
#define bFM_CANFD_TXBCIE_CFIE20               *((volatile unsigned char*)(0x42E01CD0UL))
#define bFM_CANFD_TXBCIE_CFIE21               *((volatile unsigned char*)(0x42E01CD4UL))
#define bFM_CANFD_TXBCIE_CFIE22               *((volatile unsigned char*)(0x42E01CD8UL))
#define bFM_CANFD_TXBCIE_CFIE23               *((volatile unsigned char*)(0x42E01CDCUL))
#define bFM_CANFD_TXBCIE_CFIE24               *((volatile unsigned char*)(0x42E01CE0UL))
#define bFM_CANFD_TXBCIE_CFIE25               *((volatile unsigned char*)(0x42E01CE4UL))
#define bFM_CANFD_TXBCIE_CFIE26               *((volatile unsigned char*)(0x42E01CE8UL))
#define bFM_CANFD_TXBCIE_CFIE27               *((volatile unsigned char*)(0x42E01CECUL))
#define bFM_CANFD_TXBCIE_CFIE28               *((volatile unsigned char*)(0x42E01CF0UL))
#define bFM_CANFD_TXBCIE_CFIE29               *((volatile unsigned char*)(0x42E01CF4UL))
#define bFM_CANFD_TXBCIE_CFIE30               *((volatile unsigned char*)(0x42E01CF8UL))
#define bFM_CANFD_TXBCIE_CFIE31               *((volatile unsigned char*)(0x42E01CFCUL))
#define bFM_CANFD_TXEFC_EFSA0                 *((volatile unsigned char*)(0x42E01E08UL))
#define bFM_CANFD_TXEFC_EFSA1                 *((volatile unsigned char*)(0x42E01E0CUL))
#define bFM_CANFD_TXEFC_EFSA2                 *((volatile unsigned char*)(0x42E01E10UL))
#define bFM_CANFD_TXEFC_EFSA3                 *((volatile unsigned char*)(0x42E01E14UL))
#define bFM_CANFD_TXEFC_EFSA4                 *((volatile unsigned char*)(0x42E01E18UL))
#define bFM_CANFD_TXEFC_EFSA5                 *((volatile unsigned char*)(0x42E01E1CUL))
#define bFM_CANFD_TXEFC_EFSA6                 *((volatile unsigned char*)(0x42E01E20UL))
#define bFM_CANFD_TXEFC_EFSA7                 *((volatile unsigned char*)(0x42E01E24UL))
#define bFM_CANFD_TXEFC_EFSA8                 *((volatile unsigned char*)(0x42E01E28UL))
#define bFM_CANFD_TXEFC_EFSA9                 *((volatile unsigned char*)(0x42E01E2CUL))
#define bFM_CANFD_TXEFC_EFSA10                *((volatile unsigned char*)(0x42E01E30UL))
#define bFM_CANFD_TXEFC_EFSA11                *((volatile unsigned char*)(0x42E01E34UL))
#define bFM_CANFD_TXEFC_EFSA12                *((volatile unsigned char*)(0x42E01E38UL))
#define bFM_CANFD_TXEFC_EFSA13                *((volatile unsigned char*)(0x42E01E3CUL))
#define bFM_CANFD_TXEFC_EFS0                  *((volatile unsigned char*)(0x42E01E40UL))
#define bFM_CANFD_TXEFC_EFS1                  *((volatile unsigned char*)(0x42E01E44UL))
#define bFM_CANFD_TXEFC_EFS2                  *((volatile unsigned char*)(0x42E01E48UL))
#define bFM_CANFD_TXEFC_EFS3                  *((volatile unsigned char*)(0x42E01E4CUL))
#define bFM_CANFD_TXEFC_EFS4                  *((volatile unsigned char*)(0x42E01E50UL))
#define bFM_CANFD_TXEFC_EFS5                  *((volatile unsigned char*)(0x42E01E54UL))
#define bFM_CANFD_TXEFC_EFWM0                 *((volatile unsigned char*)(0x42E01E60UL))
#define bFM_CANFD_TXEFC_EFWM1                 *((volatile unsigned char*)(0x42E01E64UL))
#define bFM_CANFD_TXEFC_EFWM2                 *((volatile unsigned char*)(0x42E01E68UL))
#define bFM_CANFD_TXEFC_EFWM3                 *((volatile unsigned char*)(0x42E01E6CUL))
#define bFM_CANFD_TXEFC_EFWM4                 *((volatile unsigned char*)(0x42E01E70UL))
#define bFM_CANFD_TXEFC_EFWM5                 *((volatile unsigned char*)(0x42E01E74UL))
#define bFM_CANFD_TXFS_EFFL0                  *((volatile unsigned char*)(0x42E01E80UL))
#define bFM_CANFD_TXFS_EFFL1                  *((volatile unsigned char*)(0x42E01E84UL))
#define bFM_CANFD_TXFS_EFFL2                  *((volatile unsigned char*)(0x42E01E88UL))
#define bFM_CANFD_TXFS_EFFL3                  *((volatile unsigned char*)(0x42E01E8CUL))
#define bFM_CANFD_TXFS_EFFL4                  *((volatile unsigned char*)(0x42E01E90UL))
#define bFM_CANFD_TXFS_EFFL5                  *((volatile unsigned char*)(0x42E01E94UL))
#define bFM_CANFD_TXFS_EFGI0                  *((volatile unsigned char*)(0x42E01EA0UL))
#define bFM_CANFD_TXFS_EFGI1                  *((volatile unsigned char*)(0x42E01EA4UL))
#define bFM_CANFD_TXFS_EFGI2                  *((volatile unsigned char*)(0x42E01EA8UL))
#define bFM_CANFD_TXFS_EFGI3                  *((volatile unsigned char*)(0x42E01EACUL))
#define bFM_CANFD_TXFS_EFGI4                  *((volatile unsigned char*)(0x42E01EB0UL))
#define bFM_CANFD_TXFS_EFPI0                  *((volatile unsigned char*)(0x42E01EC0UL))
#define bFM_CANFD_TXFS_EFPI1                  *((volatile unsigned char*)(0x42E01EC4UL))
#define bFM_CANFD_TXFS_EFPI2                  *((volatile unsigned char*)(0x42E01EC8UL))
#define bFM_CANFD_TXFS_EFPI3                  *((volatile unsigned char*)(0x42E01ECCUL))
#define bFM_CANFD_TXFS_EFPI4                  *((volatile unsigned char*)(0x42E01ED0UL))
#define bFM_CANFD_TXFS_EFF                    *((volatile unsigned char*)(0x42E01EE0UL))
#define bFM_CANFD_TXFS_TEFL                   *((volatile unsigned char*)(0x42E01EE4UL))
#define bFM_CANFD_TXFA_EFAI0                  *((volatile unsigned char*)(0x42E01F00UL))
#define bFM_CANFD_TXFA_EFAI1                  *((volatile unsigned char*)(0x42E01F04UL))
#define bFM_CANFD_TXFA_EFAI2                  *((volatile unsigned char*)(0x42E01F08UL))
#define bFM_CANFD_TXFA_EFAI3                  *((volatile unsigned char*)(0x42E01F0CUL))
#define bFM_CANFD_TXFA_EFAI4                  *((volatile unsigned char*)(0x42E01F10UL))
#define bFM_CANFD_FDECR_SEIE                  *((volatile unsigned char*)(0x42E04000UL))
#define bFM_CANFD_FDECR_DEIE                  *((volatile unsigned char*)(0x42E04004UL))
#define bFM_CANFD_FDECR_CEREN                 *((volatile unsigned char*)(0x42E04008UL))
#define bFM_CANFD_FDECR_CEIV                  *((volatile unsigned char*)(0x42E0400CUL))
#define bFM_CANFD_FDESR_SEI                   *((volatile unsigned char*)(0x42E04020UL))
#define bFM_CANFD_FDESR_DEI                   *((volatile unsigned char*)(0x42E04024UL))
#define bFM_CANFD_FDSEAR_SRA0                 *((volatile unsigned char*)(0x42E04040UL))
#define bFM_CANFD_FDSEAR_SRA1                 *((volatile unsigned char*)(0x42E04044UL))
#define bFM_CANFD_FDSEAR_SRA2                 *((volatile unsigned char*)(0x42E04048UL))
#define bFM_CANFD_FDSEAR_SRA3                 *((volatile unsigned char*)(0x42E0404CUL))
#define bFM_CANFD_FDSEAR_SRA4                 *((volatile unsigned char*)(0x42E04050UL))
#define bFM_CANFD_FDSEAR_SRA5                 *((volatile unsigned char*)(0x42E04054UL))
#define bFM_CANFD_FDSEAR_SRA6                 *((volatile unsigned char*)(0x42E04058UL))
#define bFM_CANFD_FDSEAR_SRA7                 *((volatile unsigned char*)(0x42E0405CUL))
#define bFM_CANFD_FDSEAR_SRA8                 *((volatile unsigned char*)(0x42E04060UL))
#define bFM_CANFD_FDSEAR_SRA9                 *((volatile unsigned char*)(0x42E04064UL))
#define bFM_CANFD_FDSEAR_SRA10                *((volatile unsigned char*)(0x42E04068UL))
#define bFM_CANFD_FDSEAR_SRA11                *((volatile unsigned char*)(0x42E0406CUL))
#define bFM_CANFD_FDSEAR_SRA12                *((volatile unsigned char*)(0x42E04070UL))
#define bFM_CANFD_FDSEAR_SRA13                *((volatile unsigned char*)(0x42E04074UL))
#define bFM_CANFD_FDSEAR_SRA14                *((volatile unsigned char*)(0x42E04078UL))
#define bFM_CANFD_FDSEAR_SRA15                *((volatile unsigned char*)(0x42E0407CUL))
#define bFM_CANFD_FDESCR_SEIC                 *((volatile unsigned char*)(0x42E040A0UL))
#define bFM_CANFD_FDESCR_DEIC                 *((volatile unsigned char*)(0x42E040A4UL))
#define bFM_CANFD_FDDEAR_DRA0                 *((volatile unsigned char*)(0x42E040C0UL))
#define bFM_CANFD_FDDEAR_DRA1                 *((volatile unsigned char*)(0x42E040C4UL))
#define bFM_CANFD_FDDEAR_DRA2                 *((volatile unsigned char*)(0x42E040C8UL))
#define bFM_CANFD_FDDEAR_DRA3                 *((volatile unsigned char*)(0x42E040CCUL))
#define bFM_CANFD_FDDEAR_DRA4                 *((volatile unsigned char*)(0x42E040D0UL))
#define bFM_CANFD_FDDEAR_DRA5                 *((volatile unsigned char*)(0x42E040D4UL))
#define bFM_CANFD_FDDEAR_DRA6                 *((volatile unsigned char*)(0x42E040D8UL))
#define bFM_CANFD_FDDEAR_DRA7                 *((volatile unsigned char*)(0x42E040DCUL))
#define bFM_CANFD_FDDEAR_DRA8                 *((volatile unsigned char*)(0x42E040E0UL))
#define bFM_CANFD_FDDEAR_DRA9                 *((volatile unsigned char*)(0x42E040E4UL))
#define bFM_CANFD_FDDEAR_DRA10                *((volatile unsigned char*)(0x42E040E8UL))
#define bFM_CANFD_FDDEAR_DRA11                *((volatile unsigned char*)(0x42E040ECUL))
#define bFM_CANFD_FDDEAR_DRA12                *((volatile unsigned char*)(0x42E040F0UL))
#define bFM_CANFD_FDDEAR_DRA13                *((volatile unsigned char*)(0x42E040F4UL))
#define bFM_CANFD_FDDEAR_DRA14                *((volatile unsigned char*)(0x42E040F8UL))
#define bFM_CANFD_FDDEAR_DRA15                *((volatile unsigned char*)(0x42E040FCUL))
#define bFM_CANFD_TSCNTR_CCLR                 *((volatile unsigned char*)(0x42E04200UL))
#define bFM_CANFD_TSMDR_CNTEN                 *((volatile unsigned char*)(0x42E04240UL))
#define bFM_CANFD_TSDIVR_CDIV0                *((volatile unsigned char*)(0x42E04280UL))
#define bFM_CANFD_TSDIVR_CDIV1                *((volatile unsigned char*)(0x42E04284UL))
#define bFM_CANFD_TSDIVR_CDIV2                *((volatile unsigned char*)(0x42E04288UL))
#define bFM_CANFD_TSDIVR_CDIV3                *((volatile unsigned char*)(0x42E0428CUL))
#define bFM_CANFD_TSDIVR_CDIV4                *((volatile unsigned char*)(0x42E04290UL))
#define bFM_CANFD_TSDIVR_CDIV5                *((volatile unsigned char*)(0x42E04294UL))
#define bFM_CANFD_TSDIVR_CDIV6                *((volatile unsigned char*)(0x42E04298UL))
#define bFM_CANFD_TSDIVR_CDIV7                *((volatile unsigned char*)(0x42E0429CUL))
#define bFM_CANFD_TSDIVR_CDIV8                *((volatile unsigned char*)(0x42E042A0UL))
#define bFM_CANFD_TSDIVR_CDIV9                *((volatile unsigned char*)(0x42E042A4UL))
#define bFM_CANFD_TSDIVR_CDIV10               *((volatile unsigned char*)(0x42E042A8UL))
#define bFM_CANFD_TSDIVR_CDIV11               *((volatile unsigned char*)(0x42E042ACUL))
#define bFM_CANFD_TSDIVR_CDIV12               *((volatile unsigned char*)(0x42E042B0UL))
#define bFM_CANFD_TSDIVR_CDIV13               *((volatile unsigned char*)(0x42E042B4UL))
#define bFM_CANFD_TSDIVR_CDIV14               *((volatile unsigned char*)(0x42E042B8UL))
#define bFM_CANFD_TSDIVR_CDIV15               *((volatile unsigned char*)(0x42E042BCUL))
#define bFM_CANFD_TSCDTR_CNT0                 *((volatile unsigned char*)(0x42E04300UL))
#define bFM_CANFD_TSCDTR_CNT1                 *((volatile unsigned char*)(0x42E04304UL))
#define bFM_CANFD_TSCDTR_CNT2                 *((volatile unsigned char*)(0x42E04308UL))
#define bFM_CANFD_TSCDTR_CNT3                 *((volatile unsigned char*)(0x42E0430CUL))
#define bFM_CANFD_TSCDTR_CNT4                 *((volatile unsigned char*)(0x42E04310UL))
#define bFM_CANFD_TSCDTR_CNT5                 *((volatile unsigned char*)(0x42E04314UL))
#define bFM_CANFD_TSCDTR_CNT6                 *((volatile unsigned char*)(0x42E04318UL))
#define bFM_CANFD_TSCDTR_CNT7                 *((volatile unsigned char*)(0x42E0431CUL))
#define bFM_CANFD_TSCDTR_CNT8                 *((volatile unsigned char*)(0x42E04320UL))
#define bFM_CANFD_TSCDTR_CNT9                 *((volatile unsigned char*)(0x42E04324UL))
#define bFM_CANFD_TSCDTR_CNT10                *((volatile unsigned char*)(0x42E04328UL))
#define bFM_CANFD_TSCDTR_CNT11                *((volatile unsigned char*)(0x42E0432CUL))
#define bFM_CANFD_TSCDTR_CNT12                *((volatile unsigned char*)(0x42E04330UL))
#define bFM_CANFD_TSCDTR_CNT13                *((volatile unsigned char*)(0x42E04334UL))
#define bFM_CANFD_TSCDTR_CNT14                *((volatile unsigned char*)(0x42E04338UL))
#define bFM_CANFD_TSCDTR_CNT15                *((volatile unsigned char*)(0x42E0433CUL))
#define bFM_CANFD_TSCPCLR_CMP0                *((volatile unsigned char*)(0x42E04340UL))
#define bFM_CANFD_TSCPCLR_CMP1                *((volatile unsigned char*)(0x42E04344UL))
#define bFM_CANFD_TSCPCLR_CMP2                *((volatile unsigned char*)(0x42E04348UL))
#define bFM_CANFD_TSCPCLR_CMP3                *((volatile unsigned char*)(0x42E0434CUL))
#define bFM_CANFD_TSCPCLR_CMP4                *((volatile unsigned char*)(0x42E04350UL))
#define bFM_CANFD_TSCPCLR_CMP5                *((volatile unsigned char*)(0x42E04354UL))
#define bFM_CANFD_TSCPCLR_CMP6                *((volatile unsigned char*)(0x42E04358UL))
#define bFM_CANFD_TSCPCLR_CMP7                *((volatile unsigned char*)(0x42E0435CUL))
#define bFM_CANFD_TSCPCLR_CMP8                *((volatile unsigned char*)(0x42E04360UL))
#define bFM_CANFD_TSCPCLR_CMP9                *((volatile unsigned char*)(0x42E04364UL))
#define bFM_CANFD_TSCPCLR_CMP10               *((volatile unsigned char*)(0x42E04368UL))
#define bFM_CANFD_TSCPCLR_CMP11               *((volatile unsigned char*)(0x42E0436CUL))
#define bFM_CANFD_TSCPCLR_CMP12               *((volatile unsigned char*)(0x42E04370UL))
#define bFM_CANFD_TSCPCLR_CMP13               *((volatile unsigned char*)(0x42E04374UL))
#define bFM_CANFD_TSCPCLR_CMP14               *((volatile unsigned char*)(0x42E04378UL))
#define bFM_CANFD_TSCPCLR_CMP15               *((volatile unsigned char*)(0x42E0437CUL))

/* Programable-CRC registers */
#define bFM_PCRC_PRGCRC_CFG_CIRQCLR           *((volatile unsigned char*)(0x43000180UL))
#define bFM_PCRC_PRGCRC_CFG_FO0               *((volatile unsigned char*)(0x430001A0UL))
#define bFM_PCRC_PRGCRC_CFG_FO1               *((volatile unsigned char*)(0x430001A4UL))
#define bFM_PCRC_PRGCRC_CFG_FI0               *((volatile unsigned char*)(0x430001A8UL))
#define bFM_PCRC_PRGCRC_CFG_FI1               *((volatile unsigned char*)(0x430001ACUL))
#define bFM_PCRC_PRGCRC_CFG_TEST0             *((volatile unsigned char*)(0x430001C0UL))
#define bFM_PCRC_PRGCRC_CFG_TEST1             *((volatile unsigned char*)(0x430001C4UL))
#define bFM_PCRC_PRGCRC_CFG_TEST2             *((volatile unsigned char*)(0x430001C8UL))
#define bFM_PCRC_PRGCRC_CFG_TEST3             *((volatile unsigned char*)(0x430001CCUL))
#define bFM_PCRC_PRGCRC_CFG_TEST4             *((volatile unsigned char*)(0x430001D0UL))
#define bFM_PCRC_PRGCRC_CFG_TEST5             *((volatile unsigned char*)(0x430001D4UL))
#define bFM_PCRC_PRGCRC_CFG_SZ0               *((volatile unsigned char*)(0x430001D8UL))
#define bFM_PCRC_PRGCRC_CFG_SZ1               *((volatile unsigned char*)(0x430001DCUL))
#define bFM_PCRC_PRGCRC_CFG_CIRQ              *((volatile unsigned char*)(0x430001E0UL))
#define bFM_PCRC_PRGCRC_CFG_CIEN              *((volatile unsigned char*)(0x430001E4UL))
#define bFM_PCRC_PRGCRC_CFG_CDEN              *((volatile unsigned char*)(0x430001E8UL))
#define bFM_PCRC_PRGCRC_CFG_LOCK              *((volatile unsigned char*)(0x430001F0UL))

/* High-Speed Quad SPI registers */
#define bFM_HSSPI_MCTRL_MEN                   *((volatile unsigned char*)(0x1242000000UL))
#define bFM_HSSPI_MCTRL_CSEN                  *((volatile unsigned char*)(0x1242000004UL))
#define bFM_HSSPI_MCTRL_MES                   *((volatile unsigned char*)(0x1242000010UL))
#define bFM_HSSPI_MCTRL_SYNCON                *((volatile unsigned char*)(0x1242000014UL))
#define bFM_HSSPI_PCC0_CPHA                   *((volatile unsigned char*)(0x1242000080UL))
#define bFM_HSSPI_PCC0_CPOL                   *((volatile unsigned char*)(0x1242000084UL))
#define bFM_HSSPI_PCC0_ACES                   *((volatile unsigned char*)(0x1242000088UL))
#define bFM_HSSPI_PCC0_RTM                    *((volatile unsigned char*)(0x124200008CUL))
#define bFM_HSSPI_PCC0_SSPOL                  *((volatile unsigned char*)(0x1242000090UL))
#define bFM_HSSPI_PCC0_SS2CD0                 *((volatile unsigned char*)(0x1242000094UL))
#define bFM_HSSPI_PCC0_SS2CD1                 *((volatile unsigned char*)(0x1242000098UL))
#define bFM_HSSPI_PCC0_SDIR                   *((volatile unsigned char*)(0x124200009CUL))
#define bFM_HSSPI_PCC0_SENDIAN                *((volatile unsigned char*)(0x12420000A0UL))
#define bFM_HSSPI_PCC0_CDRS0                  *((volatile unsigned char*)(0x12420000A4UL))
#define bFM_HSSPI_PCC0_CDRS1                  *((volatile unsigned char*)(0x12420000A8UL))
#define bFM_HSSPI_PCC0_CDRS2                  *((volatile unsigned char*)(0x12420000ACUL))
#define bFM_HSSPI_PCC0_CDRS3                  *((volatile unsigned char*)(0x12420000B0UL))
#define bFM_HSSPI_PCC0_CDRS4                  *((volatile unsigned char*)(0x12420000B4UL))
#define bFM_HSSPI_PCC0_CDRS5                  *((volatile unsigned char*)(0x12420000B8UL))
#define bFM_HSSPI_PCC0_CDRS6                  *((volatile unsigned char*)(0x12420000BCUL))
#define bFM_HSSPI_PCC0_SAFESYNC               *((volatile unsigned char*)(0x12420000C0UL))
#define bFM_HSSPI_PCC0_WRDSEL0                *((volatile unsigned char*)(0x12420000C4UL))
#define bFM_HSSPI_PCC0_WRDSEL1                *((volatile unsigned char*)(0x12420000C8UL))
#define bFM_HSSPI_PCC0_WRDSEL2                *((volatile unsigned char*)(0x12420000CCUL))
#define bFM_HSSPI_PCC0_WRDSEL3                *((volatile unsigned char*)(0x12420000D0UL))
#define bFM_HSSPI_PCC0_RDDSEL0                *((volatile unsigned char*)(0x12420000D4UL))
#define bFM_HSSPI_PCC0_RDDSEL1                *((volatile unsigned char*)(0x12420000D8UL))
#define bFM_HSSPI_PCC1_CPHA                   *((volatile unsigned char*)(0x1242000100UL))
#define bFM_HSSPI_PCC1_CPOL                   *((volatile unsigned char*)(0x1242000104UL))
#define bFM_HSSPI_PCC1_ACES                   *((volatile unsigned char*)(0x1242000108UL))
#define bFM_HSSPI_PCC1_RTM                    *((volatile unsigned char*)(0x124200010CUL))
#define bFM_HSSPI_PCC1_SSPOL                  *((volatile unsigned char*)(0x1242000110UL))
#define bFM_HSSPI_PCC1_SS2CD0                 *((volatile unsigned char*)(0x1242000114UL))
#define bFM_HSSPI_PCC1_SS2CD1                 *((volatile unsigned char*)(0x1242000118UL))
#define bFM_HSSPI_PCC1_SDIR                   *((volatile unsigned char*)(0x124200011CUL))
#define bFM_HSSPI_PCC1_SENDIAN                *((volatile unsigned char*)(0x1242000120UL))
#define bFM_HSSPI_PCC1_CDRS0                  *((volatile unsigned char*)(0x1242000124UL))
#define bFM_HSSPI_PCC1_CDRS1                  *((volatile unsigned char*)(0x1242000128UL))
#define bFM_HSSPI_PCC1_CDRS2                  *((volatile unsigned char*)(0x124200012CUL))
#define bFM_HSSPI_PCC1_CDRS3                  *((volatile unsigned char*)(0x1242000130UL))
#define bFM_HSSPI_PCC1_CDRS4                  *((volatile unsigned char*)(0x1242000134UL))
#define bFM_HSSPI_PCC1_CDRS5                  *((volatile unsigned char*)(0x1242000138UL))
#define bFM_HSSPI_PCC1_CDRS6                  *((volatile unsigned char*)(0x124200013CUL))
#define bFM_HSSPI_PCC1_SAFESYNC               *((volatile unsigned char*)(0x1242000140UL))
#define bFM_HSSPI_PCC1_WRDSEL0                *((volatile unsigned char*)(0x1242000144UL))
#define bFM_HSSPI_PCC1_WRDSEL1                *((volatile unsigned char*)(0x1242000148UL))
#define bFM_HSSPI_PCC1_WRDSEL2                *((volatile unsigned char*)(0x124200014CUL))
#define bFM_HSSPI_PCC1_WRDSEL3                *((volatile unsigned char*)(0x1242000150UL))
#define bFM_HSSPI_PCC1_RDDSEL0                *((volatile unsigned char*)(0x1242000154UL))
#define bFM_HSSPI_PCC1_RDDSEL1                *((volatile unsigned char*)(0x1242000158UL))
#define bFM_HSSPI_PCC2_CPHA                   *((volatile unsigned char*)(0x1242000180UL))
#define bFM_HSSPI_PCC2_CPOL                   *((volatile unsigned char*)(0x1242000184UL))
#define bFM_HSSPI_PCC2_ACES                   *((volatile unsigned char*)(0x1242000188UL))
#define bFM_HSSPI_PCC2_RTM                    *((volatile unsigned char*)(0x124200018CUL))
#define bFM_HSSPI_PCC2_SSPOL                  *((volatile unsigned char*)(0x1242000190UL))
#define bFM_HSSPI_PCC2_SS2CD0                 *((volatile unsigned char*)(0x1242000194UL))
#define bFM_HSSPI_PCC2_SS2CD1                 *((volatile unsigned char*)(0x1242000198UL))
#define bFM_HSSPI_PCC2_SDIR                   *((volatile unsigned char*)(0x124200019CUL))
#define bFM_HSSPI_PCC2_SENDIAN                *((volatile unsigned char*)(0x12420001A0UL))
#define bFM_HSSPI_PCC2_CDRS0                  *((volatile unsigned char*)(0x12420001A4UL))
#define bFM_HSSPI_PCC2_CDRS1                  *((volatile unsigned char*)(0x12420001A8UL))
#define bFM_HSSPI_PCC2_CDRS2                  *((volatile unsigned char*)(0x12420001ACUL))
#define bFM_HSSPI_PCC2_CDRS3                  *((volatile unsigned char*)(0x12420001B0UL))
#define bFM_HSSPI_PCC2_CDRS4                  *((volatile unsigned char*)(0x12420001B4UL))
#define bFM_HSSPI_PCC2_CDRS5                  *((volatile unsigned char*)(0x12420001B8UL))
#define bFM_HSSPI_PCC2_CDRS6                  *((volatile unsigned char*)(0x12420001BCUL))
#define bFM_HSSPI_PCC2_SAFESYNC               *((volatile unsigned char*)(0x12420001C0UL))
#define bFM_HSSPI_PCC2_WRDSEL0                *((volatile unsigned char*)(0x12420001C4UL))
#define bFM_HSSPI_PCC2_WRDSEL1                *((volatile unsigned char*)(0x12420001C8UL))
#define bFM_HSSPI_PCC2_WRDSEL2                *((volatile unsigned char*)(0x12420001CCUL))
#define bFM_HSSPI_PCC2_WRDSEL3                *((volatile unsigned char*)(0x12420001D0UL))
#define bFM_HSSPI_PCC2_RDDSEL0                *((volatile unsigned char*)(0x12420001D4UL))
#define bFM_HSSPI_PCC2_RDDSEL1                *((volatile unsigned char*)(0x12420001D8UL))
#define bFM_HSSPI_PCC3_CPHA                   *((volatile unsigned char*)(0x1242000200UL))
#define bFM_HSSPI_PCC3_CPOL                   *((volatile unsigned char*)(0x1242000204UL))
#define bFM_HSSPI_PCC3_ACES                   *((volatile unsigned char*)(0x1242000208UL))
#define bFM_HSSPI_PCC3_RTM                    *((volatile unsigned char*)(0x124200020CUL))
#define bFM_HSSPI_PCC3_SSPOL                  *((volatile unsigned char*)(0x1242000210UL))
#define bFM_HSSPI_PCC3_SS2CD0                 *((volatile unsigned char*)(0x1242000214UL))
#define bFM_HSSPI_PCC3_SS2CD1                 *((volatile unsigned char*)(0x1242000218UL))
#define bFM_HSSPI_PCC3_SDIR                   *((volatile unsigned char*)(0x124200021CUL))
#define bFM_HSSPI_PCC3_SENDIAN                *((volatile unsigned char*)(0x1242000220UL))
#define bFM_HSSPI_PCC3_CDRS0                  *((volatile unsigned char*)(0x1242000224UL))
#define bFM_HSSPI_PCC3_CDRS1                  *((volatile unsigned char*)(0x1242000228UL))
#define bFM_HSSPI_PCC3_CDRS2                  *((volatile unsigned char*)(0x124200022CUL))
#define bFM_HSSPI_PCC3_CDRS3                  *((volatile unsigned char*)(0x1242000230UL))
#define bFM_HSSPI_PCC3_CDRS4                  *((volatile unsigned char*)(0x1242000234UL))
#define bFM_HSSPI_PCC3_CDRS5                  *((volatile unsigned char*)(0x1242000238UL))
#define bFM_HSSPI_PCC3_CDRS6                  *((volatile unsigned char*)(0x124200023CUL))
#define bFM_HSSPI_PCC3_SAFESYNC               *((volatile unsigned char*)(0x1242000240UL))
#define bFM_HSSPI_PCC3_WRDSEL0                *((volatile unsigned char*)(0x1242000244UL))
#define bFM_HSSPI_PCC3_WRDSEL1                *((volatile unsigned char*)(0x1242000248UL))
#define bFM_HSSPI_PCC3_WRDSEL2                *((volatile unsigned char*)(0x124200024CUL))
#define bFM_HSSPI_PCC3_WRDSEL3                *((volatile unsigned char*)(0x1242000250UL))
#define bFM_HSSPI_PCC3_RDDSEL0                *((volatile unsigned char*)(0x1242000254UL))
#define bFM_HSSPI_PCC3_RDDSEL1                *((volatile unsigned char*)(0x1242000258UL))
#define bFM_HSSPI_TXF_TFFS                    *((volatile unsigned char*)(0x1242000280UL))
#define bFM_HSSPI_TXF_TFES                    *((volatile unsigned char*)(0x1242000284UL))
#define bFM_HSSPI_TXF_TFOS                    *((volatile unsigned char*)(0x1242000288UL))
#define bFM_HSSPI_TXF_TFUS                    *((volatile unsigned char*)(0x124200028CUL))
#define bFM_HSSPI_TXF_TFLETS                  *((volatile unsigned char*)(0x1242000290UL))
#define bFM_HSSPI_TXF_TFMTS                   *((volatile unsigned char*)(0x1242000294UL))
#define bFM_HSSPI_TXF_TSSRS                   *((volatile unsigned char*)(0x1242000298UL))
#define bFM_HSSPI_TXE_TFFE                    *((volatile unsigned char*)(0x1242000300UL))
#define bFM_HSSPI_TXE_TFEE                    *((volatile unsigned char*)(0x1242000304UL))
#define bFM_HSSPI_TXE_TFOE                    *((volatile unsigned char*)(0x1242000308UL))
#define bFM_HSSPI_TXE_TFUE                    *((volatile unsigned char*)(0x124200030CUL))
#define bFM_HSSPI_TXE_TFLETE                  *((volatile unsigned char*)(0x1242000310UL))
#define bFM_HSSPI_TXE_TFMTE                   *((volatile unsigned char*)(0x1242000314UL))
#define bFM_HSSPI_TXE_TSSRE                   *((volatile unsigned char*)(0x1242000318UL))
#define bFM_HSSPI_TXC_TFFC                    *((volatile unsigned char*)(0x1242000380UL))
#define bFM_HSSPI_TXC_TFEC                    *((volatile unsigned char*)(0x1242000384UL))
#define bFM_HSSPI_TXC_TFOC                    *((volatile unsigned char*)(0x1242000388UL))
#define bFM_HSSPI_TXC_TFUC                    *((volatile unsigned char*)(0x124200038CUL))
#define bFM_HSSPI_TXC_TFLETC                  *((volatile unsigned char*)(0x1242000390UL))
#define bFM_HSSPI_TXC_TFMTC                   *((volatile unsigned char*)(0x1242000394UL))
#define bFM_HSSPI_TXC_TSSRC                   *((volatile unsigned char*)(0x1242000398UL))
#define bFM_HSSPI_RXF_RFFS                    *((volatile unsigned char*)(0x1242000400UL))
#define bFM_HSSPI_RXF_RFES                    *((volatile unsigned char*)(0x1242000404UL))
#define bFM_HSSPI_RXF_RFOS                    *((volatile unsigned char*)(0x1242000408UL))
#define bFM_HSSPI_RXF_RFUS                    *((volatile unsigned char*)(0x124200040CUL))
#define bFM_HSSPI_RXF_RFLETS                  *((volatile unsigned char*)(0x1242000410UL))
#define bFM_HSSPI_RXF_RFMTS                   *((volatile unsigned char*)(0x1242000414UL))
#define bFM_HSSPI_RXF_RSSRS                   *((volatile unsigned char*)(0x1242000418UL))
#define bFM_HSSPI_RXE_RFFE                    *((volatile unsigned char*)(0x1242000480UL))
#define bFM_HSSPI_RXE_RFEE                    *((volatile unsigned char*)(0x1242000484UL))
#define bFM_HSSPI_RXE_RFOE                    *((volatile unsigned char*)(0x1242000488UL))
#define bFM_HSSPI_RXE_RFUE                    *((volatile unsigned char*)(0x124200048CUL))
#define bFM_HSSPI_RXE_RFLETE                  *((volatile unsigned char*)(0x1242000490UL))
#define bFM_HSSPI_RXE_RFMTE                   *((volatile unsigned char*)(0x1242000494UL))
#define bFM_HSSPI_RXE_RSSRE                   *((volatile unsigned char*)(0x1242000498UL))
#define bFM_HSSPI_RXC_RFFC                    *((volatile unsigned char*)(0x1242000500UL))
#define bFM_HSSPI_RXC_RFEC                    *((volatile unsigned char*)(0x1242000504UL))
#define bFM_HSSPI_RXC_RFOC                    *((volatile unsigned char*)(0x1242000508UL))
#define bFM_HSSPI_RXC_RFUC                    *((volatile unsigned char*)(0x124200050CUL))
#define bFM_HSSPI_RXC_RFLETC                  *((volatile unsigned char*)(0x1242000510UL))
#define bFM_HSSPI_RXC_RFMTC                   *((volatile unsigned char*)(0x1242000514UL))
#define bFM_HSSPI_RXC_RSSRC                   *((volatile unsigned char*)(0x1242000518UL))
#define bFM_HSSPI_FAULTF_UMAFS                *((volatile unsigned char*)(0x1242000580UL))
#define bFM_HSSPI_FAULTF_WAFS                 *((volatile unsigned char*)(0x1242000584UL))
#define bFM_HSSPI_FAULTF_PVFS                 *((volatile unsigned char*)(0x1242000588UL))
#define bFM_HSSPI_FAULTF_DWCBSFS              *((volatile unsigned char*)(0x124200058CUL))
#define bFM_HSSPI_FAULTF_DRCBSFS              *((volatile unsigned char*)(0x1242000590UL))
#define bFM_HSSPI_FAULTC_UMAFC                *((volatile unsigned char*)(0x1242000600UL))
#define bFM_HSSPI_FAULTC_WAFC                 *((volatile unsigned char*)(0x1242000604UL))
#define bFM_HSSPI_FAULTC_PVFC                 *((volatile unsigned char*)(0x1242000608UL))
#define bFM_HSSPI_FAULTC_DWCBSFC              *((volatile unsigned char*)(0x124200060CUL))
#define bFM_HSSPI_FAULTC_DRCBSFC              *((volatile unsigned char*)(0x1242000610UL))
#define bFM_HSSPI_DMCFG_SSDC                  *((volatile unsigned char*)(0x1242000684UL))
#define bFM_HSSPI_DMDMAEN_RXDMAEN             *((volatile unsigned char*)(0x12420006A0UL))
#define bFM_HSSPI_DMDMAEN_TXDMAEN             *((volatile unsigned char*)(0x12420006A4UL))
#define bFM_HSSPI_DMSTART_START               *((volatile unsigned char*)(0x1242000700UL))
#define bFM_HSSPI_DMSTOP_STOP                 *((volatile unsigned char*)(0x1242000720UL))
#define bFM_HSSPI_DMPSEL_PSEL0                *((volatile unsigned char*)(0x1242000740UL))
#define bFM_HSSPI_DMPSEL_PSEL1                *((volatile unsigned char*)(0x1242000744UL))
#define bFM_HSSPI_DMTRP_TRP0                  *((volatile unsigned char*)(0x1242000760UL))
#define bFM_HSSPI_DMTRP_TRP1                  *((volatile unsigned char*)(0x1242000764UL))
#define bFM_HSSPI_DMTRP_TRP2                  *((volatile unsigned char*)(0x1242000768UL))
#define bFM_HSSPI_DMTRP_TRP3                  *((volatile unsigned char*)(0x124200076CUL))
#define bFM_HSSPI_DMSTATUS_RXACTIVE           *((volatile unsigned char*)(0x1242000800UL))
#define bFM_HSSPI_DMSTATUS_TXACTIVE           *((volatile unsigned char*)(0x1242000804UL))
#define bFM_HSSPI_DMSTATUS_RXFLEVEL0          *((volatile unsigned char*)(0x1242000820UL))
#define bFM_HSSPI_DMSTATUS_RXFLEVEL1          *((volatile unsigned char*)(0x1242000824UL))
#define bFM_HSSPI_DMSTATUS_RXFLEVEL2          *((volatile unsigned char*)(0x1242000828UL))
#define bFM_HSSPI_DMSTATUS_RXFLEVEL3          *((volatile unsigned char*)(0x124200082CUL))
#define bFM_HSSPI_DMSTATUS_RXFLEVEL4          *((volatile unsigned char*)(0x1242000830UL))
#define bFM_HSSPI_DMSTATUS_TXFLEVEL0          *((volatile unsigned char*)(0x1242000840UL))
#define bFM_HSSPI_DMSTATUS_TXFLEVEL1          *((volatile unsigned char*)(0x1242000844UL))
#define bFM_HSSPI_DMSTATUS_TXFLEVEL2          *((volatile unsigned char*)(0x1242000848UL))
#define bFM_HSSPI_DMSTATUS_TXFLEVEL3          *((volatile unsigned char*)(0x124200084CUL))
#define bFM_HSSPI_DMSTATUS_TXFLEVEL4          *((volatile unsigned char*)(0x1242000850UL))
#define bFM_HSSPI_FIFOCFG_RXFTH0              *((volatile unsigned char*)(0x1242000980UL))
#define bFM_HSSPI_FIFOCFG_RXFTH1              *((volatile unsigned char*)(0x1242000984UL))
#define bFM_HSSPI_FIFOCFG_RXFTH2              *((volatile unsigned char*)(0x1242000988UL))
#define bFM_HSSPI_FIFOCFG_RXFTH3              *((volatile unsigned char*)(0x124200098CUL))
#define bFM_HSSPI_FIFOCFG_TXFTH0              *((volatile unsigned char*)(0x1242000990UL))
#define bFM_HSSPI_FIFOCFG_TXFTH1              *((volatile unsigned char*)(0x1242000994UL))
#define bFM_HSSPI_FIFOCFG_TXFTH2              *((volatile unsigned char*)(0x1242000998UL))
#define bFM_HSSPI_FIFOCFG_TXFTH3              *((volatile unsigned char*)(0x124200099CUL))
#define bFM_HSSPI_FIFOCFG_FWIDTH0             *((volatile unsigned char*)(0x12420009A0UL))
#define bFM_HSSPI_FIFOCFG_FWIDTH1             *((volatile unsigned char*)(0x12420009A4UL))
#define bFM_HSSPI_FIFOCFG_TXCTRL              *((volatile unsigned char*)(0x12420009A8UL))
#define bFM_HSSPI_FIFOCFG_RXFLSH              *((volatile unsigned char*)(0x12420009ACUL))
#define bFM_HSSPI_FIFOCFG_TXFLSH              *((volatile unsigned char*)(0x12420009B0UL))
#define bFM_HSSPI_CSCFG_SRAM                  *((volatile unsigned char*)(0x1242001A00UL))
#define bFM_HSSPI_CSCFG_MBM0                  *((volatile unsigned char*)(0x1242001A04UL))
#define bFM_HSSPI_CSCFG_MBM1                  *((volatile unsigned char*)(0x1242001A08UL))
#define bFM_HSSPI_CSCFG_SSEL0EN               *((volatile unsigned char*)(0x1242001A20UL))
#define bFM_HSSPI_CSCFG_SSEL1EN               *((volatile unsigned char*)(0x1242001A24UL))
#define bFM_HSSPI_CSCFG_SSEL2EN               *((volatile unsigned char*)(0x1242001A28UL))
#define bFM_HSSPI_CSCFG_SSEL3EN               *((volatile unsigned char*)(0x1242001A2CUL))
#define bFM_HSSPI_CSCFG_MSEL0                 *((volatile unsigned char*)(0x1242001A40UL))
#define bFM_HSSPI_CSCFG_MSEL1                 *((volatile unsigned char*)(0x1242001A44UL))
#define bFM_HSSPI_CSCFG_MSEL2                 *((volatile unsigned char*)(0x1242001A48UL))
#define bFM_HSSPI_CSCFG_MSEL3                 *((volatile unsigned char*)(0x1242001A4CUL))
#define bFM_HSSPI_RDCSDC0_DEC                 *((volatile unsigned char*)(0x1242001B80UL))
#define bFM_HSSPI_RDCSDC0_TRP0                *((volatile unsigned char*)(0x1242001B84UL))
#define bFM_HSSPI_RDCSDC0_TRP1                *((volatile unsigned char*)(0x1242001B88UL))
#define bFM_HSSPI_RDCSDC0_CONT                *((volatile unsigned char*)(0x1242001B8CUL))
#define bFM_HSSPI_RDCSDC1_DEC                 *((volatile unsigned char*)(0x1242001BC0UL))
#define bFM_HSSPI_RDCSDC1_TRP0                *((volatile unsigned char*)(0x1242001BC4UL))
#define bFM_HSSPI_RDCSDC1_TRP1                *((volatile unsigned char*)(0x1242001BC8UL))
#define bFM_HSSPI_RDCSDC1_CONT                *((volatile unsigned char*)(0x1242001BCCUL))
#define bFM_HSSPI_RDCSDC2_DEC                 *((volatile unsigned char*)(0x1242001C00UL))
#define bFM_HSSPI_RDCSDC2_TRP0                *((volatile unsigned char*)(0x1242001C04UL))
#define bFM_HSSPI_RDCSDC2_TRP1                *((volatile unsigned char*)(0x1242001C08UL))
#define bFM_HSSPI_RDCSDC2_CONT                *((volatile unsigned char*)(0x1242001C0CUL))
#define bFM_HSSPI_RDCSDC3_DEC                 *((volatile unsigned char*)(0x1242001C40UL))
#define bFM_HSSPI_RDCSDC3_TRP0                *((volatile unsigned char*)(0x1242001C44UL))
#define bFM_HSSPI_RDCSDC3_TRP1                *((volatile unsigned char*)(0x1242001C48UL))
#define bFM_HSSPI_RDCSDC3_CONT                *((volatile unsigned char*)(0x1242001C4CUL))
#define bFM_HSSPI_RDCSDC4_DEC                 *((volatile unsigned char*)(0x1242001C80UL))
#define bFM_HSSPI_RDCSDC4_TRP0                *((volatile unsigned char*)(0x1242001C84UL))
#define bFM_HSSPI_RDCSDC4_TRP1                *((volatile unsigned char*)(0x1242001C88UL))
#define bFM_HSSPI_RDCSDC4_CONT                *((volatile unsigned char*)(0x1242001C8CUL))
#define bFM_HSSPI_RDCSDC5_DEC                 *((volatile unsigned char*)(0x1242001CC0UL))
#define bFM_HSSPI_RDCSDC5_TRP0                *((volatile unsigned char*)(0x1242001CC4UL))
#define bFM_HSSPI_RDCSDC5_TRP1                *((volatile unsigned char*)(0x1242001CC8UL))
#define bFM_HSSPI_RDCSDC5_CONT                *((volatile unsigned char*)(0x1242001CCCUL))
#define bFM_HSSPI_RDCSDC6_DEC                 *((volatile unsigned char*)(0x1242001D00UL))
#define bFM_HSSPI_RDCSDC6_TRP0                *((volatile unsigned char*)(0x1242001D04UL))
#define bFM_HSSPI_RDCSDC6_TRP1                *((volatile unsigned char*)(0x1242001D08UL))
#define bFM_HSSPI_RDCSDC6_CONT                *((volatile unsigned char*)(0x1242001D0CUL))
#define bFM_HSSPI_RDCSDC7_DEC                 *((volatile unsigned char*)(0x1242001D40UL))
#define bFM_HSSPI_RDCSDC7_TRP0                *((volatile unsigned char*)(0x1242001D44UL))
#define bFM_HSSPI_RDCSDC7_TRP1                *((volatile unsigned char*)(0x1242001D48UL))
#define bFM_HSSPI_RDCSDC7_CONT                *((volatile unsigned char*)(0x1242001D4CUL))
#define bFM_HSSPI_WRCSDC0_DEC                 *((volatile unsigned char*)(0x1242001D80UL))
#define bFM_HSSPI_WRCSDC0_TRP0                *((volatile unsigned char*)(0x1242001D84UL))
#define bFM_HSSPI_WRCSDC0_TRP1                *((volatile unsigned char*)(0x1242001D88UL))
#define bFM_HSSPI_WRCSDC0_CONT                *((volatile unsigned char*)(0x1242001D8CUL))
#define bFM_HSSPI_WRCSDC1_DEC                 *((volatile unsigned char*)(0x1242001DC0UL))
#define bFM_HSSPI_WRCSDC1_TRP0                *((volatile unsigned char*)(0x1242001DC4UL))
#define bFM_HSSPI_WRCSDC1_TRP1                *((volatile unsigned char*)(0x1242001DC8UL))
#define bFM_HSSPI_WRCSDC1_CONT                *((volatile unsigned char*)(0x1242001DCCUL))
#define bFM_HSSPI_WRCSDC2_DEC                 *((volatile unsigned char*)(0x1242001E00UL))
#define bFM_HSSPI_WRCSDC2_TRP0                *((volatile unsigned char*)(0x1242001E04UL))
#define bFM_HSSPI_WRCSDC2_TRP1                *((volatile unsigned char*)(0x1242001E08UL))
#define bFM_HSSPI_WRCSDC2_CONT                *((volatile unsigned char*)(0x1242001E0CUL))
#define bFM_HSSPI_WRCSDC3_DEC                 *((volatile unsigned char*)(0x1242001E40UL))
#define bFM_HSSPI_WRCSDC3_TRP0                *((volatile unsigned char*)(0x1242001E44UL))
#define bFM_HSSPI_WRCSDC3_TRP1                *((volatile unsigned char*)(0x1242001E48UL))
#define bFM_HSSPI_WRCSDC3_CONT                *((volatile unsigned char*)(0x1242001E4CUL))
#define bFM_HSSPI_WRCSDC4_DEC                 *((volatile unsigned char*)(0x1242001E80UL))
#define bFM_HSSPI_WRCSDC4_TRP0                *((volatile unsigned char*)(0x1242001E84UL))
#define bFM_HSSPI_WRCSDC4_TRP1                *((volatile unsigned char*)(0x1242001E88UL))
#define bFM_HSSPI_WRCSDC4_CONT                *((volatile unsigned char*)(0x1242001E8CUL))
#define bFM_HSSPI_WRCSDC5_DEC                 *((volatile unsigned char*)(0x1242001EC0UL))
#define bFM_HSSPI_WRCSDC5_TRP0                *((volatile unsigned char*)(0x1242001EC4UL))
#define bFM_HSSPI_WRCSDC5_TRP1                *((volatile unsigned char*)(0x1242001EC8UL))
#define bFM_HSSPI_WRCSDC5_CONT                *((volatile unsigned char*)(0x1242001ECCUL))
#define bFM_HSSPI_WRCSDC6_DEC                 *((volatile unsigned char*)(0x1242001F00UL))
#define bFM_HSSPI_WRCSDC6_TRP0                *((volatile unsigned char*)(0x1242001F04UL))
#define bFM_HSSPI_WRCSDC6_TRP1                *((volatile unsigned char*)(0x1242001F08UL))
#define bFM_HSSPI_WRCSDC6_CONT                *((volatile unsigned char*)(0x1242001F0CUL))
#define bFM_HSSPI_WRCSDC7_DEC                 *((volatile unsigned char*)(0x1242001F40UL))
#define bFM_HSSPI_WRCSDC7_TRP0                *((volatile unsigned char*)(0x1242001F44UL))
#define bFM_HSSPI_WRCSDC7_TRP1                *((volatile unsigned char*)(0x1242001F48UL))
#define bFM_HSSPI_WRCSDC7_CONT                *((volatile unsigned char*)(0x1242001F4CUL))
#define bFM_HSSPI_DBCNT_RXDBEN                *((volatile unsigned char*)(0x1242008080UL))
#define bFM_HSSPI_DBCNT_TXDBEN                *((volatile unsigned char*)(0x1242008084UL))

#ifdef __cplusplus
}
#endif

#endif /* _S6E2CC_H_ */

